/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/arrays","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","os","vs/base/common/strings","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/platform/environment/electron-main/environmentMainService","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/platform/environment/common/environment","vs/base/common/map","vs/base/common/process","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","child_process","vs/platform/registry/common/platform","vs/platform/request/common/request","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/configuration/common/configurationRegistry","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/iterator","crypto","net","vs/base/common/processes","vs/base/common/severity","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/base/node/unc","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","path","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","https","string_decoder","vs/code/electron-main/main"],ie=function(j){for(var e=[],E=0,L=j.length;E<L;E++)e[E]=te[j[E]];return e};define(te[127],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(k,u){const l=Math.pow(10,u);return Math.round(k*l)/l}class L{constructor(u,l,p,m=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=E(Math.max(Math.min(1,m),0),3)}static equals(u,l){return u.r===l.r&&u.g===l.g&&u.b===l.b&&u.a===l.a}}e.RGBA=L;class r{constructor(u,l,p,m){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.l=E(Math.max(Math.min(1,p),0),3),this.a=E(Math.max(Math.min(1,m),0),3)}static equals(u,l){return u.h===l.h&&u.s===l.s&&u.l===l.l&&u.a===l.a}static fromRGBA(u){const l=u.r/255,p=u.g/255,m=u.b/255,w=u.a,f=Math.max(l,p,m),S=Math.min(l,p,m);let v=0,s=0;const g=(S+f)/2,c=f-S;if(c>0){switch(s=Math.min(g<=.5?c/(2*g):c/(2-2*g),1),f){case l:v=(p-m)/c+(p<m?6:0);break;case p:v=(m-l)/c+2;break;case m:v=(l-p)/c+4;break}v*=60,v=Math.round(v)}return new r(v,s,g,w)}static _hue2rgb(u,l,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?u+(l-u)*6*p:p<1/2?l:p<2/3?u+(l-u)*(2/3-p)*6:u}static toRGBA(u){const l=u.h/360,{s:p,l:m,a:w}=u;let f,S,v;if(p===0)f=S=v=m;else{const s=m<.5?m*(1+p):m+p-m*p,g=2*m-s;f=r._hue2rgb(g,s,l+1/3),S=r._hue2rgb(g,s,l),v=r._hue2rgb(g,s,l-1/3)}return new L(Math.round(f*255),Math.round(S*255),Math.round(v*255),w)}}e.HSLA=r;class A{constructor(u,l,p,m){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.v=E(Math.max(Math.min(1,p),0),3),this.a=E(Math.max(Math.min(1,m),0),3)}static equals(u,l){return u.h===l.h&&u.s===l.s&&u.v===l.v&&u.a===l.a}static fromRGBA(u){const l=u.r/255,p=u.g/255,m=u.b/255,w=Math.max(l,p,m),f=Math.min(l,p,m),S=w-f,v=w===0?0:S/w;let s;return S===0?s=0:w===l?s=((p-m)/S%6+6)%6:w===p?s=(m-l)/S+2:s=(l-p)/S+4,new A(Math.round(s*60),v,w,u.a)}static toRGBA(u){const{h:l,s:p,v:m,a:w}=u,f=m*p,S=f*(1-Math.abs(l/60%2-1)),v=m-f;let[s,g,c]=[0,0,0];return l<60?(s=f,g=S):l<120?(s=S,g=f):l<180?(g=f,c=S):l<240?(g=S,c=f):l<300?(s=S,c=f):l<=360&&(s=f,c=S),s=Math.round((s+v)*255),g=Math.round((g+v)*255),c=Math.round((c+v)*255),new L(s,g,c,w)}}e.HSVA=A;class D{static fromHex(u){return D.Format.CSS.parseHex(u)||D.red}static equals(u,l){return!u&&!l?!0:!u||!l?!1:u.equals(l)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:A.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof L)this.rgba=u;else if(u instanceof r)this._hsla=u,this.rgba=r.toRGBA(u);else if(u instanceof A)this._hsva=u,this.rgba=A.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&L.equals(this.rgba,u.rgba)&&r.equals(this.hsla,u.hsla)&&A.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=D._relativeLuminanceForComponent(this.rgba.r),l=D._relativeLuminanceForComponent(this.rgba.g),p=D._relativeLuminanceForComponent(this.rgba.b),m=.2126*u+.7152*l+.0722*p;return E(m,4)}static _relativeLuminanceForComponent(u){const l=u/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(u){const l=this.getRelativeLuminance(),p=u.getRelativeLuminance();return l>p?(l+.05)/(p+.05):(p+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const l=this.getRelativeLuminance(),p=u.getRelativeLuminance();return l>p}isDarkerThan(u){const l=this.getRelativeLuminance(),p=u.getRelativeLuminance();return l<p}lighten(u){return new D(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new D(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:l,g:p,b:m,a:w}=this.rgba;return new D(new L(l,p,m,w*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const l=u.rgba,p=this.rgba.a,m=l.a,w=p+m*(1-p);if(w<1e-6)return D.transparent;const f=this.rgba.r*p/w+l.r*m*(1-p)/w,S=this.rgba.g*p/w+l.g*m*(1-p)/w,v=this.rgba.b*p/w+l.b*m*(1-p)/w;return new D(new L(f,S,v,w))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:l,g:p,b:m,a:w}=this.rgba;return new D(new L(u.rgba.r-w*(u.rgba.r-l),u.rgba.g-w*(u.rgba.g-p),u.rgba.b-w*(u.rgba.b-m),1))}flatten(...u){const l=u.reduceRight((p,m)=>D._flatten(m,p));return D._flatten(this,l)}static _flatten(u,l){const p=1-u.rgba.a;return new D(new L(p*l.rgba.r+u.rgba.a*u.rgba.r,p*l.rgba.g+u.rgba.a*u.rgba.g,p*l.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(u,l,p){if(u.isLighterThan(l))return u;p=p||.5;const m=u.getRelativeLuminance(),w=l.getRelativeLuminance();return p=p*(w-m)/w,u.lighten(p)}static getDarkerColor(u,l,p){if(u.isDarkerThan(l))return u;p=p||.5;const m=u.getRelativeLuminance(),w=l.getRelativeLuminance();return p=p*(m-w)/m,u.darken(p)}}e.Color=D,D.white=new D(new L(255,255,255,1)),D.black=new D(new L(0,0,0,1)),D.red=new D(new L(255,0,0,1)),D.blue=new D(new L(0,0,255,1)),D.green=new D(new L(0,255,0,1)),D.cyan=new D(new L(0,255,255,1)),D.lightgrey=new D(new L(211,211,211,1)),D.transparent=new D(new L(0,0,0,0)),function(k){let u;(function(l){let p;(function(m){function w(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}m.formatRGB=w;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}m.formatRGBA=f;function S(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}m.formatHSL=S;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}m.formatHSLA=v;function s(t){const a=t.toString(16);return a.length!==2?"0"+a:a}function g(t){return`#${s(t.rgba.r)}${s(t.rgba.g)}${s(t.rgba.b)}`}m.formatHex=g;function c(t,a=!1){return a&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${s(t.rgba.r)}${s(t.rgba.g)}${s(t.rgba.b)}${s(Math.round(t.rgba.a*255))}`}m.formatHexA=c;function y(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}m.format=y;function b(t){const a=t.length;if(a===0||t.charCodeAt(0)!==35)return null;if(a===7){const i=16*C(t.charCodeAt(1))+C(t.charCodeAt(2)),n=16*C(t.charCodeAt(3))+C(t.charCodeAt(4)),o=16*C(t.charCodeAt(5))+C(t.charCodeAt(6));return new k(new L(i,n,o,1))}if(a===9){const i=16*C(t.charCodeAt(1))+C(t.charCodeAt(2)),n=16*C(t.charCodeAt(3))+C(t.charCodeAt(4)),o=16*C(t.charCodeAt(5))+C(t.charCodeAt(6)),d=16*C(t.charCodeAt(7))+C(t.charCodeAt(8));return new k(new L(i,n,o,d/255))}if(a===4){const i=C(t.charCodeAt(1)),n=C(t.charCodeAt(2)),o=C(t.charCodeAt(3));return new k(new L(16*i+i,16*n+n,16*o+o))}if(a===5){const i=C(t.charCodeAt(1)),n=C(t.charCodeAt(2)),o=C(t.charCodeAt(3)),d=C(t.charCodeAt(4));return new k(new L(16*i+i,16*n+n,16*o+o,(16*d+d)/255))}return null}m.parseHex=b;function C(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=l.CSS||(l.CSS={}))})(u=k.Format||(k.Format={}))}(D||(e.Color=D={}))}),define(te[55],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(D){return(k,u,l)=>{let p=null,m=null;if(typeof l.value=="function"?(p="value",m=l.value):typeof l.get=="function"&&(p="get",m=l.get),!m)throw new Error("not supported");l[p]=D(m,u)}}function L(D,k,u){let l=null,p=null;if(typeof u.value=="function"?(l="value",p=u.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(l="get",p=u.get),!p)throw new Error("not supported");const m=`$memoize$${k}`;u[l]=function(...w){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,w)}),this[m]}}e.memoize=L;function r(D,k,u){return E((l,p)=>{const m=`$debounce$${p}`,w=`$debounce$result$${p}`;return function(...f){this[w]||(this[w]=u?u():void 0),clearTimeout(this[m]),k&&(this[w]=k(this[w],...f),f=[this[w]]),this[m]=setTimeout(()=>{l.apply(this,f),this[w]=u?u():void 0},D)}})}e.debounce=r;function A(D,k,u){return E((l,p)=>{const m=`$throttle$timer$${p}`,w=`$throttle$result$${p}`,f=`$throttle$lastRun$${p}`,S=`$throttle$pending$${p}`;return function(...v){if(this[w]||(this[w]=u?u():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),k&&(this[w]=k(this[w],...v)),this[S])return;const s=this[f]+D;s<=Date.now()?(this[f]=Date.now(),l.apply(this,[this[w]]),this[w]=u?u():void 0):(this[S]=!0,this[m]=setTimeout(()=>{this[S]=!1,this[f]=Date.now(),l.apply(this,[this[w]]),this[w]=u?u():void 0},s-Date.now()))}})}e.throttle=A}),define(te[13],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?b.isErrorNoTelemetry(a)?new b(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(i=>{i(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=E,e.errorHandler=new E;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function r(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=r;function A(t){l(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function D(t){l(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=D;function k(t){if(t instanceof Error){const{name:a,message:i}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:a,message:i,stack:n,noTelemetry:b.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const u="Canceled";function l(t){return t instanceof p?!0:t instanceof Error&&t.name===u&&t.message===u}e.isCancellationError=l;class p extends Error{constructor(){super(u),this.name=this.message}}e.CancellationError=p;function m(){const t=new Error(u);return t.name=t.message,t}e.canceled=m;function w(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=w;function f(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=f;function S(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function v(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=v;function s(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=s;class g extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=g;class c extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=c;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=y;class b extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof b)return a;const i=new b;return i.message=a.message,i.stack=a.stack,i}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class C extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype);debugger}}e.BugIndicatingError=C}),define(te[23],ie([0,1,13]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(F,x=0){return F[F.length-(1+x)]}e.tail=L;function r(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=r;function A(F,x,V=(se,ae)=>se===ae){if(F===x)return!0;if(!F||!x||F.length!==x.length)return!1;for(let se=0,ae=F.length;se<ae;se++)if(!V(F[se],x[se]))return!1;return!0}e.equals=A;function D(F,x){const V=F.length-1;x<V&&(F[x]=F[V]),F.pop()}e.removeFastWithoutKeepingOrder=D;function k(F,x,V){return u(F.length,se=>V(F[se],x))}e.binarySearch=k;function u(F,x){let V=0,se=F-1;for(;V<=se;){const ae=(V+se)/2|0,Se=x(ae);if(Se<0)V=ae+1;else if(Se>0)se=ae-1;else return ae}return-(V+1)}e.binarySearch2=u;function l(F,x){let V=0,se=F.length;if(se===0)return 0;for(;V<se;){const ae=Math.floor((V+se)/2);x(F[ae])?se=ae:V=ae+1}return V}e.findFirstInSorted=l;function p(F,x,V){if(F=F|0,F>=x.length)throw new TypeError("invalid index");const se=x[Math.floor(x.length*Math.random())],ae=[],Se=[],De=[];for(const Re of x){const Le=V(Re,se);Le<0?ae.push(Re):Le>0?Se.push(Re):De.push(Re)}return F<ae.length?p(F,ae,V):F<ae.length+De.length?De[0]:p(F-(ae.length+De.length),Se,V)}e.quickSelect=p;function m(F,x){const V=[];let se;for(const ae of F.slice(0).sort(x))!se||x(se[0],ae)!==0?(se=[ae],V.push(se)):se.push(ae);return V}e.groupBy=m;function w(F,x,V){const se=[];function ae(Re,Le,Oe){if(Le===0&&Oe.length===0)return;const we=se[se.length-1];we&&we.start+we.deleteCount===Re?(we.deleteCount+=Le,we.toInsert.push(...Oe)):se.push({start:Re,deleteCount:Le,toInsert:Oe})}let Se=0,De=0;for(;;){if(Se===F.length){ae(Se,0,x.slice(De));break}if(De===x.length){ae(Se,F.length-Se,[]);break}const Re=F[Se],Le=x[De],Oe=V(Re,Le);Oe===0?(Se+=1,De+=1):Oe<0?(ae(Se,1,[]),Se+=1):Oe>0&&(ae(Se,0,[Le]),De+=1)}return se}e.sortedDiff=w;function f(F,x,V){const se=w(F,x,V),ae=[],Se=[];for(const De of se)ae.push(...F.slice(De.start,De.start+De.deleteCount)),Se.push(...De.toInsert);return{removed:ae,added:Se}}e.delta=f;function S(F,x,V){if(V===0)return[];const se=F.slice(0,V).sort(x);return s(F,x,se,V,F.length),se}e.top=S;function v(F,x,V,se,ae){return V===0?Promise.resolve([]):new Promise((Se,De)=>{(async()=>{const Re=F.length,Le=F.slice(0,V).sort(x);for(let Oe=V,we=Math.min(V+se,Re);Oe<Re;Oe=we,we=Math.min(we+se,Re)){if(Oe>V&&await new Promise(ve=>setTimeout(ve)),ae&&ae.isCancellationRequested)throw new E.CancellationError;s(F,x,Le,Oe,we)}return Le})().then(Se,De)})}e.topAsync=v;function s(F,x,V,se,ae){for(const Se=V.length;se<ae;se++){const De=F[se];if(x(De,V[Se-1])<0){V.pop();const Re=l(V,Le=>x(De,Le)<0);V.splice(Re,0,De)}}}function g(F){return F.filter(x=>!!x)}e.coalesce=g;function c(F){let x=0;for(let V=0;V<F.length;V++)F[V]&&(F[x]=F[V],x+=1);F.length=x}e.coalesceInPlace=c;function y(F,x,V){F.splice(V,0,F.splice(x,1)[0])}e.move=y;function b(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=b;function C(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=C;function t(F,x=V=>V){const V=new Set;return F.filter(se=>{const ae=x(se);return V.has(ae)?!1:(V.add(ae),!0)})}e.distinct=t;function a(F){const x=new Set;return V=>{const se=F(V);return x.has(se)?!1:(x.add(se),!0)}}e.uniqueFilter=a;function i(F,x){const V=n(F,x);if(V!==-1)return F[V]}e.findLast=i;function n(F,x){for(let V=F.length-1;V>=0;V--){const se=F[V];if(x(se))return V}return-1}e.lastIndex=n;function o(F,x){return F.length>0?F[0]:x}e.firstOrDefault=o;function d(F,x){return F.length>0?F[F.length-1]:x}e.lastOrDefault=d;function h(F,x,V=(se,ae)=>se===ae){let se=0;for(let ae=0,Se=Math.min(F.length,x.length);ae<Se&&V(F[ae],x[ae]);ae++)se++;return se}e.commonPrefixLength=h;function I(F){return[].concat(...F)}e.flatten=I;function R(F,x){let V=typeof x=="number"?F:0;typeof x=="number"?V=F:(V=0,x=F);const se=[];if(V<=x)for(let ae=V;ae<x;ae++)se.push(ae);else for(let ae=V;ae>x;ae--)se.push(ae);return se}e.range=R;function M(F,x,V){return F.reduce((se,ae)=>(se[x(ae)]=V?V(ae):ae,se),Object.create(null))}e.index=M;function T(F,x){return F.push(x),()=>W(F,x)}e.insert=T;function W(F,x){const V=F.indexOf(x);if(V>-1)return F.splice(V,1),x}e.remove=W;function z(F,x,V){const se=F.slice(0,x),ae=F.slice(x);return se.concat(V,ae)}e.arrayInsert=z;function H(F,x){let V;if(typeof x=="number"){let se=x;V=()=>{const ae=Math.sin(se++)*179426549;return ae-Math.floor(ae)}}else V=Math.random;for(let se=F.length-1;se>0;se-=1){const ae=Math.floor(V()*(se+1)),Se=F[se];F[se]=F[ae],F[ae]=Se}}e.shuffle=H;function J(F,x){const V=F.indexOf(x);V>-1&&(F.splice(V,1),F.unshift(x))}e.pushToStart=J;function ne(F,x){const V=F.indexOf(x);V>-1&&(F.splice(V,1),F.push(x))}e.pushToEnd=ne;function re(F,x){for(const V of x)F.push(V)}e.pushMany=re;function ue(F,x){return Array.isArray(F)?F.map(x):x(F)}e.mapArrayOrNot=ue;function ce(F){return Array.isArray(F)?F:[F]}e.asArray=ce;function K(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=K;function q(F,x){for(const V of F){const se=x(V);if(se!==void 0)return se}}e.mapFind=q;function N(F,x,V){const se=G(F,x),ae=F.length,Se=V.length;F.length=ae+Se;for(let De=ae-1;De>=se;De--)F[De+Se]=F[De];for(let De=0;De<Se;De++)F[De+se]=V[De]}e.insertInto=N;function $(F,x,V,se){const ae=G(F,x),Se=F.splice(ae,V);return N(F,ae,se),Se}e.splice=$;function G(F,x){return x<0?Math.max(x+F.length,0):Math.min(x,F.length)}var ee;(function(F){function x(ae){return ae<0}F.isLessThan=x;function V(ae){return ae>0}F.isGreaterThan=V;function se(ae){return ae===0}F.isNeitherLessOrGreaterThan=se,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function oe(F,x){return(V,se)=>x(F(V),F(se))}e.compareBy=oe;function le(...F){return(x,V)=>{for(const se of F){const ae=se(x,V);if(!ee.isNeitherLessOrGreaterThan(ae))return ae}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=le;const Y=(F,x)=>F-x;e.numberComparator=Y;function _(F,x){if(F.length===0)return;let V=F[0];for(let se=1;se<F.length;se++){const ae=F[se];x(ae,V)>0&&(V=ae)}return V}e.findMaxBy=_;function P(F,x){if(F.length===0)return;let V=F[0];for(let se=1;se<F.length;se++){const ae=F[se];x(ae,V)>=0&&(V=ae)}return V}e.findLastMaxBy=P;function O(F,x){return _(F,(V,se)=>-x(V,se))}e.findMinBy=O;class U{constructor(x){this.items=x,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(x){let V=this.firstIdx;for(;V<this.items.length&&x(this.items[V]);)V++;const se=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,se}takeFromEndWhile(x){let V=this.lastIdx;for(;V>=0&&x(this.items[V]);)V--;const se=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,se}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const x=this.items[this.firstIdx];return this.firstIdx++,x}removeLast(){const x=this.items[this.lastIdx];return this.lastIdx--,x}takeCount(x){const V=this.items.slice(this.firstIdx,this.firstIdx+x);return this.firstIdx+=x,V}}e.ArrayQueue=U;class B{constructor(x){this.iterate=x}forEach(x){this.iterate(V=>(x(V),!0))}toArray(){const x=[];return this.iterate(V=>(x.push(V),!0)),x}filter(x){return new B(V=>this.iterate(se=>x(se)?V(se):!0))}map(x){return new B(V=>this.iterate(se=>V(x(se))))}some(x){let V=!1;return this.iterate(se=>(V=x(se),!V)),V}findFirst(x){let V;return this.iterate(se=>x(se)?(V=se,!1):!0),V}findLast(x){let V;return this.iterate(se=>(x(se)&&(V=se),!0)),V}findLastMaxBy(x){let V,se=!0;return this.iterate(ae=>((se||ee.isGreaterThan(x(ae,V)))&&(se=!1,V=ae),!0)),V}}e.CallbackIterable=B,B.empty=new B(F=>{})}),define(te[128],ie([0,1,13]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(u,l){if(!u)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=L;function r(u,l="Unreachable"){throw new Error(l)}e.assertNever=r;function A(u){if(!u)throw new E.BugIndicatingError("Assertion Failed")}e.assert=A;function D(u){if(!u()){debugger;u(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function k(u,l){let p=0;for(;p<u.length-1;){const m=u[p],w=u[p+1];if(!l(m,w))return!1;p++}return!0}e.checkAdjacentItems=k}),define(te[48],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(L){const r=this;let A=!1,D;return function(){return A||(A=!0,D=L.apply(r,arguments)),D}}e.once=E}),define(te[68],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(L){function r(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}L.is=r;const A=Object.freeze([]);function D(){return A}L.empty=D;function*k(b){yield b}L.single=k;function u(b){return r(b)?b:k(b)}L.wrap=u;function l(b){return b||A}L.from=l;function p(b){return!b||b[Symbol.iterator]().next().done===!0}L.isEmpty=p;function m(b){return b[Symbol.iterator]().next().value}L.first=m;function w(b,C){for(const t of b)if(C(t))return!0;return!1}L.some=w;function f(b,C){for(const t of b)if(C(t))return t}L.find=f;function*S(b,C){for(const t of b)C(t)&&(yield t)}L.filter=S;function*v(b,C){let t=0;for(const a of b)yield C(a,t++)}L.map=v;function*s(...b){for(const C of b)for(const t of C)yield t}L.concat=s;function g(b,C,t){let a=t;for(const i of b)a=C(a,i);return a}L.reduce=g;function*c(b,C,t=b.length){for(C<0&&(C+=b.length),t<0?t+=b.length:t>b.length&&(t=b.length);C<t;C++)yield b[C]}L.slice=c;function y(b,C=Number.POSITIVE_INFINITY){const t=[];if(C===0)return[t,b];const a=b[Symbol.iterator]();for(let i=0;i<C;i++){const n=a.next();if(n.done)return[t,L.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return a}}]}L.consume=y})(E||(e.Iterable=E={}))}),define(te[43],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function D(t,a=!1){let i=0;const n=t.length;let o="",d=0,h=16,I=0;function R(ne){let re=0,ue=0;for(;re<ne;){const ce=t.charCodeAt(i);if(ce>=48&&ce<=57)ue=ue*16+ce-48;else if(ce>=65&&ce<=70)ue=ue*16+ce-65+10;else if(ce>=97&&ce<=102)ue=ue*16+ce-97+10;else break;i++,re++}return re<ne&&(ue=-1),ue}function M(ne){i=ne,o="",d=0,h=16,I=0}function T(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&l(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&l(t.charCodeAt(i)))for(i++;i<t.length&&l(t.charCodeAt(i));)i++;else return I=3,t.substring(ne,i);let re=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&l(t.charCodeAt(i))){for(i++;i<t.length&&l(t.charCodeAt(i));)i++;re=i}else I=3;return t.substring(ne,re)}function W(){let ne="",re=i;for(;;){if(i>=n){ne+=t.substring(re,i),I=2;break}const ue=t.charCodeAt(i);if(ue===34){ne+=t.substring(re,i),i++;break}if(ue===92){if(ne+=t.substring(re,i),i++,i>=n){I=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const K=R(4);K>=0?ne+=String.fromCharCode(K):I=4;break}default:I=5}re=i;continue}if(ue>=0&&ue<=31)if(u(ue)){ne+=t.substring(re,i),I=2;break}else I=6;i++}return ne}function z(){if(o="",I=0,d=i,i>=n)return d=n,h=17;let ne=t.charCodeAt(i);if(k(ne)){do i++,o+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(k(ne));return h=15}if(u(ne))return i++,o+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),h=14;switch(ne){case 123:return i++,h=1;case 125:return i++,h=2;case 91:return i++,h=3;case 93:return i++,h=4;case 58:return i++,h=6;case 44:return i++,h=5;case 34:return i++,o=W(),h=10;case 47:{const re=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!u(t.charCodeAt(i));)i++;return o=t.substring(re,i),h=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=n-1;let ce=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ce=!0;break}i++}return ce||(i++,I=1),o=t.substring(re,i),h=13}return o+=String.fromCharCode(ne),i++,h=16}case 45:if(o+=String.fromCharCode(ne),i++,i===n||!l(t.charCodeAt(i)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),h=11;default:for(;i<n&&H(ne);)i++,ne=t.charCodeAt(i);if(d!==i){switch(o=t.substring(d,i),o){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return o+=String.fromCharCode(ne),i++,h=16}}function H(ne){if(k(ne)||u(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let ne;do ne=z();while(ne>=12&&ne<=15);return ne}return{setPosition:M,getPosition:()=>i,scan:a?J:z,getToken:()=>h,getTokenValue:()=>o,getTokenOffset:()=>d,getTokenLength:()=>i-d,getTokenError:()=>I}}e.createScanner=D;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var p;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(p||(p={}));function m(t,a){const i=[],n=new Object;let o;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function I(R,M,T,W){d.value=R,d.offset=M,d.length=T,d.type=W,d.colonOffset=void 0,o=d}try{y(t,{onObjectBegin:(R,M)=>{if(a<=R)throw n;o=void 0,h=a>R,i.push("")},onObjectProperty:(R,M,T)=>{if(a<M||(I(R,M,T,"property"),i[i.length-1]=R,a<=M+T))throw n},onObjectEnd:(R,M)=>{if(a<=R)throw n;o=void 0,i.pop()},onArrayBegin:(R,M)=>{if(a<=R)throw n;o=void 0,i.push(0)},onArrayEnd:(R,M)=>{if(a<=R)throw n;o=void 0,i.pop()},onLiteralValue:(R,M,T)=>{if(a<M||(I(R,M,T,C(R)),a<=M+T))throw n},onSeparator:(R,M,T)=>{if(a<=M)throw n;if(R===":"&&o&&o.type==="property")o.colonOffset=M,h=!1,o=void 0;else if(R===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(h=!0,i[i.length-1]=""),o=void 0}}})}catch(R){if(R!==n)throw R}return{path:i,previousNode:o,isAtPropertyKey:h,matches:R=>{let M=0;for(let T=0;M<R.length&&T<i.length;T++)if(R[M]===i[T]||R[M]==="*")M++;else if(R[M]!=="**")return!1;return M===R.length}}}e.getLocation=m;function w(t,a=[],i=A.DEFAULT){let n=null,o=[];const d=[];function h(R){Array.isArray(o)?o.push(R):n!==null&&(o[n]=R)}return y(t,{onObjectBegin:()=>{const R={};h(R),d.push(o),o=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{o=d.pop()},onArrayBegin:()=>{const R=[];h(R),d.push(o),o=R,n=null},onArrayEnd:()=>{o=d.pop()},onLiteralValue:h,onError:(R,M,T)=>{a.push({error:R,offset:M,length:T})}},i),o[0]}e.parse=w;function f(t,a=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(R){n.type==="property"&&(n.length=R-n.offset,n=n.parent)}function d(R){return n.children.push(R),R}y(t,{onObjectBegin:R=>{n=d({type:"object",offset:R,length:-1,parent:n,children:[]})},onObjectProperty:(R,M,T)=>{n=d({type:"property",offset:M,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:R,offset:M,length:T,parent:n})},onObjectEnd:(R,M)=>{n.length=R+M-n.offset,n=n.parent,o(R+M)},onArrayBegin:(R,M)=>{n=d({type:"array",offset:R,length:-1,parent:n,children:[]})},onArrayEnd:(R,M)=>{n.length=R+M-n.offset,n=n.parent,o(R+M)},onLiteralValue:(R,M,T)=>{d({type:C(R),offset:M,length:T,parent:n,value:R}),o(M+T)},onSeparator:(R,M,T)=>{n.type==="property"&&(R===":"?n.colonOffset=M:R===","&&o(M))},onError:(R,M,T)=>{a.push({error:R,offset:M,length:T})}},i);const I=n.children[0];return I&&delete I.parent,I}e.parseTree=f;function S(t,a){if(!t)return;let i=t;for(const n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const d of i.children)if(Array.isArray(d.children)&&d.children[0].value===n){i=d.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=S;function v(t){if(!t.parent||!t.parent.children)return[];const a=v(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=v;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const a=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(a[i.children[0].value]=s(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=s;function g(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=g;function c(t,a,i=!1){if(g(t,a,i)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=a;o++){const d=c(n[o],a,i);if(d)return d}return t}}e.findNodeAtOffset=c;function y(t,a,i=A.DEFAULT){const n=D(t,!1);function o(oe){return oe?()=>oe(n.getTokenOffset(),n.getTokenLength()):()=>!0}function d(oe){return oe?le=>oe(le,n.getTokenOffset(),n.getTokenLength()):()=>!0}const h=o(a.onObjectBegin),I=d(a.onObjectProperty),R=o(a.onObjectEnd),M=o(a.onArrayBegin),T=o(a.onArrayEnd),W=d(a.onLiteralValue),z=d(a.onSeparator),H=o(a.onComment),J=d(a.onError),ne=i&&i.disallowComments,re=i&&i.allowTrailingComma;function ue(){for(;;){const oe=n.scan();switch(n.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ne||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(oe){case 12:case 13:ne?ce(10):H();break;case 16:ce(1);break;case 15:case 14:break;default:return oe}}}function ce(oe,le=[],Y=[]){if(J(oe),le.length+Y.length>0){let _=n.getToken();for(;_!==17;){if(le.indexOf(_)!==-1){ue();break}else if(Y.indexOf(_)!==-1)break;_=ue()}}}function K(oe){const le=n.getTokenValue();return oe?W(le):I(le),ue(),!0}function q(){switch(n.getToken()){case 11:{let oe=0;try{oe=JSON.parse(n.getTokenValue()),typeof oe!="number"&&(ce(2),oe=0)}catch{ce(2)}W(oe);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return ue(),!0}function N(){return n.getToken()!==10?(ce(3,[],[2,5]),!1):(K(!1),n.getToken()===6?(z(":"),ue(),ee()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function $(){h(),ue();let oe=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(oe||ce(4,[],[]),z(","),ue(),n.getToken()===2&&re)break}else oe&&ce(6,[],[]);N()||ce(4,[],[2,5]),oe=!0}return R(),n.getToken()!==2?ce(7,[2],[]):ue(),!0}function G(){M(),ue();let oe=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(oe||ce(4,[],[]),z(","),ue(),n.getToken()===4&&re)break}else oe&&ce(6,[],[]);ee()||ce(4,[],[4,5]),oe=!0}return T(),n.getToken()!==4?ce(8,[4],[]):ue(),!0}function ee(){switch(n.getToken()){case 3:return G();case 1:return $();case 10:return K(!0);default:return q()}}return ue(),n.getToken()===17?i.allowEmptyContent?!0:(ce(4,[],[]),!1):ee()?(n.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.visit=y;function b(t,a){const i=D(t),n=[];let o,d=0,h;do switch(h=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:d!==h&&n.push(t.substring(d,h)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),d=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=b;function C(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(te[129],ie([0,1,43]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(l,p,m){let w,f,S,v,s;if(p){for(v=p.offset,s=v+p.length,S=v;S>0&&!u(l,S-1);)S--;let h=s;for(;h<l.length&&!u(l,h);)h++;f=l.substring(S,h),w=D(f,m)}else f=l,w=0,S=0,v=0,s=l.length;const g=k(m,l);let c=!1,y=0,b;m.insertSpaces?b=A(" ",m.tabSize||4):b="	";const C=(0,E.createScanner)(f,!1);let t=!1;function a(){return g+A(b,w+y)}function i(){let h=C.scan();for(c=!1;h===15||h===14;)c=c||h===14,h=C.scan();return t=h===16||C.getTokenError()!==0,h}const n=[];function o(h,I,R){!t&&I<s&&R>v&&l.substring(I,R)!==h&&n.push({offset:I,length:R-I,content:h})}let d=i();if(d!==17){const h=C.getTokenOffset()+S,I=A(b,w);o(I,S,h)}for(;d!==17;){let h=C.getTokenOffset()+C.getTokenLength()+S,I=i(),R="";for(;!c&&(I===12||I===13);){const T=C.getTokenOffset()+S;o(" ",h,T),h=C.getTokenOffset()+C.getTokenLength()+S,R=I===12?a():"",I=i()}if(I===2)d!==1&&(y--,R=a());else if(I===4)d!==3&&(y--,R=a());else{switch(d){case 3:case 1:y++,R=a();break;case 5:case 12:R=a();break;case 13:c?R=a():R=" ";break;case 6:R=" ";break;case 10:if(I===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?R=" ":I!==5&&I!==17&&(t=!0);break;case 16:t=!0;break}c&&(I===12||I===13)&&(R=a())}const M=C.getTokenOffset()+S;o(R,h,M),d=I}return n}e.format=L;function r(l,p){const m=JSON.stringify(l,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?m.replace(/\r\n|\r|\n/g,p.eol):m}e.toFormattedString=r;function A(l,p){let m="";for(let w=0;w<p;w++)m+=l;return m}function D(l,p){let m=0,w=0;const f=p.tabSize||4;for(;m<l.length;){const S=l.charAt(m);if(S===" ")w++;else if(S==="	")w+=f;else break;m++}return Math.floor(w/f)}function k(l,p){for(let m=0;m<p.length;m++){const w=p.charAt(m);if(w==="\r")return m+1<p.length&&p.charAt(m+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return l&&l.eol||`
`}e.getEOL=k;function u(l,p){return`\r
`.indexOf(l.charAt(p))!==-1}e.isEOL=u}),define(te[130],ie([0,1,43,129]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function r(l,p,m){return A(l,p,void 0,m)}e.removeProperty=r;function A(l,p,m,w,f){const S=p.slice(),v=[],s=(0,E.parseTree)(l,v);let g,c;for(;S.length>0&&(c=S.pop(),g=(0,E.findNodeAtLocation)(s,S),g===void 0&&m!==void 0);)typeof c=="string"?m={[c]:m}:m=[m];if(g)if(g.type==="object"&&typeof c=="string"&&Array.isArray(g.children)){const y=(0,E.findNodeAtLocation)(g,[c]);if(y!==void 0)if(m===void 0){if(!y.parent)throw new Error("Malformed AST");const b=g.children.indexOf(y.parent);let C,t=y.parent.offset+y.parent.length;if(b>0){const a=g.children[b-1];C=a.offset+a.length}else C=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return D(l,{offset:C,length:t-C,content:""},w)}else return D(l,{offset:y.offset,length:y.length,content:JSON.stringify(m)},w);else{if(m===void 0)return[];const b=`${JSON.stringify(c)}: ${JSON.stringify(m)}`,C=f?f(g.children.map(a=>a.children[0].value)):g.children.length;let t;if(C>0){const a=g.children[C-1];t={offset:a.offset+a.length,length:0,content:","+b}}else g.children.length===0?t={offset:g.offset+1,length:0,content:b}:t={offset:g.offset+1,length:0,content:b+","};return D(l,t,w)}}else if(g.type==="array"&&typeof c=="number"&&Array.isArray(g.children))if(m!==void 0){const y=`${JSON.stringify(m)}`;let b;if(g.children.length===0||c===0)b={offset:g.offset+1,length:0,content:g.children.length===0?y:y+","};else{const C=c===-1||c>g.children.length?g.children.length:c,t=g.children[C-1];b={offset:t.offset+t.length,length:0,content:","+y}}return D(l,b,w)}else{const y=c,b=g.children[y];let C;if(g.children.length===1)C={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===y){const t=g.children[y-1],a=t.offset+t.length,i=g.offset+g.length;C={offset:a,length:i-2-a,content:""}}else C={offset:b.offset,length:g.children[y+1].offset-b.offset,content:""};return D(l,C,w)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${g.type}`);else{if(m===void 0)throw new Error("Can not delete in empty document");return D(l,{offset:s?s.offset:0,length:s?s.length:0,content:JSON.stringify(m)},w)}}e.setProperty=A;function D(l,p,m){let w=k(l,p),f=p.offset,S=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;f>0&&!(0,L.isEOL)(w,f-1);)f--;for(;S<w.length&&!(0,L.isEOL)(w,S);)S++}const v=(0,L.format)(w,{offset:f,length:S-f},m);for(let g=v.length-1;g>=0;g--){const c=v[g];w=k(w,c),f=Math.min(f,c.offset),S=Math.max(S,c.offset+c.length),S+=c.content.length-c.length}const s=l.length-(w.length-S)-f;return[{offset:f,length:s,content:w.substring(f,S)}]}e.withFormatting=D;function k(l,p){return l.substring(0,p.offset)+p.content+l.substring(p.offset+p.length)}e.applyEdit=k;function u(l,p){const m=p.slice(0).sort((f,S)=>{const v=f.offset-S.offset;return v===0?f.length-S.length:v});let w=l.length;for(let f=m.length-1;f>=0;f--){const S=m[f];if(S.offset+S.length<=w)l=k(l,S);else throw new Error("Overlapping edit");w=S.offset}return l}e.applyEdits=u}),define(te[131],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=E}),define(te[2],ie([0,1,48,68]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const r=!1;let A=null;function D(d){A=d}if(e.setDisposableTracker=D,r){const d="__is_disposable_tracked__";D(new class{trackDisposable(h){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[d]||console.log(I)},3e3)}setParent(h,I){if(h&&h!==c.None)try{h[d]=!0}catch{}}markAsDisposed(h){if(h&&h!==c.None)try{h[d]=!0}catch{}}markAsSingleton(h){}})}function k(d){return A?.trackDisposable(d),d}function u(d){A?.markAsDisposed(d)}function l(d,h){A?.setParent(d,h)}function p(d,h){if(A)for(const I of d)A.setParent(I,h)}function m(d){return A?.markAsSingleton(d),d}e.markAsSingleton=m;function w(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=w;function f(d){if(L.Iterable.is(d)){const h=[];for(const I of d)if(I)try{I.dispose()}catch(R){h.push(R)}if(h.length===1)throw h[0];if(h.length>1)throw new AggregateError(h,"Encountered errors while disposing of store");return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}e.dispose=f;function S(d){for(const h of d)w(h)&&h.dispose();return[]}e.disposeIfDisposable=S;function v(...d){const h=s(()=>f(d));return p(d,h),h}e.combinedDisposable=v;function s(d){const h=k({dispose:(0,E.once)(()=>{u(h),d()})});return h}e.toDisposable=s;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{f(this._toDispose)}finally{this._toDispose.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return l(h,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(h),h}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new g,k(this),l(this._store,this)}dispose(){u(this),this._store.dispose()}_register(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(h)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(h){this._isDisposed||h===this._value||(this._value?.dispose(),h&&l(h,this),this._value=h)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const h=this._value;return this._value=void 0,h&&l(h,null),h}}e.MutableDisposable=y;class b{constructor(h){this._disposable=h,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=b;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(h){let I=h;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,u(this))},this}}e.SafeDisposable=C;class t{constructor(){this.references=new Map}acquire(h,...I){let R=this.references.get(h);R||(R={counter:0,object:this.createReferencedObject(h,...I)},this.references.set(h,R));const{object:M}=R,T=(0,E.once)(()=>{--R.counter===0&&(this.destroyReferencedObject(h,R.object),this.references.delete(h))});return R.counter++,{object:M,dispose:T}}}e.ReferenceCollection=t;class a{constructor(h){this.referenceCollection=h}async acquire(h,...I){const R=this.referenceCollection.acquire(h,...I);try{return{object:await R.object,dispose:()=>R.dispose()}}catch(M){throw R.dispose(),M}}}e.AsyncReferenceCollection=a;class i{constructor(h){this.object=h}dispose(){}}e.ImmortalReference=i;function n(d){const h=new g;try{d(h)}finally{h.dispose()}}e.disposeOnReturn=n;class o{constructor(){this._store=new Map,this._isDisposed=!1,k(this)}dispose(){u(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{f(this._store.values())}finally{this._store.clear()}}has(h){return this._store.has(h)}get(h){return this._store.get(h)}set(h,I,R=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),R||this._store.get(h)?.dispose(),this._store.set(h,I)}deleteAndDispose(h){this._store.get(h)?.dispose(),this._store.delete(h)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=o}),define(te[100],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(A){this.element=A,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class L{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let A=this._first;for(;A!==E.Undefined;){const D=A.next;A.prev=E.Undefined,A.next=E.Undefined,A=D}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,D){const k=new E(A);if(this._first===E.Undefined)this._first=k,this._last=k;else if(D){const l=this._last;this._last=k,k.prev=l,l.next=k}else{const l=this._first;this._first=k,k.next=l,l.prev=k}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(k))}}shift(){if(this._first!==E.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==E.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==E.Undefined&&A.next!==E.Undefined){const D=A.prev;D.next=A.next,A.next.prev=D}else A.prev===E.Undefined&&A.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):A.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):A.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==E.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),define(te[35],ie([0,1]),function(j,e){"use strict";var E,L,r;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(v,s,g){let c=v.get(s);return c===void 0&&(c=g,v.set(s,c)),c}e.getOrSet=A;function D(v){const s=[];return v.forEach((g,c)=>{s.push(`${c} => ${g}`)}),`Map(${v.size}) {${s.join(", ")}}`}e.mapToString=D;function k(v){const s=[];return v.forEach(g=>{s.push(g)}),`Set(${v.size}) {${s.join(", ")}}`}e.setToString=k;class u{constructor(s,g){this.uri=s,this.value=g}}class l{constructor(s,g){this[E]="ResourceMap",s instanceof l?(this.map=new Map(s.map),this.toKey=g??l.defaultToKey):(this.map=new Map,this.toKey=s??l.defaultToKey)}set(s,g){return this.map.set(this.toKey(s),new u(s,g)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,g){typeof g<"u"&&(s=s.bind(g));for(const[c,y]of this.map)s(y.value,y.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}e.ResourceMap=l,l.defaultToKey=v=>v.toString();class p{constructor(s,g){this[L]="ResourceSet",!s||typeof s=="function"?this._map=new l(s):(this._map=new l(g),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,g){this._map.forEach((c,y)=>s.call(g,y,y,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var m;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class w{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,g=0){const c=this._map.get(s);if(c)return g!==0&&this.touch(c,g),c.value}set(s,g,c=0){let y=this._map.get(s);if(y)y.value=g,c!==0&&this.touch(y,c);else{switch(y={key:s,value:g,next:void 0,previous:void 0},c){case 0:this.addItemLast(y);break;case 1:this.addItemFirst(y);break;case 2:this.addItemLast(y);break;default:this.addItemLast(y);break}this._map.set(s,y),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const g=this._map.get(s);if(g)return this._map.delete(s),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,g){const c=this._state;let y=this._head;for(;y;){if(g?s.bind(g)(y.value,y.key,this):s(y.value,y.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const s=this,g=this._state;let c=this._head;const y={[Symbol.iterator](){return y},next(){if(s._state!==g)throw new Error("LinkedMap got modified during iteration.");if(c){const b={value:c.key,done:!1};return c=c.next,b}else return{value:void 0,done:!0}}};return y}values(){const s=this,g=this._state;let c=this._head;const y={[Symbol.iterator](){return y},next(){if(s._state!==g)throw new Error("LinkedMap got modified during iteration.");if(c){const b={value:c.value,done:!1};return c=c.next,b}else return{value:void 0,done:!0}}};return y}entries(){const s=this,g=this._state;let c=this._head;const y={[Symbol.iterator](){return y},next(){if(s._state!==g)throw new Error("LinkedMap got modified during iteration.");if(c){const b={value:[c.key,c.value],done:!1};return c=c.next,b}else return{value:void 0,done:!0}}};return y}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let g=this._head,c=this.size;for(;g&&c>s;)this._map.delete(g.key),g=g.next,c--;this._head=g,this._size=c,g&&(g.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const g=s.next,c=s.previous;if(!g||!c)throw new Error("Invalid list");g.previous=c,c.next=g}s.next=void 0,s.previous=void 0,this._state++}touch(s,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(s===this._head)return;const c=s.next,y=s.previous;s===this._tail?(y.next=void 0,this._tail=y):(c.previous=y,y.next=c),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(g===2){if(s===this._tail)return;const c=s.next,y=s.previous;s===this._head?(c.previous=void 0,this._head=c):(c.previous=y,y.next=c),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((g,c)=>{s.push([c,g])}),s}fromJSON(s){this.clear();for(const[g,c]of s)this.set(g,c)}}e.LinkedMap=w;class f extends w{constructor(s,g=1){super(),this._limit=s,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,g=2){return super.get(s,g)}peek(s){return super.get(s,0)}set(s,g){return super.set(s,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class S{constructor(){this.map=new Map}add(s){return this.map.set(s,(this.map.get(s)||0)+1),this}delete(s){let g=this.map.get(s)||0;return g===0?!1:(g--,g===0?this.map.delete(s):this.map.set(s,g),!0)}has(s){return this.map.has(s)}}e.CounterSet=S}),define(te[82],ie([0,1,35]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new E.LRUCache(1e4);function r(l){return u(l,"NFC",L)}e.normalizeNFC=r;const A=new E.LRUCache(1e4);function D(l){return u(l,"NFD",A)}e.normalizeNFD=D;const k=/[^\u0000-\u0080]/;function u(l,p,m){if(!l)return l;const w=m.get(l);if(w)return w;let f;return k.test(l)?f=l.normalize(p):f=l,m.set(l,f),f}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(p){return D(p).replace(l,"")}}()}),define(te[132],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(k,u,l){return Math.min(Math.max(k,u),l)}e.clamp=E;function L(k,u){return(u+k%u)%u}e.rot=L;class r{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=r;class A{constructor(){this._n=1,this._val=0}update(u){return this._val=this._val+(u-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class D{constructor(u){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(u),this._values.fill(0,0,u)}update(u){const l=this._values[this._index];return this._values[this._index]=u,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=u,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function j(r){const A=[];typeof r=="number"&&A.push("code/timeOrigin",r);function D(u){A.push(u,Date.now())}function k(){const u=[];for(let l=0;l<A.length;l+=2)u.push({name:A[l],startTime:A[l+1]});return u}return{mark:D,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(r+D.startTime)});return A}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function E(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=E(L))}(),function(j,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var L in E)(typeof exports=="object"?exports:j)[L]=E[L]}}(typeof self<"u"?self:this,function(){return function(j){var e={};function E(L){if(e[L])return e[L].exports;var r=e[L]={i:L,l:!1,exports:{}};return j[L].call(r.exports,r,r.exports,E),r.l=!0,r.exports}return E.m=j,E.c=e,E.d=function(L,r,A){E.o(L,r)||Object.defineProperty(L,r,{enumerable:!0,get:A})},E.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},E.t=function(L,r){if(1&r&&(L=E(L)),8&r||4&r&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(E.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&r&&typeof L!="string")for(var D in L)E.d(A,D,function(k){return L[k]}.bind(null,D));return A},E.n=function(L){var r=L&&L.__esModule?function(){return L.default}:function(){return L};return E.d(r,"a",r),r},E.o=function(L,r){return Object.prototype.hasOwnProperty.call(L,r)},E.p="",E(E.s=0)}([function(j,e,E){(function(L){var r;e=j.exports=Y,r=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],u=e.src=[],l=0,p=l++;u[p]="0|[1-9]\\d*";var m=l++;u[m]="[0-9]+";var w=l++;u[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=l++;u[f]="("+u[p]+")\\.("+u[p]+")\\.("+u[p]+")";var S=l++;u[S]="("+u[m]+")\\.("+u[m]+")\\.("+u[m]+")";var v=l++;u[v]="(?:"+u[p]+"|"+u[w]+")";var s=l++;u[s]="(?:"+u[m]+"|"+u[w]+")";var g=l++;u[g]="(?:-("+u[v]+"(?:\\."+u[v]+")*))";var c=l++;u[c]="(?:-?("+u[s]+"(?:\\."+u[s]+")*))";var y=l++;u[y]="[0-9A-Za-z-]+";var b=l++;u[b]="(?:\\+("+u[y]+"(?:\\."+u[y]+")*))";var C=l++,t="v?"+u[f]+u[g]+"?"+u[b]+"?";u[C]="^"+t+"$";var a="[v=\\s]*"+u[S]+u[c]+"?"+u[b]+"?",i=l++;u[i]="^"+a+"$";var n=l++;u[n]="((?:<|>)?=?)";var o=l++;u[o]=u[m]+"|x|X|\\*";var d=l++;u[d]=u[p]+"|x|X|\\*";var h=l++;u[h]="[v=\\s]*("+u[d]+")(?:\\.("+u[d]+")(?:\\.("+u[d]+")(?:"+u[g]+")?"+u[b]+"?)?)?";var I=l++;u[I]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[c]+")?"+u[b]+"?)?)?";var R=l++;u[R]="^"+u[n]+"\\s*"+u[h]+"$";var M=l++;u[M]="^"+u[n]+"\\s*"+u[I]+"$";var T=l++;u[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=l++;u[W]="(?:~>?)";var z=l++;u[z]="(\\s*)"+u[W]+"\\s+",k[z]=new RegExp(u[z],"g");var H=l++;u[H]="^"+u[W]+u[h]+"$";var J=l++;u[J]="^"+u[W]+u[I]+"$";var ne=l++;u[ne]="(?:\\^)";var re=l++;u[re]="(\\s*)"+u[ne]+"\\s+",k[re]=new RegExp(u[re],"g");var ue=l++;u[ue]="^"+u[ne]+u[h]+"$";var ce=l++;u[ce]="^"+u[ne]+u[I]+"$";var K=l++;u[K]="^"+u[n]+"\\s*("+a+")$|^$";var q=l++;u[q]="^"+u[n]+"\\s*("+t+")$|^$";var N=l++;u[N]="(\\s*)"+u[n]+"\\s*("+a+"|"+u[h]+")",k[N]=new RegExp(u[N],"g");var $=l++;u[$]="^\\s*("+u[h]+")\\s+-\\s+("+u[h]+")\\s*$";var G=l++;u[G]="^\\s*("+u[I]+")\\s+-\\s+("+u[I]+")\\s*$";var ee=l++;u[ee]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)r(oe,u[oe]),k[oe]||(k[oe]=new RegExp(u[oe]));function le(Z,de){if(Z instanceof Y)return Z;if(typeof Z!="string"||Z.length>A||!(de?k[i]:k[C]).test(Z))return null;try{return new Y(Z,de)}catch{return null}}function Y(Z,de){if(Z instanceof Y){if(Z.loose===de)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Y))return new Y(Z,de);r("SemVer",Z,de),this.loose=de;var fe=Z.trim().match(de?k[i]:k[C]);if(!fe)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var ke=+Ee;if(ke>=0&&ke<D)return ke}return Ee}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=le,e.valid=function(Z,de){var fe=le(Z,de);return fe?fe.version:null},e.clean=function(Z,de){var fe=le(Z.trim().replace(/^[=v]+/,""),de);return fe?fe.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(Z){return r("SemVer.compare",this.version,this.loose,Z),Z instanceof Y||(Z=new Y(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},Y.prototype.compareMain=function(Z){return Z instanceof Y||(Z=new Y(Z,this.loose)),P(this.major,Z.major)||P(this.minor,Z.minor)||P(this.patch,Z.patch)},Y.prototype.comparePre=function(Z){if(Z instanceof Y||(Z=new Y(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var de=0;do{var fe=this.prerelease[de],Ee=Z.prerelease[de];if(r("prerelease compare",de,fe,Ee),fe===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ee)return P(fe,Ee)}while(++de)},Y.prototype.inc=function(Z,de){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,de,fe,Ee){typeof fe=="string"&&(Ee=fe,fe=void 0);try{return new Y(Z,fe).inc(de,Ee).version}catch{return null}},e.diff=function(Z,de){if(F(Z,de))return null;var fe=le(Z),Ee=le(de);if(fe.prerelease.length||Ee.prerelease.length){for(var ke in fe)if((ke==="major"||ke==="minor"||ke==="patch")&&fe[ke]!==Ee[ke])return"pre"+ke;return"prerelease"}for(var ke in fe)if((ke==="major"||ke==="minor"||ke==="patch")&&fe[ke]!==Ee[ke])return ke},e.compareIdentifiers=P;var _=/^[0-9]+$/;function P(Z,de){var fe=_.test(Z),Ee=_.test(de);return fe&&Ee&&(Z=+Z,de=+de),fe&&!Ee?-1:Ee&&!fe?1:Z<de?-1:Z>de?1:0}function O(Z,de,fe){return new Y(Z,fe).compare(new Y(de,fe))}function U(Z,de,fe){return O(Z,de,fe)>0}function B(Z,de,fe){return O(Z,de,fe)<0}function F(Z,de,fe){return O(Z,de,fe)===0}function x(Z,de,fe){return O(Z,de,fe)!==0}function V(Z,de,fe){return O(Z,de,fe)>=0}function se(Z,de,fe){return O(Z,de,fe)<=0}function ae(Z,de,fe,Ee){var ke;switch(de){case"===":typeof Z=="object"&&(Z=Z.version),typeof fe=="object"&&(fe=fe.version),ke=Z===fe;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof fe=="object"&&(fe=fe.version),ke=Z!==fe;break;case"":case"=":case"==":ke=F(Z,fe,Ee);break;case"!=":ke=x(Z,fe,Ee);break;case">":ke=U(Z,fe,Ee);break;case">=":ke=V(Z,fe,Ee);break;case"<":ke=B(Z,fe,Ee);break;case"<=":ke=se(Z,fe,Ee);break;default:throw new TypeError("Invalid operator: "+de)}return ke}function Se(Z,de){if(Z instanceof Se){if(Z.loose===de)return Z;Z=Z.value}if(!(this instanceof Se))return new Se(Z,de);r("comparator",Z,de),this.loose=de,this.parse(Z),this.semver===De?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(Z,de){return P(de,Z)},e.major=function(Z,de){return new Y(Z,de).major},e.minor=function(Z,de){return new Y(Z,de).minor},e.patch=function(Z,de){return new Y(Z,de).patch},e.compare=O,e.compareLoose=function(Z,de){return O(Z,de,!0)},e.rcompare=function(Z,de,fe){return O(de,Z,fe)},e.sort=function(Z,de){return Z.sort(function(fe,Ee){return e.compare(fe,Ee,de)})},e.rsort=function(Z,de){return Z.sort(function(fe,Ee){return e.rcompare(fe,Ee,de)})},e.gt=U,e.lt=B,e.eq=F,e.neq=x,e.gte=V,e.lte=se,e.cmp=ae,e.Comparator=Se;var De={};function Re(Z,de){if(Z instanceof Re)return Z.loose===de?Z:new Re(Z.raw,de);if(Z instanceof Se)return new Re(Z.value,de);if(!(this instanceof Re))return new Re(Z,de);if(this.loose=de,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Le(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function Oe(Z,de,fe,Ee,ke,_e,We,He,Ue,$e,qe,Fe,Q){return((de=Le(fe)?"":Le(Ee)?">="+fe+".0.0":Le(ke)?">="+fe+"."+Ee+".0":">="+de)+" "+(He=Le(Ue)?"":Le($e)?"<"+(+Ue+1)+".0.0":Le(qe)?"<"+Ue+"."+(+$e+1)+".0":Fe?"<="+Ue+"."+$e+"."+qe+"-"+Fe:"<="+He)).trim()}function we(Z,de){for(var fe=0;fe<Z.length;fe++)if(!Z[fe].test(de))return!1;if(de.prerelease.length){for(fe=0;fe<Z.length;fe++)if(r(Z[fe].semver),Z[fe].semver!==De&&Z[fe].semver.prerelease.length>0){var Ee=Z[fe].semver;if(Ee.major===de.major&&Ee.minor===de.minor&&Ee.patch===de.patch)return!0}return!1}return!0}function ve(Z,de,fe){try{de=new Re(de,fe)}catch{return!1}return de.test(Z)}function Pe(Z,de,fe,Ee){var ke,_e,We,He,Ue;switch(Z=new Y(Z,Ee),de=new Re(de,Ee),fe){case">":ke=U,_e=se,We=B,He=">",Ue=">=";break;case"<":ke=B,_e=V,We=U,He="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(Z,de,Ee))return!1;for(var $e=0;$e<de.set.length;++$e){var qe=de.set[$e],Fe=null,Q=null;if(qe.forEach(function(he){he.semver===De&&(he=new Se(">=0.0.0")),Fe=Fe||he,Q=Q||he,ke(he.semver,Fe.semver,Ee)?Fe=he:We(he.semver,Q.semver,Ee)&&(Q=he)}),Fe.operator===He||Fe.operator===Ue||(!Q.operator||Q.operator===He)&&_e(Z,Q.semver)||Q.operator===Ue&&We(Z,Q.semver))return!1}return!0}Se.prototype.parse=function(Z){var de=this.loose?k[K]:k[q],fe=Z.match(de);if(!fe)throw new TypeError("Invalid comparator: "+Z);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new Y(fe[2],this.loose):this.semver=De},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(Z){return r("Comparator.test",Z,this.loose),this.semver===De||(typeof Z=="string"&&(Z=new Y(Z,this.loose)),ae(Z,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(Z,de){if(!(Z instanceof Se))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Re(Z.value,de),ve(this.value,fe,de);if(Z.operator==="")return fe=new Re(this.value,de),ve(Z.semver,fe,de);var Ee=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),ke=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),_e=this.semver.version===Z.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),He=ae(this.semver,"<",Z.semver,de)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),Ue=ae(this.semver,">",Z.semver,de)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Ee||ke||_e&&We||He||Ue},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(Z){var de=this.loose;Z=Z.trim(),r("range",Z,de);var fe=de?k[G]:k[$];Z=Z.replace(fe,Oe),r("hyphen replace",Z),Z=Z.replace(k[N],"$1$2$3"),r("comparator trim",Z,k[N]),Z=(Z=(Z=Z.replace(k[z],"$1~")).replace(k[re],"$1^")).split(/\s+/).join(" ");var Ee=de?k[K]:k[q],ke=Z.split(" ").map(function(_e){return function(We,He){return r("comp",We),We=function(Ue,$e){return Ue.trim().split(/\s+/).map(function(qe){return function(Fe,Q){r("caret",Fe,Q);var he=Q?k[ce]:k[ue];return Fe.replace(he,function(ge,me,be,Ae,Be){var Ge;return r("caret",Fe,ge,me,be,Ae,Be),Le(me)?Ge="":Le(be)?Ge=">="+me+".0.0 <"+(+me+1)+".0.0":Le(Ae)?Ge=me==="0"?">="+me+"."+be+".0 <"+me+"."+(+be+1)+".0":">="+me+"."+be+".0 <"+(+me+1)+".0.0":Be?(r("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Ge=me==="0"?be==="0"?">="+me+"."+be+"."+Ae+Be+" <"+me+"."+be+"."+(+Ae+1):">="+me+"."+be+"."+Ae+Be+" <"+me+"."+(+be+1)+".0":">="+me+"."+be+"."+Ae+Be+" <"+(+me+1)+".0.0"):(r("no pr"),Ge=me==="0"?be==="0"?">="+me+"."+be+"."+Ae+" <"+me+"."+be+"."+(+Ae+1):">="+me+"."+be+"."+Ae+" <"+me+"."+(+be+1)+".0":">="+me+"."+be+"."+Ae+" <"+(+me+1)+".0.0"),r("caret return",Ge),Ge})}(qe,$e)}).join(" ")}(We,He),r("caret",We),We=function(Ue,$e){return Ue.trim().split(/\s+/).map(function(qe){return function(Fe,Q){var he=Q?k[J]:k[H];return Fe.replace(he,function(ge,me,be,Ae,Be){var Ge;return r("tilde",Fe,ge,me,be,Ae,Be),Le(me)?Ge="":Le(be)?Ge=">="+me+".0.0 <"+(+me+1)+".0.0":Le(Ae)?Ge=">="+me+"."+be+".0 <"+me+"."+(+be+1)+".0":Be?(r("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Ge=">="+me+"."+be+"."+Ae+Be+" <"+me+"."+(+be+1)+".0"):Ge=">="+me+"."+be+"."+Ae+" <"+me+"."+(+be+1)+".0",r("tilde return",Ge),Ge})}(qe,$e)}).join(" ")}(We,He),r("tildes",We),We=function(Ue,$e){return r("replaceXRanges",Ue,$e),Ue.split(/\s+/).map(function(qe){return function(Fe,Q){Fe=Fe.trim();var he=Q?k[M]:k[R];return Fe.replace(he,function(ge,me,be,Ae,Be,Ge){r("xRange",Fe,ge,me,be,Ae,Be,Ge);var Je=Le(be),Ve=Je||Le(Ae),Ye=Ve||Le(Be);return me==="="&&Ye&&(me=""),Je?ge=me===">"||me==="<"?"<0.0.0":"*":me&&Ye?(Ve&&(Ae=0),Ye&&(Be=0),me===">"?(me=">=",Ve?(be=+be+1,Ae=0,Be=0):Ye&&(Ae=+Ae+1,Be=0)):me==="<="&&(me="<",Ve?be=+be+1:Ae=+Ae+1),ge=me+be+"."+Ae+"."+Be):Ve?ge=">="+be+".0.0 <"+(+be+1)+".0.0":Ye&&(ge=">="+be+"."+Ae+".0 <"+be+"."+(+Ae+1)+".0"),r("xRange return",ge),ge})}(qe,$e)}).join(" ")}(We,He),r("xrange",We),We=function(Ue,$e){return r("replaceStars",Ue,$e),Ue.trim().replace(k[ee],"")}(We,He),r("stars",We),We}(_e,de)}).join(" ").split(/\s+/);return this.loose&&(ke=ke.filter(function(_e){return!!_e.match(Ee)})),ke=ke.map(function(_e){return new Se(_e,de)})},Re.prototype.intersects=function(Z,de){if(!(Z instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ee){return Z.set.some(function(ke){return ke.every(function(_e){return Ee.intersects(_e,de)})})})})},e.toComparators=function(Z,de){return new Re(Z,de).set.map(function(fe){return fe.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new Y(Z,this.loose));for(var de=0;de<this.set.length;de++)if(we(this.set[de],Z))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(Z,de,fe){var Ee=null,ke=null;try{var _e=new Re(de,fe)}catch{return null}return Z.forEach(function(We){_e.test(We)&&(Ee&&ke.compare(We)!==-1||(ke=new Y(Ee=We,fe)))}),Ee},e.minSatisfying=function(Z,de,fe){var Ee=null,ke=null;try{var _e=new Re(de,fe)}catch{return null}return Z.forEach(function(We){_e.test(We)&&(Ee&&ke.compare(We)!==1||(ke=new Y(Ee=We,fe)))}),Ee},e.validRange=function(Z,de){try{return new Re(Z,de).range||"*"}catch{return null}},e.ltr=function(Z,de,fe){return Pe(Z,de,"<",fe)},e.gtr=function(Z,de,fe){return Pe(Z,de,">",fe)},e.outside=Pe,e.prerelease=function(Z,de){var fe=le(Z,de);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(Z,de,fe){return Z=new Re(Z,fe),de=new Re(de,fe),Z.intersects(de)},e.coerce=function(Z){if(Z instanceof Y)return Z;if(typeof Z!="string")return null;var de=Z.match(k[T]);return de==null?null:le((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,E(1))},function(j,e){var E,L,r=j.exports={};function A(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function k(s){if(E===setTimeout)return setTimeout(s,0);if((E===A||!E)&&setTimeout)return E=setTimeout,setTimeout(s,0);try{return E(s,0)}catch{try{return E.call(null,s,0)}catch{return E.call(this,s,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:A}catch{E=A}try{L=typeof clearTimeout=="function"?clearTimeout:D}catch{L=D}})();var u,l=[],p=!1,m=-1;function w(){p&&u&&(p=!1,u.length?l=u.concat(l):m=-1,l.length&&f())}function f(){if(!p){var s=k(w);p=!0;for(var g=l.length;g;){for(u=l,l=[];++m<g;)u&&u[m].run();m=-1,g=l.length}u=null,p=!1,function(c){if(L===clearTimeout)return clearTimeout(c);if((L===D||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(c);try{L(c)}catch{try{return L.call(null,c)}catch{return L.call(this,c)}}}(s)}}function S(s,g){this.fun=s,this.array=g}function v(){}r.nextTick=function(s){var g=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)g[c-1]=arguments[c];l.push(new S(s,g)),l.length!==1||p||k(f)},S.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=v,r.addListener=v,r.once=v,r.off=v,r.removeListener=v,r.removeAllListeners=v,r.emit=v,r.prependListener=v,r.prependOnceListener=v,r.listeners=function(s){return[]},r.binding=function(s){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(s){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(te[133],ie([0,1]),function(j,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(k,u,l){this.level=k,this.key=u,this.value=l,this.forward=[]}}const r=void 0;class A{constructor(k,u=2**16){this.comparator=k,this[E]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new L(this._maxLevel,r,r)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,r,r)}has(k){return!!A._search(this,k,this.comparator)}get(k){return A._search(this,k,this.comparator)?.value}set(k,u){return A._insert(this,k,u,this.comparator)&&(this._size+=1),this}delete(k){const u=A._delete(this,k,this.comparator);return u&&(this._size-=1),u}forEach(k,u){let l=this._header.forward[0];for(;l;)k.call(u,l.value,l.key,this),l=l.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this._header.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this._header.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this._header.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",u=this._header.forward[0];for(;u;)k+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return k}static _search(k,u,l){let p=k._header;for(let m=k._level-1;m>=0;m--)for(;p.forward[m]&&l(p.forward[m].key,u)<0;)p=p.forward[m];if(p=p.forward[0],p&&l(p.key,u)===0)return p}static _insert(k,u,l,p){const m=[];let w=k._header;for(let f=k._level-1;f>=0;f--){for(;w.forward[f]&&p(w.forward[f].key,u)<0;)w=w.forward[f];m[f]=w}if(w=w.forward[0],w&&p(w.key,u)===0)return w.value=l,!1;{const f=A._randomLevel(k);if(f>k._level){for(let S=k._level;S<f;S++)m[S]=k._header;k._level=f}w=new L(f,u,l);for(let S=0;S<f;S++)w.forward[S]=m[S].forward[S],m[S].forward[S]=w;return!0}}static _randomLevel(k,u=.5){let l=1;for(;Math.random()<u&&l<k._maxLevel;)l+=1;return l}static _delete(k,u,l){const p=[];let m=k._header;for(let w=k._level-1;w>=0;w--){for(;m.forward[w]&&l(m.forward[w].key,u)<0;)m=m.forward[w];p[w]=m}if(m=m.forward[0],!m||l(m.key,u)!==0)return!1;for(let w=0;w<k._level&&p[w].forward[w]===m;w++)p[w].forward[w]=m.forward[w];for(;k._level>0&&k._header.forward[k._level-1]===r;)k._level-=1;return!0}}e.SkipList=A}),define(te[60],ie([0,1,13,2]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function r(b){const C=b;return C?typeof C.read=="function":!1}e.isReadable=r;function A(b){const C=b;return C?[C.on,C.pause,C.resume,C.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function D(b){const C=b;return C?A(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.isReadableBufferedStream=D;function k(b,C){return new u(b,C)}e.newWriteableStream=k;class u{constructor(C,t){this.reducer=C,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(C){if(!this.state.destroyed){if(this.state.flowing)this.emitData(C);else if(this.buffer.data.push(C),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(C){this.state.destroyed||(this.state.flowing?this.emitError(C):this.buffer.error.push(C))}end(C){this.state.destroyed||(typeof C<"u"&&this.write(C),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(C){this.listeners.data.slice(0).forEach(t=>t(C))}emitError(C){this.listeners.error.length===0?(0,E.onUnexpectedError)(C):this.listeners.error.slice(0).forEach(t=>t(C))}emitEnd(){this.listeners.end.slice(0).forEach(C=>C())}on(C,t){if(!this.state.destroyed)switch(C){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(C,t){if(this.state.destroyed)return;let a;switch(C){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const C=this.reducer(this.buffer.data);this.emitData(C),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const C of this.buffer.error)this.emitError(C);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(b,C){const t=[];let a;for(;(a=b.read())!==null;)t.push(a);return C(t)}e.consumeReadable=l;function p(b,C,t){const a=[];let i;for(;(i=b.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?C(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return b.read()}}}e.peekReadable=p;function m(b,C){return new Promise((t,a)=>{const i=[];w(b,{onData:n=>{C&&i.push(n)},onError:n=>{C?a(n):t(void 0)},onEnd:()=>{t(C?C(i):void 0)}})})}e.consumeStream=m;function w(b,C){let t=!1;return b.on("error",a=>{t||C.onError(a)}),b.on("end",()=>{t||C.onEnd()}),b.on("data",a=>{t||C.onData(a)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=w;function f(b,C){return new Promise((t,a)=>{const i=new L.DisposableStore,n=[],o=I=>{if(n.push(I),n.length>C)return i.dispose(),b.pause(),t({stream:b,buffer:n,ended:!1})},d=I=>a(I),h=()=>t({stream:b,buffer:n,ended:!0});i.add((0,L.toDisposable)(()=>b.removeListener("error",d))),b.on("error",d),i.add((0,L.toDisposable)(()=>b.removeListener("end",h))),b.on("end",h),i.add((0,L.toDisposable)(()=>b.removeListener("data",o))),b.on("data",o)})}e.peekStream=f;function S(b,C){const t=k(C);return t.end(b),t}e.toStream=S;function v(){const b=k(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=v;function s(b){let C=!1;return{read:()=>C?null:(C=!0,b)}}e.toReadable=s;function g(b,C,t){const a=k(t);return w(b,{onData:i=>a.write(C.data(i)),onError:i=>a.error(C.error?C.error(i):i),onEnd:()=>a.end()}),a}e.transform=g;function c(b,C,t){let a=!1;return{read:()=>{const i=C.read();return a?i:(a=!0,i!==null?t([b,i]):b)}}}e.prefixedReadable=c;function y(b,C,t){let a=!1;const i=k(t);return w(C,{onData:n=>a?i.write(n):(a=!0,i.write(t([b,n]))),onError:n=>i.error(n),onEnd:()=>{a||(a=!0,i.write(b)),i.end()}}),i}e.prefixedStream=y}),define(te[17],ie([0,1,60]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u";let r,A;class D{static alloc(I){return L?new D(Buffer.allocUnsafe(I)):new D(new Uint8Array(I))}static wrap(I){return L&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new D(I)}static fromString(I,R){return!(R?.dontUseNodeBuffer||!1)&&L?new D(Buffer.from(I)):(r||(r=new TextEncoder),new D(r.encode(I)))}static fromByteArray(I){const R=D.alloc(I.length);for(let M=0,T=I.length;M<T;M++)R.buffer[M]=I[M];return R}static concat(I,R){if(typeof R>"u"){R=0;for(let W=0,z=I.length;W<z;W++)R+=I[W].byteLength}const M=D.alloc(R);let T=0;for(let W=0,z=I.length;W<z;W++){const H=I[W];M.set(H,T),T+=H.byteLength}return M}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=D.alloc(this.byteLength);return I.set(this),I}toString(){return L?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(I,R){return new D(this.buffer.subarray(I,R))}set(I,R){if(I instanceof D)this.buffer.set(I.buffer,R);else if(I instanceof Uint8Array)this.buffer.set(I,R);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),R);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return l(this.buffer,I)}writeUInt32BE(I,R){p(this.buffer,I,R)}readUInt32LE(I){return m(this.buffer,I)}writeUInt32LE(I,R){w(this.buffer,I,R)}readUInt8(I){return f(this.buffer,I)}writeUInt8(I,R){S(this.buffer,I,R)}}e.VSBuffer=D;function k(h,I){return h[I+0]<<0>>>0|h[I+1]<<8>>>0}e.readUInt16LE=k;function u(h,I,R){h[R+0]=I&255,I=I>>>8,h[R+1]=I&255}e.writeUInt16LE=u;function l(h,I){return h[I]*2**24+h[I+1]*2**16+h[I+2]*2**8+h[I+3]}e.readUInt32BE=l;function p(h,I,R){h[R+3]=I,I=I>>>8,h[R+2]=I,I=I>>>8,h[R+1]=I,I=I>>>8,h[R]=I}e.writeUInt32BE=p;function m(h,I){return h[I+0]<<0>>>0|h[I+1]<<8>>>0|h[I+2]<<16>>>0|h[I+3]<<24>>>0}e.readUInt32LE=m;function w(h,I,R){h[R+0]=I&255,I=I>>>8,h[R+1]=I&255,I=I>>>8,h[R+2]=I&255,I=I>>>8,h[R+3]=I&255}e.writeUInt32LE=w;function f(h,I){return h[I]}e.readUInt8=f;function S(h,I,R){h[R]=I}e.writeUInt8=S;function v(h){return E.consumeReadable(h,I=>D.concat(I))}e.readableToBuffer=v;function s(h){return E.toReadable(h)}e.bufferToReadable=s;function g(h){return E.consumeStream(h,I=>D.concat(I))}e.streamToBuffer=g;async function c(h){return h.ended?D.concat(h.buffer):D.concat([...h.buffer,await g(h.stream)])}e.bufferedStreamToBuffer=c;function y(h){return E.toStream(h,I=>D.concat(I))}e.bufferToStream=y;function b(h){return E.transform(h,{data:I=>typeof I=="string"?D.fromString(I):D.wrap(I)},I=>D.concat(I))}e.streamToBufferReadableStream=b;function C(h){return E.newWriteableStream(I=>D.concat(I),h)}e.newWriteableBufferStream=C;function t(h,I){return E.prefixedReadable(h,I,R=>D.concat(R))}e.prefixedBufferReadable=t;function a(h,I){return E.prefixedStream(h,I,R=>D.concat(R))}e.prefixedBufferStream=a;function i(h){let I=0,R=0,M=0;const T=new Uint8Array(Math.floor(h.length/4*3)),W=H=>{switch(R){case 3:T[M++]=I|H,R=0;break;case 2:T[M++]=I|H>>>2,I=H<<6,R=3;break;case 1:T[M++]=I|H>>>4,I=H<<4,R=2;break;default:I=H<<2,R=1}};for(let H=0;H<h.length;H++){const J=h.charCodeAt(H);if(J>=65&&J<=90)W(J-65);else if(J>=97&&J<=122)W(J-97+26);else if(J>=48&&J<=57)W(J-48+52);else if(J===43||J===45)W(62);else if(J===47||J===95)W(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${h[H]}`)}}const z=M;for(;R>0;)W(0);return D.wrap(T).slice(0,z)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:h},I=!0,R=!1){const M=R?o:n;let T="";const W=h.byteLength%3;let z=0;for(;z<h.byteLength-W;z+=3){const H=h[z+0],J=h[z+1],ne=h[z+2];T+=M[H>>>2],T+=M[(H<<4|J>>>4)&63],T+=M[(J<<2|ne>>>6)&63],T+=M[ne&63]}if(W===1){const H=h[z+0];T+=M[H>>>2],T+=M[H<<4&63],I&&(T+="==")}else if(W===2){const H=h[z+0],J=h[z+1];T+=M[H>>>2],T+=M[(H<<4|J>>>4)&63],T+=M[J<<2&63],I&&(T+="=")}return T}e.encodeBase64=d}),define(te[134],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(te[11],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(a){return typeof a=="string"}e.isString=E;function L(a){return Array.isArray(a)&&a.every(i=>E(i))}e.isStringArray=L;function r(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=r;function A(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}e.isTypedArray=A;function D(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=D;function k(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=k;function u(a){return a===!0||a===!1}e.isBoolean=u;function l(a){return typeof a>"u"}e.isUndefined=l;function p(a){return!m(a)}e.isDefined=p;function m(a){return l(a)||a===null}e.isUndefinedOrNull=m;function w(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=w;function f(a){if(m(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=f;function S(...a){const i=[];for(let n=0;n<a.length;n++){const o=a[n];if(m(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(o)}return i}e.assertAllDefined=S;const v=Object.prototype.hasOwnProperty;function s(a){if(!r(a))return!1;for(const i in a)if(v.call(a,i))return!1;return!0}e.isEmptyObject=s;function g(a){return typeof a=="function"}e.isFunction=g;function c(...a){return a.length>0&&a.every(g)}e.areFunctions=c;function y(a,i){const n=Math.min(a.length,i.length);for(let o=0;o<n;o++)b(a[o],i[o])}e.validateConstraints=y;function b(a,i){if(E(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(a instanceof i)return}catch{}if(!m(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=b;function C(a){return a===null?void 0:a}e.withNullAsUndefined=C;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(te[135],ie([0,1,11]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function r(k,u){if((0,E.isString)(u)){const l=L[u];if(l===void 0)throw new Error(`${k} references an unknown codicon: ${u}`);u=l}return L[k]=u,{id:k}}function A(){return L}e.getCodiconFontCharacters=A;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package_:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(te[40],ie([0,1,11]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const c=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([y,b])=>{c[y]=b&&typeof b=="object"?L(b):b}),c}e.deepClone=L;function r(g){if(!g||typeof g!="object")return g;const c=[g];for(;c.length>0;){const y=c.shift();Object.freeze(y);for(const b in y)if(A.call(y,b)){const C=y[b];typeof C=="object"&&!Object.isFrozen(C)&&!(0,E.isTypedArray)(C)&&c.push(C)}}return g}e.deepFreeze=r;const A=Object.prototype.hasOwnProperty;function D(g,c){return k(g,c,new Set)}e.cloneAndChange=D;function k(g,c,y){if((0,E.isUndefinedOrNull)(g))return g;const b=c(g);if(typeof b<"u")return b;if(Array.isArray(g)){const C=[];for(const t of g)C.push(k(t,c,y));return C}if((0,E.isObject)(g)){if(y.has(g))throw new Error("Cannot clone recursive data-structure");y.add(g);const C={};for(const t in g)A.call(g,t)&&(C[t]=k(g[t],c,y));return y.delete(g),C}return g}function u(g,c,y=!0){return(0,E.isObject)(g)?((0,E.isObject)(c)&&Object.keys(c).forEach(b=>{b in g?y&&((0,E.isObject)(g[b])&&(0,E.isObject)(c[b])?u(g[b],c[b],y):g[b]=c[b]):g[b]=c[b]}),g):c}e.mixin=u;function l(g,c){if(g===c)return!0;if(g==null||c===null||c===void 0||typeof g!=typeof c||typeof g!="object"||Array.isArray(g)!==Array.isArray(c))return!1;let y,b;if(Array.isArray(g)){if(g.length!==c.length)return!1;for(y=0;y<g.length;y++)if(!l(g[y],c[y]))return!1}else{const C=[];for(b in g)C.push(b);C.sort();const t=[];for(b in c)t.push(b);if(t.sort(),!l(C,t))return!1;for(y=0;y<C.length;y++)if(!l(g[C[y]],c[C[y]]))return!1}return!0}e.equals=l;function p(g){const c=new Set;return JSON.stringify(g,(y,b)=>{if((0,E.isObject)(b)||Array.isArray(b)){if(c.has(b))return"[Circular]";c.add(b)}return b})}e.safeStringify=p;function m(g,c){const y=Object.create(null);return!g||!c||Object.keys(c).forEach(C=>{const t=g[C],a=c[C];l(t,a)||(y[C]=a)}),y}e.distinct=m;function w(g,c){const y=c.toLowerCase(),b=Object.keys(g).find(C=>C.toLowerCase()===y);return b?g[b]:g[c]}e.getCaseInsensitive=w;function f(g,c){const y=Object.create(null);for(const[b,C]of Object.entries(g))c(b,C)&&(y[b]=C);return y}e.filter=f;function S(g){let c=[],y=Object.getPrototypeOf(g);for(;Object.prototype!==y;)c=c.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return c}e.getAllPropertyNames=S;function v(g){const c=[];for(const y of S(g))typeof g[y]=="function"&&c.push(y);return c}e.getAllMethodNames=v;function s(g,c){const y=C=>function(){const t=Array.prototype.slice.call(arguments,0);return c(C,t)},b={};for(const C of g)b[C]=y(C);return b}e.createProxyObject=s}),define(te[136],ie([0,1,135]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(D){function k(u){return u&&typeof u=="object"&&typeof u.id=="string"}D.isThemeColor=k})(L||(e.ThemeColor=L={}));function r(D){return{id:D}}e.themeColorFromId=r;var A;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function u(c){const y=k.exec(c.id);if(!y)return u(E.Codicon.error);const[,b,C]=y,t=["codicon","codicon-"+b];return C&&t.push("codicon-modifier-"+C.substring(1)),t}D.asClassNameArray=u;function l(c){return u(c).join(" ")}D.asClassName=l;function p(c){return"."+u(c).join(".")}D.asCSSSelector=p;function m(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||L.isThemeColor(c.color))}D.isThemeIcon=m;const w=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function f(c){const y=w.exec(c);if(!y)return;const[,b]=y;return{id:b}}D.fromString=f;function S(c){return{id:c}}D.fromId=S;function v(c,y){let b=c.id;const C=b.lastIndexOf("~");return C!==-1&&(b=b.substring(0,C)),y&&(b=`${b}~${y}`),{id:b}}D.modify=v;function s(c){const y=c.id.lastIndexOf("~");if(y!==-1)return c.id.substring(y+1)}D.getModifier=s;function g(c,y){return c.id===y.id&&c.color?.id===y.color?.id}D.isEqual=g})(A||(e.ThemeIcon=A={}))}),define(te[31],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(r){return E.test(r)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(k){for(let u=0;u<k.length;u++)k[u]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),D=[];for(let k=0;k<256;k++)D.push(k.toString(16).padStart(2,"0"));return function(){r(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,l="";return l+=D[A[u++]],l+=D[A[u++]],l+=D[A[u++]],l+=D[A[u++]],l+="-",l+=D[A[u++]],l+=D[A[u++]],l+="-",l+=D[A[u++]],l+=D[A[u++]],l+="-",l+=D[A[u++]],l+=D[A[u++]],l+="-",l+=D[A[u++]],l+=D[A[u++]],l+=D[A[u++]],l+=D[A[u++]],l+=D[A[u++]],l+=D[A[u++]],l}}()}),define(te[137],ie([0,1,69,41,48]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function A(D,k){if(await new Promise((p,m)=>{const w=L.createReadStream(D),f=E.createHash("sha1");w.pipe(f);const S=(0,r.once)((v,s)=>{w.removeAllListeners(),f.removeAllListeners(),v?m(v):p(s)});w.once("error",S),w.once("end",S),f.once("error",S),f.once("data",v=>S(void 0,v.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=A}),define(te[138],ie([0,1,26]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(D){const k=D.replace(/\-/g,":").toLowerCase();return!L.has(k)}function A(){const D=(0,E.networkInterfaces)();for(const k in D){const u=D[k];if(u){for(const{mac:l}of u)if(r(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(te[101],ie([0,1,70]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(k,u,l,p=1){let m=!1;return new Promise(w=>{const f=setTimeout(()=>{if(!m)return m=!0,w(0)},l);r(k,u,p,S=>{if(!m)return m=!0,clearTimeout(f),w(S)})})}e.findFreePort=L;function r(k,u,l,p){if(u===0)return p(0);const m=new E.Socket;m.once("connect",()=>(D(m),r(k+l,u-1,l,p))),m.once("data",()=>{}),m.once("error",w=>(D(m),w.code!=="ECONNREFUSED"?r(k+l,u-1,l,p):p(k))),m.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(k,u,l,p="127.0.0.1"){let m=!1,w,f=1;const S=E.createServer({pauseOnConnect:!0});function v(s,g){m||(m=!0,S.removeAllListeners(),S.close(),w&&clearTimeout(w),g(s))}return new Promise(s=>{w=setTimeout(()=>{v(0,s)},l),S.on("listening",()=>{v(k,s)}),S.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&f<u?(k++,f++,S.listen(k,p)):v(0,s)}),S.on("close",()=>{v(0,s)}),S.listen(k,p)})}e.findFreePortFaster=A;function D(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(u){console.error(u)}}}),define(te[139],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[140],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(r,A){this.sender=r,this.onMessage=A}send(r){try{this.sender.send("vscode:message",r.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=E}),define(te[42],ie([0,1,15,13]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class r{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,k){const u=(l,...p)=>{this.validateEvent(D,l)&&k(l,...p)};return this.mapListenerToWrapper.set(k,u),E.ipcMain.on(D,u),this}once(D,k){return E.ipcMain.once(D,(u,...l)=>{this.validateEvent(D,u)&&k(u,...l)}),this}handle(D,k){return E.ipcMain.handle(D,(u,...l)=>this.validateEvent(D,u)?k(u,...l):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return E.ipcMain.removeHandler(D),this}removeListener(D,k){const u=this.mapListenerToWrapper.get(k);return u&&(E.ipcMain.removeListener(D,u),this.mapListenerToWrapper.delete(k)),this}validateEvent(D,k){if(!D||!D.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const u=k.senderFrame,l=u.url;if(!l)return!0;let p="unknown";try{p=new URL(l).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${l}'.`),!1}return p!=="vscode-app"?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${p}'.`),!1):u.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new r}),define(te[141],ie([0,1,15,42,11,139]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){L.validatedIpcMain.on(A.CONTEXT_MENU_CHANNEL,(u,l,p,m,w)=>{const f=k(u,m,p);f.popup({window:(0,r.withNullAsUndefined)(E.BrowserWindow.fromWebContents(u.sender)),x:w?w.x:void 0,y:w?w.y:void 0,positioningItem:w?w.positioningItem:void 0,callback:()=>{f&&u.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,l)}})})}e.registerContextMenuListener=D;function k(u,l,p){const m=new E.Menu;return p.forEach(w=>{let f;w.type==="separator"?f=new E.MenuItem({type:w.type}):Array.isArray(w.submenu)?f=new E.MenuItem({submenu:k(u,l,w.submenu),label:w.label}):f=new E.MenuItem({label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:w.enabled,visible:w.visible,click:(S,v,s)=>u.sender.send(l,w.id,s)}),m.append(f)}),m}}),define(te[142],ie([12,10]),function(j,e){return j.create("vs/base/common/date",e)}),define(te[143],ie([0,1,142]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,r=L*60,A=r*24,D=A*7,k=A*30,u=A*365;function l(m,w,f,S){typeof m!="number"&&(m=m.getTime());const v=Math.round((new Date().getTime()-m)/1e3);if(v<-30)return(0,E.localize)(0,null,l(new Date().getTime()+v*1e3,!1));if(!S&&v<30)return(0,E.localize)(1,null);let s;return v<L?(s=v,w?s===1?f?(0,E.localize)(2,null,s):(0,E.localize)(3,null,s):f?(0,E.localize)(4,null,s):(0,E.localize)(5,null,s):s===1?f?(0,E.localize)(6,null,s):(0,E.localize)(7,null,s):f?(0,E.localize)(8,null,s):(0,E.localize)(9,null,s)):v<r?(s=Math.floor(v/L),w?s===1?f?(0,E.localize)(10,null,s):(0,E.localize)(11,null,s):f?(0,E.localize)(12,null,s):(0,E.localize)(13,null,s):s===1?f?(0,E.localize)(14,null,s):(0,E.localize)(15,null,s):f?(0,E.localize)(16,null,s):(0,E.localize)(17,null,s)):v<A?(s=Math.floor(v/r),w?s===1?f?(0,E.localize)(18,null,s):(0,E.localize)(19,null,s):f?(0,E.localize)(20,null,s):(0,E.localize)(21,null,s):s===1?f?(0,E.localize)(22,null,s):(0,E.localize)(23,null,s):f?(0,E.localize)(24,null,s):(0,E.localize)(25,null,s)):v<D?(s=Math.floor(v/A),w?s===1?(0,E.localize)(26,null,s):(0,E.localize)(27,null,s):s===1?(0,E.localize)(28,null,s):(0,E.localize)(29,null,s)):v<k?(s=Math.floor(v/D),w?s===1?f?(0,E.localize)(30,null,s):(0,E.localize)(31,null,s):f?(0,E.localize)(32,null,s):(0,E.localize)(33,null,s):s===1?f?(0,E.localize)(34,null,s):(0,E.localize)(35,null,s):f?(0,E.localize)(36,null,s):(0,E.localize)(37,null,s)):v<u?(s=Math.floor(v/k),w?s===1?f?(0,E.localize)(38,null,s):(0,E.localize)(39,null,s):f?(0,E.localize)(40,null,s):(0,E.localize)(41,null,s):s===1?f?(0,E.localize)(42,null,s):(0,E.localize)(43,null,s):f?(0,E.localize)(44,null,s):(0,E.localize)(45,null,s)):(s=Math.floor(v/u),w?s===1?f?(0,E.localize)(46,null,s):(0,E.localize)(47,null,s):f?(0,E.localize)(48,null,s):(0,E.localize)(49,null,s):s===1?f?(0,E.localize)(50,null,s):(0,E.localize)(51,null,s):f?(0,E.localize)(52,null,s):(0,E.localize)(53,null,s))}e.fromNow=l;function p(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=p}),define(te[144],ie([12,10]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(te[49],ie([0,1,23,11,144]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(m,w){return w&&(m.stack||m.stacktrace)?r.localize(0,null,k(m),D(m.stack)||D(m.stacktrace)):k(m)}function D(m){return Array.isArray(m)?m.join(`
`):m}function k(m){return m.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${m.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?r.localize(1,null,m.message):m.message||r.localize(2,null)}function u(m=null,w=!1){if(!m)return r.localize(3,null);if(Array.isArray(m)){const f=E.coalesce(m),S=u(f[0],w);return f.length>1?r.localize(4,null,S,f.length):S}if(L.isString(m))return m;if(m.detail){const f=m.detail;if(f.error)return A(f.error,w);if(f.exception)return A(f.exception,w)}return m.stack?A(m,w):m.message?m.message:r.localize(5,null)}e.toErrorMessage=u;function l(m){const w=m;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=l;function p(m,w){let f;return typeof m=="string"?f=new Error(m):f=m,f.actions=w,f}e.createErrorWithActions=p}),define(te[145],ie([12,10]),function(j,e){return j.create("vs/base/common/jsonErrorMessages",e)}),define(te[146],ie([0,1,145]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(r){switch(r){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(te[147],ie([12,10]),function(j,e){return j.create("vs/base/common/platform",e)}),define(te[3],ie([0,1,147]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,r=!1,A=!1,D=!1,k=!1,u=!1,l=!1,p=!1,m=!1,w=!1,f,S=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT,s,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?c=e.globals.vscode.process:typeof process<"u"&&(c=process);const y=typeof c?.versions?.electron=="string",b=y&&c?.type==="renderer";if(typeof navigator=="object"&&!b)g=navigator.userAgent,L=g.indexOf("Windows")>=0,r=g.indexOf("Macintosh")>=0,p=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,w=g?.indexOf("Mobi")>=0,u=!0,f=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,S=f,v=navigator.language;else if(typeof c=="object"){L=c.platform==="win32",r=c.platform==="darwin",A=c.platform==="linux",D=A&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,l=y,m=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,S=e.LANGUAGE_DEFAULT;const I=c.env.VSCODE_NLS_CONFIG;if(I)try{const R=JSON.parse(I),M=R.availableLanguages["*"];f=R.locale,v=R.osLocale,S=M||e.LANGUAGE_DEFAULT,s=R._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var C;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(C||(e.Platform=C={}));function t(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let a=0;r?a=1:L?a=3:A&&(a=2),e.isWindows=L,e.isMacintosh=r,e.isLinux=A,e.isLinuxSnap=D,e.isNative=k,e.isElectron=l,e.isWeb=u,e.isWebWorker=u&&typeof e.globals.importScripts=="function",e.isIOS=p,e.isMobile=w,e.isCI=m,e.platform=a,e.userAgent=g,e.language=S;var i;(function(I){function R(){return e.language}I.value=R;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}I.isDefaultVariant=M;function T(){return e.language==="en"}I.isDefault=T})(i||(e.Language=i={})),e.locale=f,e.platformLocale=v,e.translationsConfigFile=s,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const I=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,W=I.length;T<W;T++){const z=I[T];if(z.id===M.data.vscodeScheduleAsyncWork){I.splice(T,1),z.callback();return}}});let R=0;return M=>{const T=++R;I.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return I=>setTimeout(I)})();var n;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=r||p?2:L?1:3;let o=!0,d=!1;function h(){if(!d){d=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,o=new Uint16Array(I.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=h,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[36],ie([0,1,3]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const r=E.globals.vscode.process;L={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(te[9],ie([0,1,36]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,r=97,A=90,D=122,k=46,u=47,l=92,p=58,m=63;class w extends Error{constructor(a,i,n){let o;typeof i=="string"&&i.indexOf("not ")===0?(o="must not be",i=i.replace(/^not /,"")):o="must be";const d=a.indexOf(".")!==-1?"property":"argument";let h=`The "${a}" ${d} ${o} of type ${i}`;h+=`. Received type ${typeof n}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,a){if(t===null||typeof t!="object")throw new w(a,"Object",t)}function S(t,a){if(typeof t!="string")throw new w(a,"string",t)}const v=E.platform==="win32";function s(t){return t===u||t===l}function g(t){return t===u}function c(t){return t>=L&&t<=A||t>=r&&t<=D}function y(t,a,i,n){let o="",d=0,h=-1,I=0,R=0;for(let M=0;M<=t.length;++M){if(M<t.length)R=t.charCodeAt(M);else{if(n(R))break;R=u}if(n(R)){if(!(h===M-1||I===1))if(I===2){if(o.length<2||d!==2||o.charCodeAt(o.length-1)!==k||o.charCodeAt(o.length-2)!==k){if(o.length>2){const T=o.lastIndexOf(i);T===-1?(o="",d=0):(o=o.slice(0,T),d=o.length-1-o.lastIndexOf(i)),h=M,I=0;continue}else if(o.length!==0){o="",d=0,h=M,I=0;continue}}a&&(o+=o.length>0?`${i}..`:"..",d=2)}else o.length>0?o+=`${i}${t.slice(h+1,M)}`:o=t.slice(h+1,M),d=M-h-1;h=M,I=0}else R===k&&I!==-1?++I:I=-1}return o}function b(t,a){f(a,"pathObject");const i=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${n}`:`${i}${t}${n}`:n}e.win32={resolve(...t){let a="",i="",n=!1;for(let o=t.length-1;o>=-1;o--){let d;if(o>=0){if(d=t[o],S(d,"path"),d.length===0)continue}else a.length===0?d=E.cwd():(d=E.env[`=${a}`]||E.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==a.toLowerCase()&&d.charCodeAt(2)===l)&&(d=`${a}\\`));const h=d.length;let I=0,R="",M=!1;const T=d.charCodeAt(0);if(h===1)s(T)&&(I=1,M=!0);else if(s(T))if(M=!0,s(d.charCodeAt(1))){let W=2,z=W;for(;W<h&&!s(d.charCodeAt(W));)W++;if(W<h&&W!==z){const H=d.slice(z,W);for(z=W;W<h&&s(d.charCodeAt(W));)W++;if(W<h&&W!==z){for(z=W;W<h&&!s(d.charCodeAt(W));)W++;(W===h||W!==z)&&(R=`\\\\${H}\\${d.slice(z,W)}`,I=W)}}}else I=1;else c(T)&&d.charCodeAt(1)===p&&(R=d.slice(0,2),I=2,h>2&&s(d.charCodeAt(2))&&(M=!0,I=3));if(R.length>0)if(a.length>0){if(R.toLowerCase()!==a.toLowerCase())continue}else a=R;if(n){if(a.length>0)break}else if(i=`${d.slice(I)}\\${i}`,n=M,M&&a.length>0)break}return i=y(i,!n,"\\",s),n?`${a}\\${i}`:`${a}${i}`||"."},normalize(t){S(t,"path");const a=t.length;if(a===0)return".";let i=0,n,o=!1;const d=t.charCodeAt(0);if(a===1)return g(d)?"\\":t;if(s(d))if(o=!0,s(t.charCodeAt(1))){let I=2,R=I;for(;I<a&&!s(t.charCodeAt(I));)I++;if(I<a&&I!==R){const M=t.slice(R,I);for(R=I;I<a&&s(t.charCodeAt(I));)I++;if(I<a&&I!==R){for(R=I;I<a&&!s(t.charCodeAt(I));)I++;if(I===a)return`\\\\${M}\\${t.slice(R)}\\`;I!==R&&(n=`\\\\${M}\\${t.slice(R,I)}`,i=I)}}}else i=1;else c(d)&&t.charCodeAt(1)===p&&(n=t.slice(0,2),i=2,a>2&&s(t.charCodeAt(2))&&(o=!0,i=3));let h=i<a?y(t.slice(i),!o,"\\",s):"";return h.length===0&&!o&&(h="."),h.length>0&&s(t.charCodeAt(a-1))&&(h+="\\"),n===void 0?o?`\\${h}`:h:o?`${n}\\${h}`:`${n}${h}`},isAbsolute(t){S(t,"path");const a=t.length;if(a===0)return!1;const i=t.charCodeAt(0);return s(i)||a>2&&c(i)&&t.charCodeAt(1)===p&&s(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,i;for(let d=0;d<t.length;++d){const h=t[d];S(h,"path"),h.length>0&&(a===void 0?a=i=h:a+=`\\${h}`)}if(a===void 0)return".";let n=!0,o=0;if(typeof i=="string"&&s(i.charCodeAt(0))){++o;const d=i.length;d>1&&s(i.charCodeAt(1))&&(++o,d>2&&(s(i.charCodeAt(2))?++o:n=!1))}if(n){for(;o<a.length&&s(a.charCodeAt(o));)o++;o>=2&&(a=`\\${a.slice(o)}`)}return e.win32.normalize(a)},relative(t,a){if(S(t,"from"),S(a,"to"),t===a)return"";const i=e.win32.resolve(t),n=e.win32.resolve(a);if(i===n||(t=i.toLowerCase(),a=n.toLowerCase(),t===a))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===l;)o++;let d=t.length;for(;d-1>o&&t.charCodeAt(d-1)===l;)d--;const h=d-o;let I=0;for(;I<a.length&&a.charCodeAt(I)===l;)I++;let R=a.length;for(;R-1>I&&a.charCodeAt(R-1)===l;)R--;const M=R-I,T=h<M?h:M;let W=-1,z=0;for(;z<T;z++){const J=t.charCodeAt(o+z);if(J!==a.charCodeAt(I+z))break;J===l&&(W=z)}if(z!==T){if(W===-1)return n}else{if(M>T){if(a.charCodeAt(I+z)===l)return n.slice(I+z+1);if(z===2)return n.slice(I+z)}h>T&&(t.charCodeAt(o+z)===l?W=z:z===2&&(W=3)),W===-1&&(W=0)}let H="";for(z=o+W+1;z<=d;++z)(z===d||t.charCodeAt(z)===l)&&(H+=H.length===0?"..":"\\..");return I+=W,H.length>0?`${H}${n.slice(I,R)}`:(n.charCodeAt(I)===l&&++I,n.slice(I,R))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===l){if(a.charCodeAt(1)===l){const i=a.charCodeAt(2);if(i!==m&&i!==k)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(c(a.charCodeAt(0))&&a.charCodeAt(1)===p&&a.charCodeAt(2)===l)return`\\\\?\\${a}`;return t},dirname(t){S(t,"path");const a=t.length;if(a===0)return".";let i=-1,n=0;const o=t.charCodeAt(0);if(a===1)return s(o)?t:".";if(s(o)){if(i=n=1,s(t.charCodeAt(1))){let I=2,R=I;for(;I<a&&!s(t.charCodeAt(I));)I++;if(I<a&&I!==R){for(R=I;I<a&&s(t.charCodeAt(I));)I++;if(I<a&&I!==R){for(R=I;I<a&&!s(t.charCodeAt(I));)I++;if(I===a)return t;I!==R&&(i=n=I+1)}}}}else c(o)&&t.charCodeAt(1)===p&&(i=a>2&&s(t.charCodeAt(2))?3:2,n=i);let d=-1,h=!0;for(let I=a-1;I>=n;--I)if(s(t.charCodeAt(I))){if(!h){d=I;break}}else h=!1;if(d===-1){if(i===-1)return".";d=i}return t.slice(0,d)},basename(t,a){a!==void 0&&S(a,"ext"),S(t,"path");let i=0,n=-1,o=!0,d;if(t.length>=2&&c(t.charCodeAt(0))&&t.charCodeAt(1)===p&&(i=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let h=a.length-1,I=-1;for(d=t.length-1;d>=i;--d){const R=t.charCodeAt(d);if(s(R)){if(!o){i=d+1;break}}else I===-1&&(o=!1,I=d+1),h>=0&&(R===a.charCodeAt(h)?--h===-1&&(n=d):(h=-1,n=I))}return i===n?n=I:n===-1&&(n=t.length),t.slice(i,n)}for(d=t.length-1;d>=i;--d)if(s(t.charCodeAt(d))){if(!o){i=d+1;break}}else n===-1&&(o=!1,n=d+1);return n===-1?"":t.slice(i,n)},extname(t){S(t,"path");let a=0,i=-1,n=0,o=-1,d=!0,h=0;t.length>=2&&t.charCodeAt(1)===p&&c(t.charCodeAt(0))&&(a=n=2);for(let I=t.length-1;I>=a;--I){const R=t.charCodeAt(I);if(s(R)){if(!d){n=I+1;break}continue}o===-1&&(d=!1,o=I+1),R===k?i===-1?i=I:h!==1&&(h=1):i!==-1&&(h=-1)}return i===-1||o===-1||h===0||h===1&&i===o-1&&i===n+1?"":t.slice(i,o)},format:b.bind(null,"\\"),parse(t){S(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.length;let n=0,o=t.charCodeAt(0);if(i===1)return s(o)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(s(o)){if(n=1,s(t.charCodeAt(1))){let W=2,z=W;for(;W<i&&!s(t.charCodeAt(W));)W++;if(W<i&&W!==z){for(z=W;W<i&&s(t.charCodeAt(W));)W++;if(W<i&&W!==z){for(z=W;W<i&&!s(t.charCodeAt(W));)W++;W===i?n=W:W!==z&&(n=W+1)}}}}else if(c(o)&&t.charCodeAt(1)===p){if(i<=2)return a.root=a.dir=t,a;if(n=2,s(t.charCodeAt(2))){if(i===3)return a.root=a.dir=t,a;n=3}}n>0&&(a.root=t.slice(0,n));let d=-1,h=n,I=-1,R=!0,M=t.length-1,T=0;for(;M>=n;--M){if(o=t.charCodeAt(M),s(o)){if(!R){h=M+1;break}continue}I===-1&&(R=!1,I=M+1),o===k?d===-1?d=M:T!==1&&(T=1):d!==-1&&(T=-1)}return I!==-1&&(d===-1||T===0||T===1&&d===I-1&&d===h+1?a.base=a.name=t.slice(h,I):(a.name=t.slice(h,d),a.base=t.slice(h,I),a.ext=t.slice(d,I))),h>0&&h!==n?a.dir=t.slice(0,h-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(v){const t=/\\/g;return()=>{const a=E.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let a="",i=!1;for(let n=t.length-1;n>=-1&&!i;n--){const o=n>=0?t[n]:C();S(o,"path"),o.length!==0&&(a=`${o}/${a}`,i=o.charCodeAt(0)===u)}return a=y(a,!i,"/",g),i?`/${a}`:a.length>0?a:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===u,i=t.charCodeAt(t.length-1)===u;return t=y(t,!a,"/",g),t.length===0?a?"/":i?"./":".":(i&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===u},join(...t){if(t.length===0)return".";let a;for(let i=0;i<t.length;++i){const n=t[i];S(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(S(t,"from"),S(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const i=1,n=t.length,o=n-i,d=1,h=a.length-d,I=o<h?o:h;let R=-1,M=0;for(;M<I;M++){const W=t.charCodeAt(i+M);if(W!==a.charCodeAt(d+M))break;W===u&&(R=M)}if(M===I)if(h>I){if(a.charCodeAt(d+M)===u)return a.slice(d+M+1);if(M===0)return a.slice(d+M)}else o>I&&(t.charCodeAt(i+M)===u?R=M:M===0&&(R=0));let T="";for(M=i+R+1;M<=n;++M)(M===n||t.charCodeAt(M)===u)&&(T+=T.length===0?"..":"/..");return`${T}${a.slice(d+R)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===u;let i=-1,n=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===u){if(!n){i=o;break}}else n=!1;return i===-1?a?"/":".":a&&i===1?"//":t.slice(0,i)},basename(t,a){a!==void 0&&S(a,"ext"),S(t,"path");let i=0,n=-1,o=!0,d;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let h=a.length-1,I=-1;for(d=t.length-1;d>=0;--d){const R=t.charCodeAt(d);if(R===u){if(!o){i=d+1;break}}else I===-1&&(o=!1,I=d+1),h>=0&&(R===a.charCodeAt(h)?--h===-1&&(n=d):(h=-1,n=I))}return i===n?n=I:n===-1&&(n=t.length),t.slice(i,n)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===u){if(!o){i=d+1;break}}else n===-1&&(o=!1,n=d+1);return n===-1?"":t.slice(i,n)},extname(t){S(t,"path");let a=-1,i=0,n=-1,o=!0,d=0;for(let h=t.length-1;h>=0;--h){const I=t.charCodeAt(h);if(I===u){if(!o){i=h+1;break}continue}n===-1&&(o=!1,n=h+1),I===k?a===-1?a=h:d!==1&&(d=1):a!==-1&&(d=-1)}return a===-1||n===-1||d===0||d===1&&a===n-1&&a===i+1?"":t.slice(a,n)},format:b.bind(null,"/"),parse(t){S(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.charCodeAt(0)===u;let n;i?(a.root="/",n=1):n=0;let o=-1,d=0,h=-1,I=!0,R=t.length-1,M=0;for(;R>=n;--R){const T=t.charCodeAt(R);if(T===u){if(!I){d=R+1;break}continue}h===-1&&(I=!1,h=R+1),T===k?o===-1?o=R:M!==1&&(M=1):o!==-1&&(M=-1)}if(h!==-1){const T=d===0&&i?1:d;o===-1||M===0||M===1&&o===h-1&&o===d+1?a.base=a.name=t.slice(T,h):(a.name=t.slice(T,o),a.base=t.slice(T,h),a.ext=t.slice(o,h))}return d>0?a.dir=t.slice(0,d-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(te[71],ie([0,1,3]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(L||(e.Source=L={}));var r;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function A(k,...u){const l=u.reduce((w,f)=>(w[f]=!0,w),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(w=>!l[w]).forEach(w=>{for(let f=0;f<p.length;f++)if(w.search(p[f])!==-1){delete k[w];break}})}e.sanitizeProcessEnvironment=A;function D(k){k&&(delete k.DEBUG,E.isMacintosh&&delete k.DYLD_LIBRARY_PATH,E.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(te[83],ie([0,1,3]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=E.globals.performance&&typeof E.globals.performance.now=="function";class r{static create(D=!0){return new r(D)}constructor(D){this._highResolution=L&&D,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=r}),define(te[4],ie([0,1,13,48,2,100,83]),function(j,e,E,L,r,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,u=!1;var l;(function(d){d.None=()=>r.Disposable.None;function h(U){if(u){const{onDidAddListener:B}=U,F=S.create();let x=0;U.onDidAddListener=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),F.print()),B?.()}}}function I(U,B){return re(U,()=>{},0,void 0,!0,void 0,B)}d.defer=I;function R(U){return(B,F=null,x)=>{let V=!1,se;return se=U(ae=>{if(!V)return se?se.dispose():V=!0,B.call(F,ae)},null,x),V&&se.dispose(),se}}d.once=R;function M(U,B,F){return ne((x,V=null,se)=>U(ae=>x.call(V,B(ae)),null,se),F)}d.map=M;function T(U,B,F){return ne((x,V=null,se)=>U(ae=>{B(ae),x.call(V,ae)},null,se),F)}d.forEach=T;function W(U,B,F){return ne((x,V=null,se)=>U(ae=>B(ae)&&x.call(V,ae),null,se),F)}d.filter=W;function z(U){return U}d.signal=z;function H(...U){return(B,F=null,x)=>(0,r.combinedDisposable)(...U.map(V=>V(se=>B.call(F,se),null,x)))}d.any=H;function J(U,B,F,x){let V=F;return M(U,se=>(V=B(V,se),V),x)}d.reduce=J;function ne(U,B){let F;const x={onWillAddFirstListener(){F=U(V.fire,V)},onDidRemoveLastListener(){F?.dispose()}};B||h(x);const V=new s(x);return B?.add(V),V.event}function re(U,B,F=100,x=!1,V=!1,se,ae){let Se,De,Re,Le=0,Oe;const we={leakWarningThreshold:se,onWillAddFirstListener(){Se=U(Pe=>{Le++,De=B(De,Pe),x&&!Re&&(ve.fire(De),De=void 0),Oe=()=>{const Z=De;De=void 0,Re=void 0,(!x||Le>1)&&ve.fire(Z),Le=0},typeof F=="number"?(clearTimeout(Re),Re=setTimeout(Oe,F)):Re===void 0&&(Re=0,queueMicrotask(Oe))})},onWillRemoveListener(){V&&Le>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,Se.dispose()}};ae||h(we);const ve=new s(we);return ae?.add(ve),ve.event}d.debounce=re;function ue(U,B=0,F){return d.debounce(U,(x,V)=>x?(x.push(V),x):[V],B,void 0,!0,void 0,F)}d.accumulate=ue;function ce(U,B=(x,V)=>x===V,F){let x=!0,V;return W(U,se=>{const ae=x||!B(se,V);return x=!1,V=se,ae},F)}d.latch=ce;function K(U,B,F){return[d.filter(U,B,F),d.filter(U,x=>!B(x),F)]}d.split=K;function q(U,B=!1,F=[]){let x=F.slice(),V=U(Se=>{x?x.push(Se):ae.fire(Se)});const se=()=>{x?.forEach(Se=>ae.fire(Se)),x=null},ae=new s({onWillAddFirstListener(){V||(V=U(Se=>ae.fire(Se)))},onDidAddFirstListener(){x&&(B?setTimeout(se):se())},onDidRemoveLastListener(){V&&V.dispose(),V=null}});return ae.event}d.buffer=q;class N{constructor(B){this.event=B,this.disposables=new r.DisposableStore}map(B){return new N(M(this.event,B,this.disposables))}forEach(B){return new N(T(this.event,B,this.disposables))}filter(B){return new N(W(this.event,B,this.disposables))}reduce(B,F){return new N(J(this.event,B,F,this.disposables))}latch(){return new N(ce(this.event,void 0,this.disposables))}debounce(B,F=100,x=!1,V=!1,se){return new N(re(this.event,B,F,x,V,se,this.disposables))}on(B,F,x){return this.event(B,F,x)}once(B,F,x){return R(this.event)(B,F,x)}dispose(){this.disposables.dispose()}}function $(U){return new N(U)}d.chain=$;function G(U,B,F=x=>x){const x=(...Se)=>ae.fire(F(...Se)),V=()=>U.on(B,x),se=()=>U.removeListener(B,x),ae=new s({onWillAddFirstListener:V,onDidRemoveLastListener:se});return ae.event}d.fromNodeEventEmitter=G;function ee(U,B,F=x=>x){const x=(...Se)=>ae.fire(F(...Se)),V=()=>U.addEventListener(B,x),se=()=>U.removeEventListener(B,x),ae=new s({onWillAddFirstListener:V,onDidRemoveLastListener:se});return ae.event}d.fromDOMEventEmitter=ee;function oe(U){return new Promise(B=>R(U)(B))}d.toPromise=oe;function le(U,B){return B(void 0),U(F=>B(F))}d.runAndSubscribe=le;function Y(U,B){let F=null;function x(se){F?.dispose(),F=new r.DisposableStore,B(se,F)}x(void 0);const V=U(se=>x(se));return(0,r.toDisposable)(()=>{V.dispose(),F?.dispose()})}d.runAndSubscribeWithStore=Y;class _{constructor(B,F){this._observable=B,this._counter=0,this._hasChanged=!1;const x={onWillAddFirstListener:()=>{B.addObserver(this)},onDidRemoveLastListener:()=>{B.removeObserver(this)}};F||h(x),this.emitter=new s(x),F&&F.add(this.emitter)}beginUpdate(B){this._counter++}handlePossibleChange(B){}handleChange(B,F){this._hasChanged=!0}endUpdate(B){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function P(U,B){return new _(U,B).emitter.event}d.fromObservable=P;function O(U){return B=>{let F=0,x=!1;const V={beginUpdate(){F++},endUpdate(){F--,F===0&&(U.reportChanges(),x&&(x=!1,B()))},handlePossibleChange(){},handleChange(){x=!0}};return U.addObserver(V),{dispose(){U.removeObserver(V)}}}}d.fromObservableLight=O})(l||(e.Event=l={}));class p{constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${p._idPool++}`,p.all.add(this)}start(h){this._stopWatch=new D.StopWatch(!0),this.listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=p,p.all=new Set,p._idPool=0;let m=-1;function w(d){const h=m;return m=d,{dispose(){m=h}}}e.setGlobalLeakWarningThreshold=w;class f{constructor(h,I=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=I,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(h,I){const R=this.threshold;if(R<=0||I<R)return;this._stacks||(this._stacks=new Map);const M=this._stacks.get(h.value)||0;if(this._stacks.set(h.value,M+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=R*.5;let T,W=0;for(const[z,H]of this._stacks)(!T||W<H)&&(T=z,W=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${W}):`),console.warn(T)}return()=>{const T=this._stacks.get(h.value)||0;this._stacks.set(h.value,T-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(h,I,R){this.callback=h,this.callbackThis=I,this.stack=R,this.subscription=new r.SafeDisposable}invoke(h){this.callback.call(this.callbackThis,h)}}class s{constructor(h){this._disposed=!1,this._options=h,this._leakageMon=m>0||this._options?.leakWarningThreshold?new f(this._options?.leakWarningThreshold??m):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(k){const h=Array.from(this._listeners);queueMicrotask(()=>{for(const I of h)I.subscription.isset()&&(I.subscription.unset(),I.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(h,I,R)=>{if(this._listeners||(this._listeners=new A.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;const M=this._listeners.isEmpty();M&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let T,W;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(W=S.create(),T=this._leakageMon.check(W,this._listeners.size+1)),k&&(W=W??S.create());const z=new v(h,I,W),H=this._listeners.push(z);M&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,h,I);const J=z.subscription.set(()=>{T?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),H(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return R instanceof r.DisposableStore?R.add(J):Array.isArray(R)&&R.push(J),J}),this._event}fire(h){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new c(this._options?.onListenerError));for(const I of this._listeners)this._deliveryQueue.push(this,I,h);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=s;class g{constructor(h=E.onUnexpectedError){this._onListenerError=h,this._queue=new A.LinkedList}get size(){return this._queue.size}push(h,I,R){this._queue.push(new y(h,I,R))}clear(h){const I=new A.LinkedList;for(const R of this._queue)R.emitter!==h&&I.push(R);this._queue=I}deliver(){for(;this._queue.size>0;){const h=this._queue.shift();try{h.listener.invoke(h.event)}catch(I){this._onListenerError(I)}}}}e.EventDeliveryQueue=g;class c extends g{clear(h){this._queue.clear()}}class y{constructor(h,I,R){this.emitter=h,this.listener=I,this.event=R}}class b extends s{async fireAsync(h,I,R){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const M of this._listeners)this._asyncDeliveryQueue.push([M,h]);for(;this._asyncDeliveryQueue.size>0&&!I.isCancellationRequested;){const[M,T]=this._asyncDeliveryQueue.shift(),W=[],z={...T,token:I,waitUntil:H=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");R&&(H=R(H,M.callback)),W.push(H)}};try{M.invoke(z)}catch(H){(0,E.onUnexpectedError)(H);continue}Object.freeze(W),await Promise.allSettled(W).then(H=>{for(const J of H)J.status==="rejected"&&(0,E.onUnexpectedError)(J.reason)})}}}}e.AsyncEmitter=b;class C extends s{constructor(h){super(h),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._listeners&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=C;class t extends C{constructor(h){super(h),this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=t;class a extends s{constructor(h){super(h),this._queuedEvents=[],this._mergeFn=h?.merge}fire(h){this.hasListeners()&&(this._queuedEvents.push(h),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(I=>super.fire(I)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=a;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new s({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const I={event:h,listener:null};this.events.push(I),this.hasListeners&&this.hook(I);const R=()=>{this.hasListeners&&this.unhook(I);const M=this.events.indexOf(I);this.events.splice(M,1)};return(0,r.toDisposable)((0,L.once)(R))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(I=>this.emitter.fire(I))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.buffers=[]}wrapEvent(h){return(I,R,M)=>h(T=>{const W=this.buffers[this.buffers.length-1];W?W.push(()=>I.call(R,T)):I.call(R,T)},void 0,M)}bufferEvents(h){const I=[];this.buffers.push(I);const R=h();return this.buffers.pop(),I.forEach(M=>M()),R}}e.EventBufferer=n;class o{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=r.Disposable.None,this.emitter=new s({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(te[22],ie([0,1,4]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,u){const l=setTimeout(k.bind(u),0);return{dispose(){clearTimeout(l)}}});var r;(function(k){function u(l){return l===k.None||l===k.Cancelled||l instanceof A?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}k.isCancellationToken=u,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(r||(e.CancellationToken=r={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=r.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=r.None}}e.CancellationTokenSource=D}),define(te[148],ie([0,1,22]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new E.CancellationTokenSource,u=this.task(k.token);return this.result={promise:u,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=L;class r{constructor(k){this.fn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const u=JSON.stringify(k);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this.fn(k)),this.lastCache}}e.LRUCachedFunction=r;class A{get cachedValues(){return this._map}constructor(k){this.fn=k,this._map=new Map}get(k){if(this._map.has(k))return this._map.get(k);const u=this.fn(k);return this._map.set(k,u),u}}e.CachedFunction=A}),define(te[27],ie([0,1,148,131]),function(j,e,E,L){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=A;const D=/{(\d+)}/g;function k(Q,...he){return he.length===0?Q:Q.replace(D,function(ge,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=he.length?ge:he[be]})}e.format=k;const u=/{([^}]+)}/g;function l(Q,he){return Q.replace(u,(ge,me)=>he[me]??ge)}e.format2=l;function p(Q){return Q.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=p;function m(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function w(Q,he){let ge=0;const me=he.charCodeAt(0);for(let be=Q.length-1;be>=0;be--)Q.charCodeAt(be)===me&&ge++;return ge}e.count=w;function f(Q,he,ge="\u2026"){return Q.length<=he?Q:`${Q.substr(0,he)}${ge}`}e.truncate=f;function S(Q,he=" "){const ge=v(Q,he);return s(ge,he)}e.trim=S;function v(Q,he){if(!Q||!he)return Q;const ge=he.length;if(ge===0||Q.length===0)return Q;let me=0;for(;Q.indexOf(he,me)===me;)me=me+ge;return Q.substring(me)}e.ltrim=v;function s(Q,he){if(!Q||!he)return Q;const ge=he.length,me=Q.length;if(ge===0||me===0)return Q;let be=me,Ae=-1;for(;Ae=Q.lastIndexOf(he,be-1),!(Ae===-1||Ae+ge!==be);){if(Ae===0)return"";be=Ae}return Q.substring(0,be)}e.rtrim=s;function g(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function c(Q){return Q.replace(/\*/g,"")}e.stripWildcards=c;function y(Q,he,ge={}){if(!Q)throw new Error("Cannot create regex from empty string");he||(Q=m(Q)),ge.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let me="";return ge.global&&(me+="g"),ge.matchCase||(me+="i"),ge.multiline&&(me+="m"),ge.unicode&&(me+="u"),new RegExp(Q,me)}e.createRegExp=y;function b(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function C(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function t(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=t;function a(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=a;function i(Q){for(let he=0,ge=Q.length;he<ge;he++){const me=Q.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=i;function n(Q,he=0,ge=Q.length){for(let me=he;me<ge;me++){const be=Q.charCodeAt(me);if(be!==32&&be!==9)return Q.substring(he,me)}return Q.substring(he,ge)}e.getLeadingWhitespace=n;function o(Q,he=Q.length-1){for(let ge=he;ge>=0;ge--){const me=Q.charCodeAt(ge);if(me!==32&&me!==9)return ge}return-1}e.lastNonWhitespaceIndex=o;function d(Q,he,ge){const me=[];let be=0;for(const Ae of Q.matchAll(he)){if(me.push(Q.slice(be,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");be=Ae.index+Ae[0].length,me.push(ge(Ae[0],...Ae.slice(1),Ae.index,Q,Ae.groups))}return me.push(Q.slice(be)),Promise.all(me).then(Ae=>Ae.join(""))}e.replaceAsync=d;function h(Q,he){return Q<he?-1:Q>he?1:0}e.compare=h;function I(Q,he,ge=0,me=Q.length,be=0,Ae=he.length){for(;ge<me&&be<Ae;ge++,be++){const Je=Q.charCodeAt(ge),Ve=he.charCodeAt(be);if(Je<Ve)return-1;if(Je>Ve)return 1}const Be=me-ge,Ge=Ae-be;return Be<Ge?-1:Be>Ge?1:0}e.compareSubstring=I;function R(Q,he){return M(Q,he,0,Q.length,0,he.length)}e.compareIgnoreCase=R;function M(Q,he,ge=0,me=Q.length,be=0,Ae=he.length){for(;ge<me&&be<Ae;ge++,be++){let Je=Q.charCodeAt(ge),Ve=he.charCodeAt(be);if(Je===Ve)continue;if(Je>=128||Ve>=128)return I(Q.toLowerCase(),he.toLowerCase(),ge,me,be,Ae);W(Je)&&(Je-=32),W(Ve)&&(Ve-=32);const Ye=Je-Ve;if(Ye!==0)return Ye}const Be=me-ge,Ge=Ae-be;return Be<Ge?-1:Be>Ge?1:0}e.compareSubstringIgnoreCase=M;function T(Q){return Q>=48&&Q<=57}e.isAsciiDigit=T;function W(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=W;function z(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=z;function H(Q,he){return Q.length===he.length&&M(Q,he)===0}e.equalsIgnoreCase=H;function J(Q,he){const ge=he.length;return he.length>Q.length?!1:M(Q,he,0,ge)===0}e.startsWithIgnoreCase=J;function ne(Q,he){const ge=Math.min(Q.length,he.length);let me;for(me=0;me<ge;me++)if(Q.charCodeAt(me)!==he.charCodeAt(me))return me;return ge}e.commonPrefixLength=ne;function re(Q,he){const ge=Math.min(Q.length,he.length);let me;const be=Q.length-1,Ae=he.length-1;for(me=0;me<ge;me++)if(Q.charCodeAt(be-me)!==he.charCodeAt(Ae-me))return me;return ge}e.commonSuffixLength=re;function ue(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=ue;function ce(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=ce;function K(Q,he){return(Q-55296<<10)+(he-56320)+65536}e.computeCodePoint=K;function q(Q,he,ge){const me=Q.charCodeAt(ge);if(ue(me)&&ge+1<he){const be=Q.charCodeAt(ge+1);if(ce(be))return K(me,be)}return me}e.getNextCodePoint=q;function N(Q,he){const ge=Q.charCodeAt(he-1);if(ce(ge)&&he>1){const me=Q.charCodeAt(he-2);if(ue(me))return K(me,ge)}return ge}class ${get offset(){return this._offset}constructor(he,ge=0){this._str=he,this._len=he.length,this._offset=ge}setOffset(he){this._offset=he}prevCodePoint(){const he=N(this._str,this._offset);return this._offset-=he>=65536?2:1,he}nextCodePoint(){const he=q(this._str,this._len,this._offset);return this._offset+=he>=65536?2:1,he}eol(){return this._offset>=this._len}}e.CodePointIterator=$;class G{get offset(){return this._iterator.offset}constructor(he,ge=0){this._iterator=new $(he,ge)}nextGraphemeLength(){const he=ke.getInstance(),ge=this._iterator,me=ge.offset;let be=he.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ae=ge.offset,Be=he.getGraphemeBreakType(ge.nextCodePoint());if(fe(be,Be)){ge.setOffset(Ae);break}be=Be}return ge.offset-me}prevGraphemeLength(){const he=ke.getInstance(),ge=this._iterator,me=ge.offset;let be=he.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ae=ge.offset,Be=he.getGraphemeBreakType(ge.prevCodePoint());if(fe(Be,be)){ge.setOffset(Ae);break}be=Be}return me-ge.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=G;function ee(Q,he){return new G(Q,he).nextGraphemeLength()}e.nextCharLength=ee;function oe(Q,he){return new G(Q,he).prevGraphemeLength()}e.prevCharLength=oe;function le(Q,he){he>0&&ce(Q.charCodeAt(he))&&he--;const ge=he+ee(Q,he);return[ge-oe(Q,ge),ge]}e.getCharContainingOffset=le;function Y(Q){const he=new G(Q);let ge=0;for(;!he.eol();)ge++,he.nextGraphemeLength();return ge}e.charCount=Y;let _;function P(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function O(Q){return _||(_=P()),_.test(Q)}e.containsRTL=O;const U=/^[\t\n\r\x20-\x7E]*$/;function B(Q){return U.test(Q)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function F(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=F;function x(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=x;function V(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=V;function se(Q,he){if(Q.length<he)return Q;const ge=/\b/g;let me=0;for(;ge.test(Q)&&!(Q.length-ge.lastIndex<he);)me=ge.lastIndex,ge.lastIndex+=1;return Q.substring(me).replace(/^\s/,"")}e.lcut=se;const ae=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Se=/\x1b\].*?\x07/g;function De(Q){return Q&&(Q=Q.replace(ae,"").replace(Se,"")),Q}e.removeAnsiEscapeCodes=De,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function Le(Q){return Re(Q)?Q.substr(1):Q}e.stripUTF8BOM=Le;function Oe(Q,he){if(!Q||!he||Q.length<he.length)return!1;const ge=he.length,me=Q.toLowerCase();let be=0,Ae=-1;for(;be<ge;){const Be=me.indexOf(he[be],Ae+1);if(Be<0)return!1;Ae=Be,be++}return!0}e.fuzzyContains=Oe;function we(Q,he=!1){return Q?(he&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=we;function ve(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=ve;function Pe(Q,he=1){if(he===0)return"";let ge=-1;do ge=Q.indexOf(`
`,ge+1),he--;while(he>0&&ge>=0);return ge===-1?Q:(Q[ge-1]==="\r"&&ge--,Q.substr(0,ge))}e.getNLines=Pe;function Z(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}e.singleLetterHash=Z;function de(Q){return ke.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=de;function fe(Q,he){return Q===0?he!==5&&he!==7:Q===2&&he===3?!1:Q===4||Q===2||Q===3||he===4||he===2||he===3?!0:!(Q===8&&(he===8||he===9||he===11||he===12)||(Q===11||Q===9)&&(he===9||he===10)||(Q===12||Q===10)&&he===10||he===5||he===13||he===7||Q===1||Q===13&&he===14||Q===6&&he===6)}var Ee;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(Ee||(e.GraphemeBreakType=Ee={}));class ke{static getInstance(){return ke._INSTANCE||(ke._INSTANCE=new ke),ke._INSTANCE}constructor(){this._data=_e()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const ge=this._data,me=ge.length/3;let be=1;for(;be<=me;)if(he<ge[3*be])be=2*be;else if(he>ge[3*be+1])be=2*be+1;else return ge[3*be+2];return 0}}ke._INSTANCE=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(Q,he){if(Q===0)return 0;const ge=He(Q,he);if(ge!==void 0)return ge;const me=new $(he,Q);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=We;function He(Q,he){const ge=new $(he,Q);let me=ge.prevCodePoint();for(;Ue(me)||me===65039||me===8419;){if(ge.offset===0)return;me=ge.prevCodePoint()}if(!V(me))return;let be=ge.offset;return be>0&&ge.prevCodePoint()===8205&&(be=ge.offset),be}function Ue(Q){return 127995<=Q&&Q<=127999}var $e;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})($e||($e={})),e.noBreakWhitespace="\xA0";class qe{static getInstance(he){return qe.cache.get(Array.from(he))}static getLocales(){return qe._locales.value}constructor(he){this.confusableDictionary=he}isAmbiguous(he){return this.confusableDictionary.has(he)}getPrimaryConfusable(he){return this.confusableDictionary.get(he)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=qe,r=qe,qe.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.cache=new E.LRUCachedFunction(Q=>{function he(Ve){const Ye=new Map;for(let tt=0;tt<Ve.length;tt+=2)Ye.set(Ve[tt],Ve[tt+1]);return Ye}function ge(Ve,Ye){const tt=new Map(Ve);for(const[ot,lt]of Ye)tt.set(ot,lt);return tt}function me(Ve,Ye){if(!Ve)return Ye;const tt=new Map;for(const[ot,lt]of Ve)Ye.has(ot)&&tt.set(ot,lt);return tt}const be=r.ambiguousCharacterData.value;let Ae=Q.filter(Ve=>!Ve.startsWith("_")&&Ve in be);Ae.length===0&&(Ae=["_default"]);let Be;for(const Ve of Ae){const Ye=he(be[Ve]);Be=me(Be,Ye)}const Ge=he(be._common),Je=ge(Ge,Be);return new qe(Je)}),qe._locales=new L.Lazy(()=>Object.keys(qe.ambiguousCharacterData.value).filter(Q=>!Q.startsWith("_")));class Fe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Fe.getRawData())),this._data}static isInvisibleCharacter(he){return Fe.getData().has(he)}static get codePoints(){return Fe.getData()}}e.InvisibleCharacters=Fe,Fe._data=void 0}),define(te[32],ie([0,1,9,3,27,11]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(d){return d===47||d===92}e.isPathSeparator=D;function k(d){return d.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=k;function u(d){return d.indexOf("/")===-1&&(d=k(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.toPosixPath=u;function l(d,h=E.posix.sep){if(!d)return"";const I=d.length,R=d.charCodeAt(0);if(D(R)){if(D(d.charCodeAt(1))&&!D(d.charCodeAt(2))){let T=3;const W=T;for(;T<I&&!D(d.charCodeAt(T));T++);if(W!==T&&!D(d.charCodeAt(T+1))){for(T+=1;T<I;T++)if(D(d.charCodeAt(T)))return d.slice(0,T+1).replace(/[\\/]/g,h)}}return h}else if(g(R)&&d.charCodeAt(1)===58)return D(d.charCodeAt(2))?d.slice(0,2)+h:d.slice(0,2);let M=d.indexOf("://");if(M!==-1){for(M+=3;M<I;M++)if(D(d.charCodeAt(M)))return d.slice(0,M+1)}return""}e.getRoot=l;function p(d){if(!L.isWindows||!d||d.length<5)return!1;let h=d.charCodeAt(0);if(h!==92||(h=d.charCodeAt(1),h!==92))return!1;let I=2;const R=I;for(;I<d.length&&(h=d.charCodeAt(I),h!==92);I++);return!(R===I||(h=d.charCodeAt(I+1),isNaN(h)||h===92))}e.isUNC=p;const m=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(d,h=L.isWindows){const I=h?m:w;return!(!d||d.length===0||/^\s+$/.test(d)||(I.lastIndex=0,I.test(d))||h&&f.test(d)||d==="."||d===".."||h&&d[d.length-1]==="."||h&&d.length!==d.trim().length||d.length>255)}e.isValidBasename=S;function v(d,h,I){const R=d===h;return!I||R?R:!d||!h?!1:(0,r.equalsIgnoreCase)(d,h)}e.isEqual=v;function s(d,h,I,R=E.sep){if(d===h)return!0;if(!d||!h||h.length>d.length)return!1;if(I){if(!(0,r.startsWithIgnoreCase)(d,h))return!1;if(h.length===d.length)return!0;let T=h.length;return h.charAt(h.length-1)===R&&T--,d.charAt(T)===R}return h.charAt(h.length-1)!==R&&(h+=R),d.indexOf(h)===0}e.isEqualOrParent=s;function g(d){return d>=65&&d<=90||d>=97&&d<=122}e.isWindowsDriveLetter=g;function c(d,h){return L.isWindows&&d.endsWith(":")&&(d+=E.sep),(0,E.isAbsolute)(d)||(d=(0,E.join)(h,d)),d=(0,E.normalize)(d),L.isWindows?(d=(0,r.rtrim)(d,E.sep),d.endsWith(":")&&(d+=E.sep)):(d=(0,r.rtrim)(d,E.sep),d||(d=E.sep)),d}e.sanitizeFilePath=c;function y(d){const h=(0,E.normalize)(d);return L.isWindows?d.length>3?!1:b(h)&&(d.length===2||h.charCodeAt(2)===92):h===E.posix.sep}e.isRootOrDriveLetter=y;function b(d,h=L.isWindows){return h?g(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.hasDriveLetter=b;function C(d){return b(d)?d[0]:void 0}e.getDriveLetter=C;function t(d,h,I){return h.length>d.length?-1:d===h?0:(I&&(d=d.toLowerCase(),h=h.toLowerCase()),d.indexOf(h))}e.indexOfPath=t;function a(d){const h=d.split(":");let I,R,M;for(const T of h){const W=Number(T);(0,A.isNumber)(W)?R===void 0?R=W:M===void 0&&(M=W):I=I?[I,T].join(":"):T}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:R!==void 0?R:void 0,column:M!==void 0?M:R!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(d,h,I=8){let R="";for(let T=0;T<I;T++){let W;T===0&&L.isWindows&&!h&&(I===3||I===4)?W=n:W=i,R+=W.charAt(Math.floor(Math.random()*W.length))}let M;return h?M=`${h}-${R}`:M=R,d?(0,E.join)(d,M):M}e.randomPath=o}),define(te[56],ie([0,1,27]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(g){return r(g,0)}e.hash=L;function r(g,c){switch(typeof g){case"object":return g===null?A(349,c):Array.isArray(g)?u(g,c):l(g,c);case"string":return k(g,c);case"boolean":return D(g,c);case"number":return A(g,c);case"undefined":return A(937,c);default:return A(617,c)}}e.doHash=r;function A(g,c){return(c<<5)-c+g|0}e.numberHash=A;function D(g,c){return A(g?433:863,c)}function k(g,c){c=A(149417,c);for(let y=0,b=g.length;y<b;y++)c=A(g.charCodeAt(y),c);return c}e.stringHash=k;function u(g,c){return c=A(104579,c),g.reduce((y,b)=>r(b,y),c)}function l(g,c){return c=A(181387,c),Object.keys(g).sort().reduce((y,b)=>(y=k(b,y),r(g[b],y)),c)}class p{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=r(c,this._value),this._value}}e.Hasher=p;var m;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function w(g,c,y=32){const b=y-c,C=~((1<<b)-1);return(g<<c|(C&g)>>>b)>>>0}function f(g,c=0,y=g.byteLength,b=0){for(let C=0;C<y;C++)g[c+C]=b}function S(g,c,y="0"){for(;g.length<c;)g=y+g;return g}function v(g,c=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(y=>y.toString(16).padStart(2,"0")).join(""):S((g>>>0).toString(16),c/4)}e.toHexString=v;class s{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const y=c.length;if(y===0)return;const b=this._buff;let C=this._buffLen,t=this._leftoverHighSurrogate,a,i;for(t!==0?(a=t,i=-1,t=0):(a=c.charCodeAt(0),i=0);;){let n=a;if(E.isHighSurrogate(a))if(i+1<y){const o=c.charCodeAt(i+1);E.isLowSurrogate(o)?(i++,n=E.computeCodePoint(a,o)):n=65533}else{t=a;break}else E.isLowSurrogate(a)&&(n=65533);if(C=this._push(b,C,n),i++,i<y)a=c.charCodeAt(i);else break}this._buffLen=C,this._leftoverHighSurrogate=t}_push(c,y,b){return b<128?c[y++]=b:b<2048?(c[y++]=192|(b&1984)>>>6,c[y++]=128|(b&63)>>>0):b<65536?(c[y++]=224|(b&61440)>>>12,c[y++]=128|(b&4032)>>>6,c[y++]=128|(b&63)>>>0):(c[y++]=240|(b&1835008)>>>18,c[y++]=128|(b&258048)>>>12,c[y++]=128|(b&4032)>>>6,c[y++]=128|(b&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=s._bigBlock32,y=this._buffDV;for(let h=0;h<64;h+=4)c.setUint32(h,y.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)c.setUint32(h,w(c.getUint32(h-12,!1)^c.getUint32(h-32,!1)^c.getUint32(h-56,!1)^c.getUint32(h-64,!1),1),!1);let b=this._h0,C=this._h1,t=this._h2,a=this._h3,i=this._h4,n,o,d;for(let h=0;h<80;h++)h<20?(n=C&t|~C&a,o=1518500249):h<40?(n=C^t^a,o=1859775393):h<60?(n=C&t|C&a|t&a,o=2400959708):(n=C^t^a,o=3395469782),d=w(b,5)+n+i+o+c.getUint32(h*4,!1)&4294967295,i=a,a=t,t=w(C,30),C=b,b=d;this._h0=this._h0+b&4294967295,this._h1=this._h1+C&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=s,s._bigBlock32=new DataView(new ArrayBuffer(320))}),define(te[72],ie([0,1,27]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(L||(L={})),function(r){const A="error",D="warning",k="warn",u="info",l="ignore";function p(w){return w?E.equalsIgnoreCase(A,w)?r.Error:E.equalsIgnoreCase(D,w)||E.equalsIgnoreCase(k,w)?r.Warning:E.equalsIgnoreCase(u,w)?r.Info:r.Ignore:r.Ignore}r.fromValue=p;function m(w){switch(w){case r.Error:return A;case r.Warning:return D;case r.Info:return u;default:return l}}r.toString=m}(L||(L={})),e.default=L}),define(te[61],ie([0,1,23,27]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class r{constructor(){this._value="",this._pos=0}reset(f){return this._value=f,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(f){const S=f.charCodeAt(0),v=this._value.charCodeAt(this._pos);return S-v}value(){return this._value[this._pos]}}e.StringIterator=r;class A{constructor(f=!0){this._caseSensitive=f}reset(f){return this._value=f,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let f=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(f)this._from++;else break;else f=!1;return this}cmp(f){return this._caseSensitive?(0,L.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class D{constructor(f=!0,S=!0){this._splitOnBackslash=f,this._caseSensitive=S}reset(f){this._from=0,this._to=0,this._value=f,this._valueLen=f.length;for(let S=f.length-1;S>=0;S--,this._valueLen--){const v=this._value.charCodeAt(S);if(!(v===47||this._splitOnBackslash&&v===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let f=!0;for(;this._to<this._valueLen;this._to++){const S=this._value.charCodeAt(this._to);if(S===47||this._splitOnBackslash&&S===92)if(f)this._from++;else break;else f=!1}return this}cmp(f){return this._caseSensitive?(0,L.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=D;var k;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(k||(k={}));class u{constructor(f,S){this._ignorePathCasing=f,this._ignoreQueryAndFragment=S,this._states=[],this._stateIdx=0}reset(f){return this._value=f,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new D(!1,!this._ignorePathCasing(f)),this._pathIterator.reset(f.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(f)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(f){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(f,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(f,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(f);if(this._states[this._stateIdx]===4)return(0,L.compare)(f,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(f,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(p||(p={}));class m{static forUris(f=()=>!1,S=()=>!1){return new m(new u(f,S))}static forPaths(f=!1){return new m(new D(void 0,!f))}static forStrings(){return new m(new r)}static forConfigKeys(){return new m(new A)}constructor(f){this._iter=f}clear(){this._root=void 0}fill(f,S){if(S){const v=S.slice(0);(0,E.shuffle)(v);for(const s of v)this.set(s,f)}else{const v=f.slice(0);(0,E.shuffle)(v);for(const s of v)this.set(s[0],s[1])}}set(f,S){const v=this._iter.reset(f);let s;this._root||(this._root=new l,this._root.segment=v.value());const g=[];for(s=this._root;;){const y=v.cmp(s.segment);if(y>0)s.left||(s.left=new l,s.left.segment=v.value()),g.push([-1,s]),s=s.left;else if(y<0)s.right||(s.right=new l,s.right.segment=v.value()),g.push([1,s]),s=s.right;else if(v.hasNext())v.next(),s.mid||(s.mid=new l,s.mid.segment=v.value()),g.push([0,s]),s=s.mid;else break}const c=s.value;s.value=S,s.key=f;for(let y=g.length-1;y>=0;y--){const b=g[y][1];b.updateHeight();const C=b.balanceFactor();if(C<-1||C>1){const t=g[y][0],a=g[y+1][0];if(t===1&&a===1)g[y][1]=b.rotateLeft();else if(t===-1&&a===-1)g[y][1]=b.rotateRight();else if(t===1&&a===-1)b.right=g[y+1][1]=g[y+1][1].rotateRight(),g[y][1]=b.rotateLeft();else if(t===-1&&a===1)b.left=g[y+1][1]=g[y+1][1].rotateLeft(),g[y][1]=b.rotateRight();else throw new Error;if(y>0)switch(g[y-1][0]){case-1:g[y-1][1].left=g[y][1];break;case 1:g[y-1][1].right=g[y][1];break;case 0:g[y-1][1].mid=g[y][1];break}else this._root=g[0][1]}}return c}get(f){return this._getNode(f)?.value}_getNode(f){const S=this._iter.reset(f);let v=this._root;for(;v;){const s=S.cmp(v.segment);if(s>0)v=v.left;else if(s<0)v=v.right;else if(S.hasNext())S.next(),v=v.mid;else break}return v}has(f){const S=this._getNode(f);return!(S?.value===void 0&&S?.mid===void 0)}delete(f){return this._delete(f,!1)}deleteSuperstr(f){return this._delete(f,!0)}_delete(f,S){const v=this._iter.reset(f),s=[];let g=this._root;for(;g;){const c=v.cmp(g.segment);if(c>0)s.push([-1,g]),g=g.left;else if(c<0)s.push([1,g]),g=g.right;else if(v.hasNext())v.next(),s.push([0,g]),g=g.mid;else break}if(g){if(S?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const c=this._min(g.right);if(c.key){const{key:y,value:b,segment:C}=c;this._delete(c.key,!1),g.key=y,g.value=b,g.segment=C}}else{const c=g.left??g.right;if(s.length>0){const[y,b]=s[s.length-1];switch(y){case-1:b.left=c;break;case 0:b.mid=c;break;case 1:b.right=c;break}}else this._root=c}for(let c=s.length-1;c>=0;c--){const y=s[c][1];y.updateHeight();const b=y.balanceFactor();if(b>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),s[c][1]=y.rotateLeft()):b<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),s[c][1]=y.rotateRight()),c>0)switch(s[c-1][0]){case-1:s[c-1][1].left=s[c][1];break;case 1:s[c-1][1].right=s[c][1];break;case 0:s[c-1][1].mid=s[c][1];break}else this._root=s[0][1]}}}_min(f){for(;f.left;)f=f.left;return f}findSubstr(f){const S=this._iter.reset(f);let v=this._root,s;for(;v;){const g=S.cmp(v.segment);if(g>0)v=v.left;else if(g<0)v=v.right;else if(S.hasNext())S.next(),s=v.value||s,v=v.mid;else break}return v&&v.value||s}findSuperstr(f){return this._findSuperstrOrElement(f,!1)}_findSuperstrOrElement(f,S){const v=this._iter.reset(f);let s=this._root;for(;s;){const g=v.cmp(s.segment);if(g>0)s=s.left;else if(g<0)s=s.right;else if(v.hasNext())v.next(),s=s.mid;else return s.mid?this._entries(s.mid):S?s.value:void 0}}hasElementOrSubtree(f){return this._findSuperstrOrElement(f,!0)!==void 0}forEach(f){for(const[S,v]of this)f(v,S)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(f){const S=[];return this._dfsEntries(f,S),S[Symbol.iterator]()}_dfsEntries(f,S){f&&(f.left&&this._dfsEntries(f.left,S),f.value&&S.push([f.key,f.value]),f.mid&&this._dfsEntries(f.mid,S),f.right&&this._dfsEntries(f.right,S))}_isBalanced(){const f=S=>{if(!S)return!0;const v=S.balanceFactor();return v<-1||v>1?!1:f(S.left)&&f(S.right)};return f(this._root)}}e.TernarySearchTree=m}),define(te[8],ie([0,1,9,3]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,A=/^\//,D=/^\/\//;function k(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==m&&(n=m+n):n=m;break}return n}const p="",m="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,d,h,I,R=!1){typeof n=="object"?(this.scheme=n.scheme||p,this.authority=n.authority||p,this.path=n.path||p,this.query=n.query||p,this.fragment=n.fragment||p):(this.scheme=u(n,R),this.authority=o||p,this.path=l(this.scheme,d||p),this.query=h||p,this.fragment=I||p,k(this,R))}get fsPath(){return y(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:d,path:h,query:I,fragment:R}=n;return o===void 0?o=this.scheme:o===null&&(o=p),d===void 0?d=this.authority:d===null&&(d=p),h===void 0?h=this.path:h===null&&(h=p),I===void 0?I=this.query:I===null&&(I=p),R===void 0?R=this.fragment:R===null&&(R=p),o===this.scheme&&d===this.authority&&h===this.path&&I===this.query&&R===this.fragment?this:new v(o,d,h,I,R)}static parse(n,o=!1){const d=w.exec(n);return d?new v(d[2]||p,a(d[4]||p),a(d[5]||p),a(d[7]||p),a(d[9]||p),o):new v(p,p,p,p,p)}static file(n){let o=p;if(L.isWindows&&(n=n.replace(/\\/g,m)),n[0]===m&&n[1]===m){const d=n.indexOf(m,2);d===-1?(o=n.substring(2),n=m):(o=n.substring(2,d),n=n.substring(d)||m)}return new v("file",o,n,p,p)}static from(n){const o=new v(n.scheme,n.authority,n.path,n.query,n.fragment);return k(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return L.isWindows&&n.scheme==="file"?d=f.file(E.win32.join(y(n,!0),...o)).path:d=E.posix.join(n.path,...o),n.with({path:d})}toString(n=!1){return b(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const o=new v(n);return o._formatted=n.external,o._fsPath=n._sep===S?n.fsPath:null,o}}else return n}}e.URI=f;const S=L.isWindows?1:void 0;class v extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(n=!1){return n?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=S),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(i,n,o){let d,h=-1;for(let I=0;I<i.length;I++){const R=i.charCodeAt(I);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||n&&R===47||o&&R===91||o&&R===93||o&&R===58)h!==-1&&(d+=encodeURIComponent(i.substring(h,I)),h=-1),d!==void 0&&(d+=i.charAt(I));else{d===void 0&&(d=i.substr(0,I));const M=s[R];M!==void 0?(h!==-1&&(d+=encodeURIComponent(i.substring(h,I)),h=-1),d+=M):h===-1&&(h=I)}}return h!==-1&&(d+=encodeURIComponent(i.substring(h))),d!==void 0?d:i}function c(i){let n;for(let o=0;o<i.length;o++){const d=i.charCodeAt(o);d===35||d===63?(n===void 0&&(n=i.substr(0,o)),n+=s[d]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function y(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,L.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=y;function b(i,n){const o=n?c:g;let d="",{scheme:h,authority:I,path:R,query:M,fragment:T}=i;if(h&&(d+=h,d+=":"),(I||h==="file")&&(d+=m,d+=m),I){let W=I.indexOf("@");if(W!==-1){const z=I.substr(0,W);I=I.substr(W+1),W=z.lastIndexOf(":"),W===-1?d+=o(z,!1,!1):(d+=o(z.substr(0,W),!1,!1),d+=":",d+=o(z.substr(W+1),!1,!0)),d+="@"}I=I.toLowerCase(),W=I.lastIndexOf(":"),W===-1?d+=o(I,!1,!0):(d+=o(I.substr(0,W),!1,!0),d+=I.substr(W))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const W=R.charCodeAt(1);W>=65&&W<=90&&(R=`/${String.fromCharCode(W+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const W=R.charCodeAt(0);W>=65&&W<=90&&(R=`${String.fromCharCode(W+32)}:${R.substr(2)}`)}d+=o(R,!0,!1)}return M&&(d+="?",d+=o(M,!1,!1)),T&&(d+="#",d+=n?T:g(T,!1,!1)),d}function C(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+C(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(t)?i.replace(t,n=>C(n)):i}}),define(te[149],ie([0,1,8]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(l){const p=l;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.isRemoteConsoleLog=L;function r(l){const p=[];let m;try{const w=JSON.parse(l.arguments),f=w[w.length-1];f&&f.__$stack&&(w.pop(),m=f.__$stack),p.push(...w)}catch{p.push("Unable to log remote console arguments",l.arguments)}return{args:p,stack:m}}e.parse=r;function A(l){if(typeof l!="string")return A(r(l).stack);const p=l;if(p){const m=D(p),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(w&&w.length===4)return{uri:E.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=A;function D(l){if(!l)return l;const p=l.indexOf(`
`);return p===-1?l:l.substring(0,p)}function k(l,p){const{args:m,stack:w}=r(l),f=typeof m[0]=="string"&&m.length===1;let S=D(w);S&&(S=`(${S.trim()})`);let v=[];if(typeof m[0]=="string"?S&&f?v=[`%c[${p}] %c${m[0]} %c${S}`,u("blue"),u(""),u("grey")]:v=[`%c[${p}] %c${m[0]}`,u("blue"),u(""),...m.slice(1)]:v=[`%c[${p}]%`,u("blue"),...m],S&&!f&&v.push(S),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,v)}e.log=k;function u(l){return`color: ${l}`}}),define(te[84],ie([0,1,17,27,8]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(l){return JSON.stringify(l,k)}e.stringify=A;function D(l){let p=JSON.parse(l);return p=u(p),p}e.parse=D;function k(l,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,L.regExpFlags)(p)}:p}function u(l,p=0){if(!l||p>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return r.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof E.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let m=0;m<l.length;++m)l[m]=u(l[m],p+1);else for(const m in l)Object.hasOwnProperty.call(l,m)&&(l[m]=u(l[m],p+1))}return l}e.revive=u}),define(te[14],ie([0,1,13,3,8]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractive="vscode-interactive",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeInteractiveSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}setServerRootPath(p){this._remoteResourcesPath=`${p}/${A.vscodeRemoteResource}`}set(p,m,w){this._hosts[p]=m,this._ports[p]=w}setConnectionToken(p,m){this._connectionTokens[p]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(p){if(this._delegate)try{return this._delegate(p)}catch(s){return E.onUnexpectedError(s),p}const m=p.authority;let w=this._hosts[m];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const f=this._ports[m],S=this._connectionTokens[m];let v=`path=${encodeURIComponent(p.path)}`;return typeof S=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),r.URI.from({scheme:L.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${w}:${f}`,path:this._remoteResourcesPath,query:v})}}e.RemoteAuthorities=new D,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(p){const m=this.toUri(p,j);return this.uriToBrowserUri(m)}uriToBrowserUri(p){return p.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(p):p.scheme===A.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${A.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?p.with({scheme:A.vscodeFileResource,authority:p.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):p}asFileUri(p){const m=this.toUri(p,j);return this.uriToFileUri(m)}uriToFileUri(p){return p.scheme===A.vscodeFileResource?p.with({scheme:A.file,authority:p.authority!==k.FALLBACK_AUTHORITY?p.authority:null,query:null,fragment:null}):p}toUri(p,m){return r.URI.isUri(p)?p:r.URI.parse(m.toUrl(p))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k;var u;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const m="vscode-coi";function w(S){let v;typeof S=="string"?v=new URL(S).searchParams:S instanceof URL?v=S.searchParams:r.URI.isUri(S)&&(v=new URL(S.toString(!0)).searchParams);const s=v?.get(m);if(s)return p.get(s)}l.getHeadersFromQuery=w;function f(S,v,s){if(!globalThis.crossOriginIsolated)return;const g=v&&s?"3":s?"2":"1";S instanceof URLSearchParams?S.set(m,g):S[m]=g}l.addSearchParam=f})(u||(e.COI=u={}))}),define(te[18],ie([0,1,32,14,9,3,27,8]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function u(f){return(0,k.uriToFsPath)(f,!0)}e.originalFSPath=u;class l{constructor(S){this._ignorePathCasing=S}compare(S,v,s=!1){return S===v?0:(0,D.compare)(this.getComparisonKey(S,s),this.getComparisonKey(v,s))}isEqual(S,v,s=!1){return S===v?!0:!S||!v?!1:this.getComparisonKey(S,s)===this.getComparisonKey(v,s)}getComparisonKey(S,v=!1){return S.with({path:this._ignorePathCasing(S)?S.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(S){return this._ignorePathCasing(S)}isEqualOrParent(S,v,s=!1){if(S.scheme===v.scheme){if(S.scheme===L.Schemas.file)return E.isEqualOrParent(u(S),u(v),this._ignorePathCasing(S))&&S.query===v.query&&(s||S.fragment===v.fragment);if((0,e.isEqualAuthority)(S.authority,v.authority))return E.isEqualOrParent(S.path,v.path,this._ignorePathCasing(S),"/")&&S.query===v.query&&(s||S.fragment===v.fragment)}return!1}joinPath(S,...v){return k.URI.joinPath(S,...v)}basenameOrAuthority(S){return(0,e.basename)(S)||S.authority}basename(S){return r.posix.basename(S.path)}extname(S){return r.posix.extname(S.path)}dirname(S){if(S.path.length===0)return S;let v;return S.scheme===L.Schemas.file?v=k.URI.file(r.dirname(u(S))).path:(v=r.posix.dirname(S.path),S.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),v="/")),S.with({path:v})}normalizePath(S){if(!S.path.length)return S;let v;return S.scheme===L.Schemas.file?v=k.URI.file(r.normalize(u(S))).path:v=r.posix.normalize(S.path),S.with({path:v})}relativePath(S,v){if(S.scheme!==v.scheme||!(0,e.isEqualAuthority)(S.authority,v.authority))return;if(S.scheme===L.Schemas.file){const c=r.relative(u(S),u(v));return A.isWindows?E.toSlashes(c):c}let s=S.path||"/";const g=v.path||"/";if(this._ignorePathCasing(S)){let c=0;for(const y=Math.min(s.length,g.length);c<y&&!(s.charCodeAt(c)!==g.charCodeAt(c)&&s.charAt(c).toLowerCase()!==g.charAt(c).toLowerCase());c++);s=g.substr(0,c)+s.substr(c)}return r.posix.relative(s,g)}resolvePath(S,v){if(S.scheme===L.Schemas.file){const s=k.URI.file(r.resolve(u(S),v));return S.with({authority:s.authority,path:s.path})}return v=E.toPosixPath(v),S.with({path:r.posix.resolve(S.path,v)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,v){return S===v||S!==void 0&&v!==void 0&&(0,D.equalsIgnoreCase)(S,v)}hasTrailingPathSeparator(S,v=r.sep){if(S.scheme===L.Schemas.file){const s=u(S);return s.length>E.getRoot(s).length&&s[s.length-1]===v}else{const s=S.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,v=r.sep){return(0,e.hasTrailingPathSeparator)(S,v)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,v=r.sep){let s=!1;if(S.scheme===L.Schemas.file){const g=u(S);s=g!==void 0&&g.length===E.getRoot(g).length&&g[g.length-1]===v}else{v="/";const g=S.path;s=g.length===1&&g.charCodeAt(g.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(S,v)?S.with({path:S.path+"/"}):S}}e.ExtUri=l,e.extUri=new l(()=>!1),e.extUriBiasedIgnorePathCase=new l(f=>f.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new l(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function p(f,S){const v=[];for(let s=0;s<f.length;s++){const g=S(f[s]);f.some((c,y)=>y===s?!1:(0,e.isEqualOrParent)(g,S(c)))||v.push(f[s])}return v}e.distinctParents=p;var m;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function S(v){const s=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(y=>{const[b,C]=y.split(":");b&&C&&s.set(b,C)});const c=v.path.substring(0,v.path.indexOf(";"));return c&&s.set(f.META_DATA_MIME,c),s}f.parseMetaData=S})(m||(e.DataUri=m={}));function w(f,S,v){if(S){let s=f.path;return s&&s[0]!==r.posix.sep&&(s=r.posix.sep+s),f.with({scheme:v,authority:S,path:s})}return f.with({scheme:v})}e.toLocalResource=w}),define(te[7],ie([0,1,22,13,4,2,18,3,134]),function(j,e,E,L,r,A,D,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function l(Y){return!!Y&&typeof Y.then=="function"}e.isThenable=l;function p(Y){const _=new E.CancellationTokenSource,P=Y(_.token),O=new Promise((U,B)=>{const F=_.token.onCancellationRequested(()=>{F.dispose(),_.dispose(),B(new L.CancellationError)});Promise.resolve(P).then(x=>{F.dispose(),_.dispose(),U(x)},x=>{F.dispose(),_.dispose(),B(x)})});return new class{cancel(){_.cancel()}then(U,B){return O.then(U,B)}catch(U){return this.then(void 0,U)}finally(U){return O.finally(U)}}}e.createCancelablePromise=p;function m(Y,_,P){return new Promise((O,U)=>{const B=_.onCancellationRequested(()=>{B.dispose(),O(P)});Y.then(O,U).finally(()=>B.dispose())})}e.raceCancellation=m;function w(Y,_){return new Promise((P,O)=>{const U=_.onCancellationRequested(()=>{U.dispose(),O(new L.CancellationError)});Y.then(P,O).finally(()=>U.dispose())})}e.raceCancellationError=w;async function f(Y){let _=-1;const P=Y.map((O,U)=>O.then(B=>(_=U,B)));try{return await Promise.race(P)}finally{Y.forEach((O,U)=>{U!==_&&O.cancel()})}}e.raceCancellablePromises=f;function S(Y,_,P){let O;const U=setTimeout(()=>{O?.(void 0),P?.()},_);return Promise.race([Y.finally(()=>clearTimeout(U)),new Promise(B=>O=B)])}e.raceTimeout=S;function v(Y){return new Promise((_,P)=>{const O=Y();l(O)?O.then(_,P):_(O)})}e.asPromise=v;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const P=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(P,P).then(O)})}return new Promise((P,O)=>{this.queuedPromise.then(P,O)})}return this.activePromise=_(),new Promise((P,O)=>{this.activePromise.then(U=>{this.activePromise=null,P(U)},U=>{this.activePromise=null,O(U)})})}}e.Throttler=s;class g{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=g;class c{constructor(){this.promiseMap=new Map}queue(_,P){const U=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(P).finally(()=>{this.promiseMap.get(_)===U&&this.promiseMap.delete(_)});return this.promiseMap.set(_,U),U}}e.SequencerByKey=c;const y=(Y,_)=>{let P=!0;const O=setTimeout(()=>{P=!1,_()},Y);return{isTriggered:()=>P,dispose:()=>{clearTimeout(O),P=!1}}},b=Y=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,Y())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};class C{constructor(_){this.defaultDelay=_,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,P=this.defaultDelay){this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,B)=>{this.doResolve=U,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const O=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=P===u.MicrotaskDelay?b(O):y(P,O),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=C;class t{constructor(_){this.delayer=new C(_),this.throttler=new s}trigger(_,P){return this.delayer.trigger(()=>this.throttler.queue(_),P)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this._isOpen=!1,this._promise=new Promise((_,P)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class i extends a{constructor(_){super(),this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=i;function n(Y,_){return _?new Promise((P,O)=>{const U=setTimeout(()=>{B.dispose(),P()},Y),B=_.onCancellationRequested(()=>{clearTimeout(U),B.dispose(),O(new L.CancellationError)})}):p(P=>n(Y,P))}e.timeout=n;function o(Y,_=0){const P=setTimeout(Y,_);return(0,A.toDisposable)(()=>clearTimeout(P))}e.disposableTimeout=o;function d(Y){const _=[];let P=0;const O=Y.length;function U(){return P<O?Y[P++]():null}function B(F){F!=null&&_.push(F);const x=U();return x?x.then(B):Promise.resolve(_)}return Promise.resolve(null).then(B)}e.sequence=d;function h(Y,_=O=>!!O,P=null){let O=0;const U=Y.length,B=()=>{if(O>=U)return Promise.resolve(P);const F=Y[O++];return Promise.resolve(F()).then(V=>_(V)?Promise.resolve(V):B())};return B()}e.first=h;function I(Y,_=O=>!!O,P=null){if(Y.length===0)return Promise.resolve(P);let O=Y.length;const U=()=>{O=-1;for(const B of Y)B.cancel?.()};return new Promise((B,F)=>{for(const x of Y)x.then(V=>{--O>=0&&_(V)?(U(),B(V)):O===0&&B(P)}).catch(V=>{--O>=0&&(U(),F(V))})})}e.firstParallel=I;class R{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new r.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(_){return this._size++,new Promise((P,O)=>{this.outstandingPromises.push({factory:_,c:P,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const P=_.factory();P.then(_.c,_.e),P.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=R;class M extends R{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const _=new N;return this.drainers.add(_),_.p}isDrained(){for(const[,_]of this.queues)if(_.size>0)return!1;return!0}queueFor(_,P=D.extUri){const O=P.getComparisonKey(_);let U=this.queues.get(O);return U||(U=new M,r.Event.once(U.onDrained)(()=>{U?.dispose(),this.queues.delete(O),this.onDidQueueDrain()}),this.queues.set(O,U)),U}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const _ of this.drainers)_.complete();this.drainers.clear()}dispose(){for(const[,_]of this.queues)_.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class W{constructor(_,P){this._token=-1,typeof _=="function"&&typeof P=="number"&&this.setIfNotSet(_,P)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,P){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},P)}setIfNotSet(_,P){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},P))}}e.TimeoutTimer=W;class z{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,P){this.cancel(),this._token=setInterval(()=>{_()},P)}}e.IntervalTimer=z;class H{constructor(_,P){this.timeoutToken=-1,this.runner=_,this.timeout=P,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=H;class J{constructor(_,P){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=P,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=J;class ne extends H{constructor(_,P){super(_,P),this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner?.(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ne;class re extends A.Disposable{constructor(_,P){super(),this.options=_,this.handler=P,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.options.maxBufferedWork)return!1}else if(this.pending+_.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const P of _)this.pendingWork.push(P);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new H(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Y=>{(0,k.setTimeout0)(()=>{if(_)return;const P=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,P-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(Y,_)=>{const P=requestIdleCallback(Y,typeof _=="number"?{timeout:_}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(P))}}}}();class ue{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(P){this._error=P}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ue;async function ce(Y,_,P){let O;for(let U=0;U<P;U++)try{return await Y()}catch(B){O=B,await n(_)}throw O}e.retry=ce;class K{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(_,P,O){return this._pending={taskId:_,cancel:()=>O?.(),promise:P},P.then(()=>this.donePending(_),()=>this.donePending(_)),P}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let P,O;const U=new Promise((B,F)=>{P=B,O=F});this._next={run:_,promise:U,promiseResolve:P,promiseReject:O}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=K;class q{constructor(_,P=()=>Date.now()){this.interval=_,this.nowFn=P,this.lastIncrementTime=0,this.value=0}increment(){const _=this.nowFn();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class N{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,P)=>{this.completeCallback=_,this.errorCallback=P})}complete(_){return new Promise(P=>{this.completeCallback(_),this.resolved=!0,P()})}error(_){return new Promise(P=>{this.errorCallback(_),this.rejected=!0,P()})}cancel(){new Promise(_=>{this.errorCallback(new L.CancellationError),this.rejected=!0,_()})}}e.DeferredPromise=N;var $;(function(Y){async function _(O){let U;const B=await Promise.all(O.map(F=>F.then(x=>x,x=>{U||(U=x)})));if(typeof U<"u")throw U;return B}Y.settled=_;function P(O){return new Promise(async(U,B)=>{try{await O(U,B)}catch(F){B(F)}})}Y.withAsyncBody=P})($||(e.Promises=$={}));var G;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(G||(G={}));class ee{static fromArray(_){return new ee(P=>{P.emitMany(_)})}static fromPromise(_){return new ee(async P=>{P.emitMany(await _)})}static fromPromises(_){return new ee(async P=>{await Promise.all(_.map(async O=>P.emitOne(await O)))})}static merge(_){return new ee(async P=>{await Promise.all(_.map(async O=>{for await(const U of O)P.emitOne(U)}))})}constructor(_){this._state=0,this._results=[],this._error=null,this._onStateChanged=new r.Emitter,queueMicrotask(async()=>{const P={emitOne:O=>this.emitOne(O),emitMany:O=>this.emitMany(O),reject:O=>this.reject(O)};try{await Promise.resolve(_(P)),this.resolve()}catch(O){this.reject(O)}finally{P.emitOne=void 0,P.emitMany=void 0,P.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(_<this._results.length)return{done:!1,value:this._results[_++]};if(this._state===1)return{done:!0,value:void 0};await r.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(_,P){return new ee(async O=>{for await(const U of _)O.emitOne(P(U))})}map(_){return ee.map(this,_)}static filter(_,P){return new ee(async O=>{for await(const U of _)P(U)&&O.emitOne(U)})}filter(_){return ee.filter(this,_)}static coalesce(_){return ee.filter(_,P=>!!P)}coalesce(){return ee.coalesce(this)}static async toPromise(_){const P=[];for await(const O of _)P.push(O);return P}toPromise(){return ee.toPromise(this)}emitOne(_){this._state===0&&(this._results.push(_),this._onStateChanged.fire())}emitMany(_){this._state===0&&(this._results=this._results.concat(_),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(_){this._state===0&&(this._state=2,this._error=_,this._onStateChanged.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class oe extends ee{constructor(_,P){super(P),this._source=_}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function le(Y){const _=new E.CancellationTokenSource,P=Y(_.token);return new oe(_,async O=>{const U=_.token.onCancellationRequested(()=>{U.dispose(),_.dispose(),O.reject(new L.CancellationError)});try{for await(const B of P){if(_.token.isCancellationRequested)return;O.emitOne(B)}U.dispose(),_.dispose()}catch(B){U.dispose(),_.dispose(),O.reject(B)}})}e.createCancelableAsyncIterable=le}),define(te[102],ie([0,1,23,7,32,35,9,3,27]),function(j,e,E,L,r,A,D,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function l(){return Object.create(null)}e.getEmptyExpression=l,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const p="[/\\\\]",m="[^/\\\\]",w=/\//g;function f(q,N){switch(q){case 0:return"";case 1:return`${m}*?`;default:return`(?:${p}|${m}+${p}${N?`|${p}${m}+`:""})*?`}}function S(q,N){if(!q)return[];const $=[];let G=!1,ee=!1,oe="";for(const le of q){switch(le){case N:if(!G&&!ee){$.push(oe),oe="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}oe+=le}return oe&&$.push(oe),$}e.splitGlobAware=S;function v(q){if(!q)return"";let N="";const $=S(q,e.GLOB_SPLIT);if($.every(G=>G===e.GLOBSTAR))N=".*";else{let G=!1;$.forEach((ee,oe)=>{if(ee===e.GLOBSTAR){if(G)return;N+=f(2,oe===$.length-1)}else{let le=!1,Y="",_=!1,P="";for(const O of ee){if(O!=="}"&&le){Y+=O;continue}if(_&&(O!=="]"||!P)){let U;O==="-"?U=O:(O==="^"||O==="!")&&!P?U="^":O===e.GLOB_SPLIT?U="":U=(0,u.escapeRegExpCharacters)(O),P+=U;continue}switch(O){case"{":le=!0;continue;case"[":_=!0;continue;case"}":{const B=`(?:${S(Y,",").map(F=>v(F)).join("|")})`;N+=B,le=!1,Y="";break}case"]":{N+="["+P+"]",_=!1,P="";break}case"?":N+=m;continue;case"*":N+=f(1);continue;default:N+=(0,u.escapeRegExpCharacters)(O)}}oe<$.length-1&&($[oe+1]!==e.GLOBSTAR||oe+2<$.length)&&(N+=p)}G=ee===e.GLOBSTAR})}return N}const s=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),a=function(){return!1},i=function(){return null};function n(q,N){if(!q)return i;let $;typeof q!="string"?$=q.pattern:$=q,$=$.trim();const G=`${$}_${!!N.trimForExclusions}`;let ee=t.get(G);if(ee)return o(ee,q);let oe;return s.test($)?ee=h($.substr(4),$):(oe=g.exec(d($,N)))?ee=I(oe[1],$):(N.trimForExclusions?y:c).test($)?ee=R($,N):(oe=b.exec(d($,N)))?ee=M(oe[1].substr(1),$,!0):(oe=C.exec(d($,N)))?ee=M(oe[1],$,!1):ee=T($),t.set(G,ee),o(ee,q)}function o(q,N){if(typeof N=="string")return q;const $=function(G,ee){return(0,r.isEqualOrParent)(G,N.base,!k.isLinux)?q((0,u.ltrim)(G.substr(N.base.length),D.sep),ee):null};return $.allBasenames=q.allBasenames,$.allPaths=q.allPaths,$.basenames=q.basenames,$.patterns=q.patterns,$}function d(q,N){return N.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function h(q,N){return function($,G){return typeof $=="string"&&$.endsWith(q)?N:null}}function I(q,N){const $=`/${q}`,G=`\\${q}`,ee=function(le,Y){return typeof le!="string"?null:Y?Y===q?N:null:le===q||le.endsWith($)||le.endsWith(G)?N:null},oe=[q];return ee.basenames=oe,ee.patterns=[N],ee.allBasenames=oe,ee}function R(q,N){const $=ce(q.slice(1,-1).split(",").map(Y=>n(Y,N)).filter(Y=>Y!==i),q),G=$.length;if(!G)return i;if(G===1)return $[0];const ee=function(Y,_){for(let P=0,O=$.length;P<O;P++)if($[P](Y,_))return q;return null},oe=$.find(Y=>!!Y.allBasenames);oe&&(ee.allBasenames=oe.allBasenames);const le=$.reduce((Y,_)=>_.allPaths?Y.concat(_.allPaths):Y,[]);return le.length&&(ee.allPaths=le),ee}function M(q,N,$){const G=D.sep===D.posix.sep,ee=G?q:q.replace(w,D.sep),oe=D.sep+ee,le=D.posix.sep+q;let Y;return $?Y=function(_,P){return typeof _=="string"&&(_===ee||_.endsWith(oe)||!G&&(_===q||_.endsWith(le)))?N:null}:Y=function(_,P){return typeof _=="string"&&(_===ee||!G&&_===q)?N:null},Y.allPaths=[($?"*/":"./")+q],Y}function T(q){try{const N=new RegExp(`^${v(q)}$`);return function($){return N.lastIndex=0,typeof $=="string"&&N.test($)?q:null}}catch{return i}}function W(q,N,$){return!q||typeof N!="string"?!1:z(q)(N,void 0,$)}e.match=W;function z(q,N={}){if(!q)return a;if(typeof q=="string"||H(q)){const $=n(q,N);if($===i)return a;const G=function(ee,oe){return!!$(ee,oe)};return $.allBasenames&&(G.allBasenames=$.allBasenames),$.allPaths&&(G.allPaths=$.allPaths),G}return re(q,N)}e.parse=z;function H(q){const N=q;return N?typeof N.base=="string"&&typeof N.pattern=="string":!1}e.isRelativePattern=H;function J(q){return q.allBasenames||[]}e.getBasenameTerms=J;function ne(q){return q.allPaths||[]}e.getPathTerms=ne;function re(q,N){const $=ce(Object.getOwnPropertyNames(q).map(Y=>ue(Y,q[Y],N)).filter(Y=>Y!==i)),G=$.length;if(!G)return i;if(!$.some(Y=>!!Y.requiresSiblings)){if(G===1)return $[0];const Y=function(O,U){let B;for(let F=0,x=$.length;F<x;F++){const V=$[F](O,U);if(typeof V=="string")return V;(0,L.isThenable)(V)&&(B||(B=[]),B.push(V))}return B?(async()=>{for(const F of B){const x=await F;if(typeof x=="string")return x}return null})():null},_=$.find(O=>!!O.allBasenames);_&&(Y.allBasenames=_.allBasenames);const P=$.reduce((O,U)=>U.allPaths?O.concat(U.allPaths):O,[]);return P.length&&(Y.allPaths=P),Y}const ee=function(Y,_,P){let O,U;for(let B=0,F=$.length;B<F;B++){const x=$[B];x.requiresSiblings&&P&&(_||(_=(0,D.basename)(Y)),O||(O=_.substr(0,_.length-(0,D.extname)(Y).length)));const V=x(Y,_,O,P);if(typeof V=="string")return V;(0,L.isThenable)(V)&&(U||(U=[]),U.push(V))}return U?(async()=>{for(const B of U){const F=await B;if(typeof F=="string")return F}return null})():null},oe=$.find(Y=>!!Y.allBasenames);oe&&(ee.allBasenames=oe.allBasenames);const le=$.reduce((Y,_)=>_.allPaths?Y.concat(_.allPaths):Y,[]);return le.length&&(ee.allPaths=le),ee}function ue(q,N,$){if(N===!1)return i;const G=n(q,$);if(G===i)return i;if(typeof N=="boolean")return G;if(N){const ee=N.when;if(typeof ee=="string"){const oe=(le,Y,_,P)=>{if(!P||!G(le,Y))return null;const O=ee.replace("$(basename)",()=>_),U=P(O);return(0,L.isThenable)(U)?U.then(B=>B?q:null):U?q:null};return oe.requiresSiblings=!0,oe}}return G}function ce(q,N){const $=q.filter(Y=>!!Y.basenames);if($.length<2)return q;const G=$.reduce((Y,_)=>{const P=_.basenames;return P?Y.concat(P):Y},[]);let ee;if(N){ee=[];for(let Y=0,_=G.length;Y<_;Y++)ee.push(N)}else ee=$.reduce((Y,_)=>{const P=_.patterns;return P?Y.concat(P):Y},[]);const oe=function(Y,_){if(typeof Y!="string")return null;if(!_){let O;for(O=Y.length;O>0;O--){const U=Y.charCodeAt(O-1);if(U===47||U===92)break}_=Y.substr(O)}const P=G.indexOf(_);return P!==-1?ee[P]:null};oe.basenames=G,oe.patterns=ee,oe.allBasenames=G;const le=q.filter(Y=>!Y.basenames);return le.push(oe),le}function K(q,N){return(0,E.equals)(q,N,($,G)=>typeof $=="string"&&typeof G=="string"?$===G:typeof $!="string"&&typeof G!="string"?$.base===G.base&&$.pattern===G.pattern:!1)}e.patternsEquals=K}),define(te[44],ie([0,1,23,32,9,3,18,27]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function u(i,n){const{os:o,tildify:d,relative:h}=n;if(h){const M=l(i,h,o);if(typeof M=="string")return M}let I=i.fsPath;if(o===1&&!A.isWindows?I=I.replace(/\//g,"\\"):o!==1&&A.isWindows&&(I=I.replace(/\\/g,"/")),o!==1&&d?.userHome){const M=d.userHome.fsPath;let T;i.scheme!==d.userHome.scheme&&i.path.startsWith(r.posix.sep)?T=d.userHome.with({path:i.path}).fsPath:T=i.fsPath,I=w(T,M,o)}return(o===1?r.win32:r.posix).normalize(p(I,o===1))}e.getPathLabel=u;function l(i,n,o){const d=o===1?r.win32:r.posix,h=o===3?D.extUri:D.extUriIgnorePathCase,I=n.getWorkspace(),R=(0,E.firstOrDefault)(I.folders);if(!R)return;i.scheme!==R.uri.scheme&&i.path.startsWith(r.posix.sep)&&(i=R.uri.with({path:i.path}));const M=n.getWorkspaceFolder(i);if(!M)return;let T;if(h.isEqual(M.uri,i)?T="":T=h.relativePath(M.uri,i)??"",T&&(T=d.normalize(T)),I.folders.length>1&&!n.noPrefix){const W=M.name?M.name:h.basenameOrAuthority(M.uri);T=T?`${W} \u2022 ${T}`:W}return T}function p(i,n=A.isWindows){return(0,L.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=p;let m=Object.create(null);function w(i,n,o=A.OS){if(o===1||!i||!n)return i;let d=m.original===n?m.normalized:void 0;d||(d=n,A.isWindows&&(d=(0,L.toSlashes)(d)),d=`${(0,k.rtrim)(d,r.posix.sep)}${r.posix.sep}`,m={original:n,normalized:d});let h=i;return A.isWindows&&(h=(0,L.toSlashes)(h)),(o===3?h.startsWith(d):(0,k.startsWithIgnoreCase)(h,d))?`~/${h.substr(d.length)}`:i}e.tildify=w;function f(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=f;const S="\u2026",v="\\\\",s="~";function g(i,n=r.sep){const o=new Array(i.length);let d=!1;for(let h=0;h<i.length;h++){const I=i[h];if(I===""){o[h]=`.${n}`;continue}if(!I){o[h]=I;continue}d=!0;let R="",M=I;M.indexOf(v)===0?(R=M.substr(0,M.indexOf(v)+v.length),M=M.substr(M.indexOf(v)+v.length)):M.indexOf(n)===0?(R=M.substr(0,M.indexOf(n)+n.length),M=M.substr(M.indexOf(n)+n.length)):M.indexOf(s)===0&&(R=M.substr(0,M.indexOf(s)+s.length),M=M.substr(M.indexOf(s)+s.length));const T=M.split(n);for(let W=1;d&&W<=T.length;W++)for(let z=T.length-W;d&&z>=0;z--){d=!1;let H=T.slice(z,z+W).join(n);for(let J=0;!d&&J<i.length;J++)if(J!==h&&i[J]&&i[J].indexOf(H)>-1){const ne=z+W===T.length,re=z>0&&i[J].indexOf(n)>-1?n+H:H,ue=i[J].endsWith(re);d=!ne||ue}if(!d){let J="";(T[0].endsWith(":")||R!=="")&&(z===1&&(z=0,W++,H=T[0]+n+H),z>0&&(J=T[0]+n),J=R+J),z>0&&(J=J+S+n),J=J+H,z+W<T.length&&(J=J+n+S),o[h]=J}}d&&(o[h]=I)}return o}e.shorten=g;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function y(i,n=Object.create(null)){const o=[];let d=!1,h="";for(const I of i)if(I==="$"||d&&I==="{")h&&o.push({value:h,type:c.TEXT}),h="",d=!0;else if(I==="}"&&d){const R=n[h];if(typeof R=="string")R.length&&o.push({value:R,type:c.VARIABLE});else if(R){const M=o[o.length-1];(!M||M.type!==c.SEPARATOR)&&o.push({value:R.label,type:c.SEPARATOR})}h="",d=!1}else h+=I;return h&&!d&&o.push({value:h,type:c.TEXT}),o.filter((I,R)=>{if(I.type===c.SEPARATOR){const M=o[R-1],T=o[R+1];return[M,T].every(W=>W&&(W.type===c.VARIABLE||W.type===c.TEXT)&&W.value.length>0)}return!0}).map(I=>I.value).join("")}e.template=y;function b(i,n){return A.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=b;function C(i,n){return A.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=C;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function a(i){const n=i.indexOf("/")!==-1?r.posix:r.win32,o=n.basename(i),d=n.dirname(i);return o.length?{name:o,parentPath:d}:{name:d,parentPath:""}}e.splitName=a}),define(te[150],ie([0,1,17,8]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(m){return m.toJSON()}class A{constructor(w){this._uriTransformer=w}transformIncoming(w){const f=this._uriTransformer.transformIncoming(w);return f===w?w:r(L.URI.from(f))}transformOutgoing(w){const f=this._uriTransformer.transformOutgoing(w);return f===w?w:r(L.URI.from(f))}transformOutgoingURI(w){const f=this._uriTransformer.transformOutgoing(w);return f===w?w:L.URI.from(f)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function D(m,w,f){if(!m||f>200)return null;if(typeof m=="object"){if(m instanceof L.URI)return w.transformOutgoing(m);for(const S in m)if(Object.hasOwnProperty.call(m,S)){const v=D(m[S],w,f+1);v!==null&&(m[S]=v)}}return null}function k(m,w){const f=D(m,w,0);return f===null?m:f}e.transformOutgoingURIs=k;function u(m,w,f,S){if(!m||S>200)return null;if(typeof m=="object"){if(m.$mid===1)return f?L.URI.revive(w.transformIncoming(m)):w.transformIncoming(m);if(m instanceof E.VSBuffer)return null;for(const v in m)if(Object.hasOwnProperty.call(m,v)){const s=u(m[v],w,f,S+1);s!==null&&(m[v]=s)}}return null}function l(m,w){const f=u(m,w,!1,0);return f===null?m:f}e.transformIncomingURIs=l;function p(m,w){const f=u(m,w,!0,0);return f===null?m:f}e.transformAndReviveIncomingURIs=p}),define(te[85],ie([0,1,26,61,31,138]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(l){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(l)}value(){if(this._value===void 0){let l=0,p=0;const m=(0,E.networkInterfaces)();for(const w in m){const f=m[w];if(f)for(const{mac:S,internal:v}of f)v||(p+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(l+=1))}this._value=p>0?l/p:0}return this._value}};let D;async function k(l){return D||(D=(async()=>await u(l)||r.generateUuid())()),D}e.getMachineId=k;async function u(l){try{const p=await new Promise((w,f)=>{j(["crypto"],w,f)}),m=(0,A.getMac)();return p.createHash("sha256").update(m,"utf8").digest("hex")}catch(p){l(p);return}}}),define(te[24],ie([0,1,41,26,151,7,32,82,9,3,18,8]),function(j,e,E,L,r,A,D,k,u,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function f(re,ue=w.UNLINK){if((0,D.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return ue===w.UNLINK?v(re):S(re)}async function S(re){try{const ue=(0,D.randomPath)((0,L.tmpdir)());try{await E.promises.rename(re,ue)}catch(ce){return ce.code==="ENOENT"?void 0:v(re)}v(ue).catch(ce=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function v(re){return(0,r.promisify)(E.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function s(re){if((0,D.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=s;async function g(re,ue){return b(await(ue?c(re):(0,r.promisify)(E.readdir)(re)))}async function c(re){try{return await(0,r.promisify)(E.readdir)(re,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ue=[],ce=await g(re);for(const K of ce){let q=!1,N=!1,$=!1;try{const G=await e.Promises.lstat((0,u.join)(re,K));q=G.isFile(),N=G.isDirectory(),$=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ue.push({name:K,isFile:()=>q,isDirectory:()=>N,isSymbolicLink:()=>$})}return ue}function y(re){return b(E.readdirSync(re))}e.readdirSync=y;function b(re){return re.map(ue=>typeof ue=="string"?l.isMacintosh?(0,k.normalizeNFC)(ue):ue:(ue.name=l.isMacintosh?(0,k.normalizeNFC)(ue.name):ue.name,ue))}async function C(re){const ue=await g(re),ce=[];for(const K of ue)await a.existsDirectory((0,u.join)(re,K))&&ce.push(K);return ce}function t(re,ue=1e3){return new Promise(ce=>{let K=!1;const q=setInterval(()=>{K||(K=!0,E.access(re,N=>{K=!1,N&&(clearInterval(q),ce(void 0))}))},ue)})}e.whenDeleted=t;var a;(function(re){async function ue(q){let N;try{if(N=await e.Promises.lstat(q),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(l.isWindows&&$.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw G}throw $}}re.stat=ue;async function ce(q){try{const{stat:N,symbolicLink:$}=await re.stat(q);return N.isFile()&&$?.dangling!==!0}catch{}return!1}re.existsFile=ce;async function K(q){try{const{stat:N,symbolicLink:$}=await re.stat(q);return N.isDirectory()&&$?.dangling!==!0}catch{}return!1}re.existsDirectory=K})(a||(e.SymlinkSupport=a={}));const i=new A.ResourceQueue;function n(re,ue,ce){return i.queueFor(m.URI.file(re),p.extUriBiasedIgnorePathCase).queue(()=>{const K=R(ce);return new Promise((q,N)=>h(re,ue,K,$=>$?N($):q()))})}let o=!0;function d(re){o=re}e.configureFlushOnWrite=d;function h(re,ue,ce,K){if(!o)return E.writeFile(re,ue,{mode:ce.mode,flag:ce.flag},K);E.open(re,ce.flag,ce.mode,(q,N)=>{if(q)return K(q);E.writeFile(N,ue,$=>{if($)return E.close(N,()=>K($));E.fdatasync(N,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),d(!1)),E.close(N,ee=>K(ee))))})})}function I(re,ue,ce){const K=R(ce);if(!o)return E.writeFileSync(re,ue,{mode:K.mode,flag:K.flag});const q=E.openSync(re,K.flag,K.mode);try{E.writeFileSync(q,ue);try{E.fdatasyncSync(q)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),d(!1)}}finally{E.closeSync(q)}}e.writeFileSync=I;function R(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function M(re,ue){if(re!==ue)try{await e.Promises.rename(re,ue)}catch(ce){if(re.toLowerCase()!==ue.toLowerCase()&&ce.code==="EXDEV"||re.endsWith("."))await T(re,ue,{preserveSymlinks:!1}),await f(re,w.MOVE);else throw ce}}async function T(re,ue,ce){return z(re,ue,{root:{source:re,target:ue},options:ce,handledSourcePaths:new Set})}const W=511;async function z(re,ue,ce){if(ce.handledSourcePaths.has(re))return;ce.handledSourcePaths.add(re);const{stat:K,symbolicLink:q}=await a.stat(re);if(q){if(ce.options.preserveSymlinks)try{return await ne(re,ue,ce)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(q.dangling)return}return K.isDirectory()?H(re,ue,K.mode&W,ce):J(re,ue,K.mode&W)}async function H(re,ue,ce,K){await e.Promises.mkdir(ue,{recursive:!0,mode:ce});const q=await g(re);for(const N of q)await z((0,u.join)(re,N),(0,u.join)(ue,N),K)}async function J(re,ue,ce){await e.Promises.copyFile(re,ue),await e.Promises.chmod(ue,ce)}async function ne(re,ue,ce){let K=await e.Promises.readlink(re);(0,D.isEqualOrParent)(K,ce.root.source,!l.isLinux)&&(K=(0,u.join)(ce.root.target,K.substr(ce.root.source.length+1))),await e.Promises.symlink(K,ue)}e.Promises=new class{get access(){return(0,r.promisify)(E.access)}get stat(){return(0,r.promisify)(E.stat)}get lstat(){return(0,r.promisify)(E.lstat)}get utimes(){return(0,r.promisify)(E.utimes)}get read(){return(re,ue,ce,K,q)=>new Promise((N,$)=>{E.read(re,ue,ce,K,q,(G,ee,oe)=>G?$(G):N({bytesRead:ee,buffer:oe}))})}get readFile(){return(0,r.promisify)(E.readFile)}get write(){return(re,ue,ce,K,q)=>new Promise((N,$)=>{E.write(re,ue,ce,K,q,(G,ee,oe)=>G?$(G):N({bytesWritten:ee,buffer:oe}))})}get appendFile(){return(0,r.promisify)(E.appendFile)}get fdatasync(){return(0,r.promisify)(E.fdatasync)}get truncate(){return(0,r.promisify)(E.truncate)}get rename(){return(0,r.promisify)(E.rename)}get copyFile(){return(0,r.promisify)(E.copyFile)}get open(){return(0,r.promisify)(E.open)}get close(){return(0,r.promisify)(E.close)}get symlink(){return(0,r.promisify)(E.symlink)}get readlink(){return(0,r.promisify)(E.readlink)}get chmod(){return(0,r.promisify)(E.chmod)}get mkdir(){return(0,r.promisify)(E.mkdir)}get unlink(){return(0,r.promisify)(E.unlink)}get rmdir(){return(0,r.promisify)(E.rmdir)}get realpath(){return(0,r.promisify)(E.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return C}get writeFile(){return n}get rm(){return f}get move(){return M}get copy(){return T}}}),define(te[103],ie([0,1,41,9,3,27,24]),function(j,e,E,L,r,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(w){if(r.isLinux)return w;const f=(0,L.dirname)(w);if(w===f)return w;const S=((0,L.basename)(w)||w).toLowerCase();try{const s=(0,D.readdirSync)(f).filter(g=>g.toLowerCase()===S);if(s.length===1){const g=k(f);if(g)return(0,L.join)(g,s[0])}else if(s.length>1){const g=s.indexOf(S);if(g>=0){const c=k(f);if(c)return(0,L.join)(c,s[g])}}}catch{}return null}e.realcaseSync=k;async function u(w){if(r.isLinux)return w;const f=(0,L.dirname)(w);if(w===f)return w;const S=((0,L.basename)(w)||w).toLowerCase();try{const s=(await D.Promises.readdir(f)).filter(g=>g.toLowerCase()===S);if(s.length===1){const g=await u(f);if(g)return(0,L.join)(g,s[0])}else if(s.length>1){const g=s.indexOf(S);if(g>=0){const c=await u(f);if(c)return(0,L.join)(c,s[g])}}}catch{}return null}e.realcase=u;async function l(w){try{return await D.Promises.realpath(w)}catch{const S=m(w);return await D.Promises.access(S,E.constants.R_OK),S}}e.realpath=l;function p(w){try{return E.realpathSync(w)}catch{const S=m(w);return E.accessSync(S,E.constants.R_OK),S}}e.realpathSync=p;function m(w){return(0,A.rtrim)((0,L.normalize)(w),L.sep)}}),define(te[152],ie([0,1,26,9,24]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,D=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var u;(function(b){b[b.x64=0]="x64",b[b.x86=1]="x86",b[b.ARM=2]="ARM"})(u||(u={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class m{constructor(C,t,a){this.exePath=C,this.displayName=t,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await r.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:b=!1}={}){return b?l===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:b=!1,findPreview:C=!1}={}){const t=w({useAlternateBitness:b});if(!t)return null;const a=L.join(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const h of await r.Promises.readdir(a)){let I=-1;if(C){const M=h.indexOf("-");if(M<0)continue;const T=h.substring(0,M);if(!A.test(T)||h.substring(M+1)!=="preview")continue;I=parseInt(T,10)}else{if(!A.test(h))continue;I=parseInt(h,10)}if(I<=i)continue;const R=L.join(a,h,"pwsh.exe");await r.SymlinkSupport.existsFile(R)&&(n=R,i=I)}if(!n)return null;const o=t.includes("x86")?" (x86)":"",d=C?" Preview":"";return new m(n,`PowerShell${d}${o}`,!0)}async function S({findPreview:b}={}){if(!process.env.LOCALAPPDATA)return null;const C=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(C))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=b?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await r.Promises.readdir(C))if(t.test(i)){const n=L.join(C,i,"pwsh.exe");return new m(n,a)}return null}function v(){const b=L.join(E.homedir(),".dotnet","tools","pwsh.exe");return new m(b,".NET Core PowerShell Global Tool")}function s(){const b=L.join(process.env.windir,l===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(b,"Windows PowerShell",!0)}async function*g(){let b=await f();b&&(yield b),b=await f({useAlternateBitness:!0}),b&&(yield b),b=await S(),b&&(yield b),b=v(),b&&(yield b),b=await f({findPreview:!0}),b&&(yield b),b=await S({findPreview:!0}),b&&(yield b),b=await f({useAlternateBitness:!0,findPreview:!0}),b&&(yield b),b=s(),b&&(yield b)}async function*c(){for await(const b of g())await b.exists()&&(yield b)}e.enumeratePowerShellInstallations=c;async function y(){for await(const b of c())return b;return null}e.getFirstAvailablePowerShellInstallation=y}),define(te[86],ie([0,1,9,3,36,71,11,24]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(m=r.env){return m.comspec||"cmd.exe"}e.getWindowsShell=u;function l(m){let w=[],f=!1;const S=function(v){if(f){w.push(v);return}(!m.send(v,g=>{if(g&&console.error(g),f=!1,w.length>0){const c=w.slice(0);w=[],c.forEach(y=>S(y))}})||L.isWindows)&&(f=!0)};return{send:S}}e.createQueuedSender=l;var p;(function(m){async function w(f,S,v){if(E.isAbsolute(f))return f;if(S===void 0&&(S=r.cwd()),E.dirname(f)!=="."||(v===void 0&&D.isString(r.env.PATH)&&(v=r.env.PATH.split(E.delimiter)),v===void 0||v.length===0))return E.join(S,f);async function g(c){if(await k.Promises.exists(c)){let y;try{y=await k.Promises.stat(c)}catch(b){b.message.startsWith("EACCES")&&(y=await k.Promises.lstat(c))}return y?!y.isDirectory():!1}return!1}for(const c of v){let y;if(E.isAbsolute(c)?y=E.join(c,f):y=E.join(S,c,f),await g(y))return y;let b=y+".com";if(await g(b)||(b=y+".exe",await g(b)))return b}return E.join(S,f)}m.findExecutable=w})(p||(e.win32=p={}))}),define(te[104],ie([0,1,50,14]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function r(D){return new Promise((k,u)=>{let l;const p=new Map;function m(f,S,v,s,g){const c=p.get(S);if(f===D||c){const y={name:w(v),cmd:v,pid:f,ppid:S,load:s,mem:g};p.set(f,y),f===D&&(l=y),c&&(c.children||(c.children=[]),c.children.push(y),c.children.length>1&&(c.children=c.children.sort((b,C)=>b.pid-C.pid)))}}function w(f){const S=/--utility-sub-type=network/i,v=/--ms-enable-electron-run-as-node/i,s=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,c=/conhost\.exe/i,y=/--type=([a-zA-Z-]+)/;if(s.exec(f))return"electron-crash-reporter";if(g.exec(f))return"winpty-process";if(c.exec(f))return"console-window-host (Windows internal process)";let b=y.exec(f);if(b&&b.length===2)return b[1]==="renderer"?"window":b[1]==="utility"?S.exec(f)?"utility-network-service":"utility-process":b[1]==="extensionHost"?"extension-host":b[1];const C=/[a-zA-Z-]+\.js/g;let t="";do b=C.exec(f),b&&(t+=b+" ");while(b);return t&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${t})`:v.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=S=>S.indexOf("\\\\?\\")===0||S.indexOf("\\??\\")===0?S.substr(4):S.indexOf('"\\\\?\\')===0||S.indexOf('"\\??\\')===0?'"'+S.substr(5):S;new Promise((S,v)=>{j(["@vscode/windows-process-tree"],S,v)}).then(S=>{S.getProcessList(D,v=>{if(!v){u(new Error(`Root process ${D} not found`));return}S.getProcessCpuUsage(v,s=>{const g=new Map;s.forEach(c=>{const y=f(c.commandLine||"");g.set(c.pid,{name:w(y),cmd:y,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),l=g.get(D),l?(g.forEach(c=>{const y=g.get(c.ppid);y&&(y.children||(y.children=[]),y.children.push(c))}),g.forEach(c=>{c.children&&(c.children=c.children.sort((y,b)=>y.pid-b.pid))}),k(l)):u(new Error(`Root process ${D} not found`))})},S.ProcessDataFlag.CommandLine|S.ProcessDataFlag.Memory)})}else{let f=function(){let S=[l];const v=[];for(;S.length;){const g=S.shift();g&&(v.push(g.pid),g.children&&(S=S.concat(g.children)))}let s=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);s+=" "+v.join(" "),(0,E.exec)(s,{},(g,c,y)=>{if(g||y)u(g||new Error(y.toString()));else{const b=c.toString().split(`
`);for(let C=0;C<v.length;C++){const t=p.get(v[C]);t.load=parseFloat(b[C])}if(!l){u(new Error(`Root process ${D} not found`));return}k(l)}})};(0,E.exec)("which ps",{},(S,v,s)=>{if(S||s)if(process.platform!=="linux")u(S||new Error(s.toString()));else{const g=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(g,{},(c,y,b)=>{c||b?u(c||new Error(b.toString())):(A(y,m),f())})}else{const g=v.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${g} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,b,C)=>{y||C&&!C.includes("screen size is bogus")?u(y||new Error(C.toString())):(A(b,m),process.platform==="linux"?f():l?k(l):u(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=r;function A(D,k){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=D.toString().split(`
`);for(const p of l){const m=u.exec(p.trim());m&&m.length===6&&k(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}}),define(te[153],ie([0,1,26,3,152,86]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(m,w){return m===1?L.isWindows?p():A.getWindowsShell(w):u(m,w)}e.getSystemShell=D;let k=null;function u(m,w){if(L.isLinux&&m===2||L.isMacintosh&&m===3)return"/bin/bash";if(!k){let f;if(L.isWindows)f="/bin/bash";else{if(f=w.SHELL,!f)try{f=(0,E.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}k=f}return k}let l=null;async function p(){return l||(l=(await(0,r.getFirstAvailablePowerShellInstallation)()).exePath),l}}),define(te[87],ie([0,1,3]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUNCHostAllowlist=e.addUNCHostToAllowlist=e.getUNCHostAllowlist=e.setUNCHostAllowlist=void 0;function L(){return process.uncHostAllowlist}function r(u){if(!E.isWindows)return;const l=L();if(l)for(const p of u)l.add(p)}e.setUNCHostAllowlist=r;function A(){const u=L();return u?Array.from(u):[]}e.getUNCHostAllowlist=A;function D(u){if(!E.isWindows)return;const l=L();l&&l.add(u)}e.addUNCHostToAllowlist=D;function k(u){const l=new Set;if(Array.isArray(u))for(const p of u)typeof p=="string"&&l.add(p);return Array.from(l)}e.toUNCHostAllowlist=k});var ye=this&&this.__decorate||function(j,e,E,L){var r=arguments.length,A=r<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,E):L,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(j,e,E,L);else for(var k=j.length-1;k>=0;k--)(D=j[k])&&(A=(r<3?D(A):r>3?D(e,E,A):D(e,E))||A);return r>3&&A&&Object.defineProperty(e,E,A),A};define(te[45],ie([0,1,23,7,17,22,55,13,4,2,84,27,11]),function(j,e,E,L,r,A,D,k,u,l,p,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(f||(f={}));function S(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(v||(v={}));function s(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(g||(g={}));function c(N){let $=0;for(let G=0;;G+=7){const ee=N.read(1);if($|=(ee.buffer[0]&127)<<G,!(ee.buffer[0]&128))return $}}const y=i(0);function b(N,$){if($===0){N.write(y);return}let G=0;for(let oe=$;oe!==0;oe=oe>>>7)G++;const ee=r.VSBuffer.alloc(G);for(let oe=0;$!==0;oe++)ee.buffer[oe]=$&127,$=$>>>7,$>0&&(ee.buffer[oe]|=128);N.write(ee)}class C{constructor($){this.buffer=$,this.pos=0}read($){const G=this.buffer.slice(this.pos,this.pos+$);return this.pos+=G.byteLength,G}}e.BufferReader=C;class t{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}e.BufferWriter=t;var a;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object",N[N.Int=6]="Int"})(a||(a={}));function i(N){const $=r.VSBuffer.alloc(1);return $.writeUInt8(N,0),$}const n={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},o=typeof Buffer<"u";function d(N,$){if(typeof $>"u")N.write(n.Undefined);else if(typeof $=="string"){const G=r.VSBuffer.fromString($);N.write(n.String),b(N,G.byteLength),N.write(G)}else if(o&&Buffer.isBuffer($)){const G=r.VSBuffer.wrap($);N.write(n.Buffer),b(N,G.byteLength),N.write(G)}else if($ instanceof r.VSBuffer)N.write(n.VSBuffer),b(N,$.byteLength),N.write($);else if(Array.isArray($)){N.write(n.Array),b(N,$.length);for(const G of $)d(N,G)}else if(typeof $=="number"&&($|0)===$)N.write(n.Uint),b(N,$);else{const G=r.VSBuffer.fromString(JSON.stringify($));N.write(n.Object),b(N,G.byteLength),N.write(G)}}e.serialize=d;function h(N){switch(N.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return N.read(c(N)).toString();case a.Buffer:return N.read(c(N)).buffer;case a.VSBuffer:return N.read(c(N));case a.Array:{const G=c(N),ee=[];for(let oe=0;oe<G;oe++)ee.push(h(N));return ee}case a.Object:return JSON.parse(N.read(c(N)).toString());case a.Int:return c(N)}}e.deserialize=h;class I{constructor($,G,ee=null,oe=1e3){this.protocol=$,this.ctx=G,this.logger=ee,this.timeoutDelay=oe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel($,G){this.channels.set($,G),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const G=this.send([$.type]);this.logger?.logOutgoing(G,0,1,s($.type));return}case 201:case 202:case 204:case 203:{const G=this.send([$.type,$.id],$.data);this.logger?.logOutgoing(G,$.id,1,s($.type),$.data);return}}}send($,G=void 0){const ee=new t;return d(ee,$),d(ee,G),this.sendBuffer(ee.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onRawMessage($){const G=new C($),ee=h(G),oe=h(G),le=ee[0];switch(le){case 100:return this.logger?.logIncoming($.byteLength,ee[1],1,`${S(le)}: ${ee[2]}.${ee[3]}`,oe),this.onPromise({type:le,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 102:return this.logger?.logIncoming($.byteLength,ee[1],1,`${S(le)}: ${ee[2]}.${ee[3]}`,oe),this.onEventListen({type:le,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 101:return this.logger?.logIncoming($.byteLength,ee[1],1,`${S(le)}`),this.disposeActiveRequest({type:le,id:ee[1]});case 103:return this.logger?.logIncoming($.byteLength,ee[1],1,`${S(le)}`),this.disposeActiveRequest({type:le,id:ee[1]})}}onPromise($){const G=this.channels.get($.channelName);if(!G){this.collectPendingRequest($);return}const ee=new A.CancellationTokenSource;let oe;try{oe=G.call(this.ctx,$.name,$.arg,ee.token)}catch(_){oe=Promise.reject(_)}const le=$.id;oe.then(_=>{this.sendResponse({id:le,data:_,type:201}),this.activeRequests.delete($.id)},_=>{_ instanceof Error?this.sendResponse({id:le,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:le,data:_,type:203}),this.activeRequests.delete($.id)});const Y=(0,l.toDisposable)(()=>ee.cancel());this.activeRequests.set($.id,Y)}onEventListen($){const G=this.channels.get($.channelName);if(!G){this.collectPendingRequest($);return}const ee=$.id,le=G.listen(this.ctx,$.name,$.arg)(Y=>this.sendResponse({id:ee,data:Y,type:204}));this.activeRequests.set($.id,le)}disposeActiveRequest($){const G=this.activeRequests.get($.id);G&&(G.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let G=this.pendingRequests.get($.channelName);G||(G=[],this.pendingRequests.set($.channelName,G));const ee=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:$,timeoutTimer:ee})}flushPendingRequests($){const G=this.pendingRequests.get($);if(G){for(const ee of G)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.onPromise(ee.request);break;case 102:this.onEventListen(ee.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=I;var R;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class M{constructor($,G=null){this.protocol=$,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=G}getChannel($){const G=this;return{call(ee,oe,le){return G.isDisposed?Promise.reject(new k.CancellationError):G.requestPromise($,ee,oe,le)},listen(ee,oe){return G.isDisposed?u.Event.None:G.requestEvent($,ee,oe)}}}requestPromise($,G,ee,oe=A.CancellationToken.None){const le=this.lastRequestId++,_={id:le,type:100,channelName:$,name:G,arg:ee};if(oe.isCancellationRequested)return Promise.reject(new k.CancellationError);let P;return new Promise((U,B)=>{if(oe.isCancellationRequested)return B(new k.CancellationError);const F=()=>{const ae=Se=>{switch(Se.type){case 201:this.handlers.delete(le),U(Se.data);break;case 202:{this.handlers.delete(le);const De=new Error(Se.data.message);De.stack=Array.isArray(Se.data.stack)?Se.data.stack.join(`
`):Se.data.stack,De.name=Se.data.name,B(De);break}case 203:this.handlers.delete(le),B(Se.data);break}};this.handlers.set(le,ae),this.sendRequest(_)};let x=null;this.state===g.Idle?F():(x=(0,L.createCancelablePromise)(ae=>this.whenInitialized()),x.then(()=>{x=null,F()}));const V=()=>{x?(x.cancel(),x=null):this.sendRequest({id:le,type:101}),B(new k.CancellationError)},se=oe.onCancellationRequested(V);P=(0,l.combinedDisposable)((0,l.toDisposable)(V),se),this.activeRequests.add(P)}).finally(()=>{this.activeRequests.delete(P)})}requestEvent($,G,ee){const oe=this.lastRequestId++,Y={id:oe,type:102,channelName:$,name:G,arg:ee};let _=null;const P=new u.Emitter({onWillAddFirstListener:()=>{_=(0,L.createCancelablePromise)(U=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(P),this.sendRequest(Y)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(P),this.sendRequest({id:oe,type:103}))}}),O=U=>P.fire(U.data);return this.handlers.set(oe,O),P.event}sendRequest($){switch($.type){case 100:case 102:{const G=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger?.logOutgoing(G,$.id,0,`${S($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const G=this.send([$.type,$.id]);this.logger?.logOutgoing(G,$.id,0,S($.type));return}}}send($,G=void 0){const ee=new t;return d(ee,$),d(ee,G),this.sendBuffer(ee.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onBuffer($){const G=new C($),ee=h(G),oe=h(G),le=ee[0];switch(le){case 200:return this.logger?.logIncoming($.byteLength,0,0,s(le)),this.onResponse({type:ee[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming($.byteLength,ee[1],0,s(le),oe),this.onResponse({type:ee[0],id:ee[1],data:oe})}}onResponse($){if($.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get($.id)?.($)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=M,ye([D.memoize],M.prototype,"onDidInitializePromise",null);class T{get connections(){const $=[];return this._connections.forEach(G=>$.push(G)),$}constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:G,onDidClientDisconnect:ee})=>{u.Event.once(G.onMessage)(le=>{const Y=new C(le),_=h(Y),P=new I(G,_),O=new M(G);this.channels.forEach((B,F)=>P.registerChannel(F,B));const U={channelServer:P,channelClient:O,ctx:_};this._connections.add(U),this._onDidAddConnection.fire(U),ee(()=>{P.dispose(),O.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}getChannel($,G){const ee=this;return{call(oe,le,Y){let _;if((0,w.isFunction)(G)){const O=(0,E.getRandomElement)(ee.connections.filter(G));_=O?Promise.resolve(O):u.Event.toPromise(u.Event.filter(ee.onDidAddConnection,G))}else _=G.routeCall(ee,oe,le);const P=_.then(O=>O.channelClient.getChannel($));return z(P).call(oe,le,Y)},listen(oe,le){if((0,w.isFunction)(G))return ee.getMulticastEvent($,G,oe,le);const Y=G.routeEvent(ee,oe,le).then(_=>_.channelClient.getChannel($));return z(Y).listen(oe,le)}}}getMulticastEvent($,G,ee,oe){const le=this;let Y=new l.DisposableStore;const _=new u.Emitter({onWillAddFirstListener:()=>{Y=new l.DisposableStore;const P=new u.EventMultiplexer,O=new Map,U=F=>{const V=F.channelClient.getChannel($).listen(ee,oe),se=P.add(V);O.set(F,se)},B=F=>{const x=O.get(F);x&&(x.dispose(),O.delete(F))};le.connections.filter(G).forEach(U),u.Event.filter(le.onDidAddConnection,G)(U,void 0,Y),le.onDidRemoveConnection(B,void 0,Y),P.event(_.fire,_,Y),Y.add(P)},onDidRemoveLastListener:()=>{Y.dispose()}});return _.event}registerChannel($,G){this.channels.set($,G),this._connections.forEach(ee=>{ee.channelServer.registerChannel($,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class W{constructor($,G,ee=null){const oe=new t;d(oe,G),$.send(oe.buffer),this.channelClient=new M($,ee),this.channelServer=new I($,G,ee)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,G){this.channelServer.registerChannel($,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function z(N){return{call($,G,ee){return N.then(oe=>oe.call($,G,ee))},listen($,G){const ee=new u.Relay;return N.then(oe=>ee.input=oe.listen($,G)),ee.event}}}e.getDelayedChannel=z;function H(N){let $=!1;return{call(G,ee,oe){return $?N.call(G,ee,oe):(0,L.timeout)(0).then(()=>$=!0).then(()=>N.call(G,ee,oe))},listen(G,ee){if($)return N.listen(G,ee);const oe=new u.Relay;return(0,L.timeout)(0).then(()=>$=!0).then(()=>oe.input=N.listen(G,ee)),oe.event}}}e.getNextTickChannel=H;class J{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const G of $.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await u.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=J;var ne;(function(N){function $(le,Y){const _=le,P=Y&&Y.disableMarshalling,O=new Map;for(const U in _)ee(U)&&O.set(U,u.Event.buffer(_[U],!0));return new class{listen(U,B,F){const x=O.get(B);if(x)return x;if(oe(B)){const V=_[B];if(typeof V=="function")return V.call(_,F)}throw new Error(`Event not found: ${B}`)}call(U,B,F){const x=_[B];if(typeof x=="function"){if(!P&&Array.isArray(F))for(let V=0;V<F.length;V++)F[V]=(0,p.revive)(F[V]);return x.apply(_,F)}throw new Error(`Method not found: ${B}`)}}}N.fromService=$;function G(le,Y){const _=Y&&Y.disableMarshalling;return new Proxy({},{get(P,O){if(typeof O=="string")return Y?.properties?.has(O)?Y.properties.get(O):oe(O)?function(U){return le.listen(O,U)}:ee(O)?le.listen(O):async function(...U){let B;Y&&!(0,w.isUndefinedOrNull)(Y.context)?B=[Y.context,...U]:B=U;const F=await le.call(O,B);return _?F:(0,p.revive)(F)};throw new Error(`Property not found: ${String(O)}`)}})}N.toService=G;function ee(le){return le[0]==="o"&&le[1]==="n"&&m.isUpperAsciiLetter(le.charCodeAt(2))}function oe(le){return/^onDynamic/.test(le)&&m.isUpperAsciiLetter(le.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const $=N.toString();if($!=="[object Object]")return $}return N}function ce(N){return Array.isArray(N)?N.map(ue):ue(N)}function K(N,$,G,ee,oe,le,Y){Y=ce(Y);const _=re[oe],P=_[ee%_.length];let O=[`%c[${N}]%c[${String($).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(le)?(O=O.concat(Y),O.push(")")):O.push(Y),console.log.apply(console,O)}class q{constructor($,G){this._outgoingPrefix=$,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,G,ee,oe,le){this._totalOutgoing+=$,K(this._outgoingPrefix,this._totalOutgoing,$,G,ee,oe,le)}logIncoming($,G,ee,oe,le){this._totalIncoming+=$,K(this._incomingPrefix,this._totalIncoming,$,G,ee,oe,le)}}e.IPCLogger=q}),define(te[154],ie([0,1,17,4,45]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(u){this.port=u,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",l=>E.VSBuffer.wrap(l.data)),u.start()}send(u){this.port.postMessage(u.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class D extends r.IPCClient{constructor(u,l){const p=new A(u);super(p,l),this.protocol=p}dispose(){this.protocol.disconnect()}}e.Client=D}),define(te[105],ie([0,1,7,17,4,2,45]),function(j,e,E,L,r,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(M){M.Created="created",M.Read="read",M.Write="write",M.Open="open",M.Error="error",M.Close="close",M.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",M.NodeEndReceived="nodeEndReceived",M.NodeEndSent="nodeEndSent",M.NodeDrainBegin="nodeDrainBegin",M.NodeDrainEnd="nodeDrainEnd",M.zlibInflateError="zlibInflateError",M.zlibInflateData="zlibInflateData",M.zlibInflateInitialWrite="zlibInflateInitialWrite",M.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",M.zlibInflateWrite="zlibInflateWrite",M.zlibInflateFlushFired="zlibInflateFlushFired",M.zlibDeflateError="zlibDeflateError",M.zlibDeflateData="zlibDeflateData",M.zlibDeflateWrite="zlibDeflateWrite",M.zlibDeflateFlushFired="zlibDeflateFlushFired",M.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",M.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",M.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",M.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",M.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",M.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",M.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",M.ProtocolHeaderRead="protocolHeaderRead",M.ProtocolMessageRead="protocolMessageRead",M.ProtocolHeaderWrite="protocolHeaderWrite",M.ProtocolMessageWrite="protocolMessageWrite",M.ProtocolWrite="protocolWrite"})(k||(e.SocketDiagnosticsEventType=k={}));var u;(function(M){M.enableDiagnostics=!1,M.records=[];const T=new WeakMap;let W=0;function z(J,ne){if(!T.has(J)){const re=String(++W);T.set(J,re)}return T.get(J)}function H(J,ne,re,ue){if(!M.enableDiagnostics)return;const ce=z(J,ne);if(ue instanceof L.VSBuffer||ue instanceof Uint8Array||ue instanceof ArrayBuffer||ArrayBuffer.isView(ue)){const K=L.VSBuffer.alloc(ue.byteLength);K.set(ue),M.records.push({timestamp:Date.now(),id:ce,label:ne,type:re,buff:K})}else M.records.push({timestamp:Date.now(),id:ce,label:ne,type:re,data:ue})}M.traceSocketEvent=H})(u||(e.SocketDiagnostics=u={}));var l;(function(M){M[M.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",M[M.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(l||(e.SocketCloseEventType=l={}));let p=null;function m(){return p||(p=L.VSBuffer.alloc(0)),p}class w{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(T){this._chunks.push(T),this._totalLength+=T.byteLength}read(T){return this._read(T,!0)}peek(T){return this._read(T,!1)}_read(T,W){if(T===0)return m();if(T>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===T){const ne=this._chunks[0];return W&&(this._chunks.shift(),this._totalLength-=T),ne}if(this._chunks[0].byteLength>T){const ne=this._chunks[0].slice(0,T);return W&&(this._chunks[0]=this._chunks[0].slice(T),this._totalLength-=T),ne}const z=L.VSBuffer.alloc(T);let H=0,J=0;for(;T>0;){const ne=this._chunks[J];if(ne.byteLength>T){const re=ne.slice(0,T);z.set(re,H),H+=T,W&&(this._chunks[J]=ne.slice(T),this._totalLength-=T),T-=T}else z.set(ne,H),H+=ne.byteLength,W?(this._chunks.shift(),this._totalLength-=ne.byteLength):J++,T-=ne.byteLength}return z}}e.ChunkStream=w;var f;(function(M){M[M.None=0]="None",M[M.Regular=1]="Regular",M[M.Control=2]="Control",M[M.Ack=3]="Ack",M[M.Disconnect=5]="Disconnect",M[M.ReplayRequest=6]="ReplayRequest",M[M.Pause=7]="Pause",M[M.Resume=8]="Resume",M[M.KeepAlive=9]="KeepAlive",M[M.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",M[M.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function S(M){switch(M){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var v;(function(M){M[M.HeaderLength=13]="HeaderLength",M[M.AcknowledgeTime=2e3]="AcknowledgeTime",M[M.TimeoutTime=2e4]="TimeoutTime",M[M.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",M[M.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",M[M.KeepAliveSendTime=5e3]="KeepAliveSendTime",M[M.LatencySampleTime=6e4]="LatencySampleTime",M[M.LatencySampleCount=5]="LatencySampleCount",M[M.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",M[M.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(v||(e.ProtocolConstants=v={}));class s{constructor(T,W,z,H){this.type=T,this.id=W,this.ack=z,this.data=H,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends A.Disposable{constructor(T){super(),this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=T,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(W=>this.acceptChunk(W))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(T);this._incomingData.byteLength>=this._state.readLen;){const W=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=W.readUInt32BE(9),this._state.messageType=W.readUInt8(0),this._state.id=W.readUInt32BE(1),this._state.ack=W.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const z=this._state.messageType,H=this._state.id,J=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",W),this._onMessage.fire(new s(z,H,J,W)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class c{constructor(T){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=T,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(T){if(this._isDisposed)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const W=L.VSBuffer.alloc(13);W.writeUInt8(T.type,0),W.writeUInt32BE(T.id,1),W.writeUInt32BE(T.ack,5),W.writeUInt32BE(T.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",T.data),this._writeSoon(W,T.data)}_bufferAdd(T,W){const z=this._totalLength===0;return this._data.push(T,W),this._totalLength+=T.byteLength+W.byteLength,z}_bufferTake(){const T=L.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,T}_writeSoon(T,W){this._bufferAdd(T,W)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const T=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this._socket.write(T)}}class y extends A.Disposable{constructor(T){super(),this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=T,this._socketWriter=this._register(new c(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(W=>{W.type===1&&this._onMessage.fire(W.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(T){this._socketWriter.write(new s(1,0,0,T))}}e.Protocol=y;class b extends D.IPCClient{static fromSocket(T,W){return new b(new y(T),W)}get onDidDispose(){return this.protocol.onDidDispose}constructor(T,W,z=null){super(T,W,z),this.protocol=T}dispose(){super.dispose();const T=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),T.end()}}e.Client=b;class C{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(T){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(T):this._emitter.fire(T):this._bufferedMessages.push(T)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=C;class t{constructor(T){this.data=T,this.next=null}}class a{constructor(){this._first=null,this._last=null}length(){let T=0,W=this._first;for(;W;)W=W.next,T++;return T}peek(){return this._first?this._first.data:null}toArray(){const T=[];let W=0,z=this._first;for(;z;)T[W++]=z.data,z=z.next;return T}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(T){const W=new t(T);if(!this._first){this._first=W,this._last=W;return}this._last.next=W,this._last=W}}class i{static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}constructor(){this.lastRuns=[];const T=Date.now();for(let W=0;W<i._HISTORY_LENGTH;W++)this.lastRuns[W]=T-1e3*W;setInterval(()=>{for(let W=i._HISTORY_LENGTH;W>=1;W--)this.lastRuns[W]=this.lastRuns[W-1];this.lastRuns[0]=Date.now()},1e3)}load(){const T=Date.now(),W=(1+i._HISTORY_LENGTH)*1e3;let z=0;for(let H=0;H<i._HISTORY_LENGTH;H++)T-this.lastRuns[H]<=W&&z++;return 1-z/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;var n;(function(M){M[M.Good=0]="Good",M[M.Poor=1]="Poor"})(n||(e.ConnectionHealth=n={}));function o(M){switch(M){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class d{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=d;class h{constructor(T,W){this.roundTripTime=T,this.recentHighRoundTripCount=W}}e.HighRoundTripTimeEvent=h;class I{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(T){this._onControlMessage=new C,this.onControlMessage=this._onControlMessage.event,this._onMessage=new C,this.onMessage=this._onMessage.event,this._onDidDispose=new C,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new C,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new C,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new C,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new C,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=T.loadEstimator??i.getInstance(),this._measureRoundTripTime=T.measureRoundTripTime??!1,this._shouldSendKeepAlive=T.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new A.DisposableStore,this._socket=T.socket,this._socketWriter=this._socketDisposables.add(new c(this._socket)),this._socketReader=this._socketDisposables.add(new g(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(W=>this._receiveMessage(W))),this._socketDisposables.add(this._socket.onClose(W=>this._onSocketClose.fire(W))),this._socketLatencyMonitor=this._socketDisposables.add(new R),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(W=>this._sendLatencyMeasurementRequest(W))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(W=>this._onHighRoundTripTime.fire(W))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(W=>this._onDidChangeConnectionHealth.fire(W))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),T.initialChunk&&this._socketReader.acceptChunk(T.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const T=new s(5,0,0,m());this._socketWriter.write(T),this._socketWriter.flush()}sendPause(){const T=new s(7,0,0,m());this._socketWriter.write(T)}sendResume(){const T=new s(8,0,0,m());this._socketWriter.write(T)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(T,W){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new A.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=T,this._socketWriter=this._socketDisposables.add(new c(this._socket)),this._socketReader=this._socketDisposables.add(new g(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(z=>this._receiveMessage(z))),this._socketDisposables.add(this._socket.onClose(z=>this._onSocketClose.fire(z))),this._socketLatencyMonitor=this._socketDisposables.add(new R),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(z=>this._sendLatencyMeasurementRequest(z))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(z=>this._onHighRoundTripTime.fire(z))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(z=>this._onDidChangeConnectionHealth.fire(z))),this._socketReader.acceptChunk(W)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const T=new s(3,0,this._incomingAckId,m());this._socketWriter.write(T);const W=this._outgoingUnackMsg.toArray();for(let z=0,H=W.length;z<H;z++)this._socketWriter.write(W[z]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(T){if(T.ack>this._outgoingAckId){this._outgoingAckId=T.ack;do{const W=this._outgoingUnackMsg.peek();if(W&&W.id<=T.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this._incomingMsgId)if(T.id!==this._incomingMsgId+1){const W=Date.now();W-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=W,this._socketWriter.write(new s(6,0,0,m())))}else this._incomingMsgId=T.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(T.data);break}case 2:{this._onControlMessage.fire(T.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const W=this._outgoingUnackMsg.toArray();for(let z=0,H=W.length;z<H;z++)this._socketWriter.write(W[z]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(T.data);break}case 11:{this._socketLatencyMonitor.handleResponse(T.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(T){const W=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const z=new s(1,W,this._incomingAckId,T);this._outgoingUnackMsg.push(z),this._isReconnecting||(this._socketWriter.write(z),this._recvAckCheck())}sendControl(T){const W=new s(2,0,0,T);this._socketWriter.write(W)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const T=Date.now()-this._incomingMsgLastTime;if(T>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-T+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const T=this._outgoingUnackMsg.peek(),W=Date.now()-T.writtenTime,z=Date.now()-this._socketReader.lastReadTime,H=Date.now()-this._lastSocketTimeoutTime;if(W>=2e4&&z>=2e4&&H>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:W,timeSinceLastReceivedSomeData:z});return}const J=Math.max(2e4-W,2e4-z,2e4-H,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},J)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const T=new s(3,0,this._incomingAckId,m());this._socketWriter.write(T)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const T=new s(9,0,this._incomingAckId,m());this._socketWriter.write(T)}_sendLatencyMeasurementRequest(T){this._incomingAckId=this._incomingMsgId;const W=new s(10,0,this._incomingAckId,T);this._socketWriter.write(W)}_sendLatencyMeasurementResponse(T){this._incomingAckId=this._incomingMsgId;const W=new s(11,0,this._incomingAckId,T);this._socketWriter.write(W)}}e.PersistentProtocol=I;class R extends A.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new r.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new r.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new r.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new E.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},T=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const T=++this._lastLatencyMeasurementId,W=L.VSBuffer.alloc(4);W.writeUInt32BE(T,0),this._onSendLatencyRequest.fire(W)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const W=T.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||W!==this._lastLatencyMeasurementId)return;const z=Date.now()-this._lastLatencyMeasurementSent,H=this._latencySampleIndex++;this._latencySamples[H%this._latencySamples.length]=z;const J=this._connectionHealth,ne=this._latencySamples.filter(re=>re>=1e3).length;this._connectionHealth=ne>=3?1:0,z>1e3&&this._onHighRoundTripTime.fire(new h(z,ne)),J!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(te[155],ie([0,1,42,17,4,2,45,140]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function u(p,m){const w=r.Event.fromNodeEventEmitter(E.validatedIpcMain,m,(S,v)=>({event:S,message:v})),f=r.Event.filter(w,({event:S})=>S.sender.id===p);return r.Event.map(f,({message:S})=>S&&L.VSBuffer.wrap(S))}class l extends D.IPCServer{static getOnDidClientConnect(){const m=r.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:w})=>w);return r.Event.map(m,w=>{const f=w.id;l.Clients.get(f)?.dispose();const v=new r.Emitter;l.Clients.set(f,(0,A.toDisposable)(()=>v.fire()));const s=u(f,"vscode:message"),g=r.Event.any(r.Event.signal(u(f,"vscode:disconnect")),v.event);return{protocol:new k.Protocol(w,s),onDidClientDisconnect:g}})}constructor(){super(l.getOnDidClientConnect())}}e.Server=l,l.Clients=new Map}),define(te[156],ie([0,1,42,4,31,154]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends A.Client{constructor(l,p){super({addEventListener:(m,w)=>l.addListener(m,w),removeEventListener:(m,w)=>l.removeListener(m,w),postMessage:m=>l.postMessage(m),start:()=>l.start(),close:()=>l.close()},p)}}e.Client=D;async function k(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,r.generateUuid)();u.webContents.send("vscode:createMessageChannel",l);const p=L.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(w,f)=>({nonce:f,port:w.ports[0]})),{port:m}=await L.Event.toPromise(L.Event.once(L.Event.filter(p,w=>w.nonce===l)));return m}e.connect=k}),define(te[157],ie([0,1,50,7,17,22,149,13,4,2,40,86,71,45]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends f.ChannelServer{constructor(g){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",c=>r.VSBuffer.wrap(Buffer.from(c,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=S;class v{constructor(g,c){this.modulePath=g,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new L.Delayer(y),this.child=null,this._client=null}getChannel(g){const c=this;return{call(y,b,C){return c.requestPromise(g,y,b,C)},listen(y,b){return c.requestEvent(g,y,b)}}}requestPromise(g,c,y,b=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(k.canceled());this.disposeDelayer.cancel();const C=this.getCachedChannel(g),t=(0,L.createCancelablePromise)(n=>C.call(c,y,n)),a=b.onCancellationRequested(()=>t.cancel()),i=(0,l.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{a.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(g,c,y){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let b;const C=new u.Emitter({onWillAddFirstListener:()=>{b=this.getCachedChannel(g).listen(c,y)(C.fire,C),this.activeRequests.add(b)},onDidRemoveLastListener:()=>{this.activeRequests.delete(b),b.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return C.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,w.removeDangerousEnvVariables)(c.env),this.child=(0,E.fork)(this.modulePath,g,c);const y=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,D.isRemoteConsoleLog)(o)){(0,D.log)(o,`IPC Library: ${this.options.serverName}`);return}y.fire(r.VSBuffer.wrap(Buffer.from(o,"base64")))});const C=this.options.useQueue?(0,m.createQueuedSender)(this.child):this.child,t=o=>this.child&&this.child.connected&&C.send(o.buffer.toString("base64")),a=y.event,i={send:t,onMessage:a};this._client=new f.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,d)=>{process.removeListener("exit",n),this.activeRequests.forEach(h=>(0,l.dispose)(h)),this.activeRequests.clear(),o!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+d),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:d})})}return this._client}getCachedChannel(g){let c=this.channels.get(g);return c||(c=this.client.getChannel(g),this.channels.set(g,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(te[106],ie([0,1,7,4,2,11]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D||(e.StorageHint=D={}));function k(m){const w=m;return w?.changed instanceof Map||w?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var u;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(u||(e.StorageState=u={}));class l extends r.Disposable{constructor(w,f=Object.create(null)){super(),this.database=w,this.options=f,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=u.None,this.cache=new Map,this.flushDelayer=new E.ThrottledDelayer(l.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(w=>this.onDidChangeItemsExternal(w)))}onDidChangeItemsExternal(w){w.changed?.forEach((f,S)=>this.accept(S,f)),w.deleted?.forEach(f=>this.accept(f,void 0))}accept(w,f){if(this.state===u.Closed)return;let S=!1;(0,A.isUndefinedOrNull)(f)?S=this.cache.delete(w):this.cache.get(w)!==f&&(this.cache.set(w,f),S=!0),S&&this._onDidChangeStorage.fire(w)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===u.None&&(this.state=u.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(w,f){const S=this.cache.get(w);return(0,A.isUndefinedOrNull)(S)?f:S}getBoolean(w,f){const S=this.get(w);return(0,A.isUndefinedOrNull)(S)?f:S==="true"}getNumber(w,f){const S=this.get(w);return(0,A.isUndefinedOrNull)(S)?f:parseInt(S,10)}async set(w,f){if(this.state===u.Closed)return;if((0,A.isUndefinedOrNull)(f))return this.delete(w);const S=String(f);if(this.cache.get(w)!==S)return this.cache.set(w,S),this.pendingInserts.set(w,S),this.pendingDeletes.delete(w),this._onDidChangeStorage.fire(w),this.doFlush()}async delete(w){if(!(this.state===u.Closed||!this.cache.delete(w)))return this.pendingDeletes.has(w)||this.pendingDeletes.add(w),this.pendingInserts.delete(w),this._onDidChangeStorage.fire(w),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=u.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const w={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(w).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(w){if(this.hasPending)return this.doFlush(w)}async doFlush(w){return this.flushDelayer.trigger(()=>this.flushPending(),w)}async whenFlushed(){if(this.hasPending)return new Promise(w=>this.whenFlushedCallbacks.push(w))}isInMemory(){return this.options.hint===D.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=l,l.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(w){w.insert?.forEach((f,S)=>this.items.set(S,f)),w.delete?.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=p}),define(te[158],ie([0,1,7,4,35,9,24]),function(j,e,E,L,r,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return L.Event.None}constructor(p,m=Object.create(null)){this.path=p,this.options=m,this.name=(0,A.basename)(this.path),this.logger=new u(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const p=await this.whenConnected,m=new Map;return(await this.all(p,"SELECT * FROM ItemTable")).forEach(f=>m.set(f.key,f.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${m.size} rows`),m}async updateItems(p){const m=await this.whenConnected;return this.doUpdateItems(m,p)}doUpdateItems(p,m){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${m.insert?(0,r.mapToString)(m.insert):"0"}), delete(${m.delete?(0,r.setToString)(m.delete):"0"})`),this.transaction(p,()=>{const w=m.insert,f=m.delete;if(w&&w.size>0){const S=[];S.push([]);let v=0;w.forEach((s,g)=>{let c=S[v];c.length>k.MAX_HOST_PARAMETERS&&(v++,c=[],S.push(c)),c.push(g,s)}),S.forEach(s=>{this.prepare(p,`INSERT INTO ItemTable VALUES ${new Array(s.length/2).fill("(?,?)").join(",")}`,g=>g.run(s),()=>{const g=[];let c=0;return w.forEach((y,b)=>{g.push(b),c+=y.length}),`Keys: ${g.join(", ")} Length: ${c}`})})}if(f&&f.size){const S=[];S.push([]);let v=0;f.forEach(s=>{let g=S[v];g.length>k.MAX_HOST_PARAMETERS&&(v++,g=[],S.push(g)),g.push(s)}),S.forEach(s=>{this.prepare(p,`DELETE FROM ItemTable WHERE key IN (${new Array(s.length).fill("?").join(",")})`,g=>g.run(s),()=>{const g=[];return f.forEach(c=>{g.push(c)}),`Keys: ${g.join(", ")}`})})}})}async close(p){this.logger.trace(`[storage ${this.name}] close()`);const m=await this.whenConnected;return this.doClose(m,p)}doClose(p,m){return new Promise((w,f)=>{p.db.close(S=>(S&&this.handleSQLiteError(p,`[storage ${this.name}] close(): ${S}`),this.path===k.IN_MEMORY_PATH?w():!p.isErroneous&&!p.isInMemory?this.backup().then(w,v=>(this.logger.error(`[storage ${this.name}] backup(): ${v}`),w())):typeof m=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(v=>{const s=()=>this.doClose(v,void 0);return this.doUpdateItems(v,{insert:m()}).then(()=>s(),g=>(s(),Promise.reject(g)))})).then(w,f):f(S||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const p=this.toBackupPath(this.path);return D.Promises.copy(this.path,p,{preserveSymlinks:!1})}toBackupPath(p){return`${p}.backup`}async checkIntegrity(p){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${p})`);const m=await this.whenConnected,w=await this.get(m,p?"PRAGMA integrity_check":"PRAGMA quick_check"),f=p?w.integrity_check:w.quick_check;return m.isErroneous?`${f} (last error: ${m.lastError})`:m.isInMemory?`${f} (in-memory!)`:f}async connect(p,m=!0){this.logger.trace(`[storage ${this.name}] open(${p}, retryOnBusy: ${m})`);try{return await this.doConnect(p)}catch(w){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&m)return await(0,E.timeout)(k.BUSY_OPEN_TIMEOUT),this.connect(p,!1);try{await D.Promises.unlink(p);try{await D.Promises.rename(this.toBackupPath(p),p)}catch{}return await this.doConnect(p)}catch(f){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${f}`),this.doConnect(k.IN_MEMORY_PATH)}}}handleSQLiteError(p,m){p.isErroneous=!0,p.lastError=m,this.logger.error(m)}doConnect(p){return new Promise((m,w)=>{new Promise((f,S)=>{j(["@vscode/sqlite3"],f,S)}).then(f=>{const S={db:new(this.logger.isTracing?f.verbose().Database:f.Database)(p,v=>v?S.db&&v.code!=="SQLITE_CANTOPEN"?S.db.close(()=>w(v)):w(v):this.exec(S,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>m(S),s=>S.db.close(()=>w(s)))),isInMemory:p===k.IN_MEMORY_PATH};S.db.on("error",v=>this.handleSQLiteError(S,`[storage ${this.name}] Error (event): ${v}`)),this.logger.isTracing&&S.db.on("trace",v=>this.logger.trace(`[storage ${this.name}] Trace (event): ${v}`))},w)})}exec(p,m){return new Promise((w,f)=>{p.db.exec(m,S=>S?(this.handleSQLiteError(p,`[storage ${this.name}] exec(): ${S}`),f(S)):w())})}get(p,m){return new Promise((w,f)=>{p.db.get(m,(S,v)=>S?(this.handleSQLiteError(p,`[storage ${this.name}] get(): ${S}`),f(S)):w(v))})}all(p,m){return new Promise((w,f)=>{p.db.all(m,(S,v)=>S?(this.handleSQLiteError(p,`[storage ${this.name}] all(): ${S}`),f(S)):w(v))})}transaction(p,m){return new Promise((w,f)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),m(),p.db.run("END TRANSACTION",S=>S?(this.handleSQLiteError(p,`[storage ${this.name}] transaction(): ${S}`),f(S)):w())})})}prepare(p,m,w,f){const S=p.db.prepare(m),v=s=>{this.handleSQLiteError(p,`[storage ${this.name}] prepare(): ${s} (${m}). Details: ${f()}`)};S.on("error",v),w(S),S.finalize(s=>{s&&v(s),S.removeListener("error",v)})}}e.SQLiteStorageDatabase=k,k.IN_MEMORY_PATH=":memory:",k.BUSY_OPEN_TIMEOUT=2e3,k.MAX_HOST_PARAMETERS=256;class u{constructor(p){p&&typeof p.logTrace=="function"&&process.env[u.VSCODE_TRACE_STORAGE]&&(this.logTrace=p.logTrace),p&&typeof p.logError=="function"&&(this.logError=p.logError)}get isTracing(){return!!this.logTrace}trace(p){this.logTrace?.(p)}error(p){this.logError?.(p)}}u.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[159],ie([12,10]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(te[160],ie([12,10]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[161],ie([12,10]),function(j,e){return j.create("vs/platform/contextkey/common/contextkey",e)}),define(te[162],ie([12,10]),function(j,e){return j.create("vs/platform/contextkey/common/scanner",e)}),define(te[163],ie([12,10]),function(j,e){return j.create("vs/platform/dialogs/common/dialogs",e)}),define(te[164],ie([12,10]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[165],ie([12,10]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(te[166],ie([12,10]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(te[167],ie([12,10]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[168],ie([12,10]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[169],ie([12,10]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[170],ie([12,10]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[171],ie([12,10]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[172],ie([12,10]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(te[173],ie([12,10]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(te[174],ie([12,10]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(te[175],ie([12,10]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[176],ie([12,10]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[177],ie([12,10]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[178],ie([12,10]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[179],ie([12,10]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[180],ie([12,10]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(te[181],ie([12,10]),function(j,e){return j.create("vs/platform/shell/node/shellEnv",e)}),define(te[182],ie([12,10]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[183],ie([12,10]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(te[184],ie([12,10]),function(j,e){return j.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[185],ie([12,10]),function(j,e){return j.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[186],ie([12,10]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[187],ie([12,10]),function(j,e){return j.create("vs/platform/workspace/common/workspace",e)}),define(te[188],ie([12,10]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[189],ie([12,10]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[190],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(r){return r&&r.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function L(r){return r&&r.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(te[191],ie([0,1,8]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function r(D){let k=[];try{Array.isArray(D.workspaces)&&(k=D.workspaces.map(u=>({workspace:{id:u.id,configPath:E.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=r;function A(D){let k=[];try{Array.isArray(D.folders)&&(k=D.folders.map(u=>({folderUri:E.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=A}),define(te[192],ie([0,1,13,162]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var r;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(r||(e.TokenType=r={}));function A(...l){switch(l.length){case 1:return(0,L.localize)(0,null,l[0]);case 2:return(0,L.localize)(1,null,l[0],l[1]);case 3:return(0,L.localize)(2,null,l[0],l[1],l[2]);default:return}}const D=(0,L.localize)(3,null),k=(0,L.localize)(4,null);class u{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,E.illegalState)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(p){return this._input=p,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const m=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:m})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const m=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:m})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(p){return this._isAtEnd()||this._input.charCodeAt(this._current)!==p?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(p){this._tokens.push({type:p,offset:this._start})}_error(p){const m=this._start,w=this._input.substring(this._start,this._current),f={type:19,offset:this._start,lexeme:w};this._errors.push({offset:m,lexeme:w,additionalInfo:p}),this._tokens.push(f)}_string(){this.stringRe.lastIndex=this._start;const p=this.stringRe.exec(this._input);if(p){this._current=this._start+p[0].length;const m=this._input.substring(this._start,this._current),w=u._keywords.get(m);w?this._addToken(w):this._tokens.push({type:17,lexeme:m,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(D);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let p=this._current,m=!1,w=!1;for(;;){if(p>=this._input.length){this._current=p,this._error(k);return}const S=this._input.charCodeAt(p);if(m)m=!1;else if(S===47&&!w){p++;break}else S===91?w=!0:S===92?m=!0:S===93&&(w=!1);p++}for(;p<this._input.length&&u._regexFlags.has(this._input.charCodeAt(p));)p++;this._current=p;const f=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:f,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=u,u._regexFlags=new Set(["i","g","s","m","y","u"].map(l=>l.charCodeAt(0))),u._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(te[193],ie([0,1,4,2]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class r{constructor(){this._onCloseEmitter=new E.Emitter,this._onReloadEmitter=new E.Emitter,this._onTerminateEmitter=new E.Emitter,this._onAttachEmitter=new E.Emitter}call(k,u,l){switch(u){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(k,u,l){switch(u){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=r,r.ChannelName="extensionhostdebugservice";class A extends L.Disposable{constructor(k){super(),this.channel=k}reload(k){this.channel.call("reload",[k])}get onReload(){return this.channel.listen("reload")}close(k){this.channel.call("close",[k])}get onClose(){return this.channel.listen("close")}attachSession(k,u,l){this.channel.call("attach",[k,u,l])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(k,u){this.channel.call("terminate",[k,u])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(k,u){return this.channel.call("openExtensionDevelopmentHostWindow",[k,u])}}e.ExtensionHostDebugChannelClient=A}),define(te[194],ie([0,1,143,55,14,9,36,18,8]),function(j,e,E,L,r,A,D,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,A.dirname)(r.FileAccess.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",f)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(u.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=D.env.VSCODE_PORTABLE;return f?u.URI.file((0,A.join)(f,"argv.json")):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.resolve)(f):(0,A.normalize)((0,A.join)(r.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?u.URI.file((0,A.resolve)(f)):u.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.resolve)(f);const S=D.env.VSCODE_EXTENSIONS;if(S)return S;const v=D.env.VSCODE_PORTABLE;return v?(0,A.join)(v,"extensions"):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(S=>/^[^:/?#]+?:\/\//.test(S)?u.URI.parse(S):u.URI.file((0,A.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?u.URI.parse(f):u.URI.file((0,A.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const S of this.args.log||[]){const v=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(S);v&&v[1]&&v[2]&&f.push([v[1],v[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=D.env.VSCODE_PORTABLE;return f?u.URI.file((0,A.join)(f,"policy.json")):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this._args}constructor(f,S,v){this._args=f,this.paths=S,this.productService=v,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,ye([L.memoize],l.prototype,"appRoot",null),ye([L.memoize],l.prototype,"userHome",null),ye([L.memoize],l.prototype,"userDataPath",null),ye([L.memoize],l.prototype,"appSettingsHome",null),ye([L.memoize],l.prototype,"tmpDir",null),ye([L.memoize],l.prototype,"cacheHome",null),ye([L.memoize],l.prototype,"stateResource",null),ye([L.memoize],l.prototype,"userRoamingDataHome",null),ye([L.memoize],l.prototype,"userDataSyncHome",null),ye([L.memoize],l.prototype,"sync",null),ye([L.memoize],l.prototype,"machineSettingsResource",null),ye([L.memoize],l.prototype,"workspaceStorageHome",null),ye([L.memoize],l.prototype,"localHistoryHome",null),ye([L.memoize],l.prototype,"keyboardLayoutResource",null),ye([L.memoize],l.prototype,"argvResource",null),ye([L.memoize],l.prototype,"isExtensionDevelopment",null),ye([L.memoize],l.prototype,"untitledWorkspacesHome",null),ye([L.memoize],l.prototype,"builtinExtensionsPath",null),ye([L.memoize],l.prototype,"extensionsPath",null),ye([L.memoize],l.prototype,"extensionDevelopmentLocationURI",null),ye([L.memoize],l.prototype,"extensionDevelopmentKind",null),ye([L.memoize],l.prototype,"extensionTestsLocationURI",null),ye([L.memoize],l.prototype,"debugExtensionHost",null),ye([L.memoize],l.prototype,"logLevel",null),ye([L.memoize],l.prototype,"extensionLogLevel",null),ye([L.memoize],l.prototype,"serviceMachineIdResource",null),ye([L.memoize],l.prototype,"disableTelemetry",null),ye([L.memoize],l.prototype,"disableWorkspaceTrust",null),ye([L.memoize],l.prototype,"policyFile",null);function p(w,f){return m(w["inspect-extensions"],w["inspect-brk-extensions"],5870,f,w.debugId,w.extensionEnvironment)}e.parseExtensionHostDebugPort=p;function m(w,f,S,v,s,g){const y=Number(f||w)||(v?null:S),b=y?!!f:!1;let C;if(g)try{C=JSON.parse(g)}catch{}return{port:y,break:b,debugId:s,env:C}}e.parseDebugParams=m}),define(te[107],ie([0,1,292,3,165]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},category:{type:"string",cat:"e",description:(0,r.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(v,s,g=D){const c=v.find(d=>d.length>0&&d[0]!=="-"),y={},b=["_"],C=[],t={};let a;for(const d in s){const h=s[d];h.type==="subcommand"?d===c&&(a=h):(h.alias&&(y[d]=h.alias),h.type==="string"||h.type==="string[]"?(b.push(d),h.deprecates&&b.push(...h.deprecates)):h.type==="boolean"&&(C.push(d),h.deprecates&&C.push(...h.deprecates)),h.global&&(t[d]=h))}if(a&&c){const d=t;for(const M in a.options)d[M]=a.options[M];const h=v.filter(M=>M!==c),I=g.getSubcommandReporter?g.getSubcommandReporter(c):void 0,R=k(h,d,I);return{[c]:R,_:[]}}const i=E(v,{string:b,boolean:C,alias:y}),n={},o=i;n._=i._.map(d=>String(d)).filter(d=>d.length>0),delete o._;for(const d in s){const h=s[d];if(h.type==="subcommand")continue;h.alias&&delete o[h.alias];let I=o[d];if(h.deprecates)for(const R of h.deprecates)o.hasOwnProperty(R)&&(I||(I=o[R],I&&g.onDeprecatedOption(R,h.deprecationMessage||(0,r.localize)(35,null,d))),delete o[R]);if(typeof I<"u"){if(h.type==="string[]"){if(Array.isArray(I)||(I=[I]),!h.allowEmptyValue){const R=I.filter(M=>M.length>0);R.length!==I.length&&(g.onEmptyValue(d),I=R.length>0?R:void 0)}}else h.type==="string"&&(Array.isArray(I)?(I=I.pop(),g.onMultipleValues(d,I)):!I&&!h.allowEmptyValue&&(g.onEmptyValue(d),I=void 0));n[d]=I,h.deprecationMessage&&g.onDeprecatedOption(d,h.deprecationMessage)}delete o[d]}for(const d in o)g.onUnknownOption(d);return n}e.parseArgs=k;function u(v,s){let g="";return s.args&&(Array.isArray(s.args)?g=` <${s.args.join("> <")}>`:g=` <${s.args}>`),s.alias?`-${s.alias} --${v}${g}`:`--${v}${g}`}function l(v,s){const g=[];for(const c in v){const y=v[c],b=u(c,y);g.push([b,y.description])}return p(g,s)}e.formatOptions=l;function p(v,s){const c=v.reduce((C,t)=>Math.max(C,t[0].length),12)+2+1;if(s-c<25)return v.reduce((C,t)=>C.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const y=s-c-1,b=[];for(const C of v){const t=C[0],a=w(C[1],y),i=m(c-t.length-2);b.push("  "+t+i+a[0]);for(let n=1;n<a.length;n++)b.push(m(c)+a[n])}return b}function m(v){return" ".repeat(v)}function w(v,s){const g=[];for(;v.length;){const c=v.length<s?v.length:v.lastIndexOf(" ",s),y=v.slice(0,c).trim();v=v.slice(c),g.push(y)}return g}function f(v,s,g,c,y){const b=process.stdout.isTTY&&process.stdout.columns||80,C=y?.noInputFiles!==!0?`[${(0,r.localize)(36,null)}...]`:"",t=[`${v} ${g}`];t.push(""),t.push(`${(0,r.localize)(37,null)}: ${s} [${(0,r.localize)(38,null)}]${C}`),t.push(""),y?.noPipe!==!0&&(L.isWindows?t.push((0,r.localize)(39,null,s)):t.push((0,r.localize)(40,null,s)),t.push(""));const a={},i=[];for(const n in c){const o=c[n];if(o.type==="subcommand")o.description&&i.push({command:n,description:o.description});else if(o.description&&o.cat){let d=a[o.cat];d||(a[o.cat]=d={}),d[n]=o}}for(const n in a){const o=n,d=a[o];d&&(t.push(A[o]),t.push(...l(d,b)),t.push(""))}return i.length&&(t.push((0,r.localize)(41,null)),t.push(...p(i.map(n=>[n.command,n.description]),b)),t.push("")),t.join(`
`)}e.buildHelpMessage=f;function S(v,s){return`${v||(0,r.localize)(42,null)}
${s||(0,r.localize)(43,null)}
${process.arch}`}e.buildVersionMessage=S}),define(te[195],ie([0,1,70,193,107]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class A extends L.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.windowsMainService=k}call(k,u,l){return u==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(l[0],l[1]):super.call(k,u,l)}async openExtensionDevelopmentHostWindow(k,u){const l=(0,r.parseArgs)(k,r.OPTIONS);l.debugRenderer=u;const p=l.extensionDevelopmentPath;if(!p)return{success:!1};const[m]=await this.windowsMainService.openExtensionDevelopmentHostWindow(p,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!u)return{success:!0};const w=m.win;if(!w)return{success:!0};const f=w.webContents.debugger;let S=f.isAttached()?1/0:0;const v=(0,E.createServer)(s=>{S++===0&&f.attach();let g=!1;const c=C=>{g||s.write(JSON.stringify(C)+"\0")},y=(C,t,a,i)=>c({method:t,params:a,sessionId:i});w.on("close",()=>{f.removeListener("message",y),s.end(),g=!0}),f.addListener("message",y);let b=Buffer.alloc(0);s.on("data",C=>{b=Buffer.concat([b,C]);for(let t=b.indexOf(0);t!==-1;t=b.indexOf(0)){let a;try{const i=b.slice(0,t).toString("utf8");b=b.slice(t+1),a=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}f.sendCommand(a.method,a.params,a.sessionId).then(i=>c({id:a.id,sessionId:a.sessionId,result:i})).catch(i=>c({id:a.id,sessionId:a.sessionId,error:{code:0,message:i.message}}))}}),s.on("error",C=>{console.error("error on cdp pipe:",C)}),s.on("close",()=>{g=!0,--S===0&&f.detach()})});return await new Promise(s=>v.listen(0,s)),w.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=A}),define(te[62],ie([0,1,293,166,107]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(m,w){const f=(y,b)=>{console.warn((0,L.localize)(0,null,y,b))},S=y=>{console.warn((0,L.localize)(1,null,y))},v=(y,b)=>{console.warn((0,L.localize)(2,null,y,b))},s=y=>({onUnknownOption:b=>{y!=="tunnel"&&console.warn((0,L.localize)(3,null,b,y))},onMultipleValues:f,onEmptyValue:S,onDeprecatedOption:v,getSubcommandReporter:y!=="tunnel"?s:void 0}),g={onUnknownOption:y=>{console.warn((0,L.localize)(4,null,y))},onMultipleValues:f,onEmptyValue:S,onDeprecatedOption:v,getSubcommandReporter:s},c=(0,r.parseArgs)(m,r.OPTIONS,w?g:void 0);return c.goto&&c._.forEach(y=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,L.localize)(5,null))),c}function D(m){const w=m.findIndex(f=>!/^-/.test(f));if(w>-1)return[...m.slice(0,w),...m.slice(w+1)]}function k(m){let[,...w]=m;process.env.VSCODE_DEV&&(w=D(w)||[]);const f=!p(process.env);return A(w,f)}e.parseMainProcessArgv=k;function u(m){let[,,...w]=m;return process.env.VSCODE_DEV&&(w=D(w)||[]),A(w,!0)}e.parseCLIProcessArgv=u;function l(m,...w){const f=m.indexOf("--");return f===-1?m.push(...w):m.splice(f,0,...w),m}e.addArg=l;function p(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=p}),function(){"use strict";function j(e,E,L){function r(D,k){const u=A(D,k),l=[u];return e.isAbsolute(u)||l.unshift(L),e.resolve(...l)}function A(D,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,k);const p=D["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(m,"AppData","Roaming")}break;case"darwin":l=e.join(E.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,k)}return{getUserDataPath:r}}if(typeof define=="function")define(te[108],ie([196,26,36]),function(e,E,L){return j(e,E,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=j(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[109],ie([0,1,26,194,108]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(l,p){super(l,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,r.getUserDataPath)(l,p.nameShort)},p)}}e.NativeEnvironmentService=A;function D(u,l){return(0,L.parseDebugParams)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,l,u.extensionEnvironment)}e.parsePtyHostDebugPort=D;function k(u,l){return(0,L.parseDebugParams)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,l,u.extensionEnvironment)}e.parseSharedProcessDebugPort=k}),define(te[197],ie([0,1,41,26,32]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function A(D){const k=(0,r.randomPath)((0,L.tmpdir)());try{return(0,E.writeFileSync)(k,""),D&&console.log(`Marker file for --wait created: ${k}`),k}catch(u){D&&console.error(`Failed to create marker file for --wait: ${u}`);return}}e.createWaitMarkerFileSync=A}),define(te[198],ie([0,1,11,168]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function r(D,k,u){try{A(D,k,u)}catch(l){console.error(l?.message??l)}return D}e.localizeManifest=r;function A(D,k,u){const l=(p,m,w)=>{const f=p[m];if((0,E.isString)(f)){const S=f,v=S.length;if(v>1&&S[0]==="%"&&S[v-1]==="%"){const s=S.substr(1,v-2);let g=k[s];g===void 0&&u&&(g=u[s]);const c=typeof g=="string"?g:g?.message,y=u?.[s],b=typeof y=="string"?y:y?.message;if(!c){b||console.warn(`[${D.name}]: ${(0,L.localize)(0,null,s)}`);return}if(w&&(m==="title"||m==="category")&&b&&b!==c){const C={value:c,original:b};p[m]=C}else p[m]=c}}else if((0,E.isObject)(f))for(const S in f)f.hasOwnProperty(S)&&(S==="commands"?l(f,S,!0):l(f,S,w));else if(Array.isArray(f))for(let S=0;S<f.length;S++)l(f,S,w)};for(const p in D)D.hasOwnProperty(p)&&l(D,p)}}),define(te[199],ie([0,1,18,72,170,200]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function u(g){return g=g.trim(),g==="*"||D.test(g)}e.isValidVersionStr=u;function l(g){if(!u(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=g.match(D);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.parseVersion=l;function p(g){if(!g)return null;const c=g.majorBase,y=g.majorMustEqual,b=g.minorBase;let C=g.minorMustEqual;const t=g.patchBase;let a=g.patchMustEqual;g.hasCaret&&(c===0||(C=!1),a=!1);let i=0;if(g.preRelease){const n=k.exec(g.preRelease);if(n){const[,o,d,h]=n;i=Date.UTC(Number(o),Number(d)-1,Number(h))}}return{majorBase:c,majorMustEqual:y,minorBase:b,minorMustEqual:C,patchBase:t,patchMustEqual:a,isMinimum:g.hasGreaterEquals,notBefore:i}}e.normalizeVersion=p;function m(g,c,y){let b;typeof g=="string"?b=p(l(g)):b=g;let C;c instanceof Date?C=c.getTime():typeof c=="string"&&(C=new Date(c).getTime());let t;if(typeof y=="string"?t=p(l(y)):t=y,!b||!t)return!1;const a=b.majorBase,i=b.minorBase,n=b.patchBase;let o=t.majorBase,d=t.minorBase,h=t.patchBase;const I=t.notBefore;let R=t.majorMustEqual,M=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?a>o?!0:a<o?!1:i>d?!0:i<d||C&&C<I?!1:n>=h:(a===1&&o===0&&(!R||!M||!T)&&(o=1,d=0,h=0,R=!0,M=!1,T=!1),a<o?!1:a>o?!R:i<d?!1:i>d?!M:n<h?!1:n>h?!T:!(C&&C<I))}e.isValidVersion=m;function w(g,c,y,b,C){const t=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return t.push([L.default.Error,r.localize(0,null)]),t;if(typeof b.name!="string")return t.push([L.default.Error,r.localize(1,null,"name")]),t;if(typeof b.version!="string")return t.push([L.default.Error,r.localize(2,null,"version")]),t;if(!b.engines)return t.push([L.default.Error,r.localize(3,null,"engines")]),t;if(typeof b.engines.vscode!="string")return t.push([L.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof b.extensionDependencies<"u"&&!s(b.extensionDependencies))return t.push([L.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof b.activationEvents<"u"){if(!s(b.activationEvents))return t.push([L.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof b.main>"u"&&typeof b.browser>"u")return t.push([L.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&t.push([L.default.Warning,r.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return t.push([L.default.Error,r.localize(9,null,"main")]),t;{const n=(0,E.joinPath)(y,b.main);(0,E.isEqualOrParent)(n,y)||t.push([L.default.Warning,r.localize(10,null,n.path,y.path)])}}if(typeof b.browser<"u"){if(typeof b.browser!="string")return t.push([L.default.Error,r.localize(11,null,"browser")]),t;{const n=(0,E.joinPath)(y,b.browser);(0,E.isEqualOrParent)(n,y)||t.push([L.default.Warning,r.localize(12,null,n.path,y.path)])}}if(!A.valid(b.version))return t.push([L.default.Error,r.localize(13,null)]),t;const a=[];if(!f(g,c,b,C,a))for(const n of a)t.push([L.default.Error,n]);return t}e.validateExtensionManifest=w;function f(g,c,y,b,C){return b||typeof y.main>"u"&&typeof y.browser>"u"?!0:v(g,c,y.engines.vscode,C)}e.isValidExtensionVersion=f;function S(g,c,y){return g==="*"||v(c,y,g)}e.isEngineValid=S;function v(g,c,y,b=[]){const C=p(l(y));if(!C)return b.push(r.localize(14,null,y)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return b.push(r.localize(15,null,y)),!1}else if(!C.majorMustEqual)return b.push(r.localize(16,null,y)),!1;return m(g,c,C)?!0:(b.push(r.localize(17,null,g,y)),!1)}function s(g){if(!Array.isArray(g))return!1;for(let c=0,y=g.length;c<y;c++)if(typeof g[c]!="string")return!1;return!0}}),define(te[201],ie([0,1,17,31]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function r(A,D,k){let u=k&&k.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const p=(await D.readFile(A.serviceMachineIdResource)).value.toString();u=(0,L.isUUID)(p)?p:null}catch{u=null}if(!u){u=(0,L.generateUuid)();try{await D.writeFile(A.serviceMachineIdResource,E.VSBuffer.fromString(u))}catch{}}return k?.store("storage.serviceMachineId",u,-1,1),u}e.getServiceMachineId=r}),define(te[73],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(r,A=[],D=!1){this.ctor=r,this.staticArguments=A,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=E}),define(te[202],ie([0,1,73]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var r;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function A(k,u,l){u instanceof E.SyncDescriptor||(u=new E.SyncDescriptor(u,[],!!l)),L.push([k,u])}e.registerSingleton=A;function D(){return L}e.getSingletonServiceDescriptors=D}),define(te[203],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(A,D){this.key=A,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class L{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const D of this._nodes.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const k=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(D);k.outgoing.set(u.key,u),u.incoming.set(k.key,k)}removeNode(A){const D=this._hashFn(A);this._nodes.delete(D);for(const k of this._nodes.values())k.outgoing.delete(D),k.incoming.delete(D)}lookupOrInsertNode(A){const D=this._hashFn(A);let k=this._nodes.get(D);return k||(k=new E(D,A),this._nodes.set(D,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[D,k]of this._nodes)A.push(`${D}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,D]of this._nodes){const k=new Set([A]),u=this._findCycle(D,k);if(u)return u}}_findCycle(A,D){for(const[k,u]of A.outgoing){if(D.has(k))return[...D,k].join(" -> ");D.add(k);const l=this._findCycle(u,D);if(l)return l;D.delete(k)}}}e.Graph=L}),define(te[6],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function k(u){return u[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=k})(E||(e._util=E={})),e.IInstantiationService=r("instantiationService");function L(D,k,u){k[E.DI_TARGET]===k?k[E.DI_DEPENDENCIES].push({id:D,index:u}):(k[E.DI_DEPENDENCIES]=[{id:D,index:u}],k[E.DI_TARGET]=k)}function r(D){if(E.serviceIds.has(D))return E.serviceIds.get(D);const k=function(u,l,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,u,p)};return k.toString=()=>D,E.serviceIds.set(D,k),k}e.createDecorator=r;function A(D){return D}e.refineServiceDecorator=A}),define(te[63],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(te[19],ie([0,1,11,8,6]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,r.createDecorator)("configurationService");function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof L.URI)}e.isConfigurationOverrides=A;function D(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=D;var k;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function u(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=u;function l(s,g){const c=Object.create(null);for(const y in s)p(c,y,s[y],g);return c}e.toValuesTree=l;function p(s,g,c,y){const b=g.split("."),C=b.pop();let t=s;for(let a=0;a<b.length;a++){const i=b[a];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:y(`Ignoring ${g} as ${b.slice(0,a+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[C]=c}catch{y(`Ignoring ${g} as ${b.join(".")} is ${JSON.stringify(t)}`)}else y(`Ignoring ${g} as ${b.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=p;function m(s,g){const c=g.split(".");w(s,c)}e.removeFromValueTree=m;function w(s,g){const c=g.shift();if(g.length===0){delete s[c];return}if(Object.keys(s).indexOf(c)!==-1){const y=s[c];typeof y=="object"&&!Array.isArray(y)&&(w(y,g),Object.keys(y).length===0&&delete s[c])}}function f(s,g,c){function y(t,a){let i=t;for(const n of a){if(typeof i!="object"||i===null)return;i=i[n]}return i}const b=g.split("."),C=y(s,b);return typeof C>"u"?c:C}e.getConfigurationValue=f;function S(s,g,c){Object.keys(g).forEach(y=>{y!=="__proto__"&&(y in s?E.isObject(s[y])&&E.isObject(g[y])?S(s[y],g[y],c):c&&(s[y]=g[y]):s[y]=g[y])})}e.merge=S;function v(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(te[204],ie([0,1,3,27,192,6,161,13]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",E.isMacintosh),u.set("isLinux",E.isLinux),u.set("isWindows",E.isWindows),u.set("isWeb",E.isWeb),u.set("isMacNative",E.isMacintosh&&!E.isWeb),u.set("isEdge",E.isEdge),u.set("isFirefox",E.isFirefox),u.set("isChrome",E.isChrome),u.set("isSafari",E.isSafari);function l(_,P){if(u.get(_)!==void 0)throw(0,k.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(_,P)}e.setConstant=l;const p=Object.prototype.hasOwnProperty;var m;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const w={regexParsingWithErrorRecovery:!0},f=(0,D.localize)(0,null),S=(0,D.localize)(1,null),v=(0,D.localize)(2,null),s=(0,D.localize)(3,null),g=(0,D.localize)(4,null),c=(0,D.localize)(5,null),y=(0,D.localize)(6,null),b=(0,D.localize)(7,null);class C{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(P=w){this._config=P,this._scanner=new r.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(P){if(P===""){this._parsingErrors.push({message:f,offset:0,lexeme:"",additionalInfo:S});return}this._tokens=this._scanner.reset(P).scan(),this._current=0,this._parsingErrors=[];try{const O=this._expr();if(!this._isAtEnd()){const U=this._peek(),B=U.type===17?c:void 0;throw this._parsingErrors.push({message:g,offset:U.offset,lexeme:r.Scanner.getLexeme(U),additionalInfo:B}),C._parseError}return O}catch(O){if(O!==C._parseError)throw O;return}}_expr(){return this._or()}_or(){const P=[this._and()];for(;this._matchOne(16);){const O=this._and();P.push(O)}return P.length===1?P[0]:t.or(...P)}_and(){const P=[this._term()];for(;this._matchOne(15);){const O=this._term();P.push(O)}return P.length===1?P[0]:t.and(...P)}_term(){if(this._matchOne(2)){const P=this._peek();switch(P.type){case 11:return this._advance(),o.INSTANCE;case 12:return this._advance(),d.INSTANCE;case 0:{this._advance();const O=this._expr();return this._consume(1,s),O?.negate()}case 17:return this._advance(),W.create(P.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",P)}}return this._primary()}_primary(){const P=this._peek();switch(P.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const O=this._expr();return this._consume(1,s),O}case 17:{const O=P.lexeme;if(this._advance(),this._matchOne(9)){const B=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),B.type!==10)throw this._errExpectedButGot("REGEX",B);const F=B.lexeme,x=F.lastIndexOf("/"),V=x===F.length-1?void 0:this._removeFlagsGY(F.substring(x+1));let se;try{se=new RegExp(F.substring(1,x),V)}catch{throw this._errExpectedButGot("REGEX",B)}return ue.create(O,se)}switch(B.type){case 10:case 19:{const F=[B.lexeme];this._advance();let x=this._peek(),V=0;for(let Re=0;Re<B.lexeme.length;Re++)B.lexeme.charCodeAt(Re)===40?V++:B.lexeme.charCodeAt(Re)===41&&V--;for(;!this._isAtEnd()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:V++;break;case 1:V--;break;case 10:case 18:for(let Re=0;Re<x.lexeme.length;Re++)x.lexeme.charCodeAt(Re)===40?V++:B.lexeme.charCodeAt(Re)===41&&V--}if(V<0)break;F.push(r.Scanner.getLexeme(x)),this._advance(),x=this._peek()}const se=F.join(""),ae=se.lastIndexOf("/"),Se=ae===se.length-1?void 0:this._removeFlagsGY(se.substring(ae+1));let De;try{De=new RegExp(se.substring(1,ae),Se)}catch{throw this._errExpectedButGot("REGEX",B)}return t.regex(O,De)}case 18:{const F=B.lexeme;this._advance();let x=null;if(!(0,L.isFalsyOrWhitespace)(F)){const V=F.indexOf("/"),se=F.lastIndexOf("/");if(V!==se&&V>=0){const ae=F.slice(V+1,se),Se=F[se+1]==="i"?"i":"";try{x=new RegExp(ae,Se)}catch{throw this._errExpectedButGot("REGEX",B)}}}if(x===null)throw this._errExpectedButGot("REGEX",B);return ue.create(O,x)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,v);const B=this._value();return t.notIn(O,B)}switch(this._peek().type){case 3:{this._advance();const B=this._value();if(this._previous().type===18)return t.equals(O,B);switch(B){case"true":return t.has(O);case"false":return t.not(O);default:return t.equals(O,B)}}case 4:{this._advance();const B=this._value();if(this._previous().type===18)return t.notEquals(O,B);switch(B){case"true":return t.not(O);case"false":return t.has(O);default:return t.notEquals(O,B)}}case 5:return this._advance(),ne.create(O,this._value());case 6:return this._advance(),re.create(O,this._value());case 7:return this._advance(),H.create(O,this._value());case 8:return this._advance(),J.create(O,this._value());case 13:return this._advance(),t.in(O,this._value());default:return t.has(O)}}case 20:throw this._parsingErrors.push({message:y,offset:P.offset,lexeme:"",additionalInfo:b}),C._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const P=this._peek();switch(P.type){case 17:case 18:return this._advance(),P.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(P){return P.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(P){return this._check(P)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(P,O){if(this._check(P))return this._advance();throw this._errExpectedButGot(O,this._peek())}_errExpectedButGot(P,O,U){const B=(0,D.localize)(8,null,P,r.Scanner.getLexeme(O)),F=O.offset,x=r.Scanner.getLexeme(O);return this._parsingErrors.push({message:B,offset:F,lexeme:x,additionalInfo:U}),C._parseError}_check(P){return this._peek().type===P}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=C,C._parseError=new Error;class t{static false(){return o.INSTANCE}static true(){return d.INSTANCE}static has(P){return h.create(P)}static equals(P,O){return I.create(P,O)}static notEquals(P,O){return T.create(P,O)}static regex(P,O){return ue.create(P,O)}static in(P,O){return R.create(P,O)}static notIn(P,O){return M.create(P,O)}static not(P){return W.create(P)}static and(...P){return q.create(P,null,!0)}static or(...P){return N.create(P,null,!0)}static greater(P,O){return H.create(P,O)}static greaterEquals(P,O){return J.create(P,O)}static smaller(P,O){return ne.create(P,O)}static smallerEquals(P,O){return re.create(P,O)}static deserialize(P){return P==null?void 0:this._parser.parse(P)}}e.ContextKeyExpr=t,t._parser=new C({regexParsingWithErrorRecovery:!1});function a(_){const P=new C({regexParsingWithErrorRecovery:!1});return _.map(O=>(P.parse(O),P.lexingErrors.length>0?P.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,D.localize)(9,null,U.additionalInfo):(0,D.localize)(10,null),offset:U.offset,length:U.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}e.validateWhenClauses=a;function i(_,P){const O=_?_.substituteConstants():void 0,U=P?P.substituteConstants():void 0;return!O&&!U?!0:!O||!U?!1:O.equals(U)}e.expressionsAreEqualWithConstantSubstitution=i;function n(_,P){return _.cmp(P)}class o{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=o,o.INSTANCE=new o;class d{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return o.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class h{static create(P,O=null){const U=u.get(P);return typeof U=="boolean"?U?d.INSTANCE:o.INSTANCE:new h(P,O)}constructor(P,O){this.key=P,this.negated=O,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:G(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=u.get(this.key);return typeof P=="boolean"?P?d.INSTANCE:o.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.negated||(this.negated=W.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class I{static create(P,O,U=null){if(typeof O=="boolean")return O?h.create(P,U):W.create(P,U);const B=u.get(P);return typeof B=="boolean"?O===(B?"true":"false")?d.INSTANCE:o.INSTANCE:new I(P,O,U)}constructor(P,O,U){this.key=P,this.value=O,this.negated=U,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=u.get(this.key);if(typeof P=="boolean"){const O=P?"true":"false";return this.value===O?d.INSTANCE:o.INSTANCE}return this}evaluate(P){return P.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(P){return P.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=I;class R{static create(P,O){return new R(P,O)}constructor(P,O){this.key=P,this.valueKey=O,this.type=10,this.negated=null}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.valueKey,P.key,P.valueKey)}equals(P){return P.type===this.type?this.key===P.key&&this.valueKey===P.valueKey:!1}substituteConstants(){return this}evaluate(P){const O=P.getValue(this.valueKey),U=P.getValue(this.key);return Array.isArray(O)?O.includes(U):typeof U=="string"&&typeof O=="object"&&O!==null?p.call(O,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(P){return P.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=M.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=R;class M{static create(P,O){return new M(P,O)}constructor(P,O){this.key=P,this.valueKey=O,this.type=11,this._negated=R.create(P,O)}cmp(P){return P.type!==this.type?this.type-P.type:this._negated.cmp(P._negated)}equals(P){return P.type===this.type?this._negated.equals(P._negated):!1}substituteConstants(){return this}evaluate(P){return!this._negated.evaluate(P)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(P){return P.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=M;class T{static create(P,O,U=null){if(typeof O=="boolean")return O?W.create(P,U):h.create(P,U);const B=u.get(P);return typeof B=="boolean"?O===(B?"true":"false")?o.INSTANCE:d.INSTANCE:new T(P,O,U)}constructor(P,O,U){this.key=P,this.value=O,this.negated=U,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=u.get(this.key);if(typeof P=="boolean"){const O=P?"true":"false";return this.value===O?o.INSTANCE:d.INSTANCE}return this}evaluate(P){return P.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(P){return P.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=T;class W{static create(P,O=null){const U=u.get(P);return typeof U=="boolean"?U?o.INSTANCE:d.INSTANCE:new W(P,O)}constructor(P,O){this.key=P,this.negated=O,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:G(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=u.get(this.key);return typeof P=="boolean"?P?o.INSTANCE:d.INSTANCE:this}evaluate(P){return!P.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(P){return P.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=W;function z(_,P){if(typeof _=="string"){const O=parseFloat(_);isNaN(O)||(_=O)}return typeof _=="string"||typeof _=="number"?P(_):o.INSTANCE}class H{static create(P,O,U=null){return z(O,B=>new H(P,B,U))}constructor(P,O,U){this.key=P,this.value=O,this.negated=U,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=re.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=H;class J{static create(P,O,U=null){return z(O,B=>new J(P,B,U))}constructor(P,O,U){this.key=P,this.value=O,this.negated=U,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ne.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=J;class ne{static create(P,O,U=null){return z(O,B=>new ne(P,B,U))}constructor(P,O,U){this.key=P,this.value=O,this.negated=U,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=J.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=ne;class re{static create(P,O,U=null){return z(O,B=>new re(P,B,U))}constructor(P,O,U){this.key=P,this.value=O,this.negated=U,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=re;class ue{static create(P,O){return new ue(P,O)}constructor(P,O){this.key=P,this.regexp=O,this.type=7,this.negated=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.key<P.key)return-1;if(this.key>P.key)return 1;const O=this.regexp?this.regexp.source:"",U=P.regexp?P.regexp.source:"";return O<U?-1:O>U?1:0}equals(P){if(P.type===this.type){const O=this.regexp?this.regexp.source:"",U=P.regexp?P.regexp.source:"";return this.key===P.key&&O===U}return!1}substituteConstants(){return this}evaluate(P){const O=P.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const P=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${P}`}keys(){return[this.key]}map(P){return P.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ce.create(this)),this.negated}}e.ContextKeyRegexExpr=ue;class ce{static create(P){return new ce(P)}constructor(P){this._actual=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(P){return new ce(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ce;function K(_){let P=null;for(let O=0,U=_.length;O<U;O++){const B=_[O].substituteConstants();if(_[O]!==B&&P===null){P=[];for(let F=0;F<O;F++)P[F]=_[F]}P!==null&&(P[O]=B)}return P===null?_:P}class q{static create(P,O,U){return q._normalizeArr(P,O,U)}constructor(P,O){this.expr=P,this.negated=O,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const B=n(this.expr[O],P.expr[O]);if(B!==0)return B}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(P.expr[O]))return!1;return!0}return!1}substituteConstants(){const P=K(this.expr);return P===this.expr?this:q.create(P,this.negated,!1)}evaluate(P){for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].evaluate(P))return!1;return!0}static _normalizeArr(P,O,U){const B=[];let F=!1;for(const x of P)if(x){if(x.type===1){F=!0;continue}if(x.type===0)return o.INSTANCE;if(x.type===6){B.push(...x.expr);continue}B.push(x)}if(B.length===0&&F)return d.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(n);for(let x=1;x<B.length;x++)B[x-1].equals(B[x])&&(B.splice(x,1),x--);if(B.length===1)return B[0];for(;B.length>1;){const x=B[B.length-1];if(x.type!==9)break;B.pop();const V=B.pop(),se=B.length===0,ae=N.create(x.expr.map(Se=>q.create([Se,V],null,U)),null,se);ae&&(B.push(ae),B.sort(n))}if(B.length===1)return B[0];if(U){for(let x=0;x<B.length;x++)for(let V=x+1;V<B.length;V++)if(B[x].negate().equals(B[V]))return o.INSTANCE;if(B.length===1)return B[0]}return new q(B,O)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const O of this.expr)P.push(...O.keys());return P}map(P){return new q(this.expr.map(O=>O.map(P)),null)}negate(){if(!this.negated){const P=[];for(const O of this.expr)P.push(O.negate());this.negated=N.create(P,this,!0)}return this.negated}}e.ContextKeyAndExpr=q;class N{static create(P,O,U){return N._normalizeArr(P,O,U)}constructor(P,O){this.expr=P,this.negated=O,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const B=n(this.expr[O],P.expr[O]);if(B!==0)return B}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(P.expr[O]))return!1;return!0}return!1}substituteConstants(){const P=K(this.expr);return P===this.expr?this:N.create(P,this.negated,!1)}evaluate(P){for(let O=0,U=this.expr.length;O<U;O++)if(this.expr[O].evaluate(P))return!0;return!1}static _normalizeArr(P,O,U){let B=[],F=!1;if(P){for(let x=0,V=P.length;x<V;x++){const se=P[x];if(se){if(se.type===0){F=!0;continue}if(se.type===1)return d.INSTANCE;if(se.type===9){B=B.concat(se.expr);continue}B.push(se)}}if(B.length===0&&F)return o.INSTANCE;B.sort(n)}if(B.length!==0){if(B.length===1)return B[0];for(let x=1;x<B.length;x++)B[x-1].equals(B[x])&&(B.splice(x,1),x--);if(B.length===1)return B[0];if(U){for(let x=0;x<B.length;x++)for(let V=x+1;V<B.length;V++)if(B[x].negate().equals(B[V]))return d.INSTANCE;if(B.length===1)return B[0]}return new N(B,O)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const O of this.expr)P.push(...O.keys());return P}map(P){return new N(this.expr.map(O=>O.map(P)),null)}negate(){if(!this.negated){const P=[];for(const O of this.expr)P.push(O.negate());for(;P.length>1;){const O=P.shift(),U=P.shift(),B=[];for(const F of Y(O))for(const x of Y(U))B.push(q.create([F,x],null,!1));P.unshift(N.create(B,null,!1))}this.negated=N.create(P,this,!0)}return this.negated}}e.ContextKeyOrExpr=N;class $ extends h{static all(){return $._info.values()}constructor(P,O,U){super(P,null),this._defaultValue=O,typeof U=="object"?$._info.push({...U,key:P}):U!==!0&&$._info.push({key:P,description:U,type:O!=null?typeof O:void 0})}bindTo(P){return P.createKey(this.key,this._defaultValue)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return I.create(this.key,P)}notEqualsTo(P){return T.create(this.key,P)}}e.RawContextKey=$,$._info=[],e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function G(_,P){return _<P?-1:_>P?1:0}function ee(_,P,O,U){return _<O?-1:_>O?1:P<U?-1:P>U?1:0}function oe(_,P){if(_.type===0||P.type===1)return!0;if(_.type===9)return P.type===9?le(_.expr,P.expr):!1;if(P.type===9){for(const O of P.expr)if(oe(_,O))return!0;return!1}if(_.type===6){if(P.type===6)return le(P.expr,_.expr);for(const O of _.expr)if(oe(O,P))return!0;return!1}return _.equals(P)}e.implies=oe;function le(_,P){let O=0,U=0;for(;O<_.length&&U<P.length;){const B=_[O].cmp(P[U]);if(B<0)return!1;B===0&&O++,U++}return O===_.length}function Y(_){return _.type===9?_.expr:[_]}}),define(te[74],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class L{constructor(){this.secretVault={}}async getPassword(A,D){return this.secretVault[A]?.[D]??null}async setPassword(A,D,k){this.secretVault[A]=this.secretVault[A]??{},this.secretVault[A][D]=k}async deletePassword(A,D){return this.secretVault[A]?.[D]?(delete this.secretVault[A][D],Object.keys(this.secretVault[A]).length===0&&delete this.secretVault[A],!0):!1}async findPassword(A){return JSON.stringify(this.secretVault[A])??null}async findCredentials(A){const D=[];for(const k of Object.keys(this.secretVault[A]||{}))D.push({account:k,password:this.secretVault[A][k]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=L}),define(te[88],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L;class r{async getPerformanceInfo(D,k){return{}}async getSystemInfo(D,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,k){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=r}),define(te[89],ie([0,1,18,72,163,6,44,3,40]),function(j,e,E,L,r,A,D,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,A.createDecorator)("dialogService");var l;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(l||(l={}));class p{getConfirmationButtons(s){return this.getButtons(s,l.Confirmation)}getPromptButtons(s){return this.getButtons(s,l.Prompt)}getInputButtons(s){return this.getButtons(s,l.Input)}getButtons(s,g){const c=[];switch(g){case l.Confirmation:{const y=s;y.primaryButton?c.push(y.primaryButton):c.push((0,r.localize)(0,null)),y.cancelButton?c.push(y.cancelButton):c.push((0,r.localize)(1,null));break}case l.Prompt:{const y=s;Array.isArray(y.buttons)&&y.buttons.length>0&&c.push(...y.buttons.map(b=>b.label)),y.cancelButton&&(y.cancelButton===!0?c.push((0,r.localize)(2,null)):typeof y.cancelButton=="string"?c.push(y.cancelButton):y.cancelButton.label?c.push(y.cancelButton.label):c.push((0,r.localize)(3,null))),c.length===0&&c.push((0,r.localize)(4,null));break}case l.Input:{const y=s;y.primaryButton?c.push(y.primaryButton):c.push((0,r.localize)(5,null)),y.cancelButton?c.push(y.cancelButton):c.push((0,r.localize)(6,null));break}}return c}getDialogType(s){if(typeof s=="string")return s;if(typeof s=="number")return s===L.default.Info?"info":s===L.default.Error?"error":s===L.default.Warning?"warning":"none"}async getPromptResult(s,g,c){const y=[...s.buttons??[]];return s.cancelButton&&typeof s.cancelButton!="string"&&typeof s.cancelButton!="boolean"&&y.push(s.cancelButton),{result:await y[g]?.run({checkboxChecked:c}),checkboxChecked:c}}}e.AbstractDialogHandler=p,e.IFileDialogService=(0,A.createDecorator)("fileDialogService");var m;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(m||(e.ConfirmResult=m={}));const w=10;function f(v){const s=[];return s.push(...v.slice(0,w).map(g=>typeof g=="string"?g:(0,E.basename)(g))),v.length>w&&(v.length-w===1?s.push((0,r.localize)(7,null)):s.push((0,r.localize)(8,null,v.length-w))),s.push(""),s.join(`
`)}e.getFileNamesMessage=f;function S(v,s){const g=(0,u.deepClone)(v);let c=(g.buttons??[]).map(t=>(0,D.mnemonicButtonLabel)(t)),y=(v.buttons||[]).map((t,a)=>a),b=0,C=g.cancelId??c.length-1;if(c.length>1){const t=typeof C=="number"?c[C]:void 0;if(k.isLinux||k.isMacintosh){if(typeof t=="string"&&c.length>1&&C!==1){c.splice(C,1),c.splice(1,0,t);const a=y[C];y.splice(C,1),y.splice(1,0,a),C=1}k.isLinux&&c.length>1&&(c=c.reverse(),y=y.reverse(),b=c.length-1,typeof t=="string"&&(C=b-1))}else if(k.isWindows&&typeof t=="string"&&c.length>1&&C!==c.length-1){c.splice(C,1),c.push(t);const a=y[C];y.splice(C,1),y.push(a),C=c.length-1}}return g.buttons=c,g.defaultId=b,g.cancelId=C,g.noLink=!0,g.title=g.title||s.nameLong,{options:g,buttonIndeces:y}}e.massageMessageBoxOptions=S}),define(te[110],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(te[34],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(te[111],ie([0,1,167,6]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function r(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function A(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function D(c,y){switch(c){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function k(c,y){return y==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function u(c,y,b){return k(y,b)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===b?!0:l(b).includes(c)}e.isTargetPlatformCompatible=u;function l(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function p(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=p;var m;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(m||(e.SortBy=m={}));var w;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var f;(function(c){c.Install="install",c.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var S;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var v;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var s;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class g extends Error{constructor(y,b){super(y),this.code=b,this.name=b}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,E.localize)(1,null),original:"Preferences"}}),define(te[205],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(te[206],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[112],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(te[207],ie([0,1,50,14,9,3,71,24,86,171,112]),function(j,e,E,L,r,A,D,k,u,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const m=l.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends w{openTerminal(b,C){return this.spawnTerminal(E,b,u.getWindowsShell(),C)}spawnTerminal(b,C,t,a){const i=C.windowsExec||f.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const n=r.basename(i,".exe").toLowerCase();if(n==="cmder")return b.spawn(i,a?[a]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),n==="wt"&&o.push("-d ."),new Promise((d,h)=>{const I=s(process),R=b.spawn(t,o,{cwd:a,env:I});R.on("error",h),R.on("exit",()=>d())})}runInTerminal(b,C,t,a,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows();return new Promise((o,d)=>{const h=`"${C} - ${m}"`,I=`""${t.join('" "')}" & pause"`,R=Object.assign({},s(process),a);Object.keys(R).filter(H=>R[H]===null).forEach(H=>delete R[H]);const M={cwd:C,env:R,windowsVerbatimArguments:!0};let T,W;r.basename(n,".exe")==="wt"?(T=n,W=["-d",".",f.CMD,"/c",I]):(T=f.CMD,W=["/c","start",h,"/wait",n,"/c",I]),E.spawn(T,W,M).on("error",H=>{d(g(H))}),o(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const b=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${b?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class S extends w{openTerminal(b,C){return this.spawnTerminal(E,b,C)}runInTerminal(b,C,t,a,i){const n=i.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((o,d)=>{if(n===p.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const h=n===p.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`).fsPath,"-t",b||m,"-w",C];for(const W of t)R.push("-a"),R.push(W);if(a){const W=Object.assign({},s(process),a);for(const z in W){const H=W[z];H===null?(R.push("-u"),R.push(z)):(R.push("-e"),R.push(`${z}=${H}`))}}let M="";const T=E.spawn(S.OSASCRIPT,R);T.on("error",W=>{d(g(W))}),T.stderr.on("data",W=>{M+=W.toString()}),T.on("exit",W=>{if(W===0)o(void 0);else if(M){const z=M.split(`
`,1);d(new Error(z[0]))}else d(new Error(l.localize(1,null,h,W)))})}else d(new Error(l.localize(2,null,n)))})}spawnTerminal(b,C,t){const a=C.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const o=["-a",a];t&&o.push(t);const d=s(process),h=b.spawn("/usr/bin/open",o,{cwd:t,env:d});h.on("error",n),h.on("exit",()=>i())})}}e.MacExternalTerminalService=S,S.OSASCRIPT="/usr/bin/osascript";class v extends w{openTerminal(b,C){return this.spawnTerminal(E,b,C)}runInTerminal(b,C,t,a,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((o,d)=>{const h=[];n.then(I=>{I.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const R=`${c(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;h.push(`''${R}''`);const M=Object.assign({},s(process),a);Object.keys(M).filter(H=>M[H]===null).forEach(H=>delete M[H]);const T={cwd:C,env:M};let W="";const z=E.spawn(I,h,T);z.on("error",H=>{d(g(H))}),z.stderr.on("data",H=>{W+=H.toString()}),z.on("exit",H=>{if(H===0)o(void 0);else if(W){const J=W.split(`
`,1);d(new Error(J[0]))}else d(new Error(l.localize(4,null,I,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!v._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)v._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const b=await k.Promises.exists("/etc/debian_version");v._DEFAULT_TERMINAL_LINUX_READY=new Promise(C=>{b?C("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?C("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?C("konsole"):process.env.COLORTERM?C(process.env.COLORTERM):process.env.TERM?C(process.env.TERM):C("xterm")})}return v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(b,C,t){const a=C.linuxExec?Promise.resolve(C.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{a.then(o=>{const d=s(process),h=b.spawn(o,[],{cwd:t,env:d});h.on("error",n),h.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=l.localize(3,null);function s(y){const b={...y.env};return(0,D.sanitizeProcessEnvironment)(b),b}function g(y){return"errno"in y&&y.errno==="ENOENT"&&"path"in y&&typeof y.path=="string"?new Error(l.localize(5,null,y.path)):y}function c(y){let b="";for(const C of y)C.indexOf(" ")>=0?b+='"'+C+'"':b+=C,b+=" ";return b}}),define(te[16],ie([0,1,61,9,27,11,8,173,6,3,14]),function(j,e,E,L,r,A,D,k,u,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,u.createDecorator)("fileService");function m(q){return q.create===!0}e.isFileOpenForWriteOptions=m;var w;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var f;(function(q){q[q.Readonly=1]="Readonly"})(f||(e.FilePermission=f={}));var S;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileClone=32768]="FileClone"})(S||(e.FileSystemProviderCapabilities=S={}));function v(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=v;function s(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=s;function g(q){return!!(q.capabilities&32768)}e.hasFileCloneCapability=g;function c(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function y(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=y;function b(q){return v(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var C;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(C||(e.FileSystemProviderErrorCode=C={}));class t extends Error{static create(N,$){const G=new t(N.toString(),$);return n(G,$),G}constructor(N,$){super(N),this.code=$}}e.FileSystemProviderError=t;function a(q,N){return t.create(q,N)}e.createFileSystemProviderError=a;function i(q){return q||a((0,k.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=i;function n(q,N){return q.name=N?`${N} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=n;function o(q){if(!q)return C.Unknown;if(q instanceof t)return q.code;const N=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!N)return C.Unknown;switch(N[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=o;function d(q){if(q instanceof W)return q.fileOperationResult;switch(o(q)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 9;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=d;var h;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(h||(e.FileOperation=h={}));class I{constructor(N,$,G){this.resource=N,this.operation=$,this.target=G}isOperation(N){return this.operation===N}}e.FileOperationEvent=I;var R;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class M{constructor(N,$){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const G=new Map;for(const ee of N){const oe=G.get(ee.type);switch(oe?oe.push([ee.resource,ee]):G.set(ee.type,[[ee.resource,ee]]),ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}}for(const[ee,oe]of G)switch(ee){case 1:this.added=E.TernarySearchTree.forUris(()=>$),this.added.fill(oe);break;case 0:this.updated=E.TernarySearchTree.forUris(()=>$),this.updated.fill(oe);break;case 2:this.deleted=E.TernarySearchTree.forUris(()=>$),this.deleted.fill(oe);break}}contains(N,...$){return this.doContains(N,{includeChildren:!1},...$)}affects(N,...$){return this.doContains(N,{includeChildren:!0},...$)}doContains(N,$,...G){if(!N)return!1;const ee=G.length>0;return!!((!ee||G.includes(1))&&(this.added?.get(N)||$.includeChildren&&this.added?.findSuperstr(N))||(!ee||G.includes(0))&&(this.updated?.get(N)||$.includeChildren&&this.updated?.findSuperstr(N))||(!ee||G.includes(2))&&(this.deleted?.findSubstr(N)||$.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=M;function T(q,N,$){return!q||!N||q===N||N.length>q.length?!1:(N.charAt(N.length-1)!==L.sep&&(N+=L.sep),$?(0,r.startsWithIgnoreCase)(q,N):q.indexOf(N)===0)}e.isParent=T;class W extends Error{constructor(N,$,G){super(N),this.fileOperationResult=$,this.options=G}}e.FileOperationError=W;class z extends W{constructor(N,$,G,ee){super(N,$,ee),this.fileOperationResult=$,this.size=G}}e.TooLargeFileOperationError=z;class H extends W{constructor(N,$,G){super(N,2,G),this.stat=$}}e.NotModifiedSinceFileOperationError=H;var J;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ne;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(e.FileKind=ne={})),e.ETAG_DISABLED="";function re(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=re;async function ue(q,N){if(!N.hasProvider(D.URI.from({scheme:q.scheme})))return new Promise($=>{const G=N.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===q.scheme&&ee.added&&(G.dispose(),$())})})}e.whenProviderRegistered=ue;class ce{static formatSize(N){return(0,A.isNumber)(N)||(N=0),N<ce.KB?(0,k.localize)(1,null,N.toFixed(0)):N<ce.MB?(0,k.localize)(2,null,(N/ce.KB).toFixed(2)):N<ce.GB?(0,k.localize)(3,null,(N/ce.MB).toFixed(2)):N<ce.TB?(0,k.localize)(4,null,(N/ce.GB).toFixed(2)):(0,k.localize)(5,null,(N/ce.TB).toFixed(2))}}e.ByteSize=ce,ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB;function K(q){const N=typeof q=="string"||q?.scheme===p.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===p.Schemas.file?1024*ce.MB:N?10*ce.MB:l.isWeb?50*ce.MB:1024*ce.MB}e.getLargeFileConfirmationLimit=K}),define(te[208],ie([0,1,17,49,13,4,2,60,8,31,16]),function(j,e,E,L,r,A,D,k,u,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class m extends D.Disposable{constructor(f,S){super(),this.channel=f,this.extraCapabilities=S,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,l.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(f){return this.channel.call("stat",[f])}readdir(f){return this.channel.call("readdir",[f])}async readFile(f,S){const{buffer:v}=await this.channel.call("readFile",[f,S]);return v}readFileStream(f,S,v){const s=(0,k.newWriteableStream)(c=>E.VSBuffer.concat(c.map(y=>E.VSBuffer.wrap(y))).buffer),g=this.channel.listen("readFileStream",[f,S])(c=>{if(c instanceof E.VSBuffer)s.write(c.buffer);else{if(c==="end")s.end();else{let y;if(c instanceof Error)y=c;else{const b=c;y=(0,p.createFileSystemProviderError)(b.message??(0,L.toErrorMessage)(b),b.code??p.FileSystemProviderErrorCode.Unknown)}s.error(y),s.end()}g.dispose()}});return v.onCancellationRequested(()=>{s.error((0,r.canceled)()),s.end(),g.dispose()}),s}writeFile(f,S,v){return this.channel.call("writeFile",[f,E.VSBuffer.wrap(S),v])}open(f,S){return this.channel.call("open",[f,S])}close(f){return this.channel.call("close",[f])}async read(f,S,v,s,g){const[c,y]=await this.channel.call("read",[f,S,g]);return v.set(c.buffer.slice(0,y),s),y}write(f,S,v,s,g){return this.channel.call("write",[f,S,E.VSBuffer.wrap(v),s,g])}mkdir(f){return this.channel.call("mkdir",[f])}delete(f,S){return this.channel.call("delete",[f,S])}rename(f,S,v){return this.channel.call("rename",[f,S,v])}copy(f,S,v){return this.channel.call("copy",[f,S,v])}cloneFile(f,S){return this.channel.call("cloneFile",[f,S])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(f=>{if(Array.isArray(f)){const S=f;this._onDidChange.fire(S.map(v=>({resource:u.URI.revive(v.resource),type:v.type})))}else{const S=f;this._onDidWatchError.fire(S)}}))}watch(f,S){const v=(0,l.generateUuid)();return this.channel.call("watch",[this.sessionId,v,f,S]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=m}),define(te[113],ie([0,1,17,13,174,16]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(p,m,w,f,S,v){let s;try{await k(p,m,w,f,S,v)}catch(g){s=g}finally{s&&S.errorTransformer&&(s=S.errorTransformer(s)),typeof s<"u"&&w.error(s),w.end()}}e.readFileIntoStream=D;async function k(p,m,w,f,S,v){u(v);const s=await p.open(m,{create:!1});try{u(v);let g=0,c=0,y=S&&typeof S.length=="number"?S.length:void 0,b=E.VSBuffer.alloc(Math.min(S.bufferSize,typeof y=="number"?y:S.bufferSize)),C=S&&typeof S.position=="number"?S.position:0,t=0;do c=await p.read(s,C,b.buffer,t,b.byteLength-t),C+=c,t+=c,g+=c,typeof y=="number"&&(y-=c),t===b.byteLength&&(await w.write(f(b)),b=E.VSBuffer.alloc(Math.min(S.bufferSize,typeof y=="number"?y:S.bufferSize)),t=0);while(c>0&&(typeof y!="number"||y>0)&&u(v)&&l(g,S));if(t>0){let a=t;typeof y=="number"&&(a=Math.min(t,y)),w.write(f(b.slice(0,a)))}}catch(g){throw(0,A.ensureFileSystemProviderError)(g)}finally{await p.close(s)}}function u(p){if(p.isCancellationRequested)throw(0,L.canceled)();return!0}function l(p,m){if(typeof m?.limits?.size=="number"&&p>m.limits.size)throw(0,A.createFileSystemProviderError)((0,r.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[75],ie([0,1,102,2,9,3,8,16]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function u(g){return g.recursive===!0}e.isRecursiveWatchRequest=u;class l extends L.Disposable{constructor(c,y,b,C){super(),this.onFileChanges=c,this.onLogMessage=y,this.verboseLogging=b,this.options=C,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new L.DisposableStore;this.watcherDisposables.value=c,this.watcher=this.createWatcher(c),this.watcher.setVerboseLogging(this.verboseLogging),c.add(this.watcher.onDidChangeFile(y=>this.onFileChanges(y))),c.add(this.watcher.onDidLogMessage(y=>this.onLogMessage(y))),c.add(this.watcher.onDidError(y=>this.onError(y)))}onError(c){this.options.restartOnError?this.restartCounter<l.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${c}`):this.error(c)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.watcher?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.watcher?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${c}`})}trace(c){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${c}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=l,l.MAX_RESTARTS=5;class p extends l{constructor(c,y,b){super(c,y,b,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=p;class m extends l{constructor(c,y,b){super(c,y,b,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=m;function w(g){return g.map(c=>({type:c.type,resource:D.URI.file(c.path)}))}e.toFileChanges=w;function f(g){const c=new s;for(const y of g)c.processEvent(y);return c.coalesce()}e.coalesceEvents=f;function S(g,c){return typeof c=="string"&&!c.startsWith(E.GLOBSTAR)&&!(0,r.isAbsolute)(c)?{base:g,pattern:c}:c}e.normalizeWatcherPattern=S;function v(g,c){const y=[];for(const b of c)y.push((0,E.parse)(S(g,b)));return y}e.parseWatcherPatterns=v;class s{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(c){return A.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const y=this.mapPathToChange.get(this.toKey(c));let b=!1;if(y){const C=y.type,t=c.type;y.path!==c.path&&(c.type===2||c.type===1)?b=!0:C===1&&t===2?(this.mapPathToChange.delete(this.toKey(c)),this.coalesced.delete(y)):C===2&&t===1?y.type=0:C===1&&t===0||(y.type=t)}else b=!0;b&&(this.coalesced.add(c),this.mapPathToChange.set(this.toKey(c),c))}coalesce(){const c=[],y=[];return Array.from(this.coalesced).filter(b=>b.type!==2?(c.push(b),!1):!0).sort((b,C)=>b.path.length-C.path.length).filter(b=>y.some(C=>(0,k.isParent)(b.path,C,!A.isLinux))?!1:(y.push(b.path),!0)).concat(c)}}}),define(te[209],ie([0,1,41,7,22,32,2,82,9,3,103,24,75]),function(j,e,E,L,r,A,D,k,u,l,p,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends D.Disposable{constructor(s,g,c,y){super(),this.request=s,this.onDidFilesChange=g,this.onLogMessage=c,this.verboseLogging=y,this.throttledFileChangesEmitter=this._register(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},b=>this.onDidFilesChange(b))),this.fileChangesAggregator=this._register(new L.RunOnceWorker(b=>this.handleFileChanges(b),f.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,w.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,w.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new r.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const s=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const g=await m.Promises.stat(s);this._register(await this.doWatch(s,g.isDirectory()))}catch(s){s.code!=="ENOENT"?this.error(s):this.trace(s)}}async normalizePath(s){let g=s.path;try{g=await m.Promises.realpath(s.path),s.path===g&&(g=await(0,p.realcase)(s.path)??s.path),s.path!==g&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${s.path}, real: ${g})`)}catch{}return g}async doWatch(s,g){if(l.isMacintosh&&(0,A.isEqualOrParent)(s,"/Volumes/",!0))return this.error(`Refusing to watch ${s} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const c=new r.CancellationTokenSource(this.cts.token),y=new D.DisposableStore;try{const b=(0,u.basename)(s),C=(0,E.watch)(s);y.add((0,D.toDisposable)(()=>{C.removeAllListeners(),C.close()})),this.trace(`Started watching: '${s}'`);const t=new Set;if(g)try{for(const i of await m.Promises.readdir(s))t.add(i)}catch(i){this.error(i)}const a=new Map;y.add((0,D.toDisposable)(()=>{for(const[,i]of a)i.dispose();a.clear()})),C.on("error",(i,n)=>{this.error(`Failed to watch ${s} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),C.on("change",(i,n)=>{if(c.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),l.isMacintosh&&(o=(0,k.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(g)if(i==="rename"){a.get(o)?.dispose();const d=setTimeout(async()=>{if(a.delete(o),o===b&&!await m.Promises.exists(s)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.existsChildStrictCase((0,u.join)(s,o));if(c.token.isCancellationRequested)return;let I;h?t.has(o)?I=0:(I=1,t.add(o)):(t.delete(o),I=2),this.onFileChange({path:(0,u.join)(this.request.path,o),type:I})},f.FILE_DELETE_HANDLER_DELAY);a.set(o,(0,D.toDisposable)(()=>clearTimeout(d)))}else{let d;t.has(o)?d=0:(d=1,t.add(o)),this.onFileChange({path:(0,u.join)(this.request.path,o),type:d})}else if(i==="rename"||o!==b){const d=setTimeout(async()=>{const h=await m.Promises.exists(s);c.token.isCancellationRequested||(h?(this.onFileChange({path:this.request.path,type:0},!0),y.add(await this.doWatch(s,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},f.FILE_DELETE_HANDLER_DELAY);y.clear(),y.add((0,D.toDisposable)(()=>clearTimeout(d)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(b){await m.Promises.exists(s)&&!c.token.isCancellationRequested&&this.error(`Failed to watch ${s} for changes using fs.watch() (${b.toString()})`)}return(0,D.toDisposable)(()=>{c.dispose(!0),y.dispose()})}onFileChange(s,g=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.path}`),!g&&this.excludes.some(c=>c(s.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${s.path}`):!g&&this.includes&&this.includes.length>0&&!this.includes.some(c=>c(s.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${s.path}`):this.fileChangesAggregator.work(s))}handleFileChanges(s){const g=(0,w.coalesceEvents)(s);if(g.length>0){if(this.verboseLogging)for(const y of g)this.trace(`>> normalized ${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`);this.throttledFileChangesEmitter.work(g)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(s){if(l.isLinux)return m.Promises.exists(s);try{const g=(0,u.basename)(s);return(await m.Promises.readdir((0,u.dirname)(s))).some(y=>y===g)}catch(g){return this.trace(g),!1}}setVerboseLogging(s){this.verboseLogging=s}error(s){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${s}`})}warn(s){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${s}`})}trace(s){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${s}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.FILE_DELETE_HANDLER_DELAY=100,f.FILE_CHANGES_HANDLER_DELAY=75;async function S(v,s,g,c,y=512){const b=await m.Promises.open(v,"r"),C=Buffer.allocUnsafe(y),t=new r.CancellationTokenSource(c);let a,i=!1;const n={path:v,excludes:[],recursive:!1},o=new f(n,d=>{(async()=>{for(const{type:h}of d)if(h===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await m.Promises.read(b,C,0,y,null);if(!I||t.token.isCancellationRequested)break;s(C.slice(0,I))}}catch(I){a=new Error(I),t.dispose(!0)}finally{i=!1}}})()});return await o.ready,g(),new Promise((d,h)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await m.Promises.close(b)}catch(I){a=new Error(I)}a?h(a):d()})})}e.watchFileContents=S}),define(te[210],ie([0,1,4,102,2,3,209]),function(j,e,E,L,r,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends r.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new E.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=E.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(l){const p=this.normalizeRequests(l),m=p.filter(f=>{const S=this.watchers.get(f.path);return S?!(0,L.patternsEquals)(S.request.excludes,f.excludes)||!(0,L.patternsEquals)(S.request.includes,f.includes):!0}),w=Array.from(this.watchers.values()).filter(({request:f})=>!p.find(S=>S.path===f.path&&(0,L.patternsEquals)(S.excludes,f.excludes)&&(0,L.patternsEquals)(S.includes,f.includes))).map(({request:f})=>f.path);m.length&&this.trace(`Request to start watching: ${m.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),w.length&&this.trace(`Request to stop watching: ${w.join(",")}`);for(const f of w)this.stopWatching(f);for(const f of m)this.startWatching(f)}startWatching(l){const p=new D.NodeJSFileWatcherLibrary(l,w=>this._onDidChangeFile.fire(w),w=>this._onDidLogMessage.fire(w),this.verboseLogging),m={request:l,instance:p};this.watchers.set(l.path,m)}async stop(){for(const[l]of this.watchers)this.stopWatching(l);this.watchers.clear()}stopWatching(l){const p=this.watchers.get(l);p&&(this.watchers.delete(l),p.instance.dispose())}normalizeRequests(l){const p=new Map;for(const m of l){const w=A.isLinux?m.path:m.path.toLowerCase();p.set(w,m)}return Array.from(p.values())}async setVerboseLogging(l){this.verboseLogging=l;for(const[,p]of this.watchers)p.instance.setVerboseLogging(l)}trace(l){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(l)})}toMessage(l,p){return p?`[File Watcher (node.js)] ${l} (path: ${p.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=k}),define(te[211],ie([0,1,75,210]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class r extends E.AbstractNonRecursiveWatcherClient{constructor(D,k,u){super(D,k,u),this.init()}createWatcher(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=r}),define(te[212],ie([0,1,14,45,157,75]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends A.AbstractUniversalWatcherClient{constructor(u,l,p){super(u,l,p),this.init()}createWatcher(u){const l=u.add(new r.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(l.onDidProcessExit(({code:p,signal:m})=>this.onError(`terminated by itself with code ${p}, signal: ${m}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(te[90],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...r){this._entries=new Map;for(const[A,D]of r)this.set(A,D)}set(r,A){const D=this._entries.get(r);return this._entries.set(r,A),D}has(r){return this._entries.has(r)}get(r){return this._entries.get(r)}}e.ServiceCollection=E}),define(te[213],ie([0,1,7,13,2,73,203,6,90,100]),function(j,e,E,L,r,A,D,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class m extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class w{constructor(s=new u.ServiceCollection,g=!1,c,y=p){this._services=s,this._strict=g,this._parent=c,this._enableTracing=y,this._activeInstantiations=new Set,this._services.set(k.IInstantiationService,this),this._globalGraph=y?c?._globalGraph??new D.Graph(b=>b):void 0}createChild(s){return new w(s,this._strict,this,this._enableTracing)}invokeFunction(s,...g){const c=S.traceInvocation(this._enableTracing,s);let y=!1;try{return s({get:C=>{if(y)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(C,c);if(!t)throw new Error(`[invokeFunction] unknown service '${C}'`);return t}},...g)}finally{y=!0,c.stop()}}createInstance(s,...g){let c,y;return s instanceof A.SyncDescriptor?(c=S.traceCreation(this._enableTracing,s.ctor),y=this._createInstance(s.ctor,s.staticArguments.concat(g),c)):(c=S.traceCreation(this._enableTracing,s),y=this._createInstance(s,g,c)),c.stop(),y}_createInstance(s,g=[],c){const y=k._util.getServiceDependencies(s).sort((t,a)=>t.index-a.index),b=[];for(const t of y){const a=this._getOrCreateServiceInstance(t.id,c);a||this._throwIfStrict(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),b.push(a)}const C=y.length>0?y[0].index:g.length;if(g.length!==C){console.trace(`[createInstance] First service dependency of ${s.name} at position ${C+1} conflicts with ${g.length} static arguments`);const t=C-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,C)}return Reflect.construct(s,g.concat(b))}_setServiceInstance(s,g){if(this._services.get(s)instanceof A.SyncDescriptor)this._services.set(s,g);else if(this._parent)this._parent._setServiceInstance(s,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){const g=this._services.get(s);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):g}_getOrCreateServiceInstance(s,g){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(s));const c=this._getServiceInstanceOrDescriptor(s);return c instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,c,g.branch(s,!0)):(g.branch(s,!1),c)}_safeCreateAndCacheServiceInstance(s,g,c){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,g,c)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,g,c){const y=new D.Graph(t=>t.id.toString());let b=0;const C=[{id:s,desc:g,_trace:c}];for(;C.length;){const t=C.pop();if(y.lookupOrInsertNode(t),b++>1e3)throw new m(y);for(const a of k._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(a.id);if(i||this._throwIfStrict(`[createInstance] ${s} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof A.SyncDescriptor){const n={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};y.insertEdge(t,n),C.push(n)}}}for(;;){const t=y.roots();if(t.length===0){if(!y.isEmpty())throw new m(y);break}for(const{data:a}of t){if(this._getServiceInstanceOrDescriptor(a.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,n)}y.removeNode(a)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,g,c=[],y,b){if(this._services.get(s)instanceof A.SyncDescriptor)return this._createServiceInstance(s,g,c,y,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,g,c,y,b);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(s,g,c=[],y,b){if(y){const C=new w(void 0,this._strict,this,this._enableTracing);C._globalGraphImplicitDependency=String(s);const t=new Map,a=new E.IdleValue(()=>{const i=C._createInstance(g,c,b);for(const[n,o]of t){const d=i[n];if(typeof d=="function")for(const h of o)d.apply(i,h)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let h=t.get(n);return h||(h=new l.LinkedList,t.set(n,h)),(R,M,T)=>{const W=h.push([R,M,T]);return(0,r.toDisposable)(W)}}if(n in i)return i[n];const o=a.value;let d=o[n];return typeof d!="function"||(d=d.bind(o),i[n]=d),d},set(i,n,o){return a.value[n]=o,!0},getPrototypeOf(i){return g.prototype}})}else return this._createInstance(g,c,b)}_throwIfStrict(s,g){if(g&&console.warn(s),this._strict)throw new Error(s)}}e.InstantiationService=w;var f;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(f||(f={}));class S{static traceInvocation(s,g){return s?new S(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(s,g){return s?new S(1,g.name):S._None}constructor(s,g){this.type=s,this.name=g,this._start=Date.now(),this._dep=[]}branch(s,g){const c=new S(3,s.toString());return this._dep.push([s,g,c]),c}stop(){const s=Date.now()-this._start;S._totals+=s;let g=!1;function c(b,C){const t=[],a=new Array(b+1).join("	");for(const[i,n,o]of C._dep)if(n&&o){g=!0,t.push(`${a}CREATES -> ${i}`);const d=c(b+1,o);d&&t.push(d)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(s>2||g)&&S.all.add(y.join(`
`))}}e.Trace=S,S.all=new Set,S._None=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}},S._totals=0}),define(te[214],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var L;(function(r){r[r.Bug=0]="Bug",r[r.PerformanceIssue=1]="PerformanceIssue",r[r.FeatureRequest=2]="FeatureRequest"})(L||(e.IssueType=L={})),e.IIssueMainService=(0,E.createDecorator)("issueService")}),define(te[5],ie([0,1,49,4,56,2,35,3,18,11,8,204,6]),function(j,e,E,L,r,A,D,k,u,l,p,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function f(){return new Date().toISOString()}function S(R){return(0,l.isNumber)(R)}e.isLogLevel=S;var v;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(v||(e.LogLevel=v={})),e.DEFAULT_LOG_LEVEL=v.Info;function s(R,M,T){switch(M){case v.Trace:R.trace(T);break;case v.Debug:R.debug(T);break;case v.Info:R.info(T);break;case v.Warning:R.warn(T);break;case v.Error:R.error(T);break;case v.Off:break;default:throw new Error(`Invalid log level ${M}`)}}e.log=s;function g(R,M=!1){let T="";for(let W=0;W<R.length;W++){let z=R[W];if(z instanceof Error&&(z=(0,E.toErrorMessage)(z,M)),typeof z=="object")try{z=JSON.stringify(z)}catch{}T+=(W>0?" ":"")+z}return T}class c extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(M){this.level!==M&&(this.level=M,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(M){return this.level!==v.Off&&this.level<=M}}e.AbstractLogger=c;class y extends c{constructor(M){super(),this.logAlways=M}checkLogLevel(M){return this.logAlways||super.checkLogLevel(M)}trace(M,...T){this.checkLogLevel(v.Trace)&&this.log(v.Trace,g([M,...T],!0))}debug(M,...T){this.checkLogLevel(v.Debug)&&this.log(v.Debug,g([M,...T]))}info(M,...T){this.checkLogLevel(v.Info)&&this.log(v.Info,g([M,...T]))}warn(M,...T){this.checkLogLevel(v.Warning)&&this.log(v.Warning,g([M,...T]))}error(M,...T){if(this.checkLogLevel(v.Error))if(M instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=M.stack,this.log(v.Error,g(W))}else this.log(v.Error,g([M,...T]))}flush(){}}e.AbstractMessageLogger=y;class b extends c{constructor(M=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(M),this.useColors=!k.isWindows}trace(M,...T){this.checkLogLevel(v.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...T):console.log(`[main ${f()}]`,M,...T))}debug(M,...T){this.checkLogLevel(v.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...T):console.log(`[main ${f()}]`,M,...T))}info(M,...T){this.checkLogLevel(v.Info)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...T):console.log(`[main ${f()}]`,M,...T))}warn(M,...T){this.checkLogLevel(v.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,M,...T):console.warn(`[main ${f()}]`,M,...T))}error(M,...T){this.checkLogLevel(v.Error)&&(this.useColors?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,M,...T):console.error(`[main ${f()}]`,M,...T))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class C extends c{constructor(M=e.DEFAULT_LOG_LEVEL,T=!0){super(),this.useColors=T,this.setLevel(M)}trace(M,...T){this.checkLogLevel(v.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",M,...T):console.log(M,...T))}debug(M,...T){this.checkLogLevel(v.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",M,...T):console.log(M,...T))}info(M,...T){this.checkLogLevel(v.Info)&&(this.useColors?console.log("%c INFO","color: #33f",M,...T):console.log(M,...T))}warn(M,...T){this.checkLogLevel(v.Warning)&&(this.useColors?console.log("%c WARN","color: #993",M,...T):console.log(M,...T))}error(M,...T){this.checkLogLevel(v.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",M,...T):console.error(M,...T))}dispose(){}flush(){}}e.ConsoleLogger=C;class t extends c{constructor(M,T=e.DEFAULT_LOG_LEVEL){super(),this.adapter=M,this.setLevel(T)}trace(M,...T){this.checkLogLevel(v.Trace)&&this.adapter.log(v.Trace,[this.extractMessage(M),...T])}debug(M,...T){this.checkLogLevel(v.Debug)&&this.adapter.log(v.Debug,[this.extractMessage(M),...T])}info(M,...T){this.checkLogLevel(v.Info)&&this.adapter.log(v.Info,[this.extractMessage(M),...T])}warn(M,...T){this.checkLogLevel(v.Warning)&&this.adapter.log(v.Warning,[this.extractMessage(M),...T])}error(M,...T){this.checkLogLevel(v.Error)&&this.adapter.log(v.Error,[this.extractMessage(M),...T])}extractMessage(M){return typeof M=="string"?M:(0,E.toErrorMessage)(M,this.checkLogLevel(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends c{constructor(M){super(),this.loggers=M,M.length&&this.setLevel(M[0].getLevel())}setLevel(M){for(const T of this.loggers)T.setLevel(M);super.setLevel(M)}trace(M,...T){for(const W of this.loggers)W.trace(M,...T)}debug(M,...T){for(const W of this.loggers)W.debug(M,...T)}info(M,...T){for(const W of this.loggers)W.info(M,...T)}warn(M,...T){for(const W of this.loggers)W.warn(M,...T)}error(M,...T){for(const W of this.loggers)W.error(M,...T)}flush(){for(const M of this.loggers)M.flush()}dispose(){for(const M of this.loggers)M.dispose()}}e.MultiplexLogger=a;class i extends A.Disposable{constructor(M,T,W){if(super(),this.logLevel=M,this.logsHome=T,this._loggers=new D.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,W)for(const z of W)this._loggers.set(z.resource,{logger:void 0,info:z})}getLoggerEntry(M){return(0,l.isString)(M)?[...this._loggers.values()].find(T=>T.info.id===M):this._loggers.get(M)}getLogger(M){return this.getLoggerEntry(M)?.logger}createLogger(M,T){const W=this.toResource(M),z=(0,l.isString)(M)?M:T?.id??(0,r.hash)(W.toString()).toString(16);let H=this._loggers.get(W)?.logger;const J=T?.logLevel==="always"?v.Trace:T?.logLevel;H||(H=this.doCreateLogger(W,J??this.getLogLevel(W)??this.logLevel,{...T,id:z}));const ne={logger:H,info:{resource:W,id:z,logLevel:J,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(ne.info),this._loggers.set(W,ne),H}toResource(M){return(0,l.isString)(M)?(0,u.joinPath)(this.logsHome,`${M}.log`):M}setLogLevel(M,T){if(p.URI.isUri(M)){const W=M,z=T,H=this._loggers.get(W);H&&z!==H.info.logLevel&&(H.info.logLevel=z===this.logLevel?void 0:z,H.logger?.setLevel(z),this._loggers.set(H.info.resource,H),this._onDidChangeLogLevel.fire([W,z]))}else{this.logLevel=M;for(const[W,z]of this._loggers.entries())this._loggers.get(W)?.info.logLevel===void 0&&z.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(M,T){const W=this.getLoggerEntry(M);W&&T!==!W.info.hidden&&(W.info.hidden=!T,this._loggers.set(W.info.resource,W),this._onDidChangeVisibility.fire([W.info.resource,T]))}getLogLevel(M){let T;return M&&(T=this._loggers.get(M)?.info.logLevel),T??this.logLevel}registerLogger(M){const T=this._loggers.get(M.resource);T?T.info.hidden!==M.hidden&&this.setVisibility(M.resource,!M.hidden):(this._loggers.set(M.resource,{info:M,logger:void 0}),this._onDidChangeLoggers.fire({added:[M],removed:[]}))}deregisterLogger(M){const T=this._loggers.get(M);T&&(T.logger&&T.logger.dispose(),this._loggers.delete(M),this._onDidChangeLoggers.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const M of this._loggers.values())yield M.info}getRegisteredLogger(M){return this._loggers.get(M)?.info}dispose(){this._loggers.forEach(M=>M.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=i;class n{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(M){}getLevel(){return v.Info}trace(M,...T){}debug(M,...T){}info(M,...T){}warn(M,...T){}error(M,...T){}critical(M,...T){}dispose(){}flush(){}}e.NullLogger=n;class o extends n{}e.NullLogService=o;function d(R){if(R.verbose)return v.Trace;if(typeof R.logLevel=="string"){const M=I(R.logLevel.toLowerCase());if(M!==void 0)return M}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function h(R){switch(R){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=h;function I(R){switch(R){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=I,e.CONTEXT_LOG_LEVEL=new m.RawContextKey("logLevel",h(v.Info))});var X=this&&this.__param||function(j,e){return function(E,L){e(E,L,j)}};define(te[215],ie([0,1,74,4,2,5,3,7]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let u=e.BaseCredentialsMainService=class ht extends r.Disposable{constructor(p){super(),this.logService=p,this._onDidChangePassword=this._register(new L.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this._sequencer=new k.SequencerByKey}async getPassword(p,m){this.logService.trace("Going to get password from keytar:",p,m);let w;try{w=await this.withKeytar()}catch{return null}return await this._sequencer.queue(p+m,()=>this.doGetPassword(w,p,m))}async doGetPassword(p,m,w){this.logService.trace("Doing get password from keytar:",m,w);const f=await(0,k.retry)(()=>p.getPassword(m,w),50,3);if(!f)return this.logService.trace("Did not get a password from keytar for account:",w),f;let S,v;try{const s=JSON.parse(f);S=s.content,v=s.hasNextChunk}catch{}if(!S||!v)return this.logService.trace("Got password from keytar for account:",w),f;try{let s=1;for(;v;){const g=await(0,k.retry)(()=>p.getPassword(m,`${w}-${s}`),50,3),c=JSON.parse(g);S+=c.content,v=c.hasNextChunk,s++}return this.logService.trace(`Got ${s}-chunked password from keytar for account:`,w),S}catch(s){return this.logService.error(s),f}}async setPassword(p,m,w){this.logService.trace("Going to set password using keytar:",p,m);let f;try{f=await this.withKeytar()}catch(S){throw this.surfaceKeytarLoadError?.(S),S}await this._sequencer.queue(p+m,()=>this.doSetPassword(f,p,m,w)),this._onDidChangePassword.fire({service:p,account:m})}async doSetPassword(p,m,w,f){if(this.logService.trace("Doing set password from keytar:",m,w),!D.isWindows){await(0,k.retry)(()=>p.setPassword(m,w,f),50,3),this.logService.trace("Set password from keytar for account:",w);return}if(await this.doDeletePassword(p,m,w),f.length<=ht.PASSWORD_CHUNK_SIZE){await(0,k.retry)(()=>p.setPassword(m,w,f),50,3),this.logService.trace("Set password from keytar for account:",w);return}let S=0,v=0,s=!0;for(;s;){const g=f.substring(S,S+ht.PASSWORD_CHUNK_SIZE);S+=ht.PASSWORD_CHUNK_SIZE,s=f.length-S>0;const c={content:g,hasNextChunk:s};await(0,k.retry)(()=>p.setPassword(m,v?`${w}-${v}`:w,JSON.stringify(c)),50,3),v++}this.logService.trace(`Set${v?` ${v}-chunked`:""} password from keytar for account:`,w)}async deletePassword(p,m){this.logService.trace("Going to delete password using keytar:",p,m);let w;try{w=await this.withKeytar()}catch(S){throw this.surfaceKeytarLoadError?.(S),S}const f=await this._sequencer.queue(p+m,()=>this.doDeletePassword(w,p,m));return f&&this._onDidChangePassword.fire({service:p,account:m}),f}async doDeletePassword(p,m,w){this.logService.trace("Doing delete password from keytar:",m,w);const f=await p.getPassword(m,w);if(!f)return this.logService.trace("Did not get a password to delete from keytar for account:",w),!1;let S,v;try{const g=JSON.parse(f);S=g.content,v=g.hasNextChunk}catch{}let s=0;if(S&&v)try{for(s++;v;){const g=`${w}-${s}`,c=await p.getPassword(m,g);await p.deletePassword(m,g),v=JSON.parse(c).hasNextChunk,s++}}catch(g){this.logService.error(g)}return await p.deletePassword(m,w)?(this.logService.trace(`Deleted${s?` ${s}-chunked`:""} password from keytar for account:`,w),!0):(this.logService.trace(`Keytar failed to delete${s?` ${s}-chunked`:""} password for account:`,w),!1)}async findPassword(p){let m;try{m=await this.withKeytar()}catch{return null}return await m.findPassword(p)}async findCredentials(p){let m;try{m=await this.withKeytar()}catch{return[]}return await m.findCredentials(p)}clear(){return this._keytarCache instanceof E.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};u.MAX_PASSWORD_LENGTH=2500,u.PASSWORD_CHUNK_SIZE=u.MAX_PASSWORD_LENGTH-100,e.BaseCredentialsMainService=u=ye([X(0,A.ILogService)],u)}),define(te[216],ie([0,1,5]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let L=e.EncryptionMainService=class{constructor(A,D){this.machineId=A,this.logService=D}encryption(){return new Promise((A,D)=>j(["vscode-encrypt"],A,D))}async encrypt(A){let D;try{D=await this.encryption()}catch{return A}try{return D.encrypt(this.machineId,A)}catch(k){return this.logService.error(k),A}}async decrypt(A){let D;try{D=await this.encryption()}catch{return A}try{return D.decrypt(this.machineId,A)}catch(k){return this.logService.error(k),A}}};e.EncryptionMainService=L=ye([X(1,E.ILogService)],L)}),define(te[217],ie([0,1,23,7,13,4,2,9,75,5]),function(j,e,E,L,r,A,D,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class p extends D.Disposable{constructor(w,f){super(),this.logService=w,this.options=f,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(w,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(w,f):this.watchNonRecursive(w,f)}watchUniversal(w,f){const S={path:this.toFilePath(w),excludes:f.excludes,includes:f.includes,recursive:f.recursive},v=(0,E.insert)(this.universalPathsToWatch,S);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(w=>(0,r.onUnexpectedError)(w))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,u.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)})));const w=this.options?.watcher?.recursive?.usePolling;if(w===!0)for(const f of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const f of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(f)&&w.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(w,f){const S={path:this.toFilePath(w),excludes:f.excludes,includes:f.includes,recursive:!1},v=(0,E.insert)(this.nonRecursivePathsToWatch,S);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(w=>(0,r.onUnexpectedError)(w))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(w=>this._onDidChangeFile.fire((0,u.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(w){w.type==="error"&&this._onDidWatchError.fire(w.message),this.logService[w.type](w.message)}toFilePath(w){return(0,k.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=p}),define(te[218],ie([0,1,23,7,17,22,4,56,68,2,61,14,64,18,60,172,16,113,5,13]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let b=e.FileService=class extends l.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(t,a){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${t}`);const i=new l.DisposableStore;return this.provider.set(t,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>this._onDidFilesChange.fire(new s.FileChangesEvent(n,!this.isPathCaseSensitive(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:t}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:a}),this.provider.delete(t),(0,l.dispose)(i)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(i){a.push(i)}}),!this.provider.has(t)&&await L.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,a){const i=this.provider.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return u.Iterable.map(this.provider,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async withProvider(t){if(!(0,f.isAbsolutePath)(t))throw new s.FileOperationError((0,v.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const a=this.provider.get(t.scheme);if(!a){const i=new y.ErrorNoTelemetry;throw i.message=(0,v.localize)(1,null,t.toString()),i}return a}async withReadProvider(t){const a=await this.withProvider(t);if((0,s.hasOpenReadWriteCloseCapability)(a)||(0,s.hasReadWriteCapability)(a)||(0,s.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const a=await this.withProvider(t);if((0,s.hasOpenReadWriteCloseCapability)(a)||(0,s.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.doResolveFile(t,a)}catch(i){throw(0,s.toFileSystemProviderErrorCode)(i)===s.FileSystemProviderErrorCode.FileNotFound?new s.FileOperationError((0,v.localize)(2,null,this.resourceForError(t)),1):(0,s.ensureFileSystemProviderError)(i)}}async doResolveFile(t,a){const i=await this.withProvider(t),n=this.isPathCaseSensitive(i),o=a?.resolveTo,d=a?.resolveSingleChildDescendants,h=a?.resolveMetadata,I=await i.stat(t);let R;return this.toFileStat(i,t,I,void 0,!!h,(M,T)=>(R||(R=p.TernarySearchTree.forUris(()=>!n),R.set(t,!0),o&&R.fill(!0,o)),R.get(M.resource)||R.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&d?T===1:!1))}async toFileStat(t,a,i,n,o,d){const{providerExtUri:h}=this.getExtUri(t),I={resource:a,name:h.basename(a),isFile:(i.type&s.FileType.File)!==0,isDirectory:(i.type&s.FileType.Directory)!==0,isSymbolicLink:(i.type&s.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&s.FilePermission.Readonly)||!!(t.capabilities&2048),etag:(0,s.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&d(I,n)){try{const R=await t.readdir(a),M=await L.Promises.settled(R.map(async([T,W])=>{try{const z=h.joinPath(a,T),H=o?await t.stat(z):{type:W};return await this.toFileStat(t,z,H,R.length,o,d)}catch(z){return this.logService.trace(z),null}}));I.children=(0,E.coalesce)(M)}catch(R){this.logService.trace(R),I.children=[]}return I}return I}async resolveAll(t){return L.Promises.settled(t.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.withProvider(t),i=await a.stat(t);return this.toFileStat(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.withProvider(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.doValidateCreateFile(t,a)}catch(i){return i}return!0}async doValidateCreateFile(t,a){if(!a?.overwrite&&await this.exists(t))throw new s.FileOperationError((0,v.localize)(3,null,this.resourceForError(t)),3,a)}async createFile(t,a=r.VSBuffer.fromString(""),i){await this.doValidateCreateFile(t,i);const n=await this.writeFile(t,a);return this._onDidRunOperation.fire(new s.FileOperationEvent(t,0,n)),n}async writeFile(t,a,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:o}=this.getExtUri(n);try{await this.validateWriteFile(n,t,i)||await this.mkdirp(n,o.dirname(t));let h;if((0,s.hasReadWriteCapability)(n)&&!(a instanceof r.VSBuffer))if((0,S.isReadableStream)(a)){const I=await(0,S.peekStream)(a,3);I.ended?h=r.VSBuffer.concat(I.buffer):h=I}else h=(0,S.peekReadable)(a,I=>r.VSBuffer.concat(I),3);else h=a;!(0,s.hasOpenReadWriteCloseCapability)(n)||(0,s.hasReadWriteCapability)(n)&&h instanceof r.VSBuffer?await this.doWriteUnbuffered(n,t,i,h):await this.doWriteBuffered(n,t,i,h instanceof r.VSBuffer?(0,r.bufferToReadable)(h):h),this._onDidRunOperation.fire(new s.FileOperationEvent(t,4))}catch(d){throw new s.FileOperationError((0,v.localize)(4,null,this.resourceForError(t),(0,s.ensureFileSystemProviderError)(d).toString()),(0,s.toFileOperationResult)(d),i)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,a,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(a)));let o;try{o=await t.stat(a)}catch{return}if(o.type&s.FileType.Directory)throw new s.FileOperationError((0,v.localize)(6,null,this.resourceForError(a)),0,i);if(this.throwIfFileIsReadonly(a,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==s.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,s.etag)({mtime:i.mtime,size:o.size}))throw new s.FileOperationError((0,v.localize)(7,null),3,i);return o}async readFile(t,a,i){const n=await this.withReadProvider(t);return a?.atomic?this.doReadFileAtomic(n,t,a,i):this.doReadFile(n,t,a,i)}async doReadFileAtomic(t,a,i,n){return new Promise((o,d)=>{this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(async()=>{try{const h=await this.doReadFile(t,a,i,n);o(h)}catch(h){d(h)}})})}async doReadFile(t,a,i,n){const o=await this.doReadFileStream(t,a,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,r.streamToBuffer)(o.value)}}async readFileStream(t,a,i){const n=await this.withReadProvider(t);return this.doReadFileStream(n,t,a,i)}async doReadFileStream(t,a,i,n){const o=new A.CancellationTokenSource(n),d=this.validateReadFile(a,i).then(I=>I,I=>{throw o.cancel(),I});let h;try{return typeof i?.etag=="string"&&i.etag!==s.ETAG_DISABLED&&await d,i?.atomic&&(0,s.hasFileAtomicReadCapability)(t)||!((0,s.hasOpenReadWriteCloseCapability)(t)||(0,s.hasFileReadStreamCapability)(t))||(0,s.hasReadWriteCapability)(t)&&i?.preferUnbuffered?h=this.readFileUnbuffered(t,a,i):(0,s.hasFileReadStreamCapability)(t)?h=this.readFileStreamed(t,a,o.token,i):h=this.readFileBuffered(t,a,o.token,i),{...await d,value:h}}catch(I){throw h&&await(0,S.consumeStream)(h),this.restoreReadError(I,a,i)}}restoreReadError(t,a,i){const n=(0,v.localize)(8,null,this.resourceForError(a),(0,s.ensureFileSystemProviderError)(t).toString());return t instanceof s.NotModifiedSinceFileOperationError?new s.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof s.TooLargeFileOperationError?new s.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new s.FileOperationError(n,(0,s.toFileOperationResult)(t),i)}readFileStreamed(t,a,i,n=Object.create(null)){const o=t.readFileStream(a,n,i);return(0,S.transform)(o,{data:d=>d instanceof r.VSBuffer?d:r.VSBuffer.wrap(d),error:d=>this.restoreReadError(d,a,n)},d=>r.VSBuffer.concat(d))}readFileBuffered(t,a,i,n=Object.create(null)){const o=(0,r.newWriteableBufferStream)();return(0,g.readFileIntoStream)(t,a,o,d=>d,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:d=>this.restoreReadError(d,a,n)},i),o}readFileUnbuffered(t,a,i){const n=(0,S.newWriteableStream)(o=>r.VSBuffer.concat(o));return(async()=>{try{let o;i?.atomic&&(0,s.hasFileAtomicReadCapability)(t)?o=await t.readFile(a,{atomic:!0}):o=await t.readFile(a),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.validateReadFileLimits(a,o.byteLength,i),n.end(r.VSBuffer.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async validateReadFile(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new s.FileOperationError((0,v.localize)(9,null,this.resourceForError(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==s.ETAG_DISABLED&&a.etag===i.etag)throw new s.NotModifiedSinceFileOperationError((0,v.localize)(10,null),i,a);return this.validateReadFileLimits(t,i.size,a),i}validateReadFileLimits(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new s.TooLargeFileOperationError((0,v.localize)(11,null,this.resourceForError(t)),7,a,i)}async canMove(t,a,i){return this.doCanMoveCopy(t,a,"move",i)}async canCopy(t,a,i){return this.doCanMoveCopy(t,a,"copy",i)}async doCanMoveCopy(t,a,i,n){if(t.toString()!==a.toString())try{const o=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),d=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(o,t,d,a,i,n)}catch(o){return o}return!0}async move(t,a,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),d=await this.doMoveCopy(n,t,o,a,"move",!!i),h=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new s.FileOperationEvent(t,d==="move"?2:3,h)),h}async copy(t,a,i){const n=await this.withReadProvider(t),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),d=await this.doMoveCopy(n,t,o,a,"copy",!!i),h=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new s.FileOperationEvent(t,d==="copy"?3:2,h)),h}async doMoveCopy(t,a,i,n,o,d){if(a.toString()===n.toString())return o;const{exists:h,isSameResourceWithDifferentPathCase:I}=await this.doValidateMoveCopy(t,a,i,n,o,d);if(h&&!I&&d&&await this.del(n,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),o==="copy"){if(t===i&&(0,s.hasFileFolderCopyCapability)(t))await t.copy(a,n,{overwrite:d});else{const R=await this.resolve(a);R.isDirectory?await this.doCopyFolder(t,R,i,n):await this.doCopyFile(t,a,i,n)}return o}else return t===i?(await t.rename(a,n,{overwrite:d}),o):(await this.doMoveCopy(t,a,i,n,"copy",d),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(t,a,i,n){if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(t,a,i,n);if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(t,a,i,n);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(t,a,i,n);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasReadWriteCapability)(i))return this.doPipeUnbuffered(t,a,i,n)}async doCopyFolder(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async o=>{const d=this.getExtUri(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.doCopyFolder(t,await this.resolve(o.resource),i,d):this.doCopyFile(t,o.resource,i,d)}))}async doValidateMoveCopy(t,a,i,n,o,d){let h=!1;if(t===i){const{providerExtUri:R,isPathCaseSensitive:M}=this.getExtUri(t);if(M||(h=R.isEqual(a,n)),h&&o==="copy")throw new Error((0,v.localize)(12,null,this.resourceForError(a),this.resourceForError(n)));if(!h&&R.isEqualOrParent(n,a))throw new Error((0,v.localize)(13,null,this.resourceForError(a),this.resourceForError(n)))}const I=await this.exists(n);if(I&&!h){if(!d)throw new s.FileOperationError((0,v.localize)(14,null,this.resourceForError(a),this.resourceForError(n)),4);if(t===i){const{providerExtUri:R}=this.getExtUri(t);if(R.isEqualOrParent(a,n))throw new Error((0,v.localize)(15,null,this.resourceForError(a),this.resourceForError(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:h}}getExtUri(t){const a=this.isPathCaseSensitive(t);return{providerExtUri:a?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new s.FileOperationEvent(t,0,i)),i}async mkdirp(t,a){const i=[],{providerExtUri:n}=this.getExtUri(t);for(;!n.isEqual(a,n.dirname(a));)try{if(!((await t.stat(a)).type&s.FileType.Directory))throw new Error((0,v.localize)(16,null,this.resourceForError(a)));break}catch(o){if((0,s.toFileSystemProviderErrorCode)(o)!==s.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(a)),a=n.dirname(a)}for(let o=i.length-1;o>=0;o--){a=n.joinPath(a,i[o]);try{await t.mkdir(a)}catch(d){if((0,s.toFileSystemProviderErrorCode)(d)!==s.FileSystemProviderErrorCode.FileExists)throw d}}}async canDelete(t,a){try{await this.doValidateDelete(t,a)}catch(i){return i}return!0}async doValidateDelete(t,a){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);if(!!a?.useTrash&&!(i.capabilities&4096))throw new Error((0,v.localize)(17,null,this.resourceForError(t)));let o;try{o=await i.stat(t)}catch{}if(o)this.throwIfFileIsReadonly(t,o);else throw new s.FileOperationError((0,v.localize)(18,null,this.resourceForError(t)),1);if(!!!a?.recursive){const h=await this.resolve(t);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,v.localize)(19,null,this.resourceForError(t)))}return i}async del(t,a){const i=await this.doValidateDelete(t,a),n=!!a?.useTrash,o=!!a?.recursive;await i.delete(t,{recursive:o,useTrash:n}),this._onDidRunOperation.fire(new s.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.withProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);if(i===n&&this.getExtUri(i).providerExtUri.isEqual(t,a))return;if(i===n&&(0,s.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(a));const o=this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri);return i===n&&(0,s.hasFileFolderCopyCapability)(i)?o.queue(()=>i.copy(t,a,{overwrite:!0})):o.queue(()=>this.doCopyFile(i,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new l.DisposableStore;let n=!1,o=()=>{n=!0};return i.add((0,l.toDisposable)(()=>o())),(async()=>{try{const d=await this.doWatch(t,a);n?(0,l.dispose)(d):o=()=>(0,l.dispose)(d)}catch(d){this.logService.error(d)}})(),i}async doWatch(t,a){const i=await this.withProvider(t),n=(0,k.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(t),a]);let o=this.activeWatchers.get(n);return o||(o={count:0,disposable:i.watch(t,a)},this.activeWatchers.set(n,o)),o.count+=1,(0,l.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,l.dispose)(o.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,l.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,a,i,n){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(async()=>{const o=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,S.isReadableStream)(n)||(0,S.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(t,o,n):await this.doWriteReadableBufferedQueued(t,o,n)}catch(d){throw(0,s.ensureFileSystemProviderError)(d)}finally{await t.close(o)}})}async doWriteStreamBufferedQueued(t,a,i){let n=0,o;if((0,S.isReadableBufferedStream)(i)){if(i.buffer.length>0){const d=r.VSBuffer.concat(i.buffer);await this.doWriteBuffer(t,a,d,d.byteLength,n,0),n+=d.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((d,h)=>{(0,S.listenStream)(o,{onData:async I=>{o.pause();try{await this.doWriteBuffer(t,a,I,I.byteLength,n,0)}catch(R){return h(R)}n+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>h(I),onEnd:()=>d()})})}async doWriteReadableBufferedQueued(t,a,i){let n=0,o;for(;(o=i.read())!==null;)await this.doWriteBuffer(t,a,o,o.byteLength,n,0),n+=o.byteLength}async doWriteBuffer(t,a,i,n,o,d){let h=0;for(;h<n;){const I=await t.write(a,o+h,i.buffer,d+h,n-h);h+=I}}async doWriteUnbuffered(t,a,i,n){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,a,i,n))}async doWriteUnbufferedQueued(t,a,i,n){let o;n instanceof r.VSBuffer?o=n:(0,S.isReadableStream)(n)?o=await(0,r.streamToBuffer)(n):(0,S.isReadableBufferedStream)(n)?o=await(0,r.bufferedStreamToBuffer)(n):o=(0,r.readableToBuffer)(n),await t.writeFile(a,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(t,a,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,a,i,n))}async doPipeBufferedQueued(t,a,i,n){let o,d;try{o=await t.open(a,{create:!1}),d=await i.open(n,{create:!0,unlock:!1});const h=r.VSBuffer.alloc(this.BUFFER_SIZE);let I=0,R=0,M=0;do M=await t.read(o,I,h.buffer,R,h.byteLength-R),await this.doWriteBuffer(i,d,h,M,I,R),I+=M,R+=M,R===h.byteLength&&(R=0);while(M>0)}catch(h){throw(0,s.ensureFileSystemProviderError)(h)}finally{await L.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof d=="number"?i.close(d):Promise.resolve()])}}async doPipeUnbuffered(t,a,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,a,i,n))}async doPipeUnbufferedQueued(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(t,a,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,a,i,n))}async doPipeUnbufferedToBufferedQueued(t,a,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const d=await t.readFile(a);await this.doWriteBuffer(i,o,r.VSBuffer.wrap(d),d.byteLength,0,0)}catch(d){throw(0,s.ensureFileSystemProviderError)(d)}finally{await i.close(o)}}async doPipeBufferedToUnbuffered(t,a,i,n){const o=await(0,r.streamToBuffer)(this.readFileBuffered(t,a,A.CancellationToken.None));await this.doWriteUnbuffered(i,n,void 0,o)}throwIfFileSystemIsReadonly(t,a){if(t.capabilities&2048)throw new s.FileOperationError((0,v.localize)(20,null,this.resourceForError(a)),6);return t}throwIfFileIsReadonly(t,a){if((a.permissions??0)&s.FilePermission.Readonly)throw new s.FileOperationError((0,v.localize)(21,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===m.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=b=ye([X(0,c.ILogService)],b)}),define(te[91],ie([0,1,41,294,7,35,17,4,32,2,9,3,18,60,24,176,16,113,217,49,212,211]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(E)}catch(a){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(a)}`)}})();class t extends c.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=k.Event.None,this.resourceLocks=new A.ResourceMap(o=>w.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,m.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:o}=await S.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await S.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async d=>{try{let h;d.isSymbolicLink()?h=(await this.stat((0,w.joinPath)(i,d.name))).type:h=this.toType(d),o.push([d.name,h])}catch(h){this.logService.trace(h)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let o;return n?.dangling?o=s.FileType.Unknown:i.isFile()?o=s.FileType.File:i.isDirectory()?o=s.FileType.Directory:o=s.FileType.Unknown,n&&(o|=s.FileType.SymbolicLink),o}async createResourceLock(i){const n=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const d=new r.Barrier;return this.resourceLocks.set(i,d),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===d&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),d.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const d=this.toFilePath(i);return await S.Promises.readFile(d)}catch(d){throw this.toFileSystemProviderError(d)}finally{o?.dispose()}}traceLock(i){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,n,o){const d=(0,f.newWriteableStream)(h=>D.VSBuffer.concat(h.map(I=>D.VSBuffer.wrap(I))).buffer);return(0,g.readFileIntoStream)(this,i,d,h=>h.buffer,{...n,bufferSize:256*1024},o),d}async writeFile(i,n,o){let d;try{const h=this.toFilePath(i);if(!o.create||!o.overwrite){if(await S.Promises.exists(h)){if(!o.overwrite)throw(0,s.createFileSystemProviderError)((0,v.localize)(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,s.createFileSystemProviderError)((0,v.localize)(1,null),s.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(d,0,n,0,n.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(i,h)}finally{typeof d=="number"&&await this.close(d)}}static configureFlushOnWrite(i){t.canFlush=i}async open(i,n){const o=this.toFilePath(i);let d;(0,s.isFileOpenForWriteOptions)(n)&&(d=await this.createResourceLock(i));let h;try{if((0,s.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:R}=await S.SymlinkSupport.stat(o);R.mode&128||await S.Promises.chmod(o,R.mode|128)}catch(R){this.logService.trace(R)}let I;if((0,s.isFileOpenForWriteOptions)(n)){if(m.isWindows)try{await S.Promises.truncate(o,0),I="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}I||(I="w")}else I="r";h=await S.Promises.open(o,I)}catch(I){throw d?.dispose(),(0,s.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,I):this.toFileSystemProviderError(I)}if(this.mapHandleToPos.set(h,0),(0,s.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(h,i),d){const I=this.mapHandleToLock.get(h);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${h} (${o})`),this.mapHandleToLock.set(h,d),I&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${h} (${o})`),I.dispose())}return h}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&t.canFlush)try{await S.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.logService.error(o)}return await S.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,d,h){const I=this.normalizePos(i,n);let R=null;try{R=(await S.Promises.read(i,o,d,h,I)).bytesRead}catch(M){throw this.toFileSystemProviderError(M)}finally{this.updatePos(i,I,R)}return R}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,o){const d=this.mapHandleToPos.get(i);typeof d=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,d+o):this.mapHandleToPos.delete(i)))}async write(i,n,o,d,h){return(0,r.retry)(()=>this.doWrite(i,n,o,d,h),100,3)}async doWrite(i,n,o,d,h){const I=this.normalizePos(i,n);let R=null;try{R=(await S.Promises.write(i,o,d,h,I)).bytesWritten}catch(M){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),M)}finally{this.updatePos(i,I,R)}return R}async mkdir(i){try{await S.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const o=this.toFilePath(i);n.recursive?await S.Promises.rm(o,S.RimRafMode.MOVE):await S.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,n,o){const d=this.toFilePath(i),h=this.toFilePath(n);if(d!==h)try{await this.validateTargetDeleted(i,n,"move",o.overwrite),await S.Promises.move(d,h)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,v.localize)(2,null,(0,p.basename)(d),(0,p.basename)((0,p.dirname)(h)),I.toString()))),this.toFileSystemProviderError(I)}}async copy(i,n,o){const d=this.toFilePath(i),h=this.toFilePath(n);if(d!==h)try{await this.validateTargetDeleted(i,n,"copy",o.overwrite),await S.Promises.copy(d,h,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,v.localize)(3,null,(0,p.basename)(d),(0,p.basename)((0,p.dirname)(h)),I.toString()))),this.toFileSystemProviderError(I)}}async validateTargetDeleted(i,n,o,d){const h=this.toFilePath(i),I=this.toFilePath(n);let R=!1;if(!!(this.capabilities&1024)||(R=(0,u.isEqual)(h,I,!0)),R&&o==="copy")throw(0,s.createFileSystemProviderError)((0,v.localize)(4,null),s.FileSystemProviderErrorCode.FileExists);if(!R&&await S.Promises.exists(I)){if(!d)throw(0,s.createFileSystemProviderError)((0,v.localize)(5,null),s.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,o){const d=this.toFilePath(i),h=this.toFilePath(n),I=!!(this.capabilities&1024);if((0,u.isEqual)(d,h,!I))return;const R=new l.DisposableStore;try{const[M,T]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);R.add(M),R.add(T),o&&await S.Promises.mkdir((0,p.dirname)(h),{recursive:!0}),await S.Promises.copyFile(d,h)}catch(M){if(M.code==="ENOENT"&&!o)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(M)}finally{R.dispose()}}createUniversalWatcher(i,n,o){return new b.UniversalWatcherClient(d=>i(d),d=>n(d),o)}createNonRecursiveWatcher(i,n,o){return new C.NodeJSWatcherClient(d=>i(d),d=>n(d),o)}toFileSystemProviderError(i){if(i instanceof s.FileSystemProviderError)return i;let n=i,o;switch(i.code){case"ENOENT":o=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=s.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=s.FileSystemProviderErrorCode.Unknown;break;default:o=s.FileSystemProviderErrorCode.Unknown}return(0,s.createFileSystemProviderError)(n,o)}async toFileSystemProviderWriteError(i,n){let o=this.toFileSystemProviderError(n);if(i&&o.code===s.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await S.SymlinkSupport.stat(this.toFilePath(i));d.mode&128||(o=(0,s.createFileSystemProviderError)(n,s.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return o}}e.DiskFileSystemProvider=t,t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0}),define(te[219],ie([0,1,4,91,2,17,60,22]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class u extends r.Disposable{constructor(m,w){super(),this.provider=m,this.logService=w,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(m,w,f){const S=this.getUriTransformer(m);switch(w){case"stat":return this.stat(S,f[0]);case"readdir":return this.readdir(S,f[0]);case"open":return this.open(S,f[0],f[1]);case"close":return this.close(f[0]);case"read":return this.read(f[0],f[1],f[2]);case"readFile":return this.readFile(S,f[0],f[1]);case"write":return this.write(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.writeFile(S,f[0],f[1],f[2]);case"rename":return this.rename(S,f[0],f[1],f[2]);case"copy":return this.copy(S,f[0],f[1],f[2]);case"cloneFile":return this.cloneFile(S,f[0],f[1]);case"mkdir":return this.mkdir(S,f[0]);case"delete":return this.delete(S,f[0],f[1]);case"watch":return this.watch(S,f[0],f[1],f[2],f[3]);case"unwatch":return this.unwatch(f[0],f[1])}throw new Error(`IPC Command ${w} not found`)}listen(m,w,f){const S=this.getUriTransformer(m);switch(w){case"fileChange":return this.onFileChange(S,f[0]);case"readFileStream":return this.onReadFileStream(S,f[0],f[1])}throw new Error(`Unknown event ${w}`)}stat(m,w){const f=this.transformIncoming(m,w,!0);return this.provider.stat(f)}readdir(m,w){const f=this.transformIncoming(m,w);return this.provider.readdir(f)}async readFile(m,w,f){const S=this.transformIncoming(m,w,!0),v=await this.provider.readFile(S,f);return A.VSBuffer.wrap(v)}onReadFileStream(m,w,f){const S=this.transformIncoming(m,w,!0),v=new k.CancellationTokenSource,s=new E.Emitter({onDidRemoveLastListener:()=>{v.cancel()}}),g=this.provider.readFileStream(S,f,v.token);return(0,D.listenStream)(g,{onData:c=>s.fire(A.VSBuffer.wrap(c)),onError:c=>s.fire(c),onEnd:()=>{s.fire("end"),s.dispose(),v.dispose()}}),s.event}writeFile(m,w,f,S){const v=this.transformIncoming(m,w);return this.provider.writeFile(v,f.buffer,S)}open(m,w,f){const S=this.transformIncoming(m,w,!0);return this.provider.open(S,f)}close(m){return this.provider.close(m)}async read(m,w,f){const S=A.VSBuffer.alloc(f),v=0,s=await this.provider.read(m,w,S.buffer,v,f);return[S,s]}write(m,w,f,S,v){return this.provider.write(m,w,f.buffer,S,v)}mkdir(m,w){const f=this.transformIncoming(m,w);return this.provider.mkdir(f)}delete(m,w,f){const S=this.transformIncoming(m,w);return this.provider.delete(S,f)}rename(m,w,f,S){const v=this.transformIncoming(m,w),s=this.transformIncoming(m,f);return this.provider.rename(v,s,S)}copy(m,w,f,S){const v=this.transformIncoming(m,w),s=this.transformIncoming(m,f);return this.provider.copy(v,s,S)}cloneFile(m,w,f){const S=this.transformIncoming(m,w),v=this.transformIncoming(m,f);return this.provider.cloneFile(S,v)}onFileChange(m,w){const f=new E.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(w,this.createSessionFileWatcher(m,f))},onDidRemoveLastListener:()=>{(0,r.dispose)(this.sessionToWatcher.get(w)),this.sessionToWatcher.delete(w)}});return f.event}async watch(m,w,f,S,v){const s=this.sessionToWatcher.get(w);if(s){const g=this.transformIncoming(m,S),c=s.watch(f,g,v);this.watchRequests.set(w+f,c)}}async unwatch(m,w){const f=m+w,S=this.watchRequests.get(f);S&&((0,r.dispose)(S),this.watchRequests.delete(f))}dispose(){super.dispose();for(const[,m]of this.watchRequests)m.dispose();this.watchRequests.clear();for(const[,m]of this.sessionToWatcher)m.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=u;class l extends r.Disposable{constructor(m,w,f,S){super(),this.uriTransformer=m,this.logService=f,this.environmentService=S,this.watcherRequests=new Map,this.fileWatcher=this._register(new L.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(w)}registerListeners(m){const w=this._register(new E.Emitter);this._register(w.event(f=>{m.fire(f.map(S=>({resource:this.uriTransformer.transformOutgoingURI(S.resource),type:S.type})))})),this._register(this.fileWatcher.onDidChangeFile(f=>w.fire(f))),this._register(this.fileWatcher.onDidWatchError(f=>m.fire(f)))}getRecursiveWatcherOptions(m){}getExtraExcludes(m){}watch(m,w,f){const S=this.getExtraExcludes(this.environmentService);return Array.isArray(S)&&(f.excludes=[...f.excludes,...S]),this.watcherRequests.set(m,this.fileWatcher.watch(w,f)),(0,r.toDisposable)(()=>{(0,r.dispose)(this.watcherRequests.get(m)),this.watcherRequests.delete(m)})}dispose(){super.dispose();for(const[,m]of this.watcherRequests)m.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=l}),define(te[220],ie([0,1,15,175,3,8,16,9,219,150]),function(j,e,E,L,r,A,D,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class p extends u.AbstractDiskFileSystemProviderChannel{constructor(f,S,v){super(f,S),this.environmentService=v}getUriTransformer(f){return l.DefaultURITransformer}transformIncoming(f,S){return A.URI.revive(S)}async delete(f,S,v){if(!v.useTrash)return super.delete(f,S,v);const s=this.transformIncoming(f,S),g=(0,k.normalize)(s.fsPath);try{await E.shell.trashItem(g)}catch{throw(0,D.createFileSystemProviderError)(r.isWindows?(0,L.localize)(0,null,(0,k.basename)(g)):(0,L.localize)(1,null,(0,k.basename)(g)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(f,S){return new m(f,S,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=p;class m extends u.AbstractSessionFileWatcher{watch(f,S,v){if(v.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(f,S,v)}}}),define(te[221],ie([0,1,5]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends E.AbstractMessageLogger{constructor(A=E.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(A),this._register(this.onDidChangeLogLevel(D=>{this._logger?.setLevel(D)}))}set logger(A){this._logger=A;for(const{level:D,message:k}of this.buffer)(0,E.log)(A,D,k);this.buffer=[]}log(A,D){this._logger?(0,E.log)(this._logger,A,D):this.getLevel()<=A&&this.buffer.push({level:A,message:D})}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=L}),define(te[222],ie([0,1,2,5]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class r extends E.Disposable{constructor(D,k=[]){super(),this.logger=new L.MultiplexLogger([D,...k]),this._register(D.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(D){this.logger.setLevel(D)}getLevel(){return this.logger.getLevel()}trace(D,...k){this.logger.trace(D,...k)}debug(D,...k){this.logger.debug(D,...k)}info(D,...k){this.logger.info(D,...k)}warn(D,...k){this.logger.warn(D,...k)}error(D,...k){this.logger.error(D,...k)}flush(){this.logger.flush()}}e.LogService=r}),define(te[223],ie([0,1,35,8,5]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class A{constructor(k){this.loggerService=k,this.loggers=new E.ResourceMap}listen(k,u,l){switch(u){case"onDidChangeLoggers":return l?this.loggerService.getOnDidChangeLoggersEvent(l):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.loggerService.getOnDidChangeLogLevelEvent(l):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.loggerService.getOnDidChangeVisibilityEvent(l):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${u}`)}async call(k,u,l){switch(u){case"createLogger":this.createLogger(L.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.log(L.URI.revive(l[0]),l[1]);case"consoleLog":return this.consoleLog(l[0],l[1]);case"setLogLevel":return(0,r.isLogLevel)(l[0])?this.loggerService.setLogLevel(l[0]):this.loggerService.setLogLevel(L.URI.revive(l[0]),l[1]);case"setVisibility":return this.loggerService.setVisibility(L.URI.revive(l[0]),l[1]);case"registerLogger":return this.loggerService.registerLogger({...l[0],resource:L.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(L.URI.revive(l[0]))}throw new Error(`Call not found: ${u}`)}createLogger(k,u,l){this.loggers.set(k,this.loggerService.createLogger(k,u,l))}consoleLog(k,u){let l=console.log;switch(k){case r.LogLevel.Error:l=console.error;break;case r.LogLevel.Warning:l=console.warn;break;case r.LogLevel.Info:l=console.info;break}l.call(console,...u)}log(k,u){const l=this.loggers.get(k);if(!l)throw new Error("Create the logger before logging");for(const[p,m]of u)(0,r.log)(l,p,m)}}e.LoggerChannel=A}),define(te[224],ie([0,1,16,5]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var r;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(r||(r={}));async function A(l,p,m,w,f){try{const S=await new Promise((s,g)=>{j(["@vscode/spdlog"],s,g)});S.setFlushOn(r.Trace);const v=await S.createAsyncRotatingLogger(l,p,m,w);return f?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(S){console.error(S)}return null}function D(l,p,m){switch(p){case L.LogLevel.Trace:l.trace(m);break;case L.LogLevel.Debug:l.debug(m);break;case L.LogLevel.Info:l.info(m);break;case L.LogLevel.Warning:l.warn(m);break;case L.LogLevel.Error:l.error(m);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function k(l,p){switch(p){case L.LogLevel.Trace:l.setLevel(r.Trace);break;case L.LogLevel.Debug:l.setLevel(r.Debug);break;case L.LogLevel.Info:l.setLevel(r.Info);break;case L.LogLevel.Warning:l.setLevel(r.Warning);break;case L.LogLevel.Error:l.setLevel(r.Error);break;case L.LogLevel.Off:l.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class u extends L.AbstractMessageLogger{constructor(p,m,w,f,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(p,m,w,f),this._register(this.onDidChangeLogLevel(v=>{this._logger&&k(this._logger,v)}))}async _createSpdLogLogger(p,m,w,f){const S=w?6:1,v=30/S*E.ByteSize.MB,s=await A(p,m,v,S,f);if(s){this._logger=s,k(this._logger,this.getLevel());for(const{level:g,message:c}of this.buffer)D(this._logger,g,c);this.buffer=[]}}log(p,m){this._logger?D(this._logger,p,m):this.getLevel()<=p&&this.buffer.push({level:p,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=u}),define(te[225],ie([0,1,31,5,224]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends L.AbstractLoggerService{doCreateLogger(k,u,l){return new r.SpdLogLogger((0,E.generateUuid)(),k.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,u)}}e.LoggerService=A}),define(te[65],ie([0,1,35,4,6,5,225]),function(j,e,E,L,r,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,r.refineServiceDecorator)(A.ILoggerService);class k extends D.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new E.ResourceMap}createLogger(l,p,m){m!==void 0&&this.loggerResourcesByWindow.set(this.toResource(l),m);try{return super.createLogger(l,p)}catch(w){throw this.loggerResourcesByWindow.delete(this.toResource(l)),w}}registerLogger(l,p){p!==void 0&&this.loggerResourcesByWindow.set(l.resource,p),super.registerLogger(l)}deregisterLogger(l){this.loggerResourcesByWindow.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const p=[];for(const m of super.getRegisteredLoggers())l===this.loggerResourcesByWindow.get(m.resource)&&p.push(m);return p}getOnDidChangeLogLevelEvent(l){return L.Event.filter(this.onDidChangeLogLevel,p=>(0,A.isLogLevel)(p)||this.isInterestedLoggerResource(p[0],l))}getOnDidChangeVisibilityEvent(l){return L.Event.filter(this.onDidChangeVisibility,([p])=>this.isInterestedLoggerResource(p,l))}getOnDidChangeLoggersEvent(l){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,p=>({added:[...p.added].filter(w=>this.isInterestedLoggerResource(w.resource,l)),removed:[...p.removed].filter(w=>this.isInterestedLoggerResource(w.resource,l))})),p=>p.added.length>0||p.removed.length>0)}deregisterLoggers(l){for(const[p,m]of this.loggerResourcesByWindow)m===l&&this.deregisterLogger(p)}isInterestedLoggerResource(l,p){const m=this.loggerResourcesByWindow.get(l);return m===void 0||m===p}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=k}),define(te[226],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function L(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function r(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=r;function A(D){return!E(D)&&!L(D)&&!r(D)}e.isMenubarMenuItemAction=A}),define(te[37],ie([0,1,4,68,2,6]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class D extends r.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(l){const p=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},p!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(l),L.Iterable.reduce(this.policies.entries(),(m,[w,f])=>({...m,[w]:f}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return L.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[p,m])=>({...l,[p]:{definition:m,value:this.policies.get(p)}}),{})}}e.AbstractPolicyService=D;class k{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(te[227],ie([0,1,7,4,68,11,16,5,37]),function(j,e,E,L,r,A,D,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(m,w){const f=[];for(const S of new Set(r.Iterable.concat(m.keys(),w.keys())))m.get(S)!==w.get(S)&&f.push(S);return f}let p=e.FilePolicyService=class extends u.AbstractPolicyService{constructor(w,f,S){super(),this.file=w,this.fileService=f,this.logService=S,this.throttledDelayer=this._register(new E.ThrottledDelayer(500));const v=L.Event.filter(f.onDidFilesChange,s=>s.affects(w));this._register(f.watch(w)),this._register(v(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const w=new Map;try{const f=await this.fileService.readFile(this.file),S=JSON.parse(f.value.toString());if(!(0,A.isObject)(S))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(S))this.policyDefinitions[v]&&w.set(v,S[v])}catch(f){f.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",f)}return w}async refresh(){const w=await this.read(),f=l(this.policies,w);this.policies=w,f.length>0&&this._onDidChange.fire(f)}};e.FilePolicyService=p=ye([X(1,D.IFileService),X(2,k.ILogService)],p)}),define(te[228],ie([0,1,4,2,37]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(u){this.service=u,this.disposables=new L.DisposableStore}listen(u,l){switch(l){case"onDidChange":return E.Event.map(this.service.onDidChange,p=>p.reduce((m,w)=>({...m,[w]:this.service.getPolicyValue(w)??null}),{}),this.disposables)}throw new Error(`Event not found: ${l}`)}call(u,l,p){switch(l){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${l}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=A;class D extends r.AbstractPolicyService{constructor(u,l){super(),this.channel=l;for(const p in u){const{definition:m,value:w}=u[p];this.policyDefinitions[p]=m,w!==void 0&&this.policies.set(p,w)}this.channel.listen("onDidChange")(p=>{for(const m in p){const w=p[m];w===null?this.policies.delete(m):this.policies.set(m,w)}this._onDidChange.fire(Object.keys(p))})}async _updatePolicyDefinitions(u){const l=await this.channel.call("updatePolicyDefinitions",u);for(const p in l)this.policies.set(p,l[p])}}e.PolicyChannelClient=D}),define(te[229],ie([0,1,37,7,295,2,5]),function(j,e,E,L,r,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=e.NativePolicyService=class extends E.AbstractPolicyService{constructor(l,p){super(),this.logService=l,this.productName=p,this.throttler=new L.Throttler,this.watcher=this._register(new A.MutableDisposable)}async _updatePolicyDefinitions(l){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.throttler.queue(()=>new Promise((p,m)=>{try{this.watcher.value=(0,r.createWatcher)(this.productName,l,w=>{this._onDidPolicyChange(w),p()})}catch(w){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",w),m(w)}}))}_onDidPolicyChange(l){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const p in l){const m=l[p];m===void 0?this.policies.delete(p):this.policies.set(p,m)}this._onDidChange.fire(Object.keys(l))}};e.NativePolicyService=k=ye([X(0,D.ILogService)],k)}),define(te[76],ie([0,1,14,3,36,108]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.context<"u"){const k=L.globals.vscode.context.configuration();if(k)D=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){D=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:k,searchUrl:u,itemUrl:l,controlUrl:p}=D.extensionsGallery||{};Object.assign(D,{extensionsGallery:{serviceUrl:r.env.VSCODE_GALLERY_SERVICE_URL||k,searchUrl:r.env.VSCODE_GALLERY_SEARCH_URL||u,itemUrl:r.env.VSCODE_GALLERY_ITEM_URL||l,controlUrl:r.env.VSCODE_GALLERY_CONTROL_URL||p}});try{const m=(...v)=>v.reduce((s,g)=>(Object.keys(g).forEach(c=>{Array.isArray(s[c])&&Array.isArray(g[c])?s[c]=g[c]:typeof s[c]=="object"&&typeof g[c]=="object"?s[c]=m(s[c],g[c]):s[c]=g[c]}),s),{}),w=(0,A.getUserDataPath)({},D.nameShort),f=L.isWindows?`file:///${w}/product.json`:`file://${w}/product.json`,S=j.__$__nodeRequire(E.FileAccess.asFileUri(f).fsPath);D=m(D,S)}catch{}if(r.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const m=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:m.version,release:m.release})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(te[21],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[230],ie([0,1,69,5,21]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let A=e.ExtensionUrlTrustService=class{constructor(k,u){this.productService=k,this.logService=u,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(k,u){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const l=/^(.*)#([^#]+)$/.exec(u);if(!l)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",u),!1;const[,p,m]=l;let w=this.trustedExtensionUrlPublicKeys.get(k);if(!w){if(w=this.productService.trustedExtensionUrlPublicKeys[k],!w||w.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.trustedExtensionUrlPublicKeys.set(k,[...w])}const f=Buffer.from(decodeURIComponent(m),"base64");if(f.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",u),!1;const S=f.slice(0,6),v=f.readUIntBE(0,6),s=Date.now()-v;if(s<0||s>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",u),!1;const g=f.slice(6),c=E.createVerify("SHA256");c.write(S),c.write(Buffer.from(p)),c.end();for(let y=0;y<w.length;y++){let b=w[y];if(b!==null){if(typeof b=="string")try{b=E.createPublicKey({key:Buffer.from(b,"base64"),format:"der",type:"spki"}),w[y]=b}catch(C){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${y+1} for ${k}:`,C),w[y]=null;continue}if(c.verify(b,g))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",u),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",u),!1}};e.ExtensionUrlTrustService=A=ye([X(0,r.IProductService),X(1,L.ILogService)],A)}),define(te[231],ie([0,1,7,5]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let r=e.WindowProfiler=class{constructor(D,k,u){this._window=D,this._sessionId=k,this._logService=u}async inspect(D){await this._connect();const k=this._window.webContents.debugger;await k.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,E.timeout)(D);const u=await k.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),u.profile}async _connect(){const D=this._window.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async _disconnect(){const D=this._window.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.WindowProfiler=r=ye([X(2,L.ILogService)],r)}),define(te[77],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(te[51],ie([0,1,128,11]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class r{constructor(){this.data=new Map}add(D,k){E.ok(L.isString(D)),E.ok(L.isObject(k)),E.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,k)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new r}),define(te[232],ie([0,1,4,51]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function r(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new E.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,l){this.schemasById[r(u)]=l,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new A;L.Registry.add(e.Extensions.JSONContribution,D)}),define(te[66],ie([0,1,23,4,11,160,19,232,51]),function(j,e,E,L,r,A,D,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p||(e.ConfigurationScope=p={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const m=u.Registry.as(k.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.doRegisterConfigurations(t,a,i),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.doDeregisterConfigurations(t,a),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.doDeregisterConfigurations(a,i),this.doRegisterConfigurations(t,!1,i),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.doRegisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,a){const i=[];for(const{overrides:n,source:o}of t)for(const d in n)if(a.add(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const h=this.configurationDefaultsOverrides.get(d),I=h?.valuesSources??new Map;if(o)for(const W of Object.keys(n[d]))I.set(W,o);const R={...h?.value||{},...n[d]};this.configurationDefaultsOverrides.set(d,{source:o,value:R,valuesSources:I});const M=(0,D.getLanguageTagSettingPlainKey)(d),T={type:"object",default:R,description:A.localize(1,null,M),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:r.isString(o)?void 0:o,defaultValueSource:o};i.push(...v(d)),this.configurationProperties[d]=T,this.defaultLanguageConfigurationOverridesNode.properties[d]=T}else{this.configurationDefaultsOverrides.set(d,{value:n[d],source:o});const h=this.configurationProperties[d];h&&(this.updatePropertyDefaultValue(d,h),this.updateSchema(d,h))}this.doRegisterOverrideIdentifiers(i)}deregisterDefaultConfigurations(t){const a=new Set;this.doDeregisterDefaultConfigurations(t,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,a){for(const{overrides:i,source:n}of t)for(const o in i){const d=this.configurationDefaultsOverrides.get(o),h=r.isString(n)?n:n?.id,I=r.isString(d?.source)?d?.source:d?.source?.id;if(h===I)if(a.add(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const R=this.configurationProperties[o];R&&(this.updatePropertyDefaultValue(o,R),this.updateSchema(o,R))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,i),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const a of t)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,a,i){t.forEach(n=>{this.validateAndRegisterProperties(n,a,n.extensionInfo,n.restrictedProperties,void 0,i),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(t,a){const i=n=>{if(n.properties)for(const o in n.properties){a.add(o);const d=this.configurationProperties[o];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of t){i(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}}validateAndRegisterProperties(t,a=!0,i,n,o=3,d){o=r.isUndefinedOrNull(t.scope)?o:t.scope;const h=t.properties;if(h)for(const R in h){const M=h[R];if(a&&y(R,M)){delete h[R];continue}if(M.source=i,M.defaultDefaultValue=h[R].default,this.updatePropertyDefaultValue(R,M),e.OVERRIDE_PROPERTY_REGEX.test(R)?M.scope=void 0:(M.scope=r.isUndefinedOrNull(M.scope)?o:M.scope,M.restricted=r.isUndefinedOrNull(M.restricted)?!!n?.includes(R):M.restricted),h[R].hasOwnProperty("included")&&!h[R].included){this.excludedConfigurationProperties[R]=h[R],delete h[R];continue}else this.configurationProperties[R]=h[R],h[R].policy?.name&&this.policyConfigurations.set(h[R].policy.name,R);!h[R].deprecationMessage&&h[R].markdownDeprecationMessage&&(h[R].deprecationMessage=h[R].markdownDeprecationMessage),d.add(R)}const I=t.allOf;if(I)for(const R of I)this.validateAndRegisterProperties(R,a,i,n,o,d)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const a=i=>{const n=i.properties;if(n)for(const d in n)this.updateSchema(d,n[d]);i.allOf?.forEach(a)};a(t)}updateSchema(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.resourceLanguageSettingsSchema.properties[t]=a;break}}removeFromSchema(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const a=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,a){const i=this.configurationDefaultsOverrides.get(t);let n=i?.value,o=i?.source;r.isUndefined(n)&&(n=a.defaultDefaultValue,o=void 0),r.isUndefined(n)&&(n=g(a.type)),a.default=n,a.defaultValueSource=o}}const f="\\[([^\\]]+)\\]",S=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(C){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(C)){let a=S.exec(C);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=S.exec(C)}}return(0,E.distinct)(t)}e.overrideIdentifiersFromKey=v;function s(C){return C.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=s;function g(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const c=new w;u.Registry.add(e.Extensions.Configuration,c);function y(C,t){return C.trim()?e.OVERRIDE_PROPERTY_REGEX.test(C)?A.localize(7,null,C):c.getConfigurationProperties()[C]!==void 0?A.localize(8,null,C):t.policy?.name&&c.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,C,t.policy?.name,c.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=y;function b(){const C=[],t=c.getConfigurationProperties();for(const a of Object.keys(t))C.push([a,t[a].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=b}),define(te[114],ie([0,1,23,4,43,2,35,40,11,8,19,66,51]),function(j,e,E,L,r,A,D,k,u,l,p,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(a){return Object.isFrozen(a)?a:k.deepFreeze(a)}class S{constructor(i={},n=[],o=[],d){this._contents=i,this._keys=n,this._overrides=o,this.raw=d,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof S)return n;const o=new v("");return o.parseRaw(n),o.configurationModel});this._rawConfiguration=i.reduce((n,o)=>o===n?o:n.merge(o),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,p.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const o=this.rawConfiguration.getValue(i),d=n?this.rawConfiguration.getOverrideValue(i,n):void 0,h=n?this.rawConfiguration.override(n).getValue(i):o;return{value:o,override:d,merged:h}}getOverrideValue(i,n){const o=this.getContentsForOverrideIdentifer(n);return o?i?(0,p.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return E.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return E.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=k.deepClone(this.contents),o=k.deepClone(this.overrides),d=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const I of i)if(h.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.mergeContents(n,I.contents);for(const R of I.overrides){const[M]=o.filter(T=>E.equals(T.identifiers,R.identifiers));M?(this.mergeContents(M.contents,R.contents),M.keys.push(...R.keys),M.keys=E.distinct(M.keys)):o.push(k.deepClone(R))}for(const R of I.keys)d.indexOf(R)===-1&&d.push(R)}return new S(n,d,o,h.every(I=>I instanceof S)?void 0:h)}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const d of E.distinct([...Object.keys(this.contents),...Object.keys(n)])){let h=this.contents[d];const I=n[d];I&&(typeof h=="object"&&typeof I=="object"?(h=k.deepClone(h),this.mergeContents(h,I)):h=I),o[d]=h}return new S(o,this.keys,this.overrides)}mergeContents(i,n){for(const o of Object.keys(n)){if(o in i&&u.isObject(i[o])&&u.isObject(n[o])){this.mergeContents(i[o],n[o]);continue}i[o]=k.deepClone(n[o])}}getContentsForOverrideIdentifer(i){let n=null,o=null;const d=h=>{h&&(o?this.mergeContents(o,h):o=k.deepClone(h))};for(const h of this.overrides)E.equals(h.identifiers,[i])?n=h.contents:h.identifiers.includes(i)&&d(h.contents);return d(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.updateValue(i,n,!0)}setValue(i,n){this.updateValue(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,p.removeFromValueTree)(this.contents,i),m.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>E.equals(o.identifiers,(0,m.overrideIdentifiersFromKey)(i))),1))}updateValue(i,n,o){(0,p.addToValueTree)(this.contents,i,n,d=>console.error(d)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),m.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,m.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,p.toValuesTree)(this.contents[i],d=>console.error(d))})}}e.ConfigurationModel=S;class v{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!u.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:o,keys:d,overrides:h,restricted:I,hasExcludedProperties:R}=this.doParseRaw(i,n);this._configurationModel=new S(o,d,h,R?[i]:void 0),this._restrictedConfigurations=I||[]}doParseContent(i){let n={},o=null,d=[];const h=[],I=[];function R(T){Array.isArray(d)?d.push(T):o!==null&&(d[o]=T)}const M={onObjectBegin:()=>{const T={};R(T),h.push(d),d=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{d=h.pop()},onArrayBegin:()=>{const T=[];R(T),h.push(d),d=T,o=null},onArrayEnd:()=>{d=h.pop()},onLiteralValue:R,onError:(T,W,z)=>{I.push({error:T,offset:W,length:z})}};if(i)try{r.visit(i,M),n=d[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return n}doParseRaw(i,n){const o=w.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),d=this.filter(i,o,!0,n);i=d.raw;const h=(0,p.toValuesTree)(i,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),I=Object.keys(i),R=this.toOverrides(i,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:h,keys:I,overrides:R,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}filter(i,n,o,d){let h=!1;if(!d?.scopes&&!d?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:h};const I={},R=[];for(const M in i)if(m.OVERRIDE_PROPERTY_REGEX.test(M)&&o){const T=this.filter(i[M],n,!1,d);I[M]=T.raw,h=h||T.hasExcludedProperties,R.push(...T.restricted)}else{const T=n[M],W=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&R.push(M),(W===void 0||d.scopes===void 0||d.scopes.includes(W))&&!(d.skipRestricted&&T?.restricted)?I[M]=i[M]:h=!0}return{raw:I,restricted:R,hasExcludedProperties:h}}toOverrides(i,n){const o=[];for(const d of Object.keys(i))if(m.OVERRIDE_PROPERTY_REGEX.test(d)){const h={};for(const I in i[d])h[I]=i[d][I];o.push({identifiers:(0,m.overrideIdentifiersFromKey)(d),keys:Object.keys(h),contents:(0,p.toValuesTree)(h,n)})}return o}}e.ConfigurationModelParser=v;class s extends A.Disposable{constructor(i,n,o,d){super(),this.userSettingsResource=i,this.scopes=n,this.fileService=d,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,h=>(h.isOperation(0)||h.isOperation(3)||h.isOperation(1)||h.isOperation(4))&&o.isEqual(h.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=s;class g{constructor(i,n,o,d,h,I,R,M,T,W,z,H,J){this.key=i,this.overrides=n,this._value=o,this.overrideIdentifiers=d,this.defaultConfiguration=h,this.policyConfiguration=I,this.applicationConfiguration=R,this.userConfiguration=M,this.localUserConfiguration=T,this.remoteUserConfiguration=W,this.workspaceConfiguration=z,this.folderConfigurationModel=H,this.memoryConfigurationModel=J}get value(){return f(this._value)}inspect(i,n,o){const d=i.inspect(n,o);return{get value(){return f(d.value)},get override(){return f(d.override)},get merged(){return f(d.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class c{constructor(i,n,o,d,h=new S,I=new S,R=new D.ResourceMap,M=new S,T=new D.ResourceMap){this._defaultConfiguration=i,this._policyConfiguration=n,this._applicationConfiguration=o,this._localUserConfiguration=d,this._remoteUserConfiguration=h,this._workspaceConfiguration=I,this._folderConfigurations=R,this._memoryConfiguration=M,this._memoryConfigurationByResource=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(i,n,o){return this.getConsolidatedConfigurationModel(i,n,o).getValue(i)}updateValue(i,n,o={}){let d;o.resource?(d=this._memoryConfigurationByResource.get(o.resource),d||(d=new S,this._memoryConfigurationByResource.set(o.resource,d))):d=this._memoryConfiguration,n===void 0?d.removeValue(i):d.setValue(i,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,o){const d=this.getConsolidatedConfigurationModel(i,n,o),h=this.getFolderConfigurationModelForResource(n.resource,o),I=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,R=new Set;for(const M of d.overrides)for(const T of M.identifiers)d.getOverrideValue(i,T)!==void 0&&R.add(T);return new g(i,n,d.getValue(i),R.size?[...R]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this._workspaceConfiguration:void 0,h||void 0,I)}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:d,updated:h,removed:I}=C(this._defaultConfiguration,i);n=[...d,...h,...I]}for(const d of n)for(const h of(0,m.overrideIdentifiersFromKey)(d)){const I=this._defaultConfiguration.getKeysForOverrideIdentifier(h),R=i.getKeysForOverrideIdentifier(h),M=[...R.filter(T=>I.indexOf(T)===-1),...I.filter(T=>R.indexOf(T)===-1),...I.filter(T=>!k.equals(this._defaultConfiguration.override(h).getValue(T),i.override(h).getValue(T)))];o.push([h,M])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:o,removed:d}=C(this._policyConfiguration,i),h=[...n,...o,...d];return h.length&&this.updatePolicyConfiguration(i),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:o,removed:d,overrides:h}=C(this.applicationConfiguration,i),I=[...n,...o,...d];return I.length&&this.updateApplicationConfiguration(i),{keys:I,overrides:h}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:d,overrides:h}=C(this.localUserConfiguration,i),I=[...n,...o,...d];return I.length&&this.updateLocalUserConfiguration(i),{keys:I,overrides:h}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:d,overrides:h}=C(this.remoteUserConfiguration,i),I=[...n,...o,...d];return I.length&&this.updateRemoteUserConfiguration(i),{keys:I,overrides:h}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:d,overrides:h}=C(this.workspaceConfiguration,i),I=[...n,...o,...d];return I.length&&this.updateWorkspaceConfiguration(i),{keys:I,overrides:h}}compareAndUpdateFolderConfiguration(i,n){const o=this.folderConfigurations.get(i),{added:d,updated:h,removed:I,overrides:R}=C(o,n),M=[...d,...h,...I];return(M.length||!o)&&this.updateFolderConfiguration(i,n),{keys:M,overrides:R}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:d,removed:h,overrides:I}=C(n,void 0);return{keys:[...o,...d,...h],overrides:I}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,n,o){let d=this.getConsolidatedConfigurationModelForResource(n,o);return n.overrideIdentifier&&(d=d.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(d=d.merge(this._policyConfiguration)),d}getConsolidatedConfigurationModelForResource({resource:i},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const d=n.getFolder(i);d&&(o=this.getFolderConsolidatedConfiguration(d.uri)||o);const h=this._memoryConfigurationByResource.get(i);h&&(o=o.merge(h))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(i);d?(n=o.merge(d),this._foldersConsolidatedConfigurations.set(i,n)):n=o}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:o,overrides:d,keys:h}=this._folderConfigurations.get(n);return i.push([n,{contents:o,overrides:d,keys:h}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this._workspaceConfiguration.keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(d=>n.add(d))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.policy),d=this.parseConfigurationModel(i.application),h=this.parseConfigurationModel(i.user),I=this.parseConfigurationModel(i.workspace),R=i.folders.reduce((M,T)=>(M.set(l.URI.revive(T[0]),this.parseConfigurationModel(T[1])),M),new D.ResourceMap);return new c(n,o,d,h,new S,I,R,new S,new D.ResourceMap)}static parseConfigurationModel(i){return new S(i.contents,i.keys,i.overrides)}}e.Configuration=c;function y(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const d of a)d.keys.forEach(h=>i.add(h)),d.overrides.forEach(([h,I])=>{const R=(0,D.getOrSet)(n,h,new Set);I.forEach(M=>R.add(M))});const o=[];return n.forEach((d,h)=>o.push([h,[...d.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=y;class b{constructor(i,n,o,d){this.change=i,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=d,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const h of i.keys)this.affectedKeys.add(h);for(const[,h]of i.overrides)for(const I of h)this.affectedKeys.add(I);this._affectsConfigStr=this._marker;for(const h of this.affectedKeys)this._affectsConfigStr+=h+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=c.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){const o=this._marker+i,d=this._affectsConfigStr.indexOf(o);if(d<0)return!1;const h=d+o.length;if(h>=this._affectsConfigStr.length)return!1;const I=this._affectsConfigStr.charCodeAt(h);if(I!==this._markerCode1&&I!==this._markerCode2)return!1;if(n){const R=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,M=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!k.equals(R,M)}return!0}}e.ConfigurationChangeEvent=b;function C(a,i){const{added:n,removed:o,updated:d}=t(i?.rawConfiguration,a?.rawConfiguration),h=[],I=a?.getAllOverrideIdentifiers()||[],R=i?.getAllOverrideIdentifiers()||[];if(i){const M=R.filter(T=>!I.includes(T));for(const T of M)h.push([T,i.getKeysForOverrideIdentifier(T)])}if(a){const M=I.filter(T=>!R.includes(T));for(const T of M)h.push([T,a.getKeysForOverrideIdentifier(T)])}if(i&&a){for(const M of I)if(R.includes(M)){const T=t({contents:a.getOverrideValue(void 0,M)||{},keys:a.getKeysForOverrideIdentifier(M)},{contents:i.getOverrideValue(void 0,M)||{},keys:i.getKeysForOverrideIdentifier(M)});h.push([M,[...T.added,...T.removed,...T.updated]])}}return{added:n,removed:o,updated:d,overrides:h}}function t(a,i){const n=a?i?a.keys.filter(h=>i.keys.indexOf(h)===-1):[...a.keys]:[],o=i?a?i.keys.filter(h=>a.keys.indexOf(h)===-1):[...i.keys]:[],d=[];if(a&&i){for(const h of i.keys)if(a.keys.indexOf(h)!==-1){const I=(0,p.getConfigurationValue)(i.contents,h),R=(0,p.getConfigurationValue)(a.contents,h);k.equals(I,R)||d.push(h)}}return{added:n,removed:o,updated:d}}}),define(te[233],ie([0,1,23,4,2,40,11,114,66,5,37,51]),function(j,e,E,L,r,A,D,k,u,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class w extends r.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new k.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(m.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:s,defaultsOverrides:g})=>this.onDidUpdateConfiguration(Array.from(s),g))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(s,g){this.updateConfigurationModel(s,m.Registry.as(u.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:s})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new k.ConfigurationModel;const s=m.Registry.as(u.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(s),s)}updateConfigurationModel(s,g){const c=this.getConfigurationDefaultOverrides();for(const y of s){const b=c[y],C=g[y];b!==void 0?this._configurationModel.addValue(y,b):C?this._configurationModel.addValue(y,C.default):this._configurationModel.removeValue(y)}}}e.DefaultConfiguration=w;class f{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let S=e.PolicyConfiguration=class extends r.Disposable{get configurationModel(){return this._configurationModel}constructor(s,g,c){super(),this.defaultConfiguration=s,this.policyService=g,this.logService=c,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new k.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(s=>this.onDidChangePolicies(s))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:s})=>this.update(await this.updatePolicyDefinitions(s),!0))),this._configurationModel}async updatePolicyDefinitions(s){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",s);const g={},c=[],y=m.Registry.as(u.Extensions.Configuration).getConfigurationProperties();for(const b of s){const C=y[b];if(!C){c.push(b);continue}if(C.policy){if(C.type!=="string"&&C.type!=="number"){this.logService.warn(`Policy ${C.policy.name} has unsupported type ${C.type}`);continue}c.push(b),g[C.policy.name]={type:C.type}}}return(0,D.isEmptyObject)(g)||await this.policyService.updatePolicyDefinitions(g),c}onDidChangePolicies(s){this.logService.trace("PolicyConfiguration#onDidChangePolicies",s);const g=m.Registry.as(u.Extensions.Configuration).getPolicyConfigurations(),c=(0,E.coalesce)(s.map(y=>g.get(y)));this.update(c,!0)}update(s,g){this.logService.trace("PolicyConfiguration#update",s);const c=m.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),y=[],b=this._configurationModel.isEmpty();for(const C of s){const t=c[C]?.policy?.name;if(t){const a=this.policyService.getPolicyValue(t);(b?a!==void 0:!(0,A.equals)(this._configurationModel.getValue(C),a))&&y.push([C,a])}else this._configurationModel.getValue(C)!==void 0&&y.push([C,void 0])}if(y.length){this.logService.trace("PolicyConfiguration#changed",y);const C=this._configurationModel;this._configurationModel=new k.ConfigurationModel;for(const t of C.keys)this._configurationModel.setValue(t,C.getValue(t));for(const[t,a]of y)a===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,a);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=S=ye([X(1,p.IPolicyService),X(2,l.ILogService)],S)}),define(te[234],ie([0,1,7,4,2,18,19,114,233,37]),function(j,e,E,L,r,A,D,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class p extends r.Disposable{constructor(w,f,S,v){super(),this.settingsResource=w,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new u.DefaultConfiguration),this.policyConfiguration=S instanceof l.NullPolicyService?new u.NullPolicyConfiguration:this._register(new u.PolicyConfiguration(this.defaultConfiguration,S,v)),this.userConfiguration=this._register(new k.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,f)),this.configuration=new k.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:s,properties:g})=>this.onDidDefaultConfigurationChange(s,g))),this._register(this.policyConfiguration.onDidChangeConfiguration(s=>this.onDidPolicyConfigurationChange(s))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[w,f,S]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new k.Configuration(w,f,new k.ConfigurationModel,S)}getConfigurationData(){return this.configuration.toData()}getValue(w,f){const S=typeof w=="string"?w:void 0,v=(0,D.isConfigurationOverrides)(w)?w:(0,D.isConfigurationOverrides)(f)?f:{};return this.configuration.getValue(S,v,void 0)}updateValue(w,f,S,v){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const f=this.configuration.toData(),S=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(S,f,2)}onDidDefaultConfigurationChange(w,f){const S=this.configuration.toData(),v=this.configuration.compareAndUpdateDefaultConfiguration(w,f);this.trigger(v,S,7)}onDidPolicyConfigurationChange(w){const f=this.configuration.toData(),S=this.configuration.compareAndUpdatePolicyConfiguration(w);this.trigger(S,f,7)}trigger(w,f,S){const v=new k.ConfigurationChangeEvent(w,{data:f},this.configuration);v.source=S,v.sourceConfig=this.getTargetConfiguration(S),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(w){switch(w){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=p}),define(te[235],ie([0,1,13,6]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var r;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(r||(e.RemoteAuthorityResolverErrorCode=r={}));class A extends E.ErrorNoTelemetry{static isNotAvailable(u){return u instanceof A&&u._code===r.NotAvailable}static isTemporarilyNotAvailable(u){return u instanceof A&&u._code===r.TemporarilyNotAvailable}static isNoResolverFound(u){return u instanceof A&&u._code===r.NoResolverFound}static isHandled(u){return u instanceof A&&u.isHandled}constructor(u,l=r.Unknown,p){super(u),this._message=u,this._code=l,this._detail=p,this.isHandled=l===r.NotAvailable&&p===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function D(k){const u=k.indexOf("+");return u===-1?k:k.substring(0,u)}e.getRemoteAuthorityPrefix=D}),define(te[57],ie([0,1,14]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(l){return l.scheme===E.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=L;function r(l){if(!l)return;const p=l.indexOf("+");return p<0?l:l.substr(0,p)}e.getRemoteName=r;function A(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=A;function D(l){const{host:p,port:m}=u(l);if(typeof m>"u")throw new Error("Remote authority doesn't contain a port!");return{host:p,port:m}}e.parseAuthorityWithPort=D;function k(l,p){let{host:m,port:w}=u(l);return typeof w>"u"&&(w=p),{host:m,port:w}}e.parseAuthorityWithOptionalPort=k;function u(l){const p=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const m=l.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const w=l.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:l,port:void 0}}}),define(te[115],ie([0,1,27,6,57]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(D||(e.ExtensionType=D={}));var k;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class u{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,g){if(typeof s>"u"||s===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof s=="string"||typeof g=="string"){const c=typeof s=="string"?s:s.value,y=typeof g=="string"?g:g.value;return E.equalsIgnoreCase(c,y)}return s._lower===g._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.ExtensionIdentifier=u;class l{get size(){return this._set.size}constructor(s){if(this._set=new Set,s)for(const g of s)this.add(g)}add(s){this._set.add(u.toKey(s))}delete(s){return this._set.delete(u.toKey(s))}has(s){return this._set.has(u.toKey(s))}}e.ExtensionIdentifierSet=l;class p{constructor(){this._map=new Map}clear(){this._map.clear()}delete(s){this._map.delete(u.toKey(s))}get(s){return this._map.get(u.toKey(s))}has(s){return this._map.has(u.toKey(s))}set(s,g){this._map.set(u.toKey(s),g)}values(){return this._map.values()}forEach(s){this._map.forEach(s)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=p;function m(v){return w(v)}e.isApplicationScopedExtension=m;function w(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function f(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function S(v,s){if(s){const g=`onResolveRemoteAuthority:${(0,r.getRemoteName)(s)}`;return!!v.activationEvents?.includes(g)}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[236],ie([0,1,7,17,22,13,4,2,64,83,31,105,235,57]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var v;(function(P){P[P.Management=1]="Management",P[P.ExtensionHost=2]="ExtensionHost",P[P.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function s(P){switch(P){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(P){const O=new r.CancellationTokenSource;return setTimeout(()=>O.cancel(),P),O.token}function c(P,O){if(P.isCancellationRequested||O.isCancellationRequested)return r.CancellationToken.Cancelled;const U=new r.CancellationTokenSource;return P.onCancellationRequested(()=>U.cancel()),O.onCancellationRequested(()=>U.cancel()),U.token}class y{get didTimeout(){return this._state==="timedout"}constructor(O){this._state="pending",this._disposables=new k.DisposableStore,this.promise=new Promise((U,B)=>{this._resolvePromise=U,this._rejectPromise=B}),O.isCancellationRequested?this._timeout():this._disposables.add(O.onCancellationRequested(()=>this._timeout()))}registerDisposable(O){this._state==="pending"?this._disposables.add(O):O.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(O))}reject(O){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(O))}}function b(P,O){const U=new y(O);return U.registerDisposable(P.onControlMessage(B=>{const F=JSON.parse(B.toString()),x=G(F);x?U.reject(x):U.resolve(F)})),U.promise}function C(P,O,U,B,F,x,V,se,ae){const Se=new y(ae),De=l.StopWatch.create(!1);return P.info(`Creating a socket (${se})...`),u.mark(`code/willCreateSocket/${V}`),O.connect(U,B,F,x,se,(Re,Le)=>{Se.didTimeout?(u.mark(`code/didCreateSocketError/${V}`),P.info(`Creating a socket (${se}) finished after ${De.elapsed()} ms, but this is too late and has timed out already.`),Re&&P.error(Re),Le?.dispose()):Re||!Le?(u.mark(`code/didCreateSocketError/${V}`),P.info(`Creating a socket (${se}) returned an error after ${De.elapsed()} ms.`),Se.reject(Re)):(u.mark(`code/didCreateSocketOK/${V}`),P.info(`Creating a socket (${se}) was successful after ${De.elapsed()} ms.`),Se.resolve(Le))}),Se.promise}function t(P,O){const U=new y(O);return P.then(B=>{U.didTimeout||U.resolve(B)},B=>{U.didTimeout||U.reject(B)}),U.promise}async function a(P,O,U,B){const F=Y(P,O);P.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let x;try{x=await C(P.logService,P.socketFactory,P.host,P.port,(0,f.getRemoteServerRootPath)(P),`reconnectionToken=${P.reconnectionToken}&reconnection=${P.reconnectionProtocol?"true":"false"}`,s(O),`renderer-${s(O)}-${P.reconnectionToken}`,B)}catch(De){throw P.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),P.logService.error(De),De}P.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let V,se;P.reconnectionProtocol?(P.reconnectionProtocol.beginAcceptReconnection(x,null),V=P.reconnectionProtocol,se=!1):(V=new m.PersistentProtocol({socket:x,measureRoundTripTime:!0}),se=!0),P.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const ae=await t(P.signService.createNewMessage((0,p.generateUuid)()),B),Se={type:"auth",auth:P.connectionToken||"00000000000000000000",data:ae.data};V.sendControl(L.VSBuffer.fromString(JSON.stringify(Se)));try{const De=await b(V,c(B,g(1e4)));if(De.type!=="sign"||typeof De.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(P.logService.trace(`${F} 4/6. received SignRequest control message.`),!await t(P.signService.validate(ae,De.signedData),B)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const Le=await t(P.signService.sign(De.data),B),Oe={type:"connectionType",commit:P.commit,signedData:Le,desiredConnectionType:O};return U&&(Oe.args=U),P.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(L.VSBuffer.fromString(JSON.stringify(Oe))),{protocol:V,ownsProtocol:se}}catch(De){throw De&&De.code==="ETIMEDOUT"&&(P.logService.error(`${F} the handshake timed out. Error:`),P.logService.error(De)),De&&De.code==="VSCODE_CONNECTION_ERROR"&&(P.logService.error(`${F} received error control message when negotiating connection. Error:`),P.logService.error(De)),se&&$(V),De}}async function i(P,O,U,B){const F=Date.now(),x=Y(P,O),{protocol:V,ownsProtocol:se}=await a(P,O,U,B),ae=new y(B);return ae.registerDisposable(V.onControlMessage(Se=>{const De=JSON.parse(Se.toString()),Re=G(De);Re?(P.logService.error(`${x} received error control message when negotiating connection. Error:`),P.logService.error(Re),se&&$(V),ae.reject(Re)):(P.reconnectionProtocol?.endAcceptReconnection(),P.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${_(F)}!`),ae.resolve({protocol:V,firstMessage:De}))})),ae.promise}async function n(P,O){const{protocol:U}=await i(P,1,void 0,O);return{protocol:U}}async function o(P,O,U){const{protocol:B,firstMessage:F}=await i(P,2,O,U),x=F&&F.debugPort;return{protocol:B,debugPort:x}}async function d(P,O,U){const B=Date.now(),F=Y(P,3),{protocol:x}=await a(P,3,O,U);return P.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${_(B)}!`),x}async function h(P,O,U){const{host:B,port:F,connectionToken:x}=await P.addressProvider.getAddress();return{commit:P.commit,quality:P.quality,host:B,port:F,connectionToken:x,reconnectionToken:O,reconnectionProtocol:U,socketFactory:P.socketFactory,signService:P.signService,logService:P.logService}}async function I(P,O,U){return M(P,async B=>{const{protocol:F}=await n(B,r.CancellationToken.None);return new q(P,O,U,B.reconnectionToken,F)})}e.connectRemoteAgentManagement=I;async function R(P,O){return M(P,async U=>{const{protocol:B,debugPort:F}=await o(U,O,r.CancellationToken.None);return new N(P,O,U.reconnectionToken,B,F)})}e.connectRemoteAgentExtensionHost=R;async function M(P,O){for(let B=1;;B++)try{const F=(0,p.generateUuid)(),x=await h(P,F,null);return await O(x)}catch(F){if(B<5)P.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),P.logService.error(F);else throw P.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),P.logService.error(F),K.triggerPermanentFailure(0,0,w.RemoteAuthorityResolverError.isHandled(F)),F}}async function T(P,O,U){const B=await h(P,(0,p.generateUuid)(),null);return await d(B,{host:O,port:U},r.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function W(P){return(0,E.createCancelablePromise)(O=>new Promise((U,B)=>{const F=setTimeout(U,P*1e3);O.onCancellationRequested(()=>{clearTimeout(F),U()})}))}var z;(function(P){P[P.ConnectionLost=0]="ConnectionLost",P[P.ReconnectionWait=1]="ReconnectionWait",P[P.ReconnectionRunning=2]="ReconnectionRunning",P[P.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",P[P.ConnectionGain=4]="ConnectionGain",P[P.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(z||(e.PersistentConnectionEventType=z={}));class H{constructor(O,U){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=H;class J{constructor(O,U,B,F){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.durationSeconds=B,this.cancellableTimer=F,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=J;class ne{constructor(O,U,B){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=ne;class re{constructor(O,U,B){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=B,this.type=4}}e.ConnectionGainEvent=re;class ue{constructor(O,U){this.reconnectionToken=O,this.connectionHealth=U,this.type=5}}e.ConnectionHealthChangedEvent=ue;class ce{constructor(O,U,B,F){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=B,this.handled=F,this.type=3}}e.ReconnectionPermanentFailureEvent=ce;class K extends k.Disposable{static triggerPermanentFailure(O,U,B){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=O,this._permanentFailureAttempt=U,this._permanentFailureHandled=B,this._instances.forEach(F=>F._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(O=>O._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(O=>O._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||K._permanentFailure}constructor(O,U,B,F,x){super(),this._connectionType=O,this._options=U,this.reconnectionToken=B,this.protocol=F,this._reconnectionFailureIsFatal=x,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new re(this.reconnectionToken,0,0)),this._register(F.onSocketClose(V=>{const se=le(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${se} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${se} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${se} received socket close event.`),this._beginReconnecting()})),this._register(F.onSocketTimeout(V=>{const se=le(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),this._register(F.onHighRoundTripTime(V=>{const se=oe(this._connectionType,this.reconnectionToken);this._options.logService.info(`${se} high roundtrip time: ${V.roundTripTime}ms (${V.recentHighRoundTripCount} of 5 recent samples)`)})),this._register(F.onDidChangeConnectionHealth(V=>{this._onDidStateChange.fire(new ue(this.reconnectionToken,V))})),K._instances.push(this),this._register((0,k.toDisposable)(()=>{const V=K._instances.indexOf(this);V>=0&&K._instances.splice(V,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const O=le(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const F=B<U.length?U[B]:U[U.length-1];try{if(F>0){const V=W(F);this._onDidStateChange.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,V)),this._options.logService.info(`${O} waiting for ${F} seconds before reconnecting...`);try{await V}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this._options.logService.info(`${O} resolving connection...`);const x=await h(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${O} connecting to ${x.host}:${x.port}...`),await this._reconnect(x,g(S)),this._options.logService.info(`${O} reconnected!`),this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(x){if(x.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this._options.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(w.RemoteAuthorityResolverError.isTemporarilyNotAvailable(x)){this._options.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((x.code==="ETIMEDOUT"||x.code==="ENETUNREACH"||x.code==="ECONNREFUSED"||x.code==="ECONNRESET")&&x.syscall==="connect"){this._options.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((0,A.isCancellationError)(x)){this._options.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if(x instanceof w.RemoteAuthorityResolverError){this._options.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,w.RemoteAuthorityResolverError.isHandled(x));break}this._options.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(O,U,B){this._reconnectionFailureIsFatal?K.triggerPermanentFailure(O,U,B):this._gotoPermanentFailure(O,U,B)}_gotoPermanentFailure(O,U,B){this._onDidStateChange.fire(new ce(this.reconnectionToken,O,U,B)),$(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=K,K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[];class q extends K{constructor(O,U,B,F,x){super(1,O,F,x,!0),this.client=this._register(new m.Client(x,{remoteAuthority:U,clientId:B},O.ipcLogger))}async _reconnect(O,U){await n(O,U)}}e.ManagementPersistentConnection=q;class N extends K{constructor(O,U,B,F,x){super(2,O,B,F,!1),this._startArguments=U,this.debugPort=x}async _reconnect(O,U){await o(O,this._startArguments,U)}}e.ExtensionHostPersistentConnection=N;function $(P){try{P.acceptDisconnect();const O=P.getSocket();P.dispose(),O.dispose()}catch(O){(0,A.onUnexpectedError)(O)}}function G(P){if(P&&P.type==="error"){const O=new Error(`Connection error: ${P.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function ee(P,O){for(;P.length<O;)P+=" ";return P}function oe(P,O){return`[remote-connection][${ee(s(P),13)}][${O.substr(0,5)}\u2026]`}function le(P,O,U){return`${oe(P,O)}[${U?"reconnect":"initial"}]`}function Y(P,O){return`${le(O,P.reconnectionToken,!!P.reconnectionProtocol)}[${P.host}:${P.port}]`}function _(P){return`${Date.now()-P} ms`}}),define(te[237],ie([0,1,26,50,41,196]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function k(f=!1){return(D===void 0||f)&&(D=u()),D}e.hasWSLFeatureInstalled=k;async function u(){const f=l();if(f===void 0)return!1;if(f>=22e3){const S=m();if(S)return new Promise(v=>{L.execFile(S,["--status"],s=>v(!s))})}else{const S=w();if(S)try{if((await r.promises.stat(S)).isFile())return!0}catch{}}return!1}function l(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(f)return parseInt(f[3])}function p(f){const S=process.env.SystemRoot;if(S){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(S,v?"Sysnative":"System32",f)}}function m(){return p("wsl.exe")}function w(){return p("lxss\\LxssManager.dll")}}),define(te[52],ie([0,1,17,13,2,180,66,6,5,51]),function(j,e,E,L,r,A,D,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");class p{constructor(C){this.original=C}toJSON(){if(!this.headers){const C=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?C[t]="*****":C[t]=this.original[t];this.headers=C}return this.headers}}class m extends r.Disposable{constructor(C,t){super(),this.counter=0,this.logger=t.createLogger(C?"remotenetwork":"network",{name:C?(0,A.localize)(0,null):(0,A.localize)(1,null),when:u.CONTEXT_LOG_LEVEL.isEqualTo((0,u.LogLevelToString)(u.LogLevel.Trace)).serialize()})}async logAndRequest(C,t,a){const i=`${C} #${++this.counter}: ${t.url}`;this.logger.trace(`${i} - begin`,t.type,new p(t.headers??{}));try{const n=await a();return this.logger.trace(`${i} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.logger.error(`${i} - error`,t.type,(0,L.getErrorMessage)(n)),n}}}e.AbstractRequestService=m;function w(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.isSuccess=w;function f(b){return b.res.statusCode===204}async function S(b){return f(b)?null:(await(0,E.streamToBuffer)(b.stream)).toString()}e.asText=S;async function v(b){if(!w(b))throw new Error("Server returned "+b.res.statusCode);return S(b)}e.asTextOrError=v;async function s(b){if(!w(b))throw new Error("Server returned "+b.res.statusCode);if(f(b))return null;const t=(await(0,E.streamToBuffer)(b.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.asJson=s;function g(b){y(b)}e.updateProxyConfigurationsScope=g;let c;function y(b){const C=l.Registry.as(D.Extensions.Configuration),t=c;c={id:"http",order:15,title:(0,A.localize)(2,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},C.updateConfigurations({add:[c],remove:t?[t]:[]})}y(1)}),define(te[238],ie([0,1,17,22]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class r{constructor(k){this.service=k}listen(k,u){throw new Error("Invalid listen")}call(k,u,l,p=L.CancellationToken.None){switch(u){case"request":return this.service.request(l[0],p).then(async({res:m,stream:w})=>{const f=await(0,E.streamToBuffer)(w);return[{statusCode:m.statusCode,headers:m.headers},f]});case"resolveProxy":return this.service.resolveProxy(l[0])}throw new Error("Invalid call")}}e.RequestChannel=r;class A{constructor(k){this.channel=k}async request(k,u){const[l,p]=await this.channel.call("request",[k],u);return{res:l,stream:(0,E.bufferToStream)(p)}}async resolveProxy(k){return this.channel.call("resolveProxy",[k])}}e.RequestChannelClient=A}),define(te[239],ie([0,1,240,11]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function r(D,k){return D.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:D.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function A(D,k,u={}){const l=(0,E.parse)(D),p=u.proxyUrl||r(l,k);if(!p)return null;const m=(0,E.parse)(p);if(!/^https?:$/.test(m.protocol||""))return null;const w={host:m.hostname||"",port:m.port||(m.protocol==="https"?"443":"80"),auth:m.auth,rejectUnauthorized:(0,L.isBoolean)(u.strictSSL)?u.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((f,S)=>{j(["http-proxy-agent"],f,S)}))(w):new(await new Promise((f,S)=>{j(["https-proxy-agent"],f,S)}))(w)}e.getProxyAgent=A}),define(te[116],ie([0,1,50,9,181,22,49,13,3,31,153,62,7,132]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let S;async function v(g,c,y,b){return y["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,m.isLaunchedFromCli)(b)&&!y["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,m.isLaunchedFromCli)(b)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=w.Promises.withAsyncBody(async(C,t)=>{const a=new A.CancellationTokenSource;let i=1e4;const n=g.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,f.clamp)(n,1,120)*1e3);const o=setTimeout(()=>{a.dispose(!0),t(new Error((0,r.localize)(0,null)))},i);try{C(await s(c,a.token))}catch(d){!(0,k.isCancellationError)(d)&&!a.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,D.toErrorMessage)(d)))):C({})}finally{clearTimeout(o),a.dispose()}})),S)}e.getResolvedShellEnv=v;async function s(g,c){const y=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",y);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",b);const C=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(C+"({.*})"+C),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",a);const i=await(0,p.getSystemShell)(u.OS,a);return g.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(c.isCancellationRequested)return o(new k.CancellationError);const d=(0,L.basename)(i);let h,I;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(d)?(h=`& '${process.execPath}' ${R} -p '''${C}'' + JSON.stringify(process.env) + ''${C}'''`,I=["-Login","-Command"]):(h=`'${process.execPath}' ${R} -p '"${C}" + JSON.stringify(process.env) + "${C}"'`,d==="tcsh"||d==="csh"?I=["-ic"]:I=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),h);const M=(0,E.spawn)(i,[...I,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});c.onCancellationRequested(()=>(M.kill(),o(new k.CancellationError))),M.on("error",z=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(z)),o(z)});const T=[];M.stdout.on("data",z=>T.push(z));const W=[];M.stderr.on("data",z=>W.push(z)),M.on("close",(z,H)=>{const J=Buffer.concat(T).toString("utf8");g.trace("getUnixShellEnvironment#raw",J);const ne=Buffer.concat(W).toString("utf8");if(ne.trim()&&g.trace("getUnixShellEnvironment#stderr",ne),z||H)return o(new Error((0,r.localize)(2,null,z,H)));const re=t.exec(J),ue=re?re[1]:"{}";try{const ce=JSON.parse(ue);y?ce.ELECTRON_RUN_AS_NODE=y:delete ce.ELECTRON_RUN_AS_NODE,b?ce.ELECTRON_NO_ATTACH_CONSOLE=b:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ce),n(ce)}catch(ce){g.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(ce)),o(ce)}})})}}),define(te[92],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[241],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.validators=new Map}vsda(){return new Promise((r,A)=>j(["vsda"],r,A))}async createNewMessage(r){try{const A=await this.vsda(),D=new A.validator;if(D){const k=String(E._nextId++);return this.validators.set(k,D),{id:k,data:D.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,A){if(!r.id)return!0;const D=this.validators.get(r.id);if(!D)return!1;this.validators.delete(r.id);try{return D.validate(A)==="ok"}catch{return!1}}async sign(r){try{const A=await this.vsda(),D=new A.signer;if(D)return D.sign(r)}catch{}return r}}e.SignService=E,E._nextId=1}),define(te[33],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,E.createDecorator)("stateReadService"),e.IStateService=(0,E.createDecorator)("stateService")}),define(te[117],ie([0,1,7,17,11,34,16,5]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var u;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class l{constructor(f,S,v,s){this.storagePath=f,this.logService=v,this.fileService=s,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=S===0?void 0:new E.ThrottledDelayer(100)}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(f){f.fileOperationResult!==1&&this.logService.error(f)}}getItem(f,S){const v=this.storage[f];return(0,r.isUndefinedOrNull)(v)?S:v}setItem(f,S){this.setItems([{key:f,data:S}])}setItems(f){let S=!1;for(const{key:v,data:s}of f)this.storage[v]!==s&&((0,r.isUndefinedOrNull)(s)?(0,r.isUndefined)(this.storage[v])||(this.storage[v]=void 0,S=!0):(this.storage[v]=s,S=!0));S&&this.save()}removeItem(f){(0,r.isUndefined)(this.storage[f])||(this.storage[f]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const f=JSON.stringify(this.storage,null,4);if(f!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(f)),this.lastSavedStorageContents=f}catch(S){this.logService.error(S)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=l;let p=e.StateReadonlyService=class{constructor(f,S,v,s){this.fileStorage=new l(S.stateResource,f,v,s)}async init(){await this.fileStorage.init()}getItem(f,S){return this.fileStorage.getItem(f,S)}};e.StateReadonlyService=p=ye([X(1,A.IEnvironmentService),X(2,k.ILogService),X(3,D.IFileService)],p);class m extends p{setItem(f,S){this.fileStorage.setItem(f,S)}setItems(f){this.fileStorage.setItems(f)}removeItem(f){this.fileStorage.removeItem(f)}close(){return this.fileStorage.close()}}e.StateService=m}),define(te[93],ie([0,1,3,36,31]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(u){if(E.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function D(u,l,p,m,w,f,S,v){const s=Object.create(null);s["common.machineId"]=f,s.sessionID=(0,r.generateUuid)()+Date.now(),s.commitHash=m,s.version=w,s["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,E.PlatformToString)(E.platform),s["common.nodePlatform"]=L.platform,s["common.nodeArch"]=p,s["common.product"]=v||"desktop",S&&(s["common.msftInternal"]=S);let g=0;const c=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),E.isLinuxSnap&&(s["common.snap"]="true");const y=A(l);return y&&(s["common.platformDetail"]=y),s}e.resolveCommonProperties=D;function k(u){const l=L.env.USERDNSDOMAIN;if(!l)return!1;const p=l.toLowerCase();return u.some(m=>p===m)}e.verifyMicrosoftInternalDomain=k}),define(te[25],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var r;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(te[242],ie([0,1,26,7,43,14,9,3,8,85,24,104,88,16,21,25]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const s=new Map;async function g(t,a){const i=`${t}::${a.join(":")}`,n=s.get(i);if(n)return n;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],d=new Map,h=new Map,I=2e4;function R(T,W,z,H){const J=W.substring(T.length+1);return L.Promises.withAsyncBody(async ne=>{let re;try{re=await p.Promises.readdir(W,{withFileTypes:!0})}catch{ne();return}if(H.count>=I){H.count+=re.length,H.maxReached=!0,ne();return}let ue=re.length;if(ue===0){ne();return}let ce=re;H.count+re.length>I&&(H.maxReached=!0,ue=I-H.count,ce=re.slice(0,ue)),H.count+=re.length;for(const K of ce)if(K.isDirectory()){if(z.includes(K.name)||await R(T,(0,D.join)(W,K.name),z,H),--ue===0){ne();return}}else{const q=K.name.lastIndexOf(".");if(q>=0){const N=K.name.substring(q+1);N&&d.set(N,(d.get(N)??0)+1)}for(const N of o)N.relativePathPattern?.test(J)!==!1&&N.filePattern.test(K.name)&&h.set(N.tag,(h.get(N.tag)??0)+1);if(--ue===0){ne();return}}})}const M=L.Promises.withAsyncBody(async T=>{const W={count:0,maxReached:!1};await R(t,t,a,W);const z=await b(t);T({configFiles:c(h),fileTypes:c(d),fileCount:W.count,maxFilesReached:W.maxReached,launchConfigFiles:z})});return s.set(i,M),M}e.collectWorkspaceStats=g;function c(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function y(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.virtualMachineHint.value()*100)}%`},a=E.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=y;async function b(t){try{const a=new Map,i=(0,D.join)(t,".vscode","launch.json"),n=await p.Promises.readFile(i),o=[],d=(0,r.parse)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,r.getNodeType)(d)==="object"&&d.configurations)for(const h of d.configurations){const I=h.type;I&&(a.has(I)?a.set(I,a.get(I)+1):a.set(I,1))}return c(a)}catch{return[]}}e.collectLaunchConfigs=b;let C=e.DiagnosticsService=class{constructor(a,i){this.telemetryService=a,this.productService=i}formatMachineInfo(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}formatEnvironment(a){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const n=E.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(E.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||i.push(`Load (avg):       ${E.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(l.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,m.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async n=>{let[o,d]=n,h=this.formatProcessList(a,o);return i.forEach(I=>{if((0,w.isRemoteDiagnosticError)(I))h+=`
${I.errorMessage}`,d+=`
${I.errorMessage}`;else if(h+=`

Remote: ${I.hostName}`,I.processes&&(h+=`
${this.formatProcessList(a,I.processes)}`),I.workspaceMetadata){d+=`
|  Remote: ${I.hostName}`;for(const R of Object.keys(I.workspaceMetadata)){const M=I.workspaceMetadata[R];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),d+=`|    Folder (${R}): ${T}`,d+=this.formatWorkspaceStats(M)}}}),{processInfo:h,workspaceInfo:d}})}async getSystemInfo(a,i){const{memory:n,vmHint:o,os:d,cpus:h}=y(),I={os:d,memory:n,cpus:h,vmHint:o,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return k.isWindows||(I.load=`${E.loadavg().map(R=>Math.round(R)).join(", ")}`),k.isLinux&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(a,i){const n=[];return(0,m.listProcesses)(a.mainPID).then(async o=>(n.push(""),n.push(this.formatEnvironment(a)),n.push(""),n.push(this.formatProcessList(a,o)),a.windows.some(d=>d.folderURIs&&d.folderURIs.length>0&&!d.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(a))),i.forEach(d=>{if((0,w.isRemoteDiagnosticError)(d))n.push(`
${d.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${d.hostName}`),n.push(this.formatMachineInfo(d.machineInfo)),d.processes&&n.push(this.formatProcessList(a,d.processes)),d.workspaceMetadata)for(const h of Object.keys(d.workspaceMetadata)){const I=d.workspaceMetadata[h];let R=`${I.fileCount} files`;I.maxFilesReached&&(R=`more than ${R}`),n.push(`Folder (${h}): ${R}`),n.push(this.formatWorkspaceStats(I))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(a){const i=[];let o=0;const d=(M,T)=>{const W=` ${M}(${T})`;o+W.length>60?(i.push(h),h="|                 ",o=h.length):o+=W.length,h+=W};let h="|      File types:";const I=10,R=a.fileTypes.length>I?I:a.fileTypes.length;for(let M=0;M<R;M++){const T=a.fileTypes[M];d(T.name,T.count)}if(i.push(h),a.configFiles.length>=0&&(h="|      Conf files:",o=0,a.configFiles.forEach(M=>{d(M.name,M.count)}),i.push(h)),a.launchConfigFiles.length>0){let M="|      Launch Configs:";a.launchConfigFiles.forEach(T=>{const W=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`;M+=W}),i.push(M)}return i.join(`
`)}expandGPUFeatures(a){const i=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${a[n]}`).join(`
                  `)}formatWorkspaceMetadata(a){const i=[],n=[];return a.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(d=>{const h=u.URI.revive(d);if(h.scheme===A.Schemas.file){const I=h.fsPath;n.push(g(I,["node_modules",".git"]).then(R=>{let M=`${R.fileCount} files`;R.maxFilesReached&&(M=`more than ${M}`),i.push(`|    Folder (${(0,D.basename)(I)}): ${M}`),i.push(this.formatWorkspaceStats(R))}).catch(R=>{i.push(`|      Error: Unable to collect workspace stats for folder ${I} (${R.toString()})`)}))}else i.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(a,i){const n=new Map;a.windows.forEach(d=>n.set(d.pid,`window [${d.id}] (${d.title})`)),a.pidToNames.forEach(({pid:d,name:h})=>n.set(d,h));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(a.mainPID,n,o,i,0),o.join(`
`)}formatProcessItem(a,i,n,o,d){const h=d===0;let I;h?I=o.pid===a?`${this.productService.applicationName} main`:"remote agent":i.has(o.pid)?I=i.get(o.pid):I=`${"  ".repeat(d)} ${o.name}`;const R=process.platform==="win32"?o.mem:E.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(R/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(o.children)&&o.children.forEach(M=>this.formatProcessItem(a,i,n,M,d+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:n}of a.folders){const o=u.URI.revive(n);if(o.scheme!==A.Schemas.file)continue;const d=o.fsPath;try{(await g(d,["node_modules",".git"])).fileTypes.forEach(I=>i.add(I.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const n=u.URI.revive(i);if(n.scheme!==A.Schemas.file)continue;const o=n.fsPath;try{const d=await g(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),d.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:h.name,count:h.count})}),d.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:h.name,count:h.count})}),d.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};e.DiagnosticsService=C=ye([X(0,v.ITelemetryService),X(1,S.IProductService)],C)}),define(te[243],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(A){this.appenders=A}listen(A,D){throw new Error(`Event not found: ${D}`)}call(A,D,{eventName:k,data:u}){return this.appenders.forEach(l=>l.log(k,u)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class L{constructor(A){this.channel=A}log(A,D){return this.channel.call("log",{eventName:A,data:D}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[46],ie([0,1,40,11,4,19,57,93,25]),function(j,e,E,L,r,A,D,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class l{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=l;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class m{async publicLog(o,d,h){}async publicLogError(o,d,h){}}e.NullEndpointTelemetryService=m,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(n,o){return r.Event.debounce(o.onDidChangeConfiguration,(h,I)=>{const R=h?new Set([...h.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:R}},1e3,!0)(h=>{h.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(h.source),configurationKeys:Array.from(h.affectedKeys)})})}e.configurationTelemetry=w;function f(n,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!n.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=f;function S(n,o){return!(o.isBuilt||o.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.isLoggingOnly=S;function v(n){const o=n.getValue(u.TELEMETRY_SETTING_ID),d=n.getValue(u.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(u.TELEMETRY_OLD_SETTING_ID)===!1||d===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function s(n){const o={},d={},h={};y(n,h);for(let I in h){I=I.length>150?I.substr(I.length-149):I;const R=h[I];typeof R=="number"?d[I]=R:typeof R=="boolean"?d[I]=R?1:0:typeof R=="string"?(R.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${R.length}`),o[I]=R.substring(0,8191)):typeof R<"u"&&R!==null&&(o[I]=R)}return{properties:o,measurements:d}}e.validateTelemetryData=s;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(n){if(!n)return"none";const o=(0,D.getRemoteName)(n);return g.has(o)?o:"other"}e.cleanRemoteAuthority=c;function y(n,o,d=0,h){if(n)for(const I of Object.getOwnPropertyNames(n)){const R=n[I],M=h?h+I:I;Array.isArray(R)?o[M]=(0,E.safeStringify)(R):R instanceof Date?o[M]=R.toISOString():(0,L.isObject)(R)?d<2?y(R,o,d+1,M+"."):o[M]=(0,E.safeStringify)(R):o[M]=R}}function b(n,o){const d=n.msftInternalDomains||[],h=o.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(d)||h}e.isInternalTelemetry=b;function C(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=C;function t(n,o){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let d=n;const h=[];for(const T of o)for(;;){const W=T.exec(n);if(!W)break;h.push([W.index,T.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,R=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(d="";;){const T=R.exec(n);if(!T)break;const W=h.some(([z,H])=>T.index<H&&z<R.lastIndex);!I.test(T[0])&&!W&&(d+=n.substring(M,T.index)+"<REDACTED: user-file-path>",M=R.lastIndex)}return M<n.length&&(d+=n.substr(M)),d}function a(n){if(!n)return n;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of o)if(d.regex.test(n))return`<REDACTED: ${d.label}>`;return n}function i(n,o){return(0,E.cloneAndChange)(n,d=>{if(d instanceof l||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let h=d.replaceAll("%20"," ");h=t(h,o);for(const I of o)h=h.replace(I,"");return h=a(h),h}})}e.cleanData=i}),define(te[118],ie([0,1,27,111,115,3,8,13,36,46]),function(j,e,E,L,r,A,D,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,E.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=p;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(n){const o=n.manifest?n.manifest.version:n.version,d=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new w(n.identifier,o,d)}static parse(n){const o=m.exec(n);return o&&o[1]&&o[2]?new w({id:o[1]},o[2],o[4]||void 0):null}constructor(n,o,d="undefined"){this.version=o,this.targetPlatform=d,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof w?p(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=w;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(i){const n=f.exec(i);return n&&n[1]?[s(n[1]),n[2]]:[s(i),void 0]}e.getIdAndVersion=S;function v(i,n){return`${i}.${n}`}e.getExtensionId=v;function s(i){return i.toLowerCase()}e.adoptToGalleryExtensionId=s;function g(i,n){return s(v(i??r.UNDEFINED_PUBLISHER,n))}e.getGalleryExtensionId=g;function c(i,n){const o=[],d=h=>{for(const I of o)if(I.some(R=>p(n(R),n(h))))return I;return null};for(const h of i){const I=d(h);I?I.push(h):o.push([h])}return o}e.groupByExtension=c;function y(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function b(i){return{id:new l.TelemetryTrustedValue(i.identifier.id),name:new l.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function C(i,n){const o=[],d=n.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const h=d.shift();if(h&&o.every(I=>!p(I.identifier,{id:h}))){const I=i.filter(R=>p(R.identifier,{id:h}));I.length===1&&(o.push(I[0]),d.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=C;async function t(i,n){if(!A.isLinux)return!1;let o;try{o=(await i.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await i.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){n.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(h))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,n){const o=await t(i,n),d=(0,L.getTargetPlatform)(o?"alpine":A.platform,u.arch);return n.debug("ComputeTargetPlatform:",d),d}e.computeTargetPlatform=a}),define(te[244],ie([0,1,201,46]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function r(A,D,k,u,l,p,m){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${D.nameShort})`};if((0,L.supportsTelemetry)(D,k)&&(0,L.getTelemetryLevel)(u)===3){const f=await(0,E.getServiceMachineId)(k,l,p);w["X-Market-User-Id"]=f,w["VSCode-SessionId"]=m.machineId||f}return w}e.resolveMarketplaceHeaders=r}),define(te[245],ie([0,1,13,40,46]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://0.0.0.0/OneCollector/1.0",D="https://0.0.0.0/ping";async function k(l,p,m){const w=await new Promise((g,c)=>{j(["@microsoft/1ds-core-js"],g,c)}),f=await new Promise((g,c)=>{j(["@microsoft/1ds-post-js"],g,c)}),S=new w.AppInsightsCore,v=new f.PostChannel,s={instrumentationKey:l,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(m){s.extensionConfig={};const g={alwaysUseXhrOverride:!0,httpXHROverride:m};s.extensionConfig[v.identifier]=g}return S.initialize(s,[]),S.addTelemetryInitializer(g=>{p&&(g.ext=g.ext??{},g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),S}class u{constructor(p,m,w,f,S){this._isInternalTelemetry=p,this._eventPrefix=m,this._defaultData=w,this._xhrOverride=S,this.endPointUrl=A,this.endPointHealthUrl=D,this._defaultData||(this._defaultData={}),typeof f=="function"?this._aiCoreOrKey=f():this._aiCoreOrKey=f,this._asyncAiCore=null}_withAIClient(p){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){p(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=k(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(m=>{p(m)},m=>{(0,E.onUnexpectedError)(m),console.error(m)})}}log(p,m){if(!this._aiCoreOrKey)return;m=(0,L.mixin)(m,this._defaultData),m=(0,r.validateTelemetryData)(m);const w=this._eventPrefix+"/"+p;try{this._withAIClient(f=>{f.pluginVersionString=m?.properties.version??"Unknown",f.track({name:w,baseData:{name:w,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(p=>{this._withAIClient(m=>{m.unload(!0,()=>{this._aiCoreOrKey=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=u}),define(te[119],ie([0,1,2,40,3,27,182,19,66,76,21,51,25,46]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=e.TelemetryService=class{constructor(g,c,y){this._configurationService=c,this._productService=y,this._experimentProperties={},this._disposables=new E.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(b),"gi")),b.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(b.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(b=>{(b.affectsConfiguration(w.TELEMETRY_SETTING_ID)||b.affectsConfiguration(w.TELEMETRY_OLD_SETTING_ID)||b.affectsConfiguration(w.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(g,c){this._experimentProperties[g]=c}_updateTelemetryLevel(){let g=(0,f.getTelemetryLevel)(this._configurationService);const c=this._productService.enabledTelemetryLevels;if(c){this._sendErrorTelemetry=this.sendErrorTelemetry?c.error:!1;const y=c.usage?3:c.error?2:0;g=Math.min(g,y)}this._telemetryLevel=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(g,c,y){this._telemetryLevel<c||(y=(0,L.mixin)(y,this._experimentProperties),y=(0,f.cleanData)(y,this._cleanupPatterns),y=(0,L.mixin)(y,this._commonProperties),this._appenders.forEach(b=>b.log(g,y)))}publicLog(g,c){this._log(g,3,c)}publicLog2(g,c){this.publicLog(g,c)}publicLogError(g,c){this._sendErrorTelemetry&&this._log(g,2,c)}publicLogError2(g,c){this.publicLogError(g,c)}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=S=ye([X(1,k.IConfigurationService),X(2,p.IProductService)],S);function v(){const s=(0,D.localize)(0,null,l.default.nameLong),g=l.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=r.isWeb?"":(0,D.localize)(3,null),y=(0,D.localize)(4,null),b=(0,D.localize)(5,null),C=(0,D.localize)(6,null),t=(0,D.localize)(7,null),a=`
|       | ${y} | ${b} | ${C} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,D.localize)(8,null);return`
${s} ${g} ${c}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}m.Registry.as(u.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:v(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(u.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,D.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,D.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[246],ie([0,1,296,245]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class r extends L.AbstractOneDataSystemAppender{constructor(D,k,u,l){const p={sendPOST:(m,w)=>{const f={method:"POST",headers:{...m.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(m.data)}};try{const S=E.request(m.urlString,f,v=>{v.on("data",function(s){w(v.statusCode??200,v.headers,s.toString())}),v.on("error",function(s){w(0,{})})});S.write(m.data),S.end()}catch{w(0,{})}}};super(D,k,u,l,p)}}e.OneDataSystemAppender=r}),define(te[247],ie([0,1,3,85,25]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function A(D,k){let u=D.getItem(r.machineIdKey);return(typeof u!="string"||E.isMacintosh&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,L.getMachineId)(k.error.bind(k))),u}e.resolveMachineId=A}),define(te[120],ie([0,1,25,247]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function r(A,D){const k=await(0,L.resolveMachineId)(A,D);return A.setItem(E.machineIdKey,k),k}e.resolveMachineId=r}),define(te[78],ie([0,1,15,4,2,3,19,6,33]),function(j,e,E,L,r,A,D,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const l="#FFFFFF",p="#1E1E1E",m="#000000",w="#FFFFFF",f="theme",S="themeBackground",v="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let s=e.ThemeMainService=class extends r.Disposable{constructor(c,y){super(),this.stateService=c,this.configurationService=y,this._onDidChangeColorScheme=this._register(new L.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,E.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(A.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const c=this.getColorScheme();if(c.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return c.dark?m:w;let y=this.stateService.getItem(S,null);if(!y)switch(this.stateService.getItem(f,"vs-dark").split(" ")[0]){case"vs":y=l;break;case"hc-black":y=m;break;case"hc-light":y=w;break;default:y=p}return A.isMacintosh&&y.toUpperCase()===p&&(y="#171717"),y}saveWindowSplash(c,y){this.stateService.setItems([{key:f,data:y.baseTheme},{key:S,data:y.colorInfo.background},{key:v,data:y}]),typeof c=="number"&&this.updateBackgroundColor(c,y)}updateBackgroundColor(c,y){for(const b of E.BrowserWindow.getAllWindows())if(b.id===c){b.setBackgroundColor(y.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(v)}};e.ThemeMainService=s=ye([X(0,u.IStateService),X(1,D.IConfigurationService)],s)}),define(te[121],ie([0,1,4,19,6,5]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,r.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,r.createDecorator)("sharedTunnelsService");var D;(function(v){v.Http="http",v.Https="https"})(D||(e.TunnelProtocol=D={}));var k;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(k||(e.TunnelPrivacyId=k={}));var u;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function l(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=l,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=p,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=m;function w(v,s,g,c){if(g===1)return!1;if(g===2&&m(s)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(y?.length===4&&parseInt(y[1])>=18)return!1}return v<1024}e.isPortPrivileged=w;class f{constructor(s,g,c){this.remoteAddress=s,this.localAddress=g,this._dispose=c,this._onDispose=new E.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let S=e.AbstractTunnelService=class{constructor(s,g){this.logService=s,this.configurationService=g,this._onTunnelOpened=new E.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new E.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new E.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const s=this.configurationService.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this._tunnelProvider=s,s?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this._canElevate=s.elevation,this._privacyOptions=s.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const s=[],g=Array.from(this._tunnels.values());for(const c of g){const y=Array.from(c.values());for(const b of y){const C=await b.value;C&&s.push(C)}}return s}async dispose(){for(const s of this._tunnels.values()){for(const{value:g}of s.values())await g.then(c=>c?.dispose());s.clear()}this._tunnels.clear()}setEnvironmentTunnel(s,g,c,y,b){this.addTunnelToMap(s,g,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:g,localAddress:c,privacy:y,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,g){(m(s)||p(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const c=this.getTunnelFromMap(s,g);if(c)return++c.refcount,c.value}openTunnel(s,g,c,y,b,C=!1,t,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${c} on local port ${b}.`),!s)return;if(g||(g="localhost"),y||(y=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(c)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.retainOrCreateTunnel(s,g,c,y,b,C,t,a);return i?i.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,c);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(n);return(n.tunnelRemoteHost!==g||n.tunnelRemotePort!==c)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const g=this._tunnels.get(s.tunnelRemoteHost);if(g){const c=g.get(s.tunnelRemotePort);c&&(c.refcount--,await this.tryDisposeTunnel(s.tunnelRemoteHost,s.tunnelRemotePort,c))}}}}async tryDisposeTunnel(s,g,c){if(c.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${g}.`);const y=c.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(s)&&this._tunnels.get(s).delete(g),y}}async closeTunnel(s,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${g} `);const c=this._tunnels.get(s);if(c&&c.has(g)){const y=c.get(g);y.refcount=0,await this.tryDisposeTunnel(s,g,y)}}addTunnelToMap(s,g,c){this._tunnels.has(s)||this._tunnels.set(s,new Map),this._tunnels.get(s).set(g,{refcount:1,value:c})}async removeEmptyTunnelFromMap(s,g){const c=this._tunnels.get(s);c&&(await c.get(g)||c.delete(g),c.size===0&&this._tunnels.delete(s))}getTunnelFromMap(s,g){const c=[s];p(s)?(c.push(...e.LOCALHOST_ADDRESSES),c.push(...e.ALL_INTERFACES_ADDRESSES)):m(s)&&c.push(...e.ALL_INTERFACES_ADDRESSES);const y=c.map(b=>this._tunnels.get(b));for(const b of y){const C=b?.get(g);if(C)return C}}canTunnel(s){return!!l(s)}createWithProvider(s,g,c,y,b,C,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${c} on local port ${y}.`);const a=c;this._factoryInProgress.add(a);const i=y===void 0?c:y,n={elevationRequired:b?this.isPortPrivileged(i):!1},o={remoteAddress:{host:g,port:c},localAddressPort:y,privacy:C,public:C?C!==k.Private:void 0,protocol:t},d=s.forwardPort(o,n);return d?(this.addTunnelToMap(g,c,d),d.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(a)})):this._factoryInProgress.delete(a),d}};e.AbstractTunnelService=S=ye([X(0,A.ILogService),X(1,L.IConfigurationService)],S)}),define(te[47],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(L||(e.StateType=L={}));var r;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap",A[A.WindowsInstaller=3]="WindowsInstaller"})(r||(e.UpdateType=r={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(A,D)=>({type:"idle",updateType:A,error:D}),CheckingForUpdates:A=>({type:"checking for updates",explicit:A}),AvailableForDownload:A=>({type:"available for download",update:A}),Downloading:A=>({type:"downloading",update:A}),Downloaded:A=>({type:"downloaded",update:A}),Updating:A=>({type:"updating",update:A}),Ready:A=>({type:"ready",update:A})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(te[248],ie([0,1,3,183,66,51]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[249],ie([0,1,4,47]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class r{constructor(k){this.service=k}listen(k,u){switch(u){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${u}`)}call(k,u,l){switch(u){case"checkForUpdates":return this.service.checkForUpdates(l);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(l)}throw new Error(`Call not found: ${u}`)}}e.UpdateChannel=r;class A{get state(){return this._state}set state(k){this._state=k,this._onStateChange.fire(k)}constructor(k){this.channel=k,this._onStateChange=new E.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(u=>this.state=u),this.channel.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(k){return this.channel.call("checkForUpdates",k)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(k){return this.channel.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=A}),define(te[38],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(te[250],ie([0,1,38,202,16,18,133,4,2]),function(j,e,E,L,r,A,D,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{constructor(w){this.uri=w,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let p=e.UriIdentityService=class{constructor(w){this._fileService=w,this._dispooables=new u.DisposableStore,this._limit=2**16;const f=new Map,S=v=>{let s=f.get(v.scheme);return s===void 0&&(s=w.hasProvider(v)&&!this._fileService.hasCapability(v,1024),f.set(v.scheme,s)),s};this._dispooables.add(k.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(v=>{f.delete(v.scheme)})),this.extUri=new A.ExtUri(S),this._canonicalUris=new D.SkipList((v,s)=>this.extUri.compare(v,s,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(w){this._fileService.hasProvider(w)&&(w=(0,A.normalizePath)(w));const f=this._canonicalUris.get(w);return f?f.touch().uri.with({fragment:w.fragment}):(this._canonicalUris.set(w,new l(w)),this._checkTrim(),w)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const w=[...this._canonicalUris.entries()].sort((S,v)=>S[1].time<v[1].time?1:S[1].time>v[1].time?-1:0);l._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let S=0;S<f;S++)this._canonicalUris.set(w[S][0],w[S][1].touch())}};e.UriIdentityService=p=ye([X(0,r.IFileService)],p),(0,L.registerSingleton)(E.IUriIdentityService,p,1)}),define(te[122],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(te[251],ie([0,1,8]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(k){this.handler=k}listen(k,u){throw new Error(`Event not found: ${u}`)}call(k,u,l){switch(u){case"handleURL":return this.handler.handleURL(E.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${u}`)}}e.URLHandlerChannel=L;class r{constructor(k){this.channel=k}handleURL(k,u){return this.channel.call("handleURL",[k.toJSON(),u])}}e.URLHandlerChannelClient=r;class A{constructor(k,u){this.next=k,this.logService=u}async routeCall(k,u,l,p){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(Array.isArray(l)&&l.length>0){const m=E.URI.revive(l[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",m.toString(!0)),m.query){const w=/\bwindowId=(\d+)/.exec(m.query);if(w){const f=w[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,m.toString(!0));const S=new RegExp(`window:${f}`),v=k.connections.find(s=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",s.ctx),S.test(s.ctx)));if(v)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",m.toString(!0)),v;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",m.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",m.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(k,u,l,p)}routeEvent(k,u){throw new Error(`Event not found: ${u}`)}}e.URLHandlerRouter=A}),define(te[252],ie([0,1,7,2,8,21]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends L.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(l,p){const m=[...this.handlers.values()];return(0,E.first)(m.map(w=>()=>w.handleURL(l,p)),void 0,!1).then(w=>w||!1)}registerHandler(l){return this.handlers.add(l),(0,L.toDisposable)(()=>this.handlers.delete(l))}}e.AbstractURLService=D;let k=e.NativeURLService=class extends D{constructor(l){super(),this.productService=l}create(l){let{authority:p,path:m,query:w,fragment:f}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&m&&m.indexOf("/")!==0&&(m=`/${m}`),r.URI.from({scheme:this.productService.urlProtocol,authority:p,path:m,query:w,fragment:f})}};e.NativeURLService=k=ye([X(0,A.IProductService)],k)}),define(te[253],ie([0,1,15,7,4,2,3,8]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class u{constructor(p,m,w,f,S,v){if(this.urlService=m,this.logService=v,this.uris=[],this.retryCount=0,this.flushDisposable=A.Disposable.None,this.disposables=new A.DisposableStore,p&&(v.trace("ElectronURLListener initialUrisToHandle:",p.map(c=>c.originalUrl)),this.uris=p),D.isWindows){const c=f.isBuilt?[]:[`"${f.appRoot}"`];c.push("--open-url","--"),E.app.setAsDefaultProtocolClient(S.urlProtocol,process.execPath,c)}const s=r.Event.map(r.Event.fromNodeEventEmitter(E.app,"open-url",(c,y)=>({event:c,url:y})),({event:c,url:y})=>(c.preventDefault(),y));this.disposables.add(s(c=>{const y=this.uriFromRawUrl(c);y&&this.urlService.open(y,{originalUrl:c})})),w.getWindows().filter(c=>c.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),r.Event.once(w.onDidSignalReadyWindow)(this.flush,this,this.disposables))}uriFromRawUrl(p){try{return k.URI.parse(p)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const p=[];for(const m of this.uris)await this.urlService.open(m.uri,{originalUrl:m.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",m.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",m.originalUrl),p.push(m));p.length!==0&&(this.uris=p,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=u}),define(te[254],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(te[255],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(te[256],ie([0,1,15,2,14,8]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends L.Disposable{constructor(){super();const u=this.handleWebviewRequest.bind(this);E.protocol.registerFileProtocol(r.Schemas.vscodeWebview,u)}handleWebviewRequest(u,l){try{const p=A.URI.parse(u.url),m=D.validWebviewFilePaths.get(p.path);if(typeof m=="string"){const w=`vs/workbench/contrib/webview/browser/pre/${m}`,f=r.FileAccess.asFileUri(w);return l({path:f.fsPath,headers:{...r.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(te[79],ie([0,1,3]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(p){return!!p.workspaceUri}e.isWorkspaceToOpen=L;function r(p){return!!p.folderUri}e.isFolderToOpen=r;function A(p){return!!p.fileUri}e.isFileToOpen=A;function D(p){const m=k(p),w=p.getValue("window.menuBarVisibility");return w==="default"||m==="native"&&w==="compact"||E.isMacintosh&&E.isNative?"classic":w}e.getMenuBarVisibility=D;function k(p){if(E.isWeb)return"custom";const m=p.getValue("window");if(m){if(E.isMacintosh&&m.nativeTabs===!0||E.isMacintosh&&m.nativeFullScreen===!1)return"native";const S=m.titleBarStyle;if(S==="native"||S==="custom")return S}return E.isLinux?"native":"custom"}e.getTitleBarStyle=k;function u(p){if(!E.isWindows||E.isWeb||k(p)==="native")return!1;const m=p.getValue("window.experimental.windowControlsOverlay.enabled");return typeof m=="boolean"?m:!0}e.useWindowControlsOverlay=u;function l(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=l}),define(te[123],ie([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(E||(e.LoadReason=E={}));var L;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(L||(e.UnloadReason=L={}));const r=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=r;var A;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(A||(e.WindowMode=A={}));var D;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(te[28],ie([0,1,6]),function(j,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var L;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(L||(e.OpenContext=L={}))}),define(te[257],ie([0,1,15,22,4,56,2,31,74,110,5,21,28]),function(j,e,E,L,r,A,D,k,u,l,p,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let S=e.ProxyAuthHandler=class extends D.Disposable{constructor(s,g,c,y,b){super(),this.logService=s,this.windowsMainService=g,this.credentialsService=c,this.encryptionMainService=y,this.productService=b,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=f.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const s=r.Event.fromNodeEventEmitter(E.app,"login",(g,c,y,b,C)=>({event:g,webContents:c,req:y,authInfo:b,callback:C}));this._register(s(this.onLogin,this))}async onLogin({event:s,authInfo:g,req:c,callback:y}){if(!g.isProxy)return;if(!this.pendingProxyResolve&&this.state===f.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}s.preventDefault();let b;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),b=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(g);try{b=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}y(b?.username,b?.password)}async resolveProxyCredentials(s){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.doResolveProxyCredentials(s);if(g)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(s){this.logService.trace("auth#doResolveProxyCredentials - enter",s);const g=String((0,A.hash)({scheme:s.scheme,host:s.host,port:s.port}));let c,y;try{const a=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,g);if(a){const i=JSON.parse(await this.encryptionMainService.decrypt(a));c=i.username,y=i.password}}catch(a){this.logService.error(a)}if(this.state!==f.StoredCredentialsUsed&&typeof c=="string"&&typeof y=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=f.StoredCredentialsUsed,{username:c,password:y};const b=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!b){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${b.id} to handle proxy login`);const C={authInfo:s,username:this.sessionCredentials?.username??c,password:this.sessionCredentials?.password??y,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};b.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,C),this.state=f.LoginDialogShown;const t=await new Promise(a=>{const i=async(n,o,d)=>{if(o===C.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${b.id}`),b.win?.webContents.off("ipc-message",i),d){const h={username:d.username,password:d.password};try{if(d.remember){const I=await this.encryptionMainService.encrypt(JSON.stringify(h));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,g,I)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,g)}catch(I){this.logService.error(I)}a({username:h.username,password:h.password})}else a(void 0)};b.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=t,t}};e.ProxyAuthHandler=S=ye([X(0,p.ILogService),X(1,w.IWindowsMainService),X(2,u.ICredentialsMainService),X(3,l.IEncryptionMainService),X(4,m.IProductService)],S)}),define(te[258],ie([0,1,74,5,34,21,28,215]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let u=e.CredentialsNativeMainService=class extends k.BaseCredentialsMainService{constructor(p,m,w,f){super(p),this.environmentMainService=m,this.productService=w,this.windowsMainService=f,this.surfaceKeytarLoadError=S=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",S.message??S)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new E.InMemoryCredentialsProvider,this._keytarCache;const p=await new Promise((m,w)=>{j(["keytar"],m,w)});return await p.findCredentials("test-keytar-loads"),this._keytarCache=p,this._keytarCache}};e.CredentialsNativeMainService=u=ye([X(0,L.ILogService),X(1,r.INativeEnvironmentService),X(2,A.IProductService),X(3,D.IWindowsMainService)],u)}),define(te[259],ie([0,1,15,23,3,8,24,19,62,6,5,122,28]),function(j,e,E,L,r,A,D,k,u,l,p,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,l.createDecorator)(e.ID);let f=e.LaunchMainService=class{constructor(v,s,g,c){this.logService=v,this.windowsMainService=s,this.urlService=g,this.configurationService=c}async start(v,s){this.logService.trace("Received data from other instance: ",v,s),r.isMacintosh&&E.app.focus({steal:!0});const g=this.parseOpenUrl(v);if(g.length){let c=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const y=(0,L.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));y&&(c=y.ready())}c.then(()=>{for(const{uri:y,originalUrl:b}of g)this.urlService.open(y,{originalUrl:b})})}else return this.startOpenWindow(v,s)}parseOpenUrl(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,L.coalesce)(v._urls.map(s=>{try{return{uri:A.URI.parse(s),originalUrl:s}}catch{return null}})):[]}async startOpenWindow(v,s){const g=(0,u.isLaunchedFromCli)(s)?0:4;let c=[];const y=v.wait&&v.waitMarkerFilePath?A.URI.file(v.waitMarkerFilePath):void 0,b=v.remote||void 0,C={context:g,cli:v,userEnv:s,waitMarkerFileURI:y,remoteAuthority:b,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,C);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||v["unity-launch"]||C.forceProfile||C.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!r.isMacintosh}if(t)c=await this.windowsMainService.open({...C,forceNewWindow:!0,forceEmpty:!0});else{const a=this.windowsMainService.getLastActiveWindow();a?(this.windowsMainService.openExistingWindow(a,C),c=[a]):c=await this.windowsMainService.open({...C,forceEmpty:!0})}}else c=await this.windowsMainService.open({...C,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(y&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,D.whenDeleted)(y.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=f=ye([X(0,p.ILogService),X(1,w.IWindowsMainService),X(2,m.IURLService),X(3,k.IConfigurationService)],f)}),define(te[260],ie([0,1,15,4,2,256,28]),function(j,e,E,L,r,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=e.WebviewMainService=class extends r.Disposable{constructor(l){super(),this.windowsMainService=l,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new A.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(l,p){let m;if(typeof l.windowId=="number"){const{windowId:w}=l,f=this.windowsMainService.getWindowById(w);if(!f?.win)throw new Error(`Invalid windowId: ${w}`);m=f.win.webContents}else{const{webContentsId:w}=l;if(m=E.webContents.fromId(w),!m)throw new Error(`Invalid webContentsId: ${w}`)}m.isDestroyed()||m.setIgnoreMenuShortcuts(p)}async findInFrame(l,p,m,w){const S=this.getFrameByName(l,p);if(typeof S.findInFrame=="function"){S.findInFrame(m,{findNext:w.findNext,forward:w.forward});const v=(s,g)=>{g.finalUpdate&&(this._onFoundInFrame.fire(g),S.removeListener("found-in-frame",v))};S.on("found-in-frame",v)}}async stopFindInFrame(l,p,m){const f=this.getFrameByName(l,p);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(m.keepSelection?"keepSelection":"clearSelection")}getFrameByName(l,p){const m=this.windowsMainService.getWindowById(l.windowId);if(!m?.win)throw new Error(`Invalid windowId: ${l}`);const w=m.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===p);if(!w)throw new Error(`Unknown frame: ${p}`);return w}};e.WebviewMainService=k=ye([X(0,D.IWindowsMainService)],k)}),define(te[261],ie([0,1,7,4,2]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends r.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:u,getActiveWindowId:l}){super(),this.disposables=this._register(new r.DisposableStore),L.Event.latch(L.Event.any(k,u))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,E.createCancelablePromise)(()=>l()),(async()=>{try{const m=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:m}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(k){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=k}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(te[29],ie([0,1,187,9,61,18,8,6,14]),function(j,e,E,L,r,A,D,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function l(n){const o=n;return typeof o?.id=="string"&&D.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=l;function p(n){return typeof n?.id=="string"&&!l(n)&&!w(n)}e.isEmptyWorkspaceIdentifier=p,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function m(n,o){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,L.basename)(n)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const d=n;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.toWorkspaceIdentifier=m;function w(n){const o=n;return typeof o?.id=="string"&&D.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=w;function f(n){const o=n;if(o?.uri)return{id:o.id,uri:D.URI.revive(o.uri)};const d=n;if(d?.configPath)return{id:d.id,configPath:D.URI.revive(d.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=f;var S;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function v(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=v;function s(n){const o=n;return!!(o&&typeof o=="object"&&D.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=s;class g{constructor(o,d,h,I,R){this._id=o,this._transient=h,this._configuration=I,this._ignorePathCasing=R,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=d}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class c{constructor(o,d){this.raw=d,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,A.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function y(n){return new c({uri:n,index:0,name:(0,A.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(n,o){return A.extUriBiasedIgnorePathCase.isEqualOrParent(n,o.untitledWorkspacesHome)}e.isUntitledWorkspace=b;function C(n){let o;return D.URI.isUri(n)?o=n:o=n.configuration,o?.scheme===u.Schemas.tmp}e.isTemporaryWorkspace=C,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(n,o){return!b(n,o)&&!C(n)}e.isSavedWorkspace=a;function i(n){return(typeof n=="string"?(0,L.extname)(n):(0,A.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(te[58],ie([0,1,15,7,56,44,2,82,3,11,24,164,89,6,5,21,29]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,f.createDecorator)("dialogMainService");let g=e.DialogMainService=class{constructor(y,b){this.logService=y,this.productService=b,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(y,b){return this.doPick({...y,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},b)}pickFolder(y,b){return this.doPick({...y,pickFolders:!0,title:(0,m.localize)(1,null)},b)}pickFile(y,b){return this.doPick({...y,pickFiles:!0,title:(0,m.localize)(2,null)},b)}pickWorkspace(y,b){const C=(0,m.localize)(3,null),t=(0,A.mnemonicButtonLabel)((0,m.localize)(4,null)),a=s.WORKSPACE_FILTER;return this.doPick({...y,pickFiles:!0,title:C,filters:a,buttonLabel:t},b)}async doPick(y,b){const C={title:y.title,buttonLabel:y.buttonLabel,filters:y.filters,defaultPath:y.defaultPath};(typeof y.pickFiles=="boolean"||typeof y.pickFolders=="boolean")&&(C.properties=void 0,y.pickFiles&&y.pickFolders&&(C.properties=["multiSelections","openDirectory","openFile","createDirectory"])),C.properties||(C.properties=["multiSelections",y.pickFolders?"openDirectory":"openFile","createDirectory"]),u.isMacintosh&&C.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(C,(0,l.withNullAsUndefined)(b||E.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}getWindowDialogQueue(y){if(y){let b=this.windowDialogQueues.get(y.id);return b||(b=new L.Queue,this.windowDialogQueues.set(y.id,b)),b}else return this.noWindowDialogueQueue}showMessageBox(y,b){return this.getWindowDialogQueue(b).queue(async()=>{const{options:C,buttonIndeces:t}=(0,w.massageMessageBoxOptions)(y,this.productService);let a;return b?a=await E.dialog.showMessageBox(b,C):a=await E.dialog.showMessageBox(C),{response:t[a.response],checkboxChecked:a.checkboxChecked}})}async showSaveDialog(y,b){const C=this.acquireFileDialogLock(y,b);if(!C)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(b).queue(async()=>{let t;return b?t=await E.dialog.showSaveDialog(b,y):t=await E.dialog.showSaveDialog(y),t.filePath=this.normalizePath(t.filePath),t})}finally{(0,D.dispose)(C)}}normalizePath(y){return y&&u.isMacintosh&&(y=(0,k.normalizeNFC)(y)),y}normalizePaths(y){return y.map(b=>this.normalizePath(b))}async showOpenDialog(y,b){y.defaultPath&&(await p.Promises.exists(y.defaultPath)||(y.defaultPath=void 0));const C=this.acquireFileDialogLock(y,b);if(!C)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(b).queue(async()=>{let t;return b?t=await E.dialog.showOpenDialog(b,y):t=await E.dialog.showOpenDialog(y),t.filePaths=this.normalizePaths(t.filePaths),t})}finally{(0,D.dispose)(C)}}acquireFileDialogLock(y,b){if(!b)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",y);let C=this.windowFileDialogLocks.get(b.id);C||(C=new Set,this.windowFileDialogLocks.set(b.id,C));const t=(0,r.hash)(y);if(!C.has(t))return this.logService.trace("[DialogMainService]: new file dialog lock created",y),C.add(t),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",y),C?.delete(t),C?.size===0&&this.windowFileDialogLocks.delete(b.id)})}};e.DialogMainService=g=ye([X(0,S.ILogService),X(1,v.IProductService)],g)}),define(te[262],ie([0,1,4,2,84,29]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends L.Disposable{constructor(u,l){super(),this.logService=u,this.storageMainService=l,this.onDidChangeApplicationStorageEmitter=this._register(new E.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(l.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(u,l){this._register(E.Event.debounce(u.onDidChangeStorage,(p,m)=>(p?p.push(m):p=[m],p),D.STORAGE_CHANGE_DEBOUNCE_TIME)(p=>{p.length&&l.fire(this.serializeStorageChangeEvents(p,u))}))}serializeStorageChangeEvents(u,l){const p=new Map,m=new Set;return u.forEach(w=>{const f=l.get(w.key);typeof f=="string"?p.set(w.key,f):m.add(w.key)}),{changed:Array.from(p.entries()),deleted:Array.from(m.values())}}listen(u,l,p){switch(l){case"onDidChangeStorage":{const m=p.profile?(0,r.revive)(p.profile):void 0;if(!m)return this.onDidChangeApplicationStorageEmitter.event;let w=this.mapProfileToOnDidChangeProfileStorageEmitter.get(m.id);return w||(w=this._register(new E.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(m),w),this.mapProfileToOnDidChangeProfileStorageEmitter.set(m.id,w)),w.event}}throw new Error(`Event not found: ${l}`)}async call(u,l,p){const m=p.profile?(0,r.revive)(p.profile):void 0,w=(0,A.reviveIdentifier)(p.workspace),f=await this.withStorageInitialized(m,w);switch(l){case"getItems":return Array.from(f.items.entries());case"updateItems":{const S=p;if(S.insert)for(const[v,s]of S.insert)f.set(v,s);S.delete?.forEach(v=>f.delete(v));break}case"isUsed":{const S=p.payload;if(typeof S=="string")return this.storageMainService.isUsed(S)}default:throw new Error(`Call not found: ${l}`)}}async withStorageInitialized(u,l){let p;l?p=this.storageMainService.workspaceStorage(l):u?p=this.storageMainService.profileStorage(u):p=this.storageMainService.applicationStorage;try{await p.init()}catch(m){this.logService.error(`StorageIPC#init: Unable to init ${l?"workspace":u?"profile":"application"} storage due to ${m}`)}return p}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(te[39],ie([0,1,56,4,2,18,8,184,34,16,6,5,29,35,38,7,31,27,11]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.isUserDataProfile=y,e.IUserDataProfilesService=(0,p.createDecorator)("IUserDataProfilesService");function b(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=b;function C(i,n,o,d,h){return{id:i,name:n,location:o,isDefault:!1,shortName:h?.shortName,globalStorageHome:(0,A.joinPath)(o,"globalStorage"),settingsResource:(0,A.joinPath)(o,"settings.json"),keybindingsResource:(0,A.joinPath)(o,"keybindings.json"),tasksResource:(0,A.joinPath)(o,"tasks.json"),snippetsHome:(0,A.joinPath)(o,"snippets"),extensionsResource:(0,A.joinPath)(o,"extensions.json"),cacheHome:(0,A.joinPath)(d,i),useDefaultFlags:h?.useDefaultFlags,isTransient:h?.transient}}e.toUserDataProfile=C;let t=e.UserDataProfilesService=class extends r.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,d,h){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=d,this.logService=h,this.enabled=!0,this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new L.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new L.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new L.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=[];if(this.enabled)try{for(const I of this.getStoredProfiles()){if(!I.name||!(0,c.isString)(I.name)||!I.location){this.logService.warn("Skipping the invalid stored profile",I.location||I.name);continue}n.push(C((0,A.basename)(I.location),I.name,I.location,this.profilesCacheHome,{shortName:I.shortName,useDefaultFlags:I.useDefaultFlags}))}}catch(I){this.logService.error(I)}const o=new f.ResourceMap,d=new Map,h=this.createDefaultProfile();if(n.unshift({...h,extensionsResource:this.getDefaultProfileExtensionsLocation()??h.extensionsResource,isDefault:!0}),n.length)try{const I=this.getStoredProfileAssociations();if(I.workspaces)for(const[R,M]of Object.entries(I.workspaces)){const T=D.URI.parse(R),W=n.find(z=>z.id===M);W&&o.set(T,W)}if(I.emptyWindows)for(const[R,M]of Object.entries(I.emptyWindows)){const T=n.find(W=>W.id===M);T&&d.set(R,T)}}catch(I){this.logService.error(I)}this._profilesObject={profiles:n,workspaces:o,emptyWindows:d}}return this._profilesObject}createDefaultProfile(){return C("__default__profile__",(0,k.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome)}async createTransientProfile(n){const o="Temp",d=new RegExp(`${(0,g.escapeRegExpCharacters)(o)}\\s(\\d+)`);let h=0;for(const R of this.profiles){const M=d.exec(R.name),T=M?parseInt(M[1]):0;h=T>h?T:h}const I=`${o} ${h+1}`;return this.createProfile((0,E.hash)((0,s.generateUuid)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,o,d){return this.createProfile((0,E.hash)((0,s.generateUuid)()).toString(16),n,o,d)}async createProfile(n,o,d,h){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const I=await this.doCreateProfile(n,o,d);return h&&await this.setProfileForWorkspace(h,I),I}async doCreateProfile(n,o,d){if(!(0,c.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let h=this.profileCreationPromises.get(o);return h||(h=(async()=>{try{const I=this.profiles.find(T=>T.name===o||T.id===n);if(I)return I;const R=C(n,o,(0,A.joinPath)(this.profilesHome,n),this.profilesCacheHome,d);await this.fileService.createFolder(R.location);const M=[];return this._onWillCreateProfile.fire({profile:R,join(T){M.push(T)}}),await v.Promises.settled(M),this.updateProfiles([R],[],[]),R}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,h)),h}async updateProfile(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let d=this.profiles.find(h=>h.id===n.id);if(!d)throw new Error(`Profile '${n.name}' does not exist`);return d=C(d.id,o.name??d.name,d.location,this.profilesCacheHome,{shortName:o.shortName??d.shortName,transient:o.transient??d.isTransient,useDefaultFlags:o.useDefaultFlags??d.useDefaultFlags}),this.updateProfiles([],[],[d]),d}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(h=>h.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const d=[];this._onWillRemoveProfile.fire({profile:o,join(h){d.push(h)}});try{await Promise.allSettled(d)}catch(h){this.logService.error(h)}for(const h of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(h)?.id&&this.profilesObject.emptyWindows.delete(h);for(const h of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(h)?.id&&this.profilesObject.workspaces.delete(h);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(h){(0,l.toFileOperationResult)(h)!==1&&this.logService.error(h)}try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(h){this.logService.error(h)}}async setProfileForWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const d=this.profiles.find(h=>h.id===o.id);if(!d)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,d)}unsetWorkspace(n,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(d=>!this.uriIdentityService.extUri.isEqual(d.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return D.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(n){return(0,w.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,w.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,d){const h=[...this.profiles,...n],I=[];this.transientProfilesObject.profiles=[];for(let R of h)R.isDefault||o.some(M=>R.id===M.id)||(R=d.find(M=>R.id===M.id)??R,R.isTransient?this.transientProfilesObject.profiles.push(R):I.push({location:R.location,name:R.name,shortName:R.shortName,useDefaultFlags:R.useDefaultFlags}));this.saveStoredProfiles(I),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,d)}triggerProfilesChanges(n,o,d){this._onDidChangeProfiles.fire({added:n,removed:o,updated:d,all:this.profiles})}updateWorkspaceAssociation(n,o,d){d=o?.isTransient?!0:d,d||this.updateWorkspaceAssociation(n,void 0,!0);const h=this.getWorkspace(n),I=d?this.transientProfilesObject:this.profilesObject;D.URI.isUri(h)?(I.workspaces.delete(h),o&&I.workspaces.set(h,o)):(I.emptyWindows.delete(h),o&&I.emptyWindows.set(h,o)),d||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[d,h]of this.profilesObject.workspaces.entries())n[d.toString()]=h.id;const o={};for(const[d,h]of this.profilesObject.emptyWindows.entries())o[d.toString()]=h.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const o={},d=this.createDefaultProfile();if(n.workspaces)for(const[I,R]of Object.entries(n.workspaces)){const M=D.URI.parse(R);o[I]=this.uriIdentityService.extUri.isEqual(M,d.location)?d.id:this.uriIdentityService.extUri.basename(M)}const h={};if(n.emptyWindows)for(const[I,R]of Object.entries(n.emptyWindows)){const M=D.URI.parse(R);h[I]=this.uriIdentityService.extUri.isEqual(M,d.location)?d.id:this.uriIdentityService.extUri.basename(M)}return{workspaces:o,emptyWindows:h}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};t.PROFILES_KEY="userDataProfiles",t.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e.UserDataProfilesService=t=ye([X(0,u.IEnvironmentService),X(1,l.IFileService),X(2,S.IUriIdentityService),X(3,m.ILogService)],t);class a extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=a}),define(te[80],ie([0,1,7,17,2,4,35,8,111,118,16,6,5,39,38,11,13,25]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class y extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=y,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let b=e.AbstractExtensionsProfileScannerService=class extends r.Disposable{constructor(i,n,o,d,h,I){super(),this.extensionsLocation=i,this.fileService=n,this.userDataProfilesService=o,this.uriIdentityService=d,this.telemetryService=h,this.logService=I,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new D.ResourceMap}scanProfileExtensions(i,n){return this.withProfileExtensions(i,void 0,n)}async addExtensionsToProfile(i,n){const o=[],d=[];try{return await this.withProfileExtensions(n,h=>{const I=[];for(const R of h)i.some(([M])=>(0,l.areSameExtensions)(M.identifier,R.identifier)&&M.manifest.version!==R.version)?o.push(R):I.push(R);for(const[R,M]of i)if(!I.some(T=>(0,l.areSameExtensions)(T.identifier,R.identifier)&&T.version===R.manifest.version)){const T={identifier:R.identifier,version:R.manifest.version,location:R.location,metadata:M};d.push(T),I.push(T)}return d.length&&this._onAddExtensions.fire({extensions:d,profileLocation:n}),o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:n}),I}),d.length&&this._onDidAddExtensions.fire({extensions:d,profileLocation:n}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:n}),d}catch(h){throw d.length&&this._onDidAddExtensions.fire({extensions:d,error:h,profileLocation:n}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:h,profileLocation:n}),h}}async updateMetadata(i,n){const o=[];return await this.withProfileExtensions(n,d=>{const h=[];for(const I of d){const R=i.find(([M])=>(0,l.areSameExtensions)(M.identifier,I.identifier)&&M.manifest.version===I.version);R&&(I.metadata={...I.metadata,...R[1]},o.push(I)),h.push(I)}return h}),o}async removeExtensionFromProfile(i,n){const o=[];this._onRemoveExtensions.fire({extensions:o,profileLocation:n});try{await this.withProfileExtensions(n,d=>{const h=[];for(const I of d)(0,l.areSameExtensions)(I.identifier,i.identifier)?o.push(I):h.push(I);return o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:n}),h}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:n})}catch(d){throw o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:d,profileLocation:n}),d}}async withProfileExtensions(i,n,o){return this.getResourceAccessQueue(i).queue(async()=>{let d=[],h;try{const I=await this.fileService.readFile(i);h=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,p.toFileOperationResult)(I)!==1)throw I;if(this.uriIdentityService.extUri.isEqual(i,this.userDataProfilesService.defaultProfile.extensionsResource)&&(h=await this.migrateFromOldDefaultProfileExtensionsLocation()),!h&&o?.bailOutWhenFileNotFound)throw new y((0,s.getErrorMessage)(I),"ERROR_PROFILE_NOT_FOUND")}if(h){Array.isArray(h)||this.reportAndThrowInvalidConentError(i);let I=!1;for(const R of h){C(R)||this.reportAndThrowInvalidConentError(i);let M;if((0,v.isString)(R.relativeLocation)&&R.relativeLocation)M=this.resolveExtensionLocation(R.relativeLocation);else if((0,v.isString)(R.location))M=this.resolveExtensionLocation(R.location),I=!0,R.relativeLocation=R.location,R.location=M.toJSON();else{M=k.URI.revive(R.location);const T=this.toRelativePath(M);T&&(I=!0,R.relativeLocation=T)}d.push({identifier:R.identifier,location:M,version:R.version,metadata:R.metadata})}I&&await this.fileService.writeFile(i,L.VSBuffer.fromString(JSON.stringify(h)))}if(n){d=n(d);const I=d.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.toRelativePath(R.location),metadata:R.metadata}));await this.fileService.writeFile(i,L.VSBuffer.fromString(JSON.stringify(I)))}return d})}reportAndThrowInvalidConentError(i){const n=new y(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(i){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(i),this.extensionsLocation)?this.uriIdentityService.extUri.basename(i):void 0}resolveExtensionLocation(i){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,i)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const i=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),n=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let o;try{o=(await this.fileService.readFile(i)).value.toString()}catch(h){if((0,p.toFileOperationResult)(h)===1)return;throw h}this.logService.info("Migrating extensions from old default profile location",i.toString());let d;try{const h=JSON.parse(o);Array.isArray(h)&&h.every(I=>C(I))?d=h:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.logService.error(h)}if(d)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(d)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(h){if((0,p.toFileOperationResult)(h)===3)this.logService.info("Migration from old default profile location to new location is done by another window",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw h}try{await this.fileService.del(i)}catch(h){(0,p.toFileOperationResult)(h)!==1&&this.logService.error(h)}try{await this.fileService.del(n)}catch(h){(0,p.toFileOperationResult)(h)!==1&&this.logService.error(h)}return d})()),this._migrationPromise}getResourceAccessQueue(i){let n=this.resourcesAccessQueueMap.get(i);return n||(n=new E.Queue,this.resourcesAccessQueueMap.set(i,n)),n}};e.AbstractExtensionsProfileScannerService=b=ye([X(1,p.IFileService),X(2,f.IUserDataProfilesService),X(3,S.IUriIdentityService),X(4,g.ITelemetryService),X(5,w.ILogService)],b);function C(a){return(0,v.isObject)(a)&&(0,u.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,v.isString)(a.location)&&a.location)&&((0,v.isUndefined)(a.relativeLocation)||(0,v.isString)(a.relativeLocation))&&a.version&&(0,v.isString)(a.version)}function t(a){return a?(0,v.isString)(a.path)&&(0,v.isString)(a.scheme):!1}}),define(te[124],ie([0,1,23,7,40,17,13,43,146,2,14,9,3,18,200,72,11,8,169,34,118,115,199,16,6,5,21,4,84,80,39,38,198]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y,b,C,t,a,i,n,o,d,h,I,R,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var W;(function(ce){function K(q,N){if(q===N)return!0;const $=Object.keys(q),G=new Set;for(const ee of Object.keys(N))G.add(ee);if($.length!==G.size)return!1;for(const ee of $){if(q[ee]!==N[ee])return!1;G.delete(ee)}return G.size===0}ce.equals=K})(W||(e.Translations=W={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let z=e.AbstractExtensionsScannerService=class extends l.Disposable{constructor(K,q,N,$,G,ee,oe,le,Y,_,P,O){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=q,this.extensionsControlLocation=N,this.currentProfile=$,this.userDataProfilesService=G,this.extensionsProfileScannerService=ee,this.fileService=oe,this.logService=le,this.environmentService=Y,this.productService=_,this.uriIdentityService=P,this.instantiationService=O,this._onDidChangeCache=this._register(new d.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(J,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,b.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,q,N){const[$,G]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(q)]),ee=N?await this.scanExtensionsUnderDevelopment(K,[...$,...G]):[];return this.dedupExtensions($,G,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const q=[];q.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),q.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[N,$]=await Promise.all(q);return this.applyScanOptions([...N,...$],0,K,!1)}async scanUserExtensions(K){const q=K.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",q);const N=this.uriIdentityService.extUri.isEqual(K.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,$=await this.createExtensionScannerInput(q,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,N),G=K.useCache&&!$.devMode&&$.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let ee;try{ee=await G.scanExtensions($)}catch(oe){if(oe instanceof I.ExtensionsProfileScanningError&&oe.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),ee=await G.scanExtensions($);else throw oe}return ee=await this.applyScanOptions(ee,1,K,!0),this.logService.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(K,q){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const N=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter($=>$.scheme===p.Schemas.file).map(async $=>{const G=await this.createExtensionScannerInput($,!1,1,!0,K.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(G)).map(oe=>(oe.type=q.find(le=>(0,b.areSameExtensions)(le.identifier,oe.identifier))?.type??oe.type,this.extensionsScanner.validate(oe,G)))}))).flat();return this.applyScanOptions(N,"development",K,!0)}return[]}async scanExistingExtension(K,q,N){const $=await this.createExtensionScannerInput(K,!1,q,!0,N.language,!0,void 0),G=await this.extensionsScanner.scanExtension($);return!G||!N.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(K,q,N){const $=await this.createExtensionScannerInput(K,!1,q,!0,N.language,!0,void 0),G=await this.extensionsScanner.scanOneOrMultipleExtensions($);return this.applyScanOptions(G,q,N,!0)}async scanMetadata(K){const q=(0,f.joinPath)(K,"package.json"),N=(await this.fileService.readFile(q)).value.toString();return JSON.parse(N).__metadata}async updateMetadata(K,q){const N=(0,f.joinPath)(K,"package.json"),$=(await this.fileService.readFile(N)).value.toString(),G=JSON.parse($);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,G.__metadata={...G.__metadata,...q},await this.fileService.writeFile((0,f.joinPath)(K,"package.json"),A.VSBuffer.fromString(JSON.stringify(G,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof I.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw K}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.extensionsProfileScannerService.addExtensionsToProfile(K.map(q=>[q,q.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(q){(0,a.toFileOperationResult)(q)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(q))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.logService.error(K)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(K,q,N,$){return N.includeAllVersions||(K=this.dedupExtensions(q===0?K:void 0,q===1?K:void 0,q==="development"?K:void 0,await this.getTargetPlatform(),$)),N.includeInvalid||(K=K.filter(G=>G.isValid)),K.sort((G,ee)=>{const oe=m.basename(G.location.fsPath),le=m.basename(ee.location.fsPath);return oe<le?-1:oe>le?1:0})}dedupExtensions(K,q,N,$,G){const ee=(le,Y,_)=>{if(le.isValid&&!Y.isValid)return!1;if(le.isValid===Y.isValid){if(G&&S.gt(le.manifest.version,Y.manifest.version))return this.logService.debug(`Skipping extension ${Y.location.path} with lower version ${Y.manifest.version} in favour of ${le.location.path} with version ${le.manifest.version}`),!1;if(S.eq(le.manifest.version,Y.manifest.version)){if(le.type===0)return this.logService.debug(`Skipping extension ${Y.location.path} in favour of system extension ${le.location.path} with same version`),!1;if(le.targetPlatform===$)return this.logService.debug(`Skipping extension ${Y.location.path} from different target platform ${Y.targetPlatform}`),!1}}return _?this.logService.warn(`Overwriting user extension ${le.location.path} with ${Y.location.path}.`):this.logService.debug(`Overwriting user extension ${le.location.path} with ${Y.location.path}.`),!0},oe=new C.ExtensionIdentifierMap;return K?.forEach(le=>{const Y=oe.get(le.identifier.id);(!Y||ee(Y,le,!1))&&oe.set(le.identifier.id,le)}),q?.forEach(le=>{const Y=oe.get(le.identifier.id);if(!Y&&K&&le.type===0){this.logService.debug(`Skipping obsolete system extension ${le.location.path}.`);return}(!Y||ee(Y,le,!1))&&oe.set(le.identifier.id,le)}),N?.forEach(le=>{const Y=oe.get(le.identifier.id);(!Y||ee(Y,le,!0))&&oe.set(le.identifier.id,le),oe.set(le.identifier.id,le)}),[...oe.values()]}async scanDefaultSystemExtensions(K,q){this.logService.trace("Started scanning system extensions");const N=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,q,!0,void 0),G=await(K&&!N.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return this.logService.trace("Scanned system extensions:",G.length),G}async scanDevSystemExtensions(K,q){const N=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!N?.length)return[];this.logService.trace("Started scanning dev system extensions");const $=q?await this.getBuiltInExtensionControl():{},G=[],ee=g.URI.file(m.normalize(m.join(p.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const le of N){const Y=$[le.name]||"marketplace";switch(Y){case"disabled":break;case"marketplace":G.push((0,f.joinPath)(ee,le.name));break;default:G.push(g.URI.file(Y));break}}const oe=await Promise.all(G.map(async le=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(le,!1,0,!0,K,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",oe.length),(0,E.coalesce)(oe)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,q,N,$,G,ee,oe){const le=await this.getTranslations(G??w.language),Y=await this.getMtime(K),_=q&&!this.uriIdentityService.extUri.isEqual(K,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,P=_?await this.getMtime(_):void 0;return new H(K,Y,_,P,q,oe,N,$,ee,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,G,le)}async getMtime(K){try{const q=await this.fileService.stat(K);if(typeof q.mtime=="number")return q.mtime}catch{}}};e.AbstractExtensionsScannerService=z=ye([X(4,R.IUserDataProfilesService),X(5,I.IExtensionsProfileScannerService),X(6,a.IFileService),X(7,n.ILogService),X(8,y.IEnvironmentService),X(9,o.IProductService),X(10,M.IUriIdentityService),X(11,i.IInstantiationService)],z);class H{constructor(K,q,N,$,G,ee,oe,le,Y,_,P,O,U,B,F){this.location=K,this.mtime=q,this.applicationExtensionslocation=N,this.applicationExtensionslocationMtime=$,this.profile=G,this.profileScanOptions=ee,this.type=oe,this.excludeObsolete=le,this.validate=Y,this.productVersion=_,this.productDate=P,this.productCommit=O,this.devMode=U,this.language=B,this.translations=F}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,q){return(0,f.isEqual)(K.location,q.location)&&K.mtime===q.mtime&&(0,f.isEqual)(K.applicationExtensionslocation,q.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&K.profile===q.profile&&r.equals(K.profileScanOptions,q.profileScanOptions)&&K.type===q.type&&K.excludeObsolete===q.excludeObsolete&&K.validate===q.validate&&K.productVersion===q.productVersion&&K.productDate===q.productDate&&K.productCommit===q.productCommit&&K.devMode===q.devMode&&K.language===q.language&&W.equals(K.translations,q.translations)}}e.ExtensionScannerInput=H;let J=class extends l.Disposable{constructor(K,q,N,$,G){super(),this.obsoleteFile=K,this.extensionsProfileScannerService=q,this.uriIdentityService=N,this.fileService=$,this.logService=G}async scanExtensions(K){const q=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let N={};if(K.excludeObsolete&&K.type===1)try{const $=(await this.fileService.readFile(this.obsoleteFile)).value.toString();N=JSON.parse($)}catch{}return(0,s.isEmptyObject)(N)?q:q.filter($=>!N[b.ExtensionKey.create($).toString()])}async scanExtensionsFromLocation(K){const q=await this.fileService.resolve(K.location);if(!q.children?.length)return[];const N=await Promise.all(q.children.map(async $=>{if(!$.isDirectory||K.type===1&&(0,f.basename)($.resource).indexOf(".")===0)return null;const G=new H($.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(G)}));return(0,E.coalesce)(N).sort(($,G)=>$.location.path<G.location.path?-1:1)}async scanExtensionsFromProfile(K){let q=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){q=q.filter($=>!$.metadata?.isApplicationScoped);const N=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,$=>!!$.metadata?.isBuiltin||!!$.metadata?.isApplicationScoped,K);q.push(...N)}return q}async scanExtensionsFromProfileResource(K,q,N){const $=await this.extensionsProfileScannerService.scanProfileExtensions(K,N.profileScanOptions);if(!$.length)return[];const G=await Promise.all($.map(async ee=>{if(q(ee)){const oe=new H(ee.location,N.mtime,N.applicationExtensionslocation,N.applicationExtensionslocationMtime,N.profile,N.profileScanOptions,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations);return this.scanExtension(oe,ee.metadata)}return null}));return(0,E.coalesce)(G)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,f.joinPath)(K.location,"package.json"))){const q=await this.scanExtension(K);return q?[q]:[]}else return await this.scanExtensions(K)}catch(q){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,D.getErrorMessage)(q)),[]}}async scanExtension(K,q){try{let N=await this.scanExtensionManifest(K.location);if(N){N.publisher||(N.publisher=C.UNDEFINED_PUBLISHER),q=q??N.__metadata,delete N.__metadata;const $=(0,b.getGalleryExtensionId)(N.publisher,N.name),G=q?.id?{id:$,uuid:q.id}:{id:$},ee=q?.isSystem?0:K.type,oe=ee===0||!!q?.isBuiltin;N=await this.translateManifest(K.location,N,H.createNlsConfiguration(K));const le={type:ee,identifier:G,manifest:N,location:K.location,isBuiltin:oe,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return K.validate?this.validate(le,K):le}}catch(N){K.type!==0&&this.logService.error(N)}return null}validate(K,q){let N=!0;const $=(0,t.validateExtensionManifest)(q.productVersion,q.productDate,q.location,K.manifest,K.isBuiltin);for(const[G,ee]of $)G===v.default.Error&&(N=!1,this.logService.error(this.formatMessage(q.location,ee)));return K.isValid=N,K.validations=$,K}async scanExtensionManifest(K){const q=(0,f.joinPath)(K,"package.json");let N;try{N=(await this.fileService.readFile(q)).value.toString()}catch(G){return(0,a.toFileOperationResult)(G)!==1&&this.logService.error(this.formatMessage(K,(0,c.localize)(0,null,q.path,G.message))),null}let $;try{$=JSON.parse(N)}catch{const ee=[];(0,k.parse)(N,ee);for(const oe of ee)this.logService.error(this.formatMessage(K,(0,c.localize)(1,null,q.path,oe.offset,oe.length,(0,u.getParseErrorMessage)(oe.error))));return null}return(0,k.getNodeType)($)!=="object"?(this.logService.error(this.formatMessage(K,(0,c.localize)(2,null,q.path))),null):$}async translateManifest(K,q,N){const $=await this.getLocalizedMessages(K,q,N);if($)try{const G=[],ee=await this.resolveOriginalMessageBundle($.default,G);if(G.length>0)return G.forEach(le=>{this.logService.error(this.formatMessage(K,(0,c.localize)(3,null,$.default?.path,(0,u.getParseErrorMessage)(le.error))))}),q;if((0,k.getNodeType)($)!=="object")return this.logService.error(this.formatMessage(K,(0,c.localize)(4,null,$.default?.path))),q;const oe=$.values||Object.create(null);return(0,T.localizeManifest)(q,oe,ee)}catch{}return q}async getLocalizedMessages(K,q,N){const $=(0,f.joinPath)(K,"package.nls.json"),G=(Y,_)=>{_.forEach(P=>{this.logService.error(this.formatMessage(K,(0,c.localize)(5,null,Y?.path,(0,u.getParseErrorMessage)(P.error))))})},ee=Y=>{this.logService.error(this.formatMessage(K,(0,c.localize)(6,null,Y?.path)))},oe=`${q.publisher}.${q.name}`,le=N.translations[oe];if(le)try{const Y=g.URI.file(le),_=(await this.fileService.readFile(Y)).value.toString(),P=[],O=(0,k.parse)(_,P);return P.length>0?(G(Y,P),{values:void 0,default:$}):(0,k.getNodeType)(O)!=="object"?(ee(Y),{values:void 0,default:$}):{values:O.contents?O.contents.package:void 0,default:$}}catch{return{values:void 0,default:$}}else{if(!await this.fileService.exists($))return;let _;try{_=await this.findMessageBundles(K,N)}catch{return}if(!_.localized)return{values:void 0,default:_.original};try{const P=(await this.fileService.readFile(_.localized)).value.toString(),O=[],U=(0,k.parse)(P,O);return O.length>0?(G(_.localized,O),{values:void 0,default:_.original}):(0,k.getNodeType)(U)!=="object"?(ee(_.localized),{values:void 0,default:_.original}):{values:U,default:_.original}}catch{return{values:void 0,default:_.original}}}}async resolveOriginalMessageBundle(K,q){if(K)try{const N=(await this.fileService.readFile(K)).value.toString();return(0,k.parse)(N,q)}catch{}}findMessageBundles(K,q){return new Promise((N,$)=>{const G=ee=>{const oe=(0,f.joinPath)(K,`package.nls.${ee}.json`);this.fileService.exists(oe).then(le=>{le&&N({localized:oe,original:(0,f.joinPath)(K,"package.nls.json")});const Y=ee.lastIndexOf("-");Y===-1?N({localized:(0,f.joinPath)(K,"package.nls.json"),original:null}):(ee=ee.substring(0,Y),G(ee))})};if(q.devMode||q.pseudo||!q.language)return N({localized:(0,f.joinPath)(K,"package.nls.json"),original:null});G(q.language)})}formatMessage(K,q){return`[${K.path}]: ${q}`}};J=ye([X(1,I.IExtensionsProfileScannerService),X(2,M.IUriIdentityService),X(3,a.IFileService),X(4,n.ILogService)],J);let ne=class extends J{constructor(K,q,N,$,G,ee,oe){super(q,$,G,ee,oe),this.currentProfile=K,this.userDataProfilesService=N,this.cacheValidatorThrottler=this._register(new L.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new d.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const q=this.getCacheFile(K),N=await this.readExtensionCache(q);if(this.input=K,N&&N.input&&H.equals(N.input,this.input))return this.logService.debug("Using cached extensions scan result",K.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),N.result.map(G=>(G.location=g.URI.revive(G.location),G));const $=await super.scanExtensions(K);return await this.writeExtensionCache(q,{input:K,result:$}),$}async readExtensionCache(K){try{const q=await this.fileService.readFile(K),N=JSON.parse(q.value.toString());return{result:N.result,input:(0,h.revive)(N.input)}}catch(q){this.logService.debug("Error while reading the extension cache file:",K.path,(0,D.getErrorMessage)(q))}return null}async writeExtensionCache(K,q){try{await this.fileService.writeFile(K,A.VSBuffer.fromString(JSON.stringify(q)))}catch(N){this.logService.debug("Error while writing the extension cache file:",K.path,(0,D.getErrorMessage)(N))}}async validateCache(){if(!this.input)return;const K=this.getCacheFile(this.input),q=await this.readExtensionCache(K);if(!q)return;const N=q.result,$=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!r.equals($,N))try{this.logService.info("Invalidating Cache",N,$),await this.fileService.del(K),this._onDidChangeCache.fire()}catch(G){this.logService.error(G)}}getCacheFile(K){const q=this.getProfile(K);return this.uriIdentityService.extUri.joinPath(q.cacheHome,K.type===0?C.BUILTIN_MANIFEST_CACHE_FILE:C.USER_MANIFEST_CACHE_FILE)}getProfile(K){return K.type===0?this.userDataProfilesService.defaultProfile:K.profile?this.uriIdentityService.extUri.isEqual(K.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(q=>this.uriIdentityService.extUri.isEqual(K.location,q.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};ne=ye([X(2,R.IUserDataProfilesService),X(3,I.IExtensionsProfileScannerService),X(4,M.IUriIdentityService),X(5,a.IFileService),X(6,n.ILogService)],ne);function re(ce,K){const q=(0,b.getExtensionId)(ce.manifest.publisher,ce.manifest.name);return{id:q,identifier:new C.ExtensionIdentifier(q),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:K,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.toExtensionDescription=re;class ue extends z{constructor(K,q,N,$,G,ee,oe,le,Y,_,P,O){super(K,q,(0,f.joinPath)(N,".vscode-oss-dev","extensions","control.json"),$,G,ee,oe,le,Y,_,P,O),this.translationsPromise=(async()=>{if(w.translationsConfigFile)try{const U=await this.fileService.readFile(g.URI.file(w.translationsConfigFile));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=ue}),define(te[263],ie([0,1,5,39,38,25,80,16,34,8]),function(j,e,E,L,r,A,D,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let p=e.ExtensionsProfileScannerService=class extends D.AbstractExtensionsProfileScannerService{constructor(w,f,S,v,s,g){super(l.URI.file(w.extensionsPath),f,S,v,s,g)}};e.ExtensionsProfileScannerService=p=ye([X(0,u.INativeEnvironmentService),X(1,k.IFileService),X(2,L.IUserDataProfilesService),X(3,r.IUriIdentityService),X(4,A.ITelemetryService),X(5,E.ILogService)],p)}),define(te[264],ie([0,1,8,34,80,124,16,6,5,21,38,39]),function(j,e,E,L,r,A,D,k,u,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=e.ExtensionsScannerService=class extends A.NativeExtensionsScannerService{constructor(S,v,s,g,c,y,b,C){super(E.URI.file(c.builtinExtensionsPath),E.URI.file(c.extensionsPath),c.userHome,S.defaultProfile,S,v,s,g,c,y,b,C)}};e.ExtensionsScannerService=w=ye([X(0,m.IUserDataProfilesService),X(1,r.IExtensionsProfileScannerService),X(2,D.IFileService),X(3,u.ILogService),X(4,L.INativeEnvironmentService),X(5,l.IProductService),X(6,p.IUriIdentityService),X(7,k.IInstantiationService)],w)}),define(te[265],ie([0,1,15,2,14,9,3,61,8,31,42,34,5,39]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let S=e.ProtocolMainService=class extends L.Disposable{constructor(s,g,c){super(),this.environmentService=s,this.logService=c,this.validRoots=k.TernarySearchTree.forPaths(!D.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(s.appRoot),this.addValidFileRoot(s.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(s.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:s}=E.session;s.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(g,c)=>this.handleResourceRequest(g,c)),s.protocol.interceptFileProtocol(r.Schemas.file,(g,c)=>this.handleFileRequest(g,c)),this._register((0,L.toDisposable)(()=>{s.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),s.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(s){const g=(0,A.normalize)(s);return this.validRoots.get(g)?L.Disposable.None:(this.validRoots.set(g,!0),(0,L.toDisposable)(()=>this.validRoots.delete(g)))}handleFileRequest(s,g){const c=u.URI.parse(s.url);return this.logService.error(`Refused to load resource ${c.fsPath} from ${r.Schemas.file}: protocol (original URL: ${s.url})`),g({error:-3})}handleResourceRequest(s,g){const c=this.requestToNormalizedFilePath(s);let y;return this.environmentService.crossOriginIsolated&&((0,A.basename)(c)==="workbench.html"||(0,A.basename)(c)==="workbench-dev.html"?y=r.COI.CoopAndCoep:y=r.COI.getHeadersFromQuery(s.url)),this.validRoots.findSubstr(c)?g({path:c,headers:y}):this.validExtensions.has((0,A.extname)(c).toLowerCase())?g({path:c}):(this.logService.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${c} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${s.url})`),g({error:-3}))}requestToNormalizedFilePath(s){const g=u.URI.parse(s.url),c=r.FileAccess.uriToFileUri(g);return(0,A.normalize)(c.fsPath)}createIPCObjectUrl(){let s;const g=u.URI.from({scheme:"vscode",path:(0,l.generateUuid)()}),c=g.toString(),y=async()=>s;return p.validatedIpcMain.handle(c,y),this.logService.trace(`IPC Object URL: Registered new channel ${c}.`),{resource:g,update:b=>s=b,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${c}.`),p.validatedIpcMain.removeHandler(c)}}}};e.ProtocolMainService=S=ye([X(0,m.INativeEnvironmentService),X(1,f.IUserDataProfilesService),X(2,w.ILogService)],S)}),define(te[94],ie([0,1,7,4,2,64,11,106,6,39]),function(j,e,E,L,r,A,D,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,u.createDecorator)("storageService");var p;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(p||(e.WillSaveStateReason=p={}));var m;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(m||(e.StorageScope=m={}));var w;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function f(c){const y=c.get(e.TARGET_KEY);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}e.loadKeyTargets=f;class S extends r.Disposable{constructor(y={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super(),this.options=y,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new E.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new r.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,E.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,r.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,b){if(b===e.TARGET_KEY){switch(y){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:y})}else this._onDidChangeValue.fire({scope:y,key:b,target:this.getKeyTargets(y)[b]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,b,C){return this.getStorage(b)?.get(y,C)}getBoolean(y,b,C){return this.getStorage(b)?.getBoolean(y,C)}getNumber(y,b,C){return this.getStorage(b)?.getNumber(y,C)}store(y,b,C,t){if((0,D.isUndefinedOrNull)(b)){this.remove(y,C);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,C,t),this.getStorage(C)?.set(y,b)})}remove(y,b){this.withPausedEmitters(()=>{this.updateKeyTarget(y,b,void 0),this.getStorage(b)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,b){const C=[],t=this.getKeyTargets(y);for(const a of Object.keys(t))t[a]===b&&C.push(a);return C}updateKeyTarget(y,b,C){const t=this.getKeyTargets(b);typeof C=="number"?t[y]!==C&&(t[y]=C,this.getStorage(b)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[y]=="number"&&(delete t[y],this.getStorage(b)?.set(e.TARGET_KEY,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(y){switch(y){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(y){const b=this.getStorage(y);return b?f(b):Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=p.NONE){this._onWillSaveState.fire({reason:y});const b=this.getStorage(-1),C=this.getStorage(0),t=this.getStorage(1);switch(y){case p.NONE:await E.Promises.settled([b?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await E.Promises.settled([b?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const y=this.getStorage(-1)?.items??new Map,b=this.getStorage(0)?.items??new Map,C=this.getStorage(1)?.items??new Map;return g(y,b,C,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(y,b){return this.emitWillSaveState(p.NONE),(0,l.isUserDataProfile)(y)?this.switchToProfile(y,b):this.switchToWorkspace(y,b)}canSwitchProfile(y,b){return!(y.id===b.id||v(b)&&v(y))}switchData(y,b,C,t){this.withPausedEmitters(()=>{if(t)for(const[a,i]of y)b.set(a,i);else{const a=new Set;for(const[i,n]of y)a.add(i),b.get(i)!==n&&this.emitDidChangeValue(C,i);for(const[i]of b.items)a.has(i)||this.emitDidChangeValue(C,i)}})}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;function v(c){return c.isDefault||!!c.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class s extends S{constructor(){super(),this.applicationStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.profileStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y))),this._register(this.applicationStorage.onDidChangeStorage(y=>this.emitDidChangeValue(-1,y)))}getStorage(y){switch(y){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(y){switch(y){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(y){return!1}}e.InMemoryStorageService=s;async function g(c,y,b,C,t,a){const i=W=>{try{return JSON.parse(W)}catch{return W}},n=new Map,o=new Map;c.forEach((W,z)=>{n.set(z,W),o.set(z,i(W))});const d=new Map,h=new Map;y.forEach((W,z)=>{d.set(z,W),h.set(z,i(W))});const I=new Map,R=new Map;b.forEach((W,z)=>{I.set(z,W),R.set(z,i(W))}),console.group(C!==t?`Storage: Application (path: ${C})`:`Storage: Application & Profile (path: ${C}, default profile)`);const M=[];if(n.forEach((W,z)=>{M.push({key:z,value:W})}),console.table(M),console.groupEnd(),console.log(o),C!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const W=[];d.forEach((z,H)=>{W.push({key:H,value:z})}),console.table(W),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${a})`);const T=[];I.forEach((W,z)=>{T.push({key:z,value:W})}),console.table(T),console.groupEnd(),console.log(R)}e.logStorage=g}),define(te[266],ie([0,1,23,7,4,2,9,83,8,24,106,158,5,94,25,29]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class s extends A.Disposable{get storage(){return this._storage}constructor(a,i){super(),this.logService=a,this.fileService=i,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new r.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY}),this.initializePromise=void 0,this.whenInitPromise=new L.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=p.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===p.StorageState.None)try{const a=await this.doCreate();this._storage.dispose(),this._storage=a,this._register(a.onDidChangeStorage(n=>this._onDidChangeStorage.fire({key:n}))),await this.doInit(a);const i=a.getBoolean(f.IS_NEW_KEY);i===void 0?a.set(f.IS_NEW_KEY,!0):i&&a.set(f.IS_NEW_KEY,!1)}catch(a){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.state=p.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?a=>this.logService.trace(a):void 0,logError:a=>this.logService.error(a)}}doInit(a){return a.init()}get items(){return this._storage.items}get(a,i){return this._storage.get(a,i)}set(a,i){return this._storage.set(a,i)}delete(a){return this._storage.delete(a)}async close(){const a=new k.StopWatch(!1);await this.doClose(),a.stop(),a.elapsed()>s.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(a),this._onDidCloseStorage.fire()}async logSlowClose(a){if(this.path)try{const i=(0,E.top)(Array.from(this._storage.items.entries()).map(([o,d])=>({key:o,length:d.length})),(o,d)=>d.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.fileService.stat(u.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=p.StorageState.Closed,await this._storage.close()}}s.LOG_SLOW_CLOSE_THRESHOLD=2e3;class g extends s{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,g.STORAGE_NAME)}constructor(a,i,n,o){super(n,o),this.profile=a,this.options=i}async doCreate(){return new p.Storage(new m.SQLiteStorageDatabase(this.path??m.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}g.STORAGE_NAME="state.vscdb";class c extends g{constructor(a,i,n,o){super(a,i,n,o)}}e.ProfileStorageMain=c;class y extends g{constructor(a,i,n,o){super(i.defaultProfile,a,n,o)}async doInit(a){await super.doInit(a),this.updateTelemetryState(a)}updateTelemetryState(a){a.get(S.firstSessionDateStorageKey,void 0)===void 0&&a.set(S.firstSessionDateStorageKey,new Date().toUTCString());const n=a.get(S.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();a.set(S.lastSessionDateStorageKey,typeof n>"u"?null:n),a.set(S.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=y;class b extends s{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,b.WORKSPACE_STORAGE_NAME)}constructor(a,i,n,o,d){super(n,d),this.workspace=a,this.options=i,this.environmentService=o}async doCreate(){const{storageFilePath:a,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new p.Storage(new m.SQLiteStorageDatabase(a,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:i?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:m.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(a,b.WORKSPACE_STORAGE_NAME);return await l.Promises.exists(a)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(a,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(a),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(a){let i;if((0,v.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,D.join)(a,b.WORKSPACE_META_NAME);await l.Promises.exists(n)||await l.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=b,b.WORKSPACE_STORAGE_NAME="state.vscdb",b.WORKSPACE_META_NAME="workspace.json";class C extends s{get path(){}async doCreate(){return new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=C}),define(te[267],ie([0,1,4,2,94]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class A extends L.Disposable{constructor(k,u,l){super(),this.storageMainService=k,this.userDataProfilesService=u,this.logService=l;const p=this._register(new L.MutableDisposable);this._onDidChange=this._register(new E.Emitter({onWillAddFirstListener:()=>p.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>p.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new L.DisposableStore;return k.add(E.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(u,l)=>(u?u.push(l.key):u=[l.key],u),100)(u=>this.onDidChangeApplicationStorage(u))),k.add(E.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(u,l)=>{u||(u=new Map);let p=u.get(l.profile.id);return p||u.set(l.profile.id,p={profile:l.profile,keys:[],storage:l.storage}),p.keys.push(l.key),u},100)(u=>this.onDidChangeProfileStorage(u))),k}onDidChangeApplicationStorage(k){const u=k.includes(r.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],l=[];if(k=k.filter(p=>p!==r.TARGET_KEY),k.length){const p=(0,r.loadKeyTargets)(this.storageMainService.applicationStorage.storage);l.push({profile:this.userDataProfilesService.defaultProfile,changes:k.map(m=>({key:m,scope:0,target:p[m]}))})}this.triggerEvents(u,l)}onDidChangeProfileStorage(k){const u=[],l=new Map;for(const[p,m]of k.entries()){m.keys.includes(r.TARGET_KEY)&&u.push(m.profile);const w=m.keys.filter(f=>f!==r.TARGET_KEY);if(w.length){const f=(0,r.loadKeyTargets)(m.storage.storage);l.set(p,{profile:m.profile,changes:w.map(S=>({key:S,scope:0,target:f[S]}))})}}this.triggerEvents(u,[...l.values()])}triggerEvents(k,u){(k.length||u.length)&&this._onDidChange.fire({valueChanges:u,targetChanges:k})}listen(k,u,l){switch(u){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${u}`)}async call(k,u){throw new Error(`Call not found: ${u}`)}}e.ProfileStorageChangesListenerChannel=A}),define(te[268],ie([0,1,8,34,16,5,33,38,39,11,117]),function(j,e,E,L,r,A,D,k,u,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let m=e.UserDataProfilesReadonlyService=class ft extends u.UserDataProfilesService{constructor(v,s,g,c,y){super(g,c,s,y),this.stateReadonlyService=v,this.nativeEnvironmentService=g}getStoredProfiles(){return this.stateReadonlyService.getItem(ft.PROFILES_KEY,[]).map(s=>({...s,location:(0,l.isString)(s.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,s.location):E.URI.revive(s.location)}))}getStoredProfileAssociations(){const v=this.stateReadonlyService.getItem(ft.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(ft.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?v:this.migrateStoredProfileAssociations(v)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(E.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};m.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration",e.UserDataProfilesReadonlyService=m=ye([X(0,D.IStateReadService),X(1,k.IUriIdentityService),X(2,L.INativeEnvironmentService),X(3,r.IFileService),X(4,A.ILogService)],m);let w=e.UserDataProfilesService=class rt extends m{constructor(v,s,g,c,y){super(v,s,g,c,y),this.stateService=v}saveStoredProfiles(v){v.length?this.stateService.setItem(rt.PROFILES_KEY,v.map(s=>({...s,location:this.uriIdentityService.extUri.basename(s.location)}))):this.stateService.removeItem(rt.PROFILES_KEY)}getStoredProfiles(){const v=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(v),this.stateService.setItem("userDataProfilesMigration",!0)),v}saveStoredProfileAssociations(v){v.emptyWindows||v.workspaces?this.stateService.setItem(rt.PROFILE_ASSOCIATIONS_KEY,v):this.stateService.removeItem(rt.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const v="workspaceAndProfileInfo",s=this.stateService.getItem(v,void 0);if(s){this.stateService.removeItem(v);const c=s.reduce((y,{workspace:b,profile:C})=>(y[E.URI.revive(b).toString()]=E.URI.revive(C).toString(),y),{});this.stateService.setItem(rt.PROFILE_ASSOCIATIONS_KEY,{workspaces:c})}const g=super.getStoredProfileAssociations();return this.stateService.getItem(rt.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(g),this.stateService.setItem(rt.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),g}};e.UserDataProfilesService=w=ye([X(0,D.IStateService),X(1,k.IUriIdentityService),X(2,L.INativeEnvironmentService),X(3,r.IFileService),X(4,A.ILogService)],w);let f=e.ServerUserDataProfilesService=class extends w{constructor(v,s,g,c){super(new p.StateService(0,s,c,g),v,s,g,c)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=f=ye([X(0,k.IUriIdentityService),X(1,L.INativeEnvironmentService),X(2,r.IFileService),X(3,A.ILogService)],f)}),define(te[53],ie([0,1,34,16,6,5,38,39,268,33]),function(j,e,E,L,r,A,D,k,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,r.refineServiceDecorator)(k.IUserDataProfilesService);let p=e.UserDataProfilesMainService=class extends u.UserDataProfilesService{constructor(w,f,S,v,s){super(w,f,S,v,s)}getAssociatedEmptyWindows(){const w=[];for(const f of this.profilesObject.emptyWindows.keys())w.push({id:f});return w}};e.UserDataProfilesMainService=p=ye([X(0,l.IStateService),X(1,D.IUriIdentityService),X(2,E.INativeEnvironmentService),X(3,L.IFileService),X(4,A.ILogService)],p)}),define(te[125],ie([0,1,18,8,29]),function(j,e,E,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function A(u,l,p){for(const w of u){const f=w.openedWorkspace;if((0,r.isWorkspaceIdentifier)(f)){const S=await p(f);if(S){if(S.folders.some(v=>E.extUriBiasedIgnorePathCase.isEqualOrParent(l,v.uri)))return w}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(l,f.configPath))return w}}const m=u.filter(w=>(0,r.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(l,w.openedWorkspace.uri));if(m.length)return m.sort((w,f)=>-(w.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=A;function D(u,l){for(const p of u)if((0,r.isWorkspaceIdentifier)(p.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.configPath,l)||(0,r.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.uri,l))return p}e.findWindowOnWorkspaceOrFolder=D;function k(u,l){const p=m=>l.some(w=>E.extUriBiasedIgnorePathCase.isEqual(L.URI.file(w),L.URI.file(m)));for(const m of u)if(m.config?.extensionDevelopmentPath?.some(w=>p(w)))return m}e.findWindowOnExtensionDevelopmentPath=k}),define(te[95],ie([0,1,32,43,130,44,14,9,3,18,8,6,57,29]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function S(R){return R.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function v(R){return R.hasOwnProperty("folderUri")}e.isRecentFolder=v;function s(R){return R.hasOwnProperty("fileUri")}e.isRecentFile=s;function g(R){return c(R)||y(R)}e.isStoredWorkspaceFolder=g;function c(R){const M=R;return typeof M?.path=="string"&&(!M.name||typeof M.name=="string")}function y(R){const M=R;return typeof M?.uri=="string"&&(!M.name||typeof M.name=="string")}function b(R,M,T,W,z){if(R.scheme!==W.scheme)return{name:T,uri:R.toString(!0)};let H=M?void 0:z.relativePath(W,R);if(H!==void 0)H.length===0?H=".":u.isWindows&&(H=C(H));else if(R.scheme===D.Schemas.file)H=R.fsPath,u.isWindows&&(H=C(H));else if(z.isEqualAuthority(R.authority,W.authority))H=R.path;else return{name:T,uri:R.toString(!0)};return{name:T,path:H}}e.getStoredWorkspaceFolder=b;function C(R){return R=(0,A.normalizeDriveLetter)(R),(0,E.isUNC)(R)||(R=(0,E.toSlashes)(R)),R}function t(R,M,T){const W=[],z=new Set,H=T.dirname(M);for(const J of R){let ne;if(c(J))J.path&&(ne=T.resolvePath(H,J.path));else if(y(J))try{ne=p.URI.parse(J.uri),ne.path[0]!==k.posix.sep&&(ne=ne.with({path:k.posix.sep+ne.path}))}catch(re){console.warn(re)}if(ne){const re=T.getComparisonKey(ne);if(!z.has(re)){z.add(re);const ue=J.name||T.basenameOrAuthority(ne);W.push(new f.WorkspaceFolder({uri:ne,name:ue,index:W.length},J))}}}return W}e.toWorkspaceFolders=t;function a(R,M,T,W,z){const H=i(M,R),J=z.dirname(M),ne=z.dirname(W),re=[];for(const q of H.folders){const N=c(q)?z.resolvePath(J,q.path):p.URI.parse(q.uri);let $;T?$=!1:$=!c(q)||(0,k.isAbsolute)(q.path),re.push(b(N,$,q.name,ne,z))}const ue={insertSpaces:!1,tabSize:4,eol:u.isLinux||u.isMacintosh?`
`:`\r
`},ce=r.setProperty(R,["folders"],re,ue);let K=r.applyEdits(R,ce);return(0,l.isEqualAuthority)(H.remoteAuthority,(0,w.getRemoteAuthority)(W))&&(K=r.applyEdits(K,r.removeProperty(K,["remoteAuthority"],ue))),K}e.rewriteWorkspaceFileForNewLocation=a;function i(R,M){const T=L.parse(M);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(W=>g(W));else throw new Error(`${R} looks like an invalid workspace file.`);return T}function n(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function o(R){return typeof R.folderUri=="string"}function d(R){return typeof R.fileUri=="string"}function h(R,M){const T={workspaces:[],files:[]};if(R){const W=function(H,J){for(let ne=0;ne<H.length;ne++)try{J(H[ne],ne)}catch(re){M.warn(`Error restoring recent entry ${JSON.stringify(H[ne])}: ${re.toString()}. Skip entry.`)}},z=R;Array.isArray(z.entries)&&W(z.entries,H=>{const J=H.label,ne=H.remoteAuthority;n(H)?T.workspaces.push({label:J,remoteAuthority:ne,workspace:{id:H.workspace.id,configPath:p.URI.parse(H.workspace.configPath)}}):o(H)?T.workspaces.push({label:J,remoteAuthority:ne,folderUri:p.URI.parse(H.folderUri)}):d(H)&&T.files.push({label:J,remoteAuthority:ne,fileUri:p.URI.parse(H.fileUri)})})}return T}e.restoreRecentlyOpened=h;function I(R){const M={entries:[]};for(const T of R.workspaces)v(T)?M.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):M.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of R.files)M.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return M}e.toStoreData=I}),define(te[96],ie([0,1,69,14,3,18]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(l){function p(){let m=l.scheme===L.Schemas.file?(0,A.originalFSPath)(l):l.toString();return r.isLinux||(m=m.toLowerCase()),(0,E.createHash)("md5").update(m).digest("hex")}return{id:p(),configPath:l}}e.getWorkspaceIdentifier=D;function k(l,p){function m(){if(l.scheme!==L.Schemas.file)return(0,E.createHash)("md5").update(l.toString()).digest("hex");if(!p)return;let f;return r.isLinux?f=p.ino:r.isMacintosh?f=p.birthtime.getTime():r.isWindows&&(typeof p.birthtimeMs=="number"?f=Math.floor(p.birthtimeMs):f=p.birthtime.getTime()),(0,E.createHash)("md5").update(l.fsPath).update(f?String(f):"").digest("hex")}const w=m();if(typeof w=="string")return{id:w,uri:l}}e.getSingleFolderWorkspaceIdentifier=k;function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=u}),define(te[97],ie([0,1,69,70,26,269,17,13,4,2,9,3,31,45,105]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{traceSocketEvent(M,T){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,M,T)}constructor(M,T=""){this._canWrite=!0,this.debugLabel=T,this.socket=M,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=W=>{if(this.traceSocketEvent("error",{code:W?.code,message:W?.message}),W){if(W.code==="EPIPE")return;(0,k.onUnexpectedError)(W)}},this.socket.on("error",this._errorListener),this._closeListener=W=>{this.traceSocketEvent("close",{hadError:W}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(M){const T=W=>{this.traceSocketEvent("read",W),M(D.VSBuffer.wrap(W))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(M){const T=W=>{M({type:0,hadError:W,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(M){const T=()=>{M()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(M){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",M),this.socket.write(M.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((M,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),M();return}const W=()=>{this.socket.off("close",W),this.socket.off("end",W),this.socket.off("error",W),this.socket.off("timeout",W),this.socket.off("drain",W),this.traceSocketEvent("nodeDrainEnd"),M()};this.socket.on("close",W),this.socket.on("end",W),this.socket.on("error",W),this.socket.on("timeout",W),this.socket.on("drain",W)})}}e.NodeSocket=v;var s;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize",R[R.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(s||(s={}));var g;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(g||(g={}));class c extends l.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(M,T){this.socket.traceSocketEvent(M,T)}constructor(M,T,W,z){super(),this._onData=this._register(new u.Emitter),this._onClose=this._register(new u.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=M,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:W?.byteLength||0,recordInflateBytes:z}),this._flowManager=this._register(new y(this,T,W,z,this._onData,(H,J)=>this._write(H,J))),this._register(this._flowManager.onError(H=>{console.error(H),(0,k.onUnexpectedError)(H),this._onClose.fire({type:0,hadError:!0,error:H})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(H=>this._acceptChunk(H))),this._register(this.socket.onClose(async H=>{this._flowManager.isProcessingReadQueue()&&await u.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(H)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(M){return this._onData.event(M)}onClose(M){return this._onClose.event(M)}onEnd(M){return this.socket.onEnd(M)}write(M){let T=0;for(;T<M.byteLength;)this._flowManager.writeMessage(M.slice(T,Math.min(T+262144,M.byteLength))),T+=262144}_write(M,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",M);let W=2;M.byteLength<126?W+=0:M.byteLength<2**16?W+=2:W+=8;const z=D.VSBuffer.alloc(W);if(T?z.writeUInt8(194,0):z.writeUInt8(130,0),M.byteLength<126)z.writeUInt8(M.byteLength,1);else if(M.byteLength<2**16){z.writeUInt8(126,1);let H=1;z.writeUInt8(M.byteLength>>>8&255,++H),z.writeUInt8(M.byteLength>>>0&255,++H)}else{z.writeUInt8(127,1);let H=1;z.writeUInt8(0,++H),z.writeUInt8(0,++H),z.writeUInt8(0,++H),z.writeUInt8(0,++H),z.writeUInt8(M.byteLength>>>24&255,++H),z.writeUInt8(M.byteLength>>>16&255,++H),z.writeUInt8(M.byteLength>>>8&255,++H),z.writeUInt8(M.byteLength>>>0&255,++H)}this.socket.write(D.VSBuffer.concat([z,M]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(M){if(M.byteLength!==0){for(this._incomingData.acceptChunk(M);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),W=T.readUInt8(0),z=(W&128)>>>7,H=(W&64)>>>6,J=T.readUInt8(1),ne=(J&128)>>>7,re=J&127;this._state.state=2,this._state.readLen=2+(ne?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=z,this._state.firstFrameOfMessage&&(this._state.compressed=!!H),this._state.firstFrameOfMessage=!!z,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),W=T.readUInt8(1),z=(W&128)>>>7;let H=W&127,J=1;H===126?H=T.readUInt8(++J)*2**8+T.readUInt8(++J):H===127&&(H=T.readUInt8(++J)*0+T.readUInt8(++J)*0+T.readUInt8(++J)*0+T.readUInt8(++J)*0+T.readUInt8(++J)*2**24+T.readUInt8(++J)*2**16+T.readUInt8(++J)*2**8+T.readUInt8(++J));let ne=0;z&&(ne=T.readUInt8(++J)*2**24+T.readUInt8(++J)*2**16+T.readUInt8(++J)*2**8+T.readUInt8(++J)),this._state.state=3,this._state.readLen=H,this._state.mask=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),t(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await u.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=c;class y extends l.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(M,T,W,z,H,J){super(),this._tracer=M,this._onData=H,this._writeFn=J,this._onError=this._register(new u.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new u.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new u.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new b(this._tracer,z,W,{windowBits:15})),this._zlibDeflateStream=this._register(new C(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(ne=>this._onError.fire(ne))),this._register(this._zlibDeflateStream.onError(ne=>this._onError.fire(ne)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(M){this._writeQueue.push(M),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const M=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,M);this._writeFn(T,!0)}else this._writeFn(M,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(M,T){return new Promise((W,z)=>{M.write(T),M.flush(H=>W(H))})}acceptFrame(M,T,W){this._readQueue.push({data:M,isCompressed:T,isLastFrameOfMessage:W}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const M=this._readQueue.shift();if(this._zlibInflateStream&&M.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,M.data,M.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(M.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(M,T,W){return new Promise((z,H)=>{M.write(T),W&&M.write(D.VSBuffer.fromByteArray([0,0,255,255])),M.flush(J=>z(J))})}}class b extends l.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}constructor(M,T,W,z){super(),this._tracer=M,this._recordInflateBytes=T,this._onError=this._register(new u.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(z),this._zlibInflate.on("error",H=>{this._tracer.traceSocketEvent("zlibInflateError",{message:H?.message,code:H?.code}),this._onError.fire(H)}),this._zlibInflate.on("data",H=>{this._tracer.traceSocketEvent("zlibInflateData",H),this._pendingInflateData.push(D.VSBuffer.wrap(H))}),W&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",W.buffer),this._zlibInflate.write(W.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(M){this._recordInflateBytes&&this._recordedInflateBytes.push(M.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",M),this._zlibInflate.write(M.buffer)}flush(M){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,M(T)})}}class C extends l.Disposable{constructor(M,T){super(),this._tracer=M,this._onError=this._register(new u.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",W=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:W?.message,code:W?.code}),this._onError.fire(W)}),this._zlibDeflate.on("data",W=>{this._tracer.traceSocketEvent("zlibDeflateData",W),this._pendingDeflateData.push(D.VSBuffer.wrap(W))})}write(M){this._tracer.traceSocketEvent("zlibDeflateWrite",M.buffer),this._zlibDeflate.write(M.buffer)}flush(M){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),M(T)})}}function t(R,M){if(M===0)return;const T=R.byteLength>>>2;for(let re=0;re<T;re++){const ue=R.readUInt32BE(re*4);R.writeUInt32BE(ue^M,re*4)}const W=T*4,z=R.byteLength-W,H=M>>>24&255,J=M>>>16&255,ne=M>>>8&255;z>=1&&R.writeUInt8(R.readUInt8(W)^H,W),z>=2&&R.writeUInt8(R.readUInt8(W+1)^J,W+1),z>=3&&R.writeUInt8(R.readUInt8(W+2)^ne,W+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function i(){const R=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;const M=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,r.tmpdir)(),T=(0,p.join)(M,`vscode-ipc-${R}.sock`);return o(T),T}e.createRandomIPCHandle=i;function n(R,M,T){const W=(0,E.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${T}-${M}-sock`;const z=T.substr(0,4),H=M.substr(0,6),J=W.substr(0,8);let ne;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?ne=(0,p.join)(e.XDG_RUNTIME_DIR,`vscode-${J}-${z}-${H}.sock`):ne=(0,p.join)(R,`${z}-${H}.sock`),o(ne),ne}e.createStaticIPCHandle=n;function o(R){const M=a[m.platform];typeof M=="number"&&R.length>=M&&console.warn(`WARNING: IPC handle "${R}" is longer than ${M} chars, try a shorter --user-data-dir`)}class d extends f.IPCServer{static toClientConnectionEvent(M){const T=u.Event.fromNodeEventEmitter(M,"connection");return u.Event.map(T,W=>({protocol:new S.Protocol(new v(W,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(W,"close"))}))}constructor(M){super(d.toClientConnectionEvent(M)),this.server=M}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=d;function h(R){return new Promise((M,T)=>{const W=(0,L.createServer)();W.on("error",T),W.listen(R,()=>{W.removeListener("error",T),M(new d(W))})})}e.serve=h;function I(R,M){return new Promise((T,W)=>{const z=(0,L.createConnection)(R,()=>{z.removeListener("error",W),T(S.Client.fromSocket(new v(z,`ipc-client${M}`),M))});z.once("error",W)})}e.connect=I}),define(te[30],ie([0,1,55,9,97,34,109,6]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(A.IEnvironmentService);class u extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,r.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}e.EnvironmentMainService=u,ye([E.memoize],u.prototype,"cachedLanguagesPath",null),ye([E.memoize],u.prototype,"backupHome",null),ye([E.memoize],u.prototype,"mainIPCHandle",null),ye([E.memoize],u.prototype,"mainLockfile",null),ye([E.memoize],u.prototype,"disableUpdates",null),ye([E.memoize],u.prototype,"disableKeytar",null),ye([E.memoize],u.prototype,"crossOriginIsolated",null),ye([E.memoize],u.prototype,"codeCachePath",null),ye([E.memoize],u.prototype,"useCodeCache",null)}),define(te[270],ie([0,1,69,32,14,9,3,18,24,191,19,30,33,16,5,190,29,96]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let c=e.BackupMainService=class wt{constructor(b,C,t,a){this.environmentMainService=b,this.configurationService=C,this.logService=t,this.stateService=a,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=k.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,n)=>(0,L.isEqual)(i,n,!D.isLinux)}}async initialize(){const b=this.stateService.getItem(wt.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(b.emptyWindows),this.workspaces=await this.validateWorkspaces((0,l.deserializeWorkspaceInfos)(b)),this.folders=await this.validateFolders((0,l.deserializeFolderInfos)(b)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==f.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(b,C){this.workspaces.some(a=>b.workspace.id===a.workspace.id)||(this.workspaces.push(b),this.storeWorkspacesMetadata());const t=(0,A.join)(this.backupHome,b.workspace.id);return C?this.moveBackupFolder(t,C).then(()=>t):t}async moveBackupFolder(b,C){if(await u.Promises.exists(b)&&await this.convertToEmptyWindowBackup(b),await u.Promises.exists(C))try{await u.Promises.rename(C,b)}catch(t){this.logService.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(b){return this.folders.some(C=>this.backupUriComparer.isEqual(b.folderUri,C.folderUri))||(this.folders.push(b),this.storeWorkspacesMetadata()),(0,A.join)(this.backupHome,this.getFolderHash(b))}registerEmptyWindowBackup(b){return this.emptyWindows.some(C=>!!C.backupFolder&&this.backupPathComparer.isEqual(C.backupFolder,b.backupFolder))||(this.emptyWindows.push(b),this.storeWorkspacesMetadata()),(0,A.join)(this.backupHome,b.backupFolder)}async validateWorkspaces(b){if(!Array.isArray(b))return[];const C=new Set,t=[];for(const a of b){const i=a.workspace;if(!(0,s.isWorkspaceIdentifier)(i))return[];if(!C.has(i.id)){C.add(i.id);const n=(0,A.join)(this.backupHome,i.id);await this.doHasBackups(n)?i.configPath.scheme!==r.Schemas.file||await u.Promises.exists(i.configPath.fsPath)?t.push(a):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return t}async validateFolders(b){if(!Array.isArray(b))return[];const C=[],t=new Set;for(const a of b){const i=a.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!t.has(n)){t.add(n);const o=(0,A.join)(this.backupHome,this.getFolderHash(a));await this.doHasBackups(o)?i.scheme!==r.Schemas.file||await u.Promises.exists(i.fsPath)?C.push(a):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return C}async validateEmptyWorkspaces(b){if(!Array.isArray(b))return[];const C=[],t=new Set;for(const a of b){const i=a.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const n=(0,A.join)(this.backupHome,i);await this.doHasBackups(n)?C.push(a):await this.deleteStaleBackup(n)}}return C}async deleteStaleBackup(b){try{await u.Promises.rm(b,u.RimRafMode.MOVE)}catch(C){this.logService.error(`Backup: Could not delete stale backup: ${C.toString()}`)}}prepareNewEmptyWindowBackup(){let b=(0,g.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(C=>!!C.backupFolder&&this.backupPathComparer.isEqual(C.backupFolder,b.id));)b=(0,g.createEmptyWorkspaceIdentifier)();return{backupFolder:b.id}}async convertToEmptyWindowBackup(b){const C=this.prepareNewEmptyWindowBackup(),t=(0,A.join)(this.backupHome,C.backupFolder);try{await u.Promises.rename(b,t)}catch(a){return this.logService.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.emptyWindows.push(C),!0}async getDirtyWorkspaces(){const b=[];for(const C of this.workspaces)await this.hasBackups(C)&&b.push(C);for(const C of this.folders)await this.hasBackups(C)&&b.push(C);return b}hasBackups(b){let C;return(0,l.isEmptyWindowBackupInfo)(b)?C=(0,A.join)(this.backupHome,b.backupFolder):(0,v.isFolderBackupInfo)(b)?C=(0,A.join)(this.backupHome,this.getFolderHash(b)):C=(0,A.join)(this.backupHome,b.workspace.id),this.doHasBackups(C)}async doHasBackups(b){try{const C=await u.Promises.readdir(b);for(const t of C)try{if((await u.Promises.readdir((0,A.join)(b,t))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const b={workspaces:this.workspaces.map(({workspace:C,remoteAuthority:t})=>{const a={id:C.id,configURIPath:C.configPath.toString()};return t&&(a.remoteAuthority=t),a}),folders:this.folders.map(({folderUri:C,remoteAuthority:t})=>{const a={folderUri:C.toString()};return t&&(a.remoteAuthority=t),a}),emptyWindows:this.emptyWindows.map(({backupFolder:C,remoteAuthority:t})=>{const a={backupFolder:C};return t&&(a.remoteAuthority=t),a})};this.stateService.setItem(wt.backupWorkspacesMetadataStorageKey,b)}getFolderHash(b){const C=b.folderUri;let t;return C.scheme===r.Schemas.file?t=D.isLinux?C.fsPath:C.fsPath.toLowerCase():t=C.toString().toLowerCase(),(0,E.createHash)("md5").update(t).digest("hex")}};c.backupWorkspacesMetadataStorageKey="backupWorkspaces",e.BackupMainService=c=ye([X(0,m.IEnvironmentMainService),X(1,p.IConfigurationService),X(2,S.ILogService),X(3,w.IStateService)],c)}),define(te[20],ie([0,1,15,42,7,4,2,3,36,11,6,5,33,30]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,p.createDecorator)("lifecycleMainService");var S;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(S||(e.ShutdownReason=S={}));var v;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen",g[g.Eventually=4]="Eventually"})(v||(e.LifecycleMainPhase=v={}));let s=e.LifecycleMainService=class gt extends D.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(c,y,b){super(),this.logService=c,this.stateService=y,this.environmentMainService=b,this._onBeforeShutdown=this._register(new A.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new A.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new A.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new A.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(gt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(gt.QUIT_AND_RESTART_KEY)}registerListeners(){const c=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),k.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};E.app.addListener("before-quit",c);const y=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!k.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",y),E.app.once("will-quit",b=>{this.trace("Lifecycle#app.on(will-quit) - begin"),b.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),E.app.removeListener("before-quit",c),E.app.removeListener("window-all-closed",y),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),E.app.quit()})})}fireOnWillShutdown(c){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const y=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({reason:c,join(C,t){y.trace(`Lifecycle#onWillShutdown - begin '${C}'`),b.push(t.finally(()=>{y.trace(`Lifecycle#onWillShutdown - end '${C}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await r.Promises.settled(b)}catch(C){this.logService.error(C)}try{await this.stateService.close()}catch(C){this.logService.error(C)}})(),this.pendingWillShutdownPromise}set phase(c){if(c<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===c)return;this.trace(`lifecycle (main): phase changed (value: ${c})`),this._phase=c;const y=this.phaseWhen.get(this._phase);y&&(y.open(),this.phaseWhen.delete(this._phase))}async when(c){if(c<=this._phase)return;let y=this.phaseWhen.get(c);y||(y=new r.Barrier,this.phaseWhen.set(c,y)),await y.wait()}registerWindow(c){const y=new D.DisposableStore;this.windowCounter++,y.add(c.onWillLoad(C=>this._onWillLoadWindow.fire({window:c,workspace:C.workspace,reason:C.reason})));const b=(0,l.assertIsDefined)(c.win);b.on("close",C=>{const t=c.id;if(this.windowToCloseRequest.has(t)){this.windowToCloseRequest.delete(t);return}this.trace(`Lifecycle#window.on('close') - window ID ${c.id}`),C.preventDefault(),this.unload(c,1).then(a=>{if(a){this.windowToCloseRequest.delete(t);return}this.windowToCloseRequest.add(t),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this._onBeforeCloseWindow.fire(c),c.close()})}),b.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${c.id}`),this.windowCounter--,y.dispose(),this.windowCounter===0&&(!k.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(c,y){await this.unload(c,3)||c.reload(y)}unload(c,y){const b=this.mapWindowIdToPendingUnload.get(c.id);if(b)return b;const C=this.doUnload(c,y).finally(()=>{this.mapWindowIdToPendingUnload.delete(c.id)});return this.mapWindowIdToPendingUnload.set(c.id,C),C}async doUnload(c,y){if(!c.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${c.id}`);const b=this._quitRequested?2:y,C=await this.onBeforeUnloadWindowInRenderer(c,b);return C?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${c.id})`),this.handleWindowUnloadVeto(C)):(await this.onWillUnloadWindowInRenderer(c,b),!1)}handleWindowUnloadVeto(c){return c?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(c){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(c),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(c,y){return new Promise(b=>{const C=this.oneTimeListenerTokenGenerator++,t=`vscode:ok${C}`,a=`vscode:cancel${C}`;L.validatedIpcMain.once(t,()=>{b(!1)}),L.validatedIpcMain.once(a,()=>{b(!0)}),c.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:a,reason:y})})}onWillUnloadWindowInRenderer(c,y){return new Promise(b=>{const t=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;L.validatedIpcMain.once(t,()=>b()),c.send("vscode:onWillUnload",{replyChannel:t,reason:y})})}quit(c){return this.trace(`Lifecycle#quit() - begin (willRestart: ${c})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(c&&this.stateService.setItem(gt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(y=>{this.pendingQuitPromiseResolve=y,this.trace("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.pendingQuitPromise)}trace(c){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(c):this.logService.trace(c)}async relaunch(c){this.trace("Lifecycle#relaunch()");const y=process.argv.slice(1);if(c?.addArgs&&y.push(...c.addArgs),c?.removeArgs)for(const t of c.removeArgs){const a=y.indexOf(t);a>=0&&y.splice(a,1)}const b=()=>{try{if(k.isWindows){const t=(0,u.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.logService.error(t)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:y})};E.app.once("quit",b),await this.quit(!0)&&E.app.removeListener("quit",b)}async kill(c){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const y of E.BrowserWindow.getAllWindows())if(y&&!y.isDestroyed()){let b;y.webContents&&!y.webContents.isDestroyed()?b=new Promise(C=>y.once("closed",C)):b=Promise.resolve(),y.destroy(),await b}})()]),E.app.exit(c)}};s.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",e.LifecycleMainService=s=ye([X(0,m.ILogService),X(1,w.IStateService),X(2,f.IEnvironmentMainService)],s)}),define(te[271],ie([0,1,3,4,2,6,20]),function(j,e,E,L,r,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,A.createDecorator)("keyboardLayoutMainService");let k=e.KeyboardLayoutMainService=class extends r.Disposable{constructor(p){super(),this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,p.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const p=await new Promise((m,w)=>{j(["native-keymap"],m,w)});this._keyboardLayoutData=u(p),E.isCI||p.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=u(p),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=k=ye([X(0,D.ILifecycleMainService)],k);function u(l){const p=l.getKeyMap(),m=l.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:m}}}),define(te[272],ie([0,1,70,97]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(r,A,D,k,u,l){const p=w=>l(w,void 0),m=E.createConnection({host:r,port:A},()=>{m.removeListener("error",p);const w=Buffer.alloc(16);for(let s=0;s<16;s++)w[s]=Math.round(Math.random()*256);const f=w.toString("base64"),S=[`GET ws://${/:/.test(r)?`[${r}]`:r}:${A}${D}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];m.write(S.join(`\r
`)+`\r
\r
`);const v=s=>{s.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",v),l(void 0,new L.NodeSocket(m,u)))};m.on("data",v)});m.setNoDelay(!0),m.once("error",p)}}}),define(te[273],ie([0,1,240,7,17,13,11,19,34,116,5,52,239,269]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let S=e.RequestService=class extends m.AbstractRequestService{constructor(c,y,b,C){super(!!y.isRemoteServer,C),this.configurationService=c,this.environmentService=y,this.logService=b,this.configure(),this._register(c.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const c=this.configurationService.getValue("http");this.proxyUrl=c?.proxy,this.strictSSL=!!c?.proxyStrictSSL,this.authorization=c?.proxyAuthorization}async request(c,y){const{proxyUrl:b,strictSSL:C}=this;let t;try{t=await(0,l.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,A.getErrorMessage)(n)))}const a={...process.env,...t},i=c.agent?c.agent:await(0,w.getProxyAgent)(c.url||"",a,{proxyUrl:b,strictSSL:C});return c.agent=i,c.strictSSL=C,this.authorization&&(c.headers={...c.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(c.isChromiumNetwork?"electron":"node",c,()=>s(c,y))}async resolveProxy(c){}};e.RequestService=S=ye([X(0,k.IConfigurationService),X(1,u.INativeEnvironmentService),X(2,p.ILogService),X(3,p.ILoggerService)],S);async function v(g){return((0,E.parse)(g.url).protocol==="https:"?await new Promise((b,C)=>{j(["https"],b,C)}):await new Promise((b,C)=>{j(["http"],b,C)})).request}async function s(g,c){return L.Promises.withAsyncBody(async(y,b)=>{const C=(0,E.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await v(g),a={hostname:C.hostname,port:C.port?parseInt(C.port):C.protocol==="https:"?443:80,protocol:C.protocol,path:C.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,D.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(a.auth=g.user+":"+g.password);const i=t(a,n=>{const o=(0,D.isNumber)(g.followRedirects)?g.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&o>0&&n.headers.location)s({...g,url:n.headers.location,followRedirects:o-1},c).then(y,b);else{let d=n;!g.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(d=n.pipe((0,f.createGunzip)())),y({res:n,stream:(0,r.streamToBufferReadableStream)(d)})}});i.on("error",b),g.timeout&&i.setTimeout(g.timeout),g.isChromiumNetwork&&i.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&i.write(g.data),i.end(),c.onCancellationRequested(()=>{i.abort(),b(new A.CancellationError)})})}e.nodeRequest=s}),define(te[274],ie([0,1,15,273]),function(j,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function r(D){return E.net.request}class A extends L.RequestService{request(k,u){return super.request({...k||{},getRawRequest:r,isChromiumNetwork:!0},u)}}e.RequestMainService=A}),define(te[98],ie([0,1,8,48,4,2,34,16,6,20,5,94,266,39,53,38]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,u.createDecorator)("storageMainService");let s=e.StorageMainService=class extends A.Disposable{constructor(y,b,C,t,a,i){super(),this.logService=y,this.environmentService=b,this.userDataProfilesService=C,this.lifecycleMainService=t,this.fileService=a,this.uriIdentityService=i,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new r.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(y=>{y.window.profile&&this.profileStorage(y.window.profile).init(),y.workspace&&this.workspaceStorage(y.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(y=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=y.reason,y.join("applicationStorage",this.applicationStorage.close());for(const[,b]of this.mapProfileToStorage)y.join("profileStorage",b.close());for(const[,b]of this.mapWorkspaceToStorage)y.join("workspaceStorage",b.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(y=>{y.join((async()=>{await this.fileService.exists(y.profile.globalStorageHome)||await this.fileService.createFolder(y.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(y=>{const b=this.mapProfileToStorage.get(y.profile.id);b&&y.join(b.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const y=new w.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,L.once)(y.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),y}profileStorage(y){if((0,m.isProfileUsingDefaultStorage)(y))return this.applicationStorage;let b=this.mapProfileToStorage.get(y.id);if(!b){this.logService.trace(`StorageMainService: creating profile storage (${y.name})`),b=this.createProfileStorage(y),this.mapProfileToStorage.set(y.id,b);const C=this._register(b.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:b,profile:y})));(0,L.once)(b.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${y.name})`),this.mapProfileToStorage.delete(y.id),C.dispose()})}return b}createProfileStorage(y){return this.shutdownReason===2?new w.InMemoryStorageMain(this.logService,this.fileService):new w.ProfileStorageMain(y,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(y){let b=this.mapWorkspaceToStorage.get(y.id);return b||(this.logService.trace(`StorageMainService: creating workspace storage (${y.id})`),b=this.createWorkspaceStorage(y),this.mapWorkspaceToStorage.set(y.id,b),(0,L.once)(b.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${y.id})`),this.mapWorkspaceToStorage.delete(y.id)})),b}createWorkspaceStorage(y){return this.shutdownReason===2?new w.InMemoryStorageMain(this.logService,this.fileService):new w.WorkspaceStorageMain(y,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(y){const b=E.URI.file(y);for(const C of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(C.path&&this.uriIdentityService.extUri.isEqualOrParent(E.URI.file(C.path),b))return!0;return!1}};e.StorageMainService=s=ye([X(0,p.ILogService),X(1,D.IEnvironmentService),X(2,S.IUserDataProfilesMainService),X(3,l.ILifecycleMainService),X(4,k.IFileService),X(5,v.IUriIdentityService)],s),e.IApplicationStorageMainService=(0,u.createDecorator)("applicationStorageMainService");let g=e.ApplicationStorageMainService=class extends m.AbstractStorageService{constructor(y,b){super(),this.userDataProfilesService=y,this.storageMainService=b,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(y){if(y===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(y){if(y===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=g=ye([X(0,f.IUserDataProfilesService),X(1,e.IStorageMainService)],g)}),define(te[275],ie([0,1,70,26,101,272,7,2,19,5,21,236,121,92,3]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(b,C,t,a,i){let n;for(let o=3;o&&(n?.dispose(),n=await new s(b,C,t,a,i).waitForReady(),!(i&&r.BROWSER_RESTRICTED_PORTS[i]||!r.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));o--);return n}class s extends k.Disposable{constructor(C,t,a,i,n){super(),this.defaultTunnelHost=t,this.suggestedLocalPort=n,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=C,this._server=E.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=o=>this._onConnection(o),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(t=>{t()})}async waitForReady(){const C=this.suggestedLocalPort??this.tunnelRemotePort,t=(0,w.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let a=await(0,r.findFreePortFaster)(C,2,1e3,t),i=null;return this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(a=0,this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(C){C.pause();const t=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,m.connectRemoteAgentTunnel)(this._options,t,this.tunnelRemotePort),i=a.getSocket().socket,n=a.readEntireBuffer();a.dispose(),n.byteLength>0&&C.write(n.buffer),C.on("end",()=>{C.localAddress&&this._socketsDispose.delete(C.localAddress),i.end()}),C.on("close",()=>i.end()),C.on("error",()=>{C.localAddress&&this._socketsDispose.delete(C.localAddress),i.destroy()}),i.on("end",()=>C.end()),i.on("close",()=>C.end()),i.on("error",()=>{C.destroy()}),C.pipe(i),i.pipe(C),C.localAddress&&this._socketsDispose.set(C.localAddress,()=>{C.end(),i.end()})}}let g=e.BaseTunnelService=class extends w.AbstractTunnelService{constructor(C,t,a,i,n){super(t,n),this.socketFactory=C,this.signService=a,this.productService=i}isPortPrivileged(C){return(0,w.isPortPrivileged)(C,this.defaultTunnelHost,S.OS,L.release())}retainOrCreateTunnel(C,t,a,i,n,o,d,h){const I=this.getTunnelFromMap(t,a);if(I)return++I.refcount,I.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,t,a,n,o,d,h);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${a} on local port ${n}.`);const R={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:C,signService:this.signService,logService:this.logService,ipcLogger:null},M=v(R,i,t,a,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(t,a,M),M}}};e.BaseTunnelService=g=ye([X(1,l.ILogService),X(2,f.ISignService),X(3,p.IProductService),X(4,u.IConfigurationService)],g);let c=e.TunnelService=class extends g{constructor(C,t,a,i){super(A.nodeSocketFactory,C,t,a,i)}};e.TunnelService=c=ye([X(0,l.ILogService),X(1,f.ISignService),X(2,p.IProductService),X(3,u.IConfigurationService)],c);let y=e.SharedTunnelsService=class extends k.Disposable{constructor(C,t,a,i){super(),this.logService=C,this.productService=t,this.signService=a,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(C,t,a,i,n,o,d,h,I){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${o}.`),!this._tunnelServices.has(C)){const R=new c(this.logService,this.signService,this.productService,this.configurationService);this._register(R),this._tunnelServices.set(C,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this._tunnelServices.delete(C))})}return this._tunnelServices.get(C).openTunnel(t,a,i,n,o,d,h,I)}};e.SharedTunnelsService=y=ye([X(0,l.ILogService),X(1,p.IProductService),X(2,f.ISignService),X(3,u.IConfigurationService)],y)}),define(te[99],ie([0,1,7,22,4,19,30,20,5,21,52,47]),function(j,e,E,L,r,A,D,k,u,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function w(S,v,s){return`${s.updateUrl}/api/update/${S}/${v}/${s.commit}`}e.createUpdateURL=w;let f=e.AbstractUpdateService=class{get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}constructor(v,s,g,c,y,b){this.lifecycleMainService=v,this.configurationService=s,this.environmentMainService=g,this.requestService=c,this.logService=y,this.productService=b,this._state=m.State.Uninitialized,this._onStateChange=new r.Emitter,this.onStateChange=this._onStateChange.event,v.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.configurationService.getValue("update.mode"),s=this.getProductQuality(v);if(!s){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(s),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(m.State.Idle(this.getUpdateType())),v==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,g=>this.logService.error(g))}getProductQuality(v){return v==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(v=60*60*1e3){return(0,E.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(v){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}catch(s){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(s);return}}async _applySpecificUpdate(v){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=f=ye([X(0,k.ILifecycleMainService),X(1,A.IConfigurationService),X(2,D.IEnvironmentMainService),X(3,p.IRequestService),X(4,u.ILogService),X(5,l.IProductService)],f)}),define(te[276],ie([0,1,15,55,4,2,19,30,20,5,21,52,25,47,99]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=e.DarwinUpdateService=class extends S.AbstractUpdateService{get onRawError(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"error",(g,c)=>c)}get onRawUpdateNotAvailable(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(g,c,y)=>({url:c,version:y,productVersion:y}))}get onRawUpdateDownloaded(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(g,c,y,b)=>({releaseNotes:c,version:y,productVersion:y,date:b}))}constructor(g,c,y,b,C,t,a){super(g,c,b,C,t,a),this.telemetryService=y,this.disposables=new A.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(g){this.logService.error("UpdateService error:",g);const y=(this.state.type==="checking for updates"?this.state.explicit:!0)?g:void 0;this.setState(f.State.Idle(1,y))}buildUpdateFeedUrl(g){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const y=(0,S.createUpdateURL)(c,g,this.productService);try{E.autoUpdater.setFeedURL({url:y})}catch(b){this.logService.error("Failed to set update feed URL",b);return}return y}doCheckForUpdates(g){this.setState(f.State.CheckingForUpdates(g)),E.autoUpdater.checkForUpdates()}onUpdateAvailable(g){this.state.type==="checking for updates"&&this.setState(f.State.Downloading(g))}onUpdateDownloaded(g){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:g.version}),this.setState(f.State.Ready(g)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(f.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ye([L.memoize],v.prototype,"onRawError",null),ye([L.memoize],v.prototype,"onRawUpdateNotAvailable",null),ye([L.memoize],v.prototype,"onRawUpdateAvailable",null),ye([L.memoize],v.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=v=ye([X(0,u.ILifecycleMainService),X(1,D.IConfigurationService),X(2,w.ITelemetryService),X(3,k.IEnvironmentMainService),X(4,m.IRequestService),X(5,l.ILogService),X(6,p.IProductService)],v)}),define(te[277],ie([0,1,50,41,7,4,9,30,20,5,25,47]),function(j,e,E,L,r,A,D,k,u,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let w=class{get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}constructor(v,s,g){if(this.lifecycleMainService=v,this.logService=g,this._state=m.State.Uninitialized,this._onStateChange=new A.Emitter,this.onStateChange=this._onStateChange.event,s.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(m.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}scheduleCheckForUpdates(v=60*60*1e3){return(0,r.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(v){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(v){}};w=ye([X(0,u.ILifecycleMainService),X(1,k.IEnvironmentMainService),X(2,l.ILogService)],w);let f=e.SnapUpdateService=class extends w{constructor(v,s,g,c,y,b){super(g,c,y),this.snap=v,this.snapRevision=s,this.telemetryService=b;const C=(0,L.watch)(D.dirname(this.snap)),t=A.Event.fromNodeEventEmitter(C,"change",(o,d)=>d),a=A.Event.filter(t,o=>o==="current"),n=A.Event.debounce(a,(o,d)=>d,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{n.dispose(),C.close()})}doCheckForUpdates(){this.setState(m.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(v=>{v?this.setState(m.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(m.State.Idle(2)))},v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(m.State.Idle(2,v.message||v))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const v=await new Promise((g,c)=>(0,L.realpath)(`${D.dirname(this.snap)}/current`,(y,b)=>y?c(y):g(b))),s=D.basename(v);return this.snapRevision!==s}isLatestVersion(){return this.isUpdateAvailable().then(void 0,v=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=f=ye([X(2,u.ILifecycleMainService),X(3,k.IEnvironmentMainService),X(4,l.ILogService),X(5,p.ITelemetryService)],f)}),define(te[278],ie([0,1,2,20,53,29,7,28]),function(j,e,E,L,r,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let u=e.UserDataProfilesHandler=class extends E.Disposable{constructor(p,m,w){super(),this.userDataProfilesService=m,this.windowsMainService=w,this._register(p.onWillLoadWindow(f=>{f.reason===2&&this.unsetProfileForWorkspace(f.window)})),this._register(p.onBeforeCloseWindow(f=>this.unsetProfileForWorkspace(f))),this._register(new D.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(p){const m=this.getWorkspace(p),w=this.userDataProfilesService.getProfileForWorkspace(m);w?.isTransient&&(this.userDataProfilesService.unsetWorkspace(m,w.isTransient),w.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(p){return p.openedWorkspace??(0,A.toWorkspaceIdentifier)(p.backupPath,p.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const p=this.userDataProfilesService.getAssociatedEmptyWindows();if(p.length===0)return;const m=this.windowsMainService.getWindows().map(w=>this.getWorkspace(w));for(const w of p)m.some(f=>f.id===w.id)||this.userDataProfilesService.unsetWorkspace(w,!1)}};e.UserDataProfilesHandler=u=ye([X(0,L.ILifecycleMainService),X(1,r.IUserDataProfilesMainService),X(2,k.IWindowsMainService)],u)}),define(te[67],ie([0,1,15,2,4,5,297,7,14,28,72,25,20,71,40,3,87]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function g(b){return typeof b.responseWindowId=="number"}let c=e.UtilityProcess=class dt extends L.Disposable{static getAll(){return Array.from(dt.all.values())}constructor(C,t,a){super(),this.logService=C,this.telemetryService=t,this.lifecycleMainService=a,this.id=String(++dt.ID_COUNTER),this._onStdout=this._register(new r.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new r.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new r.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new r.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(C,t){let a;switch(this.configuration?.correlationId?a=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${C}`:a=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${C}`,t){case p.default.Error:this.logService.error(a);break;case p.default.Warning:this.logService.warn(a);break;case p.default.Info:this.logService.trace(a);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",p.default.Error),!1):!0}start(C){const t=this.doStart(C,!1);return t&&C.payload&&this.postMessage(C.payload),t}doStart(C,t){if(!this.validateCanStart())return!1;this.configuration=C;const a=`${this.configuration.type}-${this.id}`,i=u.FileAccess.asFileUri("bootstrap-fork.js").fsPath,n=this.configuration.args??[],o=this.configuration.execArgv??[],d=this.configuration.allowLoadingUnsignedLibraries,h=this.configuration.forceAllocationsToV8Sandbox,I="pipe",R=this.createEnv(C,t);return this.log("creating new...",p.default.Info),this.process=E.utilityProcess.fork(i,n,{serviceName:a,env:R,execArgv:o,allowLoadingUnsignedLibraries:d,forceAllocationsToV8Sandbox:h,stdio:I}),this.registerListeners(this.process,this.configuration,a,t),!0}createEnv(C,t){const a=C.env?{...C.env}:{...(0,S.deepClone)(process.env)};a.VSCODE_AMD_ENTRYPOINT=C.entryPoint,typeof C.parentLifecycleBound=="number"&&(a.VSCODE_PARENT_PID=String(C.parentLifecycleBound)),t&&(a.VSCODE_CRASH_REPORTER_SANDBOXED_HINT="1"),a.VSCODE_CRASH_REPORTER_PROCESS_TYPE=C.type,v.isWindows&&(a.NODE_UNC_HOST_ALLOWLIST=(0,s.getUNCHostAllowlist)().join("\\")),(0,f.removeDangerousEnvVariables)(a);for(const i of Object.keys(a))a[i]=String(a[i]);return a}registerListeners(C,t,a,i){if(C.stdout){const n=new D.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(C.stdout,"data")(o=>this._onStdout.fire(typeof o=="string"?o:n.write(o))))}if(C.stderr){const n=new D.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(C.stderr,"data")(o=>this._onStderr.fire(typeof o=="string"?o:n.write(o))))}this._register(r.Event.fromNodeEventEmitter(C,"message")(n=>this._onMessage.fire(n))),this._register(r.Event.fromNodeEventEmitter(C,"spawn")(()=>{this.processPid=C.pid,typeof C.pid=="number"&&dt.all.set(C.pid,{pid:C.pid,name:g(t)?`${t.type} [${t.responseWindowId}]`:t.type}),this.log("successfully created",p.default.Info)})),this._register(r.Event.fromNodeEventEmitter(C,"exit")(n=>{this.log(`received exit event with code ${n}`,p.default.Info),this._onExit.fire({pid:this.processPid,code:n,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(r.Event.fromNodeEventEmitter(E.app,"child-process-gone",(n,o)=>({event:n,details:o}))(({details:n})=>{n.type==="Utility"&&n.name===a&&(this.log(`crashed with code ${n.exitCode} and reason '${n.reason}'`,p.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:t.type,reason:n.reason,code:n.exitCode,sandboxed:i?"1":"0"}),this._onCrash.fire({pid:this.processPid,code:n.exitCode,reason:n.reason}),this.onDidExitOrCrashOrKill())}))}once(C,t){const a=this._register(this._onMessage.event(i=>{i===C&&(a.dispose(),t())}))}postMessage(C,t){this.process&&this.process.postMessage(C,t)}connect(C){const{port1:t,port2:a}=new E.MessageChannelMain;return this.postMessage(C,[a]),t}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",p.default.Info);const C=process;return typeof C._debugProcess=="function"?(C._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",p.default.Info),this.process.kill()?(this.log("successfully killed the process",p.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",p.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&dt.all.delete(this.processPid),this.process=void 0}async waitForExit(C){this.process&&(this.log("waiting to exit...",p.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,k.timeout)(C)]),this.process&&(this.log(`did not exit within ${C}ms, will kill it now...`,p.default.Info),this.kill()))}};c.ID_COUNTER=0,c.all=new Map,e.UtilityProcess=c=ye([X(0,A.ILogService),X(1,m.ITelemetryService),X(2,w.ILifecycleMainService)],c);let y=e.WindowUtilityProcess=class extends c{constructor(C,t,a,i){super(C,a,i),this.windowsMainService=t}start(C){const t=this.windowsMainService.getWindowById(C.responseWindowId);if(!t?.win||t.win.isDestroyed()||t.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",p.default.Error),!0;if(!super.doStart(C,t.isSandboxed))return!1;this.registerWindowListeners(t.win,C);const i=this.connect(C.payload);return t.win.webContents.postMessage(C.responseChannel,C.responseNonce,[i]),!0}registerWindowListeners(C,t){t.windowLifecycleBound&&(this._register(r.Event.filter(this.lifecycleMainService.onWillLoadWindow,a=>a.window.win===C)(()=>this.kill())),this._register(r.Event.fromNodeEventEmitter(C,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=y=ye([X(0,A.ILogService),X(1,l.IWindowsMainService),X(2,m.ITelemetryService),X(3,w.ILifecycleMainService)],y)}),define(te[279],ie([0,1,13,5,20,7,67,28,25]),function(j,e,E,L,r,A,D,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let l=e.ExtensionHostStarter=class Ct{constructor(m,w,f,S){this._logService=m,this._lifecycleMainService=w,this._windowsMainService=f,this._telemetryService=S,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(v=>{this._shutdown=!0,v.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(m){const w=this._extHosts.get(m);if(!w)throw new Error("Unknown extension host!");return w}onDynamicStdout(m){return this._getExtHost(m).onStdout}onDynamicStderr(m){return this._getExtHost(m).onStderr}onDynamicMessage(m){return this._getExtHost(m).onMessage}onDynamicExit(m){return this._getExtHost(m).onExit}async createExtensionHost(){if(this._shutdown)throw(0,E.canceled)();const m=String(++Ct._lastId),w=new D.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(m,w),w.onExit(({pid:f,code:S,signal:v})=>{this._logService.info(`Extension host with pid ${f} exited with code: ${S}, signal: ${v}.`),setTimeout(()=>{w.dispose(),this._extHosts.delete(m)})}),{id:m}}async start(m,w){if(this._shutdown)throw(0,E.canceled)();this._getExtHost(m).start({...w,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:w.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:m})}async enableInspectPort(m){if(this._shutdown)throw(0,E.canceled)();const w=this._extHosts.get(m);return w?w.enableInspectPort():!1}async kill(m){if(this._shutdown)throw(0,E.canceled)();const w=this._extHosts.get(m);w&&w.kill()}async _killAllNow(){for(const[,m]of this._extHosts)m.kill()}async _waitForAllExit(m){const w=[];for(const[,f]of this._extHosts)w.push(f.waitForExit(m));return A.Promises.settled(w).then(()=>{})}};l._lastId=0,e.ExtensionHostStarter=l=ye([X(0,L.ILogService),X(1,r.ILifecycleMainService),X(2,k.IWindowsMainService),X(3,u.ITelemetryService)],l)}),define(te[280],ie([0,1,42,7,2,30,20,5,39,37,65,67,46,109,11]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let v=e.SharedProcess=class extends r.Disposable{constructor(g,c,y,b,C,t,a){super(),this.machineId=g,this.environmentMainService=c,this.userDataProfilesService=y,this.lifecycleMainService=b,this.logService=C,this.loggerMainService=t,this.policyService=a,this.firstWindowConnectionBarrier=new L.Barrier,this.utilityProcess=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){E.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(g,c)=>this.onWindowConnection(g,c)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(g,c){this.logService.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const y=await this.connect();if(g.sender.isDestroyed())return y.close();g.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[y])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage("vscode:electron-main->shared-process=exit"),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const g=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once("vscode:shared-process->electron-main=init-done",()=>g.complete()):E.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>g.complete()),await g.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const g=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()):E.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()),await g.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new m.UtilityProcess(this.logService,w.NullTelemetryService,this.lifecycleMainService));const g=(0,f.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let c;g.port&&(c=["--nolazy"],g.break?c.push(`--inspect-brk=${g.port}`):c.push(`--inspect=${g.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:c})}createSharedProcessConfiguration(){return{machineId:this.machineId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(){return await this.whenIpcReady,(0,S.assertIsDefined)(this.utilityProcess).connect()}};e.SharedProcess=v=ye([X(1,A.IEnvironmentMainService),X(2,u.IUserDataProfilesService),X(3,D.ILifecycleMainService),X(4,k.ILogService),X(5,p.ILoggerMainService),X(6,l.IPolicyService)],v)}),define(te[281],ie([0,1,2,6,5,28,67,25,56,4,7,20]),function(j,e,E,L,r,A,D,k,u,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let w=e.UtilityProcessWorkerMainService=class extends E.Disposable{constructor(v,s,g,c){super(),this.logService=v,this.windowsMainService=s,this.telemetryService=g,this.lifecycleMainService=c,this.workers=new Map}async createWorker(v){const s=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${s})`);const g=this.hash(v);this.workers.has(g)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${s})`),this.disposeWorker(v));const c=new f(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,v);if(!c.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(g,c);const y=new p.DeferredPromise;return l.Event.once(c.onDidTerminate)(b=>{b.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${b.code}, signal: ${b.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${b.code}, signal: ${b.signal}`),this.workers.delete(g),y.complete({reason:b})}),y.p}hash(v){return(0,u.hash)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const s=this.hash(v),g=this.workers.get(s);g&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),g.kill(),this.workers.delete(s))}};e.UtilityProcessWorkerMainService=w=ye([X(0,r.ILogService),X(1,A.IWindowsMainService),X(2,k.ITelemetryService),X(3,m.ILifecycleMainService)],w);let f=class extends E.Disposable{constructor(v,s,g,c,y){super(),this.logService=v,this.windowsMainService=s,this.telemetryService=g,this.lifecycleMainService=c,this.configuration=y,this._onDidTerminate=this._register(new l.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new D.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(v=>this._onDidTerminate.fire({code:v.code,signal:v.signal}))),this._register(this.utilityProcess.onCrash(v=>this._onDidTerminate.fire({code:v.code,signal:"ECRASH"})))}spawn(){const s=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:s,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};f=ye([X(0,r.ILogService),X(1,A.IWindowsMainService),X(2,k.ITelemetryService),X(3,m.ILifecycleMainService)],f)}),define(te[282],ie([0,1,15,2,3,18,8,19,20,5,33,28,123,29]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let S=e.WindowsStateHandler=class St extends L.Disposable{get state(){return this._state}constructor(b,C,t,a,i){super(),this.windowsMainService=b,this.stateService=C,this.lifecycleMainService=t,this.logService=a,this.configurationService=i,this._state=v(this.stateService.getItem(St.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){E.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(b=>this.onBeforeCloseWindow(b)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(b=>{b.newCount-b.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(b=>this.onBeforeCloseWindow(b))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const b=new Set,C={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!C.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(C.lastActiveWindow=this.toWindowState(i),C.lastActiveWindow.uiState.mode===3&&b.add(C.lastActiveWindow.uiState.display))}const t=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(C.lastPluginDevelopmentHostWindow=this.toWindowState(t),C.lastPluginDevelopmentHostWindow.uiState.mode===3&&(b.has(C.lastPluginDevelopmentHostWindow.uiState.display)?r.isMacintosh&&!t.win?.isSimpleFullScreen()&&(C.lastPluginDevelopmentHostWindow.uiState.mode=1):b.add(C.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(C.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.toWindowState(i);return n.uiState.mode===3&&(b.has(n.uiState.display)?r.isMacintosh&&n.windowId!==C.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):b.add(n.uiState.display)),n}));const a=g(C);this.stateService.setItem(St.windowsStateStorageKey,a),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",a)}onBeforeCloseWindow(b){if(this.lifecycleMainService.quitRequested)return;const C=this.toWindowState(b);b.isExtensionDevelopmentHost&&!b.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=C:!b.isExtensionDevelopmentHost&&b.openedWorkspace&&this._state.openedWindows.forEach(t=>{const a=(0,f.isWorkspaceIdentifier)(b.openedWorkspace)&&t.workspace?.id===b.openedWorkspace.id,i=(0,f.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&t.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(t.folderUri,b.openedWorkspace.uri);(a||i)&&(t.uiState=C.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=C)}toWindowState(b){return{windowId:b.id,workspace:(0,f.isWorkspaceIdentifier)(b.openedWorkspace)?b.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)?b.openedWorkspace.uri:void 0,backupPath:b.backupPath,remoteAuthority:b.remoteAuthority,uiState:b.serializeWindowState()}}getNewWindowState(b){const C=this.doGetNewWindowState(b),t=this.configurationService.getValue("window");if(C.mode===3){let a;C.hasDefaultState?a=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):a=!!(this.lifecycleMainService.wasRestarted||t?.restoreFullscreen),a||(C.mode=1)}return C}doGetNewWindowState(b){const C=this.windowsMainService.getLastActiveWindow();if(!b.extensionTestsPath){if(b.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const d=b.workspace;if((0,f.isWorkspaceIdentifier)(d)){const I=this.state.openedWindows.filter(R=>R.workspace&&R.workspace.id===d.id).map(R=>R.uiState);if(I.length)return I[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(d)){const I=this.state.openedWindows.filter(R=>R.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(R.folderUri,d.uri)).map(R=>R.uiState);if(I.length)return I[0]}else if(b.backupPath){const I=this.state.openedWindows.filter(R=>R.backupPath===b.backupPath).map(R=>R.uiState);if(I.length)return I[0]}const h=this.lastClosedState||this.state.lastActiveWindow;if(!C&&h)return h.uiState}let t;const a=E.screen.getAllDisplays();if(a.length===1)t=a[0];else{if(r.isMacintosh){const d=E.screen.getCursorScreenPoint();t=E.screen.getDisplayNearestPoint(d)}!t&&C&&(t=E.screen.getDisplayMatching(C.getBounds())),t||(t=E.screen.getPrimaryDisplay()||a[0])}let i=(0,w.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&C){const d=C.serializeWindowState();d.mode===3?i.mode=3:i=d,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(b){if(this.windowsMainService.getWindows().length===0)return b;b.x=typeof b.x=="number"?b.x:0,b.y=typeof b.y=="number"?b.y:0;const C=this.windowsMainService.getWindows().map(t=>t.getBounds());for(;C.some(t=>t.x===b.x||t.y===b.y);)b.x+=30,b.y+=30;return b}};S.windowsStateStorageKey="windowsState",e.WindowsStateHandler=S=ye([X(0,m.IWindowsMainService),X(1,p.IStateService),X(2,u.ILifecycleMainService),X(3,l.ILogService),X(4,k.IConfigurationService)],S);function v(y){const b={openedWindows:[]},C=y||{openedWindows:[]};return C.lastActiveWindow&&(b.lastActiveWindow=s(C.lastActiveWindow)),C.lastPluginDevelopmentHostWindow&&(b.lastPluginDevelopmentHostWindow=s(C.lastPluginDevelopmentHostWindow)),Array.isArray(C.openedWindows)&&(b.openedWindows=C.openedWindows.map(t=>s(t))),b}e.restoreWindowsState=v;function s(y){const b={uiState:y.uiState};return y.backupPath&&(b.backupPath=y.backupPath),y.remoteAuthority&&(b.remoteAuthority=y.remoteAuthority),y.folder&&(b.folderUri=D.URI.parse(y.folder)),y.workspaceIdentifier&&(b.workspace={id:y.workspaceIdentifier.id,configPath:D.URI.parse(y.workspaceIdentifier.configURIPath)}),b}function g(y){return{lastActiveWindow:y.lastActiveWindow&&c(y.lastActiveWindow),lastPluginDevelopmentHostWindow:y.lastPluginDevelopmentHostWindow&&c(y.lastPluginDevelopmentHostWindow),openedWindows:y.openedWindows.map(b=>c(b))}}e.getWindowsStateStoreData=g;function c(y){return{workspaceIdentifier:y.workspace&&{id:y.workspace.id,configURIPath:y.workspace.configPath.toString()},folder:y.folderUri&&y.folderUri.toString(),backupPath:y.backupPath,remoteAuthority:y.remoteAuthority,uiState:y.uiState}}}),define(te[54],ie([0,1,15,4,43,2,14,9,18,11,24,189,63,58,30,6,5,53,125,29,95,96]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,v.createDecorator)("workspacesManagementMainService");let t=e.WorkspacesManagementMainService=class extends A.Disposable{constructor(i,n,o,d,h){super(),this.environmentMainService=i,this.logService=n,this.userDataProfilesMainService=o,this.backupMainService=d,this.dialogMainService=h,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const i=(await p.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(n=>(0,u.joinPath)(this.untitledWorkspacesHome,n,y.UNTITLED_WORKSPACE_NAME));for(const n of i){const o=(0,C.getWorkspaceIdentifier)(n),d=await this.resolveLocalWorkspace(n);d?this.untitledWorkspaces.push({workspace:o,remoteAuthority:d.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(i){i.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${i}).`)}}resolveLocalWorkspace(i){return this.doResolveLocalWorkspace(i,n=>p.Promises.readFile(n,"utf8"))}doResolveLocalWorkspace(i,n){if(this.isWorkspacePath(i)&&i.scheme===D.Schemas.file)try{const o=n(i.fsPath);return o instanceof Promise?o.then(d=>this.doResolveWorkspace(i,d),d=>{}):this.doResolveWorkspace(i,o)}catch{return}}isWorkspacePath(i){return(0,y.isUntitledWorkspace)(i,this.environmentMainService)||(0,y.hasWorkspaceFileExtension)(i)}doResolveWorkspace(i,n){try{const o=this.doParseStoredWorkspace(i,n),d=(0,C.getWorkspaceIdentifier)(i);return{id:d.id,configPath:d.configPath,folders:(0,b.toWorkspaceFolders)(o.folders,d.configPath,u.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.logService.warn(o.toString())}}doParseStoredWorkspace(i,n){const o=(0,r.parse)(n);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(d=>(0,b.isStoredWorkspaceFolder)(d));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(i,n){const{workspace:o,storedWorkspace:d}=this.newUntitledWorkspace(i,n),h=o.configPath.fsPath;return await p.Promises.mkdir((0,k.dirname)(h),{recursive:!0}),await p.Promises.writeFile(h,JSON.stringify(d,null,"	")),this.untitledWorkspaces.push({workspace:o,remoteAuthority:n}),o}newUntitledWorkspace(i=[],n){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),d=(0,u.joinPath)(this.untitledWorkspacesHome,o),h=(0,u.joinPath)(d,y.UNTITLED_WORKSPACE_NAME),I=[];for(const R of i)I.push((0,b.getStoredWorkspaceFolder)(R.uri,!0,R.name,d,u.extUriBiasedIgnorePathCase));return{workspace:(0,C.getWorkspaceIdentifier)(h),storedWorkspace:{folders:I,remoteAuthority:n}}}async getWorkspaceIdentifier(i){return(0,C.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,y.isUntitledWorkspace)(i.configPath,this.environmentMainService)}async deleteUntitledWorkspace(i){this.isUntitledWorkspace(i)&&(await this.doDeleteUntitledWorkspace(i),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(i),this._onDidDeleteUntitledWorkspace.fire(i))}async doDeleteUntitledWorkspace(i){const n=(0,u.originalFSPath)(i.configPath);try{await p.Promises.rm((0,k.dirname)(n));const o=(0,k.join)(this.environmentMainService.workspaceStorageHome.fsPath,i.id);await p.Promises.exists(o)&&await p.Promises.writeFile((0,k.join)(o,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(d=>d.workspace.id!==i.id)}catch(o){this.logService.warn(`Unable to delete untitled workspace ${n} (${o}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(i,n,o){if(!i||!i.win||!i.isReady||!await this.isValidTargetWorkspacePath(i,n,o))return;const h=await this.doEnterWorkspace(i,(0,C.getWorkspaceIdentifier)(o));if(h)return this._onDidEnterWorkspace.fire({window:i,workspace:h.workspace}),h}async isValidTargetWorkspacePath(i,n,o){return o?(0,y.isWorkspaceIdentifier)(i.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,o)?!1:(0,c.findWindowOnWorkspaceOrFolder)(n,o)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:(0,m.localize)(1,null,(0,u.basename)(o)),detail:(0,m.localize)(2,null)},(0,l.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1):!0:!0}async doEnterWorkspace(i,n){if(!i.config)return;i.focus();let o;return i.config.extensionDevelopmentPath||(i.config.backupPath?o=await this.backupMainService.registerWorkspaceBackup({workspace:n,remoteAuthority:i.remoteAuthority},i.config.backupPath):o=this.backupMainService.registerWorkspaceBackup({workspace:n,remoteAuthority:i.remoteAuthority})),(0,y.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=n,i.config.backupPath=o,{workspace:n,backupPath:o}}};e.WorkspacesManagementMainService=t=ye([X(0,S.IEnvironmentMainService),X(1,s.ILogService),X(2,g.IUserDataProfilesMainService),X(3,w.IBackupMainService),X(4,f.IDialogMainService)],t)}),define(te[126],ie([0,1,15,42,22,6,28,29,54,11,5,67]),function(j,e,E,L,r,A,D,k,u,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,A.createDecorator)(e.ID);let w=e.DiagnosticsMainService=class{constructor(S,v,s){this.windowsMainService=S,this.workspacesManagementMainService=v,this.logService=s}async getRemoteDiagnostics(S){const v=this.windowsMainService.getWindows();return(await Promise.all(v.map(async g=>{const c=g.remoteAuthority;if(!c)return;const y=`vscode:getDiagnosticInfoResponse${g.id}`,b={includeProcesses:S.includeProcesses,folders:S.includeWorkspaceMetadata?await this.getFolderURIs(g):void 0};return new Promise(C=>{g.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:y,args:b}),L.validatedIpcMain.once(y,(t,a)=>{a||C({hostName:c,errorMessage:`Unable to resolve connection to '${c}'.`}),C(a)}),setTimeout(()=>{C({hostName:c,errorMessage:`Connection to '${c}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const S=[];for(const s of E.BrowserWindow.getAllWindows()){const g=this.windowsMainService.getWindowById(s.id);g?S.push(await this.codeWindowToInfo(g)):S.push(this.browserWindowToInfo(s))}const v=[];for(const{pid:s,name:g}of m.UtilityProcess.getAll())v.push({pid:s,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:S,pidToNames:v,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async codeWindowToInfo(S){const v=await this.getFolderURIs(S),s=(0,l.assertIsDefined)(S.win);return this.browserWindowToInfo(s,v,S.remoteAuthority)}browserWindowToInfo(S,v=[],s){return{id:S.id,pid:S.webContents.getOSProcessId(),title:S.getTitle(),folderURIs:v,remoteAuthority:s}}async getFolderURIs(S){const v=[],s=S.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(s))v.push(s.uri);else if((0,k.isWorkspaceIdentifier)(s)){const g=await this.workspacesManagementMainService.resolveLocalWorkspace(s.configPath);g&&g.folders.forEach(y=>{v.push(y.uri)})}return v}};e.DiagnosticsMainService=w=ye([X(0,D.IWindowsMainService),X(1,u.IWorkspacesManagementMainService),X(2,p.ILogService)],w)}),define(te[59],ie([0,1,50,15,26,151,55,4,2,14,9,3,8,103,85,24,101,179,58,30,6,20,5,21,78,28,29,54,17,237,231,33]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y,b,C,t,a,i,n,o,d,h,I,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,b.createDecorator)("nativeHostMainService");let T=e.NativeHostMainService=class extends u.Disposable{constructor(z,H,J,ne,re,ue,ce,K,q){super(),this.windowsMainService=z,this.dialogMainService=H,this.lifecycleMainService=J,this.environmentMainService=ne,this.logService=re,this.productService=ue,this.themeMainService=ce,this.stateService=K,this.workspacesManagementMainService=q,this.onDidOpenWindow=k.Event.map(this.windowsMainService.onDidOpenWindow,N=>N.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:N,x:$,y:G})=>({windowId:N.id,x:$,y:G})),({windowId:N})=>!!this.windowsMainService.getWindowById(N)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(N,$)=>$.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(N,$)=>$.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(N,$)=>$.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),N=>!!N),N=>N.id),k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(N,$)=>$.id),N=>!!this.windowsMainService.getWindowById(N))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new k.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(N,$,G)=>G),N=>!(Array.isArray(N)&&N.length===1&&N[0]==="workArea")),k.Event.fromNodeEventEmitter(L.screen,"display-added"),k.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(H=>({id:H.id,workspace:H.openedWorkspace??(0,o.toWorkspaceIdentifier)(H.backupPath,H.isExtensionDevelopmentHost),title:H.win?.getTitle()??"",filename:H.getRepresentedFilename(),dirty:H.isDocumentEdited()}))}async getWindowCount(z){return this.windowsMainService.getWindowCount()}async getActiveWindowId(z){const H=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(H)return H.id}openWindow(z,H,J){return Array.isArray(H)?this.doOpenWindow(z,H,J):this.doOpenEmptyWindow(z,H)}async doOpenWindow(z,H,J=Object.create(null)){H.length>0&&await this.windowsMainService.open({context:5,contextWindowId:z,urisToOpen:H,cli:this.environmentMainService.args,forceNewWindow:J.forceNewWindow,forceReuseWindow:J.forceReuseWindow,preferNewWindow:J.preferNewWindow,diffMode:J.diffMode,mergeMode:J.mergeMode,addMode:J.addMode,gotoLineMode:J.gotoLineMode,noRecentEntry:J.noRecentEntry,waitMarkerFileURI:J.waitMarkerFileURI,remoteAuthority:J.remoteAuthority||void 0,forceProfile:J.forceProfile,forceTempProfile:J.forceTempProfile})}async doOpenEmptyWindow(z,H){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:z},H)}async toggleFullScreen(z){this.windowById(z)?.toggleFullScreen()}async handleTitleDoubleClick(z){this.windowById(z)?.handleTitleDoubleClick()}async isMaximized(z){const H=this.windowById(z);return H?.win?H.win.isMaximized():!1}async maximizeWindow(z){const H=this.windowById(z);H?.win&&H.win.maximize()}async unmaximizeWindow(z){const H=this.windowById(z);H?.win&&H.win.unmaximize()}async minimizeWindow(z){const H=this.windowById(z);H?.win&&H.win.minimize()}async updateWindowControls(z,H){const J=this.windowById(z);J&&J.updateWindowControls(H)}async focusWindow(z,H){H&&typeof H.windowId=="number"&&(z=H.windowId),this.windowById(z)?.focus({force:H?.force??!1})}async setMinimumSize(z,H,J){const ne=this.windowById(z);if(ne?.win){const[re,ue]=ne.win.getSize(),[ce,K]=ne.win.getMinimumSize(),[q,N]=[H??ce,J??K],[$,G]=[Math.max(re,q),Math.max(ue,N)];(ce!==q||K!==N)&&ne.win.setMinimumSize(q,N),(re!==$||ue!==G)&&ne.win.setSize($,G)}}async saveWindowSplash(z,H){this.themeMainService.saveWindowSplash(z,H)}async installShellCommand(z){const{source:H,target:J}=await this.getShellCommandLink();try{const{symbolicLink:ne}=await v.SymlinkSupport.stat(H);if(ne&&!ne.dangling){const re=await(0,f.realpath)(H);if(J===re)return}await v.Promises.unlink(H)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await v.Promises.symlink(J,H)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:re}=await this.showMessageBox(z,{type:"info",message:(0,g.localize)(0,null,this.productService.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(re===0)try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${J}' '${H}'\\" with administrator privileges"`;await(0,A.promisify)(E.exec)(ue)}catch{throw new Error((0,g.localize)(3,null,H))}}}async uninstallShellCommand(z){const{source:H}=await this.getShellCommandLink();try{await v.Promises.unlink(H)}catch(J){switch(J.code){case"EACCES":{const{response:ne}=await this.showMessageBox(z,{type:"info",message:(0,g.localize)(4,null,this.productService.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(ne===0)try{const re=`osascript -e "do shell script \\"rm '${H}'\\" with administrator privileges"`;await(0,A.promisify)(E.exec)(re)}catch{throw new Error((0,g.localize)(7,null,H))}break}case"ENOENT":break;default:throw J}}}async getShellCommandLink(){const z=(0,p.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),H=`/usr/local/bin/${this.productService.applicationName}`;if(!await v.Promises.exists(z))throw new Error((0,g.localize)(8,null,z));return{source:H,target:z}}async showMessageBox(z,H){return this.dialogMainService.showMessageBox(H,this.toBrowserWindow(z))}async showSaveDialog(z,H){return this.dialogMainService.showSaveDialog(H,this.toBrowserWindow(z))}async showOpenDialog(z,H){return this.dialogMainService.showOpenDialog(H,this.toBrowserWindow(z))}toBrowserWindow(z){const H=this.windowById(z);if(H?.win)return H.win}async pickFileFolderAndOpen(z,H){const J=await this.dialogMainService.pickFileFolder(H);J&&await this.doOpenPicked(await Promise.all(J.map(async ne=>await v.SymlinkSupport.existsDirectory(ne)?{folderUri:w.URI.file(ne)}:{fileUri:w.URI.file(ne)})),H,z)}async pickFolderAndOpen(z,H){const J=await this.dialogMainService.pickFolder(H);J&&await this.doOpenPicked(J.map(ne=>({folderUri:w.URI.file(ne)})),H,z)}async pickFileAndOpen(z,H){const J=await this.dialogMainService.pickFile(H);J&&await this.doOpenPicked(J.map(ne=>({fileUri:w.URI.file(ne)})),H,z)}async pickWorkspaceAndOpen(z,H){const J=await this.dialogMainService.pickWorkspace(H);J&&await this.doOpenPicked(J.map(ne=>({workspaceUri:w.URI.file(ne)})),H,z)}async doOpenPicked(z,H,J){await this.windowsMainService.open({context:3,contextWindowId:J,cli:this.environmentMainService.args,urisToOpen:z,forceNewWindow:H.forceNewWindow})}async showItemInFolder(z,H){L.shell.showItemInFolder(H)}async setRepresentedFilename(z,H){this.windowById(z)?.setRepresentedFilename(H)}async setDocumentEdited(z,H){this.windowById(z)?.setDocumentEdited(H)}async openExternal(z,H){return m.isLinuxSnap?this.safeSnapOpenExternal(H):L.shell.openExternal(H),!0}safeSnapOpenExternal(z){const H=process.env.GDK_PIXBUF_MODULE_FILE,J=process.env.GDK_PIXBUF_MODULEDIR,ne=process.env.GTK_IM_MODULE_FILE,re=process.env.GDK_BACKEND,ue=process.env.GIO_MODULE_DIR,ce=process.env.GTK_EXE_PREFIX,K=process.env.GSETTINGS_SCHEMA_DIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,delete process.env.GTK_IM_MODULE_FILE,delete process.env.GDK_BACKEND,delete process.env.GIO_MODULE_DIR,delete process.env.GTK_EXE_PREFIX,delete process.env.GSETTINGS_SCHEMA_DIR,L.shell.openExternal(z),process.env.GDK_PIXBUF_MODULE_FILE=H,process.env.GDK_PIXBUF_MODULEDIR=J,process.env.GTK_IM_MODULE_FILE=ne,process.env.GDK_BACKEND=re,process.env.GIO_MODULE_DIR=ue,process.env.GTK_EXE_PREFIX=ce,process.env.GSETTINGS_SCHEMA_DIR=K}moveItemToTrash(z,H){return L.shell.trashItem(H)}async isAdmin(){let z;return m.isWindows?z=(await new Promise((H,J)=>{j(["native-is-elevated"],H,J)}))():z=process.getuid()===0,z}async writeElevated(z,H,J,ne){const re=await new Promise((ue,ce)=>{j(["@vscode/sudo-prompt"],ue,ce)});return new Promise((ue,ce)=>{const K=[`"${this.cliPath}"`];ne?.unlock&&K.push("--file-chmod"),K.push("--file-write",`"${H.fsPath}"`,`"${J.fsPath}"`);const q={name:this.productService.nameLong.replace("-",""),icns:m.isMacintosh&&this.environmentMainService.isBuilt?(0,p.join)((0,p.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};re.exec(K.join(" "),q,(N,$,G)=>{$&&this.logService.trace(`[sudo-prompt] received stdout: ${$}`),G&&this.logService.trace(`[sudo-prompt] received stderr: ${G}`),N?ce(N):ue(void 0)})})}get cliPath(){return m.isWindows?this.environmentMainService.isBuilt?(0,p.join)((0,p.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,p.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):m.isLinux?this.environmentMainService.isBuilt?(0,p.join)((0,p.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,p.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,p.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,p.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return S.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return m.isWindows&&(0,I.hasWSLFeatureInstalled)()}async killProcess(z,H,J){process.kill(H,J)}async readClipboardText(z,H){return L.clipboard.readText(H)}async writeClipboardText(z,H,J){return L.clipboard.writeText(H,J)}async readClipboardFindText(z){return L.clipboard.readFindText()}async writeClipboardFindText(z,H){return L.clipboard.writeFindText(H)}async writeClipboardBuffer(z,H,J,ne){return L.clipboard.writeBuffer(H,Buffer.from(J.buffer),ne)}async readClipboardBuffer(z,H){return h.VSBuffer.wrap(L.clipboard.readBuffer(H))}async hasClipboard(z,H,J){return L.clipboard.has(H,J)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(z,H){this.windowById(z)?.updateTouchBar(H)}async notifyReady(z){this.windowById(z)?.setReady()}async relaunch(z,H){return this.lifecycleMainService.relaunch(H)}async reload(z,H){const J=this.windowById(z);if(J){if((0,o.isWorkspaceIdentifier)(J.openedWorkspace)){const ne=J.openedWorkspace.configPath;if(ne.scheme===l.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ne))?.transient)return this.openWindow(J.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(J,H?.disableExtensions!==void 0?{_:[],"disable-extensions":H.disableExtensions}:void 0)}}async closeWindow(z){this.closeWindowById(z,z)}async closeWindowById(z,H){const J=this.windowById(H);if(J?.win)return J.win.close()}async quit(z){const H=this.windowsMainService.getLastActiveWindow();H?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&H.win?H.win.close():this.lifecycleMainService.quit()}async exit(z,H){await this.lifecycleMainService.kill(H)}async resolveProxy(z,H){return this.windowById(z)?.win?.webContents?.session?.resolveProxy(H)}findFreePort(z,H,J,ne,re=1){return(0,s.findFreePort)(H,J,ne,re)}async openDevTools(z,H){const J=this.windowById(z);J?.win&&J.win.webContents.openDevTools(H)}async toggleDevTools(z){const H=this.windowById(z);H?.win&&H.win.webContents.toggleDevTools()}async sendInputEvent(z,H){const J=this.windowById(z);J?.win&&(H.type==="mouseDown"||H.type==="mouseUp")&&J.win.webContents.sendInputEvent(H)}async enableSandbox(z,H){H?this.stateService.setItem("window.experimental.useSandbox",!0):this.stateService.removeItem("window.experimental.useSandbox")}async profileRenderer(z,H,J){const ne=this.windowById(z);if(!ne||!ne.win)throw new Error;return await new R.WindowProfiler(ne.win,H,this.logService).inspect(J)}async windowsGetStringRegKey(z,H,J,ne){if(!m.isWindows)return;const re=await new Promise((ue,ce)=>{j(["@vscode/windows-registry"],ue,ce)});try{return re.GetStringRegKey(H,J,ne)}catch{return}}windowById(z){if(typeof z=="number")return this.windowsMainService.getWindowById(z)}};ye([D.memoize],T.prototype,"cliPath",null),e.NativeHostMainService=T=ye([X(0,n.IWindowsMainService),X(1,c.IDialogMainService),X(2,C.ILifecycleMainService),X(3,y.IEnvironmentMainService),X(4,t.ILogService),X(5,a.IProductService),X(6,i.IThemeMainService),X(7,M.IStateService),X(8,d.IWorkspacesManagementMainService)],T)}),define(te[283],ie([0,1,15,42,26,2,14,3,104,177,88,126,58,30,5,59,76,21,77,79,32,11,33,67,22,8,28,7]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y,b,C,t,a,i,n,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const h="issue.processExplorerWindowState";let I=e.IssueMainService=class Dt{constructor(T,W,z,H,J,ne,re,ue,ce,K,q){this.userEnv=T,this.environmentMainService=W,this.logService=z,this.diagnosticsService=H,this.diagnosticsMainService=J,this.dialogMainService=ne,this.nativeHostMainService=re,this.protocolMainService=ue,this.productService=ce,this.stateService=K,this.windowsMainService=q,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){L.validatedIpcMain.on("vscode:listProcesses",async T=>{const W=[];try{W.push({name:(0,l.localize)(0,null),rootProcess:await(0,u.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(H=>{(0,p.isRemoteDiagnosticError)(H)?W.push({name:H.hostName,rootProcess:H}):H.processes&&W.push({name:H.hostName,rootProcess:H.processes})})}catch(z){this.logService.error(`Listing processes failed: ${z}`)}this.safeSend(T,"vscode:listProcessesResponse",W)}),L.validatedIpcMain.on("vscode:workbenchCommand",(T,W)=>{const{id:z,from:H,args:J}=W;let ne;switch(H){case"processExplorer":ne=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${H}`)}ne?.webContents.send("vscode:runAction",{id:z,from:H,args:J})}),L.validatedIpcMain.on("vscode:closeProcessExplorer",T=>{this.processExplorerWindow?.close()}),L.validatedIpcMain.on("vscode:pidToNameRequest",async T=>{const W=await this.diagnosticsMainService.getMainDiagnostics(),z=[];for(const H of W.windows)z.push([H.pid,`window [${H.id}] (${H.title})`]);for(const{pid:H,name:J}of a.UtilityProcess.getAll())z.push([H,J]);this.safeSend(T,"vscode:pidToNameResponse",z)})}async openReporter(T){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=E.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const W=new A.DisposableStore,z=W.add(this.protocolMainService.createIPCObjectUrl()),H=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(H,z,{backgroundColor:T.styles.backgroundColor,title:(0,l.localize)(1,null),zoomLevel:T.zoomLevel,alwaysOnTop:!1},"issue-reporter"),z.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:T,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:s.default}),this.issueReporterWindow.loadURL(D.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,W.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,W.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(T){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=E.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const W=new A.DisposableStore,z=W.add(this.protocolMainService.createIPCObjectUrl()),H=this.stateService.getItem(h,void 0),J=R(H)?H:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(J,z,{backgroundColor:T.styles.backgroundColor,title:(0,l.localize)(2,null),zoomLevel:T.zoomLevel,alwaysOnTop:!0},"process-explorer"),z.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:T,product:s.default}),this.processExplorerWindow.loadURL(D.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,W.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,W.dispose())});const ne=()=>{if(!this.processExplorerWindow)return;const re=this.processExplorerWindow.getSize(),ue=this.processExplorerWindow.getPosition();if(!re||!ue)return;const ce={width:re[0],height:re[1],x:ue[0],y:ue[1]};this.stateService.setItem(h,ce)};this.processExplorerWindow.on("moved",ne),this.processExplorerWindow.on("resized",ne)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const T=await E.contentTracing.stopRecording(`${(0,b.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null,T),buttons:[(0,l.localize)(5,null)]},(0,C.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,T)}async getSystemStatus(){const[T,W]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(T,W)}async $getSystemInfo(){const[T,W]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(T,W)}async $getPerformanceInfo(){try{const[T,W]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(T,W)}catch(T){throw this.logService.warn("issueService#getPerformanceInfo ",T.message),T}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(T){this.logService.error(T)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:T}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,l.localize)(6,null),buttons:[(0,l.localize)(7,null),(0,l.localize)(8,null)]},this.issueReporterWindow);T===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:T}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,l.localize)(9,null),buttons:[(0,l.localize)(10,null),(0,l.localize)(11,null)]},this.issueReporterWindow);return T===0}return!1}async $getIssueReporterUri(T){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const W=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!W)throw new Error("Window not found");const z=`vscode:triggerIssueUriRequestHandlerResponse${W.id}`;return d.Promises.withAsyncBody(async(H,J)=>{const ne=new i.CancellationTokenSource;W.sendWhenReady("vscode:triggerIssueUriRequestHandler",ne.token,{replyChannel:z,extensionId:T}),L.validatedIpcMain.once(z,(re,ue)=>{H(n.URI.parse(ue))});try{await(0,d.timeout)(5e3),ne.cancel(),J(new Error("Timed out waiting for issue reporter URI"))}finally{L.validatedIpcMain.removeHandler(z)}})}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(T){T.isMinimized()&&T.restore(),T.focus()}safeSend(T,W,...z){T.sender.isDestroyed()||T.sender.send(W,...z)}createBrowserWindow(T,W,z,H){const J=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:T.width,height:T.height,minWidth:300,minHeight:200,x:T.x,y:T.y,title:z.title,backgroundColor:z.backgroundColor||Dt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:D.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${W.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,y.zoomLevelToZoomFactor)(z.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:z.alwaysOnTop,experimentalDarkMode:!0});return J.setMenuBarVisibility(!1),J}getWindowPosition(T,W,z){let H;const J=E.screen.getAllDisplays();if(J.length===1)H=J[0];else{if(k.isMacintosh){const ue=E.screen.getCursorScreenPoint();H=E.screen.getDisplayNearestPoint(ue)}!H&&T&&(H=E.screen.getDisplayMatching(T.getBounds())),H||(H=E.screen.getPrimaryDisplay()||J[0])}const ne=H.bounds,re={width:W,height:z,x:ne.x+ne.width/2-W/2,y:ne.y+ne.height/2-z/2};return ne.width>0&&ne.height>0&&(re.x<ne.x&&(re.x=ne.x),re.y<ne.y&&(re.y=ne.y),re.x>ne.x+ne.width&&(re.x=ne.x),re.y>ne.y+ne.height&&(re.y=ne.y),re.width>ne.width&&(re.width=ne.width),re.height>ne.height&&(re.height=ne.height)),re}};I.DEFAULT_BACKGROUND_COLOR="#1E1E1E",e.IssueMainService=I=ye([X(1,f.IEnvironmentMainService),X(2,S.ILogService),X(3,p.IDiagnosticsService),X(4,m.IDiagnosticsMainService),X(5,w.IDialogMainService),X(6,v.INativeHostMainService),X(7,c.IProtocolMainService),X(8,g.IProductService),X(9,t.IStateService),X(10,o.IWindowsMainService)],I);function R(M){return typeof M!="object"||M===null?!1:"x"in M&&"y"in M&&"width"in M&&"height"in M}}),define(te[284],ie([0,1,22,19,30,20,5,59,21,52,25,47,99]),function(j,e,E,L,r,A,D,k,u,l,p,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=e.LinuxUpdateService=class extends w.AbstractUpdateService{constructor(v,s,g,c,y,b,C,t){super(v,s,c,y,b,t),this.telemetryService=g,this.nativeHostMainService=C}buildUpdateFeedUrl(v){return(0,w.createUpdateURL)(`linux-${process.arch}`,v,this.productService)}doCheckForUpdates(v){this.url&&(this.setState(m.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},E.CancellationToken.None).then(l.asJson).then(s=>{!s||!s.url||!s.version||!s.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(m.State.Idle(1))):this.setState(m.State.AvailableForDownload(s))}).then(void 0,s=>{this.logService.error(s),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const g=v?s.message||s:void 0;this.setState(m.State.Idle(1,g))}))}async doDownloadUpdate(v){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(m.State.Idle(1))}};e.LinuxUpdateService=f=ye([X(0,A.ILifecycleMainService),X(1,L.IConfigurationService),X(2,p.ITelemetryService),X(3,r.IEnvironmentMainService),X(4,l.IRequestService),X(5,D.ILogService),X(6,k.INativeHostMainService),X(7,u.IProductService)],f)}),define(te[285],ie([0,1,50,41,26,7,22,55,9,8,137,24,19,30,16,20,5,59,21,52,25,47,99]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y,b,C,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(d,h=1e3){for(;!d();)await(0,A.timeout)(h)}let i;function n(){return typeof i>"u"&&(L.existsSync(u.join(u.dirname(process.execPath),"unins000.exe"))?i=0:u.basename(u.normalize(u.join(process.execPath,"..","..")))==="Program Files"?i=3:i=1),i}let o=e.Win32UpdateService=class extends t.AbstractUpdateService{get cachePath(){const h=u.join((0,r.tmpdir)(),`${this.productService.applicationName}-update-${this.productService.target}-${process.arch}`);return m.Promises.mkdir(h,{recursive:!0}).then(()=>h)}constructor(h,I,R,M,T,W,z,H,J){super(h,I,M,T,W,J),this.telemetryService=R,this.fileService=z,this.nativeHostMainService=H}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(h){let I="win32";switch(process.arch!=="ia32"&&(I+=`-${process.arch}`),n()){case 1:I+="-archive";break;case 3:I+="-msi";break;default:this.productService.target==="user"&&(I+="-user")}return(0,t.createUpdateURL)(I,h,this.productService)}doCheckForUpdates(h){this.url&&(this.setState(C.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},D.CancellationToken.None).then(y.asJson).then(I=>{const R=n();return!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(C.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(C.State.AvailableForDownload(I)),Promise.resolve(null)):(this.setState(C.State.Downloading(I)),this.cleanup(I.version).then(()=>this.getUpdatePackagePath(I.version).then(M=>m.Promises.exists(M).then(T=>{if(T)return Promise.resolve(M);const W=I.url,z=I.hash,H=`${M}.tmp`;return this.requestService.request({url:W},D.CancellationToken.None).then(J=>this.fileService.writeFile(l.URI.file(H),J.stream)).then(z?()=>(0,p.checksum)(H,I.hash):()=>{}).then(()=>m.Promises.rename(H,M)).then(()=>M)})).then(M=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:M},T&&I.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(C.State.Downloaded(I)):this.setState(C.State.Ready(I))})))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const R=h?I.message||I:void 0;this.setState(C.State.Idle(n(),R))}))}async doDownloadUpdate(h){h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(C.State.Idle(n()))}async getUpdatePackagePath(h){const I=await this.cachePath;return u.join(I,`CodeSetup-${this.productService.quality}-${h}.exe`)}async cleanup(h=null){const I=h?W=>!new RegExp(`${this.productService.quality}-${h}\\.exe$`).test(W):()=>!0,R=await this.cachePath,T=(await m.Promises.readdir(R)).filter(I).map(async W=>{try{await m.Promises.unlink(u.join(R,W))}catch{}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const h=this.state.update;this.setState(C.State.Updating(h));const I=await this.cachePath;this.availableUpdate.updateFilePath=u.join(I,`CodeSetup-${this.productService.quality}-${h.version}.flag`),await m.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,E.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(C.State.Idle(n()))});const M=`${this.productService.win32MutexName}-ready`,T=await new Promise((W,z)=>{j(["@vscode/windows-mutex"],W,z)});a(()=>T.isActive(M)).then(()=>this.setState(C.State.Ready(h)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):n()==3?(0,E.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,E.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(h){if(this.state.type!=="idle")return;const I=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),R={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!I};this.setState(C.State.Downloading(R)),this.availableUpdate={packagePath:h},I?this.productService.target==="user"?this.doApplyUpdate():this.setState(C.State.Downloaded(R)):this.setState(C.State.Ready(R))}};ye([k.memoize],o.prototype,"cachePath",null),e.Win32UpdateService=o=ye([X(0,v.ILifecycleMainService),X(1,w.IConfigurationService),X(2,b.ITelemetryService),X(3,f.IEnvironmentMainService),X(4,y.IRequestService),X(5,s.ILogService),X(6,S.IFileService),X(7,g.INativeHostMainService),X(8,c.IProductService)],o)}),define(te[286],ie([0,1,15,7,22,49,4,2,14,9,64,3,8,185,63,19,58,30,62,16,20,5,21,77,244,98,25,136,78,79,28,29,54,123,127,37,33,53,59,246,119,46,93,26,120,65,23]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y,b,C,t,a,i,n,o,d,h,I,R,M,T,W,z,H,J,ne,re,ue,ce,K,q,N,$,G,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var oe;(function(Y){Y[Y.NONE=0]="NONE",Y[Y.NAVIGATING=1]="NAVIGATING",Y[Y.READY=2]="READY"})(oe||(oe={}));let le=e.CodeWindow=class at extends k.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get isSandboxed(){return this._isSandboxed}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const _=this.userDataProfilesService.profiles.find(P=>P.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&_?_:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,M.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(_,P,O,U,B,F,x,V,se,ae,Se,De,Re,Le,Oe,we,ve,Pe,Z,de,fe){super(),this.logService=P,this.loggerMainService=O,this.environmentMainService=U,this.policyService=B,this.userDataProfilesService=F,this.fileService=x,this.applicationStorageMainService=V,this.storageMainService=se,this.configurationService=ae,this.themeMainService=Se,this.workspacesManagementMainService=De,this.backupMainService=Re,this.telemetryService=Le,this.dialogMainService=Oe,this.lifecycleMainService=we,this.productService=ve,this.protocolMainService=Pe,this.windowsMainService=Z,this.stateService=de,this.nativeHostMainService=fe,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this._isSandboxed=!1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;let Ee=!1;{const[ke,_e]=this.restoreWindowState(_.state);this.windowState=ke,this.logService.trace("window#ctor: using window state",ke);const We=this.windowState.mode===0||this.windowState.mode===3;typeof at.sandboxState>"u"&&(at.sandboxState=this.stateService.getItem("window.experimental.useSandbox",!1));const He=this.configurationService.getValue("window");typeof He?.experimental?.useSandbox=="boolean"?Ee=He.experimental.useSandbox:this.productService.quality==="stable"&&at.sandboxState?Ee=!0:Ee=this.productService.quality!=="stable",this._isSandboxed=Ee;const Ue={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:I.WindowMinimumSize.WIDTH,minHeight:I.WindowMinimumSize.HEIGHT,show:!We,title:this.productService.nameLong,webPreferences:{preload:u.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,I.zoomLevelToZoomFactor)(He?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...Ee?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};m.isLinux?Ue.icon=(0,l.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):m.isWindows&&!this.environmentMainService.isBuilt&&(Ue.icon=(0,l.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.useNativeFullScreen()&&(Ue.fullscreenable=!1),m.isMacintosh&&(Ue.acceptFirstMouse=!0,He?.clickThroughInactive===!1&&(Ue.acceptFirstMouse=!1));const $e=m.isMacintosh&&He?.nativeTabs===!0;$e&&(Ue.tabbingIdentifier=this.productService.nameShort);const qe=(0,I.getTitleBarStyle)(this.configurationService)==="custom";if(qe&&(Ue.titleBarStyle="hidden",m.isMacintosh||(Ue.frame=!1),(0,I.useWindowControlsOverlay)(this.configurationService))){const Fe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Q=z.Color.fromHex(Fe).isDarker()?"#FFFFFF":"#000000";Ue.titleBarOverlay={height:29,color:Fe,symbolColor:Q},this.hasWindowControlOverlay=!0}if((0,p.mark)("code/willCreateCodeBrowserWindow"),this._win=new E.BrowserWindow(Ue),(0,p.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,m.isMacintosh&&qe&&this._win.setSheetOffset(22),qe&&(m.isWindows&&(0,I.useWindowControlsOverlay)(this.configurationService)||m.isMacintosh)){const Fe=this.stateService.getItem(at.windowControlHeightStateStorageKey);Fe&&this.updateWindowControls({height:Fe})}m.isWindows&&qe&&this._win.hookWindowMessage(278,()=>{const[Q,he]=this._win.getPosition(),ge=E.screen.getCursorScreenPoint(),me=ge.x-Q,be=ge.y-he;return(()=>!(me>30&&be>=0&&be<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:me,y:be})),0}),(m.isMacintosh||m.isWindows)&&_e&&(!$e||E.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Fe=>typeof Fe=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),We&&((0,p.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,p.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners(Ee)}setRepresentedFilename(_){m.isMacintosh?this._win.setRepresentedFilename(_):this.representedFilename=_}getRepresentedFilename(){return m.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(_){m.isMacintosh&&this._win.setDocumentEdited(_),this.documentEdited=_}isDocumentEdited(){return m.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(_){m.isMacintosh&&_?.force&&E.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(_=>{if(this.isReady)return _(this);this.whenReadyCallbacks.push(_)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(_=>{function P(){O.dispose(),U.dispose(),_()}const O=this.onDidClose(()=>P()),U=this.onWillLoad(()=>P())})}registerListeners(_){this._win.on("unresponsive",()=>this.onWindowError(1,{sandboxed:_})),this._win.webContents.on("render-process-gone",(O,U)=>this.onWindowError(2,{...U,sandboxed:_})),this._win.webContents.on("did-fail-load",(O,U,B)=>this.onWindowError(3,{reason:B,exitCode:U,sandboxed:_})),this._win.webContents.on("will-prevent-unload",O=>{O.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",O=>{this._config&&(this._config.maximized=!0),E.app.emit("browser-window-maximize",O,this._win)}),this._win.on("unmaximize",O=>{this._config&&(this._config.maximized=!1),E.app.emit("browser-window-unmaximize",O,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(O=>this.onConfigurationUpdated(O))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(O=>this.onDidDeleteUntitledWorkspace(O)));const P=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:P},async(O,U)=>{const B=await this.getMarketplaceHeaders();U({cancel:!1,requestHeaders:Object.assign(O.requestHeaders,B)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(_,P){switch(_){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${P?.reason||"<unknown>"}, code: ${P?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${P?.reason||"<unknown>"}, code: ${P?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:_,reason:P?.reason,code:P?.exitCode,sandboxed:P?.sandboxed?"1":"0"}),_){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(_===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:O,checkboxChecked:U}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null),(0,f.localize)(2,null)],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),checkboxLabel:this._config?.workspace?(0,f.localize)(5,null):void 0},this._win);if(O!==2){const B=O===0;await this.destroyWindow(B,U)}}else if(_===2)if(m.isWindows&&P?.reason==="launch-failed"&&P.exitCode===18&&await this.nativeHostMainService.isAdmin(void 0))await this.handleWindowsAdminCrash(P);else{let O;P?O=(0,f.localize)(7,null,P.reason,P.exitCode??"<unknown>"):O=(0,f.localize)(6,null);const{response:U,checkboxChecked:B}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,f.localize)(8,null):(0,f.localize)(9,null),(0,f.localize)(10,null)],message:O,detail:this._config?.workspace?(0,f.localize)(11,null):(0,f.localize)(12,null),checkboxLabel:this._config?.workspace?(0,f.localize)(13,null):void 0},this._win),F=U===0;await this.destroyWindow(F,B)}break}}async handleWindowsAdminCrash(_){const P=[],O=(0,K.isInternalTelemetry)(this.productService,this.configurationService);if((0,K.supportsTelemetry)(this.productService,this.environmentMainService)){this.productService.aiConfig&&this.productService.aiConfig.ariaKey&&P.push(new ue.OneDataSystemAppender(O,"monacoworkbench",null,this.productService.aiConfig.ariaKey));const B=await(0,$.resolveMachineId)(this.stateService,this.logService),F={appenders:P,sendErrorTelemetry:!1,commonProperties:(0,q.resolveCommonProperties)((0,N.release)(),(0,N.hostname)(),process.arch,this.productService.commit,this.productService.version,B,O),piiPaths:(0,K.getPiiPathsFromEnvironment)(this.environmentMainService)};await new ce.TelemetryService(F,this.configurationService,this.productService).publicLog2("windowadminerror",{reason:_.reason,code:_.exitCode})}const{response:U}=await this.dialogMainService.showMessageBox({type:"error",buttons:[(0,f.localize)(14,null),(0,f.localize)(15,null)],message:(0,f.localize)(16,null),detail:(0,f.localize)(17,null,this.productService.nameLong)},this._win);U===0&&await this.nativeHostMainService.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(P.map(B=>B.flush())),await this.destroyWindow(!1,!1)}async destroyWindow(_,P){const O=this._config?.workspace;if(P&&O)try{const U=this.storageMainService.workspaceStorage(O);await U.init(),U.delete("memento/workbench.parts.editor"),await U.close()}catch(U){this.logService.error(U)}if(this._onDidDestroy.fire(),this._win?.destroy(),_&&this._config){let U,B;(0,M.isSingleFolderWorkspaceIdentifier)(O)?U={folderUri:O.uri}:(0,M.isWorkspaceIdentifier)(O)?U={workspaceUri:O.configPath}:B=!0,(0,ee.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:U?[U]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}onDidDeleteUntitledWorkspace(_){this._config?.workspace?.id===_.id&&(this._config.workspace=void 0)}onConfigurationUpdated(_){if(!_||_.affectsConfiguration("window.menuBarVisibility")){const P=this.getMenuBarVisibility();P!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=P,this.setMenuBarVisibility(P))}if(!_||_.affectsConfiguration("http.proxy")){let P=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;P?.endsWith("/")&&(P=P.substr(0,P.length-1));const O=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((P||"").indexOf("@")===-1&&(P!==this.currentHttpProxy||O!==this.currentNoProxy)){this.currentHttpProxy=P,this.currentNoProxy=O;const U=P||"",B=O?`${O},<local>`:"<local>";this.logService.trace(`Setting proxy to '${U}', bypassing '${B}'`),this._win.webContents.session.setProxy({proxyRules:U,proxyBypassRules:B,pacScript:""})}}}addTabbedWindow(_){m.isMacintosh&&_.win&&this._win.addTabbedWindow(_.win)}load(_,P=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!P.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),P.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(_,P),this.readyState===0?this._config=_:this.pendingLoadConfig=_,this.readyState=1,this._win.loadURL(u.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const O=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:_.workspace,reason:P.isReload?3:O?2:1})}updateConfiguration(_,P){const O=(this._config??this.pendingLoadConfig)?.userEnv;if(O){const U=(0,c.isLaunchedFromCli)(O)&&!(0,c.isLaunchedFromCli)(_.userEnv),B=this.isExtensionDevelopmentHost;(U||B)&&(_.userEnv={...O,..._.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(_.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),P.disableExtensions!==void 0&&(_["disable-extensions"]=P.disableExtensions),_.fullscreen=this.isFullScreen,_.maximized=this._win.isMaximized(),_.partsSplash=this.themeMainService.getWindowSplash(),(0,p.mark)("code/willOpenNewWindow"),_.perfMarks=(0,p.getMarks)(),this.configObjectUrl.update(_)}async reload(_){const P=Object.assign({},this._config);P.workspace=await this.validateWorkspaceBeforeReload(P),delete P.filesToOpenOrCreate,delete P.filesToDiff,delete P.filesToMerge,delete P.filesToWait,this.isExtensionDevelopmentHost&&_&&(P.verbose=_.verbose,P.debugId=_.debugId,P.extensionEnvironment=_.extensionEnvironment,P["inspect-extensions"]=_["inspect-extensions"],P["inspect-brk-extensions"]=_["inspect-brk-extensions"],P["extensions-dir"]=_["extensions-dir"]),P.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),P.isInitialStartup=!1,P.policiesData=this.policyService.serialize(),P.continueOn=this.environmentMainService.continueOn,P.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},P.logLevel=this.loggerMainService.getLogLevel(),P.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(P,{isReload:!0,disableExtensions:_?.["disable-extensions"]})}async validateWorkspaceBeforeReload(_){if((0,M.isWorkspaceIdentifier)(_.workspace)){const P=_.workspace.configPath;if(P.scheme===u.Schemas.file&&!await this.fileService.exists(P))return}else if((0,M.isSingleFolderWorkspaceIdentifier)(_.workspace)){const P=_.workspace.uri;if(P.scheme===u.Schemas.file&&!await this.fileService.exists(P))return}return _.workspace}serializeWindowState(){if(!this._win)return(0,W.defaultWindowState)();if(this.isFullScreen){let O;try{O=E.screen.getDisplayMatching(this.getBounds())}catch{}const U=(0,W.defaultWindowState)();return{mode:3,display:O?O.id:void 0,width:this.windowState.width||U.width,height:this.windowState.height||U.height,x:this.windowState.x||0,y:this.windowState.y||0}}const _=Object.create(null);let P;if(!m.isMacintosh&&this._win.isMaximized()?P=0:P=1,P===0?_.mode=0:_.mode=1,P===1||P===0){let O;P===1?O=this.getBounds():O=this._win.getNormalBounds(),_.x=O.x,_.y=O.y,_.width=O.width,_.height=O.height}return _}updateWindowControls(_){if(_.height&&this.stateService.setItem(at.windowControlHeightStateStorageKey,_.height),m.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:_.backgroundColor?.trim()===""?void 0:_.backgroundColor,symbolColor:_.foregroundColor?.trim()===""?void 0:_.foregroundColor,height:_.height?_.height-1:void 0});else if(m.isMacintosh&&_.height!==void 0){const P=(_.height-15)/2;this._win.setTrafficLightPosition({x:P,y:P})}}restoreWindowState(_){(0,p.mark)("code/willRestoreCodeWindowState");let P=!1;if(_)try{const O=E.screen.getAllDisplays();P=O.length>1,_=this.validateWindowState(_,O)}catch(O){this.logService.warn(`Unexpected error validating window state: ${O}
${O.stack}`)}return(0,p.mark)("code/didRestoreCodeWindowState"),[_||(0,W.defaultWindowState)(),P]}validateWindowState(_,P){if(this.logService.trace(`window#validateWindowState: validating window state on ${P.length} display(s)`,_),typeof _.x!="number"||typeof _.y!="number"||typeof _.width!="number"||typeof _.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(_.width<=0||_.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(P.length===1){const B=this.getWorkingArea(P[0]);if(B){let F=function(){!_||typeof _.x!="number"||typeof _.y!="number"||!B||(_.x<B.x&&(_.x=B.x),_.y<B.y&&(_.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),F(),_.width>B.width&&(_.width=B.width),_.height>B.height&&(_.height=B.height),_.x>B.x+B.width-128&&(_.x=B.x+B.width-_.width),_.y>B.y+B.height-128&&(_.y=B.y+B.height-_.height),F()}return _}if(_.display&&_.mode===3){const B=P.find(F=>F.id===_.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const F=(0,W.defaultWindowState)(3);return F.x=B.bounds.x,F.y=B.bounds.y,F}}let O,U;try{O=E.screen.getDisplayMatching({x:_.x,y:_.y,width:_.width,height:_.height}),U=this.getWorkingArea(O)}catch{}if(O&&U&&_.x+_.width>U.x&&_.y+_.height>U.y&&_.x<U.x+U.width&&_.y<U.y+U.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",U),_}getWorkingArea(_){if(_.workArea.width>0&&_.workArea.height>0)return _.workArea;if(_.bounds.width>0&&_.bounds.height>0)return _.bounds}getBounds(){const[_,P]=this._win.getPosition(),[O,U]=this._win.getSize();return{x:_,y:P,width:O,height:U}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(_){this.useNativeFullScreen()?this.setNativeFullScreen(_):this.setSimpleFullScreen(_),this.sendWhenReady(_?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return m.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(_){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(_)}doSetNativeFullScreen(_){m.isMacintosh&&(this.transientIsNativeFullScreen=_,this.joinNativeFullScreenTransition=new L.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,L.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(_)}setSimpleFullScreen(_){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(_),this._win.webContents.focus()}useNativeFullScreen(){const _=this.configurationService.getValue("window");return!_||typeof _.nativeFullScreen!="boolean"||_.nativeTabs?!0:_.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let _=(0,I.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(_)<0&&(_="classic"),_}setMenuBarVisibility(_,P=!0){m.isMacintosh||(_==="toggle"&&P&&this.send("vscode:showInfoMessage",(0,f.localize)(18,null)),_==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(_)}):this.doSetMenuBarVisibility(_))}doSetMenuBarVisibility(_){const P=this.isFullScreen;switch(_){case"classic":this._win.setMenuBarVisibility(!P),this._win.autoHideMenuBar=P;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(_,P,...O){this.isReady?this.send(_,...O):this.ready().then(()=>{P.isCancellationRequested||this.send(_,...O)})}send(_,...P){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${_}' for window that is destroyed`);return}try{this._win.webContents.send(_,...P)}catch(O){this.logService.warn(`Error sending IPC message to channel '${_}' of window ${this._id}: ${(0,A.toErrorMessage)(O)}`)}}}updateTouchBar(_){m.isMacintosh&&this.touchBarGroups.forEach((P,O)=>{const U=_[O];P.segments=this.createTouchBarGroupSegments(U)})}createTouchBar(){if(m.isMacintosh){for(let _=0;_<10;_++){const P=this.createTouchBarGroup();this.touchBarGroups.push(P)}this._win.setTouchBar(new E.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(_=[]){const P=this.createTouchBarGroupSegments(_),O=new E.TouchBar.TouchBarSegmentedControl({segments:P,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:O.segments[U].id,from:"touchbar"})}});return O}createTouchBarGroupSegments(_=[]){return _.map(O=>{let U;O.icon&&!d.ThemeIcon.isThemeIcon(O.icon)&&O.icon?.dark?.scheme===u.Schemas.file&&(U=E.nativeImage.createFromPath(w.URI.revive(O.icon.dark).fsPath),U.isEmpty()&&(U=void 0));let B;return typeof O.title=="string"?B=O.title:B=O.title.value,{id:O.id,label:U?void 0:B,icon:U}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id),this._win=null}};le.windowControlHeightStateStorageKey="windowControlHeight",le.sandboxState=void 0,e.CodeWindow=le=ye([X(1,C.ILogService),X(2,G.ILoggerMainService),X(3,g.IEnvironmentMainService),X(4,H.IPolicyService),X(5,ne.IUserDataProfilesMainService),X(6,y.IFileService),X(7,n.IApplicationStorageMainService),X(8,n.IStorageMainService),X(9,v.IConfigurationService),X(10,h.IThemeMainService),X(11,T.IWorkspacesManagementMainService),X(12,S.IBackupMainService),X(13,o.ITelemetryService),X(14,s.IDialogMainService),X(15,b.ILifecycleMainService),X(16,t.IProductService),X(17,a.IProtocolMainService),X(18,R.IWindowsMainService),X(19,J.IStateService),X(20,re.INativeHostMainService)],le)}),define(te[81],ie([0,1,15,23,7,4,44,2,14,3,18,8,24,188,6,20,5,98,95,29,54,35]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,S.createDecorator)("workspacesHistoryMainService");let t=e.WorkspacesHistoryMainService=class it extends k.Disposable{constructor(i,n,o,d){super(),this.logService=i,this.workspacesManagementMainService=n,this.lifecycleMainService=o,this.applicationStorageMainService=d,this._onDidChangeRecentlyOpened=this._register(new A.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new r.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const h of i)if((0,c.isRecentWorkspace)(h))!this.workspacesManagementMainService.isUntitledWorkspace(h.workspace)&&!this.containsWorkspace(n,h.workspace)&&n.push(h);else if((0,c.isRecentFolder)(h))this.containsFolder(n,h.folderUri)||n.push(h);else{const I=this.containsFile(o,h.fileUri),R=h.fileUri.scheme===u.Schemas.file&&it.COMMON_FILES_FILTER.indexOf((0,p.basename)(h.fileUri))>=0;!I&&!R&&(o.push(h),l.isWindows&&h.fileUri.scheme===u.Schemas.file&&E.app.addRecentDocument(h.fileUri.fsPath))}const d=await this.mergeEntriesFromStorage({workspaces:n,files:o});n=d.workspaces,o=d.files,n.length>it.MAX_TOTAL_RECENT_ENTRIES&&(n.length=it.MAX_TOTAL_RECENT_ENTRIES),o.length>it.MAX_TOTAL_RECENT_ENTRIES&&(o.length=it.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:n,files:o}),this._onDidChangeRecentlyOpened.fire(),l.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(i){const n=I=>{const R=this.location(I);for(const M of i)if(p.extUriBiasedIgnorePathCase.isEqual(M,R))return!1;return!0},o=await this.getRecentlyOpened(),d=o.workspaces.filter(n),h=o.files.filter(n);(d.length!==o.workspaces.length||h.length!==o.files.length)&&(await this.saveRecentlyOpened({files:h,workspaces:d}),this._onDidChangeRecentlyOpened.fire(),l.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(i){const n=new C.ResourceMap(h=>p.extUriBiasedIgnorePathCase.getComparisonKey(h));if(i?.workspaces)for(const h of i.workspaces)n.set(this.location(h),h);const o=new C.ResourceMap(h=>p.extUriBiasedIgnorePathCase.getComparisonKey(h));if(i?.files)for(const h of i.files)o.set(this.location(h),h);const d=await this.getRecentlyOpenedFromStorage();for(const h of d.workspaces){const I=n.get(this.location(h));I?I.label=I.label??h.label:n.set(this.location(h),h)}for(const h of d.files){const I=o.get(this.location(h));I?I.label=I.label??h.label:o.set(this.location(h),h)}return{workspaces:[...n.values()],files:[...o.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let i;const n=this.applicationStorageMainService.get(it.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.logService.error("Unexpected error parsing opened paths list",o)}return(0,c.restoreRecentlyOpened)(i,this.logService)}async saveRecentlyOpened(i){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(it.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,c.toStoreData)(i)),-1,1)}location(i){return(0,c.isRecentFolder)(i)?i.folderUri:(0,c.isRecentFile)(i)?i.fileUri:i.workspace.configPath}containsWorkspace(i,n){return!!i.find(o=>(0,c.isRecentWorkspace)(o)&&o.workspace.id===n.id)}containsFolder(i,n){return!!i.find(o=>(0,c.isRecentFolder)(o)&&p.extUriBiasedIgnorePathCase.isEqual(o.folderUri,n))}containsFile(i,n){return!!i.find(o=>p.extUriBiasedIgnorePathCase.isEqual(o.fileUri,n))}async handleWindowsJumpList(){l.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!l.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const h of E.app.getJumpListSettings().removedItems){const I=h.args;if(I){const R=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(I);R&&n.push(m.URI.parse(R[2]))}}await this.removeRecentlyOpened(n);let o=!1;const d=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,it.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(h=>{const I=(0,c.isRecentWorkspace)(h)?h.workspace:h.folderUri,{title:R,description:M}=this.getWindowsJumpListLabel(I,h.label);let T;return m.URI.isUri(I)?T=`--folder-uri "${I.toString()}"`:(o=!0,T=`--file-uri "${I.configPath.toString()}"`),{type:"task",title:R.substr(0,255),description:M.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));d.length>0&&i.push({type:"custom",name:o?(0,f.localize)(2,null):(0,f.localize)(3,null),items:d})}i.push({type:"recent"});try{const n=E.app.setJumpList(i);n&&n!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.logService.warn("updateWindowsJumpList#setJumpList",n)}}getWindowsJumpListLabel(i,n){if(n)return{title:(0,D.splitName)(n).name,description:n};if(m.URI.isUri(i))return{title:(0,p.basename)(i),description:this.renderJumpListPathDescription(i)};if(this.workspacesManagementMainService.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let o=(0,p.basename)(i.configPath);return o.endsWith(y.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-y.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,o),description:this.renderJumpListPathDescription(i.configPath)}}renderJumpListPathDescription(i){return i.scheme==="file"?(0,D.normalizeDriveLetter)(i.fsPath):i.toString()}async updateMacOSRecentDocuments(){if(!l.isMacintosh)return;E.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let h=0;h<i.workspaces.length&&o<it.MAX_MACOS_DOCK_RECENT_WORKSPACES;h++){const I=this.location(i.workspaces[h]);if(I.scheme===u.Schemas.file){const R=(0,p.originalFSPath)(I);await w.Promises.exists(R)&&(n.push(R),o++)}}const d=[];for(let h=0;h<i.files.length&&o<it.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;h++){const I=this.location(i.files[h]);if(I.scheme===u.Schemas.file){const R=(0,p.originalFSPath)(I);if(it.COMMON_FILES_FILTER.includes((0,p.basename)(I))||n.includes(R))continue;await w.Promises.exists(R)&&(d.push(R),o++)}}d.reverse().forEach(h=>E.app.addRecentDocument(h)),n.reverse().forEach(h=>E.app.addRecentDocument(h))}};t.MAX_TOTAL_RECENT_ENTRIES=500,t.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",t.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,t.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,t.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,t.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],e.WorkspacesHistoryMainService=t=ye([X(0,s.ILogService),X(1,b.IWorkspacesManagementMainService),X(2,v.ILifecycleMainService),X(3,g.IApplicationStorageMainService)],t)}),define(te[287],ie([0,1,15,7,22,44,3,8,178,19,30,20,5,226,59,21,33,25,47,79,28,81]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let a=e.Menubar=class yt{constructor(o,d,h,I,R,M,T,W,z,H,J){this.updateService=o,this.configurationService=d,this.windowsMainService=h,this.environmentMainService=I,this.telemetryService=R,this.workspacesHistoryMainService=M,this.stateService=T,this.lifecycleMainService=W,this.logService=z,this.nativeHostMainService=H,this.productService=J,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,y.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateService.getItem(yt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(M,T,W)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(M,T,W)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(M,T,W)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(W),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(M,T,W)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(W),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(M,T,W)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(W),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const d=this.productService.requestFeatureUrl;d&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(d,"openUserVoiceUrl"));const h=this.productService.reportIssueUrl;h&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(h,"openReportIssues"));const I=this.productService.licenseUrl;I&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const M=I.indexOf("?")>0?"&":"?";this.openUrl(`${I}${M}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(I,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&I&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,d){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateService.setItem(yt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){D.isMacintosh&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){D.isMacintosh&&(this.noActiveWindow=!E.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=E.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){E.Menu.setApplicationMenu(D.isMacintosh?new E.Menu:null);return}const d=new E.Menu;let h;if(D.isMacintosh){const R=new E.Menu;h=new E.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),d.append(h)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new E.Menu;R.append(new E.MenuItem({label:this.mnemonicLabel(u.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),E.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new E.Menu,M=new E.MenuItem({label:this.mnemonicLabel(u.localize(1,null)),submenu:R});this.setMenuById(R,"File"),d.append(M)}if(this.shouldDrawMenu("Edit")){const R=new E.Menu,M=new E.MenuItem({label:this.mnemonicLabel(u.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),d.append(M)}if(this.shouldDrawMenu("Selection")){const R=new E.Menu,M=new E.MenuItem({label:this.mnemonicLabel(u.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),d.append(M)}if(this.shouldDrawMenu("View")){const R=new E.Menu,M=new E.MenuItem({label:this.mnemonicLabel(u.localize(4,null)),submenu:R});this.setMenuById(R,"View"),d.append(M)}if(this.shouldDrawMenu("Go")){const R=new E.Menu,M=new E.MenuItem({label:this.mnemonicLabel(u.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),d.append(M)}if(this.shouldDrawMenu("Run")){const R=new E.Menu,M=new E.MenuItem({label:this.mnemonicLabel(u.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),d.append(M)}if(this.shouldDrawMenu("Terminal")){const R=new E.Menu,M=new E.MenuItem({label:this.mnemonicLabel(u.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),d.append(M)}let I;if(this.shouldDrawMenu("Window")){const R=new E.Menu;I=new E.MenuItem({label:this.mnemonicLabel(u.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(I&&d.append(I),this.shouldDrawMenu("Help")){const R=new E.Menu,M=new E.MenuItem({label:this.mnemonicLabel(u.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),d.append(M)}d.items&&d.items.length>0?E.Menu.setApplicationMenu(d):E.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const d=this.createMenuItem(u.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),h=this.getUpdateMenuItems();let I;if(this.shouldDrawMenu("Preferences")){const ne=new E.Menu;this.setMenuById(ne,"Preferences"),I=new E.MenuItem({label:this.mnemonicLabel(u.localize(11,null)),submenu:ne})}const R=new E.Menu,M=new E.MenuItem({label:u.localize(12,null),role:"services",submenu:R}),T=new E.MenuItem({label:u.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),W=new E.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new E.MenuItem({label:u.localize(15,null),role:"unhide"}),H=new E.MenuItem(this.likeAction("workbench.action.quit",{label:u.localize(16,null,this.productService.nameLong),click:async(ne,re,ue)=>{const ce=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||E.BrowserWindow.getFocusedWindow()||ce?.isMinimized())&&await this.confirmBeforeQuit(ue)&&this.nativeHostMainService.quit(void 0)}})),J=[d];J.push(...h),I&&J.push(i(),I),J.push(i(),M,i(),T,W,z,i(),H),J.forEach(ne=>o.append(ne))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const d=this.configurationService.getValue("window.confirmBeforeClose");if(d==="always"||d==="keyboardOnly"&&this.isKeyboardEvent(o)){const{response:h}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[u.localize(17,null),u.localize(18,null)],message:u.localize(19,null)});return h===0}return!0}shouldDrawMenu(o){if(!D.isMacintosh&&(0,y.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,d){d.forEach(h=>{if((0,f.isMenubarMenuItemSeparator)(h))o.append(i());else if((0,f.isMenubarMenuItemSubmenu)(h)){const I=new E.Menu,R=new E.MenuItem({label:this.mnemonicLabel(h.label),submenu:I});this.setMenu(I,h.submenu.items),o.append(R)}else(0,f.isMenubarMenuItemRecentAction)(h)?o.append(this.createOpenRecentMenuItem(h)):(0,f.isMenubarMenuItemAction)(h)&&(h.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[h.id]?o.append(new E.MenuItem(this.likeAction(h.id,{label:this.mnemonicLabel(h.label),click:this.fallbackMenuHandlers[h.id]}))):o.append(this.createMenuItem(h.label,h.id,!1,h.checked)):o.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)):o.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)))})}setMenuById(o,d){this.menubarMenus&&this.menubarMenus[d]&&this.setMenu(o,this.menubarMenus[d].items)}insertCheckForUpdatesItems(o){const d=this.getUpdateMenuItems();d.length&&(d.forEach(h=>o.append(h)),o.append(i()))}createOpenRecentMenuItem(o){const d=k.URI.revive(o.uri),h=o.id,I=h==="openRecentFile"?{fileUri:d}:h==="openRecentWorkspace"?{workspaceUri:d}:{folderUri:d};return new E.MenuItem(this.likeAction(h,{label:o.label,click:async(R,M,T)=>{const W=this.isOptionClick(T);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[I],forceNewWindow:W,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([d])}},!1))}isOptionClick(o){return!!(o&&(!D.isMacintosh&&(o.ctrlKey||o.shiftKey)||D.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,d,h){const I={label:this.mnemonicLabel(o),role:h,enabled:!0};return new E.MenuItem(this.withKeybinding(d,I))}setMacWindowMenu(o){const d=new E.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),h=new E.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),I=new E.MenuItem({label:u.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(u.localize(23,null),"workbench.action.switchWindow"),M=[];this.currentEnableNativeTabs&&(M.push(i()),M.push(this.createMenuItem(u.localize(24,null),"workbench.action.newWindowTab")),M.push(this.createRoleMenuItem(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.createRoleMenuItem(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.createRoleMenuItem(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.createRoleMenuItem(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[d,h,i(),R,...M,i(),I].forEach(T=>o.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.mnemonicLabel(u.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.mnemonicLabel(u.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.mnemonicLabel(u.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new E.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.mnemonicLabel(u.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,d,h,I){const R=this.mnemonicLabel(o),M=typeof d=="function"?d:(J,ne,re)=>{const ue=J?J.userSettingsLabel:null;let ce=d;Array.isArray(d)&&(ce=this.isOptionClick(re)?d[1]:d[0]),ue&&re.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ue}):this.runActionInRenderer({type:"commandId",commandId:ce})},T=typeof h=="boolean"?h:this.windowsMainService.getWindowCount()>0,W=typeof I=="boolean"?I:!1,z={label:R,click:M,enabled:T};W&&(z.type="checkbox",z.checked=W);let H;return typeof d=="string"?H=d:Array.isArray(d)&&(H=d[0]),D.isMacintosh&&(H==="editor.action.clipboardCutAction"?z.role="cut":H==="editor.action.clipboardCopyAction"?z.role="copy":H==="editor.action.clipboardPasteAction"&&(z.role="paste"),H==="undo"?z.click=this.makeContextAwareClickHandler(M,{inDevTools:J=>J.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):H==="redo"?z.click=this.makeContextAwareClickHandler(M,{inDevTools:J=>J.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):H==="editor.action.selectAll"&&(z.click=this.makeContextAwareClickHandler(M,{inDevTools:J=>J.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.withKeybinding(H,z))}makeContextAwareClickHandler(o,d){return(h,I,R)=>{const M=E.BrowserWindow.getFocusedWindow();if(!M)return d.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return d.inDevTools(M.webContents.devToolsWebContents);o(h,I||M,R)}}runActionInRenderer(o){let d=E.BrowserWindow.getFocusedWindow();if(!d){const I=this.windowsMainService.getLastActiveWindow();I?.isMinimized()&&(d=I.win)}const h=d?this.windowsMainService.getWindowById(d.id):void 0;if(h){if(this.logService.trace("menubar#runActionInRenderer",o),D.isMacintosh&&!this.environmentMainService.isBuilt&&!h.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const I={id:o.commandId,from:"menu"};h.sendWhenReady("vscode:runAction",r.CancellationToken.None,I)}else{const I={userSettingsLabel:o.userSettingsLabel};h.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,I)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,d){const h=typeof o=="string"?this.keybindings[o]:void 0;if(h?.label){if(h.isNative!==!1)d.accelerator=h.label,d.userSettingsLabel=h.userSettingsLabel;else if(typeof d.label=="string"){const I=d.label.indexOf("[");I>=0?d.label=`${d.label.substr(0,I)} [${h.label}]`:d.label=`${d.label} [${h.label}]`}}else d.accelerator=void 0;return d}likeAction(o,d,h=!d.accelerator){h&&(d=this.withKeybinding(o,d));const I=d.click;return d.click=(R,M,T)=>{this.reportMenuActionTelemetry(o),I?.(R,M,T)},d}openUrl(o,d){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(d)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:t})}mnemonicLabel(o){return(0,A.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",e.Menubar=a=ye([X(0,c.IUpdateService),X(1,l.IConfigurationService),X(2,b.IWindowsMainService),X(3,p.IEnvironmentMainService),X(4,g.ITelemetryService),X(5,C.IWorkspacesHistoryMainService),X(6,s.IStateService),X(7,m.ILifecycleMainService),X(8,w.ILogService),X(9,S.INativeHostMainService),X(10,v.IProductService)],a);function i(){return new E.MenuItem({type:"separator"})}}),define(te[288],ie([0,1,6,20,5,287]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let D=e.MenubarMainService=class{constructor(u,l,p){this.instantiationService=u,this.lifecycleMainService=l,this.logService=p,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(A.Menubar)}async updateMenubar(u,l){this.logService.trace("menubarService#updateMenubar",u),(await this.menubar).updateMenu(l,u)}};e.MenubarMainService=D=ye([X(0,E.IInstantiationService),X(1,L.ILifecycleMainService),X(2,r.ILogService)],D)}),define(te[289],ie([0,1,15,24,87,26,23,22,4,32,48,44,2,14,9,64,3,36,18,11,8,186,63,19,58,30,16,6,20,5,76,77,57,33,79,286,125,282,29,96,81,54,78,37,53,65]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y,b,C,t,a,i,n,o,d,h,I,R,M,T,W,z,H,J,ne,re,ue,ce,K,q,N,$,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function ee(Y){return(0,re.isWorkspaceIdentifier)(Y?.workspace)}function oe(Y){return(0,re.isSingleFolderWorkspaceIdentifier)(Y?.workspace)}let le=e.WindowsMainService=class ct extends w.Disposable{constructor(_,P,O,U,B,F,x,V,se,ae,Se,De,Re,Le,Oe,we,ve,Pe){super(),this.machineId=_,this.initialUserEnv=P,this.logService=O,this.loggerService=U,this.stateService=B,this.policyService=F,this.environmentMainService=x,this.userDataProfilesMainService=V,this.lifecycleMainService=se,this.backupMainService=ae,this.configurationService=Se,this.workspacesHistoryMainService=De,this.workspacesManagementMainService=Re,this.instantiationService=Le,this.dialogMainService=Oe,this.fileService=we,this.protocolMainService=ve,this.themeMainService=Pe,this._onDidOpenWindow=this._register(new u.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new u.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new u.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new u.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new u.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ne.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(_=>this._onDidSignalReadyWindow.fire(_.window))),this._register(this.onDidSignalReadyWindow(_=>{if(_.config?.extensionDevelopmentPath||_.config?.extensionTestsPath){const P=new w.DisposableStore;if(P.add(u.Event.any(_.onDidClose,_.onDidDestroy)(()=>P.dispose())),_.config.extensionDevelopmentPath)for(const O of _.config.extensionDevelopmentPath)P.add(this.protocolMainService.addValidFileRoot(O));_.config.extensionTestsPath&&P.add(this.protocolMainService.addValidFileRoot(_.config.extensionTestsPath))}}))}openEmptyWindow(_,P){const O=this.environmentMainService.args,U=P?.remoteAuthority||void 0,B=!0,F=P?.forceReuseWindow,x=!F;return this.open({..._,cli:O,forceEmpty:B,forceNewWindow:x,forceReuseWindow:F,remoteAuthority:U})}openExistingWindow(_,P){_.focus(),this.handleWaitMarkerFile(P,[_])}async open(_){this.logService.trace("windowsManager#open"),_.addMode&&(_.initialStartup||!this.getLastActiveWindow())&&(_.addMode=!1);const P=[],O=[],U=[],B=[],F=[];let x,V=0;const se=await this.getPathsToOpen(_);this.logService.trace("windowsManager#open pathsToOpen",se);for(const Le of se)oe(Le)?_.addMode?P.push(Le):O.push(Le):ee(Le)?U.push(Le):Le.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Le.remoteAuthority}),x.filesToOpenOrCreate.push(Le)):Le.backupPath?F.push({backupFolder:(0,S.basename)(Le.backupPath),remoteAuthority:Le.remoteAuthority}):V++;_.diffMode&&x&&x.filesToOpenOrCreate.length>=2&&(x.filesToDiff=x.filesToOpenOrCreate.slice(0,2),x.filesToOpenOrCreate=[]),_.mergeMode&&x&&x.filesToOpenOrCreate.length===4&&(x.filesToMerge=x.filesToOpenOrCreate.slice(0,4),x.filesToOpenOrCreate=[],x.filesToDiff=[]),x&&_.waitMarkerFileURI&&(x.filesToWait={paths:(0,D.coalesce)([...x.filesToDiff,x.filesToMerge[3],...x.filesToOpenOrCreate]),waitMarkerFileUri:_.waitMarkerFileURI}),_.initialStartup?(B.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),U.push(...B),F.push(...this.backupMainService.getEmptyWindowBackups())):F.length=0;const{windows:ae,filesOpenedInWindow:Se}=await this.doOpen(_,U,O,F,V,x,P);if(this.logService.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${U.length}, foldersToOpen: ${O.length}, emptyToRestore: ${F.length}, emptyToOpen: ${V})`),ae.length>1)if(Se)Se.focus();else{const Le=this.windowsStateHandler.state.lastActiveWindow&&!_.forceEmpty&&!_.cli._.length&&!_.cli["file-uri"]&&!_.cli["folder-uri"]&&!(_.urisToOpen&&_.urisToOpen.length);let Oe=!0,we=!0;if(Le){const ve=ae.filter(Pe=>this.windowsStateHandler.state.lastActiveWindow&&Pe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ve.length&&(ve[0].focus(),Oe=!1,we=!1)}if(Oe)for(let ve=ae.length-1;ve>=0;ve--){const Pe=ae[ve];if(!(Pe.openedWorkspace&&B.some(Z=>Pe.openedWorkspace&&Z.workspace.id===Pe.openedWorkspace.id)||Pe.backupPath&&F.some(Z=>Pe.backupPath&&Z.backupFolder===(0,S.basename)(Pe.backupPath)))){Pe.focus(),we=!1;break}}we&&ae[ae.length-1].focus()}const De=x&&x.filesToDiff.length>0,Re=x&&x.filesToMerge.length>0;if(!ae.some(Le=>Le.isExtensionDevelopmentHost)&&!De&&!Re&&!_.noRecentEntry){const Le=[];for(const Oe of se)ee(Oe)&&!Oe.transient?Le.push({label:Oe.label,workspace:Oe.workspace,remoteAuthority:Oe.remoteAuthority}):oe(Oe)?Le.push({label:Oe.label,folderUri:Oe.workspace.uri,remoteAuthority:Oe.remoteAuthority}):Oe.fileUri&&Le.push({label:Oe.label,fileUri:Oe.fileUri,remoteAuthority:Oe.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Le)}return this.handleWaitMarkerFile(_,ae),ae}handleWaitMarkerFile(_,P){const O=_.waitMarkerFileURI;_.context===0&&O&&P.length===1&&P[0]&&(async()=>{await P[0].whenClosedOrLoaded;try{await this.fileService.del(O)}catch{}})()}async doOpen(_,P,O,U,B,F,x){const V=[];let se;function ae(ve,Pe){V.push(ve),Pe&&(se=ve,F=void 0)}let{openFolderInNewWindow:Se,openFilesInNewWindow:De}=this.shouldOpenNewWindow(_);if(!_.initialStartup&&x.length>0){const ve=x[0].remoteAuthority,Pe=this.getLastActiveWindowForAuthority(ve);Pe&&ae(this.doAddFoldersToExistingWindow(Pe,x.map(Z=>Z.workspace.uri)))}const Re=O.length+P.length+U.length;if(F&&Re===0){const ve=F.filesToOpenOrCreate[0]||F.filesToDiff[0]||F.filesToMerge[3],Pe=this.getWindows().filter(de=>F&&(0,c.isEqualAuthority)(de.remoteAuthority,F.remoteAuthority));let Z;ve?.fileUri&&!De&&((_.context===4||_.context===0||_.context===1)&&(Z=await(0,J.findWindowOnFile)(Pe,ve.fileUri,async de=>de.configPath.scheme===f.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(de.configPath):void 0)),Z||(Z=this.doGetLastActiveWindow(Pe))),Z?(0,re.isWorkspaceIdentifier)(Z.openedWorkspace)?P.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(Z.openedWorkspace)?O.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):ae(this.doOpenFilesInExistingWindow(_,Z,F),!0):ae(await this.openInBrowserWindow({userEnv:_.userEnv,cli:_.cli,initialStartup:_.initialStartup,filesToOpen:F,forceNewWindow:!0,remoteAuthority:F.remoteAuthority,forceNewTabbedWindow:_.forceNewTabbedWindow,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile}),!0)}const Le=(0,D.distinct)(P,ve=>ve.workspace.id);if(Le.length>0){const ve=(0,D.coalesce)(Le.map(Pe=>(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),Pe.workspace.configPath)));if(ve.length>0){const Pe=ve[0],Z=(0,c.isEqualAuthority)(F?.remoteAuthority,Pe.remoteAuthority)?F:void 0;ae(this.doOpenFilesInExistingWindow(_,Pe,Z),!!Z),Se=!0}for(const Pe of Le){if(ve.some(fe=>fe.openedWorkspace&&fe.openedWorkspace.id===Pe.workspace.id))continue;const Z=Pe.remoteAuthority,de=(0,c.isEqualAuthority)(F?.remoteAuthority,Z)?F:void 0;ae(await this.doOpenFolderOrWorkspace(_,Pe,Se,de),!!de),Se=!0}}const Oe=(0,D.distinct)(O,ve=>c.extUriBiasedIgnorePathCase.getComparisonKey(ve.workspace.uri));if(Oe.length>0){const ve=(0,D.coalesce)(Oe.map(Pe=>(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),Pe.workspace.uri)));if(ve.length>0){const Pe=ve[0],Z=(0,c.isEqualAuthority)(F?.remoteAuthority,Pe.remoteAuthority)?F:void 0;ae(this.doOpenFilesInExistingWindow(_,Pe,Z),!!Z),Se=!0}for(const Pe of Oe){if(ve.some(fe=>(0,re.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)&&c.extUriBiasedIgnorePathCase.isEqual(fe.openedWorkspace.uri,Pe.workspace.uri)))continue;const Z=Pe.remoteAuthority,de=(0,c.isEqualAuthority)(F?.remoteAuthority,Z)?F:void 0;ae(await this.doOpenFolderOrWorkspace(_,Pe,Se,de),!!de),Se=!0}}const we=(0,D.distinct)(U,ve=>ve.backupFolder);if(we.length>0)for(const ve of we){const Pe=ve.remoteAuthority,Z=(0,c.isEqualAuthority)(F?.remoteAuthority,Pe)?F:void 0;ae(await this.doOpenEmpty(_,!0,Pe,Z,ve),!!Z),Se=!0}if(V.length===0||F){F&&!B&&B++;const ve=F?F.remoteAuthority:_.remoteAuthority;for(let Pe=0;Pe<B;Pe++)ae(await this.doOpenEmpty(_,Se,ve,F),!!F),Se=!0}return{windows:(0,D.distinct)(V),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(_,P,O){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:O}),P.focus();const U={filesToOpenOrCreate:O?.filesToOpenOrCreate,filesToDiff:O?.filesToDiff,filesToMerge:O?.filesToMerge,filesToWait:O?.filesToWait,termProgram:_?.userEnv?.TERM_PROGRAM};return P.sendWhenReady("vscode:openFiles",k.CancellationToken.None,U),P}doAddFoldersToExistingWindow(_,P){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:P}),_.focus();const O={foldersToAdd:P};return _.sendWhenReady("vscode:addFolders",k.CancellationToken.None,O),_}doOpenEmpty(_,P,O,U,B){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!B,remoteAuthority:O,filesToOpen:U,forceNewWindow:P});let F;return!P&&typeof _.contextWindowId=="number"&&(F=this.getWindowById(_.contextWindowId)),this.openInBrowserWindow({userEnv:_.userEnv,cli:_.cli,initialStartup:_.initialStartup,remoteAuthority:O,forceNewWindow:P,forceNewTabbedWindow:_.forceNewTabbedWindow,filesToOpen:U,windowToUse:F,emptyWindowBackupInfo:B,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile})}doOpenFolderOrWorkspace(_,P,O,U,B){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:P,filesToOpen:U}),!O&&!B&&typeof _.contextWindowId=="number"&&(B=this.getWindowById(_.contextWindowId)),this.openInBrowserWindow({workspace:P.workspace,userEnv:_.userEnv,cli:_.cli,initialStartup:_.initialStartup,remoteAuthority:P.remoteAuthority,forceNewWindow:O,forceNewTabbedWindow:_.forceNewTabbedWindow,filesToOpen:U,windowToUse:B,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile})}async getPathsToOpen(_){let P,O=!1,U=!1;if(_.urisToOpen&&_.urisToOpen.length>0?(P=await this.doExtractPathsFromAPI(_),O=!0):_.forceEmpty?P=[Object.create(null)]:_.cli._.length||_.cli["folder-uri"]||_.cli["file-uri"]?(P=await this.doExtractPathsFromCLI(_.cli),P.length===0&&P.push(Object.create(null)),O=!0):(P=await this.doGetPathsFromLastSession(),P.length===0&&P.push(Object.create(null)),U=!0),!_.addMode&&O){const B=P.filter(F=>oe(F));if(B.length>1){const F=B[0].remoteAuthority;if(B.every(x=>(0,c.isEqualAuthority)(x.remoteAuthority,F))){const x=await this.workspacesManagementMainService.createUntitledWorkspace(B.map(V=>({uri:V.workspace.uri})));P.push({workspace:x,remoteAuthority:F}),P=P.filter(V=>!oe(V))}}}if(_.initialStartup&&!U&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const B=await this.doGetPathsFromLastSession();P.unshift(...B.filter(F=>ee(F)||oe(F)||F.backupPath))}return P}async doExtractPathsFromAPI(_){const P={gotoLineMode:_.gotoLineMode,remoteAuthority:_.remoteAuthority},O=await Promise.all((0,D.coalesce)(_.urisToOpen||[]).map(async U=>{const B=await this.resolveOpenable(U,P);if(B)return B.label=U.label,B;const F=this.resourceFromOpenable(U);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,C.localize)(0,null)],message:F.scheme===f.Schemas.file?(0,C.localize)(1,null):(0,C.localize)(2,null),detail:F.scheme===f.Schemas.file?(0,C.localize)(3,null,(0,m.getPathLabel)(F,{os:s.OS,tildify:this.environmentMainService})):(0,C.localize)(4,null,F.toString(!0))},(0,y.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,D.coalesce)(O)}async doExtractPathsFromCLI(_){const P=[],O={ignoreFileNotFound:!0,gotoLineMode:_.goto,remoteAuthority:_.remote||void 0,forceOpenWorkspaceAsFile:_.diff&&_._.length===2||_.merge&&_._.length===4},U=_["folder-uri"];if(U){const x=await Promise.all(U.map(V=>{const se=this.cliArgToUri(V);if(se)return this.resolveOpenable({folderUri:se},O)}));P.push(...(0,D.coalesce)(x))}const B=_["file-uri"];if(B){const x=await Promise.all(B.map(V=>{const se=this.cliArgToUri(V);if(se)return this.resolveOpenable((0,re.hasWorkspaceFileExtension)(V)?{workspaceUri:se}:{fileUri:se},O)}));P.push(...(0,D.coalesce)(x))}const F=await Promise.all(_._.map(x=>O.remoteAuthority?this.doResolveRemotePath(x,O):this.doResolveFilePath(x,O)));return P.push(...(0,D.coalesce)(F)),P}cliArgToUri(_){try{const P=b.URI.parse(_);if(!P.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${_}`);return}return P}catch(P){this.logService.error(`Invalid URI input string: ${_}, ${P.message}`)}}async doGetPathsFromLastSession(){const _=this.getRestoreWindowsSetting();switch(_){case"none":return[];case"one":case"all":case"preserve":case"folders":{const P=[];_!=="one"&&P.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&P.push(this.windowsStateHandler.state.lastActiveWindow);const O=await Promise.all(P.map(async U=>{if(U.workspace){const B=await this.resolveOpenable({workspaceUri:U.workspace.configPath},{remoteAuthority:U.remoteAuthority,rejectTransientWorkspaces:!0});if(ee(B))return B}else if(U.folderUri){const B=await this.resolveOpenable({folderUri:U.folderUri},{remoteAuthority:U.remoteAuthority});if(oe(B))return B}else if(_!=="folders"&&U.backupPath)return{backupPath:U.backupPath,remoteAuthority:U.remoteAuthority}}));return(0,D.coalesce)(O)}}}getRestoreWindowsSetting(){let _;return this.lifecycleMainService.wasRestarted?_="all":(_=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(_)||(_="all")),_}async resolveOpenable(_,P=Object.create(null)){const O=this.resourceFromOpenable(_);return O.scheme===f.Schemas.file?((0,z.isFileToOpen)(_)&&(P={...P,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(O.fsPath,P)):this.doResolveRemoteOpenable(_,P)}doResolveRemoteOpenable(_,P){let O=this.resourceFromOpenable(_);const U=(0,T.getRemoteAuthority)(O)||P.remoteAuthority;if(O=(0,c.removeTrailingPathSeparator)((0,c.normalizePath)(O)),(0,z.isFileToOpen)(_)){if(P.gotoLineMode){const{path:B,line:F,column:x}=(0,l.parseLineAndColumnAware)(O.path);return{fileUri:O.with({path:B}),options:{selection:F?{startLineNumber:F,startColumn:x||1}:void 0},remoteAuthority:U}}return{fileUri:O,remoteAuthority:U}}else if((0,z.isWorkspaceToOpen)(_))return{workspace:(0,ue.getWorkspaceIdentifier)(O),remoteAuthority:U};return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(O),remoteAuthority:U}}resourceFromOpenable(_){return(0,z.isWorkspaceToOpen)(_)?_.workspaceUri:(0,z.isFolderToOpen)(_)?_.folderUri:_.fileUri}async doResolveFilePath(_,P,O){let U,B;P.gotoLineMode&&({path:_,line:U,column:B}=(0,l.parseLineAndColumnAware)(_)),_=(0,l.sanitizeFilePath)((0,S.normalize)(_),(0,g.cwd)());try{const F=await L.Promises.stat(_);if(F.isFile()){if(!P.forceOpenWorkspaceAsFile){const x=await this.workspacesManagementMainService.resolveLocalWorkspace(b.URI.file(_));if(x)return x.transient&&P.rejectTransientWorkspaces?void 0:{workspace:{id:x.id,configPath:x.configPath},type:o.FileType.File,exists:!0,remoteAuthority:x.remoteAuthority,transient:x.transient}}return{fileUri:b.URI.file(_),type:o.FileType.File,exists:!0,options:{selection:U?{startLineNumber:U,startColumn:B||1}:void 0}}}else{if(F.isDirectory())return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(b.URI.file(_),F),type:o.FileType.Directory,exists:!0};if(!s.isWindows&&_==="/dev/null")return{fileUri:b.URI.file(_),type:o.FileType.File,exists:!0}}}catch(F){if(F.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!O)return this.onUNCHostNotAllowed(_,P);const x=b.URI.file(_);if(this.workspacesHistoryMainService.removeRecentlyOpened([x]),P.ignoreFileNotFound)return{fileUri:x,type:o.FileType.File,exists:!1}}}async onUNCHostNotAllowed(_,P){const O=b.URI.file(_),{response:U}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,C.localize)(5,null),(0,C.localize)(6,null),(0,C.localize)(7,null)],message:(0,C.localize)(8,null,O.authority),detail:(0,C.localize)(9,null,(0,m.getPathLabel)(O,{os:s.OS,tildify:this.environmentMainService}))});if(U===0)return(0,r.addUNCHostToAllowlist)(O.authority),this.doResolveFilePath(_,P,!0);U===2&&E.shell.openExternal("https://aka.ms/vscode-windows-unc")}doResolveRemotePath(_,P){const O=_.charCodeAt(0),U=P.remoteAuthority;let B,F;P.gotoLineMode&&({path:_,line:B,column:F}=(0,l.parseLineAndColumnAware)(_)),O!==47&&((0,l.isWindowsDriveLetter)(O)&&_.charCodeAt(_.charCodeAt(1))===58&&(_=(0,l.toSlashes)(_)),_=`/${_}`);const x=b.URI.from({scheme:f.Schemas.vscodeRemote,authority:U,path:_});if(_.charCodeAt(_.length-1)!==47){if((0,re.hasWorkspaceFileExtension)(_))return P.forceOpenWorkspaceAsFile?{fileUri:x,options:{selection:B?{startLineNumber:B,startColumn:F||1}:void 0},remoteAuthority:P.remoteAuthority}:{workspace:(0,ue.getWorkspaceIdentifier)(x),remoteAuthority:U};if(P.gotoLineMode||S.posix.basename(_).indexOf(".")!==-1)return{fileUri:x,options:{selection:B?{startLineNumber:B,startColumn:F||1}:void 0},remoteAuthority:U}}return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(x),remoteAuthority:U}}shouldOpenNewWindow(_){const P=this.configurationService.getValue("window"),O=P?.openFoldersInNewWindow||"default",U=P?.openFilesInNewWindow||"off";let B=(_.preferNewWindow||_.forceNewWindow)&&!_.forceReuseWindow;!_.forceNewWindow&&!_.forceReuseWindow&&(O==="on"||O==="off")&&(B=O==="on");let F=!1;return _.forceNewWindow||_.forceReuseWindow?F=!!_.forceNewWindow&&!_.forceReuseWindow:(s.isMacintosh?_.context===1&&(F=!0):_.context!==3&&_.context!==2&&!(_.userEnv&&_.userEnv.TERM_PROGRAM==="vscode")&&(F=!0),!_.cli.extensionDevelopmentPath&&(U==="on"||U==="off")&&(F=U==="on")),{openFolderInNewWindow:!!B,openFilesInNewWindow:F}}async openExtensionDevelopmentHostWindow(_,P){const O=(0,J.findWindowOnExtensionDevelopmentPath)(this.getWindows(),_);if(O)return this.lifecycleMainService.reload(O,P.cli),O.focus(),[O];let U=P.cli["folder-uri"]||[],B=P.cli["file-uri"]||[],F=P.cli._;if(!F.length&&!U.length&&!B.length&&!P.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ae=se?.workspace??se?.folderUri;ae&&(b.URI.isUri(ae)?ae.scheme===f.Schemas.file?F=[ae.fsPath]:U=[ae.toString()]:ae.configPath.scheme===f.Schemas.file?F=[(0,c.originalFSPath)(ae.configPath)]:B=[ae.configPath.toString()])}let x=P.remoteAuthority;for(const se of _)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=b.URI.parse(se),Se=(0,T.getRemoteAuthority)(ae);Se&&(x?(0,c.isEqualAuthority)(Se,x)||this.logService.error("more than one extension development path authority"):x=Se)}F=F.filter(se=>{const ae=b.URI.file(se);return(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:(0,c.isEqualAuthority)((0,T.getRemoteAuthority)(ae),x)}),U=U.filter(se=>{const ae=this.cliArgToUri(se);return ae&&(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,c.isEqualAuthority)((0,T.getRemoteAuthority)(ae),x):!1}),B=B.filter(se=>{const ae=this.cliArgToUri(se);return ae&&(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,c.isEqualAuthority)((0,T.getRemoteAuthority)(ae),x):!1}),P.cli._=F,P.cli["folder-uri"]=U,P.cli["file-uri"]=B;const V={context:P.context,cli:P.cli,forceNewWindow:!0,forceEmpty:!F.length&&!U.length&&!B.length,userEnv:P.userEnv,noRecentEntry:!0,waitMarkerFileURI:P.waitMarkerFileURI,remoteAuthority:x,forceProfile:P.forceProfile,forceTempProfile:P.forceTempProfile};return this.open(V)}async openInBrowserWindow(_){const P=this.configurationService.getValue("window"),O=this.getLastActiveWindow(),U=O?.profile??this.userDataProfilesMainService.defaultProfile;let B;!_.forceNewWindow&&!_.forceNewTabbedWindow&&(B=_.windowToUse||O,B&&B.focus());const F={...this.environmentMainService.args,..._.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:_.emptyWindowBackupInfo?(0,S.join)(this.environmentMainService.backupHome,_.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:U},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:_.remoteAuthority,workspace:_.workspace,userEnv:{...this.initialUserEnv,..._.userEnv},filesToOpenOrCreate:_.filesToOpen?.filesToOpenOrCreate,filesToDiff:_.filesToOpen?.filesToDiff,filesToMerge:_.filesToOpen?.filesToMerge,filesToWait:_.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.fsPath,product:R.default,isInitialStartup:_.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)()},zoomLevel:typeof P?.zoomLevel=="number"?P.zoomLevel:void 0,autoDetectHighContrast:P?.autoDetectHighContrast??!0,autoDetectColorScheme:P?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(B){const x=B.config;!F.extensionDevelopmentPath&&x?.extensionDevelopmentPath&&(F.extensionDevelopmentPath=x.extensionDevelopmentPath,F.extensionDevelopmentKind=x.extensionDevelopmentKind,F["enable-proposed-api"]=x["enable-proposed-api"],F.verbose=x.verbose,F["inspect-extensions"]=x["inspect-extensions"],F["inspect-brk-extensions"]=x["inspect-brk-extensions"],F.debugId=x.debugId,F.extensionEnvironment=x.extensionEnvironment,F["extensions-dir"]=x["extensions-dir"],F["disable-extensions"]=x["disable-extensions"]),F.loggers={global:F.loggers.global,window:x?.loggers.window??F.loggers.window}}else{const x=this.windowsStateHandler.getNewWindowState(F);(0,v.mark)("code/willCreateCodeWindow");const V=B=this.instantiationService.createInstance(H.CodeWindow,{state:x,extensionDevelopmentPath:F.extensionDevelopmentPath,isExtensionTestHost:!!F.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),_.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(V),ct.WINDOWS.push(V),this._onDidOpenWindow.fire(V),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,p.once)(V.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(V)),(0,p.once)(V.onDidClose)(()=>this.onWindowClosed(V)),(0,p.once)(V.onDidDestroy)(()=>this._onDidDestroyWindow.fire(V)),V.onDidTriggerSystemContextMenu(({x:ae,y:Se})=>this._onDidTriggerSystemContextMenu.fire({window:V,x:ae,y:Se}));const se=(0,y.assertIsDefined)(V.win?.webContents);se.removeAllListeners("devtools-reload-page"),se.on("devtools-reload-page",()=>this.lifecycleMainService.reload(V)),this.lifecycleMainService.registerWindow(V)}return F.windowId=B.id,B.isReady?this.lifecycleMainService.unload(B,4).then(async x=>{x||await this.doOpenInBrowserWindow(B,F,_,U)}):await this.doOpenInBrowserWindow(B,F,_,U),B}async doOpenInBrowserWindow(_,P,O,U){if(P.extensionDevelopmentPath||((0,re.isWorkspaceIdentifier)(P.workspace)?P.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:P.workspace,remoteAuthority:P.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(P.workspace)?P.backupPath=this.backupMainService.registerFolderBackup({folderUri:P.workspace.uri,remoteAuthority:P.remoteAuthority}):P.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:O.emptyWindowBackupInfo?.backupFolder??(0,ue.createEmptyWorkspaceIdentifier)().id,remoteAuthority:P.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const B=P.workspace??(0,re.toWorkspaceIdentifier)(P.backupPath,!1),F=this.resolveProfileForBrowserWindow(O,B,U),x=F instanceof Promise?await F:F;P.profiles.profile=x,P.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(B,x)}_.load(P)}resolveProfileForBrowserWindow(_,P,O){return _.forceProfile?this.userDataProfilesMainService.profiles.find(U=>U.name===_.forceProfile)??this.userDataProfilesMainService.createNamedProfile(_.forceProfile):_.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(P)??O}onWindowClosed(_){const P=ct.WINDOWS.indexOf(_);ct.WINDOWS.splice(P,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const _=E.BrowserWindow.getFocusedWindow();if(_)return this.getWindowById(_.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(_){return this.doGetLastActiveWindow(this.getWindows().filter(P=>(0,c.isEqualAuthority)(P.remoteAuthority,_)))}doGetLastActiveWindow(_){const P=Math.max.apply(Math,_.map(O=>O.lastFocusTime));return _.find(O=>O.lastFocusTime===P)}sendToFocused(_,...P){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(_,k.CancellationToken.None,...P)}sendToAll(_,P,O){for(const U of this.getWindows())O&&O.indexOf(U.id)>=0||U.sendWhenReady(_,k.CancellationToken.None,P)}getWindows(){return ct.WINDOWS}getWindowCount(){return ct.WINDOWS.length}getWindowById(_){const P=this.getWindows().filter(O=>O.id===_);return(0,D.firstOrDefault)(P)}getWindowByWebContents(_){const P=E.BrowserWindow.fromWebContents(_);if(P)return this.getWindowById(P.id)}};le.WINDOWS=[],e.WindowsMainService=le=ye([X(2,I.ILogService),X(3,G.ILoggerMainService),X(4,W.IStateService),X(5,N.IPolicyService),X(6,n.IEnvironmentMainService),X(7,$.IUserDataProfilesMainService),X(8,h.ILifecycleMainService),X(9,t.IBackupMainService),X(10,a.IConfigurationService),X(11,ce.IWorkspacesHistoryMainService),X(12,K.IWorkspacesManagementMainService),X(13,d.IInstantiationService),X(14,i.IDialogMainService),X(15,o.IFileService),X(16,M.IProtocolMainService),X(17,q.IThemeMainService)],le)}),define(te[290],ie([0,1,63,28,81,54]),function(j,e,E,L,r,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=e.WorkspacesMainService=class{constructor(u,l,p,m){this.workspacesManagementMainService=u,this.windowsMainService=l,this.workspacesHistoryMainService=p,this.backupMainService=m,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(u,l){const p=this.windowsMainService.getWindowById(u);if(p)return this.workspacesManagementMainService.enterWorkspace(p,this.windowsMainService.getWindows(),l)}createUntitledWorkspace(u,l,p){return this.workspacesManagementMainService.createUntitledWorkspace(l,p)}deleteUntitledWorkspace(u,l){return this.workspacesManagementMainService.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(u,l){return this.workspacesManagementMainService.getWorkspaceIdentifier(l)}getRecentlyOpened(u){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(u,l){return this.workspacesHistoryMainService.addRecentlyOpened(l)}removeRecentlyOpened(u,l){return this.workspacesHistoryMainService.removeRecentlyOpened(l)}clearRecentlyOpened(u){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=D=ye([X(0,A.IWorkspacesManagementMainService),X(1,L.IWindowsMainService),X(2,r.IWorkspacesHistoryMainService),X(3,E.IBackupMainService)],D)}),define(te[291],ie([0,1,15,87,42,26,17,49,13,32,48,43,44,2,14,9,3,11,8,31,141,45,155,156,257,159,63,270,19,74,195,88,126,58,110,216,30,62,116,205,230,206,279,112,207,208,16,220,91,73,6,90,214,283,271,259,20,5,288,59,21,57,280,92,33,262,98,93,25,243,119,46,47,249,276,284,277,285,122,251,252,253,255,260,28,289,261,29,95,81,290,54,258,37,228,53,238,52,80,124,264,278,267,7,120,263,223,65,89,281,254,23]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y,b,C,t,a,i,n,o,d,h,I,R,M,T,W,z,H,J,ne,re,ue,ce,K,q,N,$,G,ee,oe,le,Y,_,P,O,U,B,F,x,V,se,ae,Se,De,Re,Le,Oe,we,ve,Pe,Z,de,fe,Ee,ke,_e,We,He,Ue,$e,qe,Fe,Q,he,ge,me,be,Ae,Be,Ge,Je,Ve,Ye,tt,ot,lt,Mt,mt,Rt,Lt,At,_t,Tt,Ot,Wt,pt,Ft,Ut,Nt,Bt,zt,vt,$t,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Et=e.CodeApplication=class extends f.Disposable{constructor(Ce,Ie,pe,Te,Me,ze,Qe,Xe,Ne,xe,je){super(),this.mainProcessNodeIpcServer=Ce,this.userEnv=Ie,this.mainInstantiationService=pe,this.logService=Te,this.environmentMainService=Me,this.lifecycleMainService=ze,this.configurationService=Qe,this.stateService=Xe,this.fileService=Ne,this.productService=xe,this.userDataProfilesMainService=je,this.configureSession(),this.registerListeners()}configureSession(){const Ce=Ne=>Ne?.startsWith(`${S.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ne,xe,je,Ke)=>Ce(Ke.requestingUrl)?je(Ie.has(xe)):je(!1)),E.session.defaultSession.setPermissionCheckHandler((Ne,xe,je,Ke)=>Ce(Ke.requestingUrl)?Ie.has(xe):!1);const pe=new Set([S.Schemas.file,S.Schemas.vscodeFileResource,S.Schemas.vscodeRemoteResource,"devtools"]),Te=Ne=>{for(let xe=Ne;xe;xe=xe.parent)if(xe.url.startsWith(`${S.Schemas.vscodeWebview}://`))return!0;return!1},Me=Ne=>Ne.resourceType==="xhr"||Te(Ne.frame),ze=Ne=>{const xe=Ne.frame;if(!xe||!this.windowsMainService)return!1;const je=E.BrowserWindow.getAllWindows();for(const Ke of je)if(xe.processId===Ke.webContents.mainFrame.processId)return!0;return!1},Qe=(Ne,xe)=>{if(Ne.path!=="/index.html")return!0;const je=xe.frame;if(!je||!this.windowsMainService)return!1;for(const Ke of this.windowsMainService.getWindows())if(Ke.win&&je.processId===Ke.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ne,xe)=>{const je=c.URI.parse(Ne.url);return je.scheme===S.Schemas.vscodeWebview&&!Qe(je,Ne)?(this.logService.error("Blocked vscode-webview request",Ne.url),xe({cancel:!0})):je.scheme===S.Schemas.vscodeFileResource&&!ze(Ne)?(this.logService.error("Blocked vscode-file request",Ne.url),xe({cancel:!0})):je.path.endsWith(".svg")&&!pe.has(je.scheme)?xe({cancel:!Me(Ne)}):xe({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ne,xe)=>{const je=Ne.responseHeaders,Ke=je["content-type"]||je["Content-Type"];if(Ke&&Array.isArray(Ke)){const Ze=c.URI.parse(Ne.url);if(Ze.path.endsWith(".svg")&&pe.has(Ze.scheme))return je["Content-Type"]=["image/svg+xml"],xe({cancel:!1,responseHeaders:je});if(!Ze.path.endsWith(S.Schemas.vscodeRemoteResource)&&Ke.some(st=>st.toLowerCase().includes("image/svg")))return xe({cancel:!Me(Ne)})}return xe({cancel:!1})});const Xe=E.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Xe.setCodeCachePath((0,v.join)(this.environmentMainService.codeCachePath,"chrome")),s.isWindows&&(0,L.setUNCHostAllowlist)((0,L.toUNCHostAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,u.setUnexpectedErrorHandler)(pe=>this.onUnexpectedError(pe)),process.on("uncaughtException",pe=>(0,u.onUnexpectedError)(pe)),process.on("unhandledRejection",pe=>(0,u.onUnexpectedError)(pe)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,b.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(pe,Te)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Te)}),E.app.on("activate",async(pe,Te)=>{this.logService.trace("app#activate"),Te||await this.windowsMainService?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(pe,Te)=>{Te.on("will-navigate",Me=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Me.preventDefault()}),Te.setWindowOpenHandler(({url:Me})=>(this.nativeHostMainService?.openExternal(void 0,Me),{action:"deny"}))});let Ce=[],Ie;E.app.on("open-file",(pe,Te)=>{this.logService.trace("app#open-file: ",Te),pe.preventDefault(),Ce.push((0,Ge.hasWorkspaceFileExtension)(Te)?{workspaceUri:c.URI.file(Te)}:{fileUri:c.URI.file(Te)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],Ie=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),r.validatedIpcMain.handle("vscode:fetchShellEnv",pe=>{const Te=this.windowsMainService?.getWindowByWebContents(pe.sender);let Me,ze;return Te?.config?(Me=Te.config,ze={...process.env,...Te.config.userEnv}):(Me=this.environmentMainService.args,ze=process.env),this.resolveShellEnvironment(Me,ze,!1)}),r.validatedIpcMain.handle("vscode:writeNlsFile",(pe,Te,Me)=>{const ze=this.validateNlsPath([Te]);if(!ze||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(ze,D.VSBuffer.fromString(Me))}),r.validatedIpcMain.handle("vscode:readNlsFile",async(pe,...Te)=>{const Me=this.validateNlsPath(Te);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Me)).value.toString()}),r.validatedIpcMain.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),r.validatedIpcMain.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),r.validatedIpcMain.on("vscode:reloadWindow",pe=>pe.sender.reload())}validateNlsPath(Ce){let Ie;for(const pe of Ce)typeof pe=="string"&&(typeof Ie!="string"?Ie=pe:Ie=(0,v.join)(Ie,pe));if(!(typeof Ie!="string"||!(0,v.isAbsolute)(Ie)||!(0,l.isEqualOrParent)(Ie,this.environmentMainService.cachedLanguagesPath,!s.isLinux)))return c.URI.file(Ie)}onUnexpectedError(Ce){if(Ce){const Ie={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.logService.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.logService.error(Ce.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ce=this.productService.win32AppUserModelId;s.isWindows&&Ce&&E.app.setAppUserModelId(Ce);try{s.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.logService.error(Ne)}const Ie=new t.Server;this.lifecycleMainService.onWillShutdown(Ne=>{Ne.reason===2&&Ie.dispose()}),this.logService.trace("Resolving machine identifier...");const pe=await(0,Ft.resolveMachineId)(this.stateService,this.logService);this.logService.trace(`Resolved machine identifier: ${pe}`);const{sharedProcessReady:Te,sharedProcessClient:Me}=this.setupSharedProcess(pe),ze=await this.initServices(pe,Te);this._register(ze.createInstance(i.ProxyAuthHandler)),this._register(ze.createInstance(Ot.UserDataProfilesHandler)),ze.invokeFunction(Ne=>this.initChannels(Ne,Ie,Me));const Qe=ze.invokeFunction(Ne=>this.setupProtocolUrlHandlers(Ne,Ie));this.lifecycleMainService.phase=2,await ze.invokeFunction(Ne=>this.openFirstWindow(Ne,Qe)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new pt.RunOnceScheduler(()=>{this._register((0,pt.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setupProtocolUrlHandlers(Ce,Ie){const pe=this.windowsMainService=Ce.get(be.IWindowsMainService),Te=Ce.get(qe.IURLService),Me=this.nativeHostMainService=Ce.get(ae.INativeHostMainService),ze=this;Te.registerHandler({async handleURL(Ke,Ze){return ze.handleProtocolUrl(pe,Te,Ke,Ze)}});const Qe=this._register(new Be.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),Xe=new C.StaticRouter(Ke=>Qe.getActiveClientId().then(Ze=>Ke===Ze)),Ne=new Fe.URLHandlerRouter(Xe,this.logService),xe=Ie.getChannel("urlHandler",Ne);Te.registerHandler(new Fe.URLHandlerChannelClient(xe));const je=this.resolveInitialProtocolUrls();return this._register(new he.ElectronURLListener(je?.urls,Te,pe,this.environmentMainService,this.productService,this.logService)),je}resolveInitialProtocolUrls(){const Ce=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Ce.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ce);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),Ce.length+Ie.length===0)return;const pe=[];return{urls:[...Ce,...Ie].map(Me=>{try{return{uri:c.URI.parse(Me),originalUrl:Me}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Me);return}}).filter(Me=>{if(!Me)return!1;if(this.shouldBlockURI(Me.uri))return this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Me.uri.toString(!0)),!1;const ze=this.getWindowOpenableFromProtocolUrl(Me.uri);return ze?(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Me.uri.toString(!0),ze),pe.push(ze),!1):(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Me.uri.toString(!0)),!0)}),openables:pe}}shouldBlockURI(Ce){if(Ce.authority===S.Schemas.file&&s.isWindows){const{options:Ie,buttonIndeces:pe}=(0,zt.massageMessageBoxOptions)({type:"warning",buttons:[(0,n.localize)(0,null),(0,n.localize)(1,null)],message:(0,n.localize)(2,null,(0,w.getPathLabel)(Ce,{os:s.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,n.localize)(3,null)},this.productService);if(pe[E.dialog.showMessageBoxSync(Ie)]===1)return!0}return!1}getWindowOpenableFromProtocolUrl(Ce){if(Ce.path){if(Ce.authority===S.Schemas.file){const Ie=c.URI.file(Ce.fsPath);return(0,Ge.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Ce.authority===S.Schemas.vscodeRemote){const Ie=Ce.path.indexOf(v.posix.sep,1);if(Ie!==-1){const pe=Ce.path.substring(1,Ie),Te=Ce.path.substring(Ie),Me=c.URI.from({scheme:S.Schemas.vscodeRemote,authority:pe,path:Te,query:Ce.query,fragment:Ce.fragment});return(0,Ge.hasWorkspaceFileExtension)(Te)?{workspaceUri:Me}:/:[\d]+$/.test(Te)?{fileUri:Me}:{folderUri:Me}}}}}async handleProtocolUrl(Ce,Ie,pe,Te){if(this.logService.trace("app#handleProtocolUrl():",pe.toString(!0),Te),pe.scheme===this.productService.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:c.URI.parse(pe.query).path,query:""})),this.shouldBlockURI(pe))return this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let Me=!1;const ze=new URLSearchParams(pe.query);ze.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),ze.delete("windowId"),pe=pe.with({query:ze.toString()}),Me=!0):s.isMacintosh&&Ce.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Me=!0);const Qe=ze.get("continueOn");Qe!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),ze.delete("continueOn"),pe=pe.with({query:ze.toString()}),this.environmentMainService.continueOn=Qe??void 0);const Xe=this.getWindowOpenableFromProtocolUrl(pe);return Xe?(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Xe,pe.toString(!0)),(0,bt.firstOrDefault)(await Ce.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Xe],forceNewWindow:Me,gotoLineMode:!0}))?.focus(),!0):Me?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,bt.firstOrDefault)(await Ce.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,De.getRemoteAuthority)(pe)}))?.ready(),Ie.open(pe,Te)):(this.logService.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Te),!1)}setupSharedProcess(Ce){const Ie=this._register(this.mainInstantiationService.createInstance(Re.SharedProcess,Ce)),pe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await Ie.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new a.Client(Me,"main")})();return{sharedProcessReady:(async()=>(await Ie.whenReady(),pe))(),sharedProcessClient:pe}}async initServices(Ce,Ie){const pe=new P.ServiceCollection;switch(process.platform){case"win32":pe.set(ke.IUpdateService,new Y.SyncDescriptor($e.Win32UpdateService));break;case"linux":s.isLinuxSnap?pe.set(ke.IUpdateService,new Y.SyncDescriptor(Ue.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(ke.IUpdateService,new Y.SyncDescriptor(He.LinuxUpdateService));break;case"darwin":pe.set(ke.IUpdateService,new Y.SyncDescriptor(We.DarwinUpdateService));break}pe.set(be.IWindowsMainService,new Y.SyncDescriptor(Ae.WindowsMainService,[Ce,this.userEnv],!1));const Te=new W.DialogMainService(this.logService,this.productService);pe.set(W.IDialogMainService,Te),pe.set(F.ILaunchMainService,new Y.SyncDescriptor(F.LaunchMainService,void 0,!1)),pe.set(T.IDiagnosticsMainService,new Y.SyncDescriptor(T.DiagnosticsMainService,void 0,!1)),pe.set(M.IDiagnosticsService,C.ProxyChannel.toService((0,C.getDelayedChannel)(Ie.then(Qe=>Qe.getChannel("diagnostics"))))),pe.set(O.IIssueMainService,new Y.SyncDescriptor(U.IssueMainService,[this.userEnv])),pe.set(z.IEncryptionMainService,new Y.SyncDescriptor(H.EncryptionMainService,[Ce])),pe.set(B.IKeyboardLayoutMainService,new Y.SyncDescriptor(B.KeyboardLayoutMainService)),pe.set(ae.INativeHostMainService,new Y.SyncDescriptor(ae.NativeHostMainService,void 0,!1)),pe.set(I.ICredentialsMainService,new Y.SyncDescriptor(ot.CredentialsNativeMainService)),pe.set(ge.IWebviewManagerService,new Y.SyncDescriptor(me.WebviewMainService)),pe.set(se.IMenubarMainService,new Y.SyncDescriptor(se.MenubarMainService)),pe.set(ue.IExtensionUrlTrustService,new Y.SyncDescriptor(ce.ExtensionUrlTrustService)),pe.set(K.IExtensionHostStarter,new Y.SyncDescriptor(q.ExtensionHostStarter)),pe.set(ve.IStorageMainService,new Y.SyncDescriptor(ve.StorageMainService)),pe.set(ve.IApplicationStorageMainService,new Y.SyncDescriptor(ve.ApplicationStorageMainService)),s.isWindows?pe.set(N.IExternalTerminalMainService,new Y.SyncDescriptor($.WindowsExternalTerminalService)):s.isMacintosh?pe.set(N.IExternalTerminalMainService,new Y.SyncDescriptor($.MacExternalTerminalService)):s.isLinux&&pe.set(N.IExternalTerminalMainService,new Y.SyncDescriptor($.LinuxExternalTerminalService));const Me=new d.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);pe.set(o.IBackupMainService,Me);const ze=new tt.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Me,Te);if(pe.set(tt.IWorkspacesManagementMainService,ze),pe.set(Je.IWorkspacesService,new Y.SyncDescriptor(Ye.WorkspacesMainService,void 0,!1)),pe.set(Ve.IWorkspacesHistoryMainService,new Y.SyncDescriptor(Ve.WorkspacesHistoryMainService,void 0,!1)),pe.set(qe.IURLService,new Y.SyncDescriptor(Q.NativeURLService,void 0,!1)),(0,Ee.supportsTelemetry)(this.productService,this.environmentMainService)){const Qe=(0,Ee.isInternalTelemetry)(this.productService,this.configurationService),Xe=(0,C.getDelayedChannel)(Ie.then(Ze=>Ze.getChannel("telemetryAppender"))),Ne=new de.TelemetryAppenderClient(Xe),xe=(0,Pe.resolveCommonProperties)((0,A.release)(),(0,A.hostname)(),process.arch,this.productService.commit,this.productService.version,Ce,Qe),je=(0,Ee.getPiiPathsFromEnvironment)(this.environmentMainService),Ke={appenders:[Ne],commonProperties:xe,piiPaths:je,sendErrorTelemetry:!0};pe.set(Z.ITelemetryService,new Y.SyncDescriptor(fe.TelemetryService,[Ke],!1))}else pe.set(Z.ITelemetryService,Ee.NullTelemetryService);return pe.set(At.IExtensionsProfileScannerService,new Y.SyncDescriptor(Ut.ExtensionsProfileScannerService,void 0,!0)),pe.set(_t.IExtensionsScannerService,new Y.SyncDescriptor(Tt.ExtensionsScannerService,void 0,!0)),pe.set(vt.IUtilityProcessWorkerMainService,new Y.SyncDescriptor(vt.UtilityProcessWorkerMainService,void 0,!0)),await pt.Promises.settled([Me.initialize(),ze.initialize()]),this.mainInstantiationService.createChild(pe)}initChannels(Ce,Ie,pe){const Te=C.ProxyChannel.fromService(Ce.get(F.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Te);const Me=C.ProxyChannel.fromService(Ce.get(T.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Me);const ze=new Mt.PolicyChannel(Ce.get(lt.IPolicyService));Ie.registerChannel("policy",ze),pe.then(et=>et.registerChannel("policy",ze));const Qe=this.fileService.getProvider(S.Schemas.file);(0,g.assertType)(Qe instanceof le.DiskFileSystemProvider);const Xe=new oe.DiskFileSystemProviderChannel(Qe,this.logService,this.environmentMainService);Ie.registerChannel(G.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Xe),pe.then(et=>et.registerChannel(G.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Xe));const Ne=C.ProxyChannel.fromService(Ce.get(mt.IUserDataProfilesMainService));Ie.registerChannel("userDataProfiles",Ne),pe.then(et=>et.registerChannel("userDataProfiles",Ne));const xe=new Rt.RequestChannel(Ce.get(Lt.IRequestService));pe.then(et=>et.registerChannel("request",xe));const je=new _e.UpdateChannel(Ce.get(ke.IUpdateService));Ie.registerChannel("update",je);const Ke=C.ProxyChannel.fromService(Ce.get(O.IIssueMainService));Ie.registerChannel("issue",Ke);const Ze=C.ProxyChannel.fromService(Ce.get(z.IEncryptionMainService));Ie.registerChannel("encryption",Ze);const st=C.ProxyChannel.fromService(Ce.get(I.ICredentialsMainService));Ie.registerChannel("credentials",st);const nt=C.ProxyChannel.fromService(Ce.get(Le.ISignService));Ie.registerChannel("sign",nt);const ut=C.ProxyChannel.fromService(Ce.get(B.IKeyboardLayoutMainService));Ie.registerChannel("keyboardLayout",ut),this.nativeHostMainService=Ce.get(ae.INativeHostMainService);const It=C.ProxyChannel.fromService(this.nativeHostMainService);Ie.registerChannel("nativeHost",It),pe.then(et=>et.registerChannel("nativeHost",It));const qt=C.ProxyChannel.fromService(Ce.get(Je.IWorkspacesService));Ie.registerChannel("workspaces",qt);const Ht=C.ProxyChannel.fromService(Ce.get(se.IMenubarMainService));Ie.registerChannel("menubar",Ht);const xt=C.ProxyChannel.fromService(Ce.get(qe.IURLService));Ie.registerChannel("url",xt);const jt=C.ProxyChannel.fromService(Ce.get(ue.IExtensionUrlTrustService));Ie.registerChannel("extensionUrlTrust",jt);const Vt=C.ProxyChannel.fromService(Ce.get(ge.IWebviewManagerService));Ie.registerChannel("webview",Vt);const Pt=this._register(new we.StorageDatabaseChannel(this.logService,Ce.get(ve.IStorageMainService)));Ie.registerChannel("storage",Pt),pe.then(et=>et.registerChannel("storage",Pt));const Gt=this._register(new Wt.ProfileStorageChangesListenerChannel(Ce.get(ve.IStorageMainService),Ce.get(mt.IUserDataProfilesMainService),this.logService));pe.then(et=>et.registerChannel("profileStorageListener",Gt));const Kt=C.ProxyChannel.fromService(Ce.get(N.IExternalTerminalMainService));Ie.registerChannel("externalTerminal",Kt);const kt=new Nt.LoggerChannel(Ce.get(Bt.ILoggerMainService));Ie.registerChannel("logger",kt),pe.then(et=>et.registerChannel("logger",kt));const Qt=new R.ElectronExtensionHostDebugBroadcastChannel(Ce.get(be.IWindowsMainService));Ie.registerChannel("extensionhostdebugservice",Qt);const Yt=C.ProxyChannel.fromService(Ce.get(K.IExtensionHostStarter));Ie.registerChannel(K.ipcExtensionHostStarterChannelName,Yt);const Xt=C.ProxyChannel.fromService(Ce.get(vt.IUtilityProcessWorkerMainService));Ie.registerChannel($t.ipcUtilityProcessWorkerChannelName,Xt)}async openFirstWindow(Ce,Ie){const pe=this.windowsMainService=Ce.get(be.IWindowsMainService),Te=(0,ne.isLaunchedFromCli)(process.env)?0:4,Me=this.environmentMainService.args;if(Ie){if(Ie.openables.length>0)return pe.open({context:Te,cli:Me,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const nt of Ie.urls){const ut=new URLSearchParams(nt.uri.query);if(ut.get("windowId")==="_blank")return ut.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ut.toString()}),pe.open({context:Te,cli:Me,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,Qe=Me._.length,Xe=!!Me["folder-uri"],Ne=!!Me["file-uri"],xe=Me["skip-add-to-recently-opened"]===!0,je=Me.wait&&Me.waitMarkerFilePath?c.URI.file(Me.waitMarkerFilePath):void 0,Ke=Me.remote||void 0,Ze=Me.profile,st=Me["profile-temp"];if(!Qe&&!Xe&&!Ne){if(Me["new-window"]||Ze||st)return pe.open({context:Te,cli:Me,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:xe,waitMarkerFileURI:je,initialStartup:!0,remoteAuthority:Ke,forceProfile:Ze,forceTempProfile:st});if(ze.length)return pe.open({context:1,cli:Me,urisToOpen:ze.map(nt=>(0,Ge.hasWorkspaceFileExtension)(nt)?{workspaceUri:c.URI.file(nt)}:{fileUri:c.URI.file(nt)}),noRecentEntry:xe,waitMarkerFileURI:je,initialStartup:!0})}return pe.open({context:Te,cli:Me,forceNewWindow:Me["new-window"]||!Qe&&Me["unity-launch"],diffMode:Me.diff,mergeMode:Me.merge,noRecentEntry:xe,waitMarkerFileURI:je,gotoLineMode:Me.goto,initialStartup:!0,remoteAuthority:Ke,forceProfile:Ze,forceTempProfile:st})}afterWindowOpen(){this.installMutex(),E.protocol.registerHttpProtocol(S.Schemas.vscodeRemoteResource,(Ce,Ie)=>{Ie({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const Ce=this.productService.win32MutexName;if(s.isWindows&&Ce)try{const Ie=await new Promise((Te,Me)=>{j(["@vscode/windows-mutex"],Te,Me)}),pe=new Ie.Mutex(Ce);(0,p.once)(this.lifecycleMainService.onWillShutdown)(()=>pe.release())}catch(Ie){this.logService.error(Ie)}}async resolveShellEnvironment(Ce,Ie,pe){try{return await(0,re.getResolvedShellEnv)(this.configurationService,this.logService,Ce,Ie)}catch(Te){const Me=(0,k.toErrorMessage)(Te);pe?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Me):this.logService.error(Me)}return{}}async updateCrashReporterEnablement(){try{const Ie=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),pe=JSON.parse((0,m.stripComments)(Ie)),Me=(0,Ee.getTelemetryLevel)(this.configurationService)>=1;if(pe["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,y.generateUuid)()}"`,"}"],Qe=Ie.substring(0,Ie.length-2).concat(`,
`,ze.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(Qe))}else{const ze=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Me},`);ze!==Ie&&await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(ze))}}catch(Ce){this.logService.error(Ce)}}};e.CodeApplication=Et=ye([X(2,_.IInstantiationService),X(3,V.ILogService),X(4,J.IEnvironmentMainService),X(5,x.ILifecycleMainService),X(6,h.IConfigurationService),X(7,Oe.IStateService),X(8,ee.IFileService),X(9,Se.IProductService),X(10,mt.IUserDataProfilesMainService)],Et)}),define(te[298],ie([0,1,15,41,8,23,7,49,13,32,48,44,14,9,64,3,36,27,24,45,97,291,10,19,234,242,30,62,197,16,218,91,73,213,90,20,221,5,76,21,77,265,121,275,52,274,92,241,33,46,78,53,37,229,227,2,38,250,65,222,89,117,248]),function(j,e,E,L,r,A,D,k,u,l,p,m,w,f,S,v,s,g,c,y,b,C,t,a,i,n,o,d,h,I,R,M,T,W,z,H,J,ne,re,ue,ce,K,q,N,$,G,ee,oe,le,Y,_,P,O,U,B,F,x,V,se,ae,Se,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Re{main(){try{this.startup()}catch(we){console.error(we.message),E.app.exit(1)}}async startup(){(0,u.setUnexpectedErrorHandler)(_e=>console.error(_e));const[we,ve,Pe,Z,de,fe,Ee,ke]=this.createServices();try{try{await this.initServices(Pe,ke,Z,de,Ee)}catch(_e){throw this.handleStartupDataDirError(Pe,Ee,_e),_e}await we.invokeFunction(async _e=>{const We=_e.get(ne.ILogService),He=_e.get(H.ILifecycleMainService),Ue=_e.get(I.IFileService),$e=_e.get(ne.ILoggerService),qe=await this.claimInstance(We,Pe,He,we,Ee,!0);return c.Promises.writeFile(Pe.mainLockfile,String(process.pid)).catch(Fe=>{We.warn(`app#startup(): Error writing main lockfile: ${Fe.stack}`)}),fe.logger=$e.createLogger("main",{name:(0,t.localize)(0,null)}),(0,p.once)(He.onWillShutdown)(Fe=>{Ue.dispose(),Z.dispose(),Fe.join("instanceLockfile",c.Promises.unlink(Pe.mainLockfile).catch(()=>{}))}),we.createInstance(C.CodeApplication,qe,ve).startup()})}catch(_e){we.invokeFunction(this.quit,_e)}}createServices(){const we=new z.ServiceCollection,ve=new F.DisposableStore;process.once("exit",()=>ve.dispose());const Pe={_serviceBrand:void 0,...re.default};we.set(ue.IProductService,Pe);const Z=new o.EnvironmentMainService(this.resolveArgs(),Pe),de=this.patchEnvironment(Z);we.set(o.IEnvironmentMainService,Z);const fe=new se.LoggerMainService((0,ne.getLogLevel)(Z),Z.logsHome);we.set(se.ILoggerMainService,fe);const Ee=new J.BufferLogger(fe.getLogLevel()),ke=ve.add(new ae.LogService(Ee,[new ne.ConsoleMainLogger(fe.getLogLevel())]));we.set(ne.ILogService,ke);const _e=new R.FileService(ke);we.set(I.IFileService,_e);const We=new M.DiskFileSystemProvider(ke);_e.registerProvider(w.Schemas.file,We);const He=new V.UriIdentityService(_e);we.set(x.IUriIdentityService,He);const Ue=new De.StateService(1,Z,ke,_e);we.set(le.IStateReadService,Ue),we.set(le.IStateService,Ue);const $e=new P.UserDataProfilesMainService(Ue,He,Z,_e,ke);we.set(P.IUserDataProfilesMainService,$e);const qe=v.isWindows&&Pe.win32RegValueName?ve.add(new U.NativePolicyService(ke,Pe.win32RegValueName)):Z.policyFile?ve.add(new B.FilePolicyService(Z.policyFile,_e,ke)):new O.NullPolicyService;we.set(O.IPolicyService,qe);const Fe=new i.ConfigurationService($e.defaultProfile.settingsResource,_e,qe,ke);return we.set(a.IConfigurationService,Fe),we.set(H.ILifecycleMainService,new T.SyncDescriptor(H.LifecycleMainService,void 0,!1)),we.set($.IRequestService,new T.SyncDescriptor(G.RequestMainService,void 0,!0)),we.set(_.IThemeMainService,new T.SyncDescriptor(_.ThemeMainService)),we.set(ee.ISignService,new T.SyncDescriptor(oe.SignService,void 0,!1)),we.set(q.ITunnelService,new T.SyncDescriptor(N.TunnelService)),we.set(ce.IProtocolMainService,new K.ProtocolMainService(Z,$e,ke)),[new W.InstantiationService(we,!0),de,Z,Fe,Ue,Ee,Pe,$e]}patchEnvironment(we){const ve={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Pe=>{const Z=process.env[Pe];typeof Z=="string"&&(ve[Pe]=Z)}),Object.assign(process.env,ve),ve}async initServices(we,ve,Pe,Z,de){await D.Promises.settled([Promise.all([we.extensionsPath,we.codeCachePath,we.logsHome.fsPath,ve.defaultProfile.globalStorageHome.fsPath,we.workspaceStorageHome.fsPath,we.localHistoryHome.fsPath,we.backupHome].map(fe=>fe?c.Promises.mkdir(fe,{recursive:!0}):void 0)),Z.init(),Pe.initialize()]),ve.init()}async claimInstance(we,ve,Pe,Z,de,fe){let Ee;try{(0,S.mark)("code/willStartMainServer"),Ee=await(0,b.serve)(ve.mainIPCHandle),(0,S.mark)("code/didStartMainServer"),(0,p.once)(Pe.onWillShutdown)(()=>Ee.dispose())}catch(ke){if(ke.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ve,de,ke),ke;let _e;try{_e=await(0,b.connect)(ve.mainIPCHandle,"main")}catch($e){if(!fe||v.isWindows||$e.code!=="ECONNREFUSED")throw $e.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,de.nameShort),(0,t.localize)(2,null),de),$e;try{(0,L.unlinkSync)(ve.mainIPCHandle)}catch(qe){throw we.warn("Could not delete obsolete instance handle",qe),qe}return this.claimInstance(we,ve,Pe,Z,de,!1)}if(ve.extensionTestsLocationURI&&!ve.debugExtensionHost.break){const $e=`Running extension tests from the command line is currently only supported if no other instance of ${de.nameShort} is running.`;throw we.error($e),_e.dispose(),new Error($e)}let We;!ve.args.wait&&!ve.args.status&&(We=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,de.nameShort),(0,t.localize)(4,null),de)},1e4));const He=y.ProxyChannel.toService(_e.getChannel("launch"),{disableMarshalling:!0}),Ue=y.ProxyChannel.toService(_e.getChannel("diagnostics"),{disableMarshalling:!0});if(ve.args.status)return Z.invokeFunction(async()=>{const $e=new n.DiagnosticsService(Y.NullTelemetryService,de),qe=await Ue.getMainDiagnostics(),Fe=await Ue.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Q=await $e.getDiagnostics(qe,Fe);throw console.log(Q),new u.ExpectedError});throw v.isWindows&&await this.windowsAllowSetForegroundWindow(He,we),we.trace("Sending env to running instance..."),await He.start(ve.args,process.env),_e.dispose(),We&&clearTimeout(We),new u.ExpectedError("Sent env to running instance. Terminating...")}if(ve.args.status)throw we.warn("Warning: The --status argument can only be used if {0} is already running. Please run it again after {0} has started.",de.nameShort),new u.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ee}handleStartupDataDirError(we,ve,Pe){if(Pe.code==="EACCES"||Pe.code==="EPERM"){const Z=(0,A.coalesce)([we.userDataPath,we.extensionsPath,b.XDG_RUNTIME_DIR]).map(de=>(0,m.getPathLabel)(r.URI.file(de),{os:v.OS,tildify:we}));this.showStartupWarningDialog((0,t.localize)(5,null),(0,t.localize)(6,null,(0,k.toErrorMessage)(Pe),Z.join(`
`)),ve)}}showStartupWarningDialog(we,ve,Pe){E.dialog.showMessageBoxSync((0,Se.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:we,detail:ve},Pe).options)}async windowsAllowSetForegroundWindow(we,ve){if(v.isWindows){const Pe=await we.getMainProcessId();ve.trace("Sending some foreground love to the running instance:",Pe);try{(await new Promise((Z,de)=>{j(["windows-foreground-love"],Z,de)})).allowSetForegroundWindow(Pe)}catch(Z){ve.error(Z)}}}quit(we,ve){const Pe=we.get(ne.ILogService),Z=we.get(H.ILifecycleMainService);let de=0;ve&&(ve.isExpected?ve.message&&Pe.trace(ve.message):(de=1,ve.stack?Pe.error(ve.stack):Pe.error(`Startup error: ${ve.toString()}`))),Z.kill(de)}resolveArgs(){const we=this.validatePaths((0,d.parseMainProcessArgv)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const ve=(0,h.createWaitMarkerFileSync)(we.verbose);ve&&((0,d.addArg)(process.argv,"--waitMarkerFilePath",ve),we.waitMarkerFilePath=ve)}return we}validatePaths(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const ve=this.doValidatePaths(we._,we.goto);we._=ve}return we}doValidatePaths(we,ve){const Pe=(0,s.cwd)(),Z=we.map(Ee=>{let ke=String(Ee),_e;ve&&(_e=(0,l.parseLineAndColumnAware)(ke),ke=_e.path),ke&&(ke=this.preparePath(Pe,ke));const We=(0,l.sanitizeFilePath)(ke,Pe),He=(0,f.basename)(We);return He&&!(0,l.isValidBasename)(He)?null:ve&&_e?(_e.path=We,this.toPath(_e)):We}),de=v.isWindows||v.isMacintosh,fe=(0,A.distinct)(Z,Ee=>Ee&&de?Ee.toLowerCase():Ee||"");return(0,A.coalesce)(fe)}preparePath(we,ve){return v.isWindows&&(ve=(0,g.rtrim)(ve,'"')),ve=(0,g.trim)((0,g.trim)(ve," "),"	"),v.isWindows&&(ve=(0,f.resolve)(we,ve),ve=(0,g.rtrim)(ve,".")),ve}toPath(we){const ve=[we.path];return typeof we.line=="number"&&ve.push(String(we.line)),typeof we.column=="number"&&ve.push(String(we.column)),ve.join(":")}}new Re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e06ea6147733c975d26c3d3552462681e05cb147/core/vs/code/electron-main/main.js.map
