/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/nls","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(te){for(var t=[],y=0,k=te.length;y<k;y++)t[y]=me[te[y]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function $t(te){if(Array.isArray(te)){for(var t=0,y=Array(te.length);t<te.length;t++)y[t]=te[t];return y}else return Array.from(te)}var Vt=Object.hasOwnProperty,It=Object.setPrototypeOf,Kt=Object.isFrozen,qt=Object.getPrototypeOf,jt=Object.getOwnPropertyDescriptor,tt=Object.freeze,lt=Object.seal,Gt=Object.create,Nt=typeof Reflect<"u"&&Reflect,Dt=Nt.apply,_t=Nt.construct;Dt||(Dt=function(t,y,k){return t.apply(y,k)}),tt||(tt=function(t){return t}),lt||(lt=function(t){return t}),_t||(_t=function(t,y){return new(Function.prototype.bind.apply(t,[null].concat($t(y))))});var Yt=nt(Array.prototype.forEach),kt=nt(Array.prototype.pop),gt=nt(Array.prototype.push),ct=nt(String.prototype.toLowerCase),Pt=nt(String.prototype.match),ut=nt(String.prototype.replace),Xt=nt(String.prototype.indexOf),Zt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Rt=Qt(TypeError);function nt(te){return function(t){for(var y=arguments.length,k=Array(y>1?y-1:0),i=1;i<y;i++)k[i-1]=arguments[i];return Dt(te,t,k)}}function Qt(te){return function(){for(var t=arguments.length,y=Array(t),k=0;k<t;k++)y[k]=arguments[k];return _t(te,y)}}function Be(te,t){It&&It(te,null);for(var y=t.length;y--;){var k=t[y];if(typeof k=="string"){var i=ct(k);i!==k&&(Kt(t)||(t[y]=i),k=i)}te[k]=!0}return te}function ht(te){var t=Gt(null),y=void 0;for(y in te)Dt(Vt,te,[y])&&(t[y]=te[y]);return t}function wt(te,t){for(;te!==null;){var y=jt(te,t);if(y){if(y.get)return nt(y.get);if(typeof y.value=="function")return nt(y.value)}te=qt(te)}function k(i){return console.warn("fallback value for",i),null}return k}var Mt=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),St=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=tt(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),At=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),ei=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ot=tt(["#text"]),Bt=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Tt=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),xt=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ti=lt(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ii=lt(/<%[\s\S]*|[\s\S]*%>/gm),si=lt(/^data-[\-\w.\u00B7-\uFFFF]/),ni=lt(/^aria-[\-\w]+$/),ri=lt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),oi=lt(/^(?:\w+script|data):/i),li=lt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),mt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(te){return typeof te}:function(te){return te&&typeof Symbol=="function"&&te.constructor===Symbol&&te!==Symbol.prototype?"symbol":typeof te};function ot(te){if(Array.isArray(te)){for(var t=0,y=Array(te.length);t<te.length;t++)y[t]=te[t];return y}else return Array.from(te)}var ai=function(){return typeof window>"u"?null:window},ui=function(t,y){if((typeof t>"u"?"undefined":mt(t))!=="object"||typeof t.createPolicy!="function")return null;var k=null,i="data-tt-policy-suffix";y.currentScript&&y.currentScript.hasAttribute(i)&&(k=y.currentScript.getAttribute(i));var z="dompurify"+(k?"#"+k:"");try{return t.createPolicy(z,{createHTML:function(_){return _}})}catch{return console.warn("TrustedTypes policy "+z+" could not be created."),null}};function Ht(){var te=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ai(),t=function(ce){return Ht(ce)};if(t.version="2.3.1",t.removed=[],!te||!te.document||te.document.nodeType!==9)return t.isSupported=!1,t;var y=te.document,k=te.document,i=te.DocumentFragment,z=te.HTMLTemplateElement,b=te.Node,_=te.Element,c=te.NodeFilter,l=te.NamedNodeMap,h=l===void 0?te.NamedNodeMap||te.MozNamedAttrMap:l,P=te.Text,r=te.Comment,a=te.DOMParser,e=te.trustedTypes,o=_.prototype,s=wt(o,"cloneNode"),u=wt(o,"nextSibling"),n=wt(o,"childNodes"),D=wt(o,"parentNode");if(typeof z=="function"){var w=k.createElement("template");w.content&&w.content.ownerDocument&&(k=w.content.ownerDocument)}var S=ui(e,y),f=S&&Z?S.createHTML(""):"",v=k,L=v.implementation,I=v.createNodeIterator,E=v.createDocumentFragment,g=v.getElementsByTagName,m=y.importNode,p={};try{p=ht(k).documentMode?k.documentMode:{}}catch{}var O={};t.isSupported=typeof D=="function"&&L&&typeof L.createHTMLDocument<"u"&&p!==9;var G=ti,J=ii,ie=si,ae=ni,ge=oi,ue=li,de=ri,he=null,Se=Be({},[].concat(ot(Mt),ot(St),ot(Ct),ot(At),ot(Ot))),_e=null,Oe=Be({},[].concat(ot(Bt),ot(Tt),ot(xt),ot(yt))),re=null,se=null,Q=!0,oe=!0,V=!1,K=!1,A=!1,W=!1,N=!1,d=!1,R=!1,$=!0,Z=!1,T=!0,F=!0,B=!1,C={},H=null,x=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),M=null,U=Be({},["audio","video","img","source","image","track"]),q=null,ee=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ne="http://www.w3.org/1998/Math/MathML",ve="http://www.w3.org/2000/svg",we="http://www.w3.org/1999/xhtml",Ne=we,Ae=!1,De=null,Pe=k.createElement("form"),Ie=function(ce){De&&De===ce||((!ce||(typeof ce>"u"?"undefined":mt(ce))!=="object")&&(ce={}),ce=ht(ce),he="ALLOWED_TAGS"in ce?Be({},ce.ALLOWED_TAGS):Se,_e="ALLOWED_ATTR"in ce?Be({},ce.ALLOWED_ATTR):Oe,q="ADD_URI_SAFE_ATTR"in ce?Be(ht(ee),ce.ADD_URI_SAFE_ATTR):ee,M="ADD_DATA_URI_TAGS"in ce?Be(ht(U),ce.ADD_DATA_URI_TAGS):U,H="FORBID_CONTENTS"in ce?Be({},ce.FORBID_CONTENTS):x,re="FORBID_TAGS"in ce?Be({},ce.FORBID_TAGS):{},se="FORBID_ATTR"in ce?Be({},ce.FORBID_ATTR):{},C="USE_PROFILES"in ce?ce.USE_PROFILES:!1,Q=ce.ALLOW_ARIA_ATTR!==!1,oe=ce.ALLOW_DATA_ATTR!==!1,V=ce.ALLOW_UNKNOWN_PROTOCOLS||!1,K=ce.SAFE_FOR_TEMPLATES||!1,A=ce.WHOLE_DOCUMENT||!1,d=ce.RETURN_DOM||!1,R=ce.RETURN_DOM_FRAGMENT||!1,$=ce.RETURN_DOM_IMPORT!==!1,Z=ce.RETURN_TRUSTED_TYPE||!1,N=ce.FORCE_BODY||!1,T=ce.SANITIZE_DOM!==!1,F=ce.KEEP_CONTENT!==!1,B=ce.IN_PLACE||!1,de=ce.ALLOWED_URI_REGEXP||de,Ne=ce.NAMESPACE||we,K&&(oe=!1),R&&(d=!0),C&&(he=Be({},[].concat(ot(Ot))),_e=[],C.html===!0&&(Be(he,Mt),Be(_e,Bt)),C.svg===!0&&(Be(he,St),Be(_e,Tt),Be(_e,yt)),C.svgFilters===!0&&(Be(he,Ct),Be(_e,Tt),Be(_e,yt)),C.mathMl===!0&&(Be(he,At),Be(_e,xt),Be(_e,yt))),ce.ADD_TAGS&&(he===Se&&(he=ht(he)),Be(he,ce.ADD_TAGS)),ce.ADD_ATTR&&(_e===Oe&&(_e=ht(_e)),Be(_e,ce.ADD_ATTR)),ce.ADD_URI_SAFE_ATTR&&Be(q,ce.ADD_URI_SAFE_ATTR),ce.FORBID_CONTENTS&&(H===x&&(H=ht(H)),Be(H,ce.FORBID_CONTENTS)),F&&(he["#text"]=!0),A&&Be(he,["html","head","body"]),he.table&&(Be(he,["tbody"]),delete re.tbody),tt&&tt(ce),De=ce)},Ke=Be({},["mi","mo","mn","ms","mtext"]),xe=Be({},["foreignobject","desc","title","annotation-xml"]),ze=Be({},St);Be(ze,Ct),Be(ze,Jt);var Je=Be({},At);Be(Je,ei);var it=function(ce){var Ee=D(ce);(!Ee||!Ee.tagName)&&(Ee={namespaceURI:we,tagName:"template"});var ke=ct(ce.tagName),He=ct(Ee.tagName);if(ce.namespaceURI===ve)return Ee.namespaceURI===we?ke==="svg":Ee.namespaceURI===ne?ke==="svg"&&(He==="annotation-xml"||Ke[He]):!!ze[ke];if(ce.namespaceURI===ne)return Ee.namespaceURI===we?ke==="math":Ee.namespaceURI===ve?ke==="math"&&xe[He]:!!Je[ke];if(ce.namespaceURI===we){if(Ee.namespaceURI===ve&&!xe[He]||Ee.namespaceURI===ne&&!Ke[He])return!1;var Xe=Be({},["title","style","font","a","script"]);return!Je[ke]&&(Xe[ke]||!ze[ke])}return!1},Me=function(ce){gt(t.removed,{element:ce});try{ce.parentNode.removeChild(ce)}catch{try{ce.outerHTML=f}catch{ce.remove()}}},Ve=function(ce,Ee){try{gt(t.removed,{attribute:Ee.getAttributeNode(ce),from:Ee})}catch{gt(t.removed,{attribute:null,from:Ee})}if(Ee.removeAttribute(ce),ce==="is"&&!_e[ce])if(d||R)try{Me(Ee)}catch{}else try{Ee.setAttribute(ce,"")}catch{}},j=function(ce){var Ee=void 0,ke=void 0;if(N)ce="<remove></remove>"+ce;else{var He=Pt(ce,/^[\r\n\t ]+/);ke=He&&He[0]}var Xe=S?S.createHTML(ce):ce;if(Ne===we)try{Ee=new a().parseFromString(Xe,"text/html")}catch{}if(!Ee||!Ee.documentElement){Ee=L.createDocument(Ne,"template",null);try{Ee.documentElement.innerHTML=Ae?"":Xe}catch{}}var Ze=Ee.body||Ee.documentElement;return ce&&ke&&Ze.insertBefore(k.createTextNode(ke),Ze.childNodes[0]||null),Ne===we?g.call(Ee,A?"html":"body")[0]:A?Ee.documentElement:Ze},le=function(ce){return I.call(ce.ownerDocument||ce,ce,c.SHOW_ELEMENT|c.SHOW_COMMENT|c.SHOW_TEXT,null,!1)},be=function(ce){return ce instanceof P||ce instanceof r?!1:typeof ce.nodeName!="string"||typeof ce.textContent!="string"||typeof ce.removeChild!="function"||!(ce.attributes instanceof h)||typeof ce.removeAttribute!="function"||typeof ce.setAttribute!="function"||typeof ce.namespaceURI!="string"||typeof ce.insertBefore!="function"},ye=function(ce){return(typeof b>"u"?"undefined":mt(b))==="object"?ce instanceof b:ce&&(typeof ce>"u"?"undefined":mt(ce))==="object"&&typeof ce.nodeType=="number"&&typeof ce.nodeName=="string"},Ce=function(ce,Ee,ke){O[ce]&&Yt(O[ce],function(He){He.call(t,Ee,ke,De)})},Re=function(ce){var Ee=void 0;if(Ce("beforeSanitizeElements",ce,null),be(ce)||Pt(ce.nodeName,/[\u0080-\uFFFF]/))return Me(ce),!0;var ke=ct(ce.nodeName);if(Ce("uponSanitizeElement",ce,{tagName:ke,allowedTags:he}),!ye(ce.firstElementChild)&&(!ye(ce.content)||!ye(ce.content.firstElementChild))&&at(/<[/\w]/g,ce.innerHTML)&&at(/<[/\w]/g,ce.textContent)||ke==="select"&&at(/<template/i,ce.innerHTML))return Me(ce),!0;if(!he[ke]||re[ke]){if(F&&!H[ke]){var He=D(ce)||ce.parentNode,Xe=n(ce)||ce.childNodes;if(Xe&&He)for(var Ze=Xe.length,Qe=Ze-1;Qe>=0;--Qe)He.insertBefore(s(Xe[Qe],!0),u(ce))}return Me(ce),!0}return ce instanceof _&&!it(ce)||(ke==="noscript"||ke==="noembed")&&at(/<\/no(script|embed)/i,ce.innerHTML)?(Me(ce),!0):(K&&ce.nodeType===3&&(Ee=ce.textContent,Ee=ut(Ee,G," "),Ee=ut(Ee,J," "),ce.textContent!==Ee&&(gt(t.removed,{element:ce.cloneNode()}),ce.textContent=Ee)),Ce("afterSanitizeElements",ce,null),!1)},Ue=function(ce,Ee,ke){if(T&&(Ee==="id"||Ee==="name")&&(ke in k||ke in Pe))return!1;if(!(oe&&!se[Ee]&&at(ie,Ee))){if(!(Q&&at(ae,Ee))){if(!_e[Ee]||se[Ee])return!1;if(!q[Ee]){if(!at(de,ut(ke,ue,""))){if(!((Ee==="src"||Ee==="xlink:href"||Ee==="href")&&ce!=="script"&&Xt(ke,"data:")===0&&M[ce])){if(!(V&&!at(ge,ut(ke,ue,"")))){if(ke)return!1}}}}}}return!0},Ge=function(ce){var Ee=void 0,ke=void 0,He=void 0,Xe=void 0;Ce("beforeSanitizeAttributes",ce,null);var Ze=ce.attributes;if(Ze){var Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:_e};for(Xe=Ze.length;Xe--;){Ee=Ze[Xe];var rt=Ee,dt=rt.name,pt=rt.namespaceURI;if(ke=Zt(Ee.value),He=ct(dt),Qe.attrName=He,Qe.attrValue=ke,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,Ce("uponSanitizeAttribute",ce,Qe),ke=Qe.attrValue,!Qe.forceKeepAttr&&(Ve(dt,ce),!!Qe.keepAttr)){if(at(/\/>/i,ke)){Ve(dt,ce);continue}K&&(ke=ut(ke,G," "),ke=ut(ke,J," "));var Ft=ce.nodeName.toLowerCase();if(Ue(Ft,He,ke))try{pt?ce.setAttributeNS(pt,dt,ke):ce.setAttribute(dt,ke),kt(t.removed)}catch{}}}Ce("afterSanitizeAttributes",ce,null)}},et=function Fe(ce){var Ee=void 0,ke=le(ce);for(Ce("beforeSanitizeShadowDOM",ce,null);Ee=ke.nextNode();)Ce("uponSanitizeShadowNode",Ee,null),!Re(Ee)&&(Ee.content instanceof i&&Fe(Ee.content),Ge(Ee));Ce("afterSanitizeShadowDOM",ce,null)};return t.sanitize=function(Fe,ce){var Ee=void 0,ke=void 0,He=void 0,Xe=void 0,Ze=void 0;if(Ae=!Fe,Ae&&(Fe="<!-->"),typeof Fe!="string"&&!ye(Fe)){if(typeof Fe.toString!="function")throw Rt("toString is not a function");if(Fe=Fe.toString(),typeof Fe!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(mt(te.toStaticHTML)==="object"||typeof te.toStaticHTML=="function"){if(typeof Fe=="string")return te.toStaticHTML(Fe);if(ye(Fe))return te.toStaticHTML(Fe.outerHTML)}return Fe}if(W||Ie(ce),t.removed=[],typeof Fe=="string"&&(B=!1),!B)if(Fe instanceof b)Ee=j("<!---->"),ke=Ee.ownerDocument.importNode(Fe,!0),ke.nodeType===1&&ke.nodeName==="BODY"||ke.nodeName==="HTML"?Ee=ke:Ee.appendChild(ke);else{if(!d&&!K&&!A&&Fe.indexOf("<")===-1)return S&&Z?S.createHTML(Fe):Fe;if(Ee=j(Fe),!Ee)return d?null:f}Ee&&N&&Me(Ee.firstChild);for(var Qe=le(B?Fe:Ee);He=Qe.nextNode();)He.nodeType===3&&He===Xe||Re(He)||(He.content instanceof i&&et(He.content),Ge(He),Xe=He);if(Xe=null,B)return Fe;if(d){if(R)for(Ze=E.call(Ee.ownerDocument);Ee.firstChild;)Ze.appendChild(Ee.firstChild);else Ze=Ee;return $&&(Ze=m.call(y,Ze,!0)),Ze}var rt=A?Ee.outerHTML:Ee.innerHTML;return K&&(rt=ut(rt,G," "),rt=ut(rt,J," ")),S&&Z?S.createHTML(rt):rt},t.setConfig=function(Fe){Ie(Fe),W=!0},t.clearConfig=function(){De=null,W=!1},t.isValidAttribute=function(Fe,ce,Ee){De||Ie({});var ke=ct(Fe),He=ct(ce);return Ue(ke,He,Ee)},t.addHook=function(Fe,ce){typeof ce=="function"&&(O[Fe]=O[Fe]||[],gt(O[Fe],ce))},t.removeHook=function(Fe){O[Fe]&&kt(O[Fe])},t.removeHooks=function(Fe){O[Fe]&&(O[Fe]=[])},t.removeAllHooks=function(){O={}},t}var ci=Ht();define("vs/base/browser/dompurify/dompurify",function(){return ci}),define(me[38],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class y{constructor(b){this.domNode=b,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._paddingTop="",this._paddingLeft="",this._paddingBottom="",this._paddingRight="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._fontVariationSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(b){const _=k(b);this._maxWidth!==_&&(this._maxWidth=_,this.domNode.style.maxWidth=this._maxWidth)}setWidth(b){const _=k(b);this._width!==_&&(this._width=_,this.domNode.style.width=this._width)}setHeight(b){const _=k(b);this._height!==_&&(this._height=_,this.domNode.style.height=this._height)}setTop(b){const _=k(b);this._top!==_&&(this._top=_,this.domNode.style.top=this._top)}setLeft(b){const _=k(b);this._left!==_&&(this._left=_,this.domNode.style.left=this._left)}setBottom(b){const _=k(b);this._bottom!==_&&(this._bottom=_,this.domNode.style.bottom=this._bottom)}setRight(b){const _=k(b);this._right!==_&&(this._right=_,this.domNode.style.right=this._right)}setPaddingTop(b){const _=k(b);this._paddingTop!==_&&(this._paddingTop=_,this.domNode.style.paddingTop=this._paddingTop)}setPaddingLeft(b){const _=k(b);this._paddingLeft!==_&&(this._paddingLeft=_,this.domNode.style.paddingLeft=this._paddingLeft)}setPaddingBottom(b){const _=k(b);this._paddingBottom!==_&&(this._paddingBottom=_,this.domNode.style.paddingBottom=this._paddingBottom)}setPaddingRight(b){const _=k(b);this._paddingRight!==_&&(this._paddingRight=_,this.domNode.style.paddingRight=this._paddingRight)}setFontFamily(b){this._fontFamily!==b&&(this._fontFamily=b,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(b){this._fontWeight!==b&&(this._fontWeight=b,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(b){const _=k(b);this._fontSize!==_&&(this._fontSize=_,this.domNode.style.fontSize=this._fontSize)}setFontStyle(b){this._fontStyle!==b&&(this._fontStyle=b,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(b){this._fontFeatureSettings!==b&&(this._fontFeatureSettings=b,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setFontVariationSettings(b){this._fontVariationSettings!==b&&(this._fontVariationSettings=b,this.domNode.style.fontVariationSettings=this._fontVariationSettings)}setTextDecoration(b){this._textDecoration!==b&&(this._textDecoration=b,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(b){const _=k(b);this._lineHeight!==_&&(this._lineHeight=_,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(b){const _=k(b);this._letterSpacing!==_&&(this._letterSpacing=_,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(b){this._className!==b&&(this._className=b,this.domNode.className=this._className)}toggleClassName(b,_){this.domNode.classList.toggle(b,_),this._className=this.domNode.className}setDisplay(b){this._display!==b&&(this._display=b,this.domNode.style.display=this._display)}setPosition(b){this._position!==b&&(this._position=b,this.domNode.style.position=this._position)}setVisibility(b){this._visibility!==b&&(this._visibility=b,this.domNode.style.visibility=this._visibility)}setColor(b){this._color!==b&&(this._color=b,this.domNode.style.color=this._color)}setBackgroundColor(b){this._backgroundColor!==b&&(this._backgroundColor=b,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(b){this._layerHint!==b&&(this._layerHint=b,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(b){this._boxShadow!==b&&(this._boxShadow=b,this.domNode.style.boxShadow=b)}setContain(b){this._contain!==b&&(this._contain=b,this.domNode.style.contain=this._contain)}setAttribute(b,_){this.domNode.setAttribute(b,_)}removeAttribute(b){this.domNode.removeAttribute(b)}appendChild(b){this.domNode.appendChild(b.domNode)}removeChild(b){this.domNode.removeChild(b.domNode)}}t.FastDomNode=y;function k(z){return typeof z=="number"?`${z}px`:z}function i(z){return new y(z)}t.createFastDomNode=i}),define(me[66],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let y=!1,k=null;function i(b){if(!b.parent||b.parent===b)return null;try{const _=b.location,c=b.parent.location;if(_.origin!=="null"&&c.origin!=="null"&&_.origin!==c.origin)return y=!0,null}catch{return y=!0,null}return b.parent}class z{static getSameOriginWindowChain(){if(!k){k=[];let _=window,c;do c=i(_),c?k.push({window:_,iframeElement:_.frameElement||null}):k.push({window:_,iframeElement:null}),_=c;while(_)}return k.slice(0)}static hasDifferentOriginAncestor(){return k||this.getSameOriginWindowChain(),y}static getPositionOfChildWindowRelativeToAncestorWindow(_,c){if(!c||_===c)return{top:0,left:0};let l=0,h=0;const P=this.getSameOriginWindowChain();for(const r of P){if(l+=r.window.scrollY,h+=r.window.scrollX,r.window===c||!r.iframeElement)break;const a=r.iframeElement.getBoundingClientRect();l+=a.top,h+=a.left}return{top:l,left:h}}}t.IframeUtils=z}),define(me[67],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var y;(function(z){z[z.Copy=0]="Copy",z[z.Move=1]="Move"})(y||(t.ListDragOverEffect=y={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class k extends Error{constructor(b,_){super(`ListError [${b}] ${_}`)}}t.ListError=k;class i{constructor(){this.cache=new WeakMap}getHeight(b){return this.cache.get(b)??this.estimateHeight(b)}setDynamicHeight(b,_){_>0&&this.cache.set(b,_)}}t.CachedListVirtualDelegate=i}),define(me[68],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class y{constructor(i){this.spliceables=i}splice(i,z,b){this.spliceables.forEach(_=>_.splice(i,z,b))}}t.CombinedSpliceable=y}),define(me[39],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const y=20;class k{constructor(z,b,_,c,l,h){this._scrollbarSize=Math.round(b),this._oppositeScrollbarSize=Math.round(_),this._arrowSize=Math.round(z),this._visibleSize=c,this._scrollSize=l,this._scrollPosition=h,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new k(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(z){const b=Math.round(z);return this._visibleSize!==b?(this._visibleSize=b,this._refreshComputedValues(),!0):!1}setScrollSize(z){const b=Math.round(z);return this._scrollSize!==b?(this._scrollSize=b,this._refreshComputedValues(),!0):!1}setScrollPosition(z){const b=Math.round(z);return this._scrollPosition!==b?(this._scrollPosition=b,this._refreshComputedValues(),!0):!1}setScrollbarSize(z){this._scrollbarSize=Math.round(z)}setOppositeScrollbarSize(z){this._oppositeScrollbarSize=Math.round(z)}static _computeValues(z,b,_,c,l){const h=Math.max(0,_-z),P=Math.max(0,h-2*b),r=c>0&&c>_;if(!r)return{computedAvailableSize:Math.round(h),computedIsNeeded:r,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(y,Math.floor(_*P/c))),e=(P-a)/(c-_),o=l*e;return{computedAvailableSize:Math.round(h),computedIsNeeded:r,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(o)}}_refreshComputedValues(){const z=k._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=z.computedAvailableSize,this._computedIsNeeded=z.computedIsNeeded,this._computedSliderSize=z.computedSliderSize,this._computedSliderRatio=z.computedSliderRatio,this._computedSliderPosition=z.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(z){if(!this._computedIsNeeded)return 0;const b=z-this._arrowSize-this._computedSliderSize/2;return Math.round(b/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(z){if(!this._computedIsNeeded)return 0;const b=z-this._arrowSize;let _=this._scrollPosition;return b<this._computedSliderPosition?_-=this._visibleSize:_+=this._visibleSize,_}getDesiredScrollPositionFromDelta(z){if(!this._computedIsNeeded)return 0;const b=this._computedSliderPosition+z;return Math.round(b/this._computedSliderRatio)}}t.ScrollbarState=k}),define(me[24],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var y;(function(c){c[c.Hidden=0]="Hidden",c[c.Visible=1]="Visible",c[c.Recurse=2]="Recurse"})(y||(t.TreeVisibility=y={}));var k;(function(c){c[c.Expanded=0]="Expanded",c[c.Collapsed=1]="Collapsed",c[c.PreserveOrExpanded=2]="PreserveOrExpanded",c[c.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(k||(t.ObjectTreeElementCollapseState=k={}));var i;(function(c){c[c.Unknown=0]="Unknown",c[c.Twistie=1]="Twistie",c[c.Element=2]="Element",c[c.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var z;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(z||(t.TreeDragOverBubble=z={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(c=!1){return{accept:!0,bubble:0,autoExpand:c}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(c=!1){return{accept:!0,bubble:0,effect:0,autoExpand:c}}};class b extends Error{constructor(l,h){super(`TreeError [${l}] ${h}`)}}t.TreeError=b;class _{constructor(l){this.fn=l,this._map=new WeakMap}map(l){let h=this._map.get(l);return h||(h=this.fn(l),this._map.set(l,h)),h}}t.WeakMapper=_}),define(me[69],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function y(b,_){const c=Object.create(null);for(const l of b){const h=_(l);let P=c[h];P||(P=c[h]=[]),P.push(l)}return c}t.groupBy=y;function k(b,_){const c=[],l=[];for(const h of b)_.has(h)||c.push(h);for(const h of _)b.has(h)||l.push(h);return{removed:c,added:l}}t.diffSets=k;function i(b,_){const c=[],l=[];for(const[h,P]of b)_.has(h)||c.push(P);for(const[h,P]of _)b.has(h)||l.push(P);return{removed:c,added:l}}t.diffMaps=i;class z{constructor(){this.map=new Map}add(_,c){let l=this.map.get(_);l||(l=new Set,this.map.set(_,l)),l.add(c)}delete(_,c){const l=this.map.get(_);l&&(l.delete(c),l.size===0&&this.map.delete(_))}forEach(_,c){const l=this.map.get(_);l&&l.forEach(c)}}t.SetMap=z}),define(me[70],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function y(_,c){const l=Math.pow(10,c);return Math.round(_*l)/l}class k{constructor(c,l,h,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=y(Math.max(Math.min(1,P),0),3)}static equals(c,l){return c.r===l.r&&c.g===l.g&&c.b===l.b&&c.a===l.a}}t.RGBA=k;class i{constructor(c,l,h,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=y(Math.max(Math.min(1,l),0),3),this.l=y(Math.max(Math.min(1,h),0),3),this.a=y(Math.max(Math.min(1,P),0),3)}static equals(c,l){return c.h===l.h&&c.s===l.s&&c.l===l.l&&c.a===l.a}static fromRGBA(c){const l=c.r/255,h=c.g/255,P=c.b/255,r=c.a,a=Math.max(l,h,P),e=Math.min(l,h,P);let o=0,s=0;const u=(e+a)/2,n=a-e;if(n>0){switch(s=Math.min(u<=.5?n/(2*u):n/(2-2*u),1),a){case l:o=(h-P)/n+(h<P?6:0);break;case h:o=(P-l)/n+2;break;case P:o=(l-h)/n+4;break}o*=60,o=Math.round(o)}return new i(o,s,u,r)}static _hue2rgb(c,l,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?c+(l-c)*6*h:h<1/2?l:h<2/3?c+(l-c)*(2/3-h)*6:c}static toRGBA(c){const l=c.h/360,{s:h,l:P,a:r}=c;let a,e,o;if(h===0)a=e=o=P;else{const s=P<.5?P*(1+h):P+h-P*h,u=2*P-s;a=i._hue2rgb(u,s,l+1/3),e=i._hue2rgb(u,s,l),o=i._hue2rgb(u,s,l-1/3)}return new k(Math.round(a*255),Math.round(e*255),Math.round(o*255),r)}}t.HSLA=i;class z{constructor(c,l,h,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=y(Math.max(Math.min(1,l),0),3),this.v=y(Math.max(Math.min(1,h),0),3),this.a=y(Math.max(Math.min(1,P),0),3)}static equals(c,l){return c.h===l.h&&c.s===l.s&&c.v===l.v&&c.a===l.a}static fromRGBA(c){const l=c.r/255,h=c.g/255,P=c.b/255,r=Math.max(l,h,P),a=Math.min(l,h,P),e=r-a,o=r===0?0:e/r;let s;return e===0?s=0:r===l?s=((h-P)/e%6+6)%6:r===h?s=(P-l)/e+2:s=(l-h)/e+4,new z(Math.round(s*60),o,r,c.a)}static toRGBA(c){const{h:l,s:h,v:P,a:r}=c,a=P*h,e=a*(1-Math.abs(l/60%2-1)),o=P-a;let[s,u,n]=[0,0,0];return l<60?(s=a,u=e):l<120?(s=e,u=a):l<180?(u=a,n=e):l<240?(u=e,n=a):l<300?(s=e,n=a):l<=360&&(s=a,n=e),s=Math.round((s+o)*255),u=Math.round((u+o)*255),n=Math.round((n+o)*255),new k(s,u,n,r)}}t.HSVA=z;class b{static fromHex(c){return b.Format.CSS.parseHex(c)||b.red}static equals(c,l){return!c&&!l?!0:!c||!l?!1:c.equals(l)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:z.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof k)this.rgba=c;else if(c instanceof i)this._hsla=c,this.rgba=i.toRGBA(c);else if(c instanceof z)this._hsva=c,this.rgba=z.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&k.equals(this.rgba,c.rgba)&&i.equals(this.hsla,c.hsla)&&z.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=b._relativeLuminanceForComponent(this.rgba.r),l=b._relativeLuminanceForComponent(this.rgba.g),h=b._relativeLuminanceForComponent(this.rgba.b),P=.2126*c+.7152*l+.0722*h;return y(P,4)}static _relativeLuminanceForComponent(c){const l=c/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(c){const l=this.getRelativeLuminance(),h=c.getRelativeLuminance();return l>h?(l+.05)/(h+.05):(h+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const l=this.getRelativeLuminance(),h=c.getRelativeLuminance();return l>h}isDarkerThan(c){const l=this.getRelativeLuminance(),h=c.getRelativeLuminance();return l<h}lighten(c){return new b(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new b(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:l,g:h,b:P,a:r}=this.rgba;return new b(new k(l,h,P,r*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new b(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const l=c.rgba,h=this.rgba.a,P=l.a,r=h+P*(1-h);if(r<1e-6)return b.transparent;const a=this.rgba.r*h/r+l.r*P*(1-h)/r,e=this.rgba.g*h/r+l.g*P*(1-h)/r,o=this.rgba.b*h/r+l.b*P*(1-h)/r;return new b(new k(a,e,o,r))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:l,g:h,b:P,a:r}=this.rgba;return new b(new k(c.rgba.r-r*(c.rgba.r-l),c.rgba.g-r*(c.rgba.g-h),c.rgba.b-r*(c.rgba.b-P),1))}flatten(...c){const l=c.reduceRight((h,P)=>b._flatten(P,h));return b._flatten(this,l)}static _flatten(c,l){const h=1-c.rgba.a;return new b(new k(h*l.rgba.r+c.rgba.a*c.rgba.r,h*l.rgba.g+c.rgba.a*c.rgba.g,h*l.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this._toString||(this._toString=b.Format.CSS.format(this)),this._toString}static getLighterColor(c,l,h){if(c.isLighterThan(l))return c;h=h||.5;const P=c.getRelativeLuminance(),r=l.getRelativeLuminance();return h=h*(r-P)/r,c.lighten(h)}static getDarkerColor(c,l,h){if(c.isDarkerThan(l))return c;h=h||.5;const P=c.getRelativeLuminance(),r=l.getRelativeLuminance();return h=h*(P-r)/P,c.darken(h)}}t.Color=b,b.white=new b(new k(255,255,255,1)),b.black=new b(new k(0,0,0,1)),b.red=new b(new k(255,0,0,1)),b.blue=new b(new k(0,0,255,1)),b.green=new b(new k(0,255,0,1)),b.cyan=new b(new k(0,255,255,1)),b.lightgrey=new b(new k(211,211,211,1)),b.transparent=new b(new k(0,0,0,0)),function(_){let c;(function(l){let h;(function(P){function r(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:_.Format.CSS.formatRGBA(f)}P.formatRGB=r;function a(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}P.formatRGBA=a;function e(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:_.Format.CSS.formatHSLA(f)}P.formatHSL=e;function o(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}P.formatHSLA=o;function s(f){const v=f.toString(16);return v.length!==2?"0"+v:v}function u(f){return`#${s(f.rgba.r)}${s(f.rgba.g)}${s(f.rgba.b)}`}P.formatHex=u;function n(f,v=!1){return v&&f.rgba.a===1?_.Format.CSS.formatHex(f):`#${s(f.rgba.r)}${s(f.rgba.g)}${s(f.rgba.b)}${s(Math.round(f.rgba.a*255))}`}P.formatHexA=n;function D(f){return f.isOpaque()?_.Format.CSS.formatHex(f):_.Format.CSS.formatRGBA(f)}P.format=D;function w(f){const v=f.length;if(v===0||f.charCodeAt(0)!==35)return null;if(v===7){const L=16*S(f.charCodeAt(1))+S(f.charCodeAt(2)),I=16*S(f.charCodeAt(3))+S(f.charCodeAt(4)),E=16*S(f.charCodeAt(5))+S(f.charCodeAt(6));return new _(new k(L,I,E,1))}if(v===9){const L=16*S(f.charCodeAt(1))+S(f.charCodeAt(2)),I=16*S(f.charCodeAt(3))+S(f.charCodeAt(4)),E=16*S(f.charCodeAt(5))+S(f.charCodeAt(6)),g=16*S(f.charCodeAt(7))+S(f.charCodeAt(8));return new _(new k(L,I,E,g/255))}if(v===4){const L=S(f.charCodeAt(1)),I=S(f.charCodeAt(2)),E=S(f.charCodeAt(3));return new _(new k(16*L+L,16*I+I,16*E+E))}if(v===5){const L=S(f.charCodeAt(1)),I=S(f.charCodeAt(2)),E=S(f.charCodeAt(3)),g=S(f.charCodeAt(4));return new _(new k(16*L+L,16*I+I,16*E+E,(16*g+g)/255))}return null}P.parseHex=w;function S(f){switch(f){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(h=l.CSS||(l.CSS={}))})(c=_.Format||(_.Format={}))}(b||(t.Color=b={}))}),define(me[25],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function y(b){return(_,c,l)=>{let h=null,P=null;if(typeof l.value=="function"?(h="value",P=l.value):typeof l.get=="function"&&(h="get",P=l.get),!P)throw new Error("not supported");l[h]=b(P,c)}}function k(b,_,c){let l=null,h=null;if(typeof c.value=="function"?(l="value",h=c.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(l="get",h=c.get),!h)throw new Error("not supported");const P=`$memoize$${_}`;c[l]=function(...r){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,r)}),this[P]}}t.memoize=k;function i(b,_,c){return y((l,h)=>{const P=`$debounce$${h}`,r=`$debounce$result$${h}`;return function(...a){this[r]||(this[r]=c?c():void 0),clearTimeout(this[P]),_&&(this[r]=_(this[r],...a),a=[this[r]]),this[P]=setTimeout(()=>{l.apply(this,a),this[r]=c?c():void 0},b)}})}t.debounce=i;function z(b,_,c){return y((l,h)=>{const P=`$throttle$timer$${h}`,r=`$throttle$result$${h}`,a=`$throttle$lastRun$${h}`,e=`$throttle$pending$${h}`;return function(...o){if(this[r]||(this[r]=c?c():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),_&&(this[r]=_(this[r],...o)),this[e])return;const s=this[a]+b;s<=Date.now()?(this[a]=Date.now(),l.apply(this,[this[r]]),this[r]=c?c():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),l.apply(this,[this[r]]),this[r]=c?c():void 0},s-Date.now()))}})}t.throttle=z}),define(me[71],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class y{constructor(i,z,b,_){this.originalStart=i,this.originalLength=z,this.modifiedStart=b,this.modifiedLength=_}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=y}),define(me[7],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(v){setTimeout(()=>{throw v.stack?w.isErrorNoTelemetry(v)?new w(v.message+`

`+v.stack):new Error(v.message+`

`+v.stack):v},0)}}addListener(v){return this.listeners.push(v),()=>{this._removeListener(v)}}emit(v){this.listeners.forEach(L=>{L(v)})}_removeListener(v){this.listeners.splice(this.listeners.indexOf(v),1)}setUnexpectedErrorHandler(v){this.unexpectedErrorHandler=v}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(v){this.unexpectedErrorHandler(v),this.emit(v)}onUnexpectedExternalError(v){this.unexpectedErrorHandler(v)}}t.ErrorHandler=y,t.errorHandler=new y;function k(f){t.errorHandler.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=k;function i(f){if(!f||typeof f!="object")return!1;const v=f;return v.code==="EPIPE"&&v.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function z(f){l(f)||t.errorHandler.onUnexpectedError(f)}t.onUnexpectedError=z;function b(f){l(f)||t.errorHandler.onUnexpectedExternalError(f)}t.onUnexpectedExternalError=b;function _(f){if(f instanceof Error){const{name:v,message:L}=f,I=f.stacktrace||f.stack;return{$isError:!0,name:v,message:L,stack:I,noTelemetry:w.isErrorNoTelemetry(f)}}return f}t.transformErrorForSerialization=_;const c="Canceled";function l(f){return f instanceof h?!0:f instanceof Error&&f.name===c&&f.message===c}t.isCancellationError=l;class h extends Error{constructor(){super(c),this.name=this.message}}t.CancellationError=h;function P(){const f=new Error(c);return f.name=f.message,f}t.canceled=P;function r(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.illegalArgument=r;function a(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.illegalState=a;function e(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function o(f){const v=new Error(`${f} has been disposed`);return v.name="DISPOSED",v}t.disposed=o;function s(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.getErrorMessage=s;class u extends Error{constructor(v){super("NotImplemented"),v&&(this.message=v)}}t.NotImplementedError=u;class n extends Error{constructor(v){super("NotSupported"),v&&(this.message=v)}}t.NotSupportedError=n;class D extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=D;class w extends Error{constructor(v){super(v),this.name="CodeExpectedError"}static fromError(v){if(v instanceof w)return v;const L=new w;return L.message=v.message,L.stack=v.stack,L}static isErrorNoTelemetry(v){return v.name==="CodeExpectedError"}}t.ErrorNoTelemetry=w;class S extends Error{constructor(v){super(v||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype);debugger}}t.BugIndicatingError=S}),define(me[13],pe([1,0,7]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function k(T,F=0){return T[T.length-(1+F)]}t.tail=k;function i(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}t.tail2=i;function z(T,F,B=(C,H)=>C===H){if(T===F)return!0;if(!T||!F||T.length!==F.length)return!1;for(let C=0,H=T.length;C<H;C++)if(!B(T[C],F[C]))return!1;return!0}t.equals=z;function b(T,F){const B=T.length-1;F<B&&(T[F]=T[B]),T.pop()}t.removeFastWithoutKeepingOrder=b;function _(T,F,B){return c(T.length,C=>B(T[C],F))}t.binarySearch=_;function c(T,F){let B=0,C=T-1;for(;B<=C;){const H=(B+C)/2|0,x=F(H);if(x<0)B=H+1;else if(x>0)C=H-1;else return H}return-(B+1)}t.binarySearch2=c;function l(T,F){let B=0,C=T.length;if(C===0)return 0;for(;B<C;){const H=Math.floor((B+C)/2);F(T[H])?C=H:B=H+1}return B}t.findFirstInSorted=l;function h(T,F,B){if(T=T|0,T>=F.length)throw new TypeError("invalid index");const C=F[Math.floor(F.length*Math.random())],H=[],x=[],M=[];for(const U of F){const q=B(U,C);q<0?H.push(U):q>0?x.push(U):M.push(U)}return T<H.length?h(T,H,B):T<H.length+M.length?M[0]:h(T-(H.length+M.length),x,B)}t.quickSelect=h;function P(T,F){const B=[];let C;for(const H of T.slice(0).sort(F))!C||F(C[0],H)!==0?(C=[H],B.push(C)):C.push(H);return B}t.groupBy=P;function r(T,F,B){const C=[];function H(U,q,ee){if(q===0&&ee.length===0)return;const ne=C[C.length-1];ne&&ne.start+ne.deleteCount===U?(ne.deleteCount+=q,ne.toInsert.push(...ee)):C.push({start:U,deleteCount:q,toInsert:ee})}let x=0,M=0;for(;;){if(x===T.length){H(x,0,F.slice(M));break}if(M===F.length){H(x,T.length-x,[]);break}const U=T[x],q=F[M],ee=B(U,q);ee===0?(x+=1,M+=1):ee<0?(H(x,1,[]),x+=1):ee>0&&(H(x,0,[q]),M+=1)}return C}t.sortedDiff=r;function a(T,F,B){const C=r(T,F,B),H=[],x=[];for(const M of C)H.push(...T.slice(M.start,M.start+M.deleteCount)),x.push(...M.toInsert);return{removed:H,added:x}}t.delta=a;function e(T,F,B){if(B===0)return[];const C=T.slice(0,B).sort(F);return s(T,F,C,B,T.length),C}t.top=e;function o(T,F,B,C,H){return B===0?Promise.resolve([]):new Promise((x,M)=>{(async()=>{const U=T.length,q=T.slice(0,B).sort(F);for(let ee=B,ne=Math.min(B+C,U);ee<U;ee=ne,ne=Math.min(ne+C,U)){if(ee>B&&await new Promise(ve=>setTimeout(ve)),H&&H.isCancellationRequested)throw new y.CancellationError;s(T,F,q,ee,ne)}return q})().then(x,M)})}t.topAsync=o;function s(T,F,B,C,H){for(const x=B.length;C<H;C++){const M=T[C];if(F(M,B[x-1])<0){B.pop();const U=l(B,q=>F(M,q)<0);B.splice(U,0,M)}}}function u(T){return T.filter(F=>!!F)}t.coalesce=u;function n(T){let F=0;for(let B=0;B<T.length;B++)T[B]&&(T[F]=T[B],F+=1);T.length=F}t.coalesceInPlace=n;function D(T,F,B){T.splice(B,0,T.splice(F,1)[0])}t.move=D;function w(T){return!Array.isArray(T)||T.length===0}t.isFalsyOrEmpty=w;function S(T){return Array.isArray(T)&&T.length>0}t.isNonEmptyArray=S;function f(T,F=B=>B){const B=new Set;return T.filter(C=>{const H=F(C);return B.has(H)?!1:(B.add(H),!0)})}t.distinct=f;function v(T){const F=new Set;return B=>{const C=T(B);return F.has(C)?!1:(F.add(C),!0)}}t.uniqueFilter=v;function L(T,F){const B=I(T,F);if(B!==-1)return T[B]}t.findLast=L;function I(T,F){for(let B=T.length-1;B>=0;B--){const C=T[B];if(F(C))return B}return-1}t.lastIndex=I;function E(T,F){return T.length>0?T[0]:F}t.firstOrDefault=E;function g(T,F){return T.length>0?T[T.length-1]:F}t.lastOrDefault=g;function m(T,F,B=(C,H)=>C===H){let C=0;for(let H=0,x=Math.min(T.length,F.length);H<x&&B(T[H],F[H]);H++)C++;return C}t.commonPrefixLength=m;function p(T){return[].concat(...T)}t.flatten=p;function O(T,F){let B=typeof F=="number"?T:0;typeof F=="number"?B=T:(B=0,F=T);const C=[];if(B<=F)for(let H=B;H<F;H++)C.push(H);else for(let H=B;H>F;H--)C.push(H);return C}t.range=O;function G(T,F,B){return T.reduce((C,H)=>(C[F(H)]=B?B(H):H,C),Object.create(null))}t.index=G;function J(T,F){return T.push(F),()=>ie(T,F)}t.insert=J;function ie(T,F){const B=T.indexOf(F);if(B>-1)return T.splice(B,1),F}t.remove=ie;function ae(T,F,B){const C=T.slice(0,F),H=T.slice(F);return C.concat(B,H)}t.arrayInsert=ae;function ge(T,F){let B;if(typeof F=="number"){let C=F;B=()=>{const H=Math.sin(C++)*179426549;return H-Math.floor(H)}}else B=Math.random;for(let C=T.length-1;C>0;C-=1){const H=Math.floor(B()*(C+1)),x=T[C];T[C]=T[H],T[H]=x}}t.shuffle=ge;function ue(T,F){const B=T.indexOf(F);B>-1&&(T.splice(B,1),T.unshift(F))}t.pushToStart=ue;function de(T,F){const B=T.indexOf(F);B>-1&&(T.splice(B,1),T.push(F))}t.pushToEnd=de;function he(T,F){for(const B of F)T.push(B)}t.pushMany=he;function Se(T,F){return Array.isArray(T)?T.map(F):F(T)}t.mapArrayOrNot=Se;function _e(T){return Array.isArray(T)?T:[T]}t.asArray=_e;function Oe(T){return T[Math.floor(Math.random()*T.length)]}t.getRandomElement=Oe;function re(T,F){for(const B of T){const C=F(B);if(C!==void 0)return C}}t.mapFind=re;function se(T,F,B){const C=oe(T,F),H=T.length,x=B.length;T.length=H+x;for(let M=H-1;M>=C;M--)T[M+x]=T[M];for(let M=0;M<x;M++)T[M+C]=B[M]}t.insertInto=se;function Q(T,F,B,C){const H=oe(T,F),x=T.splice(H,B);return se(T,H,C),x}t.splice=Q;function oe(T,F){return F<0?Math.max(F+T.length,0):Math.min(F,T.length)}var V;(function(T){function F(H){return H<0}T.isLessThan=F;function B(H){return H>0}T.isGreaterThan=B;function C(H){return H===0}T.isNeitherLessOrGreaterThan=C,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(V||(t.CompareResult=V={}));function K(T,F){return(B,C)=>F(T(B),T(C))}t.compareBy=K;function A(...T){return(F,B)=>{for(const C of T){const H=C(F,B);if(!V.isNeitherLessOrGreaterThan(H))return H}return V.neitherLessOrGreaterThan}}t.tieBreakComparators=A;const W=(T,F)=>T-F;t.numberComparator=W;function N(T,F){if(T.length===0)return;let B=T[0];for(let C=1;C<T.length;C++){const H=T[C];F(H,B)>0&&(B=H)}return B}t.findMaxBy=N;function d(T,F){if(T.length===0)return;let B=T[0];for(let C=1;C<T.length;C++){const H=T[C];F(H,B)>=0&&(B=H)}return B}t.findLastMaxBy=d;function R(T,F){return N(T,(B,C)=>-F(B,C))}t.findMinBy=R;class ${constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let B=this.firstIdx;for(;B<this.items.length&&F(this.items[B]);)B++;const C=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,C}takeFromEndWhile(F){let B=this.lastIdx;for(;B>=0&&F(this.items[B]);)B--;const C=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,C}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const F=this.items[this.firstIdx];return this.firstIdx++,F}removeLast(){const F=this.items[this.lastIdx];return this.lastIdx--,F}takeCount(F){const B=this.items.slice(this.firstIdx,this.firstIdx+F);return this.firstIdx+=F,B}}t.ArrayQueue=$;class Z{constructor(F){this.iterate=F}forEach(F){this.iterate(B=>(F(B),!0))}toArray(){const F=[];return this.iterate(B=>(F.push(B),!0)),F}filter(F){return new Z(B=>this.iterate(C=>F(C)?B(C):!0))}map(F){return new Z(B=>this.iterate(C=>B(F(C))))}some(F){let B=!1;return this.iterate(C=>(B=F(C),!B)),B}findFirst(F){let B;return this.iterate(C=>F(C)?(B=C,!1):!0),B}findLast(F){let B;return this.iterate(C=>(F(C)&&(B=C),!0)),B}findLastMaxBy(F){let B,C=!0;return this.iterate(H=>((C||V.isGreaterThan(F(H,B)))&&(C=!1,B=H),!0)),B}}t.CallbackIterable=Z,Z.empty=new Z(T=>{})}),define(me[72],pe([1,0,7]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function k(c,l){if(!c)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=k;function i(c,l="Unreachable"){throw new Error(l)}t.assertNever=i;function z(c){if(!c)throw new y.BugIndicatingError("Assertion Failed")}t.assert=z;function b(c){if(!c()){debugger;c(),(0,y.onUnexpectedError)(new y.BugIndicatingError("Assertion Failed"))}}t.assertFn=b;function _(c,l){let h=0;for(;h<c.length-1;){const P=c[h],r=c[h+1];if(!l(P,r))return!1;h++}return!0}t.checkAdjacentItems=_}),define(me[40],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function y(k){const i=this;let z=!1,b;return function(){return z||(z=!0,b=k.apply(i,arguments)),b}}t.once=y}),define(me[73],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class y{constructor(i){this._prefix=i,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=y,t.defaultGenerator=new y("id#")}),define(me[26],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(k){function i(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}k.is=i;const z=Object.freeze([]);function b(){return z}k.empty=b;function*_(w){yield w}k.single=_;function c(w){return i(w)?w:_(w)}k.wrap=c;function l(w){return w||z}k.from=l;function h(w){return!w||w[Symbol.iterator]().next().done===!0}k.isEmpty=h;function P(w){return w[Symbol.iterator]().next().value}k.first=P;function r(w,S){for(const f of w)if(S(f))return!0;return!1}k.some=r;function a(w,S){for(const f of w)if(S(f))return f}k.find=a;function*e(w,S){for(const f of w)S(f)&&(yield f)}k.filter=e;function*o(w,S){let f=0;for(const v of w)yield S(v,f++)}k.map=o;function*s(...w){for(const S of w)for(const f of S)yield f}k.concat=s;function u(w,S,f){let v=f;for(const L of w)v=S(v,L);return v}k.reduce=u;function*n(w,S,f=w.length){for(S<0&&(S+=w.length),f<0?f+=w.length:f>w.length&&(f=w.length);S<f;S++)yield w[S]}k.slice=n;function D(w,S=Number.POSITIVE_INFINITY){const f=[];if(S===0)return[f,w];const v=w[Symbol.iterator]();for(let L=0;L<S;L++){const I=v.next();if(I.done)return[f,k.empty()];f.push(I.value)}return[f,{[Symbol.iterator](){return v}}]}k.consume=D})(y||(t.Iterable=y={}))}),define(me[41],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(y||(t.KeyCode=y={}));var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(k||(t.ScanCode=k={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(o,s){this._keyCodeToStr[o]=s,this._strToKeyCode[s.toLowerCase()]=o}keyCodeToStr(o){return this._keyCodeToStr[o]}strToKeyCode(o){return this._strToKeyCode[o.toLowerCase()]||0}}const z=new i,b=new i,_=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const c=[],l=Object.create(null),h=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>h[e]||0,toEnum:e=>l[e]||0,toString:e=>c[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",o=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",0,"VK_F20",e,e],[1,118,"F21",79,"F21",0,"VK_F21",e,e],[1,119,"F22",80,"F22",0,"VK_F22",e,e],[1,120,"F23",81,"F23",0,"VK_F23",e,e],[1,121,"F24",82,"F24",0,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],s=[],u=[];for(const n of o){const[D,w,S,f,v,L,I,E,g]=n;if(u[w]||(u[w]=!0,c[w]=S,l[S]=w,h[S.toLowerCase()]=w,D&&(t.IMMUTABLE_CODE_TO_KEY_CODE[w]=f,f!==0&&f!==3&&f!==5&&f!==4&&f!==6&&f!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[f]=w))),!s[f]){if(s[f]=!0,!v)throw new Error(`String representation missing for key code ${f} around scan code ${S}`);z.define(f,v),b.define(f,E||v),_.define(f,g||E||v)}L&&(t.EVENT_KEY_CODE_MAP[L]=f),I&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[I]=f)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var P;(function(e){function o(S){return z.keyCodeToStr(S)}e.toString=o;function s(S){return z.strToKeyCode(S)}e.fromString=s;function u(S){return b.keyCodeToStr(S)}e.toUserSettingsUS=u;function n(S){return _.keyCodeToStr(S)}e.toUserSettingsGeneral=n;function D(S){return b.strToKeyCode(S)||_.strToKeyCode(S)}e.fromUserSettings=D;function w(S){if(S>=98&&S<=113)return null;switch(S){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return z.keyCodeToStr(S)}e.toElectronAccelerator=w})(P||(t.KeyCodeUtils=P={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r||(t.KeyMod=r={}));function a(e,o){const s=(o&65535)<<16>>>0;return(e|s)>>>0}t.KeyChord=a}),define(me[74],pe([1,0,7]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=t.createSimpleKeybinding=t.decodeKeybinding=void 0;var k;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(k||(k={}));function i(P,r){if(typeof P=="number"){if(P===0)return null;const a=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new c([z(a,r),z(e,r)]):new c([z(a,r)])}else{const a=[];for(let e=0;e<P.length;e++)a.push(z(P[e],r));return new c(a)}}t.decodeKeybinding=i;function z(P,r){const a=!!(P&2048),e=!!(P&256),o=r===2?e:a,s=!!(P&1024),u=!!(P&512),n=r===2?a:e,D=P&255;return new b(o,s,u,n,D)}t.createSimpleKeybinding=z;class b{constructor(r,a,e,o,s){this.ctrlKey=r,this.shiftKey=a,this.altKey=e,this.metaKey=o,this.keyCode=s}equals(r){return r instanceof b&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",o=this.metaKey?"1":"0";return`K${r}${a}${e}${o}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new c([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.KeyCodeChord=b;class _{constructor(r,a,e,o,s){this.ctrlKey=r,this.shiftKey=a,this.altKey=e,this.metaKey=o,this.scanCode=s}equals(r){return r instanceof _&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",o=this.metaKey?"1":"0";return`S${r}${a}${e}${o}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeChord=_;class c{constructor(r){if(r.length===0)throw(0,y.illegalArgument)("chords");this.chords=r}getHashCode(){let r="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(r+=";"),r+=this.chords[a].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(r.chords[a]))return!1;return!0}}t.Keybinding=c;class l{constructor(r,a,e,o,s,u){this.ctrlKey=r,this.shiftKey=a,this.altKey=e,this.metaKey=o,this.keyLabel=s,this.keyAriaLabel=u}}t.ResolvedChord=l;class h{}t.ResolvedKeybinding=h}),define(me[42],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class y{constructor(i){this.executor=i,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=y}),define(me[2],pe([1,0,40,26]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let z=null;function b(g){z=g}if(t.setDisposableTracker=b,i){const g="__is_disposable_tracked__";b(new class{trackDisposable(m){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[g]||console.log(p)},3e3)}setParent(m,p){if(m&&m!==n.None)try{m[g]=!0}catch{}}markAsDisposed(m){if(m&&m!==n.None)try{m[g]=!0}catch{}}markAsSingleton(m){}})}function _(g){return z?.trackDisposable(g),g}function c(g){z?.markAsDisposed(g)}function l(g,m){z?.setParent(g,m)}function h(g,m){if(z)for(const p of g)z.setParent(p,m)}function P(g){return z?.markAsSingleton(g),g}t.markAsSingleton=P;function r(g){return typeof g.dispose=="function"&&g.dispose.length===0}t.isDisposable=r;function a(g){if(k.Iterable.is(g)){const m=[];for(const p of g)if(p)try{p.dispose()}catch(O){m.push(O)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}t.dispose=a;function e(g){for(const m of g)r(m)&&m.dispose();return[]}t.disposeIfDisposable=e;function o(...g){const m=s(()=>a(g));return h(g,m),m}t.combinedDisposable=o;function s(g){const m=_({dispose:(0,y.once)(()=>{c(m),g()})});return m}t.toDisposable=s;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(c(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{a(this._toDispose)}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return l(m,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}}t.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this._store=new u,_(this),l(this._store,this)}dispose(){c(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}t.Disposable=n,n.None=Object.freeze({dispose(){}});class D{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){this._isDisposed||m===this._value||(this._value?.dispose(),m&&l(m,this),this._value=m)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,c(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const m=this._value;return this._value=void 0,m&&l(m,null),m}}t.MutableDisposable=D;class w{constructor(m){this._disposable=m,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=w;class S{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set(m){let p=m;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,c(this))},this}}t.SafeDisposable=S;class f{constructor(){this.references=new Map}acquire(m,...p){let O=this.references.get(m);O||(O={counter:0,object:this.createReferencedObject(m,...p)},this.references.set(m,O));const{object:G}=O,J=(0,y.once)(()=>{--O.counter===0&&(this.destroyReferencedObject(m,O.object),this.references.delete(m))});return O.counter++,{object:G,dispose:J}}}t.ReferenceCollection=f;class v{constructor(m){this.referenceCollection=m}async acquire(m,...p){const O=this.referenceCollection.acquire(m,...p);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(G){throw O.dispose(),G}}}t.AsyncReferenceCollection=v;class L{constructor(m){this.object=m}dispose(){}}t.ImmortalReference=L;function I(g){const m=new u;try{g(m)}finally{m.dispose()}}t.disposeOnReturn=I;class E{constructor(){this._store=new Map,this._isDisposed=!1,_(this)}dispose(){c(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{a(this._store.values())}finally{this._store.clear()}}has(m){return this._store.has(m)}get(m){return this._store.get(m)}set(m,p,O=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this._store.get(m)?.dispose(),this._store.set(m,p)}deleteAndDispose(m){this._store.get(m)?.dispose(),this._store.delete(m)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=E}),define(me[43],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class y{constructor(z){this.element=z,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class k{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let z=this._first;for(;z!==y.Undefined;){const b=z.next;z.prev=y.Undefined,z.next=y.Undefined,z=b}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(z){return this._insert(z,!1)}push(z){return this._insert(z,!0)}_insert(z,b){const _=new y(z);if(this._first===y.Undefined)this._first=_,this._last=_;else if(b){const l=this._last;this._last=_,_.prev=l,l.next=_}else{const l=this._first;this._first=_,_.next=l,l.prev=_}this._size+=1;let c=!1;return()=>{c||(c=!0,this._remove(_))}}shift(){if(this._first!==y.Undefined){const z=this._first.element;return this._remove(this._first),z}}pop(){if(this._last!==y.Undefined){const z=this._last.element;return this._remove(this._last),z}}_remove(z){if(z.prev!==y.Undefined&&z.next!==y.Undefined){const b=z.prev;b.next=z.next,z.next.prev=b}else z.prev===y.Undefined&&z.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):z.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):z.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let z=this._first;for(;z!==y.Undefined;)yield z.element,z=z.next}}t.LinkedList=k}),define(me[75],pe([1,0]),function(te,t){"use strict";var y,k,i;Object.defineProperty(t,"__esModule",{value:!0}),t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function z(o,s,u){let n=o.get(s);return n===void 0&&(n=u,o.set(s,n)),n}t.getOrSet=z;function b(o){const s=[];return o.forEach((u,n)=>{s.push(`${n} => ${u}`)}),`Map(${o.size}) {${s.join(", ")}}`}t.mapToString=b;function _(o){const s=[];return o.forEach(u=>{s.push(u)}),`Set(${o.size}) {${s.join(", ")}}`}t.setToString=_;class c{constructor(s,u){this.uri=s,this.value=u}}class l{constructor(s,u){this[y]="ResourceMap",s instanceof l?(this.map=new Map(s.map),this.toKey=u??l.defaultToKey):(this.map=new Map,this.toKey=s??l.defaultToKey)}set(s,u){return this.map.set(this.toKey(s),new c(s,u)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,u){typeof u<"u"&&(s=s.bind(u));for(const[n,D]of this.map)s(D.value,D.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}t.ResourceMap=l,l.defaultToKey=o=>o.toString();class h{constructor(s,u){this[k]="ResourceSet",!s||typeof s=="function"?this._map=new l(s):(this._map=new l(u),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,u){this._map.forEach((n,D)=>s.call(u,D,D,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=h;var P;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(P||(t.Touch=P={}));class r{constructor(){this[i]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,u=0){const n=this._map.get(s);if(n)return u!==0&&this.touch(n,u),n.value}set(s,u,n=0){let D=this._map.get(s);if(D)D.value=u,n!==0&&this.touch(D,n);else{switch(D={key:s,value:u,next:void 0,previous:void 0},n){case 0:this.addItemLast(D);break;case 1:this.addItemFirst(D);break;case 2:this.addItemLast(D);break;default:this.addItemLast(D);break}this._map.set(s,D),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const u=this._map.get(s);if(u)return this._map.delete(s),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,u){const n=this._state;let D=this._head;for(;D;){if(u?s.bind(u)(D.value,D.key,this):s(D.value,D.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");D=D.next}}keys(){const s=this,u=this._state;let n=this._head;const D={[Symbol.iterator](){return D},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(n){const w={value:n.key,done:!1};return n=n.next,w}else return{value:void 0,done:!0}}};return D}values(){const s=this,u=this._state;let n=this._head;const D={[Symbol.iterator](){return D},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(n){const w={value:n.value,done:!1};return n=n.next,w}else return{value:void 0,done:!0}}};return D}entries(){const s=this,u=this._state;let n=this._head;const D={[Symbol.iterator](){return D},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(n){const w={value:[n.key,n.value],done:!1};return n=n.next,w}else return{value:void 0,done:!0}}};return D}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let u=this._head,n=this.size;for(;u&&n>s;)this._map.delete(u.key),u=u.next,n--;this._head=u,this._size=n,u&&(u.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const u=s.next,n=s.previous;if(!u||!n)throw new Error("Invalid list");u.previous=n,n.next=u}s.next=void 0,s.previous=void 0,this._state++}touch(s,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(s===this._head)return;const n=s.next,D=s.previous;s===this._tail?(D.next=void 0,this._tail=D):(n.previous=D,D.next=n),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(u===2){if(s===this._tail)return;const n=s.next,D=s.previous;s===this._head?(n.previous=void 0,this._head=n):(n.previous=D,D.next=n),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((u,n)=>{s.push([n,u])}),s}fromJSON(s){this.clear();for(const[u,n]of s)this.set(u,n)}}t.LinkedMap=r;class a extends r{constructor(s,u=1){super(),this._limit=s,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,u=2){return super.get(s,u)}peek(s){return super.get(s,0)}set(s,u){return super.set(s,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=a;class e{constructor(){this.map=new Map}add(s){return this.map.set(s,(this.map.get(s)||0)+1),this}delete(s){let u=this.map.get(s)||0;return u===0?!1:(u--,u===0?this.map.delete(s):this.map.set(s,u),!0)}has(s){return this.map.has(s)}}t.CounterSet=e}),function(te,t){typeof define=="function"&&define.amd?define(me[76],pe([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(te=typeof globalThis<"u"?globalThis:te||self,t(te.marked={}))}(this,function(te){"use strict";function t(T,F){for(var B=0;B<F.length;B++){var C=F[B];C.enumerable=C.enumerable||!1,C.configurable=!0,"value"in C&&(C.writable=!0),Object.defineProperty(T,C.key,C)}}function y(T,F,B){return F&&t(T.prototype,F),B&&t(T,B),Object.defineProperty(T,"prototype",{writable:!1}),T}function k(T,F){if(T){if(typeof T=="string")return i(T,F);var B=Object.prototype.toString.call(T).slice(8,-1);if(B==="Object"&&T.constructor&&(B=T.constructor.name),B==="Map"||B==="Set")return Array.from(T);if(B==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(B))return i(T,F)}}function i(T,F){(F==null||F>T.length)&&(F=T.length);for(var B=0,C=new Array(F);B<F;B++)C[B]=T[B];return C}function z(T,F){var B=typeof Symbol<"u"&&T[Symbol.iterator]||T["@@iterator"];if(B)return(B=B.call(T)).next.bind(B);if(Array.isArray(T)||(B=k(T))||F&&T&&typeof T.length=="number"){B&&(T=B);var C=0;return function(){return C>=T.length?{done:!0}:{done:!1,value:T[C++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function b(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=b();function _(T){te.defaults=T}var c=/[&<>"']/,l=/[&<>"']/g,h=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(F){return r[F]};function e(T,F){if(F){if(c.test(T))return T.replace(l,a)}else if(h.test(T))return T.replace(P,a);return T}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(T){return T.replace(o,function(F,B){return B=B.toLowerCase(),B==="colon"?":":B.charAt(0)==="#"?B.charAt(1)==="x"?String.fromCharCode(parseInt(B.substring(2),16)):String.fromCharCode(+B.substring(1)):""})}var u=/(^|[^\[])\^/g;function n(T,F){T=typeof T=="string"?T:T.source,F=F||"";var B={replace:function(H,x){return x=x.source||x,x=x.replace(u,"$1"),T=T.replace(H,x),B},getRegex:function(){return new RegExp(T,F)}};return B}var D=/[^\w:]/g,w=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(T,F,B){if(T){var C;try{C=decodeURIComponent(s(B)).replace(D,"").toLowerCase()}catch{return null}if(C.indexOf("javascript:")===0||C.indexOf("vbscript:")===0||C.indexOf("data:")===0)return null}F&&!w.test(B)&&(B=E(F,B));try{B=encodeURI(B).replace(/%25/g,"%")}catch{return null}return B}var f={},v=/^[^:]+:\/*[^/]*$/,L=/^([^:]+:)[\s\S]*$/,I=/^([^:]+:\/*[^/]*)[\s\S]*$/;function E(T,F){f[" "+T]||(v.test(T)?f[" "+T]=T+"/":f[" "+T]=O(T,"/",!0)),T=f[" "+T];var B=T.indexOf(":")===-1;return F.substring(0,2)==="//"?B?F:T.replace(L,"$1")+F:F.charAt(0)==="/"?B?F:T.replace(I,"$1")+F:T+F}var g={exec:function(){}};function m(T){for(var F=1,B,C;F<arguments.length;F++){B=arguments[F];for(C in B)Object.prototype.hasOwnProperty.call(B,C)&&(T[C]=B[C])}return T}function p(T,F){var B=T.replace(/\|/g,function(x,M,U){for(var q=!1,ee=M;--ee>=0&&U[ee]==="\\";)q=!q;return q?"|":" |"}),C=B.split(/ \|/),H=0;if(C[0].trim()||C.shift(),C.length>0&&!C[C.length-1].trim()&&C.pop(),C.length>F)C.splice(F);else for(;C.length<F;)C.push("");for(;H<C.length;H++)C[H]=C[H].trim().replace(/\\\|/g,"|");return C}function O(T,F,B){var C=T.length;if(C===0)return"";for(var H=0;H<C;){var x=T.charAt(C-H-1);if(x===F&&!B)H++;else if(x!==F&&B)H++;else break}return T.slice(0,C-H)}function G(T,F){if(T.indexOf(F[1])===-1)return-1;for(var B=T.length,C=0,H=0;H<B;H++)if(T[H]==="\\")H++;else if(T[H]===F[0])C++;else if(T[H]===F[1]&&(C--,C<0))return H;return-1}function J(T){T&&T.sanitize&&!T.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function ie(T,F){if(F<1)return"";for(var B="";F>1;)F&1&&(B+=T),F>>=1,T+=T;return B+T}function ae(T,F,B,C){var H=F.href,x=F.title?e(F.title):null,M=T[1].replace(/\\([\[\]])/g,"$1");if(T[0].charAt(0)!=="!"){C.state.inLink=!0;var U={type:"link",raw:B,href:H,title:x,text:M,tokens:C.inlineTokens(M)};return C.state.inLink=!1,U}return{type:"image",raw:B,href:H,title:x,text:e(M)}}function ge(T,F){var B=T.match(/^(\s+)(?:```)/);if(B===null)return F;var C=B[1];return F.split(`
`).map(function(H){var x=H.match(/^\s+/);if(x===null)return H;var M=x[0];return M.length>=C.length?H.slice(C.length):H}).join(`
`)}var ue=function(){function T(B){this.options=B||te.defaults}var F=T.prototype;return F.space=function(C){var H=this.rules.block.newline.exec(C);if(H&&H[0].length>0)return{type:"space",raw:H[0]}},F.code=function(C){var H=this.rules.block.code.exec(C);if(H){var x=H[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:H[0],codeBlockStyle:"indented",text:this.options.pedantic?x:O(x,`
`)}}},F.fences=function(C){var H=this.rules.block.fences.exec(C);if(H){var x=H[0],M=ge(x,H[3]||"");return{type:"code",raw:x,lang:H[2]?H[2].trim():H[2],text:M}}},F.heading=function(C){var H=this.rules.block.heading.exec(C);if(H){var x=H[2].trim();if(/#$/.test(x)){var M=O(x,"#");(this.options.pedantic||!M||/ $/.test(M))&&(x=M.trim())}return{type:"heading",raw:H[0],depth:H[1].length,text:x,tokens:this.lexer.inline(x)}}},F.hr=function(C){var H=this.rules.block.hr.exec(C);if(H)return{type:"hr",raw:H[0]}},F.blockquote=function(C){var H=this.rules.block.blockquote.exec(C);if(H){var x=H[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:H[0],tokens:this.lexer.blockTokens(x,[]),text:x}}},F.list=function(C){var H=this.rules.block.list.exec(C);if(H){var x,M,U,q,ee,ne,ve,we,Ne,Ae,De,Pe,Ie=H[1].trim(),Ke=Ie.length>1,xe={type:"list",raw:"",ordered:Ke,start:Ke?+Ie.slice(0,-1):"",loose:!1,items:[]};Ie=Ke?"\\d{1,9}\\"+Ie.slice(-1):"\\"+Ie,this.options.pedantic&&(Ie=Ke?Ie:"[*+-]");for(var ze=new RegExp("^( {0,3}"+Ie+")((?:[	 ][^\\n]*)?(?:\\n|$))");C&&(Pe=!1,!(!(H=ze.exec(C))||this.rules.block.hr.test(C)));){if(x=H[0],C=C.substring(x.length),we=H[2].split(`
`,1)[0],Ne=C.split(`
`,1)[0],this.options.pedantic?(q=2,De=we.trimLeft()):(q=H[2].search(/[^ ]/),q=q>4?1:q,De=we.slice(q),q+=H[1].length),ne=!1,!we&&/^ *$/.test(Ne)&&(x+=Ne+`
`,C=C.substring(Ne.length+1),Pe=!0),!Pe)for(var Je=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,q-1)+"}#");C&&(Ae=C.split(`
`,1)[0],we=Ae,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(we)||Ve.test(we)||Je.test(we)||it.test(C)));){if(we.search(/[^ ]/)>=q||!we.trim())De+=`
`+we.slice(q);else if(!ne)De+=`
`+we;else break;!ne&&!we.trim()&&(ne=!0),x+=Ae+`
`,C=C.substring(Ae.length+1)}xe.loose||(ve?xe.loose=!0:/\n *\n *$/.test(x)&&(ve=!0)),this.options.gfm&&(M=/^\[[ xX]\] /.exec(De),M&&(U=M[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:x,task:!!M,checked:U,loose:!1,text:De}),xe.raw+=x}xe.items[xe.items.length-1].raw=x.trimRight(),xe.items[xe.items.length-1].text=De.trimRight(),xe.raw=xe.raw.trimRight();var j=xe.items.length;for(ee=0;ee<j;ee++){this.lexer.state.top=!1,xe.items[ee].tokens=this.lexer.blockTokens(xe.items[ee].text,[]);var le=xe.items[ee].tokens.filter(function(ye){return ye.type==="space"}),be=le.every(function(ye){for(var Ce=ye.raw.split(""),Re=0,Ue=z(Ce),Ge;!(Ge=Ue()).done;){var et=Ge.value;if(et===`
`&&(Re+=1),Re>1)return!0}return!1});!xe.loose&&le.length&&be&&(xe.loose=!0,xe.items[ee].loose=!0)}return xe}},F.html=function(C){var H=this.rules.block.html.exec(C);if(H){var x={type:"html",raw:H[0],pre:!this.options.sanitizer&&(H[1]==="pre"||H[1]==="script"||H[1]==="style"),text:H[0]};if(this.options.sanitize){var M=this.options.sanitizer?this.options.sanitizer(H[0]):e(H[0]);x.type="paragraph",x.text=M,x.tokens=this.lexer.inline(M)}return x}},F.def=function(C){var H=this.rules.block.def.exec(C);if(H){H[3]&&(H[3]=H[3].substring(1,H[3].length-1));var x=H[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:x,raw:H[0],href:H[2],title:H[3]}}},F.table=function(C){var H=this.rules.block.table.exec(C);if(H){var x={type:"table",header:p(H[1]).map(function(ve){return{text:ve}}),align:H[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:H[3]&&H[3].trim()?H[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(x.header.length===x.align.length){x.raw=H[0];var M=x.align.length,U,q,ee,ne;for(U=0;U<M;U++)/^ *-+: *$/.test(x.align[U])?x.align[U]="right":/^ *:-+: *$/.test(x.align[U])?x.align[U]="center":/^ *:-+ *$/.test(x.align[U])?x.align[U]="left":x.align[U]=null;for(M=x.rows.length,U=0;U<M;U++)x.rows[U]=p(x.rows[U],x.header.length).map(function(ve){return{text:ve}});for(M=x.header.length,q=0;q<M;q++)x.header[q].tokens=this.lexer.inline(x.header[q].text);for(M=x.rows.length,q=0;q<M;q++)for(ne=x.rows[q],ee=0;ee<ne.length;ee++)ne[ee].tokens=this.lexer.inline(ne[ee].text);return x}}},F.lheading=function(C){var H=this.rules.block.lheading.exec(C);if(H)return{type:"heading",raw:H[0],depth:H[2].charAt(0)==="="?1:2,text:H[1],tokens:this.lexer.inline(H[1])}},F.paragraph=function(C){var H=this.rules.block.paragraph.exec(C);if(H){var x=H[1].charAt(H[1].length-1)===`
`?H[1].slice(0,-1):H[1];return{type:"paragraph",raw:H[0],text:x,tokens:this.lexer.inline(x)}}},F.text=function(C){var H=this.rules.block.text.exec(C);if(H)return{type:"text",raw:H[0],text:H[0],tokens:this.lexer.inline(H[0])}},F.escape=function(C){var H=this.rules.inline.escape.exec(C);if(H)return{type:"escape",raw:H[0],text:e(H[1])}},F.tag=function(C){var H=this.rules.inline.tag.exec(C);if(H)return!this.lexer.state.inLink&&/^<a /i.test(H[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(H[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(H[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(H[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:H[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):e(H[0]):H[0]}},F.link=function(C){var H=this.rules.inline.link.exec(C);if(H){var x=H[2].trim();if(!this.options.pedantic&&/^</.test(x)){if(!/>$/.test(x))return;var M=O(x.slice(0,-1),"\\");if((x.length-M.length)%2===0)return}else{var U=G(H[2],"()");if(U>-1){var q=H[0].indexOf("!")===0?5:4,ee=q+H[1].length+U;H[2]=H[2].substring(0,U),H[0]=H[0].substring(0,ee).trim(),H[3]=""}}var ne=H[2],ve="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ne);we&&(ne=we[1],ve=we[3])}else ve=H[3]?H[3].slice(1,-1):"";return ne=ne.trim(),/^</.test(ne)&&(this.options.pedantic&&!/>$/.test(x)?ne=ne.slice(1):ne=ne.slice(1,-1)),ae(H,{href:ne&&ne.replace(this.rules.inline._escapes,"$1"),title:ve&&ve.replace(this.rules.inline._escapes,"$1")},H[0],this.lexer)}},F.reflink=function(C,H){var x;if((x=this.rules.inline.reflink.exec(C))||(x=this.rules.inline.nolink.exec(C))){var M=(x[2]||x[1]).replace(/\s+/g," ");if(M=H[M.toLowerCase()],!M||!M.href){var U=x[0].charAt(0);return{type:"text",raw:U,text:U}}return ae(x,M,x[0],this.lexer)}},F.emStrong=function(C,H,x){x===void 0&&(x="");var M=this.rules.inline.emStrong.lDelim.exec(C);if(M&&!(M[3]&&x.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=M[1]||M[2]||"";if(!U||U&&(x===""||this.rules.inline.punctuation.exec(x))){var q=M[0].length-1,ee,ne,ve=q,we=0,Ne=M[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,H=H.slice(-1*C.length+q);(M=Ne.exec(H))!=null;)if(ee=M[1]||M[2]||M[3]||M[4]||M[5]||M[6],!!ee){if(ne=ee.length,M[3]||M[4]){ve+=ne;continue}else if((M[5]||M[6])&&q%3&&!((q+ne)%3)){we+=ne;continue}if(ve-=ne,!(ve>0)){if(ne=Math.min(ne,ne+ve+we),Math.min(q,ne)%2){var Ae=C.slice(1,q+M.index+ne);return{type:"em",raw:C.slice(0,q+M.index+ne+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var De=C.slice(2,q+M.index+ne-1);return{type:"strong",raw:C.slice(0,q+M.index+ne+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},F.codespan=function(C){var H=this.rules.inline.code.exec(C);if(H){var x=H[2].replace(/\n/g," "),M=/[^ ]/.test(x),U=/^ /.test(x)&&/ $/.test(x);return M&&U&&(x=x.substring(1,x.length-1)),x=e(x,!0),{type:"codespan",raw:H[0],text:x}}},F.br=function(C){var H=this.rules.inline.br.exec(C);if(H)return{type:"br",raw:H[0]}},F.del=function(C){var H=this.rules.inline.del.exec(C);if(H)return{type:"del",raw:H[0],text:H[2],tokens:this.lexer.inlineTokens(H[2])}},F.autolink=function(C,H){var x=this.rules.inline.autolink.exec(C);if(x){var M,U;return x[2]==="@"?(M=e(this.options.mangle?H(x[1]):x[1]),U="mailto:"+M):(M=e(x[1]),U=M),{type:"link",raw:x[0],text:M,href:U,tokens:[{type:"text",raw:M,text:M}]}}},F.url=function(C,H){var x;if(x=this.rules.inline.url.exec(C)){var M,U;if(x[2]==="@")M=e(this.options.mangle?H(x[0]):x[0]),U="mailto:"+M;else{var q;do q=x[0],x[0]=this.rules.inline._backpedal.exec(x[0])[0];while(q!==x[0]);M=e(x[0]),x[1]==="www."?U="http://"+M:U=M}return{type:"link",raw:x[0],text:M,href:U,tokens:[{type:"text",raw:M,text:M}]}}},F.inlineText=function(C,H){var x=this.rules.inline.text.exec(C);if(x){var M;return this.lexer.state.inRawBlock?M=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):e(x[0]):x[0]:M=e(this.options.smartypants?H(x[0]):x[0]),{type:"text",raw:x[0],text:M}}},T}(),de={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};de._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,de._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,de.def=n(de.def).replace("label",de._label).replace("title",de._title).getRegex(),de.bullet=/(?:[*+-]|\d{1,9}[.)])/,de.listItemStart=n(/^( *)(bull) */).replace("bull",de.bullet).getRegex(),de.list=n(de.list).replace(/bull/g,de.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+de.def.source+")").getRegex(),de._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",de._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,de.html=n(de.html,"i").replace("comment",de._comment).replace("tag",de._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),de.paragraph=n(de._paragraph).replace("hr",de.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",de._tag).getRegex(),de.blockquote=n(de.blockquote).replace("paragraph",de.paragraph).getRegex(),de.normal=m({},de),de.gfm=m({},de.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),de.gfm.table=n(de.gfm.table).replace("hr",de.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",de._tag).getRegex(),de.gfm.paragraph=n(de._paragraph).replace("hr",de.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",de.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",de._tag).getRegex(),de.pedantic=m({},de.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",de._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:n(de.normal._paragraph).replace("hr",de.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",de.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var he={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};he._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",he.punctuation=n(he.punctuation).replace(/punctuation/g,he._punctuation).getRegex(),he.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,he.escapedEmSt=/\\\*|\\_/g,he._comment=n(de._comment).replace("(?:-->|$)","-->").getRegex(),he.emStrong.lDelim=n(he.emStrong.lDelim).replace(/punct/g,he._punctuation).getRegex(),he.emStrong.rDelimAst=n(he.emStrong.rDelimAst,"g").replace(/punct/g,he._punctuation).getRegex(),he.emStrong.rDelimUnd=n(he.emStrong.rDelimUnd,"g").replace(/punct/g,he._punctuation).getRegex(),he._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,he._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,he._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,he.autolink=n(he.autolink).replace("scheme",he._scheme).replace("email",he._email).getRegex(),he._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,he.tag=n(he.tag).replace("comment",he._comment).replace("attribute",he._attribute).getRegex(),he._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,he._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,he._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,he.link=n(he.link).replace("label",he._label).replace("href",he._href).replace("title",he._title).getRegex(),he.reflink=n(he.reflink).replace("label",he._label).replace("ref",de._label).getRegex(),he.nolink=n(he.nolink).replace("ref",de._label).getRegex(),he.reflinkSearch=n(he.reflinkSearch,"g").replace("reflink",he.reflink).replace("nolink",he.nolink).getRegex(),he.normal=m({},he),he.pedantic=m({},he.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",he._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",he._label).getRegex()}),he.gfm=m({},he.normal,{escape:n(he.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),he.gfm.url=n(he.gfm.url,"i").replace("email",he.gfm._extended_email).getRegex(),he.breaks=m({},he.gfm,{br:n(he.br).replace("{2,}","*").getRegex(),text:n(he.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Se(T){return T.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function _e(T){var F="",B,C,H=T.length;for(B=0;B<H;B++)C=T.charCodeAt(B),Math.random()>.5&&(C="x"+C.toString(16)),F+="&#"+C+";";return F}var Oe=function(){function T(B){this.tokens=[],this.tokens.links=Object.create(null),this.options=B||te.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var C={block:de.normal,inline:he.normal};this.options.pedantic?(C.block=de.pedantic,C.inline=he.pedantic):this.options.gfm&&(C.block=de.gfm,this.options.breaks?C.inline=he.breaks:C.inline=he.gfm),this.tokenizer.rules=C}T.lex=function(C,H){var x=new T(H);return x.lex(C)},T.lexInline=function(C,H){var x=new T(H);return x.inlineTokens(C)};var F=T.prototype;return F.lex=function(C){C=C.replace(/\r\n|\r/g,`
`),this.blockTokens(C,this.tokens);for(var H;H=this.inlineQueue.shift();)this.inlineTokens(H.src,H.tokens);return this.tokens},F.blockTokens=function(C,H){var x=this;H===void 0&&(H=[]),this.options.pedantic?C=C.replace(/\t/g,"    ").replace(/^ +$/gm,""):C=C.replace(/^( *)(\t+)/gm,function(ve,we,Ne){return we+"    ".repeat(Ne.length)});for(var M,U,q,ee;C;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ve){return(M=ve.call({lexer:x},C,H))?(C=C.substring(M.raw.length),H.push(M),!0):!1}))){if(M=this.tokenizer.space(C)){C=C.substring(M.raw.length),M.raw.length===1&&H.length>0?H[H.length-1].raw+=`
`:H.push(M);continue}if(M=this.tokenizer.code(C)){C=C.substring(M.raw.length),U=H[H.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+M.raw,U.text+=`
`+M.text,this.inlineQueue[this.inlineQueue.length-1].src=U.text):H.push(M);continue}if(M=this.tokenizer.fences(C)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.heading(C)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.hr(C)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.blockquote(C)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.list(C)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.html(C)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.def(C)){C=C.substring(M.raw.length),U=H[H.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+M.raw,U.text+=`
`+M.raw,this.inlineQueue[this.inlineQueue.length-1].src=U.text):this.tokens.links[M.tag]||(this.tokens.links[M.tag]={href:M.href,title:M.title});continue}if(M=this.tokenizer.table(C)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.lheading(C)){C=C.substring(M.raw.length),H.push(M);continue}if(q=C,this.options.extensions&&this.options.extensions.startBlock&&function(){var ve=1/0,we=C.slice(1),Ne=void 0;x.options.extensions.startBlock.forEach(function(Ae){Ne=Ae.call({lexer:this},we),typeof Ne=="number"&&Ne>=0&&(ve=Math.min(ve,Ne))}),ve<1/0&&ve>=0&&(q=C.substring(0,ve+1))}(),this.state.top&&(M=this.tokenizer.paragraph(q))){U=H[H.length-1],ee&&U.type==="paragraph"?(U.raw+=`
`+M.raw,U.text+=`
`+M.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):H.push(M),ee=q.length!==C.length,C=C.substring(M.raw.length);continue}if(M=this.tokenizer.text(C)){C=C.substring(M.raw.length),U=H[H.length-1],U&&U.type==="text"?(U.raw+=`
`+M.raw,U.text+=`
`+M.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):H.push(M);continue}if(C){var ne="Infinite loop on byte: "+C.charCodeAt(0);if(this.options.silent){console.error(ne);break}else throw new Error(ne)}}return this.state.top=!0,H},F.inline=function(C,H){return H===void 0&&(H=[]),this.inlineQueue.push({src:C,tokens:H}),H},F.inlineTokens=function(C,H){var x=this;H===void 0&&(H=[]);var M,U,q,ee=C,ne,ve,we;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(ne=this.tokenizer.rules.inline.reflinkSearch.exec(ee))!=null;)Ne.includes(ne[0].slice(ne[0].lastIndexOf("[")+1,-1))&&(ee=ee.slice(0,ne.index)+"["+ie("a",ne[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ne=this.tokenizer.rules.inline.blockSkip.exec(ee))!=null;)ee=ee.slice(0,ne.index)+"["+ie("a",ne[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ne=this.tokenizer.rules.inline.escapedEmSt.exec(ee))!=null;)ee=ee.slice(0,ne.index)+"++"+ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;C;)if(ve||(we=""),ve=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(M=De.call({lexer:x},C,H))?(C=C.substring(M.raw.length),H.push(M),!0):!1}))){if(M=this.tokenizer.escape(C)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.tag(C)){C=C.substring(M.raw.length),U=H[H.length-1],U&&M.type==="text"&&U.type==="text"?(U.raw+=M.raw,U.text+=M.text):H.push(M);continue}if(M=this.tokenizer.link(C)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.reflink(C,this.tokens.links)){C=C.substring(M.raw.length),U=H[H.length-1],U&&M.type==="text"&&U.type==="text"?(U.raw+=M.raw,U.text+=M.text):H.push(M);continue}if(M=this.tokenizer.emStrong(C,ee,we)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.codespan(C)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.br(C)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.del(C)){C=C.substring(M.raw.length),H.push(M);continue}if(M=this.tokenizer.autolink(C,_e)){C=C.substring(M.raw.length),H.push(M);continue}if(!this.state.inLink&&(M=this.tokenizer.url(C,_e))){C=C.substring(M.raw.length),H.push(M);continue}if(q=C,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Pe=C.slice(1),Ie=void 0;x.options.extensions.startInline.forEach(function(Ke){Ie=Ke.call({lexer:this},Pe),typeof Ie=="number"&&Ie>=0&&(De=Math.min(De,Ie))}),De<1/0&&De>=0&&(q=C.substring(0,De+1))}(),M=this.tokenizer.inlineText(q,Se)){C=C.substring(M.raw.length),M.raw.slice(-1)!=="_"&&(we=M.raw.slice(-1)),ve=!0,U=H[H.length-1],U&&U.type==="text"?(U.raw+=M.raw,U.text+=M.text):H.push(M);continue}if(C){var Ae="Infinite loop on byte: "+C.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return H},y(T,null,[{key:"rules",get:function(){return{block:de,inline:he}}}]),T}(),re=function(){function T(B){this.options=B||te.defaults}var F=T.prototype;return F.code=function(C,H,x){var M=(H||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(C,M);U!=null&&U!==C&&(x=!0,C=U)}return C=C.replace(/\n$/,"")+`
`,M?'<pre><code class="'+this.options.langPrefix+e(M,!0)+'">'+(x?C:e(C,!0))+`</code></pre>
`:"<pre><code>"+(x?C:e(C,!0))+`</code></pre>
`},F.blockquote=function(C){return`<blockquote>
`+C+`</blockquote>
`},F.html=function(C){return C},F.heading=function(C,H,x,M){if(this.options.headerIds){var U=this.options.headerPrefix+M.slug(x);return"<h"+H+' id="'+U+'">'+C+"</h"+H+`>
`}return"<h"+H+">"+C+"</h"+H+`>
`},F.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},F.list=function(C,H,x){var M=H?"ol":"ul",U=H&&x!==1?' start="'+x+'"':"";return"<"+M+U+`>
`+C+"</"+M+`>
`},F.listitem=function(C){return"<li>"+C+`</li>
`},F.checkbox=function(C){return"<input "+(C?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},F.paragraph=function(C){return"<p>"+C+`</p>
`},F.table=function(C,H){return H&&(H="<tbody>"+H+"</tbody>"),`<table>
<thead>
`+C+`</thead>
`+H+`</table>
`},F.tablerow=function(C){return`<tr>
`+C+`</tr>
`},F.tablecell=function(C,H){var x=H.header?"th":"td",M=H.align?"<"+x+' align="'+H.align+'">':"<"+x+">";return M+C+("</"+x+`>
`)},F.strong=function(C){return"<strong>"+C+"</strong>"},F.em=function(C){return"<em>"+C+"</em>"},F.codespan=function(C){return"<code>"+C+"</code>"},F.br=function(){return this.options.xhtml?"<br/>":"<br>"},F.del=function(C){return"<del>"+C+"</del>"},F.link=function(C,H,x){if(C=S(this.options.sanitize,this.options.baseUrl,C),C===null)return x;var M='<a href="'+e(C)+'"';return H&&(M+=' title="'+H+'"'),M+=">"+x+"</a>",M},F.image=function(C,H,x){if(C=S(this.options.sanitize,this.options.baseUrl,C),C===null)return x;var M='<img src="'+C+'" alt="'+x+'"';return H&&(M+=' title="'+H+'"'),M+=this.options.xhtml?"/>":">",M},F.text=function(C){return C},T}(),se=function(){function T(){}var F=T.prototype;return F.strong=function(C){return C},F.em=function(C){return C},F.codespan=function(C){return C},F.del=function(C){return C},F.html=function(C){return C},F.text=function(C){return C},F.link=function(C,H,x){return""+x},F.image=function(C,H,x){return""+x},F.br=function(){return""},T}(),Q=function(){function T(){this.seen={}}var F=T.prototype;return F.serialize=function(C){return C.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},F.getNextSafeSlug=function(C,H){var x=C,M=0;if(this.seen.hasOwnProperty(x)){M=this.seen[C];do M++,x=C+"-"+M;while(this.seen.hasOwnProperty(x))}return H||(this.seen[C]=M,this.seen[x]=0),x},F.slug=function(C,H){H===void 0&&(H={});var x=this.serialize(C);return this.getNextSafeSlug(x,H.dryrun)},T}(),oe=function(){function T(B){this.options=B||te.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new se,this.slugger=new Q}T.parse=function(C,H){var x=new T(H);return x.parse(C)},T.parseInline=function(C,H){var x=new T(H);return x.parseInline(C)};var F=T.prototype;return F.parse=function(C,H){H===void 0&&(H=!0);var x="",M,U,q,ee,ne,ve,we,Ne,Ae,De,Pe,Ie,Ke,xe,ze,Je,it,Me,Ve,j=C.length;for(M=0;M<j;M++){if(De=C[M],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(Ve=this.options.extensions.renderers[De.type].call({parser:this},De),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){x+=Ve||"";continue}switch(De.type){case"space":continue;case"hr":{x+=this.renderer.hr();continue}case"heading":{x+=this.renderer.heading(this.parseInline(De.tokens),De.depth,s(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{x+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(Ne="",we="",ee=De.header.length,U=0;U<ee;U++)we+=this.renderer.tablecell(this.parseInline(De.header[U].tokens),{header:!0,align:De.align[U]});for(Ne+=this.renderer.tablerow(we),Ae="",ee=De.rows.length,U=0;U<ee;U++){for(ve=De.rows[U],we="",ne=ve.length,q=0;q<ne;q++)we+=this.renderer.tablecell(this.parseInline(ve[q].tokens),{header:!1,align:De.align[q]});Ae+=this.renderer.tablerow(we)}x+=this.renderer.table(Ne,Ae);continue}case"blockquote":{Ae=this.parse(De.tokens),x+=this.renderer.blockquote(Ae);continue}case"list":{for(Pe=De.ordered,Ie=De.start,Ke=De.loose,ee=De.items.length,Ae="",U=0;U<ee;U++)ze=De.items[U],Je=ze.checked,it=ze.task,xe="",ze.task&&(Me=this.renderer.checkbox(Je),Ke?ze.tokens.length>0&&ze.tokens[0].type==="paragraph"?(ze.tokens[0].text=Me+" "+ze.tokens[0].text,ze.tokens[0].tokens&&ze.tokens[0].tokens.length>0&&ze.tokens[0].tokens[0].type==="text"&&(ze.tokens[0].tokens[0].text=Me+" "+ze.tokens[0].tokens[0].text)):ze.tokens.unshift({type:"text",text:Me}):xe+=Me),xe+=this.parse(ze.tokens,Ke),Ae+=this.renderer.listitem(xe,it,Je);x+=this.renderer.list(Ae,Pe,Ie);continue}case"html":{x+=this.renderer.html(De.text);continue}case"paragraph":{x+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ae=De.tokens?this.parseInline(De.tokens):De.text;M+1<j&&C[M+1].type==="text";)De=C[++M],Ae+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);x+=H?this.renderer.paragraph(Ae):Ae;continue}default:{var le='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(le);return}else throw new Error(le)}}}return x},F.parseInline=function(C,H){H=H||this.renderer;var x="",M,U,q,ee=C.length;for(M=0;M<ee;M++){if(U=C[M],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&(q=this.options.extensions.renderers[U.type].call({parser:this},U),q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(U.type))){x+=q||"";continue}switch(U.type){case"escape":{x+=H.text(U.text);break}case"html":{x+=H.html(U.text);break}case"link":{x+=H.link(U.href,U.title,this.parseInline(U.tokens,H));break}case"image":{x+=H.image(U.href,U.title,U.text);break}case"strong":{x+=H.strong(this.parseInline(U.tokens,H));break}case"em":{x+=H.em(this.parseInline(U.tokens,H));break}case"codespan":{x+=H.codespan(U.text);break}case"br":{x+=H.br();break}case"del":{x+=H.del(this.parseInline(U.tokens,H));break}case"text":{x+=H.text(U.text);break}default:{var ne='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return x},T}();function V(T,F,B){if(typeof T>"u"||T===null)throw new Error("marked(): input parameter is undefined or null");if(typeof T!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(T)+", string expected");if(typeof F=="function"&&(B=F,F=null),F=m({},V.defaults,F||{}),J(F),B){var C=F.highlight,H;try{H=Oe.lex(T,F)}catch(ee){return B(ee)}var x=function(ne){var ve;if(!ne)try{F.walkTokens&&V.walkTokens(H,F.walkTokens),ve=oe.parse(H,F)}catch(we){ne=we}return F.highlight=C,ne?B(ne):B(null,ve)};if(!C||C.length<3||(delete F.highlight,!H.length))return x();var M=0;V.walkTokens(H,function(ee){ee.type==="code"&&(M++,setTimeout(function(){C(ee.text,ee.lang,function(ne,ve){if(ne)return x(ne);ve!=null&&ve!==ee.text&&(ee.text=ve,ee.escaped=!0),M--,M===0&&x()})},0))}),M===0&&x();return}function U(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,F.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}try{var q=Oe.lex(T,F);if(F.walkTokens){if(F.async)return Promise.all(V.walkTokens(q,F.walkTokens)).then(function(){return oe.parse(q,F)}).catch(U);V.walkTokens(q,F.walkTokens)}return oe.parse(q,F)}catch(ee){U(ee)}}V.options=V.setOptions=function(T){return m(V.defaults,T),_(V.defaults),V},V.getDefaults=b,V.defaults=te.defaults,V.use=function(){for(var T=arguments.length,F=new Array(T),B=0;B<T;B++)F[B]=arguments[B];var C=m.apply(void 0,[{}].concat(F)),H=V.defaults.extensions||{renderers:{},childTokens:{}},x;F.forEach(function(M){if(M.extensions&&(x=!0,M.extensions.forEach(function(q){if(!q.name)throw new Error("extension name required");if(q.renderer){var ee=H.renderers?H.renderers[q.name]:null;ee?H.renderers[q.name]=function(){for(var ne=arguments.length,ve=new Array(ne),we=0;we<ne;we++)ve[we]=arguments[we];var Ne=q.renderer.apply(this,ve);return Ne===!1&&(Ne=ee.apply(this,ve)),Ne}:H.renderers[q.name]=q.renderer}if(q.tokenizer){if(!q.level||q.level!=="block"&&q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");H[q.level]?H[q.level].unshift(q.tokenizer):H[q.level]=[q.tokenizer],q.start&&(q.level==="block"?H.startBlock?H.startBlock.push(q.start):H.startBlock=[q.start]:q.level==="inline"&&(H.startInline?H.startInline.push(q.start):H.startInline=[q.start]))}q.childTokens&&(H.childTokens[q.name]=q.childTokens)})),M.renderer&&function(){var q=V.defaults.renderer||new re,ee=function(we){var Ne=q[we];q[we]=function(){for(var Ae=arguments.length,De=new Array(Ae),Pe=0;Pe<Ae;Pe++)De[Pe]=arguments[Pe];var Ie=M.renderer[we].apply(q,De);return Ie===!1&&(Ie=Ne.apply(q,De)),Ie}};for(var ne in M.renderer)ee(ne);C.renderer=q}(),M.tokenizer&&function(){var q=V.defaults.tokenizer||new ue,ee=function(we){var Ne=q[we];q[we]=function(){for(var Ae=arguments.length,De=new Array(Ae),Pe=0;Pe<Ae;Pe++)De[Pe]=arguments[Pe];var Ie=M.tokenizer[we].apply(q,De);return Ie===!1&&(Ie=Ne.apply(q,De)),Ie}};for(var ne in M.tokenizer)ee(ne);C.tokenizer=q}(),M.walkTokens){var U=V.defaults.walkTokens;C.walkTokens=function(q){var ee=[];return ee.push(M.walkTokens.call(this,q)),U&&(ee=ee.concat(U.call(this,q))),ee}}x&&(C.extensions=H),V.setOptions(C)})},V.walkTokens=function(T,F){for(var B=[],C=function(){var U=x.value;switch(B=B.concat(F.call(V,U)),U.type){case"table":{for(var q=z(U.header),ee;!(ee=q()).done;){var ne=ee.value;B=B.concat(V.walkTokens(ne.tokens,F))}for(var ve=z(U.rows),we;!(we=ve()).done;)for(var Ne=we.value,Ae=z(Ne),De;!(De=Ae()).done;){var Pe=De.value;B=B.concat(V.walkTokens(Pe.tokens,F))}break}case"list":{B=B.concat(V.walkTokens(U.items,F));break}default:V.defaults.extensions&&V.defaults.extensions.childTokens&&V.defaults.extensions.childTokens[U.type]?V.defaults.extensions.childTokens[U.type].forEach(function(Ie){B=B.concat(V.walkTokens(U[Ie],F))}):U.tokens&&(B=B.concat(V.walkTokens(U.tokens,F)))}},H=z(T),x;!(x=H()).done;)C();return B},V.parseInline=function(T,F){if(typeof T>"u"||T===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof T!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(T)+", string expected");F=m({},V.defaults,F||{}),J(F);try{var B=Oe.lexInline(T,F);return F.walkTokens&&V.walkTokens(B,F.walkTokens),oe.parseInline(B,F)}catch(C){if(C.message+=`
Please report this to https://github.com/markedjs/marked.`,F.silent)return"<p>An error occurred:</p><pre>"+e(C.message+"",!0)+"</pre>";throw C}},V.Parser=oe,V.parser=oe.parse,V.Renderer=re,V.TextRenderer=se,V.Lexer=Oe,V.lexer=Oe.lex,V.Tokenizer=ue,V.Slugger=Q,V.parse=V;var K=V.options,A=V.setOptions,W=V.use,N=V.walkTokens,d=V.parseInline,R=V,$=oe.parse,Z=Oe.lex;te.Lexer=Oe,te.Parser=oe,te.Renderer=re,te.Slugger=Q,te.TextRenderer=se,te.Tokenizer=ue,te.getDefaults=b,te.lexer=Z,te.marked=V,te.options=K,te.parse=R,te.parseInline=d,te.parser=$,te.setOptions=A,te.use=W,te.walkTokens=N,Object.defineProperty(te,"__esModule",{value:!0})}),define(me[77],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class y{constructor(i,z=0,b=i.length,_=z-1){this.items=i,this.start=z,this.end=b,this.index=_}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=y}),define(me[78],pe([1,0,77]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class k{constructor(b=[],_=10){this._initialize(b),this._limit=_,this._onChange()}getHistory(){return this._elements}add(b){this._history.delete(b),this._history.add(b),this._onChange()}next(){return this._navigator.next()}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}isFirst(){return this._currentPosition()===0}isLast(){return this._currentPosition()>=this._elements.length-1}isNowhere(){return this._navigator.current()===null}has(b){return this._history.has(b)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const b=this._elements;this._navigator=new y.ArrayNavigator(b,0,b.length,b.length)}_reduceToLimit(){const b=this._elements;b.length>this._limit&&this._initialize(b.slice(b.length-this._limit))}_currentPosition(){const b=this._navigator.current();return b?this._elements.indexOf(b):-1}_initialize(b){this._history=new Set;for(const _ of b)this._history.add(_)}get _elements(){const b=[];return this._history.forEach(_=>b.push(_)),b}}t.HistoryNavigator=k;class i{constructor(b,_=10){if(this.capacity=_,b.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:b[0],previous:void 0,next:void 0},this.valueSet=new Set([b[0]]);for(let c=1;c<b.length;c++)this.add(b[c])}add(b){const _={value:b,previous:this.tail,next:void 0};for(this.tail.next=_,this.tail=_,this.cursor=this.tail,this.size++,this.valueSet.has(b)?this._deleteFromList(b):this.valueSet.add(b);this.size>this.capacity;)this.valueSet.delete(this.head.value),this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(b){if(this.tail.value===b)return b;const _=this.tail.value;return this.valueSet.delete(_),this.tail.value=b,this.valueSet.has(b)?this._deleteFromList(b):this.valueSet.add(b),_}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(b){return this.valueSet.has(b)}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let b=this.head;for(;b;)yield b.value,b=b.next}_deleteFromList(b){let _=this.head;for(;_!==this.tail;)_.value===b&&(_===this.head?(this.head=this.head.next,this.head.previous=void 0):(_.previous.next=_.next,_.next.previous=_.previous),this.size--),_=_.next}}t.HistoryNavigator2=i}),define(me[44],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function y(_,c,l){return Math.min(Math.max(_,c),l)}t.clamp=y;function k(_,c){return(c+_%c)%c}t.rot=k;class i{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=i;class z{constructor(){this._n=1,this._val=0}update(c){return this._val=this._val+(c-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=z;class b{constructor(c){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(c),this._values.fill(0,0,c)}update(c){const l=this._values[this._index];return this._values[this._index]=c,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=c,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=b}),define(me[45],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var y;(function(k){function i(c,l){if(c.start>=l.end||l.start>=c.end)return{start:0,end:0};const h=Math.max(c.start,l.start),P=Math.min(c.end,l.end);return P-h<=0?{start:0,end:0}:{start:h,end:P}}k.intersect=i;function z(c){return c.end-c.start<=0}k.isEmpty=z;function b(c,l){return!z(i(c,l))}k.intersects=b;function _(c,l){const h=[],P={start:c.start,end:Math.min(l.start,c.end)},r={start:Math.max(l.end,c.start),end:c.end};return z(P)||h.push(P),z(r)||h.push(r),h}k.relativeComplement=_})(y||(t.Range=y={}))}),define(me[79],pe([1,0,45]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function k(c,l){const h=[];for(const P of l){if(c.start>=P.range.end)continue;if(c.end<P.range.start)break;const r=y.Range.intersect(c,P.range);y.Range.isEmpty(r)||h.push({range:r,size:P.size})}return h}t.groupIntersect=k;function i({start:c,end:l},h){return{start:c+h,end:l+h}}t.shift=i;function z(c){const l=[];let h=null;for(const P of c){const r=P.range.start,a=P.range.end,e=P.size;if(h&&e===h.size){h.range.end=a;continue}h={range:{start:r,end:a},size:e},l.push(h)}return l}t.consolidate=z;function b(...c){return z(c.reduce((l,h)=>l.concat(h),[]))}class _{constructor(){this.groups=[],this._size=0}splice(l,h,P=[]){const r=P.length-h,a=k({start:0,end:l},this.groups),e=k({start:l+h,end:Number.POSITIVE_INFINITY},this.groups).map(s=>({range:i(s.range,r),size:s.size})),o=P.map((s,u)=>({range:{start:l+u,end:l+u+1},size:s.size}));this.groups=b(a,o,e),this._size=this.groups.reduce((s,u)=>s+u.size*(u.range.end-u.range.start),0)}get count(){const l=this.groups.length;return l?this.groups[l-1].range.end:0}get size(){return this._size}indexAt(l){if(l<0)return-1;let h=0,P=0;for(const r of this.groups){const a=r.range.end-r.range.start,e=P+a*r.size;if(l<e)return h+Math.floor((l-P)/r.size);h+=a,P=e}return h}indexAfter(l){return Math.min(this.indexAt(l)+1,this.count)}positionAt(l){if(l<0)return-1;let h=0,P=0;for(const r of this.groups){const a=r.range.end-r.range.start,e=P+a;if(l<e)return h+(l-P)*r.size;h+=a*r.size,P=e}return-1}}t.RangeMap=_}),define(me[80],pe([1,0,7,2]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function i(w){const S=w;return S?typeof S.read=="function":!1}t.isReadable=i;function z(w){const S=w;return S?[S.on,S.pause,S.resume,S.destroy].every(f=>typeof f=="function"):!1}t.isReadableStream=z;function b(w){const S=w;return S?z(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}t.isReadableBufferedStream=b;function _(w,S){return new c(w,S)}t.newWriteableStream=_;class c{constructor(S,f){this.reducer=S,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S<"u"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(f=>f(S))}emitError(S){this.listeners.error.length===0?(0,y.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(f=>f(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,f){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(S,f){if(this.state.destroyed)return;let v;switch(S){case"data":v=this.listeners.data;break;case"end":v=this.listeners.end;break;case"error":v=this.listeners.error;break}if(v){const L=v.indexOf(f);L>=0&&v.splice(L,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(v=>v())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(w,S){const f=[];let v;for(;(v=w.read())!==null;)f.push(v);return S(f)}t.consumeReadable=l;function h(w,S,f){const v=[];let L;for(;(L=w.read())!==null&&v.length<f;)v.push(L);return L===null&&v.length>0?S(v):{read:()=>{if(v.length>0)return v.shift();if(typeof L<"u"){const I=L;return L=void 0,I}return w.read()}}}t.peekReadable=h;function P(w,S){return new Promise((f,v)=>{const L=[];r(w,{onData:I=>{S&&L.push(I)},onError:I=>{S?v(I):f(void 0)},onEnd:()=>{f(S?S(L):void 0)}})})}t.consumeStream=P;function r(w,S){let f=!1;return w.on("error",v=>{f||S.onError(v)}),w.on("end",()=>{f||S.onEnd()}),w.on("data",v=>{f||S.onData(v)}),(0,k.toDisposable)(()=>f=!0)}t.listenStream=r;function a(w,S){return new Promise((f,v)=>{const L=new k.DisposableStore,I=[],E=p=>{if(I.push(p),I.length>S)return L.dispose(),w.pause(),f({stream:w,buffer:I,ended:!1})},g=p=>v(p),m=()=>f({stream:w,buffer:I,ended:!0});L.add((0,k.toDisposable)(()=>w.removeListener("error",g))),w.on("error",g),L.add((0,k.toDisposable)(()=>w.removeListener("end",m))),w.on("end",m),L.add((0,k.toDisposable)(()=>w.removeListener("data",E))),w.on("data",E)})}t.peekStream=a;function e(w,S){const f=_(S);return f.end(w),f}t.toStream=e;function o(){const w=_(()=>{throw new Error("not supported")});return w.end(),w}t.emptyStream=o;function s(w){let S=!1;return{read:()=>S?null:(S=!0,w)}}t.toReadable=s;function u(w,S,f){const v=_(f);return r(w,{onData:L=>v.write(S.data(L)),onError:L=>v.error(S.error?S.error(L):L),onEnd:()=>v.end()}),v}t.transform=u;function n(w,S,f){let v=!1;return{read:()=>{const L=S.read();return v?L:(v=!0,L!==null?f([w,L]):w)}}}t.prefixedReadable=n;function D(w,S,f){let v=!1;const L=_(f);return r(S,{onData:I=>v?L.write(I):(v=!0,L.write(f([w,I]))),onError:I=>L.error(I),onEnd:()=>{v||(v=!0,L.write(w)),L.end()}}),L}t.prefixedStream=D}),define(me[30],pe([1,0,80]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const k=typeof Buffer<"u";let i,z;class b{static alloc(p){return k?new b(Buffer.allocUnsafe(p)):new b(new Uint8Array(p))}static wrap(p){return k&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new b(p)}static fromString(p,O){return!(O?.dontUseNodeBuffer||!1)&&k?new b(Buffer.from(p)):(i||(i=new TextEncoder),new b(i.encode(p)))}static fromByteArray(p){const O=b.alloc(p.length);for(let G=0,J=p.length;G<J;G++)O.buffer[G]=p[G];return O}static concat(p,O){if(typeof O>"u"){O=0;for(let ie=0,ae=p.length;ie<ae;ie++)O+=p[ie].byteLength}const G=b.alloc(O);let J=0;for(let ie=0,ae=p.length;ie<ae;ie++){const ge=p[ie];G.set(ge,J),J+=ge.byteLength}return G}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=b.alloc(this.byteLength);return p.set(this),p}toString(){return k?this.buffer.toString():(z||(z=new TextDecoder),z.decode(this.buffer))}slice(p,O){return new b(this.buffer.subarray(p,O))}set(p,O){if(p instanceof b)this.buffer.set(p.buffer,O);else if(p instanceof Uint8Array)this.buffer.set(p,O);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),O);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return l(this.buffer,p)}writeUInt32BE(p,O){h(this.buffer,p,O)}readUInt32LE(p){return P(this.buffer,p)}writeUInt32LE(p,O){r(this.buffer,p,O)}readUInt8(p){return a(this.buffer,p)}writeUInt8(p,O){e(this.buffer,p,O)}}t.VSBuffer=b;function _(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0}t.readUInt16LE=_;function c(m,p,O){m[O+0]=p&255,p=p>>>8,m[O+1]=p&255}t.writeUInt16LE=c;function l(m,p){return m[p]*2**24+m[p+1]*2**16+m[p+2]*2**8+m[p+3]}t.readUInt32BE=l;function h(m,p,O){m[O+3]=p,p=p>>>8,m[O+2]=p,p=p>>>8,m[O+1]=p,p=p>>>8,m[O]=p}t.writeUInt32BE=h;function P(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0|m[p+2]<<16>>>0|m[p+3]<<24>>>0}t.readUInt32LE=P;function r(m,p,O){m[O+0]=p&255,p=p>>>8,m[O+1]=p&255,p=p>>>8,m[O+2]=p&255,p=p>>>8,m[O+3]=p&255}t.writeUInt32LE=r;function a(m,p){return m[p]}t.readUInt8=a;function e(m,p,O){m[O]=p}t.writeUInt8=e;function o(m){return y.consumeReadable(m,p=>b.concat(p))}t.readableToBuffer=o;function s(m){return y.toReadable(m)}t.bufferToReadable=s;function u(m){return y.consumeStream(m,p=>b.concat(p))}t.streamToBuffer=u;async function n(m){return m.ended?b.concat(m.buffer):b.concat([...m.buffer,await u(m.stream)])}t.bufferedStreamToBuffer=n;function D(m){return y.toStream(m,p=>b.concat(p))}t.bufferToStream=D;function w(m){return y.transform(m,{data:p=>typeof p=="string"?b.fromString(p):b.wrap(p)},p=>b.concat(p))}t.streamToBufferReadableStream=w;function S(m){return y.newWriteableStream(p=>b.concat(p),m)}t.newWriteableBufferStream=S;function f(m,p){return y.prefixedReadable(m,p,O=>b.concat(O))}t.prefixedBufferReadable=f;function v(m,p){return y.prefixedStream(m,p,O=>b.concat(O))}t.prefixedBufferStream=v;function L(m){let p=0,O=0,G=0;const J=new Uint8Array(Math.floor(m.length/4*3)),ie=ge=>{switch(O){case 3:J[G++]=p|ge,O=0;break;case 2:J[G++]=p|ge>>>2,p=ge<<6,O=3;break;case 1:J[G++]=p|ge>>>4,p=ge<<4,O=2;break;default:p=ge<<2,O=1}};for(let ge=0;ge<m.length;ge++){const ue=m.charCodeAt(ge);if(ue>=65&&ue<=90)ie(ue-65);else if(ue>=97&&ue<=122)ie(ue-97+26);else if(ue>=48&&ue<=57)ie(ue-48+52);else if(ue===43||ue===45)ie(62);else if(ue===47||ue===95)ie(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${m[ge]}`)}}const ae=G;for(;O>0;)ie(0);return b.wrap(J).slice(0,ae)}t.decodeBase64=L;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:m},p=!0,O=!1){const G=O?E:I;let J="";const ie=m.byteLength%3;let ae=0;for(;ae<m.byteLength-ie;ae+=3){const ge=m[ae+0],ue=m[ae+1],de=m[ae+2];J+=G[ge>>>2],J+=G[(ge<<4|ue>>>4)&63],J+=G[(ue<<2|de>>>6)&63],J+=G[de&63]}if(ie===1){const ge=m[ae+0];J+=G[ge>>>2],J+=G[ge<<4&63],p&&(J+="==")}else if(ie===2){const ge=m[ae+0],ue=m[ae+1];J+=G[ge>>>2],J+=G[(ge<<4|ue>>>4)&63],J+=G[ue<<2&63],p&&(J+="=")}return J}t.encodeBase64=g}),define(me[46],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(me[6],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function y(v){return typeof v=="string"}t.isString=y;function k(v){return Array.isArray(v)&&v.every(L=>y(L))}t.isStringArray=k;function i(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}t.isObject=i;function z(v){const L=Object.getPrototypeOf(Uint8Array);return typeof v=="object"&&v instanceof L}t.isTypedArray=z;function b(v){return typeof v=="number"&&!isNaN(v)}t.isNumber=b;function _(v){return!!v&&typeof v[Symbol.iterator]=="function"}t.isIterable=_;function c(v){return v===!0||v===!1}t.isBoolean=c;function l(v){return typeof v>"u"}t.isUndefined=l;function h(v){return!P(v)}t.isDefined=h;function P(v){return l(v)||v===null}t.isUndefinedOrNull=P;function r(v,L){if(!v)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}t.assertType=r;function a(v){if(P(v))throw new Error("Assertion Failed: argument is undefined or null");return v}t.assertIsDefined=a;function e(...v){const L=[];for(let I=0;I<v.length;I++){const E=v[I];if(P(E))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);L.push(E)}return L}t.assertAllDefined=e;const o=Object.prototype.hasOwnProperty;function s(v){if(!i(v))return!1;for(const L in v)if(o.call(v,L))return!1;return!0}t.isEmptyObject=s;function u(v){return typeof v=="function"}t.isFunction=u;function n(...v){return v.length>0&&v.every(u)}t.areFunctions=n;function D(v,L){const I=Math.min(v.length,L.length);for(let E=0;E<I;E++)w(v[E],L[E])}t.validateConstraints=D;function w(v,L){if(y(L)){if(typeof v!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(u(L)){try{if(v instanceof L)return}catch{}if(!P(v)&&v.constructor===L||L.length===1&&L.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=w;function S(v){return v===null?void 0:v}t.withNullAsUndefined=S;function f(v){return typeof v>"u"?null:v}t.withUndefinedAsNull=f}),define(me[16],pe([1,0,6]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const k=Object.create(null);function i(_,c){if((0,y.isString)(c)){const l=k[c];if(l===void 0)throw new Error(`${_} references an unknown codicon: ${c}`);c=l}return k[_]=c,{id:_}}function z(){return k}t.getCodiconFontCharacters=z;function b(){return Object.values(t.Codicon)}t.getAllCodicons=b,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(me[47],pe([1,0,6]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function k(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const n=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([D,w])=>{n[D]=w&&typeof w=="object"?k(w):w}),n}t.deepClone=k;function i(u){if(!u||typeof u!="object")return u;const n=[u];for(;n.length>0;){const D=n.shift();Object.freeze(D);for(const w in D)if(z.call(D,w)){const S=D[w];typeof S=="object"&&!Object.isFrozen(S)&&!(0,y.isTypedArray)(S)&&n.push(S)}}return u}t.deepFreeze=i;const z=Object.prototype.hasOwnProperty;function b(u,n){return _(u,n,new Set)}t.cloneAndChange=b;function _(u,n,D){if((0,y.isUndefinedOrNull)(u))return u;const w=n(u);if(typeof w<"u")return w;if(Array.isArray(u)){const S=[];for(const f of u)S.push(_(f,n,D));return S}if((0,y.isObject)(u)){if(D.has(u))throw new Error("Cannot clone recursive data-structure");D.add(u);const S={};for(const f in u)z.call(u,f)&&(S[f]=_(u[f],n,D));return D.delete(u),S}return u}function c(u,n,D=!0){return(0,y.isObject)(u)?((0,y.isObject)(n)&&Object.keys(n).forEach(w=>{w in u?D&&((0,y.isObject)(u[w])&&(0,y.isObject)(n[w])?c(u[w],n[w],D):u[w]=n[w]):u[w]=n[w]}),u):n}t.mixin=c;function l(u,n){if(u===n)return!0;if(u==null||n===null||n===void 0||typeof u!=typeof n||typeof u!="object"||Array.isArray(u)!==Array.isArray(n))return!1;let D,w;if(Array.isArray(u)){if(u.length!==n.length)return!1;for(D=0;D<u.length;D++)if(!l(u[D],n[D]))return!1}else{const S=[];for(w in u)S.push(w);S.sort();const f=[];for(w in n)f.push(w);if(f.sort(),!l(S,f))return!1;for(D=0;D<S.length;D++)if(!l(u[S[D]],n[S[D]]))return!1}return!0}t.equals=l;function h(u){const n=new Set;return JSON.stringify(u,(D,w)=>{if((0,y.isObject)(w)||Array.isArray(w)){if(n.has(w))return"[Circular]";n.add(w)}return w})}t.safeStringify=h;function P(u,n){const D=Object.create(null);return!u||!n||Object.keys(n).forEach(S=>{const f=u[S],v=n[S];l(f,v)||(D[S]=v)}),D}t.distinct=P;function r(u,n){const D=n.toLowerCase(),w=Object.keys(u).find(S=>S.toLowerCase()===D);return w?u[w]:u[n]}t.getCaseInsensitive=r;function a(u,n){const D=Object.create(null);for(const[w,S]of Object.entries(u))n(w,S)&&(D[w]=S);return D}t.filter=a;function e(u){let n=[],D=Object.getPrototypeOf(u);for(;Object.prototype!==D;)n=n.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return n}t.getAllPropertyNames=e;function o(u){const n=[];for(const D of e(u))typeof u[D]=="function"&&n.push(D);return n}t.getAllMethodNames=o;function s(u,n){const D=S=>function(){const f=Array.prototype.slice.call(arguments,0);return n(S,f)},w={};for(const S of u)w[S]=D(S);return w}t.createProxyObject=s}),define(me[17],pe([1,0,16]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.themeColorFromId=t.ThemeColor=void 0;var k;(function(b){function _(c){return c&&typeof c=="object"&&typeof c.id=="string"}b.isThemeColor=_})(k||(t.ThemeColor=k={}));function i(b){return{id:b}}t.themeColorFromId=i;var z;(function(b){b.iconNameSegment="[A-Za-z0-9]+",b.iconNameExpression="[A-Za-z0-9-]+",b.iconModifierExpression="~[A-Za-z]+",b.iconNameCharacter="[A-Za-z0-9~-]";const _=new RegExp(`^(${b.iconNameExpression})(${b.iconModifierExpression})?$`);function c(n){const D=_.exec(n.id);if(!D)return c(y.Codicon.error);const[,w,S]=D,f=["codicon","codicon-"+w];return S&&f.push("codicon-modifier-"+S.substring(1)),f}b.asClassNameArray=c;function l(n){return c(n).join(" ")}b.asClassName=l;function h(n){return"."+c(n).join(".")}b.asCSSSelector=h;function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||k.isThemeColor(n.color))}b.isThemeIcon=P;const r=new RegExp(`^\\$\\((${b.iconNameExpression}(?:${b.iconModifierExpression})?)\\)$`);function a(n){const D=r.exec(n);if(!D)return;const[,w]=D;return{id:w}}b.fromString=a;function e(n){return{id:n}}b.fromId=e;function o(n,D){let w=n.id;const S=w.lastIndexOf("~");return S!==-1&&(w=w.substring(0,S)),D&&(w=`${w}~${D}`),{id:w}}b.modify=o;function s(n){const D=n.id.lastIndexOf("~");if(D!==-1)return n.id.substring(D+1)}b.getModifier=s;function u(n,D){return n.id===D.id&&n.color?.id===D.color?.id}b.isEqual=u})(z||(t.ThemeIcon=z={}))}),define(me[81],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(me[82],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class y{constructor(i,z){this.sender=i,this.onMessage=z}send(i){try{this.sender.send("vscode:message",i.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=y}),define(me[48],pe([8]),{}),define(me[83],pe([8]),{}),define(me[84],pe([8]),{}),define(me[85],pe([8]),{}),define(me[86],pe([1,0,84,85]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(me[87],pe([8]),{}),define(me[88],pe([8]),{}),define(me[89],pe([8]),{}),define(me[90],pe([8]),{}),define(me[91],pe([8]),{}),define(me[92],pe([8]),{}),define(me[93],pe([8]),{}),define(me[94],pe([8]),{}),define(me[95],pe([8]),{}),define(me[96],pe([12,10]),function(te,t){return te.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[97],pe([12,10]),function(te,t){return te.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[98],pe([12,10]),function(te,t){return te.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[99],pe([12,10]),function(te,t){return te.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(me[100],pe([12,10]),function(te,t){return te.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[101],pe([12,10]),function(te,t){return te.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[102],pe([12,10]),function(te,t){return te.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[103],pe([12,10]),function(te,t){return te.create("vs/base/common/actions",t)}),define(me[104],pe([12,10]),function(te,t){return te.create("vs/base/common/platform",t)}),define(me[5],pe([1,0,104]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let k=!1,i=!1,z=!1,b=!1,_=!1,c=!1,l=!1,h=!1,P=!1,r=!1,a,e=t.LANGUAGE_DEFAULT,o=t.LANGUAGE_DEFAULT,s,u;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let n;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?n=t.globals.vscode.process:typeof process<"u"&&(n=process);const D=typeof n?.versions?.electron=="string",w=D&&n?.type==="renderer";if(typeof navigator=="object"&&!w)u=navigator.userAgent,k=u.indexOf("Windows")>=0,i=u.indexOf("Macintosh")>=0,h=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,z=u.indexOf("Linux")>=0,r=u?.indexOf("Mobi")>=0,c=!0,a=y.getConfiguredDefaultLocale(y.localize(0,null))||t.LANGUAGE_DEFAULT,e=a,o=navigator.language;else if(typeof n=="object"){k=n.platform==="win32",i=n.platform==="darwin",z=n.platform==="linux",b=z&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,l=D,P=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const p=n.env.VSCODE_NLS_CONFIG;if(p)try{const O=JSON.parse(p),G=O.availableLanguages["*"];a=O.locale,o=O.osLocale,e=G||t.LANGUAGE_DEFAULT,s=O._translationsConfigFile}catch{}_=!0}else console.error("Unable to resolve platform.");var S;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(S||(t.Platform=S={}));function f(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=f;let v=0;i?v=1:k?v=3:z&&(v=2),t.isWindows=k,t.isMacintosh=i,t.isLinux=z,t.isLinuxSnap=b,t.isNative=_,t.isElectron=l,t.isWeb=c,t.isWebWorker=c&&typeof t.globals.importScripts=="function",t.isIOS=h,t.isMobile=r,t.isCI=P,t.platform=v,t.userAgent=u,t.language=e;var L;(function(p){function O(){return t.language}p.value=O;function G(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}p.isDefaultVariant=G;function J(){return t.language==="en"}p.isDefault=J})(L||(t.Language=L={})),t.locale=a,t.platformLocale=o,t.translationsConfigFile=s,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const p=[];t.globals.addEventListener("message",G=>{if(G.data&&G.data.vscodeScheduleAsyncWork)for(let J=0,ie=p.length;J<ie;J++){const ae=p[J];if(ae.id===G.data.vscodeScheduleAsyncWork){p.splice(J,1),ae.callback();return}}});let O=0;return G=>{const J=++O;p.push({id:J,callback:G}),t.globals.postMessage({vscodeScheduleAsyncWork:J},"*")}}return p=>setTimeout(p)})();var I;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(I||(t.OperatingSystem=I={})),t.OS=i||h?2:k?1:3;let E=!0,g=!1;function m(){if(!g){g=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,E=new Uint16Array(p.buffer)[0]===(2<<8)+1}return E}t.isLittleEndian=m,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(me[105],pe([1,0,5]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let k;if(typeof y.globals.vscode<"u"&&typeof y.globals.vscode.process<"u"){const i=y.globals.vscode.process;k={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=k.cwd,t.env=k.env,t.platform=k.platform,t.arch=k.arch}),define(me[22],pe([1,0,105]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const k=65,i=97,z=90,b=122,_=46,c=47,l=92,h=58,P=63;class r extends Error{constructor(v,L,I){let E;typeof L=="string"&&L.indexOf("not ")===0?(E="must not be",L=L.replace(/^not /,"")):E="must be";const g=v.indexOf(".")!==-1?"property":"argument";let m=`The "${v}" ${g} ${E} of type ${L}`;m+=`. Received type ${typeof I}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function a(f,v){if(f===null||typeof f!="object")throw new r(v,"Object",f)}function e(f,v){if(typeof f!="string")throw new r(v,"string",f)}const o=y.platform==="win32";function s(f){return f===c||f===l}function u(f){return f===c}function n(f){return f>=k&&f<=z||f>=i&&f<=b}function D(f,v,L,I){let E="",g=0,m=-1,p=0,O=0;for(let G=0;G<=f.length;++G){if(G<f.length)O=f.charCodeAt(G);else{if(I(O))break;O=c}if(I(O)){if(!(m===G-1||p===1))if(p===2){if(E.length<2||g!==2||E.charCodeAt(E.length-1)!==_||E.charCodeAt(E.length-2)!==_){if(E.length>2){const J=E.lastIndexOf(L);J===-1?(E="",g=0):(E=E.slice(0,J),g=E.length-1-E.lastIndexOf(L)),m=G,p=0;continue}else if(E.length!==0){E="",g=0,m=G,p=0;continue}}v&&(E+=E.length>0?`${L}..`:"..",g=2)}else E.length>0?E+=`${L}${f.slice(m+1,G)}`:E=f.slice(m+1,G),g=G-m-1;m=G,p=0}else O===_&&p!==-1?++p:p=-1}return E}function w(f,v){a(v,"pathObject");const L=v.dir||v.root,I=v.base||`${v.name||""}${v.ext||""}`;return L?L===v.root?`${L}${I}`:`${L}${f}${I}`:I}t.win32={resolve(...f){let v="",L="",I=!1;for(let E=f.length-1;E>=-1;E--){let g;if(E>=0){if(g=f[E],e(g,"path"),g.length===0)continue}else v.length===0?g=y.cwd():(g=y.env[`=${v}`]||y.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==v.toLowerCase()&&g.charCodeAt(2)===l)&&(g=`${v}\\`));const m=g.length;let p=0,O="",G=!1;const J=g.charCodeAt(0);if(m===1)s(J)&&(p=1,G=!0);else if(s(J))if(G=!0,s(g.charCodeAt(1))){let ie=2,ae=ie;for(;ie<m&&!s(g.charCodeAt(ie));)ie++;if(ie<m&&ie!==ae){const ge=g.slice(ae,ie);for(ae=ie;ie<m&&s(g.charCodeAt(ie));)ie++;if(ie<m&&ie!==ae){for(ae=ie;ie<m&&!s(g.charCodeAt(ie));)ie++;(ie===m||ie!==ae)&&(O=`\\\\${ge}\\${g.slice(ae,ie)}`,p=ie)}}}else p=1;else n(J)&&g.charCodeAt(1)===h&&(O=g.slice(0,2),p=2,m>2&&s(g.charCodeAt(2))&&(G=!0,p=3));if(O.length>0)if(v.length>0){if(O.toLowerCase()!==v.toLowerCase())continue}else v=O;if(I){if(v.length>0)break}else if(L=`${g.slice(p)}\\${L}`,I=G,G&&v.length>0)break}return L=D(L,!I,"\\",s),I?`${v}\\${L}`:`${v}${L}`||"."},normalize(f){e(f,"path");const v=f.length;if(v===0)return".";let L=0,I,E=!1;const g=f.charCodeAt(0);if(v===1)return u(g)?"\\":f;if(s(g))if(E=!0,s(f.charCodeAt(1))){let p=2,O=p;for(;p<v&&!s(f.charCodeAt(p));)p++;if(p<v&&p!==O){const G=f.slice(O,p);for(O=p;p<v&&s(f.charCodeAt(p));)p++;if(p<v&&p!==O){for(O=p;p<v&&!s(f.charCodeAt(p));)p++;if(p===v)return`\\\\${G}\\${f.slice(O)}\\`;p!==O&&(I=`\\\\${G}\\${f.slice(O,p)}`,L=p)}}}else L=1;else n(g)&&f.charCodeAt(1)===h&&(I=f.slice(0,2),L=2,v>2&&s(f.charCodeAt(2))&&(E=!0,L=3));let m=L<v?D(f.slice(L),!E,"\\",s):"";return m.length===0&&!E&&(m="."),m.length>0&&s(f.charCodeAt(v-1))&&(m+="\\"),I===void 0?E?`\\${m}`:m:E?`${I}\\${m}`:`${I}${m}`},isAbsolute(f){e(f,"path");const v=f.length;if(v===0)return!1;const L=f.charCodeAt(0);return s(L)||v>2&&n(L)&&f.charCodeAt(1)===h&&s(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let v,L;for(let g=0;g<f.length;++g){const m=f[g];e(m,"path"),m.length>0&&(v===void 0?v=L=m:v+=`\\${m}`)}if(v===void 0)return".";let I=!0,E=0;if(typeof L=="string"&&s(L.charCodeAt(0))){++E;const g=L.length;g>1&&s(L.charCodeAt(1))&&(++E,g>2&&(s(L.charCodeAt(2))?++E:I=!1))}if(I){for(;E<v.length&&s(v.charCodeAt(E));)E++;E>=2&&(v=`\\${v.slice(E)}`)}return t.win32.normalize(v)},relative(f,v){if(e(f,"from"),e(v,"to"),f===v)return"";const L=t.win32.resolve(f),I=t.win32.resolve(v);if(L===I||(f=L.toLowerCase(),v=I.toLowerCase(),f===v))return"";let E=0;for(;E<f.length&&f.charCodeAt(E)===l;)E++;let g=f.length;for(;g-1>E&&f.charCodeAt(g-1)===l;)g--;const m=g-E;let p=0;for(;p<v.length&&v.charCodeAt(p)===l;)p++;let O=v.length;for(;O-1>p&&v.charCodeAt(O-1)===l;)O--;const G=O-p,J=m<G?m:G;let ie=-1,ae=0;for(;ae<J;ae++){const ue=f.charCodeAt(E+ae);if(ue!==v.charCodeAt(p+ae))break;ue===l&&(ie=ae)}if(ae!==J){if(ie===-1)return I}else{if(G>J){if(v.charCodeAt(p+ae)===l)return I.slice(p+ae+1);if(ae===2)return I.slice(p+ae)}m>J&&(f.charCodeAt(E+ae)===l?ie=ae:ae===2&&(ie=3)),ie===-1&&(ie=0)}let ge="";for(ae=E+ie+1;ae<=g;++ae)(ae===g||f.charCodeAt(ae)===l)&&(ge+=ge.length===0?"..":"\\..");return p+=ie,ge.length>0?`${ge}${I.slice(p,O)}`:(I.charCodeAt(p)===l&&++p,I.slice(p,O))},toNamespacedPath(f){if(typeof f!="string"||f.length===0)return f;const v=t.win32.resolve(f);if(v.length<=2)return f;if(v.charCodeAt(0)===l){if(v.charCodeAt(1)===l){const L=v.charCodeAt(2);if(L!==P&&L!==_)return`\\\\?\\UNC\\${v.slice(2)}`}}else if(n(v.charCodeAt(0))&&v.charCodeAt(1)===h&&v.charCodeAt(2)===l)return`\\\\?\\${v}`;return f},dirname(f){e(f,"path");const v=f.length;if(v===0)return".";let L=-1,I=0;const E=f.charCodeAt(0);if(v===1)return s(E)?f:".";if(s(E)){if(L=I=1,s(f.charCodeAt(1))){let p=2,O=p;for(;p<v&&!s(f.charCodeAt(p));)p++;if(p<v&&p!==O){for(O=p;p<v&&s(f.charCodeAt(p));)p++;if(p<v&&p!==O){for(O=p;p<v&&!s(f.charCodeAt(p));)p++;if(p===v)return f;p!==O&&(L=I=p+1)}}}}else n(E)&&f.charCodeAt(1)===h&&(L=v>2&&s(f.charCodeAt(2))?3:2,I=L);let g=-1,m=!0;for(let p=v-1;p>=I;--p)if(s(f.charCodeAt(p))){if(!m){g=p;break}}else m=!1;if(g===-1){if(L===-1)return".";g=L}return f.slice(0,g)},basename(f,v){v!==void 0&&e(v,"ext"),e(f,"path");let L=0,I=-1,E=!0,g;if(f.length>=2&&n(f.charCodeAt(0))&&f.charCodeAt(1)===h&&(L=2),v!==void 0&&v.length>0&&v.length<=f.length){if(v===f)return"";let m=v.length-1,p=-1;for(g=f.length-1;g>=L;--g){const O=f.charCodeAt(g);if(s(O)){if(!E){L=g+1;break}}else p===-1&&(E=!1,p=g+1),m>=0&&(O===v.charCodeAt(m)?--m===-1&&(I=g):(m=-1,I=p))}return L===I?I=p:I===-1&&(I=f.length),f.slice(L,I)}for(g=f.length-1;g>=L;--g)if(s(f.charCodeAt(g))){if(!E){L=g+1;break}}else I===-1&&(E=!1,I=g+1);return I===-1?"":f.slice(L,I)},extname(f){e(f,"path");let v=0,L=-1,I=0,E=-1,g=!0,m=0;f.length>=2&&f.charCodeAt(1)===h&&n(f.charCodeAt(0))&&(v=I=2);for(let p=f.length-1;p>=v;--p){const O=f.charCodeAt(p);if(s(O)){if(!g){I=p+1;break}continue}E===-1&&(g=!1,E=p+1),O===_?L===-1?L=p:m!==1&&(m=1):L!==-1&&(m=-1)}return L===-1||E===-1||m===0||m===1&&L===E-1&&L===I+1?"":f.slice(L,E)},format:w.bind(null,"\\"),parse(f){e(f,"path");const v={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return v;const L=f.length;let I=0,E=f.charCodeAt(0);if(L===1)return s(E)?(v.root=v.dir=f,v):(v.base=v.name=f,v);if(s(E)){if(I=1,s(f.charCodeAt(1))){let ie=2,ae=ie;for(;ie<L&&!s(f.charCodeAt(ie));)ie++;if(ie<L&&ie!==ae){for(ae=ie;ie<L&&s(f.charCodeAt(ie));)ie++;if(ie<L&&ie!==ae){for(ae=ie;ie<L&&!s(f.charCodeAt(ie));)ie++;ie===L?I=ie:ie!==ae&&(I=ie+1)}}}}else if(n(E)&&f.charCodeAt(1)===h){if(L<=2)return v.root=v.dir=f,v;if(I=2,s(f.charCodeAt(2))){if(L===3)return v.root=v.dir=f,v;I=3}}I>0&&(v.root=f.slice(0,I));let g=-1,m=I,p=-1,O=!0,G=f.length-1,J=0;for(;G>=I;--G){if(E=f.charCodeAt(G),s(E)){if(!O){m=G+1;break}continue}p===-1&&(O=!1,p=G+1),E===_?g===-1?g=G:J!==1&&(J=1):g!==-1&&(J=-1)}return p!==-1&&(g===-1||J===0||J===1&&g===p-1&&g===m+1?v.base=v.name=f.slice(m,p):(v.name=f.slice(m,g),v.base=f.slice(m,p),v.ext=f.slice(g,p))),m>0&&m!==I?v.dir=f.slice(0,m-1):v.dir=v.root,v},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(o){const f=/\\/g;return()=>{const v=y.cwd().replace(f,"/");return v.slice(v.indexOf("/"))}}return()=>y.cwd()})();t.posix={resolve(...f){let v="",L=!1;for(let I=f.length-1;I>=-1&&!L;I--){const E=I>=0?f[I]:S();e(E,"path"),E.length!==0&&(v=`${E}/${v}`,L=E.charCodeAt(0)===c)}return v=D(v,!L,"/",u),L?`/${v}`:v.length>0?v:"."},normalize(f){if(e(f,"path"),f.length===0)return".";const v=f.charCodeAt(0)===c,L=f.charCodeAt(f.length-1)===c;return f=D(f,!v,"/",u),f.length===0?v?"/":L?"./":".":(L&&(f+="/"),v?`/${f}`:f)},isAbsolute(f){return e(f,"path"),f.length>0&&f.charCodeAt(0)===c},join(...f){if(f.length===0)return".";let v;for(let L=0;L<f.length;++L){const I=f[L];e(I,"path"),I.length>0&&(v===void 0?v=I:v+=`/${I}`)}return v===void 0?".":t.posix.normalize(v)},relative(f,v){if(e(f,"from"),e(v,"to"),f===v||(f=t.posix.resolve(f),v=t.posix.resolve(v),f===v))return"";const L=1,I=f.length,E=I-L,g=1,m=v.length-g,p=E<m?E:m;let O=-1,G=0;for(;G<p;G++){const ie=f.charCodeAt(L+G);if(ie!==v.charCodeAt(g+G))break;ie===c&&(O=G)}if(G===p)if(m>p){if(v.charCodeAt(g+G)===c)return v.slice(g+G+1);if(G===0)return v.slice(g+G)}else E>p&&(f.charCodeAt(L+G)===c?O=G:G===0&&(O=0));let J="";for(G=L+O+1;G<=I;++G)(G===I||f.charCodeAt(G)===c)&&(J+=J.length===0?"..":"/..");return`${J}${v.slice(g+O)}`},toNamespacedPath(f){return f},dirname(f){if(e(f,"path"),f.length===0)return".";const v=f.charCodeAt(0)===c;let L=-1,I=!0;for(let E=f.length-1;E>=1;--E)if(f.charCodeAt(E)===c){if(!I){L=E;break}}else I=!1;return L===-1?v?"/":".":v&&L===1?"//":f.slice(0,L)},basename(f,v){v!==void 0&&e(v,"ext"),e(f,"path");let L=0,I=-1,E=!0,g;if(v!==void 0&&v.length>0&&v.length<=f.length){if(v===f)return"";let m=v.length-1,p=-1;for(g=f.length-1;g>=0;--g){const O=f.charCodeAt(g);if(O===c){if(!E){L=g+1;break}}else p===-1&&(E=!1,p=g+1),m>=0&&(O===v.charCodeAt(m)?--m===-1&&(I=g):(m=-1,I=p))}return L===I?I=p:I===-1&&(I=f.length),f.slice(L,I)}for(g=f.length-1;g>=0;--g)if(f.charCodeAt(g)===c){if(!E){L=g+1;break}}else I===-1&&(E=!1,I=g+1);return I===-1?"":f.slice(L,I)},extname(f){e(f,"path");let v=-1,L=0,I=-1,E=!0,g=0;for(let m=f.length-1;m>=0;--m){const p=f.charCodeAt(m);if(p===c){if(!E){L=m+1;break}continue}I===-1&&(E=!1,I=m+1),p===_?v===-1?v=m:g!==1&&(g=1):v!==-1&&(g=-1)}return v===-1||I===-1||g===0||g===1&&v===I-1&&v===L+1?"":f.slice(v,I)},format:w.bind(null,"/"),parse(f){e(f,"path");const v={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return v;const L=f.charCodeAt(0)===c;let I;L?(v.root="/",I=1):I=0;let E=-1,g=0,m=-1,p=!0,O=f.length-1,G=0;for(;O>=I;--O){const J=f.charCodeAt(O);if(J===c){if(!p){g=O+1;break}continue}m===-1&&(p=!1,m=O+1),J===_?E===-1?E=O:G!==1&&(G=1):E!==-1&&(G=-1)}if(m!==-1){const J=g===0&&L?1:g;E===-1||G===0||G===1&&E===m-1&&E===g+1?v.base=v.name=f.slice(J,m):(v.name=f.slice(J,E),v.base=f.slice(J,m),v.ext=f.slice(E,m))}return g>0?v.dir=f.slice(0,g-1):L&&(v.dir="/"),v},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=o?t.win32.normalize:t.posix.normalize,t.isAbsolute=o?t.win32.isAbsolute:t.posix.isAbsolute,t.join=o?t.win32.join:t.posix.join,t.resolve=o?t.win32.resolve:t.posix.resolve,t.relative=o?t.win32.relative:t.posix.relative,t.dirname=o?t.win32.dirname:t.posix.dirname,t.basename=o?t.win32.basename:t.posix.basename,t.extname=o?t.win32.extname:t.posix.extname,t.format=o?t.win32.format:t.posix.format,t.parse=o?t.win32.parse:t.posix.parse,t.toNamespacedPath=o?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=o?t.win32.sep:t.posix.sep,t.delimiter=o?t.win32.delimiter:t.posix.delimiter}),define(me[106],pe([1,0,22]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function z(h){const P=(0,y.extname)(h),r=k[P.toLowerCase()];return r!==void 0?r:b(h)}t.getMediaOrTextMime=z;function b(h){const P=(0,y.extname)(h);return i[P.toLowerCase()]}t.getMediaMime=b;function _(h){for(const P in i)if(i[P]===h)return P}t.getExtensionForMimeType=_;const c=/^(.+)\/(.+?)(;.+)?$/;function l(h,P){const r=c.exec(h);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:P?void 0:h}t.normalizeMimeType=l}),define(me[107],pe([1,0,5]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const k=y.globals.performance&&typeof y.globals.performance.now=="function";class i{static create(b=!0){return new i(b)}constructor(b){this._highResolution=k&&b,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}t.StopWatch=i}),define(me[3],pe([1,0,7,40,2,43,107]),function(te,t,y,k,i,z,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const _=!1,c=!1;var l;(function(g){g.None=()=>i.Disposable.None;function m($){if(c){const{onDidAddListener:Z}=$,T=e.create();let F=0;$.onDidAddListener=()=>{++F===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),T.print()),Z?.()}}}function p($,Z){return he($,()=>{},0,void 0,!0,void 0,Z)}g.defer=p;function O($){return(Z,T=null,F)=>{let B=!1,C;return C=$(H=>{if(!B)return C?C.dispose():B=!0,Z.call(T,H)},null,F),B&&C.dispose(),C}}g.once=O;function G($,Z,T){return de((F,B=null,C)=>$(H=>F.call(B,Z(H)),null,C),T)}g.map=G;function J($,Z,T){return de((F,B=null,C)=>$(H=>{Z(H),F.call(B,H)},null,C),T)}g.forEach=J;function ie($,Z,T){return de((F,B=null,C)=>$(H=>Z(H)&&F.call(B,H),null,C),T)}g.filter=ie;function ae($){return $}g.signal=ae;function ge(...$){return(Z,T=null,F)=>(0,i.combinedDisposable)(...$.map(B=>B(C=>Z.call(T,C),null,F)))}g.any=ge;function ue($,Z,T,F){let B=T;return G($,C=>(B=Z(B,C),B),F)}g.reduce=ue;function de($,Z){let T;const F={onWillAddFirstListener(){T=$(B.fire,B)},onDidRemoveLastListener(){T?.dispose()}};Z||m(F);const B=new s(F);return Z?.add(B),B.event}function he($,Z,T=100,F=!1,B=!1,C,H){let x,M,U,q=0,ee;const ne={leakWarningThreshold:C,onWillAddFirstListener(){x=$(we=>{q++,M=Z(M,we),F&&!U&&(ve.fire(M),M=void 0),ee=()=>{const Ne=M;M=void 0,U=void 0,(!F||q>1)&&ve.fire(Ne),q=0},typeof T=="number"?(clearTimeout(U),U=setTimeout(ee,T)):U===void 0&&(U=0,queueMicrotask(ee))})},onWillRemoveListener(){B&&q>0&&ee?.()},onDidRemoveLastListener(){ee=void 0,x.dispose()}};H||m(ne);const ve=new s(ne);return H?.add(ve),ve.event}g.debounce=he;function Se($,Z=0,T){return g.debounce($,(F,B)=>F?(F.push(B),F):[B],Z,void 0,!0,void 0,T)}g.accumulate=Se;function _e($,Z=(F,B)=>F===B,T){let F=!0,B;return ie($,C=>{const H=F||!Z(C,B);return F=!1,B=C,H},T)}g.latch=_e;function Oe($,Z,T){return[g.filter($,Z,T),g.filter($,F=>!Z(F),T)]}g.split=Oe;function re($,Z=!1,T=[]){let F=T.slice(),B=$(x=>{F?F.push(x):H.fire(x)});const C=()=>{F?.forEach(x=>H.fire(x)),F=null},H=new s({onWillAddFirstListener(){B||(B=$(x=>H.fire(x)))},onDidAddFirstListener(){F&&(Z?setTimeout(C):C())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return H.event}g.buffer=re;class se{constructor(Z){this.event=Z,this.disposables=new i.DisposableStore}map(Z){return new se(G(this.event,Z,this.disposables))}forEach(Z){return new se(J(this.event,Z,this.disposables))}filter(Z){return new se(ie(this.event,Z,this.disposables))}reduce(Z,T){return new se(ue(this.event,Z,T,this.disposables))}latch(){return new se(_e(this.event,void 0,this.disposables))}debounce(Z,T=100,F=!1,B=!1,C){return new se(he(this.event,Z,T,F,B,C,this.disposables))}on(Z,T,F){return this.event(Z,T,F)}once(Z,T,F){return O(this.event)(Z,T,F)}dispose(){this.disposables.dispose()}}function Q($){return new se($)}g.chain=Q;function oe($,Z,T=F=>F){const F=(...x)=>H.fire(T(...x)),B=()=>$.on(Z,F),C=()=>$.removeListener(Z,F),H=new s({onWillAddFirstListener:B,onDidRemoveLastListener:C});return H.event}g.fromNodeEventEmitter=oe;function V($,Z,T=F=>F){const F=(...x)=>H.fire(T(...x)),B=()=>$.addEventListener(Z,F),C=()=>$.removeEventListener(Z,F),H=new s({onWillAddFirstListener:B,onDidRemoveLastListener:C});return H.event}g.fromDOMEventEmitter=V;function K($){return new Promise(Z=>O($)(Z))}g.toPromise=K;function A($,Z){return Z(void 0),$(T=>Z(T))}g.runAndSubscribe=A;function W($,Z){let T=null;function F(C){T?.dispose(),T=new i.DisposableStore,Z(C,T)}F(void 0);const B=$(C=>F(C));return(0,i.toDisposable)(()=>{B.dispose(),T?.dispose()})}g.runAndSubscribeWithStore=W;class N{constructor(Z,T){this._observable=Z,this._counter=0,this._hasChanged=!1;const F={onWillAddFirstListener:()=>{Z.addObserver(this)},onDidRemoveLastListener:()=>{Z.removeObserver(this)}};T||m(F),this.emitter=new s(F),T&&T.add(this.emitter)}beginUpdate(Z){this._counter++}handlePossibleChange(Z){}handleChange(Z,T){this._hasChanged=!0}endUpdate(Z){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function d($,Z){return new N($,Z).emitter.event}g.fromObservable=d;function R($){return Z=>{let T=0,F=!1;const B={beginUpdate(){T++},endUpdate(){T--,T===0&&($.reportChanges(),F&&(F=!1,Z()))},handlePossibleChange(){},handleChange(){F=!0}};return $.addObserver(B),{dispose(){$.removeObserver(B)}}}}g.fromObservableLight=R})(l||(t.Event=l={}));class h{constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${h._idPool++}`,h.all.add(this)}start(m){this._stopWatch=new b.StopWatch(!0),this.listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=h,h.all=new Set,h._idPool=0;let P=-1;function r(g){const m=P;return P=g,{dispose(){P=m}}}t.setGlobalLeakWarningThreshold=r;class a{constructor(m,p=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=p,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(m,p){const O=this.threshold;if(O<=0||p<O)return;this._stacks||(this._stacks=new Map);const G=this._stacks.get(m.value)||0;if(this._stacks.set(m.value,G+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=O*.5;let J,ie=0;for(const[ae,ge]of this._stacks)(!J||ie<ge)&&(J=ae,ie=ge);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${ie}):`),console.warn(J)}return()=>{const J=this._stacks.get(m.value)||0;this._stacks.set(m.value,J-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class o{constructor(m,p,O){this.callback=m,this.callbackThis=p,this.stack=O,this.subscription=new i.SafeDisposable}invoke(m){this.callback.call(this.callbackThis,m)}}class s{constructor(m){this._disposed=!1,this._options=m,this._leakageMon=P>0||this._options?.leakWarningThreshold?new a(this._options?.leakWarningThreshold??P):void 0,this._perfMon=this._options?._profName?new h(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(_){const m=Array.from(this._listeners);queueMicrotask(()=>{for(const p of m)p.subscription.isset()&&(p.subscription.unset(),p.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(m,p,O)=>{if(this._listeners||(this._listeners=new z.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const G=this._listeners.isEmpty();G&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let J,ie;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(ie=e.create(),J=this._leakageMon.check(ie,this._listeners.size+1)),_&&(ie=ie??e.create());const ae=new o(m,p,ie),ge=this._listeners.push(ae);G&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,m,p);const ue=ae.subscription.set(()=>{J?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),ge(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return O instanceof i.DisposableStore?O.add(ue):Array.isArray(O)&&O.push(ue),ue}),this._event}fire(m){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new n(this._options?.onListenerError));for(const p of this._listeners)this._deliveryQueue.push(this,p,m);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=s;class u{constructor(m=y.onUnexpectedError){this._onListenerError=m,this._queue=new z.LinkedList}get size(){return this._queue.size}push(m,p,O){this._queue.push(new D(m,p,O))}clear(m){const p=new z.LinkedList;for(const O of this._queue)O.emitter!==m&&p.push(O);this._queue=p}deliver(){for(;this._queue.size>0;){const m=this._queue.shift();try{m.listener.invoke(m.event)}catch(p){this._onListenerError(p)}}}}t.EventDeliveryQueue=u;class n extends u{clear(m){this._queue.clear()}}class D{constructor(m,p,O){this.emitter=m,this.listener=p,this.event=O}}class w extends s{async fireAsync(m,p,O){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new z.LinkedList);for(const G of this._listeners)this._asyncDeliveryQueue.push([G,m]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[G,J]=this._asyncDeliveryQueue.shift(),ie=[],ae={...J,token:p,waitUntil:ge=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");O&&(ge=O(ge,G.callback)),ie.push(ge)}};try{G.invoke(ae)}catch(ge){(0,y.onUnexpectedError)(ge);continue}Object.freeze(ie),await Promise.allSettled(ie).then(ge=>{for(const ue of ge)ue.status==="rejected"&&(0,y.onUnexpectedError)(ue.reason)})}}}}t.AsyncEmitter=w;class S extends s{constructor(m){super(m),this._isPaused=0,this._eventQueue=new z.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._listeners&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}t.PauseableEmitter=S;class f extends S{constructor(m){super(m),this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}t.DebounceEmitter=f;class v extends s{constructor(m){super(m),this._queuedEvents=[],this._mergeFn=m?.merge}fire(m){this.hasListeners()&&(this._queuedEvents.push(m),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(p=>super.fire(p)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=v;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new s({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const p={event:m,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const O=()=>{this.hasListeners&&this.unhook(p);const G=this.events.indexOf(p);this.events.splice(G,1)};return(0,i.toDisposable)((0,k.once)(O))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(p=>this.emitter.fire(p))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=L;class I{constructor(){this.buffers=[]}wrapEvent(m){return(p,O,G)=>m(J=>{const ie=this.buffers[this.buffers.length-1];ie?ie.push(()=>p.call(O,J)):p.call(O,J)},void 0,G)}bufferEvents(m){const p=[];this.buffers.push(p);const O=m();return this.buffers.pop(),p.forEach(G=>G()),O}}t.EventBufferer=I;class E{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=i.Disposable.None,this.emitter=new s({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=E}),define(me[18],pe([1,0,3,2]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class i{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new y.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(w,S){this._zoomLevel!==w&&(this._zoomLevel=w)}getZoomFactor(){return this._zoomFactor}setZoomFactor(w){this._zoomFactor=w}setFullscreen(w){this._fullscreen!==w&&(this._fullscreen=w,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}i.INSTANCE=new i;class z extends k.Disposable{constructor(){super(),this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(w){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),w&&this._onDidChange.fire()}}class b extends k.Disposable{get value(){return this._value}constructor(){super(),this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const w=this._register(new z);this._register(w.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}_getPixelRatio(){const w=document.createElement("canvas").getContext("2d"),S=window.devicePixelRatio||1,f=w.webkitBackingStorePixelRatio||w.mozBackingStorePixelRatio||w.msBackingStorePixelRatio||w.oBackingStorePixelRatio||w.backingStorePixelRatio||1;return S/f}}class _{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,k.markAsSingleton)(new b)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function c(D,w){typeof D=="string"&&(D=window.matchMedia(D)),D.addEventListener("change",w)}t.addMatchMediaChangeListener=c,t.PixelRatio=new _;function l(D,w){i.INSTANCE.setZoomLevel(D,w)}t.setZoomLevel=l;function h(){return i.INSTANCE.getZoomLevel()}t.getZoomLevel=h;function P(){return i.INSTANCE.getZoomFactor()}t.getZoomFactor=P;function r(D){i.INSTANCE.setZoomFactor(D)}t.setZoomFactor=r;function a(D){i.INSTANCE.setFullscreen(D)}t.setFullscreen=a;function e(){return i.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=i.INSTANCE.onDidChangeFullscreen;const o=navigator.userAgent;t.isFirefox=o.indexOf("Firefox")>=0,t.isWebKit=o.indexOf("AppleWebKit")>=0,t.isChrome=o.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&o.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=o.indexOf("Electron/")>=0,t.isAndroid=o.indexOf("Android")>=0;let s=!1;if(window.matchMedia){const D=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),w=window.matchMedia("(display-mode: fullscreen)");s=D.matches,c(D,({matches:S})=>{s&&w.matches||(s=S)})}function u(){return s}t.isStandalone=u;function n(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=n}),define(me[108],pe([1,0,18,5]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var i;(function(z){z[z.Always=0]="Always",z[z.FullScreen=1]="FullScreen",z[z.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.BrowserFeatures={clipboard:{writeText:k.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:k.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>k.isNative||y.isStandalone()?0:navigator.keyboard||y.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(me[20],pe([1,0,3]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class k{get event(){return this.emitter.event}constructor(z,b,_){const c=l=>this.emitter.fire(l);this.emitter=new y.Emitter({onWillAddFirstListener:()=>z.addEventListener(b,c,_),onDidRemoveLastListener:()=>z.removeEventListener(b,c,_)})}dispose(){this.emitter.dispose()}}t.DomEmitter=k}),define(me[14],pe([1,0,18,41,74,5]),function(te,t,y,k,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function b(e){if(e.charCode){const s=String.fromCharCode(e.charCode).toUpperCase();return k.KeyCodeUtils.fromString(s)}const o=e.keyCode;if(o===3)return 7;if(y.isFirefox)switch(o){case 59:return 85;case 60:if(z.isLinux)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(z.isMacintosh)return 57;break}else if(y.isWebKit){if(z.isMacintosh&&o===93)return 57;if(!z.isMacintosh&&o===92)return 57}return k.EVENT_KEY_CODE_MAP[o]||0}const _=z.isMacintosh?256:2048,c=512,l=1024,h=z.isMacintosh?2048:256;function P(e){const o=[];return e.ctrlKey&&o.push("ctrl"),e.shiftKey&&o.push("shift"),e.altKey&&o.push("alt"),e.metaKey&&o.push("meta"),`modifiers: [${o.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=P;function r(e){const o=[];return e.ctrlKey&&o.push("ctrl"),e.shiftKey&&o.push("shift"),e.altKey&&o.push("alt"),e.metaKey&&o.push("meta"),`modifiers: [${o.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${k.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=r;class a{constructor(o){this._standardKeyboardEventBrand=!0;const s=o;this.browserEvent=s,this.target=s.target,this.ctrlKey=s.ctrlKey,this.shiftKey=s.shiftKey,this.altKey=s.altKey,this.metaKey=s.metaKey,this.altGraphKey=s.getModifierState("AltGraph"),this.keyCode=b(s),this.code=s.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asKeyCodeChord=this._computeKeyCodeChord()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this._asKeyCodeChord}equals(o){return this._asKeybinding===o}_computeKeybinding(){let o=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(o=this.keyCode);let s=0;return this.ctrlKey&&(s|=_),this.altKey&&(s|=c),this.shiftKey&&(s|=l),this.metaKey&&(s|=h),s|=o,s}_computeKeyCodeChord(){let o=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(o=this.keyCode),new i.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,o)}}t.StandardKeyboardEvent=a}),define(me[21],pe([1,0,18,66,5]),function(te,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class z{constructor(l){this.timestamp=Date.now(),this.browserEvent=l,this.leftButton=l.button===0,this.middleButton=l.button===1,this.rightButton=l.button===2,this.buttons=l.buttons,this.target=l.target,this.detail=l.detail||1,l.type==="dblclick"&&(this.detail=2),this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,typeof l.pageX=="number"?(this.posx=l.pageX,this.posy=l.pageY):(this.posx=l.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=l.clientY+document.body.scrollTop+document.documentElement.scrollTop);const h=k.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(window,l.view);this.posx-=h.left,this.posy-=h.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=z;class b extends z{constructor(l){super(l),this.dataTransfer=l.dataTransfer}}t.DragMouseEvent=b;class _{constructor(l,h=0,P=0){if(this.browserEvent=l||null,this.target=l?l.target||l.targetNode||l.srcElement:null,this.deltaY=P,this.deltaX=h,l){const r=l,a=l;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof a.VERTICAL_AXIS<"u"&&a.axis===a.VERTICAL_AXIS)this.deltaY=-a.detail/3;else if(l.type==="wheel"){const e=l;e.deltaMode===e.DOM_DELTA_LINE?y.isFirefox&&!i.isMacintosh?this.deltaY=-l.deltaY/3:this.deltaY=-l.deltaY:this.deltaY=-l.deltaY/40}if(typeof r.wheelDeltaX<"u")y.isSafari&&i.isWindows?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof a.HORIZONTAL_AXIS<"u"&&a.axis===a.HORIZONTAL_AXIS)this.deltaX=-l.detail/3;else if(l.type==="wheel"){const e=l;e.deltaMode===e.DOM_DELTA_LINE?y.isFirefox&&!i.isMacintosh?this.deltaX=-l.deltaX/3:this.deltaX=-l.deltaX:this.deltaX=-l.deltaX/40}this.deltaY===0&&this.deltaX===0&&l.wheelDelta&&(this.deltaY=l.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=_}),define(me[31],pe([1,0,3,2,103]),function(te,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class z extends k.Disposable{constructor(r,a="",e="",o=!0,s){super(),this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=r,this._label=a,this._cssClass=e,this._enabled=o,this._actionCallback=s}get id(){return this._id}get label(){return this._label}set label(r){this._setLabel(r)}_setLabel(r){this._label!==r&&(this._label=r,this._onDidChange.fire({label:r}))}get tooltip(){return this._tooltip||""}set tooltip(r){this._setTooltip(r)}_setTooltip(r){this._tooltip!==r&&(this._tooltip=r,this._onDidChange.fire({tooltip:r}))}get class(){return this._cssClass}set class(r){this._setClass(r)}_setClass(r){this._cssClass!==r&&(this._cssClass=r,this._onDidChange.fire({class:r}))}get enabled(){return this._enabled}set enabled(r){this._setEnabled(r)}_setEnabled(r){this._enabled!==r&&(this._enabled=r,this._onDidChange.fire({enabled:r}))}get checked(){return this._checked}set checked(r){this._setChecked(r)}_setChecked(r){this._checked!==r&&(this._checked=r,this._onDidChange.fire({checked:r}))}async run(r,a){this._actionCallback&&await this._actionCallback(r)}}t.Action=z;class b extends k.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new y.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new y.Emitter),this.onDidRun=this._onDidRun.event}async run(r,a){if(!r.enabled)return;this._onWillRun.fire({action:r});let e;try{await this.runAction(r,a)}catch(o){e=o}this._onDidRun.fire({action:r,error:e})}async runAction(r,a){await r.run(a)}}t.ActionRunner=b;class _{constructor(){this.id=_.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let a=[];for(const e of r)e.length&&(a.length?a=[...a,new _,...e]:a=e);return a}async run(){}}t.Separator=_,_.ID="vs.actions.separator";class c{get actions(){return this._actions}constructor(r,a,e,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=a,this.class=o,this._actions=e}async run(){}}t.SubmenuAction=c;class l extends z{constructor(){super(l.ID,i.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=l,l.ID="vs.actions.empty";function h(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}t.toAction=h}),define(me[27],pe([1,0,3]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const k=Object.freeze(function(_,c){const l=setTimeout(_.bind(c),0);return{dispose(){clearTimeout(l)}}});var i;(function(_){function c(l){return l===_.None||l===_.Cancelled||l instanceof z?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}_.isCancellationToken=c,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(i||(t.CancellationToken=i={}));class z{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class b{constructor(c){this._token=void 0,this._parentListener=void 0,this._parentListener=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new z),this._token}cancel(){this._token?this._token instanceof z&&this._token.cancel():this._token=i.Cancelled}dispose(c=!1){c&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof z&&this._token.dispose():this._token=i.None}}t.CancellationTokenSource=b}),define(me[109],pe([1,0,27]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class k{constructor(_){this.task=_,this.result=null}get(){if(this.result)return this.result;const _=new y.CancellationTokenSource,c=this.task(_.token);return this.result={promise:c,dispose:()=>{this.result=null,_.cancel(),_.dispose()}},this.result}}t.Cache=k;class i{constructor(_){this.fn=_,this.lastCache=void 0,this.lastArgKey=void 0}get(_){const c=JSON.stringify(_);return this.lastArgKey!==c&&(this.lastArgKey=c,this.lastCache=this.fn(_)),this.lastCache}}t.LRUCachedFunction=i;class z{get cachedValues(){return this._map}constructor(_){this.fn=_,this._map=new Map}get(_){if(this._map.has(_))return this._map.get(_);const c=this.fn(_);return this._map.set(_,c),c}}t.CachedFunction=z}),define(me[49],pe([1,0,3,2]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var i;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class z{constructor(e,o,s,u,n,D,w){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(o=o|0,s=s|0,u=u|0,n=n|0,D=D|0,w=w|0),this.rawScrollLeft=u,this.rawScrollTop=w,o<0&&(o=0),u+o>s&&(u=s-o),u<0&&(u=0),n<0&&(n=0),w+n>D&&(w=D-n),w<0&&(w=0),this.width=o,this.scrollWidth=s,this.scrollLeft=u,this.height=n,this.scrollHeight=D,this.scrollTop=w}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,o){return new z(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,o?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,o?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new z(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,o){const s=this.width!==e.width,u=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,D=this.height!==e.height,w=this.scrollHeight!==e.scrollHeight,S=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:o,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:s,scrollWidthChanged:u,scrollLeftChanged:n,heightChanged:D,scrollHeightChanged:w,scrollTopChanged:S}}}t.ScrollState=z;class b extends k.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new y.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new z(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,o){const s=this._state.withScrollDimensions(e,o);this._setState(s,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const o=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(o,!1)}setScrollPositionSmooth(e,o){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const s=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===s.scrollLeft&&this._smoothScrolling.to.scrollTop===s.scrollTop)return;let u;o?u=new h(this._smoothScrolling.from,s,this._smoothScrolling.startTime,this._smoothScrolling.duration):u=this._smoothScrolling.combine(this._state,s,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=u}else{const s=this._state.withScrollPosition(e);this._smoothScrolling=h.start(this._state,s,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),o=this._state.withScrollPosition(e);if(this._setState(o,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,o){const s=this._state;s.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(s,o)))}}t.Scrollable=b;class _{constructor(e,o,s){this.scrollLeft=e,this.scrollTop=o,this.isDone=s}}t.SmoothScrollingUpdate=_;function c(a,e){const o=e-a;return function(s){return a+o*r(s)}}function l(a,e,o){return function(s){return s<o?a(s/o):e((s-o)/(1-o))}}class h{constructor(e,o,s,u){this.from=e,this.to=o,this.duration=u,this.startTime=s,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,o,s){if(Math.abs(e-o)>2.5*s){let n,D;return e<o?(n=e+.75*s,D=o-.75*s):(n=e-.75*s,D=o+.75*s),l(c(e,n),c(D,o),.33)}return c(e,o)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const o=(e-this.startTime)/this.duration;if(o<1){const s=this.scrollLeft(o),u=this.scrollTop(o);return new _(s,u,!1)}return new _(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,o,s){return h.start(e,o,s)}static start(e,o,s){s=s+10;const u=Date.now()-10;return new h(e,o,u,s)}}t.SmoothScrollingOperation=h;function P(a){return Math.pow(a,3)}function r(a){return 1-P(1-a)}}),define(me[11],pe([1,0,109,42]),function(te,t,y,k){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function z(j){return!j||typeof j!="string"?!0:j.trim().length===0}t.isFalsyOrWhitespace=z;const b=/{(\d+)}/g;function _(j,...le){return le.length===0?j:j.replace(b,function(be,ye){const Ce=parseInt(ye,10);return isNaN(Ce)||Ce<0||Ce>=le.length?be:le[Ce]})}t.format=_;const c=/{([^}]+)}/g;function l(j,le){return j.replace(c,(be,ye)=>le[ye]??be)}t.format2=l;function h(j){return j.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}t.escape=h;function P(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=P;function r(j,le){let be=0;const ye=le.charCodeAt(0);for(let Ce=j.length-1;Ce>=0;Ce--)j.charCodeAt(Ce)===ye&&be++;return be}t.count=r;function a(j,le,be="\u2026"){return j.length<=le?j:`${j.substr(0,le)}${be}`}t.truncate=a;function e(j,le=" "){const be=o(j,le);return s(be,le)}t.trim=e;function o(j,le){if(!j||!le)return j;const be=le.length;if(be===0||j.length===0)return j;let ye=0;for(;j.indexOf(le,ye)===ye;)ye=ye+be;return j.substring(ye)}t.ltrim=o;function s(j,le){if(!j||!le)return j;const be=le.length,ye=j.length;if(be===0||ye===0)return j;let Ce=ye,Re=-1;for(;Re=j.lastIndexOf(le,Ce-1),!(Re===-1||Re+be!==Ce);){if(Re===0)return"";Ce=Re}return j.substring(0,Ce)}t.rtrim=s;function u(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=u;function n(j){return j.replace(/\*/g,"")}t.stripWildcards=n;function D(j,le,be={}){if(!j)throw new Error("Cannot create regex from empty string");le||(j=P(j)),be.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let ye="";return be.global&&(ye+="g"),be.matchCase||(ye+="i"),be.multiline&&(ye+="m"),be.unicode&&(ye+="u"),new RegExp(j,ye)}t.createRegExp=D;function w(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}t.regExpLeadsToEndlessLoop=w;function S(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=S;function f(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}t.regExpFlags=f;function v(j){return j.split(/\r\n|\r|\n/)}t.splitLines=v;function L(j){for(let le=0,be=j.length;le<be;le++){const ye=j.charCodeAt(le);if(ye!==32&&ye!==9)return le}return-1}t.firstNonWhitespaceIndex=L;function I(j,le=0,be=j.length){for(let ye=le;ye<be;ye++){const Ce=j.charCodeAt(ye);if(Ce!==32&&Ce!==9)return j.substring(le,ye)}return j.substring(le,be)}t.getLeadingWhitespace=I;function E(j,le=j.length-1){for(let be=le;be>=0;be--){const ye=j.charCodeAt(be);if(ye!==32&&ye!==9)return be}return-1}t.lastNonWhitespaceIndex=E;function g(j,le,be){const ye=[];let Ce=0;for(const Re of j.matchAll(le)){if(ye.push(j.slice(Ce,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Ce=Re.index+Re[0].length,ye.push(be(Re[0],...Re.slice(1),Re.index,j,Re.groups))}return ye.push(j.slice(Ce)),Promise.all(ye).then(Re=>Re.join(""))}t.replaceAsync=g;function m(j,le){return j<le?-1:j>le?1:0}t.compare=m;function p(j,le,be=0,ye=j.length,Ce=0,Re=le.length){for(;be<ye&&Ce<Re;be++,Ce++){const et=j.charCodeAt(be),Fe=le.charCodeAt(Ce);if(et<Fe)return-1;if(et>Fe)return 1}const Ue=ye-be,Ge=Re-Ce;return Ue<Ge?-1:Ue>Ge?1:0}t.compareSubstring=p;function O(j,le){return G(j,le,0,j.length,0,le.length)}t.compareIgnoreCase=O;function G(j,le,be=0,ye=j.length,Ce=0,Re=le.length){for(;be<ye&&Ce<Re;be++,Ce++){let et=j.charCodeAt(be),Fe=le.charCodeAt(Ce);if(et===Fe)continue;if(et>=128||Fe>=128)return p(j.toLowerCase(),le.toLowerCase(),be,ye,Ce,Re);ie(et)&&(et-=32),ie(Fe)&&(Fe-=32);const ce=et-Fe;if(ce!==0)return ce}const Ue=ye-be,Ge=Re-Ce;return Ue<Ge?-1:Ue>Ge?1:0}t.compareSubstringIgnoreCase=G;function J(j){return j>=48&&j<=57}t.isAsciiDigit=J;function ie(j){return j>=97&&j<=122}t.isLowerAsciiLetter=ie;function ae(j){return j>=65&&j<=90}t.isUpperAsciiLetter=ae;function ge(j,le){return j.length===le.length&&G(j,le)===0}t.equalsIgnoreCase=ge;function ue(j,le){const be=le.length;return le.length>j.length?!1:G(j,le,0,be)===0}t.startsWithIgnoreCase=ue;function de(j,le){const be=Math.min(j.length,le.length);let ye;for(ye=0;ye<be;ye++)if(j.charCodeAt(ye)!==le.charCodeAt(ye))return ye;return be}t.commonPrefixLength=de;function he(j,le){const be=Math.min(j.length,le.length);let ye;const Ce=j.length-1,Re=le.length-1;for(ye=0;ye<be;ye++)if(j.charCodeAt(Ce-ye)!==le.charCodeAt(Re-ye))return ye;return be}t.commonSuffixLength=he;function Se(j){return 55296<=j&&j<=56319}t.isHighSurrogate=Se;function _e(j){return 56320<=j&&j<=57343}t.isLowSurrogate=_e;function Oe(j,le){return(j-55296<<10)+(le-56320)+65536}t.computeCodePoint=Oe;function re(j,le,be){const ye=j.charCodeAt(be);if(Se(ye)&&be+1<le){const Ce=j.charCodeAt(be+1);if(_e(Ce))return Oe(ye,Ce)}return ye}t.getNextCodePoint=re;function se(j,le){const be=j.charCodeAt(le-1);if(_e(be)&&le>1){const ye=j.charCodeAt(le-2);if(Se(ye))return Oe(ye,be)}return be}class Q{get offset(){return this._offset}constructor(le,be=0){this._str=le,this._len=le.length,this._offset=be}setOffset(le){this._offset=le}prevCodePoint(){const le=se(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=re(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}t.CodePointIterator=Q;class oe{get offset(){return this._iterator.offset}constructor(le,be=0){this._iterator=new Q(le,be)}nextGraphemeLength(){const le=Ie.getInstance(),be=this._iterator,ye=be.offset;let Ce=le.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Re=be.offset,Ue=le.getGraphemeBreakType(be.nextCodePoint());if(De(Ce,Ue)){be.setOffset(Re);break}Ce=Ue}return be.offset-ye}prevGraphemeLength(){const le=Ie.getInstance(),be=this._iterator,ye=be.offset;let Ce=le.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Re=be.offset,Ue=le.getGraphemeBreakType(be.prevCodePoint());if(De(Ue,Ce)){be.setOffset(Re);break}Ce=Ue}return ye-be.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=oe;function V(j,le){return new oe(j,le).nextGraphemeLength()}t.nextCharLength=V;function K(j,le){return new oe(j,le).prevGraphemeLength()}t.prevCharLength=K;function A(j,le){le>0&&_e(j.charCodeAt(le))&&le--;const be=le+V(j,le);return[be-K(j,be),be]}t.getCharContainingOffset=A;function W(j){const le=new oe(j);let be=0;for(;!le.eol();)be++,le.nextGraphemeLength();return be}t.charCount=W;let N;function d(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function R(j){return N||(N=d()),N.test(j)}t.containsRTL=R;const $=/^[\t\n\r\x20-\x7E]*$/;function Z(j){return $.test(j)}t.isBasicASCII=Z,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function T(j){return t.UNUSUAL_LINE_TERMINATORS.test(j)}t.containsUnusualLineTerminators=T;function F(j){return j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}t.isFullWidthCharacter=F;function B(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129008||j>=129280&&j<=129535||j>=129648&&j<=129782}t.isEmojiImprecise=B;function C(j,le){if(j.length<le)return j;const be=/\b/g;let ye=0;for(;be.test(j)&&!(j.length-be.lastIndex<le);)ye=be.lastIndex,be.lastIndex+=1;return j.substring(ye).replace(/^\s/,"")}t.lcut=C;const H=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,x=/\x1b\].*?\x07/g;function M(j){return j&&(j=j.replace(H,"").replace(x,"")),j}t.removeAnsiEscapeCodes=M,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function U(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}t.startsWithUTF8BOM=U;function q(j){return U(j)?j.substr(1):j}t.stripUTF8BOM=q;function ee(j,le){if(!j||!le||j.length<le.length)return!1;const be=le.length,ye=j.toLowerCase();let Ce=0,Re=-1;for(;Ce<be;){const Ue=ye.indexOf(le[Ce],Re+1);if(Ue<0)return!1;Re=Ue,Ce++}return!0}t.fuzzyContains=ee;function ne(j,le=!1){return j?(le&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}t.containsUppercaseCharacter=ne;function ve(j){return j.charAt(0).toUpperCase()+j.slice(1)}t.uppercaseFirstLetter=ve;function we(j,le=1){if(le===0)return"";let be=-1;do be=j.indexOf(`
`,be+1),le--;while(le>0&&be>=0);return be===-1?j:(j[be-1]==="\r"&&be--,j.substr(0,be))}t.getNLines=we;function Ne(j){return j=j%(2*26),j<26?String.fromCharCode(97+j):String.fromCharCode(65+j-26)}t.singleLetterHash=Ne;function Ae(j){return Ie.getInstance().getGraphemeBreakType(j)}t.getGraphemeBreakType=Ae;function De(j,le){return j===0?le!==5&&le!==7:j===2&&le===3?!1:j===4||j===2||j===3||le===4||le===2||le===3?!0:!(j===8&&(le===8||le===9||le===11||le===12)||(j===11||j===9)&&(le===9||le===10)||(j===12||j===10)&&le===10||le===5||le===13||le===7||j===1||j===13&&le===14||j===6&&le===6)}var Pe;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(t.GraphemeBreakType=Pe={}));class Ie{static getInstance(){return Ie._INSTANCE||(Ie._INSTANCE=new Ie),Ie._INSTANCE}constructor(){this._data=Ke()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const be=this._data,ye=be.length/3;let Ce=1;for(;Ce<=ye;)if(le<be[3*Ce])Ce=2*Ce;else if(le>be[3*Ce+1])Ce=2*Ce+1;else return be[3*Ce+2];return 0}}Ie._INSTANCE=null;function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(j,le){if(j===0)return 0;const be=ze(j,le);if(be!==void 0)return be;const ye=new Q(le,j);return ye.prevCodePoint(),ye.offset}t.getLeftDeleteOffset=xe;function ze(j,le){const be=new Q(le,j);let ye=be.prevCodePoint();for(;Je(ye)||ye===65039||ye===8419;){if(be.offset===0)return;ye=be.prevCodePoint()}if(!B(ye))return;let Ce=be.offset;return Ce>0&&be.prevCodePoint()===8205&&(Ce=be.offset),Ce}function Je(j){return 127995<=j&&j<=127999}var it;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),t.noBreakWhitespace="\xA0";class Me{static getInstance(le){return Me.cache.get(Array.from(le))}static getLocales(){return Me._locales.value}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Me,i=Me,Me.ambiguousCharacterData=new k.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Me.cache=new y.LRUCachedFunction(j=>{function le(Fe){const ce=new Map;for(let Ee=0;Ee<Fe.length;Ee+=2)ce.set(Fe[Ee],Fe[Ee+1]);return ce}function be(Fe,ce){const Ee=new Map(Fe);for(const[ke,He]of ce)Ee.set(ke,He);return Ee}function ye(Fe,ce){if(!Fe)return ce;const Ee=new Map;for(const[ke,He]of Fe)ce.has(ke)&&Ee.set(ke,He);return Ee}const Ce=i.ambiguousCharacterData.value;let Re=j.filter(Fe=>!Fe.startsWith("_")&&Fe in Ce);Re.length===0&&(Re=["_default"]);let Ue;for(const Fe of Re){const ce=le(Ce[Fe]);Ue=ye(Ue,ce)}const Ge=le(Ce._common),et=be(Ge,Ue);return new Me(et)}),Me._locales=new k.Lazy(()=>Object.keys(Me.ambiguousCharacterData.value).filter(j=>!j.startsWith("_")));class Ve{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ve.getRawData())),this._data}static isInvisibleCharacter(le){return Ve.getData().has(le)}static get codePoints(){return Ve.getData()}}t.InvisibleCharacters=Ve,Ve._data=void 0}),define(me[110],pe([1,0,22,5,11,6]),function(te,t,y,k,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function b(g){return g===47||g===92}t.isPathSeparator=b;function _(g){return g.replace(/[\\/]/g,y.posix.sep)}t.toSlashes=_;function c(g){return g.indexOf("/")===-1&&(g=_(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}t.toPosixPath=c;function l(g,m=y.posix.sep){if(!g)return"";const p=g.length,O=g.charCodeAt(0);if(b(O)){if(b(g.charCodeAt(1))&&!b(g.charCodeAt(2))){let J=3;const ie=J;for(;J<p&&!b(g.charCodeAt(J));J++);if(ie!==J&&!b(g.charCodeAt(J+1))){for(J+=1;J<p;J++)if(b(g.charCodeAt(J)))return g.slice(0,J+1).replace(/[\\/]/g,m)}}return m}else if(u(O)&&g.charCodeAt(1)===58)return b(g.charCodeAt(2))?g.slice(0,2)+m:g.slice(0,2);let G=g.indexOf("://");if(G!==-1){for(G+=3;G<p;G++)if(b(g.charCodeAt(G)))return g.slice(0,G+1)}return""}t.getRoot=l;function h(g){if(!k.isWindows||!g||g.length<5)return!1;let m=g.charCodeAt(0);if(m!==92||(m=g.charCodeAt(1),m!==92))return!1;let p=2;const O=p;for(;p<g.length&&(m=g.charCodeAt(p),m!==92);p++);return!(O===p||(m=g.charCodeAt(p+1),isNaN(m)||m===92))}t.isUNC=h;const P=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(g,m=k.isWindows){const p=m?P:r;return!(!g||g.length===0||/^\s+$/.test(g)||(p.lastIndex=0,p.test(g))||m&&a.test(g)||g==="."||g===".."||m&&g[g.length-1]==="."||m&&g.length!==g.trim().length||g.length>255)}t.isValidBasename=e;function o(g,m,p){const O=g===m;return!p||O?O:!g||!m?!1:(0,i.equalsIgnoreCase)(g,m)}t.isEqual=o;function s(g,m,p,O=y.sep){if(g===m)return!0;if(!g||!m||m.length>g.length)return!1;if(p){if(!(0,i.startsWithIgnoreCase)(g,m))return!1;if(m.length===g.length)return!0;let J=m.length;return m.charAt(m.length-1)===O&&J--,g.charAt(J)===O}return m.charAt(m.length-1)!==O&&(m+=O),g.indexOf(m)===0}t.isEqualOrParent=s;function u(g){return g>=65&&g<=90||g>=97&&g<=122}t.isWindowsDriveLetter=u;function n(g,m){return k.isWindows&&g.endsWith(":")&&(g+=y.sep),(0,y.isAbsolute)(g)||(g=(0,y.join)(m,g)),g=(0,y.normalize)(g),k.isWindows?(g=(0,i.rtrim)(g,y.sep),g.endsWith(":")&&(g+=y.sep)):(g=(0,i.rtrim)(g,y.sep),g||(g=y.sep)),g}t.sanitizeFilePath=n;function D(g){const m=(0,y.normalize)(g);return k.isWindows?g.length>3?!1:w(m)&&(g.length===2||m.charCodeAt(2)===92):m===y.posix.sep}t.isRootOrDriveLetter=D;function w(g,m=k.isWindows){return m?u(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}t.hasDriveLetter=w;function S(g){return w(g)?g[0]:void 0}t.getDriveLetter=S;function f(g,m,p){return m.length>g.length?-1:g===m?0:(p&&(g=g.toLowerCase(),m=m.toLowerCase()),g.indexOf(m))}t.indexOfPath=f;function v(g){const m=g.split(":");let p,O,G;for(const J of m){const ie=Number(J);(0,z.isNumber)(ie)?O===void 0?O=ie:G===void 0&&(G=ie):p=p?[p,J].join(":"):J}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:O!==void 0?O:void 0,column:G!==void 0?G:O!==void 0?1:void 0}}t.parseLineAndColumnAware=v;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(g,m,p=8){let O="";for(let J=0;J<p;J++){let ie;J===0&&k.isWindows&&!m&&(p===3||p===4)?ie=I:ie=L,O+=ie.charAt(Math.floor(Math.random()*ie.length))}let G;return m?G=`${m}-${O}`:G=O,g?(0,y.join)(g,G):G}t.randomPath=E}),define(me[32],pe([1,0,75,11]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function i(...x){return function(M,U){for(let q=0,ee=x.length;q<ee;q++){const ne=x[q](M,U);if(ne)return ne}return null}}t.or=i,t.matchesStrictPrefix=z.bind(void 0,!1),t.matchesPrefix=z.bind(void 0,!0);function z(x,M,U){if(!U||U.length<M.length)return null;let q;return x?q=k.startsWithIgnoreCase(U,M):q=U.indexOf(M)===0,q?M.length>0?[{start:0,end:M.length}]:[]:null}function b(x,M){const U=M.toLowerCase().indexOf(x.toLowerCase());return U===-1?null:[{start:U,end:U+x.length}]}t.matchesContiguousSubString=b;function _(x,M){return c(x.toLowerCase(),M.toLowerCase(),0,0)}t.matchesSubString=_;function c(x,M,U,q){if(U===x.length)return[];if(q===M.length)return null;if(x[U]===M[q]){let ee=null;return(ee=c(x,M,U+1,q+1))?u({start:q,end:q+1},ee):null}return c(x,M,U,q+1)}function l(x){return 97<=x&&x<=122}function h(x){return 65<=x&&x<=90}t.isUpper=h;function P(x){return 48<=x&&x<=57}function r(x){return x===32||x===9||x===10||x===13}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(x=>a.add(x.charCodeAt(0)));function e(x){return r(x)||a.has(x)}function o(x,M){return x===M||e(x)&&e(M)}function s(x){return l(x)||h(x)||P(x)}function u(x,M){return M.length===0?M=[x]:x.end===M[0].start?M[0].start=x.start:M.unshift(x),M}function n(x,M){for(let U=M;U<x.length;U++){const q=x.charCodeAt(U);if(h(q)||P(q)||U>0&&!s(x.charCodeAt(U-1)))return U}return x.length}function D(x,M,U,q){if(U===x.length)return[];if(q===M.length)return null;if(x[U]!==M[q].toLowerCase())return null;{let ee=null,ne=q+1;for(ee=D(x,M,U+1,q+1);!ee&&(ne=n(M,ne))<M.length;)ee=D(x,M,U+1,ne),ne++;return ee===null?null:u({start:q,end:q+1},ee)}}function w(x){let M=0,U=0,q=0,ee=0,ne=0;for(let De=0;De<x.length;De++)ne=x.charCodeAt(De),h(ne)&&M++,l(ne)&&U++,s(ne)&&q++,P(ne)&&ee++;const ve=M/x.length,we=U/x.length,Ne=q/x.length,Ae=ee/x.length;return{upperPercent:ve,lowerPercent:we,alphaPercent:Ne,numericPercent:Ae}}function S(x){const{upperPercent:M,lowerPercent:U}=x;return U===0&&M>.6}function f(x){const{upperPercent:M,lowerPercent:U,alphaPercent:q,numericPercent:ee}=x;return U>.2&&M<.8&&q>.6&&ee<.2}function v(x){let M=0,U=0,q=0,ee=0;for(let ne=0;ne<x.length;ne++)q=x.charCodeAt(ne),h(q)&&M++,l(q)&&U++,r(q)&&ee++;return(M===0||U===0)&&ee===0?x.length<=30:M<=5}function L(x,M){if(!M||(M=M.trim(),M.length===0)||!v(x)||M.length>60)return null;const U=w(M);if(!f(U)){if(!S(U))return null;M=M.toLowerCase()}let q=null,ee=0;for(x=x.toLowerCase();ee<M.length&&(q=D(x,M,0,ee))===null;)ee=n(M,ee+1);return q}t.matchesCamelCase=L;function I(x,M,U=!1){if(!M||M.length===0)return null;let q=null,ee=0;for(x=x.toLowerCase(),M=M.toLowerCase();ee<M.length&&(q=E(x,M,0,ee,U))===null;)ee=g(M,ee+1);return q}t.matchesWords=I;function E(x,M,U,q,ee){if(U===x.length)return[];if(q===M.length)return null;if(o(x.charCodeAt(U),M.charCodeAt(q))){let ne=null,ve=q+1;if(ne=E(x,M,U+1,q+1,ee),!ee)for(;!ne&&(ve=g(M,ve))<M.length;)ne=E(x,M,U+1,ve,ee),ve++;return ne?x.charCodeAt(U)!==M.charCodeAt(q)?ne:u({start:q,end:q+1},ne):null}else return null}function g(x,M){for(let U=M;U<x.length;U++)if(e(x.charCodeAt(U))||U>0&&e(x.charCodeAt(U-1)))return U;return x.length}const m=i(t.matchesPrefix,L,b),p=i(t.matchesPrefix,L,_),O=new y.LRUCache(1e4);function G(x,M,U=!1){if(typeof x!="string"||typeof M!="string")return null;let q=O.get(x);q||(q=new RegExp(k.convertSimple2RegExpPattern(x),"i"),O.set(x,q));const ee=q.exec(M);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:U?p(x,M):m(x,M)}t.matchesFuzzy=G;function J(x,M){const U=$(x,x.toLowerCase(),0,M,M.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return U?ae(U):null}t.matchesFuzzy2=J;function ie(x,M,U,q,ee,ne){const ve=Math.min(13,x.length);for(;U<ve;U++){const we=$(x,M,U,q,ee,ne,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,ne]}t.anyScore=ie;function ae(x){if(typeof x>"u")return[];const M=[],U=x[1];for(let q=x.length-1;q>1;q--){const ee=x[q]+U,ne=M[M.length-1];ne&&ne.end===ee?ne.end=ee+1:M.push({start:ee,end:ee+1})}return M}t.createMatches=ae;const ge=128;function ue(){const x=[],M=[];for(let U=0;U<=ge;U++)M[U]=0;for(let U=0;U<=ge;U++)x.push(M.slice(0));return x}function de(x){const M=[];for(let U=0;U<=x;U++)M[U]=0;return M}const he=de(2*ge),Se=de(2*ge),_e=ue(),Oe=ue(),re=ue(),se=!1;function Q(x,M,U,q,ee){function ne(we,Ne,Ae=" "){for(;we.length<Ne;)we=Ae+we;return we}let ve=` |   |${q.split("").map(we=>ne(we,3)).join("|")}
`;for(let we=0;we<=U;we++)we===0?ve+=" |":ve+=`${M[we-1]}|`,ve+=x[we].slice(0,ee+1).map(Ne=>ne(Ne.toString(),3)).join("|")+`
`;return ve}function oe(x,M,U,q){x=x.substr(M),U=U.substr(q),console.log(Q(Oe,x,x.length,U,U.length)),console.log(Q(re,x,x.length,U,U.length)),console.log(Q(_e,x,x.length,U,U.length))}function V(x,M){if(M<0||M>=x.length)return!1;const U=x.codePointAt(M);switch(U){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(U)}}function K(x,M){if(M<0||M>=x.length)return!1;switch(x.charCodeAt(M)){case 32:case 9:return!0;default:return!1}}function A(x,M,U){return M[x]!==U[x]}function W(x,M,U,q,ee,ne,ve=!1){for(;M<U&&ee<ne;)x[M]===q[ee]&&(ve&&(he[M]=ee),M+=1),ee+=1;return M===U}t.isPatternInWord=W;var N;(function(x){x[x.Diag=1]="Diag",x[x.Left=2]="Left",x[x.LeftLeft=3]="LeftLeft"})(N||(N={}));var d;(function(x){x.Default=[-100,0];function M(U){return!U||U.length===2&&U[0]===-100&&U[1]===0}x.isDefault=M})(d||(t.FuzzyScore=d={}));class R{constructor(M,U){this.firstMatchCanBeWeak=M,this.boostFullMatch=U}}t.FuzzyScoreOptions=R,R.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function $(x,M,U,q,ee,ne,ve=R.default){const we=x.length>ge?ge:x.length,Ne=q.length>ge?ge:q.length;if(U>=we||ne>=Ne||we-U>Ne-ne||!W(M,U,we,ee,ne,Ne,!0))return;Z(we,Ne,U,ne,M,ee);let Ae=1,De=1,Pe=U,Ie=ne;const Ke=[!1];for(Ae=1,Pe=U;Pe<we;Ae++,Pe++){const Me=he[Pe],Ve=Se[Pe],j=Pe+1<we?Se[Pe+1]:Ne;for(De=Me-ne+1,Ie=Me;Ie<j;De++,Ie++){let le=Number.MIN_SAFE_INTEGER,be=!1;Ie<=Ve&&(le=T(x,M,Pe,U,q,ee,Ie,Ne,ne,_e[Ae-1][De-1]===0,Ke));let ye=0;le!==Number.MAX_SAFE_INTEGER&&(be=!0,ye=le+Oe[Ae-1][De-1]);const Ce=Ie>Me,Re=Ce?Oe[Ae][De-1]+(_e[Ae][De-1]>0?-5:0):0,Ue=Ie>Me+1&&_e[Ae][De-1]>0,Ge=Ue?Oe[Ae][De-2]+(_e[Ae][De-2]>0?-5:0):0;if(Ue&&(!Ce||Ge>=Re)&&(!be||Ge>=ye))Oe[Ae][De]=Ge,re[Ae][De]=3,_e[Ae][De]=0;else if(Ce&&(!be||Re>=ye))Oe[Ae][De]=Re,re[Ae][De]=2,_e[Ae][De]=0;else if(be)Oe[Ae][De]=ye,re[Ae][De]=1,_e[Ae][De]=_e[Ae-1][De-1]+1;else throw new Error("not possible")}}if(se&&oe(x,U,q,ne),!Ke[0]&&!ve.firstMatchCanBeWeak)return;Ae--,De--;const xe=[Oe[Ae][De],ne];let ze=0,Je=0;for(;Ae>=1;){let Me=De;do{const Ve=re[Ae][Me];if(Ve===3)Me=Me-2;else if(Ve===2)Me=Me-1;else break}while(Me>=1);ze>1&&M[U+Ae-1]===ee[ne+De-1]&&!A(Me+ne-1,q,ee)&&ze+1>_e[Ae][Me]&&(Me=De),Me===De?ze++:ze=1,Je||(Je=Me),Ae--,De=Me-1,xe.push(De)}Ne===we&&ve.boostFullMatch&&(xe[0]+=2);const it=Je-we;return xe[0]-=it,xe}t.fuzzyScore=$;function Z(x,M,U,q,ee,ne){let ve=x-1,we=M-1;for(;ve>=U&&we>=q;)ee[ve]===ne[we]&&(Se[ve]=we,ve--),we--}function T(x,M,U,q,ee,ne,ve,we,Ne,Ae,De){if(M[U]!==ne[ve])return Number.MIN_SAFE_INTEGER;let Pe=1,Ie=!1;return ve===U-q?Pe=x[U]===ee[ve]?7:5:A(ve,ee,ne)&&(ve===0||!A(ve-1,ee,ne))?(Pe=x[U]===ee[ve]?7:5,Ie=!0):V(ne,ve)&&(ve===0||!V(ne,ve-1))?Pe=5:(V(ne,ve-1)||K(ne,ve-1))&&(Pe=5,Ie=!0),Pe>1&&U===q&&(De[0]=!0),Ie||(Ie=A(ve,ee,ne)||V(ne,ve-1)||K(ne,ve-1)),U===q?ve>Ne&&(Pe-=Ie?3:5):Ae?Pe+=Ie?2:0:Pe+=Ie?0:1,ve+1===we&&(Pe-=Ie?3:5),Pe}function F(x,M,U,q,ee,ne,ve){return C(x,M,U,q,ee,ne,!0,ve)}t.fuzzyScoreGracefulAggressive=F;function B(x,M,U,q,ee,ne,ve){return C(x,M,U,q,ee,ne,!1,ve)}t.fuzzyScoreGraceful=B;function C(x,M,U,q,ee,ne,ve,we){let Ne=$(x,M,U,q,ee,ne,we);if(Ne&&!ve)return Ne;if(x.length>=3){const Ae=Math.min(7,x.length-1);for(let De=U+1;De<Ae;De++){const Pe=H(x,De);if(Pe){const Ie=$(Pe,Pe.toLowerCase(),U,q,ee,ne,we);Ie&&(Ie[0]-=3,(!Ne||Ie[0]>Ne[0])&&(Ne=Ie))}}}return Ne}function H(x,M){if(M+1>=x.length)return;const U=x[M],q=x[M+1];if(U!==q)return x.slice(0,M)+q+U+x.slice(M+2)}}),define(me[111],pe([1,0,11]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function k(u){return i(u,0)}t.hash=k;function i(u,n){switch(typeof u){case"object":return u===null?z(349,n):Array.isArray(u)?c(u,n):l(u,n);case"string":return _(u,n);case"boolean":return b(u,n);case"number":return z(u,n);case"undefined":return z(937,n);default:return z(617,n)}}t.doHash=i;function z(u,n){return(n<<5)-n+u|0}t.numberHash=z;function b(u,n){return z(u?433:863,n)}function _(u,n){n=z(149417,n);for(let D=0,w=u.length;D<w;D++)n=z(u.charCodeAt(D),n);return n}t.stringHash=_;function c(u,n){return n=z(104579,n),u.reduce((D,w)=>i(w,D),n)}function l(u,n){return n=z(181387,n),Object.keys(u).sort().reduce((D,w)=>(D=_(w,D),i(u[w],D)),n)}class h{constructor(){this._value=0}get value(){return this._value}hash(n){return this._value=i(n,this._value),this._value}}t.Hasher=h;var P;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function r(u,n,D=32){const w=D-n,S=~((1<<w)-1);return(u<<n|(S&u)>>>w)>>>0}function a(u,n=0,D=u.byteLength,w=0){for(let S=0;S<D;S++)u[n+S]=w}function e(u,n,D="0"){for(;u.length<n;)u=D+u;return u}function o(u,n=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(D=>D.toString(16).padStart(2,"0")).join(""):e((u>>>0).toString(16),n/4)}t.toHexString=o;class s{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(n){const D=n.length;if(D===0)return;const w=this._buff;let S=this._buffLen,f=this._leftoverHighSurrogate,v,L;for(f!==0?(v=f,L=-1,f=0):(v=n.charCodeAt(0),L=0);;){let I=v;if(y.isHighSurrogate(v))if(L+1<D){const E=n.charCodeAt(L+1);y.isLowSurrogate(E)?(L++,I=y.computeCodePoint(v,E)):I=65533}else{f=v;break}else y.isLowSurrogate(v)&&(I=65533);if(S=this._push(w,S,I),L++,L<D)v=n.charCodeAt(L);else break}this._buffLen=S,this._leftoverHighSurrogate=f}_push(n,D,w){return w<128?n[D++]=w:w<2048?(n[D++]=192|(w&1984)>>>6,n[D++]=128|(w&63)>>>0):w<65536?(n[D++]=224|(w&61440)>>>12,n[D++]=128|(w&4032)>>>6,n[D++]=128|(w&63)>>>0):(n[D++]=240|(w&1835008)>>>18,n[D++]=128|(w&258048)>>>12,n[D++]=128|(w&4032)>>>6,n[D++]=128|(w&63)>>>0),D>=64&&(this._step(),D-=64,this._totalLen+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),D}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),o(this._h0)+o(this._h1)+o(this._h2)+o(this._h3)+o(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,a(this._buff,this._buffLen),this._buffLen>56&&(this._step(),a(this._buff));const n=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(n/4294967296),!1),this._buffDV.setUint32(60,n%4294967296,!1),this._step()}_step(){const n=s._bigBlock32,D=this._buffDV;for(let m=0;m<64;m+=4)n.setUint32(m,D.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)n.setUint32(m,r(n.getUint32(m-12,!1)^n.getUint32(m-32,!1)^n.getUint32(m-56,!1)^n.getUint32(m-64,!1),1),!1);let w=this._h0,S=this._h1,f=this._h2,v=this._h3,L=this._h4,I,E,g;for(let m=0;m<80;m++)m<20?(I=S&f|~S&v,E=1518500249):m<40?(I=S^f^v,E=1859775393):m<60?(I=S&f|S&v|f&v,E=2400959708):(I=S^f^v,E=3395469782),g=r(w,5)+I+L+E+n.getUint32(m*4,!1)&4294967295,L=v,v=f,f=r(S,30),S=w,w=g;this._h0=this._h0+w&4294967295,this._h1=this._h1+S&4294967295,this._h2=this._h2+f&4294967295,this._h3=this._h3+v&4294967295,this._h4=this._h4+L&4294967295}}t.StringSHA1=s,s._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[112],pe([1,0,71,111]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(r){this.source=r}getElements(){const r=this.source,a=new Int32Array(r.length);for(let e=0,o=r.length;e<o;e++)a[e]=r.charCodeAt(e);return a}}t.StringDiffSequence=i;function z(P,r,a){return new h(new i(P),new i(r)).ComputeDiff(a).changes}t.stringDiff=z;class b{static Assert(r,a){if(!r)throw new Error(a)}}class _{static Copy(r,a,e,o,s){for(let u=0;u<s;u++)e[o+u]=r[a+u]}static Copy2(r,a,e,o,s){for(let u=0;u<s;u++)e[o+u]=r[a+u]}}var c;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class l{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new y.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(r,a){this.m_originalStart=Math.min(this.m_originalStart,r),this.m_modifiedStart=Math.min(this.m_modifiedStart,a),this.m_originalCount++}AddModifiedElement(r,a){this.m_originalStart=Math.min(this.m_originalStart,r),this.m_modifiedStart=Math.min(this.m_modifiedStart,a),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class h{constructor(r,a,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=r,this._modifiedSequence=a;const[o,s,u]=h._getElements(r),[n,D,w]=h._getElements(a);this._hasStrings=u&&w,this._originalStringElements=o,this._originalElementsOrHash=s,this._modifiedStringElements=n,this._modifiedElementsOrHash=D,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(r){return r.length>0&&typeof r[0]=="string"}static _getElements(r){const a=r.getElements();if(h._isStringArray(a)){const e=new Int32Array(a.length);for(let o=0,s=a.length;o<s;o++)e[o]=(0,k.stringHash)(a[o],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}ElementsAreEqual(r,a){return this._originalElementsOrHash[r]!==this._modifiedElementsOrHash[a]?!1:this._hasStrings?this._originalStringElements[r]===this._modifiedStringElements[a]:!0}ElementsAreStrictEqual(r,a){if(!this.ElementsAreEqual(r,a))return!1;const e=h._getStrictElement(this._originalSequence,r),o=h._getStrictElement(this._modifiedSequence,a);return e===o}static _getStrictElement(r,a){return typeof r.getStrictElement=="function"?r.getStrictElement(a):null}OriginalElementsAreEqual(r,a){return this._originalElementsOrHash[r]!==this._originalElementsOrHash[a]?!1:this._hasStrings?this._originalStringElements[r]===this._originalStringElements[a]:!0}ModifiedElementsAreEqual(r,a){return this._modifiedElementsOrHash[r]!==this._modifiedElementsOrHash[a]?!1:this._hasStrings?this._modifiedStringElements[r]===this._modifiedStringElements[a]:!0}ComputeDiff(r){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,r)}_ComputeDiff(r,a,e,o,s){const u=[!1];let n=this.ComputeDiffRecursive(r,a,e,o,u);return s&&(n=this.PrettifyChanges(n)),{quitEarly:u[0],changes:n}}ComputeDiffRecursive(r,a,e,o,s){for(s[0]=!1;r<=a&&e<=o&&this.ElementsAreEqual(r,e);)r++,e++;for(;a>=r&&o>=e&&this.ElementsAreEqual(a,o);)a--,o--;if(r>a||e>o){let f;return e<=o?(b.Assert(r===a+1,"originalStart should only be one more than originalEnd"),f=[new y.DiffChange(r,0,e,o-e+1)]):r<=a?(b.Assert(e===o+1,"modifiedStart should only be one more than modifiedEnd"),f=[new y.DiffChange(r,a-r+1,e,0)]):(b.Assert(r===a+1,"originalStart should only be one more than originalEnd"),b.Assert(e===o+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const u=[0],n=[0],D=this.ComputeRecursionPoint(r,a,e,o,u,n,s),w=u[0],S=n[0];if(D!==null)return D;if(!s[0]){const f=this.ComputeDiffRecursive(r,w,e,S,s);let v=[];return s[0]?v=[new y.DiffChange(w+1,a-(w+1)+1,S+1,o-(S+1)+1)]:v=this.ComputeDiffRecursive(w+1,a,S+1,o,s),this.ConcatenateChanges(f,v)}return[new y.DiffChange(r,a-r+1,e,o-e+1)]}WALKTRACE(r,a,e,o,s,u,n,D,w,S,f,v,L,I,E,g,m,p){let O=null,G=null,J=new l,ie=a,ae=e,ge=L[0]-g[0]-o,ue=-1073741824,de=this.m_forwardHistory.length-1;do{const he=ge+r;he===ie||he<ae&&w[he-1]<w[he+1]?(f=w[he+1],I=f-ge-o,f<ue&&J.MarkNextChange(),ue=f,J.AddModifiedElement(f+1,I),ge=he+1-r):(f=w[he-1]+1,I=f-ge-o,f<ue&&J.MarkNextChange(),ue=f-1,J.AddOriginalElement(f,I+1),ge=he-1-r),de>=0&&(w=this.m_forwardHistory[de],r=w[0],ie=1,ae=w.length-1)}while(--de>=-1);if(O=J.getReverseChanges(),p[0]){let he=L[0]+1,Se=g[0]+1;if(O!==null&&O.length>0){const _e=O[O.length-1];he=Math.max(he,_e.getOriginalEnd()),Se=Math.max(Se,_e.getModifiedEnd())}G=[new y.DiffChange(he,v-he+1,Se,E-Se+1)]}else{J=new l,ie=u,ae=n,ge=L[0]-g[0]-D,ue=1073741824,de=m?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const he=ge+s;he===ie||he<ae&&S[he-1]>=S[he+1]?(f=S[he+1]-1,I=f-ge-D,f>ue&&J.MarkNextChange(),ue=f+1,J.AddOriginalElement(f+1,I+1),ge=he+1-s):(f=S[he-1],I=f-ge-D,f>ue&&J.MarkNextChange(),ue=f,J.AddModifiedElement(f+1,I+1),ge=he-1-s),de>=0&&(S=this.m_reverseHistory[de],s=S[0],ie=1,ae=S.length-1)}while(--de>=-1);G=J.getChanges()}return this.ConcatenateChanges(O,G)}ComputeRecursionPoint(r,a,e,o,s,u,n){let D=0,w=0,S=0,f=0,v=0,L=0;r--,e--,s[0]=0,u[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const I=a-r+(o-e),E=I+1,g=new Int32Array(E),m=new Int32Array(E),p=o-e,O=a-r,G=r-e,J=a-o,ae=(O-p)%2===0;g[p]=r,m[O]=a,n[0]=!1;for(let ge=1;ge<=I/2+1;ge++){let ue=0,de=0;S=this.ClipDiagonalBound(p-ge,ge,p,E),f=this.ClipDiagonalBound(p+ge,ge,p,E);for(let Se=S;Se<=f;Se+=2){Se===S||Se<f&&g[Se-1]<g[Se+1]?D=g[Se+1]:D=g[Se-1]+1,w=D-(Se-p)-G;const _e=D;for(;D<a&&w<o&&this.ElementsAreEqual(D+1,w+1);)D++,w++;if(g[Se]=D,D+w>ue+de&&(ue=D,de=w),!ae&&Math.abs(Se-O)<=ge-1&&D>=m[Se])return s[0]=D,u[0]=w,_e<=m[Se]&&1447>0&&ge<=1447+1?this.WALKTRACE(p,S,f,G,O,v,L,J,g,m,D,a,s,w,o,u,ae,n):null}const he=(ue-r+(de-e)-ge)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ue,he))return n[0]=!0,s[0]=ue,u[0]=de,he>0&&1447>0&&ge<=1447+1?this.WALKTRACE(p,S,f,G,O,v,L,J,g,m,D,a,s,w,o,u,ae,n):(r++,e++,[new y.DiffChange(r,a-r+1,e,o-e+1)]);v=this.ClipDiagonalBound(O-ge,ge,O,E),L=this.ClipDiagonalBound(O+ge,ge,O,E);for(let Se=v;Se<=L;Se+=2){Se===v||Se<L&&m[Se-1]>=m[Se+1]?D=m[Se+1]-1:D=m[Se-1],w=D-(Se-O)-J;const _e=D;for(;D>r&&w>e&&this.ElementsAreEqual(D,w);)D--,w--;if(m[Se]=D,ae&&Math.abs(Se-p)<=ge&&D<=g[Se])return s[0]=D,u[0]=w,_e>=g[Se]&&1447>0&&ge<=1447+1?this.WALKTRACE(p,S,f,G,O,v,L,J,g,m,D,a,s,w,o,u,ae,n):null}if(ge<=1447){let Se=new Int32Array(f-S+2);Se[0]=p-S+1,_.Copy2(g,S,Se,1,f-S+1),this.m_forwardHistory.push(Se),Se=new Int32Array(L-v+2),Se[0]=O-v+1,_.Copy2(m,v,Se,1,L-v+1),this.m_reverseHistory.push(Se)}}return this.WALKTRACE(p,S,f,G,O,v,L,J,g,m,D,a,s,w,o,u,ae,n)}PrettifyChanges(r){for(let a=0;a<r.length;a++){const e=r[a],o=a<r.length-1?r[a+1].originalStart:this._originalElementsOrHash.length,s=a<r.length-1?r[a+1].modifiedStart:this._modifiedElementsOrHash.length,u=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<o&&e.modifiedStart+e.modifiedLength<s&&(!u||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const w=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!w)break;e.originalStart++,e.modifiedStart++}const D=[null];if(a<r.length-1&&this.ChangesOverlap(r[a],r[a+1],D)){r[a]=D[0],r.splice(a+1,1),a--;continue}}for(let a=r.length-1;a>=0;a--){const e=r[a];let o=0,s=0;if(a>0){const f=r[a-1];o=f.originalStart+f.originalLength,s=f.modifiedStart+f.modifiedLength}const u=e.originalLength>0,n=e.modifiedLength>0;let D=0,w=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let f=1;;f++){const v=e.originalStart-f,L=e.modifiedStart-f;if(v<o||L<s||u&&!this.OriginalElementsAreEqual(v,v+e.originalLength)||n&&!this.ModifiedElementsAreEqual(L,L+e.modifiedLength))break;const E=(v===o&&L===s?5:0)+this._boundaryScore(v,e.originalLength,L,e.modifiedLength);E>w&&(w=E,D=f)}e.originalStart-=D,e.modifiedStart-=D;const S=[null];if(a>0&&this.ChangesOverlap(r[a-1],r[a],S)){r[a-1]=S[0],r.splice(a,1),a++;continue}}if(this._hasStrings)for(let a=1,e=r.length;a<e;a++){const o=r[a-1],s=r[a],u=s.originalStart-o.originalStart-o.originalLength,n=o.originalStart,D=s.originalStart+s.originalLength,w=D-n,S=o.modifiedStart,f=s.modifiedStart+s.modifiedLength,v=f-S;if(u<5&&w<20&&v<20){const L=this._findBetterContiguousSequence(n,w,S,v,u);if(L){const[I,E]=L;(I!==o.originalStart+o.originalLength||E!==o.modifiedStart+o.modifiedLength)&&(o.originalLength=I-o.originalStart,o.modifiedLength=E-o.modifiedStart,s.originalStart=I+u,s.modifiedStart=E+u,s.originalLength=D-s.originalStart,s.modifiedLength=f-s.modifiedStart)}}}return r}_findBetterContiguousSequence(r,a,e,o,s){if(a<s||o<s)return null;const u=r+a-s+1,n=e+o-s+1;let D=0,w=0,S=0;for(let f=r;f<u;f++)for(let v=e;v<n;v++){const L=this._contiguousSequenceScore(f,v,s);L>0&&L>D&&(D=L,w=f,S=v)}return D>0?[w,S]:null}_contiguousSequenceScore(r,a,e){let o=0;for(let s=0;s<e;s++){if(!this.ElementsAreEqual(r+s,a+s))return 0;o+=this._originalStringElements[r+s].length}return o}_OriginalIsBoundary(r){return r<=0||r>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[r])}_OriginalRegionIsBoundary(r,a){if(this._OriginalIsBoundary(r)||this._OriginalIsBoundary(r-1))return!0;if(a>0){const e=r+a;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(r){return r<=0||r>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[r])}_ModifiedRegionIsBoundary(r,a){if(this._ModifiedIsBoundary(r)||this._ModifiedIsBoundary(r-1))return!0;if(a>0){const e=r+a;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(r,a,e,o){const s=this._OriginalRegionIsBoundary(r,a)?1:0,u=this._ModifiedRegionIsBoundary(e,o)?1:0;return s+u}ConcatenateChanges(r,a){const e=[];if(r.length===0||a.length===0)return a.length>0?a:r;if(this.ChangesOverlap(r[r.length-1],a[0],e)){const o=new Array(r.length+a.length-1);return _.Copy(r,0,o,0,r.length-1),o[r.length-1]=e[0],_.Copy(a,1,o,r.length,a.length-1),o}else{const o=new Array(r.length+a.length);return _.Copy(r,0,o,0,r.length),_.Copy(a,0,o,r.length,a.length),o}}ChangesOverlap(r,a,e){if(b.Assert(r.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),b.Assert(r.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=a.originalStart||r.modifiedStart+r.modifiedLength>=a.modifiedStart){const o=r.originalStart;let s=r.originalLength;const u=r.modifiedStart;let n=r.modifiedLength;return r.originalStart+r.originalLength>=a.originalStart&&(s=a.originalStart+a.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=a.modifiedStart&&(n=a.modifiedStart+a.modifiedLength-r.modifiedStart),e[0]=new y.DiffChange(o,s,u,n),!0}else return e[0]=null,!1}ClipDiagonalBound(r,a,e,o){if(r>=0&&r<o)return r;const s=e,u=o-e-1,n=a%2===0;if(r<0){const D=s%2===0;return n===D?0:1}else{const D=u%2===0;return n===D?o-1:o-2}}}t.LcsDiff=h}),define(me[33],pe([1,0,32,11,17]),function(te,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.getCodiconAriaLabel=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const z="$(",b=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(`(\\\\)?${b.source}`,"g");function c(u){return u.replace(_,(n,D)=>D?n:`\\${n}`)}t.escapeIcons=c;const l=new RegExp(`\\\\${b.source}`,"g");function h(u){return u.replace(l,n=>`\\${n}`)}t.markdownEscapeEscapedIcons=h;const P=new RegExp(`(\\s)?(\\\\)?${b.source}(\\s)?`,"g");function r(u){return u.indexOf(z)===-1?u:u.replace(P,(n,D,w,S)=>w?n:D||S||"")}t.stripIcons=r;function a(u){return u?u.replace(/\$\((.*?)\)/g,(n,D)=>` ${D} `).trim():""}t.getCodiconAriaLabel=a;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function o(u){e.lastIndex=0;let n="";const D=[];let w=0;for(;;){const S=e.lastIndex,f=e.exec(u),v=u.substring(S,f?.index);if(v.length>0){n+=v;for(let L=0;L<v.length;L++)D.push(w)}if(!f)break;w+=f[0].length}return{text:n,iconOffsets:D}}t.parseLabelWithIcons=o;function s(u,n,D=!1){const{text:w,iconOffsets:S}=n;if(!S||S.length===0)return(0,y.matchesFuzzy)(u,w,D);const f=(0,k.ltrim)(w," "),v=w.length-f.length,L=(0,y.matchesFuzzy)(u,f,D);if(L)for(const I of L){const E=S[I.start+v]+v;I.start+=E,I.end+=E}return L}t.matchesFuzzyIconAware=s}),define(me[113],pe([1,0,13,11]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class i{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const e=a.charCodeAt(0),o=this._value.charCodeAt(this._pos);return e-o}value(){return this._value[this._pos]}}t.StringIterator=i;class z{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,k.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=z;class b{constructor(a=!0,e=!0){this._splitOnBackslash=a,this._caseSensitive=e}reset(a){this._from=0,this._to=0,this._value=a,this._valueLen=a.length;for(let e=a.length-1;e>=0;e--,this._valueLen--){const o=this._value.charCodeAt(e);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let a=!0;for(;this._to<this._valueLen;this._to++){const e=this._value.charCodeAt(this._to);if(e===47||this._splitOnBackslash&&e===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,k.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=b;var _;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(_||(_={}));class c{constructor(a,e){this._ignorePathCasing=a,this._ignoreQueryAndFragment=e,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(a)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return(0,k.compare)(a,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=c;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(h||(h={}));class P{static forUris(a=()=>!1,e=()=>!1){return new P(new c(a,e))}static forPaths(a=!1){return new P(new b(void 0,!a))}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new z)}constructor(a){this._iter=a}clear(){this._root=void 0}fill(a,e){if(e){const o=e.slice(0);(0,y.shuffle)(o);for(const s of o)this.set(s,a)}else{const o=a.slice(0);(0,y.shuffle)(o);for(const s of o)this.set(s[0],s[1])}}set(a,e){const o=this._iter.reset(a);let s;this._root||(this._root=new l,this._root.segment=o.value());const u=[];for(s=this._root;;){const D=o.cmp(s.segment);if(D>0)s.left||(s.left=new l,s.left.segment=o.value()),u.push([-1,s]),s=s.left;else if(D<0)s.right||(s.right=new l,s.right.segment=o.value()),u.push([1,s]),s=s.right;else if(o.hasNext())o.next(),s.mid||(s.mid=new l,s.mid.segment=o.value()),u.push([0,s]),s=s.mid;else break}const n=s.value;s.value=e,s.key=a;for(let D=u.length-1;D>=0;D--){const w=u[D][1];w.updateHeight();const S=w.balanceFactor();if(S<-1||S>1){const f=u[D][0],v=u[D+1][0];if(f===1&&v===1)u[D][1]=w.rotateLeft();else if(f===-1&&v===-1)u[D][1]=w.rotateRight();else if(f===1&&v===-1)w.right=u[D+1][1]=u[D+1][1].rotateRight(),u[D][1]=w.rotateLeft();else if(f===-1&&v===1)w.left=u[D+1][1]=u[D+1][1].rotateLeft(),u[D][1]=w.rotateRight();else throw new Error;if(D>0)switch(u[D-1][0]){case-1:u[D-1][1].left=u[D][1];break;case 1:u[D-1][1].right=u[D][1];break;case 0:u[D-1][1].mid=u[D][1];break}else this._root=u[0][1]}}return n}get(a){return this._getNode(a)?.value}_getNode(a){const e=this._iter.reset(a);let o=this._root;for(;o;){const s=e.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(e.hasNext())e.next(),o=o.mid;else break}return o}has(a){const e=this._getNode(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,e){const o=this._iter.reset(a),s=[];let u=this._root;for(;u;){const n=o.cmp(u.segment);if(n>0)s.push([-1,u]),u=u.left;else if(n<0)s.push([1,u]),u=u.right;else if(o.hasNext())o.next(),s.push([0,u]),u=u.mid;else break}if(u){if(e?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const n=this._min(u.right);if(n.key){const{key:D,value:w,segment:S}=n;this._delete(n.key,!1),u.key=D,u.value=w,u.segment=S}}else{const n=u.left??u.right;if(s.length>0){const[D,w]=s[s.length-1];switch(D){case-1:w.left=n;break;case 0:w.mid=n;break;case 1:w.right=n;break}}else this._root=n}for(let n=s.length-1;n>=0;n--){const D=s[n][1];D.updateHeight();const w=D.balanceFactor();if(w>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),s[n][1]=D.rotateLeft()):w<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),s[n][1]=D.rotateRight()),n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this._root=s[0][1]}}}_min(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this._iter.reset(a);let o=this._root,s;for(;o;){const u=e.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(e.hasNext())e.next(),s=o.value||s,o=o.mid;else break}return o&&o.value||s}findSuperstr(a){return this._findSuperstrOrElement(a,!1)}_findSuperstrOrElement(a,e){const o=this._iter.reset(a);let s=this._root;for(;s;){const u=o.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this._entries(s.mid):e?s.value:void 0}}hasElementOrSubtree(a){return this._findSuperstrOrElement(a,!0)!==void 0}forEach(a){for(const[e,o]of this)a(o,e)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(a){const e=[];return this._dfsEntries(a,e),e[Symbol.iterator]()}_dfsEntries(a,e){a&&(a.left&&this._dfsEntries(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this._dfsEntries(a.mid,e),a.right&&this._dfsEntries(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const o=e.balanceFactor();return o<-1||o>1?!1:a(e.left)&&a(e.right)};return a(this._root)}}t.TernarySearchTree=P}),define(me[15],pe([1,0,22,5]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,z=/^\//,b=/^\/\//;function _(L,I){if(!L.scheme&&I)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!i.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!z.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(L,I){return!L&&!I?"file":L}function l(L,I){switch(L){case"https":case"http":case"file":I?I[0]!==P&&(I=P+I):I=P;break}return I}const h="",P="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(I){return I instanceof a?!0:I?typeof I.authority=="string"&&typeof I.fragment=="string"&&typeof I.path=="string"&&typeof I.query=="string"&&typeof I.scheme=="string"&&typeof I.fsPath=="string"&&typeof I.with=="function"&&typeof I.toString=="function":!1}constructor(I,E,g,m,p,O=!1){typeof I=="object"?(this.scheme=I.scheme||h,this.authority=I.authority||h,this.path=I.path||h,this.query=I.query||h,this.fragment=I.fragment||h):(this.scheme=c(I,O),this.authority=E||h,this.path=l(this.scheme,g||h),this.query=m||h,this.fragment=p||h,_(this,O))}get fsPath(){return D(this,!1)}with(I){if(!I)return this;let{scheme:E,authority:g,path:m,query:p,fragment:O}=I;return E===void 0?E=this.scheme:E===null&&(E=h),g===void 0?g=this.authority:g===null&&(g=h),m===void 0?m=this.path:m===null&&(m=h),p===void 0?p=this.query:p===null&&(p=h),O===void 0?O=this.fragment:O===null&&(O=h),E===this.scheme&&g===this.authority&&m===this.path&&p===this.query&&O===this.fragment?this:new o(E,g,m,p,O)}static parse(I,E=!1){const g=r.exec(I);return g?new o(g[2]||h,v(g[4]||h),v(g[5]||h),v(g[7]||h),v(g[9]||h),E):new o(h,h,h,h,h)}static file(I){let E=h;if(k.isWindows&&(I=I.replace(/\\/g,P)),I[0]===P&&I[1]===P){const g=I.indexOf(P,2);g===-1?(E=I.substring(2),I=P):(E=I.substring(2,g),I=I.substring(g)||P)}return new o("file",E,I,h,h)}static from(I){const E=new o(I.scheme,I.authority,I.path,I.query,I.fragment);return _(E,!0),E}static joinPath(I,...E){if(!I.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return k.isWindows&&I.scheme==="file"?g=a.file(y.win32.join(D(I,!0),...E)).path:g=y.posix.join(I.path,...E),I.with({path:g})}toString(I=!1){return w(this,I)}toJSON(){return this}static revive(I){if(I){if(I instanceof a)return I;{const E=new o(I);return E._formatted=I.external,E._fsPath=I._sep===e?I.fsPath:null,E}}else return I}}t.URI=a;const e=k.isWindows?1:void 0;class o extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=D(this,!1)),this._fsPath}toString(I=!1){return I?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const I={$mid:1};return this._fsPath&&(I.fsPath=this._fsPath,I._sep=e),this._formatted&&(I.external=this._formatted),this.path&&(I.path=this.path),this.scheme&&(I.scheme=this.scheme),this.authority&&(I.authority=this.authority),this.query&&(I.query=this.query),this.fragment&&(I.fragment=this.fragment),I}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(L,I,E){let g,m=-1;for(let p=0;p<L.length;p++){const O=L.charCodeAt(p);if(O>=97&&O<=122||O>=65&&O<=90||O>=48&&O<=57||O===45||O===46||O===95||O===126||I&&O===47||E&&O===91||E&&O===93||E&&O===58)m!==-1&&(g+=encodeURIComponent(L.substring(m,p)),m=-1),g!==void 0&&(g+=L.charAt(p));else{g===void 0&&(g=L.substr(0,p));const G=s[O];G!==void 0?(m!==-1&&(g+=encodeURIComponent(L.substring(m,p)),m=-1),g+=G):m===-1&&(m=p)}}return m!==-1&&(g+=encodeURIComponent(L.substring(m))),g!==void 0?g:L}function n(L){let I;for(let E=0;E<L.length;E++){const g=L.charCodeAt(E);g===35||g===63?(I===void 0&&(I=L.substr(0,E)),I+=s[g]):I!==void 0&&(I+=L[E])}return I!==void 0?I:L}function D(L,I){let E;return L.authority&&L.path.length>1&&L.scheme==="file"?E=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?I?E=L.path.substr(1):E=L.path[1].toLowerCase()+L.path.substr(2):E=L.path,k.isWindows&&(E=E.replace(/\//g,"\\")),E}t.uriToFsPath=D;function w(L,I){const E=I?n:u;let g="",{scheme:m,authority:p,path:O,query:G,fragment:J}=L;if(m&&(g+=m,g+=":"),(p||m==="file")&&(g+=P,g+=P),p){let ie=p.indexOf("@");if(ie!==-1){const ae=p.substr(0,ie);p=p.substr(ie+1),ie=ae.lastIndexOf(":"),ie===-1?g+=E(ae,!1,!1):(g+=E(ae.substr(0,ie),!1,!1),g+=":",g+=E(ae.substr(ie+1),!1,!0)),g+="@"}p=p.toLowerCase(),ie=p.lastIndexOf(":"),ie===-1?g+=E(p,!1,!0):(g+=E(p.substr(0,ie),!1,!0),g+=p.substr(ie))}if(O){if(O.length>=3&&O.charCodeAt(0)===47&&O.charCodeAt(2)===58){const ie=O.charCodeAt(1);ie>=65&&ie<=90&&(O=`/${String.fromCharCode(ie+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===58){const ie=O.charCodeAt(0);ie>=65&&ie<=90&&(O=`${String.fromCharCode(ie+32)}:${O.substr(2)}`)}g+=E(O,!0,!1)}return G&&(g+="?",g+=E(G,!1,!1)),J&&(g+="#",g+=I?J:u(J,!1,!1)),g}function S(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+S(L.substr(3)):L}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(L){return L.match(f)?L.replace(f,I=>S(I)):L}}),define(me[50],pe([1,0,30,11,15]),function(te,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function z(l){return JSON.stringify(l,_)}t.stringify=z;function b(l){let h=JSON.parse(l);return h=c(h),h}t.parse=b;function _(l,h){return h instanceof RegExp?{$mid:2,source:h.source,flags:(0,k.regExpFlags)(h)}:h}function c(l,h=0){if(!l||h>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return i.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof y.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let P=0;P<l.length;++P)l[P]=c(l[P],h+1);else for(const P in l)Object.hasOwnProperty.call(l,P)&&(l[P]=c(l[P],h+1))}return l}t.revive=c}),define(me[28],pe([1,0,7,5,15]),function(te,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var z;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractive="vscode-interactive",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeInteractiveSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(z||(t.Schemas=z={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${z.vscodeRemoteResource}`}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h){this._remoteResourcesPath=`${h}/${z.vscodeRemoteResource}`}set(h,P,r){this._hosts[h]=P,this._ports[h]=r}setConnectionToken(h,P){this._connectionTokens[h]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)try{return this._delegate(h)}catch(s){return y.onUnexpectedError(s),h}const P=h.authority;let r=this._hosts[P];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const a=this._ports[P],e=this._connectionTokens[P];let o=`path=${encodeURIComponent(h.path)}`;return typeof e=="string"&&(o+=`&${t.connectionTokenQueryName}=${encodeURIComponent(e)}`),i.URI.from({scheme:k.isWeb?this._preferredWebSchema:z.vscodeRemoteResource,authority:`${r}:${a}`,path:this._remoteResourcesPath,query:o})}}t.RemoteAuthorities=new b,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class _{asBrowserUri(h){const P=this.toUri(h,te);return this.uriToBrowserUri(P)}uriToBrowserUri(h){return h.scheme===z.vscodeRemote?t.RemoteAuthorities.rewrite(h):h.scheme===z.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${z.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?h.with({scheme:z.vscodeFileResource,authority:h.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):h}asFileUri(h){const P=this.toUri(h,te);return this.uriToFileUri(P)}uriToFileUri(h){return h.scheme===z.vscodeFileResource?h.with({scheme:z.file,authority:h.authority!==_.FALLBACK_AUTHORITY?h.authority:null,query:null,fragment:null}):h}toUri(h,P){return i.URI.isUri(h)?h:i.URI.parse(P.toUrl(h))}}_.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new _;var c;(function(l){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(h.get("3"));const P="vscode-coi";function r(e){let o;typeof e=="string"?o=new URL(e).searchParams:e instanceof URL?o=e.searchParams:i.URI.isUri(e)&&(o=new URL(e.toString(!0)).searchParams);const s=o?.get(P);if(s)return h.get(s)}l.getHeadersFromQuery=r;function a(e,o,s){if(!globalThis.crossOriginIsolated)return;const u=o&&s?"3":s?"2":"1";e instanceof URLSearchParams?e.set(P,u):e[P]=u}l.addSearchParam=a})(c||(t.COI=c={}))}),define(me[34],pe([1,0,110,28,22,5,11,15]),function(te,t,y,k,i,z,b,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function c(a){return(0,_.uriToFsPath)(a,!0)}t.originalFSPath=c;class l{constructor(e){this._ignorePathCasing=e}compare(e,o,s=!1){return e===o?0:(0,b.compare)(this.getComparisonKey(e,s),this.getComparisonKey(o,s))}isEqual(e,o,s=!1){return e===o?!0:!e||!o?!1:this.getComparisonKey(e,s)===this.getComparisonKey(o,s)}getComparisonKey(e,o=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,o,s=!1){if(e.scheme===o.scheme){if(e.scheme===k.Schemas.file)return y.isEqualOrParent(c(e),c(o),this._ignorePathCasing(e))&&e.query===o.query&&(s||e.fragment===o.fragment);if((0,t.isEqualAuthority)(e.authority,o.authority))return y.isEqualOrParent(e.path,o.path,this._ignorePathCasing(e),"/")&&e.query===o.query&&(s||e.fragment===o.fragment)}return!1}joinPath(e,...o){return _.URI.joinPath(e,...o)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return i.posix.basename(e.path)}extname(e){return i.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let o;return e.scheme===k.Schemas.file?o=_.URI.file(i.dirname(c(e))).path:(o=i.posix.dirname(e.path),e.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),o="/")),e.with({path:o})}normalizePath(e){if(!e.path.length)return e;let o;return e.scheme===k.Schemas.file?o=_.URI.file(i.normalize(c(e))).path:o=i.posix.normalize(e.path),e.with({path:o})}relativePath(e,o){if(e.scheme!==o.scheme||!(0,t.isEqualAuthority)(e.authority,o.authority))return;if(e.scheme===k.Schemas.file){const n=i.relative(c(e),c(o));return z.isWindows?y.toSlashes(n):n}let s=e.path||"/";const u=o.path||"/";if(this._ignorePathCasing(e)){let n=0;for(const D=Math.min(s.length,u.length);n<D&&!(s.charCodeAt(n)!==u.charCodeAt(n)&&s.charAt(n).toLowerCase()!==u.charAt(n).toLowerCase());n++);s=u.substr(0,n)+s.substr(n)}return i.posix.relative(s,u)}resolvePath(e,o){if(e.scheme===k.Schemas.file){const s=_.URI.file(i.resolve(c(e),o));return e.with({authority:s.authority,path:s.path})}return o=y.toPosixPath(o),e.with({path:i.posix.resolve(e.path,o)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,o){return e===o||e!==void 0&&o!==void 0&&(0,b.equalsIgnoreCase)(e,o)}hasTrailingPathSeparator(e,o=i.sep){if(e.scheme===k.Schemas.file){const s=c(e);return s.length>y.getRoot(s).length&&s[s.length-1]===o}else{const s=e.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,o=i.sep){return(0,t.hasTrailingPathSeparator)(e,o)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,o=i.sep){let s=!1;if(e.scheme===k.Schemas.file){const u=c(e);s=u!==void 0&&u.length===y.getRoot(u).length&&u[u.length-1]===o}else{o="/";const u=e.path;s=u.length===1&&u.charCodeAt(u.length-1)===47}return!s&&!(0,t.hasTrailingPathSeparator)(e,o)?e.with({path:e.path+"/"}):e}}t.ExtUri=l,t.extUri=new l(()=>!1),t.extUriBiasedIgnorePathCase=new l(a=>a.scheme===k.Schemas.file?!z.isLinux:!0),t.extUriIgnorePathCase=new l(a=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function h(a,e){const o=[];for(let s=0;s<a.length;s++){const u=e(a[s]);a.some((n,D)=>D===s?!1:(0,t.isEqualOrParent)(u,e(n)))||o.push(a[s])}return o}t.distinctParents=h;var P;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(o){const s=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(D=>{const[w,S]=D.split(":");w&&S&&s.set(w,S)});const n=o.path.substring(0,o.path.indexOf(";"));return n&&s.set(a.META_DATA_MIME,n),s}a.parseMetaData=e})(P||(t.DataUri=P={}));function r(a,e,o){if(e){let s=a.path;return s&&s[0]!==i.posix.sep&&(s=i.posix.sep+s),a.with({scheme:o,authority:e,path:s})}return a.with({scheme:o})}t.toLocalResource=r}),define(me[9],pe([1,0,27,7,3,2,34,5,46]),function(te,t,y,k,i,z,b,_,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function l(W){return!!W&&typeof W.then=="function"}t.isThenable=l;function h(W){const N=new y.CancellationTokenSource,d=W(N.token),R=new Promise(($,Z)=>{const T=N.token.onCancellationRequested(()=>{T.dispose(),N.dispose(),Z(new k.CancellationError)});Promise.resolve(d).then(F=>{T.dispose(),N.dispose(),$(F)},F=>{T.dispose(),N.dispose(),Z(F)})});return new class{cancel(){N.cancel()}then($,Z){return R.then($,Z)}catch($){return this.then(void 0,$)}finally($){return R.finally($)}}}t.createCancelablePromise=h;function P(W,N,d){return new Promise((R,$)=>{const Z=N.onCancellationRequested(()=>{Z.dispose(),R(d)});W.then(R,$).finally(()=>Z.dispose())})}t.raceCancellation=P;function r(W,N){return new Promise((d,R)=>{const $=N.onCancellationRequested(()=>{$.dispose(),R(new k.CancellationError)});W.then(d,R).finally(()=>$.dispose())})}t.raceCancellationError=r;async function a(W){let N=-1;const d=W.map((R,$)=>R.then(Z=>(N=$,Z)));try{return await Promise.race(d)}finally{W.forEach((R,$)=>{$!==N&&R.cancel()})}}t.raceCancellablePromises=a;function e(W,N,d){let R;const $=setTimeout(()=>{R?.(void 0),d?.()},N);return Promise.race([W.finally(()=>clearTimeout($)),new Promise(Z=>R=Z)])}t.raceTimeout=e;function o(W){return new Promise((N,d)=>{const R=W();l(R)?R.then(N,d):N(R)})}t.asPromise=o;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const d=()=>{this.queuedPromise=null;const R=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,R};this.queuedPromise=new Promise(R=>{this.activePromise.then(d,d).then(R)})}return new Promise((d,R)=>{this.queuedPromise.then(d,R)})}return this.activePromise=N(),new Promise((d,R)=>{this.activePromise.then($=>{this.activePromise=null,d($)},$=>{this.activePromise=null,R($)})})}}t.Throttler=s;class u{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}t.Sequencer=u;class n{constructor(){this.promiseMap=new Map}queue(N,d){const $=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(d).finally(()=>{this.promiseMap.get(N)===$&&this.promiseMap.delete(N)});return this.promiseMap.set(N,$),$}}t.SequencerByKey=n;const D=(W,N)=>{let d=!0;const R=setTimeout(()=>{d=!1,N()},W);return{isTriggered:()=>d,dispose:()=>{clearTimeout(R),d=!1}}},w=W=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,W())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class S{constructor(N){this.defaultDelay=N,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,d=this.defaultDelay){this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,Z)=>{this.doResolve=$,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}}));const R=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=d===c.MicrotaskDelay?w(R):D(d,R),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new k.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=S;class f{constructor(N){this.delayer=new S(N),this.throttler=new s}trigger(N,d){return this.delayer.trigger(()=>this.throttler.queue(N),d)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=f;class v{constructor(){this._isOpen=!1,this._promise=new Promise((N,d)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=v;class L extends v{constructor(N){super(),this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=L;function I(W,N){return N?new Promise((d,R)=>{const $=setTimeout(()=>{Z.dispose(),d()},W),Z=N.onCancellationRequested(()=>{clearTimeout($),Z.dispose(),R(new k.CancellationError)})}):h(d=>I(W,d))}t.timeout=I;function E(W,N=0){const d=setTimeout(W,N);return(0,z.toDisposable)(()=>clearTimeout(d))}t.disposableTimeout=E;function g(W){const N=[];let d=0;const R=W.length;function $(){return d<R?W[d++]():null}function Z(T){T!=null&&N.push(T);const F=$();return F?F.then(Z):Promise.resolve(N)}return Promise.resolve(null).then(Z)}t.sequence=g;function m(W,N=R=>!!R,d=null){let R=0;const $=W.length,Z=()=>{if(R>=$)return Promise.resolve(d);const T=W[R++];return Promise.resolve(T()).then(B=>N(B)?Promise.resolve(B):Z())};return Z()}t.first=m;function p(W,N=R=>!!R,d=null){if(W.length===0)return Promise.resolve(d);let R=W.length;const $=()=>{R=-1;for(const Z of W)Z.cancel?.()};return new Promise((Z,T)=>{for(const F of W)F.then(B=>{--R>=0&&N(B)?($(),Z(B)):R===0&&Z(d)}).catch(B=>{--R>=0&&($(),T(B))})})}t.firstParallel=p;class O{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new i.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(N){return this._size++,new Promise((d,R)=>{this.outstandingPromises.push({factory:N,c:d,e:R}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const d=N.factory();d.then(N.c,N.e),d.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=O;class G extends O{constructor(){super(1)}}t.Queue=G;class J{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const N=new se;return this.drainers.add(N),N.p}isDrained(){for(const[,N]of this.queues)if(N.size>0)return!1;return!0}queueFor(N,d=b.extUri){const R=d.getComparisonKey(N);let $=this.queues.get(R);return $||($=new G,i.Event.once($.onDrained)(()=>{$?.dispose(),this.queues.delete(R),this.onDidQueueDrain()}),this.queues.set(R,$)),$}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const N of this.drainers)N.complete();this.drainers.clear()}dispose(){for(const[,N]of this.queues)N.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=J;class ie{constructor(N,d){this._token=-1,typeof N=="function"&&typeof d=="number"&&this.setIfNotSet(N,d)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,d){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},d)}setIfNotSet(N,d){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},d))}}t.TimeoutTimer=ie;class ae{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,d){this.cancel(),this._token=setInterval(()=>{N()},d)}}t.IntervalTimer=ae;class ge{constructor(N,d){this.timeoutToken=-1,this.runner=N,this.timeout=d,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=ge;class ue{constructor(N,d){d%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${d}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=d,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ue;class de extends ge{constructor(N,d){super(N,d),this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner?.(N)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=de;class he extends z.Disposable{constructor(N,d){super(),this.options=N,this.handler=d,this.pendingWork=[],this.throttler=this._register(new z.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.options.maxBufferedWork)return!1}else if(this.pending+N.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const d of N)this.pendingWork.push(d);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ge(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=he,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=W=>{(0,_.setTimeout0)(()=>{if(N)return;const d=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,d-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:t.runWhenIdle=(W,N)=>{const d=requestIdleCallback(W,typeof N=="number"?{timeout:N}:void 0);let R=!1;return{dispose(){R||(R=!0,cancelIdleCallback(d))}}}}();class Se{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(d){this._error=d}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=Se;async function _e(W,N,d){let R;for(let $=0;$<d;$++)try{return await W()}catch(Z){R=Z,await I(N)}throw R}t.retry=_e;class Oe{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(N,d,R){return this._pending={taskId:N,cancel:()=>R?.(),promise:d},d.then(()=>this.donePending(N),()=>this.donePending(N)),d}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let d,R;const $=new Promise((Z,T)=>{d=Z,R=T});this._next={run:N,promise:$,promiseResolve:d,promiseReject:R}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}t.TaskSequentializer=Oe;class re{constructor(N,d=()=>Date.now()){this.interval=N,this.nowFn=d,this.lastIncrementTime=0,this.value=0}increment(){const N=this.nowFn();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}t.IntervalCounter=re;class se{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,d)=>{this.completeCallback=N,this.errorCallback=d})}complete(N){return new Promise(d=>{this.completeCallback(N),this.resolved=!0,d()})}error(N){return new Promise(d=>{this.errorCallback(N),this.rejected=!0,d()})}cancel(){new Promise(N=>{this.errorCallback(new k.CancellationError),this.rejected=!0,N()})}}t.DeferredPromise=se;var Q;(function(W){async function N(R){let $;const Z=await Promise.all(R.map(T=>T.then(F=>F,F=>{$||($=F)})));if(typeof $<"u")throw $;return Z}W.settled=N;function d(R){return new Promise(async($,Z)=>{try{await R($,Z)}catch(T){Z(T)}})}W.withAsyncBody=d})(Q||(t.Promises=Q={}));var oe;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(oe||(oe={}));class V{static fromArray(N){return new V(d=>{d.emitMany(N)})}static fromPromise(N){return new V(async d=>{d.emitMany(await N)})}static fromPromises(N){return new V(async d=>{await Promise.all(N.map(async R=>d.emitOne(await R)))})}static merge(N){return new V(async d=>{await Promise.all(N.map(async R=>{for await(const $ of R)d.emitOne($)}))})}constructor(N){this._state=0,this._results=[],this._error=null,this._onStateChanged=new i.Emitter,queueMicrotask(async()=>{const d={emitOne:R=>this.emitOne(R),emitMany:R=>this.emitMany(R),reject:R=>this.reject(R)};try{await Promise.resolve(N(d)),this.resolve()}catch(R){this.reject(R)}finally{d.emitOne=void 0,d.emitMany=void 0,d.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(N<this._results.length)return{done:!1,value:this._results[N++]};if(this._state===1)return{done:!0,value:void 0};await i.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(N,d){return new V(async R=>{for await(const $ of N)R.emitOne(d($))})}map(N){return V.map(this,N)}static filter(N,d){return new V(async R=>{for await(const $ of N)d($)&&R.emitOne($)})}filter(N){return V.filter(this,N)}static coalesce(N){return V.filter(N,d=>!!d)}coalesce(){return V.coalesce(this)}static async toPromise(N){const d=[];for await(const R of N)d.push(R);return d}toPromise(){return V.toPromise(this)}emitOne(N){this._state===0&&(this._results.push(N),this._onStateChanged.fire())}emitMany(N){this._state===0&&(this._results=this._results.concat(N),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(N){this._state===0&&(this._state=2,this._error=N,this._onStateChanged.fire())}}t.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class K extends V{constructor(N,d){super(d),this._source=N}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=K;function A(W){const N=new y.CancellationTokenSource,d=W(N.token);return new K(N,async R=>{const $=N.token.onCancellationRequested(()=>{$.dispose(),N.dispose(),R.reject(new k.CancellationError)});try{for await(const Z of d){if(N.token.isCancellationRequested)return;R.emitOne(Z)}$.dispose(),N.dispose()}catch(Z){$.dispose(),N.dispose(),R.reject(Z)}})}t.createCancelableAsyncIterable=A}),define(me[4],pe([1,0,18,108,14,21,9,7,3,114,2,28,5,6,15]),function(te,t,y,k,i,z,b,_,c,l,h,P,r,a,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.setVisibility=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.isEventLike=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function o(X){for(;X.firstChild;)X.firstChild.remove()}t.clearNode=o;function s(X){return X?.isConnected??!1}t.isInDOM=s;class u{constructor(Y,fe,Te,Le){this._node=Y,this._type=fe,this._handler=Te,this._options=Le||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){this._handler&&(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function n(X,Y,fe,Te){return new u(X,Y,fe,Te)}t.addDisposableListener=n;function D(X){return function(Y){return X(new z.StandardMouseEvent(Y))}}function w(X){return function(Y){return X(new i.StandardKeyboardEvent(Y))}}const S=function(Y,fe,Te,Le){let $e=Te;return fe==="click"||fe==="mousedown"?$e=D(Te):(fe==="keydown"||fe==="keypress"||fe==="keyup")&&($e=w(Te)),n(Y,fe,$e,Le)};t.addStandardDisposableListener=S;const f=function(Y,fe,Te){const Le=D(fe);return L(Y,Le,Te)};t.addStandardDisposableGenericMouseDownListener=f;const v=function(Y,fe,Te){const Le=D(fe);return E(Y,Le,Te)};t.addStandardDisposableGenericMouseUpListener=v;function L(X,Y,fe){return n(X,r.isIOS&&k.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,Y,fe)}t.addDisposableGenericMouseDownListener=L;function I(X,Y,fe){return n(X,r.isIOS&&k.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,Y,fe)}t.addDisposableGenericMouseMoveListener=I;function E(X,Y,fe){return n(X,r.isIOS&&k.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,Y,fe)}t.addDisposableGenericMouseUpListener=E;class g{constructor(Y,fe=0){this._runner=Y,this.priority=fe,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(Y){(0,_.onUnexpectedError)(Y)}}static sort(Y,fe){return fe.priority-Y.priority}}(function(){let X=[],Y=null,fe=!1,Te=!1;const Le=()=>{for(fe=!1,Y=X,X=[],Te=!0;Y.length>0;)Y.sort(g.sort),Y.shift().execute();Te=!1};t.scheduleAtNextAnimationFrame=($e,We=0)=>{const Ye=new g($e,We);return X.push(Ye),fe||(fe=!0,requestAnimationFrame(Le)),Ye},t.runAtThisOrScheduleAtNextAnimationFrame=($e,We)=>{if(Te){const Ye=new g($e,We);return Y.push(Ye),Ye}else return(0,t.scheduleAtNextAnimationFrame)($e,We)}})();function m(X){return(0,t.scheduleAtNextAnimationFrame)(X,1e4)}t.measure=m;function p(X){return(0,t.scheduleAtNextAnimationFrame)(X,-1e4)}t.modify=p;const O=8,G=function(X,Y){return Y};class J extends h.Disposable{constructor(Y,fe,Te,Le=G,$e=O){super();let We=null,Ye=0;const st=this._register(new b.TimeoutTimer),je=()=>{Ye=new Date().getTime(),Te(We),We=null};this._register(n(Y,fe,vt=>{We=Le(We,vt);const Et=new Date().getTime()-Ye;Et>=$e?(st.cancel(),je()):st.setIfNotSet(je,$e-Et)}))}}function ie(X,Y,fe,Te,Le){return new J(X,Y,fe,Te,Le)}t.addDisposableThrottledListener=ie;function ae(X){return document.defaultView.getComputedStyle(X,null)}t.getComputedStyle=ae;function ge(X){if(X!==document.body)return new de(X.clientWidth,X.clientHeight);if(r.isIOS&&window.visualViewport)return new de(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new de(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new de(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new de(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=ge;class ue{static convertToPixels(Y,fe){return parseFloat(fe)||0}static getDimension(Y,fe,Te){const Le=ae(Y),$e=Le?Le.getPropertyValue(fe):"0";return ue.convertToPixels(Y,$e)}static getBorderLeftWidth(Y){return ue.getDimension(Y,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Y){return ue.getDimension(Y,"border-right-width","borderRightWidth")}static getBorderTopWidth(Y){return ue.getDimension(Y,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Y){return ue.getDimension(Y,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Y){return ue.getDimension(Y,"padding-left","paddingLeft")}static getPaddingRight(Y){return ue.getDimension(Y,"padding-right","paddingRight")}static getPaddingTop(Y){return ue.getDimension(Y,"padding-top","paddingTop")}static getPaddingBottom(Y){return ue.getDimension(Y,"padding-bottom","paddingBottom")}static getMarginLeft(Y){return ue.getDimension(Y,"margin-left","marginLeft")}static getMarginTop(Y){return ue.getDimension(Y,"margin-top","marginTop")}static getMarginRight(Y){return ue.getDimension(Y,"margin-right","marginRight")}static getMarginBottom(Y){return ue.getDimension(Y,"margin-bottom","marginBottom")}}class de{constructor(Y,fe){this.width=Y,this.height=fe}with(Y=this.width,fe=this.height){return Y!==this.width||fe!==this.height?new de(Y,fe):this}static is(Y){return typeof Y=="object"&&typeof Y.height=="number"&&typeof Y.width=="number"}static lift(Y){return Y instanceof de?Y:new de(Y.width,Y.height)}static equals(Y,fe){return Y===fe?!0:!Y||!fe?!1:Y.width===fe.width&&Y.height===fe.height}}t.Dimension=de,de.None=new de(0,0);function he(X){let Y=X.offsetParent,fe=X.offsetTop,Te=X.offsetLeft;for(;(X=X.parentNode)!==null&&X!==document.body&&X!==document.documentElement;){fe-=X.scrollTop;const Le=B(X)?null:ae(X);Le&&(Te-=Le.direction!=="rtl"?X.scrollLeft:-X.scrollLeft),X===Y&&(Te+=ue.getBorderLeftWidth(X),fe+=ue.getBorderTopWidth(X),fe+=X.offsetTop,Te+=X.offsetLeft,Y=X.offsetParent)}return{left:Te,top:fe}}t.getTopLeftOffset=he;function Se(X,Y,fe){typeof Y=="number"&&(X.style.width=`${Y}px`),typeof fe=="number"&&(X.style.height=`${fe}px`)}t.size=Se;function _e(X,Y,fe,Te,Le,$e="absolute"){typeof Y=="number"&&(X.style.top=`${Y}px`),typeof fe=="number"&&(X.style.right=`${fe}px`),typeof Te=="number"&&(X.style.bottom=`${Te}px`),typeof Le=="number"&&(X.style.left=`${Le}px`),X.style.position=$e}t.position=_e;function Oe(X){const Y=X.getBoundingClientRect();return{left:Y.left+window.scrollX,top:Y.top+window.scrollY,width:Y.width,height:Y.height}}t.getDomNodePagePosition=Oe;function re(X){let Y=X,fe=1;do{const Te=ae(Y).zoom;Te!=null&&Te!=="1"&&(fe*=Te),Y=Y.parentElement}while(Y!==null&&Y!==document.documentElement);return fe}t.getDomNodeZoomLevel=re;function se(X){const Y=ue.getMarginLeft(X)+ue.getMarginRight(X);return X.offsetWidth+Y}t.getTotalWidth=se;function Q(X){const Y=ue.getBorderLeftWidth(X)+ue.getBorderRightWidth(X),fe=ue.getPaddingLeft(X)+ue.getPaddingRight(X);return X.offsetWidth-Y-fe}t.getContentWidth=Q;function oe(X){const Y=ue.getMarginLeft(X)+ue.getMarginRight(X);return X.scrollWidth+Y}t.getTotalScrollWidth=oe;function V(X){const Y=ue.getBorderTopWidth(X)+ue.getBorderBottomWidth(X),fe=ue.getPaddingTop(X)+ue.getPaddingBottom(X);return X.offsetHeight-Y-fe}t.getContentHeight=V;function K(X){const Y=ue.getMarginTop(X)+ue.getMarginBottom(X);return X.offsetHeight+Y}t.getTotalHeight=K;function A(X,Y){if(X===null)return 0;const fe=he(X),Te=he(Y);return fe.left-Te.left}function W(X,Y){const fe=Y.map(Le=>Math.max(oe(Le),se(Le))+A(Le,X)||0);return Math.max(...fe)}t.getLargestChildWidth=W;function N(X,Y){for(;X;){if(X===Y)return!0;X=X.parentNode}return!1}t.isAncestor=N;const d="parentFlowToElementId";function R(X,Y){X.dataset[d]=Y.id}t.setParentFlowTo=R;function $(X){const Y=X.dataset[d];return typeof Y=="string"?document.getElementById(Y):null}function Z(X,Y){let fe=X;for(;fe;){if(fe===Y)return!0;if(fe instanceof HTMLElement){const Te=$(fe);if(Te){fe=Te;continue}}fe=fe.parentNode}return!1}t.isAncestorUsingFlowTo=Z;function T(X,Y,fe){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X.classList.contains(Y))return X;if(fe){if(typeof fe=="string"){if(X.classList.contains(fe))return null}else if(X===fe)return null}X=X.parentNode}return null}t.findParentWithClass=T;function F(X,Y,fe){return!!T(X,Y,fe)}t.hasParentWithClass=F;function B(X){return X&&!!X.host&&!!X.mode}t.isShadowRoot=B;function C(X){return!!H(X)}t.isInShadowDOM=C;function H(X){for(;X.parentNode;){if(X===document.body)return null;X=X.parentNode}return B(X)?X:null}t.getShadowRoot=H;function x(){let X=document.activeElement;for(;X?.shadowRoot;)X=X.shadowRoot.activeElement;return X}t.getActiveElement=x;function M(X=document.getElementsByTagName("head")[0],Y){const fe=document.createElement("style");return fe.type="text/css",fe.media="screen",Y?.(fe),X.appendChild(fe),fe}t.createStyleSheet=M;function U(X=document.getElementsByTagName("head")[0]){const Y=document.createElement("meta");return X.appendChild(Y),Y}t.createMetaElement=U;let q=null;function ee(){return q||(q=M()),q}function ne(X){return X?.sheet?.rules?X.sheet.rules:X?.sheet?.cssRules?X.sheet.cssRules:[]}function ve(X,Y,fe=ee()){!fe||!Y||fe.sheet.insertRule(X+"{"+Y+"}",0)}t.createCSSRule=ve;function we(X,Y=ee()){if(!Y)return;const fe=ne(Y),Te=[];for(let Le=0;Le<fe.length;Le++)fe[Le].selectorText.indexOf(X)!==-1&&Te.push(Le);for(let Le=Te.length-1;Le>=0;Le--)Y.sheet.deleteRule(Te[Le])}t.removeCSSRulesContainingSelector=we;function Ne(X){return typeof HTMLElement=="object"?X instanceof HTMLElement:X&&typeof X=="object"&&X.nodeType===1&&typeof X.nodeName=="string"}t.isHTMLElement=Ne,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:y.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:y.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:y.isWebKit?"webkitAnimationIteration":"animationiteration"};function Ae(X){const Y=X;return!!(Y&&typeof Y.preventDefault=="function"&&typeof Y.stopPropagation=="function")}t.isEventLike=Ae,t.EventHelper={stop:(X,Y)=>(X.preventDefault(),Y&&X.stopPropagation(),X)};function De(X){const Y=[];for(let fe=0;X&&X.nodeType===X.ELEMENT_NODE;fe++)Y[fe]=X.scrollTop,X=X.parentNode;return Y}t.saveParentsScrollTop=De;function Pe(X,Y){for(let fe=0;X&&X.nodeType===X.ELEMENT_NODE;fe++)X.scrollTop!==Y[fe]&&(X.scrollTop=Y[fe]),X=X.parentNode}t.restoreParentsScrollTop=Pe;class Ie extends h.Disposable{static hasFocusWithin(Y){const fe=H(Y),Te=fe?fe.activeElement:document.activeElement;return N(Te,Y)}constructor(Y){super(),this._onDidFocus=this._register(new c.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new c.Emitter),this.onDidBlur=this._onDidBlur.event;let fe=Ie.hasFocusWithin(Y),Te=!1;const Le=()=>{Te=!1,fe||(fe=!0,this._onDidFocus.fire())},$e=()=>{fe&&(Te=!0,window.setTimeout(()=>{Te&&(Te=!1,fe=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{Ie.hasFocusWithin(Y)!==fe&&(fe?$e():Le())},this._register(n(Y,t.EventType.FOCUS,Le,!0)),this._register(n(Y,t.EventType.BLUR,$e,!0)),this._register(n(Y,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(n(Y,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}refreshState(){this._refreshStateHandler()}}function Ke(X){return new Ie(X)}t.trackFocus=Ke;function xe(X,Y){return X.after(Y),Y}t.after=xe;function ze(X,...Y){if(X.append(...Y),Y.length===1&&typeof Y[0]!="string")return Y[0]}t.append=ze;function Je(X,Y){return X.insertBefore(Y,X.firstChild),Y}t.prepend=Je;function it(X,...Y){X.innerText="",ze(X,...Y)}t.reset=it;const Me=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Ve;(function(X){X.HTML="http://www.w3.org/1999/xhtml",X.SVG="http://www.w3.org/2000/svg"})(Ve||(t.Namespace=Ve={}));function j(X,Y,fe,...Te){const Le=Me.exec(Y);if(!Le)throw new Error("Bad use of emmet");const $e=Le[1]||"div";let We;return X!==Ve.HTML?We=document.createElementNS(X,$e):We=document.createElement($e),Le[3]&&(We.id=Le[3]),Le[4]&&(We.className=Le[4].replace(/\./g," ").trim()),fe&&Object.entries(fe).forEach(([Ye,st])=>{typeof st>"u"||(/^on\w+$/.test(Ye)?We[Ye]=st:Ye==="selected"?st&&We.setAttribute(Ye,"true"):We.setAttribute(Ye,st))}),We.append(...Te),We}function le(X,Y,...fe){return j(Ve.HTML,X,Y,...fe)}t.$=le,le.SVG=function(X,Y,...fe){return j(Ve.SVG,X,Y,...fe)};function be(X,Y){const fe=[];return X.forEach((Te,Le)=>{Le>0&&(Y instanceof Node?fe.push(Y.cloneNode()):fe.push(document.createTextNode(Y))),fe.push(Te)}),fe}t.join=be;function ye(X,...Y){X?Ce(...Y):Re(...Y)}t.setVisibility=ye;function Ce(...X){for(const Y of X)Y.style.display="",Y.removeAttribute("aria-hidden")}t.show=Ce;function Re(...X){for(const Y of X)Y.style.display="none",Y.setAttribute("aria-hidden","true")}t.hide=Re;function Ue(X,Y){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X instanceof HTMLElement&&X.hasAttribute(Y))return X;X=X.parentNode}return null}function Ge(X){!X||!X.hasAttribute("tabIndex")||(document.activeElement===X&&Ue(X.parentElement,"tabIndex")?.focus(),X.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Ge;function et(X){return Y=>{Y.preventDefault(),Y.stopPropagation(),X(Y)}}t.finalHandler=et;function Fe(){return new Promise(X=>{document.readyState==="complete"||document&&document.body!==null?X(void 0):window.addEventListener("DOMContentLoaded",X,!1)})}t.domContentLoaded=Fe;function ce(X){const Y=window.devicePixelRatio*X;return Math.max(1,Math.floor(Y))/window.devicePixelRatio}t.computeScreenAwareSize=ce;function Ee(X){window.open(X,"_blank","noopener")}t.windowOpenNoOpener=Ee;const ke=780,He=640;function Xe(X){const Y=Math.floor(window.screenLeft+window.innerWidth/2-ke/2),fe=Math.floor(window.screenTop+window.innerHeight/2-He/2);window.open(X,"_blank",`width=${ke},height=${He},top=${fe},left=${Y}`)}t.windowOpenPopup=Xe;function Ze(X,Y=!0){const fe=window.open();return fe?(Y&&(fe.opener=null),fe.location.href=X,!0):!1}t.windowOpenWithSuccess=Ze;function Qe(X){const Y=()=>{X(),fe=(0,t.scheduleAtNextAnimationFrame)(Y)};let fe=(0,t.scheduleAtNextAnimationFrame)(Y);return(0,h.toDisposable)(()=>fe.dispose())}t.animate=Qe,P.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function rt(X){return X?`url('${P.FileAccess.uriToBrowserUri(X).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=rt;function dt(X){return`'${X.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=dt;function pt(X,Y){if(X!==void 0){const fe=X.match(/^\s*var\((.+)\)$/);if(fe){const Te=fe[1].split(",",2);return Te.length===2&&(Y=pt(Te[1].trim(),Y)),`var(${Te[0]}, ${Y})`}return X}return Y}t.asCssValueWithDefault=pt;function Ft(X,Y){let fe;if(e.URI.isUri(X))fe=X.toString(!0);else{const Le=new Blob([X]);fe=URL.createObjectURL(Le),setTimeout(()=>URL.revokeObjectURL(fe))}const Te=document.createElement("a");document.body.appendChild(Te),Te.download=Y,Te.href=fe,Te.click(),setTimeout(()=>document.body.removeChild(Te))}t.triggerDownload=Ft;function zt(){return new Promise(X=>{const Y=document.createElement("input");document.body.appendChild(Y),Y.type="file",Y.multiple=!0,c.Event.once(c.Event.fromDOMEventEmitter(Y,"input"))(()=>{X((0,a.withNullAsUndefined)(Y.files))}),Y.click(),setTimeout(()=>document.body.removeChild(Y))})}t.triggerUpload=zt;var bt;(function(X){X[X.DOCUMENT=1]="DOCUMENT",X[X.BROWSER=2]="BROWSER"})(bt||(t.DetectedFullscreenMode=bt={}));function di(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:bt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:bt.BROWSER,guess:!1}:(r.isMacintosh||r.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:bt.BROWSER,guess:!0}:null}t.detectFullscreen=di;function Wt(X,Y=!1){const fe=document.createElement("a");return l.addHook("afterSanitizeAttributes",Te=>{for(const Le of["href","src"])if(Te.hasAttribute(Le)){const $e=Te.getAttribute(Le);if(Le==="href"&&$e.startsWith("#"))continue;if(fe.href=$e,!X.includes(fe.protocol.replace(/:$/,""))){if(Y&&Le==="src"&&fe.href.startsWith("data:"))continue;Te.removeAttribute(Le)}}}),(0,h.toDisposable)(()=>{l.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Wt;const fi=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const gi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function mi(X,Y){const fe=Wt(fi);try{const Te=l.sanitize(Y,gi);X.innerHTML=Te}finally{fe.dispose()}}t.safeInnerHtml=mi;function pi(X){const Y=new Uint16Array(X.length);for(let Le=0;Le<Y.length;Le++)Y[Le]=X.charCodeAt(Le);let fe="";const Te=new Uint8Array(Y.buffer);for(let Le=0;Le<Te.length;Le++)fe+=String.fromCharCode(Te[Le]);return fe}function bi(X){return btoa(pi(X))}t.multibyteAwareBtoa=bi;class ft extends c.Emitter{constructor(){super(),this._subscriptions=new h.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(n(window,"keydown",Y=>{if(Y.defaultPrevented)return;const fe=new i.StandardKeyboardEvent(Y);if(!(fe.keyCode===6&&Y.repeat)){if(Y.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(Y.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(Y.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(Y.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(fe.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=Y.altKey,this._keyStatus.ctrlKey=Y.ctrlKey,this._keyStatus.metaKey=Y.metaKey,this._keyStatus.shiftKey=Y.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=Y,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(n(window,"keyup",Y=>{Y.defaultPrevented||(!Y.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!Y.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!Y.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!Y.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=Y.altKey,this._keyStatus.ctrlKey=Y.ctrlKey,this._keyStatus.metaKey=Y.metaKey,this._keyStatus.shiftKey=Y.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=Y,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(n(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(n(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(n(document.body,"mousemove",Y=>{Y.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(n(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.instance||(ft.instance=new ft),ft.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=ft;function vi(X){const Y=document.cookie.match("(^|[^;]+)\\s*"+X+"\\s*=\\s*([^;]+)");return Y?Y.pop():void 0}t.getCookieValue=vi;class Di extends h.Disposable{constructor(Y,fe){super(),this.element=Y,this.callbacks=fe,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(n(this.element,t.EventType.DRAG_ENTER,Y=>{this.counter++,this.dragStartTime=Y.timeStamp,this.callbacks.onDragEnter(Y)})),this._register(n(this.element,t.EventType.DRAG_OVER,Y=>{Y.preventDefault(),this.callbacks.onDragOver?.(Y,Y.timeStamp-this.dragStartTime)})),this._register(n(this.element,t.EventType.DRAG_LEAVE,Y=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(Y))})),this._register(n(this.element,t.EventType.DRAG_END,Y=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(Y)})),this._register(n(this.element,t.EventType.DROP,Y=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(Y)}))}}t.DragAndDropObserver=Di;const wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function yi(X,...Y){let fe,Te;Array.isArray(Y[0])?(fe={},Te=Y[0]):(fe=Y[0]||{},Te=Y[1]);const Le=wi.exec(X);if(!Le||!Le.groups)throw new Error("Bad use of h");const $e=Le.groups.tag||"div",We=document.createElement($e);Le.groups.id&&(We.id=Le.groups.id);const Ye=[];if(Le.groups.class)for(const je of Le.groups.class.split("."))je!==""&&Ye.push(je);if(fe.className!==void 0)for(const je of fe.className.split("."))je!==""&&Ye.push(je);Ye.length>0&&(We.className=Ye.join(" "));const st={};if(Le.groups.name&&(st[Le.groups.name]=We),Te)for(const je of Te)je instanceof HTMLElement?We.appendChild(je):typeof je=="string"?We.append(je):(Object.assign(st,je),We.appendChild(je.root));for(const[je,vt]of Object.entries(fe))if(je!=="className")if(je==="style")for(const[Et,Lt]of Object.entries(vt))We.style.setProperty(Ut(Et),typeof Lt=="number"?Lt+"px":""+Lt);else je==="tabIndex"?We.tabIndex=vt:We.setAttribute(Ut(je),vt.toString());return st.root=We,st}t.h=yi;function Ut(X){return X.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(me[51],pe([1,0,4,2,106]),function(te,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class z extends k.Disposable{constructor(c,l){super(),this._register((0,y.addDisposableListener)(c,"dragover",h=>{h.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{l(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(h=>{this._register((0,y.addDisposableListener)(c,h,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=z,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.Mimes.text};function b(_,c,l,h,P){const r=document.createElement("div");r.className=l,r.textContent=c,P&&(r.style.color=P),h&&(r.style.background=h),_.dataTransfer&&(document.body.appendChild(r),_.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>document.body.removeChild(r),0))}t.applyDragImage=b}),define(me[52],pe([1,0,4]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function k(r,a={}){const e=z(a);return e.textContent=r,e}t.renderText=k;function i(r,a={}){const e=z(a);return c(e,l(r,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.renderFormattedText=i;function z(r){const a=r.inline?"span":"div",e=document.createElement(a);return r.className&&(e.className=r.className),e}t.createElement=z;class b{constructor(a){this.source=a,this.index=0}eos(){return this.index>=this.source.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.source[this.index]}advance(){this.index++}}var _;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(_||(_={}));function c(r,a,e,o){let s;if(a.type===2)s=document.createTextNode(a.content||"");else if(a.type===3)s=document.createElement("b");else if(a.type===4)s=document.createElement("i");else if(a.type===7&&o)s=document.createElement("code");else if(a.type===5&&e){const u=document.createElement("a");e.disposables.add(y.addStandardDisposableListener(u,"click",n=>{e.callback(String(a.index),n)})),s=u}else a.type===8?s=document.createElement("br"):a.type===1&&(s=r);s&&r!==s&&r.appendChild(s),s&&Array.isArray(a.children)&&a.children.forEach(u=>{c(s,u,e,o)})}function l(r,a){const e={type:1,children:[]};let o=0,s=e;const u=[],n=new b(r);for(;!n.eos();){let D=n.next();const w=D==="\\"&&P(n.peek(),a)!==0;if(w&&(D=n.next()),!w&&h(D,a)&&D===n.peek()){n.advance(),s.type===2&&(s=u.pop());const S=P(D,a);if(s.type===S||s.type===5&&S===6)s=u.pop();else{const f={type:S,children:[]};S===5&&(f.index=o,o++),s.children.push(f),u.push(s),s=f}}else if(D===`
`)s.type===2&&(s=u.pop()),s.children.push({type:8});else if(s.type!==2){const S={type:2,content:D};s.children.push(S),u.push(s),s=S}else s.content+=D}return s.type===2&&(s=u.pop()),u.length,e}function h(r,a){return P(r,a)!==0}function P(r,a){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define(me[53],pe([1,0,4,2]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class i{constructor(){this._hooks=new k.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(b,_){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const c=this._onStopCallback;this._onStopCallback=null,b&&c&&c(_)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(b,_,c,l,h){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=l,this._onStopCallback=h;let P=b;try{b.setPointerCapture(_),this._hooks.add((0,k.toDisposable)(()=>{try{b.releasePointerCapture(_)}catch{}}))}catch{P=window}this._hooks.add(y.addDisposableListener(P,y.EventType.POINTER_MOVE,r=>{if(r.buttons!==c){this.stopMonitoring(!0);return}r.preventDefault(),this._pointerMoveCallback(r)})),this._hooks.add(y.addDisposableListener(P,y.EventType.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=i});var qe=this&&this.__decorate||function(te,t,y,k){var i=arguments.length,z=i<3?t:k===null?k=Object.getOwnPropertyDescriptor(t,y):k,b;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")z=Reflect.decorate(te,t,y,k);else for(var _=te.length-1;_>=0;_--)(b=te[_])&&(z=(i<3?b(z):i>3?b(t,y,z):b(t,y))||z);return i>3&&z&&Object.defineProperty(t,y,z),z};define(me[23],pe([1,0,4,13,25,2,43]),function(te,t,y,k,i,z,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var _;(function(l){l.Tap="-monaco-gesturetap",l.Change="-monaco-gesturechange",l.Start="-monaco-gesturestart",l.End="-monaco-gesturesend",l.Contextmenu="-monaco-gesturecontextmenu"})(_||(t.EventType=_={}));class c extends z.Disposable{constructor(){super(),this.dispatched=!1,this.targets=new b.LinkedList,this.ignoreTargets=new b.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(y.addDisposableListener(document,"touchstart",h=>this.onTouchStart(h),{passive:!1})),this._register(y.addDisposableListener(document,"touchend",h=>this.onTouchEnd(h))),this._register(y.addDisposableListener(document,"touchmove",h=>this.onTouchMove(h),{passive:!1}))}static addTarget(h){if(!c.isTouchDevice())return z.Disposable.None;c.INSTANCE||(c.INSTANCE=new c);const P=c.INSTANCE.targets.push(h);return(0,z.toDisposable)(P)}static ignoreTarget(h){if(!c.isTouchDevice())return z.Disposable.None;c.INSTANCE||(c.INSTANCE=new c);const P=c.INSTANCE.ignoreTargets.push(h);return(0,z.toDisposable)(P)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(h){const P=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let r=0,a=h.targetTouches.length;r<a;r++){const e=h.targetTouches.item(r);this.activeTouches[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:P,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[P],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const o=this.newGestureEvent(_.Start,e.target);o.pageX=e.pageX,o.pageY=e.pageY,this.dispatchEvent(o)}this.dispatched&&(h.preventDefault(),h.stopPropagation(),this.dispatched=!1)}onTouchEnd(h){const P=Date.now(),r=Object.keys(this.activeTouches).length;for(let a=0,e=h.changedTouches.length;a<e;a++){const o=h.changedTouches.item(a);if(!this.activeTouches.hasOwnProperty(String(o.identifier))){console.warn("move of an UNKNOWN touch",o);continue}const s=this.activeTouches[o.identifier],u=Date.now()-s.initialTimeStamp;if(u<c.HOLD_DELAY&&Math.abs(s.initialPageX-k.tail(s.rollingPageX))<30&&Math.abs(s.initialPageY-k.tail(s.rollingPageY))<30){const n=this.newGestureEvent(_.Tap,s.initialTarget);n.pageX=k.tail(s.rollingPageX),n.pageY=k.tail(s.rollingPageY),this.dispatchEvent(n)}else if(u>=c.HOLD_DELAY&&Math.abs(s.initialPageX-k.tail(s.rollingPageX))<30&&Math.abs(s.initialPageY-k.tail(s.rollingPageY))<30){const n=this.newGestureEvent(_.Contextmenu,s.initialTarget);n.pageX=k.tail(s.rollingPageX),n.pageY=k.tail(s.rollingPageY),this.dispatchEvent(n)}else if(r===1){const n=k.tail(s.rollingPageX),D=k.tail(s.rollingPageY),w=k.tail(s.rollingTimestamps)-s.rollingTimestamps[0],S=n-s.rollingPageX[0],f=D-s.rollingPageY[0],v=[...this.targets].filter(L=>s.initialTarget instanceof Node&&L.contains(s.initialTarget));this.inertia(v,P,Math.abs(S)/w,S>0?1:-1,n,Math.abs(f)/w,f>0?1:-1,D)}this.dispatchEvent(this.newGestureEvent(_.End,s.initialTarget)),delete this.activeTouches[o.identifier]}this.dispatched&&(h.preventDefault(),h.stopPropagation(),this.dispatched=!1)}newGestureEvent(h,P){const r=document.createEvent("CustomEvent");return r.initEvent(h,!1,!0),r.initialTarget=P,r.tapCount=0,r}dispatchEvent(h){if(h.type===_.Tap){const P=new Date().getTime();let r=0;P-this._lastSetTapCountTime>c.CLEAR_TAP_COUNT_TIME?r=1:r=2,this._lastSetTapCountTime=P,h.tapCount=r}else(h.type===_.Change||h.type===_.Contextmenu)&&(this._lastSetTapCountTime=0);if(h.initialTarget instanceof Node){for(const P of this.ignoreTargets)if(P.contains(h.initialTarget))return;for(const P of this.targets)P.contains(h.initialTarget)&&(P.dispatchEvent(h),this.dispatched=!0)}}inertia(h,P,r,a,e,o,s,u){this.handle=y.scheduleAtNextAnimationFrame(()=>{const n=Date.now(),D=n-P;let w=0,S=0,f=!0;r+=c.SCROLL_FRICTION*D,o+=c.SCROLL_FRICTION*D,r>0&&(f=!1,w=a*r*D),o>0&&(f=!1,S=s*o*D);const v=this.newGestureEvent(_.Change);v.translationX=w,v.translationY=S,h.forEach(L=>L.dispatchEvent(v)),f||this.inertia(h,n,r,a,e+w,o,s,u+S)})}onTouchMove(h){const P=Date.now();for(let r=0,a=h.changedTouches.length;r<a;r++){const e=h.changedTouches.item(r);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const o=this.activeTouches[e.identifier],s=this.newGestureEvent(_.Change,o.initialTarget);s.translationX=e.pageX-k.tail(o.rollingPageX),s.translationY=e.pageY-k.tail(o.rollingPageY),s.pageX=e.pageX,s.pageY=e.pageY,this.dispatchEvent(s),o.rollingPageX.length>3&&(o.rollingPageX.shift(),o.rollingPageY.shift(),o.rollingTimestamps.shift()),o.rollingPageX.push(e.pageX),o.rollingPageY.push(e.pageY),o.rollingTimestamps.push(P)}this.dispatched&&(h.preventDefault(),h.stopPropagation(),this.dispatched=!1)}}t.Gesture=c,c.SCROLL_FRICTION=-.005,c.HOLD_DELAY=700,c.CLEAR_TAP_COUNT_TIME=400,qe([i.memoize],c,"isTouchDevice",null)}),define(me[54],pe([1,0,4,5,83]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const i=2e4;let z,b,_,c,l;function h(e){z=document.createElement("div"),z.className="monaco-aria-container";const o=()=>{const u=document.createElement("div");return u.className="monaco-alert",u.setAttribute("role","alert"),u.setAttribute("aria-atomic","true"),z.appendChild(u),u};b=o(),_=o();const s=()=>{const u=document.createElement("div");return u.className="monaco-status",u.setAttribute("role","complementary"),u.setAttribute("aria-live","polite"),u.setAttribute("aria-atomic","true"),z.appendChild(u),u};c=s(),l=s(),e.appendChild(z)}t.setARIAContainer=h;function P(e){z&&(b.textContent!==e?(y.clearNode(_),a(b,e)):(y.clearNode(b),a(_,e)))}t.alert=P;function r(e){z&&(k.isMacintosh?P(e):c.textContent!==e?(y.clearNode(l),a(c,e)):(y.clearNode(c),a(l,e)))}t.status=r;function a(e,o){y.clearNode(e),o.length>i&&(o=o.substr(0,i)),e.textContent=o,e.style.visibility="hidden",e.style.visibility="visible"}}),define(me[115],pe([1,0,4,17]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const i=new RegExp(`(\\\\)?\\$\\((${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?)\\)`,"g");function z(_){const c=new Array;let l,h=0,P=0;for(;(l=i.exec(_))!==null;){P=l.index||0,h<P&&c.push(_.substring(h,P)),h=(l.index||0)+l[0].length;const[,r,a]=l;c.push(r?`$(${a})`:b({id:a}))}return h<_.length&&c.push(_.substring(h)),c}t.renderLabelWithIcons=z;function b(_){const c=y.$("span");return c.classList.add(...k.ThemeIcon.asClassNameArray(_)),c}t.renderIcon=b}),define(me[116],pe([1,0,4]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function k(z){try{z.parentElement?.removeChild(z)}catch{}}class i{constructor(b){this.renderers=b,this.cache=new Map,this.transactionNodesPendingRemoval=new Set,this.inTransaction=!1}alloc(b){let _=this.getTemplateCache(b).pop(),c=!1;if(_)c=this.transactionNodesPendingRemoval.has(_.domNode),c&&this.transactionNodesPendingRemoval.delete(_.domNode);else{const l=(0,y.$)(".monaco-list-row"),P=this.getRenderer(b).renderTemplate(l);_={domNode:l,templateId:b,templateData:P}}return{row:_,isReusingConnectedDomNode:c}}release(b){b&&this.releaseRow(b)}transact(b){if(this.inTransaction)throw new Error("Already in transaction");this.inTransaction=!0;try{b()}finally{for(const _ of this.transactionNodesPendingRemoval)this.doRemoveNode(_);this.transactionNodesPendingRemoval.clear(),this.inTransaction=!1}}releaseRow(b){const{domNode:_,templateId:c}=b;_&&(this.inTransaction?this.transactionNodesPendingRemoval.add(_):this.doRemoveNode(_)),this.getTemplateCache(c).push(b)}doRemoveNode(b){b.classList.remove("scrolling"),k(b)}getTemplateCache(b){let _=this.cache.get(b);return _||(_=[],this.cache.set(b,_)),_}dispose(){this.cache.forEach((b,_)=>{for(const c of b)this.getRenderer(_).disposeTemplate(c.templateData),c.templateData=null}),this.cache.clear(),this.transactionNodesPendingRemoval.clear()}getRenderer(b){const _=this.renderers.get(b);if(!_)throw new Error(`No renderer found for ${b}`);return _}}t.RowCache=i}),define(me[117],pe([1,0,9,2]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class i extends k.Disposable{constructor(b,_,c){super(),this._visibility=b,this._visibleClassName=_,this._invisibleClassName=c,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new y.TimeoutTimer)}setVisibility(b){this._visibility!==b&&(this._visibility=b,this._updateShouldBeVisible())}setShouldBeVisible(b){this._rawShouldBeVisible=b,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const b=this._applyVisibilitySetting();this._shouldBeVisible!==b&&(this._shouldBeVisible=b,this.ensureVisibility())}setIsNeeded(b){this._isNeeded!==b&&(this._isNeeded=b,this.ensureVisibility())}setDomNode(b){this._domNode=b,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(b){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(b?" fade":"")))}}t.ScrollbarVisibilityController=i}),define(me[118],pe([1,0,4,23,13,3,2,5]),function(te,t,y,k,i,z,b,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class c extends b.Disposable{constructor(h,P,r,a){super(),this.selected=0,this.selectBoxOptions=a||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new z.Emitter),this.styles=r,this.registerListeners(),this.setOptions(h,P)}registerListeners(){this._register(k.Gesture.addTarget(this.selectElement)),[k.EventType.Tap].forEach(h=>{this._register(y.addDisposableListener(this.selectElement,h,P=>{this.selectElement.focus()}))}),this._register(y.addStandardDisposableListener(this.selectElement,"click",h=>{y.EventHelper.stop(h,!0)})),this._register(y.addStandardDisposableListener(this.selectElement,"change",h=>{this.selectElement.title=h.target.value,this._onDidSelect.fire({index:h.target.selectedIndex,selected:h.target.value})})),this._register(y.addStandardDisposableListener(this.selectElement,"keydown",h=>{let P=!1;_.isMacintosh?(h.keyCode===18||h.keyCode===16||h.keyCode===10)&&(P=!0):(h.keyCode===18&&h.altKey||h.keyCode===10||h.keyCode===3)&&(P=!0),P&&h.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(h,P){(!this.options||!i.equals(this.options,h))&&(this.options=h,this.selectElement.options.length=0,this.options.forEach((r,a)=>{this.selectElement.add(this.createOption(r.text,a,r.isDisabled))})),P!==void 0&&this.select(P)}select(h){this.options.length===0?this.selected=0:h>=0&&h<this.options.length?this.selected=h:h>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(h){this.selectBoxOptions.ariaLabel=h,this.selectElement.setAttribute("aria-label",h)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(h){this.selectElement.tabIndex=h?0:-1}render(h){h.classList.add("select-container"),h.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(h){this.styles=h,this.applyStyles()}applyStyles(){this.selectElement&&(this.selectElement.style.backgroundColor=this.styles.selectBackground??"",this.selectElement.style.color=this.styles.selectForeground??"",this.selectElement.style.borderColor=this.styles.selectBorder??"")}createOption(h,P,r){const a=document.createElement("option");return a.value=h,a.text=h,a.disabled=!!r,a}}t.SelectBoxNative=c}),define(me[55],pe([1,0,24,13,9,46,112,3,26]),function(te,t,y,k,i,z,b,_,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function l(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.isFilterResult=l;function h(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.getVisibleState=h;function P(a){return typeof a.collapsible=="boolean"}class r{constructor(e,o,s,u={}){this.user=e,this.list=o,this.rootRef=[],this.eventBufferer=new _.EventBufferer,this._onDidChangeCollapseState=new _.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new _.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new _.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new i.Delayer(z.MicrotaskDelay),this.collapseByDefault=typeof u.collapseByDefault>"u"?!1:u.collapseByDefault,this.filter=u.filter,this.autoExpandSingleChildren=typeof u.autoExpandSingleChildren>"u"?!1:u.autoExpandSingleChildren,this.root={parent:void 0,element:s,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,o,s=c.Iterable.empty(),u={}){if(e.length===0)throw new y.TreeError(this.user,"Invalid tree location");u.diffIdentityProvider?this.spliceSmart(u.diffIdentityProvider,e,o,s,u):this.spliceSimple(e,o,s,u)}spliceSmart(e,o,s,u=c.Iterable.empty(),n,D=n.diffDepth??0){const{parentNode:w}=this.getParentNodeWithListIndex(o);if(!w.lastDiffIds)return this.spliceSimple(o,s,u,n);const S=[...u],f=o[o.length-1],v=new b.LcsDiff({getElements:()=>w.lastDiffIds},{getElements:()=>[...w.children.slice(0,f),...S,...w.children.slice(f+s)].map(m=>e.getId(m.element).toString())}).ComputeDiff(!1);if(v.quitEarly)return w.lastDiffIds=void 0,this.spliceSimple(o,s,S,n);const L=o.slice(0,-1),I=(m,p,O)=>{if(D>0)for(let G=0;G<O;G++)m--,p--,this.spliceSmart(e,[...L,m,0],Number.MAX_SAFE_INTEGER,S[p].children,n,D-1)};let E=Math.min(w.children.length,f+s),g=S.length;for(const m of v.changes.sort((p,O)=>O.originalStart-p.originalStart))I(E,g,E-(m.originalStart+m.originalLength)),E=m.originalStart,g=m.modifiedStart-f,this.spliceSimple([...L,E],m.originalLength,c.Iterable.slice(S,g,g+m.modifiedLength),n);I(E,g,E)}spliceSimple(e,o,s=c.Iterable.empty(),{onDidCreateNode:u,onDidDeleteNode:n,diffIdentityProvider:D}){const{parentNode:w,listIndex:S,revealed:f,visible:v}=this.getParentNodeWithListIndex(e),L=[],I=c.Iterable.map(s,ue=>this.createTreeNode(ue,w,w.visible?1:0,f,L,u)),E=e[e.length-1],g=w.children.length>0;let m=0;for(let ue=E;ue>=0&&ue<w.children.length;ue--){const de=w.children[ue];if(de.visible){m=de.visibleChildIndex;break}}const p=[];let O=0,G=0;for(const ue of I)p.push(ue),G+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=m+O++);const J=(0,k.splice)(w.children,E,o,p);D?w.lastDiffIds?(0,k.splice)(w.lastDiffIds,E,o,p.map(ue=>D.getId(ue.element).toString())):w.lastDiffIds=w.children.map(ue=>D.getId(ue.element).toString()):w.lastDiffIds=void 0;let ie=0;for(const ue of J)ue.visible&&ie++;if(ie!==0)for(let ue=E+p.length;ue<w.children.length;ue++){const de=w.children[ue];de.visible&&(de.visibleChildIndex-=ie)}if(w.visibleChildrenCount+=O-ie,f&&v){const ue=J.reduce((de,he)=>de+(he.visible?he.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(w,G-ue),this.list.splice(S,ue,L)}if(J.length>0&&n){const ue=de=>{n(de),de.children.forEach(ue)};J.forEach(ue)}this._onDidSplice.fire({insertedNodes:p,deletedNodes:J});const ae=w.children.length>0;g!==ae&&this.setCollapsible(e.slice(0,-1),ae);let ge=w;for(;ge;){if(ge.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}ge=ge.parent}}rerender(e){if(e.length===0)throw new y.TreeError(this.user,"Invalid tree location");const{node:o,listIndex:s,revealed:u}=this.getTreeNodeWithListIndex(e);o.visible&&u&&this.list.splice(s,1,[o])}updateElementHeight(e,o){if(e.length===0)throw new y.TreeError(this.user,"Invalid tree location");const{listIndex:s}=this.getTreeNodeWithListIndex(e);this.list.updateElementHeight(s,o)}has(e){return this.hasTreeNode(e)}getListIndex(e){const{listIndex:o,visible:s,revealed:u}=this.getTreeNodeWithListIndex(e);return s&&u?o:-1}getListRenderCount(e){return this.getTreeNode(e).renderNodeCount}isCollapsible(e){return this.getTreeNode(e).collapsible}setCollapsible(e,o){const s=this.getTreeNode(e);typeof o>"u"&&(o=!s.collapsible);const u={collapsible:o};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,u))}isCollapsed(e){return this.getTreeNode(e).collapsed}setCollapsed(e,o,s){const u=this.getTreeNode(e);typeof o>"u"&&(o=!u.collapsed);const n={collapsed:o,recursive:s||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,n))}_setCollapseState(e,o){const{node:s,listIndex:u,revealed:n}=this.getTreeNodeWithListIndex(e),D=this._setListNodeCollapseState(s,u,n,o);if(s!==this.root&&this.autoExpandSingleChildren&&D&&!P(o)&&s.collapsible&&!s.collapsed&&!o.recursive){let w=-1;for(let S=0;S<s.children.length;S++)if(s.children[S].visible)if(w>-1){w=-1;break}else w=S;w>-1&&this._setCollapseState([...e,w],o)}return D}_setListNodeCollapseState(e,o,s,u){const n=this._setNodeCollapseState(e,u,!1);if(!s||!e.visible||!n)return n;const D=e.renderNodeCount,w=this.updateNodeAfterCollapseChange(e),S=D-(o===-1?0:1);return this.list.splice(o+1,S,w.slice(1)),n}_setNodeCollapseState(e,o,s){let u;if(e===this.root?u=!1:(P(o)?(u=e.collapsible!==o.collapsible,e.collapsible=o.collapsible):e.collapsible?(u=e.collapsed!==o.collapsed,e.collapsed=o.collapsed):u=!1,u&&this._onDidChangeCollapseState.fire({node:e,deep:s})),!P(o)&&o.recursive)for(const n of e.children)u=this._setNodeCollapseState(n,o,!0)||u;return u}expandTo(e){this.eventBufferer.bufferEvents(()=>{let o=this.getTreeNode(e);for(;o.parent;)o=o.parent,e=e.slice(0,e.length-1),o.collapsed&&this._setCollapseState(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.root.renderNodeCount,o=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,e,o),this.refilterDelayer.cancel()}createTreeNode(e,o,s,u,n,D){const w={parent:o,element:e.element,children:[],depth:o.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.collapseByDefault:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},S=this._filterNode(w,s);w.visibility=S,u&&n.push(w);const f=e.children||c.Iterable.empty(),v=u&&S!==0&&!w.collapsed;let L=0,I=1;for(const E of f){const g=this.createTreeNode(E,w,S,v,n,D);w.children.push(g),I+=g.renderNodeCount,g.visible&&(g.visibleChildIndex=L++)}return w.collapsible=w.collapsible||w.children.length>0,w.visibleChildrenCount=L,w.visible=S===2?L>0:S===1,w.visible?w.collapsed||(w.renderNodeCount=I):(w.renderNodeCount=0,u&&n.pop()),D?.(w),w}updateNodeAfterCollapseChange(e){const o=e.renderNodeCount,s=[];return this._updateNodeAfterCollapseChange(e,s),this._updateAncestorsRenderNodeCount(e.parent,s.length-o),s}_updateNodeAfterCollapseChange(e,o){if(e.visible===!1)return 0;if(o.push(e),e.renderNodeCount=1,!e.collapsed)for(const s of e.children)e.renderNodeCount+=this._updateNodeAfterCollapseChange(s,o);return this._onDidChangeRenderNodeCount.fire(e),e.renderNodeCount}updateNodeAfterFilterChange(e){const o=e.renderNodeCount,s=[];return this._updateNodeAfterFilterChange(e,e.visible?1:0,s),this._updateAncestorsRenderNodeCount(e.parent,s.length-o),s}_updateNodeAfterFilterChange(e,o,s,u=!0){let n;if(e!==this.root){if(n=this._filterNode(e,o),n===0)return e.visible=!1,e.renderNodeCount=0,!1;u&&s.push(e)}const D=s.length;e.renderNodeCount=e===this.root?0:1;let w=!1;if(!e.collapsed||n!==0){let S=0;for(const f of e.children)w=this._updateNodeAfterFilterChange(f,n,s,u&&!e.collapsed)||w,f.visible&&(f.visibleChildIndex=S++);e.visibleChildrenCount=S}else e.visibleChildrenCount=0;return e!==this.root&&(e.visible=n===2?w:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=s.length-D):(e.renderNodeCount=0,u&&s.pop()),this._onDidChangeRenderNodeCount.fire(e),e.visible}_updateAncestorsRenderNodeCount(e,o){if(o!==0)for(;e;)e.renderNodeCount+=o,this._onDidChangeRenderNodeCount.fire(e),e=e.parent}_filterNode(e,o){const s=this.filter?this.filter.filter(e.element,o):1;return typeof s=="boolean"?(e.filterData=void 0,s?1:0):l(s)?(e.filterData=s.data,h(s.visibility)):(e.filterData=void 0,h(s))}hasTreeNode(e,o=this.root){if(!e||e.length===0)return!0;const[s,...u]=e;return s<0||s>o.children.length?!1:this.hasTreeNode(u,o.children[s])}getTreeNode(e,o=this.root){if(!e||e.length===0)return o;const[s,...u]=e;if(s<0||s>o.children.length)throw new y.TreeError(this.user,"Invalid tree location");return this.getTreeNode(u,o.children[s])}getTreeNodeWithListIndex(e){if(e.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:o,listIndex:s,revealed:u,visible:n}=this.getParentNodeWithListIndex(e),D=e[e.length-1];if(D<0||D>o.children.length)throw new y.TreeError(this.user,"Invalid tree location");const w=o.children[D];return{node:w,listIndex:s,revealed:u,visible:n&&w.visible}}getParentNodeWithListIndex(e,o=this.root,s=0,u=!0,n=!0){const[D,...w]=e;if(D<0||D>o.children.length)throw new y.TreeError(this.user,"Invalid tree location");for(let S=0;S<D;S++)s+=o.children[S].renderNodeCount;return u=u&&!o.collapsed,n=n&&o.visible,w.length===0?{parentNode:o,listIndex:s,revealed:u,visible:n}:this.getParentNodeWithListIndex(w,o.children[D],s+1,u,n)}getNode(e=[]){return this.getTreeNode(e)}getNodeLocation(e){const o=[];let s=e;for(;s.parent;)o.push(s.parent.children.indexOf(s)),s=s.parent;return o.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,k.tail2)(e)[0]}getFirstElementChild(e){const o=this.getTreeNode(e);if(o.children.length!==0)return o.children[0].element}getLastElementAncestor(e=[]){const o=this.getTreeNode(e);if(o.children.length!==0)return this._getLastElementAncestor(o)}_getLastElementAncestor(e){return e.children.length===0?e.element:this._getLastElementAncestor(e.children[e.children.length-1])}}t.IndexTreeModel=r}),define(me[119],pe([1,0,55,24,26]),function(te,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class z{get size(){return this.nodes.size}constructor(_,c,l={}){this.user=_,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new y.IndexTreeModel(_,c,null,l),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,l.sorter&&(this.sorter={compare(h,P){return l.sorter.compare(h.element,P.element)}}),this.identityProvider=l.identityProvider}setChildren(_,c=i.Iterable.empty(),l={}){const h=this.getElementLocation(_);this._setChildren(h,this.preserveCollapseState(c),l)}_setChildren(_,c=i.Iterable.empty(),l){const h=new Set,P=new Set,r=e=>{if(e.element===null)return;const o=e;if(h.add(o.element),this.nodes.set(o.element,o),this.identityProvider){const s=this.identityProvider.getId(o.element).toString();P.add(s),this.nodesByIdentity.set(s,o)}l.onDidCreateNode?.(o)},a=e=>{if(e.element===null)return;const o=e;if(h.has(o.element)||this.nodes.delete(o.element),this.identityProvider){const s=this.identityProvider.getId(o.element).toString();P.has(s)||this.nodesByIdentity.delete(s)}l.onDidDeleteNode?.(o)};this.model.splice([..._,0],Number.MAX_VALUE,c,{...l,onDidCreateNode:r,onDidDeleteNode:a})}preserveCollapseState(_=i.Iterable.empty()){return this.sorter&&(_=[..._].sort(this.sorter.compare.bind(this.sorter))),i.Iterable.map(_,c=>{let l=this.nodes.get(c.element);if(!l&&this.identityProvider){const r=this.identityProvider.getId(c.element).toString();l=this.nodesByIdentity.get(r)}if(!l){let r;return typeof c.collapsed>"u"?r=void 0:c.collapsed===k.ObjectTreeElementCollapseState.Collapsed||c.collapsed===k.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:c.collapsed===k.ObjectTreeElementCollapseState.Expanded||c.collapsed===k.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=!!c.collapsed,{...c,children:this.preserveCollapseState(c.children),collapsed:r}}const h=typeof c.collapsible=="boolean"?c.collapsible:l.collapsible;let P;return typeof c.collapsed>"u"||c.collapsed===k.ObjectTreeElementCollapseState.PreserveOrCollapsed||c.collapsed===k.ObjectTreeElementCollapseState.PreserveOrExpanded?P=l.collapsed:c.collapsed===k.ObjectTreeElementCollapseState.Collapsed?P=!0:c.collapsed===k.ObjectTreeElementCollapseState.Expanded?P=!1:P=!!c.collapsed,{...c,collapsible:h,collapsed:P,children:this.preserveCollapseState(c.children)}})}rerender(_){const c=this.getElementLocation(_);this.model.rerender(c)}updateElementHeight(_,c){const l=this.getElementLocation(_);this.model.updateElementHeight(l,c)}resort(_=null,c=!0){if(!this.sorter)return;const l=this.getElementLocation(_),h=this.model.getNode(l);this._setChildren(l,this.resortChildren(h,c),{})}resortChildren(_,c,l=!0){let h=[..._.children];return(c||l)&&(h=h.sort(this.sorter.compare.bind(this.sorter))),i.Iterable.map(h,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.resortChildren(P,c,!1)}))}getFirstElementChild(_=null){const c=this.getElementLocation(_);return this.model.getFirstElementChild(c)}getLastElementAncestor(_=null){const c=this.getElementLocation(_);return this.model.getLastElementAncestor(c)}has(_){return this.nodes.has(_)}getListIndex(_){const c=this.getElementLocation(_);return this.model.getListIndex(c)}getListRenderCount(_){const c=this.getElementLocation(_);return this.model.getListRenderCount(c)}isCollapsible(_){const c=this.getElementLocation(_);return this.model.isCollapsible(c)}setCollapsible(_,c){const l=this.getElementLocation(_);return this.model.setCollapsible(l,c)}isCollapsed(_){const c=this.getElementLocation(_);return this.model.isCollapsed(c)}setCollapsed(_,c,l){const h=this.getElementLocation(_);return this.model.setCollapsed(h,c,l)}expandTo(_){const c=this.getElementLocation(_);this.model.expandTo(c)}refilter(){this.model.refilter()}getNode(_=null){if(_===null)return this.model.getNode(this.model.rootRef);const c=this.nodes.get(_);if(!c)throw new k.TreeError(this.user,`Tree element not found: ${_}`);return c}getNodeLocation(_){return _.element}getParentNodeLocation(_){if(_===null)throw new k.TreeError(this.user,"Invalid getParentNodeLocation call");const c=this.nodes.get(_);if(!c)throw new k.TreeError(this.user,`Tree element not found: ${_}`);const l=this.model.getNodeLocation(c),h=this.model.getParentNodeLocation(l);return this.model.getNode(h).element}getElementLocation(_){if(_===null)return[];const c=this.nodes.get(_);if(!c)throw new k.TreeError(this.user,`Tree element not found: ${_}`);return this.model.getNodeLocation(c)}}t.ObjectTreeModel=z}),define(me[19],pe([1,0,4,14,21,23,2]),function(te,t,y,k,i,z,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class _ extends b.Disposable{onclick(l,h){this._register(y.addDisposableListener(l,y.EventType.CLICK,P=>h(new i.StandardMouseEvent(P))))}onmousedown(l,h){this._register(y.addDisposableListener(l,y.EventType.MOUSE_DOWN,P=>h(new i.StandardMouseEvent(P))))}onmouseover(l,h){this._register(y.addDisposableListener(l,y.EventType.MOUSE_OVER,P=>h(new i.StandardMouseEvent(P))))}onmouseleave(l,h){this._register(y.addDisposableListener(l,y.EventType.MOUSE_LEAVE,P=>h(new i.StandardMouseEvent(P))))}onkeydown(l,h){this._register(y.addDisposableListener(l,y.EventType.KEY_DOWN,P=>h(new k.StandardKeyboardEvent(P))))}onkeyup(l,h){this._register(y.addDisposableListener(l,y.EventType.KEY_UP,P=>h(new k.StandardKeyboardEvent(P))))}oninput(l,h){this._register(y.addDisposableListener(l,y.EventType.INPUT,h))}onblur(l,h){this._register(y.addDisposableListener(l,y.EventType.BLUR,h))}onfocus(l,h){this._register(y.addDisposableListener(l,y.EventType.FOCUS,h))}onchange(l,h){this._register(y.addDisposableListener(l,y.EventType.CHANGE,h))}ignoreGesture(l){return z.Gesture.ignoreTarget(l)}}t.Widget=_}),define(me[35],pe([1,0,53,19,9,17,4]),function(te,t,y,k,i,z,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class _ extends k.Widget{constructor(l){super(),this._onActivate=l.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=l.bgWidth+"px",this.bgDomNode.style.height=l.bgHeight+"px",typeof l.top<"u"&&(this.bgDomNode.style.top="0px"),typeof l.left<"u"&&(this.bgDomNode.style.left="0px"),typeof l.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof l.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=l.className,this.domNode.classList.add(...z.ThemeIcon.asClassNameArray(l.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof l.top<"u"&&(this.domNode.style.top=l.top+"px"),typeof l.left<"u"&&(this.domNode.style.left=l.left+"px"),typeof l.bottom<"u"&&(this.domNode.style.bottom=l.bottom+"px"),typeof l.right<"u"&&(this.domNode.style.right=l.right+"px"),this._pointerMoveMonitor=this._register(new y.GlobalPointerMoveMonitor),this._register(b.addStandardDisposableListener(this.bgDomNode,b.EventType.POINTER_DOWN,h=>this._arrowPointerDown(h))),this._register(b.addStandardDisposableListener(this.domNode,b.EventType.POINTER_DOWN,h=>this._arrowPointerDown(h))),this._pointerdownRepeatTimer=this._register(new i.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new i.TimeoutTimer)}_arrowPointerDown(l){if(!l.target||!(l.target instanceof Element))return;const h=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(h,200),this._pointerMoveMonitor.startMonitoring(l.target,l.pointerId,l.buttons,P=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),l.preventDefault()}}t.ScrollbarArrow=_}),define(me[56],pe([1,0,4,38,53,35,117,19,5]),function(te,t,y,k,i,z,b,_,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const l=140;class h extends _.Widget{constructor(r){super(),this._lazyRender=r.lazyRender,this._host=r.host,this._scrollable=r.scrollable,this._scrollByPage=r.scrollByPage,this._scrollbarState=r.scrollbarState,this._visibilityController=this._register(new b.ScrollbarVisibilityController(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new i.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,k.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(y.addDisposableListener(this.domNode.domNode,y.EventType.POINTER_DOWN,a=>this._domNodePointerDown(a)))}_createArrow(r){const a=this._register(new z.ScrollbarArrow(r));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}_createSlider(r,a,e,o){this.slider=(0,k.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof o=="number"&&this.slider.setHeight(o),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(y.addDisposableListener(this.slider.domNode,y.EventType.POINTER_DOWN,s=>{s.button===0&&(s.preventDefault(),this._sliderPointerDown(s))})),this.onclick(this.slider.domNode,s=>{s.leftButton&&s.stopPropagation()})}_onElementSize(r){return this._scrollbarState.setVisibleSize(r)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(r){return this._scrollbarState.setScrollSize(r)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(r){return this._scrollbarState.setScrollPosition(r)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){this._shouldRender&&(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(r){r.target===this.domNode.domNode&&this._onPointerDown(r)}delegatePointerDown(r){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this._scrollbarState.getSliderPosition(),o=a+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),s=this._sliderPointerPosition(r);e<=s&&s<=o?r.button===0&&(r.preventDefault(),this._sliderPointerDown(r)):this._onPointerDown(r)}_onPointerDown(r){let a,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")a=r.offsetX,e=r.offsetY;else{const s=y.getDomNodePagePosition(this.domNode.domNode);a=r.pageX-s.left,e=r.pageY-s.top}const o=this._pointerDownRelativePosition(a,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(o):this._scrollbarState.getDesiredScrollPositionFromOffset(o)),r.button===0&&(r.preventDefault(),this._sliderPointerDown(r))}_sliderPointerDown(r){if(!r.target||!(r.target instanceof Element))return;const a=this._sliderPointerPosition(r),e=this._sliderOrthogonalPointerPosition(r),o=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(r.target,r.pointerId,r.buttons,s=>{const u=this._sliderOrthogonalPointerPosition(s),n=Math.abs(u-e);if(c.isWindows&&n>l){this._setDesiredScrollPositionNow(o.getScrollPosition());return}const w=this._sliderPointerPosition(s)-a;this._setDesiredScrollPositionNow(o.getDesiredScrollPositionFromDelta(w))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(r){const a={};this.writeScrollPosition(a,r),this._scrollable.setScrollPositionNow(a)}updateScrollbarSize(r){this._updateScrollbarSize(r),this._scrollbarState.setScrollbarSize(r),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=h}),define(me[120],pe([1,0,21,56,35,39,16]),function(te,t,y,k,i,z,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class _ extends k.AbstractScrollbar{constructor(l,h,P){const r=l.getScrollDimensions(),a=l.getCurrentScrollPosition();if(super({lazyRender:h.lazyRender,host:P,scrollbarState:new z.ScrollbarState(h.horizontalHasArrows?h.arrowSize:0,h.horizontal===2?0:h.horizontalScrollbarSize,h.vertical===2?0:h.verticalScrollbarSize,r.width,r.scrollWidth,a.scrollLeft),visibility:h.horizontal,extraScrollbarClassName:"horizontal",scrollable:l,scrollByPage:h.scrollByPage}),h.horizontalHasArrows){const e=(h.arrowSize-i.ARROW_IMG_SIZE)/2,o=(h.horizontalScrollbarSize-i.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:b.Codicon.scrollbarButtonLeft,top:o,left:e,bottom:void 0,right:void 0,bgWidth:h.arrowSize,bgHeight:h.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:b.Codicon.scrollbarButtonRight,top:o,left:void 0,bottom:void 0,right:e,bgWidth:h.arrowSize,bgHeight:h.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((h.horizontalScrollbarSize-h.horizontalSliderSize)/2),0,void 0,h.horizontalSliderSize)}_updateSlider(l,h){this.slider.setWidth(l),this.slider.setLeft(h)}_renderDomNode(l,h){this.domNode.setWidth(l),this.domNode.setHeight(h),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(l){return this._shouldRender=this._onElementScrollSize(l.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(l.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(l.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(l,h){return l}_sliderPointerPosition(l){return l.pageX}_sliderOrthogonalPointerPosition(l){return l.pageY}_updateScrollbarSize(l){this.slider.setHeight(l)}writeScrollPosition(l,h){l.scrollLeft=h}updateOptions(l){this.updateScrollbarSize(l.horizontal===2?0:l.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(l.vertical===2?0:l.verticalScrollbarSize),this._visibilityController.setVisibility(l.horizontal),this._scrollByPage=l.scrollByPage}}t.HorizontalScrollbar=_}),define(me[121],pe([1,0,21,56,35,39,16]),function(te,t,y,k,i,z,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class _ extends k.AbstractScrollbar{constructor(l,h,P){const r=l.getScrollDimensions(),a=l.getCurrentScrollPosition();if(super({lazyRender:h.lazyRender,host:P,scrollbarState:new z.ScrollbarState(h.verticalHasArrows?h.arrowSize:0,h.vertical===2?0:h.verticalScrollbarSize,0,r.height,r.scrollHeight,a.scrollTop),visibility:h.vertical,extraScrollbarClassName:"vertical",scrollable:l,scrollByPage:h.scrollByPage}),h.verticalHasArrows){const e=(h.arrowSize-i.ARROW_IMG_SIZE)/2,o=(h.verticalScrollbarSize-i.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:b.Codicon.scrollbarButtonUp,top:e,left:o,bottom:void 0,right:void 0,bgWidth:h.verticalScrollbarSize,bgHeight:h.arrowSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:b.Codicon.scrollbarButtonDown,top:void 0,left:o,bottom:e,right:void 0,bgWidth:h.verticalScrollbarSize,bgHeight:h.arrowSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((h.verticalScrollbarSize-h.verticalSliderSize)/2),h.verticalSliderSize,void 0)}_updateSlider(l,h){this.slider.setHeight(l),this.slider.setTop(h)}_renderDomNode(l,h){this.domNode.setWidth(h),this.domNode.setHeight(l),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(l){return this._shouldRender=this._onElementScrollSize(l.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(l.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(l.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(l,h){return h}_sliderPointerPosition(l){return l.pageY}_sliderOrthogonalPointerPosition(l){return l.pageX}_updateScrollbarSize(l){this.slider.setWidth(l)}writeScrollPosition(l,h){l.scrollTop=h}updateOptions(l){this.updateScrollbarSize(l.vertical===2?0:l.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(l.vertical),this._scrollByPage=l.scrollByPage}}t.VerticalScrollbar=_}),define(me[57],pe([1,0,18,4,38,21,120,121,19,9,3,2,5,49,90]),function(te,t,y,k,i,z,b,_,c,l,h,P,r,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,o=50,s=!0;class u{constructor(I,E,g){this.timestamp=I,this.deltaX=E,this.deltaY=g,this.score=0}}class n{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let I=1,E=0,g=1,m=this._rear;do{const p=m===this._front?I:Math.pow(2,-g);if(I-=p,E+=this._memory[m].score*p,m===this._front)break;m=(this._capacity+m-1)%this._capacity,g++}while(!0);return E<=.5}acceptStandardWheelEvent(I){const E=window.devicePixelRatio/(0,y.getZoomFactor)();r.isWindows||r.isLinux?this.accept(Date.now(),I.deltaX/E,I.deltaY/E):this.accept(Date.now(),I.deltaX,I.deltaY)}accept(I,E,g){const m=new u(I,E,g);m.score=this._computeScore(m),this._front===-1&&this._rear===-1?(this._memory[0]=m,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=m)}_computeScore(I){if(Math.abs(I.deltaX)>0&&Math.abs(I.deltaY)>0)return 1;let E=.5;const g=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(I.deltaX)||!this._isAlmostInt(I.deltaY))&&(E+=.25),Math.min(Math.max(E,0),1)}_isAlmostInt(I){return Math.abs(Math.round(I)-I)<.01}}t.MouseWheelClassifier=n,n.INSTANCE=new n;class D extends c.Widget{get options(){return this._options}constructor(I,E,g){super(),this._onScroll=this._register(new h.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new h.Emitter),this.onWillScroll=this._onWillScroll.event,I.style.overflow="hidden",this._options=v(E),this._scrollable=g,this._register(this._scrollable.onScroll(p=>{this._onWillScroll.fire(p),this._onDidScroll(p),this._onScroll.fire(p)}));const m={onMouseWheel:p=>this._onMouseWheel(p),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new _.VerticalScrollbar(this._scrollable,this._options,m)),this._horizontalScrollbar=this._register(new b.HorizontalScrollbar(this._scrollable,this._options,m)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(I),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,i.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,i.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,i.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,p=>this._onMouseOver(p)),this.onmouseleave(this._listenOnDomNode,p=>this._onMouseLeave(p)),this._hideTimeout=this._register(new l.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,P.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(I){this._verticalScrollbar.delegatePointerDown(I)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(I){this._scrollable.setScrollDimensions(I,!1)}updateClassName(I){this._options.className=I,r.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(I){typeof I.handleMouseWheel<"u"&&(this._options.handleMouseWheel=I.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof I.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=I.mouseWheelScrollSensitivity),typeof I.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=I.fastScrollSensitivity),typeof I.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=I.scrollPredominantAxis),typeof I.horizontal<"u"&&(this._options.horizontal=I.horizontal),typeof I.vertical<"u"&&(this._options.vertical=I.vertical),typeof I.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=I.horizontalScrollbarSize),typeof I.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=I.verticalScrollbarSize),typeof I.scrollByPage<"u"&&(this._options.scrollByPage=I.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(I){this._revealOnScroll=I}delegateScrollFromMouseWheelEvent(I){this._onMouseWheel(new z.StandardWheelEvent(I))}_setListeningToMouseWheel(I){if(this._mouseWheelToDispose.length>0!==I&&(this._mouseWheelToDispose=(0,P.dispose)(this._mouseWheelToDispose),I)){const g=m=>{this._onMouseWheel(new z.StandardWheelEvent(m))};this._mouseWheelToDispose.push(k.addDisposableListener(this._listenOnDomNode,k.EventType.MOUSE_WHEEL,g,{passive:!1}))}}_onMouseWheel(I){const E=n.INSTANCE;s&&E.acceptStandardWheelEvent(I);let g=!1;if(I.deltaY||I.deltaX){let p=I.deltaY*this._options.mouseWheelScrollSensitivity,O=I.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(p)>=Math.abs(O)?O=0:p=0),this._options.flipAxes&&([p,O]=[O,p]);const G=!r.isMacintosh&&I.browserEvent&&I.browserEvent.shiftKey;(this._options.scrollYToX||G)&&!O&&(O=p,p=0),I.browserEvent&&I.browserEvent.altKey&&(O=O*this._options.fastScrollSensitivity,p=p*this._options.fastScrollSensitivity);const J=this._scrollable.getFutureScrollPosition();let ie={};if(p){const ae=o*p,ge=J.scrollTop-(ae<0?Math.floor(ae):Math.ceil(ae));this._verticalScrollbar.writeScrollPosition(ie,ge)}if(O){const ae=o*O,ge=J.scrollLeft-(ae<0?Math.floor(ae):Math.ceil(ae));this._horizontalScrollbar.writeScrollPosition(ie,ge)}ie=this._scrollable.validateScrollPosition(ie),(J.scrollLeft!==ie.scrollLeft||J.scrollTop!==ie.scrollTop)&&(s&&this._options.mouseWheelSmoothScroll&&E.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(ie):this._scrollable.setScrollPositionNow(ie),g=!0)}let m=g;!m&&this._options.alwaysConsumeMouseWheel&&(m=!0),!m&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(m=!0),m&&(I.preventDefault(),I.stopPropagation())}_onDidScroll(I){this._shouldRender=this._horizontalScrollbar.onDidScroll(I)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(I)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const I=this._scrollable.getCurrentScrollPosition(),E=I.scrollTop>0,g=I.scrollLeft>0,m=g?" left":"",p=E?" top":"",O=g||E?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${m}`),this._topShadowDomNode.setClassName(`shadow${p}`),this._topLeftShadowDomNode.setClassName(`shadow${O}${p}${m}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(I){this._mouseIsOver=!1,this._hide()}_onMouseOver(I){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=D;class w extends D{constructor(I,E){E=E||{},E.mouseWheelSmoothScroll=!1;const g=new a.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>k.scheduleAtNextAnimationFrame(m)});super(I,E,g),this._register(g)}setScrollPosition(I){this._scrollable.setScrollPositionNow(I)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=w;class S extends D{constructor(I,E,g){super(I,E,g)}setScrollPosition(I){I.reuseAnimation?this._scrollable.setScrollPositionSmooth(I,I.reuseAnimation):this._scrollable.setScrollPositionNow(I)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=S;class f extends D{constructor(I,E){E=E||{},E.mouseWheelSmoothScroll=!1;const g=new a.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>k.scheduleAtNextAnimationFrame(m)});super(I,E,g),this._register(g),this._element=I,this.onScroll(m=>{m.scrollTopChanged&&(this._element.scrollTop=m.scrollTop),m.scrollLeftChanged&&(this._element.scrollLeft=m.scrollLeft)}),this.scanDomNode()}setScrollPosition(I){this._scrollable.setScrollPositionNow(I)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=f;function v(L){const I={lazyRender:typeof L.lazyRender<"u"?L.lazyRender:!1,className:typeof L.className<"u"?L.className:"",useShadows:typeof L.useShadows<"u"?L.useShadows:!0,handleMouseWheel:typeof L.handleMouseWheel<"u"?L.handleMouseWheel:!0,flipAxes:typeof L.flipAxes<"u"?L.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof L.consumeMouseWheelIfScrollbarIsNeeded<"u"?L.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof L.alwaysConsumeMouseWheel<"u"?L.alwaysConsumeMouseWheel:!1,scrollYToX:typeof L.scrollYToX<"u"?L.scrollYToX:!1,mouseWheelScrollSensitivity:typeof L.mouseWheelScrollSensitivity<"u"?L.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof L.fastScrollSensitivity<"u"?L.fastScrollSensitivity:5,scrollPredominantAxis:typeof L.scrollPredominantAxis<"u"?L.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof L.mouseWheelSmoothScroll<"u"?L.mouseWheelSmoothScroll:!0,arrowSize:typeof L.arrowSize<"u"?L.arrowSize:11,listenOnDomNode:typeof L.listenOnDomNode<"u"?L.listenOnDomNode:null,horizontal:typeof L.horizontal<"u"?L.horizontal:1,horizontalScrollbarSize:typeof L.horizontalScrollbarSize<"u"?L.horizontalScrollbarSize:10,horizontalSliderSize:typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:0,horizontalHasArrows:typeof L.horizontalHasArrows<"u"?L.horizontalHasArrows:!1,vertical:typeof L.vertical<"u"?L.vertical:1,verticalScrollbarSize:typeof L.verticalScrollbarSize<"u"?L.verticalScrollbarSize:10,verticalHasArrows:typeof L.verticalHasArrows<"u"?L.verticalHasArrows:!1,verticalSliderSize:typeof L.verticalSliderSize<"u"?L.verticalSliderSize:0,scrollByPage:typeof L.scrollByPage<"u"?L.scrollByPage:!1};return I.horizontalSliderSize=typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:I.horizontalScrollbarSize,I.verticalSliderSize=typeof L.verticalSliderSize<"u"?L.verticalSliderSize:I.verticalScrollbarSize,r.isMacintosh&&(I.className+=" mac"),I}}),define(me[58],pe([1,0,51,4,20,23,57,13,9,25,3,2,45,49,79,116,7]),function(te,t,y,k,i,z,b,_,c,l,h,P,r,a,e,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const u={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(I){return[I]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class D{get context(){return this._context}set context(E){this._context=E}constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=D;class w{constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=w;class S{constructor(){this.types=[],this.files=[]}update(E){if(E.types&&this.types.splice(0,this.types.length,...E.types),E.files){this.files.splice(0,this.files.length);for(let g=0;g<E.files.length;g++){const m=E.files.item(g);m&&(m.size||m.type)&&this.files.push(m)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=S;function f(I,E){return Array.isArray(I)&&Array.isArray(E)?(0,_.equals)(I,E):I===E}class v{constructor(E){E?.getSetSize?this.getSetSize=E.getSetSize.bind(E):this.getSetSize=(g,m,p)=>p,E?.getPosInSet?this.getPosInSet=E.getPosInSet.bind(E):this.getPosInSet=(g,m)=>m+1,E?.getRole?this.getRole=E.getRole.bind(E):this.getRole=g=>"listitem",E?.isChecked?this.isChecked=E.isChecked.bind(E):this.isChecked=g=>{}}}class L{get contentHeight(){return this.rangeMap.size}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(E){if(E!==this._horizontalScrolling){if(E&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=E,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const g of this.items)this.measureItemWidth(g);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,k.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(E,g,m,p=n){if(this.virtualDelegate=g,this.domId=`list_id_${++L.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new c.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=P.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=P.Disposable.None,this.onDragLeaveTimeout=P.Disposable.None,this.disposables=new P.DisposableStore,this._onDidChangeContentHeight=new h.Emitter,this.onDidChangeContentHeight=h.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this._horizontalScrolling=!1,p.horizontalScrolling&&p.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new e.RangeMap;for(const G of m)this.renderers.set(G.templateId,G);this.cache=this.disposables.add(new o.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof p.mouseSupport=="boolean"?p.mouseSupport:!0),this._horizontalScrolling=p.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof p.additionalScrollHeight>"u"?0:p.additionalScrollHeight,this.accessibilityProvider=new v(p.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(p.transformOptimization??n.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)",this.rowsContainer.style.overflow="hidden",this.rowsContainer.style.contain="strict"),this.disposables.add(z.Gesture.addTarget(this.rowsContainer)),this.scrollable=new a.Scrollable({forceIntegerValues:!0,smoothScrollDuration:p.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:G=>(0,k.scheduleAtNextAnimationFrame)(G)}),this.scrollableElement=this.disposables.add(new b.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:p.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:p.verticalScrollMode??n.verticalScrollMode,useShadows:p.useShadows??n.useShadows,mouseWheelScrollSensitivity:p.mouseWheelScrollSensitivity,fastScrollSensitivity:p.fastScrollSensitivity,scrollByPage:p.scrollByPage},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),E.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,k.addDisposableListener)(this.rowsContainer,z.EventType.Change,G=>this.onTouchChange(G))),this.disposables.add((0,k.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",G=>G.target.scrollTop=0)),this.disposables.add((0,k.addDisposableListener)(this.domNode,"dragover",G=>this.onDragOver(this.toDragEvent(G)))),this.disposables.add((0,k.addDisposableListener)(this.domNode,"drop",G=>this.onDrop(this.toDragEvent(G)))),this.disposables.add((0,k.addDisposableListener)(this.domNode,"dragleave",G=>this.onDragLeave(this.toDragEvent(G)))),this.disposables.add((0,k.addDisposableListener)(this.domNode,"dragend",G=>this.onDragEnd(G))),this.setRowLineHeight=p.setRowLineHeight??n.setRowLineHeight,this.setRowHeight=p.setRowHeight??n.setRowHeight,this.supportDynamicHeights=p.supportDynamicHeights??n.supportDynamicHeights,this.dnd=p.dnd??n.dnd,this.layout(p.initialSize?.height,p.initialSize?.width)}updateOptions(E){E.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=E.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),E.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(E.smoothScrolling?125:0),E.horizontalScrolling!==void 0&&(this.horizontalScrolling=E.horizontalScrolling);let g;E.scrollByPage!==void 0&&(g={...g??{},scrollByPage:E.scrollByPage}),E.mouseWheelScrollSensitivity!==void 0&&(g={...g??{},mouseWheelScrollSensitivity:E.mouseWheelScrollSensitivity}),E.fastScrollSensitivity!==void 0&&(g={...g??{},fastScrollSensitivity:E.fastScrollSensitivity}),g&&this.scrollableElement.updateOptions(g)}delegateScrollFromMouseWheelEvent(E){this.scrollableElement.delegateScrollFromMouseWheelEvent(E)}delegateVerticalScrollbarPointerDown(E){this.scrollableElement.delegateVerticalScrollbarPointerDown(E)}updateElementHeight(E,g,m){if(E<0||E>=this.items.length)return;const p=this.items[E].size;if(typeof g>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[E].lastDynamicHeightWidth=void 0,g=p+this.probeDynamicHeight(E)}if(p===g)return;const O=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let G=0;E<O.start||m!==null&&m>E&&m<=O.end?G=g-p:G=0,this.rangeMap.splice(E,1,[{size:g}]),this.items[E].size=g,this.render(O,Math.max(0,this.lastRenderTop+G),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(E,g,m=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(E,g,m)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(E,g,m=[]){const p=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),O={start:E,end:E+g},G=r.Range.intersect(p,O),J=new Map;for(let K=G.end-1;K>=G.start;K--){const A=this.items[K];if(A.dragStartDisposable.dispose(),A.checkedDisposable.dispose(),A.row){let W=J.get(A.templateId);W||(W=[],J.set(A.templateId,W));const N=this.renderers.get(A.templateId);N&&N.disposeElement&&N.disposeElement(A.element,K,A.row.templateData,A.size),W.push(A.row)}A.row=null}const ie={start:E+g,end:this.items.length},ae=r.Range.intersect(ie,p),ge=r.Range.relativeComplement(ie,p),ue=m.map(K=>({id:String(this.itemId++),element:K,templateId:this.virtualDelegate.getTemplateId(K),size:this.virtualDelegate.getHeight(K),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(K),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.Disposable.None,checkedDisposable:P.Disposable.None}));let de;E===0&&g>=this.items.length?(this.rangeMap=new e.RangeMap,this.rangeMap.splice(0,0,ue),de=this.items,this.items=ue):(this.rangeMap.splice(E,g,ue),de=this.items.splice(E,g,...ue));const he=m.length-g,Se=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),_e=(0,e.shift)(ae,he),Oe=r.Range.intersect(Se,_e);for(let K=Oe.start;K<Oe.end;K++)this.updateItemInDOM(this.items[K],K);const re=r.Range.relativeComplement(_e,Se);for(const K of re)for(let A=K.start;A<K.end;A++)this.removeItemFromDOM(A);const se=ge.map(K=>(0,e.shift)(K,he)),oe=[{start:E,end:E+m.length},...se].map(K=>r.Range.intersect(Se,K)),V=this.getNextToLastElement(oe);for(const K of oe)for(let A=K.start;A<K.end;A++){const W=this.items[A],d=J.get(W.templateId)?.pop();this.insertItemInDOM(A,V,d)}for(const K of J.values())for(const A of K)this.cache.release(A);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),de.map(K=>K.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,k.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let E=0;for(const g of this.items)typeof g.width<"u"&&(E=Math.max(E,g.width));this.scrollWidth=E,this.scrollableElement.setScrollDimensions({scrollWidth:E===0?0:E+10})}updateWidth(E){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const g=this.items[E];this.measureItemWidth(g),typeof g.width<"u"&&g.width>this.scrollWidth&&(this.scrollWidth=g.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}))}rerender(){if(this.supportDynamicHeights){for(const E of this.items)E.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const E=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),g=this.rangeMap.positionAt(E.start),m=this.rangeMap.positionAt(E.start+1);return m!==-1&&(m-g)/2+g<this.scrollTop?E.start+1:E.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(E){return this.items[E].element}indexOf(E){return this.items.findIndex(g=>g.element===E)}domElement(E){const g=this.items[E].row;return g&&g.domNode}elementHeight(E){return this.items[E].size}elementTop(E){return this.rangeMap.positionAt(E)}indexAt(E){return this.rangeMap.indexAt(E)}indexAfter(E){return this.rangeMap.indexAfter(E)}layout(E,g){const m={height:typeof E=="number"?E:(0,k.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,m.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(m),typeof g<"u"&&(this.renderWidth=g,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof g=="number"?g:(0,k.getContentWidth)(this.domNode)})}render(E,g,m,p,O,G=!1){const J=this.getRenderRange(g,m),ie=r.Range.relativeComplement(J,E),ae=r.Range.relativeComplement(E,J),ge=this.getNextToLastElement(ie);if(G){const ue=r.Range.intersect(E,J);for(let de=ue.start;de<ue.end;de++)this.updateItemInDOM(this.items[de],de)}this.cache.transact(()=>{for(const ue of ae)for(let de=ue.start;de<ue.end;de++)this.removeItemFromDOM(de);for(const ue of ie)for(let de=ue.start;de<ue.end;de++)this.insertItemInDOM(de,ge)}),p!==void 0&&(this.rowsContainer.style.left=`-${p}px`),this.rowsContainer.style.top=`-${g}px`,this.horizontalScrolling&&O!==void 0&&(this.rowsContainer.style.width=`${Math.max(O,this.renderWidth)}px`),this.lastRenderTop=g,this.lastRenderHeight=m}insertItemInDOM(E,g,m){const p=this.items[E];let O=!1;if(!p.row)if(m)p.row=m;else{const ge=this.cache.alloc(p.templateId);p.row=ge.row,O=ge.isReusingConnectedDomNode}const G=this.accessibilityProvider.getRole(p.element)||"listitem";p.row.domNode.setAttribute("role",G);const J=this.accessibilityProvider.isChecked(p.element);if(typeof J=="boolean")p.row.domNode.setAttribute("aria-checked",String(!!J));else if(J){const ge=ue=>p.row.domNode.setAttribute("aria-checked",String(!!ue));ge(J.value),p.checkedDisposable=J.onDidChange(ge)}(O||!p.row.domNode.parentElement)&&(g?this.rowsContainer.insertBefore(p.row.domNode,g):this.rowsContainer.appendChild(p.row.domNode)),this.updateItemInDOM(p,E);const ie=this.renderers.get(p.templateId);if(!ie)throw new Error(`No renderer found for template id ${p.templateId}`);ie?.renderElement(p.element,E,p.row.templateData,p.size);const ae=this.dnd.getDragURI(p.element);p.dragStartDisposable.dispose(),p.row.domNode.draggable=!!ae,ae&&(p.dragStartDisposable=(0,k.addDisposableListener)(p.row.domNode,"dragstart",ge=>this.onDragStart(p.element,ae,ge))),this.horizontalScrolling&&(this.measureItemWidth(p),this.eventuallyUpdateScrollWidth())}measureItemWidth(E){if(!E.row||!E.row.domNode)return;E.row.domNode.style.width="fit-content",E.width=(0,k.getContentWidth)(E.row.domNode);const g=window.getComputedStyle(E.row.domNode);g.paddingLeft&&(E.width+=parseFloat(g.paddingLeft)),g.paddingRight&&(E.width+=parseFloat(g.paddingRight)),E.row.domNode.style.width=""}updateItemInDOM(E,g){E.row.domNode.style.top=`${this.elementTop(g)}px`,this.setRowHeight&&(E.row.domNode.style.height=`${E.size}px`),this.setRowLineHeight&&(E.row.domNode.style.lineHeight=`${E.size}px`),E.row.domNode.setAttribute("data-index",`${g}`),E.row.domNode.setAttribute("data-last-element",g===this.length-1?"true":"false"),E.row.domNode.setAttribute("data-parity",g%2===0?"even":"odd"),E.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(E.element,g,this.length))),E.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(E.element,g))),E.row.domNode.setAttribute("id",this.getElementDomId(g)),E.row.domNode.classList.toggle("drop-target",E.dropTarget)}removeItemFromDOM(E){const g=this.items[E];if(g.dragStartDisposable.dispose(),g.checkedDisposable.dispose(),g.row){const m=this.renderers.get(g.templateId);m&&m.disposeElement&&m.disposeElement(g.element,E,g.row.templateData,g.size),this.cache.release(g.row),g.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(E,g){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:E,reuseAnimation:g})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(E){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:E})}get scrollTop(){return this.getScrollTop()}set scrollTop(E){this.setScrollTop(E)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"click")).event,E=>this.toMouseEvent(E),this.disposables)}get onMouseDblClick(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"dblclick")).event,E=>this.toMouseEvent(E),this.disposables)}get onMouseMiddleClick(){return h.Event.filter(h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"auxclick")).event,E=>this.toMouseEvent(E),this.disposables),E=>E.browserEvent.button===1,this.disposables)}get onMouseUp(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mouseup")).event,E=>this.toMouseEvent(E),this.disposables)}get onMouseDown(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mousedown")).event,E=>this.toMouseEvent(E),this.disposables)}get onMouseOver(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mouseover")).event,E=>this.toMouseEvent(E),this.disposables)}get onMouseMove(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mousemove")).event,E=>this.toMouseEvent(E),this.disposables)}get onMouseOut(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mouseout")).event,E=>this.toMouseEvent(E),this.disposables)}get onContextMenu(){return h.Event.any(h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"contextmenu")).event,E=>this.toMouseEvent(E),this.disposables),h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,z.EventType.Contextmenu)).event,E=>this.toGestureEvent(E),this.disposables))}get onTouchStart(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"touchstart")).event,E=>this.toTouchEvent(E),this.disposables)}get onTap(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.rowsContainer,z.EventType.Tap)).event,E=>this.toGestureEvent(E),this.disposables)}toMouseEvent(E){const g=this.getItemIndexFromEventTarget(E.target||null),m=typeof g>"u"?void 0:this.items[g],p=m&&m.element;return{browserEvent:E,index:g,element:p}}toTouchEvent(E){const g=this.getItemIndexFromEventTarget(E.target||null),m=typeof g>"u"?void 0:this.items[g],p=m&&m.element;return{browserEvent:E,index:g,element:p}}toGestureEvent(E){const g=this.getItemIndexFromEventTarget(E.initialTarget||null),m=typeof g>"u"?void 0:this.items[g],p=m&&m.element;return{browserEvent:E,index:g,element:p}}toDragEvent(E){const g=this.getItemIndexFromEventTarget(E.target||null),m=typeof g>"u"?void 0:this.items[g],p=m&&m.element;return{browserEvent:E,index:g,element:p}}onScroll(E){try{const g=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(g,E.scrollTop,E.height,E.scrollLeft,E.scrollWidth),this.supportDynamicHeights&&this._rerender(E.scrollTop,E.height,E.inSmoothScrolling)}catch(g){throw console.error("Got bad scroll event:",E),g}}onTouchChange(E){E.preventDefault(),E.stopPropagation(),this.scrollTop-=E.translationY}onDragStart(E,g,m){if(!m.dataTransfer)return;const p=this.dnd.getDragElements(E);if(m.dataTransfer.effectAllowed="copyMove",m.dataTransfer.setData(y.DataTransfers.TEXT,g),m.dataTransfer.setDragImage){let O;this.dnd.getDragLabel&&(O=this.dnd.getDragLabel(p,m)),typeof O>"u"&&(O=String(p.length));const G=(0,k.$)(".monaco-drag-image");G.textContent=O;const ie=(ae=>{for(;ae&&!ae.classList.contains("monaco-workbench");)ae=ae.parentElement;return ae||document.body})(this.domNode);ie.appendChild(G),m.dataTransfer.setDragImage(G,-10,-10),setTimeout(()=>ie.removeChild(G),0)}this.domNode.classList.add("dragging"),this.currentDragData=new D(p),u.CurrentDragAndDropData=new w(p),this.dnd.onDragStart?.(this.currentDragData,m)}onDragOver(E){if(E.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),u.CurrentDragAndDropData&&u.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(E.browserEvent),!E.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(u.CurrentDragAndDropData)this.currentDragData=u.CurrentDragAndDropData;else{if(!E.browserEvent.dataTransfer.types)return!1;this.currentDragData=new S}const g=this.dnd.onDragOver(this.currentDragData,E.element,E.index,E.browserEvent);if(this.canDrop=typeof g=="boolean"?g:g.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;E.browserEvent.dataTransfer.dropEffect=typeof g!="boolean"&&g.effect===0?"copy":"move";let m;if(typeof g!="boolean"&&g.feedback?m=g.feedback:typeof E.index>"u"?m=[-1]:m=[E.index],m=(0,_.distinct)(m).filter(p=>p>=-1&&p<this.length).sort((p,O)=>p-O),m=m[0]===-1?[-1]:m,f(this.currentDragFeedback,m))return!0;if(this.currentDragFeedback=m,this.currentDragFeedbackDisposable.dispose(),m[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,P.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const p of m){const O=this.items[p];O.dropTarget=!0,O.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,P.toDisposable)(()=>{for(const p of m){const O=this.items[p];O.dropTarget=!1,O.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(E){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,c.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,E.element,E.index,E.browserEvent)}onDrop(E){if(!this.canDrop)return;const g=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,u.CurrentDragAndDropData=void 0,!(!g||!E.browserEvent.dataTransfer)&&(E.browserEvent.preventDefault(),g.update(E.browserEvent.dataTransfer),this.dnd.drop(g,E.element,E.index,E.browserEvent))}onDragEnd(E){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,u.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(E)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=P.Disposable.None}setupDragAndDropScrollTopAnimation(E){if(!this.dragOverAnimationDisposable){const g=(0,k.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,k.animate)(this.animateDragAndDropScrollTop.bind(this,g))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,c.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=E.pageY}animateDragAndDropScrollTop(E){if(this.dragOverMouseY===void 0)return;const g=this.dragOverMouseY-E,m=this.renderHeight-35;g<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(g-35))):g>m&&(this.scrollTop+=Math.min(14,Math.floor(.3*(g-m))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(E){const g=this.scrollableElement.getDomNode();let m=E;for(;m instanceof HTMLElement&&m!==this.rowsContainer&&g.contains(m);){const p=m.getAttribute("data-index");if(p){const O=Number(p);if(!isNaN(O))return O}m=m.parentElement}}getRenderRange(E,g){return{start:this.rangeMap.indexAt(E),end:this.rangeMap.indexAfter(E+g-1)}}_rerender(E,g,m){const p=this.getRenderRange(E,g);let O,G;E===this.elementTop(p.start)?(O=p.start,G=0):p.end-p.start>1&&(O=p.start+1,G=this.elementTop(O)-E);let J=0;for(;;){const ie=this.getRenderRange(E,g);let ae=!1;for(let ge=ie.start;ge<ie.end;ge++){const ue=this.probeDynamicHeight(ge);ue!==0&&this.rangeMap.splice(ge,1,[this.items[ge]]),J+=ue,ae=ae||ue!==0}if(!ae){J!==0&&this.eventuallyUpdateScrollDimensions();const ge=r.Range.relativeComplement(p,ie);for(const de of ge)for(let he=de.start;he<de.end;he++)this.items[he].row&&this.removeItemFromDOM(he);const ue=r.Range.relativeComplement(ie,p);for(const de of ue)for(let he=de.start;he<de.end;he++){const Se=he+1,_e=Se<this.items.length?this.items[Se].row:null,Oe=_e?_e.domNode:null;this.insertItemInDOM(he,Oe)}for(let de=ie.start;de<ie.end;de++)this.items[de].row&&this.updateItemInDOM(this.items[de],de);if(typeof O=="number"){const de=this.scrollable.getFutureScrollPosition().scrollTop-E,he=this.elementTop(O)-G+de;this.setScrollTop(he,m)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(E){const g=this.items[E];if(this.virtualDelegate.getDynamicHeight){const G=this.virtualDelegate.getDynamicHeight(g.element);if(G!==null){const J=g.size;return g.size=G,g.lastDynamicHeightWidth=this.renderWidth,G-J}}if(!g.hasDynamicHeight||g.lastDynamicHeightWidth===this.renderWidth||this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(g.element))return 0;const m=g.size;if(g.row)return g.row.domNode.style.height="",g.size=g.row.domNode.offsetHeight,g.lastDynamicHeightWidth=this.renderWidth,g.size-m;const{row:p}=this.cache.alloc(g.templateId);p.domNode.style.height="",this.rowsContainer.appendChild(p.domNode);const O=this.renderers.get(g.templateId);if(!O)throw new s.BugIndicatingError("Missing renderer for templateId: "+g.templateId);return O.renderElement(g.element,E,p.templateData,void 0),g.size=p.domNode.offsetHeight,O.disposeElement?.(g.element,E,p.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(g.element,g.size),g.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(p.domNode),this.cache.release(p),g.size-m}getNextToLastElement(E){const g=E[E.length-1];if(!g)return null;const m=this.items[g.end];return!m||!m.row?null:m.row.domNode}getElementDomId(E){return`${this.domId}_${E}`}dispose(){if(this.items){for(const E of this.items)if(E.row){const g=this.renderers.get(E.row.templateId);g&&(g.disposeElement?.(E.element,-1,E.row.templateData,void 0),g.disposeTemplate(E.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,P.dispose)(this.disposables)}}t.ListView=L,L.InstanceCount=0,qe([l.memoize],L.prototype,"onMouseClick",null),qe([l.memoize],L.prototype,"onMouseDblClick",null),qe([l.memoize],L.prototype,"onMouseMiddleClick",null),qe([l.memoize],L.prototype,"onMouseUp",null),qe([l.memoize],L.prototype,"onMouseDown",null),qe([l.memoize],L.prototype,"onMouseOver",null),qe([l.memoize],L.prototype,"onMouseMove",null),qe([l.memoize],L.prototype,"onMouseOut",null),qe([l.memoize],L.prototype,"onContextMenu",null),qe([l.memoize],L.prototype,"onTouchStart",null),qe([l.memoize],L.prototype,"onTap",null)}),define(me[36],pe([1,0,4,20,14,23,54,68,13,9,70,25,3,32,2,44,5,6,67,58,89]),function(te,t,y,k,i,z,b,_,c,l,h,P,r,a,e,o,s,u,n,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class w{constructor(A){this.trait=A,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(A){return A}renderElement(A,W,N){const d=this.renderedElements.findIndex(R=>R.templateData===N);if(d>=0){const R=this.renderedElements[d];this.trait.unrender(N),R.index=W}else{const R={index:W,templateData:N};this.renderedElements.push(R)}this.trait.renderIndex(W,N)}splice(A,W,N){const d=[];for(const R of this.renderedElements)R.index<A?d.push(R):R.index>=A+W&&d.push({index:R.index+N-W,templateData:R.templateData});this.renderedElements=d}renderIndexes(A){for(const{index:W,templateData:N}of this.renderedElements)A.indexOf(W)>-1&&this.trait.renderIndex(W,N)}disposeTemplate(A){const W=this.renderedElements.findIndex(N=>N.templateData===A);W<0||this.renderedElements.splice(W,1)}}class S{get name(){return this._trait}get renderer(){return new w(this)}constructor(A){this._trait=A,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new r.Emitter,this.onChange=this._onChange.event}splice(A,W,N){W=Math.max(0,Math.min(W,this.length-A));const d=N.length-W,R=A+W,$=[...this.sortedIndexes.filter(T=>T<A),...N.map((T,F)=>T?F+A:-1).filter(T=>T!==-1),...this.sortedIndexes.filter(T=>T>=R).map(T=>T+d)],Z=this.length+d;if(this.sortedIndexes.length>0&&$.length===0&&Z>0){const T=this.sortedIndexes.find(F=>F>=A)??Z-1;$.push(Math.min(T,Z-1))}this.renderer.splice(A,W,N.length),this._set($,$),this.length=Z}renderIndex(A,W){W.classList.toggle(this._trait,this.contains(A))}unrender(A){A.classList.remove(this._trait)}set(A,W){return this._set(A,[...A].sort(re),W)}_set(A,W,N){const d=this.indexes,R=this.sortedIndexes;this.indexes=A,this.sortedIndexes=W;const $=_e(R,A);return this.renderer.renderIndexes($),this._onChange.fire({indexes:A,browserEvent:N}),d}get(){return this.indexes}contains(A){return(0,c.binarySearch)(this.sortedIndexes,A,re)>=0}dispose(){(0,e.dispose)(this._onChange)}}qe([P.memoize],S.prototype,"renderer",null);class f extends S{constructor(A){super("selected"),this.setAriaSelected=A}renderIndex(A,W){super.renderIndex(A,W),this.setAriaSelected&&(this.contains(A)?W.setAttribute("aria-selected","true"):W.setAttribute("aria-selected","false"))}}class v{constructor(A,W,N){this.trait=A,this.view=W,this.identityProvider=N}splice(A,W,N){if(!this.identityProvider)return this.trait.splice(A,W,N.map(()=>!1));const d=this.trait.get().map($=>this.identityProvider.getId(this.view.element($)).toString()),R=N.map($=>d.indexOf(this.identityProvider.getId($).toString())>-1);this.trait.splice(A,W,R)}}function L(K){return K.tagName==="INPUT"||K.tagName==="TEXTAREA"}t.isInputElement=L;function I(K){return K.classList.contains("monaco-editor")?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:I(K.parentElement)}t.isMonacoEditor=I;function E(K){return K.tagName==="A"&&K.classList.contains("monaco-button")||K.tagName==="DIV"&&K.classList.contains("monaco-button-dropdown")?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:E(K.parentElement)}t.isButton=E;class g{get onKeyDown(){return this.disposables.add(r.Event.chain(this.disposables.add(new k.DomEmitter(this.view.domNode,"keydown")).event).filter(A=>!L(A.target)).map(A=>new i.StandardKeyboardEvent(A)))}constructor(A,W,N){this.list=A,this.view=W,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter(d=>d.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter(d=>d.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter(d=>d.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter(d=>d.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter(d=>d.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter(d=>d.keyCode===9).on(this.onEscape,this,this.disposables),N.multipleSelectionSupport!==!1&&this.onKeyDown.filter(d=>(s.isMacintosh?d.metaKey:d.ctrlKey)&&d.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}updateOptions(A){A.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),A.multipleSelectionSupport&&this.onKeyDown.filter(W=>(s.isMacintosh?W.metaKey:W.ctrlKey)&&W.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(A){A.preventDefault(),A.stopPropagation(),this.list.setSelection(this.list.getFocus(),A.browserEvent)}onUpArrow(A){A.preventDefault(),A.stopPropagation(),this.list.focusPrevious(1,!1,A.browserEvent);const W=this.list.getFocus()[0];this.list.setAnchor(W),this.list.reveal(W),this.view.domNode.focus()}onDownArrow(A){A.preventDefault(),A.stopPropagation(),this.list.focusNext(1,!1,A.browserEvent);const W=this.list.getFocus()[0];this.list.setAnchor(W),this.list.reveal(W),this.view.domNode.focus()}onPageUpArrow(A){A.preventDefault(),A.stopPropagation(),this.list.focusPreviousPage(A.browserEvent);const W=this.list.getFocus()[0];this.list.setAnchor(W),this.list.reveal(W),this.view.domNode.focus()}onPageDownArrow(A){A.preventDefault(),A.stopPropagation(),this.list.focusNextPage(A.browserEvent);const W=this.list.getFocus()[0];this.list.setAnchor(W),this.list.reveal(W),this.view.domNode.focus()}onCtrlA(A){A.preventDefault(),A.stopPropagation(),this.list.setSelection((0,c.range)(this.list.length),A.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(A){this.list.getSelection().length&&(A.preventDefault(),A.stopPropagation(),this.list.setSelection([],A.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}qe([P.memoize],g.prototype,"onKeyDown",null);var m;(function(K){K[K.Automatic=0]="Automatic",K[K.Trigger=1]="Trigger"})(m||(t.TypeNavigationMode=m={}));var p;(function(K){K[K.Idle=0]="Idle",K[K.Typing=1]="Typing"})(p||(p={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(K){return K.ctrlKey||K.metaKey||K.altKey?!1:K.keyCode>=31&&K.keyCode<=56||K.keyCode>=21&&K.keyCode<=30||K.keyCode>=98&&K.keyCode<=107||K.keyCode>=85&&K.keyCode<=95}};class O{constructor(A,W,N,d,R){this.list=A,this.view=W,this.keyboardNavigationLabelProvider=N,this.keyboardNavigationEventFilter=d,this.delegate=R,this.enabled=!1,this.state=p.Idle,this.mode=m.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(A.options)}updateOptions(A){A.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=A.typeNavigationMode??m.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let A=!1;const W=this.enabledDisposables.add(r.Event.chain(this.enabledDisposables.add(new k.DomEmitter(this.view.domNode,"keydown")).event)).filter(R=>!L(R.target)).filter(()=>this.mode===m.Automatic||this.triggered).map(R=>new i.StandardKeyboardEvent(R)).filter(R=>A||this.keyboardNavigationEventFilter(R)).filter(R=>this.delegate.mightProducePrintableCharacter(R)).forEach(R=>y.EventHelper.stop(R,!0)).map(R=>R.browserEvent.key).event,N=r.Event.debounce(W,()=>null,800,void 0,void 0,void 0,this.enabledDisposables);r.Event.reduce(r.Event.any(W,N),(R,$)=>$===null?null:(R||"")+$,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),N(this.onClear,this,this.enabledDisposables),W(()=>A=!0,void 0,this.enabledDisposables),N(()=>A=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){this.enabled&&(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const A=this.list.getFocus();if(A.length>0&&A[0]===this.previouslyFocused){const W=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(A[0]));W&&(0,b.alert)(W)}this.previouslyFocused=-1}onInput(A){if(!A){this.state=p.Idle,this.triggered=!1;return}const W=this.list.getFocus(),N=W.length>0?W[0]:0,d=this.state===p.Idle?1:0;this.state=p.Typing;for(let R=0;R<this.list.length;R++){const $=(N+R+d)%this.list.length,Z=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element($)),T=Z&&Z.toString();if(typeof T>"u"||(0,a.matchesPrefix)(A,T)){this.previouslyFocused=N,this.list.setFocus([$]),this.list.reveal($);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class G{constructor(A,W){this.list=A,this.view=W,this.disposables=new e.DisposableStore,this.disposables.add(r.Event.chain(this.disposables.add(new k.DomEmitter(W.domNode,"keydown")).event)).filter(d=>!L(d.target)).map(d=>new i.StandardKeyboardEvent(d)).filter(d=>d.keyCode===2&&!d.ctrlKey&&!d.metaKey&&!d.shiftKey&&!d.altKey).on(this.onTab,this,this.disposables)}onTab(A){if(A.target!==this.view.domNode)return;const W=this.list.getFocus();if(W.length===0)return;const N=this.view.domElement(W[0]);if(!N)return;const d=N.querySelector("[tabIndex]");if(!d||!(d instanceof HTMLElement)||d.tabIndex===-1)return;const R=window.getComputedStyle(d);R.visibility==="hidden"||R.display==="none"||(A.preventDefault(),A.stopPropagation(),d.focus())}dispose(){this.disposables.dispose()}}function J(K){return s.isMacintosh?K.browserEvent.metaKey:K.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=J;function ie(K){return K.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ie;function ae(K){return K instanceof MouseEvent&&K.button===2}const ge={isSelectionSingleChangeEvent:J,isSelectionRangeChangeEvent:ie};class ue{constructor(A){this.list=A,this.disposables=new e.DisposableStore,this._onPointer=new r.Emitter,this.onPointer=this._onPointer.event,A.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ge),this.mouseSupport=typeof A.options.mouseSupport>"u"||!!A.options.mouseSupport,this.mouseSupport&&(A.onMouseDown(this.onMouseDown,this,this.disposables),A.onContextMenu(this.onContextMenu,this,this.disposables),A.onMouseDblClick(this.onDoubleClick,this,this.disposables),A.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(z.Gesture.addTarget(A.getHTMLElement()))),r.Event.any(A.onMouseClick,A.onMouseMiddleClick,A.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(A){A.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,A.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ge))}isSelectionSingleChangeEvent(A){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(A):!1}isSelectionRangeChangeEvent(A){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(A):!1}isSelectionChangeEvent(A){return this.isSelectionSingleChangeEvent(A)||this.isSelectionRangeChangeEvent(A)}onMouseDown(A){I(A.browserEvent.target)||document.activeElement!==A.browserEvent.target&&this.list.domFocus()}onContextMenu(A){if(L(A.browserEvent.target)||I(A.browserEvent.target))return;const W=typeof A.index>"u"?[]:[A.index];this.list.setFocus(W,A.browserEvent)}onViewPointer(A){if(!this.mouseSupport||L(A.browserEvent.target)||I(A.browserEvent.target))return;const W=A.index;if(typeof W>"u"){this.list.setFocus([],A.browserEvent),this.list.setSelection([],A.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(A))return this.changeSelection(A);if(this.isSelectionChangeEvent(A))return this.changeSelection(A);this.list.setFocus([W],A.browserEvent),this.list.setAnchor(W),ae(A.browserEvent)||this.list.setSelection([W],A.browserEvent),this._onPointer.fire(A)}onDoubleClick(A){if(L(A.browserEvent.target)||I(A.browserEvent.target)||this.isSelectionChangeEvent(A))return;const W=this.list.getFocus();this.list.setSelection(W,A.browserEvent)}changeSelection(A){const W=A.index;let N=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(A)){typeof N>"u"&&(N=this.list.getFocus()[0]??W,this.list.setAnchor(N));const d=Math.min(N,W),R=Math.max(N,W),$=(0,c.range)(d,R+1),Z=this.list.getSelection(),T=Se(_e(Z,[N]),N);if(T.length===0)return;const F=_e($,Oe(Z,T));this.list.setSelection(F,A.browserEvent),this.list.setFocus([W],A.browserEvent)}else if(this.isSelectionSingleChangeEvent(A)){const d=this.list.getSelection(),R=d.filter($=>$!==W);this.list.setFocus([W]),this.list.setAnchor(W),d.length===R.length?this.list.setSelection([...R,W],A.browserEvent):this.list.setSelection(R,A.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=ue;class de{constructor(A,W){this.styleElement=A,this.selectorSuffix=W}style(A){const W=this.selectorSuffix&&`.${this.selectorSuffix}`,N=[];A.listBackground&&N.push(`.monaco-list${W} .monaco-list-rows { background: ${A.listBackground}; }`),A.listFocusBackground&&(N.push(`.monaco-list${W}:focus .monaco-list-row.focused { background-color: ${A.listFocusBackground}; }`),N.push(`.monaco-list${W}:focus .monaco-list-row.focused:hover { background-color: ${A.listFocusBackground}; }`)),A.listFocusForeground&&N.push(`.monaco-list${W}:focus .monaco-list-row.focused { color: ${A.listFocusForeground}; }`),A.listActiveSelectionBackground&&(N.push(`.monaco-list${W}:focus .monaco-list-row.selected { background-color: ${A.listActiveSelectionBackground}; }`),N.push(`.monaco-list${W}:focus .monaco-list-row.selected:hover { background-color: ${A.listActiveSelectionBackground}; }`)),A.listActiveSelectionForeground&&N.push(`.monaco-list${W}:focus .monaco-list-row.selected { color: ${A.listActiveSelectionForeground}; }`),A.listActiveSelectionIconForeground&&N.push(`.monaco-list${W}:focus .monaco-list-row.selected .codicon { color: ${A.listActiveSelectionIconForeground}; }`),A.listFocusAndSelectionBackground&&N.push(`
				.monaco-drag-image,
				.monaco-list${W}:focus .monaco-list-row.selected.focused { background-color: ${A.listFocusAndSelectionBackground}; }
			`),A.listFocusAndSelectionForeground&&N.push(`
				.monaco-drag-image,
				.monaco-list${W}:focus .monaco-list-row.selected.focused { color: ${A.listFocusAndSelectionForeground}; }
			`),A.listInactiveFocusForeground&&(N.push(`.monaco-list${W} .monaco-list-row.focused { color:  ${A.listInactiveFocusForeground}; }`),N.push(`.monaco-list${W} .monaco-list-row.focused:hover { color:  ${A.listInactiveFocusForeground}; }`)),A.listInactiveSelectionIconForeground&&N.push(`.monaco-list${W} .monaco-list-row.focused .codicon { color:  ${A.listInactiveSelectionIconForeground}; }`),A.listInactiveFocusBackground&&(N.push(`.monaco-list${W} .monaco-list-row.focused { background-color:  ${A.listInactiveFocusBackground}; }`),N.push(`.monaco-list${W} .monaco-list-row.focused:hover { background-color:  ${A.listInactiveFocusBackground}; }`)),A.listInactiveSelectionBackground&&(N.push(`.monaco-list${W} .monaco-list-row.selected { background-color:  ${A.listInactiveSelectionBackground}; }`),N.push(`.monaco-list${W} .monaco-list-row.selected:hover { background-color:  ${A.listInactiveSelectionBackground}; }`)),A.listInactiveSelectionForeground&&N.push(`.monaco-list${W} .monaco-list-row.selected { color: ${A.listInactiveSelectionForeground}; }`),A.listHoverBackground&&N.push(`.monaco-list${W}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${A.listHoverBackground}; }`),A.listHoverForeground&&N.push(`.monaco-list${W}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${A.listHoverForeground}; }`);const d=(0,y.asCssValueWithDefault)(A.listFocusAndSelectionOutline,(0,y.asCssValueWithDefault)(A.listSelectionOutline,A.listFocusOutline??""));d&&N.push(`.monaco-list${W}:focus .monaco-list-row.focused.selected { outline: 1px solid ${d}; outline-offset: -1px;}`),A.listFocusOutline&&N.push(`
				.monaco-drag-image,
				.monaco-list${W}:focus .monaco-list-row.focused { outline: 1px solid ${A.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${W}.last-focused .monaco-list-row.focused { outline: 1px solid ${A.listFocusOutline}; outline-offset: -1px; }
			`);const R=(0,y.asCssValueWithDefault)(A.listSelectionOutline,A.listInactiveFocusOutline??"");R&&N.push(`.monaco-list${W} .monaco-list-row.focused.selected { outline: 1px dotted ${R}; outline-offset: -1px; }`),A.listSelectionOutline&&N.push(`.monaco-list${W} .monaco-list-row.selected { outline: 1px dotted ${A.listSelectionOutline}; outline-offset: -1px; }`),A.listInactiveFocusOutline&&N.push(`.monaco-list${W} .monaco-list-row.focused { outline: 1px dotted ${A.listInactiveFocusOutline}; outline-offset: -1px; }`),A.listHoverOutline&&N.push(`.monaco-list${W} .monaco-list-row:hover { outline: 1px dashed ${A.listHoverOutline}; outline-offset: -1px; }`),A.listDropBackground&&N.push(`
				.monaco-list${W}.drop-target,
				.monaco-list${W} .monaco-list-rows.drop-target,
				.monaco-list${W} .monaco-list-row.drop-target { background-color: ${A.listDropBackground} !important; color: inherit !important; }
			`),A.tableColumnsBorder&&N.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${A.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),A.tableOddRowsBackgroundColor&&N.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${A.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=N.join(`
`)}}t.DefaultStyleController=de,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:h.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:h.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:h.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const he={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function Se(K,A){const W=K.indexOf(A);if(W===-1)return[];const N=[];let d=W-1;for(;d>=0&&K[d]===A-(W-d);)N.push(K[d--]);for(N.reverse(),d=W;d<K.length&&K[d]===A+(d-W);)N.push(K[d++]);return N}function _e(K,A){const W=[];let N=0,d=0;for(;N<K.length||d<A.length;)if(N>=K.length)W.push(A[d++]);else if(d>=A.length)W.push(K[N++]);else if(K[N]===A[d]){W.push(K[N]),N++,d++;continue}else K[N]<A[d]?W.push(K[N++]):W.push(A[d++]);return W}function Oe(K,A){const W=[];let N=0,d=0;for(;N<K.length||d<A.length;)if(N>=K.length)W.push(A[d++]);else if(d>=A.length)W.push(K[N++]);else if(K[N]===A[d]){N++,d++;continue}else K[N]<A[d]?W.push(K[N++]):d++;return W}const re=(K,A)=>K-A;class se{constructor(A,W){this._templateId=A,this.renderers=W}get templateId(){return this._templateId}renderTemplate(A){return this.renderers.map(W=>W.renderTemplate(A))}renderElement(A,W,N,d){let R=0;for(const $ of this.renderers)$.renderElement(A,W,N[R++],d)}disposeElement(A,W,N,d){let R=0;for(const $ of this.renderers)$.disposeElement?.(A,W,N[R],d),R+=1}disposeTemplate(A){let W=0;for(const N of this.renderers)N.disposeTemplate(A[W++])}}class Q{constructor(A){this.accessibilityProvider=A,this.templateId="a18n"}renderTemplate(A){return A}renderElement(A,W,N){const d=this.accessibilityProvider.getAriaLabel(A);d?N.setAttribute("aria-label",d):N.removeAttribute("aria-label");const R=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(A);typeof R=="number"?N.setAttribute("aria-level",`${R}`):N.removeAttribute("aria-level")}disposeTemplate(A){}}class oe{constructor(A,W){this.list=A,this.dnd=W}getDragElements(A){const W=this.list.getSelectedElements();return W.indexOf(A)>-1?W:[A]}getDragURI(A){return this.dnd.getDragURI(A)}getDragLabel(A,W){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(A,W)}onDragStart(A,W){this.dnd.onDragStart?.(A,W)}onDragOver(A,W,N,d){return this.dnd.onDragOver(A,W,N,d)}onDragLeave(A,W,N,d){this.dnd.onDragLeave?.(A,W,N,d)}onDragEnd(A){this.dnd.onDragEnd?.(A)}drop(A,W,N,d){this.dnd.drop(A,W,N,d)}}class V{get onDidChangeFocus(){return r.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),A=>this.toListEvent(A),this.disposables)}get onDidChangeSelection(){return r.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),A=>this.toListEvent(A),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let A=!1;const W=this.disposables.add(r.Event.chain(this.disposables.add(new k.DomEmitter(this.view.domNode,"keydown")).event)).map(R=>new i.StandardKeyboardEvent(R)).filter(R=>A=R.keyCode===58||R.shiftKey&&R.keyCode===68).map(R=>y.EventHelper.stop(R,!0)).filter(()=>!1).event,N=this.disposables.add(r.Event.chain(this.disposables.add(new k.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>A=!1).map(R=>new i.StandardKeyboardEvent(R)).filter(R=>R.keyCode===58||R.shiftKey&&R.keyCode===68).map(R=>y.EventHelper.stop(R,!0)).map(({browserEvent:R})=>{const $=this.getFocus(),Z=$.length?$[0]:void 0,T=typeof Z<"u"?this.view.element(Z):void 0,F=typeof Z<"u"?this.view.domElement(Z):this.view.domNode;return{index:Z,element:T,anchor:F,browserEvent:R}}).event,d=this.disposables.add(r.Event.chain(this.view.onContextMenu)).filter(R=>!A).map(({element:R,index:$,browserEvent:Z})=>({element:R,index:$,anchor:{x:Z.pageX+1,y:Z.pageY},browserEvent:Z})).event;return r.Event.any(W,N,d)}get onKeyDown(){return this.disposables.add(new k.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new k.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new k.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.disposables.add(new k.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.disposables.add(new k.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(A,W,N,d,R=he){this.user=A,this._options=R,this.focus=new S("focused"),this.anchor=new S("anchor"),this.eventBufferer=new r.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event;const $=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new f($!=="listbox");const Z=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=R.accessibilityProvider,this.accessibilityProvider&&(Z.push(new Q(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),d=d.map(F=>new se(F.templateId,[...Z,F]));const T={...R,dnd:R.dnd&&new oe(this,R.dnd)};if(this.view=this.createListView(W,N,d,T),this.view.domNode.setAttribute("role",$),R.styleController)this.styleController=R.styleController(this.view.domId);else{const F=(0,y.createStyleSheet)(this.view.domNode);this.styleController=new de(F,this.view.domId)}if(this.spliceable=new _.CombinedSpliceable([new v(this.focus,this.view,R.identityProvider),new v(this.selection,this.view,R.identityProvider),new v(this.anchor,this.view,R.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new G(this,this.view)),(typeof R.keyboardSupport!="boolean"||R.keyboardSupport)&&(this.keyboardController=new g(this,this.view,R),this.disposables.add(this.keyboardController)),R.keyboardNavigationLabelProvider){const F=R.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new O(this,this.view,R.keyboardNavigationLabelProvider,R.keyboardNavigationEventFilter??(()=>!0),F),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(R),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createListView(A,W,N,d){return new D.ListView(A,W,N,d)}createMouseController(A){return new ue(this)}updateOptions(A={}){this._options={...this._options,...A},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(A),this.keyboardController?.updateOptions(A),this.view.updateOptions(A)}get options(){return this._options}splice(A,W,N=[]){if(A<0||A>this.view.length)throw new n.ListError(this.user,`Invalid start index: ${A}`);if(W<0)throw new n.ListError(this.user,`Invalid delete count: ${W}`);W===0&&N.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(A,W,N))}updateWidth(A){this.view.updateWidth(A)}updateElementHeight(A,W){this.view.updateElementHeight(A,W,null)}rerender(){this.view.rerender()}element(A){return this.view.element(A)}indexOf(A){return this.view.indexOf(A)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.getScrollTop()}set scrollTop(A){this.view.setScrollTop(A)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(A){this.view.setScrollLeft(A)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(A){this._ariaLabel=A,this.view.domNode.setAttribute("aria-label",A)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(A,W){this.view.layout(A,W)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(A,W){for(const N of A)if(N<0||N>=this.length)throw new n.ListError(this.user,`Invalid index ${N}`);this.selection.set(A,W)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(A=>this.view.element(A))}setAnchor(A){if(typeof A>"u"){this.anchor.set([]);return}if(A<0||A>=this.length)throw new n.ListError(this.user,`Invalid index ${A}`);this.anchor.set([A])}getAnchor(){return(0,c.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const A=this.getAnchor();return typeof A>"u"?void 0:this.element(A)}setFocus(A,W){for(const N of A)if(N<0||N>=this.length)throw new n.ListError(this.user,`Invalid index ${N}`);this.focus.set(A,W)}focusNext(A=1,W=!1,N,d){if(this.length===0)return;const R=this.focus.get(),$=this.findNextIndex(R.length>0?R[0]+A:0,W,d);$>-1&&this.setFocus([$],N)}focusPrevious(A=1,W=!1,N,d){if(this.length===0)return;const R=this.focus.get(),$=this.findPreviousIndex(R.length>0?R[0]-A:0,W,d);$>-1&&this.setFocus([$],N)}async focusNextPage(A,W){let N=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);N=N===0?0:N-1;const d=this.getFocus()[0];if(d!==N&&(d===void 0||N>d)){const R=this.findPreviousIndex(N,!1,W);R>-1&&d!==R?this.setFocus([R],A):this.setFocus([N],A)}else{const R=this.view.getScrollTop();let $=R+this.view.renderHeight;N>d&&($-=this.view.elementHeight(N)),this.view.setScrollTop($),this.view.getScrollTop()!==R&&(this.setFocus([]),await(0,l.timeout)(0),await this.focusNextPage(A,W))}}async focusPreviousPage(A,W){let N;const d=this.view.getScrollTop();d===0?N=this.view.indexAt(d):N=this.view.indexAfter(d-1);const R=this.getFocus()[0];if(R!==N&&(R===void 0||R>=N)){const $=this.findNextIndex(N,!1,W);$>-1&&R!==$?this.setFocus([$],A):this.setFocus([N],A)}else{const $=d;this.view.setScrollTop(d-this.view.renderHeight),this.view.getScrollTop()!==$&&(this.setFocus([]),await(0,l.timeout)(0),await this.focusPreviousPage(A,W))}}focusLast(A,W){if(this.length===0)return;const N=this.findPreviousIndex(this.length-1,!1,W);N>-1&&this.setFocus([N],A)}focusFirst(A,W){this.focusNth(0,A,W)}focusNth(A,W,N){if(this.length===0)return;const d=this.findNextIndex(A,!1,N);d>-1&&this.setFocus([d],W)}findNextIndex(A,W=!1,N){for(let d=0;d<this.length;d++){if(A>=this.length&&!W)return-1;if(A=A%this.length,!N||N(this.element(A)))return A;A++}return-1}findPreviousIndex(A,W=!1,N){for(let d=0;d<this.length;d++){if(A<0&&!W)return-1;if(A=(this.length+A%this.length)%this.length,!N||N(this.element(A)))return A;A--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(A=>this.view.element(A))}reveal(A,W){if(A<0||A>=this.length)throw new n.ListError(this.user,`Invalid index ${A}`);const N=this.view.getScrollTop(),d=this.view.elementTop(A),R=this.view.elementHeight(A);if((0,u.isNumber)(W)){const $=R-this.view.renderHeight;this.view.setScrollTop($*(0,o.clamp)(W,0,1)+d)}else{const $=d+R,Z=N+this.view.renderHeight;d<N&&$>=Z||(d<N||$>=Z&&R>=this.view.renderHeight?this.view.setScrollTop(d):$>=Z&&this.view.setScrollTop($-this.view.renderHeight))}}getRelativeTop(A){if(A<0||A>=this.length)throw new n.ListError(this.user,`Invalid index ${A}`);const W=this.view.getScrollTop(),N=this.view.elementTop(A),d=this.view.elementHeight(A);if(N<W||N+d>W+this.view.renderHeight)return null;const R=d-this.view.renderHeight;return Math.abs((W-N)/R)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}getElementID(A){return this.view.getElementDomId(A)}style(A){this.styleController.style(A)}toListEvent({indexes:A,browserEvent:W}){return{indexes:A,elements:A.map(N=>this.view.element(N)),browserEvent:W}}_onFocusChange(){const A=this.focus.get();this.view.domNode.classList.toggle("element-focused",A.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const A=this.focus.get();if(A.length>0){let W;this.accessibilityProvider?.getActiveDescendantId&&(W=this.accessibilityProvider.getActiveDescendantId(this.view.element(A[0]))),this.view.domNode.setAttribute("aria-activedescendant",W||this.view.getElementDomId(A[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const A=this.selection.get();this.view.domNode.classList.toggle("selection-none",A.length===0),this.view.domNode.classList.toggle("selection-single",A.length===1),this.view.domNode.classList.toggle("selection-multiple",A.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}t.List=V,qe([P.memoize],V.prototype,"onDidChangeFocus",null),qe([P.memoize],V.prototype,"onDidChangeSelection",null),qe([P.memoize],V.prototype,"onContextMenu",null),qe([P.memoize],V.prototype,"onKeyDown",null),qe([P.memoize],V.prototype,"onKeyUp",null),qe([P.memoize],V.prototype,"onKeyPress",null),qe([P.memoize],V.prototype,"onDidFocus",null),qe([P.memoize],V.prototype,"onDidBlur",null)}),define(me[59],pe([1,0,7,33,34,11,15]),function(te,t,y,k,i,z,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var _;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(_||(t.MarkdownStringTextNewlineStyle=_={}));class c{constructor(u="",n=!1){if(this.value=u,typeof this.value!="string")throw(0,y.illegalArgument)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(u,n=0){return this.value+=r(this.supportThemeIcons?(0,k.escapeIcons)(u):u).replace(/([ \t]+)/g,(D,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,n){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(u,n,D){return this.value+="[",this.value+=this._escape(n,"]"),this.value+="](",this.value+=this._escape(String(u),")"),D&&(this.value+=` "${this._escape(this._escape(D,'"'),")")}"`),this.value+=")",this}_escape(u,n){const D=new RegExp((0,z.escapeRegExpCharacters)(n),"g");return u.replace(D,(w,S)=>u.charAt(S-1)!=="\\"?`\\${w}`:w)}}t.MarkdownString=c;function l(s){return h(s)?!s.value:Array.isArray(s)?s.every(l):!0}t.isEmptyMarkdownString=l;function h(s){return s instanceof c?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}t.isMarkdownString=h;function P(s,u){return s===u?!0:!s||!u?!1:s.value===u.value&&s.isTrusted===u.isTrusted&&s.supportThemeIcons===u.supportThemeIcons&&s.supportHtml===u.supportHtml&&(s.baseUri===u.baseUri||!!s.baseUri&&!!u.baseUri&&(0,i.isEqual)(b.URI.from(s.baseUri),b.URI.from(u.baseUri)))}t.markdownStringEqual=P;function r(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=r;function a(s){return s.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=a;function e(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.removeMarkdownEscapes=e;function o(s){const u=[],n=s.split("|").map(w=>w.trim());s=n[0];const D=n[1];if(D){const w=/height=(\d+)/.exec(D),S=/width=(\d+)/.exec(D),f=w?w[1]:"",v=S?S[1]:"",L=isFinite(parseInt(v)),I=isFinite(parseInt(f));L&&u.push(`width="${v}"`),I&&u.push(`height="${f}"`)}return{href:s,dimensions:u}}t.parseHrefAndDimensions=o}),define(me[122],pe([1,0,4,114,20,52,14,21,115,7,3,59,33,73,42,2,76,50,28,47,34,11,15]),function(te,t,y,k,i,z,b,_,c,l,h,P,r,a,e,o,s,u,n,D,w,S,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fillInIncompleteTokens=t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const v=Object.freeze({image:(V,K,A)=>{let W=[],N=[];return V&&({href:V,dimensions:W}=(0,P.parseHrefAndDimensions)(V),N.push(`src="${(0,P.escapeDoubleQuotes)(V)}"`)),A&&N.push(`alt="${(0,P.escapeDoubleQuotes)(A)}"`),K&&N.push(`title="${(0,P.escapeDoubleQuotes)(K)}"`),W.length&&(N=N.concat(W)),"<img "+N.join(" ")+">"},paragraph:V=>`<p>${V}</p>`,link:(V,K,A)=>typeof V!="string"?"":(V===A&&(A=(0,P.removeMarkdownEscapes)(A)),K=typeof K=="string"?(0,P.escapeDoubleQuotes)((0,P.removeMarkdownEscapes)(K)):"",V=(0,P.removeMarkdownEscapes)(V),V=V.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${V}" title="${K||V}">${A}</a>`)});function L(V,K={},A={}){const W=new o.DisposableStore;let N=!1;const d=(0,z.createElement)(K),R=function(M){let U;try{U=(0,u.parse)(decodeURIComponent(M))}catch{}return U?(U=(0,D.cloneAndChange)(U,q=>{if(V.uris&&V.uris[q])return f.URI.revive(V.uris[q])}),encodeURIComponent(JSON.stringify(U))):M},$=function(M,U){const q=V.uris&&V.uris[M];let ee=f.URI.revive(q);return U?M.startsWith(n.Schemas.data+":")?M:(ee||(ee=f.URI.parse(M)),n.FileAccess.uriToBrowserUri(ee).toString(!0)):!ee||f.URI.parse(M).toString()===ee.toString()?M:(ee.query&&(ee=ee.with({query:R(ee.query)})),ee.toString())},Z=new s.marked.Renderer;Z.image=v.image,Z.link=v.link,Z.paragraph=v.paragraph;const T=[],F=[];if(K.codeBlockRendererSync?Z.code=(M,U)=>{const q=a.defaultGenerator.nextId(),ee=K.codeBlockRendererSync(I(U),M);return F.push([q,ee]),`<div class="code" data-code="${q}">${(0,S.escape)(M)}</div>`}:K.codeBlockRenderer&&(Z.code=(M,U)=>{const q=a.defaultGenerator.nextId(),ee=K.codeBlockRenderer(I(U),M);return T.push(ee.then(ne=>[q,ne])),`<div class="code" data-code="${q}">${(0,S.escape)(M)}</div>`}),K.actionHandler){const M=function(ee){let ne=ee.target;if(!(ne.tagName!=="A"&&(ne=ne.parentElement,!ne||ne.tagName!=="A")))try{let ve=ne.dataset.href;ve&&(V.baseUri&&(ve=E(f.URI.from(V.baseUri),ve)),K.actionHandler.callback(ve,ee))}catch(ve){(0,l.onUnexpectedError)(ve)}finally{ee.preventDefault()}},U=K.actionHandler.disposables.add(new i.DomEmitter(d,"click")),q=K.actionHandler.disposables.add(new i.DomEmitter(d,"auxclick"));K.actionHandler.disposables.add(h.Event.any(U.event,q.event)(ee=>{const ne=new _.StandardMouseEvent(ee);!ne.leftButton&&!ne.middleButton||M(ne)})),K.actionHandler.disposables.add(y.addDisposableListener(d,"keydown",ee=>{const ne=new b.StandardKeyboardEvent(ee);!ne.equals(10)&&!ne.equals(3)||M(ne)}))}V.supportHtml||(A.sanitizer=M=>(V.isTrusted?M.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?M:"",A.sanitize=!0,A.silent=!0),A.renderer=Z;let B=V.value??"";B.length>1e5&&(B=`${B.substr(0,1e5)}\u2026`),V.supportThemeIcons&&(B=(0,r.markdownEscapeEscapedIcons)(B));let C;if(K.fillInIncompleteTokens){const M={...s.marked.defaults,...A},U=s.marked.lexer(B,M),q=ge(U);C=s.marked.parser(q,M)}else C=s.marked.parse(B,A);V.supportThemeIcons&&(C=(0,c.renderLabelWithIcons)(C).map(U=>typeof U=="string"?U:U.outerHTML).join(""));const x=new DOMParser().parseFromString(g(V,C),"text/html");if(x.body.querySelectorAll("img").forEach(M=>{const U=M.getAttribute("src");if(U){let q=U;try{V.baseUri&&(q=E(f.URI.from(V.baseUri),q))}catch{}M.src=$(q,!0)}}),x.body.querySelectorAll("a").forEach(M=>{const U=M.getAttribute("href");if(M.setAttribute("href",""),!U||/^data:|javascript:/i.test(U)||/^command:/i.test(U)&&!V.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(U))M.replaceWith(...M.childNodes);else{let q=$(U,!1);V.baseUri&&(q=E(f.URI.from(V.baseUri),U)),M.dataset.href=q}}),d.innerHTML=g(V,x.body.innerHTML),T.length>0)Promise.all(T).then(M=>{if(N)return;const U=new Map(M),q=d.querySelectorAll("div[data-code]");for(const ee of q){const ne=U.get(ee.dataset.code??"");ne&&y.reset(ee,ne)}K.asyncRenderCallback?.()});else if(F.length>0){const M=new Map(F),U=d.querySelectorAll("div[data-code]");for(const q of U){const ee=M.get(q.dataset.code??"");ee&&y.reset(q,ee)}}if(K.asyncRenderCallback)for(const M of d.getElementsByTagName("img")){const U=W.add(y.addDisposableListener(M,"load",()=>{U.dispose(),K.asyncRenderCallback()}))}return{element:d,dispose:()=>{N=!0,W.dispose()}}}t.renderMarkdown=L;function I(V){if(!V)return"";const K=V.split(/[\s+|:|,|\{|\?]/,1);return K.length?K[0]:V}function E(V,K){return/^\w[\w\d+.-]*:/.test(K)?K:V.path.endsWith("/")?(0,w.resolvePath)(V,K).toString():(0,w.resolvePath)((0,w.dirname)(V),K).toString()}function g(V,K){const{config:A,allowedSchemes:W}=m(V);k.addHook("uponSanitizeAttribute",(d,R)=>{if(R.attrName==="style"||R.attrName==="class"){if(d.tagName==="SPAN"){if(R.attrName==="style"){R.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(R.attrValue);return}else if(R.attrName==="class"){R.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(R.attrValue);return}}R.keepAttr=!1;return}});const N=y.hookDomPurifyHrefAndSrcSanitizer(W);try{return k.sanitize(K,{...A,RETURN_TRUSTED_TYPE:!0})}finally{k.removeHook("uponSanitizeAttribute"),N.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function m(V){const K=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return V.isTrusted&&K.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...y.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:K}}function p(V){return typeof V=="string"?V:O(V)}t.renderStringAsPlaintext=p;function O(V){let K=V.value??"";K.length>1e5&&(K=`${K.substr(0,1e5)}\u2026`);const A=s.marked.parse(K,{renderer:J.value}).replace(/&(#\d+|[a-zA-Z]+);/g,W=>G.get(W)??W);return g({isTrusted:!1},A).toString()}t.renderMarkdownAsPlaintext=O;const G=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),J=new e.Lazy(()=>{const V=new s.marked.Renderer;return V.code=K=>K,V.blockquote=K=>K,V.html=K=>"",V.heading=(K,A,W)=>K+`
`,V.hr=()=>"",V.list=(K,A)=>K,V.listitem=K=>K+`
`,V.paragraph=K=>K+`
`,V.table=(K,A)=>K+A+`
`,V.tablerow=K=>K,V.tablecell=(K,A)=>K+" ",V.strong=K=>K,V.em=K=>K,V.codespan=K=>K,V.br=()=>`
`,V.del=K=>K,V.image=(K,A,W)=>"",V.text=K=>K,V.link=(K,A,W)=>W,V});function ie(V){let K="";return V.forEach(A=>{K+=A.raw}),K}function ae(V){const K=V.tokens[0];if(K.type==="text"){const A=K.raw.split(`
`),W=A[A.length-1];if(W.includes("`"))return de(V);if(W.includes("**"))return re(V);if(W.match(/\*\w/))return he(V);if(W.match(/(^|\s)__\w/))return se(V);if(W.match(/(^|\s)_\w/))return Se(V);if(W.match(/(^|\s)\[.*\]\(\w*/))return _e(V);if(W.match(/(^|\s)\[\w/))return Oe(V)}}function ge(V){let K,A;for(K=0;K<V.length;K++){const W=V[K];if(W.type==="paragraph"&&W.raw.match(/(\n|^)```/)){A=ue(V.slice(K));break}if(W.type==="paragraph"&&W.raw.match(/(\n|^)\|/)){A=oe(V.slice(K));break}if(K===V.length-1&&W.type==="paragraph"){const N=ae(W);if(N){A=[N];break}}}if(A){const W=[...V.slice(0,K),...A];return W.links=V.links,W}return V}t.fillInIncompleteTokens=ge;function ue(V){const K=ie(V);return s.marked.lexer(K+"\n```")}function de(V){return Q(V,"`")}function he(V){return Q(V,"*")}function Se(V){return Q(V,"_")}function _e(V){return Q(V,")")}function Oe(V){return Q(V,"](about:blank)")}function re(V){return Q(V,"**")}function se(V){return Q(V,"__")}function Q(V,K){const A=ie(Array.isArray(V)?V:[V]);return s.marked.lexer(A+K)[0]}function oe(V){const K=ie(V),A=K.split(`
`);let W,N=!1;for(let d=0;d<A.length;d++){const R=A[d].trim();if(typeof W>"u"&&R.match(/^\s*\|/)){const $=R.match(/(\|[^\|]+)(?=\||$)/g);$&&(W=$.length)}else if(typeof W=="number")if(R.match(/^\s*\|/)){if(d!==A.length-1)return;N=!0}else return}if(typeof W=="number"&&W>0){const d=N?A.slice(0,-1).join(`
`):K,R=!!d.match(/\|\s*$/),$=d+(R?"":"|")+`
|${" --- |".repeat(W)}`;return s.marked.lexer($)}}}),define(me[123],pe([1,0,4,9,27,59,33,2,6,99]),function(te,t,y,k,i,z,b,_,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function h(a,e){(0,c.isString)(e)?a.title=(0,b.stripIcons)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.setupNativeHover=h;class P{constructor(e,o,s){this.hoverDelegate=e,this.target=o,this.fadeInAnimation=s}async update(e,o,s){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let u;if(e===void 0||(0,c.isString)(e)||e instanceof HTMLElement)u=e;else if(!(0,c.isFunction)(e.markdown))u=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,l.localize)(0,null),o),this._cancellationTokenSource=new i.CancellationTokenSource;const n=this._cancellationTokenSource.token;if(u=await e.markdown(n),u===void 0&&(u=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.show(u,o,s)}show(e,o,s){const u=this._hoverWidget;if(this.hasContent(e)){const n={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!u,...s};this._hoverWidget=this.hoverDelegate.showHover(n,o)}u?.dispose()}hasContent(e){return e?(0,z.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function r(a,e,o,s){let u,n;const D=(L,I)=>{const E=n!==void 0;L&&(n?.dispose(),n=void 0),I&&(u?.dispose(),u=void 0),E&&a.onDidHideHover?.()},w=(L,I,E)=>new k.TimeoutTimer(async()=>{(!n||n.isDisposed)&&(n=new P(a,E||e,L>0),await n.update(o,I,s))},L),S=()=>{if(u)return;const L=new _.DisposableStore,I=m=>D(!1,m.fromElement===e);L.add(y.addDisposableListener(e,y.EventType.MOUSE_LEAVE,I,!0));const E=()=>D(!0,!0);L.add(y.addDisposableListener(e,y.EventType.MOUSE_DOWN,E,!0));const g={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const m=p=>{g.x=p.x+10,p.target instanceof HTMLElement&&p.target.classList.contains("action-label")&&D(!0,!0)};L.add(y.addDisposableListener(e,y.EventType.MOUSE_MOVE,m,!0))}L.add(w(a.delay,!1,g)),u=L},f=y.addDisposableListener(e,y.EventType.MOUSE_OVER,S,!0);return{show:L=>{D(!1,!0),w(0,L)},hide:()=>{D(!0,!0)},update:async(L,I)=>{o=L,await n?.update(o,void 0,I)},dispose:()=>{f.dispose(),D(!0,!0)}}}t.setupCustomHover=r}),define(me[124],pe([1,0,4,20,14,122,36,13,3,41,2,5,101,92]),function(te,t,y,k,i,z,b,_,c,l,h,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const a=y.$,e="selectOption.entry.template";class o{get templateId(){return e}renderTemplate(n){const D=Object.create(null);return D.root=n,D.text=y.append(n,a(".option-text")),D.detail=y.append(n,a(".option-detail")),D.decoratorRight=y.append(n,a(".option-decorator-right")),D}renderElement(n,D,w){const S=w,f=n.text,v=n.detail,L=n.decoratorRight,I=n.isDisabled;S.text.textContent=f,S.detail.textContent=v||"",S.decoratorRight.innerText=L||"",I?S.root.classList.add("option-disabled"):S.root.classList.remove("option-disabled")}disposeTemplate(n){}}class s extends h.Disposable{constructor(n,D,w,S,f){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.styles=S,this.selectBoxOptions=f||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=s.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new c.Emitter,this._register(this._onDidSelect),this.registerListeners(),this.constructSelectDropDown(w),this.selected=D||0,n&&this.setOptions(n,D),this.initStyleSheet()}getHeight(){return 22}getTemplateId(){return e}constructSelectDropDown(n){this.contextViewProvider=n,this.selectDropDownContainer=y.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=y.append(this.selectDropDownContainer,a(".select-box-details-pane"));const D=y.append(this.selectDropDownContainer,a(".select-box-dropdown-container-width-control")),w=y.append(D,a(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",y.append(w,this.widthControlElement),this._dropDownPosition=0,this.styleElement=y.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(y.addDisposableListener(this.selectDropDownContainer,y.EventType.DRAG_START,S=>{y.EventHelper.stop(S,!0)}))}registerListeners(){this._register(y.addStandardDisposableListener(this.selectElement,"change",D=>{this.selected=D.target.selectedIndex,this._onDidSelect.fire({index:D.target.selectedIndex,selected:D.target.value}),this.options[this.selected]&&this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(y.addDisposableListener(this.selectElement,y.EventType.CLICK,D=>{y.EventHelper.stop(D),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(y.addDisposableListener(this.selectElement,y.EventType.MOUSE_DOWN,D=>{y.EventHelper.stop(D)}));let n;this._register(y.addDisposableListener(this.selectElement,"touchstart",D=>{n=this._isVisible})),this._register(y.addDisposableListener(this.selectElement,"touchend",D=>{y.EventHelper.stop(D),n?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(y.addDisposableListener(this.selectElement,y.EventType.KEY_DOWN,D=>{const w=new i.StandardKeyboardEvent(D);let S=!1;P.isMacintosh?(w.keyCode===18||w.keyCode===16||w.keyCode===10||w.keyCode===3)&&(S=!0):(w.keyCode===18&&w.altKey||w.keyCode===16&&w.altKey||w.keyCode===10||w.keyCode===3)&&(S=!0),S&&(this.showSelectDropDown(),y.EventHelper.stop(D,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(n,D){_.equals(this.options,n)||(this.options=n,this.selectElement.options.length=0,this._hasDetails=!1,this._cachedMaxDetailsHeight=void 0,this.options.forEach((w,S)=>{this.selectElement.add(this.createOption(w.text,S,w.isDisabled)),typeof w.description=="string"&&(this._hasDetails=!0)})),D!==void 0&&(this.select(D),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(n){n>=0&&n<this.options.length?this.selected=n:n>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.options[this.selected]&&this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(n){this.selectBoxOptions.ariaLabel=n,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(n){this.selectElement.tabIndex=n?0:-1}render(n){this.container=n,n.classList.add("select-container"),n.appendChild(this.selectElement),this.styleSelectElement()}initStyleSheet(){const n=[];this.styles.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&this.styles.selectBorder!==this.styles.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=n.join(`
`)}styleSelectElement(){const n=this.styles.selectBackground??"",D=this.styles.selectForeground??"",w=this.styles.selectBorder??"";this.selectElement.style.backgroundColor=n,this.selectElement.style.color=D,this.selectElement.style.borderColor=w}styleList(){const n=this.styles.selectBackground??"",D=y.asCssValueWithDefault(this.styles.selectListBackground,n);this.selectDropDownListContainer.style.backgroundColor=D,this.selectionDetailsPane.style.backgroundColor=D;const w=this.styles.focusBorder??"";this.selectDropDownContainer.style.outlineColor=w,this.selectDropDownContainer.style.outlineOffset="-1px",this.selectList.style(this.styles)}createOption(n,D,w){const S=document.createElement("option");return S.value=n,S.text=n,S.disabled=!!w,S}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:n=>this.renderSelectDropDown(n,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:n=>this.renderSelectDropDown(n),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(n){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),n&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(n,D){return n.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(D),{dispose:()=>{try{n.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let n=0;return this.options.forEach((D,w)=>{this.updateDetail(w),this.selectionDetailsPane.offsetHeight>n&&(n=this.selectionDetailsPane.offsetHeight)}),n}layoutSelectDropDown(n){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const D=y.getDomNodePagePosition(this.selectElement),w=getComputedStyle(this.selectElement),S=parseFloat(w.getPropertyValue("--dropdown-padding-top"))+parseFloat(w.getPropertyValue("--dropdown-padding-bottom")),f=window.innerHeight-D.top-D.height-(this.selectBoxOptions.minBottomMargin||0),v=D.top-s.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,L=this.selectElement.offsetWidth,I=this.setWidthControlElement(this.widthControlElement),E=Math.max(I,Math.round(L)).toString()+"px";this.selectDropDownContainer.style.width=E,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let g=this.selectList.contentHeight;this._hasDetails&&this._cachedMaxDetailsHeight===void 0&&(this._cachedMaxDetailsHeight=this.measureMaxDetailsHeight());const m=this._hasDetails?this._cachedMaxDetailsHeight:0,p=g+S+m,O=Math.floor((f-S-m)/this.getHeight()),G=Math.floor((v-S-m)/this.getHeight());if(n)return D.top+D.height>window.innerHeight-22||D.top<s.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||O<1&&G<1?!1:(O<s.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&G>O&&this.options.length>O?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(D.top+D.height>window.innerHeight-22||D.top<s.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&O<1||this._dropDownPosition===1&&G<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&O+G<1)return this.hideSelectDropDown(!0),!1;p>f&&(g=O*this.getHeight())}else p>v&&(g=G*this.getHeight());return this.selectList.layout(g),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=g+S+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=g+S+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=E,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(n){let D=0;if(n){let w=0,S=0;this.options.forEach((f,v)=>{const L=f.detail?f.detail.length:0,I=f.decoratorRight?f.decoratorRight.length:0,E=f.text.length+L+I;E>S&&(w=v,S=E)}),n.textContent=this.options[w].text+(this.options[w].decoratorRight?this.options[w].decoratorRight+" ":""),D=y.getTotalWidth(n)}return D}createSelectList(n){if(this.selectList)return;this.selectDropDownListContainer=y.append(n,a(".select-box-dropdown-list-container")),this.listRenderer=new o,this.selectList=new b.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:S=>{let f=S.text;return S.detail&&(f+=`. ${S.detail}`),S.decoratorRight&&(f+=`. ${S.decoratorRight}`),S.description&&(f+=`. ${S.description}`),f},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const D=this._register(new k.DomEmitter(this.selectDropDownListContainer,"keydown")),w=c.Event.chain(D.event).filter(()=>this.selectList.length>0).map(S=>new i.StandardKeyboardEvent(S));this._register(w.filter(S=>S.keyCode===3).on(S=>this.onEnter(S),this)),this._register(w.filter(S=>S.keyCode===2).on(S=>this.onEnter(S),this)),this._register(w.filter(S=>S.keyCode===9).on(S=>this.onEscape(S),this)),this._register(w.filter(S=>S.keyCode===16).on(S=>this.onUpArrow(S),this)),this._register(w.filter(S=>S.keyCode===18).on(S=>this.onDownArrow(S),this)),this._register(w.filter(S=>S.keyCode===12).on(this.onPageDown,this)),this._register(w.filter(S=>S.keyCode===11).on(this.onPageUp,this)),this._register(w.filter(S=>S.keyCode===14).on(this.onHome,this)),this._register(w.filter(S=>S.keyCode===13).on(this.onEnd,this)),this._register(w.filter(S=>S.keyCode>=21&&S.keyCode<=56||S.keyCode>=85&&S.keyCode<=113).on(this.onCharacter,this)),this._register(y.addDisposableListener(this.selectList.getHTMLElement(),y.EventType.POINTER_UP,S=>this.onPointerUp(S))),this._register(this.selectList.onMouseOver(S=>typeof S.index<"u"&&this.selectList.setFocus([S.index]))),this._register(this.selectList.onDidChangeFocus(S=>this.onListFocus(S))),this._register(y.addDisposableListener(this.selectDropDownContainer,y.EventType.FOCUS_OUT,S=>{!this._isVisible||y.isAncestor(S.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(n){if(!this.selectList.length)return;y.EventHelper.stop(n);const D=n.target;if(!D||D.classList.contains("slider"))return;const w=D.closest(".monaco-list-row");if(!w)return;const S=Number(w.getAttribute("data-index")),f=w.classList.contains("option-disabled");S>=0&&S<this.options.length&&!f&&(this.selected=S,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(n,D){const w=f=>{for(let v=0;v<f.childNodes.length;v++){const L=f.childNodes.item(v);(L.tagName&&L.tagName.toLowerCase())==="img"?f.removeChild(L):w(L)}},S=(0,z.renderMarkdown)({value:n,supportThemeIcons:!0},{actionHandler:D});return S.element.classList.add("select-box-description-markdown"),w(S.element),S.element}onListFocus(n){!this._isVisible||!this._hasDetails||this.updateDetail(n.indexes[0])}updateDetail(n){this.selectionDetailsPane.innerText="";const D=this.options[n],w=D?.description??"",S=D?.descriptionIsMarkdown??!1;if(w){if(S){const f=D.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(w,f))}else this.selectionDetailsPane.innerText=w;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(n){y.EventHelper.stop(n),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(n){y.EventHelper.stop(n),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(n){if(this.selected<this.options.length-1){y.EventHelper.stop(n,!0);const D=this.options[this.selected+1].isDisabled;if(D&&this.options.length>this.selected+2)this.selected+=2;else{if(D)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(n){this.selected>0&&(y.EventHelper.stop(n,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(n){y.EventHelper.stop(n),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(n){y.EventHelper.stop(n),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(n){y.EventHelper.stop(n),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(n){y.EventHelper.stop(n),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(n){const D=l.KeyCodeUtils.toString(n.keyCode);let w=-1;for(let S=0;S<this.options.length-1;S++)if(w=(S+this.selected+1)%this.options.length,this.options[w].text.charAt(0).toUpperCase()===D&&!this.options[w].isDisabled){this.select(w),this.selectList.setFocus([w]),this.selectList.reveal(this.selectList.getFocus()[0]),y.EventHelper.stop(n);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=s,s.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,s.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,s.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}),define(me[125],pe([1,0,36,124,118,19,5,91]),function(te,t,y,k,i,z,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...y.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class _ extends z.Widget{constructor(l,h,P,r,a){super(),b.isMacintosh&&!a?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(l,h,r,a):this.selectBoxDelegate=new k.SelectBoxList(l,h,P,r,a),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(l,h){this.selectBoxDelegate.setOptions(l,h)}select(l){this.selectBoxDelegate.select(l)}setAriaLabel(l){this.selectBoxDelegate.setAriaLabel(l)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(l){this.selectBoxDelegate.setFocusable(l)}render(l){this.selectBoxDelegate.render(l)}}t.SelectBox=_}),define(me[60],pe([1,0,18,51,4,23,123,125,31,2,5,6,96,48]),function(te,t,y,k,i,z,b,_,c,l,h,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class a extends l.Disposable{get action(){return this._action}constructor(u,n,D={}){super(),this.options=D,this._context=u||this,this._action=n,n instanceof c.Action&&this._register(n.onDidChange(w=>{this.element&&this.handleActionChangeEvent(w)}))}handleActionChangeEvent(u){u.enabled!==void 0&&this.updateEnabled(),u.checked!==void 0&&this.updateChecked(),u.class!==void 0&&this.updateClass(),u.label!==void 0&&(this.updateLabel(),this.updateTooltip()),u.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new c.ActionRunner)),this._actionRunner}set actionRunner(u){this._actionRunner=u}isEnabled(){return this._action.enabled}setActionContext(u){this._context=u}render(u){const n=this.element=u;this._register(z.Gesture.addTarget(u));const D=this.options&&this.options.draggable;D&&(u.draggable=!0,y.isFirefox&&this._register((0,i.addDisposableListener)(u,i.EventType.DRAG_START,w=>w.dataTransfer?.setData(k.DataTransfers.TEXT,this._action.label)))),this._register((0,i.addDisposableListener)(n,z.EventType.Tap,w=>this.onClick(w,!0))),this._register((0,i.addDisposableListener)(n,i.EventType.MOUSE_DOWN,w=>{D||i.EventHelper.stop(w,!0),this._action.enabled&&w.button===0&&n.classList.add("active")})),h.isMacintosh&&this._register((0,i.addDisposableListener)(n,i.EventType.CONTEXT_MENU,w=>{w.button===0&&w.ctrlKey===!0&&this.onClick(w)})),this._register((0,i.addDisposableListener)(n,i.EventType.CLICK,w=>{i.EventHelper.stop(w,!0),this.options&&this.options.isMenu||this.onClick(w)})),this._register((0,i.addDisposableListener)(n,i.EventType.DBLCLICK,w=>{i.EventHelper.stop(w,!0)})),[i.EventType.MOUSE_UP,i.EventType.MOUSE_OUT].forEach(w=>{this._register((0,i.addDisposableListener)(n,w,S=>{i.EventHelper.stop(S),n.classList.remove("active")}))})}onClick(u,n=!1){i.EventHelper.stop(u,!0);const D=P.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?u:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,D)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(u){this.element&&(this.element.tabIndex=u?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const u=this.getTooltip()??"";this.updateAriaLabel(),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(u):(this.customHover=(0,b.setupCustomHover)(this.options.hoverDelegate,this.element,u),this._store.add(this.customHover))):this.element.title=u}updateAriaLabel(){if(this.element){const u=this.getTooltip()??"";this.element.setAttribute("aria-label",u)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=a;class e extends a{constructor(u,n,D){super(u,n,D),this.options=D,this.options.icon=D.icon!==void 0?D.icon:!1,this.options.label=D.label!==void 0?D.label:!0,this.cssClass=""}render(u){super.render(u),this.element&&(this.label=(0,i.append)(this.element,(0,i.$)("a.action-label"))),this.label&&(this._action.id===c.Separator.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button")),this.options.label&&this.options.keybinding&&this.element&&((0,i.append)(this.element,(0,i.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(u){this.label&&(this.label.tabIndex=u?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let u=null;return this.action.tooltip?u=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(u=this.action.label,this.options.keybinding&&(u=r.localize(0,null,u,this.options.keybinding))),u??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.action.class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const u=this.getTooltip()??"";this.label.setAttribute("aria-label",u)}}updateChecked(){this.label&&(this.action.checked?this.label.classList.add("checked"):this.label.classList.remove("checked"))}}t.ActionViewItem=e;class o extends a{constructor(u,n,D,w,S,f,v){super(u,n),this.selectBox=new _.SelectBox(D,w,S,f,v),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(u,n){this.selectBox.setOptions(u,n)}select(u){this.selectBox.select(u)}registerListeners(){this._register(this.selectBox.onDidSelect(u=>this.runAction(u.selected,u.index)))}runAction(u,n){this.actionRunner.run(this._action,this.getActionContext(u,n))}getActionContext(u,n){return u}setFocusable(u){this.selectBox.setFocusable(u)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(u){this.selectBox.render(u)}}t.SelectActionViewItem=o}),define(me[61],pe([1,0,4,14,60,31,3,2,6,48]),function(te,t,y,k,i,z,b,_,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var l;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(l||(t.ActionsOrientation=l={}));class h extends _.Disposable{constructor(a,e={}){super(),this._actionRunnerDisposables=this._register(new _.DisposableStore),this.viewItemDisposables=this._register(new _.DisposableMap),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new b.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new b.Emitter({onWillAddFirstListener:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new b.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new b.Emitter),this.onWillRun=this._onWillRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new z.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(u=>this._onDidRun.fire(u))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(u=>this._onWillRun.fire(u))),this.viewItems=[],this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let o,s;switch(this._orientation){case 0:o=[15],s=[17];break;case 1:o=[16],s=[18],this.domNode.className+=" vertical";break}this._register(y.addDisposableListener(this.domNode,y.EventType.KEY_DOWN,u=>{const n=new k.StandardKeyboardEvent(u);let D=!0;const w=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;o&&(n.equals(o[0])||n.equals(o[1]))?D=this.focusPrevious():s&&(n.equals(s[0])||n.equals(s[1]))?D=this.focusNext():n.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():n.equals(14)?D=this.focusFirst():n.equals(13)?D=this.focusLast():n.equals(2)&&w instanceof i.BaseActionViewItem&&w.trapsArrowNavigation?D=this.focusNext():this.isTriggerKeyEvent(n)?this._triggerKeys.keyDown?this.doTrigger(n):this.triggerKeyDown=!0:D=!1,D&&(n.preventDefault(),n.stopPropagation())})),this._register(y.addDisposableListener(this.domNode,y.EventType.KEY_UP,u=>{const n=new k.StandardKeyboardEvent(u);this.isTriggerKeyEvent(n)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.updateFocusedItem()})),this.focusTracker=this._register(y.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(y.getActiveElement()===this.domNode||!y.isAncestor(y.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),a.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(a){a?this.actionsList.setAttribute("aria-label",a):this.actionsList.removeAttribute("aria-label")}setFocusable(a){if(this.focusable=a,this.focusable){const e=this.viewItems.find(o=>o instanceof i.BaseActionViewItem&&o.isEnabled());e instanceof i.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(a){let e=!1;return this._triggerKeys.keys.forEach(o=>{e=e||a.equals(o)}),e}updateFocusedItem(){for(let a=0;a<this.actionsList.children.length;a++){const e=this.actionsList.children[a];if(y.isAncestor(y.getActiveElement(),e)){this.focusedItem=a;break}}}get context(){return this._context}set context(a){this._context=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this._actionRunner}set actionRunner(a){this._actionRunner=a,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(e=>this._onDidRun.fire(e))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(e=>this._onWillRun.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.actionsList;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.actionsList.childNodes.length;e++)if(this.actionsList.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const o=Array.isArray(a)?a:[a];let s=c.isNumber(e.index)?e.index:null;o.forEach(u=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let D;const w={hoverDelegate:this.options.hoverDelegate,...e};this.options.actionViewItemProvider&&(D=this.options.actionViewItemProvider(u,w)),D||(D=new i.ActionViewItem(this.context,u,w)),this.options.allowContextMenu||this.viewItemDisposables.set(D,y.addDisposableListener(n,y.EventType.CONTEXT_MENU,S=>{y.EventHelper.stop(S,!0)})),D.actionRunner=this._actionRunner,D.setActionContext(this.context),D.render(n),this.focusable&&D instanceof i.BaseActionViewItem&&this.viewItems.length===0&&D.setFocusable(!0),s===null||s<0||s>=this.actionsList.children.length?(this.actionsList.appendChild(n),this.viewItems.push(D)):(this.actionsList.insertBefore(n,this.actionsList.children[s]),this.viewItems.splice(s,0,D),s++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(a){if(a>=0&&a<this.actionsList.children.length){const e=this.actionsList.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.actionsList.children.length){const e=this.actionsList.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[a]),this.viewItemDisposables.deleteAndDispose(this.viewItems[a]),(0,_.dispose)(this.viewItems.splice(a,1)),this.refreshRole())}clear(){this.isEmpty()||(this.viewItems=(0,_.dispose)(this.viewItems),this.viewItemDisposables.clearAndDisposeAll(),y.clearNode(this.actionsList),this.refreshRole())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,o;if(a===void 0?e=!0:typeof a=="number"?o=a:typeof a=="boolean"&&(e=a),e&&typeof this.focusedItem>"u"){const s=this.viewItems.findIndex(u=>u.isEnabled());this.focusedItem=s===-1?void 0:s,this.updateFocus(void 0,void 0,!0)}else o!==void 0&&(this.focusedItem=o),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(a){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let o;do{if(!a&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,o=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===z.Separator.ID));return this.updateFocus(),!0}focusPrevious(a){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let o;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!a&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}o=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===z.Separator.ID));return this.updateFocus(!0),!0}updateFocus(a,e,o=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const s=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(s){let u=!0;c.isFunction(s.focus)||(u=!1),this.options.focusOnlyEnabledItems&&c.isFunction(s.isEnabled)&&!s.isEnabled()&&(u=!1),s.action.id===z.Separator.ID&&(u=!1),u?(o||this.previouslyFocusedItem!==this.focusedItem)&&(s.focus(a),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(a){if(typeof this.focusedItem>"u")return;const e=this.viewItems[this.focusedItem];if(e instanceof i.BaseActionViewItem){const o=e._context===null||e._context===void 0?a:e._context;this.run(e._action,o)}}async run(a,e){await this._actionRunner.run(a,e)}dispose(){this._context=void 0,this.viewItems=(0,_.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=h;function P(r){if(!r.length)return r;let a=-1;for(let o=0;o<r.length;o++)if(r[o].id!==z.Separator.ID){a=o;break}if(a===-1)return[];r=r.slice(a);for(let o=r.length-1;o>=0&&r[o].id===z.Separator.ID;o--)r.splice(o,1);let e=!1;for(let o=r.length-1;o>=0;o--){const s=r[o].id===z.Separator.ID;s&&!e?r.splice(o,1):s?s&&(e=!1):e=!0}return r}t.prepareActions=P}),define(me[62],pe([1,0,4,20,52,61,54,57,19,3,78,47,100,88]),function(te,t,y,k,i,z,b,_,c,l,h,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const a=y.$;var e;(function(u){u[u.INFO=1]="INFO",u[u.WARNING=2]="WARNING",u[u.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class o extends c.Widget{constructor(n,D,w){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new l.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=D,this.options=w,this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=y.append(n,a(".monaco-inputbox.idle"));const S=this.options.flexibleHeight?"textarea":"input",f=y.append(this.element,a(".ibwrapper"));if(this.input=y.append(f,a(S+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=y.append(f,a("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new _.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),y.append(n,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(I=>this.input.scrollTop=I.scrollTop));const v=this._register(new k.DomEmitter(document,"selectionchange")),L=l.Event.filter(v.event,()=>document.getSelection()?.anchorNode===f);this._register(L(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this._register(this.ignoreGesture(this.input)),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new z.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(n){this.placeholder=n,this.input.setAttribute("placeholder",n)}setTooltip(n){this.tooltip=n,this.input.title=n}setAriaLabel(n){this.ariaLabel=n,n?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(n){this.input.value!==n&&(this.input.value=n,this.onValueChange())}get step(){return this.input.step}set step(n){this.input.step=n}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:y.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(n=null){this.input.select(),n&&(this.input.setSelectionRange(n.start,n.end),n.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(n){n?this.enable():this.disable()}get width(){return y.getTotalWidth(this.input)}set width(n){if(this.options.flexibleHeight&&this.options.flexibleWidth){let D=0;if(this.mirror){const w=parseFloat(this.mirror.style.paddingLeft||"")||0,S=parseFloat(this.mirror.style.paddingRight||"")||0;D=w+S}this.input.style.width=n-D+"px"}else this.input.style.width=n+"px";this.mirror&&(this.mirror.style.width=n+"px")}set paddingRight(n){this.input.style.width=`calc(100% - ${n}px)`,this.mirror&&(this.mirror.style.paddingRight=n+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const n=this.cachedContentHeight,D=this.cachedHeight,w=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:n,height:D}),this.scrollableElement.setScrollPosition({scrollTop:w})}showMessage(n,D){if(this.state==="open"&&(0,P.equals)(this.message,n))return;this.message=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(n.type));const w=this.stylesForType(this.message.type);this.element.style.border=`1px solid ${y.asCssValueWithDefault(w.border,"transparent")}`,this.message.content&&(this.hasFocus()||D)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let n=null;return this.validation&&(n=this.validation(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const D=this.options.inputBoxStyles;switch(n){case 1:return{border:D.inputValidationInfoBorder,background:D.inputValidationInfoBackground,foreground:D.inputValidationInfoForeground};case 2:return{border:D.inputValidationWarningBorder,background:D.inputValidationWarningBackground,foreground:D.inputValidationWarningForeground};default:return{border:D.inputValidationErrorBorder,background:D.inputValidationErrorBackground,foreground:D.inputValidationErrorForeground}}}classForType(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let n;const D=()=>n.style.width=y.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:S=>{if(!this.message)return null;n=y.append(S,a(".monaco-inputbox-container")),D();const f={inline:!0,className:"monaco-inputbox-message"},v=this.message.formatContent?(0,i.renderFormattedText)(this.message.content,f):(0,i.renderText)(this.message.content,f);v.classList.add(this.classForType(this.message.type));const L=this.stylesForType(this.message.type);return v.style.backgroundColor=L.background??"",v.style.color=L.foreground??"",v.style.border=L.border?`1px solid ${L.border}`:"",y.append(n,v),null},onHide:()=>{this.state="closed"},layout:D});let w;this.message.type===3?w=r.localize(0,null,this.message.content):this.message.type===2?w=r.localize(1,null,this.message.content):w=r.localize(2,null,this.message.content),b.alert(w),this.state="open"}_hideMessage(){this.contextViewProvider&&(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const n=this.value,w=n.charCodeAt(n.length-1)===10?" ":"";(n+w).replace(/\u000c/g,"")?this.mirror.textContent=n+w:this.mirror.innerText="\xA0",this.layout()}applyStyles(){const n=this.options.inputBoxStyles,D=n.inputBackground??"",w=n.inputForeground??"",S=n.inputBorder??"";this.element.style.backgroundColor=D,this.element.style.color=w,this.input.style.backgroundColor="inherit",this.input.style.color=w,this.element.style.border=`1px solid ${y.asCssValueWithDefault(S,"transparent")}`}layout(){if(!this.mirror)return;const n=this.cachedContentHeight;this.cachedContentHeight=y.getTotalHeight(this.mirror),n!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(n){const D=this.inputElement,w=D.selectionStart,S=D.selectionEnd,f=D.value;w!==null&&S!==null&&(this.value=f.substr(0,w)+n+f.substr(S),D.setSelectionRange(w+1,w+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=o;class s extends o{constructor(n,D,w){const S=r.localize(3,null),f=` or \u21C5 ${S}`,v=` (\u21C5 ${S})`;super(n,D,w),this._onDidFocus=this._register(new l.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new l.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new h.HistoryNavigator(w.history,100);const L=()=>{if(w.showHistoryHint&&w.showHistoryHint()&&!this.placeholder.endsWith(f)&&!this.placeholder.endsWith(v)&&this.history.getHistory().length){const I=this.placeholder.endsWith(")")?f:v,E=this.placeholder+I;w.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=E:this.setPlaceHolder(E)}};this.observer=new MutationObserver((I,E)=>{I.forEach(g=>{g.target.textContent||L()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>L()),this.onblur(this.input,()=>{const I=E=>{if(this.placeholder.endsWith(E)){const g=this.placeholder.slice(0,this.placeholder.length-E.length);return w.showPlaceholderOnFocus?this.placeholder=g:this.setPlaceHolder(g),!0}else return!1};I(v)||I(f)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(n){this.value&&(n||this.value!==this.getCurrentValue())&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}isAtFirstInHistory(){return this.history.isFirst()}isAtLastInHistory(){return this.history.isLast()}isNowhereInHistory(){return this.history.isNowhere()}showNextValue(){this.history.has(this.value)||this.addToHistory();let n=this.getNextValue();n&&(n=n===this.value?this.getNextValue():n),this.value=n??"",b.status(this.value?this.value:r.localize(4,null))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let n=this.getPreviousValue();n&&(n=n===this.value?this.getPreviousValue():n),n&&(this.value=n,b.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let n=this.history.current();return n||(n=this.history.last(),this.history.next()),n}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()}}t.HistoryInputBox=s}),define(me[63],pe([1,0,60,19,16,17,3,93]),function(te,t,y,k,i,z,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class _ extends y.BaseActionViewItem{constructor(P,r,a){super(P,r,a),this.toggle=this._register(new c({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:a.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:a.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:a.toggleStyles?.inputActiveOptionForeground})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(P){this.element=P,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(P){this.toggle.domNode.tabIndex=P?0:-1}}t.ToggleActionViewItem=_;class c extends k.Widget{constructor(P){super(),this._onChange=this._register(new b.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new b.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts=P,this._checked=this._opts.isChecked;const r=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,r.push(...z.ThemeIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&r.push(...this._opts.actionClassName.split(" ")),this._checked&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...r),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,a=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),a.preventDefault())}),this._register(this.ignoreGesture(this.domNode)),this.onkeydown(this.domNode,a=>{if(a.keyCode===10||a.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),a.preventDefault(),a.stopPropagation();return}this._onKeyDown.fire(a)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(P){this._checked=P,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(P){this._icon&&this.domNode.classList.remove(...z.ThemeIcon.asClassNameArray(this._icon)),this._icon=P,this._icon&&this.domNode.classList.add(...z.ThemeIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder||"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(P){this.domNode.title=P,this.domNode.setAttribute("aria-label",P)}}t.Toggle=c;class l extends k.Widget{constructor(P,r,a){super(),this.title=P,this.isChecked=r,this.checkbox=new c({title:this.title,isChecked:this.isChecked,icon:i.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.checkbox.domNode,this.styles=a,this.applyStyles(),this._register(this.checkbox.onChange(()=>this.applyStyles()))}get checked(){return this.checkbox.checked}set checked(P){this.checkbox.checked=P,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground||"",this.domNode.style.backgroundColor=this.styles.checkboxBackground||"",this.domNode.style.borderColor=this.styles.checkboxBorder||""}}t.Checkbox=l}),define(me[126],pe([1,0,63,16,98]),function(te,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const z=i.localize(0,null),b=i.localize(1,null),_=i.localize(2,null);class c extends y.Toggle{constructor(r){super({icon:k.Codicon.caseSensitive,title:z+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.CaseSensitiveToggle=c;class l extends y.Toggle{constructor(r){super({icon:k.Codicon.wholeWord,title:b+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.WholeWordsToggle=l;class h extends y.Toggle{constructor(r){super({icon:k.Codicon.regex,title:_+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.RegexToggle=h}),define(me[127],pe([1,0,4,126,62,19,3,97,2,87]),function(te,t,y,k,i,z,b,_,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const l=_.localize(0,null);class h extends z.Widget{constructor(r,a,e){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=new c.DisposableStore,this.additionalToggles=[],this._onDidOptionChange=this._register(new b.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new b.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new b.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new b.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new b.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new b.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new b.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||l,this.showCommonFindToggles=!!e.showCommonFindToggles;const o=e.appendCaseSensitiveLabel||"",s=e.appendWholeWordsLabel||"",u=e.appendRegexLabel||"",n=e.history||[],D=!!e.flexibleHeight,w=!!e.flexibleWidth,S=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new i.HistoryInputBox(this.domNode,a,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:D,flexibleWidth:w,flexibleMaxHeight:S,inputBoxStyles:e.inputBoxStyles})),this.showCommonFindToggles){this.regex=this._register(new k.RegexToggle({appendTitle:u,isChecked:!1,...e.toggleStyles})),this._register(this.regex.onChange(v=>{this._onDidOptionChange.fire(v),!v&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(v=>{this._onRegexKeyDown.fire(v)})),this.wholeWords=this._register(new k.WholeWordsToggle({appendTitle:s,isChecked:!1,...e.toggleStyles})),this._register(this.wholeWords.onChange(v=>{this._onDidOptionChange.fire(v),!v&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new k.CaseSensitiveToggle({appendTitle:o,isChecked:!1,...e.toggleStyles})),this._register(this.caseSensitive.onChange(v=>{this._onDidOptionChange.fire(v),!v&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(v=>{this._onCaseSensitiveKeyDown.fire(v)}));const f=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,v=>{if(v.equals(15)||v.equals(17)||v.equals(9)){const L=f.indexOf(document.activeElement);if(L>=0){let I=-1;v.equals(17)?I=(L+1)%f.length:v.equals(15)&&(L===0?I=f.length-1:I=L-1),v.equals(9)?(f[L].blur(),this.inputBox.focus()):I>=0&&f[I].focus(),y.EventHelper.stop(v,!0)}}})}this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"":"none",this.caseSensitive&&this.controls.append(this.caseSensitive.domNode),this.wholeWords&&this.controls.appendChild(this.wholeWords.domNode),this.regex&&this.controls.appendChild(this.regex.domNode),this.setAdditionalToggles(e?.additionalToggles),this.controls&&this.domNode.appendChild(this.controls),r?.appendChild(this.domNode),this._register(y.addDisposableListener(this.inputBox.inputElement,"compositionstart",f=>{this.imeSessionInProgress=!0})),this._register(y.addDisposableListener(this.inputBox.inputElement,"compositionend",f=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,f=>this._onKeyDown.fire(f)),this.onkeyup(this.inputBox.inputElement,f=>this._onKeyUp.fire(f)),this.oninput(this.inputBox.inputElement,f=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,f=>this._onMouseDown.fire(f))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.updateInputBoxPadding(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex?.enable(),this.wholeWords?.enable(),this.caseSensitive?.enable();for(const r of this.additionalToggles)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex?.disable(),this.wholeWords?.disable(),this.caseSensitive?.disable();for(const r of this.additionalToggles)r.disable()}setFocusInputOnOptionClick(r){this.fixFocusOnOptionClickEnabled=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const a of this.additionalToggles)a.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.dispose(),this.additionalTogglesDisposables=new c.DisposableStore;for(const a of r??[])this.additionalTogglesDisposables.add(a),this.controls.appendChild(a.domNode),this.additionalTogglesDisposables.add(a.onChange(e=>{this._onDidOptionChange.fire(e),!e&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(a);this.additionalToggles.length>0&&(this.controls.style.display=""),this.updateInputBoxPadding()}updateInputBoxPadding(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.caseSensitive?.width()??0)+(this.wholeWords?.width()??0)+(this.regex?.width()??0)+this.additionalToggles.reduce((a,e)=>a+e.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive?.checked??!1}setCaseSensitive(r){this.caseSensitive&&(this.caseSensitive.checked=r)}getWholeWords(){return this.wholeWords?.checked??!1}setWholeWords(r){this.wholeWords&&(this.wholeWords.checked=r)}getRegex(){return this.regex?.checked??!1}setRegex(r){this.regex&&(this.regex.checked=r,this.validate())}focusOnCaseSensitive(){this.caseSensitive?.focus()}focusOnRegex(){this.regex?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=h,h.OPTION_CHANGE="optionChange"}),define(me[128],pe([1,0,4,20,14,61,127,62,58,36,63,55,24,31,13,9,16,17,69,3,32,2,44,6,102,94]),function(te,t,y,k,i,z,b,_,c,l,h,P,r,a,e,o,s,u,n,D,w,S,f,v,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class I extends c.ElementsDragAndDropData{set context(d){this.data.context=d}get context(){return this.data.context}constructor(d){super(d.elements.map(R=>R.element)),this.data=d}}function E(N){return N instanceof c.ElementsDragAndDropData?new I(N):N}class g{constructor(d,R){this.modelProvider=d,this.dnd=R,this.autoExpandDisposable=S.Disposable.None}getDragURI(d){return this.dnd.getDragURI(d.element)}getDragLabel(d,R){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(d.map($=>$.element),R)}onDragStart(d,R){this.dnd.onDragStart?.(E(d),R)}onDragOver(d,R,$,Z,T=!0){const F=this.dnd.onDragOver(E(d),R&&R.element,$,Z),B=this.autoExpandNode!==R;if(B&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=R),typeof R>"u")return F;if(B&&typeof F!="boolean"&&F.autoExpand&&(this.autoExpandDisposable=(0,o.disposableTimeout)(()=>{const U=this.modelProvider(),q=U.getNodeLocation(R);U.isCollapsed(q)&&U.setCollapsed(q,!1),this.autoExpandNode=void 0},500)),typeof F=="boolean"||!F.accept||typeof F.bubble>"u"||F.feedback){if(!T){const U=typeof F=="boolean"?F:F.accept,q=typeof F=="boolean"?void 0:F.effect;return{accept:U,effect:q,feedback:[$]}}return F}if(F.bubble===1){const U=this.modelProvider(),q=U.getNodeLocation(R),ee=U.getParentNodeLocation(q),ne=U.getNode(ee),ve=ee&&U.getListIndex(ee);return this.onDragOver(d,ne,ve,Z,!1)}const C=this.modelProvider(),H=C.getNodeLocation(R),x=C.getListIndex(H),M=C.getListRenderCount(H);return{...F,feedback:(0,e.range)(x,x+M)}}drop(d,R,$,Z){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(E(d),R&&R.element,$,Z)}onDragEnd(d){this.dnd.onDragEnd?.(d)}}function m(N,d){return d&&{...d,identityProvider:d.identityProvider&&{getId(R){return d.identityProvider.getId(R.element)}},dnd:d.dnd&&new g(N,d.dnd),multipleSelectionController:d.multipleSelectionController&&{isSelectionSingleChangeEvent(R){return d.multipleSelectionController.isSelectionSingleChangeEvent({...R,element:R.element})},isSelectionRangeChangeEvent(R){return d.multipleSelectionController.isSelectionRangeChangeEvent({...R,element:R.element})}},accessibilityProvider:d.accessibilityProvider&&{...d.accessibilityProvider,getSetSize(R){const $=N(),Z=$.getNodeLocation(R),T=$.getParentNodeLocation(Z);return $.getNode(T).visibleChildrenCount},getPosInSet(R){return R.visibleChildIndex+1},isChecked:d.accessibilityProvider&&d.accessibilityProvider.isChecked?R=>d.accessibilityProvider.isChecked(R.element):void 0,getRole:d.accessibilityProvider&&d.accessibilityProvider.getRole?R=>d.accessibilityProvider.getRole(R.element):()=>"treeitem",getAriaLabel(R){return d.accessibilityProvider.getAriaLabel(R.element)},getWidgetAriaLabel(){return d.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:d.accessibilityProvider&&d.accessibilityProvider.getWidgetRole?()=>d.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:d.accessibilityProvider&&d.accessibilityProvider.getAriaLevel?R=>d.accessibilityProvider.getAriaLevel(R.element):R=>R.depth,getActiveDescendantId:d.accessibilityProvider.getActiveDescendantId&&(R=>d.accessibilityProvider.getActiveDescendantId(R.element))},keyboardNavigationLabelProvider:d.keyboardNavigationLabelProvider&&{...d.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(R){return d.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(R.element)}}}}class p{constructor(d){this.delegate=d}getHeight(d){return this.delegate.getHeight(d.element)}getTemplateId(d){return this.delegate.getTemplateId(d.element)}hasDynamicHeight(d){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(d.element)}setDynamicHeight(d,R){this.delegate.setDynamicHeight?.(d.element,R)}}t.ComposedTreeDelegate=p;class O{static lift(d){return d instanceof O?d:new O(d)}static empty(d=0){return new O({focus:[],selection:[],expanded:Object.create(null),scrollTop:d})}constructor(d){if(this.focus=new Set(d.focus),this.selection=new Set(d.selection),d.expanded instanceof Array){this.expanded=Object.create(null);for(const R of d.expanded)this.expanded[R]=1}else this.expanded=d.expanded;this.expanded=d.expanded,this.scrollTop=d.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=O;var G;(function(N){N.None="none",N.OnHover="onHover",N.Always="always"})(G||(t.RenderIndentGuides=G={}));class J{get elements(){return this._elements}constructor(d,R=[]){this._elements=R,this.disposables=new S.DisposableStore,this.onDidChange=D.Event.forEach(d,$=>this._elements=$,this.disposables)}dispose(){this.disposables.dispose()}}class ie{constructor(d,R,$,Z,T,F={}){this.renderer=d,this.modelProvider=R,this.activeNodes=Z,this.renderedIndentGuides=T,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=ie.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.templateId=d.templateId,this.updateOptions(F),D.Event.map($,B=>B.node)(this.onDidChangeNodeTwistieState,this,this.disposables),d.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(d={}){if(typeof d.indent<"u"){const R=(0,f.clamp)(d.indent,0,40);if(R!==this.indent){this.indent=R;for(const[$,Z]of this.renderedNodes)this.renderTreeElement($,Z)}}if(typeof d.renderIndentGuides<"u"){const R=d.renderIndentGuides!==G.None;if(R!==this.shouldRenderIndentGuides){this.shouldRenderIndentGuides=R;for(const[$,Z]of this.renderedNodes)this._renderIndentGuides($,Z);if(this.indentGuidesDisposable.dispose(),R){const $=new S.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,$),this.indentGuidesDisposable=$,this._onDidChangeActiveNodes(this.activeNodes.elements)}}}typeof d.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=d.hideTwistiesOfChildlessElements)}renderTemplate(d){const R=(0,y.append)(d,(0,y.$)(".monaco-tl-row")),$=(0,y.append)(R,(0,y.$)(".monaco-tl-indent")),Z=(0,y.append)(R,(0,y.$)(".monaco-tl-twistie")),T=(0,y.append)(R,(0,y.$)(".monaco-tl-contents")),F=this.renderer.renderTemplate(T);return{container:d,indent:$,twistie:Z,indentGuidesDisposable:S.Disposable.None,templateData:F}}renderElement(d,R,$,Z){this.renderedNodes.set(d,$),this.renderedElements.set(d.element,d),this.renderTreeElement(d,$),this.renderer.renderElement(d,R,$.templateData,Z)}disposeElement(d,R,$,Z){$.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(d,R,$.templateData,Z),typeof Z=="number"&&(this.renderedNodes.delete(d),this.renderedElements.delete(d.element))}disposeTemplate(d){this.renderer.disposeTemplate(d.templateData)}onDidChangeTwistieState(d){const R=this.renderedElements.get(d);R&&this.onDidChangeNodeTwistieState(R)}onDidChangeNodeTwistieState(d){const R=this.renderedNodes.get(d);R&&(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(d,R))}renderTreeElement(d,R){const $=ie.DefaultIndent+(d.depth-1)*this.indent;R.twistie.style.paddingLeft=`${$}px`,R.indent.style.width=`${$+this.indent-16}px`,d.collapsible?R.container.setAttribute("aria-expanded",String(!d.collapsed)):R.container.removeAttribute("aria-expanded"),R.twistie.classList.remove(...u.ThemeIcon.asClassNameArray(s.Codicon.treeItemExpanded));let Z=!1;this.renderer.renderTwistie&&(Z=this.renderer.renderTwistie(d.element,R.twistie)),d.collapsible&&(!this.hideTwistiesOfChildlessElements||d.visibleChildrenCount>0)?(Z||R.twistie.classList.add(...u.ThemeIcon.asClassNameArray(s.Codicon.treeItemExpanded)),R.twistie.classList.add("collapsible"),R.twistie.classList.toggle("collapsed",d.collapsed)):R.twistie.classList.remove("collapsible","collapsed"),this._renderIndentGuides(d,R)}_renderIndentGuides(d,R){if((0,y.clearNode)(R.indent),R.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const $=new S.DisposableStore,Z=this.modelProvider();for(;;){const T=Z.getNodeLocation(d),F=Z.getParentNodeLocation(T);if(!F)break;const B=Z.getNode(F),C=(0,y.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(B)&&C.classList.add("active"),R.indent.childElementCount===0?R.indent.appendChild(C):R.indent.insertBefore(C,R.indent.firstElementChild),this.renderedIndentGuides.add(B,C),$.add((0,S.toDisposable)(()=>this.renderedIndentGuides.delete(B,C))),d=B}R.indentGuidesDisposable=$}_onDidChangeActiveNodes(d){if(!this.shouldRenderIndentGuides)return;const R=new Set,$=this.modelProvider();d.forEach(Z=>{const T=$.getNodeLocation(Z);try{const F=$.getParentNodeLocation(T);Z.collapsible&&Z.children.length>0&&!Z.collapsed?R.add(Z):F&&R.add($.getNode(F))}catch{}}),this.activeIndentNodes.forEach(Z=>{R.has(Z)||this.renderedIndentGuides.forEach(Z,T=>T.classList.remove("active"))}),R.forEach(Z=>{this.activeIndentNodes.has(Z)||this.renderedIndentGuides.forEach(Z,T=>T.classList.add("active"))}),this.activeIndentNodes=R}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,S.dispose)(this.disposables)}}ie.DefaultIndent=8;class ae{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(d){this._pattern=d,this._lowercasePattern=d.toLowerCase()}constructor(d,R,$){this.tree=d,this.keyboardNavigationLabelProvider=R,this._filter=$,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new S.DisposableStore,d.onWillRefilter(this.reset,this,this.disposables)}filter(d,R){let $=1;if(this._filter){const F=this._filter.filter(d,R);if(typeof F=="boolean"?$=F?1:0:(0,P.isFilterResult)(F)?$=(0,P.getVisibleState)(F.visibility):$=F,$===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:w.FuzzyScore.Default,visibility:$};const Z=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(d),T=Array.isArray(Z)?Z:[Z];for(const F of T){const B=F&&F.toString();if(typeof B>"u")return{data:w.FuzzyScore.Default,visibility:$};let C;if(this.tree.findMatchType===Se.Contiguous){const H=B.toLowerCase().indexOf(this._lowercasePattern);if(H>-1){C=[Number.MAX_SAFE_INTEGER,0];for(let x=this._lowercasePattern.length;x>0;x--)C.push(H+x-1)}}else C=(0,w.fuzzyScore)(this._pattern,this._lowercasePattern,0,B,B.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(C)return this._matchCount++,T.length===1?{data:C,visibility:$}:{data:{label:B,score:C},visibility:$}}return this.tree.findMode===he.Filter?typeof this.tree.options.defaultFindVisibility=="number"?this.tree.options.defaultFindVisibility:this.tree.options.defaultFindVisibility?this.tree.options.defaultFindVisibility(d):2:{data:w.FuzzyScore.Default,visibility:$}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,S.dispose)(this.disposables)}}class ge extends h.Toggle{constructor(d){super({icon:s.Codicon.listFilter,title:(0,L.localize)(0,null),isChecked:d.isChecked??!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.ModeToggle=ge;class ue extends h.Toggle{constructor(d){super({icon:s.Codicon.searchFuzzy,title:(0,L.localize)(1,null),isChecked:d.isChecked??!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.FuzzyToggle=ue;const de={inputBoxStyles:_.unthemedInboxStyles,toggleStyles:h.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var he;(function(N){N[N.Highlight=0]="Highlight",N[N.Filter=1]="Filter"})(he||(t.TreeFindMode=he={}));var Se;(function(N){N[N.Fuzzy=0]="Fuzzy",N[N.Contiguous=1]="Contiguous"})(Se||(t.TreeFindMatchType=Se={}));class _e extends S.Disposable{set mode(d){this.modeToggle.checked=d===he.Filter,this.findInput.inputBox.setPlaceHolder(d===he.Filter?(0,L.localize)(2,null):(0,L.localize)(3,null))}set matchType(d){this.matchTypeToggle.checked=d===Se.Fuzzy}get value(){return this.findInput.inputBox.value}set value(d){this.findInput.inputBox.value=d}constructor(d,R,$,Z,T,F){super(),this.tree=R,this.elements=(0,y.h)(".monaco-tree-type-filter",[(0,y.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,y.h)(".monaco-tree-type-filter-input@findInput"),(0,y.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new D.Emitter,this.onDidDisable=this._onDidDisable.event,d.appendChild(this.elements.root),this._register((0,S.toDisposable)(()=>d.removeChild(this.elements.root)));const B=F?.styles??de;B.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=B.listFilterWidgetBackground),B.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${B.listFilterWidgetShadow}`),this.modeToggle=this._register(new ge({...B.toggleStyles,isChecked:Z===he.Filter})),this.matchTypeToggle=this._register(new ue({...B.toggleStyles,isChecked:T===Se.Fuzzy})),this.onDidChangeMode=D.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?he.Filter:he.Highlight,this._store),this.onDidChangeMatchType=D.Event.map(this.matchTypeToggle.onChange,()=>this.matchTypeToggle.checked?Se.Fuzzy:Se.Contiguous,this._store),this.findInput=this._register(new b.FindInput(this.elements.findInput,$,{label:(0,L.localize)(4,null),additionalToggles:[this.modeToggle,this.matchTypeToggle],showCommonFindToggles:!1,inputBoxStyles:B.inputBoxStyles,toggleStyles:B.toggleStyles,history:F?.history})),this.actionbar=this._register(new z.ActionBar(this.elements.actionbar)),this.mode=Z;const C=this._register(new k.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),H=this._register(D.Event.chain(C.event)).map(q=>new i.StandardKeyboardEvent(q)).event;this._register(H(q=>{if(q.equals(3)){q.preventDefault(),q.stopPropagation(),this.findInput.inputBox.addToHistory(),this.tree.domFocus();return}if(q.equals(18)){q.preventDefault(),q.stopPropagation(),this.findInput.inputBox.isAtLastInHistory()||this.findInput.inputBox.isNowhereInHistory()?(this.findInput.inputBox.addToHistory(),this.tree.domFocus()):this.findInput.inputBox.showNextValue();return}if(q.equals(16)){q.preventDefault(),q.stopPropagation(),this.findInput.inputBox.showPreviousValue();return}}));const x=this._register(new a.Action("close",(0,L.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(x,{icon:!0,label:!1});const M=this._register(new k.DomEmitter(this.elements.grab,"mousedown"));this._register(M.event(q=>{const ee=new S.DisposableStore,ne=ee.add(new k.DomEmitter(window,"mousemove")),ve=ee.add(new k.DomEmitter(window,"mouseup")),we=this.right,Ne=q.pageX,Ae=this.top,De=q.pageY;this.elements.grab.classList.add("grabbing");const Pe=this.elements.root.style.transition;this.elements.root.style.transition="unset";const Ie=Ke=>{const xe=Ke.pageX-Ne;this.right=we-xe;const ze=Ke.pageY-De;this.top=Ae+ze,this.layout()};ee.add(ne.event(Ie)),ee.add(ve.event(Ke=>{Ie(Ke),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=Pe,ee.dispose()}))}));const U=this._register(D.Event.chain(this._register(new k.DomEmitter(this.elements.grab,"keydown")).event)).map(q=>new i.StandardKeyboardEvent(q)).event;this._register(U(q=>{let ee,ne;if(q.keyCode===15?ee=Number.POSITIVE_INFINITY:q.keyCode===17?ee=0:q.keyCode===10&&(ee=this.right===0?Number.POSITIVE_INFINITY:0),q.keyCode===16?ne=0:q.keyCode===18&&(ne=Number.POSITIVE_INFINITY),ee!==void 0&&(q.preventDefault(),q.stopPropagation(),this.right=ee,this.layout()),ne!==void 0){q.preventDefault(),q.stopPropagation(),this.top=ne;const ve=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=ve},0)}})),this.onDidChangeValue=this.findInput.onDidChange}getHistory(){return this.findInput.inputBox.getHistory()}focus(){this.findInput.focus()}select(){this.findInput.select(),this.findInput.inputBox.addToHistory(!0)}layout(d=this.width){this.width=d,this.right=(0,f.clamp)(this.right,0,Math.max(0,d-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,f.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(d){this.findInput.showMessage(d)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,o.timeout)(300),super.dispose()}}class Oe{get pattern(){return this._pattern}get mode(){return this._mode}set mode(d){d!==this._mode&&(this._mode=d,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(d))}get matchType(){return this._matchType}set matchType(d){d!==this._matchType&&(this._matchType=d,this.widget&&(this.widget.matchType=this._matchType),this.tree.refilter(),this.render(),this._onDidChangeMatchType.fire(d))}constructor(d,R,$,Z,T,F={}){this.tree=d,this.view=$,this.filter=Z,this.contextViewProvider=T,this.options=F,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new D.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangeMatchType=new D.Emitter,this.onDidChangeMatchType=this._onDidChangeMatchType.event,this._onDidChangePattern=new D.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new D.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new S.DisposableStore,this.disposables=new S.DisposableStore,this._mode=d.options.defaultFindMode??he.Highlight,this._matchType=d.options.defaultFindMatchType??Se.Fuzzy,R.onDidSplice(this.onDidSpliceModel,this,this.disposables)}updateOptions(d={}){d.defaultFindMode!==void 0&&(this.mode=d.defaultFindMode),d.defaultFindMatchType!==void 0&&(this.matchType=d.defaultFindMatchType)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new _e(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.matchType,{...this.options,history:this._history}),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(d=>this.mode=d,void 0,this.enabledDisposables),this.widget.onDidChangeMatchType(d=>this.matchType=d,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){this.widget&&(this._history=this.widget.getHistory(),this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new S.DisposableStore,this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(d){this._pattern=d,this._onDidChangePattern.fire(d),this.filter.pattern=d,this.tree.refilter(),d&&this.tree.focusNext(0,!0,void 0,$=>!w.FuzzyScore.isDefault($.filterData));const R=this.tree.getFocus();if(R.length>0){const $=R[0];this.tree.getRelativeTop($)===null&&this.tree.reveal($,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const d=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&d?this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:2,content:(0,L.localize)(6,null)}):this.widget?.showMessage({type:2}):this.widget?.clearMessage()}shouldAllowFocus(d){return!this.widget||!this.pattern||this._mode===he.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!w.FuzzyScore.isDefault(d.filterData)}layout(d){this.width=d,this.widget?.layout(d)}dispose(){this._history=void 0,this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function re(N){let d=r.TreeMouseEventTarget.Unknown;return(0,y.hasParentWithClass)(N.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?d=r.TreeMouseEventTarget.Twistie:(0,y.hasParentWithClass)(N.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?d=r.TreeMouseEventTarget.Element:(0,y.hasParentWithClass)(N.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(d=r.TreeMouseEventTarget.Filter),{browserEvent:N.browserEvent,element:N.element?N.element.element:null,target:d}}function se(N){return{element:N.element?N.element.element:null,browserEvent:N.browserEvent,anchor:N.anchor}}function Q(N,d){d(N),N.children.forEach(R=>Q(R,d))}class oe{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(d,R){this.getFirstViewElementWithTrait=d,this.identityProvider=R,this.nodes=[],this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event}set(d,R){!R?.__forceEvent&&(0,e.equals)(this.nodes,d)||this._set(d,!1,R)}_set(d,R,$){if(this.nodes=[...d],this.elements=void 0,this._nodeSet=void 0,!R){const Z=this;this._onDidChange.fire({get elements(){return Z.get()},browserEvent:$})}}get(){return this.elements||(this.elements=this.nodes.map(d=>d.element)),[...this.elements]}getNodes(){return this.nodes}has(d){return this.nodeSet.has(d)}onDidModelSplice({insertedNodes:d,deletedNodes:R}){if(!this.identityProvider){const C=this.createNodeSet(),H=x=>C.delete(x);R.forEach(x=>Q(x,H)),this.set([...C.values()]);return}const $=new Set,Z=C=>$.add(this.identityProvider.getId(C.element).toString());R.forEach(C=>Q(C,Z));const T=new Map,F=C=>T.set(this.identityProvider.getId(C.element).toString(),C);d.forEach(C=>Q(C,F));const B=[];for(const C of this.nodes){const H=this.identityProvider.getId(C.element).toString();if(!$.has(H))B.push(C);else{const M=T.get(H);M&&M.visible&&B.push(M)}}if(this.nodes.length>0&&B.length===0){const C=this.getFirstViewElementWithTrait();C&&B.push(C)}this._set(B,!0)}createNodeSet(){const d=new Set;for(const R of this.nodes)d.add(R);return d}}class V extends l.MouseController{constructor(d,R){super(d),this.tree=R}onViewPointer(d){if((0,l.isButton)(d.browserEvent.target)||(0,l.isInputElement)(d.browserEvent.target)||(0,l.isMonacoEditor)(d.browserEvent.target))return;const R=d.element;if(!R)return super.onViewPointer(d);if(this.isSelectionRangeChangeEvent(d)||this.isSelectionSingleChangeEvent(d))return super.onViewPointer(d);const $=d.browserEvent.target,Z=$.classList.contains("monaco-tl-twistie")||$.classList.contains("monaco-icon-label")&&$.classList.contains("folder-icon")&&d.browserEvent.offsetX<16;let T=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?T=this.tree.expandOnlyOnTwistieClick(R.element):T=!!this.tree.expandOnlyOnTwistieClick,T&&!Z&&d.browserEvent.detail!==2)return super.onViewPointer(d);if(!this.tree.expandOnDoubleClick&&d.browserEvent.detail===2)return super.onViewPointer(d);if(R.collapsible){const F=this.tree.getNodeLocation(R),B=d.browserEvent.altKey;if(this.tree.setFocus([F]),this.tree.toggleCollapsed(F,B),T&&Z)return}super.onViewPointer(d)}onDoubleClick(d){d.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||super.onDoubleClick(d)}}class K extends l.List{constructor(d,R,$,Z,T,F,B,C){super(d,R,$,Z,C),this.focusTrait=T,this.selectionTrait=F,this.anchorTrait=B}createMouseController(d){return new V(this,d.tree)}splice(d,R,$=[]){if(super.splice(d,R,$),$.length===0)return;const Z=[],T=[];let F;$.forEach((B,C)=>{this.focusTrait.has(B)&&Z.push(d+C),this.selectionTrait.has(B)&&T.push(d+C),this.anchorTrait.has(B)&&(F=d+C)}),Z.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...Z])),T.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...T])),typeof F=="number"&&super.setAnchor(F)}setFocus(d,R,$=!1){super.setFocus(d,R),$||this.focusTrait.set(d.map(Z=>this.element(Z)),R)}setSelection(d,R,$=!1){super.setSelection(d,R),$||this.selectionTrait.set(d.map(Z=>this.element(Z)),R)}setAnchor(d,R=!1){super.setAnchor(d),R||(typeof d>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(d)]))}}class A{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return D.Event.map(this.view.onMouseClick,re)}get onMouseDblClick(){return D.Event.filter(D.Event.map(this.view.onMouseDblClick,re),d=>d.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return D.Event.map(this.view.onContextMenu,se)}get onTap(){return D.Event.map(this.view.onTap,re)}get onPointer(){return D.Event.map(this.view.onPointer,re)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return D.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??he.Highlight}set findMode(d){this.findController&&(this.findController.mode=d)}get findMatchType(){return this.findController?.matchType??Se.Fuzzy}set findMatchType(d){this.findController&&(this.findController.matchType=d)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:D.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(d,R,$,Z,T={}){this._user=d,this._options=T,this.eventBufferer=new D.EventBufferer,this.onDidChangeFindOpenState=D.Event.None,this.disposables=new S.DisposableStore,this._onWillRefilter=new D.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new D.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const F=new p($),B=new D.Relay,C=new D.Relay,H=this.disposables.add(new J(C.event)),x=new n.SetMap;this.renderers=Z.map(q=>new ie(q,()=>this.model,B.event,H,x,T));for(const q of this.renderers)this.disposables.add(q);let M;T.keyboardNavigationLabelProvider&&(M=new ae(this,T.keyboardNavigationLabelProvider,T.filter),T={...T,filter:M},this.disposables.add(M)),this.focus=new oe(()=>this.view.getFocusedElements()[0],T.identityProvider),this.selection=new oe(()=>this.view.getSelectedElements()[0],T.identityProvider),this.anchor=new oe(()=>this.view.getAnchorElement(),T.identityProvider),this.view=new K(d,R,F,this.renderers,this.focus,this.selection,this.anchor,{...m(()=>this.model,T),tree:this}),this.model=this.createModel(d,this.view,T),B.input=this.model.onDidChangeCollapseState;const U=D.Event.forEach(this.model.onDidSplice,q=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(q),this.selection.onDidModelSplice(q)})},this.disposables);if(U(()=>null,null,this.disposables),C.input=D.Event.chain(D.Event.any(U,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const q=new Set;for(const ee of this.focus.getNodes())q.add(ee);for(const ee of this.selection.getNodes())q.add(ee);return[...q.values()]}).event,T.keyboardSupport!==!1){const q=D.Event.chain(this.view.onKeyDown).filter(ee=>!(0,l.isInputElement)(ee.target)).map(ee=>new i.StandardKeyboardEvent(ee));q.filter(ee=>ee.keyCode===15).on(this.onLeftArrow,this,this.disposables),q.filter(ee=>ee.keyCode===17).on(this.onRightArrow,this,this.disposables),q.filter(ee=>ee.keyCode===10).on(this.onSpace,this,this.disposables)}if((T.findWidgetEnabled??!0)&&T.keyboardNavigationLabelProvider&&T.contextViewProvider){const q=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.findController=new Oe(this,this.model,this.view,M,T.contextViewProvider,q),this.focusNavigationFilter=ee=>this.findController.shouldAllowFocus(ee),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode,this.onDidChangeFindMatchType=this.findController.onDidChangeMatchType}else this.onDidChangeFindMode=D.Event.None,this.onDidChangeFindMatchType=D.Event.None;this.styleElement=(0,y.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===G.Always)}updateOptions(d={}){this._options={...this._options,...d};for(const R of this.renderers)R.updateOptions(d);this.view.updateOptions(this._options),this.findController?.updateOptions(d),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===G.Always)}get options(){return this._options}updateWidth(d){const R=this.model.getListIndex(d);R!==-1&&this.view.updateWidth(R)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.scrollTop}set scrollTop(d){this.view.scrollTop=d}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(d){this.view.scrollLeft=d}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const d=this.view.firstVisibleIndex;return d<0||d>=this.view.length?void 0:this.view.element(d).element}get lastVisibleElement(){const d=this.view.lastVisibleIndex;return this.view.element(d).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(d){this.view.ariaLabel=d}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(d,R){this.view.layout(d,R),(0,v.isNumber)(R)&&this.findController?.layout(R)}style(d){const R=`.${this.view.domId}`,$=[];d.treeIndentGuidesStroke&&($.push(`.monaco-list${R}:hover .monaco-tl-indent > .indent-guide, .monaco-list${R}.always .monaco-tl-indent > .indent-guide  { border-color: ${d.treeInactiveIndentGuidesStroke}; }`),$.push(`.monaco-list${R} .monaco-tl-indent > .indent-guide.active { border-color: ${d.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=$.join(`
`),this.view.style(d)}getParentElement(d){const R=this.model.getParentNodeLocation(d);return this.model.getNode(R).element}getFirstElementChild(d){return this.model.getFirstElementChild(d)}getNode(d){return this.model.getNode(d)}getNodeLocation(d){return this.model.getNodeLocation(d)}collapse(d,R=!1){return this.model.setCollapsed(d,!0,R)}expand(d,R=!1){return this.model.setCollapsed(d,!1,R)}toggleCollapsed(d,R=!1){return this.model.setCollapsed(d,void 0,R)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(d){return this.model.isCollapsible(d)}setCollapsible(d,R){return this.model.setCollapsible(d,R)}isCollapsed(d){return this.model.isCollapsed(d)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(d){if(typeof d>"u")return this.view.setAnchor(void 0);const R=this.model.getNode(d);this.anchor.set([R]);const $=this.model.getListIndex(d);$>-1&&this.view.setAnchor($,!0)}getAnchor(){return(0,e.firstOrDefault)(this.anchor.get(),void 0)}setSelection(d,R){const $=d.map(T=>this.model.getNode(T));this.selection.set($,R);const Z=d.map(T=>this.model.getListIndex(T)).filter(T=>T>-1);this.view.setSelection(Z,R,!0)}getSelection(){return this.selection.get()}setFocus(d,R){const $=d.map(T=>this.model.getNode(T));this.focus.set($,R);const Z=d.map(T=>this.model.getListIndex(T)).filter(T=>T>-1);this.view.setFocus(Z,R,!0)}focusNext(d=1,R=!1,$,Z=this.focusNavigationFilter){this.view.focusNext(d,R,$,Z)}focusPrevious(d=1,R=!1,$,Z=this.focusNavigationFilter){this.view.focusPrevious(d,R,$,Z)}focusNextPage(d,R=this.focusNavigationFilter){return this.view.focusNextPage(d,R)}focusPreviousPage(d,R=this.focusNavigationFilter){return this.view.focusPreviousPage(d,R)}focusLast(d,R=this.focusNavigationFilter){this.view.focusLast(d,R)}focusFirst(d,R=this.focusNavigationFilter){this.view.focusFirst(d,R)}getFocus(){return this.focus.get()}reveal(d,R){this.model.expandTo(d);const $=this.model.getListIndex(d);$!==-1&&this.view.reveal($,R)}getRelativeTop(d){const R=this.model.getListIndex(d);return R===-1?null:this.view.getRelativeTop(R)}getViewState(d=this.options.identityProvider){if(!d)throw new r.TreeError(this._user,"Can't get tree view state without an identity provider");const R=F=>d.getId(F).toString(),$=O.empty(this.scrollTop);for(const F of this.getFocus())$.focus.add(R(F));for(const F of this.getSelection())$.selection.add(R(F));const Z=this.model.getNode(),T=[Z];for(;T.length>0;){const F=T.shift();F!==Z&&F.collapsible&&($.expanded[R(F.element)]=F.collapsed?0:1),T.push(...F.children)}return $}onLeftArrow(d){d.preventDefault(),d.stopPropagation();const R=this.view.getFocusedElements();if(R.length===0)return;const $=R[0],Z=this.model.getNodeLocation($);if(!this.model.setCollapsed(Z,!0)){const F=this.model.getParentNodeLocation(Z);if(!F)return;const B=this.model.getListIndex(F);this.view.reveal(B),this.view.setFocus([B])}}onRightArrow(d){d.preventDefault(),d.stopPropagation();const R=this.view.getFocusedElements();if(R.length===0)return;const $=R[0],Z=this.model.getNodeLocation($);if(!this.model.setCollapsed(Z,!1)){if(!$.children.some(C=>C.visible))return;const[F]=this.view.getFocus(),B=F+1;this.view.reveal(B),this.view.setFocus([B])}}onSpace(d){d.preventDefault(),d.stopPropagation();const R=this.view.getFocusedElements();if(R.length===0)return;const $=R[0],Z=this.model.getNodeLocation($),T=d.browserEvent.altKey;this.model.setCollapsed(Z,void 0,T)}navigate(d){return new W(this.view,this.model,d)}dispose(){(0,S.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=A;class W{constructor(d,R,$){this.view=d,this.model=R,$?this.index=this.model.getListIndex($):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(me[129],pe([1,0,128,119,24,26]),function(te,t,y,k,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class b extends y.AbstractTree{constructor(c,l,h,P,r,a={}){super(c,l,h,P,a),this.user=c,this.dataSource=r,this.nodesByIdentity=new Map,this.identityProvider=a.identityProvider}getInput(){return this.input}setInput(c,l){if(l&&!this.identityProvider)throw new i.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=c,!c){this.nodesByIdentity.clear(),this.model.setChildren(null,z.Iterable.empty());return}if(!l){this._refresh(c);return}const h=[],P=[],r=e=>{const o=this.identityProvider.getId(e).toString();return!l.expanded[o]},a=e=>{const o=this.identityProvider.getId(e.element).toString();l.focus.has(o)&&h.push(e.element),l.selection.has(o)&&P.push(e.element)};this._refresh(c,r,a),this.setFocus(h),this.setSelection(P),l&&typeof l.scrollTop=="number"&&(this.scrollTop=l.scrollTop)}updateChildren(c=this.input){if(typeof this.input>"u")throw new i.TreeError(this.user,"Tree input not set");let l;this.identityProvider&&(l=h=>{const P=this.identityProvider.getId(h).toString(),r=this.nodesByIdentity.get(P);if(r)return r.collapsed}),this._refresh(c,l)}resort(c=this.input,l=!0){this.model.resort(c===this.input?null:c,l)}refresh(c){if(c===void 0){this.view.rerender();return}this.model.rerender(c)}_refresh(c,l,h){let P;if(this.identityProvider){const r=new Set,a=h;h=e=>{const o=this.identityProvider.getId(e.element).toString();r.add(o),this.nodesByIdentity.set(o,e),a?.(e)},P=e=>{const o=this.identityProvider.getId(e.element).toString();r.has(o)||this.nodesByIdentity.delete(o)}}this.model.setChildren(c===this.input?null:c,this.iterate(c,l).elements,{onDidCreateNode:h,onDidDeleteNode:P})}iterate(c,l){const h=[...this.dataSource.getChildren(c)];return{elements:z.Iterable.map(h,r=>{const{elements:a,size:e}=this.iterate(r,l),o=this.dataSource.hasChildren?this.dataSource.hasChildren(r):void 0,s=e===0?void 0:l&&l(r);return{element:r,children:a,collapsible:o,collapsed:s}}),size:h.length}}createModel(c,l,h){return new k.ObjectTreeModel(c,l,h)}}t.DataTree=b}),define(me[64],pe([1,0,13,9,30,27,25,7,3,2,50,11,6]),function(te,t,y,k,i,z,b,_,c,l,h,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.deserialize=t.serialize=t.BufferWriter=t.BufferReader=void 0;var a;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(a||(a={}));function e(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var o;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(o||(o={}));function s(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(u||(u={}));function n(se){let Q=0;for(let oe=0;;oe+=7){const V=se.read(1);if(Q|=(V.buffer[0]&127)<<oe,!(V.buffer[0]&128))return Q}}const D=L(0);function w(se,Q){if(Q===0){se.write(D);return}let oe=0;for(let K=Q;K!==0;K=K>>>7)oe++;const V=i.VSBuffer.alloc(oe);for(let K=0;Q!==0;K++)V.buffer[K]=Q&127,Q=Q>>>7,Q>0&&(V.buffer[K]|=128);se.write(V)}class S{constructor(Q){this.buffer=Q,this.pos=0}read(Q){const oe=this.buffer.slice(this.pos,this.pos+Q);return this.pos+=oe.byteLength,oe}}t.BufferReader=S;class f{constructor(){this.buffers=[]}get buffer(){return i.VSBuffer.concat(this.buffers)}write(Q){this.buffers.push(Q)}}t.BufferWriter=f;var v;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object",se[se.Int=6]="Int"})(v||(v={}));function L(se){const Q=i.VSBuffer.alloc(1);return Q.writeUInt8(se,0),Q}const I={Undefined:L(v.Undefined),String:L(v.String),Buffer:L(v.Buffer),VSBuffer:L(v.VSBuffer),Array:L(v.Array),Object:L(v.Object),Uint:L(v.Int)},E=typeof Buffer<"u";function g(se,Q){if(typeof Q>"u")se.write(I.Undefined);else if(typeof Q=="string"){const oe=i.VSBuffer.fromString(Q);se.write(I.String),w(se,oe.byteLength),se.write(oe)}else if(E&&Buffer.isBuffer(Q)){const oe=i.VSBuffer.wrap(Q);se.write(I.Buffer),w(se,oe.byteLength),se.write(oe)}else if(Q instanceof i.VSBuffer)se.write(I.VSBuffer),w(se,Q.byteLength),se.write(Q);else if(Array.isArray(Q)){se.write(I.Array),w(se,Q.length);for(const oe of Q)g(se,oe)}else if(typeof Q=="number"&&(Q|0)===Q)se.write(I.Uint),w(se,Q);else{const oe=i.VSBuffer.fromString(JSON.stringify(Q));se.write(I.Object),w(se,oe.byteLength),se.write(oe)}}t.serialize=g;function m(se){switch(se.read(1).readUInt8(0)){case v.Undefined:return;case v.String:return se.read(n(se)).toString();case v.Buffer:return se.read(n(se)).buffer;case v.VSBuffer:return se.read(n(se));case v.Array:{const oe=n(se),V=[];for(let K=0;K<oe;K++)V.push(m(se));return V}case v.Object:return JSON.parse(se.read(n(se)).toString());case v.Int:return n(se)}}t.deserialize=m;class p{constructor(Q,oe,V=null,K=1e3){this.protocol=Q,this.ctx=oe,this.logger=V,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(Q,oe){this.channels.set(Q,oe),setTimeout(()=>this.flushPendingRequests(Q),0)}sendResponse(Q){switch(Q.type){case 200:{const oe=this.send([Q.type]);this.logger?.logOutgoing(oe,0,1,s(Q.type));return}case 201:case 202:case 204:case 203:{const oe=this.send([Q.type,Q.id],Q.data);this.logger?.logOutgoing(oe,Q.id,1,s(Q.type),Q.data);return}}}send(Q,oe=void 0){const V=new f;return g(V,Q),g(V,oe),this.sendBuffer(V.buffer)}sendBuffer(Q){try{return this.protocol.send(Q),Q.byteLength}catch{return 0}}onRawMessage(Q){const oe=new S(Q),V=m(oe),K=m(oe),A=V[0];switch(A){case 100:return this.logger?.logIncoming(Q.byteLength,V[1],1,`${e(A)}: ${V[2]}.${V[3]}`,K),this.onPromise({type:A,id:V[1],channelName:V[2],name:V[3],arg:K});case 102:return this.logger?.logIncoming(Q.byteLength,V[1],1,`${e(A)}: ${V[2]}.${V[3]}`,K),this.onEventListen({type:A,id:V[1],channelName:V[2],name:V[3],arg:K});case 101:return this.logger?.logIncoming(Q.byteLength,V[1],1,`${e(A)}`),this.disposeActiveRequest({type:A,id:V[1]});case 103:return this.logger?.logIncoming(Q.byteLength,V[1],1,`${e(A)}`),this.disposeActiveRequest({type:A,id:V[1]})}}onPromise(Q){const oe=this.channels.get(Q.channelName);if(!oe){this.collectPendingRequest(Q);return}const V=new z.CancellationTokenSource;let K;try{K=oe.call(this.ctx,Q.name,Q.arg,V.token)}catch(N){K=Promise.reject(N)}const A=Q.id;K.then(N=>{this.sendResponse({id:A,data:N,type:201}),this.activeRequests.delete(Q.id)},N=>{N instanceof Error?this.sendResponse({id:A,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:A,data:N,type:203}),this.activeRequests.delete(Q.id)});const W=(0,l.toDisposable)(()=>V.cancel());this.activeRequests.set(Q.id,W)}onEventListen(Q){const oe=this.channels.get(Q.channelName);if(!oe){this.collectPendingRequest(Q);return}const V=Q.id,A=oe.listen(this.ctx,Q.name,Q.arg)(W=>this.sendResponse({id:V,data:W,type:204}));this.activeRequests.set(Q.id,A)}disposeActiveRequest(Q){const oe=this.activeRequests.get(Q.id);oe&&(oe.dispose(),this.activeRequests.delete(Q.id))}collectPendingRequest(Q){let oe=this.pendingRequests.get(Q.channelName);oe||(oe=[],this.pendingRequests.set(Q.channelName,oe));const V=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.sendResponse({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);oe.push({request:Q,timeoutTimer:V})}flushPendingRequests(Q){const oe=this.pendingRequests.get(Q);if(oe){for(const V of oe)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(Q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=p;var O;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(O||(t.RequestInitiator=O={}));class G{constructor(Q,oe=null){this.protocol=Q,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=oe}getChannel(Q){const oe=this;return{call(V,K,A){return oe.isDisposed?Promise.reject(new _.CancellationError):oe.requestPromise(Q,V,K,A)},listen(V,K){return oe.isDisposed?c.Event.None:oe.requestEvent(Q,V,K)}}}requestPromise(Q,oe,V,K=z.CancellationToken.None){const A=this.lastRequestId++,N={id:A,type:100,channelName:Q,name:oe,arg:V};if(K.isCancellationRequested)return Promise.reject(new _.CancellationError);let d;return new Promise(($,Z)=>{if(K.isCancellationRequested)return Z(new _.CancellationError);const T=()=>{const H=x=>{switch(x.type){case 201:this.handlers.delete(A),$(x.data);break;case 202:{this.handlers.delete(A);const M=new Error(x.data.message);M.stack=Array.isArray(x.data.stack)?x.data.stack.join(`
`):x.data.stack,M.name=x.data.name,Z(M);break}case 203:this.handlers.delete(A),Z(x.data);break}};this.handlers.set(A,H),this.sendRequest(N)};let F=null;this.state===u.Idle?T():(F=(0,k.createCancelablePromise)(H=>this.whenInitialized()),F.then(()=>{F=null,T()}));const B=()=>{F?(F.cancel(),F=null):this.sendRequest({id:A,type:101}),Z(new _.CancellationError)},C=K.onCancellationRequested(B);d=(0,l.combinedDisposable)((0,l.toDisposable)(B),C),this.activeRequests.add(d)}).finally(()=>{this.activeRequests.delete(d)})}requestEvent(Q,oe,V){const K=this.lastRequestId++,W={id:K,type:102,channelName:Q,name:oe,arg:V};let N=null;const d=new c.Emitter({onWillAddFirstListener:()=>{N=(0,k.createCancelablePromise)($=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(d),this.sendRequest(W)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(d),this.sendRequest({id:K,type:103}))}}),R=$=>d.fire($.data);return this.handlers.set(K,R),d.event}sendRequest(Q){switch(Q.type){case 100:case 102:{const oe=this.send([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.logger?.logOutgoing(oe,Q.id,0,`${e(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const oe=this.send([Q.type,Q.id]);this.logger?.logOutgoing(oe,Q.id,0,e(Q.type));return}}}send(Q,oe=void 0){const V=new f;return g(V,Q),g(V,oe),this.sendBuffer(V.buffer)}sendBuffer(Q){try{return this.protocol.send(Q),Q.byteLength}catch{return 0}}onBuffer(Q){const oe=new S(Q),V=m(oe),K=m(oe),A=V[0];switch(A){case 200:return this.logger?.logIncoming(Q.byteLength,0,0,s(A)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(Q.byteLength,V[1],0,s(A),K),this.onResponse({type:V[0],id:V[1],data:K})}}onResponse(Q){if(Q.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(Q.id)?.(Q)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelClient=G,qe([b.memoize],G.prototype,"onDidInitializePromise",null);class J{get connections(){const Q=[];return this._connections.forEach(oe=>Q.push(oe)),Q}constructor(Q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,Q(({protocol:oe,onDidClientDisconnect:V})=>{c.Event.once(oe.onMessage)(A=>{const W=new S(A),N=m(W),d=new p(oe,N),R=new G(oe);this.channels.forEach((Z,T)=>d.registerChannel(T,Z));const $={channelServer:d,channelClient:R,ctx:N};this._connections.add($),this._onDidAddConnection.fire($),V(()=>{d.dispose(),R.dispose(),this._connections.delete($),this._onDidRemoveConnection.fire($)})})})}getChannel(Q,oe){const V=this;return{call(K,A,W){let N;if((0,r.isFunction)(oe)){const R=(0,y.getRandomElement)(V.connections.filter(oe));N=R?Promise.resolve(R):c.Event.toPromise(c.Event.filter(V.onDidAddConnection,oe))}else N=oe.routeCall(V,K,A);const d=N.then(R=>R.channelClient.getChannel(Q));return ae(d).call(K,A,W)},listen(K,A){if((0,r.isFunction)(oe))return V.getMulticastEvent(Q,oe,K,A);const W=oe.routeEvent(V,K,A).then(N=>N.channelClient.getChannel(Q));return ae(W).listen(K,A)}}}getMulticastEvent(Q,oe,V,K){const A=this;let W=new l.DisposableStore;const N=new c.Emitter({onWillAddFirstListener:()=>{W=new l.DisposableStore;const d=new c.EventMultiplexer,R=new Map,$=T=>{const B=T.channelClient.getChannel(Q).listen(V,K),C=d.add(B);R.set(T,C)},Z=T=>{const F=R.get(T);F&&(F.dispose(),R.delete(T))};A.connections.filter(oe).forEach($),c.Event.filter(A.onDidAddConnection,oe)($,void 0,W),A.onDidRemoveConnection(Z,void 0,W),d.event(N.fire,N,W),W.add(d)},onDidRemoveLastListener:()=>{W.dispose()}});return N.event}registerChannel(Q,oe){this.channels.set(Q,oe),this._connections.forEach(V=>{V.channelServer.registerChannel(Q,oe)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=J;class ie{constructor(Q,oe,V=null){const K=new f;g(K,oe),Q.send(K.buffer),this.channelClient=new G(Q,V),this.channelServer=new p(Q,oe,V)}getChannel(Q){return this.channelClient.getChannel(Q)}registerChannel(Q,oe){this.channelServer.registerChannel(Q,oe)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=ie;function ae(se){return{call(Q,oe,V){return se.then(K=>K.call(Q,oe,V))},listen(Q,oe){const V=new c.Relay;return se.then(K=>V.input=K.listen(Q,oe)),V.event}}}t.getDelayedChannel=ae;function ge(se){let Q=!1;return{call(oe,V,K){return Q?se.call(oe,V,K):(0,k.timeout)(0).then(()=>Q=!0).then(()=>se.call(oe,V,K))},listen(oe,V){if(Q)return se.listen(oe,V);const K=new c.Relay;return(0,k.timeout)(0).then(()=>Q=!0).then(()=>K.input=se.listen(oe,V)),K.event}}}t.getNextTickChannel=ge;class ue{constructor(Q){this.fn=Q}routeCall(Q){return this.route(Q)}routeEvent(Q){return this.route(Q)}async route(Q){for(const oe of Q.connections)if(await Promise.resolve(this.fn(oe.ctx)))return Promise.resolve(oe);return await c.Event.toPromise(Q.onDidAddConnection),await this.route(Q)}}t.StaticRouter=ue;var de;(function(se){function Q(A,W){const N=A,d=W&&W.disableMarshalling,R=new Map;for(const $ in N)V($)&&R.set($,c.Event.buffer(N[$],!0));return new class{listen($,Z,T){const F=R.get(Z);if(F)return F;if(K(Z)){const B=N[Z];if(typeof B=="function")return B.call(N,T)}throw new Error(`Event not found: ${Z}`)}call($,Z,T){const F=N[Z];if(typeof F=="function"){if(!d&&Array.isArray(T))for(let B=0;B<T.length;B++)T[B]=(0,h.revive)(T[B]);return F.apply(N,T)}throw new Error(`Method not found: ${Z}`)}}}se.fromService=Q;function oe(A,W){const N=W&&W.disableMarshalling;return new Proxy({},{get(d,R){if(typeof R=="string")return W?.properties?.has(R)?W.properties.get(R):K(R)?function($){return A.listen(R,$)}:V(R)?A.listen(R):async function(...$){let Z;W&&!(0,r.isUndefinedOrNull)(W.context)?Z=[W.context,...$]:Z=$;const T=await A.call(R,Z);return N?T:(0,h.revive)(T)};throw new Error(`Property not found: ${String(R)}`)}})}se.toService=oe;function V(A){return A[0]==="o"&&A[1]==="n"&&P.isUpperAsciiLetter(A.charCodeAt(2))}function K(A){return/^onDynamic/.test(A)&&P.isUpperAsciiLetter(A.charCodeAt(9))}})(de||(t.ProxyChannel=de={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Se(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const Q=se.toString();if(Q!=="[object Object]")return Q}return se}function _e(se){return Array.isArray(se)?se.map(Se):Se(se)}function Oe(se,Q,oe,V,K,A,W){W=_e(W);const N=he[K],d=N[V%N.length];let R=[`%c[${se}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(oe).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(A)?(R=R.concat(W),R.push(")")):R.push(W),console.log.apply(console,R)}class re{constructor(Q,oe){this._outgoingPrefix=Q,this._incomingPrefix=oe,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(Q,oe,V,K,A){this._totalOutgoing+=Q,Oe(this._outgoingPrefix,this._totalOutgoing,Q,oe,V,K,A)}logIncoming(Q,oe,V,K,A){this._totalIncoming+=Q,Oe(this._incomingPrefix,this._totalIncoming,Q,oe,V,K,A)}}t.IPCLogger=re}),define(me[29],pe([1,0,5]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=y.globals.vscode.ipcRenderer,t.ipcMessagePort=y.globals.vscode.ipcMessagePort,t.webFrame=y.globals.vscode.webFrame,t.process=y.globals.vscode.process,t.context=y.globals.vscode.context}),define(me[130],pe([1,0,81,29]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let i=0;function z(_,c,l){const h=[],P=i++,r=`vscode:onContextMenu${P}`,a=(e,o,s)=>{h[o].click?.(s)};k.ipcRenderer.once(r,a),k.ipcRenderer.once(y.CONTEXT_MENU_CLOSE_CHANNEL,(e,o)=>{o===P&&(k.ipcRenderer.removeListener(r,a),l?.())}),k.ipcRenderer.send(y.CONTEXT_MENU_CHANNEL,P,_.map(e=>b(e,h)),r,c)}t.popup=z;function b(_,c){const l={id:c.length,label:_.label,type:_.type,accelerator:_.accelerator,checked:_.checked,enabled:typeof _.enabled=="boolean"?_.enabled:!0,visible:typeof _.visible=="boolean"?_.visible:!0};return c.push(_),Array.isArray(_.submenu)&&(l.submenu=_.submenu.map(h=>b(h,c))),l}}),define(me[131],pe([1,0,30,3,64,82,29]),function(te,t,y,k,i,z,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class _ extends i.IPCClient{static createProtocol(){const l=k.Event.fromNodeEventEmitter(b.ipcRenderer,"vscode:message",(h,P)=>y.VSBuffer.wrap(P));return b.ipcRenderer.send("vscode:hello"),new z.Protocol(b.ipcRenderer,l)}constructor(l){const h=_.createProtocol();super(h,l),this.protocol=h}dispose(){this.protocol.disconnect()}}t.Client=_}),define(me[132],pe([12,10]),function(te,t){return te.create("vs/platform/files/common/files",t)}),define(me[133],pe([12,10]),function(te,t){return te.create("vs/platform/theme/common/iconRegistry",t)}),define(me[37],pe([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var y;(function(b){b.serviceIds=new Map,b.DI_TARGET="$di$target",b.DI_DEPENDENCIES="$di$dependencies";function _(c){return c[b.DI_DEPENDENCIES]||[]}b.getServiceDependencies=_})(y||(t._util=y={})),t.IInstantiationService=i("instantiationService");function k(b,_,c){_[y.DI_TARGET]===_?_[y.DI_DEPENDENCIES].push({id:b,index:c}):(_[y.DI_DEPENDENCIES]=[{id:b,index:c}],_[y.DI_TARGET]=_)}function i(b){if(y.serviceIds.has(b))return y.serviceIds.get(b);const _=function(c,l,h){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(_,c,h)};return _.toString=()=>b,y.serviceIds.set(b,_),_}t.createDecorator=i;function z(b){return b}t.refineServiceDecorator=z}),define(me[134],pe([1,0,37]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,y.createDecorator)(t.ID);function k(z){return!!z.hostName&&!!z.errorMessage}t.isRemoteDiagnosticError=k;class i{async getPerformanceInfo(b,_){return{}}async getSystemInfo(b,_){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(b,_){return""}async getWorkspaceFileExtensions(b){return{extensions:[]}}async reportWorkspaceStats(b){}}t.NullDiagnosticsService=i}),define(me[135],pe([1,0,113,22,11,6,15,132,37,5,28]),function(te,t,y,k,i,z,b,_,c,l,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLargeFileConfirmationLimit=t.ByteSize=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,c.createDecorator)("fileService");function P(re){return re.create===!0}t.isFileOpenForWriteOptions=P;var r;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(r||(t.FileType=r={}));var a;(function(re){re[re.Readonly=1]="Readonly"})(a||(t.FilePermission=a={}));var e;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileClone=32768]="FileClone"})(e||(t.FileSystemProviderCapabilities=e={}));function o(re){return!!(re.capabilities&2)}t.hasReadWriteCapability=o;function s(re){return!!(re.capabilities&8)}t.hasFileFolderCopyCapability=s;function u(re){return!!(re.capabilities&32768)}t.hasFileCloneCapability=u;function n(re){return!!(re.capabilities&4)}t.hasOpenReadWriteCloseCapability=n;function D(re){return!!(re.capabilities&16)}t.hasFileReadStreamCapability=D;function w(re){return o(re)?!!(re.capabilities&16384):!1}t.hasFileAtomicReadCapability=w;var S;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(S||(t.FileSystemProviderErrorCode=S={}));class f extends Error{static create(se,Q){const oe=new f(se.toString(),Q);return I(oe,Q),oe}constructor(se,Q){super(se),this.code=Q}}t.FileSystemProviderError=f;function v(re,se){return f.create(re,se)}t.createFileSystemProviderError=v;function L(re){return re||v((0,_.localize)(0,null),S.Unknown)}t.ensureFileSystemProviderError=L;function I(re,se){return re.name=se?`${se} (FileSystemError)`:"FileSystemError",re}t.markAsFileSystemProviderError=I;function E(re){if(!re)return S.Unknown;if(re instanceof f)return re.code;const se=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!se)return S.Unknown;switch(se[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}t.toFileSystemProviderErrorCode=E;function g(re){if(re instanceof ie)return re.fileOperationResult;switch(E(re)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 9;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileTooLarge:return 7;default:return 10}}t.toFileOperationResult=g;var m;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(m||(t.FileOperation=m={}));class p{constructor(se,Q,oe){this.resource=se,this.operation=Q,this.target=oe}isOperation(se){return this.operation===se}}t.FileOperationEvent=p;var O;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(O||(t.FileChangeType=O={}));class G{constructor(se,Q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const oe=new Map;for(const V of se){const K=oe.get(V.type);switch(K?K.push([V.resource,V]):oe.set(V.type,[[V.resource,V]]),V.type){case 1:this.rawAdded.push(V.resource);break;case 0:this.rawUpdated.push(V.resource);break;case 2:this.rawDeleted.push(V.resource);break}}for(const[V,K]of oe)switch(V){case 1:this.added=y.TernarySearchTree.forUris(()=>Q),this.added.fill(K);break;case 0:this.updated=y.TernarySearchTree.forUris(()=>Q),this.updated.fill(K);break;case 2:this.deleted=y.TernarySearchTree.forUris(()=>Q),this.deleted.fill(K);break}}contains(se,...Q){return this.doContains(se,{includeChildren:!1},...Q)}affects(se,...Q){return this.doContains(se,{includeChildren:!0},...Q)}doContains(se,Q,...oe){if(!se)return!1;const V=oe.length>0;return!!((!V||oe.includes(1))&&(this.added?.get(se)||Q.includeChildren&&this.added?.findSuperstr(se))||(!V||oe.includes(0))&&(this.updated?.get(se)||Q.includeChildren&&this.updated?.findSuperstr(se))||(!V||oe.includes(2))&&(this.deleted?.findSubstr(se)||Q.includeChildren&&this.deleted?.findSuperstr(se)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=G;function J(re,se,Q){return!re||!se||re===se||se.length>re.length?!1:(se.charAt(se.length-1)!==k.sep&&(se+=k.sep),Q?(0,i.startsWithIgnoreCase)(re,se):re.indexOf(se)===0)}t.isParent=J;class ie extends Error{constructor(se,Q,oe){super(se),this.fileOperationResult=Q,this.options=oe}}t.FileOperationError=ie;class ae extends ie{constructor(se,Q,oe,V){super(se,Q,V),this.fileOperationResult=Q,this.size=oe}}t.TooLargeFileOperationError=ae;class ge extends ie{constructor(se,Q,oe){super(se,2,oe),this.stat=Q}}t.NotModifiedSinceFileOperationError=ge;var ue;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(t.FileOperationResult=ue={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var de;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(de||(t.FileKind=de={})),t.ETAG_DISABLED="";function he(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}t.etag=he;async function Se(re,se){if(!se.hasProvider(b.URI.from({scheme:re.scheme})))return new Promise(Q=>{const oe=se.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===re.scheme&&V.added&&(oe.dispose(),Q())})})}t.whenProviderRegistered=Se;class _e{static formatSize(se){return(0,z.isNumber)(se)||(se=0),se<_e.KB?(0,_.localize)(1,null,se.toFixed(0)):se<_e.MB?(0,_.localize)(2,null,(se/_e.KB).toFixed(2)):se<_e.GB?(0,_.localize)(3,null,(se/_e.MB).toFixed(2)):se<_e.TB?(0,_.localize)(4,null,(se/_e.GB).toFixed(2)):(0,_.localize)(5,null,(se/_e.TB).toFixed(2))}}t.ByteSize=_e,_e.KB=1024,_e.MB=_e.KB*_e.KB,_e.GB=_e.MB*_e.KB,_e.TB=_e.GB*_e.KB;function Oe(re){const se=typeof re=="string"||re?.scheme===h.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===h.Schemas.file?1024*_e.MB:se?10*_e.MB:l.isWeb?50*_e.MB:1024*_e.MB}t.getLargeFileConfirmationLimit=Oe}),define(me[136],pe([1,0,37]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,y.createDecorator)("mainProcessService");class k{constructor(z,b){this.server=z,this.router=b}getChannel(z){return this.server.getChannel(z,this.router)}registerChannel(z,b){this.server.registerChannel(z,b)}}t.MainProcessService=k}),define(me[137],pe([1,0,2,131]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class i extends y.Disposable{constructor(b){super(),this.mainProcessConnection=this._register(new k.Client(`window:${b}`))}getChannel(b){return this.mainProcessConnection.getChannel(b)}registerChannel(b,_){this.mainProcessConnection.registerChannel(b,_)}}t.ElectronIPCMainProcessService=i});var hi=this&&this.__param||function(te,t){return function(y,k){t(y,k,te)}};define(me[138],pe([1,0,64,136]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let i=t.NativeHostService=class{constructor(b,_){return this.windowId=b,y.ProxyChannel.toService(_.getChannel("nativeHost"),{context:b,properties:(()=>{const c=new Map;return c.set("windowId",b),c})()})}};t.NativeHostService=i=qe([hi(1,k.IMainProcessService)],i)}),define(me[65],pe([1,0,72,6]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class i{constructor(){this.data=new Map}add(b,_){y.ok(k.isString(b)),y.ok(k.isObject(_)),y.ok(!this.data.has(b),"There is already an extension with this id"),this.data.set(b,_)}knows(b){return this.data.has(b)}as(b){return this.data.get(b)||null}}t.Registry=new i}),define(me[139],pe([1,0,3,65]),function(te,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function i(_){return _.length>0&&_.charAt(_.length-1)==="#"?_.substring(0,_.length-1):_}class z{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,l){this.schemasById[i(c)]=l,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const b=new z;k.Registry.add(t.Extensions.JSONContribution,b)}),define(me[140],pe([1,0,9,16,17,3,6,15,133,139,65]),function(te,t,y,k,i,z,b,_,c,l,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var P;(function(w){function S(f,v){let L=f.defaults;for(;i.ThemeIcon.isThemeIcon(L);){const I=e.getIcon(L.id);if(!I)return;L=I.defaults}return L}w.getDefinition=S})(P||(t.IconContribution=P={}));var r;(function(w){function S(v){return{weight:v.weight,style:v.style,src:v.src.map(L=>({format:L.format,location:L.location.toString()}))}}w.toJSONObject=S;function f(v){const L=I=>(0,b.isString)(I)?I:void 0;if(v&&Array.isArray(v.src)&&v.src.every(I=>(0,b.isString)(I.format)&&(0,b.isString)(I.location)))return{weight:L(v.weight),style:L(v.style),src:v.src.map(I=>({format:I.format,location:_.URI.parse(I.location)}))}}w.fromJSONObject=f})(r||(t.IconFontDefinition=r={}));class a{constructor(){this._onDidChange=new z.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(S,f,v,L){const I=this.iconsById[S];if(I){if(v&&!I.description){I.description=v,this.iconSchema.properties[S].markdownDescription=`${v} $(${S})`;const m=this.iconReferenceSchema.enum.indexOf(S);m!==-1&&(this.iconReferenceSchema.enumDescriptions[m]=v),this._onDidChange.fire()}return I}const E={id:S,description:v,defaults:f,deprecationMessage:L};this.iconsById[S]=E;const g={$ref:"#/definitions/icons"};return L&&(g.deprecationMessage=L),v&&(g.markdownDescription=`${v}: $(${S})`),this.iconSchema.properties[S]=g,this.iconReferenceSchema.enum.push(S),this.iconReferenceSchema.enumDescriptions.push(v||""),this._onDidChange.fire(),{id:S}}deregisterIcon(S){delete this.iconsById[S],delete this.iconSchema.properties[S];const f=this.iconReferenceSchema.enum.indexOf(S);f!==-1&&(this.iconReferenceSchema.enum.splice(f,1),this.iconReferenceSchema.enumDescriptions.splice(f,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(S=>this.iconsById[S])}getIcon(S){return this.iconsById[S]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(S,f){const v=this.iconFontsById[S];return v||(this.iconFontsById[S]=f,this._onDidChange.fire(),f)}deregisterIconFont(S){delete this.iconFontsById[S]}getIconFont(S){return this.iconFontsById[S]}toString(){const S=(I,E)=>I.id.localeCompare(E.id),f=I=>{for(;i.ThemeIcon.isThemeIcon(I.defaults);)I=this.iconsById[I.defaults.id];return`codicon codicon-${I?I.id:""}`},v=[];v.push("| preview     | identifier                        | default codicon ID                | description"),v.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const L=Object.keys(this.iconsById).map(I=>this.iconsById[I]);for(const I of L.filter(E=>!!E.description).sort(S))v.push(`|<i class="${f(I)}"></i>|${I.id}|${i.ThemeIcon.isThemeIcon(I.defaults)?I.defaults.id:I.id}|${I.description||""}|`);v.push("| preview     | identifier                        "),v.push("| ----------- | --------------------------------- |");for(const I of L.filter(E=>!i.ThemeIcon.isThemeIcon(E.defaults)).sort(S))v.push(`|<i class="${f(I)}"></i>|${I.id}|`);return v.join(`
`)}}const e=new a;h.Registry.add(t.Extensions.IconContribution,e);function o(w,S,f,v){return e.registerIcon(w,S,f,v)}t.registerIcon=o;function s(){return e}t.getIconRegistry=s;function u(){const w=(0,k.getCodiconFontCharacters)();for(const S in w){const f="\\"+w[S].toString(16);e.registerIcon(S,{fontCharacter:f})}}u(),t.iconsSchemaId="vscode://schemas/icons";const n=h.Registry.as(l.Extensions.JSONContribution);n.registerSchema(t.iconsSchemaId,e.getIconSchema());const D=new y.RunOnceScheduler(()=>n.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{D.isScheduled()||D.schedule()}),t.widgetClose=o("widget-close",k.Codicon.close,(0,c.localize)(2,null)),t.gotoPreviousLocation=o("goto-previous-location",k.Codicon.arrowUp,(0,c.localize)(3,null)),t.gotoNextLocation=o("goto-next-location",k.Codicon.arrowDown,(0,c.localize)(4,null)),t.syncing=i.ThemeIcon.modify(k.Codicon.sync,"spin"),t.spinningLoading=i.ThemeIcon.modify(k.Codicon.loading,"spin")}),define(me[141],pe([1,0,4,3,17,140]),function(te,t,y,k,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function b(c){const l=new k.Emitter,h=(0,z.getIconRegistry)();return h.onDidChange(()=>l.fire()),c?.onDidProductIconThemeChange(()=>l.fire()),{onDidChange:l.event,getCSS(){const P=c?c.getProductIconTheme():new _,r={},a=o=>{const s=P.getIcon(o);if(!s)return;const u=s.font;return u?(r[u.id]=u.definition,`.codicon-${o.id}:before { content: '${s.fontCharacter}'; font-family: ${(0,y.asCSSPropertyValue)(u.id)}; }`):`.codicon-${o.id}:before { content: '${s.fontCharacter}'; }`},e=[];for(const o of h.getIcons()){const s=a(o);s&&e.push(s)}for(const o in r){const s=r[o],u=s.weight?`font-weight: ${s.weight};`:"",n=s.style?`font-style: ${s.style};`:"",D=s.src.map(w=>`${(0,y.asCSSUrl)(w.location)} format('${w.format}')`).join(", ");e.push(`@font-face { src: ${D}; font-family: ${(0,y.asCSSPropertyValue)(o)};${u}${n} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=b;class _{getIcon(l){const h=(0,z.getIconRegistry)();let P=l.defaults;for(;i.ThemeIcon.isThemeIcon(P);){const r=h.getIcon(P.id);if(!r)return;P=r.defaults}return P}}t.UnthemedProductIconTheme=_}),define(me[142],pe([1,0,5]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function k(h){return!!h.workspaceUri}t.isWorkspaceToOpen=k;function i(h){return!!h.folderUri}t.isFolderToOpen=i;function z(h){return!!h.fileUri}t.isFileToOpen=z;function b(h){const P=_(h),r=h.getValue("window.menuBarVisibility");return r==="default"||P==="native"&&r==="compact"||y.isMacintosh&&y.isNative?"classic":r}t.getMenuBarVisibility=b;function _(h){if(y.isWeb)return"custom";const P=h.getValue("window");if(P){if(y.isMacintosh&&P.nativeTabs===!0||y.isMacintosh&&P.nativeFullScreen===!1)return"native";const e=P.titleBarStyle;if(e==="native"||e==="custom")return e}return y.isLinux?"native":"custom"}t.getTitleBarStyle=_;function c(h){if(!y.isWindows||y.isWeb||_(h)==="native")return!1;const P=h.getValue("window.experimental.windowControlsOverlay.enabled");return typeof P=="boolean"?P:!0}t.useWindowControlsOverlay=c;function l(h=0){return Math.pow(1.2,h)}t.zoomLevelToZoomFactor=l}),define(me[143],pe([1,0,18,29,142]),function(te,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function z(c){k.webFrame.setZoomLevel(c),(0,y.setZoomFactor)((0,i.zoomLevelToZoomFactor)(c)),(0,y.setZoomLevel)(c,!1)}t.applyZoom=z;function b(){z((0,y.getZoomLevel)()+1)}t.zoomIn=b;function _(){z((0,y.getZoomLevel)()-1)}t.zoomOut=_}),define(me[144],pe([1,0,10,4,129,9,130,29,134,135,137,138,141,143,14,95,86]),function(te,t,y,k,i,z,b,_,c,l,h,P,r,a,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const o=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,s=/\s--inspect-port=(?<port>\d+)/;class u{getHeight(O){return 22}getTemplateId(O){return I(O)?"process":v(O)?"machine":(0,c.isRemoteDiagnosticError)(O)?"error":L(O)?"header":""}}class n{hasChildren(O){return(0,c.isRemoteDiagnosticError)(O)?!1:I(O)?!!O.children?.length:!0}getChildren(O){return I(O)?O.children?O.children:[]:(0,c.isRemoteDiagnosticError)(O)?[]:L(O)?O.processRoots.length>1?O.processRoots:[O.processRoots[0].rootProcess]:v(O)?[O.rootProcess]:[O.processes]}}class D{constructor(){this.templateId="header"}renderTemplate(O){const G=(0,k.append)(O,(0,k.$)(".row")),J=(0,k.append)(G,(0,k.$)(".nameLabel")),ie=(0,k.append)(G,(0,k.$)(".cpu")),ae=(0,k.append)(G,(0,k.$)(".memory")),ge=(0,k.append)(G,(0,k.$)(".pid"));return{name:J,CPU:ie,memory:ae,PID:ge}}renderElement(O,G,J,ie){J.name.textContent=(0,y.localize)(0,null),J.CPU.textContent=(0,y.localize)(1,null),J.PID.textContent=(0,y.localize)(2,null),J.memory.textContent=(0,y.localize)(3,null)}disposeTemplate(O){}}class w{constructor(){this.templateId="machine"}renderTemplate(O){const G=Object.create(null),J=(0,k.append)(O,(0,k.$)(".row"));return G.name=(0,k.append)(J,(0,k.$)(".nameLabel")),G}renderElement(O,G,J,ie){J.name.textContent=O.element.name}disposeTemplate(O){}}class S{constructor(){this.templateId="error"}renderTemplate(O){const G=Object.create(null),J=(0,k.append)(O,(0,k.$)(".row"));return G.name=(0,k.append)(J,(0,k.$)(".nameLabel")),G}renderElement(O,G,J,ie){J.name.textContent=O.element.errorMessage}disposeTemplate(O){}}class f{constructor(O,G,J){this.platform=O,this.totalMem=G,this.mapPidToName=J,this.templateId="process"}renderTemplate(O){const G=(0,k.append)(O,(0,k.$)(".row")),J=(0,k.append)(G,(0,k.$)(".nameLabel")),ie=(0,k.append)(G,(0,k.$)(".cpu")),ae=(0,k.append)(G,(0,k.$)(".memory")),ge=(0,k.append)(G,(0,k.$)(".pid"));return{name:J,CPU:ie,PID:ge,memory:ae}}renderElement(O,G,J,ie){const{element:ae}=O,ge=ae.pid.toFixed(0);let ue=ae.name;this.mapPidToName.has(ae.pid)&&(ue=this.mapPidToName.get(ae.pid)),J.name.textContent=ue,J.name.title=ae.cmd,J.CPU.textContent=ae.load.toFixed(0),J.PID.textContent=ge,J.PID.parentElement.id=`pid-${ge}`;const de=this.platform==="win32"?ae.mem:this.totalMem*(ae.mem/100);J.memory.textContent=(de/l.ByteSize.MB).toFixed(0)}disposeTemplate(O){}}function v(p){return!!p.name&&!!p.rootProcess}function L(p){return!!p.processRoots}function I(p){return!!p.pid}class E{constructor(O,G){this.data=G,this.mapPidToName=new Map;const J=new h.ElectronIPCMainProcessService(O);this.nativeHostService=new P.NativeHostService(O,J),this.applyStyles(G.styles),this.setEventHandlers(G),_.ipcRenderer.on("vscode:pidToNameResponse",(ie,ae)=>{this.mapPidToName=new Map;for(const[ge,ue]of ae)this.mapPidToName.set(ge,ue)}),_.ipcRenderer.on("vscode:listProcessesResponse",async(ie,ae)=>{ae.forEach((ge,ue)=>{I(ge.rootProcess)&&(ge.rootProcess.name=ue===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:ae}}),this.tree.layout(window.innerHeight,window.innerWidth)):await this.createProcessTree(ae),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),_.ipcRenderer.send("vscode:pidToNameRequest"),_.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(O){document.onkeydown=G=>{const J=O.platform==="darwin"?G.metaKey:G.ctrlKey;J&&G.keyCode===87&&(G.stopPropagation(),G.preventDefault(),_.ipcRenderer.send("vscode:closeProcessExplorer")),J&&G.keyCode===187&&(0,a.zoomIn)(),J&&G.keyCode===189&&(0,a.zoomOut)()}}async createProcessTree(O){const G=document.getElementById("process-list");if(!G)return;const{totalmem:J}=await this.nativeHostService.getOSStatistics(),ie=[new f(this.data.platform,J,this.mapPidToName),new D,new w,new S];this.tree=new i.DataTree("processExplorer",G,new u,ie,new n,{identityProvider:{getId:ae=>I(ae)?ae.pid.toString():(0,c.isRemoteDiagnosticError)(ae)?ae.hostName:L(ae)?"processes":v(ae)?ae.name:"header"}}),this.tree.setInput({processes:{processRoots:O}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onKeyDown(ae=>{const ge=new e.StandardKeyboardEvent(ae);if(ge.keyCode===35&&ge.altKey){const ue=this.getSelectedPids();Promise.all(ue.map(de=>this.nativeHostService.killProcess(de,"SIGTERM"))).then(()=>this.tree?.refresh())}}),this.tree.onContextMenu(ae=>{I(ae.element)&&this.showContextMenu(ae.element,!0)}),G.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{G.style.height=`${window.innerHeight}px`,this.tree?.layout(window.innerHeight,window.innerWidth)})}isDebuggable(O){const G=o.exec(O);return G&&G.groups.port!=="0"||O.indexOf("node ")>=0||O.indexOf("node.exe")>=0}attachTo(O){const G={type:"node",request:"attach",name:`process ${O.pid}`};let J=o.exec(O.cmd);J?G.port=Number(J.groups.port):G.processId=String(O.pid),J=s.exec(O.cmd),J&&(G.port=Number(J.groups.port)),_.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[G]})}applyStyles(O){const G=(0,k.createStyleSheet)(),J=[];O.listFocusBackground&&(J.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${O.listFocusBackground}; }`),J.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${O.listFocusBackground}; }`)),O.listFocusForeground&&J.push(`.monaco-list:focus .monaco-list-row.focused { color: ${O.listFocusForeground}; }`),O.listActiveSelectionBackground&&(J.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${O.listActiveSelectionBackground}; }`),J.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${O.listActiveSelectionBackground}; }`)),O.listActiveSelectionForeground&&J.push(`.monaco-list:focus .monaco-list-row.selected { color: ${O.listActiveSelectionForeground}; }`),O.listHoverBackground&&J.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${O.listHoverBackground}; }`),O.listHoverForeground&&J.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${O.listHoverForeground}; }`),O.listFocusOutline&&J.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${O.listFocusOutline}; outline-offset: -1px; }`),O.listHoverOutline&&J.push(`.monaco-list-row:hover { outline: 1px dashed ${O.listHoverOutline}; outline-offset: -1px; }`),O.scrollbarShadowColor&&J.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${O.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),O.scrollbarSliderBackgroundColor&&J.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${O.scrollbarSliderBackgroundColor};
				}
			`),O.scrollbarSliderHoverBackgroundColor&&J.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${O.scrollbarSliderHoverBackgroundColor};
				}
			`),O.scrollbarSliderActiveBackgroundColor&&J.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${O.scrollbarSliderActiveBackgroundColor};
				}
			`),G.textContent=J.join(`
`),O.color&&(document.body.style.color=O.color)}showContextMenu(O,G){const J=[],ie=Number(O.pid);G&&(J.push({accelerator:"Alt+E",label:(0,y.localize)(4,null),click:()=>{this.nativeHostService.killProcess(ie,"SIGTERM")}}),J.push({label:(0,y.localize)(5,null),click:()=>{this.nativeHostService.killProcess(ie,"SIGKILL")}}),J.push({type:"separator"})),J.push({label:(0,y.localize)(6,null),click:()=>{const ae=this.getSelectedPids();ae?.includes(ie)||(ae.length=0,ae.push(ie));const ge=ae?.map(ue=>document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(ge){const ue=ge.map(de=>de.innerText).filter(de=>!!de);this.nativeHostService.writeClipboardText(ue.join(`
`))}}}),J.push({label:(0,y.localize)(7,null),click:()=>{const ae=document.getElementById("process-list");ae&&this.nativeHostService.writeClipboardText(ae.innerText)}}),O&&G&&this.isDebuggable(O.cmd)&&(J.push({type:"separator"}),J.push({label:(0,y.localize)(8,null),click:()=>{this.attachTo(O)}})),(0,b.popup)(J)}requestProcessList(O){setTimeout(()=>{const G=Date.now(),J=O+G-this.lastRequestTime;this.lastRequestTime=G,J>1e3?(_.ipcRenderer.send("vscode:pidToNameRequest"),_.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(J)},200)}getSelectedPids(){return this.tree?.getSelection()?.map(O=>{if(!(!O||!("pid"in O)))return O.pid}).filter(O=>!!O)}}function g(){const p=(0,k.createStyleSheet)();p.id="codiconStyles";const O=(0,r.getIconsStyleSheet)(void 0);function G(){p.textContent=O.getCSS()}const J=new z.RunOnceScheduler(G,0);O.onDidChange(()=>J.schedule()),J.schedule()}function m(p){const O=p.data.platform==="win32"?"windows":p.data.platform==="linux"?"linux":"mac";document.body.classList.add(O),g(),(0,a.applyZoom)(p.data.zoomLevel),new E(p.windowId,p.data)}t.startup=m})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e06ea6147733c975d26c3d3552462681e05cb147/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
