/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","vs/base/common/errorMessage","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","os","vs/base/common/process","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/platform/environment/node/userDataPath","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ne=function(q){for(var e=[],A=0,T=q.length;A<T;A++)e[A]=ie[q[A]];return e};define(ie[50],ne([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function A(O){return(I,h,c)=>{let b=null,y=null;if(typeof c.value=="function"?(b="value",y=c.value):typeof c.get=="function"&&(b="get",y=c.get),!y)throw new Error("not supported");c[b]=O(y,h)}}function T(O,I,h){let c=null,b=null;if(typeof h.value=="function"?(c="value",b=h.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",b=h.get),!b)throw new Error("not supported");const y=`$memoize$${I}`;h[c]=function(...m){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,m)}),this[y]}}e.memoize=T;function C(O,I,h){return A((c,b)=>{const y=`$debounce$${b}`,m=`$debounce$result$${b}`;return function(...v){this[m]||(this[m]=h?h():void 0),clearTimeout(this[y]),I&&(this[m]=I(this[m],...v),v=[this[m]]),this[y]=setTimeout(()=>{c.apply(this,v),this[m]=h?h():void 0},O)}})}e.debounce=C;function N(O,I,h){return A((c,b)=>{const y=`$throttle$timer$${b}`,m=`$throttle$result$${b}`,v=`$throttle$lastRun$${b}`,L=`$throttle$pending$${b}`;return function(...D){if(this[m]||(this[m]=h?h():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...D)),this[L])return;const u=this[v]+O;u<=Date.now()?(this[v]=Date.now(),c.apply(this,[this[m]]),this[m]=h?h():void 0):(this[L]=!0,this[y]=setTimeout(()=>{this[L]=!1,this[v]=Date.now(),c.apply(this,[this[m]]),this[m]=h?h():void 0},u-Date.now()))}})}e.throttle=N}),define(ie[70],ne([0,1,9]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function T(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=T;function C(h,c="Unreachable"){throw new Error(c)}e.assertNever=C;function N(h){if(!h)throw new A.BugIndicatingError("Assertion Failed")}e.assert=N;function O(h){if(!h()){debugger;h(),(0,A.onUnexpectedError)(new A.BugIndicatingError("Assertion Failed"))}}e.assertFn=O;function I(h,c){let b=0;for(;b<h.length-1;){const y=h[b],m=h[b+1];if(!c(y,m))return!1;b++}return!0}e.checkAdjacentItems=I}),define(ie[51],ne([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var A;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(A||(e.ScanError=A={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function O(t,o=!1){let n=0;const i=t.length;let r="",a=0,l=16,d=0;function E(re){let fe=0,ce=0;for(;fe<re;){const se=t.charCodeAt(n);if(se>=48&&se<=57)ce=ce*16+se-48;else if(se>=65&&se<=70)ce=ce*16+se-65+10;else if(se>=97&&se<=102)ce=ce*16+se-97+10;else break;n++,fe++}return fe<re&&(ce=-1),ce}function k(re){n=re,r="",a=0,l=16,d=0}function F(){const re=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&c(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&c(t.charCodeAt(n)))for(n++;n<t.length&&c(t.charCodeAt(n));)n++;else return d=3,t.substring(re,n);let fe=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&c(t.charCodeAt(n))){for(n++;n<t.length&&c(t.charCodeAt(n));)n++;fe=n}else d=3;return t.substring(re,fe)}function Y(){let re="",fe=n;for(;;){if(n>=i){re+=t.substring(fe,n),d=2;break}const ce=t.charCodeAt(n);if(ce===34){re+=t.substring(fe,n),n++;break}if(ce===92){if(re+=t.substring(fe,n),n++,n>=i){d=2;break}switch(t.charCodeAt(n++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const j=E(4);j>=0?re+=String.fromCharCode(j):d=4;break}default:d=5}fe=n;continue}if(ce>=0&&ce<=31)if(h(ce)){re+=t.substring(fe,n),d=2;break}else d=6;n++}return re}function X(){if(r="",d=0,a=n,n>=i)return a=i,l=17;let re=t.charCodeAt(n);if(I(re)){do n++,r+=String.fromCharCode(re),re=t.charCodeAt(n);while(I(re));return l=15}if(h(re))return n++,r+=String.fromCharCode(re),re===13&&t.charCodeAt(n)===10&&(n++,r+=`
`),l=14;switch(re){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,r=Y(),l=10;case 47:{const fe=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!h(t.charCodeAt(n));)n++;return r=t.substring(fe,n),l=12}if(t.charCodeAt(n+1)===42){n+=2;const ce=i-1;let se=!1;for(;n<ce;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,se=!0;break}n++}return se||(n++,d=1),r=t.substring(fe,n),l=13}return r+=String.fromCharCode(re),n++,l=16}case 45:if(r+=String.fromCharCode(re),n++,n===i||!c(t.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),l=11;default:for(;n<i&&ee(re);)n++,re=t.charCodeAt(n);if(a!==n){switch(r=t.substring(a,n),r){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return r+=String.fromCharCode(re),n++,l=16}}function ee(re){if(I(re)||h(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let re;do re=X();while(re>=12&&re<=15);return re}return{setPosition:k,getPosition:()=>n,scan:o?le:X,getToken:()=>l,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>d}}e.createScanner=O;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function y(t,o){const n=[],i=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function d(E,k,F,Y){a.value=E,a.offset=k,a.length=F,a.type=Y,a.colonOffset=void 0,r=a}try{S(t,{onObjectBegin:(E,k)=>{if(o<=E)throw i;r=void 0,l=o>E,n.push("")},onObjectProperty:(E,k,F)=>{if(o<k||(d(E,k,F,"property"),n[n.length-1]=E,o<=k+F))throw i},onObjectEnd:(E,k)=>{if(o<=E)throw i;r=void 0,n.pop()},onArrayBegin:(E,k)=>{if(o<=E)throw i;r=void 0,n.push(0)},onArrayEnd:(E,k)=>{if(o<=E)throw i;r=void 0,n.pop()},onLiteralValue:(E,k,F)=>{if(o<k||(d(E,k,F,w(E)),o<=k+F))throw i},onSeparator:(E,k,F)=>{if(o<=k)throw i;if(E===":"&&r&&r.type==="property")r.colonOffset=k,l=!1,r=void 0;else if(E===","){const Y=n[n.length-1];typeof Y=="number"?n[n.length-1]=Y+1:(l=!0,n[n.length-1]=""),r=void 0}}})}catch(E){if(E!==i)throw E}return{path:n,previousNode:r,isAtPropertyKey:l,matches:E=>{let k=0;for(let F=0;k<E.length&&F<n.length;F++)if(E[k]===n[F]||E[k]==="*")k++;else if(E[k]!=="**")return!1;return k===E.length}}}e.getLocation=y;function m(t,o=[],n=N.DEFAULT){let i=null,r=[];const a=[];function l(E){Array.isArray(r)?r.push(E):i!==null&&(r[i]=E)}return S(t,{onObjectBegin:()=>{const E={};l(E),a.push(r),r=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const E=[];l(E),a.push(r),r=E,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:l,onError:(E,k,F)=>{o.push({error:E,offset:k,length:F})}},n),r[0]}e.parse=m;function v(t,o=[],n=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(E){i.type==="property"&&(i.length=E-i.offset,i=i.parent)}function a(E){return i.children.push(E),E}S(t,{onObjectBegin:E=>{i=a({type:"object",offset:E,length:-1,parent:i,children:[]})},onObjectProperty:(E,k,F)=>{i=a({type:"property",offset:k,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:E,offset:k,length:F,parent:i})},onObjectEnd:(E,k)=>{i.length=E+k-i.offset,i=i.parent,r(E+k)},onArrayBegin:(E,k)=>{i=a({type:"array",offset:E,length:-1,parent:i,children:[]})},onArrayEnd:(E,k)=>{i.length=E+k-i.offset,i=i.parent,r(E+k)},onLiteralValue:(E,k,F)=>{a({type:w(E),offset:k,length:F,parent:i,value:E}),r(k+F)},onSeparator:(E,k,F)=>{i.type==="property"&&(E===":"?i.colonOffset=k:E===","&&r(k))},onError:(E,k,F)=>{o.push({error:E,offset:k,length:F})}},n);const d=i.children[0];return d&&delete d.parent,d}e.parseTree=v;function L(t,o){if(!t)return;let n=t;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===i){n=a.children[1],r=!0;break}if(!r)return}else{const r=i;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=L;function D(t){if(!t.parent||!t.parent.children)return[];const o=D(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}e.getNodePath=D;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const o=Object.create(null);for(const n of t.children){const i=n.children[1];i&&(o[n.children[0].value]=u(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function g(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}e.contains=g;function f(t,o,n=!1){if(g(t,o,n)){const i=t.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=o;r++){const a=f(i[r],o,n);if(a)return a}return t}}e.findNodeAtOffset=f;function S(t,o,n=N.DEFAULT){const i=O(t,!1);function r(H){return H?()=>H(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(H){return H?x=>H(x,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=r(o.onObjectBegin),d=a(o.onObjectProperty),E=r(o.onObjectEnd),k=r(o.onArrayBegin),F=r(o.onArrayEnd),Y=a(o.onLiteralValue),X=a(o.onSeparator),ee=r(o.onComment),le=a(o.onError),re=n&&n.disallowComments,fe=n&&n.allowTrailingComma;function ce(){for(;;){const H=i.scan();switch(i.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:re||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(H){case 12:case 13:re?se(10):ee();break;case 16:se(1);break;case 15:case 14:break;default:return H}}}function se(H,x=[],U=[]){if(le(H),x.length+U.length>0){let R=i.getToken();for(;R!==17;){if(x.indexOf(R)!==-1){ce();break}else if(U.indexOf(R)!==-1)break;R=ce()}}}function j(H){const x=i.getTokenValue();return H?Y(x):d(x),ce(),!0}function B(){switch(i.getToken()){case 11:{let H=0;try{H=JSON.parse(i.getTokenValue()),typeof H!="number"&&(se(2),H=0)}catch{se(2)}Y(H);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return ce(),!0}function V(){return i.getToken()!==10?(se(3,[],[2,5]),!1):(j(!1),i.getToken()===6?(X(":"),ce(),G()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function M(){l(),ce();let H=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(H||se(4,[],[]),X(","),ce(),i.getToken()===2&&fe)break}else H&&se(6,[],[]);V()||se(4,[],[2,5]),H=!0}return E(),i.getToken()!==2?se(7,[2],[]):ce(),!0}function $(){k(),ce();let H=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(H||se(4,[],[]),X(","),ce(),i.getToken()===4&&fe)break}else H&&se(6,[],[]);G()||se(4,[],[4,5]),H=!0}return F(),i.getToken()!==4?se(8,[4],[]):ce(),!0}function G(){switch(i.getToken()){case 3:return $();case 1:return M();case 10:return j(!0);default:return B()}}return ce(),i.getToken()===17?n.allowEmptyContent?!0:(se(4,[],[]),!1):G()?(i.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=S;function p(t,o){const n=O(t),i=[];let r,a=0,l;do switch(l=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:a!==l&&i.push(t.substring(a,l)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),a=n.getPosition();break}while(r!==17);return i.join("")}e.stripComments=p;function w(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(ie[71],ne([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function A(I,h,c){return Math.min(Math.max(I,h),c)}e.clamp=A;function T(I,h){return(h+I%h)%h}e.rot=T;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class N{constructor(){this._n=1,this._val=0}update(h){return this._val=this._val+(h-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=N;class O{constructor(h){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(h),this._values.fill(0,0,h)}update(h){const c=this._values[this._index];return this._values[this._index]=h,this._index=(this._index+1)%this._values.length,this._sum-=c,this._sum+=h,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=O}),function(){function q(C){const N=[];typeof C=="number"&&N.push("code/timeOrigin",C);function O(h){N.push(h,Date.now())}function I(){const h=[];for(let c=0;c<N.length;c+=2)h.push({name:N[c],startTime:N[c+1]});return h}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const O of performance.getEntriesByType("mark"))N.push({name:O.name,startTime:Math.round(C+O.startTime)});return N}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function A(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return A(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=A(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=A(T))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var A=e();for(var T in A)(typeof exports=="object"?exports:q)[T]=A[T]}}(typeof self<"u"?self:this,function(){return function(q){var e={};function A(T){if(e[T])return e[T].exports;var C=e[T]={i:T,l:!1,exports:{}};return q[T].call(C.exports,C,C.exports,A),C.l=!0,C.exports}return A.m=q,A.c=e,A.d=function(T,C,N){A.o(T,C)||Object.defineProperty(T,C,{enumerable:!0,get:N})},A.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},A.t=function(T,C){if(1&C&&(T=A(T)),8&C||4&C&&typeof T=="object"&&T&&T.__esModule)return T;var N=Object.create(null);if(A.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:T}),2&C&&typeof T!="string")for(var O in T)A.d(N,O,function(I){return T[I]}.bind(null,O));return N},A.n=function(T){var C=T&&T.__esModule?function(){return T.default}:function(){return T};return A.d(C,"a",C),C},A.o=function(T,C){return Object.prototype.hasOwnProperty.call(T,C)},A.p="",A(A.s=0)}([function(q,e,A){(function(T){var C;e=q.exports=U,C=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],h=e.src=[],c=0,b=c++;h[b]="0|[1-9]\\d*";var y=c++;h[y]="[0-9]+";var m=c++;h[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=c++;h[v]="("+h[b]+")\\.("+h[b]+")\\.("+h[b]+")";var L=c++;h[L]="("+h[y]+")\\.("+h[y]+")\\.("+h[y]+")";var D=c++;h[D]="(?:"+h[b]+"|"+h[m]+")";var u=c++;h[u]="(?:"+h[y]+"|"+h[m]+")";var g=c++;h[g]="(?:-("+h[D]+"(?:\\."+h[D]+")*))";var f=c++;h[f]="(?:-?("+h[u]+"(?:\\."+h[u]+")*))";var S=c++;h[S]="[0-9A-Za-z-]+";var p=c++;h[p]="(?:\\+("+h[S]+"(?:\\."+h[S]+")*))";var w=c++,t="v?"+h[v]+h[g]+"?"+h[p]+"?";h[w]="^"+t+"$";var o="[v=\\s]*"+h[L]+h[f]+"?"+h[p]+"?",n=c++;h[n]="^"+o+"$";var i=c++;h[i]="((?:<|>)?=?)";var r=c++;h[r]=h[y]+"|x|X|\\*";var a=c++;h[a]=h[b]+"|x|X|\\*";var l=c++;h[l]="[v=\\s]*("+h[a]+")(?:\\.("+h[a]+")(?:\\.("+h[a]+")(?:"+h[g]+")?"+h[p]+"?)?)?";var d=c++;h[d]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[f]+")?"+h[p]+"?)?)?";var E=c++;h[E]="^"+h[i]+"\\s*"+h[l]+"$";var k=c++;h[k]="^"+h[i]+"\\s*"+h[d]+"$";var F=c++;h[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=c++;h[Y]="(?:~>?)";var X=c++;h[X]="(\\s*)"+h[Y]+"\\s+",I[X]=new RegExp(h[X],"g");var ee=c++;h[ee]="^"+h[Y]+h[l]+"$";var le=c++;h[le]="^"+h[Y]+h[d]+"$";var re=c++;h[re]="(?:\\^)";var fe=c++;h[fe]="(\\s*)"+h[re]+"\\s+",I[fe]=new RegExp(h[fe],"g");var ce=c++;h[ce]="^"+h[re]+h[l]+"$";var se=c++;h[se]="^"+h[re]+h[d]+"$";var j=c++;h[j]="^"+h[i]+"\\s*("+o+")$|^$";var B=c++;h[B]="^"+h[i]+"\\s*("+t+")$|^$";var V=c++;h[V]="(\\s*)"+h[i]+"\\s*("+o+"|"+h[l]+")",I[V]=new RegExp(h[V],"g");var M=c++;h[M]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var $=c++;h[$]="^\\s*("+h[d]+")\\s+-\\s+("+h[d]+")\\s*$";var G=c++;h[G]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)C(H,h[H]),I[H]||(I[H]=new RegExp(h[H]));function x(z,J){if(z instanceof U)return z;if(typeof z!="string"||z.length>N||!(J?I[n]:I[w]).test(z))return null;try{return new U(z,J)}catch{return null}}function U(z,J){if(z instanceof U){if(z.loose===J)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof U))return new U(z,J);C("SemVer",z,J),this.loose=J;var Z=z.trim().match(J?I[n]:I[w]);if(!Z)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+Z[1],this.minor=+Z[2],this.patch=+Z[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");Z[4]?this.prerelease=Z[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var Se=+me;if(Se>=0&&Se<O)return Se}return me}):this.prerelease=[],this.build=Z[5]?Z[5].split("."):[],this.format()}e.parse=x,e.valid=function(z,J){var Z=x(z,J);return Z?Z.version:null},e.clean=function(z,J){var Z=x(z.trim().replace(/^[=v]+/,""),J);return Z?Z.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(z){return C("SemVer.compare",this.version,this.loose,z),z instanceof U||(z=new U(z,this.loose)),this.compareMain(z)||this.comparePre(z)},U.prototype.compareMain=function(z){return z instanceof U||(z=new U(z,this.loose)),s(this.major,z.major)||s(this.minor,z.minor)||s(this.patch,z.patch)},U.prototype.comparePre=function(z){if(z instanceof U||(z=new U(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var J=0;do{var Z=this.prerelease[J],me=z.prerelease[J];if(C("prerelease compare",J,Z,me),Z===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(Z===void 0)return-1;if(Z!==me)return s(Z,me)}while(++J)},U.prototype.inc=function(z,J){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Z=this.prerelease.length;--Z>=0;)typeof this.prerelease[Z]=="number"&&(this.prerelease[Z]++,Z=-2);Z===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,J,Z,me){typeof Z=="string"&&(me=Z,Z=void 0);try{return new U(z,Z).inc(J,me).version}catch{return null}},e.diff=function(z,J){if(K(z,J))return null;var Z=x(z),me=x(J);if(Z.prerelease.length||me.prerelease.length){for(var Se in Z)if((Se==="major"||Se==="minor"||Se==="patch")&&Z[Se]!==me[Se])return"pre"+Se;return"prerelease"}for(var Se in Z)if((Se==="major"||Se==="minor"||Se==="patch")&&Z[Se]!==me[Se])return Se},e.compareIdentifiers=s;var R=/^[0-9]+$/;function s(z,J){var Z=R.test(z),me=R.test(J);return Z&&me&&(z=+z,J=+J),Z&&!me?-1:me&&!Z?1:z<J?-1:z>J?1:0}function P(z,J,Z){return new U(z,Z).compare(new U(J,Z))}function _(z,J,Z){return P(z,J,Z)>0}function W(z,J,Z){return P(z,J,Z)<0}function K(z,J,Z){return P(z,J,Z)===0}function Q(z,J,Z){return P(z,J,Z)!==0}function ae(z,J,Z){return P(z,J,Z)>=0}function de(z,J,Z){return P(z,J,Z)<=0}function pe(z,J,Z,me){var Se;switch(J){case"===":typeof z=="object"&&(z=z.version),typeof Z=="object"&&(Z=Z.version),Se=z===Z;break;case"!==":typeof z=="object"&&(z=z.version),typeof Z=="object"&&(Z=Z.version),Se=z!==Z;break;case"":case"=":case"==":Se=K(z,Z,me);break;case"!=":Se=Q(z,Z,me);break;case">":Se=_(z,Z,me);break;case">=":Se=ae(z,Z,me);break;case"<":Se=W(z,Z,me);break;case"<=":Se=de(z,Z,me);break;default:throw new TypeError("Invalid operator: "+J)}return Se}function ue(z,J){if(z instanceof ue){if(z.loose===J)return z;z=z.value}if(!(this instanceof ue))return new ue(z,J);C("comparator",z,J),this.loose=J,this.parse(z),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(z,J){return s(J,z)},e.major=function(z,J){return new U(z,J).major},e.minor=function(z,J){return new U(z,J).minor},e.patch=function(z,J){return new U(z,J).patch},e.compare=P,e.compareLoose=function(z,J){return P(z,J,!0)},e.rcompare=function(z,J,Z){return P(J,z,Z)},e.sort=function(z,J){return z.sort(function(Z,me){return e.compare(Z,me,J)})},e.rsort=function(z,J){return z.sort(function(Z,me){return e.rcompare(Z,me,J)})},e.gt=_,e.lt=W,e.eq=K,e.neq=Q,e.gte=ae,e.lte=de,e.cmp=pe,e.Comparator=ue;var ge={};function oe(z,J){if(z instanceof oe)return z.loose===J?z:new oe(z.raw,J);if(z instanceof ue)return new oe(z.value,J);if(!(this instanceof oe))return new oe(z,J);if(this.loose=J,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(Z){return this.parseRange(Z.trim())},this).filter(function(Z){return Z.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function he(z){return!z||z.toLowerCase()==="x"||z==="*"}function Ee(z,J,Z,me,Se,ke,Pe,Oe,Ce,Le,Fe,Ie,Te){return((J=he(Z)?"":he(me)?">="+Z+".0.0":he(Se)?">="+Z+"."+me+".0":">="+J)+" "+(Oe=he(Ce)?"":he(Le)?"<"+(+Ce+1)+".0.0":he(Fe)?"<"+Ce+"."+(+Le+1)+".0":Ie?"<="+Ce+"."+Le+"."+Fe+"-"+Ie:"<="+Oe)).trim()}function De(z,J){for(var Z=0;Z<z.length;Z++)if(!z[Z].test(J))return!1;if(J.prerelease.length){for(Z=0;Z<z.length;Z++)if(C(z[Z].semver),z[Z].semver!==ge&&z[Z].semver.prerelease.length>0){var me=z[Z].semver;if(me.major===J.major&&me.minor===J.minor&&me.patch===J.patch)return!0}return!1}return!0}function Ne(z,J,Z){try{J=new oe(J,Z)}catch{return!1}return J.test(z)}function Me(z,J,Z,me){var Se,ke,Pe,Oe,Ce;switch(z=new U(z,me),J=new oe(J,me),Z){case">":Se=_,ke=de,Pe=W,Oe=">",Ce=">=";break;case"<":Se=W,ke=ae,Pe=_,Oe="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(z,J,me))return!1;for(var Le=0;Le<J.set.length;++Le){var Fe=J.set[Le],Ie=null,Te=null;if(Fe.forEach(function(xe){xe.semver===ge&&(xe=new ue(">=0.0.0")),Ie=Ie||xe,Te=Te||xe,Se(xe.semver,Ie.semver,me)?Ie=xe:Pe(xe.semver,Te.semver,me)&&(Te=xe)}),Ie.operator===Oe||Ie.operator===Ce||(!Te.operator||Te.operator===Oe)&&ke(z,Te.semver)||Te.operator===Ce&&Pe(z,Te.semver))return!1}return!0}ue.prototype.parse=function(z){var J=this.loose?I[j]:I[B],Z=z.match(J);if(!Z)throw new TypeError("Invalid comparator: "+z);this.operator=Z[1],this.operator==="="&&(this.operator=""),Z[2]?this.semver=new U(Z[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(z){return C("Comparator.test",z,this.loose),this.semver===ge||(typeof z=="string"&&(z=new U(z,this.loose)),pe(z,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(z,J){if(!(z instanceof ue))throw new TypeError("a Comparator is required");var Z;if(this.operator==="")return Z=new oe(z.value,J),Ne(this.value,Z,J);if(z.operator==="")return Z=new oe(this.value,J),Ne(z.semver,Z,J);var me=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),ke=this.semver.version===z.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Oe=pe(this.semver,"<",z.semver,J)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ce=pe(this.semver,">",z.semver,J)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return me||Se||ke&&Pe||Oe||Ce},e.Range=oe,oe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},oe.prototype.toString=function(){return this.range},oe.prototype.parseRange=function(z){var J=this.loose;z=z.trim(),C("range",z,J);var Z=J?I[$]:I[M];z=z.replace(Z,Ee),C("hyphen replace",z),z=z.replace(I[V],"$1$2$3"),C("comparator trim",z,I[V]),z=(z=(z=z.replace(I[X],"$1~")).replace(I[fe],"$1^")).split(/\s+/).join(" ");var me=J?I[j]:I[B],Se=z.split(" ").map(function(ke){return function(Pe,Oe){return C("comp",Pe),Pe=function(Ce,Le){return Ce.trim().split(/\s+/).map(function(Fe){return function(Ie,Te){C("caret",Ie,Te);var xe=Te?I[se]:I[ce];return Ie.replace(xe,function(_e,ye,we,be,Re){var Ae;return C("caret",Ie,_e,ye,we,be,Re),he(ye)?Ae="":he(we)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":he(be)?Ae=ye==="0"?">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+".0 <"+(+ye+1)+".0.0":Re?(C("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ae=ye==="0"?we==="0"?">="+ye+"."+we+"."+be+Re+" <"+ye+"."+we+"."+(+be+1):">="+ye+"."+we+"."+be+Re+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+be+Re+" <"+(+ye+1)+".0.0"):(C("no pr"),Ae=ye==="0"?we==="0"?">="+ye+"."+we+"."+be+" <"+ye+"."+we+"."+(+be+1):">="+ye+"."+we+"."+be+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+be+" <"+(+ye+1)+".0.0"),C("caret return",Ae),Ae})}(Fe,Le)}).join(" ")}(Pe,Oe),C("caret",Pe),Pe=function(Ce,Le){return Ce.trim().split(/\s+/).map(function(Fe){return function(Ie,Te){var xe=Te?I[le]:I[ee];return Ie.replace(xe,function(_e,ye,we,be,Re){var Ae;return C("tilde",Ie,_e,ye,we,be,Re),he(ye)?Ae="":he(we)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":he(be)?Ae=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":Re?(C("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ae=">="+ye+"."+we+"."+be+Re+" <"+ye+"."+(+we+1)+".0"):Ae=">="+ye+"."+we+"."+be+" <"+ye+"."+(+we+1)+".0",C("tilde return",Ae),Ae})}(Fe,Le)}).join(" ")}(Pe,Oe),C("tildes",Pe),Pe=function(Ce,Le){return C("replaceXRanges",Ce,Le),Ce.split(/\s+/).map(function(Fe){return function(Ie,Te){Ie=Ie.trim();var xe=Te?I[k]:I[E];return Ie.replace(xe,function(_e,ye,we,be,Re,Ae){C("xRange",Ie,_e,ye,we,be,Re,Ae);var $e=he(we),Ve=$e||he(be),We=Ve||he(Re);return ye==="="&&We&&(ye=""),$e?_e=ye===">"||ye==="<"?"<0.0.0":"*":ye&&We?(Ve&&(be=0),We&&(Re=0),ye===">"?(ye=">=",Ve?(we=+we+1,be=0,Re=0):We&&(be=+be+1,Re=0)):ye==="<="&&(ye="<",Ve?we=+we+1:be=+be+1),_e=ye+we+"."+be+"."+Re):Ve?_e=">="+we+".0.0 <"+(+we+1)+".0.0":We&&(_e=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0"),C("xRange return",_e),_e})}(Fe,Le)}).join(" ")}(Pe,Oe),C("xrange",Pe),Pe=function(Ce,Le){return C("replaceStars",Ce,Le),Ce.trim().replace(I[G],"")}(Pe,Oe),C("stars",Pe),Pe}(ke,J)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(ke){return!!ke.match(me)})),Se=Se.map(function(ke){return new ue(ke,J)})},oe.prototype.intersects=function(z,J){if(!(z instanceof oe))throw new TypeError("a Range is required");return this.set.some(function(Z){return Z.every(function(me){return z.set.some(function(Se){return Se.every(function(ke){return me.intersects(ke,J)})})})})},e.toComparators=function(z,J){return new oe(z,J).set.map(function(Z){return Z.map(function(me){return me.value}).join(" ").trim().split(" ")})},oe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new U(z,this.loose));for(var J=0;J<this.set.length;J++)if(De(this.set[J],z))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(z,J,Z){var me=null,Se=null;try{var ke=new oe(J,Z)}catch{return null}return z.forEach(function(Pe){ke.test(Pe)&&(me&&Se.compare(Pe)!==-1||(Se=new U(me=Pe,Z)))}),me},e.minSatisfying=function(z,J,Z){var me=null,Se=null;try{var ke=new oe(J,Z)}catch{return null}return z.forEach(function(Pe){ke.test(Pe)&&(me&&Se.compare(Pe)!==1||(Se=new U(me=Pe,Z)))}),me},e.validRange=function(z,J){try{return new oe(z,J).range||"*"}catch{return null}},e.ltr=function(z,J,Z){return Me(z,J,"<",Z)},e.gtr=function(z,J,Z){return Me(z,J,">",Z)},e.outside=Me,e.prerelease=function(z,J){var Z=x(z,J);return Z&&Z.prerelease.length?Z.prerelease:null},e.intersects=function(z,J,Z){return z=new oe(z,Z),J=new oe(J,Z),z.intersects(J)},e.coerce=function(z){if(z instanceof U)return z;if(typeof z!="string")return null;var J=z.match(I[F]);return J==null?null:x((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,A(1))},function(q,e){var A,T,C=q.exports={};function N(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(u){if(A===setTimeout)return setTimeout(u,0);if((A===N||!A)&&setTimeout)return A=setTimeout,setTimeout(u,0);try{return A(u,0)}catch{try{return A.call(null,u,0)}catch{return A.call(this,u,0)}}}(function(){try{A=typeof setTimeout=="function"?setTimeout:N}catch{A=N}try{T=typeof clearTimeout=="function"?clearTimeout:O}catch{T=O}})();var h,c=[],b=!1,y=-1;function m(){b&&h&&(b=!1,h.length?c=h.concat(c):y=-1,c.length&&v())}function v(){if(!b){var u=I(m);b=!0;for(var g=c.length;g;){for(h=c,c=[];++y<g;)h&&h[y].run();y=-1,g=c.length}h=null,b=!1,function(f){if(T===clearTimeout)return clearTimeout(f);if((T===O||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(f);try{T(f)}catch{try{return T.call(null,f)}catch{return T.call(this,f)}}}(u)}}function L(u,g){this.fun=u,this.array=g}function D(){}C.nextTick=function(u){var g=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)g[f-1]=arguments[f];c.push(new L(u,g)),c.length!==1||b||I(v)},L.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=D,C.addListener=D,C.once=D,C.off=D,C.removeListener=D,C.removeAllListeners=D,C.emit=D,C.prependListener=D,C.prependOnceListener=D,C.listeners=function(u){return[]},C.binding=function(u){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(u){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(ie[72],ne([0,1]),function(q,e){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class T{constructor(I,h,c){this.level=I,this.key=h,this.value=c,this.forward=[]}}const C=void 0;class N{constructor(I,h=2**16){this.comparator=I,this[A]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new T(this._maxLevel,C,C)}get size(){return this._size}clear(){this._header=new T(this._maxLevel,C,C)}has(I){return!!N._search(this,I,this.comparator)}get(I){return N._search(this,I,this.comparator)?.value}set(I,h){return N._insert(this,I,h,this.comparator)&&(this._size+=1),this}delete(I){const h=N._delete(this,I,this.comparator);return h&&(this._size-=1),h}forEach(I,h){let c=this._header.forward[0];for(;c;)I.call(h,c.value,c.key,this),c=c.forward[0]}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",h=this._header.forward[0];for(;h;)I+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return I}static _search(I,h,c){let b=I._header;for(let y=I._level-1;y>=0;y--)for(;b.forward[y]&&c(b.forward[y].key,h)<0;)b=b.forward[y];if(b=b.forward[0],b&&c(b.key,h)===0)return b}static _insert(I,h,c,b){const y=[];let m=I._header;for(let v=I._level-1;v>=0;v--){for(;m.forward[v]&&b(m.forward[v].key,h)<0;)m=m.forward[v];y[v]=m}if(m=m.forward[0],m&&b(m.key,h)===0)return m.value=c,!1;{const v=N._randomLevel(I);if(v>I._level){for(let L=I._level;L<v;L++)y[L]=I._header;I._level=v}m=new T(v,h,c);for(let L=0;L<v;L++)m.forward[L]=y[L].forward[L],y[L].forward[L]=m;return!0}}static _randomLevel(I,h=.5){let c=1;for(;Math.random()<h&&c<I._maxLevel;)c+=1;return c}static _delete(I,h,c){const b=[];let y=I._header;for(let m=I._level-1;m>=0;m--){for(;y.forward[m]&&c(y.forward[m].key,h)<0;)y=y.forward[m];b[m]=y}if(y=y.forward[0],!y||c(y.key,h)!==0)return!1;for(let m=0;m<I._level&&b[m].forward[m]===y;m++)b[m].forward[m]=y.forward[m];for(;I._level>0&&I._header.forward[I._level-1]===C;)I._level-=1;return!0}}e.SkipList=N}),define(ie[44],ne([0,1,9,2]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(p){const w=p;return w?typeof w.read=="function":!1}e.isReadable=C;function N(p){const w=p;return w?[w.on,w.pause,w.resume,w.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=N;function O(p){const w=p;return w?N(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=O;function I(p,w){return new h(p,w)}e.newWriteableStream=I;class h{constructor(w,t){this.reducer=w,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(t=>t(w))}emitError(w){this.listeners.error.length===0?(0,A.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(t=>t(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,t){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(w,t){if(this.state.destroyed)return;let o;switch(w){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(t);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(p,w){const t=[];let o;for(;(o=p.read())!==null;)t.push(o);return w(t)}e.consumeReadable=c;function b(p,w,t){const o=[];let n;for(;(n=p.read())!==null&&o.length<t;)o.push(n);return n===null&&o.length>0?w(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return p.read()}}}e.peekReadable=b;function y(p,w){return new Promise((t,o)=>{const n=[];m(p,{onData:i=>{w&&n.push(i)},onError:i=>{w?o(i):t(void 0)},onEnd:()=>{t(w?w(n):void 0)}})})}e.consumeStream=y;function m(p,w){let t=!1;return p.on("error",o=>{t||w.onError(o)}),p.on("end",()=>{t||w.onEnd()}),p.on("data",o=>{t||w.onData(o)}),(0,T.toDisposable)(()=>t=!0)}e.listenStream=m;function v(p,w){return new Promise((t,o)=>{const n=new T.DisposableStore,i=[],r=d=>{if(i.push(d),i.length>w)return n.dispose(),p.pause(),t({stream:p,buffer:i,ended:!1})},a=d=>o(d),l=()=>t({stream:p,buffer:i,ended:!0});n.add((0,T.toDisposable)(()=>p.removeListener("error",a))),p.on("error",a),n.add((0,T.toDisposable)(()=>p.removeListener("end",l))),p.on("end",l),n.add((0,T.toDisposable)(()=>p.removeListener("data",r))),p.on("data",r)})}e.peekStream=v;function L(p,w){const t=I(w);return t.end(p),t}e.toStream=L;function D(){const p=I(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=D;function u(p){let w=!1;return{read:()=>w?null:(w=!0,p)}}e.toReadable=u;function g(p,w,t){const o=I(t);return m(p,{onData:n=>o.write(w.data(n)),onError:n=>o.error(w.error?w.error(n):n),onEnd:()=>o.end()}),o}e.transform=g;function f(p,w,t){let o=!1;return{read:()=>{const n=w.read();return o?n:(o=!0,n!==null?t([p,n]):p)}}}e.prefixedReadable=f;function S(p,w,t){let o=!1;const n=I(t);return m(w,{onData:i=>o?n.write(i):(o=!0,n.write(t([p,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(p)),n.end()}}),n}e.prefixedStream=S}),define(ie[14],ne([0,1,44]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let C,N;class O{static alloc(d){return T?new O(Buffer.allocUnsafe(d)):new O(new Uint8Array(d))}static wrap(d){return T&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new O(d)}static fromString(d,E){return!(E?.dontUseNodeBuffer||!1)&&T?new O(Buffer.from(d)):(C||(C=new TextEncoder),new O(C.encode(d)))}static fromByteArray(d){const E=O.alloc(d.length);for(let k=0,F=d.length;k<F;k++)E.buffer[k]=d[k];return E}static concat(d,E){if(typeof E>"u"){E=0;for(let Y=0,X=d.length;Y<X;Y++)E+=d[Y].byteLength}const k=O.alloc(E);let F=0;for(let Y=0,X=d.length;Y<X;Y++){const ee=d[Y];k.set(ee,F),F+=ee.byteLength}return k}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=O.alloc(this.byteLength);return d.set(this),d}toString(){return T?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(d,E){return new O(this.buffer.subarray(d,E))}set(d,E){if(d instanceof O)this.buffer.set(d.buffer,E);else if(d instanceof Uint8Array)this.buffer.set(d,E);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),E);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return c(this.buffer,d)}writeUInt32BE(d,E){b(this.buffer,d,E)}readUInt32LE(d){return y(this.buffer,d)}writeUInt32LE(d,E){m(this.buffer,d,E)}readUInt8(d){return v(this.buffer,d)}writeUInt8(d,E){L(this.buffer,d,E)}}e.VSBuffer=O;function I(l,d){return l[d+0]<<0>>>0|l[d+1]<<8>>>0}e.readUInt16LE=I;function h(l,d,E){l[E+0]=d&255,d=d>>>8,l[E+1]=d&255}e.writeUInt16LE=h;function c(l,d){return l[d]*2**24+l[d+1]*2**16+l[d+2]*2**8+l[d+3]}e.readUInt32BE=c;function b(l,d,E){l[E+3]=d,d=d>>>8,l[E+2]=d,d=d>>>8,l[E+1]=d,d=d>>>8,l[E]=d}e.writeUInt32BE=b;function y(l,d){return l[d+0]<<0>>>0|l[d+1]<<8>>>0|l[d+2]<<16>>>0|l[d+3]<<24>>>0}e.readUInt32LE=y;function m(l,d,E){l[E+0]=d&255,d=d>>>8,l[E+1]=d&255,d=d>>>8,l[E+2]=d&255,d=d>>>8,l[E+3]=d&255}e.writeUInt32LE=m;function v(l,d){return l[d]}e.readUInt8=v;function L(l,d,E){l[E]=d}e.writeUInt8=L;function D(l){return A.consumeReadable(l,d=>O.concat(d))}e.readableToBuffer=D;function u(l){return A.toReadable(l)}e.bufferToReadable=u;function g(l){return A.consumeStream(l,d=>O.concat(d))}e.streamToBuffer=g;async function f(l){return l.ended?O.concat(l.buffer):O.concat([...l.buffer,await g(l.stream)])}e.bufferedStreamToBuffer=f;function S(l){return A.toStream(l,d=>O.concat(d))}e.bufferToStream=S;function p(l){return A.transform(l,{data:d=>typeof d=="string"?O.fromString(d):O.wrap(d)},d=>O.concat(d))}e.streamToBufferReadableStream=p;function w(l){return A.newWriteableStream(d=>O.concat(d),l)}e.newWriteableBufferStream=w;function t(l,d){return A.prefixedReadable(l,d,E=>O.concat(E))}e.prefixedBufferReadable=t;function o(l,d){return A.prefixedStream(l,d,E=>O.concat(E))}e.prefixedBufferStream=o;function n(l){let d=0,E=0,k=0;const F=new Uint8Array(Math.floor(l.length/4*3)),Y=ee=>{switch(E){case 3:F[k++]=d|ee,E=0;break;case 2:F[k++]=d|ee>>>2,d=ee<<6,E=3;break;case 1:F[k++]=d|ee>>>4,d=ee<<4,E=2;break;default:d=ee<<2,E=1}};for(let ee=0;ee<l.length;ee++){const le=l.charCodeAt(ee);if(le>=65&&le<=90)Y(le-65);else if(le>=97&&le<=122)Y(le-97+26);else if(le>=48&&le<=57)Y(le-48+52);else if(le===43||le===45)Y(62);else if(le===47||le===95)Y(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${l[ee]}`)}}const X=k;for(;E>0;)Y(0);return O.wrap(F).slice(0,X)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:l},d=!0,E=!1){const k=E?r:i;let F="";const Y=l.byteLength%3;let X=0;for(;X<l.byteLength-Y;X+=3){const ee=l[X+0],le=l[X+1],re=l[X+2];F+=k[ee>>>2],F+=k[(ee<<4|le>>>4)&63],F+=k[(le<<2|re>>>6)&63],F+=k[re&63]}if(Y===1){const ee=l[X+0];F+=k[ee>>>2],F+=k[ee<<4&63],d&&(F+="==")}else if(Y===2){const ee=l[X+0],le=l[X+1];F+=k[ee>>>2],F+=k[(ee<<4|le>>>4)&63],F+=k[le<<2&63],d&&(F+="=")}return F}e.encodeBase64=a}),define(ie[30],ne([0,1,3]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const f=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([S,p])=>{f[S]=p&&typeof p=="object"?T(p):p}),f}e.deepClone=T;function C(g){if(!g||typeof g!="object")return g;const f=[g];for(;f.length>0;){const S=f.shift();Object.freeze(S);for(const p in S)if(N.call(S,p)){const w=S[p];typeof w=="object"&&!Object.isFrozen(w)&&!(0,A.isTypedArray)(w)&&f.push(w)}}return g}e.deepFreeze=C;const N=Object.prototype.hasOwnProperty;function O(g,f){return I(g,f,new Set)}e.cloneAndChange=O;function I(g,f,S){if((0,A.isUndefinedOrNull)(g))return g;const p=f(g);if(typeof p<"u")return p;if(Array.isArray(g)){const w=[];for(const t of g)w.push(I(t,f,S));return w}if((0,A.isObject)(g)){if(S.has(g))throw new Error("Cannot clone recursive data-structure");S.add(g);const w={};for(const t in g)N.call(g,t)&&(w[t]=I(g[t],f,S));return S.delete(g),w}return g}function h(g,f,S=!0){return(0,A.isObject)(g)?((0,A.isObject)(f)&&Object.keys(f).forEach(p=>{p in g?S&&((0,A.isObject)(g[p])&&(0,A.isObject)(f[p])?h(g[p],f[p],S):g[p]=f[p]):g[p]=f[p]}),g):f}e.mixin=h;function c(g,f){if(g===f)return!0;if(g==null||f===null||f===void 0||typeof g!=typeof f||typeof g!="object"||Array.isArray(g)!==Array.isArray(f))return!1;let S,p;if(Array.isArray(g)){if(g.length!==f.length)return!1;for(S=0;S<g.length;S++)if(!c(g[S],f[S]))return!1}else{const w=[];for(p in g)w.push(p);w.sort();const t=[];for(p in f)t.push(p);if(t.sort(),!c(w,t))return!1;for(S=0;S<w.length;S++)if(!c(g[w[S]],f[w[S]]))return!1}return!0}e.equals=c;function b(g){const f=new Set;return JSON.stringify(g,(S,p)=>{if((0,A.isObject)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.safeStringify=b;function y(g,f){const S=Object.create(null);return!g||!f||Object.keys(f).forEach(w=>{const t=g[w],o=f[w];c(t,o)||(S[w]=o)}),S}e.distinct=y;function m(g,f){const S=f.toLowerCase(),p=Object.keys(g).find(w=>w.toLowerCase()===S);return p?g[p]:g[f]}e.getCaseInsensitive=m;function v(g,f){const S=Object.create(null);for(const[p,w]of Object.entries(g))f(p,w)&&(S[p]=w);return S}e.filter=v;function L(g){let f=[],S=Object.getPrototypeOf(g);for(;Object.prototype!==S;)f=f.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return f}e.getAllPropertyNames=L;function D(g){const f=[];for(const S of L(g))typeof g[S]=="function"&&f.push(S);return f}e.getAllMethodNames=D;function u(g,f){const S=w=>function(){const t=Array.prototype.slice.call(arguments,0);return f(w,t)},p={};for(const w of g)p[w]=S(w);return p}e.createProxyObject=u}),define(ie[28],ne([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const A=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(C){return A.test(C)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(I){for(let h=0;h<I.length;h++)I[h]=Math.floor(Math.random()*256);return I};const N=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){C(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let h=0,c="";return c+=O[N[h++]],c+=O[N[h++]],c+=O[N[h++]],c+=O[N[h++]],c+="-",c+=O[N[h++]],c+=O[N[h++]],c+="-",c+=O[N[h++]],c+=O[N[h++]],c+="-",c+=O[N[h++]],c+=O[N[h++]],c+="-",c+=O[N[h++]],c+=O[N[h++]],c+=O[N[h++]],c+=O[N[h++]],c+=O[N[h++]],c+=O[N[h++]],c}}()}),define(ie[73],ne([0,1,36]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(O){const I=O.replace(/\-/g,":").toLowerCase();return!T.has(I)}function N(){const O=(0,A.networkInterfaces)();for(const I in O){const h=O[I];if(h){for(const{mac:c}of h)if(C(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=N}),define(ie[74],ne([7,4]),function(q,e){return q.create("vs/base/common/date",e)}),define(ie[75],ne([0,1,74]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,C=T*60,N=C*24,O=N*7,I=N*30,h=N*365;function c(y,m,v,L){typeof y!="number"&&(y=y.getTime());const D=Math.round((new Date().getTime()-y)/1e3);if(D<-30)return(0,A.localize)(0,null,c(new Date().getTime()+D*1e3,!1));if(!L&&D<30)return(0,A.localize)(1,null);let u;return D<T?(u=D,m?u===1?v?(0,A.localize)(2,null,u):(0,A.localize)(3,null,u):v?(0,A.localize)(4,null,u):(0,A.localize)(5,null,u):u===1?v?(0,A.localize)(6,null,u):(0,A.localize)(7,null,u):v?(0,A.localize)(8,null,u):(0,A.localize)(9,null,u)):D<C?(u=Math.floor(D/T),m?u===1?v?(0,A.localize)(10,null,u):(0,A.localize)(11,null,u):v?(0,A.localize)(12,null,u):(0,A.localize)(13,null,u):u===1?v?(0,A.localize)(14,null,u):(0,A.localize)(15,null,u):v?(0,A.localize)(16,null,u):(0,A.localize)(17,null,u)):D<N?(u=Math.floor(D/C),m?u===1?v?(0,A.localize)(18,null,u):(0,A.localize)(19,null,u):v?(0,A.localize)(20,null,u):(0,A.localize)(21,null,u):u===1?v?(0,A.localize)(22,null,u):(0,A.localize)(23,null,u):v?(0,A.localize)(24,null,u):(0,A.localize)(25,null,u)):D<O?(u=Math.floor(D/N),m?u===1?(0,A.localize)(26,null,u):(0,A.localize)(27,null,u):u===1?(0,A.localize)(28,null,u):(0,A.localize)(29,null,u)):D<I?(u=Math.floor(D/O),m?u===1?v?(0,A.localize)(30,null,u):(0,A.localize)(31,null,u):v?(0,A.localize)(32,null,u):(0,A.localize)(33,null,u):u===1?v?(0,A.localize)(34,null,u):(0,A.localize)(35,null,u):v?(0,A.localize)(36,null,u):(0,A.localize)(37,null,u)):D<h?(u=Math.floor(D/I),m?u===1?v?(0,A.localize)(38,null,u):(0,A.localize)(39,null,u):v?(0,A.localize)(40,null,u):(0,A.localize)(41,null,u):u===1?v?(0,A.localize)(42,null,u):(0,A.localize)(43,null,u):v?(0,A.localize)(44,null,u):(0,A.localize)(45,null,u)):(u=Math.floor(D/h),m?u===1?v?(0,A.localize)(46,null,u):(0,A.localize)(47,null,u):v?(0,A.localize)(48,null,u):(0,A.localize)(49,null,u):u===1?v?(0,A.localize)(50,null,u):(0,A.localize)(51,null,u):v?(0,A.localize)(52,null,u):(0,A.localize)(53,null,u))}e.fromNow=c;function b(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ie[76],ne([7,4]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(ie[32],ne([0,1,19,3,76]),function(q,e,A,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(y,m){return m&&(y.stack||y.stacktrace)?C.localize(0,null,I(y),O(y.stack)||O(y.stacktrace)):I(y)}function O(y){return Array.isArray(y)?y.join(`
`):y}function I(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?C.localize(1,null,y.message):y.message||C.localize(2,null)}function h(y=null,m=!1){if(!y)return C.localize(3,null);if(Array.isArray(y)){const v=A.coalesce(y),L=h(v[0],m);return v.length>1?C.localize(4,null,L,v.length):L}if(T.isString(y))return y;if(y.detail){const v=y.detail;if(v.error)return N(v.error,m);if(v.exception)return N(v.exception,m)}return y.stack?N(y,m):y.message?y.message:C.localize(5,null)}e.toErrorMessage=h;function c(y){const m=y;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=c;function b(y,m){let v;return typeof y=="string"?v=new Error(y):v=y,v.actions=m,v}e.createErrorWithActions=b}),define(ie[77],ne([7,4]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(ie[78],ne([0,1,77]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function T(C){switch(C){case 1:return(0,A.localize)(0,null);case 2:return(0,A.localize)(1,null);case 3:return(0,A.localize)(2,null);case 4:return(0,A.localize)(3,null);case 5:return(0,A.localize)(4,null);case 6:return(0,A.localize)(5,null);case 7:return(0,A.localize)(6,null);case 8:return(0,A.localize)(7,null);case 9:return(0,A.localize)(8,null);default:return""}}e.getParseErrorMessage=T}),define(ie[52],ne([0,1,12]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var T;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(T||(e.Source=T={}));var C;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function N(I,...h){const c=h.reduce((m,v)=>(m[v]=!0,m),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!c[m]).forEach(m=>{for(let v=0;v<b.length;v++)if(m.search(b[v])!==-1){delete I[m];break}})}e.sanitizeProcessEnvironment=N;function O(I){I&&(delete I.DEBUG,A.isMacintosh&&delete I.DYLD_LIBRARY_PATH,A.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=O}),define(ie[45],ne([0,1,29]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function T(g){return C(g,0)}e.hash=T;function C(g,f){switch(typeof g){case"object":return g===null?N(349,f):Array.isArray(g)?h(g,f):c(g,f);case"string":return I(g,f);case"boolean":return O(g,f);case"number":return N(g,f);case"undefined":return N(937,f);default:return N(617,f)}}e.doHash=C;function N(g,f){return(f<<5)-f+g|0}e.numberHash=N;function O(g,f){return N(g?433:863,f)}function I(g,f){f=N(149417,f);for(let S=0,p=g.length;S<p;S++)f=N(g.charCodeAt(S),f);return f}e.stringHash=I;function h(g,f){return f=N(104579,f),g.reduce((S,p)=>C(p,S),f)}function c(g,f){return f=N(181387,f),Object.keys(g).sort().reduce((S,p)=>(S=I(p,S),C(g[p],S)),f)}class b{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=C(f,this._value),this._value}}e.Hasher=b;var y;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function m(g,f,S=32){const p=S-f,w=~((1<<p)-1);return(g<<f|(w&g)>>>p)>>>0}function v(g,f=0,S=g.byteLength,p=0){for(let w=0;w<S;w++)g[f+w]=p}function L(g,f,S="0"){for(;g.length<f;)g=S+g;return g}function D(g,f=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(S=>S.toString(16).padStart(2,"0")).join(""):L((g>>>0).toString(16),f/4)}e.toHexString=D;class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const S=f.length;if(S===0)return;const p=this._buff;let w=this._buffLen,t=this._leftoverHighSurrogate,o,n;for(t!==0?(o=t,n=-1,t=0):(o=f.charCodeAt(0),n=0);;){let i=o;if(A.isHighSurrogate(o))if(n+1<S){const r=f.charCodeAt(n+1);A.isLowSurrogate(r)?(n++,i=A.computeCodePoint(o,r)):i=65533}else{t=o;break}else A.isLowSurrogate(o)&&(i=65533);if(w=this._push(p,w,i),n++,n<S)o=f.charCodeAt(n);else break}this._buffLen=w,this._leftoverHighSurrogate=t}_push(f,S,p){return p<128?f[S++]=p:p<2048?(f[S++]=192|(p&1984)>>>6,f[S++]=128|(p&63)>>>0):p<65536?(f[S++]=224|(p&61440)>>>12,f[S++]=128|(p&4032)>>>6,f[S++]=128|(p&63)>>>0):(f[S++]=240|(p&1835008)>>>18,f[S++]=128|(p&258048)>>>12,f[S++]=128|(p&4032)>>>6,f[S++]=128|(p&63)>>>0),S>=64&&(this._step(),S-=64,this._totalLen+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),S}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),D(this._h0)+D(this._h1)+D(this._h2)+D(this._h3)+D(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=u._bigBlock32,S=this._buffDV;for(let l=0;l<64;l+=4)f.setUint32(l,S.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)f.setUint32(l,m(f.getUint32(l-12,!1)^f.getUint32(l-32,!1)^f.getUint32(l-56,!1)^f.getUint32(l-64,!1),1),!1);let p=this._h0,w=this._h1,t=this._h2,o=this._h3,n=this._h4,i,r,a;for(let l=0;l<80;l++)l<20?(i=w&t|~w&o,r=1518500249):l<40?(i=w^t^o,r=1859775393):l<60?(i=w&t|w&o|t&o,r=2400959708):(i=w^t^o,r=3395469782),a=m(p,5)+i+n+r+f.getUint32(l*4,!1)&4294967295,n=o,o=t,t=m(w,30),w=p,p=a;this._h0=this._h0+p&4294967295,this._h1=this._h1+w&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=u,u._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ie[53],ne([0,1,29]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(T||(T={})),function(C){const N="error",O="warning",I="warn",h="info",c="ignore";function b(m){return m?A.equalsIgnoreCase(N,m)?C.Error:A.equalsIgnoreCase(O,m)||A.equalsIgnoreCase(I,m)?C.Warning:A.equalsIgnoreCase(h,m)?C.Info:C.Ignore:C.Ignore}C.fromValue=b;function y(m){switch(m){case C.Error:return N;case C.Warning:return O;case C.Info:return h;default:return c}}C.toString=y}(T||(T={})),e.default=T}),define(ie[79],ne([0,1,11]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(c){const b=c;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=T;function C(c){const b=[];let y;try{const m=JSON.parse(c.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),y=v.__$stack),b.push(...m)}catch{b.push("Unable to log remote console arguments",c.arguments)}return{args:b,stack:y}}e.parse=C;function N(c){if(typeof c!="string")return N(C(c).stack);const b=c;if(b){const y=O(b),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(m&&m.length===4)return{uri:A.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=N;function O(c){if(!c)return c;const b=c.indexOf(`
`);return b===-1?c:c.substring(0,b)}function I(c,b){const{args:y,stack:m}=C(c),v=typeof y[0]=="string"&&y.length===1;let L=O(m);L&&(L=`(${L.trim()})`);let D=[];if(typeof y[0]=="string"?L&&v?D=[`%c[${b}] %c${y[0]} %c${L}`,h("blue"),h(""),h("grey")]:D=[`%c[${b}] %c${y[0]}`,h("blue"),h(""),...y.slice(1)]:D=[`%c[${b}]%`,h("blue"),...y],L&&!v&&D.push(L),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,D)}e.log=I;function h(c){return`color: ${c}`}}),define(ie[54],ne([0,1,14,29,11]),function(q,e,A,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(c){return JSON.stringify(c,I)}e.stringify=N;function O(c){let b=JSON.parse(c);return b=h(b),b}e.parse=O;function I(c,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,T.regExpFlags)(b)}:b}function h(c,b=0){if(!c||b>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return C.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof A.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let y=0;y<c.length;++y)c[y]=h(c[y],b+1);else for(const y in c)Object.hasOwnProperty.call(c,y)&&(c[y]=h(c[y],b+1))}return c}e.revive=h}),define(ie[80],ne([0,1,36,55,28,73]),function(q,e,A,T,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(c){return this._virtualMachineOUIs||(this._virtualMachineOUIs=T.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(c)}value(){if(this._value===void 0){let c=0,b=0;const y=(0,A.networkInterfaces)();for(const m in y){const v=y[m];if(v)for(const{mac:L,internal:D}of v)D||(b+=1,this._isVirtualMachineMacAddress(L.toUpperCase())&&(c+=1))}this._value=b>0?c/b:0}return this._value}};let O;async function I(c){return O||(O=(async()=>await h(c)||C.generateUuid())()),O}e.getMachineId=I;async function h(c){try{const b=await new Promise((m,v)=>{q(["crypto"],m,v)}),y=(0,N.getMac)();return b.createHash("sha256").update(y,"utf8").digest("hex")}catch(b){c(b);return}}}),define(ie[81],ne([0,1,36,15,22]),function(q,e,A,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const N=/^\d+$/,O=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var h;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class y{constructor(w,t,o){this.exePath=w,this.displayName=t,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await C.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:p=!1,findPreview:w=!1}={}){const t=m({useAlternateBitness:p});if(!t)return null;const o=T.join(t,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(o))return null;let n=-1,i=null;for(const l of await C.Promises.readdir(o)){let d=-1;if(w){const k=l.indexOf("-");if(k<0)continue;const F=l.substring(0,k);if(!N.test(F)||l.substring(k+1)!=="preview")continue;d=parseInt(F,10)}else{if(!N.test(l))continue;d=parseInt(l,10)}if(d<=n)continue;const E=T.join(o,l,"pwsh.exe");await C.SymlinkSupport.existsFile(E)&&(i=E,n=d)}if(!i)return null;const r=t.includes("x86")?" (x86)":"",a=w?" Preview":"";return new y(i,`PowerShell${a}${r}`,!0)}async function L({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const w=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(w))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=p?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const n of await C.Promises.readdir(w))if(t.test(n)){const i=T.join(w,n,"pwsh.exe");return new y(i,o)}return null}function D(){const p=T.join(A.homedir(),".dotnet","tools","pwsh.exe");return new y(p,".NET Core PowerShell Global Tool")}function u(){const p=T.join(process.env.windir,c===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(p,"Windows PowerShell",!0)}async function*g(){let p=await v();p&&(yield p),p=await v({useAlternateBitness:!0}),p&&(yield p),p=await L(),p&&(yield p),p=D(),p&&(yield p),p=await v({findPreview:!0}),p&&(yield p),p=await L({findPreview:!0}),p&&(yield p),p=await v({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=u(),p&&(yield p)}async function*f(){for await(const p of g())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=f;async function S(){for await(const p of f())return p;return null}e.getFirstAvailablePowerShellInstallation=S}),define(ie[56],ne([0,1,15,12,37,52,3,22]),function(q,e,A,T,C,N,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function h(y=C.env){return y.comspec||"cmd.exe"}e.getWindowsShell=h;function c(y){let m=[],v=!1;const L=function(D){if(v){m.push(D);return}(!y.send(D,g=>{if(g&&console.error(g),v=!1,m.length>0){const f=m.slice(0);m=[],f.forEach(S=>L(S))}})||T.isWindows)&&(v=!0)};return{send:L}}e.createQueuedSender=c;var b;(function(y){async function m(v,L,D){if(A.isAbsolute(v))return v;if(L===void 0&&(L=C.cwd()),A.dirname(v)!=="."||(D===void 0&&O.isString(C.env.PATH)&&(D=C.env.PATH.split(A.delimiter)),D===void 0||D.length===0))return A.join(L,v);async function g(f){if(await I.Promises.exists(f)){let S;try{S=await I.Promises.stat(f)}catch(p){p.message.startsWith("EACCES")&&(S=await I.Promises.lstat(f))}return S?!S.isDirectory():!1}return!1}for(const f of D){let S;if(A.isAbsolute(f)?S=A.join(f,v):S=A.join(L,f,v),await g(S))return S;let p=S+".com";if(await g(p)||(p=S+".exe",await g(p)))return p}return A.join(L,v)}y.findExecutable=m})(b||(e.win32=b={}))}),define(ie[82],ne([0,1,36,12,81,56]),function(q,e,A,T,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function O(y,m){return y===1?T.isWindows?b():N.getWindowsShell(m):h(y,m)}e.getSystemShell=O;let I=null;function h(y,m){if(T.isLinux&&y===2||T.isMacintosh&&y===3)return"/bin/bash";if(!I){let v;if(T.isWindows)v="/bin/bash";else{if(v=m.SHELL,!v)try{v=(0,A.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}I=v}return I}let c=null;async function b(){return c||(c=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),c}});var ve=this&&this.__decorate||function(q,e,A,T){var C=arguments.length,N=C<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,A):T,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(q,e,A,T);else for(var I=q.length-1;I>=0;I--)(O=q[I])&&(N=(C<3?O(N):C>3?O(e,A,N):O(e,A))||N);return C>3&&N&&Object.defineProperty(e,A,N),N};define(ie[57],ne([0,1,19,8,14,23,50,9,5,2,54,29,3]),function(q,e,A,T,C,N,O,I,h,c,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var v;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(v||(v={}));function L(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var D;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(D||(D={}));function u(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(g||(g={}));function f(V){let M=0;for(let $=0;;$+=7){const G=V.read(1);if(M|=(G.buffer[0]&127)<<$,!(G.buffer[0]&128))return M}}const S=n(0);function p(V,M){if(M===0){V.write(S);return}let $=0;for(let H=M;H!==0;H=H>>>7)$++;const G=C.VSBuffer.alloc($);for(let H=0;M!==0;H++)G.buffer[H]=M&127,M=M>>>7,M>0&&(G.buffer[H]|=128);V.write(G)}class w{constructor(M){this.buffer=M,this.pos=0}read(M){const $=this.buffer.slice(this.pos,this.pos+M);return this.pos+=$.byteLength,$}}e.BufferReader=w;class t{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}e.BufferWriter=t;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function n(V){const M=C.VSBuffer.alloc(1);return M.writeUInt8(V,0),M}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},r=typeof Buffer<"u";function a(V,M){if(typeof M>"u")V.write(i.Undefined);else if(typeof M=="string"){const $=C.VSBuffer.fromString(M);V.write(i.String),p(V,$.byteLength),V.write($)}else if(r&&Buffer.isBuffer(M)){const $=C.VSBuffer.wrap(M);V.write(i.Buffer),p(V,$.byteLength),V.write($)}else if(M instanceof C.VSBuffer)V.write(i.VSBuffer),p(V,M.byteLength),V.write(M);else if(Array.isArray(M)){V.write(i.Array),p(V,M.length);for(const $ of M)a(V,$)}else if(typeof M=="number"&&(M|0)===M)V.write(i.Uint),p(V,M);else{const $=C.VSBuffer.fromString(JSON.stringify(M));V.write(i.Object),p(V,$.byteLength),V.write($)}}e.serialize=a;function l(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(f(V)).toString();case o.Buffer:return V.read(f(V)).buffer;case o.VSBuffer:return V.read(f(V));case o.Array:{const $=f(V),G=[];for(let H=0;H<$;H++)G.push(l(V));return G}case o.Object:return JSON.parse(V.read(f(V)).toString());case o.Int:return f(V)}}e.deserialize=l;class d{constructor(M,$,G=null,H=1e3){this.protocol=M,this.ctx=$,this.logger=G,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(x=>this.onRawMessage(x)),this.sendResponse({type:200})}registerChannel(M,$){this.channels.set(M,$),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const $=this.send([M.type]);this.logger?.logOutgoing($,0,1,u(M.type));return}case 201:case 202:case 204:case 203:{const $=this.send([M.type,M.id],M.data);this.logger?.logOutgoing($,M.id,1,u(M.type),M.data);return}}}send(M,$=void 0){const G=new t;return a(G,M),a(G,$),this.sendBuffer(G.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onRawMessage(M){const $=new w(M),G=l($),H=l($),x=G[0];switch(x){case 100:return this.logger?.logIncoming(M.byteLength,G[1],1,`${L(x)}: ${G[2]}.${G[3]}`,H),this.onPromise({type:x,id:G[1],channelName:G[2],name:G[3],arg:H});case 102:return this.logger?.logIncoming(M.byteLength,G[1],1,`${L(x)}: ${G[2]}.${G[3]}`,H),this.onEventListen({type:x,id:G[1],channelName:G[2],name:G[3],arg:H});case 101:return this.logger?.logIncoming(M.byteLength,G[1],1,`${L(x)}`),this.disposeActiveRequest({type:x,id:G[1]});case 103:return this.logger?.logIncoming(M.byteLength,G[1],1,`${L(x)}`),this.disposeActiveRequest({type:x,id:G[1]})}}onPromise(M){const $=this.channels.get(M.channelName);if(!$){this.collectPendingRequest(M);return}const G=new N.CancellationTokenSource;let H;try{H=$.call(this.ctx,M.name,M.arg,G.token)}catch(R){H=Promise.reject(R)}const x=M.id;H.then(R=>{this.sendResponse({id:x,data:R,type:201}),this.activeRequests.delete(M.id)},R=>{R instanceof Error?this.sendResponse({id:x,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.sendResponse({id:x,data:R,type:203}),this.activeRequests.delete(M.id)});const U=(0,c.toDisposable)(()=>G.cancel());this.activeRequests.set(M.id,U)}onEventListen(M){const $=this.channels.get(M.channelName);if(!$){this.collectPendingRequest(M);return}const G=M.id,x=$.listen(this.ctx,M.name,M.arg)(U=>this.sendResponse({id:G,data:U,type:204}));this.activeRequests.set(M.id,x)}disposeActiveRequest(M){const $=this.activeRequests.get(M.id);$&&($.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let $=this.pendingRequests.get(M.channelName);$||($=[],this.pendingRequests.set(M.channelName,$));const G=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:M,timeoutTimer:G})}flushPendingRequests(M){const $=this.pendingRequests.get(M);if($){for(const G of $)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=d;var E;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class k{constructor(M,$=null){this.protocol=M,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=$}getChannel(M){const $=this;return{call(G,H,x){return $.isDisposed?Promise.reject(new I.CancellationError):$.requestPromise(M,G,H,x)},listen(G,H){return $.isDisposed?h.Event.None:$.requestEvent(M,G,H)}}}requestPromise(M,$,G,H=N.CancellationToken.None){const x=this.lastRequestId++,R={id:x,type:100,channelName:M,name:$,arg:G};if(H.isCancellationRequested)return Promise.reject(new I.CancellationError);let s;return new Promise((_,W)=>{if(H.isCancellationRequested)return W(new I.CancellationError);const K=()=>{const pe=ue=>{switch(ue.type){case 201:this.handlers.delete(x),_(ue.data);break;case 202:{this.handlers.delete(x);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,W(ge);break}case 203:this.handlers.delete(x),W(ue.data);break}};this.handlers.set(x,pe),this.sendRequest(R)};let Q=null;this.state===g.Idle?K():(Q=(0,T.createCancelablePromise)(pe=>this.whenInitialized()),Q.then(()=>{Q=null,K()}));const ae=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:x,type:101}),W(new I.CancellationError)},de=H.onCancellationRequested(ae);s=(0,c.combinedDisposable)((0,c.toDisposable)(ae),de),this.activeRequests.add(s)}).finally(()=>{this.activeRequests.delete(s)})}requestEvent(M,$,G){const H=this.lastRequestId++,U={id:H,type:102,channelName:M,name:$,arg:G};let R=null;const s=new h.Emitter({onWillAddFirstListener:()=>{R=(0,T.createCancelablePromise)(_=>this.whenInitialized()),R.then(()=>{R=null,this.activeRequests.add(s),this.sendRequest(U)})},onDidRemoveLastListener:()=>{R?(R.cancel(),R=null):(this.activeRequests.delete(s),this.sendRequest({id:H,type:103}))}}),P=_=>s.fire(_.data);return this.handlers.set(H,P),s.event}sendRequest(M){switch(M.type){case 100:case 102:{const $=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger?.logOutgoing($,M.id,0,`${L(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const $=this.send([M.type,M.id]);this.logger?.logOutgoing($,M.id,0,L(M.type));return}}}send(M,$=void 0){const G=new t;return a(G,M),a(G,$),this.sendBuffer(G.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onBuffer(M){const $=new w(M),G=l($),H=l($),x=G[0];switch(x){case 200:return this.logger?.logIncoming(M.byteLength,0,0,u(x)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(M.byteLength,G[1],0,u(x),H),this.onResponse({type:G[0],id:G[1],data:H})}}onResponse(M){if(M.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(M.id)?.(M)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=k,ve([O.memoize],k.prototype,"onDidInitializePromise",null);class F{get connections(){const M=[];return this._connections.forEach($=>M.push($)),M}constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:$,onDidClientDisconnect:G})=>{h.Event.once($.onMessage)(x=>{const U=new w(x),R=l(U),s=new d($,R),P=new k($);this.channels.forEach((W,K)=>s.registerChannel(K,W));const _={channelServer:s,channelClient:P,ctx:R};this._connections.add(_),this._onDidAddConnection.fire(_),G(()=>{s.dispose(),P.dispose(),this._connections.delete(_),this._onDidRemoveConnection.fire(_)})})})}getChannel(M,$){const G=this;return{call(H,x,U){let R;if((0,m.isFunction)($)){const P=(0,A.getRandomElement)(G.connections.filter($));R=P?Promise.resolve(P):h.Event.toPromise(h.Event.filter(G.onDidAddConnection,$))}else R=$.routeCall(G,H,x);const s=R.then(P=>P.channelClient.getChannel(M));return X(s).call(H,x,U)},listen(H,x){if((0,m.isFunction)($))return G.getMulticastEvent(M,$,H,x);const U=$.routeEvent(G,H,x).then(R=>R.channelClient.getChannel(M));return X(U).listen(H,x)}}}getMulticastEvent(M,$,G,H){const x=this;let U=new c.DisposableStore;const R=new h.Emitter({onWillAddFirstListener:()=>{U=new c.DisposableStore;const s=new h.EventMultiplexer,P=new Map,_=K=>{const ae=K.channelClient.getChannel(M).listen(G,H),de=s.add(ae);P.set(K,de)},W=K=>{const Q=P.get(K);Q&&(Q.dispose(),P.delete(K))};x.connections.filter($).forEach(_),h.Event.filter(x.onDidAddConnection,$)(_,void 0,U),x.onDidRemoveConnection(W,void 0,U),s.event(R.fire,R,U),U.add(s)},onDidRemoveLastListener:()=>{U.dispose()}});return R.event}registerChannel(M,$){this.channels.set(M,$),this._connections.forEach(G=>{G.channelServer.registerChannel(M,$)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=F;class Y{constructor(M,$,G=null){const H=new t;a(H,$),M.send(H.buffer),this.channelClient=new k(M,G),this.channelServer=new d(M,$,G)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,$){this.channelServer.registerChannel(M,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=Y;function X(V){return{call(M,$,G){return V.then(H=>H.call(M,$,G))},listen(M,$){const G=new h.Relay;return V.then(H=>G.input=H.listen(M,$)),G.event}}}e.getDelayedChannel=X;function ee(V){let M=!1;return{call($,G,H){return M?V.call($,G,H):(0,T.timeout)(0).then(()=>M=!0).then(()=>V.call($,G,H))},listen($,G){if(M)return V.listen($,G);const H=new h.Relay;return(0,T.timeout)(0).then(()=>M=!0).then(()=>H.input=V.listen($,G)),H.event}}}e.getNextTickChannel=ee;class le{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const $ of M.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await h.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=le;var re;(function(V){function M(x,U){const R=x,s=U&&U.disableMarshalling,P=new Map;for(const _ in R)G(_)&&P.set(_,h.Event.buffer(R[_],!0));return new class{listen(_,W,K){const Q=P.get(W);if(Q)return Q;if(H(W)){const ae=R[W];if(typeof ae=="function")return ae.call(R,K)}throw new Error(`Event not found: ${W}`)}call(_,W,K){const Q=R[W];if(typeof Q=="function"){if(!s&&Array.isArray(K))for(let ae=0;ae<K.length;ae++)K[ae]=(0,b.revive)(K[ae]);return Q.apply(R,K)}throw new Error(`Method not found: ${W}`)}}}V.fromService=M;function $(x,U){const R=U&&U.disableMarshalling;return new Proxy({},{get(s,P){if(typeof P=="string")return U?.properties?.has(P)?U.properties.get(P):H(P)?function(_){return x.listen(P,_)}:G(P)?x.listen(P):async function(..._){let W;U&&!(0,m.isUndefinedOrNull)(U.context)?W=[U.context,..._]:W=_;const K=await x.call(P,W);return R?K:(0,b.revive)(K)};throw new Error(`Property not found: ${String(P)}`)}})}V.toService=$;function G(x){return x[0]==="o"&&x[1]==="n"&&y.isUpperAsciiLetter(x.charCodeAt(2))}function H(x){return/^onDynamic/.test(x)&&y.isUpperAsciiLetter(x.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const M=V.toString();if(M!=="[object Object]")return M}return V}function se(V){return Array.isArray(V)?V.map(ce):ce(V)}function j(V,M,$,G,H,x,U){U=se(U);const R=fe[H],s=R[G%R.length];let P=[`%c[${V}]%c[${String(M).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${s}`];/\($/.test(x)?(P=P.concat(U),P.push(")")):P.push(U),console.log.apply(console,P)}class B{constructor(M,$){this._outgoingPrefix=M,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,$,G,H,x){this._totalOutgoing+=M,j(this._outgoingPrefix,this._totalOutgoing,M,$,G,H,x)}logIncoming(M,$,G,H,x){this._totalIncoming+=M,j(this._incomingPrefix,this._totalIncoming,M,$,G,H,x)}}e.IPCLogger=B}),define(ie[83],ne([0,1,58,8,14,23,79,9,5,2,30,56,52,57]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class L extends v.ChannelServer{constructor(g){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",f=>C.VSBuffer.wrap(Buffer.from(f,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=L;class D{constructor(g,f){this.modulePath=g,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new T.Delayer(S),this.child=null,this._client=null}getChannel(g){const f=this;return{call(S,p,w){return f.requestPromise(g,S,p,w)},listen(S,p){return f.requestEvent(g,S,p)}}}requestPromise(g,f,S,p=N.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const w=this.getCachedChannel(g),t=(0,T.createCancelablePromise)(i=>w.call(f,S,i)),o=p.onCancellationRequested(()=>t.cancel()),n=(0,c.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(g,f,S){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let p;const w=new h.Emitter({onWillAddFirstListener:()=>{p=this.getCachedChannel(g).listen(f,S)(w.fire,w),this.activeRequests.add(p)},onDidRemoveLastListener:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return w.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(f.env),this.child=(0,A.fork)(this.modulePath,g,f);const S=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,O.isRemoteConsoleLog)(r)){(0,O.log)(r,`IPC Library: ${this.options.serverName}`);return}S.fire(C.VSBuffer.wrap(Buffer.from(r,"base64")))});const w=this.options.useQueue?(0,y.createQueuedSender)(this.child):this.child,t=r=>this.child&&this.child.connected&&w.send(r.buffer.toString("base64")),o=S.event,n={send:t,onMessage:o};this._client=new v.ChannelClient(n);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,a)=>{process.removeListener("exit",i),this.activeRequests.forEach(l=>(0,c.dispose)(l)),this.activeRequests.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:a})})}return this._client}getCachedChannel(g){let f=this.channels.get(g);return f||(f=this.client.getChannel(g),this.channels.set(g,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=D}),define(ie[84],ne([0,1,8,5,2,3]),function(q,e,A,T,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var O;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function I(y){const m=y;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var h;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(h||(e.StorageState=h={}));class c extends C.Disposable{constructor(m,v=Object.create(null)){super(),this.database=m,this.options=v,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(c.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((v,L)=>this.accept(L,v)),m.deleted?.forEach(v=>this.accept(v,void 0))}accept(m,v){if(this.state===h.Closed)return;let L=!1;(0,N.isUndefinedOrNull)(v)?L=this.cache.delete(m):this.cache.get(m)!==v&&(this.cache.set(m,v),L=!0),L&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,v){const L=this.cache.get(m);return(0,N.isUndefinedOrNull)(L)?v:L}getBoolean(m,v){const L=this.get(m);return(0,N.isUndefinedOrNull)(L)?v:L==="true"}getNumber(m,v){const L=this.get(m);return(0,N.isUndefinedOrNull)(L)?v:parseInt(L,10)}async set(m,v){if(this.state===h.Closed)return;if((0,N.isUndefinedOrNull)(v))return this.delete(m);const L=String(v);if(this.cache.get(m)!==L)return this.cache.set(m,L),this.pendingInserts.set(m,L),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===h.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}isInMemory(){return this.options.hint===O.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=c,c.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((v,L)=>this.items.set(L,v)),m.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=b}),define(ie[85],ne([7,4]),function(q,e){return q.create("vs/base/node/zip",e)}),define(ie[86],ne([7,4]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[87],ne([7,4]),function(q,e){return q.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[88],ne([7,4]),function(q,e){return q.create("vs/platform/contextkey/common/scanner",e)}),define(ie[89],ne([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[90],ne([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[91],ne([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[92],ne([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[93],ne([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[94],ne([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[95],ne([7,4]),function(q,e){return q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[96],ne([7,4]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[97],ne([7,4]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(ie[98],ne([7,4]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(ie[99],ne([7,4]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[100],ne([7,4]),function(q,e){return q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[101],ne([7,4]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(ie[102],ne([7,4]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(ie[103],ne([7,4]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[104],ne([7,4]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[105],ne([7,4]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(ie[106],ne([0,1,9,88]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var C;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(C||(e.TokenType=C={}));function N(...c){switch(c.length){case 1:return(0,T.localize)(0,null,c[0]);case 2:return(0,T.localize)(1,null,c[0],c[1]);case 3:return(0,T.localize)(2,null,c[0],c[1],c[2]);default:return}}const O=(0,T.localize)(3,null),I=(0,T.localize)(4,null);class h{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,A.illegalState)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(b){return this._input=b,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const y=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:y})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const y=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:y})}else this._match(126)?this._addToken(9):this._error(N("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(N("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(b){return this._isAtEnd()||this._input.charCodeAt(this._current)!==b?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(b){this._tokens.push({type:b,offset:this._start})}_error(b){const y=this._start,m=this._input.substring(this._start,this._current),v={type:19,offset:this._start,lexeme:m};this._errors.push({offset:y,lexeme:m,additionalInfo:b}),this._tokens.push(v)}_string(){this.stringRe.lastIndex=this._start;const b=this.stringRe.exec(this._input);if(b){this._current=this._start+b[0].length;const y=this._input.substring(this._start,this._current),m=h._keywords.get(y);m?this._addToken(m):this._tokens.push({type:17,lexeme:y,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(O);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let b=this._current,y=!1,m=!1;for(;;){if(b>=this._input.length){this._current=b,this._error(I);return}const L=this._input.charCodeAt(b);if(y)y=!1;else if(L===47&&!m){b++;break}else L===91?m=!0:L===92?y=!0:L===93&&(m=!1);b++}for(;b<this._input.length&&h._regexFlags.has(this._input.charCodeAt(b));)b++;this._current=b;const v=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:v,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=h,h._regexFlags=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0))),h._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ie[107],ne([0,1,75,50,16,15,37,17,11]),function(q,e,A,T,C,N,O,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,N.dirname)(C.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,N.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const v=(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.join)(this.userDataPath,"logs",v)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(h.URI.file((0,N.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=O.env.VSCODE_PORTABLE;return v?h.URI.file((0,N.join)(v,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,N.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,N.resolve)(v):(0,N.normalize)((0,N.join)(C.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?h.URI.file((0,N.resolve)(v)):h.URI.file((0,N.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,N.resolve)(v);const L=O.env.VSCODE_EXTENSIONS;if(L)return L;const D=O.env.VSCODE_PORTABLE;return D?(0,N.join)(D,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(L=>/^[^:/?#]+?:\/\//.test(L)?h.URI.parse(L):h.URI.file((0,N.normalize)(L)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?h.URI.parse(v):h.URI.file((0,N.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const L of this.args.log||[]){const D=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(L);D&&D[1]&&D[2]&&v.push([D[1],D[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=O.env.VSCODE_PORTABLE;return v?h.URI.file((0,N.join)(v,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this._args}constructor(v,L,D){this._args=v,this.paths=L,this.productService=D,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=c,ve([T.memoize],c.prototype,"appRoot",null),ve([T.memoize],c.prototype,"userHome",null),ve([T.memoize],c.prototype,"userDataPath",null),ve([T.memoize],c.prototype,"appSettingsHome",null),ve([T.memoize],c.prototype,"tmpDir",null),ve([T.memoize],c.prototype,"cacheHome",null),ve([T.memoize],c.prototype,"stateResource",null),ve([T.memoize],c.prototype,"userRoamingDataHome",null),ve([T.memoize],c.prototype,"userDataSyncHome",null),ve([T.memoize],c.prototype,"sync",null),ve([T.memoize],c.prototype,"machineSettingsResource",null),ve([T.memoize],c.prototype,"workspaceStorageHome",null),ve([T.memoize],c.prototype,"localHistoryHome",null),ve([T.memoize],c.prototype,"keyboardLayoutResource",null),ve([T.memoize],c.prototype,"argvResource",null),ve([T.memoize],c.prototype,"isExtensionDevelopment",null),ve([T.memoize],c.prototype,"untitledWorkspacesHome",null),ve([T.memoize],c.prototype,"builtinExtensionsPath",null),ve([T.memoize],c.prototype,"extensionsPath",null),ve([T.memoize],c.prototype,"extensionDevelopmentLocationURI",null),ve([T.memoize],c.prototype,"extensionDevelopmentKind",null),ve([T.memoize],c.prototype,"extensionTestsLocationURI",null),ve([T.memoize],c.prototype,"debugExtensionHost",null),ve([T.memoize],c.prototype,"logLevel",null),ve([T.memoize],c.prototype,"extensionLogLevel",null),ve([T.memoize],c.prototype,"serviceMachineIdResource",null),ve([T.memoize],c.prototype,"disableTelemetry",null),ve([T.memoize],c.prototype,"disableWorkspaceTrust",null),ve([T.memoize],c.prototype,"policyFile",null);function b(m,v){return y(m["inspect-extensions"],m["inspect-brk-extensions"],5870,v,m.debugId,m.extensionEnvironment)}e.parseExtensionHostDebugPort=b;function y(m,v,L,D,u,g){const S=Number(v||m)||(D?null:L),p=S?!!v:!1;let w;if(g)try{w=JSON.parse(g)}catch{}return{port:S,break:p,debugId:u,env:w}}e.parseDebugParams=y}),define(ie[108],ne([0,1,36,107,160]),function(q,e,A,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class N extends T.AbstractNativeEnvironmentService{constructor(c,b){super(c,{homeDir:(0,A.homedir)(),tmpDir:(0,A.tmpdir)(),userDataDir:(0,C.getUserDataPath)(c,b.nameShort)},b)}}e.NativeEnvironmentService=N;function O(h,c){return(0,T.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.parsePtyHostDebugPort=O;function I(h,c){return(0,T.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.parseSharedProcessDebugPort=I}),define(ie[109],ne([0,1,3,92]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function C(O,I,h){try{N(O,I,h)}catch(c){console.error(c?.message??c)}return O}e.localizeManifest=C;function N(O,I,h){const c=(b,y,m)=>{const v=b[y];if((0,A.isString)(v)){const L=v,D=L.length;if(D>1&&L[0]==="%"&&L[D-1]==="%"){const u=L.substr(1,D-2);let g=I[u];g===void 0&&h&&(g=h[u]);const f=typeof g=="string"?g:g?.message,S=h?.[u],p=typeof S=="string"?S:S?.message;if(!f){p||console.warn(`[${O.name}]: ${(0,T.localize)(0,null,u)}`);return}if(m&&(y==="title"||y==="category")&&p&&p!==f){const w={value:f,original:p};b[y]=w}else b[y]=f}}else if((0,A.isObject)(v))for(const L in v)v.hasOwnProperty(L)&&(L==="commands"?c(v,L,!0):c(v,L,m));else if(Array.isArray(v))for(let L=0;L<v.length;L++)c(v,L,m)};for(const b in O)O.hasOwnProperty(b)&&c(O,b)}}),define(ie[46],ne([0,1,17,53,96,41]),function(q,e,A,T,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function h(g){return g=g.trim(),g==="*"||O.test(g)}e.isValidVersionStr=h;function c(g){if(!h(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=g.match(O);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=c;function b(g){if(!g)return null;const f=g.majorBase,S=g.majorMustEqual,p=g.minorBase;let w=g.minorMustEqual;const t=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(f===0||(w=!1),o=!1);let n=0;if(g.preRelease){const i=I.exec(g.preRelease);if(i){const[,r,a,l]=i;n=Date.UTC(Number(r),Number(a)-1,Number(l))}}return{majorBase:f,majorMustEqual:S,minorBase:p,minorMustEqual:w,patchBase:t,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:n}}e.normalizeVersion=b;function y(g,f,S){let p;typeof g=="string"?p=b(c(g)):p=g;let w;f instanceof Date?w=f.getTime():typeof f=="string"&&(w=new Date(f).getTime());let t;if(typeof S=="string"?t=b(c(S)):t=S,!p||!t)return!1;const o=p.majorBase,n=p.minorBase,i=p.patchBase;let r=t.majorBase,a=t.minorBase,l=t.patchBase;const d=t.notBefore;let E=t.majorMustEqual,k=t.minorMustEqual,F=t.patchMustEqual;return t.isMinimum?o>r?!0:o<r?!1:n>a?!0:n<a||w&&w<d?!1:i>=l:(o===1&&r===0&&(!E||!k||!F)&&(r=1,a=0,l=0,E=!0,k=!1,F=!1),o<r?!1:o>r?!E:n<a?!1:n>a?!k:i<l?!1:i>l?!F:!(w&&w<d))}e.isValidVersion=y;function m(g,f,S,p,w){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([T.default.Error,C.localize(0,null)]),t;if(typeof p.name!="string")return t.push([T.default.Error,C.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([T.default.Error,C.localize(2,null,"version")]),t;if(!p.engines)return t.push([T.default.Error,C.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([T.default.Error,C.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!u(p.extensionDependencies))return t.push([T.default.Error,C.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!u(p.activationEvents))return t.push([T.default.Error,C.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([T.default.Error,C.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([T.default.Warning,C.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([T.default.Error,C.localize(9,null,"main")]),t;{const i=(0,A.joinPath)(S,p.main);(0,A.isEqualOrParent)(i,S)||t.push([T.default.Warning,C.localize(10,null,i.path,S.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([T.default.Error,C.localize(11,null,"browser")]),t;{const i=(0,A.joinPath)(S,p.browser);(0,A.isEqualOrParent)(i,S)||t.push([T.default.Warning,C.localize(12,null,i.path,S.path)])}}if(!N.valid(p.version))return t.push([T.default.Error,C.localize(13,null)]),t;const o=[];if(!v(g,f,p,w,o))for(const i of o)t.push([T.default.Error,i]);return t}e.validateExtensionManifest=m;function v(g,f,S,p,w){return p||typeof S.main>"u"&&typeof S.browser>"u"?!0:D(g,f,S.engines.vscode,w)}e.isValidExtensionVersion=v;function L(g,f,S){return g==="*"||D(f,S,g)}e.isEngineValid=L;function D(g,f,S,p=[]){const w=b(c(S));if(!w)return p.push(C.localize(14,null,S)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return p.push(C.localize(15,null,S)),!1}else if(!w.majorMustEqual)return p.push(C.localize(16,null,S)),!1;return y(g,f,w)?!0:(p.push(C.localize(17,null,g,S)),!1)}function u(g){if(!Array.isArray(g))return!1;for(let f=0,S=g.length;f<S;f++)if(typeof g[f]!="string")return!1;return!0}}),define(ie[110],ne([0,1,14,28]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function C(N,O,I){let h=I&&I.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const b=(await O.readFile(N.serviceMachineIdResource)).value.toString();h=(0,T.isUUID)(b)?b:null}catch{h=null}if(!h){h=(0,T.generateUuid)();try{await O.writeFile(N.serviceMachineIdResource,A.VSBuffer.fromString(h))}catch{}}return I?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=C}),define(ie[47],ne([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class A{constructor(C,N=[],O=!1){this.ctor=C,this.staticArguments=N,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=A}),define(ie[111],ne([0,1,47]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var C;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function N(I,h,c){h instanceof A.SyncDescriptor||(h=new A.SyncDescriptor(h,[],!!c)),T.push([I,h])}e.registerSingleton=N;function O(){return T}e.getSingletonServiceDescriptors=O}),define(ie[112],ne([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class A{constructor(N,O){this.key=N,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=A;class T{constructor(N){this._hashFn=N,this._nodes=new Map}roots(){const N=[];for(const O of this._nodes.values())O.outgoing.size===0&&N.push(O);return N}insertEdge(N,O){const I=this.lookupOrInsertNode(N),h=this.lookupOrInsertNode(O);I.outgoing.set(h.key,h),h.incoming.set(I.key,I)}removeNode(N){const O=this._hashFn(N);this._nodes.delete(O);for(const I of this._nodes.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(N){const O=this._hashFn(N);let I=this._nodes.get(O);return I||(I=new A(O,N),this._nodes.set(O,I)),I}lookup(N){return this._nodes.get(this._hashFn(N))}isEmpty(){return this._nodes.size===0}toString(){const N=[];for(const[O,I]of this._nodes)N.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,O]of this._nodes){const I=new Set([N]),h=this._findCycle(O,I);if(h)return h}}_findCycle(N,O){for(const[I,h]of N.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const c=this._findCycle(h,O);if(c)return c;O.delete(I)}}}e.Graph=T}),define(ie[24],ne([0,1,3,11,10]),function(q,e,A,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function N(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof T.URI)}e.isConfigurationOverrides=N;function O(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=O;var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function h(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function c(u,g){const f=Object.create(null);for(const S in u)b(f,S,u[S],g);return f}e.toValuesTree=c;function b(u,g,f,S){const p=g.split("."),w=p.pop();let t=u;for(let o=0;o<p.length;o++){const n=p[o];let i=t[n];switch(typeof i){case"undefined":i=t[n]=Object.create(null);break;case"object":break;default:S(`Ignoring ${g} as ${p.slice(0,o+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[w]=f}catch{S(`Ignoring ${g} as ${p.join(".")} is ${JSON.stringify(t)}`)}else S(`Ignoring ${g} as ${p.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=b;function y(u,g){const f=g.split(".");m(u,f)}e.removeFromValueTree=y;function m(u,g){const f=g.shift();if(g.length===0){delete u[f];return}if(Object.keys(u).indexOf(f)!==-1){const S=u[f];typeof S=="object"&&!Array.isArray(S)&&(m(S,g),Object.keys(S).length===0&&delete u[f])}}function v(u,g,f){function S(t,o){let n=t;for(const i of o){if(typeof n!="object"||n===null)return;n=n[i]}return n}const p=g.split("."),w=S(u,p);return typeof w>"u"?f:w}e.getConfigurationValue=v;function L(u,g,f){Object.keys(g).forEach(S=>{S!=="__proto__"&&(S in u?A.isObject(u[S])&&A.isObject(g[S])?L(u[S],g[S],f):f&&(u[S]=g[S]):u[S]=g[S])})}e.merge=L;function D(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=D}),define(ie[113],ne([0,1,12,29,106,10,87,9]),function(q,e,A,T,C,N,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",A.isMacintosh),h.set("isLinux",A.isLinux),h.set("isWindows",A.isWindows),h.set("isWeb",A.isWeb),h.set("isMacNative",A.isMacintosh&&!A.isWeb),h.set("isEdge",A.isEdge),h.set("isFirefox",A.isFirefox),h.set("isChrome",A.isChrome),h.set("isSafari",A.isSafari);function c(R,s){if(h.get(R)!==void 0)throw(0,I.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(R,s)}e.setConstant=c;const b=Object.prototype.hasOwnProperty;var y;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const m={regexParsingWithErrorRecovery:!0},v=(0,O.localize)(0,null),L=(0,O.localize)(1,null),D=(0,O.localize)(2,null),u=(0,O.localize)(3,null),g=(0,O.localize)(4,null),f=(0,O.localize)(5,null),S=(0,O.localize)(6,null),p=(0,O.localize)(7,null);class w{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(s=m){this._config=s,this._scanner=new C.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(s){if(s===""){this._parsingErrors.push({message:v,offset:0,lexeme:"",additionalInfo:L});return}this._tokens=this._scanner.reset(s).scan(),this._current=0,this._parsingErrors=[];try{const P=this._expr();if(!this._isAtEnd()){const _=this._peek(),W=_.type===17?f:void 0;throw this._parsingErrors.push({message:g,offset:_.offset,lexeme:C.Scanner.getLexeme(_),additionalInfo:W}),w._parseError}return P}catch(P){if(P!==w._parseError)throw P;return}}_expr(){return this._or()}_or(){const s=[this._and()];for(;this._matchOne(16);){const P=this._and();s.push(P)}return s.length===1?s[0]:t.or(...s)}_and(){const s=[this._term()];for(;this._matchOne(15);){const P=this._term();s.push(P)}return s.length===1?s[0]:t.and(...s)}_term(){if(this._matchOne(2)){const s=this._peek();switch(s.type){case 11:return this._advance(),r.INSTANCE;case 12:return this._advance(),a.INSTANCE;case 0:{this._advance();const P=this._expr();return this._consume(1,u),P?.negate()}case 17:return this._advance(),Y.create(s.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",s)}}return this._primary()}_primary(){const s=this._peek();switch(s.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const P=this._expr();return this._consume(1,u),P}case 17:{const P=s.lexeme;if(this._advance(),this._matchOne(9)){const W=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),W.type!==10)throw this._errExpectedButGot("REGEX",W);const K=W.lexeme,Q=K.lastIndexOf("/"),ae=Q===K.length-1?void 0:this._removeFlagsGY(K.substring(Q+1));let de;try{de=new RegExp(K.substring(1,Q),ae)}catch{throw this._errExpectedButGot("REGEX",W)}return ce.create(P,de)}switch(W.type){case 10:case 19:{const K=[W.lexeme];this._advance();let Q=this._peek(),ae=0;for(let oe=0;oe<W.lexeme.length;oe++)W.lexeme.charCodeAt(oe)===40?ae++:W.lexeme.charCodeAt(oe)===41&&ae--;for(;!this._isAtEnd()&&Q.type!==15&&Q.type!==16;){switch(Q.type){case 0:ae++;break;case 1:ae--;break;case 10:case 18:for(let oe=0;oe<Q.lexeme.length;oe++)Q.lexeme.charCodeAt(oe)===40?ae++:W.lexeme.charCodeAt(oe)===41&&ae--}if(ae<0)break;K.push(C.Scanner.getLexeme(Q)),this._advance(),Q=this._peek()}const de=K.join(""),pe=de.lastIndexOf("/"),ue=pe===de.length-1?void 0:this._removeFlagsGY(de.substring(pe+1));let ge;try{ge=new RegExp(de.substring(1,pe),ue)}catch{throw this._errExpectedButGot("REGEX",W)}return t.regex(P,ge)}case 18:{const K=W.lexeme;this._advance();let Q=null;if(!(0,T.isFalsyOrWhitespace)(K)){const ae=K.indexOf("/"),de=K.lastIndexOf("/");if(ae!==de&&ae>=0){const pe=K.slice(ae+1,de),ue=K[de+1]==="i"?"i":"";try{Q=new RegExp(pe,ue)}catch{throw this._errExpectedButGot("REGEX",W)}}}if(Q===null)throw this._errExpectedButGot("REGEX",W);return ce.create(P,Q)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,D);const W=this._value();return t.notIn(P,W)}switch(this._peek().type){case 3:{this._advance();const W=this._value();if(this._previous().type===18)return t.equals(P,W);switch(W){case"true":return t.has(P);case"false":return t.not(P);default:return t.equals(P,W)}}case 4:{this._advance();const W=this._value();if(this._previous().type===18)return t.notEquals(P,W);switch(W){case"true":return t.not(P);case"false":return t.has(P);default:return t.notEquals(P,W)}}case 5:return this._advance(),re.create(P,this._value());case 6:return this._advance(),fe.create(P,this._value());case 7:return this._advance(),ee.create(P,this._value());case 8:return this._advance(),le.create(P,this._value());case 13:return this._advance(),t.in(P,this._value());default:return t.has(P)}}case 20:throw this._parsingErrors.push({message:S,offset:s.offset,lexeme:"",additionalInfo:p}),w._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const s=this._peek();switch(s.type){case 17:case 18:return this._advance(),s.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(s){return s.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(s){return this._check(s)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(s,P){if(this._check(s))return this._advance();throw this._errExpectedButGot(P,this._peek())}_errExpectedButGot(s,P,_){const W=(0,O.localize)(8,null,s,C.Scanner.getLexeme(P)),K=P.offset,Q=C.Scanner.getLexeme(P);return this._parsingErrors.push({message:W,offset:K,lexeme:Q,additionalInfo:_}),w._parseError}_check(s){return this._peek().type===s}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=w,w._parseError=new Error;class t{static false(){return r.INSTANCE}static true(){return a.INSTANCE}static has(s){return l.create(s)}static equals(s,P){return d.create(s,P)}static notEquals(s,P){return F.create(s,P)}static regex(s,P){return ce.create(s,P)}static in(s,P){return E.create(s,P)}static notIn(s,P){return k.create(s,P)}static not(s){return Y.create(s)}static and(...s){return B.create(s,null,!0)}static or(...s){return V.create(s,null,!0)}static greater(s,P){return ee.create(s,P)}static greaterEquals(s,P){return le.create(s,P)}static smaller(s,P){return re.create(s,P)}static smallerEquals(s,P){return fe.create(s,P)}static deserialize(s){return s==null?void 0:this._parser.parse(s)}}e.ContextKeyExpr=t,t._parser=new w({regexParsingWithErrorRecovery:!1});function o(R){const s=new w({regexParsingWithErrorRecovery:!1});return R.map(P=>(s.parse(P),s.lexingErrors.length>0?s.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,O.localize)(9,null,_.additionalInfo):(0,O.localize)(10,null),offset:_.offset,length:_.lexeme.length})):s.parsingErrors.length>0?s.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}e.validateWhenClauses=o;function n(R,s){const P=R?R.substituteConstants():void 0,_=s?s.substituteConstants():void 0;return!P&&!_?!0:!P||!_?!1:P.equals(_)}e.expressionsAreEqualWithConstantSubstitution=n;function i(R,s){return R.cmp(s)}class r{constructor(){this.type=0}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!1}serialize(){return"false"}keys(){return[]}map(s){return this}negate(){return a.INSTANCE}}e.ContextKeyFalseExpr=r,r.INSTANCE=new r;class a{constructor(){this.type=1}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!0}serialize(){return"true"}keys(){return[]}map(s){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=a,a.INSTANCE=new a;class l{static create(s,P=null){const _=h.get(s);return typeof _=="boolean"?_?a.INSTANCE:r.INSTANCE:new l(s,P)}constructor(s,P){this.key=s,this.negated=P,this.type=2}cmp(s){return s.type!==this.type?this.type-s.type:$(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}substituteConstants(){const s=h.get(this.key);return typeof s=="boolean"?s?a.INSTANCE:r.INSTANCE:this}evaluate(s){return!!s.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(s){return s.mapDefined(this.key)}negate(){return this.negated||(this.negated=Y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=l;class d{static create(s,P,_=null){if(typeof P=="boolean")return P?l.create(s,_):Y.create(s,_);const W=h.get(s);return typeof W=="boolean"?P===(W?"true":"false")?a.INSTANCE:r.INSTANCE:new d(s,P,_)}constructor(s,P,_){this.key=s,this.value=P,this.negated=_,this.type=4}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){const s=h.get(this.key);if(typeof s=="boolean"){const P=s?"true":"false";return this.value===P?a.INSTANCE:r.INSTANCE}return this}evaluate(s){return s.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(s){return s.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class E{static create(s,P){return new E(s,P)}constructor(s,P){this.key=s,this.valueKey=P,this.type=10,this.negated=null}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.valueKey,s.key,s.valueKey)}equals(s){return s.type===this.type?this.key===s.key&&this.valueKey===s.valueKey:!1}substituteConstants(){return this}evaluate(s){const P=s.getValue(this.valueKey),_=s.getValue(this.key);return Array.isArray(P)?P.includes(_):typeof _=="string"&&typeof P=="object"&&P!==null?b.call(P,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(s){return s.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=k.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=E;class k{static create(s,P){return new k(s,P)}constructor(s,P){this.key=s,this.valueKey=P,this.type=11,this._negated=E.create(s,P)}cmp(s){return s.type!==this.type?this.type-s.type:this._negated.cmp(s._negated)}equals(s){return s.type===this.type?this._negated.equals(s._negated):!1}substituteConstants(){return this}evaluate(s){return!this._negated.evaluate(s)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(s){return s.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=k;class F{static create(s,P,_=null){if(typeof P=="boolean")return P?Y.create(s,_):l.create(s,_);const W=h.get(s);return typeof W=="boolean"?P===(W?"true":"false")?r.INSTANCE:a.INSTANCE:new F(s,P,_)}constructor(s,P,_){this.key=s,this.value=P,this.negated=_,this.type=5}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){const s=h.get(this.key);if(typeof s=="boolean"){const P=s?"true":"false";return this.value===P?r.INSTANCE:a.INSTANCE}return this}evaluate(s){return s.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(s){return s.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=F;class Y{static create(s,P=null){const _=h.get(s);return typeof _=="boolean"?_?r.INSTANCE:a.INSTANCE:new Y(s,P)}constructor(s,P){this.key=s,this.negated=P,this.type=3}cmp(s){return s.type!==this.type?this.type-s.type:$(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}substituteConstants(){const s=h.get(this.key);return typeof s=="boolean"?s?r.INSTANCE:a.INSTANCE:this}evaluate(s){return!s.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(s){return s.mapNot(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=Y;function X(R,s){if(typeof R=="string"){const P=parseFloat(R);isNaN(P)||(R=P)}return typeof R=="string"||typeof R=="number"?s(R):r.INSTANCE}class ee{static create(s,P,_=null){return X(P,W=>new ee(s,W,_))}constructor(s,P,_){this.key=s,this.value=P,this.negated=_,this.type=12}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){return this}evaluate(s){return typeof this.value=="string"?!1:parseFloat(s.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=fe.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=ee;class le{static create(s,P,_=null){return X(P,W=>new le(s,W,_))}constructor(s,P,_){this.key=s,this.value=P,this.negated=_,this.type=13}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){return this}evaluate(s){return typeof this.value=="string"?!1:parseFloat(s.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=re.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=le;class re{static create(s,P,_=null){return X(P,W=>new re(s,W,_))}constructor(s,P,_){this.key=s,this.value=P,this.negated=_,this.type=14}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){return this}evaluate(s){return typeof this.value=="string"?!1:parseFloat(s.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=le.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=re;class fe{static create(s,P,_=null){return X(P,W=>new fe(s,W,_))}constructor(s,P,_){this.key=s,this.value=P,this.negated=_,this.type=15}cmp(s){return s.type!==this.type?this.type-s.type:G(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}substituteConstants(){return this}evaluate(s){return typeof this.value=="string"?!1:parseFloat(s.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ee.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=fe;class ce{static create(s,P){return new ce(s,P)}constructor(s,P){this.key=s,this.regexp=P,this.type=7,this.negated=null}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.key<s.key)return-1;if(this.key>s.key)return 1;const P=this.regexp?this.regexp.source:"",_=s.regexp?s.regexp.source:"";return P<_?-1:P>_?1:0}equals(s){if(s.type===this.type){const P=this.regexp?this.regexp.source:"",_=s.regexp?s.regexp.source:"";return this.key===s.key&&P===_}return!1}substituteConstants(){return this}evaluate(s){const P=s.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const s=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${s}`}keys(){return[this.key]}map(s){return s.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=se.create(this)),this.negated}}e.ContextKeyRegexExpr=ce;class se{static create(s){return new se(s)}constructor(s){this._actual=s,this.type=8}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}substituteConstants(){return this}evaluate(s){return!this._actual.evaluate(s)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(s){return new se(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=se;function j(R){let s=null;for(let P=0,_=R.length;P<_;P++){const W=R[P].substituteConstants();if(R[P]!==W&&s===null){s=[];for(let K=0;K<P;K++)s[K]=R[K]}s!==null&&(s[P]=W)}return s===null?R:s}class B{static create(s,P,_){return B._normalizeArr(s,P,_)}constructor(s,P){this.expr=s,this.negated=P,this.type=6}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const W=i(this.expr[P],s.expr[P]);if(W!==0)return W}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(s.expr[P]))return!1;return!0}return!1}substituteConstants(){const s=j(this.expr);return s===this.expr?this:B.create(s,this.negated,!1)}evaluate(s){for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].evaluate(s))return!1;return!0}static _normalizeArr(s,P,_){const W=[];let K=!1;for(const Q of s)if(Q){if(Q.type===1){K=!0;continue}if(Q.type===0)return r.INSTANCE;if(Q.type===6){W.push(...Q.expr);continue}W.push(Q)}if(W.length===0&&K)return a.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(i);for(let Q=1;Q<W.length;Q++)W[Q-1].equals(W[Q])&&(W.splice(Q,1),Q--);if(W.length===1)return W[0];for(;W.length>1;){const Q=W[W.length-1];if(Q.type!==9)break;W.pop();const ae=W.pop(),de=W.length===0,pe=V.create(Q.expr.map(ue=>B.create([ue,ae],null,_)),null,de);pe&&(W.push(pe),W.sort(i))}if(W.length===1)return W[0];if(_){for(let Q=0;Q<W.length;Q++)for(let ae=Q+1;ae<W.length;ae++)if(W[Q].negate().equals(W[ae]))return r.INSTANCE;if(W.length===1)return W[0]}return new B(W,P)}}serialize(){return this.expr.map(s=>s.serialize()).join(" && ")}keys(){const s=[];for(const P of this.expr)s.push(...P.keys());return s}map(s){return new B(this.expr.map(P=>P.map(s)),null)}negate(){if(!this.negated){const s=[];for(const P of this.expr)s.push(P.negate());this.negated=V.create(s,this,!0)}return this.negated}}e.ContextKeyAndExpr=B;class V{static create(s,P,_){return V._normalizeArr(s,P,_)}constructor(s,P){this.expr=s,this.negated=P,this.type=9}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const W=i(this.expr[P],s.expr[P]);if(W!==0)return W}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(s.expr[P]))return!1;return!0}return!1}substituteConstants(){const s=j(this.expr);return s===this.expr?this:V.create(s,this.negated,!1)}evaluate(s){for(let P=0,_=this.expr.length;P<_;P++)if(this.expr[P].evaluate(s))return!0;return!1}static _normalizeArr(s,P,_){let W=[],K=!1;if(s){for(let Q=0,ae=s.length;Q<ae;Q++){const de=s[Q];if(de){if(de.type===0){K=!0;continue}if(de.type===1)return a.INSTANCE;if(de.type===9){W=W.concat(de.expr);continue}W.push(de)}}if(W.length===0&&K)return r.INSTANCE;W.sort(i)}if(W.length!==0){if(W.length===1)return W[0];for(let Q=1;Q<W.length;Q++)W[Q-1].equals(W[Q])&&(W.splice(Q,1),Q--);if(W.length===1)return W[0];if(_){for(let Q=0;Q<W.length;Q++)for(let ae=Q+1;ae<W.length;ae++)if(W[Q].negate().equals(W[ae]))return a.INSTANCE;if(W.length===1)return W[0]}return new V(W,P)}}serialize(){return this.expr.map(s=>s.serialize()).join(" || ")}keys(){const s=[];for(const P of this.expr)s.push(...P.keys());return s}map(s){return new V(this.expr.map(P=>P.map(s)),null)}negate(){if(!this.negated){const s=[];for(const P of this.expr)s.push(P.negate());for(;s.length>1;){const P=s.shift(),_=s.shift(),W=[];for(const K of U(P))for(const Q of U(_))W.push(B.create([K,Q],null,!1));s.unshift(V.create(W,null,!1))}this.negated=V.create(s,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class M extends l{static all(){return M._info.values()}constructor(s,P,_){super(s,null),this._defaultValue=P,typeof _=="object"?M._info.push({..._,key:s}):_!==!0&&M._info.push({key:s,description:_,type:P!=null?typeof P:void 0})}bindTo(s){return s.createKey(this.key,this._defaultValue)}getValue(s){return s.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(s){return d.create(this.key,s)}notEqualsTo(s){return F.create(this.key,s)}}e.RawContextKey=M,M._info=[],e.IContextKeyService=(0,N.createDecorator)("contextKeyService");function $(R,s){return R<s?-1:R>s?1:0}function G(R,s,P,_){return R<P?-1:R>P?1:s<_?-1:s>_?1:0}function H(R,s){if(R.type===0||s.type===1)return!0;if(R.type===9)return s.type===9?x(R.expr,s.expr):!1;if(s.type===9){for(const P of s.expr)if(H(R,P))return!0;return!1}if(R.type===6){if(s.type===6)return x(s.expr,R.expr);for(const P of R.expr)if(H(P,s))return!0;return!1}return R.equals(s)}e.implies=H;function x(R,s){let P=0,_=0;for(;P<R.length&&_<s.length;){const W=R[P].cmp(s[_]);if(W<0)return!1;W===0&&P++,_++}return P===R.length}function U(R){return R.type===9?R.expr:[R]}}),define(ie[59],ne([0,1,10]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,A.createDecorator)("downloadService")}),define(ie[18],ne([0,1,10]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,A.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,A.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[20],ne([0,1,90,10]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function C(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function N(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function O(f,S){switch(f){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function I(f,S){return S==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function h(f,S,p){return I(S,p)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===p?!0:c(p).includes(f)}e.isTargetPlatformCompatible=h;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=b;var y;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var m;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var v;(function(f){f.Install="install",f.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var L;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(L||(e.InstallOperation=L={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var D;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(D||(e.ExtensionManagementErrorCode=D={}));var u;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class g extends Error{constructor(S,p){super(S),this.code=p,this.name=p}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,A.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,A.localize)(1,null),original:"Preferences"}}),define(ie[60],ne([0,1,10]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,A.createDecorator)("IExtensionSignatureVerificationService");class T{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((N,O)=>q(["node-vsce-sign"],async I=>N(I),O))),this.moduleLoadingPromise}async verify(N,O,I){let h;try{h=await this.vsceSign()}catch{return!1}return h.verify(N,O,I)}}e.ExtensionSignatureVerificationService=T}),define(ie[61],ne([0,1,14,9,98,13]),function(q,e,A,T,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(b,y,m,v,L,D){let u;try{await I(b,y,m,v,L,D)}catch(g){u=g}finally{u&&L.errorTransformer&&(u=L.errorTransformer(u)),typeof u<"u"&&m.error(u),m.end()}}e.readFileIntoStream=O;async function I(b,y,m,v,L,D){h(D);const u=await b.open(y,{create:!1});try{h(D);let g=0,f=0,S=L&&typeof L.length=="number"?L.length:void 0,p=A.VSBuffer.alloc(Math.min(L.bufferSize,typeof S=="number"?S:L.bufferSize)),w=L&&typeof L.position=="number"?L.position:0,t=0;do f=await b.read(u,w,p.buffer,t,p.byteLength-t),w+=f,t+=f,g+=f,typeof S=="number"&&(S-=f),t===p.byteLength&&(await m.write(v(p)),p=A.VSBuffer.alloc(Math.min(L.bufferSize,typeof S=="number"?S:L.bufferSize)),t=0);while(f>0&&(typeof S!="number"||S>0)&&h(D)&&c(g,L));if(t>0){let o=t;typeof S=="number"&&(o=Math.min(t,S)),m.write(v(p.slice(0,o)))}}catch(g){throw(0,N.ensureFileSystemProviderError)(g)}finally{await b.close(u)}}function h(b){if(b.isCancellationRequested)throw(0,T.canceled)();return!0}function c(b,y){if(typeof y?.limits?.size=="number"&&b>y.limits.size)throw(0,N.createFileSystemProviderError)((0,C.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[114],ne([0,1,5,161,2,12,162]),function(q,e,A,T,C,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends C.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new A.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=A.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(c){const b=this.normalizeRequests(c),y=b.filter(v=>{const L=this.watchers.get(v.path);return L?!(0,T.patternsEquals)(L.request.excludes,v.excludes)||!(0,T.patternsEquals)(L.request.includes,v.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:v})=>!b.find(L=>L.path===v.path&&(0,T.patternsEquals)(L.excludes,v.excludes)&&(0,T.patternsEquals)(L.includes,v.includes))).map(({request:v})=>v.path);y.length&&this.trace(`Request to start watching: ${y.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const v of m)this.stopWatching(v);for(const v of y)this.startWatching(v)}startWatching(c){const b=new O.NodeJSFileWatcherLibrary(c,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),y={request:c,instance:b};this.watchers.set(c.path,y)}async stop(){for(const[c]of this.watchers)this.stopWatching(c);this.watchers.clear()}stopWatching(c){const b=this.watchers.get(c);b&&(this.watchers.delete(c),b.instance.dispose())}normalizeRequests(c){const b=new Map;for(const y of c){const m=N.isLinux?y.path:y.path.toLowerCase();b.set(m,y)}return Array.from(b.values())}async setVerboseLogging(c){this.verboseLogging=c;for(const[,b]of this.watchers)b.instance.setVerboseLogging(c)}trace(c){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(c)})}toMessage(c,b){return b?`[File Watcher (node.js)] ${c} (path: ${b.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=I}),define(ie[115],ne([0,1,62,114]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class C extends A.AbstractNonRecursiveWatcherClient{constructor(O,I,h){super(O,I,h),this.init()}createWatcher(){return new T.NodeJSWatcher}}e.NodeJSWatcherClient=C}),define(ie[116],ne([0,1,16,57,83,62]),function(q,e,A,T,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends N.AbstractUniversalWatcherClient{constructor(h,c,b){super(h,c,b),this.init()}createWatcher(h){const c=h.add(new C.Client(A.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:b,signal:y})=>this.onError(`terminated by itself with code ${b}, signal: ${y}`))),T.ProxyChannel.toService((0,T.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(ie[63],ne([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class A{constructor(...C){this._entries=new Map;for(const[N,O]of C)this.set(N,O)}set(C,N){const O=this._entries.get(C);return this._entries.set(C,N),O}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=A}),define(ie[117],ne([0,1,8,9,2,47,112,10,63,163]),function(q,e,A,T,C,N,O,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class y extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class m{constructor(u=new h.ServiceCollection,g=!1,f,S=b){this._services=u,this._strict=g,this._parent=f,this._enableTracing=S,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=S?f?._globalGraph??new O.Graph(p=>p):void 0}createChild(u){return new m(u,this._strict,this,this._enableTracing)}invokeFunction(u,...g){const f=L.traceInvocation(this._enableTracing,u);let S=!1;try{return u({get:w=>{if(S)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(w,f);if(!t)throw new Error(`[invokeFunction] unknown service '${w}'`);return t}},...g)}finally{S=!0,f.stop()}}createInstance(u,...g){let f,S;return u instanceof N.SyncDescriptor?(f=L.traceCreation(this._enableTracing,u.ctor),S=this._createInstance(u.ctor,u.staticArguments.concat(g),f)):(f=L.traceCreation(this._enableTracing,u),S=this._createInstance(u,g,f)),f.stop(),S}_createInstance(u,g=[],f){const S=I._util.getServiceDependencies(u).sort((t,o)=>t.index-o.index),p=[];for(const t of S){const o=this._getOrCreateServiceInstance(t.id,f);o||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(o)}const w=S.length>0?S[0].index:g.length;if(g.length!==w){console.trace(`[createInstance] First service dependency of ${u.name} at position ${w+1} conflicts with ${g.length} static arguments`);const t=w-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,w)}return Reflect.construct(u,g.concat(p))}_setServiceInstance(u,g){if(this._services.get(u)instanceof N.SyncDescriptor)this._services.set(u,g);else if(this._parent)this._parent._setServiceInstance(u,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){const g=this._services.get(u);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):g}_getOrCreateServiceInstance(u,g){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(u));const f=this._getServiceInstanceOrDescriptor(u);return f instanceof N.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,f,g.branch(u,!0)):(g.branch(u,!1),f)}_safeCreateAndCacheServiceInstance(u,g,f){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,g,f)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,g,f){const S=new O.Graph(t=>t.id.toString());let p=0;const w=[{id:u,desc:g,_trace:f}];for(;w.length;){const t=w.pop();if(S.lookupOrInsertNode(t),p++>1e3)throw new y(S);for(const o of I._util.getServiceDependencies(t.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(o.id);if(n||this._throwIfStrict(`[createInstance] ${u} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),n instanceof N.SyncDescriptor){const i={id:o.id,desc:n,_trace:t._trace.branch(o.id,!0)};S.insertEdge(t,i),w.push(i)}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new y(S);break}for(const{data:o}of t){if(this._getServiceInstanceOrDescriptor(o.id)instanceof N.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}S.removeNode(o)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,g,f=[],S,p){if(this._services.get(u)instanceof N.SyncDescriptor)return this._createServiceInstance(u,g,f,S,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,g,f,S,p);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(u,g,f=[],S,p){if(S){const w=new m(void 0,this._strict,this,this._enableTracing);w._globalGraphImplicitDependency=String(u);const t=new Map,o=new A.IdleValue(()=>{const n=w._createInstance(g,f,p);for(const[i,r]of t){const a=n[i];if(typeof a=="function")for(const l of r)a.apply(n,l)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=t.get(i);return l||(l=new c.LinkedList,t.set(i,l)),(E,k,F)=>{const Y=l.push([E,k,F]);return(0,C.toDisposable)(Y)}}if(i in n)return n[i];const r=o.value;let a=r[i];return typeof a!="function"||(a=a.bind(r),n[i]=a),a},set(n,i,r){return o.value[i]=r,!0},getPrototypeOf(n){return g.prototype}})}else return this._createInstance(g,f,p)}_throwIfStrict(u,g){if(g&&console.warn(u),this._strict)throw new Error(u)}}e.InstantiationService=m;var v;(function(D){D[D.None=0]="None",D[D.Creation=1]="Creation",D[D.Invocation=2]="Invocation",D[D.Branch=3]="Branch"})(v||(v={}));class L{static traceInvocation(u,g){return u?new L(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):L._None}static traceCreation(u,g){return u?new L(1,g.name):L._None}constructor(u,g){this.type=u,this.name=g,this._start=Date.now(),this._dep=[]}branch(u,g){const f=new L(3,u.toString());return this._dep.push([u,g,f]),f}stop(){const u=Date.now()-this._start;L._totals+=u;let g=!1;function f(p,w){const t=[],o=new Array(p+1).join("	");for(const[n,i,r]of w._dep)if(i&&r){g=!0,t.push(`${o}CREATES -> ${n}`);const a=f(p+1,r);a&&t.push(a)}else t.push(`${o}uses -> ${n}`);return t.join(`
`)}const S=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${L._totals.toFixed(2)}ms)`];(u>2||g)&&L.all.add(S.join(`
`))}}e.Trace=L,L.all=new Set,L._None=new class extends L{constructor(){super(0,null)}stop(){}branch(){return this}},L._totals=0});var te=this&&this.__param||function(q,e){return function(A,T){e(A,T,q)}};define(ie[64],ne([0,1,23,2,12,100,20,10]),function(q,e,A,T,C,N,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function h(b){return b.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=h,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let c=e.LanguagePackBaseService=class extends T.Disposable{constructor(y){super(),this.extensionGalleryService=y}async getAvailableLanguages(){const y=new A.CancellationTokenSource;setTimeout(()=>y.cancel(),1e3);let m;try{m=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const L=m.firstPage.filter(D=>D.properties.localizedLanguages?.length&&D.tags.some(u=>u.startsWith("lp-"))).map(D=>{const u=D.properties.localizedLanguages?.[0],g=h(D);return{...this.createQuickPickItem(g,u,D),extensionId:D.identifier.id,galleryExtension:D}});return L.push(this.createQuickPickItem("en","English")),L}createQuickPickItem(y,m,v){const L=m??y;let D;if(L!==y&&(D=`(${y})`),y.toLowerCase()===C.language.toLowerCase()&&(D??="",D+=(0,N.localize)(0,null)),v?.installCount){D??="";const u=v.installCount;let g;u>1e6?g=`${Math.floor(u/1e5)/10}M`:u>1e3?g=`${Math.floor(u/1e3)}K`:g=String(u),D+=` $(cloud-download) ${g}`}return{id:y,label:L,description:D}}};e.LanguagePackBaseService=c=ve([te(0,O.IExtensionGalleryService)],c)}),define(ie[6],ne([0,1,32,5,45,2,33,12,17,3,11,113,10]),function(q,e,A,T,C,N,O,I,h,c,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function v(){return new Date().toISOString()}function L(E){return(0,c.isNumber)(E)}e.isLogLevel=L;var D;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(D||(e.LogLevel=D={})),e.DEFAULT_LOG_LEVEL=D.Info;function u(E,k,F){switch(k){case D.Trace:E.trace(F);break;case D.Debug:E.debug(F);break;case D.Info:E.info(F);break;case D.Warning:E.warn(F);break;case D.Error:E.error(F);break;case D.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=u;function g(E,k=!1){let F="";for(let Y=0;Y<E.length;Y++){let X=E[Y];if(X instanceof Error&&(X=(0,A.toErrorMessage)(X,k)),typeof X=="object")try{X=JSON.stringify(X)}catch{}F+=(Y>0?" ":"")+X}return F}class f extends N.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(k){this.level!==k&&(this.level=k,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(k){return this.level!==D.Off&&this.level<=k}}e.AbstractLogger=f;class S extends f{constructor(k){super(),this.logAlways=k}checkLogLevel(k){return this.logAlways||super.checkLogLevel(k)}trace(k,...F){this.checkLogLevel(D.Trace)&&this.log(D.Trace,g([k,...F],!0))}debug(k,...F){this.checkLogLevel(D.Debug)&&this.log(D.Debug,g([k,...F]))}info(k,...F){this.checkLogLevel(D.Info)&&this.log(D.Info,g([k,...F]))}warn(k,...F){this.checkLogLevel(D.Warning)&&this.log(D.Warning,g([k,...F]))}error(k,...F){if(this.checkLogLevel(D.Error))if(k instanceof Error){const Y=Array.prototype.slice.call(arguments);Y[0]=k.stack,this.log(D.Error,g(Y))}else this.log(D.Error,g([k,...F]))}flush(){}}e.AbstractMessageLogger=S;class p extends f{constructor(k=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(k),this.useColors=!I.isWindows}trace(k,...F){this.checkLogLevel(D.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,k,...F):console.log(`[main ${v()}]`,k,...F))}debug(k,...F){this.checkLogLevel(D.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,k,...F):console.log(`[main ${v()}]`,k,...F))}info(k,...F){this.checkLogLevel(D.Info)&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,k,...F):console.log(`[main ${v()}]`,k,...F))}warn(k,...F){this.checkLogLevel(D.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,k,...F):console.warn(`[main ${v()}]`,k,...F))}error(k,...F){this.checkLogLevel(D.Error)&&(this.useColors?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,k,...F):console.error(`[main ${v()}]`,k,...F))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class w extends f{constructor(k=e.DEFAULT_LOG_LEVEL,F=!0){super(),this.useColors=F,this.setLevel(k)}trace(k,...F){this.checkLogLevel(D.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",k,...F):console.log(k,...F))}debug(k,...F){this.checkLogLevel(D.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",k,...F):console.log(k,...F))}info(k,...F){this.checkLogLevel(D.Info)&&(this.useColors?console.log("%c INFO","color: #33f",k,...F):console.log(k,...F))}warn(k,...F){this.checkLogLevel(D.Warning)&&(this.useColors?console.log("%c WARN","color: #993",k,...F):console.log(k,...F))}error(k,...F){this.checkLogLevel(D.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",k,...F):console.error(k,...F))}dispose(){}flush(){}}e.ConsoleLogger=w;class t extends f{constructor(k,F=e.DEFAULT_LOG_LEVEL){super(),this.adapter=k,this.setLevel(F)}trace(k,...F){this.checkLogLevel(D.Trace)&&this.adapter.log(D.Trace,[this.extractMessage(k),...F])}debug(k,...F){this.checkLogLevel(D.Debug)&&this.adapter.log(D.Debug,[this.extractMessage(k),...F])}info(k,...F){this.checkLogLevel(D.Info)&&this.adapter.log(D.Info,[this.extractMessage(k),...F])}warn(k,...F){this.checkLogLevel(D.Warning)&&this.adapter.log(D.Warning,[this.extractMessage(k),...F])}error(k,...F){this.checkLogLevel(D.Error)&&this.adapter.log(D.Error,[this.extractMessage(k),...F])}extractMessage(k){return typeof k=="string"?k:(0,A.toErrorMessage)(k,this.checkLogLevel(D.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class o extends f{constructor(k){super(),this.loggers=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const F of this.loggers)F.setLevel(k);super.setLevel(k)}trace(k,...F){for(const Y of this.loggers)Y.trace(k,...F)}debug(k,...F){for(const Y of this.loggers)Y.debug(k,...F)}info(k,...F){for(const Y of this.loggers)Y.info(k,...F)}warn(k,...F){for(const Y of this.loggers)Y.warn(k,...F)}error(k,...F){for(const Y of this.loggers)Y.error(k,...F)}flush(){for(const k of this.loggers)k.flush()}dispose(){for(const k of this.loggers)k.dispose()}}e.MultiplexLogger=o;class n extends N.Disposable{constructor(k,F,Y){if(super(),this.logLevel=k,this.logsHome=F,this._loggers=new O.ResourceMap,this._onDidChangeLoggers=this._register(new T.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,Y)for(const X of Y)this._loggers.set(X.resource,{logger:void 0,info:X})}getLoggerEntry(k){return(0,c.isString)(k)?[...this._loggers.values()].find(F=>F.info.id===k):this._loggers.get(k)}getLogger(k){return this.getLoggerEntry(k)?.logger}createLogger(k,F){const Y=this.toResource(k),X=(0,c.isString)(k)?k:F?.id??(0,C.hash)(Y.toString()).toString(16);let ee=this._loggers.get(Y)?.logger;const le=F?.logLevel==="always"?D.Trace:F?.logLevel;ee||(ee=this.doCreateLogger(Y,le??this.getLogLevel(Y)??this.logLevel,{...F,id:X}));const re={logger:ee,info:{resource:Y,id:X,logLevel:le,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(re.info),this._loggers.set(Y,re),ee}toResource(k){return(0,c.isString)(k)?(0,h.joinPath)(this.logsHome,`${k}.log`):k}setLogLevel(k,F){if(b.URI.isUri(k)){const Y=k,X=F,ee=this._loggers.get(Y);ee&&X!==ee.info.logLevel&&(ee.info.logLevel=X===this.logLevel?void 0:X,ee.logger?.setLevel(X),this._loggers.set(ee.info.resource,ee),this._onDidChangeLogLevel.fire([Y,X]))}else{this.logLevel=k;for(const[Y,X]of this._loggers.entries())this._loggers.get(Y)?.info.logLevel===void 0&&X.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(k,F){const Y=this.getLoggerEntry(k);Y&&F!==!Y.info.hidden&&(Y.info.hidden=!F,this._loggers.set(Y.info.resource,Y),this._onDidChangeVisibility.fire([Y.info.resource,F]))}getLogLevel(k){let F;return k&&(F=this._loggers.get(k)?.info.logLevel),F??this.logLevel}registerLogger(k){const F=this._loggers.get(k.resource);F?F.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this._loggers.set(k.resource,{info:k,logger:void 0}),this._onDidChangeLoggers.fire({added:[k],removed:[]}))}deregisterLogger(k){const F=this._loggers.get(k);F&&(F.logger&&F.logger.dispose(),this._loggers.delete(k),this._onDidChangeLoggers.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const k of this._loggers.values())yield k.info}getRegisteredLogger(k){return this._loggers.get(k)?.info}dispose(){this._loggers.forEach(k=>k.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class i{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(k){}getLevel(){return D.Info}trace(k,...F){}debug(k,...F){}info(k,...F){}warn(k,...F){}error(k,...F){}critical(k,...F){}dispose(){}flush(){}}e.NullLogger=i;class r extends i{}e.NullLogService=r;function a(E){if(E.verbose)return D.Trace;if(typeof E.logLevel=="string"){const k=d(E.logLevel.toLowerCase());if(k!==void 0)return k}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(E){switch(E){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Off:return"off"}}e.LogLevelToString=l;function d(E){switch(E){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Error;case"off":return D.Off}}e.parseLogLevel=d,e.CONTEXT_LOG_LEVEL=new y.RawContextKey("logLevel",l(D.Info))}),define(ie[118],ne([0,1,19,8,9,5,2,15,62,6]),function(q,e,A,T,C,N,O,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends O.Disposable{constructor(m,v){super(),this.logService=m,this.options=v,this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new N.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new T.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new T.ThrottledDelayer(0))}watch(m,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,v):this.watchNonRecursive(m,v)}watchUniversal(m,v){const L={path:this.toFilePath(m),excludes:v.excludes,includes:v.includes,recursive:v.recursive},D=(0,A.insert)(this.universalPathsToWatch,L);return this.refreshUniversalWatchers(),(0,O.toDisposable)(()=>{D(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,C.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,h.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const v of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const v of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(v)&&m.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,v){const L={path:this.toFilePath(m),excludes:v.excludes,includes:v.includes,recursive:!1},D=(0,A.insert)(this.nonRecursivePathsToWatch,L);return this.refreshNonRecursiveWatchers(),(0,O.toDisposable)(()=>{D(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,C.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,I.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ie[119],ne([0,1,19,8,14,23,5,45,65,2,55,16,120,17,44,97,13,61,6,9]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v,L,D,u,g,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=e.FileService=class extends c.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new T.ResourceQueue)}registerProvider(t,o){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const n=new c.DisposableStore;return this.provider.set(t,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:o}),n.add(o.onDidChangeFile(i=>this._onDidFilesChange.fire(new u.FileChangesEvent(i,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),n.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:t}))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:o}),this.provider.delete(t),(0,c.dispose)(n)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(n){o.push(n)}}),!this.provider.has(t)&&await T.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,o){const n=this.provider.get(t.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return h.Iterable.map(this.provider,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async withProvider(t){if(!(0,v.isAbsolutePath)(t))throw new u.FileOperationError((0,D.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const o=this.provider.get(t.scheme);if(!o){const n=new S.ErrorNoTelemetry;throw n.message=(0,D.localize)(1,null,t.toString()),n}return o}async withReadProvider(t){const o=await this.withProvider(t);if((0,u.hasOpenReadWriteCloseCapability)(o)||(0,u.hasReadWriteCapability)(o)||(0,u.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const o=await this.withProvider(t);if((0,u.hasOpenReadWriteCloseCapability)(o)||(0,u.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.doResolveFile(t,o)}catch(n){throw(0,u.toFileSystemProviderErrorCode)(n)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,D.localize)(2,null,this.resourceForError(t)),1):(0,u.ensureFileSystemProviderError)(n)}}async doResolveFile(t,o){const n=await this.withProvider(t),i=this.isPathCaseSensitive(n),r=o?.resolveTo,a=o?.resolveSingleChildDescendants,l=o?.resolveMetadata,d=await n.stat(t);let E;return this.toFileStat(n,t,d,void 0,!!l,(k,F)=>(E||(E=b.TernarySearchTree.forUris(()=>!i),E.set(t,!0),r&&E.fill(!0,r)),E.get(k.resource)||E.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&a?F===1:!1))}async toFileStat(t,o,n,i,r,a){const{providerExtUri:l}=this.getExtUri(t),d={resource:o,name:l.basename(o),isFile:(n.type&u.FileType.File)!==0,isDirectory:(n.type&u.FileType.Directory)!==0,isSymbolicLink:(n.type&u.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&u.FilePermission.Readonly)||!!(t.capabilities&2048),etag:(0,u.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(d.isDirectory&&a(d,i)){try{const E=await t.readdir(o),k=await T.Promises.settled(E.map(async([F,Y])=>{try{const X=l.joinPath(o,F),ee=r?await t.stat(X):{type:Y};return await this.toFileStat(t,X,ee,E.length,r,a)}catch(X){return this.logService.trace(X),null}}));d.children=(0,A.coalesce)(k)}catch(E){this.logService.trace(E),d.children=[]}return d}return d}async resolveAll(t){return T.Promises.settled(t.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.withProvider(t),n=await o.stat(t);return this.toFileStat(o,t,n,void 0,!0,()=>!1)}async exists(t){const o=await this.withProvider(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.doValidateCreateFile(t,o)}catch(n){return n}return!0}async doValidateCreateFile(t,o){if(!o?.overwrite&&await this.exists(t))throw new u.FileOperationError((0,D.localize)(3,null,this.resourceForError(t)),3,o)}async createFile(t,o=C.VSBuffer.fromString(""),n){await this.doValidateCreateFile(t,n);const i=await this.writeFile(t,o);return this._onDidRunOperation.fire(new u.FileOperationEvent(t,0,i)),i}async writeFile(t,o,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,t,n)||await this.mkdirp(i,r.dirname(t));let l;if((0,u.hasReadWriteCapability)(i)&&!(o instanceof C.VSBuffer))if((0,L.isReadableStream)(o)){const d=await(0,L.peekStream)(o,3);d.ended?l=C.VSBuffer.concat(d.buffer):l=d}else l=(0,L.peekReadable)(o,d=>C.VSBuffer.concat(d),3);else l=o;!(0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)&&l instanceof C.VSBuffer?await this.doWriteUnbuffered(i,t,n,l):await this.doWriteBuffered(i,t,n,l instanceof C.VSBuffer?(0,C.bufferToReadable)(l):l),this._onDidRunOperation.fire(new u.FileOperationEvent(t,4))}catch(a){throw new u.FileOperationError((0,D.localize)(4,null,this.resourceForError(t),(0,u.ensureFileSystemProviderError)(a).toString()),(0,u.toFileOperationResult)(a),n)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,o,n){if(!!n?.unlock&&!(t.capabilities&8192))throw new Error((0,D.localize)(5,null,this.resourceForError(o)));let r;try{r=await t.stat(o)}catch{return}if(r.type&u.FileType.Directory)throw new u.FileOperationError((0,D.localize)(6,null,this.resourceForError(o)),0,n);if(this.throwIfFileIsReadonly(o,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==u.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,u.etag)({mtime:n.mtime,size:r.size}))throw new u.FileOperationError((0,D.localize)(7,null),3,n);return r}async readFile(t,o,n){const i=await this.withReadProvider(t);return o?.atomic?this.doReadFileAtomic(i,t,o,n):this.doReadFile(i,t,o,n)}async doReadFileAtomic(t,o,n,i){return new Promise((r,a)=>{this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(t,o,n,i);r(l)}catch(l){a(l)}})})}async doReadFile(t,o,n,i){const r=await this.doReadFileStream(t,o,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,C.streamToBuffer)(r.value)}}async readFileStream(t,o,n){const i=await this.withReadProvider(t);return this.doReadFileStream(i,t,o,n)}async doReadFileStream(t,o,n,i){const r=new N.CancellationTokenSource(i),a=this.validateReadFile(o,n).then(d=>d,d=>{throw r.cancel(),d});let l;try{return typeof n?.etag=="string"&&n.etag!==u.ETAG_DISABLED&&await a,n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)||!((0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasFileReadStreamCapability)(t))||(0,u.hasReadWriteCapability)(t)&&n?.preferUnbuffered?l=this.readFileUnbuffered(t,o,n):(0,u.hasFileReadStreamCapability)(t)?l=this.readFileStreamed(t,o,r.token,n):l=this.readFileBuffered(t,o,r.token,n),{...await a,value:l}}catch(d){throw l&&await(0,L.consumeStream)(l),this.restoreReadError(d,o,n)}}restoreReadError(t,o,n){const i=(0,D.localize)(8,null,this.resourceForError(o),(0,u.ensureFileSystemProviderError)(t).toString());return t instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(i,t.stat,n):t instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new u.FileOperationError(i,(0,u.toFileOperationResult)(t),n)}readFileStreamed(t,o,n,i=Object.create(null)){const r=t.readFileStream(o,i,n);return(0,L.transform)(r,{data:a=>a instanceof C.VSBuffer?a:C.VSBuffer.wrap(a),error:a=>this.restoreReadError(a,o,i)},a=>C.VSBuffer.concat(a))}readFileBuffered(t,o,n,i=Object.create(null)){const r=(0,C.newWriteableBufferStream)();return(0,g.readFileIntoStream)(t,o,r,a=>a,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>this.restoreReadError(a,o,i)},n),r}readFileUnbuffered(t,o,n){const i=(0,L.newWriteableStream)(r=>C.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)?r=await t.readFile(o,{atomic:!0}):r=await t.readFile(o),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(o,r.byteLength,n),i.end(C.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(t,o){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new u.FileOperationError((0,D.localize)(9,null,this.resourceForError(t)),0,o);if(typeof o?.etag=="string"&&o.etag!==u.ETAG_DISABLED&&o.etag===n.etag)throw new u.NotModifiedSinceFileOperationError((0,D.localize)(10,null),n,o);return this.validateReadFileLimits(t,n.size,o),n}validateReadFileLimits(t,o,n){if(typeof n?.limits?.size=="number"&&o>n.limits.size)throw new u.TooLargeFileOperationError((0,D.localize)(11,null,this.resourceForError(t)),7,o,n)}async canMove(t,o,n){return this.doCanMoveCopy(t,o,"move",n)}async canCopy(t,o,n){return this.doCanMoveCopy(t,o,"copy",n)}async doCanMoveCopy(t,o,n,i){if(t.toString()!==o.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(r,t,a,o,n,i)}catch(r){return r}return!0}async move(t,o,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),a=await this.doMoveCopy(i,t,r,o,"move",!!n),l=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(t,a==="move"?2:3,l)),l}async copy(t,o,n){const i=await this.withReadProvider(t),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),a=await this.doMoveCopy(i,t,r,o,"copy",!!n),l=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(t,a==="copy"?3:2,l)),l}async doMoveCopy(t,o,n,i,r,a){if(o.toString()===i.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:d}=await this.doValidateMoveCopy(t,o,n,i,r,a);if(l&&!d&&a&&await this.del(i,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i)),r==="copy"){if(t===n&&(0,u.hasFileFolderCopyCapability)(t))await t.copy(o,i,{overwrite:a});else{const E=await this.resolve(o);E.isDirectory?await this.doCopyFolder(t,E,n,i):await this.doCopyFile(t,o,n,i)}return r}else return t===n?(await t.rename(o,i,{overwrite:a}),r):(await this.doMoveCopy(t,o,n,i,"copy",a),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(t,o,n,i){if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(t,o,n,i);if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(t,o,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(t,o,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.doPipeUnbuffered(t,o,n,i)}async doCopyFolder(t,o,n,i){await n.mkdir(i),Array.isArray(o.children)&&await T.Promises.settled(o.children.map(async r=>{const a=this.getExtUri(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(t,await this.resolve(r.resource),n,a):this.doCopyFile(t,r.resource,n,a)}))}async doValidateMoveCopy(t,o,n,i,r,a){let l=!1;if(t===n){const{providerExtUri:E,isPathCaseSensitive:k}=this.getExtUri(t);if(k||(l=E.isEqual(o,i)),l&&r==="copy")throw new Error((0,D.localize)(12,null,this.resourceForError(o),this.resourceForError(i)));if(!l&&E.isEqualOrParent(i,o))throw new Error((0,D.localize)(13,null,this.resourceForError(o),this.resourceForError(i)))}const d=await this.exists(i);if(d&&!l){if(!a)throw new u.FileOperationError((0,D.localize)(14,null,this.resourceForError(o),this.resourceForError(i)),4);if(t===n){const{providerExtUri:E}=this.getExtUri(t);if(E.isEqualOrParent(o,i))throw new Error((0,D.localize)(15,null,this.resourceForError(o),this.resourceForError(i)))}}return{exists:d,isSameResourceWithDifferentPathCase:l}}getExtUri(t){const o=this.isPathCaseSensitive(t);return{providerExtUri:o?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(o,t);const n=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(t,0,n)),n}async mkdirp(t,o){const n=[],{providerExtUri:i}=this.getExtUri(t);for(;!i.isEqual(o,i.dirname(o));)try{if(!((await t.stat(o)).type&u.FileType.Directory))throw new Error((0,D.localize)(16,null,this.resourceForError(o)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(o)),o=i.dirname(o)}for(let r=n.length-1;r>=0;r--){o=i.joinPath(o,n[r]);try{await t.mkdir(o)}catch(a){if((0,u.toFileSystemProviderErrorCode)(a)!==u.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,o){try{await this.doValidateDelete(t,o)}catch(n){return n}return!0}async doValidateDelete(t,o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);if(!!o?.useTrash&&!(n.capabilities&4096))throw new Error((0,D.localize)(17,null,this.resourceForError(t)));let r;try{r=await n.stat(t)}catch{}if(r)this.throwIfFileIsReadonly(t,r);else throw new u.FileOperationError((0,D.localize)(18,null,this.resourceForError(t)),1);if(!!!o?.recursive){const l=await this.resolve(t);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,D.localize)(19,null,this.resourceForError(t)))}return n}async del(t,o){const n=await this.doValidateDelete(t,o),i=!!o?.useTrash,r=!!o?.recursive;await n.delete(t,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new u.FileOperationEvent(t,1))}async cloneFile(t,o){const n=await this.withProvider(t),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(n===i&&this.getExtUri(n).providerExtUri.isEqual(t,o))return;if(n===i&&(0,u.hasFileCloneCapability)(n))return n.cloneFile(t,o);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(o));const r=this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri);return n===i&&(0,u.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(t,o,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,t,i,o))}watch(t,o={recursive:!1,excludes:[]}){const n=new c.DisposableStore;let i=!1,r=()=>{i=!0};return n.add((0,c.toDisposable)(()=>r())),(async()=>{try{const a=await this.doWatch(t,o);i?(0,c.dispose)(a):r=()=>(0,c.dispose)(a)}catch(a){this.logService.error(a)}})(),n}async doWatch(t,o){const n=await this.withProvider(t),i=(0,I.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(t),o]);let r=this.activeWatchers.get(i);return r||(r={count:0,disposable:n.watch(t,o)},this.activeWatchers.set(i,r)),r.count+=1,(0,c.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,c.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,o,n,i){return this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(async()=>{const r=await t.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,L.isReadableStream)(i)||(0,L.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(t,r,i):await this.doWriteReadableBufferedQueued(t,r,i)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await t.close(r)}})}async doWriteStreamBufferedQueued(t,o,n){let i=0,r;if((0,L.isReadableBufferedStream)(n)){if(n.buffer.length>0){const a=C.VSBuffer.concat(n.buffer);await this.doWriteBuffer(t,o,a,a.byteLength,i,0),i+=a.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((a,l)=>{(0,L.listenStream)(r,{onData:async d=>{r.pause();try{await this.doWriteBuffer(t,o,d,d.byteLength,i,0)}catch(E){return l(E)}i+=d.byteLength,setTimeout(()=>r.resume())},onError:d=>l(d),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(t,o,n){let i=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(t,o,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(t,o,n,i,r,a){let l=0;for(;l<i;){const d=await t.write(o,r+l,n.buffer,a+l,i-l);l+=d}}async doWriteUnbuffered(t,o,n,i){return this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,o,n,i))}async doWriteUnbufferedQueued(t,o,n,i){let r;i instanceof C.VSBuffer?r=i:(0,L.isReadableStream)(i)?r=await(0,C.streamToBuffer)(i):(0,L.isReadableBufferedStream)(i)?r=await(0,C.bufferedStreamToBuffer)(i):r=(0,C.readableToBuffer)(i),await t.writeFile(o,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(t,o,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,o,n,i))}async doPipeBufferedQueued(t,o,n,i){let r,a;try{r=await t.open(o,{create:!1}),a=await n.open(i,{create:!0,unlock:!1});const l=C.VSBuffer.alloc(this.BUFFER_SIZE);let d=0,E=0,k=0;do k=await t.read(r,d,l.buffer,E,l.byteLength-E),await this.doWriteBuffer(n,a,l,k,d,E),d+=k,E+=k,E===l.byteLength&&(E=0);while(k>0)}catch(l){throw(0,u.ensureFileSystemProviderError)(l)}finally{await T.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof a=="number"?n.close(a):Promise.resolve()])}}async doPipeUnbuffered(t,o,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,o,n,i))}async doPipeUnbufferedQueued(t,o,n,i){return n.writeFile(i,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(t,o,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,o,n,i))}async doPipeUnbufferedToBufferedQueued(t,o,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const a=await t.readFile(o);await this.doWriteBuffer(n,r,C.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(t,o,n,i){const r=await(0,C.streamToBuffer)(this.readFileBuffered(t,o,N.CancellationToken.None));await this.doWriteUnbuffered(n,i,void 0,r)}throwIfFileSystemIsReadonly(t,o){if(t.capabilities&2048)throw new u.FileOperationError((0,D.localize)(20,null,this.resourceForError(o)),6);return t}throwIfFileIsReadonly(t,o){if((o.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,D.localize)(21,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===y.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=p=ve([te(0,f.ILogService)],p)}),define(ie[121],ne([0,1,122,164,8,33,14,5,165,2,15,12,17,44,22,99,13,61,118,32,116,115]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v,L,D,u,g,f,S,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,T.gracefulify)(A)}catch(o){console.error(`Error enabling graceful-fs: ${(0,S.toErrorMessage)(o)}`)}})();class t extends f.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new N.ResourceMap(r=>m.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,y.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:r}=await L.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(n){try{const i=await L.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async a=>{try{let l;a.isSymbolicLink()?l=(await this.stat((0,m.joinPath)(n,a.name))).type:l=this.toType(a),r.push([a.name,l])}catch(l){this.logService.trace(l)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let r;return i?.dangling?r=u.FileType.Unknown:n.isFile()?r=u.FileType.File:n.isDirectory()?r=u.FileType.Directory:r=u.FileType.Unknown,i&&(r|=u.FileType.SymbolicLink),r}async createResourceLock(n){const i=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const a=new C.Barrier;return this.resourceLocks.set(n,a),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(n)===a&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(n,i){let r;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),r=await this.createResourceLock(n));const a=this.toFilePath(n);return await L.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{r?.dispose()}}traceLock(n){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,i,r){const a=(0,v.newWriteableStream)(l=>O.VSBuffer.concat(l.map(d=>O.VSBuffer.wrap(d))).buffer);return(0,g.readFileIntoStream)(this,n,a,l=>l.buffer,{...i,bufferSize:256*1024},r),a}async writeFile(n,i,r){let a;try{const l=this.toFilePath(n);if(!r.create||!r.overwrite){if(await L.Promises.exists(l)){if(!r.overwrite)throw(0,u.createFileSystemProviderError)((0,D.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,u.createFileSystemProviderError)((0,D.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:r.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(n,l)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(n){t.canFlush=n}async open(n,i){const r=this.toFilePath(n);let a;(0,u.isFileOpenForWriteOptions)(i)&&(a=await this.createResourceLock(n));let l;try{if((0,u.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:E}=await L.SymlinkSupport.stat(r);E.mode&128||await L.Promises.chmod(r,E.mode|128)}catch(E){this.logService.trace(E)}let d;if((0,u.isFileOpenForWriteOptions)(i)){if(y.isWindows)try{await L.Promises.truncate(r,0),d="r+"}catch(E){E.code!=="ENOENT"&&this.logService.trace(E)}d||(d="w")}else d="r";l=await L.Promises.open(r,d)}catch(d){throw a?.dispose(),(0,u.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(l,0),(0,u.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(l,n),a){const d=this.mapHandleToLock.get(l);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${r})`),this.mapHandleToLock.set(l,a),d&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${r})`),d.dispose())}return l}async close(n){const i=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&t.canFlush)try{await L.Promises.fdatasync(n)}catch(r){t.configureFlushOnWrite(!1),this.logService.error(r)}return await L.Promises.close(n)}catch(r){throw this.toFileSystemProviderError(r)}finally{i&&(this.mapHandleToLock.get(n)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,r,a,l){const d=this.normalizePos(n,i);let E=null;try{E=(await L.Promises.read(n,r,a,l,d)).bytesRead}catch(k){throw this.toFileSystemProviderError(k)}finally{this.updatePos(n,d,E)}return E}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,r){const a=this.mapHandleToPos.get(n);typeof a=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(n,a+r):this.mapHandleToPos.delete(n)))}async write(n,i,r,a,l){return(0,C.retry)(()=>this.doWrite(n,i,r,a,l),100,3)}async doWrite(n,i,r,a,l){const d=this.normalizePos(n,i);let E=null;try{E=(await L.Promises.write(n,r,a,l,d)).bytesWritten}catch(k){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),k)}finally{this.updatePos(n,d,E)}return E}async mkdir(n){try{await L.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const r=this.toFilePath(n);i.recursive?await L.Promises.rm(r,L.RimRafMode.MOVE):await L.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(n,i,r){const a=this.toFilePath(n),l=this.toFilePath(i);if(a!==l)try{await this.validateTargetDeleted(n,i,"move",r.overwrite),await L.Promises.move(a,l)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,D.localize)(2,null,(0,b.basename)(a),(0,b.basename)((0,b.dirname)(l)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(n,i,r){const a=this.toFilePath(n),l=this.toFilePath(i);if(a!==l)try{await this.validateTargetDeleted(n,i,"copy",r.overwrite),await L.Promises.copy(a,l,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,D.localize)(3,null,(0,b.basename)(a),(0,b.basename)((0,b.dirname)(l)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(n,i,r,a){const l=this.toFilePath(n),d=this.toFilePath(i);let E=!1;if(!!(this.capabilities&1024)||(E=(0,h.isEqual)(l,d,!0)),E&&r==="copy")throw(0,u.createFileSystemProviderError)((0,D.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!E&&await L.Promises.exists(d)){if(!a)throw(0,u.createFileSystemProviderError)((0,D.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.doCloneFile(n,i,!1)}async doCloneFile(n,i,r){const a=this.toFilePath(n),l=this.toFilePath(i),d=!!(this.capabilities&1024);if((0,h.isEqual)(a,l,!d))return;const E=new c.DisposableStore;try{const[k,F]=await Promise.all([this.createResourceLock(n),this.createResourceLock(i)]);E.add(k),E.add(F),r&&await L.Promises.mkdir((0,b.dirname)(l),{recursive:!0}),await L.Promises.copyFile(a,l)}catch(k){if(k.code==="ENOENT"&&!r)return this.doCloneFile(n,i,!0);throw this.toFileSystemProviderError(k)}finally{E.dispose()}}createUniversalWatcher(n,i,r){return new p.UniversalWatcherClient(a=>n(a),a=>i(a),r)}createNonRecursiveWatcher(n,i,r){return new w.NodeJSWatcherClient(a=>n(a),a=>i(a),r)}toFileSystemProviderError(n){if(n instanceof u.FileSystemProviderError)return n;let i=n,r;switch(n.code){case"ENOENT":r=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=u.FileSystemProviderErrorCode.Unknown;break;default:r=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(n,i){let r=this.toFileSystemProviderError(i);if(n&&r.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await L.SymlinkSupport.stat(this.toFilePath(n));a.mode&128||(r=(0,u.createFileSystemProviderError)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return r}}e.DiskFileSystemProvider=t,t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0}),define(ie[123],ne([0,1,2,6]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class C extends A.Disposable{constructor(O,I=[]){super(),this.logger=new T.MultiplexLogger([O,...I]),this._register(O.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(O){this.logger.setLevel(O)}getLevel(){return this.logger.getLevel()}trace(O,...I){this.logger.trace(O,...I)}debug(O,...I){this.logger.debug(O,...I)}info(O,...I){this.logger.info(O,...I)}warn(O,...I){this.logger.warn(O,...I)}error(O,...I){this.logger.error(O,...I)}flush(){this.logger.flush()}}e.LogService=C}),define(ie[124],ne([0,1,13,6]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var C;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(C||(C={}));async function N(c,b,y,m,v){try{const L=await new Promise((u,g)=>{q(["@vscode/spdlog"],u,g)});L.setFlushOn(C.Trace);const D=await L.createAsyncRotatingLogger(c,b,y,m);return v?D.clearFormatters():D.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),D}catch(L){console.error(L)}return null}function O(c,b,y){switch(b){case T.LogLevel.Trace:c.trace(y);break;case T.LogLevel.Debug:c.debug(y);break;case T.LogLevel.Info:c.info(y);break;case T.LogLevel.Warning:c.warn(y);break;case T.LogLevel.Error:c.error(y);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function I(c,b){switch(b){case T.LogLevel.Trace:c.setLevel(C.Trace);break;case T.LogLevel.Debug:c.setLevel(C.Debug);break;case T.LogLevel.Info:c.setLevel(C.Info);break;case T.LogLevel.Warning:c.setLevel(C.Warning);break;case T.LogLevel.Error:c.setLevel(C.Error);break;case T.LogLevel.Off:c.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class h extends T.AbstractMessageLogger{constructor(b,y,m,v,L){super(),this.buffer=[],this.setLevel(L),this._loggerCreationPromise=this._createSpdLogLogger(b,y,m,v),this._register(this.onDidChangeLogLevel(D=>{this._logger&&I(this._logger,D)}))}async _createSpdLogLogger(b,y,m,v){const L=m?6:1,D=30/L*A.ByteSize.MB,u=await N(b,y,D,L,v);if(u){this._logger=u,I(this._logger,this.getLevel());for(const{level:g,message:f}of this.buffer)O(this._logger,g,f);this.buffer=[]}}log(b,y){this._logger?O(this._logger,b,y):this.getLevel()<=b&&this.buffer.push({level:b,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=h}),define(ie[125],ne([0,1,28,6,124]),function(q,e,A,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class N extends T.AbstractLoggerService{doCreateLogger(I,h,c){return new C.SpdLogLogger((0,A.generateUuid)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.LoggerService=N}),define(ie[38],ne([0,1,5,65,2,10]),function(q,e,A,T,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,N.createDecorator)("policy");class O extends C.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new A.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(c){const b=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...c,...this.policyDefinitions},b!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(c),T.Iterable.reduce(this.policies.entries(),(y,[m,v])=>({...y,[m]:v}),{})}getPolicyValue(c){return this.policies.get(c)}serialize(){return T.Iterable.reduce(Object.entries(this.policyDefinitions),(c,[b,y])=>({...c,[b]:{definition:y,value:this.policies.get(b)}}),{})}}e.AbstractPolicyService=O;class I{constructor(){this.onDidChange=A.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(ie[126],ne([0,1,8,5,65,3,13,6,38]),function(q,e,A,T,C,N,O,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(y,m){const v=[];for(const L of new Set(C.Iterable.concat(y.keys(),m.keys())))y.get(L)!==m.get(L)&&v.push(L);return v}let b=e.FilePolicyService=class extends h.AbstractPolicyService{constructor(m,v,L){super(),this.file=m,this.fileService=v,this.logService=L,this.throttledDelayer=this._register(new A.ThrottledDelayer(500));const D=T.Event.filter(v.onDidFilesChange,u=>u.affects(m));this._register(v.watch(m)),this._register(D(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const m=new Map;try{const v=await this.fileService.readFile(this.file),L=JSON.parse(v.value.toString());if(!(0,N.isObject)(L))throw new Error("Policy file isn't a JSON object");for(const D of Object.keys(L))this.policyDefinitions[D]&&m.set(D,L[D])}catch(v){v.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",v)}return m}async refresh(){const m=await this.read(),v=c(this.policies,m);this.policies=m,v.length>0&&this._onDidChange.fire(v)}};e.FilePolicyService=b=ve([te(1,O.IFileService),te(2,I.ILogService)],b)}),define(ie[127],ne([0,1,38,8,166,2,6]),function(q,e,A,T,C,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let I=e.NativePolicyService=class extends A.AbstractPolicyService{constructor(c,b){super(),this.logService=c,this.productName=b,this.throttler=new T.Throttler,this.watcher=this._register(new N.MutableDisposable)}async _updatePolicyDefinitions(c){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.throttler.queue(()=>new Promise((b,y)=>{try{this.watcher.value=(0,C.createWatcher)(this.productName,c,m=>{this._onDidPolicyChange(m),b()})}catch(m){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),y(m)}}))}_onDidPolicyChange(c){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const b in c){const y=c[b];y===void 0?this.policies.delete(b):this.policies.set(b,y)}this._onDidChange.fire(Object.keys(c))}};e.NativePolicyService=I=ve([te(0,O.ILogService)],I)}),define(ie[31],ne([0,1,10]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,A.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[34],ne([0,1,70,3]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(O,I){A.ok(T.isString(O)),A.ok(T.isObject(I)),A.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,I)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}e.Registry=new C}),define(ie[128],ne([0,1,5,34]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class N{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,c){this.schemasById[C(h)]=c,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new N;T.Registry.add(e.Extensions.JSONContribution,O)}),define(ie[42],ne([0,1,19,5,3,86,24,128,34]),function(q,e,A,T,C,N,O,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=h.Registry.as(I.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const n=new Set;this.doRegisterConfigurations(t,o,n),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(t){const o=new Set;this.doDeregisterConfigurations(t,o),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:t,remove:o}){const n=new Set;this.doDeregisterConfigurations(o,n),this.doRegisterConfigurations(t,!1,n),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(t){const o=new Set;this.doRegisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,o){const n=[];for(const{overrides:i,source:r}of t)for(const a in i)if(o.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const l=this.configurationDefaultsOverrides.get(a),d=l?.valuesSources??new Map;if(r)for(const Y of Object.keys(i[a]))d.set(Y,r);const E={...l?.value||{},...i[a]};this.configurationDefaultsOverrides.set(a,{source:r,value:E,valuesSources:d});const k=(0,O.getLanguageTagSettingPlainKey)(a),F={type:"object",default:E,description:N.localize(1,null,k),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:C.isString(r)?void 0:r,defaultValueSource:r};n.push(...D(a)),this.configurationProperties[a]=F,this.defaultLanguageConfigurationOverridesNode.properties[a]=F}else{this.configurationDefaultsOverrides.set(a,{value:i[a],source:r});const l=this.configurationProperties[a];l&&(this.updatePropertyDefaultValue(a,l),this.updateSchema(a,l))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(t){const o=new Set;this.doDeregisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,o){for(const{overrides:n,source:i}of t)for(const r in n){const a=this.configurationDefaultsOverrides.get(r),l=C.isString(i)?i:i?.id,d=C.isString(a?.source)?a?.source:a?.source?.id;if(l===d)if(o.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const E=this.configurationProperties[r];E&&(this.updatePropertyDefaultValue(r,E),this.updateSchema(r,E))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let o=!1;const n=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,n),o=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,n),o=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,n),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const o of t)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,o,n){t.forEach(i=>{this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties,void 0,n),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,o){const n=i=>{if(i.properties)for(const r in i.properties){o.add(r);const a=this.configurationProperties[r];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>n(r))};for(const i of t){n(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(t,o=!0,n,i,r=3,a){r=C.isUndefinedOrNull(t.scope)?r:t.scope;const l=t.properties;if(l)for(const E in l){const k=l[E];if(o&&S(E,k)){delete l[E];continue}if(k.source=n,k.defaultDefaultValue=l[E].default,this.updatePropertyDefaultValue(E,k),e.OVERRIDE_PROPERTY_REGEX.test(E)?k.scope=void 0:(k.scope=C.isUndefinedOrNull(k.scope)?r:k.scope,k.restricted=C.isUndefinedOrNull(k.restricted)?!!i?.includes(E):k.restricted),l[E].hasOwnProperty("included")&&!l[E].included){this.excludedConfigurationProperties[E]=l[E],delete l[E];continue}else this.configurationProperties[E]=l[E],l[E].policy?.name&&this.policyConfigurations.set(l[E].policy.name,E);!l[E].deprecationMessage&&l[E].markdownDeprecationMessage&&(l[E].deprecationMessage=l[E].markdownDeprecationMessage),a.add(E)}const d=t.allOf;if(d)for(const E of d)this.validateAndRegisterProperties(E,o,n,i,r,a)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const o=n=>{const i=n.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);n.allOf?.forEach(o)};o(t)}updateSchema(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.resourceLanguageSettingsSchema.properties[t]=o;break}}removeFromSchema(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const o=`[${t}]`,n={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}}registerOverridePropertyPatternKey(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,o){const n=this.configurationDefaultsOverrides.get(t);let i=n?.value,r=n?.source;C.isUndefined(i)&&(i=o.defaultDefaultValue,r=void 0),C.isUndefined(i)&&(i=g(o.type)),o.default=i,o.defaultValueSource=r}}const v="\\[([^\\]]+)\\]",L=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function D(w){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let o=L.exec(w);for(;o?.length;){const n=o[1].trim();n&&t.push(n),o=L.exec(w)}}return(0,A.distinct)(t)}e.overrideIdentifiersFromKey=D;function u(w){return w.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=u;function g(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const f=new m;h.Registry.add(e.Extensions.Configuration,f);function S(w,t){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?N.localize(7,null,w):f.getConfigurationProperties()[w]!==void 0?N.localize(8,null,w):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,w,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}e.validateProperty=S;function p(){const w=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))w.push([o,t[o].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=p}),define(ie[66],ne([0,1,19,5,51,2,33,30,3,11,24,42,34]),function(q,e,A,T,C,N,O,I,h,c,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function v(o){return Object.isFrozen(o)?o:I.deepFreeze(o)}class L{constructor(n={},i=[],r=[],a){this._contents=n,this._keys=i,this._overrides=r,this.raw=a,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof L)return i;const r=new D("");return r.parseRaw(i),r.configurationModel});this._rawConfiguration=n.reduce((i,r)=>r===i?r:i.merge(r),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,b.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const r=this.rawConfiguration.getValue(n),a=i?this.rawConfiguration.getOverrideValue(n,i):void 0,l=i?this.rawConfiguration.override(i).getValue(n):r;return{value:r,override:a,merged:l}}getOverrideValue(n,i){const r=this.getContentsForOverrideIdentifer(i);return r?n?(0,b.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const r of this.overrides)r.identifiers.includes(n)&&i.push(...r.keys);return A.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return A.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=I.deepClone(this.contents),r=I.deepClone(this.overrides),a=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const d of n)if(l.push(...d.raw?.length?d.raw:[d]),!d.isEmpty()){this.mergeContents(i,d.contents);for(const E of d.overrides){const[k]=r.filter(F=>A.equals(F.identifiers,E.identifiers));k?(this.mergeContents(k.contents,E.contents),k.keys.push(...E.keys),k.keys=A.distinct(k.keys)):r.push(I.deepClone(E))}for(const E of d.keys)a.indexOf(E)===-1&&a.push(E)}return new L(i,a,r,l.every(d=>d instanceof L)?void 0:l)}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const a of A.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[a];const d=i[a];d&&(typeof l=="object"&&typeof d=="object"?(l=I.deepClone(l),this.mergeContents(l,d)):l=d),r[a]=l}return new L(r,this.keys,this.overrides)}mergeContents(n,i){for(const r of Object.keys(i)){if(r in n&&h.isObject(n[r])&&h.isObject(i[r])){this.mergeContents(n[r],i[r]);continue}n[r]=I.deepClone(i[r])}}getContentsForOverrideIdentifer(n){let i=null,r=null;const a=l=>{l&&(r?this.mergeContents(r,l):r=I.deepClone(l))};for(const l of this.overrides)A.equals(l.identifiers,[n])?i=l.contents:l.identifiers.includes(n)&&a(l.contents);return a(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.updateValue(n,i,!0)}setValue(n,i){this.updateValue(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,b.removeFromValueTree)(this.contents,n),y.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(r=>A.equals(r.identifiers,(0,y.overrideIdentifiersFromKey)(n))),1))}updateValue(n,i,r){(0,b.addToValueTree)(this.contents,n,i,a=>console.error(a)),r=r||this.keys.indexOf(n)===-1,r&&this.keys.push(n),y.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,b.toValuesTree)(this.contents[n],a=>console.error(a))})}}e.ConfigurationModel=L;class D{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new L}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!h.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:r,keys:a,overrides:l,restricted:d,hasExcludedProperties:E}=this.doParseRaw(n,i);this._configurationModel=new L(r,a,l,E?[n]:void 0),this._restrictedConfigurations=d||[]}doParseContent(n){let i={},r=null,a=[];const l=[],d=[];function E(F){Array.isArray(a)?a.push(F):r!==null&&(a[r]=F)}const k={onObjectBegin:()=>{const F={};E(F),l.push(a),a=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const F=[];E(F),l.push(a),a=F,r=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:E,onError:(F,Y,X)=>{d.push({error:F,offset:Y,length:X})}};if(n)try{C.visit(n,k),i=a[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return i}doParseRaw(n,i){const r=m.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),a=this.filter(n,r,!0,i);n=a.raw;const l=(0,b.toValuesTree)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),d=Object.keys(n),E=this.toOverrides(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:l,keys:d,overrides:E,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}filter(n,i,r,a){let l=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:l};const d={},E=[];for(const k in n)if(y.OVERRIDE_PROPERTY_REGEX.test(k)&&r){const F=this.filter(n[k],i,!1,a);d[k]=F.raw,l=l||F.hasExcludedProperties,E.push(...F.restricted)}else{const F=i[k],Y=F?typeof F.scope<"u"?F.scope:3:void 0;F?.restricted&&E.push(k),(Y===void 0||a.scopes===void 0||a.scopes.includes(Y))&&!(a.skipRestricted&&F?.restricted)?d[k]=n[k]:l=!0}return{raw:d,restricted:E,hasExcludedProperties:l}}toOverrides(n,i){const r=[];for(const a of Object.keys(n))if(y.OVERRIDE_PROPERTY_REGEX.test(a)){const l={};for(const d in n[a])l[d]=n[a][d];r.push({identifiers:(0,y.overrideIdentifiersFromKey)(a),keys:Object.keys(l),contents:(0,b.toValuesTree)(l,i)})}return r}}e.ConfigurationModelParser=D;class u extends N.Disposable{constructor(n,i,r,a){super(),this.userSettingsResource=n,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new D(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.any(T.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),T.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&r.isEqual(l.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new L}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=u;class g{constructor(n,i,r,a,l,d,E,k,F,Y,X,ee,le){this.key=n,this.overrides=i,this._value=r,this.overrideIdentifiers=a,this.defaultConfiguration=l,this.policyConfiguration=d,this.applicationConfiguration=E,this.userConfiguration=k,this.localUserConfiguration=F,this.remoteUserConfiguration=Y,this.workspaceConfiguration=X,this.folderConfigurationModel=ee,this.memoryConfigurationModel=le}get value(){return v(this._value)}inspect(n,i,r){const a=n.inspect(i,r);return{get value(){return v(a.value)},get override(){return v(a.override)},get merged(){return v(a.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class f{constructor(n,i,r,a,l=new L,d=new L,E=new O.ResourceMap,k=new L,F=new O.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=i,this._applicationConfiguration=r,this._localUserConfiguration=a,this._remoteUserConfiguration=l,this._workspaceConfiguration=d,this._folderConfigurations=E,this._memoryConfiguration=k,this._memoryConfigurationByResource=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(n,i,r){return this.getConsolidatedConfigurationModel(n,i,r).getValue(n)}updateValue(n,i,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new L,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(n):a.setValue(n,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,r){const a=this.getConsolidatedConfigurationModel(n,i,r),l=this.getFolderConfigurationModelForResource(i.resource,r),d=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,E=new Set;for(const k of a.overrides)for(const F of k.identifiers)a.getOverrideValue(n,F)!==void 0&&E.add(F);return new g(n,i,a.getValue(n),E.size?[...E]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,l||void 0,d)}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const r=[];if(!i){const{added:a,updated:l,removed:d}=w(this._defaultConfiguration,n);i=[...a,...l,...d]}for(const a of i)for(const l of(0,y.overrideIdentifiersFromKey)(a)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(l),E=n.getKeysForOverrideIdentifier(l),k=[...E.filter(F=>d.indexOf(F)===-1),...d.filter(F=>E.indexOf(F)===-1),...d.filter(F=>!I.equals(this._defaultConfiguration.override(l).getValue(F),n.override(l).getValue(F)))];r.push([l,k])}return this.updateDefaultConfiguration(n),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:r,removed:a}=w(this._policyConfiguration,n),l=[...i,...r,...a];return l.length&&this.updatePolicyConfiguration(n),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:r,removed:a,overrides:l}=w(this.applicationConfiguration,n),d=[...i,...r,...a];return d.length&&this.updateApplicationConfiguration(n),{keys:d,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:r,removed:a,overrides:l}=w(this.localUserConfiguration,n),d=[...i,...r,...a];return d.length&&this.updateLocalUserConfiguration(n),{keys:d,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:r,removed:a,overrides:l}=w(this.remoteUserConfiguration,n),d=[...i,...r,...a];return d.length&&this.updateRemoteUserConfiguration(n),{keys:d,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:r,removed:a,overrides:l}=w(this.workspaceConfiguration,n),d=[...i,...r,...a];return d.length&&this.updateWorkspaceConfiguration(n),{keys:d,overrides:l}}compareAndUpdateFolderConfiguration(n,i){const r=this.folderConfigurations.get(n),{added:a,updated:l,removed:d,overrides:E}=w(r,i),k=[...a,...l,...d];return(k.length||!r)&&this.updateFolderConfiguration(n,i),{keys:k,overrides:E}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:a,removed:l,overrides:d}=w(i,void 0);return{keys:[...r,...a,...l],overrides:d}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,i,r){let a=this.getConsolidatedConfigurationModelForResource(i,r);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:n},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const a=i.getFolder(n);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const l=this._memoryConfigurationByResource.get(n);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(n);a?(i=r.merge(a),this._foldersConsolidatedConfigurations.set(n,i)):i=r}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const r=i.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:r,overrides:a,keys:l}=this._folderConfigurations.get(i);return n.push([i,{contents:r,overrides:a,keys:l}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this._workspaceConfiguration.keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(a=>i.add(a))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),a=this.parseConfigurationModel(n.application),l=this.parseConfigurationModel(n.user),d=this.parseConfigurationModel(n.workspace),E=n.folders.reduce((k,F)=>(k.set(c.URI.revive(F[0]),this.parseConfigurationModel(F[1])),k),new O.ResourceMap);return new f(i,r,a,l,new L,d,E,new L,new O.ResourceMap)}static parseConfigurationModel(n){return new L(n.contents,n.keys,n.overrides)}}e.Configuration=f;function S(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,i=new Map;for(const a of o)a.keys.forEach(l=>n.add(l)),a.overrides.forEach(([l,d])=>{const E=(0,O.getOrSet)(i,l,new Set);d.forEach(k=>E.add(k))});const r=[];return i.forEach((a,l)=>r.push([l,[...a.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=S;class p{constructor(n,i,r,a){this.change=n,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=a,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const l of n.keys)this.affectedKeys.add(l);for(const[,l]of n.overrides)for(const d of l)this.affectedKeys.add(d);this._affectsConfigStr=this._marker;for(const l of this.affectedKeys)this._affectsConfigStr+=l+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){const r=this._marker+n,a=this._affectsConfigStr.indexOf(r);if(a<0)return!1;const l=a+r.length;if(l>=this._affectsConfigStr.length)return!1;const d=this._affectsConfigStr.charCodeAt(l);if(d!==this._markerCode1&&d!==this._markerCode2)return!1;if(i){const E=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,k=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!I.equals(E,k)}return!0}}e.ConfigurationChangeEvent=p;function w(o,n){const{added:i,removed:r,updated:a}=t(n?.rawConfiguration,o?.rawConfiguration),l=[],d=o?.getAllOverrideIdentifiers()||[],E=n?.getAllOverrideIdentifiers()||[];if(n){const k=E.filter(F=>!d.includes(F));for(const F of k)l.push([F,n.getKeysForOverrideIdentifier(F)])}if(o){const k=d.filter(F=>!E.includes(F));for(const F of k)l.push([F,o.getKeysForOverrideIdentifier(F)])}if(n&&o){for(const k of d)if(E.includes(k)){const F=t({contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)},{contents:n.getOverrideValue(void 0,k)||{},keys:n.getKeysForOverrideIdentifier(k)});l.push([k,[...F.added,...F.removed,...F.updated]])}}return{added:i,removed:r,updated:a,overrides:l}}function t(o,n){const i=o?n?o.keys.filter(l=>n.keys.indexOf(l)===-1):[...o.keys]:[],r=n?o?n.keys.filter(l=>o.keys.indexOf(l)===-1):[...n.keys]:[],a=[];if(o&&n){for(const l of n.keys)if(o.keys.indexOf(l)!==-1){const d=(0,b.getConfigurationValue)(n.contents,l),E=(0,b.getConfigurationValue)(o.contents,l);I.equals(d,E)||a.push(l)}}return{added:i,removed:r,updated:a}}}),define(ie[129],ne([0,1,19,5,2,30,3,66,42,6,38,34]),function(q,e,A,T,C,N,O,I,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends C.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(y.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:g})=>this.onDidUpdateConfiguration(Array.from(u),g))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(u,g){this.updateConfigurationModel(u,y.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:u})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new I.ConfigurationModel;const u=y.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(u),u)}updateConfigurationModel(u,g){const f=this.getConfigurationDefaultOverrides();for(const S of u){const p=f[S],w=g[S];p!==void 0?this._configurationModel.addValue(S,p):w?this._configurationModel.addValue(S,w.default):this._configurationModel.removeValue(S)}}}e.DefaultConfiguration=m;class v{constructor(){this.onDidChangeConfiguration=T.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=v;let L=e.PolicyConfiguration=class extends C.Disposable{get configurationModel(){return this._configurationModel}constructor(u,g,f){super(),this.defaultConfiguration=u,this.policyService=g,this.logService=f,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(u=>this.onDidChangePolicies(u))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:u})=>this.update(await this.updatePolicyDefinitions(u),!0))),this._configurationModel}async updatePolicyDefinitions(u){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",u);const g={},f=[],S=y.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const p of u){const w=S[p];if(!w){f.push(p);continue}if(w.policy){if(w.type!=="string"&&w.type!=="number"){this.logService.warn(`Policy ${w.policy.name} has unsupported type ${w.type}`);continue}f.push(p),g[w.policy.name]={type:w.type}}}return(0,O.isEmptyObject)(g)||await this.policyService.updatePolicyDefinitions(g),f}onDidChangePolicies(u){this.logService.trace("PolicyConfiguration#onDidChangePolicies",u);const g=y.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),f=(0,A.coalesce)(u.map(S=>g.get(S)));this.update(f,!0)}update(u,g){this.logService.trace("PolicyConfiguration#update",u);const f=y.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),S=[],p=this._configurationModel.isEmpty();for(const w of u){const t=f[w]?.policy?.name;if(t){const o=this.policyService.getPolicyValue(t);(p?o!==void 0:!(0,N.equals)(this._configurationModel.getValue(w),o))&&S.push([w,o])}else this._configurationModel.getValue(w)!==void 0&&S.push([w,void 0])}if(S.length){this.logService.trace("PolicyConfiguration#changed",S);const w=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const t of w.keys)this._configurationModel.setValue(t,w.getValue(t));for(const[t,o]of S)o===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,o);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=L=ve([te(1,b.IPolicyService),te(2,c.ILogService)],L)}),define(ie[130],ne([0,1,8,5,2,17,24,66,129,38]),function(q,e,A,T,C,N,O,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends C.Disposable{constructor(m,v,L,D){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new h.DefaultConfiguration),this.policyConfiguration=L instanceof c.NullPolicyService?new h.NullPolicyConfiguration:this._register(new h.PolicyConfiguration(this.defaultConfiguration,L,D)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,N.extUriBiasedIgnorePathCase,v)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new A.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:u,properties:g})=>this.onDidDefaultConfigurationChange(u,g))),this._register(this.policyConfiguration.onDidChangeConfiguration(u=>this.onDidPolicyConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,v,L]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(m,v,new I.ConfigurationModel,L)}getConfigurationData(){return this.configuration.toData()}getValue(m,v){const L=typeof m=="string"?m:void 0,D=(0,O.isConfigurationOverrides)(m)?m:(0,O.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(L,D,void 0)}updateValue(m,v,L,D){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const v=this.configuration.toData(),L=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(L,v,2)}onDidDefaultConfigurationChange(m,v){const L=this.configuration.toData(),D=this.configuration.compareAndUpdateDefaultConfiguration(m,v);this.trigger(D,L,7)}onDidPolicyConfigurationChange(m){const v=this.configuration.toData(),L=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(L,v,7)}trigger(m,v,L){const D=new I.ConfigurationChangeEvent(m,{data:v},this.configuration);D.source=L,D.sourceConfig=this.getTargetConfiguration(L),this._onDidChangeConfiguration.fire(D)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ie[67],ne([0,1,16]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(c){return c.scheme===A.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=T;function C(c){if(!c)return;const b=c.indexOf("+");return b<0?c:c.substr(0,b)}e.getRemoteName=C;function N(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=N;function O(c){const{host:b,port:y}=h(c);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:y}}e.parseAuthorityWithPort=O;function I(c,b){let{host:y,port:m}=h(c);return typeof m>"u"&&(m=b),{host:y,port:m}}e.parseAuthorityWithOptionalPort=I;function h(c){const b=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const y=c.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const m=c.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:c,port:void 0}}}),define(ie[35],ne([0,1,29,10,67]),function(q,e,A,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(D){if(typeof D=="object"&&D!==null&&D.supported!==!0)return D.description}e.getWorkspaceSupportTypeMessage=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(D){D[D.System=0]="System",D[D.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function(D){D.WIN32_X64="win32-x64",D.WIN32_IA32="win32-ia32",D.WIN32_ARM64="win32-arm64",D.LINUX_X64="linux-x64",D.LINUX_ARM64="linux-arm64",D.LINUX_ARMHF="linux-armhf",D.ALPINE_X64="alpine-x64",D.ALPINE_ARM64="alpine-arm64",D.DARWIN_X64="darwin-x64",D.DARWIN_ARM64="darwin-arm64",D.WEB="web",D.UNIVERSAL="universal",D.UNKNOWN="unknown",D.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class h{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,g){if(typeof u>"u"||u===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof u=="string"||typeof g=="string"){const f=typeof u=="string"?u:u.value,S=typeof g=="string"?g:g.value;return A.equalsIgnoreCase(f,S)}return u._lower===g._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.ExtensionIdentifier=h;class c{get size(){return this._set.size}constructor(u){if(this._set=new Set,u)for(const g of u)this.add(g)}add(u){this._set.add(h.toKey(u))}delete(u){return this._set.delete(h.toKey(u))}has(u){return this._set.has(h.toKey(u))}}e.ExtensionIdentifierSet=c;class b{constructor(){this._map=new Map}clear(){this._map.clear()}delete(u){this._map.delete(h.toKey(u))}get(u){return this._map.get(h.toKey(u))}has(u){return this._map.has(h.toKey(u))}set(u,g){this._map.set(h.toKey(u),g)}values(){return this._map.values()}forEach(u){this._map.forEach(u)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=b;function y(D){return m(D)}e.isApplicationScopedExtension=y;function m(D){return D.contributes&&D.contributes.localizations?D.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function v(D){return D.contributes&&D.contributes.authentication?D.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function L(D,u){if(u){const g=`onResolveRemoteAuthority:${(0,C.getRemoteName)(u)}`;return!!D.activationEvents?.includes(g)}return!1}e.isResolverExtension=L,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[131],ne([0,1,2,35,13]),function(q,e,A,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends A.Disposable{constructor(I,h,c,b,y){super(),this.userDataProfilesService=I,this.fileService=h,this.uriIdentityService=c,this.logService=y,this._register(b.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(b.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(I){for(const h of I)h.local&&this.invalidate(h.profileLocation)}onDidUnInstallExtension(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const h of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(h.extensionsResource,I)&&await this.deleteUserCacheFile(h);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(I){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(I.cacheHome,T.USER_MANIFEST_CACHE_FILE))}catch(h){(0,C.toFileOperationResult)(h)!==1&&this.logService.error(h)}}}e.ExtensionsManifestCache=N}),define(ie[43],ne([0,1,14,9,2,101,42,10,6,34]),function(q,e,A,T,C,N,O,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");class b{constructor(w){this.original=w}toJSON(){if(!this.headers){const w=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?w[t]="*****":w[t]=this.original[t];this.headers=w}return this.headers}}class y extends C.Disposable{constructor(w,t){super(),this.counter=0,this.logger=t.createLogger(w?"remotenetwork":"network",{name:w?(0,N.localize)(0,null):(0,N.localize)(1,null),when:h.CONTEXT_LOG_LEVEL.isEqualTo((0,h.LogLevelToString)(h.LogLevel.Trace)).serialize()})}async logAndRequest(w,t,o){const n=`${w} #${++this.counter}: ${t.url}`;this.logger.trace(`${n} - begin`,t.type,new b(t.headers??{}));try{const i=await o();return this.logger.trace(`${n} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${n} - error`,t.type,(0,T.getErrorMessage)(i)),i}}}e.AbstractRequestService=y;function m(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=m;function v(p){return p.res.statusCode===204}async function L(p){return v(p)?null:(await(0,A.streamToBuffer)(p.stream)).toString()}e.asText=L;async function D(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);return L(p)}e.asTextOrError=D;async function u(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);if(v(p))return null;const t=(await(0,A.streamToBuffer)(p.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.asJson=u;function g(p){S(p)}e.updateProxyConfigurationsScope=g;let f;function S(p){const w=c.Registry.as(O.Extensions.Configuration),t=f;f={id:"http",order:15,title:(0,N.localize)(2,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0}}},w.updateConfigurations({add:[f],remove:t?[t]:[]})}S(1)}),define(ie[132],ne([0,1,23,16,13,43]),function(q,e,A,T,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=e.DownloadService=class{constructor(h,c){this.requestService=h,this.fileService=c}async download(h,c,b=A.CancellationToken.None){if(h.scheme===T.Schemas.file||h.scheme===T.Schemas.vscodeRemote){await this.fileService.copy(h,c);return}const y={type:"GET",url:h.toString(!0)},m=await this.requestService.request(y,b);if(m.res.statusCode===200)await this.fileService.writeFile(c,m.stream);else{const v=await(0,N.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${v}`)}}};e.DownloadService=O=ve([te(0,N.IRequestService),te(1,C.IFileService)],O)}),define(ie[133],ne([0,1,134,3]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function C(O,I){return O.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:O.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function N(O,I,h={}){const c=(0,A.parse)(O),b=h.proxyUrl||C(c,I);if(!b)return null;const y=(0,A.parse)(b);if(!/^https?:$/.test(y.protocol||""))return null;const m={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,T.isBoolean)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((v,L)=>{q(["http-proxy-agent"],v,L)}))(m):new(await new Promise((v,L)=>{q(["https-proxy-agent"],v,L)}))(m)}e.getProxyAgent=N}),define(ie[135],ne([0,1,58,15,102,23,32,9,12,28,82,167,8,71]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let L;async function D(g,f,S,p){return S["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(p)&&!S["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),L||(L=m.Promises.withAsyncBody(async(w,t)=>{const o=new N.CancellationTokenSource;let n=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(n=(0,v.clamp)(i,1,120)*1e3);const r=setTimeout(()=>{o.dispose(!0),t(new Error((0,C.localize)(0,null)))},n);try{w(await u(f,o.token))}catch(a){!(0,I.isCancellationError)(a)&&!o.token.isCancellationRequested?t(new Error((0,C.localize)(1,null,(0,O.toErrorMessage)(a)))):w({})}finally{clearTimeout(r),o.dispose()}})),L)}e.getResolvedShellEnv=D;async function u(g,f){const S=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",S);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",p);const w=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(w+"({.*})"+w),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const n=await(0,b.getSystemShell)(h.OS,o);return g.trace("getUnixShellEnvironment#shell",n),new Promise((i,r)=>{if(f.isCancellationRequested)return r(new I.CancellationError);const a=(0,T.basename)(n);let l,d;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(l=`& '${process.execPath}' ${E} -p '''${w}'' + JSON.stringify(process.env) + ''${w}'''`,d=["-Login","-Command"]):(l=`'${process.execPath}' ${E} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,a==="tcsh"||a==="csh"?d=["-ic"]:d=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),l);const k=(0,A.spawn)(n,[...d,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(k.kill(),r(new I.CancellationError))),k.on("error",X=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(X)),r(X)});const F=[];k.stdout.on("data",X=>F.push(X));const Y=[];k.stderr.on("data",X=>Y.push(X)),k.on("close",(X,ee)=>{const le=Buffer.concat(F).toString("utf8");g.trace("getUnixShellEnvironment#raw",le);const re=Buffer.concat(Y).toString("utf8");if(re.trim()&&g.trace("getUnixShellEnvironment#stderr",re),X||ee)return r(new Error((0,C.localize)(2,null,X,ee)));const fe=t.exec(le),ce=fe?fe[1]:"{}";try{const se=JSON.parse(ce);S?se.ELECTRON_RUN_AS_NODE=S:delete se.ELECTRON_RUN_AS_NODE,p?se.ELECTRON_NO_ATTACH_CONSOLE=p:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",se),i(se)}catch(se){g.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(se)),r(se)}})})}}),define(ie[136],ne([0,1,10]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,A.createDecorator)("stateReadService"),e.IStateService=(0,A.createDecorator)("stateService")}),define(ie[68],ne([0,1,8,14,3,18,13,6]),function(q,e,A,T,C,N,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var h;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(h||(e.SaveStrategy=h={}));class c{constructor(v,L,D,u){this.storagePath=v,this.logService=D,this.fileService=u,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=L===0?void 0:new A.ThrottledDelayer(100)}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}}getItem(v,L){const D=this.storage[v];return(0,C.isUndefinedOrNull)(D)?L:D}setItem(v,L){this.setItems([{key:v,data:L}])}setItems(v){let L=!1;for(const{key:D,data:u}of v)this.storage[D]!==u&&((0,C.isUndefinedOrNull)(u)?(0,C.isUndefined)(this.storage[D])||(this.storage[D]=void 0,L=!0):(this.storage[D]=u,L=!0));L&&this.save()}removeItem(v){(0,C.isUndefined)(this.storage[v])||(this.storage[v]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const v=JSON.stringify(this.storage,null,4);if(v!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,T.VSBuffer.fromString(v)),this.lastSavedStorageContents=v}catch(L){this.logService.error(L)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=c;let b=e.StateReadonlyService=class{constructor(v,L,D,u){this.fileStorage=new c(L.stateResource,v,D,u)}async init(){await this.fileStorage.init()}getItem(v,L){return this.fileStorage.getItem(v,L)}};e.StateReadonlyService=b=ve([te(1,N.IEnvironmentService),te(2,I.ILogService),te(3,O.IFileService)],b);class y extends b{setItem(v,L){this.fileStorage.setItem(v,L)}setItems(v){this.fileStorage.setItems(v)}removeItem(v){this.fileStorage.removeItem(v)}close(){return this.fileStorage.close()}}e.StateService=y}),define(ie[69],ne([0,1,12,37,28]),function(q,e,A,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(h){if(A.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function O(h,c,b,y,m,v,L,D){const u=Object.create(null);u["common.machineId"]=v,u.sessionID=(0,C.generateUuid)()+Date.now(),u.commitHash=y,u.version=m,u["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,A.PlatformToString)(A.platform),u["common.nodePlatform"]=T.platform,u["common.nodeArch"]=b,u["common.product"]=D||"desktop",L&&(u["common.msftInternal"]=L);let g=0;const f=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),A.isLinuxSnap&&(u["common.snap"]="true");const S=N(c);return S&&(u["common.platformDetail"]=S),u}e.resolveCommonProperties=O;function I(h){const c=T.env.USERDNSDOMAIN;if(!c)return!1;const b=c.toLowerCase();return h.some(y=>b===y)}e.verifyMicrosoftInternalDomain=I}),define(ie[25],ne([0,1,10]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,A.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,A.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var C;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(ie[39],ne([0,1,30,3,5,24,67,69,25]),function(q,e,A,T,C,N,O,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=c;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class y{async publicLog(r,a,l){}async publicLogError(r,a,l){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(i,r){return C.Event.debounce(r.onDidChangeConfiguration,(l,d)=>{const E=l?new Set([...l.affectedKeys,...d.affectedKeys]):d.affectedKeys;return{...d,affectedKeys:E}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,N.ConfigurationTargetToString)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.configurationTelemetry=m;function v(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=v;function L(i,r){return!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=L;function D(i){const r=i.getValue(h.TELEMETRY_SETTING_ID),a=i.getValue(h.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(h.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=D;function u(i){const r={},a={},l={};S(i,l);for(let d in l){d=d.length>150?d.substr(d.length-149):d;const E=l[d];typeof E=="number"?a[d]=E:typeof E=="boolean"?a[d]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${E.length}`),r[d]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(r[d]=E)}return{properties:r,measurements:a}}e.validateTelemetryData=u;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(i){if(!i)return"none";const r=(0,O.getRemoteName)(i);return g.has(r)?r:"other"}e.cleanRemoteAuthority=f;function S(i,r,a=0,l){if(i)for(const d of Object.getOwnPropertyNames(i)){const E=i[d],k=l?l+d:d;Array.isArray(E)?r[k]=(0,A.safeStringify)(E):E instanceof Date?r[k]=E.toISOString():(0,T.isObject)(E)?a<2?S(E,r,a+1,k+"."):r[k]=(0,A.safeStringify)(E):r[k]=E}}function p(i,r){const a=i.msftInternalDomains||[],l=r.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(a)||l}e.isInternalTelemetry=p;function w(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=w;function t(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const l=[];for(const F of r)for(;;){const Y=F.exec(i);if(!Y)break;l.push([Y.index,F.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(a="";;){const F=E.exec(i);if(!F)break;const Y=l.some(([X,ee])=>F.index<ee&&X<E.lastIndex);!d.test(F[0])&&!Y&&(a+=i.substring(k,F.index)+"<REDACTED: user-file-path>",k=E.lastIndex)}return k<i.length&&(a+=i.substr(k)),a}function o(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of r)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function n(i,r){return(0,A.cloneAndChange)(i,a=>{if(a instanceof c||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let l=a.replaceAll("%20"," ");l=t(l,r);for(const d of r)l=l.replace(d,"");return l=o(l),l}})}e.cleanData=n}),define(ie[26],ne([0,1,29,20,35,12,11,9,37,39]),function(q,e,A,T,C,N,O,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,A.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=b;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(i){const r=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new m(i.identifier,r,a)}static parse(i){const r=y.exec(i);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,a="undefined"){this.version=r,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof m?b(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=m;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function L(n){const i=v.exec(n);return i&&i[1]?[u(i[1]),i[2]]:[u(n),void 0]}e.getIdAndVersion=L;function D(n,i){return`${n}.${i}`}e.getExtensionId=D;function u(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=u;function g(n,i){return u(D(n??C.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=g;function f(n,i){const r=[],a=l=>{for(const d of r)if(d.some(E=>b(i(E),i(l))))return d;return null};for(const l of n){const d=a(l);d?d.push(l):r.push([l])}return r}e.groupByExtension=f;function S(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function p(n){return{id:new c.TelemetryTrustedValue(n.identifier.id),name:new c.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function w(n,i){const r=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const l=a.shift();if(l&&r.every(d=>!b(d.identifier,{id:l}))){const d=n.filter(E=>b(E.identifier,{id:l}));d.length===1&&(r.push(d[0]),a.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=w;async function t(n,i){if(!N.isLinux)return!1;let r;try{r=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(l))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,i){const r=await t(n,i),a=(0,T.getTargetPlatform)(r?"alpine":N.platform,h.arch);return i.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=o}),define(ie[137],ne([0,1,23,9,16,17,41,11,91,20,26,35]),function(q,e,A,T,C,N,O,I,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const m=u=>(0,h.localize)(0,null,u),v=(0,h.localize)(1,null,"ms-dotnettools.csharp");function L(u,g){return g?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let D=e.ExtensionManagementCLI=class{constructor(g,f,S){this.logger=g,this.extensionManagementService=f,this.extensionGalleryService=S}get location(){}async listExtensions(g,f,S){let p=await this.extensionManagementService.getInstalled(1,S);const w=y.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(f&&f!==""){if(w.indexOf(f.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.logger.info("Possible Categories: "),w.forEach(o=>{this.logger.info(o)});return}this.location&&this.logger.info((0,h.localize)(2,null,this.location)),p=p.sort((o,n)=>o.identifier.id.localeCompare(n.identifier.id));let t;for(const o of p)t!==o.identifier.id&&(t=o.identifier.id,this.logger.info(L(o.manifest,g)))}async installExtensions(g,f,S,p){const w=[];try{const t=[];g.length&&this.logger.info(this.location?(0,h.localize)(3,null,this.location):(0,h.localize)(4,null));const o=[];let n=[];const i=(a,l,d)=>{n.push({id:a,version:l!=="prerelease"?l:void 0,installOptions:{...S,isBuiltin:d,installPreReleaseVersion:l==="prerelease"||S.installPreReleaseVersion}})};for(const a of g)if(a instanceof I.URI)o.push({vsix:a,installOptions:S});else{const[l,d]=(0,b.getIdAndVersion)(a);i(l,d,!1)}for(const a of f)if(a instanceof I.URI)o.push({vsix:a,installOptions:{...S,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,d]=(0,b.getIdAndVersion)(a);i(l,d,!0)}const r=await this.extensionManagementService.getInstalled(1,S.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:a,installOptions:l})=>{try{const d=await this.installVSIX(a,l,p,r);d&&t.push(d)}catch(d){this.logger.error(d),w.push(a.toString())}})),n.length&&(n=n.filter(({id:a,version:l})=>{const d=r.find(E=>(0,b.areSameExtensions)(E.identifier,{id:a}));if(d){if(!p&&(!l||l==="prerelease"&&d.preRelease))return this.logger.info((0,h.localize)(5,null,a,d.manifest.version,a)),!1;if(l&&d.manifest.version===l)return this.logger.info((0,h.localize)(6,null,`${a}@${l}`)),!1}return!0}),n.length)){const a=await this.getGalleryExtensions(n);await Promise.all(n.map(async l=>{const d=a.get(l.id.toLowerCase());if(d)try{const E=await this.installFromGallery(l,d,r);E&&t.push(E)}catch(E){this.logger.error(E.message||E.stack||E),w.push(l.id)}else this.logger.error(`${m(l.version?`${l.id}@${l.version}`:l.id)}
${v}`),w.push(l.id)}))}}catch(t){throw this.logger.error((0,h.localize)(7,null,(0,T.getErrorMessage)(t))),t}if(w.length)throw new Error((0,h.localize)(8,null,w.join(", ")))}async installVSIX(g,f,S,p){const w=await this.extensionManagementService.getManifest(g);if(!w)throw new Error("Invalid vsix");if(await this.validateVSIX(w,S,f.profileLocation,p))try{return await this.extensionManagementService.install(g,f),this.logger.info((0,h.localize)(9,null,(0,N.basename)(g))),w}catch(o){if((0,T.isCancellationError)(o))return this.logger.info((0,h.localize)(10,null,(0,N.basename)(g))),null;throw o}return null}async getGalleryExtensions(g){const f=new Map,S=g.some(t=>t.installOptions.installPreReleaseVersion),p=await this.extensionManagementService.getTargetPlatform(),w=[];for(const t of g)c.EXTENSION_IDENTIFIER_REGEX.test(t.id)&&w.push({...t,preRelease:S});if(w.length){const t=await this.extensionGalleryService.getExtensions(w,{targetPlatform:p},A.CancellationToken.None);for(const o of t)f.set(o.identifier.id.toLowerCase(),o)}return f}async installFromGallery({id:g,version:f,installOptions:S},p,w){const t=await this.extensionGalleryService.getManifest(p,A.CancellationToken.None);if(t&&!this.validateExtensionKind(t))return null;const o=w.find(n=>(0,b.areSameExtensions)(n.identifier,p.identifier));if(o){if(p.version===o.manifest.version)return this.logger.info((0,h.localize)(11,null,f?`${g}@${f}`:g)),null;this.logger.info((0,h.localize)(12,null,g,p.version))}try{S.isBuiltin?this.logger.info(f?(0,h.localize)(13,null,g,f):(0,h.localize)(14,null,g)):this.logger.info(f?(0,h.localize)(15,null,g,f):(0,h.localize)(16,null,g));const n=await this.extensionManagementService.installFromGallery(p,{...S,installGivenVersion:!!f});return this.logger.info((0,h.localize)(17,null,g,n.manifest.version)),t}catch(n){if((0,T.isCancellationError)(n))return this.logger.info((0,h.localize)(18,null,g)),null;throw n}}validateExtensionKind(g){return!0}async validateVSIX(g,f,S,p){if(!f){const w={id:(0,b.getGalleryExtensionId)(g.publisher,g.name)},t=p.find(o=>(0,b.areSameExtensions)(w,o.identifier)&&(0,O.gt)(o.manifest.version,g.version));if(t)return this.logger.info((0,h.localize)(19,null,t.identifier.id,t.manifest.version,g.version)),!1}return this.validateExtensionKind(g)}async uninstallExtensions(g,f,S){const p=async t=>{if(t instanceof I.URI){const o=await this.extensionManagementService.getManifest(t);return L(o)}return t},w=[];for(const t of g){const o=await p(t),i=(await this.extensionManagementService.getInstalled(void 0,S)).filter(r=>(0,b.areSameExtensions)(r.identifier,{id:o}));if(!i.length)throw new Error(`${this.notInstalled(o)}
${v}`);if(i.some(r=>r.type===0)){this.logger.info((0,h.localize)(20,null,o));return}if(!f&&i.some(r=>r.isBuiltin)){this.logger.info((0,h.localize)(21,null,o));return}this.logger.info((0,h.localize)(22,null,o));for(const r of i)await this.extensionManagementService.uninstall(r,{profileLocation:S}),w.push(r);this.location?this.logger.info((0,h.localize)(23,null,o,this.location)):this.logger.info((0,h.localize)(24,null,o))}}async locateExtension(g){const f=await this.extensionManagementService.getInstalled();g.forEach(S=>{f.forEach(p=>{if(p.identifier.id===S&&p.location.scheme===C.Schemas.file){this.logger.info(p.location.fsPath);return}})})}notInstalled(g){return this.location?(0,h.localize)(25,null,g,this.location):(0,h.localize)(26,null,g)}};e.ExtensionManagementCLI=D=ve([te(1,c.IExtensionManagementService),te(2,c.IExtensionGalleryService)],D)}),define(ie[138],ne([0,1,5,2,33,26,35]),function(q,e,A,T,C,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class I extends T.Disposable{constructor(c,b,y,m,v,L,D){super(),this.extensionManagementService=c,this.extensionsScannerService=b,this.userDataProfilesService=y,this.extensionsProfileScannerService=m,this.uriIdentityService=v,this.fileService=L,this.logService=D,this._onDidChangeExtensionsByAnotherSource=this._register(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new T.DisposableMap),this.initialize().then(null,u=>D.error(u))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(c=>this.onDidChangeProfiles(c.added,c.removed))),this._register(this.extensionsProfileScannerService.onAddExtensions(c=>this.onAddExtensions(c))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(c=>this.onDidAddExtensions(c))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(c=>this.onRemoveExtensions(c))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(c=>this.onDidRemoveExtensions(c))),this._register(this.fileService.onDidFilesChange(c=>this.onDidFilesChange(c)))}async onDidChangeProfiles(c,b){try{await Promise.all(b.map(y=>(this.extensionsProfileWatchDisposables.deleteAndDispose(y.id),this.removeExtensionsFromProfile(y.extensionsResource)))),c.length&&await Promise.all(c.map(y=>(this.extensionsProfileWatchDisposables.set(y.id,(0,T.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(y.extensionsResource)),this.fileService.watch(y.extensionsResource))),this.populateExtensionsFromProfile(y.extensionsResource))))}catch(y){throw this.logService.error(y),y}}async onAddExtensions(c){for(const b of c.extensions)this.addExtensionWithKey(this.getKey(b.identifier,b.version),c.profileLocation)}async onDidAddExtensions(c){for(const b of c.extensions){const y=this.getKey(b.identifier,b.version);c.error?this.removeExtensionWithKey(y,c.profileLocation):this.addExtensionWithKey(y,c.profileLocation)}}async onRemoveExtensions(c){for(const b of c.extensions)this.removeExtensionWithKey(this.getKey(b.identifier,b.version),c.profileLocation)}async onDidRemoveExtensions(c){const b=[],y=[];for(const m of c.extensions){const v=this.getKey(m.identifier,m.version);c.error?this.addExtensionWithKey(v,c.profileLocation):(this.removeExtensionWithKey(v,c.profileLocation),this.allExtensions.has(v)||(this.logService.debug("Extension is removed from all profiles",m.identifier.id,m.version),y.push(this.extensionManagementService.scanInstalledExtensionAtLocation(m.location).then(L=>{L?b.push(L):this.logService.info("Extension not found at the location",m.location.toString())},L=>this.logService.error(L)))))}try{await Promise.all(y),b.length&&await this.uninstallExtensionsNotInProfiles(b)}catch(m){this.logService.error(m)}}onDidFilesChange(c){for(const b of this.userDataProfilesService.profiles)c.contains(b.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(b.extensionsResource)}async onDidExtensionsProfileChange(c){const b=[],y=[],m=await this.extensionsProfileScannerService.scanProfileExtensions(c),v=new Set,L=new Set;for(const[D,u]of this.allExtensions)u.has(c)&&L.add(D);for(const D of m){const u=this.getKey(D.identifier,D.version);v.add(u),L.has(u)||(b.push(D.identifier),this.addExtensionWithKey(u,c))}for(const D of L)if(!v.has(D)){const u=this.fromKey(D);u&&(y.push(u.identifier),this.removeExtensionWithKey(D,c))}(b.length||y.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b.length?{extensions:b,profileLocation:c}:void 0,removed:y.length?{extensions:y,profileLocation:c}:void 0})}async populateExtensionsFromProfile(c){const b=await this.extensionsProfileScannerService.scanProfileExtensions(c);for(const y of b)this.addExtensionWithKey(this.getKey(y.identifier,y.version),c)}async removeExtensionsFromProfile(c){for(const b of[...this.allExtensions.keys()])this.removeExtensionWithKey(b,c);await this.uninstallExtensionsNotInProfiles()}async uninstallExtensionsNotInProfiles(c){c||(c=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(y=>!this.allExtensions.has(this.getKey(y.identifier,y.manifest.version)))),c.length&&await this.extensionManagementService.markAsUninstalled(...c)}addExtensionWithKey(c,b){let y=this.allExtensions.get(c);y||this.allExtensions.set(c,y=new C.ResourceSet(m=>this.uriIdentityService.extUri.getComparisonKey(m))),y.add(b)}removeExtensionWithKey(c,b){const y=this.allExtensions.get(c);y&&y.delete(b),y?.size||this.allExtensions.delete(c)}getKey(c,b){return`${O.ExtensionIdentifier.toKey(c.id)}@${b}`}fromKey(c){const[b,y]=(0,N.getIdAndVersion)(c);return y?{identifier:{id:b},version:y}:void 0}}e.ExtensionsWatcher=I}),define(ie[139],ne([0,1,110,39]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function C(N,O,I,h,c,b,y){const m={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${O.nameShort})`};if((0,T.supportsTelemetry)(O,I)&&(0,T.getTelemetryLevel)(h)===3){const v=await(0,A.getServiceMachineId)(I,c,b);m["X-Market-User-Id"]=v,m["VSCode-SessionId"]=y.machineId||v}return m}e.resolveMarketplaceHeaders=C}),define(ie[140],ne([0,1,168,19,8,2,16,15,22,18,20,26,6,64,11]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let D=e.NativeLanguagePackService=class extends v.LanguagePackBaseService{constructor(S,p,w,t){super(w),this.extensionManagementService=S,this.logService=t,this.cache=this._register(new u(p,t)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(S,p){const t=(await this.cache.getLanguagePacks())[p];if(!t){this.logService.warn(`No language pack found for ${p}`);return}const o=t.translations[S];return o?L.URI.file(o):void 0}async getInstalledLanguages(){const S=await this.cache.getLanguagePacks(),p=Object.keys(S).map(w=>{const t=S[w];return{...this.createQuickPickItem(w,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.createQuickPickItem("en","English")),p.sort((w,t)=>w.label.localeCompare(t.label)),p}async postInstallExtension(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",S.identifier.id),await this.update())}async postUninstallExtension(S){const p=await this.cache.getLanguagePacks();Object.keys(p).some(w=>p[w]&&p[w].extensions.some(t=>(0,y.areSameExtensions)(t.extensionIdentifier,S.identifier)))&&(this.logService.info("Removing language packs from the extension",S.identifier.id),await this.update())}async update(){const[S,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),w=await this.cache.update(p);return!(0,T.equals)(Object.keys(S),Object.keys(w))}};e.NativeLanguagePackService=D=ve([te(0,b.IExtensionManagementService),te(1,c.INativeEnvironmentService),te(2,b.IExtensionGalleryService),te(3,m.ILogService)],D);let u=class extends N.Disposable{constructor(S,p){super(),this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(S.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new C.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(S){return this.withLanguagePacks(p=>{Object.keys(p).forEach(w=>delete p[w]),this.createLanguagePacksFromExtensions(p,...S)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(S,...p){for(const w of p)w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(S,w);Object.keys(S).forEach(w=>this.updateHash(S[w]))}createLanguagePacksFromExtension(S,p){const w=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of t)if(p.location.scheme===O.Schemas.file&&g(o)){let n=S[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},S[o.languageId]=n);const i=n.extensions.filter(r=>(0,y.areSameExtensions)(r.extensionIdentifier,w))[0];i?i.version=p.manifest.version:n.extensions.push({extensionIdentifier:w,version:p.manifest.version});for(const r of o.translations)n.translations[r.id]=(0,I.join)(p.location.fsPath,r.path)}}updateHash(S){if(S){const p=(0,A.createHash)("md5");for(const w of S.extensions)p.update(w.extensionIdentifier.uuid||w.extensionIdentifier.id).update(w.version);S.hash=p.digest("hex")}}withLanguagePacks(S=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return h.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,w=>w.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(w)).then(w=>{try{return JSON.parse(w)}catch{return{}}}).then(w=>(p=S(w),w)).then(w=>{for(const o of Object.keys(w))w[o]||delete w[o];this.languagePacks=w,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),h.Promises.writeFile(this.languagePacksFilePath,t)}).then(()=>p,w=>this.logService.error(w))})}};u=ve([te(0,c.INativeEnvironmentService),te(1,m.ILogService)],u);function g(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const S of f.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ie[141],ne([0,1,9,30,39]),function(q,e,A,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const N="https://0.0.0.0/OneCollector/1.0",O="https://0.0.0.0/ping";async function I(c,b,y){const m=await new Promise((g,f)=>{q(["@microsoft/1ds-core-js"],g,f)}),v=await new Promise((g,f)=>{q(["@microsoft/1ds-post-js"],g,f)}),L=new m.AppInsightsCore,D=new v.PostChannel,u={instrumentationKey:c,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[D]]};if(y){u.extensionConfig={};const g={alwaysUseXhrOverride:!0,httpXHROverride:y};u.extensionConfig[D.identifier]=g}return L.initialize(u,[]),L.addTelemetryInitializer(g=>{b&&(g.ext=g.ext??{},g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),L}class h{constructor(b,y,m,v,L){this._isInternalTelemetry=b,this._eventPrefix=y,this._defaultData=m,this._xhrOverride=L,this.endPointUrl=N,this.endPointHealthUrl=O,this._defaultData||(this._defaultData={}),typeof v=="function"?this._aiCoreOrKey=v():this._aiCoreOrKey=v,this._asyncAiCore=null}_withAIClient(b){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){b(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=I(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(y=>{b(y)},y=>{(0,A.onUnexpectedError)(y),console.error(y)})}}log(b,y){if(!this._aiCoreOrKey)return;y=(0,T.mixin)(y,this._defaultData),y=(0,C.validateTelemetryData)(y);const m=this._eventPrefix+"/"+b;try{this._withAIClient(v=>{v.pluginVersionString=y?.properties.version??"Unknown",v.track({name:m,baseData:{name:m,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(b=>{this._withAIClient(y=>{y.unload(!0,()=>{this._aiCoreOrKey=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=h}),define(ie[142],ne([0,1,2,30,12,29,103,24,42,143,31,34,25,39]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let L=e.TelemetryService=class{constructor(g,f,S){this._configurationService=f,this._productService=S,this._experimentProperties={},this._disposables=new A.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,N.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,N.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(p=>{(p.affectsConfiguration(m.TELEMETRY_SETTING_ID)||p.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(g,f){this._experimentProperties[g]=f}_updateTelemetryLevel(){let g=(0,v.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const S=f.usage?3:f.error?2:0;g=Math.min(g,S)}this._telemetryLevel=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(g,f,S){this._telemetryLevel<f||(S=(0,T.mixin)(S,this._experimentProperties),S=(0,v.cleanData)(S,this._cleanupPatterns),S=(0,T.mixin)(S,this._commonProperties),this._appenders.forEach(p=>p.log(g,S)))}publicLog(g,f){this._log(g,3,f)}publicLog2(g,f){this.publicLog(g,f)}publicLogError(g,f){this._sendErrorTelemetry&&this._log(g,2,f)}publicLogError2(g,f){this.publicLogError(g,f)}};L.IDLE_START_EVENT_NAME="UserIdleStart",L.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=L=ve([te(1,I.IConfigurationService),te(2,b.IProductService)],L);function D(){const u=(0,O.localize)(0,null,c.default.nameLong),g=c.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=C.isWeb?"":(0,O.localize)(3,null),S=(0,O.localize)(4,null),p=(0,O.localize)(5,null),w=(0,O.localize)(6,null),t=(0,O.localize)(7,null),o=`
|       | ${S} | ${p} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${u} ${g} ${f}

&nbsp;

${t}
${o}

&nbsp;

${n}
`}y.Registry.as(h.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:D(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(h.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,O.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,O.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[144],ne([0,1,169,141]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class C extends T.AbstractOneDataSystemAppender{constructor(O,I,h,c){const b={sendPOST:(y,m)=>{const v={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const L=A.request(y.urlString,v,D=>{D.on("data",function(u){m(D.statusCode??200,D.headers,u.toString())}),D.on("error",function(u){m(0,{})})});L.write(y.data),L.end()}catch{m(0,{})}}};super(O,I,h,c,b)}}e.OneDataSystemAppender=C}),define(ie[145],ne([0,1,15,22]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function C(N,O){const I=Object.create(null),h=(b,y)=>{const m=JSON.parse(b);I[y]=m};if(O){const b=[],y=await T.Promises.readdir(O);for(const v of y)try{(await T.Promises.stat((0,A.join)(O,v))).isDirectory()&&b.push(v)}catch{}const m=[];for(const v of b)(await T.Promises.readdir((0,A.join)(O,v))).filter(D=>D==="telemetry.json").length===1&&m.push(v);for(const v of m){const L=(await T.Promises.readFile((0,A.join)(O,v,"telemetry.json"))).toString();h(L,v)}}let c=(await T.Promises.readFile((0,A.join)(N,"telemetry-core.json"))).toString();return h(c,"vscode-core"),c=(await T.Promises.readFile((0,A.join)(N,"telemetry-extensions.json"))).toString(),h(c,"vscode-extensions"),JSON.stringify(I,null,4)}e.buildTelemetryMessage=C}),define(ie[146],ne([0,1,12,80,25]),function(q,e,A,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function N(O,I){let h=O.getItem(C.machineIdKey);return(typeof h!="string"||A.isMacintosh&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,T.getMachineId)(I.error.bind(I))),h}e.resolveMachineId=N}),define(ie[27],ne([0,1,10]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,A.createDecorator)("IUriIdentityService")}),define(ie[147],ne([0,1,27,111,13,17,72,5,2]),function(q,e,A,T,C,N,O,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(m){this.uri=m,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let b=e.UriIdentityService=class{constructor(m){this._fileService=m,this._dispooables=new h.DisposableStore,this._limit=2**16;const v=new Map,L=D=>{let u=v.get(D.scheme);return u===void 0&&(u=m.hasProvider(D)&&!this._fileService.hasCapability(D,1024),v.set(D.scheme,u)),u};this._dispooables.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(D=>{v.delete(D.scheme)})),this.extUri=new N.ExtUri(L),this._canonicalUris=new O.SkipList((D,u)=>this.extUri.compare(D,u,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,N.normalizePath)(m));const v=this._canonicalUris.get(m);return v?v.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new c(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((L,D)=>L[1].time<D[1].time?1:L[1].time>D[1].time?-1:0);c._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let L=0;L<v;L++)this._canonicalUris.set(m[L][0],m[L][1].touch())}};e.UriIdentityService=b=ve([te(0,C.IFileService)],b),(0,T.registerSingleton)(A.IUriIdentityService,b,1)}),define(ie[148],ne([0,1,105,15,55,17,11,10,16]),function(q,e,A,T,C,N,O,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function c(i){const r=i;return typeof r?.id=="string"&&O.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=c;function b(i){return typeof i?.id=="string"&&!c(i)&&!m(i)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,T.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=y;function m(i){const r=i;return typeof r?.id=="string"&&O.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=m;function v(i){const r=i;if(r?.uri)return{id:r.id,uri:O.URI.revive(r.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:O.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=v;var L;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(L||(e.WorkbenchState=L={}));function D(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=D;function u(i){const r=i;return!!(r&&typeof r=="object"&&O.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=u;class g{constructor(r,a,l,d,E){this._id=r,this._transient=l,this._configuration=d,this._ignorePathCasing=E,this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=a}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class f{constructor(r,a){this.raw=a,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,N.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function S(i){return new f({uri:i,index:0,name:(0,N.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(i,r){return N.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function w(i){let r;return O.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=w,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function o(i,r){return!p(i,r)&&!w(i)}e.isSavedWorkspace=o;function n(i){return(typeof i=="string"?(0,T.extname)(i):(0,N.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(ie[21],ne([0,1,45,5,2,17,11,104,18,13,10,6,148,33,27,8,28,29,3]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v,L,D,u,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function S(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&O.URI.isUri(i.location)&&O.URI.isUri(i.globalStorageHome)&&O.URI.isUri(i.settingsResource)&&O.URI.isUri(i.keybindingsResource)&&O.URI.isUri(i.tasksResource)&&O.URI.isUri(i.snippetsHome)&&O.URI.isUri(i.extensionsResource))}e.isUserDataProfile=S,e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function p(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:O.URI.revive(n.location).with({scheme:i}),globalStorageHome:O.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:O.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:O.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:O.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:O.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:O.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:O.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=p;function w(n,i,r,a,l){return{id:n,name:i,location:r,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,N.joinPath)(r,"globalStorage"),settingsResource:(0,N.joinPath)(r,"settings.json"),keybindingsResource:(0,N.joinPath)(r,"keybindings.json"),tasksResource:(0,N.joinPath)(r,"tasks.json"),snippetsHome:(0,N.joinPath)(r,"snippets"),extensionsResource:(0,N.joinPath)(r,"extensions.json"),cacheHome:(0,N.joinPath)(a,n),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=w;let t=e.UserDataProfilesService=class extends C.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,r,a,l){super(),this.environmentService=i,this.fileService=r,this.uriIdentityService=a,this.logService=l,this.enabled=!0,this._onDidChangeProfiles=this._register(new T.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new T.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new T.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new T.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new v.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,N.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,N.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=[];if(this.enabled)try{for(const d of this.getStoredProfiles()){if(!d.name||!(0,f.isString)(d.name)||!d.location){this.logService.warn("Skipping the invalid stored profile",d.location||d.name);continue}i.push(w((0,N.basename)(d.location),d.name,d.location,this.profilesCacheHome,{shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}))}}catch(d){this.logService.error(d)}const r=new v.ResourceMap,a=new Map,l=this.createDefaultProfile();if(i.unshift({...l,extensionsResource:this.getDefaultProfileExtensionsLocation()??l.extensionsResource,isDefault:!0}),i.length)try{const d=this.getStoredProfileAssociations();if(d.workspaces)for(const[E,k]of Object.entries(d.workspaces)){const F=O.URI.parse(E),Y=i.find(X=>X.id===k);Y&&r.set(F,Y)}if(d.emptyWindows)for(const[E,k]of Object.entries(d.emptyWindows)){const F=i.find(Y=>Y.id===k);F&&a.set(E,F)}}catch(d){this.logService.error(d)}this._profilesObject={profiles:i,workspaces:r,emptyWindows:a}}return this._profilesObject}createDefaultProfile(){return w("__default__profile__",(0,I.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome)}async createTransientProfile(i){const r="Temp",a=new RegExp(`${(0,g.escapeRegExpCharacters)(r)}\\s(\\d+)`);let l=0;for(const E of this.profiles){const k=a.exec(E.name),F=k?parseInt(k[1]):0;l=F>l?F:l}const d=`${r} ${l+1}`;return this.createProfile((0,A.hash)((0,u.generateUuid)()).toString(16),d,{transient:!0},i)}async createNamedProfile(i,r,a){return this.createProfile((0,A.hash)((0,u.generateUuid)()).toString(16),i,r,a)}async createProfile(i,r,a,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const d=await this.doCreateProfile(i,r,a);return l&&await this.setProfileForWorkspace(l,d),d}async doCreateProfile(i,r,a){if(!(0,f.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let l=this.profileCreationPromises.get(r);return l||(l=(async()=>{try{const d=this.profiles.find(F=>F.name===r||F.id===i);if(d)return d;const E=w(i,r,(0,N.joinPath)(this.profilesHome,i),this.profilesCacheHome,a);await this.fileService.createFolder(E.location);const k=[];return this._onWillCreateProfile.fire({profile:E,join(F){k.push(F)}}),await D.Promises.settled(k),this.updateProfiles([E],[],[]),E}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,l)),l}async updateProfile(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(l=>l.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=w(a.id,r.name??a.name,a.location,this.profilesCacheHome,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags}),this.updateProfiles([],[],[a]),a}async removeProfile(i){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(l=>l.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:r,join(l){a.push(l)}});try{await Promise.allSettled(a)}catch(l){this.logService.error(l)}for(const l of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(l)?.id&&this.profilesObject.emptyWindows.delete(l);for(const l of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(l)?.id&&this.profilesObject.workspaces.delete(l);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(l){(0,c.toFileOperationResult)(l)!==1&&this.logService.error(l)}try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(l){this.logService.error(l)}}async setProfileForWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(l=>l.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,a)}unsetWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(i,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.getWorkspace(i);return O.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(i){return(0,m.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,m.isWorkspaceIdentifier)(i)?i.configPath:i.id}isProfileAssociatedToWorkspace(i){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location)))}updateProfiles(i,r,a){const l=[...this.profiles,...i],d=[];this.transientProfilesObject.profiles=[];for(let E of l)E.isDefault||r.some(k=>E.id===k.id)||(E=a.find(k=>E.id===k.id)??E,E.isTransient?this.transientProfilesObject.profiles.push(E):d.push({location:E.location,name:E.name,shortName:E.shortName,useDefaultFlags:E.useDefaultFlags}));this.saveStoredProfiles(d),this._profilesObject=void 0,this.triggerProfilesChanges(i,r,a)}triggerProfilesChanges(i,r,a){this._onDidChangeProfiles.fire({added:i,removed:r,updated:a,all:this.profiles})}updateWorkspaceAssociation(i,r,a){a=r?.isTransient?!0:a,a||this.updateWorkspaceAssociation(i,void 0,!0);const l=this.getWorkspace(i),d=a?this.transientProfilesObject:this.profilesObject;O.URI.isUri(l)?(d.workspaces.delete(l),r&&d.workspaces.set(l,r)):(d.emptyWindows.delete(l),r&&d.emptyWindows.set(l,r)),a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[a,l]of this.profilesObject.workspaces.entries())i[a.toString()]=l.id;const r={};for(const[a,l]of this.profilesObject.emptyWindows.entries())r[a.toString()]=l.id;this.saveStoredProfileAssociations({workspaces:i,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(i){const r={},a=this.createDefaultProfile();if(i.workspaces)for(const[d,E]of Object.entries(i.workspaces)){const k=O.URI.parse(E);r[d]=this.uriIdentityService.extUri.isEqual(k,a.location)?a.id:this.uriIdentityService.extUri.basename(k)}const l={};if(i.emptyWindows)for(const[d,E]of Object.entries(i.emptyWindows)){const k=O.URI.parse(E);l[d]=this.uriIdentityService.extUri.isEqual(k,a.location)?a.id:this.uriIdentityService.extUri.basename(k)}return{workspaces:r,emptyWindows:l}}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};t.PROFILES_KEY="userDataProfiles",t.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e.UserDataProfilesService=t=ve([te(0,h.IEnvironmentService),te(1,c.IFileService),te(2,L.IUriIdentityService),te(3,y.ILogService)],t);class o extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=o}),define(ie[149],ne([0,1,19,8,23,9,5,2,12,3,11,89,20,26,35,6,31,25,21]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v,L,D,u,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let S=e.AbstractExtensionManagementService=class extends I.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(i,r,a,l,d){super(),this.galleryService=i,this.telemetryService=r,this.logService=a,this.productService=l,this.userDataProfilesService=d,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new O.Emitter),this._onDidInstallExtensions=this._register(new O.Emitter),this._onUninstallExtension=this._register(new O.Emitter),this._onDidUninstallExtension=this._register(new O.Emitter),this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(({task:E})=>E.cancel()),this.uninstallingExtensions.forEach(E=>E.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(a=>(0,m.isTargetPlatformCompatible)(a,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.galleryService.isEnabled())throw new m.ExtensionManagementError(y.localize(0,null),m.ExtensionManagementErrorCode.Internal);const a=await this.checkAndGetCompatibleVersion(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(a.manifest,a.extension,r)}catch(a){throw t(this.telemetryService,"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(i),error:a}),this.logService.error("Failed to install extension.",i.identifier.id),this.logService.error(a),w(a)}}async uninstall(i,r={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,r)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtension(i,r,a){const l=a.isApplicationScoped||a.isBuiltin||(0,L.isApplicationScopedExtension)(i),d={...a,installOnlyNewlyAddedFromExtensionPack:b.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:l,profileLocation:l?this.userDataProfilesService.defaultProfile.extensionsResource:a.profileLocation??this.getCurrentExtensionsManifestLocation()},E=le=>`${v.ExtensionKey.create(le).toString()}${d.profileLocation?`-${d.profileLocation.toString()}`:""}`;if(!b.URI.isUri(r)){const le=this.installingExtensions.get(E(r));if(le)return this.logService.info("Extensions is already requested to install",r.identifier.id),le.task.waitUntilTaskIsFinished()}const k=[],F=[],Y=[],X=this.createInstallExtensionTask(i,r,d);b.URI.isUri(r)||this.installingExtensions.set(E(r),{task:X,waitingTasks:[]}),this._onInstallExtension.fire({identifier:X.identifier,source:r,profileLocation:d.profileLocation}),this.logService.info("Installing extension:",X.identifier.id),k.push({task:X,manifest:i});let ee=!1;try{if(d.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",X.identifier.id);else try{const re=await this.getAllDepsAndPackExtensions(X.identifier,i,!!d.installOnlyNewlyAddedFromExtensionPack,!!d.installPreReleaseVersion,d.profileLocation),fe=await this.getInstalled(void 0,d.profileLocation);for(const{gallery:ce,manifest:se}of(0,A.distinct)(re,({gallery:j})=>j.identifier.id)){ee=ee||!!se.extensionDependencies?.some(V=>(0,v.areSameExtensions)({id:V},X.identifier));const j=E(ce),B=this.installingExtensions.get(j);if(B){if(this.canWaitForTask(X,B.task)){const V=B.task.identifier;this.logService.info("Waiting for already requested installing extension",V.id,X.identifier.id),B.waitingTasks.push(X),F.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,M=>M.some($=>(0,v.areSameExtensions)($.identifier,V)))).then(M=>{if(this.logService.info("Finished waiting for already requested installing extension",V.id,X.identifier.id),!M.find(G=>(0,v.areSameExtensions)(G.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else if(!fe.some(({identifier:V})=>(0,v.areSameExtensions)(V,ce.identifier))){const V=this.createInstallExtensionTask(se,ce,{...d,donotIncludePackAndDependencies:!0});this.installingExtensions.set(j,{task:V,waitingTasks:[X]}),this._onInstallExtension.fire({identifier:V.identifier,source:ce,profileLocation:d.profileLocation}),this.logService.info("Installing extension:",V.identifier.id,X.identifier.id),k.push({task:V,manifest:se})}}}catch(re){if(b.URI.isUri(X.source))(0,A.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",X.identifier.id,re.message),(0,A.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",X.identifier.id,re.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",X.identifier.id),re}const le=k.reduce((re,{task:fe,manifest:ce})=>(re.set(fe.identifier.id.toLowerCase(),{task:fe,manifest:ce}),re),new Map);for(;le.size;){let re;const fe=[...le.values()].filter(({manifest:ce})=>!ce.extensionDependencies?.some(se=>le.has(se.toLowerCase())));fe.length?re=le.size===1?fe:fe.filter(({task:ce})=>!(ce===X&&!ee)):(this.logService.info("Found extensions with circular dependencies",fe.map(({task:ce})=>ce.identifier.id)),re=[...le.values()]),await this.joinAllSettled(re.map(async({task:ce})=>{const se=new Date().getTime();try{const j=await ce.run();if(await this.joinAllSettled(this.participants.map(B=>B.postInstall(j,ce.source,d,C.CancellationToken.None))),!b.URI.isUri(ce.source)){const B=ce.operation===3,V=B?void 0:(new Date().getTime()-ce.source.lastUpdated)/1e3;if(t(this.telemetryService,B?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(ce.source),verificationStatus:ce.verificationStatus,duration:new Date().getTime()-se,durationSinceUpdate:V}),h.isWeb&&ce.operation!==3)try{await this.galleryService.reportStatistic(j.manifest.publisher,j.manifest.name,j.manifest.version,"install")}catch{}}Y.push({local:j,identifier:ce.identifier,operation:ce.operation,source:ce.source,context:d.context,profileLocation:ce.profileLocation,applicationScoped:j.isApplicationScoped})}catch(j){throw b.URI.isUri(ce.source)||t(this.telemetryService,ce.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(ce.source),verificationStatus:ce.verificationStatus,duration:new Date().getTime()-se,error:j}),this.logService.error("Error while installing the extension:",ce.identifier.id),j}finally{le.delete(ce.identifier.id.toLowerCase())}}))}return F.length&&await this.joinAllSettled(F),Y.forEach(({identifier:re})=>this.logService.info("Extension installed successfully:",re.id)),this._onDidInstallExtensions.fire(Y),Y.filter(({identifier:re})=>(0,v.areSameExtensions)(re,X.identifier))[0].local}catch(le){if(k.forEach(({task:re})=>re.cancel()),Y.length)try{const re=await Promise.allSettled(Y.map(({local:fe})=>this.createUninstallExtensionTask(fe,{versionOnly:!0,profileLocation:d.profileLocation}).run()));for(let fe=0;fe<re.length;fe++){const ce=re[fe],{identifier:se}=Y[fe];ce.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",se.id):this.logService.warn("Rollback: Error while uninstalling extension",se.id,(0,N.getErrorMessage)(ce.reason))}}catch(re){this.logService.warn("Error while rolling back extensions",(0,N.getErrorMessage)(re),Y.map(({identifier:fe})=>fe.id))}throw this._onDidInstallExtensions.fire(k.map(({task:re})=>({identifier:re.identifier,operation:2,source:re.source,context:d.context,profileLocation:d.profileLocation}))),le}finally{for(const{task:le}of k)le.source&&!b.URI.isUri(le.source)&&this.installingExtensions.delete(E(le.source))}}canWaitForTask(i,r){for(const[,{task:a,waitingTasks:l}]of this.installingExtensions.entries())if(a===i&&(l.includes(r)||l.some(d=>this.canWaitForTask(d,r)))||a===r&&l[0]&&!this.canWaitForTask(i,l[0]))return!1;return!0}async joinAllSettled(i){const r=[],a=[],l=await Promise.allSettled(i);for(const d of l)d.status==="fulfilled"?r.push(d.value):a.push(d.reason);if(a.length)throw p(a);return r}async getAllDepsAndPackExtensions(i,r,a,l,d){if(!this.galleryService.isEnabled())return[];const E=await this.getInstalled(void 0,d),k=[],F=[],Y=async(X,ee)=>{k.push(X);const le=ee.extensionDependencies||[],re=[...le];if(ee.extensionPack){const fe=a?E.find(ce=>(0,v.areSameExtensions)(ce.identifier,X)):void 0;for(const ce of ee.extensionPack)fe&&fe.manifest.extensionPack&&fe.manifest.extensionPack.some(se=>(0,v.areSameExtensions)({id:se},{id:ce}))||re.every(se=>!(0,v.areSameExtensions)({id:se},{id:ce}))&&re.push(ce)}if(re.length){const fe=re.filter(ce=>k.every(se=>!(0,v.areSameExtensions)(se,{id:ce})));if(fe.length){const ce=await this.galleryService.getExtensions(fe.map(se=>({id:se,preRelease:l})),C.CancellationToken.None);for(const se of ce){if(k.find(V=>(0,v.areSameExtensions)(V,se.identifier)))continue;const j=le.some(V=>(0,v.areSameExtensions)({id:V},se.identifier));let B;try{B=await this.checkAndGetCompatibleVersion(se,!1,l)}catch(V){if(V instanceof m.ExtensionManagementError&&V.code===m.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!j){this.logService.info("Skipping the packed extension as it cannot be installed",se.identifier.id);continue}else throw V}F.push({gallery:B.extension,manifest:B.manifest}),await Y(B.extension.identifier,B.manifest)}}}};return await Y(i,r),F}async checkAndGetCompatibleVersion(i,r,a){if((await this.getExtensionsControlManifest()).malicious.some(k=>(0,v.areSameExtensions)(i.identifier,k)))throw new m.ExtensionManagementError(y.localize(1,null,i.identifier.id),m.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const k=await this.getTargetPlatform();throw new m.ExtensionManagementError(y.localize(2,null,i.identifier.id,this.productService.nameLong,(0,m.TargetPlatformToString)(k)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const d=await this.getCompatibleVersion(i,r,a);if(d){if(a&&!r&&i.hasPreReleaseVersion&&!d.properties.isPreReleaseVersion)throw new m.ExtensionManagementError(y.localize(3,null,i.identifier.id,this.productService.nameLong,this.productService.version),m.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],C.CancellationToken.None))[0]?new m.ExtensionManagementError(y.localize(4,null,i.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.ExtensionManagementError(y.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),m.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",d.identifier.id);const E=await this.galleryService.getManifest(d,C.CancellationToken.None);if(E===null)throw new m.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(E.version!==d.version)throw new m.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:d,manifest:E}}async getCompatibleVersion(i,r,a){const l=await this.getTargetPlatform();let d=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==a&&(d=(await this.galleryService.getExtensions([{...i.identifier,preRelease:a}],{targetPlatform:l,compatible:!0},C.CancellationToken.None))[0]||null),!d&&await this.galleryService.isExtensionCompatible(i,a,l)&&(d=i),d||(r?d=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:l,compatible:!0},C.CancellationToken.None))[0]||null:d=await this.galleryService.getCompatibleExtension(i,a,l)),d}async uninstallExtension(i,r){const a={...r,profileLocation:i.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},l=X=>`${X.id.toLowerCase()}${a.versionOnly?`-${i.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,d=this.uninstallingExtensions.get(l(i.identifier));if(d)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),d.waitUntilTaskIsFinished();const E=X=>{const ee=this.createUninstallExtensionTask(X,a);return this.uninstallingExtensions.set(l(ee.extension.identifier),ee),a.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,a.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this._onUninstallExtension.fire({identifier:X.identifier,profileLocation:a.profileLocation,applicationScoped:X.isApplicationScoped}),ee},k=(X,ee)=>{ee?a.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,a.profileLocation.toString(),ee.message):this.logService.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,ee.message):a.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,a.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),t(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(X),error:ee}),this._onDidUninstallExtension.fire({identifier:X.identifier,error:ee?.code,profileLocation:a.profileLocation,applicationScoped:X.isApplicationScoped})},F=[],Y=[];try{F.push(E(i));const X=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const ee=this.getAllPackExtensionsToUninstall(i,X);for(const le of ee)this.uninstallingExtensions.has(l(le.identifier))?this.logService.info("Extensions is already requested to uninstall",le.identifier.id):F.push(E(le))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(F.map(ee=>ee.extension),X,i),await this.joinAllSettled(F.map(async ee=>{try{if(await ee.run(),await this.joinAllSettled(this.participants.map(le=>le.postUninstall(ee.extension,a,C.CancellationToken.None))),ee.extension.identifier.uuid)try{await this.galleryService.reportStatistic(ee.extension.manifest.publisher,ee.extension.manifest.name,ee.extension.manifest.version,"uninstall")}catch{}k(ee.extension)}catch(le){const re=le instanceof m.ExtensionManagementError?le:new m.ExtensionManagementError((0,N.getErrorMessage)(le),m.ExtensionManagementErrorCode.Internal);throw k(ee.extension,re),re}finally{Y.push(ee)}}))}catch(X){const ee=X instanceof m.ExtensionManagementError?X:new m.ExtensionManagementError((0,N.getErrorMessage)(X),m.ExtensionManagementErrorCode.Internal);for(const le of F){try{le.cancel()}catch{}Y.includes(le)||k(le.extension,ee)}throw ee}finally{for(const X of F)this.uninstallingExtensions.delete(l(X.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}checkForDependents(i,r,a){for(const l of i){const d=this.getDependents(l,r);if(d.length){const E=d.filter(k=>!i.some(F=>(0,v.areSameExtensions)(F.identifier,k.identifier)));if(E.length)throw new Error(this.getDependentsErrorMessage(l,E,a))}}}getDependentsErrorMessage(i,r,a){return a===i?r.length===1?y.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?y.localize(9,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(10,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(11,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(i,r,a=[]){if(a.indexOf(i)!==-1)return[];a.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const d=r.filter(k=>!k.isBuiltin&&l.some(F=>(0,v.areSameExtensions)({id:F},k.identifier))),E=[];for(const k of d)E.push(...this.getAllPackExtensionsToUninstall(k,r,a));return[...d,...E]}return[]}getDependents(i,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(l=>(0,v.areSameExtensions)({id:l},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};e.AbstractExtensionManagementService=S=ve([te(0,m.IExtensionGalleryService),te(1,g.ITelemetryService),te(2,D.ILogService),te(3,u.IProductService),te(4,f.IUserDataProfilesService)],S);function p(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=p;function w(n){if(n instanceof m.ExtensionManagementError)return n;const i=new m.ExtensionManagementError(n.message,m.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function t(n,i,{extensionData:r,verificationStatus:a,duration:l,error:d,durationSinceUpdate:E}){let k,F;(0,c.isDefined)(a)&&(a===!0?a="Verified":(a===!1||(k=m.ExtensionManagementErrorCode.Signature,F=a),a="Unverified")),d&&(d instanceof m.ExtensionManagementError?(k=d.code,d.code===m.ExtensionManagementErrorCode.Signature&&(F=d.message)):k=m.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:a,success:!d,duration:l,errorcode:k,errorcodeDetail:F,durationSinceUpdate:E})}class o{constructor(){this.barrier=new T.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(i=>new Promise((r,a)=>{const l=i.onCancellationRequested(()=>{l.dispose(),a(new N.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=o}),define(ie[40],ne([0,1,8,14,2,5,33,11,20,26,13,10,6,21,27,3,9,25]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v,L,D,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class S extends Error{constructor(n,i){super(n),this.code=i}}e.ExtensionsProfileScanningError=S,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let p=e.AbstractExtensionsProfileScannerService=class extends C.Disposable{constructor(n,i,r,a,l,d){super(),this.extensionsLocation=n,this.fileService=i,this.userDataProfilesService=r,this.uriIdentityService=a,this.telemetryService=l,this.logService=d,this._onAddExtensions=this._register(new N.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new N.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new N.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new N.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new O.ResourceMap}scanProfileExtensions(n,i){return this.withProfileExtensions(n,void 0,i)}async addExtensionsToProfile(n,i){const r=[],a=[];try{return await this.withProfileExtensions(i,l=>{const d=[];for(const E of l)n.some(([k])=>(0,c.areSameExtensions)(k.identifier,E.identifier)&&k.manifest.version!==E.version)?r.push(E):d.push(E);for(const[E,k]of n)if(!d.some(F=>(0,c.areSameExtensions)(F.identifier,E.identifier)&&F.version===E.manifest.version)){const F={identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:k};a.push(F),d.push(F)}return a.length&&this._onAddExtensions.fire({extensions:a,profileLocation:i}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:i}),d}),a.length&&this._onDidAddExtensions.fire({extensions:a,profileLocation:i}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:i}),a}catch(l){throw a.length&&this._onDidAddExtensions.fire({extensions:a,error:l,profileLocation:i}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:l,profileLocation:i}),l}}async updateMetadata(n,i){const r=[];return await this.withProfileExtensions(i,a=>{const l=[];for(const d of a){const E=n.find(([k])=>(0,c.areSameExtensions)(k.identifier,d.identifier)&&k.manifest.version===d.version);E&&(d.metadata={...d.metadata,...E[1]},r.push(d)),l.push(d)}return l}),r}async removeExtensionFromProfile(n,i){const r=[];this._onRemoveExtensions.fire({extensions:r,profileLocation:i});try{await this.withProfileExtensions(i,a=>{const l=[];for(const d of a)(0,c.areSameExtensions)(d.identifier,n.identifier)?r.push(d):l.push(d);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:i}),l}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:i})}catch(a){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:a,profileLocation:i}),a}}async withProfileExtensions(n,i,r){return this.getResourceAccessQueue(n).queue(async()=>{let a=[],l;try{const d=await this.fileService.readFile(n);l=JSON.parse(d.value.toString().trim()||"[]")}catch(d){if((0,b.toFileOperationResult)(d)!==1)throw d;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(l=await this.migrateFromOldDefaultProfileExtensionsLocation()),!l&&r?.bailOutWhenFileNotFound)throw new S((0,u.getErrorMessage)(d),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.reportAndThrowInvalidConentError(n);let d=!1;for(const E of l){w(E)||this.reportAndThrowInvalidConentError(n);let k;if((0,D.isString)(E.relativeLocation)&&E.relativeLocation)k=this.resolveExtensionLocation(E.relativeLocation);else if((0,D.isString)(E.location))k=this.resolveExtensionLocation(E.location),d=!0,E.relativeLocation=E.location,E.location=k.toJSON();else{k=I.URI.revive(E.location);const F=this.toRelativePath(k);F&&(d=!0,E.relativeLocation=F)}a.push({identifier:E.identifier,location:k,version:E.version,metadata:E.metadata})}d&&await this.fileService.writeFile(n,T.VSBuffer.fromString(JSON.stringify(l)))}if(i){a=i(a);const d=a.map(E=>({identifier:E.identifier,version:E.version,location:E.location.toJSON(),relativeLocation:this.toRelativePath(E.location),metadata:E.metadata}));await this.fileService.writeFile(n,T.VSBuffer.fromString(JSON.stringify(d)))}return a})}reportAndThrowInvalidConentError(n){const i=new S(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(n)).value.toString()}catch(l){if((0,b.toFileOperationResult)(l)===1)return;throw l}this.logService.info("Migrating extensions from old default profile location",n.toString());let a;try{const l=JSON.parse(r);Array.isArray(l)&&l.every(d=>w(d))?a=l:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.logService.error(l)}if(a)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(l){if((0,b.toFileOperationResult)(l)===3)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw l}try{await this.fileService.del(n)}catch(l){(0,b.toFileOperationResult)(l)!==1&&this.logService.error(l)}try{await this.fileService.del(i)}catch(l){(0,b.toFileOperationResult)(l)!==1&&this.logService.error(l)}return a})()),this._migrationPromise}getResourceAccessQueue(n){let i=this.resourcesAccessQueueMap.get(n);return i||(i=new A.Queue,this.resourcesAccessQueueMap.set(n,i)),i}};e.AbstractExtensionsProfileScannerService=p=ve([te(1,b.IFileService),te(2,v.IUserDataProfilesService),te(3,L.IUriIdentityService),te(4,g.ITelemetryService),te(5,m.ILogService)],p);function w(o){return(0,D.isObject)(o)&&(0,h.isIExtensionIdentifier)(o.identifier)&&(t(o.location)||(0,D.isString)(o.location)&&o.location)&&((0,D.isUndefined)(o.relativeLocation)||(0,D.isString)(o.relativeLocation))&&o.version&&(0,D.isString)(o.version)}function t(o){return o?(0,D.isString)(o.path)&&(0,D.isString)(o.scheme):!1}}),define(ie[48],ne([0,1,19,8,30,14,9,51,78,2,16,15,12,17,41,53,3,11,93,18,26,35,46,13,10,6,31,5,54,40,21,27,109]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v,L,D,u,g,f,S,p,w,t,o,n,i,r,a,l,d,E,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var Y;(function(se){function j(B,V){if(B===V)return!0;const M=Object.keys(B),$=new Set;for(const G of Object.keys(V))$.add(G);if(M.length!==$.size)return!1;for(const G of M){if(B[G]!==V[G])return!1;$.delete(G)}return $.size===0}se.equals=j})(Y||(e.Translations=Y={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let X=e.AbstractExtensionsScannerService=class extends c.Disposable{constructor(j,B,V,M,$,G,H,x,U,R,s,P){super(),this.systemExtensionsLocation=j,this.userExtensionsLocation=B,this.extensionsControlLocation=V,this.currentProfile=M,this.userDataProfilesService=$,this.extensionsProfileScannerService=G,this.fileService=H,this.logService=x,this.environmentService=U,this.productService=R,this.uriIdentityService=s,this.instantiationService=P,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(le,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,p.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(j,B,V){const[M,$]=await Promise.all([this.scanSystemExtensions(j),this.scanUserExtensions(B)]),G=V?await this.scanExtensionsUnderDevelopment(j,[...M,...$]):[];return this.dedupExtensions(M,$,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(j){const B=[];B.push(this.scanDefaultSystemExtensions(!!j.useCache,j.language)),B.push(this.scanDevSystemExtensions(j.language,!!j.checkControlFile));const[V,M]=await Promise.all(B);return this.applyScanOptions([...V,...M],0,j,!1)}async scanUserExtensions(j){const B=j.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",B);const V=this.uriIdentityService.extUri.isEqual(j.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.createExtensionScannerInput(B,!!j.profileLocation,1,!j.includeUninstalled,j.language,!0,V),$=j.useCache&&!M.devMode&&M.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let G;try{G=await $.scanExtensions(M)}catch(H){if(H instanceof d.ExtensionsProfileScanningError&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),G=await $.scanExtensions(M);else throw H}return G=await this.applyScanOptions(G,1,j,!0),this.logService.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(j,B){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(M=>M.scheme===b.Schemas.file).map(async M=>{const $=await this.createExtensionScannerInput(M,!1,1,!0,j.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(H=>(H.type=B.find(x=>(0,p.areSameExtensions)(x.identifier,H.identifier))?.type??H.type,this.extensionsScanner.validate(H,$)))}))).flat();return this.applyScanOptions(V,"development",j,!0)}return[]}async scanExistingExtension(j,B,V){const M=await this.createExtensionScannerInput(j,!1,B,!0,V.language,!0,void 0),$=await this.extensionsScanner.scanExtension(M);return!$||!V.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(j,B,V){const M=await this.createExtensionScannerInput(j,!1,B,!0,V.language,!0,void 0),$=await this.extensionsScanner.scanOneOrMultipleExtensions(M);return this.applyScanOptions($,B,V,!0)}async scanMetadata(j){const B=(0,v.joinPath)(j,"package.json"),V=(await this.fileService.readFile(B)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(j,B){const V=(0,v.joinPath)(j,"package.json"),M=(await this.fileService.readFile(V)).value.toString(),$=JSON.parse(M);B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,$.__metadata={...$.__metadata,...B},await this.fileService.writeFile((0,v.joinPath)(j,"package.json"),N.VSBuffer.fromString(JSON.stringify($,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(j){if(j instanceof d.ExtensionsProfileScanningError&&j.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw j}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const j=await this.scanUserExtensions({includeInvalid:!0});if(j.length)await this.extensionsProfileScannerService.addExtensionsToProfile(j.map(B=>[B,B.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,N.VSBuffer.fromString(JSON.stringify([])))}catch(B){(0,o.toFileOperationResult)(B)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.getErrorMessage)(B))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(j){this.logService.error(j)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(j,B,V,M){return V.includeAllVersions||(j=this.dedupExtensions(B===0?j:void 0,B===1?j:void 0,B==="development"?j:void 0,await this.getTargetPlatform(),M)),V.includeInvalid||(j=j.filter($=>$.isValid)),j.sort(($,G)=>{const H=y.basename($.location.fsPath),x=y.basename(G.location.fsPath);return H<x?-1:H>x?1:0})}dedupExtensions(j,B,V,M,$){const G=(x,U,R)=>{if(x.isValid&&!U.isValid)return!1;if(x.isValid===U.isValid){if($&&L.gt(x.manifest.version,U.manifest.version))return this.logService.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(L.eq(x.manifest.version,U.manifest.version)){if(x.type===0)return this.logService.debug(`Skipping extension ${U.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===M)return this.logService.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return R?this.logService.warn(`Overwriting user extension ${x.location.path} with ${U.location.path}.`):this.logService.debug(`Overwriting user extension ${x.location.path} with ${U.location.path}.`),!0},H=new w.ExtensionIdentifierMap;return j?.forEach(x=>{const U=H.get(x.identifier.id);(!U||G(U,x,!1))&&H.set(x.identifier.id,x)}),B?.forEach(x=>{const U=H.get(x.identifier.id);if(!U&&j&&x.type===0){this.logService.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!U||G(U,x,!1))&&H.set(x.identifier.id,x)}),V?.forEach(x=>{const U=H.get(x.identifier.id);(!U||G(U,x,!0))&&H.set(x.identifier.id,x),H.set(x.identifier.id,x)}),[...H.values()]}async scanDefaultSystemExtensions(j,B){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,B,!0,void 0),$=await(j&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(j,B){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const M=B?await this.getBuiltInExtensionControl():{},$=[],G=g.URI.file(y.normalize(y.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of V){const U=M[x.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":$.push((0,v.joinPath)(G,x.name));break;default:$.push(g.URI.file(U));break}}const H=await Promise.all($.map(async x=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(x,!1,0,!0,j,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",H.length),(0,A.coalesce)(H)}async getBuiltInExtensionControl(){try{const j=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(j.value.toString())}catch{return{}}}async createExtensionScannerInput(j,B,V,M,$,G,H){const x=await this.getTranslations($??m.language),U=await this.getMtime(j),R=B&&!this.uriIdentityService.extUri.isEqual(j,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,s=R?await this.getMtime(R):void 0;return new ee(j,U,R,s,B,H,V,M,G,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,x)}async getMtime(j){try{const B=await this.fileService.stat(j);if(typeof B.mtime=="number")return B.mtime}catch{}}};e.AbstractExtensionsScannerService=X=ve([te(4,E.IUserDataProfilesService),te(5,d.IExtensionsProfileScannerService),te(6,o.IFileService),te(7,i.ILogService),te(8,S.IEnvironmentService),te(9,r.IProductService),te(10,k.IUriIdentityService),te(11,n.IInstantiationService)],X);class ee{constructor(j,B,V,M,$,G,H,x,U,R,s,P,_,W,K){this.location=j,this.mtime=B,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=M,this.profile=$,this.profileScanOptions=G,this.type=H,this.excludeObsolete=x,this.validate=U,this.productVersion=R,this.productDate=s,this.productCommit=P,this.devMode=_,this.language=W,this.translations=K}static createNlsConfiguration(j){return{language:j.language,pseudo:j.language==="pseudo",devMode:j.devMode,translations:j.translations}}static equals(j,B){return(0,v.isEqual)(j.location,B.location)&&j.mtime===B.mtime&&(0,v.isEqual)(j.applicationExtensionslocation,B.applicationExtensionslocation)&&j.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&j.profile===B.profile&&C.equals(j.profileScanOptions,B.profileScanOptions)&&j.type===B.type&&j.excludeObsolete===B.excludeObsolete&&j.validate===B.validate&&j.productVersion===B.productVersion&&j.productDate===B.productDate&&j.productCommit===B.productCommit&&j.devMode===B.devMode&&j.language===B.language&&Y.equals(j.translations,B.translations)}}e.ExtensionScannerInput=ee;let le=class extends c.Disposable{constructor(j,B,V,M,$){super(),this.obsoleteFile=j,this.extensionsProfileScannerService=B,this.uriIdentityService=V,this.fileService=M,this.logService=$}async scanExtensions(j){const B=j.profile?await this.scanExtensionsFromProfile(j):await this.scanExtensionsFromLocation(j);let V={};if(j.excludeObsolete&&j.type===1)try{const M=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(M)}catch{}return(0,u.isEmptyObject)(V)?B:B.filter(M=>!V[p.ExtensionKey.create(M).toString()])}async scanExtensionsFromLocation(j){const B=await this.fileService.resolve(j.location);if(!B.children?.length)return[];const V=await Promise.all(B.children.map(async M=>{if(!M.isDirectory||j.type===1&&(0,v.basename)(M.resource).indexOf(".")===0)return null;const $=new ee(M.resource,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension($)}));return(0,A.coalesce)(V).sort((M,$)=>M.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(j){let B=await this.scanExtensionsFromProfileResource(j.location,()=>!0,j);if(j.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(j.location,j.applicationExtensionslocation)){B=B.filter(M=>!M.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(j.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,j);B.push(...V)}return B}async scanExtensionsFromProfileResource(j,B,V){const M=await this.extensionsProfileScannerService.scanProfileExtensions(j,V.profileScanOptions);if(!M.length)return[];const $=await Promise.all(M.map(async G=>{if(B(G)){const H=new ee(G.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(H,G.metadata)}return null}));return(0,A.coalesce)($)}async scanOneOrMultipleExtensions(j){try{if(await this.fileService.exists((0,v.joinPath)(j.location,"package.json"))){const B=await this.scanExtension(j);return B?[B]:[]}else return await this.scanExtensions(j)}catch(B){return this.logService.error(`Error scanning extensions at ${j.location.path}:`,(0,O.getErrorMessage)(B)),[]}}async scanExtension(j,B){try{let V=await this.scanExtensionManifest(j.location);if(V){V.publisher||(V.publisher=w.UNDEFINED_PUBLISHER),B=B??V.__metadata,delete V.__metadata;const M=(0,p.getGalleryExtensionId)(V.publisher,V.name),$=B?.id?{id:M,uuid:B.id}:{id:M},G=B?.isSystem?0:j.type,H=G===0||!!B?.isBuiltin;V=await this.translateManifest(j.location,V,ee.createNlsConfiguration(j));const x={type:G,identifier:$,manifest:V,location:j.location,isBuiltin:H,targetPlatform:B?.targetPlatform??"undefined",metadata:B,isValid:!0,validations:[]};return j.validate?this.validate(x,j):x}}catch(V){j.type!==0&&this.logService.error(V)}return null}validate(j,B){let V=!0;const M=(0,t.validateExtensionManifest)(B.productVersion,B.productDate,B.location,j.manifest,j.isBuiltin);for(const[$,G]of M)$===D.default.Error&&(V=!1,this.logService.error(this.formatMessage(B.location,G)));return j.isValid=V,j.validations=M,j}async scanExtensionManifest(j){const B=(0,v.joinPath)(j,"package.json");let V;try{V=(await this.fileService.readFile(B)).value.toString()}catch($){return(0,o.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(j,(0,f.localize)(0,null,B.path,$.message))),null}let M;try{M=JSON.parse(V)}catch{const G=[];(0,I.parse)(V,G);for(const H of G)this.logService.error(this.formatMessage(j,(0,f.localize)(1,null,B.path,H.offset,H.length,(0,h.getParseErrorMessage)(H.error))));return null}return(0,I.getNodeType)(M)!=="object"?(this.logService.error(this.formatMessage(j,(0,f.localize)(2,null,B.path))),null):M}async translateManifest(j,B,V){const M=await this.getLocalizedMessages(j,B,V);if(M)try{const $=[],G=await this.resolveOriginalMessageBundle(M.default,$);if($.length>0)return $.forEach(x=>{this.logService.error(this.formatMessage(j,(0,f.localize)(3,null,M.default?.path,(0,h.getParseErrorMessage)(x.error))))}),B;if((0,I.getNodeType)(M)!=="object")return this.logService.error(this.formatMessage(j,(0,f.localize)(4,null,M.default?.path))),B;const H=M.values||Object.create(null);return(0,F.localizeManifest)(B,H,G)}catch{}return B}async getLocalizedMessages(j,B,V){const M=(0,v.joinPath)(j,"package.nls.json"),$=(U,R)=>{R.forEach(s=>{this.logService.error(this.formatMessage(j,(0,f.localize)(5,null,U?.path,(0,h.getParseErrorMessage)(s.error))))})},G=U=>{this.logService.error(this.formatMessage(j,(0,f.localize)(6,null,U?.path)))},H=`${B.publisher}.${B.name}`,x=V.translations[H];if(x)try{const U=g.URI.file(x),R=(await this.fileService.readFile(U)).value.toString(),s=[],P=(0,I.parse)(R,s);return s.length>0?($(U,s),{values:void 0,default:M}):(0,I.getNodeType)(P)!=="object"?(G(U),{values:void 0,default:M}):{values:P.contents?P.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.fileService.exists(M))return;let R;try{R=await this.findMessageBundles(j,V)}catch{return}if(!R.localized)return{values:void 0,default:R.original};try{const s=(await this.fileService.readFile(R.localized)).value.toString(),P=[],_=(0,I.parse)(s,P);return P.length>0?($(R.localized,P),{values:void 0,default:R.original}):(0,I.getNodeType)(_)!=="object"?(G(R.localized),{values:void 0,default:R.original}):{values:_,default:R.original}}catch{return{values:void 0,default:R.original}}}}async resolveOriginalMessageBundle(j,B){if(j)try{const V=(await this.fileService.readFile(j)).value.toString();return(0,I.parse)(V,B)}catch{}}findMessageBundles(j,B){return new Promise((V,M)=>{const $=G=>{const H=(0,v.joinPath)(j,`package.nls.${G}.json`);this.fileService.exists(H).then(x=>{x&&V({localized:H,original:(0,v.joinPath)(j,"package.nls.json")});const U=G.lastIndexOf("-");U===-1?V({localized:(0,v.joinPath)(j,"package.nls.json"),original:null}):(G=G.substring(0,U),$(G))})};if(B.devMode||B.pseudo||!B.language)return V({localized:(0,v.joinPath)(j,"package.nls.json"),original:null});$(B.language)})}formatMessage(j,B){return`[${j.path}]: ${B}`}};le=ve([te(1,d.IExtensionsProfileScannerService),te(2,k.IUriIdentityService),te(3,o.IFileService),te(4,i.ILogService)],le);let re=class extends le{constructor(j,B,V,M,$,G,H){super(B,M,$,G,H),this.currentProfile=j,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new T.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(j){const B=this.getCacheFile(j),V=await this.readExtensionCache(B);if(this.input=j,V&&V.input&&ee.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",j.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map($=>($.location=g.URI.revive($.location),$));const M=await super.scanExtensions(j);return await this.writeExtensionCache(B,{input:j,result:M}),M}async readExtensionCache(j){try{const B=await this.fileService.readFile(j),V=JSON.parse(B.value.toString());return{result:V.result,input:(0,l.revive)(V.input)}}catch(B){this.logService.debug("Error while reading the extension cache file:",j.path,(0,O.getErrorMessage)(B))}return null}async writeExtensionCache(j,B){try{await this.fileService.writeFile(j,N.VSBuffer.fromString(JSON.stringify(B)))}catch(V){this.logService.debug("Error while writing the extension cache file:",j.path,(0,O.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const j=this.getCacheFile(this.input),B=await this.readExtensionCache(j);if(!B)return;const V=B.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!C.equals(M,V))try{this.logService.info("Invalidating Cache",V,M),await this.fileService.del(j),this._onDidChangeCache.fire()}catch($){this.logService.error($)}}getCacheFile(j){const B=this.getProfile(j);return this.uriIdentityService.extUri.joinPath(B.cacheHome,j.type===0?w.BUILTIN_MANIFEST_CACHE_FILE:w.USER_MANIFEST_CACHE_FILE)}getProfile(j){return j.type===0?this.userDataProfilesService.defaultProfile:j.profile?this.uriIdentityService.extUri.isEqual(j.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(B=>this.uriIdentityService.extUri.isEqual(j.location,B.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};re=ve([te(2,E.IUserDataProfilesService),te(3,d.IExtensionsProfileScannerService),te(4,k.IUriIdentityService),te(5,o.IFileService),te(6,i.ILogService)],re);function fe(se,j){const B=(0,p.getExtensionId)(se.manifest.publisher,se.manifest.name);return{id:B,identifier:new w.ExtensionIdentifier(B),isBuiltin:se.type===0,isUserBuiltin:se.type===1&&se.isBuiltin,isUnderDevelopment:j,extensionLocation:se.location,uuid:se.identifier.uuid,targetPlatform:se.targetPlatform,...se.manifest}}e.toExtensionDescription=fe;class ce extends X{constructor(j,B,V,M,$,G,H,x,U,R,s,P){super(j,B,(0,v.joinPath)(V,".vscode-oss-dev","extensions","control.json"),M,$,G,H,x,U,R,s,P),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const _=await this.fileService.readFile(g.URI.file(m.translationsConfigFile));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}getTranslations(j){return this.translationsPromise}}e.NativeExtensionsScannerService=ce}),define(ie[150],ne([0,1,58,8,32,5,2,16,15,22,6,21]),function(q,e,A,T,C,N,O,I,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=e.ExtensionsLifecycle=class extends O.Disposable{constructor(L,D){super(),this.userDataProfilesService=L,this.logService=D,this.processesLimiter=new T.Limiter(5)}async postUninstall(L){const D=this.parseScript(L,"uninstall");D&&(this.logService.info(L.identifier.id,L.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(D.script,"uninstall",D.args,!0,L),this.logService.info("Finished running post uninstall script",L.identifier.id,L.manifest.version)}catch(u){this.logService.error("Failed to run post uninstall script",L.identifier.id,L.manifest.version),this.logService.error(u)}}));try{await c.Promises.rm(this.getExtensionStoragePath(L))}catch(u){this.logService.error("Error while removing extension storage path",L.identifier.id),this.logService.error(u)}}parseScript(L,D){const u=`vscode:${D}`;if(L.location.scheme===I.Schemas.file&&L.manifest&&L.manifest.scripts&&typeof L.manifest.scripts[u]=="string"){const g=L.manifest.scripts[u].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(L.identifier.id,L.manifest.version,`${u} should be a node script`),null):{script:(0,h.join)(L.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(L,D,u,g,f){return new Promise((S,p)=>{const w=this.start(L,D,u,f);let t;const o=n=>{t&&(clearTimeout(t),t=null),n?p(n):S(void 0)};w.on("error",n=>{o((0,C.toErrorMessage)(n)||"Unknown")}),w.on("exit",(n,i)=>{o(n?`post-${D} process exited with code ${n}`:void 0)}),g&&(t=setTimeout(()=>{t=null,w.kill(),p("timed out")},5e3))})}start(L,D,u,g){const f={silent:!0,execArgv:void 0},S=(0,A.fork)(L,[`--type=extension-post-${D}`,...u],f);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const p=N.Event.fromNodeEventEmitter(S.stdout,"data"),w=N.Event.fromNodeEventEmitter(S.stderr,"data");p(n=>this.logService.info(g.identifier.id,g.manifest.version,`post-${D}`,n)),w(n=>this.logService.error(g.identifier.id,g.manifest.version,`post-${D}`,n));const t=N.Event.any(N.Event.map(p,n=>({data:`%c${n}`,format:[""]})),N.Event.map(w,n=>({data:`%c${n}`,format:["color: red"]})));return N.Event.debounce(t,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(g.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),S}getExtensionStoragePath(L){return(0,h.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,L.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=m=ve([te(0,y.IUserDataProfilesService),te(1,b.ILogService)],m)}),define(ie[151],ne([0,1,6,21,27,25,40,13,18,11]),function(q,e,A,T,C,N,O,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let b=e.ExtensionsProfileScannerService=class extends O.AbstractExtensionsProfileScannerService{constructor(m,v,L,D,u,g){super(c.URI.file(m.extensionsPath),v,L,D,u,g)}};e.ExtensionsProfileScannerService=b=ve([te(0,h.INativeEnvironmentService),te(1,I.IFileService),te(2,T.IUserDataProfilesService),te(3,C.IUriIdentityService),te(4,N.ITelemetryService),te(5,A.ILogService)],b)}),define(ie[152],ne([0,1,11,18,40,48,13,10,6,31,27,21]),function(q,e,A,T,C,N,O,I,h,c,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=e.ExtensionsScannerService=class extends N.NativeExtensionsScannerService{constructor(L,D,u,g,f,S,p,w){super(A.URI.file(f.builtinExtensionsPath),A.URI.file(f.extensionsPath),f.userHome,L.defaultProfile,L,D,u,g,f,S,p,w)}};e.ExtensionsScannerService=m=ve([te(0,y.IUserDataProfilesService),te(1,C.IExtensionsProfileScannerService),te(2,O.IFileService),te(3,h.ILogService),te(4,T.INativeEnvironmentService),te(5,c.IProductService),te(6,b.IUriIdentityService),te(7,I.IInstantiationService)],m)}),define(ie[153],ne([0,1,8,5,2,120,3,84,10,21]),function(q,e,A,T,C,N,O,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var b;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var m;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function v(f){const S=f.get(e.TARGET_KEY);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}e.loadKeyTargets=v;class L extends C.Disposable{constructor(S={flushInterval:L.DEFAULT_FLUSH_INTERVAL}){super(),this.options=S,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new A.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new C.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,A.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,C.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,N.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,p){if(p===e.TARGET_KEY){switch(S){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:S})}else this._onDidChangeValue.fire({scope:S,key:p,target:this.getKeyTargets(S)[p]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,p,w){return this.getStorage(p)?.get(S,w)}getBoolean(S,p,w){return this.getStorage(p)?.getBoolean(S,w)}getNumber(S,p,w){return this.getStorage(p)?.getNumber(S,w)}store(S,p,w,t){if((0,O.isUndefinedOrNull)(p)){this.remove(S,w);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,w,t),this.getStorage(w)?.set(S,p)})}remove(S,p){this.withPausedEmitters(()=>{this.updateKeyTarget(S,p,void 0),this.getStorage(p)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,p){const w=[],t=this.getKeyTargets(S);for(const o of Object.keys(t))t[o]===p&&w.push(o);return w}updateKeyTarget(S,p,w){const t=this.getKeyTargets(p);typeof w=="number"?t[S]!==w&&(t[S]=w,this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[S]=="number"&&(delete t[S],this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(S){switch(S){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(S){const p=this.getStorage(S);return p?v(p):Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(S=b.NONE){this._onWillSaveState.fire({reason:S});const p=this.getStorage(-1),w=this.getStorage(0),t=this.getStorage(1);switch(S){case b.NONE:await A.Promises.settled([p?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await A.Promises.settled([p?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const S=this.getStorage(-1)?.items??new Map,p=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return g(S,p,w,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(S,p){return this.emitWillSaveState(b.NONE),(0,c.isUserDataProfile)(S)?this.switchToProfile(S,p):this.switchToWorkspace(S,p)}canSwitchProfile(S,p){return!(S.id===p.id||D(p)&&D(S))}switchData(S,p,w,t){this.withPausedEmitters(()=>{if(t)for(const[o,n]of S)p.set(o,n);else{const o=new Set;for(const[n,i]of S)o.add(n),p.get(n)!==i&&this.emitDidChangeValue(w,n);for(const[n]of p.items)o.has(n)||this.emitDidChangeValue(w,n)}})}}e.AbstractStorageService=L,L.DEFAULT_FLUSH_INTERVAL=60*1e3;function D(f){return f.isDefault||!!f.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=D;class u extends L{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.profileStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S))),this._register(this.applicationStorage.onDidChangeStorage(S=>this.emitDidChangeValue(-1,S)))}getStorage(S){switch(S){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(S){switch(S){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(S){return!1}}e.InMemoryStorageService=u;async function g(f,S,p,w,t,o){const n=Y=>{try{return JSON.parse(Y)}catch{return Y}},i=new Map,r=new Map;f.forEach((Y,X)=>{i.set(X,Y),r.set(X,n(Y))});const a=new Map,l=new Map;S.forEach((Y,X)=>{a.set(X,Y),l.set(X,n(Y))});const d=new Map,E=new Map;p.forEach((Y,X)=>{d.set(X,Y),E.set(X,n(Y))}),console.group(w!==t?`Storage: Application (path: ${w})`:`Storage: Application & Profile (path: ${w}, default profile)`);const k=[];if(i.forEach((Y,X)=>{k.push({key:X,value:Y})}),console.table(k),console.groupEnd(),console.log(r),w!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];a.forEach((X,ee)=>{Y.push({key:ee,value:X})}),console.table(Y),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const F=[];d.forEach((Y,X)=>{F.push({key:X,value:Y})}),console.table(F),console.groupEnd(),console.log(E)}e.logStorage=g}),define(ie[154],ne([0,1,19,23,9,12,37,3,11,24,18,20,26,46,13,6,31,43,139,153,25]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v,L,D,u,g,f,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const w=N.isWeb?"web":(0,y.getTargetPlatform)(N.platform,O.arch),t="X-Market-Search-Activity-Id";var o;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function n(...R){return String(R.reduce((s,P)=>s|P,0))}var i;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class E{constructor(s=d){this.state=s}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(s,P=this.state.pageSize){return new E({...this.state,pageNumber:s,pageSize:P})}withFilter(s,...P){const _=[...this.state.criteria,...P.length?P.map(W=>({filterType:s,value:W})):[{filterType:s}]];return new E({...this.state,criteria:_})}withSortBy(s){return new E({...this.state,sortBy:s})}withSortOrder(s){return new E({...this.state,sortOrder:s})}withFlags(...s){return new E({...this.state,flags:s.reduce((P,_)=>P|_,0)})}withAssetTypes(...s){return new E({...this.state,assetTypes:s})}withSource(s){return new E({...this.state,source:s})}get raw(){const{criteria:s,pageNumber:P,pageSize:_,sortBy:W,sortOrder:K,flags:Q,assetTypes:ae}=this.state;return{filters:[{criteria:s,pageNumber:P,pageSize:_,sortBy:W,sortOrder:K}],assetTypes:ae,flags:Q}}get searchText(){const s=this.state.criteria.filter(P=>P.filterType===i.SearchText)[0];return s&&s.value?s.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(s=>String(s.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function k(R,s){const P=(R||[]).filter(_=>_.statisticName===s)[0];return P?P.value:0}function F(R){const s="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(_=>_.assetType.indexOf(s)===0).reduce((_,W)=>{const K=ee(R,W.assetType);return K&&_.push([W.assetType.substring(s.length),K]),_},[])}function Y(R){if(R.properties){const s=R.properties.filter(W=>W.key===r.Repository),P=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),_=s.filter(W=>P.test(W.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return ee(R,r.Repository)}function X(R){return{uri:`${R.fallbackAssetUri}/${r.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${r.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function ee(R,s){return R.files.filter(_=>_.assetType===s)[0]?{uri:`${R.assetUri}/${s}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${s}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function le(R,s){const P=R.properties?R.properties.filter(W=>W.key===s):[],_=P.length>0&&P[0].value;return _?_.split(",").map(W=>(0,m.adoptToGalleryExtensionId)(W)):[]}function re(R){const s=R.properties?R.properties.filter(P=>P.key===a.Engine):[];return s.length>0&&s[0].value||""}function fe(R){const s=R.properties?R.properties.filter(P=>P.key===a.PreRelease):[];return s.length>0&&s[0].value==="true"}function ce(R){const s=R.properties?R.properties.filter(_=>_.key===a.LocalizedLanguages):[],P=s.length>0&&s[0].value||"";return P?P.split(","):[]}function se(R){return R.properties?.find(s=>s.key===a.SponsorLink)?.value}function j(R){return R.indexOf("preview")!==-1}function B(R){return R.targetPlatform?(0,y.toTargetPlatform)(R.targetPlatform):"undefined"}function V(R){const s=(0,A.distinct)(R.versions.map(B)),P=!!R.tags?.includes(y.WEB_EXTENSION_TAG),_=s.indexOf("web");return P?_===-1&&s.push("web"):_!==-1&&s.splice(_,1),s}function M(R,s){const P=(0,y.getFallbackTargetPlarforms)(s);for(let _=0;_<R.length;_++){const W=R[_];if(W.version===R[_-1]?.version){let K=_;const Q=B(W);if(Q===s)for(;K>0&&R[K-1].version===W.version;)K--;else if(P.includes(Q))for(;K>0&&R[K-1].version===W.version&&B(R[K-1])!==s;)K--;K!==_&&(R.splice(_,1),R.splice(K,0,W))}}return R}e.sortExtensionVersions=M;function $(R,s,P){R.telemetryData={index:s,querySource:P,queryActivityId:R.queryContext?.[t]}}function G(R,s,P,_){const W=R.versions[0],K={manifest:ee(s,r.Manifest),readme:ee(s,r.Details),changelog:ee(s,r.Changelog),license:ee(s,r.License),repository:Y(s),download:X(s),icon:ee(s,r.Icon),signature:ee(s,r.Signature),coreTranslations:F(s)};return{identifier:{id:(0,m.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:s.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:se(W),description:R.shortDescription||"",installCount:k(R.statistics,"install"),rating:k(R.statistics,"averagerating"),ratingCount:k(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:P,assets:K,properties:{dependencies:le(s,a.Dependency),extensionPack:le(s,a.ExtensionPack),engine:re(s),localizedLanguages:ce(s),targetPlatform:B(s),isPreReleaseVersion:fe(s)},hasPreReleaseVersion:fe(W),hasReleaseVersion:!0,preview:j(R.flags),isSigned:!!K.signature,queryContext:_}}let H=class{constructor(s,P,_,W,K,Q,ae,de){this.requestService=P,this.logService=_,this.environmentService=W,this.telemetryService=K,this.fileService=Q,this.productService=ae,this.configurationService=de;const pe=ae.extensionsGallery,ue=pe?.servicePPEUrl&&de.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ue?pe.servicePPEUrl:pe?.serviceUrl,this.extensionsGallerySearchUrl=ue?void 0:pe?.searchUrl,this.extensionsControlUrl=pe?.controlUrl,this.commonHeadersPromise=(0,f.resolveMarketplaceHeaders)(ae.version,ae,this.environmentService,this.configurationService,this.fileService,s,this.telemetryService)}api(s=""){return`${this.extensionsGalleryUrl}${s}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(s,P,_){const W=T.CancellationToken.isCancellationToken(P)?{}:P,K=T.CancellationToken.isCancellationToken(P)?P:_,Q=[],ae=[],de=[],pe=[];let ue=!0;for(const he of s){he.uuid?ae.push(he.uuid):Q.push(he.id);const Ee=!!(he.version||he.preRelease);de.push({id:he.id,uuid:he.uuid,includePreRelease:Ee}),he.version&&pe.push({id:he.id,uuid:he.uuid,version:he.version}),ue=ue&&!!he.hasPreRelease&&!Ee}if(!ae.length&&!Q.length)return[];let ge=new E().withPage(1,s.length);ae.length&&(ge=ge.withFilter(i.ExtensionId,...ae)),Q.length&&(ge=ge.withFilter(i.ExtensionName,...Q)),(W.queryAllVersions||ue)&&(ge=ge.withFlags(ge.flags,o.IncludeVersions)),W.source&&(ge=ge.withSource(W.source));const{extensions:oe}=await this.queryGalleryExtensions(ge,{targetPlatform:W.targetPlatform??w,includePreRelease:de,versions:pe,compatible:!!W.compatible},K);return W.source&&oe.forEach((he,Ee)=>$(he,Ee,W.source)),oe}async getCompatibleExtension(s,P,_){if((0,y.isNotWebExtensionInWebTargetPlatform)(s.allTargetPlatforms,_))return null;if(await this.isExtensionCompatible(s,P,_))return s;const W=new E().withFlags(o.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,s.identifier.uuid),{extensions:K}=await this.queryGalleryExtensions(W,{targetPlatform:_,compatible:!0,includePreRelease:P},T.CancellationToken.None);return K[0]||null}async isExtensionCompatible(s,P,_){if(!(0,y.isTargetPlatformCompatible)(s.properties.targetPlatform,s.allTargetPlatforms,_)||!P&&s.properties.isPreReleaseVersion)return!1;let W=s.properties.engine;if(!W){const K=await this.getManifest(s,T.CancellationToken.None);if(!K)throw new Error("Manifest was not found");W=K.engines.vscode}return(0,v.isEngineValid)(W,this.productService.version,this.productService.date)}async isValidVersion(s,P,_,W,K){if(!(0,y.isTargetPlatformCompatible)(B(s),W,K)||P!=="any"&&fe(s)!==(P==="prerelease"))return!1;if(_)try{const Q=await this.getEngine(s);if(!(0,v.isEngineValid)(Q,this.productService.version,this.productService.date))return!1}catch(Q){return this.logService.error(`Error while getting the engine for the version ${s.version}.`,(0,C.getErrorMessage)(Q)),!1}return!0}async query(s,P){let _=s.text||"";const W=s.pageSize??50;let K=new E().withPage(1,W);_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ge,oe)=>(K=K.withFilter(i.Category,oe||ge),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ge,oe)=>(K=K.withFilter(i.Tag,oe||ge),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(i.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),K=K.withFilter(i.SearchText,_)),K=K.withSortBy(0)):s.ids?K=K.withFilter(i.ExtensionId,...s.ids):s.names?K=K.withFilter(i.ExtensionName,...s.names):K=K.withSortBy(4),typeof s.sortBy=="number"&&(K=K.withSortBy(s.sortBy)),typeof s.sortOrder=="number"&&(K=K.withSortOrder(s.sortOrder)),s.source&&(K=K.withSource(s.source));const Q=async(ue,ge)=>{const{extensions:oe,total:he}=await this.queryGalleryExtensions(ue,{targetPlatform:w,compatible:!1,includePreRelease:!!s.includePreRelease},ge);return oe.forEach((Ee,De)=>$(Ee,(ue.pageNumber-1)*ue.pageSize+De,s.source)),{extensions:oe,total:he}},{extensions:ae,total:de}=await Q(K,P),pe=async(ue,ge)=>{if(ge.isCancellationRequested)throw new C.CancellationError;const{extensions:oe}=await Q(K.withPage(ue+1),ge);return oe};return{firstPage:ae,total:de,pageSize:K.pageSize,getPage:pe}}async queryGalleryExtensions(s,P,_){const W=s.flags;s.flags&o.IncludeLatestVersionOnly&&s.flags&o.IncludeVersions&&(s=s.withFlags(s.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(s.flags&o.IncludeLatestVersionOnly)&&!(s.flags&o.IncludeVersions)&&(s=s.withFlags(s.flags,o.IncludeLatestVersionOnly)),P.versions?.length&&(s=s.withFlags(s.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),s=s.withFlags(s.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:K,total:Q,context:ae}=await this.queryRawGalleryExtensions(s,_);if(!(s.flags&o.IncludeLatestVersionOnly)){const ge=[];for(const oe of K){const he=await this.toGalleryExtensionWithCriteria(oe,P,ae);he&&ge.push(he)}return{extensions:ge,total:Q}}const pe=[],ue=new Map;for(let ge=0;ge<K.length;ge++){const oe=K[ge],he={id:(0,m.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName),uuid:oe.extensionId},Ee=(0,I.isBoolean)(P.includePreRelease)?P.includePreRelease:!!P.includePreRelease.find(Ne=>(0,m.areSameExtensions)(Ne,he))?.includePreRelease;if(P.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(V(oe),P.targetPlatform))continue;const De=await this.toGalleryExtensionWithCriteria(oe,P,ae);!De||De.properties.isPreReleaseVersion&&(!Ee||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==P.targetPlatform&&De.hasPreReleaseVersion?ue.set(oe.extensionId,ge):pe.push([ge,De])}if(ue.size){const ge=new Date().getTime(),oe=new E().withFlags(W&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,ue.size).withFilter(i.ExtensionId,...ue.keys()),{extensions:he}=await this.queryGalleryExtensions(oe,P,_);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:ue.size});for(const Ee of he){const De=ue.get(Ee.identifier.uuid);pe.push([De,Ee])}}return{extensions:pe.sort((ge,oe)=>ge[0]-oe[0]).map(([,ge])=>ge),total:Q}}async toGalleryExtensionWithCriteria(s,P,_){const W={id:(0,m.getGalleryExtensionId)(s.publisher.publisherName,s.extensionName),uuid:s.extensionId},K=P.versions?.find(pe=>(0,m.areSameExtensions)(pe,W))?.version,Q=(0,I.isBoolean)(P.includePreRelease)?P.includePreRelease:!!P.includePreRelease.find(pe=>(0,m.areSameExtensions)(pe,W))?.includePreRelease,ae=V(s),de=M(s.versions,P.targetPlatform);if(P.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(ae,P.targetPlatform))return null;for(let pe=0;pe<de.length;pe++){const ue=de[pe];if(!(K&&ue.version!==K)){if(await this.isValidVersion(ue,Q?"any":"release",P.compatible,ae,P.targetPlatform))return G(s,ue,ae,_);if(K&&ue.version===K)return null}}return K||P.compatible?null:G(s,s.versions[0],ae)}async queryRawGalleryExtensions(s,P){if(!this.isEnabled())throw new Error("No extension gallery service configured.");s=s.withFlags(s.flags,o.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(o.Unpublished));const _=await this.commonHeadersPromise,W=JSON.stringify(s.raw),K={..._,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)},Q=new Date().getTime();let ae,de,pe=0;try{if(ae=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&s.criteria.some(ge=>ge.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:W,headers:K},P),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:pe};const ue=await(0,g.asJson)(ae);if(ue){const ge=ue.results[0],oe=ge.extensions,he=ge.resultMetadata&&ge.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return pe=he&&he.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:oe,total:pe,context:{[t]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:pe}}catch(ue){throw de=ue,ue}finally{this.telemetryService.publicLog2("galleryService:query",{...s.telemetryData,requestBodySize:String(W.length),duration:new Date().getTime()-Q,success:!!ae&&(0,g.isSuccess)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:de?(0,C.isCancellationError)(de)?"canceled":(0,C.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(pe)})}}async reportStatistic(s,P,_,W){if(!this.isEnabled())return;const K=N.isWeb?this.api(`/itemName/${s}.${P}/version/${_}/statType/${W==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${s}/extensions/${P}/${_}/stats?statType=${W}`),Q=N.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",de={...await this.commonHeadersPromise,Accept:Q};try{await this.requestService.request({type:"POST",url:K,headers:de},T.CancellationToken.None)}catch{}}async download(s,P,_){this.logService.trace("ExtensionGalleryService#download",s.identifier.id);const W=(0,m.getGalleryExtensionTelemetryData)(s),K=new Date().getTime(),Q=ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...W,duration:ge}),ae=_===2?"install":_===3?"update":"",de=ae?{uri:`${s.assets.download.uri}${h.URI.parse(s.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${s.assets.download.fallbackUri}${h.URI.parse(s.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:s.assets.download,pe=s.queryContext?.[t]?{[t]:s.queryContext[t]}:void 0,ue=await this.getAsset(de,pe?{headers:pe}:void 0);await this.fileService.writeFile(P,ue.stream),Q(new Date().getTime()-K)}async downloadSignatureArchive(s,P){if(!s.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",s.identifier.id);const _=await this.getAsset(s.assets.signature);await this.fileService.writeFile(P,_.stream)}async getReadme(s,P){if(s.assets.readme){const _=await this.getAsset(s.assets.readme,{},P);return await(0,g.asTextOrError)(_)||""}return""}async getManifest(s,P){if(s.assets.manifest){const _=await this.getAsset(s.assets.manifest,{},P),W=await(0,g.asTextOrError)(_);return W?JSON.parse(W):null}return null}async getManifestFromRawExtensionVersion(s,P){const _=ee(s,r.Manifest);if(!_)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},K=await this.getAsset(_,{headers:W});return await(0,g.asJson)(K)}async getCoreTranslation(s,P){const _=s.assets.coreTranslations.filter(W=>W[0]===P.toUpperCase())[0];if(_){const W=await this.getAsset(_[1]),K=await(0,g.asTextOrError)(W);return K?JSON.parse(K):null}return null}async getChangelog(s,P){if(s.assets.changelog){const _=await this.getAsset(s.assets.changelog,{},P);return await(0,g.asTextOrError)(_)||""}return""}async getAllCompatibleVersions(s,P,_){let W=new E().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);s.identifier.uuid?W=W.withFilter(i.ExtensionId,s.identifier.uuid):W=W.withFilter(i.ExtensionName,s.identifier.id);const{galleryExtensions:K}=await this.queryRawGalleryExtensions(W,T.CancellationToken.None);if(!K.length)return[];const Q=V(K[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)(Q,_))return[];const ae=[];await Promise.all(K[0].versions.map(async ue=>{try{await this.isValidVersion(ue,P?"any":"release",!0,Q,_)&&ae.push(ue)}catch{}}));const de=[],pe=new Set;for(const ue of M(ae,_))pe.has(ue.version)||(pe.add(ue.version),de.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:fe(ue)}));return de}async getAsset(s,P={},_=T.CancellationToken.None){const W=await this.commonHeadersPromise,K={type:"GET"},Q={...W,...P.headers||{}};P={...P,...K,headers:Q};const ae=s.uri,de=s.fallbackUri,pe={...P,url:ae};try{const ue=await this.requestService.request(pe,_);if(ue.res.statusCode===200)return ue;const ge=await(0,g.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ge}`)}catch(ue){if((0,C.isCancellationError)(ue))throw ue;const ge=(0,C.getErrorMessage)(ue);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:ge});const oe={...P,url:de};return this.requestService.request(oe,_)}}async getEngine(s){let P=re(s);if(!P){const _=await this.getManifestFromRawExtensionVersion(s,T.CancellationToken.None);if(!_)throw new Error("Manifest was not found");P=_.engines.vscode}return P}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const s=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},T.CancellationToken.None);if(s.res.statusCode!==200)throw new Error("Could not get extensions report.");const P=await(0,g.asJson)(s),_=[],W={};if(P){for(const K of P.malicious)_.push({id:K});if(P.migrateToPreRelease)for(const[K,Q]of Object.entries(P.migrateToPreRelease))(!Q.engine||(0,v.isEngineValid)(Q.engine,this.productService.version,this.productService.date))&&(W[K.toLowerCase()]={disallowInstall:!0,extension:{id:Q.id,displayName:Q.displayName,autoMigrate:{storage:!!Q.migrateStorage},preRelease:!0}});if(P.deprecated)for(const[K,Q]of Object.entries(P.deprecated))Q&&(W[K.toLowerCase()]=(0,I.isBoolean)(Q)?{}:Q)}return{malicious:_,deprecated:W}}};H=ve([te(1,g.IRequestService),te(2,D.ILogService),te(3,b.IEnvironmentService),te(4,p.ITelemetryService),te(5,L.IFileService),te(6,u.IProductService),te(7,c.IConfigurationService)],H);let x=e.ExtensionGalleryService=class extends H{constructor(s,P,_,W,K,Q,ae,de){super(s,P,_,W,K,Q,ae,de)}};e.ExtensionGalleryService=x=ve([te(0,S.IStorageService),te(1,g.IRequestService),te(2,D.ILogService),te(3,b.IEnvironmentService),te(4,p.ITelemetryService),te(5,L.IFileService),te(6,u.IProductService),te(7,c.IConfigurationService)],x);let U=e.ExtensionGalleryServiceWithNoStorageService=class extends H{constructor(s,P,_,W,K,Q,ae){super(void 0,s,P,_,W,K,Q,ae)}};e.ExtensionGalleryServiceWithNoStorageService=U=ve([te(0,g.IRequestService),te(1,D.ILogService),te(2,b.IEnvironmentService),te(3,p.ITelemetryService),te(4,L.IFileService),te(5,u.IProductService),te(6,c.IConfigurationService)],U)}),define(ie[155],ne([0,1,11,18,13,6,136,27,21,3,68]),function(q,e,A,T,C,N,O,I,h,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let y=e.UserDataProfilesReadonlyService=class ze extends h.UserDataProfilesService{constructor(D,u,g,f,S){super(g,f,u,S),this.stateReadonlyService=D,this.nativeEnvironmentService=g}getStoredProfiles(){return this.stateReadonlyService.getItem(ze.PROFILES_KEY,[]).map(u=>({...u,location:(0,c.isString)(u.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,u.location):A.URI.revive(u.location)}))}getStoredProfileAssociations(){const D=this.stateReadonlyService.getItem(ze.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(ze.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?D:this.migrateStoredProfileAssociations(D)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(A.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration",e.UserDataProfilesReadonlyService=y=ve([te(0,O.IStateReadService),te(1,I.IUriIdentityService),te(2,T.INativeEnvironmentService),te(3,C.IFileService),te(4,N.ILogService)],y);let m=e.UserDataProfilesService=class Ue extends y{constructor(D,u,g,f,S){super(D,u,g,f,S),this.stateService=D}saveStoredProfiles(D){D.length?this.stateService.setItem(Ue.PROFILES_KEY,D.map(u=>({...u,location:this.uriIdentityService.extUri.basename(u.location)}))):this.stateService.removeItem(Ue.PROFILES_KEY)}getStoredProfiles(){const D=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(D),this.stateService.setItem("userDataProfilesMigration",!0)),D}saveStoredProfileAssociations(D){D.emptyWindows||D.workspaces?this.stateService.setItem(Ue.PROFILE_ASSOCIATIONS_KEY,D):this.stateService.removeItem(Ue.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const D="workspaceAndProfileInfo",u=this.stateService.getItem(D,void 0);if(u){this.stateService.removeItem(D);const f=u.reduce((S,{workspace:p,profile:w})=>(S[A.URI.revive(p).toString()]=A.URI.revive(w).toString(),S),{});this.stateService.setItem(Ue.PROFILE_ASSOCIATIONS_KEY,{workspaces:f})}const g=super.getStoredProfileAssociations();return this.stateService.getItem(Ue.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(g),this.stateService.setItem(Ue.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),g}};e.UserDataProfilesService=m=ve([te(0,O.IStateService),te(1,I.IUriIdentityService),te(2,T.INativeEnvironmentService),te(3,C.IFileService),te(4,N.ILogService)],m);let v=e.ServerUserDataProfilesService=class extends m{constructor(D,u,g,f){super(new b.StateService(0,u,f,g),D,u,g,f)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=v=ve([te(0,I.IUriIdentityService),te(1,T.INativeEnvironmentService),te(2,C.IFileService),te(3,N.ILogService)],v)}),define(ie[49],ne([0,1,122,8,15,3,22,85,170,171]),function(q,e,A,T,C,N,O,I,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const b=new RegExp(e.CorruptZipMessage);class y extends Error{constructor(o,n){let i=n.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=n}}e.ExtractError=y;function m(t){const o=t.externalFileAttributes>>16||33188;return[448,56,7].map(n=>o&n).reduce((n,i)=>n+i,o&61440)}function v(t){if(t instanceof y)return t;let o;return b.test(t.message)&&(o="CorruptZip"),new y(o,t)}function L(t,o,n,i,r,a){const l=C.dirname(o),d=C.join(i,l);if(!d.startsWith(i))return Promise.reject(new Error(I.localize(0,null,o)));const E=C.join(i,o);let k;return a.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(O.Promises.mkdir(d,{recursive:!0})).then(()=>new Promise((F,Y)=>{if(!a.isCancellationRequested)try{k=(0,A.createWriteStream)(E,{mode:n}),k.once("close",()=>F()),k.once("error",Y),t.once("error",Y),t.pipe(k)}catch(X){Y(X)}}))}function D(t,o,n,i){let r=(0,T.createCancelablePromise)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{r.cancel(),t.close()}),new Promise((l,d)=>{const E=new T.Sequencer,k=F=>{F.isCancellationRequested||(a++,t.readEntry())};t.once("error",d),t.once("close",()=>r.then(()=>{i.isCancellationRequested||t.entryCount===a?l():d(new y("Incomplete",new Error(I.localize(1,null,a,t.entryCount))))},d)),t.readEntry(),t.on("entry",F=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(F.fileName)){k(i);return}const Y=F.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(Y)){const le=C.join(o,Y);r=(0,T.createCancelablePromise)(re=>O.Promises.mkdir(le,{recursive:!0}).then(()=>k(re)).then(void 0,d));return}const X=g(t,F),ee=m(F);r=(0,T.createCancelablePromise)(le=>E.queue(()=>X.then(re=>L(re,Y,ee,o,n,le).then(()=>k(le)))).then(null,d))})})}function u(t,o=!1){return new Promise((n,i)=>{(0,h.open)(t,o?{lazyEntries:!0}:void 0,(r,a)=>{r?i(v(r)):n((0,N.assertIsDefined)(a))})})}function g(t,o){return new Promise((n,i)=>{t.openReadStream(o,(r,a)=>{r?i(v(r)):n((0,N.assertIsDefined)(a))})})}function f(t,o){return new Promise((n,i)=>{const r=new c.ZipFile;o.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const a=(0,A.createWriteStream)(t);r.outputStream.pipe(a),r.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>n(t))})}e.zip=f;function S(t,o,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let a=u(t,!0);return n.overwrite&&(a=a.then(l=>O.Promises.rm(o).then(()=>l))),a.then(l=>D(l,o,{sourcePathRegex:r},i))}e.extract=S;function p(t,o){return u(t).then(n=>new Promise((i,r)=>{n.on("entry",a=>{a.fileName===o&&g(n,a).then(l=>i(l),l=>r(l))}),n.once("close",()=>r(new Error(I.localize(2,null,o))))}))}function w(t,o){return p(t,o).then(n=>new Promise((i,r)=>{const a=[];n.once("error",r),n.on("data",l=>a.push(l)),n.on("end",()=>i(Buffer.concat(a)))}))}e.buffer=w}),define(ie[156],ne([0,1,8,9,2,16,12,17,41,3,28,22,49,24,18,20,26,60,13,6]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v,L,D,u,g,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=e.ExtensionsDownloader=class je extends C.Disposable{constructor(t,o,n,i,r,a){super(),this.fileService=o,this.extensionGalleryService=n,this.configurationService=i,this.extensionSignatureVerificationService=r,this.logService=a,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(t,o,n){await this.cleanUpPromise;const i=(0,I.joinPath)(this.extensionsDownloadDir,this.getName(t));try{await this.downloadFile(t,i,a=>this.extensionGalleryService.download(t,a,o))}catch(a){throw new D.ExtensionManagementError(a.message,D.ExtensionManagementErrorCode.Download)}let r=!1;if(n&&this.shouldVerifySignature(t)){const a=await this.downloadSignatureArchive(t);try{r=await this.extensionSignatureVerificationService.verify(i.fsPath,a.fsPath,this.logService.getLevel()===S.LogLevel.Trace)}catch(l){const d=l;if(r=d.code,d.output&&this.logService.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${d.output}`),r===D.ExtensionSignaturetErrorCode.PackageIsInvalidZip||r===D.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new D.ExtensionManagementError(m.CorruptZipMessage,D.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(a)}catch(l){this.logService.error(l)}}}return r===!0?this.logService.info(`Extension signature is verified: ${t.identifier.id}`):r===!1?this.logService.info(`Extension signature verification is not done: ${t.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${r}': ${t.identifier.id}`),{location:i,verificationStatus:r}}shouldVerifySignature(t){if(!t.isSigned)return!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,c.isBoolean)(o)?o:!0}async downloadSignatureArchive(t){await this.cleanUpPromise;const o=(0,I.joinPath)(this.extensionsDownloadDir,`${this.getName(t)}${je.SignatureArchiveExtension}`);return await this.downloadFile(t,o,n=>this.extensionGalleryService.downloadSignatureArchive(t,n)),o}async downloadFile(t,o,n){if(await this.fileService.exists(o))return;if(o.scheme!==N.Schemas.file){await n(o);return}const i=(0,I.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(i)||await n(i);try{await this.rename(i,o,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(i)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(r)}. Deleted the file from downloaded location`,i.path),r}}async delete(t){await this.cleanUpPromise,await this.fileService.del(t)}async rename(t,o,n){try{await y.Promises.rename(t.fsPath,o.fsPath)}catch(i){if(O.isWindows&&i&&i.code==="EPERM"&&Date.now()<n)return this.logService.info(`Failed renaming ${t} to ${o} with 'EPERM' error. Trying again...`),this.rename(t,o,n);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],n=[],i=[];for(const l of t.children)if(l.name.endsWith(je.SignatureArchiveExtension))i.push(l.resource);else{const d=u.ExtensionKey.parse(l.name);d&&n.push([d,l])}const r=(0,u.groupByExtension)(n,([l])=>l),a=[];for(const l of r)l.sort((d,E)=>h.rcompare(d[0].version,E[0].version)),o.push(...l.slice(1).map(d=>d[1].resource)),a.push(l[0][1]);a.sort((l,d)=>l.mtime-d.mtime),o.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(l=>l.resource)),o.push(...i),await A.Promises.settled(o.map(l=>(this.logService.trace("Deleting from cache",l.path),this.fileService.del(l))))}}catch(t){this.logService.error(t)}}getName(t){return this.cache?u.ExtensionKey.create(t).toString().toLowerCase():(0,b.generateUuid)()}};p.SignatureArchiveExtension=".sigzip",e.ExtensionsDownloader=p=ve([te(0,L.INativeEnvironmentService),te(1,f.IFileService),te(2,D.IExtensionGalleryService),te(3,v.IConfigurationService),te(4,g.IExtensionSignatureVerificationService),te(5,S.ILogService)],p)}),define(ie[157],ne([0,1,49,95]),function(q,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function C(N){return(0,A.buffer)(N,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,T.localize)(0,null))}})}e.getManifest=C}),define(ie[158],ne([0,1,8,14,23,32,9,5,2,33,16,15,12,17,41,3,11,28,22,49,94,59,18,149,20,26,40,48,156,150,157,131,138,46,13,10,6,31,25,27,21]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v,L,D,u,g,f,S,p,w,t,o,n,i,r,a,l,d,E,k,F,Y,X,ee,le,re,fe,ce,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ee.refineServiceDecorator)(n.IExtensionManagementService);let j=e.ExtensionManagementService=class extends o.AbstractExtensionManagementService{constructor(x,U,R,s,P,_,W,K,Q,ae,de,pe){super(x,U,R,ae,pe),this.extensionsScannerService=P,this.extensionsProfileScannerService=_,this.downloadService=W,this.fileService=Q,this.uriIdentityService=de,this._onDidUpdateExtensionMetadata=this._register(new I.Emitter),this.onDidUpdateExtensionMetadata=this._onDidUpdateExtensionMetadata.event,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new c.ResourceSet;const ue=this._register(K.createInstance(d.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(B,oe=>ue.postUninstall(oe))),this.manifestCache=this._register(new k.ExtensionsManifestCache(pe,Q,de,this,this.logService)),this.extensionsDownloader=this._register(K.createInstance(l.ExtensionsDownloader));const ge=this._register(new F.ExtensionsWatcher(this,this.extensionsScannerService,pe,_,de,Q,R));this._register(ge.onDidChangeExtensionsByAnotherSource(oe=>this.onDidChangeExtensionsFromAnotherSource(oe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(x){this.logService.trace("ExtensionManagementService#zip",x.identifier.id);const U=await this.collectFiles(x),R=await(0,S.zip)((0,v.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,g.generateUuid)()).fsPath,U);return u.URI.file(R)}async unzip(x){return this.logService.trace("ExtensionManagementService#unzip",x.toString()),(await this.install(x)).identifier}async getManifest(x){const{location:U,cleanup:R}=await this.downloadVsix(x),s=y.resolve(U.fsPath);try{return await(0,E.getManifest)(s)}finally{await R()}}getInstalled(x,U=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(x??null,U)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(x){return this.extensionsScanner.scanUserExtensionAtLocation(x)}async install(x,U={}){this.logService.trace("ExtensionManagementService#install",x.toString());const{location:R,cleanup:s}=await this.downloadVsix(x);try{const P=await(0,E.getManifest)(y.resolve(R.fsPath));if(P.engines&&P.engines.vscode&&!(0,Y.isEngineValid)(P.engines.vscode,this.productService.version,this.productService.date))throw new Error(p.localize(0,null,(0,i.getGalleryExtensionId)(P.publisher,P.name),this.productService.version));return await this.installExtension(P,R,U)}finally{await s()}}async installFromLocation(x,U){this.logService.trace("ExtensionManagementService#installFromLocation",x.toString());const R=await this.extensionsScanner.scanUserExtensionAtLocation(x);if(!R)throw new Error(`Cannot find a valid extension from the location ${x.toString()}`);return await this.addExtensionsToProfile([[R,void 0]],U),this.logService.info("Successfully installed extension",R.identifier.id,U.toString()),R}async installExtensionsFromProfile(x,U,R){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",x,U.toString(),R.toString());const s=(await this.extensionsScanner.scanExtensions(1,U)).filter(P=>x.some(_=>(0,i.areSameExtensions)(_,P.identifier)));if(s.length){const P=await Promise.all(s.map(_=>this.extensionsScanner.scanMetadata(_,U)));await this.addExtensionsToProfile(s.map((_,W)=>[_,P[W]]),R),this.logService.info("Successfully installed extensions",s.map(_=>_.identifier.id),R.toString())}return s}async updateMetadata(x,U,R=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",x.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0),U.isMachineScoped=U.isMachineScoped||void 0,U.isBuiltin=U.isBuiltin||void 0,U.pinned=U.pinned||void 0,x=await this.extensionsScanner.updateMetadata(x,U,R),this.manifestCache.invalidate(R),this._onDidUpdateExtensionMetadata.fire(x),x}async reinstallFromGallery(x){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",x.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(1,null));const U=await this.getTargetPlatform(),[R]=await this.galleryService.getExtensions([{...x.identifier,preRelease:x.preRelease}],{targetPlatform:U,compatible:!0},C.CancellationToken.None);if(!R)throw new Error(p.localize(2,null));await this.extensionsScanner.setUninstalled(x);try{await this.extensionsScanner.removeUninstalledExtension(x)}catch(s){throw new Error(p.localize(3,null,(0,N.toErrorMessage)(s)))}return this.installFromGallery(R)}copyExtensions(x,U){return this.extensionsScanner.copyExtensions(x,U)}markAsUninstalled(...x){return this.extensionsScanner.setUninstalled(...x)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(x){this.logService.error(x)}}async download(x,U,R){const{location:s}=await this.extensionsDownloader.download(x,U,!R);return s}async downloadVsix(x){if(x.scheme===b.Schemas.file)return{location:x,async cleanup(){}};this.logService.trace("Downloading extension from",x.toString());const U=(0,v.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,g.generateUuid)());return await this.downloadService.download(x,U),this.logService.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.fileService.del(U)}catch(s){this.logService.error(s)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(x,U,R){if(u.URI.isUri(U))return new $(x,U,R,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const s=i.ExtensionKey.create(U).toString();let P=this.installGalleryExtensionsTasks.get(s);return P||(this.installGalleryExtensionsTasks.set(s,P=new M(x,U,R,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),P.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(s))),P}createUninstallExtensionTask(x,U){return new G(x,U.profileLocation,this.extensionsProfileScannerService)}async collectFiles(x){const U=async s=>{let P=await f.Promises.readdir(s);P=P.map(K=>y.join(s,K));const _=await Promise.all(P.map(K=>f.Promises.stat(K)));let W=Promise.resolve([]);return _.forEach((K,Q)=>{const ae=P[Q];K.isFile()&&(W=W.then(de=>[...de,ae])),K.isDirectory()&&(W=W.then(de=>U(ae).then(pe=>[...de,...pe])))}),W};return(await U(x.location.fsPath)).map(s=>({path:`extension/${y.relative(x.location.fsPath,s)}`,localPath:s}))}async onDidChangeExtensionsFromAnotherSource({added:x,removed:U}){if(U)for(const R of U.extensions)this.logService.info("Extensions removed from another source",R.id,U.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:R,profileLocation:U.profileLocation});if(x){const s=(await this.extensionsScanner.scanExtensions(1,x.profileLocation)).filter(P=>x.extensions.some(_=>(0,i.areSameExtensions)(_,P.identifier)));this._onDidInstallExtensions.fire(s.map(P=>(this.logService.info("Extensions added from another source",P.identifier.id,x.profileLocation.toString()),{identifier:P.identifier,local:P,profileLocation:x.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(U=>this.knownDirectories.add(U)));const x=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const U of x.children??[])U.isDirectory&&this.knownDirectories.add(U.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(U=>this.onDidFilesChange(U)))}async onDidFilesChange(x){if(!x.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const U=[];for(const R of x.rawAdded){if(this.knownDirectories.has(R)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(R),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(R,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(R).startsWith(".")||!(await this.fileService.stat(R)).isDirectory)continue;const s=await this.extensionsScanner.scanUserExtensionAtLocation(R);s&&s.installedTimestamp===void 0&&(this.knownDirectories.add(R),U.push(s))}U.length&&(await this.addExtensionsToProfile(U.map(R=>[R,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",U.map(R=>R.identifier.id)))}async addExtensionsToProfile(x,U){const R=x.map(s=>s[0]);await this.setInstalled(R),await this.extensionsProfileScannerService.addExtensionsToProfile(x,U),this._onDidInstallExtensions.fire(R.map(s=>({local:s,identifier:s.identifier,operation:1,profileLocation:U})))}async setInstalled(x){const U=await this.extensionsScanner.getUninstalledExtensions();for(const R of x){const s=i.ExtensionKey.create(R);U[s.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",s.id),await this.extensionsScanner.setInstalled(s),this.logService.info("Removed the extension from uninstalled list:",s.id))}}};e.ExtensionManagementService=j=ve([te(0,n.IExtensionGalleryService),te(1,fe.ITelemetryService),te(2,le.ILogService),te(3,t.INativeEnvironmentService),te(4,a.IExtensionsScannerService),te(5,r.IExtensionsProfileScannerService),te(6,w.IDownloadService),te(7,ee.IInstantiationService),te(8,X.IFileService),te(9,re.IProductService),te(10,ce.IUriIdentityService),te(11,se.IUserDataProfilesService)],j);let B=e.ExtensionsScanner=class extends h.Disposable{constructor(x,U,R,s,P,_){super(),this.beforeRemovingExtension=x,this.fileService=U,this.extensionsScannerService=R,this.extensionsProfileScannerService=s,this.uriIdentityService=P,this.logService=_,this._onExtract=this._register(new I.Emitter),this.onExtract=this._onExtract.event,this.cleanUpGeneratedFoldersPromise=Promise.resolve(),this.uninstalledResource=(0,v.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new A.Queue}async cleanUp(){await this.removeUninstalledExtensions(),this.cleanUpGeneratedFoldersPromise=this.cleanUpGeneratedFoldersPromise.then(()=>this.removeGeneratedFolders()),await this.cleanUpGeneratedFoldersPromise}async scanExtensions(x,U){const R={includeInvalid:!0,profileLocation:U};let s=[];return x===null||x===0?s.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},R,!1)):x===1&&s.push(...await this.extensionsScannerService.scanUserExtensions(R)),s=x!==null?s.filter(P=>P.type===x):s,Promise.all(s.map(P=>this.toLocalExtension(P)))}async scanAllUserExtensions(x){const U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!x,includeInvalid:!0});return Promise.all(U.map(R=>this.toLocalExtension(R)))}async scanUserExtensionAtLocation(x){try{const U=await this.extensionsScannerService.scanExistingExtension(x,1,{includeInvalid:!0});if(U)return await this.toLocalExtension(U)}catch(U){this.logService.error(U)}return null}async extractUserExtension(x,U,R,s){await this.cleanUpGeneratedFoldersPromise.catch(()=>{});const P=x.toString(),_=y.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,g.generateUuid)()}`),W=y.join(this.extensionsScannerService.userExtensionsLocation.fsPath,P);try{await f.Promises.rm(W)}catch{throw new n.ExtensionManagementError(p.localize(4,null,W,x.id),n.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(x,U,_,s),await this.extensionsScannerService.updateMetadata(u.URI.file(_),R);try{this._onExtract.fire(u.URI.file(W)),await this.rename(x,_,W,Date.now()+2*60*1e3),this.logService.info("Renamed to",W)}catch(K){try{await f.Promises.rm(_)}catch{}if(K.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",x.id);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(K)}. Deleted from extracted location`,_),K}return this.scanLocalExtension(u.URI.file(W),1)}async scanMetadata(x,U){return U?(await this.extensionsProfileScannerService.scanProfileExtensions(U)).find(s=>(0,i.areSameExtensions)(s.identifier,x.identifier))?.metadata:this.extensionsScannerService.scanMetadata(x.location)}async updateMetadata(x,U,R){return R?await this.extensionsProfileScannerService.updateMetadata([[x,U]],R):await this.extensionsScannerService.updateMetadata(x.location,U),this.scanLocalExtension(x.location,x.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...x){const U=x.map(R=>i.ExtensionKey.create(R));await this.withUninstalledExtensions(R=>U.forEach(s=>{R[s.toString()]=!0,this.logService.info("Marked extension as uninstalled",s.toString())}))}async setInstalled(x){await this.withUninstalledExtensions(U=>delete U[x.toString()])}async removeExtension(x,U){this.logService.trace(`Deleting ${U} extension from disk`,x.identifier.id,x.location.fsPath);const R=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(x.location),`._${(0,g.generateUuid)()}`);await this.rename(x.identifier,x.location.fsPath,R.fsPath,Date.now()+2*60*1e3),await this.fileService.del(R,{recursive:!0}),this.logService.info("Deleted from disk",x.identifier.id,x.location.fsPath)}async removeUninstalledExtension(x){await this.removeExtension(x,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[i.ExtensionKey.create(x).toString()])}async copyExtensions(x,U){const R=await this.scanExtensions(1,x),s=await Promise.all(R.filter(P=>!P.isApplicationScoped).map(async P=>[P,await this.scanMetadata(P,x)]));await this.extensionsProfileScannerService.addExtensionsToProfile(s,U)}async withUninstalledExtensions(x){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(s){if((0,X.toFileOperationResult)(s)!==1)throw s}let R={};if(U)try{R=JSON.parse(U)}catch{}return x&&(x(R),Object.keys(R).length?await this.fileService.writeFile(this.uninstalledResource,T.VSBuffer.fromString(JSON.stringify(R))):await this.fileService.del(this.uninstalledResource)),R})}async extractAtLocation(x,U,R,s){this.logService.trace(`Started extracting the extension from ${U} to ${R}`);try{await f.Promises.rm(R)}catch(P){throw new n.ExtensionManagementError(this.joinErrors(P).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(U,R,{sourcePath:"extension",overwrite:!0},s),this.logService.info(`Extracted extension to ${R}:`,x.id)}catch(P){try{await f.Promises.rm(R)}catch{}let _=n.ExtensionManagementErrorCode.Extract;throw P instanceof S.ExtractError&&(P.type==="CorruptZip"?_=n.ExtensionManagementErrorCode.CorruptZip:P.type==="Incomplete"&&(_=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(P.message,_)}}async rename(x,U,R,s){try{await f.Promises.rename(U,R)}catch(P){if(m.isWindows&&P&&P.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${U} to ${R} with 'EPERM' error. Trying again...`,x.id),this.rename(x,U,R,s);throw new n.ExtensionManagementError(P.message||p.localize(5,null,U,R),P.code||n.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(x,U){const R=await this.extensionsScannerService.scanExistingExtension(x,U,{includeInvalid:!0});if(R)return this.toLocalExtension(R);throw new Error(p.localize(6,null,x.path))}async toLocalExtension(x){const U=await this.fileService.resolve(x.location);let R,s;return U.children&&(R=U.children.find(({name:P})=>/^readme(\.txt|\.md|)$/i.test(P))?.resource,s=U.children.find(({name:P})=>/^changelog(\.txt|\.md|)$/i.test(P))?.resource),{identifier:x.identifier,type:x.type,isBuiltin:x.isBuiltin||!!x.metadata?.isBuiltin,location:x.location,manifest:x.manifest,targetPlatform:x.targetPlatform,validations:x.validations,isValid:x.isValid,readmeUrl:R,changelogUrl:s,publisherDisplayName:x.metadata?.publisherDisplayName||null,publisherId:x.metadata?.publisherId||null,isApplicationScoped:!!x.metadata?.isApplicationScoped,isMachineScoped:!!x.metadata?.isMachineScoped,isPreReleaseVersion:!!x.metadata?.isPreReleaseVersion,preRelease:!!x.metadata?.preRelease,installedTimestamp:x.metadata?.installedTimestamp,updated:!!x.metadata?.updated,pinned:!!x.metadata?.pinned}}async removeUninstalledExtensions(){const x=await this.getUninstalledExtensions();if(Object.keys(x).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(x));const U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=new Set;for(const P of U)x[i.ExtensionKey.create(P).toString()]||R.add(P.identifier.id.toLowerCase());try{const P=(0,i.groupByExtension)(U,_=>_.identifier);await A.Promises.settled(P.map(async _=>{const W=_.sort((K,Q)=>L.rcompare(K.manifest.version,Q.manifest.version))[0];R.has(W.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(W))}))}catch(P){this.logService.error(P)}const s=U.filter(P=>P.metadata&&x[i.ExtensionKey.create(P).toString()]);await Promise.allSettled(s.map(P=>this.removeUninstalledExtension(P)))}async removeGeneratedFolders(){this.logService.trace("ExtensionManagementService#removeGeneratedFolders");const x=[];let U;try{U=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(R){(0,X.toFileOperationResult)(R)!==1&&this.logService.error(R)}for(const R of U?.children??[])R.isDirectory&&R.name.startsWith("._")&&(0,g.isUUID)(R.name.substring(2))&&x.push((async()=>{this.logService.trace("Deleting the generated extension folder",R.resource.toString());try{await this.fileService.del(R.resource,{recursive:!0}),this.logService.info("Deleted the generated extension folder",R.resource.toString())}catch(s){this.logService.error(s)}})());await Promise.allSettled(x)}joinErrors(x){const U=Array.isArray(x)?x:[x];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((R,s)=>new Error(`${R.message}${R.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}};e.ExtensionsScanner=B=ve([te(1,X.IFileService),te(2,a.IExtensionsScannerService),te(3,r.IExtensionsProfileScannerService),te(4,ce.IUriIdentityService),te(5,le.ILogService)],B);class V extends o.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,D.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(x,U,R,s,P,_,W,K,Q){super(),this.identifier=x,this.source=U,this.options=R,this.extensionsScanner=s,this.uriIdentityService=P,this.userDataProfilesService=_,this.extensionsScannerService=W,this.extensionsProfileScannerService=K,this.logService=Q,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(x){const[U,R]=await this.install(x);return this._profileLocation=U.isBuiltin||U.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[U,R]],this._profileLocation),U}async extractExtension({zipPath:x,key:U,metadata:R},s){let P=await this.unsetIfUninstalled(U);return P||(this.logService.trace("Extracting extension...",U.id),P=await this.extensionsScanner.extractUserExtension(U,x,R,s),this.logService.info("Extracting extension completed.",U.id)),P}async unsetIfUninstalled(x){return await this.isUninstalled(x)?(this.logService.trace("Removing the extension from uninstalled list:",x.id),await this.extensionsScanner.setInstalled(x),this.logService.info("Removed the extension from uninstalled list:",x.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(s=>i.ExtensionKey.create(s).equals(x))):void 0}async isUninstalled(x){return!!(await this.extensionsScanner.getUninstalledExtensions())[x.toString()]}}class M extends V{constructor(x,U,R,s,P,_,W,K,Q,ae){super(U.identifier,U,R,P,_,W,K,Q,ae),this.gallery=U,this.extensionsDownloader=s}async install(x){const R=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(W=>(0,i.areSameExtensions)(W.identifier,this.gallery.identifier));R&&(this._operation=3);const s={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,isSystem:R?.type===0?!0:void 0,updated:!!R,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,D.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:R?.preRelease)};if(R?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(R,s),s];const{location:P,verificationStatus:_}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=_,this.validateManifest(P.fsPath),[await this.extractExtension({zipPath:P.fsPath,key:i.ExtensionKey.create(this.gallery),metadata:s},x),s]}catch(W){try{await this.extensionsDownloader.delete(P)}catch(K){this.logService.warn("Error while deleting the downloaded file",P.toString(),(0,O.getErrorMessage)(K))}throw W}}async validateManifest(x){try{await(0,E.getManifest)(x)}catch(U){throw new n.ExtensionManagementError((0,o.joinErrors)(U).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=M;class $ extends V{constructor(x,U,R,s,P,_,W,K,Q,ae){super({id:(0,i.getGalleryExtensionId)(x.publisher,x.name)},U,R,P,_,W,K,Q,ae),this.manifest=x,this.location=U,this.galleryService=s}async doRun(x){const U=await super.doRun(x);return this.updateMetadata(U,x),U}async install(x){const U=new i.ExtensionKey(this.identifier,this.manifest.version),s=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(W=>(0,i.areSameExtensions)(this.identifier,W.identifier)),P={isApplicationScoped:this.options.isApplicationScoped||s?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||s?.isMachineScoped,isBuiltin:this.options.isBuiltin||s?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(s)if(this._operation=3,U.equals(new i.ExtensionKey(s.identifier,s.manifest.version)))try{await this.extensionsScanner.removeExtension(s,"existing")}catch{throw new Error(p.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&L.gt(s.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(s);else{const W=await this.unsetIfUninstalled(U);if(W)try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(p.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:y.resolve(this.location.fsPath),key:U,metadata:P},x),P]}async updateMetadata(x,U){try{let[R]=await this.galleryService.getExtensions([{id:x.identifier.id,version:x.manifest.version}],U);if(R||([R]=await this.galleryService.getExtensions([{id:x.identifier.id}],U)),R){const s={id:R.identifier.uuid,publisherDisplayName:R.publisherDisplayName,publisherId:R.publisherId,isPreReleaseVersion:R.properties.isPreReleaseVersion,preRelease:R.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(x,s,this.options.profileLocation)}}catch{}}}class G extends o.AbstractExtensionTask{constructor(x,U,R){super(),this.extension=x,this.profileLocation=U,this.extensionsProfileScannerService=R}async doRun(x){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ie[159],ne([0,1,134,8,14,9,3,24,18,135,6,43,133,172]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let L=e.RequestService=class extends y.AbstractRequestService{constructor(f,S,p,w){super(!!S.isRemoteServer,w),this.configurationService=f,this.environmentService=S,this.logService=p,this.configure(),this._register(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const f=this.configurationService.getValue("http");this.proxyUrl=f?.proxy,this.strictSSL=!!f?.proxyStrictSSL,this.authorization=f?.proxyAuthorization}async request(f,S){const{proxyUrl:p,strictSSL:w}=this;let t;try{t=await(0,c.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,N.getErrorMessage)(i)))}const o={...process.env,...t},n=f.agent?f.agent:await(0,m.getProxyAgent)(f.url||"",o,{proxyUrl:p,strictSSL:w});return f.agent=n,f.strictSSL=w,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(f.isChromiumNetwork?"electron":"node",f,()=>u(f,S))}async resolveProxy(f){}};e.RequestService=L=ve([te(0,I.IConfigurationService),te(1,h.INativeEnvironmentService),te(2,b.ILogService),te(3,b.ILoggerService)],L);async function D(g){return((0,A.parse)(g.url).protocol==="https:"?await new Promise((p,w)=>{q(["https"],p,w)}):await new Promise((p,w)=>{q(["http"],p,w)})).request}async function u(g,f){return T.Promises.withAsyncBody(async(S,p)=>{const w=(0,A.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await D(g),o={hostname:w.hostname,port:w.port?parseInt(w.port):w.protocol==="https:"?443:80,protocol:w.protocol,path:w.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,O.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password);const n=t(o,i=>{const r=(0,O.isNumber)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)u({...g,url:i.headers.location,followRedirects:r-1},f).then(S,p);else{let a=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,v.createGunzip)())),S({res:i,stream:(0,C.streamToBufferReadableStream)(a)})}});n.on("error",p),g.timeout&&n.setTimeout(g.timeout),g.isChromiumNetwork&&n.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&n.write(g.data),n.end(),f.onCancellationRequested(()=>{n.abort(),p(new N.CancellationError)})})}e.nodeRequest=u}),define(ie[173],ne([0,1,36,8,32,9,2,16,15,12,37,11,22,24,130,59,132,18,108,154,20,60,137,40,48,158,152,13,119,121,47,117,63,64,140,6,126,38,127,143,31,43,159,68,69,25,142,39,144,145,27,147,21,155,146,151,123,125,4]),function(q,e,A,T,C,N,O,I,h,c,b,y,m,v,L,D,u,g,f,S,p,w,t,o,n,i,r,a,l,d,E,k,F,Y,X,ee,le,re,fe,ce,se,j,B,V,M,$,G,H,x,U,R,s,P,_,W,K,Q,ae,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends O.Disposable{constructor(oe){super(),this.argv=oe,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[oe,he]=await this.initServices();return oe.invokeFunction(async Ee=>{const De=Ee.get(ee.ILogService),Ne=Ee.get(a.IFileService),Me=Ee.get(g.INativeEnvironmentService),z=Ee.get(P.IUserDataProfilesService);De.info("CLI main",this.argv),this.registerErrorHandler(De),await this.doRun(Me,Ne,z,oe),await Promise.all(he.map(J=>{(0,T.raceTimeout)(J.flush(),1e3)}))})}async initServices(){const oe=new F.ServiceCollection,he={_serviceBrand:void 0,...ce.default};oe.set(se.IProductService,he);const Ee=new f.NativeEnvironmentService(this.argv,he);oe.set(g.INativeEnvironmentService,Ee),await Promise.all([Ee.appSettingsHome.fsPath,Ee.extensionsPath].map(Ie=>Ie?m.Promises.mkdir(Ie,{recursive:!0}):void 0));const De=new ae.LoggerService((0,ee.getLogLevel)(Ee),Ee.logsHome);oe.set(ee.ILoggerService,De);const Ne=this._register(De.createLogger("cli",{name:(0,de.localize)(0,null)})),Me=[];De.getLogLevel()===ee.LogLevel.Trace&&Me.push(new ee.ConsoleLogger(De.getLogLevel()));const z=this._register(new Q.LogService(Ne,Me));oe.set(ee.ILogService,z);const J=this._register(new l.FileService(z));oe.set(a.IFileService,J);const Z=this._register(new d.DiskFileSystemProvider(z));J.registerProvider(I.Schemas.file,Z);const me=new s.UriIdentityService(J);oe.set(R.IUriIdentityService,me);const Se=new V.StateReadonlyService(1,Ee,z,J),ke=new _.UserDataProfilesReadonlyService(Se,me,Ee,J,z);oe.set(P.IUserDataProfilesService,ke);const Pe=c.isWindows&&he.win32RegValueName?this._register(new fe.NativePolicyService(z,he.win32RegValueName)):Ee.policyFile?this._register(new le.FilePolicyService(Ee.policyFile,J,z)):new re.NullPolicyService;oe.set(re.IPolicyService,Pe);const Oe=this._register(new L.ConfigurationService(ke.defaultProfile.settingsResource,J,Pe,z));oe.set(v.IConfigurationService,Oe),await Promise.all([Se.init(),Oe.initialize()]);let Ce;try{Ce=await(0,W.resolveMachineId)(Se,z)}catch(Ie){Ie.code!=="ENOENT"&&z.error(Ie)}ke.init(),oe.set(R.IUriIdentityService,new s.UriIdentityService(J)),oe.set(j.IRequestService,new E.SyncDescriptor(B.RequestService,void 0,!0)),oe.set(D.IDownloadService,new E.SyncDescriptor(u.DownloadService,void 0,!0)),oe.set(o.IExtensionsProfileScannerService,new E.SyncDescriptor(K.ExtensionsProfileScannerService,void 0,!0)),oe.set(n.IExtensionsScannerService,new E.SyncDescriptor(r.ExtensionsScannerService,void 0,!0)),oe.set(w.IExtensionSignatureVerificationService,new E.SyncDescriptor(w.ExtensionSignatureVerificationService,void 0,!0)),oe.set(i.INativeServerExtensionManagementService,new E.SyncDescriptor(i.ExtensionManagementService,void 0,!0)),oe.set(p.IExtensionGalleryService,new E.SyncDescriptor(S.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),oe.set(Y.ILanguagePackService,new E.SyncDescriptor(X.NativeLanguagePackService,void 0,!1));const Le=[],Fe=(0,H.isInternalTelemetry)(he,Oe);if((0,H.supportsTelemetry)(he,Ee)){he.aiConfig&&he.aiConfig.ariaKey&&Le.push(new x.OneDataSystemAppender(Fe,"monacoworkbench",null,he.aiConfig.ariaKey));const Ie={appenders:Le,sendErrorTelemetry:!1,commonProperties:(0,M.resolveCommonProperties)((0,A.release)(),(0,A.hostname)(),process.arch,he.commit,he.version,Ce,Fe),piiPaths:(0,H.getPiiPathsFromEnvironment)(Ee)};oe.set($.ITelemetryService,new E.SyncDescriptor(G.TelemetryService,[Ie],!1))}else oe.set($.ITelemetryService,H.NullTelemetryService);return[new k.InstantiationService(oe),Le]}registerErrorHandler(oe){(0,N.setUnexpectedErrorHandler)(he=>{const Ee=(0,C.toErrorMessage)(he,!0);Ee&&oe.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",he=>{(0,N.isSigPipeError)(he)||(0,N.onUnexpectedError)(he)}),process.on("unhandledRejection",he=>(0,N.onUnexpectedError)(he))}async doRun(oe,he,Ee,De){let Ne;if(oe.args.profile&&(Ne=Ee.profiles.find(z=>z.name===oe.args.profile),!Ne))throw new Error(`Profile '${oe.args.profile}' not found.`);const Me=(Ne??Ee.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return De.createInstance(t.ExtensionManagementCLI,new ee.ConsoleLogger(ee.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,Me);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const z={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:Me};return De.createInstance(t.ExtensionManagementCLI,new ee.ConsoleLogger(ee.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),z,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return De.createInstance(t.ExtensionManagementCLI,new ee.ConsoleLogger(ee.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,Me);if(this.argv["locate-extension"])return De.createInstance(t.ExtensionManagementCLI,new ee.ConsoleLogger(ee.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(oe.appRoot,oe.extensionsPath))}}asExtensionIdOrVSIX(oe){return oe.map(he=>/\.vsix$/i.test(he)?y.URI.file((0,h.isAbsolute)(he)?he:(0,h.join)((0,b.cwd)(),he)):he)}}async function ue(ge){const oe=new pe(ge);try{await oe.run()}finally{oe.dispose()}}e.main=ue})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e06ea6147733c975d26c3d3552462681e05cb147/core/vs/code/node/cliProcessMain.js.map
