/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/types","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/path","vs/platform/environment/common/environment","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/common/hash","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","path","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","util","minimist","assert","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(ie){for(var e=[],T=0,O=ie.length;T<O;T++)e[T]=oe[ie[T]];return e};define(oe[61],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(_){return(k,P,S)=>{let D=null,w=null;if(typeof S.value=="function"?(D="value",w=S.value):typeof S.get=="function"&&(D="get",w=S.get),!w)throw new Error("not supported");S[D]=_(w,P)}}function O(_,k,P){let S=null,D=null;if(typeof P.value=="function"?(S="value",D=P.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(S="get",D=P.get),!D)throw new Error("not supported");const w=`$memoize$${k}`;P[S]=function(...m){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,m)}),this[w]}}e.memoize=O;function l(_,k,P){return T((S,D)=>{const w=`$debounce$${D}`,m=`$debounce$result$${D}`;return function(...f){this[m]||(this[m]=P?P():void 0),clearTimeout(this[w]),k&&(this[m]=k(this[m],...f),f=[this[m]]),this[w]=setTimeout(()=>{S.apply(this,f),this[m]=P?P():void 0},_)}})}e.debounce=l;function A(_,k,P){return T((S,D)=>{const w=`$throttle$timer$${D}`,m=`$throttle$result$${D}`,f=`$throttle$lastRun$${D}`,p=`$throttle$pending$${D}`;return function(...b){if(this[m]||(this[m]=P?P():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),k&&(this[m]=k(this[m],...b)),this[p])return;const a=this[f]+_;a<=Date.now()?(this[f]=Date.now(),S.apply(this,[this[m]]),this[m]=P?P():void 0):(this[p]=!0,this[w]=setTimeout(()=>{this[p]=!1,this[f]=Date.now(),S.apply(this,[this[m]]),this[m]=P?P():void 0},a-Date.now()))}})}e.throttle=A}),define(oe[9],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class T{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?y.isErrorNoTelemetry(s)?new y(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(t=>{t(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=T,e.errorHandler=new T;function O(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=O;function l(n){if(!n||typeof n!="object")return!1;const s=n;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function A(n){S(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=A;function _(n){S(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=_;function k(n){if(n instanceof Error){const{name:s,message:t}=n,i=n.stacktrace||n.stack;return{$isError:!0,name:s,message:t,stack:i,noTelemetry:y.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=k;const P="Canceled";function S(n){return n instanceof D?!0:n instanceof Error&&n.name===P&&n.message===P}e.isCancellationError=S;class D extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=D;function w(){const n=new Error(P);return n.name=n.message,n}e.canceled=w;function m(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=m;function f(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=f;function p(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function b(n){const s=new Error(`${n} has been disposed`);return s.name="DISPOSED",s}e.disposed=b;function a(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=a;class h extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=h;class u extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=u;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class y extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof y)return s;const t=new y;return t.message=s.message,t.stack=s.stack,t}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=y;class L extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype);debugger}}e.BugIndicatingError=L}),define(oe[21],ae([0,1,9]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function O(V,X=0){return V[V.length-(1+X)]}e.tail=O;function l(V){if(V.length===0)throw new Error("Invalid tail call");return[V.slice(0,V.length-1),V[V.length-1]]}e.tail2=l;function A(V,X,ee=(ce,ue)=>ce===ue){if(V===X)return!0;if(!V||!X||V.length!==X.length)return!1;for(let ce=0,ue=V.length;ce<ue;ce++)if(!ee(V[ce],X[ce]))return!1;return!0}e.equals=A;function _(V,X){const ee=V.length-1;X<ee&&(V[X]=V[ee]),V.pop()}e.removeFastWithoutKeepingOrder=_;function k(V,X,ee){return P(V.length,ce=>ee(V[ce],X))}e.binarySearch=k;function P(V,X){let ee=0,ce=V-1;for(;ee<=ce;){const ue=(ee+ce)/2|0,fe=X(ue);if(fe<0)ee=ue+1;else if(fe>0)ce=ue-1;else return ue}return-(ee+1)}e.binarySearch2=P;function S(V,X){let ee=0,ce=V.length;if(ce===0)return 0;for(;ee<ce;){const ue=Math.floor((ee+ce)/2);X(V[ue])?ce=ue:ee=ue+1}return ee}e.findFirstInSorted=S;function D(V,X,ee){if(V=V|0,V>=X.length)throw new TypeError("invalid index");const ce=X[Math.floor(X.length*Math.random())],ue=[],fe=[],ve=[];for(const ye of X){const be=ee(ye,ce);be<0?ue.push(ye):be>0?fe.push(ye):ve.push(ye)}return V<ue.length?D(V,ue,ee):V<ue.length+ve.length?ve[0]:D(V-(ue.length+ve.length),fe,ee)}e.quickSelect=D;function w(V,X){const ee=[];let ce;for(const ue of V.slice(0).sort(X))!ce||X(ce[0],ue)!==0?(ce=[ue],ee.push(ce)):ce.push(ue);return ee}e.groupBy=w;function m(V,X,ee){const ce=[];function ue(ye,be,De){if(be===0&&De.length===0)return;const ke=ce[ce.length-1];ke&&ke.start+ke.deleteCount===ye?(ke.deleteCount+=be,ke.toInsert.push(...De)):ce.push({start:ye,deleteCount:be,toInsert:De})}let fe=0,ve=0;for(;;){if(fe===V.length){ue(fe,0,X.slice(ve));break}if(ve===X.length){ue(fe,V.length-fe,[]);break}const ye=V[fe],be=X[ve],De=ee(ye,be);De===0?(fe+=1,ve+=1):De<0?(ue(fe,1,[]),fe+=1):De>0&&(ue(fe,0,[be]),ve+=1)}return ce}e.sortedDiff=m;function f(V,X,ee){const ce=m(V,X,ee),ue=[],fe=[];for(const ve of ce)ue.push(...V.slice(ve.start,ve.start+ve.deleteCount)),fe.push(...ve.toInsert);return{removed:ue,added:fe}}e.delta=f;function p(V,X,ee){if(ee===0)return[];const ce=V.slice(0,ee).sort(X);return a(V,X,ce,ee,V.length),ce}e.top=p;function b(V,X,ee,ce,ue){return ee===0?Promise.resolve([]):new Promise((fe,ve)=>{(async()=>{const ye=V.length,be=V.slice(0,ee).sort(X);for(let De=ee,ke=Math.min(ee+ce,ye);De<ye;De=ke,ke=Math.min(ke+ce,ye)){if(De>ee&&await new Promise(We=>setTimeout(We)),ue&&ue.isCancellationRequested)throw new T.CancellationError;a(V,X,be,De,ke)}return be})().then(fe,ve)})}e.topAsync=b;function a(V,X,ee,ce,ue){for(const fe=ee.length;ce<ue;ce++){const ve=V[ce];if(X(ve,ee[fe-1])<0){ee.pop();const ye=S(ee,be=>X(ve,be)<0);ee.splice(ye,0,ve)}}}function h(V){return V.filter(X=>!!X)}e.coalesce=h;function u(V){let X=0;for(let ee=0;ee<V.length;ee++)V[ee]&&(V[X]=V[ee],X+=1);V.length=X}e.coalesceInPlace=u;function g(V,X,ee){V.splice(ee,0,V.splice(X,1)[0])}e.move=g;function y(V){return!Array.isArray(V)||V.length===0}e.isFalsyOrEmpty=y;function L(V){return Array.isArray(V)&&V.length>0}e.isNonEmptyArray=L;function n(V,X=ee=>ee){const ee=new Set;return V.filter(ce=>{const ue=X(ce);return ee.has(ue)?!1:(ee.add(ue),!0)})}e.distinct=n;function s(V){const X=new Set;return ee=>{const ce=V(ee);return X.has(ce)?!1:(X.add(ce),!0)}}e.uniqueFilter=s;function t(V,X){const ee=i(V,X);if(ee!==-1)return V[ee]}e.findLast=t;function i(V,X){for(let ee=V.length-1;ee>=0;ee--){const ce=V[ee];if(X(ce))return ee}return-1}e.lastIndex=i;function r(V,X){return V.length>0?V[0]:X}e.firstOrDefault=r;function o(V,X){return V.length>0?V[V.length-1]:X}e.lastOrDefault=o;function c(V,X,ee=(ce,ue)=>ce===ue){let ce=0;for(let ue=0,fe=Math.min(V.length,X.length);ue<fe&&ee(V[ue],X[ue]);ue++)ce++;return ce}e.commonPrefixLength=c;function v(V){return[].concat(...V)}e.flatten=v;function E(V,X){let ee=typeof X=="number"?V:0;typeof X=="number"?ee=V:(ee=0,X=V);const ce=[];if(ee<=X)for(let ue=ee;ue<X;ue++)ce.push(ue);else for(let ue=ee;ue>X;ue--)ce.push(ue);return ce}e.range=E;function d(V,X,ee){return V.reduce((ce,ue)=>(ce[X(ue)]=ee?ee(ue):ue,ce),Object.create(null))}e.index=d;function I(V,X){return V.push(X),()=>R(V,X)}e.insert=I;function R(V,X){const ee=V.indexOf(X);if(ee>-1)return V.splice(ee,1),X}e.remove=R;function N(V,X,ee){const ce=V.slice(0,X),ue=V.slice(X);return ce.concat(ee,ue)}e.arrayInsert=N;function F(V,X){let ee;if(typeof X=="number"){let ce=X;ee=()=>{const ue=Math.sin(ce++)*179426549;return ue-Math.floor(ue)}}else ee=Math.random;for(let ce=V.length-1;ce>0;ce-=1){const ue=Math.floor(ee()*(ce+1)),fe=V[ce];V[ce]=V[ue],V[ue]=fe}}e.shuffle=F;function W(V,X){const ee=V.indexOf(X);ee>-1&&(V.splice(ee,1),V.unshift(X))}e.pushToStart=W;function q(V,X){const ee=V.indexOf(X);ee>-1&&(V.splice(ee,1),V.push(X))}e.pushToEnd=q;function B(V,X){for(const ee of X)V.push(ee)}e.pushMany=B;function Q(V,X){return Array.isArray(V)?V.map(X):X(V)}e.mapArrayOrNot=Q;function Z(V){return Array.isArray(V)?V:[V]}e.asArray=Z;function K(V){return V[Math.floor(Math.random()*V.length)]}e.getRandomElement=K;function x(V,X){for(const ee of V){const ce=X(ee);if(ce!==void 0)return ce}}e.mapFind=x;function $(V,X,ee){const ce=te(V,X),ue=V.length,fe=ee.length;V.length=ue+fe;for(let ve=ue-1;ve>=ce;ve--)V[ve+fe]=V[ve];for(let ve=0;ve<fe;ve++)V[ve+ce]=ee[ve]}e.insertInto=$;function j(V,X,ee,ce){const ue=te(V,X),fe=V.splice(ue,ee);return $(V,ue,ce),fe}e.splice=j;function te(V,X){return X<0?Math.max(X+V.length,0):Math.min(X,V.length)}var ne;(function(V){function X(ue){return ue<0}V.isLessThan=X;function ee(ue){return ue>0}V.isGreaterThan=ee;function ce(ue){return ue===0}V.isNeitherLessOrGreaterThan=ce,V.greaterThan=1,V.lessThan=-1,V.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function se(V,X){return(ee,ce)=>X(V(ee),V(ce))}e.compareBy=se;function J(...V){return(X,ee)=>{for(const ce of V){const ue=ce(X,ee);if(!ne.isNeitherLessOrGreaterThan(ue))return ue}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=J;const G=(V,X)=>V-X;e.numberComparator=G;function M(V,X){if(V.length===0)return;let ee=V[0];for(let ce=1;ce<V.length;ce++){const ue=V[ce];X(ue,ee)>0&&(ee=ue)}return ee}e.findMaxBy=M;function C(V,X){if(V.length===0)return;let ee=V[0];for(let ce=1;ce<V.length;ce++){const ue=V[ce];X(ue,ee)>=0&&(ee=ue)}return ee}e.findLastMaxBy=C;function U(V,X){return M(V,(ee,ce)=>-X(ee,ce))}e.findMinBy=U;class z{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let ee=this.firstIdx;for(;ee<this.items.length&&X(this.items[ee]);)ee++;const ce=ee===this.firstIdx?null:this.items.slice(this.firstIdx,ee);return this.firstIdx=ee,ce}takeFromEndWhile(X){let ee=this.lastIdx;for(;ee>=0&&X(this.items[ee]);)ee--;const ce=ee===this.lastIdx?null:this.items.slice(ee+1,this.lastIdx+1);return this.lastIdx=ee,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}removeLast(){const X=this.items[this.lastIdx];return this.lastIdx--,X}takeCount(X){const ee=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,ee}}e.ArrayQueue=z;class H{constructor(X){this.iterate=X}forEach(X){this.iterate(ee=>(X(ee),!0))}toArray(){const X=[];return this.iterate(ee=>(X.push(ee),!0)),X}filter(X){return new H(ee=>this.iterate(ce=>X(ce)?ee(ce):!0))}map(X){return new H(ee=>this.iterate(ce=>ee(X(ce))))}some(X){let ee=!1;return this.iterate(ce=>(ee=X(ce),!ee)),ee}findFirst(X){let ee;return this.iterate(ce=>X(ce)?(ee=ce,!1):!0),ee}findLast(X){let ee;return this.iterate(ce=>(X(ce)&&(ee=ce),!0)),ee}findLastMaxBy(X){let ee,ce=!0;return this.iterate(ue=>((ce||ne.isGreaterThan(X(ue,ee)))&&(ce=!1,ee=ue),!0)),ee}}e.CallbackIterable=H,H.empty=new H(V=>{})}),define(oe[128],ae([0,1,9]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(P,S){if(!P)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=O;function l(P,S="Unreachable"){throw new Error(S)}e.assertNever=l;function A(P){if(!P)throw new T.BugIndicatingError("Assertion Failed")}e.assert=A;function _(P){if(!P()){debugger;P(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=_;function k(P,S){let D=0;for(;D<P.length-1;){const w=P[D],m=P[D+1];if(!S(w,m))return!1;D++}return!0}e.checkAdjacentItems=k}),define(oe[84],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function T(O){const l=this;let A=!1,_;return function(){return A||(A=!0,_=O.apply(l,arguments)),_}}e.once=T}),define(oe[62],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var T;(function(O){function l(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}O.is=l;const A=Object.freeze([]);function _(){return A}O.empty=_;function*k(y){yield y}O.single=k;function P(y){return l(y)?y:k(y)}O.wrap=P;function S(y){return y||A}O.from=S;function D(y){return!y||y[Symbol.iterator]().next().done===!0}O.isEmpty=D;function w(y){return y[Symbol.iterator]().next().value}O.first=w;function m(y,L){for(const n of y)if(L(n))return!0;return!1}O.some=m;function f(y,L){for(const n of y)if(L(n))return n}O.find=f;function*p(y,L){for(const n of y)L(n)&&(yield n)}O.filter=p;function*b(y,L){let n=0;for(const s of y)yield L(s,n++)}O.map=b;function*a(...y){for(const L of y)for(const n of L)yield n}O.concat=a;function h(y,L,n){let s=n;for(const t of y)s=L(s,t);return s}O.reduce=h;function*u(y,L,n=y.length){for(L<0&&(L+=y.length),n<0?n+=y.length:n>y.length&&(n=y.length);L<n;L++)yield y[L]}O.slice=u;function g(y,L=Number.POSITIVE_INFINITY){const n=[];if(L===0)return[n,y];const s=y[Symbol.iterator]();for(let t=0;t<L;t++){const i=s.next();if(i.done)return[n,O.empty()];n.push(i.value)}return[n,{[Symbol.iterator](){return s}}]}O.consume=g})(T||(e.Iterable=T={}))}),define(oe[35],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(T||(e.ScanError=T={}));var O;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var l;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(l||(e.ParseErrorCode=l={}));var A;(function(n){n.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function _(n,s=!1){let t=0;const i=n.length;let r="",o=0,c=16,v=0;function E(q){let B=0,Q=0;for(;B<q;){const Z=n.charCodeAt(t);if(Z>=48&&Z<=57)Q=Q*16+Z-48;else if(Z>=65&&Z<=70)Q=Q*16+Z-65+10;else if(Z>=97&&Z<=102)Q=Q*16+Z-97+10;else break;t++,B++}return B<q&&(Q=-1),Q}function d(q){t=q,r="",o=0,c=16,v=0}function I(){const q=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&S(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&S(n.charCodeAt(t)))for(t++;t<n.length&&S(n.charCodeAt(t));)t++;else return v=3,n.substring(q,t);let B=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&S(n.charCodeAt(t))){for(t++;t<n.length&&S(n.charCodeAt(t));)t++;B=t}else v=3;return n.substring(q,B)}function R(){let q="",B=t;for(;;){if(t>=i){q+=n.substring(B,t),v=2;break}const Q=n.charCodeAt(t);if(Q===34){q+=n.substring(B,t),t++;break}if(Q===92){if(q+=n.substring(B,t),t++,t>=i){v=2;break}switch(n.charCodeAt(t++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const K=E(4);K>=0?q+=String.fromCharCode(K):v=4;break}default:v=5}B=t;continue}if(Q>=0&&Q<=31)if(P(Q)){q+=n.substring(B,t),v=2;break}else v=6;t++}return q}function N(){if(r="",v=0,o=t,t>=i)return o=i,c=17;let q=n.charCodeAt(t);if(k(q)){do t++,r+=String.fromCharCode(q),q=n.charCodeAt(t);while(k(q));return c=15}if(P(q))return t++,r+=String.fromCharCode(q),q===13&&n.charCodeAt(t)===10&&(t++,r+=`
`),c=14;switch(q){case 123:return t++,c=1;case 125:return t++,c=2;case 91:return t++,c=3;case 93:return t++,c=4;case 58:return t++,c=6;case 44:return t++,c=5;case 34:return t++,r=R(),c=10;case 47:{const B=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!P(n.charCodeAt(t));)t++;return r=n.substring(B,t),c=12}if(n.charCodeAt(t+1)===42){t+=2;const Q=i-1;let Z=!1;for(;t<Q;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,Z=!0;break}t++}return Z||(t++,v=1),r=n.substring(B,t),c=13}return r+=String.fromCharCode(q),t++,c=16}case 45:if(r+=String.fromCharCode(q),t++,t===i||!S(n.charCodeAt(t)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=I(),c=11;default:for(;t<i&&F(q);)t++,q=n.charCodeAt(t);if(o!==t){switch(r=n.substring(o,t),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode(q),t++,c=16}}function F(q){if(k(q)||P(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=N();while(q>=12&&q<=15);return q}return{setPosition:d,getPosition:()=>t,scan:s?W:N,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>v}}e.createScanner=_;function k(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function P(n){return n===10||n===13||n===8232||n===8233}function S(n){return n>=48&&n<=57}var D;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(D||(D={}));function w(n,s){const t=[],i=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function v(E,d,I,R){o.value=E,o.offset=d,o.length=I,o.type=R,o.colonOffset=void 0,r=o}try{g(n,{onObjectBegin:(E,d)=>{if(s<=E)throw i;r=void 0,c=s>E,t.push("")},onObjectProperty:(E,d,I)=>{if(s<d||(v(E,d,I,"property"),t[t.length-1]=E,s<=d+I))throw i},onObjectEnd:(E,d)=>{if(s<=E)throw i;r=void 0,t.pop()},onArrayBegin:(E,d)=>{if(s<=E)throw i;r=void 0,t.push(0)},onArrayEnd:(E,d)=>{if(s<=E)throw i;r=void 0,t.pop()},onLiteralValue:(E,d,I)=>{if(s<d||(v(E,d,I,L(E)),s<=d+I))throw i},onSeparator:(E,d,I)=>{if(s<=d)throw i;if(E===":"&&r&&r.type==="property")r.colonOffset=d,c=!1,r=void 0;else if(E===","){const R=t[t.length-1];typeof R=="number"?t[t.length-1]=R+1:(c=!0,t[t.length-1]=""),r=void 0}}})}catch(E){if(E!==i)throw E}return{path:t,previousNode:r,isAtPropertyKey:c,matches:E=>{let d=0;for(let I=0;d<E.length&&I<t.length;I++)if(E[d]===t[I]||E[d]==="*")d++;else if(E[d]!=="**")return!1;return d===E.length}}}e.getLocation=w;function m(n,s=[],t=A.DEFAULT){let i=null,r=[];const o=[];function c(E){Array.isArray(r)?r.push(E):i!==null&&(r[i]=E)}return g(n,{onObjectBegin:()=>{const E={};c(E),o.push(r),r=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const E=[];c(E),o.push(r),r=E,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:c,onError:(E,d,I)=>{s.push({error:E,offset:d,length:I})}},t),r[0]}e.parse=m;function f(n,s=[],t=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(E){i.type==="property"&&(i.length=E-i.offset,i=i.parent)}function o(E){return i.children.push(E),E}g(n,{onObjectBegin:E=>{i=o({type:"object",offset:E,length:-1,parent:i,children:[]})},onObjectProperty:(E,d,I)=>{i=o({type:"property",offset:d,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:E,offset:d,length:I,parent:i})},onObjectEnd:(E,d)=>{i.length=E+d-i.offset,i=i.parent,r(E+d)},onArrayBegin:(E,d)=>{i=o({type:"array",offset:E,length:-1,parent:i,children:[]})},onArrayEnd:(E,d)=>{i.length=E+d-i.offset,i=i.parent,r(E+d)},onLiteralValue:(E,d,I)=>{o({type:L(E),offset:d,length:I,parent:i,value:E}),r(d+I)},onSeparator:(E,d,I)=>{i.type==="property"&&(E===":"?i.colonOffset=d:E===","&&r(d))},onError:(E,d,I)=>{s.push({error:E,offset:d,length:I})}},t);const v=i.children[0];return v&&delete v.parent,v}e.parseTree=f;function p(n,s){if(!n)return;let t=n;for(const i of s)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let r=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],r=!0;break}if(!r)return}else{const r=i;if(t.type!=="array"||r<0||!Array.isArray(t.children)||r>=t.children.length)return;t=t.children[r]}return t}e.findNodeAtLocation=p;function b(n){if(!n.parent||!n.parent.children)return[];const s=b(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;s.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&s.push(t)}return s}e.getNodePath=b;function a(n){switch(n.type){case"array":return n.children.map(a);case"object":{const s=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(s[t.children[0].value]=a(i))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=a;function h(n,s,t=!1){return s>=n.offset&&s<n.offset+n.length||t&&s===n.offset+n.length}e.contains=h;function u(n,s,t=!1){if(h(n,s,t)){const i=n.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=s;r++){const o=u(i[r],s,t);if(o)return o}return n}}e.findNodeAtOffset=u;function g(n,s,t=A.DEFAULT){const i=_(n,!1);function r(se){return se?()=>se(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(se){return se?J=>se(J,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=r(s.onObjectBegin),v=o(s.onObjectProperty),E=r(s.onObjectEnd),d=r(s.onArrayBegin),I=r(s.onArrayEnd),R=o(s.onLiteralValue),N=o(s.onSeparator),F=r(s.onComment),W=o(s.onError),q=t&&t.disallowComments,B=t&&t.allowTrailingComma;function Q(){for(;;){const se=i.scan();switch(i.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:q||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(se){case 12:case 13:q?Z(10):F();break;case 16:Z(1);break;case 15:case 14:break;default:return se}}}function Z(se,J=[],G=[]){if(W(se),J.length+G.length>0){let M=i.getToken();for(;M!==17;){if(J.indexOf(M)!==-1){Q();break}else if(G.indexOf(M)!==-1)break;M=Q()}}}function K(se){const J=i.getTokenValue();return se?R(J):v(J),Q(),!0}function x(){switch(i.getToken()){case 11:{let se=0;try{se=JSON.parse(i.getTokenValue()),typeof se!="number"&&(Z(2),se=0)}catch{Z(2)}R(se);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return Q(),!0}function $(){return i.getToken()!==10?(Z(3,[],[2,5]),!1):(K(!1),i.getToken()===6?(N(":"),Q(),ne()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function j(){c(),Q();let se=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(se||Z(4,[],[]),N(","),Q(),i.getToken()===2&&B)break}else se&&Z(6,[],[]);$()||Z(4,[],[2,5]),se=!0}return E(),i.getToken()!==2?Z(7,[2],[]):Q(),!0}function te(){d(),Q();let se=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(se||Z(4,[],[]),N(","),Q(),i.getToken()===4&&B)break}else se&&Z(6,[],[]);ne()||Z(4,[],[4,5]),se=!0}return I(),i.getToken()!==4?Z(8,[4],[]):Q(),!0}function ne(){switch(i.getToken()){case 3:return te();case 1:return j();case 10:return K(!0);default:return x()}}return Q(),i.getToken()===17?t.allowEmptyContent?!0:(Z(4,[],[]),!1):ne()?(i.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}e.visit=g;function y(n,s){const t=_(n),i=[];let r,o=0,c;do switch(c=t.getPosition(),r=t.scan(),r){case 12:case 13:case 17:o!==c&&i.push(n.substring(o,c)),s!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,s)),o=t.getPosition();break}while(r!==17);return i.join("")}e.stripComments=y;function L(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=L}),define(oe[42],ae([0,1,35]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function O(S,D,w){let m,f,p,b,a;if(D){for(b=D.offset,a=b+D.length,p=b;p>0&&!P(S,p-1);)p--;let c=a;for(;c<S.length&&!P(S,c);)c++;f=S.substring(p,c),m=_(f,w)}else f=S,m=0,p=0,b=0,a=S.length;const h=k(w,S);let u=!1,g=0,y;w.insertSpaces?y=A(" ",w.tabSize||4):y="	";const L=(0,T.createScanner)(f,!1);let n=!1;function s(){return h+A(y,m+g)}function t(){let c=L.scan();for(u=!1;c===15||c===14;)u=u||c===14,c=L.scan();return n=c===16||L.getTokenError()!==0,c}const i=[];function r(c,v,E){!n&&v<a&&E>b&&S.substring(v,E)!==c&&i.push({offset:v,length:E-v,content:c})}let o=t();if(o!==17){const c=L.getTokenOffset()+p,v=A(y,m);r(v,p,c)}for(;o!==17;){let c=L.getTokenOffset()+L.getTokenLength()+p,v=t(),E="";for(;!u&&(v===12||v===13);){const I=L.getTokenOffset()+p;r(" ",c,I),c=L.getTokenOffset()+L.getTokenLength()+p,E=v===12?s():"",v=t()}if(v===2)o!==1&&(g--,E=s());else if(v===4)o!==3&&(g--,E=s());else{switch(o){case 3:case 1:g++,E=s();break;case 5:case 12:E=s();break;case 13:u?E=s():E=" ";break;case 6:E=" ";break;case 10:if(v===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?E=" ":v!==5&&v!==17&&(n=!0);break;case 16:n=!0;break}u&&(v===12||v===13)&&(E=s())}const d=L.getTokenOffset()+p;r(E,c,d),o=v}return i}e.format=O;function l(S,D){const w=JSON.stringify(S,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?w.replace(/\r\n|\r|\n/g,D.eol):w}e.toFormattedString=l;function A(S,D){let w="";for(let m=0;m<D;m++)w+=S;return w}function _(S,D){let w=0,m=0;const f=D.tabSize||4;for(;w<S.length;){const p=S.charAt(w);if(p===" ")m++;else if(p==="	")m+=f;else break;w++}return Math.floor(m/f)}function k(S,D){for(let w=0;w<D.length;w++){const m=D.charAt(w);if(m==="\r")return w+1<D.length&&D.charAt(w+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=k;function P(S,D){return`\r
`.indexOf(S.charAt(D))!==-1}e.isEOL=P}),define(oe[85],ae([0,1,35,42]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function l(S,D,w){return A(S,D,void 0,w)}e.removeProperty=l;function A(S,D,w,m,f){const p=D.slice(),b=[],a=(0,T.parseTree)(S,b);let h,u;for(;p.length>0&&(u=p.pop(),h=(0,T.findNodeAtLocation)(a,p),h===void 0&&w!==void 0);)typeof u=="string"?w={[u]:w}:w=[w];if(h)if(h.type==="object"&&typeof u=="string"&&Array.isArray(h.children)){const g=(0,T.findNodeAtLocation)(h,[u]);if(g!==void 0)if(w===void 0){if(!g.parent)throw new Error("Malformed AST");const y=h.children.indexOf(g.parent);let L,n=g.parent.offset+g.parent.length;if(y>0){const s=h.children[y-1];L=s.offset+s.length}else L=h.offset+1,h.children.length>1&&(n=h.children[1].offset);return _(S,{offset:L,length:n-L,content:""},m)}else return _(S,{offset:g.offset,length:g.length,content:JSON.stringify(w)},m);else{if(w===void 0)return[];const y=`${JSON.stringify(u)}: ${JSON.stringify(w)}`,L=f?f(h.children.map(s=>s.children[0].value)):h.children.length;let n;if(L>0){const s=h.children[L-1];n={offset:s.offset+s.length,length:0,content:","+y}}else h.children.length===0?n={offset:h.offset+1,length:0,content:y}:n={offset:h.offset+1,length:0,content:y+","};return _(S,n,m)}}else if(h.type==="array"&&typeof u=="number"&&Array.isArray(h.children))if(w!==void 0){const g=`${JSON.stringify(w)}`;let y;if(h.children.length===0||u===0)y={offset:h.offset+1,length:0,content:h.children.length===0?g:g+","};else{const L=u===-1||u>h.children.length?h.children.length:u,n=h.children[L-1];y={offset:n.offset+n.length,length:0,content:","+g}}return _(S,y,m)}else{const g=u,y=h.children[g];let L;if(h.children.length===1)L={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===g){const n=h.children[g-1],s=n.offset+n.length,t=h.offset+h.length;L={offset:s,length:t-2-s,content:""}}else L={offset:y.offset,length:h.children[g+1].offset-y.offset,content:""};return _(S,L,m)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${h.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return _(S,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(w)},m)}}e.setProperty=A;function _(S,D,w){let m=k(S,D),f=D.offset,p=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;f>0&&!(0,O.isEOL)(m,f-1);)f--;for(;p<m.length&&!(0,O.isEOL)(m,p);)p++}const b=(0,O.format)(m,{offset:f,length:p-f},w);for(let h=b.length-1;h>=0;h--){const u=b[h];m=k(m,u),f=Math.min(f,u.offset),p=Math.max(p,u.offset+u.length),p+=u.content.length-u.length}const a=S.length-(m.length-p)-f;return[{offset:f,length:a,content:m.substring(f,p)}]}e.withFormatting=_;function k(S,D){return S.substring(0,D.offset)+D.content+S.substring(D.offset+D.length)}e.applyEdit=k;function P(S,D){const w=D.slice(0).sort((f,p)=>{const b=f.offset-p.offset;return b===0?f.length-p.length:b});let m=S.length;for(let f=w.length-1;f>=0;f--){const p=w[f];if(p.offset+p.length<=m)S=k(S,p);else throw new Error("Overlapping edit");m=p.offset}return S}e.applyEdits=P}),define(oe[129],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class T{constructor(l){this.executor=l,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(l){this._error=l}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=T}),define(oe[2],ae([0,1,84,62]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let A=null;function _(o){A=o}if(e.setDisposableTracker=_,l){const o="__is_disposable_tracked__";_(new class{trackDisposable(c){const v=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[o]||console.log(v)},3e3)}setParent(c,v){if(c&&c!==u.None)try{c[o]=!0}catch{}}markAsDisposed(c){if(c&&c!==u.None)try{c[o]=!0}catch{}}markAsSingleton(c){}})}function k(o){return A?.trackDisposable(o),o}function P(o){A?.markAsDisposed(o)}function S(o,c){A?.setParent(o,c)}function D(o,c){if(A)for(const v of o)A.setParent(v,c)}function w(o){return A?.markAsSingleton(o),o}e.markAsSingleton=w;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=m;function f(o){if(O.Iterable.is(o)){const c=[];for(const v of o)if(v)try{v.dispose()}catch(E){c.push(E)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=f;function p(o){for(const c of o)m(c)&&c.dispose();return[]}e.disposeIfDisposable=p;function b(...o){const c=a(()=>f(o));return D(o,c),c}e.combinedDisposable=b;function a(o){const c=k({dispose:(0,T.once)(()=>{P(c),o()})});return c}e.toDisposable=a;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{f(this._toDispose)}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return S(c,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new h,k(this),S(this._store,this)}dispose(){P(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&S(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,P(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&S(c,null),c}}e.MutableDisposable=g;class y{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=y;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(c){let v=c;return this.unset=()=>v=void 0,this.isset=()=>v!==void 0,this.dispose=()=>{v&&(v(),v=void 0,P(this))},this}}e.SafeDisposable=L;class n{constructor(){this.references=new Map}acquire(c,...v){let E=this.references.get(c);E||(E={counter:0,object:this.createReferencedObject(c,...v)},this.references.set(c,E));const{object:d}=E,I=(0,T.once)(()=>{--E.counter===0&&(this.destroyReferencedObject(c,E.object),this.references.delete(c))});return E.counter++,{object:d,dispose:I}}}e.ReferenceCollection=n;class s{constructor(c){this.referenceCollection=c}async acquire(c,...v){const E=this.referenceCollection.acquire(c,...v);try{return{object:await E.object,dispose:()=>E.dispose()}}catch(d){throw E.dispose(),d}}}e.AsyncReferenceCollection=s;class t{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=t;function i(o){const c=new h;try{o(c)}finally{c.dispose()}}e.disposeOnReturn=i;class r{constructor(){this._store=new Map,this._isDisposed=!1,k(this)}dispose(){P(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{f(this._store.values())}finally{this._store.clear()}}has(c){return this._store.has(c)}get(c){return this._store.get(c)}set(c,v,E=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),E||this._store.get(c)?.dispose(),this._store.set(c,v)}deleteAndDispose(c){this._store.get(c)?.dispose(),this._store.delete(c)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=r}),define(oe[86],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class T{constructor(A){this.element=A,this.next=T.Undefined,this.prev=T.Undefined}}T.Undefined=new T(void 0);class O{constructor(){this._first=T.Undefined,this._last=T.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===T.Undefined}clear(){let A=this._first;for(;A!==T.Undefined;){const _=A.next;A.prev=T.Undefined,A.next=T.Undefined,A=_}this._first=T.Undefined,this._last=T.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,_){const k=new T(A);if(this._first===T.Undefined)this._first=k,this._last=k;else if(_){const S=this._last;this._last=k,k.prev=S,S.next=k}else{const S=this._first;this._first=k,k.next=S,S.prev=k}this._size+=1;let P=!1;return()=>{P||(P=!0,this._remove(k))}}shift(){if(this._first!==T.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==T.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==T.Undefined&&A.next!==T.Undefined){const _=A.prev;_.next=A.next,A.next.prev=_}else A.prev===T.Undefined&&A.next===T.Undefined?(this._first=T.Undefined,this._last=T.Undefined):A.next===T.Undefined?(this._last=this._last.prev,this._last.next=T.Undefined):A.prev===T.Undefined&&(this._first=this._first.next,this._first.prev=T.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==T.Undefined;)yield A.element,A=A.next}}e.LinkedList=O}),define(oe[37],ae([0,1]),function(ie,e){"use strict";var T,O,l;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(b,a,h){let u=b.get(a);return u===void 0&&(u=h,b.set(a,u)),u}e.getOrSet=A;function _(b){const a=[];return b.forEach((h,u)=>{a.push(`${u} => ${h}`)}),`Map(${b.size}) {${a.join(", ")}}`}e.mapToString=_;function k(b){const a=[];return b.forEach(h=>{a.push(h)}),`Set(${b.size}) {${a.join(", ")}}`}e.setToString=k;class P{constructor(a,h){this.uri=a,this.value=h}}class S{constructor(a,h){this[T]="ResourceMap",a instanceof S?(this.map=new Map(a.map),this.toKey=h??S.defaultToKey):(this.map=new Map,this.toKey=a??S.defaultToKey)}set(a,h){return this.map.set(this.toKey(a),new P(a,h)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,h){typeof h<"u"&&(a=a.bind(h));for(const[u,g]of this.map)a(g.value,g.uri,this)}*values(){for(const a of this.map.values())yield a.value}*keys(){for(const a of this.map.values())yield a.uri}*entries(){for(const a of this.map.values())yield[a.uri,a.value]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.map)yield[a.uri,a.value]}}e.ResourceMap=S,S.defaultToKey=b=>b.toString();class D{constructor(a,h){this[O]="ResourceSet",!a||typeof a=="function"?this._map=new S(a):(this._map=new S(h),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,h){this._map.forEach((u,g)=>a.call(h,g,g,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=D;var w;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class m{constructor(){this[l]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,h=0){const u=this._map.get(a);if(u)return h!==0&&this.touch(u,h),u.value}set(a,h,u=0){let g=this._map.get(a);if(g)g.value=h,u!==0&&this.touch(g,u);else{switch(g={key:a,value:h,next:void 0,previous:void 0},u){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(a,g),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const h=this._map.get(a);if(h)return this._map.delete(a),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,h){const u=this._state;let g=this._head;for(;g;){if(h?a.bind(h)(g.value,g.key,this):a(g.value,g.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const a=this,h=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(a._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:u.key,done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return g}values(){const a=this,h=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(a._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:u.value,done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return g}entries(){const a=this,h=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(a._state!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:[u.key,u.value],done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return g}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let h=this._head,u=this.size;for(;h&&u>a;)this._map.delete(h.key),h=h.next,u--;this._head=h,this._size=u,h&&(h.previous=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const h=a.next,u=a.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}a.next=void 0,a.previous=void 0,this._state++}touch(a,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(a===this._head)return;const u=a.next,g=a.previous;a===this._tail?(g.next=void 0,this._tail=g):(u.previous=g,g.next=u),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(h===2){if(a===this._tail)return;const u=a.next,g=a.previous;a===this._head?(u.previous=void 0,this._head=u):(u.previous=g,g.next=u),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((h,u)=>{a.push([u,h])}),a}fromJSON(a){this.clear();for(const[h,u]of a)this.set(h,u)}}e.LinkedMap=m;class f extends m{constructor(a,h=1){super(),this._limit=a,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,h=2){return super.get(a,h)}peek(a){return super.get(a,0)}set(a,h){return super.set(a,h,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class p{constructor(){this.map=new Map}add(a){return this.map.set(a,(this.map.get(a)||0)+1),this}delete(a){let h=this.map.get(a)||0;return h===0?!1:(h--,h===0?this.map.delete(a):this.map.set(a,h),!0)}has(a){return this.map.has(a)}}e.CounterSet=p}),define(oe[87],ae([0,1,37]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const O=new T.LRUCache(1e4);function l(S){return P(S,"NFC",O)}e.normalizeNFC=l;const A=new T.LRUCache(1e4);function _(S){return P(S,"NFD",A)}e.normalizeNFD=_;const k=/[^\u0000-\u0080]/;function P(S,D,w){if(!S)return S;const m=w.get(S);if(m)return m;let f;return k.test(S)?f=S.normalize(D):f=S,w.set(S,f),f}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(D){return _(D).replace(S,"")}}()}),define(oe[130],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function T(k,P,S){return Math.min(Math.max(k,P),S)}e.clamp=T;function O(k,P){return(P+k%P)%P}e.rot=O;class l{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=l;class A{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class _{constructor(P){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(P),this._values.fill(0,0,P)}update(P){const S=this._values[this._index];return this._values[this._index]=P,this._index=(this._index+1)%this._values.length,this._sum-=S,this._sum+=P,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function ie(l){const A=[];typeof l=="number"&&A.push("code/timeOrigin",l);function _(P){A.push(P,Date.now())}function k(){const P=[];for(let S=0;S<A.length;S+=2)P.push({name:A[S],startTime:A[S+1]});return P}return{mark:_,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const _ of performance.getEntriesByType("mark"))A.push({name:_.name,startTime:Math.round(l+_.startTime)});return A}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function T(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=T(O))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var O in T)(typeof exports=="object"?exports:ie)[O]=T[O]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function T(O){if(e[O])return e[O].exports;var l=e[O]={i:O,l:!1,exports:{}};return ie[O].call(l.exports,l,l.exports,T),l.l=!0,l.exports}return T.m=ie,T.c=e,T.d=function(O,l,A){T.o(O,l)||Object.defineProperty(O,l,{enumerable:!0,get:A})},T.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},T.t=function(O,l){if(1&l&&(O=T(O)),8&l||4&l&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(T.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&l&&typeof O!="string")for(var _ in O)T.d(A,_,function(k){return O[k]}.bind(null,_));return A},T.n=function(O){var l=O&&O.__esModule?function(){return O.default}:function(){return O};return T.d(l,"a",l),l},T.o=function(O,l){return Object.prototype.hasOwnProperty.call(O,l)},T.p="",T(T.s=0)}([function(ie,e,T){(function(O){var l;e=ie.exports=G,l=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],P=e.src=[],S=0,D=S++;P[D]="0|[1-9]\\d*";var w=S++;P[w]="[0-9]+";var m=S++;P[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=S++;P[f]="("+P[D]+")\\.("+P[D]+")\\.("+P[D]+")";var p=S++;P[p]="("+P[w]+")\\.("+P[w]+")\\.("+P[w]+")";var b=S++;P[b]="(?:"+P[D]+"|"+P[m]+")";var a=S++;P[a]="(?:"+P[w]+"|"+P[m]+")";var h=S++;P[h]="(?:-("+P[b]+"(?:\\."+P[b]+")*))";var u=S++;P[u]="(?:-?("+P[a]+"(?:\\."+P[a]+")*))";var g=S++;P[g]="[0-9A-Za-z-]+";var y=S++;P[y]="(?:\\+("+P[g]+"(?:\\."+P[g]+")*))";var L=S++,n="v?"+P[f]+P[h]+"?"+P[y]+"?";P[L]="^"+n+"$";var s="[v=\\s]*"+P[p]+P[u]+"?"+P[y]+"?",t=S++;P[t]="^"+s+"$";var i=S++;P[i]="((?:<|>)?=?)";var r=S++;P[r]=P[w]+"|x|X|\\*";var o=S++;P[o]=P[D]+"|x|X|\\*";var c=S++;P[c]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[h]+")?"+P[y]+"?)?)?";var v=S++;P[v]="[v=\\s]*("+P[r]+")(?:\\.("+P[r]+")(?:\\.("+P[r]+")(?:"+P[u]+")?"+P[y]+"?)?)?";var E=S++;P[E]="^"+P[i]+"\\s*"+P[c]+"$";var d=S++;P[d]="^"+P[i]+"\\s*"+P[v]+"$";var I=S++;P[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=S++;P[R]="(?:~>?)";var N=S++;P[N]="(\\s*)"+P[R]+"\\s+",k[N]=new RegExp(P[N],"g");var F=S++;P[F]="^"+P[R]+P[c]+"$";var W=S++;P[W]="^"+P[R]+P[v]+"$";var q=S++;P[q]="(?:\\^)";var B=S++;P[B]="(\\s*)"+P[q]+"\\s+",k[B]=new RegExp(P[B],"g");var Q=S++;P[Q]="^"+P[q]+P[c]+"$";var Z=S++;P[Z]="^"+P[q]+P[v]+"$";var K=S++;P[K]="^"+P[i]+"\\s*("+s+")$|^$";var x=S++;P[x]="^"+P[i]+"\\s*("+n+")$|^$";var $=S++;P[$]="(\\s*)"+P[i]+"\\s*("+s+"|"+P[c]+")",k[$]=new RegExp(P[$],"g");var j=S++;P[j]="^\\s*("+P[c]+")\\s+-\\s+("+P[c]+")\\s*$";var te=S++;P[te]="^\\s*("+P[v]+")\\s+-\\s+("+P[v]+")\\s*$";var ne=S++;P[ne]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)l(se,P[se]),k[se]||(k[se]=new RegExp(P[se]));function J(le,de){if(le instanceof G)return le;if(typeof le!="string"||le.length>A||!(de?k[t]:k[L]).test(le))return null;try{return new G(le,de)}catch{return null}}function G(le,de){if(le instanceof G){if(le.loose===de)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof G))return new G(le,de);l("SemVer",le,de),this.loose=de;var ge=le.trim().match(de?k[t]:k[L]);if(!ge)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Ie=+Pe;if(Ie>=0&&Ie<_)return Ie}return Pe}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=J,e.valid=function(le,de){var ge=J(le,de);return ge?ge.version:null},e.clean=function(le,de){var ge=J(le.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(le){return l("SemVer.compare",this.version,this.loose,le),le instanceof G||(le=new G(le,this.loose)),this.compareMain(le)||this.comparePre(le)},G.prototype.compareMain=function(le){return le instanceof G||(le=new G(le,this.loose)),C(this.major,le.major)||C(this.minor,le.minor)||C(this.patch,le.patch)},G.prototype.comparePre=function(le){if(le instanceof G||(le=new G(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Pe=le.prerelease[de];if(l("prerelease compare",de,ge,Pe),ge===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(ge===void 0)return-1;if(ge!==Pe)return C(ge,Pe)}while(++de)},G.prototype.inc=function(le,de){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,de,ge,Pe){typeof ge=="string"&&(Pe=ge,ge=void 0);try{return new G(le,ge).inc(de,Pe).version}catch{return null}},e.diff=function(le,de){if(V(le,de))return null;var ge=J(le),Pe=J(de);if(ge.prerelease.length||Pe.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==Pe[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==Pe[Ie])return Ie},e.compareIdentifiers=C;var M=/^[0-9]+$/;function C(le,de){var ge=M.test(le),Pe=M.test(de);return ge&&Pe&&(le=+le,de=+de),ge&&!Pe?-1:Pe&&!ge?1:le<de?-1:le>de?1:0}function U(le,de,ge){return new G(le,ge).compare(new G(de,ge))}function z(le,de,ge){return U(le,de,ge)>0}function H(le,de,ge){return U(le,de,ge)<0}function V(le,de,ge){return U(le,de,ge)===0}function X(le,de,ge){return U(le,de,ge)!==0}function ee(le,de,ge){return U(le,de,ge)>=0}function ce(le,de,ge){return U(le,de,ge)<=0}function ue(le,de,ge,Pe){var Ie;switch(de){case"===":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Ie=le===ge;break;case"!==":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Ie=le!==ge;break;case"":case"=":case"==":Ie=V(le,ge,Pe);break;case"!=":Ie=X(le,ge,Pe);break;case">":Ie=z(le,ge,Pe);break;case">=":Ie=ee(le,ge,Pe);break;case"<":Ie=H(le,ge,Pe);break;case"<=":Ie=ce(le,ge,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return Ie}function fe(le,de){if(le instanceof fe){if(le.loose===de)return le;le=le.value}if(!(this instanceof fe))return new fe(le,de);l("comparator",le,de),this.loose=de,this.parse(le),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(le,de){return C(de,le)},e.major=function(le,de){return new G(le,de).major},e.minor=function(le,de){return new G(le,de).minor},e.patch=function(le,de){return new G(le,de).patch},e.compare=U,e.compareLoose=function(le,de){return U(le,de,!0)},e.rcompare=function(le,de,ge){return U(de,le,ge)},e.sort=function(le,de){return le.sort(function(ge,Pe){return e.compare(ge,Pe,de)})},e.rsort=function(le,de){return le.sort(function(ge,Pe){return e.rcompare(ge,Pe,de)})},e.gt=z,e.lt=H,e.eq=V,e.neq=X,e.gte=ee,e.lte=ce,e.cmp=ue,e.Comparator=fe;var ve={};function ye(le,de){if(le instanceof ye)return le.loose===de?le:new ye(le.raw,de);if(le instanceof fe)return new ye(le.value,de);if(!(this instanceof ye))return new ye(le,de);if(this.loose=de,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function be(le){return!le||le.toLowerCase()==="x"||le==="*"}function De(le,de,ge,Pe,Ie,Me,Le,$e,Oe,Fe,Ne,_e,re){return((de=be(ge)?"":be(Pe)?">="+ge+".0.0":be(Ie)?">="+ge+"."+Pe+".0":">="+de)+" "+($e=be(Oe)?"":be(Fe)?"<"+(+Oe+1)+".0.0":be(Ne)?"<"+Oe+"."+(+Fe+1)+".0":_e?"<="+Oe+"."+Fe+"."+Ne+"-"+_e:"<="+$e)).trim()}function ke(le,de){for(var ge=0;ge<le.length;ge++)if(!le[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<le.length;ge++)if(l(le[ge].semver),le[ge].semver!==ve&&le[ge].semver.prerelease.length>0){var Pe=le[ge].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function We(le,de,ge){try{de=new ye(de,ge)}catch{return!1}return de.test(le)}function Ke(le,de,ge,Pe){var Ie,Me,Le,$e,Oe;switch(le=new G(le,Pe),de=new ye(de,Pe),ge){case">":Ie=z,Me=ce,Le=H,$e=">",Oe=">=";break;case"<":Ie=H,Me=ee,Le=z,$e="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(le,de,Pe))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var Ne=de.set[Fe],_e=null,re=null;if(Ne.forEach(function(he){he.semver===ve&&(he=new fe(">=0.0.0")),_e=_e||he,re=re||he,Ie(he.semver,_e.semver,Pe)?_e=he:Le(he.semver,re.semver,Pe)&&(re=he)}),_e.operator===$e||_e.operator===Oe||(!re.operator||re.operator===$e)&&Me(le,re.semver)||re.operator===Oe&&Le(le,re.semver))return!1}return!0}fe.prototype.parse=function(le){var de=this.loose?k[K]:k[x],ge=le.match(de);if(!ge)throw new TypeError("Invalid comparator: "+le);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new G(ge[2],this.loose):this.semver=ve},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(le){return l("Comparator.test",le,this.loose),this.semver===ve||(typeof le=="string"&&(le=new G(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(le,de){if(!(le instanceof fe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new ye(le.value,de),We(this.value,ge,de);if(le.operator==="")return ge=new ye(this.value,de),We(le.semver,ge,de);var Pe=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Me=this.semver.version===le.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),$e=ue(this.semver,"<",le.semver,de)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Oe=ue(this.semver,">",le.semver,de)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Pe||Ie||Me&&Le||$e||Oe},e.Range=ye,ye.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},ye.prototype.toString=function(){return this.range},ye.prototype.parseRange=function(le){var de=this.loose;le=le.trim(),l("range",le,de);var ge=de?k[te]:k[j];le=le.replace(ge,De),l("hyphen replace",le),le=le.replace(k[$],"$1$2$3"),l("comparator trim",le,k[$]),le=(le=(le=le.replace(k[N],"$1~")).replace(k[B],"$1^")).split(/\s+/).join(" ");var Pe=de?k[K]:k[x],Ie=le.split(" ").map(function(Me){return function(Le,$e){return l("comp",Le),Le=function(Oe,Fe){return Oe.trim().split(/\s+/).map(function(Ne){return function(_e,re){l("caret",_e,re);var he=re?k[Z]:k[Q];return _e.replace(he,function(me,pe,we,Ce,Re){var Ae;return l("caret",_e,me,pe,we,Ce,Re),be(pe)?Ae="":be(we)?Ae=">="+pe+".0.0 <"+(+pe+1)+".0.0":be(Ce)?Ae=pe==="0"?">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+".0 <"+(+pe+1)+".0.0":Re?(l("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ae=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ce+Re+" <"+pe+"."+we+"."+(+Ce+1):">="+pe+"."+we+"."+Ce+Re+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ce+Re+" <"+(+pe+1)+".0.0"):(l("no pr"),Ae=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ce+" <"+pe+"."+we+"."+(+Ce+1):">="+pe+"."+we+"."+Ce+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ce+" <"+(+pe+1)+".0.0"),l("caret return",Ae),Ae})}(Ne,Fe)}).join(" ")}(Le,$e),l("caret",Le),Le=function(Oe,Fe){return Oe.trim().split(/\s+/).map(function(Ne){return function(_e,re){var he=re?k[W]:k[F];return _e.replace(he,function(me,pe,we,Ce,Re){var Ae;return l("tilde",_e,me,pe,we,Ce,Re),be(pe)?Ae="":be(we)?Ae=">="+pe+".0.0 <"+(+pe+1)+".0.0":be(Ce)?Ae=">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":Re?(l("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ae=">="+pe+"."+we+"."+Ce+Re+" <"+pe+"."+(+we+1)+".0"):Ae=">="+pe+"."+we+"."+Ce+" <"+pe+"."+(+we+1)+".0",l("tilde return",Ae),Ae})}(Ne,Fe)}).join(" ")}(Le,$e),l("tildes",Le),Le=function(Oe,Fe){return l("replaceXRanges",Oe,Fe),Oe.split(/\s+/).map(function(Ne){return function(_e,re){_e=_e.trim();var he=re?k[d]:k[E];return _e.replace(he,function(me,pe,we,Ce,Re,Ae){l("xRange",_e,me,pe,we,Ce,Re,Ae);var ze=be(we),Te=ze||be(Ce),xe=Te||be(Re);return pe==="="&&xe&&(pe=""),ze?me=pe===">"||pe==="<"?"<0.0.0":"*":pe&&xe?(Te&&(Ce=0),xe&&(Re=0),pe===">"?(pe=">=",Te?(we=+we+1,Ce=0,Re=0):xe&&(Ce=+Ce+1,Re=0)):pe==="<="&&(pe="<",Te?we=+we+1:Ce=+Ce+1),me=pe+we+"."+Ce+"."+Re):Te?me=">="+we+".0.0 <"+(+we+1)+".0.0":xe&&(me=">="+we+"."+Ce+".0 <"+we+"."+(+Ce+1)+".0"),l("xRange return",me),me})}(Ne,Fe)}).join(" ")}(Le,$e),l("xrange",Le),Le=function(Oe,Fe){return l("replaceStars",Oe,Fe),Oe.trim().replace(k[ne],"")}(Le,$e),l("stars",Le),Le}(Me,de)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(Pe)})),Ie=Ie.map(function(Me){return new fe(Me,de)})},ye.prototype.intersects=function(le,de){if(!(le instanceof ye))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Pe){return le.set.some(function(Ie){return Ie.every(function(Me){return Pe.intersects(Me,de)})})})})},e.toComparators=function(le,de){return new ye(le,de).set.map(function(ge){return ge.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},ye.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new G(le,this.loose));for(var de=0;de<this.set.length;de++)if(ke(this.set[de],le))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(le,de,ge){var Pe=null,Ie=null;try{var Me=new ye(de,ge)}catch{return null}return le.forEach(function(Le){Me.test(Le)&&(Pe&&Ie.compare(Le)!==-1||(Ie=new G(Pe=Le,ge)))}),Pe},e.minSatisfying=function(le,de,ge){var Pe=null,Ie=null;try{var Me=new ye(de,ge)}catch{return null}return le.forEach(function(Le){Me.test(Le)&&(Pe&&Ie.compare(Le)!==1||(Ie=new G(Pe=Le,ge)))}),Pe},e.validRange=function(le,de){try{return new ye(le,de).range||"*"}catch{return null}},e.ltr=function(le,de,ge){return Ke(le,de,"<",ge)},e.gtr=function(le,de,ge){return Ke(le,de,">",ge)},e.outside=Ke,e.prerelease=function(le,de){var ge=J(le,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(le,de,ge){return le=new ye(le,ge),de=new ye(de,ge),le.intersects(de)},e.coerce=function(le){if(le instanceof G)return le;if(typeof le!="string")return null;var de=le.match(k[I]);return de==null?null:J((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,T(1))},function(ie,e){var T,O,l=ie.exports={};function A(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function k(a){if(T===setTimeout)return setTimeout(a,0);if((T===A||!T)&&setTimeout)return T=setTimeout,setTimeout(a,0);try{return T(a,0)}catch{try{return T.call(null,a,0)}catch{return T.call(this,a,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:A}catch{T=A}try{O=typeof clearTimeout=="function"?clearTimeout:_}catch{O=_}})();var P,S=[],D=!1,w=-1;function m(){D&&P&&(D=!1,P.length?S=P.concat(S):w=-1,S.length&&f())}function f(){if(!D){var a=k(m);D=!0;for(var h=S.length;h;){for(P=S,S=[];++w<h;)P&&P[w].run();w=-1,h=S.length}P=null,D=!1,function(u){if(O===clearTimeout)return clearTimeout(u);if((O===_||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(u);try{O(u)}catch{try{return O.call(null,u)}catch{return O.call(this,u)}}}(a)}}function p(a,h){this.fun=a,this.array=h}function b(){}l.nextTick=function(a){var h=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)h[u-1]=arguments[u];S.push(new p(a,h)),S.length!==1||D||k(f)},p.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=b,l.addListener=b,l.once=b,l.off=b,l.removeListener=b,l.removeAllListeners=b,l.emit=b,l.prependListener=b,l.prependOnceListener=b,l.listeners=function(a){return[]},l.binding=function(a){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(a){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(oe[131],ae([0,1]),function(ie,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(k,P,S){this.level=k,this.key=P,this.value=S,this.forward=[]}}const l=void 0;class A{constructor(k,P=2**16){this.comparator=k,this[T]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(P)|0),this._header=new O(this._maxLevel,l,l)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,l,l)}has(k){return!!A._search(this,k,this.comparator)}get(k){return A._search(this,k,this.comparator)?.value}set(k,P){return A._insert(this,k,P,this.comparator)&&(this._size+=1),this}delete(k){const P=A._delete(this,k,this.comparator);return P&&(this._size-=1),P}forEach(k,P){let S=this._header.forward[0];for(;S;)k.call(P,S.value,S.key,this),S=S.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this._header.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this._header.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this._header.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",P=this._header.forward[0];for(;P;)k+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return k}static _search(k,P,S){let D=k._header;for(let w=k._level-1;w>=0;w--)for(;D.forward[w]&&S(D.forward[w].key,P)<0;)D=D.forward[w];if(D=D.forward[0],D&&S(D.key,P)===0)return D}static _insert(k,P,S,D){const w=[];let m=k._header;for(let f=k._level-1;f>=0;f--){for(;m.forward[f]&&D(m.forward[f].key,P)<0;)m=m.forward[f];w[f]=m}if(m=m.forward[0],m&&D(m.key,P)===0)return m.value=S,!1;{const f=A._randomLevel(k);if(f>k._level){for(let p=k._level;p<f;p++)w[p]=k._header;k._level=f}m=new O(f,P,S);for(let p=0;p<f;p++)m.forward[p]=w[p].forward[p],w[p].forward[p]=m;return!0}}static _randomLevel(k,P=.5){let S=1;for(;Math.random()<P&&S<k._maxLevel;)S+=1;return S}static _delete(k,P,S){const D=[];let w=k._header;for(let m=k._level-1;m>=0;m--){for(;w.forward[m]&&S(w.forward[m].key,P)<0;)w=w.forward[m];D[m]=w}if(w=w.forward[0],!w||S(w.key,P)!==0)return!1;for(let m=0;m<k._level&&D[m].forward[m]===w;m++)D[m].forward[m]=w.forward[m];for(;k._level>0&&k._header.forward[k._level-1]===l;)k._level-=1;return!0}}e.SkipList=A}),define(oe[43],ae([0,1,9,2]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(y){const L=y;return L?typeof L.read=="function":!1}e.isReadable=l;function A(y){const L=y;return L?[L.on,L.pause,L.resume,L.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=A;function _(y){const L=y;return L?A(L.stream)&&Array.isArray(L.buffer)&&typeof L.ended=="boolean":!1}e.isReadableBufferedStream=_;function k(y,L){return new P(y,L)}e.newWriteableStream=k;class P{constructor(L,n){this.reducer=L,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(L){if(!this.state.destroyed){if(this.state.flowing)this.emitData(L);else if(this.buffer.data.push(L),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(L){this.state.destroyed||(this.state.flowing?this.emitError(L):this.buffer.error.push(L))}end(L){this.state.destroyed||(typeof L<"u"&&this.write(L),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(L){this.listeners.data.slice(0).forEach(n=>n(L))}emitError(L){this.listeners.error.length===0?(0,T.onUnexpectedError)(L):this.listeners.error.slice(0).forEach(n=>n(L))}emitEnd(){this.listeners.end.slice(0).forEach(L=>L())}on(L,n){if(!this.state.destroyed)switch(L){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(L,n){if(this.state.destroyed)return;let s;switch(L){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const t=s.indexOf(n);t>=0&&s.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const L=this.reducer(this.buffer.data);this.emitData(L),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const L of this.buffer.error)this.emitError(L);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(y,L){const n=[];let s;for(;(s=y.read())!==null;)n.push(s);return L(n)}e.consumeReadable=S;function D(y,L,n){const s=[];let t;for(;(t=y.read())!==null&&s.length<n;)s.push(t);return t===null&&s.length>0?L(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return y.read()}}}e.peekReadable=D;function w(y,L){return new Promise((n,s)=>{const t=[];m(y,{onData:i=>{L&&t.push(i)},onError:i=>{L?s(i):n(void 0)},onEnd:()=>{n(L?L(t):void 0)}})})}e.consumeStream=w;function m(y,L){let n=!1;return y.on("error",s=>{n||L.onError(s)}),y.on("end",()=>{n||L.onEnd()}),y.on("data",s=>{n||L.onData(s)}),(0,O.toDisposable)(()=>n=!0)}e.listenStream=m;function f(y,L){return new Promise((n,s)=>{const t=new O.DisposableStore,i=[],r=v=>{if(i.push(v),i.length>L)return t.dispose(),y.pause(),n({stream:y,buffer:i,ended:!1})},o=v=>s(v),c=()=>n({stream:y,buffer:i,ended:!0});t.add((0,O.toDisposable)(()=>y.removeListener("error",o))),y.on("error",o),t.add((0,O.toDisposable)(()=>y.removeListener("end",c))),y.on("end",c),t.add((0,O.toDisposable)(()=>y.removeListener("data",r))),y.on("data",r)})}e.peekStream=f;function p(y,L){const n=k(L);return n.end(y),n}e.toStream=p;function b(){const y=k(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=b;function a(y){let L=!1;return{read:()=>L?null:(L=!0,y)}}e.toReadable=a;function h(y,L,n){const s=k(n);return m(y,{onData:t=>s.write(L.data(t)),onError:t=>s.error(L.error?L.error(t):t),onEnd:()=>s.end()}),s}e.transform=h;function u(y,L,n){let s=!1;return{read:()=>{const t=L.read();return s?t:(s=!0,t!==null?n([y,t]):y)}}}e.prefixedReadable=u;function g(y,L,n){let s=!1;const t=k(n);return m(L,{onData:i=>s?t.write(i):(s=!0,t.write(n([y,i]))),onError:i=>t.error(i),onEnd:()=>{s||(s=!0,t.write(y)),t.end()}}),t}e.prefixedStream=g}),define(oe[16],ae([0,1,43]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer<"u";let l,A;class _{static alloc(v){return O?new _(Buffer.allocUnsafe(v)):new _(new Uint8Array(v))}static wrap(v){return O&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new _(v)}static fromString(v,E){return!(E?.dontUseNodeBuffer||!1)&&O?new _(Buffer.from(v)):(l||(l=new TextEncoder),new _(l.encode(v)))}static fromByteArray(v){const E=_.alloc(v.length);for(let d=0,I=v.length;d<I;d++)E.buffer[d]=v[d];return E}static concat(v,E){if(typeof E>"u"){E=0;for(let R=0,N=v.length;R<N;R++)E+=v[R].byteLength}const d=_.alloc(E);let I=0;for(let R=0,N=v.length;R<N;R++){const F=v[R];d.set(F,I),I+=F.byteLength}return d}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=_.alloc(this.byteLength);return v.set(this),v}toString(){return O?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(v,E){return new _(this.buffer.subarray(v,E))}set(v,E){if(v instanceof _)this.buffer.set(v.buffer,E);else if(v instanceof Uint8Array)this.buffer.set(v,E);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),E);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return S(this.buffer,v)}writeUInt32BE(v,E){D(this.buffer,v,E)}readUInt32LE(v){return w(this.buffer,v)}writeUInt32LE(v,E){m(this.buffer,v,E)}readUInt8(v){return f(this.buffer,v)}writeUInt8(v,E){p(this.buffer,v,E)}}e.VSBuffer=_;function k(c,v){return c[v+0]<<0>>>0|c[v+1]<<8>>>0}e.readUInt16LE=k;function P(c,v,E){c[E+0]=v&255,v=v>>>8,c[E+1]=v&255}e.writeUInt16LE=P;function S(c,v){return c[v]*2**24+c[v+1]*2**16+c[v+2]*2**8+c[v+3]}e.readUInt32BE=S;function D(c,v,E){c[E+3]=v,v=v>>>8,c[E+2]=v,v=v>>>8,c[E+1]=v,v=v>>>8,c[E]=v}e.writeUInt32BE=D;function w(c,v){return c[v+0]<<0>>>0|c[v+1]<<8>>>0|c[v+2]<<16>>>0|c[v+3]<<24>>>0}e.readUInt32LE=w;function m(c,v,E){c[E+0]=v&255,v=v>>>8,c[E+1]=v&255,v=v>>>8,c[E+2]=v&255,v=v>>>8,c[E+3]=v&255}e.writeUInt32LE=m;function f(c,v){return c[v]}e.readUInt8=f;function p(c,v,E){c[E]=v}e.writeUInt8=p;function b(c){return T.consumeReadable(c,v=>_.concat(v))}e.readableToBuffer=b;function a(c){return T.toReadable(c)}e.bufferToReadable=a;function h(c){return T.consumeStream(c,v=>_.concat(v))}e.streamToBuffer=h;async function u(c){return c.ended?_.concat(c.buffer):_.concat([...c.buffer,await h(c.stream)])}e.bufferedStreamToBuffer=u;function g(c){return T.toStream(c,v=>_.concat(v))}e.bufferToStream=g;function y(c){return T.transform(c,{data:v=>typeof v=="string"?_.fromString(v):_.wrap(v)},v=>_.concat(v))}e.streamToBufferReadableStream=y;function L(c){return T.newWriteableStream(v=>_.concat(v),c)}e.newWriteableBufferStream=L;function n(c,v){return T.prefixedReadable(c,v,E=>_.concat(E))}e.prefixedBufferReadable=n;function s(c,v){return T.prefixedStream(c,v,E=>_.concat(E))}e.prefixedBufferStream=s;function t(c){let v=0,E=0,d=0;const I=new Uint8Array(Math.floor(c.length/4*3)),R=F=>{switch(E){case 3:I[d++]=v|F,E=0;break;case 2:I[d++]=v|F>>>2,v=F<<6,E=3;break;case 1:I[d++]=v|F>>>4,v=F<<4,E=2;break;default:v=F<<2,E=1}};for(let F=0;F<c.length;F++){const W=c.charCodeAt(F);if(W>=65&&W<=90)R(W-65);else if(W>=97&&W<=122)R(W-97+26);else if(W>=48&&W<=57)R(W-48+52);else if(W===43||W===45)R(62);else if(W===47||W===95)R(63);else{if(W===61)break;throw new SyntaxError(`Unexpected base64 character ${c[F]}`)}}const N=d;for(;E>0;)R(0);return _.wrap(I).slice(0,N)}e.decodeBase64=t;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:c},v=!0,E=!1){const d=E?r:i;let I="";const R=c.byteLength%3;let N=0;for(;N<c.byteLength-R;N+=3){const F=c[N+0],W=c[N+1],q=c[N+2];I+=d[F>>>2],I+=d[(F<<4|W>>>4)&63],I+=d[(W<<2|q>>>6)&63],I+=d[q&63]}if(R===1){const F=c[N+0];I+=d[F>>>2],I+=d[F<<4&63],v&&(I+="==")}else if(R===2){const F=c[N+0],W=c[N+1];I+=d[F>>>2],I+=d[(F<<4|W>>>4)&63],I+=d[W<<2&63],v&&(I+="=")}return I}e.encodeBase64=o}),define(oe[132],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(oe[11],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function T(s){return typeof s=="string"}e.isString=T;function O(s){return Array.isArray(s)&&s.every(t=>T(t))}e.isStringArray=O;function l(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=l;function A(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}e.isTypedArray=A;function _(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=_;function k(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=k;function P(s){return s===!0||s===!1}e.isBoolean=P;function S(s){return typeof s>"u"}e.isUndefined=S;function D(s){return!w(s)}e.isDefined=D;function w(s){return S(s)||s===null}e.isUndefinedOrNull=w;function m(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=m;function f(s){if(w(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=f;function p(...s){const t=[];for(let i=0;i<s.length;i++){const r=s[i];if(w(r))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(r)}return t}e.assertAllDefined=p;const b=Object.prototype.hasOwnProperty;function a(s){if(!l(s))return!1;for(const t in s)if(b.call(s,t))return!1;return!0}e.isEmptyObject=a;function h(s){return typeof s=="function"}e.isFunction=h;function u(...s){return s.length>0&&s.every(h)}e.areFunctions=u;function g(s,t){const i=Math.min(s.length,t.length);for(let r=0;r<i;r++)y(s[r],t[r])}e.validateConstraints=g;function y(s,t){if(T(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(s instanceof t)return}catch{}if(!w(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=y;function L(s){return s===null?void 0:s}e.withNullAsUndefined=L;function n(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=n}),define(oe[52],ae([0,1,11]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const O=Object.create(null);function l(k,P){if((0,T.isString)(P)){const S=O[P];if(S===void 0)throw new Error(`${k} references an unknown codicon: ${P}`);P=S}return O[k]=P,{id:k}}function A(){return O}e.getCodiconFontCharacters=A;function _(){return Object.values(e.Codicon)}e.getAllCodicons=_,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),send:l("send",60431),sparkle:l("sparkle",60432),insert:l("insert",60433),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(oe[31],ae([0,1,11]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const u=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([g,y])=>{u[g]=y&&typeof y=="object"?O(y):y}),u}e.deepClone=O;function l(h){if(!h||typeof h!="object")return h;const u=[h];for(;u.length>0;){const g=u.shift();Object.freeze(g);for(const y in g)if(A.call(g,y)){const L=g[y];typeof L=="object"&&!Object.isFrozen(L)&&!(0,T.isTypedArray)(L)&&u.push(L)}}return h}e.deepFreeze=l;const A=Object.prototype.hasOwnProperty;function _(h,u){return k(h,u,new Set)}e.cloneAndChange=_;function k(h,u,g){if((0,T.isUndefinedOrNull)(h))return h;const y=u(h);if(typeof y<"u")return y;if(Array.isArray(h)){const L=[];for(const n of h)L.push(k(n,u,g));return L}if((0,T.isObject)(h)){if(g.has(h))throw new Error("Cannot clone recursive data-structure");g.add(h);const L={};for(const n in h)A.call(h,n)&&(L[n]=k(h[n],u,g));return g.delete(h),L}return h}function P(h,u,g=!0){return(0,T.isObject)(h)?((0,T.isObject)(u)&&Object.keys(u).forEach(y=>{y in h?g&&((0,T.isObject)(h[y])&&(0,T.isObject)(u[y])?P(h[y],u[y],g):h[y]=u[y]):h[y]=u[y]}),h):u}e.mixin=P;function S(h,u){if(h===u)return!0;if(h==null||u===null||u===void 0||typeof h!=typeof u||typeof h!="object"||Array.isArray(h)!==Array.isArray(u))return!1;let g,y;if(Array.isArray(h)){if(h.length!==u.length)return!1;for(g=0;g<h.length;g++)if(!S(h[g],u[g]))return!1}else{const L=[];for(y in h)L.push(y);L.sort();const n=[];for(y in u)n.push(y);if(n.sort(),!S(L,n))return!1;for(g=0;g<L.length;g++)if(!S(h[L[g]],u[L[g]]))return!1}return!0}e.equals=S;function D(h){const u=new Set;return JSON.stringify(h,(g,y)=>{if((0,T.isObject)(y)||Array.isArray(y)){if(u.has(y))return"[Circular]";u.add(y)}return y})}e.safeStringify=D;function w(h,u){const g=Object.create(null);return!h||!u||Object.keys(u).forEach(L=>{const n=h[L],s=u[L];S(n,s)||(g[L]=s)}),g}e.distinct=w;function m(h,u){const g=u.toLowerCase(),y=Object.keys(h).find(L=>L.toLowerCase()===g);return y?h[y]:h[u]}e.getCaseInsensitive=m;function f(h,u){const g=Object.create(null);for(const[y,L]of Object.entries(h))u(y,L)&&(g[y]=L);return g}e.filter=f;function p(h){let u=[],g=Object.getPrototypeOf(h);for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}e.getAllPropertyNames=p;function b(h){const u=[];for(const g of p(h))typeof h[g]=="function"&&u.push(g);return u}e.getAllMethodNames=b;function a(h,u){const g=L=>function(){const n=Array.prototype.slice.call(arguments,0);return u(L,n)},y={};for(const L of h)y[L]=g(L);return y}e.createProxyObject=a}),define(oe[133],ae([0,1,52]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var O;(function(_){function k(P){return P&&typeof P=="object"&&typeof P.id=="string"}_.isThemeColor=k})(O||(e.ThemeColor=O={}));function l(_){return{id:_}}e.themeColorFromId=l;var A;(function(_){_.iconNameSegment="[A-Za-z0-9]+",_.iconNameExpression="[A-Za-z0-9-]+",_.iconModifierExpression="~[A-Za-z]+",_.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${_.iconNameExpression})(${_.iconModifierExpression})?$`);function P(u){const g=k.exec(u.id);if(!g)return P(T.Codicon.error);const[,y,L]=g,n=["codicon","codicon-"+y];return L&&n.push("codicon-modifier-"+L.substring(1)),n}_.asClassNameArray=P;function S(u){return P(u).join(" ")}_.asClassName=S;function D(u){return"."+P(u).join(".")}_.asCSSSelector=D;function w(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||O.isThemeColor(u.color))}_.isThemeIcon=w;const m=new RegExp(`^\\$\\((${_.iconNameExpression}(?:${_.iconModifierExpression})?)\\)$`);function f(u){const g=m.exec(u);if(!g)return;const[,y]=g;return{id:y}}_.fromString=f;function p(u){return{id:u}}_.fromId=p;function b(u,g){let y=u.id;const L=y.lastIndexOf("~");return L!==-1&&(y=y.substring(0,L)),g&&(y=`${y}~${g}`),{id:y}}_.modify=b;function a(u){const g=u.id.lastIndexOf("~");if(g!==-1)return u.id.substring(g+1)}_.getModifier=a;function h(u,g){return u.id===g.id&&u.color?.id===g.color?.id}_.isEqual=h})(A||(e.ThemeIcon=A={}))}),define(oe[32],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(l){return T.test(l)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(k){for(let P=0;P<k.length;P++)k[P]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),_=[];for(let k=0;k<256;k++)_.push(k.toString(16).padStart(2,"0"));return function(){l(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let P=0,S="";return S+=_[A[P++]],S+=_[A[P++]],S+=_[A[P++]],S+=_[A[P++]],S+="-",S+=_[A[P++]],S+=_[A[P++]],S+="-",S+=_[A[P++]],S+=_[A[P++]],S+="-",S+=_[A[P++]],S+=_[A[P++]],S+="-",S+=_[A[P++]],S+=_[A[P++]],S+=_[A[P++]],S+=_[A[P++]],S+=_[A[P++]],S+=_[A[P++]],S}}()}),define(oe[134],ae([0,1,34]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function l(_){const k=_.replace(/\-/g,":").toLowerCase();return!O.has(k)}function A(){const _=(0,T.networkInterfaces)();for(const k in _){const P=_[k];if(P){for(const{mac:S}of P)if(l(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(oe[135],ae([0,1,63]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function O(k,P,S,D=1){let w=!1;return new Promise(m=>{const f=setTimeout(()=>{if(!w)return w=!0,m(0)},S);l(k,P,D,p=>{if(!w)return w=!0,clearTimeout(f),m(p)})})}e.findFreePort=O;function l(k,P,S,D){if(P===0)return D(0);const w=new T.Socket;w.once("connect",()=>(_(w),l(k+S,P-1,S,D))),w.once("data",()=>{}),w.once("error",m=>(_(w),m.code!=="ECONNREFUSED"?l(k+S,P-1,S,D):D(k))),w.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(k,P,S,D="127.0.0.1"){let w=!1,m,f=1;const p=T.createServer({pauseOnConnect:!0});function b(a,h){w||(w=!0,p.removeAllListeners(),p.close(),m&&clearTimeout(m),h(a))}return new Promise(a=>{m=setTimeout(()=>{b(0,a)},S),p.on("listening",()=>{b(k,a)}),p.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&f<P?(k++,f++,p.listen(k,D)):b(0,a)}),p.on("close",()=>{b(0,a)}),p.listen(k,D)})}e.findFreePortFaster=A;function _(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(P){console.error(P)}}}),define(oe[136],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function T(O){return!!O.parentPort}e.isUtilityProcess=T}),define(oe[137],ae([8,7]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(oe[64],ae([0,1,137]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,l=O*60,A=l*24,_=A*7,k=A*30,P=A*365;function S(w,m,f,p){typeof w!="number"&&(w=w.getTime());const b=Math.round((new Date().getTime()-w)/1e3);if(b<-30)return(0,T.localize)(0,null,S(new Date().getTime()+b*1e3,!1));if(!p&&b<30)return(0,T.localize)(1,null);let a;return b<O?(a=b,m?a===1?f?(0,T.localize)(2,null,a):(0,T.localize)(3,null,a):f?(0,T.localize)(4,null,a):(0,T.localize)(5,null,a):a===1?f?(0,T.localize)(6,null,a):(0,T.localize)(7,null,a):f?(0,T.localize)(8,null,a):(0,T.localize)(9,null,a)):b<l?(a=Math.floor(b/O),m?a===1?f?(0,T.localize)(10,null,a):(0,T.localize)(11,null,a):f?(0,T.localize)(12,null,a):(0,T.localize)(13,null,a):a===1?f?(0,T.localize)(14,null,a):(0,T.localize)(15,null,a):f?(0,T.localize)(16,null,a):(0,T.localize)(17,null,a)):b<A?(a=Math.floor(b/l),m?a===1?f?(0,T.localize)(18,null,a):(0,T.localize)(19,null,a):f?(0,T.localize)(20,null,a):(0,T.localize)(21,null,a):a===1?f?(0,T.localize)(22,null,a):(0,T.localize)(23,null,a):f?(0,T.localize)(24,null,a):(0,T.localize)(25,null,a)):b<_?(a=Math.floor(b/A),m?a===1?(0,T.localize)(26,null,a):(0,T.localize)(27,null,a):a===1?(0,T.localize)(28,null,a):(0,T.localize)(29,null,a)):b<k?(a=Math.floor(b/_),m?a===1?f?(0,T.localize)(30,null,a):(0,T.localize)(31,null,a):f?(0,T.localize)(32,null,a):(0,T.localize)(33,null,a):a===1?f?(0,T.localize)(34,null,a):(0,T.localize)(35,null,a):f?(0,T.localize)(36,null,a):(0,T.localize)(37,null,a)):b<P?(a=Math.floor(b/k),m?a===1?f?(0,T.localize)(38,null,a):(0,T.localize)(39,null,a):f?(0,T.localize)(40,null,a):(0,T.localize)(41,null,a):a===1?f?(0,T.localize)(42,null,a):(0,T.localize)(43,null,a):f?(0,T.localize)(44,null,a):(0,T.localize)(45,null,a)):(a=Math.floor(b/P),m?a===1?f?(0,T.localize)(46,null,a):(0,T.localize)(47,null,a):f?(0,T.localize)(48,null,a):(0,T.localize)(49,null,a):a===1?f?(0,T.localize)(50,null,a):(0,T.localize)(51,null,a):f?(0,T.localize)(52,null,a):(0,T.localize)(53,null,a))}e.fromNow=S;function D(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(oe[138],ae([8,7]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,11,138]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(w,m){return m&&(w.stack||w.stacktrace)?l.localize(0,null,k(w),_(w.stack)||_(w.stacktrace)):k(w)}function _(w){return Array.isArray(w)?w.join(`
`):w}function k(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?l.localize(1,null,w.message):w.message||l.localize(2,null)}function P(w=null,m=!1){if(!w)return l.localize(3,null);if(Array.isArray(w)){const f=T.coalesce(w),p=P(f[0],m);return f.length>1?l.localize(4,null,p,f.length):p}if(O.isString(w))return w;if(w.detail){const f=w.detail;if(f.error)return A(f.error,m);if(f.exception)return A(f.exception,m)}return w.stack?A(w,m):w.message?w.message:l.localize(5,null)}e.toErrorMessage=P;function S(w){const m=w;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=S;function D(w,m){let f;return typeof w=="string"?f=new Error(w):f=w,f.actions=m,f}e.createErrorWithActions=D}),define(oe[139],ae([8,7]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(oe[140],ae([0,1,139]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(l){switch(l){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(oe[141],ae([8,7]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,141]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let O=!1,l=!1,A=!1,_=!1,k=!1,P=!1,S=!1,D=!1,w=!1,m=!1,f,p=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT,a,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",y=g&&u?.type==="renderer";if(typeof navigator=="object"&&!y)h=navigator.userAgent,O=h.indexOf("Windows")>=0,l=h.indexOf("Macintosh")>=0,D=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=h.indexOf("Linux")>=0,m=h?.indexOf("Mobi")>=0,P=!0,f=T.getConfiguredDefaultLocale(T.localize(0,null))||e.LANGUAGE_DEFAULT,p=f,b=navigator.language;else if(typeof u=="object"){O=u.platform==="win32",l=u.platform==="darwin",A=u.platform==="linux",_=A&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,S=g,w=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const v=u.env.VSCODE_NLS_CONFIG;if(v)try{const E=JSON.parse(v),d=E.availableLanguages["*"];f=E.locale,b=E.osLocale,p=d||e.LANGUAGE_DEFAULT,a=E._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var L;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(L||(e.Platform=L={}));function n(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=n;let s=0;l?s=1:O?s=3:A&&(s=2),e.isWindows=O,e.isMacintosh=l,e.isLinux=A,e.isLinuxSnap=_,e.isNative=k,e.isElectron=S,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=D,e.isMobile=m,e.isCI=w,e.platform=s,e.userAgent=h,e.language=p;var t;(function(v){function E(){return e.language}v.value=E;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}v.isDefaultVariant=d;function I(){return e.language==="en"}v.isDefault=I})(t||(e.Language=t={})),e.locale=f,e.platformLocale=b,e.translationsConfigFile=a,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const v=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let I=0,R=v.length;I<R;I++){const N=v[I];if(N.id===d.data.vscodeScheduleAsyncWork){v.splice(I,1),N.callback();return}}});let E=0;return d=>{const I=++E;v.push({id:I,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=l||D?2:O?1:3;let r=!0,o=!1;function c(){if(!o){o=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,r=new Uint16Array(v.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[36],ae([0,1,4]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;if(typeof T.globals.vscode<"u"&&typeof T.globals.vscode.process<"u"){const l=T.globals.vscode.process;O={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return T.isWindows?"win32":T.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(oe[14],ae([0,1,36]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,l=97,A=90,_=122,k=46,P=47,S=92,D=58,w=63;class m extends Error{constructor(s,t,i){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const o=s.indexOf(".")!==-1?"property":"argument";let c=`The "${s}" ${o} ${r} of type ${t}`;c+=`. Received type ${typeof i}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function f(n,s){if(n===null||typeof n!="object")throw new m(s,"Object",n)}function p(n,s){if(typeof n!="string")throw new m(s,"string",n)}const b=T.platform==="win32";function a(n){return n===P||n===S}function h(n){return n===P}function u(n){return n>=O&&n<=A||n>=l&&n<=_}function g(n,s,t,i){let r="",o=0,c=-1,v=0,E=0;for(let d=0;d<=n.length;++d){if(d<n.length)E=n.charCodeAt(d);else{if(i(E))break;E=P}if(i(E)){if(!(c===d-1||v===1))if(v===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==k||r.charCodeAt(r.length-2)!==k){if(r.length>2){const I=r.lastIndexOf(t);I===-1?(r="",o=0):(r=r.slice(0,I),o=r.length-1-r.lastIndexOf(t)),c=d,v=0;continue}else if(r.length!==0){r="",o=0,c=d,v=0;continue}}s&&(r+=r.length>0?`${t}..`:"..",o=2)}else r.length>0?r+=`${t}${n.slice(c+1,d)}`:r=n.slice(c+1,d),o=d-c-1;c=d,v=0}else E===k&&v!==-1?++v:v=-1}return r}function y(n,s){f(s,"pathObject");const t=s.dir||s.root,i=s.base||`${s.name||""}${s.ext||""}`;return t?t===s.root?`${t}${i}`:`${t}${n}${i}`:i}e.win32={resolve(...n){let s="",t="",i=!1;for(let r=n.length-1;r>=-1;r--){let o;if(r>=0){if(o=n[r],p(o,"path"),o.length===0)continue}else s.length===0?o=T.cwd():(o=T.env[`=${s}`]||T.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==s.toLowerCase()&&o.charCodeAt(2)===S)&&(o=`${s}\\`));const c=o.length;let v=0,E="",d=!1;const I=o.charCodeAt(0);if(c===1)a(I)&&(v=1,d=!0);else if(a(I))if(d=!0,a(o.charCodeAt(1))){let R=2,N=R;for(;R<c&&!a(o.charCodeAt(R));)R++;if(R<c&&R!==N){const F=o.slice(N,R);for(N=R;R<c&&a(o.charCodeAt(R));)R++;if(R<c&&R!==N){for(N=R;R<c&&!a(o.charCodeAt(R));)R++;(R===c||R!==N)&&(E=`\\\\${F}\\${o.slice(N,R)}`,v=R)}}}else v=1;else u(I)&&o.charCodeAt(1)===D&&(E=o.slice(0,2),v=2,c>2&&a(o.charCodeAt(2))&&(d=!0,v=3));if(E.length>0)if(s.length>0){if(E.toLowerCase()!==s.toLowerCase())continue}else s=E;if(i){if(s.length>0)break}else if(t=`${o.slice(v)}\\${t}`,i=d,d&&s.length>0)break}return t=g(t,!i,"\\",a),i?`${s}\\${t}`:`${s}${t}`||"."},normalize(n){p(n,"path");const s=n.length;if(s===0)return".";let t=0,i,r=!1;const o=n.charCodeAt(0);if(s===1)return h(o)?"\\":n;if(a(o))if(r=!0,a(n.charCodeAt(1))){let v=2,E=v;for(;v<s&&!a(n.charCodeAt(v));)v++;if(v<s&&v!==E){const d=n.slice(E,v);for(E=v;v<s&&a(n.charCodeAt(v));)v++;if(v<s&&v!==E){for(E=v;v<s&&!a(n.charCodeAt(v));)v++;if(v===s)return`\\\\${d}\\${n.slice(E)}\\`;v!==E&&(i=`\\\\${d}\\${n.slice(E,v)}`,t=v)}}}else t=1;else u(o)&&n.charCodeAt(1)===D&&(i=n.slice(0,2),t=2,s>2&&a(n.charCodeAt(2))&&(r=!0,t=3));let c=t<s?g(n.slice(t),!r,"\\",a):"";return c.length===0&&!r&&(c="."),c.length>0&&a(n.charCodeAt(s-1))&&(c+="\\"),i===void 0?r?`\\${c}`:c:r?`${i}\\${c}`:`${i}${c}`},isAbsolute(n){p(n,"path");const s=n.length;if(s===0)return!1;const t=n.charCodeAt(0);return a(t)||s>2&&u(t)&&n.charCodeAt(1)===D&&a(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,t;for(let o=0;o<n.length;++o){const c=n[o];p(c,"path"),c.length>0&&(s===void 0?s=t=c:s+=`\\${c}`)}if(s===void 0)return".";let i=!0,r=0;if(typeof t=="string"&&a(t.charCodeAt(0))){++r;const o=t.length;o>1&&a(t.charCodeAt(1))&&(++r,o>2&&(a(t.charCodeAt(2))?++r:i=!1))}if(i){for(;r<s.length&&a(s.charCodeAt(r));)r++;r>=2&&(s=`\\${s.slice(r)}`)}return e.win32.normalize(s)},relative(n,s){if(p(n,"from"),p(s,"to"),n===s)return"";const t=e.win32.resolve(n),i=e.win32.resolve(s);if(t===i||(n=t.toLowerCase(),s=i.toLowerCase(),n===s))return"";let r=0;for(;r<n.length&&n.charCodeAt(r)===S;)r++;let o=n.length;for(;o-1>r&&n.charCodeAt(o-1)===S;)o--;const c=o-r;let v=0;for(;v<s.length&&s.charCodeAt(v)===S;)v++;let E=s.length;for(;E-1>v&&s.charCodeAt(E-1)===S;)E--;const d=E-v,I=c<d?c:d;let R=-1,N=0;for(;N<I;N++){const W=n.charCodeAt(r+N);if(W!==s.charCodeAt(v+N))break;W===S&&(R=N)}if(N!==I){if(R===-1)return i}else{if(d>I){if(s.charCodeAt(v+N)===S)return i.slice(v+N+1);if(N===2)return i.slice(v+N)}c>I&&(n.charCodeAt(r+N)===S?R=N:N===2&&(R=3)),R===-1&&(R=0)}let F="";for(N=r+R+1;N<=o;++N)(N===o||n.charCodeAt(N)===S)&&(F+=F.length===0?"..":"\\..");return v+=R,F.length>0?`${F}${i.slice(v,E)}`:(i.charCodeAt(v)===S&&++v,i.slice(v,E))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=e.win32.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===S){if(s.charCodeAt(1)===S){const t=s.charCodeAt(2);if(t!==w&&t!==k)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(u(s.charCodeAt(0))&&s.charCodeAt(1)===D&&s.charCodeAt(2)===S)return`\\\\?\\${s}`;return n},dirname(n){p(n,"path");const s=n.length;if(s===0)return".";let t=-1,i=0;const r=n.charCodeAt(0);if(s===1)return a(r)?n:".";if(a(r)){if(t=i=1,a(n.charCodeAt(1))){let v=2,E=v;for(;v<s&&!a(n.charCodeAt(v));)v++;if(v<s&&v!==E){for(E=v;v<s&&a(n.charCodeAt(v));)v++;if(v<s&&v!==E){for(E=v;v<s&&!a(n.charCodeAt(v));)v++;if(v===s)return n;v!==E&&(t=i=v+1)}}}}else u(r)&&n.charCodeAt(1)===D&&(t=s>2&&a(n.charCodeAt(2))?3:2,i=t);let o=-1,c=!0;for(let v=s-1;v>=i;--v)if(a(n.charCodeAt(v))){if(!c){o=v;break}}else c=!1;if(o===-1){if(t===-1)return".";o=t}return n.slice(0,o)},basename(n,s){s!==void 0&&p(s,"ext"),p(n,"path");let t=0,i=-1,r=!0,o;if(n.length>=2&&u(n.charCodeAt(0))&&n.charCodeAt(1)===D&&(t=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let c=s.length-1,v=-1;for(o=n.length-1;o>=t;--o){const E=n.charCodeAt(o);if(a(E)){if(!r){t=o+1;break}}else v===-1&&(r=!1,v=o+1),c>=0&&(E===s.charCodeAt(c)?--c===-1&&(i=o):(c=-1,i=v))}return t===i?i=v:i===-1&&(i=n.length),n.slice(t,i)}for(o=n.length-1;o>=t;--o)if(a(n.charCodeAt(o))){if(!r){t=o+1;break}}else i===-1&&(r=!1,i=o+1);return i===-1?"":n.slice(t,i)},extname(n){p(n,"path");let s=0,t=-1,i=0,r=-1,o=!0,c=0;n.length>=2&&n.charCodeAt(1)===D&&u(n.charCodeAt(0))&&(s=i=2);for(let v=n.length-1;v>=s;--v){const E=n.charCodeAt(v);if(a(E)){if(!o){i=v+1;break}continue}r===-1&&(o=!1,r=v+1),E===k?t===-1?t=v:c!==1&&(c=1):t!==-1&&(c=-1)}return t===-1||r===-1||c===0||c===1&&t===r-1&&t===i+1?"":n.slice(t,r)},format:y.bind(null,"\\"),parse(n){p(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const t=n.length;let i=0,r=n.charCodeAt(0);if(t===1)return a(r)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(a(r)){if(i=1,a(n.charCodeAt(1))){let R=2,N=R;for(;R<t&&!a(n.charCodeAt(R));)R++;if(R<t&&R!==N){for(N=R;R<t&&a(n.charCodeAt(R));)R++;if(R<t&&R!==N){for(N=R;R<t&&!a(n.charCodeAt(R));)R++;R===t?i=R:R!==N&&(i=R+1)}}}}else if(u(r)&&n.charCodeAt(1)===D){if(t<=2)return s.root=s.dir=n,s;if(i=2,a(n.charCodeAt(2))){if(t===3)return s.root=s.dir=n,s;i=3}}i>0&&(s.root=n.slice(0,i));let o=-1,c=i,v=-1,E=!0,d=n.length-1,I=0;for(;d>=i;--d){if(r=n.charCodeAt(d),a(r)){if(!E){c=d+1;break}continue}v===-1&&(E=!1,v=d+1),r===k?o===-1?o=d:I!==1&&(I=1):o!==-1&&(I=-1)}return v!==-1&&(o===-1||I===0||I===1&&o===v-1&&o===c+1?s.base=s.name=n.slice(c,v):(s.name=n.slice(c,o),s.base=n.slice(c,v),s.ext=n.slice(o,v))),c>0&&c!==i?s.dir=n.slice(0,c-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(b){const n=/\\/g;return()=>{const s=T.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>T.cwd()})();e.posix={resolve(...n){let s="",t=!1;for(let i=n.length-1;i>=-1&&!t;i--){const r=i>=0?n[i]:L();p(r,"path"),r.length!==0&&(s=`${r}/${s}`,t=r.charCodeAt(0)===P)}return s=g(s,!t,"/",h),t?`/${s}`:s.length>0?s:"."},normalize(n){if(p(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===P,t=n.charCodeAt(n.length-1)===P;return n=g(n,!s,"/",h),n.length===0?s?"/":t?"./":".":(t&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return p(n,"path"),n.length>0&&n.charCodeAt(0)===P},join(...n){if(n.length===0)return".";let s;for(let t=0;t<n.length;++t){const i=n[t];p(i,"path"),i.length>0&&(s===void 0?s=i:s+=`/${i}`)}return s===void 0?".":e.posix.normalize(s)},relative(n,s){if(p(n,"from"),p(s,"to"),n===s||(n=e.posix.resolve(n),s=e.posix.resolve(s),n===s))return"";const t=1,i=n.length,r=i-t,o=1,c=s.length-o,v=r<c?r:c;let E=-1,d=0;for(;d<v;d++){const R=n.charCodeAt(t+d);if(R!==s.charCodeAt(o+d))break;R===P&&(E=d)}if(d===v)if(c>v){if(s.charCodeAt(o+d)===P)return s.slice(o+d+1);if(d===0)return s.slice(o+d)}else r>v&&(n.charCodeAt(t+d)===P?E=d:d===0&&(E=0));let I="";for(d=t+E+1;d<=i;++d)(d===i||n.charCodeAt(d)===P)&&(I+=I.length===0?"..":"/..");return`${I}${s.slice(o+E)}`},toNamespacedPath(n){return n},dirname(n){if(p(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===P;let t=-1,i=!0;for(let r=n.length-1;r>=1;--r)if(n.charCodeAt(r)===P){if(!i){t=r;break}}else i=!1;return t===-1?s?"/":".":s&&t===1?"//":n.slice(0,t)},basename(n,s){s!==void 0&&p(s,"ext"),p(n,"path");let t=0,i=-1,r=!0,o;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let c=s.length-1,v=-1;for(o=n.length-1;o>=0;--o){const E=n.charCodeAt(o);if(E===P){if(!r){t=o+1;break}}else v===-1&&(r=!1,v=o+1),c>=0&&(E===s.charCodeAt(c)?--c===-1&&(i=o):(c=-1,i=v))}return t===i?i=v:i===-1&&(i=n.length),n.slice(t,i)}for(o=n.length-1;o>=0;--o)if(n.charCodeAt(o)===P){if(!r){t=o+1;break}}else i===-1&&(r=!1,i=o+1);return i===-1?"":n.slice(t,i)},extname(n){p(n,"path");let s=-1,t=0,i=-1,r=!0,o=0;for(let c=n.length-1;c>=0;--c){const v=n.charCodeAt(c);if(v===P){if(!r){t=c+1;break}continue}i===-1&&(r=!1,i=c+1),v===k?s===-1?s=c:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||i===-1||o===0||o===1&&s===i-1&&s===t+1?"":n.slice(s,i)},format:y.bind(null,"/"),parse(n){p(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const t=n.charCodeAt(0)===P;let i;t?(s.root="/",i=1):i=0;let r=-1,o=0,c=-1,v=!0,E=n.length-1,d=0;for(;E>=i;--E){const I=n.charCodeAt(E);if(I===P){if(!v){o=E+1;break}continue}c===-1&&(v=!1,c=E+1),I===k?r===-1?r=E:d!==1&&(d=1):r!==-1&&(d=-1)}if(c!==-1){const I=o===0&&t?1:o;r===-1||d===0||d===1&&r===c-1&&r===o+1?s.base=s.name=n.slice(I,c):(s.name=n.slice(I,r),s.base=n.slice(I,c),s.ext=n.slice(r,c))}return o>0?s.dir=n.slice(0,o-1):t&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(oe[142],ae([0,1,14]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(D){const w=(0,T.extname)(D),m=O[w.toLowerCase()];return m!==void 0?m:_(D)}e.getMediaOrTextMime=A;function _(D){const w=(0,T.extname)(D);return l[w.toLowerCase()]}e.getMediaMime=_;function k(D){for(const w in l)if(l[w]===D)return w}e.getExtensionForMimeType=k;const P=/^(.+)\/(.+?)(;.+)?$/;function S(D,w){const m=P.exec(D);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:w?void 0:D}e.normalizeMimeType=S}),define(oe[88],ae([0,1,4]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(O||(e.Source=O={}));var l;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(l||(e.TerminateResponseCode=l={}));function A(k,...P){const S=P.reduce((m,f)=>(m[f]=!0,m),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(m=>!S[m]).forEach(m=>{for(let f=0;f<D.length;f++)if(m.search(D[f])!==-1){delete k[m];break}})}e.sanitizeProcessEnvironment=A;function _(k){k&&(delete k.DEBUG,T.isMacintosh&&delete k.DYLD_LIBRARY_PATH,T.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(oe[89],ae([0,1,4]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const O=T.globals.performance&&typeof T.globals.performance.now=="function";class l{static create(_=!0){return new l(_)}constructor(_){this._highResolution=O&&_,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?T.globals.performance.now():Date.now()}}e.StopWatch=l}),define(oe[3],ae([0,1,9,84,2,86,89]),function(ie,e,T,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,P=!1;var S;(function(o){o.None=()=>l.Disposable.None;function c(z){if(P){const{onDidAddListener:H}=z,V=p.create();let X=0;z.onDidAddListener=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),H?.()}}}function v(z,H){return B(z,()=>{},0,void 0,!0,void 0,H)}o.defer=v;function E(z){return(H,V=null,X)=>{let ee=!1,ce;return ce=z(ue=>{if(!ee)return ce?ce.dispose():ee=!0,H.call(V,ue)},null,X),ee&&ce.dispose(),ce}}o.once=E;function d(z,H,V){return q((X,ee=null,ce)=>z(ue=>X.call(ee,H(ue)),null,ce),V)}o.map=d;function I(z,H,V){return q((X,ee=null,ce)=>z(ue=>{H(ue),X.call(ee,ue)},null,ce),V)}o.forEach=I;function R(z,H,V){return q((X,ee=null,ce)=>z(ue=>H(ue)&&X.call(ee,ue),null,ce),V)}o.filter=R;function N(z){return z}o.signal=N;function F(...z){return(H,V=null,X)=>(0,l.combinedDisposable)(...z.map(ee=>ee(ce=>H.call(V,ce),null,X)))}o.any=F;function W(z,H,V,X){let ee=V;return d(z,ce=>(ee=H(ee,ce),ee),X)}o.reduce=W;function q(z,H){let V;const X={onWillAddFirstListener(){V=z(ee.fire,ee)},onDidRemoveLastListener(){V?.dispose()}};H||c(X);const ee=new a(X);return H?.add(ee),ee.event}function B(z,H,V=100,X=!1,ee=!1,ce,ue){let fe,ve,ye,be=0,De;const ke={leakWarningThreshold:ce,onWillAddFirstListener(){fe=z(Ke=>{be++,ve=H(ve,Ke),X&&!ye&&(We.fire(ve),ve=void 0),De=()=>{const le=ve;ve=void 0,ye=void 0,(!X||be>1)&&We.fire(le),be=0},typeof V=="number"?(clearTimeout(ye),ye=setTimeout(De,V)):ye===void 0&&(ye=0,queueMicrotask(De))})},onWillRemoveListener(){ee&&be>0&&De?.()},onDidRemoveLastListener(){De=void 0,fe.dispose()}};ue||c(ke);const We=new a(ke);return ue?.add(We),We.event}o.debounce=B;function Q(z,H=0,V){return o.debounce(z,(X,ee)=>X?(X.push(ee),X):[ee],H,void 0,!0,void 0,V)}o.accumulate=Q;function Z(z,H=(X,ee)=>X===ee,V){let X=!0,ee;return R(z,ce=>{const ue=X||!H(ce,ee);return X=!1,ee=ce,ue},V)}o.latch=Z;function K(z,H,V){return[o.filter(z,H,V),o.filter(z,X=>!H(X),V)]}o.split=K;function x(z,H=!1,V=[]){let X=V.slice(),ee=z(fe=>{X?X.push(fe):ue.fire(fe)});const ce=()=>{X?.forEach(fe=>ue.fire(fe)),X=null},ue=new a({onWillAddFirstListener(){ee||(ee=z(fe=>ue.fire(fe)))},onDidAddFirstListener(){X&&(H?setTimeout(ce):ce())},onDidRemoveLastListener(){ee&&ee.dispose(),ee=null}});return ue.event}o.buffer=x;class ${constructor(H){this.event=H,this.disposables=new l.DisposableStore}map(H){return new $(d(this.event,H,this.disposables))}forEach(H){return new $(I(this.event,H,this.disposables))}filter(H){return new $(R(this.event,H,this.disposables))}reduce(H,V){return new $(W(this.event,H,V,this.disposables))}latch(){return new $(Z(this.event,void 0,this.disposables))}debounce(H,V=100,X=!1,ee=!1,ce){return new $(B(this.event,H,V,X,ee,ce,this.disposables))}on(H,V,X){return this.event(H,V,X)}once(H,V,X){return E(this.event)(H,V,X)}dispose(){this.disposables.dispose()}}function j(z){return new $(z)}o.chain=j;function te(z,H,V=X=>X){const X=(...fe)=>ue.fire(V(...fe)),ee=()=>z.on(H,X),ce=()=>z.removeListener(H,X),ue=new a({onWillAddFirstListener:ee,onDidRemoveLastListener:ce});return ue.event}o.fromNodeEventEmitter=te;function ne(z,H,V=X=>X){const X=(...fe)=>ue.fire(V(...fe)),ee=()=>z.addEventListener(H,X),ce=()=>z.removeEventListener(H,X),ue=new a({onWillAddFirstListener:ee,onDidRemoveLastListener:ce});return ue.event}o.fromDOMEventEmitter=ne;function se(z){return new Promise(H=>E(z)(H))}o.toPromise=se;function J(z,H){return H(void 0),z(V=>H(V))}o.runAndSubscribe=J;function G(z,H){let V=null;function X(ce){V?.dispose(),V=new l.DisposableStore,H(ce,V)}X(void 0);const ee=z(ce=>X(ce));return(0,l.toDisposable)(()=>{ee.dispose(),V?.dispose()})}o.runAndSubscribeWithStore=G;class M{constructor(H,V){this._observable=H,this._counter=0,this._hasChanged=!1;const X={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};V||c(X),this.emitter=new a(X),V&&V.add(this.emitter)}beginUpdate(H){this._counter++}handlePossibleChange(H){}handleChange(H,V){this._hasChanged=!0}endUpdate(H){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function C(z,H){return new M(z,H).emitter.event}o.fromObservable=C;function U(z){return H=>{let V=0,X=!1;const ee={beginUpdate(){V++},endUpdate(){V--,V===0&&(z.reportChanges(),X&&(X=!1,H()))},handlePossibleChange(){},handleChange(){X=!0}};return z.addObserver(ee),{dispose(){z.removeObserver(ee)}}}}o.fromObservableLight=U})(S||(e.Event=S={}));class D{constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${D._idPool++}`,D.all.add(this)}start(c){this._stopWatch=new _.StopWatch(!0),this.listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=D,D.all=new Set,D._idPool=0;let w=-1;function m(o){const c=w;return w=o,{dispose(){w=c}}}e.setGlobalLeakWarningThreshold=m;class f{constructor(c,v=Math.random().toString(18).slice(2,5)){this.threshold=c,this.name=v,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(c,v){const E=this.threshold;if(E<=0||v<E)return;this._stacks||(this._stacks=new Map);const d=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,d+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=E*.5;let I,R=0;for(const[N,F]of this._stacks)(!I||R<F)&&(I=N,R=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${R}):`),console.warn(I)}return()=>{const I=this._stacks.get(c.value)||0;this._stacks.set(c.value,I-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(c,v,E){this.callback=c,this.callbackThis=v,this.stack=E,this.subscription=new l.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class a{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=w>0||this._options?.leakWarningThreshold?new f(this._options?.leakWarningThreshold??w):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(k){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const v of c)v.subscription.isset()&&(v.subscription.unset(),v.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,v,E)=>{if(this._listeners||(this._listeners=new A.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const d=this._listeners.isEmpty();d&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let I,R;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(R=p.create(),I=this._leakageMon.check(R,this._listeners.size+1)),k&&(R=R??p.create());const N=new b(c,v,R),F=this._listeners.push(N);d&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,c,v);const W=N.subscription.set(()=>{I?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),F(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return E instanceof l.DisposableStore?E.add(W):Array.isArray(E)&&E.push(W),W}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new u(this._options?.onListenerError));for(const v of this._listeners)this._deliveryQueue.push(this,v,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=a;class h{constructor(c=T.onUnexpectedError){this._onListenerError=c,this._queue=new A.LinkedList}get size(){return this._queue.size}push(c,v,E){this._queue.push(new g(c,v,E))}clear(c){const v=new A.LinkedList;for(const E of this._queue)E.emitter!==c&&v.push(E);this._queue=v}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(v){this._onListenerError(v)}}}}e.EventDeliveryQueue=h;class u extends h{clear(c){this._queue.clear()}}class g{constructor(c,v,E){this.emitter=c,this.listener=v,this.event=E}}class y extends a{async fireAsync(c,v,E){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const d of this._listeners)this._asyncDeliveryQueue.push([d,c]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[d,I]=this._asyncDeliveryQueue.shift(),R=[],N={...I,token:v,waitUntil:F=>{if(Object.isFrozen(R))throw new Error("waitUntil can NOT be called asynchronous");E&&(F=E(F,d.callback)),R.push(F)}};try{d.invoke(N)}catch(F){(0,T.onUnexpectedError)(F);continue}Object.freeze(R),await Promise.allSettled(R).then(F=>{for(const W of F)W.status==="rejected"&&(0,T.onUnexpectedError)(W.reason)})}}}}e.AsyncEmitter=y;class L extends a{constructor(c){super(c),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=L;class n extends L{constructor(c){super(c),this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=n;class s extends a{constructor(c){super(c),this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this.hasListeners()&&(this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(v=>super.fire(v)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const v={event:c,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const E=()=>{this.hasListeners&&this.unhook(v);const d=this.events.indexOf(v);this.events.splice(d,1)};return(0,l.toDisposable)((0,O.once)(E))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(v=>this.emitter.fire(v))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class i{constructor(){this.buffers=[]}wrapEvent(c){return(v,E,d)=>c(I=>{const R=this.buffers[this.buffers.length-1];R?R.push(()=>v.call(E,I)):v.call(E,I)},void 0,d)}bufferEvents(c){const v=[];this.buffers.push(v);const E=c();return this.buffers.pop(),v.forEach(d=>d()),E}}e.EventBufferer=i;class r{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=l.Disposable.None,this.emitter=new a({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(oe[26],ae([0,1,3]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const O=Object.freeze(function(k,P){const S=setTimeout(k.bind(P),0);return{dispose(){clearTimeout(S)}}});var l;(function(k){function P(S){return S===k.None||S===k.Cancelled||S instanceof A?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}k.isCancellationToken=P,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:T.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(l||(e.CancellationToken=l={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?O:(this._emitter||(this._emitter=new T.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(P){this._token=void 0,this._parentListener=void 0,this._parentListener=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=l.Cancelled}dispose(P=!1){P&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=l.None}}e.CancellationTokenSource=_}),define(oe[143],ae([0,1,26]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class O{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new T.CancellationTokenSource,P=this.task(k.token);return this.result={promise:P,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=O;class l{constructor(k){this.fn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const P=JSON.stringify(k);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.fn(k)),this.lastCache}}e.LRUCachedFunction=l;class A{get cachedValues(){return this._map}constructor(k){this.fn=k,this._map=new Map}get(k){if(this._map.has(k))return this._map.get(k);const P=this.fn(k);return this._map.set(k,P),P}}e.CachedFunction=A}),define(oe[27],ae([0,1,143,129]),function(ie,e,T,O){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.isFalsyOrWhitespace=A;const _=/{(\d+)}/g;function k(re,...he){return he.length===0?re:re.replace(_,function(me,pe){const we=parseInt(pe,10);return isNaN(we)||we<0||we>=he.length?me:he[we]})}e.format=k;const P=/{([^}]+)}/g;function S(re,he){return re.replace(P,(me,pe)=>he[pe]??me)}e.format2=S;function D(re){return re.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=D;function w(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function m(re,he){let me=0;const pe=he.charCodeAt(0);for(let we=re.length-1;we>=0;we--)re.charCodeAt(we)===pe&&me++;return me}e.count=m;function f(re,he,me="\u2026"){return re.length<=he?re:`${re.substr(0,he)}${me}`}e.truncate=f;function p(re,he=" "){const me=b(re,he);return a(me,he)}e.trim=p;function b(re,he){if(!re||!he)return re;const me=he.length;if(me===0||re.length===0)return re;let pe=0;for(;re.indexOf(he,pe)===pe;)pe=pe+me;return re.substring(pe)}e.ltrim=b;function a(re,he){if(!re||!he)return re;const me=he.length,pe=re.length;if(me===0||pe===0)return re;let we=pe,Ce=-1;for(;Ce=re.lastIndexOf(he,we-1),!(Ce===-1||Ce+me!==we);){if(Ce===0)return"";we=Ce}return re.substring(0,we)}e.rtrim=a;function h(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function u(re){return re.replace(/\*/g,"")}e.stripWildcards=u;function g(re,he,me={}){if(!re)throw new Error("Cannot create regex from empty string");he||(re=w(re)),me.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(re,pe)}e.createRegExp=g;function y(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function L(re){return!!re.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=L;function n(re){return(re.global?"g":"")+(re.ignoreCase?"i":"")+(re.multiline?"m":"")+(re.unicode?"u":"")}e.regExpFlags=n;function s(re){return re.split(/\r\n|\r|\n/)}e.splitLines=s;function t(re){for(let he=0,me=re.length;he<me;he++){const pe=re.charCodeAt(he);if(pe!==32&&pe!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function i(re,he=0,me=re.length){for(let pe=he;pe<me;pe++){const we=re.charCodeAt(pe);if(we!==32&&we!==9)return re.substring(he,pe)}return re.substring(he,me)}e.getLeadingWhitespace=i;function r(re,he=re.length-1){for(let me=he;me>=0;me--){const pe=re.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.lastNonWhitespaceIndex=r;function o(re,he,me){const pe=[];let we=0;for(const Ce of re.matchAll(he)){if(pe.push(re.slice(we,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");we=Ce.index+Ce[0].length,pe.push(me(Ce[0],...Ce.slice(1),Ce.index,re,Ce.groups))}return pe.push(re.slice(we)),Promise.all(pe).then(Ce=>Ce.join(""))}e.replaceAsync=o;function c(re,he){return re<he?-1:re>he?1:0}e.compare=c;function v(re,he,me=0,pe=re.length,we=0,Ce=he.length){for(;me<pe&&we<Ce;me++,we++){const ze=re.charCodeAt(me),Te=he.charCodeAt(we);if(ze<Te)return-1;if(ze>Te)return 1}const Re=pe-me,Ae=Ce-we;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstring=v;function E(re,he){return d(re,he,0,re.length,0,he.length)}e.compareIgnoreCase=E;function d(re,he,me=0,pe=re.length,we=0,Ce=he.length){for(;me<pe&&we<Ce;me++,we++){let ze=re.charCodeAt(me),Te=he.charCodeAt(we);if(ze===Te)continue;if(ze>=128||Te>=128)return v(re.toLowerCase(),he.toLowerCase(),me,pe,we,Ce);R(ze)&&(ze-=32),R(Te)&&(Te-=32);const xe=ze-Te;if(xe!==0)return xe}const Re=pe-me,Ae=Ce-we;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstringIgnoreCase=d;function I(re){return re>=48&&re<=57}e.isAsciiDigit=I;function R(re){return re>=97&&re<=122}e.isLowerAsciiLetter=R;function N(re){return re>=65&&re<=90}e.isUpperAsciiLetter=N;function F(re,he){return re.length===he.length&&d(re,he)===0}e.equalsIgnoreCase=F;function W(re,he){const me=he.length;return he.length>re.length?!1:d(re,he,0,me)===0}e.startsWithIgnoreCase=W;function q(re,he){const me=Math.min(re.length,he.length);let pe;for(pe=0;pe<me;pe++)if(re.charCodeAt(pe)!==he.charCodeAt(pe))return pe;return me}e.commonPrefixLength=q;function B(re,he){const me=Math.min(re.length,he.length);let pe;const we=re.length-1,Ce=he.length-1;for(pe=0;pe<me;pe++)if(re.charCodeAt(we-pe)!==he.charCodeAt(Ce-pe))return pe;return me}e.commonSuffixLength=B;function Q(re){return 55296<=re&&re<=56319}e.isHighSurrogate=Q;function Z(re){return 56320<=re&&re<=57343}e.isLowSurrogate=Z;function K(re,he){return(re-55296<<10)+(he-56320)+65536}e.computeCodePoint=K;function x(re,he,me){const pe=re.charCodeAt(me);if(Q(pe)&&me+1<he){const we=re.charCodeAt(me+1);if(Z(we))return K(pe,we)}return pe}e.getNextCodePoint=x;function $(re,he){const me=re.charCodeAt(he-1);if(Z(me)&&he>1){const pe=re.charCodeAt(he-2);if(Q(pe))return K(pe,me)}return me}class j{get offset(){return this._offset}constructor(he,me=0){this._str=he,this._len=he.length,this._offset=me}setOffset(he){this._offset=he}prevCodePoint(){const he=$(this._str,this._offset);return this._offset-=he>=65536?2:1,he}nextCodePoint(){const he=x(this._str,this._len,this._offset);return this._offset+=he>=65536?2:1,he}eol(){return this._offset>=this._len}}e.CodePointIterator=j;class te{get offset(){return this._iterator.offset}constructor(he,me=0){this._iterator=new j(he,me)}nextGraphemeLength(){const he=Ie.getInstance(),me=this._iterator,pe=me.offset;let we=he.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ce=me.offset,Re=he.getGraphemeBreakType(me.nextCodePoint());if(ge(we,Re)){me.setOffset(Ce);break}we=Re}return me.offset-pe}prevGraphemeLength(){const he=Ie.getInstance(),me=this._iterator,pe=me.offset;let we=he.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ce=me.offset,Re=he.getGraphemeBreakType(me.prevCodePoint());if(ge(Re,we)){me.setOffset(Ce);break}we=Re}return pe-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=te;function ne(re,he){return new te(re,he).nextGraphemeLength()}e.nextCharLength=ne;function se(re,he){return new te(re,he).prevGraphemeLength()}e.prevCharLength=se;function J(re,he){he>0&&Z(re.charCodeAt(he))&&he--;const me=he+ne(re,he);return[me-se(re,me),me]}e.getCharContainingOffset=J;function G(re){const he=new te(re);let me=0;for(;!he.eol();)me++,he.nextGraphemeLength();return me}e.charCount=G;let M;function C(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(re){return M||(M=C()),M.test(re)}e.containsRTL=U;const z=/^[\t\n\r\x20-\x7E]*$/;function H(re){return z.test(re)}e.isBasicASCII=H,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function V(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}e.containsUnusualLineTerminators=V;function X(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.isFullWidthCharacter=X;function ee(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.isEmojiImprecise=ee;function ce(re,he){if(re.length<he)return re;const me=/\b/g;let pe=0;for(;me.test(re)&&!(re.length-me.lastIndex<he);)pe=me.lastIndex,me.lastIndex+=1;return re.substring(pe).replace(/^\s/,"")}e.lcut=ce;const ue=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,fe=/\x1b\].*?\x07/g;function ve(re){return re&&(re=re.replace(ue,"").replace(fe,"")),re}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ye(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ye;function be(re){return ye(re)?re.substr(1):re}e.stripUTF8BOM=be;function De(re,he){if(!re||!he||re.length<he.length)return!1;const me=he.length,pe=re.toLowerCase();let we=0,Ce=-1;for(;we<me;){const Re=pe.indexOf(he[we],Ce+1);if(Re<0)return!1;Ce=Re,we++}return!0}e.fuzzyContains=De;function ke(re,he=!1){return re?(he&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.containsUppercaseCharacter=ke;function We(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.uppercaseFirstLetter=We;function Ke(re,he=1){if(he===0)return"";let me=-1;do me=re.indexOf(`
`,me+1),he--;while(he>0&&me>=0);return me===-1?re:(re[me-1]==="\r"&&me--,re.substr(0,me))}e.getNLines=Ke;function le(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.singleLetterHash=le;function de(re){return Ie.getInstance().getGraphemeBreakType(re)}e.getGraphemeBreakType=de;function ge(re,he){return re===0?he!==5&&he!==7:re===2&&he===3?!1:re===4||re===2||re===3||he===4||he===2||he===3?!0:!(re===8&&(he===8||he===9||he===11||he===12)||(re===11||re===9)&&(he===9||he===10)||(re===12||re===10)&&he===10||he===5||he===13||he===7||re===1||re===13&&he===14||re===6&&he===6)}var Pe;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Ie{static getInstance(){return Ie._INSTANCE||(Ie._INSTANCE=new Ie),Ie._INSTANCE}constructor(){this._data=Me()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const me=this._data,pe=me.length/3;let we=1;for(;we<=pe;)if(he<me[3*we])we=2*we;else if(he>me[3*we+1])we=2*we+1;else return me[3*we+2];return 0}}Ie._INSTANCE=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(re,he){if(re===0)return 0;const me=$e(re,he);if(me!==void 0)return me;const pe=new j(he,re);return pe.prevCodePoint(),pe.offset}e.getLeftDeleteOffset=Le;function $e(re,he){const me=new j(he,re);let pe=me.prevCodePoint();for(;Oe(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!ee(pe))return;let we=me.offset;return we>0&&me.prevCodePoint()===8205&&(we=me.offset),we}function Oe(re){return 127995<=re&&re<=127999}var Fe;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class Ne{static getInstance(he){return Ne.cache.get(Array.from(he))}static getLocales(){return Ne._locales.value}constructor(he){this.confusableDictionary=he}isAmbiguous(he){return this.confusableDictionary.has(he)}getPrimaryConfusable(he){return this.confusableDictionary.get(he)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ne,l=Ne,Ne.ambiguousCharacterData=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.cache=new T.LRUCachedFunction(re=>{function he(Te){const xe=new Map;for(let je=0;je<Te.length;je+=2)xe.set(Te[je],Te[je+1]);return xe}function me(Te,xe){const je=new Map(Te);for(const[et,nt]of xe)je.set(et,nt);return je}function pe(Te,xe){if(!Te)return xe;const je=new Map;for(const[et,nt]of Te)xe.has(et)&&je.set(et,nt);return je}const we=l.ambiguousCharacterData.value;let Ce=re.filter(Te=>!Te.startsWith("_")&&Te in we);Ce.length===0&&(Ce=["_default"]);let Re;for(const Te of Ce){const xe=he(we[Te]);Re=pe(Re,xe)}const Ae=he(we._common),ze=me(Ae,Re);return new Ne(ze)}),Ne._locales=new O.Lazy(()=>Object.keys(Ne.ambiguousCharacterData.value).filter(re=>!re.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(he){return _e.getData().has(he)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(oe[47],ae([0,1,14,4,27,11]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(o){return o===47||o===92}e.isPathSeparator=_;function k(o){return o.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=k;function P(o){return o.indexOf("/")===-1&&(o=k(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=P;function S(o,c=T.posix.sep){if(!o)return"";const v=o.length,E=o.charCodeAt(0);if(_(E)){if(_(o.charCodeAt(1))&&!_(o.charCodeAt(2))){let I=3;const R=I;for(;I<v&&!_(o.charCodeAt(I));I++);if(R!==I&&!_(o.charCodeAt(I+1))){for(I+=1;I<v;I++)if(_(o.charCodeAt(I)))return o.slice(0,I+1).replace(/[\\/]/g,c)}}return c}else if(h(E)&&o.charCodeAt(1)===58)return _(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let d=o.indexOf("://");if(d!==-1){for(d+=3;d<v;d++)if(_(o.charCodeAt(d)))return o.slice(0,d+1)}return""}e.getRoot=S;function D(o){if(!O.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let v=2;const E=v;for(;v<o.length&&(c=o.charCodeAt(v),c!==92);v++);return!(E===v||(c=o.charCodeAt(v+1),isNaN(c)||c===92))}e.isUNC=D;const w=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(o,c=O.isWindows){const v=c?w:m;return!(!o||o.length===0||/^\s+$/.test(o)||(v.lastIndex=0,v.test(o))||c&&f.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=p;function b(o,c,v){const E=o===c;return!v||E?E:!o||!c?!1:(0,l.equalsIgnoreCase)(o,c)}e.isEqual=b;function a(o,c,v,E=T.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(v){if(!(0,l.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let I=c.length;return c.charAt(c.length-1)===E&&I--,o.charAt(I)===E}return c.charAt(c.length-1)!==E&&(c+=E),o.indexOf(c)===0}e.isEqualOrParent=a;function h(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=h;function u(o,c){return O.isWindows&&o.endsWith(":")&&(o+=T.sep),(0,T.isAbsolute)(o)||(o=(0,T.join)(c,o)),o=(0,T.normalize)(o),O.isWindows?(o=(0,l.rtrim)(o,T.sep),o.endsWith(":")&&(o+=T.sep)):(o=(0,l.rtrim)(o,T.sep),o||(o=T.sep)),o}e.sanitizeFilePath=u;function g(o){const c=(0,T.normalize)(o);return O.isWindows?o.length>3?!1:y(c)&&(o.length===2||c.charCodeAt(2)===92):c===T.posix.sep}e.isRootOrDriveLetter=g;function y(o,c=O.isWindows){return c?h(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function L(o){return y(o)?o[0]:void 0}e.getDriveLetter=L;function n(o,c,v){return c.length>o.length?-1:o===c?0:(v&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=n;function s(o){const c=o.split(":");let v,E,d;for(const I of c){const R=Number(I);(0,A.isNumber)(R)?E===void 0?E=R:d===void 0&&(d=R):v=v?[v,I].join(":"):I}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:E!==void 0?E:void 0,column:d!==void 0?d:E!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function r(o,c,v=8){let E="";for(let I=0;I<v;I++){let R;I===0&&O.isWindows&&!c&&(v===3||v===4)?R=i:R=t,E+=R.charAt(Math.floor(Math.random()*R.length))}let d;return c?d=`${c}-${E}`:d=E,o?(0,T.join)(o,d):d}e.randomPath=r}),define(oe[65],ae([0,1,27]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(h){return l(h,0)}e.hash=O;function l(h,u){switch(typeof h){case"object":return h===null?A(349,u):Array.isArray(h)?P(h,u):S(h,u);case"string":return k(h,u);case"boolean":return _(h,u);case"number":return A(h,u);case"undefined":return A(937,u);default:return A(617,u)}}e.doHash=l;function A(h,u){return(u<<5)-u+h|0}e.numberHash=A;function _(h,u){return A(h?433:863,u)}function k(h,u){u=A(149417,u);for(let g=0,y=h.length;g<y;g++)u=A(h.charCodeAt(g),u);return u}e.stringHash=k;function P(h,u){return u=A(104579,u),h.reduce((g,y)=>l(y,g),u)}function S(h,u){return u=A(181387,u),Object.keys(h).sort().reduce((g,y)=>(g=k(y,g),l(h[y],g)),u)}class D{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=l(u,this._value),this._value}}e.Hasher=D;var w;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function m(h,u,g=32){const y=g-u,L=~((1<<y)-1);return(h<<u|(L&h)>>>y)>>>0}function f(h,u=0,g=h.byteLength,y=0){for(let L=0;L<g;L++)h[u+L]=y}function p(h,u,g="0"){for(;h.length<u;)h=g+h;return h}function b(h,u=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(g=>g.toString(16).padStart(2,"0")).join(""):p((h>>>0).toString(16),u/4)}e.toHexString=b;class a{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const g=u.length;if(g===0)return;const y=this._buff;let L=this._buffLen,n=this._leftoverHighSurrogate,s,t;for(n!==0?(s=n,t=-1,n=0):(s=u.charCodeAt(0),t=0);;){let i=s;if(T.isHighSurrogate(s))if(t+1<g){const r=u.charCodeAt(t+1);T.isLowSurrogate(r)?(t++,i=T.computeCodePoint(s,r)):i=65533}else{n=s;break}else T.isLowSurrogate(s)&&(i=65533);if(L=this._push(y,L,i),t++,t<g)s=u.charCodeAt(t);else break}this._buffLen=L,this._leftoverHighSurrogate=n}_push(u,g,y){return y<128?u[g++]=y:y<2048?(u[g++]=192|(y&1984)>>>6,u[g++]=128|(y&63)>>>0):y<65536?(u[g++]=224|(y&61440)>>>12,u[g++]=128|(y&4032)>>>6,u[g++]=128|(y&63)>>>0):(u[g++]=240|(y&1835008)>>>18,u[g++]=128|(y&258048)>>>12,u[g++]=128|(y&4032)>>>6,u[g++]=128|(y&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=a._bigBlock32,g=this._buffDV;for(let c=0;c<64;c+=4)u.setUint32(c,g.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)u.setUint32(c,m(u.getUint32(c-12,!1)^u.getUint32(c-32,!1)^u.getUint32(c-56,!1)^u.getUint32(c-64,!1),1),!1);let y=this._h0,L=this._h1,n=this._h2,s=this._h3,t=this._h4,i,r,o;for(let c=0;c<80;c++)c<20?(i=L&n|~L&s,r=1518500249):c<40?(i=L^n^s,r=1859775393):c<60?(i=L&n|L&s|n&s,r=2400959708):(i=L^n^s,r=3395469782),o=m(y,5)+i+t+r+u.getUint32(c*4,!1)&4294967295,t=s,s=n,n=m(L,30),L=y,y=o;this._h0=this._h0+y&4294967295,this._h1=this._h1+L&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=a,a._bigBlock32=new DataView(new ArrayBuffer(320))}),define(oe[90],ae([0,1,27]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(O||(O={})),function(l){const A="error",_="warning",k="warn",P="info",S="ignore";function D(m){return m?T.equalsIgnoreCase(A,m)?l.Error:T.equalsIgnoreCase(_,m)||T.equalsIgnoreCase(k,m)?l.Warning:T.equalsIgnoreCase(P,m)?l.Info:l.Ignore:l.Ignore}l.fromValue=D;function w(m){switch(m){case l.Error:return A;case l.Warning:return _;case l.Info:return P;default:return S}}l.toString=w}(O||(O={})),e.default=O}),define(oe[48],ae([0,1,21,27]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this._value="",this._pos=0}reset(f){return this._value=f,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(f){const p=f.charCodeAt(0),b=this._value.charCodeAt(this._pos);return p-b}value(){return this._value[this._pos]}}e.StringIterator=l;class A{constructor(f=!0){this._caseSensitive=f}reset(f){return this._value=f,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let f=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(f)this._from++;else break;else f=!1;return this}cmp(f){return this._caseSensitive?(0,O.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class _{constructor(f=!0,p=!0){this._splitOnBackslash=f,this._caseSensitive=p}reset(f){this._from=0,this._to=0,this._value=f,this._valueLen=f.length;for(let p=f.length-1;p>=0;p--,this._valueLen--){const b=this._value.charCodeAt(p);if(!(b===47||this._splitOnBackslash&&b===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let f=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(f)this._from++;else break;else f=!1}return this}cmp(f){return this._caseSensitive?(0,O.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var k;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(k||(k={}));class P{constructor(f,p){this._ignorePathCasing=f,this._ignoreQueryAndFragment=p,this._states=[],this._stateIdx=0}reset(f){return this._value=f,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(f)),this._pathIterator.reset(f.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(f)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(f){if(this._states[this._stateIdx]===1)return(0,O.compareIgnoreCase)(f,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,O.compareIgnoreCase)(f,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(f);if(this._states[this._stateIdx]===4)return(0,O.compare)(f,this._value.query);if(this._states[this._stateIdx]===5)return(0,O.compare)(f,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=P;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(D||(D={}));class w{static forUris(f=()=>!1,p=()=>!1){return new w(new P(f,p))}static forPaths(f=!1){return new w(new _(void 0,!f))}static forStrings(){return new w(new l)}static forConfigKeys(){return new w(new A)}constructor(f){this._iter=f}clear(){this._root=void 0}fill(f,p){if(p){const b=p.slice(0);(0,T.shuffle)(b);for(const a of b)this.set(a,f)}else{const b=f.slice(0);(0,T.shuffle)(b);for(const a of b)this.set(a[0],a[1])}}set(f,p){const b=this._iter.reset(f);let a;this._root||(this._root=new S,this._root.segment=b.value());const h=[];for(a=this._root;;){const g=b.cmp(a.segment);if(g>0)a.left||(a.left=new S,a.left.segment=b.value()),h.push([-1,a]),a=a.left;else if(g<0)a.right||(a.right=new S,a.right.segment=b.value()),h.push([1,a]),a=a.right;else if(b.hasNext())b.next(),a.mid||(a.mid=new S,a.mid.segment=b.value()),h.push([0,a]),a=a.mid;else break}const u=a.value;a.value=p,a.key=f;for(let g=h.length-1;g>=0;g--){const y=h[g][1];y.updateHeight();const L=y.balanceFactor();if(L<-1||L>1){const n=h[g][0],s=h[g+1][0];if(n===1&&s===1)h[g][1]=y.rotateLeft();else if(n===-1&&s===-1)h[g][1]=y.rotateRight();else if(n===1&&s===-1)y.right=h[g+1][1]=h[g+1][1].rotateRight(),h[g][1]=y.rotateLeft();else if(n===-1&&s===1)y.left=h[g+1][1]=h[g+1][1].rotateLeft(),h[g][1]=y.rotateRight();else throw new Error;if(g>0)switch(h[g-1][0]){case-1:h[g-1][1].left=h[g][1];break;case 1:h[g-1][1].right=h[g][1];break;case 0:h[g-1][1].mid=h[g][1];break}else this._root=h[0][1]}}return u}get(f){return this._getNode(f)?.value}_getNode(f){const p=this._iter.reset(f);let b=this._root;for(;b;){const a=p.cmp(b.segment);if(a>0)b=b.left;else if(a<0)b=b.right;else if(p.hasNext())p.next(),b=b.mid;else break}return b}has(f){const p=this._getNode(f);return!(p?.value===void 0&&p?.mid===void 0)}delete(f){return this._delete(f,!1)}deleteSuperstr(f){return this._delete(f,!0)}_delete(f,p){const b=this._iter.reset(f),a=[];let h=this._root;for(;h;){const u=b.cmp(h.segment);if(u>0)a.push([-1,h]),h=h.left;else if(u<0)a.push([1,h]),h=h.right;else if(b.hasNext())b.next(),a.push([0,h]),h=h.mid;else break}if(h){if(p?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const u=this._min(h.right);if(u.key){const{key:g,value:y,segment:L}=u;this._delete(u.key,!1),h.key=g,h.value=y,h.segment=L}}else{const u=h.left??h.right;if(a.length>0){const[g,y]=a[a.length-1];switch(g){case-1:y.left=u;break;case 0:y.mid=u;break;case 1:y.right=u;break}}else this._root=u}for(let u=a.length-1;u>=0;u--){const g=a[u][1];g.updateHeight();const y=g.balanceFactor();if(y>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),a[u][1]=g.rotateLeft()):y<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),a[u][1]=g.rotateRight()),u>0)switch(a[u-1][0]){case-1:a[u-1][1].left=a[u][1];break;case 1:a[u-1][1].right=a[u][1];break;case 0:a[u-1][1].mid=a[u][1];break}else this._root=a[0][1]}}}_min(f){for(;f.left;)f=f.left;return f}findSubstr(f){const p=this._iter.reset(f);let b=this._root,a;for(;b;){const h=p.cmp(b.segment);if(h>0)b=b.left;else if(h<0)b=b.right;else if(p.hasNext())p.next(),a=b.value||a,b=b.mid;else break}return b&&b.value||a}findSuperstr(f){return this._findSuperstrOrElement(f,!1)}_findSuperstrOrElement(f,p){const b=this._iter.reset(f);let a=this._root;for(;a;){const h=b.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(b.hasNext())b.next(),a=a.mid;else return a.mid?this._entries(a.mid):p?a.value:void 0}}hasElementOrSubtree(f){return this._findSuperstrOrElement(f,!0)!==void 0}forEach(f){for(const[p,b]of this)f(b,p)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(f){const p=[];return this._dfsEntries(f,p),p[Symbol.iterator]()}_dfsEntries(f,p){f&&(f.left&&this._dfsEntries(f.left,p),f.value&&p.push([f.key,f.value]),f.mid&&this._dfsEntries(f.mid,p),f.right&&this._dfsEntries(f.right,p))}_isBalanced(){const f=p=>{if(!p)return!0;const b=p.balanceFactor();return b<-1||b>1?!1:f(p.left)&&f(p.right)};return f(this._root)}}e.TernarySearchTree=w}),define(oe[12],ae([0,1,14,4]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,A=/^\//,_=/^\/\//;function k(t,i){if(!t.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!l.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!A.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(t,i){return!t&&!i?"file":t}function S(t,i){switch(t){case"https":case"http":case"file":i?i[0]!==w&&(i=w+i):i=w;break}return i}const D="",w="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(i){return i instanceof f?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,o,c,v,E=!1){typeof i=="object"?(this.scheme=i.scheme||D,this.authority=i.authority||D,this.path=i.path||D,this.query=i.query||D,this.fragment=i.fragment||D):(this.scheme=P(i,E),this.authority=r||D,this.path=S(this.scheme,o||D),this.query=c||D,this.fragment=v||D,k(this,E))}get fsPath(){return g(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:o,path:c,query:v,fragment:E}=i;return r===void 0?r=this.scheme:r===null&&(r=D),o===void 0?o=this.authority:o===null&&(o=D),c===void 0?c=this.path:c===null&&(c=D),v===void 0?v=this.query:v===null&&(v=D),E===void 0?E=this.fragment:E===null&&(E=D),r===this.scheme&&o===this.authority&&c===this.path&&v===this.query&&E===this.fragment?this:new b(r,o,c,v,E)}static parse(i,r=!1){const o=m.exec(i);return o?new b(o[2]||D,s(o[4]||D),s(o[5]||D),s(o[7]||D),s(o[9]||D),r):new b(D,D,D,D,D)}static file(i){let r=D;if(O.isWindows&&(i=i.replace(/\\/g,w)),i[0]===w&&i[1]===w){const o=i.indexOf(w,2);o===-1?(r=i.substring(2),i=w):(r=i.substring(2,o),i=i.substring(o)||w)}return new b("file",r,i,D,D)}static from(i){const r=new b(i.scheme,i.authority,i.path,i.query,i.fragment);return k(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return O.isWindows&&i.scheme==="file"?o=f.file(T.win32.join(g(i,!0),...r)).path:o=T.posix.join(i.path,...r),i.with({path:o})}toString(i=!1){return y(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof f)return i;{const r=new b(i);return r._formatted=i.external,r._fsPath=i._sep===p?i.fsPath:null,r}}else return i}}e.URI=f;const p=O.isWindows?1:void 0;class b extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(i=!1){return i?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(t,i,r){let o,c=-1;for(let v=0;v<t.length;v++){const E=t.charCodeAt(v);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||i&&E===47||r&&E===91||r&&E===93||r&&E===58)c!==-1&&(o+=encodeURIComponent(t.substring(c,v)),c=-1),o!==void 0&&(o+=t.charAt(v));else{o===void 0&&(o=t.substr(0,v));const d=a[E];d!==void 0?(c!==-1&&(o+=encodeURIComponent(t.substring(c,v)),c=-1),o+=d):c===-1&&(c=v)}}return c!==-1&&(o+=encodeURIComponent(t.substring(c))),o!==void 0?o:t}function u(t){let i;for(let r=0;r<t.length;r++){const o=t.charCodeAt(r);o===35||o===63?(i===void 0&&(i=t.substr(0,r)),i+=a[o]):i!==void 0&&(i+=t[r])}return i!==void 0?i:t}function g(t,i){let r;return t.authority&&t.path.length>1&&t.scheme==="file"?r=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?i?r=t.path.substr(1):r=t.path[1].toLowerCase()+t.path.substr(2):r=t.path,O.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=g;function y(t,i){const r=i?u:h;let o="",{scheme:c,authority:v,path:E,query:d,fragment:I}=t;if(c&&(o+=c,o+=":"),(v||c==="file")&&(o+=w,o+=w),v){let R=v.indexOf("@");if(R!==-1){const N=v.substr(0,R);v=v.substr(R+1),R=N.lastIndexOf(":"),R===-1?o+=r(N,!1,!1):(o+=r(N.substr(0,R),!1,!1),o+=":",o+=r(N.substr(R+1),!1,!0)),o+="@"}v=v.toLowerCase(),R=v.lastIndexOf(":"),R===-1?o+=r(v,!1,!0):(o+=r(v.substr(0,R),!1,!0),o+=v.substr(R))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const R=E.charCodeAt(1);R>=65&&R<=90&&(E=`/${String.fromCharCode(R+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const R=E.charCodeAt(0);R>=65&&R<=90&&(E=`${String.fromCharCode(R+32)}:${E.substr(2)}`)}o+=r(E,!0,!1)}return d&&(o+="?",o+=r(d,!1,!1)),I&&(o+="#",o+=i?I:h(I,!1,!1)),o}function L(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+L(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(n)?t.replace(n,i=>L(i)):t}}),define(oe[144],ae([0,1,12]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(S){const D=S;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=O;function l(S){const D=[];let w;try{const m=JSON.parse(S.arguments),f=m[m.length-1];f&&f.__$stack&&(m.pop(),w=f.__$stack),D.push(...m)}catch{D.push("Unable to log remote console arguments",S.arguments)}return{args:D,stack:w}}e.parse=l;function A(S){if(typeof S!="string")return A(l(S).stack);const D=S;if(D){const w=_(D),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(m&&m.length===4)return{uri:T.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=A;function _(S){if(!S)return S;const D=S.indexOf(`
`);return D===-1?S:S.substring(0,D)}function k(S,D){const{args:w,stack:m}=l(S),f=typeof w[0]=="string"&&w.length===1;let p=_(m);p&&(p=`(${p.trim()})`);let b=[];if(typeof w[0]=="string"?p&&f?b=[`%c[${D}] %c${w[0]} %c${p}`,P("blue"),P(""),P("grey")]:b=[`%c[${D}] %c${w[0]}`,P("blue"),P(""),...w.slice(1)]:b=[`%c[${D}]%`,P("blue"),...w],p&&!f&&b.push(p),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,b)}e.log=k;function P(S){return`color: ${S}`}}),define(oe[91],ae([0,1,16,27,12]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(S){return JSON.stringify(S,k)}e.stringify=A;function _(S){let D=JSON.parse(S);return D=P(D),D}e.parse=_;function k(S,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,O.regExpFlags)(D)}:D}function P(S,D=0){if(!S||D>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return l.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof T.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let w=0;w<S.length;++w)S[w]=P(S[w],D+1);else for(const w in S)Object.hasOwnProperty.call(S,w)&&(S[w]=P(S[w],D+1))}return S}e.revive=P}),define(oe[22],ae([0,1,9,4,12]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.vscodeInteractiveSesssion="vscode-chat-editor",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}setServerRootPath(D){this._remoteResourcesPath=`${D}/${A.vscodeRemoteResource}`}set(D,w,m){this._hosts[D]=w,this._ports[D]=m}setConnectionToken(D,w){this._connectionTokens[D]=w}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(D){if(this._delegate)try{return this._delegate(D)}catch(a){return T.onUnexpectedError(a),D}const w=D.authority;let m=this._hosts[w];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const f=this._ports[w],p=this._connectionTokens[w];let b=`path=${encodeURIComponent(D.path)}`;return typeof p=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),l.URI.from({scheme:O.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${m}:${f}`,path:this._remoteResourcesPath,query:b})}}e.RemoteAuthorities=new _,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(D){const w=this.toUri(D,ie);return this.uriToBrowserUri(w)}uriToBrowserUri(D){return D.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(D):D.scheme===A.file&&(O.isNative||O.isWebWorker&&O.globals.origin===`${A.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?D.with({scheme:A.vscodeFileResource,authority:D.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):D}asFileUri(D){const w=this.toUri(D,ie);return this.uriToFileUri(w)}uriToFileUri(D){return D.scheme===A.vscodeFileResource?D.with({scheme:A.file,authority:D.authority!==k.FALLBACK_AUTHORITY?D.authority:null,query:null,fragment:null}):D}toUri(D,w){return l.URI.isUri(D)?D:l.URI.parse(w.toUrl(D))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k;var P;(function(S){const D=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(D.get("3"));const w="vscode-coi";function m(p){let b;typeof p=="string"?b=new URL(p).searchParams:p instanceof URL?b=p.searchParams:l.URI.isUri(p)&&(b=new URL(p.toString(!0)).searchParams);const a=b?.get(w);if(a)return D.get(a)}S.getHeadersFromQuery=m;function f(p,b,a){if(!globalThis.crossOriginIsolated)return;const h=b&&a?"3":a?"2":"1";p instanceof URLSearchParams?p.set(w,h):p[w]=h}S.addSearchParam=f})(P||(e.COI=P={}))}),define(oe[23],ae([0,1,47,22,14,4,27,12]),function(ie,e,T,O,l,A,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(f){return(0,k.uriToFsPath)(f,!0)}e.originalFSPath=P;class S{constructor(p){this._ignorePathCasing=p}compare(p,b,a=!1){return p===b?0:(0,_.compare)(this.getComparisonKey(p,a),this.getComparisonKey(b,a))}isEqual(p,b,a=!1){return p===b?!0:!p||!b?!1:this.getComparisonKey(p,a)===this.getComparisonKey(b,a)}getComparisonKey(p,b=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,b,a=!1){if(p.scheme===b.scheme){if(p.scheme===O.Schemas.file)return T.isEqualOrParent(P(p),P(b),this._ignorePathCasing(p))&&p.query===b.query&&(a||p.fragment===b.fragment);if((0,e.isEqualAuthority)(p.authority,b.authority))return T.isEqualOrParent(p.path,b.path,this._ignorePathCasing(p),"/")&&p.query===b.query&&(a||p.fragment===b.fragment)}return!1}joinPath(p,...b){return k.URI.joinPath(p,...b)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return l.posix.basename(p.path)}extname(p){return l.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let b;return p.scheme===O.Schemas.file?b=k.URI.file(l.dirname(P(p))).path:(b=l.posix.dirname(p.path),p.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),b="/")),p.with({path:b})}normalizePath(p){if(!p.path.length)return p;let b;return p.scheme===O.Schemas.file?b=k.URI.file(l.normalize(P(p))).path:b=l.posix.normalize(p.path),p.with({path:b})}relativePath(p,b){if(p.scheme!==b.scheme||!(0,e.isEqualAuthority)(p.authority,b.authority))return;if(p.scheme===O.Schemas.file){const u=l.relative(P(p),P(b));return A.isWindows?T.toSlashes(u):u}let a=p.path||"/";const h=b.path||"/";if(this._ignorePathCasing(p)){let u=0;for(const g=Math.min(a.length,h.length);u<g&&!(a.charCodeAt(u)!==h.charCodeAt(u)&&a.charAt(u).toLowerCase()!==h.charAt(u).toLowerCase());u++);a=h.substr(0,u)+a.substr(u)}return l.posix.relative(a,h)}resolvePath(p,b){if(p.scheme===O.Schemas.file){const a=k.URI.file(l.resolve(P(p),b));return p.with({authority:a.authority,path:a.path})}return b=T.toPosixPath(b),p.with({path:l.posix.resolve(p.path,b)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,b){return p===b||p!==void 0&&b!==void 0&&(0,_.equalsIgnoreCase)(p,b)}hasTrailingPathSeparator(p,b=l.sep){if(p.scheme===O.Schemas.file){const a=P(p);return a.length>T.getRoot(a).length&&a[a.length-1]===b}else{const a=p.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,b=l.sep){return(0,e.hasTrailingPathSeparator)(p,b)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,b=l.sep){let a=!1;if(p.scheme===O.Schemas.file){const h=P(p);a=h!==void 0&&h.length===T.getRoot(h).length&&h[h.length-1]===b}else{b="/";const h=p.path;a=h.length===1&&h.charCodeAt(h.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(p,b)?p.with({path:p.path+"/"}):p}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(f=>f.scheme===O.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new S(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(f,p){const b=[];for(let a=0;a<f.length;a++){const h=p(f[a]);f.some((u,g)=>g===a?!1:(0,e.isEqualOrParent)(h,p(u)))||b.push(f[a])}return b}e.distinctParents=D;var w;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function p(b){const a=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(g=>{const[y,L]=g.split(":");y&&L&&a.set(y,L)});const u=b.path.substring(0,b.path.indexOf(";"));return u&&a.set(f.META_DATA_MIME,u),a}f.parseMetaData=p})(w||(e.DataUri=w={}));function m(f,p,b){if(p){let a=f.path;return a&&a[0]!==l.posix.sep&&(a=l.posix.sep+a),f.with({scheme:b,authority:p,path:a})}return f.with({scheme:b})}e.toLocalResource=m}),define(oe[6],ae([0,1,26,9,3,2,23,4,132]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(G){return!!G&&typeof G.then=="function"}e.isThenable=S;function D(G){const M=new T.CancellationTokenSource,C=G(M.token),U=new Promise((z,H)=>{const V=M.token.onCancellationRequested(()=>{V.dispose(),M.dispose(),H(new O.CancellationError)});Promise.resolve(C).then(X=>{V.dispose(),M.dispose(),z(X)},X=>{V.dispose(),M.dispose(),H(X)})});return new class{cancel(){M.cancel()}then(z,H){return U.then(z,H)}catch(z){return this.then(void 0,z)}finally(z){return U.finally(z)}}}e.createCancelablePromise=D;function w(G,M,C){return new Promise((U,z)=>{const H=M.onCancellationRequested(()=>{H.dispose(),U(C)});G.then(U,z).finally(()=>H.dispose())})}e.raceCancellation=w;function m(G,M){return new Promise((C,U)=>{const z=M.onCancellationRequested(()=>{z.dispose(),U(new O.CancellationError)});G.then(C,U).finally(()=>z.dispose())})}e.raceCancellationError=m;async function f(G){let M=-1;const C=G.map((U,z)=>U.then(H=>(M=z,H)));try{return await Promise.race(C)}finally{G.forEach((U,z)=>{z!==M&&U.cancel()})}}e.raceCancellablePromises=f;function p(G,M,C){let U;const z=setTimeout(()=>{U?.(void 0),C?.()},M);return Promise.race([G.finally(()=>clearTimeout(z)),new Promise(H=>U=H)])}e.raceTimeout=p;function b(G){return new Promise((M,C)=>{const U=G();S(U)?U.then(M,C):M(U)})}e.asPromise=b;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const C=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(C,C).then(U)})}return new Promise((C,U)=>{this.queuedPromise.then(C,U)})}return this.activePromise=M(),new Promise((C,U)=>{this.activePromise.then(z=>{this.activePromise=null,C(z)},z=>{this.activePromise=null,U(z)})})}}e.Throttler=a;class h{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=h;class u{constructor(){this.promiseMap=new Map}queue(M,C){const z=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(C).finally(()=>{this.promiseMap.get(M)===z&&this.promiseMap.delete(M)});return this.promiseMap.set(M,z),z}}e.SequencerByKey=u;const g=(G,M)=>{let C=!0;const U=setTimeout(()=>{C=!1,M()},G);return{isTriggered:()=>C,dispose:()=>{clearTimeout(U),C=!1}}},y=G=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,G())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class L{constructor(M){this.defaultDelay=M,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,C=this.defaultDelay){this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,H)=>{this.doResolve=z,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}}));const U=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=C===P.MicrotaskDelay?y(U):g(C,U),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new O.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=L;class n{constructor(M){this.delayer=new L(M),this.throttler=new a}trigger(M,C){return this.delayer.trigger(()=>this.throttler.queue(M),C)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=n;class s{constructor(){this._isOpen=!1,this._promise=new Promise((M,C)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class t extends s{constructor(M){super(),this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=t;function i(G,M){return M?new Promise((C,U)=>{const z=setTimeout(()=>{H.dispose(),C()},G),H=M.onCancellationRequested(()=>{clearTimeout(z),H.dispose(),U(new O.CancellationError)})}):D(C=>i(G,C))}e.timeout=i;function r(G,M=0){const C=setTimeout(G,M);return(0,A.toDisposable)(()=>clearTimeout(C))}e.disposableTimeout=r;function o(G){const M=[];let C=0;const U=G.length;function z(){return C<U?G[C++]():null}function H(V){V!=null&&M.push(V);const X=z();return X?X.then(H):Promise.resolve(M)}return Promise.resolve(null).then(H)}e.sequence=o;function c(G,M=U=>!!U,C=null){let U=0;const z=G.length,H=()=>{if(U>=z)return Promise.resolve(C);const V=G[U++];return Promise.resolve(V()).then(ee=>M(ee)?Promise.resolve(ee):H())};return H()}e.first=c;function v(G,M=U=>!!U,C=null){if(G.length===0)return Promise.resolve(C);let U=G.length;const z=()=>{U=-1;for(const H of G)H.cancel?.()};return new Promise((H,V)=>{for(const X of G)X.then(ee=>{--U>=0&&M(ee)?(z(),H(ee)):U===0&&H(C)}).catch(ee=>{--U>=0&&(z(),V(ee))})})}e.firstParallel=v;class E{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new l.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(M){return this._size++,new Promise((C,U)=>{this.outstandingPromises.push({factory:M,c:C,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const C=M.factory();C.then(M.c,M.e),C.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=E;class d extends E{constructor(){super(1)}}e.Queue=d;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const M=new $;return this.drainers.add(M),M.p}isDrained(){for(const[,M]of this.queues)if(M.size>0)return!1;return!0}queueFor(M,C=_.extUri){const U=C.getComparisonKey(M);let z=this.queues.get(U);return z||(z=new d,l.Event.once(z.onDrained)(()=>{z?.dispose(),this.queues.delete(U),this.onDidQueueDrain()}),this.queues.set(U,z)),z}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const M of this.drainers)M.complete();this.drainers.clear()}dispose(){for(const[,M]of this.queues)M.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class R{constructor(M,C){this._token=-1,typeof M=="function"&&typeof C=="number"&&this.setIfNotSet(M,C)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,C){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},C)}setIfNotSet(M,C){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},C))}}e.TimeoutTimer=R;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,C){this.cancel(),this._token=setInterval(()=>{M()},C)}}e.IntervalTimer=N;class F{constructor(M,C){this.timeoutToken=-1,this.runner=M,this.timeout=C,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=F;class W{constructor(M,C){C%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.runner=M,this.timeout=C,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(M=this.timeout){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(M/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=W;class q extends F{constructor(M,C){super(M,C),this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner?.(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=q;class B extends A.Disposable{constructor(M,C){super(),this.options=M,this.handler=C,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.options.maxBufferedWork)return!1}else if(this.pending+M.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const C of M)this.pendingWork.push(C);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=G=>{(0,k.setTimeout0)(()=>{if(M)return;const C=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.runWhenIdle=(G,M)=>{const C=requestIdleCallback(G,typeof M=="number"?{timeout:M}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(C))}}}}();class Q{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(C){this._error=C}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=Q;async function Z(G,M,C){let U;for(let z=0;z<C;z++)try{return await G()}catch(H){U=H,await i(M)}throw U}e.retry=Z;class K{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(M,C,U){return this._pending={taskId:M,cancel:()=>U?.(),promise:C},C.then(()=>this.donePending(M),()=>this.donePending(M)),C}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let C,U;const z=new Promise((H,V)=>{C=H,U=V});this._next={run:M,promise:z,promiseResolve:C,promiseReject:U}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=K;class x{constructor(M,C=()=>Date.now()){this.interval=M,this.nowFn=C,this.lastIncrementTime=0,this.value=0}increment(){const M=this.nowFn();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class ${get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,C)=>{this.completeCallback=M,this.errorCallback=C})}complete(M){return new Promise(C=>{this.completeCallback(M),this.resolved=!0,C()})}error(M){return new Promise(C=>{this.errorCallback(M),this.rejected=!0,C()})}cancel(){new Promise(M=>{this.errorCallback(new O.CancellationError),this.rejected=!0,M()})}}e.DeferredPromise=$;var j;(function(G){async function M(U){let z;const H=await Promise.all(U.map(V=>V.then(X=>X,X=>{z||(z=X)})));if(typeof z<"u")throw z;return H}G.settled=M;function C(U){return new Promise(async(z,H)=>{try{await U(z,H)}catch(V){H(V)}})}G.withAsyncBody=C})(j||(e.Promises=j={}));var te;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(te||(te={}));class ne{static fromArray(M){return new ne(C=>{C.emitMany(M)})}static fromPromise(M){return new ne(async C=>{C.emitMany(await M)})}static fromPromises(M){return new ne(async C=>{await Promise.all(M.map(async U=>C.emitOne(await U)))})}static merge(M){return new ne(async C=>{await Promise.all(M.map(async U=>{for await(const z of U)C.emitOne(z)}))})}constructor(M){this._state=0,this._results=[],this._error=null,this._onStateChanged=new l.Emitter,queueMicrotask(async()=>{const C={emitOne:U=>this.emitOne(U),emitMany:U=>this.emitMany(U),reject:U=>this.reject(U)};try{await Promise.resolve(M(C)),this.resolve()}catch(U){this.reject(U)}finally{C.emitOne=void 0,C.emitMany=void 0,C.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(M<this._results.length)return{done:!1,value:this._results[M++]};if(this._state===1)return{done:!0,value:void 0};await l.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(M,C){return new ne(async U=>{for await(const z of M)U.emitOne(C(z))})}map(M){return ne.map(this,M)}static filter(M,C){return new ne(async U=>{for await(const z of M)C(z)&&U.emitOne(z)})}filter(M){return ne.filter(this,M)}static coalesce(M){return ne.filter(M,C=>!!C)}coalesce(){return ne.coalesce(this)}static async toPromise(M){const C=[];for await(const U of M)C.push(U);return C}toPromise(){return ne.toPromise(this)}emitOne(M){this._state===0&&(this._results.push(M),this._onStateChanged.fire())}emitMany(M){this._state===0&&(this._results=this._results.concat(M),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(M){this._state===0&&(this._state=2,this._error=M,this._onStateChanged.fire())}}e.AsyncIterableObject=ne,ne.EMPTY=ne.fromArray([]);class se extends ne{constructor(M,C){super(C),this._source=M}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function J(G){const M=new T.CancellationTokenSource,C=G(M.token);return new se(M,async U=>{const z=M.token.onCancellationRequested(()=>{z.dispose(),M.dispose(),U.reject(new O.CancellationError)});try{for await(const H of C){if(M.token.isCancellationRequested)return;U.emitOne(H)}z.dispose(),M.dispose()}catch(H){z.dispose(),M.dispose(),U.reject(H)}})}e.createCancelableAsyncIterable=J}),define(oe[92],ae([0,1,21,6,47,37,14,4,27]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const D="[/\\\\]",w="[^/\\\\]",m=/\//g;function f(x,$){switch(x){case 0:return"";case 1:return`${w}*?`;default:return`(?:${D}|${w}+${D}${$?`|${D}${w}+`:""})*?`}}function p(x,$){if(!x)return[];const j=[];let te=!1,ne=!1,se="";for(const J of x){switch(J){case $:if(!te&&!ne){j.push(se),se="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}se+=J}return se&&j.push(se),j}e.splitGlobAware=p;function b(x){if(!x)return"";let $="";const j=p(x,e.GLOB_SPLIT);if(j.every(te=>te===e.GLOBSTAR))$=".*";else{let te=!1;j.forEach((ne,se)=>{if(ne===e.GLOBSTAR){if(te)return;$+=f(2,se===j.length-1)}else{let J=!1,G="",M=!1,C="";for(const U of ne){if(U!=="}"&&J){G+=U;continue}if(M&&(U!=="]"||!C)){let z;U==="-"?z=U:(U==="^"||U==="!")&&!C?z="^":U===e.GLOB_SPLIT?z="":z=(0,P.escapeRegExpCharacters)(U),C+=z;continue}switch(U){case"{":J=!0;continue;case"[":M=!0;continue;case"}":{const H=`(?:${p(G,",").map(V=>b(V)).join("|")})`;$+=H,J=!1,G="";break}case"]":{$+="["+C+"]",M=!1,C="";break}case"?":$+=w;continue;case"*":$+=f(1);continue;default:$+=(0,P.escapeRegExpCharacters)(U)}}se<j.length-1&&(j[se+1]!==e.GLOBSTAR||se+2<j.length)&&($+=D)}te=ne===e.GLOBSTAR})}return $}const a=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,L=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new A.LRUCache(1e4),s=function(){return!1},t=function(){return null};function i(x,$){if(!x)return t;let j;typeof x!="string"?j=x.pattern:j=x,j=j.trim();const te=`${j}_${!!$.trimForExclusions}`;let ne=n.get(te);if(ne)return r(ne,x);let se;return a.test(j)?ne=c(j.substr(4),j):(se=h.exec(o(j,$)))?ne=v(se[1],j):($.trimForExclusions?g:u).test(j)?ne=E(j,$):(se=y.exec(o(j,$)))?ne=d(se[1].substr(1),j,!0):(se=L.exec(o(j,$)))?ne=d(se[1],j,!1):ne=I(j),n.set(te,ne),r(ne,x)}function r(x,$){if(typeof $=="string")return x;const j=function(te,ne){return(0,l.isEqualOrParent)(te,$.base,!k.isLinux)?x((0,P.ltrim)(te.substr($.base.length),_.sep),ne):null};return j.allBasenames=x.allBasenames,j.allPaths=x.allPaths,j.basenames=x.basenames,j.patterns=x.patterns,j}function o(x,$){return $.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function c(x,$){return function(j,te){return typeof j=="string"&&j.endsWith(x)?$:null}}function v(x,$){const j=`/${x}`,te=`\\${x}`,ne=function(J,G){return typeof J!="string"?null:G?G===x?$:null:J===x||J.endsWith(j)||J.endsWith(te)?$:null},se=[x];return ne.basenames=se,ne.patterns=[$],ne.allBasenames=se,ne}function E(x,$){const j=Z(x.slice(1,-1).split(",").map(G=>i(G,$)).filter(G=>G!==t),x),te=j.length;if(!te)return t;if(te===1)return j[0];const ne=function(G,M){for(let C=0,U=j.length;C<U;C++)if(j[C](G,M))return x;return null},se=j.find(G=>!!G.allBasenames);se&&(ne.allBasenames=se.allBasenames);const J=j.reduce((G,M)=>M.allPaths?G.concat(M.allPaths):G,[]);return J.length&&(ne.allPaths=J),ne}function d(x,$,j){const te=_.sep===_.posix.sep,ne=te?x:x.replace(m,_.sep),se=_.sep+ne,J=_.posix.sep+x;let G;return j?G=function(M,C){return typeof M=="string"&&(M===ne||M.endsWith(se)||!te&&(M===x||M.endsWith(J)))?$:null}:G=function(M,C){return typeof M=="string"&&(M===ne||!te&&M===x)?$:null},G.allPaths=[(j?"*/":"./")+x],G}function I(x){try{const $=new RegExp(`^${b(x)}$`);return function(j){return $.lastIndex=0,typeof j=="string"&&$.test(j)?x:null}}catch{return t}}function R(x,$,j){return!x||typeof $!="string"?!1:N(x)($,void 0,j)}e.match=R;function N(x,$={}){if(!x)return s;if(typeof x=="string"||F(x)){const j=i(x,$);if(j===t)return s;const te=function(ne,se){return!!j(ne,se)};return j.allBasenames&&(te.allBasenames=j.allBasenames),j.allPaths&&(te.allPaths=j.allPaths),te}return B(x,$)}e.parse=N;function F(x){const $=x;return $?typeof $.base=="string"&&typeof $.pattern=="string":!1}e.isRelativePattern=F;function W(x){return x.allBasenames||[]}e.getBasenameTerms=W;function q(x){return x.allPaths||[]}e.getPathTerms=q;function B(x,$){const j=Z(Object.getOwnPropertyNames(x).map(G=>Q(G,x[G],$)).filter(G=>G!==t)),te=j.length;if(!te)return t;if(!j.some(G=>!!G.requiresSiblings)){if(te===1)return j[0];const G=function(U,z){let H;for(let V=0,X=j.length;V<X;V++){const ee=j[V](U,z);if(typeof ee=="string")return ee;(0,O.isThenable)(ee)&&(H||(H=[]),H.push(ee))}return H?(async()=>{for(const V of H){const X=await V;if(typeof X=="string")return X}return null})():null},M=j.find(U=>!!U.allBasenames);M&&(G.allBasenames=M.allBasenames);const C=j.reduce((U,z)=>z.allPaths?U.concat(z.allPaths):U,[]);return C.length&&(G.allPaths=C),G}const ne=function(G,M,C){let U,z;for(let H=0,V=j.length;H<V;H++){const X=j[H];X.requiresSiblings&&C&&(M||(M=(0,_.basename)(G)),U||(U=M.substr(0,M.length-(0,_.extname)(G).length)));const ee=X(G,M,U,C);if(typeof ee=="string")return ee;(0,O.isThenable)(ee)&&(z||(z=[]),z.push(ee))}return z?(async()=>{for(const H of z){const V=await H;if(typeof V=="string")return V}return null})():null},se=j.find(G=>!!G.allBasenames);se&&(ne.allBasenames=se.allBasenames);const J=j.reduce((G,M)=>M.allPaths?G.concat(M.allPaths):G,[]);return J.length&&(ne.allPaths=J),ne}function Q(x,$,j){if($===!1)return t;const te=i(x,j);if(te===t)return t;if(typeof $=="boolean")return te;if($){const ne=$.when;if(typeof ne=="string"){const se=(J,G,M,C)=>{if(!C||!te(J,G))return null;const U=ne.replace("$(basename)",()=>M),z=C(U);return(0,O.isThenable)(z)?z.then(H=>H?x:null):z?x:null};return se.requiresSiblings=!0,se}}return te}function Z(x,$){const j=x.filter(G=>!!G.basenames);if(j.length<2)return x;const te=j.reduce((G,M)=>{const C=M.basenames;return C?G.concat(C):G},[]);let ne;if($){ne=[];for(let G=0,M=te.length;G<M;G++)ne.push($)}else ne=j.reduce((G,M)=>{const C=M.patterns;return C?G.concat(C):G},[]);const se=function(G,M){if(typeof G!="string")return null;if(!M){let U;for(U=G.length;U>0;U--){const z=G.charCodeAt(U-1);if(z===47||z===92)break}M=G.substr(U)}const C=te.indexOf(M);return C!==-1?ne[C]:null};se.basenames=te,se.patterns=ne,se.allBasenames=te;const J=x.filter(G=>!G.basenames);return J.push(se),J}function K(x,$){return(0,T.equals)(x,$,(j,te)=>typeof j=="string"&&typeof te=="string"?j===te:typeof j!="string"&&typeof te!="string"?j.base===te.base&&j.pattern===te.pattern:!1)}e.patternsEquals=K}),define(oe[93],ae([0,1,16,12]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(w){return w.toJSON()}class A{constructor(m){this._uriTransformer=m}transformIncoming(m){const f=this._uriTransformer.transformIncoming(m);return f===m?m:l(O.URI.from(f))}transformOutgoing(m){const f=this._uriTransformer.transformOutgoing(m);return f===m?m:l(O.URI.from(f))}transformOutgoingURI(m){const f=this._uriTransformer.transformOutgoing(m);return f===m?m:O.URI.from(f)}transformOutgoingScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function _(w,m,f){if(!w||f>200)return null;if(typeof w=="object"){if(w instanceof O.URI)return m.transformOutgoing(w);for(const p in w)if(Object.hasOwnProperty.call(w,p)){const b=_(w[p],m,f+1);b!==null&&(w[p]=b)}}return null}function k(w,m){const f=_(w,m,0);return f===null?w:f}e.transformOutgoingURIs=k;function P(w,m,f,p){if(!w||p>200)return null;if(typeof w=="object"){if(w.$mid===1)return f?O.URI.revive(m.transformIncoming(w)):m.transformIncoming(w);if(w instanceof T.VSBuffer)return null;for(const b in w)if(Object.hasOwnProperty.call(w,b)){const a=P(w[b],m,f,p+1);a!==null&&(w[b]=a)}}return null}function S(w,m){const f=P(w,m,!1,0);return f===null?w:f}e.transformIncomingURIs=S;function D(w,m){const f=P(w,m,!0,0);return f===null?w:f}e.transformAndReviveIncomingURIs=D}),define(oe[145],ae([0,1,34,48,32,134]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(S){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(S)}value(){if(this._value===void 0){let S=0,D=0;const w=(0,T.networkInterfaces)();for(const m in w){const f=w[m];if(f)for(const{mac:p,internal:b}of f)b||(D+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(S+=1))}this._value=D>0?S/D:0}return this._value}};let _;async function k(S){return _||(_=(async()=>await P(S)||l.generateUuid())()),_}e.getMachineId=k;async function P(S){try{const D=await new Promise((m,f)=>{ie(["crypto"],m,f)}),w=(0,A.getMac)();return D.createHash("sha256").update(w,"utf8").digest("hex")}catch(D){S(D);return}}}),define(oe[28],ae([0,1,53,34,283,6,47,87,14,4,23,12]),function(ie,e,T,O,l,A,_,k,P,S,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function f(B,Q=m.UNLINK){if((0,_.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return Q===m.UNLINK?b(B):p(B)}async function p(B){try{const Q=(0,_.randomPath)((0,O.tmpdir)());try{await T.promises.rename(B,Q)}catch(Z){return Z.code==="ENOENT"?void 0:b(B)}b(Q).catch(Z=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function b(B){return(0,l.promisify)(T.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function a(B){if((0,_.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");T.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function h(B,Q){return y(await(Q?u(B):(0,l.promisify)(T.readdir)(B)))}async function u(B){try{return await(0,l.promisify)(T.readdir)(B,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const Q=[],Z=await h(B);for(const K of Z){let x=!1,$=!1,j=!1;try{const te=await e.Promises.lstat((0,P.join)(B,K));x=te.isFile(),$=te.isDirectory(),j=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}Q.push({name:K,isFile:()=>x,isDirectory:()=>$,isSymbolicLink:()=>j})}return Q}function g(B){return y(T.readdirSync(B))}e.readdirSync=g;function y(B){return B.map(Q=>typeof Q=="string"?S.isMacintosh?(0,k.normalizeNFC)(Q):Q:(Q.name=S.isMacintosh?(0,k.normalizeNFC)(Q.name):Q.name,Q))}async function L(B){const Q=await h(B),Z=[];for(const K of Q)await s.existsDirectory((0,P.join)(B,K))&&Z.push(K);return Z}function n(B,Q=1e3){return new Promise(Z=>{let K=!1;const x=setInterval(()=>{K||(K=!0,T.access(B,$=>{K=!1,$&&(clearInterval(x),Z(void 0))}))},Q)})}e.whenDeleted=n;var s;(function(B){async function Q(x){let $;try{if($=await e.Promises.lstat(x),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(S.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw te}throw j}}B.stat=Q;async function Z(x){try{const{stat:$,symbolicLink:j}=await B.stat(x);return $.isFile()&&j?.dangling!==!0}catch{}return!1}B.existsFile=Z;async function K(x){try{const{stat:$,symbolicLink:j}=await B.stat(x);return $.isDirectory()&&j?.dangling!==!0}catch{}return!1}B.existsDirectory=K})(s||(e.SymlinkSupport=s={}));const t=new A.ResourceQueue;function i(B,Q,Z){return t.queueFor(w.URI.file(B),D.extUriBiasedIgnorePathCase).queue(()=>{const K=E(Z);return new Promise((x,$)=>c(B,Q,K,j=>j?$(j):x()))})}let r=!0;function o(B){r=B}e.configureFlushOnWrite=o;function c(B,Q,Z,K){if(!r)return T.writeFile(B,Q,{mode:Z.mode,flag:Z.flag},K);T.open(B,Z.flag,Z.mode,(x,$)=>{if(x)return K(x);T.writeFile($,Q,j=>{if(j)return T.close($,()=>K(j));T.fdatasync($,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),o(!1)),T.close($,ne=>K(ne))))})})}function v(B,Q,Z){const K=E(Z);if(!r)return T.writeFileSync(B,Q,{mode:K.mode,flag:K.flag});const x=T.openSync(B,K.flag,K.mode);try{T.writeFileSync(x,Q);try{T.fdatasyncSync(x)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),o(!1)}}finally{T.closeSync(x)}}e.writeFileSync=v;function E(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function d(B,Q){if(B!==Q)try{await e.Promises.rename(B,Q)}catch(Z){if(B.toLowerCase()!==Q.toLowerCase()&&Z.code==="EXDEV"||B.endsWith("."))await I(B,Q,{preserveSymlinks:!1}),await f(B,m.MOVE);else throw Z}}async function I(B,Q,Z){return N(B,Q,{root:{source:B,target:Q},options:Z,handledSourcePaths:new Set})}const R=511;async function N(B,Q,Z){if(Z.handledSourcePaths.has(B))return;Z.handledSourcePaths.add(B);const{stat:K,symbolicLink:x}=await s.stat(B);if(x){if(Z.options.preserveSymlinks)try{return await q(B,Q,Z)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(x.dangling)return}return K.isDirectory()?F(B,Q,K.mode&R,Z):W(B,Q,K.mode&R)}async function F(B,Q,Z,K){await e.Promises.mkdir(Q,{recursive:!0,mode:Z});const x=await h(B);for(const $ of x)await N((0,P.join)(B,$),(0,P.join)(Q,$),K)}async function W(B,Q,Z){await e.Promises.copyFile(B,Q),await e.Promises.chmod(Q,Z)}async function q(B,Q,Z){let K=await e.Promises.readlink(B);(0,_.isEqualOrParent)(K,Z.root.source,!S.isLinux)&&(K=(0,P.join)(Z.root.target,K.substr(Z.root.source.length+1))),await e.Promises.symlink(K,Q)}e.Promises=new class{get access(){return(0,l.promisify)(T.access)}get stat(){return(0,l.promisify)(T.stat)}get lstat(){return(0,l.promisify)(T.lstat)}get utimes(){return(0,l.promisify)(T.utimes)}get read(){return(B,Q,Z,K,x)=>new Promise(($,j)=>{T.read(B,Q,Z,K,x,(te,ne,se)=>te?j(te):$({bytesRead:ne,buffer:se}))})}get readFile(){return(0,l.promisify)(T.readFile)}get write(){return(B,Q,Z,K,x)=>new Promise(($,j)=>{T.write(B,Q,Z,K,x,(te,ne,se)=>te?j(te):$({bytesWritten:ne,buffer:se}))})}get appendFile(){return(0,l.promisify)(T.appendFile)}get fdatasync(){return(0,l.promisify)(T.fdatasync)}get truncate(){return(0,l.promisify)(T.truncate)}get rename(){return(0,l.promisify)(T.rename)}get copyFile(){return(0,l.promisify)(T.copyFile)}get open(){return(0,l.promisify)(T.open)}get close(){return(0,l.promisify)(T.close)}get symlink(){return(0,l.promisify)(T.symlink)}get readlink(){return(0,l.promisify)(T.readlink)}get chmod(){return(0,l.promisify)(T.chmod)}get mkdir(){return(0,l.promisify)(T.mkdir)}get unlink(){return(0,l.promisify)(T.unlink)}get rmdir(){return(0,l.promisify)(T.rmdir)}get realpath(){return(0,l.promisify)(T.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return L}get writeFile(){return i}get rm(){return f}get move(){return d}get copy(){return I}}}),define(oe[146],ae([0,1,53,14,4,27,28]),function(ie,e,T,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(m){if(l.isLinux)return m;const f=(0,O.dirname)(m);if(m===f)return m;const p=((0,O.basename)(m)||m).toLowerCase();try{const a=(0,_.readdirSync)(f).filter(h=>h.toLowerCase()===p);if(a.length===1){const h=k(f);if(h)return(0,O.join)(h,a[0])}else if(a.length>1){const h=a.indexOf(p);if(h>=0){const u=k(f);if(u)return(0,O.join)(u,a[h])}}}catch{}return null}e.realcaseSync=k;async function P(m){if(l.isLinux)return m;const f=(0,O.dirname)(m);if(m===f)return m;const p=((0,O.basename)(m)||m).toLowerCase();try{const a=(await _.Promises.readdir(f)).filter(h=>h.toLowerCase()===p);if(a.length===1){const h=await P(f);if(h)return(0,O.join)(h,a[0])}else if(a.length>1){const h=a.indexOf(p);if(h>=0){const u=await P(f);if(u)return(0,O.join)(u,a[h])}}}catch{}return null}e.realcase=P;async function S(m){try{return await _.Promises.realpath(m)}catch{const p=w(m);return await _.Promises.access(p,T.constants.R_OK),p}}e.realpath=S;function D(m){try{return T.realpathSync(m)}catch{const p=w(m);return T.accessSync(p,T.constants.R_OK),p}}e.realpathSync=D;function w(m){return(0,A.rtrim)((0,O.normalize)(m),O.sep)}}),define(oe[94],ae([0,1,34,14,28]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,_=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var P;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(P||(P={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class w{constructor(L,n,s){this.exePath=L,this.displayName=n,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await l.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:y=!1}={}){return y?S===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:y=!1,findPreview:L=!1}={}){const n=m({useAlternateBitness:y});if(!n)return null;const s=O.join(n,"PowerShell");if(!await l.SymlinkSupport.existsDirectory(s))return null;let t=-1,i=null;for(const c of await l.Promises.readdir(s)){let v=-1;if(L){const d=c.indexOf("-");if(d<0)continue;const I=c.substring(0,d);if(!A.test(I)||c.substring(d+1)!=="preview")continue;v=parseInt(I,10)}else{if(!A.test(c))continue;v=parseInt(c,10)}if(v<=t)continue;const E=O.join(s,c,"pwsh.exe");await l.SymlinkSupport.existsFile(E)&&(i=E,t=v)}if(!i)return null;const r=n.includes("x86")?" (x86)":"",o=L?" Preview":"";return new w(i,`PowerShell${o}${r}`,!0)}async function p({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const L=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await l.SymlinkSupport.existsDirectory(L))return null;const{pwshMsixDirRegex:n,pwshMsixName:s}=y?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:_,pwshMsixName:"PowerShell (Store)"};for(const t of await l.Promises.readdir(L))if(n.test(t)){const i=O.join(L,t,"pwsh.exe");return new w(i,s)}return null}function b(){const y=O.join(T.homedir(),".dotnet","tools","pwsh.exe");return new w(y,".NET Core PowerShell Global Tool")}function a(){const y=O.join(process.env.windir,S===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(y,"Windows PowerShell",!0)}async function*h(){let y=await f();y&&(yield y),y=await f({useAlternateBitness:!0}),y&&(yield y),y=await p(),y&&(yield y),y=b(),y&&(yield y),y=await f({findPreview:!0}),y&&(yield y),y=await p({findPreview:!0}),y&&(yield y),y=await f({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=a(),y&&(yield y)}async function*u(){for await(const y of h())await y.exists()&&(yield y)}e.enumeratePowerShellInstallations=u;async function g(){for await(const y of u())return y;return null}e.getFirstAvailablePowerShellInstallation=g}),define(oe[95],ae([0,1,14,4,36,88,11,28]),function(ie,e,T,O,l,A,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function P(w=l.env){return w.comspec||"cmd.exe"}e.getWindowsShell=P;function S(w){let m=[],f=!1;const p=function(b){if(f){m.push(b);return}(!w.send(b,h=>{if(h&&console.error(h),f=!1,m.length>0){const u=m.slice(0);m=[],u.forEach(g=>p(g))}})||O.isWindows)&&(f=!0)};return{send:p}}e.createQueuedSender=S;var D;(function(w){async function m(f,p,b){if(T.isAbsolute(f))return f;if(p===void 0&&(p=l.cwd()),T.dirname(f)!=="."||(b===void 0&&_.isString(l.env.PATH)&&(b=l.env.PATH.split(T.delimiter)),b===void 0||b.length===0))return T.join(p,f);async function h(u){if(await k.Promises.exists(u)){let g;try{g=await k.Promises.stat(u)}catch(y){y.message.startsWith("EACCES")&&(g=await k.Promises.lstat(u))}return g?!g.isDirectory():!1}return!1}for(const u of b){let g;if(T.isAbsolute(u)?g=T.join(u,f):g=T.join(p,u,f),await h(g))return g;let y=g+".com";if(await h(y)||(y=g+".exe",await h(y)))return y}return T.join(p,f)}w.findExecutable=m})(D||(e.win32=D={}))}),define(oe[147],ae([0,1,49,22]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function l(_){return new Promise((k,P)=>{let S;const D=new Map;function w(f,p,b,a,h){const u=D.get(p);if(f===_||u){const g={name:m(b),cmd:b,pid:f,ppid:p,load:a,mem:h};D.set(f,g),f===_&&(S=g),u&&(u.children||(u.children=[]),u.children.push(g),u.children.length>1&&(u.children=u.children.sort((y,L)=>y.pid-L.pid)))}}function m(f){const p=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,a=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,u=/conhost\.exe/i,g=/--type=([a-zA-Z-]+)/;if(a.exec(f))return"electron-crash-reporter";if(h.exec(f))return"winpty-process";if(u.exec(f))return"console-window-host (Windows internal process)";let y=g.exec(f);if(y&&y.length===2)return y[1]==="renderer"?"window":y[1]==="utility"?p.exec(f)?"utility-network-service":"utility-process":y[1]==="extensionHost"?"extension-host":y[1];const L=/[a-zA-Z-]+\.js/g;let n="";do y=L.exec(f),y&&(n+=y+" ");while(y);return n&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${n})`:b.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,b)=>{ie(["@vscode/windows-process-tree"],p,b)}).then(p=>{p.getProcessList(_,b=>{if(!b){P(new Error(`Root process ${_} not found`));return}p.getProcessCpuUsage(b,a=>{const h=new Map;a.forEach(u=>{const g=f(u.commandLine||"");h.set(u.pid,{name:m(g),cmd:g,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),S=h.get(_),S?(h.forEach(u=>{const g=h.get(u.ppid);g&&(g.children||(g.children=[]),g.children.push(u))}),h.forEach(u=>{u.children&&(u.children=u.children.sort((g,y)=>g.pid-y.pid))}),k(S)):P(new Error(`Root process ${_} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let f=function(){let p=[S];const b=[];for(;p.length;){const h=p.shift();h&&(b.push(h.pid),h.children&&(p=p.concat(h.children)))}let a=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+b.join(" "),(0,T.exec)(a,{},(h,u,g)=>{if(h||g)P(h||new Error(g.toString()));else{const y=u.toString().split(`
`);for(let L=0;L<b.length;L++){const n=D.get(b[L]);n.load=parseFloat(y[L])}if(!S){P(new Error(`Root process ${_} not found`));return}k(S)}})};(0,T.exec)("which ps",{},(p,b,a)=>{if(p||a)if(process.platform!=="linux")P(p||new Error(a.toString()));else{const h=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,T.exec)(h,{},(u,g,y)=>{u||y?P(u||new Error(y.toString())):(A(g,w),f())})}else{const h=b.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,T.exec)(`${h} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,y,L)=>{g||L&&!L.includes("screen size is bogus")?P(g||new Error(L.toString())):(A(y,w),process.platform==="linux"?f():S?k(S):P(new Error(`Root process ${_} not found`)))})}})}})}e.listProcesses=l;function A(_,k){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=_.toString().split(`
`);for(const D of S){const w=P.exec(D.trim());w&&w.length===6&&k(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(oe[148],ae([0,1,34,4,94,95]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function _(w,m){return w===1?O.isWindows?D():A.getWindowsShell(m):P(w,m)}e.getSystemShell=_;let k=null;function P(w,m){if(O.isLinux&&w===2||O.isMacintosh&&w===3)return"/bin/bash";if(!k){let f;if(O.isWindows)f="/bin/bash";else{if(f=m.SHELL,!f)try{f=(0,T.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}k=f}return k}let S=null;async function D(){return S||(S=(await(0,l.getFirstAvailablePowerShellInstallation)()).exePath),S}});var Se=this&&this.__decorate||function(ie,e,T,O){var l=arguments.length,A=l<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,T):O,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,T,O);else for(var k=ie.length-1;k>=0;k--)(_=ie[k])&&(A=(l<3?_(A):l>3?_(e,T,A):_(e,T))||A);return l>3&&A&&Object.defineProperty(e,T,A),A};define(oe[41],ae([0,1,21,6,16,26,61,9,3,2,91,27,11]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(f||(f={}));function p($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(b||(b={}));function a($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(h||(h={}));function u($){let j=0;for(let te=0;;te+=7){const ne=$.read(1);if(j|=(ne.buffer[0]&127)<<te,!(ne.buffer[0]&128))return j}}const g=t(0);function y($,j){if(j===0){$.write(g);return}let te=0;for(let se=j;se!==0;se=se>>>7)te++;const ne=l.VSBuffer.alloc(te);for(let se=0;j!==0;se++)ne.buffer[se]=j&127,j=j>>>7,j>0&&(ne.buffer[se]|=128);$.write(ne)}class L{constructor(j){this.buffer=j,this.pos=0}read(j){const te=this.buffer.slice(this.pos,this.pos+j);return this.pos+=te.byteLength,te}}e.BufferReader=L;class n{constructor(){this.buffers=[]}get buffer(){return l.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}e.BufferWriter=n;var s;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object",$[$.Int=6]="Int"})(s||(s={}));function t($){const j=l.VSBuffer.alloc(1);return j.writeUInt8($,0),j}const i={Undefined:t(s.Undefined),String:t(s.String),Buffer:t(s.Buffer),VSBuffer:t(s.VSBuffer),Array:t(s.Array),Object:t(s.Object),Uint:t(s.Int)},r=typeof Buffer<"u";function o($,j){if(typeof j>"u")$.write(i.Undefined);else if(typeof j=="string"){const te=l.VSBuffer.fromString(j);$.write(i.String),y($,te.byteLength),$.write(te)}else if(r&&Buffer.isBuffer(j)){const te=l.VSBuffer.wrap(j);$.write(i.Buffer),y($,te.byteLength),$.write(te)}else if(j instanceof l.VSBuffer)$.write(i.VSBuffer),y($,j.byteLength),$.write(j);else if(Array.isArray(j)){$.write(i.Array),y($,j.length);for(const te of j)o($,te)}else if(typeof j=="number"&&(j|0)===j)$.write(i.Uint),y($,j);else{const te=l.VSBuffer.fromString(JSON.stringify(j));$.write(i.Object),y($,te.byteLength),$.write(te)}}e.serialize=o;function c($){switch($.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return $.read(u($)).toString();case s.Buffer:return $.read(u($)).buffer;case s.VSBuffer:return $.read(u($));case s.Array:{const te=u($),ne=[];for(let se=0;se<te;se++)ne.push(c($));return ne}case s.Object:return JSON.parse($.read(u($)).toString());case s.Int:return u($)}}e.deserialize=c;class v{constructor(j,te,ne=null,se=1e3){this.protocol=j,this.ctx=te,this.logger=ne,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(j,te){this.channels.set(j,te),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const te=this.send([j.type]);this.logger?.logOutgoing(te,0,1,a(j.type));return}case 201:case 202:case 204:case 203:{const te=this.send([j.type,j.id],j.data);this.logger?.logOutgoing(te,j.id,1,a(j.type),j.data);return}}}send(j,te=void 0){const ne=new n;return o(ne,j),o(ne,te),this.sendBuffer(ne.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const te=new L(j),ne=c(te),se=c(te),J=ne[0];switch(J){case 100:return this.logger?.logIncoming(j.byteLength,ne[1],1,`${p(J)}: ${ne[2]}.${ne[3]}`,se),this.onPromise({type:J,id:ne[1],channelName:ne[2],name:ne[3],arg:se});case 102:return this.logger?.logIncoming(j.byteLength,ne[1],1,`${p(J)}: ${ne[2]}.${ne[3]}`,se),this.onEventListen({type:J,id:ne[1],channelName:ne[2],name:ne[3],arg:se});case 101:return this.logger?.logIncoming(j.byteLength,ne[1],1,`${p(J)}`),this.disposeActiveRequest({type:J,id:ne[1]});case 103:return this.logger?.logIncoming(j.byteLength,ne[1],1,`${p(J)}`),this.disposeActiveRequest({type:J,id:ne[1]})}}onPromise(j){const te=this.channels.get(j.channelName);if(!te){this.collectPendingRequest(j);return}const ne=new A.CancellationTokenSource;let se;try{se=te.call(this.ctx,j.name,j.arg,ne.token)}catch(M){se=Promise.reject(M)}const J=j.id;se.then(M=>{this.sendResponse({id:J,data:M,type:201}),this.activeRequests.delete(j.id)},M=>{M instanceof Error?this.sendResponse({id:J,data:{message:M.message,name:M.name,stack:M.stack?M.stack.split?M.stack.split(`
`):M.stack:void 0},type:202}):this.sendResponse({id:J,data:M,type:203}),this.activeRequests.delete(j.id)});const G=(0,S.toDisposable)(()=>ne.cancel());this.activeRequests.set(j.id,G)}onEventListen(j){const te=this.channels.get(j.channelName);if(!te){this.collectPendingRequest(j);return}const ne=j.id,J=te.listen(this.ctx,j.name,j.arg)(G=>this.sendResponse({id:ne,data:G,type:204}));this.activeRequests.set(j.id,J)}disposeActiveRequest(j){const te=this.activeRequests.get(j.id);te&&(te.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let te=this.pendingRequests.get(j.channelName);te||(te=[],this.pendingRequests.set(j.channelName,te));const ne=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);te.push({request:j,timeoutTimer:ne})}flushPendingRequests(j){const te=this.pendingRequests.get(j);if(te){for(const ne of te)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.onPromise(ne.request);break;case 102:this.onEventListen(ne.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=v;var E;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class d{constructor(j,te=null){this.protocol=j,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new P.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ne=>this.onBuffer(ne)),this.logger=te}getChannel(j){const te=this;return{call(ne,se,J){return te.isDisposed?Promise.reject(new k.CancellationError):te.requestPromise(j,ne,se,J)},listen(ne,se){return te.isDisposed?P.Event.None:te.requestEvent(j,ne,se)}}}requestPromise(j,te,ne,se=A.CancellationToken.None){const J=this.lastRequestId++,M={id:J,type:100,channelName:j,name:te,arg:ne};if(se.isCancellationRequested)return Promise.reject(new k.CancellationError);let C;return new Promise((z,H)=>{if(se.isCancellationRequested)return H(new k.CancellationError);const V=()=>{const ue=fe=>{switch(fe.type){case 201:this.handlers.delete(J),z(fe.data);break;case 202:{this.handlers.delete(J);const ve=new Error(fe.data.message);ve.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ve.name=fe.data.name,H(ve);break}case 203:this.handlers.delete(J),H(fe.data);break}};this.handlers.set(J,ue),this.sendRequest(M)};let X=null;this.state===h.Idle?V():(X=(0,O.createCancelablePromise)(ue=>this.whenInitialized()),X.then(()=>{X=null,V()}));const ee=()=>{X?(X.cancel(),X=null):this.sendRequest({id:J,type:101}),H(new k.CancellationError)},ce=se.onCancellationRequested(ee);C=(0,S.combinedDisposable)((0,S.toDisposable)(ee),ce),this.activeRequests.add(C)}).finally(()=>{this.activeRequests.delete(C)})}requestEvent(j,te,ne){const se=this.lastRequestId++,G={id:se,type:102,channelName:j,name:te,arg:ne};let M=null;const C=new P.Emitter({onWillAddFirstListener:()=>{M=(0,O.createCancelablePromise)(z=>this.whenInitialized()),M.then(()=>{M=null,this.activeRequests.add(C),this.sendRequest(G)})},onDidRemoveLastListener:()=>{M?(M.cancel(),M=null):(this.activeRequests.delete(C),this.sendRequest({id:se,type:103}))}}),U=z=>C.fire(z.data);return this.handlers.set(se,U),C.event}sendRequest(j){switch(j.type){case 100:case 102:{const te=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger?.logOutgoing(te,j.id,0,`${p(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const te=this.send([j.type,j.id]);this.logger?.logOutgoing(te,j.id,0,p(j.type));return}}}send(j,te=void 0){const ne=new n;return o(ne,j),o(ne,te),this.sendBuffer(ne.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const te=new L(j),ne=c(te),se=c(te),J=ne[0];switch(J){case 200:return this.logger?.logIncoming(j.byteLength,0,0,a(J)),this.onResponse({type:ne[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(j.byteLength,ne[1],0,a(J),se),this.onResponse({type:ne[0],id:ne[1],data:se})}}onResponse(j){if(j.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(j.id)?.(j)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=d,Se([_.memoize],d.prototype,"onDidInitializePromise",null);class I{get connections(){const j=[];return this._connections.forEach(te=>j.push(te)),j}constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new P.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new P.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:te,onDidClientDisconnect:ne})=>{P.Event.once(te.onMessage)(J=>{const G=new L(J),M=c(G),C=new v(te,M),U=new d(te);this.channels.forEach((H,V)=>C.registerChannel(V,H));const z={channelServer:C,channelClient:U,ctx:M};this._connections.add(z),this._onDidAddConnection.fire(z),ne(()=>{C.dispose(),U.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}getChannel(j,te){const ne=this;return{call(se,J,G){let M;if((0,m.isFunction)(te)){const U=(0,T.getRandomElement)(ne.connections.filter(te));M=U?Promise.resolve(U):P.Event.toPromise(P.Event.filter(ne.onDidAddConnection,te))}else M=te.routeCall(ne,se,J);const C=M.then(U=>U.channelClient.getChannel(j));return N(C).call(se,J,G)},listen(se,J){if((0,m.isFunction)(te))return ne.getMulticastEvent(j,te,se,J);const G=te.routeEvent(ne,se,J).then(M=>M.channelClient.getChannel(j));return N(G).listen(se,J)}}}getMulticastEvent(j,te,ne,se){const J=this;let G=new S.DisposableStore;const M=new P.Emitter({onWillAddFirstListener:()=>{G=new S.DisposableStore;const C=new P.EventMultiplexer,U=new Map,z=V=>{const ee=V.channelClient.getChannel(j).listen(ne,se),ce=C.add(ee);U.set(V,ce)},H=V=>{const X=U.get(V);X&&(X.dispose(),U.delete(V))};J.connections.filter(te).forEach(z),P.Event.filter(J.onDidAddConnection,te)(z,void 0,G),J.onDidRemoveConnection(H,void 0,G),C.event(M.fire,M,G),G.add(C)},onDidRemoveLastListener:()=>{G.dispose()}});return M.event}registerChannel(j,te){this.channels.set(j,te),this._connections.forEach(ne=>{ne.channelServer.registerChannel(j,te)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class R{constructor(j,te,ne=null){const se=new n;o(se,te),j.send(se.buffer),this.channelClient=new d(j,ne),this.channelServer=new v(j,te,ne)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,te){this.channelServer.registerChannel(j,te)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function N($){return{call(j,te,ne){return $.then(se=>se.call(j,te,ne))},listen(j,te){const ne=new P.Relay;return $.then(se=>ne.input=se.listen(j,te)),ne.event}}}e.getDelayedChannel=N;function F($){let j=!1;return{call(te,ne,se){return j?$.call(te,ne,se):(0,O.timeout)(0).then(()=>j=!0).then(()=>$.call(te,ne,se))},listen(te,ne){if(j)return $.listen(te,ne);const se=new P.Relay;return(0,O.timeout)(0).then(()=>j=!0).then(()=>se.input=$.listen(te,ne)),se.event}}}e.getNextTickChannel=F;class W{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const te of j.connections)if(await Promise.resolve(this.fn(te.ctx)))return Promise.resolve(te);return await P.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=W;var q;(function($){function j(J,G){const M=J,C=G&&G.disableMarshalling,U=new Map;for(const z in M)ne(z)&&U.set(z,P.Event.buffer(M[z],!0));return new class{listen(z,H,V){const X=U.get(H);if(X)return X;if(se(H)){const ee=M[H];if(typeof ee=="function")return ee.call(M,V)}throw new Error(`Event not found: ${H}`)}call(z,H,V){const X=M[H];if(typeof X=="function"){if(!C&&Array.isArray(V))for(let ee=0;ee<V.length;ee++)V[ee]=(0,D.revive)(V[ee]);return X.apply(M,V)}throw new Error(`Method not found: ${H}`)}}}$.fromService=j;function te(J,G){const M=G&&G.disableMarshalling;return new Proxy({},{get(C,U){if(typeof U=="string")return G?.properties?.has(U)?G.properties.get(U):se(U)?function(z){return J.listen(U,z)}:ne(U)?J.listen(U):async function(...z){let H;G&&!(0,m.isUndefinedOrNull)(G.context)?H=[G.context,...z]:H=z;const V=await J.call(U,H);return M?V:(0,D.revive)(V)};throw new Error(`Property not found: ${String(U)}`)}})}$.toService=te;function ne(J){return J[0]==="o"&&J[1]==="n"&&w.isUpperAsciiLetter(J.charCodeAt(2))}function se(J){return/^onDynamic/.test(J)&&w.isUpperAsciiLetter(J.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){const j=$.toString();if(j!=="[object Object]")return j}return $}function Z($){return Array.isArray($)?$.map(Q):Q($)}function K($,j,te,ne,se,J,G){G=Z(G);const M=B[se],C=M[ne%M.length];let U=[`%c[${$}]%c[${String(j).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(J)?(U=U.concat(G),U.push(")")):U.push(G),console.log.apply(console,U)}class x{constructor(j,te){this._outgoingPrefix=j,this._incomingPrefix=te,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,te,ne,se,J){this._totalOutgoing+=j,K(this._outgoingPrefix,this._totalOutgoing,j,te,ne,se,J)}logIncoming(j,te,ne,se,J){this._totalIncoming+=j,K(this._incomingPrefix,this._totalIncoming,j,te,ne,se,J)}}e.IPCLogger=x}),define(oe[96],ae([0,1,6,16,3,2,41]),function(ie,e,T,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(d){d.Created="created",d.Read="read",d.Write="write",d.Open="open",d.Error="error",d.Close="close",d.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",d.NodeEndReceived="nodeEndReceived",d.NodeEndSent="nodeEndSent",d.NodeDrainBegin="nodeDrainBegin",d.NodeDrainEnd="nodeDrainEnd",d.zlibInflateError="zlibInflateError",d.zlibInflateData="zlibInflateData",d.zlibInflateInitialWrite="zlibInflateInitialWrite",d.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",d.zlibInflateWrite="zlibInflateWrite",d.zlibInflateFlushFired="zlibInflateFlushFired",d.zlibDeflateError="zlibDeflateError",d.zlibDeflateData="zlibDeflateData",d.zlibDeflateWrite="zlibDeflateWrite",d.zlibDeflateFlushFired="zlibDeflateFlushFired",d.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",d.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",d.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",d.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",d.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",d.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",d.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",d.ProtocolHeaderRead="protocolHeaderRead",d.ProtocolMessageRead="protocolMessageRead",d.ProtocolHeaderWrite="protocolHeaderWrite",d.ProtocolMessageWrite="protocolMessageWrite",d.ProtocolWrite="protocolWrite"})(k||(e.SocketDiagnosticsEventType=k={}));var P;(function(d){d.enableDiagnostics=!1,d.records=[];const I=new WeakMap;let R=0;function N(W,q){if(!I.has(W)){const B=String(++R);I.set(W,B)}return I.get(W)}function F(W,q,B,Q){if(!d.enableDiagnostics)return;const Z=N(W,q);if(Q instanceof O.VSBuffer||Q instanceof Uint8Array||Q instanceof ArrayBuffer||ArrayBuffer.isView(Q)){const K=O.VSBuffer.alloc(Q.byteLength);K.set(Q),d.records.push({timestamp:Date.now(),id:Z,label:q,type:B,buff:K})}else d.records.push({timestamp:Date.now(),id:Z,label:q,type:B,data:Q})}d.traceSocketEvent=F})(P||(e.SocketDiagnostics=P={}));var S;(function(d){d[d.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",d[d.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let D=null;function w(){return D||(D=O.VSBuffer.alloc(0)),D}class m{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(I){this._chunks.push(I),this._totalLength+=I.byteLength}read(I){return this._read(I,!0)}peek(I){return this._read(I,!1)}_read(I,R){if(I===0)return w();if(I>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===I){const q=this._chunks[0];return R&&(this._chunks.shift(),this._totalLength-=I),q}if(this._chunks[0].byteLength>I){const q=this._chunks[0].slice(0,I);return R&&(this._chunks[0]=this._chunks[0].slice(I),this._totalLength-=I),q}const N=O.VSBuffer.alloc(I);let F=0,W=0;for(;I>0;){const q=this._chunks[W];if(q.byteLength>I){const B=q.slice(0,I);N.set(B,F),F+=I,R&&(this._chunks[W]=q.slice(I),this._totalLength-=I),I-=I}else N.set(q,F),F+=q.byteLength,R?(this._chunks.shift(),this._totalLength-=q.byteLength):W++,I-=q.byteLength}return N}}e.ChunkStream=m;var f;(function(d){d[d.None=0]="None",d[d.Regular=1]="Regular",d[d.Control=2]="Control",d[d.Ack=3]="Ack",d[d.Disconnect=5]="Disconnect",d[d.ReplayRequest=6]="ReplayRequest",d[d.Pause=7]="Pause",d[d.Resume=8]="Resume",d[d.KeepAlive=9]="KeepAlive",d[d.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",d[d.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function p(d){switch(d){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var b;(function(d){d[d.HeaderLength=13]="HeaderLength",d[d.AcknowledgeTime=2e3]="AcknowledgeTime",d[d.TimeoutTime=2e4]="TimeoutTime",d[d.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",d[d.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",d[d.KeepAliveSendTime=5e3]="KeepAliveSendTime",d[d.LatencySampleTime=6e4]="LatencySampleTime",d[d.LatencySampleCount=5]="LatencySampleCount",d[d.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",d[d.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(b||(e.ProtocolConstants=b={}));class a{constructor(I,R,N,F){this.type=I,this.id=R,this.ack=N,this.data=F,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends A.Disposable{constructor(I){super(),this._onMessage=this._register(new l.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=I,this._isDisposed=!1,this._incomingData=new m,this._register(this._socket.onData(R=>this.acceptChunk(R))),this.lastReadTime=Date.now()}acceptChunk(I){if(!(!I||I.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;){const R=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=R.readUInt32BE(9),this._state.messageType=R.readUInt8(0),this._state.id=R.readUInt32BE(1),this._state.ack=R.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const N=this._state.messageType,F=this._state.id,W=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",R),this._onMessage.fire(new a(N,F,W,R)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(I){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=I,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(I){if(this._isDisposed)return;I.writtenTime=Date.now(),this.lastWriteTime=Date.now();const R=O.VSBuffer.alloc(13);R.writeUInt8(I.type,0),R.writeUInt32BE(I.id,1),R.writeUInt32BE(I.ack,5),R.writeUInt32BE(I.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(I.type),id:I.id,ack:I.ack,messageSize:I.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",I.data),this._writeSoon(R,I.data)}_bufferAdd(I,R){const N=this._totalLength===0;return this._data.push(I,R),this._totalLength+=I.byteLength+R.byteLength,N}_bufferTake(){const I=O.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,I}_writeSoon(I,R){this._bufferAdd(I,R)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const I=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:I.byteLength}),this._socket.write(I)}}class g extends A.Disposable{constructor(I){super(),this._onMessage=new l.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new l.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=I,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(R=>{R.type===1&&this._onMessage.fire(R.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(I){this._socketWriter.write(new a(1,0,0,I))}}e.Protocol=g;class y extends _.IPCClient{static fromSocket(I,R){return new y(new g(I),R)}get onDidDispose(){return this.protocol.onDidDispose}constructor(I,R,N=null){super(I,R,N),this.protocol=I}dispose(){super.dispose();const I=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),I.end()}}e.Client=y;class L{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new l.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(I){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(I):this._emitter.fire(I):this._bufferedMessages.push(I)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=L;class n{constructor(I){this.data=I,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let I=0,R=this._first;for(;R;)R=R.next,I++;return I}peek(){return this._first?this._first.data:null}toArray(){const I=[];let R=0,N=this._first;for(;N;)I[R++]=N.data,N=N.next;return I}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(I){const R=new n(I);if(!this._first){this._first=R,this._last=R;return}this._last.next=R,this._last=R}}class t{static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}constructor(){this.lastRuns=[];const I=Date.now();for(let R=0;R<t._HISTORY_LENGTH;R++)this.lastRuns[R]=I-1e3*R;setInterval(()=>{for(let R=t._HISTORY_LENGTH;R>=1;R--)this.lastRuns[R]=this.lastRuns[R-1];this.lastRuns[0]=Date.now()},1e3)}load(){const I=Date.now(),R=(1+t._HISTORY_LENGTH)*1e3;let N=0;for(let F=0;F<t._HISTORY_LENGTH;F++)I-this.lastRuns[F]<=R&&N++;return 1-N/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;var i;(function(d){d[d.Good=0]="Good",d[d.Poor=1]="Poor"})(i||(e.ConnectionHealth=i={}));function r(d){switch(d){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class o{constructor(I){this.connectionHealth=I}}e.ConnectionHealthChangedEvent=o;class c{constructor(I,R){this.roundTripTime=I,this.recentHighRoundTripCount=R}}e.HighRoundTripTimeEvent=c;class v{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(I){this._onControlMessage=new L,this.onControlMessage=this._onControlMessage.event,this._onMessage=new L,this.onMessage=this._onMessage.event,this._onDidDispose=new L,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new L,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new L,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new L,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new L,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=I.loadEstimator??t.getInstance(),this._measureRoundTripTime=I.measureRoundTripTime??!1,this._shouldSendKeepAlive=I.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new A.DisposableStore,this._socket=I.socket,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new h(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(R=>this._receiveMessage(R))),this._socketDisposables.add(this._socket.onClose(R=>this._onSocketClose.fire(R))),this._socketLatencyMonitor=this._socketDisposables.add(new E),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(R=>this._sendLatencyMeasurementRequest(R))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(R=>this._onHighRoundTripTime.fire(R))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(R=>this._onDidChangeConnectionHealth.fire(R))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),I.initialChunk&&this._socketReader.acceptChunk(I.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const I=new a(5,0,0,w());this._socketWriter.write(I),this._socketWriter.flush()}sendPause(){const I=new a(7,0,0,w());this._socketWriter.write(I)}sendResume(){const I=new a(8,0,0,w());this._socketWriter.write(I)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(I,R){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new A.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=I,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new h(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(N=>this._receiveMessage(N))),this._socketDisposables.add(this._socket.onClose(N=>this._onSocketClose.fire(N))),this._socketLatencyMonitor=this._socketDisposables.add(new E),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(N=>this._sendLatencyMeasurementRequest(N))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(N=>this._onHighRoundTripTime.fire(N))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(N=>this._onDidChangeConnectionHealth.fire(N))),this._socketReader.acceptChunk(R)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const I=new a(3,0,this._incomingAckId,w());this._socketWriter.write(I);const R=this._outgoingUnackMsg.toArray();for(let N=0,F=R.length;N<F;N++)this._socketWriter.write(R[N]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(I){if(I.ack>this._outgoingAckId){this._outgoingAckId=I.ack;do{const R=this._outgoingUnackMsg.peek();if(R&&R.id<=I.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(I.type){case 0:break;case 1:{if(I.id>this._incomingMsgId)if(I.id!==this._incomingMsgId+1){const R=Date.now();R-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=R,this._socketWriter.write(new a(6,0,0,w())))}else this._incomingMsgId=I.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(I.data);break}case 2:{this._onControlMessage.fire(I.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const R=this._outgoingUnackMsg.toArray();for(let N=0,F=R.length;N<F;N++)this._socketWriter.write(R[N]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(I.data);break}case 11:{this._socketLatencyMonitor.handleResponse(I.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(I){const R=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const N=new a(1,R,this._incomingAckId,I);this._outgoingUnackMsg.push(N),this._isReconnecting||(this._socketWriter.write(N),this._recvAckCheck())}sendControl(I){const R=new a(2,0,0,I);this._socketWriter.write(R)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const I=Date.now()-this._incomingMsgLastTime;if(I>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-I+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const I=this._outgoingUnackMsg.peek(),R=Date.now()-I.writtenTime,N=Date.now()-this._socketReader.lastReadTime,F=Date.now()-this._lastSocketTimeoutTime;if(R>=2e4&&N>=2e4&&F>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:R,timeSinceLastReceivedSomeData:N});return}const W=Math.max(2e4-R,2e4-N,2e4-F,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},W)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const I=new a(3,0,this._incomingAckId,w());this._socketWriter.write(I)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const I=new a(9,0,this._incomingAckId,w());this._socketWriter.write(I)}_sendLatencyMeasurementRequest(I){this._incomingAckId=this._incomingMsgId;const R=new a(10,0,this._incomingAckId,I);this._socketWriter.write(R)}_sendLatencyMeasurementResponse(I){this._incomingAckId=this._incomingMsgId;const R=new a(11,0,this._incomingAckId,I);this._socketWriter.write(R)}}e.PersistentProtocol=v;class E extends A.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new l.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new l.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new l.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new T.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},I=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const I=++this._lastLatencyMeasurementId,R=O.VSBuffer.alloc(4);R.writeUInt32BE(I,0),this._onSendLatencyRequest.fire(R)},6e4)}handleResponse(I){if(I.byteLength!==4)return;const R=I.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||R!==this._lastLatencyMeasurementId)return;const N=Date.now()-this._lastLatencyMeasurementSent,F=this._latencySampleIndex++;this._latencySamples[F%this._latencySamples.length]=N;const W=this._connectionHealth,q=this._latencySamples.filter(B=>B>=1e3).length;this._connectionHealth=q>=3?1:0,N>1e3&&this._onHighRoundTripTime.fire(new c(N,q)),W!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(oe[66],ae([0,1,49,6,16,26,144,9,3,2,31,95,88,41]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(h){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",u=>l.VSBuffer.wrap(Buffer.from(u,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=p;class b{constructor(h,u){this.modulePath=h,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new O.Delayer(g),this.child=null,this._client=null}getChannel(h){const u=this;return{call(g,y,L){return u.requestPromise(h,g,y,L)},listen(g,y){return u.requestEvent(h,g,y)}}}requestPromise(h,u,g,y=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(k.canceled());this.disposeDelayer.cancel();const L=this.getCachedChannel(h),n=(0,O.createCancelablePromise)(i=>L.call(u,g,i)),s=y.onCancellationRequested(()=>n.cancel()),t=(0,S.toDisposable)(()=>n.cancel());return this.activeRequests.add(t),n.finally(()=>{s.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(h,u,g){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let y;const L=new P.Emitter({onWillAddFirstListener:()=>{y=this.getCachedChannel(h).listen(u,g)(L.fire,L),this.activeRequests.add(y)},onDidRemoveLastListener:()=>{this.activeRequests.delete(y),y.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return L.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(u.env),this.child=(0,T.fork)(this.modulePath,h,u);const g=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,_.isRemoteConsoleLog)(r)){(0,_.log)(r,`IPC Library: ${this.options.serverName}`);return}g.fire(l.VSBuffer.wrap(Buffer.from(r,"base64")))});const L=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,n=r=>this.child&&this.child.connected&&L.send(r.buffer.toString("base64")),s=g.event,t={send:n,onMessage:s};this._client=new f.ChannelClient(t);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(c=>(0,S.dispose)(c)),this.activeRequests.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:o})})}return this._client}getCachedChannel(h){let u=this.channels.get(h);return u||(u=this.client.getChannel(h),this.channels.set(h,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=b}),define(oe[149],ae([0,1,136,16,41,3,11,21]),function(ie,e,T,O,l,A,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class P{constructor(m){this.port=m,this.onMessage=A.Event.fromNodeEventEmitter(this.port,"message",f=>O.VSBuffer.wrap(f.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}class S extends l.IPCServer{static getOnDidClientConnect(){(0,_.assertType)((0,T.isUtilityProcess)(process),"Electron Utility Process");const m=new A.Emitter;return process.parentPort.on("message",f=>{const p=(0,k.firstOrDefault)(f.ports);p&&m.fire(p)}),A.Event.map(m.event,f=>({protocol:new P(f),onDidClientDisconnect:A.Event.fromNodeEventEmitter(f,"close")}))}constructor(){super(S.getOnDidClientConnect())}}e.Server=S;function D(w,m,f){const p=b=>{b.data===m&&(w.removeListener("message",p),f())};w.on("message",p)}e.once=D}),define(oe[67],ae([0,1,6,3,2,11]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var _;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(_||(e.StorageHint=_={}));function k(w){const m=w;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var P;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(P||(e.StorageState=P={}));class S extends l.Disposable{constructor(m,f=Object.create(null)){super(),this.database=m,this.options=f,this._onDidChangeStorage=this._register(new O.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((f,p)=>this.accept(p,f)),m.deleted?.forEach(f=>this.accept(f,void 0))}accept(m,f){if(this.state===P.Closed)return;let p=!1;(0,A.isUndefinedOrNull)(f)?p=this.cache.delete(m):this.cache.get(m)!==f&&(this.cache.set(m,f),p=!0),p&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==_.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,f){const p=this.cache.get(m);return(0,A.isUndefinedOrNull)(p)?f:p}getBoolean(m,f){const p=this.get(m);return(0,A.isUndefinedOrNull)(p)?f:p==="true"}getNumber(m,f){const p=this.get(m);return(0,A.isUndefinedOrNull)(p)?f:parseInt(p,10)}async set(m,f){if(this.state===P.Closed)return;if((0,A.isUndefinedOrNull)(f))return this.delete(m);const p=String(f);if(this.cache.get(m)!==p)return this.cache.set(m,p),this.pendingInserts.set(m,p),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===P.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}isInMemory(){return this.options.hint===_.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class D{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((f,p)=>this.items.set(p,f)),m.delete?.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=D}),define(oe[150],ae([8,7]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(oe[151],ae([8,7]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[152],ae([8,7]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[153],ae([8,7]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(oe[154],ae([8,7]),function(ie,e){return ie.create("vs/platform/environment/node/argv",e)}),define(oe[155],ae([8,7]),function(ie,e){return ie.create("vs/platform/environment/node/argvHelper",e)}),define(oe[156],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[157],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[158],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[159],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[160],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[161],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[162],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[163],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(oe[164],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(oe[165],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(oe[166],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[167],ae([8,7]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[168],ae([8,7]),function(ie,e){return ie.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[169],ae([8,7]),function(ie,e){return ie.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[170],ae([8,7]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(oe[171],ae([8,7]),function(ie,e){return ie.create("vs/platform/shell/node/shellEnv",e)}),define(oe[172],ae([8,7]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[173],ae([8,7]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[174],ae([8,7]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[175],ae([8,7]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[176],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[177],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[178],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[179],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[180],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[181],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[182],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[183],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[184],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[185],ae([8,7]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(oe[186],ae([0,1,9,153]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var l;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(l||(e.TokenType=l={}));function A(...S){switch(S.length){case 1:return(0,O.localize)(0,null,S[0]);case 2:return(0,O.localize)(1,null,S[0],S[1]);case 3:return(0,O.localize)(2,null,S[0],S[1],S[2]);default:return}}const _=(0,O.localize)(3,null),k=(0,O.localize)(4,null);class P{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(D){switch(D.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return D.isTripleEq?"===":"==";case 4:return D.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return D.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return D.lexeme;case 18:return D.lexeme;case 19:return D.lexeme;case 20:return"EOF";default:throw(0,T.illegalState)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(D){return this._input=D,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const w=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:w})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const w=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:w})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(D){return this._isAtEnd()||this._input.charCodeAt(this._current)!==D?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(D){this._tokens.push({type:D,offset:this._start})}_error(D){const w=this._start,m=this._input.substring(this._start,this._current),f={type:19,offset:this._start,lexeme:m};this._errors.push({offset:w,lexeme:m,additionalInfo:D}),this._tokens.push(f)}_string(){this.stringRe.lastIndex=this._start;const D=this.stringRe.exec(this._input);if(D){this._current=this._start+D[0].length;const w=this._input.substring(this._start,this._current),m=P._keywords.get(w);m?this._addToken(m):this._tokens.push({type:17,lexeme:w,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(_);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let D=this._current,w=!1,m=!1;for(;;){if(D>=this._input.length){this._current=D,this._error(k);return}const p=this._input.charCodeAt(D);if(w)w=!1;else if(p===47&&!m){D++;break}else p===91?m=!0:p===92?w=!0:p===93&&(m=!1);D++}for(;D<this._input.length&&P._regexFlags.has(this._input.charCodeAt(D));)D++;this._current=D;const f=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:f,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=P,P._regexFlags=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0))),P._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(oe[187],ae([0,1,64,61,22,14,36,23,12]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,A.dirname)(l.FileAccess.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",f)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(P.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=_.env.VSCODE_PORTABLE;return f?P.URI.file((0,A.join)(f,"argv.json")):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.resolve)(f):(0,A.normalize)((0,A.join)(l.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?P.URI.file((0,A.resolve)(f)):P.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.resolve)(f);const p=_.env.VSCODE_EXTENSIONS;if(p)return p;const b=_.env.VSCODE_PORTABLE;return b?(0,A.join)(b,"extensions"):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(p=>/^[^:/?#]+?:\/\//.test(p)?P.URI.parse(p):P.URI.file((0,A.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?P.URI.parse(f):P.URI.file((0,A.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!_.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const p of this.args.log||[]){const b=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);b&&b[1]&&b[2]&&f.push([b[1],b[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=_.env.VSCODE_PORTABLE;return f?P.URI.file((0,A.join)(f,"policy.json")):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this._args}constructor(f,p,b){this._args=f,this.paths=p,this.productService=b,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=S,Se([O.memoize],S.prototype,"appRoot",null),Se([O.memoize],S.prototype,"userHome",null),Se([O.memoize],S.prototype,"userDataPath",null),Se([O.memoize],S.prototype,"appSettingsHome",null),Se([O.memoize],S.prototype,"tmpDir",null),Se([O.memoize],S.prototype,"cacheHome",null),Se([O.memoize],S.prototype,"stateResource",null),Se([O.memoize],S.prototype,"userRoamingDataHome",null),Se([O.memoize],S.prototype,"userDataSyncHome",null),Se([O.memoize],S.prototype,"sync",null),Se([O.memoize],S.prototype,"machineSettingsResource",null),Se([O.memoize],S.prototype,"workspaceStorageHome",null),Se([O.memoize],S.prototype,"localHistoryHome",null),Se([O.memoize],S.prototype,"keyboardLayoutResource",null),Se([O.memoize],S.prototype,"argvResource",null),Se([O.memoize],S.prototype,"isExtensionDevelopment",null),Se([O.memoize],S.prototype,"untitledWorkspacesHome",null),Se([O.memoize],S.prototype,"builtinExtensionsPath",null),Se([O.memoize],S.prototype,"extensionsPath",null),Se([O.memoize],S.prototype,"extensionDevelopmentLocationURI",null),Se([O.memoize],S.prototype,"extensionDevelopmentKind",null),Se([O.memoize],S.prototype,"extensionTestsLocationURI",null),Se([O.memoize],S.prototype,"debugExtensionHost",null),Se([O.memoize],S.prototype,"logLevel",null),Se([O.memoize],S.prototype,"extensionLogLevel",null),Se([O.memoize],S.prototype,"serviceMachineIdResource",null),Se([O.memoize],S.prototype,"disableTelemetry",null),Se([O.memoize],S.prototype,"disableWorkspaceTrust",null),Se([O.memoize],S.prototype,"policyFile",null);function D(m,f){return w(m["inspect-extensions"],m["inspect-brk-extensions"],5870,f,m.debugId,m.extensionEnvironment)}e.parseExtensionHostDebugPort=D;function w(m,f,p,b,a,h){const g=Number(f||m)||(b?null:p),y=g?!!f:!1;let L;if(h)try{L=JSON.parse(h)}catch{}return{port:g,break:y,debugId:a,env:L}}e.parseDebugParams=w}),define(oe[188],ae([0,1,284,4,154]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,l.localize)(0,null),e:(0,l.localize)(1,null),t:(0,l.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,l.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,l.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,l.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,l.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,l.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,l.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,l.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,l.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,l.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,l.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,l.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,l.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,l.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,l.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,l.localize)(17,null)},category:{type:"string",cat:"e",description:(0,l.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,l.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,l.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,l.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,l.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,l.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,l.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,l.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,l.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,l.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,l.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,l.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,l.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,l.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,l.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,l.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,l.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const _={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(b,a,h=_){const u=b.find(o=>o.length>0&&o[0]!=="-"),g={},y=["_"],L=[],n={};let s;for(const o in a){const c=a[o];c.type==="subcommand"?o===u&&(s=c):(c.alias&&(g[o]=c.alias),c.type==="string"||c.type==="string[]"?(y.push(o),c.deprecates&&y.push(...c.deprecates)):c.type==="boolean"&&(L.push(o),c.deprecates&&L.push(...c.deprecates)),c.global&&(n[o]=c))}if(s&&u){const o=n;for(const d in s.options)o[d]=s.options[d];const c=b.filter(d=>d!==u),v=h.getSubcommandReporter?h.getSubcommandReporter(u):void 0,E=k(c,o,v);return{[u]:E,_:[]}}const t=T(b,{string:y,boolean:L,alias:g}),i={},r=t;i._=t._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(const o in a){const c=a[o];if(c.type==="subcommand")continue;c.alias&&delete r[c.alias];let v=r[o];if(c.deprecates)for(const E of c.deprecates)r.hasOwnProperty(E)&&(v||(v=r[E],v&&h.onDeprecatedOption(E,c.deprecationMessage||(0,l.localize)(35,null,o))),delete r[E]);if(typeof v<"u"){if(c.type==="string[]"){if(Array.isArray(v)||(v=[v]),!c.allowEmptyValue){const E=v.filter(d=>d.length>0);E.length!==v.length&&(h.onEmptyValue(o),v=E.length>0?E:void 0)}}else c.type==="string"&&(Array.isArray(v)?(v=v.pop(),h.onMultipleValues(o,v)):!v&&!c.allowEmptyValue&&(h.onEmptyValue(o),v=void 0));i[o]=v,c.deprecationMessage&&h.onDeprecatedOption(o,c.deprecationMessage)}delete r[o]}for(const o in r)h.onUnknownOption(o);return i}e.parseArgs=k;function P(b,a){let h="";return a.args&&(Array.isArray(a.args)?h=` <${a.args.join("> <")}>`:h=` <${a.args}>`),a.alias?`-${a.alias} --${b}${h}`:`--${b}${h}`}function S(b,a){const h=[];for(const u in b){const g=b[u],y=P(u,g);h.push([y,g.description])}return D(h,a)}e.formatOptions=S;function D(b,a){const u=b.reduce((L,n)=>Math.max(L,n[0].length),12)+2+1;if(a-u<25)return b.reduce((L,n)=>L.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const g=a-u-1,y=[];for(const L of b){const n=L[0],s=m(L[1],g),t=w(u-n.length-2);y.push("  "+n+t+s[0]);for(let i=1;i<s.length;i++)y.push(w(u)+s[i])}return y}function w(b){return" ".repeat(b)}function m(b,a){const h=[];for(;b.length;){const u=b.length<a?b.length:b.lastIndexOf(" ",a),g=b.slice(0,u).trim();b=b.slice(u),h.push(g)}return h}function f(b,a,h,u,g){const y=process.stdout.isTTY&&process.stdout.columns||80,L=g?.noInputFiles!==!0?`[${(0,l.localize)(36,null)}...]`:"",n=[`${b} ${h}`];n.push(""),n.push(`${(0,l.localize)(37,null)}: ${a} [${(0,l.localize)(38,null)}]${L}`),n.push(""),g?.noPipe!==!0&&(O.isWindows?n.push((0,l.localize)(39,null,a)):n.push((0,l.localize)(40,null,a)),n.push(""));const s={},t=[];for(const i in u){const r=u[i];if(r.type==="subcommand")r.description&&t.push({command:i,description:r.description});else if(r.description&&r.cat){let o=s[r.cat];o||(s[r.cat]=o={}),o[i]=r}}for(const i in s){const r=i,o=s[r];o&&(n.push(A[r]),n.push(...S(o,y)),n.push(""))}return t.length&&(n.push((0,l.localize)(41,null)),n.push(...D(t.map(i=>[i.command,i.description]),y)),n.push("")),n.join(`
`)}e.buildHelpMessage=f;function p(b,a){return`${b||(0,l.localize)(42,null)}
${a||(0,l.localize)(43,null)}
${process.arch}`}e.buildVersionMessage=p}),define(oe[189],ae([0,1,285,155,188]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(w,m){const f=(g,y)=>{console.warn((0,O.localize)(0,null,g,y))},p=g=>{console.warn((0,O.localize)(1,null,g))},b=(g,y)=>{console.warn((0,O.localize)(2,null,g,y))},a=g=>({onUnknownOption:y=>{g!=="tunnel"&&console.warn((0,O.localize)(3,null,y,g))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:b,getSubcommandReporter:g!=="tunnel"?a:void 0}),h={onUnknownOption:g=>{console.warn((0,O.localize)(4,null,g))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:b,getSubcommandReporter:a},u=(0,l.parseArgs)(w,l.OPTIONS,m?h:void 0);return u.goto&&u._.forEach(g=>T(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,O.localize)(5,null))),u}function _(w){const m=w.findIndex(f=>!/^-/.test(f));if(m>-1)return[...w.slice(0,m),...w.slice(m+1)]}function k(w){let[,...m]=w;process.env.VSCODE_DEV&&(m=_(m)||[]);const f=!D(process.env);return A(m,f)}e.parseMainProcessArgv=k;function P(w){let[,,...m]=w;return process.env.VSCODE_DEV&&(m=_(m)||[]),A(m,!0)}e.parseCLIProcessArgv=P;function S(w,...m){const f=w.indexOf("--");return f===-1?w.push(...m):w.splice(f,0,...m),w}e.addArg=S;function D(w){return w.VSCODE_CLI==="1"}e.isLaunchedFromCli=D}),function(){"use strict";function ie(e,T,O){function l(_,k){const P=A(_,k),S=[P];return e.isAbsolute(P)||S.unshift(O),e.resolve(...S)}function A(_,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,k);const D=_["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(w,"AppData","Roaming")}break;case"darwin":S=e.join(T.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,k)}return{getUserDataPath:l}}if(typeof define=="function")define(oe[97],ae([190,34,36]),function(e,T,O){return ie(e,T,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=ie(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[98],ae([0,1,34,187,97]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends O.AbstractNativeEnvironmentService{constructor(S,D){super(S,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,l.getUserDataPath)(S,D.nameShort)},D)}}e.NativeEnvironmentService=A;function _(P,S){return(0,O.parseDebugParams)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,S,P.extensionEnvironment)}e.parsePtyHostDebugPort=_;function k(P,S){return(0,O.parseDebugParams)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,S,P.extensionEnvironment)}e.parseSharedProcessDebugPort=k}),define(oe[191],ae([0,1,11,158]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function l(_,k,P){try{A(_,k,P)}catch(S){console.error(S?.message??S)}return _}e.localizeManifest=l;function A(_,k,P){const S=(D,w,m)=>{const f=D[w];if((0,T.isString)(f)){const p=f,b=p.length;if(b>1&&p[0]==="%"&&p[b-1]==="%"){const a=p.substr(1,b-2);let h=k[a];h===void 0&&P&&(h=P[a]);const u=typeof h=="string"?h:h?.message,g=P?.[a],y=typeof g=="string"?g:g?.message;if(!u){y||console.warn(`[${_.name}]: ${(0,O.localize)(0,null,a)}`);return}if(m&&(w==="title"||w==="category")&&y&&y!==u){const L={value:u,original:y};D[w]=L}else D[w]=u}}else if((0,T.isObject)(f))for(const p in f)f.hasOwnProperty(p)&&(p==="commands"?S(f,p,!0):S(f,p,m));else if(Array.isArray(f))for(let p=0;p<f.length;p++)S(f,p,m)};for(const D in _)_.hasOwnProperty(D)&&S(_,D)}}),define(oe[192],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class T{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.channel.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=T;class O{constructor(A){this.service=A}listen(A,_){throw new Error(`Event not found: ${_}`)}call(A,_,k){switch(_){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(k[0])}throw new Error(`Call not found: ${_}`)}}e.ExtensionRecommendationNotificationServiceChannel=O}),define(oe[68],ae([0,1,23,90,162,54]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function P(h){return h=h.trim(),h==="*"||_.test(h)}e.isValidVersionStr=P;function S(h){if(!P(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=h.match(_);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=S;function D(h){if(!h)return null;const u=h.majorBase,g=h.majorMustEqual,y=h.minorBase;let L=h.minorMustEqual;const n=h.patchBase;let s=h.patchMustEqual;h.hasCaret&&(u===0||(L=!1),s=!1);let t=0;if(h.preRelease){const i=k.exec(h.preRelease);if(i){const[,r,o,c]=i;t=Date.UTC(Number(r),Number(o)-1,Number(c))}}return{majorBase:u,majorMustEqual:g,minorBase:y,minorMustEqual:L,patchBase:n,patchMustEqual:s,isMinimum:h.hasGreaterEquals,notBefore:t}}e.normalizeVersion=D;function w(h,u,g){let y;typeof h=="string"?y=D(S(h)):y=h;let L;u instanceof Date?L=u.getTime():typeof u=="string"&&(L=new Date(u).getTime());let n;if(typeof g=="string"?n=D(S(g)):n=g,!y||!n)return!1;const s=y.majorBase,t=y.minorBase,i=y.patchBase;let r=n.majorBase,o=n.minorBase,c=n.patchBase;const v=n.notBefore;let E=n.majorMustEqual,d=n.minorMustEqual,I=n.patchMustEqual;return n.isMinimum?s>r?!0:s<r?!1:t>o?!0:t<o||L&&L<v?!1:i>=c:(s===1&&r===0&&(!E||!d||!I)&&(r=1,o=0,c=0,E=!0,d=!1,I=!1),s<r?!1:s>r?!E:t<o?!1:t>o?!d:i<c?!1:i>c?!I:!(L&&L<v))}e.isValidVersion=w;function m(h,u,g,y,L){const n=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return n.push([O.default.Error,l.localize(0,null)]),n;if(typeof y.name!="string")return n.push([O.default.Error,l.localize(1,null,"name")]),n;if(typeof y.version!="string")return n.push([O.default.Error,l.localize(2,null,"version")]),n;if(!y.engines)return n.push([O.default.Error,l.localize(3,null,"engines")]),n;if(typeof y.engines.vscode!="string")return n.push([O.default.Error,l.localize(4,null,"engines.vscode")]),n;if(typeof y.extensionDependencies<"u"&&!a(y.extensionDependencies))return n.push([O.default.Error,l.localize(5,null,"extensionDependencies")]),n;if(typeof y.activationEvents<"u"){if(!a(y.activationEvents))return n.push([O.default.Error,l.localize(6,null,"activationEvents")]),n;if(typeof y.main>"u"&&typeof y.browser>"u")return n.push([O.default.Error,l.localize(7,null,"activationEvents","main","browser")]),n}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&n.push([O.default.Warning,l.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return n.push([O.default.Error,l.localize(9,null,"main")]),n;{const i=(0,T.joinPath)(g,y.main);(0,T.isEqualOrParent)(i,g)||n.push([O.default.Warning,l.localize(10,null,i.path,g.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return n.push([O.default.Error,l.localize(11,null,"browser")]),n;{const i=(0,T.joinPath)(g,y.browser);(0,T.isEqualOrParent)(i,g)||n.push([O.default.Warning,l.localize(12,null,i.path,g.path)])}}if(!A.valid(y.version))return n.push([O.default.Error,l.localize(13,null)]),n;const s=[];if(!f(h,u,y,L,s))for(const i of s)n.push([O.default.Error,i]);return n}e.validateExtensionManifest=m;function f(h,u,g,y,L){return y||typeof g.main>"u"&&typeof g.browser>"u"?!0:b(h,u,g.engines.vscode,L)}e.isValidExtensionVersion=f;function p(h,u,g){return h==="*"||b(u,g,h)}e.isEngineValid=p;function b(h,u,g,y=[]){const L=D(S(g));if(!L)return y.push(l.localize(14,null,g)),!1;if(L.majorBase===0){if(!L.majorMustEqual||!L.minorMustEqual)return y.push(l.localize(15,null,g)),!1}else if(!L.majorMustEqual)return y.push(l.localize(16,null,g)),!1;return w(h,u,L)?!0:(y.push(l.localize(17,null,h,g)),!1)}function a(h){if(!Array.isArray(h))return!1;for(let u=0,g=h.length;u<g;u++)if(typeof h[u]!="string")return!1;return!0}}),define(oe[44],ae([0,1,16,32]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function l(A,_,k){let P=k&&k.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const D=(await _.readFile(A.serviceMachineIdResource)).value.toString();P=(0,O.isUUID)(D)?D:null}catch{P=null}if(!P){P=(0,O.generateUuid)();try{await _.writeFile(A.serviceMachineIdResource,T.VSBuffer.fromString(P))}catch{}}return k?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=l}),define(oe[69],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(l,A=[],_=!1){this.ctor=l,this.staticArguments=A,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=T}),define(oe[193],ae([0,1,69]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var l;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(l||(e.InstantiationType=l={}));function A(k,P,S){P instanceof T.SyncDescriptor||(P=new T.SyncDescriptor(P,[],!!S)),O.push([k,P])}e.registerSingleton=A;function _(){return O}e.getSingletonServiceDescriptors=_}),define(oe[194],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(A,_){this.key=A,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class O{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const _ of this._nodes.values())_.outgoing.size===0&&A.push(_);return A}insertEdge(A,_){const k=this.lookupOrInsertNode(A),P=this.lookupOrInsertNode(_);k.outgoing.set(P.key,P),P.incoming.set(k.key,k)}removeNode(A){const _=this._hashFn(A);this._nodes.delete(_);for(const k of this._nodes.values())k.outgoing.delete(_),k.incoming.delete(_)}lookupOrInsertNode(A){const _=this._hashFn(A);let k=this._nodes.get(_);return k||(k=new T(_,A),this._nodes.set(_,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[_,k]of this._nodes)A.push(`${_}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,_]of this._nodes){const k=new Set([A]),P=this._findCycle(_,k);if(P)return P}}_findCycle(A,_){for(const[k,P]of A.outgoing){if(_.has(k))return[..._,k].join(" -> ");_.add(k);const S=this._findCycle(P,_);if(S)return S;_.delete(k)}}}e.Graph=O}),define(oe[5],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var T;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function k(P){return P[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=k})(T||(e._util=T={})),e.IInstantiationService=l("instantiationService");function O(_,k,P){k[T.DI_TARGET]===k?k[T.DI_DEPENDENCIES].push({id:_,index:P}):(k[T.DI_DEPENDENCIES]=[{id:_,index:P}],k[T.DI_TARGET]=k)}function l(_){if(T.serviceIds.has(_))return T.serviceIds.get(_);const k=function(P,S,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(k,P,D)};return k.toString=()=>_,T.serviceIds.set(_,k),k}e.createDecorator=l;function A(_){return _}e.refineServiceDecorator=A}),define(oe[195],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,T.createDecorator)("checksumService")}),define(oe[17],ae([0,1,11,12,5]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof O.URI)}e.isConfigurationOverrides=A;function _(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=_;var k;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function P(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function S(a,h){const u=Object.create(null);for(const g in a)D(u,g,a[g],h);return u}e.toValuesTree=S;function D(a,h,u,g){const y=h.split("."),L=y.pop();let n=a;for(let s=0;s<y.length;s++){const t=y[s];let i=n[t];switch(typeof i){case"undefined":i=n[t]=Object.create(null);break;case"object":break;default:g(`Ignoring ${h} as ${y.slice(0,s+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[L]=u}catch{g(`Ignoring ${h} as ${y.join(".")} is ${JSON.stringify(n)}`)}else g(`Ignoring ${h} as ${y.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=D;function w(a,h){const u=h.split(".");m(a,u)}e.removeFromValueTree=w;function m(a,h){const u=h.shift();if(h.length===0){delete a[u];return}if(Object.keys(a).indexOf(u)!==-1){const g=a[u];typeof g=="object"&&!Array.isArray(g)&&(m(g,h),Object.keys(g).length===0&&delete a[u])}}function f(a,h,u){function g(n,s){let t=n;for(const i of s){if(typeof t!="object"||t===null)return;t=t[i]}return t}const y=h.split("."),L=g(a,y);return typeof L>"u"?u:L}e.getConfigurationValue=f;function p(a,h,u){Object.keys(h).forEach(g=>{g!=="__proto__"&&(g in a?T.isObject(a[g])&&T.isObject(h[g])?p(a[g],h[g],u):u&&(a[g]=h[g]):a[g]=h[g])})}e.merge=p;function b(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(oe[70],ae([0,1,4,27,186,5,152,9]),function(ie,e,T,O,l,A,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",T.isMacintosh),P.set("isLinux",T.isLinux),P.set("isWindows",T.isWindows),P.set("isWeb",T.isWeb),P.set("isMacNative",T.isMacintosh&&!T.isWeb),P.set("isEdge",T.isEdge),P.set("isFirefox",T.isFirefox),P.set("isChrome",T.isChrome),P.set("isSafari",T.isSafari);function S(M,C){if(P.get(M)!==void 0)throw(0,k.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set(M,C)}e.setConstant=S;const D=Object.prototype.hasOwnProperty;var w;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const m={regexParsingWithErrorRecovery:!0},f=(0,_.localize)(0,null),p=(0,_.localize)(1,null),b=(0,_.localize)(2,null),a=(0,_.localize)(3,null),h=(0,_.localize)(4,null),u=(0,_.localize)(5,null),g=(0,_.localize)(6,null),y=(0,_.localize)(7,null);class L{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(C=m){this._config=C,this._scanner=new l.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(C){if(C===""){this._parsingErrors.push({message:f,offset:0,lexeme:"",additionalInfo:p});return}this._tokens=this._scanner.reset(C).scan(),this._current=0,this._parsingErrors=[];try{const U=this._expr();if(!this._isAtEnd()){const z=this._peek(),H=z.type===17?u:void 0;throw this._parsingErrors.push({message:h,offset:z.offset,lexeme:l.Scanner.getLexeme(z),additionalInfo:H}),L._parseError}return U}catch(U){if(U!==L._parseError)throw U;return}}_expr(){return this._or()}_or(){const C=[this._and()];for(;this._matchOne(16);){const U=this._and();C.push(U)}return C.length===1?C[0]:n.or(...C)}_and(){const C=[this._term()];for(;this._matchOne(15);){const U=this._term();C.push(U)}return C.length===1?C[0]:n.and(...C)}_term(){if(this._matchOne(2)){const C=this._peek();switch(C.type){case 11:return this._advance(),r.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const U=this._expr();return this._consume(1,a),U?.negate()}case 17:return this._advance(),R.create(C.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",C)}}return this._primary()}_primary(){const C=this._peek();switch(C.type){case 11:return this._advance(),n.true();case 12:return this._advance(),n.false();case 0:{this._advance();const U=this._expr();return this._consume(1,a),U}case 17:{const U=C.lexeme;if(this._advance(),this._matchOne(9)){const H=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),H.type!==10)throw this._errExpectedButGot("REGEX",H);const V=H.lexeme,X=V.lastIndexOf("/"),ee=X===V.length-1?void 0:this._removeFlagsGY(V.substring(X+1));let ce;try{ce=new RegExp(V.substring(1,X),ee)}catch{throw this._errExpectedButGot("REGEX",H)}return Q.create(U,ce)}switch(H.type){case 10:case 19:{const V=[H.lexeme];this._advance();let X=this._peek(),ee=0;for(let ye=0;ye<H.lexeme.length;ye++)H.lexeme.charCodeAt(ye)===40?ee++:H.lexeme.charCodeAt(ye)===41&&ee--;for(;!this._isAtEnd()&&X.type!==15&&X.type!==16;){switch(X.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let ye=0;ye<X.lexeme.length;ye++)X.lexeme.charCodeAt(ye)===40?ee++:H.lexeme.charCodeAt(ye)===41&&ee--}if(ee<0)break;V.push(l.Scanner.getLexeme(X)),this._advance(),X=this._peek()}const ce=V.join(""),ue=ce.lastIndexOf("/"),fe=ue===ce.length-1?void 0:this._removeFlagsGY(ce.substring(ue+1));let ve;try{ve=new RegExp(ce.substring(1,ue),fe)}catch{throw this._errExpectedButGot("REGEX",H)}return n.regex(U,ve)}case 18:{const V=H.lexeme;this._advance();let X=null;if(!(0,O.isFalsyOrWhitespace)(V)){const ee=V.indexOf("/"),ce=V.lastIndexOf("/");if(ee!==ce&&ee>=0){const ue=V.slice(ee+1,ce),fe=V[ce+1]==="i"?"i":"";try{X=new RegExp(ue,fe)}catch{throw this._errExpectedButGot("REGEX",H)}}}if(X===null)throw this._errExpectedButGot("REGEX",H);return Q.create(U,X)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,b);const H=this._value();return n.notIn(U,H)}switch(this._peek().type){case 3:{this._advance();const H=this._value();if(this._previous().type===18)return n.equals(U,H);switch(H){case"true":return n.has(U);case"false":return n.not(U);default:return n.equals(U,H)}}case 4:{this._advance();const H=this._value();if(this._previous().type===18)return n.notEquals(U,H);switch(H){case"true":return n.not(U);case"false":return n.has(U);default:return n.notEquals(U,H)}}case 5:return this._advance(),q.create(U,this._value());case 6:return this._advance(),B.create(U,this._value());case 7:return this._advance(),F.create(U,this._value());case 8:return this._advance(),W.create(U,this._value());case 13:return this._advance(),n.in(U,this._value());default:return n.has(U)}}case 20:throw this._parsingErrors.push({message:g,offset:C.offset,lexeme:"",additionalInfo:y}),L._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const C=this._peek();switch(C.type){case 17:case 18:return this._advance(),C.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(C){return C.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(C){return this._check(C)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(C,U){if(this._check(C))return this._advance();throw this._errExpectedButGot(U,this._peek())}_errExpectedButGot(C,U,z){const H=(0,_.localize)(8,null,C,l.Scanner.getLexeme(U)),V=U.offset,X=l.Scanner.getLexeme(U);return this._parsingErrors.push({message:H,offset:V,lexeme:X,additionalInfo:z}),L._parseError}_check(C){return this._peek().type===C}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=L,L._parseError=new Error;class n{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(C){return c.create(C)}static equals(C,U){return v.create(C,U)}static notEquals(C,U){return I.create(C,U)}static regex(C,U){return Q.create(C,U)}static in(C,U){return E.create(C,U)}static notIn(C,U){return d.create(C,U)}static not(C){return R.create(C)}static and(...C){return x.create(C,null,!0)}static or(...C){return $.create(C,null,!0)}static greater(C,U){return F.create(C,U)}static greaterEquals(C,U){return W.create(C,U)}static smaller(C,U){return q.create(C,U)}static smallerEquals(C,U){return B.create(C,U)}static deserialize(C){return C==null?void 0:this._parser.parse(C)}}e.ContextKeyExpr=n,n._parser=new L({regexParsingWithErrorRecovery:!1});function s(M){const C=new L({regexParsingWithErrorRecovery:!1});return M.map(U=>(C.parse(U),C.lexingErrors.length>0?C.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,_.localize)(9,null,z.additionalInfo):(0,_.localize)(10,null),offset:z.offset,length:z.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.validateWhenClauses=s;function t(M,C){const U=M?M.substituteConstants():void 0,z=C?C.substituteConstants():void 0;return!U&&!z?!0:!U||!z?!1:U.equals(z)}e.expressionsAreEqualWithConstantSubstitution=t;function i(M,C){return M.cmp(C)}class r{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=r,r.INSTANCE=new r;class o{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class c{static create(C,U=null){const z=P.get(C);return typeof z=="boolean"?z?o.INSTANCE:r.INSTANCE:new c(C,U)}constructor(C,U){this.key=C,this.negated=U,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:te(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=P.get(this.key);return typeof C=="boolean"?C?o.INSTANCE:r.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.negated||(this.negated=R.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=c;class v{static create(C,U,z=null){if(typeof U=="boolean")return U?c.create(C,z):R.create(C,z);const H=P.get(C);return typeof H=="boolean"?U===(H?"true":"false")?o.INSTANCE:r.INSTANCE:new v(C,U,z)}constructor(C,U,z){this.key=C,this.value=U,this.negated=z,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=P.get(this.key);if(typeof C=="boolean"){const U=C?"true":"false";return this.value===U?o.INSTANCE:r.INSTANCE}return this}evaluate(C){return C.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(C){return C.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=v;class E{static create(C,U){return new E(C,U)}constructor(C,U){this.key=C,this.valueKey=U,this.type=10,this.negated=null}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.valueKey,C.key,C.valueKey)}equals(C){return C.type===this.type?this.key===C.key&&this.valueKey===C.valueKey:!1}substituteConstants(){return this}evaluate(C){const U=C.getValue(this.valueKey),z=C.getValue(this.key);return Array.isArray(U)?U.includes(z):typeof z=="string"&&typeof U=="object"&&U!==null?D.call(U,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(C){return C.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=E;class d{static create(C,U){return new d(C,U)}constructor(C,U){this.key=C,this.valueKey=U,this.type=11,this._negated=E.create(C,U)}cmp(C){return C.type!==this.type?this.type-C.type:this._negated.cmp(C._negated)}equals(C){return C.type===this.type?this._negated.equals(C._negated):!1}substituteConstants(){return this}evaluate(C){return!this._negated.evaluate(C)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(C){return C.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=d;class I{static create(C,U,z=null){if(typeof U=="boolean")return U?R.create(C,z):c.create(C,z);const H=P.get(C);return typeof H=="boolean"?U===(H?"true":"false")?r.INSTANCE:o.INSTANCE:new I(C,U,z)}constructor(C,U,z){this.key=C,this.value=U,this.negated=z,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=P.get(this.key);if(typeof C=="boolean"){const U=C?"true":"false";return this.value===U?r.INSTANCE:o.INSTANCE}return this}evaluate(C){return C.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(C){return C.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=I;class R{static create(C,U=null){const z=P.get(C);return typeof z=="boolean"?z?r.INSTANCE:o.INSTANCE:new R(C,U)}constructor(C,U){this.key=C,this.negated=U,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:te(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=P.get(this.key);return typeof C=="boolean"?C?r.INSTANCE:o.INSTANCE:this}evaluate(C){return!C.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(C){return C.mapNot(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=R;function N(M,C){if(typeof M=="string"){const U=parseFloat(M);isNaN(U)||(M=U)}return typeof M=="string"||typeof M=="number"?C(M):r.INSTANCE}class F{static create(C,U,z=null){return N(U,H=>new F(C,H,z))}constructor(C,U,z){this.key=C,this.value=U,this.negated=z,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=F;class W{static create(C,U,z=null){return N(U,H=>new W(C,H,z))}constructor(C,U,z){this.key=C,this.value=U,this.negated=z,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=W;class q{static create(C,U,z=null){return N(U,H=>new q(C,H,z))}constructor(C,U,z){this.key=C,this.value=U,this.negated=z,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=W.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=q;class B{static create(C,U,z=null){return N(U,H=>new B(C,H,z))}constructor(C,U,z){this.key=C,this.value=U,this.negated=z,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=B;class Q{static create(C,U){return new Q(C,U)}constructor(C,U){this.key=C,this.regexp=U,this.type=7,this.negated=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.key<C.key)return-1;if(this.key>C.key)return 1;const U=this.regexp?this.regexp.source:"",z=C.regexp?C.regexp.source:"";return U<z?-1:U>z?1:0}equals(C){if(C.type===this.type){const U=this.regexp?this.regexp.source:"",z=C.regexp?C.regexp.source:"";return this.key===C.key&&U===z}return!1}substituteConstants(){return this}evaluate(C){const U=C.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const C=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${C}`}keys(){return[this.key]}map(C){return C.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=Z.create(this)),this.negated}}e.ContextKeyRegexExpr=Q;class Z{static create(C){return new Z(C)}constructor(C){this._actual=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(C){return new Z(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=Z;function K(M){let C=null;for(let U=0,z=M.length;U<z;U++){const H=M[U].substituteConstants();if(M[U]!==H&&C===null){C=[];for(let V=0;V<U;V++)C[V]=M[V]}C!==null&&(C[U]=H)}return C===null?M:C}class x{static create(C,U,z){return x._normalizeArr(C,U,z)}constructor(C,U){this.expr=C,this.negated=U,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let U=0,z=this.expr.length;U<z;U++){const H=i(this.expr[U],C.expr[U]);if(H!==0)return H}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].equals(C.expr[U]))return!1;return!0}return!1}substituteConstants(){const C=K(this.expr);return C===this.expr?this:x.create(C,this.negated,!1)}evaluate(C){for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].evaluate(C))return!1;return!0}static _normalizeArr(C,U,z){const H=[];let V=!1;for(const X of C)if(X){if(X.type===1){V=!0;continue}if(X.type===0)return r.INSTANCE;if(X.type===6){H.push(...X.expr);continue}H.push(X)}if(H.length===0&&V)return o.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(i);for(let X=1;X<H.length;X++)H[X-1].equals(H[X])&&(H.splice(X,1),X--);if(H.length===1)return H[0];for(;H.length>1;){const X=H[H.length-1];if(X.type!==9)break;H.pop();const ee=H.pop(),ce=H.length===0,ue=$.create(X.expr.map(fe=>x.create([fe,ee],null,z)),null,ce);ue&&(H.push(ue),H.sort(i))}if(H.length===1)return H[0];if(z){for(let X=0;X<H.length;X++)for(let ee=X+1;ee<H.length;ee++)if(H[X].negate().equals(H[ee]))return r.INSTANCE;if(H.length===1)return H[0]}return new x(H,U)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const U of this.expr)C.push(...U.keys());return C}map(C){return new x(this.expr.map(U=>U.map(C)),null)}negate(){if(!this.negated){const C=[];for(const U of this.expr)C.push(U.negate());this.negated=$.create(C,this,!0)}return this.negated}}e.ContextKeyAndExpr=x;class ${static create(C,U,z){return $._normalizeArr(C,U,z)}constructor(C,U){this.expr=C,this.negated=U,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let U=0,z=this.expr.length;U<z;U++){const H=i(this.expr[U],C.expr[U]);if(H!==0)return H}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].equals(C.expr[U]))return!1;return!0}return!1}substituteConstants(){const C=K(this.expr);return C===this.expr?this:$.create(C,this.negated,!1)}evaluate(C){for(let U=0,z=this.expr.length;U<z;U++)if(this.expr[U].evaluate(C))return!0;return!1}static _normalizeArr(C,U,z){let H=[],V=!1;if(C){for(let X=0,ee=C.length;X<ee;X++){const ce=C[X];if(ce){if(ce.type===0){V=!0;continue}if(ce.type===1)return o.INSTANCE;if(ce.type===9){H=H.concat(ce.expr);continue}H.push(ce)}}if(H.length===0&&V)return r.INSTANCE;H.sort(i)}if(H.length!==0){if(H.length===1)return H[0];for(let X=1;X<H.length;X++)H[X-1].equals(H[X])&&(H.splice(X,1),X--);if(H.length===1)return H[0];if(z){for(let X=0;X<H.length;X++)for(let ee=X+1;ee<H.length;ee++)if(H[X].negate().equals(H[ee]))return o.INSTANCE;if(H.length===1)return H[0]}return new $(H,U)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const U of this.expr)C.push(...U.keys());return C}map(C){return new $(this.expr.map(U=>U.map(C)),null)}negate(){if(!this.negated){const C=[];for(const U of this.expr)C.push(U.negate());for(;C.length>1;){const U=C.shift(),z=C.shift(),H=[];for(const V of G(U))for(const X of G(z))H.push(x.create([V,X],null,!1));C.unshift($.create(H,null,!1))}this.negated=$.create(C,this,!0)}return this.negated}}e.ContextKeyOrExpr=$;class j extends c{static all(){return j._info.values()}constructor(C,U,z){super(C,null),this._defaultValue=U,typeof z=="object"?j._info.push({...z,key:C}):z!==!0&&j._info.push({key:C,description:z,type:U!=null?typeof U:void 0})}bindTo(C){return C.createKey(this.key,this._defaultValue)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return v.create(this.key,C)}notEqualsTo(C){return I.create(this.key,C)}}e.RawContextKey=j,j._info=[],e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function te(M,C){return M<C?-1:M>C?1:0}function ne(M,C,U,z){return M<U?-1:M>U?1:C<z?-1:C>z?1:0}function se(M,C){if(M.type===0||C.type===1)return!0;if(M.type===9)return C.type===9?J(M.expr,C.expr):!1;if(C.type===9){for(const U of C.expr)if(se(M,U))return!0;return!1}if(M.type===6){if(C.type===6)return J(C.expr,M.expr);for(const U of M.expr)if(se(U,C))return!0;return!1}return M.equals(C)}e.implies=se;function J(M,C){let U=0,z=0;for(;U<M.length&&z<C.length;){const H=M[U].cmp(C[z]);if(H<0)return!1;H===0&&U++,z++}return U===M.length}function G(M){return M.type===9?M.expr:[M]}}),define(oe[99],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,T.createDecorator)(e.ID);function O(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=O;class l{async getPerformanceInfo(_,k){return{}}async getSystemInfo(_,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(_,k){return""}async getWorkspaceFileExtensions(_){return{extensions:[]}}async reportWorkspaceStats(_){}}e.NullDiagnosticsService=l}),define(oe[100],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(oe[15],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[29],ae([0,1,157,5]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function _(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function k(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function P(u,g,y){return k(g,y)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===y?!0:S(y).includes(u)}e.isTargetPlatformCompatible=P;function S(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function D(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=D;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var f;(function(u){u.Install="install",u.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var p;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var b;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var a;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class h extends Error{constructor(g,y){super(g),this.code=y,this.name=y}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,T.localize)(1,null),original:"Preferences"}}),define(oe[196],ae([0,1,3,2,31,12,93,29]),function(ie,e,T,O,l,A,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(a,h){return a?A.URI.revive(h?h.transformIncoming(a):a):void 0}function S(a,h){return h?h.transformOutgoingURI(a):a}function D(a,h){h=h||_.DefaultURITransformer;const u=a.manifest;return{...(0,_.transformAndReviveIncomingURIs)({...a,manifest:void 0},h),manifest:u}}function w(a,h){return a?.profileLocation?(0,_.transformAndReviveIncomingURIs)(a,h??_.DefaultURITransformer):a}function m(a,h){return h?(0,l.cloneAndChange)(a,u=>u instanceof A.URI?h.transformOutgoingURI(u):void 0):a}class f{constructor(h,u){this.service=h,this.getUriTransformer=u,this.onInstallExtension=T.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=T.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=T.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=T.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=T.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,u){const g=this.getUriTransformer(h);switch(u){case"onInstallExtension":return T.Event.map(this.onInstallExtension,y=>({...y,profileLocation:y.profileLocation?S(y.profileLocation,g):y.profileLocation}));case"onDidInstallExtensions":return T.Event.map(this.onDidInstallExtensions,y=>y.map(L=>({...L,local:L.local?m(L.local,g):L.local,profileLocation:L.profileLocation?S(L.profileLocation,g):L.profileLocation})));case"onUninstallExtension":return T.Event.map(this.onUninstallExtension,y=>({...y,profileLocation:y.profileLocation?S(y.profileLocation,g):y.profileLocation}));case"onDidUninstallExtension":return T.Event.map(this.onDidUninstallExtension,y=>({...y,profileLocation:y.profileLocation?S(y.profileLocation,g):y.profileLocation}));case"onDidUpdateExtensionMetadata":return T.Event.map(this.onDidUpdateExtensionMetadata,y=>m(y,g))}throw new Error("Invalid listen")}async call(h,u,g){const y=this.getUriTransformer(h);switch(u){case"zip":{const L=D(g[0],y),n=await this.service.zip(L);return S(n,y)}case"unzip":return this.service.unzip(P(g[0],y));case"install":return this.service.install(P(g[0],y),w(g[1],y));case"installFromLocation":return this.service.installFromLocation(P(g[0],y),P(g[1],y));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(g[0],P(g[1],y),P(g[2],y));case"getManifest":return this.service.getManifest(P(g[0],y));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(g[0]);case"installFromGallery":return this.service.installFromGallery(g[0],w(g[1],y));case"uninstall":return this.service.uninstall(D(g[0],y),w(g[1],y));case"reinstallFromGallery":return this.service.reinstallFromGallery(D(g[0],y));case"getInstalled":return(await this.service.getInstalled(g[0],P(g[1],y))).map(n=>m(n,y));case"copyExtensions":return this.service.copyExtensions(P(g[0],y),P(g[1],y));case"updateMetadata":{const L=await this.service.updateMetadata(D(g[0],y),g[1],P(g[2],y));return m(L,y)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(g[0],g[1],g[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class p extends O.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(h){super(),this.channel=h,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this._onDidUpdateExtensionMetadata=this._register(new T.Emitter),this._register(this.channel.listen("onInstallExtension")(u=>this.fireEvent(this._onInstallExtension,{...u,source:this.isUriComponents(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(u=>this.fireEvent(this._onDidInstallExtensions,u.map(g=>({...g,local:g.local?D(g.local,null):g.local,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source,profileLocation:A.URI.revive(g.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(u=>this.fireEvent(this._onUninstallExtension,{...u,profileLocation:A.URI.revive(u.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(u=>this.fireEvent(this._onDidUninstallExtension,{...u,profileLocation:A.URI.revive(u.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(u=>this._onDidUpdateExtensionMetadata.fire(D(u,null))))}fireEvent(h,u){h.fire(u)}isUriComponents(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(h){const u=await this.getTargetPlatform();return h.allTargetPlatforms.some(g=>(0,k.isTargetPlatformCompatible)(g,h.allTargetPlatforms,u))}zip(h){return Promise.resolve(this.channel.call("zip",[h]).then(u=>A.URI.revive(u)))}unzip(h){return Promise.resolve(this.channel.call("unzip",[h]))}install(h,u){return Promise.resolve(this.channel.call("install",[h,u])).then(g=>D(g,null))}installFromLocation(h,u){return Promise.resolve(this.channel.call("installFromLocation",[h,u])).then(g=>D(g,null))}async installExtensionsFromProfile(h,u,g){return(await this.channel.call("installExtensionsFromProfile",[h,u,g])).map(L=>D(L,null))}getManifest(h){return Promise.resolve(this.channel.call("getManifest",[h]))}installFromGallery(h,u){return Promise.resolve(this.channel.call("installFromGallery",[h,u])).then(g=>D(g,null))}uninstall(h,u){return Promise.resolve(this.channel.call("uninstall",[h,u]))}reinstallFromGallery(h){return Promise.resolve(this.channel.call("reinstallFromGallery",[h])).then(u=>D(u,null))}getInstalled(h=null,u){return Promise.resolve(this.channel.call("getInstalled",[h,u])).then(g=>g.map(y=>D(y,null)))}updateMetadata(h,u,g){return Promise.resolve(this.channel.call("updateMetadata",[h,u,g])).then(y=>D(y,null))}copyExtensions(h,u){return this.channel.call("copyExtensions",[h,u])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(h,u,g){const y=await this.channel.call("download",[h,u,g]);return A.URI.revive(y)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class b{constructor(h){this.service=h}listen(h,u){throw new Error("Invalid listen")}call(h,u,g){switch(u){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(oe[101],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class O{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((A,_)=>ie(["node-vsce-sign"],async k=>A(k),_))),this.moduleLoadingPromise}async verify(A,_,k){let P;try{P=await this.vsceSign()}catch{return!1}return P.verify(A,_,k)}}e.ExtensionSignatureVerificationService=O}),define(oe[102],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var O;(function(_){_[_.FILE=1]="FILE",_[_.WORKSPACE=2]="WORKSPACE",_[_.EXE=3]="EXE"})(O||(e.RecommendationSource=O={}));function l(_){switch(_){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=l;var A;(function(_){_.Ignored="ignored",_.Cancelled="cancelled",_.TooMany="toomany",_.IncompatibleWindow="incompatibleWindow",_.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.IExtensionRecommendationNotificationService=(0,T.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[13],ae([0,1,48,14,27,11,12,164,5,4,22]),function(ie,e,T,O,l,A,_,k,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function w(x){return x.create===!0}e.isFileOpenForWriteOptions=w;var m;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var f;(function(x){x[x.Readonly=1]="Readonly"})(f||(e.FilePermission=f={}));var p;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileClone=32768]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function b(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=b;function a(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=a;function h(x){return!!(x.capabilities&32768)}e.hasFileCloneCapability=h;function u(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function g(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=g;function y(x){return b(x)?!!(x.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var L;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(L||(e.FileSystemProviderErrorCode=L={}));class n extends Error{static create($,j){const te=new n($.toString(),j);return i(te,j),te}constructor($,j){super($),this.code=j}}e.FileSystemProviderError=n;function s(x,$){return n.create(x,$)}e.createFileSystemProviderError=s;function t(x){return x||s((0,k.localize)(0,null),L.Unknown)}e.ensureFileSystemProviderError=t;function i(x,$){return x.name=$?`${$} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=i;function r(x){if(!x)return L.Unknown;if(x instanceof n)return x.code;const $=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!$)return L.Unknown;switch($[1]){case L.FileExists:return L.FileExists;case L.FileIsADirectory:return L.FileIsADirectory;case L.FileNotADirectory:return L.FileNotADirectory;case L.FileNotFound:return L.FileNotFound;case L.FileTooLarge:return L.FileTooLarge;case L.FileWriteLocked:return L.FileWriteLocked;case L.NoPermissions:return L.NoPermissions;case L.Unavailable:return L.Unavailable}return L.Unknown}e.toFileSystemProviderErrorCode=r;function o(x){if(x instanceof R)return x.fileOperationResult;switch(r(x)){case L.FileNotFound:return 1;case L.FileIsADirectory:return 0;case L.FileNotADirectory:return 9;case L.FileWriteLocked:return 5;case L.NoPermissions:return 6;case L.FileExists:return 4;case L.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=o;var c;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(c||(e.FileOperation=c={}));class v{constructor($,j,te){this.resource=$,this.operation=j,this.target=te}isOperation($){return this.operation===$}}e.FileOperationEvent=v;var E;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(E||(e.FileChangeType=E={}));class d{constructor($,j){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const te=new Map;for(const ne of $){const se=te.get(ne.type);switch(se?se.push([ne.resource,ne]):te.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,se]of te)switch(ne){case 1:this.added=T.TernarySearchTree.forUris(()=>j),this.added.fill(se);break;case 0:this.updated=T.TernarySearchTree.forUris(()=>j),this.updated.fill(se);break;case 2:this.deleted=T.TernarySearchTree.forUris(()=>j),this.deleted.fill(se);break}}contains($,...j){return this.doContains($,{includeChildren:!1},...j)}affects($,...j){return this.doContains($,{includeChildren:!0},...j)}doContains($,j,...te){if(!$)return!1;const ne=te.length>0;return!!((!ne||te.includes(1))&&(this.added?.get($)||j.includeChildren&&this.added?.findSuperstr($))||(!ne||te.includes(0))&&(this.updated?.get($)||j.includeChildren&&this.updated?.findSuperstr($))||(!ne||te.includes(2))&&(this.deleted?.findSubstr($)||j.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function I(x,$,j){return!x||!$||x===$||$.length>x.length?!1:($.charAt($.length-1)!==O.sep&&($+=O.sep),j?(0,l.startsWithIgnoreCase)(x,$):x.indexOf($)===0)}e.isParent=I;class R extends Error{constructor($,j,te){super($),this.fileOperationResult=j,this.options=te}}e.FileOperationError=R;class N extends R{constructor($,j,te,ne){super($,j,ne),this.fileOperationResult=j,this.size=te}}e.TooLargeFileOperationError=N;class F extends R{constructor($,j,te){super($,2,te),this.stat=j}}e.NotModifiedSinceFileOperationError=F;var W;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var q;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.ETAG_DISABLED="";function B(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=B;async function Q(x,$){if(!$.hasProvider(_.URI.from({scheme:x.scheme})))return new Promise(j=>{const te=$.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===x.scheme&&ne.added&&(te.dispose(),j())})})}e.whenProviderRegistered=Q;class Z{static formatSize($){return(0,A.isNumber)($)||($=0),$<Z.KB?(0,k.localize)(1,null,$.toFixed(0)):$<Z.MB?(0,k.localize)(2,null,($/Z.KB).toFixed(2)):$<Z.GB?(0,k.localize)(3,null,($/Z.MB).toFixed(2)):$<Z.TB?(0,k.localize)(4,null,($/Z.GB).toFixed(2)):(0,k.localize)(5,null,($/Z.TB).toFixed(2))}}e.ByteSize=Z,Z.KB=1024,Z.MB=Z.KB*Z.KB,Z.GB=Z.MB*Z.KB,Z.TB=Z.GB*Z.KB;function K(x){const $=typeof x=="string"||x?.scheme===D.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===D.Schemas.file?1024*Z.MB:$?10*Z.MB:S.isWeb?50*Z.MB:1024*Z.MB}e.getLargeFileConfirmationLimit=K});var Y=this&&this.__param||function(ie,e){return function(T,O){e(T,O,ie)}};define(oe[197],ae([0,1,71,43,13]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=e.ChecksumService=class{constructor(k){this.fileService=k}async checksum(k){const P=(await this.fileService.readFileStream(k)).value;return new Promise((S,D)=>{const w=(0,T.createHash)("md5");(0,O.listenStream)(P,{onData:m=>w.update(m.buffer),onError:m=>D(m),onEnd:()=>S(w.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=A=Se([Y(0,l.IFileService)],A)}),define(oe[198],ae([0,1,16,38,9,3,2,43,12,32,13]),function(ie,e,T,O,l,A,_,k,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends _.Disposable{constructor(f,p){super(),this.channel=f,this.extraCapabilities=p,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,S.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(f){return this.channel.call("stat",[f])}readdir(f){return this.channel.call("readdir",[f])}async readFile(f,p){const{buffer:b}=await this.channel.call("readFile",[f,p]);return b}readFileStream(f,p,b){const a=(0,k.newWriteableStream)(u=>T.VSBuffer.concat(u.map(g=>T.VSBuffer.wrap(g))).buffer),h=this.channel.listen("readFileStream",[f,p])(u=>{if(u instanceof T.VSBuffer)a.write(u.buffer);else{if(u==="end")a.end();else{let g;if(u instanceof Error)g=u;else{const y=u;g=(0,D.createFileSystemProviderError)(y.message??(0,O.toErrorMessage)(y),y.code??D.FileSystemProviderErrorCode.Unknown)}a.error(g),a.end()}h.dispose()}});return b.onCancellationRequested(()=>{a.error((0,l.canceled)()),a.end(),h.dispose()}),a}writeFile(f,p,b){return this.channel.call("writeFile",[f,T.VSBuffer.wrap(p),b])}open(f,p){return this.channel.call("open",[f,p])}close(f){return this.channel.call("close",[f])}async read(f,p,b,a,h){const[u,g]=await this.channel.call("read",[f,p,h]);return b.set(u.buffer.slice(0,g),a),g}write(f,p,b,a,h){return this.channel.call("write",[f,p,T.VSBuffer.wrap(b),a,h])}mkdir(f){return this.channel.call("mkdir",[f])}delete(f,p){return this.channel.call("delete",[f,p])}rename(f,p,b){return this.channel.call("rename",[f,p,b])}copy(f,p,b){return this.channel.call("copy",[f,p,b])}cloneFile(f,p){return this.channel.call("cloneFile",[f,p])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(f=>{if(Array.isArray(f)){const p=f;this._onDidChange.fire(p.map(b=>({resource:P.URI.revive(b.resource),type:b.type})))}else{const p=f;this._onDidWatchError.fire(p)}}))}watch(f,p){const b=(0,S.generateUuid)();return this.channel.call("watch",[this.sessionId,b,f,p]),(0,_.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,b]))}}e.DiskFileSystemProviderClient=w}),define(oe[103],ae([0,1,16,9,165,13]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function _(D,w,m,f,p,b){let a;try{await k(D,w,m,f,p,b)}catch(h){a=h}finally{a&&p.errorTransformer&&(a=p.errorTransformer(a)),typeof a<"u"&&m.error(a),m.end()}}e.readFileIntoStream=_;async function k(D,w,m,f,p,b){P(b);const a=await D.open(w,{create:!1});try{P(b);let h=0,u=0,g=p&&typeof p.length=="number"?p.length:void 0,y=T.VSBuffer.alloc(Math.min(p.bufferSize,typeof g=="number"?g:p.bufferSize)),L=p&&typeof p.position=="number"?p.position:0,n=0;do u=await D.read(a,L,y.buffer,n,y.byteLength-n),L+=u,n+=u,h+=u,typeof g=="number"&&(g-=u),n===y.byteLength&&(await m.write(f(y)),y=T.VSBuffer.alloc(Math.min(p.bufferSize,typeof g=="number"?g:p.bufferSize)),n=0);while(u>0&&(typeof g!="number"||g>0)&&P(b)&&S(h,p));if(n>0){let s=n;typeof g=="number"&&(s=Math.min(n,g)),m.write(f(y.slice(0,s)))}}catch(h){throw(0,A.ensureFileSystemProviderError)(h)}finally{await D.close(a)}}function P(D){if(D.isCancellationRequested)throw(0,O.canceled)();return!0}function S(D,w){if(typeof w?.limits?.size=="number"&&D>w.limits.size)throw(0,A.createFileSystemProviderError)((0,l.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[55],ae([0,1,92,2,14,4,12,13]),function(ie,e,T,O,l,A,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(h){return h.recursive===!0}e.isRecursiveWatchRequest=P;class S extends O.Disposable{constructor(u,g,y,L){super(),this.onFileChanges=u,this.onLogMessage=g,this.verboseLogging=y,this.options=L,this.watcherDisposables=this._register(new O.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const u=new O.DisposableStore;this.watcherDisposables.value=u,this.watcher=this.createWatcher(u),this.watcher.setVerboseLogging(this.verboseLogging),u.add(this.watcher.onDidChangeFile(g=>this.onFileChanges(g))),u.add(this.watcher.onDidLogMessage(g=>this.onLogMessage(g))),u.add(this.watcher.onDidError(g=>this.onError(g)))}onError(u){this.options.restartOnError?this.restartCounter<S.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${u}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${u}`):this.error(u)}restart(u){this.restartCounter++,this.init(),this.watch(u)}async watch(u){this.requests=u,await this.watcher?.watch(u)}async setVerboseLogging(u){this.verboseLogging=u,await this.watcher?.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${u}`})}trace(u){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${u}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.MAX_RESTARTS=5;class D extends S{constructor(u,g,y){super(u,g,y,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=D;class w extends S{constructor(u,g,y){super(u,g,y,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function m(h){return h.map(u=>({type:u.type,resource:_.URI.file(u.path)}))}e.toFileChanges=m;function f(h){const u=new a;for(const g of h)u.processEvent(g);return u.coalesce()}e.coalesceEvents=f;function p(h,u){return typeof u=="string"&&!u.startsWith(T.GLOBSTAR)&&!(0,l.isAbsolute)(u)?{base:h,pattern:u}:u}e.normalizeWatcherPattern=p;function b(h,u){const g=[];for(const y of u)g.push((0,T.parse)(p(h,y)));return g}e.parseWatcherPatterns=b;class a{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(u){return A.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const g=this.mapPathToChange.get(this.toKey(u));let y=!1;if(g){const L=g.type,n=u.type;g.path!==u.path&&(u.type===2||u.type===1)?y=!0:L===1&&n===2?(this.mapPathToChange.delete(this.toKey(u)),this.coalesced.delete(g)):L===2&&n===1?g.type=0:L===1&&n===0||(g.type=n)}else y=!0;y&&(this.coalesced.add(u),this.mapPathToChange.set(this.toKey(u),u))}coalesce(){const u=[],g=[];return Array.from(this.coalesced).filter(y=>y.type!==2?(u.push(y),!1):!0).sort((y,L)=>y.path.length-L.path.length).filter(y=>g.some(L=>(0,k.isParent)(y.path,L,!A.isLinux))?!1:(g.push(y.path),!0)).concat(u)}}}),define(oe[199],ae([0,1,53,6,26,47,2,87,14,4,146,28,55]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends _.Disposable{constructor(a,h,u,g){super(),this.request=a,this.onDidFilesChange=h,this.onLogMessage=u,this.verboseLogging=g,this.throttledFileChangesEmitter=this._register(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},y=>this.onDidFilesChange(y))),this.fileChangesAggregator=this._register(new O.RunOnceWorker(y=>this.handleFileChanges(y),f.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,m.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,m.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new l.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const a=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const h=await w.Promises.stat(a);this._register(await this.doWatch(a,h.isDirectory()))}catch(a){a.code!=="ENOENT"?this.error(a):this.trace(a)}}async normalizePath(a){let h=a.path;try{h=await w.Promises.realpath(a.path),a.path===h&&(h=await(0,D.realcase)(a.path)??a.path),a.path!==h&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${h})`)}catch{}return h}async doWatch(a,h){if(S.isMacintosh&&(0,A.isEqualOrParent)(a,"/Volumes/",!0))return this.error(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),_.Disposable.None;const u=new l.CancellationTokenSource(this.cts.token),g=new _.DisposableStore;try{const y=(0,P.basename)(a),L=(0,T.watch)(a);g.add((0,_.toDisposable)(()=>{L.removeAllListeners(),L.close()})),this.trace(`Started watching: '${a}'`);const n=new Set;if(h)try{for(const t of await w.Promises.readdir(a))n.add(t)}catch(t){this.error(t)}const s=new Map;g.add((0,_.toDisposable)(()=>{for(const[,t]of s)t.dispose();s.clear()})),L.on("error",(t,i)=>{this.error(`Failed to watch ${a} for changes using fs.watch() (${t}, ${i})`),this.dispose()}),L.on("change",(t,i)=>{if(u.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${i}`);let r="";if(i&&(r=i.toString(),S.isMacintosh&&(r=(0,k.normalizeNFC)(r))),!(!r||t!=="change"&&t!=="rename"))if(h)if(t==="rename"){s.get(r)?.dispose();const o=setTimeout(async()=>{if(s.delete(r),r===y&&!await w.Promises.exists(a)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.existsChildStrictCase((0,P.join)(a,r));if(u.token.isCancellationRequested)return;let v;c?n.has(r)?v=0:(v=1,n.add(r)):(n.delete(r),v=2),this.onFileChange({path:(0,P.join)(this.request.path,r),type:v})},f.FILE_DELETE_HANDLER_DELAY);s.set(r,(0,_.toDisposable)(()=>clearTimeout(o)))}else{let o;n.has(r)?o=0:(o=1,n.add(r)),this.onFileChange({path:(0,P.join)(this.request.path,r),type:o})}else if(t==="rename"||r!==y){const o=setTimeout(async()=>{const c=await w.Promises.exists(a);u.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0},!0),g.add(await this.doWatch(a,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},f.FILE_DELETE_HANDLER_DELAY);g.clear(),g.add((0,_.toDisposable)(()=>clearTimeout(o)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(y){await w.Promises.exists(a)&&!u.token.isCancellationRequested&&this.error(`Failed to watch ${a} for changes using fs.watch() (${y.toString()})`)}return(0,_.toDisposable)(()=>{u.dispose(!0),g.dispose()})}onFileChange(a,h=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!h&&this.excludes.some(u=>u(a.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${a.path}`):!h&&this.includes&&this.includes.length>0&&!this.includes.some(u=>u(a.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${a.path}`):this.fileChangesAggregator.work(a))}handleFileChanges(a){const h=(0,m.coalesceEvents)(a);if(h.length>0){if(this.verboseLogging)for(const g of h)this.trace(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`);this.throttledFileChangesEmitter.work(h)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(a){if(S.isLinux)return w.Promises.exists(a);try{const h=(0,P.basename)(a);return(await w.Promises.readdir((0,P.dirname)(a))).some(g=>g===h)}catch(h){return this.trace(h),!1}}setVerboseLogging(a){this.verboseLogging=a}error(a){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}warn(a){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}trace(a){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.FILE_DELETE_HANDLER_DELAY=100,f.FILE_CHANGES_HANDLER_DELAY=75;async function p(b,a,h,u,g=512){const y=await w.Promises.open(b,"r"),L=Buffer.allocUnsafe(g),n=new l.CancellationTokenSource(u);let s,t=!1;const i={path:b,excludes:[],recursive:!1},r=new f(i,o=>{(async()=>{for(const{type:c}of o)if(c===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:v}=await w.Promises.read(y,L,0,g,null);if(!v||n.token.isCancellationRequested)break;a(L.slice(0,v))}}catch(v){s=new Error(v),n.dispose(!0)}finally{t=!1}}})()});return await r.ready,h(),new Promise((o,c)=>{n.token.onCancellationRequested(async()=>{r.dispose();try{await w.Promises.close(y)}catch(v){s=new Error(v)}s?c(s):o()})})}e.watchFileContents=p}),define(oe[200],ae([0,1,3,92,2,4,199]),function(ie,e,T,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends l.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new T.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=T.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(S){const D=this.normalizeRequests(S),w=D.filter(f=>{const p=this.watchers.get(f.path);return p?!(0,O.patternsEquals)(p.request.excludes,f.excludes)||!(0,O.patternsEquals)(p.request.includes,f.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:f})=>!D.find(p=>p.path===f.path&&(0,O.patternsEquals)(p.excludes,f.excludes)&&(0,O.patternsEquals)(p.includes,f.includes))).map(({request:f})=>f.path);w.length&&this.trace(`Request to start watching: ${w.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const f of m)this.stopWatching(f);for(const f of w)this.startWatching(f)}startWatching(S){const D=new _.NodeJSFileWatcherLibrary(S,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),w={request:S,instance:D};this.watchers.set(S.path,w)}async stop(){for(const[S]of this.watchers)this.stopWatching(S);this.watchers.clear()}stopWatching(S){const D=this.watchers.get(S);D&&(this.watchers.delete(S),D.instance.dispose())}normalizeRequests(S){const D=new Map;for(const w of S){const m=A.isLinux?w.path:w.path.toLowerCase();D.set(m,w)}return Array.from(D.values())}async setVerboseLogging(S){this.verboseLogging=S;for(const[,D]of this.watchers)D.instance.setVerboseLogging(S)}trace(S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(S)})}toMessage(S,D){return D?`[File Watcher (node.js)] ${S} (path: ${D.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=k}),define(oe[201],ae([0,1,55,200]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends T.AbstractNonRecursiveWatcherClient{constructor(_,k,P){super(_,k,P),this.init()}createWatcher(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(oe[202],ae([0,1,22,41,66,55]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class _ extends A.AbstractUniversalWatcherClient{constructor(P,S,D){super(P,S,D),this.init()}createWatcher(P){const S=P.add(new l.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(S.onDidProcessExit(({code:D,signal:w})=>this.onError(`terminated by itself with code ${D}, signal: ${w}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=_}),define(oe[72],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...l){this._entries=new Map;for(const[A,_]of l)this.set(A,_)}set(l,A){const _=this._entries.get(l);return this._entries.set(l,A),_}has(l){return this._entries.has(l)}get(l){return this._entries.get(l)}}e.ServiceCollection=T}),define(oe[203],ae([0,1,6,9,2,69,194,5,72,86]),function(ie,e,T,O,l,A,_,k,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class w extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class m{constructor(a=new P.ServiceCollection,h=!1,u,g=D){this._services=a,this._strict=h,this._parent=u,this._enableTracing=g,this._activeInstantiations=new Set,this._services.set(k.IInstantiationService,this),this._globalGraph=g?u?._globalGraph??new _.Graph(y=>y):void 0}createChild(a){return new m(a,this._strict,this,this._enableTracing)}invokeFunction(a,...h){const u=p.traceInvocation(this._enableTracing,a);let g=!1;try{return a({get:L=>{if(g)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(L,u);if(!n)throw new Error(`[invokeFunction] unknown service '${L}'`);return n}},...h)}finally{g=!0,u.stop()}}createInstance(a,...h){let u,g;return a instanceof A.SyncDescriptor?(u=p.traceCreation(this._enableTracing,a.ctor),g=this._createInstance(a.ctor,a.staticArguments.concat(h),u)):(u=p.traceCreation(this._enableTracing,a),g=this._createInstance(a,h,u)),u.stop(),g}_createInstance(a,h=[],u){const g=k._util.getServiceDependencies(a).sort((n,s)=>n.index-s.index),y=[];for(const n of g){const s=this._getOrCreateServiceInstance(n.id,u);s||this._throwIfStrict(`[createInstance] ${a.name} depends on UNKNOWN service ${n.id}.`,!1),y.push(s)}const L=g.length>0?g[0].index:h.length;if(h.length!==L){console.trace(`[createInstance] First service dependency of ${a.name} at position ${L+1} conflicts with ${h.length} static arguments`);const n=L-h.length;n>0?h=h.concat(new Array(n)):h=h.slice(0,L)}return Reflect.construct(a,h.concat(y))}_setServiceInstance(a,h){if(this._services.get(a)instanceof A.SyncDescriptor)this._services.set(a,h);else if(this._parent)this._parent._setServiceInstance(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){const h=this._services.get(a);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):h}_getOrCreateServiceInstance(a,h){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(a));const u=this._getServiceInstanceOrDescriptor(a);return u instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,u,h.branch(a,!0)):(h.branch(a,!1),u)}_safeCreateAndCacheServiceInstance(a,h,u){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,h,u)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,h,u){const g=new _.Graph(n=>n.id.toString());let y=0;const L=[{id:a,desc:h,_trace:u}];for(;L.length;){const n=L.pop();if(g.lookupOrInsertNode(n),y++>1e3)throw new w(g);for(const s of k._util.getServiceDependencies(n.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(s.id);if(t||this._throwIfStrict(`[createInstance] ${a} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),t instanceof A.SyncDescriptor){const i={id:s.id,desc:t,_trace:n._trace.branch(s.id,!0)};g.insertEdge(n,i),L.push(i)}}}for(;;){const n=g.roots();if(n.length===0){if(!g.isEmpty())throw new w(g);break}for(const{data:s}of n){if(this._getServiceInstanceOrDescriptor(s.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}g.removeNode(s)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,h,u=[],g,y){if(this._services.get(a)instanceof A.SyncDescriptor)return this._createServiceInstance(a,h,u,g,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,h,u,g,y);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(a,h,u=[],g,y){if(g){const L=new m(void 0,this._strict,this,this._enableTracing);L._globalGraphImplicitDependency=String(a);const n=new Map,s=new T.IdleValue(()=>{const t=L._createInstance(h,u,y);for(const[i,r]of n){const o=t[i];if(typeof o=="function")for(const c of r)o.apply(t,c)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!s.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let c=n.get(i);return c||(c=new S.LinkedList,n.set(i,c)),(E,d,I)=>{const R=c.push([E,d,I]);return(0,l.toDisposable)(R)}}if(i in t)return t[i];const r=s.value;let o=r[i];return typeof o!="function"||(o=o.bind(r),t[i]=o),o},set(t,i,r){return s.value[i]=r,!0},getPrototypeOf(t){return h.prototype}})}else return this._createInstance(h,u,y)}_throwIfStrict(a,h){if(h&&console.warn(a),this._strict)throw new Error(a)}}e.InstantiationService=m;var f;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(f||(f={}));class p{static traceInvocation(a,h){return a?new p(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(a,h){return a?new p(1,h.name):p._None}constructor(a,h){this.type=a,this.name=h,this._start=Date.now(),this._dep=[]}branch(a,h){const u=new p(3,a.toString());return this._dep.push([a,h,u]),u}stop(){const a=Date.now()-this._start;p._totals+=a;let h=!1;function u(y,L){const n=[],s=new Array(y+1).join("	");for(const[t,i,r]of L._dep)if(i&&r){h=!0,n.push(`${s}CREATES -> ${t}`);const o=u(y+1,r);o&&n.push(o)}else n.push(`${s}uses -> ${t}`);return n.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(a>2||h)&&p.all.add(g.join(`
`))}}e.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p._totals=0}),define(oe[73],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,T.createDecorator)("mainProcessService");class O{constructor(A,_){this.server=A,this.router=_}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,_){this.server.registerChannel(A,_)}}e.MainProcessService=O}),define(oe[74],ae([0,1,26,2,4,167,29,5]),function(ie,e,T,O,l,A,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function P(D){return D.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=P,e.ILanguagePackService=(0,k.createDecorator)("languagePackService");let S=e.LanguagePackBaseService=class extends O.Disposable{constructor(w){super(),this.extensionGalleryService=w}async getAvailableLanguages(){const w=new T.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let m;try{m=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const p=m.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(a=>a.startsWith("lp-"))).map(b=>{const a=b.properties.localizedLanguages?.[0],h=P(b);return{...this.createQuickPickItem(h,a,b),extensionId:b.identifier.id,galleryExtension:b}});return p.push(this.createQuickPickItem("en","English")),p}createQuickPickItem(w,m,f){const p=m??w;let b;if(p!==w&&(b=`(${w})`),w.toLowerCase()===l.language.toLowerCase()&&(b??="",b+=(0,A.localize)(0,null)),f?.installCount){b??="";const a=f.installCount;let h;a>1e6?h=`${Math.floor(a/1e5)/10}M`:a>1e3?h=`${Math.floor(a/1e3)}K`:h=String(a),b+=` $(cloud-download) ${h}`}return{id:w,label:p,description:b}}};e.LanguagePackBaseService=S=Se([Y(0,_.IExtensionGalleryService)],S)}),define(oe[204],ae([0,1,2,74]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let l=e.LocalizationsUpdater=class extends T.Disposable{constructor(_){super(),this.localizationsService=_,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=l=Se([Y(0,O.ILanguagePackService)],l)}),define(oe[10],ae([0,1,38,3,65,2,37,4,23,11,12,70,5]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function f(){return new Date().toISOString()}function p(E){return(0,S.isNumber)(E)}e.isLogLevel=p;var b;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(b||(e.LogLevel=b={})),e.DEFAULT_LOG_LEVEL=b.Info;function a(E,d,I){switch(d){case b.Trace:E.trace(I);break;case b.Debug:E.debug(I);break;case b.Info:E.info(I);break;case b.Warning:E.warn(I);break;case b.Error:E.error(I);break;case b.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=a;function h(E,d=!1){let I="";for(let R=0;R<E.length;R++){let N=E[R];if(N instanceof Error&&(N=(0,T.toErrorMessage)(N,d)),typeof N=="object")try{N=JSON.stringify(N)}catch{}I+=(R>0?" ":"")+N}return I}class u extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(d){this.level!==d&&(this.level=d,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(d){return this.level!==b.Off&&this.level<=d}}e.AbstractLogger=u;class g extends u{constructor(d){super(),this.logAlways=d}checkLogLevel(d){return this.logAlways||super.checkLogLevel(d)}trace(d,...I){this.checkLogLevel(b.Trace)&&this.log(b.Trace,h([d,...I],!0))}debug(d,...I){this.checkLogLevel(b.Debug)&&this.log(b.Debug,h([d,...I]))}info(d,...I){this.checkLogLevel(b.Info)&&this.log(b.Info,h([d,...I]))}warn(d,...I){this.checkLogLevel(b.Warning)&&this.log(b.Warning,h([d,...I]))}error(d,...I){if(this.checkLogLevel(b.Error))if(d instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=d.stack,this.log(b.Error,h(R))}else this.log(b.Error,h([d,...I]))}flush(){}}e.AbstractMessageLogger=g;class y extends u{constructor(d=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(d),this.useColors=!k.isWindows}trace(d,...I){this.checkLogLevel(b.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,d,...I):console.log(`[main ${f()}]`,d,...I))}debug(d,...I){this.checkLogLevel(b.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,d,...I):console.log(`[main ${f()}]`,d,...I))}info(d,...I){this.checkLogLevel(b.Info)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,d,...I):console.log(`[main ${f()}]`,d,...I))}warn(d,...I){this.checkLogLevel(b.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,d,...I):console.warn(`[main ${f()}]`,d,...I))}error(d,...I){this.checkLogLevel(b.Error)&&(this.useColors?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,d,...I):console.error(`[main ${f()}]`,d,...I))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class L extends u{constructor(d=e.DEFAULT_LOG_LEVEL,I=!0){super(),this.useColors=I,this.setLevel(d)}trace(d,...I){this.checkLogLevel(b.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",d,...I):console.log(d,...I))}debug(d,...I){this.checkLogLevel(b.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",d,...I):console.log(d,...I))}info(d,...I){this.checkLogLevel(b.Info)&&(this.useColors?console.log("%c INFO","color: #33f",d,...I):console.log(d,...I))}warn(d,...I){this.checkLogLevel(b.Warning)&&(this.useColors?console.log("%c WARN","color: #993",d,...I):console.log(d,...I))}error(d,...I){this.checkLogLevel(b.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",d,...I):console.error(d,...I))}dispose(){}flush(){}}e.ConsoleLogger=L;class n extends u{constructor(d,I=e.DEFAULT_LOG_LEVEL){super(),this.adapter=d,this.setLevel(I)}trace(d,...I){this.checkLogLevel(b.Trace)&&this.adapter.log(b.Trace,[this.extractMessage(d),...I])}debug(d,...I){this.checkLogLevel(b.Debug)&&this.adapter.log(b.Debug,[this.extractMessage(d),...I])}info(d,...I){this.checkLogLevel(b.Info)&&this.adapter.log(b.Info,[this.extractMessage(d),...I])}warn(d,...I){this.checkLogLevel(b.Warning)&&this.adapter.log(b.Warning,[this.extractMessage(d),...I])}error(d,...I){this.checkLogLevel(b.Error)&&this.adapter.log(b.Error,[this.extractMessage(d),...I])}extractMessage(d){return typeof d=="string"?d:(0,T.toErrorMessage)(d,this.checkLogLevel(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class s extends u{constructor(d){super(),this.loggers=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const I of this.loggers)I.setLevel(d);super.setLevel(d)}trace(d,...I){for(const R of this.loggers)R.trace(d,...I)}debug(d,...I){for(const R of this.loggers)R.debug(d,...I)}info(d,...I){for(const R of this.loggers)R.info(d,...I)}warn(d,...I){for(const R of this.loggers)R.warn(d,...I)}error(d,...I){for(const R of this.loggers)R.error(d,...I)}flush(){for(const d of this.loggers)d.flush()}dispose(){for(const d of this.loggers)d.dispose()}}e.MultiplexLogger=s;class t extends A.Disposable{constructor(d,I,R){if(super(),this.logLevel=d,this.logsHome=I,this._loggers=new _.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,R)for(const N of R)this._loggers.set(N.resource,{logger:void 0,info:N})}getLoggerEntry(d){return(0,S.isString)(d)?[...this._loggers.values()].find(I=>I.info.id===d):this._loggers.get(d)}getLogger(d){return this.getLoggerEntry(d)?.logger}createLogger(d,I){const R=this.toResource(d),N=(0,S.isString)(d)?d:I?.id??(0,l.hash)(R.toString()).toString(16);let F=this._loggers.get(R)?.logger;const W=I?.logLevel==="always"?b.Trace:I?.logLevel;F||(F=this.doCreateLogger(R,W??this.getLogLevel(R)??this.logLevel,{...I,id:N}));const q={logger:F,info:{resource:R,id:N,logLevel:W,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(q.info),this._loggers.set(R,q),F}toResource(d){return(0,S.isString)(d)?(0,P.joinPath)(this.logsHome,`${d}.log`):d}setLogLevel(d,I){if(D.URI.isUri(d)){const R=d,N=I,F=this._loggers.get(R);F&&N!==F.info.logLevel&&(F.info.logLevel=N===this.logLevel?void 0:N,F.logger?.setLevel(N),this._loggers.set(F.info.resource,F),this._onDidChangeLogLevel.fire([R,N]))}else{this.logLevel=d;for(const[R,N]of this._loggers.entries())this._loggers.get(R)?.info.logLevel===void 0&&N.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(d,I){const R=this.getLoggerEntry(d);R&&I!==!R.info.hidden&&(R.info.hidden=!I,this._loggers.set(R.info.resource,R),this._onDidChangeVisibility.fire([R.info.resource,I]))}getLogLevel(d){let I;return d&&(I=this._loggers.get(d)?.info.logLevel),I??this.logLevel}registerLogger(d){const I=this._loggers.get(d.resource);I?I.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this._loggers.set(d.resource,{info:d,logger:void 0}),this._onDidChangeLoggers.fire({added:[d],removed:[]}))}deregisterLogger(d){const I=this._loggers.get(d);I&&(I.logger&&I.logger.dispose(),this._loggers.delete(d),this._onDidChangeLoggers.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const d of this._loggers.values())yield d.info}getRegisteredLogger(d){return this._loggers.get(d)?.info}dispose(){this._loggers.forEach(d=>d.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=t;class i{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(d){}getLevel(){return b.Info}trace(d,...I){}debug(d,...I){}info(d,...I){}warn(d,...I){}error(d,...I){}critical(d,...I){}dispose(){}flush(){}}e.NullLogger=i;class r extends i{}e.NullLogService=r;function o(E){if(E.verbose)return b.Trace;if(typeof E.logLevel=="string"){const d=v(E.logLevel.toLowerCase());if(d!==void 0)return d}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function c(E){switch(E){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=c;function v(E){switch(E){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=v,e.CONTEXT_LOG_LEVEL=new w.RawContextKey("logLevel",c(b.Info))}),define(oe[205],ae([0,1,6,9,2,23,28,15,10]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=e.LogsDataCleaner=class extends l.Disposable{constructor(w,m){super(),this.environmentService=w,this.logService=m,this._register(new T.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,A.basename)(this.environmentService.logsHome),m=(0,A.dirname)(this.environmentService.logsHome),b=(await _.Promises.readdir(m.fsPath)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==w),a=b.slice(0,Math.max(0,b.length-9));a.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${a.join(", ")}'`),await Promise.all(a.map(h=>_.Promises.rm((0,A.joinPath)(m,h).fsPath))))}catch(w){(0,O.onUnexpectedError)(w)}}};e.LogsDataCleaner=S=Se([Y(0,k.IEnvironmentService),Y(1,P.ILogService)],S)}),define(oe[206],ae([0,1,21,6,9,3,2,14,55,10]),function(ie,e,T,O,l,A,_,k,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends _.Disposable{constructor(m,f){super(),this.logService=m,this.options=f,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(m,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,f):this.watchNonRecursive(m,f)}watchUniversal(m,f){const p={path:this.toFilePath(m),excludes:f.excludes,includes:f.includes,recursive:f.recursive},b=(0,T.insert)(this.universalPathsToWatch,p);return this.refreshUniversalWatchers(),(0,_.toDisposable)(()=>{b(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,l.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,P.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const f of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const f of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(f)&&m.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,f){const p={path:this.toFilePath(m),excludes:f.excludes,includes:f.includes,recursive:!1},b=(0,T.insert)(this.nonRecursivePathsToWatch,p);return this.refreshNonRecursiveWatchers(),(0,_.toDisposable)(()=>{b(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,l.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,P.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,k.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(oe[207],ae([0,1,21,6,16,26,3,65,62,2,48,22,104,23,43,163,13,103,10,9]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=e.FileService=class extends S.Disposable{constructor(n){super(),this.logService=n,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new _.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new _.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new _.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new _.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new _.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(n,s){if(this.provider.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${n}`);const t=new S.DisposableStore;return this.provider.set(n,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:n,provider:s}),t.add(s.onDidChangeFile(i=>this._onDidFilesChange.fire(new a.FileChangesEvent(i,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&t.add(s.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:n}))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:n,provider:s}),this.provider.delete(n),(0,S.dispose)(t)})}getProvider(n){return this.provider.get(n)}async activateProvider(n){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:n,join(t){s.push(t)}}),!this.provider.has(n)&&await O.Promises.settled(s)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.provider.has(n.scheme)}hasCapability(n,s){const t=this.provider.get(n.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return P.Iterable.map(this.provider,([n,s])=>({scheme:n,capabilities:s.capabilities}))}async withProvider(n){if(!(0,f.isAbsolutePath)(n))throw new a.FileOperationError((0,b.localize)(0,null,this.resourceForError(n)),8);await this.activateProvider(n.scheme);const s=this.provider.get(n.scheme);if(!s){const t=new g.ErrorNoTelemetry;throw t.message=(0,b.localize)(1,null,n.toString()),t}return s}async withReadProvider(n){const s=await this.withProvider(n);if((0,a.hasOpenReadWriteCloseCapability)(s)||(0,a.hasReadWriteCapability)(s)||(0,a.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(n){const s=await this.withProvider(n);if((0,a.hasOpenReadWriteCloseCapability)(s)||(0,a.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,s){try{return await this.doResolveFile(n,s)}catch(t){throw(0,a.toFileSystemProviderErrorCode)(t)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,b.localize)(2,null,this.resourceForError(n)),1):(0,a.ensureFileSystemProviderError)(t)}}async doResolveFile(n,s){const t=await this.withProvider(n),i=this.isPathCaseSensitive(t),r=s?.resolveTo,o=s?.resolveSingleChildDescendants,c=s?.resolveMetadata,v=await t.stat(n);let E;return this.toFileStat(t,n,v,void 0,!!c,(d,I)=>(E||(E=D.TernarySearchTree.forUris(()=>!i),E.set(n,!0),r&&E.fill(!0,r)),E.get(d.resource)||E.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&o?I===1:!1))}async toFileStat(n,s,t,i,r,o){const{providerExtUri:c}=this.getExtUri(n),v={resource:s,name:c.basename(s),isFile:(t.type&a.FileType.File)!==0,isDirectory:(t.type&a.FileType.Directory)!==0,isSymbolicLink:(t.type&a.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&a.FilePermission.Readonly)||!!(n.capabilities&2048),etag:(0,a.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(v.isDirectory&&o(v,i)){try{const E=await n.readdir(s),d=await O.Promises.settled(E.map(async([I,R])=>{try{const N=c.joinPath(s,I),F=r?await n.stat(N):{type:R};return await this.toFileStat(n,N,F,E.length,r,o)}catch(N){return this.logService.trace(N),null}}));v.children=(0,T.coalesce)(d)}catch(E){this.logService.trace(E),v.children=[]}return v}return v}async resolveAll(n){return O.Promises.settled(n.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const s=await this.withProvider(n),t=await s.stat(n);return this.toFileStat(s,n,t,void 0,!0,()=>!1)}async exists(n){const s=await this.withProvider(n);try{return!!await s.stat(n)}catch{return!1}}async canCreateFile(n,s){try{await this.doValidateCreateFile(n,s)}catch(t){return t}return!0}async doValidateCreateFile(n,s){if(!s?.overwrite&&await this.exists(n))throw new a.FileOperationError((0,b.localize)(3,null,this.resourceForError(n)),3,s)}async createFile(n,s=l.VSBuffer.fromString(""),t){await this.doValidateCreateFile(n,t);const i=await this.writeFile(n,s);return this._onDidRunOperation.fire(new a.FileOperationEvent(n,0,i)),i}async writeFile(n,s,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,n,t)||await this.mkdirp(i,r.dirname(n));let c;if((0,a.hasReadWriteCapability)(i)&&!(s instanceof l.VSBuffer))if((0,p.isReadableStream)(s)){const v=await(0,p.peekStream)(s,3);v.ended?c=l.VSBuffer.concat(v.buffer):c=v}else c=(0,p.peekReadable)(s,v=>l.VSBuffer.concat(v),3);else c=s;!(0,a.hasOpenReadWriteCloseCapability)(i)||(0,a.hasReadWriteCapability)(i)&&c instanceof l.VSBuffer?await this.doWriteUnbuffered(i,n,t,c):await this.doWriteBuffered(i,n,t,c instanceof l.VSBuffer?(0,l.bufferToReadable)(c):c),this._onDidRunOperation.fire(new a.FileOperationEvent(n,4))}catch(o){throw new a.FileOperationError((0,b.localize)(4,null,this.resourceForError(n),(0,a.ensureFileSystemProviderError)(o).toString()),(0,a.toFileOperationResult)(o),t)}return this.resolve(n,{resolveMetadata:!0})}async validateWriteFile(n,s,t){if(!!t?.unlock&&!(n.capabilities&8192))throw new Error((0,b.localize)(5,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{return}if(r.type&a.FileType.Directory)throw new a.FileOperationError((0,b.localize)(6,null,this.resourceForError(s)),0,t);if(this.throwIfFileIsReadonly(s,r),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==a.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,a.etag)({mtime:t.mtime,size:r.size}))throw new a.FileOperationError((0,b.localize)(7,null),3,t);return r}async readFile(n,s,t){const i=await this.withReadProvider(n);return s?.atomic?this.doReadFileAtomic(i,n,s,t):this.doReadFile(i,n,s,t)}async doReadFileAtomic(n,s,t,i){return new Promise((r,o)=>{this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(n,s,t,i);r(c)}catch(c){o(c)}})})}async doReadFile(n,s,t,i){const r=await this.doReadFileStream(n,s,{...t,preferUnbuffered:!0},i);return{...r,value:await(0,l.streamToBuffer)(r.value)}}async readFileStream(n,s,t){const i=await this.withReadProvider(n);return this.doReadFileStream(i,n,s,t)}async doReadFileStream(n,s,t,i){const r=new A.CancellationTokenSource(i),o=this.validateReadFile(s,t).then(v=>v,v=>{throw r.cancel(),v});let c;try{return typeof t?.etag=="string"&&t.etag!==a.ETAG_DISABLED&&await o,t?.atomic&&(0,a.hasFileAtomicReadCapability)(n)||!((0,a.hasOpenReadWriteCloseCapability)(n)||(0,a.hasFileReadStreamCapability)(n))||(0,a.hasReadWriteCapability)(n)&&t?.preferUnbuffered?c=this.readFileUnbuffered(n,s,t):(0,a.hasFileReadStreamCapability)(n)?c=this.readFileStreamed(n,s,r.token,t):c=this.readFileBuffered(n,s,r.token,t),{...await o,value:c}}catch(v){throw c&&await(0,p.consumeStream)(c),this.restoreReadError(v,s,t)}}restoreReadError(n,s,t){const i=(0,b.localize)(8,null,this.resourceForError(s),(0,a.ensureFileSystemProviderError)(n).toString());return n instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(i,n.stat,t):n instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(i,n.fileOperationResult,n.size,n.options):new a.FileOperationError(i,(0,a.toFileOperationResult)(n),t)}readFileStreamed(n,s,t,i=Object.create(null)){const r=n.readFileStream(s,i,t);return(0,p.transform)(r,{data:o=>o instanceof l.VSBuffer?o:l.VSBuffer.wrap(o),error:o=>this.restoreReadError(o,s,i)},o=>l.VSBuffer.concat(o))}readFileBuffered(n,s,t,i=Object.create(null)){const r=(0,l.newWriteableBufferStream)();return(0,h.readFileIntoStream)(n,s,r,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>this.restoreReadError(o,s,i)},t),r}readFileUnbuffered(n,s,t){const i=(0,p.newWriteableStream)(r=>l.VSBuffer.concat(r));return(async()=>{try{let r;t?.atomic&&(0,a.hasFileAtomicReadCapability)(n)?r=await n.readFile(s,{atomic:!0}):r=await n.readFile(s),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(s,r.byteLength,t),i.end(l.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(n,s){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new a.FileOperationError((0,b.localize)(9,null,this.resourceForError(n)),0,s);if(typeof s?.etag=="string"&&s.etag!==a.ETAG_DISABLED&&s.etag===t.etag)throw new a.NotModifiedSinceFileOperationError((0,b.localize)(10,null),t,s);return this.validateReadFileLimits(n,t.size,s),t}validateReadFileLimits(n,s,t){if(typeof t?.limits?.size=="number"&&s>t.limits.size)throw new a.TooLargeFileOperationError((0,b.localize)(11,null,this.resourceForError(n)),7,s,t)}async canMove(n,s,t){return this.doCanMoveCopy(n,s,"move",t)}async canCopy(n,s,t){return this.doCanMoveCopy(n,s,"copy",t)}async doCanMoveCopy(n,s,t,i){if(n.toString()!==s.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n):await this.withReadProvider(n),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(r,n,o,s,t,i)}catch(r){return r}return!0}async move(n,s,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,n,r,s,"move",!!t),c=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(n,o==="move"?2:3,c)),c}async copy(n,s,t){const i=await this.withReadProvider(n),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,n,r,s,"copy",!!t),c=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(n,o==="copy"?3:2,c)),c}async doMoveCopy(n,s,t,i,r,o){if(s.toString()===i.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:v}=await this.doValidateMoveCopy(n,s,t,i,r,o);if(c&&!v&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),r==="copy"){if(n===t&&(0,a.hasFileFolderCopyCapability)(n))await n.copy(s,i,{overwrite:o});else{const E=await this.resolve(s);E.isDirectory?await this.doCopyFolder(n,E,t,i):await this.doCopyFile(n,s,t,i)}return r}else return n===t?(await n.rename(s,i,{overwrite:o}),r):(await this.doMoveCopy(n,s,t,i,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(n,s,t,i){if((0,a.hasOpenReadWriteCloseCapability)(n)&&(0,a.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(n,s,t,i);if((0,a.hasOpenReadWriteCloseCapability)(n)&&(0,a.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(n,s,t,i);if((0,a.hasReadWriteCapability)(n)&&(0,a.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(n,s,t,i);if((0,a.hasReadWriteCapability)(n)&&(0,a.hasReadWriteCapability)(t))return this.doPipeUnbuffered(n,s,t,i)}async doCopyFolder(n,s,t,i){await t.mkdir(i),Array.isArray(s.children)&&await O.Promises.settled(s.children.map(async r=>{const o=this.getExtUri(t).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(n,await this.resolve(r.resource),t,o):this.doCopyFile(n,r.resource,t,o)}))}async doValidateMoveCopy(n,s,t,i,r,o){let c=!1;if(n===t){const{providerExtUri:E,isPathCaseSensitive:d}=this.getExtUri(n);if(d||(c=E.isEqual(s,i)),c&&r==="copy")throw new Error((0,b.localize)(12,null,this.resourceForError(s),this.resourceForError(i)));if(!c&&E.isEqualOrParent(i,s))throw new Error((0,b.localize)(13,null,this.resourceForError(s),this.resourceForError(i)))}const v=await this.exists(i);if(v&&!c){if(!o)throw new a.FileOperationError((0,b.localize)(14,null,this.resourceForError(s),this.resourceForError(i)),4);if(n===t){const{providerExtUri:E}=this.getExtUri(n);if(E.isEqualOrParent(s,i))throw new Error((0,b.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:v,isSameResourceWithDifferentPathCase:c}}getExtUri(n){const s=this.isPathCaseSensitive(n);return{providerExtUri:s?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(n){return!!(n.capabilities&1024)}async createFolder(n){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(n),n);await this.mkdirp(s,n);const t=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(n,0,t)),t}async mkdirp(n,s){const t=[],{providerExtUri:i}=this.getExtUri(n);for(;!i.isEqual(s,i.dirname(s));)try{if(!((await n.stat(s)).type&a.FileType.Directory))throw new Error((0,b.localize)(16,null,this.resourceForError(s)));break}catch(r){if((0,a.toFileSystemProviderErrorCode)(r)!==a.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(i.basename(s)),s=i.dirname(s)}for(let r=t.length-1;r>=0;r--){s=i.joinPath(s,t[r]);try{await n.mkdir(s)}catch(o){if((0,a.toFileSystemProviderErrorCode)(o)!==a.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(n,s){try{await this.doValidateDelete(n,s)}catch(t){return t}return!0}async doValidateDelete(n,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(n),n);if(!!s?.useTrash&&!(t.capabilities&4096))throw new Error((0,b.localize)(17,null,this.resourceForError(n)));let r;try{r=await t.stat(n)}catch{}if(r)this.throwIfFileIsReadonly(n,r);else throw new a.FileOperationError((0,b.localize)(18,null,this.resourceForError(n)),1);if(!!!s?.recursive){const c=await this.resolve(n);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,b.localize)(19,null,this.resourceForError(n)))}return t}async del(n,s){const t=await this.doValidateDelete(n,s),i=!!s?.useTrash,r=!!s?.recursive;await t.delete(n,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new a.FileOperationEvent(n,1))}async cloneFile(n,s){const t=await this.withProvider(n),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(t===i&&this.getExtUri(t).providerExtUri.isEqual(n,s))return;if(t===i&&(0,a.hasFileCloneCapability)(t))return t.cloneFile(n,s);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(s));const r=this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri);return t===i&&(0,a.hasFileFolderCopyCapability)(t)?r.queue(()=>t.copy(n,s,{overwrite:!0})):r.queue(()=>this.doCopyFile(t,n,i,s))}watch(n,s={recursive:!1,excludes:[]}){const t=new S.DisposableStore;let i=!1,r=()=>{i=!0};return t.add((0,S.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(n,s);i?(0,S.dispose)(o):r=()=>(0,S.dispose)(o)}catch(o){this.logService.error(o)}})(),t}async doWatch(n,s){const t=await this.withProvider(n),i=(0,k.hash)([this.getExtUri(t).providerExtUri.getComparisonKey(n),s]);let r=this.activeWatchers.get(i);return r||(r={count:0,disposable:t.watch(n,s)},this.activeWatchers.set(i,r)),r.count+=1,(0,S.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,S.dispose)(r.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,n]of this.activeWatchers)(0,S.dispose)(n.disposable);this.activeWatchers.clear()}async doWriteBuffered(n,s,t,i){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(async()=>{const r=await n.open(s,{create:!0,unlock:t?.unlock??!1});try{(0,p.isReadableStream)(i)||(0,p.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(n,r,i):await this.doWriteReadableBufferedQueued(n,r,i)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await n.close(r)}})}async doWriteStreamBufferedQueued(n,s,t){let i=0,r;if((0,p.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=l.VSBuffer.concat(t.buffer);await this.doWriteBuffer(n,s,o,o.byteLength,i,0),i+=o.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((o,c)=>{(0,p.listenStream)(r,{onData:async v=>{r.pause();try{await this.doWriteBuffer(n,s,v,v.byteLength,i,0)}catch(E){return c(E)}i+=v.byteLength,setTimeout(()=>r.resume())},onError:v=>c(v),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(n,s,t){let i=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(n,s,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(n,s,t,i,r,o){let c=0;for(;c<i;){const v=await n.write(s,r+c,t.buffer,o+c,i-c);c+=v}}async doWriteUnbuffered(n,s,t,i){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(n,s,t,i))}async doWriteUnbufferedQueued(n,s,t,i){let r;i instanceof l.VSBuffer?r=i:(0,p.isReadableStream)(i)?r=await(0,l.streamToBuffer)(i):(0,p.isReadableBufferedStream)(i)?r=await(0,l.bufferedStreamToBuffer)(i):r=(0,l.readableToBuffer)(i),await n.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(n,s,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(n,s,t,i))}async doPipeBufferedQueued(n,s,t,i){let r,o;try{r=await n.open(s,{create:!1}),o=await t.open(i,{create:!0,unlock:!1});const c=l.VSBuffer.alloc(this.BUFFER_SIZE);let v=0,E=0,d=0;do d=await n.read(r,v,c.buffer,E,c.byteLength-E),await this.doWriteBuffer(t,o,c,d,v,E),v+=d,E+=d,E===c.byteLength&&(E=0);while(d>0)}catch(c){throw(0,a.ensureFileSystemProviderError)(c)}finally{await O.Promises.settled([typeof r=="number"?n.close(r):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(n,s,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(n,s,t,i))}async doPipeUnbufferedQueued(n,s,t,i){return t.writeFile(i,await n.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(n,s,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(n,s,t,i))}async doPipeUnbufferedToBufferedQueued(n,s,t,i){const r=await t.open(i,{create:!0,unlock:!1});try{const o=await n.readFile(s);await this.doWriteBuffer(t,r,l.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(n,s,t,i){const r=await(0,l.streamToBuffer)(this.readFileBuffered(n,s,A.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,r)}throwIfFileSystemIsReadonly(n,s){if(n.capabilities&2048)throw new a.FileOperationError((0,b.localize)(20,null,this.resourceForError(s)),6);return n}throwIfFileIsReadonly(n,s){if((s.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,b.localize)(21,null,this.resourceForError(n)),6)}resourceForError(n){return n.scheme===w.Schemas.file?n.fsPath:n.toString(!0)}};e.FileService=y=Se([Y(0,u.ILogService)],y)}),define(oe[208],ae([0,1,53,286,6,37,16,3,47,2,14,4,23,43,28,166,13,103,206,38,202,201]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(T)}catch(s){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(s)}`)}})();class n extends u.AbstractDiskFileSystemProvider{constructor(t,i){super(t,i),this.onDidChangeCapabilities=k.Event.None,this.resourceLocks=new A.ResourceMap(r=>m.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:i,symbolicLink:r}=await p.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(t){try{const i=await p.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,m.joinPath)(t,o.name))).type:c=this.toType(o),r.push([o.name,c])}catch(c){this.logService.trace(c)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(t,i){let r;return i?.dangling?r=a.FileType.Unknown:t.isFile()?r=a.FileType.File:t.isDirectory()?r=a.FileType.Directory:r=a.FileType.Unknown,i&&(r|=a.FileType.SymbolicLink),r}async createResourceLock(t){const i=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const o=new l.Barrier;return this.resourceLocks.set(t,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,S.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(t)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let r;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),r=await this.createResourceLock(t));const o=this.toFilePath(t);return await p.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{r?.dispose()}}traceLock(t){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,i,r){const o=(0,f.newWriteableStream)(c=>_.VSBuffer.concat(c.map(v=>_.VSBuffer.wrap(v))).buffer);return(0,h.readFileIntoStream)(this,t,o,c=>c.buffer,{...i,bufferSize:256*1024},r),o}async writeFile(t,i,r){let o;try{const c=this.toFilePath(t);if(!r.create||!r.overwrite){if(await p.Promises.exists(c)){if(!r.overwrite)throw(0,a.createFileSystemProviderError)((0,b.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,a.createFileSystemProviderError)((0,b.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(t,{create:!0,unlock:r.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(t,c)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(t){n.canFlush=t}async open(t,i){const r=this.toFilePath(t);let o;(0,a.isFileOpenForWriteOptions)(i)&&(o=await this.createResourceLock(t));let c;try{if((0,a.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:E}=await p.SymlinkSupport.stat(r);E.mode&128||await p.Promises.chmod(r,E.mode|128)}catch(E){this.logService.trace(E)}let v;if((0,a.isFileOpenForWriteOptions)(i)){if(w.isWindows)try{await p.Promises.truncate(r,0),v="r+"}catch(E){E.code!=="ENOENT"&&this.logService.trace(E)}v||(v="w")}else v="r";c=await p.Promises.open(r,v)}catch(v){throw o?.dispose(),(0,a.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(t,v):this.toFileSystemProviderError(v)}if(this.mapHandleToPos.set(c,0),(0,a.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(c,t),o){const v=this.mapHandleToLock.get(c);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${r})`),this.mapHandleToLock.set(c,o),v&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${r})`),v.dispose())}return c}async close(t){const i=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&n.canFlush)try{await p.Promises.fdatasync(t)}catch(r){n.configureFlushOnWrite(!1),this.logService.error(r)}return await p.Promises.close(t)}catch(r){throw this.toFileSystemProviderError(r)}finally{i&&(this.mapHandleToLock.get(t)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,r,o,c){const v=this.normalizePos(t,i);let E=null;try{E=(await p.Promises.read(t,r,o,c,v)).bytesRead}catch(d){throw this.toFileSystemProviderError(d)}finally{this.updatePos(t,v,E)}return E}normalizePos(t,i){return i===this.mapHandleToPos.get(t)?null:i}updatePos(t,i,r){const o=this.mapHandleToPos.get(t);typeof o=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(t,o+r):this.mapHandleToPos.delete(t)))}async write(t,i,r,o,c){return(0,l.retry)(()=>this.doWrite(t,i,r,o,c),100,3)}async doWrite(t,i,r,o,c){const v=this.normalizePos(t,i);let E=null;try{E=(await p.Promises.write(t,r,o,c,v)).bytesWritten}catch(d){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),d)}finally{this.updatePos(t,v,E)}return E}async mkdir(t){try{await p.Promises.mkdir(this.toFilePath(t))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(t,i){try{const r=this.toFilePath(t);i.recursive?await p.Promises.rm(r,p.RimRafMode.MOVE):await p.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(t,i,r){const o=this.toFilePath(t),c=this.toFilePath(i);if(o!==c)try{await this.validateTargetDeleted(t,i,"move",r.overwrite),await p.Promises.move(o,c)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,b.localize)(2,null,(0,D.basename)(o),(0,D.basename)((0,D.dirname)(c)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(t,i,r){const o=this.toFilePath(t),c=this.toFilePath(i);if(o!==c)try{await this.validateTargetDeleted(t,i,"copy",r.overwrite),await p.Promises.copy(o,c,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,b.localize)(3,null,(0,D.basename)(o),(0,D.basename)((0,D.dirname)(c)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(t,i,r,o){const c=this.toFilePath(t),v=this.toFilePath(i);let E=!1;if(!!(this.capabilities&1024)||(E=(0,P.isEqual)(c,v,!0)),E&&r==="copy")throw(0,a.createFileSystemProviderError)((0,b.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!E&&await p.Promises.exists(v)){if(!o)throw(0,a.createFileSystemProviderError)((0,b.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(t,i){return this.doCloneFile(t,i,!1)}async doCloneFile(t,i,r){const o=this.toFilePath(t),c=this.toFilePath(i),v=!!(this.capabilities&1024);if((0,P.isEqual)(o,c,!v))return;const E=new S.DisposableStore;try{const[d,I]=await Promise.all([this.createResourceLock(t),this.createResourceLock(i)]);E.add(d),E.add(I),r&&await p.Promises.mkdir((0,D.dirname)(c),{recursive:!0}),await p.Promises.copyFile(o,c)}catch(d){if(d.code==="ENOENT"&&!r)return this.doCloneFile(t,i,!0);throw this.toFileSystemProviderError(d)}finally{E.dispose()}}createUniversalWatcher(t,i,r){return new y.UniversalWatcherClient(o=>t(o),o=>i(o),r)}createNonRecursiveWatcher(t,i,r){return new L.NodeJSWatcherClient(o=>t(o),o=>i(o),r)}toFileSystemProviderError(t){if(t instanceof a.FileSystemProviderError)return t;let i=t,r;switch(t.code){case"ENOENT":r=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=a.FileSystemProviderErrorCode.Unknown;break;default:r=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(t,i){let r=this.toFileSystemProviderError(i);if(t&&r.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await p.SymlinkSupport.stat(this.toFilePath(t));o.mode&128||(r=(0,a.createFileSystemProviderError)(i,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}e.DiskFileSystemProvider=n,n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0}),define(oe[105],ae([0,1,3,2,5,10]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,l.createDecorator)("sharedProcessLifecycleService");let _=e.SharedProcessLifecycleService=class extends O.Disposable{constructor(P){super(),this.logService=P,this._onWillShutdown=this._register(new T.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=_=Se([Y(0,A.ILogService)],_)}),define(oe[106],ae([0,1,12,3,10,2]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class _ extends l.AbstractLoggerService{constructor(w,m,f,p,b){super(m,f,p),this.windowId=w,this.channel=b,this._register(b.listen("onDidChangeLogLevel",w)(a=>{(0,l.isLogLevel)(a)?super.setLogLevel(a):super.setLogLevel(T.URI.revive(a[0]),a[1])})),this._register(b.listen("onDidChangeVisibility",w)(([a,h])=>super.setVisibility(T.URI.revive(a),h))),this._register(b.listen("onDidChangeLoggers",w)(({added:a,removed:h})=>{for(const u of a)super.registerLogger({...u,resource:T.URI.revive(u.resource)});for(const u of h)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new l.AdapterLogger({log:(w,m)=>{this.channel.call("consoleLog",[w,m])}})}registerLogger(w){super.registerLogger(w),this.channel.call("registerLogger",[w,this.windowId])}deregisterLogger(w){super.deregisterLogger(w),this.channel.call("deregisterLogger",[w,this.windowId])}setLogLevel(w,m){super.setLogLevel(w,m),this.channel.call("setLogLevel",[w,m])}setVisibility(w,m){super.setVisibility(w,m),this.channel.call("setVisibility",[this.toResource(w),m])}doCreateLogger(w,m,f){return new k(this.channel,w,m,f,this.windowId)}static setLogLevel(w,m,f){return w.call("setLogLevel",[m,f])}}e.LoggerChannelClient=_;class k extends l.AbstractMessageLogger{constructor(w,m,f,p,b){super(p?.logLevel==="always"),this.channel=w,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[m,p,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,m){const f=[[w,m]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(w){this.channel.call("log",[this.file,w])}}class P{constructor(w,m){this.loggerService=w,this.getUriTransformer=m}listen(w,m){const f=this.getUriTransformer(w);switch(m){case"onDidChangeLoggers":return O.Event.map(this.loggerService.onDidChangeLoggers,p=>({added:[...p.added].map(b=>this.transformLogger(b,f)),removed:[...p.removed].map(b=>this.transformLogger(b,f))}));case"onDidChangeVisibility":return O.Event.map(this.loggerService.onDidChangeVisibility,p=>[f.transformOutgoingURI(p[0]),p[1]]);case"onDidChangeLogLevel":return O.Event.map(this.loggerService.onDidChangeLogLevel,p=>(0,l.isLogLevel)(p)?p:[f.transformOutgoingURI(p[0]),p[1]])}throw new Error(`Event not found: ${m}`)}async call(w,m,f){const p=this.getUriTransformer(w);switch(m){case"setLogLevel":return(0,l.isLogLevel)(f[0])?this.loggerService.setLogLevel(f[0]):this.loggerService.setLogLevel(T.URI.revive(p.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(b=>this.transformLogger(b,p)))}throw new Error(`Call not found: ${m}`)}transformLogger(w,m){return{...w,resource:m.transformOutgoingURI(w.resource)}}}e.LoggerChannel=P;class S extends A.Disposable{constructor(w,m){super(),m.call("setLogLevel",[w.getLogLevel()]),this._register(w.onDidChangeLogLevel(f=>m.call("setLogLevel",[f]))),m.call("getRegisteredLoggers").then(f=>{for(const p of f)w.registerLogger({...p,resource:T.URI.revive(p.resource)})}),this._register(m.listen("onDidChangeVisibility")(([f,p])=>w.setVisibility(T.URI.revive(f),p))),this._register(m.listen("onDidChangeLoggers")(({added:f,removed:p})=>{for(const b of f)w.registerLogger({...b,resource:T.URI.revive(b.resource)});for(const b of p)w.deregisterLogger(b.resource)}))}}e.RemoteLoggerChannelClient=S}),define(oe[209],ae([0,1,2,10]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends T.Disposable{constructor(_,k=[]){super(),this.logger=new O.MultiplexLogger([_,...k]),this._register(_.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(_){this.logger.setLevel(_)}getLevel(){return this.logger.getLevel()}trace(_,...k){this.logger.trace(_,...k)}debug(_,...k){this.logger.debug(_,...k)}info(_,...k){this.logger.info(_,...k)}warn(_,...k){this.logger.warn(_,...k)}error(_,...k){this.logger.error(_,...k)}flush(){this.logger.flush()}}e.LogService=l}),define(oe[56],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,T.createDecorator)("nativeHostService")}),define(oe[57],ae([0,1,3,62,2,5]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class _ extends l.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(S){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...S,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(S),O.Iterable.reduce(this.policies.entries(),(w,[m,f])=>({...w,[m]:f}),{})}getPolicyValue(S){return this.policies.get(S)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(S,[D,w])=>({...S,[D]:{definition:w,value:this.policies.get(D)}}),{})}}e.AbstractPolicyService=_;class k{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(oe[210],ae([0,1,3,2,57]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(P){this.service=P,this.disposables=new O.DisposableStore}listen(P,S){switch(S){case"onDidChange":return T.Event.map(this.service.onDidChange,D=>D.reduce((w,m)=>({...w,[m]:this.service.getPolicyValue(m)??null}),{}),this.disposables)}throw new Error(`Event not found: ${S}`)}call(P,S,D){switch(S){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(D)}throw new Error(`Call not found: ${S}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=A;class _ extends l.AbstractPolicyService{constructor(P,S){super(),this.channel=S;for(const D in P){const{definition:w,value:m}=P[D];this.policyDefinitions[D]=w,m!==void 0&&this.policies.set(D,m)}this.channel.listen("onDidChange")(D=>{for(const w in D){const m=D[w];m===null?this.policies.delete(w):this.policies.set(w,m)}this._onDidChange.fire(Object.keys(D))})}async _updatePolicyDefinitions(P){const S=await this.channel.call("updatePolicyDefinitions",P);for(const D in S)this.policies.set(D,S[D])}}e.PolicyChannelClient=_}),define(oe[107],ae([0,1,22,4,36,97]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let _;if(typeof O.globals.vscode<"u"&&typeof O.globals.vscode.context<"u"){const k=O.globals.vscode.context.configuration();if(k)_=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){_=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:k,searchUrl:P,itemUrl:S,controlUrl:D}=_.extensionsGallery||{};Object.assign(_,{extensionsGallery:{serviceUrl:l.env.VSCODE_GALLERY_SERVICE_URL||k,searchUrl:l.env.VSCODE_GALLERY_SEARCH_URL||P,itemUrl:l.env.VSCODE_GALLERY_ITEM_URL||S,controlUrl:l.env.VSCODE_GALLERY_CONTROL_URL||D}});try{const w=(...b)=>b.reduce((a,h)=>(Object.keys(h).forEach(u=>{Array.isArray(a[u])&&Array.isArray(h[u])?a[u]=h[u]:typeof a[u]=="object"&&typeof h[u]=="object"?a[u]=w(a[u],h[u]):a[u]=h[u]}),a),{}),m=(0,A.getUserDataPath)({},_.nameShort),f=O.isWindows?`file:///${m}/product.json`:`file://${m}/product.json`,p=ie.__$__nodeRequire(T.FileAccess.asFileUri(f).fsPath);_=w(_,p)}catch{}if(l.env.VSCODE_DEV&&Object.assign(_,{nameShort:`${_.nameShort} Dev`,nameLong:`${_.nameLong} Dev`,dataFolderName:`${_.dataFolderName}-dev`,serverDataFolderName:_.serverDataFolderName?`${_.serverDataFolderName}-dev`:void 0}),!_.version){const w=globalThis._VSCODE_PACKAGE_JSON;Object.assign(_,{version:w.version,release:w.release})}}else _={},Object.keys(_).length===0&&Object.assign(_,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=_}),define(oe[25],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[211],ae([0,1,6,9,2,14,28,10,25]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=e.CodeCacheCleaner=class extends l.Disposable{constructor(w,m,f){super(),this.productService=m,this.logService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new T.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},3e4)).schedule()}async cleanUpCodeCaches(w){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),f=(0,A.dirname)(w),p=(0,A.basename)(w),b=await _.Promises.readdir(f);await Promise.all(b.map(async a=>{if(a===p)return;const h=(0,A.join)(f,a),u=await _.Promises.stat(h);if(u.isDirectory()&&m-u.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${a}.`),_.Promises.rm(h)}))}catch(m){(0,O.onUnexpectedError)(m)}}};e.CodeCacheCleaner=S=Se([Y(1,P.IProductService),Y(2,k.ILogService)],S)}),define(oe[212],ae([0,1,6,9,2,14,28,15,10,25]),function(ie,e,T,O,l,A,_,k,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let D=e.LanguagePackCachedDataCleaner=class extends l.Disposable{constructor(m,f,p){super(),this.environmentService=m,this.logService=f,this.productService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new T.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),f=JSON.parse(await _.Promises.readFile((0,A.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(f)){const g=f[u];m[`${g.hash}.${u}`]=!0}const p=(0,A.join)(this.environmentService.userDataPath,"clp");if(!await _.Promises.exists(p))return;const a=await _.Promises.readdir(p);for(const u of a){if(m[u]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await _.Promises.rm((0,A.join)(p,u))}const h=Date.now();for(const u of Object.keys(m)){const g=(0,A.join)(p,u),y=await _.Promises.readdir(g);for(const L of y){if(L==="tcf.json")continue;const n=(0,A.join)(g,L),s=await _.Promises.stat(n);s.isDirectory()&&h-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(u,L)}`),await _.Promises.rm(n))}}}catch(m){(0,O.onUnexpectedError)(m)}}};e.LanguagePackCachedDataCleaner=D=Se([Y(0,k.INativeEnvironmentService),Y(1,P.ILogService),Y(2,S.IProductService)],D)}),define(oe[213],ae([0,1,14,5]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,O.createDecorator)("IV8InspectProfilingService");var l;(function(A){function _(P){return!!(P.samples&&P.timeDeltas)}A.isValidProfile=_;function k(P,S="noAbsolutePaths"){for(const D of P.nodes)D.callFrame&&D.callFrame.url&&((0,T.isAbsolute)(D.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(D.callFrame.url))&&(D.callFrame.url=(0,T.join)(S,(0,T.basename)(D.callFrame.url)));return P}A.rewriteAbsolutePaths=k})(l||(e.Utils=l={}))}),define(oe[214],ae([0,1,32]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class O{constructor(){this._sessions=new Map}async startProfiling(A){const k=await(await new Promise((S,D)=>{ie(["v8-inspect-profiler"],S,D)})).startProfiling({port:A.port,checkForPaused:!0}),P=(0,T.generateUuid)();return this._sessions.set(P,k),P}async stopProfiling(A){const _=this._sessions.get(A);if(!_)throw new Error(`UNKNOWN session '${A}'`);const k=await _.stop();return this._sessions.delete(A),k.profile}}e.InspectProfilingService=O}),define(oe[39],ae([0,1,128,11]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.data=new Map}add(_,k){T.ok(O.isString(_)),T.ok(O.isObject(k)),T.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,k)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new l}),define(oe[108],ae([0,1,3,39]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(P,S){this.schemasById[l(P)]=S,this._onDidChangeSchema.fire(P)}notifySchemaChanged(P){this._onDidChangeSchema.fire(P)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new A;O.Registry.add(e.Extensions.JSONContribution,_)}),define(oe[45],ae([0,1,21,3,11,151,17,108,39]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(L){L.Multiline="multilineText",L.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(L){L[L.APPLICATION=1]="APPLICATION",L[L.MACHINE=2]="MACHINE",L[L.WINDOW=3]="WINDOW",L[L.RESOURCE=4]="RESOURCE",L[L.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",L[L.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(e.ConfigurationScope=D={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=P.Registry.as(k.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const t=new Set;this.doRegisterConfigurations(n,s,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(n){const s=new Set;this.doDeregisterConfigurations(n,s),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:n,remove:s}){const t=new Set;this.doDeregisterConfigurations(s,t),this.doRegisterConfigurations(n,!1,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}registerDefaultConfigurations(n){const s=new Set;this.doRegisterDefaultConfigurations(n,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,s){const t=[];for(const{overrides:i,source:r}of n)for(const o in i)if(s.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const c=this.configurationDefaultsOverrides.get(o),v=c?.valuesSources??new Map;if(r)for(const R of Object.keys(i[o]))v.set(R,r);const E={...c?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:r,value:E,valuesSources:v});const d=(0,_.getLanguageTagSettingPlainKey)(o),I={type:"object",default:E,description:A.localize(1,null,d),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:l.isString(r)?void 0:r,defaultValueSource:r};t.push(...b(o)),this.configurationProperties[o]=I,this.defaultLanguageConfigurationOverridesNode.properties[o]=I}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:r});const c=this.configurationProperties[o];c&&(this.updatePropertyDefaultValue(o,c),this.updateSchema(o,c))}this.doRegisterOverrideIdentifiers(t)}deregisterDefaultConfigurations(n){const s=new Set;this.doDeregisterDefaultConfigurations(n,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,s){for(const{overrides:t,source:i}of n)for(const r in t){const o=this.configurationDefaultsOverrides.get(r),c=l.isString(i)?i:i?.id,v=l.isString(o?.source)?o?.source:o?.source?.id;if(c===v)if(s.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const E=this.configurationProperties[r];E&&(this.updatePropertyDefaultValue(r,E),this.updateSchema(r,E))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(n){let s=!1;const t=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,t),s=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,t),s=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,t),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const s of n)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,s,t){n.forEach(i=>{this.validateAndRegisterProperties(i,s,i.extensionInfo,i.restrictedProperties,void 0,t),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(n,s){const t=i=>{if(i.properties)for(const r in i.properties){s.add(r);const o=this.configurationProperties[r];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>t(r))};for(const i of n){t(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(n,s=!0,t,i,r=3,o){r=l.isUndefinedOrNull(n.scope)?r:n.scope;const c=n.properties;if(c)for(const E in c){const d=c[E];if(s&&g(E,d)){delete c[E];continue}if(d.source=t,d.defaultDefaultValue=c[E].default,this.updatePropertyDefaultValue(E,d),e.OVERRIDE_PROPERTY_REGEX.test(E)?d.scope=void 0:(d.scope=l.isUndefinedOrNull(d.scope)?r:d.scope,d.restricted=l.isUndefinedOrNull(d.restricted)?!!i?.includes(E):d.restricted),c[E].hasOwnProperty("included")&&!c[E].included){this.excludedConfigurationProperties[E]=c[E],delete c[E];continue}else this.configurationProperties[E]=c[E],c[E].policy?.name&&this.policyConfigurations.set(c[E].policy.name,E);!c[E].deprecationMessage&&c[E].markdownDeprecationMessage&&(c[E].deprecationMessage=c[E].markdownDeprecationMessage),o.add(E)}const v=n.allOf;if(v)for(const E of v)this.validateAndRegisterProperties(E,s,t,i,r,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const s=t=>{const i=t.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);t.allOf?.forEach(s)};s(n)}updateSchema(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.resourceLanguageSettingsSchema.properties[n]=s;break}}removeFromSchema(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const s=`[${n}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}}registerOverridePropertyPatternKey(){const n={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,s){const t=this.configurationDefaultsOverrides.get(n);let i=t?.value,r=t?.source;l.isUndefined(i)&&(i=s.defaultDefaultValue,r=void 0),l.isUndefined(i)&&(i=h(s.type)),s.default=i,s.defaultValueSource=r}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(L){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(L)){let s=p.exec(L);for(;s?.length;){const t=s[1].trim();t&&n.push(t),s=p.exec(L)}}return(0,T.distinct)(n)}e.overrideIdentifiersFromKey=b;function a(L){return L.reduce((n,s)=>`${n}[${s}]`,"")}e.keyFromOverrideIdentifiers=a;function h(L){switch(Array.isArray(L)?L[0]:L){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const u=new m;P.Registry.add(e.Extensions.Configuration,u);function g(L,n){return L.trim()?e.OVERRIDE_PROPERTY_REGEX.test(L)?A.localize(7,null,L):u.getConfigurationProperties()[L]!==void 0?A.localize(8,null,L):n.policy?.name&&u.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(9,null,L,n.policy?.name,u.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(6,null)}e.validateProperty=g;function y(){const L=[],n=u.getConfigurationProperties();for(const s of Object.keys(n))L.push([s,n[s].scope]);return L.push(["launch",4]),L.push(["task",4]),L}e.getScopes=y}),define(oe[75],ae([0,1,21,3,35,2,37,31,11,12,17,45,39]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(s){return Object.isFrozen(s)?s:k.deepFreeze(s)}class p{constructor(t={},i=[],r=[],o){this._contents=t,this._keys=i,this._overrides=r,this.raw=o,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof p)return i;const r=new b("");return r.parseRaw(i),r.configurationModel});this._rawConfiguration=t.reduce((i,r)=>r===i?r:i.merge(r),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,D.getConfigurationValue)(this.contents,t):this.contents}inspect(t,i){const r=this.rawConfiguration.getValue(t),o=i?this.rawConfiguration.getOverrideValue(t,i):void 0,c=i?this.rawConfiguration.override(i).getValue(t):r;return{value:r,override:o,merged:c}}getOverrideValue(t,i){const r=this.getContentsForOverrideIdentifer(i);return r?t?(0,D.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const r of this.overrides)r.identifiers.includes(t)&&i.push(...r.keys);return T.distinct(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return T.distinct(t)}override(t){let i=this.overrideConfigurations.get(t);return i||(i=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,i)),i}merge(...t){const i=k.deepClone(this.contents),r=k.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const v of t)if(c.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.mergeContents(i,v.contents);for(const E of v.overrides){const[d]=r.filter(I=>T.equals(I.identifiers,E.identifiers));d?(this.mergeContents(d.contents,E.contents),d.keys.push(...E.keys),d.keys=T.distinct(d.keys)):r.push(k.deepClone(E))}for(const E of v.keys)o.indexOf(E)===-1&&o.push(E)}return new p(i,o,r,c.every(v=>v instanceof p)?void 0:c)}createOverrideConfigurationModel(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o];const v=i[o];v&&(typeof c=="object"&&typeof v=="object"?(c=k.deepClone(c),this.mergeContents(c,v)):c=v),r[o]=c}return new p(r,this.keys,this.overrides)}mergeContents(t,i){for(const r of Object.keys(i)){if(r in t&&P.isObject(t[r])&&P.isObject(i[r])){this.mergeContents(t[r],i[r]);continue}t[r]=k.deepClone(i[r])}}getContentsForOverrideIdentifer(t){let i=null,r=null;const o=c=>{c&&(r?this.mergeContents(r,c):r=k.deepClone(c))};for(const c of this.overrides)T.equals(c.identifiers,[t])?i=c.contents:c.identifiers.includes(t)&&o(c.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.updateValue(t,i,!0)}setValue(t,i){this.updateValue(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,D.removeFromValueTree)(this.contents,t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>T.equals(r.identifiers,(0,w.overrideIdentifiersFromKey)(t))),1))}updateValue(t,i,r){(0,D.addToValueTree)(this.contents,t,i,o=>console.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,D.toValuesTree)(this.contents[t],o=>console.error(o))})}}e.ConfigurationModel=p;class b{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!P.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:r,keys:o,overrides:c,restricted:v,hasExcludedProperties:E}=this.doParseRaw(t,i);this._configurationModel=new p(r,o,c,E?[t]:void 0),this._restrictedConfigurations=v||[]}doParseContent(t){let i={},r=null,o=[];const c=[],v=[];function E(I){Array.isArray(o)?o.push(I):r!==null&&(o[r]=I)}const d={onObjectBegin:()=>{const I={};E(I),c.push(o),o=I,r=null},onObjectProperty:I=>{r=I},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const I=[];E(I),c.push(o),o=I,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:E,onError:(I,R,N)=>{v.push({error:I,offset:R,length:N})}};if(t)try{l.visit(t,d),i=o[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return i}doParseRaw(t,i){const r=m.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,r,!0,i);t=o.raw;const c=(0,D.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),v=Object.keys(t),E=this.toOverrides(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:c,keys:v,overrides:E,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(t,i,r,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:c};const v={},E=[];for(const d in t)if(w.OVERRIDE_PROPERTY_REGEX.test(d)&&r){const I=this.filter(t[d],i,!1,o);v[d]=I.raw,c=c||I.hasExcludedProperties,E.push(...I.restricted)}else{const I=i[d],R=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&E.push(d),(R===void 0||o.scopes===void 0||o.scopes.includes(R))&&!(o.skipRestricted&&I?.restricted)?v[d]=t[d]:c=!0}return{raw:v,restricted:E,hasExcludedProperties:c}}toOverrides(t,i){const r=[];for(const o of Object.keys(t))if(w.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const v in t[o])c[v]=t[o][v];r.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,D.toValuesTree)(c,i)})}return r}}e.ConfigurationModelParser=b;class a extends A.Disposable{constructor(t,i,r,o){super(),this.userSettingsResource=t,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=a;class h{constructor(t,i,r,o,c,v,E,d,I,R,N,F,W){this.key=t,this.overrides=i,this._value=r,this.overrideIdentifiers=o,this.defaultConfiguration=c,this.policyConfiguration=v,this.applicationConfiguration=E,this.userConfiguration=d,this.localUserConfiguration=I,this.remoteUserConfiguration=R,this.workspaceConfiguration=N,this.folderConfigurationModel=F,this.memoryConfigurationModel=W}get value(){return f(this._value)}inspect(t,i,r){const o=t.inspect(i,r);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class u{constructor(t,i,r,o,c=new p,v=new p,E=new _.ResourceMap,d=new p,I=new _.ResourceMap){this._defaultConfiguration=t,this._policyConfiguration=i,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=c,this._workspaceConfiguration=v,this._folderConfigurations=E,this._memoryConfiguration=d,this._memoryConfigurationByResource=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(t,i,r){return this.getConsolidatedConfigurationModel(t,i,r).getValue(t)}updateValue(t,i,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new p,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(t):o.setValue(t,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,r){const o=this.getConsolidatedConfigurationModel(t,i,r),c=this.getFolderConfigurationModelForResource(i.resource,r),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,E=new Set;for(const d of o.overrides)for(const I of d.identifiers)o.getOverrideValue(t,I)!==void 0&&E.add(I);return new h(t,i,o.getValue(t),E.size?[...E]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,c||void 0,v)}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const r=[];if(!i){const{added:o,updated:c,removed:v}=L(this._defaultConfiguration,t);i=[...o,...c,...v]}for(const o of i)for(const c of(0,w.overrideIdentifiersFromKey)(o)){const v=this._defaultConfiguration.getKeysForOverrideIdentifier(c),E=t.getKeysForOverrideIdentifier(c),d=[...E.filter(I=>v.indexOf(I)===-1),...v.filter(I=>E.indexOf(I)===-1),...v.filter(I=>!k.equals(this._defaultConfiguration.override(c).getValue(I),t.override(c).getValue(I)))];r.push([c,d])}return this.updateDefaultConfiguration(t),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:r,removed:o}=L(this._policyConfiguration,t),c=[...i,...r,...o];return c.length&&this.updatePolicyConfiguration(t),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:r,removed:o,overrides:c}=L(this.applicationConfiguration,t),v=[...i,...r,...o];return v.length&&this.updateApplicationConfiguration(t),{keys:v,overrides:c}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:r,removed:o,overrides:c}=L(this.localUserConfiguration,t),v=[...i,...r,...o];return v.length&&this.updateLocalUserConfiguration(t),{keys:v,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:r,removed:o,overrides:c}=L(this.remoteUserConfiguration,t),v=[...i,...r,...o];return v.length&&this.updateRemoteUserConfiguration(t),{keys:v,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:r,removed:o,overrides:c}=L(this.workspaceConfiguration,t),v=[...i,...r,...o];return v.length&&this.updateWorkspaceConfiguration(t),{keys:v,overrides:c}}compareAndUpdateFolderConfiguration(t,i){const r=this.folderConfigurations.get(t),{added:o,updated:c,removed:v,overrides:E}=L(r,i),d=[...o,...c,...v];return(d.length||!r)&&this.updateFolderConfiguration(t,i),{keys:d,overrides:E}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:c,overrides:v}=L(i,void 0);return{keys:[...r,...o,...c],overrides:v}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,i,r){let o=this.getConsolidatedConfigurationModelForResource(i,r);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:t},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const o=i.getFolder(t);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const c=this._memoryConfigurationByResource.get(t);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(i=r.merge(o),this._foldersConsolidatedConfigurations.set(t,i)):i=r}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const r=i.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:r,overrides:o,keys:c}=this._folderConfigurations.get(i);return t.push([i,{contents:r,overrides:o,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this._workspaceConfiguration.keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(r=>t.add(r))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.policy),o=this.parseConfigurationModel(t.application),c=this.parseConfigurationModel(t.user),v=this.parseConfigurationModel(t.workspace),E=t.folders.reduce((d,I)=>(d.set(S.URI.revive(I[0]),this.parseConfigurationModel(I[1])),d),new _.ResourceMap);return new u(i,r,o,c,new p,v,E,new p,new _.ResourceMap)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides)}}e.Configuration=u;function g(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,i=new Map;for(const o of s)o.keys.forEach(c=>t.add(c)),o.overrides.forEach(([c,v])=>{const E=(0,_.getOrSet)(i,c,new Set);v.forEach(d=>E.add(d))});const r=[];return i.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=g;class y{constructor(t,i,r,o){this.change=t,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=o,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const c of t.keys)this.affectedKeys.add(c);for(const[,c]of t.overrides)for(const v of c)this.affectedKeys.add(v);this._affectsConfigStr=this._marker;for(const c of this.affectedKeys)this._affectsConfigStr+=c+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){const r=this._marker+t,o=this._affectsConfigStr.indexOf(r);if(o<0)return!1;const c=o+r.length;if(c>=this._affectsConfigStr.length)return!1;const v=this._affectsConfigStr.charCodeAt(c);if(v!==this._markerCode1&&v!==this._markerCode2)return!1;if(i){const E=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!k.equals(E,d)}return!0}}e.ConfigurationChangeEvent=y;function L(s,t){const{added:i,removed:r,updated:o}=n(t?.rawConfiguration,s?.rawConfiguration),c=[],v=s?.getAllOverrideIdentifiers()||[],E=t?.getAllOverrideIdentifiers()||[];if(t){const d=E.filter(I=>!v.includes(I));for(const I of d)c.push([I,t.getKeysForOverrideIdentifier(I)])}if(s){const d=v.filter(I=>!E.includes(I));for(const I of d)c.push([I,s.getKeysForOverrideIdentifier(I)])}if(t&&s){for(const d of v)if(E.includes(d)){const I=n({contents:s.getOverrideValue(void 0,d)||{},keys:s.getKeysForOverrideIdentifier(d)},{contents:t.getOverrideValue(void 0,d)||{},keys:t.getKeysForOverrideIdentifier(d)});c.push([d,[...I.added,...I.removed,...I.updated]])}}return{added:i,removed:r,updated:o,overrides:c}}function n(s,t){const i=s?t?s.keys.filter(c=>t.keys.indexOf(c)===-1):[...s.keys]:[],r=t?s?t.keys.filter(c=>s.keys.indexOf(c)===-1):[...t.keys]:[],o=[];if(s&&t){for(const c of t.keys)if(s.keys.indexOf(c)!==-1){const v=(0,D.getConfigurationValue)(t.contents,c),E=(0,D.getConfigurationValue)(s.contents,c);k.equals(v,E)||o.push(c)}}return{added:i,removed:r,updated:o}}}),define(oe[215],ae([0,1,21,3,2,31,11,75,45,10,57,39]),function(ie,e,T,O,l,A,_,k,P,S,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends l.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new k.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(w.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:h})=>this.onDidUpdateConfiguration(Array.from(a),h))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(a,h){this.updateConfigurationModel(a,w.Registry.as(P.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:a})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new k.ConfigurationModel;const a=w.Registry.as(P.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(a),a)}updateConfigurationModel(a,h){const u=this.getConfigurationDefaultOverrides();for(const g of a){const y=u[g],L=h[g];y!==void 0?this._configurationModel.addValue(g,y):L?this._configurationModel.addValue(g,L.default):this._configurationModel.removeValue(g)}}}e.DefaultConfiguration=m;class f{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let p=e.PolicyConfiguration=class extends l.Disposable{get configurationModel(){return this._configurationModel}constructor(a,h,u){super(),this.defaultConfiguration=a,this.policyService=h,this.logService=u,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new k.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(a=>this.onDidChangePolicies(a))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:a})=>this.update(await this.updatePolicyDefinitions(a),!0))),this._configurationModel}async updatePolicyDefinitions(a){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",a);const h={},u=[],g=w.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(const y of a){const L=g[y];if(!L){u.push(y);continue}if(L.policy){if(L.type!=="string"&&L.type!=="number"){this.logService.warn(`Policy ${L.policy.name} has unsupported type ${L.type}`);continue}u.push(y),h[L.policy.name]={type:L.type}}}return(0,_.isEmptyObject)(h)||await this.policyService.updatePolicyDefinitions(h),u}onDidChangePolicies(a){this.logService.trace("PolicyConfiguration#onDidChangePolicies",a);const h=w.Registry.as(P.Extensions.Configuration).getPolicyConfigurations(),u=(0,T.coalesce)(a.map(g=>h.get(g)));this.update(u,!0)}update(a,h){this.logService.trace("PolicyConfiguration#update",a);const u=w.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),g=[],y=this._configurationModel.isEmpty();for(const L of a){const n=u[L]?.policy?.name;if(n){const s=this.policyService.getPolicyValue(n);(y?s!==void 0:!(0,A.equals)(this._configurationModel.getValue(L),s))&&g.push([L,s])}else this._configurationModel.getValue(L)!==void 0&&g.push([L,void 0])}if(g.length){this.logService.trace("PolicyConfiguration#changed",g);const L=this._configurationModel;this._configurationModel=new k.ConfigurationModel;for(const n of L.keys)this._configurationModel.setValue(n,L.getValue(n));for(const[n,s]of g)s===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,s);h&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=p=Se([Y(1,D.IPolicyService),Y(2,S.ILogService)],p)}),define(oe[216],ae([0,1,6,3,2,23,17,75,215,57]),function(ie,e,T,O,l,A,_,k,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends l.Disposable{constructor(m,f,p,b){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new P.DefaultConfiguration),this.policyConfiguration=p instanceof S.NullPolicyService?new P.NullPolicyConfiguration:this._register(new P.PolicyConfiguration(this.defaultConfiguration,p,b)),this.userConfiguration=this._register(new k.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,f)),this.configuration=new k.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:a,properties:h})=>this.onDidDefaultConfigurationChange(a,h))),this._register(this.policyConfiguration.onDidChangeConfiguration(a=>this.onDidPolicyConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,f,p]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new k.Configuration(m,f,new k.ConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(m,f){const p=typeof m=="string"?m:void 0,b=(0,_.isConfigurationOverrides)(m)?m:(0,_.isConfigurationOverrides)(f)?f:{};return this.configuration.getValue(p,b,void 0)}updateValue(m,f,p,b){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const f=this.configuration.toData(),p=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(p,f,2)}onDidDefaultConfigurationChange(m,f){const p=this.configuration.toData(),b=this.configuration.compareAndUpdateDefaultConfiguration(m,f);this.trigger(b,p,7)}onDidPolicyConfigurationChange(m){const f=this.configuration.toData(),p=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(p,f,7)}trigger(m,f,p){const b=new k.ConfigurationChangeEvent(m,{data:f},this.configuration);b.source=p,b.sourceConfig=this.getTargetConfiguration(p),this._onDidChangeConfiguration.fire(b)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(oe[217],ae([0,1,9,5]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var l;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class A extends T.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof A&&P._code===l.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof A&&P._code===l.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof A&&P._code===l.NoResolverFound}static isHandled(P){return P instanceof A&&P.isHandled}constructor(P,S=l.Unknown,D){super(P),this._message=P,this._code=S,this._detail=D,this.isHandled=S===l.NotAvailable&&D===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function _(k){const P=k.indexOf("+");return P===-1?k:k.substring(0,P)}e.getRemoteAuthorityPrefix=_}),define(oe[76],ae([0,1,22]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(S){return S.scheme===T.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=O;function l(S){if(!S)return;const D=S.indexOf("+");return D<0?S:S.substr(0,D)}e.getRemoteName=l;function A(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=A;function _(S){const{host:D,port:w}=P(S);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:D,port:w}}e.parseAuthorityWithPort=_;function k(S,D){let{host:w,port:m}=P(S);return typeof m>"u"&&(m=D),{host:w,port:m}}e.parseAuthorityWithOptionalPort=k;function P(S){const D=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const w=S.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const m=S.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:S,port:void 0}}}),define(oe[50],ae([0,1,27,5,76]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(_||(e.ExtensionType=_={}));var k;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class P{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,h){if(typeof a>"u"||a===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof a=="string"||typeof h=="string"){const u=typeof a=="string"?a:a.value,g=typeof h=="string"?h:h.value;return T.equalsIgnoreCase(u,g)}return a._lower===h._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.ExtensionIdentifier=P;class S{get size(){return this._set.size}constructor(a){if(this._set=new Set,a)for(const h of a)this.add(h)}add(a){this._set.add(P.toKey(a))}delete(a){return this._set.delete(P.toKey(a))}has(a){return this._set.has(P.toKey(a))}}e.ExtensionIdentifierSet=S;class D{constructor(){this._map=new Map}clear(){this._map.clear()}delete(a){this._map.delete(P.toKey(a))}get(a){return this._map.get(P.toKey(a))}has(a){return this._map.has(P.toKey(a))}set(a,h){this._map.set(P.toKey(a),h)}values(){return this._map.values()}forEach(a){this._map.forEach(a)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=D;function w(b){return m(b)}e.isApplicationScopedExtension=w;function m(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function f(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function p(b,a){if(a){const h=`onResolveRemoteAuthority:${(0,l.getRemoteName)(a)}`;return!!b.activationEvents?.includes(h)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[218],ae([0,1,2,50,13]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends T.Disposable{constructor(k,P,S,D,w){super(),this.userDataProfilesService=k,this.fileService=P,this.uriIdentityService=S,this.logService=w,this._register(D.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(D.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(k){for(const P of k)P.local&&this.invalidate(P.profileLocation)}onDidUnInstallExtension(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const P of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(P.extensionsResource,k)&&await this.deleteUserCacheFile(P);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(k){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(k.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(P){(0,l.toFileOperationResult)(P)!==1&&this.logService.error(P)}}}e.ExtensionsManifestCache=A}),define(oe[219],ae([0,1,6,16,26,9,3,2,104,89,32,96,217,76]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var b;(function(C){C[C.Management=1]="Management",C[C.ExtensionHost=2]="ExtensionHost",C[C.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function a(C){switch(C){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(C){const U=new l.CancellationTokenSource;return setTimeout(()=>U.cancel(),C),U.token}function u(C,U){if(C.isCancellationRequested||U.isCancellationRequested)return l.CancellationToken.Cancelled;const z=new l.CancellationTokenSource;return C.onCancellationRequested(()=>z.cancel()),U.onCancellationRequested(()=>z.cancel()),z.token}class g{get didTimeout(){return this._state==="timedout"}constructor(U){this._state="pending",this._disposables=new k.DisposableStore,this.promise=new Promise((z,H)=>{this._resolvePromise=z,this._rejectPromise=H}),U.isCancellationRequested?this._timeout():this._disposables.add(U.onCancellationRequested(()=>this._timeout()))}registerDisposable(U){this._state==="pending"?this._disposables.add(U):U.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(U))}reject(U){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(U))}}function y(C,U){const z=new g(U);return z.registerDisposable(C.onControlMessage(H=>{const V=JSON.parse(H.toString()),X=te(V);X?z.reject(X):z.resolve(V)})),z.promise}function L(C,U,z,H,V,X,ee,ce,ue){const fe=new g(ue),ve=S.StopWatch.create(!1);return C.info(`Creating a socket (${ce})...`),P.mark(`code/willCreateSocket/${ee}`),U.connect(z,H,V,X,ce,(ye,be)=>{fe.didTimeout?(P.mark(`code/didCreateSocketError/${ee}`),C.info(`Creating a socket (${ce}) finished after ${ve.elapsed()} ms, but this is too late and has timed out already.`),ye&&C.error(ye),be?.dispose()):ye||!be?(P.mark(`code/didCreateSocketError/${ee}`),C.info(`Creating a socket (${ce}) returned an error after ${ve.elapsed()} ms.`),fe.reject(ye)):(P.mark(`code/didCreateSocketOK/${ee}`),C.info(`Creating a socket (${ce}) was successful after ${ve.elapsed()} ms.`),fe.resolve(be))}),fe.promise}function n(C,U){const z=new g(U);return C.then(H=>{z.didTimeout||z.resolve(H)},H=>{z.didTimeout||z.reject(H)}),z.promise}async function s(C,U,z,H){const V=G(C,U);C.logService.trace(`${V} 1/6. invoking socketFactory.connect().`);let X;try{X=await L(C.logService,C.socketFactory,C.host,C.port,(0,f.getRemoteServerRootPath)(C),`reconnectionToken=${C.reconnectionToken}&reconnection=${C.reconnectionProtocol?"true":"false"}`,a(U),`renderer-${a(U)}-${C.reconnectionToken}`,H)}catch(ve){throw C.logService.error(`${V} socketFactory.connect() failed or timed out. Error:`),C.logService.error(ve),ve}C.logService.trace(`${V} 2/6. socketFactory.connect() was successful.`);let ee,ce;C.reconnectionProtocol?(C.reconnectionProtocol.beginAcceptReconnection(X,null),ee=C.reconnectionProtocol,ce=!1):(ee=new w.PersistentProtocol({socket:X,measureRoundTripTime:!0}),ce=!0),C.logService.trace(`${V} 3/6. sending AuthRequest control message.`);const ue=await n(C.signService.createNewMessage((0,D.generateUuid)()),H),fe={type:"auth",auth:C.connectionToken||"00000000000000000000",data:ue.data};ee.sendControl(O.VSBuffer.fromString(JSON.stringify(fe)));try{const ve=await y(ee,u(H,h(1e4)));if(ve.type!=="sign"||typeof ve.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(C.logService.trace(`${V} 4/6. received SignRequest control message.`),!await n(C.signService.validate(ue,ve.signedData),H)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const be=await n(C.signService.sign(ve.data),H),De={type:"connectionType",commit:C.commit,signedData:be,desiredConnectionType:U};return z&&(De.args=z),C.logService.trace(`${V} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(O.VSBuffer.fromString(JSON.stringify(De))),{protocol:ee,ownsProtocol:ce}}catch(ve){throw ve&&ve.code==="ETIMEDOUT"&&(C.logService.error(`${V} the handshake timed out. Error:`),C.logService.error(ve)),ve&&ve.code==="VSCODE_CONNECTION_ERROR"&&(C.logService.error(`${V} received error control message when negotiating connection. Error:`),C.logService.error(ve)),ce&&j(ee),ve}}async function t(C,U,z,H){const V=Date.now(),X=G(C,U),{protocol:ee,ownsProtocol:ce}=await s(C,U,z,H),ue=new g(H);return ue.registerDisposable(ee.onControlMessage(fe=>{const ve=JSON.parse(fe.toString()),ye=te(ve);ye?(C.logService.error(`${X} received error control message when negotiating connection. Error:`),C.logService.error(ye),ce&&j(ee),ue.reject(ye)):(C.reconnectionProtocol?.endAcceptReconnection(),C.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${M(V)}!`),ue.resolve({protocol:ee,firstMessage:ve}))})),ue.promise}async function i(C,U){const{protocol:z}=await t(C,1,void 0,U);return{protocol:z}}async function r(C,U,z){const{protocol:H,firstMessage:V}=await t(C,2,U,z),X=V&&V.debugPort;return{protocol:H,debugPort:X}}async function o(C,U,z){const H=Date.now(),V=G(C,3),{protocol:X}=await s(C,3,U,z);return C.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${M(H)}!`),X}async function c(C,U,z){const{host:H,port:V,connectionToken:X}=await C.addressProvider.getAddress();return{commit:C.commit,quality:C.quality,host:H,port:V,connectionToken:X,reconnectionToken:U,reconnectionProtocol:z,socketFactory:C.socketFactory,signService:C.signService,logService:C.logService}}async function v(C,U,z){return d(C,async H=>{const{protocol:V}=await i(H,l.CancellationToken.None);return new x(C,U,z,H.reconnectionToken,V)})}e.connectRemoteAgentManagement=v;async function E(C,U){return d(C,async z=>{const{protocol:H,debugPort:V}=await r(z,U,l.CancellationToken.None);return new $(C,U,z.reconnectionToken,H,V)})}e.connectRemoteAgentExtensionHost=E;async function d(C,U){for(let H=1;;H++)try{const V=(0,D.generateUuid)(),X=await c(C,V,null);return await U(X)}catch(V){if(H<5)C.logService.error(`[remote-connection][attempt ${H}] An error occurred in initial connection! Will retry... Error:`),C.logService.error(V);else throw C.logService.error(`[remote-connection][attempt ${H}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),C.logService.error(V),K.triggerPermanentFailure(0,0,m.RemoteAuthorityResolverError.isHandled(V)),V}}async function I(C,U,z){const H=await c(C,(0,D.generateUuid)(),null);return await o(H,{host:U,port:z},l.CancellationToken.None)}e.connectRemoteAgentTunnel=I;function R(C){return(0,T.createCancelablePromise)(U=>new Promise((z,H)=>{const V=setTimeout(z,C*1e3);U.onCancellationRequested(()=>{clearTimeout(V),z()})}))}var N;(function(C){C[C.ConnectionLost=0]="ConnectionLost",C[C.ReconnectionWait=1]="ReconnectionWait",C[C.ReconnectionRunning=2]="ReconnectionRunning",C[C.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",C[C.ConnectionGain=4]="ConnectionGain",C[C.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(N||(e.PersistentConnectionEventType=N={}));class F{constructor(U,z){this.reconnectionToken=U,this.millisSinceLastIncomingData=z,this.type=0}}e.ConnectionLostEvent=F;class W{constructor(U,z,H,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=z,this.durationSeconds=H,this.cancellableTimer=V,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class q{constructor(U,z,H){this.reconnectionToken=U,this.millisSinceLastIncomingData=z,this.attempt=H,this.type=2}}e.ReconnectionRunningEvent=q;class B{constructor(U,z,H){this.reconnectionToken=U,this.millisSinceLastIncomingData=z,this.attempt=H,this.type=4}}e.ConnectionGainEvent=B;class Q{constructor(U,z){this.reconnectionToken=U,this.connectionHealth=z,this.type=5}}e.ConnectionHealthChangedEvent=Q;class Z{constructor(U,z,H,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=z,this.attempt=H,this.handled=V,this.type=3}}e.ReconnectionPermanentFailureEvent=Z;class K extends k.Disposable{static triggerPermanentFailure(U,z,H){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=U,this._permanentFailureAttempt=z,this._permanentFailureHandled=H,this._instances.forEach(V=>V._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(U=>U._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(U=>U._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||K._permanentFailure}constructor(U,z,H,V,X){super(),this._connectionType=U,this._options=z,this.reconnectionToken=H,this.protocol=V,this._reconnectionFailureIsFatal=X,this._onDidStateChange=this._register(new _.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new B(this.reconnectionToken,0,0)),this._register(V.onSocketClose(ee=>{const ce=J(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${ce} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${ce} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${ce} received socket close event.`),this._beginReconnecting()})),this._register(V.onSocketTimeout(ee=>{const ce=J(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),this._register(V.onHighRoundTripTime(ee=>{const ce=se(this._connectionType,this.reconnectionToken);this._options.logService.info(`${ce} high roundtrip time: ${ee.roundTripTime}ms (${ee.recentHighRoundTripCount} of 5 recent samples)`)})),this._register(V.onDidChangeConnectionHealth(ee=>{this._onDidStateChange.fire(new Q(this.reconnectionToken,ee))})),K._instances.push(this),this._register((0,k.toDisposable)(()=>{const ee=K._instances.indexOf(this);ee>=0&&K._instances.splice(ee,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const U=J(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30];let H=-1;do{H++;const V=H<z.length?z[H]:z[z.length-1];try{if(V>0){const ee=R(V);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V,ee)),this._options.logService.info(`${U} waiting for ${V} seconds before reconnecting...`);try{await ee}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1)),this._options.logService.info(`${U} resolving connection...`);const X=await c(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${U} connecting to ${X.host}:${X.port}...`),await this._reconnect(X,h(p)),this._options.logService.info(`${U} reconnected!`),this._onDidStateChange.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(H>360){this._options.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(m.RemoteAuthorityResolverError.isTemporarilyNotAvailable(X)){this._options.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this._options.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((0,A.isCancellationError)(X)){this._options.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if(X instanceof m.RemoteAuthorityResolverError){this._options.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,m.RemoteAuthorityResolverError.isHandled(X));break}this._options.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(U,z,H){this._reconnectionFailureIsFatal?K.triggerPermanentFailure(U,z,H):this._gotoPermanentFailure(U,z,H)}_gotoPermanentFailure(U,z,H){this._onDidStateChange.fire(new Z(this.reconnectionToken,U,z,H)),j(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=K,K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[];class x extends K{constructor(U,z,H,V,X){super(1,U,V,X,!0),this.client=this._register(new w.Client(X,{remoteAuthority:z,clientId:H},U.ipcLogger))}async _reconnect(U,z){await i(U,z)}}e.ManagementPersistentConnection=x;class $ extends K{constructor(U,z,H,V,X){super(2,U,H,V,!1),this._startArguments=z,this.debugPort=X}async _reconnect(U,z){await r(U,this._startArguments,z)}}e.ExtensionHostPersistentConnection=$;function j(C){try{C.acceptDisconnect();const U=C.getSocket();C.dispose(),U.dispose()}catch(U){(0,A.onUnexpectedError)(U)}}function te(C){if(C&&C.type==="error"){const U=new Error(`Connection error: ${C.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function ne(C,U){for(;C.length<U;)C+=" ";return C}function se(C,U){return`[remote-connection][${ne(a(C),13)}][${U.substr(0,5)}\u2026]`}function J(C,U,z){return`${se(C,U)}[${z?"reconnect":"initial"}]`}function G(C,U){return`${J(U,C.reconnectionToken,!!C.reconnectionProtocol)}[${C.host}:${C.port}]`}function M(C){return`${Date.now()-C} ms`}}),define(oe[220],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,T.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[109],ae([0,1,5,168]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,T.createDecorator)("IRemoteTunnelService");var l;(function(A){A.disconnected=_=>({type:"disconnected",onTokenFailed:_}),A.connected=_=>({type:"connected",info:_}),A.connecting=_=>({type:"connecting",progress:_}),A.uninitialized={type:"uninitialized"}})(l||(e.TunnelStates=l={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,O.localize)(0,null)}),define(oe[58],ae([0,1,16,9,2,170,45,5,10,39]),function(ie,e,T,O,l,A,_,k,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");class D{constructor(L){this.original=L}toJSON(){if(!this.headers){const L=Object.create(null);for(const n in this.original)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?L[n]="*****":L[n]=this.original[n];this.headers=L}return this.headers}}class w extends l.Disposable{constructor(L,n){super(),this.counter=0,this.logger=n.createLogger(L?"remotenetwork":"network",{name:L?(0,A.localize)(0,null):(0,A.localize)(1,null),when:P.CONTEXT_LOG_LEVEL.isEqualTo((0,P.LogLevelToString)(P.LogLevel.Trace)).serialize()})}async logAndRequest(L,n,s){const t=`${L} #${++this.counter}: ${n.url}`;this.logger.trace(`${t} - begin`,n.type,new D(n.headers??{}));try{const i=await s();return this.logger.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${t} - error`,n.type,(0,O.getErrorMessage)(i)),i}}}e.AbstractRequestService=w;function m(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=m;function f(y){return y.res.statusCode===204}async function p(y){return f(y)?null:(await(0,T.streamToBuffer)(y.stream)).toString()}e.asText=p;async function b(y){if(!m(y))throw new Error("Server returned "+y.res.statusCode);return p(y)}e.asTextOrError=b;async function a(y){if(!m(y))throw new Error("Server returned "+y.res.statusCode);if(f(y))return null;const n=(await(0,T.streamToBuffer)(y.stream)).toString();try{return JSON.parse(n)}catch(s){throw s.message+=`:
`+n,s}}e.asJson=a;function h(y){g(y)}e.updateProxyConfigurationsScope=h;let u;function g(y){const L=S.Registry.as(_.Extensions.Configuration),n=u;u={id:"http",order:15,title:(0,A.localize)(2,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},L.updateConfigurations({add:[u],remove:n?[n]:[]})}g(1)}),define(oe[221],ae([0,1,26,22,13,58]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let _=e.DownloadService=class{constructor(P,S){this.requestService=P,this.fileService=S}async download(P,S,D=T.CancellationToken.None){if(P.scheme===O.Schemas.file||P.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(P,S);return}const w={type:"GET",url:P.toString(!0)},m=await this.requestService.request(w,D);if(m.res.statusCode===200)await this.fileService.writeFile(S,m.stream);else{const f=await(0,A.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${f}`)}}};e.DownloadService=_=Se([Y(0,A.IRequestService),Y(1,l.IFileService)],_)}),define(oe[222],ae([0,1,16,26]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class l{constructor(k){this.service=k}listen(k,P){throw new Error("Invalid listen")}call(k,P,S,D=O.CancellationToken.None){switch(P){case"request":return this.service.request(S[0],D).then(async({res:w,stream:m})=>{const f=await(0,T.streamToBuffer)(m);return[{statusCode:w.statusCode,headers:w.headers},f]});case"resolveProxy":return this.service.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=l;class A{constructor(k){this.channel=k}async request(k,P){const[S,D]=await this.channel.call("request",[k],P);return{res:S,stream:(0,T.bufferToStream)(D)}}async resolveProxy(k){return this.channel.call("resolveProxy",[k])}}e.RequestChannelClient=A}),define(oe[223],ae([0,1,61,22,98]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends l.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:O.Schemas.vscodeUserData})}}e.SharedProcessEnvironmentService=A,Se([T.memoize],A.prototype,"userRoamingDataHome",null)}),define(oe[224],ae([0,1,49,14,171,26,38,9,4,32,148,189,6,130]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let p;async function b(h,u,g,y){return g["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(y)&&!g["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(y)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=m.Promises.withAsyncBody(async(L,n)=>{const s=new A.CancellationTokenSource;let t=1e4;const i=h.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,f.clamp)(i,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),n(new Error((0,l.localize)(0,null)))},t);try{L(await a(u,s.token))}catch(o){!(0,k.isCancellationError)(o)&&!s.token.isCancellationRequested?n(new Error((0,l.localize)(1,null,(0,_.toErrorMessage)(o)))):L({})}finally{clearTimeout(r),s.dispose()}})),p)}e.getResolvedShellEnv=b;async function a(h,u){const g=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",g);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",y);const L=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(L+"({.*})"+L),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",s);const t=await(0,D.getSystemShell)(P.OS,s);return h.trace("getUnixShellEnvironment#shell",t),new Promise((i,r)=>{if(u.isCancellationRequested)return r(new k.CancellationError);const o=(0,O.basename)(t);let c,v;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${E} -p '''${L}'' + JSON.stringify(process.env) + ''${L}'''`,v=["-Login","-Command"]):(c=`'${process.execPath}' ${E} -p '"${L}" + JSON.stringify(process.env) + "${L}"'`,o==="tcsh"||o==="csh"?v=["-ic"]:v=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(v),c);const d=(0,T.spawn)(t,[...v,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});u.onCancellationRequested(()=>(d.kill(),r(new k.CancellationError))),d.on("error",N=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,_.toErrorMessage)(N)),r(N)});const I=[];d.stdout.on("data",N=>I.push(N));const R=[];d.stderr.on("data",N=>R.push(N)),d.on("close",(N,F)=>{const W=Buffer.concat(I).toString("utf8");h.trace("getUnixShellEnvironment#raw",W);const q=Buffer.concat(R).toString("utf8");if(q.trim()&&h.trace("getUnixShellEnvironment#stderr",q),N||F)return r(new Error((0,l.localize)(2,null,N,F)));const B=n.exec(W),Q=B?B[1]:"{}";try{const Z=JSON.parse(Q);g?Z.ELECTRON_RUN_AS_NODE=g:delete Z.ELECTRON_RUN_AS_NODE,y?Z.ELECTRON_NO_ATTACH_CONSOLE=y:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.VSCODE_RESOLVING_ENVIRONMENT,delete Z.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",Z),i(Z)}catch(Z){h.error("getUnixShellEnvironment#errorCaught",(0,_.toErrorMessage)(Z)),r(Z)}})})}}),define(oe[110],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,T.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[225],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class T{constructor(){this.validators=new Map}vsda(){return new Promise((l,A)=>ie(["vsda"],l,A))}async createNewMessage(l){try{const A=await this.vsda(),_=new A.validator;if(_){const k=String(T._nextId++);return this.validators.set(k,_),{id:k,data:_.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,A){if(!l.id)return!0;const _=this.validators.get(l.id);if(!_)return!1;this.validators.delete(l.id);try{return _.validate(A)==="ok"}catch{return!1}}async sign(l){try{const A=await this.vsda(),_=new A.signer;if(_)return _.sign(l)}catch{}return l}}e.SignService=T,T._nextId=1}),define(oe[77],ae([0,1,3,2]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class l extends O.Disposable{constructor(w,m,f){super(),this.channel=w,this.profile=m,this.workspace=f}async getItems(){const w={profile:this.profile,workspace:this.workspace},m=await this.channel.call("getItems",w);return new Map(m)}updateItems(w){const m={profile:this.profile,workspace:this.workspace};return w.insert&&(m.insert=Array.from(w.insert.entries())),w.delete&&(m.delete=Array.from(w.delete.values())),this.channel.call("updateItems",m)}}class A extends l{constructor(w,m){super(w,m,void 0),this._onDidChangeItemsExternal=this._register(new T.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(w=>this.onDidChangeStorage(w)))}onDidChangeStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}}class _ extends A{constructor(w){super(w,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=_;class k extends A{constructor(w,m){super(w,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=k;class P extends l{constructor(w,m){super(w,void 0,m),this.onDidChangeItemsExternal=T.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P;class S{constructor(w){this.channel=w}isUsed(w){const m={payload:w,profile:void 0,workspace:void 0};return this.channel.call("isUsed",m)}}e.StorageClient=S}),define(oe[111],ae([0,1,4,36,32]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(P){if(T.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function _(P,S,D,w,m,f,p,b){const a=Object.create(null);a["common.machineId"]=f,a.sessionID=(0,l.generateUuid)()+Date.now(),a.commitHash=w,a.version=m,a["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,T.PlatformToString)(T.platform),a["common.nodePlatform"]=O.platform,a["common.nodeArch"]=D,a["common.product"]=b||"desktop",p&&(a["common.msftInternal"]=p);let h=0;const u=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),T.isLinuxSnap&&(a["common.snap"]="true");const g=A(S);return g&&(a["common.platformDetail"]=g),a}e.resolveCommonProperties=_;function k(P){const S=O.env.USERDNSDOMAIN;if(!S)return!1;const D=S.toLowerCase();return P.some(w=>D===w)}e.verifyMicrosoftInternalDomain=k}),define(oe[20],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var l;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(l||(e.TelemetryConfiguration=l={}))}),define(oe[226],ae([0,1,34,6,35,22,14,4,12,145,28,147,99,13,25,20]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function h(n,s){const t=`${n}::${s.join(":")}`,i=a.get(t);if(i)return i;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,c=new Map,v=2e4;function E(I,R,N,F){const W=R.substring(I.length+1);return O.Promises.withAsyncBody(async q=>{let B;try{B=await D.Promises.readdir(R,{withFileTypes:!0})}catch{q();return}if(F.count>=v){F.count+=B.length,F.maxReached=!0,q();return}let Q=B.length;if(Q===0){q();return}let Z=B;F.count+B.length>v&&(F.maxReached=!0,Q=v-F.count,Z=B.slice(0,Q)),F.count+=B.length;for(const K of Z)if(K.isDirectory()){if(N.includes(K.name)||await E(I,(0,_.join)(R,K.name),N,F),--Q===0){q();return}}else{const x=K.name.lastIndexOf(".");if(x>=0){const $=K.name.substring(x+1);$&&o.set($,(o.get($)??0)+1)}for(const $ of r)$.relativePathPattern?.test(W)!==!1&&$.filePattern.test(K.name)&&c.set($.tag,(c.get($.tag)??0)+1);if(--Q===0){q();return}}})}const d=O.Promises.withAsyncBody(async I=>{const R={count:0,maxReached:!1};await E(n,n,s,R);const N=await y(n);I({configFiles:u(c),fileTypes:u(o),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:N})});return a.set(t,d),d}e.collectWorkspaceStats=h;function u(n){return Array.from(n.entries(),([s,t])=>({name:s,count:t})).sort((s,t)=>t.count-s.count)}function g(){const n={os:`${T.type()} ${T.arch()} ${T.release()}`,memory:`${(T.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(T.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},s=T.cpus();return s&&s.length>0&&(n.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),n}e.getMachineInfo=g;async function y(n){try{const s=new Map,t=(0,_.join)(n,".vscode","launch.json"),i=await D.Promises.readFile(t),r=[],o=(0,l.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${t}`),[];if((0,l.getNodeType)(o)==="object"&&o.configurations)for(const c of o.configurations){const v=c.type;v&&(s.has(v)?s.set(v,s.get(v)+1):s.set(v,1))}return u(s)}catch{return[]}}e.collectLaunchConfigs=y;let L=e.DiagnosticsService=class{constructor(s,t){this.telemetryService=s,this.productService=t}formatMachineInfo(s){const t=[];return t.push(`OS Version:       ${s.os}`),t.push(`CPUs:             ${s.cpus}`),t.push(`Memory (System):  ${s.memory}`),t.push(`VM:               ${s.vmHint}`),t.join(`
`)}formatEnvironment(s){const t=[];t.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),t.push(`OS Version:       ${T.type()} ${T.arch()} ${T.release()}`);const i=T.cpus();return i&&i.length>0&&t.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),t.push(`Memory (System):  ${(T.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(T.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||t.push(`Load (avg):       ${T.loadavg().map(r=>Math.round(r)).join(", ")}`),t.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${s.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(s,t){return Promise.all([(0,w.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async i=>{let[r,o]=i,c=this.formatProcessList(s,r);return t.forEach(v=>{if((0,m.isRemoteDiagnosticError)(v))c+=`
${v.errorMessage}`,o+=`
${v.errorMessage}`;else if(c+=`

Remote: ${v.hostName}`,v.processes&&(c+=`
${this.formatProcessList(s,v.processes)}`),v.workspaceMetadata){o+=`
|  Remote: ${v.hostName}`;for(const E of Object.keys(v.workspaceMetadata)){const d=v.workspaceMetadata[E];let I=`${d.fileCount} files`;d.maxFilesReached&&(I=`more than ${I}`),o+=`|    Folder (${E}): ${I}`,o+=this.formatWorkspaceStats(d)}}}),{processInfo:c,workspaceInfo:o}})}async getSystemInfo(s,t){const{memory:i,vmHint:r,os:o,cpus:c}=g(),v={os:o,memory:i,cpus:c,vmHint:r,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:t};return k.isWindows||(v.load=`${T.loadavg().map(E=>Math.round(E)).join(", ")}`),k.isLinux&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(s,t){const i=[];return(0,w.listProcesses)(s.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(s)),i.push(""),i.push(this.formatProcessList(s,r)),s.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(s))),t.forEach(o=>{if((0,m.isRemoteDiagnosticError)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.formatMachineInfo(o.machineInfo)),o.processes&&i.push(this.formatProcessList(s,o.processes)),o.workspaceMetadata)for(const c of Object.keys(o.workspaceMetadata)){const v=o.workspaceMetadata[c];let E=`${v.fileCount} files`;v.maxFilesReached&&(E=`more than ${E}`),i.push(`Folder (${c}): ${E}`),i.push(this.formatWorkspaceStats(v))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(s){const t=[];let r=0;const o=(d,I)=>{const R=` ${d}(${I})`;r+R.length>60?(t.push(c),c="|                 ",r=c.length):r+=R.length,c+=R};let c="|      File types:";const v=10,E=s.fileTypes.length>v?v:s.fileTypes.length;for(let d=0;d<E;d++){const I=s.fileTypes[d];o(I.name,I.count)}if(t.push(c),s.configFiles.length>=0&&(c="|      Conf files:",r=0,s.configFiles.forEach(d=>{o(d.name,d.count)}),t.push(c)),s.launchConfigFiles.length>0){let d="|      Launch Configs:";s.launchConfigFiles.forEach(I=>{const R=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;d+=R}),t.push(d)}return t.join(`
`)}expandGPUFeatures(s){const t=Math.max(...Object.keys(s).map(i=>i.length));return Object.keys(s).map(i=>`${i}:  ${" ".repeat(t-i.length)}  ${s[i]}`).join(`
                  `)}formatWorkspaceMetadata(s){const t=[],i=[];return s.windows.forEach(r=>{r.folderURIs.length===0||r.remoteAuthority||(t.push(`|  Window (${r.title})`),r.folderURIs.forEach(o=>{const c=P.URI.revive(o);if(c.scheme===A.Schemas.file){const v=c.fsPath;i.push(h(v,["node_modules",".git"]).then(E=>{let d=`${E.fileCount} files`;E.maxFilesReached&&(d=`more than ${d}`),t.push(`|    Folder (${(0,_.basename)(v)}): ${d}`),t.push(this.formatWorkspaceStats(E))}).catch(E=>{t.push(`|      Error: Unable to collect workspace stats for folder ${v} (${E.toString()})`)}))}else t.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>t.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(s,t){const i=new Map;s.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),s.pidToNames.forEach(({pid:o,name:c})=>i.set(o,c));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),t&&this.formatProcessItem(s.mainPID,i,r,t,0),r.join(`
`)}formatProcessItem(s,t,i,r,o){const c=o===0;let v;c?v=r.pid===s?`${this.productService.applicationName} main`:"remote agent":t.has(r.pid)?v=t.get(r.pid):v=`${"  ".repeat(o)} ${r.name}`;const E=process.platform==="win32"?r.mem:T.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(E/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(r.children)&&r.children.forEach(d=>this.formatProcessItem(s,t,i,d,o+1))}async getWorkspaceFileExtensions(s){const t=new Set;for(const{uri:i}of s.folders){const r=P.URI.revive(i);if(r.scheme!==A.Schemas.file)continue;const o=r.fsPath;try{(await h(o,["node_modules",".git"])).fileTypes.forEach(v=>t.add(v.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(s){for(const{uri:t}of s.folders){const i=P.URI.revive(t);if(i.scheme!==A.Schemas.file)continue;const r=i.fsPath;try{const o=await h(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),o.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:c.name,count:c.count})}),o.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:c.name,count:c.count})}),o.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};e.DiagnosticsService=L=Se([Y(0,b.ITelemetryService),Y(1,p.IProductService)],L)}),define(oe[112],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class T{constructor(A){this.appenders=A}listen(A,_){throw new Error(`Event not found: ${_}`)}call(A,_,{eventName:k,data:P}){return this.appenders.forEach(S=>S.log(k,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=T;class O{constructor(A){this.channel=A}log(A,_){return this.channel.call("log",{eventName:A,data:_}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=O}),define(oe[46],ae([0,1,31,11,3,17,76,111,20]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class S{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=S;class D{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=D,e.NullTelemetryService=new D;class w{async publicLog(r,o,c){}async publicLogError(r,o,c){}}e.NullEndpointTelemetryService=w,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(i,r){return l.Event.debounce(r.onDidChangeConfiguration,(c,v)=>{const E=c?new Set([...c.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:E}},1e3,!0)(c=>{c.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=m;function f(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=f;function p(i,r){return!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=p;function b(i){const r=i.getValue(P.TELEMETRY_SETTING_ID),o=i.getValue(P.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function a(i){const r={},o={},c={};g(i,c);for(let v in c){v=v.length>150?v.substr(v.length-149):v;const E=c[v];typeof E=="number"?o[v]=E:typeof E=="boolean"?o[v]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${E.length}`),r[v]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(r[v]=E)}return{properties:r,measurements:o}}e.validateTelemetryData=a;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const r=(0,_.getRemoteName)(i);return h.has(r)?r:"other"}e.cleanRemoteAuthority=u;function g(i,r,o=0,c){if(i)for(const v of Object.getOwnPropertyNames(i)){const E=i[v],d=c?c+v:v;Array.isArray(E)?r[d]=(0,T.safeStringify)(E):E instanceof Date?r[d]=E.toISOString():(0,O.isObject)(E)?o<2?g(E,r,o+1,d+"."):r[d]=(0,T.safeStringify)(E):r[d]=E}}function y(i,r){const o=i.msftInternalDomains||[],c=r.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(o)||c}e.isInternalTelemetry=y;function L(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=L;function n(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const c=[];for(const I of r)for(;;){const R=I.exec(i);if(!R)break;c.push([R.index,I.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(o="";;){const I=E.exec(i);if(!I)break;const R=c.some(([N,F])=>I.index<F&&N<E.lastIndex);!v.test(I[0])&&!R&&(o+=i.substring(d,I.index)+"<REDACTED: user-file-path>",d=E.lastIndex)}return d<i.length&&(o+=i.substr(d)),o}function s(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of r)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function t(i,r){return(0,T.cloneAndChange)(i,o=>{if(o instanceof S||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let c=o.replaceAll("%20"," ");c=n(c,r);for(const v of r)c=c.replace(v,"");return c=s(c),c}})}e.cleanData=t}),define(oe[33],ae([0,1,27,29,50,4,12,9,36,46]),function(ie,e,T,O,l,A,_,k,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function D(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,T.compareIgnoreCase)(t.id,i.id)===0}e.areSameExtensions=D;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(i){const r=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new m(i.identifier,r,o)}static parse(i){const r=w.exec(i);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof m?D(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=m;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(t){const i=f.exec(t);return i&&i[1]?[a(i[1]),i[2]]:[a(t),void 0]}e.getIdAndVersion=p;function b(t,i){return`${t}.${i}`}e.getExtensionId=b;function a(t){return t.toLowerCase()}e.adoptToGalleryExtensionId=a;function h(t,i){return a(b(t??l.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=h;function u(t,i){const r=[],o=c=>{for(const v of r)if(v.some(E=>D(i(E),i(c))))return v;return null};for(const c of t){const v=o(c);v?v.push(c):r.push([c])}return r}e.groupByExtension=u;function g(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function y(t){return{id:new S.TelemetryTrustedValue(t.identifier.id),name:new S.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function L(t,i){const r=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(v=>!D(v.identifier,{id:c}))){const v=t.filter(E=>D(E.identifier,{id:c}));v.length===1&&(r.push(v[0]),o.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=L;async function n(t,i){if(!A.isLinux)return!1;let r;try{r=(await t.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await t.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(t,i){const r=await n(t,i),o=(0,O.getTargetPlatform)(r?"alpine":A.platform,P.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(oe[227],ae([0,1,21,2,23,12,13,25,6,3,14,4,36,33]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let p=e.ExtensionTipsService=class extends O.Disposable{constructor(g,y){super(),this.fileService=g,this.productService=y,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,L])=>this.allConfigBasedTips.set(L.configPath,L))}getConfigBasedTips(g){return this.getValidConfigBasedTips(g)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(g){const y=[];for(const[L,n]of this.allConfigBasedTips)if(!(n.configScheme&&n.configScheme!==g.scheme))try{const s=(await this.fileService.readFile((0,l.joinPath)(g,L))).value.toString();for(const[t,i]of Object.entries(n.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(s))&&y.push({extensionId:t,extensionName:i.name,configName:n.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return y}};e.ExtensionTipsService=p=Se([Y(0,_.IFileService),Y(1,k.IProductService)],p);const b="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";class h extends p{constructor(g,y,L,n,s,t,i,r){super(i,r),this.userHome=g,this.windowEvents=y,this.telemetryService=L,this.extensionManagementService=n,this.storageService=s,this.extensionRecommendationNotificationService=t,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,r.exeBasedExtensionTips&&Object.entries(r.exeBasedExtensionTips).forEach(([o,c])=>{const v=[],E=[],d=[];Object.entries(c.recommendations).forEach(([I,R])=>{R.important?c.important?v.push({extensionId:I,extensionName:R.name,isExtensionPack:!!R.isExtensionPack}):E.push({extensionId:I,extensionName:R.name,isExtensionPack:!!R.isExtensionPack}):d.push({extensionId:I,extensionName:R.name,isExtensionPack:!!R.isExtensionPack})}),v.length&&this.highImportanceExecutableTips.set(o,{exeFriendlyName:c.friendlyName,windowsPath:c.windowsPath,recommendations:v}),E.length&&this.mediumImportanceExecutableTips.set(o,{exeFriendlyName:c.friendlyName,windowsPath:c.windowsPath,recommendations:E}),d.length&&this.allOtherExecutableTips.set(o,{exeFriendlyName:c.friendlyName,windowsPath:c.windowsPath,recommendations:d})}),(0,P.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const g=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),y=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...g,...y]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const g=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),y=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),L=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(g,L),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(y,L)}groupImportantTipsByExe(g,y){const L=new Map;g.forEach(r=>L.set(r.extensionId.toLowerCase(),r));const{installed:n,uninstalled:s}=this.groupByInstalled([...L.keys()],y);for(const r of n){const o=L.get(r);o&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:r,exeName:o.exeName})}for(const r of s){const o=L.get(r);o&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:r,exeName:o.exeName})}const t=this.getPromptedExecutableTips(),i=new Map;for(const r of s){const o=L.get(r);if(o&&(!t[o.exeName]||!t[o.exeName].includes(o.extensionId))){let c=i.get(o.exeName);c||(c=[],i.set(o.exeName,c)),c.push(o)}}return i}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[g,y]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(y).then(L=>{switch(L){case"reacted":this.addToRecommendedExecutables(y[0].exeName,y);break;case"ignored":this.highImportanceTipsByExe.delete(g);break;case"incompatibleWindow":{const n=S.Event.once(S.Event.latch(S.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(n(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const n=this._register((0,P.disposableTimeout)(()=>{n.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const g=this.getLastPromptedMediumExeTime(),y=Date.now()-g,L=7*24*60*60*1e3;if(y<L){const t=this._register((0,P.disposableTimeout)(()=>{t.dispose(),this.promptMediumImportanceExeBasedTip()},L-y));return}const[n,s]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(s).then(t=>{switch(t){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(n),this.addToRecommendedExecutables(s[0].exeName,s);const i=this._register((0,P.disposableTimeout)(()=>{i.dispose(),this.promptMediumImportanceExeBasedTip()},L));break}case"ignored":this.mediumImportanceTipsByExe.delete(n),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const i=S.Event.once(S.Event.latch(S.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(i(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const i=this._register((0,P.disposableTimeout)(()=>{i.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(g){const y=await this.extensionManagementService.getInstalled(1),L=g.filter(n=>!n.whenNotInstalled||n.whenNotInstalled.every(s=>y.every(t=>!(0,f.areSameExtensions)(t.identifier,{id:s})))).map(({extensionId:n})=>n.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:L,source:3,name:g[0].exeFriendlyName,searchValue:`@exe:"${g[0].exeName}"`})}getLastPromptedMediumExeTime(){let g=this.storageService.getNumber(a,-1);return g||(g=Date.now(),this.updateLastPromptedMediumExeTime(g)),g}updateLastPromptedMediumExeTime(g){this.storageService.store(a,g,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(b,-1,"{}"))}addToRecommendedExecutables(g,y){const L=this.getPromptedExecutableTips();L[g]=y.map(({extensionId:n})=>n.toLowerCase()),this.storageService.store(b,JSON.stringify(L),-1,0)}groupByInstalled(g,y){const L=[],n=[],s=y.reduce((t,i)=>(t.add(i.identifier.id.toLowerCase()),t),new Set);return g.forEach(t=>{s.has(t.toLowerCase())?L.push(t):n.push(t)}),{installed:L,uninstalled:n}}async getValidExecutableBasedExtensionTips(g){const y=[],L=new Map;for(const n of g.keys()){const s=g.get(n);if(!s||!(0,T.isNonEmptyArray)(s.recommendations))continue;const t=[];w.isWindows?s.windowsPath&&t.push(s.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(t.push((0,D.join)("/usr/local/bin",n)),t.push((0,D.join)("/usr/bin",n)),t.push((0,D.join)(this.userHome.fsPath,n)));for(const i of t){let r=L.get(i);if(r===void 0&&(r=await this.fileService.exists(A.URI.file(i)),L.set(i,r)),r)for(const{extensionId:o,extensionName:c,isExtensionPack:v,whenNotInstalled:E}of s.recommendations)y.push({extensionId:o,extensionName:c,isExtensionPack:v,exeName:n,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:E})}}return y}}e.AbstractNativeExtensionTipsService=h}),define(oe[228],ae([0,1,26,33]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function l(A,_,k,P,S){try{const D=await A.getExtensionsControlManifest();if(!D.deprecated)return;const w=await A.getInstalled(1);for(const[m,f]of Object.entries(D.deprecated)){if(!f?.extension)continue;const{id:p,autoMigrate:b,preRelease:a}=f.extension;if(!b)continue;const h=w.find(g=>(0,O.areSameExtensions)(g.identifier,{id:m}));if(!h)continue;const u=(await _.getExtensions([{id:p,preRelease:a}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},T.CancellationToken.None))[0];if(!u){S.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${p}' extension is not found`);continue}try{S.info(`Migrating '${h.identifier.id}' extension to '${p}' extension...`);const g=!P.getDisabledExtensions().some(L=>(0,O.areSameExtensions)(L,h.identifier));await A.uninstall(h),S.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let y=w.find(L=>(0,O.areSameExtensions)(L.identifier,{id:p}));(!y||!y.isPreReleaseVersion&&g)&&(y=await A.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${y.identifier.id}'`),g||(await P.disableExtension(y.identifier),S.info(`Disabled the pre-release extension '${y.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),b.storage&&(k.addToMigrationList((0,O.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,O.getExtensionId)(y.manifest.publisher,y.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${h.identifier.id}' extension to '${p}' extension.`)}catch(g){S.error(g)}}}catch(D){S.error(D)}}e.migrateUnsupportedExtensions=l}),define(oe[229],ae([0,1,3,2,37,33,50]),function(ie,e,T,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class k extends O.Disposable{constructor(S,D,w,m,f,p,b){super(),this.extensionManagementService=S,this.extensionsScannerService=D,this.userDataProfilesService=w,this.extensionsProfileScannerService=m,this.uriIdentityService=f,this.fileService=p,this.logService=b,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,a=>b.error(a))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(S=>this.onDidChangeProfiles(S.added,S.removed))),this._register(this.extensionsProfileScannerService.onAddExtensions(S=>this.onAddExtensions(S))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(S=>this.onDidAddExtensions(S))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(S=>this.onRemoveExtensions(S))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(S=>this.onDidRemoveExtensions(S))),this._register(this.fileService.onDidFilesChange(S=>this.onDidFilesChange(S)))}async onDidChangeProfiles(S,D){try{await Promise.all(D.map(w=>(this.extensionsProfileWatchDisposables.deleteAndDispose(w.id),this.removeExtensionsFromProfile(w.extensionsResource)))),S.length&&await Promise.all(S.map(w=>(this.extensionsProfileWatchDisposables.set(w.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(w.extensionsResource)),this.fileService.watch(w.extensionsResource))),this.populateExtensionsFromProfile(w.extensionsResource))))}catch(w){throw this.logService.error(w),w}}async onAddExtensions(S){for(const D of S.extensions)this.addExtensionWithKey(this.getKey(D.identifier,D.version),S.profileLocation)}async onDidAddExtensions(S){for(const D of S.extensions){const w=this.getKey(D.identifier,D.version);S.error?this.removeExtensionWithKey(w,S.profileLocation):this.addExtensionWithKey(w,S.profileLocation)}}async onRemoveExtensions(S){for(const D of S.extensions)this.removeExtensionWithKey(this.getKey(D.identifier,D.version),S.profileLocation)}async onDidRemoveExtensions(S){const D=[],w=[];for(const m of S.extensions){const f=this.getKey(m.identifier,m.version);S.error?this.addExtensionWithKey(f,S.profileLocation):(this.removeExtensionWithKey(f,S.profileLocation),this.allExtensions.has(f)||(this.logService.debug("Extension is removed from all profiles",m.identifier.id,m.version),w.push(this.extensionManagementService.scanInstalledExtensionAtLocation(m.location).then(p=>{p?D.push(p):this.logService.info("Extension not found at the location",m.location.toString())},p=>this.logService.error(p)))))}try{await Promise.all(w),D.length&&await this.uninstallExtensionsNotInProfiles(D)}catch(m){this.logService.error(m)}}onDidFilesChange(S){for(const D of this.userDataProfilesService.profiles)S.contains(D.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(D.extensionsResource)}async onDidExtensionsProfileChange(S){const D=[],w=[],m=await this.extensionsProfileScannerService.scanProfileExtensions(S),f=new Set,p=new Set;for(const[b,a]of this.allExtensions)a.has(S)&&p.add(b);for(const b of m){const a=this.getKey(b.identifier,b.version);f.add(a),p.has(a)||(D.push(b.identifier),this.addExtensionWithKey(a,S))}for(const b of p)if(!f.has(b)){const a=this.fromKey(b);a&&(w.push(a.identifier),this.removeExtensionWithKey(b,S))}(D.length||w.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:D.length?{extensions:D,profileLocation:S}:void 0,removed:w.length?{extensions:w,profileLocation:S}:void 0})}async populateExtensionsFromProfile(S){const D=await this.extensionsProfileScannerService.scanProfileExtensions(S);for(const w of D)this.addExtensionWithKey(this.getKey(w.identifier,w.version),S)}async removeExtensionsFromProfile(S){for(const D of[...this.allExtensions.keys()])this.removeExtensionWithKey(D,S);await this.uninstallExtensionsNotInProfiles()}async uninstallExtensionsNotInProfiles(S){S||(S=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(w=>!this.allExtensions.has(this.getKey(w.identifier,w.manifest.version)))),S.length&&await this.extensionManagementService.markAsUninstalled(...S)}addExtensionWithKey(S,D){let w=this.allExtensions.get(S);w||this.allExtensions.set(S,w=new l.ResourceSet(m=>this.uriIdentityService.extUri.getComparisonKey(m))),w.add(D)}removeExtensionWithKey(S,D){const w=this.allExtensions.get(S);w&&w.delete(D),w?.size||this.allExtensions.delete(S)}getKey(S,D){return`${_.ExtensionIdentifier.toKey(S.id)}@${D}`}fromKey(S){const[D,w]=(0,A.getIdAndVersion)(S);return w?{identifier:{id:D},version:w}:void 0}}e.ExtensionsWatcher=k}),define(oe[230],ae([0,1,44,46]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function l(A,_,k,P,S,D,w){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${_.nameShort})`};if((0,O.supportsTelemetry)(_,k)&&(0,O.getTelemetryLevel)(P)===3){const f=await(0,T.getServiceMachineId)(k,S,D);m["X-Market-User-Id"]=f,m["VSCode-SessionId"]=w.machineId||f}return m}e.resolveMarketplaceHeaders=l}),define(oe[231],ae([0,1,71,21,6,2,22,14,28,15,29,33,10,74,12]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let b=e.NativeLanguagePackService=class extends f.LanguagePackBaseService{constructor(g,y,L,n){super(L),this.extensionManagementService=g,this.logService=n,this.cache=this._register(new a(y,n)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getBuiltInExtensionTranslationsUri(g,y){const n=(await this.cache.getLanguagePacks())[y];if(!n){this.logService.warn(`No language pack found for ${y}`);return}const s=n.translations[g];return s?p.URI.file(s):void 0}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),y=Object.keys(g).map(L=>{const n=g[L];return{...this.createQuickPickItem(L,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return y.push(this.createQuickPickItem("en","English")),y.sort((L,n)=>L.label.localeCompare(n.label)),y}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const y=await this.cache.getLanguagePacks();Object.keys(y).some(L=>y[L]&&y[L].extensions.some(n=>(0,w.areSameExtensions)(n.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),L=await this.cache.update(y);return!(0,O.equals)(Object.keys(g),Object.keys(L))}};e.NativeLanguagePackService=b=Se([Y(0,D.IExtensionManagementService),Y(1,S.INativeEnvironmentService),Y(2,D.IExtensionGalleryService),Y(3,m.ILogService)],b);let a=class extends A.Disposable{constructor(g,y){super(),this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,k.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new l.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(y=>{Object.keys(y).forEach(L=>delete y[L]),this.createLanguagePacksFromExtensions(y,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...y){for(const L of y)L&&L.manifest&&L.manifest.contributes&&L.manifest.contributes.localizations&&L.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,L);Object.keys(g).forEach(L=>this.updateHash(g[L]))}createLanguagePacksFromExtension(g,y){const L=y.identifier,n=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const s of n)if(y.location.scheme===_.Schemas.file&&h(s)){let t=g[s.languageId];t||(t={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},g[s.languageId]=t);const i=t.extensions.filter(r=>(0,w.areSameExtensions)(r.extensionIdentifier,L))[0];i?i.version=y.manifest.version:t.extensions.push({extensionIdentifier:L,version:y.manifest.version});for(const r of s.translations)t.translations[r.id]=(0,k.join)(y.location.fsPath,r.path)}}updateHash(g){if(g){const y=(0,T.createHash)("md5");for(const L of g.extensions)y.update(L.extensionIdentifier.uuid||L.extensionIdentifier.id).update(L.version);g.hash=y.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return P.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,L=>L.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(L)).then(L=>{try{return JSON.parse(L)}catch{return{}}}).then(L=>(y=g(L),L)).then(L=>{for(const s of Object.keys(L))L[s]||delete L[s];this.languagePacks=L,this.initializedCache=!0;const n=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",n),P.Promises.writeFile(this.languagePacksFilePath,n)}).then(()=>y,L=>this.logService.error(L))})}};a=Se([Y(0,S.INativeEnvironmentService),Y(1,m.ILogService)],a);function h(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const g of u.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(oe[232],ae([0,1,9,31,46]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://0.0.0.0/OneCollector/1.0",_="https://0.0.0.0/ping";async function k(S,D,w){const m=await new Promise((h,u)=>{ie(["@microsoft/1ds-core-js"],h,u)}),f=await new Promise((h,u)=>{ie(["@microsoft/1ds-post-js"],h,u)}),p=new m.AppInsightsCore,b=new f.PostChannel,a={instrumentationKey:S,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(w){a.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:w};a.extensionConfig[b.identifier]=h}return p.initialize(a,[]),p.addTelemetryInitializer(h=>{D&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),p}class P{constructor(D,w,m,f,p){this._isInternalTelemetry=D,this._eventPrefix=w,this._defaultData=m,this._xhrOverride=p,this.endPointUrl=A,this.endPointHealthUrl=_,this._defaultData||(this._defaultData={}),typeof f=="function"?this._aiCoreOrKey=f():this._aiCoreOrKey=f,this._asyncAiCore=null}_withAIClient(D){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){D(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=k(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(w=>{D(w)},w=>{(0,T.onUnexpectedError)(w),console.error(w)})}}log(D,w){if(!this._aiCoreOrKey)return;w=(0,O.mixin)(w,this._defaultData),w=(0,l.validateTelemetryData)(w);const m=this._eventPrefix+"/"+D;try{this._withAIClient(f=>{f.pluginVersionString=w?.properties.version??"Unknown",f.track({name:m,baseData:{name:m,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(D=>{this._withAIClient(w=>{w.unload(!0,()=>{this._aiCoreOrKey=void 0,D(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(oe[113],ae([0,1,2,172,15,10,25,46]),function(ie,e,T,O,l,A,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let P=e.TelemetryLogAppender=class extends T.Disposable{constructor(D,w,m,f,p=""){super(),this.prefix=p;const b=w.getLogger(k.telemetryLogId);if(b)this.logger=this._register(b);else{const h=(0,k.isLoggingOnly)(f,m)?" (Not Sent)":"",u=()=>(0,k.supportsTelemetry)(f,m)&&D.getLevel()===A.LogLevel.Trace;this.logger=this._register(w.createLogger(k.telemetryLogId,{name:(0,O.localize)(0,null,h),hidden:!u()})),this._register(D.onDidChangeLogLevel(()=>w.setVisibility(k.telemetryLogId,u()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(D,w){this.logger.trace(`${this.prefix}telemetry/${D}`,(0,k.validateTelemetryData)(w))}};e.TelemetryLogAppender=P=Se([Y(0,A.ILogService),Y(1,A.ILoggerService),Y(2,l.IEnvironmentService),Y(3,_.IProductService)],P)}),define(oe[114],ae([0,1,2,31,4,27,173,17,45,107,25,39,20,46]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=e.TelemetryService=class{constructor(h,u,g){this._configurationService=u,this._productService=g,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=h.appenders,this._commonProperties=h.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=h.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(y),"gi")),y.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(y.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(y=>{(y.affectsConfiguration(m.TELEMETRY_SETTING_ID)||y.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||y.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(h,u){this._experimentProperties[h]=u}_updateTelemetryLevel(){let h=(0,f.getTelemetryLevel)(this._configurationService);const u=this._productService.enabledTelemetryLevels;if(u){this._sendErrorTelemetry=this.sendErrorTelemetry?u.error:!1;const g=u.usage?3:u.error?2:0;h=Math.min(h,g)}this._telemetryLevel=h}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(h,u,g){this._telemetryLevel<u||(g=(0,O.mixin)(g,this._experimentProperties),g=(0,f.cleanData)(g,this._cleanupPatterns),g=(0,O.mixin)(g,this._commonProperties),this._appenders.forEach(y=>y.log(h,g)))}publicLog(h,u){this._log(h,3,u)}publicLog2(h,u){this.publicLog(h,u)}publicLogError(h,u){this._sendErrorTelemetry&&this._log(h,2,u)}publicLogError2(h,u){this.publicLogError(h,u)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=p=Se([Y(1,k.IConfigurationService),Y(2,D.IProductService)],p);function b(){const a=(0,_.localize)(0,null,S.default.nameLong),h=S.default.privacyStatementUrl?(0,_.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,_.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=l.isWeb?"":(0,_.localize)(3,null),g=(0,_.localize)(4,null),y=(0,_.localize)(5,null),L=(0,_.localize)(6,null),n=(0,_.localize)(7,null),s=`
|       | ${g} | ${y} | ${L} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,_.localize)(8,null);return`
${a} ${h} ${u}

&nbsp;

${n}
${s}

&nbsp;

${t}
`}w.Registry.as(P.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,_.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,_.localize)(10,null),(0,_.localize)(11,null),(0,_.localize)(12,null),(0,_.localize)(13,null)],markdownDescription:b(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(P.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,_.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,_.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,_.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,_.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[233],ae([0,1,287,232]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class l extends O.AbstractOneDataSystemAppender{constructor(_,k,P,S){const D={sendPOST:(w,m)=>{const f={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const p=T.request(w.urlString,f,b=>{b.on("data",function(a){m(b.statusCode??200,b.headers,a.toString())}),b.on("error",function(a){m(0,{})})});p.write(w.data),p.end()}catch{m(0,{})}}};super(_,k,P,S,D)}}e.OneDataSystemAppender=l}),define(oe[234],ae([0,1,22,66,17,15,10,25,20,112,113,114]),function(ie,e,T,O,l,A,_,k,P,S,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=e.CustomEndpointTelemetryService=class{constructor(p,b,a,h,u,g){this.configurationService=p,this.telemetryService=b,this.logService=a,this.loggerService=h,this.environmentService=u,this.productService=g,this.customTelemetryServices=new Map}getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const b=Object.create(null);b["common.vscodemachineid"]=this.telemetryService.machineId,b["common.vscodesessionid"]=this.telemetryService.sessionId;const a=[p.id,JSON.stringify(b),p.aiKey],u=new O.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:a,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),g=[new S.TelemetryAppenderClient(u),new D.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new w.TelemetryService({appenders:g,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(p.id)}publicLog(p,b,a){this.getCustomTelemetryService(p).publicLog(b,a)}publicLogError(p,b,a){this.getCustomTelemetryService(p).publicLogError(b,a)}};e.CustomEndpointTelemetryService=m=Se([Y(0,l.IConfigurationService),Y(1,P.ITelemetryService),Y(2,_.ILogService),Y(3,_.ILoggerService),Y(4,A.IEnvironmentService),Y(5,k.IProductService)],m)}),define(oe[115],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var T;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(T||(e.EnvironmentVariableMutatorType=T={}))}),define(oe[235],ae([0,1,4,115]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class l{constructor(S){this.collections=S,this.map=new Map,this.descriptionMap=new Map,S.forEach((D,w)=>{this.populateDescriptionMap(D,w);const m=D.map.entries();let f=m.next();for(;!f.done;){const p=f.value[1],b=f.value[0];let a=this.map.get(b);if(a||(a=[],this.map.set(b,a)),a.length>0&&a[0].type===O.EnvironmentVariableMutatorType.Replace){f=m.next();continue}const h={extensionIdentifier:w,value:p.value,type:p.type,scope:p.scope,variable:p.variable};h.scope||delete h.scope,a.unshift(h),f=m.next()}})}async applyToProcessEnvironment(S,D,w){let m;T.isWindows&&(m={},Object.keys(S).forEach(f=>m[f.toLowerCase()]=f));for(const[f,p]of this.getVariableMap(D)){const b=T.isWindows&&m[f.toLowerCase()]||f;for(const a of p){const h=w?await w(a.value):a.value;switch(a.type){case O.EnvironmentVariableMutatorType.Append:S[b]=(S[b]||"")+h;break;case O.EnvironmentVariableMutatorType.Prepend:S[b]=h+(S[b]||"");break;case O.EnvironmentVariableMutatorType.Replace:S[b]=h;break}}}}diff(S,D){const w=new Map,m=new Map,f=new Map;if(S.getVariableMap(D).forEach((p,b)=>{const a=this.getVariableMap(D).get(b),h=_(p,a);h&&w.set(b,h)}),this.getVariableMap(D).forEach((p,b)=>{const a=S.getVariableMap(D).get(b),h=_(p,a);h&&f.set(b,h)}),this.getVariableMap(D).forEach((p,b)=>{const a=S.getVariableMap(D).get(b),h=k(p,a);h&&m.set(b,h)}),!(w.size===0&&m.size===0&&f.size===0))return{added:w,changed:m,removed:f}}getVariableMap(S){const D=new Map;return this.map.forEach((w,m)=>{const f=w.filter(p=>A(p,S));f.length>0&&D.set(f[0].variable,f)}),D}getDescriptionMap(S){const D=new Map;return this.descriptionMap.forEach((w,m)=>{const f=w.filter(p=>A(p,S));f.length>0&&D.set(f[0].extensionIdentifier,f[0].description)}),D}populateDescriptionMap(S,D){if(!S.descriptionMap)return;const w=S.descriptionMap.entries();let m=w.next();for(;!m.done;){const f=m.value[1],p=m.value[0];let b=this.descriptionMap.get(p);b||(b=[],this.descriptionMap.set(p,b));const a={extensionIdentifier:D,scope:f.scope,description:f.description};a.scope||delete a.scope,b.push(a),m=w.next()}}}e.MergedEnvironmentVariableCollection=l;function A(P,S){return!!(!P.scope||P.scope.workspaceFolder&&S?.workspaceFolder&&P.scope.workspaceFolder.index===S.workspaceFolder.index)}function _(P,S){if(!S)return P;const D=new Set;S.forEach(m=>D.add(m.extensionIdentifier));const w=[];return P.forEach(m=>{D.has(m.extensionIdentifier)||w.push(m)}),w.length===0?void 0:w}function k(P,S){if(!S)return;const D=new Map;S.forEach(m=>D.set(m.extensionIdentifier,m));const w=[];return P.forEach(m=>{const f=D.get(m.extensionIdentifier);f&&(m.type!==f.type||m.value!==f.value||m.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&w.push(f)}),w.length===0?void 0:w}}),define(oe[236],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function T(P){return[...P.entries()]}e.serializeEnvironmentVariableCollection=T;function O(P){return P?[...P.entries()]:[]}e.serializeEnvironmentDescriptionMap=O;function l(P){return new Map(P)}e.deserializeEnvironmentVariableCollection=l;function A(P){return new Map(P??[])}e.deserializeEnvironmentDescriptionMap=A;function _(P){return Array.from(P.entries()).map(S=>[S[0],T(S[1].map),O(S[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=_;function k(P){return new Map(P.map(S=>[S[0],{map:l(S[1]),descriptionMap:A(S[2])}]))}e.deserializeEnvironmentVariableCollections=k}),define(oe[237],ae([0,1,6,26,3,2,10]),function(ie,e,T,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let k=e.RequestStore=class extends A.Disposable{constructor(S,D){super(),this._logService=D,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new l.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=S===void 0?15e3:S}createRequest(S){return new Promise((D,w)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,D),this._onCreateRequest.fire({requestId:m,...S});const f=new O.CancellationTokenSource;(0,T.timeout)(this._timeout,f.token).then(()=>w(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,A.toDisposable)(()=>f.cancel())])})}acceptReply(S,D){const w=this._pendingRequests.get(S);w?(this._pendingRequests.delete(S),(0,A.dispose)(this._pendingRequestDisposables.get(S)||[]),this._pendingRequestDisposables.delete(S),w(D)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};e.RequestStore=k=Se([Y(1,_.ILogService)],k)}),define(oe[116],ae([0,1,5,70]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new O.RawContextKey("terminalTabFocusMode",!1,!0);var l;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(l||(e.TerminalSettingPrefix=l={}));var A;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.AutomationProfileLinux="terminal.integrated.automationProfile.linux",g.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",g.AutomationProfileWindows="terminal.integrated.automationProfile.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsDefaultColor="terminal.integrated.tabs.defaultColor",g.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.TabStopWidth="terminal.integrated.tabStopWidth",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.TabFocusMode="terminal.integrated.tabFocusMode",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoEnabled="terminal.integrated.localEchoEnabled",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover",g.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",g.AutoReplies="terminal.integrated.autoReplies",g.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",g.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",g.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",g.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",g.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",g.SmoothScrolling="terminal.integrated.smoothScrolling"})(A||(e.TerminalSettingId=A={}));var _;(function(g){g.PowerShell="pwsh",g.Bash="bash",g.Fish="fish",g.Sh="sh",g.Csh="csh",g.Ksh="ksh",g.Zsh="zsh"})(_||(e.PosixShellType=_={}));var k;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(k||(e.WindowsShellType=k={}));var P;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(P||(e.TitleEventSource=P={}));var S;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Logger="logger",g.Heartbeat="heartbeat"})(S||(e.TerminalIpcChannels=S={})),e.IPtyService=(0,T.createDecorator)("ptyService");var D;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd",g.FixedDimensions="fixedDimensions",g.Title="title",g.ShellType="shellType",g.HasChildProcesses="hasChildProcesses",g.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",g.OverrideDimensions="overrideDimensions",g.FailedShellIntegrationActivation="failedShellIntegrationActivation",g.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(D||(e.ProcessPropertyType=D={}));var w;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w||(e.HeartbeatConstants=w={}));var m;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(m||(e.TerminalLocation=m={}));var f;(function(g){g.TerminalView="view",g.Editor="editor"})(f||(e.TerminalLocationString=f={}));var p;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(p||(e.LocalReconnectConstants=p={}));var b;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(b||(e.FlowControlConstants=b={}));var a;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(a||(e.ProfileSource=a={}));var h;(function(g){g[g.Off=0]="Off",g[g.FinalTerm=1]="FinalTerm",g[g.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var u;(function(g){g[g.Unknown=0]="Unknown",g[g.Shutdown=1]="Shutdown",g[g.Process=2]="Process",g[g.User=3]="User",g[g.Extension=4]="Extension"})(u||(e.TerminalExitReason=u={}))}),define(oe[238],ae([0,1,52,12,175,133]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function _(m,f){const p=[{name:null,description:(0,l.localize)(0,null)}];return p.push(...m.map(b=>({name:b.profileName,description:k(b)}))),f&&p.push(...f.map(b=>({name:b.title,description:P(b)}))),{values:p.map(b=>b.name),markdownDescriptions:p.map(b=>b.description)}}e.createProfileSchemaEnums=_;function k(m){let f=`$(${A.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:T.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?f+=`
- args: "${m.args}"`:f+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(f+=`
- overrideName: ${m.overrideName}`),m.color&&(f+=`
- color: ${m.color}`),m.env&&(f+=`
- env: ${JSON.stringify(m.env)}`),f}function P(m){return`$(${A.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:T.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function S(m,f){if(!m&&!f)return!0;if(typeof m=="string"&&typeof f=="string")return m===f;if(Array.isArray(m)&&Array.isArray(f)){if(m.length!==f.length)return!1;for(let p=0;p<m.length;p++)if(m[p]!==f[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function D(m,f){if(!m&&!f)return!0;if(!m||!f)return!1;if(A.ThemeIcon.isThemeIcon(m)&&A.ThemeIcon.isThemeIcon(f))return m.id===f.id&&m.color===f.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof f=="object"&&"light"in f&&"dark"in f){const p=m,b=f;if((O.URI.isUri(p.light)||w(p.light))&&(O.URI.isUri(p.dark)||w(p.dark))&&(O.URI.isUri(b.light)||w(b.light))&&(O.URI.isUri(b.dark)||w(b.dark)))return p.light.path===b.light.path&&p.dark.path===b.dark.path}if(O.URI.isUri(m)&&O.URI.isUri(f)||w(m)||w(f)){const p=m,b=f;return p.path===b.path&&p.scheme===b.scheme}return!1}e.terminalIconsEqual=D;function w(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=w}),define(oe[239],ae([0,1,52,174,45,39,238]),function(ie,e,T,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,T.getAllCodicons)(),y=>y.id),markdownEnumDescriptions:Array.from((0,T.getAllCodicons)(),y=>`$(${y.id})`)};const k={args:{description:(0,O.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,O.localize)(1,null),type:"boolean"},icon:{description:(0,O.localize)(2,null),...e.terminalIconSchema},color:{description:(0,O.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,O.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},P={type:"object",required:["path"],properties:{path:{description:(0,O.localize)(5,null),type:["string","array"],items:{type:"string"}},...k}},S={type:"object",required:["path"],properties:{path:{description:(0,O.localize)(6,null),type:["string"],items:{type:"string"}},...k}},D=(0,O.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,O.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,O.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),f=(0,O.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,O.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),b=(0,O.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),a={id:"terminal",order:100,title:(0,O.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:D},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:D},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,O.localize)(26,null)}},{type:"string",markdownDescription:(0,O.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,O.localize)(29,null),enum:["PowerShell","Git Bash"]},...k}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(30,null),type:"string"},id:{description:(0,O.localize)(31,null),type:"string"},title:{description:(0,O.localize)(32,null),type:"string"},...k}},{type:"null"},P]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(34,null),type:"string"},id:{description:(0,O.localize)(35,null),type:"string"},title:{description:(0,O.localize)(36,null),type:"string"},...k}},{type:"null"},P]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(38,null),type:"string"},id:{description:(0,O.localize)(39,null),type:"string"},title:{description:(0,O.localize)(40,null),type:"string"},...k}},{type:"null"},P]}},["terminal.integrated.useWslProfiles"]:{description:(0,O.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,O.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,O.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,O.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,O.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){A.Registry.as(l.Extensions.Configuration).registerConfiguration(a),g()}e.registerTerminalPlatformConfiguration=h;let u;function g(y,L){const n=A.Registry.as(l.Extensions.Configuration);let s;y&&(s=(0,_.createProfileSchemaEnums)(y?.profiles,L));const t=u;u={id:"terminal",order:100,title:(0,O.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:y?.os===3?s?.values:void 0,markdownEnumDescriptions:y?.os===3?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:y?.os===2?s?.values:void 0,markdownEnumDescriptions:y?.os===2?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:y?.os===1?s?.values:void 0,markdownEnumDescriptions:y?.os===1?s?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[u],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(oe[240],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,T.createDecorator)("localPtyService")}),define(oe[241],ae([0,1,34,22,31,14,4,36,27,11,28,115,236,235]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function p(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(T.release());let r=0;return i&&i.length===4&&(r=parseInt(i[3])),r}e.getWindowsBuildNumber=p;async function b(i,r,o,c=k.env,v=D.Promises.exists){if(A.isAbsolute(i))return await v(i)?i:void 0;if(r===void 0&&(r=k.cwd()),A.dirname(i)!=="."){const R=A.join(r,i);return await v(R)?R:void 0}const d=(0,l.getCaseInsensitive)(c,"PATH");if(o===void 0&&(0,S.isString)(d)&&(o=d.split(A.delimiter)),o===void 0||o.length===0){const R=A.join(r,i);return await v(R)?R:void 0}for(const R of o){let N;if(A.isAbsolute(R)?N=A.join(R,i):N=A.join(r,R,i),await v(N))return N;if(_.isWindows){let F=N+".com";if(await v(F)||(F=N+".exe",await v(F)))return F}}const I=A.join(r,i);return await v(I)?I:void 0}e.findExecutable=b;function a(i,r,o,c,v){const E=_.isWindows&&(!r.windowsEnableConpty||p()<18309);if(!r.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||E)return;const d=i.args,I=k.platform==="win32"?A.basename(i.executable).toLowerCase():A.basename(i.executable),R=A.dirname(O.FileAccess.asFileUri("").fsPath);let N;const F={VSCODE_INJECTION:"1"};if(_.isWindows){if(I==="pwsh.exe"||I==="powershell.exe")return!d||s(d)?N=g.get(u.WindowsPwsh):n(d)&&(N=g.get(u.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,P.format)(N[N.length-1],R,""),r.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),{newArgs:N,envMixin:F}):void 0;c.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(I){case"bash":return!d||d.length===0?N=g.get(u.Bash):t(d)&&(F.VSCODE_SHELL_LOGIN="1",h(r,F),N=g.get(u.Bash)),N?(N=[...N],N[N.length-1]=(0,P.format)(N[N.length-1],R),{newArgs:N,envMixin:F}):void 0;case"fish":{const W=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",q=A.join(R,"out/vs/workbench/contrib/xdg_data");return F.XDG_DATA_DIRS=`${W}:${q}`,h(r,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!d||s(d)?N=g.get(u.Pwsh):n(d)&&(N=g.get(u.PwshLogin)),N?(r.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),N=[...N],N[N.length-1]=(0,P.format)(N[N.length-1],R,""),{newArgs:N,envMixin:F}):void 0;case"zsh":{if(!d||d.length===0?N=g.get(u.Zsh):t(d)?(N=g.get(u.ZshLogin),h(r,F)):(d===g.get(u.Zsh)||d===g.get(u.ZshLogin))&&(N=d),!N)return;N=[...N],N[N.length-1]=(0,P.format)(N[N.length-1],R);let W;try{W=T.userInfo().username}catch{W="unknown"}const q=A.join(T.tmpdir(),`${W}-${v.applicationName}-zsh`);F.ZDOTDIR=q;const B=o?.ZDOTDIR??T.homedir()??"~";F.USER_ZDOTDIR=B;const Q=[];return Q.push({source:A.join(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(q,".zshrc")}),Q.push({source:A.join(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(q,".zprofile")}),Q.push({source:A.join(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(q,".zshenv")}),Q.push({source:A.join(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(q,".zlogin")}),{newArgs:N,envMixin:F,filesToCopy:Q}}}c.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=a;function h(i,r){if(_.isMacintosh&&i.environmentVariableCollections){const o=(0,m.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),v=new f.MergedEnvironmentVariableCollection(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),E=[];if(v)for(const d of v)d.type===w.EnvironmentVariableMutatorType.Prepend&&E.push(d.value);E.length>0&&(r.VSCODE_PATH_PREFIX=E.join(""))}}var u;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(u||(u={}));const g=new Map;g.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(u.Zsh,["-i"]),g.set(u.ZshLogin,["-il"]),g.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const y=["-login","-l"],L=["-nol","-nologo"];function n(i){return typeof i=="string"?y.includes(i.toLowerCase()):i.length===1&&y.includes(i[0].toLowerCase())||i.length===2&&(y.includes(i[0].toLowerCase())||y.includes(i[1].toLowerCase()))&&(L.includes(i[0].toLowerCase())||L.includes(i[1].toLowerCase()))}function s(i){return typeof i=="string"?L.includes(i.toLowerCase()):i.length===0||i?.length===1&&L.includes(i[0].toLowerCase())}function t(i){return i==="string"&&y.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&y.includes(i[0].toLowerCase())}}),define(oe[242],ae([0,1,49,52,14,4,11,28,94,241,190]),function(ie,e,T,O,l,A,_,k,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let w,m=!0;function f(i,r,o,c,v=process.env,E,d,I,R){return E=E||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},A.isWindows?p(o,E,v,d,c.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:c.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:c.getValue("terminal.integrated.defaultProfile.windows"),R,I):n(E,d,o,i&&typeof i=="object"?{...i}:c.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:c.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),R,I,v)}e.detectAvailableProfiles=f;async function p(i,r,o,c,v,E,d,I,R){const N=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),F=`${process.env.windir}\\${N?"Sysnative":"System32"}`;let W=!1;(0,S.getWindowsBuildNumber)()>=16299&&(W=!0),await h(I);const q=new Map;if(i){q.set("PowerShell",{source:"PowerShell",icon:O.Codicon.terminalPowershell,isAutoDetected:!0}),q.set("Windows PowerShell",{path:`${F}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.Codicon.terminalPowershell,isAutoDetected:!0}),q.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),q.set("Command Prompt",{path:`${F}\\cmd.exe`,icon:O.Codicon.terminalCmd,isAutoDetected:!0}),q.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),q.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.Codicon.terminalBash,isAutoDetected:!0});const Q=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;q.set("Cmder",{path:`${F}\\cmd.exe`,args:["/K",Q],requiresPath:process.env.CMDER_ROOT?Q:{path:Q,isUnsafe:!0},isAutoDetected:!0})}s(E,q);const B=await b(q.entries(),d,r,o,c,R);if(i||v)try{const Q=await y(`${F}\\${W?"wsl":"bash"}.exe`,d);for(const Z of Q)(!E||!(Z.profileName in E))&&B.push(Z)}catch{m&&(c?.info("WSL is not installed, so could not detect WSL profiles"),m=!1)}return B}async function b(i,r,o,c=process.env,v,E){const d=[];for(const[I,R]of i){if(R===null)continue;let N,F,W;if("source"in R){const Z=w?.get(R.source);if(!Z)continue;N=Z.paths,F=R.args||Z.args,R.icon?W=a(R.icon):Z.icon&&(W=Z.icon)}else N=Array.isArray(R.path)?R.path:[R.path],F=A.isWindows||Array.isArray(R.args)?R.args:void 0,W=a(R.icon);let q;if(E){const Z=N.map(x=>typeof x=="string"?x:x.path),K=await E(Z);q=new Array(N.length);for(let x=0;x<N.length;x++)typeof N[x]=="string"?q[x]=K[x]:q[x]={path:K[x],isUnsafe:!0}}else q=N.slice();let B;if(R.requiresPath){let Z;if((0,_.isString)(R.requiresPath)?Z=R.requiresPath:(Z=R.requiresPath.path,R.requiresPath.isUnsafe&&(B=Z)),!await o.existsFile(Z))continue}const Q=await t(I,r,q,o,c,F,R.env,R.overrideName,R.isAutoDetected,B);Q?(Q.isAutoDetected=R.isAutoDetected,Q.icon=W,Q.color=R.color,d.push(Q)):v?.debug("Terminal profile not validated",I,N)}return v?.debug("Validated terminal profiles",d),d}function a(i){return typeof i=="string"?{id:i}:i}async function h(i){if(w&&!i)return;const[r,o]=await Promise.all([u(),i||g()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:r,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:o,icon:O.Codicon.terminalPowershell})}async function u(){const i=new Set,r=await(0,S.findExecutable)("git.exe");if(r){const v=(0,D.dirname)(r);i.add((0,D.resolve)(v,"../.."))}function o(v,E){E&&v.add(E)}o(i,process.env.ProgramW6432),o(i,process.env.ProgramFiles),o(i,process.env["ProgramFiles(X86)"]),o(i,`${process.env.LocalAppData}\\Program`);const c=[];for(const v of i)c.push(`${v}\\Git\\bin\\bash.exe`,`${v}\\Git\\usr\\bin\\bash.exe`,`${v}\\usr\\bin\\bash.exe`);return c.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),c}async function g(){const i=[];for await(const r of(0,P.enumeratePowerShellInstallations)())i.push(r.exePath);return i}async function y(i,r){const o=[],c=await new Promise((d,I)=>{T.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(R,N)=>{if(R)return I("Problem occurred when getting wsl distros");d(N)})});if(!c)return[];const v=new RegExp(/[\r?\n]/),E=c.split(v).filter(d=>d.trim().length>0&&d!=="");for(const d of E){if(d===""||d.startsWith("docker-desktop"))continue;const I=`${d} (WSL)`,R={profileName:I,path:i,args:["-d",`${d}`],isDefault:I===r,icon:L(d),isAutoDetected:!1};o.push(R)}return o}function L(i){return i.includes("Ubuntu")?O.Codicon.terminalUbuntu:i.includes("Debian")?O.Codicon.terminalDebian:O.Codicon.terminalLinux}async function n(i,r,o,c,v,E,d,I){const R=new Map;if(o){const N=(await i.readFile("/etc/shells")).toString(),F=E||N.split(`
`).filter(q=>q.trim().includes("#")&&q.trim().length>0),W=new Map;for(const q of F){let B=(0,l.basename)(q),Q=W.get(B)||0;Q++,Q>1&&(B=`${B} (${Q})`),W.set(B,Q),R.set(B,{path:q,isAutoDetected:!0})}}return s(c,R),await b(R.entries(),v,i,I,r,d)}function s(i,r){if(i)for(const[o,c]of Object.entries(i))c===null||typeof c!="object"||!("path"in c)&&!("source"in c)?r.delete(o):(c.icon=c.icon||r.get(o)?.icon,r.set(o,c))}async function t(i,r,o,c,v,E,d,I,R,N){if(o.length===0)return Promise.resolve(void 0);const F=o.shift();if(F==="")return t(i,r,o,c,v,E,d,I,R);const W=typeof F!="string"&&F.isUnsafe,q=typeof F=="string"?F:F.path,B={profileName:i,path:q,args:E,env:d,overrideName:I,isAutoDetected:R,isDefault:i===r,isUnsafePath:W,requiresUnsafePath:N};if((0,l.basename)(q)===q){const Z=v.PATH?v.PATH.split(l.delimiter):void 0,K=await(0,S.findExecutable)(q,void 0,Z,void 0,c.existsFile);return K?(B.path=K,B.isFromPath=!0,B):t(i,r,o,c,v,E)}return await c.existsFile((0,l.normalize)(q))?B:t(i,r,o,c,v,E,d,I,R)}}),define(oe[243],ae([0,1,3,2,22,4,41,66,17,15,98,224,10,237,116,239,242,106]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var u;(function(L){L[L.MaxRestarts=5]="MaxRestarts"})(u||(u={}));let g=0,y=e.PtyHostService=class extends O.Disposable{constructor(n,s,t,i,r,o){super(),this._reconnectConstants=n,this.isRemote=s,this._configurationService=t,this._environmentService=i,this._logService=r,this._loggerService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new T.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new T.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new T.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new T.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new T.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new T.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new T.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new T.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new T.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new T.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new T.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new T.Emitter),this.onProcessExit=this._onProcessExit.event,(0,b.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,O.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new f.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(A.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(n){return this._logService.error("ptyHost was unable to resolve shell environment",n),{}}}_startPtyHost(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:g,VSCODE_PTY_REMOTE:this.isRemote,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},s=(0,D.parsePtyHostDebugPort)(this._environmentService.args,this._environmentService.isBuilt);s&&(s.break&&s.port?n.debugBrk=s.port:!s.break&&s.port&&(n.debug=s.port));const t=new k.Client(l.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this._onPtyHostStart.fire(),_.ProxyChannel.toService(t.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(o=>{this._onPtyHostExit.fire(o.code),this._isDisposed||(this._restartCount<=u.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))})),this._register(new h.RemoteLoggerChannelClient(this._loggerService,t.getChannel(p.TerminalIpcChannels.Logger)));const r=_.ProxyChannel.toService(t.getChannel(p.TerminalIpcChannels.PtyHost));return this._register(r.onProcessData(o=>this._onProcessData.fire(o))),this._register(r.onProcessReady(o=>this._onProcessReady.fire(o))),this._register(r.onProcessExit(o=>this._onProcessExit.fire(o))),this._register(r.onDidChangeProperty(o=>this._onDidChangeProperty.fire(o))),this._register(r.onProcessReplay(o=>this._onProcessReplay.fire(o))),this._register(r.onProcessOrphanQuestion(o=>this._onProcessOrphanQuestion.fire(o))),this._register(r.onDidRequestDetach(o=>this._onDidRequestDetach.fire(o))),[t,r]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(n,s,t,i,r,o,c,v,E,d,I){const R=setTimeout(()=>this._handleUnresponsiveCreateProcess(),p.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(n,s,t,i,r,o,c,v,E,d,I);return clearTimeout(R),g=Math.max(g,N),N}updateTitle(n,s,t){return this._proxy.updateTitle(n,s,t)}updateIcon(n,s,t,i){return this._proxy.updateIcon(n,s,t,i)}attachToProcess(n){return this._proxy.attachToProcess(n)}detachFromProcess(n,s){return this._proxy.detachFromProcess(n,s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(n){return this._proxy.start(n)}shutdown(n,s){return this._proxy.shutdown(n,s)}input(n,s){return this._proxy.input(n,s)}processBinary(n,s){return this._proxy.processBinary(n,s)}resize(n,s,t){return this._proxy.resize(n,s,t)}acknowledgeDataEvent(n,s){return this._proxy.acknowledgeDataEvent(n,s)}setUnicodeVersion(n,s){return this._proxy.setUnicodeVersion(n,s)}getInitialCwd(n){return this._proxy.getInitialCwd(n)}getCwd(n){return this._proxy.getCwd(n)}getLatency(n){return this._proxy.getLatency(n)}orphanQuestionReply(n){return this._proxy.orphanQuestionReply(n)}installAutoReply(n,s){return this._proxy.installAutoReply(n,s)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(n){return this._proxy.uninstallAutoReply(n)}getDefaultSystemShell(n){return this._proxy.getDefaultSystemShell(n)}async getProfiles(n,s,t,i=!1){const r=await this._shellEnv;return(0,a.detectAvailableProfiles)(s,t,i,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,n))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(n,s){return this._proxy.getWslPath(n,s)}getRevivedPtyNewId(n){return this._proxy.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this._proxy.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this._proxy.getTerminalLayoutInfo(n)}async requestDetachInstance(n,s){return this._proxy.requestDetachInstance(n,s)}async acceptDetachInstanceReply(n,s){return this._proxy.acceptDetachInstanceReply(n,s)}async freePortKillProcess(n){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(n)}async serializeTerminalState(n){return this._proxy.serializeTerminalState(n)}async reviveTerminalProcesses(n,s){return this._proxy.reviveTerminalProcesses(n,s)}async refreshProperty(n,s){return this._proxy.refreshProperty(n,s)}async updateProperty(n,s,t){return this._proxy.updateProperty(n,s,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(n,s){return this._resolveVariablesRequestStore.createRequest({workspaceId:n,originalText:s})}async acceptPtyHostResolvedVariables(n,s){this._resolveVariablesRequestStore.acceptReply(n,s)}};e.PtyHostService=y=Se([Y(2,P.IConfigurationService),Y(3,S.IEnvironmentService),Y(4,m.ILogService),Y(5,m.ILoggerService)],y)}),define(oe[78],ae([0,1,3,17,5,10]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var _;(function(b){b.Http="http",b.Https="https"})(_||(e.TunnelProtocol=_={}));var k;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(k||(e.TunnelPrivacyId=k={}));var P;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(P||(e.ProvidedOnAutoForward=P={}));function S(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=D,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=w;function m(b,a,h,u){if(h===1)return!1;if(h===2&&w(a)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(g?.length===4&&parseInt(g[1])>=18)return!1}return b<1024}e.isPortPrivileged=m;class f{constructor(a,h,u){this.remoteAddress=a,this.localAddress=h,this._dispose=u,this._onDispose=new T.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let p=e.AbstractTunnelService=class{constructor(a,h){this.logService=a,this.configurationService=h,this._onTunnelOpened=new T.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new T.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new T.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const a=this.configurationService.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this._tunnelProvider=a,a?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this._canElevate=a.elevation,this._privacyOptions=a.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const a=[],h=Array.from(this._tunnels.values());for(const u of h){const g=Array.from(u.values());for(const y of g){const L=await y.value;L&&a.push(L)}}return a}async dispose(){for(const a of this._tunnels.values()){for(const{value:h}of a.values())await h.then(u=>u?.dispose());a.clear()}this._tunnels.clear()}setEnvironmentTunnel(a,h,u,g,y){this.addTunnelToMap(a,h,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:h,localAddress:u,privacy:g,protocol:y,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,h){(w(a)||D(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const u=this.getTunnelFromMap(a,h);if(u)return++u.refcount,u.value}openTunnel(a,h,u,g,y,L=!1,n,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${u} on local port ${y}.`),!a)return;if(h||(h="localhost"),g||(g=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(u)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.retainOrCreateTunnel(a,h,u,g,y,L,n,s);return t?t.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,u);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(i);return(i.tunnelRemoteHost!==h||i.tunnelRemotePort!==u)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const h=this._tunnels.get(a.tunnelRemoteHost);if(h){const u=h.get(a.tunnelRemotePort);u&&(u.refcount--,await this.tryDisposeTunnel(a.tunnelRemoteHost,a.tunnelRemotePort,u))}}}}async tryDisposeTunnel(a,h,u){if(u.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${h}.`);const g=u.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(a)&&this._tunnels.get(a).delete(h),g}}async closeTunnel(a,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${h} `);const u=this._tunnels.get(a);if(u&&u.has(h)){const g=u.get(h);g.refcount=0,await this.tryDisposeTunnel(a,h,g)}}addTunnelToMap(a,h,u){this._tunnels.has(a)||this._tunnels.set(a,new Map),this._tunnels.get(a).set(h,{refcount:1,value:u})}async removeEmptyTunnelFromMap(a,h){const u=this._tunnels.get(a);u&&(await u.get(h)||u.delete(h),u.size===0&&this._tunnels.delete(a))}getTunnelFromMap(a,h){const u=[a];D(a)?(u.push(...e.LOCALHOST_ADDRESSES),u.push(...e.ALL_INTERFACES_ADDRESSES)):w(a)&&u.push(...e.ALL_INTERFACES_ADDRESSES);const g=u.map(y=>this._tunnels.get(y));for(const y of g){const L=y?.get(h);if(L)return L}}canTunnel(a){return!!S(a)}createWithProvider(a,h,u,g,y,L,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${u} on local port ${g}.`);const s=u;this._factoryInProgress.add(s);const t=g===void 0?u:g,i={elevationRequired:y?this.isPortPrivileged(t):!1},r={remoteAddress:{host:h,port:u},localAddressPort:g,privacy:L,public:L?L!==k.Private:void 0,protocol:n},o=a.forwardPort(r,i);return o?(this.addTunnelToMap(h,u,o),o.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),o}};e.AbstractTunnelService=p=Se([Y(0,A.ILogService),Y(1,O.IConfigurationService)],p)}),define(oe[244],ae([0,1,10,78,2,9,6]),function(ie,e,T,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class k extends l.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new _.DeferredPromise),this._addressPromise.p)}setAddress(D){this._address=D,this._addressPromise&&(this._addressPromise.complete(D),this._addressPromise=null)}setTunnel(D){this._register(D)}}let P=e.SharedProcessTunnelService=class Ct extends l.Disposable{constructor(D,w){super(),this._tunnelService=D,this._logService=w,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(D=>D.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(D,w,m,f,p,b,a){const h=new k,u=await Promise.resolve(this._tunnelService.openTunnel(D,h,m,f,p,b,a));if(!u)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${f} (remote).`),h.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(w))throw this._disposedTunnels.delete(w),h.dispose(),await u.dispose(),(0,A.canceled)();return h.setTunnel(u),this._tunnels.set(w,h),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${u.localAddress} (local) to ${m}:${f} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(D,w){const m=this._tunnels.get(D);m&&m.setAddress(w)}async destroyTunnel(D){const w=this._tunnels.get(D);if(w){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${D}.`),this._tunnels.delete(D),await w.dispose();return}this._disposedTunnels.add(D)}};P._lastId=0,e.SharedProcessTunnelService=P=Se([Y(0,O.ISharedTunnelsService),Y(1,T.ILogService)],P)}),define(oe[30],ae([0,1,5]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(oe[245],ae([0,1,30,193,13,23,131,3,2]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(m){this.uri=m,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let D=e.UriIdentityService=class{constructor(m){this._fileService=m,this._dispooables=new P.DisposableStore,this._limit=2**16;const f=new Map,p=b=>{let a=f.get(b.scheme);return a===void 0&&(a=m.hasProvider(b)&&!this._fileService.hasCapability(b,1024),f.set(b.scheme,a)),a};this._dispooables.add(k.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(b=>{f.delete(b.scheme)})),this.extUri=new A.ExtUri(p),this._canonicalUris=new _.SkipList((b,a)=>this.extUri.compare(b,a,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,A.normalizePath)(m));const f=this._canonicalUris.get(m);return f?f.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new S(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((p,b)=>p[1].time<b[1].time?1:p[1].time>b[1].time?-1:0);S._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let p=0;p<f;p++)this._canonicalUris.set(m[p][0],m[p][1].touch())}};e.UriIdentityService=D=Se([Y(0,l.IFileService)],D),(0,O.registerSingleton)(T.IUriIdentityService,D,1)}),define(oe[246],ae([0,1,3,2,13,43,48,16]),function(ie,e,T,O,l,A,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends O.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(D,w,m,f){super(),this.fileSystemScheme=D,this.fileSystemProvider=w,this.userDataScheme=m,this.logService=f,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=_.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(p=>this.handleFileChanges(p)))}watch(D,w){this.watchResources.set(D,D);const m=this.fileSystemProvider.watch(this.toFileSystemResource(D),w);return(0,O.toDisposable)(()=>{this.watchResources.delete(D),m.dispose()})}stat(D){return this.fileSystemProvider.stat(this.toFileSystemResource(D))}mkdir(D){return this.fileSystemProvider.mkdir(this.toFileSystemResource(D))}rename(D,w,m){return this.fileSystemProvider.rename(this.toFileSystemResource(D),this.toFileSystemResource(w),m)}readFile(D){return this.fileSystemProvider.readFile(this.toFileSystemResource(D),{atomic:!0})}readFileStream(D,w,m){const f=(0,A.newWriteableStream)(p=>k.VSBuffer.concat(p.map(b=>k.VSBuffer.wrap(b))).buffer);return(async()=>{try{const p=await this.readFile(D);f.end(p)}catch(p){f.error(p),f.end()}})(),f}readdir(D){return this.fileSystemProvider.readdir(this.toFileSystemResource(D))}writeFile(D,w,m){return this.fileSystemProvider.writeFile(this.toFileSystemResource(D),w,m)}delete(D,w){return this.fileSystemProvider.delete(this.toFileSystemResource(D),w)}copy(D,w,m){if((0,l.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(D),this.toFileSystemResource(w),m);throw new Error("copy not supported")}handleFileChanges(D){const w=[];for(const m of D){if(m.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(m.resource);this.watchResources.findSubstr(f)&&w.push({resource:f,type:m.type})}w.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(w))}toFileSystemResource(D){return D.with({scheme:this.fileSystemScheme})}toUserDataResource(D){return D.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(oe[59],ae([0,1,85]),function(ie,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function O(_,k,P,S){const D=(0,T.setProperty)(_,k,P,S)[0];return D&&(_=_.substring(0,D.offset)+D.content+_.substring(D.offset+D.length)),_}e.edit=O;function l(_,k,P){let S=P;for(;S>=0;){if(_.charAt(S)===k.charAt(k.length-1)&&k.length===1)return S+1;if(S--,k.length===2&&S>=0&&_.charAt(S)===k.charAt(0))return S+2}return 0}e.getLineStartOffset=l;function A(_,k,P){let S=P;for(;S>=0;)if(_.charAt(S)===k.charAt(k.length-1)&&k.length===1||(S++,k.length===2&&S>=0&&_.charAt(S)===k.charAt(1)))return S;return _.length-1}e.getLineEndOffset=A}),define(oe[247],ae([0,1,31,54,11]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(f,p,b,a,h,u){const g=[],y=[],L=[];if(!p){const q=f.filter(({identifier:B})=>h.every(Q=>Q.toLowerCase()!==B.id.toLowerCase()));return{local:{added:g,removed:y,updated:L},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}f=f.map(w),p=p.map(w),b=b?b.map(w):null;const n=new Map,s=q=>{q.uuid&&n.set(q.id.toLowerCase(),q.uuid)};f.forEach(({identifier:q})=>s(q)),p.forEach(({identifier:q})=>s(q)),b?.forEach(({identifier:q})=>s(q));const t=q=>{const B=q.identifier.uuid||n.get(q.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${q.identifier.id.toLowerCase()}`},i=(q,B)=>(q.set(t(B),B),q),r=f.reduce(i,new Map),o=p.reduce(i,new Map),c=p.reduce((q,B)=>i(q,(0,T.deepClone)(B)),new Map),v=b?b.reduce(i,new Map):null,E=a.reduce(i,new Map),d=h.reduce((q,B)=>{const Q=n.get(B.toLowerCase());return q.add(Q?`uuid:${Q}`:`id:${B.toLowerCase()}`)},new Set),I=u?u.reduce((q,{id:B,uuid:Q})=>(Q=Q??n.get(B.toLowerCase()),q.add(Q?`uuid:${Q}`:`id:${B.toLowerCase()}`)),new Set):null,R=_(r,o,d,!1);if(R.added.size>0||R.removed.size>0||R.updated.size>0){const q=_(v,r,d,!1),B=_(v,o,d,!0),Q=(Z,K,x,$)=>{let j,te,ne;return K.installed?(j=$.pinned,ne=$.preRelease,j&&(te=$.version)):(j=x.pinned,ne=x.preRelease,j&&(te=x.version)),j===void 0&&(j=K.pinned,j&&(te=K.version)),ne===void 0&&(ne=K.preRelease),{...$,installed:K.installed||x.installed,pinned:j,preRelease:ne,version:te??(x.version&&(!K.installed||O.gt(x.version,K.version))?x.version:K.version),state:P(K,x,v?.get(Z))}};for(const Z of B.removed.values()){const K=r.get(Z);if(!K)continue;const x=(0,l.assertIsDefined)(v?.get(Z)),$=I&&!I.has(Z)&&x.installed;K.installed&&$?y.push(K.identifier):c.set(Z,K)}for(const Z of B.added.values()){const K=(0,l.assertIsDefined)(o.get(Z)),x=r.get(Z);if(x){if(R.updated.has(Z)){const $=Q(Z,x,K,K);k(x,K,!1,!1)||L.push(m($,Z)),c.set(Z,$)}}else K.installed&&g.push(m(K,Z))}for(const Z of B.updated.values()){const K=(0,l.assertIsDefined)(o.get(Z)),x=(0,l.assertIsDefined)(v?.get(Z)),$=r.get(Z);if($)if(I&&!I.has(Z)&&x.installed&&$.installed&&!K.installed)y.push($.identifier);else{const te=Q(Z,$,K,K);L.push(m(te,Z)),c.set(Z,te)}else K.installed&&g.push(m(K,Z))}for(const Z of q.added.values())B.added.has(Z)||c.set(Z,(0,l.assertIsDefined)(r.get(Z)));for(const Z of q.updated.values()){if(B.removed.has(Z)||B.updated.has(Z))continue;const K=(0,l.assertIsDefined)(r.get(Z)),x=(0,l.assertIsDefined)(o.get(Z));c.set(Z,Q(Z,K,x,K))}for(const Z of q.removed.values())B.updated.has(Z)||B.removed.has(Z)||E.has(Z)||(0,l.assertIsDefined)(o.get(Z)).installed&&I&&(I.has(Z)||!(0,l.assertIsDefined)(v?.get(Z)).installed||c.delete(Z))}const N=[],F=_(o,c,new Set,!0),W=F.added.size>0||F.updated.size>0||F.removed.size>0;return W&&c.forEach((q,B)=>N.push(m(q,B))),{local:{added:g,removed:y,updated:L},remote:W?{added:[...F.added].map(q=>c.get(q)),updated:[...F.updated].map(q=>c.get(q)),removed:[...F.removed].map(q=>o.get(q)),all:N}:null}}e.merge=A;function _(f,p,b,a){const h=f?[...f.keys()].filter(n=>!b.has(n)):[],u=[...p.keys()].filter(n=>!b.has(n)),g=u.filter(n=>h.indexOf(n)===-1).reduce((n,s)=>(n.add(s),n),new Set),y=h.filter(n=>u.indexOf(n)===-1).reduce((n,s)=>(n.add(s),n),new Set),L=new Set;for(const n of h){if(y.has(n))continue;const s=f.get(n),t=p.get(n);(!t||!k(s,t,a,!0))&&L.add(n)}return{added:g,removed:y,updated:L}}function k(f,p,b,a){return!(f.disabled!==p.disabled||a&&f.installed!==p.installed||f.installed&&p.installed&&(f.preRelease!==p.preRelease||f.pinned!==p.pinned||p.pinned&&f.version!==p.version)||!D(f.state,p.state)||b&&f.version!==p.version)}function P(f,p,b){const a=f.state,h=p.state,u=b?.state;if(!p.version||a&&O.gt(f.version,p.version))return a;if(h&&O.gt(p.version,f.version)||!a)return h;if(!h)return a;const g=(0,T.deepClone)(a),y=u?S(u,h):{added:Object.keys(h).reduce((n,s)=>(n.add(s),n),new Set),removed:new Set,updated:new Set},L=u?S(u,a):{added:Object.keys(a).reduce((n,s)=>(n.add(s),n),new Set),removed:new Set,updated:new Set};for(const n of[...y.added.values(),...y.updated.values()])g[n]=h[n];for(const n of y.removed.values())L.updated.has(n)||delete g[n];return g}function S(f,p){const b=Object.keys(f),a=Object.keys(p),h=a.filter(y=>b.indexOf(y)===-1).reduce((y,L)=>(y.add(L),y),new Set),u=b.filter(y=>a.indexOf(y)===-1).reduce((y,L)=>(y.add(L),y),new Set),g=new Set;for(const y of b){if(u.has(y))continue;const L=f[y],n=p[y];(0,T.equals)(L,n)||g.add(y)}return{added:h,removed:u,updated:g}}function D(f={},p={}){const{added:b,removed:a,updated:h}=S(f,p);return b.size===0&&a.size===0&&h.size===0}function w(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function m(f,p){const b={identifier:{id:f.identifier.id,uuid:p.startsWith("uuid:")?p.substring(5):void 0},version:f.version,preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled&&(b.disabled=!0),f.installed&&(b.installed=!0),f.state&&(b.state=f.state),b}}),define(oe[117],ae([0,1,21,17,5]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,l.createDecorator)("IIgnoredExtensionsManagementService");let A=e.IgnoredExtensionsManagementService=class{constructor(k){this.configurationService=k}hasToNeverSyncExtension(k){return this.getConfiguredIgnoredExtensions().includes(k.toLowerCase())}hasToAlwaysSyncExtension(k){return this.getConfiguredIgnoredExtensions().includes(`-${k.toLowerCase()}`)}updateIgnoredExtensions(k,P){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return S=S.filter(D=>D!==k&&D!==`-${k}`),P&&S.push(k.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(k,P){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return S=S.filter(D=>D!==k&&D!==`-${k}`),P&&S.push(`-${k.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(k){const P=k.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),S=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),D=[],w=[];if(Array.isArray(S))for(const m of S)m.startsWith("-")?w.push(m.substring(1)):D.push(m);return(0,T.distinct)([...P,...D].filter(m=>w.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let k=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return k!==void 0||(k=this.configurationService.inspect("sync.ignoredExtensions").userValue,k!==void 0)?k:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};e.IgnoredExtensionsManagementService=A=Se([Y(0,O.IConfigurationService)],A)}),define(oe[248],ae([0,1,21,35,31,70,59]),function(ie,e,T,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(y){return(0,O.parse)(y)||[]}async function P(y,L,n,s,t){const i=k(y),r=k(L),o=n?k(n):null,c=[...i,...r,...o||[]].map(Q=>Q.key),v=await t.resolveUserBindings(c),E=D(i,r,o,v);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:y,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:L,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:y,hasChanges:!0,hasConflicts:!1};const d=m(i),I=m(r),R=o?m(o):null,N=p(d,I,v),F=R?p(R,d,v):{added:[...d.keys()].reduce((Q,Z)=>(Q.add(Z),Q),new Set),removed:new Set,updated:new Set},W=R?p(R,I,v):{added:[...I.keys()].reduce((Q,Z)=>(Q.add(Z),Q),new Set),removed:new Set,updated:new Set},q=S(N,F,W);let B=y;for(const Q of q.removed.values())q.conflicts.has(Q)||(B=u(B,Q,s));for(const Q of q.added.values()){if(q.conflicts.has(Q))continue;const Z=I.get(Q);if(Z.some(K=>K.command!==`-${Q}`&&E.conflicts.has(v[K.key]))){q.conflicts.add(Q);continue}B=h(B,Z,s)}for(const Q of q.updated.values()){if(q.conflicts.has(Q))continue;const Z=I.get(Q);if(Z.some(K=>K.command!==`-${Q}`&&E.conflicts.has(v[K.key]))){q.conflicts.add(Q);continue}B=g(B,Q,Z,s)}return{mergeContent:B,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.merge=P;function S(y,L,n){const s=new Set,t=new Set,i=new Set,r=new Set;for(const o of L.removed.values())n.updated.has(o)&&r.add(o);for(const o of n.removed.values())r.has(o)||(L.updated.has(o)?r.add(o):t.add(o));for(const o of L.added.values())r.has(o)||n.added.has(o)&&y.updated.has(o)&&r.add(o);for(const o of n.added.values())r.has(o)||(L.added.has(o)?y.updated.has(o)&&r.add(o):s.add(o));for(const o of L.updated.values())r.has(o)||n.updated.has(o)&&y.updated.has(o)&&r.add(o);for(const o of n.updated.values())r.has(o)||(L.updated.has(o)?y.updated.has(o)&&r.add(o):i.add(o));return{added:s,removed:t,updated:i,conflicts:r}}function D(y,L,n,s){const t=new Set,i=w(y,s),r=w(L,s),o=n?w(n,s):null,c=f(i,r);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const v=o?f(o,i):{added:[...i.keys()].reduce((F,W)=>(F.add(W),F),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const E=o?f(o,r):{added:[...r.keys()].reduce((F,W)=>(F.add(W),F),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:d,removed:I,updated:R,conflicts:N}=S(c,v,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:d,removed:I,updated:R,conflicts:N}}function w(y,L){const n=new Map;for(const s of y){const t=L[s.key];let i=n.get(t);i||(i=[],n.set(t,i)),i.push(s)}return n}function m(y){const L=new Map;for(const n of y){const s=n.command[0]==="-"?n.command.substring(1):n.command;let t=L.get(s);t||(t=[],L.set(s,t)),t.push(n)}return L}function f(y,L){const n=[...y.keys()],s=[...L.keys()],t=s.filter(o=>n.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),i=n.filter(o=>s.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),r=new Set;for(const o of n){if(i.has(o))continue;const c=y.get(o).map(E=>({...E,key:o})),v=L.get(o).map(E=>({...E,key:o}));(0,T.equals)(c,v,(E,d)=>a(E,d))||r.add(o)}return{added:t,removed:i,updated:r}}function p(y,L,n){const s=[...y.keys()],t=[...L.keys()],i=t.filter(c=>s.indexOf(c)===-1).reduce((c,v)=>(c.add(v),c),new Set),r=s.filter(c=>t.indexOf(c)===-1).reduce((c,v)=>(c.add(v),c),new Set),o=new Set;for(const c of s){if(r.has(c))continue;const v=y.get(c).map(d=>({...d,key:n[d.key]})),E=L.get(c).map(d=>({...d,key:n[d.key]}));b(v,E)||o.add(c)}return{added:i,removed:r,updated:o}}function b(y,L){return!(!(0,T.equals)(y.filter(({command:n})=>n[0]!=="-"),L.filter(({command:n})=>n[0]!=="-"),(n,s)=>a(n,s))||!(0,T.equals)(y.filter(({command:n})=>n[0]==="-"),L.filter(({command:n})=>n[0]==="-"),(n,s)=>a(n,s)))}function a(y,L){if(y.command!==L.command||y.key!==L.key)return!1;const n=A.ContextKeyExpr.deserialize(y.when),s=A.ContextKeyExpr.deserialize(L.when);return!(n&&!s||!n&&s||n&&s&&!n.equals(s)||!l.equals(y.args,L.args))}function h(y,L,n){for(const s of L)y=_.edit(y,[-1],s,n);return y}function u(y,L,n){const s=k(y);for(let t=s.length-1;t>=0;t--)(s[t].command===L||s[t].command===`-${L}`)&&(y=_.edit(y,[t],void 0,n));return y}function g(y,L,n,s){const t=k(y),i=t.findIndex(r=>r.command===L||r.command===`-${L}`);for(let r=t.length-1;r>=0;r--)(t[r].command===L||t[r].command===`-${L}`)&&(y=_.edit(y,[r],void 0,s));for(let r=n.length-1;r>=0;r--)y=_.edit(y,[i],n[r],s);return y}}),define(oe[249],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function T(A,_,k){const P={},S={},D=new Set;if(!_)return{local:{added:P,updated:S,removed:[...D.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const w=O(A,_);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:P,updated:S,removed:[...D.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=O(k,A),f=O(k,_),p={},b={},a=new Set,h=new Set;for(const u of m.removed.values())f.updated.has(u)?P[u]=_[u]:a.add(u);for(const u of f.removed.values())h.has(u)||(m.updated.has(u)?h.add(u):D.add(u));for(const u of m.updated.values())h.has(u)||(f.updated.has(u)?w.updated.has(u)&&h.add(u):b[u]=A[u]);for(const u of f.updated.values())h.has(u)||(m.updated.has(u)?w.updated.has(u)&&h.add(u):A[u]!==void 0&&(S[u]=_[u]));for(const u of m.added.values())h.has(u)||(f.added.has(u)?w.updated.has(u)&&h.add(u):p[u]=A[u]);for(const u of f.added.values())h.has(u)||(m.added.has(u)?w.updated.has(u)&&h.add(u):P[u]=_[u]);return{local:{added:P,removed:[...D.values()],updated:S},remote:{added:p,removed:[...a.values()],updated:b},conflicts:[...h.values()]}}e.merge=T;function O(A,_){const k=A?Object.keys(A):[],P=_?Object.keys(_):[],S=P.filter(m=>k.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),D=k.filter(m=>P.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),w=new Set;for(const m of k){if(D.has(m))continue;const f=A[m],p=_[m];f!==p&&w.add(m)}return{added:S,removed:D,updated:w}}function l(A,_){const{added:k,removed:P,updated:S}=O(A,_);return k.size===0&&P.size===0&&S.size===0}e.areSame=l}),define(oe[250],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(l,A,_,k){const P={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!A){const w=l.filter(({id:m})=>!k.includes(m));return w.length?S.added=w:S=null,{local:P,remote:S}}const D=O(l,A,k);if(D.added.length>0||D.removed.length>0||D.updated.length>0){const w=O(_,l,k),m=O(_,A,k);for(const f of m.removed){const p=l.find(b=>b.id===f);p&&P.removed.push(p)}for(const f of m.added){const p=A.find(b=>b.id===f);w.added.includes(f)?D.updated.includes(f)&&P.updated.push(p):P.added.push(p)}for(const f of m.updated)P.updated.push(A.find(p=>p.id===f));for(const f of w.added)m.added.includes(f)||S.added.push(l.find(p=>p.id===f));for(const f of w.updated)m.removed.includes(f)||m.updated.includes(f)||S.updated.push(l.find(p=>p.id===f));for(const f of w.removed){const p=A.find(b=>b.id===f);p&&S.removed.push(p)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:P,remote:S}}e.merge=T;function O(l,A,_){l=l?l.filter(({id:m})=>!_.includes(m)):[],A=A.filter(({id:m})=>!_.includes(m));const k=l.map(({id:m})=>m),P=A.map(({id:m})=>m),S=P.filter(m=>k.indexOf(m)===-1),D=k.filter(m=>P.indexOf(m)===-1),w=[];for(const{id:m,name:f,shortName:p}of l){if(D.includes(m))continue;const b=A.find(a=>a.id===m);(!b||b.name!==f||b.shortName!==p)&&w.push(m)}return{added:S,removed:D,updated:w}}}),define(oe[24],ae([0,1,21,11,181,45,29,5,108,39]),function(ie,e,T,O,l,A,_,k,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function D(){const r=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(o=>!!r[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=D;function w(){const r=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(r).filter(E=>!!r[E].ignoreSync),c=Object.keys(r).filter(E=>r[E].scope===2||r[E].scope===6),v=D();return(0,T.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...c,...v])}e.getDefaultIgnoredSettings=w,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function m(){const r="vscode://schemas/ignoredSettings",o=S.Registry.as(A.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,l.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,l.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,l.localize)(2,null),items:[{type:"string",pattern:_.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,l.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,l.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const c=S.Registry.as(P.Extensions.JSONContribution),v=()=>{const E=D(),d=w().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),I=Object.keys(A.allSettings.properties).filter(F=>d.indexOf(F)===-1),R=d.filter(F=>E.indexOf(F)===-1),N={items:{type:"string",enum:[...I,...R.map(F=>`-${F}`)]}};c.registerSchema(r,N)};return o.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=m;function f(r){return r&&(0,O.isObject)(r)&&(0,O.isString)(r.id)&&Array.isArray(r.scopes)}e.isAuthenticationProvider=f;var p;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState",r.Profiles="profiles"})(p||(e.SyncResource=p={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function b(r,...o){return r?[r,...o]:o}e.getPathSegments=b;function a(r,o,c,v){return v.joinPath(c.userDataSyncHome,...b(r,o,`lastSync${o}.json`))}e.getLastSyncResourceUri=a,e.IUserDataSyncStoreManagementService=(0,k.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,k.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,k.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function h(r){const o={};return o[e.HEADER_EXECUTION_ID]=r,o}e.createSyncHeaders=h;var u;(function(r){r.Unauthorized="Unauthorized",r.Forbidden="Forbidden",r.NotFound="NotFound",r.MethodNotFound="MethodNotFound",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.RequestProtocolNotSupported="RequestProtocolNotSupported",r.RequestPathNotEscaped="RequestPathNotEscaped",r.RequestHeadersNotObject="RequestHeadersNotObject",r.NoCollection="NoCollection",r.NoRef="NoRef",r.EmptyResponse="EmptyResponse",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyProfiles="LocalTooManyProfiles",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class g extends Error{constructor(o,c,v,E){super(o),this.code=c,this.resource=v,this.operationId=E,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class y extends g{constructor(o,c,v,E,d){super(o,v,void 0,d),this.url=c,this.serverCode=E}}e.UserDataSyncStoreError=y;class L extends g{constructor(o,c){super(o,c)}}e.UserDataAutoSyncError=L,function(r){function o(c){if(c instanceof r)return c;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(c.name);if(v&&v[1]){const E=v[2]==="unknown"?void 0:v[2],d=v[3]==="unknown"?void 0:v[3];return new r(c.message,v[1],E,d)}return new r(c.message,"Unknown")}r.toUserDataSyncError=o}(g||(e.UserDataSyncError=g={}));var n;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var s;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(s||(e.Change=s={}));var t;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(t||(e.MergeState=t={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(r){return`sync.enable.${r}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,k.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,k.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,k.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,k.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,k.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,k.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(oe[251],ae([0,1,31,24]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function l(_,k,P,S,D){if(!k)return{remote:{added:Object.keys(_),removed:[],updated:[],all:Object.keys(_).length>0?_:null},local:{added:{},removed:[],updated:{}}};const w=A(_,k);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=P?A(P,k):{added:Object.keys(k).reduce((u,g)=>(u.add(g),u),new Set),removed:new Set,updated:new Set},f=P?A(P,_):{added:Object.keys(_).reduce((u,g)=>(u.add(g),u),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},b=T.deepClone(k),a=!P;for(const u of f.added.values())u!==O.SYNC_SERVICE_URL_TYPE&&a&&m.added.has(u)||(b[u]=_[u]);for(const u of f.updated.values())b[u]=_[u];for(const u of f.removed.values())S.unregistered.includes(u)||delete b[u];for(const u of m.added.values()){const g=k[u];if(S.machine.includes(u)){D.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(P&&f.added.has(u))continue;const y=_[u];y&&y.value===g.value||u===O.SYNC_SERVICE_URL_TYPE&&a&&f.added.has(u)||(y?p.updated[u]=g:p.added[u]=g)}for(const u of m.updated.values()){const g=k[u];if(S.machine.includes(u)){D.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(u)||f.removed.has(u))continue;const y=_[u];y&&y.value===g.value||(p.updated[u]=g)}for(const u of m.removed.values()){if(S.machine.includes(u)){D.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}f.updated.has(u)||f.removed.has(u)||p.removed.push(u)}const h=A(k,b);return{local:p,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:b}}}e.merge=l;function A(_,k){const P=Object.keys(_),S=Object.keys(k),D=S.filter(f=>P.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),w=P.filter(f=>S.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),m=new Set;for(const f of P){if(w.has(f))continue;const p=_[f],b=k[f];T.equals(p,b)||m.add(f)}return{added:D,removed:w,updated:m}}}),define(oe[252],ae([0,1,21,35,85,42,31,59,24]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(c,v,E){let d=[];E?d=w(E):d=D(v);const I=[],R=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(d))for(const N of d)N.startsWith("-")?R.push(N.substring(1)):I.push(N);return(0,T.distinct)([...c,...I].filter(N=>R.indexOf(N)===-1))}e.getIgnoredSettings=S;function D(c){let v=c.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=c.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:c.getValue("settingsSync.ignoredSettings")||[]}function w(c){const v=(0,O.parse)(c);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function m(c,v){const E=(0,O.parse)(c)||{};let d="{}";for(const I of Object.keys(E)){const R=(0,l.setProperty)(d,[I],E[I],v);d=(0,l.applyEdits)(d,R)}return d}e.removeComments=m;function f(c,v,E,d){if(E.length){const I=o(v),R=(0,O.parse)(v)||{},N=(0,O.parse)(c);if(!N)return c;const F=[];for(const W of E){const q=R[W],B=N[W];q===void 0?c=k.edit(c,[W],void 0,d):B!==void 0?c=k.edit(c,[W],q,d):F.push(n(W,I))}F.sort((W,q)=>W.startOffset-q.startOffset),F.forEach(W=>c=u(W.setting.key,v,c,d))}return c}e.updateIgnoredSettings=f;function p(c,v,E,d,I,R){const N=f(c,v,d,R),F=E!==N,W=E!==v;if(!F&&!W)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!W)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(W&&!F)return{conflictsSettings:[],localContent:f(v,c,d,R),remoteContent:null,hasConflicts:!1};if(E===null&&a(c)){const U=b(c,v,d)?null:f(v,c,d,R);return{conflictsSettings:[],localContent:U,remoteContent:null,hasConflicts:!1}}let q=c,B=v;const Q=(0,O.parse)(c),Z=(0,O.parse)(v),K=E?(0,O.parse)(E):null,x=d.reduce((U,z)=>(U.add(z),U),new Set),$=h(Q,Z,x),j=h(K,Q,x),te=h(K,Z,x),ne=new Map,se=new Set,J=U=>{se.add(U);const z=I.filter(({key:H})=>H===U)[0];z?(q=k.edit(q,[U],z.value,R),B=k.edit(B,[U],z.value,R)):ne.set(U,{key:U,localValue:Q[U],remoteValue:Z[U]})};for(const U of j.removed.values())te.updated.has(U)?J(U):B=k.edit(B,[U],void 0,R);for(const U of te.removed.values())se.has(U)||(j.updated.has(U)?J(U):q=k.edit(q,[U],void 0,R));for(const U of j.updated.values())se.has(U)||(te.updated.has(U)?$.updated.has(U)&&J(U):B=k.edit(B,[U],Q[U],R));for(const U of te.updated.values())se.has(U)||(j.updated.has(U)?$.updated.has(U)&&J(U):q=k.edit(q,[U],Z[U],R));for(const U of j.added.values())se.has(U)||(te.added.has(U)?$.updated.has(U)&&J(U):B=u(U,q,B,R));for(const U of te.added.values())se.has(U)||(j.added.has(U)?$.updated.has(U)&&J(U):q=u(U,B,q,R));const G=ne.size>0||!b(q,B,d),M=G||!b(q,c,[]),C=G||!b(B,v,[]);return{localContent:M?q:null,remoteContent:C?B:null,conflictsSettings:[...ne.values()],hasConflicts:G}}e.merge=p;function b(c,v,E){if(c===v)return!0;const d=(0,O.parse)(c),I=(0,O.parse)(v),R=E.reduce((W,q)=>(W.add(q),W),new Set),N=o(c).filter(W=>!(W.setting&&R.has(W.setting.key))),F=o(v).filter(W=>!(W.setting&&R.has(W.setting.key)));if(N.length!==F.length)return!1;for(let W=0;W<N.length;W++){const q=N[W],B=F[W];if(q.setting&&B.setting){if(q.setting.key!==B.setting.key||!_.equals(d[q.setting.key],I[q.setting.key]))return!1}else if(!q.setting&&!B.setting){if(q.value!==B.value)return!1}else return!1}return!0}function a(c){return c?o(c).length===0:!0}e.isEmpty=a;function h(c,v,E){const d=c?Object.keys(c).filter(W=>!E.has(W)):[],I=Object.keys(v).filter(W=>!E.has(W)),R=I.filter(W=>d.indexOf(W)===-1).reduce((W,q)=>(W.add(q),W),new Set),N=d.filter(W=>I.indexOf(W)===-1).reduce((W,q)=>(W.add(q),W),new Set),F=new Set;if(c)for(const W of d){if(N.has(W))continue;const q=c[W],B=v[W];_.equals(q,B)||F.add(W)}return{added:R,removed:N,updated:F}}function u(c,v,E,d){const I=(0,O.parse)(v),R=o(v),N=o(E),F=g(c,R,N);return y(E,c,I[c],F,N,d)}e.addSetting=u;function g(c,v,E){const d=v.findIndex(R=>R.setting?.key===c),I=v[d-1];if(I){if(I.setting){const N=n(I.setting.key,E);if(N)return{index:E.indexOf(N),insertAfter:!0}}else{const N=s(d,v);if(N){const F=n(N.setting.key,E);if(F){const W=t(E.indexOf(F),E),q=i(v,N,v[d]);if(W){const B=i(E,F,W),Q=r(q,B);return Q?{index:E.indexOf(Q),insertAfter:!0}:{index:E.indexOf(W),insertAfter:!1}}else{const B=i(E,F,E[E.length-1]),Q=r(q,B);return Q?{index:E.indexOf(Q),insertAfter:!0}:{index:E.length-1,insertAfter:!0}}}}}const R=v[d+1];if(R)if(R.setting){const N=n(R.setting.key,E);if(N)return{index:E.indexOf(N),insertAfter:!1}}else{const N=t(d,v);if(N){const F=n(N.setting.key,E);if(F){const W=s(E.indexOf(F),E),q=i(v,v[d],N);if(W){const B=i(E,W,F),Q=r(q.reverse(),B.reverse());return Q?{index:E.indexOf(Q),insertAfter:!1}:{index:E.indexOf(W),insertAfter:!0}}else{const B=i(E,E[0],F),Q=r(q.reverse(),B.reverse());return Q?{index:E.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:E.length-1,insertAfter:!0}}function y(c,v,E,d,I,R){let N;return d.index===-1?N=(0,l.setProperty)(c,[v],E,R):N=L(c,v,E,d,I,R).map(F=>(0,l.withFormatting)(c,F,R)[0]),(0,l.applyEdits)(c,N)}function L(c,v,E,d,I,R){const N=`${JSON.stringify(v)}: ${JSON.stringify(E)}`,F=(0,A.getEOL)(R,c),W=I[d.index];if(d.insertAfter){const q=[];if(W.setting)q.push({offset:W.endOffset,length:0,content:","+N});else{const B=t(d.index,I),Q=s(d.index,I),Z=Q?.setting?.commaOffset;Q&&Z===void 0&&q.push({offset:Q.endOffset,length:0,content:","});const K=Z!==void 0&&Z>W.endOffset;q.push({offset:K?Z+1:W.endOffset,length:0,content:B?F+N+",":F+N})}return q}else{if(W.setting)return[{offset:W.startOffset,length:0,content:N+","}];const q=(I[d.index-1]&&!I[d.index-1].setting?F:"")+N+(t(d.index,I)?",":"")+F;return[{offset:W.startOffset,length:0,content:q}]}}function n(c,v){return v.filter(E=>E.setting?.key===c)[0]}function s(c,v){for(let E=c-1;E>=0;E--)if(v[E].setting)return v[E]}function t(c,v){for(let E=c+1;E<v.length;E++)if(v[E].setting)return v[E]}function i(c,v,E){const d=c.indexOf(v),I=c.indexOf(E);return c.filter((R,N)=>d<N&&N<I)}function r(c,v){if(c.length&&v.length){let E=0;for(;E<v.length&&E<c.length;E++)if(c[E].value!==v[E].value)return v[E-1];return v[E-1]}}function o(c){const v=[];let E=-1,d,I;const R={onObjectBegin:N=>{E++},onObjectProperty:(N,F,W)=>{E===0&&(d=F,I=N)},onObjectEnd:(N,F)=>{E--,E===0&&v.push({startOffset:d,endOffset:N+F,value:c.substring(d,N+F),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(N,F)=>{E++},onArrayEnd:(N,F)=>{E--,E===0&&v.push({startOffset:d,endOffset:N+F,value:c.substring(d,N+F),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(N,F,W)=>{E===0&&v.push({startOffset:d,endOffset:F+W,value:c.substring(d,F+W),setting:{key:I,commaOffset:void 0}})},onSeparator:(N,F,W)=>{if(E===0&&N===","){let q=v.length-1;for(;q>=0&&!v[q].setting;q--);const B=v[q];B&&v.splice(q,1,{startOffset:B.startOffset,endOffset:B.endOffset,value:B.value,setting:{key:B.setting.key,commaOffset:F}})}},onComment:(N,F)=>{E===0&&v.push({startOffset:N,endOffset:N+F,value:c.substring(N,N+F)})}};return(0,O.visit)(c,R),v}}),define(oe[79],ae([0,1,3,2,5,24]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,l.createDecorator)("IUserDataSyncAccountService");let _=e.UserDataSyncAccountService=class extends O.Disposable{get account(){return this._account}constructor(P,S){super(),this.userDataSyncStoreService=P,this.logService=S,this._onDidChangeAccount=this._register(new T.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(P.onTokenFailed(D=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,D),this.updateAccount(void 0),D==="Forbidden"?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(P.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(P){(P&&this._account?P.token!==this._account.token||P.authenticationProviderId!==this._account.authenticationProviderId:P!==this._account)&&(this._account=P,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(P))}};e.UserDataSyncAccountService=_=Se([Y(0,A.IUserDataSyncStoreService),Y(1,A.IUserDataSyncLogService)],_)}),define(oe[253],ae([0,1,2,12]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class l{constructor(m){this.service=m}listen(m,f){switch(f){case"onError":return this.service.onError}throw new Error(`Event not found: ${f}`)}call(m,f,p){switch(f){case"triggerSync":return this.service.triggerSync(p[0],p[1],p[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(p[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=l;class A{constructor(m){this.service=m}listen(m,f){throw new Error(`Event not found: ${f}`)}call(m,f,p){switch(f){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(p[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(O.URI.revive(p[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class _{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=_;class k{constructor(m){this.service=m}listen(m,f){switch(f){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${f}`)}async call(m,f,p){switch(f){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(p[0],p[1]);case"setEnablements":return this.service.setEnablements(p)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=k;class P{constructor(m){this.service=m}listen(m,f){switch(f){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${f}`)}call(m,f,p){switch(f){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(p)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class S{constructor(m){this.service=m}listen(m,f){switch(f){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${f}`)}call(m,f,p){switch(f){case"switch":return this.service.switch(p[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class D extends T.Disposable{constructor(m){super(),this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:O.URI.revive(m.url),type:m.type,defaultUrl:O.URI.revive(m.defaultUrl),insidersUrl:O.URI.revive(m.insidersUrl),stableUrl:O.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=D}),define(oe[254],ae([0,1,182,10,24]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let A=e.UserDataSyncLogService=class extends O.AbstractLogger{constructor(k){super(),this.logger=this._register(k.createLogger(l.USER_DATA_SYNC_LOG_ID,{name:(0,T.localize)(0,null)}))}trace(k,...P){this.logger.trace(k,...P)}debug(k,...P){this.logger.debug(k,...P)}info(k,...P){this.logger.info(k,...P)}warn(k,...P){this.logger.warn(k,...P)}error(k,...P){this.logger.error(k,...P)}flush(){this.logger.flush()}};e.UserDataSyncLogService=A=Se([Y(0,O.ILoggerService)],A)}),define(oe[255],ae([0,1,6,3,2]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends l.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:P,getActiveWindowId:S}){super(),this.disposables=this._register(new l.DisposableStore),O.Event.latch(O.Event.any(k,P))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,T.createCancelablePromise)(()=>S()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(k){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=k}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(oe[118],ae([0,1,185,14,48,23,12,5,22]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function S(i){const r=i;return typeof r?.id=="string"&&_.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=S;function D(i){return typeof i?.id=="string"&&!S(i)&&!m(i)}e.isEmptyWorkspaceIdentifier=D,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=w;function m(i){const r=i;return typeof r?.id=="string"&&_.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=m;function f(i){const r=i;if(r?.uri)return{id:r.id,uri:_.URI.revive(r.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:_.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=f;var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function b(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=b;function a(i){const r=i;return!!(r&&typeof r=="object"&&_.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=a;class h{constructor(r,o,c,v,E){this._id=r,this._transient=c,this._configuration=v,this._ignorePathCasing=E,this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class u{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,A.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function g(i){return new u({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(i,r){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function L(i){let r;return _.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=L,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function s(i,r){return!y(i,r)&&!L(i)}e.isSavedWorkspace=s;function t(i){return(typeof i=="string"?(0,O.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(oe[18],ae([0,1,65,3,2,23,12,176,15,13,5,10,118,37,30,6,32,27,11]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function g(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&_.URI.isUri(i.location)&&_.URI.isUri(i.globalStorageHome)&&_.URI.isUri(i.settingsResource)&&_.URI.isUri(i.keybindingsResource)&&_.URI.isUri(i.tasksResource)&&_.URI.isUri(i.snippetsHome)&&_.URI.isUri(i.extensionsResource))}e.isUserDataProfile=g,e.IUserDataProfilesService=(0,D.createDecorator)("IUserDataProfilesService");function y(t,i){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:_.URI.revive(t.location).with({scheme:i}),globalStorageHome:_.URI.revive(t.globalStorageHome).with({scheme:i}),settingsResource:_.URI.revive(t.settingsResource).with({scheme:i}),keybindingsResource:_.URI.revive(t.keybindingsResource).with({scheme:i}),tasksResource:_.URI.revive(t.tasksResource).with({scheme:i}),snippetsHome:_.URI.revive(t.snippetsHome).with({scheme:i}),extensionsResource:_.URI.revive(t.extensionsResource).with({scheme:i}),cacheHome:_.URI.revive(t.cacheHome).with({scheme:i}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=y;function L(t,i,r,o,c){return{id:t,name:i,location:r,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,A.joinPath)(r,"globalStorage"),settingsResource:(0,A.joinPath)(r,"settings.json"),keybindingsResource:(0,A.joinPath)(r,"keybindings.json"),tasksResource:(0,A.joinPath)(r,"tasks.json"),snippetsHome:(0,A.joinPath)(r,"snippets"),extensionsResource:(0,A.joinPath)(r,"extensions.json"),cacheHome:(0,A.joinPath)(o,t),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=L;let n=e.UserDataProfilesService=class extends l.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,r,o,c){super(),this.environmentService=i,this.fileService=r,this.uriIdentityService=o,this.logService=c,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=[];if(this.enabled)try{for(const v of this.getStoredProfiles()){if(!v.name||!(0,u.isString)(v.name)||!v.location){this.logService.warn("Skipping the invalid stored profile",v.location||v.name);continue}i.push(L((0,A.basename)(v.location),v.name,v.location,this.profilesCacheHome,{shortName:v.shortName,useDefaultFlags:v.useDefaultFlags}))}}catch(v){this.logService.error(v)}const r=new f.ResourceMap,o=new Map,c=this.createDefaultProfile();if(i.unshift({...c,extensionsResource:this.getDefaultProfileExtensionsLocation()??c.extensionsResource,isDefault:!0}),i.length)try{const v=this.getStoredProfileAssociations();if(v.workspaces)for(const[E,d]of Object.entries(v.workspaces)){const I=_.URI.parse(E),R=i.find(N=>N.id===d);R&&r.set(I,R)}if(v.emptyWindows)for(const[E,d]of Object.entries(v.emptyWindows)){const I=i.find(R=>R.id===d);I&&o.set(E,I)}}catch(v){this.logService.error(v)}this._profilesObject={profiles:i,workspaces:r,emptyWindows:o}}return this._profilesObject}createDefaultProfile(){return L("__default__profile__",(0,k.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome)}async createTransientProfile(i){const r="Temp",o=new RegExp(`${(0,h.escapeRegExpCharacters)(r)}\\s(\\d+)`);let c=0;for(const E of this.profiles){const d=o.exec(E.name),I=d?parseInt(d[1]):0;c=I>c?I:c}const v=`${r} ${c+1}`;return this.createProfile((0,T.hash)((0,a.generateUuid)()).toString(16),v,{transient:!0},i)}async createNamedProfile(i,r,o){return this.createProfile((0,T.hash)((0,a.generateUuid)()).toString(16),i,r,o)}async createProfile(i,r,o,c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const v=await this.doCreateProfile(i,r,o);return c&&await this.setProfileForWorkspace(c,v),v}async doCreateProfile(i,r,o){if(!(0,u.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let c=this.profileCreationPromises.get(r);return c||(c=(async()=>{try{const v=this.profiles.find(I=>I.name===r||I.id===i);if(v)return v;const E=L(i,r,(0,A.joinPath)(this.profilesHome,i),this.profilesCacheHome,o);await this.fileService.createFolder(E.location);const d=[];return this._onWillCreateProfile.fire({profile:E,join(I){d.push(I)}}),await b.Promises.settled(d),this.updateProfiles([E],[],[]),E}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,c)),c}async updateProfile(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(c=>c.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);return o=L(o.id,r.name??o.name,o.location,this.profilesCacheHome,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.updateProfiles([],[],[o]),o}async removeProfile(i){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(c=>c.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:r,join(c){o.push(c)}});try{await Promise.allSettled(o)}catch(c){this.logService.error(c)}for(const c of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(c)?.id&&this.profilesObject.emptyWindows.delete(c);for(const c of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(c)?.id&&this.profilesObject.workspaces.delete(c);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(c){(0,S.toFileOperationResult)(c)!==1&&this.logService.error(c)}try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(c){this.logService.error(c)}}async setProfileForWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(c=>c.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,o)}unsetWorkspace(i,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(i,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.getWorkspace(i);return _.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(i){return(0,m.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,m.isWorkspaceIdentifier)(i)?i.configPath:i.id}isProfileAssociatedToWorkspace(i){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location)))}updateProfiles(i,r,o){const c=[...this.profiles,...i],v=[];this.transientProfilesObject.profiles=[];for(let E of c)E.isDefault||r.some(d=>E.id===d.id)||(E=o.find(d=>E.id===d.id)??E,E.isTransient?this.transientProfilesObject.profiles.push(E):v.push({location:E.location,name:E.name,shortName:E.shortName,useDefaultFlags:E.useDefaultFlags}));this.saveStoredProfiles(v),this._profilesObject=void 0,this.triggerProfilesChanges(i,r,o)}triggerProfilesChanges(i,r,o){this._onDidChangeProfiles.fire({added:i,removed:r,updated:o,all:this.profiles})}updateWorkspaceAssociation(i,r,o){o=r?.isTransient?!0:o,o||this.updateWorkspaceAssociation(i,void 0,!0);const c=this.getWorkspace(i),v=o?this.transientProfilesObject:this.profilesObject;_.URI.isUri(c)?(v.workspaces.delete(c),r&&v.workspaces.set(c,r)):(v.emptyWindows.delete(c),r&&v.emptyWindows.set(c,r)),o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[o,c]of this.profilesObject.workspaces.entries())i[o.toString()]=c.id;const r={};for(const[o,c]of this.profilesObject.emptyWindows.entries())r[o.toString()]=c.id;this.saveStoredProfileAssociations({workspaces:i,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(i){const r={},o=this.createDefaultProfile();if(i.workspaces)for(const[v,E]of Object.entries(i.workspaces)){const d=_.URI.parse(E);r[v]=this.uriIdentityService.extUri.isEqual(d,o.location)?o.id:this.uriIdentityService.extUri.basename(d)}const c={};if(i.emptyWindows)for(const[v,E]of Object.entries(i.emptyWindows)){const d=_.URI.parse(E);c[v]=this.uriIdentityService.extUri.isEqual(d,o.location)?o.id:this.uriIdentityService.extUri.basename(d)}return{workspaces:r,emptyWindows:c}}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};n.PROFILES_KEY="userDataProfiles",n.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e.UserDataProfilesService=n=Se([Y(0,P.IEnvironmentService),Y(1,S.IFileService),Y(2,p.IUriIdentityService),Y(3,w.ILogService)],n);class s extends n{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=s}),define(oe[256],ae([0,1,6,2,18]),function(ie,e,T,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=e.UserDataProfilesCleaner=class extends O.Disposable{constructor(k){super(),this._register(new T.RunOnceScheduler(()=>{k.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=A=Se([Y(0,l.IUserDataProfilesService)],A)}),define(oe[257],ae([0,1,21,6,26,9,3,2,4,11,12,156,29,33,50,10,25,20,18]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=e.AbstractExtensionManagementService=class extends k.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(i,r,o,c,v){super(),this.galleryService=i,this.telemetryService=r,this.logService=o,this.productService=c,this.userDataProfilesService=v,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new _.Emitter),this._onDidInstallExtensions=this._register(new _.Emitter),this._onUninstallExtension=this._register(new _.Emitter),this._onDidUninstallExtension=this._register(new _.Emitter),this.participants=[],this._register((0,k.toDisposable)(()=>{this.installingExtensions.forEach(({task:E})=>E.cancel()),this.uninstallingExtensions.forEach(E=>E.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,m.isTargetPlatformCompatible)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.galleryService.isEnabled())throw new m.ExtensionManagementError(w.localize(0,null),m.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw n(this.telemetryService,"extensionGallery:install",{extensionData:(0,f.getGalleryExtensionTelemetryData)(i),error:o}),this.logService.error("Failed to install extension.",i.identifier.id),this.logService.error(o),L(o)}}async uninstall(i,r={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,r)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtension(i,r,o){const c=o.isApplicationScoped||o.isBuiltin||(0,p.isApplicationScopedExtension)(i),v={...o,installOnlyNewlyAddedFromExtensionPack:D.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:c,profileLocation:c?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation??this.getCurrentExtensionsManifestLocation()},E=W=>`${f.ExtensionKey.create(W).toString()}${v.profileLocation?`-${v.profileLocation.toString()}`:""}`;if(!D.URI.isUri(r)){const W=this.installingExtensions.get(E(r));if(W)return this.logService.info("Extensions is already requested to install",r.identifier.id),W.task.waitUntilTaskIsFinished()}const d=[],I=[],R=[],N=this.createInstallExtensionTask(i,r,v);D.URI.isUri(r)||this.installingExtensions.set(E(r),{task:N,waitingTasks:[]}),this._onInstallExtension.fire({identifier:N.identifier,source:r,profileLocation:v.profileLocation}),this.logService.info("Installing extension:",N.identifier.id),d.push({task:N,manifest:i});let F=!1;try{if(v.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const q=await this.getAllDepsAndPackExtensions(N.identifier,i,!!v.installOnlyNewlyAddedFromExtensionPack,!!v.installPreReleaseVersion,v.profileLocation),B=await this.getInstalled(void 0,v.profileLocation);for(const{gallery:Q,manifest:Z}of(0,T.distinct)(q,({gallery:K})=>K.identifier.id)){F=F||!!Z.extensionDependencies?.some($=>(0,f.areSameExtensions)({id:$},N.identifier));const K=E(Q),x=this.installingExtensions.get(K);if(x){if(this.canWaitForTask(N,x.task)){const $=x.task.identifier;this.logService.info("Waiting for already requested installing extension",$.id,N.identifier.id),x.waitingTasks.push(N),I.push(_.Event.toPromise(_.Event.filter(this.onDidInstallExtensions,j=>j.some(te=>(0,f.areSameExtensions)(te.identifier,$)))).then(j=>{if(this.logService.info("Finished waiting for already requested installing extension",$.id,N.identifier.id),!j.find(ne=>(0,f.areSameExtensions)(ne.identifier,$))?.local)throw new Error(`Extension ${$.id} is not installed`)}))}}else if(!B.some(({identifier:$})=>(0,f.areSameExtensions)($,Q.identifier))){const $=this.createInstallExtensionTask(Z,Q,{...v,donotIncludePackAndDependencies:!0});this.installingExtensions.set(K,{task:$,waitingTasks:[N]}),this._onInstallExtension.fire({identifier:$.identifier,source:Q,profileLocation:v.profileLocation}),this.logService.info("Installing extension:",$.identifier.id,N.identifier.id),d.push({task:$,manifest:Z})}}}catch(q){if(D.URI.isUri(N.source))(0,T.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",N.identifier.id,q.message),(0,T.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",N.identifier.id,q.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),q}const W=d.reduce((q,{task:B,manifest:Q})=>(q.set(B.identifier.id.toLowerCase(),{task:B,manifest:Q}),q),new Map);for(;W.size;){let q;const B=[...W.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(Z=>W.has(Z.toLowerCase())));B.length?q=W.size===1?B:B.filter(({task:Q})=>!(Q===N&&!F)):(this.logService.info("Found extensions with circular dependencies",B.map(({task:Q})=>Q.identifier.id)),q=[...W.values()]),await this.joinAllSettled(q.map(async({task:Q})=>{const Z=new Date().getTime();try{const K=await Q.run();if(await this.joinAllSettled(this.participants.map(x=>x.postInstall(K,Q.source,v,l.CancellationToken.None))),!D.URI.isUri(Q.source)){const x=Q.operation===3,$=x?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(n(this.telemetryService,x?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.getGalleryExtensionTelemetryData)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-Z,durationSinceUpdate:$}),P.isWeb&&Q.operation!==3)try{await this.galleryService.reportStatistic(K.manifest.publisher,K.manifest.name,K.manifest.version,"install")}catch{}}R.push({local:K,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:v.context,profileLocation:Q.profileLocation,applicationScoped:K.isApplicationScoped})}catch(K){throw D.URI.isUri(Q.source)||n(this.telemetryService,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.getGalleryExtensionTelemetryData)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-Z,error:K}),this.logService.error("Error while installing the extension:",Q.identifier.id),K}finally{W.delete(Q.identifier.id.toLowerCase())}}))}return I.length&&await this.joinAllSettled(I),R.forEach(({identifier:q})=>this.logService.info("Extension installed successfully:",q.id)),this._onDidInstallExtensions.fire(R),R.filter(({identifier:q})=>(0,f.areSameExtensions)(q,N.identifier))[0].local}catch(W){if(d.forEach(({task:q})=>q.cancel()),R.length)try{const q=await Promise.allSettled(R.map(({local:B})=>this.createUninstallExtensionTask(B,{versionOnly:!0,profileLocation:v.profileLocation}).run()));for(let B=0;B<q.length;B++){const Q=q[B],{identifier:Z}=R[B];Q.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",Z.id):this.logService.warn("Rollback: Error while uninstalling extension",Z.id,(0,A.getErrorMessage)(Q.reason))}}catch(q){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(q),R.map(({identifier:B})=>B.id))}throw this._onDidInstallExtensions.fire(d.map(({task:q})=>({identifier:q.identifier,operation:2,source:q.source,context:v.context,profileLocation:v.profileLocation}))),W}finally{for(const{task:W}of d)W.source&&!D.URI.isUri(W.source)&&this.installingExtensions.delete(E(W.source))}}canWaitForTask(i,r){for(const[,{task:o,waitingTasks:c}]of this.installingExtensions.entries())if(o===i&&(c.includes(r)||c.some(v=>this.canWaitForTask(v,r)))||o===r&&c[0]&&!this.canWaitForTask(i,c[0]))return!1;return!0}async joinAllSettled(i){const r=[],o=[],c=await Promise.allSettled(i);for(const v of c)v.status==="fulfilled"?r.push(v.value):o.push(v.reason);if(o.length)throw y(o);return r}async getAllDepsAndPackExtensions(i,r,o,c,v){if(!this.galleryService.isEnabled())return[];const E=await this.getInstalled(void 0,v),d=[],I=[],R=async(N,F)=>{d.push(N);const W=F.extensionDependencies||[],q=[...W];if(F.extensionPack){const B=o?E.find(Q=>(0,f.areSameExtensions)(Q.identifier,N)):void 0;for(const Q of F.extensionPack)B&&B.manifest.extensionPack&&B.manifest.extensionPack.some(Z=>(0,f.areSameExtensions)({id:Z},{id:Q}))||q.every(Z=>!(0,f.areSameExtensions)({id:Z},{id:Q}))&&q.push(Q)}if(q.length){const B=q.filter(Q=>d.every(Z=>!(0,f.areSameExtensions)(Z,{id:Q})));if(B.length){const Q=await this.galleryService.getExtensions(B.map(Z=>({id:Z,preRelease:c})),l.CancellationToken.None);for(const Z of Q){if(d.find($=>(0,f.areSameExtensions)($,Z.identifier)))continue;const K=W.some($=>(0,f.areSameExtensions)({id:$},Z.identifier));let x;try{x=await this.checkAndGetCompatibleVersion(Z,!1,c)}catch($){if($ instanceof m.ExtensionManagementError&&$.code===m.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!K){this.logService.info("Skipping the packed extension as it cannot be installed",Z.identifier.id);continue}else throw $}I.push({gallery:x.extension,manifest:x.manifest}),await R(x.extension.identifier,x.manifest)}}}};return await R(i,r),I}async checkAndGetCompatibleVersion(i,r,o){if((await this.getExtensionsControlManifest()).malicious.some(d=>(0,f.areSameExtensions)(i.identifier,d)))throw new m.ExtensionManagementError(w.localize(1,null,i.identifier.id),m.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const d=await this.getTargetPlatform();throw new m.ExtensionManagementError(w.localize(2,null,i.identifier.id,this.productService.nameLong,(0,m.TargetPlatformToString)(d)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const v=await this.getCompatibleVersion(i,r,o);if(v){if(o&&!r&&i.hasPreReleaseVersion&&!v.properties.isPreReleaseVersion)throw new m.ExtensionManagementError(w.localize(3,null,i.identifier.id,this.productService.nameLong,this.productService.version),m.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],l.CancellationToken.None))[0]?new m.ExtensionManagementError(w.localize(4,null,i.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.ExtensionManagementError(w.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),m.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",v.identifier.id);const E=await this.galleryService.getManifest(v,l.CancellationToken.None);if(E===null)throw new m.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(E.version!==v.version)throw new m.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:E}}async getCompatibleVersion(i,r,o){const c=await this.getTargetPlatform();let v=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(v=(await this.galleryService.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},l.CancellationToken.None))[0]||null),!v&&await this.galleryService.isExtensionCompatible(i,o,c)&&(v=i),v||(r?v=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:c,compatible:!0},l.CancellationToken.None))[0]||null:v=await this.galleryService.getCompatibleExtension(i,o,c)),v}async uninstallExtension(i,r){const o={...r,profileLocation:i.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},c=N=>`${N.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,v=this.uninstallingExtensions.get(c(i.identifier));if(v)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),v.waitUntilTaskIsFinished();const E=N=>{const F=this.createUninstallExtensionTask(N,o);return this.uninstallingExtensions.set(c(F.extension.identifier),F),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${N.identifier.id}@${N.manifest.version}`),this._onUninstallExtension.fire({identifier:N.identifier,profileLocation:o.profileLocation,applicationScoped:N.isApplicationScoped}),F},d=(N,F)=>{F?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,o.profileLocation.toString(),F.message):this.logService.error("Failed to uninstall extension:",`${N.identifier.id}@${N.manifest.version}`,F.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${N.identifier.id}@${N.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${N.identifier.id}@${N.manifest.version}`),n(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,f.getLocalExtensionTelemetryData)(N),error:F}),this._onDidUninstallExtension.fire({identifier:N.identifier,error:F?.code,profileLocation:o.profileLocation,applicationScoped:N.isApplicationScoped})},I=[],R=[];try{I.push(E(i));const N=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const F=this.getAllPackExtensionsToUninstall(i,N);for(const W of F)this.uninstallingExtensions.has(c(W.identifier))?this.logService.info("Extensions is already requested to uninstall",W.identifier.id):I.push(E(W))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(I.map(F=>F.extension),N,i),await this.joinAllSettled(I.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(W=>W.postUninstall(F.extension,o,l.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}d(F.extension)}catch(W){const q=W instanceof m.ExtensionManagementError?W:new m.ExtensionManagementError((0,A.getErrorMessage)(W),m.ExtensionManagementErrorCode.Internal);throw d(F.extension,q),q}finally{R.push(F)}}))}catch(N){const F=N instanceof m.ExtensionManagementError?N:new m.ExtensionManagementError((0,A.getErrorMessage)(N),m.ExtensionManagementErrorCode.Internal);for(const W of I){try{W.cancel()}catch{}R.includes(W)||d(W.extension,F)}throw F}finally{for(const N of I)this.uninstallingExtensions.delete(c(N.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",N.extension.identifier.id)}}checkForDependents(i,r,o){for(const c of i){const v=this.getDependents(c,r);if(v.length){const E=v.filter(d=>!i.some(I=>(0,f.areSameExtensions)(I.identifier,d.identifier)));if(E.length)throw new Error(this.getDependentsErrorMessage(c,E,o))}}}getDependentsErrorMessage(i,r,o){return o===i?r.length===1?w.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?w.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):w.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?w.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?w.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):w.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const v=r.filter(d=>!d.isBuiltin&&c.some(I=>(0,f.areSameExtensions)({id:I},d.identifier))),E=[];for(const d of v)E.push(...this.getAllPackExtensionsToUninstall(d,r,o));return[...v,...E]}return[]}getDependents(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,f.areSameExtensions)({id:c},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};e.AbstractExtensionManagementService=g=Se([Y(0,m.IExtensionGalleryService),Y(1,h.ITelemetryService),Y(2,b.ILogService),Y(3,a.IProductService),Y(4,u.IUserDataProfilesService)],g);function y(t){const i=Array.isArray(t)?t:[t];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=y;function L(t){if(t instanceof m.ExtensionManagementError)return t;const i=new m.ExtensionManagementError(t.message,m.ExtensionManagementErrorCode.Internal);return i.stack=t.stack,i}function n(t,i,{extensionData:r,verificationStatus:o,duration:c,error:v,durationSinceUpdate:E}){let d,I;(0,S.isDefined)(o)&&(o===!0?o="Verified":(o===!1||(d=m.ExtensionManagementErrorCode.Signature,I=o),o="Unverified")),v&&(v instanceof m.ExtensionManagementError?(d=v.code,v.code===m.ExtensionManagementErrorCode.Signature&&(I=v.message)):d=m.ExtensionManagementErrorCode.Internal),t.publicLog(i,{...r,verificationStatus:o,success:!v,duration:c,errorcode:d,errorcodeDetail:I,durationSinceUpdate:E})}class s{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(i=>new Promise((r,o)=>{const c=i.onCancellationRequested(()=>{c.dispose(),o(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=s}),define(oe[51],ae([0,1,6,16,2,3,37,12,29,33,13,5,10,18,30,11,9,20]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class g extends Error{constructor(t,i){super(t),this.code=i}}e.ExtensionsProfileScanningError=g,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let y=e.AbstractExtensionsProfileScannerService=class extends l.Disposable{constructor(t,i,r,o,c,v){super(),this.extensionsLocation=t,this.fileService=i,this.userDataProfilesService=r,this.uriIdentityService=o,this.telemetryService=c,this.logService=v,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new _.ResourceMap}scanProfileExtensions(t,i){return this.withProfileExtensions(t,void 0,i)}async addExtensionsToProfile(t,i){const r=[],o=[];try{return await this.withProfileExtensions(i,c=>{const v=[];for(const E of c)t.some(([d])=>(0,S.areSameExtensions)(d.identifier,E.identifier)&&d.manifest.version!==E.version)?r.push(E):v.push(E);for(const[E,d]of t)if(!v.some(I=>(0,S.areSameExtensions)(I.identifier,E.identifier)&&I.version===E.manifest.version)){const I={identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:d};o.push(I),v.push(I)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:i}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:i}),v}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:i}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:i}),o}catch(c){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:c,profileLocation:i}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:c,profileLocation:i}),c}}async updateMetadata(t,i){const r=[];return await this.withProfileExtensions(i,o=>{const c=[];for(const v of o){const E=t.find(([d])=>(0,S.areSameExtensions)(d.identifier,v.identifier)&&d.manifest.version===v.version);E&&(v.metadata={...v.metadata,...E[1]},r.push(v)),c.push(v)}return c}),r}async removeExtensionFromProfile(t,i){const r=[];this._onRemoveExtensions.fire({extensions:r,profileLocation:i});try{await this.withProfileExtensions(i,o=>{const c=[];for(const v of o)(0,S.areSameExtensions)(v.identifier,t.identifier)?r.push(v):c.push(v);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:i}),c}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:i})}catch(o){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:o,profileLocation:i}),o}}async withProfileExtensions(t,i,r){return this.getResourceAccessQueue(t).queue(async()=>{let o=[],c;try{const v=await this.fileService.readFile(t);c=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,D.toFileOperationResult)(v)!==1)throw v;if(this.uriIdentityService.extUri.isEqual(t,this.userDataProfilesService.defaultProfile.extensionsResource)&&(c=await this.migrateFromOldDefaultProfileExtensionsLocation()),!c&&r?.bailOutWhenFileNotFound)throw new g((0,a.getErrorMessage)(v),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.reportAndThrowInvalidConentError(t);let v=!1;for(const E of c){L(E)||this.reportAndThrowInvalidConentError(t);let d;if((0,b.isString)(E.relativeLocation)&&E.relativeLocation)d=this.resolveExtensionLocation(E.relativeLocation);else if((0,b.isString)(E.location))d=this.resolveExtensionLocation(E.location),v=!0,E.relativeLocation=E.location,E.location=d.toJSON();else{d=k.URI.revive(E.location);const I=this.toRelativePath(d);I&&(v=!0,E.relativeLocation=I)}o.push({identifier:E.identifier,location:d,version:E.version,metadata:E.metadata})}v&&await this.fileService.writeFile(t,O.VSBuffer.fromString(JSON.stringify(c)))}if(i){o=i(o);const v=o.map(E=>({identifier:E.identifier,version:E.version,location:E.location.toJSON(),relativeLocation:this.toRelativePath(E.location),metadata:E.metadata}));await this.fileService.writeFile(t,O.VSBuffer.fromString(JSON.stringify(v)))}return o})}reportAndThrowInvalidConentError(t){const i=new g(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(t){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(t),this.extensionsLocation)?this.uriIdentityService.extUri.basename(t):void 0}resolveExtensionLocation(t){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,t)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const t=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(t)).value.toString()}catch(c){if((0,D.toFileOperationResult)(c)===1)return;throw c}this.logService.info("Migrating extensions from old default profile location",t.toString());let o;try{const c=JSON.parse(r);Array.isArray(c)&&c.every(v=>L(v))?o=c:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.logService.error(c)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(c){if((0,D.toFileOperationResult)(c)===3)this.logService.info("Migration from old default profile location to new location is done by another window",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw c}try{await this.fileService.del(t)}catch(c){(0,D.toFileOperationResult)(c)!==1&&this.logService.error(c)}try{await this.fileService.del(i)}catch(c){(0,D.toFileOperationResult)(c)!==1&&this.logService.error(c)}return o})()),this._migrationPromise}getResourceAccessQueue(t){let i=this.resourcesAccessQueueMap.get(t);return i||(i=new T.Queue,this.resourcesAccessQueueMap.set(t,i)),i}};e.AbstractExtensionsProfileScannerService=y=Se([Y(1,D.IFileService),Y(2,f.IUserDataProfilesService),Y(3,p.IUriIdentityService),Y(4,h.ITelemetryService),Y(5,m.ILogService)],y);function L(s){return(0,b.isObject)(s)&&(0,P.isIExtensionIdentifier)(s.identifier)&&(n(s.location)||(0,b.isString)(s.location)&&s.location)&&((0,b.isUndefined)(s.relativeLocation)||(0,b.isString)(s.relativeLocation))&&s.version&&(0,b.isString)(s.version)}function n(s){return s?(0,b.isString)(s.path)&&(0,b.isString)(s.scheme):!1}}),define(oe[80],ae([0,1,21,6,31,16,9,35,140,2,22,14,4,23,54,90,11,12,159,15,33,50,68,13,5,10,25,3,91,51,18,30,191]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g,y,L,n,s,t,i,r,o,c,v,E,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var R;(function(Z){function K(x,$){if(x===$)return!0;const j=Object.keys(x),te=new Set;for(const ne of Object.keys($))te.add(ne);if(j.length!==te.size)return!1;for(const ne of j){if(x[ne]!==$[ne])return!1;te.delete(ne)}return te.size===0}Z.equals=K})(R||(e.Translations=R={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let N=e.AbstractExtensionsScannerService=class extends S.Disposable{constructor(K,x,$,j,te,ne,se,J,G,M,C,U){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=x,this.extensionsControlLocation=$,this.currentProfile=j,this.userDataProfilesService=te,this.extensionsProfileScannerService=ne,this.fileService=se,this.logService=J,this.environmentService=G,this.productService=M,this.uriIdentityService=C,this.instantiationService=U,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(q,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(q,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(W,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,y.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,x,$){const[j,te]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(x)]),ne=$?await this.scanExtensionsUnderDevelopment(K,[...j,...te]):[];return this.dedupExtensions(j,te,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const x=[];x.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),x.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[$,j]=await Promise.all(x);return this.applyScanOptions([...$,...j],0,K,!1)}async scanUserExtensions(K){const x=K.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",x);const $=this.uriIdentityService.extUri.isEqual(K.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.createExtensionScannerInput(x,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,$),te=K.useCache&&!j.devMode&&j.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let ne;try{ne=await te.scanExtensions(j)}catch(se){if(se instanceof v.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),ne=await te.scanExtensions(j);else throw se}return ne=await this.applyScanOptions(ne,1,K,!0),this.logService.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(K,x){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const $=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(j=>j.scheme===D.Schemas.file).map(async j=>{const te=await this.createExtensionScannerInput(j,!1,1,!0,K.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(te)).map(se=>(se.type=x.find(J=>(0,y.areSameExtensions)(J.identifier,se.identifier))?.type??se.type,this.extensionsScanner.validate(se,te)))}))).flat();return this.applyScanOptions($,"development",K,!0)}return[]}async scanExistingExtension(K,x,$){const j=await this.createExtensionScannerInput(K,!1,x,!0,$.language,!0,void 0),te=await this.extensionsScanner.scanExtension(j);return!te||!$.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(K,x,$){const j=await this.createExtensionScannerInput(K,!1,x,!0,$.language,!0,void 0),te=await this.extensionsScanner.scanOneOrMultipleExtensions(j);return this.applyScanOptions(te,x,$,!0)}async scanMetadata(K){const x=(0,f.joinPath)(K,"package.json"),$=(await this.fileService.readFile(x)).value.toString();return JSON.parse($).__metadata}async updateMetadata(K,x){const $=(0,f.joinPath)(K,"package.json"),j=(await this.fileService.readFile($)).value.toString(),te=JSON.parse(j);x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,te.__metadata={...te.__metadata,...x},await this.fileService.writeFile((0,f.joinPath)(K,"package.json"),A.VSBuffer.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof v.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw K}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.extensionsProfileScannerService.addExtensionsToProfile(K.map(x=>[x,x.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(x){(0,s.toFileOperationResult)(x)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,_.getErrorMessage)(x))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.logService.error(K)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(K,x,$,j){return $.includeAllVersions||(K=this.dedupExtensions(x===0?K:void 0,x===1?K:void 0,x==="development"?K:void 0,await this.getTargetPlatform(),j)),$.includeInvalid||(K=K.filter(te=>te.isValid)),K.sort((te,ne)=>{const se=w.basename(te.location.fsPath),J=w.basename(ne.location.fsPath);return se<J?-1:se>J?1:0})}dedupExtensions(K,x,$,j,te){const ne=(J,G,M)=>{if(J.isValid&&!G.isValid)return!1;if(J.isValid===G.isValid){if(te&&p.gt(J.manifest.version,G.manifest.version))return this.logService.debug(`Skipping extension ${G.location.path} with lower version ${G.manifest.version} in favour of ${J.location.path} with version ${J.manifest.version}`),!1;if(p.eq(J.manifest.version,G.manifest.version)){if(J.type===0)return this.logService.debug(`Skipping extension ${G.location.path} in favour of system extension ${J.location.path} with same version`),!1;if(J.targetPlatform===j)return this.logService.debug(`Skipping extension ${G.location.path} from different target platform ${G.targetPlatform}`),!1}}return M?this.logService.warn(`Overwriting user extension ${J.location.path} with ${G.location.path}.`):this.logService.debug(`Overwriting user extension ${J.location.path} with ${G.location.path}.`),!0},se=new L.ExtensionIdentifierMap;return K?.forEach(J=>{const G=se.get(J.identifier.id);(!G||ne(G,J,!1))&&se.set(J.identifier.id,J)}),x?.forEach(J=>{const G=se.get(J.identifier.id);if(!G&&K&&J.type===0){this.logService.debug(`Skipping obsolete system extension ${J.location.path}.`);return}(!G||ne(G,J,!1))&&se.set(J.identifier.id,J)}),$?.forEach(J=>{const G=se.get(J.identifier.id);(!G||ne(G,J,!0))&&se.set(J.identifier.id,J),se.set(J.identifier.id,J)}),[...se.values()]}async scanDefaultSystemExtensions(K,x){this.logService.trace("Started scanning system extensions");const $=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,x,!0,void 0),te=await(K&&!$.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions($);return this.logService.trace("Scanned system extensions:",te.length),te}async scanDevSystemExtensions(K,x){const $=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!$?.length)return[];this.logService.trace("Started scanning dev system extensions");const j=x?await this.getBuiltInExtensionControl():{},te=[],ne=h.URI.file(w.normalize(w.join(D.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const J of $){const G=j[J.name]||"marketplace";switch(G){case"disabled":break;case"marketplace":te.push((0,f.joinPath)(ne,J.name));break;default:te.push(h.URI.file(G));break}}const se=await Promise.all(te.map(async J=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(J,!1,0,!0,K,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",se.length),(0,T.coalesce)(se)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,x,$,j,te,ne,se){const J=await this.getTranslations(te??m.language),G=await this.getMtime(K),M=x&&!this.uriIdentityService.extUri.isEqual(K,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,C=M?await this.getMtime(M):void 0;return new F(K,G,M,C,x,se,$,j,ne,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,te,J)}async getMtime(K){try{const x=await this.fileService.stat(K);if(typeof x.mtime=="number")return x.mtime}catch{}}};e.AbstractExtensionsScannerService=N=Se([Y(4,E.IUserDataProfilesService),Y(5,v.IExtensionsProfileScannerService),Y(6,s.IFileService),Y(7,i.ILogService),Y(8,g.IEnvironmentService),Y(9,r.IProductService),Y(10,d.IUriIdentityService),Y(11,t.IInstantiationService)],N);class F{constructor(K,x,$,j,te,ne,se,J,G,M,C,U,z,H,V){this.location=K,this.mtime=x,this.applicationExtensionslocation=$,this.applicationExtensionslocationMtime=j,this.profile=te,this.profileScanOptions=ne,this.type=se,this.excludeObsolete=J,this.validate=G,this.productVersion=M,this.productDate=C,this.productCommit=U,this.devMode=z,this.language=H,this.translations=V}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,x){return(0,f.isEqual)(K.location,x.location)&&K.mtime===x.mtime&&(0,f.isEqual)(K.applicationExtensionslocation,x.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===x.applicationExtensionslocationMtime&&K.profile===x.profile&&l.equals(K.profileScanOptions,x.profileScanOptions)&&K.type===x.type&&K.excludeObsolete===x.excludeObsolete&&K.validate===x.validate&&K.productVersion===x.productVersion&&K.productDate===x.productDate&&K.productCommit===x.productCommit&&K.devMode===x.devMode&&K.language===x.language&&R.equals(K.translations,x.translations)}}e.ExtensionScannerInput=F;let W=class extends S.Disposable{constructor(K,x,$,j,te){super(),this.obsoleteFile=K,this.extensionsProfileScannerService=x,this.uriIdentityService=$,this.fileService=j,this.logService=te}async scanExtensions(K){const x=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let $={};if(K.excludeObsolete&&K.type===1)try{const j=(await this.fileService.readFile(this.obsoleteFile)).value.toString();$=JSON.parse(j)}catch{}return(0,a.isEmptyObject)($)?x:x.filter(j=>!$[y.ExtensionKey.create(j).toString()])}async scanExtensionsFromLocation(K){const x=await this.fileService.resolve(K.location);if(!x.children?.length)return[];const $=await Promise.all(x.children.map(async j=>{if(!j.isDirectory||K.type===1&&(0,f.basename)(j.resource).indexOf(".")===0)return null;const te=new F(j.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(te)}));return(0,T.coalesce)($).sort((j,te)=>j.location.path<te.location.path?-1:1)}async scanExtensionsFromProfile(K){let x=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){x=x.filter(j=>!j.metadata?.isApplicationScoped);const $=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,K);x.push(...$)}return x}async scanExtensionsFromProfileResource(K,x,$){const j=await this.extensionsProfileScannerService.scanProfileExtensions(K,$.profileScanOptions);if(!j.length)return[];const te=await Promise.all(j.map(async ne=>{if(x(ne)){const se=new F(ne.location,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.profileScanOptions,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(se,ne.metadata)}return null}));return(0,T.coalesce)(te)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,f.joinPath)(K.location,"package.json"))){const x=await this.scanExtension(K);return x?[x]:[]}else return await this.scanExtensions(K)}catch(x){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,_.getErrorMessage)(x)),[]}}async scanExtension(K,x){try{let $=await this.scanExtensionManifest(K.location);if($){$.publisher||($.publisher=L.UNDEFINED_PUBLISHER),x=x??$.__metadata,delete $.__metadata;const j=(0,y.getGalleryExtensionId)($.publisher,$.name),te=x?.id?{id:j,uuid:x.id}:{id:j},ne=x?.isSystem?0:K.type,se=ne===0||!!x?.isBuiltin;$=await this.translateManifest(K.location,$,F.createNlsConfiguration(K));const J={type:ne,identifier:te,manifest:$,location:K.location,isBuiltin:se,targetPlatform:x?.targetPlatform??"undefined",metadata:x,isValid:!0,validations:[]};return K.validate?this.validate(J,K):J}}catch($){K.type!==0&&this.logService.error($)}return null}validate(K,x){let $=!0;const j=(0,n.validateExtensionManifest)(x.productVersion,x.productDate,x.location,K.manifest,K.isBuiltin);for(const[te,ne]of j)te===b.default.Error&&($=!1,this.logService.error(this.formatMessage(x.location,ne)));return K.isValid=$,K.validations=j,K}async scanExtensionManifest(K){const x=(0,f.joinPath)(K,"package.json");let $;try{$=(await this.fileService.readFile(x)).value.toString()}catch(te){return(0,s.toFileOperationResult)(te)!==1&&this.logService.error(this.formatMessage(K,(0,u.localize)(0,null,x.path,te.message))),null}let j;try{j=JSON.parse($)}catch{const ne=[];(0,k.parse)($,ne);for(const se of ne)this.logService.error(this.formatMessage(K,(0,u.localize)(1,null,x.path,se.offset,se.length,(0,P.getParseErrorMessage)(se.error))));return null}return(0,k.getNodeType)(j)!=="object"?(this.logService.error(this.formatMessage(K,(0,u.localize)(2,null,x.path))),null):j}async translateManifest(K,x,$){const j=await this.getLocalizedMessages(K,x,$);if(j)try{const te=[],ne=await this.resolveOriginalMessageBundle(j.default,te);if(te.length>0)return te.forEach(J=>{this.logService.error(this.formatMessage(K,(0,u.localize)(3,null,j.default?.path,(0,P.getParseErrorMessage)(J.error))))}),x;if((0,k.getNodeType)(j)!=="object")return this.logService.error(this.formatMessage(K,(0,u.localize)(4,null,j.default?.path))),x;const se=j.values||Object.create(null);return(0,I.localizeManifest)(x,se,ne)}catch{}return x}async getLocalizedMessages(K,x,$){const j=(0,f.joinPath)(K,"package.nls.json"),te=(G,M)=>{M.forEach(C=>{this.logService.error(this.formatMessage(K,(0,u.localize)(5,null,G?.path,(0,P.getParseErrorMessage)(C.error))))})},ne=G=>{this.logService.error(this.formatMessage(K,(0,u.localize)(6,null,G?.path)))},se=`${x.publisher}.${x.name}`,J=$.translations[se];if(J)try{const G=h.URI.file(J),M=(await this.fileService.readFile(G)).value.toString(),C=[],U=(0,k.parse)(M,C);return C.length>0?(te(G,C),{values:void 0,default:j}):(0,k.getNodeType)(U)!=="object"?(ne(G),{values:void 0,default:j}):{values:U.contents?U.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.fileService.exists(j))return;let M;try{M=await this.findMessageBundles(K,$)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const C=(await this.fileService.readFile(M.localized)).value.toString(),U=[],z=(0,k.parse)(C,U);return U.length>0?(te(M.localized,U),{values:void 0,default:M.original}):(0,k.getNodeType)(z)!=="object"?(ne(M.localized),{values:void 0,default:M.original}):{values:z,default:M.original}}catch{return{values:void 0,default:M.original}}}}async resolveOriginalMessageBundle(K,x){if(K)try{const $=(await this.fileService.readFile(K)).value.toString();return(0,k.parse)($,x)}catch{}}findMessageBundles(K,x){return new Promise(($,j)=>{const te=ne=>{const se=(0,f.joinPath)(K,`package.nls.${ne}.json`);this.fileService.exists(se).then(J=>{J&&$({localized:se,original:(0,f.joinPath)(K,"package.nls.json")});const G=ne.lastIndexOf("-");G===-1?$({localized:(0,f.joinPath)(K,"package.nls.json"),original:null}):(ne=ne.substring(0,G),te(ne))})};if(x.devMode||x.pseudo||!x.language)return $({localized:(0,f.joinPath)(K,"package.nls.json"),original:null});te(x.language)})}formatMessage(K,x){return`[${K.path}]: ${x}`}};W=Se([Y(1,v.IExtensionsProfileScannerService),Y(2,d.IUriIdentityService),Y(3,s.IFileService),Y(4,i.ILogService)],W);let q=class extends W{constructor(K,x,$,j,te,ne,se){super(x,j,te,ne,se),this.currentProfile=K,this.userDataProfilesService=$,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const x=this.getCacheFile(K),$=await this.readExtensionCache(x);if(this.input=K,$&&$.input&&F.equals($.input,this.input))return this.logService.debug("Using cached extensions scan result",K.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),$.result.map(te=>(te.location=h.URI.revive(te.location),te));const j=await super.scanExtensions(K);return await this.writeExtensionCache(x,{input:K,result:j}),j}async readExtensionCache(K){try{const x=await this.fileService.readFile(K),$=JSON.parse(x.value.toString());return{result:$.result,input:(0,c.revive)($.input)}}catch(x){this.logService.debug("Error while reading the extension cache file:",K.path,(0,_.getErrorMessage)(x))}return null}async writeExtensionCache(K,x){try{await this.fileService.writeFile(K,A.VSBuffer.fromString(JSON.stringify(x)))}catch($){this.logService.debug("Error while writing the extension cache file:",K.path,(0,_.getErrorMessage)($))}}async validateCache(){if(!this.input)return;const K=this.getCacheFile(this.input),x=await this.readExtensionCache(K);if(!x)return;const $=x.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!l.equals(j,$))try{this.logService.info("Invalidating Cache",$,j),await this.fileService.del(K),this._onDidChangeCache.fire()}catch(te){this.logService.error(te)}}getCacheFile(K){const x=this.getProfile(K);return this.uriIdentityService.extUri.joinPath(x.cacheHome,K.type===0?L.BUILTIN_MANIFEST_CACHE_FILE:L.USER_MANIFEST_CACHE_FILE)}getProfile(K){return K.type===0?this.userDataProfilesService.defaultProfile:K.profile?this.uriIdentityService.extUri.isEqual(K.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(x=>this.uriIdentityService.extUri.isEqual(K.location,x.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};q=Se([Y(2,E.IUserDataProfilesService),Y(3,v.IExtensionsProfileScannerService),Y(4,d.IUriIdentityService),Y(5,s.IFileService),Y(6,i.ILogService)],q);function B(Z,K){const x=(0,y.getExtensionId)(Z.manifest.publisher,Z.manifest.name);return{id:x,identifier:new L.ExtensionIdentifier(x),isBuiltin:Z.type===0,isUserBuiltin:Z.type===1&&Z.isBuiltin,isUnderDevelopment:K,extensionLocation:Z.location,uuid:Z.identifier.uuid,targetPlatform:Z.targetPlatform,...Z.manifest}}e.toExtensionDescription=B;class Q extends N{constructor(K,x,$,j,te,ne,se,J,G,M,C,U){super(K,x,(0,f.joinPath)($,".vscode-oss-dev","extensions","control.json"),j,te,ne,se,J,G,M,C,U),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const z=await this.fileService.readFile(h.URI.file(m.translationsConfigFile));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=Q}),define(oe[258],ae([0,1,49,6,38,3,2,22,14,28,10,18]),function(ie,e,T,O,l,A,_,k,P,S,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=e.ExtensionsLifecycle=class extends _.Disposable{constructor(p,b){super(),this.userDataProfilesService=p,this.logService=b,this.processesLimiter=new O.Limiter(5)}async postUninstall(p){const b=this.parseScript(p,"uninstall");b&&(this.logService.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(b.script,"uninstall",b.args,!0,p),this.logService.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(a){this.logService.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.logService.error(a)}}));try{await S.Promises.rm(this.getExtensionStoragePath(p))}catch(a){this.logService.error("Error while removing extension storage path",p.identifier.id),this.logService.error(a)}}parseScript(p,b){const a=`vscode:${b}`;if(p.location.scheme===k.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[a]=="string"){const h=p.manifest.scripts[a].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.logService.warn(p.identifier.id,p.manifest.version,`${a} should be a node script`),null):{script:(0,P.join)(p.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}runLifecycleHook(p,b,a,h,u){return new Promise((g,y)=>{const L=this.start(p,b,a,u);let n;const s=t=>{n&&(clearTimeout(n),n=null),t?y(t):g(void 0)};L.on("error",t=>{s((0,l.toErrorMessage)(t)||"Unknown")}),L.on("exit",(t,i)=>{s(t?`post-${b} process exited with code ${t}`:void 0)}),h&&(n=setTimeout(()=>{n=null,L.kill(),y("timed out")},5e3))})}start(p,b,a,h){const u={silent:!0,execArgv:void 0},g=(0,T.fork)(p,[`--type=extension-post-${b}`,...a],u);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const y=A.Event.fromNodeEventEmitter(g.stdout,"data"),L=A.Event.fromNodeEventEmitter(g.stderr,"data");y(t=>this.logService.info(h.identifier.id,h.manifest.version,`post-${b}`,t)),L(t=>this.logService.error(h.identifier.id,h.manifest.version,`post-${b}`,t));const n=A.Event.any(A.Event.map(y,t=>({data:`%c${t}`,format:[""]})),A.Event.map(L,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(h.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),g}getExtensionStoragePath(p){return(0,P.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=m=Se([Y(0,w.IUserDataProfilesService),Y(1,D.ILogService)],m)}),define(oe[259],ae([0,1,10,18,30,20,51,13,15,12]),function(ie,e,T,O,l,A,_,k,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let D=e.ExtensionsProfileScannerService=class extends _.AbstractExtensionsProfileScannerService{constructor(m,f,p,b,a,h){super(S.URI.file(m.extensionsPath),f,p,b,a,h)}};e.ExtensionsProfileScannerService=D=Se([Y(0,P.INativeEnvironmentService),Y(1,k.IFileService),Y(2,O.IUserDataProfilesService),Y(3,l.IUriIdentityService),Y(4,A.ITelemetryService),Y(5,T.ILogService)],D)}),define(oe[260],ae([0,1,12,15,51,80,13,5,10,25,30,18]),function(ie,e,T,O,l,A,_,k,P,S,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=e.ExtensionsScannerService=class extends A.NativeExtensionsScannerService{constructor(p,b,a,h,u,g,y,L){super(T.URI.file(u.builtinExtensionsPath),T.URI.file(u.extensionsPath),u.userHome,p.defaultProfile,p,b,a,h,u,g,y,L)}};e.ExtensionsScannerService=m=Se([Y(0,w.IUserDataProfilesService),Y(1,l.IExtensionsProfileScannerService),Y(2,_.IFileService),Y(3,P.ILogService),Y(4,O.INativeEnvironmentService),Y(5,S.IProductService),Y(6,D.IUriIdentityService),Y(7,k.IInstantiationService)],m)}),define(oe[19],ae([0,1,6,3,2,104,11,67,5,18]),function(ie,e,T,O,l,A,_,k,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,P.createDecorator)("storageService");var D;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(D||(e.WillSaveStateReason=D={}));var w;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var m;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function f(u){const g=u.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.loadKeyTargets=f;class p extends l.Disposable{constructor(g={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super(),this.options=g,this._onDidChangeValue=this._register(new O.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new l.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,l.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,y){if(y===e.TARGET_KEY){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:y,target:this.getKeyTargets(g)[y]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,y,L){return this.getStorage(y)?.get(g,L)}getBoolean(g,y,L){return this.getStorage(y)?.getBoolean(g,L)}getNumber(g,y,L){return this.getStorage(y)?.getNumber(g,L)}store(g,y,L,n){if((0,_.isUndefinedOrNull)(y)){this.remove(g,L);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,L,n),this.getStorage(L)?.set(g,y)})}remove(g,y){this.withPausedEmitters(()=>{this.updateKeyTarget(g,y,void 0),this.getStorage(y)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,y){const L=[],n=this.getKeyTargets(g);for(const s of Object.keys(n))n[s]===y&&L.push(s);return L}updateKeyTarget(g,y,L){const n=this.getKeyTargets(y);typeof L=="number"?n[g]!==L&&(n[g]=L,this.getStorage(y)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[g]=="number"&&(delete n[g],this.getStorage(y)?.set(e.TARGET_KEY,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const y=this.getStorage(g);return y?f(y):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=D.NONE){this._onWillSaveState.fire({reason:g});const y=this.getStorage(-1),L=this.getStorage(0),n=this.getStorage(1);switch(g){case D.NONE:await T.Promises.settled([y?.whenFlushed()??Promise.resolve(),L?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await T.Promises.settled([y?.flush(0)??Promise.resolve(),L?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,y=this.getStorage(0)?.items??new Map,L=this.getStorage(1)?.items??new Map;return h(g,y,L,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,y){return this.emitWillSaveState(D.NONE),(0,S.isUserDataProfile)(g)?this.switchToProfile(g,y):this.switchToWorkspace(g,y)}canSwitchProfile(g,y){return!(g.id===y.id||b(y)&&b(g))}switchData(g,y,L,n){this.withPausedEmitters(()=>{if(n)for(const[s,t]of g)y.set(s,t);else{const s=new Set;for(const[t,i]of g)s.add(t),y.get(t)!==i&&this.emitDidChangeValue(L,t);for(const[t]of y.items)s.has(t)||this.emitDidChangeValue(L,t)}})}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;function b(u){return u.isDefault||!!u.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=b;class a extends p{constructor(){super(),this.applicationStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(g){return!1}}e.InMemoryStorageService=a;async function h(u,g,y,L,n,s){const t=R=>{try{return JSON.parse(R)}catch{return R}},i=new Map,r=new Map;u.forEach((R,N)=>{i.set(N,R),r.set(N,t(R))});const o=new Map,c=new Map;g.forEach((R,N)=>{o.set(N,R),c.set(N,t(R))});const v=new Map,E=new Map;y.forEach((R,N)=>{v.set(N,R),E.set(N,t(R))}),console.group(L!==n?`Storage: Application (path: ${L})`:`Storage: Application & Profile (path: ${L}, default profile)`);const d=[];if(i.forEach((R,N)=>{d.push({key:N,value:R})}),console.table(d),console.groupEnd(),console.log(r),L!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const R=[];o.forEach((N,F)=>{R.push({key:F,value:N})}),console.table(R),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${s})`);const I=[];v.forEach((R,N)=>{I.push({key:N,value:R})}),console.table(I),console.groupEnd(),console.log(E)}e.logStorage=h}),define(oe[119],ae([0,1,3,2,11,29,33,19]),function(ie,e,T,O,l,A,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=e.GlobalExtensionEnablementService=class extends O.Disposable{constructor(w,m){super(),this._onDidChangeEnablement=new T.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new S(w)),this._register(this.storageManger.onDidChange(f=>this._onDidChangeEnablement.fire({extensions:f,source:"storage"}))),this._register(m.onDidInstallExtensions(f=>f.forEach(({local:p,operation:b})=>{p&&b===4&&this._removeFromDisabledExtensions(p.identifier)})))}async enableExtension(w,m){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:m}),!0):!1}async disableExtension(w,m){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){const m=this.getDisabledExtensions();return m.every(f=>!(0,_.areSameExtensions)(f,w))?(m.push(w),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(w){const m=this.getDisabledExtensions();for(let f=0;f<m.length;f++){const p=m[f];if((0,_.areSameExtensions)(p,w))return m.splice(f,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(w){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,m){this.storageManger.set(w,m,0)}};e.GlobalExtensionEnablementService=P=Se([Y(0,k.IStorageService),Y(1,A.IExtensionManagementService)],P);class S extends O.Disposable{constructor(w){super(),this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(w,m){let f;return m===0?((0,l.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,m)),f=this.storage[w]):f=this._get(w,m),JSON.parse(f)}set(w,m,f){const p=JSON.stringify(m.map(({id:a,uuid:h})=>({id:a,uuid:h})));this._get(w,f)!==p&&(f===0&&(m.length?this.storage[w]=p:delete this.storage[w]),this._set(w,m.length?p:void 0,f))}onDidStorageChange(w){if(w.scope===0&&!(0,l.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const f=this.get(w.key,w.scope);delete this.storage[w.key];const p=this.get(w.key,w.scope),b=f.filter(h=>!p.some(u=>(0,_.areSameExtensions)(h,u))),a=p.filter(h=>!f.some(u=>(0,_.areSameExtensions)(u,h)));(b.length||a.length)&&this._onDidChange.fire([...b,...a])}}_get(w,m){return this.storageService.get(w,m,"[]")}_set(w,m,f){m?this.storageService.store(w,m,f,1):this.storageService.remove(w,f)}}e.StorageManager=S}),define(oe[261],ae([0,1,21,26,9,4,36,11,12,17,15,29,33,68,13,10,25,58,230,19,20]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const L=A.isWeb?"web":(0,w.getTargetPlatform)(A.platform,_.arch),n="X-Market-Search-Activity-Id";var s;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function t(...M){return String(M.reduce((C,U)=>C|U,0))}var i;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},v={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class E{constructor(C=v){this.state=C}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(C,U=this.state.pageSize){return new E({...this.state,pageNumber:C,pageSize:U})}withFilter(C,...U){const z=[...this.state.criteria,...U.length?U.map(H=>({filterType:C,value:H})):[{filterType:C}]];return new E({...this.state,criteria:z})}withSortBy(C){return new E({...this.state,sortBy:C})}withSortOrder(C){return new E({...this.state,sortOrder:C})}withFlags(...C){return new E({...this.state,flags:C.reduce((U,z)=>U|z,0)})}withAssetTypes(...C){return new E({...this.state,assetTypes:C})}withSource(C){return new E({...this.state,source:C})}get raw(){const{criteria:C,pageNumber:U,pageSize:z,sortBy:H,sortOrder:V,flags:X,assetTypes:ee}=this.state;return{filters:[{criteria:C,pageNumber:U,pageSize:z,sortBy:H,sortOrder:V}],assetTypes:ee,flags:X}}get searchText(){const C=this.state.criteria.filter(U=>U.filterType===i.SearchText)[0];return C&&C.value?C.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(C=>String(C.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function d(M,C){const U=(M||[]).filter(z=>z.statisticName===C)[0];return U?U.value:0}function I(M){const C="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(z=>z.assetType.indexOf(C)===0).reduce((z,H)=>{const V=F(M,H.assetType);return V&&z.push([H.assetType.substring(C.length),V]),z},[])}function R(M){if(M.properties){const C=M.properties.filter(H=>H.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=C.filter(H=>U.test(H.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return F(M,r.Repository)}function N(M){return{uri:`${M.fallbackAssetUri}/${r.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${r.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function F(M,C){return M.files.filter(z=>z.assetType===C)[0]?{uri:`${M.assetUri}/${C}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${C}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function W(M,C){const U=M.properties?M.properties.filter(H=>H.key===C):[],z=U.length>0&&U[0].value;return z?z.split(",").map(H=>(0,m.adoptToGalleryExtensionId)(H)):[]}function q(M){const C=M.properties?M.properties.filter(U=>U.key===o.Engine):[];return C.length>0&&C[0].value||""}function B(M){const C=M.properties?M.properties.filter(U=>U.key===o.PreRelease):[];return C.length>0&&C[0].value==="true"}function Q(M){const C=M.properties?M.properties.filter(z=>z.key===o.LocalizedLanguages):[],U=C.length>0&&C[0].value||"";return U?U.split(","):[]}function Z(M){return M.properties?.find(C=>C.key===o.SponsorLink)?.value}function K(M){return M.indexOf("preview")!==-1}function x(M){return M.targetPlatform?(0,w.toTargetPlatform)(M.targetPlatform):"undefined"}function $(M){const C=(0,T.distinct)(M.versions.map(x)),U=!!M.tags?.includes(w.WEB_EXTENSION_TAG),z=C.indexOf("web");return U?z===-1&&C.push("web"):z!==-1&&C.splice(z,1),C}function j(M,C){const U=(0,w.getFallbackTargetPlarforms)(C);for(let z=0;z<M.length;z++){const H=M[z];if(H.version===M[z-1]?.version){let V=z;const X=x(H);if(X===C)for(;V>0&&M[V-1].version===H.version;)V--;else if(U.includes(X))for(;V>0&&M[V-1].version===H.version&&x(M[V-1])!==C;)V--;V!==z&&(M.splice(z,1),M.splice(V,0,H))}}return M}e.sortExtensionVersions=j;function te(M,C,U){M.telemetryData={index:C,querySource:U,queryActivityId:M.queryContext?.[n]}}function ne(M,C,U,z){const H=M.versions[0],V={manifest:F(C,r.Manifest),readme:F(C,r.Details),changelog:F(C,r.Changelog),license:F(C,r.License),repository:R(C),download:N(C),icon:F(C,r.Icon),signature:F(C,r.Signature),coreTranslations:I(C)};return{identifier:{id:(0,m.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:C.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,publisherSponsorLink:Z(H),description:M.shortDescription||"",installCount:d(M.statistics,"install"),rating:d(M.statistics,"averagerating"),ratingCount:d(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:U,assets:V,properties:{dependencies:W(C,o.Dependency),extensionPack:W(C,o.ExtensionPack),engine:q(C),localizedLanguages:Q(C),targetPlatform:x(C),isPreReleaseVersion:B(C)},hasPreReleaseVersion:B(H),hasReleaseVersion:!0,preview:K(M.flags),isSigned:!!V.signature,queryContext:z}}let se=class{constructor(C,U,z,H,V,X,ee,ce){this.requestService=U,this.logService=z,this.environmentService=H,this.telemetryService=V,this.fileService=X,this.productService=ee,this.configurationService=ce;const ue=ee.extensionsGallery,fe=ue?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=fe?ue.servicePPEUrl:ue?.serviceUrl,this.extensionsGallerySearchUrl=fe?void 0:ue?.searchUrl,this.extensionsControlUrl=ue?.controlUrl,this.commonHeadersPromise=(0,u.resolveMarketplaceHeaders)(ee.version,ee,this.environmentService,this.configurationService,this.fileService,C,this.telemetryService)}api(C=""){return`${this.extensionsGalleryUrl}${C}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(C,U,z){const H=O.CancellationToken.isCancellationToken(U)?{}:U,V=O.CancellationToken.isCancellationToken(U)?U:z,X=[],ee=[],ce=[],ue=[];let fe=!0;for(const be of C){be.uuid?ee.push(be.uuid):X.push(be.id);const De=!!(be.version||be.preRelease);ce.push({id:be.id,uuid:be.uuid,includePreRelease:De}),be.version&&ue.push({id:be.id,uuid:be.uuid,version:be.version}),fe=fe&&!!be.hasPreRelease&&!De}if(!ee.length&&!X.length)return[];let ve=new E().withPage(1,C.length);ee.length&&(ve=ve.withFilter(i.ExtensionId,...ee)),X.length&&(ve=ve.withFilter(i.ExtensionName,...X)),(H.queryAllVersions||fe)&&(ve=ve.withFlags(ve.flags,s.IncludeVersions)),H.source&&(ve=ve.withSource(H.source));const{extensions:ye}=await this.queryGalleryExtensions(ve,{targetPlatform:H.targetPlatform??L,includePreRelease:ce,versions:ue,compatible:!!H.compatible},V);return H.source&&ye.forEach((be,De)=>te(be,De,H.source)),ye}async getCompatibleExtension(C,U,z){if((0,w.isNotWebExtensionInWebTargetPlatform)(C.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(C,U,z))return C;const H=new E().withFlags(s.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,C.identifier.uuid),{extensions:V}=await this.queryGalleryExtensions(H,{targetPlatform:z,compatible:!0,includePreRelease:U},O.CancellationToken.None);return V[0]||null}async isExtensionCompatible(C,U,z){if(!(0,w.isTargetPlatformCompatible)(C.properties.targetPlatform,C.allTargetPlatforms,z)||!U&&C.properties.isPreReleaseVersion)return!1;let H=C.properties.engine;if(!H){const V=await this.getManifest(C,O.CancellationToken.None);if(!V)throw new Error("Manifest was not found");H=V.engines.vscode}return(0,f.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(C,U,z,H,V){if(!(0,w.isTargetPlatformCompatible)(x(C),H,V)||U!=="any"&&B(C)!==(U==="prerelease"))return!1;if(z)try{const X=await this.getEngine(C);if(!(0,f.isEngineValid)(X,this.productService.version,this.productService.date))return!1}catch(X){return this.logService.error(`Error while getting the engine for the version ${C.version}.`,(0,l.getErrorMessage)(X)),!1}return!0}async query(C,U){let z=C.text||"";const H=C.pageSize??50;let V=new E().withPage(1,H);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ve,ye)=>(V=V.withFilter(i.Category,ye||ve),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ve,ye)=>(V=V.withFilter(i.Tag,ye||ve),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(V=V.withFilter(i.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),V=V.withFilter(i.SearchText,z)),V=V.withSortBy(0)):C.ids?V=V.withFilter(i.ExtensionId,...C.ids):C.names?V=V.withFilter(i.ExtensionName,...C.names):V=V.withSortBy(4),typeof C.sortBy=="number"&&(V=V.withSortBy(C.sortBy)),typeof C.sortOrder=="number"&&(V=V.withSortOrder(C.sortOrder)),C.source&&(V=V.withSource(C.source));const X=async(fe,ve)=>{const{extensions:ye,total:be}=await this.queryGalleryExtensions(fe,{targetPlatform:L,compatible:!1,includePreRelease:!!C.includePreRelease},ve);return ye.forEach((De,ke)=>te(De,(fe.pageNumber-1)*fe.pageSize+ke,C.source)),{extensions:ye,total:be}},{extensions:ee,total:ce}=await X(V,U),ue=async(fe,ve)=>{if(ve.isCancellationRequested)throw new l.CancellationError;const{extensions:ye}=await X(V.withPage(fe+1),ve);return ye};return{firstPage:ee,total:ce,pageSize:V.pageSize,getPage:ue}}async queryGalleryExtensions(C,U,z){const H=C.flags;C.flags&s.IncludeLatestVersionOnly&&C.flags&s.IncludeVersions&&(C=C.withFlags(C.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(C.flags&s.IncludeLatestVersionOnly)&&!(C.flags&s.IncludeVersions)&&(C=C.withFlags(C.flags,s.IncludeLatestVersionOnly)),U.versions?.length&&(C=C.withFlags(C.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),C=C.withFlags(C.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:V,total:X,context:ee}=await this.queryRawGalleryExtensions(C,z);if(!(C.flags&s.IncludeLatestVersionOnly)){const ve=[];for(const ye of V){const be=await this.toGalleryExtensionWithCriteria(ye,U,ee);be&&ve.push(be)}return{extensions:ve,total:X}}const ue=[],fe=new Map;for(let ve=0;ve<V.length;ve++){const ye=V[ve],be={id:(0,m.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},De=(0,k.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(We=>(0,m.areSameExtensions)(We,be))?.includePreRelease;if(U.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)($(ye),U.targetPlatform))continue;const ke=await this.toGalleryExtensionWithCriteria(ye,U,ee);!ke||ke.properties.isPreReleaseVersion&&(!De||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==U.targetPlatform&&ke.hasPreReleaseVersion?fe.set(ye.extensionId,ve):ue.push([ve,ke])}if(fe.size){const ve=new Date().getTime(),ye=new E().withFlags(H&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,fe.size).withFilter(i.ExtensionId,...fe.keys()),{extensions:be}=await this.queryGalleryExtensions(ye,U,z);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ve,count:fe.size});for(const De of be){const ke=fe.get(De.identifier.uuid);ue.push([ke,De])}}return{extensions:ue.sort((ve,ye)=>ve[0]-ye[0]).map(([,ve])=>ve),total:X}}async toGalleryExtensionWithCriteria(C,U,z){const H={id:(0,m.getGalleryExtensionId)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},V=U.versions?.find(ue=>(0,m.areSameExtensions)(ue,H))?.version,X=(0,k.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ue=>(0,m.areSameExtensions)(ue,H))?.includePreRelease,ee=$(C),ce=j(C.versions,U.targetPlatform);if(U.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(ee,U.targetPlatform))return null;for(let ue=0;ue<ce.length;ue++){const fe=ce[ue];if(!(V&&fe.version!==V)){if(await this.isValidVersion(fe,X?"any":"release",U.compatible,ee,U.targetPlatform))return ne(C,fe,ee,z);if(V&&fe.version===V)return null}}return V||U.compatible?null:ne(C,C.versions[0],ee)}async queryRawGalleryExtensions(C,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");C=C.withFlags(C.flags,s.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,t(s.Unpublished));const z=await this.commonHeadersPromise,H=JSON.stringify(C.raw),V={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},X=new Date().getTime();let ee,ce,ue=0;try{if(ee=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&C.criteria.some(ve=>ve.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:H,headers:V},U),ee.res.statusCode&&ee.res.statusCode>=400&&ee.res.statusCode<500)return{galleryExtensions:[],total:ue};const fe=await(0,h.asJson)(ee);if(fe){const ve=fe.results[0],ye=ve.extensions,be=ve.resultMetadata&&ve.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return ue=be&&be.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ue,context:{[n]:ee.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(fe){throw ce=fe,fe}finally{this.telemetryService.publicLog2("galleryService:query",{...C.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-X,success:!!ee&&(0,h.isSuccess)(ee),responseBodySize:ee?.res.headers["Content-Length"],statusCode:ee?String(ee.res.statusCode):void 0,errorCode:ce?(0,l.isCancellationError)(ce)?"canceled":(0,l.getErrorMessage)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(C,U,z,H){if(!this.isEnabled())return;const V=A.isWeb?this.api(`/itemName/${C}.${U}/version/${z}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${C}/extensions/${U}/${z}/stats?statType=${H}`),X=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.commonHeadersPromise,Accept:X};try{await this.requestService.request({type:"POST",url:V,headers:ce},O.CancellationToken.None)}catch{}}async download(C,U,z){this.logService.trace("ExtensionGalleryService#download",C.identifier.id);const H=(0,m.getGalleryExtensionTelemetryData)(C),V=new Date().getTime(),X=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:ve}),ee=z===2?"install":z===3?"update":"",ce=ee?{uri:`${C.assets.download.uri}${P.URI.parse(C.assets.download.uri).query?"&":"?"}${ee}=true`,fallbackUri:`${C.assets.download.fallbackUri}${P.URI.parse(C.assets.download.fallbackUri).query?"&":"?"}${ee}=true`}:C.assets.download,ue=C.queryContext?.[n]?{[n]:C.queryContext[n]}:void 0,fe=await this.getAsset(ce,ue?{headers:ue}:void 0);await this.fileService.writeFile(U,fe.stream),X(new Date().getTime()-V)}async downloadSignatureArchive(C,U){if(!C.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",C.identifier.id);const z=await this.getAsset(C.assets.signature);await this.fileService.writeFile(U,z.stream)}async getReadme(C,U){if(C.assets.readme){const z=await this.getAsset(C.assets.readme,{},U);return await(0,h.asTextOrError)(z)||""}return""}async getManifest(C,U){if(C.assets.manifest){const z=await this.getAsset(C.assets.manifest,{},U),H=await(0,h.asTextOrError)(z);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(C,U){const z=F(C,r.Manifest);if(!z)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},V=await this.getAsset(z,{headers:H});return await(0,h.asJson)(V)}async getCoreTranslation(C,U){const z=C.assets.coreTranslations.filter(H=>H[0]===U.toUpperCase())[0];if(z){const H=await this.getAsset(z[1]),V=await(0,h.asTextOrError)(H);return V?JSON.parse(V):null}return null}async getChangelog(C,U){if(C.assets.changelog){const z=await this.getAsset(C.assets.changelog,{},U);return await(0,h.asTextOrError)(z)||""}return""}async getAllCompatibleVersions(C,U,z){let H=new E().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);C.identifier.uuid?H=H.withFilter(i.ExtensionId,C.identifier.uuid):H=H.withFilter(i.ExtensionName,C.identifier.id);const{galleryExtensions:V}=await this.queryRawGalleryExtensions(H,O.CancellationToken.None);if(!V.length)return[];const X=$(V[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(X,z))return[];const ee=[];await Promise.all(V[0].versions.map(async fe=>{try{await this.isValidVersion(fe,U?"any":"release",!0,X,z)&&ee.push(fe)}catch{}}));const ce=[],ue=new Set;for(const fe of j(ee,z))ue.has(fe.version)||(ue.add(fe.version),ce.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:B(fe)}));return ce}async getAsset(C,U={},z=O.CancellationToken.None){const H=await this.commonHeadersPromise,V={type:"GET"},X={...H,...U.headers||{}};U={...U,...V,headers:X};const ee=C.uri,ce=C.fallbackUri,ue={...U,url:ee};try{const fe=await this.requestService.request(ue,z);if(fe.res.statusCode===200)return fe;const ve=await(0,h.asTextOrError)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${ve}`)}catch(fe){if((0,l.isCancellationError)(fe))throw fe;const ve=(0,l.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ee,message:ve});const ye={...U,url:ce};return this.requestService.request(ye,z)}}async getEngine(C){let U=q(C);if(!U){const z=await this.getManifestFromRawExtensionVersion(C,O.CancellationToken.None);if(!z)throw new Error("Manifest was not found");U=z.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const C=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,h.asJson)(C),z=[],H={};if(U){for(const V of U.malicious)z.push({id:V});if(U.migrateToPreRelease)for(const[V,X]of Object.entries(U.migrateToPreRelease))(!X.engine||(0,f.isEngineValid)(X.engine,this.productService.version,this.productService.date))&&(H[V.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[V,X]of Object.entries(U.deprecated))X&&(H[V.toLowerCase()]=(0,k.isBoolean)(X)?{}:X)}return{malicious:z,deprecated:H}}};se=Se([Y(1,h.IRequestService),Y(2,b.ILogService),Y(3,D.IEnvironmentService),Y(4,y.ITelemetryService),Y(5,p.IFileService),Y(6,a.IProductService),Y(7,S.IConfigurationService)],se);let J=e.ExtensionGalleryService=class extends se{constructor(C,U,z,H,V,X,ee,ce){super(C,U,z,H,V,X,ee,ce)}};e.ExtensionGalleryService=J=Se([Y(0,g.IStorageService),Y(1,h.IRequestService),Y(2,b.ILogService),Y(3,D.IEnvironmentService),Y(4,y.ITelemetryService),Y(5,p.IFileService),Y(6,a.IProductService),Y(7,S.IConfigurationService)],J);let G=e.ExtensionGalleryServiceWithNoStorageService=class extends se{constructor(C,U,z,H,V,X,ee){super(void 0,C,U,z,H,V,X,ee)}};e.ExtensionGalleryServiceWithNoStorageService=G=Se([Y(0,h.IRequestService),Y(1,b.ILogService),Y(2,D.IEnvironmentService),Y(3,y.ITelemetryService),Y(4,p.IFileService),Y(5,a.IProductService),Y(6,S.IConfigurationService)],G)}),define(oe[81],ae([0,1,5,3,2,19,33,25,21,10,11]),function(ie,e,T,O,l,A,_,k,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,T.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=e.ExtensionStorageService=class Qe extends l.Disposable{static toKey(p){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(p.id)}@${p.version}`}static fromKey(p){const b=w.exec(p);if(b&&b[1])return{id:b[1],version:b[2]}}static async removeOutdatedExtensionVersions(p,b){const a=await p.getInstalled(),h=[];for(const[u,g]of Qe.readAllExtensionsWithKeysForSync(b)){const y=a.find(L=>(0,_.areSameExtensions)(L.identifier,{id:u}))?.manifest.version;for(const L of g)y!==L&&h.push(Qe.toKey({id:u,version:L}))}for(const u of h)b.remove(u,0)}static readAllExtensionsWithKeysForSync(p){const b=new Map,a=p.keys(0,1);for(const h of a){const u=Qe.fromKey(h);if(u){let g=b.get(u.id.toLowerCase());g||b.set(u.id.toLowerCase(),g=[]),g.push(u.version)}}return b}constructor(p,b,a){super(),this.storageService=p,this.productService=b,this.logService=a,this._onDidChangeExtensionStorageToSync=this._register(new O.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Qe.readAllExtensionsWithKeysForSync(p),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}onDidChangeStorageValue(p){if(p.scope!==0)return;if(this.extensionsWithKeysForSync.has(p.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const b=Qe.fromKey(p.key);if(b){if(this.storageService.get(p.key,0)===void 0)this.extensionsWithKeysForSync.delete(b.id.toLowerCase());else{let a=this.extensionsWithKeysForSync.get(b.id.toLowerCase());a||this.extensionsWithKeysForSync.set(b.id.toLowerCase(),a=[]),a.push(b.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(p){if((0,D.isString)(p))return p;const b=p.manifest?p.manifest.publisher:p.publisher,a=p.manifest?p.manifest.name:p.name;return(0,_.getExtensionId)(b,a)}getExtensionState(p,b){const a=this.getExtensionId(p),h=this.getExtensionStateRaw(p,b);if(h)try{return JSON.parse(h)}catch(u){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${a}, global: ${b}): ${u}`)}}getExtensionStateRaw(p,b){const a=this.getExtensionId(p),h=this.storageService.get(a,b?0:1);return h&&h?.length>Qe.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${a}, global: ${b}): ${h.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),h}setExtensionState(p,b,a){const h=this.getExtensionId(p);b===void 0?this.storageService.remove(h,a?0:1):this.storageService.store(h,JSON.stringify(b),a?0:1,1)}setKeysForSync(p,b){this.storageService.store(Qe.toKey(p),JSON.stringify(b),0,1)}getKeysForSync(p){const b=this.productService.extensionSyncedKeys?.[p.id.toLowerCase()],a=this.storageService.get(Qe.toKey(p),0),h=a?JSON.parse(a):void 0;return h&&b?(0,P.distinct)([...h,...b]):h||b}addToMigrationList(p,b){if(p!==b){const a=this.migrationList.filter(h=>!h.includes(p)&&!h.includes(b));a.push([p,b]),this.migrationList=a}}getSourceExtensionToMigrate(p){const b=this.migrationList.find(([,a])=>p===a);return b?b[0]:void 0}get migrationList(){const p=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const b=JSON.parse(p);if(Array.isArray(b))return b}catch{}return[]}set migrationList(p){p.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};m.LARGE_STATE_WARNING_THRESHOLD=512*1024,e.ExtensionStorageService=m=Se([Y(0,A.IStorageService),Y(1,k.IProductService),Y(2,S.ILogService)],m)}),define(oe[262],ae([0,1,29,13,25,15,102,56,19,20,227]),function(ie,e,T,O,l,A,_,k,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let w=e.ExtensionTipsService=class extends D.AbstractNativeExtensionTipsService{constructor(f,p,b,a,h,u,g,y){super(f.userHome,h,p,b,a,u,g,y)}};e.ExtensionTipsService=w=Se([Y(0,A.INativeEnvironmentService),Y(1,S.ITelemetryService),Y(2,T.IExtensionManagementService),Y(3,P.IStorageService),Y(4,k.INativeHostService),Y(5,_.IExtensionRecommendationNotificationService),Y(6,O.IFileService),Y(7,l.IProductService)],w)}),define(oe[263],ae([0,1,109,3,20,15,2,10,14,49,25,4,6,105,17,169,34,19,11]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const g=[T.CONFIGURATION_KEY_HOST_NAME,T.CONFIGURATION_KEY_PREVENT_SLEEP],y="remoteTunnelSession";let L=e.RemoteTunnelService=class extends _.Disposable{constructor(t,i,r,o,c,v,E){super(),this.telemetryService=t,this.productService=i,this.environmentService=r,this.configurationService=v,this.storageService=E,this._onDidTokenFailedEmitter=new O.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new O.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeSessionEmitter=new O.Emitter,this.onDidChangeSession=this._onDidChangeSessionEmitter.event,this._initialized=!1,this._logger=this._register(o.createLogger(T.LOG_ID,{name:T.LOGGER_NAME})),this._startTunnelProcessDelayer=new m.Delayer(100),this._register(this._logger.onDidChangeLogLevel(d=>this._logger.info("Log level changed to "+(0,k.LogLevelToString)(d)))),this._register(c.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(v.onDidChangeConfiguration(d=>{g.some(I=>d.affectsConfiguration(I))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._session=this._restoreSession(),this._tunnelStatus=T.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(t){this._tunnelStatus=t,this._onDidChangeTunnelStatusEmitter.fire(t)}setSession(t){n(t,this._session)||(this._session=t,this._onDidChangeSessionEmitter.fire(t),this._storeSession(t),t?(this._logger.info(`Session updated: ${t.accountLabel} (${t.providerId})`),t.token&&this._logger.info(`Session token updated: ${t.accountLabel} (${t.providerId})`)):this._logger.info("Session reset"))}async getSession(){return this._session}async initialize(t){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setSession(t);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(i){this._logger.error(i)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let t;w.isMacintosh?t=this.environmentService.appRoot:t=(0,P.dirname)((0,P.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,P.join)(t,"bin",`${this.productService.tunnelApplicationName}${w.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(t){if(n(t,this._session))return this._tunnelStatus;this.setSession(t);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(i){this._logger.error(i)}return this._tunnelStatus}async stopTunnel(){this.setSession(void 0),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);const t=(i,r)=>{r?this._logger.error(i):this._logger.info(i)};try{await this.runCodeTunneCommand("stop",["kill"],t)}catch(i){this._logger.error(i)}this.setTunnelStatus(T.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:!!this._session}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let t=!1;const i=(d,I)=>{I?this._logger.error(d):this._logger.info(d),!this.environmentService.isBuilt&&d.startsWith("   Compiling")&&this.setTunnelStatus(T.TunnelStates.connecting((0,b.localize)(0,null)))},r=this.runCodeTunneCommand("status",["status"],i);this._tunnelProcess=r;try{const d=await r;if(this._tunnelProcess!==r)return;if(t=d===0,this._logger.info(t?"Other tunnel running, attaching...":"No other tunnel running"),!t&&!this._session){this._tunnelProcess=void 0,this.setTunnelStatus(T.TunnelStates.disconnected());return}}catch(d){this._logger.error(d),this._tunnelProcess=void 0,this.setTunnelStatus(T.TunnelStates.disconnected());return}const o=this._session;if(o&&o.token){const d=o.token;this.setTunnelStatus(T.TunnelStates.connecting((0,b.localize)(1,null,o.accountLabel,o.providerId)));const I=(N,F)=>{N=N.replaceAll(d,"*".repeat(4)),i(N,F)},R=this.runCodeTunneCommand("login",["user","login","--provider",o.providerId,"--access-token",d,"--log",(0,k.LogLevelToString)(this._logger.getLevel())],I);this._tunnelProcess=R;try{if(await R,this._tunnelProcess!==R)return}catch(N){this._logger.error(N),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(o),this.setTunnelStatus(T.TunnelStates.disconnected(o));return}}const c=this._getTunnelName();c?this.setTunnelStatus(T.TunnelStates.connecting((0,b.localize)(2,null,c))):this.setTunnelStatus(T.TunnelStates.connecting((0,b.localize)(3,null)));const v=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,k.LogLevelToString)(this._logger.getLevel())];c?v.push("--name",c):v.push("--random-name"),this._preventSleep()&&v.push("--no-sleep");const E=this.runCodeTunneCommand("tunnel",v,(d,I)=>{I?this._logger.error(d):this._logger.info(d);const R=d.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(R){const N={link:R[1],domain:R[2],tunnelName:R[4],isAttached:t};this.setTunnelStatus(T.TunnelStates.connected(N))}else d.match(/error refreshing token/)&&(E.cancel(),this._onDidTokenFailedEmitter.fire(o),this.setTunnelStatus(T.TunnelStates.disconnected(o)))});this._tunnelProcess=E,E.finally(()=>{E===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._session=void 0,this.setTunnelStatus(T.TunnelStates.disconnected()))})}runCodeTunneCommand(t,i,r=()=>{}){return(0,m.createCancelablePromise)(o=>new Promise((c,v)=>{o.isCancellationRequested&&c(-1);let E;if(o.onCancellationRequested(()=>{E&&(this._logger.info(`${t} terminating(${E.pid})`),E.kill())}),!this.environmentService.isBuilt)r("Building tunnel CLI from sources and run",!1),r(`${t} Spawning: cargo run -- tunnel ${i.join(" ")}`,!1),E=(0,S.spawn)("cargo",["run","--","tunnel",...i],{cwd:(0,P.join)(this.environmentService.appRoot,"cli")});else{r("Running tunnel CLI",!1);const d=this.getTunnelCommandLocation();r(`${t} Spawning: ${d} tunnel ${i.join(" ")}`,!1),E=(0,S.spawn)(d,["tunnel",...i],{cwd:(0,a.homedir)()})}E.stdout.on("data",d=>{if(E){const I=d.toString();r(I,!1)}}),E.stderr.on("data",d=>{if(E){const I=d.toString();r(I,!0)}}),E.on("exit",d=>{E&&(r(`${t} exit(${E.pid}): + ${d} `,!1),E=void 0,c(d||0))}),E.on("error",d=>{E&&(r(`${t} error(${E.pid}): + ${d} `,!0),E=void 0,v())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(T.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let t=this.configurationService.getValue(T.CONFIGURATION_KEY_HOST_NAME)||(0,a.hostname)();return t=t.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),t||void 0}_restoreSession(){try{const t=this.storageService.get(y,-1);if(t){const i=JSON.parse(t);if(i&&(0,u.isString)(i.accountLabel)&&(0,u.isString)(i.sessionId)&&(0,u.isString)(i.providerId))return i;this._logger.error("Problems restoring session from storage, invalid format",i)}}catch(t){this._logger.error("Problems restoring session from storage",t)}}_storeSession(t){if(t){const i={providerId:t.providerId,sessionId:t.sessionId,accountLabel:t.accountLabel};this.storageService.store(y,JSON.stringify(i),-1,1)}else this.storageService.remove(y,-1)}};e.RemoteTunnelService=L=Se([Y(0,l.ITelemetryService),Y(1,D.IProductService),Y(2,A.INativeEnvironmentService),Y(3,k.ILoggerService),Y(4,f.ISharedProcessLifecycleService),Y(5,p.IConfigurationService),Y(6,h.IStorageService)],L);function n(s,t){return s&&t?s.sessionId===t.sessionId&&s.providerId===t.providerId&&s.token===t.token:s===t}}),define(oe[264],ae([0,1,6,2,23,67,19,77,18]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class S extends _.AbstractStorageService{constructor(w,m,f,p){super(),this.initialWorkspace=w,this.initialProfiles=m,this.remoteService=f,this.environmentService=p,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new O.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new O.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const w=this._register(new k.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),m=this._register(new A.Storage(w));return this._register(m.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f))),m}createProfileStorage(w){this.profileStorageDisposables.clear(),this.profileStorageProfile=w;let m;if((0,_.isProfileUsingDefaultStorage)(w))m=this.applicationStorage;else{const f=this.profileStorageDisposables.add(new k.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),w));m=this.profileStorageDisposables.add(new A.Storage(f))}return this.profileStorageDisposables.add(m.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),m}createWorkspaceStorage(w){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=w?.id;let m;if(w){const f=this.workspaceStorageDisposables.add(new k.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),w));m=this.workspaceStorageDisposables.add(new A.Storage(f)),this.workspaceStorageDisposables.add(m.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)))}return m}async doInitialize(){await T.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(w){switch(w){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(w){switch(w){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,l.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(_.WillSaveStateReason.SHUTDOWN),await T.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(w,m){if(!this.canSwitchProfile(this.profileStorageProfile,w))return;const f=this.profileStorage,p=f.items;f!==this.applicationStorage&&await f.close(),this.profileStorage=this.createProfileStorage(w),await this.profileStorage.init(),this.switchData(p,this.profileStorage,0,m)}async switchToWorkspace(w,m){const f=this.workspaceStorage,p=f?.items??new Map;await f?.close(),this.workspaceStorage=this.createWorkspaceStorage(w),await this.workspaceStorage.init(),this.switchData(p,this.workspaceStorage,1,m)}hasScope(w){return(0,P.isUserDataProfile)(w)?this.profileStorageProfile.id===w.id:this.workspaceStorageId===w.id}}e.RemoteStorageService=S}),define(oe[265],ae([0,1,3,2,18,93]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class _{constructor(S,D){this.service=S,this.getUriTransformer=D}listen(S,D){const w=this.getUriTransformer(S);switch(D){case"onDidChangeProfiles":return T.Event.map(this.service.onDidChangeProfiles,m=>({all:m.all.map(f=>(0,A.transformOutgoingURIs)({...f},w)),added:m.added.map(f=>(0,A.transformOutgoingURIs)({...f},w)),removed:m.removed.map(f=>(0,A.transformOutgoingURIs)({...f},w)),updated:m.updated.map(f=>(0,A.transformOutgoingURIs)({...f},w))}))}throw new Error(`Invalid listen ${D}`)}async call(S,D,w){const m=this.getUriTransformer(S);switch(D){case"createProfile":{const f=await this.service.createProfile(w[0],w[1],w[2]);return(0,A.transformOutgoingURIs)({...f},m)}case"updateProfile":{let f=(0,l.reviveProfile)((0,A.transformIncomingURIs)(w[0],m),this.service.profilesHome.scheme);return f=await this.service.updateProfile(f,w[1]),(0,A.transformOutgoingURIs)({...f},m)}case"removeProfile":{const f=(0,l.reviveProfile)((0,A.transformIncomingURIs)(w[0],m),this.service.profilesHome.scheme);return this.service.removeProfile(f)}}throw new Error(`Invalid call ${D}`)}}e.RemoteUserDataProfilesServiceChannel=_;class k extends O.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(S,D,w){super(),this.profilesHome=D,this.channel=w,this._profiles=[],this._onDidChangeProfiles=this._register(new T.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=S.map(m=>(0,l.reviveProfile)(m,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(m=>{const f=m.added.map(a=>(0,l.reviveProfile)(a,this.profilesHome.scheme)),p=m.removed.map(a=>(0,l.reviveProfile)(a,this.profilesHome.scheme)),b=m.updated.map(a=>(0,l.reviveProfile)(a,this.profilesHome.scheme));this._profiles=m.all.map(a=>(0,l.reviveProfile)(a,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:f,removed:p,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(S){this.enabled=S}isEnabled(){return this.enabled}async createNamedProfile(S,D,w){const m=await this.channel.call("createNamedProfile",[S,D,w]);return(0,l.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(S,D,w,m){const f=await this.channel.call("createProfile",[S,D,w,m]);return(0,l.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(S){const D=await this.channel.call("createTransientProfile",[S]);return(0,l.reviveProfile)(D,this.profilesHome.scheme)}async setProfileForWorkspace(S,D){await this.channel.call("setProfileForWorkspace",[S,D])}removeProfile(S){return this.channel.call("removeProfile",[S])}async updateProfile(S,D){const w=await this.channel.call("updateProfile",[S,D]);return(0,l.reviveProfile)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=k}),define(oe[60],ae([0,1,2,67,5,19,3,77,18]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,l.createDecorator)("IUserDataProfileStorageService");let S=e.AbstractUserDataProfileStorageService=class extends T.Disposable{constructor(f){super(),this.storageService=f}async readStorageData(f){return this.withProfileScopedStorageService(f,async p=>this.getItems(p))}async updateStorageData(f,p,b){return this.withProfileScopedStorageService(f,async a=>this.writeItems(a,p,b))}async withProfileScopedStorageService(f,p){if(this.storageService.hasScope(f))return p(this.storageService);const b=await this.createStorageDatabase(f),a=new w(b);try{await a.initialize();const h=await p(a);return await a.flush(),h}finally{a.dispose(),await this.closeAndDispose(b)}}getItems(f){const p=new Map,b=a=>{for(const h of f.keys(0,a))p.set(h,{value:f.get(h,0),target:a})};return b(0),b(1),p}writeItems(f,p,b){for(const[a,h]of p)f.store(a,h,0,b)}async closeAndDispose(f){try{await f.close()}finally{(0,T.isDisposable)(f)&&f.dispose()}}};e.AbstractUserDataProfileStorageService=S=Se([Y(0,A.IStorageService)],S);class D extends S{constructor(f,p,b,a){super(b),this.remoteService=f;const h=f.getChannel("profileStorageListener"),u=this._register(new T.MutableDisposable);this._onDidChange=this._register(new _.Emitter({onWillAddFirstListener:()=>{u.value=h.listen("onDidChange")(g=>{a.trace("profile storage changes",g),this._onDidChange.fire({targetChanges:g.targetChanges.map(y=>(0,P.reviveProfile)(y,p.profilesHome.scheme)),valueChanges:g.valueChanges.map(y=>({...y,profile:(0,P.reviveProfile)(y.profile,p.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(f){const p=this.remoteService.getChannel("storage");return(0,A.isProfileUsingDefaultStorage)(f)?new k.ApplicationStorageDatabaseClient(p):new k.ProfileStorageDatabaseClient(p,f)}}e.RemoteUserDataProfileStorageService=D;class w extends A.AbstractStorageService{constructor(f){super({flushInterval:100}),this.profileStorage=this._register(new O.Storage(f))}doInitialize(){return this.profileStorage.init()}getStorage(f){return f===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(oe[266],ae([0,1,19,10,18,73,60]),function(ie,e,T,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let k=e.NativeUserDataProfileStorageService=class extends _.RemoteUserDataProfileStorageService{constructor(S,D,w,m){super(S,D,w,m)}};e.NativeUserDataProfileStorageService=k=Se([Y(0,A.IMainProcessService),Y(1,l.IUserDataProfilesService),Y(2,T.IStorageService),Y(3,O.ILogService)],k)}),define(oe[40],ae([0,1,21,6,16,26,3,35,2,27,11,177,17,15,13,10,44,19,20,30,24,18]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||s(v.syncData)))}e.isRemoteUserData=n;function s(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.isSyncData=s;function t(v,E){return`${(0,S.uppercaseFirstLetter)(v)}${E.isDefault?"":` (${E.name})`}`}e.getSyncResourceLogLabel=t;let i=e.AbstractSynchroniser=class extends P.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(E,d,I,R,N,F,W,q,B,Q,Z,K){super(),this.syncResource=E,this.collection=d,this.fileService=I,this.environmentService=R,this.storageService=N,this.userDataSyncStoreService=F,this.userDataSyncBackupStoreService=W,this.userDataSyncEnablementService=q,this.telemetryService=B,this.logService=Q,this.configurationService=Z,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new O.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=t(E.syncResource,E.profile),this.extUri=K.extUri,this.syncFolder=this.extUri.joinPath(R.userDataSyncHome,...(0,y.getPathSegments)(E.profile.isDefault?void 0:E.profile.id,E.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,y.PREVIEW_DIR_NAME),this.lastSyncResource=(0,y.getLastSyncResourceUri)(E.profile.isDefault?void 0:E.profile.id,E.syncResource,R,this.extUri),this.currentMachineIdPromise=(0,a.getServiceMachineId)(R,I,N)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const E=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(E.remoteUserData,E.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const E=await this.getLastSyncUserData();(E?await this.hasRemoteChanged(E):!0)&&this._onDidChangeLocal.fire()}}setStatus(E){this._status!==E&&(this._status=E,this._onDidChangStatus.fire(E))}async sync(E,d={}){await this._sync(E,!0,this.getUserDataSyncConfiguration(),d)}async preview(E,d,I={}){return this._sync(E,!1,d,I)}async apply(E,d={}){try{this.syncHeaders={...d};const I=await this.doApply(E);return this.setStatus(I),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(E,d,I,R){try{if(this.syncHeaders={...R},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let N="idle";try{const F=await this.getLastSyncUserData(),W=await this.getLatestRemoteUserData(E,F);return N=await this.performSync(W,F,d,I),N==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(N)}}finally{this.syncHeaders={}}}async replace(E){const d=this.parseSyncData(E);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),R=await this.getLatestRemoteUserData(null,I),N=await this.isRemoteDataFromCurrentMachine(R),F=await this.generateSyncPreview({ref:R.ref,syncData:d},I,N,this.getUserDataSyncConfiguration(),A.CancellationToken.None),W=[];for(const q of F){const B=await this.getAcceptResult(q,q.remoteResource,void 0,A.CancellationToken.None),{remoteChange:Q}=await this.getAcceptResult(q,q.previewResource,q.remoteContent,A.CancellationToken.None);W.push([q,{...B,remoteChange:Q!==0?Q:2}])}await this.applyResult(R,I,W,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(E){const d=await this.currentMachineIdPromise;return!!E.syncData?.machineId&&E.syncData.machineId===d}async getLatestRemoteUserData(E,d){if(d){const I=E?E[this.resource]:void 0;if(d.ref===I||I===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(E,d,I,R){if(E.syncData&&E.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new y.UserDataSyncError((0,w.localize)(0,null,this.resource,this.version,E.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(E,d,I,R)}catch(N){if(N instanceof y.UserDataSyncError)switch(N.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(E,d,I,R);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),E=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(E,d,I,R)}throw N}}async doSync(E,d,I,R){try{const N=await this.isRemoteDataFromCurrentMachine(E),F=!N&&d===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,W=I&&!F;this.syncPreviewPromise||(this.syncPreviewPromise=(0,O.createCancelablePromise)(B=>this.doGenerateSyncResourcePreview(E,d,N,W,R,B)));let q=await this.syncPreviewPromise;if(I&&F){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const B of q.resourcePreviews)q=await this.accept(B.remoteResource)||q}return this.updateConflicts(q.resourcePreviews),q.resourcePreviews.some(({mergeState:B})=>B==="conflict")?"hasConflicts":I?await this.doApply(!1):"syncing"}catch(N){throw this.syncPreviewPromise=null,N}}async merge(E){return await this.updateSyncResourcePreview(E,async d=>{const I=await this.getMergeResult(d,A.CancellationToken.None);await this.fileService.writeFile(d.previewResource,l.VSBuffer.fromString(I?.content||""));const R=I&&!I.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,A.CancellationToken.None):void 0;return d.acceptResult=R,d.mergeState=I.hasConflicts?"conflict":R?"accepted":"preview",d.localChange=R?R.localChange:I.localChange,d.remoteChange=R?R.remoteChange:I.remoteChange,d}),this.syncPreviewPromise}async accept(E,d){return await this.updateSyncResourcePreview(E,async I=>{const R=await this.getAcceptResult(I,E,d,A.CancellationToken.None);return I.acceptResult=R,I.mergeState="accepted",I.localChange=R.localChange,I.remoteChange=R.remoteChange,I}),this.syncPreviewPromise}async discard(E){return await this.updateSyncResourcePreview(E,async d=>{const I=await this.getMergeResult(d,A.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,l.VSBuffer.fromString(I.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=I.localChange,d.remoteChange=I.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(E,d){if(!this.syncPreviewPromise)return;let I=await this.syncPreviewPromise;const R=I.resourcePreviews.findIndex(({localResource:N,remoteResource:F,previewResource:W})=>this.extUri.isEqual(N,E)||this.extUri.isEqual(F,E)||this.extUri.isEqual(W,E));R!==-1&&(this.syncPreviewPromise=(0,O.createCancelablePromise)(async N=>{const F=[...I.resourcePreviews];return F[R]=await d(F[R]),{...I,resourcePreviews:F}}),I=await this.syncPreviewPromise,this.updateConflicts(I.resourcePreviews),I.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(E){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:I})=>I==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:I})=>I!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(I=>[I,I.acceptResult]),E),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(E){const d=E.filter(({mergeState:I})=>I==="conflict");(0,T.equals)(this._conflicts,d,(I,R)=>this.extUri.isEqual(I.previewResource,R.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const E=await this.getLastSyncUserData();return!!E&&E.syncData!==null}async resolvePreviewContent(E){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const I of d.resourcePreviews){if(this.extUri.isEqual(I.acceptedResource,E))return I.acceptResult?I.acceptResult.content:null;if(this.extUri.isEqual(I.remoteResource,E))return I.remoteContent;if(this.extUri.isEqual(I.localResource,E))return I.localContent;if(this.extUri.isEqual(I.baseResource,E))return I.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(E){(0,p.toFileOperationResult)(E)!==1&&this.logService.error(E)}}async doGenerateSyncResourcePreview(E,d,I,R,N,F){const W=await this.generateSyncPreview(E,d,I,N,F),q=[];for(const B of W){const Q=B.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(B.localChange===0&&B.remoteChange===0)q.push({...B,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Z=R?await this.getMergeResult(B,F):void 0;if(F.isCancellationRequested)break;await this.fileService.writeFile(B.previewResource,l.VSBuffer.fromString(Z?.content||""));const K=Z&&!Z.hasConflicts?await this.getAcceptResult(B,B.previewResource,void 0,F):void 0;q.push({...B,acceptResult:K,mergeState:Z?.hasConflicts?"conflict":K?"accepted":"preview",localChange:K?K.localChange:Z?Z.localChange:B.localChange,remoteChange:K?K.remoteChange:Z?Z.remoteChange:B.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:E,lastSyncUserData:d,resourcePreviews:q,isLastSyncFromCurrentMachine:I}}async getLastSyncUserData(){let E=this.getStoredLastSyncUserDataStateContent();if(E||(E=await this.migrateLastSyncUserData()),!E)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const d=JSON.parse(E),I=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!d.version&&!!I&&d.version!==I,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${I}.`),await this.resetLocal(),null;let R,N=1;for(;R===void 0&&N++<6;)try{const F=await this.readLastSyncStoredRemoteUserData();F&&(F.ref===d.ref?R=F.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof p.FileOperationError&&F.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(F instanceof y.UserDataSyncError)throw F;this.logService.error(F,N)}}if(R===void 0)try{const F=await this.userDataSyncStoreService.resolveResourceContent(this.resource,d.ref,this.collection,this.syncHeaders);R=F===null?null:this.parseSyncData(F),await this.writeLastSyncStoredRemoteUserData({ref:d.ref,syncData:R})}catch(F){if(F instanceof y.UserDataSyncError&&F.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw F}return R===void 0?null:{...d,syncData:R}}async updateLastSyncUserData(E,d={}){if(d.ref||d.version)throw new Error("Cannot have core properties as additional");const I=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),R={ref:E.ref,version:I,...d};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(R),-1,1),await this.writeLastSyncStoredRemoteUserData(E)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const E=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const d=E?JSON.parse(E):void 0;if(n(d))return d}catch(d){this.logService.error(d)}}async writeLastSyncStoredRemoteUserData(E){await this.fileService.writeFile(this.lastSyncResource,l.VSBuffer.fromString(JSON.stringify(E)))}async migrateLastSyncUserData(){try{const E=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(E.value.toString());await this.fileService.del(this.lastSyncResource),d.ref&&d.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...d,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:d.ref,syncData:d.content===null?null:JSON.parse(d.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,d)}catch(E){E instanceof p.FileOperationError&&E.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(E)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(E){const{ref:d,content:I}=await this.getUserData(E);let R=null;return I!==null&&(R=this.parseSyncData(I)),{ref:d,syncData:R}}parseSyncData(E){try{const d=JSON.parse(E);if(s(d))return d}catch(d){this.logService.error(d)}throw new y.UserDataSyncError((0,w.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(E){const d=E?{ref:E.ref,content:E.syncData?JSON.stringify(E.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,d,this.collection,this.syncHeaders)}async updateRemoteUserData(E,d){const I=await this.currentMachineIdPromise,R={version:this.version,machineId:I,content:E};try{return d=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(R),d,this.collection,this.syncHeaders),{ref:d,syncData:R}}catch(N){throw N instanceof y.UserDataSyncError&&N.code==="TooLarge"&&(N=new y.UserDataSyncError(N.message,N.code,this.resource)),N}}async backupLocal(E){const d={version:this.version,content:E};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(d))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(y.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=i=Se([Y(2,p.IFileService),Y(3,f.IEnvironmentService),Y(4,h.IStorageService),Y(5,y.IUserDataSyncStoreService),Y(6,y.IUserDataSyncBackupStoreService),Y(7,y.IUserDataSyncEnablementService),Y(8,u.ITelemetryService),Y(9,y.IUserDataSyncLogService),Y(10,m.IConfigurationService),Y(11,g.IUriIdentityService)],i);let r=e.AbstractFileSynchroniser=class extends i{constructor(E,d,I,R,N,F,W,q,B,Q,Z,K,x){super(d,I,R,N,F,W,q,B,Q,Z,K,x),this.file=E,this._register(this.fileService.watch(this.extUri.dirname(E))),this._register(this.fileService.onDidFilesChange($=>this.onFileChanges($)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(E,d,I){try{d?await this.fileService.writeFile(this.file,l.VSBuffer.fromString(E),I?void 0:d):await this.fileService.createFile(this.file,l.VSBuffer.fromString(E),{overwrite:I})}catch(R){throw R instanceof p.FileOperationError&&R.fileOperationResult===1||R instanceof p.FileOperationError&&R.fileOperationResult===3?new y.UserDataSyncError(R.message,"LocalPreconditionFailed"):R}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(E){if(!(E instanceof p.FileOperationError&&E.fileOperationResult===1))throw E}}onFileChanges(E){E.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=r=Se([Y(3,p.IFileService),Y(4,f.IEnvironmentService),Y(5,h.IStorageService),Y(6,y.IUserDataSyncStoreService),Y(7,y.IUserDataSyncBackupStoreService),Y(8,y.IUserDataSyncEnablementService),Y(9,u.ITelemetryService),Y(10,y.IUserDataSyncLogService),Y(11,m.IConfigurationService),Y(12,g.IUriIdentityService)],r);let o=e.AbstractJsonFileSynchroniser=class extends r{constructor(E,d,I,R,N,F,W,q,B,Q,Z,K,x,$){super(E,d,I,R,N,F,W,q,B,Q,Z,x,$),this.userDataSyncUtilService=K,this._formattingOptions=void 0}hasErrors(E,d){const I=[],R=(0,k.parse)(E,I,{allowEmptyContent:!0,allowTrailingComma:!0});return I.length>0||!(0,D.isUndefined)(R)&&d!==Array.isArray(R)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=o=Se([Y(3,p.IFileService),Y(4,f.IEnvironmentService),Y(5,h.IStorageService),Y(6,y.IUserDataSyncStoreService),Y(7,y.IUserDataSyncBackupStoreService),Y(8,y.IUserDataSyncEnablementService),Y(9,u.ITelemetryService),Y(10,y.IUserDataSyncLogService),Y(11,y.IUserDataSyncUtilService),Y(12,m.IConfigurationService),Y(13,g.IUriIdentityService)],o);let c=e.AbstractInitializer=class{constructor(E,d,I,R,N,F,W){this.resource=E,this.userDataProfilesService=d,this.environmentService=I,this.logService=R,this.fileService=N,this.storageService=F,this.extUri=W.extUri,this.lastSyncResource=(0,y.getLastSyncResourceUri)(void 0,this.resource,I,this.extUri)}async initialize({ref:E,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const I=this.parseSyncData(d);if(I)try{await this.doInitialize({ref:E,syncData:I})}catch(R){this.logService.error(R)}}parseSyncData(E){try{const d=JSON.parse(E);if(s(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(E,d={}){if(d.ref||d.version)throw new Error("Cannot have core properties as additional");const I={ref:E.ref,version:void 0,...d};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(I),-1,1),await this.fileService.writeFile(this.lastSyncResource,l.VSBuffer.fromString(JSON.stringify(E)))}};e.AbstractInitializer=c=Se([Y(1,L.IUserDataProfilesService),Y(2,f.IEnvironmentService),Y(3,b.ILogService),Y(4,p.IFileService),Y(5,h.IStorageService),Y(6,g.IUriIdentityService)],c)}),define(oe[120],ae([0,1,6,26,9,3,42,2,27,17,15,119,29,33,81,13,5,72,10,19,20,30,18,40,247,117,24,60]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g,y,L,n,s,t,i,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function c(N,F){const W=JSON.parse(N.content);if(N.version===1||N.version===2){const q=(await F.getInstalled(0)).filter(B=>B.isBuiltin);for(const B of W)N.version===1&&(B.enabled===!1&&(B.disabled=!0),delete B.enabled),N.version===2&&q.every(Q=>!(0,f.areSameExtensions)(Q.identifier,B.identifier))&&(B.installed=!0)}return W}function v(N){return JSON.parse(N.content)}e.parseExtensions=v;function E(N,F){return N.sort((W,q)=>!W.identifier.uuid&&q.identifier.uuid?-1:W.identifier.uuid&&!q.identifier.uuid?1:(0,P.compare)(W.identifier.id,q.identifier.id)),F?(0,_.toFormattedString)(N,{}):JSON.stringify(N)}e.stringify=E;let d=e.ExtensionsSynchroniser=class extends s.AbstractSynchroniser{constructor(F,W,q,B,Q,Z,K,x,$,j,te,ne,se,J,G,M,C){super({syncResource:"extensions",profile:F},W,B,q,Q,Z,K,ne,se,j,te,G),this.extensionManagementService=x,this.ignoredExtensionsManagementService=$,this.instantiationService=C,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(I),this._register(A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,U=>U.some(({local:z})=>!!z)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,U=>!U.error),A.Event.filter(M.onDidChange,U=>U.valueChanges.some(({profile:z,changes:H})=>this.syncResource.profile.id===z.id&&H.some(V=>V.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),J.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(F,W){const q=F.syncData?await c(F.syncData,this.extensionManagementService):null,B=W?.skippedExtensions??[],Q=W?.builtinExtensions??null,Z=W?.syncData?await c(W.syncData,this.extensionManagementService):null,{localExtensions:K,ignoredExtensions:x}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);q?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:$,remote:j}=(0,t.merge)(K,q,Z,B,x,Q),te={local:$,remote:j,content:this.getPreviewContent(K,$.added,$.updated,$.removed),localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:j!==null?2:0},ne=this.stringify(K,!1);return[{skippedExtensions:B,builtinExtensions:Q,baseResource:this.baseResource,baseContent:Z?this.stringify(Z,!1):ne,localResource:this.localResource,localContent:ne,localExtensions:K,remoteResource:this.remoteResource,remoteExtensions:q,remoteContent:q?this.stringify(q,!1):null,previewResource:this.previewResource,previewResult:te,localChange:te.localChange,remoteChange:te.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(F){const W=F.syncData?await c(F.syncData,this.extensionManagementService):null,{localExtensions:q,ignoredExtensions:B}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,t.merge)(q,W,W,F.skippedExtensions||[],B,F.builtinExtensions||[]);return Q!==null}getPreviewContent(F,W,q,B){const Q=[...W,...q],Z=new Set,K=x=>{Z.add(x.id.toLowerCase()),x.uuid&&Z.add(x.uuid)};Q.forEach(({identifier:x})=>K(x)),B.forEach(K);for(const x of F)Z.has(x.identifier.id.toLowerCase())||x.identifier.uuid&&Z.has(x.identifier.uuid)||Q.push(x);return this.stringify(Q,!1)}async getMergeResult(F,W){return{...F.previewResult,hasConflicts:!1}}async getAcceptResult(F,W,q,B){if(this.extUri.isEqual(W,this.localResource))return this.acceptLocal(F);if(this.extUri.isEqual(W,this.remoteResource))return this.acceptRemote(F);if(this.extUri.isEqual(W,this.previewResource))return F.previewResult;throw new Error(`Invalid Resource: ${W.toString()}`)}async acceptLocal(F){const W=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),q=this.ignoredExtensionsManagementService.getIgnoredExtensions(W),B=(0,t.merge)(F.localExtensions,null,null,F.skippedExtensions,q,F.builtinExtensions),{local:Q,remote:Z}=B;return{content:F.localContent,local:Q,remote:Z,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:Z!==null?2:0}}async acceptRemote(F){const W=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),q=this.ignoredExtensionsManagementService.getIgnoredExtensions(W),B=F.remoteContent?JSON.parse(F.remoteContent):null;if(B!==null){const Q=(0,t.merge)(F.localExtensions,B,F.localExtensions,[],q,F.builtinExtensions),{local:Z,remote:K}=Q;return{content:F.remoteContent,local:Z,remote:K,localChange:Z.added.length>0||Z.removed.length>0||Z.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(F,W,q,B){let{skippedExtensions:Q,builtinExtensions:Z,localExtensions:K}=q[0][0];const{local:x,remote:$,localChange:j,remoteChange:te}=q[0][1];if(j===0&&te===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),j!==0&&(await this.backupLocal(JSON.stringify(K)),Q=await this.localExtensionsProvider.updateLocalExtensions(x.added,x.removed,x.updated,Q,this.syncResource.profile)),$){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ne=JSON.stringify($.all);F=await this.updateRemoteUserData(ne,B?null:F.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${$.added.length?` Added: ${JSON.stringify($.added.map(se=>se.identifier.id))}.`:""}${$.updated.length?` Updated: ${JSON.stringify($.updated.map(se=>se.identifier.id))}.`:""}${$.removed.length?` Removed: ${JSON.stringify($.removed.map(se=>se.identifier.id))}.`:""}`)}W?.ref!==F.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),Z=this.computeBuiltinExtensions(K,Z),await this.updateLastSyncUserData(F,{skippedExtensions:Q,builtinExtensions:Z}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(ne=>ne.identifier.id))}.`:""}`))}computeBuiltinExtensions(F,W){const q=new Set,B=[];for(const Q of F)q.add(Q.identifier.id.toLowerCase()),Q.installed||B.push(Q.identifier);if(W)for(const Q of W)q.has(Q.id.toLowerCase())||B.push(Q);return B}async resolveContent(F){if(this.extUri.isEqual(this.remoteResource,F)||this.extUri.isEqual(this.baseResource,F)||this.extUri.isEqual(this.localResource,F)||this.extUri.isEqual(this.acceptedResource,F)){const W=await this.resolvePreviewContent(F);return W&&this.stringify(JSON.parse(W),!0)}return null}stringify(F,W){return E(F,W)}async hasLocalData(){try{const{localExtensions:F}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(F.some(W=>W.installed||W.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=d=Se([Y(2,D.IEnvironmentService),Y(3,b.IFileService),Y(4,g.IStorageService),Y(5,r.IUserDataSyncStoreService),Y(6,r.IUserDataSyncBackupStoreService),Y(7,m.IExtensionManagementService),Y(8,i.IIgnoredExtensionsManagementService),Y(9,r.IUserDataSyncLogService),Y(10,S.IConfigurationService),Y(11,r.IUserDataSyncEnablementService),Y(12,y.ITelemetryService),Y(13,p.IExtensionStorageService),Y(14,L.IUriIdentityService),Y(15,o.IUserDataProfileStorageService),Y(16,a.IInstantiationService)],d);let I=e.LocalExtensionsProvider=class{constructor(F,W,q,B,Q,Z){this.extensionManagementService=F,this.userDataProfileStorageService=W,this.extensionGalleryService=q,this.ignoredExtensionsManagementService=B,this.instantiationService=Q,this.logService=Z}async getLocalExtensions(F){const W=await this.extensionManagementService.getInstalled(void 0,F.extensionsResource),q=this.ignoredExtensionsManagementService.getIgnoredExtensions(W);return{localExtensions:await this.withProfileScopedServices(F,async(Q,Z)=>{const K=Q.getDisabledExtensions();return W.map(x=>{const{identifier:$,isBuiltin:j,manifest:te,preRelease:ne,pinned:se}=x,J={identifier:$,preRelease:ne,version:te.version,pinned:!!se};K.some(G=>(0,f.areSameExtensions)(G,$))&&(J.disabled=!0),j||(J.installed=!0);try{const G=Z.getKeysForSync({id:$.id,version:te.version});if(G){const M=Z.getExtensionState(x,!0)||{};J.state=Object.keys(M).reduce((C,U)=>(G.includes(U)&&(C[U]=M[U]),C),{})}}catch(G){this.logService.info(`${(0,s.getSyncResourceLogLabel)("extensions",F)}: Error while parsing extension state`,(0,l.getErrorMessage)(G))}return J})}),ignoredExtensions:q}}async updateLocalExtensions(F,W,q,B,Q){const Z=(0,s.getSyncResourceLogLabel)("extensions",Q),K=[],x=[],$=[],j=await this.extensionManagementService.getInstalled(void 0,Q.extensionsResource);if((F.length||q.length)&&await this.withProfileScopedServices(Q,async(ne,se)=>{await T.Promises.settled([...F,...q].map(async J=>{const G=j.find(U=>(0,f.areSameExtensions)(U.identifier,J.identifier));if(G&&G.isBuiltin){J.state&&G.manifest.version===J.version&&this.updateExtensionState(J.state,G,G.manifest.version,se),ne.getDisabledExtensions().some(z=>(0,f.areSameExtensions)(z,J.identifier))!==!!J.disabled&&(J.disabled?(this.logService.trace(`${Z}: Disabling extension...`,J.identifier.id),await ne.disableExtension(J.identifier),this.logService.info(`${Z}: Disabled extension`,J.identifier.id)):(this.logService.trace(`${Z}: Enabling extension...`,J.identifier.id),await ne.enableExtension(J.identifier),this.logService.info(`${Z}: Enabled extension`,J.identifier.id))),x.push(J.identifier);return}const M=J.pinned?J.version:void 0,C=(await this.extensionGalleryService.getExtensions([{...J.identifier,version:M,preRelease:M?void 0:J.preRelease}],O.CancellationToken.None))[0];if(J.state&&(G?G.manifest.version===J.version:C)&&this.updateExtensionState(J.state,G||C,G?.manifest.version,se),C)try{ne.getDisabledExtensions().some(z=>(0,f.areSameExtensions)(z,J.identifier))!==!!J.disabled&&(J.disabled?(this.logService.trace(`${Z}: Disabling extension...`,J.identifier.id,C.version),await ne.disableExtension(C.identifier),this.logService.info(`${Z}: Disabled extension`,J.identifier.id,C.version)):(this.logService.trace(`${Z}: Enabling extension...`,J.identifier.id,C.version),await ne.enableExtension(C.identifier),this.logService.info(`${Z}: Enabled extension`,J.identifier.id,C.version))),(!G||G.preRelease!==J.preRelease||G.pinned!==J.pinned||M&&G.manifest.version!==M)&&(await this.extensionManagementService.canInstall(C)?K.push([J,C]):(this.logService.info(`${Z}: Skipped synchronizing extension because it cannot be installed.`,C.displayName||C.identifier.id),$.push(J)))}catch(U){$.push(J),this.logService.error(U),this.logService.info(`${Z}: Skipped synchronizing extension`,C.displayName||C.identifier.id)}else $.push(J),this.logService.info(`${Z}: Skipped synchronizing extension because the extension is not found.`,J.identifier.id)}))}),W.length){const ne=j.filter(({identifier:se,isBuiltin:J})=>!J&&W.some(G=>(0,f.areSameExtensions)(se,G)));await T.Promises.settled(ne.map(async se=>{this.logService.trace(`${Z}: Uninstalling local extension...`,se.identifier.id),await this.extensionManagementService.uninstall(se,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.logService.info(`${Z}: Uninstalled local extension.`,se.identifier.id),x.push(se.identifier)}))}for(const[ne,se]of K)try{this.logService.trace(`${Z}: Installing extension...`,se.identifier.id,se.version),await this.extensionManagementService.installFromGallery(se,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:ne.pinned&&!!ne.version,installPreReleaseVersion:ne.preRelease,profileLocation:Q.extensionsResource,context:{[m.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[m.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.logService.info(`${Z}: Installed extension.`,se.identifier.id,se.version),x.push(se.identifier)}catch(J){$.push(ne),J instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatiblePreRelease,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(J.code)?this.logService.info(`${Z}: Skipped synchronizing extension because the compatible extension is not found.`,se.displayName||se.identifier.id):(this.logService.error(J),this.logService.info(`${Z}: Skipped synchronizing extension`,se.displayName||se.identifier.id))}const te=[];for(const ne of B)x.some(se=>(0,f.areSameExtensions)(se,ne.identifier))||te.push(ne);for(const ne of $)te.some(se=>(0,f.areSameExtensions)(se.identifier,ne.identifier))||te.push(ne);return te}updateExtensionState(F,W,q,B){const Q=B.getExtensionState(W,!0)||{},Z=q?B.getKeysForSync({id:W.identifier.id,version:q}):void 0;Z?Z.forEach(K=>{Q[K]=F[K]}):Object.keys(F).forEach(K=>Q[K]=F[K]),B.setExtensionState(W,Q,!0)}async withProfileScopedServices(F,W){return this.userDataProfileStorageService.withProfileScopedStorageService(F,async q=>{const B=new k.DisposableStore,Q=this.instantiationService.createChild(new h.ServiceCollection([g.IStorageService,q])),Z=B.add(Q.createInstance(w.GlobalExtensionEnablementService)),K=B.add(Q.createInstance(p.ExtensionStorageService));try{return await W(Z,K)}finally{B.dispose()}})}};e.LocalExtensionsProvider=I=Se([Y(0,m.IExtensionManagementService),Y(1,o.IUserDataProfileStorageService),Y(2,m.IExtensionGalleryService),Y(3,i.IIgnoredExtensionsManagementService),Y(4,a.IInstantiationService),Y(5,r.IUserDataSyncLogService)],I);let R=e.AbstractExtensionsInitializer=class extends s.AbstractInitializer{constructor(F,W,q,B,Q,Z,K,x){super("extensions",B,Q,Z,q,K,x),this.extensionManagementService=F,this.ignoredExtensionsManagementService=W}async parseExtensions(F){return F.syncData?await c(F.syncData,this.extensionManagementService):null}generatePreview(F,W){const q=[],B=[],Q=[];for(const Z of F){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(Z.identifier.id))continue;const K=W.find(x=>(0,f.areSameExtensions)(x.identifier,Z.identifier));K?(q.push(K),Z.disabled&&Q.push(Z.identifier)):Z.installed&&(B.push({...Z.identifier,preRelease:!!Z.preRelease}),Z.disabled&&Q.push(Z.identifier))}return{installedExtensions:q,newExtensions:B,disabledExtensions:Q,remoteExtensions:F}}};e.AbstractExtensionsInitializer=R=Se([Y(0,m.IExtensionManagementService),Y(1,i.IIgnoredExtensionsManagementService),Y(2,b.IFileService),Y(3,n.IUserDataProfilesService),Y(4,D.IEnvironmentService),Y(5,u.ILogService),Y(6,g.IStorageService),Y(7,L.IUriIdentityService)],R)}),define(oe[121],ae([0,1,16,9,3,35,42,4,32,17,15,13,10,44,19,20,30,40,59,251,24,18,60,5]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g,y,L,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",i=["locale"];function r(I,R){const N=I.storage?Object.keys(I.storage).sort():[],F={};return N.forEach(W=>F[W]=I.storage[W]),I.storage=F,R?(0,_.toFormattedString)(I,{}):JSON.stringify(I)}e.stringify=r;const o=1;let c=e.GlobalStateSynchroniser=class extends h.AbstractSynchroniser{constructor(R,N,F,W,q,B,Q,Z,K,x,$,j,te,ne){super({syncResource:"globalState",profile:R},N,W,Z,j,q,B,K,x,Q,$,te),this.userDataProfileStorageService=F,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ne.createInstance(v),this._register(W.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(l.Event.any(l.Event.filter(W.onDidFilesChange,se=>se.contains(this.environmentService.argvResource)),l.Event.filter(F.onDidChange,se=>!!(se.targetChanges.some(J=>this.syncResource.profile.id===J.id)||se.valueChanges.some(({profile:J,changes:G})=>this.syncResource.profile.id===J.id&&G.some(M=>M.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(R,N,F){const W=R.syncData?JSON.parse(R.syncData.content):null;N=N===null&&F?R:N;const q=N&&N.syncData?JSON.parse(N.syncData.content):null,B=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);W?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.getStorageKeys(q),{local:Z,remote:K}=(0,g.merge)(B.storage,W?W.storage:null,q?q.storage:null,Q,this.logService),x={content:null,local:Z,remote:K,localChange:Object.keys(Z.added).length>0||Object.keys(Z.updated).length>0||Z.removed.length>0?2:0,remoteChange:K.all!==null?2:0},$=r(B,!1);return[{baseResource:this.baseResource,baseContent:q?r(q,!1):$,localResource:this.localResource,localContent:$,localUserData:B,remoteResource:this.remoteResource,remoteContent:W?r(W,!1):null,previewResource:this.previewResource,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.acceptedResource,storageKeys:Q}]}async hasRemoteChanged(R){const N=R.syncData?JSON.parse(R.syncData.content):null;if(N===null)return!0;const F=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),W=await this.getStorageKeys(N),{remote:q}=(0,g.merge)(F.storage,N.storage,N.storage,W,this.logService);return q.all!==null}async getMergeResult(R,N){return{...R.previewResult,hasConflicts:!1}}async getAcceptResult(R,N,F,W){if(this.extUri.isEqual(N,this.localResource))return this.acceptLocal(R);if(this.extUri.isEqual(N,this.remoteResource))return this.acceptRemote(R);if(this.extUri.isEqual(N,this.previewResource))return R.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async acceptLocal(R){return{content:R.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(R.localUserData.storage),removed:[],updated:[],all:R.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(R){if(R.remoteContent!==null){const N=JSON.parse(R.remoteContent),{local:F,remote:W}=(0,g.merge)(R.localUserData.storage,N.storage,null,R.storageKeys,this.logService);return{content:R.remoteContent,local:F,remote:W,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:W!==null?2:0}}else return{content:R.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(R,N,F,W){const{localUserData:q}=F[0][0],{local:B,remote:Q,localChange:Z,remoteChange:K}=F[0][1];if(Z===0&&K===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),Z!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(q)),await this.localGlobalStateProvider.writeLocalGlobalState(B,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),K!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const x=JSON.stringify({storage:Q.all});R=await this.updateRemoteUserData(x,W?null:R.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}N?.ref!==R.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(R),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(R){if(this.extUri.isEqual(this.remoteResource,R)||this.extUri.isEqual(this.baseResource,R)||this.extUri.isEqual(this.localResource,R)||this.extUri.isEqual(this.acceptedResource,R)){const N=await this.resolvePreviewContent(R);return N&&r(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:R}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(R).length>1||R[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(R){const N=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),F=[],W=[];for(const[Q,Z]of N)Z.target===0?F.push(Q):Z.target===1&&W.push(Q);const q=[...F,...W],B=R?.storage?Object.keys(R.storage).filter(Q=>!Q.startsWith(t)&&!q.includes(Q)&&N.get(Q)!==void 0):[];if(!k.isWeb){const Q=[...y.ALL_SYNC_RESOURCES.map(Z=>(0,y.getEnablementKey)(Z)),y.SYNC_SERVICE_URL_TYPE];B.push(...Q),W.push(...Q)}return{user:F,machine:W,unregistered:B}}};e.GlobalStateSynchroniser=c=Se([Y(2,n.IUserDataProfileStorageService),Y(3,w.IFileService),Y(4,y.IUserDataSyncStoreService),Y(5,y.IUserDataSyncBackupStoreService),Y(6,y.IUserDataSyncLogService),Y(7,D.IEnvironmentService),Y(8,y.IUserDataSyncEnablementService),Y(9,b.ITelemetryService),Y(10,S.IConfigurationService),Y(11,p.IStorageService),Y(12,a.IUriIdentityService),Y(13,s.IInstantiationService)],c);let v=e.LocalGlobalStateProvider=class{constructor(R,N,F,W){this.fileService=R,this.environmentService=N,this.userDataProfileStorageService=F,this.logService=W}async getLocalGlobalState(R){const N={};if(R.isDefault){const W=await this.getLocalArgvContent(),q=(0,A.parse)(W);for(const B of i)q[B]!==void 0&&(N[`${t}${B}`]={version:1,value:q[B]})}const F=await this.userDataProfileStorageService.readStorageData(R);for(const[W,q]of F)q.value&&q.target===0&&(N[W]={version:1,value:q.value});return{storage:N}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const R=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),R.value.toString()}catch(R){this.logService.debug((0,O.getErrorMessage)(R))}return"{}"}async writeLocalGlobalState({added:R,removed:N,updated:F},W){const q=(0,h.getSyncResourceLogLabel)("globalState",W),B={},Q=new Map,Z=await this.userDataProfileStorageService.readStorageData(W),K=(x,$)=>{for(const j of x){if(j.startsWith(t)){B[j.substring(t.length)]=$?$[j].value:void 0;continue}if($){const te=$[j];te.value!==Z.get(j)?.value&&Q.set(j,te.value)}else Z.get(j)!==void 0&&Q.set(j,void 0)}};if(K(Object.keys(R),R),K(Object.keys(F),F),K(N),Object.keys(B).length){this.logService.trace(`${q}: Updating locale...`);const x=await this.getLocalArgvContent();let $=x;for(const j of Object.keys(B))$=(0,u.edit)($,[j],B[j],{});x!==$&&(this.logService.trace(`${q}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,T.VSBuffer.fromString($)),this.logService.info(`${q}: Updated locale.`)),this.logService.info(`${q}: Updated locale`)}Q.size&&(this.logService.trace(`${q}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(W,Q,0),this.logService.info(`${q}: Updated global state`,[...Q.keys()]))}};e.LocalGlobalStateProvider=v=Se([Y(0,w.IFileService),Y(1,D.IEnvironmentService),Y(2,n.IUserDataProfileStorageService),Y(3,y.IUserDataSyncLogService)],v);let E=e.GlobalStateInitializer=class extends h.AbstractInitializer{constructor(R,N,F,W,q,B){super("globalState",F,W,q,N,R,B)}async doInitialize(R){const N=R.syncData?JSON.parse(R.syncData.content):null;if(!N){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const F={},W={};for(const q of Object.keys(N.storage))q.startsWith(t)?F[q.substring(t.length)]=N.storage[q].value:this.storageService.get(q,0)===void 0&&(W[q]=N.storage[q].value);if(Object.keys(F).length){let q="{}";try{q=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const B of Object.keys(F))q=(0,u.edit)(q,[B],F[B],{});await this.fileService.writeFile(this.environmentService.argvResource,T.VSBuffer.fromString(q))}if(Object.keys(W).length)for(const q of Object.keys(W))this.storageService.store(q,W[q],0,0)}};e.GlobalStateInitializer=E=Se([Y(0,p.IStorageService),Y(1,w.IFileService),Y(2,L.IUserDataProfilesService),Y(3,D.IEnvironmentService),Y(4,y.IUserDataSyncLogService),Y(5,a.IUriIdentityService)],E);let d=e.UserDataSyncStoreTypeSynchronizer=class{constructor(R,N,F,W,q){this.userDataSyncStoreClient=R,this.storageService=N,this.environmentService=F,this.fileService=W,this.logService=q}getSyncStoreType(R){return this.parseGlobalState(R)?.storage[y.SYNC_SERVICE_URL_TYPE]?.value}async sync(R){const N=(0,y.createSyncHeaders)((0,P.generateUuid)());try{return await this.doSync(R,N)}catch(F){if(F instanceof y.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(R,N)}throw F}}async doSync(R,N){const F=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,N),W=this.parseGlobalState(F)||{storage:{}};W.storage[y.SYNC_SERVICE_URL_TYPE]={value:R,version:o};const q=await(0,f.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),B={version:o,machineId:q,content:r(W,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(B),F.ref,void 0,N)}parseGlobalState({content:R}){if(!R)return null;const N=JSON.parse(R);if((0,h.isSyncData)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=d=Se([Y(1,p.IStorageService),Y(2,D.IEnvironmentService),Y(3,w.IFileService),Y(4,m.ILogService)],d)}),define(oe[122],ae([0,1,21,16,3,35,4,11,178,17,15,13,19,20,30,18,40,248,24]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function g(n,s,t){try{const i=JSON.parse(n);if(!s)return(0,k.isUndefined)(i.all)?null:i.all;switch(_.OS){case 2:return(0,k.isUndefined)(i.mac)?null:i.mac;case 3:return(0,k.isUndefined)(i.linux)?null:i.linux;case 1:return(0,k.isUndefined)(i.windows)?null:i.windows}}catch(i){return t.error(i),null}}e.getKeybindingsContentFromSyncContent=g;let y=e.KeybindingsSynchroniser=class extends a.AbstractJsonFileSynchroniser{constructor(s,t,i,r,o,c,v,E,d,I,R,N,F){super(s.keybindingsResource,{syncResource:"keybindings",profile:s},t,E,d,I,i,r,v,N,o,R,c,F),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(l.Event.filter(c.onDidChangeConfiguration,W=>W.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,i,r){const o=s.syncData?g(s.syncData.content,r.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&i?s:t;const c=t?this.getKeybindingsContentFromLastSyncUserData(t):null,v=await this.getLocalFileContent(),E=await this.getFormattingOptions();let d=null,I=!1,R=!1,N=!1;if(o){let q=v?v.value.toString():"[]";if(q=q||"[]",this.hasErrors(q,!0))throw new u.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==q||c!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const B=await(0,h.merge)(q,o,c,E,this.userDataSyncUtilService);B.hasChanges&&(d=B.mergeContent,N=B.hasConflicts,I=N||B.mergeContent!==q,R=N||B.mergeContent!==o)}}else v&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=v.value.toString(),R=!0);const F={content:N?c:d,localChange:I?v?2:1:0,remoteChange:R?2:0,hasConflicts:N},W=v?v.value.toString():null;return[{fileContent:v,baseResource:this.baseResource,baseContent:c,localResource:this.localResource,localContent:W,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getKeybindingsContentFromLastSyncUserData(s);if(t===null)return!0;const i=await this.getLocalFileContent(),r=i?i.value.toString():"",o=await this.getFormattingOptions(),c=await(0,h.merge)(r||"[]",t,t,o,this.userDataSyncUtilService);return c.hasConflicts||c.mergeContent!==t}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,i,r){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,i,r){const{fileContent:o}=i[0][0];let{content:c,localChange:v,remoteChange:E}=i[0][1];if(v===0&&E===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c,!0)))throw new u.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(c||"[]",o,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),E!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(c||"[]",s.syncData?.content);s=await this.updateRemoteUserData(d,r?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=(0,A.parse)(s.value.toString());if((0,T.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.baseResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)?this.resolvePreviewContent(s):null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:g(s.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(s,t){let i={};try{i=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=s,_.OS){case 2:i.mac=s;break;case 3:i.linux=s;break;case 1:i.windows=s;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(u.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=y=Se([Y(2,u.IUserDataSyncStoreService),Y(3,u.IUserDataSyncBackupStoreService),Y(4,u.IUserDataSyncLogService),Y(5,S.IConfigurationService),Y(6,u.IUserDataSyncEnablementService),Y(7,w.IFileService),Y(8,D.IEnvironmentService),Y(9,m.IStorageService),Y(10,u.IUserDataSyncUtilService),Y(11,f.ITelemetryService),Y(12,p.IUriIdentityService)],y);let L=e.KeybindingsInitializer=class extends a.AbstractInitializer{constructor(s,t,i,r,o,c){super("keybindings",t,i,r,s,o,c)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,O.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,A.parse)(s.value.toString());return!(0,T.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return g(s,!0,this.logService)}catch(t){return this.logService.error(t),null}}};e.KeybindingsInitializer=L=Se([Y(0,w.IFileService),Y(1,b.IUserDataProfilesService),Y(2,D.IEnvironmentService),Y(3,u.IUserDataSyncLogService),Y(4,m.IStorageService),Y(5,p.IUriIdentityService)],L)}),define(oe[123],ae([0,1,16,3,179,17,75,15,29,13,19,20,30,18,40,59,252,24]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function u(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function g(n){const s=JSON.parse(n);return u(s)?s:{settings:n}}e.parseSettingsSyncContent=g;let y=e.SettingsSynchroniser=class extends p.AbstractJsonFileSynchroniser{constructor(s,t,i,r,o,c,v,E,d,I,R,N,F,W){super(s.settingsResource,{syncResource:"settings",profile:s},t,i,r,o,c,v,R,N,E,d,I,W),this.extensionManagementService=F,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const t=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(s,t),r=this.getSettingsSyncContent(i),o=new _.ConfigurationModelParser(h.USER_DATA_SYNC_CONFIGURATION_SCOPE);return r?.settings&&o.parse(r.settings),o.configurationModel.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,t,i){const r=await this.getLocalFileContent(),o=await this.getFormattingOptions(),c=this.getSettingsSyncContent(s);t=t===null&&i?s:t;const v=t?this.getSettingsSyncContent(t):null,E=await this.getIgnoredSettings();let d=null,I=!1,R=!1,N=!1;if(c){let B=r?r.value.toString().trim():"{}";B=B||"{}",this.validateContent(B),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const Q=(0,a.merge)(B,c.settings,v?v.settings:null,E,[],o);d=Q.localContent||Q.remoteContent,I=Q.localContent!==null,R=Q.remoteContent!==null,N=Q.hasConflicts}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),d=r.value.toString().trim()||"{}",this.validateContent(d),R=!0);const F=r?r.value.toString():null,W=v?.settings??null,q={content:N?W:d,localChange:I?2:0,remoteChange:R?2:0,hasConflicts:N};return[{fileContent:r,baseResource:this.baseResource,baseContent:W,localResource:this.localResource,localContent:F,localChange:q.localChange,remoteResource:this.remoteResource,remoteContent:c?c.settings:null,remoteChange:q.remoteChange,previewResource:this.previewResource,previewResult:q,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getSettingsSyncContent(s);if(t===null)return!0;const i=await this.getLocalFileContent(),r=i?i.value.toString().trim():"",o=await this.getIgnoredSettings(),c=await this.getFormattingOptions();return(0,a.merge)(r||"{}",t.settings,t.settings,o,[],c).remoteContent!==null}async getMergeResult(s,t){const i=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,a.updateIgnoredSettings)(s.previewResult.content,"{}",r,i):null}}async getAcceptResult(s,t,i,r){const o=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?(0,a.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",c,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent!==null?(0,a.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",c,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i!==null?(0,a.updateIgnoredSettings)(i,s.fileContent?s.fileContent.value.toString():"{}",c,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,i,r){const{fileContent:o}=i[0][0];let{content:c,localChange:v,remoteChange:E}=i[0][1];if(v===0&&E===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),v!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(c,o,r),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),E!==0){const d=await this.getFormattingOptions(),I=this.getSettingsSyncContent(s),R=await this.getIgnoredSettings(c);c=(0,a.updateIgnoredSettings)(c,I?I.settings:"{}",R,d),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),r?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=await this.getFormattingOptions(),i=(0,b.edit)(s.value.toString(),[h.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,a.isEmpty)(i)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)||this.extUri.isEqual(this.baseResource,s)?this.resolvePreviewContent(s):null}async resolvePreviewContent(s){let t=await super.resolvePreviewContent(s);if(t){const i=await this.getFormattingOptions(),r=await this.getIgnoredSettings();t=(0,a.updateIgnoredSettings)(t,"{}",r,i)}return t}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return g(s)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:o})=>!!o)),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,a.getIgnoredSettings)(t,this.configurationService,s)}validateContent(s){if(this.hasErrors(s,!1))throw new h.UserDataSyncError((0,l.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=y=Se([Y(2,S.IFileService),Y(3,k.IEnvironmentService),Y(4,D.IStorageService),Y(5,h.IUserDataSyncStoreService),Y(6,h.IUserDataSyncBackupStoreService),Y(7,h.IUserDataSyncLogService),Y(8,h.IUserDataSyncUtilService),Y(9,A.IConfigurationService),Y(10,h.IUserDataSyncEnablementService),Y(11,w.ITelemetryService),Y(12,P.IExtensionManagementService),Y(13,m.IUriIdentityService)],y);let L=e.SettingsInitializer=class extends p.AbstractInitializer{constructor(s,t,i,r,o,c){super("settings",t,i,r,s,o,c)}async doInitialize(s){const t=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,T.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,a.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return g(s)}catch(t){this.logService.error(t)}return null}};e.SettingsInitializer=L=Se([Y(0,S.IFileService),Y(1,f.IUserDataProfilesService),Y(2,k.IEnvironmentService),Y(3,h.IUserDataSyncLogService),Y(4,D.IStorageService),Y(5,m.IUriIdentityService)],L)}),define(oe[124],ae([0,1,16,3,31,17,15,13,19,20,30,18,40,249,24]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function b(u){return JSON.parse(u.content)}e.parseSnippets=b;let a=e.SnippetsSynchroniser=class extends m.AbstractSynchroniser{constructor(g,y,L,n,s,t,i,r,o,c,v,E){super({syncResource:"snippets",profile:g},y,n,L,s,t,i,c,v,r,o,E),this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(L.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(O.Event.filter(this.fileService.onDidFilesChange,d=>d.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,y,L){const n=await this.getSnippetsFileContents(),s=this.toSnippetsContents(n),t=g.syncData?this.parseSnippets(g.syncData):null;y=y===null&&L?g:y;const i=y&&y.syncData?this.parseSnippets(y.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,f.merge)(s,t,i);return this.getResourcePreviews(r,n,t||{},i||{})}async hasRemoteChanged(g){const y=g.syncData?this.parseSnippets(g.syncData):null;if(y===null)return!0;const L=await this.getSnippetsFileContents(),n=this.toSnippetsContents(L),s=(0,f.merge)(n,y,y);return Object.keys(s.remote.added).length>0||Object.keys(s.remote.updated).length>0||s.remote.removed.length>0||s.conflicts.length>0}async getMergeResult(g,y){return g.previewResult}async getAcceptResult(g,y,L,n){if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder))return L===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:L,localChange:L===null?g.fileContent!==null?3:0:2,remoteChange:L===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${y.toString()}`)}async applyResult(g,y,L,n){const s=L.map(([t,i])=>({...t,acceptResult:i}));s.every(({localChange:t,remoteChange:i})=>t===0&&i===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:t})=>t!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,n)),s.some(({remoteChange:t})=>t!==0)&&(g=await this.updateRemoteSnippets(s,g,n)),y?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:t}of s)try{await this.fileService.del(t)}catch{}}getResourcePreviews(g,y,L,n){const s=new Map;for(const t of Object.keys(g.local.added)){const i={content:g.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(g.local.updated)){const i={content:g.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},r=y[t]?y[t].value.toString():null;s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of g.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},r=y[t]?y[t].value.toString():null;s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(g.remote.added)){const i={content:g.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},r=y[t]?y[t].value.toString():null;s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(g.remote.updated)){const i={content:g.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},r=y[t]?y[t].value.toString():null;s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of g.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of g.conflicts){const i={content:n[t]??null,hasConflicts:!0,localChange:y[t]?2:1,remoteChange:L[t]?2:1},r=y[t]?y[t].value.toString():null;s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[t]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(y))if(!s.has(t)){const i={content:y[t]?y[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},r=y[t]?y[t].value.toString():null;s.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[t]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...s.values()]}async resolveContent(g){return this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(g):null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const y={};for(const L of g)L.fileContent&&(y[this.extUri.basename(L.localResource)]=L.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(y)))}async updateLocalSnippets(g,y){for(const{fileContent:L,acceptResult:n,localResource:s,remoteResource:t,localChange:i}of g)if(i!==0){const r=t?this.extUri.basename(t):this.extUri.basename(s),o=this.extUri.joinPath(this.snippetsFolder,r);i===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):i===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,T.VSBuffer.fromString(n.content),{overwrite:y}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,T.VSBuffer.fromString(n.content),y?void 0:L),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(g,y,L){const n=y.syncData?this.parseSnippets(y.syncData):{},s=(0,l.deepClone)(n);for(const{acceptResult:t,localResource:i,remoteResource:r,remoteChange:o}of g)if(o!==0){const c=i?this.extUri.basename(i):this.extUri.basename(r);o===3?delete s[c]:s[c]=t.content}return(0,f.areSame)(n,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),y=await this.updateRemoteUserData(JSON.stringify(s),L?null:y.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),y}parseSnippets(g){return b(g)}toSnippetsContents(g){const y={};for(const L of Object.keys(g))y[L]=g[L].value.toString();return y}async getSnippetsFileContents(){const g={};let y;try{y=await this.fileService.resolve(this.snippetsFolder)}catch(L){if(L instanceof k.FileOperationError&&L.fileOperationResult===1)return g;throw L}for(const L of y.children||[]){const n=L.resource,s=this.extUri.extname(n);if(s===".json"||s===".code-snippets"){const t=this.extUri.relativePath(this.snippetsFolder,n),i=await this.fileService.readFile(n);g[t]=i}}return g}};e.SnippetsSynchroniser=a=Se([Y(2,_.IEnvironmentService),Y(3,k.IFileService),Y(4,P.IStorageService),Y(5,p.IUserDataSyncStoreService),Y(6,p.IUserDataSyncBackupStoreService),Y(7,p.IUserDataSyncLogService),Y(8,A.IConfigurationService),Y(9,p.IUserDataSyncEnablementService),Y(10,S.ITelemetryService),Y(11,D.IUriIdentityService)],a);let h=e.SnippetsInitializer=class extends m.AbstractInitializer{constructor(g,y,L,n,s,t){super("snippets",y,L,n,g,s,t)}async doInitialize(g){const y=g.syncData?JSON.parse(g.syncData.content):null;if(!y){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(y)){const s=y[n];if(s){const t=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,n);await this.fileService.createFile(t,T.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(t))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};e.SnippetsInitializer=h=Se([Y(0,k.IFileService),Y(1,w.IUserDataProfilesService),Y(2,_.IEnvironmentService),Y(3,p.IUserDataSyncLogService),Y(4,P.IStorageService),Y(5,D.IUriIdentityService)],h)}),define(oe[125],ae([0,1,16,17,15,13,19,20,30,18,40,24]),function(ie,e,T,O,l,A,_,k,P,S,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function m(a,h){try{return JSON.parse(a).tasks??null}catch(u){return h.error(u),null}}e.getTasksContentFromSyncContent=m;let f=e.TasksSynchroniser=class extends D.AbstractFileSynchroniser{constructor(h,u,g,y,L,n,s,t,i,r,o,c){super(h.tasksResource,{syncResource:"tasks",profile:h},u,t,i,r,g,y,s,o,L,n,c),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(h,u,g,y){const L=h.syncData?m(h.syncData.content,this.logService):null;u=u===null&&g?h:u;const n=u?.syncData?m(u.syncData.content,this.logService):null,s=await this.getLocalFileContent();let t=null,i=!1,r=!1,o=!1;if(h.syncData){const E=s?s.value.toString():null;if(!n||n!==E||n!==L){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const d=b(E,L,n);t=d.content,o=d.hasConflicts,i=d.hasLocalChanged,r=d.hasRemoteChanged}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=s.value.toString(),r=!0);const c={content:o?n:t,localChange:i?s?2:1:0,remoteChange:r?2:0,hasConflicts:o},v=s?s.value.toString():null;return[{fileContent:s,baseResource:this.baseResource,baseContent:n,localResource:this.localResource,localContent:v,localChange:c.localChange,remoteResource:this.remoteResource,remoteContent:L,remoteChange:c.remoteChange,previewResource:this.previewResource,previewResult:c,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const u=h?.syncData?m(h.syncData.content,this.logService):null;if(u===null)return!0;const g=await this.getLocalFileContent(),y=g?g.value.toString():null,L=b(y,u,u);return L.hasLocalChanged||L.hasRemoteChanged}async getMergeResult(h,u){return h.previewResult}async getAcceptResult(h,u,g,y){if(this.extUri.isEqual(u,this.localResource))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(u,this.remoteResource))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(u,this.previewResource))return g===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:g,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async applyResult(h,u,g,y){const{fileContent:L}=g[0][0],{content:n,localChange:s,remoteChange:t}=g[0][1];if(s===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),s!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),L&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(L.value.toString()))),n?await this.updateLocalFileContent(n,L,y):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(n));h=await this.updateRemoteUserData(i,y?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}u?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(h){return this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.baseResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)?this.resolvePreviewContent(h):null}toTasksSyncContent(h){return h?{tasks:h}:{}}};e.TasksSynchroniser=f=Se([Y(2,w.IUserDataSyncStoreService),Y(3,w.IUserDataSyncBackupStoreService),Y(4,w.IUserDataSyncLogService),Y(5,O.IConfigurationService),Y(6,w.IUserDataSyncEnablementService),Y(7,A.IFileService),Y(8,l.IEnvironmentService),Y(9,_.IStorageService),Y(10,k.ITelemetryService),Y(11,P.IUriIdentityService)],f);let p=e.TasksInitializer=class extends D.AbstractInitializer{constructor(h,u,g,y,L,n){super("tasks",u,g,y,h,L,n),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(h){const u=h.syncData?m(h.syncData.content,this.logService):null;if(!u){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,T.VSBuffer.fromString(u)),await this.updateLastSyncUserData(h)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=p=Se([Y(0,A.IFileService),Y(1,S.IUserDataProfilesService),Y(2,l.IEnvironmentService),Y(3,w.IUserDataSyncLogService),Y(4,_.IStorageService),Y(5,P.IUriIdentityService)],p);function b(a,h,u){if(a===null&&h===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(a===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const g=u!==a,y=u!==h;return!g&&!y?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:g&&!y?{content:a,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:y&&!g?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:a,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[126],ae([0,1,42,17,15,13,19,20,30,18,40,250,24]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let f=e.UserDataProfilesManifestSynchroniser=class extends D.AbstractSynchroniser{constructor(h,u,g,y,L,n,s,t,i,r,o,c,v){super({syncResource:"profiles",profile:h},u,y,L,n,s,t,o,c,i,r,v),this.userDataProfilesService=g,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?b(h.syncData):null}async getRemoteSyncedProfiles(h){const u=await this.getLastSyncUserData(),g=await this.getLatestRemoteUserData(h,u);return g?.syncData?b(g.syncData):null}async generateSyncPreview(h,u,g){if(!this.userDataProfilesService.isEnabled())throw new m.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const y=h.syncData?b(h.syncData):null,L=u?.syncData?b(u.syncData):null,n=this.getLocalUserDataProfiles(),{local:s,remote:t}=(0,w.merge)(n,y,L,[]),i={local:s,remote:t,content:L?this.stringifyRemoteProfiles(L):null,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:t!==null?2:0},r=p(n,!1);return[{baseResource:this.baseResource,baseContent:L?this.stringifyRemoteProfiles(L):null,localResource:this.localResource,localContent:r,remoteResource:this.remoteResource,remoteContent:y?this.stringifyRemoteProfiles(y):null,remoteProfiles:y,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const u=h?.syncData?b(h.syncData):null,g=this.getLocalUserDataProfiles(),{remote:y}=(0,w.merge)(g,u,u,[]);return!!y?.added.length||!!y?.removed.length||!!y?.updated.length}async getMergeResult(h,u){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,u,g,y){if(this.extUri.isEqual(u,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(u,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(u,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async acceptLocal(h){const u=this.getLocalUserDataProfiles(),g=(0,w.merge)(u,null,null,[]),{local:y,remote:L}=g;return{content:h.localContent,local:y,remote:L,localChange:y.added.length>0||y.removed.length>0||y.updated.length>0?2:0,remoteChange:L!==null?2:0}}async acceptRemote(h){const u=h.remoteContent?JSON.parse(h.remoteContent):null,g=[],y=[];for(const L of this.getLocalUserDataProfiles()){const n=u?.find(s=>s.id===L.id);n&&(g.push({id:L.id,name:L.name,collection:n.collection}),y.push(L))}if(u!==null){const L=(0,w.merge)(y,u,g,[]),{local:n,remote:s}=L;return{content:h.remoteContent,local:n,remote:s,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:s!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(h,u,g,y){const{local:L,remote:n,localChange:s,remoteChange:t}=g[0][1];s===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const i=g[0][0].remoteProfiles||[];if(i.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new m.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(s!==0){await this.backupLocal(p(this.getLocalUserDataProfiles(),!1));const r=[];for(const o of L.added)r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${o.name}' profile...`),await this.userDataProfilesService.createProfile(o.id,o.name,{shortName:o.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${o.name}'.`)})());for(const o of L.removed)r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${o.name}' profile...`),await this.userDataProfilesService.removeProfile(o),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${o.name}'.`)})());for(const o of L.updated){const c=this.userDataProfilesService.profiles.find(v=>v.id===o.id);c?r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${o.name}' profile...`),await this.userDataProfilesService.updateProfile(c,{name:o.name,shortName:o.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${o.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(r)}if(t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const r=[],o=i.length+(n?.added.length??0)<=20;if(o)for(const c of n?.added||[]){const v=await this.userDataSyncStoreService.createCollection(this.syncHeaders);r.push(v),i.push({id:c.id,name:c.name,collection:v,shortName:c.shortName})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const c of n?.removed||[])i.splice(i.findIndex(({id:v})=>c.id===v),1);for(const c of n?.updated||[]){const v=i.find(({id:E})=>c.id===E);v&&i.splice(i.indexOf(v),1,{id:c.id,name:c.name,collection:v.collection,shortName:c.shortName})}try{h=await this.updateRemoteProfiles(i,y?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${o&&n?.added.length?` Added: ${JSON.stringify(n.added.map(c=>c.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(c=>c.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(c=>c.name))}.`:""}`)}catch(c){if(r.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of r)await this.userDataSyncStoreService.deleteCollection(v,this.syncHeaders)}throw c}for(const c of n?.removed||[])await this.userDataSyncStoreService.deleteCollection(c.collection,this.syncHeaders)}u?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,u){return this.updateRemoteUserData(this.stringifyRemoteProfiles(h),u)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(h){if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.baseResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)){const u=await this.resolvePreviewContent(h);return u&&(0,T.toFormattedString)(JSON.parse(u),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(h=>!h.isDefault&&!h.isTransient)}stringifyRemoteProfiles(h){return JSON.stringify([...h].sort((u,g)=>u.name.localeCompare(g.name)))}};e.UserDataProfilesManifestSynchroniser=f=Se([Y(2,S.IUserDataProfilesService),Y(3,A.IFileService),Y(4,l.IEnvironmentService),Y(5,_.IStorageService),Y(6,m.IUserDataSyncStoreService),Y(7,m.IUserDataSyncBackupStoreService),Y(8,m.IUserDataSyncLogService),Y(9,O.IConfigurationService),Y(10,m.IUserDataSyncEnablementService),Y(11,k.ITelemetryService),Y(12,P.IUriIdentityService)],f);function p(a,h){const u=[...a].sort((g,y)=>g.name.localeCompare(y.name)).map(g=>({id:g.id,name:g.name}));return h?(0,T.toFormattedString)(u,{}):JSON.stringify(u)}e.stringifyLocalProfiles=p;function b(a){return JSON.parse(a.content)}e.parseUserDataProfilesManifest=b}),define(oe[267],ae([0,1,6,16,64,2,23,17,15,13,18,24]),function(ie,e,T,O,l,A,_,k,P,S,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=e.UserDataSyncBackupStoreService=class extends A.Disposable{constructor(p,b,a,h,u){super(),this.environmentService=p,this.fileService=b,this.configurationService=a,this.logService=h,this.userDataProfilesService=u,this.cleanUp()}async cleanUp(){for(const b of this.userDataProfilesService.profiles)for(const a of w.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(b,a))}catch(h){this.logService.error(h)}let p;try{p=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(b){(0,S.toFileOperationResult)(b)!==1&&this.logService.error(b);return}if(p.children){for(const b of p.children)if(b.isDirectory&&!this.userDataProfilesService.profiles.some(a=>a.id===b.name))try{this.logService.info("Deleting non existing profile from backup",b.resource.path),await this.fileService.del(b.resource,{recursive:!0})}catch(a){this.logService.error(a)}}}async getAllRefs(p,b){const a=this.getResourceBackupHome(p,b);try{const h=await this.fileService.resolve(a);if(h.children)return h.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.getCreationTime(g)}))}catch(h){if((0,S.toFileOperationResult)(h)!==1)throw h}return[]}async resolveContent(p,b,a){const h=this.getResourceBackupHome(p,b),u=(0,_.joinPath)(h,a);try{return(await this.fileService.readFile(u)).value.toString()}catch(g){return this.logService.error(g),null}}async backup(p,b,a){const h=this.getResourceBackupHome(p,b),u=(0,_.joinPath)(h,`${(0,l.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(u,O.VSBuffer.fromString(a))}catch(g){this.logService.error(g)}try{this.cleanUpBackup(h)}catch{}}getResourceBackupHome(p,b){return(0,_.joinPath)(this.environmentService.userDataSyncHome,...p.isDefault?[b]:[p.id,b])}async cleanUpBackup(p){try{try{if(!await this.fileService.exists(p))return}catch{return}const b=await this.fileService.resolve(p);if(b.children){const a=b.children.filter(y=>y.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(y.name)).sort(),h=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let u=a.filter(y=>Date.now()-this.getCreationTime(y)>h);const g=a.length-u.length;g<10&&(u=u.slice(10-g)),await T.Promises.settled(u.map(async y=>{this.logService.info("Deleting from backup",y.resource.path),await this.fileService.del(y.resource)}))}}catch(b){this.logService.error(b)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};e.UserDataSyncBackupStoreService=m=Se([Y(0,P.IEnvironmentService),Y(1,S.IFileService),Y(2,k.IConfigurationService),Y(3,w.IUserDataSyncLogService),Y(4,D.IUserDataProfilesService)],m)}),define(oe[268],ae([0,1,3,2,4,15,19,20,24]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let D=e.UserDataSyncEnablementService=class extends O.Disposable{constructor(m,f,p,b){super(),this.storageService=m,this.telemetryService=f,this.environmentService=p,this.userDataSyncStoreManagementService=b,this._onDidChangeEnablement=new T.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new T.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(m.onDidChangeValue(a=>this.onDidStorageChange(a)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(S,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(S,{enabled:m}),this.storageService.store(S,m,-1,1))}isResourceEnabled(m){return this.storageService.getBoolean((0,P.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,f){if(this.isResourceEnabled(m)!==f){const p=(0,P.getEnablementKey)(m);this.storeResourceEnablement(p,f)}}getResourceSyncStateVersion(m){}storeResourceEnablement(m,f){this.storageService.store(m,f,-1,l.isWeb?0:1)}onDidStorageChange(m){if(m.scope!==-1)return;if(S===m.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const f=P.ALL_SYNC_RESOURCES.filter(p=>(0,P.getEnablementKey)(p)===m.key)[0];if(f){this._onDidChangeResourceEnablement.fire([f,this.isResourceEnabled(f)]);return}}};e.UserDataSyncEnablementService=D=Se([Y(0,_.IStorageService),Y(1,k.ITelemetryService),Y(2,A.IEnvironmentService),Y(3,P.IUserDataSyncStoreManagementService)],D)}),define(oe[82],ae([0,1,3,2,4,27,183,15,13,5,25,44,19,24]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const p="sync.currentMachineName",b="Safari",a="Chrome",h="Edge",u="Firefox",g="Android";function y(s){switch(s){case b:case a:case h:case u:case g:case(0,l.PlatformToString)(0):return!0}return!1}e.isWebPlatform=y;function L(){return l.isSafari?b:l.isChrome?a:l.isEdge?h:l.isFirefox?u:l.isAndroid?g:(0,l.PlatformToString)(l.isWeb?0:l.platform)}let n=e.UserDataSyncMachinesService=class it extends O.Disposable{constructor(t,i,r,o,c,v){super(),this.storageService=r,this.userDataSyncStoreService=o,this.logService=c,this.productService=v,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(t,i,r)}async getMachines(t){const i=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(o=>({...o,isCurrent:o.id===i}))}async addCurrentMachine(t){const i=await this.currentMachineIdPromise,r=await this.readMachinesData(t);r.machines.some(({id:o})=>o===i)||(r.machines.push({id:i,name:this.computeCurrentMachineName(r.machines),platform:L()}),await this.writeMachinesData(r))}async removeCurrentMachine(t){const i=await this.currentMachineIdPromise,r=await this.readMachinesData(t),o=r.machines.filter(({id:c})=>c!==i);o.length!==r.machines.length&&(r.machines=o,await this.writeMachinesData(r))}async renameMachine(t,i,r){const o=await this.readMachinesData(r),c=o.machines.find(({id:v})=>v===t);if(c){c.name=i,await this.writeMachinesData(o);const v=await this.currentMachineIdPromise;t===v&&this.storageService.store(p,i,-1,1)}}async setEnablements(t){const i=await this.readMachinesData();for(const[r,o]of t){const c=i.machines.find(v=>v.id===r);c&&(c.disabled=o?void 0:!0)}await this.writeMachinesData(i)}computeCurrentMachineName(t){const i=this.storageService.get(p,-1);if(i)return i;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${L()} (${this.productService.nameShort})`,o=new RegExp(`${(0,A.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let c=0;for(const v of t){const E=o.exec(v.name),d=E?parseInt(E[1]):0;c=d>c?d:c}return`${r} #${c+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const i=this.parse(this.userData);if(i.version!==it.VERSION)throw new Error((0,_.localize)(0,null,this.productService.nameLong));return i}async writeMachinesData(t){const i=JSON.stringify(t),r=await this.userDataSyncStoreService.writeResource(it.RESOURCE,i,this.userData?.ref||null);this.userData={ref:r,content:i},this._onDidChange.fire()}async readUserData(t){if(this.userData){const i=t&&t.latest?t.latest[it.RESOURCE]:void 0;if(this.userData.ref===i)return this.userData;if(i===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(it.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(i){this.logService.error(i)}return{version:it.VERSION,machines:[]}}};n.VERSION=1,n.RESOURCE="machines",e.UserDataSyncMachinesService=n=Se([Y(0,k.IEnvironmentService),Y(1,P.IFileService),Y(2,m.IStorageService),Y(3,f.IUserDataSyncStoreService),Y(4,f.IUserDataSyncLogService),Y(5,D.IProductService)],n)}),define(oe[269],ae([0,1,6,64,38,9,3,2,4,23,12,180,25,19,20,24,79,82]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const u="sync.disableMachineEventually",g="sync.sessionId",y="sync.storeUrl",L="sync.productQuality";let n=e.UserDataAutoSyncService=class extends k.Disposable{get syncUrl(){const i=this.storageService.get(y,-1);return i?D.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(y,i.toString(),-1,1):this.storageService.remove(y,-1)}get productQuality(){return this.storageService.get(L,-1)}set productQuality(i){i?this.storageService.store(L,i,-1,1):this.storageService.remove(L,-1)}constructor(i,r,o,c,v,E,d,I,R,N){super(),this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=c,this.userDataSyncService=v,this.logService=E,this.userDataSyncAccountService=d,this.telemetryService=I,this.userDataSyncMachinesService=R,this.storageService=N,this.autoSync=this._register(new k.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new T.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=r.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(r.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.syncUrl,r.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=r.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(d.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(v.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this._register(_.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:i,message:r}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new s(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(r&&this.logService.info(r),this.autoSync.clear()):r&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(r))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,O.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,r,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(g,-1),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(c){if(this.logService.error(c),r)this.updateEnablement(!1);else throw c}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const r=b.UserDataSyncError.toUserDataSyncError(i);r instanceof b.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:r.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),r.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):r.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):r.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):r.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):r.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):r.code==="UpgradeRequired"||r.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):r.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${r.resource} content with newer version than of client. Requires client upgrade.`)):r.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${r.resource} content with older version than of client. Requires server reset.`)):r.code==="ServiceChanged"||r.code==="DefaultServiceChanged"?P.isWeb&&r.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(r),this.successiveFailures++),this._onError.fire(r)}async disableMachineEventually(){this.storageService.store(u,!0,-1,1),await(0,T.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(u,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(u,-1)}async triggerSync(i,r,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(r&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const c=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:c}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=n=Se([Y(0,m.IProductService),Y(1,b.IUserDataSyncStoreManagementService),Y(2,b.IUserDataSyncStoreService),Y(3,b.IUserDataSyncEnablementService),Y(4,b.IUserDataSyncService),Y(5,b.IUserDataSyncLogService),Y(6,a.IUserDataSyncAccountService),Y(7,p.ITelemetryService),Y(8,h.IUserDataSyncMachinesService),Y(9,f.IStorageService)],n);class s extends k.Disposable{constructor(i,r,o,c,v,E,d,I,R){super(),this.lastSyncUrl=i,this.interval=r,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=c,this.userDataSyncService=v,this.userDataSyncMachinesService=E,this.logService=d,this.telemetryService=I,this.storageService=R,this.intervalHandler=this._register(new k.MutableDisposable),this._onDidStartSync=this._register(new _.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new _.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,k.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(s.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,T.disposableTimeout)(()=>this.sync(s.INTERVAL_SYNCING,!1),this.interval)}sync(i,r){const o=(0,T.createCancelablePromise)(async c=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(v){if((0,A.isCancellationError)(v))return}return this.doSync(i,r,c)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,S.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),r=this.userDataSyncStoreManagementService.userDataSyncStore;return!!r&&!!i&&(!(0,S.isEqual)(r.defaultUrl,i.defaultUrl)||!(0,S.isEqual)(r.insidersUrl,i.insidersUrl)||!(0,S.isEqual)(r.stableUrl,i.stableUrl))}async doSync(i,r,o){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let c;try{await this.createAndRunSyncTask(r,o)}catch(v){if(this.logService.error(v),c=v,b.UserDataSyncError.toUserDataSyncError(v).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(r,o),c=void 0}catch(E){this.logService.error(E),c=E}}this._onDidFinishSync.fire(c)}async createAndRunSyncTask(i,r){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,i),r.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new b.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new b.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new b.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const o=this.storageService.get(g,-1);if(o&&this.manifest&&o!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new b.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new b.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new b.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const c=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(r.isCancellationRequested)return;const v=c.find(d=>d.isCurrent);if(v?.disabled)throw new b.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");const E=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-E}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(d){throw new b.UserDataAutoSyncError((0,l.toErrorMessage)(d),d instanceof b.UserDataSyncError?d.code:"Unknown")}this.manifest&&this.manifest.session!==o&&this.storageService.store(g,this.manifest.session,-1,1),!r.isCancellationRequested&&(v||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(i){return super._register(i)}}s.INTERVAL_SYNCING="Interval"}),define(oe[270],ae([0,1,12,184,15,13,44,19,30,24,18,40,124,123,122,17,125,120,121,5,126,42]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=e.UserDataSyncResourceProviderService=class qe{constructor(t,i,r,o,c,v,E,d,I,R){this.userDataSyncStoreService=t,this.userDataSyncBackupStoreService=i,this.logService=r,this.environmentService=c,this.storageService=v,this.fileService=E,this.userDataProfilesService=d,this.configurationService=I,this.instantiationService=R,this.extUri=o.extUri}async getRemoteSyncedProfiles(){const t=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(t.content){const i=this.parseSyncData(t.content,"profiles");return(0,y.parseUserDataProfilesManifest)(i)}return[]}async getRemoteSyncResourceHandles(t,i){return(await this.userDataSyncStoreService.getAllResourceRefs(t,i?.collection)).map(({created:o,ref:c})=>({created:o,uri:this.toUri({remote:!0,syncResource:t,profile:i?.id??this.userDataProfilesService.defaultProfile.id,collection:i?.collection,ref:c,node:void 0})}))}async getLocalSyncResourceHandles(t,i){return(await this.userDataSyncBackupStoreService.getAllRefs(i,t)).map(({created:o,ref:c})=>({created:o,uri:this.toUri({remote:!1,syncResource:t,profile:i.id,collection:void 0,ref:c,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const i=this.resolveUri(t),r=i?this.userDataProfilesService.profiles.find(o=>o.id===i.profile):void 0;return i&&r?{profile:r,syncResource:i?.syncResource}:void 0}async getAssociatedResources({uri:t}){const i=this.resolveUri(t);if(!i)return[];const r=this.userDataProfilesService.profiles.find(o=>o.id===i.profile);switch(i.syncResource){case"settings":return this.getSettingsAssociatedResources(t,r);case"keybindings":return this.getKeybindingsAssociatedResources(t,r);case"tasks":return this.getTasksAssociatedResources(t,r);case"snippets":return this.getSnippetsAssociatedResources(t,r);case"globalState":return this.getGlobalStateAssociatedResources(t,r);case"extensions":return this.getExtensionsAssociatedResources(t,r);case"profiles":return this.getProfilesAssociatedResources(t,r)}}async getMachineId({uri:t}){const i=this.resolveUri(t);if(i){if(i.remote){if(i.ref){const{content:r}=await this.getUserData(i.syncResource,i.ref,i.collection);if(r)return this.parseSyncData(r,i.syncResource)?.machineId}return}return(0,_.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(t){const i=this.resolveUri(t);if(!i||i.node===qe.NOT_EXISTING_RESOURCE)return null;if(i.ref){const r=await this.getContentFromStore(i.remote,i.syncResource,i.profile,i.collection,i.ref);return i.node&&r?this.resolveNodeContent(i.syncResource,r,i.node):r}return!i.remote&&!i.node?this.resolveLatestContent(i.syncResource,i.profile):null}async getContentFromStore(t,i,r,o,c){if(t){const{content:E}=await this.getUserData(i,c,o);return E}const v=this.userDataProfilesService.profiles.find(E=>E.id===r);return v?this.userDataSyncBackupStoreService.resolveContent(v,i,c):null}resolveNodeContent(t,i,r){const o=this.parseSyncData(i,t);switch(t){case"settings":return this.resolveSettingsNodeContent(o,r);case"keybindings":return this.resolveKeybindingsNodeContent(o,r);case"tasks":return this.resolveTasksNodeContent(o,r);case"snippets":return this.resolveSnippetsNodeContent(o,r);case"globalState":return this.resolveGlobalStateNodeContent(o,r);case"extensions":return this.resolveExtensionsNodeContent(o,r);case"profiles":return this.resolveProfileNodeContent(o,r)}}async resolveLatestContent(t,i){const r=this.userDataProfilesService.profiles.find(o=>o.id===i);if(!r)return null;switch(t){case"globalState":return this.resolveLatestGlobalStateContent(r);case"extensions":return this.resolveLatestExtensionsContent(r);case"profiles":return this.resolveLatestProfilesContent(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}getSettingsAssociatedResources(t,i){const r=this.extUri.joinPath(t,"settings.json"),o=i?i.settingsResource:this.extUri.joinPath(t,qe.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:o}]}resolveSettingsNodeContent(t,i){switch(i){case"settings.json":return(0,f.parseSettingsSyncContent)(t.content).settings}return null}getKeybindingsAssociatedResources(t,i){const r=this.extUri.joinPath(t,"keybindings.json"),o=i?i.keybindingsResource:this.extUri.joinPath(t,qe.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:o}]}resolveKeybindingsNodeContent(t,i){switch(i){case"keybindings.json":return(0,p.getKeybindingsContentFromSyncContent)(t.content,!!this.configurationService.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(t,i){const r=this.extUri.joinPath(t,"tasks.json"),o=i?i.tasksResource:this.extUri.joinPath(t,qe.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:o}]}resolveTasksNodeContent(t,i){switch(i){case"tasks.json":return(0,a.getTasksContentFromSyncContent)(t.content,this.logService)}return null}async getSnippetsAssociatedResources(t,i){const r=await this.resolveContent(t);if(r){const o=this.parseSyncData(r,"snippets");if(o){const c=(0,m.parseSnippets)(o),v=[];for(const E of Object.keys(c)){const d=this.extUri.joinPath(t,E),I=i?this.extUri.joinPath(i.snippetsHome,E):this.extUri.joinPath(t,qe.NOT_EXISTING_RESOURCE);v.push({resource:d,comparableResource:I})}return v}}return[]}resolveSnippetsNodeContent(t,i){return(0,m.parseSnippets)(t)[i]||null}getExtensionsAssociatedResources(t,i){const r=this.extUri.joinPath(t,"extensions.json"),o=i?this.toUri({remote:!1,syncResource:"extensions",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,qe.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:o}]}resolveExtensionsNodeContent(t,i){switch(i){case"extensions.json":return(0,h.stringify)((0,h.parseExtensions)(t),!0)}return null}async resolveLatestExtensionsContent(t){const{localExtensions:i}=await this.instantiationService.createInstance(h.LocalExtensionsProvider).getLocalExtensions(t);return(0,h.stringify)(i,!0)}getGlobalStateAssociatedResources(t,i){const r=this.extUri.joinPath(t,"globalState.json"),o=i?this.toUri({remote:!1,syncResource:"globalState",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,qe.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:o}]}resolveGlobalStateNodeContent(t,i){switch(i){case"globalState.json":return(0,u.stringify)(JSON.parse(t.content),!0)}return null}async resolveLatestGlobalStateContent(t){const i=await this.instantiationService.createInstance(u.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,u.stringify)(i,!0)}getProfilesAssociatedResources(t,i){const r=this.extUri.joinPath(t,"profiles.json"),o=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:o}]}resolveProfileNodeContent(t,i){switch(i){case"profiles.json":return(0,L.toFormattedString)(JSON.parse(t.content),{})}return null}async resolveLatestProfilesContent(t){return(0,y.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(i=>!i.isDefault&&!i.isTransient),!0)}toUri(t){const i=t.remote?qe.REMOTE_BACKUP_AUTHORITY:qe.LOCAL_BACKUP_AUTHORITY,r=[t.syncResource,t.profile];return t.collection&&r.push(`collection:${t.collection}`),t.ref&&r.push(`ref:${t.ref}`),t.node&&r.push(t.node),this.extUri.joinPath(T.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:i,path:"/"}),...r)}resolveUri(t){if(t.scheme!==S.USER_DATA_SYNC_SCHEME||t.authority!==qe.LOCAL_BACKUP_AUTHORITY&&t.authority!==qe.REMOTE_BACKUP_AUTHORITY)return;const i=[];for(;t.path!=="/";)i.unshift(this.extUri.basename(t)),t=this.extUri.dirname(t);if(i.length<2)return;const r=t.authority===qe.REMOTE_BACKUP_AUTHORITY,o=i.shift(),c=i.shift();let v,E,d;for(;i.length;){const I=i.shift();I.startsWith("collection:")?v=I.substring(11):I.startsWith("ref:")?E=I.substring(4):d=I}return{remote:r,syncResource:o,profile:c,collection:v,ref:E,node:d}}parseSyncData(t,i){try{const r=JSON.parse(t);if((0,w.isSyncData)(r))return r}catch(r){this.logService.error(r)}throw new S.UserDataSyncError((0,O.localize)(0,null),"IncompatibleRemoteContent",i)}async getUserData(t,i,r){const o=await this.userDataSyncStoreService.resolveResourceContent(t,i,r);return{ref:i,content:o}}};n.NOT_EXISTING_RESOURCE="not-existing-resource",n.REMOTE_BACKUP_AUTHORITY="remote-backup",n.LOCAL_BACKUP_AUTHORITY="local-backup",e.UserDataSyncResourceProviderService=n=Se([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncBackupStoreService),Y(2,S.IUserDataSyncLogService),Y(3,P.IUriIdentityService),Y(4,l.IEnvironmentService),Y(5,k.IStorageService),Y(6,A.IFileService),Y(7,D.IUserDataProfilesService),Y(8,b.IConfigurationService),Y(9,g.IInstantiationService)],n)}),define(oe[271],ae([0,1,21,6,26,38,3,2,23,11,32,17,29,5,19,20,18,120,121,122,123,124,125,126,24]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g,y,L,n,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const i="sync.lastSyncTime";let r=e.UserDataSyncService=class extends k.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(d,I,R,N,F,W,q,B,Q){super(),this.userDataSyncStoreService=d,this.userDataSyncStoreManagementService=I,this.instantiationService=R,this.logService=N,this.telemetryService=F,this.storageService=W,this.userDataSyncEnablementService=q,this.userDataProfilesService=B,this.userDataSyncResourceProviderService=Q,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=I.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(i,-1,void 0),this._register((0,k.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(d,I){this.checkEnablement(),this.logService.info("Sync started.");const R=new Date().getTime(),N=(0,D.generateUuid)();try{const B=(0,t.createSyncHeaders)(N);I&&(B["Cache-Control"]="no-cache"),d=await this.userDataSyncStoreService.manifest(d,B)}catch(B){const Q=t.UserDataSyncError.toUserDataSyncError(B);throw v(Q,N,this.userDataSyncStoreManagementService,this.telemetryService),Q}const F=!1,W=this;let q;return{manifest:d,async run(){if(F)throw new Error("Can run a task only once");q=(0,O.createCancelablePromise)(B=>W.sync(d,!1,N,B)),await q.finally(()=>q=void 0),W.logService.info(`Sync done. Took ${new Date().getTime()-R}ms`),W.updateLastSyncTime()},stop(){return q?.cancel(),W.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const d=new Date().getTime(),I=(0,D.generateUuid)(),R=(0,t.createSyncHeaders)(I);let N;try{N=await this.userDataSyncStoreService.manifest(null,R)}catch(q){const B=t.UserDataSyncError.toUserDataSyncError(q);throw v(B,I,this.userDataSyncStoreManagementService,this.telemetryService),B}await this.resetLocal();const F=this,W=new l.CancellationTokenSource;return{id:I,async merge(){return F.sync(N,!0,I,W.token)},async apply(){try{try{await F.applyManualSync(N,I,W.token)}catch(q){if(t.UserDataSyncError.toUserDataSyncError(q).code==="MethodNotFound")F.logService.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.logService.info("Applying manual sync again..."),await F.applyManualSync(N,I,W.token);else throw q}}catch(q){throw F.logService.error(q),q}F.logService.info(`Sync done. Took ${new Date().getTime()-d}ms`),F.updateLastSyncTime()},async stop(){W.cancel(),await F.stop(),await F.resetLocal()}}}async sync(d,I,R,N){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(F,d,I,R,N));const W=F.enabled.find(q=>q.resource==="profiles");if(W){const q=await W.getLastSyncedProfiles()||[];if(N.isCancellationRequested)return;await this.syncRemoteProfiles(q,d,I,R,N)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(d,I,R,N,F){for(const W of d){if(F.isCancellationRequested)return;const q=this.userDataProfilesService.profiles.find(Q=>Q.id===W.id);if(!q){this.logService.error(`Profile with id:${W.id} and name: ${W.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",W.name);const B=this.getOrCreateActiveProfileSynchronizer(q,W);this._syncErrors.push(...await this.syncProfile(B,I,R,N,F))}for(const[W,q]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(B=>B.id===q[0].profile.id)||(q[1].dispose(),this.activeProfileSynchronizers.delete(W))}async applyManualSync(d,I,R){const N=this.getActiveProfileSynchronizers();for(const Q of N){if(R.isCancellationRequested)return;await Q.apply(I,R)}const F=N.find(Q=>Q.profile.isDefault);if(!F)return;const W=F.enabled.find(Q=>Q.resource==="profiles");if(!W)return;const B=(await W.getRemoteSyncedProfiles(d?.latest??null)||[]).filter(Q=>N.every(Z=>Z.profile.id!==Q.id));B.length&&await this.syncRemoteProfiles(B,d,!1,I,R)}async syncProfile(d,I,R,N,F){return(await d.sync(I,R,N,F)).map(([q,B])=>({profile:d.profile,syncResource:q,error:B}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(d=>d.stop()))}async resolveContent(d){const I=await this.userDataSyncResourceProviderService.resolveContent(d);if(I)return I;for(const R of this.getActiveProfileSynchronizers())for(const N of R.enabled){const F=await N.resolveContent(d);if(F)return F}return null}async replace(d){this.checkEnablement();const I=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(d);if(!I)return;const R=await this.resolveContent(d.uri);R&&await this.performAction(I.profile,async N=>{if(I.syncResource===N.resource)return await N.replace(R),!0})}async accept(d,I,R,N){this.checkEnablement(),await this.performAction(d.profile,async F=>{if(d.syncResource===F.resource)return await F.accept(I,R),N&&await F.apply((0,S.isBoolean)(N)?!1:N.force,(0,t.createSyncHeaders)((0,D.generateUuid)())),!0})}getRemoteProfiles(){return this.userDataSyncResourceProviderService.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(d,I){return this.userDataSyncResourceProviderService.getRemoteSyncResourceHandles(d,I)}async getLocalSyncResourceHandles(d,I){return this.userDataSyncResourceProviderService.getLocalSyncResourceHandles(d,I??this.userDataProfilesService.defaultProfile)}async getAssociatedResources(d){return this.userDataSyncResourceProviderService.getAssociatedResources(d)}async getMachineId(d){return this.userDataSyncResourceProviderService.getMachineId(d)}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async I=>{if(I.resource!=="globalState"&&await I.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async I=>{if(await I.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(d){this.logService.error(d)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(i,-1);for(const[d]of this.activeProfileSynchronizers.values())try{await d.resetLocal()}catch(I){this.logService.error(I)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const d=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),I=d.map(W=>W.collection),R=await this.userDataSyncStoreService.getAllCollections(),N=R.filter(W=>!I.includes(W));N.length&&(this.logService.info(`Deleting ${N.length} redundant collections on server`),await Promise.allSettled(N.map(W=>this.userDataSyncStoreService.deleteCollection(W))),this.logService.info("Deleted redundant collections on server"));const F=d.filter(W=>R.includes(W.collection));if(F.length!==d.length){this.logService.info("Updating remote profiles with invalid collections on server");const W=this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{await W.updateRemoteProfiles(F,null),this.logService.info("Updated remote profiles on server")}finally{W.dispose()}}}async performAction(d,I){const R=new k.DisposableStore;try{const N=this.activeProfileSynchronizers.get(d.id);if(N){const Q=await this.performActionWithProfileSynchronizer(N[0],I,R);return(0,S.isUndefined)(Q)?null:Q}if(d.isDefault){const Q=R.add(this.instantiationService.createInstance(o,d,void 0)),Z=await this.performActionWithProfileSynchronizer(Q,I,R);return(0,S.isUndefined)(Z)?null:Z}if(this.userDataProfilesService.isEnabled())return null;const F=R.add(this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,d,void 0)),W=await this.userDataSyncStoreService.manifest(null),B=(await F.getRemoteSyncedProfiles(W?.latest??null)||[]).find(Q=>Q.id===d.id);if(B){const Q=R.add(this.instantiationService.createInstance(o,d,B.collection)),Z=await this.performActionWithProfileSynchronizer(Q,I,R);return(0,S.isUndefined)(Z)?null:Z}return null}finally{R.dispose()}}async performActionWithProfileSynchronizer(d,I,R){const N=[...d.enabled,...d.disabled.map(F=>R.add(d.createSynchronizer(F)))];for(const F of N){const W=await I(F);if(!(0,S.isUndefined)(W))return W}}setStatus(d){const I=this._status;this._status!==d&&(this._status=d,this._onDidChangeStatus.fire(d),I==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const d=this.getActiveProfileSynchronizers().map(I=>I.conflicts).flat();(0,T.equals)(this._conflicts,d,(I,R)=>I.profile.id===R.profile.id&&I.syncResource===R.syncResource&&(0,T.equals)(I.conflicts,R.conflicts,(N,F)=>(0,P.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(i,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(d,I){let R=this.activeProfileSynchronizers.get(d.id);if(R&&R[0].collection!==I?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),R[1].dispose(),R=void 0,this.activeProfileSynchronizers.delete(d.id)),!R){const N=new k.DisposableStore,F=N.add(this.instantiationService.createInstance(o,d,I?.collection));N.add(F.onDidChangeStatus(W=>this.setStatus(W))),N.add(F.onDidChangeConflicts(W=>this.updateConflicts())),N.add(F.onDidChangeLocal(W=>this._onDidChangeLocal.fire(W))),this.activeProfileSynchronizers.set(d.id,R=[F,N])}return R[0]}getActiveProfileSynchronizers(){const d=[];for(const[I]of this.activeProfileSynchronizers.values())d.push(I);return d}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,d])=>d.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=r=Se([Y(0,t.IUserDataSyncStoreService),Y(1,t.IUserDataSyncStoreManagementService),Y(2,f.IInstantiationService),Y(3,t.IUserDataSyncLogService),Y(4,b.ITelemetryService),Y(5,p.IStorageService),Y(6,t.IUserDataSyncEnablementService),Y(7,a.IUserDataProfilesService),Y(8,t.IUserDataSyncResourceProviderService)],r);let o=class extends k.Disposable{get enabled(){return this._enabled.sort((d,I)=>d[1]-I[1]).map(([d])=>d)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(d=>!this.userDataSyncEnablementService.isResourceEnabled(d))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(d,I,R,N,F,W,q,B,Q,Z){super(),this.profile=d,this.collection=I,this.userDataSyncEnablementService=R,this.instantiationService=N,this.extensionGalleryService=F,this.userDataSyncStoreManagementService=W,this.telemetryService=q,this.logService=B,this.userDataProfilesService=Q,this.configurationService=Z,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(R.onDidChangeResourceEnablement(([K,x])=>this.onDidChangeResourceEnablement(K,x))),this._register((0,k.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,K])=>K.dispose())));for(const K of t.ALL_SYNC_RESOURCES)R.isResourceEnabled(K)&&this.registerSynchronizer(K)}onDidChangeResourceEnablement(d,I){I?this.registerSynchronizer(d):this.deRegisterSynchronizer(d)}registerSynchronizer(d){if(this._enabled.some(([F])=>F.resource===d))return;if(d==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(d==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled()))return;const I=new k.DisposableStore,R=I.add(this.createSynchronizer(d));I.add(R.onDidChangeStatus(()=>this.updateStatus())),I.add(R.onDidChangeConflicts(()=>this.updateConflicts())),I.add(R.onDidChangeLocal(()=>this._onDidChangeLocal.fire(d)));const N=this.getOrder(d);this._enabled.push([R,N,I])}deRegisterSynchronizer(d){const I=this._enabled.findIndex(([R])=>R.resource===d);if(I!==-1){const[[R,,N]]=this._enabled.splice(I,1);N.dispose(),this.updateStatus(),Promise.allSettled([R.stop(),R.resetLocal()]).then(null,F=>this.logService.error(F))}}createSynchronizer(d){switch(d){case"settings":return this.instantiationService.createInstance(y.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(g.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(L.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(u.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(h.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(d,I,R,N){if(N.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const W=[],q=(0,t.createSyncHeaders)(R),B=(this.collection?d?.collections?.[this.collection]?.latest:d?.latest)??null,Q=I?await this.getUserDataSyncConfiguration(B):{};for(const Z of F){if(N.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(Z.resource))return[];try{if(I){const K=await Z.preview(B,Q,q);if(K)for(const x of K.resourcePreviews)(x.localChange!==0||x.remoteChange!==0)&&x.mergeState==="preview"&&await Z.merge(x.previewResource)}else await Z.sync(B,q)}catch(K){const x=t.UserDataSyncError.toUserDataSyncError(K);if(v(x,R,this.userDataSyncStoreManagementService,this.telemetryService),c(K))throw x;this.logService.error(K),this.logService.error(`${Z.resource}: ${(0,A.toErrorMessage)(K)}`),W.push([Z.resource,x])}}return W}finally{this.updateStatus()}}async apply(d,I){const R=(0,t.createSyncHeaders)(d);for(const N of this.enabled){if(I.isCancellationRequested)return;try{await N.apply(!1,R)}catch(F){const W=t.UserDataSyncError.toUserDataSyncError(F);if(v(W,d,this.userDataSyncStoreManagementService,this.telemetryService),c(F))throw W;this.logService.error(F),this.logService.error(`${N.resource}: ${(0,A.toErrorMessage)(F)}`)}}}async stop(){for(const d of this.enabled)try{d.status!=="idle"&&await d.stop()}catch(I){this.logService.error(I)}}async resetLocal(){for(const d of this.enabled)try{await d.resetLocal()}catch(I){this.logService.error(`${d.resource}: ${(0,A.toErrorMessage)(I)}`),this.logService.error(I)}}async getUserDataSyncConfiguration(d){if(!this.profile.isDefault)return{};const I=this.configurationService.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),R=this.enabled.find(N=>N instanceof y.SettingsSynchroniser);if(R){const N=await R.getRemoteUserDataSyncConfiguration(d);return{...I,...N}}return I}setStatus(d){this._status!==d&&(this._status=d,this._onDidChangeStatus.fire(d))}updateStatus(){return this.updateConflicts(),this.enabled.some(d=>d.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(d=>d.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const d=this.enabled.filter(I=>I.status==="hasConflicts").filter(I=>I.conflicts.conflicts.length>0).map(I=>I.conflicts);(0,T.equals)(this._conflicts,d,(I,R)=>I.syncResource===R.syncResource&&(0,T.equals)(I.conflicts,R.conflicts,(N,F)=>(0,P.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}getOrder(d){switch(d){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};o=Se([Y(2,t.IUserDataSyncEnablementService),Y(3,f.IInstantiationService),Y(4,m.IExtensionGalleryService),Y(5,t.IUserDataSyncStoreManagementService),Y(6,b.ITelemetryService),Y(7,t.IUserDataSyncLogService),Y(8,a.IUserDataProfilesService),Y(9,w.IConfigurationService)],o);function c(E){if(E instanceof t.UserDataSyncError)switch(E.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function v(E,d,I,R){R.publicLog2("sync/error",{code:E.code,serverCode:E instanceof t.UserDataSyncStoreError?String(E.serverCode):void 0,url:E instanceof t.UserDataSyncStoreError?E.url:void 0,resource:E.resource,executionId:d,service:I.userDataSyncStore.url.toString()})}}),define(oe[272],ae([0,1,3,2,12,18,24]),function(ie,e,T,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function k(m,f){return{...m,profile:(0,A.reviveProfile)(m.profile,f.profilesHome.scheme)}}function P(m){return{created:m.created,uri:l.URI.revive(m.uri)}}class S{constructor(f,p,b){this.service=f,this.userDataProfilesService=p,this.logService=b,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new T.Emitter}listen(f,p){switch(p){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${p}`)}async call(f,p,b){try{return await this._call(f,p,b)}catch(a){throw this.logService.error(a),a}}async _call(f,p,b){switch(p){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(l.URI.revive(b[0]));case"accept":return this.service.accept(k(b[0],this.userDataProfilesService),l.URI.revive(b[1]),b[2],b[3]);case"getRemoteProfiles":return this.service.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0],b[1]?(0,A.reviveProfile)(b[1],this.userDataProfilesService.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0],b[1]);case"replace":return this.service.replace(P(b[0]));case"getAssociatedResources":return this.service.getAssociatedResources(P(b[0]));case"getMachineId":return this.service.getMachineId(P(b[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"createManualSyncTask":return this.createManualSyncTask()}if(p.startsWith("manualSync/")){const a=p.substring(11),h=b[0],u=this.getManualSyncTask(h);switch(b=b.slice(1),a){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.manualSyncTasks.delete(this.createKey(u.id)));case"stop":return u.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(u.id)))}}throw new Error("Invalid call")}getManualSyncTask(f){const p=this.manualSyncTasks.get(this.createKey(f));if(!p)throw new Error(`Manual sync taks not found: ${f}`);return p}async createManualSyncTask(){const f=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(f.id),f),f.id}createKey(f){return`manualSyncTask-${f}`}}e.UserDataSyncChannel=S;let D=e.UserDataSyncChannelClient=class extends O.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(f,p){super(),this.userDataProfilesService=p,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(b,a,h){return f.call(b,a,h).then(null,u=>{throw _.UserDataSyncError.toUserDataSyncError(u)})},listen(b,a){return f.listen(b,a)}},this.channel.call("_getInitialData").then(([b,a,h])=>{this.updateStatus(b),this.updateConflicts(a),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(u=>this.updateStatus(u))),this._register(this.channel.listen("onDidChangeLastSyncTime")(u=>this.updateLastSyncTime(u)))}),this._register(this.channel.listen("onDidChangeConflicts")(b=>this.updateConflicts(b))),this._register(this.channel.listen("onSyncErrors")(b=>this._onSyncErrors.fire(b.map(a=>({...a,error:_.UserDataSyncError.toUserDataSyncError(a.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.channel.call("createManualSyncTask"),p=this;return new w(f,{async call(a,h,u){return p.channel.call(`manualSync/${a}`,[f,...Array.isArray(h)?h:[h]],u)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(f,p,b,a){return this.channel.call("accept",[f,p,b,a])}resolveContent(f){return this.channel.call("resolveContent",[f])}getRemoteProfiles(){return this.channel.call("getRemoteProfiles")}async getLocalSyncResourceHandles(f,p){return(await this.channel.call("getLocalSyncResourceHandles",[f,p])).map(({created:a,uri:h})=>({created:a,uri:l.URI.revive(h)}))}async getRemoteSyncResourceHandles(f,p){return(await this.channel.call("getRemoteSyncResourceHandles",[f,p])).map(({created:a,uri:h})=>({created:a,uri:l.URI.revive(h)}))}async getAssociatedResources(f){return(await this.channel.call("getAssociatedResources",[f])).map(({resource:b,comparableResource:a})=>({resource:l.URI.revive(b),comparableResource:l.URI.revive(a)}))}getMachineId(f){return this.channel.call("getMachineId",[f])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(f){return this.channel.call("replace",[f])}async updateStatus(f){this._status=f,this._onDidChangeStatus.fire(f)}async updateConflicts(f){this._conflicts=f.map(p=>({syncResource:p.syncResource,profile:(0,A.reviveProfile)(p.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:p.conflicts.map(b=>({...b,baseResource:l.URI.revive(b.baseResource),localResource:l.URI.revive(b.localResource),remoteResource:l.URI.revive(b.remoteResource),previewResource:l.URI.revive(b.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(f){this._lastSyncTime!==f&&(this._lastSyncTime=f,this._onDidChangeLastSyncTime.fire(f))}};e.UserDataSyncChannelClient=D=Se([Y(1,A.IUserDataProfilesService)],D);class w extends O.Disposable{constructor(f,p){super(),this.id=f,this.channel=p}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(oe[273],ae([0,1,6,26,9,3,2,142,4,23,11,12,32,17,15,13,25,58,44,19,24]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const L="sync.previous.store",n="sync.donot-make-requests-until",s="sync.user-session-id",t="sync.machine-session-id",i=100,r=1e3*60*5;let o=e.AbstractUserDataSyncStoreManagementService=class extends _.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(y.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(R){this.storageService.store(y.SYNC_SERVICE_URL_TYPE,R,-1,P.isWeb?0:1)}constructor(R,N,F){super(),this.productService=R,this.configurationService=N,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new A.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(A.Event.filter(F.onDidChangeValue,W=>W.key===y.SYNC_SERVICE_URL_TYPE&&W.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[y.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(y.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(R,N){R=P.isWeb&&R?.web?{...R,...R.web}:R;const F={...R||{},...N||{}};if(F&&(0,D.isString)(F.url)&&(0,D.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(W=>Array.isArray(F.authenticationProviders[W].scopes))){const W=F,q=!!W.canSwitch&&!N?.url,B=W.url===W.insidersUrl?"insiders":"stable",Q=(q?this.userDataSyncStoreType:void 0)||B,Z=N?.url||(Q==="insiders"?W.insidersUrl:Q==="stable"?W.stableUrl:W.url);return{url:w.URI.parse(Z),type:Q,defaultType:B,defaultUrl:w.URI.parse(W.url),stableUrl:w.URI.parse(W.stableUrl),insidersUrl:w.URI.parse(W.insidersUrl),canSwitch:q,authenticationProviders:Object.keys(W.authenticationProviders).reduce((K,x)=>(K.push({id:x,scopes:W.authenticationProviders[x].scopes}),K),[])}}}};e.AbstractUserDataSyncStoreManagementService=o=Se([Y(0,a.IProductService),Y(1,f.IConfigurationService),Y(2,g.IStorageService)],o);let c=e.UserDataSyncStoreManagementService=class extends o{constructor(R,N,F){super(R,N,F);const W=this.storageService.get(L,-1);W&&(this.previousConfigurationSyncStore=JSON.parse(W));const q=this.productService[y.CONFIGURATION_SYNC_STORE_KEY];q?this.storageService.store(L,JSON.stringify(q),-1,1):this.storageService.remove(L,-1)}async switch(R){R!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=R,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=c=Se([Y(0,a.IProductService),Y(1,f.IConfigurationService),Y(2,g.IStorageService)],c);let v=e.UserDataSyncStoreClient=class extends _.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(R,N,F,W,q,B,Q){super(),this.requestService=F,this.logService=W,this.storageService=Q,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new A.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(R),this.commonHeadersPromise=(0,u.getServiceMachineId)(q,B,Q).then(Z=>{const K={"X-Client-Name":`${N.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(K["X-Client-Commit"]=N.commit),K}),this.session=new d(i,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,_.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(R,N){this.authToken={token:R,type:N}}updateUserDataSyncStoreUrl(R){this.userDataSyncStoreUrl=R?(0,S.joinPath)(R,"v1"):void 0}initDonotMakeRequestsUntil(){const R=this.storageService.getNumber(n,-1);R&&Date.now()<R&&this.setDonotMakeRequestsUntil(new Date(R))}setDonotMakeRequestsUntil(R){this._donotMakeRequestsUntil?.getTime()!==R?.getTime()&&(this._donotMakeRequestsUntil=R,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,T.createCancelablePromise)(N=>(0,T.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(n,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(R={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.userDataSyncStoreUrl,"collection").toString();R={...R},R["Content-Type"]="application/json";const F=await this.request(N,{type:"GET",headers:R},[],O.CancellationToken.None);return(await(0,h.asJson)(F))?.map(({id:W})=>W)||[]}async createCollection(R={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.userDataSyncStoreUrl,"collection").toString();R={...R},R["Content-Type"]=k.Mimes.text;const F=await this.request(N,{type:"POST",headers:R},[],O.CancellationToken.None),W=await(0,h.asTextOrError)(F);if(!W)throw new y.UserDataSyncStoreError("Server did not return the collection id",N,"NoCollection",F.res.statusCode,F.res.headers[y.HEADER_OPERATION_ID]);return W}async deleteCollection(R,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=R?(0,S.joinPath)(this.userDataSyncStoreUrl,"collection",R).toString():(0,S.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},await this.request(F,{type:"DELETE",headers:N},[],O.CancellationToken.None)}async getAllResourceRefs(R,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=this.getResourceUrl(this.userDataSyncStoreUrl,N,R),W={},q=await this.request(F.toString(),{type:"GET",headers:W},[],O.CancellationToken.None);return(await(0,h.asJson)(q)||[]).map(({url:Q,created:Z})=>({ref:(0,S.relativePath)(F,F.with({path:Q})),created:Z*1e3}))}async resolveResourceContent(R,N,F,W={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,S.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,R),N).toString();W={...W},W["Cache-Control"]="no-cache";const B=await this.request(q,{type:"GET",headers:W},[],O.CancellationToken.None);return await(0,h.asTextOrError)(B)}async deleteResource(R,N,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=N!==null?(0,S.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,R),N).toString():this.getResourceUrl(this.userDataSyncStoreUrl,F,R).toString(),q={};await this.request(W,{type:"DELETE",headers:q},[],O.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=(0,S.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":k.Mimes.text};await this.request(R,{type:"DELETE",headers:N},[],O.CancellationToken.None)}async readResource(R,N,F,W={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,S.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,R),"latest").toString();W={...W},W["Cache-Control"]="no-cache",N&&(W["If-None-Match"]=N.ref);const B=await this.request(q,{type:"GET",headers:W},[304],O.CancellationToken.None);let Q=null;if(B.res.statusCode===304&&(Q=N),Q===null){const Z=B.res.headers.etag;if(!Z)throw new y.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",B.res.statusCode,B.res.headers[y.HEADER_OPERATION_ID]);const K=await(0,h.asTextOrError)(B);if(!K&&B.res.statusCode===304)throw new y.UserDataSyncStoreError("Empty response",q,"EmptyResponse",B.res.statusCode,B.res.headers[y.HEADER_OPERATION_ID]);Q={ref:Z,content:K}}return Q}async writeResource(R,N,F,W,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=this.getResourceUrl(this.userDataSyncStoreUrl,W,R).toString();q={...q},q["Content-Type"]=k.Mimes.text,F&&(q["If-Match"]=F);const Q=await this.request(B,{type:"POST",data:N,headers:q},[],O.CancellationToken.None),Z=Q.res.headers.etag;if(!Z)throw new y.UserDataSyncStoreError("Server did not return the ref",B,"NoRef",Q.res.statusCode,Q.res.headers[y.HEADER_OPERATION_ID]);return Z}async manifest(R,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",R&&(N["If-None-Match"]=R.ref);const W=await this.request(F,{type:"GET",headers:N},[304],O.CancellationToken.None);let q=null;if(W.res.statusCode===304&&(q=R),!q){const Q=W.res.headers.etag;if(!Q)throw new y.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",W.res.statusCode,W.res.headers[y.HEADER_OPERATION_ID]);const Z=await(0,h.asTextOrError)(W);if(!Z&&W.res.statusCode===304)throw new y.UserDataSyncStoreError("Empty response",F,"EmptyResponse",W.res.statusCode,W.res.headers[y.HEADER_OPERATION_ID]);Z&&(q={...JSON.parse(Z),ref:Q})}const B=this.storageService.get(s,-1);return B&&q&&B!==q.session&&this.clearSession(),q===null&&B&&this.clearSession(),q&&this.storageService.store(s,q.session,-1,1),q}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}getResourceUrl(R,N,F){return N?(0,S.joinPath)(R,"collection",N,"resource",F):(0,S.joinPath)(R,"resource",F)}clearSession(){this.storageService.remove(s,-1),this.storageService.remove(t,-1)}async request(R,N,F,W){if(!this.authToken)throw new y.UserDataSyncStoreError("No Auth Token Available",R,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new y.UserDataSyncStoreError(`${N.type} request '${R}' failed because of too many requests (429).`,R,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const q=await this.commonHeadersPromise;N.headers={...N.headers||{},...q,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:R,type:N.type,headers:{...N.headers,authorization:void 0}});let B;try{B=await this.session.request(R,N,W)}catch($){if(!($ instanceof y.UserDataSyncStoreError)){let j="RequestFailed";const te=(0,l.getErrorMessage)($).toLowerCase();te.includes("xhr timeout")?j="RequestTimeout":te.includes("protocol")&&te.includes("not supported")?j="RequestProtocolNotSupported":te.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":te.includes("headers must be an object")?j="RequestHeadersNotObject":(0,l.isCancellationError)($)&&(j="RequestCanceled"),$=new y.UserDataSyncStoreError(`Connection refused for the request '${R}'.`,R,j,void 0,void 0)}throw this.logService.info("Request failed",R),$}const Q=B.res.headers[y.HEADER_OPERATION_ID],Z={url:R,status:B.res.statusCode,"execution-id":N.headers[y.HEADER_EXECUTION_ID],"operation-id":Q},K=(0,h.isSuccess)(B)||B.res.statusCode&&F.indexOf(B.res.statusCode)!==-1;let x="";if(K?this.logService.trace("Request succeeded",Z):(this.logService.info("Request failed",Z),x=await(0,h.asText)(B)||""),B.res.statusCode===401||B.res.statusCode===403){if(this.authToken=void 0,B.res.statusCode===401)throw this._onTokenFailed.fire("Unauthorized"),new y.UserDataSyncStoreError(`${N.type} request '${R}' failed because of Unauthorized (401).`,R,"Unauthorized",B.res.statusCode,Q);if(B.res.statusCode===403)throw this._onTokenFailed.fire("Forbidden"),new y.UserDataSyncStoreError(`${N.type} request '${R}' failed because the access is forbidden (403).`,R,"Forbidden",B.res.statusCode,Q)}if(this._onTokenSucceed.fire(),B.res.statusCode===404)throw new y.UserDataSyncStoreError(`${N.type} request '${R}' failed because the requested resource is not found (404).`,R,"NotFound",B.res.statusCode,Q);if(B.res.statusCode===405)throw new y.UserDataSyncStoreError(`${N.type} request '${R}' failed because the requested endpoint is not found (405). ${x}`,R,"MethodNotFound",B.res.statusCode,Q);if(B.res.statusCode===409)throw new y.UserDataSyncStoreError(`${N.type} request '${R}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,R,"Conflict",B.res.statusCode,Q);if(B.res.statusCode===410)throw new y.UserDataSyncStoreError(`${N.type} request '${R}' failed because the requested resource is not longer available (410).`,R,"Gone",B.res.statusCode,Q);if(B.res.statusCode===412)throw new y.UserDataSyncStoreError(`${N.type} request '${R}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,R,"PreconditionFailed",B.res.statusCode,Q);if(B.res.statusCode===413)throw new y.UserDataSyncStoreError(`${N.type} request '${R}' failed because of too large payload (413).`,R,"TooLarge",B.res.statusCode,Q);if(B.res.statusCode===426)throw new y.UserDataSyncStoreError(`${N.type} request '${R}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,R,"UpgradeRequired",B.res.statusCode,Q);if(B.res.statusCode===429){const $=B.res.headers["retry-after"];throw $?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt($)*1e3)),new y.UserDataSyncStoreError(`${N.type} request '${R}' failed because of too many requests (429).`,R,"TooManyRequestsAndRetryAfter",B.res.statusCode,Q)):new y.UserDataSyncStoreError(`${N.type} request '${R}' failed because of too many requests (429).`,R,"RemoteTooManyRequests",B.res.statusCode,Q)}if(!K)throw new y.UserDataSyncStoreError("Server returned "+B.res.statusCode,R,"Unknown",B.res.statusCode,Q);return B}addSessionHeaders(R){let N=this.storageService.get(t,-1);N===void 0&&(N=(0,m.generateUuid)(),this.storageService.store(t,N,-1,1)),R["X-Machine-Session-Id"]=N;const F=this.storageService.get(s,-1);F!==void 0&&(R["X-User-Session-Id"]=F)}};e.UserDataSyncStoreClient=v=Se([Y(1,a.IProductService),Y(2,h.IRequestService),Y(3,y.IUserDataSyncLogService),Y(4,p.IEnvironmentService),Y(5,b.IFileService),Y(6,g.IStorageService)],v);let E=e.UserDataSyncStoreService=class extends v{constructor(R,N,F,W,q,B,Q){super(R.userDataSyncStore?.url,N,F,W,q,B,Q),this._register(R.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(R.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=E=Se([Y(0,y.IUserDataSyncStoreManagementService),Y(1,a.IProductService),Y(2,h.IRequestService),Y(3,y.IUserDataSyncLogService),Y(4,p.IEnvironmentService),Y(5,b.IFileService),Y(6,g.IStorageService)],E);class d{constructor(R,N,F,W){this.limit=R,this.interval=N,this.requestService=F,this.logService=W,this.requests=[],this.startTime=void 0}request(R,N,F){if(this.isExpired()&&this.reset(),N.url=R,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new y.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,R,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(R),this.requestService.request(N,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=d}),define(oe[274],ae([0,1,3,56,25,19,20,269,24,79,82]),function(ie,e,T,O,l,A,_,k,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=e.UserDataAutoSyncService=class extends k.UserDataAutoSyncService{constructor(f,p,b,a,h,u,g,y,L,n,s){super(f,p,b,a,h,g,y,L,n,s),this._register(T.Event.debounce(T.Event.any(T.Event.map(u.onDidFocusWindow,()=>"windowFocus"),T.Event.map(u.onDidOpenWindow,()=>"windowOpen")),(t,i)=>t?[...t,i]:[i],1e3)(t=>this.triggerSync(t,!0,!1)))}};e.UserDataAutoSyncService=w=Se([Y(0,l.IProductService),Y(1,P.IUserDataSyncStoreManagementService),Y(2,P.IUserDataSyncStoreService),Y(3,P.IUserDataSyncEnablementService),Y(4,P.IUserDataSyncService),Y(5,O.INativeHostService),Y(6,P.IUserDataSyncLogService),Y(7,S.IUserDataSyncAccountService),Y(8,_.ITelemetryService),Y(9,D.IUserDataSyncMachinesService),Y(10,A.IStorageService)],w)}),define(oe[275],ae([0,1,71,22,4,23]),function(ie,e,T,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function _(S){function D(){let w=S.scheme===O.Schemas.file?(0,A.originalFSPath)(S):S.toString();return l.isLinux||(w=w.toLowerCase()),(0,T.createHash)("md5").update(w).digest("hex")}return{id:D(),configPath:S}}e.getWorkspaceIdentifier=_;function k(S,D){function w(){if(S.scheme!==O.Schemas.file)return(0,T.createHash)("md5").update(S.toString()).digest("hex");if(!D)return;let f;return l.isLinux?f=D.ino:l.isMacintosh?f=D.birthtime.getTime():l.isWindows&&(typeof D.birthtimeMs=="number"?f=Math.floor(D.birthtimeMs):f=D.birthtime.getTime()),(0,T.createHash)("md5").update(S.fsPath).update(f?String(f):"").digest("hex")}const m=w();if(typeof m=="string")return{id:m,uri:S}}e.getSingleFolderWorkspaceIdentifier=k;function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=P}),define(oe[276],ae([0,1,6,9,2,14,28,15,10,77,118,275,56,73]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let p=e.UnusedWorkspaceStorageDataCleaner=class extends l.Disposable{constructor(a,h,u,g){super(),this.environmentService=a,this.logService=h,this.nativeHostService=u,this.mainProcessService=g,this._register(new T.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const a=await _.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),h=new S.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(a.map(async u=>{const g=(0,A.join)(this.environmentService.workspaceStorageHome.fsPath,u);u.length===w.NON_EMPTY_WORKSPACE_ID_LENGTH||u===D.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(n=>n.workspace?.id===u)||await h.isUsed(g)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${u} as it seems to be an unused empty workspace.`),await _.Promises.rm(g))}))}catch(a){(0,O.onUnexpectedError)(a)}}};e.UnusedWorkspaceStorageDataCleaner=p=Se([Y(0,k.INativeEnvironmentService),Y(1,P.ILogService),Y(2,m.INativeHostService),Y(3,f.IMainProcessService)],p)}),define(oe[83],ae([0,1,53,6,14,11,28,150,288,289]),function(ie,e,T,O,l,A,_,k,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const D=new RegExp(e.CorruptZipMessage);class w extends Error{constructor(s,t){let i=t.message;switch(s){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=s,this.cause=t}}e.ExtractError=w;function m(n){const s=n.externalFileAttributes>>16||33188;return[448,56,7].map(t=>s&t).reduce((t,i)=>t+i,s&61440)}function f(n){if(n instanceof w)return n;let s;return D.test(n.message)&&(s="CorruptZip"),new w(s,n)}function p(n,s,t,i,r,o){const c=l.dirname(s),v=l.join(i,c);if(!v.startsWith(i))return Promise.reject(new Error(k.localize(0,null,s)));const E=l.join(i,s);let d;return o.onCancellationRequested(()=>{d?.destroy()}),Promise.resolve(_.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((I,R)=>{if(!o.isCancellationRequested)try{d=(0,T.createWriteStream)(E,{mode:t}),d.once("close",()=>I()),d.once("error",R),n.once("error",R),n.pipe(d)}catch(N){R(N)}}))}function b(n,s,t,i){let r=(0,O.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{r.cancel(),n.close()}),new Promise((c,v)=>{const E=new O.Sequencer,d=I=>{I.isCancellationRequested||(o++,n.readEntry())};n.once("error",v),n.once("close",()=>r.then(()=>{i.isCancellationRequested||n.entryCount===o?c():v(new w("Incomplete",new Error(k.localize(1,null,o,n.entryCount))))},v)),n.readEntry(),n.on("entry",I=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(I.fileName)){d(i);return}const R=I.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(R)){const W=l.join(s,R);r=(0,O.createCancelablePromise)(q=>_.Promises.mkdir(W,{recursive:!0}).then(()=>d(q)).then(void 0,v));return}const N=h(n,I),F=m(I);r=(0,O.createCancelablePromise)(W=>E.queue(()=>N.then(q=>p(q,R,F,s,t,W).then(()=>d(W)))).then(null,v))})})}function a(n,s=!1){return new Promise((t,i)=>{(0,P.open)(n,s?{lazyEntries:!0}:void 0,(r,o)=>{r?i(f(r)):t((0,A.assertIsDefined)(o))})})}function h(n,s){return new Promise((t,i)=>{n.openReadStream(s,(r,o)=>{r?i(f(r)):t((0,A.assertIsDefined)(o))})})}function u(n,s){return new Promise((t,i)=>{const r=new S.ZipFile;s.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const o=(0,T.createWriteStream)(n);r.outputStream.pipe(o),r.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>t(n))})}e.zip=u;function g(n,s,t={},i){const r=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let o=a(n,!0);return t.overwrite&&(o=o.then(c=>_.Promises.rm(s).then(()=>c))),o.then(c=>b(c,s,{sourcePathRegex:r},i))}e.extract=g;function y(n,s){return a(n).then(t=>new Promise((i,r)=>{t.on("entry",o=>{o.fileName===s&&h(t,o).then(c=>i(c),c=>r(c))}),t.once("close",()=>r(new Error(k.localize(2,null,s))))}))}function L(n,s){return y(n,s).then(t=>new Promise((i,r)=>{const o=[];t.once("error",r),t.on("data",c=>o.push(c)),t.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=L}),define(oe[277],ae([0,1,6,9,2,22,4,23,54,11,32,28,83,17,15,29,33,101,13,10]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let y=e.ExtensionsDownloader=class pt extends l.Disposable{constructor(n,s,t,i,r,o){super(),this.fileService=s,this.extensionGalleryService=t,this.configurationService=i,this.extensionSignatureVerificationService=r,this.logService=o,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(n,s,t){await this.cleanUpPromise;const i=(0,k.joinPath)(this.extensionsDownloadDir,this.getName(n));try{await this.downloadFile(n,i,o=>this.extensionGalleryService.download(n,o,s))}catch(o){throw new b.ExtensionManagementError(o.message,b.ExtensionManagementErrorCode.Download)}let r=!1;if(t&&this.shouldVerifySignature(n)){const o=await this.downloadSignatureArchive(n);try{r=await this.extensionSignatureVerificationService.verify(i.fsPath,o.fsPath,this.logService.getLevel()===g.LogLevel.Trace)}catch(c){const v=c;if(r=v.code,v.output&&this.logService.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${v.output}`),r===b.ExtensionSignaturetErrorCode.PackageIsInvalidZip||r===b.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new b.ExtensionManagementError(m.CorruptZipMessage,b.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(c){this.logService.error(c)}}}return r===!0?this.logService.info(`Extension signature is verified: ${n.identifier.id}`):r===!1?this.logService.info(`Extension signature verification is not done: ${n.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${r}': ${n.identifier.id}`),{location:i,verificationStatus:r}}shouldVerifySignature(n){if(!n.isSigned)return!1;const s=this.configurationService.getValue("extensions.verifySignature");return(0,S.isBoolean)(s)?s:!0}async downloadSignatureArchive(n){await this.cleanUpPromise;const s=(0,k.joinPath)(this.extensionsDownloadDir,`${this.getName(n)}${pt.SignatureArchiveExtension}`);return await this.downloadFile(n,s,t=>this.extensionGalleryService.downloadSignatureArchive(n,t)),s}async downloadFile(n,s,t){if(await this.fileService.exists(s))return;if(s.scheme!==A.Schemas.file){await t(s);return}const i=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,D.generateUuid)()}`);await this.fileService.exists(i)||await t(i);try{await this.rename(i,s,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(i)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,s.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(r)}. Deleted the file from downloaded location`,i.path),r}}async delete(n){await this.cleanUpPromise,await this.fileService.del(n)}async rename(n,s,t){try{await w.Promises.rename(n.fsPath,s.fsPath)}catch(i){if(_.isWindows&&i&&i.code==="EPERM"&&Date.now()<t)return this.logService.info(`Failed renaming ${n} to ${s} with 'EPERM' error. Trying again...`),this.rename(n,s,t);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const s=[],t=[],i=[];for(const c of n.children)if(c.name.endsWith(pt.SignatureArchiveExtension))i.push(c.resource);else{const v=a.ExtensionKey.parse(c.name);v&&t.push([v,c])}const r=(0,a.groupByExtension)(t,([c])=>c),o=[];for(const c of r)c.sort((v,E)=>P.rcompare(v[0].version,E[0].version)),s.push(...c.slice(1).map(v=>v[1].resource)),o.push(c[0][1]);o.sort((c,v)=>c.mtime-v.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(c=>c.resource)),s.push(...i),await T.Promises.settled(s.map(c=>(this.logService.trace("Deleting from cache",c.path),this.fileService.del(c))))}}catch(n){this.logService.error(n)}}getName(n){return this.cache?a.ExtensionKey.create(n).toString().toLowerCase():(0,D.generateUuid)()}};y.SignatureArchiveExtension=".sigzip",e.ExtensionsDownloader=y=Se([Y(0,p.INativeEnvironmentService),Y(1,u.IFileService),Y(2,b.IExtensionGalleryService),Y(3,f.IConfigurationService),Y(4,h.IExtensionSignatureVerificationService),Y(5,g.ILogService)],y)}),define(oe[278],ae([0,1,83,161]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function l(A){return(0,T.buffer)(A,"extension/package.json").then(_=>{try{return JSON.parse(_.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=l}),define(oe[127],ae([0,1,6,16,26,38,9,3,2,37,22,14,4,23,54,11,12,32,28,83,160,100,15,257,29,33,51,80,277,258,278,218,229,68,13,5,10,25,20,30,18]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g,y,L,n,s,t,i,r,o,c,v,E,d,I,R,N,F,W,q,B,Q,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(t.IExtensionManagementService);let K=e.ExtensionManagementService=class extends s.AbstractExtensionManagementService{constructor(J,G,M,C,U,z,H,V,X,ee,ce,ue){super(J,G,M,ee,ue),this.extensionsScannerService=U,this.extensionsProfileScannerService=z,this.downloadService=H,this.fileService=X,this.uriIdentityService=ce,this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this.onDidUpdateExtensionMetadata=this._onDidUpdateExtensionMetadata.event,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new S.ResourceSet;const fe=this._register(V.createInstance(v.ExtensionsLifecycle));this.extensionsScanner=this._register(V.createInstance(x,ye=>fe.postUninstall(ye))),this.manifestCache=this._register(new d.ExtensionsManifestCache(ue,X,ce,this,this.logService)),this.extensionsDownloader=this._register(V.createInstance(c.ExtensionsDownloader));const ve=this._register(new I.ExtensionsWatcher(this,this.extensionsScannerService,ue,z,ce,X,M));this._register(ve.onDidChangeExtensionsByAnotherSource(ye=>this.onDidChangeExtensionsFromAnotherSource(ye))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(J){this.logService.trace("ExtensionManagementService#zip",J.identifier.id);const G=await this.collectFiles(J),M=await(0,g.zip)((0,f.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,G);return a.URI.file(M)}async unzip(J){return this.logService.trace("ExtensionManagementService#unzip",J.toString()),(await this.install(J)).identifier}async getManifest(J){const{location:G,cleanup:M}=await this.downloadVsix(J),C=w.resolve(G.fsPath);try{return await(0,E.getManifest)(C)}finally{await M()}}getInstalled(J,G=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(J??null,G)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(J){return this.extensionsScanner.scanUserExtensionAtLocation(J)}async install(J,G={}){this.logService.trace("ExtensionManagementService#install",J.toString());const{location:M,cleanup:C}=await this.downloadVsix(J);try{const U=await(0,E.getManifest)(w.resolve(M.fsPath));if(U.engines&&U.engines.vscode&&!(0,R.isEngineValid)(U.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,i.getGalleryExtensionId)(U.publisher,U.name),this.productService.version));return await this.installExtension(U,M,G)}finally{await C()}}async installFromLocation(J,G){this.logService.trace("ExtensionManagementService#installFromLocation",J.toString());const M=await this.extensionsScanner.scanUserExtensionAtLocation(J);if(!M)throw new Error(`Cannot find a valid extension from the location ${J.toString()}`);return await this.addExtensionsToProfile([[M,void 0]],G),this.logService.info("Successfully installed extension",M.identifier.id,G.toString()),M}async installExtensionsFromProfile(J,G,M){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",J,G.toString(),M.toString());const C=(await this.extensionsScanner.scanExtensions(1,G)).filter(U=>J.some(z=>(0,i.areSameExtensions)(z,U.identifier)));if(C.length){const U=await Promise.all(C.map(z=>this.extensionsScanner.scanMetadata(z,G)));await this.addExtensionsToProfile(C.map((z,H)=>[z,U[H]]),M),this.logService.info("Successfully installed extensions",C.map(z=>z.identifier.id),M.toString())}return C}async updateMetadata(J,G,M=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",J.identifier.id),G.isPreReleaseVersion&&(G.preRelease=!0),G.isMachineScoped=G.isMachineScoped||void 0,G.isBuiltin=G.isBuiltin||void 0,G.pinned=G.pinned||void 0,J=await this.extensionsScanner.updateMetadata(J,G,M),this.manifestCache.invalidate(M),this._onDidUpdateExtensionMetadata.fire(J),J}async reinstallFromGallery(J){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",J.identifier.id),!this.galleryService.isEnabled())throw new Error(y.localize(1,null));const G=await this.getTargetPlatform(),[M]=await this.galleryService.getExtensions([{...J.identifier,preRelease:J.preRelease}],{targetPlatform:G,compatible:!0},l.CancellationToken.None);if(!M)throw new Error(y.localize(2,null));await this.extensionsScanner.setUninstalled(J);try{await this.extensionsScanner.removeUninstalledExtension(J)}catch(C){throw new Error(y.localize(3,null,(0,A.toErrorMessage)(C)))}return this.installFromGallery(M)}copyExtensions(J,G){return this.extensionsScanner.copyExtensions(J,G)}markAsUninstalled(...J){return this.extensionsScanner.setUninstalled(...J)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(J){this.logService.error(J)}}async download(J,G,M){const{location:C}=await this.extensionsDownloader.download(J,G,!M);return C}async downloadVsix(J){if(J.scheme===D.Schemas.file)return{location:J,async cleanup(){}};this.logService.trace("Downloading extension from",J.toString());const G=(0,f.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,h.generateUuid)());return await this.downloadService.download(J,G),this.logService.info("Downloaded extension to",G.toString()),{location:G,cleanup:async()=>{try{await this.fileService.del(G)}catch(C){this.logService.error(C)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(J,G,M){if(a.URI.isUri(G))return new te(J,G,M,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const C=i.ExtensionKey.create(G).toString();let U=this.installGalleryExtensionsTasks.get(C);return U||(this.installGalleryExtensionsTasks.set(C,U=new j(J,G,M,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),U.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(C))),U}createUninstallExtensionTask(J,G){return new ne(J,G.profileLocation,this.extensionsProfileScannerService)}async collectFiles(J){const G=async C=>{let U=await u.Promises.readdir(C);U=U.map(V=>w.join(C,V));const z=await Promise.all(U.map(V=>u.Promises.stat(V)));let H=Promise.resolve([]);return z.forEach((V,X)=>{const ee=U[X];V.isFile()&&(H=H.then(ce=>[...ce,ee])),V.isDirectory()&&(H=H.then(ce=>G(ee).then(ue=>[...ce,...ue])))}),H};return(await G(J.location.fsPath)).map(C=>({path:`extension/${w.relative(J.location.fsPath,C)}`,localPath:C}))}async onDidChangeExtensionsFromAnotherSource({added:J,removed:G}){if(G)for(const M of G.extensions)this.logService.info("Extensions removed from another source",M.id,G.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:M,profileLocation:G.profileLocation});if(J){const C=(await this.extensionsScanner.scanExtensions(1,J.profileLocation)).filter(U=>J.extensions.some(z=>(0,i.areSameExtensions)(z,U.identifier)));this._onDidInstallExtensions.fire(C.map(U=>(this.logService.info("Extensions added from another source",U.identifier.id,J.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:J.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(G=>this.knownDirectories.add(G)));const J=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const G of J.children??[])G.isDirectory&&this.knownDirectories.add(G.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(G=>this.onDidFilesChange(G)))}async onDidFilesChange(J){if(!J.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const G=[];for(const M of J.rawAdded){if(this.knownDirectories.has(M)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(M),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(M,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(M).startsWith(".")||!(await this.fileService.stat(M)).isDirectory)continue;const C=await this.extensionsScanner.scanUserExtensionAtLocation(M);C&&C.installedTimestamp===void 0&&(this.knownDirectories.add(M),G.push(C))}G.length&&(await this.addExtensionsToProfile(G.map(M=>[M,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",G.map(M=>M.identifier.id)))}async addExtensionsToProfile(J,G){const M=J.map(C=>C[0]);await this.setInstalled(M),await this.extensionsProfileScannerService.addExtensionsToProfile(J,G),this._onDidInstallExtensions.fire(M.map(C=>({local:C,identifier:C.identifier,operation:1,profileLocation:G})))}async setInstalled(J){const G=await this.extensionsScanner.getUninstalledExtensions();for(const M of J){const C=i.ExtensionKey.create(M);G[C.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",C.id),await this.extensionsScanner.setInstalled(C),this.logService.info("Removed the extension from uninstalled list:",C.id))}}};e.ExtensionManagementService=K=Se([Y(0,t.IExtensionGalleryService),Y(1,B.ITelemetryService),Y(2,W.ILogService),Y(3,n.INativeEnvironmentService),Y(4,o.IExtensionsScannerService),Y(5,r.IExtensionsProfileScannerService),Y(6,L.IDownloadService),Y(7,F.IInstantiationService),Y(8,N.IFileService),Y(9,q.IProductService),Y(10,Q.IUriIdentityService),Y(11,Z.IUserDataProfilesService)],K);let x=e.ExtensionsScanner=class extends P.Disposable{constructor(J,G,M,C,U,z){super(),this.beforeRemovingExtension=J,this.fileService=G,this.extensionsScannerService=M,this.extensionsProfileScannerService=C,this.uriIdentityService=U,this.logService=z,this._onExtract=this._register(new k.Emitter),this.onExtract=this._onExtract.event,this.cleanUpGeneratedFoldersPromise=Promise.resolve(),this.uninstalledResource=(0,f.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new T.Queue}async cleanUp(){await this.removeUninstalledExtensions(),this.cleanUpGeneratedFoldersPromise=this.cleanUpGeneratedFoldersPromise.then(()=>this.removeGeneratedFolders()),await this.cleanUpGeneratedFoldersPromise}async scanExtensions(J,G){const M={includeInvalid:!0,profileLocation:G};let C=[];return J===null||J===0?C.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},M,!1)):J===1&&C.push(...await this.extensionsScannerService.scanUserExtensions(M)),C=J!==null?C.filter(U=>U.type===J):C,Promise.all(C.map(U=>this.toLocalExtension(U)))}async scanAllUserExtensions(J){const G=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!J,includeInvalid:!0});return Promise.all(G.map(M=>this.toLocalExtension(M)))}async scanUserExtensionAtLocation(J){try{const G=await this.extensionsScannerService.scanExistingExtension(J,1,{includeInvalid:!0});if(G)return await this.toLocalExtension(G)}catch(G){this.logService.error(G)}return null}async extractUserExtension(J,G,M,C){await this.cleanUpGeneratedFoldersPromise.catch(()=>{});const U=J.toString(),z=w.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`),H=w.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U);try{await u.Promises.rm(H)}catch{throw new t.ExtensionManagementError(y.localize(4,null,H,J.id),t.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(J,G,z,C),await this.extensionsScannerService.updateMetadata(a.URI.file(z),M);try{this._onExtract.fire(a.URI.file(H)),await this.rename(J,z,H,Date.now()+2*60*1e3),this.logService.info("Renamed to",H)}catch(V){try{await u.Promises.rm(z)}catch{}if(V.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",J.id);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(V)}. Deleted from extracted location`,z),V}return this.scanLocalExtension(a.URI.file(H),1)}async scanMetadata(J,G){return G?(await this.extensionsProfileScannerService.scanProfileExtensions(G)).find(C=>(0,i.areSameExtensions)(C.identifier,J.identifier))?.metadata:this.extensionsScannerService.scanMetadata(J.location)}async updateMetadata(J,G,M){return M?await this.extensionsProfileScannerService.updateMetadata([[J,G]],M):await this.extensionsScannerService.updateMetadata(J.location,G),this.scanLocalExtension(J.location,J.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...J){const G=J.map(M=>i.ExtensionKey.create(M));await this.withUninstalledExtensions(M=>G.forEach(C=>{M[C.toString()]=!0,this.logService.info("Marked extension as uninstalled",C.toString())}))}async setInstalled(J){await this.withUninstalledExtensions(G=>delete G[J.toString()])}async removeExtension(J,G){this.logService.trace(`Deleting ${G} extension from disk`,J.identifier.id,J.location.fsPath);const M=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(J.location),`._${(0,h.generateUuid)()}`);await this.rename(J.identifier,J.location.fsPath,M.fsPath,Date.now()+2*60*1e3),await this.fileService.del(M,{recursive:!0}),this.logService.info("Deleted from disk",J.identifier.id,J.location.fsPath)}async removeUninstalledExtension(J){await this.removeExtension(J,"uninstalled"),await this.withUninstalledExtensions(G=>delete G[i.ExtensionKey.create(J).toString()])}async copyExtensions(J,G){const M=await this.scanExtensions(1,J),C=await Promise.all(M.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,J)]));await this.extensionsProfileScannerService.addExtensionsToProfile(C,G)}async withUninstalledExtensions(J){return this.uninstalledFileLimiter.queue(async()=>{let G;try{G=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(C){if((0,N.toFileOperationResult)(C)!==1)throw C}let M={};if(G)try{M=JSON.parse(G)}catch{}return J&&(J(M),Object.keys(M).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(M))):await this.fileService.del(this.uninstalledResource)),M})}async extractAtLocation(J,G,M,C){this.logService.trace(`Started extracting the extension from ${G} to ${M}`);try{await u.Promises.rm(M)}catch(U){throw new t.ExtensionManagementError(this.joinErrors(U).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(G,M,{sourcePath:"extension",overwrite:!0},C),this.logService.info(`Extracted extension to ${M}:`,J.id)}catch(U){try{await u.Promises.rm(M)}catch{}let z=t.ExtensionManagementErrorCode.Extract;throw U instanceof g.ExtractError&&(U.type==="CorruptZip"?z=t.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&(z=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(U.message,z)}}async rename(J,G,M,C){try{await u.Promises.rename(G,M)}catch(U){if(m.isWindows&&U&&U.code==="EPERM"&&Date.now()<C)return this.logService.info(`Failed renaming ${G} to ${M} with 'EPERM' error. Trying again...`,J.id),this.rename(J,G,M,C);throw new t.ExtensionManagementError(U.message||y.localize(5,null,G,M),U.code||t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(J,G){const M=await this.extensionsScannerService.scanExistingExtension(J,G,{includeInvalid:!0});if(M)return this.toLocalExtension(M);throw new Error(y.localize(6,null,J.path))}async toLocalExtension(J){const G=await this.fileService.resolve(J.location);let M,C;return G.children&&(M=G.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,C=G.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:J.identifier,type:J.type,isBuiltin:J.isBuiltin||!!J.metadata?.isBuiltin,location:J.location,manifest:J.manifest,targetPlatform:J.targetPlatform,validations:J.validations,isValid:J.isValid,readmeUrl:M,changelogUrl:C,publisherDisplayName:J.metadata?.publisherDisplayName||null,publisherId:J.metadata?.publisherId||null,isApplicationScoped:!!J.metadata?.isApplicationScoped,isMachineScoped:!!J.metadata?.isMachineScoped,isPreReleaseVersion:!!J.metadata?.isPreReleaseVersion,preRelease:!!J.metadata?.preRelease,installedTimestamp:J.metadata?.installedTimestamp,updated:!!J.metadata?.updated,pinned:!!J.metadata?.pinned}}async removeUninstalledExtensions(){const J=await this.getUninstalledExtensions();if(Object.keys(J).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(J));const G=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=new Set;for(const U of G)J[i.ExtensionKey.create(U).toString()]||M.add(U.identifier.id.toLowerCase());try{const U=(0,i.groupByExtension)(G,z=>z.identifier);await T.Promises.settled(U.map(async z=>{const H=z.sort((V,X)=>p.rcompare(V.manifest.version,X.manifest.version))[0];M.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}))}catch(U){this.logService.error(U)}const C=G.filter(U=>U.metadata&&J[i.ExtensionKey.create(U).toString()]);await Promise.allSettled(C.map(U=>this.removeUninstalledExtension(U)))}async removeGeneratedFolders(){this.logService.trace("ExtensionManagementService#removeGeneratedFolders");const J=[];let G;try{G=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(M){(0,N.toFileOperationResult)(M)!==1&&this.logService.error(M)}for(const M of G?.children??[])M.isDirectory&&M.name.startsWith("._")&&(0,h.isUUID)(M.name.substring(2))&&J.push((async()=>{this.logService.trace("Deleting the generated extension folder",M.resource.toString());try{await this.fileService.del(M.resource,{recursive:!0}),this.logService.info("Deleted the generated extension folder",M.resource.toString())}catch(C){this.logService.error(C)}})());await Promise.allSettled(J)}joinErrors(J){const G=Array.isArray(J)?J:[J];return G.length===1?G[0]instanceof Error?G[0]:new Error(G[0]):G.reduce((M,C)=>new Error(`${M.message}${M.message?",":""}${C instanceof Error?C.message:C}`),new Error(""))}};e.ExtensionsScanner=x=Se([Y(1,N.IFileService),Y(2,o.IExtensionsScannerService),Y(3,r.IExtensionsProfileScannerService),Y(4,Q.IUriIdentityService),Y(5,W.ILogService)],x);class $ extends s.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,b.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(J,G,M,C,U,z,H,V,X){super(),this.identifier=J,this.source=G,this.options=M,this.extensionsScanner=C,this.uriIdentityService=U,this.userDataProfilesService=z,this.extensionsScannerService=H,this.extensionsProfileScannerService=V,this.logService=X,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(J){const[G,M]=await this.install(J);return this._profileLocation=G.isBuiltin||G.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[G,M]],this._profileLocation),G}async extractExtension({zipPath:J,key:G,metadata:M},C){let U=await this.unsetIfUninstalled(G);return U||(this.logService.trace("Extracting extension...",G.id),U=await this.extensionsScanner.extractUserExtension(G,J,M,C),this.logService.info("Extracting extension completed.",G.id)),U}async unsetIfUninstalled(J){return await this.isUninstalled(J)?(this.logService.trace("Removing the extension from uninstalled list:",J.id),await this.extensionsScanner.setInstalled(J),this.logService.info("Removed the extension from uninstalled list:",J.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(C=>i.ExtensionKey.create(C).equals(J))):void 0}async isUninstalled(J){return!!(await this.extensionsScanner.getUninstalledExtensions())[J.toString()]}}class j extends ${constructor(J,G,M,C,U,z,H,V,X,ee){super(G.identifier,G,M,U,z,H,V,X,ee),this.gallery=G,this.extensionsDownloader=C}async install(J){const M=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(H=>(0,i.areSameExtensions)(H.identifier,this.gallery.identifier));M&&(this._operation=3);const C={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||M?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,isSystem:M?.type===0?!0:void 0,updated:!!M,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,b.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:M?.preRelease)};if(M?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(M,C),C];const{location:U,verificationStatus:z}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=z,this.validateManifest(U.fsPath),[await this.extractExtension({zipPath:U.fsPath,key:i.ExtensionKey.create(this.gallery),metadata:C},J),C]}catch(H){try{await this.extensionsDownloader.delete(U)}catch(V){this.logService.warn("Error while deleting the downloaded file",U.toString(),(0,_.getErrorMessage)(V))}throw H}}async validateManifest(J){try{await(0,E.getManifest)(J)}catch(G){throw new t.ExtensionManagementError((0,s.joinErrors)(G).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=j;class te extends ${constructor(J,G,M,C,U,z,H,V,X,ee){super({id:(0,i.getGalleryExtensionId)(J.publisher,J.name)},G,M,U,z,H,V,X,ee),this.manifest=J,this.location=G,this.galleryService=C}async doRun(J){const G=await super.doRun(J);return this.updateMetadata(G,J),G}async install(J){const G=new i.ExtensionKey(this.identifier,this.manifest.version),C=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(H=>(0,i.areSameExtensions)(this.identifier,H.identifier)),U={isApplicationScoped:this.options.isApplicationScoped||C?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||C?.isMachineScoped,isBuiltin:this.options.isBuiltin||C?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(C)if(this._operation=3,G.equals(new i.ExtensionKey(C.identifier,C.manifest.version)))try{await this.extensionsScanner.removeExtension(C,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&p.gt(C.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(C);else{const H=await this.unsetIfUninstalled(G);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(y.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:w.resolve(this.location.fsPath),key:G,metadata:U},J),U]}async updateMetadata(J,G){try{let[M]=await this.galleryService.getExtensions([{id:J.identifier.id,version:J.manifest.version}],G);if(M||([M]=await this.galleryService.getExtensions([{id:J.identifier.id}],G)),M){const C={id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(J,C,this.options.profileLocation)}}catch{}}}class ne extends s.AbstractExtensionTask{constructor(J,G,M){super(),this.extension=J,this.profileLocation=G,this.extensionsProfileScannerService=M}async doRun(J){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(oe[279],ae([0,1,2,29,81,228,127,10,19]),function(ie,e,T,O,l,A,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=e.ExtensionsContributions=class extends T.Disposable{constructor(w,m,f,p,b,a){super(),w.cleanUp(),(0,A.migrateUnsupportedExtensions)(w,m,f,p,a),l.ExtensionStorageService.removeOutdatedExtensionVersions(w,b)}};e.ExtensionsContributions=S=Se([Y(0,_.INativeServerExtensionManagementService),Y(1,O.IExtensionGalleryService),Y(2,l.IExtensionStorageService),Y(3,O.IGlobalExtensionEnablementService),Y(4,P.IStorageService),Y(5,k.ILogService)],S)}),define(oe[280],ae([0,1,71,63,34,290,16,9,3,2,14,4,32,41,96]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class b{traceSocketEvent(d,I){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,d,I)}constructor(d,I=""){this._canWrite=!0,this.debugLabel=I,this.socket=d,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,k.onUnexpectedError)(R)}},this.socket.on("error",this._errorListener),this._closeListener=R=>{this.traceSocketEvent("close",{hadError:R}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(d){const I=R=>{this.traceSocketEvent("read",R),d(_.VSBuffer.wrap(R))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(d){const I=R=>{d({type:0,hadError:R,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(d){const I=()=>{d()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(d){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",d),this.socket.write(d.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,k.onUnexpectedError)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,k.onUnexpectedError)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((d,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),d();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),d()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=b;var a;(function(E){E[E.MinHeaderByteSize=2]="MinHeaderByteSize",E[E.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(a||(a={}));var h;(function(E){E[E.PeekHeader=1]="PeekHeader",E[E.ReadHeader=2]="ReadHeader",E[E.ReadBody=3]="ReadBody",E[E.Fin=4]="Fin"})(h||(h={}));class u extends S.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(d,I){this.socket.traceSocketEvent(d,I)}constructor(d,I,R,N){super(),this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=d,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:R?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new g(this,I,R,N,this._onData,(F,W)=>this._write(F,W))),this._register(this._flowManager.onError(F=>{console.error(F),(0,k.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(async F=>{this._flowManager.isProcessingReadQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(F)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){let I=0;for(;I<d.byteLength;)this._flowManager.writeMessage(d.slice(I,Math.min(I+262144,d.byteLength))),I+=262144}_write(d,I){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",d);let R=2;d.byteLength<126?R+=0:d.byteLength<2**16?R+=2:R+=8;const N=_.VSBuffer.alloc(R);if(I?N.writeUInt8(194,0):N.writeUInt8(130,0),d.byteLength<126)N.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){N.writeUInt8(126,1);let F=1;N.writeUInt8(d.byteLength>>>8&255,++F),N.writeUInt8(d.byteLength>>>0&255,++F)}else{N.writeUInt8(127,1);let F=1;N.writeUInt8(0,++F),N.writeUInt8(0,++F),N.writeUInt8(0,++F),N.writeUInt8(0,++F),N.writeUInt8(d.byteLength>>>24&255,++F),N.writeUInt8(d.byteLength>>>16&255,++F),N.writeUInt8(d.byteLength>>>8&255,++F),N.writeUInt8(d.byteLength>>>0&255,++F)}this.socket.write(_.VSBuffer.concat([N,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const I=this._incomingData.peek(this._state.readLen),R=I.readUInt8(0),N=(R&128)>>>7,F=(R&64)>>>6,W=I.readUInt8(1),q=(W&128)>>>7,B=W&127;this._state.state=2,this._state.readLen=2+(q?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=!!F),this._state.firstFrameOfMessage=!!N,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const I=this._incomingData.read(this._state.readLen),R=I.readUInt8(1),N=(R&128)>>>7;let F=R&127,W=1;F===126?F=I.readUInt8(++W)*2**8+I.readUInt8(++W):F===127&&(F=I.readUInt8(++W)*0+I.readUInt8(++W)*0+I.readUInt8(++W)*0+I.readUInt8(++W)*0+I.readUInt8(++W)*2**24+I.readUInt8(++W)*2**16+I.readUInt8(++W)*2**8+I.readUInt8(++W));let q=0;N&&(q=I.readUInt8(++W)*2**24+I.readUInt8(++W)*2**16+I.readUInt8(++W)*2**8+I.readUInt8(++W)),this._state.state=3,this._state.readLen=F,this._state.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const I=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),n(I,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(I,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=u;class g extends S.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}constructor(d,I,R,N,F,W){super(),this._tracer=d,this._onData=F,this._writeFn=W,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new P.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,I?(this._zlibInflateStream=this._register(new y(this._tracer,N,R,{windowBits:15})),this._zlibDeflateStream=this._register(new L(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(q=>this._onError.fire(q))),this._register(this._zlibDeflateStream.onError(q=>this._onError.fire(q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(d){this._writeQueue.push(d),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const d=this._writeQueue.shift();if(this._zlibDeflateStream){const I=await this._deflateMessage(this._zlibDeflateStream,d);this._writeFn(I,!0)}else this._writeFn(d,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(d,I){return new Promise((R,N)=>{d.write(I),d.flush(F=>R(F))})}acceptFrame(d,I,R){this._readQueue.push({data:d,isCompressed:I,isLastFrameOfMessage:R}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const d=this._readQueue.shift();if(this._zlibInflateStream&&d.isCompressed){const I=await this._inflateFrame(this._zlibInflateStream,d.data,d.isLastFrameOfMessage);this._onData.fire(I)}else this._onData.fire(d.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(d,I,R){return new Promise((N,F)=>{d.write(I),R&&d.write(_.VSBuffer.fromByteArray([0,0,255,255])),d.flush(W=>N(W))})}}class y extends S.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}constructor(d,I,R,N){super(),this._tracer=d,this._recordInflateBytes=I,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(N),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(_.VSBuffer.wrap(F))}),R&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(d){this._recordInflateBytes&&this._recordedInflateBytes.push(d.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",d),this._zlibInflate.write(d.buffer)}flush(d){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const I=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,d(I)})}}class L extends S.Disposable{constructor(d,I){super(),this._tracer=d,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",R=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibDeflate.on("data",R=>{this._tracer.traceSocketEvent("zlibDeflateData",R),this._pendingDeflateData.push(_.VSBuffer.wrap(R))})}write(d){this._tracer.traceSocketEvent("zlibDeflateWrite",d.buffer),this._zlibDeflate.write(d.buffer)}flush(d){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let I=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,I=I.slice(0,I.byteLength-4),d(I)})}}function n(E,d){if(d===0)return;const I=E.byteLength>>>2;for(let B=0;B<I;B++){const Q=E.readUInt32BE(B*4);E.writeUInt32BE(Q^d,B*4)}const R=I*4,N=E.byteLength-R,F=d>>>24&255,W=d>>>16&255,q=d>>>8&255;N>=1&&E.writeUInt8(E.readUInt8(R)^F,R),N>=2&&E.writeUInt8(E.readUInt8(R+1)^W,R+1),N>=3&&E.writeUInt8(E.readUInt8(R+2)^q,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function t(){const E=(0,m.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${E}-sock`;const d=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,l.tmpdir)(),I=(0,D.join)(d,`vscode-ipc-${E}.sock`);return r(I),I}e.createRandomIPCHandle=t;function i(E,d,I){const R=(0,T.createHash)("md5").update(E).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${I}-${d}-sock`;const N=I.substr(0,4),F=d.substr(0,6),W=R.substr(0,8);let q;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?q=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${W}-${N}-${F}.sock`):q=(0,D.join)(E,`${N}-${F}.sock`),r(q),q}e.createStaticIPCHandle=i;function r(E){const d=s[w.platform];typeof d=="number"&&E.length>=d&&console.warn(`WARNING: IPC handle "${E}" is longer than ${d} chars, try a shorter --user-data-dir`)}class o extends f.IPCServer{static toClientConnectionEvent(d){const I=P.Event.fromNodeEventEmitter(d,"connection");return P.Event.map(I,R=>({protocol:new p.Protocol(new b(R,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(R,"close"))}))}constructor(d){super(o.toClientConnectionEvent(d)),this.server=d}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function c(E){return new Promise((d,I)=>{const R=(0,O.createServer)();R.on("error",I),R.listen(E,()=>{R.removeListener("error",I),d(new o(R))})})}e.serve=c;function v(E,d){return new Promise((I,R)=>{const N=(0,O.createConnection)(E,()=>{N.removeListener("error",R),I(p.Client.fromSocket(new b(N,`ipc-client${d}`),d))});N.once("error",R)})}e.connect=v}),define(oe[281],ae([0,1,63,280]),function(ie,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(l,A,_,k,P,S){const D=m=>S(m,void 0),w=T.createConnection({host:l,port:A},()=>{w.removeListener("error",D);const m=Buffer.alloc(16);for(let a=0;a<16;a++)m[a]=Math.round(Math.random()*256);const f=m.toString("base64"),p=[`GET ws://${/:/.test(l)?`[${l}]`:l}:${A}${_}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];w.write(p.join(`\r
`)+`\r
\r
`);const b=a=>{a.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",b),S(void 0,new O.NodeSocket(w,P)))};w.on("data",b)});w.setNoDelay(!0),w.once("error",D)}}}),define(oe[282],ae([0,1,63,34,135,281,6,2,17,10,25,219,78,110,4]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function b(y,L,n,s,t){let i;for(let r=3;r&&(i?.dispose(),i=await new a(y,L,n,s,t).waitForReady(),!(t&&l.BROWSER_RESTRICTED_PORTS[t]||!l.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));r--);return i}class a extends k.Disposable{constructor(L,n,s,t,i){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=i,this.privacy=m.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=L,this._server=T.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const L=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,m.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let s=await(0,l.findFreePortFaster)(L,2,1e3,n),t=null;return this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address(),t||(s=0,this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async _onConnection(L){L.pause();const n=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,w.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),t=s.getSocket().socket,i=s.readEntireBuffer();s.dispose(),i.byteLength>0&&L.write(i.buffer),L.on("end",()=>{L.localAddress&&this._socketsDispose.delete(L.localAddress),t.end()}),L.on("close",()=>t.end()),L.on("error",()=>{L.localAddress&&this._socketsDispose.delete(L.localAddress),t.destroy()}),t.on("end",()=>L.end()),t.on("close",()=>L.end()),t.on("error",()=>{L.destroy()}),L.pipe(t),t.pipe(L),L.localAddress&&this._socketsDispose.set(L.localAddress,()=>{L.end(),t.end()})}}let h=e.BaseTunnelService=class extends m.AbstractTunnelService{constructor(L,n,s,t,i){super(n,i),this.socketFactory=L,this.signService=s,this.productService=t}isPortPrivileged(L){return(0,m.isPortPrivileged)(L,this.defaultTunnelHost,p.OS,O.release())}retainOrCreateTunnel(L,n,s,t,i,r,o,c){const v=this.getTunnelFromMap(n,s);if(v)return++v.refcount,v.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,n,s,i,r,o,c);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${i}.`);const E={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:L,signService:this.signService,logService:this.logService,ipcLogger:null},d=b(E,t,n,s,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,s,d),d}}};e.BaseTunnelService=h=Se([Y(1,S.ILogService),Y(2,f.ISignService),Y(3,D.IProductService),Y(4,P.IConfigurationService)],h);let u=e.TunnelService=class extends h{constructor(L,n,s,t){super(A.nodeSocketFactory,L,n,s,t)}};e.TunnelService=u=Se([Y(0,S.ILogService),Y(1,f.ISignService),Y(2,D.IProductService),Y(3,P.IConfigurationService)],u);let g=e.SharedTunnelsService=class extends k.Disposable{constructor(L,n,s,t){super(),this.logService=L,this.productService=n,this.signService=s,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(L,n,s,t,i,r,o,c,v){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${r}.`),!this._tunnelServices.has(L)){const E=new u(this.logService,this.signService,this.productService,this.configurationService);this._register(E),this._tunnelServices.set(L,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this._tunnelServices.delete(L))})}return this._tunnelServices.get(L).openTunnel(n,s,t,i,r,o,c,v)}};e.SharedTunnelsService=g=Se([Y(0,S.ILogService),Y(1,D.IProductService),Y(2,f.ISignService),Y(3,P.IConfigurationService)],g)}),define(oe[291],ae([0,1,240,34,38,9,2,22,12,41,149,211,212,204,205,276,195,197,17,216,99,226,100,221,15,223,119,261,29,101,196,127,102,13,207,208,69,5,203,72,74,231,10,106,107,25,58,19,111,20,112,113,114,46,234,116,243,81,117,24,79,267,253,254,82,268,271,272,273,60,266,255,110,225,78,282,220,244,30,245,4,246,198,214,213,80,260,18,51,210,57,265,233,256,109,270,279,7,209,105,263,259,222,192,56,274,262,73,264]),function(ie,e,T,O,l,A,_,k,P,S,D,w,m,f,p,b,a,h,u,g,y,L,n,s,t,i,r,o,c,v,E,d,I,R,N,F,W,q,B,Q,Z,K,x,$,j,te,ne,se,J,G,M,C,U,z,H,V,X,ee,ce,ue,fe,ve,ye,be,De,ke,We,Ke,le,de,ge,Pe,Ie,Me,Le,$e,Oe,Fe,Ne,_e,re,he,me,pe,we,Ce,Re,Ae,ze,Te,xe,je,et,nt,vt,Pt,It,Dt,Rt,St,kt,Lt,_t,Tt,At,Ot,Ut,yt,Nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Mt extends _.Disposable{constructor(Ee){super(),this.configuration=Ee,this.server=this._register(new D.Server),this.lifecycleService=void 0,this.registerListeners()}registerListeners(){let Ee=!1;const Ue=()=>{Ee||(Ee=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ue),(0,D.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Ue)}async init(){const Ee=await this.initServices();(0,ue.registerConfiguration)(),Ee.invokeFunction(Ue=>{const Ye=Ue.get(x.ILogService);Ye.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(Ye)}),this._register((0,_.combinedDisposable)(Ee.createInstance(w.CodeCacheCleaner,this.configuration.codeCachePath),Ee.createInstance(m.LanguagePackCachedDataCleaner),Ee.createInstance(b.UnusedWorkspaceStorageDataCleaner),Ee.createInstance(p.LogsDataCleaner),Ee.createInstance(f.LocalizationsUpdater),Ee.createInstance(It.ExtensionsContributions),Ee.createInstance(nt.UserDataProfilesCleaner)))}async initServices(){const Ee=new Q.ServiceCollection,Ue={_serviceBrand:void 0,...j.default};Ee.set(te.IProductService,Ue);const Ye=new S.StaticRouter(Ve=>Ve==="main"),Ge=new yt.MainProcessService(this.server,Ye);Ee.set(yt.IMainProcessService,Ge);const at=this.configuration.policiesData?new Te.PolicyChannelClient(this.configuration.policiesData,Ge.getChannel("policy")):new xe.NullPolicyService;Ee.set(xe.IPolicyService,at);const Be=new i.SharedProcessEnvironmentService(this.configuration.args,Ue);Ee.set(t.INativeEnvironmentService,Be);const Xe=new $.LoggerChannelClient(void 0,this.configuration.logLevel,Be.logsHome,this.configuration.loggers.map(Ve=>({...Ve,resource:P.URI.revive(Ve.resource)})),Ge.getChannel("logger"));Ee.set(x.ILoggerService,Xe);const ct=this._register(Xe.createLogger("sharedprocess",{name:(0,Dt.localize)(0,null)})),dt=this._register(new x.ConsoleLogger(ct.getLevel())),He=this._register(new Rt.LogService(ct,[dt]));Ee.set(x.ILogService,He),this.lifecycleService=this._register(new St.SharedProcessLifecycleService(He)),Ee.set(St.ISharedProcessLifecycleService,this.lifecycleService);const Ze=this._register(new N.FileService(He));Ee.set(R.IFileService,Ze);const ft=this._register(new F.DiskFileSystemProvider(He));Ze.registerProvider(k.Schemas.file,ft);const gt=this._register(new he.FileUserDataProvider(k.Schemas.file,this._register(new me.DiskFileSystemProviderClient(Ge.getChannel(me.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:re.isLinux})),k.Schemas.vscodeUserData,He));Ze.registerProvider(k.Schemas.vscodeUserData,gt);const tt=this._register(new je.UserDataProfilesService(this.configuration.profiles.all,P.URI.revive(this.configuration.profiles.home).with({scheme:Be.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Ee.set(Ae.IUserDataProfilesService,tt);const Je=this._register(new g.ConfigurationService(tt.defaultProfile.settingsResource,Ze,at,He));Ee.set(u.IConfigurationService,Je);const rt=new Nt.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},Ge,Be);Ee.set(se.IStorageService,rt),this._register((0,_.toDisposable)(()=>rt.flush())),await Promise.all([Je.initialize(),rt.initialize()]);const mt=new _e.UriIdentityService(Ze);Ee.set(Ne.IUriIdentityService,mt),Ee.set(ne.IRequestService,new _t.RequestChannelClient(Ge.getChannel("request"))),Ee.set(a.IChecksumService,new W.SyncDescriptor(h.ChecksumService,void 0,!1)),Ee.set(we.IV8InspectProfilingService,new W.SyncDescriptor(pe.InspectProfilingService,void 0,!1));const lt=S.ProxyChannel.toService(Ge.getChannel("nativeHost"));Ee.set(At.INativeHostService,lt),Ee.set(n.IDownloadService,new W.SyncDescriptor(s.DownloadService,void 0,!0));const Ft=this._register(new Pe.ActiveWindowManager(lt)),xt=new S.StaticRouter(Ve=>Ft.getActiveClientId().then(ht=>Ve===ht));Ee.set(I.IExtensionRecommendationNotificationService,new Tt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",xt)));let ut;const st=[],Et=(0,z.isInternalTelemetry)(Ue,Je);if((0,z.supportsTelemetry)(Ue,Be)){const Ve=new C.TelemetryLogAppender(He,Xe,Be,Ue);if(st.push(Ve),Ue.aiConfig?.ariaKey){const ht=new et.OneDataSystemAppender(Et,"monacoworkbench",null,Ue.aiConfig.ariaKey);this._register((0,_.toDisposable)(()=>ht.flush())),st.push(ht)}ut=new U.TelemetryService({appenders:st,commonProperties:(0,J.resolveCommonProperties)((0,O.release)(),(0,O.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Et),sendErrorTelemetry:!0,piiPaths:(0,z.getPiiPathsFromEnvironment)(Be)},Je,Ue)}else{ut=z.NullTelemetryService;const Ve=z.NullAppender;st.push(Ve)}this.server.registerChannel("telemetryAppender",new M.TelemetryAppenderChannel(st)),Ee.set(G.ITelemetryService,ut);const $t=new H.CustomEndpointTelemetryService(Je,ut,He,Xe,Be,Ue);Ee.set(G.ICustomEndpointTelemetryService,$t),Ee.set(ze.IExtensionsProfileScannerService,new W.SyncDescriptor(Lt.ExtensionsProfileScannerService,void 0,!0)),Ee.set(Ce.IExtensionsScannerService,new W.SyncDescriptor(Re.ExtensionsScannerService,void 0,!0)),Ee.set(v.IExtensionSignatureVerificationService,new W.SyncDescriptor(v.ExtensionSignatureVerificationService,void 0,!0)),Ee.set(d.INativeServerExtensionManagementService,new W.SyncDescriptor(d.ExtensionManagementService,void 0,!0)),Ee.set(c.IExtensionGalleryService,new W.SyncDescriptor(o.ExtensionGalleryService,void 0,!0)),Ee.set(c.IExtensionTipsService,new W.SyncDescriptor(Ut.ExtensionTipsService,void 0,!1)),Ee.set(Z.ILanguagePackService,new W.SyncDescriptor(K.NativeLanguagePackService,void 0,!1)),Ee.set(y.IDiagnosticsService,new W.SyncDescriptor(L.DiagnosticsService,void 0,!1)),Ee.set(fe.IUserDataSyncAccountService,new W.SyncDescriptor(fe.UserDataSyncAccountService,void 0,!0)),Ee.set(ue.IUserDataSyncLogService,new W.SyncDescriptor(be.UserDataSyncLogService,void 0,!0)),Ee.set(ue.IUserDataSyncUtilService,new ye.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),Ee.set(c.IGlobalExtensionEnablementService,new W.SyncDescriptor(r.GlobalExtensionEnablementService,void 0,!1)),Ee.set(ce.IIgnoredExtensionsManagementService,new W.SyncDescriptor(ce.IgnoredExtensionsManagementService,void 0,!0)),Ee.set(ee.IExtensionStorageService,new W.SyncDescriptor(ee.ExtensionStorageService)),Ee.set(ue.IUserDataSyncStoreManagementService,new W.SyncDescriptor(le.UserDataSyncStoreManagementService,void 0,!0)),Ee.set(ue.IUserDataSyncStoreService,new W.SyncDescriptor(le.UserDataSyncStoreService,void 0,!0)),Ee.set(De.IUserDataSyncMachinesService,new W.SyncDescriptor(De.UserDataSyncMachinesService,void 0,!0)),Ee.set(ue.IUserDataSyncBackupStoreService,new W.SyncDescriptor(ve.UserDataSyncBackupStoreService,void 0,!1)),Ee.set(ue.IUserDataSyncEnablementService,new W.SyncDescriptor(ke.UserDataSyncEnablementService,void 0,!0)),Ee.set(ue.IUserDataSyncService,new W.SyncDescriptor(We.UserDataSyncService,void 0,!1)),Ee.set(de.IUserDataProfileStorageService,new W.SyncDescriptor(ge.NativeUserDataProfileStorageService,void 0,!0)),Ee.set(ue.IUserDataSyncResourceProviderService,new W.SyncDescriptor(Pt.UserDataSyncResourceProviderService,void 0,!0));const bt=new X.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Je.getValue("terminal.integrated.persistentSessionScrollback")??100},!1,Je,Be,He,Xe);return bt.initialize(),Ee.set(T.ILocalPtyService,this._register(bt)),Ee.set(Ie.ISignService,new W.SyncDescriptor(Me.SignService,void 0,!1)),Ee.set(Le.ISharedTunnelsService,new W.SyncDescriptor($e.SharedTunnelsService)),Ee.set(Oe.ISharedProcessTunnelService,new W.SyncDescriptor(Fe.SharedProcessTunnelService)),Ee.set(vt.IRemoteTunnelService,new W.SyncDescriptor(kt.RemoteTunnelService)),new B.InstantiationService(Ee)}initChannels(Ee){const Ue=new E.ExtensionManagementChannel(Ee.get(c.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const Ye=S.ProxyChannel.fromService(Ee.get(Z.ILanguagePackService));this.server.registerChannel("languagePacks",Ye);const Ge=S.ProxyChannel.fromService(Ee.get(y.IDiagnosticsService));this.server.registerChannel("diagnostics",Ge);const at=new E.ExtensionTipsChannel(Ee.get(c.IExtensionTipsService));this.server.registerChannel("extensionTipsService",at);const Be=S.ProxyChannel.fromService(Ee.get(a.IChecksumService));this.server.registerChannel("checksum",Be);const Xe=S.ProxyChannel.fromService(Ee.get(we.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ct=new ye.UserDataSyncMachinesServiceChannel(Ee.get(De.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ct);const dt=S.ProxyChannel.fromService(Ee.get(G.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",dt);const He=new ye.UserDataSyncAccountServiceChannel(Ee.get(fe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",He);const Ze=new ye.UserDataSyncStoreManagementServiceChannel(Ee.get(ue.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ze);const ft=new Ke.UserDataSyncChannel(Ee.get(ue.IUserDataSyncService),Ee.get(Ae.IUserDataProfilesService),Ee.get(x.ILogService));this.server.registerChannel("userDataSync",ft);const gt=this._register(Ee.get(q.IInstantiationService).createInstance(Ot.UserDataAutoSyncService)),tt=new ye.UserDataAutoSyncChannel(gt);this.server.registerChannel("userDataAutoSync",tt);const Je=Ee.get(T.ILocalPtyService),rt=S.ProxyChannel.fromService(Je);this.server.registerChannel(V.TerminalIpcChannels.LocalPty,rt);const mt=S.ProxyChannel.fromService(Ee.get(Oe.ISharedProcessTunnelService));this.server.registerChannel(Oe.ipcSharedProcessTunnelChannelName,mt);const lt=S.ProxyChannel.fromService(Ee.get(vt.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",lt)}registerErrorHandler(Ee){process.on("uncaughtException",Ue=>(0,A.onUnexpectedError)(Ue)),process.on("unhandledRejection",Ue=>(0,A.onUnexpectedError)(Ue)),(0,A.setUnexpectedErrorHandler)(Ue=>{const Ye=(0,l.toErrorMessage)(Ue,!0);Ye&&Ee.error(`[uncaught exception in sharedProcess]: ${Ye}`)})}}async function wt(ot){const Ee=new Mt(ot);process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"),await Ee.init(),process.parentPort.postMessage("vscode:shared-process->electron-main=init-done")}e.main=wt,process.parentPort.once("message",ot=>{wt(ot.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e06ea6147733c975d26c3d3552462681e05cb147/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
