/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/process","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/iterator","vs/base/common/themables","vs/editor/common/core/position","os","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostInteractiveSession","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/environment/node/userDataPath","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","path","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(oe){for(var e=[],o=0,A=oe.length;o<A;o++)e[o]=De[oe[o]];return e};define(De[63],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function o(T,P){const y=Object.create(null);for(const g of T){const L=P(g);let I=y[L];I||(I=y[L]=[]),I.push(g)}return y}e.groupBy=o;function A(T,P){const y=[],g=[];for(const L of T)P.has(L)||y.push(L);for(const L of P)T.has(L)||g.push(L);return{removed:y,added:g}}e.diffSets=A;function l(T,P){const y=[],g=[];for(const[L,I]of T)P.has(L)||y.push(I);for(const[L,I]of P)T.has(L)||g.push(I);return{removed:y,added:g}}e.diffMaps=l;class R{constructor(){this.map=new Map}add(P,y){let g=this.map.get(P);g||(g=new Set,this.map.set(P,g)),g.add(y)}delete(P,y){const g=this.map.get(P);g&&(g.delete(y),g.size===0&&this.map.delete(P))}forEach(P,y){const g=this.map.get(P);g&&g.forEach(y)}}e.SetMap=R}),define(De[64],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function o(T){return(P,y,g)=>{let L=null,I=null;if(typeof g.value=="function"?(L="value",I=g.value):typeof g.get=="function"&&(L="get",I=g.get),!I)throw new Error("not supported");g[L]=T(I,y)}}function A(T,P,y){let g=null,L=null;if(typeof y.value=="function"?(g="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(g="get",L=y.get),!L)throw new Error("not supported");const I=`$memoize$${P}`;y[g]=function(...w){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,w)}),this[I]}}e.memoize=A;function l(T,P,y){return o((g,L)=>{const I=`$debounce$${L}`,w=`$debounce$result$${L}`;return function(...k){this[w]||(this[w]=y?y():void 0),clearTimeout(this[I]),P&&(this[w]=P(this[w],...k),k=[this[w]]),this[I]=setTimeout(()=>{g.apply(this,k),this[w]=y?y():void 0},T)}})}e.debounce=l;function R(T,P,y){return o((g,L)=>{const I=`$throttle$timer$${L}`,w=`$throttle$result$${L}`,k=`$throttle$lastRun$${L}`,C=`$throttle$pending$${L}`;return function(...b){if(this[w]||(this[w]=y?y():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),P&&(this[w]=P(this[w],...b)),this[C])return;const i=this[k]+T;i<=Date.now()?(this[k]=Date.now(),g.apply(this,[this[w]]),this[w]=y?y():void 0):(this[C]=!0,this[I]=setTimeout(()=>{this[C]=!1,this[k]=Date.now(),g.apply(this,[this[w]]),this[w]=y?y():void 0},i-Date.now()))}})}e.throttle=R}),define(De[8],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class o{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?E.isErrorNoTelemetry(s)?new E(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(r=>{r(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=o,e.errorHandler=new o;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function l(t){if(!t||typeof t!="object")return!1;const s=t;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function R(t){g(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=R;function T(t){g(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=T;function P(t){if(t instanceof Error){const{name:s,message:r}=t,a=t.stacktrace||t.stack;return{$isError:!0,name:s,message:r,stack:a,noTelemetry:E.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const y="Canceled";function g(t){return t instanceof L?!0:t instanceof Error&&t.name===y&&t.message===y}e.isCancellationError=g;class L extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=L;function I(){const t=new Error(y);return t.name=t.message,t}e.canceled=I;function w(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=w;function k(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=k;function C(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function b(t){const s=new Error(`${t} has been disposed`);return s.name="DISPOSED",s}e.disposed=b;function i(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=i;class d extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=d;class h extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=h;class S extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=S;class E extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof E)return s;const r=new E;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=E;class p extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(De[18],Ie([1,0,8]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(re,ne=0){return re[re.length-(1+ne)]}e.tail=A;function l(re){if(re.length===0)throw new Error("Invalid tail call");return[re.slice(0,re.length-1),re[re.length-1]]}e.tail2=l;function R(re,ne,de=(ee,ce)=>ee===ce){if(re===ne)return!0;if(!re||!ne||re.length!==ne.length)return!1;for(let ee=0,ce=re.length;ee<ce;ee++)if(!de(re[ee],ne[ee]))return!1;return!0}e.equals=R;function T(re,ne){const de=re.length-1;ne<de&&(re[ne]=re[de]),re.pop()}e.removeFastWithoutKeepingOrder=T;function P(re,ne,de){return y(re.length,ee=>de(re[ee],ne))}e.binarySearch=P;function y(re,ne){let de=0,ee=re-1;for(;de<=ee;){const ce=(de+ee)/2|0,le=ne(ce);if(le<0)de=ce+1;else if(le>0)ee=ce-1;else return ce}return-(de+1)}e.binarySearch2=y;function g(re,ne){let de=0,ee=re.length;if(ee===0)return 0;for(;de<ee;){const ce=Math.floor((de+ee)/2);ne(re[ce])?ee=ce:de=ce+1}return de}e.findFirstInSorted=g;function L(re,ne,de){if(re=re|0,re>=ne.length)throw new TypeError("invalid index");const ee=ne[Math.floor(ne.length*Math.random())],ce=[],le=[],ue=[];for(const O of ne){const j=de(O,ee);j<0?ce.push(O):j>0?le.push(O):ue.push(O)}return re<ce.length?L(re,ce,de):re<ce.length+ue.length?ue[0]:L(re-(ce.length+ue.length),le,de)}e.quickSelect=L;function I(re,ne){const de=[];let ee;for(const ce of re.slice(0).sort(ne))!ee||ne(ee[0],ce)!==0?(ee=[ce],de.push(ee)):ee.push(ce);return de}e.groupBy=I;function w(re,ne,de){const ee=[];function ce(O,j,Y){if(j===0&&Y.length===0)return;const te=ee[ee.length-1];te&&te.start+te.deleteCount===O?(te.deleteCount+=j,te.toInsert.push(...Y)):ee.push({start:O,deleteCount:j,toInsert:Y})}let le=0,ue=0;for(;;){if(le===re.length){ce(le,0,ne.slice(ue));break}if(ue===ne.length){ce(le,re.length-le,[]);break}const O=re[le],j=ne[ue],Y=de(O,j);Y===0?(le+=1,ue+=1):Y<0?(ce(le,1,[]),le+=1):Y>0&&(ce(le,0,[j]),ue+=1)}return ee}e.sortedDiff=w;function k(re,ne,de){const ee=w(re,ne,de),ce=[],le=[];for(const ue of ee)ce.push(...re.slice(ue.start,ue.start+ue.deleteCount)),le.push(...ue.toInsert);return{removed:ce,added:le}}e.delta=k;function C(re,ne,de){if(de===0)return[];const ee=re.slice(0,de).sort(ne);return i(re,ne,ee,de,re.length),ee}e.top=C;function b(re,ne,de,ee,ce){return de===0?Promise.resolve([]):new Promise((le,ue)=>{(async()=>{const O=re.length,j=re.slice(0,de).sort(ne);for(let Y=de,te=Math.min(de+ee,O);Y<O;Y=te,te=Math.min(te+ee,O)){if(Y>de&&await new Promise(be=>setTimeout(be)),ce&&ce.isCancellationRequested)throw new o.CancellationError;i(re,ne,j,Y,te)}return j})().then(le,ue)})}e.topAsync=b;function i(re,ne,de,ee,ce){for(const le=de.length;ee<ce;ee++){const ue=re[ee];if(ne(ue,de[le-1])<0){de.pop();const O=g(de,j=>ne(ue,j)<0);de.splice(O,0,ue)}}}function d(re){return re.filter(ne=>!!ne)}e.coalesce=d;function h(re){let ne=0;for(let de=0;de<re.length;de++)re[de]&&(re[ne]=re[de],ne+=1);re.length=ne}e.coalesceInPlace=h;function S(re,ne,de){re.splice(de,0,re.splice(ne,1)[0])}e.move=S;function E(re){return!Array.isArray(re)||re.length===0}e.isFalsyOrEmpty=E;function p(re){return Array.isArray(re)&&re.length>0}e.isNonEmptyArray=p;function t(re,ne=de=>de){const de=new Set;return re.filter(ee=>{const ce=ne(ee);return de.has(ce)?!1:(de.add(ce),!0)})}e.distinct=t;function s(re){const ne=new Set;return de=>{const ee=re(de);return ne.has(ee)?!1:(ne.add(ee),!0)}}e.uniqueFilter=s;function r(re,ne){const de=a(re,ne);if(de!==-1)return re[de]}e.findLast=r;function a(re,ne){for(let de=re.length-1;de>=0;de--){const ee=re[de];if(ne(ee))return de}return-1}e.lastIndex=a;function v(re,ne){return re.length>0?re[0]:ne}e.firstOrDefault=v;function _(re,ne){return re.length>0?re[re.length-1]:ne}e.lastOrDefault=_;function c(re,ne,de=(ee,ce)=>ee===ce){let ee=0;for(let ce=0,le=Math.min(re.length,ne.length);ce<le&&de(re[ce],ne[ce]);ce++)ee++;return ee}e.commonPrefixLength=c;function u(re){return[].concat(...re)}e.flatten=u;function m(re,ne){let de=typeof ne=="number"?re:0;typeof ne=="number"?de=re:(de=0,ne=re);const ee=[];if(de<=ne)for(let ce=de;ce<ne;ce++)ee.push(ce);else for(let ce=de;ce>ne;ce--)ee.push(ce);return ee}e.range=m;function f(re,ne,de){return re.reduce((ee,ce)=>(ee[ne(ce)]=de?de(ce):ce,ee),Object.create(null))}e.index=f;function n(re,ne){return re.push(ne),()=>D(re,ne)}e.insert=n;function D(re,ne){const de=re.indexOf(ne);if(de>-1)return re.splice(de,1),ne}e.remove=D;function M(re,ne,de){const ee=re.slice(0,ne),ce=re.slice(ne);return ee.concat(de,ce)}e.arrayInsert=M;function W(re,ne){let de;if(typeof ne=="number"){let ee=ne;de=()=>{const ce=Math.sin(ee++)*179426549;return ce-Math.floor(ce)}}else de=Math.random;for(let ee=re.length-1;ee>0;ee-=1){const ce=Math.floor(de()*(ee+1)),le=re[ee];re[ee]=re[ce],re[ce]=le}}e.shuffle=W;function $(re,ne){const de=re.indexOf(ne);de>-1&&(re.splice(de,1),re.unshift(ne))}e.pushToStart=$;function N(re,ne){const de=re.indexOf(ne);de>-1&&(re.splice(de,1),re.push(ne))}e.pushToEnd=N;function U(re,ne){for(const de of ne)re.push(de)}e.pushMany=U;function q(re,ne){return Array.isArray(re)?re.map(ne):ne(re)}e.mapArrayOrNot=q;function F(re){return Array.isArray(re)?re:[re]}e.asArray=F;function B(re){return re[Math.floor(Math.random()*re.length)]}e.getRandomElement=B;function Q(re,ne){for(const de of re){const ee=ne(de);if(ee!==void 0)return ee}}e.mapFind=Q;function J(re,ne,de){const ee=ie(re,ne),ce=re.length,le=de.length;re.length=ce+le;for(let ue=ce-1;ue>=ee;ue--)re[ue+le]=re[ue];for(let ue=0;ue<le;ue++)re[ue+ee]=de[ue]}e.insertInto=J;function X(re,ne,de,ee){const ce=ie(re,ne),le=re.splice(ce,de);return J(re,ce,ee),le}e.splice=X;function ie(re,ne){return ne<0?Math.max(ne+re.length,0):Math.min(ne,re.length)}var ae;(function(re){function ne(ce){return ce<0}re.isLessThan=ne;function de(ce){return ce>0}re.isGreaterThan=de;function ee(ce){return ce===0}re.isNeitherLessOrGreaterThan=ee,re.greaterThan=1,re.lessThan=-1,re.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function we(re,ne){return(de,ee)=>ne(re(de),re(ee))}e.compareBy=we;function he(...re){return(ne,de)=>{for(const ee of re){const ce=ee(ne,de);if(!ae.isNeitherLessOrGreaterThan(ce))return ce}return ae.neitherLessOrGreaterThan}}e.tieBreakComparators=he;const fe=(re,ne)=>re-ne;e.numberComparator=fe;function V(re,ne){if(re.length===0)return;let de=re[0];for(let ee=1;ee<re.length;ee++){const ce=re[ee];ne(ce,de)>0&&(de=ce)}return de}e.findMaxBy=V;function x(re,ne){if(re.length===0)return;let de=re[0];for(let ee=1;ee<re.length;ee++){const ce=re[ee];ne(ce,de)>=0&&(de=ce)}return de}e.findLastMaxBy=x;function Z(re,ne){return V(re,(de,ee)=>-ne(de,ee))}e.findMinBy=Z;class pe{constructor(ne){this.items=ne,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ne){let de=this.firstIdx;for(;de<this.items.length&&ne(this.items[de]);)de++;const ee=de===this.firstIdx?null:this.items.slice(this.firstIdx,de);return this.firstIdx=de,ee}takeFromEndWhile(ne){let de=this.lastIdx;for(;de>=0&&ne(this.items[de]);)de--;const ee=de===this.lastIdx?null:this.items.slice(de+1,this.lastIdx+1);return this.lastIdx=de,ee}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ne=this.items[this.firstIdx];return this.firstIdx++,ne}removeLast(){const ne=this.items[this.lastIdx];return this.lastIdx--,ne}takeCount(ne){const de=this.items.slice(this.firstIdx,this.firstIdx+ne);return this.firstIdx+=ne,de}}e.ArrayQueue=pe;class _e{constructor(ne){this.iterate=ne}forEach(ne){this.iterate(de=>(ne(de),!0))}toArray(){const ne=[];return this.iterate(de=>(ne.push(de),!0)),ne}filter(ne){return new _e(de=>this.iterate(ee=>ne(ee)?de(ee):!0))}map(ne){return new _e(de=>this.iterate(ee=>de(ne(ee))))}some(ne){let de=!1;return this.iterate(ee=>(de=ne(ee),!de)),de}findFirst(ne){let de;return this.iterate(ee=>ne(ee)?(de=ee,!1):!0),de}findLast(ne){let de;return this.iterate(ee=>(ne(ee)&&(de=ee),!0)),de}findLastMaxBy(ne){let de,ee=!0;return this.iterate(ce=>((ee||ae.isGreaterThan(ne(ce,de)))&&(ee=!1,de=ce),!0)),de}}e.CallbackIterable=_e,_e.empty=new _e(re=>{})}),define(De[51],Ie([1,0,8]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(y,g){if(!y)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=A;function l(y,g="Unreachable"){throw new Error(g)}e.assertNever=l;function R(y){if(!y)throw new o.BugIndicatingError("Assertion Failed")}e.assert=R;function T(y){if(!y()){debugger;y(),(0,o.onUnexpectedError)(new o.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function P(y,g){let L=0;for(;L<y.length-1;){const I=y[L],w=y[L+1];if(!g(I,w))return!1;L++}return!0}e.checkAdjacentItems=P}),define(De[65],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function o(A){const l=this;let R=!1,T;return function(){return R||(R=!0,T=A.apply(l,arguments)),T}}e.once=o}),define(De[102],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(l){this._prefix=l,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(De[52],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(A){function l(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}A.is=l;const R=Object.freeze([]);function T(){return R}A.empty=T;function*P(E){yield E}A.single=P;function y(E){return l(E)?E:P(E)}A.wrap=y;function g(E){return E||R}A.from=g;function L(E){return!E||E[Symbol.iterator]().next().done===!0}A.isEmpty=L;function I(E){return E[Symbol.iterator]().next().value}A.first=I;function w(E,p){for(const t of E)if(p(t))return!0;return!1}A.some=w;function k(E,p){for(const t of E)if(p(t))return t}A.find=k;function*C(E,p){for(const t of E)p(t)&&(yield t)}A.filter=C;function*b(E,p){let t=0;for(const s of E)yield p(s,t++)}A.map=b;function*i(...E){for(const p of E)for(const t of p)yield t}A.concat=i;function d(E,p,t){let s=t;for(const r of E)s=p(s,r);return s}A.reduce=d;function*h(E,p,t=E.length){for(p<0&&(p+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);p<t;p++)yield E[p]}A.slice=h;function S(E,p=Number.POSITIVE_INFINITY){const t=[];if(p===0)return[t,E];const s=E[Symbol.iterator]();for(let r=0;r<p;r++){const a=s.next();if(a.done)return[t,A.empty()];t.push(a.value)}return[t,{[Symbol.iterator](){return s}}]}A.consume=S})(o||(e.Iterable=o={}))}),define(De[148],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(o||(e.ScanError=o={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var l;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(l||(e.ParseErrorCode=l={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function T(t,s=!1){let r=0;const a=t.length;let v="",_=0,c=16,u=0;function m(N){let U=0,q=0;for(;U<N;){const F=t.charCodeAt(r);if(F>=48&&F<=57)q=q*16+F-48;else if(F>=65&&F<=70)q=q*16+F-65+10;else if(F>=97&&F<=102)q=q*16+F-97+10;else break;r++,U++}return U<N&&(q=-1),q}function f(N){r=N,v="",_=0,c=16,u=0}function n(){const N=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&g(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&g(t.charCodeAt(r)))for(r++;r<t.length&&g(t.charCodeAt(r));)r++;else return u=3,t.substring(N,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&g(t.charCodeAt(r))){for(r++;r<t.length&&g(t.charCodeAt(r));)r++;U=r}else u=3;return t.substring(N,U)}function D(){let N="",U=r;for(;;){if(r>=a){N+=t.substring(U,r),u=2;break}const q=t.charCodeAt(r);if(q===34){N+=t.substring(U,r),r++;break}if(q===92){if(N+=t.substring(U,r),r++,r>=a){u=2;break}switch(t.charCodeAt(r++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const B=m(4);B>=0?N+=String.fromCharCode(B):u=4;break}default:u=5}U=r;continue}if(q>=0&&q<=31)if(y(q)){N+=t.substring(U,r),u=2;break}else u=6;r++}return N}function M(){if(v="",u=0,_=r,r>=a)return _=a,c=17;let N=t.charCodeAt(r);if(P(N)){do r++,v+=String.fromCharCode(N),N=t.charCodeAt(r);while(P(N));return c=15}if(y(N))return r++,v+=String.fromCharCode(N),N===13&&t.charCodeAt(r)===10&&(r++,v+=`
`),c=14;switch(N){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,v=D(),c=10;case 47:{const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<a&&!y(t.charCodeAt(r));)r++;return v=t.substring(U,r),c=12}if(t.charCodeAt(r+1)===42){r+=2;const q=a-1;let F=!1;for(;r<q;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,F=!0;break}r++}return F||(r++,u=1),v=t.substring(U,r),c=13}return v+=String.fromCharCode(N),r++,c=16}case 45:if(v+=String.fromCharCode(N),r++,r===a||!g(t.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=n(),c=11;default:for(;r<a&&W(N);)r++,N=t.charCodeAt(r);if(_!==r){switch(v=t.substring(_,r),v){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return v+=String.fromCharCode(N),r++,c=16}}function W(N){if(P(N)||y(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let N;do N=M();while(N>=12&&N<=15);return N}return{setPosition:f,getPosition:()=>r,scan:s?$:M,getToken:()=>c,getTokenValue:()=>v,getTokenOffset:()=>_,getTokenLength:()=>r-_,getTokenError:()=>u}}e.createScanner=T;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function I(t,s){const r=[],a=new Object;let v;const _={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function u(m,f,n,D){_.value=m,_.offset=f,_.length=n,_.type=D,_.colonOffset=void 0,v=_}try{S(t,{onObjectBegin:(m,f)=>{if(s<=m)throw a;v=void 0,c=s>m,r.push("")},onObjectProperty:(m,f,n)=>{if(s<f||(u(m,f,n,"property"),r[r.length-1]=m,s<=f+n))throw a},onObjectEnd:(m,f)=>{if(s<=m)throw a;v=void 0,r.pop()},onArrayBegin:(m,f)=>{if(s<=m)throw a;v=void 0,r.push(0)},onArrayEnd:(m,f)=>{if(s<=m)throw a;v=void 0,r.pop()},onLiteralValue:(m,f,n)=>{if(s<f||(u(m,f,n,p(m)),s<=f+n))throw a},onSeparator:(m,f,n)=>{if(s<=f)throw a;if(m===":"&&v&&v.type==="property")v.colonOffset=f,c=!1,v=void 0;else if(m===","){const D=r[r.length-1];typeof D=="number"?r[r.length-1]=D+1:(c=!0,r[r.length-1]=""),v=void 0}}})}catch(m){if(m!==a)throw m}return{path:r,previousNode:v,isAtPropertyKey:c,matches:m=>{let f=0;for(let n=0;f<m.length&&n<r.length;n++)if(m[f]===r[n]||m[f]==="*")f++;else if(m[f]!=="**")return!1;return f===m.length}}}e.getLocation=I;function w(t,s=[],r=R.DEFAULT){let a=null,v=[];const _=[];function c(m){Array.isArray(v)?v.push(m):a!==null&&(v[a]=m)}return S(t,{onObjectBegin:()=>{const m={};c(m),_.push(v),v=m,a=null},onObjectProperty:m=>{a=m},onObjectEnd:()=>{v=_.pop()},onArrayBegin:()=>{const m=[];c(m),_.push(v),v=m,a=null},onArrayEnd:()=>{v=_.pop()},onLiteralValue:c,onError:(m,f,n)=>{s.push({error:m,offset:f,length:n})}},r),v[0]}e.parse=w;function k(t,s=[],r=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(m){a.type==="property"&&(a.length=m-a.offset,a=a.parent)}function _(m){return a.children.push(m),m}S(t,{onObjectBegin:m=>{a=_({type:"object",offset:m,length:-1,parent:a,children:[]})},onObjectProperty:(m,f,n)=>{a=_({type:"property",offset:f,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:m,offset:f,length:n,parent:a})},onObjectEnd:(m,f)=>{a.length=m+f-a.offset,a=a.parent,v(m+f)},onArrayBegin:(m,f)=>{a=_({type:"array",offset:m,length:-1,parent:a,children:[]})},onArrayEnd:(m,f)=>{a.length=m+f-a.offset,a=a.parent,v(m+f)},onLiteralValue:(m,f,n)=>{_({type:p(m),offset:f,length:n,parent:a,value:m}),v(f+n)},onSeparator:(m,f,n)=>{a.type==="property"&&(m===":"?a.colonOffset=f:m===","&&v(f))},onError:(m,f,n)=>{s.push({error:m,offset:f,length:n})}},r);const u=a.children[0];return u&&delete u.parent,u}e.parseTree=k;function C(t,s){if(!t)return;let r=t;for(const a of s)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let v=!1;for(const _ of r.children)if(Array.isArray(_.children)&&_.children[0].value===a){r=_.children[1],v=!0;break}if(!v)return}else{const v=a;if(r.type!=="array"||v<0||!Array.isArray(r.children)||v>=r.children.length)return;r=r.children[v]}return r}e.findNodeAtLocation=C;function b(t){if(!t.parent||!t.parent.children)return[];const s=b(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=b;function i(t){switch(t.type){case"array":return t.children.map(i);case"object":{const s=Object.create(null);for(const r of t.children){const a=r.children[1];a&&(s[r.children[0].value]=i(a))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=i;function d(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=d;function h(t,s,r=!1){if(d(t,s,r)){const a=t.children;if(Array.isArray(a))for(let v=0;v<a.length&&a[v].offset<=s;v++){const _=h(a[v],s,r);if(_)return _}return t}}e.findNodeAtOffset=h;function S(t,s,r=R.DEFAULT){const a=T(t,!1);function v(we){return we?()=>we(a.getTokenOffset(),a.getTokenLength()):()=>!0}function _(we){return we?he=>we(he,a.getTokenOffset(),a.getTokenLength()):()=>!0}const c=v(s.onObjectBegin),u=_(s.onObjectProperty),m=v(s.onObjectEnd),f=v(s.onArrayBegin),n=v(s.onArrayEnd),D=_(s.onLiteralValue),M=_(s.onSeparator),W=v(s.onComment),$=_(s.onError),N=r&&r.disallowComments,U=r&&r.allowTrailingComma;function q(){for(;;){const we=a.scan();switch(a.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:N||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(we){case 12:case 13:N?F(10):W();break;case 16:F(1);break;case 15:case 14:break;default:return we}}}function F(we,he=[],fe=[]){if($(we),he.length+fe.length>0){let V=a.getToken();for(;V!==17;){if(he.indexOf(V)!==-1){q();break}else if(fe.indexOf(V)!==-1)break;V=q()}}}function B(we){const he=a.getTokenValue();return we?D(he):u(he),q(),!0}function Q(){switch(a.getToken()){case 11:{let we=0;try{we=JSON.parse(a.getTokenValue()),typeof we!="number"&&(F(2),we=0)}catch{F(2)}D(we);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return q(),!0}function J(){return a.getToken()!==10?(F(3,[],[2,5]),!1):(B(!1),a.getToken()===6?(M(":"),q(),ae()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function X(){c(),q();let we=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(we||F(4,[],[]),M(","),q(),a.getToken()===2&&U)break}else we&&F(6,[],[]);J()||F(4,[],[2,5]),we=!0}return m(),a.getToken()!==2?F(7,[2],[]):q(),!0}function ie(){f(),q();let we=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(we||F(4,[],[]),M(","),q(),a.getToken()===4&&U)break}else we&&F(6,[],[]);ae()||F(4,[],[4,5]),we=!0}return n(),a.getToken()!==4?F(8,[4],[]):q(),!0}function ae(){switch(a.getToken()){case 3:return ie();case 1:return X();case 10:return B(!0);default:return Q()}}return q(),a.getToken()===17?r.allowEmptyContent?!0:(F(4,[],[]),!1):ae()?(a.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=S;function E(t,s){const r=T(t),a=[];let v,_=0,c;do switch(c=r.getPosition(),v=r.scan(),v){case 12:case 13:case 17:_!==c&&a.push(t.substring(_,c)),s!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,s)),_=r.getPosition();break}while(v!==17);return a.join("")}e.stripComments=E;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(De[66],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class o{constructor(l){this.executor=l,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(l){this._error=l}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=o}),define(De[6],Ie([1,0,65,52]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let R=null;function T(_){R=_}if(e.setDisposableTracker=T,l){const _="__is_disposable_tracked__";T(new class{trackDisposable(c){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[_]||console.log(u)},3e3)}setParent(c,u){if(c&&c!==h.None)try{c[_]=!0}catch{}}markAsDisposed(c){if(c&&c!==h.None)try{c[_]=!0}catch{}}markAsSingleton(c){}})}function P(_){return R?.trackDisposable(_),_}function y(_){R?.markAsDisposed(_)}function g(_,c){R?.setParent(_,c)}function L(_,c){if(R)for(const u of _)R.setParent(u,c)}function I(_){return R?.markAsSingleton(_),_}e.markAsSingleton=I;function w(_){return typeof _.dispose=="function"&&_.dispose.length===0}e.isDisposable=w;function k(_){if(A.Iterable.is(_)){const c=[];for(const u of _)if(u)try{u.dispose()}catch(m){c.push(m)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(_)?[]:_}else if(_)return _.dispose(),_}e.dispose=k;function C(_){for(const c of _)w(c)&&c.dispose();return[]}e.disposeIfDisposable=C;function b(..._){const c=i(()=>k(_));return L(_,c),c}e.combinedDisposable=b;function i(_){const c=P({dispose:(0,o.once)(()=>{y(c),_()})});return c}e.toDisposable=i;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{k(this._toDispose)}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return g(c,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new d,P(this),g(this._store,this)}dispose(){y(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&g(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&g(c,null),c}}e.MutableDisposable=S;class E{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=E;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(c){let u=c;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,y(this))},this}}e.SafeDisposable=p;class t{constructor(){this.references=new Map}acquire(c,...u){let m=this.references.get(c);m||(m={counter:0,object:this.createReferencedObject(c,...u)},this.references.set(c,m));const{object:f}=m,n=(0,o.once)(()=>{--m.counter===0&&(this.destroyReferencedObject(c,m.object),this.references.delete(c))});return m.counter++,{object:f,dispose:n}}}e.ReferenceCollection=t;class s{constructor(c){this.referenceCollection=c}async acquire(c,...u){const m=this.referenceCollection.acquire(c,...u);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(f){throw m.dispose(),f}}}e.AsyncReferenceCollection=s;class r{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=r;function a(_){const c=new d;try{_(c)}finally{c.dispose()}}e.disposeOnReturn=a;class v{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){y(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{k(this._store.values())}finally{this._store.clear()}}has(c){return this._store.has(c)}get(c){return this._store.get(c)}set(c,u,m=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),m||this._store.get(c)?.dispose(),this._store.set(c,u)}deleteAndDispose(c){this._store.get(c)?.dispose(),this._store.delete(c)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=v}),define(De[67],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class o{constructor(R){this.element=R,this.next=o.Undefined,this.prev=o.Undefined}}o.Undefined=new o(void 0);class A{constructor(){this._first=o.Undefined,this._last=o.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===o.Undefined}clear(){let R=this._first;for(;R!==o.Undefined;){const T=R.next;R.prev=o.Undefined,R.next=o.Undefined,R=T}this._first=o.Undefined,this._last=o.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,T){const P=new o(R);if(this._first===o.Undefined)this._first=P,this._last=P;else if(T){const g=this._last;this._last=P,P.prev=g,g.next=P}else{const g=this._first;this._first=P,P.next=g,g.prev=P}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(P))}}shift(){if(this._first!==o.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==o.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==o.Undefined&&R.next!==o.Undefined){const T=R.prev;T.next=R.next,R.next.prev=T}else R.prev===o.Undefined&&R.next===o.Undefined?(this._first=o.Undefined,this._last=o.Undefined):R.next===o.Undefined?(this._last=this._last.prev,this._last.next=o.Undefined):R.prev===o.Undefined&&(this._first=this._first.next,this._first.prev=o.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==o.Undefined;)yield R.element,R=R.next}}e.LinkedList=A}),define(De[28],Ie([1,0]),function(oe,e){"use strict";var o,A,l;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(b,i,d){let h=b.get(i);return h===void 0&&(h=d,b.set(i,h)),h}e.getOrSet=R;function T(b){const i=[];return b.forEach((d,h)=>{i.push(`${h} => ${d}`)}),`Map(${b.size}) {${i.join(", ")}}`}e.mapToString=T;function P(b){const i=[];return b.forEach(d=>{i.push(d)}),`Set(${b.size}) {${i.join(", ")}}`}e.setToString=P;class y{constructor(i,d){this.uri=i,this.value=d}}class g{constructor(i,d){this[o]="ResourceMap",i instanceof g?(this.map=new Map(i.map),this.toKey=d??g.defaultToKey):(this.map=new Map,this.toKey=i??g.defaultToKey)}set(i,d){return this.map.set(this.toKey(i),new y(i,d)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,d){typeof d<"u"&&(i=i.bind(d));for(const[h,S]of this.map)i(S.value,S.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=g,g.defaultToKey=b=>b.toString();class L{constructor(i,d){this[A]="ResourceSet",!i||typeof i=="function"?this._map=new g(i):(this._map=new g(d),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,d){this._map.forEach((h,S)=>i.call(d,S,S,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var I;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(I||(e.Touch=I={}));class w{constructor(){this[l]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,d=0){const h=this._map.get(i);if(h)return d!==0&&this.touch(h,d),h.value}set(i,d,h=0){let S=this._map.get(i);if(S)S.value=d,h!==0&&this.touch(S,h);else{switch(S={key:i,value:d,next:void 0,previous:void 0},h){case 0:this.addItemLast(S);break;case 1:this.addItemFirst(S);break;case 2:this.addItemLast(S);break;default:this.addItemLast(S);break}this._map.set(i,S),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const d=this._map.get(i);if(d)return this._map.delete(i),this.removeItem(d),this._size--,d.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,d){const h=this._state;let S=this._head;for(;S;){if(d?i.bind(d)(S.value,S.key,this):i(S.value,S.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const i=this,d=this._state;let h=this._head;const S={[Symbol.iterator](){return S},next(){if(i._state!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const E={value:h.key,done:!1};return h=h.next,E}else return{value:void 0,done:!0}}};return S}values(){const i=this,d=this._state;let h=this._head;const S={[Symbol.iterator](){return S},next(){if(i._state!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const E={value:h.value,done:!1};return h=h.next,E}else return{value:void 0,done:!0}}};return S}entries(){const i=this,d=this._state;let h=this._head;const S={[Symbol.iterator](){return S},next(){if(i._state!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const E={value:[h.key,h.value],done:!1};return h=h.next,E}else return{value:void 0,done:!0}}};return S}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let d=this._head,h=this.size;for(;d&&h>i;)this._map.delete(d.key),d=d.next,h--;this._head=d,this._size=h,d&&(d.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const d=i.next,h=i.previous;if(!d||!h)throw new Error("Invalid list");d.previous=h,h.next=d}i.next=void 0,i.previous=void 0,this._state++}touch(i,d){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(i===this._head)return;const h=i.next,S=i.previous;i===this._tail?(S.next=void 0,this._tail=S):(h.previous=S,S.next=h),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(d===2){if(i===this._tail)return;const h=i.next,S=i.previous;i===this._head?(h.previous=void 0,this._head=h):(h.previous=S,S.next=h),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((d,h)=>{i.push([h,d])}),i}fromJSON(i){this.clear();for(const[d,h]of i)this.set(d,h)}}e.LinkedMap=w;class k extends w{constructor(i,d=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,d),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,d=2){return super.get(i,d)}peek(i){return super.get(i,0)}set(i,d){return super.set(i,d,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=k;class C{constructor(){this.map=new Map}add(i){return this.map.set(i,(this.map.get(i)||0)+1),this}delete(i){let d=this.map.get(i)||0;return d===0?!1:(d--,d===0?this.map.delete(i):this.map.set(i,d),!0)}has(i){return this.map.has(i)}}e.CounterSet=C}),function(oe,e){typeof define=="function"&&define.amd?define(De[149],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(re,ne){for(var de=0;de<ne.length;de++){var ee=ne[de];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(re,ee.key,ee)}}function o(re,ne,de){return ne&&e(re.prototype,ne),de&&e(re,de),Object.defineProperty(re,"prototype",{writable:!1}),re}function A(re,ne){if(re){if(typeof re=="string")return l(re,ne);var de=Object.prototype.toString.call(re).slice(8,-1);if(de==="Object"&&re.constructor&&(de=re.constructor.name),de==="Map"||de==="Set")return Array.from(re);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return l(re,ne)}}function l(re,ne){(ne==null||ne>re.length)&&(ne=re.length);for(var de=0,ee=new Array(ne);de<ne;de++)ee[de]=re[de];return ee}function R(re,ne){var de=typeof Symbol<"u"&&re[Symbol.iterator]||re["@@iterator"];if(de)return(de=de.call(re)).next.bind(de);if(Array.isArray(re)||(de=A(re))||ne&&re&&typeof re.length=="number"){de&&(re=de);var ee=0;return function(){return ee>=re.length?{done:!0}:{done:!1,value:re[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=T();function P(re){oe.defaults=re}var y=/[&<>"']/,g=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(ne){return w[ne]};function C(re,ne){if(ne){if(y.test(re))return re.replace(g,k)}else if(L.test(re))return re.replace(I,k);return re}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function i(re){return re.replace(b,function(ne,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var d=/(^|[^\[])\^/g;function h(re,ne){re=typeof re=="string"?re:re.source,ne=ne||"";var de={replace:function(ce,le){return le=le.source||le,le=le.replace(d,"$1"),re=re.replace(ce,le),de},getRegex:function(){return new RegExp(re,ne)}};return de}var S=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(re,ne,de){if(re){var ee;try{ee=decodeURIComponent(i(de)).replace(S,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ne&&!E.test(de)&&(de=v(ne,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},s=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(re,ne){t[" "+re]||(s.test(re)?t[" "+re]=re+"/":t[" "+re]=m(re,"/",!0)),re=t[" "+re];var de=re.indexOf(":")===-1;return ne.substring(0,2)==="//"?de?ne:re.replace(r,"$1")+ne:ne.charAt(0)==="/"?de?ne:re.replace(a,"$1")+ne:re+ne}var _={exec:function(){}};function c(re){for(var ne=1,de,ee;ne<arguments.length;ne++){de=arguments[ne];for(ee in de)Object.prototype.hasOwnProperty.call(de,ee)&&(re[ee]=de[ee])}return re}function u(re,ne){var de=re.replace(/\|/g,function(le,ue,O){for(var j=!1,Y=ue;--Y>=0&&O[Y]==="\\";)j=!j;return j?"|":" |"}),ee=de.split(/ \|/),ce=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ne)ee.splice(ne);else for(;ee.length<ne;)ee.push("");for(;ce<ee.length;ce++)ee[ce]=ee[ce].trim().replace(/\\\|/g,"|");return ee}function m(re,ne,de){var ee=re.length;if(ee===0)return"";for(var ce=0;ce<ee;){var le=re.charAt(ee-ce-1);if(le===ne&&!de)ce++;else if(le!==ne&&de)ce++;else break}return re.slice(0,ee-ce)}function f(re,ne){if(re.indexOf(ne[1])===-1)return-1;for(var de=re.length,ee=0,ce=0;ce<de;ce++)if(re[ce]==="\\")ce++;else if(re[ce]===ne[0])ee++;else if(re[ce]===ne[1]&&(ee--,ee<0))return ce;return-1}function n(re){re&&re.sanitize&&!re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(re,ne){if(ne<1)return"";for(var de="";ne>1;)ne&1&&(de+=re),ne>>=1,re+=re;return de+re}function M(re,ne,de,ee){var ce=ne.href,le=ne.title?C(ne.title):null,ue=re[1].replace(/\\([\[\]])/g,"$1");if(re[0].charAt(0)!=="!"){ee.state.inLink=!0;var O={type:"link",raw:de,href:ce,title:le,text:ue,tokens:ee.inlineTokens(ue)};return ee.state.inLink=!1,O}return{type:"image",raw:de,href:ce,title:le,text:C(ue)}}function W(re,ne){var de=re.match(/^(\s+)(?:```)/);if(de===null)return ne;var ee=de[1];return ne.split(`
`).map(function(ce){var le=ce.match(/^\s+/);if(le===null)return ce;var ue=le[0];return ue.length>=ee.length?ce.slice(ee.length):ce}).join(`
`)}var $=function(){function re(de){this.options=de||oe.defaults}var ne=re.prototype;return ne.space=function(ee){var ce=this.rules.block.newline.exec(ee);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},ne.code=function(ee){var ce=this.rules.block.code.exec(ee);if(ce){var le=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?le:m(le,`
`)}}},ne.fences=function(ee){var ce=this.rules.block.fences.exec(ee);if(ce){var le=ce[0],ue=W(le,ce[3]||"");return{type:"code",raw:le,lang:ce[2]?ce[2].trim():ce[2],text:ue}}},ne.heading=function(ee){var ce=this.rules.block.heading.exec(ee);if(ce){var le=ce[2].trim();if(/#$/.test(le)){var ue=m(le,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(le=ue.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:le,tokens:this.lexer.inline(le)}}},ne.hr=function(ee){var ce=this.rules.block.hr.exec(ee);if(ce)return{type:"hr",raw:ce[0]}},ne.blockquote=function(ee){var ce=this.rules.block.blockquote.exec(ee);if(ce){var le=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},ne.list=function(ee){var ce=this.rules.block.list.exec(ee);if(ce){var le,ue,O,j,Y,te,be,ye,me,ke,Pe,Be,$e=ce[1].trim(),et=$e.length>1,Qe={type:"list",raw:"",ordered:et,start:et?+$e.slice(0,-1):"",loose:!1,items:[]};$e=et?"\\d{1,9}\\"+$e.slice(-1):"\\"+$e,this.options.pedantic&&($e=et?$e:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+$e+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(Be=!1,!(!(ce=Ye.exec(ee))||this.rules.block.hr.test(ee)));){if(le=ce[0],ee=ee.substring(le.length),ye=ce[2].split(`
`,1)[0],me=ee.split(`
`,1)[0],this.options.pedantic?(j=2,Pe=ye.trimLeft()):(j=ce[2].search(/[^ ]/),j=j>4?1:j,Pe=ye.slice(j),j+=ce[1].length),te=!1,!ye&&/^ *$/.test(me)&&(le+=me+`
`,ee=ee.substring(me.length+1),Be=!0),!Be)for(var nt=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ct=new RegExp("^ {0,"+Math.min(3,j-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,j-1)+"}#");ee&&(ke=ee.split(`
`,1)[0],ye=ke,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(ye)||it.test(ye)||nt.test(ye)||ct.test(ee)));){if(ye.search(/[^ ]/)>=j||!ye.trim())Pe+=`
`+ye.slice(j);else if(!te)Pe+=`
`+ye;else break;!te&&!ye.trim()&&(te=!0),le+=ke+`
`,ee=ee.substring(ke.length+1)}Qe.loose||(be?Qe.loose=!0:/\n *\n *$/.test(le)&&(be=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(Pe),ue&&(O=ue[0]!=="[ ] ",Pe=Pe.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:le,task:!!ue,checked:O,loose:!1,text:Pe}),Qe.raw+=le}Qe.items[Qe.items.length-1].raw=le.trimRight(),Qe.items[Qe.items.length-1].text=Pe.trimRight(),Qe.raw=Qe.raw.trimRight();var z=Qe.items.length;for(Y=0;Y<z;Y++){this.lexer.state.top=!1,Qe.items[Y].tokens=this.lexer.blockTokens(Qe.items[Y].text,[]);var K=Qe.items[Y].tokens.filter(function(Ae){return Ae.type==="space"}),ge=K.every(function(Ae){for(var Me=Ae.raw.split(""),qe=0,He=R(Me),tt;!(tt=He()).done;){var pt=tt.value;if(pt===`
`&&(qe+=1),qe>1)return!0}return!1});!Qe.loose&&K.length&&ge&&(Qe.loose=!0,Qe.items[Y].loose=!0)}return Qe}},ne.html=function(ee){var ce=this.rules.block.html.exec(ee);if(ce){var le={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(ce[0]):C(ce[0]);le.type="paragraph",le.text=ue,le.tokens=this.lexer.inline(ue)}return le}},ne.def=function(ee){var ce=this.rules.block.def.exec(ee);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var le=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:ce[0],href:ce[2],title:ce[3]}}},ne.table=function(ee){var ce=this.rules.block.table.exec(ee);if(ce){var le={type:"table",header:u(ce[1]).map(function(be){return{text:be}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ce[0];var ue=le.align.length,O,j,Y,te;for(O=0;O<ue;O++)/^ *-+: *$/.test(le.align[O])?le.align[O]="right":/^ *:-+: *$/.test(le.align[O])?le.align[O]="center":/^ *:-+ *$/.test(le.align[O])?le.align[O]="left":le.align[O]=null;for(ue=le.rows.length,O=0;O<ue;O++)le.rows[O]=u(le.rows[O],le.header.length).map(function(be){return{text:be}});for(ue=le.header.length,j=0;j<ue;j++)le.header[j].tokens=this.lexer.inline(le.header[j].text);for(ue=le.rows.length,j=0;j<ue;j++)for(te=le.rows[j],Y=0;Y<te.length;Y++)te[Y].tokens=this.lexer.inline(te[Y].text);return le}}},ne.lheading=function(ee){var ce=this.rules.block.lheading.exec(ee);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},ne.paragraph=function(ee){var ce=this.rules.block.paragraph.exec(ee);if(ce){var le=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:le,tokens:this.lexer.inline(le)}}},ne.text=function(ee){var ce=this.rules.block.text.exec(ee);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},ne.escape=function(ee){var ce=this.rules.inline.escape.exec(ee);if(ce)return{type:"escape",raw:ce[0],text:C(ce[1])}},ne.tag=function(ee){var ce=this.rules.inline.tag.exec(ee);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):C(ce[0]):ce[0]}},ne.link=function(ee){var ce=this.rules.inline.link.exec(ee);if(ce){var le=ce[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var ue=m(le.slice(0,-1),"\\");if((le.length-ue.length)%2===0)return}else{var O=f(ce[2],"()");if(O>-1){var j=ce[0].indexOf("!")===0?5:4,Y=j+ce[1].length+O;ce[2]=ce[2].substring(0,O),ce[0]=ce[0].substring(0,Y).trim(),ce[3]=""}}var te=ce[2],be="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(te);ye&&(te=ye[1],be=ye[3])}else be=ce[3]?ce[3].slice(1,-1):"";return te=te.trim(),/^</.test(te)&&(this.options.pedantic&&!/>$/.test(le)?te=te.slice(1):te=te.slice(1,-1)),M(ce,{href:te&&te.replace(this.rules.inline._escapes,"$1"),title:be&&be.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},ne.reflink=function(ee,ce){var le;if((le=this.rules.inline.reflink.exec(ee))||(le=this.rules.inline.nolink.exec(ee))){var ue=(le[2]||le[1]).replace(/\s+/g," ");if(ue=ce[ue.toLowerCase()],!ue||!ue.href){var O=le[0].charAt(0);return{type:"text",raw:O,text:O}}return M(le,ue,le[0],this.lexer)}},ne.emStrong=function(ee,ce,le){le===void 0&&(le="");var ue=this.rules.inline.emStrong.lDelim.exec(ee);if(ue&&!(ue[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var O=ue[1]||ue[2]||"";if(!O||O&&(le===""||this.rules.inline.punctuation.exec(le))){var j=ue[0].length-1,Y,te,be=j,ye=0,me=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,ce=ce.slice(-1*ee.length+j);(ue=me.exec(ce))!=null;)if(Y=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!Y){if(te=Y.length,ue[3]||ue[4]){be+=te;continue}else if((ue[5]||ue[6])&&j%3&&!((j+te)%3)){ye+=te;continue}if(be-=te,!(be>0)){if(te=Math.min(te,te+be+ye),Math.min(j,te)%2){var ke=ee.slice(1,j+ue.index+te);return{type:"em",raw:ee.slice(0,j+ue.index+te+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var Pe=ee.slice(2,j+ue.index+te-1);return{type:"strong",raw:ee.slice(0,j+ue.index+te+1),text:Pe,tokens:this.lexer.inlineTokens(Pe)}}}}}},ne.codespan=function(ee){var ce=this.rules.inline.code.exec(ee);if(ce){var le=ce[2].replace(/\n/g," "),ue=/[^ ]/.test(le),O=/^ /.test(le)&&/ $/.test(le);return ue&&O&&(le=le.substring(1,le.length-1)),le=C(le,!0),{type:"codespan",raw:ce[0],text:le}}},ne.br=function(ee){var ce=this.rules.inline.br.exec(ee);if(ce)return{type:"br",raw:ce[0]}},ne.del=function(ee){var ce=this.rules.inline.del.exec(ee);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},ne.autolink=function(ee,ce){var le=this.rules.inline.autolink.exec(ee);if(le){var ue,O;return le[2]==="@"?(ue=C(this.options.mangle?ce(le[1]):le[1]),O="mailto:"+ue):(ue=C(le[1]),O=ue),{type:"link",raw:le[0],text:ue,href:O,tokens:[{type:"text",raw:ue,text:ue}]}}},ne.url=function(ee,ce){var le;if(le=this.rules.inline.url.exec(ee)){var ue,O;if(le[2]==="@")ue=C(this.options.mangle?ce(le[0]):le[0]),O="mailto:"+ue;else{var j;do j=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(j!==le[0]);ue=C(le[0]),le[1]==="www."?O="http://"+ue:O=ue}return{type:"link",raw:le[0],text:ue,href:O,tokens:[{type:"text",raw:ue,text:ue}]}}},ne.inlineText=function(ee,ce){var le=this.rules.inline.text.exec(ee);if(le){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):C(le[0]):le[0]:ue=C(this.options.smartypants?ce(le[0]):le[0]),{type:"text",raw:le[0],text:ue}}},re}(),N={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:_,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};N._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,N._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,N.def=h(N.def).replace("label",N._label).replace("title",N._title).getRegex(),N.bullet=/(?:[*+-]|\d{1,9}[.)])/,N.listItemStart=h(/^( *)(bull) */).replace("bull",N.bullet).getRegex(),N.list=h(N.list).replace(/bull/g,N.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+N.def.source+")").getRegex(),N._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",N._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,N.html=h(N.html,"i").replace("comment",N._comment).replace("tag",N._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),N.paragraph=h(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.blockquote=h(N.blockquote).replace("paragraph",N.paragraph).getRegex(),N.normal=c({},N),N.gfm=c({},N.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),N.gfm.table=h(N.gfm.table).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.gfm.paragraph=h(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",N.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.pedantic=c({},N.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",N._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:_,paragraph:h(N.normal._paragraph).replace("hr",N.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",N.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:_,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:_,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=h(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=h(N._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=h(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=h(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=h(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=h(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=h(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=h(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=h(U.reflink).replace("label",U._label).replace("ref",N._label).getRegex(),U.nolink=h(U.nolink).replace("ref",N._label).getRegex(),U.reflinkSearch=h(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=c({},U),U.pedantic=c({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=c({},U.normal,{escape:h(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=h(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=c({},U.gfm,{br:h(U.br).replace("{2,}","*").getRegex(),text:h(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function q(re){return re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(re){var ne="",de,ee,ce=re.length;for(de=0;de<ce;de++)ee=re.charCodeAt(de),Math.random()>.5&&(ee="x"+ee.toString(16)),ne+="&#"+ee+";";return ne}var B=function(){function re(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||oe.defaults,this.options.tokenizer=this.options.tokenizer||new $,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:N.normal,inline:U.normal};this.options.pedantic?(ee.block=N.pedantic,ee.inline=U.pedantic):this.options.gfm&&(ee.block=N.gfm,this.options.breaks?ee.inline=U.breaks:ee.inline=U.gfm),this.tokenizer.rules=ee}re.lex=function(ee,ce){var le=new re(ce);return le.lex(ee)},re.lexInline=function(ee,ce){var le=new re(ce);return le.inlineTokens(ee)};var ne=re.prototype;return ne.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},ne.blockTokens=function(ee,ce){var le=this;ce===void 0&&(ce=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(be,ye,me){return ye+"    ".repeat(me.length)});for(var ue,O,j,Y;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(be){return(ue=be.call({lexer:le},ee,ce))?(ee=ee.substring(ue.raw.length),ce.push(ue),!0):!1}))){if(ue=this.tokenizer.space(ee)){ee=ee.substring(ue.raw.length),ue.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(ue);continue}if(ue=this.tokenizer.code(ee)){ee=ee.substring(ue.raw.length),O=ce[ce.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ue.raw,O.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=O.text):ce.push(ue);continue}if(ue=this.tokenizer.fences(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.heading(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.hr(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.blockquote(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.list(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.html(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.def(ee)){ee=ee.substring(ue.raw.length),O=ce[ce.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ue.raw,O.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=O.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.lheading(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(j=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var be=1/0,ye=ee.slice(1),me=void 0;le.options.extensions.startBlock.forEach(function(ke){me=ke.call({lexer:this},ye),typeof me=="number"&&me>=0&&(be=Math.min(be,me))}),be<1/0&&be>=0&&(j=ee.substring(0,be+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(j))){O=ce[ce.length-1],Y&&O.type==="paragraph"?(O.raw+=`
`+ue.raw,O.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):ce.push(ue),Y=j.length!==ee.length,ee=ee.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(ee)){ee=ee.substring(ue.raw.length),O=ce[ce.length-1],O&&O.type==="text"?(O.raw+=`
`+ue.raw,O.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):ce.push(ue);continue}if(ee){var te="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(te);break}else throw new Error(te)}}return this.state.top=!0,ce},ne.inline=function(ee,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:ee,tokens:ce}),ce},ne.inlineTokens=function(ee,ce){var le=this;ce===void 0&&(ce=[]);var ue,O,j,Y=ee,te,be,ye;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(te=this.tokenizer.rules.inline.reflinkSearch.exec(Y))!=null;)me.includes(te[0].slice(te[0].lastIndexOf("[")+1,-1))&&(Y=Y.slice(0,te.index)+"["+D("a",te[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(te=this.tokenizer.rules.inline.blockSkip.exec(Y))!=null;)Y=Y.slice(0,te.index)+"["+D("a",te[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(te=this.tokenizer.rules.inline.escapedEmSt.exec(Y))!=null;)Y=Y.slice(0,te.index)+"++"+Y.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(be||(ye=""),be=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Pe){return(ue=Pe.call({lexer:le},ee,ce))?(ee=ee.substring(ue.raw.length),ce.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.tag(ee)){ee=ee.substring(ue.raw.length),O=ce[ce.length-1],O&&ue.type==="text"&&O.type==="text"?(O.raw+=ue.raw,O.text+=ue.text):ce.push(ue);continue}if(ue=this.tokenizer.link(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(ue.raw.length),O=ce[ce.length-1],O&&ue.type==="text"&&O.type==="text"?(O.raw+=ue.raw,O.text+=ue.text):ce.push(ue);continue}if(ue=this.tokenizer.emStrong(ee,Y,ye)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.codespan(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.br(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.del(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.autolink(ee,F)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(ee,F))){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(j=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var Pe=1/0,Be=ee.slice(1),$e=void 0;le.options.extensions.startInline.forEach(function(et){$e=et.call({lexer:this},Be),typeof $e=="number"&&$e>=0&&(Pe=Math.min(Pe,$e))}),Pe<1/0&&Pe>=0&&(j=ee.substring(0,Pe+1))}(),ue=this.tokenizer.inlineText(j,q)){ee=ee.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(ye=ue.raw.slice(-1)),be=!0,O=ce[ce.length-1],O&&O.type==="text"?(O.raw+=ue.raw,O.text+=ue.text):ce.push(ue);continue}if(ee){var ke="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return ce},o(re,null,[{key:"rules",get:function(){return{block:N,inline:U}}}]),re}(),Q=function(){function re(de){this.options=de||oe.defaults}var ne=re.prototype;return ne.code=function(ee,ce,le){var ue=(ce||"").match(/\S*/)[0];if(this.options.highlight){var O=this.options.highlight(ee,ue);O!=null&&O!==ee&&(le=!0,ee=O)}return ee=ee.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+C(ue,!0)+'">'+(le?ee:C(ee,!0))+`</code></pre>
`:"<pre><code>"+(le?ee:C(ee,!0))+`</code></pre>
`},ne.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ne.html=function(ee){return ee},ne.heading=function(ee,ce,le,ue){if(this.options.headerIds){var O=this.options.headerPrefix+ue.slug(le);return"<h"+ce+' id="'+O+'">'+ee+"</h"+ce+`>
`}return"<h"+ce+">"+ee+"</h"+ce+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(ee,ce,le){var ue=ce?"ol":"ul",O=ce&&le!==1?' start="'+le+'"':"";return"<"+ue+O+`>
`+ee+"</"+ue+`>
`},ne.listitem=function(ee){return"<li>"+ee+`</li>
`},ne.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(ee){return"<p>"+ee+`</p>
`},ne.table=function(ee,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ce+`</table>
`},ne.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ne.tablecell=function(ee,ce){var le=ce.header?"th":"td",ue=ce.align?"<"+le+' align="'+ce.align+'">':"<"+le+">";return ue+ee+("</"+le+`>
`)},ne.strong=function(ee){return"<strong>"+ee+"</strong>"},ne.em=function(ee){return"<em>"+ee+"</em>"},ne.codespan=function(ee){return"<code>"+ee+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(ee){return"<del>"+ee+"</del>"},ne.link=function(ee,ce,le){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return le;var ue='<a href="'+C(ee)+'"';return ce&&(ue+=' title="'+ce+'"'),ue+=">"+le+"</a>",ue},ne.image=function(ee,ce,le){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return le;var ue='<img src="'+ee+'" alt="'+le+'"';return ce&&(ue+=' title="'+ce+'"'),ue+=this.options.xhtml?"/>":">",ue},ne.text=function(ee){return ee},re}(),J=function(){function re(){}var ne=re.prototype;return ne.strong=function(ee){return ee},ne.em=function(ee){return ee},ne.codespan=function(ee){return ee},ne.del=function(ee){return ee},ne.html=function(ee){return ee},ne.text=function(ee){return ee},ne.link=function(ee,ce,le){return""+le},ne.image=function(ee,ce,le){return""+le},ne.br=function(){return""},re}(),X=function(){function re(){this.seen={}}var ne=re.prototype;return ne.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(ee,ce){var le=ee,ue=0;if(this.seen.hasOwnProperty(le)){ue=this.seen[ee];do ue++,le=ee+"-"+ue;while(this.seen.hasOwnProperty(le))}return ce||(this.seen[ee]=ue,this.seen[le]=0),le},ne.slug=function(ee,ce){ce===void 0&&(ce={});var le=this.serialize(ee);return this.getNextSafeSlug(le,ce.dryrun)},re}(),ie=function(){function re(de){this.options=de||oe.defaults,this.options.renderer=this.options.renderer||new Q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new X}re.parse=function(ee,ce){var le=new re(ce);return le.parse(ee)},re.parseInline=function(ee,ce){var le=new re(ce);return le.parseInline(ee)};var ne=re.prototype;return ne.parse=function(ee,ce){ce===void 0&&(ce=!0);var le="",ue,O,j,Y,te,be,ye,me,ke,Pe,Be,$e,et,Qe,Ye,nt,ct,Fe,it,z=ee.length;for(ue=0;ue<z;ue++){if(Pe=ee[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(it=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Pe.type))){le+=it||"";continue}switch(Pe.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(Pe.tokens),Pe.depth,i(this.parseInline(Pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(Pe.text,Pe.lang,Pe.escaped);continue}case"table":{for(me="",ye="",Y=Pe.header.length,O=0;O<Y;O++)ye+=this.renderer.tablecell(this.parseInline(Pe.header[O].tokens),{header:!0,align:Pe.align[O]});for(me+=this.renderer.tablerow(ye),ke="",Y=Pe.rows.length,O=0;O<Y;O++){for(be=Pe.rows[O],ye="",te=be.length,j=0;j<te;j++)ye+=this.renderer.tablecell(this.parseInline(be[j].tokens),{header:!1,align:Pe.align[j]});ke+=this.renderer.tablerow(ye)}le+=this.renderer.table(me,ke);continue}case"blockquote":{ke=this.parse(Pe.tokens),le+=this.renderer.blockquote(ke);continue}case"list":{for(Be=Pe.ordered,$e=Pe.start,et=Pe.loose,Y=Pe.items.length,ke="",O=0;O<Y;O++)Ye=Pe.items[O],nt=Ye.checked,ct=Ye.task,Qe="",Ye.task&&(Fe=this.renderer.checkbox(nt),et?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=Fe+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=Fe+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:Fe}):Qe+=Fe),Qe+=this.parse(Ye.tokens,et),ke+=this.renderer.listitem(Qe,ct,nt);le+=this.renderer.list(ke,Be,$e);continue}case"html":{le+=this.renderer.html(Pe.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(Pe.tokens));continue}case"text":{for(ke=Pe.tokens?this.parseInline(Pe.tokens):Pe.text;ue+1<z&&ee[ue+1].type==="text";)Pe=ee[++ue],ke+=`
`+(Pe.tokens?this.parseInline(Pe.tokens):Pe.text);le+=ce?this.renderer.paragraph(ke):ke;continue}default:{var K='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return le},ne.parseInline=function(ee,ce){ce=ce||this.renderer;var le="",ue,O,j,Y=ee.length;for(ue=0;ue<Y;ue++){if(O=ee[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[O.type]&&(j=this.options.extensions.renderers[O.type].call({parser:this},O),j!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(O.type))){le+=j||"";continue}switch(O.type){case"escape":{le+=ce.text(O.text);break}case"html":{le+=ce.html(O.text);break}case"link":{le+=ce.link(O.href,O.title,this.parseInline(O.tokens,ce));break}case"image":{le+=ce.image(O.href,O.title,O.text);break}case"strong":{le+=ce.strong(this.parseInline(O.tokens,ce));break}case"em":{le+=ce.em(this.parseInline(O.tokens,ce));break}case"codespan":{le+=ce.codespan(O.text);break}case"br":{le+=ce.br();break}case"del":{le+=ce.del(this.parseInline(O.tokens,ce));break}case"text":{le+=ce.text(O.text);break}default:{var te='Token with "'+O.type+'" type was not found.';if(this.options.silent){console.error(te);return}else throw new Error(te)}}}return le},re}();function ae(re,ne,de){if(typeof re>"u"||re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");if(typeof ne=="function"&&(de=ne,ne=null),ne=c({},ae.defaults,ne||{}),n(ne),de){var ee=ne.highlight,ce;try{ce=B.lex(re,ne)}catch(Y){return de(Y)}var le=function(te){var be;if(!te)try{ne.walkTokens&&ae.walkTokens(ce,ne.walkTokens),be=ie.parse(ce,ne)}catch(ye){te=ye}return ne.highlight=ee,te?de(te):de(null,be)};if(!ee||ee.length<3||(delete ne.highlight,!ce.length))return le();var ue=0;ae.walkTokens(ce,function(Y){Y.type==="code"&&(ue++,setTimeout(function(){ee(Y.text,Y.lang,function(te,be){if(te)return le(te);be!=null&&be!==Y.text&&(Y.text=be,Y.escaped=!0),ue--,ue===0&&le()})},0))}),ue===0&&le();return}function O(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+C(Y.message+"",!0)+"</pre>";throw Y}try{var j=B.lex(re,ne);if(ne.walkTokens){if(ne.async)return Promise.all(ae.walkTokens(j,ne.walkTokens)).then(function(){return ie.parse(j,ne)}).catch(O);ae.walkTokens(j,ne.walkTokens)}return ie.parse(j,ne)}catch(Y){O(Y)}}ae.options=ae.setOptions=function(re){return c(ae.defaults,re),P(ae.defaults),ae},ae.getDefaults=T,ae.defaults=oe.defaults,ae.use=function(){for(var re=arguments.length,ne=new Array(re),de=0;de<re;de++)ne[de]=arguments[de];var ee=c.apply(void 0,[{}].concat(ne)),ce=ae.defaults.extensions||{renderers:{},childTokens:{}},le;ne.forEach(function(ue){if(ue.extensions&&(le=!0,ue.extensions.forEach(function(j){if(!j.name)throw new Error("extension name required");if(j.renderer){var Y=ce.renderers?ce.renderers[j.name]:null;Y?ce.renderers[j.name]=function(){for(var te=arguments.length,be=new Array(te),ye=0;ye<te;ye++)be[ye]=arguments[ye];var me=j.renderer.apply(this,be);return me===!1&&(me=Y.apply(this,be)),me}:ce.renderers[j.name]=j.renderer}if(j.tokenizer){if(!j.level||j.level!=="block"&&j.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[j.level]?ce[j.level].unshift(j.tokenizer):ce[j.level]=[j.tokenizer],j.start&&(j.level==="block"?ce.startBlock?ce.startBlock.push(j.start):ce.startBlock=[j.start]:j.level==="inline"&&(ce.startInline?ce.startInline.push(j.start):ce.startInline=[j.start]))}j.childTokens&&(ce.childTokens[j.name]=j.childTokens)})),ue.renderer&&function(){var j=ae.defaults.renderer||new Q,Y=function(ye){var me=j[ye];j[ye]=function(){for(var ke=arguments.length,Pe=new Array(ke),Be=0;Be<ke;Be++)Pe[Be]=arguments[Be];var $e=ue.renderer[ye].apply(j,Pe);return $e===!1&&($e=me.apply(j,Pe)),$e}};for(var te in ue.renderer)Y(te);ee.renderer=j}(),ue.tokenizer&&function(){var j=ae.defaults.tokenizer||new $,Y=function(ye){var me=j[ye];j[ye]=function(){for(var ke=arguments.length,Pe=new Array(ke),Be=0;Be<ke;Be++)Pe[Be]=arguments[Be];var $e=ue.tokenizer[ye].apply(j,Pe);return $e===!1&&($e=me.apply(j,Pe)),$e}};for(var te in ue.tokenizer)Y(te);ee.tokenizer=j}(),ue.walkTokens){var O=ae.defaults.walkTokens;ee.walkTokens=function(j){var Y=[];return Y.push(ue.walkTokens.call(this,j)),O&&(Y=Y.concat(O.call(this,j))),Y}}le&&(ee.extensions=ce),ae.setOptions(ee)})},ae.walkTokens=function(re,ne){for(var de=[],ee=function(){var O=le.value;switch(de=de.concat(ne.call(ae,O)),O.type){case"table":{for(var j=R(O.header),Y;!(Y=j()).done;){var te=Y.value;de=de.concat(ae.walkTokens(te.tokens,ne))}for(var be=R(O.rows),ye;!(ye=be()).done;)for(var me=ye.value,ke=R(me),Pe;!(Pe=ke()).done;){var Be=Pe.value;de=de.concat(ae.walkTokens(Be.tokens,ne))}break}case"list":{de=de.concat(ae.walkTokens(O.items,ne));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[O.type]?ae.defaults.extensions.childTokens[O.type].forEach(function($e){de=de.concat(ae.walkTokens(O[$e],ne))}):O.tokens&&(de=de.concat(ae.walkTokens(O.tokens,ne)))}},ce=R(re),le;!(le=ce()).done;)ee();return de},ae.parseInline=function(re,ne){if(typeof re>"u"||re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");ne=c({},ae.defaults,ne||{}),n(ne);try{var de=B.lexInline(re,ne);return ne.walkTokens&&ae.walkTokens(de,ne.walkTokens),ie.parseInline(de,ne)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+C(ee.message+"",!0)+"</pre>";throw ee}},ae.Parser=ie,ae.parser=ie.parse,ae.Renderer=Q,ae.TextRenderer=J,ae.Lexer=B,ae.lexer=B.lex,ae.Tokenizer=$,ae.Slugger=X,ae.parse=ae;var we=ae.options,he=ae.setOptions,fe=ae.use,V=ae.walkTokens,x=ae.parseInline,Z=ae,pe=ie.parse,_e=B.lex;oe.Lexer=B,oe.Parser=ie,oe.Renderer=Q,oe.Slugger=X,oe.TextRenderer=J,oe.Tokenizer=$,oe.getDefaults=T,oe.lexer=_e,oe.marked=ae,oe.options=we,oe.parse=Z,oe.parseInline=x,oe.parser=pe,oe.setOptions=he,oe.use=fe,oe.walkTokens=V,Object.defineProperty(oe,"__esModule",{value:!0})}),define(De[88],Ie([1,0,28]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new o.LRUCache(1e4);function l(g){return y(g,"NFC",A)}e.normalizeNFC=l;const R=new o.LRUCache(1e4);function T(g){return y(g,"NFD",R)}e.normalizeNFD=T;const P=/[^\u0000-\u0080]/;function y(g,L,I){if(!g)return g;const w=I.get(g);if(w)return w;let k;return P.test(g)?k=g.normalize(L):k=g,I.set(g,k),k}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(L){return T(L).replace(g,"")}}()}),define(De[103],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(P,y,g){return Math.min(Math.max(P,y),g)}e.clamp=o;function A(P,y){return(y+P%y)%y}e.rot=A;class l{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=l;class R{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=R;class T{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const g=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=g,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function oe(l){const R=[];typeof l=="number"&&R.push("code/timeOrigin",l);function T(y){R.push(y,Date.now())}function P(){const y=[];for(let g=0;g<R.length;g+=2)y.push({name:R[g],startTime:R[g+1]});return y}return{mark:T,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(l+T.startTime)});return R}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function o(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=o(A))}(),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var A in o)(typeof exports=="object"?exports:oe)[A]=o[A]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function o(A){if(e[A])return e[A].exports;var l=e[A]={i:A,l:!1,exports:{}};return oe[A].call(l.exports,l,l.exports,o),l.l=!0,l.exports}return o.m=oe,o.c=e,o.d=function(A,l,R){o.o(A,l)||Object.defineProperty(A,l,{enumerable:!0,get:R})},o.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},o.t=function(A,l){if(1&l&&(A=o(A)),8&l||4&l&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(o.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&l&&typeof A!="string")for(var T in A)o.d(R,T,function(P){return A[P]}.bind(null,T));return R},o.n=function(A){var l=A&&A.__esModule?function(){return A.default}:function(){return A};return o.d(l,"a",l),l},o.o=function(A,l){return Object.prototype.hasOwnProperty.call(A,l)},o.p="",o(o.s=0)}([function(oe,e,o){(function(A){var l;e=oe.exports=fe,l=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],y=e.src=[],g=0,L=g++;y[L]="0|[1-9]\\d*";var I=g++;y[I]="[0-9]+";var w=g++;y[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=g++;y[k]="("+y[L]+")\\.("+y[L]+")\\.("+y[L]+")";var C=g++;y[C]="("+y[I]+")\\.("+y[I]+")\\.("+y[I]+")";var b=g++;y[b]="(?:"+y[L]+"|"+y[w]+")";var i=g++;y[i]="(?:"+y[I]+"|"+y[w]+")";var d=g++;y[d]="(?:-("+y[b]+"(?:\\."+y[b]+")*))";var h=g++;y[h]="(?:-?("+y[i]+"(?:\\."+y[i]+")*))";var S=g++;y[S]="[0-9A-Za-z-]+";var E=g++;y[E]="(?:\\+("+y[S]+"(?:\\."+y[S]+")*))";var p=g++,t="v?"+y[k]+y[d]+"?"+y[E]+"?";y[p]="^"+t+"$";var s="[v=\\s]*"+y[C]+y[h]+"?"+y[E]+"?",r=g++;y[r]="^"+s+"$";var a=g++;y[a]="((?:<|>)?=?)";var v=g++;y[v]=y[I]+"|x|X|\\*";var _=g++;y[_]=y[L]+"|x|X|\\*";var c=g++;y[c]="[v=\\s]*("+y[_]+")(?:\\.("+y[_]+")(?:\\.("+y[_]+")(?:"+y[d]+")?"+y[E]+"?)?)?";var u=g++;y[u]="[v=\\s]*("+y[v]+")(?:\\.("+y[v]+")(?:\\.("+y[v]+")(?:"+y[h]+")?"+y[E]+"?)?)?";var m=g++;y[m]="^"+y[a]+"\\s*"+y[c]+"$";var f=g++;y[f]="^"+y[a]+"\\s*"+y[u]+"$";var n=g++;y[n]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=g++;y[D]="(?:~>?)";var M=g++;y[M]="(\\s*)"+y[D]+"\\s+",P[M]=new RegExp(y[M],"g");var W=g++;y[W]="^"+y[D]+y[c]+"$";var $=g++;y[$]="^"+y[D]+y[u]+"$";var N=g++;y[N]="(?:\\^)";var U=g++;y[U]="(\\s*)"+y[N]+"\\s+",P[U]=new RegExp(y[U],"g");var q=g++;y[q]="^"+y[N]+y[c]+"$";var F=g++;y[F]="^"+y[N]+y[u]+"$";var B=g++;y[B]="^"+y[a]+"\\s*("+s+")$|^$";var Q=g++;y[Q]="^"+y[a]+"\\s*("+t+")$|^$";var J=g++;y[J]="(\\s*)"+y[a]+"\\s*("+s+"|"+y[c]+")",P[J]=new RegExp(y[J],"g");var X=g++;y[X]="^\\s*("+y[c]+")\\s+-\\s+("+y[c]+")\\s*$";var ie=g++;y[ie]="^\\s*("+y[u]+")\\s+-\\s+("+y[u]+")\\s*$";var ae=g++;y[ae]="(<|>)?=?\\s*\\*";for(var we=0;we<35;we++)l(we,y[we]),P[we]||(P[we]=new RegExp(y[we]));function he(me,ke){if(me instanceof fe)return me;if(typeof me!="string"||me.length>R||!(ke?P[r]:P[p]).test(me))return null;try{return new fe(me,ke)}catch{return null}}function fe(me,ke){if(me instanceof fe){if(me.loose===ke)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof fe))return new fe(me,ke);l("SemVer",me,ke),this.loose=ke;var Pe=me.trim().match(ke?P[r]:P[p]);if(!Pe)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+Pe[1],this.minor=+Pe[2],this.patch=+Pe[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");Pe[4]?this.prerelease=Pe[4].split(".").map(function(Be){if(/^[0-9]+$/.test(Be)){var $e=+Be;if($e>=0&&$e<T)return $e}return Be}):this.prerelease=[],this.build=Pe[5]?Pe[5].split("."):[],this.format()}e.parse=he,e.valid=function(me,ke){var Pe=he(me,ke);return Pe?Pe.version:null},e.clean=function(me,ke){var Pe=he(me.trim().replace(/^[=v]+/,""),ke);return Pe?Pe.version:null},e.SemVer=fe,fe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},fe.prototype.toString=function(){return this.version},fe.prototype.compare=function(me){return l("SemVer.compare",this.version,this.loose,me),me instanceof fe||(me=new fe(me,this.loose)),this.compareMain(me)||this.comparePre(me)},fe.prototype.compareMain=function(me){return me instanceof fe||(me=new fe(me,this.loose)),x(this.major,me.major)||x(this.minor,me.minor)||x(this.patch,me.patch)},fe.prototype.comparePre=function(me){if(me instanceof fe||(me=new fe(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var ke=0;do{var Pe=this.prerelease[ke],Be=me.prerelease[ke];if(l("prerelease compare",ke,Pe,Be),Pe===void 0&&Be===void 0)return 0;if(Be===void 0)return 1;if(Pe===void 0)return-1;if(Pe!==Be)return x(Pe,Be)}while(++ke)},fe.prototype.inc=function(me,ke){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ke);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ke);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ke),this.inc("pre",ke);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ke),this.inc("pre",ke);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Pe=this.prerelease.length;--Pe>=0;)typeof this.prerelease[Pe]=="number"&&(this.prerelease[Pe]++,Pe=-2);Pe===-1&&this.prerelease.push(0)}ke&&(this.prerelease[0]===ke?isNaN(this.prerelease[1])&&(this.prerelease=[ke,0]):this.prerelease=[ke,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,ke,Pe,Be){typeof Pe=="string"&&(Be=Pe,Pe=void 0);try{return new fe(me,Pe).inc(ke,Be).version}catch{return null}},e.diff=function(me,ke){if(re(me,ke))return null;var Pe=he(me),Be=he(ke);if(Pe.prerelease.length||Be.prerelease.length){for(var $e in Pe)if(($e==="major"||$e==="minor"||$e==="patch")&&Pe[$e]!==Be[$e])return"pre"+$e;return"prerelease"}for(var $e in Pe)if(($e==="major"||$e==="minor"||$e==="patch")&&Pe[$e]!==Be[$e])return $e},e.compareIdentifiers=x;var V=/^[0-9]+$/;function x(me,ke){var Pe=V.test(me),Be=V.test(ke);return Pe&&Be&&(me=+me,ke=+ke),Pe&&!Be?-1:Be&&!Pe?1:me<ke?-1:me>ke?1:0}function Z(me,ke,Pe){return new fe(me,Pe).compare(new fe(ke,Pe))}function pe(me,ke,Pe){return Z(me,ke,Pe)>0}function _e(me,ke,Pe){return Z(me,ke,Pe)<0}function re(me,ke,Pe){return Z(me,ke,Pe)===0}function ne(me,ke,Pe){return Z(me,ke,Pe)!==0}function de(me,ke,Pe){return Z(me,ke,Pe)>=0}function ee(me,ke,Pe){return Z(me,ke,Pe)<=0}function ce(me,ke,Pe,Be){var $e;switch(ke){case"===":typeof me=="object"&&(me=me.version),typeof Pe=="object"&&(Pe=Pe.version),$e=me===Pe;break;case"!==":typeof me=="object"&&(me=me.version),typeof Pe=="object"&&(Pe=Pe.version),$e=me!==Pe;break;case"":case"=":case"==":$e=re(me,Pe,Be);break;case"!=":$e=ne(me,Pe,Be);break;case">":$e=pe(me,Pe,Be);break;case">=":$e=de(me,Pe,Be);break;case"<":$e=_e(me,Pe,Be);break;case"<=":$e=ee(me,Pe,Be);break;default:throw new TypeError("Invalid operator: "+ke)}return $e}function le(me,ke){if(me instanceof le){if(me.loose===ke)return me;me=me.value}if(!(this instanceof le))return new le(me,ke);l("comparator",me,ke),this.loose=ke,this.parse(me),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(me,ke){return x(ke,me)},e.major=function(me,ke){return new fe(me,ke).major},e.minor=function(me,ke){return new fe(me,ke).minor},e.patch=function(me,ke){return new fe(me,ke).patch},e.compare=Z,e.compareLoose=function(me,ke){return Z(me,ke,!0)},e.rcompare=function(me,ke,Pe){return Z(ke,me,Pe)},e.sort=function(me,ke){return me.sort(function(Pe,Be){return e.compare(Pe,Be,ke)})},e.rsort=function(me,ke){return me.sort(function(Pe,Be){return e.rcompare(Pe,Be,ke)})},e.gt=pe,e.lt=_e,e.eq=re,e.neq=ne,e.gte=de,e.lte=ee,e.cmp=ce,e.Comparator=le;var ue={};function O(me,ke){if(me instanceof O)return me.loose===ke?me:new O(me.raw,ke);if(me instanceof le)return new O(me.value,ke);if(!(this instanceof O))return new O(me,ke);if(this.loose=ke,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(Pe){return this.parseRange(Pe.trim())},this).filter(function(Pe){return Pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function j(me){return!me||me.toLowerCase()==="x"||me==="*"}function Y(me,ke,Pe,Be,$e,et,Qe,Ye,nt,ct,Fe,it,z){return((ke=j(Pe)?"":j(Be)?">="+Pe+".0.0":j($e)?">="+Pe+"."+Be+".0":">="+ke)+" "+(Ye=j(nt)?"":j(ct)?"<"+(+nt+1)+".0.0":j(Fe)?"<"+nt+"."+(+ct+1)+".0":it?"<="+nt+"."+ct+"."+Fe+"-"+it:"<="+Ye)).trim()}function te(me,ke){for(var Pe=0;Pe<me.length;Pe++)if(!me[Pe].test(ke))return!1;if(ke.prerelease.length){for(Pe=0;Pe<me.length;Pe++)if(l(me[Pe].semver),me[Pe].semver!==ue&&me[Pe].semver.prerelease.length>0){var Be=me[Pe].semver;if(Be.major===ke.major&&Be.minor===ke.minor&&Be.patch===ke.patch)return!0}return!1}return!0}function be(me,ke,Pe){try{ke=new O(ke,Pe)}catch{return!1}return ke.test(me)}function ye(me,ke,Pe,Be){var $e,et,Qe,Ye,nt;switch(me=new fe(me,Be),ke=new O(ke,Be),Pe){case">":$e=pe,et=ee,Qe=_e,Ye=">",nt=">=";break;case"<":$e=_e,et=de,Qe=pe,Ye="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(me,ke,Be))return!1;for(var ct=0;ct<ke.set.length;++ct){var Fe=ke.set[ct],it=null,z=null;if(Fe.forEach(function(K){K.semver===ue&&(K=new le(">=0.0.0")),it=it||K,z=z||K,$e(K.semver,it.semver,Be)?it=K:Qe(K.semver,z.semver,Be)&&(z=K)}),it.operator===Ye||it.operator===nt||(!z.operator||z.operator===Ye)&&et(me,z.semver)||z.operator===nt&&Qe(me,z.semver))return!1}return!0}le.prototype.parse=function(me){var ke=this.loose?P[B]:P[Q],Pe=me.match(ke);if(!Pe)throw new TypeError("Invalid comparator: "+me);this.operator=Pe[1],this.operator==="="&&(this.operator=""),Pe[2]?this.semver=new fe(Pe[2],this.loose):this.semver=ue},le.prototype.toString=function(){return this.value},le.prototype.test=function(me){return l("Comparator.test",me,this.loose),this.semver===ue||(typeof me=="string"&&(me=new fe(me,this.loose)),ce(me,this.operator,this.semver,this.loose))},le.prototype.intersects=function(me,ke){if(!(me instanceof le))throw new TypeError("a Comparator is required");var Pe;if(this.operator==="")return Pe=new O(me.value,ke),be(this.value,Pe,ke);if(me.operator==="")return Pe=new O(this.value,ke),be(me.semver,Pe,ke);var Be=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),$e=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),et=this.semver.version===me.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Ye=ce(this.semver,"<",me.semver,ke)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),nt=ce(this.semver,">",me.semver,ke)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Be||$e||et&&Qe||Ye||nt},e.Range=O,O.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},O.prototype.toString=function(){return this.range},O.prototype.parseRange=function(me){var ke=this.loose;me=me.trim(),l("range",me,ke);var Pe=ke?P[ie]:P[X];me=me.replace(Pe,Y),l("hyphen replace",me),me=me.replace(P[J],"$1$2$3"),l("comparator trim",me,P[J]),me=(me=(me=me.replace(P[M],"$1~")).replace(P[U],"$1^")).split(/\s+/).join(" ");var Be=ke?P[B]:P[Q],$e=me.split(" ").map(function(et){return function(Qe,Ye){return l("comp",Qe),Qe=function(nt,ct){return nt.trim().split(/\s+/).map(function(Fe){return function(it,z){l("caret",it,z);var K=z?P[F]:P[q];return it.replace(K,function(ge,Ae,Me,qe,He){var tt;return l("caret",it,ge,Ae,Me,qe,He),j(Ae)?tt="":j(Me)?tt=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":j(qe)?tt=Ae==="0"?">="+Ae+"."+Me+".0 <"+Ae+"."+(+Me+1)+".0":">="+Ae+"."+Me+".0 <"+(+Ae+1)+".0.0":He?(l("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),tt=Ae==="0"?Me==="0"?">="+Ae+"."+Me+"."+qe+He+" <"+Ae+"."+Me+"."+(+qe+1):">="+Ae+"."+Me+"."+qe+He+" <"+Ae+"."+(+Me+1)+".0":">="+Ae+"."+Me+"."+qe+He+" <"+(+Ae+1)+".0.0"):(l("no pr"),tt=Ae==="0"?Me==="0"?">="+Ae+"."+Me+"."+qe+" <"+Ae+"."+Me+"."+(+qe+1):">="+Ae+"."+Me+"."+qe+" <"+Ae+"."+(+Me+1)+".0":">="+Ae+"."+Me+"."+qe+" <"+(+Ae+1)+".0.0"),l("caret return",tt),tt})}(Fe,ct)}).join(" ")}(Qe,Ye),l("caret",Qe),Qe=function(nt,ct){return nt.trim().split(/\s+/).map(function(Fe){return function(it,z){var K=z?P[$]:P[W];return it.replace(K,function(ge,Ae,Me,qe,He){var tt;return l("tilde",it,ge,Ae,Me,qe,He),j(Ae)?tt="":j(Me)?tt=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":j(qe)?tt=">="+Ae+"."+Me+".0 <"+Ae+"."+(+Me+1)+".0":He?(l("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),tt=">="+Ae+"."+Me+"."+qe+He+" <"+Ae+"."+(+Me+1)+".0"):tt=">="+Ae+"."+Me+"."+qe+" <"+Ae+"."+(+Me+1)+".0",l("tilde return",tt),tt})}(Fe,ct)}).join(" ")}(Qe,Ye),l("tildes",Qe),Qe=function(nt,ct){return l("replaceXRanges",nt,ct),nt.split(/\s+/).map(function(Fe){return function(it,z){it=it.trim();var K=z?P[f]:P[m];return it.replace(K,function(ge,Ae,Me,qe,He,tt){l("xRange",it,ge,Ae,Me,qe,He,tt);var pt=j(Me),at=pt||j(qe),vt=at||j(He);return Ae==="="&&vt&&(Ae=""),pt?ge=Ae===">"||Ae==="<"?"<0.0.0":"*":Ae&&vt?(at&&(qe=0),vt&&(He=0),Ae===">"?(Ae=">=",at?(Me=+Me+1,qe=0,He=0):vt&&(qe=+qe+1,He=0)):Ae==="<="&&(Ae="<",at?Me=+Me+1:qe=+qe+1),ge=Ae+Me+"."+qe+"."+He):at?ge=">="+Me+".0.0 <"+(+Me+1)+".0.0":vt&&(ge=">="+Me+"."+qe+".0 <"+Me+"."+(+qe+1)+".0"),l("xRange return",ge),ge})}(Fe,ct)}).join(" ")}(Qe,Ye),l("xrange",Qe),Qe=function(nt,ct){return l("replaceStars",nt,ct),nt.trim().replace(P[ae],"")}(Qe,Ye),l("stars",Qe),Qe}(et,ke)}).join(" ").split(/\s+/);return this.loose&&($e=$e.filter(function(et){return!!et.match(Be)})),$e=$e.map(function(et){return new le(et,ke)})},O.prototype.intersects=function(me,ke){if(!(me instanceof O))throw new TypeError("a Range is required");return this.set.some(function(Pe){return Pe.every(function(Be){return me.set.some(function($e){return $e.every(function(et){return Be.intersects(et,ke)})})})})},e.toComparators=function(me,ke){return new O(me,ke).set.map(function(Pe){return Pe.map(function(Be){return Be.value}).join(" ").trim().split(" ")})},O.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new fe(me,this.loose));for(var ke=0;ke<this.set.length;ke++)if(te(this.set[ke],me))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(me,ke,Pe){var Be=null,$e=null;try{var et=new O(ke,Pe)}catch{return null}return me.forEach(function(Qe){et.test(Qe)&&(Be&&$e.compare(Qe)!==-1||($e=new fe(Be=Qe,Pe)))}),Be},e.minSatisfying=function(me,ke,Pe){var Be=null,$e=null;try{var et=new O(ke,Pe)}catch{return null}return me.forEach(function(Qe){et.test(Qe)&&(Be&&$e.compare(Qe)!==1||($e=new fe(Be=Qe,Pe)))}),Be},e.validRange=function(me,ke){try{return new O(me,ke).range||"*"}catch{return null}},e.ltr=function(me,ke,Pe){return ye(me,ke,"<",Pe)},e.gtr=function(me,ke,Pe){return ye(me,ke,">",Pe)},e.outside=ye,e.prerelease=function(me,ke){var Pe=he(me,ke);return Pe&&Pe.prerelease.length?Pe.prerelease:null},e.intersects=function(me,ke,Pe){return me=new O(me,Pe),ke=new O(ke,Pe),me.intersects(ke)},e.coerce=function(me){if(me instanceof fe)return me;if(typeof me!="string")return null;var ke=me.match(P[n]);return ke==null?null:he((ke[1]||"0")+"."+(ke[2]||"0")+"."+(ke[3]||"0"))}}).call(this,o(1))},function(oe,e){var o,A,l=oe.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function P(i){if(o===setTimeout)return setTimeout(i,0);if((o===R||!o)&&setTimeout)return o=setTimeout,setTimeout(i,0);try{return o(i,0)}catch{try{return o.call(null,i,0)}catch{return o.call(this,i,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:R}catch{o=R}try{A=typeof clearTimeout=="function"?clearTimeout:T}catch{A=T}})();var y,g=[],L=!1,I=-1;function w(){L&&y&&(L=!1,y.length?g=y.concat(g):I=-1,g.length&&k())}function k(){if(!L){var i=P(w);L=!0;for(var d=g.length;d;){for(y=g,g=[];++I<d;)y&&y[I].run();I=-1,d=g.length}y=null,L=!1,function(h){if(A===clearTimeout)return clearTimeout(h);if((A===T||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(h);try{A(h)}catch{try{return A.call(null,h)}catch{return A.call(this,h)}}}(i)}}function C(i,d){this.fun=i,this.array=d}function b(){}l.nextTick=function(i){var d=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)d[h-1]=arguments[h];g.push(new C(i,d)),g.length!==1||L||P(k)},C.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=b,l.addListener=b,l.once=b,l.off=b,l.removeListener=b,l.removeAllListeners=b,l.emit=b,l.prependListener=b,l.prependOnceListener=b,l.listeners=function(i){return[]},l.binding=function(i){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(i){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(De[104],Ie([1,0,8,6]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(E){const p=E;return p?typeof p.read=="function":!1}e.isReadable=l;function R(E){const p=E;return p?[p.on,p.pause,p.resume,p.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function T(E){const p=E;return p?R(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=T;function P(E,p){return new y(E,p)}e.newWriteableStream=P;class y{constructor(p,t){this.reducer=p,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(t=>t(p))}emitError(p){this.listeners.error.length===0?(0,o.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(t=>t(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,t){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(p,t){if(this.state.destroyed)return;let s;switch(p){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const r=s.indexOf(t);r>=0&&s.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(E,p){const t=[];let s;for(;(s=E.read())!==null;)t.push(s);return p(t)}e.consumeReadable=g;function L(E,p,t){const s=[];let r;for(;(r=E.read())!==null&&s.length<t;)s.push(r);return r===null&&s.length>0?p(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const a=r;return r=void 0,a}return E.read()}}}e.peekReadable=L;function I(E,p){return new Promise((t,s)=>{const r=[];w(E,{onData:a=>{p&&r.push(a)},onError:a=>{p?s(a):t(void 0)},onEnd:()=>{t(p?p(r):void 0)}})})}e.consumeStream=I;function w(E,p){let t=!1;return E.on("error",s=>{t||p.onError(s)}),E.on("end",()=>{t||p.onEnd()}),E.on("data",s=>{t||p.onData(s)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=w;function k(E,p){return new Promise((t,s)=>{const r=new A.DisposableStore,a=[],v=u=>{if(a.push(u),a.length>p)return r.dispose(),E.pause(),t({stream:E,buffer:a,ended:!1})},_=u=>s(u),c=()=>t({stream:E,buffer:a,ended:!0});r.add((0,A.toDisposable)(()=>E.removeListener("error",_))),E.on("error",_),r.add((0,A.toDisposable)(()=>E.removeListener("end",c))),E.on("end",c),r.add((0,A.toDisposable)(()=>E.removeListener("data",v))),E.on("data",v)})}e.peekStream=k;function C(E,p){const t=P(p);return t.end(E),t}e.toStream=C;function b(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=b;function i(E){let p=!1;return{read:()=>p?null:(p=!0,E)}}e.toReadable=i;function d(E,p,t){const s=P(t);return w(E,{onData:r=>s.write(p.data(r)),onError:r=>s.error(p.error?p.error(r):r),onEnd:()=>s.end()}),s}e.transform=d;function h(E,p,t){let s=!1;return{read:()=>{const r=p.read();return s?r:(s=!0,r!==null?t([E,r]):E)}}}e.prefixedReadable=h;function S(E,p,t){let s=!1;const r=P(t);return w(p,{onData:a=>s?r.write(a):(s=!0,r.write(t([E,a]))),onError:a=>r.error(a),onEnd:()=>{s||(s=!0,r.write(E)),r.end()}}),r}e.prefixedStream=S}),define(De[22],Ie([1,0,104]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let l,R;class T{static alloc(u){return A?new T(Buffer.allocUnsafe(u)):new T(new Uint8Array(u))}static wrap(u){return A&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new T(u)}static fromString(u,m){return!(m?.dontUseNodeBuffer||!1)&&A?new T(Buffer.from(u)):(l||(l=new TextEncoder),new T(l.encode(u)))}static fromByteArray(u){const m=T.alloc(u.length);for(let f=0,n=u.length;f<n;f++)m.buffer[f]=u[f];return m}static concat(u,m){if(typeof m>"u"){m=0;for(let D=0,M=u.length;D<M;D++)m+=u[D].byteLength}const f=T.alloc(m);let n=0;for(let D=0,M=u.length;D<M;D++){const W=u[D];f.set(W,n),n+=W.byteLength}return f}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=T.alloc(this.byteLength);return u.set(this),u}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(u,m){return new T(this.buffer.subarray(u,m))}set(u,m){if(u instanceof T)this.buffer.set(u.buffer,m);else if(u instanceof Uint8Array)this.buffer.set(u,m);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),m);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return g(this.buffer,u)}writeUInt32BE(u,m){L(this.buffer,u,m)}readUInt32LE(u){return I(this.buffer,u)}writeUInt32LE(u,m){w(this.buffer,u,m)}readUInt8(u){return k(this.buffer,u)}writeUInt8(u,m){C(this.buffer,u,m)}}e.VSBuffer=T;function P(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0}e.readUInt16LE=P;function y(c,u,m){c[m+0]=u&255,u=u>>>8,c[m+1]=u&255}e.writeUInt16LE=y;function g(c,u){return c[u]*2**24+c[u+1]*2**16+c[u+2]*2**8+c[u+3]}e.readUInt32BE=g;function L(c,u,m){c[m+3]=u,u=u>>>8,c[m+2]=u,u=u>>>8,c[m+1]=u,u=u>>>8,c[m]=u}e.writeUInt32BE=L;function I(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0|c[u+2]<<16>>>0|c[u+3]<<24>>>0}e.readUInt32LE=I;function w(c,u,m){c[m+0]=u&255,u=u>>>8,c[m+1]=u&255,u=u>>>8,c[m+2]=u&255,u=u>>>8,c[m+3]=u&255}e.writeUInt32LE=w;function k(c,u){return c[u]}e.readUInt8=k;function C(c,u,m){c[m]=u}e.writeUInt8=C;function b(c){return o.consumeReadable(c,u=>T.concat(u))}e.readableToBuffer=b;function i(c){return o.toReadable(c)}e.bufferToReadable=i;function d(c){return o.consumeStream(c,u=>T.concat(u))}e.streamToBuffer=d;async function h(c){return c.ended?T.concat(c.buffer):T.concat([...c.buffer,await d(c.stream)])}e.bufferedStreamToBuffer=h;function S(c){return o.toStream(c,u=>T.concat(u))}e.bufferToStream=S;function E(c){return o.transform(c,{data:u=>typeof u=="string"?T.fromString(u):T.wrap(u)},u=>T.concat(u))}e.streamToBufferReadableStream=E;function p(c){return o.newWriteableStream(u=>T.concat(u),c)}e.newWriteableBufferStream=p;function t(c,u){return o.prefixedReadable(c,u,m=>T.concat(m))}e.prefixedBufferReadable=t;function s(c,u){return o.prefixedStream(c,u,m=>T.concat(m))}e.prefixedBufferStream=s;function r(c){let u=0,m=0,f=0;const n=new Uint8Array(Math.floor(c.length/4*3)),D=W=>{switch(m){case 3:n[f++]=u|W,m=0;break;case 2:n[f++]=u|W>>>2,u=W<<6,m=3;break;case 1:n[f++]=u|W>>>4,u=W<<4,m=2;break;default:u=W<<2,m=1}};for(let W=0;W<c.length;W++){const $=c.charCodeAt(W);if($>=65&&$<=90)D($-65);else if($>=97&&$<=122)D($-97+26);else if($>=48&&$<=57)D($-48+52);else if($===43||$===45)D(62);else if($===47||$===95)D(63);else{if($===61)break;throw new SyntaxError(`Unexpected base64 character ${c[W]}`)}}const M=f;for(;m>0;)D(0);return T.wrap(n).slice(0,M)}e.decodeBase64=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function _({buffer:c},u=!0,m=!1){const f=m?v:a;let n="";const D=c.byteLength%3;let M=0;for(;M<c.byteLength-D;M+=3){const W=c[M+0],$=c[M+1],N=c[M+2];n+=f[W>>>2],n+=f[(W<<4|$>>>4)&63],n+=f[($<<2|N>>>6)&63],n+=f[N&63]}if(D===1){const W=c[M+0];n+=f[W>>>2],n+=f[W<<4&63],u&&(n+="==")}else if(D===2){const W=c[M+0],$=c[M+1];n+=f[W>>>2],n+=f[(W<<4|$>>>4)&63],n+=f[$<<2&63],u&&(n+="=")}return n}e.encodeBase64=_}),define(De[150],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(De[10],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function o(s){return typeof s=="string"}e.isString=o;function A(s){return Array.isArray(s)&&s.every(r=>o(r))}e.isStringArray=A;function l(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=l;function R(s){const r=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof r}e.isTypedArray=R;function T(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=T;function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=P;function y(s){return s===!0||s===!1}e.isBoolean=y;function g(s){return typeof s>"u"}e.isUndefined=g;function L(s){return!I(s)}e.isDefined=L;function I(s){return g(s)||s===null}e.isUndefinedOrNull=I;function w(s,r){if(!s)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=w;function k(s){if(I(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=k;function C(...s){const r=[];for(let a=0;a<s.length;a++){const v=s[a];if(I(v))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);r.push(v)}return r}e.assertAllDefined=C;const b=Object.prototype.hasOwnProperty;function i(s){if(!l(s))return!1;for(const r in s)if(b.call(s,r))return!1;return!0}e.isEmptyObject=i;function d(s){return typeof s=="function"}e.isFunction=d;function h(...s){return s.length>0&&s.every(d)}e.areFunctions=h;function S(s,r){const a=Math.min(s.length,r.length);for(let v=0;v<a;v++)E(s[v],r[v])}e.validateConstraints=S;function E(s,r){if(o(r)){if(typeof s!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(d(r)){try{if(s instanceof r)return}catch{}if(!I(s)&&s.constructor===r||r.length===1&&r.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function p(s){return s===null?void 0:s}e.withNullAsUndefined=p;function t(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=t}),define(De[68],Ie([1,0,10]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function l(P,y){if((0,o.isString)(y)){const g=A[y];if(g===void 0)throw new Error(`${P} references an unknown codicon: ${y}`);y=g}return A[P]=y,{id:P}}function R(){return A}e.getCodiconFontCharacters=R;function T(){return Object.values(e.Codicon)}e.getAllCodicons=T,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),send:l("send",60431),sparkle:l("sparkle",60432),insert:l("insert",60433),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(De[23],Ie([1,0,10]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const h=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([S,E])=>{h[S]=E&&typeof E=="object"?A(E):E}),h}e.deepClone=A;function l(d){if(!d||typeof d!="object")return d;const h=[d];for(;h.length>0;){const S=h.shift();Object.freeze(S);for(const E in S)if(R.call(S,E)){const p=S[E];typeof p=="object"&&!Object.isFrozen(p)&&!(0,o.isTypedArray)(p)&&h.push(p)}}return d}e.deepFreeze=l;const R=Object.prototype.hasOwnProperty;function T(d,h){return P(d,h,new Set)}e.cloneAndChange=T;function P(d,h,S){if((0,o.isUndefinedOrNull)(d))return d;const E=h(d);if(typeof E<"u")return E;if(Array.isArray(d)){const p=[];for(const t of d)p.push(P(t,h,S));return p}if((0,o.isObject)(d)){if(S.has(d))throw new Error("Cannot clone recursive data-structure");S.add(d);const p={};for(const t in d)R.call(d,t)&&(p[t]=P(d[t],h,S));return S.delete(d),p}return d}function y(d,h,S=!0){return(0,o.isObject)(d)?((0,o.isObject)(h)&&Object.keys(h).forEach(E=>{E in d?S&&((0,o.isObject)(d[E])&&(0,o.isObject)(h[E])?y(d[E],h[E],S):d[E]=h[E]):d[E]=h[E]}),d):h}e.mixin=y;function g(d,h){if(d===h)return!0;if(d==null||h===null||h===void 0||typeof d!=typeof h||typeof d!="object"||Array.isArray(d)!==Array.isArray(h))return!1;let S,E;if(Array.isArray(d)){if(d.length!==h.length)return!1;for(S=0;S<d.length;S++)if(!g(d[S],h[S]))return!1}else{const p=[];for(E in d)p.push(E);p.sort();const t=[];for(E in h)t.push(E);if(t.sort(),!g(p,t))return!1;for(S=0;S<p.length;S++)if(!g(d[p[S]],h[p[S]]))return!1}return!0}e.equals=g;function L(d){const h=new Set;return JSON.stringify(d,(S,E)=>{if((0,o.isObject)(E)||Array.isArray(E)){if(h.has(E))return"[Circular]";h.add(E)}return E})}e.safeStringify=L;function I(d,h){const S=Object.create(null);return!d||!h||Object.keys(h).forEach(p=>{const t=d[p],s=h[p];g(t,s)||(S[p]=s)}),S}e.distinct=I;function w(d,h){const S=h.toLowerCase(),E=Object.keys(d).find(p=>p.toLowerCase()===S);return E?d[E]:d[h]}e.getCaseInsensitive=w;function k(d,h){const S=Object.create(null);for(const[E,p]of Object.entries(d))h(E,p)&&(S[E]=p);return S}e.filter=k;function C(d){let h=[],S=Object.getPrototypeOf(d);for(;Object.prototype!==S;)h=h.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return h}e.getAllPropertyNames=C;function b(d){const h=[];for(const S of C(d))typeof d[S]=="function"&&h.push(S);return h}e.getAllMethodNames=b;function i(d,h){const S=p=>function(){const t=Array.prototype.slice.call(arguments,0);return h(p,t)},E={};for(const p of d)E[p]=S(p);return E}e.createProxyObject=i}),define(De[53],Ie([1,0,68]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(T){function P(y){return y&&typeof y=="object"&&typeof y.id=="string"}T.isThemeColor=P})(A||(e.ThemeColor=A={}));function l(T){return{id:T}}e.themeColorFromId=l;var R;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function y(h){const S=P.exec(h.id);if(!S)return y(o.Codicon.error);const[,E,p]=S,t=["codicon","codicon-"+E];return p&&t.push("codicon-modifier-"+p.substring(1)),t}T.asClassNameArray=y;function g(h){return y(h).join(" ")}T.asClassName=g;function L(h){return"."+y(h).join(".")}T.asCSSSelector=L;function I(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||A.isThemeColor(h.color))}T.isThemeIcon=I;const w=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function k(h){const S=w.exec(h);if(!S)return;const[,E]=S;return{id:E}}T.fromString=k;function C(h){return{id:h}}T.fromId=C;function b(h,S){let E=h.id;const p=E.lastIndexOf("~");return p!==-1&&(E=E.substring(0,p)),S&&(E=`${E}~${S}`),{id:E}}T.modify=b;function i(h){const S=h.id.lastIndexOf("~");if(S!==-1)return h.id.substring(S+1)}T.getModifier=i;function d(h,S){return h.id===S.id&&h.color?.id===S.color?.id}T.isEqual=d})(R||(e.ThemeIcon=R={}))}),define(De[105],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var o;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o||(e.Constants=o={}));function A(R){return R<0?0:R>255?255:R|0}e.toUint8=A;function l(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=l}),define(De[30],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(l){return o.test(l)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(P){for(let y=0;y<P.length;y++)P[y]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),T=[];for(let P=0;P<256;P++)T.push(P.toString(16).padStart(2,"0"));return function(){l(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,g="";return g+=T[R[y++]],g+=T[R[y++]],g+=T[R[y++]],g+=T[R[y++]],g+="-",g+=T[R[y++]],g+=T[R[y++]],g+="-",g+=T[R[y++]],g+=T[R[y++]],g+="-",g+=T[R[y++]],g+=T[R[y++]],g+="-",g+=T[R[y++]],g+=T[R[y++]],g+=T[R[y++]],g+=T[R[y++]],g+=T[R[y++]],g+=T[R[y++]],g}}()}),define(De[151],Ie([1,0,18,52,30]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function R(y){return{id:(0,l.generateUuid)(),asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}e.createStringDataTransferItem=R;function T(y,g,L){return{id:(0,l.generateUuid)(),asString:async()=>"",asFile:()=>({name:y,uri:g,data:L}),value:void 0}}e.createFileDataTransferItem=T;class P{constructor(){this._entries=new Map}get size(){let g=0;return this.forEach(()=>g++),g}has(g){return this._entries.has(this.toKey(g))}matches(g){if(this.has(g))return!0;if(g.toLowerCase()==="files")return A.Iterable.some(this.values(),C=>C.asFile());if(g==="*/*")return this._entries.size>0;const L=this.toKey(g).match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!L)return!1;const[I,w,k]=L;return k==="*"?A.Iterable.some(this._entries.keys(),C=>C.startsWith(w+"/")):!1}get(g){return this._entries.get(this.toKey(g))?.[0]}append(g,L){const I=this._entries.get(g);I?I.push(L):this._entries.set(this.toKey(g),[L])}replace(g,L){this._entries.set(this.toKey(g),[L])}delete(g){this._entries.delete(this.toKey(g))}*entries(){for(const[g,L]of this._entries.entries())for(const I of L)yield[g,I]}values(){return Array.from(this._entries.values()).flat()}forEach(g){for(const[L,I]of this.entries())g(I,L)}toKey(g){return g.toLowerCase()}}e.VSDataTransfer=P,e.UriList=Object.freeze({create:y=>(0,o.distinct)(y.map(g=>g.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.UriList.split(y).filter(g=>!g.startsWith("#"))})}),define(De[106],Ie([1,0,105]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class A{constructor(P){const y=(0,o.toUint8)(P);this._defaultValue=y,this._asciiMap=A._createAsciiMap(y),this._map=new Map}static _createAsciiMap(P){const y=new Uint8Array(256);return y.fill(P),y}set(P,y){const g=(0,o.toUint8)(y);P>=0&&P<256?this._asciiMap[P]=g:this._map.set(P,g)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=A;var l;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(l||(l={}));class R{constructor(){this._actual=new A(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}clear(){return this._actual.clear()}}e.CharacterSet=R}),define(De[54],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class o{constructor(l,R){this.lineNumber=l,this.column=R}with(l=this.lineNumber,R=this.column){return l===this.lineNumber&&R===this.column?this:new o(l,R)}delta(l=0,R=0){return this.with(this.lineNumber+l,this.column+R)}equals(l){return o.equals(this,l)}static equals(l,R){return!l&&!R?!0:!!l&&!!R&&l.lineNumber===R.lineNumber&&l.column===R.column}isBefore(l){return o.isBefore(this,l)}static isBefore(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<R.column}isBeforeOrEqual(l){return o.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<=R.column}static compare(l,R){const T=l.lineNumber|0,P=R.lineNumber|0;if(T===P){const y=l.column|0,g=R.column|0;return y-g}return T-P}clone(){return new o(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new o(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.Position=o}),define(De[32],Ie([1,0,54]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(R,T,P,y){R>P||R===P&&T>y?(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=R,this.endColumn=T):(this.startLineNumber=R,this.startColumn=T,this.endLineNumber=P,this.endColumn=y)}isEmpty(){return A.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return A.containsPosition(this,R)}static containsPosition(R,T){return!(T.lineNumber<R.startLineNumber||T.lineNumber>R.endLineNumber||T.lineNumber===R.startLineNumber&&T.column<R.startColumn||T.lineNumber===R.endLineNumber&&T.column>R.endColumn)}static strictContainsPosition(R,T){return!(T.lineNumber<R.startLineNumber||T.lineNumber>R.endLineNumber||T.lineNumber===R.startLineNumber&&T.column<=R.startColumn||T.lineNumber===R.endLineNumber&&T.column>=R.endColumn)}containsRange(R){return A.containsRange(this,R)}static containsRange(R,T){return!(T.startLineNumber<R.startLineNumber||T.endLineNumber<R.startLineNumber||T.startLineNumber>R.endLineNumber||T.endLineNumber>R.endLineNumber||T.startLineNumber===R.startLineNumber&&T.startColumn<R.startColumn||T.endLineNumber===R.endLineNumber&&T.endColumn>R.endColumn)}strictContainsRange(R){return A.strictContainsRange(this,R)}static strictContainsRange(R,T){return!(T.startLineNumber<R.startLineNumber||T.endLineNumber<R.startLineNumber||T.startLineNumber>R.endLineNumber||T.endLineNumber>R.endLineNumber||T.startLineNumber===R.startLineNumber&&T.startColumn<=R.startColumn||T.endLineNumber===R.endLineNumber&&T.endColumn>=R.endColumn)}plusRange(R){return A.plusRange(this,R)}static plusRange(R,T){let P,y,g,L;return T.startLineNumber<R.startLineNumber?(P=T.startLineNumber,y=T.startColumn):T.startLineNumber===R.startLineNumber?(P=T.startLineNumber,y=Math.min(T.startColumn,R.startColumn)):(P=R.startLineNumber,y=R.startColumn),T.endLineNumber>R.endLineNumber?(g=T.endLineNumber,L=T.endColumn):T.endLineNumber===R.endLineNumber?(g=T.endLineNumber,L=Math.max(T.endColumn,R.endColumn)):(g=R.endLineNumber,L=R.endColumn),new A(P,y,g,L)}intersectRanges(R){return A.intersectRanges(this,R)}static intersectRanges(R,T){let P=R.startLineNumber,y=R.startColumn,g=R.endLineNumber,L=R.endColumn;const I=T.startLineNumber,w=T.startColumn,k=T.endLineNumber,C=T.endColumn;return P<I?(P=I,y=w):P===I&&(y=Math.max(y,w)),g>k?(g=k,L=C):g===k&&(L=Math.min(L,C)),P>g||P===g&&y>L?null:new A(P,y,g,L)}equalsRange(R){return A.equalsRange(this,R)}static equalsRange(R,T){return!R&&!T?!0:!!R&&!!T&&R.startLineNumber===T.startLineNumber&&R.startColumn===T.startColumn&&R.endLineNumber===T.endLineNumber&&R.endColumn===T.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(R){return new o.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(R){return new o.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,T){return new A(this.startLineNumber,this.startColumn,R,T)}setStartPosition(R,T){return new A(R,T,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(R){return new A(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(R){return new A(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new A(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,T=R){return new A(R.lineNumber,R.column,T.lineNumber,T.column)}static lift(R){return R?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,T){return!(R.endLineNumber<T.startLineNumber||R.endLineNumber===T.startLineNumber&&R.endColumn<T.startColumn||T.endLineNumber<R.startLineNumber||T.endLineNumber===R.startLineNumber&&T.endColumn<R.startColumn)}static areIntersecting(R,T){return!(R.endLineNumber<T.startLineNumber||R.endLineNumber===T.startLineNumber&&R.endColumn<=T.startColumn||T.endLineNumber<R.startLineNumber||T.endLineNumber===R.startLineNumber&&T.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,T){if(R&&T){const g=R.startLineNumber|0,L=T.startLineNumber|0;if(g===L){const I=R.startColumn|0,w=T.startColumn|0;if(I===w){const k=R.endLineNumber|0,C=T.endLineNumber|0;if(k===C){const b=R.endColumn|0,i=T.endColumn|0;return b-i}return k-C}return I-w}return g-L}return(R?1:0)-(T?1:0)}static compareRangesUsingEnds(R,T){return R.endLineNumber===T.endLineNumber?R.endColumn===T.endColumn?R.startLineNumber===T.startLineNumber?R.startColumn-T.startColumn:R.startLineNumber-T.startLineNumber:R.endColumn-T.endColumn:R.endLineNumber-T.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=A}),define(De[152],Ie([1,0,54,32]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var l;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(l||(e.SelectionDirection=l={}));class R extends A.Range{constructor(P,y,g,L){super(P,y,g,L),this.selectionStartLineNumber=P,this.selectionStartColumn=y,this.positionLineNumber=g,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return R.selectionsEqual(this,P)}static selectionsEqual(P,y){return P.selectionStartLineNumber===y.selectionStartLineNumber&&P.selectionStartColumn===y.selectionStartColumn&&P.positionLineNumber===y.positionLineNumber&&P.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,P,y):new R(P,y,this.startLineNumber,this.startColumn)}getPosition(){return new o.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new o.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(P,y){return this.getDirection()===0?new R(P,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,P,y)}static fromPositions(P,y=P){return new R(P.lineNumber,P.column,y.lineNumber,y.column)}static fromRange(P,y){return y===0?new R(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):new R(P.endLineNumber,P.endColumn,P.startLineNumber,P.startColumn)}static liftSelection(P){return new R(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,y){if(P&&!y||!P&&y)return!1;if(!P&&!y)return!0;if(P.length!==y.length)return!1;for(let g=0,L=P.length;g<L;g++)if(!this.selectionsEqual(P[g],y[g]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,y,g,L,I){return I===0?new R(P,y,g,L):new R(g,L,P,y)}}e.Selection=R}),define(De[153],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[154],Ie([1,0,106]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var A;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(A||(e.WordCharacterClass=A={}));class l extends o.CharacterClassifier{constructor(P){super(0);for(let y=0,g=P.length;y<g;y++)this.set(P.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=l;function R(T){const P={};return y=>(P.hasOwnProperty(y)||(P[y]=T(y)),P[y])}e.getMapForWordSeparators=R(T=>new l(T))}),define(De[107],Ie([1,0,52,6,67]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(I=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)I.indexOf(k)>=0||(w+="\\"+k);return w+="\\s]+)",new RegExp(w,"g")}e.DEFAULT_WORD_REGEXP=R();function T(I){let w=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)w=I;else{let k="g";I.ignoreCase&&(k+="i"),I.multiline&&(k+="m"),I.unicode&&(k+="u"),w=new RegExp(I.source,k)}return w.lastIndex=0,w}e.ensureValidWordDefinition=T;const P=new l.LinkedList;P.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(I){const w=P.unshift(I);return(0,A.toDisposable)(w)}e.setDefaultGetWordAtTextConfig=y;function g(I,w,k,C,b){if(b||(b=o.Iterable.first(P)),k.length>b.maxLen){let E=I-b.maxLen/2;return E<0?E=0:C+=E,k=k.substring(E,I+b.maxLen/2),g(I,w,k,C,b)}const i=Date.now(),d=I-1-C;let h=-1,S=null;for(let E=1;!(Date.now()-i>=b.timeBudget);E++){const p=d-b.windowSize*E;w.lastIndex=Math.max(0,p);const t=L(w,k,d,h);if(!t&&S||(S=t,p<=0))break;h=p}if(S){const E={word:S[0],startColumn:C+1+S.index,endColumn:C+1+S.index+S[0].length};return w.lastIndex=0,E}return null}e.getWordAtText=g;function L(I,w,k,C){let b;for(;b=I.exec(w);){const i=b.index||0;if(i<=k&&I.lastIndex>=k)return b;if(C>0&&i>C)return null}return null}}),define(De[155],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(o||(e.IndentAction=o={}));class A{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let y=0,g=P.notIn.length;y<g;y++)switch(P.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,y){if(P.getTokenCount()===0)return!0;const g=P.findTokenIndexAtOffset(y-2),L=P.getStandardTokenType(g);return this.isOK(L)}_findNeutralCharacterInRange(P,y){for(let g=P;g<=y;g++){const L=String.fromCharCode(g);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=A;class l{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of P)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=l;function R(T,P,y){T.has(P)?T.get(P).push(y):T.set(P,[y])}}),define(De[156],Ie([1,0,106]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var A;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(A||(e.State=A={}));class l{constructor(C,b,i){const d=new Uint8Array(C*b);for(let h=0,S=C*b;h<S;h++)d[h]=i;this._data=d,this.rows=C,this.cols=b}get(C,b){return this._data[C*this.cols+b]}set(C,b,i){this._data[C*this.cols+b]=i}}class R{constructor(C){let b=0,i=0;for(let h=0,S=C.length;h<S;h++){const[E,p,t]=C[h];p>b&&(b=p),E>i&&(i=E),t>i&&(i=t)}b++,i++;const d=new l(i,b,0);for(let h=0,S=C.length;h<S;h++){const[E,p,t]=C[h];d.set(E,p,t)}this._states=d,this._maxCharCode=b}nextState(C,b){return b<0||b>=this._maxCharCode?0:this._states.get(C,b)}}e.StateMachine=R;let T=null;function P(){return T===null&&(T=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var y;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let g=null;function L(){if(g===null){g=new o.CharacterClassifier(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let b=0;b<k.length;b++)g.set(k.charCodeAt(b),1);const C=".,;:";for(let b=0;b<C.length;b++)g.set(C.charCodeAt(b),2)}return g}class I{static _createLink(C,b,i,d,h){let S=h-1;do{const E=b.charCodeAt(S);if(C.get(E)!==2)break;S--}while(S>d);if(d>0){const E=b.charCodeAt(d-1),p=b.charCodeAt(S);(E===40&&p===41||E===91&&p===93||E===123&&p===125)&&S--}return{range:{startLineNumber:i,startColumn:d+1,endLineNumber:i,endColumn:S+2},url:b.substring(d,S+1)}}static computeLinks(C,b=P()){const i=L(),d=[];for(let h=1,S=C.getLineCount();h<=S;h++){const E=C.getLineContent(h),p=E.length;let t=0,s=0,r=0,a=1,v=!1,_=!1,c=!1,u=!1;for(;t<p;){let m=!1;const f=E.charCodeAt(t);if(a===13){let n;switch(f){case 40:v=!0,n=0;break;case 41:n=v?0:1;break;case 91:c=!0,_=!0,n=0;break;case 93:c=!1,n=_?0:1;break;case 123:u=!0,n=0;break;case 125:n=u?0:1;break;case 39:case 34:case 96:r===f?n=1:r===39||r===34||r===96?n=0:n=1;break;case 42:n=r===42?1:0;break;case 124:n=r===124?1:0;break;case 32:n=c?0:1;break;default:n=i.get(f)}n===1&&(d.push(I._createLink(i,E,h,s,t)),m=!0)}else if(a===12){let n;f===91?(_=!0,n=0):n=i.get(f),n===1?m=!0:a=13}else a=b.nextState(a,f),a===0&&(m=!0);m&&(a=1,v=!1,_=!1,u=!1,s=t+1,r=f),t++}a===13&&d.push(I._createLink(i,E,h,s,p))}return d}}e.LinkComputer=I;function w(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:I.computeLinks(k)}e.computeLinks=w}),define(De[108],Ie([1,0,23]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var A;(function(E){E[E.Left=1]="Left",E[E.Center=2]="Center",E[E.Right=4]="Right",E[E.Full=7]="Full"})(A||(e.OverviewRulerLane=A={}));var l;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(l||(e.GlyphMarginLane=l={}));var R;(function(E){E[E.Inline=1]="Inline",E[E.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var T;(function(E){E[E.Both=0]="Both",E[E.Right=1]="Right",E[E.Left=2]="Left",E[E.None=3]="None"})(T||(e.InjectedTextCursorStops=T={}));var P;(function(E){E[E.TextDefined=0]="TextDefined",E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(P||(e.EndOfLinePreference=P={}));var y;(function(E){E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(y||(e.DefaultEndOfLine=y={}));var g;(function(E){E[E.LF=0]="LF",E[E.CRLF=1]="CRLF"})(g||(e.EndOfLineSequence=g={}));class L{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(p){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,p.tabSize|0),p.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,p.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!p.insertSpaces,this.defaultEOL=p.defaultEOL|0,this.trimAutoWhitespace=!!p.trimAutoWhitespace,this.bracketPairColorizationOptions=p.bracketPairColorizationOptions}equals(p){return this.tabSize===p.tabSize&&this._indentSizeIsTabSize===p._indentSizeIsTabSize&&this.indentSize===p.indentSize&&this.insertSpaces===p.insertSpaces&&this.defaultEOL===p.defaultEOL&&this.trimAutoWhitespace===p.trimAutoWhitespace&&(0,o.equals)(this.bracketPairColorizationOptions,p.bracketPairColorizationOptions)}createChangeEvent(p){return{tabSize:this.tabSize!==p.tabSize,indentSize:this.indentSize!==p.indentSize,insertSpaces:this.insertSpaces!==p.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==p.trimAutoWhitespace}}}e.TextModelResolvedOptions=L;class I{constructor(p,t){this._findMatchBrand=void 0,this.range=p,this.matches=t}}e.FindMatch=I;var w;(function(E){E[E.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",E[E.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",E[E.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",E[E.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function k(E){return E&&typeof E.read=="function"}e.isITextSnapshot=k;var C;(function(E){E[E.Left=0]="Left",E[E.Right=1]="Right",E[E.None=2]="None",E[E.LeftOfInjectedText=3]="LeftOfInjectedText",E[E.RightOfInjectedText=4]="RightOfInjectedText"})(C||(e.PositionAffinity=C={}));var b;(function(E){E[E.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(b||(e.ModelConstants=b={}));class i{constructor(p,t,s,r,a,v){this.identifier=p,this.range=t,this.text=s,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=a,this._isTracked=v}}e.ValidAnnotatedEditOperation=i;class d{constructor(p,t,s){this.regex=p,this.wordSeparators=t,this.simpleSearch=s}}e.SearchData=d;class h{constructor(p,t,s){this.reverseEdits=p,this.changes=t,this.trimAutoWhitespaceLineNumbers=s}}e.ApplyEditsResult=h;function S(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=S}),define(De[157],Ie([1,0,18,105]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class l{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,g){y=(0,A.toUint32)(y);const L=this.values,I=this.prefixSum,w=g.length;return w===0?!1:(this.values=new Uint32Array(L.length+w),this.values.set(L.subarray(0,y),0),this.values.set(L.subarray(y),y+w),this.values.set(g,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(y,g){return y=(0,A.toUint32)(y),g=(0,A.toUint32)(g),this.values[y]===g?!1:(this.values[y]=g,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,g){y=(0,A.toUint32)(y),g=(0,A.toUint32)(g);const L=this.values,I=this.prefixSum;if(y>=L.length)return!1;const w=L.length-y;return g>=w&&(g=w),g===0?!1:(this.values=new Uint32Array(L.length-g),this.values.set(L.subarray(0,y),0),this.values.set(L.subarray(y+g),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(y){return y<0?0:(y=(0,A.toUint32)(y),this._getPrefixSum(y))}_getPrefixSum(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let g=this.prefixSumValidIndex[0]+1;g===0&&(this.prefixSum[0]=this.values[0],g++),y>=this.values.length&&(y=this.values.length-1);for(let L=g;L<=y;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let g=0,L=this.values.length-1,I=0,w=0,k=0;for(;g<=L;)if(I=g+(L-g)/2|0,w=this.prefixSum[I],k=w-this.values[I],y<k)L=I-1;else if(y>=w)g=I+1;else break;return new T(I,y-k)}}e.PrefixSumComputer=l;class R{constructor(y){this._values=y,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(y){return this._ensureValid(),y===0?0:this._prefixSum[y-1]}getIndexOf(y){this._ensureValid();const g=this._indexBySum[y],L=g>0?this._prefixSum[g-1]:0;return new T(g,y-L)}removeValues(y,g){this._values.splice(y,g),this._invalidate(y)}insertValues(y,g){this._values=(0,o.arrayInsert)(this._values,y,g),this._invalidate(y)}_invalidate(y){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,y-1)}_ensureValid(){if(!this._isValid){for(let y=this._validEndIndex+1,g=this._values.length;y<g;y++){const L=this._values[y],I=y>0?this._prefixSum[y-1]:0;this._prefixSum[y]=I+L;for(let w=0;w<L;w++)this._indexBySum[I+w]=y}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(y,g){this._values[y]!==g&&(this._values[y]=g,this._invalidate(y))}}e.ConstantTimePrefixSumComputer=R;class T{constructor(y,g){this.index=y,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=g}}e.PrefixSumIndexOfResult=T}),define(De[158],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class o{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(R){if(R&&this._dragOperations.has(R)){const T=this._dragOperations.get(R);return this._dragOperations.delete(R),T}}addDragOperationTransfer(R,T){this._dragOperations.set(R,T)}}e.TreeViewsDnDService=o;class A{constructor(R){this.identifier=R}}e.DraggedTreeItemsIdentifier=A}),define(De[159],Ie([12,13]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(De[160],Ie([12,13]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(De[161],Ie([1,0,160]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,l=A*60,R=l*24,T=R*7,P=R*30,y=R*365;function g(I,w,k,C){typeof I!="number"&&(I=I.getTime());const b=Math.round((new Date().getTime()-I)/1e3);if(b<-30)return(0,o.localize)(0,null,g(new Date().getTime()+b*1e3,!1));if(!C&&b<30)return(0,o.localize)(1,null);let i;return b<A?(i=b,w?i===1?k?(0,o.localize)(2,null,i):(0,o.localize)(3,null,i):k?(0,o.localize)(4,null,i):(0,o.localize)(5,null,i):i===1?k?(0,o.localize)(6,null,i):(0,o.localize)(7,null,i):k?(0,o.localize)(8,null,i):(0,o.localize)(9,null,i)):b<l?(i=Math.floor(b/A),w?i===1?k?(0,o.localize)(10,null,i):(0,o.localize)(11,null,i):k?(0,o.localize)(12,null,i):(0,o.localize)(13,null,i):i===1?k?(0,o.localize)(14,null,i):(0,o.localize)(15,null,i):k?(0,o.localize)(16,null,i):(0,o.localize)(17,null,i)):b<R?(i=Math.floor(b/l),w?i===1?k?(0,o.localize)(18,null,i):(0,o.localize)(19,null,i):k?(0,o.localize)(20,null,i):(0,o.localize)(21,null,i):i===1?k?(0,o.localize)(22,null,i):(0,o.localize)(23,null,i):k?(0,o.localize)(24,null,i):(0,o.localize)(25,null,i)):b<T?(i=Math.floor(b/R),w?i===1?(0,o.localize)(26,null,i):(0,o.localize)(27,null,i):i===1?(0,o.localize)(28,null,i):(0,o.localize)(29,null,i)):b<P?(i=Math.floor(b/T),w?i===1?k?(0,o.localize)(30,null,i):(0,o.localize)(31,null,i):k?(0,o.localize)(32,null,i):(0,o.localize)(33,null,i):i===1?k?(0,o.localize)(34,null,i):(0,o.localize)(35,null,i):k?(0,o.localize)(36,null,i):(0,o.localize)(37,null,i)):b<y?(i=Math.floor(b/P),w?i===1?k?(0,o.localize)(38,null,i):(0,o.localize)(39,null,i):k?(0,o.localize)(40,null,i):(0,o.localize)(41,null,i):i===1?k?(0,o.localize)(42,null,i):(0,o.localize)(43,null,i):k?(0,o.localize)(44,null,i):(0,o.localize)(45,null,i)):(i=Math.floor(b/y),w?i===1?k?(0,o.localize)(46,null,i):(0,o.localize)(47,null,i):k?(0,o.localize)(48,null,i):(0,o.localize)(49,null,i):i===1?k?(0,o.localize)(50,null,i):(0,o.localize)(51,null,i):k?(0,o.localize)(52,null,i):(0,o.localize)(53,null,i))}e.fromNow=g;function L(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(De[162],Ie([12,13]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(De[46],Ie([1,0,18,10,162]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(I,w){return w&&(I.stack||I.stacktrace)?l.localize(0,null,P(I),T(I.stack)||T(I.stacktrace)):P(I)}function T(I){return Array.isArray(I)?I.join(`
`):I}function P(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?l.localize(1,null,I.message):I.message||l.localize(2,null)}function y(I=null,w=!1){if(!I)return l.localize(3,null);if(Array.isArray(I)){const k=o.coalesce(I),C=y(k[0],w);return k.length>1?l.localize(4,null,C,k.length):C}if(A.isString(I))return I;if(I.detail){const k=I.detail;if(k.error)return R(k.error,w);if(k.exception)return R(k.exception,w)}return I.stack?R(I,w):I.message?I.message:l.localize(5,null)}e.toErrorMessage=y;function g(I){const w=I;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=g;function L(I,w){let k;return typeof I=="string"?k=new Error(I):k=I,k.actions=w,k}e.createErrorWithActions=L}),define(De[163],Ie([12,13]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(De[14],Ie([1,0,163]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,l=!1,R=!1,T=!1,P=!1,y=!1,g=!1,L=!1,I=!1,w=!1,k,C=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT,i,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const S=typeof h?.versions?.electron=="string",E=S&&h?.type==="renderer";if(typeof navigator=="object"&&!E)d=navigator.userAgent,A=d.indexOf("Windows")>=0,l=d.indexOf("Macintosh")>=0,L=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=d.indexOf("Linux")>=0,w=d?.indexOf("Mobi")>=0,y=!0,k=o.getConfiguredDefaultLocale(o.localize(0,null))||e.LANGUAGE_DEFAULT,C=k,b=navigator.language;else if(typeof h=="object"){A=h.platform==="win32",l=h.platform==="darwin",R=h.platform==="linux",T=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,g=S,I=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.LANGUAGE_DEFAULT,C=e.LANGUAGE_DEFAULT;const u=h.env.VSCODE_NLS_CONFIG;if(u)try{const m=JSON.parse(u),f=m.availableLanguages["*"];k=m.locale,b=m.osLocale,C=f||e.LANGUAGE_DEFAULT,i=m._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var p;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(p||(e.Platform=p={}));function t(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let s=0;l?s=1:A?s=3:R&&(s=2),e.isWindows=A,e.isMacintosh=l,e.isLinux=R,e.isLinuxSnap=T,e.isNative=P,e.isElectron=g,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=w,e.isCI=I,e.platform=s,e.userAgent=d,e.language=C;var r;(function(u){function m(){return e.language}u.value=m;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=f;function n(){return e.language==="en"}u.isDefault=n})(r||(e.Language=r={})),e.locale=k,e.platformLocale=b,e.translationsConfigFile=i,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const u=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let n=0,D=u.length;n<D;n++){const M=u[n];if(M.id===f.data.vscodeScheduleAsyncWork){u.splice(n,1),M.callback();return}}});let m=0;return f=>{const n=++m;u.push({id:n,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:n},"*")}}return u=>setTimeout(u)})();var a;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=l||L?2:A?1:3;let v=!0,_=!1;function c(){if(!_){_=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,v=new Uint16Array(u.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[33],Ie([1,0,14]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.process<"u"){const l=o.globals.vscode.process;A={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return o.isWindows?"win32":o.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(De[15],Ie([1,0,33]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,l=97,R=90,T=122,P=46,y=47,g=92,L=58,I=63;class w extends Error{constructor(s,r,a){let v;typeof r=="string"&&r.indexOf("not ")===0?(v="must not be",r=r.replace(/^not /,"")):v="must be";const _=s.indexOf(".")!==-1?"property":"argument";let c=`The "${s}" ${_} ${v} of type ${r}`;c+=`. Received type ${typeof a}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,s){if(t===null||typeof t!="object")throw new w(s,"Object",t)}function C(t,s){if(typeof t!="string")throw new w(s,"string",t)}const b=o.platform==="win32";function i(t){return t===y||t===g}function d(t){return t===y}function h(t){return t>=A&&t<=R||t>=l&&t<=T}function S(t,s,r,a){let v="",_=0,c=-1,u=0,m=0;for(let f=0;f<=t.length;++f){if(f<t.length)m=t.charCodeAt(f);else{if(a(m))break;m=y}if(a(m)){if(!(c===f-1||u===1))if(u===2){if(v.length<2||_!==2||v.charCodeAt(v.length-1)!==P||v.charCodeAt(v.length-2)!==P){if(v.length>2){const n=v.lastIndexOf(r);n===-1?(v="",_=0):(v=v.slice(0,n),_=v.length-1-v.lastIndexOf(r)),c=f,u=0;continue}else if(v.length!==0){v="",_=0,c=f,u=0;continue}}s&&(v+=v.length>0?`${r}..`:"..",_=2)}else v.length>0?v+=`${r}${t.slice(c+1,f)}`:v=t.slice(c+1,f),_=f-c-1;c=f,u=0}else m===P&&u!==-1?++u:u=-1}return v}function E(t,s){k(s,"pathObject");const r=s.dir||s.root,a=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${a}`:`${r}${t}${a}`:a}e.win32={resolve(...t){let s="",r="",a=!1;for(let v=t.length-1;v>=-1;v--){let _;if(v>=0){if(_=t[v],C(_,"path"),_.length===0)continue}else s.length===0?_=o.cwd():(_=o.env[`=${s}`]||o.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==s.toLowerCase()&&_.charCodeAt(2)===g)&&(_=`${s}\\`));const c=_.length;let u=0,m="",f=!1;const n=_.charCodeAt(0);if(c===1)i(n)&&(u=1,f=!0);else if(i(n))if(f=!0,i(_.charCodeAt(1))){let D=2,M=D;for(;D<c&&!i(_.charCodeAt(D));)D++;if(D<c&&D!==M){const W=_.slice(M,D);for(M=D;D<c&&i(_.charCodeAt(D));)D++;if(D<c&&D!==M){for(M=D;D<c&&!i(_.charCodeAt(D));)D++;(D===c||D!==M)&&(m=`\\\\${W}\\${_.slice(M,D)}`,u=D)}}}else u=1;else h(n)&&_.charCodeAt(1)===L&&(m=_.slice(0,2),u=2,c>2&&i(_.charCodeAt(2))&&(f=!0,u=3));if(m.length>0)if(s.length>0){if(m.toLowerCase()!==s.toLowerCase())continue}else s=m;if(a){if(s.length>0)break}else if(r=`${_.slice(u)}\\${r}`,a=f,f&&s.length>0)break}return r=S(r,!a,"\\",i),a?`${s}\\${r}`:`${s}${r}`||"."},normalize(t){C(t,"path");const s=t.length;if(s===0)return".";let r=0,a,v=!1;const _=t.charCodeAt(0);if(s===1)return d(_)?"\\":t;if(i(_))if(v=!0,i(t.charCodeAt(1))){let u=2,m=u;for(;u<s&&!i(t.charCodeAt(u));)u++;if(u<s&&u!==m){const f=t.slice(m,u);for(m=u;u<s&&i(t.charCodeAt(u));)u++;if(u<s&&u!==m){for(m=u;u<s&&!i(t.charCodeAt(u));)u++;if(u===s)return`\\\\${f}\\${t.slice(m)}\\`;u!==m&&(a=`\\\\${f}\\${t.slice(m,u)}`,r=u)}}}else r=1;else h(_)&&t.charCodeAt(1)===L&&(a=t.slice(0,2),r=2,s>2&&i(t.charCodeAt(2))&&(v=!0,r=3));let c=r<s?S(t.slice(r),!v,"\\",i):"";return c.length===0&&!v&&(c="."),c.length>0&&i(t.charCodeAt(s-1))&&(c+="\\"),a===void 0?v?`\\${c}`:c:v?`${a}\\${c}`:`${a}${c}`},isAbsolute(t){C(t,"path");const s=t.length;if(s===0)return!1;const r=t.charCodeAt(0);return i(r)||s>2&&h(r)&&t.charCodeAt(1)===L&&i(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,r;for(let _=0;_<t.length;++_){const c=t[_];C(c,"path"),c.length>0&&(s===void 0?s=r=c:s+=`\\${c}`)}if(s===void 0)return".";let a=!0,v=0;if(typeof r=="string"&&i(r.charCodeAt(0))){++v;const _=r.length;_>1&&i(r.charCodeAt(1))&&(++v,_>2&&(i(r.charCodeAt(2))?++v:a=!1))}if(a){for(;v<s.length&&i(s.charCodeAt(v));)v++;v>=2&&(s=`\\${s.slice(v)}`)}return e.win32.normalize(s)},relative(t,s){if(C(t,"from"),C(s,"to"),t===s)return"";const r=e.win32.resolve(t),a=e.win32.resolve(s);if(r===a||(t=r.toLowerCase(),s=a.toLowerCase(),t===s))return"";let v=0;for(;v<t.length&&t.charCodeAt(v)===g;)v++;let _=t.length;for(;_-1>v&&t.charCodeAt(_-1)===g;)_--;const c=_-v;let u=0;for(;u<s.length&&s.charCodeAt(u)===g;)u++;let m=s.length;for(;m-1>u&&s.charCodeAt(m-1)===g;)m--;const f=m-u,n=c<f?c:f;let D=-1,M=0;for(;M<n;M++){const $=t.charCodeAt(v+M);if($!==s.charCodeAt(u+M))break;$===g&&(D=M)}if(M!==n){if(D===-1)return a}else{if(f>n){if(s.charCodeAt(u+M)===g)return a.slice(u+M+1);if(M===2)return a.slice(u+M)}c>n&&(t.charCodeAt(v+M)===g?D=M:M===2&&(D=3)),D===-1&&(D=0)}let W="";for(M=v+D+1;M<=_;++M)(M===_||t.charCodeAt(M)===g)&&(W+=W.length===0?"..":"\\..");return u+=D,W.length>0?`${W}${a.slice(u,m)}`:(a.charCodeAt(u)===g&&++u,a.slice(u,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.win32.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===g){if(s.charCodeAt(1)===g){const r=s.charCodeAt(2);if(r!==I&&r!==P)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(h(s.charCodeAt(0))&&s.charCodeAt(1)===L&&s.charCodeAt(2)===g)return`\\\\?\\${s}`;return t},dirname(t){C(t,"path");const s=t.length;if(s===0)return".";let r=-1,a=0;const v=t.charCodeAt(0);if(s===1)return i(v)?t:".";if(i(v)){if(r=a=1,i(t.charCodeAt(1))){let u=2,m=u;for(;u<s&&!i(t.charCodeAt(u));)u++;if(u<s&&u!==m){for(m=u;u<s&&i(t.charCodeAt(u));)u++;if(u<s&&u!==m){for(m=u;u<s&&!i(t.charCodeAt(u));)u++;if(u===s)return t;u!==m&&(r=a=u+1)}}}}else h(v)&&t.charCodeAt(1)===L&&(r=s>2&&i(t.charCodeAt(2))?3:2,a=r);let _=-1,c=!0;for(let u=s-1;u>=a;--u)if(i(t.charCodeAt(u))){if(!c){_=u;break}}else c=!1;if(_===-1){if(r===-1)return".";_=r}return t.slice(0,_)},basename(t,s){s!==void 0&&C(s,"ext"),C(t,"path");let r=0,a=-1,v=!0,_;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(r=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let c=s.length-1,u=-1;for(_=t.length-1;_>=r;--_){const m=t.charCodeAt(_);if(i(m)){if(!v){r=_+1;break}}else u===-1&&(v=!1,u=_+1),c>=0&&(m===s.charCodeAt(c)?--c===-1&&(a=_):(c=-1,a=u))}return r===a?a=u:a===-1&&(a=t.length),t.slice(r,a)}for(_=t.length-1;_>=r;--_)if(i(t.charCodeAt(_))){if(!v){r=_+1;break}}else a===-1&&(v=!1,a=_+1);return a===-1?"":t.slice(r,a)},extname(t){C(t,"path");let s=0,r=-1,a=0,v=-1,_=!0,c=0;t.length>=2&&t.charCodeAt(1)===L&&h(t.charCodeAt(0))&&(s=a=2);for(let u=t.length-1;u>=s;--u){const m=t.charCodeAt(u);if(i(m)){if(!_){a=u+1;break}continue}v===-1&&(_=!1,v=u+1),m===P?r===-1?r=u:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||v===-1||c===0||c===1&&r===v-1&&r===a+1?"":t.slice(r,v)},format:E.bind(null,"\\"),parse(t){C(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.length;let a=0,v=t.charCodeAt(0);if(r===1)return i(v)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(i(v)){if(a=1,i(t.charCodeAt(1))){let D=2,M=D;for(;D<r&&!i(t.charCodeAt(D));)D++;if(D<r&&D!==M){for(M=D;D<r&&i(t.charCodeAt(D));)D++;if(D<r&&D!==M){for(M=D;D<r&&!i(t.charCodeAt(D));)D++;D===r?a=D:D!==M&&(a=D+1)}}}}else if(h(v)&&t.charCodeAt(1)===L){if(r<=2)return s.root=s.dir=t,s;if(a=2,i(t.charCodeAt(2))){if(r===3)return s.root=s.dir=t,s;a=3}}a>0&&(s.root=t.slice(0,a));let _=-1,c=a,u=-1,m=!0,f=t.length-1,n=0;for(;f>=a;--f){if(v=t.charCodeAt(f),i(v)){if(!m){c=f+1;break}continue}u===-1&&(m=!1,u=f+1),v===P?_===-1?_=f:n!==1&&(n=1):_!==-1&&(n=-1)}return u!==-1&&(_===-1||n===0||n===1&&_===u-1&&_===c+1?s.base=s.name=t.slice(c,u):(s.name=t.slice(c,_),s.base=t.slice(c,u),s.ext=t.slice(_,u))),c>0&&c!==a?s.dir=t.slice(0,c-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(b){const t=/\\/g;return()=>{const s=o.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>o.cwd()})();e.posix={resolve(...t){let s="",r=!1;for(let a=t.length-1;a>=-1&&!r;a--){const v=a>=0?t[a]:p();C(v,"path"),v.length!==0&&(s=`${v}/${s}`,r=v.charCodeAt(0)===y)}return s=S(s,!r,"/",d),r?`/${s}`:s.length>0?s:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===y,r=t.charCodeAt(t.length-1)===y;return t=S(t,!s,"/",d),t.length===0?s?"/":r?"./":".":(r&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let s;for(let r=0;r<t.length;++r){const a=t[r];C(a,"path"),a.length>0&&(s===void 0?s=a:s+=`/${a}`)}return s===void 0?".":e.posix.normalize(s)},relative(t,s){if(C(t,"from"),C(s,"to"),t===s||(t=e.posix.resolve(t),s=e.posix.resolve(s),t===s))return"";const r=1,a=t.length,v=a-r,_=1,c=s.length-_,u=v<c?v:c;let m=-1,f=0;for(;f<u;f++){const D=t.charCodeAt(r+f);if(D!==s.charCodeAt(_+f))break;D===y&&(m=f)}if(f===u)if(c>u){if(s.charCodeAt(_+f)===y)return s.slice(_+f+1);if(f===0)return s.slice(_+f)}else v>u&&(t.charCodeAt(r+f)===y?m=f:f===0&&(m=0));let n="";for(f=r+m+1;f<=a;++f)(f===a||t.charCodeAt(f)===y)&&(n+=n.length===0?"..":"/..");return`${n}${s.slice(_+m)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===y;let r=-1,a=!0;for(let v=t.length-1;v>=1;--v)if(t.charCodeAt(v)===y){if(!a){r=v;break}}else a=!1;return r===-1?s?"/":".":s&&r===1?"//":t.slice(0,r)},basename(t,s){s!==void 0&&C(s,"ext"),C(t,"path");let r=0,a=-1,v=!0,_;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let c=s.length-1,u=-1;for(_=t.length-1;_>=0;--_){const m=t.charCodeAt(_);if(m===y){if(!v){r=_+1;break}}else u===-1&&(v=!1,u=_+1),c>=0&&(m===s.charCodeAt(c)?--c===-1&&(a=_):(c=-1,a=u))}return r===a?a=u:a===-1&&(a=t.length),t.slice(r,a)}for(_=t.length-1;_>=0;--_)if(t.charCodeAt(_)===y){if(!v){r=_+1;break}}else a===-1&&(v=!1,a=_+1);return a===-1?"":t.slice(r,a)},extname(t){C(t,"path");let s=-1,r=0,a=-1,v=!0,_=0;for(let c=t.length-1;c>=0;--c){const u=t.charCodeAt(c);if(u===y){if(!v){r=c+1;break}continue}a===-1&&(v=!1,a=c+1),u===P?s===-1?s=c:_!==1&&(_=1):s!==-1&&(_=-1)}return s===-1||a===-1||_===0||_===1&&s===a-1&&s===r+1?"":t.slice(s,a)},format:E.bind(null,"/"),parse(t){C(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.charCodeAt(0)===y;let a;r?(s.root="/",a=1):a=0;let v=-1,_=0,c=-1,u=!0,m=t.length-1,f=0;for(;m>=a;--m){const n=t.charCodeAt(m);if(n===y){if(!u){_=m+1;break}continue}c===-1&&(u=!1,c=m+1),n===P?v===-1?v=m:f!==1&&(f=1):v!==-1&&(f=-1)}if(c!==-1){const n=_===0&&r?1:_;v===-1||f===0||f===1&&v===c-1&&v===_+1?s.base=s.name=t.slice(n,c):(s.name=t.slice(n,v),s.base=t.slice(n,c),s.ext=t.slice(v,c))}return _>0?s.dir=t.slice(0,_-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(De[109],Ie([1,0,66,15]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const l=new o.Lazy(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),R=new o.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new o.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(u,m,f=!1){const n=u||"",D=m||"",M=l.value.collator.compare(n,D);return l.value.collatorIsNumeric&&M===0&&n!==D?n<D?-1:1:M}e.compareFileNames=P;function y(u,m){const f=R.value.collator;return u=u||"",m=m||"",E(f,u,m)}e.compareFileNamesDefault=y;function g(u,m){const f=R.value.collator;return u=u||"",m=m||"",r(u,m)||E(f,u,m)}e.compareFileNamesUpper=g;function L(u,m){const f=R.value.collator;return u=u||"",m=m||"",s(u,m)||E(f,u,m)}e.compareFileNamesLower=L;function I(u,m){return u=u||"",m=m||"",u===m?0:u<m?-1:1}e.compareFileNamesUnicode=I;function w(u,m){const[f,n]=h(u),[D,M]=h(m);let W=l.value.collator.compare(n,M);if(W===0){if(l.value.collatorIsNumeric&&n!==M)return n<M?-1:1;if(W=l.value.collator.compare(f,D),l.value.collatorIsNumeric&&W===0&&f!==D)return f<D?-1:1}return W}e.compareFileExtensions=w;function k(u,m){u=u||"",m=m||"";const f=S(u),n=S(m),D=R.value.collator,M=T.value.collator;return E(M,f,n)||E(D,u,m)}e.compareFileExtensionsDefault=k;function C(u,m){u=u||"",m=m||"";const f=S(u),n=S(m),D=R.value.collator,M=T.value.collator;return E(M,f,n)||r(u,m)||E(D,u,m)}e.compareFileExtensionsUpper=C;function b(u,m){u=u||"",m=m||"";const f=S(u),n=S(m),D=R.value.collator,M=T.value.collator;return E(M,f,n)||s(u,m)||E(D,u,m)}e.compareFileExtensionsLower=b;function i(u,m){u=u||"",m=m||"";const f=S(u).toLowerCase(),n=S(m).toLowerCase();return f!==n?f<n?-1:1:u!==m?u<m?-1:1:0}e.compareFileExtensionsUnicode=i;const d=/^(.*?)(\.([^.]*))?$/;function h(u,m=!1){const f=u?d.exec(u):[];let n=[f&&f[1]||"",f&&f[3]||""];return m&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function S(u){const m=u?d.exec(u):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function E(u,m,f){const n=u.compare(m,f);return n!==0?n:m.length!==f.length?m.length<f.length?-1:1:0}function p(u){const m=u.charAt(0);return m.toLocaleUpperCase()!==m}function t(u){const m=u.charAt(0);return m.toLocaleLowerCase()!==m}function s(u,m){return p(u)&&t(m)?-1:t(u)&&p(m)?1:0}function r(u,m){return t(u)&&p(m)?-1:p(u)&&t(m)?1:0}function a(u,m,f=!1){return f||(u=u&&u.toLowerCase(),m=m&&m.toLowerCase()),u===m?0:u<m?-1:1}function v(u,m,f=!1){const n=u.split(A.sep),D=m.split(A.sep),M=n.length-1,W=D.length-1;let $,N;for(let U=0;;U++){if($=M===U,N=W===U,$&&N)return P(n[U],D[U],f);if($)return-1;if(N)return 1;const q=a(n[U],D[U],f);if(q!==0)return q}}e.comparePaths=v;function _(u,m,f){const n=u.toLowerCase(),D=m.toLowerCase(),M=c(u,m,f);if(M)return M;const W=n.endsWith(f),$=D.endsWith(f);if(W!==$)return W?-1:1;const N=P(n,D);return N!==0?N:n.localeCompare(D)}e.compareAnything=_;function c(u,m,f){const n=u.toLowerCase(),D=m.toLowerCase(),M=n.startsWith(f),W=D.startsWith(f);if(M!==W)return M?-1:1;if(M&&W){if(n.length<D.length)return-1;if(n.length>D.length)return 1}return 0}e.compareByPrefix=c}),define(De[89],Ie([1,0,15]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const I=(0,o.extname)(L),w=A[I.toLowerCase()];return w!==void 0?w:T(L)}e.getMediaOrTextMime=R;function T(L){const I=(0,o.extname)(L);return l[I.toLowerCase()]}e.getMediaMime=T;function P(L){for(const I in l)if(l[I]===L)return I}e.getExtensionForMimeType=P;const y=/^(.+)\/(.+?)(;.+)?$/;function g(L,I){const w=y.exec(L);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:I?void 0:L}e.normalizeMimeType=g}),define(De[110],Ie([1,0,14]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A||(e.Source=A={}));var l;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(l||(e.TerminateResponseCode=l={}));function R(P,...y){const g=y.reduce((w,k)=>(w[k]=!0,w),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(w=>!g[w]).forEach(w=>{for(let k=0;k<L.length;k++)if(w.search(L[k])!==-1){delete P[w];break}})}e.sanitizeProcessEnvironment=R;function T(P){P&&(delete P.DEBUG,o.isMacintosh&&delete P.DYLD_LIBRARY_PATH,o.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(De[37],Ie([1,0,14]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=o.globals.performance&&typeof o.globals.performance.now=="function";class l{static create(T=!0){return new l(T)}constructor(T){this._highResolution=A&&T,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?o.globals.performance.now():Date.now()}}e.StopWatch=l}),define(De[3],Ie([1,0,8,65,6,67,37]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,y=!1;var g;(function(_){_.None=()=>l.Disposable.None;function c(pe){if(y){const{onDidAddListener:_e}=pe,re=C.create();let ne=0;pe.onDidAddListener=()=>{++ne===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),_e?.()}}}function u(pe,_e){return U(pe,()=>{},0,void 0,!0,void 0,_e)}_.defer=u;function m(pe){return(_e,re=null,ne)=>{let de=!1,ee;return ee=pe(ce=>{if(!de)return ee?ee.dispose():de=!0,_e.call(re,ce)},null,ne),de&&ee.dispose(),ee}}_.once=m;function f(pe,_e,re){return N((ne,de=null,ee)=>pe(ce=>ne.call(de,_e(ce)),null,ee),re)}_.map=f;function n(pe,_e,re){return N((ne,de=null,ee)=>pe(ce=>{_e(ce),ne.call(de,ce)},null,ee),re)}_.forEach=n;function D(pe,_e,re){return N((ne,de=null,ee)=>pe(ce=>_e(ce)&&ne.call(de,ce),null,ee),re)}_.filter=D;function M(pe){return pe}_.signal=M;function W(...pe){return(_e,re=null,ne)=>(0,l.combinedDisposable)(...pe.map(de=>de(ee=>_e.call(re,ee),null,ne)))}_.any=W;function $(pe,_e,re,ne){let de=re;return f(pe,ee=>(de=_e(de,ee),de),ne)}_.reduce=$;function N(pe,_e){let re;const ne={onWillAddFirstListener(){re=pe(de.fire,de)},onDidRemoveLastListener(){re?.dispose()}};_e||c(ne);const de=new i(ne);return _e?.add(de),de.event}function U(pe,_e,re=100,ne=!1,de=!1,ee,ce){let le,ue,O,j=0,Y;const te={leakWarningThreshold:ee,onWillAddFirstListener(){le=pe(ye=>{j++,ue=_e(ue,ye),ne&&!O&&(be.fire(ue),ue=void 0),Y=()=>{const me=ue;ue=void 0,O=void 0,(!ne||j>1)&&be.fire(me),j=0},typeof re=="number"?(clearTimeout(O),O=setTimeout(Y,re)):O===void 0&&(O=0,queueMicrotask(Y))})},onWillRemoveListener(){de&&j>0&&Y?.()},onDidRemoveLastListener(){Y=void 0,le.dispose()}};ce||c(te);const be=new i(te);return ce?.add(be),be.event}_.debounce=U;function q(pe,_e=0,re){return _.debounce(pe,(ne,de)=>ne?(ne.push(de),ne):[de],_e,void 0,!0,void 0,re)}_.accumulate=q;function F(pe,_e=(ne,de)=>ne===de,re){let ne=!0,de;return D(pe,ee=>{const ce=ne||!_e(ee,de);return ne=!1,de=ee,ce},re)}_.latch=F;function B(pe,_e,re){return[_.filter(pe,_e,re),_.filter(pe,ne=>!_e(ne),re)]}_.split=B;function Q(pe,_e=!1,re=[]){let ne=re.slice(),de=pe(le=>{ne?ne.push(le):ce.fire(le)});const ee=()=>{ne?.forEach(le=>ce.fire(le)),ne=null},ce=new i({onWillAddFirstListener(){de||(de=pe(le=>ce.fire(le)))},onDidAddFirstListener(){ne&&(_e?setTimeout(ee):ee())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return ce.event}_.buffer=Q;class J{constructor(_e){this.event=_e,this.disposables=new l.DisposableStore}map(_e){return new J(f(this.event,_e,this.disposables))}forEach(_e){return new J(n(this.event,_e,this.disposables))}filter(_e){return new J(D(this.event,_e,this.disposables))}reduce(_e,re){return new J($(this.event,_e,re,this.disposables))}latch(){return new J(F(this.event,void 0,this.disposables))}debounce(_e,re=100,ne=!1,de=!1,ee){return new J(U(this.event,_e,re,ne,de,ee,this.disposables))}on(_e,re,ne){return this.event(_e,re,ne)}once(_e,re,ne){return m(this.event)(_e,re,ne)}dispose(){this.disposables.dispose()}}function X(pe){return new J(pe)}_.chain=X;function ie(pe,_e,re=ne=>ne){const ne=(...le)=>ce.fire(re(...le)),de=()=>pe.on(_e,ne),ee=()=>pe.removeListener(_e,ne),ce=new i({onWillAddFirstListener:de,onDidRemoveLastListener:ee});return ce.event}_.fromNodeEventEmitter=ie;function ae(pe,_e,re=ne=>ne){const ne=(...le)=>ce.fire(re(...le)),de=()=>pe.addEventListener(_e,ne),ee=()=>pe.removeEventListener(_e,ne),ce=new i({onWillAddFirstListener:de,onDidRemoveLastListener:ee});return ce.event}_.fromDOMEventEmitter=ae;function we(pe){return new Promise(_e=>m(pe)(_e))}_.toPromise=we;function he(pe,_e){return _e(void 0),pe(re=>_e(re))}_.runAndSubscribe=he;function fe(pe,_e){let re=null;function ne(ee){re?.dispose(),re=new l.DisposableStore,_e(ee,re)}ne(void 0);const de=pe(ee=>ne(ee));return(0,l.toDisposable)(()=>{de.dispose(),re?.dispose()})}_.runAndSubscribeWithStore=fe;class V{constructor(_e,re){this._observable=_e,this._counter=0,this._hasChanged=!1;const ne={onWillAddFirstListener:()=>{_e.addObserver(this)},onDidRemoveLastListener:()=>{_e.removeObserver(this)}};re||c(ne),this.emitter=new i(ne),re&&re.add(this.emitter)}beginUpdate(_e){this._counter++}handlePossibleChange(_e){}handleChange(_e,re){this._hasChanged=!0}endUpdate(_e){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function x(pe,_e){return new V(pe,_e).emitter.event}_.fromObservable=x;function Z(pe){return _e=>{let re=0,ne=!1;const de={beginUpdate(){re++},endUpdate(){re--,re===0&&(pe.reportChanges(),ne&&(ne=!1,_e()))},handlePossibleChange(){},handleChange(){ne=!0}};return pe.addObserver(de),{dispose(){pe.removeObserver(de)}}}}_.fromObservableLight=Z})(g||(e.Event=g={}));class L{constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${L._idPool++}`,L.all.add(this)}start(c){this._stopWatch=new T.StopWatch(!0),this.listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=L,L.all=new Set,L._idPool=0;let I=-1;function w(_){const c=I;return I=_,{dispose(){I=c}}}e.setGlobalLeakWarningThreshold=w;class k{constructor(c,u=Math.random().toString(18).slice(2,5)){this.threshold=c,this.name=u,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(c,u){const m=this.threshold;if(m<=0||u<m)return;this._stacks||(this._stacks=new Map);const f=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let n,D=0;for(const[M,W]of this._stacks)(!n||D<W)&&(n=M,D=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${D}):`),console.warn(n)}return()=>{const n=this._stacks.get(c.value)||0;this._stacks.set(c.value,n-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(c,u,m){this.callback=c,this.callbackThis=u,this.stack=m,this.subscription=new l.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class i{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=I>0||this._options?.leakWarningThreshold?new k(this._options?.leakWarningThreshold??I):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const u of c)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,u,m)=>{if(this._listeners||(this._listeners=new R.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const f=this._listeners.isEmpty();f&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let n,D;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(D=C.create(),n=this._leakageMon.check(D,this._listeners.size+1)),P&&(D=D??C.create());const M=new b(c,u,D),W=this._listeners.push(M);f&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,c,u);const $=M.subscription.set(()=>{n?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),W(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return m instanceof l.DisposableStore?m.add($):Array.isArray(m)&&m.push($),$}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new h(this._options?.onListenerError));for(const u of this._listeners)this._deliveryQueue.push(this,u,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=i;class d{constructor(c=o.onUnexpectedError){this._onListenerError=c,this._queue=new R.LinkedList}get size(){return this._queue.size}push(c,u,m){this._queue.push(new S(c,u,m))}clear(c){const u=new R.LinkedList;for(const m of this._queue)m.emitter!==c&&u.push(m);this._queue=u}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(u){this._onListenerError(u)}}}}e.EventDeliveryQueue=d;class h extends d{clear(c){this._queue.clear()}}class S{constructor(c,u,m){this.emitter=c,this.listener=u,this.event=m}}class E extends i{async fireAsync(c,u,m){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const f of this._listeners)this._asyncDeliveryQueue.push([f,c]);for(;this._asyncDeliveryQueue.size>0&&!u.isCancellationRequested;){const[f,n]=this._asyncDeliveryQueue.shift(),D=[],M={...n,token:u,waitUntil:W=>{if(Object.isFrozen(D))throw new Error("waitUntil can NOT be called asynchronous");m&&(W=m(W,f.callback)),D.push(W)}};try{f.invoke(M)}catch(W){(0,o.onUnexpectedError)(W);continue}Object.freeze(D),await Promise.allSettled(D).then(W=>{for(const $ of W)$.status==="rejected"&&(0,o.onUnexpectedError)($.reason)})}}}}e.AsyncEmitter=E;class p extends i{constructor(c){super(c),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=p;class t extends p{constructor(c){super(c),this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=t;class s extends i{constructor(c){super(c),this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this.hasListeners()&&(this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(u=>super.fire(u)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new i({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const u={event:c,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const m=()=>{this.hasListeners&&this.unhook(u);const f=this.events.indexOf(u);this.events.splice(f,1)};return(0,l.toDisposable)((0,A.once)(m))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(u=>this.emitter.fire(u))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(c){return(u,m,f)=>c(n=>{const D=this.buffers[this.buffers.length-1];D?D.push(()=>u.call(m,n)):u.call(m,n)},void 0,f)}bufferEvents(c){const u=[];this.buffers.push(u);const m=c();return this.buffers.pop(),u.forEach(f=>f()),m}}e.EventBufferer=a;class v{constructor(){this.listening=!1,this.inputEvent=g.None,this.inputEventListener=l.Disposable.None,this.emitter=new i({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=v}),define(De[164],Ie([1,0,3,6,159]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends A.Disposable{constructor(w,k="",C="",b=!0,i){super(),this._onDidChange=this._register(new o.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=w,this._label=k,this._cssClass=C,this._enabled=b,this._actionCallback=i}get id(){return this._id}get label(){return this._label}set label(w){this._setLabel(w)}_setLabel(w){this._label!==w&&(this._label=w,this._onDidChange.fire({label:w}))}get tooltip(){return this._tooltip||""}set tooltip(w){this._setTooltip(w)}_setTooltip(w){this._tooltip!==w&&(this._tooltip=w,this._onDidChange.fire({tooltip:w}))}get class(){return this._cssClass}set class(w){this._setClass(w)}_setClass(w){this._cssClass!==w&&(this._cssClass=w,this._onDidChange.fire({class:w}))}get enabled(){return this._enabled}set enabled(w){this._setEnabled(w)}_setEnabled(w){this._enabled!==w&&(this._enabled=w,this._onDidChange.fire({enabled:w}))}get checked(){return this._checked}set checked(w){this._setChecked(w)}_setChecked(w){this._checked!==w&&(this._checked=w,this._onDidChange.fire({checked:w}))}async run(w,k){this._actionCallback&&await this._actionCallback(w)}}e.Action=R;class T extends A.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new o.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new o.Emitter),this.onDidRun=this._onDidRun.event}async run(w,k){if(!w.enabled)return;this._onWillRun.fire({action:w});let C;try{await this.runAction(w,k)}catch(b){C=b}this._onDidRun.fire({action:w,error:C})}async runAction(w,k){await w.run(k)}}e.ActionRunner=T;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let k=[];for(const C of w)C.length&&(k.length?k=[...k,new P,...C]:k=C);return k}async run(){}}e.Separator=P,P.ID="vs.actions.separator";class y{get actions(){return this._actions}constructor(w,k,C,b){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=k,this.class=b,this._actions=C}async run(){}}e.SubmenuAction=y;class g extends R{constructor(){super(g.ID,l.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=g,g.ID="vs.actions.empty";function L(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.toAction=L}),define(De[21],Ie([1,0,3]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,y){const g=setTimeout(P.bind(y),0);return{dispose(){clearTimeout(g)}}});var l;(function(P){function y(g){return g===P.None||g===P.Cancelled||g instanceof R?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}P.isCancellationToken=y,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(l||(e.CancellationToken=l={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new o.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=l.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=l.None}}e.CancellationTokenSource=T}),define(De[165],Ie([1,0,21]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new o.CancellationTokenSource,y=this.task(P.token);return this.result={promise:y,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=A;class l{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const y=JSON.stringify(P);return this.lastArgKey!==y&&(this.lastArgKey=y,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=l;class R{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const y=this.fn(P);return this._map.set(P,y),y}}e.CachedFunction=R}),define(De[9],Ie([1,0,165,66]),function(oe,e,o,A){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=R;const T=/{(\d+)}/g;function P(z,...K){return K.length===0?z:z.replace(T,function(ge,Ae){const Me=parseInt(Ae,10);return isNaN(Me)||Me<0||Me>=K.length?ge:K[Me]})}e.format=P;const y=/{([^}]+)}/g;function g(z,K){return z.replace(y,(ge,Ae)=>K[Ae]??ge)}e.format2=g;function L(z){return z.replace(/[<>&]/g,function(K){switch(K){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return K}})}e.escape=L;function I(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function w(z,K){let ge=0;const Ae=K.charCodeAt(0);for(let Me=z.length-1;Me>=0;Me--)z.charCodeAt(Me)===Ae&&ge++;return ge}e.count=w;function k(z,K,ge="\u2026"){return z.length<=K?z:`${z.substr(0,K)}${ge}`}e.truncate=k;function C(z,K=" "){const ge=b(z,K);return i(ge,K)}e.trim=C;function b(z,K){if(!z||!K)return z;const ge=K.length;if(ge===0||z.length===0)return z;let Ae=0;for(;z.indexOf(K,Ae)===Ae;)Ae=Ae+ge;return z.substring(Ae)}e.ltrim=b;function i(z,K){if(!z||!K)return z;const ge=K.length,Ae=z.length;if(ge===0||Ae===0)return z;let Me=Ae,qe=-1;for(;qe=z.lastIndexOf(K,Me-1),!(qe===-1||qe+ge!==Me);){if(qe===0)return"";Me=qe}return z.substring(0,Me)}e.rtrim=i;function d(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function h(z){return z.replace(/\*/g,"")}e.stripWildcards=h;function S(z,K,ge={}){if(!z)throw new Error("Cannot create regex from empty string");K||(z=I(z)),ge.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let Ae="";return ge.global&&(Ae+="g"),ge.matchCase||(Ae+="i"),ge.multiline&&(Ae+="m"),ge.unicode&&(Ae+="u"),new RegExp(z,Ae)}e.createRegExp=S;function E(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function p(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function t(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=t;function s(z){return z.split(/\r\n|\r|\n/)}e.splitLines=s;function r(z){for(let K=0,ge=z.length;K<ge;K++){const Ae=z.charCodeAt(K);if(Ae!==32&&Ae!==9)return K}return-1}e.firstNonWhitespaceIndex=r;function a(z,K=0,ge=z.length){for(let Ae=K;Ae<ge;Ae++){const Me=z.charCodeAt(Ae);if(Me!==32&&Me!==9)return z.substring(K,Ae)}return z.substring(K,ge)}e.getLeadingWhitespace=a;function v(z,K=z.length-1){for(let ge=K;ge>=0;ge--){const Ae=z.charCodeAt(ge);if(Ae!==32&&Ae!==9)return ge}return-1}e.lastNonWhitespaceIndex=v;function _(z,K,ge){const Ae=[];let Me=0;for(const qe of z.matchAll(K)){if(Ae.push(z.slice(Me,qe.index)),qe.index===void 0)throw new Error("match.index should be defined");Me=qe.index+qe[0].length,Ae.push(ge(qe[0],...qe.slice(1),qe.index,z,qe.groups))}return Ae.push(z.slice(Me)),Promise.all(Ae).then(qe=>qe.join(""))}e.replaceAsync=_;function c(z,K){return z<K?-1:z>K?1:0}e.compare=c;function u(z,K,ge=0,Ae=z.length,Me=0,qe=K.length){for(;ge<Ae&&Me<qe;ge++,Me++){const pt=z.charCodeAt(ge),at=K.charCodeAt(Me);if(pt<at)return-1;if(pt>at)return 1}const He=Ae-ge,tt=qe-Me;return He<tt?-1:He>tt?1:0}e.compareSubstring=u;function m(z,K){return f(z,K,0,z.length,0,K.length)}e.compareIgnoreCase=m;function f(z,K,ge=0,Ae=z.length,Me=0,qe=K.length){for(;ge<Ae&&Me<qe;ge++,Me++){let pt=z.charCodeAt(ge),at=K.charCodeAt(Me);if(pt===at)continue;if(pt>=128||at>=128)return u(z.toLowerCase(),K.toLowerCase(),ge,Ae,Me,qe);D(pt)&&(pt-=32),D(at)&&(at-=32);const vt=pt-at;if(vt!==0)return vt}const He=Ae-ge,tt=qe-Me;return He<tt?-1:He>tt?1:0}e.compareSubstringIgnoreCase=f;function n(z){return z>=48&&z<=57}e.isAsciiDigit=n;function D(z){return z>=97&&z<=122}e.isLowerAsciiLetter=D;function M(z){return z>=65&&z<=90}e.isUpperAsciiLetter=M;function W(z,K){return z.length===K.length&&f(z,K)===0}e.equalsIgnoreCase=W;function $(z,K){const ge=K.length;return K.length>z.length?!1:f(z,K,0,ge)===0}e.startsWithIgnoreCase=$;function N(z,K){const ge=Math.min(z.length,K.length);let Ae;for(Ae=0;Ae<ge;Ae++)if(z.charCodeAt(Ae)!==K.charCodeAt(Ae))return Ae;return ge}e.commonPrefixLength=N;function U(z,K){const ge=Math.min(z.length,K.length);let Ae;const Me=z.length-1,qe=K.length-1;for(Ae=0;Ae<ge;Ae++)if(z.charCodeAt(Me-Ae)!==K.charCodeAt(qe-Ae))return Ae;return ge}e.commonSuffixLength=U;function q(z){return 55296<=z&&z<=56319}e.isHighSurrogate=q;function F(z){return 56320<=z&&z<=57343}e.isLowSurrogate=F;function B(z,K){return(z-55296<<10)+(K-56320)+65536}e.computeCodePoint=B;function Q(z,K,ge){const Ae=z.charCodeAt(ge);if(q(Ae)&&ge+1<K){const Me=z.charCodeAt(ge+1);if(F(Me))return B(Ae,Me)}return Ae}e.getNextCodePoint=Q;function J(z,K){const ge=z.charCodeAt(K-1);if(F(ge)&&K>1){const Ae=z.charCodeAt(K-2);if(q(Ae))return B(Ae,ge)}return ge}class X{get offset(){return this._offset}constructor(K,ge=0){this._str=K,this._len=K.length,this._offset=ge}setOffset(K){this._offset=K}prevCodePoint(){const K=J(this._str,this._offset);return this._offset-=K>=65536?2:1,K}nextCodePoint(){const K=Q(this._str,this._len,this._offset);return this._offset+=K>=65536?2:1,K}eol(){return this._offset>=this._len}}e.CodePointIterator=X;class ie{get offset(){return this._iterator.offset}constructor(K,ge=0){this._iterator=new X(K,ge)}nextGraphemeLength(){const K=$e.getInstance(),ge=this._iterator,Ae=ge.offset;let Me=K.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const qe=ge.offset,He=K.getGraphemeBreakType(ge.nextCodePoint());if(Pe(Me,He)){ge.setOffset(qe);break}Me=He}return ge.offset-Ae}prevGraphemeLength(){const K=$e.getInstance(),ge=this._iterator,Ae=ge.offset;let Me=K.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const qe=ge.offset,He=K.getGraphemeBreakType(ge.prevCodePoint());if(Pe(He,Me)){ge.setOffset(qe);break}Me=He}return Ae-ge.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ie;function ae(z,K){return new ie(z,K).nextGraphemeLength()}e.nextCharLength=ae;function we(z,K){return new ie(z,K).prevGraphemeLength()}e.prevCharLength=we;function he(z,K){K>0&&F(z.charCodeAt(K))&&K--;const ge=K+ae(z,K);return[ge-we(z,ge),ge]}e.getCharContainingOffset=he;function fe(z){const K=new ie(z);let ge=0;for(;!K.eol();)ge++,K.nextGraphemeLength();return ge}e.charCount=fe;let V;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Z(z){return V||(V=x()),V.test(z)}e.containsRTL=Z;const pe=/^[\t\n\r\x20-\x7E]*$/;function _e(z){return pe.test(z)}e.isBasicASCII=_e,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function re(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=re;function ne(z){return z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=ne;function de(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129008||z>=129280&&z<=129535||z>=129648&&z<=129782}e.isEmojiImprecise=de;function ee(z,K){if(z.length<K)return z;const ge=/\b/g;let Ae=0;for(;ge.test(z)&&!(z.length-ge.lastIndex<K);)Ae=ge.lastIndex,ge.lastIndex+=1;return z.substring(Ae).replace(/^\s/,"")}e.lcut=ee;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,le=/\x1b\].*?\x07/g;function ue(z){return z&&(z=z.replace(ce,"").replace(le,"")),z}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function O(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=O;function j(z){return O(z)?z.substr(1):z}e.stripUTF8BOM=j;function Y(z,K){if(!z||!K||z.length<K.length)return!1;const ge=K.length,Ae=z.toLowerCase();let Me=0,qe=-1;for(;Me<ge;){const He=Ae.indexOf(K[Me],qe+1);if(He<0)return!1;qe=He,Me++}return!0}e.fuzzyContains=Y;function te(z,K=!1){return z?(K&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=te;function be(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=be;function ye(z,K=1){if(K===0)return"";let ge=-1;do ge=z.indexOf(`
`,ge+1),K--;while(K>0&&ge>=0);return ge===-1?z:(z[ge-1]==="\r"&&ge--,z.substr(0,ge))}e.getNLines=ye;function me(z){return z=z%(2*26),z<26?String.fromCharCode(97+z):String.fromCharCode(65+z-26)}e.singleLetterHash=me;function ke(z){return $e.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=ke;function Pe(z,K){return z===0?K!==5&&K!==7:z===2&&K===3?!1:z===4||z===2||z===3||K===4||K===2||K===3?!0:!(z===8&&(K===8||K===9||K===11||K===12)||(z===11||z===9)&&(K===9||K===10)||(z===12||z===10)&&K===10||K===5||K===13||K===7||z===1||z===13&&K===14||z===6&&K===6)}var Be;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(Be||(e.GraphemeBreakType=Be={}));class $e{static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}constructor(){this._data=et()}getGraphemeBreakType(K){if(K<32)return K===10?3:K===13?2:4;if(K<127)return 0;const ge=this._data,Ae=ge.length/3;let Me=1;for(;Me<=Ae;)if(K<ge[3*Me])Me=2*Me;else if(K>ge[3*Me+1])Me=2*Me+1;else return ge[3*Me+2];return 0}}$e._INSTANCE=null;function et(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(z,K){if(z===0)return 0;const ge=Ye(z,K);if(ge!==void 0)return ge;const Ae=new X(K,z);return Ae.prevCodePoint(),Ae.offset}e.getLeftDeleteOffset=Qe;function Ye(z,K){const ge=new X(K,z);let Ae=ge.prevCodePoint();for(;nt(Ae)||Ae===65039||Ae===8419;){if(ge.offset===0)return;Ae=ge.prevCodePoint()}if(!de(Ae))return;let Me=ge.offset;return Me>0&&ge.prevCodePoint()===8205&&(Me=ge.offset),Me}function nt(z){return 127995<=z&&z<=127999}var ct;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.noBreakWhitespace="\xA0";class Fe{static getInstance(K){return Fe.cache.get(Array.from(K))}static getLocales(){return Fe._locales.value}constructor(K){this.confusableDictionary=K}isAmbiguous(K){return this.confusableDictionary.has(K)}getPrimaryConfusable(K){return this.confusableDictionary.get(K)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Fe,l=Fe,Fe.ambiguousCharacterData=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Fe.cache=new o.LRUCachedFunction(z=>{function K(at){const vt=new Map;for(let yt=0;yt<at.length;yt+=2)vt.set(at[yt],at[yt+1]);return vt}function ge(at,vt){const yt=new Map(at);for(const[_t,Tt]of vt)yt.set(_t,Tt);return yt}function Ae(at,vt){if(!at)return vt;const yt=new Map;for(const[_t,Tt]of at)vt.has(_t)&&yt.set(_t,Tt);return yt}const Me=l.ambiguousCharacterData.value;let qe=z.filter(at=>!at.startsWith("_")&&at in Me);qe.length===0&&(qe=["_default"]);let He;for(const at of qe){const vt=K(Me[at]);He=Ae(He,vt)}const tt=K(Me._common),pt=ge(tt,He);return new Fe(pt)}),Fe._locales=new A.Lazy(()=>Object.keys(Fe.ambiguousCharacterData.value).filter(z=>!z.startsWith("_")));class it{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(it.getRawData())),this._data}static isInvisibleCharacter(K){return it.getData().has(K)}static get codePoints(){return it.getData()}}e.InvisibleCharacters=it,it._data=void 0}),define(De[34],Ie([1,0,15,14,9,10]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(_){return _===47||_===92}e.isPathSeparator=T;function P(_){return _.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=P;function y(_){return _.indexOf("/")===-1&&(_=P(_)),/^[a-zA-Z]:(\/|$)/.test(_)&&(_="/"+_),_}e.toPosixPath=y;function g(_,c=o.posix.sep){if(!_)return"";const u=_.length,m=_.charCodeAt(0);if(T(m)){if(T(_.charCodeAt(1))&&!T(_.charCodeAt(2))){let n=3;const D=n;for(;n<u&&!T(_.charCodeAt(n));n++);if(D!==n&&!T(_.charCodeAt(n+1))){for(n+=1;n<u;n++)if(T(_.charCodeAt(n)))return _.slice(0,n+1).replace(/[\\/]/g,c)}}return c}else if(d(m)&&_.charCodeAt(1)===58)return T(_.charCodeAt(2))?_.slice(0,2)+c:_.slice(0,2);let f=_.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(T(_.charCodeAt(f)))return _.slice(0,f+1)}return""}e.getRoot=g;function L(_){if(!A.isWindows||!_||_.length<5)return!1;let c=_.charCodeAt(0);if(c!==92||(c=_.charCodeAt(1),c!==92))return!1;let u=2;const m=u;for(;u<_.length&&(c=_.charCodeAt(u),c!==92);u++);return!(m===u||(c=_.charCodeAt(u+1),isNaN(c)||c===92))}e.isUNC=L;const I=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(_,c=A.isWindows){const u=c?I:w;return!(!_||_.length===0||/^\s+$/.test(_)||(u.lastIndex=0,u.test(_))||c&&k.test(_)||_==="."||_===".."||c&&_[_.length-1]==="."||c&&_.length!==_.trim().length||_.length>255)}e.isValidBasename=C;function b(_,c,u){const m=_===c;return!u||m?m:!_||!c?!1:(0,l.equalsIgnoreCase)(_,c)}e.isEqual=b;function i(_,c,u,m=o.sep){if(_===c)return!0;if(!_||!c||c.length>_.length)return!1;if(u){if(!(0,l.startsWithIgnoreCase)(_,c))return!1;if(c.length===_.length)return!0;let n=c.length;return c.charAt(c.length-1)===m&&n--,_.charAt(n)===m}return c.charAt(c.length-1)!==m&&(c+=m),_.indexOf(c)===0}e.isEqualOrParent=i;function d(_){return _>=65&&_<=90||_>=97&&_<=122}e.isWindowsDriveLetter=d;function h(_,c){return A.isWindows&&_.endsWith(":")&&(_+=o.sep),(0,o.isAbsolute)(_)||(_=(0,o.join)(c,_)),_=(0,o.normalize)(_),A.isWindows?(_=(0,l.rtrim)(_,o.sep),_.endsWith(":")&&(_+=o.sep)):(_=(0,l.rtrim)(_,o.sep),_||(_=o.sep)),_}e.sanitizeFilePath=h;function S(_){const c=(0,o.normalize)(_);return A.isWindows?_.length>3?!1:E(c)&&(_.length===2||c.charCodeAt(2)===92):c===o.posix.sep}e.isRootOrDriveLetter=S;function E(_,c=A.isWindows){return c?d(_.charCodeAt(0))&&_.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function p(_){return E(_)?_[0]:void 0}e.getDriveLetter=p;function t(_,c,u){return c.length>_.length?-1:_===c?0:(u&&(_=_.toLowerCase(),c=c.toLowerCase()),_.indexOf(c))}e.indexOfPath=t;function s(_){const c=_.split(":");let u,m,f;for(const n of c){const D=Number(n);(0,R.isNumber)(D)?m===void 0?m=D:f===void 0&&(f=D):u=u?[u,n].join(":"):n}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:m!==void 0?m:void 0,column:f!==void 0?f:m!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",a="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(_,c,u=8){let m="";for(let n=0;n<u;n++){let D;n===0&&A.isWindows&&!c&&(u===3||u===4)?D=a:D=r,m+=D.charAt(Math.floor(Math.random()*D.length))}let f;return c?f=`${c}-${m}`:f=m,_?(0,o.join)(_,f):f}e.randomPath=v}),define(De[111],Ie([1,0,28,9]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function l(...le){return function(ue,O){for(let j=0,Y=le.length;j<Y;j++){const te=le[j](ue,O);if(te)return te}return null}}e.or=l,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(le,ue,O){if(!O||O.length<ue.length)return null;let j;return le?j=A.startsWithIgnoreCase(O,ue):j=O.indexOf(ue)===0,j?ue.length>0?[{start:0,end:ue.length}]:[]:null}function T(le,ue){const O=ue.toLowerCase().indexOf(le.toLowerCase());return O===-1?null:[{start:O,end:O+le.length}]}e.matchesContiguousSubString=T;function P(le,ue){return y(le.toLowerCase(),ue.toLowerCase(),0,0)}e.matchesSubString=P;function y(le,ue,O,j){if(O===le.length)return[];if(j===ue.length)return null;if(le[O]===ue[j]){let Y=null;return(Y=y(le,ue,O+1,j+1))?d({start:j,end:j+1},Y):null}return y(le,ue,O,j+1)}function g(le){return 97<=le&&le<=122}function L(le){return 65<=le&&le<=90}e.isUpper=L;function I(le){return 48<=le&&le<=57}function w(le){return le===32||le===9||le===10||le===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>k.add(le.charCodeAt(0)));function C(le){return w(le)||k.has(le)}function b(le,ue){return le===ue||C(le)&&C(ue)}function i(le){return g(le)||L(le)||I(le)}function d(le,ue){return ue.length===0?ue=[le]:le.end===ue[0].start?ue[0].start=le.start:ue.unshift(le),ue}function h(le,ue){for(let O=ue;O<le.length;O++){const j=le.charCodeAt(O);if(L(j)||I(j)||O>0&&!i(le.charCodeAt(O-1)))return O}return le.length}function S(le,ue,O,j){if(O===le.length)return[];if(j===ue.length)return null;if(le[O]!==ue[j].toLowerCase())return null;{let Y=null,te=j+1;for(Y=S(le,ue,O+1,j+1);!Y&&(te=h(ue,te))<ue.length;)Y=S(le,ue,O+1,te),te++;return Y===null?null:d({start:j,end:j+1},Y)}}function E(le){let ue=0,O=0,j=0,Y=0,te=0;for(let Pe=0;Pe<le.length;Pe++)te=le.charCodeAt(Pe),L(te)&&ue++,g(te)&&O++,i(te)&&j++,I(te)&&Y++;const be=ue/le.length,ye=O/le.length,me=j/le.length,ke=Y/le.length;return{upperPercent:be,lowerPercent:ye,alphaPercent:me,numericPercent:ke}}function p(le){const{upperPercent:ue,lowerPercent:O}=le;return O===0&&ue>.6}function t(le){const{upperPercent:ue,lowerPercent:O,alphaPercent:j,numericPercent:Y}=le;return O>.2&&ue<.8&&j>.6&&Y<.2}function s(le){let ue=0,O=0,j=0,Y=0;for(let te=0;te<le.length;te++)j=le.charCodeAt(te),L(j)&&ue++,g(j)&&O++,w(j)&&Y++;return(ue===0||O===0)&&Y===0?le.length<=30:ue<=5}function r(le,ue){if(!ue||(ue=ue.trim(),ue.length===0)||!s(le)||ue.length>60)return null;const O=E(ue);if(!t(O)){if(!p(O))return null;ue=ue.toLowerCase()}let j=null,Y=0;for(le=le.toLowerCase();Y<ue.length&&(j=S(le,ue,0,Y))===null;)Y=h(ue,Y+1);return j}e.matchesCamelCase=r;function a(le,ue,O=!1){if(!ue||ue.length===0)return null;let j=null,Y=0;for(le=le.toLowerCase(),ue=ue.toLowerCase();Y<ue.length&&(j=v(le,ue,0,Y,O))===null;)Y=_(ue,Y+1);return j}e.matchesWords=a;function v(le,ue,O,j,Y){if(O===le.length)return[];if(j===ue.length)return null;if(b(le.charCodeAt(O),ue.charCodeAt(j))){let te=null,be=j+1;if(te=v(le,ue,O+1,j+1,Y),!Y)for(;!te&&(be=_(ue,be))<ue.length;)te=v(le,ue,O+1,be,Y),be++;return te?le.charCodeAt(O)!==ue.charCodeAt(j)?te:d({start:j,end:j+1},te):null}else return null}function _(le,ue){for(let O=ue;O<le.length;O++)if(C(le.charCodeAt(O))||O>0&&C(le.charCodeAt(O-1)))return O;return le.length}const c=l(e.matchesPrefix,r,T),u=l(e.matchesPrefix,r,P),m=new o.LRUCache(1e4);function f(le,ue,O=!1){if(typeof le!="string"||typeof ue!="string")return null;let j=m.get(le);j||(j=new RegExp(A.convertSimple2RegExpPattern(le),"i"),m.set(le,j));const Y=j.exec(ue);return Y?[{start:Y.index,end:Y.index+Y[0].length}]:O?u(le,ue):c(le,ue)}e.matchesFuzzy=f;function n(le,ue){const O=pe(le,le.toLowerCase(),0,ue,ue.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return O?M(O):null}e.matchesFuzzy2=n;function D(le,ue,O,j,Y,te){const be=Math.min(13,le.length);for(;O<be;O++){const ye=pe(le,ue,O,j,Y,te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,te]}e.anyScore=D;function M(le){if(typeof le>"u")return[];const ue=[],O=le[1];for(let j=le.length-1;j>1;j--){const Y=le[j]+O,te=ue[ue.length-1];te&&te.end===Y?te.end=Y+1:ue.push({start:Y,end:Y+1})}return ue}e.createMatches=M;const W=128;function $(){const le=[],ue=[];for(let O=0;O<=W;O++)ue[O]=0;for(let O=0;O<=W;O++)le.push(ue.slice(0));return le}function N(le){const ue=[];for(let O=0;O<=le;O++)ue[O]=0;return ue}const U=N(2*W),q=N(2*W),F=$(),B=$(),Q=$(),J=!1;function X(le,ue,O,j,Y){function te(ye,me,ke=" "){for(;ye.length<me;)ye=ke+ye;return ye}let be=` |   |${j.split("").map(ye=>te(ye,3)).join("|")}
`;for(let ye=0;ye<=O;ye++)ye===0?be+=" |":be+=`${ue[ye-1]}|`,be+=le[ye].slice(0,Y+1).map(me=>te(me.toString(),3)).join("|")+`
`;return be}function ie(le,ue,O,j){le=le.substr(ue),O=O.substr(j),console.log(X(B,le,le.length,O,O.length)),console.log(X(Q,le,le.length,O,O.length)),console.log(X(F,le,le.length,O,O.length))}function ae(le,ue){if(ue<0||ue>=le.length)return!1;const O=le.codePointAt(ue);switch(O){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(O)}}function we(le,ue){if(ue<0||ue>=le.length)return!1;switch(le.charCodeAt(ue)){case 32:case 9:return!0;default:return!1}}function he(le,ue,O){return ue[le]!==O[le]}function fe(le,ue,O,j,Y,te,be=!1){for(;ue<O&&Y<te;)le[ue]===j[Y]&&(be&&(U[ue]=Y),ue+=1),Y+=1;return ue===O}e.isPatternInWord=fe;var V;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(V||(V={}));var x;(function(le){le.Default=[-100,0];function ue(O){return!O||O.length===2&&O[0]===-100&&O[1]===0}le.isDefault=ue})(x||(e.FuzzyScore=x={}));class Z{constructor(ue,O){this.firstMatchCanBeWeak=ue,this.boostFullMatch=O}}e.FuzzyScoreOptions=Z,Z.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function pe(le,ue,O,j,Y,te,be=Z.default){const ye=le.length>W?W:le.length,me=j.length>W?W:j.length;if(O>=ye||te>=me||ye-O>me-te||!fe(ue,O,ye,Y,te,me,!0))return;_e(ye,me,O,te,ue,Y);let ke=1,Pe=1,Be=O,$e=te;const et=[!1];for(ke=1,Be=O;Be<ye;ke++,Be++){const Fe=U[Be],it=q[Be],z=Be+1<ye?q[Be+1]:me;for(Pe=Fe-te+1,$e=Fe;$e<z;Pe++,$e++){let K=Number.MIN_SAFE_INTEGER,ge=!1;$e<=it&&(K=re(le,ue,Be,O,j,Y,$e,me,te,F[ke-1][Pe-1]===0,et));let Ae=0;K!==Number.MAX_SAFE_INTEGER&&(ge=!0,Ae=K+B[ke-1][Pe-1]);const Me=$e>Fe,qe=Me?B[ke][Pe-1]+(F[ke][Pe-1]>0?-5:0):0,He=$e>Fe+1&&F[ke][Pe-1]>0,tt=He?B[ke][Pe-2]+(F[ke][Pe-2]>0?-5:0):0;if(He&&(!Me||tt>=qe)&&(!ge||tt>=Ae))B[ke][Pe]=tt,Q[ke][Pe]=3,F[ke][Pe]=0;else if(Me&&(!ge||qe>=Ae))B[ke][Pe]=qe,Q[ke][Pe]=2,F[ke][Pe]=0;else if(ge)B[ke][Pe]=Ae,Q[ke][Pe]=1,F[ke][Pe]=F[ke-1][Pe-1]+1;else throw new Error("not possible")}}if(J&&ie(le,O,j,te),!et[0]&&!be.firstMatchCanBeWeak)return;ke--,Pe--;const Qe=[B[ke][Pe],te];let Ye=0,nt=0;for(;ke>=1;){let Fe=Pe;do{const it=Q[ke][Fe];if(it===3)Fe=Fe-2;else if(it===2)Fe=Fe-1;else break}while(Fe>=1);Ye>1&&ue[O+ke-1]===Y[te+Pe-1]&&!he(Fe+te-1,j,Y)&&Ye+1>F[ke][Fe]&&(Fe=Pe),Fe===Pe?Ye++:Ye=1,nt||(nt=Fe),ke--,Pe=Fe-1,Qe.push(Pe)}me===ye&&be.boostFullMatch&&(Qe[0]+=2);const ct=nt-ye;return Qe[0]-=ct,Qe}e.fuzzyScore=pe;function _e(le,ue,O,j,Y,te){let be=le-1,ye=ue-1;for(;be>=O&&ye>=j;)Y[be]===te[ye]&&(q[be]=ye,be--),ye--}function re(le,ue,O,j,Y,te,be,ye,me,ke,Pe){if(ue[O]!==te[be])return Number.MIN_SAFE_INTEGER;let Be=1,$e=!1;return be===O-j?Be=le[O]===Y[be]?7:5:he(be,Y,te)&&(be===0||!he(be-1,Y,te))?(Be=le[O]===Y[be]?7:5,$e=!0):ae(te,be)&&(be===0||!ae(te,be-1))?Be=5:(ae(te,be-1)||we(te,be-1))&&(Be=5,$e=!0),Be>1&&O===j&&(Pe[0]=!0),$e||($e=he(be,Y,te)||ae(te,be-1)||we(te,be-1)),O===j?be>me&&(Be-=$e?3:5):ke?Be+=$e?2:0:Be+=$e?0:1,be+1===ye&&(Be-=$e?3:5),Be}function ne(le,ue,O,j,Y,te,be){return ee(le,ue,O,j,Y,te,!0,be)}e.fuzzyScoreGracefulAggressive=ne;function de(le,ue,O,j,Y,te,be){return ee(le,ue,O,j,Y,te,!1,be)}e.fuzzyScoreGraceful=de;function ee(le,ue,O,j,Y,te,be,ye){let me=pe(le,ue,O,j,Y,te,ye);if(me&&!be)return me;if(le.length>=3){const ke=Math.min(7,le.length-1);for(let Pe=O+1;Pe<ke;Pe++){const Be=ce(le,Pe);if(Be){const $e=pe(Be,Be.toLowerCase(),O,j,Y,te,ye);$e&&($e[0]-=3,(!me||$e[0]>me[0])&&(me=$e))}}}return me}function ce(le,ue){if(ue+1>=le.length)return;const O=le[ue],j=le[ue+1];if(O!==j)return le.slice(0,ue)+j+O+le.slice(ue+2)}}),define(De[69],Ie([1,0,9]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(d){return l(d,0)}e.hash=A;function l(d,h){switch(typeof d){case"object":return d===null?R(349,h):Array.isArray(d)?y(d,h):g(d,h);case"string":return P(d,h);case"boolean":return T(d,h);case"number":return R(d,h);case"undefined":return R(937,h);default:return R(617,h)}}e.doHash=l;function R(d,h){return(h<<5)-h+d|0}e.numberHash=R;function T(d,h){return R(d?433:863,h)}function P(d,h){h=R(149417,h);for(let S=0,E=d.length;S<E;S++)h=R(d.charCodeAt(S),h);return h}e.stringHash=P;function y(d,h){return h=R(104579,h),d.reduce((S,E)=>l(E,S),h)}function g(d,h){return h=R(181387,h),Object.keys(d).sort().reduce((S,E)=>(S=P(E,S),l(d[E],S)),h)}class L{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=l(h,this._value),this._value}}e.Hasher=L;var I;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function w(d,h,S=32){const E=S-h,p=~((1<<E)-1);return(d<<h|(p&d)>>>E)>>>0}function k(d,h=0,S=d.byteLength,E=0){for(let p=0;p<S;p++)d[h+p]=E}function C(d,h,S="0"){for(;d.length<h;)d=S+d;return d}function b(d,h=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(S=>S.toString(16).padStart(2,"0")).join(""):C((d>>>0).toString(16),h/4)}e.toHexString=b;class i{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const S=h.length;if(S===0)return;const E=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=h.charCodeAt(0),r=0);;){let a=s;if(o.isHighSurrogate(s))if(r+1<S){const v=h.charCodeAt(r+1);o.isLowSurrogate(v)?(r++,a=o.computeCodePoint(s,v)):a=65533}else{t=s;break}else o.isLowSurrogate(s)&&(a=65533);if(p=this._push(E,p,a),r++,r<S)s=h.charCodeAt(r);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(h,S,E){return E<128?h[S++]=E:E<2048?(h[S++]=192|(E&1984)>>>6,h[S++]=128|(E&63)>>>0):E<65536?(h[S++]=224|(E&61440)>>>12,h[S++]=128|(E&4032)>>>6,h[S++]=128|(E&63)>>>0):(h[S++]=240|(E&1835008)>>>18,h[S++]=128|(E&258048)>>>12,h[S++]=128|(E&4032)>>>6,h[S++]=128|(E&63)>>>0),S>=64&&(this._step(),S-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),S}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,k(this._buff,this._buffLen),this._buffLen>56&&(this._step(),k(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=i._bigBlock32,S=this._buffDV;for(let c=0;c<64;c+=4)h.setUint32(c,S.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)h.setUint32(c,w(h.getUint32(c-12,!1)^h.getUint32(c-32,!1)^h.getUint32(c-56,!1)^h.getUint32(c-64,!1),1),!1);let E=this._h0,p=this._h1,t=this._h2,s=this._h3,r=this._h4,a,v,_;for(let c=0;c<80;c++)c<20?(a=p&t|~p&s,v=1518500249):c<40?(a=p^t^s,v=1859775393):c<60?(a=p&t|p&s|t&s,v=2400959708):(a=p^t^s,v=3395469782),_=w(E,5)+a+r+v+h.getUint32(c*4,!1)&4294967295,r=s,s=t,t=w(p,30),p=E,E=_;this._h0=this._h0+E&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=i,i._bigBlock32=new DataView(new ArrayBuffer(320))}),define(De[112],Ie([1,0,109,111,69,15,14,9]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,g=[y,[]];function L(F,B,Q,J){if(!F||!B)return g;const X=F.length,ie=B.length;if(X<ie)return g;const ae=F.toLowerCase();return I(B,Q,ie,F,ae,X,J)}e.scoreFuzzy=L;function I(F,B,Q,J,X,ie,ae){const we=[],he=[];for(let Z=0;Z<Q;Z++){const pe=Z*ie,_e=pe-ie,re=Z>0,ne=F[Z],de=B[Z];for(let ee=0;ee<ie;ee++){const ce=ee>0,le=pe+ee,ue=le-1,O=_e+ee-1,j=ce?we[ue]:0,Y=re&&ce?we[O]:0,te=re&&ce?he[O]:0;let be;!Y&&re?be=0:be=w(ne,de,J,X,ee,te),be&&Y+be>=j&&(ae||re||X.startsWith(B,ee))?(he[le]=te+1,we[le]=Y+be):(he[le]=y,we[le]=j)}}const fe=[];let V=Q-1,x=ie-1;for(;V>=0&&x>=0;){const Z=V*ie+x;he[Z]===y||(fe.push(x),V--),x--}return[we[Q*ie-1],fe.reverse()]}function w(F,B,Q,J,X,ie){let ae=0;if(!k(B,J[X]))return ae;if(ae+=1,ie>0&&(ae+=ie*5),F===Q[X]&&(ae+=1),X===0)ae+=8;else{const we=C(Q.charCodeAt(X-1));we?ae+=we:(0,A.isUpper)(Q.charCodeAt(X))&&ie===0&&(ae+=2)}return ae}function k(F,B){return F===B?!0:F==="/"||F==="\\"?B==="/"||B==="\\":!1}function C(F){switch(F){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const b=[void 0,[]];function i(F,B,Q=0,J=0){const X=B;return X.values&&X.values.length>1?d(F,X.values,Q,J):h(F,B,Q,J)}e.scoreFuzzy2=i;function d(F,B,Q,J){let X=0;const ie=[];for(const ae of B){const[we,he]=h(F,ae,Q,J);if(typeof we!="number")return b;X+=we,ie.push(...he)}return[X,u(ie)]}function h(F,B,Q,J){const X=(0,A.fuzzyScore)(B.original,B.originalLowercase,Q,F,F.toLowerCase(),J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,A.createMatches)(X)]:b}const S=Object.freeze({score:0}),E=1<<18,p=1<<17,t=1<<16;function s(F,B,Q,J){const X=J.values?J.values:[J];return(0,l.hash)({[J.normalized]:{values:X.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:F,description:B,allowNonContiguousMatches:Q}})}function r(F,B,Q,J,X){if(!F||!B.normalized)return S;const ie=J.getItemLabel(F);if(!ie)return S;const ae=J.getItemDescription(F),we=s(ie,ae,Q,B),he=X[we];if(he)return he;const fe=a(ie,ae,J.getItemPath(F),B,Q);return X[we]=fe,fe}e.scoreItemFuzzy=r;function a(F,B,Q,J,X){const ie=!Q||!J.containsPathSeparator;return Q&&(T.isLinux?J.pathNormalized===Q:(0,P.equalsIgnoreCase)(J.pathNormalized,Q))?{score:E,labelMatch:[{start:0,end:F.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:J.values&&J.values.length>1?v(F,B,Q,J.values,ie,X):_(F,B,Q,J,ie,X)}function v(F,B,Q,J,X,ie){let ae=0;const we=[],he=[];for(const fe of J){const{score:V,labelMatch:x,descriptionMatch:Z}=_(F,B,Q,fe,X,ie);if(V===y)return S;ae+=V,x&&we.push(...x),Z&&he.push(...Z)}return{score:ae,labelMatch:u(we),descriptionMatch:u(he)}}function _(F,B,Q,J,X,ie){if(X||!B){const[ae,we]=L(F,J.normalized,J.normalizedLowercase,ie&&!J.expectContiguousMatch);if(ae){const he=(0,A.matchesPrefix)(J.normalized,F);let fe;if(he){fe=p;const V=Math.round(J.normalized.length/F.length*100);fe+=V}else fe=t;return{score:fe+ae,labelMatch:he||c(we)}}}if(B){let ae=B;Q&&(ae=`${B}${R.sep}`);const we=ae.length,he=`${ae}${F}`,[fe,V]=L(he,J.normalized,J.normalizedLowercase,ie&&!J.expectContiguousMatch);if(fe){const x=c(V),Z=[],pe=[];return x.forEach(_e=>{_e.start<we&&_e.end>we?(Z.push({start:0,end:_e.end-we}),pe.push({start:_e.start,end:we})):_e.start>=we?Z.push({start:_e.start-we,end:_e.end-we}):pe.push(_e)}),{score:fe,labelMatch:Z,descriptionMatch:pe}}}return S}function c(F){const B=[];if(!F)return B;let Q;for(const J of F)Q&&Q.end===J?Q.end+=1:(Q={start:J,end:J+1},B.push(Q));return B}function u(F){const B=F.sort((X,ie)=>X.start-ie.start),Q=[];let J;for(const X of B)!J||!m(J,X)?(J=X,Q.push(X)):(J.start=Math.min(J.start,X.start),J.end=Math.max(J.end,X.end));return Q}function m(F,B){return!(F.end<B.start||B.end<F.start)}function f(F,B,Q,J,X,ie){const ae=r(F,Q,J,X,ie),we=r(B,Q,J,X,ie),he=ae.score,fe=we.score;if((he===E||fe===E)&&he!==fe)return he===E?-1:1;if(he>t||fe>t){if(he!==fe)return he>fe?-1:1;if(he<p&&fe<p){const ne=D(ae.labelMatch,we.labelMatch);if(ne!==0)return ne}const _e=X.getItemLabel(F)||"",re=X.getItemLabel(B)||"";if(_e.length!==re.length)return _e.length-re.length}if(he!==fe)return he>fe?-1:1;const V=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,x=Array.isArray(we.labelMatch)&&we.labelMatch.length>0;if(V&&!x)return-1;if(x&&!V)return 1;const Z=n(F,ae,X),pe=n(B,we,X);return Z&&pe&&Z!==pe?pe>Z?-1:1:M(F,B,Q,X)}e.compareItemsByFuzzyScore=f;function n(F,B,Q){let J=-1,X=-1;if(B.descriptionMatch&&B.descriptionMatch.length?J=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(J=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(X=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const ie=Q.getItemDescription(F);ie&&(X+=ie.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(X=B.descriptionMatch[B.descriptionMatch.length-1].end);return X-J}function D(F,B){if(!F&&!B||(!F||!F.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!F||!F.length)return 1;const Q=F[0].start,X=F[F.length-1].end-Q,ie=B[0].start,we=B[B.length-1].end-ie;return X===we?0:we<X?1:-1}function M(F,B,Q,J){const X=J.getItemLabel(F)||"",ie=J.getItemLabel(B)||"",ae=J.getItemDescription(F),we=J.getItemDescription(B),he=X.length+(ae?ae.length:0),fe=ie.length+(we?we.length:0);if(he!==fe)return he-fe;const V=J.getItemPath(F),x=J.getItemPath(B);return V&&x&&V.length!==x.length?V.length-x.length:X!==ie?(0,o.compareAnything)(X,ie,Q.normalized):ae&&we&&ae!==we?(0,o.compareAnything)(ae,we,Q.normalized):V&&x&&V!==x?(0,o.compareAnything)(V,x,Q.normalized):0}function W(F){return F.startsWith('"')&&F.endsWith('"')}const $=" ";function N(F){typeof F!="string"&&(F="");const B=F.toLowerCase(),{pathNormalized:Q,normalized:J,normalizedLowercase:X}=U(F),ie=Q.indexOf(R.sep)>=0,ae=W(F);let we;const he=F.split($);if(he.length>1)for(const fe of he){const V=W(fe),{pathNormalized:x,normalized:Z,normalizedLowercase:pe}=U(fe);Z&&(we||(we=[]),we.push({original:fe,originalLowercase:fe.toLowerCase(),pathNormalized:x,normalized:Z,normalizedLowercase:pe,expectContiguousMatch:V}))}return{original:F,originalLowercase:B,pathNormalized:Q,normalized:J,normalizedLowercase:X,values:we,containsPathSeparator:ie,expectContiguousMatch:ae}}e.prepareQuery=N;function U(F){let B;T.isWindows?B=F.replace(/\//g,R.sep):B=F.replace(/\\/g,R.sep);const Q=(0,P.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:Q,normalizedLowercase:Q.toLowerCase()}}function q(F){return Array.isArray(F)?N(F.map(B=>B.original).join($)):N(F.original)}e.pieceToQuery=q}),define(De[166],Ie([1,0,111,9,53]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",T=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${T.source}`,"g");function y(d){return d.replace(P,(h,S)=>S?h:`\\${h}`)}e.escapeIcons=y;const g=new RegExp(`\\\\${T.source}`,"g");function L(d){return d.replace(g,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=L;const I=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function w(d){return d.indexOf(R)===-1?d:d.replace(I,(h,S,E,p)=>E?h:S||p||"")}e.stripIcons=w;function k(d){return d?d.replace(/\$\((.*?)\)/g,(h,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=k;const C=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function b(d){C.lastIndex=0;let h="";const S=[];let E=0;for(;;){const p=C.lastIndex,t=C.exec(d),s=d.substring(p,t?.index);if(s.length>0){h+=s;for(let r=0;r<s.length;r++)S.push(E)}if(!t)break;E+=t[0].length}return{text:h,iconOffsets:S}}e.parseLabelWithIcons=b;function i(d,h,S=!1){const{text:E,iconOffsets:p}=h;if(!p||p.length===0)return(0,o.matchesFuzzy)(d,E,S);const t=(0,A.ltrim)(E," "),s=E.length-t.length,r=(0,o.matchesFuzzy)(d,t,S);if(r)for(const a of r){const v=p[a.start+s]+s;a.start+=v,a.end+=v}return r}e.matchesFuzzyIconAware=i}),define(De[38],Ie([1,0,9]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(A||(A={})),function(l){const R="error",T="warning",P="warn",y="info",g="ignore";function L(w){return w?o.equalsIgnoreCase(R,w)?l.Error:o.equalsIgnoreCase(T,w)||o.equalsIgnoreCase(P,w)?l.Warning:o.equalsIgnoreCase(y,w)?l.Info:l.Ignore:l.Ignore}l.fromValue=L;function I(w){switch(w){case l.Error:return R;case l.Warning:return T;case l.Info:return y;default:return g}}l.toString=I}(A||(A={})),e.default=A}),define(De[70],Ie([1,0,18,9]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this._value="",this._pos=0}reset(k){return this._value=k,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(k){const C=k.charCodeAt(0),b=this._value.charCodeAt(this._pos);return C-b}value(){return this._value[this._pos]}}e.StringIterator=l;class R{constructor(k=!0){this._caseSensitive=k}reset(k){return this._value=k,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let k=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(k)this._from++;else break;else k=!1;return this}cmp(k){return this._caseSensitive?(0,A.compareSubstring)(k,this._value,0,k.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(k,this._value,0,k.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class T{constructor(k=!0,C=!0){this._splitOnBackslash=k,this._caseSensitive=C}reset(k){this._from=0,this._to=0,this._value=k,this._valueLen=k.length;for(let C=k.length-1;C>=0;C--,this._valueLen--){const b=this._value.charCodeAt(C);if(!(b===47||this._splitOnBackslash&&b===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let k=!0;for(;this._to<this._valueLen;this._to++){const C=this._value.charCodeAt(this._to);if(C===47||this._splitOnBackslash&&C===92)if(k)this._from++;else break;else k=!1}return this}cmp(k){return this._caseSensitive?(0,A.compareSubstring)(k,this._value,0,k.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(k,this._value,0,k.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var P;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(P||(P={}));class y{constructor(k,C){this._ignorePathCasing=k,this._ignoreQueryAndFragment=C,this._states=[],this._stateIdx=0}reset(k){return this._value=k,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(k)),this._pathIterator.reset(k.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(k)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(k){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(k,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(k,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(k);if(this._states[this._stateIdx]===4)return(0,A.compare)(k,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(k,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(L||(L={}));class I{static forUris(k=()=>!1,C=()=>!1){return new I(new y(k,C))}static forPaths(k=!1){return new I(new T(void 0,!k))}static forStrings(){return new I(new l)}static forConfigKeys(){return new I(new R)}constructor(k){this._iter=k}clear(){this._root=void 0}fill(k,C){if(C){const b=C.slice(0);(0,o.shuffle)(b);for(const i of b)this.set(i,k)}else{const b=k.slice(0);(0,o.shuffle)(b);for(const i of b)this.set(i[0],i[1])}}set(k,C){const b=this._iter.reset(k);let i;this._root||(this._root=new g,this._root.segment=b.value());const d=[];for(i=this._root;;){const S=b.cmp(i.segment);if(S>0)i.left||(i.left=new g,i.left.segment=b.value()),d.push([-1,i]),i=i.left;else if(S<0)i.right||(i.right=new g,i.right.segment=b.value()),d.push([1,i]),i=i.right;else if(b.hasNext())b.next(),i.mid||(i.mid=new g,i.mid.segment=b.value()),d.push([0,i]),i=i.mid;else break}const h=i.value;i.value=C,i.key=k;for(let S=d.length-1;S>=0;S--){const E=d[S][1];E.updateHeight();const p=E.balanceFactor();if(p<-1||p>1){const t=d[S][0],s=d[S+1][0];if(t===1&&s===1)d[S][1]=E.rotateLeft();else if(t===-1&&s===-1)d[S][1]=E.rotateRight();else if(t===1&&s===-1)E.right=d[S+1][1]=d[S+1][1].rotateRight(),d[S][1]=E.rotateLeft();else if(t===-1&&s===1)E.left=d[S+1][1]=d[S+1][1].rotateLeft(),d[S][1]=E.rotateRight();else throw new Error;if(S>0)switch(d[S-1][0]){case-1:d[S-1][1].left=d[S][1];break;case 1:d[S-1][1].right=d[S][1];break;case 0:d[S-1][1].mid=d[S][1];break}else this._root=d[0][1]}}return h}get(k){return this._getNode(k)?.value}_getNode(k){const C=this._iter.reset(k);let b=this._root;for(;b;){const i=C.cmp(b.segment);if(i>0)b=b.left;else if(i<0)b=b.right;else if(C.hasNext())C.next(),b=b.mid;else break}return b}has(k){const C=this._getNode(k);return!(C?.value===void 0&&C?.mid===void 0)}delete(k){return this._delete(k,!1)}deleteSuperstr(k){return this._delete(k,!0)}_delete(k,C){const b=this._iter.reset(k),i=[];let d=this._root;for(;d;){const h=b.cmp(d.segment);if(h>0)i.push([-1,d]),d=d.left;else if(h<0)i.push([1,d]),d=d.right;else if(b.hasNext())b.next(),i.push([0,d]),d=d.mid;else break}if(d){if(C?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const h=this._min(d.right);if(h.key){const{key:S,value:E,segment:p}=h;this._delete(h.key,!1),d.key=S,d.value=E,d.segment=p}}else{const h=d.left??d.right;if(i.length>0){const[S,E]=i[i.length-1];switch(S){case-1:E.left=h;break;case 0:E.mid=h;break;case 1:E.right=h;break}}else this._root=h}for(let h=i.length-1;h>=0;h--){const S=i[h][1];S.updateHeight();const E=S.balanceFactor();if(E>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),i[h][1]=S.rotateLeft()):E<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),i[h][1]=S.rotateRight()),h>0)switch(i[h-1][0]){case-1:i[h-1][1].left=i[h][1];break;case 1:i[h-1][1].right=i[h][1];break;case 0:i[h-1][1].mid=i[h][1];break}else this._root=i[0][1]}}}_min(k){for(;k.left;)k=k.left;return k}findSubstr(k){const C=this._iter.reset(k);let b=this._root,i;for(;b;){const d=C.cmp(b.segment);if(d>0)b=b.left;else if(d<0)b=b.right;else if(C.hasNext())C.next(),i=b.value||i,b=b.mid;else break}return b&&b.value||i}findSuperstr(k){return this._findSuperstrOrElement(k,!1)}_findSuperstrOrElement(k,C){const b=this._iter.reset(k);let i=this._root;for(;i;){const d=b.cmp(i.segment);if(d>0)i=i.left;else if(d<0)i=i.right;else if(b.hasNext())b.next(),i=i.mid;else return i.mid?this._entries(i.mid):C?i.value:void 0}}hasElementOrSubtree(k){return this._findSuperstrOrElement(k,!0)!==void 0}forEach(k){for(const[C,b]of this)k(b,C)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(k){const C=[];return this._dfsEntries(k,C),C[Symbol.iterator]()}_dfsEntries(k,C){k&&(k.left&&this._dfsEntries(k.left,C),k.value&&C.push([k.key,k.value]),k.mid&&this._dfsEntries(k.mid,C),k.right&&this._dfsEntries(k.right,C))}_isBalanced(){const k=C=>{if(!C)return!0;const b=C.balanceFactor();return b<-1||b>1?!1:k(C.left)&&k(C.right)};return k(this._root)}}e.TernarySearchTree=I}),define(De[2],Ie([1,0,15,14]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,R=/^\//,T=/^\/\//;function P(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!l.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(r,a){return!r&&!a?"file":r}function g(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==I&&(a=I+a):a=I;break}return a}const L="",I="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(a){return a instanceof k?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,v,_,c,u,m=!1){typeof a=="object"?(this.scheme=a.scheme||L,this.authority=a.authority||L,this.path=a.path||L,this.query=a.query||L,this.fragment=a.fragment||L):(this.scheme=y(a,m),this.authority=v||L,this.path=g(this.scheme,_||L),this.query=c||L,this.fragment=u||L,P(this,m))}get fsPath(){return S(this,!1)}with(a){if(!a)return this;let{scheme:v,authority:_,path:c,query:u,fragment:m}=a;return v===void 0?v=this.scheme:v===null&&(v=L),_===void 0?_=this.authority:_===null&&(_=L),c===void 0?c=this.path:c===null&&(c=L),u===void 0?u=this.query:u===null&&(u=L),m===void 0?m=this.fragment:m===null&&(m=L),v===this.scheme&&_===this.authority&&c===this.path&&u===this.query&&m===this.fragment?this:new b(v,_,c,u,m)}static parse(a,v=!1){const _=w.exec(a);return _?new b(_[2]||L,s(_[4]||L),s(_[5]||L),s(_[7]||L),s(_[9]||L),v):new b(L,L,L,L,L)}static file(a){let v=L;if(A.isWindows&&(a=a.replace(/\\/g,I)),a[0]===I&&a[1]===I){const _=a.indexOf(I,2);_===-1?(v=a.substring(2),a=I):(v=a.substring(2,_),a=a.substring(_)||I)}return new b("file",v,a,L,L)}static from(a){const v=new b(a.scheme,a.authority,a.path,a.query,a.fragment);return P(v,!0),v}static joinPath(a,...v){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let _;return A.isWindows&&a.scheme==="file"?_=k.file(o.win32.join(S(a,!0),...v)).path:_=o.posix.join(a.path,...v),a.with({path:_})}toString(a=!1){return E(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof k)return a;{const v=new b(a);return v._formatted=a.external,v._fsPath=a._sep===C?a.fsPath:null,v}}else return a}}e.URI=k;const C=A.isWindows?1:void 0;class b extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=S(this,!1)),this._fsPath}toString(a=!1){return a?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=C),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const i={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(r,a,v){let _,c=-1;for(let u=0;u<r.length;u++){const m=r.charCodeAt(u);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||a&&m===47||v&&m===91||v&&m===93||v&&m===58)c!==-1&&(_+=encodeURIComponent(r.substring(c,u)),c=-1),_!==void 0&&(_+=r.charAt(u));else{_===void 0&&(_=r.substr(0,u));const f=i[m];f!==void 0?(c!==-1&&(_+=encodeURIComponent(r.substring(c,u)),c=-1),_+=f):c===-1&&(c=u)}}return c!==-1&&(_+=encodeURIComponent(r.substring(c))),_!==void 0?_:r}function h(r){let a;for(let v=0;v<r.length;v++){const _=r.charCodeAt(v);_===35||_===63?(a===void 0&&(a=r.substr(0,v)),a+=i[_]):a!==void 0&&(a+=r[v])}return a!==void 0?a:r}function S(r,a){let v;return r.authority&&r.path.length>1&&r.scheme==="file"?v=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?a?v=r.path.substr(1):v=r.path[1].toLowerCase()+r.path.substr(2):v=r.path,A.isWindows&&(v=v.replace(/\//g,"\\")),v}e.uriToFsPath=S;function E(r,a){const v=a?h:d;let _="",{scheme:c,authority:u,path:m,query:f,fragment:n}=r;if(c&&(_+=c,_+=":"),(u||c==="file")&&(_+=I,_+=I),u){let D=u.indexOf("@");if(D!==-1){const M=u.substr(0,D);u=u.substr(D+1),D=M.lastIndexOf(":"),D===-1?_+=v(M,!1,!1):(_+=v(M.substr(0,D),!1,!1),_+=":",_+=v(M.substr(D+1),!1,!0)),_+="@"}u=u.toLowerCase(),D=u.lastIndexOf(":"),D===-1?_+=v(u,!1,!0):(_+=v(u.substr(0,D),!1,!0),_+=u.substr(D))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const D=m.charCodeAt(1);D>=65&&D<=90&&(m=`/${String.fromCharCode(D+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const D=m.charCodeAt(0);D>=65&&D<=90&&(m=`${String.fromCharCode(D+32)}:${m.substr(2)}`)}_+=v(m,!0,!1)}return f&&(_+="?",_+=v(f,!1,!1)),n&&(_+="#",_+=a?n:d(n,!1,!1)),_}function p(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+p(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,a=>p(a)):r}}),define(De[71],Ie([1,0,22,9,2]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(g){return JSON.stringify(g,P)}e.stringify=R;function T(g){let L=JSON.parse(g);return L=y(L),L}e.parse=T;function P(g,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,A.regExpFlags)(L)}:L}function y(g,L=0){if(!g||L>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return l.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 16:return new Date(g.source)}if(g instanceof o.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let I=0;I<g.length;++I)g[I]=y(g[I],L+1);else for(const I in g)Object.hasOwnProperty.call(g,I)&&(g[I]=y(g[I],L+1))}return g}e.revive=y}),define(De[16],Ie([1,0,8,14,2]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractive="vscode-interactive",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeInteractiveSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this._preferredWebSchema=L}setDelegate(L){this._delegate=L}setServerRootPath(L){this._remoteResourcesPath=`${L}/${R.vscodeRemoteResource}`}set(L,I,w){this._hosts[L]=I,this._ports[L]=w}setConnectionToken(L,I){this._connectionTokens[L]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(L){if(this._delegate)try{return this._delegate(L)}catch(i){return o.onUnexpectedError(i),L}const I=L.authority;let w=this._hosts[I];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const k=this._ports[I],C=this._connectionTokens[I];let b=`path=${encodeURIComponent(L.path)}`;return typeof C=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),l.URI.from({scheme:A.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${w}:${k}`,path:this._remoteResourcesPath,query:b})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(L){const I=this.toUri(L,oe);return this.uriToBrowserUri(I)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===R.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${R.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(L){const I=this.toUri(L,oe);return this.uriToFileUri(I)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==P.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(L,I){return l.URI.isUri(L)?L:l.URI.parse(I.toUrl(L))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P;var y;(function(g){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(L.get("3"));const I="vscode-coi";function w(C){let b;typeof C=="string"?b=new URL(C).searchParams:C instanceof URL?b=C.searchParams:l.URI.isUri(C)&&(b=new URL(C.toString(!0)).searchParams);const i=b?.get(I);if(i)return L.get(i)}g.getHeadersFromQuery=w;function k(C,b,i){if(!globalThis.crossOriginIsolated)return;const d=b&&i?"3":i?"2":"1";C instanceof URLSearchParams?C.set(I,d):C[I]=d}g.addSearchParam=k})(y||(e.COI=y={}))}),define(De[24],Ie([1,0,34,16,15,14,9,2]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(k){return(0,P.uriToFsPath)(k,!0)}e.originalFSPath=y;class g{constructor(C){this._ignorePathCasing=C}compare(C,b,i=!1){return C===b?0:(0,T.compare)(this.getComparisonKey(C,i),this.getComparisonKey(b,i))}isEqual(C,b,i=!1){return C===b?!0:!C||!b?!1:this.getComparisonKey(C,i)===this.getComparisonKey(b,i)}getComparisonKey(C,b=!1){return C.with({path:this._ignorePathCasing(C)?C.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(C){return this._ignorePathCasing(C)}isEqualOrParent(C,b,i=!1){if(C.scheme===b.scheme){if(C.scheme===A.Schemas.file)return o.isEqualOrParent(y(C),y(b),this._ignorePathCasing(C))&&C.query===b.query&&(i||C.fragment===b.fragment);if((0,e.isEqualAuthority)(C.authority,b.authority))return o.isEqualOrParent(C.path,b.path,this._ignorePathCasing(C),"/")&&C.query===b.query&&(i||C.fragment===b.fragment)}return!1}joinPath(C,...b){return P.URI.joinPath(C,...b)}basenameOrAuthority(C){return(0,e.basename)(C)||C.authority}basename(C){return l.posix.basename(C.path)}extname(C){return l.posix.extname(C.path)}dirname(C){if(C.path.length===0)return C;let b;return C.scheme===A.Schemas.file?b=P.URI.file(l.dirname(y(C))).path:(b=l.posix.dirname(C.path),C.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),b="/")),C.with({path:b})}normalizePath(C){if(!C.path.length)return C;let b;return C.scheme===A.Schemas.file?b=P.URI.file(l.normalize(y(C))).path:b=l.posix.normalize(C.path),C.with({path:b})}relativePath(C,b){if(C.scheme!==b.scheme||!(0,e.isEqualAuthority)(C.authority,b.authority))return;if(C.scheme===A.Schemas.file){const h=l.relative(y(C),y(b));return R.isWindows?o.toSlashes(h):h}let i=C.path||"/";const d=b.path||"/";if(this._ignorePathCasing(C)){let h=0;for(const S=Math.min(i.length,d.length);h<S&&!(i.charCodeAt(h)!==d.charCodeAt(h)&&i.charAt(h).toLowerCase()!==d.charAt(h).toLowerCase());h++);i=d.substr(0,h)+i.substr(h)}return l.posix.relative(i,d)}resolvePath(C,b){if(C.scheme===A.Schemas.file){const i=P.URI.file(l.resolve(y(C),b));return C.with({authority:i.authority,path:i.path})}return b=o.toPosixPath(b),C.with({path:l.posix.resolve(C.path,b)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,b){return C===b||C!==void 0&&b!==void 0&&(0,T.equalsIgnoreCase)(C,b)}hasTrailingPathSeparator(C,b=l.sep){if(C.scheme===A.Schemas.file){const i=y(C);return i.length>o.getRoot(i).length&&i[i.length-1]===b}else{const i=C.path;return i.length>1&&i.charCodeAt(i.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,b=l.sep){return(0,e.hasTrailingPathSeparator)(C,b)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,b=l.sep){let i=!1;if(C.scheme===A.Schemas.file){const d=y(C);i=d!==void 0&&d.length===o.getRoot(d).length&&d[d.length-1]===b}else{b="/";const d=C.path;i=d.length===1&&d.charCodeAt(d.length-1)===47}return!i&&!(0,e.hasTrailingPathSeparator)(C,b)?C.with({path:C.path+"/"}):C}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(k=>k.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new g(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(k,C){const b=[];for(let i=0;i<k.length;i++){const d=C(k[i]);k.some((h,S)=>S===i?!1:(0,e.isEqualOrParent)(d,C(h)))||b.push(k[i])}return b}e.distinctParents=L;var I;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function C(b){const i=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(S=>{const[E,p]=S.split(":");E&&p&&i.set(E,p)});const h=b.path.substring(0,b.path.indexOf(";"));return h&&i.set(k.META_DATA_MIME,h),i}k.parseMetaData=C})(I||(e.DataUri=I={}));function w(k,C,b){if(C){let i=k.path;return i&&i[0]!==l.posix.sep&&(i=l.posix.sep+i),k.with({scheme:b,authority:C,path:i})}return k.with({scheme:b})}e.toLocalResource=w}),define(De[19],Ie([1,0,21,8,3,6,24,14,150]),function(oe,e,o,A,l,R,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=g;function L(fe){const V=new o.CancellationTokenSource,x=fe(V.token),Z=new Promise((pe,_e)=>{const re=V.token.onCancellationRequested(()=>{re.dispose(),V.dispose(),_e(new A.CancellationError)});Promise.resolve(x).then(ne=>{re.dispose(),V.dispose(),pe(ne)},ne=>{re.dispose(),V.dispose(),_e(ne)})});return new class{cancel(){V.cancel()}then(pe,_e){return Z.then(pe,_e)}catch(pe){return this.then(void 0,pe)}finally(pe){return Z.finally(pe)}}}e.createCancelablePromise=L;function I(fe,V,x){return new Promise((Z,pe)=>{const _e=V.onCancellationRequested(()=>{_e.dispose(),Z(x)});fe.then(Z,pe).finally(()=>_e.dispose())})}e.raceCancellation=I;function w(fe,V){return new Promise((x,Z)=>{const pe=V.onCancellationRequested(()=>{pe.dispose(),Z(new A.CancellationError)});fe.then(x,Z).finally(()=>pe.dispose())})}e.raceCancellationError=w;async function k(fe){let V=-1;const x=fe.map((Z,pe)=>Z.then(_e=>(V=pe,_e)));try{return await Promise.race(x)}finally{fe.forEach((Z,pe)=>{pe!==V&&Z.cancel()})}}e.raceCancellablePromises=k;function C(fe,V,x){let Z;const pe=setTimeout(()=>{Z?.(void 0),x?.()},V);return Promise.race([fe.finally(()=>clearTimeout(pe)),new Promise(_e=>Z=_e)])}e.raceTimeout=C;function b(fe){return new Promise((V,x)=>{const Z=fe();g(Z)?Z.then(V,x):V(Z)})}e.asPromise=b;class i{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(V){if(this.activePromise){if(this.queuedPromiseFactory=V,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const Z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Z};this.queuedPromise=new Promise(Z=>{this.activePromise.then(x,x).then(Z)})}return new Promise((x,Z)=>{this.queuedPromise.then(x,Z)})}return this.activePromise=V(),new Promise((x,Z)=>{this.activePromise.then(pe=>{this.activePromise=null,x(pe)},pe=>{this.activePromise=null,Z(pe)})})}}e.Throttler=i;class d{constructor(){this.current=Promise.resolve(null)}queue(V){return this.current=this.current.then(()=>V(),()=>V())}}e.Sequencer=d;class h{constructor(){this.promiseMap=new Map}queue(V,x){const pe=(this.promiseMap.get(V)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(V)===pe&&this.promiseMap.delete(V)});return this.promiseMap.set(V,pe),pe}}e.SequencerByKey=h;const S=(fe,V)=>{let x=!0;const Z=setTimeout(()=>{x=!1,V()},fe);return{isTriggered:()=>x,dispose:()=>{clearTimeout(Z),x=!1}}},E=fe=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,fe())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class p{constructor(V){this.defaultDelay=V,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(V,x=this.defaultDelay){this.task=V,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((pe,_e)=>{this.doResolve=pe,this.doReject=_e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const pe=this.task;return this.task=null,pe()}}));const Z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=x===y.MicrotaskDelay?E(Z):S(x,Z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new A.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class t{constructor(V){this.delayer=new p(V),this.throttler=new i}trigger(V,x){return this.delayer.trigger(()=>this.throttler.queue(V),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=t;class s{constructor(){this._isOpen=!1,this._promise=new Promise((V,x)=>{this._completePromise=V})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class r extends s{constructor(V){super(),this._timeout=setTimeout(()=>this.open(),V)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function a(fe,V){return V?new Promise((x,Z)=>{const pe=setTimeout(()=>{_e.dispose(),x()},fe),_e=V.onCancellationRequested(()=>{clearTimeout(pe),_e.dispose(),Z(new A.CancellationError)})}):L(x=>a(fe,x))}e.timeout=a;function v(fe,V=0){const x=setTimeout(fe,V);return(0,R.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=v;function _(fe){const V=[];let x=0;const Z=fe.length;function pe(){return x<Z?fe[x++]():null}function _e(re){re!=null&&V.push(re);const ne=pe();return ne?ne.then(_e):Promise.resolve(V)}return Promise.resolve(null).then(_e)}e.sequence=_;function c(fe,V=Z=>!!Z,x=null){let Z=0;const pe=fe.length,_e=()=>{if(Z>=pe)return Promise.resolve(x);const re=fe[Z++];return Promise.resolve(re()).then(de=>V(de)?Promise.resolve(de):_e())};return _e()}e.first=c;function u(fe,V=Z=>!!Z,x=null){if(fe.length===0)return Promise.resolve(x);let Z=fe.length;const pe=()=>{Z=-1;for(const _e of fe)_e.cancel?.()};return new Promise((_e,re)=>{for(const ne of fe)ne.then(de=>{--Z>=0&&V(de)?(pe(),_e(de)):Z===0&&_e(x)}).catch(de=>{--Z>=0&&(pe(),re(de))})})}e.firstParallel=u;class m{constructor(V){this._size=0,this.maxDegreeOfParalellism=V,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new l.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(V){return this._size++,new Promise((x,Z)=>{this.outstandingPromises.push({factory:V,c:x,e:Z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const V=this.outstandingPromises.shift();this.runningPromises++;const x=V.factory();x.then(V.c,V.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=m;class f extends m{constructor(){super(1)}}e.Queue=f;class n{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const V=new J;return this.drainers.add(V),V.p}isDrained(){for(const[,V]of this.queues)if(V.size>0)return!1;return!0}queueFor(V,x=T.extUri){const Z=x.getComparisonKey(V);let pe=this.queues.get(Z);return pe||(pe=new f,l.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.queues.delete(Z),this.onDidQueueDrain()}),this.queues.set(Z,pe)),pe}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const V of this.drainers)V.complete();this.drainers.clear()}dispose(){for(const[,V]of this.queues)V.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=n;class D{constructor(V,x){this._token=-1,typeof V=="function"&&typeof x=="number"&&this.setIfNotSet(V,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(V,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,V()},x)}setIfNotSet(V,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,V()},x))}}e.TimeoutTimer=D;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(V,x){this.cancel(),this._token=setInterval(()=>{V()},x)}}e.IntervalTimer=M;class W{constructor(V,x){this.timeoutToken=-1,this.runner=V,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(V=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,V)}get delay(){return this.timeout}set delay(V){this.timeout=V}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=W;class ${constructor(V,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=V,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(V=this.timeout){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(V/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class N extends W{constructor(V,x){super(V,x),this.units=[]}work(V){this.units.push(V),this.isScheduled()||this.schedule()}doRun(){const V=this.units;this.units=[],this.runner?.(V)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class U extends R.Disposable{constructor(V,x){super(),this.options=V,this.handler=x,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(V){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+V.length>this.options.maxBufferedWork)return!1}else if(this.pending+V.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const x of V)this.pendingWork.push(x);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new W(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,P.setTimeout0)(()=>{if(V)return;const x=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,x-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.runWhenIdle=(fe,V)=>{const x=requestIdleCallback(fe,typeof V=="number"?{timeout:V}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,cancelIdleCallback(x))}}}}();class q{constructor(V){this._didRun=!1,this._executor=()=>{try{this._value=V()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function F(fe,V,x){let Z;for(let pe=0;pe<x;pe++)try{return await fe()}catch(_e){Z=_e,await a(V)}throw Z}e.retry=F;class B{hasPending(V){return this._pending?typeof V=="number"?this._pending.taskId===V:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(V,x,Z){return this._pending={taskId:V,cancel:()=>Z?.(),promise:x},x.then(()=>this.donePending(V),()=>this.donePending(V)),x}donePending(V){this._pending&&V===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const V=this._next;this._next=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}setNext(V){if(this._next)this._next.run=V;else{let x,Z;const pe=new Promise((_e,re)=>{x=_e,Z=re});this._next={run:V,promise:pe,promiseResolve:x,promiseReject:Z}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=B;class Q{constructor(V,x=()=>Date.now()){this.interval=V,this.nowFn=x,this.lastIncrementTime=0,this.value=0}increment(){const V=this.nowFn();return V-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=V,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class J{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((V,x)=>{this.completeCallback=V,this.errorCallback=x})}complete(V){return new Promise(x=>{this.completeCallback(V),this.resolved=!0,x()})}error(V){return new Promise(x=>{this.errorCallback(V),this.rejected=!0,x()})}cancel(){new Promise(V=>{this.errorCallback(new A.CancellationError),this.rejected=!0,V()})}}e.DeferredPromise=J;var X;(function(fe){async function V(Z){let pe;const _e=await Promise.all(Z.map(re=>re.then(ne=>ne,ne=>{pe||(pe=ne)})));if(typeof pe<"u")throw pe;return _e}fe.settled=V;function x(Z){return new Promise(async(pe,_e)=>{try{await Z(pe,_e)}catch(re){_e(re)}})}fe.withAsyncBody=x})(X||(e.Promises=X={}));var ie;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(ie||(ie={}));class ae{static fromArray(V){return new ae(x=>{x.emitMany(V)})}static fromPromise(V){return new ae(async x=>{x.emitMany(await V)})}static fromPromises(V){return new ae(async x=>{await Promise.all(V.map(async Z=>x.emitOne(await Z)))})}static merge(V){return new ae(async x=>{await Promise.all(V.map(async Z=>{for await(const pe of Z)x.emitOne(pe)}))})}constructor(V){this._state=0,this._results=[],this._error=null,this._onStateChanged=new l.Emitter,queueMicrotask(async()=>{const x={emitOne:Z=>this.emitOne(Z),emitMany:Z=>this.emitMany(Z),reject:Z=>this.reject(Z)};try{await Promise.resolve(V(x)),this.resolve()}catch(Z){this.reject(Z)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(V<this._results.length)return{done:!1,value:this._results[V++]};if(this._state===1)return{done:!0,value:void 0};await l.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(V,x){return new ae(async Z=>{for await(const pe of V)Z.emitOne(x(pe))})}map(V){return ae.map(this,V)}static filter(V,x){return new ae(async Z=>{for await(const pe of V)x(pe)&&Z.emitOne(pe)})}filter(V){return ae.filter(this,V)}static coalesce(V){return ae.filter(V,x=>!!x)}coalesce(){return ae.coalesce(this)}static async toPromise(V){const x=[];for await(const Z of V)x.push(Z);return x}toPromise(){return ae.toPromise(this)}emitOne(V){this._state===0&&(this._results.push(V),this._onStateChanged.fire())}emitMany(V){this._state===0&&(this._results=this._results.concat(V),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(V){this._state===0&&(this._state=2,this._error=V,this._onStateChanged.fire())}}e.AsyncIterableObject=ae,ae.EMPTY=ae.fromArray([]);class we extends ae{constructor(V,x){super(x),this._source=V}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=we;function he(fe){const V=new o.CancellationTokenSource,x=fe(V.token);return new we(V,async Z=>{const pe=V.token.onCancellationRequested(()=>{pe.dispose(),V.dispose(),Z.reject(new A.CancellationError)});try{for await(const _e of x){if(V.token.isCancellationRequested)return;Z.emitOne(_e)}pe.dispose(),V.dispose()}catch(_e){pe.dispose(),V.dispose(),Z.reject(_e)}})}e.createCancelableAsyncIterable=he}),define(De[39],Ie([1,0,18,19,34,28,15,14,9]),function(oe,e,o,A,l,R,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",I="[^/\\\\]",w=/\//g;function k(Q,J){switch(Q){case 0:return"";case 1:return`${I}*?`;default:return`(?:${L}|${I}+${L}${J?`|${L}${I}+`:""})*?`}}function C(Q,J){if(!Q)return[];const X=[];let ie=!1,ae=!1,we="";for(const he of Q){switch(he){case J:if(!ie&&!ae){X.push(we),we="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}we+=he}return we&&X.push(we),X}e.splitGlobAware=C;function b(Q){if(!Q)return"";let J="";const X=C(Q,e.GLOB_SPLIT);if(X.every(ie=>ie===e.GLOBSTAR))J=".*";else{let ie=!1;X.forEach((ae,we)=>{if(ae===e.GLOBSTAR){if(ie)return;J+=k(2,we===X.length-1)}else{let he=!1,fe="",V=!1,x="";for(const Z of ae){if(Z!=="}"&&he){fe+=Z;continue}if(V&&(Z!=="]"||!x)){let pe;Z==="-"?pe=Z:(Z==="^"||Z==="!")&&!x?pe="^":Z===e.GLOB_SPLIT?pe="":pe=(0,y.escapeRegExpCharacters)(Z),x+=pe;continue}switch(Z){case"{":he=!0;continue;case"[":V=!0;continue;case"}":{const _e=`(?:${C(fe,",").map(re=>b(re)).join("|")})`;J+=_e,he=!1,fe="";break}case"]":{J+="["+x+"]",V=!1,x="";break}case"?":J+=I;continue;case"*":J+=k(1);continue;default:J+=(0,y.escapeRegExpCharacters)(Z)}}we<X.length-1&&(X[we+1]!==e.GLOBSTAR||we+2<X.length)&&(J+=L)}ie=ae===e.GLOBSTAR})}return J}const i=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),s=function(){return!1},r=function(){return null};function a(Q,J){if(!Q)return r;let X;typeof Q!="string"?X=Q.pattern:X=Q,X=X.trim();const ie=`${X}_${!!J.trimForExclusions}`;let ae=t.get(ie);if(ae)return v(ae,Q);let we;return i.test(X)?ae=c(X.substr(4),X):(we=d.exec(_(X,J)))?ae=u(we[1],X):(J.trimForExclusions?S:h).test(X)?ae=m(X,J):(we=E.exec(_(X,J)))?ae=f(we[1].substr(1),X,!0):(we=p.exec(_(X,J)))?ae=f(we[1],X,!1):ae=n(X),t.set(ie,ae),v(ae,Q)}function v(Q,J){if(typeof J=="string")return Q;const X=function(ie,ae){return(0,l.isEqualOrParent)(ie,J.base,!P.isLinux)?Q((0,y.ltrim)(ie.substr(J.base.length),T.sep),ae):null};return X.allBasenames=Q.allBasenames,X.allPaths=Q.allPaths,X.basenames=Q.basenames,X.patterns=Q.patterns,X}function _(Q,J){return J.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function c(Q,J){return function(X,ie){return typeof X=="string"&&X.endsWith(Q)?J:null}}function u(Q,J){const X=`/${Q}`,ie=`\\${Q}`,ae=function(he,fe){return typeof he!="string"?null:fe?fe===Q?J:null:he===Q||he.endsWith(X)||he.endsWith(ie)?J:null},we=[Q];return ae.basenames=we,ae.patterns=[J],ae.allBasenames=we,ae}function m(Q,J){const X=F(Q.slice(1,-1).split(",").map(fe=>a(fe,J)).filter(fe=>fe!==r),Q),ie=X.length;if(!ie)return r;if(ie===1)return X[0];const ae=function(fe,V){for(let x=0,Z=X.length;x<Z;x++)if(X[x](fe,V))return Q;return null},we=X.find(fe=>!!fe.allBasenames);we&&(ae.allBasenames=we.allBasenames);const he=X.reduce((fe,V)=>V.allPaths?fe.concat(V.allPaths):fe,[]);return he.length&&(ae.allPaths=he),ae}function f(Q,J,X){const ie=T.sep===T.posix.sep,ae=ie?Q:Q.replace(w,T.sep),we=T.sep+ae,he=T.posix.sep+Q;let fe;return X?fe=function(V,x){return typeof V=="string"&&(V===ae||V.endsWith(we)||!ie&&(V===Q||V.endsWith(he)))?J:null}:fe=function(V,x){return typeof V=="string"&&(V===ae||!ie&&V===Q)?J:null},fe.allPaths=[(X?"*/":"./")+Q],fe}function n(Q){try{const J=new RegExp(`^${b(Q)}$`);return function(X){return J.lastIndex=0,typeof X=="string"&&J.test(X)?Q:null}}catch{return r}}function D(Q,J,X){return!Q||typeof J!="string"?!1:M(Q)(J,void 0,X)}e.match=D;function M(Q,J={}){if(!Q)return s;if(typeof Q=="string"||W(Q)){const X=a(Q,J);if(X===r)return s;const ie=function(ae,we){return!!X(ae,we)};return X.allBasenames&&(ie.allBasenames=X.allBasenames),X.allPaths&&(ie.allPaths=X.allPaths),ie}return U(Q,J)}e.parse=M;function W(Q){const J=Q;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.isRelativePattern=W;function $(Q){return Q.allBasenames||[]}e.getBasenameTerms=$;function N(Q){return Q.allPaths||[]}e.getPathTerms=N;function U(Q,J){const X=F(Object.getOwnPropertyNames(Q).map(fe=>q(fe,Q[fe],J)).filter(fe=>fe!==r)),ie=X.length;if(!ie)return r;if(!X.some(fe=>!!fe.requiresSiblings)){if(ie===1)return X[0];const fe=function(Z,pe){let _e;for(let re=0,ne=X.length;re<ne;re++){const de=X[re](Z,pe);if(typeof de=="string")return de;(0,A.isThenable)(de)&&(_e||(_e=[]),_e.push(de))}return _e?(async()=>{for(const re of _e){const ne=await re;if(typeof ne=="string")return ne}return null})():null},V=X.find(Z=>!!Z.allBasenames);V&&(fe.allBasenames=V.allBasenames);const x=X.reduce((Z,pe)=>pe.allPaths?Z.concat(pe.allPaths):Z,[]);return x.length&&(fe.allPaths=x),fe}const ae=function(fe,V,x){let Z,pe;for(let _e=0,re=X.length;_e<re;_e++){const ne=X[_e];ne.requiresSiblings&&x&&(V||(V=(0,T.basename)(fe)),Z||(Z=V.substr(0,V.length-(0,T.extname)(fe).length)));const de=ne(fe,V,Z,x);if(typeof de=="string")return de;(0,A.isThenable)(de)&&(pe||(pe=[]),pe.push(de))}return pe?(async()=>{for(const _e of pe){const re=await _e;if(typeof re=="string")return re}return null})():null},we=X.find(fe=>!!fe.allBasenames);we&&(ae.allBasenames=we.allBasenames);const he=X.reduce((fe,V)=>V.allPaths?fe.concat(V.allPaths):fe,[]);return he.length&&(ae.allPaths=he),ae}function q(Q,J,X){if(J===!1)return r;const ie=a(Q,X);if(ie===r)return r;if(typeof J=="boolean")return ie;if(J){const ae=J.when;if(typeof ae=="string"){const we=(he,fe,V,x)=>{if(!x||!ie(he,fe))return null;const Z=ae.replace("$(basename)",()=>V),pe=x(Z);return(0,A.isThenable)(pe)?pe.then(_e=>_e?Q:null):pe?Q:null};return we.requiresSiblings=!0,we}}return ie}function F(Q,J){const X=Q.filter(fe=>!!fe.basenames);if(X.length<2)return Q;const ie=X.reduce((fe,V)=>{const x=V.basenames;return x?fe.concat(x):fe},[]);let ae;if(J){ae=[];for(let fe=0,V=ie.length;fe<V;fe++)ae.push(J)}else ae=X.reduce((fe,V)=>{const x=V.patterns;return x?fe.concat(x):fe},[]);const we=function(fe,V){if(typeof fe!="string")return null;if(!V){let Z;for(Z=fe.length;Z>0;Z--){const pe=fe.charCodeAt(Z-1);if(pe===47||pe===92)break}V=fe.substr(Z)}const x=ie.indexOf(V);return x!==-1?ae[x]:null};we.basenames=ie,we.patterns=ae,we.allBasenames=ie;const he=Q.filter(fe=>!fe.basenames);return he.push(we),he}function B(Q,J){return(0,o.equals)(Q,J,(X,ie)=>typeof X=="string"&&typeof ie=="string"?X===ie:typeof X!="string"&&typeof ie!="string"?X.base===ie.base&&X.pattern===ie.pattern:!1)}e.patternsEquals=B}),define(De[113],Ie([1,0,8,166,24,9,2]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(P||(e.MarkdownStringTextNewlineStyle=P={}));class y{constructor(d="",h=!1){if(this.value=d,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(d,h=0){return this.value+=w(this.supportThemeIcons?(0,A.escapeIcons)(d):d).replace(/([ \t]+)/g,(S,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,h){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(d,h,S){return this.value+="[",this.value+=this._escape(h,"]"),this.value+="](",this.value+=this._escape(String(d),")"),S&&(this.value+=` "${this._escape(this._escape(S,'"'),")")}"`),this.value+=")",this}_escape(d,h){const S=new RegExp((0,R.escapeRegExpCharacters)(h),"g");return d.replace(S,(E,p)=>d.charAt(p-1)!=="\\"?`\\${E}`:E)}}e.MarkdownString=y;function g(i){return L(i)?!i.value:Array.isArray(i)?i.every(g):!0}e.isEmptyMarkdownString=g;function L(i){return i instanceof y?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||typeof i.isTrusted=="object"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function I(i,d){return i===d?!0:!i||!d?!1:i.value===d.value&&i.isTrusted===d.isTrusted&&i.supportThemeIcons===d.supportThemeIcons&&i.supportHtml===d.supportHtml&&(i.baseUri===d.baseUri||!!i.baseUri&&!!d.baseUri&&(0,l.isEqual)(T.URI.from(i.baseUri),T.URI.from(d.baseUri)))}e.markdownStringEqual=I;function w(i){return i.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=w;function k(i){return i.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=k;function C(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=C;function b(i){const d=[],h=i.split("|").map(E=>E.trim());i=h[0];const S=h[1];if(S){const E=/height=(\d+)/.exec(S),p=/width=(\d+)/.exec(S),t=E?E[1]:"",s=p?p[1]:"",r=isFinite(parseInt(s)),a=isFinite(parseInt(t));r&&d.push(`width="${s}"`),a&&d.push(`height="${t}"`)}return{href:i,dimensions:d}}e.parseHrefAndDimensions=b}),define(De[114],Ie([1,0,18,34,15,14,24,9]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(r,a){const{os:v,tildify:_,relative:c}=a;if(c){const f=g(r,c,v);if(typeof f=="string")return f}let u=r.fsPath;if(v===1&&!R.isWindows?u=u.replace(/\//g,"\\"):v!==1&&R.isWindows&&(u=u.replace(/\\/g,"/")),v!==1&&_?.userHome){const f=_.userHome.fsPath;let n;r.scheme!==_.userHome.scheme&&r.path.startsWith(l.posix.sep)?n=_.userHome.with({path:r.path}).fsPath:n=r.fsPath,u=w(n,f,v)}return(v===1?l.win32:l.posix).normalize(L(u,v===1))}e.getPathLabel=y;function g(r,a,v){const _=v===1?l.win32:l.posix,c=v===3?T.extUri:T.extUriIgnorePathCase,u=a.getWorkspace(),m=(0,o.firstOrDefault)(u.folders);if(!m)return;r.scheme!==m.uri.scheme&&r.path.startsWith(l.posix.sep)&&(r=m.uri.with({path:r.path}));const f=a.getWorkspaceFolder(r);if(!f)return;let n;if(c.isEqual(f.uri,r)?n="":n=c.relativePath(f.uri,r)??"",n&&(n=_.normalize(n)),u.folders.length>1&&!a.noPrefix){const D=f.name?f.name:c.basenameOrAuthority(f.uri);n=n?`${D} \u2022 ${n}`:D}return n}function L(r,a=R.isWindows){return(0,A.hasDriveLetter)(r,a)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=L;let I=Object.create(null);function w(r,a,v=R.OS){if(v===1||!r||!a)return r;let _=I.original===a?I.normalized:void 0;_||(_=a,R.isWindows&&(_=(0,A.toSlashes)(_)),_=`${(0,P.rtrim)(_,l.posix.sep)}${l.posix.sep}`,I={original:a,normalized:_});let c=r;return R.isWindows&&(c=(0,A.toSlashes)(c)),(v===3?c.startsWith(_):(0,P.startsWithIgnoreCase)(c,_))?`~/${c.substr(_.length)}`:r}e.tildify=w;function k(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=k;const C="\u2026",b="\\\\",i="~";function d(r,a=l.sep){const v=new Array(r.length);let _=!1;for(let c=0;c<r.length;c++){const u=r[c];if(u===""){v[c]=`.${a}`;continue}if(!u){v[c]=u;continue}_=!0;let m="",f=u;f.indexOf(b)===0?(m=f.substr(0,f.indexOf(b)+b.length),f=f.substr(f.indexOf(b)+b.length)):f.indexOf(a)===0?(m=f.substr(0,f.indexOf(a)+a.length),f=f.substr(f.indexOf(a)+a.length)):f.indexOf(i)===0&&(m=f.substr(0,f.indexOf(i)+i.length),f=f.substr(f.indexOf(i)+i.length));const n=f.split(a);for(let D=1;_&&D<=n.length;D++)for(let M=n.length-D;_&&M>=0;M--){_=!1;let W=n.slice(M,M+D).join(a);for(let $=0;!_&&$<r.length;$++)if($!==c&&r[$]&&r[$].indexOf(W)>-1){const N=M+D===n.length,U=M>0&&r[$].indexOf(a)>-1?a+W:W,q=r[$].endsWith(U);_=!N||q}if(!_){let $="";(n[0].endsWith(":")||m!=="")&&(M===1&&(M=0,D++,W=n[0]+a+W),M>0&&($=n[0]+a),$=m+$),M>0&&($=$+C+a),$=$+W,M+D<n.length&&($=$+a+C),v[c]=$}}_&&(v[c]=u)}return v}e.shorten=d;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function S(r,a=Object.create(null)){const v=[];let _=!1,c="";for(const u of r)if(u==="$"||_&&u==="{")c&&v.push({value:c,type:h.TEXT}),c="",_=!0;else if(u==="}"&&_){const m=a[c];if(typeof m=="string")m.length&&v.push({value:m,type:h.VARIABLE});else if(m){const f=v[v.length-1];(!f||f.type!==h.SEPARATOR)&&v.push({value:m.label,type:h.SEPARATOR})}c="",_=!1}else c+=u;return c&&!_&&v.push({value:c,type:h.TEXT}),v.filter((u,m)=>{if(u.type===h.SEPARATOR){const f=v[m-1],n=v[m+1];return[f,n].every(D=>D&&(D.type===h.VARIABLE||D.type===h.TEXT)&&D.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=S;function E(r,a){return R.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):r.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function p(r,a){return R.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):R.isWindows?r.replace(/&&|&/g,v=>v==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function s(r){const a=r.indexOf("/")!==-1?l.posix:l.win32,v=a.basename(r),_=a.dirname(r);return v.length?{name:v,parentPath:_}:{name:_,parentPath:""}}e.splitName=s}),define(De[115],Ie([1,0,22,2]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(I){return I.toJSON()}class R{constructor(w){this._uriTransformer=w}transformIncoming(w){const k=this._uriTransformer.transformIncoming(w);return k===w?w:l(A.URI.from(k))}transformOutgoing(w){const k=this._uriTransformer.transformOutgoing(w);return k===w?w:l(A.URI.from(k))}transformOutgoingURI(w){const k=this._uriTransformer.transformOutgoing(w);return k===w?w:A.URI.from(k)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function T(I,w,k){if(!I||k>200)return null;if(typeof I=="object"){if(I instanceof A.URI)return w.transformOutgoing(I);for(const C in I)if(Object.hasOwnProperty.call(I,C)){const b=T(I[C],w,k+1);b!==null&&(I[C]=b)}}return null}function P(I,w){const k=T(I,w,0);return k===null?I:k}e.transformOutgoingURIs=P;function y(I,w,k,C){if(!I||C>200)return null;if(typeof I=="object"){if(I.$mid===1)return k?A.URI.revive(w.transformIncoming(I)):w.transformIncoming(I);if(I instanceof o.VSBuffer)return null;for(const b in I)if(Object.hasOwnProperty.call(I,b)){const i=y(I[b],w,k,C+1);i!==null&&(I[b]=i)}}return null}function g(I,w){const k=y(I,w,!1,0);return k===null?I:k}e.transformIncomingURIs=g;function L(I,w){const k=y(I,w,!0,0);return k===null?I:k}e.transformAndReviveIncomingURIs=L}),define(De[29],Ie([1,0,72,55,330,19,34,88,15,14,24,2]),function(oe,e,o,A,l,R,T,P,y,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function k(U,q=w.UNLINK){if((0,T.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return q===w.UNLINK?b(U):C(U)}async function C(U){try{const q=(0,T.randomPath)((0,A.tmpdir)());try{await o.promises.rename(U,q)}catch(F){return F.code==="ENOENT"?void 0:b(U)}b(q).catch(F=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function b(U){return(0,l.promisify)(o.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function i(U){if((0,T.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=i;async function d(U,q){return E(await(q?h(U):(0,l.promisify)(o.readdir)(U)))}async function h(U){try{return await(0,l.promisify)(o.readdir)(U,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const q=[],F=await d(U);for(const B of F){let Q=!1,J=!1,X=!1;try{const ie=await e.Promises.lstat((0,y.join)(U,B));Q=ie.isFile(),J=ie.isDirectory(),X=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}q.push({name:B,isFile:()=>Q,isDirectory:()=>J,isSymbolicLink:()=>X})}return q}function S(U){return E(o.readdirSync(U))}e.readdirSync=S;function E(U){return U.map(q=>typeof q=="string"?g.isMacintosh?(0,P.normalizeNFC)(q):q:(q.name=g.isMacintosh?(0,P.normalizeNFC)(q.name):q.name,q))}async function p(U){const q=await d(U),F=[];for(const B of q)await s.existsDirectory((0,y.join)(U,B))&&F.push(B);return F}function t(U,q=1e3){return new Promise(F=>{let B=!1;const Q=setInterval(()=>{B||(B=!0,o.access(U,J=>{B=!1,J&&(clearInterval(Q),F(void 0))}))},q)})}e.whenDeleted=t;var s;(function(U){async function q(Q){let J;try{if(J=await e.Promises.lstat(Q),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(Q),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(g.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Q)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw ie}throw X}}U.stat=q;async function F(Q){try{const{stat:J,symbolicLink:X}=await U.stat(Q);return J.isFile()&&X?.dangling!==!0}catch{}return!1}U.existsFile=F;async function B(Q){try{const{stat:J,symbolicLink:X}=await U.stat(Q);return J.isDirectory()&&X?.dangling!==!0}catch{}return!1}U.existsDirectory=B})(s||(e.SymlinkSupport=s={}));const r=new R.ResourceQueue;function a(U,q,F){return r.queueFor(I.URI.file(U),L.extUriBiasedIgnorePathCase).queue(()=>{const B=m(F);return new Promise((Q,J)=>c(U,q,B,X=>X?J(X):Q()))})}let v=!0;function _(U){v=U}e.configureFlushOnWrite=_;function c(U,q,F,B){if(!v)return o.writeFile(U,q,{mode:F.mode,flag:F.flag},B);o.open(U,F.flag,F.mode,(Q,J)=>{if(Q)return B(Q);o.writeFile(J,q,X=>{if(X)return o.close(J,()=>B(X));o.fdatasync(J,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),_(!1)),o.close(J,ae=>B(ae))))})})}function u(U,q,F){const B=m(F);if(!v)return o.writeFileSync(U,q,{mode:B.mode,flag:B.flag});const Q=o.openSync(U,B.flag,B.mode);try{o.writeFileSync(Q,q);try{o.fdatasyncSync(Q)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),_(!1)}}finally{o.closeSync(Q)}}e.writeFileSync=u;function m(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function f(U,q){if(U!==q)try{await e.Promises.rename(U,q)}catch(F){if(U.toLowerCase()!==q.toLowerCase()&&F.code==="EXDEV"||U.endsWith("."))await n(U,q,{preserveSymlinks:!1}),await k(U,w.MOVE);else throw F}}async function n(U,q,F){return M(U,q,{root:{source:U,target:q},options:F,handledSourcePaths:new Set})}const D=511;async function M(U,q,F){if(F.handledSourcePaths.has(U))return;F.handledSourcePaths.add(U);const{stat:B,symbolicLink:Q}=await s.stat(U);if(Q){if(F.options.preserveSymlinks)try{return await N(U,q,F)}catch(J){console.warn("[node.js fs] copy of symlink failed: ",J)}if(Q.dangling)return}return B.isDirectory()?W(U,q,B.mode&D,F):$(U,q,B.mode&D)}async function W(U,q,F,B){await e.Promises.mkdir(q,{recursive:!0,mode:F});const Q=await d(U);for(const J of Q)await M((0,y.join)(U,J),(0,y.join)(q,J),B)}async function $(U,q,F){await e.Promises.copyFile(U,q),await e.Promises.chmod(q,F)}async function N(U,q,F){let B=await e.Promises.readlink(U);(0,T.isEqualOrParent)(B,F.root.source,!g.isLinux)&&(B=(0,y.join)(F.root.target,B.substr(F.root.source.length+1))),await e.Promises.symlink(B,q)}e.Promises=new class{get access(){return(0,l.promisify)(o.access)}get stat(){return(0,l.promisify)(o.stat)}get lstat(){return(0,l.promisify)(o.lstat)}get utimes(){return(0,l.promisify)(o.utimes)}get read(){return(U,q,F,B,Q)=>new Promise((J,X)=>{o.read(U,q,F,B,Q,(ie,ae,we)=>ie?X(ie):J({bytesRead:ae,buffer:we}))})}get readFile(){return(0,l.promisify)(o.readFile)}get write(){return(U,q,F,B,Q)=>new Promise((J,X)=>{o.write(U,q,F,B,Q,(ie,ae,we)=>ie?X(ie):J({bytesWritten:ae,buffer:we}))})}get appendFile(){return(0,l.promisify)(o.appendFile)}get fdatasync(){return(0,l.promisify)(o.fdatasync)}get truncate(){return(0,l.promisify)(o.truncate)}get rename(){return(0,l.promisify)(o.rename)}get copyFile(){return(0,l.promisify)(o.copyFile)}get open(){return(0,l.promisify)(o.open)}get close(){return(0,l.promisify)(o.close)}get symlink(){return(0,l.promisify)(o.symlink)}get readlink(){return(0,l.promisify)(o.readlink)}get chmod(){return(0,l.promisify)(o.chmod)}get mkdir(){return(0,l.promisify)(o.mkdir)}get unlink(){return(0,l.promisify)(o.unlink)}get rmdir(){return(0,l.promisify)(o.rmdir)}get realpath(){return(0,l.promisify)(o.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return p}get writeFile(){return a}get rm(){return k}get move(){return f}get copy(){return n}}}),define(De[116],Ie([1,0,72,15,14,9,29]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(w){if(l.isLinux)return w;const k=(0,A.dirname)(w);if(w===k)return w;const C=((0,A.basename)(w)||w).toLowerCase();try{const i=(0,T.readdirSync)(k).filter(d=>d.toLowerCase()===C);if(i.length===1){const d=P(k);if(d)return(0,A.join)(d,i[0])}else if(i.length>1){const d=i.indexOf(C);if(d>=0){const h=P(k);if(h)return(0,A.join)(h,i[d])}}}catch{}return null}e.realcaseSync=P;async function y(w){if(l.isLinux)return w;const k=(0,A.dirname)(w);if(w===k)return w;const C=((0,A.basename)(w)||w).toLowerCase();try{const i=(await T.Promises.readdir(k)).filter(d=>d.toLowerCase()===C);if(i.length===1){const d=await y(k);if(d)return(0,A.join)(d,i[0])}else if(i.length>1){const d=i.indexOf(C);if(d>=0){const h=await y(k);if(h)return(0,A.join)(h,i[d])}}}catch{}return null}e.realcase=y;async function g(w){try{return await T.Promises.realpath(w)}catch{const C=I(w);return await T.Promises.access(C,o.constants.R_OK),C}}e.realpath=g;function L(w){try{return o.realpathSync(w)}catch{const C=I(w);return o.accessSync(C,o.constants.R_OK),C}}e.realpathSync=L;function I(w){return(0,R.rtrim)((0,A.normalize)(w),A.sep)}}),define(De[117],Ie([1,0,15,14,33,110,10,29]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(I=l.env){return I.comspec||"cmd.exe"}e.getWindowsShell=y;function g(I){let w=[],k=!1;const C=function(b){if(k){w.push(b);return}(!I.send(b,d=>{if(d&&console.error(d),k=!1,w.length>0){const h=w.slice(0);w=[],h.forEach(S=>C(S))}})||A.isWindows)&&(k=!0)};return{send:C}}e.createQueuedSender=g;var L;(function(I){async function w(k,C,b){if(o.isAbsolute(k))return k;if(C===void 0&&(C=l.cwd()),o.dirname(k)!=="."||(b===void 0&&T.isString(l.env.PATH)&&(b=l.env.PATH.split(o.delimiter)),b===void 0||b.length===0))return o.join(C,k);async function d(h){if(await P.Promises.exists(h)){let S;try{S=await P.Promises.stat(h)}catch(E){E.message.startsWith("EACCES")&&(S=await P.Promises.lstat(h))}return S?!S.isDirectory():!1}return!1}for(const h of b){let S;if(o.isAbsolute(h)?S=o.join(h,k):S=o.join(C,h,k),await d(S))return S;let E=S+".com";if(await d(E)||(E=S+".exe",await d(E)))return E}return o.join(C,k)}I.findExecutable=w})(L||(e.win32=L={}))});var Ve=this&&this.__decorate||function(oe,e,o,A){var l=arguments.length,R=l<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,o):A,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(oe,e,o,A);else for(var P=oe.length-1;P>=0;P--)(T=oe[P])&&(R=(l<3?T(R):l>3?T(e,o,R):T(e,o))||R);return l>3&&R&&Object.defineProperty(e,o,R),R};define(De[118],Ie([1,0,18,19,22,21,64,8,3,6,71,9,10]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var k;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(k||(k={}));function C(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(b||(b={}));function i(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(d||(d={}));function h(J){let X=0;for(let ie=0;;ie+=7){const ae=J.read(1);if(X|=(ae.buffer[0]&127)<<ie,!(ae.buffer[0]&128))return X}}const S=r(0);function E(J,X){if(X===0){J.write(S);return}let ie=0;for(let we=X;we!==0;we=we>>>7)ie++;const ae=l.VSBuffer.alloc(ie);for(let we=0;X!==0;we++)ae.buffer[we]=X&127,X=X>>>7,X>0&&(ae.buffer[we]|=128);J.write(ae)}class p{constructor(X){this.buffer=X,this.pos=0}read(X){const ie=this.buffer.slice(this.pos,this.pos+X);return this.pos+=ie.byteLength,ie}}e.BufferReader=p;class t{constructor(){this.buffers=[]}get buffer(){return l.VSBuffer.concat(this.buffers)}write(X){this.buffers.push(X)}}e.BufferWriter=t;var s;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(s||(s={}));function r(J){const X=l.VSBuffer.alloc(1);return X.writeUInt8(J,0),X}const a={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},v=typeof Buffer<"u";function _(J,X){if(typeof X>"u")J.write(a.Undefined);else if(typeof X=="string"){const ie=l.VSBuffer.fromString(X);J.write(a.String),E(J,ie.byteLength),J.write(ie)}else if(v&&Buffer.isBuffer(X)){const ie=l.VSBuffer.wrap(X);J.write(a.Buffer),E(J,ie.byteLength),J.write(ie)}else if(X instanceof l.VSBuffer)J.write(a.VSBuffer),E(J,X.byteLength),J.write(X);else if(Array.isArray(X)){J.write(a.Array),E(J,X.length);for(const ie of X)_(J,ie)}else if(typeof X=="number"&&(X|0)===X)J.write(a.Uint),E(J,X);else{const ie=l.VSBuffer.fromString(JSON.stringify(X));J.write(a.Object),E(J,ie.byteLength),J.write(ie)}}e.serialize=_;function c(J){switch(J.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return J.read(h(J)).toString();case s.Buffer:return J.read(h(J)).buffer;case s.VSBuffer:return J.read(h(J));case s.Array:{const ie=h(J),ae=[];for(let we=0;we<ie;we++)ae.push(c(J));return ae}case s.Object:return JSON.parse(J.read(h(J)).toString());case s.Int:return h(J)}}e.deserialize=c;class u{constructor(X,ie,ae=null,we=1e3){this.protocol=X,this.ctx=ie,this.logger=ae,this.timeoutDelay=we,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(he=>this.onRawMessage(he)),this.sendResponse({type:200})}registerChannel(X,ie){this.channels.set(X,ie),setTimeout(()=>this.flushPendingRequests(X),0)}sendResponse(X){switch(X.type){case 200:{const ie=this.send([X.type]);this.logger?.logOutgoing(ie,0,1,i(X.type));return}case 201:case 202:case 204:case 203:{const ie=this.send([X.type,X.id],X.data);this.logger?.logOutgoing(ie,X.id,1,i(X.type),X.data);return}}}send(X,ie=void 0){const ae=new t;return _(ae,X),_(ae,ie),this.sendBuffer(ae.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onRawMessage(X){const ie=new p(X),ae=c(ie),we=c(ie),he=ae[0];switch(he){case 100:return this.logger?.logIncoming(X.byteLength,ae[1],1,`${C(he)}: ${ae[2]}.${ae[3]}`,we),this.onPromise({type:he,id:ae[1],channelName:ae[2],name:ae[3],arg:we});case 102:return this.logger?.logIncoming(X.byteLength,ae[1],1,`${C(he)}: ${ae[2]}.${ae[3]}`,we),this.onEventListen({type:he,id:ae[1],channelName:ae[2],name:ae[3],arg:we});case 101:return this.logger?.logIncoming(X.byteLength,ae[1],1,`${C(he)}`),this.disposeActiveRequest({type:he,id:ae[1]});case 103:return this.logger?.logIncoming(X.byteLength,ae[1],1,`${C(he)}`),this.disposeActiveRequest({type:he,id:ae[1]})}}onPromise(X){const ie=this.channels.get(X.channelName);if(!ie){this.collectPendingRequest(X);return}const ae=new R.CancellationTokenSource;let we;try{we=ie.call(this.ctx,X.name,X.arg,ae.token)}catch(V){we=Promise.reject(V)}const he=X.id;we.then(V=>{this.sendResponse({id:he,data:V,type:201}),this.activeRequests.delete(X.id)},V=>{V instanceof Error?this.sendResponse({id:he,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.sendResponse({id:he,data:V,type:203}),this.activeRequests.delete(X.id)});const fe=(0,g.toDisposable)(()=>ae.cancel());this.activeRequests.set(X.id,fe)}onEventListen(X){const ie=this.channels.get(X.channelName);if(!ie){this.collectPendingRequest(X);return}const ae=X.id,he=ie.listen(this.ctx,X.name,X.arg)(fe=>this.sendResponse({id:ae,data:fe,type:204}));this.activeRequests.set(X.id,he)}disposeActiveRequest(X){const ie=this.activeRequests.get(X.id);ie&&(ie.dispose(),this.activeRequests.delete(X.id))}collectPendingRequest(X){let ie=this.pendingRequests.get(X.channelName);ie||(ie=[],this.pendingRequests.set(X.channelName,ie));const ae=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.sendResponse({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ie.push({request:X,timeoutTimer:ae})}flushPendingRequests(X){const ie=this.pendingRequests.get(X);if(ie){for(const ae of ie)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.onPromise(ae.request);break;case 102:this.onEventListen(ae.request);break}this.pendingRequests.delete(X)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var m;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class f{constructor(X,ie=null){this.protocol=X,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ae=>this.onBuffer(ae)),this.logger=ie}getChannel(X){const ie=this;return{call(ae,we,he){return ie.isDisposed?Promise.reject(new P.CancellationError):ie.requestPromise(X,ae,we,he)},listen(ae,we){return ie.isDisposed?y.Event.None:ie.requestEvent(X,ae,we)}}}requestPromise(X,ie,ae,we=R.CancellationToken.None){const he=this.lastRequestId++,V={id:he,type:100,channelName:X,name:ie,arg:ae};if(we.isCancellationRequested)return Promise.reject(new P.CancellationError);let x;return new Promise((pe,_e)=>{if(we.isCancellationRequested)return _e(new P.CancellationError);const re=()=>{const ce=le=>{switch(le.type){case 201:this.handlers.delete(he),pe(le.data);break;case 202:{this.handlers.delete(he);const ue=new Error(le.data.message);ue.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,ue.name=le.data.name,_e(ue);break}case 203:this.handlers.delete(he),_e(le.data);break}};this.handlers.set(he,ce),this.sendRequest(V)};let ne=null;this.state===d.Idle?re():(ne=(0,A.createCancelablePromise)(ce=>this.whenInitialized()),ne.then(()=>{ne=null,re()}));const de=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:he,type:101}),_e(new P.CancellationError)},ee=we.onCancellationRequested(de);x=(0,g.combinedDisposable)((0,g.toDisposable)(de),ee),this.activeRequests.add(x)}).finally(()=>{this.activeRequests.delete(x)})}requestEvent(X,ie,ae){const we=this.lastRequestId++,fe={id:we,type:102,channelName:X,name:ie,arg:ae};let V=null;const x=new y.Emitter({onWillAddFirstListener:()=>{V=(0,A.createCancelablePromise)(pe=>this.whenInitialized()),V.then(()=>{V=null,this.activeRequests.add(x),this.sendRequest(fe)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.activeRequests.delete(x),this.sendRequest({id:we,type:103}))}}),Z=pe=>x.fire(pe.data);return this.handlers.set(we,Z),x.event}sendRequest(X){switch(X.type){case 100:case 102:{const ie=this.send([X.type,X.id,X.channelName,X.name],X.arg);this.logger?.logOutgoing(ie,X.id,0,`${C(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const ie=this.send([X.type,X.id]);this.logger?.logOutgoing(ie,X.id,0,C(X.type));return}}}send(X,ie=void 0){const ae=new t;return _(ae,X),_(ae,ie),this.sendBuffer(ae.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onBuffer(X){const ie=new p(X),ae=c(ie),we=c(ie),he=ae[0];switch(he){case 200:return this.logger?.logIncoming(X.byteLength,0,0,i(he)),this.onResponse({type:ae[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(X.byteLength,ae[1],0,i(he),we),this.onResponse({type:ae[0],id:ae[1],data:we})}}onResponse(X){if(X.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(X.id)?.(X)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=f,Ve([T.memoize],f.prototype,"onDidInitializePromise",null);class n{get connections(){const X=[];return this._connections.forEach(ie=>X.push(ie)),X}constructor(X){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,X(({protocol:ie,onDidClientDisconnect:ae})=>{y.Event.once(ie.onMessage)(he=>{const fe=new p(he),V=c(fe),x=new u(ie,V),Z=new f(ie);this.channels.forEach((_e,re)=>x.registerChannel(re,_e));const pe={channelServer:x,channelClient:Z,ctx:V};this._connections.add(pe),this._onDidAddConnection.fire(pe),ae(()=>{x.dispose(),Z.dispose(),this._connections.delete(pe),this._onDidRemoveConnection.fire(pe)})})})}getChannel(X,ie){const ae=this;return{call(we,he,fe){let V;if((0,w.isFunction)(ie)){const Z=(0,o.getRandomElement)(ae.connections.filter(ie));V=Z?Promise.resolve(Z):y.Event.toPromise(y.Event.filter(ae.onDidAddConnection,ie))}else V=ie.routeCall(ae,we,he);const x=V.then(Z=>Z.channelClient.getChannel(X));return M(x).call(we,he,fe)},listen(we,he){if((0,w.isFunction)(ie))return ae.getMulticastEvent(X,ie,we,he);const fe=ie.routeEvent(ae,we,he).then(V=>V.channelClient.getChannel(X));return M(fe).listen(we,he)}}}getMulticastEvent(X,ie,ae,we){const he=this;let fe=new g.DisposableStore;const V=new y.Emitter({onWillAddFirstListener:()=>{fe=new g.DisposableStore;const x=new y.EventMultiplexer,Z=new Map,pe=re=>{const de=re.channelClient.getChannel(X).listen(ae,we),ee=x.add(de);Z.set(re,ee)},_e=re=>{const ne=Z.get(re);ne&&(ne.dispose(),Z.delete(re))};he.connections.filter(ie).forEach(pe),y.Event.filter(he.onDidAddConnection,ie)(pe,void 0,fe),he.onDidRemoveConnection(_e,void 0,fe),x.event(V.fire,V,fe),fe.add(x)},onDidRemoveLastListener:()=>{fe.dispose()}});return V.event}registerChannel(X,ie){this.channels.set(X,ie),this._connections.forEach(ae=>{ae.channelServer.registerChannel(X,ie)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=n;class D{constructor(X,ie,ae=null){const we=new t;_(we,ie),X.send(we.buffer),this.channelClient=new f(X,ae),this.channelServer=new u(X,ie,ae)}getChannel(X){return this.channelClient.getChannel(X)}registerChannel(X,ie){this.channelServer.registerChannel(X,ie)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function M(J){return{call(X,ie,ae){return J.then(we=>we.call(X,ie,ae))},listen(X,ie){const ae=new y.Relay;return J.then(we=>ae.input=we.listen(X,ie)),ae.event}}}e.getDelayedChannel=M;function W(J){let X=!1;return{call(ie,ae,we){return X?J.call(ie,ae,we):(0,A.timeout)(0).then(()=>X=!0).then(()=>J.call(ie,ae,we))},listen(ie,ae){if(X)return J.listen(ie,ae);const we=new y.Relay;return(0,A.timeout)(0).then(()=>X=!0).then(()=>we.input=J.listen(ie,ae)),we.event}}}e.getNextTickChannel=W;class ${constructor(X){this.fn=X}routeCall(X){return this.route(X)}routeEvent(X){return this.route(X)}async route(X){for(const ie of X.connections)if(await Promise.resolve(this.fn(ie.ctx)))return Promise.resolve(ie);return await y.Event.toPromise(X.onDidAddConnection),await this.route(X)}}e.StaticRouter=$;var N;(function(J){function X(he,fe){const V=he,x=fe&&fe.disableMarshalling,Z=new Map;for(const pe in V)ae(pe)&&Z.set(pe,y.Event.buffer(V[pe],!0));return new class{listen(pe,_e,re){const ne=Z.get(_e);if(ne)return ne;if(we(_e)){const de=V[_e];if(typeof de=="function")return de.call(V,re)}throw new Error(`Event not found: ${_e}`)}call(pe,_e,re){const ne=V[_e];if(typeof ne=="function"){if(!x&&Array.isArray(re))for(let de=0;de<re.length;de++)re[de]=(0,L.revive)(re[de]);return ne.apply(V,re)}throw new Error(`Method not found: ${_e}`)}}}J.fromService=X;function ie(he,fe){const V=fe&&fe.disableMarshalling;return new Proxy({},{get(x,Z){if(typeof Z=="string")return fe?.properties?.has(Z)?fe.properties.get(Z):we(Z)?function(pe){return he.listen(Z,pe)}:ae(Z)?he.listen(Z):async function(...pe){let _e;fe&&!(0,w.isUndefinedOrNull)(fe.context)?_e=[fe.context,...pe]:_e=pe;const re=await he.call(Z,_e);return V?re:(0,L.revive)(re)};throw new Error(`Property not found: ${String(Z)}`)}})}J.toService=ie;function ae(he){return he[0]==="o"&&he[1]==="n"&&I.isUpperAsciiLetter(he.charCodeAt(2))}function we(he){return/^onDynamic/.test(he)&&I.isUpperAsciiLetter(he.charCodeAt(9))}})(N||(e.ProxyChannel=N={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const X=J.toString();if(X!=="[object Object]")return X}return J}function F(J){return Array.isArray(J)?J.map(q):q(J)}function B(J,X,ie,ae,we,he,fe){fe=F(fe);const V=U[we],x=V[ae%V.length];let Z=[`%c[${J}]%c[${String(X).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${he}`,"color: darkgreen","color: grey","color: grey",`color: ${x}`];/\($/.test(he)?(Z=Z.concat(fe),Z.push(")")):Z.push(fe),console.log.apply(console,Z)}class Q{constructor(X,ie){this._outgoingPrefix=X,this._incomingPrefix=ie,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(X,ie,ae,we,he){this._totalOutgoing+=X,B(this._outgoingPrefix,this._totalOutgoing,X,ie,ae,we,he)}logIncoming(X,ie,ae,we,he){this._totalIncoming+=X,B(this._incomingPrefix,this._totalIncoming,X,ie,ae,we,he)}}e.IPCLogger=Q}),define(De[119],Ie([1,0,19,22,3,6,118]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(f){f.Created="created",f.Read="read",f.Write="write",f.Open="open",f.Error="error",f.Close="close",f.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",f.NodeEndReceived="nodeEndReceived",f.NodeEndSent="nodeEndSent",f.NodeDrainBegin="nodeDrainBegin",f.NodeDrainEnd="nodeDrainEnd",f.zlibInflateError="zlibInflateError",f.zlibInflateData="zlibInflateData",f.zlibInflateInitialWrite="zlibInflateInitialWrite",f.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",f.zlibInflateWrite="zlibInflateWrite",f.zlibInflateFlushFired="zlibInflateFlushFired",f.zlibDeflateError="zlibDeflateError",f.zlibDeflateData="zlibDeflateData",f.zlibDeflateWrite="zlibDeflateWrite",f.zlibDeflateFlushFired="zlibDeflateFlushFired",f.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",f.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",f.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",f.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",f.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",f.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",f.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",f.ProtocolHeaderRead="protocolHeaderRead",f.ProtocolMessageRead="protocolMessageRead",f.ProtocolHeaderWrite="protocolHeaderWrite",f.ProtocolMessageWrite="protocolMessageWrite",f.ProtocolWrite="protocolWrite"})(P||(e.SocketDiagnosticsEventType=P={}));var y;(function(f){f.enableDiagnostics=!1,f.records=[];const n=new WeakMap;let D=0;function M($,N){if(!n.has($)){const U=String(++D);n.set($,U)}return n.get($)}function W($,N,U,q){if(!f.enableDiagnostics)return;const F=M($,N);if(q instanceof A.VSBuffer||q instanceof Uint8Array||q instanceof ArrayBuffer||ArrayBuffer.isView(q)){const B=A.VSBuffer.alloc(q.byteLength);B.set(q),f.records.push({timestamp:Date.now(),id:F,label:N,type:U,buff:B})}else f.records.push({timestamp:Date.now(),id:F,label:N,type:U,data:q})}f.traceSocketEvent=W})(y||(e.SocketDiagnostics=y={}));var g;(function(f){f[f.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",f[f.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g||(e.SocketCloseEventType=g={}));let L=null;function I(){return L||(L=A.VSBuffer.alloc(0)),L}class w{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,D){if(n===0)return I();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const N=this._chunks[0];return D&&(this._chunks.shift(),this._totalLength-=n),N}if(this._chunks[0].byteLength>n){const N=this._chunks[0].slice(0,n);return D&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),N}const M=A.VSBuffer.alloc(n);let W=0,$=0;for(;n>0;){const N=this._chunks[$];if(N.byteLength>n){const U=N.slice(0,n);M.set(U,W),W+=n,D&&(this._chunks[$]=N.slice(n),this._totalLength-=n),n-=n}else M.set(N,W),W+=N.byteLength,D?(this._chunks.shift(),this._totalLength-=N.byteLength):$++,n-=N.byteLength}return M}}e.ChunkStream=w;var k;(function(f){f[f.None=0]="None",f[f.Regular=1]="Regular",f[f.Control=2]="Control",f[f.Ack=3]="Ack",f[f.Disconnect=5]="Disconnect",f[f.ReplayRequest=6]="ReplayRequest",f[f.Pause=7]="Pause",f[f.Resume=8]="Resume",f[f.KeepAlive=9]="KeepAlive",f[f.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",f[f.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(k||(k={}));function C(f){switch(f){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var b;(function(f){f[f.HeaderLength=13]="HeaderLength",f[f.AcknowledgeTime=2e3]="AcknowledgeTime",f[f.TimeoutTime=2e4]="TimeoutTime",f[f.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",f[f.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",f[f.KeepAliveSendTime=5e3]="KeepAliveSendTime",f[f.LatencySampleTime=6e4]="LatencySampleTime",f[f.LatencySampleCount=5]="LatencySampleCount",f[f.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",f[f.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(b||(e.ProtocolConstants=b={}));class i{constructor(n,D,M,W){this.type=n,this.id=D,this.ack=M,this.data=W,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends R.Disposable{constructor(n){super(),this._onMessage=this._register(new l.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(D=>this.acceptChunk(D))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const D=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=D.readUInt32BE(9),this._state.messageType=D.readUInt8(0),this._state.id=D.readUInt32BE(1),this._state.ack=D.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:C(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const M=this._state.messageType,W=this._state.id,$=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",D),this._onMessage.fire(new i(M,W,$,D)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const D=A.VSBuffer.alloc(13);D.writeUInt8(n.type,0),D.writeUInt32BE(n.id,1),D.writeUInt32BE(n.ack,5),D.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:C(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(D,n.data)}_bufferAdd(n,D){const M=this._totalLength===0;return this._data.push(n,D),this._totalLength+=n.byteLength+D.byteLength,M}_bufferTake(){const n=A.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,D){this._bufferAdd(n,D)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class S extends R.Disposable{constructor(n){super(),this._onMessage=new l.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new l.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(D=>{D.type===1&&this._onMessage.fire(D.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new i(1,0,0,n))}}e.Protocol=S;class E extends T.IPCClient{static fromSocket(n,D){return new E(new S(n),D)}get onDidDispose(){return this.protocol.onDidDispose}constructor(n,D,M=null){super(n,D,M),this.protocol=n}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=E;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new l.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class t{constructor(n){this.data=n,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let n=0,D=this._first;for(;D;)D=D.next,n++;return n}peek(){return this._first?this._first.data:null}toArray(){const n=[];let D=0,M=this._first;for(;M;)n[D++]=M.data,M=M.next;return n}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const D=new t(n);if(!this._first){this._first=D,this._last=D;return}this._last.next=D,this._last=D}}class r{static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const n=Date.now();for(let D=0;D<r._HISTORY_LENGTH;D++)this.lastRuns[D]=n-1e3*D;setInterval(()=>{for(let D=r._HISTORY_LENGTH;D>=1;D--)this.lastRuns[D]=this.lastRuns[D-1];this.lastRuns[0]=Date.now()},1e3)}load(){const n=Date.now(),D=(1+r._HISTORY_LENGTH)*1e3;let M=0;for(let W=0;W<r._HISTORY_LENGTH;W++)n-this.lastRuns[W]<=D&&M++;return 1-M/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;var a;(function(f){f[f.Good=0]="Good",f[f.Poor=1]="Poor"})(a||(e.ConnectionHealth=a={}));function v(f){switch(f){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=v;class _{constructor(n){this.connectionHealth=n}}e.ConnectionHealthChangedEvent=_;class c{constructor(n,D){this.roundTripTime=n,this.recentHighRoundTripCount=D}}e.HighRoundTripTimeEvent=c;class u{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(n){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new p,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new p,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=n.loadEstimator??r.getInstance(),this._measureRoundTripTime=n.measureRoundTripTime??!1,this._shouldSendKeepAlive=n.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new R.DisposableStore,this._socket=n.socket,this._socketWriter=this._socketDisposables.add(new h(this._socket)),this._socketReader=this._socketDisposables.add(new d(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(D=>this._receiveMessage(D))),this._socketDisposables.add(this._socket.onClose(D=>this._onSocketClose.fire(D))),this._socketLatencyMonitor=this._socketDisposables.add(new m),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(D=>this._sendLatencyMeasurementRequest(D))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(D=>this._onHighRoundTripTime.fire(D))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(D=>this._onDidChangeConnectionHealth.fire(D))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),n.initialChunk&&this._socketReader.acceptChunk(n.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new i(5,0,0,I());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new i(7,0,0,I());this._socketWriter.write(n)}sendResume(){const n=new i(8,0,0,I());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,D){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new R.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=this._socketDisposables.add(new h(this._socket)),this._socketReader=this._socketDisposables.add(new d(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(M=>this._receiveMessage(M))),this._socketDisposables.add(this._socket.onClose(M=>this._onSocketClose.fire(M))),this._socketLatencyMonitor=this._socketDisposables.add(new m),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(M=>this._sendLatencyMeasurementRequest(M))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(M=>this._onHighRoundTripTime.fire(M))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(M=>this._onDidChangeConnectionHealth.fire(M))),this._socketReader.acceptChunk(D)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const n=new i(3,0,this._incomingAckId,I());this._socketWriter.write(n);const D=this._outgoingUnackMsg.toArray();for(let M=0,W=D.length;M<W;M++)this._socketWriter.write(D[M]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const D=this._outgoingUnackMsg.peek();if(D&&D.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const D=Date.now();D-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=D,this._socketWriter.write(new i(6,0,0,I())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const D=this._outgoingUnackMsg.toArray();for(let M=0,W=D.length;M<W;M++)this._socketWriter.write(D[M]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(n.data);break}case 11:{this._socketLatencyMonitor.handleResponse(n.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const D=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const M=new i(1,D,this._incomingAckId,n);this._outgoingUnackMsg.push(M),this._isReconnecting||(this._socketWriter.write(M),this._recvAckCheck())}sendControl(n){const D=new i(2,0,0,n);this._socketWriter.write(D)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),D=Date.now()-n.writtenTime,M=Date.now()-this._socketReader.lastReadTime,W=Date.now()-this._lastSocketTimeoutTime;if(D>=2e4&&M>=2e4&&W>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:D,timeSinceLastReceivedSomeData:M});return}const $=Math.max(2e4-D,2e4-M,2e4-W,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},$)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new i(3,0,this._incomingAckId,I());this._socketWriter.write(n)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const n=new i(9,0,this._incomingAckId,I());this._socketWriter.write(n)}_sendLatencyMeasurementRequest(n){this._incomingAckId=this._incomingMsgId;const D=new i(10,0,this._incomingAckId,n);this._socketWriter.write(D)}_sendLatencyMeasurementResponse(n){this._incomingAckId=this._incomingMsgId;const D=new i(11,0,this._incomingAckId,n);this._socketWriter.write(D)}}e.PersistentProtocol=u;class m extends R.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new l.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new l.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new l.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new o.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},n=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const n=++this._lastLatencyMeasurementId,D=A.VSBuffer.alloc(4);D.writeUInt32BE(n,0),this._onSendLatencyRequest.fire(D)},6e4)}handleResponse(n){if(n.byteLength!==4)return;const D=n.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||D!==this._lastLatencyMeasurementId)return;const M=Date.now()-this._lastLatencyMeasurementSent,W=this._latencySampleIndex++;this._latencySamples[W%this._latencySamples.length]=M;const $=this._connectionHealth,N=this._latencySamples.filter(U=>U>=1e3).length;this._connectionHealth=N>=3?1:0,M>1e3&&this._onHighRoundTripTime.fire(new c(M,N)),$!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(De[167],Ie([1,0,39,15]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function l(R,T,P,y,g,L){if(Array.isArray(R)){let I=0;for(const w of R){const k=l(w,T,P,y,g,L);if(k===10)return k;k>I&&(I=k)}return I}else{if(typeof R=="string")return y?R==="*"?5:R===P?10:0:0;if(R){const{language:I,pattern:w,scheme:k,hasAccessToAllModels:C,notebookType:b}=R;if(!y&&!C)return 0;b&&g&&(T=g);let i=0;if(k)if(k===T.scheme)i=10;else if(k==="*")i=5;else return 0;if(I)if(I===P)i=10;else if(I==="*")i=Math.max(i,5);else return 0;if(b)if(b===L)i=10;else if(b==="*"&&L!==void 0)i=Math.max(i,5);else return 0;if(w){let d;if(typeof w=="string"?d=w:d={...w,base:(0,A.normalize)(w.base)},d===T.fsPath||(0,o.match)(d,T.fsPath))i=10;else return 0}return i}else return 0}}e.score=l}),define(De[168],Ie([1,0,9,54,157]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(P,y,g,L){this._uri=P,this._lines=y,this._eol=g,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const y=P.changes;for(const g of y)this._acceptDeleteRange(g.range),this._acceptInsertText(new A.Position(g.range.startLineNumber,g.range.startColumn),g.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,y=this._lines.length,g=new Uint32Array(y);for(let L=0;L<y;L++)g[L]=this._lines[L].length+P;this._lineStarts=new l.PrefixSumComputer(g)}}_setLineText(P,y){this._lines[P]=y,this._lineStarts&&this._lineStarts.setValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,y){if(y.length===0)return;const g=(0,o.splitLines)(y);if(g.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+g[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}g[g.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+g[0]);const L=new Uint32Array(g.length-1);for(let I=1;I<g.length;I++)this._lines.splice(P.lineNumber+I-1,0,g[I]),L[I-1]=g[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,L)}}e.MirrorTextModel=R}),define(De[169],Ie([1,0,9,154,54,32,108]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class y{constructor(h,S,E,p){this.searchString=h,this.isRegex=S,this.matchCase=E,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let h;this.isRegex?h=g(this.searchString):h=this.searchString.indexOf(`
`)>=0;let S=null;try{S=o.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:h,global:!0,unicode:!0})}catch{return null}if(!S)return null;let E=!this.isRegex&&!h;return E&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(E=this.matchCase),new T.SearchData(S,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,E?this.searchString:null)}}e.SearchParams=y;function g(d){if(!d||d.length===0)return!1;for(let h=0,S=d.length;h<S;h++){const E=d.charCodeAt(h);if(E===10)return!0;if(E===92){if(h++,h>=S)break;const p=d.charCodeAt(h);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=g;function L(d,h,S){if(!S)return new T.FindMatch(d,null);const E=[];for(let p=0,t=h.length;p<t;p++)E[p]=h[p];return new T.FindMatch(d,E)}e.createFindMatch=L;class I{constructor(h){const S=[];let E=0;for(let p=0,t=h.length;p<t;p++)h.charCodeAt(p)===10&&(S[E++]=p);this._lineFeedsOffsets=S}findLineFeedCountBeforeOffset(h){const S=this._lineFeedsOffsets;let E=0,p=S.length-1;if(p===-1||h<=S[0])return 0;for(;E<p;){const t=E+((p-E)/2>>0);S[t]>=h?p=t-1:S[t+1]>=h?(E=t,p=t):E=t+1}return E+1}}class w{static findMatches(h,S,E,p,t){const s=S.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(h,E,new i(s.wordSeparators,s.regex),p,t):this._doFindMatchesLineByLine(h,E,s,p,t):[]}static _getMultilineMatchRange(h,S,E,p,t,s){let r,a=0;p?(a=p.findLineFeedCountBeforeOffset(t),r=S+t+a):r=S+t;let v;if(p){const m=p.findLineFeedCountBeforeOffset(t+s.length)-a;v=r+s.length+m}else v=r+s.length;const _=h.getPositionAt(r),c=h.getPositionAt(v);return new R.Range(_.lineNumber,_.column,c.lineNumber,c.column)}static _doFindMatchesMultiline(h,S,E,p,t){const s=h.getOffsetAt(S.getStartPosition()),r=h.getValueInRange(S,1),a=h.getEOL()===`\r
`?new I(r):null,v=[];let _=0,c;for(E.reset(0);c=E.next(r);)if(v[_++]=L(this._getMultilineMatchRange(h,s,r,a,c.index,c[0]),c,p),_>=t)return v;return v}static _doFindMatchesLineByLine(h,S,E,p,t){const s=[];let r=0;if(S.startLineNumber===S.endLineNumber){const v=h.getLineContent(S.startLineNumber).substring(S.startColumn-1,S.endColumn-1);return r=this._findMatchesInLine(E,v,S.startLineNumber,S.startColumn-1,r,s,p,t),s}const a=h.getLineContent(S.startLineNumber).substring(S.startColumn-1);r=this._findMatchesInLine(E,a,S.startLineNumber,S.startColumn-1,r,s,p,t);for(let v=S.startLineNumber+1;v<S.endLineNumber&&r<t;v++)r=this._findMatchesInLine(E,h.getLineContent(v),v,0,r,s,p,t);if(r<t){const v=h.getLineContent(S.endLineNumber).substring(0,S.endColumn-1);r=this._findMatchesInLine(E,v,S.endLineNumber,0,r,s,p,t)}return s}static _findMatchesInLine(h,S,E,p,t,s,r,a){const v=h.wordSeparators;if(!r&&h.simpleSearch){const u=h.simpleSearch,m=u.length,f=S.length;let n=-m;for(;(n=S.indexOf(u,n+m))!==-1;)if((!v||b(v,S,f,n,m))&&(s[t++]=new T.FindMatch(new R.Range(E,n+1+p,E,n+1+m+p),null),t>=a))return t;return t}const _=new i(h.wordSeparators,h.regex);let c;_.reset(0);do if(c=_.next(S),c&&(s[t++]=L(new R.Range(E,c.index+1+p,E,c.index+1+c[0].length+p),c,r),t>=a))return t;while(c);return t}static findNextMatch(h,S,E,p){const t=S.parseSearchRequest();if(!t)return null;const s=new i(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(h,E,s,p):this._doFindNextMatchLineByLine(h,E,s,p)}static _doFindNextMatchMultiline(h,S,E,p){const t=new l.Position(S.lineNumber,1),s=h.getOffsetAt(t),r=h.getLineCount(),a=h.getValueInRange(new R.Range(t.lineNumber,t.column,r,h.getLineMaxColumn(r)),1),v=h.getEOL()===`\r
`?new I(a):null;E.reset(S.column-1);const _=E.next(a);return _?L(this._getMultilineMatchRange(h,s,a,v,_.index,_[0]),_,p):S.lineNumber!==1||S.column!==1?this._doFindNextMatchMultiline(h,new l.Position(1,1),E,p):null}static _doFindNextMatchLineByLine(h,S,E,p){const t=h.getLineCount(),s=S.lineNumber,r=h.getLineContent(s),a=this._findFirstMatchInLine(E,r,s,S.column,p);if(a)return a;for(let v=1;v<=t;v++){const _=(s+v-1)%t,c=h.getLineContent(_+1),u=this._findFirstMatchInLine(E,c,_+1,1,p);if(u)return u}return null}static _findFirstMatchInLine(h,S,E,p,t){h.reset(p-1);const s=h.next(S);return s?L(new R.Range(E,s.index+1,E,s.index+1+s[0].length),s,t):null}static findPreviousMatch(h,S,E,p){const t=S.parseSearchRequest();if(!t)return null;const s=new i(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(h,E,s,p):this._doFindPreviousMatchLineByLine(h,E,s,p)}static _doFindPreviousMatchMultiline(h,S,E,p){const t=this._doFindMatchesMultiline(h,new R.Range(1,1,S.lineNumber,S.column),E,p,10*P);if(t.length>0)return t[t.length-1];const s=h.getLineCount();return S.lineNumber!==s||S.column!==h.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(h,new l.Position(s,h.getLineMaxColumn(s)),E,p):null}static _doFindPreviousMatchLineByLine(h,S,E,p){const t=h.getLineCount(),s=S.lineNumber,r=h.getLineContent(s).substring(0,S.column-1),a=this._findLastMatchInLine(E,r,s,p);if(a)return a;for(let v=1;v<=t;v++){const _=(t+s-v-1)%t,c=h.getLineContent(_+1),u=this._findLastMatchInLine(E,c,_+1,p);if(u)return u}return null}static _findLastMatchInLine(h,S,E,p){let t=null,s;for(h.reset(0);s=h.next(S);)t=L(new R.Range(E,s.index+1,E,s.index+1+s[0].length),s,p);return t}}e.TextModelSearch=w;function k(d,h,S,E,p){if(E===0)return!0;const t=h.charCodeAt(E-1);if(d.get(t)!==0||t===13||t===10)return!0;if(p>0){const s=h.charCodeAt(E);if(d.get(s)!==0)return!0}return!1}function C(d,h,S,E,p){if(E+p===S)return!0;const t=h.charCodeAt(E+p);if(d.get(t)!==0||t===13||t===10)return!0;if(p>0){const s=h.charCodeAt(E+p-1);if(d.get(s)!==0)return!0}return!1}function b(d,h,S,E,p){return k(d,h,S,E,p)&&C(d,h,S,E,p)}e.isValidMatch=b;class i{constructor(h,S){this._wordSeparators=h,this._searchRegex=S,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(h){this._searchRegex.lastIndex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(h){const S=h.length;let E;do{if(this._prevMatchStartIndex+this._prevMatchLength===S||(E=this._searchRegex.exec(h),!E))return null;const p=E.index,t=E[0].length;if(p===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){o.getNextCodePoint(h,S,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=p,this._prevMatchLength=t,!this._wordSeparators||b(this._wordSeparators,h,S,p,t))return E}while(E);return null}}e.Searcher=i}),define(De[120],Ie([1,0,22,14]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var l;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(l||(l={}));function R(I){for(let w=0,k=I.length;w<k;w+=4){const C=I[w+0],b=I[w+1],i=I[w+2],d=I[w+3];I[w+0]=d,I[w+1]=i,I[w+2]=b,I[w+3]=C}}function T(I){const w=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return A.isLittleEndian()||R(w),o.VSBuffer.wrap(w)}function P(I){const w=I.buffer;if(A.isLittleEndian()||R(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const k=new Uint8Array(w.byteLength);return k.set(w),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function y(I){const w=new Uint32Array(g(I));let k=0;if(w[k++]=I.id,I.type==="full")w[k++]=1,w[k++]=I.data.length,w.set(I.data,k),k+=I.data.length;else{w[k++]=2,w[k++]=I.deltas.length;for(const C of I.deltas)w[k++]=C.start,w[k++]=C.deleteCount,C.data?(w[k++]=C.data.length,w.set(C.data,k),k+=C.data.length):w[k++]=0}return T(w)}e.encodeSemanticTokensDto=y;function g(I){let w=0;if(w+=1+1,I.type==="full")w+=1+I.data.length;else{w+=1,w+=(1+1+1)*I.deltas.length;for(const k of I.deltas)k.data&&(w+=k.data.length)}return w}function L(I){const w=P(I);let k=0;const C=w[k++];if(w[k++]===1){const h=w[k++],S=w.subarray(k,k+h);return k+=h,{id:C,type:"full",data:S}}const i=w[k++],d=[];for(let h=0;h<i;h++){const S=w[k++],E=w[k++],p=w[k++];let t;p>0&&(t=w.subarray(k,k+p),k+=p),d[h]={start:S,deleteCount:E,data:t}}return{id:C,type:"delta",deltas:d}}e.decodeSemanticTokensDto=L}),define(De[170],Ie([1,0,3,6]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class l{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new o.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,y){return this._tokenizationSupports.set(P,y),this.handleChange([P]),(0,A.toDisposable)(()=>{this._tokenizationSupports.get(P)===y&&(this._tokenizationSupports.delete(P),this.handleChange([P]))})}get(P){return this._tokenizationSupports.get(P)||null}registerFactory(P,y){this._factories.get(P)?.dispose();const g=new R(this,P,y);return this._factories.set(P,g),(0,A.toDisposable)(()=>{const L=this._factories.get(P);!L||L!==g||(this._factories.delete(P),L.dispose())})}async getOrCreate(P){const y=this.get(P);if(y)return y;const g=this._factories.get(P);return!g||g.isResolved?null:(await g.resolve(),this.get(P))}isResolved(P){if(this.get(P))return!0;const g=this._factories.get(P);return!!(!g||g.isResolved)}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=l;class R extends A.Disposable{get isResolved(){return this._isResolved}constructor(P,y,g){super(),this._registry=P,this._languageId=y,this._factory=g,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const P=await this._factory.tokenizationSupport;this._isResolved=!0,P&&!this._isDisposed&&this._register(this._registry.register(this._languageId,P))}}}),define(De[73],Ie([1,0,68,2,32,170]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class T{constructor(D,M,W){this.offset=D,this.type=M,this.language=W,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=T;class P{constructor(D,M){this.tokens=D,this.endState=M,this._tokenizationResultBrand=void 0}}e.TokenizationResult=P;class y{constructor(D,M){this.tokens=D,this.endState=M,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=y;var g;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(g||(e.CompletionItemKind=g={}));var L;(function(n){const D=new Map;D.set(0,o.Codicon.symbolMethod),D.set(1,o.Codicon.symbolFunction),D.set(2,o.Codicon.symbolConstructor),D.set(3,o.Codicon.symbolField),D.set(4,o.Codicon.symbolVariable),D.set(5,o.Codicon.symbolClass),D.set(6,o.Codicon.symbolStruct),D.set(7,o.Codicon.symbolInterface),D.set(8,o.Codicon.symbolModule),D.set(9,o.Codicon.symbolProperty),D.set(10,o.Codicon.symbolEvent),D.set(11,o.Codicon.symbolOperator),D.set(12,o.Codicon.symbolUnit),D.set(13,o.Codicon.symbolValue),D.set(15,o.Codicon.symbolEnum),D.set(14,o.Codicon.symbolConstant),D.set(15,o.Codicon.symbolEnum),D.set(16,o.Codicon.symbolEnumMember),D.set(17,o.Codicon.symbolKeyword),D.set(27,o.Codicon.symbolSnippet),D.set(18,o.Codicon.symbolText),D.set(19,o.Codicon.symbolColor),D.set(20,o.Codicon.symbolFile),D.set(21,o.Codicon.symbolReference),D.set(22,o.Codicon.symbolCustomColor),D.set(23,o.Codicon.symbolFolder),D.set(24,o.Codicon.symbolTypeParameter),D.set(25,o.Codicon.account),D.set(26,o.Codicon.issues);function M(N){let U=D.get(N);return U||(console.info("No codicon found for CompletionItemKind "+N),U=o.Codicon.symbolProperty),U}n.toIcon=M;const W=new Map;W.set("method",0),W.set("function",1),W.set("constructor",2),W.set("field",3),W.set("variable",4),W.set("class",5),W.set("struct",6),W.set("interface",7),W.set("module",8),W.set("property",9),W.set("event",10),W.set("operator",11),W.set("unit",12),W.set("value",13),W.set("constant",14),W.set("enum",15),W.set("enum-member",16),W.set("enumMember",16),W.set("keyword",17),W.set("snippet",27),W.set("text",18),W.set("color",19),W.set("file",20),W.set("reference",21),W.set("customcolor",22),W.set("folder",23),W.set("type-parameter",24),W.set("typeParameter",24),W.set("account",25),W.set("issue",26);function $(N,U){let q=W.get(N);return typeof q>"u"&&!U&&(q=9),q}n.fromString=$})(L||(e.CompletionItemKinds=L={}));var I;(function(n){n[n.Deprecated=1]="Deprecated"})(I||(e.CompletionItemTag=I={}));var w;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(w||(e.CompletionItemInsertTextRule=w={}));var k;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(k||(e.CompletionTriggerKind=k={}));var C;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(C||(e.InlineCompletionTriggerKind=C={}));class b{constructor(D,M,W,$){this.range=D,this.text=M,this.completionKind=W,this.isSnippetText=$}equals(D){return l.Range.lift(this.range).equalsRange(D.range)&&this.text===D.text&&this.completionKind===D.completionKind&&this.isSnippetText===D.isSnippetText}}e.SelectedSuggestionInfo=b;var i;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var d;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(d||(e.SignatureHelpTriggerKind=d={}));var h;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(h||(e.DocumentHighlightKind=h={}));function S(n){return n&&A.URI.isUri(n.uri)&&l.Range.isIRange(n.range)&&(l.Range.isIRange(n.originSelectionRange)||l.Range.isIRange(n.targetSelectionRange))}e.isLocationLink=S;var E;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(E||(e.SymbolKind=E={}));var p;(function(n){n[n.Deprecated=1]="Deprecated"})(p||(e.SymbolTag=p={}));var t;(function(n){const D=new Map;D.set(0,o.Codicon.symbolFile),D.set(1,o.Codicon.symbolModule),D.set(2,o.Codicon.symbolNamespace),D.set(3,o.Codicon.symbolPackage),D.set(4,o.Codicon.symbolClass),D.set(5,o.Codicon.symbolMethod),D.set(6,o.Codicon.symbolProperty),D.set(7,o.Codicon.symbolField),D.set(8,o.Codicon.symbolConstructor),D.set(9,o.Codicon.symbolEnum),D.set(10,o.Codicon.symbolInterface),D.set(11,o.Codicon.symbolFunction),D.set(12,o.Codicon.symbolVariable),D.set(13,o.Codicon.symbolConstant),D.set(14,o.Codicon.symbolString),D.set(15,o.Codicon.symbolNumber),D.set(16,o.Codicon.symbolBoolean),D.set(17,o.Codicon.symbolArray),D.set(18,o.Codicon.symbolObject),D.set(19,o.Codicon.symbolKey),D.set(20,o.Codicon.symbolNull),D.set(21,o.Codicon.symbolEnumMember),D.set(22,o.Codicon.symbolStruct),D.set(23,o.Codicon.symbolEvent),D.set(24,o.Codicon.symbolOperator),D.set(25,o.Codicon.symbolTypeParameter);function M(W){let $=D.get(W);return $||(console.info("No codicon found for SymbolKind "+W),$=o.Codicon.symbolProperty),$}n.toIcon=M})(t||(e.SymbolKinds=t={}));class s{static fromValue(D){switch(D){case"comment":return s.Comment;case"imports":return s.Imports;case"region":return s.Region}return new s(D)}constructor(D){this.value=D}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var r;(function(n){function D(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}n.is=D})(r||(e.Command=r={}));var a;(function(n){n[n.Collapsed=0]="Collapsed",n[n.Expanded=1]="Expanded"})(a||(e.CommentThreadCollapsibleState=a={}));var v;(function(n){n[n.Unresolved=0]="Unresolved",n[n.Resolved=1]="Resolved"})(v||(e.CommentThreadState=v={}));var _;(function(n){n[n.Editing=0]="Editing",n[n.Preview=1]="Preview"})(_||(e.CommentMode=_={}));var c;(function(n){n[n.Published=0]="Published",n[n.Draft=1]="Draft"})(c||(e.CommentState=c={}));var u;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(u||(e.InlayHintKind=u={}));class m{constructor(D){this.createSupport=D,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(D=>{D&&D.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=m,e.TokenizationRegistry=new R.TokenizationRegistry;var f;(function(n){n[n.None=0]="None",n[n.Option=1]="Option",n[n.Default=2]="Default",n[n.Preferred=3]="Preferred"})(f||(e.ExternalUriOpenerPriority=f={}))}),define(De[171],Ie([12,13]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(De[121],Ie([1,0,171,14,107,18,23,153]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(K){this._values=K}hasChanged(K){return this._values[K]}}e.ConfigurationChangedEvent=g;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class I{constructor(K,ge,Ae,Me){this.id=K,this.name=ge,this.defaultValue=Ae,this.schema=Me}applyUpdate(K,ge){return k(K,ge)}compute(K,ge,Ae){return Ae}}class w{constructor(K,ge){this.newValue=K,this.didChange=ge}}e.ApplyUpdateResult=w;function k(z,K){if(typeof z!="object"||typeof K!="object"||!z||!K)return new w(K,z!==K);if(Array.isArray(z)||Array.isArray(K)){const Ae=Array.isArray(z)&&Array.isArray(K)&&R.equals(z,K);return new w(K,!Ae)}let ge=!1;for(const Ae in K)if(K.hasOwnProperty(Ae)){const Me=k(z[Ae],K[Ae]);Me.didChange&&(z[Ae]=Me.newValue,ge=!0)}return new w(z,ge)}class C{constructor(K){this.schema=void 0,this.id=K,this.name="_never_",this.defaultValue=void 0}applyUpdate(K,ge){return k(K,ge)}validate(K){return this.defaultValue}}class b{constructor(K,ge,Ae,Me){this.id=K,this.name=ge,this.defaultValue=Ae,this.schema=Me}applyUpdate(K,ge){return k(K,ge)}validate(K){return typeof K>"u"?this.defaultValue:K}compute(K,ge,Ae){return Ae}}function i(z,K){return typeof z>"u"?K:z==="false"?!1:!!z}e.boolean=i;class d extends b{constructor(K,ge,Ae,Me=void 0){typeof Me<"u"&&(Me.type="boolean",Me.default=Ae),super(K,ge,Ae,Me)}validate(K){return i(K,this.defaultValue)}}function h(z,K,ge,Ae){if(typeof z>"u")return K;let Me=parseInt(z,10);return isNaN(Me)?K:(Me=Math.max(ge,Me),Me=Math.min(Ae,Me),Me|0)}e.clampedInt=h;class S extends b{static clampedInt(K,ge,Ae,Me){return h(K,ge,Ae,Me)}constructor(K,ge,Ae,Me,qe,He=void 0){typeof He<"u"&&(He.type="integer",He.default=Ae,He.minimum=Me,He.maximum=qe),super(K,ge,Ae,He),this.minimum=Me,this.maximum=qe}validate(K){return S.clampedInt(K,this.defaultValue,this.minimum,this.maximum)}}function E(z,K,ge,Ae){if(typeof z>"u")return K;const Me=p.float(z,K);return p.clamp(Me,ge,Ae)}e.clampedFloat=E;class p extends b{static clamp(K,ge,Ae){return K<ge?ge:K>Ae?Ae:K}static float(K,ge){if(typeof K=="number")return K;if(typeof K>"u")return ge;const Ae=parseFloat(K);return isNaN(Ae)?ge:Ae}constructor(K,ge,Ae,Me,qe){typeof qe<"u"&&(qe.type="number",qe.default=Ae),super(K,ge,Ae,qe),this.validationFn=Me}validate(K){return this.validationFn(p.float(K,this.defaultValue))}}class t extends b{static string(K,ge){return typeof K!="string"?ge:K}constructor(K,ge,Ae,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.default=Ae),super(K,ge,Ae,Me)}validate(K){return t.string(K,this.defaultValue)}}function s(z,K,ge,Ae){return typeof z!="string"?K:Ae&&z in Ae?Ae[z]:ge.indexOf(z)===-1?K:z}e.stringSet=s;class r extends b{constructor(K,ge,Ae,Me,qe=void 0){typeof qe<"u"&&(qe.type="string",qe.enum=Me,qe.default=Ae),super(K,ge,Ae,qe),this._allowedValues=Me}validate(K){return s(K,this.defaultValue,this._allowedValues)}}class a extends I{constructor(K,ge,Ae,Me,qe,He,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=qe,tt.default=Me),super(K,ge,Ae,tt),this._allowedValues=qe,this._convert=He}validate(K){return typeof K!="string"?this.defaultValue:this._allowedValues.indexOf(K)===-1?this.defaultValue:this._convert(K)}}function v(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class _ extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",tags:["accessibility"],description:o.localize(3,null)})}validate(K){switch(K){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(K,ge,Ae){return Ae===0?K.accessibilitySupport:Ae}}class c extends I{constructor(){const K={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",K,{"editor.comments.insertSpace":{type:"boolean",default:K.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:K.ignoreEmptyLines,description:o.localize(5,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{insertSpace:i(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var u;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(u||(e.TextEditorCursorBlinkingStyle=u={}));function m(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function n(z){switch(z){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=n;function D(z){switch(z){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class M extends C{constructor(){super(136)}compute(K,ge,Ae){const Me=["monaco-editor"];return ge.get(37)&&Me.push(ge.get(37)),K.extraEditorClassName&&Me.push(K.extraEditorClassName),ge.get(71)==="default"?Me.push("mouse-default"):ge.get(71)==="copy"&&Me.push("mouse-copy"),ge.get(106)&&Me.push("showUnused"),ge.get(134)&&Me.push("showDeprecated"),Me.join(" ")}}class W extends d{constructor(){super(35,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(K,ge,Ae){return Ae&&K.emptySelectionClipboard}}class $ extends I{constructor(){const K={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",K,{"editor.find.cursorMoveOnType":{type:"boolean",default:K.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:K.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:K.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:K.globalFindClipboard,description:o.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:K.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:K.loop,description:o.localize(18,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{cursorMoveOnType:i(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof K.seedSearchStringFromSelection=="boolean"?K.seedSearchStringFromSelection?"always":"never":s(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof K.autoFindInSelection=="boolean"?K.autoFindInSelection?"always":"never":s(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(ge.loop,this.defaultValue.loop)}}}class N extends I{constructor(){super(49,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"?N.OFF:K==="true"?N.ON:K:K?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class U extends I{constructor(){super(52,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:o.localize(22,null)},{type:"string",description:o.localize(23,null)}],description:o.localize(24,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"?U.OFF:K==="true"?U.TRANSLATE:K:K?U.TRANSLATE:U.OFF}compute(K,ge,Ae){return K.fontInfo.fontVariationSettings}}e.EditorFontVariations=U,U.OFF="normal",U.TRANSLATE="translate";class q extends C{constructor(){super(48)}compute(K,ge,Ae){return K.fontInfo}}class F extends b{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(25,null)})}validate(K){const ge=p.float(K,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(ge,6,100)}compute(K,ge,Ae){return K.fontInfo.fontSize}}class B extends I{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:o.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(27,null)})}validate(K){return K==="normal"||K==="bold"?K:String(S.clampedInt(K,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class Q extends I{constructor(){const K={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:K.multiple,enumDescriptions:[o.localize(28,null),o.localize(29,null),o.localize(30,null)]},Ae=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",K,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:o.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:o.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:o.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:K.alternativeDefinitionCommand,enum:Ae,description:o.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:K.alternativeTypeDefinitionCommand,enum:Ae,description:o.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:K.alternativeDeclarationCommand,enum:Ae,description:o.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:K.alternativeImplementationCommand,enum:Ae,description:o.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:K.alternativeReferenceCommand,enum:Ae,description:o.localize(41,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{multiple:s(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??s(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??s(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??s(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??s(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??s(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class J extends I{constructor(){const K={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",K,{"editor.hover.enabled":{type:"boolean",default:K.enabled,description:o.localize(42,null)},"editor.hover.delay":{type:"number",default:K.delay,minimum:0,maximum:1e4,description:o.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:K.sticky,description:o.localize(44,null)},"editor.hover.above":{type:"boolean",default:K.above,description:o.localize(45,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{enabled:i(ge.enabled,this.defaultValue.enabled),delay:S.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:i(ge.sticky,this.defaultValue.sticky),above:i(ge.above,this.defaultValue.above)}}}var X;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(X||(e.RenderMinimap=X={}));class ie extends C{constructor(){super(139)}compute(K,ge,Ae){return ie.computeLayout(ge,{memory:K.memory,outerWidth:K.outerWidth,outerHeight:K.outerHeight,isDominatedByLongLines:K.isDominatedByLongLines,lineHeight:K.fontInfo.lineHeight,viewLineCount:K.viewLineCount,lineNumbersDigitCount:K.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:K.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:K.fontInfo.maxDigitWidth,pixelRatio:K.pixelRatio,glyphMarginDecorationLaneCount:K.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(K){const ge=K.height/K.lineHeight,Ae=Math.floor(K.paddingTop/K.lineHeight);let Me=Math.floor(K.paddingBottom/K.lineHeight);K.scrollBeyondLastLine&&(Me=Math.max(Me,ge-1));const qe=(Ae+K.viewLineCount+Me)/(K.pixelRatio*K.height),He=Math.floor(K.viewLineCount/qe);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Ae,extraLinesBeyondLastLine:Me,desiredRatio:qe,minimapLineCount:He}}static _computeMinimapLayout(K,ge){const Ae=K.outerWidth,Me=K.outerHeight,qe=K.pixelRatio;if(!K.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(qe*Me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Me};const He=ge.stableMinimapLayoutInput,tt=He&&K.outerHeight===He.outerHeight&&K.lineHeight===He.lineHeight&&K.typicalHalfwidthCharacterWidth===He.typicalHalfwidthCharacterWidth&&K.pixelRatio===He.pixelRatio&&K.scrollBeyondLastLine===He.scrollBeyondLastLine&&K.paddingTop===He.paddingTop&&K.paddingBottom===He.paddingBottom&&K.minimap.enabled===He.minimap.enabled&&K.minimap.side===He.minimap.side&&K.minimap.size===He.minimap.size&&K.minimap.showSlider===He.minimap.showSlider&&K.minimap.renderCharacters===He.minimap.renderCharacters&&K.minimap.maxColumn===He.minimap.maxColumn&&K.minimap.scale===He.minimap.scale&&K.verticalScrollbarWidth===He.verticalScrollbarWidth&&K.isViewportWrapping===He.isViewportWrapping,pt=K.lineHeight,at=K.typicalHalfwidthCharacterWidth,vt=K.scrollBeyondLastLine,yt=K.minimap.renderCharacters;let _t=qe>=2?Math.round(K.minimap.scale*2):K.minimap.scale;const Tt=K.minimap.maxColumn,xt=K.minimap.size,jt=K.minimap.side,Ht=K.verticalScrollbarWidth,At=K.viewLineCount,lt=K.remainingWidth,bt=K.isViewportWrapping,Wt=yt?2:3;let Ut=Math.floor(qe*Me);const kt=Ut/qe;let ft=!1,Pt=!1,Ft=Wt*_t,Rt=_t/qe,Ke=1;if(xt==="fill"||xt==="fit"){const{typicalViewportLineCount:Xe,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:rt,desiredRatio:St,minimapLineCount:Et}=ie.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:vt,paddingTop:K.paddingTop,paddingBottom:K.paddingBottom,height:Me,lineHeight:pt,pixelRatio:qe});if(At/Et>1)ft=!0,Pt=!0,_t=1,Ft=1,Rt=_t/qe;else{let st=!1,dt=_t+1;if(xt==="fit"){const Ot=Math.ceil((je+At+rt)*Ft);bt&&tt&&lt<=ge.stableFitRemainingWidth?(st=!0,dt=ge.stableFitMaxMinimapScale):st=Ot>Ut}if(xt==="fill"||st){ft=!0;const Ot=_t;Ft=Math.min(pt*qe,Math.max(1,Math.floor(1/St))),bt&&tt&&lt<=ge.stableFitRemainingWidth&&(dt=ge.stableFitMaxMinimapScale),_t=Math.min(dt,Math.max(1,Math.floor(Ft/Wt))),_t>Ot&&(Ke=Math.min(2,_t/Ot)),Rt=_t/qe/Ke,Ut=Math.ceil(Math.max(Xe,je+At+rt)*Ft),bt?(ge.stableMinimapLayoutInput=K,ge.stableFitRemainingWidth=lt,ge.stableFitMaxMinimapScale=_t):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const Re=Math.floor(Tt*Rt),Le=Math.min(Re,Math.max(0,Math.floor((lt-Ht-2)*Rt/(at+Rt)))+e.MINIMAP_GUTTER_WIDTH);let Ce=Math.floor(qe*Le);const se=Ce/qe;Ce=Math.floor(Ce*Ke);const Oe=yt?1:2,We=jt==="left"?0:Ae-Le-Ht;return{renderMinimap:Oe,minimapLeft:We,minimapWidth:Le,minimapHeightIsEditorHeight:ft,minimapIsSampling:Pt,minimapScale:_t,minimapLineHeight:Ft,minimapCanvasInnerWidth:Ce,minimapCanvasInnerHeight:Ut,minimapCanvasOuterWidth:se,minimapCanvasOuterHeight:kt}}static computeLayout(K,ge){const Ae=ge.outerWidth|0,Me=ge.outerHeight|0,qe=ge.lineHeight|0,He=ge.lineNumbersDigitCount|0,tt=ge.typicalHalfwidthCharacterWidth,pt=ge.maxDigitWidth,at=ge.pixelRatio,vt=ge.viewLineCount,yt=K.get(131),_t=yt==="inherit"?K.get(130):yt,Tt=_t==="inherit"?K.get(126):_t,xt=K.get(129),jt=ge.isDominatedByLongLines,Ht=K.get(55),At=K.get(65).renderType!==0,lt=K.get(66),bt=K.get(100),Wt=K.get(81),Ut=K.get(70),kt=K.get(98),ft=kt.verticalScrollbarSize,Pt=kt.verticalHasArrows,Ft=kt.arrowSize,Rt=kt.horizontalScrollbarSize,Ke=K.get(41),Re=K.get(105)!=="never";let Le=K.get(63);Ke&&Re&&(Le+=16);let Ce=0;if(At){const ai=Math.max(He,lt);Ce=Math.round(ai*pt)}let se=0;Ht&&(se=qe*ge.glyphMarginDecorationLaneCount);let Oe=0,We=Oe+se,Xe=We+Ce,je=Xe+Le;const rt=Ae-se-Ce-Le;let St=!1,Et=!1,ht=-1;_t==="inherit"&&jt?(St=!0,Et=!0):Tt==="on"||Tt==="bounded"?Et=!0:Tt==="wordWrapColumn"&&(ht=xt);const st=ie._computeMinimapLayout({outerWidth:Ae,outerHeight:Me,lineHeight:qe,typicalHalfwidthCharacterWidth:tt,pixelRatio:at,scrollBeyondLastLine:bt,paddingTop:Wt.top,paddingBottom:Wt.bottom,minimap:Ut,verticalScrollbarWidth:ft,viewLineCount:vt,remainingWidth:rt,isViewportWrapping:Et},ge.memory||new L);st.renderMinimap!==0&&st.minimapLeft===0&&(Oe+=st.minimapWidth,We+=st.minimapWidth,Xe+=st.minimapWidth,je+=st.minimapWidth);const dt=rt-st.minimapWidth,Ot=Math.max(1,Math.floor((dt-ft-2)/tt)),Bt=Pt?Ft:0;return Et&&(ht=Math.max(1,Ot),Tt==="bounded"&&(ht=Math.min(ht,xt))),{width:Ae,height:Me,glyphMarginLeft:Oe,glyphMarginWidth:se,glyphMarginDecorationLaneCount:ge.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:Ce,decorationsLeft:Xe,decorationsWidth:Le,contentLeft:je,contentWidth:dt,minimap:st,viewportColumn:Ot,isWordWrapMinified:St,isViewportWrapping:Et,wrappingColumn:ht,verticalScrollbarWidth:ft,horizontalScrollbarHeight:Rt,overviewRuler:{top:Bt,width:ft,height:Me-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=ie;class ae extends I{constructor(){super(133,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(46,null),o.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(48,null)}})}validate(K){return s(K,"simple",["simple","advanced"])}compute(K,ge,Ae){return ge.get(2)===2?"advanced":Ae}}class we extends I{constructor(){const K={enabled:!0};super(62,"lightbulb",K,{"editor.lightbulb.enabled":{type:"boolean",default:K.enabled,description:o.localize(49,null)}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{enabled:i(K.enabled,this.defaultValue.enabled)}}}class he extends I{constructor(){const K={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(110,"stickyScroll",K,{"editor.stickyScroll.enabled":{type:"boolean",default:K.enabled,description:o.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:K.maxLineCount,minimum:1,maximum:10,description:o.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:K.defaultModel,description:o.localize(52,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{enabled:i(ge.enabled,this.defaultValue.enabled),maxLineCount:S.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(ge.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class fe extends I{constructor(){const K={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(135,"inlayHints",K,{"editor.inlayHints.enabled":{type:"string",default:K.enabled,description:o.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(54,null),o.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(56,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:K.fontSize,markdownDescription:o.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:K.fontFamily,markdownDescription:o.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:K.padding,description:o.localize(60,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:s(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:S.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(ge.fontFamily,this.defaultValue.fontFamily),padding:i(ge.padding,this.defaultValue.padding)}}}class V extends I{constructor(){super(63,"lineDecorationsWidth",10)}validate(K){return typeof K=="string"&&/^\d+(\.\d+)?ch$/.test(K)?-parseFloat(K.substring(0,K.length-2)):S.clampedInt(K,this.defaultValue,0,1e3)}compute(K,ge,Ae){return Ae<0?S.clampedInt(-Ae*K.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ae}}class x extends p{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,K=>p.clamp(K,0,150),{markdownDescription:o.localize(61,null)})}compute(K,ge,Ae){return K.fontInfo.lineHeight}}class Z extends I{constructor(){const K={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",K,{"editor.minimap.enabled":{type:"boolean",default:K.enabled,description:o.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:K.autohide,description:o.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(64,null),o.localize(65,null),o.localize(66,null)],default:K.size,description:o.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:K.side,description:o.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:K.showSlider,description:o.localize(69,null)},"editor.minimap.scale":{type:"number",default:K.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:K.renderCharacters,description:o.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:K.maxColumn,description:o.localize(72,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{enabled:i(ge.enabled,this.defaultValue.enabled),autohide:i(ge.autohide,this.defaultValue.autohide),size:s(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ge.side,this.defaultValue.side,["right","left"]),showSlider:s(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(ge.renderCharacters,this.defaultValue.renderCharacters),scale:S.clampedInt(ge.scale,1,1,3),maxColumn:S.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(z){return z==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class _e extends I{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(74,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{top:S.clampedInt(ge.top,0,0,1e3),bottom:S.clampedInt(ge.bottom,0,0,1e3)}}}class re extends I{constructor(){const K={enabled:!0,cycle:!0};super(82,"parameterHints",K,{"editor.parameterHints.enabled":{type:"boolean",default:K.enabled,description:o.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:K.cycle,description:o.localize(76,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{enabled:i(ge.enabled,this.defaultValue.enabled),cycle:i(ge.cycle,this.defaultValue.cycle)}}}class ne extends C{constructor(){super(137)}compute(K,ge,Ae){return K.pixelRatio}}class de extends I{constructor(){const K={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(77,null),o.localize(78,null),o.localize(79,null)]}];super(85,"quickSuggestions",K,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:K.strings,description:o.localize(80,null)},comments:{anyOf:ge,default:K.comments,description:o.localize(81,null)},other:{anyOf:ge,default:K.other,description:o.localize(82,null)}},default:K,markdownDescription:o.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=K}validate(K){if(typeof K=="boolean"){const at=K?"on":"off";return{comments:at,strings:at,other:at}}if(!K||typeof K!="object")return this.defaultValue;const{other:ge,comments:Ae,strings:Me}=K,qe=["on","inline","off"];let He,tt,pt;return typeof ge=="boolean"?He=ge?"on":"off":He=s(ge,this.defaultValue.other,qe),typeof Ae=="boolean"?tt=Ae?"on":"off":tt=s(Ae,this.defaultValue.comments,qe),typeof Me=="boolean"?pt=Me?"on":"off":pt=s(Me,this.defaultValue.strings,qe),{other:He,comments:tt,strings:pt}}}var ee;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class ce extends I{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(84,null),o.localize(85,null),o.localize(86,null),o.localize(87,null)],default:"on",description:o.localize(88,null)})}validate(K){let ge=this.defaultValue.renderType,Ae=this.defaultValue.renderFn;return typeof K<"u"&&(typeof K=="function"?(ge=4,Ae=K):K==="interval"?ge=3:K==="relative"?ge=2:K==="on"?ge=1:ge=0),{renderType:ge,renderFn:Ae}}}function le(z){const K=z.get(93);return K==="editable"?z.get(87):K!=="on"}e.filterValidationDecorations=le;class ue extends I{constructor(){const K=[],ge={type:"number",description:o.localize(89,null)};super(97,"rulers",K,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:o.localize(90,null),format:"color-hex"}}}]},default:K,description:o.localize(91,null)})}validate(K){if(Array.isArray(K)){const ge=[];for(const Ae of K)if(typeof Ae=="number")ge.push({column:S.clampedInt(Ae,0,0,1e4),color:null});else if(Ae&&typeof Ae=="object"){const Me=Ae;ge.push({column:S.clampedInt(Me.column,0,0,1e4),color:Me.color})}return ge.sort((Ae,Me)=>Ae.column-Me.column),ge}return this.defaultValue}}function O(z,K){if(typeof z!="string")return K;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class j extends I{constructor(){const K={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(98,"scrollbar",K,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(92,null),o.localize(93,null),o.localize(94,null)],default:"auto",description:o.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(96,null),o.localize(97,null),o.localize(98,null)],default:"auto",description:o.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:K.verticalScrollbarSize,description:o.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:K.horizontalScrollbarSize,description:o.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:K.scrollByPage,description:o.localize(102,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K,Ae=S.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Me=S.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:S.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:O(ge.vertical,this.defaultValue.vertical),horizontal:O(ge.horizontal,this.defaultValue.horizontal),useShadows:i(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ae,horizontalSliderSize:S.clampedInt(ge.horizontalSliderSize,Ae,0,1e3),verticalScrollbarSize:Me,verticalSliderSize:S.clampedInt(ge.verticalSliderSize,Me,0,1e3),scrollByPage:i(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Y extends I{constructor(){const K={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(120,"unicodeHighlight",K,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.nonBasicASCII,description:o.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:K.invisibleCharacters,description:o.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:K.ambiguousCharacters,description:o.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeComments,description:o.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeStrings,description:o.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:K.allowedCharacters,description:o.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:K.allowedLocales,description:o.localize(109,null)}})}applyUpdate(K,ge){let Ae=!1;ge.allowedCharacters&&K&&(T.equals(K.allowedCharacters,ge.allowedCharacters)||(K={...K,allowedCharacters:ge.allowedCharacters},Ae=!0)),ge.allowedLocales&&K&&(T.equals(K.allowedLocales,ge.allowedLocales)||(K={...K,allowedLocales:ge.allowedLocales},Ae=!0));const Me=super.applyUpdate(K,ge);return Ae?new w(Me.newValue,!0):Me}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{nonBasicASCII:me(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(K.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(K.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(K,ge){if(typeof K!="object"||!K)return ge;const Ae={};for(const[Me,qe]of Object.entries(K))qe===!0&&(Ae[Me]=!0);return Ae}}class te extends I{constructor(){const K={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(60,"inlineSuggest",K,{"editor.inlineSuggest.enabled":{type:"boolean",default:K.enabled,description:o.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:K.showToolbar,enum:["always","onHover"],enumDescriptions:[o.localize(111,null),o.localize(112,null)],description:o.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:K.suppressSuggestions,description:o.localize(114,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{enabled:i(ge.enabled,this.defaultValue.enabled),mode:s(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(ge.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:i(ge.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(ge.keepOnBlur,this.defaultValue.keepOnBlur)}}}class be extends I{constructor(){const K={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",K,{"editor.bracketPairColorization.enabled":{type:"boolean",default:K.enabled,markdownDescription:o.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:K.independentColorPoolPerBracketType,description:o.localize(116,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{enabled:i(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ye extends I{constructor(){const K={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",K,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(117,null),o.localize(118,null),o.localize(119,null)],default:K.bracketPairs,description:o.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(121,null),o.localize(122,null),o.localize(123,null)],default:K.bracketPairsHorizontal,description:o.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:K.highlightActiveBracketPair,description:o.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:K.indentation,description:o.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(127,null),o.localize(128,null),o.localize(129,null)],default:K.highlightActiveIndentation,description:o.localize(130,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{bracketPairs:me(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:me(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function me(z,K,ge){const Ae=ge.indexOf(z);return Ae===-1?K:ge[Ae]}class ke extends I{constructor(){const K={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(113,"suggest",K,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(131,null),o.localize(132,null)],default:K.insertMode,description:o.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:K.filterGraceful,description:o.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:K.localityBonus,description:o.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:K.shareSuggestSelections,markdownDescription:o.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(137,null),o.localize(138,null),o.localize(139,null),o.localize(140,null)],default:K.selectionMode,markdownDescription:o.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:K.snippetsPreventQuickSuggestions,description:o.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:K.showIcons,description:o.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:K.showStatusBar,description:o.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:K.preview,description:o.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:K.showInlineDetails,description:o.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(178,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{insertMode:s(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(ge.showIcons,this.defaultValue.showIcons),showStatusBar:i(ge.showStatusBar,this.defaultValue.showStatusBar),preview:i(ge.preview,this.defaultValue.preview),previewMode:s(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(ge.showMethods,this.defaultValue.showMethods),showFunctions:i(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:i(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(ge.showFields,this.defaultValue.showFields),showVariables:i(ge.showVariables,this.defaultValue.showVariables),showClasses:i(ge.showClasses,this.defaultValue.showClasses),showStructs:i(ge.showStructs,this.defaultValue.showStructs),showInterfaces:i(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:i(ge.showModules,this.defaultValue.showModules),showProperties:i(ge.showProperties,this.defaultValue.showProperties),showEvents:i(ge.showEvents,this.defaultValue.showEvents),showOperators:i(ge.showOperators,this.defaultValue.showOperators),showUnits:i(ge.showUnits,this.defaultValue.showUnits),showValues:i(ge.showValues,this.defaultValue.showValues),showConstants:i(ge.showConstants,this.defaultValue.showConstants),showEnums:i(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:i(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(ge.showKeywords,this.defaultValue.showKeywords),showWords:i(ge.showWords,this.defaultValue.showWords),showColors:i(ge.showColors,this.defaultValue.showColors),showFiles:i(ge.showFiles,this.defaultValue.showFiles),showReferences:i(ge.showReferences,this.defaultValue.showReferences),showFolders:i(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:i(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(ge.showSnippets,this.defaultValue.showSnippets),showUsers:i(ge.showUsers,this.defaultValue.showUsers),showIssues:i(ge.showIssues,this.defaultValue.showIssues)}}}class Pe extends I{constructor(){super(108,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(179,null),default:!0,type:"boolean"}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(K.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var Be;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class $e extends I{constructor(){super(132,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(180,null),o.localize(181,null),o.localize(182,null),o.localize(183,null)],description:o.localize(184,null),default:"same"}})}validate(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(K,ge,Ae){return ge.get(2)===2?0:Ae}}class et extends C{constructor(){super(140)}compute(K,ge,Ae){const Me=ge.get(139);return{isDominatedByLongLines:K.isDominatedByLongLines,isWordWrapMinified:Me.isWordWrapMinified,isViewportWrapping:Me.isViewportWrapping,wrappingColumn:Me.wrappingColumn}}}class Qe extends I{constructor(){const K={enabled:!0,showDropSelector:"afterDrop"};super(34,"dropIntoEditor",K,{"editor.dropIntoEditor.enabled":{type:"boolean",default:K.enabled,markdownDescription:o.localize(185,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:o.localize(186,null),enum:["afterDrop","never"],enumDescriptions:[o.localize(187,null),o.localize(188,null)],default:"afterDrop"}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const ge=K;return{enabled:i(ge.enabled,this.defaultValue.enabled),showDropSelector:s(ge.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}const Ye="Consolas, 'Courier New', monospace",nt="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?nt:A.isLinux?ct:Ye,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(z){return e.editorOptionsRegistry[z.id]=z,z}var it;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",z[z.autoClosingDelete=7]="autoClosingDelete",z[z.autoClosingOvertype=8]="autoClosingOvertype",z[z.autoClosingQuotes=9]="autoClosingQuotes",z[z.autoIndent=10]="autoIndent",z[z.automaticLayout=11]="automaticLayout",z[z.autoSurround=12]="autoSurround",z[z.bracketPairColorization=13]="bracketPairColorization",z[z.guides=14]="guides",z[z.codeLens=15]="codeLens",z[z.codeLensFontFamily=16]="codeLensFontFamily",z[z.codeLensFontSize=17]="codeLensFontSize",z[z.colorDecorators=18]="colorDecorators",z[z.colorDecoratorsLimit=19]="colorDecoratorsLimit",z[z.columnSelection=20]="columnSelection",z[z.comments=21]="comments",z[z.contextmenu=22]="contextmenu",z[z.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",z[z.cursorBlinking=24]="cursorBlinking",z[z.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",z[z.cursorStyle=26]="cursorStyle",z[z.cursorSurroundingLines=27]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",z[z.cursorWidth=29]="cursorWidth",z[z.disableLayerHinting=30]="disableLayerHinting",z[z.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",z[z.domReadOnly=32]="domReadOnly",z[z.dragAndDrop=33]="dragAndDrop",z[z.dropIntoEditor=34]="dropIntoEditor",z[z.emptySelectionClipboard=35]="emptySelectionClipboard",z[z.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",z[z.extraEditorClassName=37]="extraEditorClassName",z[z.fastScrollSensitivity=38]="fastScrollSensitivity",z[z.find=39]="find",z[z.fixedOverflowWidgets=40]="fixedOverflowWidgets",z[z.folding=41]="folding",z[z.foldingStrategy=42]="foldingStrategy",z[z.foldingHighlight=43]="foldingHighlight",z[z.foldingImportsByDefault=44]="foldingImportsByDefault",z[z.foldingMaximumRegions=45]="foldingMaximumRegions",z[z.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=47]="fontFamily",z[z.fontInfo=48]="fontInfo",z[z.fontLigatures=49]="fontLigatures",z[z.fontSize=50]="fontSize",z[z.fontWeight=51]="fontWeight",z[z.fontVariations=52]="fontVariations",z[z.formatOnPaste=53]="formatOnPaste",z[z.formatOnType=54]="formatOnType",z[z.glyphMargin=55]="glyphMargin",z[z.gotoLocation=56]="gotoLocation",z[z.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",z[z.hover=58]="hover",z[z.inDiffEditor=59]="inDiffEditor",z[z.inlineSuggest=60]="inlineSuggest",z[z.letterSpacing=61]="letterSpacing",z[z.lightbulb=62]="lightbulb",z[z.lineDecorationsWidth=63]="lineDecorationsWidth",z[z.lineHeight=64]="lineHeight",z[z.lineNumbers=65]="lineNumbers",z[z.lineNumbersMinChars=66]="lineNumbersMinChars",z[z.linkedEditing=67]="linkedEditing",z[z.links=68]="links",z[z.matchBrackets=69]="matchBrackets",z[z.minimap=70]="minimap",z[z.mouseStyle=71]="mouseStyle",z[z.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=73]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",z[z.multiCursorModifier=75]="multiCursorModifier",z[z.multiCursorPaste=76]="multiCursorPaste",z[z.multiCursorLimit=77]="multiCursorLimit",z[z.occurrencesHighlight=78]="occurrencesHighlight",z[z.overviewRulerBorder=79]="overviewRulerBorder",z[z.overviewRulerLanes=80]="overviewRulerLanes",z[z.padding=81]="padding",z[z.parameterHints=82]="parameterHints",z[z.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",z[z.quickSuggestions=85]="quickSuggestions",z[z.quickSuggestionsDelay=86]="quickSuggestionsDelay",z[z.readOnly=87]="readOnly",z[z.renameOnType=88]="renameOnType",z[z.renderControlCharacters=89]="renderControlCharacters",z[z.renderFinalNewline=90]="renderFinalNewline",z[z.renderLineHighlight=91]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=93]="renderValidationDecorations",z[z.renderWhitespace=94]="renderWhitespace",z[z.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",z[z.roundedSelection=96]="roundedSelection",z[z.rulers=97]="rulers",z[z.scrollbar=98]="scrollbar",z[z.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=100]="scrollBeyondLastLine",z[z.scrollPredominantAxis=101]="scrollPredominantAxis",z[z.selectionClipboard=102]="selectionClipboard",z[z.selectionHighlight=103]="selectionHighlight",z[z.selectOnLineNumbers=104]="selectOnLineNumbers",z[z.showFoldingControls=105]="showFoldingControls",z[z.showUnused=106]="showUnused",z[z.snippetSuggestions=107]="snippetSuggestions",z[z.smartSelect=108]="smartSelect",z[z.smoothScrolling=109]="smoothScrolling",z[z.stickyScroll=110]="stickyScroll",z[z.stickyTabStops=111]="stickyTabStops",z[z.stopRenderingLineAfter=112]="stopRenderingLineAfter",z[z.suggest=113]="suggest",z[z.suggestFontSize=114]="suggestFontSize",z[z.suggestLineHeight=115]="suggestLineHeight",z[z.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",z[z.suggestSelection=117]="suggestSelection",z[z.tabCompletion=118]="tabCompletion",z[z.tabIndex=119]="tabIndex",z[z.unicodeHighlighting=120]="unicodeHighlighting",z[z.unusualLineTerminators=121]="unusualLineTerminators",z[z.useShadowDOM=122]="useShadowDOM",z[z.useTabStops=123]="useTabStops",z[z.wordBreak=124]="wordBreak",z[z.wordSeparators=125]="wordSeparators",z[z.wordWrap=126]="wordWrap",z[z.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=129]="wordWrapColumn",z[z.wordWrapOverride1=130]="wordWrapOverride1",z[z.wordWrapOverride2=131]="wordWrapOverride2",z[z.wrappingIndent=132]="wrappingIndent",z[z.wrappingStrategy=133]="wrappingStrategy",z[z.showDeprecated=134]="showDeprecated",z[z.inlayHints=135]="inlayHints",z[z.editorClassName=136]="editorClassName",z[z.pixelRatio=137]="pixelRatio",z[z.tabFocusMode=138]="tabFocusMode",z[z.layoutInfo=139]="layoutInfo",z[z.wrappingInfo=140]="wrappingInfo",z[z.defaultColorDecorators=141]="defaultColorDecorators"})(it||(e.EditorOption=it={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(189,null)})),acceptSuggestionOnEnter:Fe(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(190,null),""],markdownDescription:o.localize(191,null)})),accessibilitySupport:Fe(new _),accessibilityPageSize:Fe(new S(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(192,null),tags:["accessibility"]})),ariaLabel:Fe(new t(4,"ariaLabel",o.localize(193,null))),screenReaderAnnounceInlineSuggestion:Fe(new d(6,"screenReaderAnnounceInlineSuggestion",!1,{description:o.localize(194,null),tags:["accessibility"]})),autoClosingBrackets:Fe(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(195,null),o.localize(196,null),""],description:o.localize(197,null)})),autoClosingDelete:Fe(new r(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(198,null),""],description:o.localize(199,null)})),autoClosingOvertype:Fe(new r(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(200,null),""],description:o.localize(201,null)})),autoClosingQuotes:Fe(new r(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(202,null),o.localize(203,null),""],description:o.localize(204,null)})),autoIndent:Fe(new a(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[o.localize(205,null),o.localize(206,null),o.localize(207,null),o.localize(208,null),o.localize(209,null)],description:o.localize(210,null)})),automaticLayout:Fe(new d(11,"automaticLayout",!1)),autoSurround:Fe(new r(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(211,null),o.localize(212,null),o.localize(213,null),""],description:o.localize(214,null)})),bracketPairColorization:Fe(new be),bracketPairGuides:Fe(new ye),stickyTabStops:Fe(new d(111,"stickyTabStops",!1,{description:o.localize(215,null)})),codeLens:Fe(new d(15,"codeLens",!0,{description:o.localize(216,null)})),codeLensFontFamily:Fe(new t(16,"codeLensFontFamily","",{description:o.localize(217,null)})),codeLensFontSize:Fe(new S(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(218,null)})),colorDecorators:Fe(new d(18,"colorDecorators",!0,{description:o.localize(219,null)})),colorDecoratorsLimit:Fe(new S(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(220,null)})),columnSelection:Fe(new d(20,"columnSelection",!1,{description:o.localize(221,null)})),comments:Fe(new c),contextmenu:Fe(new d(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new d(23,"copyWithSyntaxHighlighting",!0,{description:o.localize(222,null)})),cursorBlinking:Fe(new a(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:o.localize(223,null)})),cursorSmoothCaretAnimation:Fe(new r(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(224,null),o.localize(225,null),o.localize(226,null)],description:o.localize(227,null)})),cursorStyle:Fe(new a(26,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],D,{description:o.localize(228,null)})),cursorSurroundingLines:Fe(new S(27,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(229,null)})),cursorSurroundingLinesStyle:Fe(new r(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(230,null),o.localize(231,null)],description:o.localize(232,null)})),cursorWidth:Fe(new S(29,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(233,null)})),disableLayerHinting:Fe(new d(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new d(31,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new d(32,"domReadOnly",!1)),dragAndDrop:Fe(new d(33,"dragAndDrop",!0,{description:o.localize(234,null)})),emptySelectionClipboard:Fe(new W),dropIntoEditor:Fe(new Qe),stickyScroll:Fe(new he),experimentalWhitespaceRendering:Fe(new r(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(235,null),o.localize(236,null),o.localize(237,null)],description:o.localize(238,null)})),extraEditorClassName:Fe(new t(37,"extraEditorClassName","")),fastScrollSensitivity:Fe(new p(38,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:o.localize(239,null)})),find:Fe(new $),fixedOverflowWidgets:Fe(new d(40,"fixedOverflowWidgets",!1)),folding:Fe(new d(41,"folding",!0,{description:o.localize(240,null)})),foldingStrategy:Fe(new r(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(241,null),o.localize(242,null)],description:o.localize(243,null)})),foldingHighlight:Fe(new d(43,"foldingHighlight",!0,{description:o.localize(244,null)})),foldingImportsByDefault:Fe(new d(44,"foldingImportsByDefault",!1,{description:o.localize(245,null)})),foldingMaximumRegions:Fe(new S(45,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(246,null)})),unfoldOnClickAfterEndOfLine:Fe(new d(46,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(247,null)})),fontFamily:Fe(new t(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(248,null)})),fontInfo:Fe(new q),fontLigatures2:Fe(new N),fontSize:Fe(new F),fontWeight:Fe(new B),fontVariations:Fe(new U),formatOnPaste:Fe(new d(53,"formatOnPaste",!1,{description:o.localize(249,null)})),formatOnType:Fe(new d(54,"formatOnType",!1,{description:o.localize(250,null)})),glyphMargin:Fe(new d(55,"glyphMargin",!0,{description:o.localize(251,null)})),gotoLocation:Fe(new Q),hideCursorInOverviewRuler:Fe(new d(57,"hideCursorInOverviewRuler",!1,{description:o.localize(252,null)})),hover:Fe(new J),inDiffEditor:Fe(new d(59,"inDiffEditor",!1)),letterSpacing:Fe(new p(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>p.clamp(z,-5,20),{description:o.localize(253,null)})),lightbulb:Fe(new we),lineDecorationsWidth:Fe(new V),lineHeight:Fe(new x),lineNumbers:Fe(new ce),lineNumbersMinChars:Fe(new S(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new d(67,"linkedEditing",!1,{description:o.localize(254,null)})),links:Fe(new d(68,"links",!0,{description:o.localize(255,null)})),matchBrackets:Fe(new r(69,"matchBrackets","always",["always","near","never"],{description:o.localize(256,null)})),minimap:Fe(new Z),mouseStyle:Fe(new r(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new p(72,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:o.localize(257,null)})),mouseWheelZoom:Fe(new d(73,"mouseWheelZoom",!1,{markdownDescription:o.localize(258,null)})),multiCursorMergeOverlapping:Fe(new d(74,"multiCursorMergeOverlapping",!0,{description:o.localize(259,null)})),multiCursorModifier:Fe(new a(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[o.localize(260,null),o.localize(261,null)],markdownDescription:o.localize(262,null)})),multiCursorPaste:Fe(new r(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(263,null),o.localize(264,null)],markdownDescription:o.localize(265,null)})),multiCursorLimit:Fe(new S(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(266,null)})),occurrencesHighlight:Fe(new d(78,"occurrencesHighlight",!0,{description:o.localize(267,null)})),overviewRulerBorder:Fe(new d(79,"overviewRulerBorder",!0,{description:o.localize(268,null)})),overviewRulerLanes:Fe(new S(80,"overviewRulerLanes",3,0,3)),padding:Fe(new _e),parameterHints:Fe(new re),peekWidgetDefaultFocus:Fe(new r(83,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(269,null),o.localize(270,null)],description:o.localize(271,null)})),definitionLinkOpensInPeek:Fe(new d(84,"definitionLinkOpensInPeek",!1,{description:o.localize(272,null)})),quickSuggestions:Fe(new de),quickSuggestionsDelay:Fe(new S(86,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(273,null)})),readOnly:Fe(new d(87,"readOnly",!1)),renameOnType:Fe(new d(88,"renameOnType",!1,{description:o.localize(274,null),markdownDeprecationMessage:o.localize(275,null)})),renderControlCharacters:Fe(new d(89,"renderControlCharacters",!0,{description:o.localize(276,null),restricted:!0})),renderFinalNewline:Fe(new r(90,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:o.localize(277,null)})),renderLineHighlight:Fe(new r(91,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(278,null)],description:o.localize(279,null)})),renderLineHighlightOnlyWhenFocus:Fe(new d(92,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(280,null)})),renderValidationDecorations:Fe(new r(93,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new r(94,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(281,null),o.localize(282,null),o.localize(283,null),""],description:o.localize(284,null)})),revealHorizontalRightPadding:Fe(new S(95,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new d(96,"roundedSelection",!0,{description:o.localize(285,null)})),rulers:Fe(new ue),scrollbar:Fe(new j),scrollBeyondLastColumn:Fe(new S(99,"scrollBeyondLastColumn",4,0,1073741824,{description:o.localize(286,null)})),scrollBeyondLastLine:Fe(new d(100,"scrollBeyondLastLine",!0,{description:o.localize(287,null)})),scrollPredominantAxis:Fe(new d(101,"scrollPredominantAxis",!0,{description:o.localize(288,null)})),selectionClipboard:Fe(new d(102,"selectionClipboard",!0,{description:o.localize(289,null),included:A.isLinux})),selectionHighlight:Fe(new d(103,"selectionHighlight",!0,{description:o.localize(290,null)})),selectOnLineNumbers:Fe(new d(104,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new r(105,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(291,null),o.localize(292,null),o.localize(293,null)],description:o.localize(294,null)})),showUnused:Fe(new d(106,"showUnused",!0,{description:o.localize(295,null)})),showDeprecated:Fe(new d(134,"showDeprecated",!0,{description:o.localize(296,null)})),inlayHints:Fe(new fe),snippetSuggestions:Fe(new r(107,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(297,null),o.localize(298,null),o.localize(299,null),o.localize(300,null)],description:o.localize(301,null)})),smartSelect:Fe(new Pe),smoothScrolling:Fe(new d(109,"smoothScrolling",!1,{description:o.localize(302,null)})),stopRenderingLineAfter:Fe(new S(112,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ke),inlineSuggest:Fe(new te),suggestFontSize:Fe(new S(114,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(303,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new S(115,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(304,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new d(116,"suggestOnTriggerCharacters",!0,{description:o.localize(305,null)})),suggestSelection:Fe(new r(117,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(306,null),o.localize(307,null),o.localize(308,null)],description:o.localize(309,null)})),tabCompletion:Fe(new r(118,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(310,null),o.localize(311,null),o.localize(312,null)],description:o.localize(313,null)})),tabIndex:Fe(new S(119,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new Y),unusualLineTerminators:Fe(new r(121,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(314,null),o.localize(315,null),o.localize(316,null)],description:o.localize(317,null)})),useShadowDOM:Fe(new d(122,"useShadowDOM",!0)),useTabStops:Fe(new d(123,"useTabStops",!0,{description:o.localize(318,null)})),wordBreak:Fe(new r(124,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(319,null),o.localize(320,null)],description:o.localize(321,null)})),wordSeparators:Fe(new t(125,"wordSeparators",l.USUAL_WORD_SEPARATORS,{description:o.localize(322,null)})),wordWrap:Fe(new r(126,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(323,null),o.localize(324,null),o.localize(325,null),o.localize(326,null)],description:o.localize(327,null)})),wordWrapBreakAfterCharacters:Fe(new t(127,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new t(128,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new S(129,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(328,null)})),wordWrapOverride1:Fe(new r(130,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new r(131,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new M),defaultColorDecorators:Fe(new d(141,"defaultColorDecorators",!1,{markdownDescription:o.localize(329,null)})),pixelRatio:Fe(new ne),tabFocusMode:Fe(new d(138,"tabFocusMode",!1,{markdownDescription:o.localize(330,null)})),layoutInfo:Fe(new ie),wrappingInfo:Fe(new et),wrappingIndent:Fe(new $e),wrappingStrategy:Fe(new ae)}}),define(De[172],Ie([12,13]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[173],Ie([12,13]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(De[174],Ie([12,13]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(De[175],Ie([12,13]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[176],Ie([12,13]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[177],Ie([12,13]),function(oe,e){return oe.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[178],Ie([12,13]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(De[179],Ie([12,13]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(De[180],Ie([12,13]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(De[181],Ie([12,13]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(De[182],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[183],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[184],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/common/extHostInteractiveSession",e)}),define(De[185],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[186],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLogService",e)}),define(De[187],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/common/extHostProgress",e)}),define(De[188],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[189],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[190],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[191],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[192],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[193],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[194],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[195],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(De[196],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(De[197],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[198],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[199],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[200],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[201],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[202],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[203],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[204],Ie([12,13]),function(oe,e){return oe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[205],Ie([1,0,8,174]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var l;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(l||(e.TokenType=l={}));function R(...g){switch(g.length){case 1:return(0,A.localize)(0,null,g[0]);case 2:return(0,A.localize)(1,null,g[0],g[1]);case 3:return(0,A.localize)(2,null,g[0],g[1],g[2]);default:return}}const T=(0,A.localize)(3,null),P=(0,A.localize)(4,null);class y{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,o.illegalState)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(L){return this._input=L,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const I=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:I})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const I=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:I})}else this._match(126)?this._addToken(9):this._error(R("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(R("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(L){return this._isAtEnd()||this._input.charCodeAt(this._current)!==L?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(L){this._tokens.push({type:L,offset:this._start})}_error(L){const I=this._start,w=this._input.substring(this._start,this._current),k={type:19,offset:this._start,lexeme:w};this._errors.push({offset:I,lexeme:w,additionalInfo:L}),this._tokens.push(k)}_string(){this.stringRe.lastIndex=this._start;const L=this.stringRe.exec(this._input);if(L){this._current=this._start+L[0].length;const I=this._input.substring(this._start,this._current),w=y._keywords.get(I);w?this._addToken(w):this._tokens.push({type:17,lexeme:I,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let L=this._current,I=!1,w=!1;for(;;){if(L>=this._input.length){this._current=L,this._error(P);return}const C=this._input.charCodeAt(L);if(I)I=!1;else if(C===47&&!w){L++;break}else C===91?w=!0:C===92?I=!0:C===93&&(w=!1);L++}for(;L<this._input.length&&y._regexFlags.has(this._input.charCodeAt(L));)L++;this._current=L;const k=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:k,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=y,y._regexFlags=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0))),y._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),function(){"use strict";function oe(e,o,A){function l(T,P){const y=R(T,P),g=[y];return e.isAbsolute(y)||g.unshift(A),e.resolve(...g)}function R(T,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,P);const L=T["user-data-dir"];if(L)return L;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(I,"AppData","Roaming")}break;case"darwin":g=e.join(o.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(o.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,P)}return{getUserDataPath:l}}if(typeof define=="function")define(De[206],Ie([331,55,33]),function(e,o,A){return oe(e,o,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),o=require("os");module.exports=oe(e,o,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(De[207],Ie([1,0,24,38,176,332]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function y(d){return d=d.trim(),d==="*"||T.test(d)}e.isValidVersionStr=y;function g(d){if(!y(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=d.match(T);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=g;function L(d){if(!d)return null;const h=d.majorBase,S=d.majorMustEqual,E=d.minorBase;let p=d.minorMustEqual;const t=d.patchBase;let s=d.patchMustEqual;d.hasCaret&&(h===0||(p=!1),s=!1);let r=0;if(d.preRelease){const a=P.exec(d.preRelease);if(a){const[,v,_,c]=a;r=Date.UTC(Number(v),Number(_)-1,Number(c))}}return{majorBase:h,majorMustEqual:S,minorBase:E,minorMustEqual:p,patchBase:t,patchMustEqual:s,isMinimum:d.hasGreaterEquals,notBefore:r}}e.normalizeVersion=L;function I(d,h,S){let E;typeof d=="string"?E=L(g(d)):E=d;let p;h instanceof Date?p=h.getTime():typeof h=="string"&&(p=new Date(h).getTime());let t;if(typeof S=="string"?t=L(g(S)):t=S,!E||!t)return!1;const s=E.majorBase,r=E.minorBase,a=E.patchBase;let v=t.majorBase,_=t.minorBase,c=t.patchBase;const u=t.notBefore;let m=t.majorMustEqual,f=t.minorMustEqual,n=t.patchMustEqual;return t.isMinimum?s>v?!0:s<v?!1:r>_?!0:r<_||p&&p<u?!1:a>=c:(s===1&&v===0&&(!m||!f||!n)&&(v=1,_=0,c=0,m=!0,f=!1,n=!1),s<v?!1:s>v?!m:r<_?!1:r>_?!f:a<c?!1:a>c?!n:!(p&&p<u))}e.isValidVersion=I;function w(d,h,S,E,p){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([A.default.Error,l.localize(0,null)]),t;if(typeof E.name!="string")return t.push([A.default.Error,l.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([A.default.Error,l.localize(2,null,"version")]),t;if(!E.engines)return t.push([A.default.Error,l.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([A.default.Error,l.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!i(E.extensionDependencies))return t.push([A.default.Error,l.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!i(E.activationEvents))return t.push([A.default.Error,l.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([A.default.Error,l.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([A.default.Warning,l.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([A.default.Error,l.localize(9,null,"main")]),t;{const a=(0,o.joinPath)(S,E.main);(0,o.isEqualOrParent)(a,S)||t.push([A.default.Warning,l.localize(10,null,a.path,S.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([A.default.Error,l.localize(11,null,"browser")]),t;{const a=(0,o.joinPath)(S,E.browser);(0,o.isEqualOrParent)(a,S)||t.push([A.default.Warning,l.localize(12,null,a.path,S.path)])}}if(!R.valid(E.version))return t.push([A.default.Error,l.localize(13,null)]),t;const s=[];if(!k(d,h,E,p,s))for(const a of s)t.push([A.default.Error,a]);return t}e.validateExtensionManifest=w;function k(d,h,S,E,p){return E||typeof S.main>"u"&&typeof S.browser>"u"?!0:b(d,h,S.engines.vscode,p)}e.isValidExtensionVersion=k;function C(d,h,S){return d==="*"||b(h,S,d)}e.isEngineValid=C;function b(d,h,S,E=[]){const p=L(g(S));if(!p)return E.push(l.localize(14,null,S)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return E.push(l.localize(15,null,S)),!1}else if(!p.majorMustEqual)return E.push(l.localize(16,null,S)),!1;return I(d,h,p)?!0:(E.push(l.localize(17,null,d,S)),!1)}function i(d){if(!Array.isArray(d))return!1;for(let h=0,S=d.length;h<S;h++)if(typeof d[h]!="string")return!1;return!0}}),define(De[90],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(l,R=[],T=!1){this.ctor=l,this.staticArguments=R,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=o}),define(De[91],Ie([1,0,90]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var l;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(l||(e.InstantiationType=l={}));function R(P,y,g){y instanceof o.SyncDescriptor||(y=new o.SyncDescriptor(y,[],!!g)),A.push([P,y])}e.registerSingleton=R;function T(){return A}e.getSingletonServiceDescriptors=T}),define(De[208],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(R,T){this.key=R,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=o;class A{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const T of this._nodes.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const P=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(T);P.outgoing.set(y.key,y),y.incoming.set(P.key,P)}removeNode(R){const T=this._hashFn(R);this._nodes.delete(T);for(const P of this._nodes.values())P.outgoing.delete(T),P.incoming.delete(T)}lookupOrInsertNode(R){const T=this._hashFn(R);let P=this._nodes.get(T);return P||(P=new o(T,R),this._nodes.set(T,P)),P}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[T,P]of this._nodes)R.push(`${T}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,T]of this._nodes){const P=new Set([R]),y=this._findCycle(T,P);if(y)return y}}_findCycle(R,T){for(const[P,y]of R.outgoing){if(T.has(P))return[...T,P].join(" -> ");T.add(P);const g=this._findCycle(y,T);if(g)return g;T.delete(P)}}}e.Graph=A}),define(De[4],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function P(y){return y[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=P})(o||(e._util=o={})),e.IInstantiationService=l("instantiationService");function A(T,P,y){P[o.DI_TARGET]===P?P[o.DI_DEPENDENCIES].push({id:T,index:y}):(P[o.DI_DEPENDENCIES]=[{id:T,index:y}],P[o.DI_TARGET]=P)}function l(T){if(o.serviceIds.has(T))return o.serviceIds.get(T);const P=function(y,g,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,y,L)};return P.toString=()=>T,o.serviceIds.set(T,P),P}e.createDecorator=l;function R(T){return T}e.refineServiceDecorator=R}),define(De[56],Ie([1,0,10,2,4]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof A.URI)}e.isConfigurationOverrides=R;function T(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=T;var P;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function y(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function g(i,d){const h=Object.create(null);for(const S in i)L(h,S,i[S],d);return h}e.toValuesTree=g;function L(i,d,h,S){const E=d.split("."),p=E.pop();let t=i;for(let s=0;s<E.length;s++){const r=E[s];let a=t[r];switch(typeof a){case"undefined":a=t[r]=Object.create(null);break;case"object":break;default:S(`Ignoring ${d} as ${E.slice(0,s+1).join(".")} is ${JSON.stringify(a)}`);return}t=a}if(typeof t=="object"&&t!==null)try{t[p]=h}catch{S(`Ignoring ${d} as ${E.join(".")} is ${JSON.stringify(t)}`)}else S(`Ignoring ${d} as ${E.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=L;function I(i,d){const h=d.split(".");w(i,h)}e.removeFromValueTree=I;function w(i,d){const h=d.shift();if(d.length===0){delete i[h];return}if(Object.keys(i).indexOf(h)!==-1){const S=i[h];typeof S=="object"&&!Array.isArray(S)&&(w(S,d),Object.keys(S).length===0&&delete i[h])}}function k(i,d,h){function S(t,s){let r=t;for(const a of s){if(typeof r!="object"||r===null)return;r=r[a]}return r}const E=d.split("."),p=S(i,E);return typeof p>"u"?h:p}e.getConfigurationValue=k;function C(i,d,h){Object.keys(d).forEach(S=>{S!=="__proto__"&&(S in i?o.isObject(i[S])&&o.isObject(d[S])?C(i[S],d[S],h):h&&(i[S]=d[S]):i[S]=d[S])})}e.merge=C;function b(i){return i.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(De[44],Ie([1,0,14,9,205,4,173,8]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",o.isMacintosh),y.set("isLinux",o.isLinux),y.set("isWindows",o.isWindows),y.set("isWeb",o.isWeb),y.set("isMacNative",o.isMacintosh&&!o.isWeb),y.set("isEdge",o.isEdge),y.set("isFirefox",o.isFirefox),y.set("isChrome",o.isChrome),y.set("isSafari",o.isSafari);function g(V,x){if(y.get(V)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(V,x)}e.setConstant=g;const L=Object.prototype.hasOwnProperty;var I;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const w={regexParsingWithErrorRecovery:!0},k=(0,T.localize)(0,null),C=(0,T.localize)(1,null),b=(0,T.localize)(2,null),i=(0,T.localize)(3,null),d=(0,T.localize)(4,null),h=(0,T.localize)(5,null),S=(0,T.localize)(6,null),E=(0,T.localize)(7,null);class p{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(x=w){this._config=x,this._scanner=new l.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(x){if(x===""){this._parsingErrors.push({message:k,offset:0,lexeme:"",additionalInfo:C});return}this._tokens=this._scanner.reset(x).scan(),this._current=0,this._parsingErrors=[];try{const Z=this._expr();if(!this._isAtEnd()){const pe=this._peek(),_e=pe.type===17?h:void 0;throw this._parsingErrors.push({message:d,offset:pe.offset,lexeme:l.Scanner.getLexeme(pe),additionalInfo:_e}),p._parseError}return Z}catch(Z){if(Z!==p._parseError)throw Z;return}}_expr(){return this._or()}_or(){const x=[this._and()];for(;this._matchOne(16);){const Z=this._and();x.push(Z)}return x.length===1?x[0]:t.or(...x)}_and(){const x=[this._term()];for(;this._matchOne(15);){const Z=this._term();x.push(Z)}return x.length===1?x[0]:t.and(...x)}_term(){if(this._matchOne(2)){const x=this._peek();switch(x.type){case 11:return this._advance(),v.INSTANCE;case 12:return this._advance(),_.INSTANCE;case 0:{this._advance();const Z=this._expr();return this._consume(1,i),Z?.negate()}case 17:return this._advance(),D.create(x.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",x)}}return this._primary()}_primary(){const x=this._peek();switch(x.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const Z=this._expr();return this._consume(1,i),Z}case 17:{const Z=x.lexeme;if(this._advance(),this._matchOne(9)){const _e=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),_e.type!==10)throw this._errExpectedButGot("REGEX",_e);const re=_e.lexeme,ne=re.lastIndexOf("/"),de=ne===re.length-1?void 0:this._removeFlagsGY(re.substring(ne+1));let ee;try{ee=new RegExp(re.substring(1,ne),de)}catch{throw this._errExpectedButGot("REGEX",_e)}return q.create(Z,ee)}switch(_e.type){case 10:case 19:{const re=[_e.lexeme];this._advance();let ne=this._peek(),de=0;for(let O=0;O<_e.lexeme.length;O++)_e.lexeme.charCodeAt(O)===40?de++:_e.lexeme.charCodeAt(O)===41&&de--;for(;!this._isAtEnd()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let O=0;O<ne.lexeme.length;O++)ne.lexeme.charCodeAt(O)===40?de++:_e.lexeme.charCodeAt(O)===41&&de--}if(de<0)break;re.push(l.Scanner.getLexeme(ne)),this._advance(),ne=this._peek()}const ee=re.join(""),ce=ee.lastIndexOf("/"),le=ce===ee.length-1?void 0:this._removeFlagsGY(ee.substring(ce+1));let ue;try{ue=new RegExp(ee.substring(1,ce),le)}catch{throw this._errExpectedButGot("REGEX",_e)}return t.regex(Z,ue)}case 18:{const re=_e.lexeme;this._advance();let ne=null;if(!(0,A.isFalsyOrWhitespace)(re)){const de=re.indexOf("/"),ee=re.lastIndexOf("/");if(de!==ee&&de>=0){const ce=re.slice(de+1,ee),le=re[ee+1]==="i"?"i":"";try{ne=new RegExp(ce,le)}catch{throw this._errExpectedButGot("REGEX",_e)}}}if(ne===null)throw this._errExpectedButGot("REGEX",_e);return q.create(Z,ne)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,b);const _e=this._value();return t.notIn(Z,_e)}switch(this._peek().type){case 3:{this._advance();const _e=this._value();if(this._previous().type===18)return t.equals(Z,_e);switch(_e){case"true":return t.has(Z);case"false":return t.not(Z);default:return t.equals(Z,_e)}}case 4:{this._advance();const _e=this._value();if(this._previous().type===18)return t.notEquals(Z,_e);switch(_e){case"true":return t.not(Z);case"false":return t.has(Z);default:return t.notEquals(Z,_e)}}case 5:return this._advance(),N.create(Z,this._value());case 6:return this._advance(),U.create(Z,this._value());case 7:return this._advance(),W.create(Z,this._value());case 8:return this._advance(),$.create(Z,this._value());case 13:return this._advance(),t.in(Z,this._value());default:return t.has(Z)}}case 20:throw this._parsingErrors.push({message:S,offset:x.offset,lexeme:"",additionalInfo:E}),p._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const x=this._peek();switch(x.type){case 17:case 18:return this._advance(),x.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(x){return x.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(x){return this._check(x)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(x,Z){if(this._check(x))return this._advance();throw this._errExpectedButGot(Z,this._peek())}_errExpectedButGot(x,Z,pe){const _e=(0,T.localize)(8,null,x,l.Scanner.getLexeme(Z)),re=Z.offset,ne=l.Scanner.getLexeme(Z);return this._parsingErrors.push({message:_e,offset:re,lexeme:ne,additionalInfo:pe}),p._parseError}_check(x){return this._peek().type===x}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=p,p._parseError=new Error;class t{static false(){return v.INSTANCE}static true(){return _.INSTANCE}static has(x){return c.create(x)}static equals(x,Z){return u.create(x,Z)}static notEquals(x,Z){return n.create(x,Z)}static regex(x,Z){return q.create(x,Z)}static in(x,Z){return m.create(x,Z)}static notIn(x,Z){return f.create(x,Z)}static not(x){return D.create(x)}static and(...x){return Q.create(x,null,!0)}static or(...x){return J.create(x,null,!0)}static greater(x,Z){return W.create(x,Z)}static greaterEquals(x,Z){return $.create(x,Z)}static smaller(x,Z){return N.create(x,Z)}static smallerEquals(x,Z){return U.create(x,Z)}static deserialize(x){return x==null?void 0:this._parser.parse(x)}}e.ContextKeyExpr=t,t._parser=new p({regexParsingWithErrorRecovery:!1});function s(V){const x=new p({regexParsingWithErrorRecovery:!1});return V.map(Z=>(x.parse(Z),x.lexingErrors.length>0?x.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,T.localize)(9,null,pe.additionalInfo):(0,T.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):x.parsingErrors.length>0?x.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}e.validateWhenClauses=s;function r(V,x){const Z=V?V.substituteConstants():void 0,pe=x?x.substituteConstants():void 0;return!Z&&!pe?!0:!Z||!pe?!1:Z.equals(pe)}e.expressionsAreEqualWithConstantSubstitution=r;function a(V,x){return V.cmp(x)}class v{constructor(){this.type=0}cmp(x){return this.type-x.type}equals(x){return x.type===this.type}substituteConstants(){return this}evaluate(x){return!1}serialize(){return"false"}keys(){return[]}map(x){return this}negate(){return _.INSTANCE}}e.ContextKeyFalseExpr=v,v.INSTANCE=new v;class _{constructor(){this.type=1}cmp(x){return this.type-x.type}equals(x){return x.type===this.type}substituteConstants(){return this}evaluate(x){return!0}serialize(){return"true"}keys(){return[]}map(x){return this}negate(){return v.INSTANCE}}e.ContextKeyTrueExpr=_,_.INSTANCE=new _;class c{static create(x,Z=null){const pe=y.get(x);return typeof pe=="boolean"?pe?_.INSTANCE:v.INSTANCE:new c(x,Z)}constructor(x,Z){this.key=x,this.negated=Z,this.type=2}cmp(x){return x.type!==this.type?this.type-x.type:ie(this.key,x.key)}equals(x){return x.type===this.type?this.key===x.key:!1}substituteConstants(){const x=y.get(this.key);return typeof x=="boolean"?x?_.INSTANCE:v.INSTANCE:this}evaluate(x){return!!x.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(x){return x.mapDefined(this.key)}negate(){return this.negated||(this.negated=D.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=c;class u{static create(x,Z,pe=null){if(typeof Z=="boolean")return Z?c.create(x,pe):D.create(x,pe);const _e=y.get(x);return typeof _e=="boolean"?Z===(_e?"true":"false")?_.INSTANCE:v.INSTANCE:new u(x,Z,pe)}constructor(x,Z,pe){this.key=x,this.value=Z,this.negated=pe,this.type=4}cmp(x){return x.type!==this.type?this.type-x.type:ae(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){const x=y.get(this.key);if(typeof x=="boolean"){const Z=x?"true":"false";return this.value===Z?_.INSTANCE:v.INSTANCE}return this}evaluate(x){return x.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(x){return x.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class m{static create(x,Z){return new m(x,Z)}constructor(x,Z){this.key=x,this.valueKey=Z,this.type=10,this.negated=null}cmp(x){return x.type!==this.type?this.type-x.type:ae(this.key,this.valueKey,x.key,x.valueKey)}equals(x){return x.type===this.type?this.key===x.key&&this.valueKey===x.valueKey:!1}substituteConstants(){return this}evaluate(x){const Z=x.getValue(this.valueKey),pe=x.getValue(this.key);return Array.isArray(Z)?Z.includes(pe):typeof pe=="string"&&typeof Z=="object"&&Z!==null?L.call(Z,pe):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(x){return x.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=m;class f{static create(x,Z){return new f(x,Z)}constructor(x,Z){this.key=x,this.valueKey=Z,this.type=11,this._negated=m.create(x,Z)}cmp(x){return x.type!==this.type?this.type-x.type:this._negated.cmp(x._negated)}equals(x){return x.type===this.type?this._negated.equals(x._negated):!1}substituteConstants(){return this}evaluate(x){return!this._negated.evaluate(x)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(x){return x.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=f;class n{static create(x,Z,pe=null){if(typeof Z=="boolean")return Z?D.create(x,pe):c.create(x,pe);const _e=y.get(x);return typeof _e=="boolean"?Z===(_e?"true":"false")?v.INSTANCE:_.INSTANCE:new n(x,Z,pe)}constructor(x,Z,pe){this.key=x,this.value=Z,this.negated=pe,this.type=5}cmp(x){return x.type!==this.type?this.type-x.type:ae(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){const x=y.get(this.key);if(typeof x=="boolean"){const Z=x?"true":"false";return this.value===Z?v.INSTANCE:_.INSTANCE}return this}evaluate(x){return x.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(x){return x.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=n;class D{static create(x,Z=null){const pe=y.get(x);return typeof pe=="boolean"?pe?v.INSTANCE:_.INSTANCE:new D(x,Z)}constructor(x,Z){this.key=x,this.negated=Z,this.type=3}cmp(x){return x.type!==this.type?this.type-x.type:ie(this.key,x.key)}equals(x){return x.type===this.type?this.key===x.key:!1}substituteConstants(){const x=y.get(this.key);return typeof x=="boolean"?x?v.INSTANCE:_.INSTANCE:this}evaluate(x){return!x.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(x){return x.mapNot(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=D;function M(V,x){if(typeof V=="string"){const Z=parseFloat(V);isNaN(Z)||(V=Z)}return typeof V=="string"||typeof V=="number"?x(V):v.INSTANCE}class W{static create(x,Z,pe=null){return M(Z,_e=>new W(x,_e,pe))}constructor(x,Z,pe){this.key=x,this.value=Z,this.negated=pe,this.type=12}cmp(x){return x.type!==this.type?this.type-x.type:ae(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){return this}evaluate(x){return typeof this.value=="string"?!1:parseFloat(x.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(x){return x.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=W;class ${static create(x,Z,pe=null){return M(Z,_e=>new $(x,_e,pe))}constructor(x,Z,pe){this.key=x,this.value=Z,this.negated=pe,this.type=13}cmp(x){return x.type!==this.type?this.type-x.type:ae(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){return this}evaluate(x){return typeof this.value=="string"?!1:parseFloat(x.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(x){return x.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=$;class N{static create(x,Z,pe=null){return M(Z,_e=>new N(x,_e,pe))}constructor(x,Z,pe){this.key=x,this.value=Z,this.negated=pe,this.type=14}cmp(x){return x.type!==this.type?this.type-x.type:ae(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){return this}evaluate(x){return typeof this.value=="string"?!1:parseFloat(x.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(x){return x.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=N;class U{static create(x,Z,pe=null){return M(Z,_e=>new U(x,_e,pe))}constructor(x,Z,pe){this.key=x,this.value=Z,this.negated=pe,this.type=15}cmp(x){return x.type!==this.type?this.type-x.type:ae(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){return this}evaluate(x){return typeof this.value=="string"?!1:parseFloat(x.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(x){return x.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=W.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=U;class q{static create(x,Z){return new q(x,Z)}constructor(x,Z){this.key=x,this.regexp=Z,this.type=7,this.negated=null}cmp(x){if(x.type!==this.type)return this.type-x.type;if(this.key<x.key)return-1;if(this.key>x.key)return 1;const Z=this.regexp?this.regexp.source:"",pe=x.regexp?x.regexp.source:"";return Z<pe?-1:Z>pe?1:0}equals(x){if(x.type===this.type){const Z=this.regexp?this.regexp.source:"",pe=x.regexp?x.regexp.source:"";return this.key===x.key&&Z===pe}return!1}substituteConstants(){return this}evaluate(x){const Z=x.getValue(this.key);return this.regexp?this.regexp.test(Z):!1}serialize(){const x=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${x}`}keys(){return[this.key]}map(x){return x.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=F.create(this)),this.negated}}e.ContextKeyRegexExpr=q;class F{static create(x){return new F(x)}constructor(x){this._actual=x,this.type=8}cmp(x){return x.type!==this.type?this.type-x.type:this._actual.cmp(x._actual)}equals(x){return x.type===this.type?this._actual.equals(x._actual):!1}substituteConstants(){return this}evaluate(x){return!this._actual.evaluate(x)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(x){return new F(this._actual.map(x))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=F;function B(V){let x=null;for(let Z=0,pe=V.length;Z<pe;Z++){const _e=V[Z].substituteConstants();if(V[Z]!==_e&&x===null){x=[];for(let re=0;re<Z;re++)x[re]=V[re]}x!==null&&(x[Z]=_e)}return x===null?V:x}class Q{static create(x,Z,pe){return Q._normalizeArr(x,Z,pe)}constructor(x,Z){this.expr=x,this.negated=Z,this.type=6}cmp(x){if(x.type!==this.type)return this.type-x.type;if(this.expr.length<x.expr.length)return-1;if(this.expr.length>x.expr.length)return 1;for(let Z=0,pe=this.expr.length;Z<pe;Z++){const _e=a(this.expr[Z],x.expr[Z]);if(_e!==0)return _e}return 0}equals(x){if(x.type===this.type){if(this.expr.length!==x.expr.length)return!1;for(let Z=0,pe=this.expr.length;Z<pe;Z++)if(!this.expr[Z].equals(x.expr[Z]))return!1;return!0}return!1}substituteConstants(){const x=B(this.expr);return x===this.expr?this:Q.create(x,this.negated,!1)}evaluate(x){for(let Z=0,pe=this.expr.length;Z<pe;Z++)if(!this.expr[Z].evaluate(x))return!1;return!0}static _normalizeArr(x,Z,pe){const _e=[];let re=!1;for(const ne of x)if(ne){if(ne.type===1){re=!0;continue}if(ne.type===0)return v.INSTANCE;if(ne.type===6){_e.push(...ne.expr);continue}_e.push(ne)}if(_e.length===0&&re)return _.INSTANCE;if(_e.length!==0){if(_e.length===1)return _e[0];_e.sort(a);for(let ne=1;ne<_e.length;ne++)_e[ne-1].equals(_e[ne])&&(_e.splice(ne,1),ne--);if(_e.length===1)return _e[0];for(;_e.length>1;){const ne=_e[_e.length-1];if(ne.type!==9)break;_e.pop();const de=_e.pop(),ee=_e.length===0,ce=J.create(ne.expr.map(le=>Q.create([le,de],null,pe)),null,ee);ce&&(_e.push(ce),_e.sort(a))}if(_e.length===1)return _e[0];if(pe){for(let ne=0;ne<_e.length;ne++)for(let de=ne+1;de<_e.length;de++)if(_e[ne].negate().equals(_e[de]))return v.INSTANCE;if(_e.length===1)return _e[0]}return new Q(_e,Z)}}serialize(){return this.expr.map(x=>x.serialize()).join(" && ")}keys(){const x=[];for(const Z of this.expr)x.push(...Z.keys());return x}map(x){return new Q(this.expr.map(Z=>Z.map(x)),null)}negate(){if(!this.negated){const x=[];for(const Z of this.expr)x.push(Z.negate());this.negated=J.create(x,this,!0)}return this.negated}}e.ContextKeyAndExpr=Q;class J{static create(x,Z,pe){return J._normalizeArr(x,Z,pe)}constructor(x,Z){this.expr=x,this.negated=Z,this.type=9}cmp(x){if(x.type!==this.type)return this.type-x.type;if(this.expr.length<x.expr.length)return-1;if(this.expr.length>x.expr.length)return 1;for(let Z=0,pe=this.expr.length;Z<pe;Z++){const _e=a(this.expr[Z],x.expr[Z]);if(_e!==0)return _e}return 0}equals(x){if(x.type===this.type){if(this.expr.length!==x.expr.length)return!1;for(let Z=0,pe=this.expr.length;Z<pe;Z++)if(!this.expr[Z].equals(x.expr[Z]))return!1;return!0}return!1}substituteConstants(){const x=B(this.expr);return x===this.expr?this:J.create(x,this.negated,!1)}evaluate(x){for(let Z=0,pe=this.expr.length;Z<pe;Z++)if(this.expr[Z].evaluate(x))return!0;return!1}static _normalizeArr(x,Z,pe){let _e=[],re=!1;if(x){for(let ne=0,de=x.length;ne<de;ne++){const ee=x[ne];if(ee){if(ee.type===0){re=!0;continue}if(ee.type===1)return _.INSTANCE;if(ee.type===9){_e=_e.concat(ee.expr);continue}_e.push(ee)}}if(_e.length===0&&re)return v.INSTANCE;_e.sort(a)}if(_e.length!==0){if(_e.length===1)return _e[0];for(let ne=1;ne<_e.length;ne++)_e[ne-1].equals(_e[ne])&&(_e.splice(ne,1),ne--);if(_e.length===1)return _e[0];if(pe){for(let ne=0;ne<_e.length;ne++)for(let de=ne+1;de<_e.length;de++)if(_e[ne].negate().equals(_e[de]))return _.INSTANCE;if(_e.length===1)return _e[0]}return new J(_e,Z)}}serialize(){return this.expr.map(x=>x.serialize()).join(" || ")}keys(){const x=[];for(const Z of this.expr)x.push(...Z.keys());return x}map(x){return new J(this.expr.map(Z=>Z.map(x)),null)}negate(){if(!this.negated){const x=[];for(const Z of this.expr)x.push(Z.negate());for(;x.length>1;){const Z=x.shift(),pe=x.shift(),_e=[];for(const re of fe(Z))for(const ne of fe(pe))_e.push(Q.create([re,ne],null,!1));x.unshift(J.create(_e,null,!1))}this.negated=J.create(x,this,!0)}return this.negated}}e.ContextKeyOrExpr=J;class X extends c{static all(){return X._info.values()}constructor(x,Z,pe){super(x,null),this._defaultValue=Z,typeof pe=="object"?X._info.push({...pe,key:x}):pe!==!0&&X._info.push({key:x,description:pe,type:Z!=null?typeof Z:void 0})}bindTo(x){return x.createKey(this.key,this._defaultValue)}getValue(x){return x.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(x){return u.create(this.key,x)}notEqualsTo(x){return n.create(this.key,x)}}e.RawContextKey=X,X._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function ie(V,x){return V<x?-1:V>x?1:0}function ae(V,x,Z,pe){return V<Z?-1:V>Z?1:x<pe?-1:x>pe?1:0}function we(V,x){if(V.type===0||x.type===1)return!0;if(V.type===9)return x.type===9?he(V.expr,x.expr):!1;if(x.type===9){for(const Z of x.expr)if(we(V,Z))return!0;return!1}if(V.type===6){if(x.type===6)return he(x.expr,V.expr);for(const Z of V.expr)if(we(Z,x))return!0;return!1}return V.equals(x)}e.implies=we;function he(V,x){let Z=0,pe=0;for(;Z<V.length&&pe<x.length;){const _e=V[Z].cmp(x[pe]);if(_e<0)return!1;_e===0&&Z++,pe++}return Z===V.length}function fe(V){return V.type===9?V.expr:[V]}}),define(De[209],Ie([1,0,4]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(De[122],Ie([1,0,175,4]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function R(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function T(h,S){switch(h){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function P(h,S){return S==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function y(h,S,E){return P(S,E)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===E?!0:g(E).includes(h)}e.isTargetPlatformCompatible=y;function g(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function L(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=L;var I;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var w;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var k;(function(h){h.Install="install",h.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var C;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(C||(e.InstallOperation=C={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var b;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var i;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(i||(e.ExtensionSignaturetErrorCode=i={}));class d extends Error{constructor(S,E){super(S),this.code=E,this.name=E}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,o.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,o.localize)(1,null),original:"Preferences"}}),define(De[210],Ie([1,0,4]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,o.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,o.createDecorator)("externalTerminal")}),define(De[211],Ie([1,0,47,16,15,14,110,29,117,177,210]),function(oe,e,o,A,l,R,T,P,y,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=g.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends w{openTerminal(E,p){return this.spawnTerminal(o,E,y.getWindowsShell(),p)}spawnTerminal(E,p,t,s){const r=p.windowsExec||k.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=l.basename(r,".exe").toLowerCase();if(a==="cmder")return E.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const v=["/c","start","/wait"];return r.indexOf(" ")>=0&&v.push('""'),v.push(r),a==="wt"&&v.push("-d ."),new Promise((_,c)=>{const u=i(process),m=E.spawn(t,v,{cwd:s,env:u});m.on("error",c),m.on("exit",()=>_())})}runInTerminal(E,p,t,s,r){const a="windowsExec"in r&&r.windowsExec?r.windowsExec:k.getDefaultTerminalWindows();return new Promise((v,_)=>{const c=`"${p} - ${I}"`,u=`""${t.join('" "')}" & pause"`,m=Object.assign({},i(process),s);Object.keys(m).filter(W=>m[W]===null).forEach(W=>delete m[W]);const f={cwd:p,env:m,windowsVerbatimArguments:!0};let n,D;l.basename(a,".exe")==="wt"?(n=a,D=["-d",".",k.CMD,"/c",u]):(n=k.CMD,D=["/c","start",c,"/wait",a,"/c",u]),o.spawn(n,D,f).on("error",W=>{_(d(W))}),v(void 0)})}static getDefaultTerminalWindows(){if(!k._DEFAULT_TERMINAL_WINDOWS){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return k._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=k,k.CMD="cmd.exe";class C extends w{openTerminal(E,p){return this.spawnTerminal(o,E,p)}runInTerminal(E,p,t,s,r){const a=r.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((v,_)=>{if(a===L.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const c=a===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",m=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`).fsPath,"-t",E||I,"-w",p];for(const D of t)m.push("-a"),m.push(D);if(s){const D=Object.assign({},i(process),s);for(const M in D){const W=D[M];W===null?(m.push("-u"),m.push(M)):(m.push("-e"),m.push(`${M}=${W}`))}}let f="";const n=o.spawn(C.OSASCRIPT,m);n.on("error",D=>{_(d(D))}),n.stderr.on("data",D=>{f+=D.toString()}),n.on("exit",D=>{if(D===0)v(void 0);else if(f){const M=f.split(`
`,1);_(new Error(M[0]))}else _(new Error(g.localize(1,null,c,D)))})}else _(new Error(g.localize(2,null,a)))})}spawnTerminal(E,p,t){const s=p.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{const v=["-a",s];t&&v.push(t);const _=i(process),c=E.spawn("/usr/bin/open",v,{cwd:t,env:_});c.on("error",a),c.on("exit",()=>r())})}}e.MacExternalTerminalService=C,C.OSASCRIPT="/usr/bin/osascript";class b extends w{openTerminal(E,p){return this.spawnTerminal(o,E,p)}runInTerminal(E,p,t,s,r){const a=r.linuxExec?Promise.resolve(r.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((v,_)=>{const c=[];a.then(u=>{u.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const m=`${h(t)}; echo; read -p "${b.WAIT_MESSAGE}" -n1;`;c.push(`''${m}''`);const f=Object.assign({},i(process),s);Object.keys(f).filter(W=>f[W]===null).forEach(W=>delete f[W]);const n={cwd:p,env:f};let D="";const M=o.spawn(u,c,n);M.on("error",W=>{_(d(W))}),M.stderr.on("data",W=>{D+=W.toString()}),M.on("exit",W=>{if(W===0)v(void 0);else if(D){const $=D.split(`
`,1);_(new Error($[0]))}else _(new Error(g.localize(4,null,u,W)))})})})}static async getDefaultTerminalLinuxReady(){if(!b._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)b._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");b._DEFAULT_TERMINAL_LINUX_READY=new Promise(p=>{E?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return b._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(E,p,t){const s=p.linuxExec?Promise.resolve(p.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{s.then(v=>{const _=i(process),c=E.spawn(v,[],{cwd:t,env:_});c.on("error",a),c.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=b,b.WAIT_MESSAGE=g.localize(3,null);function i(S){const E={...S.env};return(0,T.sanitizeProcessEnvironment)(E),E}function d(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(g.localize(5,null,S.path)):S}function h(S){let E="";for(const p of S)p.indexOf(" ")>=0?E+='"'+p+'"':E+=p,E+=" ";return E}}),define(De[45],Ie([1,0,70,15,9,10,2,178,4,14,16]),function(oe,e,o,A,l,R,T,P,y,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function I(Q){return Q.create===!0}e.isFileOpenForWriteOptions=I;var w;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.File=1]="File",Q[Q.Directory=2]="Directory",Q[Q.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var k;(function(Q){Q[Q.Readonly=1]="Readonly"})(k||(e.FilePermission=k={}));var C;(function(Q){Q[Q.None=0]="None",Q[Q.FileReadWrite=2]="FileReadWrite",Q[Q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Q[Q.FileReadStream=16]="FileReadStream",Q[Q.FileFolderCopy=8]="FileFolderCopy",Q[Q.PathCaseSensitive=1024]="PathCaseSensitive",Q[Q.Readonly=2048]="Readonly",Q[Q.Trash=4096]="Trash",Q[Q.FileWriteUnlock=8192]="FileWriteUnlock",Q[Q.FileAtomicRead=16384]="FileAtomicRead",Q[Q.FileClone=32768]="FileClone"})(C||(e.FileSystemProviderCapabilities=C={}));function b(Q){return!!(Q.capabilities&2)}e.hasReadWriteCapability=b;function i(Q){return!!(Q.capabilities&8)}e.hasFileFolderCopyCapability=i;function d(Q){return!!(Q.capabilities&32768)}e.hasFileCloneCapability=d;function h(Q){return!!(Q.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function S(Q){return!!(Q.capabilities&16)}e.hasFileReadStreamCapability=S;function E(Q){return b(Q)?!!(Q.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;var p;(function(Q){Q.FileExists="EntryExists",Q.FileNotFound="EntryNotFound",Q.FileNotADirectory="EntryNotADirectory",Q.FileIsADirectory="EntryIsADirectory",Q.FileExceedsStorageQuota="EntryExceedsStorageQuota",Q.FileTooLarge="EntryTooLarge",Q.FileWriteLocked="EntryWriteLocked",Q.NoPermissions="NoPermissions",Q.Unavailable="Unavailable",Q.Unknown="Unknown"})(p||(e.FileSystemProviderErrorCode=p={}));class t extends Error{static create(J,X){const ie=new t(J.toString(),X);return a(ie,X),ie}constructor(J,X){super(J),this.code=X}}e.FileSystemProviderError=t;function s(Q,J){return t.create(Q,J)}e.createFileSystemProviderError=s;function r(Q){return Q||s((0,P.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=r;function a(Q,J){return Q.name=J?`${J} (FileSystemError)`:"FileSystemError",Q}e.markAsFileSystemProviderError=a;function v(Q){if(!Q)return p.Unknown;if(Q instanceof t)return Q.code;const J=/^(.+) \(FileSystemError\)$/.exec(Q.name);if(!J)return p.Unknown;switch(J[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=v;function _(Q){if(Q instanceof D)return Q.fileOperationResult;switch(v(Q)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=_;var c;(function(Q){Q[Q.CREATE=0]="CREATE",Q[Q.DELETE=1]="DELETE",Q[Q.MOVE=2]="MOVE",Q[Q.COPY=3]="COPY",Q[Q.WRITE=4]="WRITE"})(c||(e.FileOperation=c={}));class u{constructor(J,X,ie){this.resource=J,this.operation=X,this.target=ie}isOperation(J){return this.operation===J}}e.FileOperationEvent=u;var m;(function(Q){Q[Q.UPDATED=0]="UPDATED",Q[Q.ADDED=1]="ADDED",Q[Q.DELETED=2]="DELETED"})(m||(e.FileChangeType=m={}));class f{constructor(J,X){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const ae of J){const we=ie.get(ae.type);switch(we?we.push([ae.resource,ae]):ie.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,we]of ie)switch(ae){case 1:this.added=o.TernarySearchTree.forUris(()=>X),this.added.fill(we);break;case 0:this.updated=o.TernarySearchTree.forUris(()=>X),this.updated.fill(we);break;case 2:this.deleted=o.TernarySearchTree.forUris(()=>X),this.deleted.fill(we);break}}contains(J,...X){return this.doContains(J,{includeChildren:!1},...X)}affects(J,...X){return this.doContains(J,{includeChildren:!0},...X)}doContains(J,X,...ie){if(!J)return!1;const ae=ie.length>0;return!!((!ae||ie.includes(1))&&(this.added?.get(J)||X.includeChildren&&this.added?.findSuperstr(J))||(!ae||ie.includes(0))&&(this.updated?.get(J)||X.includeChildren&&this.updated?.findSuperstr(J))||(!ae||ie.includes(2))&&(this.deleted?.findSubstr(J)||X.includeChildren&&this.deleted?.findSuperstr(J)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=f;function n(Q,J,X){return!Q||!J||Q===J||J.length>Q.length?!1:(J.charAt(J.length-1)!==A.sep&&(J+=A.sep),X?(0,l.startsWithIgnoreCase)(Q,J):Q.indexOf(J)===0)}e.isParent=n;class D extends Error{constructor(J,X,ie){super(J),this.fileOperationResult=X,this.options=ie}}e.FileOperationError=D;class M extends D{constructor(J,X,ie,ae){super(J,X,ae),this.fileOperationResult=X,this.size=ie}}e.TooLargeFileOperationError=M;class W extends D{constructor(J,X,ie){super(J,2,ie),this.stat=X}}e.NotModifiedSinceFileOperationError=W;var $;(function(Q){Q[Q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Q[Q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Q[Q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Q[Q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Q[Q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Q[Q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Q[Q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Q[Q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Q[Q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Q[Q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Q[Q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})($||(e.FileOperationResult=$={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(Q){Q[Q.FILE=0]="FILE",Q[Q.FOLDER=1]="FOLDER",Q[Q.ROOT_FOLDER=2]="ROOT_FOLDER"})(N||(e.FileKind=N={})),e.ETAG_DISABLED="";function U(Q){if(!(typeof Q.size!="number"||typeof Q.mtime!="number"))return Q.mtime.toString(29)+Q.size.toString(31)}e.etag=U;async function q(Q,J){if(!J.hasProvider(T.URI.from({scheme:Q.scheme})))return new Promise(X=>{const ie=J.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===Q.scheme&&ae.added&&(ie.dispose(),X())})})}e.whenProviderRegistered=q;class F{static formatSize(J){return(0,R.isNumber)(J)||(J=0),J<F.KB?(0,P.localize)(1,null,J.toFixed(0)):J<F.MB?(0,P.localize)(2,null,(J/F.KB).toFixed(2)):J<F.GB?(0,P.localize)(3,null,(J/F.MB).toFixed(2)):J<F.TB?(0,P.localize)(4,null,(J/F.GB).toFixed(2)):(0,P.localize)(5,null,(J/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;function B(Q){const J=typeof Q=="string"||Q?.scheme===L.Schemas.vscodeRemote;return typeof Q!="string"&&Q?.scheme===L.Schemas.file?1024*F.MB:J?10*F.MB:g.isWeb?50*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=B}),define(De[92],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...l){this._entries=new Map;for(const[R,T]of l)this.set(R,T)}set(l,R){const T=this._entries.get(l);return this._entries.set(l,R),T}has(l){return this._entries.has(l)}get(l){return this._entries.get(l)}}e.ServiceCollection=o}),define(De[212],Ie([1,0,19,8,6,90,208,4,92,67]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class I extends Error{constructor(i){super("cyclic dependency between services"),this.message=i.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${i.toString()}`}}class w{constructor(i=new y.ServiceCollection,d=!1,h,S=L){this._services=i,this._strict=d,this._parent=h,this._enableTracing=S,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=S?h?._globalGraph??new T.Graph(E=>E):void 0}createChild(i){return new w(i,this._strict,this,this._enableTracing)}invokeFunction(i,...d){const h=C.traceInvocation(this._enableTracing,i);let S=!1;try{return i({get:p=>{if(S)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(p,h);if(!t)throw new Error(`[invokeFunction] unknown service '${p}'`);return t}},...d)}finally{S=!0,h.stop()}}createInstance(i,...d){let h,S;return i instanceof R.SyncDescriptor?(h=C.traceCreation(this._enableTracing,i.ctor),S=this._createInstance(i.ctor,i.staticArguments.concat(d),h)):(h=C.traceCreation(this._enableTracing,i),S=this._createInstance(i,d,h)),h.stop(),S}_createInstance(i,d=[],h){const S=P._util.getServiceDependencies(i).sort((t,s)=>t.index-s.index),E=[];for(const t of S){const s=this._getOrCreateServiceInstance(t.id,h);s||this._throwIfStrict(`[createInstance] ${i.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(s)}const p=S.length>0?S[0].index:d.length;if(d.length!==p){console.trace(`[createInstance] First service dependency of ${i.name} at position ${p+1} conflicts with ${d.length} static arguments`);const t=p-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,p)}return Reflect.construct(i,d.concat(E))}_setServiceInstance(i,d){if(this._services.get(i)instanceof R.SyncDescriptor)this._services.set(i,d);else if(this._parent)this._parent._setServiceInstance(i,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(i){const d=this._services.get(i);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(i):d}_getOrCreateServiceInstance(i,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(i));const h=this._getServiceInstanceOrDescriptor(i);return h instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(i,h,d.branch(i,!0)):(d.branch(i,!1),h)}_safeCreateAndCacheServiceInstance(i,d,h){if(this._activeInstantiations.has(i))throw new Error(`illegal state - RECURSIVELY instantiating service '${i}'`);this._activeInstantiations.add(i);try{return this._createAndCacheServiceInstance(i,d,h)}finally{this._activeInstantiations.delete(i)}}_createAndCacheServiceInstance(i,d,h){const S=new T.Graph(t=>t.id.toString());let E=0;const p=[{id:i,desc:d,_trace:h}];for(;p.length;){const t=p.pop();if(S.lookupOrInsertNode(t),E++>1e3)throw new I(S);for(const s of P._util.getServiceDependencies(t.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(s.id);if(r||this._throwIfStrict(`[createInstance] ${i} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),r instanceof R.SyncDescriptor){const a={id:s.id,desc:r,_trace:t._trace.branch(s.id,!0)};S.insertEdge(t,a),p.push(a)}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new I(S);break}for(const{data:s}of t){if(this._getServiceInstanceOrDescriptor(s.id)instanceof R.SyncDescriptor){const a=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,a)}S.removeNode(s)}}return this._getServiceInstanceOrDescriptor(i)}_createServiceInstanceWithOwner(i,d,h=[],S,E){if(this._services.get(i)instanceof R.SyncDescriptor)return this._createServiceInstance(i,d,h,S,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(i,d,h,S,E);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(i,d,h=[],S,E){if(S){const p=new w(void 0,this._strict,this,this._enableTracing);p._globalGraphImplicitDependency=String(i);const t=new Map,s=new o.IdleValue(()=>{const r=p._createInstance(d,h,E);for(const[a,v]of t){const _=r[a];if(typeof _=="function")for(const c of v)_.apply(r,c)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,a){if(!s.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let c=t.get(a);return c||(c=new g.LinkedList,t.set(a,c)),(m,f,n)=>{const D=c.push([m,f,n]);return(0,l.toDisposable)(D)}}if(a in r)return r[a];const v=s.value;let _=v[a];return typeof _!="function"||(_=_.bind(v),r[a]=_),_},set(r,a,v){return s.value[a]=v,!0},getPrototypeOf(r){return d.prototype}})}else return this._createInstance(d,h,E)}_throwIfStrict(i,d){if(d&&console.warn(i),this._strict)throw new Error(i)}}e.InstantiationService=w;var k;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(k||(k={}));class C{static traceInvocation(i,d){return i?new C(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C._None}static traceCreation(i,d){return i?new C(1,d.name):C._None}constructor(i,d){this.type=i,this.name=d,this._start=Date.now(),this._dep=[]}branch(i,d){const h=new C(3,i.toString());return this._dep.push([i,d,h]),h}stop(){const i=Date.now()-this._start;C._totals+=i;let d=!1;function h(E,p){const t=[],s=new Array(E+1).join("	");for(const[r,a,v]of p._dep)if(a&&v){d=!0,t.push(`${s}CREATES -> ${r}`);const _=h(E+1,v);_&&t.push(_)}else t.push(`${s}uses -> ${r}`);return t.join(`
`)}const S=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${i.toFixed(2)}ms (grand total ${C._totals.toFixed(2)}ms)`];(i>2||d)&&C.all.add(S.join(`
`))}}e.Trace=C,C.all=new Set,C._None=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}},C._totals=0}),define(De[17],Ie([1,0,46,3,69,6,28,14,24,10,2,44,4]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function k(){return new Date().toISOString()}function C(m){return(0,g.isNumber)(m)}e.isLogLevel=C;var b;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(b||(e.LogLevel=b={})),e.DEFAULT_LOG_LEVEL=b.Info;function i(m,f,n){switch(f){case b.Trace:m.trace(n);break;case b.Debug:m.debug(n);break;case b.Info:m.info(n);break;case b.Warning:m.warn(n);break;case b.Error:m.error(n);break;case b.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=i;function d(m,f=!1){let n="";for(let D=0;D<m.length;D++){let M=m[D];if(M instanceof Error&&(M=(0,o.toErrorMessage)(M,f)),typeof M=="object")try{M=JSON.stringify(M)}catch{}n+=(D>0?" ":"")+M}return n}class h extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(f){this.level!==f&&(this.level=f,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(f){return this.level!==b.Off&&this.level<=f}}e.AbstractLogger=h;class S extends h{constructor(f){super(),this.logAlways=f}checkLogLevel(f){return this.logAlways||super.checkLogLevel(f)}trace(f,...n){this.checkLogLevel(b.Trace)&&this.log(b.Trace,d([f,...n],!0))}debug(f,...n){this.checkLogLevel(b.Debug)&&this.log(b.Debug,d([f,...n]))}info(f,...n){this.checkLogLevel(b.Info)&&this.log(b.Info,d([f,...n]))}warn(f,...n){this.checkLogLevel(b.Warning)&&this.log(b.Warning,d([f,...n]))}error(f,...n){if(this.checkLogLevel(b.Error))if(f instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=f.stack,this.log(b.Error,d(D))}else this.log(b.Error,d([f,...n]))}flush(){}}e.AbstractMessageLogger=S;class E extends h{constructor(f=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(f),this.useColors=!P.isWindows}trace(f,...n){this.checkLogLevel(b.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,f,...n):console.log(`[main ${k()}]`,f,...n))}debug(f,...n){this.checkLogLevel(b.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,f,...n):console.log(`[main ${k()}]`,f,...n))}info(f,...n){this.checkLogLevel(b.Info)&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,f,...n):console.log(`[main ${k()}]`,f,...n))}warn(f,...n){this.checkLogLevel(b.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,f,...n):console.warn(`[main ${k()}]`,f,...n))}error(f,...n){this.checkLogLevel(b.Error)&&(this.useColors?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,f,...n):console.error(`[main ${k()}]`,f,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class p extends h{constructor(f=e.DEFAULT_LOG_LEVEL,n=!0){super(),this.useColors=n,this.setLevel(f)}trace(f,...n){this.checkLogLevel(b.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",f,...n):console.log(f,...n))}debug(f,...n){this.checkLogLevel(b.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",f,...n):console.log(f,...n))}info(f,...n){this.checkLogLevel(b.Info)&&(this.useColors?console.log("%c INFO","color: #33f",f,...n):console.log(f,...n))}warn(f,...n){this.checkLogLevel(b.Warning)&&(this.useColors?console.log("%c WARN","color: #993",f,...n):console.log(f,...n))}error(f,...n){this.checkLogLevel(b.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",f,...n):console.error(f,...n))}dispose(){}flush(){}}e.ConsoleLogger=p;class t extends h{constructor(f,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=f,this.setLevel(n)}trace(f,...n){this.checkLogLevel(b.Trace)&&this.adapter.log(b.Trace,[this.extractMessage(f),...n])}debug(f,...n){this.checkLogLevel(b.Debug)&&this.adapter.log(b.Debug,[this.extractMessage(f),...n])}info(f,...n){this.checkLogLevel(b.Info)&&this.adapter.log(b.Info,[this.extractMessage(f),...n])}warn(f,...n){this.checkLogLevel(b.Warning)&&this.adapter.log(b.Warning,[this.extractMessage(f),...n])}error(f,...n){this.checkLogLevel(b.Error)&&this.adapter.log(b.Error,[this.extractMessage(f),...n])}extractMessage(f){return typeof f=="string"?f:(0,o.toErrorMessage)(f,this.checkLogLevel(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class s extends h{constructor(f){super(),this.loggers=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const n of this.loggers)n.setLevel(f);super.setLevel(f)}trace(f,...n){for(const D of this.loggers)D.trace(f,...n)}debug(f,...n){for(const D of this.loggers)D.debug(f,...n)}info(f,...n){for(const D of this.loggers)D.info(f,...n)}warn(f,...n){for(const D of this.loggers)D.warn(f,...n)}error(f,...n){for(const D of this.loggers)D.error(f,...n)}flush(){for(const f of this.loggers)f.flush()}dispose(){for(const f of this.loggers)f.dispose()}}e.MultiplexLogger=s;class r extends R.Disposable{constructor(f,n,D){if(super(),this.logLevel=f,this.logsHome=n,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new A.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,D)for(const M of D)this._loggers.set(M.resource,{logger:void 0,info:M})}getLoggerEntry(f){return(0,g.isString)(f)?[...this._loggers.values()].find(n=>n.info.id===f):this._loggers.get(f)}getLogger(f){return this.getLoggerEntry(f)?.logger}createLogger(f,n){const D=this.toResource(f),M=(0,g.isString)(f)?f:n?.id??(0,l.hash)(D.toString()).toString(16);let W=this._loggers.get(D)?.logger;const $=n?.logLevel==="always"?b.Trace:n?.logLevel;W||(W=this.doCreateLogger(D,$??this.getLogLevel(D)??this.logLevel,{...n,id:M}));const N={logger:W,info:{resource:D,id:M,logLevel:$,name:n?.name,hidden:n?.hidden,extensionId:n?.extensionId,when:n?.when}};return this.registerLogger(N.info),this._loggers.set(D,N),W}toResource(f){return(0,g.isString)(f)?(0,y.joinPath)(this.logsHome,`${f}.log`):f}setLogLevel(f,n){if(L.URI.isUri(f)){const D=f,M=n,W=this._loggers.get(D);W&&M!==W.info.logLevel&&(W.info.logLevel=M===this.logLevel?void 0:M,W.logger?.setLevel(M),this._loggers.set(W.info.resource,W),this._onDidChangeLogLevel.fire([D,M]))}else{this.logLevel=f;for(const[D,M]of this._loggers.entries())this._loggers.get(D)?.info.logLevel===void 0&&M.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(f,n){const D=this.getLoggerEntry(f);D&&n!==!D.info.hidden&&(D.info.hidden=!n,this._loggers.set(D.info.resource,D),this._onDidChangeVisibility.fire([D.info.resource,n]))}getLogLevel(f){let n;return f&&(n=this._loggers.get(f)?.info.logLevel),n??this.logLevel}registerLogger(f){const n=this._loggers.get(f.resource);n?n.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this._loggers.set(f.resource,{info:f,logger:void 0}),this._onDidChangeLoggers.fire({added:[f],removed:[]}))}deregisterLogger(f){const n=this._loggers.get(f);n&&(n.logger&&n.logger.dispose(),this._loggers.delete(f),this._onDidChangeLoggers.fire({added:[],removed:[n.info]}))}*getRegisteredLoggers(){for(const f of this._loggers.values())yield f.info}getRegisteredLogger(f){return this._loggers.get(f)?.info}dispose(){this._loggers.forEach(f=>f.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=r;class a{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(f){}getLevel(){return b.Info}trace(f,...n){}debug(f,...n){}info(f,...n){}warn(f,...n){}error(f,...n){}critical(f,...n){}dispose(){}flush(){}}e.NullLogger=a;class v extends a{}e.NullLogService=v;function _(m){if(m.verbose)return b.Trace;if(typeof m.logLevel=="string"){const f=u(m.logLevel.toLowerCase());if(f!==void 0)return f}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function c(m){switch(m){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=c;function u(m){switch(m){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=u,e.CONTEXT_LOG_LEVEL=new I.RawContextKey("logLevel",c(b.Info))}),define(De[213],Ie([1,0,6,17]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends o.Disposable{constructor(T,P=[]){super(),this.logger=new A.MultiplexLogger([T,...P]),this._register(T.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...P){this.logger.trace(T,...P)}debug(T,...P){this.logger.debug(T,...P)}info(T,...P){this.logger.info(T,...P)}warn(T,...P){this.logger.warn(T,...P)}error(T,...P){this.logger.error(T,...P)}flush(){this.logger.flush()}}e.LogService=l}),define(De[214],Ie([1,0,45,17]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var l;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(l||(l={}));async function R(g,L,I,w,k){try{const C=await new Promise((i,d)=>{oe(["@vscode/spdlog"],i,d)});C.setFlushOn(l.Trace);const b=await C.createAsyncRotatingLogger(g,L,I,w);return k?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(C){console.error(C)}return null}function T(g,L,I){switch(L){case A.LogLevel.Trace:g.trace(I);break;case A.LogLevel.Debug:g.debug(I);break;case A.LogLevel.Info:g.info(I);break;case A.LogLevel.Warning:g.warn(I);break;case A.LogLevel.Error:g.error(I);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function P(g,L){switch(L){case A.LogLevel.Trace:g.setLevel(l.Trace);break;case A.LogLevel.Debug:g.setLevel(l.Debug);break;case A.LogLevel.Info:g.setLevel(l.Info);break;case A.LogLevel.Warning:g.setLevel(l.Warning);break;case A.LogLevel.Error:g.setLevel(l.Error);break;case A.LogLevel.Off:g.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class y extends A.AbstractMessageLogger{constructor(L,I,w,k,C){super(),this.buffer=[],this.setLevel(C),this._loggerCreationPromise=this._createSpdLogLogger(L,I,w,k),this._register(this.onDidChangeLogLevel(b=>{this._logger&&P(this._logger,b)}))}async _createSpdLogLogger(L,I,w,k){const C=w?6:1,b=30/C*o.ByteSize.MB,i=await R(L,I,b,C,k);if(i){this._logger=i,P(this._logger,this.getLevel());for(const{level:d,message:h}of this.buffer)T(this._logger,d,h);this.buffer=[]}}log(L,I){this._logger?T(this._logger,L,I):this.getLevel()<=L&&this.buffer.push({level:L,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(De[123],Ie([1,0,38,179,4]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var T;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(y){function g(C,b){return b-C}y.compare=g;const L=Object.create(null);L[y.Error]=(0,A.localize)(0,null),L[y.Warning]=(0,A.localize)(1,null),L[y.Info]=(0,A.localize)(2,null);function I(C){return L[C]||""}y.toString=I;function w(C){switch(C){case o.default.Error:return y.Error;case o.default.Warning:return y.Warning;case o.default.Info:return y.Info;case o.default.Ignore:return y.Hint}}y.fromSeverity=w;function k(C){switch(C){case y.Error:return o.default.Error;case y.Warning:return o.default.Warning;case y.Info:return o.default.Info;case y.Hint:return o.default.Ignore}}y.toSeverity=k}(T||(e.MarkerSeverity=T={}));var P;(function(y){const g="";function L(w){return I(w,!0)}y.makeKey=L;function I(w,k){const C=[g];return w.source?C.push(w.source.replace("\xA6","\\\xA6")):C.push(g),w.code?typeof w.code=="string"?C.push(w.code.replace("\xA6","\\\xA6")):C.push(w.code.value.replace("\xA6","\\\xA6")):C.push(g),w.severity!==void 0&&w.severity!==null?C.push(T.toString(w.severity)):C.push(g),w.message&&k?C.push(w.message.replace("\xA6","\\\xA6")):C.push(g),w.startLineNumber!==void 0&&w.startLineNumber!==null?C.push(w.startLineNumber.toString()):C.push(g),w.startColumn!==void 0&&w.startColumn!==null?C.push(w.startColumn.toString()):C.push(g),w.endLineNumber!==void 0&&w.endLineNumber!==null?C.push(w.endLineNumber.toString()):C.push(g),w.endColumn!==void 0&&w.endColumn!==null?C.push(w.endColumn.toString()):C.push(g),C.push(g),C.join("\xA6")}y.makeKeyOptionalMessage=I})(P||(e.IMarkerData=P={})),e.IMarkerService=(0,l.createDecorator)("markerService")}),define(De[215],Ie([1,0,3,38,4]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,l.createDecorator)("notificationService");var R;(function(L){L[L.DEFAULT=0]="DEFAULT",L[L.SILENT=1]="SILENT",L[L.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var T;(function(L){L[L.WORKSPACE=0]="WORKSPACE",L[L.PROFILE=1]="PROFILE",L[L.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));var P;(function(L){L[L.OFF=0]="OFF",L[L.SILENT=1]="SILENT",L[L.ERROR=2]="ERROR"})(P||(e.NotificationsFilter=P={}));class y{constructor(){this.progress=new g,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.NoOpNotification=y;class g{infinite(){}done(){}total(I){}worked(I){}}e.NoOpProgress=g}),define(De[124],Ie([1,0,9,2,4]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,l.createDecorator)("openerService");function R(g,L){return A.URI.isUri(g)?(0,o.equalsIgnoreCase)(g.scheme,L):(0,o.startsWithIgnoreCase)(g,L+":")}e.matchesScheme=R;function T(g,...L){return L.some(I=>R(g,I))}e.matchesSomeScheme=T;function P(g,L){return g.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=P;function y(g){let L;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return I&&(L={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},g=g.with({fragment:""})),{selection:L,uri:g}}e.extractSelection=y}),define(De[216],Ie([1,0,16,14,33,206]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.context<"u"){const P=A.globals.vscode.context.configuration();if(P)T=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){T=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:P,searchUrl:y,itemUrl:g,controlUrl:L}=T.extensionsGallery||{};Object.assign(T,{extensionsGallery:{serviceUrl:l.env.VSCODE_GALLERY_SERVICE_URL||P,searchUrl:l.env.VSCODE_GALLERY_SEARCH_URL||y,itemUrl:l.env.VSCODE_GALLERY_ITEM_URL||g,controlUrl:l.env.VSCODE_GALLERY_CONTROL_URL||L}});try{const I=(...b)=>b.reduce((i,d)=>(Object.keys(d).forEach(h=>{Array.isArray(i[h])&&Array.isArray(d[h])?i[h]=d[h]:typeof i[h]=="object"&&typeof d[h]=="object"?i[h]=I(i[h],d[h]):i[h]=d[h]}),i),{}),w=(0,R.getUserDataPath)({},T.nameShort),k=A.isWindows?`file:///${w}/product.json`:`file://${w}/product.json`,C=oe.__$__nodeRequire(o.FileAccess.asFileUri(k).fsPath);T=I(T,C)}catch{}if(l.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:I.version,release:I.release})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(De[217],Ie([1,0,4]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,o.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__param||function(oe,e){return function(o,A){e(o,A,oe)}};define(De[125],Ie([1,0,19,21,6,4]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var T;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this._value}constructor(I){this.callback=I}report(I){this._value=I,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let y=e.UnmanagedProgress=class extends l.Disposable{constructor(I,w){super(),this.deferred=new o.DeferredPromise,w.withProgress(I,k=>(this.reporter=k,this.lastStep&&k.report(this.lastStep),this.deferred.p)),this._register((0,l.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};e.UnmanagedProgress=y=Ve([ze(1,e.IProgressService)],y);class g extends l.Disposable{constructor(I){super(),this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new l.DisposableStore)}start(I){this.stop();const w=++this.currentOperationId,k=new A.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{w===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,l.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,l.toDisposable)(()=>k.cancel())),this.currentOperationDisposables.add((0,l.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:w,token:k.token,stop:()=>this.doStop(w),isCurrent:()=>this.currentOperationId===w}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=g,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(De[40],Ie([1,0,51,10]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.data=new Map}add(T,P){o.ok(A.isString(T)),o.ok(A.isObject(P)),o.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new l}),define(De[93],Ie([1,0,3,40]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this._onDidChangeSchema=new o.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,g){this.schemasById[l(y)]=g,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new R;A.Registry.add(e.Extensions.JSONContribution,T)}),define(De[126],Ie([1,0,18,3,10,172,56,93,40]),function(oe,e,o,A,l,R,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=y.Registry.as(P.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const r=new Set;this.doRegisterConfigurations(t,s,r),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(t){const s=new Set;this.doDeregisterConfigurations(t,s),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:t,remove:s}){const r=new Set;this.doDeregisterConfigurations(s,r),this.doRegisterConfigurations(t,!1,r),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(t){const s=new Set;this.doRegisterDefaultConfigurations(t,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,s){const r=[];for(const{overrides:a,source:v}of t)for(const _ in a)if(s.add(_),e.OVERRIDE_PROPERTY_REGEX.test(_)){const c=this.configurationDefaultsOverrides.get(_),u=c?.valuesSources??new Map;if(v)for(const D of Object.keys(a[_]))u.set(D,v);const m={...c?.value||{},...a[_]};this.configurationDefaultsOverrides.set(_,{source:v,value:m,valuesSources:u});const f=(0,T.getLanguageTagSettingPlainKey)(_),n={type:"object",default:m,description:R.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:l.isString(v)?void 0:v,defaultValueSource:v};r.push(...b(_)),this.configurationProperties[_]=n,this.defaultLanguageConfigurationOverridesNode.properties[_]=n}else{this.configurationDefaultsOverrides.set(_,{value:a[_],source:v});const c=this.configurationProperties[_];c&&(this.updatePropertyDefaultValue(_,c),this.updateSchema(_,c))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(t){const s=new Set;this.doDeregisterDefaultConfigurations(t,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,s){for(const{overrides:r,source:a}of t)for(const v in r){const _=this.configurationDefaultsOverrides.get(v),c=l.isString(a)?a:a?.id,u=l.isString(_?.source)?_?.source:_?.source?.id;if(c===u)if(s.add(v),this.configurationDefaultsOverrides.delete(v),e.OVERRIDE_PROPERTY_REGEX.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const m=this.configurationProperties[v];m&&(this.updatePropertyDefaultValue(v,m),this.updateSchema(v,m))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let s=!1;const r=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,r),s=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,r),s=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,r),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const s of t)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,s,r){t.forEach(a=>{this.validateAndRegisterProperties(a,s,a.extensionInfo,a.restrictedProperties,void 0,r),this.configurationContributors.push(a),this.registerJSONConfiguration(a)})}doDeregisterConfigurations(t,s){const r=a=>{if(a.properties)for(const v in a.properties){s.add(v);const _=this.configurationProperties[v];_?.policy?.name&&this.policyConfigurations.delete(_.policy.name),delete this.configurationProperties[v],this.removeFromSchema(v,a.properties[v])}a.allOf?.forEach(v=>r(v))};for(const a of t){r(a);const v=this.configurationContributors.indexOf(a);v!==-1&&this.configurationContributors.splice(v,1)}}validateAndRegisterProperties(t,s=!0,r,a,v=3,_){v=l.isUndefinedOrNull(t.scope)?v:t.scope;const c=t.properties;if(c)for(const m in c){const f=c[m];if(s&&S(m,f)){delete c[m];continue}if(f.source=r,f.defaultDefaultValue=c[m].default,this.updatePropertyDefaultValue(m,f),e.OVERRIDE_PROPERTY_REGEX.test(m)?f.scope=void 0:(f.scope=l.isUndefinedOrNull(f.scope)?v:f.scope,f.restricted=l.isUndefinedOrNull(f.restricted)?!!a?.includes(m):f.restricted),c[m].hasOwnProperty("included")&&!c[m].included){this.excludedConfigurationProperties[m]=c[m],delete c[m];continue}else this.configurationProperties[m]=c[m],c[m].policy?.name&&this.policyConfigurations.set(c[m].policy.name,m);!c[m].deprecationMessage&&c[m].markdownDeprecationMessage&&(c[m].deprecationMessage=c[m].markdownDeprecationMessage),_.add(m)}const u=t.allOf;if(u)for(const m of u)this.validateAndRegisterProperties(m,s,r,a,v,_)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const s=r=>{const a=r.properties;if(a)for(const _ in a)this.updateSchema(_,a[_]);r.allOf?.forEach(s)};s(t)}updateSchema(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.resourceLanguageSettingsSchema.properties[t]=s;break}}removeFromSchema(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const s=`[${t}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,r),e.allSettings.properties[s]=r,e.applicationSettings.properties[s]=r,e.machineSettings.properties[s]=r,e.machineOverridableSettings.properties[s]=r,e.windowSettings.properties[s]=r,e.resourceSettings.properties[s]=r}}registerOverridePropertyPatternKey(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,s){const r=this.configurationDefaultsOverrides.get(t);let a=r?.value,v=r?.source;l.isUndefined(a)&&(a=s.defaultDefaultValue,v=void 0),l.isUndefined(a)&&(a=d(s.type)),s.default=a,s.defaultValueSource=v}}const k="\\[([^\\]]+)\\]",C=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(p){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let s=C.exec(p);for(;s?.length;){const r=s[1].trim();r&&t.push(r),s=C.exec(p)}}return(0,o.distinct)(t)}e.overrideIdentifiersFromKey=b;function i(p){return p.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=i;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const h=new w;y.Registry.add(e.Extensions.Configuration,h);function S(p,t){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?R.localize(7,null,p):h.getConfigurationProperties()[p]!==void 0?R.localize(8,null,p):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,p,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=S;function E(){const p=[],t=h.getConfigurationProperties();for(const s of Object.keys(t))p.push([s,t[s].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=E}),define(De[218],Ie([1,0,18,3,148,6,28,23,10,2,56,126,40]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function k(s){return Object.isFrozen(s)?s:P.deepFreeze(s)}class C{constructor(r={},a=[],v=[],_){this._contents=r,this._keys=a,this._overrides=v,this.raw=_,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof C)return a;const v=new b("");return v.parseRaw(a),v.configurationModel});this._rawConfiguration=r.reduce((a,v)=>v===a?v:a.merge(v),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,L.getConfigurationValue)(this.contents,r):this.contents}inspect(r,a){const v=this.rawConfiguration.getValue(r),_=a?this.rawConfiguration.getOverrideValue(r,a):void 0,c=a?this.rawConfiguration.override(a).getValue(r):v;return{value:v,override:_,merged:c}}getOverrideValue(r,a){const v=this.getContentsForOverrideIdentifer(a);return v?r?(0,L.getConfigurationValue)(v,r):v:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const v of this.overrides)v.identifiers.includes(r)&&a.push(...v.keys);return o.distinct(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return o.distinct(r)}override(r){let a=this.overrideConfigurations.get(r);return a||(a=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,a)),a}merge(...r){const a=P.deepClone(this.contents),v=P.deepClone(this.overrides),_=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const u of r)if(c.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.mergeContents(a,u.contents);for(const m of u.overrides){const[f]=v.filter(n=>o.equals(n.identifiers,m.identifiers));f?(this.mergeContents(f.contents,m.contents),f.keys.push(...m.keys),f.keys=o.distinct(f.keys)):v.push(P.deepClone(m))}for(const m of u.keys)_.indexOf(m)===-1&&_.push(m)}return new C(a,_,v,c.every(u=>u instanceof C)?void 0:c)}createOverrideConfigurationModel(r){const a=this.getContentsForOverrideIdentifer(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const v={};for(const _ of o.distinct([...Object.keys(this.contents),...Object.keys(a)])){let c=this.contents[_];const u=a[_];u&&(typeof c=="object"&&typeof u=="object"?(c=P.deepClone(c),this.mergeContents(c,u)):c=u),v[_]=c}return new C(v,this.keys,this.overrides)}mergeContents(r,a){for(const v of Object.keys(a)){if(v in r&&y.isObject(r[v])&&y.isObject(a[v])){this.mergeContents(r[v],a[v]);continue}r[v]=P.deepClone(a[v])}}getContentsForOverrideIdentifer(r){let a=null,v=null;const _=c=>{c&&(v?this.mergeContents(v,c):v=P.deepClone(c))};for(const c of this.overrides)o.equals(c.identifiers,[r])?a=c.contents:c.identifiers.includes(r)&&_(c.contents);return _(a),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,a){this.updateValue(r,a,!0)}setValue(r,a){this.updateValue(r,a,!1)}removeValue(r){const a=this.keys.indexOf(r);a!==-1&&(this.keys.splice(a,1),(0,L.removeFromValueTree)(this.contents,r),I.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(v=>o.equals(v.identifiers,(0,I.overrideIdentifiersFromKey)(r))),1))}updateValue(r,a,v){(0,L.addToValueTree)(this.contents,r,a,_=>console.error(_)),v=v||this.keys.indexOf(r)===-1,v&&this.keys.push(r),I.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,L.toValuesTree)(this.contents[r],_=>console.error(_))})}}e.ConfigurationModel=C;class b{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,a){if(!y.isUndefinedOrNull(r)){const v=this.doParseContent(r);this.parseRaw(v,a)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,a){this._raw=r;const{contents:v,keys:_,overrides:c,restricted:u,hasExcludedProperties:m}=this.doParseRaw(r,a);this._configurationModel=new C(v,_,c,m?[r]:void 0),this._restrictedConfigurations=u||[]}doParseContent(r){let a={},v=null,_=[];const c=[],u=[];function m(n){Array.isArray(_)?_.push(n):v!==null&&(_[v]=n)}const f={onObjectBegin:()=>{const n={};m(n),c.push(_),_=n,v=null},onObjectProperty:n=>{v=n},onObjectEnd:()=>{_=c.pop()},onArrayBegin:()=>{const n=[];m(n),c.push(_),_=n,v=null},onArrayEnd:()=>{_=c.pop()},onLiteralValue:m,onError:(n,D,M)=>{u.push({error:n,offset:D,length:M})}};if(r)try{l.visit(r,f),a=_[0]||{}}catch(n){console.error(`Error while parsing settings file ${this._name}: ${n}`),this._parseErrors=[n]}return a}doParseRaw(r,a){const v=w.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),_=this.filter(r,v,!0,a);r=_.raw;const c=(0,L.toValuesTree)(r,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),u=Object.keys(r),m=this.toOverrides(r,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:c,keys:u,overrides:m,restricted:_.restricted,hasExcludedProperties:_.hasExcludedProperties}}filter(r,a,v,_){let c=!1;if(!_?.scopes&&!_?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const u={},m=[];for(const f in r)if(I.OVERRIDE_PROPERTY_REGEX.test(f)&&v){const n=this.filter(r[f],a,!1,_);u[f]=n.raw,c=c||n.hasExcludedProperties,m.push(...n.restricted)}else{const n=a[f],D=n?typeof n.scope<"u"?n.scope:3:void 0;n?.restricted&&m.push(f),(D===void 0||_.scopes===void 0||_.scopes.includes(D))&&!(_.skipRestricted&&n?.restricted)?u[f]=r[f]:c=!0}return{raw:u,restricted:m,hasExcludedProperties:c}}toOverrides(r,a){const v=[];for(const _ of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(_)){const c={};for(const u in r[_])c[u]=r[_][u];v.push({identifiers:(0,I.overrideIdentifiersFromKey)(_),keys:Object.keys(c),contents:(0,L.toValuesTree)(c,a)})}return v}}e.ConfigurationModelParser=b;class i extends R.Disposable{constructor(r,a,v,_){super(),this.userSettingsResource=r,this.scopes=a,this.fileService=_,this._onDidChange=this._register(new A.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(v.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(A.Event.any(A.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),A.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&v.isEqual(c.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new C}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=i;class d{constructor(r,a,v,_,c,u,m,f,n,D,M,W,$){this.key=r,this.overrides=a,this._value=v,this.overrideIdentifiers=_,this.defaultConfiguration=c,this.policyConfiguration=u,this.applicationConfiguration=m,this.userConfiguration=f,this.localUserConfiguration=n,this.remoteUserConfiguration=D,this.workspaceConfiguration=M,this.folderConfigurationModel=W,this.memoryConfigurationModel=$}get value(){return k(this._value)}inspect(r,a,v){const _=r.inspect(a,v);return{get value(){return k(_.value)},get override(){return k(_.override)},get merged(){return k(_.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(r,a,v,_,c=new C,u=new C,m=new T.ResourceMap,f=new C,n=new T.ResourceMap){this._defaultConfiguration=r,this._policyConfiguration=a,this._applicationConfiguration=v,this._localUserConfiguration=_,this._remoteUserConfiguration=c,this._workspaceConfiguration=u,this._folderConfigurations=m,this._memoryConfiguration=f,this._memoryConfigurationByResource=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(r,a,v){return this.getConsolidatedConfigurationModel(r,a,v).getValue(r)}updateValue(r,a,v={}){let _;v.resource?(_=this._memoryConfigurationByResource.get(v.resource),_||(_=new C,this._memoryConfigurationByResource.set(v.resource,_))):_=this._memoryConfiguration,a===void 0?_.removeValue(r):_.setValue(r,a),v.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,a,v){const _=this.getConsolidatedConfigurationModel(r,a,v),c=this.getFolderConfigurationModelForResource(a.resource,v),u=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,m=new Set;for(const f of _.overrides)for(const n of f.identifiers)_.getOverrideValue(r,n)!==void 0&&m.add(n);return new d(r,a,_.getValue(r),m.size?[...m]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this._workspaceConfiguration:void 0,c||void 0,u)}keys(r){const a=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,a){this._folderConfigurations.set(r,a),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const v=[];if(!a){const{added:_,updated:c,removed:u}=p(this._defaultConfiguration,r);a=[..._,...c,...u]}for(const _ of a)for(const c of(0,I.overrideIdentifiersFromKey)(_)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(c),m=r.getKeysForOverrideIdentifier(c),f=[...m.filter(n=>u.indexOf(n)===-1),...u.filter(n=>m.indexOf(n)===-1),...u.filter(n=>!P.equals(this._defaultConfiguration.override(c).getValue(n),r.override(c).getValue(n)))];v.push([c,f])}return this.updateDefaultConfiguration(r),{keys:a,overrides:v}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:v,removed:_}=p(this._policyConfiguration,r),c=[...a,...v,..._];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:v,removed:_,overrides:c}=p(this.applicationConfiguration,r),u=[...a,...v,..._];return u.length&&this.updateApplicationConfiguration(r),{keys:u,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:v,removed:_,overrides:c}=p(this.localUserConfiguration,r),u=[...a,...v,..._];return u.length&&this.updateLocalUserConfiguration(r),{keys:u,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:v,removed:_,overrides:c}=p(this.remoteUserConfiguration,r),u=[...a,...v,..._];return u.length&&this.updateRemoteUserConfiguration(r),{keys:u,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:v,removed:_,overrides:c}=p(this.workspaceConfiguration,r),u=[...a,...v,..._];return u.length&&this.updateWorkspaceConfiguration(r),{keys:u,overrides:c}}compareAndUpdateFolderConfiguration(r,a){const v=this.folderConfigurations.get(r),{added:_,updated:c,removed:u,overrides:m}=p(v,a),f=[..._,...c,...u];return(f.length||!v)&&this.updateFolderConfiguration(r,a),{keys:f,overrides:m}}compareAndDeleteFolderConfiguration(r){const a=this.folderConfigurations.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:v,updated:_,removed:c,overrides:u}=p(a,void 0);return{keys:[...v,..._,...c],overrides:u}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,a,v){let _=this.getConsolidatedConfigurationModelForResource(a,v);return a.overrideIdentifier&&(_=_.override(a.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(_=_.merge(this._policyConfiguration)),_}getConsolidatedConfigurationModelForResource({resource:r},a){let v=this.getWorkspaceConsolidatedConfiguration();if(a&&r){const _=a.getFolder(r);_&&(v=this.getFolderConsolidatedConfiguration(_.uri)||v);const c=this._memoryConfigurationByResource.get(r);c&&(v=v.merge(c))}return v}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let a=this._foldersConsolidatedConfigurations.get(r);if(!a){const v=this.getWorkspaceConsolidatedConfiguration(),_=this._folderConfigurations.get(r);_?(a=v.merge(_),this._foldersConsolidatedConfigurations.set(r,a)):a=v}return a}getFolderConfigurationModelForResource(r,a){if(a&&r){const v=a.getFolder(r);if(v)return this._folderConfigurations.get(v.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,a)=>{const{contents:v,overrides:_,keys:c}=this._folderConfigurations.get(a);return r.push([a,{contents:v,overrides:_,keys:c}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(a=>r.add(a)),this.userConfiguration.keys.forEach(a=>r.add(a)),this._workspaceConfiguration.keys.forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.keys.forEach(v=>r.add(v))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.getAllOverrideIdentifiers().forEach(v=>r.add(v))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(v=>a.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(v=>a.add(v)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(v=>a.add(v)),this._folderConfigurations.forEach(v=>v.getKeysForOverrideIdentifier(r).forEach(_=>a.add(_))),[...a.values()]}static parse(r){const a=this.parseConfigurationModel(r.defaults),v=this.parseConfigurationModel(r.policy),_=this.parseConfigurationModel(r.application),c=this.parseConfigurationModel(r.user),u=this.parseConfigurationModel(r.workspace),m=r.folders.reduce((f,n)=>(f.set(g.URI.revive(n[0]),this.parseConfigurationModel(n[1])),f),new T.ResourceMap);return new h(a,v,_,c,new C,u,m,new C,new T.ResourceMap)}static parseConfigurationModel(r){return new C(r.contents,r.keys,r.overrides)}}e.Configuration=h;function S(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,a=new Map;for(const _ of s)_.keys.forEach(c=>r.add(c)),_.overrides.forEach(([c,u])=>{const m=(0,T.getOrSet)(a,c,new Set);u.forEach(f=>m.add(f))});const v=[];return a.forEach((_,c)=>v.push([c,[..._.values()]])),{keys:[...r.values()],overrides:v}}e.mergeChanges=S;class E{constructor(r,a,v,_){this.change=r,this.previous=a,this.currentConfiguraiton=v,this.currentWorkspace=_,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const u of c)this.affectedKeys.add(u);this._affectsConfigStr=this._marker;for(const c of this.affectedKeys)this._affectsConfigStr+=c+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,a){const v=this._marker+r,_=this._affectsConfigStr.indexOf(v);if(_<0)return!1;const c=_+v.length;if(c>=this._affectsConfigStr.length)return!1;const u=this._affectsConfigStr.charCodeAt(c);if(u!==this._markerCode1&&u!==this._markerCode2)return!1;if(a){const m=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.previous?.workspace):void 0,f=this.currentConfiguraiton.getValue(r,a,this.currentWorkspace);return!P.equals(m,f)}return!0}}e.ConfigurationChangeEvent=E;function p(s,r){const{added:a,removed:v,updated:_}=t(r?.rawConfiguration,s?.rawConfiguration),c=[],u=s?.getAllOverrideIdentifiers()||[],m=r?.getAllOverrideIdentifiers()||[];if(r){const f=m.filter(n=>!u.includes(n));for(const n of f)c.push([n,r.getKeysForOverrideIdentifier(n)])}if(s){const f=u.filter(n=>!m.includes(n));for(const n of f)c.push([n,s.getKeysForOverrideIdentifier(n)])}if(r&&s){for(const f of u)if(m.includes(f)){const n=t({contents:s.getOverrideValue(void 0,f)||{},keys:s.getKeysForOverrideIdentifier(f)},{contents:r.getOverrideValue(void 0,f)||{},keys:r.getKeysForOverrideIdentifier(f)});c.push([f,[...n.added,...n.removed,...n.updated]])}}return{added:a,removed:v,updated:_,overrides:c}}function t(s,r){const a=s?r?s.keys.filter(c=>r.keys.indexOf(c)===-1):[...s.keys]:[],v=r?s?r.keys.filter(c=>s.keys.indexOf(c)===-1):[...r.keys]:[],_=[];if(s&&r){for(const c of r.keys)if(s.keys.indexOf(c)!==-1){const u=(0,L.getConfigurationValue)(r.contents,c),m=(0,L.getConfigurationValue)(s.contents,c);P.equals(u,m)||_.push(c)}}return{added:a,removed:v,updated:_}}}),define(De[127],Ie([1,0,8,4]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class R extends o.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof R&&y._code===l.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===l.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===l.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}constructor(y,g=l.Unknown,L){super(y),this._message=y,this._code=g,this._detail=L,this.isHandled=g===l.NotAvailable&&L===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function T(P){const y=P.indexOf("+");return y===-1?P:P.substring(0,y)}e.getRemoteAuthorityPrefix=T}),define(De[74],Ie([1,0,16]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(g){return g.scheme===o.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=A;function l(g){if(!g)return;const L=g.indexOf("+");return L<0?g:g.substr(0,L)}e.getRemoteName=l;function R(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.getRemoteServerRootPath=R;function T(g){const{host:L,port:I}=y(g);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:I}}e.parseAuthorityWithPort=T;function P(g,L){let{host:I,port:w}=y(g);return typeof w>"u"&&(w=L),{host:I,port:w}}e.parseAuthorityWithOptionalPort=P;function y(g){const L=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const I=g.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const w=g.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:g,port:void 0}}}),define(De[25],Ie([1,0,9,4,74]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(T||(e.ExtensionType=T={}));var P;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,d){if(typeof i>"u"||i===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof i=="string"||typeof d=="string"){const h=typeof i=="string"?i:i.value,S=typeof d=="string"?d:d.value;return o.equalsIgnoreCase(h,S)}return i._lower===d._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;class g{get size(){return this._set.size}constructor(i){if(this._set=new Set,i)for(const d of i)this.add(d)}add(i){this._set.add(y.toKey(i))}delete(i){return this._set.delete(y.toKey(i))}has(i){return this._set.has(y.toKey(i))}}e.ExtensionIdentifierSet=g;class L{constructor(){this._map=new Map}clear(){this._map.clear()}delete(i){this._map.delete(y.toKey(i))}get(i){return this._map.get(y.toKey(i))}has(i){return this._map.has(y.toKey(i))}set(i,d){this._map.set(y.toKey(i),d)}values(){return this._map.values()}forEach(i){this._map.forEach(i)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=L;function I(b){return w(b)}e.isApplicationScopedExtension=I;function w(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function k(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=k;function C(b,i){if(i){const d=`onResolveRemoteAuthority:${(0,l.getRemoteName)(i)}`;return!!b.activationEvents?.includes(d)}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[128],Ie([1,0,8,25]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class l{constructor(){this._generators=new Map,this._cache=new WeakMap}register(T,P){this._generators.set(T,P)}readActivationEvents(T){return this._cache.has(T)||this._cache.set(T,this._readActivationEvents(T)),this._cache.get(T)}createActivationEventsMap(T){const P=Object.create(null);for(const y of T){const g=this.readActivationEvents(y);g.length>0&&(P[A.ExtensionIdentifier.toKey(y.identifier)]=g)}return P}_readActivationEvents(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const P=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];if(!T.contributes)return P;for(const y in T.contributes){const g=this._generators.get(y);if(!g)continue;const L=T.contributes[y],I=Array.isArray(L)?L:[L];try{g(I,P)}catch(w){(0,o.onUnexpectedError)(w)}}return P}}e.ImplicitActivationEventsImpl=l,e.ImplicitActivationEvents=new l}),define(De[219],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class o{constructor(){this.validators=new Map}vsda(){return new Promise((l,R)=>oe(["vsda"],l,R))}async createNewMessage(l){try{const R=await this.vsda(),T=new R.validator;if(T){const P=String(o._nextId++);return this.validators.set(P,T),{id:P,data:T.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,R){if(!l.id)return!0;const T=this.validators.get(l.id);if(!T)return!1;this.validators.delete(l.id);try{return T.validate(R)==="ok"}catch{return!1}}async sign(l){try{const R=await this.vsda(),T=new R.signer;if(T)return T.sign(l)}catch{}return l}}e.SignService=o,o._nextId=1}),define(De[220],Ie([1,0,14,33,30]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(y){if(o.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function T(y,g,L,I,w,k,C,b){const i=Object.create(null);i["common.machineId"]=k,i.sessionID=(0,l.generateUuid)()+Date.now(),i.commitHash=I,i.version=w,i["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,o.PlatformToString)(o.platform),i["common.nodePlatform"]=A.platform,i["common.nodeArch"]=L,i["common.product"]=b||"desktop",C&&(i["common.msftInternal"]=C);let d=0;const h=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),o.isLinuxSnap&&(i["common.snap"]="true");const S=R(g);return S&&(i["common.platformDetail"]=S),i}e.resolveCommonProperties=T;function P(y){const g=A.env.USERDNSDOMAIN;if(!g)return!1;const L=g.toLowerCase();return y.some(I=>L===I)}e.verifyMicrosoftInternalDomain=P}),define(De[221],Ie([1,0,4]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,o.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,o.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var l;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(l||(e.TelemetryConfiguration=l={}))}),define(De[75],Ie([1,0,23,10,3,56,74,220,221]),function(oe,e,o,A,l,R,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class g{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=g;class L{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class I{async publicLog(v,_,c){}async publicLogError(v,_,c){}}e.NullEndpointTelemetryService=I,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(a,v){return l.Event.debounce(v.onDidChangeConfiguration,(c,u)=>{const m=c?new Set([...c.affectedKeys,...u.affectedKeys]):u.affectedKeys;return{...u,affectedKeys:m}},1e3,!0)(c=>{c.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=w;function k(a,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!a.enableTelemetry||v.extensionTestsLocationURI)}e.supportsTelemetry=k;function C(a,v){return!(v.isBuilt||v.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=C;function b(a){const v=a.getValue(y.TELEMETRY_SETTING_ID),_=a.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||_===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function i(a){const v={},_={},c={};S(a,c);for(let u in c){u=u.length>150?u.substr(u.length-149):u;const m=c[u];typeof m=="number"?_[u]=m:typeof m=="boolean"?_[u]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${m.length}`),v[u]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(v[u]=m)}return{properties:v,measurements:_}}e.validateTelemetryData=i;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(a){if(!a)return"none";const v=(0,T.getRemoteName)(a);return d.has(v)?v:"other"}e.cleanRemoteAuthority=h;function S(a,v,_=0,c){if(a)for(const u of Object.getOwnPropertyNames(a)){const m=a[u],f=c?c+u:u;Array.isArray(m)?v[f]=(0,o.safeStringify)(m):m instanceof Date?v[f]=m.toISOString():(0,A.isObject)(m)?_<2?S(m,v,_+1,f+"."):v[f]=(0,o.safeStringify)(m):v[f]=m}}function E(a,v){const _=a.msftInternalDomains||[],c=v.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(_)||c}e.isInternalTelemetry=E;function p(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=p;function t(a,v){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let _=a;const c=[];for(const n of v)for(;;){const D=n.exec(a);if(!D)break;c.push([D.index,n.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(_="";;){const n=m.exec(a);if(!n)break;const D=c.some(([M,W])=>n.index<W&&M<m.lastIndex);!u.test(n[0])&&!D&&(_+=a.substring(f,n.index)+"<REDACTED: user-file-path>",f=m.lastIndex)}return f<a.length&&(_+=a.substr(f)),_}function s(a){if(!a)return a;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const _ of v)if(_.regex.test(a))return`<REDACTED: ${_.label}>`;return a}function r(a,v){return(0,o.cloneAndChange)(a,_=>{if(_ instanceof g||Object.hasOwnProperty.call(_,"isTrustedTelemetryValue"))return _.value;if(typeof _=="string"){let c=_.replaceAll("%20"," ");c=t(c,v);for(const u of v)c=c.replace(u,"");return c=s(c),c}})}e.cleanData=r}),define(De[222],Ie([1,0,9,122,25,14,2,8,33,75]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(r,a){return r.uuid&&a.uuid?r.uuid===a.uuid:r.id===a.id?!0:(0,o.compareIgnoreCase)(r.id,a.id)===0}e.areSameExtensions=L;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(a){const v=a.manifest?a.manifest.version:a.version,_=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new w(a.identifier,v,_)}static parse(a){const v=I.exec(a);return v&&v[1]&&v[2]?new w({id:v[1]},v[2],v[4]||void 0):null}constructor(a,v,_="undefined"){this.version=v,this.targetPlatform=_,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof w?L(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=w;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(r){const a=k.exec(r);return a&&a[1]?[i(a[1]),a[2]]:[i(r),void 0]}e.getIdAndVersion=C;function b(r,a){return`${r}.${a}`}e.getExtensionId=b;function i(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=i;function d(r,a){return i(b(r??l.UNDEFINED_PUBLISHER,a))}e.getGalleryExtensionId=d;function h(r,a){const v=[],_=c=>{for(const u of v)if(u.some(m=>L(a(m),a(c))))return u;return null};for(const c of r){const u=_(c);u?u.push(c):v.push([c])}return v}e.groupByExtension=h;function S(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function E(r){return{id:new g.TelemetryTrustedValue(r.identifier.id),name:new g.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function p(r,a){const v=[],_=a.manifest.extensionDependencies?.slice(0)??[];for(;_.length;){const c=_.shift();if(c&&v.every(u=>!L(u.identifier,{id:c}))){const u=r.filter(m=>L(m.identifier,{id:c}));u.length===1&&(v.push(u[0]),_.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=p;async function t(r,a){if(!R.isLinux)return!1;let v;try{v=(await r.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await r.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){a.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,a){const v=await t(r,a),_=(0,A.getTargetPlatform)(v?"alpine":R.platform,y.arch);return a.debug("ComputeTargetPlatform:",_),_}e.computeTargetPlatform=s}),define(De[223],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function o(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=o;function A(y){return y?[...y.entries()]:[]}e.serializeEnvironmentDescriptionMap=A;function l(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=l;function R(y){return new Map(y??[])}e.deserializeEnvironmentDescriptionMap=R;function T(y){return Array.from(y.entries()).map(g=>[g[0],o(g[1].map),A(g[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=T;function P(y){return new Map(y.map(g=>[g[0],{map:l(g[1]),descriptionMap:R(g[2])}]))}e.deserializeEnvironmentVariableCollections=P}),define(De[224],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(l){this._callback=l,this._terminalBufferMap=new Map}dispose(){for(const l of this._terminalBufferMap.values())l.dispose()}startBuffering(l,R,T=5){const P=R(y=>{const g=typeof y=="string"?y:y.data;let L=this._terminalBufferMap.get(l);if(L){L.data.push(g);return}const I=setTimeout(()=>this.flushBuffer(l),T);L={data:[g],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(l),P.dispose()}},this._terminalBufferMap.set(l,L)});return P}stopBuffering(l){this._terminalBufferMap.get(l)?.dispose()}flushBuffer(l){const R=this._terminalBufferMap.get(l);R&&(this._terminalBufferMap.delete(l),this._callback(l,R.data.join("")))}}e.TerminalDataBufferer=o}),define(De[225],Ie([1,0,19,68,53,3,10,2,180,93,40]),function(oe,e,o,A,l,R,T,P,y,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var I;(function(E){function p(t,s){let r=t.defaults;for(;l.ThemeIcon.isThemeIcon(r);){const a=C.getIcon(r.id);if(!a)return;r=a.defaults}return r}E.getDefinition=p})(I||(e.IconContribution=I={}));var w;(function(E){function p(s){return{weight:s.weight,style:s.style,src:s.src.map(r=>({format:r.format,location:r.location.toString()}))}}E.toJSONObject=p;function t(s){const r=a=>(0,T.isString)(a)?a:void 0;if(s&&Array.isArray(s.src)&&s.src.every(a=>(0,T.isString)(a.format)&&(0,T.isString)(a.location)))return{weight:r(s.weight),style:r(s.style),src:s.src.map(a=>({format:a.format,location:P.URI.parse(a.location)}))}}E.fromJSONObject=t})(w||(e.IconFontDefinition=w={}));class k{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${l.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(p,t,s,r){const a=this.iconsById[p];if(a){if(s&&!a.description){a.description=s,this.iconSchema.properties[p].markdownDescription=`${s} $(${p})`;const c=this.iconReferenceSchema.enum.indexOf(p);c!==-1&&(this.iconReferenceSchema.enumDescriptions[c]=s),this._onDidChange.fire()}return a}const v={id:p,description:s,defaults:t,deprecationMessage:r};this.iconsById[p]=v;const _={$ref:"#/definitions/icons"};return r&&(_.deprecationMessage=r),s&&(_.markdownDescription=`${s}: $(${p})`),this.iconSchema.properties[p]=_,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const t=this.iconReferenceSchema.enum.indexOf(p);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(p,t){const s=this.iconFontsById[p];return s||(this.iconFontsById[p]=t,this._onDidChange.fire(),t)}deregisterIconFont(p){delete this.iconFontsById[p]}getIconFont(p){return this.iconFontsById[p]}toString(){const p=(a,v)=>a.id.localeCompare(v.id),t=a=>{for(;l.ThemeIcon.isThemeIcon(a.defaults);)a=this.iconsById[a.defaults.id];return`codicon codicon-${a?a.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.iconsById).map(a=>this.iconsById[a]);for(const a of r.filter(v=>!!v.description).sort(p))s.push(`|<i class="${t(a)}"></i>|${a.id}|${l.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const a of r.filter(v=>!l.ThemeIcon.isThemeIcon(v.defaults)).sort(p))s.push(`|<i class="${t(a)}"></i>|${a.id}|`);return s.join(`
`)}}const C=new k;L.Registry.add(e.Extensions.IconContribution,C);function b(E,p,t,s){return C.registerIcon(E,p,t,s)}e.registerIcon=b;function i(){return C}e.getIconRegistry=i;function d(){const E=(0,A.getCodiconFontCharacters)();for(const p in E){const t="\\"+E[p].toString(16);C.registerIcon(p,{fontCharacter:t})}}d(),e.iconsSchemaId="vscode://schemas/icons";const h=L.Registry.as(g.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,C.getIconSchema());const S=new o.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);C.onDidChange(()=>{S.isScheduled()||S.schedule()}),e.widgetClose=b("widget-close",A.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=b("goto-previous-location",A.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=b("goto-next-location",A.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=l.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=l.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(De[129],Ie([1,0,3,56,4,17]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var T;(function(b){b.Http="http",b.Https="https"})(T||(e.TunnelProtocol=T={}));var P;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(P||(e.TunnelPrivacyId=P={}));var y;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function g(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(i)return{address:i[1],port:+i[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=I;function w(b,i,d,h){if(d===1)return!1;if(d===2&&I(i)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(S?.length===4&&parseInt(S[1])>=18)return!1}return b<1024}e.isPortPrivileged=w;class k{constructor(i,d,h){this.remoteAddress=i,this.localAddress=d,this._dispose=h,this._onDispose=new o.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=k;let C=e.AbstractTunnelService=class{constructor(i,d){this.logService=i,this.configurationService=d,this._onTunnelOpened=new o.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new o.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new o.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const i=this.configurationService.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this._tunnelProvider=i,i?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this._canElevate=i.elevation,this._privacyOptions=i.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const i=[],d=Array.from(this._tunnels.values());for(const h of d){const S=Array.from(h.values());for(const E of S){const p=await E.value;p&&i.push(p)}}return i}async dispose(){for(const i of this._tunnels.values()){for(const{value:d}of i.values())await d.then(h=>h?.dispose());i.clear()}this._tunnels.clear()}setEnvironmentTunnel(i,d,h,S,E){this.addTunnelToMap(i,d,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:d,localAddress:h,privacy:S,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,d){(I(i)||L(i))&&(i=e.LOCALHOST_ADDRESSES[0]);const h=this.getTunnelFromMap(i,d);if(h)return++h.refcount,h.value}openTunnel(i,d,h,S,E,p=!1,t,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${h} on local port ${E}.`),!i)return;if(d||(d="localhost"),S||(S=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(h)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(i,d,h,S,E,p,t,s);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,h);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.makeTunnel(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==h)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(v),v}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const d=this._tunnels.get(i.tunnelRemoteHost);if(d){const h=d.get(i.tunnelRemotePort);h&&(h.refcount--,await this.tryDisposeTunnel(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async tryDisposeTunnel(i,d,h){if(h.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${d}.`);const S=h.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(i)&&this._tunnels.get(i).delete(d),S}}async closeTunnel(i,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${d} `);const h=this._tunnels.get(i);if(h&&h.has(d)){const S=h.get(d);S.refcount=0,await this.tryDisposeTunnel(i,d,S)}}addTunnelToMap(i,d,h){this._tunnels.has(i)||this._tunnels.set(i,new Map),this._tunnels.get(i).set(d,{refcount:1,value:h})}async removeEmptyTunnelFromMap(i,d){const h=this._tunnels.get(i);h&&(await h.get(d)||h.delete(d),h.size===0&&this._tunnels.delete(i))}getTunnelFromMap(i,d){const h=[i];L(i)?(h.push(...e.LOCALHOST_ADDRESSES),h.push(...e.ALL_INTERFACES_ADDRESSES)):I(i)&&h.push(...e.ALL_INTERFACES_ADDRESSES);const S=h.map(E=>this._tunnels.get(E));for(const E of S){const p=E?.get(d);if(p)return p}}canTunnel(i){return!!g(i)}createWithProvider(i,d,h,S,E,p,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${h} on local port ${S}.`);const s=h;this._factoryInProgress.add(s);const r=S===void 0?h:S,a={elevationRequired:E?this.isPortPrivileged(r):!1},v={remoteAddress:{host:d,port:h},localAddressPort:S,privacy:p,public:p?p!==P.Private:void 0,protocol:t},_=i.forwardPort(v,a);return _?(this.addTunnelToMap(d,h,_),_.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),_}};e.AbstractTunnelService=C=Ve([ze(0,R.ILogService),ze(1,A.IConfigurationService)],C)}),define(De[226],Ie([1,0,4]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,o.createDecorator)("editSessionIdentityService");var A;(function(l){l[l.Complete=100]="Complete",l[l.Partial=50]="Partial",l[l.None=0]="None"})(A||(e.EditSessionIdentityMatch=A={}))}),define(De[227],Ie([1,0,16]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(y){return y.scheme!==o.Schemas.file&&y.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=A;function l(y){if(y.folders.length)return y.folders.every(g=>A(g.uri))?y.folders[0].uri:void 0;if(y.configuration&&A(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=l;function R(y){return l(y)?.scheme}e.getVirtualWorkspaceScheme=R;function T(y){return l(y)?.authority}e.getVirtualWorkspaceAuthority=T;function P(y){return l(y)!==void 0}e.isVirtualWorkspace=P}),define(De[48],Ie([1,0,181,15,70,24,2,4,16]),function(oe,e,o,A,l,R,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function g(a){const v=a;return typeof v?.id=="string"&&T.URI.isUri(v.uri)}e.isSingleFolderWorkspaceIdentifier=g;function L(a){return typeof a?.id=="string"&&!g(a)&&!w(a)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(a,v){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,A.basename)(a)}:v?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const _=a;return _.configuration?{id:_.id,configPath:_.configuration}:_.folders.length===1?{id:_.id,uri:_.folders[0].uri}:{id:_.id}}e.toWorkspaceIdentifier=I;function w(a){const v=a;return typeof v?.id=="string"&&T.URI.isUri(v.configPath)}e.isWorkspaceIdentifier=w;function k(a){const v=a;if(v?.uri)return{id:v.id,uri:T.URI.revive(v.uri)};const _=a;if(_?.configPath)return{id:_.id,configPath:T.URI.revive(_.configPath)};if(a?.id)return{id:a.id}}e.reviveIdentifier=k;var C;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(C||(e.WorkbenchState=C={}));function b(a){const v=a;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=b;function i(a){const v=a;return!!(v&&typeof v=="object"&&T.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=i;class d{constructor(v,_,c,u,m){this._id=v,this._transient=c,this._configuration=u,this._ignorePathCasing=m,this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=_}update(v){this._id=v.id,this._configuration=v.configuration,this._transient=v.transient,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v)||null}updateFoldersMap(){this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class h{constructor(v,_){this.raw=_,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,R.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function S(a){return new h({uri:a,index:0,name:(0,R.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(a,v){return R.extUriBiasedIgnorePathCase.isEqualOrParent(a,v.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function p(a){let v;return T.URI.isUri(a)?v=a:v=a.configuration,v?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=p,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(a){return a.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function s(a,v){return!E(a,v)&&!p(a)}e.isSavedWorkspace=s;function r(a){return(typeof a=="string"?(0,A.extname)(a):(0,R.extname)(a))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(De[76],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(l){this.id=l,this._data=new Map,this._idPool=1}add(l){const R=this._idPool++;return this._data.set(R,l),this.logDebugInfo(),R}get(l,R){return this._data.has(l)?this._data.get(l)[R]:void 0}delete(l){this._data.delete(l),this.logDebugInfo()}logDebugInfo(){o.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=o,o.enableDebugLogging=!1}),define(De[49],Ie([1,0,16,24,4]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(o.Schemas)),this._providerInfo=new Map,this.extUri=new A.ExtUri(P=>{const y=this._providerInfo.get(P.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(P,y){y===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,y)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,l.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ie([1,0,4]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(De[228],Ie([1,0,186,17,213,26]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=e.ExtHostLogService=class extends l.LogService{constructor(y,g,L){const I=L.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",w=L.remote.isRemote?(0,o.localize)(0,null):y?(0,o.localize)(1,null):(0,o.localize)(2,null);super(g.createLogger(I,{name:w}))}};e.ExtHostLogService=T=Ve([ze(1,A.ILoggerService),ze(2,R.IExtHostInitDataService)],T)}),define(De[229],Ie([1,0,19]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(T,P,y){this._deferredPromises=new Map,this._id=T,this._shared=P,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(g=>(this._value=g,this)),this._storageListener=this._storage.onDidChangeStorage(g=>{g.shared===this._shared&&g.key===this._id&&(this._value=g.value)}),this._scheduler=new o.RunOnceScheduler(()=>{const g=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of g.values())L.complete()}catch(L){for(const I of g.values())I.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,P){let y=this._value[T];return typeof y>"u"&&(y=P),y}update(T,P){this._value[T]=P;const y=this._deferredPromises.get(T);if(y!==void 0)return y.p;const g=new o.DeferredPromise;return this._deferredPromises.set(T,g),this._scheduler.isScheduled()||this._scheduler.schedule(),g.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=A;class l extends A{setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}constructor(T,P){super(T.identifier.value,!0,P),this._extension=T}}e.ExtensionGlobalMemento=l}),define(De[230],Ie([1,0,3,2]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class l{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new o.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new o.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,P,y,g){const I=this._notebooksAndEditors.getNotebookDocument(A.URI.revive(T)).acceptModelChanged(P.value,y,g);this._onDidChangeNotebookDocument.fire(I)}$acceptDirtyStateChanged(T,P){this._notebooksAndEditors.getNotebookDocument(A.URI.revive(T)).acceptDirty(P)}$acceptModelSaved(T){const P=this._notebooksAndEditors.getNotebookDocument(A.URI.revive(T));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=l}),define(De[20],Ie([1,0,4]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class A{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=A});var Je=this&&this.__classPrivateFieldSet||function(oe,e,o,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,o):l?l.value=o:e.set(oe,o),o},xe=this&&this.__classPrivateFieldGet||function(oe,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(oe):A?A.value:e.get(oe)};define(De[231],Ie([1,0,25,3]),function(oe,e,o,A){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(P,y){l.set(this,void 0),this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._id=o.ExtensionIdentifier.toKey(P.identifier),Je(this,l,y,"f"),xe(this,l,"f").onDidChangePassword(g=>{g.extensionId===this._id&&this._onDidChange.fire({key:g.key})})}get(P){return xe(this,l,"f").get(this._id,P)}store(P,y){return xe(this,l,"f").store(this._id,P,y)}delete(P){return xe(this,l,"f").delete(this._id,P)}}e.ExtensionSecrets=R,l=new WeakMap}),define(De[57],Ie([1,0,4,129,3,20]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var T;(function(y){function g(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:I.protocol}}y.fromApiTunnel=g;function L(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==A.TunnelPrivacyId.ConstantPrivate&&I.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}y.fromServiceTunnel=L})(T||(e.TunnelDtoConverter=T={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let P=e.ExtHostTunnelService=class{constructor(g){this.onDidChangeTunnels=new l.Emitter().event}async $applyCandidateFilter(g){return g}async openTunnel(g,L){}async getTunnels(){return[]}async setTunnelFactory(g){return{dispose:()=>{}}}registerPortsAttributesProvider(g,L){return{dispose:()=>{}}}async $providePortAttributes(g,L,I,w,k){return[]}async $forwardPort(g,L){}async $closeTunnel(g){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.ExtHostTunnelService=P=Ve([ze(0,R.IExtHostRpcService)],P)}),define(De[58],Ie([1,0,4]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class A{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=A}),define(De[232],Ie([1,0,22]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(y){let g=this.buffers.indexOf(y);return g<0&&(g=this.buffers.length,this.buffers.push(y)),g}}function l(P,y){if(y.serializeBuffersForPostMessage){const g=new A,I=JSON.stringify(P,(k,C)=>{if(C instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(C)};if(ArrayBuffer.isView(C)){const b=R(C);if(b)return{$$vscode_array_buffer_reference$$:!0,index:g.add(C.buffer),view:{type:b,byteLength:C.byteLength,byteOffset:C.byteOffset}}}return C}),w=g.buffers.map(k=>{const C=new Uint8Array(k);return o.VSBuffer.wrap(C)});return{message:I,buffers:w}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=l;function R(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(P,y){const g=y.map(w=>{const k=new ArrayBuffer(w.byteLength);return new Uint8Array(k).set(w.buffer),k}),L=y.length?(w,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const C=k,{index:b}=C,i=g[b];if(C.view)switch(C.view.type){case 1:return new Int8Array(i,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(i,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(i,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(i,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(i,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(i,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(i,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(i,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(i,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(i,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(i,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return i}return k}:void 0;return{message:JSON.parse(P,L),arrayBuffers:g}}e.deserializeWebviewMessage=T}),define(De[233],Ie([1,0,234,333,334,2,335]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(I,w,k,C,b,i){const d=i.environment.useHostProxy,h=typeof d=="boolean"?d:!i.remote.isRemote,S=(0,T.createProxyResolver)({resolveProxy:p=>I.resolveProxy(p),getHttpProxySetting:()=>w.getConfiguration("http").get("proxy"),log:(p,t,...s)=>{switch(p){case T.LogLevel.Trace:C.trace(t,...s);break;case T.LogLevel.Debug:C.debug(t,...s);break;case T.LogLevel.Info:C.info(t,...s);break;case T.LogLevel.Warning:C.warn(t,...s);break;case T.LogLevel.Error:C.error(t,...s);break;case T.LogLevel.Critical:C.error(t,...s);break;case T.LogLevel.Off:break;default:r(p,t,s);break}function r(a,v,..._){C.error("Unknown log level",a),C.error(v,..._)}},getLogLevel:()=>C.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:h,env:process.env}),E=y(w,S);return L(k,E)}e.connectProxyResolver=P;function y(I,w){const k={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(b=>{k.config=I.getConfiguration("http").get("proxySupport")||"off"});const C={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(b=>{C.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},o,(0,T.createHttpPatch)(o,w,{config:"off"},C,!0)),on:Object.assign({},o,(0,T.createHttpPatch)(o,w,{config:"on"},C,!0)),override:Object.assign({},o,(0,T.createHttpPatch)(o,w,{config:"override"},C,!0)),onRequest:Object.assign({},o,(0,T.createHttpPatch)(o,w,k,C,!0)),default:Object.assign(o,(0,T.createHttpPatch)(o,w,k,C,!1))},https:{off:Object.assign({},A,(0,T.createHttpPatch)(A,w,{config:"off"},C,!0)),on:Object.assign({},A,(0,T.createHttpPatch)(A,w,{config:"on"},C,!0)),override:Object.assign({},A,(0,T.createHttpPatch)(A,w,{config:"override"},C,!0)),onRequest:Object.assign({},A,(0,T.createHttpPatch)(A,w,k,C,!0)),default:Object.assign(A,(0,T.createHttpPatch)(A,w,k,C,!1))},tls:Object.assign(l,(0,T.createTlsPatch)(l))}}const g=new Map;function L(I,w){return I.getExtensionPathIndex().then(k=>{const C=globalThis._VSCODE_NODE_MODULES.module,b=C._load;C._load=function(d,h,S){if(d==="tls")return w.tls;if(d!=="http"&&d!=="https")return b.apply(this,arguments);const E=w[d],p=k.findSubstr(R.URI.file(h.filename));let t=g.get(p);if(t||g.set(p,t={}),!t[d]){const s=E.default;t[d]={...s}}return t[d]}})}}),define(De[235],Ie([1,0,115]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(R){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:R,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function l(R){return new o.URITransformer(A(R))}e.createURITransformer=l}),define(De[130],Ie([1,0,195,10,2,6,4,40,45,16,46,164,38]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(he){he[he.PROGRAMMATIC=1]="PROGRAMMATIC",he[he.USER=2]="USER",he[he.EDIT=3]="EDIT",he[he.NAVIGATION=4]="NAVIGATION",he[he.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var C;(function(he){he[he.IDENTICAL=1]="IDENTICAL",he[he.SIMILAR=2]="SIMILAR",he[he.DIFFERENT=3]="DIFFERENT"})(C||(e.EditorPaneSelectionCompareResult=C={}));function b(he){const fe=he;return!!fe&&typeof fe.getSelection=="function"&&!!fe.onDidChangeSelection}e.isEditorPaneWithSelection=b;function i(he,fe,V){for(const x of V.visibleEditorPanes)if(x.group.id===fe&&he.matches(x.input))return x.getViewState()}e.findViewStateForEditor=i;function d(he){if(u(he))return!1;const fe=he;return l.URI.isUri(fe?.resource)}e.isResourceEditorInput=d;function h(he){if(u(he))return!1;const fe=he;return fe?.original!==void 0&&fe.modified!==void 0}e.isResourceDiffEditorInput=h;function S(he){if(u(he)||h(he))return!1;const fe=he;return fe?.primary!==void 0&&fe.secondary!==void 0}e.isResourceSideBySideEditorInput=S;function E(he){if(u(he))return!1;const fe=he;return fe?fe.resource===void 0||fe.resource.scheme===g.Schemas.untitled||fe.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;const p=/Untitled-\d+/;function t(he){return he.scheme===g.Schemas.untitled&&he.path.length>1&&!p.test(he.path)}e.isUntitledWithAssociatedResource=t;function s(he){if(u(he))return!1;const fe=he;return l.URI.isUri(fe?.base?.resource)&&l.URI.isUri(fe?.input1?.resource)&&l.URI.isUri(fe?.input2?.resource)&&l.URI.isUri(fe?.result?.resource)}e.isResourceMergeEditorInput=s;var r;(function(he){he[he.SHORT=0]="SHORT",he[he.MEDIUM=1]="MEDIUM",he[he.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var a;(function(he){he[he.EXPLICIT=1]="EXPLICIT",he[he.AUTO=2]="AUTO",he[he.FOCUS_CHANGE=3]="FOCUS_CHANGE",he[he.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class v{constructor(){this.mapIdToSaveSource=new Map}registerSource(fe,V){let x=this.mapIdToSaveSource.get(fe);return x||(x={source:fe,label:V},this.mapIdToSaveSource.set(fe,x)),x.source}getSourceLabel(fe){return this.mapIdToSaveSource.get(fe)?.label??fe}}e.SaveSourceRegistry=new v;var _;(function(he){he[he.None=0]="None",he[he.Readonly=2]="Readonly",he[he.Untitled=4]="Untitled",he[he.Singleton=8]="Singleton",he[he.RequiresTrust=16]="RequiresTrust",he[he.CanSplitInGroup=32]="CanSplitInGroup",he[he.ForceDescription=64]="ForceDescription",he[he.CanDropIntoEditor=128]="CanDropIntoEditor",he[he.MultipleEditors=256]="MultipleEditors"})(_||(e.EditorInputCapabilities=_={}));class c extends R.Disposable{}e.AbstractEditorInput=c;function u(he){return he instanceof c}e.isEditorInput=u;function m(he){const fe=he;return l.URI.isUri(fe?.preferredResource)}function f(he){const fe=he;return u(fe?.primary)&&u(fe?.secondary)}e.isSideBySideEditorInput=f;function n(he){const fe=he;return u(fe?.modified)&&u(fe?.original)}e.isDiffEditorInput=n;function D(he,fe,V,x,Z){return we(x,[(0,I.toAction)({id:"workbench.action.openLargeFile",label:(0,o.localize)(2,null),run:()=>{const pe={...V,limits:{size:Number.MAX_VALUE}};he.openEditor(fe,pe)}}),(0,I.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,o.localize)(3,null),run:()=>Z.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.createTooLargeFileError=D;function M(he){return u(he?.editor)}e.isEditorInputWithOptions=M;function W(he){const fe=he;return M(he)&&fe?.group!==void 0}e.isEditorInputWithOptionsAndGroup=W;function $(he){const fe=he;return typeof fe?.groupId=="number"&&u(fe.editor)}e.isEditorIdentifier=$;var N;(function(he){he[he.UNKNOWN=0]="UNKNOWN",he[he.REPLACE=1]="REPLACE",he[he.MOVE=2]="MOVE",he[he.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var U;(function(he){he[he.GROUP_ACTIVE=0]="GROUP_ACTIVE",he[he.GROUP_INDEX=1]="GROUP_INDEX",he[he.GROUP_LOCKED=2]="GROUP_LOCKED",he[he.EDITOR_OPEN=3]="EDITOR_OPEN",he[he.EDITOR_CLOSE=4]="EDITOR_CLOSE",he[he.EDITOR_MOVE=5]="EDITOR_MOVE",he[he.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",he[he.EDITOR_LABEL=7]="EDITOR_LABEL",he[he.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",he[he.EDITOR_PIN=9]="EDITOR_PIN",he[he.EDITOR_STICKY=10]="EDITOR_STICKY",he[he.EDITOR_DIRTY=11]="EDITOR_DIRTY",he[he.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var q;(function(he){he[he.PRIMARY=1]="PRIMARY",he[he.SECONDARY=2]="SECONDARY",he[he.BOTH=3]="BOTH",he[he.ANY=4]="ANY"})(q||(e.SideBySideEditor=q={}));class F{getOriginalUri(fe,V){if(!fe)return;if(s(fe))return e.EditorResourceAccessor.getOriginalUri(fe.result,V);if(V?.supportSideBySide){const{primary:Z,secondary:pe}=this.getSideEditors(fe);if(Z&&pe){if(V?.supportSideBySide===q.BOTH)return{primary:this.getOriginalUri(Z,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(pe,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===q.ANY)return this.getOriginalUri(Z,{filterByScheme:V.filterByScheme})??this.getOriginalUri(pe,{filterByScheme:V.filterByScheme});fe=V.supportSideBySide===q.PRIMARY?Z:pe}}if(h(fe)||S(fe)||s(fe))return;const x=m(fe)?fe.preferredResource:fe.resource;return!x||!V||!V.filterByScheme?x:this.filterUri(x,V.filterByScheme)}getSideEditors(fe){return f(fe)||S(fe)?{primary:fe.primary,secondary:fe.secondary}:n(fe)||h(fe)?{primary:fe.modified,secondary:fe.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(fe,V){if(!fe)return;if(s(fe))return e.EditorResourceAccessor.getCanonicalUri(fe.result,V);if(V?.supportSideBySide){const{primary:Z,secondary:pe}=this.getSideEditors(fe);if(Z&&pe){if(V?.supportSideBySide===q.BOTH)return{primary:this.getCanonicalUri(Z,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(pe,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===q.ANY)return this.getCanonicalUri(Z,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(pe,{filterByScheme:V.filterByScheme});fe=V.supportSideBySide===q.PRIMARY?Z:pe}}if(h(fe)||S(fe)||s(fe))return;const x=fe.resource;return!x||!V||!V.filterByScheme?x:this.filterUri(x,V.filterByScheme)}filterUri(fe,V){if(Array.isArray(V)){if(V.some(x=>fe.scheme===x))return fe}else if(V===fe.scheme)return fe}}e.EditorResourceAccessor=new F;var B;(function(he){he[he.LEFT=0]="LEFT",he[he.RIGHT=1]="RIGHT"})(B||(e.CloseDirection=B={}));class Q{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(fe){const V=this.instantiationService=fe.get(T.IInstantiationService);for(const[x,Z]of this.editorSerializerConstructors)this.createEditorSerializer(x,Z,V);this.editorSerializerConstructors.clear()}createEditorSerializer(fe,V,x){const Z=x.createInstance(V);this.editorSerializerInstances.set(fe,Z)}registerFileEditorFactory(fe){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=fe}getFileEditorFactory(){return(0,A.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(fe,V){if(this.editorSerializerConstructors.has(fe)||this.editorSerializerInstances.has(fe))throw new Error(`A editor serializer with type ID '${fe}' was already registered.`);return this.instantiationService?this.createEditorSerializer(fe,V,this.instantiationService):this.editorSerializerConstructors.set(fe,V),(0,R.toDisposable)(()=>{this.editorSerializerConstructors.delete(fe),this.editorSerializerInstances.delete(fe)})}getEditorSerializer(fe){return this.editorSerializerInstances.get(typeof fe=="string"?fe:fe.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new Q);async function J(he,fe,V){return!he||!he.length?[]:await Promise.all(he.map(async x=>{const Z=l.URI.revive(x.fileUri);if(!Z){V.info("Cannot resolve the path because it is not valid.",x);return}if(!await fe.canHandleResource(Z)){V.info("Cannot resolve the path because it cannot be handled",x);return}let _e=x.exists,re=x.type;if(typeof _e!="boolean"||typeof re!="number")try{re=(await fe.stat(Z)).isDirectory?y.FileType.Directory:y.FileType.Unknown,_e=!0}catch(de){V.error(de),_e=!1}if(!_e&&x.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",x);return}if(re===y.FileType.Directory){V.info("Cannot resolve the path because it is a directory",x);return}const ne={...x.options,pinned:!0};return _e?{resource:Z,options:ne}:{resource:Z,options:ne,forceUntitled:!0}}))}e.pathsToEditors=J;var X;(function(he){he[he.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",he[he.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function ie(he){const fe=he;if(!fe)return!1;const V=fe;if(V.modified)return ie(V.modified);const x=fe;return!!(x.contributionsState&&x.viewState&&Array.isArray(x.cursorState))}e.isTextEditorViewState=ie;function ae(he){return(0,L.isErrorWithActions)(he)}e.isEditorOpenError=ae;function we(he,fe,V){const x=(0,L.createErrorWithActions)(he,fe);return x.forceMessage=V?.forceMessage,x.forceSeverity=V?.forceSeverity,x.allowDialog=V?.allowDialog,x}e.createEditorOpenError=we}),define(De[236],Ie([1,0,3,196,4,6,28,40,18,63,23,68,225]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,w.registerIcon)("default-view-icon",I.Codicon.window,(0,A.localize)(0,null));var k;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(k||(e.Extensions=k={}));var C;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(C||(e.ViewContainerLocation=C={})),e.ViewContainerLocations=[0,1,2];function b(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=b;class i extends R.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new o.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new o.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,y.flatten)([...this.viewContainers.values()])}registerViewContainer(a,v,_){const c=this.get(a.id);if(c)return c;const u=a;return u.openCommandActionDescriptor=_?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,T.getOrSet)(this.viewContainers,v,[]).push(u),_?.isDefault&&this.defaultViewContainers.push(u),this._onDidRegister.fire({viewContainer:u,viewContainerLocation:v}),u}deregisterViewContainer(a){for(const v of this.viewContainers.keys()){const _=this.viewContainers.get(v),c=_?.indexOf(a);if(c!==-1){_?.splice(c,1),_.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:a,viewContainerLocation:v});return}}}get(a){return this.all.filter(v=>v.id===a)[0]}getViewContainers(a){return[...this.viewContainers.get(a)||[]]}getViewContainerLocation(a){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(_=>_?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===a)}}P.Registry.add(k.ViewContainersRegistry,new i);var d;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(d||(e.ViewContentGroups=d={}));function h(r,a){const v=r.group??d.More,_=a.group??d.More;return v!==_?v.localeCompare(_):(r.order??5)-(a.order??5)}class S extends R.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new o.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new o.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new o.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new o.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new g.SetMap}registerViews(a,v){this.registerViews2([{views:a,viewContainer:v}])}registerViews2(a){a.forEach(({views:v,viewContainer:_})=>this.addViews(v,_)),this._onViewsRegistered.fire(a)}deregisterViews(a,v){const _=this.removeViews(a,v);_.length&&this._onViewsDeregistered.fire({views:_,viewContainer:v})}moveViews(a,v){for(const _ of this._views.keys())if(_!==v){const c=this.removeViews(a,_);c.length&&(this.addViews(c,v),this._onDidChangeContainer.fire({views:c,from:_,to:v}))}}getViews(a){return this._views.get(a)||[]}getView(a){for(const v of this._viewContainers){const _=(this._views.get(v)||[]).filter(c=>c.id===a)[0];if(_)return _}return null}getViewContainer(a){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(c=>c.id===a)[0])return v;return null}registerViewWelcomeContent(a,v){return this._viewWelcomeContents.add(a,v),this._onDidChangeViewWelcomeContent.fire(a),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(a,v),this._onDidChangeViewWelcomeContent.fire(a)})}registerViewWelcomeContent2(a,v){const _=new Map;for(const[c,u]of v)this._viewWelcomeContents.add(a,u),_.set(c,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(a,u),this._onDidChangeViewWelcomeContent.fire(a)}));return this._onDidChangeViewWelcomeContent.fire(a),_}getViewWelcomeContent(a){const v=[];return this._viewWelcomeContents.forEach(a,_=>v.push(_)),v.sort(h)}addViews(a,v){let _=this._views.get(v);_||(_=[],this._views.set(v,_),this._viewContainers.push(v));for(const c of a){if(this.getView(c.id)!==null)throw new Error((0,A.localize)(1,null,c.id));_.push(c)}}removeViews(a,v){const _=this._views.get(v);if(!_)return[];const c=[],u=[];for(const m of _)a.includes(m)?c.push(m):u.push(m);return c.length&&(u.length?this._views.set(v,u):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),c}}P.Registry.add(k.ViewsRegistry,new S),e.IViewsService=(0,l.createDecorator)("viewsService"),e.IViewDescriptorService=(0,l.createDecorator)("viewDescriptorService");var E;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(E||(e.ViewVisibilityState=E={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p||(e.TreeItemCollapsibleState=p={}));class t{constructor(a,v){this.resolved=!1,this._hasResolve=!1,(0,L.mixin)(this,a),this._hasResolve=!!v,this.resolve=async _=>{if(v&&!this.resolved){const c=await v(_);c&&(this.tooltip=this.tooltip??c.tooltip,this.command=this.command??c.command)}_.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class s extends Error{constructor(a){super((0,A.localize)(2,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.NoTreeViewError=s}),define(De[131],Ie([1,0,3,19,197]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new o.Emitter,this._onExit=new o.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,y,g,L){const I={command:P};if(y&&Object.keys(y).length>0&&(I.arguments=y),this.internalSend("request",I),typeof L=="number"){const w=setTimeout(()=>{clearTimeout(w);const k=this.pendingRequests.get(I.seq);if(k){this.pendingRequests.delete(I.seq);const C={type:"response",seq:0,request_seq:I.seq,success:!1,command:P,message:(0,l.localize)(0,null,L,P)};k(C)}},L)}return g&&this.pendingRequests.set(I.seq,g),I.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,y){return P.type!=="event"||y.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,A.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback?.(P);break;case"request":this.requestCallback?.(P);break;case"response":{const y=P,g=this.pendingRequests.get(y.request_seq);g&&(this.pendingRequests.delete(y.request_seq),g(y));break}}}}internalSend(P,y){y.type=P,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((y,g)=>P.set(g,y)),await(0,A.timeout)(500),P.forEach((y,g)=>{y({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(g)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=R}),define(De[237],Ie([1,0,198,44,4]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(50,null)});const R=w=>o.localize(51,null,w);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(52,null)};var T;(function(w){w[w.Inactive=0]="Inactive",w[w.Initializing=1]="Initializing",w[w.Stopped=2]="Stopped",w[w.Running=3]="Running"})(T||(e.State=T={}));function P(w){switch(w){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var y;(function(w){w[w.Valid=0]="Valid",w[w.Unreadable=1]="Unreadable",w[w.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var g;(function(w){w[w.Initial=1]="Initial",w[w.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var L;(function(w){w.UnverifiedBreakpoints="unverifiedBreakpoints"})(L||(e.DebuggerString=L={})),e.IDebugService=(0,l.createDecorator)("debugService");var I;(function(w){w[w.CONDITION=0]="CONDITION",w[w.HIT_COUNT=1]="HIT_COUNT",w[w.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(De[238],Ie([1,0,9,2,15,23,16,32,21,18]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function I(c,u,m){return c.replace(L,function(f,n){return u&&n.length>0&&n[0]!=="_"?f:m&&m.hasOwnProperty(n)?m[n]:f})}e.formatPII=I;function w(c){const u={};for(const m of Object.keys(c))m.startsWith("!")||(u[m]=c[m]);return u}e.filterExceptionsFromTelemetry=w;function k(c){return c.configuration.request==="attach"&&!C(c)&&(!c.parentSession||k(c.parentSession))}e.isSessionAttach=k;function C(c){let u=c.configuration.type;if(u)return u==="vslsShare"&&(u=c.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(u,"extensionhost")||(0,o.equalsIgnoreCase)(u,"pwa-extensionhost")?c:c.parentSession?C(c.parentSession):void 0}e.getExtensionHostDebugSession=C;function b(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=b;function i(c,u,m){let f,n=0;const D=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let M=null;for(;M=D.exec(c);){const W=M.index+1,$=W+M[0].length;if(W<=u&&$>=m){f=M[0],n=W;break}}if(f){const W=/\w+/g;let $=null;for(;($=W.exec(f))&&!($.index+1+n+$[0].length>=m););$&&(f=f.substring(0,W.lastIndex))}return f?{start:n,end:n+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=i;async function d(c,u,m,f){if(c.evaluatableExpressionProvider.has(u)){const n=c.evaluatableExpressionProvider.ordered(u),D=(0,g.coalesce)(await Promise.all(n.map(async M=>{try{return await M.provideEvaluatableExpression(u,m,f??y.CancellationToken.None)}catch{return}})));if(D.length>0){let M=D[0].expression;const W=D[0].range;return M||(M=u.getLineContent(m.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:M}}}else{const n=u.getLineContent(m.lineNumber),{start:D,end:M}=i(n,m.column,m.column),W=n.substring(D-1,M);return{matchingExpression:W,range:new P.Range(m.lineNumber,D,m.lineNumber,D+W.length)}}return null}e.getEvaluatableExpressionAtPosition=d;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function S(c){return!!(c&&c.match(h))}e.isUri=S;function E(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(S(c.path))return A.URI.parse(c.path);if((0,l.isAbsolute)(c.path))return A.URI.file(c.path)}return c.path}function p(c){if(typeof c.path=="object"){const u=A.URI.revive(c.path);if(u)return u.scheme===T.Schemas.file?u.fsPath:u.toString()}return c.path}function t(c,u){const m=u?E:p,f=(0,R.deepClone)(c);return r(f,(n,D)=>{n&&D&&(D.path=m(D))}),f}e.convertToDAPaths=t;function s(c,u){const m=u?E:p,f=(0,R.deepClone)(c);return r(f,(n,D)=>{!n&&D&&(D.path=m(D))}),f}e.convertToVSCPaths=s;function r(c,u){switch(c.type){case"event":{const m=c;switch(m.event){case"output":u(!1,m.body.source);break;case"loadedSource":u(!1,m.body.source);break;case"breakpoint":u(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=c;switch(m.command){case"setBreakpoints":u(!0,m.arguments.source);break;case"breakpointLocations":u(!0,m.arguments.source);break;case"source":u(!0,m.arguments.source);break;case"gotoTargets":u(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(f=>u(!1,f));break;default:break}break}case"response":{const m=c;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(f=>u(!1,f.source));break;case"loadedSources":m.body.sources.forEach(f=>u(!1,f));break;case"scopes":m.body.scopes.forEach(f=>u(!1,f.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(f=>u(!1,f.source));break;case"setBreakpoints":m.body.breakpoints.forEach(f=>u(!1,f.source));break;case"disassemble":m.body?.instructions.forEach(n=>u(!1,n.location));break;default:break}break}}}function a(c){return c.filter(u=>!u.presentation?.hidden).sort((u,m)=>u.presentation?m.presentation?u.presentation.group?m.presentation.group?u.presentation.group!==m.presentation.group?u.presentation.group.localeCompare(m.presentation.group):v(u.presentation.order,m.presentation.order):-1:m.presentation.group?1:v(u.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.getVisibleAndSorted=a;function v(c,u){return typeof c!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:c-u}async function _(c,u){const m=c.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(m!=="none"&&(await u.saveAll(),m==="allEditorsInActiveGroup")){const f=u.activeEditorPane;f&&f.input.resource?.scheme===T.Schemas.untitled&&await u.save({editor:f.input,groupId:f.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=_}),define(De[239],Ie([1,0,47,132,23,15,14,9,29,199,131]),function(oe,e,o,A,l,R,T,P,y,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class I extends L.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(d,h){this.outputStream=h,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,d.on("data",S=>this.handleData(S))}sendMessage(d){if(this.outputStream){const h=JSON.stringify(d);this.outputStream.write(`Content-Length: ${Buffer.byteLength(h,"utf8")}${I.TWO_CRLF}${h}`,"utf8")}}handleData(d){for(this.rawData=Buffer.concat([this.rawData,d]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const h=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,h.length>0)try{this.acceptMessage(JSON.parse(h))}catch(S){this._onError.fire(new Error((S.message||S)+`
`+h))}continue}}else{const h=this.rawData.indexOf(I.TWO_CRLF);if(h!==-1){const E=this.rawData.toString("utf8",0,h).split(I.HEADER_LINESEPARATOR);for(const p of E){const t=p.split(I.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(h+I.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=I,I.TWO_CRLF=`\r
\r
`,I.HEADER_LINESEPARATOR=/\r?\n/,I.HEADER_FIELDSEPARATOR=/: */;class w extends I{startSession(){return new Promise((d,h)=>{let S=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),d(),S=!0}),this.socket.on("close",()=>{S?this._onError.fire(new Error("connection closed")):h(new Error("connection closed"))}),this.socket.on("error",E=>{S?this._onError.fire(E):h(E)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=w;class k extends w{constructor(d){super(),this.adapterServer=d}createConnection(d){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",d)}}e.SocketDebugAdapter=k;class C extends w{constructor(d){super(),this.adapterServer=d}createConnection(d){return A.createConnection(this.adapterServer.path,d)}}e.NamedPipeDebugAdapter=C;class b extends I{constructor(d,h){super(),this.adapterExecutable=d,this.debugType=h}async startSession(){const d=this.adapterExecutable.command,h=this.adapterExecutable.args,S=this.adapterExecutable.options||{};try{if(d)if(R.isAbsolute(d)){if(!await y.Promises.exists(d))throw new Error(g.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(g.localize(1,null,this.debugType));let E=process.env;if(S.env&&Object.keys(S.env).length>0&&(E=l.mixin(l.deepClone(process.env),S.env)),d==="node")if(Array.isArray(h)&&h.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:E,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};S.cwd&&(t.cwd=S.cwd);const s=o.fork(h[0],h.slice(1),t);if(!s.pid)throw new Error(g.localize(2,null,h[0]));this.serverProcess=s}else throw new Error(g.localize(3,null));else{const p={env:E};S.cwd&&(p.cwd=S.cwd),this.serverProcess=o.spawn(d,h,p)}this.serverProcess.on("error",p=>{this._onError.fire(p)}),this.serverProcess.on("exit",(p,t)=>{this._onExit.fire(p)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",p=>{this._onError.fire(p)}),this.serverProcess.stdin.on("error",p=>{this._onError.fire(p)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(E){this._onError.fire(E)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((d,h)=>{const S=o.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(E,p,t){if(E)return h(E)});S.on("exit",d),S.on("error",h)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(d,h){if(!d)return;const S=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?S.runtime=R.join(h,d.runtime):S.runtime=d.runtime),d.runtimeArgs&&(S.runtimeArgs=d.runtimeArgs),d.program&&(R.isAbsolute(d.program)?S.program=d.program:S.program=R.join(h,d.program)),d.args&&(S.args=d.args);const E=d;return E.win&&(S.win=b.extract(E.win,h)),E.winx86&&(S.winx86=b.extract(E.winx86,h)),E.windows&&(S.windows=b.extract(E.windows,h)),E.osx&&(S.osx=b.extract(E.osx,h)),E.linux&&(S.linux=b.extract(E.linux,h)),S}static platformAdapterExecutable(d,h){let S=Object.create(null);h=h.toLowerCase();for(const a of d)if(a.contributes){const v=a.contributes.debuggers;v&&v.length>0&&v.filter(_=>typeof _.type=="string"&&P.equalsIgnoreCase(_.type,h)).forEach(_=>{const c=b.extract(_,a.extensionLocation.fsPath);S=l.mixin(S,c,a.isBuiltin)})}let E;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?E=S.winx86||S.win||S.windows:T.isWindows?E=S.win||S.windows:T.isMacintosh?E=S.osx:T.isLinux&&(E=S.linux),E=E||S;const p=E.program||S.program,t=E.args||S.args,s=E.runtime||S.runtime,r=E.runtimeArgs||S.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof p=="string"?[p]:[]).concat(t||[])};if(p)return{type:"executable",command:p,args:t||[]}}}e.ExecutableDebugAdapter=b}),define(De[240],Ie([1,0,47,34,14]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(g,L){return new Promise((I,w)=>{let k="";const C=o.spawn(g,L);C.pid&&C.stdout.on("data",b=>{k+=b.toString()}),C.on("error",b=>{w(b)}),C.on("close",b=>{I(k)})})}async function T(g){if(g)if(l.isWindows){const L=await new Promise((I,w)=>{oe(["@vscode/windows-process-tree"],I,w)});return new Promise(I=>{L.getProcessTree(g,w=>{I(!!w&&w.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(g)]).then(L=>{const I=L.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=T;var P;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(P||(P={}));function y(g,L,I,w,k){g=g.trim().toLowerCase();let C;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?C=1:g.indexOf("cmd.exe")>=0?C=0:g.indexOf("bash")>=0?C=2:l.isWindows?C=0:C=2;let b,i=" ";switch(C){case 1:if(b=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),w){const d=(0,A.getDriveLetter)(w);d&&(i+=`${d}:; `),i+=`cd ${b(w)}; `}if(k)for(const d in k){const h=k[d];h===null?i+=`Remove-Item env:${d}; `:i+=`\${env:${d}}='${h}'; `}if(L.length>0){const d=L.shift(),h=I?d:b(d);i+=h[0]==="'"?`& ${h} `:`${h} `;for(const S of L)i+=S==="<"||S===">"||I?S:b(S),i+=" "}break;case 0:if(b=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(h=>d.includes(h))||d.length===0?`"${d}"`:d),w){const d=(0,A.getDriveLetter)(w);d&&(i+=`${d}: && `),i+=`cd ${b(w)} && `}if(k){i+='cmd /C "';for(const d in k){let h=k[d];h===null?i+=`set "${d}=" && `:(h=h.replace(/[&^|<>]/g,S=>`^${S}`),i+=`set "${d}=${h}" && `)}}for(const d of L)i+=d==="<"||d===">"||I?d:b(d),i+=" ";k&&(i+='"');break;case 2:{b=h=>(h=h.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),h.length===0?'""':h);const d=h=>/[^\w@%\/+=,.:^-]/.test(h)?`'${h.replace(/'/g,"'\\''")}'`:h;if(w&&(i+=`cd ${b(w)} ; `),k){i+="/usr/bin/env";for(const h in k){const S=k[h];S===null?i+=` -u ${d(h)}`:i+=` ${d(`${h}=${S}`)}`}i+=" "}for(const h of L)i+=h==="<"||h===">"||I?h:b(h),i+=" ";break}}return i}e.prepareCommand=y}),define(De[94],Ie([1,0,22,39,52,89,16,15,14,44]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(L||(e.CellKind=L={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var w;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var k;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(k||(e.NotebookExecutionState=k={}));var C;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(C||(e.NotebookRendererMatch=C={}));var b;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(b||(e.RendererMessagingSpec=b={}));var i;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(i||(e.NotebookCellsChangeType=i={}));var d;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(d||(e.SelectionStateType=d={}));var h;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(h||(e.CellEditType=h={}));var S;(function(F){F.scheme=T.Schemas.vscodeNotebookCell;const B=["W","X","Y","Z","a","b","c","d","e","f"],Q=new RegExp(`^[${B.join("")}]+`),J=7;function X(V,x){const Z=x.toString(J),_e=`${Z.length<B.length?B[Z.length-1]:"z"}${Z}s${(0,o.encodeBase64)(o.VSBuffer.fromString(V.scheme),!0,!0)}`;return V.with({scheme:F.scheme,fragment:_e})}F.generate=X;function ie(V){if(V.scheme!==F.scheme)return;const x=V.fragment.indexOf("s");if(x<0)return;const Z=parseInt(V.fragment.substring(0,x).replace(Q,""),J),pe=(0,o.decodeBase64)(V.fragment.substring(x+1)).toString();if(!isNaN(Z))return{handle:Z,notebook:V.with({scheme:pe,fragment:null})}}F.parse=ie;function ae(V,x){return V.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${x??""},${V.scheme!==T.Schemas.file?V.scheme:""}`})}F.generateCellOutputUri=ae;function we(V){if(V.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const x=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(V.fragment);if(!x)return;const Z=x[1]&&x[1]!==""?x[1]:void 0,pe=x[2];return{outputId:Z,notebook:V.with({scheme:pe||T.Schemas.file,fragment:null})}}F.parseCellOutputUri=we;function he(V,x,Z){return F.generate(V,x).with({scheme:Z})}F.generateCellPropertyUri=he;function fe(V,x){if(V.scheme===x)return F.parse(V.with({scheme:F.scheme}))}F.parseCellPropertyUri=fe})(S||(e.CellUri=S={}));const E=F=>y.isWindows?F.replace(/\//g,"\\"):F;class p{constructor(B=[],Q=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=Q,this.order=[...new Set(B)].map(J=>({pattern:J,matches:A.parse(E(J))}))}sort(B){const Q=new Map(l.Iterable.map(B,X=>[X,E(X)]));let J=[];for(const{matches:X}of this.order)for(const[ie,ae]of Q)if(X(ae)){J.push(ie),Q.delete(ie);break}return Q.size&&(J=J.concat([...Q.keys()].sort((X,ie)=>this.defaultOrder.indexOf(X)-this.defaultOrder.indexOf(ie)))),J}prioritize(B,Q){const J=this.findIndex(B);if(J===-1){this.order.unshift({pattern:B,matches:A.parse(E(B))});return}const X=new Set(Q.map(ae=>this.findIndex(ae,J)));X.delete(-1);const ie=Array.from(X).sort();this.order.splice(J+1,0,...ie.map(ae=>this.order[ae]));for(let ae=ie.length-1;ae>=0;ae--)this.order.splice(ie[ae],1)}toArray(){return this.order.map(B=>B.pattern)}findIndex(B,Q=this.order.length){const J=E(B);for(let X=0;X<Q;X++)if(this.order[X].matches(J))return X;return-1}}e.MimeTypeDisplayOrder=p;function t(F,B,Q,J=(X,ie)=>X===ie){const X=[];function ie(he,fe,V){if(fe===0&&V.length===0)return;const x=X[X.length-1];x&&x.start+x.deleteCount===he?(x.deleteCount+=fe,x.toInsert.push(...V)):X.push({start:he,deleteCount:fe,toInsert:V})}let ae=0,we=0;for(;;){if(ae===F.length){ie(ae,0,B.slice(we));break}if(we===B.length){ie(ae,F.length-ae,[]);break}const he=F[ae],fe=B[we];if(J(he,fe)){ae+=1,we+=1;continue}Q(fe)?(ie(ae,1,[]),ae+=1):(ie(ae,0,[fe]),we+=1)}return X}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new g.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(F){F.default="default",F.option="option"})(s||(e.NotebookEditorPriority=s={}));function r(F){const B=F;return!!((typeof B.include=="string"||A.isRelativePattern(B.include))&&(typeof B.exclude=="string"||A.isRelativePattern(B.exclude)))}e.isDocumentExcludePattern=r;function a(F,B,Q){if(Array.isArray(F.viewType)&&F.viewType.indexOf(B)>=0||F.viewType===B)return!0;if(F.filenamePattern){const J=r(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,X=r(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(A.match(J,(0,P.basename)(Q.fsPath).toLowerCase()))return!(X&&A.match(X,(0,P.basename)(Q.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",codeActionsOnSave:"notebook.experimental.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var v;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class _{static create(B){return`${_._prefix}${B}`}static parse(B){if(B.startsWith(_._prefix))return B.substring(_._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=_,_._prefix="notebook/";function c(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.isTextStreamMime=c;const u=new TextDecoder;function m(F){const B=[];let Q=!1;for(const J of F)(B.length===0||Q)&&(B.push(J),Q=!0);return M(B),q(o.VSBuffer.concat(B.map(J=>o.VSBuffer.wrap(J))))}e.compressOutputItemStreams=m;const f=`${String.fromCharCode(27)}[A`,n=f.split("").map(F=>F.charCodeAt(0)),D=10;function M(F){F.forEach((B,Q)=>{if(Q===0||B.length<f.length)return;const J=F[Q-1],X=B.subarray(0,f.length);if(X[0]===n[0]&&X[1]===n[1]&&X[2]===n[2]){const ie=J.lastIndexOf(D);if(ie===-1)return;F[Q-1]=J.subarray(0,ie),F[Q]=B.subarray(f.length)}})}function W(F){let B=F;do F=B,B=F.replace(/[^\n]\x08/gm,"");while(B.length<F.length);return F}function $(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const B=F.match(/^(.*)\r+/m)[1];let Q=F.match(/\r+(.*)$/m)[1];Q=Q+B.slice(Q.length,B.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return F}const N="\b".charCodeAt(0),U="\r".charCodeAt(0);function q(F){return!F.buffer.includes(N)&&!F.buffer.includes(U)?F:o.VSBuffer.fromString($(W(u.decode(F.buffer))))}}),define(De[241],Ie([1,0,4]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(l){l[l.Output=1]="Output",l[l.OutputItems=2]="OutputItems",l[l.ExecutionState=3]="ExecutionState"})(A||(e.CellExecutionUpdateType=A={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(De[59],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(R){R.Delimiter="\0"})(o||(e.TestIdPathParts=o={}));var A;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(A||(e.TestPosition=A={}));class l{static fromExtHostTestItem(T,P,y=T.parent){if(T._isRoot)return new l([P]);const g=[T.id];for(let L=y;L&&L.id!==P;L=L.parent)g.push(L.id);return g.push(P),new l(g.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const P=T.indexOf("\0");return P===-1?T:T.slice(0,P)}static fromString(T){return new l(T.split("\0"))}static join(T,P){return new l([...T.path,P])}static joinToString(T,P){return T.toString()+"\0"+P}static parentId(T){const P=T.lastIndexOf("\0");return P===-1?void 0:T.slice(0,P)}static localId(T){const P=T.lastIndexOf("\0");return P===-1?T:T.slice(P+1)}static isChild(T,P){return P.startsWith(T)&&P[T.length]==="\0"}static compare(T,P){return T===P?0:l.isChild(T,P)?2:l.isChild(P,T)?3:1}constructor(T,P=T.length){if(this.path=T,this.viewEnd=P,T.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new l(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new l(this.path,T)}*idsToRoot(){for(let T=this.viewEnd;T>0;T--)yield new l(this.path,T)}compare(T){if(typeof T=="string")return l.compare(this.toString(),T);for(let P=0;P<T.viewEnd&&P<this.viewEnd;P++)if(T.path[P]!==this.path[P])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=l}),define(De[77],Ie([1,0,2,32,59]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(u){u[u.Unset=0]="Unset",u[u.Queued=1]="Queued",u[u.Running=2]="Running",u[u.Passed=3]="Passed",u[u.Failed=4]="Failed",u[u.Skipped=5]="Skipped",u[u.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var T;(function(u){u[u.Run=1]="Run",u[u.Debug=2]="Debug",u[u.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var P;(function(u){u[u.Run=2]="Run",u[u.Debug=4]="Debug",u[u.Coverage=8]="Coverage",u[u.HasNonDefaultProfile=16]="HasNonDefaultProfile",u[u.HasConfigurable=32]="HasConfigurable",u[u.SupportsContinuousRun=64]="SupportsContinuousRun"})(P||(e.TestRunProfileBitset=P={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=u=>"runId"in u;e.isStartControllerTests=y;var g;(function(u){u.serialize=m=>({range:m.range.toJSON(),uri:m.uri.toJSON()}),u.deserialize=m=>({range:A.Range.lift(m.range),uri:o.URI.revive(m.uri)})})(g||(e.IRichLocation=g={}));var L;(function(u){u[u.Error=0]="Error",u[u.Output=1]="Output"})(L||(e.TestMessageType=L={}));var I;(function(u){u.serialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,location:m.location&&g.serialize(m.location)}),u.deserialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,location:m.location&&g.deserialize(m.location)})})(I||(e.ITestErrorMessage=I={}));const w=(u,m)=>`${m?"s":"e"}${u}`;e.getMarkId=w;var k;(function(u){u.serialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&g.serialize(m.location)}),u.deserialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&g.deserialize(m.location)})})(k||(e.ITestOutputMessage=k={}));var C;(function(u){u.serialize=m=>m.type===0?I.serialize(m):k.serialize(m),u.deserialize=m=>m.type===0?I.deserialize(m):k.deserialize(m)})(C||(e.ITestMessage=C={}));var b;(function(u){u.serializeWithoutMessages=m=>({state:m.state,duration:m.duration,messages:[]}),u.serialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(C.serialize)}),u.deserialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(C.deserialize)})})(b||(e.ITestTaskState=b={}));const i="\0",d=(u,m)=>u+i+m;e.namespaceTestTag=d;const h=u=>{const m=u.indexOf(i);return{ctrlId:u.slice(0,m),tagId:u.slice(m+1)}};e.denamespaceTestTag=h;var S;(function(u){u.serialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?.toJSON(),range:m.range?.toJSON()||null,description:m.description,error:m.error,sortText:m.sortText}),u.deserialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?o.URI.revive(m.uri):void 0,range:m.range?A.Range.lift(m.range):null,description:m.description,error:m.error,sortText:m.sortText})})(S||(e.ITestItem=S={}));var E;(function(u){u[u.NotExpandable=0]="NotExpandable",u[u.Expandable=1]="Expandable",u[u.BusyExpanding=2]="BusyExpanding",u[u.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var p;(function(u){u.serialize=m=>({expand:m.expand,item:S.serialize(m.item)}),u.deserialize=m=>({controllerId:l.TestId.root(m.item.extId),expand:m.expand,item:S.deserialize(m.item)})})(p||(e.InternalTestItem=p={}));var t;(function(u){u.serialize=m=>{let f;return m.item&&(f={},m.item.label!==void 0&&(f.label=m.item.label),m.item.tags!==void 0&&(f.tags=m.item.tags),m.item.busy!==void 0&&(f.busy=m.item.busy),m.item.uri!==void 0&&(f.uri=m.item.uri?.toJSON()),m.item.range!==void 0&&(f.range=m.item.range?.toJSON()),m.item.description!==void 0&&(f.description=m.item.description),m.item.error!==void 0&&(f.error=m.item.error),m.item.sortText!==void 0&&(f.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:f}},u.deserialize=m=>{let f;return m.item&&(f={},m.item.label!==void 0&&(f.label=m.item.label),m.item.tags!==void 0&&(f.tags=m.item.tags),m.item.busy!==void 0&&(f.busy=m.item.busy),m.item.range!==void 0&&(f.range=m.item.range?A.Range.lift(m.item.range):null),m.item.description!==void 0&&(f.description=m.item.description),m.item.error!==void 0&&(f.error=m.item.error),m.item.sortText!==void 0&&(f.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:f}}})(t||(e.ITestItemUpdate=t={}));const s=(u,m)=>{m.expand!==void 0&&(u.expand=m.expand),m.item!==void 0&&(u.item=u.item?Object.assign(u.item,m.item):m.item)};e.applyTestItemUpdate=s;var r;(function(u){u.serializeWithoutMessages=m=>({...p.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(b.serializeWithoutMessages),retired:m.retired}),u.serialize=m=>({...p.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(b.serialize),retired:m.retired}),u.deserialize=m=>({...p.deserialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(b.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var a;(function(u){u[u.Function=0]="Function",u[u.Statement=1]="Statement"})(a||(e.DetailType=a={}));var v;(function(u){u[u.Add=0]="Add",u[u.Update=1]="Update",u[u.DocumentSynced=2]="DocumentSynced",u[u.Remove=3]="Remove",u[u.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",u[u.Retire=5]="Retire",u[u.AddTag=6]="AddTag",u[u.RemoveTag=7]="RemoveTag"})(v||(e.TestDiffOpType=v={}));var _;(function(u){u.deserialize=m=>m.op===0?{op:m.op,item:p.deserialize(m.item)}:m.op===1?{op:m.op,item:t.deserialize(m.item)}:m.op===2?{op:m.op,uri:o.URI.revive(m.uri),docv:m.docv}:m,u.serialize=m=>m.op===0?{op:m.op,item:p.serialize(m.item)}:m.op===1?{op:m.op,item:t.serialize(m.item)}:m})(_||(e.TestsDiffOp=_={}));class c{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(m){const f=this.createChangeCollector();for(const n of m)switch(n.op){case 0:this.add(p.deserialize(n.item),f);break;case 1:this.update(t.deserialize(n.item),f);break;case 3:this.remove(n.itemId,f);break;case 5:this.retireTest(n.itemId);break;case 4:this.updatePendingRoots(n.amount);break;case 6:this._tags.set(n.tag.id,n.tag);break;case 7:this._tags.delete(n.id);break}f.complete?.()}add(m,f){const n=l.TestId.parentId(m.item.extId)?.toString();let D;if(!n)D=this.createItem(m),this.roots.add(D),this.items.set(m.item.extId,D);else if(this.items.has(n)){const M=this.items.get(n);M.children.add(m.item.extId),D=this.createItem(m,M),this.items.set(m.item.extId,D)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(m)}`);return}return f.add?.(D),m.expand===2&&this.busyControllerCount++,D}update(m,f){const n=this.items.get(m.extId);if(n)return m.expand!==void 0&&(n.expand===2&&this.busyControllerCount--,m.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(n,m),f.update?.(n),n}remove(m,f){const n=this.items.get(m);if(!n)return;const D=l.TestId.parentId(n.item.extId)?.toString();D?this.items.get(D).children.delete(n.item.extId):this.roots.delete(n);const M=[[m]];for(;M.length;)for(const W of M.pop()){const $=this.items.get(W);$&&(M.push($.children),this.items.delete(W),f.remove?.($,$!==n),$.expand===2&&this.busyControllerCount--)}}retireTest(m){}updatePendingRoots(m){this.pendingRootCount+=m}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=c}),define(De[95],Ie([1,0,19,3,6,51,77,59]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const g=(h,S)=>h===S,I=Object.entries({range:(h,S)=>h===S?!0:!h||!S?!1:h.equalsRange(S),busy:g,label:g,description:g,error:g,sortText:g,tags:(h,S)=>!(h.length!==S.length||h.some(E=>!S.includes(E)))}),w=(h,S)=>{let E;for(const[p,t]of I)t(h[p],S[p])||(E?E[p]=S[p]:E={[p]:S[p]});return E};class k extends l.Disposable{get root(){return this.options.root}constructor(S){super(),this.options=S,this.debounceSendDiff=this._register(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new A.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(S){this._resolveHandler=S;for(const E of this.tree.values())this.updateExpandability(E)}get resolveHandler(){return this._resolveHandler}collectDiff(){const S=this.diff;return this.diff=[],S}pushDiff(S){switch(S.op){case 2:{for(const E of this.diff)if(E.op===2&&E.uri===S.uri){E.docv=S.docv;return}break}case 1:{const E=this.diff[this.diff.length-1];if(E){if(E.op===1&&E.item.extId===S.item.extId){(0,T.applyTestItemUpdate)(E.item,S.item);return}if(E.op===0&&E.item.item.extId===S.item.extId){(0,T.applyTestItemUpdate)(E.item,S.item);return}}break}}this.diff.push(S),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(S,E){const p=this.tree.get(S);if(p){if((p.expandLevels===void 0||E>p.expandLevels)&&(p.expandLevels=E),p.expand===1){const t=this.resolveChildren(p);return t.isOpen()?this.expandChildren(p,E-1):t.wait().then(()=>this.expandChildren(p,E-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,E-1)):this.expandChildren(p,E-1)}}dispose(){for(const S of this.tree.values())this.options.getApiFor(S.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(S,E){switch(E.op){case 3:this.removeItem(P.TestId.joinToString(S.fullId,E.id));break;case 0:this.upsertItem(E.item,S);break;case 5:for(const p of E.ops)this.onTestItemEvent(S,p);break;case 1:this.diffTagRefs(E.new,E.old,S.fullId.toString());break;case 2:this.updateExpandability(S);break;case 4:this.pushDiff({op:1,item:{extId:S.fullId.toString(),item:E.update}});break;case 6:this.documentSynced(S.actual.uri);break;default:(0,R.assertNever)(E)}}documentSynced(S){S&&this.pushDiff({op:2,uri:S,docv:this.options.getDocumentVersion(S)})}upsertItem(S,E){const p=P.TestId.fromExtHostTestItem(S,this.root.id,E?.actual),t=this.options.getApiFor(S);t.parent&&t.parent!==E?.actual&&this.options.getChildren(t.parent).delete(S.id);let s=this.tree.get(p.toString());if(!s){s={fullId:p,actual:S,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},S.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(S,E),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(S)}}),this.connectItemAndChildren(S,s,E);return}if(s.actual===S){this.connectItem(S,s,E);return}if(s.actual.uri?.toString()!==S.uri?.toString())return this.removeItem(p.toString()),this.upsertItem(S,E);const r=this.options.getChildren(s.actual),a=s.actual,v=w(this.options.toITestItem(a),this.options.toITestItem(S));this.options.getApiFor(a).listener=void 0,s.actual=S,s.expand=0,v&&(v.hasOwnProperty("tags")&&(this.diffTagRefs(S.tags,a.tags,p.toString()),delete v.tags),this.onTestItemEvent(s,{op:4,update:v})),this.connectItemAndChildren(S,s,E);for(const[_,c]of r)this.options.getChildren(S).get(c.id)||this.removeItem(P.TestId.joinToString(p,c.id));this.documentSynced(s.actual.uri)}diffTagRefs(S,E,p){const t=new Set(E.map(s=>s.id));for(const s of S)t.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:p,item:{tags:S.map(s=>(0,T.namespaceTestTag)(this.options.controllerId,s.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(S){const E=this.tags.get(S.id);E?E.refCount++:(this.tags.set(S.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,S.id)}}))}decrementTagRefs(S){const E=this.tags.get(S);E&&!--E.refCount&&(this.tags.delete(S),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,S)}))}setItemParent(S,E){this.options.getApiFor(S).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(S,E,p){this.setItemParent(S,p);const t=this.options.getApiFor(S);t.parent=p?.actual,t.listener=s=>this.onTestItemEvent(E,s),this.updateExpandability(E)}connectItemAndChildren(S,E,p){this.connectItem(S,E,p);for(const[t,s]of this.options.getChildren(S))this.upsertItem(s,E)}updateExpandability(S){let E;this._resolveHandler?S.resolveBarrier?E=S.resolveBarrier.isOpen()?3:2:E=S.actual.canResolveChildren?1:0:E=0,E!==S.expand&&(S.expand=E,this.pushDiff({op:1,item:{extId:S.fullId.toString(),expand:E}}),E===1&&S.expandLevels!==void 0&&this.resolveChildren(S))}expandChildren(S,E){if(E<0)return;const p=[];for(const[t,s]of this.options.getChildren(S.actual)){const r=this.expand(P.TestId.joinToString(S.fullId,s.id),E);(0,o.isThenable)(r)&&p.push(r)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(S){if(S.resolveBarrier)return S.resolveBarrier;if(!this._resolveHandler){const s=new o.Barrier;return s.open(),s}S.expand=2,this.pushExpandStateUpdate(S);const E=S.resolveBarrier=new o.Barrier,p=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let t;try{t=this._resolveHandler(S.actual===this.root?void 0:S.actual)}catch(s){p(s)}return(0,o.isThenable)(t)?t.catch(p).then(()=>{E.open(),this.updateExpandability(S)}):(E.open(),this.updateExpandability(S)),S.resolveBarrier}pushExpandStateUpdate(S){this.pushDiff({op:1,item:{extId:S.fullId.toString(),expand:S.expand}})}removeItem(S){const E=this.tree.get(S);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:S});const p=[E];for(;p.length;){const t=p.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(t.fullId.toString());for(const[s,r]of this.options.getChildren(t.actual))p.push(this.tree.get(P.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const S=this.collectDiff();S.length&&this.diffOpEmitter.fire(S)}}e.TestItemCollection=k;class C extends Error{constructor(S){super(`Attempted to insert a duplicate test item ID ${S}`)}}e.DuplicateTestItemError=C;class b extends Error{constructor(S){super(`TestItem with ID "${S}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class i extends Error{constructor(S,E,p){super(`TestItem with ID "${S}" is from controller "${E}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=i;const d=(h,S,E)=>{let p=new Map;return{get size(){return p.size},forEach(t,s){for(const r of p.values())t.call(s,r,this)},[Symbol.iterator](){return p.entries()},replace(t){const s=new Map,r=new Set(p.keys()),a={op:5,ops:[]};for(const v of t){if(!(v instanceof E))throw new b(v.id);const _=S(v).controllerId;if(_!==h.controllerId)throw new i(v.id,_,h.controllerId);if(s.has(v.id))throw new C(v.id);s.set(v.id,v),r.delete(v.id),a.ops.push({op:0,item:v})}for(const v of r.keys())a.ops.push({op:3,id:v});h.listener?.(a),p=s},add(t){if(!(t instanceof E))throw new b(t.id);p.set(t.id,t),h.listener?.({op:0,item:t})},delete(t){p.delete(t)&&h.listener?.({op:3,id:t})},get(t){return p.get(t)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=d}),define(De[133],Ie([1,0,95]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,l=(T,P)=>{const y={controllerId:P};return A.set(T,y),y};e.createPrivateApiFor=l;const R=T=>{const P=A.get(T);if(!P)throw new o.InvalidTestItemError(T?.id||"<unknown>");return P};e.getPrivateApiFor=R}),define(De[96],Ie([1,0,16,2]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function l(P,y){return P.scheme===o.Schemas.http||P.scheme===o.Schemas.https?P:(y&&y.authority&&y.isRemote&&P.scheme===o.Schemas.file&&(P=A.URI.from({scheme:o.Schemas.vscodeRemote,authority:y.authority,path:P.path})),A.URI.from({scheme:o.Schemas.https,authority:`${P.scheme}+${R(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=l;function R(P){return P.replace(/./g,y=>{const g=y.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?y:"-"+g.toString(16).padStart(4,"0")})}function T(P){return P.replace(/-([0-9a-f]{4})/g,(y,g)=>String.fromCharCode(parseInt(g,16)))}e.decodeAuthority=T}),define(De[242],Ie([1,0,3,6,96]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(P,y,g){this._proxy=P,this._editors=y,this._remoteInfo=g,this._handlePool=0,this._disposables=new A.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const I of this._insets.values())L.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,y,g,L,I){let w;for(const S of this._editors.getVisibleTextEditors(!0))if(S.value===P){w=S;break}if(!w)throw new Error("not a visible editor");const k=this,C=this._handlePool++,b=new o.Emitter,i=new o.Emitter,d=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(S){return(0,l.asWebviewUri)(S,k._remoteInfo)}get cspSource(){return l.webviewGenericCspSource}set options(S){this._options=S,k._proxy.$setOptions(C,S)}get options(){return this._options}set html(S){this._html=S,k._proxy.$setHtml(C,S)}get html(){return this._html}get onDidReceiveMessage(){return b.event}postMessage(S){return k._proxy.$postMessage(C,S)}},h=new class{constructor(){this.editor=P,this.line=y,this.height=g,this.webview=d,this.onDidDispose=i.event}dispose(){k._insets.has(C)&&(k._insets.delete(C),k._proxy.$disposeEditorInset(C),i.fire(),i.dispose(),b.dispose())}};return this._proxy.$createEditorInset(C,w.id,w.value.document.uri,y+1,g,L||{},I.identifier,I.extensionLocation),this._insets.set(C,{editor:P,inset:h,onDidReceiveMessage:b}),h}$onDidDispose(P){const y=this._insets.get(P);y&&y.inset.dispose()}$onDidReceiveMessage(P,y){this._insets.get(P)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=R}),define(De[243],Ie([1,0,4]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,o.createDecorator)("configurationResolverService");var A;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(A||(e.VariableKind=A={}));class l extends Error{constructor(T,P){super(P),this.variable=T}}e.VariableError=l}),define(De[244],Ie([1,0,15,33,10,23,14,114,202,243,9]),function(oe,e,o,A,l,R,T,P,y,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(k,C,b,i){this._contributedVariables=new Map,this._context=k,this._labelService=C,this._userHomePromise=b,i&&(this._envVariablesPromise=i.then(d=>this.prepareEnv(d)))}prepareEnv(k){if(T.isWindows){const C=Object.create(null);return Object.keys(k).forEach(b=>{C[b.toLowerCase()]=k[b]}),C}return k}resolveWithEnvironment(k,C,b){return this.recursiveResolve({env:this.prepareEnv(k),userHome:void 0},C?C.uri:void 0,b)}async resolveAsync(k,C){const b={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(b,k?k.uri:void 0,C)}async resolveAnyBase(k,C,b,i){const d=R.deepClone(C);T.isWindows&&d.windows?Object.keys(d.windows).forEach(S=>d[S]=d.windows[S]):T.isMacintosh&&d.osx?Object.keys(d.osx).forEach(S=>d[S]=d.osx[S]):T.isLinux&&d.linux&&Object.keys(d.linux).forEach(S=>d[S]=d.linux[S]),delete d.windows,delete d.osx,delete d.linux;const h={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(h,k?k.uri:void 0,d,b,i)}async resolveAnyAsync(k,C,b){return this.resolveAnyBase(k,C,b)}async resolveAnyMap(k,C,b){const i=new Map;return{newConfig:await this.resolveAnyBase(k,C,b,i),resolvedVariables:i}}resolveWithInteractionReplace(k,C,b,i){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,C,b,i){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,C){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,C)}async recursiveResolve(k,C,b,i,d){if(l.isString(b))return this.resolveString(k,C,b,i,d);if(Array.isArray(b))return Promise.all(b.map(h=>this.recursiveResolve(k,C,h,i,d)));if(l.isObject(b)){const h=Object.create(null),S=await Promise.all(Object.keys(b).map(async E=>[await this.resolveString(k,C,E,i,d),await this.recursiveResolve(k,C,b[E],i,d)]));for(const[E,p]of S)h[E]=p;return h}return b}resolveString(k,C,b,i,d){return(0,L.replaceAsync)(b,I.VARIABLE_REGEXP,async(h,S)=>{if(S.includes(I.VARIABLE_LHS))return h;let E=await this.evaluateSingleVariable(k,h,S,C,i);return d?.set(S,E),E!==h&&l.isString(E)&&E.match(I.VARIABLE_REGEXP)&&(E=await this.resolveString(k,C,E,i,d)),E})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}async evaluateSingleVariable(k,C,b,i,d){let h;const S=b.split(":");S.length>1&&(b=S[0],h=S[1]);const E=s=>{const r=this._context.getFilePath();if(r)return(0,P.normalizeDriveLetter)(r);throw new g.VariableError(s,(0,y.localize)(0,null,C))},p=s=>{const r=E(s);if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return(0,P.normalizeDriveLetter)(a)}throw new g.VariableError(s,(0,y.localize)(1,null,C,o.basename(r)))},t=s=>{if(h){const r=this._context.getFolderUri(h);if(r)return r;throw new g.VariableError(s,(0,y.localize)(2,null,C,h))}if(i)return i;throw this._context.getWorkspaceFolderCount()>1?new g.VariableError(s,(0,y.localize)(3,null,C)):new g.VariableError(s,(0,y.localize)(4,null,C))};switch(b){case"env":if(h){if(k.env){const s=k.env[T.isWindows?h.toLowerCase():h];if(l.isString(s))return s}return""}throw new g.VariableError(g.VariableKind.Env,(0,y.localize)(5,null,C));case"config":if(h){const s=this._context.getConfigurationValue(i,h);if(l.isUndefinedOrNull(s))throw new g.VariableError(g.VariableKind.Config,(0,y.localize)(6,null,C,h));if(l.isObject(s))throw new g.VariableError(g.VariableKind.Config,(0,y.localize)(7,null,C,h));return s}throw new g.VariableError(g.VariableKind.Config,(0,y.localize)(8,null,C));case"command":return this.resolveFromMap(g.VariableKind.Command,C,h,d,"command");case"input":return this.resolveFromMap(g.VariableKind.Input,C,h,d,"input");case"extensionInstallFolder":if(h){const s=await this._context.getExtension(h);if(!s)throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,C,h));return this.fsPath(s.extensionLocation)}throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,C));default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(t(g.VariableKind.WorkspaceFolder)));case"cwd":return i||h?(0,P.normalizeDriveLetter)(this.fsPath(t(g.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(o.basename(this.fsPath(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new g.VariableError(g.VariableKind.UserHome,(0,y.localize)(11,null,C))}case"lineNumber":{const s=this._context.getLineNumber();if(s)return s;throw new g.VariableError(g.VariableKind.LineNumber,(0,y.localize)(12,null,C))}case"selectedText":{const s=this._context.getSelectedText();if(s)return s;throw new g.VariableError(g.VariableKind.SelectedText,(0,y.localize)(13,null,C))}case"file":return E(g.VariableKind.File);case"fileWorkspaceFolder":return p(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return i||h?o.relative(this.fsPath(t(g.VariableKind.RelativeFile)),E(g.VariableKind.RelativeFile)):E(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=o.dirname(E(g.VariableKind.RelativeFileDirname));if(i||h){const r=o.relative(this.fsPath(t(g.VariableKind.RelativeFileDirname)),s);return r.length===0?".":r}return s}case"fileDirname":return o.dirname(E(g.VariableKind.FileDirname));case"fileExtname":return o.extname(E(g.VariableKind.FileExtname));case"fileBasename":return o.basename(E(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=o.basename(E(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-o.extname(s).length)}case"fileDirnameBasename":return o.basename(o.dirname(E(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this._context.getExecPath();return s||C}case"execInstallFolder":{const s=this._context.getAppRoot();return s||C}case"pathSeparator":return o.sep;default:try{const s=h?`${b}:${h}`:b;return this.resolveFromMap(g.VariableKind.Unknown,C,s,d,void 0)}catch{return C}}}}resolveFromMap(k,C,b,i,d){if(b&&i){const h=d===void 0?i[b]:i[d+":"+b];if(typeof h=="string")return h;throw new g.VariableError(k,(0,y.localize)(14,null,C))}return C}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[134],Ie([1,0,4,130]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var l;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(l||(e.GroupDirection=l={}));var R;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var T;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var P;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(P||(e.GroupsArrangement=P={}));var y;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function g(C){const b=C;return(0,A.isEditorInput)(b?.editor)&&(0,A.isEditorInput)(b?.replacement)}e.isEditorReplacement=g;var L;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var I;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function w(C){const b=C;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=w;function k(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(De[245],Ie([1,0,4,134]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function l(R){const T=R;return typeof R=="number"||(0,A.isEditorGroup)(T)}e.isPreferredGroup=l}),define(De[246],Ie([1,0,4,209]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(A.IEnvironmentService)}),define(De[135],Ie([1,0,25,3,15,6]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class P{static isHostExtension(i,d,h){if(d.getExtensionDescription(i))return!1;const S=h.getExtensionDescription(i);return S?!!((S.main||S.browser)&&S.api==="none"):!1}constructor(i,d){this._activationEventsReader=i,this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=d,this._initialize()}_initialize(){this._extensionDescriptions.sort(k),this._extensionsMap=new o.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this._extensionsMap.set(i.identifier,i),this._extensionsArr.push(i);const d=this._activationEventsReader.readActivationEvents(i);if(Array.isArray(d))for(let h of d)h==="onUri"&&(h=`onUri:${o.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(h)||this._activationMap.set(h,[]),this._activationMap.get(h).push(i)}}set(i){this._extensionDescriptions=i,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,d){this._extensionDescriptions=C(this._extensionDescriptions,d),this._extensionDescriptions=this._extensionDescriptions.concat(i);const h=P._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=C(this._extensionDescriptions,h.map(S=>S.identifier)),this._initialize(),this._onDidChange.fire(void 0),new T(h)}static _findLoopingExtensions(i){const d=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(t){this._nodesSet.has(t)||(this._nodesSet.add(t),this._nodesArr.push(t))}addArc(t,s){this.addNode(t),this.addNode(s),this._arcs.has(t)?this._arcs.get(t).push(s):this._arcs.set(t,[s])}getArcs(t){return this._arcs.has(t)?this._arcs.get(t):[]}hasOnlyGoodArcs(t,s){const r=d.getArcs(t);for(let a=0;a<r.length;a++)if(!s.has(r[a]))return!1;return!0}getNodes(){return this._nodesArr}},h=new o.ExtensionIdentifierMap;for(const t of i)if(h.set(t.identifier,t),t.extensionDependencies)for(const s of t.extensionDependencies)d.addArc(o.ExtensionIdentifier.toKey(t.identifier),o.ExtensionIdentifier.toKey(s));const S=new Set;d.getNodes().filter(t=>d.getArcs(t).length===0).forEach(t=>S.add(t));const E=d.getNodes().filter(t=>!S.has(t));let p;do{p=!1;for(let t=0;t<E.length;t++){const s=E[t];d.hasOnlyGoodArcs(s,S)&&(E.splice(t,1),t--,S.add(s),p=!0)}}while(p);return E.map(t=>h.get(t))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(i)}getExtensionDescriptionsForActivationEvent(i){const d=this._activationMap.get(i);return d?d.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const d=this._extensionsMap.get(i);return d||void 0}getExtensionDescriptionByUUID(i){for(const d of this._extensionsArr)if(d.uuid===i)return d}getExtensionDescriptionByIdOrUUID(i,d){return this.getExtensionDescription(i)??(d?this.getExtensionDescriptionByUUID(d):void 0)}}e.ExtensionDescriptionRegistry=P,e.basicActivationEventsReader={readActivationEvents:b=>b.activationEvents};class y{constructor(i){this._lock=new I,this._actual=new P(i,[])}async acquireLock(i){const d=await this._lock.acquire(i);return new g(this,d)}deltaExtensions(i,d,h){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(d,h)}containsActivationEvent(i){return this._actual.containsActivationEvent(i)}containsExtension(i){return this._actual.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this._actual.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getExtensionDescription(i){return this._actual.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this._actual.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,d){return this._actual.getExtensionDescriptionByIdOrUUID(i,d)}}e.LockableExtensionDescriptionRegistry=y;class g extends R.Disposable{constructor(i,d){super(),this._registry=i,this._isDisposed=!1,this._register(d)}isAcquiredFor(i){return!this._isDisposed&&this._registry===i}}e.ExtensionDescriptionRegistryLock=g;class L{constructor(i){this.name=i,this.promise=new Promise((d,h)=>{this._resolve=d})}resolve(i){this._resolve(i)}}class I{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(i){const d=new L(i);return this._pendingCustomers.push(d),this._advance(),d.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const i=this._pendingCustomers.shift();this._isLocked=!0;let d=!0;const h=setTimeout(()=>{d&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),S=()=>{d&&(clearTimeout(h),d=!1,this._isLocked=!1,this._advance())};i.resolve((0,R.toDisposable)(S))}}var w;(function(b){b[b.Builtin=0]="Builtin",b[b.User=1]="User",b[b.Dev=2]="Dev"})(w||(w={}));function k(b,i){const d=b.isBuiltin?0:b.isUnderDevelopment?2:1,h=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(d!==h)return d-h;const S=l.posix.basename(b.extensionLocation.path),E=l.posix.basename(i.extensionLocation.path);return S<E?-1:S>E?1:0}function C(b,i){const d=new o.ExtensionIdentifierSet(i);return b.filter(h=>!d.has(h.identifier))}}),define(De[247],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var o;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(o||(e.ExtHostConnectionType=o={}));class A{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[A.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=A,A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class l{constructor(){this.type=2}serialize(I){I[l.ENV_KEY]="1"}}e.SocketExtHostConnection=l,l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class R{constructor(){this.type=3}serialize(I){I[R.ENV_KEY]="1"}}e.MessagePortExtHostConnection=R,R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function T(L){delete L[A.ENV_KEY],delete L[l.ENV_KEY],delete L[R.ENV_KEY]}function P(L,I){T(I),L.serialize(I)}e.writeExtHostConnection=P;function y(L){if(L[A.ENV_KEY])return g(L,new A(L[A.ENV_KEY]));if(L[l.ENV_KEY])return g(L,new l);if(L[R.ENV_KEY])return g(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function g(L,I){return T(L),I}}),define(De[97],Ie([1,0,22]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(A||(e.UIKind=A={}));var l;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(l||(e.ExtensionHostExitCode=l={}));var R;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function T(g){const L=o.VSBuffer.alloc(1);switch(g){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=T;function P(g,L){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=P;var y;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(De[78],Ie([1,0,4,3,17,26,97,74,75,23,2,6,189]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let k=e.ExtHostTelemetry=class extends I.Disposable{constructor(d,h){super(),this.initData=d,this.loggerService=h,this._onDidChangeTelemetryEnabled=this._register(new A.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new A.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=L.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=h.createLogger(this.extHostTelemetryLogFile,{id:y.extensionTelemetryLogChannelId,name:(0,w.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(h.onDidChangeLogLevel(S=>{(0,l.isLogLevel)(S)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(d,h,S){const E=this.getTelemetryDetails(),p=new C(h,S,d,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(d),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),t=this._telemetryLoggers.get(d.identifier.value)??[];return this._telemetryLoggers.set(d.identifier.value,[...t,p]),p.apiTelemetryLogger}$initializeTelemetryLevel(d,h,S){this._level=d,this._telemetryIsSupported=h,this._productConfig=S??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(d){const h=Object.create(null);switch(h["common.extname"]=`${d.publisher}.${d.name}`,h["common.extversion"]=d.version,h["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,h["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,h["common.vscodeversion"]=this.initData.version,h["common.isnewappinstall"]=b(this.initData.telemetryInfo.firstSessionDate),h["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case T.UIKind.Web:h["common.uikind"]="web";break;case T.UIKind.Desktop:h["common.uikind"]="desktop";break;default:h["common.uikind"]="unknown"}return h["common.remotename"]=(0,P.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),h}$onDidChangeTelemetryLevel(d){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=d;const h=this.getTelemetryDetails();this._telemetryLoggers.forEach((S,E)=>{const p=S.filter(t=>!t.isDisposed);p.length===0?this._telemetryLoggers.delete(E):this._telemetryLoggers.set(E,p)}),this._telemetryLoggers.forEach(S=>{for(const E of S)E.updateTelemetryEnablements(h.isUsageEnabled,h.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(d,h){const E=this._telemetryLoggers.get(d.value)?.filter(t=>!t.isDisposed);if(!E)return this._telemetryLoggers.delete(d.value),!1;let p=!1;for(const t of E)t.ignoreUnhandledExtHostErrors||(t.logError(h),p=!0);return p}};e.ExtHostTelemetry=k=Ve([ze(0,R.IExtHostInitDataService),ze(1,l.ILoggerService)],k);class C{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,h,S,E,p,t,s){this._extension=S,this._logger=E,this._inLoggingOnlyMode=p,this._commonProperties=t,this._onDidChangeEnableStates=new A.Emitter,this.ignoreUnhandledExtHostErrors=h?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=h?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=h?.additionalCommonProperties,this._sender=d,this._telemetryEnablements={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(d,h){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:d,isErrorsEnabled:h},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(d){let h="properties"in d?d.properties??{}:d;return h=(0,y.cleanData)(h,[]),this._additionalCommonProperties&&(h=(0,g.mixin)(h,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(h=(0,g.mixin)(h,this._commonProperties)),"properties"in d?d.properties=h:d=h,d}logEvent(d,h){this._sender&&(this._extension.publisher==="vscode"?d=this._extension.name+"/"+d:d=this._extension.identifier.value+"/"+d,h=this.mixInCommonPropsAndCleanData(h||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(d,h),this._logger.trace(d,h))}logUsage(d,h){this._telemetryEnablements.isUsageEnabled&&this.logEvent(d,h)}logError(d,h){!this._telemetryEnablements.isErrorsEnabled||!this._sender||(typeof d=="string"?this.logEvent(d,h):this._sender.sendErrorData(d,h))}get apiTelemetryLogger(){if(!this._apiObject){const d=this,h={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return d._telemetryEnablements.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d._onDidChangeEnableStates.event.bind(d)};this._apiObject=Object.freeze(h)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let d=this._sender;this._sender=void 0,Promise.resolve(d.flush()).then(d=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=C;function b(i){const d=Date.now()-new Date(i).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=b,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(De[27],Ie([1,0,3,2,222,128,25,4]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class y{constructor(p){this.dependency=p}}e.MissingExtensionDependency=y;var g;(function(E){E[E.EagerAutoStart=1]="EagerAutoStart",E[E.EagerManualStart=2]="EagerManualStart",E[E.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class L{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,addActivationEvents:R.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions),myToRemove:[],myToAdd:this._myExtensions}}set(p,t){const s=[],r=[],a=[],v=[],_=I(this._allExtensions),c=I(p),u=(M,W)=>M.extensionLocation.toString()===W.extensionLocation.toString()||M.isBuiltin===W.isBuiltin||M.isUserBuiltin===W.isUserBuiltin||M.isUnderDevelopment===W.isUnderDevelopment;for(const M of this._allExtensions){const W=c.get(M.identifier);if(!W){s.push(M.identifier),_.delete(M.identifier);continue}if(!u(M,W)){s.push(M.identifier),_.delete(M.identifier);continue}}for(const M of p){const W=_.get(M.identifier);if(!W){r.push(M);continue}if(!u(W,M)){s.push(W.identifier),_.delete(W.identifier);continue}}const m=new T.ExtensionIdentifierSet(this._myExtensions),f=new T.ExtensionIdentifierSet(t);for(const M of this._myExtensions)f.has(M)||a.push(M);for(const M of t)m.has(M)||v.push(M);const n=R.ImplicitActivationEvents.createActivationEventsMap(r),D={toRemove:s,toAdd:r,addActivationEvents:n,myToRemove:a,myToAdd:v};return this.delta(D),D}delta(p){const{toRemove:t,toAdd:s,myToRemove:r,myToAdd:a}=p,v=new T.ExtensionIdentifierSet(t),_=new T.ExtensionIdentifierSet(r);for(let c=0;c<this._allExtensions.length;c++)v.has(this._allExtensions[c].identifier)&&(this._allExtensions.splice(c,1),c--);for(let c=0;c<this._myExtensions.length;c++)_.has(this._myExtensions[c])&&(this._myExtensions.splice(c,1),c--);for(const c of s)this._allExtensions.push(c);for(const c of a)this._myExtensions.push(c)}containsExtension(p){for(const t of this._myExtensions)if(T.ExtensionIdentifier.equals(t,p))return!0;return!1}}e.ExtensionHostExtensions=L;function I(E){const p=new T.ExtensionIdentifierMap;for(const t of E)p.set(t.identifier,t);return p}function w(E,p){return E.enabledApiProposals?E.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=w;function k(E,p){if(!w(E,p))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.checkProposedApiEnabled=k;class C{constructor(p,t,s,r){this.codeLoadingTime=p,this.activateCallTime=t,this.activateResolvedTime=s,this.activationReason=r}}e.ActivationTimes=C;class b{constructor(p,t){this.description=p,this.value=t}}e.ExtensionPointContribution=b;var i;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(i||(e.ActivationKind=i={}));function d(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,l.getGalleryExtensionId)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function h(E,p){return{identifier:new T.ExtensionIdentifier((0,l.getExtensionId)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!p,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.toExtensionDescription=h;class S{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None,this.onWillStop=o.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=S}),define(De[248],Ie([1,0,8,135,25,27,17,19]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(d,h,S,E){this.startup=d,this.codeLoadingTime=h,this.activateCallTime=S,this.activateResolvedTime=E}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class g{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,h){return d===-1||h===-1?-1:h-d}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=g;class L{constructor(d,h,S,E,p,t){this.activationFailed=d,this.activationFailedError=h,this.activationTimes=S,this.module=E,this.exports=p,this.subscriptions=t}}e.ActivatedExtension=L;class I extends L{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class w extends L{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=w;class k extends L{constructor(d){super(!0,d,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=e.ExtensionsActivator=class{constructor(d,h,S,E){this._logService=E,this._registry=d,this._globalRegistry=h,this._host=S,this._operations=new l.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[d,h]of this._operations)h.dispose()}async waitForActivatingExtensions(){const d=[];for(const[h,S]of this._operations)d.push(S.wait());await Promise.all(d)}isActivated(d){const h=this._operations.get(d);return!!(h&&h.value)}getActivatedExtension(d){const h=this._operations.get(d);if(!h||!h.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return h.value}async activateByEvent(d,h){if(this._alreadyActivatedEvents[d])return;const S=this._registry.getExtensionDescriptionsForActivationEvent(d);await this._activateExtensions(S.map(E=>({id:E.identifier,reason:{startup:h,extensionId:E.identifier,activationEvent:d}}))),this._alreadyActivatedEvents[d]=!0}activateById(d,h){const S=this._registry.getExtensionDescription(d);if(!S)throw new Error(`Extension '${d}' is not known`);return this._activateExtensions([{id:S.identifier,reason:h}])}async _activateExtensions(d){const h=d.filter(S=>!this.isActivated(S.id)).map(S=>this._handleActivationRequest(S));await Promise.all(h.map(S=>S.wait()))}_handleActivationRequest(d){if(this._operations.has(d.id))return this._operations.get(d.id);if(this._isHostExtension(d.id))return this._createAndSaveOperation(d,null,[],null);const h=this._registry.getExtensionDescription(d.id);if(!h){const p=new Error(`Cannot activate unknown extension '${d.id.value}'`),t=this._createAndSaveOperation(d,null,[],new k(p));return this._host.onExtensionActivationError(d.id,p,new R.MissingExtensionDependency(d.id.value)),t}const S=[],E=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const p of E){if(this._isResolvedExtension(p))continue;const t=this._operations.get(p);if(t){S.push(t);continue}if(this._isHostExtension(p)){S.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(p).identifier,reason:d.reason}));continue}const s=this._registry.getExtensionDescription(p);if(s){if(!s.main&&!s.browser)continue;S.push(this._handleActivationRequest({id:s.identifier,reason:d.reason}));continue}const r=h.displayName||h.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),v=this._createAndSaveOperation(d,h.displayName,[],new k(a));return this._host.onExtensionActivationError(h.identifier,a,new R.MissingExtensionDependency(p)),v}return this._createAndSaveOperation(d,h.displayName,S,null)}_createAndSaveOperation(d,h,S,E){const p=new b(d.id,h,d.reason,S,E,this._host,this._logService);return this._operations.set(d.id,p),p}_isHostExtension(d){return A.ExtensionDescriptionRegistry.isHostExtension(d,this._registry,this._globalRegistry)}_isResolvedExtension(d){const h=this._globalRegistry.getExtensionDescription(d);return h?!h.main&&!h.browser:!1}};e.ExtensionsActivator=C=Ve([ze(3,T.ILogService)],C);let b=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(d,h,S,E,p,t,s){this._id=d,this._displayName=h,this._reason=S,this._deps=E,this._value=p,this._host=t,this._logService=s,this._barrier=new P.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let d=0;d<this._deps.length;d++){const h=this._deps[d];if(h.value&&!h.value.activationFailed){this._deps.splice(d,1),d--;continue}if(h.value&&h.value.activationFailed){const S=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);S.detail=h.value.activationFailedError,this._value=new k(S),this._host.onExtensionActivationError(this._id,S,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(d=>d.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(d){const h=new Error;if(d&&d.name&&(h.name=d.name),d&&d.message?h.message=`Activating extension '${this._id.value}' failed: ${d.message}.`:h.message=`Activating extension '${this._id.value}' failed: ${d}.`,d&&d.stack&&(h.stack=d.stack),this._value=new k(h),this._isDisposed&&o.isCancellationError(d))return;this._host.onExtensionActivationError(this._id,h,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(d)}}};b=Ve([ze(6,T.ILogService)],b)});var Je=this&&this.__classPrivateFieldSet||function(oe,e,o,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,o):l?l.value=o:e.set(oe,o),o},xe=this&&this.__classPrivateFieldGet||function(oe,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(oe):A?A.value:e.get(oe)};define(De[7],Ie([1,0,18,8,113,28,89,9,10,2,30,45,127,94,27]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C){"use strict";var b,i,d,h,S,E,p,t,s,r,a,v,_,c,u,m,f,n,D,M,W,$,N,U,q;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(G){return Object.assign(G,{apply:function(){const Ee=arguments.length===1?[]:arguments[1];return Reflect.construct(G,Ee,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[Ee,...Te]=arguments;return Reflect.construct(G,Te,Ee.constructor)}}})}var B;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(B||(e.TerminalOutputAnchor=B={}));var Q;(function(G){G[G.Command=0]="Command",G[G.Opener=1]="Opener"})(Q||(e.TerminalQuickFixType=Q={}));let J=e.Disposable=t=class{static from(...H){let Ee=H;return new t(function(){if(Ee){for(const Te of Ee)Te&&typeof Te.dispose=="function"&&Te.dispose();Ee=void 0}})}constructor(H){b.set(this,void 0),Je(this,b,H,"f")}dispose(){typeof xe(this,b,"f")=="function"&&(xe(this,b,"f").call(this),Je(this,b,void 0,"f"))}};b=new WeakMap,e.Disposable=J=t=Ve([F],J);let X=e.Position=s=class{static Min(...H){if(H.length===0)throw new TypeError;let Ee=H[0];for(let Te=1;Te<H.length;Te++){const Ge=H[Te];Ge.isBefore(Ee)&&(Ee=Ge)}return Ee}static Max(...H){if(H.length===0)throw new TypeError;let Ee=H[0];for(let Te=1;Te<H.length;Te++){const Ge=H[Te];Ge.isAfter(Ee)&&(Ee=Ge)}return Ee}static isPosition(H){if(!H)return!1;if(H instanceof s)return!0;const{line:Ee,character:Te}=H;return typeof Ee=="number"&&typeof Te=="number"}static of(H){if(H instanceof s)return H;if(this.isPosition(H))return new s(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(H,Ee){if(H<0)throw(0,A.illegalArgument)("line must be non-negative");if(Ee<0)throw(0,A.illegalArgument)("character must be non-negative");this._line=H,this._character=Ee}isBefore(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<H._character}isBeforeOrEqual(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<=H._character}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this._line===H._line&&this._character===H._character}compareTo(H){return this._line<H._line?-1:this._line>H.line?1:this._character<H._character?-1:this._character>H._character?1:0}translate(H,Ee=0){if(H===null||Ee===null)throw(0,A.illegalArgument)();let Te;return typeof H>"u"?Te=0:typeof H=="number"?Te=H:(Te=typeof H.lineDelta=="number"?H.lineDelta:0,Ee=typeof H.characterDelta=="number"?H.characterDelta:0),Te===0&&Ee===0?this:new s(this.line+Te,this.character+Ee)}with(H,Ee=this.character){if(H===null||Ee===null)throw(0,A.illegalArgument)();let Te;return typeof H>"u"?Te=this.line:typeof H=="number"?Te=H:(Te=typeof H.line=="number"?H.line:this.line,Ee=typeof H.character=="number"?H.character:this.character),Te===this.line&&Ee===this.character?this:new s(Te,Ee)}toJSON(){return{line:this.line,character:this.character}}};e.Position=X=s=Ve([F],X);let ie=e.Range=r=class{static isRange(H){return H instanceof r?!0:H?X.isPosition(H.start)&&X.isPosition(H.end):!1}static of(H){if(H instanceof r)return H;if(this.isRange(H))return new r(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(H,Ee,Te,Ge){let Ze,ut;if(typeof H=="number"&&typeof Ee=="number"&&typeof Te=="number"&&typeof Ge=="number"?(Ze=new X(H,Ee),ut=new X(Te,Ge)):X.isPosition(H)&&X.isPosition(Ee)&&(Ze=X.of(H),ut=X.of(Ee)),!Ze||!ut)throw new Error("Invalid arguments");Ze.isBefore(ut)?(this._start=Ze,this._end=ut):(this._start=ut,this._end=Ze)}contains(H){return r.isRange(H)?this.contains(H.start)&&this.contains(H.end):X.isPosition(H)?!(X.of(H).isBefore(this._start)||this._end.isBefore(H)):!1}isEqual(H){return this._start.isEqual(H._start)&&this._end.isEqual(H._end)}intersection(H){const Ee=X.Max(H.start,this._start),Te=X.Min(H.end,this._end);if(!Ee.isAfter(Te))return new r(Ee,Te)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const Ee=X.Min(H.start,this._start),Te=X.Max(H.end,this.end);return new r(Ee,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(H,Ee=this.end){if(H===null||Ee===null)throw(0,A.illegalArgument)();let Te;return H?X.isPosition(H)?Te=H:(Te=H.start||this.start,Ee=H.end||this.end):Te=this.start,Te.isEqual(this._start)&&Ee.isEqual(this.end)?this:new r(Te,Ee)}toJSON(){return[this.start,this.end]}};e.Range=ie=r=Ve([F],ie);let ae=e.Selection=a=class extends ie{static isSelection(H){return H instanceof a?!0:H?ie.isRange(H)&&X.isPosition(H.anchor)&&X.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(H,Ee,Te,Ge){let Ze,ut;if(typeof H=="number"&&typeof Ee=="number"&&typeof Te=="number"&&typeof Ge=="number"?(Ze=new X(H,Ee),ut=new X(Te,Ge)):X.isPosition(H)&&X.isPosition(Ee)&&(Ze=X.of(H),ut=X.of(Ee)),!Ze||!ut)throw new Error("Invalid arguments");super(Ze,ut),this._anchor=Ze,this._active=ut}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=ae=a=Ve([F],ae);class we{constructor(H,Ee,Te){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("host");if(typeof Ee!="number"||Ee===0||Math.round(Ee)!==Ee)throw(0,A.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,A.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(Ee),this.connectionToken=Te}}e.ResolvedAuthority=we;class he extends Error{static NotAvailable(H,Ee){return new he(H,w.RemoteAuthorityResolverErrorCode.NotAvailable,Ee)}static TemporarilyNotAvailable(H){return new he(H,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,Ee=w.RemoteAuthorityResolverErrorCode.Unknown,Te){super(H),this._message=H,this._code=Ee,this._detail=Te,Object.setPrototypeOf(this,he.prototype)}}e.RemoteAuthorityResolverError=he;var fe;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(fe||(e.EndOfLine=fe={}));var V;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(V||(e.EnvironmentVariableMutatorType=V={}));let x=e.TextEdit=v=class{static isTextEdit(H){return H instanceof v?!0:H?ie.isRange(H)&&typeof H.newText=="string":!1}static replace(H,Ee){return new v(H,Ee)}static insert(H,Ee){return v.replace(new ie(H,H),Ee)}static delete(H){return v.replace(H,"")}static setEndOfLine(H){const Ee=new v(new ie(new X(0,0),new X(0,0)),"");return Ee.newEol=H,Ee}get range(){return this._range}set range(H){if(H&&!ie.isRange(H))throw(0,A.illegalArgument)("range");this._range=H}get newText(){return this._newText||""}set newText(H){if(H&&typeof H!="string")throw(0,A.illegalArgument)("newText");this._newText=H}get newEol(){return this._newEol}set newEol(H){if(H&&typeof H!="number")throw(0,A.illegalArgument)("newEol");this._newEol=H}constructor(H,Ee){this._range=H,this._newText=Ee}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=x=v=Ve([F],x);let Z=e.NotebookEdit=_=class{static isNotebookCellEdit(H){return H instanceof _?!0:H?Qt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,Ee){return new _(H,Ee)}static insertCells(H,Ee){return new _(new Qt(H,H),Ee)}static deleteCells(H){return new _(H,[])}static updateCellMetadata(H,Ee){const Te=new _(new Qt(H,H),[]);return Te.newCellMetadata=Ee,Te}static updateNotebookMetadata(H){const Ee=new _(new Qt(0,0),[]);return Ee.newNotebookMetadata=H,Ee}constructor(H,Ee){this.range=H,this.newCells=Ee}};e.NotebookEdit=Z=_=Ve([F],Z);class pe{static isSnippetTextEdit(H){return H instanceof pe?!0:H?ie.isRange(H.range)&&ne.isSnippetString(H.snippet):!1}static replace(H,Ee){return new pe(H,Ee)}static insert(H,Ee){return pe.replace(new ie(H,H),Ee)}constructor(H,Ee){this.range=H,this.snippet=Ee}}e.SnippetTextEdit=pe;var _e;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(_e||(e.FileEditType=_e={}));let re=e.WorkspaceEdit=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(H,Ee,Te,Ge){this._edits.push({_type:1,from:H,to:Ee,options:Te,metadata:Ge})}createFile(H,Ee,Te){this._edits.push({_type:1,from:void 0,to:H,options:Ee,metadata:Te})}deleteFile(H,Ee,Te){this._edits.push({_type:1,from:H,to:void 0,options:Ee,metadata:Te})}replaceNotebookMetadata(H,Ee,Te){this._edits.push({_type:3,metadata:Te,uri:H,edit:{editType:5,metadata:Ee},notebookMetadata:Ee})}replaceNotebookCells(H,Ee,Te,Ge){const Ze=Ee.start,ut=Ee.end;(Ze!==ut||Te.length>0)&&this._edits.push({_type:5,uri:H,index:Ze,count:ut-Ze,cells:Te,metadata:Ge})}replaceNotebookCellMetadata(H,Ee,Te,Ge){this._edits.push({_type:3,metadata:Ge,uri:H,edit:{editType:8,index:Ee,metadata:Te}})}replace(H,Ee,Te,Ge){this._edits.push({_type:2,uri:H,edit:new x(Ee,Te),metadata:Ge})}insert(H,Ee,Te,Ge){this.replace(H,new ie(Ee,Ee),Te,Ge)}delete(H,Ee,Te){this.replace(H,Ee,"",Te)}has(H){return this._edits.some(Ee=>Ee._type===2&&Ee.uri.toString()===H.toString())}set(H,Ee){if(Ee)for(const Te of Ee){if(!Te)continue;let Ge,Ze;Array.isArray(Te)?(Ge=Te[0],Ze=Te[1]):Ge=Te,Z.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.replaceNotebookCellMetadata(H,Ge.range.start,Ge.newCellMetadata,Ze):Ge.newNotebookMetadata?this.replaceNotebookMetadata(H,Ge.newNotebookMetadata,Ze):this.replaceNotebookCells(H,Ge.range,Ge.newCells,Ze):pe.isSnippetTextEdit(Ge)?this._edits.push({_type:6,uri:H,range:Ge.range,edit:Ge.snippet,metadata:Ze}):this._edits.push({_type:2,uri:H,edit:Ge,metadata:Ze})}else{for(let Te=0;Te<this._edits.length;Te++){const Ge=this._edits[Te];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===H.toString()&&(this._edits[Te]=void 0);break}}(0,o.coalesceInPlace)(this._edits)}}get(H){const Ee=[];for(const Te of this._edits)Te._type===2&&Te.uri.toString()===H.toString()&&Ee.push(Te.edit);return Ee}entries(){const H=new R.ResourceMap;for(const Ee of this._edits)if(Ee._type===2){let Te=H.get(Ee.uri);Te||(Te=[Ee.uri,[]],H.set(Ee.uri,Te)),Te[1].push(Ee.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=re=Ve([F],re);let ne=e.SnippetString=c=class{static isSnippetString(H){return H instanceof c?!0:H?typeof H.value=="string":!1}static _escape(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this._tabstop=1,this.value=H||""}appendText(H){return this.value+=c._escape(H),this}appendTabstop(H=this._tabstop++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,Ee=this._tabstop++){if(typeof H=="function"){const Te=new c;Te._tabstop=this._tabstop,H(Te),this._tabstop=Te._tabstop,H=Te.value}else H=c._escape(H);return this.value+="${",this.value+=Ee,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,Ee=this._tabstop++){const Te=H.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Ee,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(H,Ee){if(typeof Ee=="function"){const Te=new c;Te._tabstop=this._tabstop,Ee(Te),this._tabstop=Te._tabstop,Ee=Te.value}else typeof Ee=="string"&&(Ee=Ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,Ee&&(this.value+=":",this.value+=Ee),this.value+="}",this}};e.SnippetString=ne=c=Ve([F],ne);var de;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(de||(e.DiagnosticTag=de={}));var ee;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let ce=e.Location=u=class{static isLocation(H){return H instanceof u?!0:H?ie.isRange(H.range)&&g.URI.isUri(H.uri):!1}constructor(H,Ee){if(this.uri=H,Ee)if(ie.isRange(Ee))this.range=ie.of(Ee);else if(X.isPosition(Ee))this.range=new ie(Ee,Ee);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=ce=u=Ve([F],ce);let le=e.DiagnosticRelatedInformation=class{static is(H){return H?typeof H.message=="string"&&H.location&&ie.isRange(H.location.range)&&g.URI.isUri(H.location.uri):!1}constructor(H,Ee){this.location=H,this.message=Ee}static isEqual(H,Ee){return H===Ee?!0:!H||!Ee?!1:H.message===Ee.message&&H.location.range.isEqual(Ee.location.range)&&H.location.uri.toString()===Ee.location.uri.toString()}};e.DiagnosticRelatedInformation=le=Ve([F],le);let ue=e.Diagnostic=class{constructor(H,Ee,Te=ee.Error){if(!ie.isRange(H))throw new TypeError("range must be set");if(!Ee)throw new TypeError("message must be set");this.range=H,this.message=Ee,this.severity=Te}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,Ee){return H===Ee?!0:!H||!Ee?!1:H.message===Ee.message&&H.severity===Ee.severity&&H.code===Ee.code&&H.severity===Ee.severity&&H.source===Ee.source&&H.range.isEqual(Ee.range)&&(0,o.equals)(H.tags,Ee.tags)&&(0,o.equals)(H.relatedInformation,Ee.relatedInformation,le.isEqual)}};e.Diagnostic=ue=Ve([F],ue);let O=e.Hover=class{constructor(H,Ee){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=Ee}};e.Hover=O=Ve([F],O);var j;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(j||(e.DocumentHighlightKind=j={}));let Y=e.DocumentHighlight=class{constructor(H,Ee=j.Text){this.range=H,this.kind=Ee}toJSON(){return{range:this.range,kind:j[this.kind]}}};e.DocumentHighlight=Y=Ve([F],Y);var te;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var be;(function(G){G[G.Deprecated=1]="Deprecated"})(be||(e.SymbolTag=be={}));let ye=e.SymbolInformation=m=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,Ee,Te,Ge,Ze){this.name=H,this.kind=Ee,this.containerName=Ze,typeof Te=="string"&&(this.containerName=Te),Ge instanceof ce?this.location=Ge:Te instanceof ie&&(this.location=new ce(Ge,Te)),m.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=ye=m=Ve([F],ye);let me=e.DocumentSymbol=f=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(f.validate)}constructor(H,Ee,Te,Ge,Ze){this.name=H,this.detail=Ee,this.kind=Te,this.range=Ge,this.selectionRange=Ze,this.children=[],f.validate(this)}};e.DocumentSymbol=me=f=Ve([F],me);var ke;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(ke||(e.CodeActionTriggerKind=ke={}));let Pe=e.CodeAction=class{constructor(H,Ee){this.title=H,this.kind=Ee}};e.CodeAction=Pe=Ve([F],Pe);let Be=e.CodeActionKind=n=class{constructor(H){this.value=H}append(H){return new n(this.value?this.value+n.sep+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+n.sep)}};Be.sep=".",e.CodeActionKind=Be=n=Ve([F],Be),Be.Empty=new Be(""),Be.QuickFix=Be.Empty.append("quickfix"),Be.Refactor=Be.Empty.append("refactor"),Be.RefactorExtract=Be.Refactor.append("extract"),Be.RefactorInline=Be.Refactor.append("inline"),Be.RefactorMove=Be.Refactor.append("move"),Be.RefactorRewrite=Be.Refactor.append("rewrite"),Be.Source=Be.Empty.append("source"),Be.SourceOrganizeImports=Be.Source.append("organizeImports"),Be.SourceFixAll=Be.Source.append("fixAll");let $e=e.SelectionRange=class{constructor(H,Ee){if(this.range=H,this.parent=Ee,Ee&&!Ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=$e=Ve([F],$e);class et{constructor(H,Ee,Te,Ge,Ze,ut){this.kind=H,this.name=Ee,this.detail=Te,this.uri=Ge,this.range=Ze,this.selectionRange=ut}}e.CallHierarchyItem=et;class Qe{constructor(H,Ee){this.fromRanges=Ee,this.from=H}}e.CallHierarchyIncomingCall=Qe;class Ye{constructor(H,Ee){this.fromRanges=Ee,this.to=H}}e.CallHierarchyOutgoingCall=Ye;var nt;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(nt||(e.LanguageStatusSeverity=nt={}));let ct=e.CodeLens=class{constructor(H,Ee){this.range=H,this.command=Ee}get isResolved(){return!!this.command}};e.CodeLens=ct=Ve([F],ct);let Fe=e.MarkdownString=D=class{static isMarkdownString(H){return H instanceof D?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,Ee=!1){i.set(this,void 0),Je(this,i,new l.MarkdownString(H,{supportThemeIcons:Ee}),"f")}get value(){return xe(this,i,"f").value}set value(H){xe(this,i,"f").value=H}get isTrusted(){return xe(this,i,"f").isTrusted}set isTrusted(H){xe(this,i,"f").isTrusted=H}get supportThemeIcons(){return xe(this,i,"f").supportThemeIcons}set supportThemeIcons(H){xe(this,i,"f").supportThemeIcons=H}get supportHtml(){return xe(this,i,"f").supportHtml}set supportHtml(H){xe(this,i,"f").supportHtml=H}get baseUri(){return xe(this,i,"f").baseUri}set baseUri(H){xe(this,i,"f").baseUri=H}appendText(H){return xe(this,i,"f").appendText(H),this}appendMarkdown(H){return xe(this,i,"f").appendMarkdown(H),this}appendCodeblock(H,Ee){return xe(this,i,"f").appendCodeblock(Ee??"",H),this}};i=new WeakMap,e.MarkdownString=Fe=D=Ve([F],Fe);let it=e.ParameterInformation=class{constructor(H,Ee){this.label=H,this.documentation=Ee}};e.ParameterInformation=it=Ve([F],it);let z=e.SignatureInformation=class{constructor(H,Ee){this.label=H,this.documentation=Ee,this.parameters=[]}};e.SignatureInformation=z=Ve([F],z);let K=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=K=Ve([F],K);var ge;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ge||(e.SignatureHelpTriggerKind=ge={}));var Ae;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(Ae||(e.InlayHintKind=Ae={}));let Me=e.InlayHintLabelPart=class{constructor(H){this.value=H}};e.InlayHintLabelPart=Me=Ve([F],Me);let qe=e.InlayHint=class{constructor(H,Ee,Te){this.position=H,this.label=Ee,this.kind=Te}};e.InlayHint=qe=Ve([F],qe);var He;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He||(e.CompletionTriggerKind=He={}));var tt;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(tt||(e.CompletionItemKind=tt={}));var pt;(function(G){G[G.Deprecated=1]="Deprecated"})(pt||(e.CompletionItemTag=pt={}));let at=e.CompletionItem=class{constructor(H,Ee){this.label=H,this.kind=Ee}toJSON(){return{label:this.label,kind:this.kind&&tt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=at=Ve([F],at);let vt=e.CompletionList=class{constructor(H=[],Ee=!1){this.items=H,this.isIncomplete=Ee}};e.CompletionList=vt=Ve([F],vt);let yt=e.InlineSuggestion=class{constructor(H,Ee,Te){this.insertText=H,this.range=Ee,this.command=Te}};e.InlineSuggestion=yt=Ve([F],yt);let _t=e.InlineSuggestionList=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.InlineSuggestionList=_t=Ve([F],_t);var Tt;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Tt||(e.ViewColumn=Tt={}));var xt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(xt||(e.StatusBarAlignment=xt={}));var jt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(jt||(e.TextEditorLineNumbersStyle=jt={}));var Ht;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Ht||(e.TextDocumentSaveReason=Ht={}));var At;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(At||(e.TextEditorRevealType=At={}));var lt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(lt||(e.TextEditorSelectionChangeKind=lt={}));var bt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(bt||(e.TextDocumentChangeReason=bt={}));var Wt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Wt||(e.DecorationRangeBehavior=Wt={})),function(G){function H(Ee){switch(Ee){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(lt||(e.TextEditorSelectionChangeKind=lt={}));let Ut=e.DocumentLink=class{constructor(H,Ee){if(Ee&&!g.URI.isUri(Ee))throw(0,A.illegalArgument)("target");if(!ie.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.target=Ee}};e.DocumentLink=Ut=Ve([F],Ut);let kt=e.Color=class{constructor(H,Ee,Te,Ge){this.red=H,this.green=Ee,this.blue=Te,this.alpha=Ge}};e.Color=kt=Ve([F],kt);let ft=e.ColorInformation=class{constructor(H,Ee){if(Ee&&!(Ee instanceof kt))throw(0,A.illegalArgument)("color");if(!ie.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.color=Ee}};e.ColorInformation=ft=Ve([F],ft);let Pt=e.ColorPresentation=class{constructor(H){if(!H||typeof H!="string")throw(0,A.illegalArgument)("label");this.label=H}};e.ColorPresentation=Pt=Ve([F],Pt);var Ft;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Ft||(e.ColorFormat=Ft={}));var Rt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Rt||(e.SourceControlInputBoxValidationType=Rt={}));var Ke;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Ke||(e.TerminalExitReason=Ke={}));class Re{constructor(H,Ee,Te){if(this.startIndex=H,this.length=Ee,this.tooltip=Te,typeof H!="number"||H<0)throw(0,A.illegalArgument)("startIndex");if(typeof Ee!="number"||Ee<1)throw(0,A.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Le{constructor(H){this.uri=H}}e.TerminalQuickFixOpener=Le;class Ce{constructor(H){this.terminalCommand=H}}e.TerminalQuickFixCommand=Ce;var se;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(se||(e.TerminalLocation=se={}));class Oe{constructor(H){if(this.options=H,typeof H!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Oe;var We;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(We||(e.TaskRevealKind=We={}));var Xe;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Xe||(e.TaskPanelKind=Xe={}));let je=e.TaskGroup=M=class{static from(H){switch(H){case"clean":return M.Clean;case"build":return M.Build;case"rebuild":return M.Rebuild;case"test":return M.Test;default:return}}constructor(H,Ee){if(this.label=Ee,typeof H!="string"||typeof Ee!="string")throw(0,A.illegalArgument)("name");this._id=H}get id(){return this._id}};je.Clean=new M("clean","Clean"),je.Build=new M("build","Build"),je.Rebuild=new M("rebuild","Rebuild"),je.Test=new M("test","Test"),e.TaskGroup=je=M=Ve([F],je);function rt(G){let H="";for(let Ee=0;Ee<G.length;Ee++)H+=G[Ee].replace(/,/g,",,")+",";return H}let St=e.ProcessExecution=class{constructor(H,Ee,Te){if(typeof H!="string")throw(0,A.illegalArgument)("process");this._args=[],this._process=H,Ee!==void 0&&(Array.isArray(Ee)?(this._args=Ee,this._options=Te):this._options=Ee)}get process(){return this._process}set process(H){if(typeof H!="string")throw(0,A.illegalArgument)("process");this._process=H}get args(){return this._args}set args(H){Array.isArray(H)||(H=[]),this._args=H}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("process"),this._process!==void 0&&H.push(this._process),this._args&&this._args.length>0)for(const Ee of this._args)H.push(Ee);return rt(H)}};e.ProcessExecution=St=Ve([F],St);let Et=e.ShellExecution=class{constructor(H,Ee,Te){if(this._args=[],Array.isArray(Ee)){if(!H)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this._command=H,this._args=Ee,this._options=Te}else{if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this._commandLine=H,this._options=Ee}}get commandLine(){return this._commandLine}set commandLine(H){if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this._commandLine=H}get command(){return this._command?this._command:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this._command=H}get args(){return this._args}set args(H){this._args=H||[]}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("shell"),this._commandLine!==void 0&&H.push(this._commandLine),this._command!==void 0&&H.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const Ee of this._args)H.push(typeof Ee=="string"?Ee:Ee.value);return rt(H)}};e.ShellExecution=Et=Ve([F],Et);var ht;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(ht||(e.ShellQuoting=ht={}));var st;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(st||(e.TaskScope=st={}));class dt{constructor(H){this._callback=H}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(H){this._callback=H}get callback(){return this._callback}}e.CustomExecution=dt;let Ot=e.Task=W=class{constructor(H,Ee,Te,Ge,Ze,ut){this.__deprecated=!1,this._definition=this.definition=H;let gt;typeof Ee=="string"?(this._name=this.name=Ee,this._source=this.source=Te,this.execution=Ge,gt=Ze,this.__deprecated=!0):Ee===st.Global||Ee===st.Workspace?(this.target=Ee,this._name=this.name=Te,this._source=this.source=Ge,this.execution=Ze,gt=ut):(this.target=Ee,this._name=this.name=Te,this._source=this.source=Ge,this.execution=Ze,gt=ut),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(H){this.__id=H}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof St?this._definition={type:W.ProcessType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:W.ShellType,id:this._execution.computeId()}:this._execution instanceof dt?this._definition={type:W.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:W.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(H){if(H==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=H}get scope(){return this._scope}set target(H){this.clear(),this._scope=H}get name(){return this._name}set name(H){if(typeof H!="string")throw(0,A.illegalArgument)("name");this.clear(),this._name=H}get execution(){return this._execution}set execution(H){H===null&&(H=void 0),this.clear(),this._execution=H;const Ee=this._definition.type;(W.EmptyType===Ee||W.ProcessType===Ee||W.ShellType===Ee||W.ExtensionCallbackType===Ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(H){if(Array.isArray(H))this.clear(),this._problemMatchers=H,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.clear(),this._isBackground=H}get source(){return this._source}set source(H){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=H}get group(){return this._group}set group(H){H===null&&(H=void 0),this.clear(),this._group=H}get detail(){return this._detail}set detail(H){H===null&&(H=void 0),this._detail=H}get presentationOptions(){return this._presentationOptions}set presentationOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._presentationOptions=H}get runOptions(){return this._runOptions}set runOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._runOptions=H}};Ot.ExtensionCallbackType="customExecution",Ot.ProcessType="process",Ot.ShellType="shell",Ot.EmptyType="$empty",e.Task=Ot=W=Ve([F],Ot);var Bt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Bt||(e.ProgressLocation=Bt={}));var ai;(function(G){function H(Ee){const Te=Ee;return(0,y.isNumber)(Te.value)?Te.tooltip&&!(0,y.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}G.isViewBadge=H})(ai||(e.ViewBadge=ai={}));let ri=e.TreeItem=$=class{static isTreeItem(H,Ee){const Te=H;if(Te.checkboxState!==void 0){(0,C.checkProposedApiEnabled)(Ee,"treeItemCheckbox");const Ge=(0,y.isNumber)(Te.checkboxState)?Te.checkboxState:(0,y.isObject)(Te.checkboxState)&&(0,y.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ze=!(0,y.isNumber)(Te.checkboxState)&&(0,y.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==It.Checked&&Ge!==It.Unchecked||Ze!==void 0&&!(0,y.isString)(Ze))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(H instanceof $)return!0;if(Te.label!==void 0&&!(0,y.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,y.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,y.isString)(Te.iconPath)&&!g.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,y.isString)(Te.iconPath.id))){const Ge=Te.iconPath;if(!Ge||!(0,y.isString)(Ge.light)&&!g.URI.isUri(Ge.light)&&!(0,y.isString)(Ge.dark)&&!g.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,y.isString)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!g.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,y.isString)(Te.tooltip)&&!(Te.tooltip instanceof Fe)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<ei.None&&Te.collapsibleState>ei.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,y.isString)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(H,Ee=ei.None){this.collapsibleState=Ee,g.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.TreeItem=ri=$=Ve([F],ri);var ei;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(ei||(e.TreeItemCollapsibleState=ei={}));var It;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(It||(e.TreeItemCheckboxState=It={}));let Pi=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H,Ee){this.value=H,this.id=Ee??(0,L.generateUuid)()}};e.DataTransferItem=Pi=Ve([F],Pi);class Yi{constructor(H,Ee,Te,Ge){this.name=H,this.uri=Ee,this._itemId=Te,this._getData=Ge}data(){return this._getData()}}e.DataTransferFile=Yi;let Dt=e.DataTransfer=class{constructor(H){d.add(this),h.set(this,new Map);for(const[Ee,Te]of H??[]){const Ge=xe(this,h,"f").get(xe(this,d,"m",S).call(this,Ee));Ge?Ge.push(Te):xe(this,h,"f").set(xe(this,d,"m",S).call(this,Ee),[Te])}}get(H){return xe(this,h,"f").get(xe(this,d,"m",S).call(this,H))?.[0]}set(H,Ee){xe(this,h,"f").set(xe(this,d,"m",S).call(this,H),[Ee])}forEach(H,Ee){for(const[Te,Ge]of xe(this,h,"f"))for(const Ze of Ge)H.call(Ee,Ze,Te,this)}*[(h=new WeakMap,d=new WeakSet,Symbol.iterator)](){for(const[H,Ee]of xe(this,h,"f"))for(const Te of Ee)yield[H,Te]}};S=function(H){return H.toLowerCase()},e.DataTransfer=Dt=Ve([F],Dt);let gi=e.DocumentDropEdit=class{constructor(H){this.insertText=H}};e.DocumentDropEdit=gi=Ve([F],gi);let pi=e.DocumentPasteEdit=class{constructor(H){this.insertText=H}};e.DocumentPasteEdit=pi=Ve([F],pi);let $t=e.ThemeIcon=class{constructor(H,Ee){this.id=H,this.color=Ee}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.ThemeIcon=$t=Ve([F],$t),$t.File=new $t("file"),$t.Folder=new $t("folder");let Ti=e.ThemeColor=class{constructor(H){this.id=H}};e.ThemeColor=Ti=Ve([F],Ti);var Ai;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Ai||(e.ConfigurationTarget=Ai={}));let Mt=e.RelativePattern=class{get base(){return this._base}set base(H){this._base=H,this._baseUri=g.URI.file(H)}get baseUri(){return this._baseUri}set baseUri(H){this._baseUri=H,this._base=H.fsPath}constructor(H,Ee){if(typeof H!="string"&&(!H||!g.URI.isUri(H)&&!g.URI.isUri(H.uri)))throw(0,A.illegalArgument)("base");if(typeof Ee!="string")throw(0,A.illegalArgument)("pattern");typeof H=="string"?this.baseUri=g.URI.file(H):g.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=Ee}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Mt=Ve([F],Mt);const vi=new WeakMap;function Ji(G,H){vi.set(G,H)}e.setBreakpointId=Ji;let Kt=e.Breakpoint=class{constructor(H,Ee,Te,Ge){this.enabled=typeof H=="boolean"?H:!0,typeof Ee=="string"&&(this.condition=Ee),typeof Te=="string"&&(this.hitCondition=Te),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=vi.get(this)??(0,L.generateUuid)()),this._id}};e.Breakpoint=Kt=Ve([F],Kt);let si=e.SourceBreakpoint=class extends Kt{constructor(H,Ee,Te,Ge,Ze){if(super(Ee,Te,Ge,Ze),H===null)throw(0,A.illegalArgument)("location");this.location=H}};e.SourceBreakpoint=si=Ve([F],si);let mt=e.FunctionBreakpoint=class extends Kt{constructor(H,Ee,Te,Ge,Ze){super(Ee,Te,Ge,Ze),this.functionName=H}};e.FunctionBreakpoint=mt=Ve([F],mt);let Ri=e.DataBreakpoint=class extends Kt{constructor(H,Ee,Te,Ge,Ze,ut,gt){if(super(Ge,Ze,ut,gt),!Ee)throw(0,A.illegalArgument)("dataId");this.label=H,this.dataId=Ee,this.canPersist=Te}};e.DataBreakpoint=Ri=Ve([F],Ri);let Xt=e.DebugAdapterExecutable=class{constructor(H,Ee,Te){this.command=H,this.args=Ee||[],this.options=Te}};e.DebugAdapterExecutable=Xt=Ve([F],Xt);let ti=e.DebugAdapterServer=class{constructor(H,Ee){this.port=H,this.host=Ee}};e.DebugAdapterServer=ti=Ve([F],ti);let bi=e.DebugAdapterNamedPipeServer=class{constructor(H){this.path=H}};e.DebugAdapterNamedPipeServer=bi=Ve([F],bi);let Li=e.DebugAdapterInlineImplementation=class{constructor(H){this.implementation=H}};e.DebugAdapterInlineImplementation=Li=Ve([F],Li);let Oi=e.EvaluatableExpression=class{constructor(H,Ee){this.range=H,this.expression=Ee}};e.EvaluatableExpression=Oi=Ve([F],Oi);var Ei;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Ei||(e.InlineCompletionTriggerKind=Ei={}));let Fi=e.InlineValueText=class{constructor(H,Ee){this.range=H,this.text=Ee}};e.InlineValueText=Fi=Ve([F],Fi);let wi=e.InlineValueVariableLookup=class{constructor(H,Ee,Te=!0){this.range=H,this.variableName=Ee,this.caseSensitiveLookup=Te}};e.InlineValueVariableLookup=wi=Ve([F],wi);let ii=e.InlineValueEvaluatableExpression=class{constructor(H,Ee){this.range=H,this.expression=Ee}};e.InlineValueEvaluatableExpression=ii=Ve([F],ii);let Mi=e.InlineValueContext=class{constructor(H,Ee){this.frameId=H,this.stoppedLocation=Ee}};e.InlineValueContext=Mi=Ve([F],Mi);var ci;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(ci||(e.FileChangeType=ci={}));let li=e.FileSystemError=N=class extends Error{static FileExists(H){return new N(H,I.FileSystemProviderErrorCode.FileExists,N.FileExists)}static FileNotFound(H){return new N(H,I.FileSystemProviderErrorCode.FileNotFound,N.FileNotFound)}static FileNotADirectory(H){return new N(H,I.FileSystemProviderErrorCode.FileNotADirectory,N.FileNotADirectory)}static FileIsADirectory(H){return new N(H,I.FileSystemProviderErrorCode.FileIsADirectory,N.FileIsADirectory)}static NoPermissions(H){return new N(H,I.FileSystemProviderErrorCode.NoPermissions,N.NoPermissions)}static Unavailable(H){return new N(H,I.FileSystemProviderErrorCode.Unavailable,N.Unavailable)}constructor(H,Ee=I.FileSystemProviderErrorCode.Unknown,Te){super(g.URI.isUri(H)?H.toString(!0):H),this.code=Te?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,Ee),Object.setPrototypeOf(this,N.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};e.FileSystemError=li=N=Ve([F],li);let Ni=e.FoldingRange=class{constructor(H,Ee,Te){this.start=H,this.end=Ee,this.kind=Te}};e.FoldingRange=Ni=Ve([F],Ni);var xi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(xi||(e.FoldingRangeKind=xi={}));var ni;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(ni||(e.CommentThreadCollapsibleState=ni={}));var Ui;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var Bi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Bi||(e.CommentState=Bi={}));var zi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(zi||(e.CommentThreadState=zi={}));class ui{constructor(H,Ee=[]){this.tokenTypes=H,this.tokenModifiers=Ee}}e.SemanticTokensLegend=ui;function Zi(G){return typeof G>"u"||(0,y.isStringArray)(G)}class _i{constructor(H){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,H){this._hasLegend=!0;for(let Ee=0,Te=H.tokenTypes.length;Ee<Te;Ee++)this._tokenTypeStrToInt.set(H.tokenTypes[Ee],Ee);for(let Ee=0,Te=H.tokenModifiers.length;Ee<Te;Ee++)this._tokenModifierStrToInt.set(H.tokenModifiers[Ee],Ee)}}push(H,Ee,Te,Ge,Ze){if(typeof H=="number"&&typeof Ee=="number"&&typeof Te=="number"&&typeof Ge=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this._pushEncoded(H,Ee,Te,Ge,Ze);if(ie.isRange(H)&&typeof Ee=="string"&&Zi(Te))return this._push(H,Ee,Te);throw(0,A.illegalArgument)()}_push(H,Ee,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Ee))throw new Error("`tokenType` is not in the provided legend");const Ge=H.start.line,Ze=H.start.character,ut=H.end.character-H.start.character,gt=this._tokenTypeStrToInt.get(Ee);let zt=0;if(Te)for(const Vt of Te){if(!this._tokenModifierStrToInt.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this._tokenModifierStrToInt.get(Vt);zt|=1<<Gt>>>0}this._pushEncoded(Ge,Ze,ut,gt,zt)}_pushEncoded(H,Ee,Te,Ge,Ze){if(this._dataIsSortedAndDeltaEncoded&&(H<this._prevLine||H===this._prevLine&&Ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const zt=this._data.length/5|0;let Vt=0,Gt=0;for(let Yt=0;Yt<zt;Yt++){let Jt=this._data[5*Yt],Ii=this._data[5*Yt+1];Jt===0?(Jt=Vt,Ii+=Gt):Jt+=Vt,this._data[5*Yt]=Jt,this._data[5*Yt+1]=Ii,Vt=Jt,Gt=Ii}}let ut=H,gt=Ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Ze,this._prevLine=H,this._prevChar=Ee}static _sortAndDeltaEncode(H){const Ee=[],Te=H.length/5|0;for(let gt=0;gt<Te;gt++)Ee[gt]=gt;Ee.sort((gt,zt)=>{const Vt=H[5*gt],Gt=H[5*zt];if(Vt===Gt){const Yt=H[5*gt+1],Jt=H[5*zt+1];return Yt-Jt}return Vt-Gt});const Ge=new Uint32Array(H.length);let Ze=0,ut=0;for(let gt=0;gt<Te;gt++){const zt=5*Ee[gt],Vt=H[zt+0],Gt=H[zt+1],Yt=H[zt+2],Jt=H[zt+3],Ii=H[zt+4],Sn=Vt-Ze,xn=Sn===0?Gt-ut:Gt,ki=5*gt;Ge[ki+0]=Sn,Ge[ki+1]=xn,Ge[ki+2]=Yt,Ge[ki+3]=Jt,Ge[ki+4]=Ii,Ze=Vt,ut=Gt}return Ge}build(H){return this._dataIsSortedAndDeltaEncoded?new Si(new Uint32Array(this._data),H):new Si(_i._sortAndDeltaEncode(this._data),H)}}e.SemanticTokensBuilder=_i;class Si{constructor(H,Ee){this.resultId=Ee,this.data=H}}e.SemanticTokens=Si;class en{constructor(H,Ee,Te){this.start=H,this.deleteCount=Ee,this.data=Te}}e.SemanticTokensEdit=en;class tn{constructor(H,Ee){this.resultId=Ee,this.edits=H}}e.SemanticTokensEdits=tn;var di;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(di||(e.DebugConsoleMode=di={}));let hi=e.QuickInputButtons=class{constructor(){}};hi.Back={iconPath:new $t("arrow-left")},e.QuickInputButtons=hi=Ve([F],hi);var yi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(yi||(e.QuickPickItemKind=yi={}));var Ue;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Ue||(e.InputBoxValidationSeverity=Ue={}));var qt;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(qt||(e.ExtensionKind=qt={}));class Wi{static validate(H){if(typeof H.badge=="string"){let Ee=(0,P.nextCharLength)(H.badge,0);if(Ee<H.badge.length&&(Ee+=(0,P.nextCharLength)(H.badge,Ee)),H.badge.length>Ee)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!$t.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,Ee,Te){this.badge=H,this.tooltip=Ee,this.color=Te}}e.FileDecoration=Wi;let wt=e.ColorTheme=class{constructor(H){this.kind=H}};e.ColorTheme=wt=Ve([F],wt);var Hi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Hi||(e.ColorThemeKind=Hi={}));class Qt{static isNotebookRange(H){return H instanceof Qt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(H,Ee){if(H<0)throw(0,A.illegalArgument)("start must be positive");if(Ee<0)throw(0,A.illegalArgument)("end must be positive");H<=Ee?(this._start=H,this._end=Ee):(this._start=Ee,this._end=H)}with(H){let Ee=this._start,Te=this._end;return H.start!==void 0&&(Ee=H.start),H.end!==void 0&&(Te=H.end),Ee===this._start&&Te===this._end?this:new Qt(Ee,Te)}}e.NotebookRange=Qt;class oi{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(Ee=>oi.isNotebookCellData(Ee))}static isNotebookCellData(H){return!0}constructor(H,Ee,Te,Ge,Ze,ut,gt){this.kind=H,this.value=Ee,this.languageId=Te,this.mime=Ge,this.outputs=Ze??[],this.metadata=ut,this.executionSummary=gt,oi.validate(this)}}e.NotebookCellData=oi;class nn{constructor(H){this.cells=H}}e.NotebookData=nn;class Nt{static isNotebookCellOutputItem(H){return H instanceof Nt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const Ee={name:H.name,message:H.message,stack:H.stack};return Nt.json(Ee,"application/vnd.code.notebook.error")}static stdout(H){return Nt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return Nt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,Ee="application/octet-stream"){return new Nt(H,Ee)}static text(H,Ee=T.Mimes.text){const Te=xe(Nt,E,"f",p).encode(String(H));return new Nt(Te,Ee)}static json(H,Ee="text/x-json"){const Te=JSON.stringify(H,void 0,"	");return Nt.text(Te,Ee)}constructor(H,Ee){this.data=H,this.mime=Ee;const Te=(0,T.normalizeMimeType)(Ee,!0);if(!Te)throw new Error(`INVALID mime type: ${Ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=Nt,E=Nt,p={value:new TextEncoder};class fi{static isNotebookCellOutput(H){return H instanceof fi?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,Ee=!1){const Te=new Set,Ge=new Set;for(let Ze=0;Ze<H.length;Ze++){const ut=H[Ze],gt=(0,T.normalizeMimeType)(ut.mime);if(!Te.has(gt)||(0,k.isTextStreamMime)(gt)){Te.add(gt);continue}Ge.add(Ze),Ee&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ge.size===0?H:H.filter((Ze,ut)=>!Ge.has(ut))}constructor(H,Ee,Te){this.items=fi.ensureUniqueMimeTypes(H,!0),typeof Ee=="string"?(this.id=Ee,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=Ee??Te)}}e.NotebookCellOutput=fi;var $i;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})($i||(e.NotebookCellKind=$i={}));var Vi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(Vi||(e.NotebookCellExecutionState=Vi={}));var Ci;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Ci||(e.NotebookCellStatusBarAlignment=Ci={}));var ji;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(ji||(e.NotebookEditorRevealType=ji={}));class rn{constructor(H,Ee){this.text=H,this.alignment=Ee}}e.NotebookCellStatusBarItem=rn;var qi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(qi||(e.NotebookControllerAffinity=qi={}));var Gi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(Gi||(e.NotebookControllerAffinity2=Gi={}));class sn{constructor(H,Ee=[]){this.uri=H,this.provides=(0,o.asArray)(Ee)}}e.NotebookRendererScript=sn;class on{constructor(H){this.label=H}}e.NotebookKernelSourceAction=on;let Ki=e.TimelineItem=class{constructor(H,Ee){this.label=H,this.timestamp=Ee}};e.TimelineItem=Ki=Ve([F],Ki);var Xi;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(Xi||(e.ExtensionMode=Xi={}));var ve;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ve||(e.ExtensionRuntime=ve={}));var Se;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Se||(e.StandardTokenType=Se={}));class Ne{constructor(H,Ee){this.ranges=H,this.wordPattern=Ee}}e.LinkedEditingRanges=Ne;class ot{constructor(H,Ee){this._port=H,this._autoForwardAction=Ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ot;var Ct;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(Ct||(e.TestResultState=Ct={}));var Lt;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(Lt||(e.TestRunProfileKind=Lt={}));let an=e.TestRunRequest=class{constructor(H=void 0,Ee=void 0,Te=void 0,Ge=!1){this.include=H,this.exclude=Ee,this.profile=Te,this.continuous=Ge}};e.TestRunRequest=an=Ve([F],an);let ln=e.TestRunRequest2=class extends an{};e.TestRunRequest2=ln=Ve([F],ln);let un=e.TestMessage=U=class{static diff(H,Ee,Te){const Ge=new U(H);return Ge.expectedOutput=Ee,Ge.actualOutput=Te,Ge}constructor(H){this.message=H}};e.TestMessage=un=U=Ve([F],un);let dn=e.TestTag=class{constructor(H){this.id=H}};e.TestTag=dn=Ve([F],dn);let Di=e.CoveredCount=class{constructor(H,Ee){this.covered=H,this.total=Ee}};e.CoveredCount=Di=Ve([F],Di);let hn=e.FileCoverage=q=class{static fromDetails(H,Ee){const Te=new Di(0,0),Ge=new Di(0,0),Ze=new Di(0,0);for(const gt of Ee)if("branches"in gt){Te.total+=1,Te.covered+=gt.executionCount>0?1:0;for(const zt of gt.branches)Ge.total+=1,Ge.covered+=zt.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=gt.executionCount>0?1:0;const ut=new q(H,Te,Ge.total>0?Ge:void 0,Ze.total>0?Ze:void 0);return ut.detailedCoverage=Ee,ut}constructor(H,Ee,Te,Ge){this.uri=H,this.statementCoverage=Ee,this.branchCoverage=Te,this.functionCoverage=Ge}};e.FileCoverage=hn=q=Ve([F],hn);let fn=e.StatementCoverage=class{constructor(H,Ee,Te=[]){this.executionCount=H,this.location=Ee,this.branches=Te}};e.StatementCoverage=fn=Ve([F],fn);let mn=e.BranchCoverage=class{constructor(H,Ee){this.executionCount=H,this.location=Ee}};e.BranchCoverage=mn=Ve([F],mn);let gn=e.FunctionCoverage=class{constructor(H,Ee){this.executionCount=H,this.location=Ee}};e.FunctionCoverage=gn=Ve([F],gn);var pn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(pn||(e.ExternalUriOpenerPriority=pn={}));var vn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(vn||(e.WorkspaceTrustState=vn={}));var bn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(bn||(e.PortAutoForwardAction=bn={}));class kn{constructor(H,Ee,Te,Ge,Ze,ut){this.kind=H,this.name=Ee,this.detail=Te,this.uri=Ge,this.range=Ze,this.selectionRange=ut}}e.TypeHierarchyItem=kn;class Pn{constructor(H){this.uri=H}}e.TextTabInput=Pn;class Tn{constructor(H,Ee){this.original=H,this.modified=Ee}}e.TextDiffTabInput=Tn;class An{constructor(H,Ee,Te,Ge){this.base=H,this.input1=Ee,this.input2=Te,this.result=Ge}}e.TextMergeTabInput=An;class Rn{constructor(H,Ee){this.uri=H,this.viewType=Ee}}e.CustomEditorTabInput=Rn;class Ln{constructor(H){this.viewType=H}}e.WebviewEditorTabInput=Ln;class On{constructor(H,Ee){this.uri=H,this.notebookType=Ee}}e.NotebookEditorTabInput=On;class Fn{constructor(H,Ee,Te){this.original=H,this.modified=Ee,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Fn;class Mn{constructor(){}}e.TerminalEditorTabInput=Mn;class Nn{constructor(H,Ee){this.uri=H,this.inputBoxUri=Ee}}e.InteractiveWindowInput=Nn;var En;(function(G){G[G.Up=1]="Up",G[G.Down=2]="Down"})(En||(e.InteractiveSessionVoteDirection=En={}));var wn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var _n;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone"})(_n||(e.InteractiveEditorResponseFeedbackKind=_n={}))}),define(De[136],Ie([1,0,51,16,9,168,107,7,18]),function(oe,e,o,A,l,R,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const g=new Map;function L(C,b){b?g.set(C,b):g.delete(C)}e.setWordDefinitionFor=L;function I(C){return g.get(C)}class w extends R.MirrorTextModel{constructor(b,i,d,h,S,E,p,t){super(i,d,h,S),this._proxy=b,this._languageId=E,this._isDirty=p,this.notebook=t,this._isDisposed=!1}dispose(){(0,o.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(b){return(0,y.equals)(this._lines,b)}get document(){if(!this._document){const b=this;this._document={get uri(){return b._uri},get fileName(){return b._uri.fsPath},get isUntitled(){return b._uri.scheme===A.Schemas.untitled},get languageId(){return b._languageId},get version(){return b._versionId},get isClosed(){return b._isDisposed},get isDirty(){return b._isDirty},save(){return b._save()},getText(i){return i?b._getTextInRange(i):b.getText()},get eol(){return b._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return b._lines.length},lineAt(i){return b._lineAt(i)},offsetAt(i){return b._offsetAt(i)},positionAt(i){return b._positionAt(i)},validateRange(i){return b._validateRange(i)},validatePosition(i){return b._validatePosition(i)},getWordRangeAtPosition(i,d){return b._getWordRangeAtPosition(i,d)}}}return Object.freeze(this._document)}_acceptLanguageId(b){(0,o.ok)(!this._isDisposed),this._languageId=b}_acceptIsDirty(b){(0,o.ok)(!this._isDisposed),this._isDirty=b}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(b){const i=this._validateRange(b);if(i.isEmpty)return"";if(i.isSingleLine)return this._lines[i.start.line].substring(i.start.character,i.end.character);const d=this._eol,h=i.start.line,S=i.end.line,E=[];E.push(this._lines[h].substring(i.start.character));for(let p=h+1;p<S;p++)E.push(this._lines[p]);return E.push(this._lines[S].substring(0,i.end.character)),E.join(d)}_lineAt(b){let i;if(b instanceof P.Position?i=b.line:typeof b=="number"&&(i=b),typeof i!="number"||i<0||i>=this._lines.length||Math.floor(i)!==i)throw new Error("Illegal value for `line`");return new k(i,this._lines[i],i===this._lines.length-1)}_offsetAt(b){return b=this._validatePosition(b),this._ensureLineStarts(),this._lineStarts.getPrefixSum(b.line-1)+b.character}_positionAt(b){b=Math.floor(b),b=Math.max(0,b),this._ensureLineStarts();const i=this._lineStarts.getIndexOf(b),d=this._lines[i.index].length;return new P.Position(i.index,Math.min(i.remainder,d))}_validateRange(b){if(!(b instanceof P.Range))throw new Error("Invalid argument");const i=this._validatePosition(b.start),d=this._validatePosition(b.end);return i===b.start&&d===b.end?b:new P.Range(i.line,i.character,d.line,d.character)}_validatePosition(b){if(!(b instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return b.with(0,0);let{line:i,character:d}=b,h=!1;if(i<0)i=0,d=0,h=!0;else if(i>=this._lines.length)i=this._lines.length-1,d=this._lines[i].length,h=!0;else{const S=this._lines[i].length;d<0?(d=0,h=!0):d>S&&(d=S,h=!0)}return h?new P.Position(i,d):b}_getWordRangeAtPosition(b,i){const d=this._validatePosition(b);if(!i)i=I(this._languageId);else if((0,l.regExpLeadsToEndlessLoop)(i))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${i.source}' because it matches the empty string.`);const h=(0,T.getWordAtText)(d.character+1,(0,T.ensureValidWordDefinition)(i),this._lines[d.line],0);if(h)return new P.Range(d.line,h.startColumn-1,d.line,h.endColumn-1)}}e.ExtHostDocumentData=w;class k{constructor(b,i,d){this._line=b,this._text=i,this._isLastLine=d}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=k}),define(De[249],Ie([1,0,7,20,3]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=e.ExtHostTheming=class{constructor(P){this._actual=new o.ColorTheme(o.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new l.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let y;switch(P){case"light":y=o.ColorThemeKind.Light;break;case"hcDark":y=o.ColorThemeKind.HighContrast;break;case"hcLight":y=o.ColorThemeKind.HighContrastLight;break;default:y=o.ColorThemeKind.Dark}this._actual=new o.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=R=Ve([ze(0,A.IExtHostRpcService)],R)}),define(De[11],Ie([1,0,18,22,151,65,113,28,149,71,89,23,10,2,32,73,123,133,130,94,59,77,245,7]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h,S,E,p,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveSessionFollowup=e.InteractiveSessionReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Re){function Le(se){const{selectionStartLineNumber:Oe,selectionStartColumn:We,positionLineNumber:Xe,positionColumn:je}=se,rt=new s.Position(Oe-1,We-1),St=new s.Position(Xe-1,je-1);return new s.Selection(rt,St)}Re.to=Le;function Ce(se){const{anchor:Oe,active:We}=se;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Re.from=Ce})(r||(e.Selection=r={}));var a;(function(Re){function Le(se){if(!se)return;const{start:Oe,end:We}=se;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Re.from=Le;function Ce(se){if(!se)return;const{startLineNumber:Oe,startColumn:We,endLineNumber:Xe,endColumn:je}=se;return new s.Range(Oe-1,We-1,Xe-1,je-1)}Re.to=Ce})(a||(e.Range=a={}));var v;(function(Re){function Le(Ce){switch(Ce){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Re.to=Le})(v||(e.TokenType=v={}));var _;(function(Re){function Le(se){return new s.Position(se.lineNumber-1,se.column-1)}Re.to=Le;function Ce(se){return{lineNumber:se.line+1,column:se.character+1}}Re.from=Ce})(_||(e.Position=_={}));var c;(function(Re){function Le(Oe,We,Xe){return(0,o.coalesce)((0,o.asArray)(Oe).map(je=>Ce(je,We,Xe)))}Re.from=Le;function Ce(Oe,We,Xe){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:Xe?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:se(Oe.scheme,We),pattern:K.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:Xe?.isBuiltin}}function se(Oe,We){return We&&typeof Oe=="string"?We.transformOutgoingScheme(Oe):Oe}})(c||(e.DocumentSelector=c={}));var u;(function(Re){function Le(se){switch(se){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Re.from=Le;function Ce(se){switch(se){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Re.to=Ce})(u||(e.DiagnosticTag=u={}));var m;(function(Re){function Le(se){let Oe;return se.code&&((0,w.isString)(se.code)||(0,w.isNumber)(se.code)?Oe=String(se.code):Oe={value:String(se.code.value),target:se.code.target}),{...a.from(se.range),message:se.message,source:se.source,code:Oe,severity:n.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(f.from),tags:Array.isArray(se.tags)?(0,o.coalesce)(se.tags.map(u.from)):void 0}}Re.from=Le;function Ce(se){const Oe=new s.Diagnostic(a.to(se),se.message,n.to(se.severity));return Oe.source=se.source,Oe.code=(0,w.isString)(se.code)?se.code:se.code?.value,Oe.relatedInformation=se.relatedInformation&&se.relatedInformation.map(f.to),Oe.tags=se.tags&&(0,o.coalesce)(se.tags.map(u.to)),Oe}Re.to=Ce})(m||(e.Diagnostic=m={}));var f;(function(Re){function Le(se){return{...a.from(se.location.range),message:se.message,resource:se.location.uri}}Re.from=Le;function Ce(se){return new s.DiagnosticRelatedInformation(new s.Location(se.resource,a.to(se)),se.message)}Re.to=Ce})(f||(e.DiagnosticRelatedInformation=f={}));var n;(function(Re){function Le(se){switch(se){case s.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Re.from=Le;function Ce(se){switch(se){case i.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Re.to=Ce})(n||(e.DiagnosticSeverity=n={}));var D;(function(Re){function Le(se){return typeof se=="number"&&se>=s.ViewColumn.One?se-1:se===s.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Re.from=Le;function Ce(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Ce})(D||(e.ViewColumn=D={}));function M(Re){return typeof Re.range<"u"}function W(Re){return Re.length===0?!0:!!M(Re[0])}e.isDecorationOptionsArr=W;var $;(function(Re){function Le(je){return je.map(Re.from)}Re.fromMany=Le;function Ce(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function se(je){let rt;if(Ce(je)){const{language:st,value:dt}=je;rt={value:"```"+st+`
`+dt+"\n```\n"}}else s.MarkdownString.isMarkdownString(je)?rt={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?rt={value:je}:rt={value:""};const St=Object.create(null);rt.uris=St;const Et=st=>{try{let dt=k.URI.parse(st,!0);dt=dt.with({query:Oe(dt.query,St)}),St[st]=dt}catch{}return""},ht=new y.marked.Renderer;return ht.link=Et,ht.image=st=>typeof st=="string"?Et(T.parseHrefAndDimensions(st).href):"",(0,y.marked)(rt.value,{renderer:ht}),rt}Re.from=se;function Oe(je,rt){if(!je)return je;let St;try{St=(0,g.parse)(je)}catch{}if(!St)return je;let Et=!1;return St=(0,I.cloneAndChange)(St,ht=>{if(k.URI.isUri(ht)){const st=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[st]=ht,Et=!0,st}else return}),Et?JSON.stringify(St):je}function We(je){const rt=new s.MarkdownString(je.value,je.supportThemeIcons);return rt.isTrusted=je.isTrusted,rt.supportHtml=je.supportHtml,rt.baseUri=je.baseUri?k.URI.from(je.baseUri):void 0,rt}Re.to=We;function Xe(je){if(je)return typeof je=="string"?je:Re.from(je)}Re.fromStrict=Xe})($||(e.MarkdownString=$={}));function N(Re){return W(Re)?Re.map(Le=>({range:a.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?$.fromMany(Le.hoverMessage):Le.hoverMessage?$.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Re.map(Le=>({range:a.from(Le)}))}e.fromRangeOrRangeWithMessage=N;function U(Re){return typeof Re>"u"?Re:typeof Re=="string"?k.URI.file(Re):Re}e.pathOrURIToURI=U;var q;(function(Re){function Le(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?U(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Re.from=Le})(q||(e.ThemableDecorationAttachmentRenderOptions=q={}));var F;(function(Re){function Le(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?U(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?q.from(Ce.before):void 0,after:Ce.after?q.from(Ce.after):void 0}}Re.from=Le})(F||(e.ThemableDecorationRenderOptions=F={}));var B;(function(Re){function Le(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Le})(B||(e.DecorationRangeBehavior=B={}));var Q;(function(Re){function Le(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?B.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?F.from(Ce.light):void 0,dark:Ce.dark?F.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?U(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?q.from(Ce.before):void 0,after:Ce.after?q.from(Ce.after):void 0}}Re.from=Le})(Q||(e.DecorationRenderOptions=Q={}));var J;(function(Re){function Le(se){return{text:se.newText,eol:se.newEol&&nt.from(se.newEol),range:a.from(se.range)}}Re.from=Le;function Ce(se){const Oe=new s.TextEdit(a.to(se.range),se.text);return Oe.newEol=typeof se.eol>"u"?void 0:nt.to(se.eol),Oe}Re.to=Ce})(J||(e.TextEdit=J={}));var X;(function(Re){function Le(se,Oe){const We={edits:[]};if(se instanceof s.WorkspaceEdit){const Xe=new P.ResourceSet;for(const je of se._allEntries())je._type===1&&k.URI.isUri(je.to)&&je.from===void 0&&Xe.add(je.to);for(const je of se._allEntries())if(je._type===1){let rt;je.options?.contents&&(ArrayBuffer.isView(je.options.contents)?rt={type:"base64",value:(0,A.encodeBase64)(A.VSBuffer.wrap(je.options.contents))}:rt={type:"dataTransferItem",id:je.options.contents._itemId}),We.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contents:rt},metadata:je.metadata})}else je._type===2?We.edits.push({resource:je.uri,textEdit:J.from(je.edit),versionId:Xe.has(je.uri)?void 0:Oe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?We.edits.push({resource:je.uri,textEdit:{range:a.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:Xe.has(je.uri)?void 0:Oe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?We.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(je.uri)}):je._type===5&&We.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(pt.from)}})}return We}Re.from=Le;function Ce(se){const Oe=new s.WorkspaceEdit,We=new P.ResourceMap;for(const Xe of se.edits)if(Xe.textEdit){const je=Xe,rt=k.URI.revive(je.resource),St=a.to(je.textEdit.range),Et=je.textEdit.text,ht=je.textEdit.insertAsSnippet;let st;ht?st=s.SnippetTextEdit.replace(St,new s.SnippetString(Et)):st=s.TextEdit.replace(St,Et);const dt=We.get(rt);dt?dt.push(st):We.set(rt,[st])}else Oe.renameFile(k.URI.revive(Xe.oldResource),k.URI.revive(Xe.newResource),Xe.options);for(const[Xe,je]of We)Oe.set(Xe,je);return Oe}Re.to=Ce})(X||(e.WorkspaceEdit=X={}));var ie;(function(Re){const Le=Object.create(null);Le[s.SymbolKind.File]=0,Le[s.SymbolKind.Module]=1,Le[s.SymbolKind.Namespace]=2,Le[s.SymbolKind.Package]=3,Le[s.SymbolKind.Class]=4,Le[s.SymbolKind.Method]=5,Le[s.SymbolKind.Property]=6,Le[s.SymbolKind.Field]=7,Le[s.SymbolKind.Constructor]=8,Le[s.SymbolKind.Enum]=9,Le[s.SymbolKind.Interface]=10,Le[s.SymbolKind.Function]=11,Le[s.SymbolKind.Variable]=12,Le[s.SymbolKind.Constant]=13,Le[s.SymbolKind.String]=14,Le[s.SymbolKind.Number]=15,Le[s.SymbolKind.Boolean]=16,Le[s.SymbolKind.Array]=17,Le[s.SymbolKind.Object]=18,Le[s.SymbolKind.Key]=19,Le[s.SymbolKind.Null]=20,Le[s.SymbolKind.EnumMember]=21,Le[s.SymbolKind.Struct]=22,Le[s.SymbolKind.Event]=23,Le[s.SymbolKind.Operator]=24,Le[s.SymbolKind.TypeParameter]=25;function Ce(Oe){return typeof Le[Oe]=="number"?Le[Oe]:6}Re.from=Ce;function se(Oe){for(const We in Le)if(Le[We]===Oe)return Number(We);return s.SymbolKind.Property}Re.to=se})(ie||(e.SymbolKind=ie={}));var ae;(function(Re){function Le(se){switch(se){case s.SymbolTag.Deprecated:return 1}}Re.from=Le;function Ce(se){switch(se){case 1:return s.SymbolTag.Deprecated}}Re.to=Ce})(ae||(e.SymbolTag=ae={}));var we;(function(Re){function Le(se){return{name:se.name,kind:ie.from(se.kind),tags:se.tags&&se.tags.map(ae.from),containerName:se.containerName,location:Z.from(se.location)}}Re.from=Le;function Ce(se){const Oe=new s.SymbolInformation(se.name,ie.to(se.kind),se.containerName,Z.to(se.location));return Oe.tags=se.tags&&se.tags.map(ae.to),Oe}Re.to=Ce})(we||(e.WorkspaceSymbol=we={}));var he;(function(Re){function Le(se){const Oe={name:se.name||"!!MISSING: name!!",detail:se.detail,range:a.from(se.range),selectionRange:a.from(se.selectionRange),kind:ie.from(se.kind),tags:se.tags?.map(ae.from)??[]};return se.children&&(Oe.children=se.children.map(Le)),Oe}Re.from=Le;function Ce(se){const Oe=new s.DocumentSymbol(se.name,se.detail,ie.to(se.kind),a.to(se.range),a.to(se.selectionRange));return(0,o.isNonEmptyArray)(se.tags)&&(Oe.tags=se.tags.map(ae.to)),se.children&&(Oe.children=se.children.map(Ce)),Oe}Re.to=Ce})(he||(e.DocumentSymbol=he={}));var fe;(function(Re){function Le(se){const Oe=new s.CallHierarchyItem(ie.to(se.kind),se.name,se.detail||"",k.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Oe._sessionId=se._sessionId,Oe._itemId=se._itemId,Oe}Re.to=Le;function Ce(se,Oe,We){if(Oe=Oe??se._sessionId,We=We??se._itemId,Oe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:We,name:se.name,detail:se.detail,kind:ie.from(se.kind),uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(ae.from)}}Re.from=Ce})(fe||(e.CallHierarchyItem=fe={}));var V;(function(Re){function Le(Ce){return new s.CallHierarchyIncomingCall(fe.to(Ce.from),Ce.fromRanges.map(se=>a.to(se)))}Re.to=Le})(V||(e.CallHierarchyIncomingCall=V={}));var x;(function(Re){function Le(Ce){return new s.CallHierarchyOutgoingCall(fe.to(Ce.to),Ce.fromRanges.map(se=>a.to(se)))}Re.to=Le})(x||(e.CallHierarchyOutgoingCall=x={}));var Z;(function(Re){function Le(se){return{range:se.range&&a.from(se.range),uri:se.uri}}Re.from=Le;function Ce(se){return new s.Location(k.URI.revive(se.uri),a.to(se.range))}Re.to=Ce})(Z||(e.location=Z={}));var pe;(function(Re){function Le(se){const Oe=se,We=se;return{originSelectionRange:Oe.originSelectionRange?a.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:We.uri,range:a.from(Oe.targetRange?Oe.targetRange:We.range),targetSelectionRange:Oe.targetSelectionRange?a.from(Oe.targetSelectionRange):void 0}}Re.from=Le;function Ce(se){return{targetUri:k.URI.revive(se.uri),targetRange:a.to(se.range),targetSelectionRange:se.targetSelectionRange?a.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?a.to(se.originSelectionRange):void 0}}Re.to=Ce})(pe||(e.DefinitionLink=pe={}));var _e;(function(Re){function Le(se){return{range:a.from(se.range),contents:$.fromMany(se.contents)}}Re.from=Le;function Ce(se){return new s.Hover(se.contents.map($.to),a.to(se.range))}Re.to=Ce})(_e||(e.Hover=_e={}));var re;(function(Re){function Le(se){return{range:a.from(se.range),expression:se.expression}}Re.from=Le;function Ce(se){return new s.EvaluatableExpression(a.to(se.range),se.expression)}Re.to=Ce})(re||(e.EvaluatableExpression=re={}));var ne;(function(Re){function Le(se){if(se instanceof s.InlineValueText)return{type:"text",range:a.from(se.range),text:se.text};if(se instanceof s.InlineValueVariableLookup)return{type:"variable",range:a.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Le;function Ce(se){switch(se.type){case"text":return{range:a.to(se.range),text:se.text};case"variable":return{range:a.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:a.to(se.range),expression:se.expression}}}Re.to=Ce})(ne||(e.InlineValue=ne={}));var de;(function(Re){function Le(se){return{frameId:se.frameId,stoppedLocation:a.from(se.stoppedLocation)}}Re.from=Le;function Ce(se){return new s.InlineValueContext(se.frameId,a.to(se.stoppedLocation))}Re.to=Ce})(de||(e.InlineValueContext=de={}));var ee;(function(Re){function Le(se){return{range:a.from(se.range),kind:se.kind}}Re.from=Le;function Ce(se){return new s.DocumentHighlight(a.to(se.range),se.kind)}Re.to=Ce})(ee||(e.DocumentHighlight=ee={}));var ce;(function(Re){function Le(Ce){switch(Ce){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Re.to=Le})(ce||(e.CompletionTriggerKind=ce={}));var le;(function(Re){function Le(Ce){return{triggerKind:ce.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Re.to=Le})(le||(e.CompletionContext=le={}));var ue;(function(Re){function Le(se){switch(se){case s.CompletionItemTag.Deprecated:return 1}}Re.from=Le;function Ce(se){switch(se){case 1:return s.CompletionItemTag.Deprecated}}Re.to=Ce})(ue||(e.CompletionItemTag=ue={}));var O;(function(Re){const Le=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ce(We){return Le.get(We)??9}Re.from=Ce;const se=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Oe(We){return se.get(We)??s.CompletionItemKind.Property}Re.to=Oe})(O||(e.CompletionItemKind=O={}));var j;(function(Re){function Le(Ce,se){const Oe=new s.CompletionItem(Ce.label);return Oe.insertText=Ce.insertText,Oe.kind=O.to(Ce.kind),Oe.tags=Ce.tags?.map(ue.to),Oe.detail=Ce.detail,Oe.documentation=T.isMarkdownString(Ce.documentation)?$.to(Ce.documentation):Ce.documentation,Oe.sortText=Ce.sortText,Oe.filterText=Ce.filterText,Oe.preselect=Ce.preselect,Oe.commitCharacters=Ce.commitCharacters,C.Range.isIRange(Ce.range)?Oe.range=a.to(Ce.range):typeof Ce.range=="object"&&(Oe.range={inserting:a.to(Ce.range.insert),replacing:a.to(Ce.range.replace)}),Oe.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Oe.insertText=new s.SnippetString(Ce.insertText):(Oe.insertText=Ce.insertText,Oe.textEdit=Oe.range instanceof s.Range?new s.TextEdit(Oe.range,Oe.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Ce.additionalTextEdits.map(We=>J.to(We))),Oe.command=se&&Ce.command?se.fromInternal(Ce.command):void 0,Oe}Re.to=Le})(j||(e.CompletionItem=j={}));var Y;(function(Re){function Le(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:$.fromStrict(se.documentation)}}Re.from=Le;function Ce(se){return{label:se.label,documentation:T.isMarkdownString(se.documentation)?$.to(se.documentation):se.documentation}}Re.to=Ce})(Y||(e.ParameterInformation=Y={}));var te;(function(Re){function Le(se){return{label:se.label,documentation:$.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(Y.from):[],activeParameter:se.activeParameter}}Re.from=Le;function Ce(se){return{label:se.label,documentation:T.isMarkdownString(se.documentation)?$.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(Y.to):[],activeParameter:se.activeParameter}}Re.to=Ce})(te||(e.SignatureInformation=te={}));var be;(function(Re){function Le(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(te.from):[]}}Re.from=Le;function Ce(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(te.to):[]}}Re.to=Ce})(be||(e.SignatureHelp=be={}));var ye;(function(Re){function Le(Ce,se){const Oe=new s.InlayHint(_.to(se.position),typeof se.label=="string"?se.label:se.label.map(me.to.bind(void 0,Ce)),se.kind&&ke.to(se.kind));return Oe.textEdits=se.textEdits&&se.textEdits.map(J.to),Oe.tooltip=T.isMarkdownString(se.tooltip)?$.to(se.tooltip):se.tooltip,Oe.paddingLeft=se.paddingLeft,Oe.paddingRight=se.paddingRight,Oe}Re.to=Le})(ye||(e.InlayHint=ye={}));var me;(function(Re){function Le(Ce,se){const Oe=new s.InlayHintLabelPart(se.label);return Oe.tooltip=T.isMarkdownString(se.tooltip)?$.to(se.tooltip):se.tooltip,b.Command.is(se.command)&&(Oe.command=Ce.fromInternal(se.command)),se.location&&(Oe.location=Z.to(se.location)),Oe}Re.to=Le})(me||(e.InlayHintLabelPart=me={}));var ke;(function(Re){function Le(se){return se}Re.from=Le;function Ce(se){return se}Re.to=Ce})(ke||(e.InlayHintKind=ke={}));var Pe;(function(Re){function Le(se){return{range:a.from(se.range),url:se.target,tooltip:se.tooltip}}Re.from=Le;function Ce(se){let Oe;if(se.url)try{Oe=typeof se.url=="string"?k.URI.parse(se.url,!0):k.URI.revive(se.url)}catch{}return new s.DocumentLink(a.to(se.range),Oe)}Re.to=Ce})(Pe||(e.DocumentLink=Pe={}));var Be;(function(Re){function Le(se){const Oe=new s.ColorPresentation(se.label);return se.textEdit&&(Oe.textEdit=J.to(se.textEdit)),se.additionalTextEdits&&(Oe.additionalTextEdits=se.additionalTextEdits.map(We=>J.to(We))),Oe}Re.to=Le;function Ce(se){return{label:se.label,textEdit:se.textEdit?J.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Oe=>J.from(Oe)):void 0}}Re.from=Ce})(Be||(e.ColorPresentation=Be={}));var $e;(function(Re){function Le(se){return new s.Color(se[0],se[1],se[2],se[3])}Re.to=Le;function Ce(se){return[se.red,se.green,se.blue,se.alpha]}Re.from=Ce})($e||(e.Color=$e={}));var et;(function(Re){function Le(se){return{range:a.from(se.range)}}Re.from=Le;function Ce(se){return new s.SelectionRange(a.to(se.range))}Re.to=Ce})(et||(e.SelectionRange=et={}));var Qe;(function(Re){function Le(Ce){switch(Ce){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Re.to=Le})(Qe||(e.TextDocumentSaveReason=Qe={}));var Ye;(function(Re){function Le(se){switch(se){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Le;function Ce(se){switch(se){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Re.to=Ce})(Ye||(e.TextEditorLineNumbersStyle=Ye={}));var nt;(function(Re){function Le(se){if(se===s.EndOfLine.CRLF)return 1;if(se===s.EndOfLine.LF)return 0}Re.from=Le;function Ce(se){if(se===1)return s.EndOfLine.CRLF;if(se===0)return s.EndOfLine.LF}Re.to=Ce})(nt||(e.EndOfLine=nt={}));var ct;(function(Re){function Le(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Le})(ct||(e.ProgressLocation=ct={}));var Fe;(function(Re){function Le(se){const Oe={start:se.start+1,end:se.end+1};return se.kind&&(Oe.kind=it.from(se.kind)),Oe}Re.from=Le;function Ce(se){const Oe={start:se.start-1,end:se.end-1};return se.kind&&(Oe.kind=it.to(se.kind)),Oe}Re.to=Ce})(Fe||(e.FoldingRange=Fe={}));var it;(function(Re){function Le(se){if(se)switch(se){case s.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}Re.from=Le;function Ce(se){if(se)switch(se.value){case b.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}Re.to=Ce})(it||(e.FoldingRangeKind=it={}));var z;(function(Re){function Le(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?a.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?h.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Le})(z||(e.TextEditorOpenOptions=z={}));var K;(function(Re){function Le(We){return We instanceof s.RelativePattern?We.toJSON():typeof We=="string"?We:Ce(We)||se(We)?new s.RelativePattern(We.baseUri??We.base,We.pattern).toJSON():We}Re.from=Le;function Ce(We){const Xe=We;return Xe?k.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function se(We){const Xe=We;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Oe(We){return typeof We=="string"?We:new s.RelativePattern(k.URI.revive(We.baseUri),We.pattern)}Re.to=Oe})(K||(e.GlobPattern=K={}));var ge;(function(Re){function Le(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Le);if(typeof Ce=="string")return Ce;{const se=Ce;return{language:se.language,scheme:se.scheme,pattern:K.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Re.from=Le})(ge||(e.LanguageSelector=ge={}));var Ae;(function(Re){function Le(se){return{start:se.start,end:se.end}}Re.from=Le;function Ce(se){return new s.NotebookRange(se.start,se.end)}Re.to=Ce})(Ae||(e.NotebookRange=Ae={}));var Me;(function(Re){function Le(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Re.to=Le;function Ce(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Re.from=Ce})(Me||(e.NotebookCellExecutionSummary=Me={}));var qe;(function(Re){function Le(Ce){if(Ce===S.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ce===S.NotebookCellExecutionState.Pending)return;if(Ce===S.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Re.to=Le})(qe||(e.NotebookCellExecutionState=qe={}));var He;(function(Re){function Le(se){switch(se){case s.NotebookCellKind.Markup:return S.CellKind.Markup;case s.NotebookCellKind.Code:default:return S.CellKind.Code}}Re.from=Le;function Ce(se){switch(se){case S.CellKind.Markup:return s.NotebookCellKind.Markup;case S.CellKind.Code:default:return s.NotebookCellKind.Code}}Re.to=Ce})(He||(e.NotebookCellKind=He={}));var tt;(function(Re){function Le(se){const Oe={metadata:se.metadata??Object.create(null),cells:[]};for(const We of se.cells)s.NotebookCellData.validate(We),Oe.cells.push(pt.from(We));return Oe}Re.from=Le;function Ce(se){const Oe=new s.NotebookData(se.cells.map(pt.to));return(0,w.isEmptyObject)(se.metadata)||(Oe.metadata=se.metadata),Oe}Re.to=Ce})(tt||(e.NotebookData=tt={}));var pt;(function(Re){function Le(se){return{cellKind:He.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Me.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(vt.from):[]}}Re.from=Le;function Ce(se){return new s.NotebookCellData(He.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(vt.to):void 0,se.metadata,se.internalMetadata?Me.to(se.internalMetadata):void 0)}Re.to=Ce})(pt||(e.NotebookCellData=pt={}));var at;(function(Re){function Le(se){return{mime:se.mime,valueBytes:A.VSBuffer.wrap(se.data)}}Re.from=Le;function Ce(se){return new s.NotebookCellOutputItem(se.valueBytes.buffer,se.mime)}Re.to=Ce})(at||(e.NotebookCellOutputItem=at={}));var vt;(function(Re){function Le(se){return{outputId:se.id,items:se.items.map(at.from),metadata:se.metadata}}Re.from=Le;function Ce(se){const Oe=se.items.map(at.to);return new s.NotebookCellOutput(Oe,se.outputId,se.metadata)}Re.to=Ce})(vt||(e.NotebookCellOutput=vt={}));var yt;(function(Re){function Le(Oe){return se(Oe)?{include:(0,w.withNullAsUndefined)(K.from(Oe.include)),exclude:(0,w.withNullAsUndefined)(K.from(Oe.exclude))}:(0,w.withNullAsUndefined)(K.from(Oe))}Re.from=Le;function Ce(Oe){return se(Oe)?{include:K.to(Oe.include),exclude:K.to(Oe.exclude)}:K.to(Oe)}Re.to=Ce;function se(Oe){const We=Oe;return We?!(0,w.isUndefinedOrNull)(We.include)&&!(0,w.isUndefinedOrNull)(We.exclude):!1}})(yt||(e.NotebookExclusiveDocumentPattern=yt={}));var _t;(function(Re){function Le(Ce,se,Oe){const We=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(We,Oe),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Re.from=Le})(_t||(e.NotebookStatusBarItem=_t={}));var Tt;(function(Re){function Le(Ce,se,Oe){const We=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:se.toInternal(We,Oe),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Re.from=Le})(Tt||(e.NotebookKernelSourceAction=Tt={}));var xt;(function(Re){function Le(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Re.from=Le})(xt||(e.NotebookDocumentContentOptions=xt={}));var jt;(function(Re){function Le(se){return{uri:se.uri,provides:se.provides}}Re.from=Le;function Ce(se){return new s.NotebookRendererScript(k.URI.revive(se.uri),se.provides)}Re.to=Ce})(jt||(e.NotebookRendererScript=jt={}));var Ht;(function(Re){function Le(se){return{message:$.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,location:se.location&&{range:a.from(se.location.range),uri:se.location.uri}}}Re.from=Le;function Ce(se){const Oe=new s.TestMessage(typeof se.message=="string"?se.message:$.to(se.message));return Oe.actualOutput=se.actual,Oe.expectedOutput=se.expected,Oe.location=se.location?Z.to(se.location):void 0,Oe}Re.to=Ce})(Ht||(e.TestMessage=Ht={}));var At;(function(Re){Re.namespace=p.namespaceTestTag,Re.denamespace=p.denamespaceTestTag})(At||(e.TestTag=At={}));var lt;(function(Re){function Le(se){const Oe=(0,d.getPrivateApiFor)(se).controllerId;return{extId:E.TestId.fromExtHostTestItem(se,Oe).toString(),label:se.label,uri:k.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(We=>At.namespace(Oe,We.id)),range:C.Range.lift(a.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&$.fromStrict(se.error)||null}}Re.from=Le;function Ce(se){return{parent:void 0,error:void 0,id:E.TestId.fromString(se.extId).localId,label:se.label,uri:k.URI.revive(se.uri),tags:(se.tags||[]).map(Oe=>{const{tagId:We}=At.denamespace(Oe);return new s.TestTag(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Re.toPlain=Ce})(lt||(e.TestItem=lt={})),function(Re){function Le(se){return{id:se.id}}Re.from=Le;function Ce(se){return new s.TestTag(se.id)}Re.to=Ce}(At||(e.TestTag=At={}));var bt;(function(Re){const Le=(se,Oe)=>{const We=[];for(const[je,rt]of Oe)E.TestId.compare(rt.item.extId,je)===2&&(Oe.delete(je),We.push(rt));const Xe={...lt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(rt=>rt.type===0).map(Ht.to)})),children:We.map(je=>Le(je,Oe))};for(const je of Xe.children)je.parent=Xe;return Xe};function Ce(se){const Oe=[],We=new Map;for(const Xe of se.items){We.set(Xe.item.extId,Xe);const je=E.TestId.root(Xe.item.extId);se.request.targets.some(rt=>rt.controllerId===je&&rt.testIds.includes(Xe.item.extId))&&Oe.push(Xe)}return{completedAt:se.completedAt,results:Oe.map(Xe=>Le(Xe,We))}}Re.to=Ce})(bt||(e.TestResults=bt={}));var Wt;(function(Re){function Le(We){return{covered:We.covered,total:We.covered}}function Ce(We){return"line"in We?_.from(We):a.from(We)}function se(We){return"branches"in We?{count:We.executionCount,location:Ce(We.location),type:1,branches:We.branches.length?We.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&Ce(Xe.location)})):void 0}:{type:0,count:We.executionCount,location:Ce(We.location)}}Re.fromDetailed=se;function Oe(We){return{uri:We.uri,statement:Le(We.statementCoverage),branch:We.branchCoverage&&Le(We.branchCoverage),function:We.functionCoverage&&Le(We.functionCoverage),details:We.detailedCoverage?.map(se)}}Re.fromFile=Oe})(Wt||(e.TestCoverage=Wt={}));var Ut;(function(Re){function Le(Ce){switch(Ce){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Re.to=Le})(Ut||(e.CodeActionTriggerKind=Ut={}));var kt;(function(Re){function Le(se){const Oe=new s.TypeHierarchyItem(ie.to(se.kind),se.name,se.detail||"",k.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Oe._sessionId=se._sessionId,Oe._itemId=se._itemId,Oe}Re.to=Le;function Ce(se,Oe,We){if(Oe=Oe??se._sessionId,We=We??se._itemId,Oe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:We,kind:ie.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(ae.from)}}Re.from=Ce})(kt||(e.TypeHierarchyItem=kt={}));var ft;(function(Re){function Le(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Re.from=Le})(ft||(e.ViewBadge=ft={}));var Pt;(function(Re){function Le(We,Xe,je){const rt=Xe.fileData;return rt?new class extends s.DataTransferItem{asFile(){return new s.DataTransferFile(rt.name,k.URI.revive(rt.uri),Xe.id,(0,R.once)(()=>je()))}}("",Xe.id):We===L.Mimes.uriList&&Xe.uriListData?new s.DataTransferItem(Oe(Xe.uriListData)):new s.DataTransferItem(Xe.asString)}Re.to=Le;async function Ce(We,Xe){const je=await Xe.asString();if(We===L.Mimes.uriList)return{id:Xe.id,asString:je,fileData:void 0,uriListData:se(je)};const rt=Xe.asFile();return{id:Xe.id,asString:je,fileData:rt?{name:rt.name,uri:rt.uri}:void 0}}Re.from=Ce;function se(We){return l.UriList.split(We).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return k.URI.parse(Xe)}catch{}return Xe})}function Oe(We){return l.UriList.create(We.map(Xe=>typeof Xe=="string"?Xe:k.URI.revive(Xe)))}})(Pt||(e.DataTransferItem=Pt={}));var Ft;(function(Re){function Le(se,Oe){const We=se.items.map(([Xe,je])=>[Xe,Pt.to(Xe,je,()=>Oe(je.id))]);return new s.DataTransfer(We)}Re.toDataTransfer=Le;async function Ce(se){const Oe={items:[]},We=[];return se.forEach((Xe,je)=>{We.push((async()=>{Oe.items.push([je,await Pt.from(je,Xe)])})())}),await Promise.all(We),Oe}Re.toDataTransferDTO=Ce})(Ft||(e.DataTransfer=Ft={}));var Rt;(function(Re){function Le(se){return{message:se.message,metadata:se.metadata,title:se.title,tooltip:se.tooltip}}Re.to=Le;function Ce(se){return{kind:"reply",message:se.message,metadata:se.metadata,title:se.title,tooltip:se.tooltip}}Re.from=Ce})(Rt||(e.InteractiveSessionReplyFollowup=Rt={}));var Ke;(function(Re){function Le(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",args:Ce.args}:Rt.from(Ce)}Re.from=Le})(Ke||(e.InteractiveSessionFollowup=Ke={}))}),define(De[250],Ie([1,0,2,8,7,11,67]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(g,L,I,w={timeout:1500,errors:3}){this._logService=g,this._documents=L,this._mainThreadBulkEdits=I,this._thresholds=w,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(g){return(L,I,w)=>{const C={dispose:this._callbacks.push([L,I,g])};return Array.isArray(w)&&w.push(C),C}}async $participateInSave(g,L){const I=o.URI.revive(g);let w=!1;const k=setTimeout(()=>w=!0,this._thresholds.timeout),C=[];try{for(const b of[...this._callbacks]){if(w)break;const i=this._documents.getDocument(I),d=await this._deliverEventAsyncAndBlameBadListeners(b,{document:i,reason:R.TextDocumentSaveReason.to(L)});C.push(d)}}finally{clearTimeout(k)}return C}_deliverEventAsyncAndBlameBadListeners([g,L,I],w){const k=this._badListeners.get(g);return typeof k=="number"&&k>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,g,L,w).then(()=>!0,C=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const b=this._badListeners.get(g);this._badListeners.set(g,b?b+1:1),typeof b=="number"&&b>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(g,L,I,w){const k=[],C=Date.now(),{document:b,reason:i}=w,{version:d}=b,h=Object.freeze({document:b,reason:i,waitUntil(S){if(Object.isFrozen(k))throw(0,A.illegalState)("waitUntil can not be called async");k.push(Promise.resolve(S))}});try{L.apply(I,[h])}catch(S){return Promise.reject(S)}return Object.freeze(k),new Promise((S,E)=>{const p=setTimeout(()=>E(new Error("timeout")),this._thresholds.timeout);return Promise.all(k).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(p),S(t)}).catch(t=>{clearTimeout(p),E(t)})}).then(S=>{const E={edits:[]};for(const p of S)if(Array.isArray(p)&&p.every(t=>t instanceof l.TextEdit))for(const{newText:t,newEol:s,range:r}of p)E.edits.push({resource:b.uri,versionId:void 0,textEdit:{range:r&&R.Range.from(r),text:t,eol:s&&R.EndOfLine.from(s)}});if(E.edits.length!==0)return d===b.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(De[251],Ie([1,0,16,2,11,7,94]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(I,w,k,C){this.start=I,this.deletedCount=w,this.deletedItems=k,this.items=C}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(I,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,w,k){this.notebook=I,this._extHostDocument=w,this._cellData=k,this.handle=k.handle,this.uri=A.URI.revive(k.uri),this.cellKind=k.cellKind,this._outputs=k.outputs.map(l.NotebookCellOutput.to),this._internalMetadata=k.internalMetadata??{},this._metadata=Object.freeze(k.metadata??{}),this._previousResult=Object.freeze(l.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,w=this._extHostDocument.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:l.NotebookCellKind.to(this._cellData.cellKind),document:w.document,get mime(){return I._mime},set mime(C){I._mime=C},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}};this._apiCell=Object.freeze(k)}return this._apiCell}setOutputs(I){this._outputs=I.map(l.NotebookCellOutput.to)}setOutputItems(I,w,k){const C=k.map(l.NotebookCellOutputItem.to),b=this._outputs.find(i=>i.id===I);if(b&&(w||(b.items.length=0),b.items.push(...C),b.items.length>1&&b.items.every(i=>T.isTextStreamMime(i.mime)))){const i=new Map,d=[];b.items.forEach(h=>{let S;i.has(h.mime)?S=i.get(h.mime):(S=[],i.set(h.mime,S),d.push(h.mime)),S.push(h.data)}),b.items.length=0,d.forEach(h=>{const S=T.compressOutputItemStreams(i.get(h));b.items.push({mime:h,data:S.buffer})})}}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(l.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=y;class g{constructor(I,w,k,C,b){this._proxy=I,this._textDocumentsAndEditors=w,this._textDocuments=k,this.uri=C,this.handle=g._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0,void 0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const I=this,w={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===o.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(k){return k=I._validateIndex(k),I._cells[k].apiCell},getCells(k){return(k?I._getCells(k):I._cells).map(b=>b.apiCell)},save(){return I._save()}};this._notebook=Object.freeze(w)}return this._notebook}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,w,k){this._versionId=I.versionId,this._isDirty=w,this.acceptDocumentPropertiesChanged({metadata:k});const C={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},b=[];for(const d of I.rawEvents)d.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1,C.contentChanges):d.kind===T.NotebookCellsChangeType.Move?this._moveCells(d.index,d.length,d.newIdx,C.contentChanges):d.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(d.index,d.outputs),b.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems),b.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(d.index,d.language),b.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document})):d.kind===T.NotebookCellsChangeType.ChangeCellContent?b.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document}):d.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(d.index,d.metadata),b.push({cell:this._cells[d.index].apiCell,metadata:this._cells[d.index].apiCell.metadata})):d.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(d.index,d.internalMetadata),b.push({cell:this._cells[d.index].apiCell,executionSummary:this._cells[d.index].apiCell.executionSummary}));const i=new Map;for(let d=0;d<b.length;d++){const h=b[d],S=i.get(h.cell);if(S===void 0){const E=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});i.set(h.cell,E-1)}else C.cellChanges[S]={...C.cellChanges[S],...h}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let w=I.start|0,k=I.end|0;return w<0&&(w=0),k>this._cells.length&&(k=this._cells.length),I.with({start:w,end:k})}_getCells(I){I=this._validateRange(I);const w=[];for(let k=I.start;k<I.end;k++)w.push(this._cells[k]);return w}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,w,k){if(this._disposed)return;const C=[],b=[],i=[];if(I.reverse().forEach(d=>{const S=d[2].map(t=>{const s=new y(this,this._textDocumentsAndEditors,t);return w||b.push(y.asModelAddData(this.apiNotebook,t)),s}),E=new P(d[0],d[1],[],S),p=this._cells.splice(d[0],d[1],...S);for(const t of p)i.push(t.uri),E.deletedItems.push(t.apiCell);C.push(E)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:b,removedDocuments:i}),k)for(const d of C)k.push(d.asApiEvent())}_moveCells(I,w,k,C){const b=this._cells.splice(I,w);this._cells.splice(k,0,...b);const i=[new P(I,w,b.map(d=>d.apiCell),[]),new P(k,0,[],b)];for(const d of i)C.push(d.asApiEvent())}_setCellOutputs(I,w){this._cells[I].setOutputs(w)}_setCellOutputItems(I,w,k,C){this._cells[I].setOutputItems(w,k,C)}_changeCellLanguage(I,w){const k=this._cells[I];k.apiCell.document.languageId!==w&&this._textDocuments.$acceptModelLanguageChanged(k.uri,w)}_changeCellMime(I,w){const k=this._cells[I];k.apiCell.mime=w}_changeCellMetadata(I,w){this._cells[I].setMetadata(w)}_changeCellInternalMetadata(I,w){this._cells[I].setInternalMetadata(w)}getCellFromApiCell(I){return this._cells.find(w=>w.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(w=>w.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}e.ExtHostNotebookDocument=g,g._handlePool=0}),define(De[252],Ie([1,0,3,2,11,7]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class T{constructor(y,g,L,I={timeout:1500,errors:3}){this._logService=y,this._notebooksAndEditors=g,this._mainThreadBulkEdits=L,this._thresholds=I,this._onWillSaveNotebookDocumentEvent=new o.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(g,L,I)=>{const w=function(C){g.call(L,C)};return w.extension=y,this._onWillSaveNotebookDocumentEvent.event(w,void 0,I)}}async $participateInSave(y,g,L){const I=A.URI.revive(y),w=this._notebooksAndEditors.getNotebookDocument(I);if(!w)throw new Error("Unable to resolve notebook document");const k=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:w.apiNotebook,reason:l.TextDocumentSaveReason.to(g)},L,async(b,i)=>{const d=Date.now(),h=await await Promise.resolve(b);Date.now()-d>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",i.extension.identifier),!L.isCancellationRequested&&h&&(h instanceof R.WorkspaceEdit?k.push(h):this._logService.warn("onWillSaveNotebookDocument-listener from extension",i.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(k.length===0)return!0;const C={edits:[]};for(const b of k){const{edits:i}=l.WorkspaceEdit.from(b);C.edits=C.edits.concat(i)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(C)}}e.ExtHostNotebookDocumentSaveParticipant=T}),define(De[137],Ie([1,0,8,11,7]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(P,y,g,L,I,w){this.id=P,this._proxy=y,this.notebookData=g,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=I,this._visibleRanges=L,this._viewColumn=w}get apiEditor(){if(!this._editor){const P=this;this._editor={get notebook(){return P.notebookData.apiNotebook},get selection(){return P._selections[0]},set selection(y){this.selections=[y]},get selections(){return P._selections},set selections(y){if(!Array.isArray(y)||!y.every(l.NotebookRange.isNotebookRange))throw(0,o.illegalArgument)("selections");P._selections=y,P._trySetSelections(y)},get visibleRanges(){return P._visibleRanges},revealRange(y,g){P._proxy.$tryRevealRange(P.id,A.NotebookRange.from(y),g??l.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_trySetSelections(P){this._proxy.$trySetSelections(this.id,P.map(A.NotebookRange.from))}_acceptViewColumn(P){this._viewColumn=P}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(De[253],Ie([1,0,8,3,17,11]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let T=e.ExtHostNotebookEditors=class{constructor(y,g){this._logService=y,this._notebooksAndEditors=g,this._onDidChangeNotebookEditorSelection=new A.Emitter({onListenerError:o.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new A.Emitter({onListenerError:o.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,g){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,g);const L=this._notebooksAndEditors.getEditorById(y);g.visibleRanges&&L._acceptVisibleRanges(g.visibleRanges.ranges.map(R.NotebookRange.to)),g.selections&&L._acceptSelections(g.selections.selections.map(R.NotebookRange.to)),g.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:L.apiEditor,visibleRanges:L.apiEditor.visibleRanges}),g.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:L.apiEditor,selections:L.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const g in y)this._notebooksAndEditors.getEditorById(g)._acceptViewColumn(R.ViewColumn.to(y[g]))}};e.ExtHostNotebookEditors=T=Ve([ze(0,l.ILogService)],T)}),define(De[254],Ie([1,0,11,125,187,21,64,8]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(w){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=w}async withProgress(w,k,C){const b=this._handles++,{title:i,location:d,cancellable:h}=k,S={label:(0,l.localize)(0,null,w.displayName||w.name),id:w.identifier.value};return this._proxy.$startProgress(b,{location:o.ProgressLocation.from(d),title:i,source:S,cancellable:h},w.isUnderDevelopment?void 0:w.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(b,C,!!h)}_withProgress(w,k,C){let b;C&&(b=new R.CancellationTokenSource,this._mapHandleToCancellationSource.set(w,b));const i=h=>{this._proxy.$progressEnd(h),this._mapHandleToCancellationSource.delete(h),b?.dispose()};let d;try{d=k(new L(this._proxy,w),C&&b?b.token:R.CancellationToken.None)}catch(h){throw i(w),h}return d.then(h=>i(w),h=>i(w)),d}$acceptProgressCanceled(w){const k=this._mapHandleToCancellationSource.get(w);k&&(k.cancel(),this._mapHandleToCancellationSource.delete(w))}}e.ExtHostProgress=y;function g(I,w){return I.message=w.message,typeof w.increment=="number"&&(typeof I.increment=="number"?I.increment+=w.increment:I.increment=w.increment),I}class L extends A.Progress{constructor(w,k){super(C=>this.throttledReport(C)),this._proxy=w,this._handle=k}throttledReport(w){this._proxy.$progressReport(this._handle,w)}}Ve([(0,T.throttle)(100,(I,w)=>g(I,w),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(De[138],Ie([1,0,32,133,59,95,77,11,2]),function(oe,e,o,A,l,R,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const g=(S,E,p,t)=>{let s=E;return{enumerable:!0,configurable:!1,get(){return s},set(r){if(!p(s,r)){const a=s;s=r,S.listener?.(t(r,a))}}}},L=(S,E)=>S===E,I={range:(S,E)=>S===E?!0:!S||!E?!1:S.isEqual(E),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(S,E)=>!(S.length!==E.length||S.some(p=>!E.find(t=>p.id===t.id)))},w=S=>E=>({op:4,update:S(E)}),k=(S,E)=>({range:(()=>{let p;const t=w(s=>({range:o.Range.lift(P.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return p},set(s){S.listener?.({op:6}),I.range(p,s)||(p=s,S.listener?.(t(s)))}}})(),label:g(S,E,I.label,w(p=>({label:p}))),description:g(S,void 0,I.description,w(p=>({description:p}))),sortText:g(S,void 0,I.sortText,w(p=>({sortText:p}))),canResolveChildren:g(S,!1,I.canResolveChildren,p=>({op:2,state:p})),busy:g(S,!1,I.busy,w(p=>({busy:p}))),error:g(S,void 0,I.error,w(p=>({error:P.MarkdownString.fromStrict(p)||null}))),tags:g(S,[],I.tags,(p,t)=>({op:1,new:p.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),C=S=>{const E=l.TestId.fromString(S.extId),p=new i(E.controllerId,E.localId,S.label,y.URI.revive(S.uri)||void 0);return p.range=P.Range.to(S.range||void 0),p.description=S.description||void 0,p.sortText=S.sortText||void 0,p.tags=S.tags.map(t=>P.TestTag.to({id:(0,T.denamespaceTestTag)(t).tagId})),p},b=S=>{let E;for(const p of S.tests){const t=C(p.item);(0,A.getPrivateApiFor)(t).parent=E,E=t}return E};e.toItemFromContext=b;class i{constructor(E,p,t,s){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const r=(0,A.createPrivateApiFor)(this,E);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof d?void 0:r.parent}},children:{value:(0,R.createTestItemChildren)(r,A.getPrivateApiFor,i),enumerable:!0,writable:!1},...k(r,t)})}}e.TestItemImpl=i;class d extends i{constructor(E,p){super(E,E,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class h extends R.TestItemCollection{constructor(E,p,t){super({controllerId:E,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:A.getPrivateApiFor,getChildren:s=>s.children,root:new d(E,p),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=h}),define(De[139],Ie([1,0,51,8,102,11,7]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class P{constructor(w,k,C){const b=P._Keys.nextId();w.$registerTextEditorDecorationType(k.identifier,b,R.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:b,dispose(){w.$removeTextEditorDecorationType(b)}})}}e.TextEditorDecorationType=P,P._Keys=new l.IdGenerator("TextEditorDecorationType");class y{constructor(w,k){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=w,this._documentVersionId=w.version,this._undoStopBefore=k.undoStopBefore,this._undoStopAfter=k.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(w,k){this._throwIfFinalized();let C=null;if(w instanceof T.Position)C=new T.Range(w,w);else if(w instanceof T.Range)C=w;else throw new Error("Unrecognized location");this._pushEdit(C,k,!1)}insert(w,k){this._throwIfFinalized(),this._pushEdit(new T.Range(w,w),k,!0)}delete(w){this._throwIfFinalized();let k=null;if(w instanceof T.Range)k=w;else throw new Error("Unrecognized location");this._pushEdit(k,null,!0)}_pushEdit(w,k,C){const b=this._document.validateRange(w);this._collectedEdits.push({range:b,text:k,forceMoveMarkers:C})}setEndOfLine(w){if(this._throwIfFinalized(),w!==T.EndOfLine.LF&&w!==T.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this._setEndOfLine=w}}class g{constructor(w,k,C,b){this._proxy=w,this._id=k,this._accept(C),this._logService=b;const i=this;this.value={get tabSize(){return i._tabSize},set tabSize(d){i._setTabSize(d)},get indentSize(){return i._indentSize},set indentSize(d){i._setIndentSize(d)},get insertSpaces(){return i._insertSpaces},set insertSpaces(d){i._setInsertSpaces(d)},get cursorStyle(){return i._cursorStyle},set cursorStyle(d){i._setCursorStyle(d)},get lineNumbers(){return i._lineNumbers},set lineNumbers(d){i._setLineNumbers(d)}}}_accept(w){this._tabSize=w.tabSize,this._indentSize=w.indentSize,this._insertSpaces=w.insertSpaces,this._cursorStyle=w.cursorStyle,this._lineNumbers=R.TextEditorLineNumbersStyle.to(w.lineNumbers)}_validateTabSize(w){if(w==="auto")return"auto";if(typeof w=="number"){const k=Math.floor(w);return k>0?k:null}if(typeof w=="string"){const k=parseInt(w,10);return isNaN(k)?null:k>0?k:null}return null}_setTabSize(w){const k=this._validateTabSize(w);if(k!==null){if(typeof k=="number"){if(this._tabSize===k)return;this._tabSize=k}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:k}))}}_validateIndentSize(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const k=Math.floor(w);return k>0?k:null}if(typeof w=="string"){const k=parseInt(w,10);return isNaN(k)?null:k>0?k:null}return null}_setIndentSize(w){const k=this._validateIndentSize(w);if(k!==null){if(typeof k=="number"){if(this._indentSize===k)return;this._indentSize=k}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:k}))}}_validateInsertSpaces(w){return w==="auto"?"auto":w==="false"?!1:!!w}_setInsertSpaces(w){const k=this._validateInsertSpaces(w);if(typeof k=="boolean"){if(this._insertSpaces===k)return;this._insertSpaces=k}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:k}))}_setCursorStyle(w){this._cursorStyle!==w&&(this._cursorStyle=w,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:w})))}_setLineNumbers(w){this._lineNumbers!==w&&(this._lineNumbers=w,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:R.TextEditorLineNumbersStyle.from(w)})))}assign(w){const k={};let C=!1;if(typeof w.tabSize<"u"){const b=this._validateTabSize(w.tabSize);b==="auto"?(C=!0,k.tabSize=b):typeof b=="number"&&this._tabSize!==b&&(this._tabSize=b,C=!0,k.tabSize=b)}if(typeof w.indentSize<"u"){const b=this._validateIndentSize(w.indentSize);b==="tabSize"?(C=!0,k.indentSize=b):typeof b=="number"&&this._indentSize!==b&&(this._indentSize=b,C=!0,k.indentSize=b)}if(typeof w.insertSpaces<"u"){const b=this._validateInsertSpaces(w.insertSpaces);b==="auto"?(C=!0,k.insertSpaces=b):this._insertSpaces!==b&&(this._insertSpaces=b,C=!0,k.insertSpaces=b)}typeof w.cursorStyle<"u"&&this._cursorStyle!==w.cursorStyle&&(this._cursorStyle=w.cursorStyle,C=!0,k.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this._lineNumbers!==w.lineNumbers&&(this._lineNumbers=w.lineNumbers,C=!0,k.lineNumbers=R.TextEditorLineNumbersStyle.from(w.lineNumbers)),C&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,k))}_warnOnError(w,k){k.catch(C=>{this._logService.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this._logService.warn(C)})}}e.ExtHostTextEditorOptions=g;class L{constructor(w,k,C,b,i,d,h,S){this.id=w,this._proxy=k,this._logService=C,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=i,this._options=new g(this._proxy,this.id,d,C),this._visibleRanges=h,this._viewColumn=S;const E=this;this.value=Object.freeze({get document(){return b.value},set document(p){throw(0,A.readonly)("document")},get selection(){return E._selections&&E._selections[0]},set selection(p){if(!(p instanceof T.Selection))throw(0,A.illegalArgument)("selection");E._selections=[p],E._trySetSelection()},get selections(){return E._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof T.Selection)))throw(0,A.illegalArgument)("selections");E._selections=p,E._trySetSelection()},get visibleRanges(){return E._visibleRanges},set visibleRanges(p){throw(0,A.readonly)("visibleRanges")},get options(){return E._options.value},set options(p){E._disposed||E._options.assign(p)},get viewColumn(){return E._viewColumn},set viewColumn(p){throw(0,A.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(E._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(b.value,t);return p(s),E._applyEdit(s)},insertSnippet(p,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(E._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=E._selections.map(a=>R.Range.from(a));else if(t instanceof T.Position){const{lineNumber:a,column:v}=R.Position.from(t);r=[{startLineNumber:a,startColumn:v,endLineNumber:a,endColumn:v}]}else if(t instanceof T.Range)r=[R.Range.from(t)];else{r=[];for(const a of t)if(a instanceof T.Range)r.push(R.Range.from(a));else{const{lineNumber:v,column:_}=R.Position.from(a);r.push({startLineNumber:v,startColumn:_,endLineNumber:v,endColumn:_})}}return k.$tryInsertSnippet(w,b.value.version,p.value,r,s)},setDecorations(p,t){const s=t.length===0;s&&!E._hasDecorationsForKey.has(p.key)||(s?E._hasDecorationsForKey.delete(p.key):E._hasDecorationsForKey.add(p.key),E._runOnProxy(()=>{if(R.isDecorationOptionsArr(t))return k.$trySetDecorations(w,p.key,R.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let a=0,v=t.length;a<v;a++){const _=t[a];r[4*a]=_.start.line+1,r[4*a+1]=_.start.character+1,r[4*a+2]=_.end.line+1,r[4*a+3]=_.end.character+1}return k.$trySetDecorationsFast(w,p.key,r)}}))},revealRange(p,t){E._runOnProxy(()=>k.$tryRevealRange(w,R.Range.from(p),t||T.TextEditorRevealType.Default))},show(p){k.$tryShowEditor(w,R.ViewColumn.from(p))},hide(){k.$tryHideEditor(w)}})}dispose(){(0,o.ok)(!this._disposed),this._disposed=!0}_acceptOptions(w){(0,o.ok)(!this._disposed),this._options._accept(w)}_acceptVisibleRanges(w){(0,o.ok)(!this._disposed),this._visibleRanges=w}_acceptViewColumn(w){(0,o.ok)(!this._disposed),this._viewColumn=w}_acceptSelections(w){(0,o.ok)(!this._disposed),this._selections=w}async _trySetSelection(){const w=this._selections.map(R.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,w)),this.value}_applyEdit(w){const k=w.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const C=k.edits.map(i=>i.range);C.sort((i,d)=>i.end.line===d.end.line?i.end.character===d.end.character?i.start.line===d.start.line?i.start.character-d.start.character:i.start.line-d.start.line:i.end.character-d.end.character:i.end.line-d.end.line);for(let i=0,d=C.length-1;i<d;i++){const h=C[i].end;if(C[i+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const b=k.edits.map(i=>({range:R.Range.from(i.range),text:i.text,forceMoveMarkers:i.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,b,{setEndOfLine:typeof k.setEndOfLine=="number"?R.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}_runOnProxy(w){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this._logService.warn(k),null))}}e.ExtHostTextEditor=L}),define(De[255],Ie([1,0,191,7,24,2,3,6,236,19,7,10,18,11,21,27,158]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(E,p){if((0,I.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let t;return Array.isArray(E.highlights)&&(t=E.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:E.label,highlights:t}}}class h{constructor(p,t,s){this._proxy=p,this.commands=t,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new i.TreeViewsDnDService;function r(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:a=>r(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(v=>r(v)?this.convertArgument(v):v):a})}registerTreeDataProvider(p,t,s){const r=this.createTreeView(p,{treeDataProvider:t},s);return{dispose:()=>r.dispose()}}createTreeView(p,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],a=t.dragAndDropController?.dragMimeTypes??[],v=!!t.dragAndDropController?.handleDrag,_=!!t.dragAndDropController?.handleDrop,c=this.createExtHostTreeView(p,t,s),u=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:a,hasHandleDrag:v,hasHandleDrop:_});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,b.checkProposedApiEnabled)(s,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(m){c.message=m},get title(){return c.title},set title(m){c.title=m},get description(){return c.description},set description(m){c.description=m},get badge(){return c.badge},set badge(m){m!==void 0&&L.ViewBadge.isViewBadge(m)?c.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(c.badge=void 0)},reveal:(m,f)=>c.reveal(m,f),dispose:async()=>{await u,this.treeViews.delete(p),c.dispose()}}}$getChildren(p,t){const s=this.treeViews.get(p);return s?s.getChildren(t):Promise.reject(new y.NoTreeViewError(p))}async $handleDrop(p,t,s,r,a,v,_,c){const u=this.treeViews.get(p);if(!u)return Promise.reject(new y.NoTreeViewError(p));const m=k.DataTransfer.toDataTransfer(s,async f=>(await this._proxy.$resolveDropFileData(p,t,f)).buffer);return _===p&&c&&await this.addAdditionalTransferItems(m,u,c,a,v),u.onDrop(m,r,a)}async addAdditionalTransferItems(p,t,s,r,a){const v=this.treeDragAndDropService.removeDragOperationTransfer(a);if(v)(await v)?.forEach((_,c)=>{_&&p.set(c,_)});else if(a&&t.handleDrag){const _=t.handleDrag(s,p,r);this.treeDragAndDropService.addDragOperationTransfer(a,_),await _}return p}async $handleDrag(p,t,s,r){const a=this.treeViews.get(p);if(!a)return Promise.reject(new y.NoTreeViewError(p));const v=await this.addAdditionalTransferItems(new A.DataTransfer,a,t,r,s);if(v)return k.DataTransfer.toDataTransferDTO(v)}async $hasResolve(p){const t=this.treeViews.get(p);if(!t)throw new y.NoTreeViewError(p);return t.hasResolve}$resolve(p,t,s){const r=this.treeViews.get(p);if(!r)throw new y.NoTreeViewError(p);return r.resolveTreeItem(t,s)}$setExpanded(p,t,s){const r=this.treeViews.get(p);if(!r)throw new y.NoTreeViewError(p);r.setExpanded(t,s)}$setSelection(p,t){const s=this.treeViews.get(p);if(!s)throw new y.NoTreeViewError(p);s.setSelection(t)}$setFocus(p,t){const s=this.treeViews.get(p);if(!s)throw new y.NoTreeViewError(p);s.setFocus(t)}$setVisible(p,t){const s=this.treeViews.get(p);if(!s)throw new y.NoTreeViewError(p);s.setVisible(t)}$changeCheckboxState(p,t){const s=this.treeViews.get(p);if(!s)throw new y.NoTreeViewError(p);s.setCheckboxState(t)}createExtHostTreeView(p,t,s){const r=new S(p,t,this._proxy,this.commands.converter,this.logService,s);return this.treeViews.set(p,r),r}convertArgument(p){const t=this.treeViews.get(p.$treeViewId);return t&&"$treeItemHandle"in p?t.getExtensionElement(p.$treeItemHandle):t&&"$focusedTreeItem"in p&&p.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=h;class S extends P.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,I.isUndefinedOrNull)(p))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(p,t,s,r,a,v){if(super(),this.viewId=p,this.proxy=s,this.commands=r,this.logService=a,this.extension=v,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new T.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new C.CancellationTokenSource,v.contributes&&v.contributes.views)for(const u in v.contributes.views)for(const m of v.contributes.views[u])m.id===p&&(this._title=m.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(u=>this._onDidChangeData.fire({message:!1,element:u})));let _,c;this._register(T.Event.debounce(this._onDidChangeData.event,(u,m)=>(u||(u={message:!1,elements:[]}),m.element!==!1&&(_||(_=new Promise(f=>c=f),this.refreshPromise=this.refreshPromise.then(()=>_)),Array.isArray(m.element)?u.elements.push(...m.element):u.elements.push(m.element)),m.message&&(u.message=!0),u),200,!0)(({message:u,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=c;return _=null,this.refresh(m).then(()=>f())})),u&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(p){const t=p?this.getExtensionElement(p):void 0;if(p&&!t)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(p);return s||(s=await this.fetchChildrenNodes(t)),s?s.map(r=>r.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,t){t=t||{select:!0,focus:!1};const s=(0,I.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,I.isUndefinedOrNull)(t.focus)?!1:t.focus,a=(0,I.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(v=>this.resolveTreeNode(p,v[v.length-1]).then(_=>this.proxy.$reveal(this.viewId,{item:_.item,parentChain:v.map(c=>c.item)},{select:s,focus:r,expand:a})),v=>this.logService.error(v)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:r,expand:a})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}get badge(){return this._badge}set badge(p){this._badge?.value===p?.value&&this._badge?.tooltip===p?.tooltip||(this._badge=k.ViewBadge.from(p),this.proxy.$setBadge(this.viewId,p))}setExpanded(p,t){const s=this.getExtensionElement(p);s&&(t?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelection(p){(0,w.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this._focusedHandle=p}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(p){const t=(await Promise.all(p.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.dataProvider.getTreeItem(r),newState:s.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(p,t,s){const r=[];for(const a of p){const v=this.getExtensionElement(a);v&&r.push(v)}if(!(!this.dndController?.handleDrag||r.length===0))return await this.dndController.handleDrag(r,t,s),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(p,t,s){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.dndController?.handleDrop))return(0,g.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(r,p,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,t){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(p);if(s){const r=this.nodes.get(s);if(r){const a=await this.dataProvider.resolveTreeItem(r.extensionItem,s,t)??r.extensionItem;return this.validateTreeItem(a),r.item.tooltip=this.getTooltip(a.tooltip),r.item.command=this.getCommand(r.disposableStore,a.command),r.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(t=>t?this.resolveUnknownParentChain(t).then(s=>this.resolveTreeNode(t,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}resolveParent(p){const t=this.nodes.get(p);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,g.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,t){const s=this.nodes.get(p);return s?Promise.resolve(s):(0,g.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(r=>this.createHandle(p,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const a=this.getExtensionElement(r);if(a){const v=this.nodes.get(a);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(p){if(p){let t;if(typeof p=="string"){const s=this.getExtensionElement(p);t=s?this.nodes.get(s):void 0}else t=p;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const t=new C.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=p?this.nodes.get(p):void 0,r=await this.dataProvider.getChildren(p);if(t.token.isCancellationRequested)return;const a=await Promise.all((0,w.coalesce)(r||[]).map(async v=>{const _=await this.dataProvider.getTreeItem(v);return _&&!t.token.isCancellationRequested?this.createAndRegisterTreeNode(v,_,s):null}));return t.token.isCancellationRequested?void 0:(0,w.coalesce)(a)}finally{t.dispose()}}refresh(p){if(p.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new C.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(p);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const t=new Set,s=p.map(a=>this.nodes.get(a));for(const a of s)if(a&&!t.has(a.item.handle)){let v=a;for(;v&&v.parent&&s.findIndex(_=>v&&v.parent&&_&&_.item.handle===v.parent.item.handle)===-1;){const _=this.elements.get(v.parent.item.handle);v=_?this.nodes.get(_):void 0}v&&!v.parent&&t.add(a.item.handle)}const r=[];return t.forEach(a=>{const v=this.elements.get(a);if(v){const _=this.nodes.get(v);_&&(!_.parent||!t.has(_.parent.item.handle))&&r.push(a)}}),r}refreshHandles(p){const t={};return Promise.all(p.map(s=>this.refreshNode(s).then(r=>{r&&(t[s]=r.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(p){const t=this.getExtensionElement(p);if(t){const s=this.nodes.get(t);if(s)return this.clearChildren(t),(0,g.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(r=>{if(r){const a=this.createTreeNode(t,r,s.parent);return this.updateNodeCache(t,a,s,s.parent),s.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,t,s){const r=this.createTreeNode(p,t,s);if(t.id&&this.elements.has(r.item.handle))throw new Error((0,o.localize)(0,null,t.id));return this.addNodeToCache(p,r),this.addNodeToParentCache(r,s),r}getTooltip(p){return L.MarkdownString.isMarkdownString(p)?k.MarkdownString.from(p):p}getCommand(p,t){return t?{...this.commands.toInternal(t,p),originalId:t.command}:void 0}getCheckbox(p){if(!p.checkboxState)return;let t,s;return typeof p.checkboxState=="number"?t=p.checkboxState:(t=p.checkboxState.state,s=p.checkboxState.tooltip),{isChecked:t===L.TreeItemCheckboxState.Checked,tooltip:s}}validateTreeItem(p){if(!L.TreeItem.isTreeItem(p,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(p,t,s){this.validateTreeItem(t);const r=new P.DisposableStore,a=this.createHandle(p,t,s),v=this.getLightIconPath(t);return{item:{handle:a,parentHandle:s?s.item.handle:void 0,label:d(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(r,t.command),contextValue:t.contextValue,icon:v,iconDark:this.getDarkIconPath(t)||v,themeIcon:this.getThemeIcon(t),collapsibleState:(0,I.isUndefinedOrNull)(t.collapsibleState)?L.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(p){return p.iconPath instanceof L.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:t,label:s,resourceUri:r},a,v){if(t)return`${S.ID_HANDLE_PREFIX}/${t}`;const _=d(s,this.extension),c=a?a.item.handle:S.LABEL_HANDLE_PREFIX;let u=_?_.label:r?(0,l.basename)(r):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const m=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,f=this.getChildrenNodes(a)||[];let n,D=0;do{if(n=`${c}/${D}:${u}`,v||!this.elements.has(n)||m===n)break;D++}while(D<=f.length);return n}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof L.ThemeIcon))return typeof p.iconPath=="string"||R.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof L.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return R.URI.isUri(p)?p:R.URI.file(p)}addNodeToCache(p,t){this.elements.set(t.item.handle,p),this.nodes.set(p,t)}updateNodeCache(p,t,s,r){this.elements.delete(t.item.handle),this.nodes.delete(p),t.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(p,t);const a=this.getChildrenNodes(r)||[],v=a.filter(_=>_.item.handle===s.item.handle)[0];v&&a.splice(a.indexOf(v),1,t)}addNodeToParentCache(p,t){t?(t.children||(t.children=[]),t.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const t=this.nodes.get(p);if(t){if(t.children)for(const s of t.children){const r=this.elements.get(s.item.handle);r&&this.clear(r)}t.children=void 0}}else this.clearAll()}clear(p){const t=this.nodes.get(p);if(t){if(t.children)for(const s of t.children){const r=this.elements.get(s.item.handle);r&&this.clear(r)}this.nodes.delete(p),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(De[256],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",getSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.getSessions.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[257],Ie([1,0,203,8,38,122,93,40,25,256,217,128]),function(oe,e,o,A,l,R,T,P,y,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const w=P.Registry.as(T.Extensions.JSONContribution);class k{constructor(p,t,s){this._messageHandler=p,this._extension=t,this._extensionPointId=s}_msg(p,t){this._messageHandler({type:p,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(p){this._msg(l.default.Error,p)}warn(p){this._msg(l.default.Warning,p)}info(p){this._msg(l.default.Info,p)}}e.ExtensionMessageCollector=k;class C{static _toSet(p){const t=new y.ExtensionIdentifierSet;for(let s=0,r=p.length;s<r;s++)t.add(p[s].description.identifier);return t}static compute(p,t){if(!p||!p.length)return new C(t,[]);if(!t||!t.length)return new C([],p);const s=this._toSet(p),r=this._toSet(t),a=t.filter(_=>!s.has(_.description.identifier)),v=p.filter(_=>!r.has(_.description.identifier));return new C(a,v)}constructor(p,t){this.added=p,this.removed=t}}e.ExtensionPointUserDelta=C;class b{constructor(p,t){this.name=p,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(p){if(this._handler!==null)throw new Error("Handler already set!");this._handler=p,this._handle()}acceptUsers(p){this._delta=C.compute(this._users,p),this._users=p,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(p){(0,A.onUnexpectedError)(p)}}}e.ExtensionPoint=b;const i={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:o.localize(15,null),type:"string",enum:["none"],enumDescriptions:[o.localize(16,null)]},activationEvents:{description:o.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:o.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:o.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(32,null)},{label:"onUri",body:"onUri",description:o.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(37,null)},{label:"onRenderer",description:o.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:o.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(41,null)},{label:"*",description:o.localize(42,null),body:"*"}]}},badges:{type:"array",description:o.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(44,null)},href:{type:"string",description:o.localize(45,null)},description:{type:"string",description:o.localize(46,null)}}}},markdown:{type:"string",description:o.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:o.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:o.localize(51,null),type:"array",items:i,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(52,null)},{body:["workspace"],description:o.localize(53,null)},{body:["ui","workspace"],description:o.localize(54,null)},{body:["workspace","ui"],description:o.localize(55,null)},{body:[],description:o.localize(56,null)}]},capabilities:{description:o.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(60,null),o.localize(61,null),o.localize(62,null)]},description:{type:"string",markdownDescription:o.localize(63,null)}}},untrustedWorkspaces:{description:o.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(66,null),o.localize(67,null),o.localize(68,null)]},restrictedConfigurations:{description:o.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(70,null)}}}}},sponsor:{description:o.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(73,null),type:"string"},"vscode:uninstall":{description:o.localize(74,null),type:"string"}}},icon:{type:"string",description:o.localize(75,null)},l10n:{type:"string",description:o.localize(76,null)}}};class h{constructor(){this._extensionPoints=new Map}registerExtensionPoint(p){if(this._extensionPoints.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const t=new b(p.extensionPoint,p.defaultExtensionKind);return this._extensionPoints.set(p.extensionPoint,t),p.activationEventsGenerator&&I.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,w.registerSchema(d,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=h;const S={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(S.ExtensionsRegistry,new h),e.ExtensionsRegistry=P.Registry.as(S.ExtensionsRegistry),w.registerSchema(d,e.schema),w.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:o.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(De[258],Ie([1,0,200,10,23,257,44,3]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var g;(function(w){function k(C,b,i){if(!C)return;const d=A.isString(C.type)?C.type:void 0;if(!d||d.length===0){i.error(o.localize(3,null));return}const h=[];if(Array.isArray(C.required))for(const S of C.required)A.isString(S)&&h.push(S);return{extensionId:b.value,taskType:d,required:h,properties:C.properties?l.deepClone(C.properties):{},when:C.when?T.ContextKeyExpr.deserialize(C.when):void 0}}w.from=k})(g||(g={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(w,k)=>{for(const C of w)C.type&&k.push(`onTaskType:${C.type}`)},jsonSchema:{description:o.localize(4,null),type:"array",items:y}});class I{constructor(){this._onDefinitionsChanged=new P.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((k,C)=>{L.setHandler((b,i)=>{this._schema=void 0;try{for(const d of i.removed){const h=d.value;for(const S of h)this.taskTypes&&S.type&&this.taskTypes[S.type]&&delete this.taskTypes[S.type]}for(const d of i.added){const h=d.value;for(const S of h){const E=g.from(S,d.description.identifier,d.collector);E&&(this.taskTypes[E.taskType]=E)}}(i.removed.length>0||i.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}k(void 0)})})}onReady(){return this.readyPromise}get(k){return this.taskTypes[k]}all(){return Object.keys(this.taskTypes).map(k=>this.taskTypes[k])}getJsonSchema(){if(this._schema===void 0){const k=[];for(const C of this.all()){const b={type:"object",additionalProperties:!1};C.required.length>0&&(b.required=C.required.slice(0)),C.properties!==void 0?b.properties=l.deepClone(C.properties):b.properties=Object.create(null),b.properties.type={type:"string",enum:[C.taskType]},k.push(b)}this._schema={oneOf:k}}return this._schema}}e.TaskDefinitionRegistry=new I}),define(De[259],Ie([1,0,201,10,24,23,44,258]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,o.localize(0,null)),e.TASKS_CATEGORY={value:o.localize(1,null),original:"Tasks"};var y;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function q(F){if(!F)return U.Strong;switch(F.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=q}(y||(e.ShellQuoting=y={}));var g;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var L;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(L||(e.RevealKind=L={})),function(U){function q(F){switch(F.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=q}(L||(e.RevealKind=L={}));var I;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(U){function q(F){switch(F.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=q}(I||(e.RevealProblemKind=I={}));var w;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(w||(e.PanelKind=w={})),function(U){function q(F){switch(F.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=q}(w||(e.PanelKind=w={}));var k;(function(U){U.defaults={echo:!0,reveal:L.Always,revealProblems:I.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(k||(e.PresentationOptions=k={}));var C;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(C||(e.RuntimeType=C={})),function(U){function q(B){switch(B.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=q;function F(B){switch(B){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=F}(C||(e.RuntimeType=C={}));var b;(function(U){function q(F){return A.isString(F)?F:F.value}U.value=q})(b||(e.CommandString=b={}));var i;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function q(B){return B===U.Clean._id||B===U.Build._id||B===U.Rebuild._id||B===U.Test._id}U.is=q;function F(B){if(B!==void 0)return A.isString(B)?q(B)?{_id:B,isDefault:!1}:void 0:B}U.from=F})(i||(e.TaskGroup=i={}));var d;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(d||(e.TaskScope=d={}));var h;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function q(F){switch(F){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=q})(h||(e.TaskSourceKind=h={}));var S;(function(U){U.parallel="parallel",U.sequence="sequence"})(S||(e.DependsOrder=S={}));var E;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(E||(e.RunOnOptions=E={}));var p;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(p||(e.RunOptions=p={}));class t{constructor(q,F,B,Q,J,X){this._label="",this._id=q,F&&(this._label=F),B&&(this.type=B),this.runOptions=Q,this.configurationProperties=J,this._source=X}getDefinition(q){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const q={folder:this.getFolderId(),id:this._id};return JSON.stringify(q)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(q,F=!1){if(q===void 0)return!1;if(A.isString(q))return q===this._label||q===this.configurationProperties.identifier||F&&q===this._id;const B=this.getDefinition(!0);return B!==void 0&&B._key===q._key}getQualifiedLabel(){const q=this.getWorkspaceFolder();return q?`${this._label} (${q.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(q){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),q&&(this._taskLoadMessages=this._taskLoadMessages.concat(q))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class s extends t{constructor(q,F,B,Q,J,X,ie,ae){super(q,B,void 0,ie,ae,F),this.command={},this._source=F,this.hasDefinedMatchers=X,J&&(this.command=J)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(q=!1){if(q&&this._source.customizes!==void 0)return this._source.customizes;{let F;switch(this.command?this.command.runtime:void 0){case C.Shell:F="shell";break;case C.Process:F="process";break;case C.CustomExecution:F="customExecution";break;case void 0:F="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:F,_key:this._id,id:this._id}}}static is(q){return q instanceof s}getMapKey(){const q=this._source.config.workspaceFolder;return q?`${q.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===h.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const q=this.getFolderId();if(!q)return;let F=this.configurationProperties.identifier;this._source.kind!==h.Workspace&&(F+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:F};return JSON.stringify(B)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(q){return new s(q._id,q._source,q._label,q.type,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.CustomTask=s;class r extends t{constructor(q,F,B,Q,J,X,ie){super(q,B,Q,X,ie,F),this._source=F,this.configures=J}static is(q){return q instanceof r}fromObject(q){return q}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===h.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const q=this.getFolderId();if(!q)return;let F=this.configurationProperties.identifier;this._source.kind!==h.Workspace&&(F+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:F};return JSON.stringify(B)}}e.ConfiguringTask=r;class a extends t{constructor(q,F,B,Q,J,X,ie,ae,we){super(q,B,Q,ae,we,F),this.defines=J,this.hasDefinedMatchers=ie,this.command=X,this.icon=we.icon,this.hide=we.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(q){return q instanceof a}getMapKey(){const q=this._source.workspaceFolder;return q?`${this._source.scope.toString()}|${q.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const q={type:"contributed",scope:this._source.scope,id:this._id};return q.folder=this.getFolderId(),JSON.stringify(q)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(q){return new a(q._id,q._source,q._label,q.type,q.defines,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.ContributedTask=a;class v extends t{constructor(q,F,B,Q,J,X){super(q,B,Q,J,X,F),this._source=F}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(q){return q instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(q){return new v(q._id,q._source,q._label,q.type,q.runOptions,q.configurationProperties)}}e.InMemoryTask=v;var _;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(_||(e.ExecutionEngine=_={})),function(U){U._default=U.Terminal}(_||(e.ExecutionEngine=_={}));var c;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(c||(e.JsonSchemaVersion=c={}));class u{constructor(q){this._order=new Map;for(let F=0;F<q.length;F++)this._order.set(q[F].uri.toString(),F)}compare(q,F){const B=q.getWorkspaceFolder(),Q=F.getWorkspaceFolder();if(B&&Q){let J=this._order.get(B.uri.toString());J=J===void 0?0:J+1;let X=this._order.get(Q.uri.toString());return X=X===void 0?0:X+1,J===X?q._label.localeCompare(F._label):J-X}else return!B&&Q?-1:B&&!Q?1:0}}e.TaskSorter=u;var m;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(m||(e.TaskEventKind=m={}));var f;(function(U){U.SingleRun="singleRun",U.Background="background"})(f||(e.TaskRunType=f={}));var n;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(n||(e.TaskRunSource=n={}));var D;(function(U){function q(F,B,Q,J){if(B){const X={kind:F,taskId:B._id,taskName:B.configurationProperties.name,runType:B.configurationProperties.isBackground?"background":"singleRun",group:B.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:Q,__task:B};return F==="start"?X.resolvedVariables=J:F==="processStarted"?X.processId=J:F==="processEnded"&&(X.exitCode=J),Object.freeze(X)}else return Object.freeze({kind:"changed"})}U.create=q})(D||(e.TaskEvent=D={}));var M;(function(U){function q(B){const Q=Object.keys(B).sort();let J="";for(const X of Q){let ie=B[X];ie instanceof Object?ie=q(ie):typeof ie=="string"&&(ie=ie.replace(/,/g,",,")),J+=X+","+ie+","}return J}function F(B){const J={_key:q(B),type:B.taskType};return Object.assign(J,B),J}U.create=F})(M||(e.KeyedTaskIdentifier=M={}));var W;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(W||(e.TaskSettingId=W={}));var $;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})($||(e.TasksSchemaProperties=$={}));var N;(function(U){function q(F,B){const Q=P.TaskDefinitionRegistry.get(F.type);if(Q===void 0){const ae=R.deepClone(F);return delete ae._key,M.create(ae)}const J=Object.create(null);J.type=Q.taskType;const X=new Set;Q.required.forEach(ae=>X.add(ae));const ie=Q.properties;for(const ae of Object.keys(ie)){const we=F[ae];if(we!=null)J[ae]=we;else if(X.has(ae)){const he=ie[ae];if(he.default!==void 0)J[ae]=R.deepClone(he.default);else switch(he.type){case"boolean":J[ae]=!1;break;case"number":case"integer":J[ae]=0;break;case"string":J[ae]="";break;default:B.error(o.localize(2,null,JSON.stringify(F,void 0,0),ae));return}}}return M.create(J)}U.createTaskIdentifier=q})(N||(e.TaskDefinition=N={}))}),define(De[260],Ie([1,0,8]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,P)=>{this._actualOk=T,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,o.onUnexpectedError)(T))}then(T,P){return this._ensureActual().then(T,P)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=A;class l extends A{constructor(){super(),this._hasErr=!0,this._err=new o.CancellationError}}e.CanceledLazyPromise=l}),define(De[60],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++o.count}}e.ProxyIdentifier=o,o.count=0;const A=[];function l(P){const y=new o(P);return A[y.nid]=y,y}e.createProxyIdentifier=l;function R(P){return A[P].sid}e.getStringIdentifierForProxy=R;class T{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=T}),define(De[5],Ie([1,0,60]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(A||(e.TextEditorRevealType=A={}));var l;(function(b){b[b.UnknownInput=0]="UnknownInput",b[b.TextInput=1]="TextInput",b[b.TextDiffInput=2]="TextDiffInput",b[b.TextMergeInput=3]="TextMergeInput",b[b.NotebookInput=4]="NotebookInput",b[b.NotebookDiffInput=5]="NotebookDiffInput",b[b.CustomEditorInput=6]="CustomEditorInput",b[b.WebviewEditorInput=7]="WebviewEditorInput",b[b.TerminalEditorInput=8]="TerminalEditorInput",b[b.InteractiveEditorInput=9]="InteractiveEditorInput"})(l||(e.TabInputKind=l={}));var R;(function(b){b[b.TAB_OPEN=0]="TAB_OPEN",b[b.TAB_CLOSE=1]="TAB_CLOSE",b[b.TAB_UPDATE=2]="TAB_UPDATE",b[b.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var T;(function(b){b[b.Editable=0]="Editable",b[b.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var P;(function(b){b[b.Int8Array=1]="Int8Array",b[b.Uint8Array=2]="Uint8Array",b[b.Uint8ClampedArray=3]="Uint8ClampedArray",b[b.Int16Array=4]="Int16Array",b[b.Uint16Array=5]="Uint16Array",b[b.Int32Array=6]="Int32Array",b[b.Uint32Array=7]="Uint32Array",b[b.Float32Array=8]="Float32Array",b[b.Float64Array=9]="Float64Array",b[b.BigInt64Array=10]="BigInt64Array",b[b.BigUint64Array=11]="BigUint64Array"})(P||(e.WebviewMessageArrayBufferViewType=P={}));var y;(function(b){b[b.Text=1]="Text",b[b.Error=2]="Error",b[b.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var g;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var L;(function(b){b[b.None=0]="None",b[b.Process=1]="Process",b[b.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class I{static mixin(i){return i._id=I._n++,i}}e.IdObject=I,I._n=0;var w;(function(b){b.label="a",b.kind="b",b.detail="c",b.documentation="d",b.sortText="e",b.filterText="f",b.preselect="g",b.insertText="h",b.insertTextRules="i",b.range="j",b.commitCharacters="k",b.additionalTextEdits="l",b.kindModifier="m",b.commandIdent="n",b.commandId="o",b.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var k;(function(b){b.defaultRanges="a",b.completions="b",b.isIncomplete="c",b.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var C;(function(b){b[b.Workspace=0]="Workspace",b[b.TextDocument=1]="TextDocument"})(C||(e.ExtHostTestingResource=C={})),e.MainContext={MainThreadAuthentication:(0,o.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,o.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,o.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,o.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,o.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,o.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,o.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,o.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,o.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,o.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,o.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,o.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,o.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,o.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,o.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,o.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,o.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,o.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,o.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,o.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,o.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,o.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,o.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,o.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,o.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,o.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,o.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,o.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,o.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,o.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,o.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,o.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,o.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,o.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,o.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,o.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,o.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,o.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,o.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,o.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,o.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,o.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,o.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,o.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,o.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,o.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,o.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,o.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,o.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,o.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,o.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,o.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,o.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,o.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,o.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,o.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,o.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,o.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,o.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,o.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,o.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,o.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,o.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,o.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,o.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,o.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,o.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,o.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,o.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,o.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,o.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,o.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,o.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,o.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,o.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,o.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,o.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,o.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,o.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,o.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,o.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,o.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,o.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,o.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,o.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,o.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,o.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,o.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,o.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,o.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,o.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,o.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,o.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,o.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,o.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,o.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,o.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,o.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,o.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,o.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,o.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,o.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,o.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,o.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,o.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,o.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,o.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,o.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,o.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,o.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,o.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,o.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,o.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostSemanticSimilarity:(0,o.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,o.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,o.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,o.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,o.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,o.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,o.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,o.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,o.createProxyIdentifier)("ExtHostIssueReporter")}}),define(De[79],Ie([1,0,4,17,5,20]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let T=e.ExtHostApiDeprecationService=class{constructor(y,g){this._extHostLogService=g,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(l.MainContext.MainThreadTelemetry)}report(y,g,L){const I=this.getUsageKey(y,g);this._reportedUsages.has(I)||(this._reportedUsages.add(I),g.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:y}))}getUsageKey(y,g){return`${y}-${g.identifier.value}`}};e.ExtHostApiDeprecationService=T=Ve([ze(0,R.IExtHostRpcService),ze(1,A.ILogService)],T),e.NullApiDeprecationService=Object.freeze(new class{report(P,y,g){}})}),define(De[261],Ie([1,0,3,5,7,25]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(g){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new o.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new P,this._getSessionsTaskSingler=new P,this._proxy=g.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(g){return this._providers=g,Promise.resolve()}async getSession(g,L,I,w={}){const k=R.ExtensionIdentifier.toKey(g.identifier),C=[...I].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${k} ${L} ${C}`,async()=>{await this._proxy.$ensureProvider(L);const b=g.displayName||g.name;return this._proxy.$getSession(L,I,k,b,w)})}async getSessions(g,L,I){const w=R.ExtensionIdentifier.toKey(g.identifier),k=[...I].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${w} ${k}`,async()=>{await this._proxy.$ensureProvider(L);const C=g.displayName||g.name;return this._proxy.$getSessions(L,I,w,C)})}async removeSession(g,L){const I=this._authenticationProviders.get(g);return I?I.provider.removeSession(L):this._proxy.$removeSession(g,L)}registerAuthenticationProvider(g,L,I,w){if(this._authenticationProviders.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this._authenticationProviders.set(g,{label:L,provider:I,options:w??{supportsMultipleAccounts:!1}}),this._providers.find(C=>C.id===g)||this._providers.push({id:g,label:L});const k=I.onDidChangeSessions(C=>{this._proxy.$sendDidChangeSessions(g,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this._proxy.$registerAuthenticationProvider(g,L,w?.supportsMultipleAccounts??!1),new l.Disposable(()=>{k.dispose(),this._authenticationProviders.delete(g);const C=this._providers.findIndex(b=>b.id===g);C>-1&&this._providers.splice(C),this._proxy.$unregisterAuthenticationProvider(g)})}$createSession(g,L){const I=this._authenticationProviders.get(g);if(I)return Promise.resolve(I.provider.createSession(L));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,L){const I=this._authenticationProviders.get(g);if(I)return Promise.resolve(I.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,L){const I=this._authenticationProviders.get(g);if(I)return Promise.resolve(I.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,L){return this._onDidChangeSessions.fire({provider:{id:g,label:L}}),Promise.resolve()}}e.ExtHostAuthentication=T;class P{constructor(){this._inFlightPromises=new Map}getOrCreate(g,L){const I=this._inFlightPromises.get(g);if(I)return I;const w=L().finally(()=>this._inFlightPromises.delete(g));return this._inFlightPromises.set(g,w),w}}}),define(De[262],Ie([1,0,5,20,11]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=e.ExtHostBulkEdits=class{constructor(P,y){this._proxy=P.getProxy(o.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:g=>y.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P,y,g){const L=l.WorkspaceEdit.from(P,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(L,void 0,g?.isRefactoring??!1)}};e.ExtHostBulkEdits=R=Ve([ze(0,A.IExtHostRpcService)],R)}),define(De[263],Ie([1,0,5]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(R){const T=R.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(P){return T.$writeText(P)}})}}e.ExtHostClipboard=A});var Je=this&&this.__classPrivateFieldSet||function(oe,e,o,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,o):l?l.value=o:e.set(oe,o),o},xe=this&&this.__classPrivateFieldGet||function(oe,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(oe):A?A.value:e.get(oe)};define(De[41],Ie([1,0,10,7,11,23,5,18,17,71,32,54,2,6,4,20,138,22,60,46,37,75,78]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h,S,E,p,t){"use strict";var s,r,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let v=e.ExtHostCommands=class{constructor(n,D,M){s.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,r.set(this,void 0),a.set(this,void 0),Je(this,s,n.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=D,Je(this,a,M,"f"),Je(this,r,n.getProxy(T.MainContext.MainThreadTelemetry),"f"),this.converter=new _(this,W=>{const $=this._apiCommands.get(W);return $?.result===u.Void?$:void 0},D),this._argumentProcessors=[{processArgument(W){return(0,g.revive)(W)}},{processArgument(W){return(0,R.cloneAndChange)(W,function($){if(L.Range.isIRange($))return l.Range.to($);if(I.Position.isIPosition($))return l.Position.to($);if(L.Range.isIRange($.range)&&w.URI.isUri($.uri))return l.location.to($);if($ instanceof d.VSBuffer)return $.buffer.buffer;if(!Array.isArray($))return $})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const D=this.registerCommand(!1,n.id,async(...M)=>{const W=n.args.map((N,U)=>{if(!N.validate(M[U]))throw new Error(`Invalid argument '${N.name}' when running '${n.id}', received: ${M[U]}`);return N.convert(M[U])}),$=await this.executeCommand(n.internalId,...W);return n.result.convert($,M,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new A.Disposable(()=>{D.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,D,M,W,$,N){if(this._logService.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this._commands.has(D))throw new Error(`command '${D}' already exists`);return this._commands.set(D,{callback:M,thisArg:W,description:$,extension:N}),n&&xe(this,s,"f").$registerCommand(D),new A.Disposable(()=>{this._commands.delete(D)&&n&&xe(this,s,"f").$unregisterCommand(D)})}executeCommand(n,...D){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,D,!0)}async _doExecuteCommand(n,D,M){if(this._commands.has(n))return xe(this,s,"f").$fireCommandActivationEvent(n),this._executeContributedCommand(n,D,!1);{let W=!1;const $=(0,R.cloneAndChange)(D,function(N){if(N instanceof A.Position)return l.Position.from(N);if(N instanceof A.Range)return l.Range.from(N);if(N instanceof A.Location)return l.location.from(N);if(A.NotebookRange.isNotebookRange(N))return l.NotebookRange.from(N);if(N instanceof ArrayBuffer)return W=!0,d.VSBuffer.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return W=!0,d.VSBuffer.wrap(N);if(N instanceof d.VSBuffer)return W=!0,N;if(!Array.isArray(N))return N});try{const N=await xe(this,s,"f").$executeCommand(n,W?new h.SerializableObjectWithBuffers($):$,M);return(0,g.revive)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this._doExecuteCommand(n,D,!1);throw N}}}async _executeContributedCommand(n,D,M){const W=this._commands.get(n);if(!W)throw new Error("Unknown command");const{callback:$,thisArg:N,description:U}=W;if(U)for(let F=0;F<U.args.length;F++)try{(0,o.validateConstraint)(D[F],U.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${U.args[F].name}' - ${U.args[F].description}`)}const q=E.StopWatch.create();try{return await $.apply(N,D)}catch(F){if(n===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...D);B&&(n=B.command)}if(this._logService.error(F,n,W.extension?.identifier),!M)throw F;if(W.extension?.identifier){const B=xe(this,a,"f").onExtensionError(W.extension.identifier,F);this._logService.trace("forwarded error to extension?",B,W.extension?.identifier)}throw new class extends Error{constructor(){super((0,S.toErrorMessage)(F)),this.id=n,this.source=W.extension?.displayName??W.extension?.name}}}finally{this._reportTelemetry(W,n,q.elapsed())}}_reportTelemetry(n,D,M){n.extension&&xe(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:n.extension.identifier.value,id:new p.TelemetryTrustedValue(D),duration:M})}$executeContributedCommand(n,...D){this._logService.trace("ExtHostCommands#$executeContributedCommand",n);const M=this._commands.get(n);return M?(D=D.map(W=>this._argumentProcessors.reduce(($,N)=>N.processArgument($,M.extension?.identifier),W)),this._executeContributedCommand(n,D,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),xe(this,s,"f").$getCommands().then(D=>(n&&(D=D.filter(M=>M[0]!=="_")),D))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(const[D,M]of this._commands){const{description:W}=M;W&&(n[D]=W)}return Promise.resolve(n)}};s=new WeakMap,r=new WeakMap,a=new WeakMap,e.ExtHostCommands=v=Ve([ze(0,b.IExtHostRpcService),ze(1,y.ILogService),ze(2,t.IExtHostTelemetry)],v),e.IExtHostCommands=(0,C.createDecorator)("IExtHostCommands");class _{constructor(n,D,M){this._commands=n,this._lookupApiCommand=D,this._logService=M,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,D){if(!n)return;const M={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return M;const W=this._lookupApiCommand(n.command);if(W)M.id=W.internalId,M.arguments=W.args.map(($,N)=>$.convert(n.arguments&&n.arguments[N]));else if((0,P.isNonEmptyArray)(n.arguments)){const $=`${n.command}/${++this._cachIdPool}`;this._cache.set($,n),D.add((0,k.toDisposable)(()=>{this._cache.delete($),this._logService.trace("CommandsConverter#DISPOSE",$)})),M.$ident=$,M.id=this.delegatingCommandId,M.arguments=[$],this._logService.trace("CommandsConverter#CREATE",n.command,$)}return M}fromInternal(n){return typeof n.$ident=="string"?this._cache.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this._cache.get(n[0])}_executeConvertedCommand(...n){const D=this.getActualCommand(...n);return this._logService.trace("CommandsConverter#EXECUTE",n[0],D?D.command:"MISSING"),D?this._commands.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${n[0]}`)}}e.CommandsConverter=_;class c{constructor(n,D,M,W){this.name=n,this.description=D,this.validate=M,this.convert=W}optional(){return new c(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,D){return new c(n??this.name,D??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",f=>w.URI.isUri(f),f=>f),c.Position=new c("position","A position in a text document",f=>A.Position.isPosition(f),l.Position.from),c.Range=new c("range","A range in a text document",f=>A.Range.isRange(f),l.Range.from),c.Selection=new c("selection","A selection in a text document",f=>A.Selection.isSelection(f),l.Selection.from),c.Number=new c("number","",f=>typeof f=="number",f=>f),c.String=new c("string","",f=>typeof f=="string",f=>f),c.CallHierarchyItem=new c("item","A call hierarchy item",f=>f instanceof A.CallHierarchyItem,l.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",f=>f instanceof A.TypeHierarchyItem,l.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VSCodium TestItem",f=>f instanceof i.TestItemImpl,l.TestItem.from);class u{constructor(n,D){this.description=n,this.convert=D}}e.ApiCommandResult=u,u.Void=new u("no result",f=>f);class m{constructor(n,D,M,W,$){this.id=n,this.internalId=D,this.description=M,this.args=W,this.result=$}}e.ApiCommand=m}),define(De[264],Ie([1,0,18,16,2,73,120,44,124,41,11,7]),function(oe,e,o,A,l,R,T,P,y,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new g.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(L.DocumentHighlight.to))),new g.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,d)=>{if((0,o.isFalsyOrEmpty)(i))return;class h extends I.SymbolInformation{static to(E){const p=new h(E.name,L.SymbolKind.to(E.kind),E.containerName||"",new I.Location(d[0],L.Range.to(E.range)));return p.detail=E.detail,p.range=p.location.range,p.selectionRange=L.Range.to(E.selectionRange),p.children=E.children?E.children.map(h.to):[],p}}return i.map(h.to)})),new g.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new g.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range,new g.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new g.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,new g.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new g.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new g.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(L.location.to))),new g.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(L.Hover.to))),new g.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(d=>I.Position.isPosition(d)),i=>i.map(L.Position.from))],new g.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(d=>{let h;for(const S of d.reverse())h=new I.SelectionRange(L.Range.to(S),h);return h}))),new g.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.ApiCommandArgument.String.with("query","Search string")],new g.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(L.WorkspaceSymbol.to))),new g.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",i=>i.map(L.CallHierarchyItem.to))),new g.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.ApiCommandArgument.CallHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",i=>i.map(L.CallHierarchyIncomingCall.to))),new g.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.ApiCommandArgument.CallHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",i=>i.map(L.CallHierarchyOutgoingCall.to))),new g.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(i)return{range:L.Range.to(i.range),placeholder:i.text}})),new g.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("newName","The new symbol name")],new g.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(i){if(i.rejectReason)throw new Error(i.rejectReason);return L.WorkspaceEdit.to(i)}})),new g.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(L.DocumentLink.to))),new g.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new I.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new g.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const d=(0,T.decodeSemanticTokensDto)(i);if(d.type==="full")return new I.SemanticTokens(d.data,void 0)})),new g.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range.optional()],new g.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new I.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new g.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const d=(0,T.decodeSemanticTokensDto)(i);if(d.type==="full")return new I.SemanticTokens(d.data,void 0)})),new g.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,d,h)=>{if(!i)return new I.CompletionList([]);const S=i.suggestions.map(E=>L.CompletionItem.to(E,h));return new I.CompletionList(S,i.incomplete)})),new g.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return L.SignatureHelp.to(i)})),new g.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,d,h)=>C(S=>new I.CodeLens(L.Range.to(S.range),S.command&&h.fromInternal(S.command)))(i))),new g.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>I.Range.isRange(i),i=>I.Selection.isSelection(i)?L.Selection.from(i):L.Range.from(i)),g.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),g.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,d,h)=>C(S=>{if(S._isSynthetic){if(!S.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(S.command)}else{const E=new I.CodeAction(S.title,S.kind?new I.CodeActionKind(S.kind):void 0);return S.edit&&(E.edit=L.WorkspaceEdit.to(S.edit)),S.command&&(E.command=h.fromInternal(S.command)),E.isPreferred=S.isPreferred,E}})(i))),new g.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(d=>new I.ColorInformation(L.Range.to(d.range),L.Color.to(d.color))):[])),new g.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.ApiCommandArgument("color","The color to show and insert",i=>i instanceof I.Color,L.Color.from),new g.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:L.Range.from(i.range)}))],new g.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(L.ColorPresentation.to):[])),new g.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,d,h)=>i.map(L.InlayHint.to.bind(void 0,h)))),new g.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(i,d)=>{if(i)return i.map(L.FoldingRange.to)})),new g.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(d=>L.NotebookExclusiveDocumentPattern.to(d))})))),new g.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(L.InlineValue.to))),new g.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",i=>l.URI.isUri(i)||typeof i=="string"&&(0,y.matchesSomeScheme)(i,A.Schemas.http,A.Schemas.https),i=>i),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[L.ViewColumn.from(i),void 0]:[L.ViewColumn.from(i.viewColumn),L.TextEditorOpenOptions.from(i)])).optional(),g.ApiCommandArgument.String.with("label","").optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.ApiCommandArgument.Uri.with("resource","Resource to open"),g.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[L.ViewColumn.from(i),void 0]:[L.ViewColumn.from(i.viewColumn),L.TextEditorOpenOptions.from(i)])).optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),g.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),g.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[L.ViewColumn.from(i.viewColumn),L.TextEditorOpenOptions.from(i)]).optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(L.TypeHierarchyItem.to))),new g.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.ApiCommandArgument.TypeHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(L.TypeHierarchyItem.to))),new g.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.ApiCommandArgument.TypeHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(L.TypeHierarchyItem.to))),new g.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.ApiCommandArgument.TestItem],g.ApiCommandResult.Void),new g.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.ApiCommandResult.Void),new g.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.ApiCommandArgument.String.with("name","The context key name"),new g.ApiCommandArgument("value","The context key value",()=>!0,i=>i)],g.ApiCommandResult.Void)];class k{static register(d){w.forEach(d.registerApiCommand,d),this._registerValidateWhenClausesCommand(d)}static _registerValidateWhenClausesCommand(d){d.registerCommand(!1,"_validateWhenClauses",P.validateWhenClauses)}}e.ExtHostApiCommands=k;function C(i){return d=>{if(Array.isArray(d))return d.map(i)}}function b(i){if(!Array.isArray(i))return;const d=[];for(const h of i)R.isLocationLink(h)?d.push(L.DefinitionLink.to(h)):d.push(L.location.to(h));return d}}),define(De[265],Ie([1,0,19,64,3,6,2,73,25,11,7,5,27,10]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function C(b,i,d){const h=b.getProxy(I.MainContext.MainThreadComments);class S{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new y.ExtensionIdentifierMap,i.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const u=this._commentControllers.get(c.handle);return u?u.value:c}else if(c&&c.$mid===7){const u=this._commentControllers.get(c.commentControlHandle);if(!u)return c;const m=u.getCommentThread(c.commentThreadHandle);return m?m.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const u=this._commentControllers.get(c.thread.commentControlHandle);if(!u)return c;const m=u.getCommentThread(c.thread.commentThreadHandle);return m?c.$mid===8?m.value:{thread:m.value,text:c.text}:c}else if(c&&c.$mid===10){const u=this._commentControllers.get(c.thread.commentControlHandle);if(!u)return c;const m=u.getCommentThread(c.thread.commentThreadHandle);if(!m)return c;const f=c.commentUniqueId,n=m.getCommentByUniqueId(f);return n||c}else if(c&&c.$mid===11){const u=this._commentControllers.get(c.thread.commentControlHandle);if(!u)return c;const m=u.getCommentThread(c.thread.commentThreadHandle);if(!m)return c;const f=c.text,n=c.commentUniqueId,D=m.getCommentByUniqueId(n);return D?(typeof D.body=="string"?D.body=f:D.body=new L.MarkdownString(f),D):c}return c}})}createCommentController(c,u,m){const f=S.handlePool++,n=new p(c,f,u,m);this._commentControllers.set(n.handle,n);const D=this._commentControllersByExtension.get(c.identifier)||[];return D.push(n),this._commentControllersByExtension.set(c.identifier,D),n.value}$createCommentThreadTemplate(c,u,m){const f=this._commentControllers.get(c);f&&f.$createCommentThreadTemplate(u,m)}async $updateCommentThreadTemplate(c,u,m){const f=this._commentControllers.get(c);f&&f.$updateCommentThreadTemplate(u,m)}$deleteCommentThread(c,u){this._commentControllers.get(c)?.$deleteCommentThread(u)}$provideCommentingRanges(c,u,m){const f=this._commentControllers.get(c);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const n=d.getDocument(T.URI.revive(u));return(0,o.asPromise)(async()=>{const D=await f.commentingRangeProvider.provideCommentingRanges(n,m);let M;return Array.isArray(D)?M={ranges:D,fileComments:!1}:D?M={ranges:D.ranges||[],fileComments:D.fileComments||!1}:M=(0,k.withNullAsUndefined)(D),M}).then(D=>{let M;return D&&(M={ranges:D.ranges.map(W=>g.Range.from(W)),fileComments:D.fileComments}),M})}$toggleReaction(c,u,m,f,n){const D=this._commentControllers.get(c);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const M=D.getCommentThread(u);if(M){const W=M.getCommentByUniqueId(f.uniqueIdInThread);if(D!==void 0&&W&&D.reactionHandler)return D.reactionHandler(W,r(n))}return Promise.resolve(void 0)})}}S.handlePool=0;class E{set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){(c===void 0!=(this._range===void 0)||!c||!this._range||!c.isEqual(this._range))&&(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(c){this._state=c,this.modifications.state=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(c,u,m,f,n,D,M,W){this._commentControllerHandle=u,this._id=m,this._uri=f,this._range=n,this._comments=D,this.extensionDescription=M,this._isTemplate=W,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new l.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputDisposables.value=new R.DisposableStore,this._id===void 0&&(this._id=`${c}.${this.handle}`),h.$createCommentThread(u,this.handle,this._id,this._uri,g.Range.from(this._range),M.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this._localDisposables.push({dispose:()=>{h.$deleteCommentThread(u,this.handle)}});const $=this;this.value={get uri(){return $.uri},get range(){return $.range},set range(N){$.range=N},get comments(){return $.comments},set comments(N){$.comments=N},get collapsibleState(){return $.collapsibleState},set collapsibleState(N){$.collapsibleState=N},get canReply(){return $.canReply},set canReply(N){$.canReply=N},get contextValue(){return $.contextValue},set contextValue(N){$.contextValue=N},get label(){return $.label},set label(N){$.label=N},get state(){return $.state},set state(N){$.state=N},dispose:()=>{$.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new R.DisposableStore);const c=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),u={};c("range")&&(u.range=g.Range.from(this._range)),c("label")&&(u.label=this.label),c("contextValue")&&(u.contextValue=this.contextValue??null),c("comments")&&(u.comments=this._comments.map(m=>t(this,m,this._commentsMap,this.extensionDescription))),c("collapsibleState")&&(u.collapseState=a(this._collapseState)),c("canReply")&&(u.canReply=this.canReply),c("state")&&(u.state=v(this._state)),c("isTemplate")&&(u.isTemplate=this._isTemplate),this.modifications={},h.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(c){for(const u of this._commentsMap){const m=u[0],f=u[1];if(c===f)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose())}}E._handlePool=0,Ve([(0,A.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class p{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(c){this._commentingRangeProvider=c,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,h.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(c,u,m,f){this._extension=c,this._handle=u,this._id=m,this._label=f,this._threads=new Map,h.$registerCommentController(this.handle,m,f);const n=this;this.value=Object.freeze({id:n.id,label:n.label,get options(){return n.options},set options(D){n.options=D},get commentingRangeProvider(){return n.commentingRangeProvider},set commentingRangeProvider(D){n.commentingRangeProvider=D},get reactionHandler(){return n.reactionHandler},set reactionHandler(D){n.reactionHandler=D},createCommentThread(D,M,W){return n.createCommentThread(D,M,W).value},dispose:()=>{n.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(c,u,m){u===void 0&&(0,w.checkProposedApiEnabled)(this._extension,"fileComments");const f=new E(this.id,this.handle,void 0,c,u,m,this._extension,!1);return this._threads.set(f.handle,f),f}$createCommentThreadTemplate(c,u){const m=new E(this.id,this.handle,void 0,T.URI.revive(c),g.Range.to(u),[],this._extension,!0);return m.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(c,u){const m=this._threads.get(c);m&&(m.range=g.Range.to(u))}$deleteCommentThread(c){this._threads.get(c)?.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._localDisposables.forEach(c=>c.dispose())}}function t(_,c,u,m){let f=u.get(c);return f||(f=++_.commentHandle,u.set(c,f)),c.state!==void 0&&(0,w.checkProposedApiEnabled)(m,"commentsDraftState"),{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:f,body:typeof c.body=="string"?c.body:g.MarkdownString.from(c.body),userName:c.author.name,userIconPath:c.author.iconPath,label:c.label,commentReactions:c.reactions?c.reactions.map(n=>s(n)):void 0,state:c.state,timestamp:c.timestamp?.toJSON()}}function s(_){return{label:_.label,iconPath:_.iconPath?g.pathOrURIToURI(_.iconPath):void 0,count:_.count,hasReacted:_.authorHasReacted}}function r(_){return{label:_.label||"",count:_.count||0,iconPath:_.iconPath?T.URI.revive(_.iconPath):"",authorHasReacted:_.hasReacted||!1}}function a(_){if(_!==void 0)switch(_){case L.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function v(_){if(_!==void 0)switch(_){case L.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new S}e.createExtHostComments=C}),define(De[266],Ie([1,0,23,5,26,20]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let T=e.AbstractExtHostConsoleForwarder=class{constructor(L,I){this._mainThreadConsole=L.getProxy(A.MainContext.MainThreadConsole),this._includeStack=I.consoleForward.includeStack,this._logNative=I.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(L,I){const w=this,k=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){w._handleConsoleCall(L,I,k,arguments)}})}_handleConsoleCall(L,I,w,k){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:I,arguments:y(k,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(L,w,k)}};e.AbstractExtHostConsoleForwarder=T=Ve([ze(0,R.IExtHostRpcService),ze(1,l.IExtHostInitDataService)],T);const P=1e5;function y(g,L){const I=[];if(g.length)for(let w=0;w<g.length;w++){let k=g[w];if(typeof k>"u")k="undefined";else if(k instanceof Error){const C=k;C.stack?k=C.stack:k=C.toString()}I.push(k)}if(L){const w=new Error().stack;w&&I.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,o.safeStringify)(I);return w.length>P?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(De[140],Ie([1,0,2,5,7,4,20,17,18,9,15,27]),function(oe,e,o,A,l,R,T,P,y,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=e.ExtHostDecorations=class Qi{constructor(C,b){this._logService=b,this._provider=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(C,b){const i=Qi._handlePool++;this._provider.set(i,{provider:C,extensionDescription:b}),this._proxy.$registerDecorationProvider(i,b.identifier.value);const d=C.onDidChangeFileDecorations&&C.onDidChangeFileDecorations(h=>{if(!h){this._proxy.$onDidChange(i,null);return}const S=(0,y.asArray)(h);if(S.length<=Qi._maxEventSize){this._proxy.$onDidChange(i,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",b.identifier.value,S.length);const E=S.map(s=>({uri:s,rank:(0,g.count)(s.path,"/")})),p=(0,y.groupBy)(E,(s,r)=>s.rank-r.rank||(0,g.compare)(s.uri.path,r.uri.path)),t=[];e:for(const s of p){let r;for(const a of s){const v=(0,L.dirname)(a.uri.path);if(r!==v&&(r=v,t.push(a.uri)>=Qi._maxEventSize))break e}}this._proxy.$onDidChange(i,t)});return new l.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(i),this._provider.delete(i)})}async $provideDecorations(C,b,i){if(!this._provider.has(C))return Object.create(null);const d=Object.create(null),{provider:h,extensionDescription:S}=this._provider.get(C);return await Promise.all(b.map(async E=>{try{const{uri:p,id:t}=E,s=await Promise.resolve(h.provideFileDecoration(o.URI.revive(p),i));if(!s)return;try{l.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,I.checkProposedApiEnabled)(S,"codiconDecoration"),d[t]=[s.propagate,s.tooltip,s.badge,s.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${S}': ${r}`)}}catch(p){this._logService.error(p)}})),d}};w._handlePool=0,w._maxEventSize=250,e.ExtHostDecorations=w=Ve([ze(0,T.IExtHostRpcService),ze(1,P.ILogService)],w),e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(oe,e,o,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,o):l?l.value=o:e.set(oe,o),o},xe=this&&this.__classPrivateFieldGet||function(oe,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(oe):A?A.value:e.get(oe)};define(De[267],Ie([1,0,182,123,2,5,7,11,3,17,28,49]),function(oe,e,o,A,l,R,T,P,y,g,L,I){"use strict";var w,k,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class b{constructor(h,S,E,p,t,s,r){this._name=h,this._owner=S,this._maxDiagnosticsPerFile=E,this._modelVersionIdProvider=p,w.set(this,void 0),k.set(this,void 0),C.set(this,void 0),this._isDisposed=!1,Je(this,C,new L.ResourceMap(a=>t.getComparisonKey(a)),"f"),Je(this,w,s,"f"),Je(this,k,r,"f")}dispose(){this._isDisposed||(xe(this,k,"f").fire([...xe(this,C,"f").keys()]),xe(this,w,"f")?.$clear(this._owner),xe(this,C,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(h,S){if(!h){this.clear();return}this._checkDisposed();let E=[];if(l.URI.isUri(h)){if(!S){this.delete(h);return}xe(this,C,"f").set(h,S.slice()),E=[h]}else if(Array.isArray(h)){E=[];let t;h=[...h].sort(b._compareIndexedTuplesByUri);for(const s of h){const[r,a]=s;if((!t||r.toString()!==t.toString())&&(t&&xe(this,C,"f").get(t).length===0&&xe(this,C,"f").delete(t),t=r,E.push(r),xe(this,C,"f").set(r,[])),a)xe(this,C,"f").get(r)?.push(...a);else{const v=xe(this,C,"f").get(r);v&&(v.length=0)}}}if(xe(this,k,"f").fire(E),!xe(this,w,"f"))return;const p=[];for(const t of E){let s=[];const r=xe(this,C,"f").get(t);if(r)if(r.length>this._maxDiagnosticsPerFile){s=[];const a=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let v=0;v<4;v++)for(const _ of r)if(_.severity===a[v]&&s.push({...P.Diagnostic.from(_),modelVersionId:this._modelVersionIdProvider(t)})===this._maxDiagnosticsPerFile)break e;s.push({severity:A.MarkerSeverity.Info,message:(0,o.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=r.map(a=>({...P.Diagnostic.from(a),modelVersionId:this._modelVersionIdProvider(t)}));p.push([t,s])}xe(this,w,"f").$changeMany(this._owner,p)}delete(h){this._checkDisposed(),xe(this,k,"f").fire([h]),xe(this,C,"f").delete(h),xe(this,w,"f")?.$changeMany(this._owner,[[h,void 0]])}clear(){this._checkDisposed(),xe(this,k,"f").fire([...xe(this,C,"f").keys()]),xe(this,C,"f").clear(),xe(this,w,"f")?.$clear(this._owner)}forEach(h,S){this._checkDisposed();for(const[E,p]of this)h.call(S,E,p,this)}*[(w=new WeakMap,k=new WeakMap,C=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const h of xe(this,C,"f").keys())yield[h,this.get(h)]}get(h){this._checkDisposed();const S=xe(this,C,"f").get(h);return Array.isArray(S)?Object.freeze(S.slice(0)):[]}has(h){return this._checkDisposed(),Array.isArray(xe(this,C,"f").get(h))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(h,S){return h[0].toString()<S[0].toString()?-1:h[0].toString()>S[0].toString()?1:0}}e.DiagnosticCollection=b;let i=e.ExtHostDiagnostics=class mi{static _mapper(h){const S=new L.ResourceMap;for(const E of h)S.set(E,E);return{uris:Object.freeze(Array.from(S.values()))}}constructor(h,S,E,p){this._logService=S,this._fileSystemInfoService=E,this._extHostDocumentsAndEditors=p,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,mi._mapper),this._proxy=h.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(h,S){const{_collections:E,_proxy:p,_onDidChangeDiagnostics:t,_logService:s,_fileSystemInfoService:r,_extHostDocumentsAndEditors:a}=this,v=new class{$changeMany(u,m){p.$changeMany(u,m),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",h.value,u,m.length===0?"CLEARING":m)}$clear(u){p.$clear(u),s.trace("[DiagnosticCollection] remove all (extension, owner)",h.value,u)}dispose(){p.dispose()}};let _;if(!S)S="_generated_diagnostic_collection_name_#"+mi._idPool++,_=S;else if(!E.has(S))_=S;else{this._logService.warn(`DiagnosticCollection with name '${S}' does already exist.`);do _=S+mi._idPool++;while(E.has(_))}return new class extends b{constructor(){super(S,_,mi._maxDiagnosticsPerFile,u=>a.getDocument(u)?.version,r.extUri,v,t),E.set(_,this)}dispose(){super.dispose(),E.delete(_)}}}getDiagnostics(h){if(h)return this._getDiagnostics(h);{const S=new Map,E=[];for(const p of this._collections.values())p.forEach((t,s)=>{let r=S.get(t.toString());typeof r>"u"&&(r=E.length,S.set(t.toString(),r),E.push([t,[]])),E[r][1]=E[r][1].concat(...s)});return E}}_getDiagnostics(h){let S=[];for(const E of this._collections.values())E.has(h)&&(S=S.concat(E.get(h)));return S}$acceptMarkersChange(h){if(!this._mirrorCollection){const S="_generated_mirror",E=new b(S,S,mi._maxDiagnosticsPerFile,p=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(S,E),this._mirrorCollection=E}for(const[S,E]of h)this._mirrorCollection.set(l.URI.revive(S),E.map(P.Diagnostic.to))}};i._idPool=0,i._maxDiagnosticsPerFile=1e3,e.ExtHostDiagnostics=i=Ve([ze(1,g.ILogService),ze(2,I.IExtHostFileSystemInfo)],i)}),define(De[268],Ie([1,0,2,5,27]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(P){this._proxy=P.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(P,y){return y?.allowUIResources&&(0,l.checkProposedApiEnabled)(P,"showLocal"),this._proxy.$showOpenDialog(y).then(g=>g?g.map(L=>o.URI.revive(L)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(y=>y?o.URI.revive(y):void 0)}}e.ExtHostDialogs=R}),define(De[269],Ie([1,0,8,2,7,5,16,21,9]),function(oe,e,o,A,l,R,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class g{constructor(I,w,k){this._documentsAndEditors=w,this._logService=k,this._documentContentProviders=new Map,this._proxy=I.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,w){if(Object.keys(T.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const k=g._handlePool++;this._documentContentProviders.set(k,w),this._proxy.$registerTextContentProvider(k,I);let C;return typeof w.onDidChange=="function"&&(C=w.onDidChange(b=>{if(b.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${b.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(b)&&this.$provideTextDocumentContent(k,b).then(i=>{if(!i&&typeof i!="string")return;const d=this._documentsAndEditors.getDocument(b);if(!d)return;const h=(0,y.splitLines)(i);if(!d.equalLines(h))return this._proxy.$onVirtualDocumentChange(b,i)},o.onUnexpectedError)})),new l.Disposable(()=>{this._documentContentProviders.delete(k)&&this._proxy.$unregisterTextContentProvider(k),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(I,w){const k=this._documentContentProviders.get(I);return k?Promise.resolve(k.provideTextDocumentContent(A.URI.revive(w),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.ExtHostDocumentContentProvider=g,g._handlePool=0}),define(De[270],Ie([1,0,3,6,2,5,136,11,10,23,7]),function(oe,e,o,A,l,R,T,P,y,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(k,C){this._onDidAddDocument=new o.Emitter,this._onDidRemoveDocument=new o.Emitter,this._onDidChangeDocument=new o.Emitter,this._onDidSaveDocument=new o.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new A.DisposableStore,this._documentLoader=new Map,this._proxy=k.getProxy(R.MainContext.MainThreadDocuments),this._documentsAndEditors=C,this._documentsAndEditors.onDidRemoveDocuments(b=>{for(const i of b)this._onDidRemoveDocument.fire(i.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(b=>{for(const i of b)this._onDidAddDocument.fire(i.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(k){if(!k)return;const C=this._documentsAndEditors.getDocument(k);if(C)return C}getDocument(k){const C=this.getDocumentData(k);if(!C?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return C.document}ensureDocumentData(k){const C=this._documentsAndEditors.getDocument(k);if(C)return Promise.resolve(C);let b=this._documentLoader.get(k.toString());return b||(b=this._proxy.$tryOpenDocument(k).then(i=>{this._documentLoader.delete(k.toString());const d=l.URI.revive(i);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(d))},i=>(this._documentLoader.delete(k.toString()),Promise.reject(i))),this._documentLoader.set(k.toString(),b)),b}createDocumentData(k){return this._proxy.$tryCreateDocument(k).then(C=>l.URI.revive(C))}$acceptModelLanguageChanged(k,C){const b=l.URI.revive(k),i=this._documentsAndEditors.getDocument(b);if(!i)throw new Error("unknown document");this._onDidRemoveDocument.fire(i.document),i._acceptLanguageId(C),this._onDidAddDocument.fire(i.document)}$acceptModelSaved(k){const C=l.URI.revive(k),b=this._documentsAndEditors.getDocument(C);if(!b)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this._onDidSaveDocument.fire(b.document)}$acceptDirtyStateChanged(k,C){const b=l.URI.revive(k),i=this._documentsAndEditors.getDocument(b);if(!i)throw new Error("unknown document");i._acceptIsDirty(C),this._onDidChangeDocument.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,C,b){const i=l.URI.revive(k),d=this._documentsAndEditors.getDocument(i);if(!d)throw new Error("unknown document");d._acceptIsDirty(b),d.onEvents(C);let h;C.isUndoing?h=L.TextDocumentChangeReason.Undo:C.isRedoing&&(h=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,g.deepFreeze)({document:d.document,contentChanges:C.changes.map(S=>({range:P.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:h}))}setWordDefinitionFor(k,C){(0,T.setWordDefinitionFor)(k,C)}}e.ExtHostDocuments=I}),define(De[61],Ie([1,0,51,3,6,2,4,5,136,20,139,11,17,28,16,52,66]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(E){this.value=E,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let h=e.ExtHostDocumentsAndEditors=class{constructor(E,p){this._extHostRpc=E,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new k.ResourceMap,this._onDidAddDocuments=new A.Emitter,this._onDidRemoveDocuments=new A.Emitter,this._onDidChangeVisibleTextEditors=new A.Emitter,this._onDidChangeActiveTextEditor=new A.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const p=[],t=[],s=[];if(E.removedDocuments)for(const r of E.removedDocuments){const a=R.URI.revive(r),v=this._documents.get(a);v?.unref()&&(this._documents.delete(a),p.push(v.value))}if(E.addedDocuments)for(const r of E.addedDocuments){const a=R.URI.revive(r.uri);let v=this._documents.get(a);if(v&&a.scheme!==C.Schemas.vscodeNotebookCell&&a.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);v||(v=new d(new y.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),a,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(a,v),t.push(v.value)),v.ref()}if(E.removedEditors)for(const r of E.removedEditors){const a=this._editors.get(r);this._editors.delete(r),a&&s.push(a)}if(E.addedEditors)for(const r of E.addedEditors){const a=R.URI.revive(r.documentUri);o.ok(this._documents.has(a),`document '${a}' does not exist`),o.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const v=this._documents.get(a).value,_=new L.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new i.Lazy(()=>v.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(c=>I.Range.to(c)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,_)}E.newActiveEditor!==void 0&&(o.ok(E.newActiveEditor===null||this._editors.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this._activeEditorId=E.newActiveEditor),(0,l.dispose)(p),(0,l.dispose)(s),E.removedDocuments&&this._onDidRemoveDocuments.fire(p),E.addedDocuments&&this._onDidAddDocuments.fire(t),(E.removedEditors||E.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),E.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(E){return this._documents.get(E)?.value}allDocuments(){return b.Iterable.map(this._documents.values(),E=>E.value)}getEditor(E){return this._editors.get(E)}activeEditor(E){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return E?p:p?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=h=Ve([ze(0,g.IExtHostRpcService),ze(1,w.ILogService)],h),e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[62],Ie([1,0,11,5,2,3,4,7,20,10,63]),function(oe,e,o,A,l,R,T,P,y,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class I{constructor(i,d,h){this._activeTabIdGetter=h,this._parentGroup=d,this.acceptDtoUpdate(i)}get apiObject(){if(!this._apiObject){const i=this,d={get isActive(){return i._dto.id===i._activeTabIdGetter()},get label(){return i._dto.label},get input(){return i._input},get isDirty(){return i._dto.isDirty},get isPinned(){return i._dto.isPinned},get isPreview(){return i._dto.isPreview},get group(){return i._parentGroup.apiObject}};this._apiObject=Object.freeze(d)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(i){this._dto=i,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(l.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(l.URI.revive(this._dto.input.original),l.URI.revive(this._dto.input.modified));case 3:return new P.TextMergeTabInput(l.URI.revive(this._dto.input.base),l.URI.revive(this._dto.input.input1),l.URI.revive(this._dto.input.input2),l.URI.revive(this._dto.input.result));case 6:return new P.CustomEditorTabInput(l.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new P.NotebookEditorTabInput(l.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(l.URI.revive(this._dto.input.original),l.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(l.URI.revive(this._dto.input.uri),l.URI.revive(this._dto.input.inputBoxUri));default:return}}}class w{constructor(i,d){this._tabs=[],this._activeTabId="",this._dto=i,this._activeGroupIdGetter=d;for(const h of i.tabs)h.isActive&&(this._activeTabId=h.id),this._tabs.push(new I(h,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const i=this,d={get isActive(){return i._dto.groupId===i._activeGroupIdGetter()},get viewColumn(){return o.ViewColumn.to(i._dto.viewColumn)},get activeTab(){return i._tabs.find(h=>h.tabId===i._activeTabId)?.apiObject},get tabs(){return Object.freeze(i._tabs.map(h=>h.apiObject))}};this._apiObject=Object.freeze(d)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(i){this._dto=i}acceptTabOperation(i){if(i.kind===0){const h=new I(i.tabDto,this,()=>this.activeTabId());return this._tabs.splice(i.index,0,h),i.tabDto.isActive&&(this._activeTabId=h.tabId),h}else if(i.kind===1){const h=this._tabs.splice(i.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${i.index} which does not exist`);return h.tabId===this._activeTabId&&(this._activeTabId=""),h}else if(i.kind===3){if(i.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this._tabs.splice(i.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${i.oldIndex} which does not exist`);return this._tabs.splice(i.index,0,h),h}const d=this._tabs.find(h=>h.tabId===i.tabDto.id);if(!d)throw new Error("INVALID tab");return i.tabDto.isActive?this._activeTabId=i.tabDto.id:this._activeTabId===i.tabDto.id&&!i.tabDto.isActive&&(this._activeTabId=""),d.acceptDtoUpdate(i.tabDto),d}activeTabId(){return this._activeTabId}}let k=e.ExtHostEditorTabs=class{constructor(i){this._onDidChangeTabs=new R.Emitter,this._onDidChangeTabGroups=new R.Emitter,this._extHostTabGroups=[],this._proxy=i.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const i=this,d={onDidChangeTabGroups:i._onDidChangeTabGroups.event,onDidChangeTabs:i._onDidChangeTabs.event,get all(){return Object.freeze(i._extHostTabGroups.map(h=>h.apiObject))},get activeTabGroup(){const h=i._activeGroupId;return(0,g.assertIsDefined)(i._extHostTabGroups.find(E=>E.groupId===h)?.apiObject)},close:async(h,S)=>{const E=Array.isArray(h)?h:[h];return E.length?C(E[0])?this._closeGroups(E,S):this._closeTabs(E,S):!0}};this._apiObject=Object.freeze(d)}return this._apiObject}$acceptEditorTabModel(i){const d=new Set(this._extHostTabGroups.map(r=>r.groupId)),h=new Set(i.map(r=>r.groupId)),S=(0,L.diffSets)(d,h),E=this._extHostTabGroups.filter(r=>S.removed.includes(r.groupId)).map(r=>r.apiObject),p=[],t=[];this._extHostTabGroups=i.map(r=>{const a=new w(r,()=>this._activeGroupId);return S.added.includes(a.groupId)?p.push(a.apiObject):t.push(a.apiObject),a});const s=(0,g.assertIsDefined)(i.find(r=>r.isActive===!0)?.groupId);s!==void 0&&this._activeGroupId!==s&&(this._activeGroupId=s),this._onDidChangeTabGroups.fire(Object.freeze({opened:p,closed:E,changed:t}))}$acceptTabGroupUpdate(i){const d=this._extHostTabGroups.find(h=>h.groupId===i.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(i),i.isActive&&(this._activeGroupId=i.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(i){const d=this._extHostTabGroups.find(S=>S.groupId===i.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const h=d.acceptTabOperation(i);switch(i.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}_findExtHostTabFromApi(i){for(const d of this._extHostTabGroups)for(const h of d.tabs)if(h.apiObject===i)return h}_findExtHostTabGroupFromApi(i){return this._extHostTabGroups.find(d=>d.apiObject===i)}async _closeTabs(i,d){const h=[];for(const S of i){const E=this._findExtHostTabFromApi(S);if(!E)throw new Error("Tab close: Invalid tab not found!");h.push(E.tabId)}return this._proxy.$closeTab(h,d)}async _closeGroups(i,d){const h=[];for(const S of i){const E=this._findExtHostTabGroupFromApi(S);if(!E)throw new Error("Group close: Invalid group not found!");h.push(E.groupId)}return this._proxy.$closeGroup(h,d)}};e.ExtHostEditorTabs=k=Ve([ze(0,y.IExtHostRpcService)],k);function C(b){return b.tabs!==void 0}}),define(De[271],Ie([1,0,2,5,6,7,11,156,9,22,27]),function(oe,e,o,A,l,R,T,P,y,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(C){this._stateMachine=void 0,this._schemes.push(C)}delete(C){const b=this._schemes.indexOf(C);b>=0&&(this._schemes.splice(b,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const C=this._schemes.sort(),b=[];let i,d,h=14,S=14;for(const E of C){let p=i?(0,y.commonPrefixLength)(i,E):0;for(p===0?d=1:d=S;p<E.length;p++)p+1===E.length?(h=S,S=9):S+=1,b.push([d,E.toUpperCase().charCodeAt(p),S]),b.push([d,E.toLowerCase().charCodeAt(p),S]),d=S;i=E,S=h}b.push([9,58,10]),b.push([10,47,12]),this._stateMachine=new P.StateMachine(b)}}provideDocumentLinks(C){this._initStateMachine();const b=[],i=P.LinkComputer.computeLinks({getLineContent(d){return C.lineAt(d-1).text},getLineCount(){return C.lineCount}},this._stateMachine);for(const d of i){const h=T.DocumentLink.to(d);h.target&&b.push(h)}return b}}class w{constructor(C,b){this._extHostLanguageFeatures=b,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=C.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(C,b,i,d={}){if(w._validateFileSystemProvider(i),this._registeredSchemes.has(b))throw new Error(`a provider for the scheme '${b}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(C,"*",this._linkProvider));const h=this._handlePool++;this._linkProvider.add(b),this._registeredSchemes.add(b),this._fsProvider.set(h,i);let S=2;d.isCaseSensitive&&(S+=1024),d.isReadonly&&(S+=2048),typeof i.copy=="function"&&(S+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,L.checkProposedApiEnabled)(C,"fsChunks"),S+=4),this._proxy.$registerFileSystemProvider(h,b,S).catch(p=>{console.error(`FAILED to register filesystem provider of ${C.identifier.value}-extension for the scheme ${b}`),console.error(p)});const E=i.onDidChangeFile(p=>{const t=[];for(const s of p){const{uri:r,type:a}=s;if(r.scheme!==b)continue;let v;switch(a){case R.FileChangeType.Changed:v=0;break;case R.FileChangeType.Created:v=1;break;case R.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:v})}this._proxy.$onFileSystemChange(h,t)});return(0,l.toDisposable)(()=>{E.dispose(),this._linkProvider.delete(b),this._registeredSchemes.delete(b),this._fsProvider.delete(h),this._proxy.$unregisterProvider(h)})}static _validateFileSystemProvider(C){if(!C)throw new Error("MISSING provider");if(typeof C.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof C.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof C.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof C.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof C.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof C.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof C.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof C.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(C){const{type:b,ctime:i,mtime:d,size:h,permissions:S}=C;return{type:b,ctime:i,mtime:d,size:h,permissions:S}}$stat(C,b){return Promise.resolve(this._getFsProvider(C).stat(o.URI.revive(b))).then(i=>w._asIStat(i))}$readdir(C,b){return Promise.resolve(this._getFsProvider(C).readDirectory(o.URI.revive(b)))}$readFile(C,b){return Promise.resolve(this._getFsProvider(C).readFile(o.URI.revive(b))).then(i=>g.VSBuffer.wrap(i))}$writeFile(C,b,i,d){return Promise.resolve(this._getFsProvider(C).writeFile(o.URI.revive(b),i.buffer,d))}$delete(C,b,i){return Promise.resolve(this._getFsProvider(C).delete(o.URI.revive(b),i))}$rename(C,b,i,d){return Promise.resolve(this._getFsProvider(C).rename(o.URI.revive(b),o.URI.revive(i),d))}$copy(C,b,i,d){const h=this._getFsProvider(C);if(!h.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(h.copy(o.URI.revive(b),o.URI.revive(i),d))}$mkdir(C,b){return Promise.resolve(this._getFsProvider(C).createDirectory(o.URI.revive(b)))}$watch(C,b,i,d){const h=this._getFsProvider(C).watch(o.URI.revive(i),d);this._watches.set(b,h)}$unwatch(C,b){const i=this._watches.get(b);i&&(i.dispose(),this._watches.delete(b))}$open(C,b,i){const d=this._getFsProvider(C);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(o.URI.revive(b),i))}$close(C,b){const i=this._getFsProvider(C);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(b))}$read(C,b,i,d){const h=this._getFsProvider(C);if(!h.read)throw new Error('FileSystemProvider does not implement "read"');const S=g.VSBuffer.alloc(d);return Promise.resolve(h.read(b,i,S.buffer,0,d)).then(E=>S.slice(0,E))}$write(C,b,i,d){const h=this._getFsProvider(C);if(!h.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(h.write(b,i,d.buffer,0,d.byteLength))}_getFsProvider(C){const b=this._fsProvider.get(C);if(!b){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return b}}e.ExtHostFileSystem=w}),define(De[80],Ie([1,0,5,45,7,22,4,20,49,6]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=e.ExtHostConsumerFileSystem=class Zt{constructor(w,k){this._fileSystemProvider=new Map,this._proxy=w.getProxy(o.MainContext.MainThreadFileSystem);const C=this;this.value=Object.freeze({async stat(b){try{const i=C._fileSystemProvider.get(b.scheme);if(!i)return await C._proxy.$stat(b);await C._proxy.$ensureActivation(b.scheme);const d=await i.stat(b);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(i){Zt._handleError(i)}},async readDirectory(b){try{const i=C._fileSystemProvider.get(b.scheme);return i?(await C._proxy.$ensureActivation(b.scheme),(await i.readDirectory(b)).slice()):await C._proxy.$readdir(b)}catch(i){return Zt._handleError(i)}},async createDirectory(b){try{return await C._proxy.$mkdir(b)}catch(i){return Zt._handleError(i)}},async readFile(b){try{const i=C._fileSystemProvider.get(b.scheme);return i?(await C._proxy.$ensureActivation(b.scheme),(await i.readFile(b)).slice()):(await C._proxy.$readFile(b)).buffer}catch(i){return Zt._handleError(i)}},async writeFile(b,i){try{return await C._proxy.$writeFile(b,R.VSBuffer.wrap(i))}catch(d){return Zt._handleError(d)}},async delete(b,i){try{const d=C._fileSystemProvider.get(b.scheme);return d?(await C._proxy.$ensureActivation(b.scheme),await d.delete(b,{recursive:!1,...i})):await C._proxy.$delete(b,{recursive:!1,useTrash:!1,...i})}catch(d){return Zt._handleError(d)}},async rename(b,i,d){try{return await C._proxy.$rename(b,i,{overwrite:!1,...d})}catch(h){return Zt._handleError(h)}},async copy(b,i,d){try{return await C._proxy.$copy(b,i,{overwrite:!1,...d})}catch(h){return Zt._handleError(h)}},isWritableFileSystem(b){const i=k.getCapabilities(b);if(typeof i=="number")return!(i&2048)}})}static _handleError(w){if(w instanceof l.FileSystemError)throw w;if(!(w instanceof Error))throw new l.FileSystemError(String(w));if(w.name==="ENOPRO"||w.message.includes("ENOPRO"))throw l.FileSystemError.Unavailable(w.message);switch(w.name){case A.FileSystemProviderErrorCode.FileExists:throw l.FileSystemError.FileExists(w.message);case A.FileSystemProviderErrorCode.FileNotFound:throw l.FileSystemError.FileNotFound(w.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw l.FileSystemError.FileNotADirectory(w.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw l.FileSystemError.FileIsADirectory(w.message);case A.FileSystemProviderErrorCode.NoPermissions:throw l.FileSystemError.NoPermissions(w.message);case A.FileSystemProviderErrorCode.Unavailable:throw l.FileSystemError.Unavailable(w.message);default:throw new l.FileSystemError(w.message,w.name)}}addFileSystemProvider(w,k){return this._fileSystemProvider.set(w,k),(0,g.toDisposable)(()=>this._fileSystemProvider.delete(w))}};e.ExtHostConsumerFileSystem=L=Ve([ze(0,P.IExtHostRpcService),ze(1,y.IExtHostFileSystemInfo)],L),e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(De[272],Ie([1,0,3,39,2,5,11,7]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(I,w,k,C,b,i,d,h){this._onDidCreate=new o.Emitter,this._onDidChange=new o.Emitter,this._onDidDelete=new o.Emitter;const S=this.ensureWatching(I,k,b);this._config=0,i&&(this._config+=1),d&&(this._config+=2),h&&(this._config+=4);const E=(0,A.parse)(b),p=typeof b=="string",t=C(s=>{if(!i)for(const r of s.created){const a=l.URI.revive(r);E(a.fsPath)&&(!p||w.getWorkspaceFolder(a))&&this._onDidCreate.fire(a)}if(!d)for(const r of s.changed){const a=l.URI.revive(r);E(a.fsPath)&&(!p||w.getWorkspaceFolder(a))&&this._onDidChange.fire(a)}if(!h)for(const r of s.deleted){const a=l.URI.revive(r);E(a.fsPath)&&(!p||w.getWorkspaceFolder(a))&&this._onDidDelete.fire(a)}});this._disposable=P.Disposable.from(S,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(I,w,k){const C=P.Disposable.from();if(typeof k=="string")return C;const b=I.getProxy(R.MainContext.MainThreadFileSystem);let i=!1;(k.pattern.includes(A.GLOBSTAR)||k.pattern.includes(A.GLOB_SPLIT))&&(i=!0);const d=Math.random();return b.$watch(w.identifier.value,d,k.baseUri,{recursive:i,excludes:[]}),P.Disposable.from({dispose:()=>b.$unwatch(d)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class g{constructor(I,w,k){this._mainContext=I,this._logService=w,this._extHostDocumentsAndEditors=k,this._onFileSystemEvent=new o.Emitter,this._onDidRenameFile=new o.Emitter,this._onDidCreateFile=new o.Emitter,this._onDidDeleteFile=new o.Emitter,this._onWillRenameFile=new o.AsyncEmitter,this._onWillCreateFile=new o.AsyncEmitter,this._onWillDeleteFile=new o.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,w,k,C,b,i){return new y(this._mainContext,I,w,this._onFileSystemEvent.event,T.GlobPattern.from(k),C,b,i)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,w){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:w.map(k=>({oldUri:l.URI.revive(k.source),newUri:l.URI.revive(k.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:w.map(k=>l.URI.revive(k.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:w.map(k=>l.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,w){return(k,C,b)=>{const i=function(h){k.call(C,h)};return i.extension=I,w.event(i,void 0,b)}}async $onWillRunFileOperation(I,w,k,C){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:w.map(b=>({oldUri:l.URI.revive(b.source),newUri:l.URI.revive(b.target)}))},k,C);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:w.map(b=>l.URI.revive(b.target))},k,C);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:w.map(b=>l.URI.revive(b.target))},k,C)}}async _fireWillEvent(I,w,k,C){const b=new Set,i=[];if(await I.fireAsync(w,C,async(h,S)=>{const E=Date.now(),p=await Promise.resolve(h);p instanceof P.WorkspaceEdit&&(i.push([S.extension,p]),b.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-E>k&&this._logService.warn("SLOW file-participant",S.extension.identifier)}),C.isCancellationRequested||i.length===0)return;const d={edits:[]};for(const[,h]of i){const{edits:S}=T.WorkspaceEdit.from(h,{getTextDocumentVersion:E=>this._extHostDocumentsAndEditors.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(S)}return{edit:d,extensionNames:Array.from(b)}}}e.ExtHostFileSystemEventService=g}),define(De[273],Ie([1,0,2,41]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class l{constructor(T,P,y,g,L){this._extHostNotebooks=P,this._textDocumentsAndEditors=y,this._commands=g;const I=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",w=>!0,w=>w),new A.ApiCommandArgument("resource","Interactive resource Uri",w=>!0,w=>w),new A.ApiCommandArgument("controllerId","Notebook controller Id",w=>!0,w=>w),new A.ApiCommandArgument("title","Interactive editor title",w=>!0,w=>w)],new A.ApiCommandResult("Notebook and input URI",w=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const k=this._extHostNotebooks.getEditorById(w.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:o.URI.revive(w.notebookUri),inputUri:o.URI.revive(w.inputUri),notebookEditor:k.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:o.URI.revive(w.notebookUri),inputUri:o.URI.revive(w.inputUri)}}));this._commands.registerApiCommand(I)}$willAddInteractiveDocument(T,P,y,g){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:y,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(o.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=l}),define(De[274],Ie([1,0,6,2,5,11,7]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class P{constructor(I,w){this.extension=I,this.provider=w,this.handle=P._pool++}}P._pool=0;class y{constructor(I){this.session=I,this.responses=[]}}class g{constructor(I,w,k){this._documents=w,this._logService=k,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=I.getProxy(l.MainContext.MainThreadInteractiveEditor)}registerProvider(I,w){const k=new P(I,w);return this._inputProvider.set(k.handle,k),this._proxy.$registerInteractiveEditorProvider(k.handle,I.identifier.value,typeof w.handleInteractiveEditorResponseFeedback=="function"),(0,o.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(k.handle),this._inputProvider.delete(k.handle)})}async $prepareInteractiveSession(I,w,k,C){const b=this._inputProvider.get(I);if(!b){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this._documents.getDocument(A.URI.revive(w)),d=R.Selection.to(k),h=await b.provider.prepareInteractiveEditorSession({document:i,selection:d},C);if(!h)return;if(h.wholeRange&&!h.wholeRange.contains(d))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const S=g._nextId++;return this._inputSessions.set(S,new y(h)),{id:S,placeholder:h.placeholder,slashCommands:h.slashCommands,wholeRange:R.Range.from(h.wholeRange)}}async $provideResponse(I,w,k,C){const b=this._inputProvider.get(I);if(!b)return;const i=this._inputSessions.get(w.id);if(!i)return;const d=await b.provider.provideInteractiveEditorResponse({session:i.session,prompt:k.prompt,selection:R.Selection.to(k.selection),wholeRange:R.Range.to(k.wholeRange)},C);if(d){const h=i.responses.push(d)-1,S={wholeRange:R.Range.from(d.wholeRange),placeholder:d.placeholder};if(g._isMessageResponse(d))return{...S,id:h,type:"message",message:R.MarkdownString.from(d.contents)};const{edits:E}=d;if(E instanceof T.WorkspaceEdit)return{...S,id:h,type:"bulkEdit",edits:R.WorkspaceEdit.from(E)};if(Array.isArray(E))return{...S,id:h,type:"editorEdit",edits:E.map(R.TextEdit.from)}}}$handleFeedback(I,w,k,C){const b=this._inputProvider.get(I),i=this._inputSessions.get(w),d=i?.responses[k];if(b&&d){let h;switch(C){case 1:h=T.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:h=T.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:h=T.InteractiveEditorResponseFeedbackKind.Undone;break}b.provider.handleInteractiveEditorResponseFeedback?.(i.session,d,h)}}$releaseSession(I,w){const k=this._inputSessions.get(w),C=this._inputProvider.get(I);k&&C&&C.provider.releaseInteractiveEditorSession?.(k.session),this._inputSessions.delete(w)}static _isMessageResponse(I){return typeof I=="object"&&typeof I.contents=="object"}}e.ExtHostInteractiveEditor=g,g._nextId=0}),define(De[275],Ie([1,0,3,6,37,184,5,11]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class y{constructor(I,w){this.extension=I,this.provider=w,this.handle=y._pool++}}y._pool=0;class g{constructor(I,w){this.logService=w,this._interactiveSessionProvider=new Map,this._interactiveSessions=new Map,this._onDidPerformUserAction=new o.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=I.getProxy(T.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(I,w,k){const C=new y(I,k);return this._interactiveSessionProvider.set(C.handle,C),this._proxy.$registerInteractiveSessionProvider(C.handle,w),(0,A.toDisposable)(()=>{this._proxy.$unregisterInteractiveSessionProvider(C.handle),this._interactiveSessionProvider.delete(C.handle)})}addInteractiveSessionRequest(I){this._proxy.$addInteractiveSessionRequest(I)}sendInteractiveRequestToProvider(I,w){this._proxy.$sendInteractiveRequestToProvider(I,w)}async $prepareInteractiveSession(I,w,k){const C=this._interactiveSessionProvider.get(I);if(!C)return;const b=await C.provider.prepareSession(w,k);if(!b)return;const i=g._nextId++;return this._interactiveSessions.set(i,b),{id:i,requesterUsername:b.requester?.name,requesterAvatarIconUri:b.requester?.icon,responderUsername:b.responder?.name,responderAvatarIconUri:b.responder?.icon,inputPlaceholder:b.inputPlaceholder}}async $resolveInteractiveRequest(I,w,k,C){const b=this._interactiveSessionProvider.get(I);if(!b)return;const i=this._interactiveSessions.get(w);if(!i||!b.provider.resolveRequest)return;const d=await b.provider.resolveRequest(i,k,C);if(d)return{message:typeof d.message=="string"?d.message:P.InteractiveSessionReplyFollowup.from(d.message)}}async $provideWelcomeMessage(I,w){const k=this._interactiveSessionProvider.get(I);if(!k||!k.provider.provideWelcomeMessage)return;const C=await k.provider.provideWelcomeMessage(w);if(C)return C.map(b=>typeof b=="string"?b:b.map(i=>P.InteractiveSessionReplyFollowup.from(i)))}async $provideFollowups(I,w,k){const C=this._interactiveSessionProvider.get(I);if(!C)return;const b=this._interactiveSessions.get(w);return!b||!C.provider.provideFollowups?void 0:(await C.provider.provideFollowups(b,k))?.map(d=>P.InteractiveSessionFollowup.from(d))}async $provideInteractiveReply(I,w,k,C){const b=this._interactiveSessionProvider.get(I);if(!b)return;const i=this._interactiveSessions.get(w);if(!i)return;const d={session:i,message:typeof k.message=="string"?k.message:P.InteractiveSessionReplyFollowup.to(k.message)},h=l.StopWatch.create(!1);let S;const E={report:s=>{C.isCancellationRequested||(typeof S>"u"&&(S=h.elapsed()),this._proxy.$acceptInteractiveResponseProgress(I,w,s))}};let p;try{p=await b.provider.provideResponseWithProgress(d,E,C),p||(p={errorDetails:{message:(0,R.localize)(0,null)}})}catch(s){p={errorDetails:{message:(0,R.localize)(1,null,s.message),responseIsIncomplete:!0}},this.logService.error(s)}try{if(i.saveState&&this._interactiveSessions.has(w)){const s=i.saveState();this._proxy.$acceptInteractiveSessionState(w,s)}}catch(s){this.logService.warn(s)}const t={firstProgress:S??0,totalElapsed:h.elapsed()};return{errorDetails:p.errorDetails,timings:t}}async $provideSlashCommands(I,w,k){const C=this._interactiveSessionProvider.get(I);if(!C)return;const b=this._interactiveSessions.get(w);return!b||!C.provider.provideSlashCommands?void 0:(await C.provider.provideSlashCommands(b,k))?.map(d=>({...d,kind:P.CompletionItemKind.from(d.kind)}))}$releaseSession(I){this._interactiveSessions.delete(I)}async $onDidPerformUserAction(I){this._onDidPerformUserAction.fire(I)}}e.ExtHostInteractiveSession=g,g._nextId=0}),define(De[276],Ie([1,0,5,7]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class l{constructor(T){this._IssueUriRequestHandlers=new Map,this._proxy=T.getProxy(o.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(T,P){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const y=this._IssueUriRequestHandlers.get(T);if(!y)throw new Error("Issue request handler not found");const g=await y.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(T,P){const y=T.identifier.value;return this._IssueUriRequestHandlers.set(y,P),this._proxy.$registerIssueUriRequestHandler(y),new A.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(y),this._IssueUriRequestHandlers.delete(y)})}}e.ExtHostIssueReporter=l}),define(De[277],Ie([1,0,6,5]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class l{constructor(T){this._handlePool=0,this._proxy=T.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,T),(0,o.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=l}),define(De[278],Ie([1,0,2,23,11,7,73,5,9,32,18,10,152,21,6,120,102,76,37,8,19,27,185]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h,S,E,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentSymbols(O,j){const Y=this._documents.getDocument(O),te=await this._provider.provideDocumentSymbols(Y,j);if(!(0,L.isFalsyOrEmpty)(te))return te[0]instanceof R.DocumentSymbol?te.map(l.DocumentSymbol.from):s._asDocumentSymbolTree(te)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((te,be)=>{let ye=te.location.range.start.compareTo(be.location.range.start);return ye===0&&(ye=be.location.range.end.compareTo(te.location.range.end)),ye});const j=[],Y=[];for(const te of O){const be={name:te.name||"!!MISSING: name!!",kind:l.SymbolKind.from(te.kind),tags:te.tags?.map(l.SymbolTag.from)||[],detail:"",containerName:te.containerName,range:l.Range.from(te.location.range),selectionRange:l.Range.from(te.location.range),children:[]};for(;;){if(Y.length===0){Y.push(be),j.push(be);break}const ye=Y[Y.length-1];if(g.Range.containsRange(ye.range,be.range)&&!g.Range.equalsRange(ye.range,be.range)){ye.children?.push(be),Y.push(be);break}Y.pop()}}return j}}class r{constructor(O,j,Y){this._documents=O,this._commands=j,this._provider=Y,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,j){const Y=this._documents.getDocument(O),te=await this._provider.provideCodeLenses(Y,j);if(!te||j.isCancellationRequested)return;const be=this._cache.add(te),ye=new C.DisposableStore;this._disposables.set(be,ye);const me={cacheId:be,lenses:[]};for(let ke=0;ke<te.length;ke++)me.lenses.push({cacheId:[be,ke],range:l.Range.from(te[ke].range),command:this._commands.toInternal(te[ke].command,ye)});return me}async resolveCodeLens(O,j){const Y=O.cacheId&&this._cache.get(...O.cacheId);if(!Y)return;let te;if(typeof this._provider.resolveCodeLens!="function"||Y.isResolved?te=Y:te=await this._provider.resolveCodeLens(Y,j),te||(te=Y),j.isCancellationRequested)return;const be=O.cacheId&&this._disposables.get(O.cacheId[0]);if(be)return O.command=this._commands.toInternal(te.command??r._badCmd,be),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function a(ue){return Array.isArray(ue)?ue.map(l.DefinitionLink.from):ue?[l.DefinitionLink.from(ue)]:[]}class v{constructor(O,j){this._documents=O,this._provider=j}async provideDefinition(O,j,Y){const te=this._documents.getDocument(O),be=l.Position.to(j),ye=await this._provider.provideDefinition(te,be,Y);return a(ye)}}class _{constructor(O,j){this._documents=O,this._provider=j}async provideDeclaration(O,j,Y){const te=this._documents.getDocument(O),be=l.Position.to(j),ye=await this._provider.provideDeclaration(te,be,Y);return a(ye)}}class c{constructor(O,j){this._documents=O,this._provider=j}async provideImplementation(O,j,Y){const te=this._documents.getDocument(O),be=l.Position.to(j),ye=await this._provider.provideImplementation(te,be,Y);return a(ye)}}class u{constructor(O,j){this._documents=O,this._provider=j}async provideTypeDefinition(O,j,Y){const te=this._documents.getDocument(O),be=l.Position.to(j),ye=await this._provider.provideTypeDefinition(te,be,Y);return a(ye)}}class m{constructor(O,j){this._documents=O,this._provider=j}async provideHover(O,j,Y){const te=this._documents.getDocument(O),be=l.Position.to(j),ye=await this._provider.provideHover(te,be,Y);if(!(!ye||(0,L.isFalsyOrEmpty)(ye.contents)))return ye.range||(ye.range=te.getWordRangeAtPosition(be)),ye.range||(ye.range=new R.Range(be,be)),l.Hover.from(ye)}}class f{constructor(O,j){this._documents=O,this._provider=j}async provideEvaluatableExpression(O,j,Y){const te=this._documents.getDocument(O),be=l.Position.to(j),ye=await this._provider.provideEvaluatableExpression(te,be,Y);if(ye)return l.EvaluatableExpression.from(ye)}}class n{constructor(O,j){this._documents=O,this._provider=j}async provideInlineValues(O,j,Y,te){const be=this._documents.getDocument(O),ye=await this._provider.provideInlineValues(be,l.Range.to(j),l.InlineValueContext.to(Y),te);if(Array.isArray(ye))return ye.map(me=>l.InlineValue.from(me))}}class D{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentHighlights(O,j,Y){const te=this._documents.getDocument(O),be=l.Position.to(j),ye=await this._provider.provideDocumentHighlights(te,be,Y);if(Array.isArray(ye))return ye.map(l.DocumentHighlight.from)}}class M{constructor(O,j){this._documents=O,this._provider=j}async provideLinkedEditingRanges(O,j,Y){const te=this._documents.getDocument(O),be=l.Position.to(j),ye=await this._provider.provideLinkedEditingRanges(te,be,Y);if(ye&&Array.isArray(ye.ranges))return{ranges:(0,L.coalesce)(ye.ranges.map(l.Range.from)),wordPattern:ye.wordPattern}}}class W{constructor(O,j){this._documents=O,this._provider=j}async provideReferences(O,j,Y,te){const be=this._documents.getDocument(O),ye=l.Position.to(j),me=await this._provider.provideReferences(be,ye,Y,te);if(Array.isArray(me))return me.map(l.location.from)}}class ${constructor(O,j,Y,te,be,ye,me){this._documents=O,this._commands=j,this._diagnostics=Y,this._provider=te,this._logService=be,this._extension=ye,this._apiDeprecation=me,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,j,Y,te){const be=this._documents.getDocument(O),ye=w.Selection.isISelection(j)?l.Selection.to(j):l.Range.to(j),me=[];for(const Qe of this._diagnostics.getDiagnostics(O))if(ye.intersection(Qe.range)&&me.push(Qe)>$._maxCodeActionsPerFile)break;const ke={diagnostics:me,only:Y.only?new R.CodeActionKind(Y.only):void 0,triggerKind:l.CodeActionTriggerKind.to(Y.trigger)},Pe=await this._provider.provideCodeActions(be,ye,ke,te);if(!(0,L.isNonEmptyArray)(Pe)||te.isCancellationRequested)return;const Be=this._cache.add(Pe),$e=new C.DisposableStore;this._disposables.set(Be,$e);const et=[];for(let Qe=0;Qe<Pe.length;Qe++){const Ye=Pe[Qe];Ye&&($._isCommand(Ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Ye.title,command:this._commands.toInternal(Ye,$e)})):(ke.only&&(Ye.kind?ke.only.contains(Ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ke.only.value} 'requested but returned code action is of kind '${Ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ke.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[Be,Qe],title:Ye.title,command:Ye.command&&this._commands.toInternal(Ye.command,$e),diagnostics:Ye.diagnostics&&Ye.diagnostics.map(l.Diagnostic.from),edit:Ye.edit&&l.WorkspaceEdit.from(Ye.edit,void 0),kind:Ye.kind&&Ye.kind.value,isPreferred:Ye.isPreferred,disabled:Ye.disabled?.reason})))}return{cacheId:Be,actions:et}}async resolveCodeAction(O,j){const[Y,te]=O,be=this._cache.get(Y,te);if(!be||$._isCommand(be))return{};if(!this._provider.resolveCodeAction)return{};const ye=await this._provider.resolveCodeAction(be,j)??be;let me;ye.edit&&(me=l.WorkspaceEdit.from(ye.edit,void 0));let ke;if(ye.command){const Pe=this._disposables.get(Y);Pe&&(ke=this._commands.toInternal(ye.command,Pe))}return{edit:me,command:ke}}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}$._maxCodeActionsPerFile=1e3;class N{constructor(O,j,Y,te){this._proxy=O,this._documents=j,this._provider=Y,this._handle=te}async prepareDocumentPaste(O,j,Y,te){if(!this._provider.prepareDocumentPaste)return;const be=this._documents.getDocument(O),ye=j.map(ke=>l.Range.to(ke)),me=l.DataTransfer.toDataTransfer(Y,()=>{throw new S.NotImplementedError});return await this._provider.prepareDocumentPaste(be,ye,me,te),l.DataTransfer.toDataTransferDTO(me)}async providePasteEdits(O,j,Y,te,be){const ye=this._documents.getDocument(j),me=Y.map(Be=>l.Range.to(Be)),ke=l.DataTransfer.toDataTransfer(te,async Be=>(await this._proxy.$resolvePasteFileData(this._handle,O,Be)).buffer),Pe=await this._provider.provideDocumentPasteEdits(ye,me,ke,be);if(Pe)return{insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?l.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class U{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentFormattingEdits(O,j,Y){const te=this._documents.getDocument(O),be=await this._provider.provideDocumentFormattingEdits(te,j,Y);if(Array.isArray(be))return be.map(l.TextEdit.from)}}class q{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentRangeFormattingEdits(O,j,Y,te){const be=this._documents.getDocument(O),ye=l.Range.to(j),me=await this._provider.provideDocumentRangeFormattingEdits(be,ye,Y,te);if(Array.isArray(me))return me.map(l.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,j,Y,te){(0,I.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const be=this._documents.getDocument(O),ye=j.map(l.Range.to),me=await this._provider.provideDocumentRangesFormattingEdits(be,ye,Y,te);if(Array.isArray(me))return me.map(l.TextEdit.from)}}class F{constructor(O,j){this._documents=O,this._provider=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,j,Y,te,be){const ye=this._documents.getDocument(O),me=l.Position.to(j),ke=await this._provider.provideOnTypeFormattingEdits(ye,me,Y,te,be);if(Array.isArray(ke))return ke.map(l.TextEdit.from)}}class B{constructor(O,j){this._provider=O,this._logService=j,this._cache=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,j){const Y=await this._provider.provideWorkspaceSymbols(O,j);if(!(0,L.isNonEmptyArray)(Y))return{symbols:[]};const te=this._cache.add(Y),be={cacheId:te,symbols:[]};for(let ye=0;ye<Y.length;ye++){const me=Y[ye];if(!me||!me.name){this._logService.warn("INVALID SymbolInformation",me);continue}be.symbols.push({...l.WorkspaceSymbol.from(me),cacheId:[te,ye]})}return be}async resolveWorkspaceSymbol(O,j){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const Y=this._cache.get(...O.cacheId);if(Y){const te=await this._provider.resolveWorkspaceSymbol(Y,j);return te&&(0,A.mixin)(O,l.WorkspaceSymbol.from(te),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class Q{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,j,Y){this._documents=O,this._provider=j,this._logService=Y}async provideRenameEdits(O,j,Y,te){const be=this._documents.getDocument(O),ye=l.Position.to(j);try{const me=await this._provider.provideRenameEdits(be,ye,Y,te);return me?l.WorkspaceEdit.from(me):void 0}catch(me){const ke=Q._asMessage(me);return ke?{rejectReason:ke,edits:void 0}:Promise.reject(me)}}async resolveRenameLocation(O,j,Y){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const te=this._documents.getDocument(O),be=l.Position.to(j);try{const ye=await this._provider.prepareRename(te,be,Y);let me,ke;if(R.Range.isRange(ye)?(me=ye,ke=te.getText(ye)):(0,I.isObject)(ye)&&(me=ye.range,ke=ye.placeholder),!me||!ke)return;if(me.start.line>be.line||me.end.line<be.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:l.Range.from(me),text:ke}}catch(ye){const me=Q._asMessage(ye);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(ye)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class J{constructor(O,j){this.resultId=O,this.tokens=j}}class X{constructor(O,j){this._documents=O,this._provider=j,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,j,Y){const te=this._documents.getDocument(O),be=j!==0?this._previousResults.get(j):null;let ye=typeof be?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(te,be.resultId,Y):await this._provider.provideDocumentSemanticTokens(te,Y);return be&&this._previousResults.delete(j),ye?(ye=X._fixProvidedSemanticTokens(ye),this._send(X._convertToEdits(be,ye),ye)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return X._isSemanticTokens(O)?X._isCorrectSemanticTokens(O)?O:new R.SemanticTokens(new Uint32Array(O.data),O.resultId):X._isSemanticTokensEdits(O)?X._isCorrectSemanticTokensEdits(O)?O:new R.SemanticTokensEdits(O.edits.map(j=>new R.SemanticTokensEdit(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const j of O.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,j){if(!X._isSemanticTokens(j)||!O||!O.tokens)return j;const Y=O.tokens,te=Y.length,be=j.data,ye=be.length;let me=0;const ke=Math.min(te,ye);for(;me<ke&&Y[me]===be[me];)me++;if(me===te&&me===ye)return new R.SemanticTokensEdits([],j.resultId);let Pe=0;const Be=ke-me;for(;Pe<Be&&Y[te-Pe-1]===be[ye-Pe-1];)Pe++;return new R.SemanticTokensEdits([{start:me,deleteCount:te-me-Pe,data:be.subarray(me,ye-Pe)}],j.resultId)}_send(O,j){if(X._isSemanticTokens(O)){const Y=this._nextResultId++;return this._previousResults.set(Y,new J(O.resultId,O.data)),(0,b.encodeSemanticTokensDto)({id:Y,type:"full",data:O.data})}if(X._isSemanticTokensEdits(O)){const Y=this._nextResultId++;return X._isSemanticTokens(j)?this._previousResults.set(Y,new J(j.resultId,j.data)):this._previousResults.set(Y,new J(O.resultId)),(0,b.encodeSemanticTokensDto)({id:Y,type:"delta",deltas:(O.edits||[]).map(te=>({start:te.start,deleteCount:te.deleteCount,data:te.data}))})}return null}}class ie{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentRangeSemanticTokens(O,j,Y){const te=this._documents.getDocument(O),be=await this._provider.provideDocumentRangeSemanticTokens(te,l.Range.to(j),Y);return be?this._send(be):null}_send(O){return(0,b.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class ae{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,j,Y,te,be){this._documents=O,this._commands=j,this._provider=Y,this._apiDeprecation=te,this._extension=be,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,j,Y,te){const be=this._documents.getDocument(O),ye=l.Position.to(j),me=be.getWordRangeAtPosition(ye)||new R.Range(ye,ye),ke=me.with({end:ye}),Pe=new h.StopWatch(!0),Be=await this._provider.provideCompletionItems(be,ye,te,l.CompletionContext.to(Y));if(!Be||te.isCancellationRequested)return;const $e=Array.isArray(Be)?new R.CompletionList(Be):Be,et=ae.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),Qe=new C.DisposableStore;this._disposables.set(et,Qe);const Ye=[],nt={x:et,b:Ye,a:{replace:l.Range.from(me),insert:l.Range.from(ke)},c:$e.isIncomplete||void 0,d:Pe.elapsed()};for(let ct=0;ct<$e.items.length;ct++){const Fe=$e.items[ct],it=this._convertCompletionItem(Fe,[et,ct],ke,me);Ye.push(it)}return nt}async resolveCompletionItem(O,j){if(typeof this._provider.resolveCompletionItem!="function")return;const Y=this._cache.get(...O);if(!Y)return;const te=await this._provider.resolveCompletionItem(Y,j);if(te)return this._convertCompletionItem(te,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,j,Y,te){const be=this._disposables.get(j[0]);if(!be)throw Error("DisposableStore is missing...");const ye=this._commands.toInternal(O.command,be),me={x:j,a:O.label,b:O.kind!==void 0?l.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(l.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:l.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(l.TextEdit.from),n:ye?.$ident,o:ye?.id,p:ye?.$ident?void 0:ye?.arguments};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=O.textEdit.newText):typeof O.insertText=="string"?me.h=O.insertText:O.insertText instanceof R.SnippetString&&(me.h=O.insertText.value,me.i|=4);let ke;return O.textEdit?ke=O.textEdit.range:O.range&&(ke=O.range),R.Range.isRange(ke)?me.j=l.Range.from(ke):ke&&(!Y?.isEqual(ke.inserting)||!te?.isEqual(ke.replacing))&&(me.j={insert:l.Range.from(ke.inserting),replace:l.Range.from(ke.replacing)}),me}}class we{async provideInlineCompletions(O,j,Y,te){}disposeCompletions(O){}handleDidShowCompletionItem(O,j,Y){}handlePartialAccept(O,j,Y){}}class he extends we{constructor(O,j,Y,te){super(),this._extension=O,this._documents=j,this._provider=Y,this._commands=te,this._references=new fe,this._isAdditionsProposedApiEnabled=(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,j,Y,te){const be=this._documents.getDocument(O),ye=l.Position.to(j),me=await this._provider.provideInlineCompletionItems(be,ye,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:l.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[Y.triggerKind]},te);if(!me||te.isCancellationRequested)return;const ke=Array.isArray(me)?me:me.items,Pe=this._isAdditionsProposedApiEnabled?Array.isArray(me)?[]:me.commands||[]:[],Be=this._isAdditionsProposedApiEnabled&&!Array.isArray(me)?me.suppressSuggestions:void 0,$e=this._isAdditionsProposedApiEnabled&&!Array.isArray(me)?me.enableForwardStability:void 0;let et;return{pid:this._references.createReferenceId({dispose(){et?.dispose()},items:ke}),items:ke.map((Ye,nt)=>{let ct;Ye.command&&(et||(et=new C.DisposableStore),ct=this._commands.toInternal(Ye.command,et));const Fe=Ye.insertText;return{insertText:typeof Fe=="string"?Fe:{snippet:Fe.value},filterText:Ye.filterText,range:Ye.range?l.Range.from(Ye.range):void 0,command:ct,idx:nt,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:Pe.map(Ye=>(et||(et=new C.DisposableStore),this._commands.toInternal(Ye,et))),suppressSuggestions:Be,enableForwardStability:$e}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,j,Y){const te=this._references.get(O)?.items[j];te&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(te,Y)}handlePartialAccept(O,j,Y){const te=this._references.get(O)?.items[j];te&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(te,Y)}}class fe{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const j=this._idPool++;return this._references.set(j,O),j}disposeReferenceId(O){const j=this._references.get(O);return this._references.delete(O),j}get(O){return this._references.get(O)}}class V{constructor(O,j){this._documents=O,this._provider=j,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(O,j,Y,te){const be=this._documents.getDocument(O),ye=l.Position.to(j),me=this.reviveContext(Y),ke=await this._provider.provideSignatureHelp(be,ye,te,me);if(ke){const Pe=this._cache.add([ke]);return{...l.SignatureHelp.from(ke),id:Pe}}}reviveContext(O){let j;if(O.activeSignatureHelp){const Y=l.SignatureHelp.to(O.activeSignatureHelp),te=this._cache.get(O.activeSignatureHelp.id,0);te?(j=te,j.activeSignature=Y.activeSignature,j.activeParameter=Y.activeParameter):j=Y}return{...O,activeSignatureHelp:j}}releaseSignatureHelp(O){this._cache.delete(O)}}class x{constructor(O,j,Y,te,be){this._documents=O,this._commands=j,this._provider=Y,this._logService=te,this._extension=be,this._cache=new d.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,j,Y){const te=this._documents.getDocument(O),be=l.Range.to(j),ye=await this._provider.provideInlayHints(te,be,Y);if(!Array.isArray(ye)||ye.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${j}`);return}if(Y.isCancellationRequested)return;const me=this._cache.add(ye);this._disposables.set(me,new C.DisposableStore);const ke={hints:[],cacheId:me};for(let Pe=0;Pe<ye.length;Pe++)this._isValidInlayHint(ye[Pe],be)&&ke.hints.push(this._convertInlayHint(ye[Pe],[me,Pe]));return this._logService.trace(`[InlayHints] ${ke.hints.length} inlay hints from '${this._extension.identifier.value}' for ${j}`),ke}async resolveInlayHint(O,j){if(typeof this._provider.resolveInlayHint!="function")return;const Y=this._cache.get(...O);if(!Y)return;const te=await this._provider.resolveInlayHint(Y,j);if(te&&this._isValidInlayHint(te))return this._convertInlayHint(te,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,j){return O.label.length===0||Array.isArray(O.label)&&O.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(j&&!j.contains(O.position))}_convertInlayHint(O,j){const Y=this._disposables.get(j[0]);if(!Y)throw Error("DisposableStore is missing...");const te={label:"",cacheId:j,tooltip:l.MarkdownString.fromStrict(O.tooltip),position:l.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(l.TextEdit.from),kind:O.kind&&l.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?te.label=O.label:te.label=O.label.map(be=>{const ye={label:be.value};return ye.tooltip=l.MarkdownString.fromStrict(be.tooltip),R.Location.isLocation(be.location)&&(ye.location=l.location.from(be.location)),be.command&&(ye.command=this._commands.toInternal(be.command,Y)),ye}),te}}class Z{constructor(O,j){this._documents=O,this._provider=j,this._cache=new d.Cache("DocumentLink")}async provideLinks(O,j){const Y=this._documents.getDocument(O),te=await this._provider.provideDocumentLinks(Y,j);if(!(!Array.isArray(te)||te.length===0)&&!j.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:te.filter(Z._validateLink).map(l.DocumentLink.from)};{const be=this._cache.add(te),ye={links:[],cacheId:be};for(let me=0;me<te.length;me++){if(!Z._validateLink(te[me]))continue;const ke=l.DocumentLink.from(te[me]);ke.cacheId=[be,me],ye.links.push(ke)}return ye}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,j){if(typeof this._provider.resolveDocumentLink!="function")return;const Y=this._cache.get(...O);if(!Y)return;const te=await this._provider.resolveDocumentLink(Y,j);if(!(!te||!Z._validateLink(te)))return l.DocumentLink.from(te)}releaseLinks(O){this._cache.delete(O)}}class pe{constructor(O,j){this._documents=O,this._provider=j}async provideColors(O,j){const Y=this._documents.getDocument(O),te=await this._provider.provideDocumentColors(Y,j);return Array.isArray(te)?te.map(ye=>({color:l.Color.from(ye.color),range:l.Range.from(ye.range)})):[]}async provideColorPresentations(O,j,Y){const te=this._documents.getDocument(O),be=l.Range.to(j.range),ye=l.Color.to(j.color),me=await this._provider.provideColorPresentations(ye,{document:te,range:be},Y);if(Array.isArray(me))return me.map(l.ColorPresentation.from)}}class _e{constructor(O,j){this._documents=O,this._provider=j}async provideFoldingRanges(O,j,Y){const te=this._documents.getDocument(O),be=await this._provider.provideFoldingRanges(te,j,Y);if(Array.isArray(be))return be.map(l.FoldingRange.from)}}class re{constructor(O,j,Y){this._documents=O,this._provider=j,this._logService=Y}async provideSelectionRanges(O,j,Y){const te=this._documents.getDocument(O),be=j.map(l.Position.to),ye=await this._provider.provideSelectionRanges(te,be,Y);if(!(0,L.isNonEmptyArray)(ye))return[];if(ye.length!==be.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let ke=0;ke<be.length;ke++){const Pe=[];me.push(Pe);let Be=be[ke],$e=ye[ke];for(;;){if(!$e.range.contains(Be))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(l.SelectionRange.from($e)),!$e.parent)break;Be=$e.range,$e=$e.parent}}return me}}class ne{constructor(O,j){this._documents=O,this._provider=j,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(O,j,Y){const te=this._documents.getDocument(O),be=l.Position.to(j),ye=await this._provider.prepareCallHierarchy(te,be,Y);if(!ye)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(ye)?ye.map(ke=>this._cacheAndConvertItem(me,ke)):[this._cacheAndConvertItem(me,ye)]}async provideCallsTo(O,j,Y){const te=this._itemFromCache(O,j);if(!te)throw new Error("missing call hierarchy item");const be=await this._provider.provideCallHierarchyIncomingCalls(te,Y);if(be)return be.map(ye=>({from:this._cacheAndConvertItem(O,ye.from),fromRanges:ye.fromRanges.map(me=>l.Range.from(me))}))}async provideCallsFrom(O,j,Y){const te=this._itemFromCache(O,j);if(!te)throw new Error("missing call hierarchy item");const be=await this._provider.provideCallHierarchyOutgoingCalls(te,Y);if(be)return be.map(ye=>({to:this._cacheAndConvertItem(O,ye.to),fromRanges:ye.fromRanges.map(me=>l.Range.from(me))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,j){const Y=this._cache.get(O),te=l.CallHierarchyItem.from(j,O,Y.size.toString(36));return Y.set(te._itemId,j),te}_itemFromCache(O,j){return this._cache.get(O)?.get(j)}}class de{constructor(O,j){this._documents=O,this._provider=j,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(O,j,Y){const te=this._documents.getDocument(O),be=l.Position.to(j),ye=await this._provider.prepareTypeHierarchy(te,be,Y);if(!ye)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(ye)?ye.map(ke=>this._cacheAndConvertItem(me,ke)):[this._cacheAndConvertItem(me,ye)]}async provideSupertypes(O,j,Y){const te=this._itemFromCache(O,j);if(!te)throw new Error("missing type hierarchy item");const be=await this._provider.provideTypeHierarchySupertypes(te,Y);if(be)return be.map(ye=>this._cacheAndConvertItem(O,ye))}async provideSubtypes(O,j,Y){const te=this._itemFromCache(O,j);if(!te)throw new Error("missing type hierarchy item");const be=await this._provider.provideTypeHierarchySubtypes(te,Y);if(be)return be.map(ye=>this._cacheAndConvertItem(O,ye))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,j){const Y=this._cache.get(O),te=l.TypeHierarchyItem.from(j,O,Y.size.toString(36));return Y.set(te._itemId,j),te}_itemFromCache(O,j){return this._cache.get(O)?.get(j)}}class ee{constructor(O,j,Y,te,be){this._proxy=O,this._documents=j,this._provider=Y,this._handle=te,this._extension=be}async provideDocumentOnDropEdits(O,j,Y,te,be){const ye=this._documents.getDocument(j),me=l.Position.to(Y),ke=l.DataTransfer.toDataTransfer(te,async Be=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,Be)).buffer),Pe=await this._provider.provideDocumentDropEdits(ye,me,ke,be);if(Pe)return{label:Pe.label??(0,t.localize)(0,null,this._extension.displayName||this._extension.name),insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?l.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class ce{constructor(O,j){this.adapter=O,this.extension=j}}class le{constructor(O,j,Y,te,be,ye,me,ke){this._uriTransformer=j,this._documents=Y,this._commands=te,this._diagnostics=be,this._logService=ye,this._apiDeprecation=me,this._extensionTelemetry=ke,this._adapter=new Map,this._proxy=O.getProxy(P.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(O,j){return l.DocumentSelector.from(O,this._uriTransformer,j)}_createDisposable(O){return new R.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return le._handlePool++}async _withAdapter(O,j,Y,te,be,ye=!1){const me=this._adapter.get(O);if(!me||!(me.adapter instanceof j))return te;const ke=Date.now();ye||this._logService.trace(`[${me.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const Pe=Y(me.adapter,me.extension);return Promise.resolve(Pe).catch(Be=>{(0,S.isCancellationError)(Be)||(this._logService.error(`[${me.extension.identifier.value}] provider FAILED`),this._logService.error(Be),this._extensionTelemetry.onExtensionError(me.extension.identifier,Be))}).finally(()=>{ye||this._logService.trace(`[${me.extension.identifier.value}] provider DONE after ${Date.now()-ke}ms`)}),k.CancellationToken.isCancellationToken(be)?(0,E.raceCancellationError)(Pe,be):Pe}_addNewAdapter(O,j){const Y=this._nextHandle();return this._adapter.set(Y,new ce(O,j)),Y}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,j,Y,te){const be=this._addNewAdapter(new s(this._documents,Y),O),ye=te&&te.label||le._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(be,this._transformDocumentSelector(j,O),ye),this._createDisposable(be)}$provideDocumentSymbols(O,j,Y){return this._withAdapter(O,s,te=>te.provideDocumentSymbols(o.URI.revive(j),Y),void 0,Y)}registerCodeLensProvider(O,j,Y){const te=this._nextHandle(),be=typeof Y.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(te,new ce(new r(this._documents,this._commands.converter,Y),O)),this._proxy.$registerCodeLensSupport(te,this._transformDocumentSelector(j,O),be);let ye=this._createDisposable(te);if(be!==void 0){const me=Y.onDidChangeCodeLenses(ke=>this._proxy.$emitCodeLensEvent(be));ye=R.Disposable.from(ye,me)}return ye}$provideCodeLenses(O,j,Y){return this._withAdapter(O,r,te=>te.provideCodeLenses(o.URI.revive(j),Y),void 0,Y)}$resolveCodeLens(O,j,Y){return this._withAdapter(O,r,te=>te.resolveCodeLens(j,Y),void 0,void 0)}$releaseCodeLenses(O,j){this._withAdapter(O,r,Y=>Promise.resolve(Y.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(O,j,Y){const te=this._addNewAdapter(new v(this._documents,Y),O);return this._proxy.$registerDefinitionSupport(te,this._transformDocumentSelector(j,O)),this._createDisposable(te)}$provideDefinition(O,j,Y,te){return this._withAdapter(O,v,be=>be.provideDefinition(o.URI.revive(j),Y,te),[],te)}registerDeclarationProvider(O,j,Y){const te=this._addNewAdapter(new _(this._documents,Y),O);return this._proxy.$registerDeclarationSupport(te,this._transformDocumentSelector(j,O)),this._createDisposable(te)}$provideDeclaration(O,j,Y,te){return this._withAdapter(O,_,be=>be.provideDeclaration(o.URI.revive(j),Y,te),[],te)}registerImplementationProvider(O,j,Y){const te=this._addNewAdapter(new c(this._documents,Y),O);return this._proxy.$registerImplementationSupport(te,this._transformDocumentSelector(j,O)),this._createDisposable(te)}$provideImplementation(O,j,Y,te){return this._withAdapter(O,c,be=>be.provideImplementation(o.URI.revive(j),Y,te),[],te)}registerTypeDefinitionProvider(O,j,Y){const te=this._addNewAdapter(new u(this._documents,Y),O);return this._proxy.$registerTypeDefinitionSupport(te,this._transformDocumentSelector(j,O)),this._createDisposable(te)}$provideTypeDefinition(O,j,Y,te){return this._withAdapter(O,u,be=>be.provideTypeDefinition(o.URI.revive(j),Y,te),[],te)}registerHoverProvider(O,j,Y,te){const be=this._addNewAdapter(new m(this._documents,Y),O);return this._proxy.$registerHoverProvider(be,this._transformDocumentSelector(j,O)),this._createDisposable(be)}$provideHover(O,j,Y,te){return this._withAdapter(O,m,be=>be.provideHover(o.URI.revive(j),Y,te),void 0,te)}registerEvaluatableExpressionProvider(O,j,Y,te){const be=this._addNewAdapter(new f(this._documents,Y),O);return this._proxy.$registerEvaluatableExpressionProvider(be,this._transformDocumentSelector(j,O)),this._createDisposable(be)}$provideEvaluatableExpression(O,j,Y,te){return this._withAdapter(O,f,be=>be.provideEvaluatableExpression(o.URI.revive(j),Y,te),void 0,te)}registerInlineValuesProvider(O,j,Y,te){const be=typeof Y.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ye=this._addNewAdapter(new n(this._documents,Y),O);this._proxy.$registerInlineValuesProvider(ye,this._transformDocumentSelector(j,O),be);let me=this._createDisposable(ye);if(be!==void 0){const ke=Y.onDidChangeInlineValues(Pe=>this._proxy.$emitInlineValuesEvent(be));me=R.Disposable.from(me,ke)}return me}$provideInlineValues(O,j,Y,te,be){return this._withAdapter(O,n,ye=>ye.provideInlineValues(o.URI.revive(j),Y,te,be),void 0,be)}registerDocumentHighlightProvider(O,j,Y){const te=this._addNewAdapter(new D(this._documents,Y),O);return this._proxy.$registerDocumentHighlightProvider(te,this._transformDocumentSelector(j,O)),this._createDisposable(te)}$provideDocumentHighlights(O,j,Y,te){return this._withAdapter(O,D,be=>be.provideDocumentHighlights(o.URI.revive(j),Y,te),void 0,te)}registerLinkedEditingRangeProvider(O,j,Y){const te=this._addNewAdapter(new M(this._documents,Y),O);return this._proxy.$registerLinkedEditingRangeProvider(te,this._transformDocumentSelector(j,O)),this._createDisposable(te)}$provideLinkedEditingRanges(O,j,Y,te){return this._withAdapter(O,M,async be=>{const ye=await be.provideLinkedEditingRanges(o.URI.revive(j),Y,te);if(ye)return{ranges:ye.ranges,wordPattern:ye.wordPattern?le._serializeRegExp(ye.wordPattern):void 0}},void 0,te)}registerReferenceProvider(O,j,Y){const te=this._addNewAdapter(new W(this._documents,Y),O);return this._proxy.$registerReferenceSupport(te,this._transformDocumentSelector(j,O)),this._createDisposable(te)}$provideReferences(O,j,Y,te,be){return this._withAdapter(O,W,ye=>ye.provideReferences(o.URI.revive(j),Y,te,be),void 0,be)}registerCodeActionProvider(O,j,Y,te){const be=new C.DisposableStore,ye=this._addNewAdapter(new $(this._documents,this._commands.converter,this._diagnostics,Y,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(ye,this._transformDocumentSelector(j,O),{providedKinds:te?.providedCodeActionKinds?.map(me=>me.value),documentation:te?.documentation?.map(me=>({kind:me.kind.value,command:this._commands.converter.toInternal(me.command,be)}))},le._extLabel(O),!!Y.resolveCodeAction),be.add(this._createDisposable(ye)),be}$provideCodeActions(O,j,Y,te,be){return this._withAdapter(O,$,ye=>ye.provideCodeActions(o.URI.revive(j),Y,te,be),void 0,be)}$resolveCodeAction(O,j,Y){return this._withAdapter(O,$,te=>te.resolveCodeAction(j,Y),{},void 0)}$releaseCodeActions(O,j){this._withAdapter(O,$,Y=>Promise.resolve(Y.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(O,j,Y){const te=this._addNewAdapter(new U(this._documents,Y),O);return this._proxy.$registerDocumentFormattingSupport(te,this._transformDocumentSelector(j,O),O.identifier,O.displayName||O.name),this._createDisposable(te)}$provideDocumentFormattingEdits(O,j,Y,te){return this._withAdapter(O,U,be=>be.provideDocumentFormattingEdits(o.URI.revive(j),Y,te),void 0,te)}registerDocumentRangeFormattingEditProvider(O,j,Y){const te=typeof Y.provideDocumentRangesFormattingEdits=="function";te&&(0,p.checkProposedApiEnabled)(O,"formatMultipleRanges");const be=this._addNewAdapter(new q(this._documents,Y),O);return this._proxy.$registerRangeFormattingSupport(be,this._transformDocumentSelector(j,O),O.identifier,O.displayName||O.name,te),this._createDisposable(be)}$provideDocumentRangeFormattingEdits(O,j,Y,te,be){return this._withAdapter(O,q,ye=>ye.provideDocumentRangeFormattingEdits(o.URI.revive(j),Y,te,be),void 0,be)}$provideDocumentRangesFormattingEdits(O,j,Y,te,be){return this._withAdapter(O,q,ye=>ye.provideDocumentRangesFormattingEdits(o.URI.revive(j),Y,te,be),void 0,be)}registerOnTypeFormattingEditProvider(O,j,Y,te){const be=this._addNewAdapter(new F(this._documents,Y),O);return this._proxy.$registerOnTypeFormattingSupport(be,this._transformDocumentSelector(j,O),te,O.identifier),this._createDisposable(be)}$provideOnTypeFormattingEdits(O,j,Y,te,be,ye){return this._withAdapter(O,F,me=>me.provideOnTypeFormattingEdits(o.URI.revive(j),Y,te,be,ye),void 0,ye)}registerWorkspaceSymbolProvider(O,j){const Y=this._addNewAdapter(new B(j,this._logService),O);return this._proxy.$registerNavigateTypeSupport(Y,typeof j.resolveWorkspaceSymbol=="function"),this._createDisposable(Y)}$provideWorkspaceSymbols(O,j,Y){return this._withAdapter(O,B,te=>te.provideWorkspaceSymbols(j,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(O,j,Y){return this._withAdapter(O,B,te=>te.resolveWorkspaceSymbol(j,Y),void 0,void 0)}$releaseWorkspaceSymbols(O,j){this._withAdapter(O,B,Y=>Y.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(O,j,Y){const te=this._addNewAdapter(new Q(this._documents,Y,this._logService),O);return this._proxy.$registerRenameSupport(te,this._transformDocumentSelector(j,O),Q.supportsResolving(Y)),this._createDisposable(te)}$provideRenameEdits(O,j,Y,te,be){return this._withAdapter(O,Q,ye=>ye.provideRenameEdits(o.URI.revive(j),Y,te,be),void 0,be)}$resolveRenameLocation(O,j,Y,te){return this._withAdapter(O,Q,be=>be.resolveRenameLocation(o.URI.revive(j),Y,te),void 0,te)}registerDocumentSemanticTokensProvider(O,j,Y,te){const be=this._addNewAdapter(new X(this._documents,Y),O),ye=typeof Y.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(be,this._transformDocumentSelector(j,O),te,ye);let me=this._createDisposable(be);if(ye){const ke=Y.onDidChangeSemanticTokens(Pe=>this._proxy.$emitDocumentSemanticTokensEvent(ye));me=R.Disposable.from(me,ke)}return me}$provideDocumentSemanticTokens(O,j,Y,te){return this._withAdapter(O,X,be=>be.provideDocumentSemanticTokens(o.URI.revive(j),Y,te),null,te)}$releaseDocumentSemanticTokens(O,j){this._withAdapter(O,X,Y=>Y.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,j,Y,te){const be=this._addNewAdapter(new ie(this._documents,Y),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(be,this._transformDocumentSelector(j,O),te),this._createDisposable(be)}$provideDocumentRangeSemanticTokens(O,j,Y,te){return this._withAdapter(O,ie,be=>be.provideDocumentRangeSemanticTokens(o.URI.revive(j),Y,te),null,te)}registerCompletionItemProvider(O,j,Y,te){const be=this._addNewAdapter(new ae(this._documents,this._commands.converter,Y,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(be,this._transformDocumentSelector(j,O),te,ae.supportsResolving(Y),`${O.identifier.value}(${te.join("")})`),this._createDisposable(be)}$provideCompletionItems(O,j,Y,te,be){return this._withAdapter(O,ae,ye=>ye.provideCompletionItems(o.URI.revive(j),Y,te,be),void 0,be)}$resolveCompletionItem(O,j,Y){return this._withAdapter(O,ae,te=>te.resolveCompletionItem(j,Y),void 0,Y)}$releaseCompletionItems(O,j){this._withAdapter(O,ae,Y=>Y.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(O,j,Y){const te=new he(O,this._documents,Y,this._commands.converter),be=this._addNewAdapter(te,O);return this._proxy.$registerInlineCompletionsSupport(be,this._transformDocumentSelector(j,O),te.supportsHandleEvents),this._createDisposable(be)}$provideInlineCompletions(O,j,Y,te,be){return this._withAdapter(O,we,ye=>ye.provideInlineCompletions(o.URI.revive(j),Y,te,be),void 0,be)}$handleInlineCompletionDidShow(O,j,Y,te){this._withAdapter(O,we,async be=>{be.handleDidShowCompletionItem(j,Y,te)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,j,Y,te){this._withAdapter(O,we,async be=>{be.handlePartialAccept(j,Y,te)},void 0,void 0)}$freeInlineCompletionsList(O,j){this._withAdapter(O,we,async Y=>{Y.disposeCompletions(j)},void 0,void 0)}registerSignatureHelpProvider(O,j,Y,te){const be=Array.isArray(te)?{triggerCharacters:te,retriggerCharacters:[]}:te,ye=this._addNewAdapter(new V(this._documents,Y),O);return this._proxy.$registerSignatureHelpProvider(ye,this._transformDocumentSelector(j,O),be),this._createDisposable(ye)}$provideSignatureHelp(O,j,Y,te,be){return this._withAdapter(O,V,ye=>ye.provideSignatureHelp(o.URI.revive(j),Y,te,be),void 0,be)}$releaseSignatureHelp(O,j){this._withAdapter(O,V,Y=>Y.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(O,j,Y){const te=typeof Y.onDidChangeInlayHints=="function"?this._nextHandle():void 0,be=this._addNewAdapter(new x(this._documents,this._commands.converter,Y,this._logService,O),O);this._proxy.$registerInlayHintsProvider(be,this._transformDocumentSelector(j,O),typeof Y.resolveInlayHint=="function",te,le._extLabel(O));let ye=this._createDisposable(be);if(te!==void 0){const me=Y.onDidChangeInlayHints(ke=>this._proxy.$emitInlayHintsEvent(te));ye=R.Disposable.from(ye,me)}return ye}$provideInlayHints(O,j,Y,te){return this._withAdapter(O,x,be=>be.provideInlayHints(o.URI.revive(j),Y,te),void 0,te)}$resolveInlayHint(O,j,Y){return this._withAdapter(O,x,te=>te.resolveInlayHint(j,Y),void 0,Y)}$releaseInlayHints(O,j){this._withAdapter(O,x,Y=>Y.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(O,j,Y){const te=this._addNewAdapter(new Z(this._documents,Y),O);return this._proxy.$registerDocumentLinkProvider(te,this._transformDocumentSelector(j,O),typeof Y.resolveDocumentLink=="function"),this._createDisposable(te)}$provideDocumentLinks(O,j,Y){return this._withAdapter(O,Z,te=>te.provideLinks(o.URI.revive(j),Y),void 0,Y,j.scheme==="output")}$resolveDocumentLink(O,j,Y){return this._withAdapter(O,Z,te=>te.resolveLink(j,Y),void 0,void 0,!0)}$releaseDocumentLinks(O,j){this._withAdapter(O,Z,Y=>Y.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(O,j,Y){const te=this._addNewAdapter(new pe(this._documents,Y),O);return this._proxy.$registerDocumentColorProvider(te,this._transformDocumentSelector(j,O)),this._createDisposable(te)}$provideDocumentColors(O,j,Y){return this._withAdapter(O,pe,te=>te.provideColors(o.URI.revive(j),Y),[],Y)}$provideColorPresentations(O,j,Y,te){return this._withAdapter(O,pe,be=>be.provideColorPresentations(o.URI.revive(j),Y,te),void 0,te)}registerFoldingRangeProvider(O,j,Y){const te=this._nextHandle(),be=typeof Y.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(te,new ce(new _e(this._documents,Y),O)),this._proxy.$registerFoldingRangeProvider(te,this._transformDocumentSelector(j,O),O.identifier,be);let ye=this._createDisposable(te);if(be!==void 0){const me=Y.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(be));ye=R.Disposable.from(ye,me)}return ye}$provideFoldingRanges(O,j,Y,te){return this._withAdapter(O,_e,be=>be.provideFoldingRanges(o.URI.revive(j),Y,te),void 0,te)}registerSelectionRangeProvider(O,j,Y){const te=this._addNewAdapter(new re(this._documents,Y,this._logService),O);return this._proxy.$registerSelectionRangeProvider(te,this._transformDocumentSelector(j,O)),this._createDisposable(te)}$provideSelectionRanges(O,j,Y,te){return this._withAdapter(O,re,be=>be.provideSelectionRanges(o.URI.revive(j),Y,te),[],te)}registerCallHierarchyProvider(O,j,Y){const te=this._addNewAdapter(new ne(this._documents,Y),O);return this._proxy.$registerCallHierarchyProvider(te,this._transformDocumentSelector(j,O)),this._createDisposable(te)}$prepareCallHierarchy(O,j,Y,te){return this._withAdapter(O,ne,be=>Promise.resolve(be.prepareSession(o.URI.revive(j),Y,te)),void 0,te)}$provideCallHierarchyIncomingCalls(O,j,Y,te){return this._withAdapter(O,ne,be=>be.provideCallsTo(j,Y,te),void 0,te)}$provideCallHierarchyOutgoingCalls(O,j,Y,te){return this._withAdapter(O,ne,be=>be.provideCallsFrom(j,Y,te),void 0,te)}$releaseCallHierarchy(O,j){this._withAdapter(O,ne,Y=>Promise.resolve(Y.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(O,j,Y){const te=this._addNewAdapter(new de(this._documents,Y),O);return this._proxy.$registerTypeHierarchyProvider(te,this._transformDocumentSelector(j,O)),this._createDisposable(te)}$prepareTypeHierarchy(O,j,Y,te){return this._withAdapter(O,de,be=>Promise.resolve(be.prepareSession(o.URI.revive(j),Y,te)),void 0,te)}$provideTypeHierarchySupertypes(O,j,Y,te){return this._withAdapter(O,de,be=>be.provideSupertypes(j,Y,te),void 0,te)}$provideTypeHierarchySubtypes(O,j,Y,te){return this._withAdapter(O,de,be=>be.provideSubtypes(j,Y,te),void 0,te)}$releaseTypeHierarchy(O,j){this._withAdapter(O,de,Y=>Promise.resolve(Y.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(O,j,Y,te){const be=this._nextHandle();return this._adapter.set(be,new ce(new ee(this._proxy,this._documents,Y,be,O),O)),this._proxy.$registerDocumentOnDropEditProvider(be,this._transformDocumentSelector(j,O),O.identifier,(0,p.isProposedApiEnabled)(O,"dropMetadata")?te:void 0),this._createDisposable(be)}$provideDocumentOnDropEdits(O,j,Y,te,be,ye){return this._withAdapter(O,ee,me=>Promise.resolve(me.provideDocumentOnDropEdits(j,o.URI.revive(Y),te,be,ye)),void 0,void 0)}registerDocumentPasteEditProvider(O,j,Y,te){const be=this._nextHandle();return this._adapter.set(be,new ce(new N(this._proxy,this._documents,Y,be),O)),this._proxy.$registerPasteEditProvider(be,this._transformDocumentSelector(j,O),!!Y.prepareDocumentPaste,te.pasteMimeTypes),this._createDisposable(be)}$prepareDocumentPaste(O,j,Y,te,be){return this._withAdapter(O,N,ye=>ye.prepareDocumentPaste(o.URI.revive(j),Y,te,be),void 0,be)}$providePasteEdits(O,j,Y,te,be,ye){return this._withAdapter(O,N,me=>me.providePasteEdits(j,o.URI.revive(Y),te,be,ye),void 0,ye)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,y.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:le._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:le._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?le._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?le._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:le._serializeRegExp(O.beforeText),afterText:O.afterText?le._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?le._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(le._serializeOnEnterRule)}setLanguageConfiguration(O,j,Y){const{wordPattern:te}=Y;if(te&&(0,y.regExpLeadsToEndlessLoop)(te))throw new Error(`Invalid language configuration: wordPattern '${te}' is not allowed to match the empty string.`);te?this._documents.setWordDefinitionFor(j,te):this._documents.setWordDefinitionFor(j,void 0),Y.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),Y.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const be=this._nextHandle(),ye={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?le._serializeRegExp(Y.wordPattern):void 0,indentationRules:Y.indentationRules?le._serializeIndentationRule(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?le._serializeOnEnterRules(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport};return this._proxy.$setLanguageConfiguration(be,j,ye),this._createDisposable(be)}$setWordDefinitions(O){for(const j of O)this._documents.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.ExtHostLanguageFeatures=le,le._handlePool=0}),define(De[279],Ie([1,0,5,11,7,38,19,6]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,I,w,k){this._documents=I,this._commands=w,this._uriTransformer=k,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,I){await this._proxy.$changeLanguage(L,I);const w=this._documents.getDocumentData(L);if(!w)throw new Error(`document '${L.toString()}' NOT found`);return w.document}async tokenAtPosition(L,I){const w=L.version,k=A.Position.from(I),C=await this._proxy.$tokensAtPosition(L.uri,k),b={type:l.StandardTokenType.Other,range:L.getWordRangeAtPosition(I)??new l.Range(I.line,I.character,I.line,I.character)};if(!C)return b;const i={range:A.Range.to(C.range),type:A.TokenType.to(C.type)};return!i.range.contains(I)||w!==L.version?b:i}createLanguageStatusItem(L,I,w){const k=this._handlePool++,C=this._proxy,b=this._ids,i=`${L.identifier.value}/${I}`;if(b.has(i))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);b.add(i);const d={selector:w,id:I,name:L.displayName??L.name,severity:l.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let h;const S=new P.DisposableStore,E=()=>{h?.dispose(),h=(0,T.disposableTimeout)(()=>{S.clear(),this._proxy.$setLanguageStatus(k,{id:i,name:d.name??L.displayName??L.name,source:L.displayName??L.name,selector:A.DocumentSelector.from(d.selector,this._uriTransformer),label:d.text,detail:d.detail??"",severity:d.severity===l.LanguageStatusSeverity.Error?R.default.Error:d.severity===l.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:d.command&&this._commands.toInternal(d.command,S),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},p={dispose(){S.dispose(),h?.dispose(),C.$removeLanguageStatus(k),b.delete(i)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,E()},get selector(){return d.selector},set selector(t){d.selector=t,E()},get text(){return d.text},set text(t){d.text=t,E()},get detail(){return d.detail},set detail(t){d.detail=t,E()},get severity(){return d.severity},set severity(t){d.severity=t,E()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,E()},get command(){return d.command},set command(t){d.command=t,E()},get busy(){return d.busy},set busy(t){d.busy=t,E()}};return E(),p}}e.ExtHostLanguages=y}),define(De[98],Ie([1,0,14,9,2,4,17,5,26,20]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=e.ExtHostLocalizationService=class{constructor(w,k,C){this.logService=C,this.bundleCache=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadLocalization),this.currentLanguage=w.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===o.LANGUAGE_DEFAULT}getMessage(w,k){const{message:C,args:b,comment:i}=k;if(this.isDefaultLanguage)return(0,A.format2)(C,b??{});let d=C;i&&i.length>0&&(d+=`/${Array.isArray(i)?i.join(""):i}`);const h=this.bundleCache.get(w)?.contents[d];return h||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,A.format2)(h??C,b??{})}getBundle(w){return this.bundleCache.get(w)?.contents}getBundleUri(w){return this.bundleCache.get(w)?.uri}async initializeLocalizedMessages(w){if(this.isDefaultLanguage||!w.l10n&&!w.isBuiltin||this.bundleCache.has(w.identifier.value))return;let k;const C=await this.getBundleLocation(w);if(!C){this.logService.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const b=await this._proxy.$fetchBundleContents(C),i=JSON.parse(b);k=w.isBuiltin?i.contents?.bundle:i}catch(b){this.logService.error(`Failed to load translations for ${w.identifier.value} from ${C}: ${b.message}`);return}k&&this.bundleCache.set(w.identifier.value,{contents:k,uri:C})}async getBundleLocation(w){if(w.isBuiltin){const k=await this._proxy.$fetchBuiltInBundleUri(w.identifier.value,this.currentLanguage);return l.URI.revive(k)}return w.l10n?l.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=L=Ve([ze(0,y.IExtHostInitDataService),ze(1,g.IExtHostRpcService),ze(2,T.ILogService)],L),e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(De[141],Ie([1,0,17,5,26,20,2,71]),function(oe,e,o,A,l,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=e.ExtHostLoggerService=class extends o.AbstractLoggerService{constructor(I,w){super(w.logLevel,w.logsLocation,w.loggers.map(k=>(0,P.revive)(k))),this._proxy=I.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(I,w){w?this.setLogLevel(T.URI.revive(w),I):this.setLogLevel(I)}setVisibility(I,w){super.setVisibility(I,w),this._proxy.$setVisibility(I,w)}doCreateLogger(I,w,k){return new g(this._proxy,I,w,k)}};e.ExtHostLoggerService=y=Ve([ze(0,R.IExtHostRpcService),ze(1,l.IExtHostInitDataService)],y);class g extends o.AbstractMessageLogger{constructor(I,w,k,C){super(C?.logLevel==="always"),this.proxy=I,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(k),this.proxy.$createLogger(w,C).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,w){const k=[[I,w]];this.isLoggerCreated?this.doLog(k):this.buffer.push(...k)}doLog(I){this.proxy.$log(this.file,I)}flush(){this.proxy.$flush(this.file)}}}),define(De[280],Ie([1,0,5,17,27]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(P){return P&&P.title}let T=e.ExtHostMessageService=class{constructor(y,g){this._logService=g,this._proxy=y.getProxy(o.MainContext.MainThreadMessageService)}showMessage(y,g,L,I,w){const k={source:{identifier:y.identifier,label:y.displayName||y.name}};let C;typeof I=="string"||R(I)?C=[I,...w]:(k.modal=I?.modal,k.useCustom=I?.useCustom,k.detail=I?.detail,C=w),k.useCustom&&(0,l.checkProposedApiEnabled)(y,"resolvers");const b=[];for(let i=0;i<C.length;i++){const d=C[i];if(typeof d=="string")b.push({title:d,handle:i,isCloseAffordance:!1});else if(typeof d=="object"){const{title:h,isCloseAffordance:S}=d;b.push({title:h,isCloseAffordance:!!S,handle:i})}else this._logService.warn("Invalid message item:",d)}return this._proxy.$showMessage(g,L,k,b).then(i=>{if(typeof i=="number")return C[i]})}};e.ExtHostMessageService=T=Ve([ze(1,A.ILogService)],T)}),define(De[281],Ie([1,0,22,3,6,28,9,10,2,76,5,41,11,7,60,251,137,8]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(E=>E.apiEditor)}constructor(E,p,t,s){this._textDocumentsAndEditors=t,this._textDocuments=s,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new g.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=E.getProxy(L.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=E.getProxy(L.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=E.getProxy(L.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const a=r.notebookEditor?.notebookUri,v=r.cell.handle,c=this._documents.get(a)?.getCell(v);if(c)return c.apiCell}if(r&&r.$mid===14){const a=r.uri,v=this._documents.get(a);if(v)return v.apiNotebook}return r}}),h._registerApiCommands(p)}getEditorById(E){const p=this._editors.get(E);if(!p)throw new Error(`unknown text editor: ${E}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(E){for(const[p,t]of this._editors)if(t.apiEditor===E)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(E,p){const t=this._documents.get(E);if(!t&&!p)throw new Error(`NO notebook document for '${E}'`);return t}static _convertNotebookRegistrationData(E,p){if(!p)return;const t=p.filenamePattern.map(s=>w.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(p.filenamePattern&&!t){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:p.displayName,filenamePattern:t,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,p,t){const s=h._notebookStatusBarItemProviderHandlePool++,r=typeof t.onDidChangeCellStatusBarItems=="function"?h._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,t),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,r,p);let a;return r!==void 0&&(a=t.onDidChangeCellStatusBarItems(v=>this._notebookProxy.$emitCellStatusBarEvent(r))),new k.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,r),a?.dispose()})}async createNotebookDocument(E){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:E.viewType,content:E.content&&w.NotebookData.from(E.content)});return y.URI.revive(p)}async openNotebookDocument(E){const p=this._documents.get(E);if(p)return p.apiNotebook;const t=await this._notebookDocumentsProxy.$tryOpenNotebook(E),s=this._documents.get(y.URI.revive(t));return(0,P.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(E,p){y.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let t;typeof p=="object"?t={position:w.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(w.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:t={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(E.uri,E.notebookType,t),r=s&&this._editors.get(s)?.apiEditor;if(r)return r;throw s?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,p,t,s){const r=this._notebookStatusBarItemProviders.get(E),a=y.URI.revive(p),v=this._documents.get(a);if(!v||!r)return;const _=v.getCellFromIndex(t);if(!_)return;const c=await r.provideCellStatusBarItems(_.apiCell,s);if(!c)return;const u=new l.DisposableStore,m=this._statusBarCache.add([u]),n=(Array.isArray(c)?c:[c]).map(D=>w.NotebookStatusBarItem.from(D,this._commandsConverter,u));return{cacheId:m,items:n}}$releaseNotebookCellStatusBarItems(E){this._statusBarCache.delete(E)}registerNotebookSerializer(E,p,t,s,r){if((0,T.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,t),this._notebookProxy.$registerNotebookSerializer(a,{id:E.identifier,location:E.extensionLocation},p,w.NotebookDocumentContentOptions.from(s),h._convertNotebookRegistrationData(E,r)),(0,l.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(E,p,t){const s=this._notebookSerializer.get(E);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(p.buffer,t);return new C.SerializableObjectWithBuffers(w.NotebookData.from(r))}async $notebookToData(E,p,t){const s=this._notebookSerializer.get(E);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook(w.NotebookData.to(p.value),t);return o.VSBuffer.wrap(r)}_createExtHostEditor(E,p,t){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const s=new i.ExtHostNotebookEditor(p,this._notebookEditorsProxy,E,t.visibleRanges.map(w.NotebookRange.to),t.selections.map(w.NotebookRange.to),typeof t.viewColumn=="number"?w.ViewColumn.to(t.viewColumn):void 0);this._editors.set(p,s)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const t of E.value.removedDocuments){const s=y.URI.revive(t),r=this._documents.get(s);r&&(r.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===s.toString()&&this._editors.delete(a.id)}if(E.value.addedDocuments){const t=[];for(const s of E.value.addedDocuments){const r=y.URI.revive(s.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const a=new b.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,s);t.push(...s.cells.map(v=>b.ExtHostCell.asModelAddData(a.apiNotebook,v))),this._documents.get(r)?.dispose(),this._documents.set(r,a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:t}),this._onDidOpenNotebookDocument.fire(a.apiNotebook)}}if(E.value.addedEditors)for(const t of E.value.addedEditors){if(this._editors.has(t.id))return;const s=y.URI.revive(t.documentUri),r=this._documents.get(s);r&&this._createExtHostEditor(r,t.id,t)}const p=[];if(E.value.removedEditors)for(const t of E.value.removedEditors){const s=this._editors.get(t);s&&(this._editors.delete(t),this._activeNotebookEditor?.id===s.id&&(this._activeNotebookEditor=void 0),p.push(s))}if(E.value.visibleEditors){this._visibleNotebookEditors=E.value.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const t=new Set;this._visibleNotebookEditors.forEach(s=>t.add(s.id));for(const s of this._editors.values()){const r=t.has(s.id);s._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this._activeNotebookEditor=void 0:E.value.newActiveEditor&&(this._editors.get(E.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${E.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(E){const p=I.ApiCommandArgument.String.with("notebookType","A notebook type"),t=new I.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new I.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>o.VSBuffer.wrap(r))],new I.ApiCommandResult("Notebook Data",r=>w.NotebookData.to(r.value))),s=new I.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new I.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new C.SerializableObjectWithBuffers(w.NotebookData.from(r)))],new I.ApiCommandResult("Bytes",r=>r.buffer));E.registerApiCommand(t),E.registerApiCommand(s)}}e.ExtHostNotebookController=h,h._notebookStatusBarItemProviderHandlePool=0}),define(De[282],Ie([1,0,18,19,21,3,6,28,2,25,17,76,5,41,11,7,96,241,27,60]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let E=e.ExtHostNotebookKernels=class{constructor(c,u,m,f,n){this._initData=u,this._extHostNotebook=m,this._commands=f,this._logService=n,this._activeExecutions=new P.ResourceMap,this._activeNotebookExecutions=new P.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new I.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=c.getProxy(w.MainContext.MainThreadNotebookKernels);const D=new k.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new k.ApiCommandArgument("options","Select kernel options",M=>!0,M=>{if(M&&"notebookEditor"in M&&"id"in M){const W=this._extHostNotebook.getIdByEditor(M.notebookEditor);return{id:M.id,extension:M.extension,notebookEditorId:W}}else if(M&&"notebookEditor"in M){const W=this._extHostNotebook.getIdByEditor(M.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${M.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return M})],k.ApiCommandResult.Void);this._commands.registerApiCommand(D)}createNotebookController(c,u,m,f,n,D){for(const he of this._kernelData.values())if(he.controller.id===u&&g.ExtensionIdentifier.equals(c.identifier,he.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const M=this._handlePool++,W=this;this._logService.trace(`NotebookController[${M}], CREATED by ${c.identifier.value}, ${u}`);const $=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${c.identifier}'`);let N=!1;const U=new T.DisposableStore,q=new R.Emitter,F=new R.Emitter,B={id:v(c.identifier,u),notebookType:m,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:f||c.identifier.value,preloads:D?D.map(C.NotebookRendererScript.from):[]};let Q=n??$,J;this._proxy.$addKernel(M,B).catch(he=>{console.log(he),N=!0});let X=0;const ie=()=>{if(N)return;const he=++X;Promise.resolve().then(()=>{he===X&&this._proxy.$updateKernel(M,B)})},ae=new P.ResourceMap,we={get id(){return u},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:q.event,get label(){return B.label},set label(he){B.label=he??c.displayName??c.name,ie()},get detail(){return B.detail??""},set detail(he){B.detail=he,ie()},get description(){return B.description??""},set description(he){B.description=he,ie()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(he){B.supportedLanguages=he,ie()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(he){B.supportsExecutionOrder=he,ie()},get rendererScripts(){return B.preloads?B.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(he){Q=he??$},get interruptHandler(){return J},set interruptHandler(he){J=he,B.supportsInterrupt=!!he,ie()},createNotebookCellExecution(he){if(N)throw new Error("notebook controller is DISPOSED");if(!ae.has(he.notebook.uri))throw W._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(fe=>fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${he.notebook.uri.toString()}`);return W._createNotebookCellExecution(he,v(c.identifier,this.id))},createNotebookExecution(he){if((0,h.checkProposedApiEnabled)(c,"notebookExecution"),N)throw new Error("notebook controller is DISPOSED");if(!ae.has(he.uri))throw W._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(fe=>fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${he.uri.toString()}`);return W._createNotebookExecution(he,v(c.identifier,this.id))},dispose:()=>{N||(this._logService.trace(`NotebookController[${M}], DISPOSED`),N=!0,this._kernelData.delete(M),U.dispose(),q.dispose(),F.dispose(),this._proxy.$removeKernel(M))},updateNotebookAffinity(he,fe){fe===b.NotebookControllerAffinity2.Hidden&&(0,h.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),W._proxy.$updateNotebookPriority(M,he.uri,fe)},onDidReceiveMessage:F.event,postMessage(he,fe){return(0,h.checkProposedApiEnabled)(c,"notebookMessaging"),W._proxy.$postMessage(M,fe&&W._extHostNotebook.getIdByEditor(fe),he)},asWebviewUri(he){return(0,h.checkProposedApiEnabled)(c,"notebookMessaging"),(0,i.asWebviewUri)(he,W._initData.remote)}};return this._kernelData.set(M,{extensionId:c.identifier,controller:we,onDidReceiveMessage:F,onDidChangeSelection:q,associatedNotebooks:ae}),we}getIdByController(c){for(const[u,m]of this._kernelData)if(m.controller===c)return v(m.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,u){const m=this._kernelDetectionTaskHandlePool++,f=this;this._logService.trace(`NotebookControllerDetectionTask[${m}], CREATED by ${c.identifier.value}`),this._proxy.$addKernelDetectionTask(m,u);const n={dispose:()=>{this._kernelDetectionTask.delete(m),f._proxy.$removeKernelDetectionTask(m)}};return this._kernelDetectionTask.set(m,n),n}registerKernelSourceActionProvider(c,u,m){const f=this._kernelSourceActionProviderHandlePool++,n=typeof m.onDidChangeNotebookKernelSourceActions=="function"?f:void 0,D=this;this._kernelSourceActionProviders.set(f,m),this._logService.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${c.identifier.value}`),this._proxy.$addKernelSourceActionProvider(f,f,u);let M;return n!==void 0&&(M=m.onDidChangeNotebookKernelSourceActions(W=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(n))),{dispose:()=>{this._kernelSourceActionProviders.delete(f),D._proxy.$removeKernelSourceActionProvider(f,f),M?.dispose()}}}async $provideKernelSourceActions(c,u){const m=this._kernelSourceActionProviders.get(c);if(m){const f=new T.DisposableStore;return this._kernelSourceActionProviderCache.add([f]),(await m.provideNotebookKernelSourceActions(u)??[]).map(D=>C.NotebookKernelSourceAction.from(D,this._commands.converter,f))}return[]}$acceptNotebookAssociation(c,u,m){const f=this._kernelData.get(c);if(f){const n=this._extHostNotebook.getNotebookDocument(y.URI.revive(u));m?f.associatedNotebooks.set(n.uri,!0):f.associatedNotebooks.delete(n.uri),this._logService.trace(`NotebookController[${c}] ASSOCIATE notebook`,n.uri.toString(),m),f.onDidChangeSelection.fire({selected:m,notebook:n.apiNotebook})}}async $executeCells(c,u,m){const f=this._kernelData.get(c);if(!f)return;const n=this._extHostNotebook.getNotebookDocument(y.URI.revive(u)),D=[];for(const M of m){const W=n.getCell(M);W&&D.push(W.apiCell)}try{this._logService.trace(`NotebookController[${c}] EXECUTE cells`,n.uri.toString(),D.length),await f.controller.executeHandler.call(f.controller,D,n.apiNotebook,f.controller)}catch(M){this._logService.error(`NotebookController[${c}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(c,u,m){const f=this._kernelData.get(c);if(!f)return;const n=this._extHostNotebook.getNotebookDocument(y.URI.revive(u));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,n.apiNotebook);else for(const D of m){const M=n.getCell(D);M&&this._activeExecutions.get(M.uri)?.cancel()}if(f.controller.interruptHandler){const D=this._activeNotebookExecutions.get(n.uri);m.length&&Array.isArray(D)&&D.length&&D.forEach(M=>M.dispose())}}$acceptKernelMessageFromRenderer(c,u,m){const f=this._kernelData.get(c);if(!f)return;const n=this._extHostNotebook.getEditorById(u);f.onDidReceiveMessage.fire(Object.freeze({editor:n.apiEditor,message:m}))}$cellExecutionChanged(c,u,m){const n=this._extHostNotebook.getNotebookDocument(y.URI.revive(c)).getCell(u);if(n){const D=m?C.NotebookCellExecutionState.to(m):b.NotebookCellExecutionState.Idle;D!==void 0&&this._onDidChangeCellExecutionState.fire({cell:n.apiCell,state:D})}}_createNotebookCellExecution(c,u){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!f)throw new Error("invalid cell");if(this._activeExecutions.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const n=new t(u,f,this._proxy);this._activeExecutions.set(f.uri,n);const D=n.onDidChangeState(()=>{n.state===p.Resolved&&(n.dispose(),D.dispose(),this._activeExecutions.delete(f.uri))});return n.asApiObject()}_createNotebookExecution(c,u){const m=this._extHostNotebook.getNotebookDocument(c.uri),f=c.getCells().find(M=>{const W=m.getCellFromApiCell(M);return W&&this._activeExecutions.has(W.uri)});if(f)throw new Error(`duplicate cell execution for ${f.document.uri}`);if(this._activeNotebookExecutions.has(m.uri))throw new Error(`duplicate notebook execution for ${m.uri}`);const n=new r(u,m,this._proxy),D=n.onDidChangeState(()=>{n.state===s.Resolved&&(n.dispose(),D.dispose(),this._activeNotebookExecutions.delete(m.uri))});return this._activeNotebookExecutions.set(m.uri,[n,D]),n.asApiObject()}};e.ExtHostNotebookKernels=E=Ve([ze(4,L.ILogService)],E);var p;(function(_){_[_.Init=0]="Init",_[_.Started=1]="Started",_[_.Resolved=2]="Resolved"})(p||(p={}));class t extends T.Disposable{get state(){return this._state}constructor(c,u,m){super(),this._cell=u,this._proxy=m,this._handle=t.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new a(10,f=>this.update(f)),this._executionOrder=u.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,c,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(c){await this._collector.addItem(c)}async update(c){const u=Array.isArray(c)?c:[c];return this._proxy.$updateExecution(this._handle,new S.SerializableObjectWithBuffers(u))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(c){let u=this._cell;if(c&&(u=this._cell.notebook.getCellFromApiCell(c)),!u)throw new Error("INVALID cell");return u.handle}validateAndConvertOutputs(c){return c.map(u=>{const m=b.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return m===u.items?C.NotebookCellOutput.from(u):C.NotebookCellOutput.from({items:m,id:u.id,metadata:u.metadata})})}async updateOutputs(c,u,m){const f=this.cellIndexToHandle(u),n=this.validateAndConvertOutputs((0,o.asArray)(c));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,cellHandle:f,append:m,outputs:n})}async updateOutputItems(c,u,m){return c=b.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(c),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,items:c.map(C.NotebookCellOutputItem.from),outputId:u.id,append:m})}asApiObject(){const c=this;return Object.freeze({get token(){return c._tokenSource.token},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(m){c._executionOrder=m,c.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:c._executionOrder}])},start(m){if(c._state===p.Resolved||c._state===p.Started)throw new Error("Cannot call start again");c._state=p.Started,c._onDidChangeState.fire(),c.update({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:m})},end(m,f){if(c._state===p.Resolved)throw new Error("Cannot call resolve twice");c._state=p.Resolved,c._onDidChangeState.fire(),c._collector.flush(),c._proxy.$completeExecution(c._handle,new S.SerializableObjectWithBuffers({runEndTime:f,lastRunSuccess:m}))},clearOutput(m){return c.verifyStateForOutput(),c.updateOutputs([],m,!1)},appendOutput(m,f){return c.verifyStateForOutput(),c.updateOutputs(m,f,!0)},replaceOutput(m,f){return c.verifyStateForOutput(),c.updateOutputs(m,f,!1)},appendOutputItems(m,f){return c.verifyStateForOutput(),c.updateOutputItems(m,f,!0)},replaceOutputItems(m,f){return c.verifyStateForOutput(),c.updateOutputItems(m,f,!1)}})}}t.HANDLE=0;var s;(function(_){_[_.Init=0]="Init",_[_.Started=1]="Started",_[_.Resolved=2]="Resolved"})(s||(s={}));class r extends T.Disposable{get state(){return this._state}constructor(c,u,m){super(),this._notebook=u,this._proxy=m,this._handle=r.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,c,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===s.Resolved||this._state===s.Started)throw new Error("Cannot call start again");this._state=s.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===s.Resolved)throw new Error("Cannot call resolve twice");this._state=s.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}r.HANDLE=0;class a{constructor(c,u){this.delay=c,this.callback=u,this.batch=[],this.startedTimer=Date.now()}addItem(c){return this.batch.push(c),this.currentDeferred||(this.currentDeferred=new A.DeferredPromise,this.startedTimer=Date.now(),(0,A.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const c=this.currentDeferred;this.currentDeferred=void 0;const u=this.batch;return this.batch=[],this.callback(u).finally(()=>c.complete())}}function v(_,c){return`${_.value}/${c}`}e.createKernelId=v}),define(De[283],Ie([1,0,3,5,137]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(P,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,y,g){const L=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(y)?.fire({editor:L.apiEditor,message:g})}createRendererMessaging(P,y){if(!P.contributes?.notebookRenderer?.some(L=>L.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(L,I,w)=>this.getOrCreateEmitterFor(y).event(L,I,w),postMessage:(L,I)=>{l.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,I]=[I,L]);const w=I&&l.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.proxy.$postMessage(w?.id,y,L)}}}getOrCreateEmitterFor(P){let y=this._rendererMessageEmitters.get(P);return y||(y=new o.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,y),y)}}e.ExtHostNotebookRenderers=R}),define(De[284],Ie([1,0,6,10,2,27,5]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class P{constructor(g){this.handlers=new Map,this.proxy=g.getProxy(T.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,L,I){if((0,R.checkProposedApiEnabled)(g,"profileContentHandlers"),this.handlers.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.handlers.set(L,I),this.proxy.$registerProfileContentHandler(L,I.name,I.description,g.identifier.value),(0,o.toDisposable)(()=>{this.handlers.delete(L),this.proxy.$unregisterProfileContentHandler(L)})}async $saveProfile(g,L,I,w){const k=this.handlers.get(g);if(!k)throw new Error(`Unknown handler with id: ${g}`);return k.saveProfile(L,I,w)}async $readProfile(g,L,I){const w=this.handlers.get(g);if(!w)throw new Error(`Unknown handler with id: ${g}`);return w.readProfile((0,A.isString)(L)?L:l.URI.revive(L),I)}}e.ExtHostProfileContentHandlers=P}),define(De[285],Ie([1,0,2,5,19,11]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class T{constructor(y,g){this.uriTransformer=g,this.providers=new Map,this.proxy=y.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,g,L){const I=o.URI.revive(g),w=this.providers.get(y);return w?(0,l.asPromise)(()=>w.provideOriginalResource(I,L)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(y,g,L,I){const w=T.handlePool++;return this.providers.set(w,g),this.proxy.$registerQuickDiffProvider(w,R.DocumentSelector.from(y,this.uriTransformer),L,I),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(w),this.providers.delete(w)}}}}e.ExtHostQuickDiff=T,T.handlePool=0}),define(De[286],Ie([1,0,21,3,6,5,2,7,8,18,38,53,27,11]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function C(b,i,d){const h=b.getProxy(R.MainContext.MainThreadQuickOpen);class S{constructor(c,u){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=u}showQuickPick(c,u,m,f=o.CancellationToken.None){this._onDidSelectItem=void 0;const n=Promise.resolve(u),D=++this._instances,M=h.$show(D,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},f),W={},$=M.then(()=>W);return Promise.race([$,n]).then(N=>{if(N===W)return;const U=(0,w.isProposedApiEnabled)(c,"quickPickItemTooltip");return n.then(q=>{const F=[];for(let B=0;B<q.length;B++){const Q=q[B];typeof Q=="string"?F.push({label:Q,handle:B}):Q.kind===P.QuickPickItemKind.Separator?F.push({type:"separator",label:Q.label}):(Q.tooltip&&!U&&console.warn(`Extension '${c.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${c.identifier.value}`),F.push({label:Q.label,description:Q.description,detail:Q.detail,picked:Q.picked,alwaysShow:Q.alwaysShow,tooltip:U?k.MarkdownString.fromStrict(Q.tooltip):void 0,handle:B}))}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{m.onDidSelectItem(q[B])}),h.$setItems(D,F),M.then(B=>{if(typeof B=="number")return q[B];if(Array.isArray(B))return B.map(Q=>q[Q])})})}).then(void 0,N=>{if(!(0,y.isCancellationError)(N))return h.$setError(D,N),Promise.reject(N)})}$onItemSelected(c){this._onDidSelectItem?.(c)}showInput(c,u=o.CancellationToken.None){return this._validateInput=c?.validateInput,h.$input(c,typeof this._validateInput=="function",u).then(void 0,m=>{if(!(0,y.isCancellationError)(m))return Promise.reject(m)})}async $validateInput(c){if(!this._validateInput)return;const u=await this._validateInput(c);if(!u||typeof u=="string")return u;let m;switch(u.severity){case P.InputBoxValidationSeverity.Info:m=L.default.Info;break;case P.InputBoxValidationSeverity.Warning:m=L.default.Warning;break;case P.InputBoxValidationSeverity.Error:m=L.default.Error;break;default:m=u.message?L.default.Error:L.default.Ignore;break}return{content:u.message,severity:m}}async showWorkspaceFolderPick(c,u=o.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!m)return;const f=await this._workspace.getWorkspaceFolders2();if(f)return f.find(n=>n.uri.toString()===m.uri.toString())}createQuickPick(c){const u=new a(c,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}createInputBox(c){const u=new v(c,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(c,u){this._sessions.get(c)?._fireDidChangeValue(u)}$onDidAccept(c){this._sessions.get(c)?._fireDidAccept()}$onDidChangeActive(c,u){const m=this._sessions.get(c);m instanceof a&&m._fireDidChangeActive(u)}$onDidChangeSelection(c,u){const m=this._sessions.get(c);m instanceof a&&m._fireDidChangeSelection(u)}$onDidTriggerButton(c,u){this._sessions.get(c)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(c,u,m){const f=this._sessions.get(c);f instanceof a&&f._fireDidTriggerItemButton(u,m)}$onDidHide(c){this._sessions.get(c)?._fireDidHide()}}class E{constructor(c,u){this._extensionId=c,this._onDidDispose=u,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((u,m)=>{const f=u===P.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(f,u)}),this.update({buttons:c.map((u,m)=>({...r(u),tooltip:u.tooltip,handle:u===P.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const u=this._handlesToButtons.get(c);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,l.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),h.$dispose(this._id))}update(c){if(!this._disposed){for(const u of Object.keys(c)){const m=c[u];this._pendingUpdate[u]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){h.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function p(_){if(_ instanceof P.ThemeIcon)return{id:_.id};const c=s(_),u=t(_);return{dark:typeof c=="string"?T.URI.file(c):c,light:typeof u=="string"?T.URI.file(u):u}}function t(_){return typeof _=="object"&&"light"in _?_.light:_}function s(_){return typeof _=="object"&&"dark"in _?_.dark:_}function r(_){const c=p(_.iconPath);let u,m;return"id"in c?m=I.ThemeIcon.asClassName(c):u=c,{iconPath:u,iconClass:m}}class a extends E{constructor(c,u){super(c.identifier,u),this.extension=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this._onDidTriggerItemButtonEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((f,n)=>{this._handlesToItems.set(n,f),this._itemsToHandles.set(f,n)});const u=(0,w.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),m=[];for(let f=0;f<c.length;f++){const n=c[f];n.kind===P.QuickPickItemKind.Separator?m.push({type:"separator",label:n.label}):(n.tooltip&&!u&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`),m.push({handle:f,label:n.label,description:n.description,detail:n.detail,picked:n.picked,alwaysShow:n.alwaysShow,tooltip:u?k.MarkdownString.fromStrict(n.tooltip):void 0,buttons:n.buttons?.map((D,M)=>({...r(D),tooltip:D.tooltip,handle:M}))}))}this.update({items:m})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(c){const u=(0,g.coalesce)(c.map(m=>this._handlesToItems.get(m)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(c){const u=(0,g.coalesce)(c.map(m=>this._handlesToItems.get(m)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}_fireDidTriggerItemButton(c,u){const m=this._handlesToItems.get(c);if(!m||!m.buttons||!m.buttons.length)return;const f=m.buttons[u];f&&this._onDidTriggerItemButtonEmitter.fire({button:f,item:m})}}class v extends E{constructor(c,u){super(c.identifier,u),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get valueSelection(){return this._valueSelection}set valueSelection(c){this._valueSelection=c,this.update({valueSelection:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,c?typeof c=="string"?this.update({validationMessage:c,severity:L.default.Error}):this.update({validationMessage:c.message,severity:c.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new S(i,d)}e.createExtHostQuickOpen=C});var xe=this&&this.__classPrivateFieldGet||function(oe,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(oe):A?A.value:e.get(oe)},Je=this&&this.__classPrivateFieldSet||function(oe,e,o,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,o):l?l.value=o:e.set(oe,o),o};define(De[287],Ie([1,0,2,3,64,6,19,5,18,109,17,25,53,11,27,16]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b){"use strict";var i,d,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function S(f){if(f)return typeof f.iconPath=="string"?o.URI.file(f.iconPath):o.URI.isUri(f.iconPath)||w.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function E(f,n){if(!f.iconPath&&!n.iconPath)return 0;if(f.iconPath){if(!n.iconPath)return 1}else return-1;const D=typeof f.iconPath=="string"?f.iconPath:o.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,M=typeof n.iconPath=="string"?n.iconPath:o.URI.isUri(n.iconPath)?n.iconPath.fsPath:n.iconPath.id;return(0,g.comparePaths)(D,M)}function p(f,n){let D=0;if(f.strikeThrough!==n.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==n.faded)return f.faded?1:-1;if(f.tooltip!==n.tooltip)return(f.tooltip||"").localeCompare(n.tooltip||"");if(D=E(f,n),D!==0)return D;if(f.light&&n.light)D=E(f.light,n.light);else{if(f.light)return 1;if(n.light)return-1}if(D!==0)return D;if(f.dark&&n.dark)D=E(f.dark,n.dark);else{if(f.dark)return 1;if(n.dark)return-1}return D}function t(f,n){if(f.command!==n.command)return f.command<n.command?-1:1;if(f.title!==n.title)return f.title<n.title?-1:1;if(f.tooltip!==n.tooltip){if(f.tooltip!==void 0&&n.tooltip!==void 0)return f.tooltip<n.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(n.tooltip!==void 0)return-1}if(f.arguments===n.arguments)return 0;if(f.arguments)if(n.arguments){if(f.arguments.length!==n.arguments.length)return f.arguments.length-n.arguments.length}else return 1;else return-1;for(let D=0;D<f.arguments.length;D++){const M=f.arguments[D],W=n.arguments[D];if(M!==W)return M<W?-1:1}return 0}function s(f,n){let D=(0,g.comparePaths)(f.resourceUri.fsPath,n.resourceUri.fsPath,!0);if(D!==0)return D;if(f.command&&n.command)D=t(f.command,n.command);else{if(f.command)return 1;if(n.command)return-1}if(D!==0)return D;if(f.decorations&&n.decorations)D=p(f.decorations,n.decorations);else{if(f.decorations)return 1;if(n.decorations)return-1}return D}function r(f,n){for(let D=0;D<f.length;D++)if(f[D]!==n[D])return!1;return!0}function a(f,n){return f.command===n.command&&f.title===n.title&&f.tooltip===n.tooltip&&(f.arguments&&n.arguments?r(f.arguments,n.arguments):f.arguments===n.arguments)}function v(f,n){return(0,y.equals)(f,n,a)}class _{get value(){return this._value}set value(n){n=n??"",xe(this,i,"f").$setInputBoxValue(this._sourceControlHandle,n),this.updateValue(n)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(n){xe(this,i,"f").$setInputBoxPlaceholder(this._sourceControlHandle,n),this._placeholder=n}get validateInput(){return(0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(n){if((0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),n&&typeof n!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=n,xe(this,i,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!n)}get enabled(){return this._enabled}set enabled(n){n=!!n,this._enabled!==n&&(this._enabled=n,xe(this,i,"f").$setInputBoxEnablement(this._sourceControlHandle,n))}get visible(){return this._visible}set visible(n){n=!!n,this._visible!==n&&(this._visible=n,xe(this,i,"f").$setInputBoxVisibility(this._sourceControlHandle,n))}get document(){return(0,C.checkProposedApiEnabled)(this._extension,"scmTextDocument"),xe(this,d,"f").getDocument(this._documentUri)}constructor(n,D,M,W,$){this._extension=n,this._sourceControlHandle=W,this._documentUri=$,i.set(this,void 0),d.set(this,void 0),this._value="",this._onDidChange=new A.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,d,D,"f"),Je(this,i,M,"f")}showValidationMessage(n,D){(0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),xe(this,i,"f").$showValidationMessage(this._sourceControlHandle,n,D)}$onInputBoxValueChange(n){this.updateValue(n)}updateValue(n){this._value=n,this._onDidChange.fire(n)}}e.ExtHostSCMInputBox=_,i=new WeakMap,d=new WeakMap;class c{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(n){this._label=n,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,n)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(n){this._hideWhenEmpty=n,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(n){this._resourceStates=[...n],this._onDidUpdateResourceStates.fire()}constructor(n,D,M,W,$){this._proxy=n,this._commands=D,this._sourceControlHandle=M,this._id=W,this._label=$,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new A.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new A.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=c._handlePool++}getResourceState(n){return this._resourceStatesMap.get(n)}$executeResourceCommand(n,D){const M=this._resourceStatesCommandsMap.get(n);return M?(0,T.asPromise)(()=>this._commands.executeCommand(M.command,...M.arguments||[],D)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const n=[...this._resourceStates].sort(s),M=(0,y.sortedDiff)(this._resourceSnapshot,n,s).map(N=>{const U=N.toInsert.map(q=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,q);const B=q.resourceUri;let Q;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const Z=new R.DisposableStore;Q=this._commands.converter.toInternal(q.command,Z),this._resourceStatesDisposablesMap.set(F,Z)}else this._resourceStatesCommandsMap.set(F,q.command);const J=S(q.decorations),X=q.decorations&&S(q.decorations.light)||J,ie=q.decorations&&S(q.decorations.dark)||J,ae=[X,ie],we=q.decorations&&q.decorations.tooltip||"",he=q.decorations&&!!q.decorations.strikeThrough,fe=q.decorations&&!!q.decorations.faded,V=q.contextValue||"";return{rawResource:[F,B,ae,we,he,fe,V,Q],handle:F}});return{start:N.start,deleteCount:N.deleteCount,toInsert:U}}),W=M.map(({start:N,deleteCount:U,toInsert:q})=>[N,U,q.map(F=>F.rawResource)]),$=M.reverse();for(const{start:N,deleteCount:U,toInsert:q}of $){const F=q.map(Q=>Q.handle),B=this._handlesSnapshot.splice(N,U,...F);for(const Q of B)this._resourceStatesMap.delete(Q),this._resourceStatesCommandsMap.delete(Q),this._resourceStatesDisposablesMap.get(Q)?.dispose(),this._resourceStatesDisposablesMap.delete(Q)}return this._resourceSnapshot=n,W}dispose(){this._disposed=!0,this._onDidDispose.fire()}}c._handlePool=0;class u{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(n){this._count!==n&&(this._count=n,xe(this,h,"f").$updateSourceControl(this.handle,{count:n}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(n){this._quickDiffProvider=n;let D;(0,C.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(D=n?.label),xe(this,h,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!n,quickDiffLabel:D})}get commitTemplate(){return this._commitTemplate}set commitTemplate(n){n!==this._commitTemplate&&(this._commitTemplate=n,xe(this,h,"f").$updateSourceControl(this.handle,{commitTemplate:n}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(n){this._acceptInputDisposables.value=new R.DisposableStore,this._acceptInputCommand=n;const D=this._commands.converter.toInternal(n,this._acceptInputDisposables.value);xe(this,h,"f").$updateSourceControl(this.handle,{acceptInputCommand:D})}get actionButton(){return(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(n){(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new R.DisposableStore,this._actionButton=n;const D=n!==void 0?{command:this._commands.converter.toInternal(n.command,this._actionButtonDisposables.value),secondaryCommands:n.secondaryCommands?.map(M=>M.map(W=>this._commands.converter.toInternal(W,this._actionButtonDisposables.value))),description:n.description,enabled:n.enabled}:void 0;xe(this,h,"f").$updateSourceControl(this.handle,{actionButton:D??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(n){if(this._statusBarCommands&&n&&v(this._statusBarCommands,n))return;this._statusBarDisposables.value=new R.DisposableStore,this._statusBarCommands=n;const D=(n||[]).map(M=>this._commands.converter.toInternal(M,this._statusBarDisposables.value));xe(this,h,"f").$updateSourceControl(this.handle,{statusBarCommands:D})}get selected(){return this._selected}constructor(n,D,M,W,$,N,U){this._extension=n,this._commands=W,this._id=$,this._label=N,this._rootUri=U,h.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new R.MutableDisposable,this._statusBarDisposables=new R.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new A.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=u._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,h,M,"f");const q=o.URI.from({scheme:b.Schemas.vscodeSourceControl,path:`${$}/scm${this.handle}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this._inputBox=new _(n,D,xe(this,h,"f"),this.handle,q),xe(this,h,"f").$registerSourceControl(this.handle,$,N,U,q)}createResourceGroup(n,D){const M=new c(xe(this,h,"f"),this._commands,this.handle,n,D),W=A.Event.once(M.onDidDispose)(()=>this.createdResourceGroups.delete(M));return this.createdResourceGroups.set(M,W),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const n=[],D=[];for(const[M,W]of this.createdResourceGroups){W.dispose();const $=M.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(M),this.eventuallyUpdateResourceStates()});A.Event.once(M.onDidDispose)(()=>{this.updatedResourceGroups.delete(M),$.dispose(),this._groups.delete(M.handle),xe(this,h,"f").$unregisterGroup(this.handle,M.handle)}),n.push([M.handle,M.id,M.label,M.features]);const N=M._takeResourceStateSnapshot();N.length>0&&D.push([M.handle,N]),this._groups.set(M.handle,M)}xe(this,h,"f").$registerGroups(this.handle,n,D),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const n=[];this.updatedResourceGroups.forEach(D=>{const M=D._takeResourceStateSnapshot();M.length!==0&&n.push([D.handle,M])}),n.length>0&&xe(this,h,"f").$spliceResourceStates(this.handle,n),this.updatedResourceGroups.clear()}getResourceGroup(n){return this._groups.get(n)}setSelectionState(n){this._selected=n,this._onDidChangeSelection.fire(n)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(n=>n.dispose()),xe(this,h,"f").$unregisterSourceControl(this.handle)}}h=new WeakMap,u._handlePool=0,Ve([(0,l.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),Ve([(0,l.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let m=e.ExtHostSCM=class yn{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(n,D,M,W){this._commands=D,this._extHostDocuments=M,this.logService=W,this._sourceControls=new Map,this._sourceControlsByExtension=new I.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new A.Emitter,this._proxy=n.getProxy(P.MainContext.MainThreadSCM),this._telemetry=n.getProxy(P.MainContext.MainThreadTelemetry),D.registerArgumentProcessor({processArgument:$=>{if($&&$.$mid===3){const N=this._sourceControls.get($.sourceControlHandle);if(!N)return $;const U=N.getResourceGroup($.groupHandle);return U?U.getResourceState($.handle):$}else if($&&$.$mid===4){const N=this._sourceControls.get($.sourceControlHandle);return N?N.getResourceGroup($.groupHandle):$}else if($&&$.$mid===5){const N=this._sourceControls.get($.handle);return N||$}return $}})}createSourceControl(n,D,M,W){this.logService.trace("ExtHostSCM#createSourceControl",n.identifier.value,D,M,W),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:n.identifier.value});const $=yn._handlePool++,N=new u(n,this._extHostDocuments,this._proxy,this._commands,D,M,W);this._sourceControls.set($,N);const U=this._sourceControlsByExtension.get(n.identifier)||[];return U.push(N),this._sourceControlsByExtension.set(n.identifier,U),N}getLastInputBox(n){this.logService.trace("ExtHostSCM#getLastInputBox",n.identifier.value);const D=this._sourceControlsByExtension.get(n.identifier),M=D&&D[D.length-1];return M&&M.inputBox}$provideOriginalResource(n,D,M){const W=o.URI.revive(D);this.logService.trace("ExtHostSCM#$provideOriginalResource",n,W.toString());const $=this._sourceControls.get(n);return!$||!$.quickDiffProvider||!$.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>$.quickDiffProvider.provideOriginalResource(W,M)).then(N=>N||null)}$onInputBoxValueChange(n,D){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",n);const M=this._sourceControls.get(n);return M&&M.inputBox.$onInputBoxValueChange(D),Promise.resolve(void 0)}$executeResourceCommand(n,D,M,W){this.logService.trace("ExtHostSCM#$executeResourceCommand",n,D,M);const $=this._sourceControls.get(n);if(!$)return Promise.resolve(void 0);const N=$.getResourceGroup(D);return N?N.$executeResourceCommand(M,W):Promise.resolve(void 0)}$validateInput(n,D,M){this.logService.trace("ExtHostSCM#$validateInput",n);const W=this._sourceControls.get(n);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>W.inputBox.validateInput(D,M)).then($=>{if(!$)return Promise.resolve(void 0);const N=k.MarkdownString.fromStrict($.message);return N?Promise.resolve([N,$.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(n){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",n),n!==void 0&&this._sourceControls.get(n)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=n,Promise.resolve(void 0)}};m._handlePool=0,e.ExtHostSCM=m=Ve([ze(3,L.ILogService)],m)}),define(De[99],Ie([1,0,5,3,4]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(P){this._onDidChangePassword=new A.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,y){return this._proxy.$getPassword(P,y)}store(P,y,g){return this._proxy.$setPassword(P,y,g)}delete(P,y){return this._proxy.$deletePassword(P,y)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,l.createDecorator)("IExtHostSecretState")}),define(De[288],Ie([1,0,5,7]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSemanticSimilarity=void 0;class l{constructor(T){this._semanticSimilarityProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(o.MainContext.MainThreadSemanticSimilarity)}async $provideSimilarityScore(T,P,y,g){if(this._semanticSimilarityProviders.size===0)throw new Error("No semantic similarity providers registered");const L=this._semanticSimilarityProviders.get(T);if(!L)throw new Error("Semantic similarity provider not found");return await L.provideSimilarityScore(P,y,g)}registerSemanticSimilarityProvider(T,P){const y=this._nextHandle;return this._nextHandle++,this._semanticSimilarityProviders.set(y,P),this._proxy.$registerSemanticSimilarityProvider(y),new A.Disposable(()=>{this._proxy.$unregisterSemanticSimilarityProvider(y),this._semanticSimilarityProviders.delete(y)})}}e.ExtHostSemanticSimilarity=l});var Je=this&&this.__classPrivateFieldSet||function(oe,e,o,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,o):l?l.value=o:e.set(oe,o),o},xe=this&&this.__classPrivateFieldGet||function(oe,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(oe):A?A.value:e.get(oe)};define(De[289],Ie([1,0,7,5,188,6,11,10]),function(oe,e,o,A,l,R,T,P){"use strict";var y,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(C,b,i,d,h=o.StatusBarAlignment.Left,S){y.set(this,void 0),g.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._staleCommandRegistrations=new R.DisposableStore,Je(this,y,C,"f"),Je(this,g,b,"f"),this._entryId=L.ID_GEN++,this._extension=i,this._id=d,this._alignment=h,this._priority=this.validatePriority(S)}validatePriority(C){if((0,P.isNumber)(C))return C===Number.POSITIVE_INFINITY?Number.MAX_VALUE:C===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:C}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(C){this._text=C,this.update()}set name(C){this._name=C,this.update()}set tooltip(C){this._tooltip=C,this.update()}set color(C){this._color=C,this.update()}set backgroundColor(C){C&&!L.ALLOWED_BACKGROUND_COLORS.has(C.id)&&(C=void 0),this._backgroundColor=C,this.update()}set command(C){this._command?.fromApi!==C&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new R.DisposableStore,typeof C=="string"?this._command={fromApi:C,internal:xe(this,g,"f").toInternal({title:"",command:C},this._latestCommandRegistration)}:C?this._command={fromApi:C,internal:xe(this,g,"f").toInternal(C,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(C){this._accessibilityInformation=C,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,xe(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let C;this._extension?this._id?C=`${this._extension.identifier.value}.${this._id}`:C=this._extension.identifier.value:C=this._id;let b;this._name?b=this._name:b=(0,l.localize)(0,null,this._extension.displayName||this._extension.name);let i=this._color;this._backgroundColor&&(i=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const d=T.MarkdownString.fromStrict(this._tooltip);xe(this,y,"f").$setEntry(this._entryId,C,this._extension?.identifier.value,b,this._text,d,this._command?.internal,i,this._backgroundColor,this._alignment===o.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,y=new WeakMap,g=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(C){this._messages=[],this._item=C.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,l.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(C){const b={message:C};return this._messages.unshift(b),this._update(),new o.Disposable(()=>{const i=this._messages.indexOf(b);i>=0&&(this._messages.splice(i,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class w{constructor(C,b){this._proxy=C.getProxy(A.MainContext.MainThreadStatusBar),this._commands=b,this._statusMessage=new I(this)}createStatusBarEntry(C,b,i,d){return new L(this._proxy,this._commands,C,b,i,d)}setStatusBarMessage(C,b){const i=this._statusMessage.setMessage(C);let d;return typeof b=="number"?d=setTimeout(()=>i.dispose(),b):typeof b<"u"&&b.then(()=>i.dispose(),()=>i.dispose()),new o.Disposable(()=>{i.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=w}),define(De[100],Ie([1,0,5,3,4]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(P,y){this._logService=y,this._onDidChangeStorage=new A.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,y){this._proxy.$registerExtensionStorageKeysToSync(P,y)}async initializeExtensionStorage(P,y,g){const L=await this._proxy.$initializeExtensionStorage(P,y);let I;return L&&(I=this.safeParseValue(P,y,L)),I||g}setValue(P,y,g){return this._proxy.$setValue(P,y,g)}$acceptValue(P,y,g){const L=this.safeParseValue(P,y,g);L&&this._onDidChangeStorage.fire({shared:P,key:y,value:L})}safeParseValue(P,y,g){try{return JSON.parse(g)}catch(L){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${P}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,l.createDecorator)("IExtHostStorage")}),define(De[81],Ie([1,0,4,26,17,80,2]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let P=e.ExtensionStoragePaths=class{constructor(g,L,I){this._logService=L,this._extHostFileSystem=I,this._workspace=g.workspace??void 0,this._environment=g.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(w=>this._value=w)}async _getWorkspaceStorageURI(g){return T.URI.joinPath(this._environment.workspaceStorageHome,g)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const g=this._workspace.id,L=await this._getWorkspaceStorageURI(g);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(g){if(this._value)return T.URI.joinPath(this._value,g.identifier.value)}globalValue(g){return T.URI.joinPath(this._environment.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=P=Ve([ze(0,A.IExtHostInitDataService),ze(1,l.ILogService),ze(2,R.IExtHostConsumerFileSystem)],P)}),define(De[42],Ie([1,0,3,5,4,2,20,6,7,190,8,223,21,30,224,53,10,19,11]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,l.createDecorator)("IExtHostTerminalService");class S{constructor(u,m,f,n){this._proxy=u,this._id=m,this._creationOptions=f,this._name=n,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(M=>this._pidPromiseComplete=M);const D=this;this.value={get name(){return D._name||""},get processId(){return D._pidPromise},get creationOptions(){return D._creationOptions},get exitStatus(){return D._exitStatus},get state(){return D._state},sendText(M,W=!0){D._checkDisposed(),D._proxy.$sendText(D._id,M,W)},show(M){D._checkDisposed(),D._proxy.$show(D._id,M)},hide(){D._checkDisposed(),D._proxy.$hide(D._id)},dispose(){D._disposed||(D._disposed=!0,D._proxy.$dispose(D._id))},get dimensions(){if(!(D._cols===void 0||D._rows===void 0))return{columns:D._cols,rows:D._rows}}}}async create(u,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,i.withNullAsUndefined)(u.shellPath),shellArgs:(0,i.withNullAsUndefined)(u.shellArgs),cwd:(0,i.withNullAsUndefined)(u.cwd),env:(0,i.withNullAsUndefined)(u.env),icon:(0,i.withNullAsUndefined)(a(u.iconPath)),color:b.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,i.withNullAsUndefined)(u.message),strictEnv:(0,i.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,i.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,i.withNullAsUndefined)(m?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,i.withNullAsUndefined)(m?.useShellEnvironment),location:m?.location||this._serializeParentTerminal(u.location,m?.resolvedExtHostIdentifier),isTransient:(0,i.withNullAsUndefined)(u.isTransient)})}async createExtensionTerminal(u,m,f,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:b.ThemeColor.isThemeColor(n)?n.id:void 0,location:this._serializeParentTerminal(u,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,m){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in u?{viewColumn:h.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitStatus(u,m){this._exitStatus=Object.freeze({code:u,reason:m})}setDimensions(u,m){return u===this._cols&&m===this._rows||u===0||m===0?!1:(this._cols=u,this._rows=m,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(m=>{m!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=S;class E{get onProcessReady(){return this._onProcessReady.event}constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._onProcessData=new o.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new o.Emitter,this._onDidChangeProperty=new o.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new o.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${m}`)}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput?.(u)}resize(u,m){this._pty.setDimensions?.({columns:u,rows:m})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(m=>this._onProcessData.fire(m)),this._pty.onDidClose?.((m=void 0)=>{this._onProcessExit.fire(m===void 0?void 0:m)}),this._pty.onDidOverrideDimensions?.(m=>{m&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this._pty.onDidChangeName?.(m=>{this._onDidChangeProperty.fire({type:"title",value:m})}),this._pty.open(u||void 0),u&&this._pty.setDimensions?.(u),this._onProcessReady.fire({pid:-1,cwd:""})}}let p=1,t=e.BaseExtHostTerminalService=class extends P.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(u,m){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new o.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new o.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new o.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new o.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new o.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new o.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=m.getProxy(A.MainContext.MainThreadTerminalService),this._bufferer=new C.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new o.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[f,n]of this._terminalProcesses)n.shutdown(!0)}})}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,m){const f=new S(this._proxy,(0,k.generateUuid)(),u,u.name),n=new E(u.pty);return f.createExtensionTerminal(u.location,this._serializeParentTerminal(u,m).resolvedExtHostIdentifier,a(u.iconPath),v(u.color)).then(D=>{const M=this._setupExtHostProcessListeners(D,n);this._terminalProcessDisposables[D]=M}),this._terminals.push(f),f.value}_serializeParentTerminal(u,m){if(m=m||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const f=u.location.parentTerminal;if(f){const n=this._terminals.find(D=>D.value===f);n&&(m.resolvedExtHostIdentifier=n._id)}}else u.location&&typeof u.location!="object"?m.location=u.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(u,m){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const n=new E(m),D=this._setupExtHostProcessListeners(u,n);this._terminalProcessDisposables[u]=D}async $acceptActiveTerminalChanged(u){const m=this._activeTerminal;if(u===null){this._activeTerminal=void 0,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(u);f&&(this._activeTerminal=f,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,m){const f=this._getTerminalById(u);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:m})}async $acceptTerminalDimensions(u,m,f){const n=this._getTerminalById(u);n&&n.setDimensions(m,f)&&this._onDidChangeTerminalDimensions.fire({terminal:n.value,dimensions:n.value.dimensions})}async $acceptTerminalMaximumDimensions(u,m,f){this._terminalProcesses.get(u)?.resize(m,f)}async $acceptTerminalTitleChange(u,m){const f=this._getTerminalById(u);f&&(f.name=m)}async $acceptTerminalClosed(u,m,f){const n=this._getTerminalObjectIndexById(this._terminals,u);if(n!==null){const D=this._terminals.splice(n,1)[0];D.setExitStatus(m,f),this._onDidCloseTerminal.fire(D.value)}}$acceptTerminalOpened(u,m,f,n){if(m){const W=this._getTerminalObjectIndexById(this._terminals,m);if(W!==null){this._terminals[W]._id=u,this._onDidOpenTerminal.fire(this.terminals[W]),this._terminals[W].isOpen=!0;return}}const D={name:n.name,shellPath:n.executable,shellArgs:n.args,cwd:typeof n.cwd=="string"?n.cwd:R.URI.revive(n.cwd),env:n.env,hideFromUser:n.hideFromUser},M=new S(this._proxy,u,D,f);this._terminals.push(M),this._onDidOpenTerminal.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(u,m){this._getTerminalById(u)?._setProcessId(m)}async $startExtensionTerminal(u,m){const f=this._getTerminalById(u);if(!f)return{message:(0,g.localize)(0,null,u)};f.isOpen||await new Promise(D=>{const M=this.onDidOpenTerminal(async W=>{W===f.value&&(M.dispose(),D())})});const n=this._terminalProcesses.get(u);n?n.startSendingEvents(m):this._extensionTerminalAwaitingStart[u]={initialDimensions:m}}_setupExtHostProcessListeners(u,m){const f=new P.DisposableStore;f.add(m.onProcessReady(D=>this._proxy.$sendProcessReady(u,D.pid,D.cwd))),f.add(m.onDidChangeProperty(D=>this._proxy.$sendProcessProperty(u,D))),this._bufferer.startBuffering(u,m.onProcessData),f.add(m.onProcessExit(D=>this._onProcessExit(u,D))),this._terminalProcesses.set(u,m);const n=this._extensionTerminalAwaitingStart[u];return n&&m instanceof E&&(m.startSendingEvents(n.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),f}$acceptProcessAckDataEvent(u,m){this._terminalProcesses.get(u)?.acknowledgeDataEvent(m)}$acceptProcessInput(u,m){this._terminalProcesses.get(u)?.input(m)}$acceptTerminalInteraction(u){const m=this._getTerminalById(u);m?.setInteractedWith()&&this._onDidChangeTerminalState.fire(m.value)}$acceptProcessResize(u,m,f){try{this._terminalProcesses.get(u)?.resize(m,f)}catch(n){if(n.code!=="EPIPE"&&n.code!=="ERR_IPC_CHANNEL_CLOSED")throw n}}$acceptProcessShutdown(u,m){this._terminalProcesses.get(u)?.shutdown(m)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(m=>this._proxy.$sendProcessProperty(u,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(m=>this._proxy.$sendProcessProperty(u,{type:"cwd",value:m}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,m,f){if(this._profileProviders.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this._profileProviders.set(m,f),this._proxy.$registerProfileProvider(m,u.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(m),this._proxy.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(u,m,f){if(this._quickFixProviders.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this._quickFixProviders.set(u,f),this._proxy.$registerQuickFixProvider(u,m),new y.Disposable(()=>{this._quickFixProviders.delete(u),this._proxy.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,m){const f=new w.CancellationTokenSource().token;if(f.isCancellationRequested)return;const n=this._quickFixProviders.get(u);if(!n)return;const D=await n.provideTerminalQuickFixes(m,f);if(D!==null)return D}async $createContributedProfileTerminal(u,m){const f=new w.CancellationTokenSource().token;let n=await this._profileProviders.get(u)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(n&&!("options"in n)&&(n={options:n}),!n||!("options"in n))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in n.options){this.createExtensionTerminal(n.options,m);return}this.createTerminalFromOptions(n.options,m)}}async $provideLinks(u,m){const f=this._getTerminalById(u);if(!f)return[];this._terminalLinkCache.delete(u),this._terminalLinkCancellationSource.get(u)?.dispose(!0);const D=new w.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,D);const M=[],W={terminal:f.value,line:m},$=[];for(const q of this._linkProviders)$.push(d.Promises.withAsyncBody(async F=>{D.token.onCancellationRequested(()=>F({provider:q,links:[]}));const B=await q.provideTerminalLinks(W,D.token)||[];D.token.isCancellationRequested||F({provider:q,links:B})}));const N=await Promise.all($);if(D.token.isCancellationRequested)return[];const U=new Map;for(const q of N)q&&q.links.length>0&&M.push(...q.links.map(F=>{const B={id:p++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return U.set(B.id,{provider:q.provider,link:F}),B}));return this._terminalLinkCache.set(u,U),M}$activateLink(u,m){const f=this._terminalLinkCache.get(u)?.get(m);f&&f.provider.handleTerminalLink(f.link)}_onProcessExit(u,m){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const f=this._terminalProcessDisposables[u];f&&(f.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,m)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,m){const f=this._getTerminalObjectIndexById(u,m);return f!==null?u[f]:null}_getTerminalObjectIndexById(u,m){let f=null;return u.some((n,D)=>n._id===m?(f=D,!0):!1),f}getEnvironmentVariableCollection(u){let m=this._environmentVariableCollections.get(u.identifier.value);return m||(m=new s,this._setEnvironmentVariableCollection(u.identifier.value,m)),m}_syncEnvironmentVariableCollection(u,m){const f=(0,I.serializeEnvironmentVariableCollection)(m.map),n=(0,I.serializeEnvironmentDescriptionMap)(m.descriptionMap);this._proxy.$setEnvironmentVariableCollection(u,m.persistent,f.length===0?void 0:f,n)}$initEnvironmentVariableCollections(u){u.forEach(m=>{const f=m[0],n=new s(m[1]);this._setEnvironmentVariableCollection(f,n)})}$acceptDefaultProfile(u,m){const f=this._defaultProfile;this._defaultProfile=u,this._defaultAutomationProfile=m,f?.path!==u.path&&this._onDidChangeShell.fire(u.path)}_setEnvironmentVariableCollection(u,m){this._environmentVariableCollections.set(u,m),m.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,m)})}};e.BaseExtHostTerminalService=t=Ve([ze(1,T.IExtHostRpcService)],t);class s{get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(u){this.map=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new o.Emitter,this.map=new Map(u)}get size(){return this.map.size}replace(u,m,f){this._setIfDiffers(u,{value:m,type:y.EnvironmentVariableMutatorType.Replace,scope:f})}append(u,m,f){this._setIfDiffers(u,{value:m,type:y.EnvironmentVariableMutatorType.Append,scope:f})}prepend(u,m,f){this._setIfDiffers(u,{value:m,type:y.EnvironmentVariableMutatorType.Prepend,scope:f})}_setIfDiffers(u,m){m.scope||delete m.scope;const f=this.getKey(u,m.scope),n=this.map.get(f);if(!n||n.value!==m.value||n.type!==m.type||n.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const D=this.getKey(u,m.scope),M={variable:u,...m};this.map.set(D,M),this._onDidChangeCollection.fire()}}get(u,m){const f=this.getKey(u,m),n=this.map.get(f);return n?_(n):void 0}getKey(u,m){const f=this.getWorkspaceKey(m?.workspaceFolder);return f?`${u}:::${f}`:u}getWorkspaceKey(u){return u?u.uri.toString():void 0}forEach(u,m){this.map.forEach((f,n)=>u.call(m,f.variable,_(f),this))}[Symbol.iterator](){const u=new Map;return this.map.forEach((m,f)=>{m.scope||u.set(m.variable,_(m))}),u.entries()}delete(u,m){const f=this.getKey(u,m);this.map.delete(f),this._onDidChangeCollection.fire()}clear(u){if(u?.workspaceFolder){for(const[m,f]of this.map)f.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(m);this.clearDescription(u)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(u,m){const f=this.getKey("",m),n=this.descriptionMap.get(f);if(!n||n.description!==u){let D;typeof u=="string"?D=u:D=u?.value.split(`

`)[0];const M={description:D,scope:m};this.descriptionMap.set(f,M),this._onDidChangeCollection.fire()}}clearDescription(u){const m=this.getKey("",u);this.descriptionMap.delete(m)}}let r=e.WorkerExtHostTerminalService=class extends t{constructor(u){super(!1,u)}createTerminal(u,m,f){throw new L.NotSupportedError}createTerminalFromOptions(u,m){throw new L.NotSupportedError}};e.WorkerExtHostTerminalService=r=Ve([ze(0,T.IExtHostRpcService)],r);function a(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function v(c){return b.ThemeColor.isThemeColor(c)?c:void 0}function _(c){const u={...c};return u.scope=u.scope??void 0,delete u.variable,u}});var xe=this&&this.__classPrivateFieldGet||function(oe,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(oe):A?A.value:e.get(oe)},Je=this&&this.__classPrivateFieldSet||function(oe,e,o,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,o):l?l.value=o:e.set(oe,o),o};define(De[290],Ie([1,0,18,19,22,21,3,65,69,6,23,10,30,5,20,138,11,7,59,95,77]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h,S,E){"use strict";var p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=e.ExtHostTesting=class{constructor(N,U,q){this.editors=q,this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=N.getProxy(k.MainContext.MainThreadTesting),this.observer=new D(this.proxy),this.runTracker=new _(this.proxy),U.registerArgumentProcessor({processArgument:F=>{if(F?.$mid!==15)return F;const B=F,Q=B.tests[B.tests.length-1].item.extId;return this.controllers.get(h.TestId.root(Q))?.collection.tree.get(Q)?.actual??(0,b.toItemFromContext)(F)}}),U.registerCommand(!1,"testing.getExplorerSelection",async()=>{const F=await U.executeCommand("_testing.getExplorerSelection"),B=Q=>{const J=this.controllers.get(h.TestId.root(Q));if(J)return h.TestId.isRoot(Q)?J.controller:J.collection.tree.get(Q)?.actual};return{include:F?.include.map(B).filter(I.isDefined)||[],exclude:F?.exclude.map(B).filter(I.isDefined)||[]}})}createTestController(N,U,q,F){if(this.controllers.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const B=new g.DisposableStore,Q=B.add(new b.ExtHostTestItemCollection(U,q,this.editors));Q.root.label=q;const J=new Map,X=this.proxy,ie={items:Q.root.children,get label(){return q},set label(we){q=we,Q.root.label=we,X.$updateController(U,{label:q})},get refreshHandler(){return F},set refreshHandler(we){F=we,X.$updateController(U,{canRefresh:!!we})},get id(){return U},createRunProfile:(we,he,fe,V,x,Z)=>{let pe=(0,y.hash)(we);for(;J.has(pe);)pe++;return new M(this.proxy,J,U,pe,we,he,fe,V,x,Z)},createTestItem(we,he,fe){return new b.TestItemImpl(U,we,he,fe)},createTestRun:(we,he,fe=!0)=>this.runTracker.createTestRun(U,Q,we,he,fe),set resolveHandler(we){Q.resolveHandler=we},get resolveHandler(){return Q.resolveHandler},dispose:()=>{B.dispose()}};X.$registerTestController(U,q,!!F),B.add((0,g.toDisposable)(()=>X.$unregisterTestController(U)));const ae={controller:ie,collection:Q,profiles:J};return this.controllers.set(U,ae),B.add((0,g.toDisposable)(()=>this.controllers.delete(U))),B.add(Q.onDidGenerateDiff(we=>X.$publishDiff(U,we.map(E.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.observer.checkout()}async runTests(N,U=R.CancellationToken.None){const q=c(N);if(!q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(q.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(B=>h.TestId.fromExtHostTestItem(B,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:W[q.kind],profileId:q.profileId,controllerId:q.controllerId}],exclude:N.exclude?.map(B=>B.id)},U)}$syncTests(){for(const{collection:N}of this.controllers.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,U,q){return(0,o.mapFind)(this.runTracker.trackers,B=>B.id===N?B.getCoverage(U):void 0)?.provideFileCoverage(q)??Promise.resolve([])}$resolveFileCoverage(N,U,q,F){return(0,o.mapFind)(this.runTracker.trackers,Q=>Q.id===N?Q.getCoverage(U):void 0)?.resolveFileCoverage(q,F)??Promise.resolve([])}$configureRunProfile(N,U){this.controllers.get(N)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(N,U){await this.controllers.get(N)?.controller.refreshHandler?.(U)}$publishTestResults(N){this.results=Object.freeze(N.map(U=>(0,L.deepFreeze)(i.TestResults.to(U))).concat(this.results).sort((U,q)=>q.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(N,U){const q=this.controllers.get(h.TestId.fromString(N).controllerId)?.collection;q&&(await q.expand(N,U<0?1/0:U),q.flushDiff())}$acceptDiff(N){this.observer.applyDiff(N.map(E.TestsDiffOp.deserialize))}async $runControllerTests(N,U){return Promise.all(N.map(q=>this.runControllerTestRequest(q,!1,U)))}async $startContinuousRun(N,U){const q=new R.CancellationTokenSource(U),F=await Promise.all(N.map(B=>this.runControllerTestRequest(B,!0,q.token)));return!U.isCancellationRequested&&!F.some(B=>B.error)&&await new Promise(B=>U.onCancellationRequested(B)),q.dispose(!0),F}async runControllerTestRequest(N,U,q){const F=this.controllers.get(N.controllerId);if(!F)return{};const{collection:B,profiles:Q}=F,J=Q.get(N.profileId);if(!J)return{};const X=N.testIds.map(he=>B.tree.get(he)).filter(I.isDefined),ie=N.excludeExtIds.map(he=>F.collection.tree.get(he)).filter(I.isDefined).filter(he=>X.some(fe=>fe.fullId.compare(he.fullId)===2));if(!X.length)return{};const ae=new d.TestRunRequest(X.some(he=>he.actual instanceof b.TestItemRootImpl)?void 0:X.map(he=>he.actual),ie.map(he=>he.actual),J,U),we=(0,E.isStartControllerTests)(N)&&this.runTracker.prepareForMainThreadTestRun(ae,u.fromInternal(N,F.collection),q);try{return await J.runHandler(ae,q),{}}catch(he){return{error:String(he)}}finally{we&&(we.hasRunningTasks&&!q.isCancellationRequested&&await T.Event.toPromise(we.onEnd),we.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(N)}};e.ExtHostTesting=s=Ve([ze(0,C.IExtHostRpcService)],s);const r=1e4;var a;(function($){$[$.Running=0]="Running",$[$.Cancelling=1]="Cancelling",$[$.Ended=2]="Ended"})(a||(a={}));class v extends g.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(N,U,q){super(),this.dto=N,this.proxy=U,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new R.CancellationTokenSource(q));const F=this._register(new A.RunOnceScheduler(()=>this.forciblyEndTasks(),r));this._register(this.cts.token.onCancellationRequested(()=>F.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(N){return this.tasks.get(N)?.coverage}createRun(N){const U=this.dto.id,q=this.dto.controllerId,F=(0,w.generateUuid)(),B=new m(this.proxy,U,F),Q=ae=>(we,...he)=>{if(X){console.warn(`Setting the state of test "${we.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(we)&&(this.ensureTestIsKnown(we),ae(we,...he))},J=(ae,we)=>{const he=we instanceof Array?we.map(i.TestMessage.from):[i.TestMessage.from(we)];if(ae.uri&&ae.range){const fe={range:i.Range.from(ae.range),uri:ae.uri};for(const V of he)V.location=V.location||fe}this.proxy.$appendTestMessagesInRun(U,F,h.TestId.fromExtHostTestItem(ae,q).toString(),he)};let X=!1;const ie={isPersisted:this.dto.isPersisted,token:this.cts.token,name:N,get coverageProvider(){return B.coverageProvider},set coverageProvider(ae){B.coverageProvider=ae},enqueued:Q(ae=>{this.proxy.$updateTestStateInRun(U,F,h.TestId.fromExtHostTestItem(ae,q).toString(),1)}),skipped:Q(ae=>{this.proxy.$updateTestStateInRun(U,F,h.TestId.fromExtHostTestItem(ae,q).toString(),5)}),started:Q(ae=>{this.proxy.$updateTestStateInRun(U,F,h.TestId.fromExtHostTestItem(ae,q).toString(),2)}),errored:Q((ae,we,he)=>{J(ae,we),this.proxy.$updateTestStateInRun(U,F,h.TestId.fromExtHostTestItem(ae,q).toString(),6,he)}),failed:Q((ae,we,he)=>{J(ae,we),this.proxy.$updateTestStateInRun(U,F,h.TestId.fromExtHostTestItem(ae,q).toString(),4,he)}),passed:Q((ae,we)=>{this.proxy.$updateTestStateInRun(U,F,h.TestId.fromExtHostTestItem(ae,this.dto.controllerId).toString(),3,we)}),appendOutput:(ae,we,he)=>{X||(he&&(this.dto.isIncluded(he)?this.ensureTestIsKnown(he):he=void 0),this.proxy.$appendOutputToRun(U,F,l.VSBuffer.fromString(ae),we&&i.location.from(we),he&&h.TestId.fromExtHostTestItem(he,q).toString()))},end:()=>{X||(X=!0,this.proxy.$finishedTestRunTask(U,F),this.tasks.delete(F),this.tasks.size||this.markEnded())}};return this.tasks.set(F,{run:ie,coverage:B}),this.proxy.$startedTestRunTask(U,{id:F,name:N,running:!0}),ie}forciblyEndTasks(){for(const{run:N}of this.tasks.values())N.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(N){if(!(N instanceof b.TestItemImpl))throw new S.InvalidTestItemError(N.id);if(this.sharedTestIds.has(h.TestId.fromExtHostTestItem(N,this.dto.controllerId).toString()))return;const U=[],q=this.dto.colllection.root;for(;;){const F=i.TestItem.from(N);if(U.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),N===q))break;N=N.parent||q}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class _{get trackers(){return this.tracked.values()}constructor(N){this.proxy=N,this.tracked=new Map}prepareForMainThreadTestRun(N,U,q){return this.getTracker(N,U,q)}cancelRunById(N){for(const U of this.tracked.values())if(U.id===N){U.cancel();return}}cancelAllRuns(){for(const N of this.tracked.values())N.cancel()}createTestRun(N,U,q,F,B){const Q=this.tracked.get(q);if(Q)return Q.createRun(F);const J=u.fromPublic(N,U,q,B),X=c(q);this.proxy.$startedExtensionTestRun({controllerId:N,continuous:!!q.continuous,profile:X&&{group:W[X.kind],id:X.profileId},exclude:q.exclude?.map(ae=>h.TestId.fromExtHostTestItem(ae,U.root.id).toString())??[],id:J.id,include:q.include?.map(ae=>h.TestId.fromExtHostTestItem(ae,U.root.id).toString())??[U.root.id],persist:B});const ie=this.getTracker(q,J);return ie.onEnd(()=>{this.proxy.$finishedExtensionTestRun(J.id),ie.dispose()}),ie.createRun(F)}getTracker(N,U,q){const F=new v(U,this.proxy,q);return this.tracked.set(N,F),F.onEnd(()=>this.tracked.delete(N)),F}}e.TestRunCoordinator=_;const c=$=>{if($.profile){if(!($.profile instanceof M))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class u{static fromPublic(N,U,q,F){return new u(N,(0,w.generateUuid)(),q.include?.map(B=>h.TestId.fromExtHostTestItem(B,N).toString())??[N],q.exclude?.map(B=>h.TestId.fromExtHostTestItem(B,N).toString())??[],F,U)}static fromInternal(N,U){return new u(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,U)}constructor(N,U,q,F,B,Q){this.controllerId=N,this.id=U,this.isPersisted=B,this.colllection=Q,this.includePrefix=q.map(J=>J+"\0"),this.excludePrefix=F.map(J=>J+"\0")}isIncluded(N){const U=h.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const q of this.excludePrefix)if(U===q||U.startsWith(q))return!1;for(const q of this.includePrefix)if(U===q||U.startsWith(q))return!0;return!1}}e.TestRunDto=u;class m{set coverageProvider(N){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this._coverageProvider=N,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(N,U,q){this.proxy=N,this.runId=U,this.taskId=q}async provideFileCoverage(N){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(N))());try{return(await this.fileCoverage)?.map(i.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(N,U){const q=await this.fileCoverage;let F=q?.[N];return!this._coverageProvider||!q||!F?[]:(F.detailedCoverage||(F=q[N]=await this._coverageProvider.resolveFileCoverage?.(F,U)??F),F.detailedCoverage?.map(i.TestCoverage.fromDetailed)??[])}}class f{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(N){this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(N){this.added.add(N)}update(N){Object.assign(N.revived,i.TestItem.toPlain(N.item)),this.added.has(N)||this.updated.add(N)}remove(N){if(this.added.has(N)){this.added.delete(N);return}this.updated.delete(N);const U=h.TestId.parentId(N.item.extId);if(U&&this.alreadyRemoved.has(U.toString())){this.alreadyRemoved.add(N.item.extId);return}this.removed.add(N)}getChangeEvent(){const{added:N,updated:U,removed:q}=this;return{get added(){return[...N].map(F=>F.revived)},get updated(){return[...U].map(F=>F.revived)},get removed(){return[...q].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class n extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(N){return this.items.get(N)}getMirroredTestDataByReference(N){return this.items.get(N.id)}createItem(N,U){return{...N,revived:i.TestItem.toPlain(N.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new f(this.changeEmitter)}}class D{constructor(N){this.proxy=N}checkout(){this.current||(this.current=this.createObserverData());const N=this.current;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(U=>U.revived)},dispose:(0,P.once)(()=>{--N.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(N){return this.current?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.current?.tests.apply(N)}createObserverData(){const N=new n;return this.proxy.$subscribeToDiffs(),{observers:0,tests:N}}}class M{get label(){return this._label}set label(N){N!==this._label&&(this._label=N,xe(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(N){N!==this._supportsContinuousRun&&(this._supportsContinuousRun=N,xe(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this._isDefault}set isDefault(N){N!==this._isDefault&&(this._isDefault=N,xe(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,xe(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?i.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(N){N!==this._configureHandler&&(this._configureHandler=N,xe(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,U,q,F,B,Q,J,X=!1,ie=void 0,ae=!1){this.controllerId=q,this.profileId=F,this._label=B,this.kind=Q,this.runHandler=J,this._isDefault=X,this._tag=ie,this._supportsContinuousRun=ae,p.set(this,void 0),t.set(this,void 0),Je(this,p,N,"f"),Je(this,t,U,"f"),U.set(F,this);const we=W[Q];if(typeof we!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);xe(this,p,"f").$publishTestRunProfile({profileId:F,controllerId:q,tag:ie?i.TestTag.namespace(this.controllerId,ie.id):null,label:B,group:we,isDefault:X,hasConfigurationHandler:!1,supportsContinuousRun:ae})}dispose(){xe(this,t,"f")?.delete(this.profileId)&&(Je(this,t,void 0,"f"),xe(this,p,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=M,p=new WeakMap,t=new WeakMap;const W={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(De[291],Ie([1,0,18,8,3,5,139,11,7]),function(oe,e,o,A,l,R,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class g{constructor(I,w){this._extHostDocumentsAndEditors=w,this._onDidChangeTextEditorSelection=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=I.getProxy(R.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(k=>this._onDidChangeVisibleTextEditors.fire(k)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(k=>this._onDidChangeActiveTextEditor.fire(k))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(I){const w=this._extHostDocumentsAndEditors.allEditors();return I?w:w.map(k=>k.value)}async showTextDocument(I,w,k){let C;typeof w=="number"?C={position:P.ViewColumn.from(w),preserveFocus:k}:typeof w=="object"?C={position:P.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?P.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:C={preserveFocus:!1};const b=await this._proxy.$tryShowTextDocument(I.uri,C),i=b&&this._extHostDocumentsAndEditors.getEditor(b);if(i)return i.value;throw b?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,w){return new T.TextEditorDecorationType(this._proxy,I,w).value}$acceptEditorPropertiesChanged(I,w){const k=this._extHostDocumentsAndEditors.getEditor(I);if(!k)throw new Error("unknown text editor");if(w.options&&k._acceptOptions(w.options),w.selections){const C=w.selections.selections.map(P.Selection.to);k._acceptSelections(C)}if(w.visibleRanges){const C=o.coalesce(w.visibleRanges.map(P.Range.to));k._acceptVisibleRanges(C)}if(w.options&&this._onDidChangeTextEditorOptions.fire({textEditor:k.value,options:{...w.options,lineNumbers:P.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const C=y.TextEditorSelectionChangeKind.fromValue(w.selections.source),b=w.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:k.value,selections:b,kind:C})}if(w.visibleRanges){const C=o.coalesce(w.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:k.value,visibleRanges:C})}}$acceptEditorPositionData(I){for(const w in I){const k=this._extHostDocumentsAndEditors.getEditor(w);if(!k)throw new Error("Unknown text editor");const C=P.ViewColumn.to(I[w]);k.value.viewColumn!==C&&(k._acceptViewColumn(C),this._onDidChangeTextEditorViewColumn.fire({textEditor:k.value,viewColumn:C}))}}getDiffInformation(I){return Promise.resolve(this._proxy.$getDiffInformation(I))}}e.ExtHostEditors=g}),define(De[292],Ie([1,0,2,4,5,6,7,11,25,10]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class L{constructor(k,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=k.getProxy(l.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(b,i)=>{if(b&&b.$mid===12)if(this._providers.get(b.source)&&y.ExtensionIdentifier.equals(i,this._providers.get(b.source)?.extension)){const d=b.uri===void 0?void 0:o.URI.revive(b.uri);return this._itemsBySourceAndUriMap.get(b.source)?.get(I(d))?.get(b.handle)}else return;return b}})}async $getTimeline(k,C,b,i){return this._providers.get(k)?.provider.provideTimeline(o.URI.revive(C),b,i)}registerTimelineProvider(k,C,b,i){const d=new R.DisposableStore,h=this.convertTimelineItem(C.id,i,d).bind(this);let S;C.onDidChange&&(S=C.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:C.id}),this));const E=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:k,onDidChange:void 0,async provideTimeline(p,t,s){t?.resetCache&&(d.clear(),E.get(C.id)?.clear());const r=await C.provideTimeline(p,t,s);if(r==null)return;const a=h(p,t);return{...r,source:C.id,items:r.items.map(a)}},dispose(){for(const p of E.values())p.get(C.id)?.clear();S?.dispose(),d.dispose()}},b)}convertTimelineItem(k,C,b){return(i,d)=>{let h;if(d?.cacheResults){let S=this._itemsBySourceAndUriMap.get(k);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(k,S));const E=I(i);h=S.get(E),h===void 0&&(h=new Map,S.set(E,h))}return S=>{const{iconPath:E,...p}=S,t=`${k}|${S.id??S.timestamp}`;h?.set(t,S);let s,r,a;S.iconPath&&(E instanceof T.ThemeIcon?a={id:E.id,color:E.color}:o.URI.isUri(E)?(s=E,r=E):{light:s,dark:r}=E);let v;return T.MarkdownString.isMarkdownString(p.tooltip)?v=P.MarkdownString.from(p.tooltip):(0,g.isString)(p.tooltip)?v=p.tooltip:T.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=P.MarkdownString.from(p.detail)):(0,g.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=p.detail),{...p,id:p.id??void 0,handle:t,source:k,command:S.command?C.toInternal(S.command,b):void 0,icon:s,iconDark:r,themeIcon:a,tooltip:v,accessibilityInformation:S.accessibilityInformation}}}}registerTimelineProviderCore(k,C){if(this._providers.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this._proxy.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this._providers.set(k.id,{provider:k,extension:C}),(0,R.toDisposable)(()=>{for(const i of this._itemsBySourceAndUriMap.values())i.get(k.id)?.clear();this._providers.delete(k.id),this._proxy.$unregisterTimelineProvider(k.id),k.dispose()})}}e.ExtHostTimeline=L;function I(w){return w?.toString()}}),define(De[293],Ie([1,0,6,16,2,5]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(y){this._openers=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,g,L,I){if(this._openers.has(g))throw new Error(`Opener with id '${g}' already registered`);const w=I.schemes.find(k=>!T.supportedSchemes.has(k));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this._openers.set(g,L),this._proxy.$registerUriOpener(g,I.schemes,y,I.label),(0,o.toDisposable)(()=>{this._openers.delete(g),this._proxy.$unregisterUriOpener(g)})}async $canOpenUri(y,g,L){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener with id: ${y}`);const w=l.URI.revive(g);return I.canOpenExternalUri(w,L)}async $openUri(y,g,L){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener id: '${y}'`);return I.openExternalUri(l.URI.revive(g.resolvedUri),{sourceUri:l.URI.revive(g.sourceUri)},L)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([A.Schemas.http,A.Schemas.https])}),define(De[294],Ie([1,0,5,2,6,8,25]),function(oe,e,o,A,l,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(g){this.handles=new T.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=g.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(g,L){if(this.handles.has(g))throw new Error(`Protocol handler already registered for extension ${g}`);const I=P.HandlePool++;return this.handles.add(g),this.handlers.set(I,L),this._proxy.$registerUriHandler(I,g),(0,l.toDisposable)(()=>{this.handles.delete(g),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(g,L){const I=this.handlers.get(g);if(!I)return Promise.resolve(void 0);try{I.handleUri(A.URI.revive(L))}catch(w){(0,R.onUnexpectedError)(w)}return Promise.resolve(void 0)}async createAppUri(g){return A.URI.revive(await this._proxy.$createAppUri(g))}}e.ExtHostUrls=P,P.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(oe,e,o,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,o):l?l.value=o:e.set(oe,o),o},xe=this&&this.__classPrivateFieldGet||function(oe,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(oe):A?A.value:e.get(oe)};define(De[82],Ie([1,0,3,16,23,2,207,232,96,5]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";var L,I,w,k,C,b,i,d,h,S,E,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(n,D,M,W,$,N,U){L.set(this,void 0),I.set(this,void 0),w.set(this,void 0),k.set(this,void 0),C.set(this,void 0),b.set(this,void 0),i.set(this,""),d.set(this,void 0),h.set(this,!1),S.set(this,!1),E.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new o.Emitter),this._onDidDispose=xe(this,t,"f").event,Je(this,L,n,"f"),Je(this,I,D,"f"),Je(this,d,M,"f"),Je(this,k,W,"f"),Je(this,C,$,"f"),Je(this,b,N,"f"),Je(this,E,r(N),"f"),Je(this,p,a(N),"f"),Je(this,w,U,"f")}dispose(){Je(this,h,!0,"f"),xe(this,t,"f").fire(),xe(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return Je(this,S,!0,"f"),(0,y.asWebviewUri)(n,xe(this,k,"f"))}get cspSource(){const n=xe(this,b,"f").extensionLocation;if(n.scheme===A.Schemas.https||n.scheme===A.Schemas.http){let D=n.toString();return D.endsWith("/")||(D+="/"),D+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),xe(this,i,"f")}set html(n){this.assertNotDisposed(),xe(this,i,"f")!==n&&(Je(this,i,n,"f"),xe(this,p,"f")&&!xe(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(Je(this,S,!0,"f"),xe(this,w,"f").report("Webview vscode-resource: uris",xe(this,b,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),xe(this,I,"f").$setHtml(xe(this,L,"f"),this.rewriteOldResourceUrlsIfNeeded(n)))}get options(){return this.assertNotDisposed(),xe(this,d,"f")}set options(n){this.assertNotDisposed(),l.equals(xe(this,d,"f"),n)||xe(this,I,"f").$setOptions(xe(this,L,"f"),c(xe(this,b,"f"),xe(this,C,"f"),n)),Je(this,d,n,"f")}async postMessage(n){if(xe(this,h,"f"))return!1;const D=(0,P.serializeWebviewMessage)(n,{serializeBuffersForPostMessage:xe(this,E,"f")});return xe(this,I,"f").$postMessage(xe(this,L,"f"),D.message,...D.buffers)}assertNotDisposed(){if(xe(this,h,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(n){if(!xe(this,p,"f"))return n;const D=xe(this,b,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,M=xe(this,b,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?xe(this,b,"f").extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(W,$,N,U,q,F)=>{const B=R.URI.from({scheme:U||"file",path:decodeURIComponent(q)}),Q=(0,y.asWebviewUri)(B,{isRemote:D,authority:M}).toString();return`${$}${Q}${F}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(W,$,N,U,q,F)=>{const B=R.URI.from({scheme:U||"file",path:decodeURIComponent(q)}),Q=(0,y.asWebviewUri)(B,{isRemote:D,authority:M}).toString();return`${$}${Q}${F}`})}}e.ExtHostWebview=s,L=new WeakMap,I=new WeakMap,w=new WeakMap,k=new WeakMap,C=new WeakMap,b=new WeakMap,i=new WeakMap,d=new WeakMap,h=new WeakMap,S=new WeakMap,E=new WeakMap,p=new WeakMap,t=new WeakMap;function r(f){try{const n=(0,T.normalizeVersion)((0,T.parseVersion)(f.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function a(f){try{const n=(0,T.normalizeVersion)((0,T.parseVersion)(f.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class v{constructor(n,D,M,W,$){this.remoteInfo=D,this.workspace=M,this._logService=W,this._deprecationService=$,this._webviews=new Map,this._webviewProxy=n.getProxy(g.MainContext.MainThreadWebviews)}$onMessage(n,D,M){const W=this.getWebview(n);if(W){const{message:$}=(0,P.deserializeWebviewMessage)(D,M.value);W._onMessageEmitter.fire($)}}$onMissingCsp(n,D){this._logService.warn(`${D} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,D,M){const W=new s(n,this._webviewProxy,u(D),this.remoteInfo,this.workspace,M,this._deprecationService);return this._webviews.set(n,W),W._onDidDispose(()=>{this._webviews.delete(n)}),W}deleteWebview(n){this._webviews.delete(n)}getWebview(n){return this._webviews.get(n)}}e.ExtHostWebviews=v;function _(f){return{id:f.identifier,location:f.extensionLocation}}e.toExtensionData=_;function c(f,n,D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,enableForms:D.enableForms,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots||m(f,n)}}e.serializeWebviewOptions=c;function u(f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots?.map(n=>R.URI.from(n))}}function m(f,n){return[...(n?.getWorkspaceFolders()||[]).map(D=>D.uri),f.extensionLocation]}}),define(De[295],Ie([1,0,21,69,6,16,24,2,11,82,76,5,7]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class k{constructor(s,r){this.document=s,this._storagePath=r,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,r){await this.getEdit(s).undo(),r||this.disposeBackup()}async redo(s,r){await this.getEdit(s).redo(),r||this.disposeBackup()}disposeEdits(s){for(const r of s)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=p(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const r=this._edits.get(s,0);if(!r)throw new Error("No edit found");return r}}class C{constructor(){this._documents=new Map}get(s,r){return this._documents.get(this.key(s,r))}add(s,r,a){const v=this.key(s,r.uri);if(this._documents.has(v))throw new Error(`Document already exists for viewType:${s} resource:${r.uri}`);const _=new k(r,a);return this._documents.set(v,_),_}delete(s,r){const a=this.key(s,r.uri);this._documents.delete(a)}key(s,r){return`${s}@@@${r}`}}var b;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(b||(b={}));class i{constructor(){this._providers=new Map}addTextProvider(s,r,a){return this.add(0,s,r,a)}addCustomProvider(s,r,a){return this.add(1,s,r,a)}get(s){return this._providers.get(s)}add(s,r,a,v){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:s,extension:a,provider:v}),new w.Disposable(()=>this._providers.delete(r))}}class d{constructor(s,r,a,v,_){this._extHostDocuments=r,this._extensionStoragePaths=a,this._extHostWebview=v,this._extHostWebviewPanels=_,this._editorProviders=new i,this._documents=new C,this._proxy=s.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,r,a,v){const _=new l.DisposableStore;return S(a)?(_.add(this._editorProviders.addTextProvider(r,s,a)),this._proxy.$registerTextEditorProvider((0,g.toExtensionData)(s),r,v.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,g.shouldSerializeBuffersForPostMessage)(s))):(_.add(this._editorProviders.addCustomProvider(r,s,a)),h(a)&&_.add(a.onDidChangeCustomDocument(c=>{const u=this.getCustomDocumentEntry(r,c.document.uri);if(E(c)){const m=u.addEdit(c);this._proxy.$onDidEdit(c.document.uri,r,m,c.label)}else this._proxy.$onContentChange(c.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,g.toExtensionData)(s),r,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,g.shouldSerializeBuffersForPostMessage)(s))),w.Disposable.from(_,new w.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(s,r,a,v,_){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${r}'`);const u=P.URI.revive(s),m=await c.provider.openCustomDocument(u,{backupId:a,untitledDocumentData:v?.buffer},_);let f;return h(c.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(c.extension)??this._extensionStoragePaths.globalValue(c.extension)),this._documents.add(r,m,f),{editable:h(c.provider)}}async $disposeCustomDocument(s,r){const a=this._editorProviders.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${r}'`);const v=P.URI.revive(s),{document:_}=this.getCustomDocumentEntry(r,v);this._documents.delete(r,_),_.dispose()}async $resolveCustomEditor(s,r,a,v,_,c){const u=this._editorProviders.get(a);if(!u)throw new Error(`No provider found for '${a}'`);const m=y.ViewColumn.to(_),f=this._extHostWebview.createNewWebview(r,v.contentOptions,u.extension),n=this._extHostWebviewPanels.createNewWebviewPanel(r,a,v.title,m,v.options,f,!0),D=P.URI.revive(s);switch(u.type){case 1:{const{document:M}=this.getCustomDocumentEntry(a,D);return u.provider.resolveCustomEditor(M,n,c)}case 0:{const M=this._extHostDocuments.getDocument(D);return u.provider.resolveCustomTextEditor(M,n,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,r,a){this.getCustomDocumentEntry(r,s).disposeEdits(a)}async $onMoveCustomEditor(s,r,a){const v=this._editorProviders.get(a);if(!v)throw new Error(`No provider found for '${a}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const _=this._extHostWebviewPanels.getWebviewPanel(s);if(!_)throw new Error("No webview found");const c=P.URI.revive(r),u=this._extHostDocuments.getDocument(c);await v.provider.moveCustomTextEditor(u,_,o.CancellationToken.None)}async $undo(s,r,a,v){return this.getCustomDocumentEntry(r,s).undo(a,v)}async $redo(s,r,a,v){return this.getCustomDocumentEntry(r,s).redo(a,v)}async $revert(s,r,a){const v=this.getCustomDocumentEntry(r,s);await this.getCustomEditorProvider(r).revertCustomDocument(v.document,a),v.disposeBackup()}async $onSave(s,r,a){const v=this.getCustomDocumentEntry(r,s);await this.getCustomEditorProvider(r).saveCustomDocument(v.document,a),v.disposeBackup()}async $onSaveAs(s,r,a,v){const _=this.getCustomDocumentEntry(r,s);return this.getCustomEditorProvider(r).saveCustomDocumentAs(_.document,P.URI.revive(a),v)}async $backup(s,r,a){const v=this.getCustomDocumentEntry(r,s),c=await this.getCustomEditorProvider(r).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},a);return v.updateBackup(c),c.id}getCustomDocumentEntry(s,r){const a=this._documents.get(s,P.URI.revive(r));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(s){const a=this._editorProviders.get(s)?.provider;if(!a||!h(a))throw new Error("Custom document is not editable");return a}}e.ExtHostCustomEditors=d;function h(t){return!!t.onDidChangeCustomDocument}function S(t){return typeof t.resolveCustomTextEditor=="function"}function E(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function p(t){const s=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,A.hash)(s)+""}});var Je=this&&this.__classPrivateFieldSet||function(oe,e,o,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,o):l?l.value=o:e.set(oe,o),o},xe=this&&this.__classPrivateFieldGet||function(oe,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(oe):A?A.value:e.get(oe)};define(De[296],Ie([1,0,3,6,2,30,11,82,5,7]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";var L,I,w,k,C,b,i,d,h,S,E,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends A.Disposable{constructor(_,c,u,m){super(),L.set(this,void 0),I.set(this,void 0),w.set(this,void 0),k.set(this,void 0),C.set(this,void 0),b.set(this,void 0),i.set(this,void 0),d.set(this,void 0),h.set(this,!0),S.set(this,void 0),E.set(this,!1),p.set(this,this._register(new o.Emitter)),this.onDidDispose=xe(this,p,"f").event,t.set(this,this._register(new o.Emitter)),this.onDidChangeViewState=xe(this,t,"f").event,Je(this,L,_,"f"),Je(this,I,c,"f"),Je(this,k,u,"f"),Je(this,w,m.viewType,"f"),Je(this,C,m.panelOptions,"f"),Je(this,d,m.viewColumn,"f"),Je(this,b,m.title,"f"),Je(this,S,m.active,"f")}dispose(){xe(this,E,"f")||(Je(this,E,!0,"f"),xe(this,p,"f").fire(),xe(this,I,"f").$disposeWebview(xe(this,L,"f")),xe(this,k,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),xe(this,k,"f")}get viewType(){return this.assertNotDisposed(),xe(this,w,"f")}get title(){return this.assertNotDisposed(),xe(this,b,"f")}set title(_){this.assertNotDisposed(),xe(this,b,"f")!==_&&(Je(this,b,_,"f"),xe(this,I,"f").$setTitle(xe(this,L,"f"),_))}get iconPath(){return this.assertNotDisposed(),xe(this,i,"f")}set iconPath(_){this.assertNotDisposed(),xe(this,i,"f")!==_&&(Je(this,i,_,"f"),xe(this,I,"f").$setIconPath(xe(this,L,"f"),l.URI.isUri(_)?{light:_,dark:_}:_))}get options(){return xe(this,C,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof xe(this,d,"f")=="number"&&xe(this,d,"f")<0))return xe(this,d,"f")}get active(){return this.assertNotDisposed(),xe(this,S,"f")}get visible(){return this.assertNotDisposed(),xe(this,h,"f")}_updateViewState(_){xe(this,E,"f")||(this.active!==_.active||this.visible!==_.visible||this.viewColumn!==_.viewColumn)&&(Je(this,S,_.active,"f"),Je(this,h,_.visible,"f"),Je(this,d,_.viewColumn,"f"),xe(this,t,"f").fire({webviewPanel:this}))}reveal(_,c){this.assertNotDisposed(),xe(this,I,"f").$reveal(xe(this,L,"f"),{viewColumn:typeof _>"u"?void 0:T.ViewColumn.from(_),preserveFocus:!!c})}assertNotDisposed(){if(xe(this,E,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,I=new WeakMap,w=new WeakMap,k=new WeakMap,C=new WeakMap,b=new WeakMap,i=new WeakMap,d=new WeakMap,h=new WeakMap,S=new WeakMap,E=new WeakMap,p=new WeakMap,t=new WeakMap;class r{static newHandle(){return(0,R.generateUuid)()}constructor(_,c,u){this.webviews=c,this.workspace=u,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=_.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(_,c,u,m,f={}){const n=typeof m=="object"?m.viewColumn:m,D={viewColumn:T.ViewColumn.from(n),preserveFocus:typeof m=="object"&&!!m.preserveFocus},M=(0,P.shouldSerializeBuffersForPostMessage)(_),W=r.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(_),W,c,{title:u,panelOptions:a(f),webviewOptions:(0,P.serializeWebviewOptions)(_,this.workspace,f),serializeBuffersForPostMessage:M},D);const $=this.webviews.createNewWebview(W,f,_);return this.createNewWebviewPanel(W,c,u,n,f,$,!0)}$onDidChangeWebviewPanelViewStates(_){const c=Object.keys(_);c.sort((u,m)=>{const f=_[u],n=_[m];return f.active?1:n.active?-1:+f.visible-+n.visible});for(const u of c){const m=this.getWebviewPanel(u);if(!m)continue;const f=_[u];m._updateViewState({active:f.active,visible:f.visible,viewColumn:T.ViewColumn.to(f.position)})}}async $onDidDisposeWebviewPanel(_){this.getWebviewPanel(_)?.dispose(),this._webviewPanels.delete(_),this.webviews.deleteWebview(_)}registerWebviewPanelSerializer(_,c,u){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:u,extension:_}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(_)}),new g.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(_,c,u,m){const f=this._serializers.get(c);if(!f)throw new Error(`No serializer found for '${c}'`);const{serializer:n,extension:D}=f,M=this.webviews.createNewWebview(_,u.webviewOptions,D),W=this.createNewWebviewPanel(_,c,u.title,m,u.panelOptions,M,u.active);await n.deserializeWebviewPanel(W,u.state)}createNewWebviewPanel(_,c,u,m,f,n,D){const M=new s(_,this._proxy,n,{viewType:c,title:u,viewColumn:m,panelOptions:f,active:D});return this._webviewPanels.set(_,M),M}getWebviewPanel(_){return this._webviewPanels.get(_)}}e.ExtHostWebviewPanels=r;function a(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(oe,e,o,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,o):l?l.value=o:e.set(oe,o),o},xe=this&&this.__classPrivateFieldGet||function(oe,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(oe):A?A.value:e.get(oe)};define(De[297],Ie([1,0,3,6,82,11,5,7]),function(oe,e,o,A,l,R,T,P){"use strict";var y,g,L,I,w,k,C,b,i,d,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends A.Disposable{constructor(t,s,r,a,v,_){super(),y.set(this,void 0),g.set(this,void 0),L.set(this,void 0),I.set(this,void 0),w.set(this,!1),k.set(this,void 0),C.set(this,void 0),b.set(this,void 0),i.set(this,void 0),d.set(this,this._register(new o.Emitter)),this.onDidChangeVisibility=xe(this,d,"f").event,h.set(this,this._register(new o.Emitter)),this.onDidDispose=xe(this,h,"f").event,Je(this,L,r,"f"),Je(this,C,a,"f"),Je(this,y,t,"f"),Je(this,g,s,"f"),Je(this,I,v,"f"),Je(this,k,_,"f")}dispose(){xe(this,w,"f")||(Je(this,w,!0,"f"),xe(this,h,"f").fire(),xe(this,I,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),xe(this,C,"f")}set title(t){this.assertNotDisposed(),xe(this,C,"f")!==t&&(Je(this,C,t,"f"),xe(this,g,"f").$setWebviewViewTitle(xe(this,y,"f"),t))}get description(){return this.assertNotDisposed(),xe(this,b,"f")}set description(t){this.assertNotDisposed(),xe(this,b,"f")!==t&&(Je(this,b,t,"f"),xe(this,g,"f").$setWebviewViewDescription(xe(this,y,"f"),t))}get visible(){return xe(this,k,"f")}get webview(){return xe(this,I,"f")}get viewType(){return xe(this,L,"f")}_setVisible(t){t===xe(this,k,"f")||xe(this,w,"f")||(Je(this,k,t,"f"),xe(this,d,"f").fire())}get badge(){return this.assertNotDisposed(),xe(this,i,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===xe(this,i,"f")?.value&&t?.tooltip===xe(this,i,"f")?.tooltip)&&(Je(this,i,R.ViewBadge.from(t),"f"),xe(this,g,"f").$setWebviewViewBadge(xe(this,y,"f"),t))}show(t){this.assertNotDisposed(),xe(this,g,"f").$show(xe(this,y,"f"),!!t)}assertNotDisposed(){if(xe(this,w,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,g=new WeakMap,L=new WeakMap,I=new WeakMap,w=new WeakMap,k=new WeakMap,C=new WeakMap,b=new WeakMap,i=new WeakMap,d=new WeakMap,h=new WeakMap;class E{constructor(t,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,s,r,a){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:r,extension:t}),this._proxy.$registerWebviewViewProvider((0,l.toExtensionData)(t),s,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,l.shouldSerializeBuffersForPostMessage)(t)}),new P.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(t,s,r,a,v){const _=this._viewProviders.get(s);if(!_)throw new Error(`No view provider found for '${s}'`);const{provider:c,extension:u}=_,m=this._extHostWebview.createNewWebview(t,{},u),f=new S(t,this._proxy,s,r,m,!0);this._webviewViews.set(t,f),await c.resolveWebviewView(f,{state:a},v)}async $onDidChangeWebviewViewVisibility(t,s){this.getWebviewView(t)._setVisible(s)}async $disposeWebviewView(t){const s=this.getWebviewView(t);this._webviewViews.delete(t),s.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const s=this._webviewViews.get(t);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=E}),define(De[142],Ie([1,0,3,5,2,16,9,4,20]),function(oe,e,o,A,l,R,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let g=e.ExtHostWindow=class Cn{get state(){return this._state}constructor(I){this._onDidChangeWindowState=new o.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Cn.InitialState,this._proxy=I.getProxy(A.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(w=>this.$onDidChangeWindowFocus(w))}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,w){let k;if(typeof I=="string"){k=I;try{I=l.URI.parse(I)}catch{return Promise.reject(`Invalid uri - '${I}'`)}}return(0,T.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,k,w)}async asExternalUri(I,w){if((0,T.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const k=await this._proxy.$asExternalUri(I,w);return l.URI.from(k)}};g.InitialState={focused:!0},e.ExtHostWindow=g=Ve([ze(0,y.IExtHostRpcService)],g),e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(De[298],Ie([1,0,266,26,20]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let T=e.ExtHostConsoleForwarder=class extends o.AbstractExtHostConsoleForwarder{constructor(y,g){super(y,g),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(y,g,L){const I=y==="error"||y==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,I.write(`
START_NATIVE_LOG
`),g.apply(console,L),I.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(y,g){const L=process[y],I=L.write;let w="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(k,C,b)=>{if(!this._isMakingConsoleCall){w+=k.toString(C);const i=w.length>R?w.length:w.lastIndexOf(`
`);i!==-1&&(console[g](w.slice(0,i)),w=w.slice(i+1))}I.call(L,k,C,b)}})}};e.ExtHostConsoleForwarder=T=Ve([ze(0,l.IExtHostRpcService),ze(1,A.IExtHostInitDataService)],T)}),define(De[299],Ie([1,0,15,55,30,41,6,5,2,20]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=e.ExtHostDownloadService=class extends T.Disposable{constructor(w,k){super();const C=w.getProxy(P.MainContext.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async b=>{const i=y.URI.file((0,o.join)((0,A.tmpdir)(),(0,l.generateUuid)()));return await C.$download(b,i),i})}};e.ExtHostDownloadService=L=Ve([ze(0,g.IExtHostRpcService),ze(1,R.IExtHostCommands)],L)}),define(De[300],Ie([1,0,141,16,214,30]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class T extends o.ExtHostLoggerService{doCreateLogger(y,g,L){return y.scheme===A.Schemas.file?new l.SpdLogLogger(L?.name||(0,R.generateUuid)(),y.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,g):super.doCreateLogger(y,g,L)}registerLogger(y){super.registerLogger(y),this._proxy.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this._proxy.$deregisterLogger(y)}}e.ExtHostLoggerService=T}),define(De[301],Ie([1,0,72,15,2,81,6,16,19,29]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const s=await super._getWorkspaceStorageURI(t);if(s.scheme!==P.Schemas.file)return s;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const r=s.fsPath;let a=0;do{let v;a===0?v=r:v=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${a}`:`${r}-${a}`,await I(v);const _=A.join(v,"vscode.lock"),c=await b(this._logService,_,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),l.URI.file(v);a++}while(a<10);return s}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function I(p){try{await g.Promises.stat(p);return}catch{}try{await g.Promises.mkdir(p,{recursive:!0})}catch{}}const w=1e3,k=10*60*1e3;class C extends T.Disposable{constructor(t,s){super(),this.logService=t,this.filename=s,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await i(t,s);(!r||r.pid!==process.pid)&&(t.info(`Lock '${s}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.Promises.utimes(s,new Date,new Date)}catch(a){t.error(a),t.info(`Lock '${s}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{o.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+t};await g.Promises.writeFile(this.filename,JSON.stringify(s),{flag:"w"})}catch(s){this.logService.error(s)}}}async function b(p,t,s){try{const a={pid:process.pid,willReleaseAt:0};await g.Promises.writeFile(t,JSON.stringify(a),{flag:"wx"})}catch(a){p.error(a)}const r=await i(p,t);return!r||r.pid!==process.pid?s?(p.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),S(p,t)):(p.info(`Lock '${t}': Lock acquired.`),new C(p,t))}async function i(p,t){let s;try{s=await g.Promises.readFile(t)}catch(r){return p.error(r),null}try{return JSON.parse(String(s))}catch(r){return p.error(r),null}}async function d(p,t){let s;try{s=await g.Promises.stat(t)}catch(r){return p.error(r),0}return s.mtime.getTime()}function h(p){try{return process.kill(p,0),!0}catch{return!1}}async function S(p,t){const s=await i(p,t);if(!s)return p.info(`Lock '${t}': Could not read pid of lock holder.`),E(p,t);if(s.willReleaseAt){let c=s.willReleaseAt-Date.now();if(c<5e3){for(c>0?p.info(`Lock '${t}': The lockfile is scheduled to be released in ${c} ms.`):p.info(`Lock '${t}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,y.timeout)(Math.min(100,c)),await d(p,t)===0)return E(p,t);c=s.willReleaseAt-Date.now()}return E(p,t)}}if(!h(s.pid))return p.info(`Lock '${t}': The pid ${s.pid} appears to be gone.`),E(p,t);const r=await d(p,t),a=Date.now()-r;if(a<=k)return p.info(`Lock '${t}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;p.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const v=await d(p,t),_=Date.now()-v;return _<=k?(p.info(`Lock '${t}': The lock does not look stale, elapsed: ${_} ms, giving up.`),null):(p.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),E(p,t))}async function E(p,t){p.info(`Lock '${t}': Deleting a stale lock.`);try{await g.Promises.unlink(t)}catch{}return b(p,t,!0)}}),define(De[302],Ie([1,0,30,20,42]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=e.ExtHostTerminalService=class extends l.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,y,g){return this.createTerminalFromOptions({name:P,shellPath:y,shellArgs:g})}createTerminalFromOptions(P,y){const g=new l.ExtHostTerminal(this._proxy,(0,o.generateUuid)(),P,P.name);return this._terminals.push(g),g.create(P,this._serializeParentTerminal(P,y)),g.value}};e.ExtHostTerminalService=R=Ve([ze(0,A.IExtHostRpcService)],R)}),define(De[303],Ie([1,0,5,20,194,6,26,2,47,24,29,7,14,57,3,129,103,17]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class h extends b.DisposableTunnel{}function S(c){const u=c.trim().split(`
`),m=[];return u.forEach(n=>{const D=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(n);D&&D.length>=3&&m.push({pid:parseInt(D[1],10),socket:parseInt(D[2],10)})}),m.reduce((n,D)=>(n[D.socket]=D,n),{})}e.getSockets=S;function E(...c){const u=[].concat(...c.map(t));return[...new Map(u.filter(m=>m.st==="0A").map(m=>{const f=m.local_address.split(":");return{socket:parseInt(m.inode,10),ip:p(f[0]),port:parseInt(f[1],16)}}).map(m=>[m.ip+":"+m.port,m])).values()]}e.loadListeningPorts=E;function p(c){let u="";if(c.length===8)for(let m=c.length-2;m>=0;m-=2)u+=parseInt(c.substr(m,2),16),m!==0&&(u+=".");else for(let m=0;m<c.length;m+=8){const f=c.substring(m,m+8);let n="";for(let D=8;D>=2;D-=2)n+=f.substring(D-2,D),(D===6||D===2)&&(n=parseInt(n,16).toString(16),u+=`${n}`,n="",m+D!==c.length-6&&(u+=":"))}return u}e.parseIpAddress=p;function t(c){const u=c.trim().split(`
`),m=u.shift().trim().split(/\s+/).filter(n=>n!=="rx_queue"&&n!=="tm->when");return u.map(n=>n.trim().split(/\s+/).reduce((D,M,W)=>(D[m[W]||W]=M,D),{}))}e.loadConnectionTable=t;function s(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/server-main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function r(c){const u=c.trim().split(`
`),m=[];return u.forEach(f=>{const n=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(f);n&&n.length>=4&&m.push({pid:parseInt(n[1],10),ppid:parseInt(n[2]),cmd:n[3]})}),m}e.getRootProcesses=r;async function a(c,u,m){const f=m.reduce((D,M)=>(D[M.pid]=M,D),{}),n=[];return c.forEach(({socket:D,ip:M,port:W})=>{const $=u[D]?u[D].pid:void 0,N=$?f[$]?.cmd:void 0;$&&N&&!s(N)&&n.push({host:M,port:W,detail:N,pid:$})}),n}e.findPorts=a;function v(c,u,m){const f=new Map,n=r(u);for(const D of c){const M=m.get(D.port);if(M){f.set(D.port,M);continue}const W=n.find($=>$.cmd.includes(`${D.port}`));if(W){let $=W,N;do N=n.find(U=>U.ppid===$.pid),N&&($=N);while(N);f.set(D.port,{host:D.ip,port:D.port,pid:$.pid,detail:$.cmd,ppid:$.ppid})}else f.set(D.port,{host:D.ip,port:D.port,ppid:Number.MAX_VALUE})}return f}e.tryFindRootPorts=v;let _=e.ExtHostTunnelService=class extends R.Disposable{constructor(u,m,f){super(),this.logService=f,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new C.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._initialCandidates=void 0,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=u.getProxy(o.MainContext.MainThreadTunnelService),w.isLinux&&m.remote.isRemote&&m.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async openTunnel(u,m){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${u.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const f=await this._proxy.$openTunnel(m,u.displayName);if(f){const n=new h(f.remoteAddress,f.localAddress,()=>this._proxy.$closeTunnel(f.remoteAddress));return this._register(n),n}}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(u=>u.port).join(", ")}`)}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(u){return Math.max(u*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(u,m){const f=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(f,{selector:u,provider:m}),this._proxy.$registerPortsAttributesProvider(u,f),new I.Disposable(()=>{this._portAttributesProviders.delete(f),this._proxy.$unregisterPortsAttributesProvider(f)})}async $providePortAttributes(u,m,f,n,D){const M=[];for(const $ of u){const N=this._portAttributesProviders.get($);if(!N)return[];M.push(...await Promise.all(m.map(async U=>N.provider.providePortAttributes(U,f,n,D))))}const W=M.filter($=>!!$);return W.length>0?W.map($=>({autoForwardAction:$.autoForwardAction,port:$.port})):[]}async $registerCandidateFinder(u){if(u&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=u;let m;this._initialCandidates&&(m=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const f=new i.MovingAverage;let n=0;for(;this._candidateFindingEnabled;){const D=new Date().getTime(),M=(await this.findCandidatePorts()).filter(N=>(0,b.isLocalhost)(N.host)||(0,b.isAllInterfaces)(N.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(N=>N.port).join(", ")}`);const W=new Date().getTime()-D;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${W} ms.`),n++>3&&f.update(W),(!m||JSON.stringify(m)!==JSON.stringify(M))&&(m=M,await this._proxy.$onFoundNewCandidates(m));const $=this.calculateDelay(f.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${$} ms.`),await new Promise(N=>setTimeout(()=>N(),$))}}async setTunnelFactory(u){if(u){if(u.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(u.candidatePortSource),u.showCandidatePort&&(this._showCandidatePort=u.showCandidatePort,this._proxy.$setCandidateFilter()),u.tunnelFactory){this._forwardPortProvider=u.tunnelFactory;let m=u.tunnelFeatures?.privacyOptions??[];u.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:l.localize(0,null),themeIcon:"lock"},{id:"public",label:l.localize(1,null),themeIcon:"eye"}]);const f=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,public:!!u.tunnelFeatures?.public,privacyOptions:m}:void 0;this._proxy.$setTunnelProvider(f)}}else this._forwardPortProvider=void 0;return(0,R.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(u,m){if(this._extensionTunnels.has(u.host)){const f=this._extensionTunnels.get(u.host);f.has(u.port)&&(m&&f.get(u.port).disposeListener.dispose(),await f.get(u.port).tunnel.dispose(),f.delete(u.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(u,m){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const f=this._forwardPortProvider(u,m);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),f!==void 0){const n=await f;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(u.remoteAddress.host)||this._extensionTunnels.set(u.remoteAddress.host,new Map);const D=this._register(n.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(n.remoteAddress))));return this._extensionTunnels.get(u.remoteAddress.host).set(u.remoteAddress.port,{tunnel:n,disposeListener:D}),k.TunnelDtoConverter.fromApiTunnel(n)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(u){const m=await Promise.all(u.map(n=>this._showCandidatePort(n.host,n.port,n.detail??""))),f=u.filter((n,D)=>m[D]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${u.map(n=>n.port).join(", ")} to ${f.map(n=>n.port).join(", ")}`),f}async findCandidatePorts(){let u="",m="";try{u=await L.Promises.readFile("/proc/net/tcp","utf8"),m=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const f=E(u,m),n=await new Promise(F=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,Q,J)=>{F(Q)})}),D=S(n),M=await L.Promises.readdir("/proc"),W=[];for(const F of M)try{const B=Number(F),Q=g.joinPath(P.URI.file("/proc"),F);if((await L.Promises.stat(Q.fsPath)).isDirectory()&&!isNaN(B)){const X=await L.Promises.readlink(g.joinPath(Q,"cwd").fsPath),ie=await L.Promises.readFile(g.joinPath(Q,"cmdline").fsPath,"utf8");W.push({pid:B,cwd:X,cmd:ie})}}catch{}const $=[],N=f.filter(F=>{const B=D[F.socket];return B||$.push(F),B}),U=a(N,D,W);let q;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${$.length}`),$.length>0){const F=await new Promise(B=>{(0,y.exec)("ps -F -A -l | grep root",(Q,J,X)=>{B(J)})});this._foundRootPorts=v($,F,this._foundRootPorts),q=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${q.map(B=>B.port).join(", ")}`)}return U.then(F=>q?F.concat(q):F)}};e.ExtHostTunnelService=_=Ve([ze(0,A.IExtHostRpcService),ze(1,T.IExtHostInitDataService),ze(2,d.ILogService)],_)}),define(De[304],Ie([1,0,19,22,21,8,3,6,115,260,60]),function(oe,e,o,A,l,R,T,P,y,g,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function w(f,n){try{return JSON.stringify(f,n)}catch{return"null"}}const k="$$ref$$",C={[k]:-1};class b{constructor(n,D){this.jsonString=n,this.referencedBuffers=D}}function i(f,n=null,D=!1){const M=[];return{jsonString:(D?w:JSON.stringify)(f,($,N)=>{if(typeof N>"u")return C;if(typeof N=="object"){if(N instanceof A.VSBuffer){const U=M.push(N)-1;return{[k]:U}}if(n)return n($,N)}return N}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=i;function d(f,n,D){return JSON.parse(f,(M,W)=>{if(W){const $=W[k];if(typeof $=="number")return n[$];if(D&&W.$mid===1)return D.transformIncoming(W)}return W})}e.parseJsonAndRestoreBufferRefs=d;function h(f,n){return JSON.stringify(f,n)}function S(f){return f?(n,D)=>D&&D.$mid===1?f.transformOutgoing(D):D:null}var E;(function(f){f[f.LocalSide=0]="LocalSide",f[f.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));var p;(function(f){f[f.Responsive=0]="Responsive",f[f.Unresponsive=1]="Unresponsive"})(p||(e.ResponsiveState=p={}));const t=()=>{},s=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class a extends P.Disposable{constructor(n,D=null,M=null){super(),this[I]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=n,this._logger=D,this._uriTransformer=M,this._uriReplacer=S(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let W=0,$=L.ProxyIdentifier.count;W<$;W++)this._locals[W]=null,this._proxies[W]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new o.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(W=>this._receiveOneMessage(W))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(n=>{this._pendingRPCReplies[n].resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(n){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(n){this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(n){this._responsiveState!==n&&(this._responsiveState=n,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(n){return this._uriTransformer?(0,y.transformIncomingURIs)(n,this._uriTransformer):n}getProxy(n){const{nid:D,sid:M}=n;return this._proxies[D]||(this._proxies[D]=this._createProxy(D,M)),this._proxies[D]}_createProxy(n,D){const M={get:(W,$)=>(typeof $=="string"&&!W[$]&&$.charCodeAt(0)===36&&(W[$]=(...N)=>this._remoteCall(n,$,N)),$===r?D:W[$])};return new Proxy(Object.create(null),M)}set(n,D){return this._locals[n.nid]=D,D}assertRegistered(n){for(let D=0,M=n.length;D<M;D++){const W=n[D];if(!this._locals[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}_receiveOneMessage(n){if(this._isDisposed)return;const D=n.byteLength,M=v.read(n,0),W=M.readUInt8(),$=M.readUInt32();switch(W){case 1:case 2:{let{rpcId:N,method:U,args:q}=c.deserializeRequestJSONArgs(M);this._uriTransformer&&(q=(0,y.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(D,$,N,U,q,W===2);break}case 3:case 4:{let{rpcId:N,method:U,args:q}=c.deserializeRequestMixedArgs(M);this._uriTransformer&&(q=(0,y.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(D,$,N,U,q,W===4);break}case 5:{this._logger?.logIncoming(D,$,0,"ack"),this._onDidReceiveAcknowledge($);break}case 6:{this._receiveCancel(D,$);break}case 7:{this._receiveReply(D,$,void 0);break}case 9:{let N=c.deserializeReplyOKJSON(M);this._uriTransformer&&(N=(0,y.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReply(D,$,N);break}case 10:{const N=c.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(D,$,N);break}case 8:{const N=c.deserializeReplyOKVSBuffer(M);this._receiveReply(D,$,N);break}case 11:{let N=c.deserializeReplyErrError(M);this._uriTransformer&&(N=(0,y.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReplyErr(D,$,N);break}case 12:{this._receiveReplyErr(D,$,void 0);break}default:console.error("received unexpected message"),console.error(n)}}_receiveRequest(n,D,M,W,$,N){this._logger?.logIncoming(n,D,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(M)}.${W}(`,$);const U=String(D);let q,F;if(N){const Q=new l.CancellationTokenSource;$.push(Q.token),q=this._invokeHandler(M,W,$),F=()=>Q.cancel()}else q=this._invokeHandler(M,W,$),F=t;this._cancelInvokedHandlers[U]=F;const B=c.serializeAcknowledged(D);this._logger?.logOutgoing(B.byteLength,D,1,"ack"),this._protocol.send(B),q.then(Q=>{delete this._cancelInvokedHandlers[U];const J=c.serializeReplyOK(D,Q,this._uriReplacer);this._logger?.logOutgoing(J.byteLength,D,1,"reply:",Q),this._protocol.send(J)},Q=>{delete this._cancelInvokedHandlers[U];const J=c.serializeReplyErr(D,Q);this._logger?.logOutgoing(J.byteLength,D,1,"replyErr:",Q),this._protocol.send(J)})}_receiveCancel(n,D){this._logger?.logIncoming(n,D,1,"receiveCancel");const M=String(D);this._cancelInvokedHandlers[M]?.()}_receiveReply(n,D,M){this._logger?.logIncoming(n,D,0,"receiveReply:",M);const W=String(D);if(!this._pendingRPCReplies.hasOwnProperty(W))return;const $=this._pendingRPCReplies[W];delete this._pendingRPCReplies[W],$.resolveOk(M)}_receiveReplyErr(n,D,M){this._logger?.logIncoming(n,D,0,"receiveReplyErr:",M);const W=String(D);if(!this._pendingRPCReplies.hasOwnProperty(W))return;const $=this._pendingRPCReplies[W];delete this._pendingRPCReplies[W];let N;M&&(M.$isError?(N=new Error,N.name=M.name,N.message=M.message,N.stack=M.stack):N=M),$.resolveErr(N)}_invokeHandler(n,D,M){try{return Promise.resolve(this._doInvokeHandler(n,D,M))}catch(W){return Promise.reject(W)}}_doInvokeHandler(n,D,M){const W=this._locals[n];if(!W)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(n));const $=W[D];if(typeof $!="function")throw new Error("Unknown method "+D+" on actor "+(0,L.getStringIdentifierForProxy)(n));return $.apply(W,M)}_remoteCall(n,D,M){if(this._isDisposed)return new g.CanceledLazyPromise;let W=null;if(M.length>0&&l.CancellationToken.isCancellationToken(M[M.length-1])&&(W=M.pop()),W&&W.isCancellationRequested)return Promise.reject(R.canceled());const $=c.serializeRequestArguments(M,this._uriReplacer),N=++this._lastMessageId,U=String(N),q=new g.LazyPromise;W&&W.onCancellationRequested(()=>{const B=c.serializeCancel(N);this._logger?.logOutgoing(B.byteLength,N,0,"cancel"),this._protocol.send(c.serializeCancel(N))}),this._pendingRPCReplies[U]=q,this._onWillSendRequest(N);const F=c.serializeRequest(N,n,D,$,!!W);return this._logger?.logOutgoing(F.byteLength,N,0,`request: ${(0,L.getStringIdentifierForProxy)(n)}.${D}(`,M),this._protocol.send(F),q}}e.RPCProtocol=a,I=s,a.UNRESPONSIVE_TIME=3*1e3;class v{static alloc(n,D,M){const W=new v(A.VSBuffer.alloc(M+1+4),0);return W.writeUInt8(n),W.writeUInt32(D),W}static read(n,D){return new v(n,D)}get buffer(){return this._buff}constructor(n,D){this._buff=n,this._offset=D}static sizeUInt8(){return 1}writeUInt8(n){this._buff.writeUInt8(n,this._offset),this._offset+=1}readUInt8(){const n=this._buff.readUInt8(this._offset);return this._offset+=1,n}writeUInt32(n){this._buff.writeUInt32BE(n,this._offset),this._offset+=4}readUInt32(){const n=this._buff.readUInt32BE(this._offset);return this._offset+=4,n}static sizeShortString(n){return 1+n.byteLength}writeShortString(n){this._buff.writeUInt8(n.byteLength,this._offset),this._offset+=1,this._buff.set(n,this._offset),this._offset+=n.byteLength}readShortString(){const n=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+n).toString();return this._offset+=n,M}static sizeLongString(n){return 4+n.byteLength}writeLongString(n){this._buff.writeUInt32BE(n.byteLength,this._offset),this._offset+=4,this._buff.set(n,this._offset),this._offset+=n.byteLength}readLongString(){const n=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+n).toString();return this._offset+=n,M}writeBuffer(n){this._buff.writeUInt32BE(n.byteLength,this._offset),this._offset+=4,this._buff.set(n,this._offset),this._offset+=n.byteLength}static sizeVSBuffer(n){return 4+n.byteLength}writeVSBuffer(n){this._buff.writeUInt32BE(n.byteLength,this._offset),this._offset+=4,this._buff.set(n,this._offset),this._offset+=n.byteLength}readVSBuffer(){const n=this._buff.readUInt32BE(this._offset);this._offset+=4;const D=this._buff.slice(this._offset,this._offset+n);return this._offset+=n,D}static sizeMixedArray(n){let D=0;D+=1;for(let M=0,W=n.length;M<W;M++){const $=n[M];switch(D+=1,$.type){case 1:D+=this.sizeLongString($.value);break;case 2:D+=this.sizeVSBuffer($.value);break;case 3:D+=this.sizeUInt32,D+=this.sizeLongString($.value);for(let N=0;N<$.buffers.length;++N)D+=this.sizeVSBuffer($.buffers[N]);break;case 4:break}}return D}writeMixedArray(n){this._buff.writeUInt8(n.length,this._offset),this._offset+=1;for(let D=0,M=n.length;D<M;D++){const W=n[D];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let $=0;$<W.buffers.length;++$)this.writeBuffer(W.buffers[$]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const n=this._buff.readUInt8(this._offset);this._offset+=1;const D=new Array(n);for(let M=0;M<n;M++)switch(this.readUInt8()){case 1:D[M]=this.readLongString();break;case 2:D[M]=this.readVSBuffer();break;case 3:{const $=this.readUInt32(),N=this.readLongString(),U=[];for(let q=0;q<$;++q)U.push(this.readVSBuffer());D[M]=new L.SerializableObjectWithBuffers(d(N,U,null));break}case 4:D[M]=void 0;break}return D}}v.sizeUInt32=4;var _;(function(f){f[f.Simple=0]="Simple",f[f.Mixed=1]="Mixed"})(_||(_={}));class c{static _useMixedArgSerialization(n){for(let D=0,M=n.length;D<M;D++)if(n[D]instanceof A.VSBuffer||n[D]instanceof L.SerializableObjectWithBuffers||typeof n[D]>"u")return!0;return!1}static serializeRequestArguments(n,D){if(this._useMixedArgSerialization(n)){const M=[];for(let W=0,$=n.length;W<$;W++){const N=n[W];if(N instanceof A.VSBuffer)M[W]={type:2,value:N};else if(typeof N>"u")M[W]={type:4};else if(N instanceof L.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:q}=i(N.value,D);M[W]={type:3,value:A.VSBuffer.fromString(U),buffers:q}}else M[W]={type:1,value:A.VSBuffer.fromString(h(N,D))}}return{type:1,args:M}}return{type:0,args:h(n,D)}}static serializeRequest(n,D,M,W,$){switch(W.type){case 0:return this._requestJSONArgs(n,D,M,W.args,$);case 1:return this._requestMixedArgs(n,D,M,W.args,$)}}static _requestJSONArgs(n,D,M,W,$){const N=A.VSBuffer.fromString(M),U=A.VSBuffer.fromString(W);let q=0;q+=v.sizeUInt8(),q+=v.sizeShortString(N),q+=v.sizeLongString(U);const F=v.alloc($?2:1,n,q);return F.writeUInt8(D),F.writeShortString(N),F.writeLongString(U),F.buffer}static deserializeRequestJSONArgs(n){const D=n.readUInt8(),M=n.readShortString(),W=n.readLongString();return{rpcId:D,method:M,args:JSON.parse(W)}}static _requestMixedArgs(n,D,M,W,$){const N=A.VSBuffer.fromString(M);let U=0;U+=v.sizeUInt8(),U+=v.sizeShortString(N),U+=v.sizeMixedArray(W);const q=v.alloc($?4:3,n,U);return q.writeUInt8(D),q.writeShortString(N),q.writeMixedArray(W),q.buffer}static deserializeRequestMixedArgs(n){const D=n.readUInt8(),M=n.readShortString(),W=n.readMixedArray(),$=new Array(W.length);for(let N=0,U=W.length;N<U;N++){const q=W[N];typeof q=="string"?$[N]=JSON.parse(q):$[N]=q}return{rpcId:D,method:M,args:$}}static serializeAcknowledged(n){return v.alloc(5,n,0).buffer}static serializeCancel(n){return v.alloc(6,n,0).buffer}static serializeReplyOK(n,D,M){if(typeof D>"u")return this._serializeReplyOKEmpty(n);if(D instanceof A.VSBuffer)return this._serializeReplyOKVSBuffer(n,D);if(D instanceof L.SerializableObjectWithBuffers){const{jsonString:W,referencedBuffers:$}=i(D.value,M,!0);return this._serializeReplyOKJSONWithBuffers(n,W,$)}else return this._serializeReplyOKJSON(n,w(D,M))}static _serializeReplyOKEmpty(n){return v.alloc(7,n,0).buffer}static _serializeReplyOKVSBuffer(n,D){let M=0;M+=v.sizeVSBuffer(D);const W=v.alloc(8,n,M);return W.writeVSBuffer(D),W.buffer}static deserializeReplyOKVSBuffer(n){return n.readVSBuffer()}static _serializeReplyOKJSON(n,D){const M=A.VSBuffer.fromString(D);let W=0;W+=v.sizeLongString(M);const $=v.alloc(9,n,W);return $.writeLongString(M),$.buffer}static _serializeReplyOKJSONWithBuffers(n,D,M){const W=A.VSBuffer.fromString(D);let $=0;$+=v.sizeUInt32,$+=v.sizeLongString(W);for(const U of M)$+=v.sizeVSBuffer(U);const N=v.alloc(10,n,$);N.writeUInt32(M.length),N.writeLongString(W);for(const U of M)N.writeBuffer(U);return N.buffer}static deserializeReplyOKJSON(n){const D=n.readLongString();return JSON.parse(D)}static deserializeReplyOKJSONWithBuffers(n,D){const M=n.readUInt32(),W=n.readLongString(),$=[];for(let N=0;N<M;++N)$.push(n.readVSBuffer());return new L.SerializableObjectWithBuffers(d(W,$,D))}static serializeReplyErr(n,D){const M=D?w(R.transformErrorForSerialization(D),null):void 0;if(typeof M!="string")return this._serializeReplyErrEmpty(n);const W=A.VSBuffer.fromString(M);let $=0;$+=v.sizeLongString(W);const N=v.alloc(11,n,$);return N.writeLongString(W),N.buffer}static deserializeReplyErrError(n){const D=n.readLongString();return JSON.parse(D)}static _serializeReplyErrEmpty(n){return v.alloc(12,n,0).buffer}}var u;(function(f){f[f.RequestJSONArgs=1]="RequestJSONArgs",f[f.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",f[f.RequestMixedArgs=3]="RequestMixedArgs",f[f.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",f[f.Acknowledged=5]="Acknowledged",f[f.Cancel=6]="Cancel",f[f.ReplyOKEmpty=7]="ReplyOKEmpty",f[f.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",f[f.ReplyOKJSON=9]="ReplyOKJSON",f[f.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",f[f.ReplyErrError=11]="ReplyErrError",f[f.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var m;(function(f){f[f.String=1]="String",f[f.VSBuffer=2]="VSBuffer",f[f.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",f[f.Undefined=4]="Undefined"})(m||(m={}))}),define(De[305],Ie([1,0,3,40,44,4]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new l.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new l.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new l.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var T;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class P{constructor(){this.channels=new Map,this._onDidRegisterChannel=new o.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new o.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(g){this.channels.has(g.id)||(this.channels.set(g.id,g),this._onDidRegisterChannel.fire(g.id))}getChannels(){const g=[];return this.channels.forEach(L=>g.push(L)),g}getChannel(g){return this.channels.get(g)}removeChannel(g){this.channels.delete(g),this._onDidRemoveChannel.fire(g)}}A.Registry.add(e.Extensions.OutputChannels,new P),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new l.RawContextKey("activeOutputChannel","")}),define(De[143],Ie([1,0,5,4,20,25,17,305,80,26,49,161,22,10,45,3,6]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class d extends T.AbstractMessageLogger{get disposed(){return this._disposed}constructor(p,t,s,r,a){super(),this.id=p,this.name=t,this.logger=s,this.proxy=r,this.extension=a,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(s.getLevel()),this._register(s.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,p)}replace(p){const t=this.offset;this.info(p),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(p,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:t))}hide(){this.proxy.$close(this.id)}log(p,t){this.offset+=w.VSBuffer.fromString(t).byteLength,(0,T.log)(this.logger,p,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class h extends d{appendLine(p){this.append(p)}}let S=e.ExtHostOutputService=class{constructor(p,t,s,r,a,v){this.initData=t,this.extHostFileSystem=s,this.extHostFileSystemInfo=r,this.loggerService=a,this.logService=v,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(o.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[t,s]of this.channels)s.visible=t===this.visibleChannelId}createOutputChannel(p,t,s){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,a=(0,k.isString)(t)?t:void 0;if((0,k.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const _=this.initData.environment.extensionLogLevel?.find(([u])=>R.ExtensionIdentifier.equals(s.identifier,u))?.[1];_&&(v=(0,T.parseLogLevel)(_));const c=r?this.doCreateLogOutputChannel(p,v,s):this.doCreateOutputChannel(p,a,s);return c.then(u=>{this.channels.set(u.id,u),u.visible=u.id===this.visibleChannelId}),r?this.createExtHostLogOutputChannel(p,v??this.logService.getLevel(),c):this.createExtHostOutputChannel(p,c)}async doCreateOutputChannel(p,t,s){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const r=await this.outputDirectoryPromise,a=this.extHostFileSystemInfo.extUri.joinPath(r,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.loggerService.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),_=await this.proxy.$register(p,a,t,s.identifier.value);return new d(_,p,v,this.proxy,s)}async doCreateLogOutputChannel(p,t,s){const r=await this.createExtensionLogDirectory(s),a=p.replace(/[\\/:\*\?"<>\|]/g,""),v=this.extHostFileSystemInfo.extUri.joinPath(r,`${a}.log`),_=`${s.identifier.value}.${a}`,c=this.loggerService.createLogger(v,{id:_,name:p,logLevel:t,extensionId:s.identifier.value});return new h(_,p,c,this.proxy,s)}createExtensionLogDirectory(p){let t=this.extensionLogDirectoryPromise.get(p.identifier.value);if(!t){const s=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,p.identifier.value);this.extensionLogDirectoryPromise.set(p.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(s)}catch(r){if((0,C.toFileSystemProviderErrorCode)(r)!==C.FileSystemProviderErrorCode.FileExists)throw r}return s})())}return t}createExtHostOutputChannel(p,t){let s=!1;const r=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return p},append(a){r(),t.then(v=>v.append(a))},appendLine(a){r(),t.then(v=>v.appendLine(a))},clear(){r(),t.then(a=>a.clear())},replace(a){r(),t.then(v=>v.replace(a))},show(a,v){r(),t.then(_=>_.show(a,v))},hide(){r(),t.then(a=>a.hide())},dispose(){s=!0,t.then(a=>a.dispose())}}}createExtHostLogOutputChannel(p,t,s){const r=new i.DisposableStore,a=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},v=r.add(new b.Emitter);function _(c){t=c,v.fire(c)}return s.then(c=>{r.add(c),c.logLevel!==t&&_(c.logLevel),r.add(c.onDidChangeLogLevel(u=>_(u)))}),{...this.createExtHostOutputChannel(p,s),get logLevel(){return t},onDidChangeLogLevel:v.event,trace(c,...u){a(),s.then(m=>m.trace(c,...u))},debug(c,...u){a(),s.then(m=>m.debug(c,...u))},info(c,...u){a(),s.then(m=>m.info(c,...u))},warn(c,...u){a(),s.then(m=>m.warn(c,...u))},error(c,...u){a(),s.then(m=>m.error(c,...u))},dispose(){r.dispose()}}}};e.ExtHostOutputService=S=Ve([ze(0,l.IExtHostRpcService),ze(1,g.IExtHostInitDataService),ze(2,y.IExtHostConsumerFileSystem),ze(3,L.IExtHostFileSystemInfo),ze(4,T.ILoggerService),ze(5,T.ILogService)],S),e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(De[306],Ie([1,0,4]),function(oe,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(De[307],Ie([1,0,34,16,15,14,24,2,4,227,48,246,306]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let k=e.AbstractPathService=class Dn{constructor(b,i,d,h){this.localUserHome=b,this.remoteAgentService=i,this.environmentService=d,this.contextService=h,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||R.OS)(),this.resolveUserHome=(async()=>{const S=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=S?.userHome??b})()}hasValidBasename(b,i,d){return typeof i=="string"||typeof i>"u"?this.resolveOS.then(h=>this.doHasValidBasename(b,h,i)):this.doHasValidBasename(b,i,d)}doHasValidBasename(b,i,d){return b.scheme===A.Schemas.file||b.scheme===A.Schemas.vscodeRemote?(0,o.isValidBasename)(d??(0,T.basename)(b),i===1):!0}get defaultUriScheme(){return Dn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(b,i){if(b.remoteAuthority)return A.Schemas.vscodeRemote;const d=(0,g.getVirtualWorkspaceScheme)(i.getWorkspace());if(d)return d;const h=i.getWorkspace().folders[0];if(h)return h.uri.scheme;const S=i.getWorkspace().configuration;return S?S.scheme:A.Schemas.file}userHome(b){return b?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(b=>b===1?l.win32:l.posix)}async fileURI(b){let i="";if(await this.resolveOS===1&&(b=b.replace(/\\/g,"/")),b[0]==="/"&&b[1]==="/"){const h=b.indexOf("/",2);h===-1?(i=b.substring(2),b="/"):(i=b.substring(2,h),b=b.substring(h)||"/")}return P.URI.from({scheme:A.Schemas.file,authority:i,path:b,query:"",fragment:""})}};e.AbstractPathService=k=Ve([ze(1,w.IRemoteAgentService),ze(2,I.IWorkbenchEnvironmentService),ze(3,L.IWorkspaceContextService)],k)}),define(De[83],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(T,P){this.line=T,this.character=P}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,P){return new o(0,0)}with(T){return new o(0,0)}}e.Position=o;class A{constructor(T,P,y,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(T,P),this.end=new o(y,g)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new A(0,0,0,0)}with(T){return new A(0,0,0,0)}}e.Range=A;var l;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(l||(e.TextSearchCompleteMessageType=l={}))}),define(De[31],Ie([1,0,18,39,23,34,9,4,15,8,83,19]),function(oe,e,o,A,l,R,T,P,y,g,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const w="\u27EA ",k=" characters skipped \u27EB",C=(w.length+k.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var b;(function(ie){ie[ie.file=0]="file",ie[ie.text=1]="text"})(b||(e.SearchProviderType=b={}));var i;(function(ie){ie[ie.File=1]="File",ie[ie.Text=2]="Text"})(i||(e.QueryType=i={}));function d(ie){return!!ie.preview}e.resultIsMatch=d;function h(ie){return!!ie.resource}e.isFileMatch=h;function S(ie){return!!ie.message}e.isProgressMessage=S;var E;(function(ie){ie[ie.Normal=0]="Normal",ie[ie.NewSearchStarted=1]="NewSearchStarted"})(E||(e.SearchCompletionExitCode=E={}));class p{constructor(ae){this.resource=ae,this.results=[]}}e.FileMatch=p;class t{constructor(ae,we,he,fe){this.ranges=we,this.webviewIndex=fe;const V=Array.isArray(we)?we:[we];if(he&&he.matchLines===1&&s(V)){ae=(0,T.getNLines)(ae,he.matchLines);let x="",Z=0,pe=0;const _e=Math.floor(he.charsPerLine/5),re=[];for(const ne of V){const de=Math.max(ne.startColumn-_e,0),ee=ne.startColumn+he.charsPerLine;if(de>pe+_e+C){const ce=w+(de-pe)+k;x+=ce+ae.slice(de,ee),Z+=de-(pe+ce.length)}else x+=ae.slice(pe,ee);re.push(new a(0,ne.startColumn-Z,ne.endColumn-Z)),pe=ee}this.preview={text:x,matches:Array.isArray(this.ranges)?re:re[0]}}else{const x=Array.isArray(we)?we[0].startLineNumber:we.startLineNumber;this.preview={text:ae,matches:(0,o.mapArrayOrNot)(we,Z=>new r(Z.startLineNumber-x,Z.startColumn,Z.endLineNumber-x,Z.endColumn))}}}}e.TextSearchMatch=t;function s(ie){const ae=ie[0].startLineNumber;for(const we of ie)if(we.startLineNumber!==ae||we.endLineNumber!==ae)return!1;return!0}class r{constructor(ae,we,he,fe){this.startLineNumber=ae,this.startColumn=we,this.endLineNumber=he,this.endColumn=fe}}e.SearchRange=r;class a extends r{constructor(ae,we,he){super(ae,we,ae,he)}}e.OneLineRange=a;var v;(function(ie){ie.List="list",ie.Tree="tree"})(v||(e.ViewMode=v={}));var _;(function(ie){ie.Default="default",ie.FileNames="fileNames",ie.Type="type",ie.Modified="modified",ie.CountDescending="countDescending",ie.CountAscending="countAscending"})(_||(e.SearchSortOrder=_={}));function c(ie,ae=!0){const we=ie&&ie.files&&ie.files.exclude,he=ae&&ie&&ie.search&&ie.search.exclude;if(!we&&!he)return;if(!we||!he)return we||he;let fe=Object.create(null);return fe=l.mixin(fe,l.deepClone(we)),fe=l.mixin(fe,l.deepClone(he),!0),fe}e.getExcludes=c;function u(ie,ae){return ie.excludePattern&&A.match(ie.excludePattern,ae)?!1:ie.includePattern||ie.usingSearchPaths?ie.includePattern&&A.match(ie.includePattern,ae)?!0:ie.usingSearchPaths?!!ie.folderQueries&&ie.folderQueries.some(we=>{const he=we.folder.fsPath;if(R.isEqualOrParent(ae,he)){const fe=y.relative(he,ae);return!we.includePattern||!!A.match(we.includePattern,fe)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var m;(function(ie){ie[ie.unknownEncoding=1]="unknownEncoding",ie[ie.regexParseError=2]="regexParseError",ie[ie.globParseError=3]="globParseError",ie[ie.invalidLiteral=4]="invalidLiteral",ie[ie.rgProcessError=5]="rgProcessError",ie[ie.other=6]="other",ie[ie.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class f extends Error{constructor(ae,we){super(ae),this.code=we}}e.SearchError=f;function n(ie){const ae=ie.message;if((0,g.isCancellationError)(ie))return new f(ae,m.canceled);try{const we=JSON.parse(ae);return new f(we.message,we.code)}catch{return new f(ae,m.other)}}e.deserializeSearchError=n;function D(ie){const ae={message:ie.message,code:ie.code};return new Error(JSON.stringify(ae))}e.serializeSearchError=D;function M(ie){return ie.type==="error"?!0:ie.type==="success"}e.isSerializedSearchComplete=M;function W(ie){return ie.type==="success"}e.isSerializedSearchSuccess=W;function $(ie){return!!ie.path}e.isSerializedFileMatch=$;function N(ie,ae){const we=ie.searchPath?ie.searchPath:ie.relativePath;return(0,T.fuzzyContains)(we,ae)}e.isFilePatternMatch=N;class U{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function q(ie,ae){const we={...ie||{},...ae||{}};return Object.keys(we).filter(he=>{const fe=we[he];return typeof fe=="boolean"&&fe})}e.resolvePatternsForProvider=q;class F{constructor(ae,we){this._parsedIncludeExpression=null,this._excludeExpression={...ae.excludePattern||{},...we.excludePattern||{}},this._parsedExcludeExpression=A.parse(this._excludeExpression);let he=ae.includePattern;we.includePattern&&(he?he={...he,...we.includePattern}:he=we.includePattern),he&&(this._parsedIncludeExpression=A.parse(he))}matchesExcludesSync(ae,we,he){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ae,we,he))}includedInQuerySync(ae,we,he){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ae,we,he)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ae,we,he))}includedInQuery(ae,we,he){const fe=this._parsedExcludeExpression(ae,we,he),V=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ae,we,he):!0;return(0,I.isThenable)(fe)?fe.then(x=>x?!1:V()):V()}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=F;function B(ie){for(const ae in ie)if(typeof ie[ae]!="boolean")return!0;return!1}function Q(ie){if(!ie)return;let ae;return we=>(ae||(ae=(ie()||Promise.resolve([])).then(he=>he?X(he):{})),ae.then(he=>!!he[we]))}e.hasSiblingPromiseFn=Q;function J(ie){if(!ie)return;let ae;return we=>{if(!ae){const he=ie();ae=he?X(he):{}}return!!ae[we]}}e.hasSiblingFn=J;function X(ie){const ae={};for(const we of ie)ae[we]=!0;return ae}}),define(De[35],Ie([1,0,18,19,21,3,6,70,16,103,24,9,10,2,192,4,17,215,48,49,26,20,11,7,58,31,5]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h,S,E,p,t,s,r,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function _(W,$,N){return new L.ExtUri(U=>f(U,N)).isEqual(W,$)}function c(W,$,N){return _(W.uri,$.uri,N)?0:(0,I.compare)(W.uri.toString(),$.uri.toString())}function u(W,$,N){return W.index!==$.index?W.index<$.index?-1:1:_(W.uri,$.uri,N)?(0,I.compare)(W.name,$.name):(0,I.compare)(W.uri.toString(),$.uri.toString())}function m(W,$,N,U){const q=W.slice(0).sort((B,Q)=>N(B,Q,U)),F=$.slice(0).sort((B,Q)=>N(B,Q,U));return(0,o.delta)(q,F,(B,Q)=>N(B,Q,U))}function f(W,$){const N=$.getCapabilities(W.scheme);return!(N&&N&1024)}class n extends h.Workspace{static toExtHostWorkspace($,N,U,q){if(!$)return{workspace:null,added:[],removed:[]};const{id:F,name:B,folders:Q,configuration:J,transient:X,isUntitled:ie}=$,ae=[],we=N;N?Q.forEach((x,Z)=>{const pe=k.URI.revive(x.uri),_e=n._findFolder(U||N,pe,q);_e?(_e.name=x.name,_e.index=x.index,ae.push(_e)):ae.push({uri:pe,name:x.name,index:Z})}):ae.push(...Q.map(({uri:x,name:Z,index:pe})=>({uri:k.URI.revive(x),name:Z,index:pe}))),ae.sort((x,Z)=>x.index<Z.index?-1:1);const he=new n(F,B,ae,!!X,J?k.URI.revive(J):null,!!ie,x=>f(x,q)),{added:fe,removed:V}=m(we?we.workspaceFolders:[],he.workspaceFolders,c,q);return{workspace:he,added:fe,removed:V}}static _findFolder($,N,U){for(let q=0;q<$.folders.length;q++){const F=$.workspaceFolders[q];if(_(F.uri,N,U))return F}}constructor($,N,U,q,F,B,Q){super($,U.map(J=>new h.WorkspaceFolder(J)),q,F,Q),this._name=N,this._isUntitled=B,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(Q),U.forEach(J=>{this._workspaceFolders.push(J),this._structure.set(J.uri,J)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder($,N){return N&&this._structure.get($)&&($=(0,L.dirname)($)),this._structure.findSubstr($)}resolveWorkspaceFolder($){return this._structure.get($)}}let D=e.ExtHostWorkspace=class{constructor($,N,U,q,F){this._onDidChangeWorkspace=new R.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new R.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new R.AsyncEmitter,this._logService=q,this._extHostFileSystemInfo=U,this._uriTransformerService=F,this._requestIdProvider=new g.Counter,this._barrier=new A.Barrier,this._proxy=$.getProxy(v.MainContext.MainThreadWorkspace),this._messageService=$.getProxy(v.MainContext.MainThreadMessageService);const B=N.workspace;this._confirmedWorkspace=B?new n(B.id,B.name,[],!!B.transient,B.configuration?k.URI.revive(B.configuration):null,!!B.isUntitled,Q=>f(Q,U)):void 0}$initializeWorkspace($,N){this._trusted=N,this.$acceptWorkspaceData($),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?k.URI.from({scheme:y.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders($,N,U,...q){const F=[];if(Array.isArray(q)&&q.forEach(ie=>{k.URI.isUri(ie.uri)&&!F.some(ae=>_(ae.uri,ie.uri,this._extHostFileSystemInfo))&&F.push({uri:ie.uri,name:ie.name||(0,L.basenameOrAuthority)(ie.uri)})}),this._unconfirmedWorkspace||[N,U].some(ie=>typeof ie!="number"||ie<0)||U===0&&F.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+U>B.length)return!1;const Q=B.slice(0);Q.splice(N,U,...F.map(ie=>({uri:ie.uri,name:ie.name||(0,L.basenameOrAuthority)(ie.uri),index:void 0})));for(let ie=0;ie<Q.length;ie++){const ae=Q[ie];if(Q.some((we,he)=>he!==ie&&_(ae.uri,we.uri,this._extHostFileSystemInfo)))return!1}Q.forEach((ie,ae)=>ie.index=ae);const{added:J,removed:X}=m(B,Q,u,this._extHostFileSystemInfo);if(J.length===0&&X.length===0)return!1;if(this._proxy){const ie=$.displayName||$.name;this._proxy.$updateWorkspaceFolders(ie,N,U,F).then(void 0,ae=>{this._unconfirmedWorkspace=void 0;const we={source:{identifier:$.identifier,label:$.displayName||$.name}};this._messageService.$showMessage(d.Severity.Error,(0,C.localize)(0,null,ie,ae.toString()),we,[])})}return this.trySetWorkspaceFolders(Q),!0}getWorkspaceFolder($,N){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,N)}async getWorkspaceFolder2($,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,N)}async resolveWorkspaceFolder($){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder($)}getPath(){if(!this._actualWorkspace)return;const{folders:$}=this._actualWorkspace;if($.length!==0)return $[0].uri.fsPath}getRelativePath($,N){let U,q="";if(typeof $=="string"?(U=k.URI.file($),q=$):typeof $<"u"&&(U=$,q=$.fsPath),!U)return q;const F=this.getWorkspaceFolder(U,!0);if(!F)return q;typeof N>"u"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let B=(0,L.relativePath)(F.uri,U);return N&&F.name&&(B=`${F.name}/${B}`),B}trySetWorkspaceFolders($){this._actualWorkspace&&(this._unconfirmedWorkspace=n.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:$,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData($){const{workspace:N,added:U,removed:q}=n.toExtHostWorkspace($,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:q}))}findFiles($,N,U,q,F=l.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let B;if(N===null?B=!1:N&&(typeof N=="string"?B=N:B=N.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:Q,folder:J}=M(t.GlobPattern.from($));return this._proxy.$startFileSearch((0,w.withUndefinedAsNull)(Q),(0,w.withUndefinedAsNull)(J),(0,w.withUndefinedAsNull)(B),(0,w.withUndefinedAsNull)(U),F).then(X=>Array.isArray(X)?X.map(ie=>k.URI.revive(ie)):[])}async findTextInFiles($,N,U,q,F=l.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),Q=typeof N.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:J,folder:X}=M(t.GlobPattern.from(N.include)),ie=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,ae={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:Q,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:J,excludePattern:ie},we=!1;if(this._activeSearchCallbacks[B]=he=>{if(we)return;const fe=k.URI.revive(he.resource);he.results.forEach(V=>{(0,a.resultIsMatch)(V)?U({uri:fe,preview:{text:V.preview.text,matches:(0,o.mapArrayOrNot)(V.preview.matches,x=>new s.Range(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,o.mapArrayOrNot)(V.ranges,x=>new s.Range(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):U({uri:fe,text:V.text,lineNumber:V.lineNumber})})},F.isCancellationRequested)return{};try{const he=await this._proxy.$startTextSearch($,(0,w.withUndefinedAsNull)(X),ae,B,F);return delete this._activeSearchCallbacks[B],he||{}}catch(he){throw delete this._activeSearchCallbacks[B],he}}$handleTextSearchResult($,N){this._activeSearchCallbacks[N]?.($)}async save($){const N=await this._proxy.$save($,{saveAs:!1});return k.URI.revive(N)}async saveAs($){const N=await this._proxy.$save($,{saveAs:!0});return k.URI.revive(N)}saveAll($){return this._proxy.$saveAll($)}resolveProxy($){return this._proxy.$resolveProxy($)}get trusted(){return this._trusted}requestWorkspaceTrust($){return this._proxy.$requestWorkspaceTrust($)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider($,N){if(this._editSessionIdentityProviders.has($))throw new Error(`A provider has already been registered for scheme ${$}`);this._editSessionIdentityProviders.set($,N);const U=this._uriTransformerService.transformOutgoingScheme($),q=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(q,U),(0,T.toDisposable)(()=>{this._editSessionIdentityProviders.delete($),this._proxy.$unregisterEditSessionIdentityProvider(q)})}async $getEditSessionIdentifier($,N){this._logService.info("Getting edit session identifier for workspaceFolder",$);const U=await this.resolveWorkspaceFolder(k.URI.revive($));if(!U){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const q=this._editSessionIdentityProviders.get(U.uri.scheme);if(this._logService.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!q),!q)return;const F=await q.provideEditSessionIdentity(U,N);if(this._logService.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch($,N,U,q){this._logService.info("Getting edit session identifier for workspaceFolder",$);const F=await this.resolveWorkspaceFolder(k.URI.revive($));if(!F){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this._editSessionIdentityProviders.get(F.uri.scheme);if(this._logService.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const Q=await B.provideEditSessionIdentityMatch?.(N,U,q);if(this._logService.info("Provider returned edit session identifier match result: ",Q),!!Q)return Q}getOnWillCreateEditSessionIdentityEvent($){return(N,U,q)=>{const F=function(Q){N.call(U,Q)};return F.extension=$,this._onWillCreateEditSessionIdentityEvent.event(F,void 0,q)}}async $onWillCreateEditSessionIdentity($,N,U){const q=await this.resolveWorkspaceFolder(k.URI.revive($));if(q===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:q},N,async(F,B)=>{const Q=Date.now();await Promise.resolve(F),Date.now()-Q>U&&this._logService.warn("SLOW edit session create-participant",B.extension.identifier)}),N.isCancellationRequested}};e.ExtHostWorkspace=D=Ve([ze(0,p.IExtHostRpcService),ze(1,E.IExtHostInitDataService),ze(2,S.IExtHostFileSystemInfo),ze(3,i.ILogService),ze(4,r.IURITransformerService)],D),e.IExtHostWorkspace=(0,b.createDecorator)("IExtHostWorkspace");function M(W){let $,N;return W&&(typeof W=="string"?$=W:($=W.pattern,N=k.URI.revive(W.baseUri))),{includePattern:$,folder:N}}}),define(De[36],Ie([1,0,23,3,35,5,7,218,126,10,19,4,20,17,2]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function b(s,r){if(r){const a=r.split(".");let v=s;for(let _=0;v&&_<a.length;_++)v=v[a[_]];return v}}function i(s){return s instanceof C.URI}function d(s){return s&&s.uri instanceof C.URI&&s.languageId&&typeof s.languageId=="string"}function h(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function S(s){return s&&s.uri instanceof C.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function E(s){if(i(s))return{resource:s};if(d(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(h(s))return{overrideIdentifier:s.languageId};if(S(s))return{resource:s.uri};if(s===null)return{resource:null}}let p=e.ExtHostConfiguration=class{constructor(r,a,v){this._proxy=r.getProxy(R.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=v,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,a){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(r,a))}};e.ExtHostConfiguration=p=Ve([ze(0,w.IExtHostRpcService),ze(1,l.IExtHostWorkspace),ze(2,k.ILogService)],p);class t{constructor(r,a,v,_){this._onDidChangeConfiguration=new A.Emitter,this._proxy=r,this._logService=_,this._extHostWorkspace=a,this._configuration=P.Configuration.parse(v),this._configurationScopes=this._toMap(v.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,a){const v={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,v))}getConfiguration(r,a,v){const _=E(a)||{},c=this._toReadonlyValue(r?b(this._configuration.getValue(void 0,_,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,_,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,_,v?.identifier);function u(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(f){return typeof b(c,f)<"u"},get:(f,n)=>{this._validateConfigurationAccess(r?`${r}.${f}`:f,_,v?.identifier);let D=b(c,f);if(typeof D>"u")D=n;else{let M;const W=($,N)=>{if((0,g.isObject)($)){let U;const q=()=>{M=M||(0,o.deepClone)(c),U=U||b(M,N)};return new Proxy($,{get:(F,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return q(),()=>U;if(M)return U=U||b(M,N),U[B];const Q=F[B];return typeof B=="string"?W(Q,`${N}.${B}`):Q},set:(F,B,Q)=>(q(),U&&(U[B]=Q),!0),deleteProperty:(F,B)=>(q(),U&&delete U[B],!0),defineProperty:(F,B,Q)=>(q(),U&&Object.defineProperty(U,B,Q),!0)})}return Array.isArray($)?(0,o.deepClone)($):$};D=W(D,f)}return D},update:(f,n,D,M)=>{f=r?`${r}.${f}`:f;const W=u(D);return n!==void 0?this._proxy.$updateConfigurationOption(W,f,n,_,M):this._proxy.$removeConfigurationOption(W,f,_,M)},inspect:f=>{f=r?`${r}.${f}`:f;const n=this._configuration.inspect(f,_,this._extHostWorkspace.workspace);if(n)return{key:f,defaultValue:(0,o.deepClone)(n.policy?.value??n.default?.value),globalValue:(0,o.deepClone)(n.user?.value??n.application?.value),workspaceValue:(0,o.deepClone)(n.workspace?.value),workspaceFolderValue:(0,o.deepClone)(n.workspaceFolder?.value),defaultLanguageValue:(0,o.deepClone)(n.default?.override),globalLanguageValue:(0,o.deepClone)(n.user?.override??n.application?.override),workspaceLanguageValue:(0,o.deepClone)(n.workspace?.override),workspaceFolderLanguageValue:(0,o.deepClone)(n.workspaceFolder?.override),languageIds:(0,o.deepClone)(n.overrideIdentifiers)}}};return typeof c=="object"&&(0,o.mixin)(m,c,!1),Object.freeze(m)}_toReadonlyValue(r){const a=v=>(0,g.isObject)(v)?new Proxy(v,{get:(_,c)=>a(_[c]),set:(_,c,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(_,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(_,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:_=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return a(r)}_validateConfigurationAccess(r,a,v){const _=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),c=v?`[${v.value}] `:"";if(_===4){typeof a?.resource>"u"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(_===3){a?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,a){const v=new P.ConfigurationChangeEvent(r,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(_,c)=>v.affectsConfiguration(_,E(c))})}_toMap(r){return r.reduce((a,v)=>(a.set(v[0],v[1]),a),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(oe,e,o,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,o):l?l.value=o:e.set(oe,o),o},xe=this&&this.__classPrivateFieldGet||function(oe,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(oe):A?A.value:e.get(oe)};define(De[84],Ie([1,0,2,19,3,5,7,35,61,36,21,42,20,26,4,16,14,17,79,259,8]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h,S,E){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function($){function N(q){if(q!=null)return q}$.from=N;function U(q){if(q!=null)return q}$.to=U})(t||(t={}));var s;(function($){function N(q){if(q!=null)return q}$.from=N;function U(q){if(q!=null)return q}$.to=U})(s||(s={}));var r;(function($){function N(q){if(q!=null)return q}$.from=N;function U(q){if(q!=null)return q}$.to=U})(r||(r={}));var a;(function($){function N(F){if(F){const B=F;return B&&!!B.process}else return!1}$.is=N;function U(F){if(F==null)return;const B={process:F.process,args:F.args};return F.options&&(B.options=r.from(F.options)),B}$.from=U;function q(F){if(F!=null)return new T.ProcessExecution(F.process,F.args,F.options)}$.to=q})(a||(a={}));var v;(function($){function N(q){if(q!=null)return q}$.from=N;function U(q){if(q!=null)return q}$.to=U})(v||(v={}));var _;(function($){function N(F){if(F){const B=F;return B&&(!!B.commandLine||!!B.command)}else return!1}$.is=N;function U(F){if(F==null)return;const B={};return F.commandLine!==void 0?B.commandLine=F.commandLine:(B.command=F.command,B.args=F.args),F.options&&(B.options=v.from(F.options)),B}$.from=U;function q(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new T.ShellExecution(F.commandLine,F.options):new T.ShellExecution(F.command,F.args?F.args:[],F.options)}$.to=q})(_||(_={}));var c;(function($){function N(F){if(F){const B=F;return B&&B.customExecution==="customExecution"}else return!1}$.is=N;function U(F){return{customExecution:"customExecution"}}$.from=U;function q(F,B){return B.get(F)}$.to=q})(c||(e.CustomExecutionDTO=c={}));var u;(function($){function N(U,q){let F;return U.scope!==void 0&&typeof U.scope!="number"?F=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===T.TaskScope.Workspace&&q&&q.workspaceFile?F=q.workspaceFile:F=S.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:F}}$.from=N})(u||(e.TaskHandleDTO=u={}));var m;(function($){function N(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}$.from=N})(m||(m={}));var f;(function($){function N(F,B){if(F==null)return[];const Q=[];for(const J of F){const X=U(J,B);X&&Q.push(X)}return Q}$.fromMany=N;function U(F,B){if(F==null)return;let Q;F.execution instanceof T.ProcessExecution?Q=a.from(F.execution):F.execution instanceof T.ShellExecution?Q=_.from(F.execution):F.execution&&F.execution instanceof T.CustomExecution&&(Q=c.from(F.execution));const J=t.from(F.definition);let X;return F.scope?typeof F.scope=="number"?X=F.scope:X=F.scope.uri:X=T.TaskScope.Workspace,!J||!X?void 0:{_id:F._id,definition:J,name:F.name,source:{extensionId:B.identifier.value,label:F.source,scope:X},execution:Q,isBackground:F.isBackground,group:m.from(F.group),presentationOptions:s.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}$.from=U;async function q(F,B,Q){if(F==null)return;let J;a.is(F.execution)?J=a.to(F.execution):_.is(F.execution)?J=_.to(F.execution):c.is(F.execution)&&(J=c.to(F._id,Q));const X=t.to(F.definition);let ie;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?ie=F.source.scope:ie=await B.resolveWorkspaceFolder(o.URI.revive(F.source.scope)):ie=T.TaskScope.Workspace),!X||!ie)return;const ae=new T.Task(X,ie,F.name,F.source.label,J,F.problemMatchers);return F.isBackground!==void 0&&(ae.isBackground=F.isBackground),F.group!==void 0&&(ae.group=T.TaskGroup.from(F.group._id),ae.group&&F.group.isDefault&&(ae.group=new T.TaskGroup(ae.group.id,ae.group.label),F.group.isDefault===!0&&(ae.group.isDefault=F.group.isDefault))),F.presentationOptions&&(ae.presentationOptions=s.to(F.presentationOptions)),F._id&&(ae._id=F._id),F.detail&&(ae.detail=F.detail),ae}$.to=q})(f||(e.TaskDTO=f={}));var n;(function($){function N(q){return q}$.from=N;function U(q){if(q)return Object.assign(Object.create(null),q)}$.to=U})(n||(n={}));class D{constructor(N,U,q){this._id=U,this._task=q,p.set(this,void 0),Je(this,p,N,"f")}get task(){return this._task}terminate(){xe(this,p,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}p=new WeakMap;let M=e.ExtHostTaskBase=class{constructor(N,U,q,F,B,Q,J,X){this._onDidExecuteTask=new l.Emitter,this._onDidTerminateTask=new l.Emitter,this._onDidTaskProcessStarted=new l.Emitter,this._onDidTaskProcessEnded=new l.Emitter,this._proxy=N.getProxy(R.MainContext.MainThreadTask),this._workspaceProvider=q,this._editorService=F,this._configurationService=B,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=J,this._deprecationService=X,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,U,q){if(!q)return new T.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:U,provider:q,extension:N}),this._proxy.$registerTaskProvider(F,U),new T.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(N,U){this._proxy.$registerTaskSystem(N,U)}fetchTasks(N){return this._proxy.$fetchTasks(n.from(N)).then(async U=>{const q=[];for(const F of U){const B=await f.to(F,this._workspaceProvider,this._providedCustomExecutions2);B&&q.push(B)}return q})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(U=>N.push(U)),N}terminateTask(N){if(!(N instanceof D))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,U,q){const F=this._providedCustomExecutions2.get(N.id);F&&(this._activeCustomExecutions2.set(N.id,F),this._terminalService.attachPtyToTerminal(U,await F.callback(q))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const U=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:U})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const U=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:U,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const U=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:U,exitCode:N.exitCode})}$provideTasks(N,U){const q=this._handlers.get(N);if(!q)return Promise.reject(new Error("no handler found"));const F=[],B=(0,A.asPromise)(()=>q.provider.provideTasks(L.CancellationToken.None)).then(Q=>this.provideTasksInternal(U,F,q,Q));return new Promise(Q=>{B.then(J=>{Promise.all(F).then(()=>{Q(J)})})})}async $resolveTask(N,U){const q=this._handlers.get(N);if(!q)return Promise.reject(new Error("no handler found"));if(U.definition.type!==q.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${q.type}].`);const F=await f.to(U,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const B=await q.provider.resolveTask(F,L.CancellationToken.None);if(!B)return;this.checkDeprecation(B,q);const Q=f.from(B,q.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(Q.execution)&&await this.addCustomExecution(Q,B,!0),await this.resolveTaskInternal(Q)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,U,q){const F=await this._proxy.$createTaskId(N);!q&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,U.execution)),this._providedCustomExecutions2.set(F,U.execution)}async getTaskExecution(N,U){if(typeof N=="string"){const B=this._taskExecutionPromises.get(N);if(!B)throw new E.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return B}const q=this._taskExecutionPromises.get(N.id);if(q)return q;const F=new Promise((B,Q)=>{function J(X,ie,ae){ae?B(new D(X,ie.id,ae)):Q("Unexpected: Task does not exist.")}U?J(this,N,U):f.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(X=>J(this,N,X))});return this._taskExecutionPromises.set(N.id,F),F.then(B=>(this._taskExecutions.set(N.id,B),B),B=>Promise.reject(B))}checkDeprecation(N,U){N._deprecated&&this._deprecationService.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));const q=this._notProvidedCustomExecutions.values();let F=q.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=q.next()}};e.ExtHostTaskBase=M=Ve([ze(0,w.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,g.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,d.ILogService),ze(7,h.IExtHostApiDeprecationService)],M);let W=e.WorkerExtHostTask=class extends M{constructor(N,U,q,F,B,Q,J,X){super(N,U,q,F,B,Q,J,X),this.registerTaskSystem(b.Schemas.vscodeRemote,{scheme:b.Schemas.vscodeRemote,authority:"",platform:i.PlatformToString(0)})}async executeTask(N,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const q=f.from(U,N);if(q===void 0)throw new Error("Task is not valid");if(c.is(q.execution))await this.addCustomExecution(q,U,!1);else throw new E.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(q),U);return this._proxy.$executeTask(q).catch(B=>{throw new Error(B)}),F}provideTasksInternal(N,U,q,F){const B=[];if(F)for(const Q of F){this.checkDeprecation(Q,q),(!Q.definition||!N[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const J=f.from(Q,q.extension);J&&c.is(J.execution)?(B.push(J),U.push(this.addCustomExecution(J,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:q.extension}}async resolveTaskInternal(N){if(c.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,U,q){}};e.WorkerExtHostTask=W=Ve([ze(0,w.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,g.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,d.ILogService),ze(7,h.IExtHostApiDeprecationService)],W),e.IExtHostTask=(0,C.createDecorator)("IExtHostTask")}),define(De[308],Ie([1,0,15,21,46,39,24,37,31]),function(oe,e,o,A,l,R,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class g{constructor(w,k,C){this.config=w,this.provider=k,this.sessionToken=C,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=w.filePattern,this.includePattern=w.includePattern&&R.parse(w.includePattern),this.maxResults=w.maxResults||void 0,this.exists=w.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=w.excludePattern&&R.parse(w.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(w=>w.cancel()),this.activeCancellationTokens=new Set}search(w){const k=this.config.folderQueries||[];return new Promise((C,b)=>{const i=d=>{this.resultCount++,w(d)};if(this.isCanceled)return C({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(d=>{const h=d.toString(),S=o.basename(h);this.globalExcludePattern&&this.globalExcludePattern(h,S)||this.matchFile(i,{base:d,basename:S})}),Promise.all(k.map(d=>this.searchInFolder(d,i))).then(d=>{C({limitHit:this.isLimitHit,stats:d[0]||void 0})},d=>{b(new Error((0,l.toErrorMessage)(d)))})})}async searchInFolder(w,k){const C=new A.CancellationTokenSource,b=this.getSearchOptionsForFolder(w),i=this.initDirectoryTree(),d=new y.QueryGlobTester(this.config,w),h=!d.hasSiblingExcludeClauses();let S;try{this.activeCancellationTokens.add(C),S=P.StopWatch.create();const E=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},b,C.token),p=S.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(E&&E.forEach(s=>{const r=o.posix.relative(w.folder.path,s.path);if(h){const a=o.basename(s.path);this.matchFile(k,{base:w.folder,relativePath:r,basename:a});return}this.addDirectoryEntries(i,w.folder,r,k)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(i,d,k),{providerTime:p,postProcessTime:t.elapsed()})}finally{C.dispose(),this.activeCancellationTokens.delete(C)}}getSearchOptionsForFolder(w){const k=(0,y.resolvePatternsForProvider)(this.config.includePattern,w.includePattern),C=(0,y.resolvePatternsForProvider)(this.config.excludePattern,w.excludePattern);return{folder:w.folder,excludes:C,includes:k,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}addDirectoryEntries({pathToEntries:w},k,C,b){if(C===this.filePattern){const d=o.basename(this.filePattern);this.matchFile(b,{base:k,relativePath:this.filePattern,basename:d})}function i(d){const h=o.basename(d),S=o.dirname(d);let E=w[S];E||(E=w[S]=[],i(S)),E.push({base:k,relativePath:d,basename:h})}i(C)}matchDirectoryTree({rootEntries:w,pathToEntries:k},C,b){const i=this,d=this.filePattern;function h(S){const E=(0,y.hasSiblingFn)(()=>S.map(p=>p.basename));for(let p=0,t=S.length;p<t;p++){const s=S[p],{relativePath:r,basename:a}=s;if(C.matchesExcludesSync(r,a,d!==a?E:void 0))continue;const v=k[r];if(v)h(v);else{if(r===d)continue;i.matchFile(b,s)}if(i.isLimitHit)break}}h(w)}matchFile(w,k){(!this.includePattern||k.relativePath&&this.includePattern(k.relativePath,k.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||w(k))}}class L{constructor(){this.sessions=new Map}fileSearch(w,k,C,b){const i=this.getSessionTokenSource(w.cacheKey),d=new g(w,k,i&&i.token);let h=0;const S=E=>{h+=E.length,C(E.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(d,L.BATCH_SIZE,S,b).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:E.stats}}))}clearCache(w){this.getSessionTokenSource(w)?.cancel()}getSessionTokenSource(w){if(w)return this.sessions.has(w)||this.sessions.set(w,new A.CancellationTokenSource),this.sessions.get(w)}rawMatchToSearchItem(w){return w.relativePath?{resource:T.joinPath(w.base,w.relativePath)}:{resource:w.base}}doSearch(w,k,C,b){b.onCancellationRequested(()=>{w.cancel()});const i=h=>{h&&(d.push(h),k>0&&d.length>=k&&(C(d),d=[]))};let d=[];return w.search(i).then(h=>(d.length&&C(d),h),h=>(d.length&&C(d),Promise.reject(h)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(De[309],Ie([1,0,18,63,39,114,28,16,15,24,9,10,2,169,204,56,17,48,134,307,31]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=e.QueryBuilder=class{constructor(f,n,D,M,W){this.configurationService=f,this.workspaceContextService=n,this.editorGroupsService=D,this.logService=M,this.pathService=W}text(f,n,D={}){f=this.getContentPattern(f,D);const M=this.configurationService.getValue(),W=n&&n.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(n?.map(d.toWorkspaceFolder),D),type:2,contentPattern:f,previewOptions:D.previewOptions,maxFileSize:D.maxFileSize,usePCRE2:M.search.usePCRE2||W||!1,beforeContext:D.beforeContext,afterContext:D.afterContext,userDisabledExcludesAndIgnoreFiles:D.disregardExcludeSettings&&D.disregardIgnoreFiles}}getContentPattern(f,n){const D=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const M={...f,wordSeparators:D.editor.wordSeparators};return this.isCaseSensitive(f,n)&&(M.isCaseSensitive=!0),this.isMultiline(f)&&(M.isMultiline=!0),n.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=n.notebookSearchConfig.includeMarkupInput),n.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=n.notebookSearchConfig.includeCodeInput),n.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=n.notebookSearchConfig.includeOutput),M}file(f,n={}){return{...this.commonQuery(f,n),type:1,filePattern:n.filePattern?n.filePattern.trim():n.filePattern,exists:n.exists,sortByScore:n.sortByScore,cacheKey:n.cacheKey}}handleIncludeExclude(f,n){return f?(f=Array.isArray(f)?f.map(v):v(f),n?this.parseSearchPaths(f):{pattern:s(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],n={}){const D=this.handleIncludeExclude(n.includePattern,n.expandPatterns),M=this.handleIncludeExclude(n.excludePattern,n.expandPatterns),W=f.length>1,$=(D.searchPaths&&D.searchPaths.length?D.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,n,M)):f.map(q=>this.getFolderQueryForRoot(q,n,M,W))).filter(q=>!!q),N={_reason:n._reason,folderQueries:$,usingSearchPaths:!!(D.searchPaths&&D.searchPaths.length),extraFileResources:n.extraFileResources,excludePattern:M.pattern,includePattern:D.pattern,onlyOpenEditors:n.onlyOpenEditors,maxResults:n.maxResults};if(n.onlyOpenEditors){const q=o.coalesce(o.flatten(this.editorGroupsService.groups.map(Q=>Q.editors.map(J=>J.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(q));const F=q.filter(Q=>(0,E.pathIncludedInQuery)(N,Q.fsPath)),B=this.commonQueryFromFileList(F);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...N,...B}}const U=n.extraFileResources&&n.extraFileResources.filter(q=>(0,E.pathIncludedInQuery)(N,q.fsPath));return N.extraFileResources=U&&U.length?U:void 0,N}commonQueryFromFileList(f){const n=[],D=new T.ResourceMap,M={};let W=!1;return f.forEach($=>{if($.scheme===P.Schemas.walkThrough)return;if((0,g.isAbsolutePath)($)){const U=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:y.dirname($.fsPath)});let q=D.get(U);q||(W=!0,q={folder:U,includePattern:{}},n.push(q),D.set(U,q));const F=y.relative(U.fsPath,$.fsPath);(0,I.assertIsDefined)(q.includePattern)[F.replace(/\\/g,"/")]=!0}else $.fsPath&&(W=!0,M[$.fsPath]=!0)}),{folderQueries:n,includePattern:M,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}isCaseSensitive(f,n){if(n.isSmartCase){if(f.isRegExp){if(L.containsUppercaseCharacter(f.pattern,!0))return!0}else if(L.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,k.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const n=B=>y.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),M=(Array.isArray(f)?f:r(f)).map(B=>{const Q=this.pathService.resolvedUserHome;return Q?(0,R.untildify)(B,Q.scheme===P.Schemas.file?Q.fsPath:Q.path):B}),W=A.groupBy(M,B=>n(B)?"searchPaths":"exprSegments"),$=(W.exprSegments||[]).map(B=>L.rtrim(B,"/")).map(B=>L.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),a(B))),N={},U=this.expandSearchPathPatterns(W.searchPaths||[]);U&&U.length&&(N.searchPaths=U);const q=o.flatten($),F=s(...q);return F&&(N.pattern=F),N}getExcludesForFolder(f,n){return n.disregardExcludeSettings?void 0:(0,E.getExcludes)(f,!n.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const n=f.flatMap(M=>{let{pathPortion:W,globPortion:$}=t(M);return $&&($=_($)),this.expandOneSearchPath(W).flatMap(U=>this.resolveOneSearchPathPattern(U,$))}),D=new Map;return n.forEach(M=>{const W=M.searchPath.toString(),$=D.get(W);$?M.pattern&&($.pattern=$.pattern||{},$.pattern[M.pattern]=!0):D.set(W,{searchPath:M.searchPath,pattern:M.pattern?s(M.pattern):void 0})}),Array.from(D.values())}expandOneSearchPath(f){if(y.isAbsolute(f)){const n=this.workspaceContextService.getWorkspace().folders;return n[0]&&n[0].uri.scheme!==P.Schemas.file?[{searchPath:n[0].uri.with({path:f})}]:[{searchPath:w.URI.file(y.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const n=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=v(f),f.startsWith("../")||f===".."){const M=y.posix.resolve(n.path,f);return[{searchPath:n.with({path:M})}]}const D=_(f);return[{searchPath:n,pattern:D}]}else{if(f==="./"||f===".\\")return[];{const n=f.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(W=>{const $=n.match(new RegExp(`^${L.escapeRegExpCharacters(W.name)}(?:/(.*)|$)`));return $?{match:$,folder:W}:null}).filter(I.isDefined);if(M.length)return M.map(W=>{const $=W.match[1];return{searchPath:W.folder.uri,pattern:$&&_($)}});{const W=f.match(/\.[\/\\](.+)[\/\\]?/),$=W?W[1]:f,N=C.localize(0,null,$);throw new Error(N)}}}}resolveOneSearchPathPattern(f,n){const D=f.pattern&&n?`${f.pattern}/${n}`:f.pattern||n,M=[{searchPath:f.searchPath,pattern:D}];return D&&!D.endsWith("**")&&M.push({searchPath:f.searchPath,pattern:D+"/**"}),M}getFolderQueryForSearchPath(f,n,D){const M=this.getFolderQueryForRoot((0,d.toWorkspaceFolder)(f.searchPath),n,D,!1);return M?{...M,includePattern:f.pattern}:null}getFolderQueryForRoot(f,n,D,M){let W;const $=w.URI.isUri(f)?f:f.uri;if(D.searchPaths){const B=D.searchPaths.filter(Q=>(0,g.isEqual)(Q.searchPath,$))[0];if(B&&!B.pattern)return null;B&&(W=B.pattern)}const N=this.configurationService.getValue({resource:$}),q={...this.getExcludesForFolder(N,n)||{},...W||{}},F=w.URI.isUri(f)?(0,g.basename)(f):f.name;return{folder:$,folderName:M?F:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof n.disregardIgnoreFiles=="boolean"?n.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof n.disregardGlobalIgnoreFiles=="boolean"?n.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof n.disregardParentIgnoreFiles=="boolean"?n.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof n.ignoreSymlinks=="boolean"?n.ignoreSymlinks:!N.search.followSymlinks}}};e.QueryBuilder=p=Ve([ze(0,b.IConfigurationService),ze(1,d.IWorkspaceContextService),ze(2,h.IEditorGroupsService),ze(3,i.ILogService),ze(4,S.IPathService)],p);function t(m){const f=m.match(/[\*\{\}\(\)\[\]\?]/);if(f){const n=f.index,D=m.substr(0,n).match(/[/|\\][^/\\]*$/);if(D){let M=m.substr(0,D.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:m.substr((D.index||0)+1)}}}return{pathPortion:m}}function s(...m){return m.length?m.reduce((f,n)=>(f[n]=!0,f),Object.create(null)):void 0}function r(m){return l.splitGlobAware(m,",").map(f=>f.trim()).filter(f=>!!f.length)}function a(m){return[`**/${m}/**`,`**/${m}`].map(n=>n.replace(/\*\*\/\*\*/g,"**"))}function v(m){return m.replace(/\\/g,"/")}function _(m){return v(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(m){return m.replace(/([?*[\]])/g,"[$1]")}function u(m,f){m=o.distinct(m,M=>M.toString());const n=[],D=f.getWorkspace();return m&&m.forEach(M=>{let W;if(f.getWorkbenchState()===2)W=(0,g.relativePath)(D.folders[0].uri,M),W&&W!=="."&&(W="./"+W);else{const $=f.getWorkspaceFolder(M);if($){const N=$.name;if(D.folders.filter(q=>q.name===N).length===1){const q=(0,g.relativePath)($.uri,M);q===""?W=`./${$.name}`:W=`./${$.name}/${q}`}else W=M.fsPath}}W&&n.push(c(W))}),n}e.resolveResourcesForSearchIncludes=u}),define(De[310],Ie([1,0,24,2,21,8,4,309,31,48]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function I(b,i){const d=i.activationEvents;if(!d)return Promise.resolve(void 0);const h=[],S=[];for(const a of d)if(/^workspaceContains:/.test(a)){const v=a.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||b.forceUsingSearch?S.push(v):h.push(v)}if(h.length===0&&S.length===0)return Promise.resolve(void 0);let E;const p=new Promise((a,v)=>{E=a}),t=a=>E({activationEvent:a}),s=Promise.all(h.map(a=>w(b,a,t))).then(()=>{}),r=k(b,i.identifier,S,t);return Promise.all([s,r]).then(()=>{E(void 0)}),p}e.checkActivateWorkspaceContainsExtension=I;async function w(b,i,d){for(const h of b.folders)if(await b.exists(o.joinPath(A.URI.revive(h),i))){d(`workspaceContains:${i}`);return}}async function k(b,i,d,h){if(d.length===0)return Promise.resolve(void 0);const S=new l.CancellationTokenSource,E=b.checkExists(b.folders,d,S.token),p=setTimeout(async()=>{S.cancel(),b.logService.info(`Not activating extension '${i.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},L);let t=!1;try{t=await E}catch(s){R.isCancellationError(s)||R.onUnexpectedError(s)}S.dispose(),clearTimeout(p),t&&h(`workspaceContains:${d.join(",")}`)}function C(b,i,d,h){const S=b.get(T.IInstantiationService),E=b.get(y.ISearchService),t=S.createInstance(P.QueryBuilder).file(i.map(s=>(0,g.toWorkspaceFolder)(A.URI.revive(s))),{_reason:"checkExists",includePattern:d,exists:!0});return E.fileSearch(t,h).then(s=>!!s.limitHit,s=>R.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=C});var Je=this&&this.__classPrivateFieldSet||function(oe,e,o,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,o):l?l.value=o:e.set(oe,o),o},xe=this&&this.__classPrivateFieldGet||function(oe,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(oe):A?A.value:e.get(oe)};define(De[43],Ie([1,0,183,15,85,24,19,6,70,2,17,5,36,248,100,35,27,135,8,25,22,229,7,127,4,26,81,20,92,57,42,3,310,99,231,16,98,37,14]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h,S,E,p,t,s,r,a,v,_,c,u,m,f,n,D,M,W,$,N,U){"use strict";var q,F,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let Q=e.AbstractExtHostExtensionService=class In extends P.Disposable{constructor(V,x,Z,pe,_e,re,ne,de,ee,ce,le){super(),this._onDidChangeRemoteConnectionData=this._register(new f.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=x,this._extHostContext=Z,this._initData=ne,this._extHostWorkspace=pe,this._extHostConfiguration=_e,this._logService=re,this._extHostTunnelService=ee,this._extHostTerminalService=ce,this._extHostLocalizationService=le,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._activationEventsReader=new he(this._initData.activationEvents),this._globalRegistry=new d.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.allExtensions);const ue=new S.ExtensionIdentifierSet(this._initData.myExtensions);this._myRegistry=new d.ExtensionDescriptionRegistry(this._activationEventsReader,ae(this._globalRegistry,ue)),this._storage=new C.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new D.ExtHostSecretState(this._extHostContext),this._storagePath=de,this._instaService=V.createChild(new c.ServiceCollection([C.IExtHostStorage,this._storage],[D.IExtHostSecretState,this._secretState])),this._activator=this._register(new k.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(O,j,Y)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(O,h.transformErrorForSerialization(j),Y)},actualActivateExtension:async(O,j)=>{if(d.ExtensionDescriptionRegistry.isHostExtension(O,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(O,j),new k.HostExtension;const Y=this._myRegistry.getExtensionDescription(O);return this._activateExtension(Y,j)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),l.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){h.onUnexpectedError(V)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._myRegistry.getAllExtensionDescriptions().map(_e=>_e.identifier).filter(_e=>this.isActivated(_e)).map(_e=>this._deactivate(_e))}catch{}await Promise.all(V)}terminate(V,x=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${V}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),h.setUnexpectedErrorHandler(pe=>{this._logService.error(pe)}),this._extHostContext.dispose();const Z=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),Z]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${x}`):this._logService.info(`Extension host exiting with code ${x}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(x)})}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}async getExtension(V){const x=await this._mainThreadExtensionsProxy.$getExtension(V);return x&&{...x,identifier:new S.ExtensionIdentifier(x.identifier.value),extensionLocation:g.URI.revive(x.extensionLocation)}}_activateByEvent(V,x){return this._activator.activateByEvent(V,x)}_activateById(V,x){return this._activator.activateById(V,x)}activateByIdWithErrors(V,x){return this._activateById(V,x).then(()=>{const Z=this._activator.getActivatedExtension(V);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._myRegistry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}async _realPathExtensionUri(V){if(V.scheme!==W.Schemas.file)return V;const x=await this._hostUtils.realpath(V.fsPath);return g.URI.file(x)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(V=>new we(V))),this._extensionPathIndex}async _createExtensionPathIndex(V){const x=y.TernarySearchTree.forUris(Z=>R.extUriBiasedIgnorePathCase.ignorePathCasing(Z));return await Promise.all(V.map(async Z=>{if(this._getEntryPoint(Z)){const pe=await this._realPathExtensionUri(Z.extensionLocation);x.set(pe,Z)}})),x}_deactivate(V){let x=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return x;const Z=this._activator.getActivatedExtension(V);if(!Z)return x;try{typeof Z.module.deactivate=="function"&&(x=Promise.resolve(Z.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(`An error occurred when deactivating the extension '${V.value}':`),this._logService.error(pe)}try{(0,P.dispose)(Z.subscriptions)}catch(pe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${V.value}':`),this._logService.error(pe)}return x}async _activateExtension(V,x){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,x).then(Z=>{const pe=Z.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,x),this._logExtensionActivationTimes(V,x,"success",pe),Z},Z=>{throw this._logExtensionActivationTimes(V,x,"failure"),Z})}_logExtensionActivationTimes(V,x,Z,pe){const _e=X(V,x);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{..._e,...pe||{},outcome:Z})}_doActivateExtension(V,x){const Z=X(V,x);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Z);const pe=this._getEntryPoint(V);if(!pe)return Promise.resolve(new k.EmptyExtension(k.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${V.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this._logService.flush();const _e=new k.ExtensionActivationTimesBuilder(x.startup);return Promise.all([this._loadCommonJSModule(V,(0,R.joinPath)(V.extensionLocation,pe),_e),this._loadExtensionContext(V)]).then(re=>(l.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),In._callActivate(this._logService,V.identifier,re[0],re[1],_e))).then(re=>(l.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),re))}_loadExtensionContext(V){const x=new p.ExtensionGlobalMemento(V,this._storage),Z=new p.ExtensionMemento(V.identifier.value,!1,this._storage),pe=new M.ExtensionSecrets(V,this._secretState),_e=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,re=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([x.whenReady,Z.whenReady,this._storagePath.whenReady]).then(()=>{const ne=this;let de,ee;const ce=(0,i.isProposedApiEnabled)(V,"ipc")?this._initData.messagePorts?.get(S.ExtensionIdentifier.toKey(V.identifier)):void 0;return Object.freeze({globalState:x,workspaceState:Z,secrets:pe,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(le){return A.join(V.extensionLocation.fsPath,le)},get storagePath(){return ne._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return ne._storagePath.globalValue(V).fsPath},get logPath(){return A.join(ne._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return g.URI.joinPath(ne._initData.logsLocation,V.identifier.value)},get storageUri(){return ne._storagePath.workspaceValue(V)},get globalStorageUri(){return ne._storagePath.globalValue(V)},get extensionMode(){return _e},get extension(){return de===void 0&&(de=new ie(ne,V.identifier,V,re,!1)),de},get extensionRuntime(){return(0,i.checkProposedApiEnabled)(V,"extensionRuntime"),ne.extensionRuntime},get environmentVariableCollection(){return ne._extHostTerminalService.getEnvironmentVariableCollection(V)},get messagePassingProtocol(){if(!ee){if(!ce)return;const le=f.Event.buffer(f.Event.fromDOMEventEmitter(ce,"message",ue=>ue.data));ce.start(),ee={onDidReceiveMessage:le,postMessage:ce.postMessage.bind(ce)}}return ee}})})}static _callActivate(V,x,Z,pe,_e){return Z=Z||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,x,Z,pe,_e).then(re=>new k.ActivatedExtension(!1,null,_e.build(),Z,re,pe.subscriptions))}static _callActivateOptional(V,x,Z,pe,_e){if(typeof Z.activate=="function")try{_e.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${x.value}`);const re=typeof global=="object"?global:self,ne=Z.activate.apply(re,[pe]);return _e.activateCallStop(),_e.activateResolveStart(),Promise.resolve(ne).then(de=>(_e.activateResolveStop(),de))}catch(re){return Promise.reject(re)}else return Promise.resolve(Z)}_activateOneStartupFinished(V,x){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:x}).then(void 0,Z=>{this._logService.error(Z)})}_activateAllStartupFinishedDeferred(V,x=0){const pe=Date.now();(0,U.setTimeout0)(()=>{for(let _e=x;_e<V.length;_e+=1){const re=V[_e];for(const ne of re.activationEvents??[])if(ne==="onStartupFinished")if(Date.now()-pe>50){this._activateAllStartupFinishedDeferred(V,_e);break}else this._activateOneStartupFinished(re,ne)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(l.getMarks()),this._extHostConfiguration.getConfigProvider().then(V=>{const x=V.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Z=this._myRegistry.getAllExtensionDescriptions();if(x)this._activateAllStartupFinishedDeferred(Z);else for(const pe of Z)if(pe.activationEvents)for(const _e of pe.activationEvents)_e==="onStartupFinished"&&this._activateOneStartupFinished(pe,_e)})}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,re=>{this._logService.error(re)});this._register(this._extHostWorkspace.onDidChangeWorkspace(re=>this._handleWorkspaceContainsEagerExtensions(re.added)));const x=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Z=this._handleWorkspaceContainsEagerExtensions(x),pe=this._handleRemoteResolverEagerExtensions(),_e=Promise.all([pe,V,Z]).then(()=>{});return Promise.race([_e,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),_e}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(x=>this._handleWorkspaceContainsEagerExtension(V,x))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,x){if(this.isActivated(x.identifier))return;const Z=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={logService:this._logService,folders:V.map(re=>re.uri),forceUsingSearch:Z,exists:re=>this._hostUtils.exists(re.fsPath),checkExists:(re,ne,de)=>this._mainThreadWorkspaceProxy.$checkExists(re,ne,de)},_e=await(0,n.checkActivateWorkspaceContainsExtension)(pe,x);if(_e)return this._activateById(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:_e.activationEvent}).then(void 0,re=>this._logService.error(re))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:x}=this._initData.environment;if(!V||!x)throw new Error(o.localize(0,null));const Z=await this._loadCommonJSModule(null,x,new k.ExtensionActivationTimesBuilder(!1));if(!Z||typeof Z.run!="function")throw new Error(o.localize(1,null,x.toString()));return new Promise((pe,_e)=>{const re=(ee,ce)=>{ee?_e(ee):pe(typeof ce=="number"&&ce>0?1:0)},ne=(0,R.originalFSPath)(x),de=Z.run(ne,re);de&&de.then&&de.then(()=>{pe(0)}).catch(ee=>{_e(ee instanceof Error&&ee.stack?ee.stack:String(ee))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,T.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,x){return this._resolvers[V]=x,(0,P.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const x=V.indexOf("+");if(x===-1)throw new Error("Not an authority that can be resolved!");const Z=V.substr(0,x);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this._resolvers[Z]}}async $resolveAuthority(V,x){const Z=N.StopWatch.create(!1),pe=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(V)},${x})][${Z.elapsed()}ms] `,_e=ce=>this._logService.info(`${pe()}${ce}`),re=(ce,le=void 0)=>this._logService.error(`${pe()}${ce}`,le);_e("activating resolver...");const{authorityPrefix:ne,resolver:de}=await this._activateAndGetResolver(V);if(!de)return re("no resolver"),{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};const ee=new T.IntervalTimer;try{_e("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(de)),ee.cancelAndSet(()=>_e("waiting..."),1e3),_e("invoking resolve()..."),l.mark(`code/extHost/willResolveAuthority/${ne}`);const ce=await de.resolve(V,{resolveAttempt:x});l.mark(`code/extHost/didResolveAuthorityOK/${ne}`),ee.dispose(),_e(`returned ${ce.host}:${ce.port}`);const le={authority:V,host:ce.host,port:ce.port,connectionToken:ce.connectionToken},ue={extensionHostEnv:ce.extensionHostEnv,isTrusted:ce.isTrusted,authenticationSession:ce.authenticationSessionForInitializingExtensions?{id:ce.authenticationSessionForInitializingExtensions.id,providerId:ce.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:le,options:ue,tunnelInformation:{environmentTunnels:ce.environmentTunnels,features:ce.tunnelFeatures}}}}catch(ce){if(l.mark(`code/extHost/didResolveAuthorityError/${ne}`),ee.dispose(),re("returned an error",ce),ce instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ce._code,message:ce._message,detail:ce._detail}};throw ce}}async $getCanonicalURI(V,x){this._logService.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(V)})`);const{resolver:Z}=await this._activateAndGetResolver(V);if(!Z)return null;const pe=g.URI.revive(x);if(typeof Z.getCanonicalURI>"u")return pe;const _e=await(0,T.asPromise)(()=>Z.getCanonicalURI(pe));return _e||pe}$startExtensionHost(V){V.toAdd.forEach(pe=>pe.extensionLocation=g.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:Z}=J(this._activationEventsReader,this._globalRegistry,this._myRegistry,V);return this._globalRegistry.set(x.getAllExtensionDescriptions()),this._myRegistry.set(Z),this._startExtensionHost()}$activateByEvent(V,x){return x===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(Z=>this._activateByEvent(V,!1))}async $activate(V,x){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(V)?(await this._activateById(V,x),!0):!1}async $deltaExtensions(V){V.toAdd.forEach(re=>re.extensionLocation=g.URI.revive(re.extensionLocation));const{globalRegistry:x,myExtensions:Z}=J(this._activationEventsReader,this._globalRegistry,this._myRegistry,V),pe=await this._createExtensionPathIndex(Z);return(await this.getExtensionPathIndex()).setSearchTree(pe),this._globalRegistry.set(x.getAllExtensionDescriptions()),this._myRegistry.set(Z),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){const x=E.VSBuffer.alloc(V),Z=Math.random()%256;for(let pe=0;pe<V;pe++)x.writeUInt8(Z,pe);return x}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=Q=Ve([ze(0,r.IInstantiationService),ze(1,e.IHostUtils),ze(2,_.IExtHostRpcService),ze(3,b.IExtHostWorkspace),ze(4,w.IExtHostConfiguration),ze(5,L.ILogService),ze(6,a.IExtHostInitDataService),ze(7,v.IExtensionStoragePaths),ze(8,u.IExtHostTunnelService),ze(9,m.IExtHostTerminalService),ze(10,$.IExtHostLocalizationService)],Q);function J(fe,V,x,Z){fe.addActivationEvents(Z.addActivationEvents);const pe=new d.ExtensionDescriptionRegistry(fe,V.getAllExtensionDescriptions());pe.deltaExtensions(Z.toAdd,Z.toRemove);const _e=new S.ExtensionIdentifierSet(x.getAllExtensionDescriptions().map(ne=>ne.identifier));for(const ne of Z.myToRemove)_e.delete(ne);for(const ne of Z.myToAdd)_e.add(ne);const re=ae(pe,_e);return{globalRegistry:pe,myExtensions:re}}function X(fe,V){return{id:fe.identifier.value,name:fe.name,extensionVersion:fe.version,publisherDisplayName:fe.publisher,activationEvents:fe.activationEvents?fe.activationEvents.join(","):null,isBuiltin:fe.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class ie{constructor(V,x,Z,pe,_e){q.set(this,void 0),F.set(this,void 0),B.set(this,void 0),Je(this,q,V,"f"),Je(this,F,x,"f"),Je(this,B,Z.identifier,"f"),this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=A.normalize((0,R.originalFSPath)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=pe,this.isFromDifferentExtensionHost=_e}get isActive(){return xe(this,q,"f").isActivated(xe(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return xe(this,q,"f").getExtensionExports(xe(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await xe(this,q,"f").activateByIdWithErrors(xe(this,B,"f"),{startup:!1,extensionId:xe(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=ie,q=new WeakMap,F=new WeakMap,B=new WeakMap;function ae(fe,V){return fe.getAllExtensionDescriptions().filter(x=>V.has(x.identifier))}class we{constructor(V){this._searchTree=V}setSearchTree(V){this._searchTree=V}findSubstr(V){return this._searchTree.findSubstr(V)}forEach(V){return this._searchTree.forEach(V)}}e.ExtensionPaths=we;class he{constructor(V){this._map=new S.ExtensionIdentifierMap,this.addActivationEvents(V)}readActivationEvents(V){return this._map.get(V.identifier)}addActivationEvents(V){for(const x of Object.keys(V))this._map.set(x,V[x])}}}),define(De[311],Ie([1,0,85,2,5,36,27,25,20,26,4,43,33,17,9]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let b=e.RequireInterceptor=class{constructor(p,t,s,r,a,v,_){this._apiFactory=p,this._extensionRegistry=t,this._instaService=s,this._extHostConfiguration=r,this._extHostExtensionService=a,this._initData=v,this._logService=_,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),o.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,t,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(h,t)),this.register(this._instaService.createInstance(i)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(S,t,this._initData.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const t of p.nodeModuleName)this._factories.set(t,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(t=>p.alternativeModuleName(t))}};e.RequireInterceptor=b=Ve([ze(2,L.IInstantiationService),ze(3,R.IExtHostConfiguration),ze(4,I.IExtHostExtensionService),ze(5,g.IExtHostInitDataService),ze(6,k.ILogService)],b);let i=class cn{constructor(p){if(p.environment.appRoot&&cn.aliased.size){const t=(0,C.escapeRegExpCharacters)(this.forceForwardSlashes(p.environment.appRoot.fsPath)),s="[a-z0-9_.-]",r=`@${s}+\\/${s}+|${s}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${a}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(p){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(p));if(!t)return;const[,s,r,a]=t,v=cn.aliased.get(r);if(v!==void 0)return console.warn(`${r} as been renamed to ${v}, please update your imports`),s+v+a}forceForwardSlashes(p){return p.replace(/\\/g,"/")}};i.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),i=Ve([ze(0,g.IExtHostInitDataService)],i);class d{constructor(p,t,s,r,a){this._apiFactory=p,this._extensionPaths=t,this._extensionRegistry=s,this._configProvider=r,this._logService=a,this.nodeModuleName="vscode",this._extApiImpl=new P.ExtensionIdentifierMap}load(p,t){const s=this._extensionPaths.findSubstr(t);if(s){let r=this._extApiImpl.get(s.identifier);return r||(r=this._apiFactory(s,this._extensionRegistry,this._configProvider),this._extApiImpl.set(s.identifier,r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((a,v)=>r+=`	${v} -> ${a.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let h=class{constructor(p,t,s){this._extensionPaths=p,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(l.MainContext.MainThreadTelemetry);const{environment:r}=s,a=t.getProxy(l.MainContext.MainThreadKeytar);if(r.appRoot){let v=r.appRoot.fsPath;w.platform==="win32"&&(v=v.replace(/\\/g,"/")),v[v.length-1]==="/"&&(v=v.substr(0,v.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${v}/node_modules.asar/keytar`),this.alternativeNames.add(`${v}/node_modules/keytar`)}this._impl={getPassword:(v,_)=>a.$getPassword(v,_),setPassword:(v,_,c)=>a.$setPassword(v,_,c),deletePassword:(v,_)=>a.$deletePassword(v,_),findPassword:v=>a.$findPassword(v),findCredentials(v){return a.$findCredentials(v)}}}load(p,t){const s=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(p){const t=p.length;if(t<=7||!this.alternativeNames)return;const s=t-7;if((p.charAt(s)==="/"||p.charAt(s)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}};h=Ve([ze(1,y.IExtHostRpcService),ze(2,g.IExtHostInitDataService)],h);let S=class{constructor(p,t,s){this._extensionPaths=p,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=s.getProxy(l.MainContext.MainThreadTelemetry);const r=s.getProxy(l.MainContext.MainThreadWindow);this._impl=(a,v)=>{const _=A.URI.parse(a);return v?this.callOriginal(a,v):_.scheme==="http"||_.scheme==="https"?r.$openUri(_,a,{allowTunneling:!0}):_.scheme==="mailto"||_.scheme===this._appUriScheme?r.$openUri(_,a,{}):this.callOriginal(a,v)}}load(p,t,s){const r=this._extensionPaths.findSubstr(t);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=s(p),this._impl}callOriginal(p,t){return this.sendNoForwardTelemetry(),this._original(p,t)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};S=Ve([ze(2,y.IExtHostRpcService)],S)}),define(De[50],Ie([1,0,66,6,15,33,4,61,62,43,7,35,244,36]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class C extends w.AbstractVariableResolverService{constructor(d,h,S,E,p,t,s){function r(){if(S){const a=S.activeEditor();if(a)return a.document.uri;const v=E.tabGroups.all.find(_=>_.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof L.TextDiffTabInput||v.input instanceof L.NotebookDiffEditorTabInput)return v.input.modified;if(v.input instanceof L.TextTabInput||v.input instanceof L.NotebookEditorTabInput||v.input instanceof L.CustomEditorTabInput)return v.input.uri}}}super({getFolderUri:a=>{const v=t.folders.filter(_=>_.name===a);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(a,v)=>p.getConfiguration(void 0,a).get(v),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=r();if(a)return l.normalize(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const a=r();if(a){const v=h.getWorkspaceFolder(a);if(v)return l.normalize(v.uri.fsPath)}}},getSelectedText:()=>{if(S){const a=S.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(S){const a=S.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>d.getExtension(a)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let b=e.ExtHostVariableResolverProviderService=class extends A.Disposable{constructor(d,h,S,E,p){super(),this.extensionService=d,this.workspaceService=h,this.editorService=S,this.configurationService=E,this.editorTabs=p,this._resolver=new o.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async a=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new C(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,r,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=b=Ve([ze(0,g.IExtHostExtensionService),ze(1,I.IExtHostWorkspace),ze(2,P.IExtHostDocumentsAndEditors),ze(3,k.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs)],b)}),define(De[86],Ie([1,0,19,3,10,2,4,5,62,43,20,7,35,131,238,36,50]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,T.createDecorator)("IExtHostDebugService");let d=e.ExtHostDebugServiceBase=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,a,v,_,c,u){this._workspaceService=a,this._extensionService=v,this._configurationService=_,this._editorTabs=c,this._variableResolver=u,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=r.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._onDidChangeStackFrameFocus=new A.Emitter,this._activeDebugConsole=new S(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(m=>{m.onDidChange(f=>{this.registerAllDebugTypes(m)}),this.registerAllDebugTypes(m)})}asDebugSourceUri(r,a){const v=r;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let _=`debug:${encodeURIComponent(v.path||"")}`,c="?";return a&&(_+=`${c}session=${encodeURIComponent(a.id)}`,c="&"),_+=`${c}ref=${v.sourceReference}`,R.URI.parse(_)}else{if(v.path)return R.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const a=[];for(const v of r.getAllExtensionDescriptions())if(v.contributes){const _=v.contributes.debuggers;if(_&&_.length>0)for(const c of _)(0,C.isDebuggerMainContribution)(c)&&a.push(c.type)}this._debugServiceProxy.$registerDebugTypes(a)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(a=>r.push(a)),r}addBreakpoints(r){this.startBreakpoints();const a=r.filter(c=>{const u=c.id;return this._breakpoints.has(u)?!1:(this._breakpoints.set(u,c),!0)});this.fireBreakpointChanges(a,[],[]);const v=[],_=new Map;for(const c of a)if(c instanceof I.SourceBreakpoint){let u=_.get(c.location.uri.toString());u||(u={type:"sourceMulti",uri:c.location.uri,lines:[]},_.set(c.location.uri.toString(),u),v.push(u)),u.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof I.FunctionBreakpoint&&v.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(v)}removeBreakpoints(r){this.startBreakpoints();const a=r.filter(u=>this._breakpoints.delete(u.id));this.fireBreakpointChanges([],a,[]);const v=a.filter(u=>u instanceof I.SourceBreakpoint).map(u=>u.id),_=a.filter(u=>u instanceof I.FunctionBreakpoint).map(u=>u.id),c=a.filter(u=>u instanceof I.DataBreakpoint).map(u=>u.id);return this._debugServiceProxy.$unregisterBreakpoints(v,_,c)}startDebugging(r,a,v){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,a,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,a,v){if(!a)return new I.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:_,provider:a}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,v,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,_),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==a),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(r,a,v){if(!v)return new I.Disposable(()=>{});if(!this.definesDebugType(r,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.getAdapterDescriptorFactoryByType(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:a,handle:_,factory:v}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(a,_),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==v),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(r,a){if(!a)return new I.Disposable(()=>{});const v=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:v,factory:a}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==a)})}async $runInTerminal(r,a){return Promise.resolve(void 0)}async $substituteVariables(r,a){let v;const _=await this.getFolder(r);return _&&(v={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(v,a)}createDebugAdapter(r,a){if(r.type==="implementation")return new p(r.implementation)}createSignService(){}async $startDASession(r,a){const v=this,_=await this.getSession(a);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const u=this.convertToDto(c),m=this.createDebugAdapter(u,_);if(!m)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const f=m;return this._debugAdapters.set(r,f),this.getDebugAdapterTrackers(_).then(n=>(n&&this._debugAdaptersTrackers.set(r,n),f.onMessage(async D=>{if(D.type==="request"&&D.command==="handshake"){const M=D,W={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(M.arguments.value);W.body={signature:$},f.sendResponse(W)}else throw new Error("no signer")}catch($){W.success=!1,W.message=$.message,f.sendResponse(W)}}else n&&n.onDidSendMessage&&n.onDidSendMessage(D),D=(0,C.convertToVSCPaths)(D,!0),v._debugServiceProxy.$acceptDAMessage(r,D)}),f.onError(D=>{n&&n.onError&&n.onError(D),this._debugServiceProxy.$acceptDAError(r,D.name,D.message,D.stack)}),f.onExit(D=>{n&&n.onExit&&n.onExit((0,l.withNullAsUndefined)(D),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,l.withNullAsUndefined)(D),void 0)}),n&&n.onWillStartSession&&n.onWillStartSession(),f.startSession()))})}$sendDAMessage(r,a){a=(0,C.convertToDAPaths)(a,!1);const v=this._debugAdaptersTrackers.get(r);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(a),this._debugAdapters.get(r)?.sendMessage(a)}$stopDASession(r){const a=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),a&&a.onWillStopSession&&a.onWillStopSession();const v=this._debugAdapters.get(r);return this._debugAdapters.delete(r),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const a=[],v=[],_=[];if(r.added)for(const c of r.added){const u=c.id;if(u&&!this._breakpoints.has(u)){let m;if(c.type==="function")m=new I.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")m=new I.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const f=R.URI.revive(c.uri);m=new I.SourceBreakpoint(new I.Location(f,new I.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}(0,I.setBreakpointId)(m,u),this._breakpoints.set(u,m),a.push(m)}}if(r.removed)for(const c of r.removed){const u=this._breakpoints.get(c);u&&(this._breakpoints.delete(c),v.push(u))}if(r.changed){for(const c of r.changed)if(c.id){const u=this._breakpoints.get(c.id);if(u){if(u instanceof I.FunctionBreakpoint&&c.type==="function"){const m=u;m.enabled=c.enabled,m.condition=c.condition,m.hitCondition=c.hitCondition,m.logMessage=c.logMessage,m.functionName=c.functionName}else if(u instanceof I.SourceBreakpoint&&c.type==="source"){const m=u;m.enabled=c.enabled,m.condition=c.condition,m.hitCondition=c.hitCondition,m.logMessage=c.logMessage,m.location=new I.Location(R.URI.revive(c.uri),new I.Position(c.line,c.character))}_.push(u)}}}this.fireBreakpointChanges(a,v,_)}async $acceptStackFrameFocus(r){let a;const v=r.sessionId?await this.getSession(r.sessionId):void 0;if(!v)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?a={kind:r.kind,threadId:r.threadId,session:v}:a={kind:r.kind,threadId:r.threadId,frameId:r.frameId,session:v},this._stackFrameFocus=a,this._onDidChangeStackFrameFocus.fire(a)}$provideDebugConfigurations(r,a,v){return(0,o.asPromise)(async()=>{const _=this.getConfigProviderByHandle(r);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(a);return _.provideDebugConfigurations(c,v)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(r,a,v,_){return(0,o.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.getFolder(a);return c.resolveDebugConfiguration(u,v,_)})}$resolveDebugConfigurationWithSubstitutedVariables(r,a,v,_){return(0,o.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.getFolder(a);return c.resolveDebugConfigurationWithSubstitutedVariables(u,v,_)})}async $provideDebugAdapter(r,a){const v=this.getAdapterDescriptorFactoryByHandle(r);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(a);return this.getAdapterDescriptor(v,_).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(r){const a=await this.getSession(r);this._onDidStartDebugSession.fire(a)}async $acceptDebugSessionTerminated(r){const a=await this.getSession(r);a&&(this._onDidTerminateDebugSession.fire(a),this._debugSessions.delete(a.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,a){(await this.getSession(r))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(r,a){const _={session:await this.getSession(r),event:a.event,body:a.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(r){if(r instanceof I.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof I.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const a=this._adapterFactories.filter(v=>v.type===r);if(a.length>0)return a[0].factory}getAdapterDescriptorFactoryByHandle(r){const a=this._adapterFactories.filter(v=>v.handle===r);if(a.length>0)return a[0].factory}getConfigProviderByHandle(r){const a=this._configProviders.filter(v=>v.handle===r);if(a.length>0)return a[0].provider}definesDebugType(r,a){if(r.contributes){const v=r.contributes.debuggers;if(v&&v.length>0){for(const _ of v)if(_.label&&_.type&&_.type===a)return!0}}return!1}getDebugAdapterTrackers(r){const v=r.configuration.type,_=this._trackerFactories.filter(c=>c.type===v||c.type==="*").map(c=>(0,o.asPromise)(()=>c.factory.createDebugAdapterTracker(r)).then(u=>u,u=>null));return Promise.race([Promise.all(_).then(c=>{const u=c.filter(m=>!!m);if(u.length>0)return new E(u)}),new Promise(c=>setTimeout(()=>c(void 0),1e3))]).catch(c=>{})}async getAdapterDescriptor(r,a){const v=a.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new I.DebugAdapterServer(v));if(r){const c=await this._extensionService.getExtensionRegistry();return(0,o.asPromise)(()=>r.createDebugAdapterDescriptor(a,this.daExecutableFromPackage(a,c))).then(u=>{if(u)return u})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(a,_))}daExecutableFromPackage(r,a){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,a,v){(r.length>0||a.length>0||v.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:a,changed:v}))}async getSession(r){if(r)if(typeof r=="string"){const a=this._debugSessions.get(r);if(a)return a}else{let a=this._debugSessions.get(r.id);if(!a){const v=await this.getFolder(r.folderUri),_=r.parent?this._debugSessions.get(r.parent):void 0;a=new h(this._debugServiceProxy,r.id,r.type,r.name,v,r.configuration,_),this._debugSessions.set(a.id,a),this._debugServiceProxy.$sessionCached(a.id)}return a}throw new Error("cannot find session")}getFolder(r){if(r){const a=R.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=d=Ve([ze(0,L.IExtHostRpcService),ze(1,w.IExtHostWorkspace),ze(2,g.IExtHostExtensionService),ze(3,b.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs),ze(5,i.IExtHostVariableResolverProvider)],d);class h{constructor(r,a,v,_,c,u,m){this._debugServiceProxy=r,this._id=a,this._type=v,this._name=_,this._workspaceFolder=c,this._configuration=u,this._parentSession=m}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,a){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,a)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=h;class S{constructor(r){this.value=Object.freeze({append(a){r.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.ExtHostDebugConsole=S;class E{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(a=>a.onError?a.onError(r):void 0)}onExit(r,a){this.trackers.forEach(v=>v.onExit?v.onExit(r,a):void 0)}}class p extends k.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=e.WorkerExtHostDebugService=class extends d{constructor(r,a,v,_,c,u){super(r,a,v,_,c,u)}};e.WorkerExtHostDebugService=t=Ve([ze(0,L.IExtHostRpcService),ze(1,w.IExtHostWorkspace),ze(2,g.IExtHostExtensionService),ze(3,b.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs),ze(5,i.IExtHostVariableResolverProvider)],t)}),define(De[312],Ie([1,0,8,85,2,5,304,17,91,92,26,212,20,58,43,78]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class i{static async installEarlyHandler(S){const E=S.get(P.ILogService),t=S.get(w.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);o.setUnexpectedErrorHandler(s=>{E.error(s);const r=o.transformErrorForSerialization(s);t.$onUnexpectedError(r)})}static async installFullHandler(S){const E=S.get(P.ILogService),p=S.get(w.IExtHostRpcService),t=S.get(C.IExtHostExtensionService),s=S.get(b.IExtHostTelemetry),r=p.getProxy(R.MainContext.MainThreadExtensionService),a=p.getProxy(R.MainContext.MainThreadErrors),v=await t.getExtensionPathIndex(),_=new WeakMap;function c(m,f){let n="",D,M;for(const W of f)n+=`
	at ${W.toString()}`,M=W.getFileName(),!D&&M&&(D=v.findSubstr(l.URI.file(M)));return _.set(m,D?.identifier),`${m.name||"Error"}: ${m.message||""}${n}`}let u=c;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(m){u=function(f,n){return c(f,n),m.call(Error,f,n)}}}),o.setUnexpectedErrorHandler(m=>{E.error(m);const f=o.transformErrorForSerialization(m),n=_.get(m);if(!n){a.$onUnexpectedError(f);return}r.$onExtensionRuntimeError(n,f);const D=s.onExtensionError(n,m);E.trace("forwarded error to extension?",D,n)})}}Error.stackTraceLimit=100;class d{constructor(S,E,p,t,s){this._hostUtils=p,this._rpcProtocol=new T.RPCProtocol(S,null,t),E=d._transform(E,this._rpcProtocol);const r=new g.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());r.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...E,messagePorts:s}),r.set(w.IExtHostRpcService,new w.ExtHostRpcService(this._rpcProtocol)),r.set(k.IURITransformerService,new k.URITransformerService(t)),r.set(C.IHostUtils,p);const a=new I.InstantiationService(r,!0);a.invokeFunction(i.installEarlyHandler),this._logService=a.invokeFunction(v=>v.get(P.ILogService)),A.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",E),this._extensionService=a.invokeFunction(v=>v.get(C.IExtHostExtensionService)),this._extensionService.initialize(),a.invokeFunction(i.installFullHandler)}async asBrowserUri(S){const E=this._rpcProtocol.getProxy(R.MainContext.MainThreadExtensionService);return l.URI.revive(await E.$asBrowserUri(S))}terminate(S){this._extensionService.terminate(S)}static _transform(S,E){S.allExtensions.forEach(t=>{t.extensionLocation=l.URI.revive(E.transformIncomingURIs(t.extensionLocation))}),S.environment.appRoot=l.URI.revive(E.transformIncomingURIs(S.environment.appRoot));const p=S.environment.extensionDevelopmentLocationURI;return p&&(S.environment.extensionDevelopmentLocationURI=p.map(t=>l.URI.revive(E.transformIncomingURIs(t)))),S.environment.extensionTestsLocationURI=l.URI.revive(E.transformIncomingURIs(S.environment.extensionTestsLocationURI)),S.environment.globalStorageHome=l.URI.revive(E.transformIncomingURIs(S.environment.globalStorageHome)),S.environment.workspaceStorageHome=l.URI.revive(E.transformIncomingURIs(S.environment.workspaceStorageHome)),S.environment.extensionTelemetryLogResource=l.URI.revive(E.transformIncomingURIs(S.environment.extensionTelemetryLogResource)),S.nlsBaseUrl=l.URI.revive(E.transformIncomingURIs(S.nlsBaseUrl)),S.logsLocation=l.URI.revive(E.transformIncomingURIs(S.logsLocation)),S.workspace=E.transformIncomingURIs(S.workspace),S}}e.ExtensionHostMain=d}),define(De[313],Ie([1,0,19,14,193,211,219,86,62,43,20,42,7,50,35,239,240,36]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let h=e.ExtHostDebugService=class extends P.ExtHostDebugServiceBase{constructor(s,r,a,v,_,c,u){super(s,r,a,v,c,u),this._terminalService=_,this._integratedTerminalInstances=new p}createDebugAdapter(s,r){switch(s.type){case"server":return new b.SocketDebugAdapter(s);case"pipeServer":return new b.NamedPipeDebugAdapter(s);case"executable":return new b.ExecutableDebugAdapter(s,r.type)}return super.createDebugAdapter(s,r)}daExecutableFromPackage(s,r){const a=b.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),s.type);if(a)return new w.DebugAdapterExecutable(a.command,a.args,a.options)}createSignService(){return new T.SignService}async $runInTerminal(s,r){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal($=>{this._integratedTerminalInstances.onTerminalClosed($)}));const a=await this._configurationService.getConfigProvider(),v=this._terminalService.getDefaultShell(!0),_=this._terminalService.getDefaultShellArgs(!0),c=s.title||l.localize(0,null),u=JSON.stringify({shell:v,shellArgs:_});let m=await this._integratedTerminalInstances.checkout(u,c),f,n=!1;if(m)f=s.cwd;else{const $={shellPath:v,shellArgs:_,cwd:s.cwd,name:c,iconPath:new w.ThemeIcon("debug")};n=!0,m=this._terminalService.createTerminalFromOptions($,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(m,u)}m.show(!0);const D=await m.processId;n?await new Promise($=>setTimeout($,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0||v.indexOf("cmd.exe")>=0?m.sendText("cls"):v.indexOf("bash")>=0?m.sendText("clear"):A.isWindows?m.sendText("cls"):m.sendText("clear"));const M=(0,i.prepareCommand)(v,s.args,!!s.argsCanBeInterpretedByShell,f,s.env);m.sendText(M);const W=this.onDidTerminateDebugSession($=>{$.id===r&&(this._integratedTerminalInstances.free(m),W.dispose())});return D}else if(s.kind==="external")return E(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,r)}};e.ExtHostDebugService=h=Ve([ze(0,L.IExtHostRpcService),ze(1,C.IExtHostWorkspace),ze(2,g.IExtHostExtensionService),ze(3,d.IExtHostConfiguration),ze(4,I.IExtHostTerminalService),ze(5,y.IExtHostEditorTabs),ze(6,k.IExtHostVariableResolverProvider)],h);let S;function E(t,s){if(!S)if(A.isWindows)S=new R.WindowsExternalTerminalService;else if(A.isMacintosh)S=new R.MacExternalTerminalService;else if(A.isLinux)S=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=s.getConfiguration("terminal");return S.runInTerminal(t.title,t.cwd,t.args,t.env||{},r.external||{})}class p{constructor(){this._terminalInstances=new Map}async checkout(s,r){const v=[...this._terminalInstances.entries()].map(([_,c])=>(0,o.createCancelablePromise)(async u=>{if(_.name!==r||c.lastUsedAt!==-1&&await(0,i.hasChildProcesses)(await _.processId))return null;const m=Date.now();return c.lastUsedAt+p.minUseDelay>m||u.isCancellationRequested||c.config!==s?null:(c.lastUsedAt=m,_)}));return await(0,o.firstParallel)(v,_=>!!_)}insert(s,r){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:r})}free(s){const r=this._terminalInstances.get(s);r&&(r.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}p.minUseDelay=1e3}),define(De[314],Ie([1,0,15,2,117,35,61,36,48,42,20,26,84,16,17,79,24,55,50]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let S=e.ExtHostTask=class extends w.ExtHostTaskBase{constructor(p,t,s,r,a,v,_,c,u){super(p,t,s,r,a,v,_,c),this.workspaceService=s,this.variableResolver=u,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,t){const s=t;if(!t.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const r=w.TaskHandleDTO.from(s,this.workspaceService),a=await this._proxy.$getTaskExecution(r);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const v=await this.getTaskExecution(a,t);return this._proxy.$executeTask(r).catch(()=>{}),v}else{const r=w.TaskDTO.from(t,p);if(r===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,t,!1);const a=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),t);return this._proxy.$executeTask(r).catch(()=>{}),a}}provideTasksInternal(p,t,s,r){const a=[];if(r)for(const v of r){this.checkDeprecation(v,s),(!v.definition||!p[v.definition.type])&&this._logService.warn(`The task [${v.source}, ${v.name}] uses an undefined task type. The task will be ignored in the future.`);const _=w.TaskDTO.from(v,s.extension);_&&(a.push(_),w.CustomExecutionDTO.is(_.execution)&&t.push(this.addCustomExecution(_,v,!0)))}return{tasks:a,extension:s.extension}}async resolveTaskInternal(p){return p}async getAFolder(p){let t=p&&p.length>0?p[0]:void 0;if(!t){const s=A.URI.file((0,d.homedir)());t=new y.WorkspaceFolder({uri:s,name:i.basename(s),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,t){const s=A.URI.revive(p),r={process:void 0,variables:Object.create(null)},a=await this._workspaceProvider.resolveWorkspaceFolder(s),v=await this._workspaceProvider.getWorkspaceFolders2()??[],_=await this.variableResolver.getResolver(),c=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(v);for(const u of t.variables)r.variables[u]=await _.resolveAsync(c,u);if(t.process!==void 0){let u;if(t.process.path!==void 0){u=t.process.path.split(o.delimiter);for(let m=0;m<u.length;m++)u[m]=await _.resolveAsync(c,u[m])}r.process=await l.win32.findExecutable(await _.resolveAsync(c,t.process.name),t.process.cwd!==void 0?await _.resolveAsync(c,t.process.cwd):void 0,u)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(p,t,s){return l.win32.findExecutable(p,t,s)}};e.ExtHostTask=S=Ve([ze(0,L.IExtHostRpcService),ze(1,I.IExtHostInitDataService),ze(2,R.IExtHostWorkspace),ze(3,T.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,g.IExtHostTerminalService),ze(6,C.ILogService),ze(7,b.IExtHostApiDeprecationService),ze(8,h.IExtHostVariableResolverProvider)],S)}),define(De[315],Ie([1,0,55,50]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class l extends A.ExtHostVariableResolverProviderService{homeDir(){return(0,o.homedir)()}}e.NodeExtHostVariableResolverProviderService=l}),define(De[144],Ie([1,0,18,19,21,46,16,15,24,2,31]),function(oe,e,o,A,l,R,T,P,y,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class I{constructor(h,S,E,p){this.query=h,this.provider=S,this.fileUtils=E,this.processType=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(h,S){const E=this.query.folderQueries||[],p=new l.CancellationTokenSource;return S.onCancellationRequested(()=>p.cancel()),new Promise((t,s)=>{this.collector=new k(h);let r=!1;const a=(v,_)=>{if(!r&&!this.isLimitHit){const c=this.resultSize(v);b(v)&&typeof this.query.maxResults=="number"&&this.resultCount+c>this.query.maxResults&&(this.isLimitHit=!0,r=!0,p.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const u=this.resultSize(v);this.resultCount+=u,(u>0||!b(v))&&this.collector.add(v,_)}};Promise.all(E.map((v,_)=>this.searchInFolder(v,c=>a(c,_),p.token))).then(v=>{p.dispose(),this.collector.flush();const _=v.some(c=>!!c&&!!c.limitHit);t({limitHit:this.isLimitHit||_,messages:(0,o.flatten)(v.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.processType}})},v=>{p.dispose();const _=(0,R.toErrorMessage)(v);s(new Error(_))})})}resultSize(h){return b(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}trimResultToSize(h,S){const E=Array.isArray(h.ranges)?h.ranges:[h.ranges],p=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:E.slice(0,S),preview:{matches:p.slice(0,S),text:h.preview.text},uri:h.uri}}async searchInFolder(h,S,E){const p=new L.QueryGlobTester(this.query,h),t=[],s={report:v=>{if(!this.validateProviderResult(v))return;const _=h.folder.scheme===T.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(v.uri))):void 0,c=y.relativePath(h.folder,v.uri);if(c){const u=p.includedInQuery(c,P.basename(c),_);(0,A.isThenable)(u)?t.push(u.then(m=>{m&&S(v)})):u&&S(v)}}},r=this.getSearchOptionsForFolder(h),a=await this.provider.provideTextSearchResults(w(this.query.contentPattern),r,s,E);return t.length&&await Promise.all(t),a}validateProviderResult(h){if(b(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(h){const S=(0,L.resolvePatternsForProvider)(this.query.includePattern,h.includePattern),E=(0,L.resolvePatternsForProvider)(this.query.excludePattern,h.excludePattern),p={folder:g.URI.from(h.folder),excludes:E,includes:S,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.fileUtils.toCanonicalName(h.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return p.usePCRE2=this.query.usePCRE2,p}}e.TextSearchManager=I;function w(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class k{constructor(h){this._onResult=h,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new i(512,S=>this.sendItems(S))}add(h,S){this._currentFileMatch&&(this._currentFolderIdx!==S||!y.isEqual(this._currentUri,h.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=S,this._currentFileMatch={resource:h.uri,results:[]}),this._currentFileMatch.results.push(C(h))}pushToCollector(){const h=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,h)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(h){this._onResult(h)}}e.TextSearchResultsCollector=k;function C(d){return b(d)?{preview:{matches:(0,o.mapArrayOrNot)(d.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:d.preview.text},ranges:(0,o.mapArrayOrNot)(d.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function b(d){return!!d.preview}e.extensionResultIsMatch=b;class i{constructor(h,S){this.maxBatchSize=h,this.cb=S,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(h,S){h&&this.addItemToBatch(h,S)}addItems(h,S){h&&this.addItemsToBatch(h,S)}addItemToBatch(h,S){this.batch.push(h),this.batchSize+=S,this.onUpdate()}addItemsToBatch(h,S){this.batch=this.batch.concat(h),this.batchSize+=S,this.onUpdate()}onUpdate(){this.totalNumberCompleted<i.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},i.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=i,i.TIMEOUT=4e3,i.START_BATCH_AFTER_COUNT=50}),define(De[87],Ie([1,0,6,5,4,308,20,58,17,2,144]),function(oe,e,o,A,l,R,T,P,y,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,l.createDecorator)("IExtHostSearch");let I=e.ExtHostSearch=class{constructor(b,i,d){this.extHostRpc=b,this._uriTransformer=i,this._logService=d,this._proxy=this.extHostRpc.getProxy(A.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new R.FileSearchManager}_transformScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}registerTextSearchProvider(b,i){if(this._textSearchUsedSchemes.has(b))throw new Error(`a text search provider for the scheme '${b}' is already registered`);this._textSearchUsedSchemes.add(b);const d=this._handlePool++;return this._textSearchProvider.set(d,i),this._proxy.$registerTextSearchProvider(d,this._transformScheme(b)),(0,o.toDisposable)(()=>{this._textSearchUsedSchemes.delete(b),this._textSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}registerFileSearchProvider(b,i){if(this._fileSearchUsedSchemes.has(b))throw new Error(`a file search provider for the scheme '${b}' is already registered`);this._fileSearchUsedSchemes.add(b);const d=this._handlePool++;return this._fileSearchProvider.set(d,i),this._proxy.$registerFileSearchProvider(d,this._transformScheme(b)),(0,o.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(b),this._fileSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(b,i,d,h){const S=w(d),E=this._fileSearchProvider.get(b);if(E)return this._fileSearchManager.fileSearch(S,E,p=>{this._proxy.$handleFileMatch(b,i,p.map(t=>t.resource))},h);throw new Error("unknown provider: "+b)}$clearCache(b){return this._fileSearchManager.clearCache(b),Promise.resolve(void 0)}$provideTextSearchResults(b,i,d,h){const S=this._textSearchProvider.get(b);if(!S||!S.provideTextSearchResults)throw new Error(`Unknown provider ${b}`);const E=w(d);return this.createTextSearchManager(E,S).search(t=>this._proxy.$handleTextMatch(b,i,t),h)}$enableExtensionHostSearch(){}createTextSearchManager(b,i){return new L.TextSearchManager(b,i,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};e.ExtHostSearch=I=Ve([ze(0,T.IExtHostRpcService),ze(1,P.IURITransformerService),ze(2,y.ILogService)],I);function w(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(k),extraFileResources:C.extraFileResources&&C.extraFileResources.map(b=>g.URI.revive(b))}}e.reviveQuery=w;function k(C){return{...C,folder:g.URI.revive(C.folder)}}}),define(De[316],Ie([1,0,21,8,3,38,2,121,108,155,167,45,5,97,264,263,41,265,36,267,268,269,250,270,61,43,271,272,278,279,280,143,254,286,287,289,100,42,291,255,11,7,75,294,82,142,35,25,242,277,74,140,84,86,87,17,58,20,26,281,249,57,79,261,292,81,80,297,295,296,262,49,290,293,99,62,78,282,83,283,16,124,253,230,273,6,27,237,98,226,284,285,275,274,252,288,276]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h,S,E,p,t,s,r,a,v,_,c,u,m,f,n,D,M,W,$,N,U,q,F,B,Q,J,X,ie,ae,we,he,fe,V,x,Z,pe,_e,re,ne,de,ee,ce,le,ue,O,j,Y,te,be,ye,me,ke,Pe,Be,$e,et,Qe,Ye,nt,ct,Fe,it,z,K,ge,Ae,Me,qe,He,tt,pt,at,vt,yt,_t,Tt,xt,jt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function At(lt){const bt=lt.get(ee.IExtHostInitDataService),Wt=lt.get(Be.IExtHostFileSystemInfo),Ut=lt.get(be.IExtHostConsumerFileSystem),kt=lt.get(a.IExtHostExtensionService),ft=lt.get(ae.IExtHostWorkspace),Pt=lt.get(nt.IExtHostTelemetry),Ft=lt.get(h.IExtHostConfiguration),Rt=lt.get(ne.IURITransformerService),Ke=lt.get(de.IExtHostRpcService),Re=lt.get($.IExtHostStorage),Le=lt.get(te.IExtensionStoragePaths),Ce=lt.get(re.ILoggerService),se=lt.get(re.ILogService),Oe=lt.get(ue.IExtHostTunnelService),We=lt.get(O.IExtHostApiDeprecationService),Xe=lt.get(ie.IExtHostWindow),je=lt.get(Qe.IExtHostSecretState),rt=lt.get(Ye.IExtHostEditorTabs);Ke.set(w.ExtHostContext.ExtHostFileSystemInfo,Wt),Ke.set(w.ExtHostContext.ExtHostLogLevelServiceShape,Ce),Ke.set(w.ExtHostContext.ExtHostWorkspace,ft),Ke.set(w.ExtHostContext.ExtHostConfiguration,Ft),Ke.set(w.ExtHostContext.ExtHostExtensionService,kt),Ke.set(w.ExtHostContext.ExtHostStorage,Re),Ke.set(w.ExtHostContext.ExtHostTunnelService,Oe),Ke.set(w.ExtHostContext.ExtHostWindow,Xe),Ke.set(w.ExtHostContext.ExtHostSecretState,je),Ke.set(w.ExtHostContext.ExtHostTelemetry,Pt),Ke.set(w.ExtHostContext.ExtHostEditorTabs,rt);const St=Ke.set(w.ExtHostContext.ExtHostDecorations,lt.get(x.IExtHostDecorations)),Et=Ke.set(w.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(r.IExtHostDocumentsAndEditors)),ht=Ke.set(w.ExtHostContext.ExtHostCommands,lt.get(i.IExtHostCommands)),st=Ke.set(w.ExtHostContext.ExtHostTerminalService,lt.get(N.IExtHostTerminalService)),dt=Ke.set(w.ExtHostContext.ExtHostDebugService,lt.get(pe.IExtHostDebugService)),Ot=Ke.set(w.ExtHostContext.ExtHostSearch,lt.get(_e.IExtHostSearch)),Bt=Ke.set(w.ExtHostContext.ExtHostTask,lt.get(Z.IExtHostTask)),ai=Ke.set(w.ExtHostContext.ExtHostOutputService,lt.get(f.IExtHostOutputService)),ri=Ke.set(w.ExtHostContext.ExtHostLocalization,lt.get(pt.IExtHostLocalizationService)),ei=Ke.set(w.ExtHostContext.ExtHostUrls,new J.ExtHostUrls(Ke)),It=Ke.set(w.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Ke,Et)),Pi=Ke.set(w.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ke,Et,se)),Yi=Ke.set(w.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(se,It,Ke.getProxy(w.MainContext.MainThreadBulkEdits))),Dt=Ke.set(w.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(Ke,ht,Et,It)),gi=Ke.set(w.ExtHostContext.ExtHostNotebookDocuments,new Ae.ExtHostNotebookDocuments(Dt)),pi=Ke.set(w.ExtHostContext.ExtHostNotebookEditors,new ge.ExtHostNotebookEditors(se,Dt)),$t=Ke.set(w.ExtHostContext.ExtHostNotebookKernels,new ct.ExtHostNotebookKernels(Ke,bt,Dt,ht,se)),Ti=Ke.set(w.ExtHostContext.ExtHostNotebookRenderers,new it.ExtHostNotebookRenderers(Ke,Dt)),Ai=Ke.set(w.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new xt.ExtHostNotebookDocumentSaveParticipant(se,Dt,Ke.getProxy(w.MainContext.MainThreadBulkEdits))),Mt=Ke.set(w.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Ke,Et)),vi=Ke.set(w.ExtHostContext.ExtHostTreeViews,new q.ExtHostTreeViews(Ke.getProxy(w.MainContext.MainThreadTreeViews),ht,se)),Ji=Ke.set(w.ExtHostContext.ExtHostEditorInsets,new he.ExtHostEditorInsets(Ke.getProxy(w.MainContext.MainThreadEditorInsets),Mt,bt.remote)),Kt=Ke.set(w.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(Ke,se,Wt,Et)),si=Ke.set(w.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(Ke,It,ht.converter,Rt)),mt=Ke.set(w.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ke,Rt,It,ht,Kt,se,We,Pt)),Ri=Ke.set(w.ExtHostContext.ExtHostFileSystem,new v.ExtHostFileSystem(Ke,mt)),Xt=Ke.set(w.ExtHostContext.ExtHostFileSystemEventService,new _.ExtHostFileSystemEventService(Ke,se,Et)),ti=Ke.set(w.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(Ke,ft,ht)),bi=Ke.set(w.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(Ke,ht,It,se)),Li=Ke.set(w.ExtHostContext.ExtHostQuickDiff,new yt.ExtHostQuickDiff(Ke,Rt)),Oi=Ke.set(w.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(Ke,ht,It)),Ei=Ke.set(w.ExtHostContext.ExtHostProgress,new n.ExtHostProgress(Ke.getProxy(w.MainContext.MainThreadProgress))),Fi=Ke.set(w.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(Ke)),wi=Ke.set(w.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(Ke)),ii=Ke.set(w.ExtHostContext.ExtHostAuthentication,new j.ExtHostAuthentication(Ke)),Mi=Ke.set(w.ExtHostContext.ExtHostTimeline,new Y.ExtHostTimeline(Ke,ht)),ci=Ke.set(w.ExtHostContext.ExtHostWebviews,new X.ExtHostWebviews(Ke,bt.remote,ft,se,We)),li=Ke.set(w.ExtHostContext.ExtHostWebviewPanels,new ke.ExtHostWebviewPanels(Ke,ci,ft)),Ni=Ke.set(w.ExtHostContext.ExtHostCustomEditors,new me.ExtHostCustomEditors(Ke,It,Le,ci,li)),xi=Ke.set(w.ExtHostContext.ExtHostWebviewViews,new ye.ExtHostWebviewViews(Ke,ci)),ni=Ke.set(w.ExtHostContext.ExtHostTesting,new $e.ExtHostTesting(Ke,ht,Et)),Ui=Ke.set(w.ExtHostContext.ExtHostUriOpeners,new et.ExtHostUriOpeners(Ke)),Bi=Ke.set(w.ExtHostContext.ExtHostProfileContentHandlers,new vt.ExtHostProfileContentHandlers(Ke));Ke.set(w.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ke,Dt,Et,ht,se));const zi=Ke.set(w.ExtHostContext.ExtHostInteractiveEditor,new Tt.ExtHostInteractiveEditor(Ke,It,se)),ui=Ke.set(w.ExtHostContext.ExtHostInteractiveSession,new _t.ExtHostInteractiveSession(Ke,se)),Zi=Ke.set(w.ExtHostContext.ExtHostSemanticSimilarity,new jt.ExtHostSemanticSimilarity(Ke)),_i=Ke.set(w.ExtHostContext.ExtHostIssueReporter,new Ht.ExtHostIssueReporter(Ke)),Si=Object.values(w.ExtHostContext);Ke.assertRegistered(Si);const en=new Pe.ExtHostBulkEdits(Ke,Et),tn=new b.ExtHostClipboard(Ke),di=new m.ExtHostMessageService(Ke,se),hi=new E.ExtHostDialogs(Ke),yi=new W.ExtHostStatusBar(Ke,ht.converter);return C.ExtHostApiCommands.register(ht),function(Ue,qt,Wi){const wt=function(){let ve=!Ue.isUnderDevelopment;function Se(){ve||(se.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ve=!0)}return function Ne(ot){if(Array.isArray(ot))ot.forEach(Ne);else if(typeof ot=="string")Se();else{const Ct=ot;typeof Ct.scheme>"u"&&Se(),typeof Ct.exclusive=="boolean"&&(0,He.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return ot}}(),Hi={getSession(ve,Se,Ne){return ii.getSession(Ue,ve,Se,Ne)},getSessions(ve,Se){return(0,He.checkProposedApiEnabled)(Ue,"getSessions"),ii.getSessions(Ue,ve,Se)},async hasSession(ve,Se){return(0,He.checkProposedApiEnabled)(Ue,"authSession"),!!await ii.getSession(Ue,ve,Se,{silent:!0})},get onDidChangeSessions(){return ii.onDidChangeSessions},registerAuthenticationProvider(ve,Se,Ne,ot){return ii.registerAuthenticationProvider(ve,Se,Ne,ot)}},Qt={registerCommand(ve,Se,Ne){return ht.registerCommand(!0,ve,Se,Ne,void 0,Ue)},registerTextEditorCommand(ve,Se,Ne){return ht.registerCommand(!0,ve,(...ot)=>{const Ct=Mt.getActiveTextEditor();if(!Ct){se.warn("Cannot execute "+ve+" because there is no active text editor.");return}return Ct.edit(Lt=>{Se.apply(Ne,[Ct,Lt,...ot])}).then(Lt=>{Lt||se.warn("Edits from command "+ve+" were not applied.")},Lt=>{se.warn("An error occurred while running command "+ve,Lt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ve,Se,Ne)=>((0,He.checkProposedApiEnabled)(Ue,"diffCommand"),ht.registerCommand(!0,ve,async(...ot)=>{const Ct=Et.activeEditor(!0);if(!Ct){se.warn("Cannot execute "+ve+" because there is no active text editor.");return}const Lt=await Mt.getDiffInformation(Ct.id);Se.apply(Ne,[Lt,...ot])},void 0,void 0,Ue)),executeCommand(ve,...Se){return ht.executeCommand(ve,...Se)},getCommands(ve=!1){return ht.getCommands(ve)}},oi={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return tn.value},get shell(){return st.getDefaultShell(!1)},get onDidChangeShell(){return(0,He.checkProposedApiEnabled)(Ue,"envShellEvent"),st.onDidChangeShell},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,He.checkProposedApiEnabled)(Ue,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,He.checkProposedApiEnabled)(Ue,"telemetry"),Pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ve,Se){return nt.ExtHostTelemetryLogger.validateSender(ve),Pt.instantiateLogger(Ue,ve,Se)},openExternal(ve,Se){return Xe.openUri(ve,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(ve){if(ve.scheme===bt.environment.appUriScheme)return ei.createAppUri(ve);try{return await Xe.asExternalUri(ve,{allowTunneling:!!bt.remote.authority})}catch(Se){if((0,K.matchesScheme)(ve,z.Schemas.http)||(0,K.matchesScheme)(ve,z.Schemas.https))return ve;throw Se}},get remoteName(){return(0,V.getRemoteName)(bt.remote.authority)},get remoteAuthority(){return(0,He.checkProposedApiEnabled)(Ue,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return se.getLevel()},get onDidChangeLogLevel(){return se.onDidChangeLogLevel},registerIssueUriRequestHandler(ve){return(0,He.checkProposedApiEnabled)(Ue,"handleIssueUri"),_i.registerIssueUriRequestHandler(Ue,ve)}};bt.environment.extensionTestsLocationURI||Object.freeze(oi);const nn={createTestController(ve,Se,Ne){return ni.createTestController(Ue,ve,Se,Ne)},createTestObserver(){return(0,He.checkProposedApiEnabled)(Ue,"testObserver"),ni.createTestObserver()},runTests(ve){return(0,He.checkProposedApiEnabled)(Ue,"testObserver"),ni.runTests(ve)},get onDidChangeTestResults(){return(0,He.checkProposedApiEnabled)(Ue,"testObserver"),ni.onResultsChanged},get testResults(){return(0,He.checkProposedApiEnabled)(Ue,"testObserver"),ni.results}},Nt=bt.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,fi={getExtension(ve,Se){(0,He.isProposedApiEnabled)(Ue,"extensionsAny")||(Se=!1);const Ne=qt.mine.getExtensionDescription(ve);if(Ne)return new a.Extension(kt,Ue.identifier,Ne,Nt,!1);if(Se){const ot=qt.all.getExtensionDescription(ve);if(ot)return new a.Extension(kt,Ue.identifier,ot,Nt,!0)}},get all(){const ve=[];for(const Se of qt.mine.getAllExtensionDescriptions())ve.push(new a.Extension(kt,Ue.identifier,Se,Nt,!1));return ve},get allAcrossExtensionHosts(){(0,He.checkProposedApiEnabled)(Ue,"extensionsAny");const ve=new we.ExtensionIdentifierSet(qt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),Se=[];for(const Ne of qt.all.getAllExtensionDescriptions()){const ot=!ve.has(Ne.identifier);Se.push(new a.Extension(kt,Ue.identifier,Ne,Nt,ot))}return Se},get onDidChange(){return(0,He.isProposedApiEnabled)(Ue,"extensionsAny")?l.Event.any(qt.mine.onDidChange,qt.all.onDidChange):qt.mine.onDidChange}},$i={createDiagnosticCollection(ve){return Kt.createDiagnosticCollection(Ue.identifier,ve)},get onDidChangeDiagnostics(){return Kt.onDidChangeDiagnostics},getDiagnostics:ve=>Kt.getDiagnostics(ve),getLanguages(){return si.getLanguages()},setTextDocumentLanguage(ve,Se){return si.changeLanguage(ve.uri,Se)},match(ve,Se){const Ne=It.getDocumentData(Se.uri)?.notebook;return(0,L.score)(F.LanguageSelector.from(ve),Se.uri,Se.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ve,Se,Ne){return mt.registerCodeActionProvider(Ue,wt(ve),Se,Ne)},registerDocumentPasteEditProvider(ve,Se,Ne){return(0,He.checkProposedApiEnabled)(Ue,"documentPaste"),mt.registerDocumentPasteEditProvider(Ue,wt(ve),Se,Ne)},registerCodeLensProvider(ve,Se){return mt.registerCodeLensProvider(Ue,wt(ve),Se)},registerDefinitionProvider(ve,Se){return mt.registerDefinitionProvider(Ue,wt(ve),Se)},registerDeclarationProvider(ve,Se){return mt.registerDeclarationProvider(Ue,wt(ve),Se)},registerImplementationProvider(ve,Se){return mt.registerImplementationProvider(Ue,wt(ve),Se)},registerTypeDefinitionProvider(ve,Se){return mt.registerTypeDefinitionProvider(Ue,wt(ve),Se)},registerHoverProvider(ve,Se){return mt.registerHoverProvider(Ue,wt(ve),Se,Ue.identifier)},registerEvaluatableExpressionProvider(ve,Se){return mt.registerEvaluatableExpressionProvider(Ue,wt(ve),Se,Ue.identifier)},registerInlineValuesProvider(ve,Se){return mt.registerInlineValuesProvider(Ue,wt(ve),Se,Ue.identifier)},registerDocumentHighlightProvider(ve,Se){return mt.registerDocumentHighlightProvider(Ue,wt(ve),Se)},registerLinkedEditingRangeProvider(ve,Se){return mt.registerLinkedEditingRangeProvider(Ue,wt(ve),Se)},registerReferenceProvider(ve,Se){return mt.registerReferenceProvider(Ue,wt(ve),Se)},registerRenameProvider(ve,Se){return mt.registerRenameProvider(Ue,wt(ve),Se)},registerDocumentSymbolProvider(ve,Se,Ne){return mt.registerDocumentSymbolProvider(Ue,wt(ve),Se,Ne)},registerWorkspaceSymbolProvider(ve){return mt.registerWorkspaceSymbolProvider(Ue,ve)},registerDocumentFormattingEditProvider(ve,Se){return mt.registerDocumentFormattingEditProvider(Ue,wt(ve),Se)},registerDocumentRangeFormattingEditProvider(ve,Se){return mt.registerDocumentRangeFormattingEditProvider(Ue,wt(ve),Se)},registerOnTypeFormattingEditProvider(ve,Se,Ne,...ot){return mt.registerOnTypeFormattingEditProvider(Ue,wt(ve),Se,[Ne].concat(ot))},registerDocumentSemanticTokensProvider(ve,Se,Ne){return mt.registerDocumentSemanticTokensProvider(Ue,wt(ve),Se,Ne)},registerDocumentRangeSemanticTokensProvider(ve,Se,Ne){return mt.registerDocumentRangeSemanticTokensProvider(Ue,wt(ve),Se,Ne)},registerSignatureHelpProvider(ve,Se,Ne,...ot){return typeof Ne=="object"?mt.registerSignatureHelpProvider(Ue,wt(ve),Se,Ne):mt.registerSignatureHelpProvider(Ue,wt(ve),Se,typeof Ne>"u"?[]:[Ne,...ot])},registerCompletionItemProvider(ve,Se,...Ne){return mt.registerCompletionItemProvider(Ue,wt(ve),Se,Ne)},registerInlineCompletionItemProvider(ve,Se){return Se.handleDidShowCompletionItem&&(0,He.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),Se.handleDidPartiallyAcceptCompletionItem&&(0,He.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),mt.registerInlineCompletionsProvider(Ue,wt(ve),Se)},registerDocumentLinkProvider(ve,Se){return mt.registerDocumentLinkProvider(Ue,wt(ve),Se)},registerColorProvider(ve,Se){return mt.registerColorProvider(Ue,wt(ve),Se)},registerFoldingRangeProvider(ve,Se){return mt.registerFoldingRangeProvider(Ue,wt(ve),Se)},registerSelectionRangeProvider(ve,Se){return mt.registerSelectionRangeProvider(Ue,ve,Se)},registerCallHierarchyProvider(ve,Se){return mt.registerCallHierarchyProvider(Ue,ve,Se)},registerTypeHierarchyProvider(ve,Se){return mt.registerTypeHierarchyProvider(Ue,ve,Se)},setLanguageConfiguration:(ve,Se)=>mt.setLanguageConfiguration(Ue,ve,Se),getTokenInformationAtPosition(ve,Se){return(0,He.checkProposedApiEnabled)(Ue,"tokenInformation"),si.tokenAtPosition(ve,Se)},registerInlayHintsProvider(ve,Se){return mt.registerInlayHintsProvider(Ue,ve,Se)},createLanguageStatusItem(ve,Se){return si.createLanguageStatusItem(Ue,ve,Se)},registerDocumentDropEditProvider(ve,Se,Ne){return mt.registerDocumentOnDropEditProvider(Ue,ve,Se,(0,He.isProposedApiEnabled)(Ue,"dropMetadata")?Ne:void 0)}},Vi={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return st.activeTerminal},get terminals(){return st.terminals},async showTextDocument(ve,Se,Ne){const ot=await(T.URI.isUri(ve)?Promise.resolve(Ci.openTextDocument(ve)):Promise.resolve(ve));return Mt.showTextDocument(ot,Se,Ne)},createTextEditorDecorationType(ve){return Mt.createTextEditorDecorationType(Ue,ve)},onDidChangeActiveTextEditor(ve,Se,Ne){return Mt.onDidChangeActiveTextEditor(ve,Se,Ne)},onDidChangeVisibleTextEditors(ve,Se,Ne){return Mt.onDidChangeVisibleTextEditors(ve,Se,Ne)},onDidChangeTextEditorSelection(ve,Se,Ne){return Mt.onDidChangeTextEditorSelection(ve,Se,Ne)},onDidChangeTextEditorOptions(ve,Se,Ne){return Mt.onDidChangeTextEditorOptions(ve,Se,Ne)},onDidChangeTextEditorVisibleRanges(ve,Se,Ne){return Mt.onDidChangeTextEditorVisibleRanges(ve,Se,Ne)},onDidChangeTextEditorViewColumn(ve,Se,Ne){return Mt.onDidChangeTextEditorViewColumn(ve,Se,Ne)},onDidCloseTerminal(ve,Se,Ne){return st.onDidCloseTerminal(ve,Se,Ne)},onDidOpenTerminal(ve,Se,Ne){return st.onDidOpenTerminal(ve,Se,Ne)},onDidChangeActiveTerminal(ve,Se,Ne){return st.onDidChangeActiveTerminal(ve,Se,Ne)},onDidChangeTerminalDimensions(ve,Se,Ne){return(0,He.checkProposedApiEnabled)(Ue,"terminalDimensions"),st.onDidChangeTerminalDimensions(ve,Se,Ne)},onDidChangeTerminalState(ve,Se,Ne){return st.onDidChangeTerminalState(ve,Se,Ne)},onDidWriteTerminalData(ve,Se,Ne){return(0,He.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),st.onDidWriteTerminalData(ve,Se,Ne)},get state(){return Xe.state},onDidChangeWindowState(ve,Se,Ne){return Xe.onDidChangeWindowState(ve,Se,Ne)},showInformationMessage(ve,...Se){return di.showMessage(Ue,R.default.Info,ve,Se[0],Se.slice(1))},showWarningMessage(ve,...Se){return di.showMessage(Ue,R.default.Warning,ve,Se[0],Se.slice(1))},showErrorMessage(ve,...Se){return di.showMessage(Ue,R.default.Error,ve,Se[0],Se.slice(1))},showQuickPick(ve,Se,Ne){return ti.showQuickPick(Ue,ve,Se,Ne)},showWorkspaceFolderPick(ve){return ti.showWorkspaceFolderPick(ve)},showInputBox(ve,Se){return ti.showInput(ve,Se)},showOpenDialog(ve){return hi.showOpenDialog(Ue,ve)},showSaveDialog(ve){return hi.showSaveDialog(ve)},createStatusBarItem(ve,Se,Ne){let ot,Ct,Lt;return typeof ve=="string"?(ot=ve,Ct=Se,Lt=Ne):(Ct=ve,Lt=Se),yi.createStatusBarEntry(Ue,ot,Ct,Lt)},setStatusBarMessage(ve,Se){return yi.setStatusBarMessage(ve,Se)},withScmProgress(ve){return We.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Ei.withProgress(Ue,{location:B.ProgressLocation.SourceControl},(Se,Ne)=>ve({report(ot){}}))},withProgress(ve,Se){return Ei.withProgress(Ue,ve,Se)},createOutputChannel(ve,Se){return ai.createOutputChannel(ve,Se,Ue)},createWebviewPanel(ve,Se,Ne,ot){return li.createWebviewPanel(Ue,ve,Se,Ne,ot)},createWebviewTextEditorInset(ve,Se,Ne,ot){return(0,He.checkProposedApiEnabled)(Ue,"editorInsets"),Ji.createWebviewEditorInset(ve,Se,Ne,ot,Ue)},createTerminal(ve,Se,Ne){return typeof ve=="object"?"pty"in ve?st.createExtensionTerminal(ve):st.createTerminalFromOptions(ve):st.createTerminal(ve,Se,Ne)},registerTerminalLinkProvider(ve){return st.registerLinkProvider(ve)},registerTerminalProfileProvider(ve,Se){return st.registerProfileProvider(Ue,ve,Se)},registerTerminalQuickFixProvider(ve,Se){return(0,He.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),st.registerTerminalQuickFixProvider(ve,Ue.identifier.value,Se)},registerTreeDataProvider(ve,Se){return vi.registerTreeDataProvider(ve,Se,Ue)},createTreeView(ve,Se){return vi.createTreeView(ve,Se,Ue)},registerWebviewPanelSerializer:(ve,Se)=>li.registerWebviewPanelSerializer(Ue,ve,Se),registerCustomEditorProvider:(ve,Se,Ne={})=>Ni.registerCustomEditorProvider(Ue,ve,Se,Ne),registerFileDecorationProvider(ve){return St.registerFileDecorationProvider(ve,Ue)},registerUriHandler(ve){return ei.registerUriHandler(Ue.identifier,ve)},createQuickPick(){return ti.createQuickPick(Ue)},createInputBox(){return ti.createInputBox(Ue)},get activeColorTheme(){return wi.activeColorTheme},onDidChangeActiveColorTheme(ve,Se,Ne){return wi.onDidChangeActiveColorTheme(ve,Se,Ne)},registerWebviewViewProvider(ve,Se,Ne){return xi.registerWebviewViewProvider(Ue,ve,Se,Ne?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ve,Se,Ne){return Dt.onDidChangeActiveNotebookEditor(ve,Se,Ne)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ve,Se,Ne){return pi.onDidChangeNotebookEditorSelection(ve,Se,Ne)},onDidChangeNotebookEditorVisibleRanges(ve,Se,Ne){return pi.onDidChangeNotebookEditorVisibleRanges(ve,Se,Ne)},showNotebookDocument(ve,Se){return Dt.showNotebookDocument(ve,Se)},registerExternalUriOpener(ve,Se,Ne){return(0,He.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ui.registerExternalUriOpener(Ue.identifier,ve,Se,Ne)},registerProfileContentHandler(ve,Se){return(0,He.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Bi.registrProfileContentHandler(Ue,ve,Se)},registerQuickDiffProvider(ve,Se,Ne,ot){return(0,He.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Li.registerQuickDiffProvider(wt(ve),Se,Ne,ot)},get tabGroups(){return rt.tabGroups}},Ci={get rootPath(){return We.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ve){throw A.readonly()},getWorkspaceFolder(ve){return ft.getWorkspaceFolder(ve)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ve){throw A.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ve){throw A.readonly()},updateWorkspaceFolders:(ve,Se,...Ne)=>ft.updateWorkspaceFolders(Ue,ve,Se||0,...Ne),onDidChangeWorkspaceFolders:function(ve,Se,Ne){return ft.onDidChangeWorkspace(ve,Se,Ne)},asRelativePath:(ve,Se)=>ft.getRelativePath(ve,Se),findFiles:(ve,Se,Ne,ot)=>ft.findFiles(ve,Se,Ne,Ue.identifier,ot),findTextInFiles:(ve,Se,Ne,ot)=>{(0,He.checkProposedApiEnabled)(Ue,"findTextInFiles");let Ct,Lt;return typeof Se=="object"?(Ct=Se,Lt=Ne):(Ct={},Lt=Se,ot=Ne),ft.findTextInFiles(ve,Ct||{},Lt,Ue.identifier,ot)},save:ve=>((0,He.checkProposedApiEnabled)(Ue,"saveEditor"),ft.save(ve)),saveAs:ve=>((0,He.checkProposedApiEnabled)(Ue,"saveEditor"),ft.saveAs(ve)),saveAll:ve=>ft.saveAll(ve),applyEdit(ve,Se){return en.applyWorkspaceEdit(ve,Ue,Se)},createFileSystemWatcher:(ve,Se,Ne,ot)=>Xt.createFileSystemWatcher(ft,Ue,ve,Se,Ne,ot),get textDocuments(){return It.getAllDocumentData().map(ve=>ve.document)},set textDocuments(ve){throw A.readonly()},openTextDocument(ve){let Se;const Ne=ve;if(typeof ve=="string")Se=Promise.resolve(T.URI.file(ve));else if(T.URI.isUri(ve))Se=Promise.resolve(ve);else if(!Ne||typeof Ne=="object")Se=It.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(ot=>It.ensureDocumentData(ot).then(Ct=>Ct.document))},onDidOpenTextDocument:(ve,Se,Ne)=>It.onDidAddDocument(ve,Se,Ne),onDidCloseTextDocument:(ve,Se,Ne)=>It.onDidRemoveDocument(ve,Se,Ne),onDidChangeTextDocument:(ve,Se,Ne)=>It.onDidChangeDocument(ve,Se,Ne),onDidSaveTextDocument:(ve,Se,Ne)=>It.onDidSaveDocument(ve,Se,Ne),onWillSaveTextDocument:(ve,Se,Ne)=>Yi.getOnWillSaveTextDocumentEvent(Ue)(ve,Se,Ne),get notebookDocuments(){return Dt.notebookDocuments.map(ve=>ve.apiNotebook)},async openNotebookDocument(ve,Se){let Ne;if(T.URI.isUri(ve))Ne=ve,await Dt.openNotebookDocument(ve);else if(typeof ve=="string")Ne=T.URI.revive(await Dt.createNotebookDocument({viewType:ve,content:Se}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ve,Se,Ne){return gi.onDidSaveNotebookDocument(ve,Se,Ne)},onDidChangeNotebookDocument(ve,Se,Ne){return gi.onDidChangeNotebookDocument(ve,Se,Ne)},onWillSaveNotebookDocument(ve,Se,Ne){return Ai.getOnWillSaveNotebookDocumentEvent(Ue)(ve,Se,Ne)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(ve,Se,Ne,ot){return Dt.registerNotebookSerializer(Ue,ve,Se,Ne,(0,He.isProposedApiEnabled)(Ue,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ve,Se,Ne)=>Wi.onDidChangeConfiguration(ve,Se,Ne),getConfiguration(ve,Se){return Se=arguments.length===1?void 0:Se,Wi.getConfiguration(ve,Se,Ue)},registerTextDocumentContentProvider(ve,Se){return Pi.registerTextDocumentContentProvider(ve,Se)},registerTaskProvider:(ve,Se)=>(We.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Bt.registerTaskProvider(Ue,ve,Se)),registerFileSystemProvider(ve,Se,Ne){return(0,qe.combinedDisposable)(Ri.registerFileSystemProvider(Ue,ve,Se,Ne),Ut.addFileSystemProvider(ve,Se))},get fs(){return Ut.value},registerFileSearchProvider:(ve,Se)=>((0,He.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Ot.registerFileSearchProvider(ve,Se)),registerTextSearchProvider:(ve,Se)=>((0,He.checkProposedApiEnabled)(Ue,"textSearchProvider"),Ot.registerTextSearchProvider(ve,Se)),registerRemoteAuthorityResolver:(ve,Se)=>((0,He.checkProposedApiEnabled)(Ue,"resolvers"),kt.registerRemoteAuthorityResolver(ve,Se)),registerResourceLabelFormatter:ve=>((0,He.checkProposedApiEnabled)(Ue,"resolvers"),Fi.$registerResourceLabelFormatter(ve)),onDidCreateFiles:(ve,Se,Ne)=>Xt.onDidCreateFile(ve,Se,Ne),onDidDeleteFiles:(ve,Se,Ne)=>Xt.onDidDeleteFile(ve,Se,Ne),onDidRenameFiles:(ve,Se,Ne)=>Xt.onDidRenameFile(ve,Se,Ne),onWillCreateFiles:(ve,Se,Ne)=>Xt.getOnWillCreateFileEvent(Ue)(ve,Se,Ne),onWillDeleteFiles:(ve,Se,Ne)=>Xt.getOnWillDeleteFileEvent(Ue)(ve,Se,Ne),onWillRenameFiles:(ve,Se,Ne)=>Xt.getOnWillRenameFileEvent(Ue)(ve,Se,Ne),openTunnel:ve=>((0,He.checkProposedApiEnabled)(Ue,"tunnels"),Oe.openTunnel(Ue,ve).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,He.checkProposedApiEnabled)(Ue,"tunnels"),Oe.getTunnels()},onDidChangeTunnels:(ve,Se,Ne)=>((0,He.checkProposedApiEnabled)(Ue,"tunnels"),Oe.onDidChangeTunnels(ve,Se,Ne)),registerPortAttributesProvider:(ve,Se)=>((0,He.checkProposedApiEnabled)(Ue,"portsAttributes"),Oe.registerPortsAttributesProvider(ve,Se)),registerTimelineProvider:(ve,Se)=>((0,He.checkProposedApiEnabled)(Ue,"timeline"),Mi.registerTimelineProvider(ve,Se,Ue.identifier,ht.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ve=>((0,He.checkProposedApiEnabled)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ve)),onDidGrantWorkspaceTrust:(ve,Se,Ne)=>ft.onDidGrantWorkspaceTrust(ve,Se,Ne),registerEditSessionIdentityProvider:(ve,Se)=>((0,He.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ve,Se)),onWillCreateEditSessionIdentity:(ve,Se,Ne)=>((0,He.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Ue)(ve,Se,Ne))},ji={get inputBox(){return We.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Ue)},createSourceControl(ve,Se,Ne){return bi.createSourceControl(Ue,ve,Se,Ne)}},rn={createCommentController(ve,Se){return Oi.createCommentController(Ue,ve,Se)}},qi={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},get stackFrameFocus(){return dt.stackFrameFocus},onDidStartDebugSession(ve,Se,Ne){return dt.onDidStartDebugSession(ve,Se,Ne)},onDidTerminateDebugSession(ve,Se,Ne){return dt.onDidTerminateDebugSession(ve,Se,Ne)},onDidChangeActiveDebugSession(ve,Se,Ne){return dt.onDidChangeActiveDebugSession(ve,Se,Ne)},onDidReceiveDebugSessionCustomEvent(ve,Se,Ne){return dt.onDidReceiveDebugSessionCustomEvent(ve,Se,Ne)},onDidChangeBreakpoints(ve,Se,Ne){return dt.onDidChangeBreakpoints(ve,Se,Ne)},onDidChangeStackFrameFocus(ve,Se,Ne){return(0,He.checkProposedApiEnabled)(Ue,"debugFocus"),dt.onDidChangeStackFrameFocus(ve,Se,Ne)},registerDebugConfigurationProvider(ve,Se,Ne){return dt.registerDebugConfigurationProvider(ve,Se,Ne||tt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ve,Se){return dt.registerDebugAdapterDescriptorFactory(Ue,ve,Se)},registerDebugAdapterTrackerFactory(ve,Se){return dt.registerDebugAdapterTrackerFactory(ve,Se)},startDebugging(ve,Se,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?dt.startDebugging(ve,Se,{parentSession:Ne}):dt.startDebugging(ve,Se,Ne||{})},stopDebugging(ve){return dt.stopDebugging(ve)},addBreakpoints(ve){return dt.addBreakpoints(ve)},removeBreakpoints(ve){return dt.removeBreakpoints(ve)},asDebugSourceUri(ve,Se){return dt.asDebugSourceUri(ve,Se)}},Gi={registerTaskProvider:(ve,Se)=>Bt.registerTaskProvider(Ue,ve,Se),fetchTasks:ve=>Bt.fetchTasks(ve),executeTask:ve=>Bt.executeTask(Ue,ve),get taskExecutions(){return Bt.taskExecutions},onDidStartTask:(ve,Se,Ne)=>Bt.onDidStartTask(ve,Se,Ne),onDidEndTask:(ve,Se,Ne)=>Bt.onDidEndTask(ve,Se,Ne),onDidStartTaskProcess:(ve,Se,Ne)=>Bt.onDidStartTaskProcess(ve,Se,Ne),onDidEndTaskProcess:(ve,Se,Ne)=>Bt.onDidEndTaskProcess(ve,Se,Ne)},sn={createNotebookController(ve,Se,Ne,ot,Ct){return $t.createNotebookController(Ue,ve,Se,Ne,ot,(0,He.isProposedApiEnabled)(Ue,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(ve,Se)=>Dt.registerNotebookCellStatusBarItemProvider(Ue,ve,Se),createRendererMessaging(ve){return Ti.createRendererMessaging(Ue,ve)},createNotebookControllerDetectionTask(ve){return(0,He.checkProposedApiEnabled)(Ue,"notebookKernelSource"),$t.createNotebookControllerDetectionTask(Ue,ve)},registerKernelSourceActionProvider(ve,Se){return(0,He.checkProposedApiEnabled)(Ue,"notebookKernelSource"),$t.registerKernelSourceActionProvider(Ue,ve,Se)},onDidChangeNotebookCellExecutionState(ve,Se,Ne){return(0,He.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),$t.onDidChangeNotebookCellExecutionState(ve,Se,Ne)}},on={t(...ve){if(typeof ve[0]=="string"){const Se=ve.shift(),Ne=!ve||typeof ve[0]!="object"?ve:ve[0];return ri.getMessage(Ue.identifier.value,{message:Se,args:Ne})}return ri.getMessage(Ue.identifier.value,ve[0])},get bundle(){return ri.getBundle(Ue.identifier.value)},get uri(){return ri.getBundleUri(Ue.identifier.value)}},Ki={_version:1,registerInteractiveEditorSessionProvider(ve){return(0,He.checkProposedApiEnabled)(Ue,"interactive"),zi.registerProvider(Ue,ve)},registerInteractiveSessionProvider(ve,Se){return(0,He.checkProposedApiEnabled)(Ue,"interactive"),ui.registerInteractiveSessionProvider(Ue,ve,Se)},addInteractiveRequest(ve){return(0,He.checkProposedApiEnabled)(Ue,"interactive"),ui.addInteractiveSessionRequest(ve)},sendInteractiveRequestToProvider(ve,Se){return(0,He.checkProposedApiEnabled)(Ue,"interactive"),ui.sendInteractiveRequestToProvider(ve,Se)},get onDidPerformUserAction(){return ui.onDidPerformUserAction}},Xi={registerSemanticSimilarityProvider(ve){return(0,He.checkProposedApiEnabled)(Ue,"semanticSimilarity"),Zi.registerSemanticSimilarityProvider(Ue,ve)}};return{version:bt.version,ai:Xi,authentication:Hi,commands:Qt,comments:rn,debug:qi,env:oi,extensions:fi,interactive:Ki,l10n:on,languages:$i,notebooks:sn,scm:ji,tasks:Gi,tests:nn,window:Vi,workspace:Ci,Breakpoint:B.Breakpoint,TerminalOutputAnchor:B.TerminalOutputAnchor,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:w.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentState:B.CommentState,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CommentThreadState:B.CommentThreadState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:tt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:l.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileDecoration2:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestionList,Hover:B.Hover,IndentAction:g.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalQuickFixCommand:B.TerminalQuickFixCommand,TerminalQuickFixOpener:B.TerminalQuickFixOpener,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TerminalExitReason:B.TerminalExitReason,TerminalQuickFixType:B.TerminalQuickFixType,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,SnippetTextEdit:B.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItem2:B.TreeItem,TreeItemCheckboxState:B.TreeItemCheckboxState,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:k.UIKind,Uri:T.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,DocumentDropEdit:B.DocumentDropEdit,DocumentPasteEdit:B.DocumentPasteEdit,InlayHint:B.InlayHint,InlayHintLabelPart:B.InlayHintLabelPart,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,NotebookControllerAffinity2:B.NotebookControllerAffinity2,NotebookEdit:B.NotebookEdit,NotebookKernelSourceAction:B.NotebookKernelSourceAction,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestRunRequest2:B.TestRunRequest2,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:Fe.TextSearchCompleteMessageType,DataTransfer:B.DataTransfer,DataTransferItem:B.DataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind,InputBoxValidationSeverity:B.InputBoxValidationSeverity,TabInputText:B.TextTabInput,TabInputTextDiff:B.TextDiffTabInput,TabInputTextMerge:B.TextMergeTabInput,TabInputCustom:B.CustomEditorTabInput,TabInputNotebook:B.NotebookEditorTabInput,TabInputNotebookDiff:B.NotebookDiffEditorTabInput,TabInputWebview:B.WebviewEditorTabInput,TabInputTerminal:B.TerminalEditorTabInput,TabInputInteractiveWindow:B.InteractiveWindowInput,TelemetryTrustedValue:Q.TelemetryTrustedValue,LogLevel:re.LogLevel,EditSessionIdentityMatch:at.EditSessionIdentityMatch,InteractiveSessionVoteDirection:B.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:B.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:B.InteractiveEditorResponseFeedbackKind}}}e.createApiFactoryAndRegisterActors=At}),define(De[317],Ie([1,0,91,143,35,140,36,41,61,42,84,86,87,100,57,79,142,80,49,99,78,62,141,17,50,98]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h,S,E,p,t,s,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,1),(0,o.registerSingleton)(s.ILoggerService,t.ExtHostLoggerService,1),(0,o.registerSingleton)(b.IExtHostApiDeprecationService,b.ExtHostApiDeprecationService,1),(0,o.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,0),(0,o.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration,0),(0,o.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,0),(0,o.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService,0),(0,o.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,o.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,o.registerSingleton)(h.IExtHostFileSystemInfo,h.ExtHostFileSystemInfo,0),(0,o.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,o.registerSingleton)(w.IExtHostSearch,w.ExtHostSearch,0),(0,o.registerSingleton)(k.IExtHostStorage,k.ExtHostStorage,0),(0,o.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,o.registerSingleton)(g.IExtHostTerminalService,g.WorkerExtHostTerminalService,0),(0,o.registerSingleton)(C.IExtHostTunnelService,C.ExtHostTunnelService,0),(0,o.registerSingleton)(i.IExtHostWindow,i.ExtHostWindow,0),(0,o.registerSingleton)(l.IExtHostWorkspace,l.ExtHostWorkspace,0),(0,o.registerSingleton)(S.IExtHostSecretState,S.ExtHostSecretState,0),(0,o.registerSingleton)(E.IExtHostTelemetry,E.ExtHostTelemetry,0),(0,o.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,o.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(De[101],Ie([1,0,18,17,31,83]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=T;function P(I,w,k,C){const b=(0,o.mapArrayOrNot)(k,y),i=new l.TextSearchMatch(w,b,C),d=i.preview.matches;return{ranges:(0,o.mapArrayOrNot)(b,g),uri:I,preview:{text:i.preview.text,matches:(0,o.mapArrayOrNot)(d,g)}}}e.createTextSearchResult=P;function y(I){return new l.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function g(I){return new R.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let L=e.OutputChannel=class{constructor(w,k){this.prefix=w,this.logService=k}appendLine(w){this.logService.debug(`${this.prefix}#search`,w)}};e.OutputChannel=L=Ve([ze(1,A.ILogService)],L)}),define(De[318],Ie([1,0,47,15,88,34,14,9,101,319]),function(oe,e,o,A,l,R,T,P,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(S,E,p,t){const s=w(S,E,p,t),r=E.folder.fsPath;return{cmd:o.spawn(L,s.args,{cwd:r}),rgDiskPath:L,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=I;function w(S,E,p,t){const s=["--files","--hidden","--case-sensitive"];C([E],p,!1).forEach(a=>{const v=(0,y.anchorGlob)(a);if(s.push("-g",v),T.isMacintosh){const _=(0,l.normalizeNFD)(v);_!==v&&s.push("-g",_)}});const r=k([E],t,void 0,!1);return r.globArgs.forEach(a=>{const v=`!${(0,y.anchorGlob)(a)}`;if(s.push("-g",v),T.isMacintosh){const _=(0,l.normalizeNFD)(v);_!==v&&s.push("-g",_)}}),E.disregardIgnoreFiles!==!1?s.push("--no-ignore"):E.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),E.ignoreSymlinks||s.push("--follow"),S.exists&&s.push("--quiet"),s.push("--no-config"),E.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function k(S,E,p,t=!0){const s=[];let r={};return S.forEach(a=>{const v=Object.assign({},a.excludePattern||{},E||{}),_=b(v,t?a.folder.fsPath:void 0,p);s.push(..._.globArgs),_.siblingClauses&&(r=Object.assign(r,_.siblingClauses))}),{globArgs:s,siblingClauses:r}}function C(S,E,p=!0){const t=[];return S.forEach(s=>{const r=Object.assign({},E||{},s.includePattern||{}),a=b(r,p?s.folder.fsPath:void 0);t.push(...a.globArgs)}),t}function b(S,E,p){const t=[],s={};return Object.keys(S).forEach(r=>{if(p&&p.has(r)||!r)return;const a=S[r];r=d(E?i(E,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof a=="boolean"&&a?(r.startsWith("\\\\")&&(r+="**"),t.push(h(r))):a&&a.when&&(s[r]=a)}),{globArgs:t,siblingClauses:s}}function i(S,E){return A.isAbsolute(E)?E:A.join(S,E)}e.getAbsoluteGlob=i;function d(S){return S=P.rtrim(S,"\\"),P.rtrim(S,"/")}function h(S){return R.getRoot(S).toLowerCase()==="c:/"?S.replace(/^c:[/\\]/i,"/"):S}e.fixDriveC=h}),define(De[320],Ie([1,0,47,72,15,321,18,46,39,88,34,14,37,9,10,29,31,318,112]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const S=new Set;process.on("exit",()=>{S.forEach(r=>r())});class E{constructor(a){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=a,this.filePattern=a.filePattern||"",this.includePattern=a.includePattern&&y.parse(a.includePattern),this.maxResults=a.maxResults||null,this.exists=!!a.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,h.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=a.excludePattern&&y.parse(a.excludePattern),this.folderExcludePatterns=new Map,a.folderQueries.forEach(v=>{const _=Object.assign({},v.excludePattern||{},this.config.excludePattern||{}),c=v.folder.fsPath;a.folderQueries.map(u=>u.folder.fsPath).filter(u=>u!==c).forEach(u=>{(0,L.isEqualOrParent)(u,c)&&(_[l.relative(c,u)]=!0)}),this.folderExcludePatterns.set(c,new t(_,c))})}cancel(){this.isCanceled=!0,S.forEach(a=>a())}walk(a,v,_,c,u){if(this.fileWalkSW=w.StopWatch.create(!1),this.isCanceled)return u(null,this.isLimitHit);v.forEach(m=>{const f=l.basename(m.fsPath);this.globalExcludePattern&&this.globalExcludePattern(m.fsPath,f)||this.matchFile(_,{relativePath:m.fsPath,searchPath:void 0})}),this.cmdSW=w.StopWatch.create(!1),this.parallel(a,(m,f)=>{this.call(this.cmdTraversal,this,m,_,c,n=>{if(n){const D=(0,P.toErrorMessage)(n);console.error(D),this.errors.push(D),f(n,void 0)}else f(null,void 0)})},(m,f)=>{this.fileWalkSW.stop();const n=m?T.coalesce(m)[0]:null;u(n,this.isLimitHit)})}parallel(a,v,_){const c=new Array(a.length),u=new Array(a.length);let m=!1,f=0;if(a.length===0)return _(null,[]);a.forEach((n,D)=>{v(n,(M,W)=>{if(M?(m=!0,c[D]=null,u[D]=M):(c[D]=W,u[D]=null),++f===a.length)return _(m?u:null,c)})})}call(a,v,..._){try{a.apply(v,_)}catch(c){_[_.length-1](c)}}cmdTraversal(a,v,_,c){const u=a.folder.fsPath,m=I.isMacintosh,f=()=>$&&$.kill();S.add(f);let n=F=>{S.delete(f),n=()=>{},c(F)},D="";const M=this.initDirectoryTree(),W=(0,d.spawnRipgrepCmd)(this.config,a,this.config.includePattern,this.folderExcludePatterns.get(a.folder.fsPath).expression),$=W.cmd,N=!Object.keys(W.siblingClauses).length,U=W.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let q=`${W.rgDiskPath} ${U}
 - cwd: ${W.cwd}`;W.rgArgs.siblingClauses&&(q+=`
 - Sibling clauses: ${JSON.stringify(W.rgArgs.siblingClauses)}`),_({message:q}),this.cmdResultCount=0,this.collectStdout($,"utf8",_,(F,B,Q)=>{if(F){n(F);return}if(this.isLimitHit){n();return}const X=(D+(m?g.normalizeNFC(B||""):B)).split(`
`);if(Q){const ie=X.length;X[ie-1]=X[ie-1].trim(),X[ie-1]||X.pop()}else D=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){n(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=X.length,N){for(const ie of X)if(this.matchFile(v,{base:u,relativePath:ie,searchPath:this.getSearchPath(a,ie)}),this.isLimitHit){f();break}(Q||this.isLimitHit)&&n();return}this.addDirectoryEntries(a,M,u,X,v),Q&&(this.matchDirectoryTree(M,u,v),n())})}spawnFindCmd(a){const v=this.folderExcludePatterns.get(a.folder.fsPath),_=v.getBasenameTerms(),c=v.getPathTerms(),u=["-L","."];if(_.length||c.length){u.push("-not","(","(");for(const m of _)u.push("-name",m),u.push("-o");for(const m of c)u.push("-path",m),u.push("-o");u.pop(),u.push(")","-prune",")")}return u.push("-type","f"),o.spawn("find",u,{cwd:a.folder.fsPath})}readStdout(a,v,_){let c="";this.collectStdout(a,v,()=>{},(u,m,f)=>{if(u){_(u);return}c+=m,f&&_(null,c)})}collectStdout(a,v,_,c){let u=(n,D,M)=>{(n||M)&&(u=()=>{},this.cmdSW?.stop()),c(n,D,M)},m=!1;a.stdout?(this.forwardData(a.stdout,v,u),a.stdout.once("data",()=>m=!0)):_({message:"stdout is null"});let f;a.stderr?f=this.collectData(a.stderr):_({message:"stderr is null"}),a.on("error",n=>{u(n)}),a.on("close",n=>{let D;!m&&(D=this.decodeData(f,v))&&s(D)?u(new Error(`command failed with error code ${n}: ${this.decodeData(f,v)}`)):(this.exists&&n===0&&(this.isLimitHit=!0),u(null,"",!0))})}forwardData(a,v,_){const c=new R.StringDecoder(v);return a.on("data",u=>{_(null,c.write(u))}),c}collectData(a){const v=[];return a.on("data",_=>{v.push(_)}),v}decodeData(a,v){const _=new R.StringDecoder(v);return a.map(c=>_.write(c)).join("")}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries(a,{pathToEntries:v},_,c,u){c.indexOf(this.filePattern)!==-1&&this.matchFile(u,{base:_,relativePath:this.filePattern,searchPath:this.getSearchPath(a,this.filePattern)});const m=f=>{const n=l.basename(f),D=l.dirname(f);let M=v[D];M||(M=v[D]=[],m(D)),M.push({base:_,relativePath:f,basename:n,searchPath:this.getSearchPath(a,f)})};c.forEach(m)}matchDirectoryTree({rootEntries:a,pathToEntries:v},_,c){const u=this,m=this.folderExcludePatterns.get(_),f=this.filePattern;function n(D){u.directoriesWalked++;const M=(0,i.hasSiblingFn)(()=>D.map(W=>W.basename));for(let W=0,$=D.length;W<$;W++){const N=D[W],{relativePath:U,basename:q}=N;if(m.test(U,q,f!==q?M:void 0))continue;const F=v[U];if(F)n(F);else{if(u.filesWalked++,U===f)continue;u.matchFile(c,N)}if(u.isLimitHit)break}}n(a)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(a,v,_,c,u){const m=a.folder,f=(0,i.hasSiblingFn)(()=>_);this.parallel(_,(n,D)=>{if(this.isCanceled||this.isLimitHit)return D(null);const M=v?[v,n].join(l.sep):n;if(this.folderExcludePatterns.get(a.folder.fsPath).test(M,n,this.config.filePattern!==n?f:void 0))return D(null);const W=[m.fsPath,M].join(l.sep);A.lstat(W,($,N)=>{if($||this.isCanceled||this.isLimitHit)return D(null);this.statLinkIfNeeded(W,N,(U,q)=>U||this.isCanceled||this.isLimitHit?D(null):q.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(W,N,(F,B)=>F||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?D(null):(this.walkedPaths[B]=!0,b.Promises.readdir(W).then(Q=>{if(this.isCanceled||this.isLimitHit)return D(null);this.doWalk(a,M,Q,c,J=>D(J||null))},Q=>{D(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&C.isNumber(q.size)&&q.size>this.maxFilesize||this.matchFile(c,{base:m.fsPath,relativePath:M,searchPath:this.getSearchPath(a,M)}),D(null,void 0)))})},n=>{const D=n&&T.coalesce(n);return u(D&&D.length>0?D[0]:void 0)})}matchFile(a,v){this.isFileMatch(v)&&(!this.includePattern||this.includePattern(v.relativePath,l.basename(v.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||a(v))}isFileMatch(a){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,i.isFilePatternMatch)(a,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(a,v,_){return v.isSymbolicLink()?A.stat(a,_):_(null,v)}realPathIfNeeded(a,v,_){return v.isSymbolicLink()?A.realpath(a,(c,u)=>c?_(c):_(null,u)):_(null,a)}getSearchPath(a,v){return a.folderName?l.join(a.folderName,v):v}}e.FileWalker=E;class p{constructor(a){this.folderQueries=a.folderQueries,this.extraFiles=a.extraFileResources||[],this.walker=new E(a)}search(a,v,_){this.walker.walk(this.folderQueries,this.extraFiles,a,v,(c,u)=>{_(c,{limitHit:u,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(a,v){this.expression=a,this.root=v,this.init(a)}init(a){let v,_;Object.keys(a).filter(c=>a[c]).forEach(c=>{l.isAbsolute(c)?(v=v||y.getEmptyExpression(),v[c]=a[c]):(_=_||y.getEmptyExpression(),_[c]=a[c])}),this.absoluteParsedExpr=v&&y.parse(v,{trimForExclusions:!0}),this.relativeParsedExpr=_&&y.parse(_,{trimForExclusions:!0})}test(a,v,_){return this.relativeParsedExpr&&this.relativeParsedExpr(a,v,_)||this.absoluteParsedExpr&&this.absoluteParsedExpr(l.join(this.root,a),v,_)}getBasenameTerms(){const a=[];return this.absoluteParsedExpr&&a.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&a.push(...y.getBasenameTerms(this.relativeParsedExpr)),a}getPathTerms(){const a=[];return this.absoluteParsedExpr&&a.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&a.push(...y.getPathTerms(this.relativeParsedExpr)),a}}function s(r){const a=r.trim().split(`
`),v=a[0].trim();if(v.startsWith("Error parsing regex"))return v;if(v.startsWith("regex parse error"))return k.uppercaseFirstLetter(a[a.length-1].trim());if(v.startsWith("error parsing glob")||v.startsWith("unsupported encoding"))return v.charAt(0).toUpperCase()+v.substr(1);if(v==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(v.startsWith("Literal "))return v}}),define(De[322],Ie([1,0,104,22]),function(oe,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function l(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(a=>a===r)}e.isUTFEncoding=l,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,T=512,P=512*8,y=512*128;var g;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(g||(e.DecodeStreamErrorKind=g={}));class L extends Error{constructor(a,v){super(a),this.decodeStreamErrorKind=v}}e.DecodeStreamError=L;class I{static async create(a){let v;if(a!==e.UTF8)v=(await new Promise((c,u)=>{oe(["@vscode/iconv-lite-umd"],c,u)})).getDecoder(b(a));else{const _=new TextDecoder;v={write(c){return _.decode(c,{stream:!0})},end(){return _.decode()}}}return new I(v)}constructor(a){this.iconvLiteDecoder=a}write(a){return this.iconvLiteDecoder.write(a)}end(){return this.iconvLiteDecoder.end()}}function w(r,a){const v=a.minBytesRequiredForDetection??a.guessEncoding?P:T;return new Promise((_,c)=>{const u=(0,o.newWriteableStream)(W=>W.join("")),m=[];let f=0,n;const D=async()=>{try{const W=await s({buffer:A.VSBuffer.concat(m),bytesRead:f},a.guessEncoding);if(W.seemsBinary&&a.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);W.encoding=await a.overwriteEncoding(W.encoding),n=await I.create(W.encoding);const $=n.write(A.VSBuffer.concat(m).buffer);u.write($),m.length=0,f=0,_({stream:u,detected:W})}catch(W){M?.dispose(),u.destroy(),c(W)}},M=(0,o.listenStream)(r,{onData:async W=>{n?u.write(n.write(W.buffer)):(m.push(W),f+=W.byteLength,f>=v&&(r.pause(),await D(),setTimeout(()=>r.resume())))},onError:W=>u.error(W),onEnd:async()=>{n||await D(),u.end(n?.end())}})})}e.toDecodeStream=w;async function k(r,a,v){const c=(await new Promise((f,n)=>{oe(["@vscode/iconv-lite-umd"],f,n)})).getEncoder(b(a),v);let u=!1,m=!1;return{read(){if(m)return null;const f=r.read();if(typeof f!="string"){if(m=!0,!u&&v?.addBOM)switch(a){case e.UTF8:case e.UTF8_with_bom:return A.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const n=c.end();return n&&n.length>0?(u=!0,A.VSBuffer.wrap(n)):null}return u=!0,A.VSBuffer.wrap(c.write(f))}}}e.toEncodeReadable=k;async function C(r){return(await new Promise((v,_)=>{oe(["@vscode/iconv-lite-umd"],v,_)})).encodingExists(b(r))}e.encodingExists=C;function b(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=b;function i(r,a){if(!r||a<e.UTF16be_BOM.length)return null;const v=r.readUInt8(0),_=r.readUInt8(1);if(v===e.UTF16be_BOM[0]&&_===e.UTF16be_BOM[1])return e.UTF16be;if(v===e.UTF16le_BOM[0]&&_===e.UTF16le_BOM[1])return e.UTF16le;if(a<e.UTF8_BOM.length)return null;const c=r.readUInt8(2);return v===e.UTF8_BOM[0]&&_===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=i;const d=["ascii","utf-16","utf-32"];async function h(r){const a=await new Promise((m,f)=>{oe(["jschardet"],m,f)}),v=r.slice(0,y),_=p(v.buffer),c=a.detect(_);if(!c||!c.encoding)return null;const u=c.encoding.toLowerCase();return 0<=d.indexOf(u)?null:E(c.encoding)}const S={ibm866:"cp866",big5:"cp950"};function E(r){const a=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return S[a]||a}function p(r){let a="";for(let v=0;v<r.length;v++)a+=String.fromCharCode(r[v]);return a}function t(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const a=r.match(/windows(\d+)/);return a?"windows-"+a[1]:r}}}e.toCanonicalName=t;function s({buffer:r,bytesRead:a},v){let _=i(r,a),c=!1;if(_!==e.UTF16be&&_!==e.UTF16le&&r){let u=!0,m=!0,f=!1;for(let n=0;n<a&&n<R;n++){const D=n%2===1,M=r.readUInt8(n)===0;if(M&&(f=!0),u&&(D&&!M||!D&&M)&&(u=!1),m&&(D&&M||!D&&!M)&&(m=!1),M&&!u&&!m)break}f&&(u?_=e.UTF16le:m?_=e.UTF16be:c=!0)}return v&&!c&&!_&&r?h(r.slice(0,a)).then(u=>({seemsBinary:!1,encoding:u})):{seemsBinary:c,encoding:_}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[145],Ie([1,0,322,29,144]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends l.TextSearchManager{constructor(P,y,g=A,L="searchProcess"){super(P,y,{readdir:I=>g.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,o.toCanonicalName)(I)},L)}}e.NativeTextSearchManager=R}),define(De[146],Ie([1,0,47,336,321,18,63,39,15,9,2,31,83,337,319,101]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const i=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(n){this.outputChannel=n}provideTextSearchResults(n,D,M,W){return this.outputChannel.appendLine(`provideTextSearchResults ${n.pattern}, ${JSON.stringify({...D,folder:D.folder.toString()})}`),new Promise(($,N)=>{W.onCancellationRequested(()=>ie());const U=s(n,D),q=D.folder.fsPath,F=U.map(V=>V.match(/^-/)?V:`'${V}'`).join(" ");this.outputChannel.appendLine(`${i} ${F}
 - cwd: ${q}`);let B=o.spawn(i,U,{cwd:q});B.on("error",V=>{console.error(V),this.outputChannel.appendLine("Error: "+(V&&V.message)),N((0,I.serializeSearchError)(new I.SearchError(V&&V.message,I.SearchErrorCode.rgProcessError)))});let Q=!1;const J=new E(D.maxResults,q,D.previewOptions);J.on("result",V=>{Q=!0,we="",M.report(V)});let X=!1;const ie=()=>{X=!0,B?.kill(),J?.cancel()};let ae=!1;J.on("hitLimit",()=>{ae=!0,ie()});let we="";B.stdout.on("data",V=>{J.handleData(V),Q||(we+=V)});let he=!1;B.stdout.once("data",()=>he=!0);let fe="";B.stderr.on("data",V=>{const x=V.toString();this.outputChannel.appendLine(x),fe.length+x.length<1e6&&(fe+=x)}),B.on("close",()=>{if(this.outputChannel.appendLine(he?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(Q?"Got result from parser":"No result from parser"),we&&this.outputChannel.appendLine(`Got data without result: ${we}`),this.outputChannel.appendLine(""),X)$({limitHit:ae});else{J.flush(),B=null;let V;fe&&!he&&(V=h(fe))?N((0,I.serializeSearchError)(new I.SearchError(V.message,V.code))):$({limitHit:ae})}})})}}e.RipgrepTextSearchEngine=d;function h(f){const n=f.split(`
`),D=n[0].trim();if(n.some(W=>W.startsWith("regex parse error")))return new I.SearchError(S(n),I.SearchErrorCode.regexParseError);const M=D.match(/grep config error: unknown encoding: (.*)/);if(M)return new I.SearchError(`Unknown encoding: ${M[1]}`,I.SearchErrorCode.unknownEncoding);if(D.startsWith("error parsing glob"))return new I.SearchError(D.charAt(0).toUpperCase()+D.substr(1),I.SearchErrorCode.globParseError);if(D.startsWith("the literal"))return new I.SearchError(D.charAt(0).toUpperCase()+D.substr(1),I.SearchErrorCode.invalidLiteral);if(D.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(D,I.SearchErrorCode.regexParseError)}function S(f){const n=["Regex parse error"],D=f.filter(M=>M.startsWith("PCRE2:"));if(D.length>=1){const M=D[0].replace("PCRE2:","");if(M.indexOf(":")!==-1&&M.split(":").length>=2){const W=M.split(":")[1];n.push(":"+W)}}return n.join("")}class E extends A.EventEmitter{constructor(n,D,M){super(),this.maxResults=n,this.rootFolder=D,this.previewOptions=M,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new l.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(n,D){return super.on(n,D),this}handleData(n){if(this.isDone)return;const D=typeof n=="string"?n:this.stringDecoder.write(n);this.handleDecodedData(D)}handleDecodedData(n){let D=n.indexOf(`
`);const M=this.remainder+n;if(D>=0)D+=this.remainder.length;else{this.remainder=M;return}let W=0;for(;D>=0;)this.handleLine(M.substring(W,D).trim()),W=D+1,D=M.indexOf(`
`,W);this.remainder=M.substring(W)}handleLine(n){if(this.isDone||!n)return;let D;try{D=JSON.parse(n)}catch{throw new Error(`malformed line from rg: ${n}`)}if(D.type==="match"){const M=p(D.data.path),W=L.URI.file(y.join(this.rootFolder,M)),$=this.createTextSearchMatch(D.data,W);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(D.type==="context"){const M=p(D.data.path),W=L.URI.file(y.join(this.rootFolder,M));this.createTextSearchContext(D.data,W).forEach(N=>this.onResult(N))}}createTextSearchMatch(n,D){const M=n.line_number-1,W=p(n.lines),$=Buffer.from(W);let N=0,U=0,q=M;n.submatches.length===0&&n.submatches.push(W.length?{start:0,end:1,match:{text:W[0]}}:{start:0,end:0,match:{text:""}});const F=(0,R.coalesce)(n.submatches.map((B,Q)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const J=p(B.match),X=$.slice(N,B.start).toString(),ie=t(X),ae=ie.numLines>0?ie.lastLineLength:ie.lastLineLength+U,we=t(J),he=ie.numLines+q,fe=we.numLines+he,V=we.numLines>0?we.lastLineLength:we.lastLineLength+ae;return N=B.end,U=V,q=fe,new w.Range(he,ae,fe,V)}));return(0,b.createTextSearchResult)(D,W,F,this.previewOptions)}createTextSearchContext(n,D){const M=p(n.lines),W=n.line_number;return M.replace(/\r?\n$/,"").split(`
`).map(($,N)=>({text:$,uri:D,lineNumber:W+N}))}onResult(n){this.emit("result",n)}}e.RipgrepParser=E;function p(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function t(f){const n=/\n/g;let D=0,M=-1,W;for(;W=n.exec(f);)D++,M=W.index;const $=M>=0?f.length-M-1:f.length;return{numLines:D,lastLineLength:$}}function s(f,n){const D=["--hidden"];D.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:M,otherIncludes:W}=(0,T.groupBy)(n.includes,N=>N.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(W&&W.length){const N=new Set;W.forEach(U=>{N.add(U)}),D.push("-g","!*"),N.forEach(U=>{r(U).map(b.anchorGlob).forEach(q=>{D.push("-g",q)})})}M&&M.length&&M.forEach(N=>{D.push("-g",N)}),n.excludes.map(b.anchorGlob).forEach(N=>D.push("-g",`!${N}`)),n.maxFileSize&&D.push("--max-filesize",n.maxFileSize+""),n.useIgnoreFiles?n.useParentIgnoreFiles||D.push("--no-ignore-parent"):D.push("--no-ignore"),n.followSymlinks&&D.push("--follow"),n.encoding&&n.encoding!=="utf8"&&D.push("--encoding",n.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,g.escapeRegExpCharacters)(f.pattern),f.isRegExp=!0),n.usePCRE2&&D.push("--pcre2"),D.push("--crlf"),f.isRegExp&&(f.pattern=a(f.pattern),D.push("--engine","auto"));let $;if(f.isWordMatch){const U=(0,g.createRegExp)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");D.push("--regexp",U)}else if(f.isRegExp){let N=_(f.pattern);N=c(N),D.push("--regexp",N)}else $=f.pattern,D.push("--fixed-strings");return D.push("--no-config"),n.useGlobalIgnoreFiles||D.push("--no-ignore-global"),D.push("--json"),f.isMultiline&&D.push("--multiline"),n.beforeContext&&D.push("--before-context",n.beforeContext+""),n.afterContext&&D.push("--after-context",n.afterContext+""),D.push("--"),$&&D.push($),D.push("."),D}e.getRgArgs=s;function r(f){return m(f).flatMap(D=>{const M=(0,P.splitGlobAware)(D,"/");return M.map((W,$)=>M.slice(0,$+1).join("/"))})}function a(f){const n=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(n);)f=f.replace(n,"$1\\x{$2}");const D=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(D);)f=f.replace(D,"$1\\x{$2}");return f}e.unicodeEscapesToPCRE2=a;const v=f=>f.type==="Assertion"&&f.kind==="lookbehind";function _(f){let n;try{n=new k.RegExpParser().parsePattern(f)}catch{return f}let D="",M=0;const W=(U,q,F)=>{D+=f.slice(M,U)+F,M=q},$=[];return new k.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const q=$[0];if(!q)W(U.start,U.end,"\\r?\\n");else if(!$.some(v))if(q.type==="CharacterClass")if(q.negate){const F=f.slice(q.start+2,U.start)+f.slice(U.end,q.end-1);q.parent?.type==="Quantifier"?W(q.start,q.end,F?`[^${F}]`:"."):W(q.start,q.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=f.slice(q.start+1,U.start)+f.slice(U.end,q.end-1);W(q.start,q.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else q.type==="Quantifier"&&W(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){$.unshift(U)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(U){$.unshift(U)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(U){$.unshift(U)},onCharacterClassLeave(){$.shift()},onAssertionEnter(U){v(U)&&$.push(U)},onAssertionLeave(U){$[0]===U&&$.shift()}}).visit(n),D+=f.slice(M),D}e.fixRegexNewline=_;function c(f){return f.replace(/\n/g,"\\r?\\n")}e.fixNewline=c;function u(f){let n=!1,D=!1,M="",W="";for(let $=0;$<f.length;$++){const N=f[$];switch(N){case"\\":D?(n?W+="\\"+N:M+="\\"+N,D=!1):D=!0;break;case"{":if(D)n?W+=N:M+=N,D=!1;else{if(n)return{strInBraces:M+"{"+W+"{"+f.substring($+1)};n=!0}break;case"}":if(D)n?W+=N:M+=N,D=!1;else{if(n)return{fixedStart:M,strInBraces:W,fixedEnd:f.substring($+1)};M+=N}break;default:n?W+=(D?"\\":"")+N:M+=(D?"\\":"")+N,D=!1;break}}return{strInBraces:M+(n?"{"+W:"")}}function m(f){const{fixedStart:n,strInBraces:D,fixedEnd:M}=u(f);if(n===void 0||M===void 0)return[D];let W=(0,P.splitGlobAware)(D,",");W.length||(W=[""]);const $=m(M);return W.flatMap(N=>{const U=n+N;return $.map(q=>U+q)})}e.performBraceExpansionForRipgrep=m}),define(De[323],Ie([1,0,21,146,125,16]),function(oe,e,o,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(g){this.outputChannel=g,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(g,L,I,w){const k=new A.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===R.Schemas.vscodeUserData){const C={...L,folder:L.folder.with({scheme:R.Schemas.file})},b=new l.Progress(i=>I.report({...i,uri:i.uri.with({scheme:L.folder.scheme})}));return this.withToken(w,i=>k.provideTextSearchResults(g,C,b,i))}else return this.withToken(w,C=>k.provideTextSearchResults(g,L,I,C))}async withToken(g,L){const I=P(g);this.inProgress.add(I);const w=await L(I.token);return this.inProgress.delete(I),w}dispose(){this.inProgress.forEach(g=>g.cancel())}}e.RipgrepSearchProvider=T;function P(y){const g=new o.CancellationTokenSource;return y.onCancellationRequested(()=>g.cancel()),g}}),define(De[324],Ie([1,0,29,146,145]),function(oe,e,o,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(y){this.query=y}search(y,g,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(k){L({message:k})}},w=new l.NativeTextSearchManager(this.query,new A.RipgrepTextSearchEngine(I),o);return new Promise((k,C)=>w.search(b=>{g(b.map(T))},y).then(b=>k({limitHit:b.limitHit,type:"success",stats:b.stats}),C))}}e.TextSearchEngineAdapter=R;function T(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((y,g)=>{if(g.ranges){const L=g;return y+(Array.isArray(L.ranges)?L.ranges.length:1)}else return y+1},0)}}}),define(De[325],Ie([1,0,18,19,8,3,112,15,37,2,45,31,320,324]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class C{constructor(E="searchProcess"){this.processType=E,this.caches=Object.create(null)}fileSearch(E){let p;const t=d(E),s=new R.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(r=>this.doFileSearchWithEngine(w.Engine,t,a=>s.fire(a),r)),p.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return s.event}textSearch(E){let p;const t=d(E),s=new R.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(r=>this.ripgrepTextSearch(t,a=>s.fire(a),r)),p.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return s.event}ripgrepTextSearch(E,p,t){return E.maxFileSize=this.getPlatformFileLimits().maxFileSize,new k.TextSearchEngineAdapter(E).search(t,p,p)}getPlatformFileLimits(){return{maxFileSize:process.arch==="ia32"?300*L.ByteSize.MB:16*L.ByteSize.GB}}doFileSearch(E,p,t){return this.doFileSearchWithEngine(w.Engine,E,p,t)}doFileSearchWithEngine(E,p,t,s,r=C.BATCH_SIZE){let a=0;const v=c=>{Array.isArray(c)?(a+=c.length,t(c.map(u=>this.rawMatchToSearchItem(u)))):c.relativePath?(a++,t(this.rawMatchToSearchItem(c))):t(c)};if(p.sortByScore){let c=this.trySortedSearchFromCache(p,v,s);if(!c){const u=p.maxResults?Object.assign({},p,{maxResults:null}):p,m=new E(u);c=this.doSortedSearch(m,p,t,v,s)}return new Promise((u,m)=>{c.then(([f,n])=>{const D=n.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(D,t,r),u(f)},m)})}const _=new E(p);return this.doSearch(_,v,r,s).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:a,sortingTime:void 0}}))}rawMatchToSearchItem(E){return{path:E.base?(0,P.join)(E.base,E.relativePath):E.relativePath}}doSortedSearch(E,p,t,s,r){const a=new R.Emitter;let v=(0,A.createCancelablePromise)(c=>{let u=[];const m=f=>{Array.isArray(f)?u=f:(s(f),a.fire(f))};return this.doSearch(E,m,-1,c).then(f=>[f,u])}),_;if(p.cacheKey){_=this.getOrCreateCache(p.cacheKey);const c={promise:v,event:a.event,resolved:!1};_.resultsToSearchCache[p.filePattern||""]=c,v.then(()=>{c.resolved=!0},u=>{delete _.resultsToSearchCache[p.filePattern||""]}),v=this.preventCancellation(v)}return v.then(([c,u])=>{const m=_?_.scorerCache:Object.create(null),f=(typeof p.maxResults!="number"||p.maxResults>0)&&y.StopWatch.create(!1);return this.sortResults(p,u,m,r).then(n=>{const D=f?f.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:D,fromCache:!1,type:this.processType,workspaceFolderCount:p.folderQueries.length,resultCount:n.length},messages:c.messages,limitHit:c.limitHit||typeof p.maxResults=="number"&&u.length>p.maxResults},n]})})}getOrCreateCache(E){const p=this.caches[E];return p||(this.caches[E]=new b)}trySortedSearchFromCache(E,p,t){const s=E.cacheKey&&this.caches[E.cacheKey];if(!s)return;const r=this.getResultsFromCache(s,E.filePattern||"",p,t);if(r)return r.then(([a,v,_])=>{const c=y.StopWatch.create(!1);return this.sortResults(E,v,s.scorerCache,t).then(u=>{const m=c.elapsed(),f={fromCache:!0,detailStats:_,type:this.processType,resultCount:v.length,sortingTime:m};return[{type:"success",limitHit:a.limitHit||typeof E.maxResults=="number"&&v.length>E.maxResults,stats:f},u]})})}sortResults(E,p,t,s){const r=(0,T.prepareQuery)(E.filePattern||""),a=(_,c)=>(0,T.compareItemsByFuzzyScore)(_,c,r,!0,i,t),v=typeof E.maxResults=="number"?E.maxResults:Number.MAX_VALUE;return o.topAsync(p,a,v,1e4,s)}sendProgress(E,p,t){if(t&&t>0)for(let s=0;s<E.length;s+=t)p(E.slice(s,s+t));else p(E)}getResultsFromCache(E,p,t,s){const r=y.StopWatch.create(!1),a=p.indexOf(P.sep)>=0;let v;for(const m in E.resultsToSearchCache)if(p.startsWith(m)){if(a&&m.indexOf(P.sep)<0&&m!=="")continue;const f=E.resultsToSearchCache[m];v={promise:this.preventCancellation(f.promise),event:f.event,resolved:f.resolved};break}if(!v)return null;const _=r.elapsed(),c=y.StopWatch.create(!1),u=v.event(t);return s&&s.onCancellationRequested(()=>{u.dispose()}),v.promise.then(([m,f])=>{if(s&&s.isCancellationRequested)throw(0,l.canceled)();const n=[],D=(0,T.prepareQuery)(p).normalizedLowercase;for(const M of f)(0,I.isFilePatternMatch)(M,D)&&n.push(M);return[m,n,{cacheWasResolved:v.resolved,cacheLookupTime:_,cacheFilterTime:c.elapsed(),cacheEntryCount:f.length}]})}doSearch(E,p,t,s){return new Promise((r,a)=>{let v=[];s?.onCancellationRequested(()=>E.cancel()),E.search(_=>{_&&(t?(v.push(_),t>0&&v.length>=t&&(p(v),v=[])):p(_))},_=>{p(_)},(_,c)=>{v.length&&p(v),_?a(_):r(c)})})}clearCache(E){return delete this.caches[E],Promise.resolve(void 0)}preventCancellation(E){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,t){return E.then(p,t)}catch(p){return this.then(void 0,p)}finally(p){return E.finally(p)}}}}e.SearchService=C,C.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const i=new class{getItemLabel(S){return(0,P.basename)(S.relativePath)}getItemDescription(S){return(0,P.dirname)(S.relativePath)}getItemPath(S){return S.relativePath}};function d(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(h),extraFileResources:S.extraFileResources&&S.extraFileResources.map(E=>g.URI.revive(E))}}function h(S){return{...S,folder:g.URI.revive(S.folder)}}}),define(De[326],Ie([1,0,6,16,2,29,17,26,20,87,58,31,325,323,101,145]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let i=e.NativeExtHostSearch=class extends g.ExtHostSearch{constructor(h,S,E,p){super(h,E,p),this._pfs=R,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new C.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(A.Schemas.vscodeUserData,new k.RipgrepSearchProvider(t)),S.remote.isRemote&&S.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const h=new C.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(A.Schemas.file,new k.RipgrepSearchProvider(h)),this.registerInternalFileSearchProvider(A.Schemas.file,new w.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(h,S){const E=this._handlePool++;return this._internalFileSearchProvider=S,this._internalFileSearchHandle=E,this._proxy.$registerFileSearchProvider(E,this._transformScheme(h)),(0,o.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(E)})}$provideFileSearchResults(h,S,E,p){const t=(0,g.reviveQuery)(E);return h===this._internalFileSearchHandle?this.doInternalFileSearch(h,S,t,p):super.$provideFileSearchResults(h,S,E,p)}doInternalFileSearch(h,S,E,p){const t=s=>{if((0,I.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this._proxy.$handleFileMatch(h,S,s.map(r=>l.URI.file(r.path)));return}s.message&&this._logService.debug("ExtHostSearch",s.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(E,t,p)}$clearCache(h){return this._internalFileSearchProvider?.clearCache(h),super.$clearCache(h)}createTextSearchManager(h,S){return new b.NativeTextSearchManager(h,S,void 0,"textSearchProvider")}};e.NativeExtHostSearch=i=Ve([ze(0,y.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,L.IURITransformerService),ze(3,T.ILogService)],i)}),define(De[147],Ie([1,0,338,132,55,339,22,8,3,6,15,14,30,118,119]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class b{traceSocketEvent(f,n){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,n)}constructor(f,n=""){this._canWrite=!0,this.debugLabel=n,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,P.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener),this._closeListener=D=>{this.traceSocketEvent("close",{hadError:D}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(f){const n=D=>{this.traceSocketEvent("read",D),f(T.VSBuffer.wrap(D))};return this.socket.on("data",n),{dispose:()=>this.socket.off("data",n)}}onClose(f){const n=D=>{f({type:0,hadError:D,error:void 0})};return this.socket.on("close",n),{dispose:()=>this.socket.off("close",n)}}onEnd(f){const n=()=>{f()};return this.socket.on("end",n),{dispose:()=>this.socket.off("end",n)}}write(f){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,n=>{if(n){if(n.code==="EPIPE")return;(0,P.onUnexpectedError)(n)}})}catch(n){if(n.code==="EPIPE")return;(0,P.onUnexpectedError)(n)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,n)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=b;var i;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(i||(i={}));var d;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(d||(d={}));class h extends g.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(f,n){this.socket.traceSocketEvent(f,n)}constructor(f,n,D,M){super(),this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:n,inflateBytesLength:D?.byteLength||0,recordInflateBytes:M}),this._flowManager=this._register(new S(this,n,D,M,this._onData,(W,$)=>this._write(W,$))),this._register(this._flowManager.onError(W=>{console.error(W),(0,P.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(W=>this._acceptChunk(W))),this._register(this.socket.onClose(async W=>{this._flowManager.isProcessingReadQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(W)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let n=0;for(;n<f.byteLength;)this._flowManager.writeMessage(f.slice(n,Math.min(n+262144,f.byteLength))),n+=262144}_write(f,n){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let D=2;f.byteLength<126?D+=0:f.byteLength<2**16?D+=2:D+=8;const M=T.VSBuffer.alloc(D);if(n?M.writeUInt8(194,0):M.writeUInt8(130,0),f.byteLength<126)M.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){M.writeUInt8(126,1);let W=1;M.writeUInt8(f.byteLength>>>8&255,++W),M.writeUInt8(f.byteLength>>>0&255,++W)}else{M.writeUInt8(127,1);let W=1;M.writeUInt8(0,++W),M.writeUInt8(0,++W),M.writeUInt8(0,++W),M.writeUInt8(0,++W),M.writeUInt8(f.byteLength>>>24&255,++W),M.writeUInt8(f.byteLength>>>16&255,++W),M.writeUInt8(f.byteLength>>>8&255,++W),M.writeUInt8(f.byteLength>>>0&255,++W)}this.socket.write(T.VSBuffer.concat([M,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const n=this._incomingData.peek(this._state.readLen),D=n.readUInt8(0),M=(D&128)>>>7,W=(D&64)>>>6,$=n.readUInt8(1),N=($&128)>>>7,U=$&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(U===126?2:0)+(U===127?8:0),this._state.fin=M,this._state.firstFrameOfMessage&&(this._state.compressed=!!W),this._state.firstFrameOfMessage=!!M,this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const n=this._incomingData.read(this._state.readLen),D=n.readUInt8(1),M=(D&128)>>>7;let W=D&127,$=1;W===126?W=n.readUInt8(++$)*2**8+n.readUInt8(++$):W===127&&(W=n.readUInt8(++$)*0+n.readUInt8(++$)*0+n.readUInt8(++$)*0+n.readUInt8(++$)*0+n.readUInt8(++$)*2**24+n.readUInt8(++$)*2**16+n.readUInt8(++$)*2**8+n.readUInt8(++$));let N=0;M&&(N=n.readUInt8(++$)*2**24+n.readUInt8(++$)*2**16+n.readUInt8(++$)*2**8+n.readUInt8(++$)),this._state.state=3,this._state.readLen=W,this._state.mask=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const n=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",n),t(n,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",n),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(n,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class S extends g.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}constructor(f,n,D,M,W,$){super(),this._tracer=f,this._onData=W,this._writeFn=$,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new y.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new y.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,n?(this._zlibInflateStream=this._register(new E(this._tracer,M,D,{windowBits:15})),this._zlibDeflateStream=this._register(new p(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(N=>this._onError.fire(N))),this._register(this._zlibDeflateStream.onError(N=>this._onError.fire(N)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(f){this._writeQueue.push(f),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const f=this._writeQueue.shift();if(this._zlibDeflateStream){const n=await this._deflateMessage(this._zlibDeflateStream,f);this._writeFn(n,!0)}else this._writeFn(f,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(f,n){return new Promise((D,M)=>{f.write(n),f.flush(W=>D(W))})}acceptFrame(f,n,D){this._readQueue.push({data:f,isCompressed:n,isLastFrameOfMessage:D}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const f=this._readQueue.shift();if(this._zlibInflateStream&&f.isCompressed){const n=await this._inflateFrame(this._zlibInflateStream,f.data,f.isLastFrameOfMessage);this._onData.fire(n)}else this._onData.fire(f.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(f,n,D){return new Promise((M,W)=>{f.write(n),D&&f.write(T.VSBuffer.fromByteArray([0,0,255,255])),f.flush($=>M($))})}}class E extends g.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}constructor(f,n,D,M){super(),this._tracer=f,this._recordInflateBytes=n,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,R.createInflateRaw)(M),this._zlibInflate.on("error",W=>{this._tracer.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this._onError.fire(W)}),this._zlibInflate.on("data",W=>{this._tracer.traceSocketEvent("zlibInflateData",W),this._pendingInflateData.push(T.VSBuffer.wrap(W))}),D&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(f){this._recordInflateBytes&&this._recordedInflateBytes.push(f.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",f),this._zlibInflate.write(f.buffer)}flush(f){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const n=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,f(n)})}}class p extends g.Disposable{constructor(f,n){super(),this._tracer=f,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,R.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",D=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibDeflate.on("data",D=>{this._tracer.traceSocketEvent("zlibDeflateData",D),this._pendingDeflateData.push(T.VSBuffer.wrap(D))})}write(f){this._tracer.traceSocketEvent("zlibDeflateWrite",f.buffer),this._zlibDeflate.write(f.buffer)}flush(f){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let n=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,n=n.slice(0,n.byteLength-4),f(n)})}}function t(m,f){if(f===0)return;const n=m.byteLength>>>2;for(let U=0;U<n;U++){const q=m.readUInt32BE(U*4);m.writeUInt32BE(q^f,U*4)}const D=n*4,M=m.byteLength-D,W=f>>>24&255,$=f>>>16&255,N=f>>>8&255;M>=1&&m.writeUInt8(m.readUInt8(D)^W,D),M>=2&&m.writeUInt8(m.readUInt8(D+1)^$,D+1),M>=3&&m.writeUInt8(m.readUInt8(D+2)^N,D+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function r(){const m=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const f=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,l.tmpdir)(),n=(0,L.join)(f,`vscode-ipc-${m}.sock`);return v(n),n}e.createRandomIPCHandle=r;function a(m,f,n){const D=(0,o.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${n}-${f}-sock`;const M=n.substr(0,4),W=f.substr(0,6),$=D.substr(0,8);let N;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-${$}-${M}-${W}.sock`):N=(0,L.join)(m,`${M}-${W}.sock`),v(N),N}e.createStaticIPCHandle=a;function v(m){const f=s[I.platform];typeof f=="number"&&m.length>=f&&console.warn(`WARNING: IPC handle "${m}" is longer than ${f} chars, try a shorter --user-data-dir`)}class _ extends k.IPCServer{static toClientConnectionEvent(f){const n=y.Event.fromNodeEventEmitter(f,"connection");return y.Event.map(n,D=>({protocol:new C.Protocol(new b(D,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(D,"close"))}))}constructor(f){super(_.toClientConnectionEvent(f)),this.server=f}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=_;function c(m){return new Promise((f,n)=>{const D=(0,A.createServer)();D.on("error",n),D.listen(m,()=>{D.removeListener("error",n),f(new _(D))})})}e.serve=c;function u(m,f){return new Promise((n,D)=>{const M=(0,A.createConnection)(m,()=>{M.removeListener("error",D),n(C.Client.fromSocket(new b(M,`ipc-client${f}`),f))});M.once("error",D)})}e.connect=u}),define(De[327],Ie([1,0,147,234,72,41,2,17,48]),function(oe,e,o,A,l,R,T,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class g{constructor(w,k,C){this._commands=w,this.logService=k,this._ipcHandlePath=C,this._server=A.createServer((b,i)=>this.onRequest(b,i)),this.setup().catch(b=>(k.error(b),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",w=>this.logService.error(w))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(w,k){const C=(i,d)=>{k.writeHead(i,{"content-type":"application/json"}),k.end(JSON.stringify(d||null),h=>h&&this.logService.error(h))},b=[];w.setEncoding("utf8"),w.on("data",i=>b.push(i)),w.on("end",async()=>{try{const i=JSON.parse(b.join(""));let d;switch(i.type){case"open":d=await this.open(i);break;case"openExternal":d=await this.openExternal(i);break;case"status":d=await this.getStatus(i);break;case"extensionManagement":d=await this.manageExtensions(i);break;default:C(404,`Unknown message type: ${i.type}`);break}C(200,d)}catch(i){const d=i instanceof Error?i.message:JSON.stringify(i);C(500,d),this.logService.error("Error while processing pipe request",i)}})}async open(w){const{fileURIs:k,folderURIs:C,forceNewWindow:b,diffMode:i,mergeMode:d,addMode:h,forceReuseWindow:S,gotoLineMode:E,waitMarkerFilePath:p,remoteAuthority:t}=w,s=[];if(Array.isArray(C))for(const _ of C)try{s.push({folderUri:T.URI.parse(_)})}catch{}if(Array.isArray(k))for(const _ of k)try{(0,y.hasWorkspaceFileExtension)(_)?s.push({workspaceUri:T.URI.parse(_)}):s.push({fileUri:T.URI.parse(_)})}catch{}const r=p?T.URI.file(p):void 0,v={forceNewWindow:b,diffMode:i,mergeMode:d,addMode:h,gotoLineMode:E,forceReuseWindow:S,preferNewWindow:!S&&!r&&!h,waitMarkerFileURI:r,remoteAuthority:t};return this._commands.executeCommand("_remoteCLI.windowOpen",s,v),""}async openExternal(w){for(const k of w.uris){const C=T.URI.parse(k),b=C.scheme==="file"?C:k;await this._commands.executeCommand("_remoteCLI.openExternal",b)}}async manageExtensions(w){const k=b=>b?.map(i=>/\.vsix$/i.test(i)?T.URI.parse(i):i),C={list:w.list,install:k(w.install),uninstall:k(w.uninstall),force:w.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",C)}async getStatus(w){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&l.existsSync(this._ipcHandlePath)&&l.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=g;let L=e.CLIServer=class extends g{constructor(w,k){super(w,k,(0,o.createRandomIPCHandle)())}};e.CLIServer=L=Ve([ze(0,R.IExtHostCommands),ze(1,P.ILogService)],L)}),define(De[328],Ie([1,0,85,316,311,233,43,299,2,16,7,327,116,298]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class C extends l.RequireInterceptor{_installInterceptor(){const d=this,h=globalThis._VSCODE_NODE_MODULES.module,S=h._load;h._load=function(s,r,a){return s=p(s),d._factories.has(s)?d._factories.get(s).load(s,y.URI.file((0,w.realpathSync)(r.filename)),v=>S.apply(this,[v,r,a])):S.apply(this,arguments)};const E=h._resolveLookupPaths;h._resolveLookupPaths=(t,s)=>E.call(this,p(t),s);const p=t=>{for(const s of d._alternatives){const r=s(t);if(r){t=r;break}}return t}}}class b extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(k.ExtHostConsoleForwarder);const d=this._instaService.invokeFunction(A.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(P.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const E=this._instaService.createInstance(I.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=E.ipcHandlePath}await this._instaService.createInstance(C,d,{mine:this._myRegistry,all:this._globalRegistry}).install(),o.mark("code/extHost/didInitAPI");const S=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,S,this,this._logService,this._mainThreadTelemetryProxy,this._initData),o.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(d){return d.main}async _loadCommonJSModule(d,h,S){if(h.scheme!==g.Schemas.file)throw new Error(`Cannot load URI: '${h}', must be of file-scheme`);let E=null;S.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${h.toString(!0)}`),this._logService.flush();const p=d?.identifier.value;d&&await this._extHostLocalizationService.initializeLocalizedMessages(d);try{p&&o.mark(`code/extHost/willLoadExtensionCode/${p}`),E=oe.__$__nodeRequire(h.fsPath)}finally{p&&o.mark(`code/extHost/didLoadExtensionCode/${p}`),S.codeLoadingStop()}return E}async $setRemoteEnvironment(d){if(this._initData.remote.isRemote)for(const h in d){const S=d[h];S===null?delete process.env[h]:process.env[h]=S}}}e.ExtHostExtensionService=b}),define(De[329],Ie([1,0,91,302,314,313,326,328,303,86,43,87,84,42,57,81,301,300,17,315,50,228,90]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d,h,S,E,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(L.IExtHostExtensionService,P.ExtHostExtensionService,0),(0,o.registerSingleton)(h.ILoggerService,d.ExtHostLoggerService,1),(0,o.registerSingleton)(h.ILogService,new t.SyncDescriptor(p.ExtHostLogService,[!1],!0)),(0,o.registerSingleton)(b.IExtensionStoragePaths,i.ExtensionStoragePaths,0),(0,o.registerSingleton)(g.IExtHostDebugService,R.ExtHostDebugService,0),(0,o.registerSingleton)(I.IExtHostSearch,T.NativeExtHostSearch,0),(0,o.registerSingleton)(w.IExtHostTask,l.ExtHostTask,0),(0,o.registerSingleton)(k.IExtHostTerminalService,A.ExtHostTerminalService,0),(0,o.registerSingleton)(C.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,o.registerSingleton)(E.IExtHostVariableResolverProvider,S.NodeExtHostVariableResolverProviderService,0)}),define(De[340],Ie([1,0,132,341,85,8,119,147,216,97,312,22,29,116,19,121,235,247,317,329]),function(oe,e,o,A,l,R,T,P,y,g,L,I,w,k,C,b,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let _=0;_<process.execArgv.length;_++)process.execArgv[_]==="--inspect-port=0"&&(process.execArgv.splice(_,1),_--)}();const h=A(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const v=globalThis._VSCODE_NODE_MODULES.module,_=v._load;v._load=function(c){if(c==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return _.apply(this,arguments)}})();const S=process.exit.bind(process);function E(v){process.exit=function(_){if(v)S(_);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const _=new Error("An extension called process.crash() and this was prevented.");console.warn(_.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(v){S()};function t(){const v=(0,d.readExtHostConnection)(process.env);if(v.type===3)return new Promise((_,c)=>{const u=m=>{const f=m[0],n=new T.BufferedEmitter;f.on("message",D=>n.fire(I.VSBuffer.wrap(D.data))),f.on("close",()=>{p("renderer closed the MessagePort")}),f.start(),_({onMessage:n.event,send:D=>f.postMessage(D.buffer)})};process.parentPort.on("message",m=>u(m.ports))});if(v.type===2)return new Promise((_,c)=>{let u=null;const m=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),f=108e5,n=3e5,D=new C.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),f),M=new C.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),n);process.on("message",($,N)=>{if($&&$.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const U=I.VSBuffer.wrap(Buffer.from($.initialDataChunk,"base64"));let q;if($.skipWebSocketFrames)q=new P.NodeSocket(N,"extHost-socket");else{const F=I.VSBuffer.wrap(Buffer.from($.inflateBytes,"base64"));q=new P.WebSocketNodeSocket(new P.NodeSocket(N,"extHost-socket"),$.permessageDeflate,F,!1)}u?(D.cancel(),M.cancel(),u.beginAcceptReconnection(q,U),u.endAcceptReconnection(),u.sendResume()):(clearTimeout(m),u=new T.PersistentProtocol({socket:q,initialChunk:U}),u.sendResume(),u.onDidDispose(()=>p("renderer disconnected")),_(u),u.onSocketClose(()=>{D.schedule()}))}if($&&$.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(M.isScheduled())return;D.isScheduled()&&M.schedule()}});const W={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(W)});{const _=v.pipeName;return new Promise((c,u)=>{const m=o.createConnection(_,()=>{m.removeListener("error",u);const f=new T.PersistentProtocol({socket:new P.NodeSocket(m,"extHost-renderer")});f.sendResume(),c(f)});m.once("error",u),m.on("close",()=>{p("renderer closed the socket")})})}}async function s(){const v=await t();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,v.onMessage(_=>{(0,g.isMessageOfType)(_,2)?(this._terminating=!0,p("received terminate message from renderer")):this._onMessage.fire(_)})}send(_){this._terminating||v.send(_)}async drain(){if(v.drain)return v.drain()}}}function r(v){return new Promise(_=>{const c=v.onMessage(u=>{c.dispose();const m=JSON.parse(u.toString()),f=m.commit,n=y.default.commit;if(f&&n&&f!==n&&S(55),m.parentPid){let D=0;setInterval(function(){try{process.kill(m.parentPid,0),D=0}catch(W){W&&W.code==="EPERM"?(D++,D>=3&&p(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${W.message} (code: ${W.code}) (errno: ${W.errno})`)):p(`parent process ${m.parentPid} does not exist anymore: ${W.message} (code: ${W.code}) (errno: ${W.errno})`)}},1e3);let M;try{M=globalThis._VSCODE_NODE_MODULES["native-watchdog"],M.start(m.parentPid)}catch(W){(0,R.onUnexpectedError)(W)}}v.send((0,g.createMessageOfType)(0)),_({protocol:v,initData:m})});v.send((0,g.createMessageOfType)(1))})}async function a(){const v=[];process.on("unhandledRejection",(D,M)=>{v.push(M),setTimeout(()=>{const W=v.indexOf(M);W>=0&&M.catch($=>{v.splice(W,1),(0,R.isCancellationError)($)||(console.warn(`rejected promise not handled within 1 second: ${$}`),$&&$.stack&&console.warn(`stack trace: ${$.stack}`),D&&(0,R.onUnexpectedError)(D))})},1e3)}),process.on("rejectionHandled",D=>{const M=v.indexOf(D);M>=0&&v.splice(M,1)}),process.on("uncaughtException",function(D){(0,R.isSigPipeError)(D)||(0,R.onUnexpectedError)(D)}),l.mark("code/extHost/willConnectToRenderer");const _=await s();l.mark("code/extHost/didConnectToRenderer");const c=await r(_);l.mark("code/extHost/didWaitForInitData");const{initData:u}=c;E(!!u.environment.extensionTestsLocationURI),u.environment.useHostProxy=h.useHostProxy!==void 0?h.useHostProxy!=="false":void 0,u.environment.skipWorkspaceStorageLock=(0,b.boolean)(h.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(M){S(M)}exists(M){return w.Promises.exists(M)}realpath(M){return(0,k.realpath)(M)}};let f=null;u.remote.authority&&h.transformURIs&&(f=(0,i.createURITransformer)(u.remote.authority));const n=new L.ExtensionHostMain(c.protocol,u,m,f);p=D=>n.terminate(D)}a().catch(v=>console.log(v))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e06ea6147733c975d26c3d3552462681e05cb147/core/vs/workbench/api/node/extensionHostProcess.js.map
