/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Te=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostInteractiveSession","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Pe=function(te){for(var e=[],n=0,T=te.length;n<T;n++)e[n]=Te[te[n]];return e};define(Te[64],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(A,P){const S=Object.create(null);for(const h of A){const R=P(h);let b=S[R];b||(b=S[R]=[]),b.push(h)}return S}e.groupBy=n;function T(A,P){const S=[],h=[];for(const R of A)P.has(R)||S.push(R);for(const R of P)A.has(R)||h.push(R);return{removed:S,added:h}}e.diffSets=T;function D(A,P){const S=[],h=[];for(const[R,b]of A)P.has(R)||S.push(b);for(const[R,b]of P)A.has(R)||h.push(b);return{removed:S,added:h}}e.diffMaps=D;class F{constructor(){this.map=new Map}add(P,S){let h=this.map.get(P);h||(h=new Set,this.map.set(P,h)),h.add(S)}delete(P,S){const h=this.map.get(P);h&&(h.delete(S),h.size===0&&this.map.delete(P))}forEach(P,S){const h=this.map.get(P);h&&h.forEach(S)}}e.SetMap=F}),define(Te[65],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(A){return(P,S,h)=>{let R=null,b=null;if(typeof h.value=="function"?(R="value",b=h.value):typeof h.get=="function"&&(R="get",b=h.get),!b)throw new Error("not supported");h[R]=A(b,S)}}function T(A,P,S){let h=null,R=null;if(typeof S.value=="function"?(h="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(h="get",R=S.get),!R)throw new Error("not supported");const b=`$memoize$${P}`;S[h]=function(...g){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,g)}),this[b]}}e.memoize=T;function D(A,P,S){return n((h,R)=>{const b=`$debounce$${R}`,g=`$debounce$result$${R}`;return function(..._){this[g]||(this[g]=S?S():void 0),clearTimeout(this[b]),P&&(this[g]=P(this[g],..._),_=[this[g]]),this[b]=setTimeout(()=>{h.apply(this,_),this[g]=S?S():void 0},A)}})}e.debounce=D;function F(A,P,S){return n((h,R)=>{const b=`$throttle$timer$${R}`,g=`$throttle$result$${R}`,_=`$throttle$lastRun$${R}`,p=`$throttle$pending$${R}`;return function(...u){if(this[g]||(this[g]=S?S():void 0),(this[_]===null||this[_]===void 0)&&(this[_]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...u)),this[p])return;const t=this[_]+A;t<=Date.now()?(this[_]=Date.now(),h.apply(this,[this[g]]),this[g]=S?S():void 0):(this[p]=!0,this[b]=setTimeout(()=>{this[p]=!1,this[_]=Date.now(),h.apply(this,[this[g]]),this[g]=S?S():void 0},t-Date.now()))}})}e.throttle=F}),define(Te[84],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Te[114],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var F;(function(i){i.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function A(i,a=!1){let r=0;const s=i.length;let w="",I=0,c=16,l=0;function m(U){let B=0,G=0;for(;B<U;){const N=i.charCodeAt(r);if(N>=48&&N<=57)G=G*16+N-48;else if(N>=65&&N<=70)G=G*16+N-65+10;else if(N>=97&&N<=102)G=G*16+N-97+10;else break;r++,B++}return B<U&&(G=-1),G}function E(U){r=U,w="",I=0,c=16,l=0}function f(){const U=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&h(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&h(i.charCodeAt(r)))for(r++;r<i.length&&h(i.charCodeAt(r));)r++;else return l=3,i.substring(U,r);let B=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&h(i.charCodeAt(r))){for(r++;r<i.length&&h(i.charCodeAt(r));)r++;B=r}else l=3;return i.substring(U,B)}function L(){let U="",B=r;for(;;){if(r>=s){U+=i.substring(B,r),l=2;break}const G=i.charCodeAt(r);if(G===34){U+=i.substring(B,r),r++;break}if(G===92){if(U+=i.substring(B,r),r++,r>=s){l=2;break}switch(i.charCodeAt(r++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const H=m(4);H>=0?U+=String.fromCharCode(H):l=4;break}default:l=5}B=r;continue}if(G>=0&&G<=31)if(S(G)){U+=i.substring(B,r),l=2;break}else l=6;r++}return U}function W(){if(w="",l=0,I=r,r>=s)return I=s,c=17;let U=i.charCodeAt(r);if(P(U)){do r++,w+=String.fromCharCode(U),U=i.charCodeAt(r);while(P(U));return c=15}if(S(U))return r++,w+=String.fromCharCode(U),U===13&&i.charCodeAt(r)===10&&(r++,w+=`
`),c=14;switch(U){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,w=L(),c=10;case 47:{const B=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<s&&!S(i.charCodeAt(r));)r++;return w=i.substring(B,r),c=12}if(i.charCodeAt(r+1)===42){r+=2;const G=s-1;let N=!1;for(;r<G;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,N=!0;break}r++}return N||(r++,l=1),w=i.substring(B,r),c=13}return w+=String.fromCharCode(U),r++,c=16}case 45:if(w+=String.fromCharCode(U),r++,r===s||!h(i.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=f(),c=11;default:for(;r<s&&J(U);)r++,U=i.charCodeAt(r);if(I!==r){switch(w=i.substring(I,r),w){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return w+=String.fromCharCode(U),r++,c=16}}function J(U){if(P(U)||S(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let U;do U=W();while(U>=12&&U<=15);return U}return{setPosition:E,getPosition:()=>r,scan:a?q:W,getToken:()=>c,getTokenValue:()=>w,getTokenOffset:()=>I,getTokenLength:()=>r-I,getTokenError:()=>l}}e.createScanner=A;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function h(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function b(i,a){const r=[],s=new Object;let w;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function l(m,E,f,L){I.value=m,I.offset=E,I.length=f,I.type=L,I.colonOffset=void 0,w=I}try{y(i,{onObjectBegin:(m,E)=>{if(a<=m)throw s;w=void 0,c=a>m,r.push("")},onObjectProperty:(m,E,f)=>{if(a<E||(l(m,E,f,"property"),r[r.length-1]=m,a<=E+f))throw s},onObjectEnd:(m,E)=>{if(a<=m)throw s;w=void 0,r.pop()},onArrayBegin:(m,E)=>{if(a<=m)throw s;w=void 0,r.push(0)},onArrayEnd:(m,E)=>{if(a<=m)throw s;w=void 0,r.pop()},onLiteralValue:(m,E,f)=>{if(a<E||(l(m,E,f,v(m)),a<=E+f))throw s},onSeparator:(m,E,f)=>{if(a<=E)throw s;if(m===":"&&w&&w.type==="property")w.colonOffset=E,c=!1,w=void 0;else if(m===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(c=!0,r[r.length-1]=""),w=void 0}}})}catch(m){if(m!==s)throw m}return{path:r,previousNode:w,isAtPropertyKey:c,matches:m=>{let E=0;for(let f=0;E<m.length&&f<r.length;f++)if(m[E]===r[f]||m[E]==="*")E++;else if(m[E]!=="**")return!1;return E===m.length}}}e.getLocation=b;function g(i,a=[],r=F.DEFAULT){let s=null,w=[];const I=[];function c(m){Array.isArray(w)?w.push(m):s!==null&&(w[s]=m)}return y(i,{onObjectBegin:()=>{const m={};c(m),I.push(w),w=m,s=null},onObjectProperty:m=>{s=m},onObjectEnd:()=>{w=I.pop()},onArrayBegin:()=>{const m=[];c(m),I.push(w),w=m,s=null},onArrayEnd:()=>{w=I.pop()},onLiteralValue:c,onError:(m,E,f)=>{a.push({error:m,offset:E,length:f})}},r),w[0]}e.parse=g;function _(i,a=[],r=F.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(m){s.type==="property"&&(s.length=m-s.offset,s=s.parent)}function I(m){return s.children.push(m),m}y(i,{onObjectBegin:m=>{s=I({type:"object",offset:m,length:-1,parent:s,children:[]})},onObjectProperty:(m,E,f)=>{s=I({type:"property",offset:E,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:m,offset:E,length:f,parent:s})},onObjectEnd:(m,E)=>{s.length=m+E-s.offset,s=s.parent,w(m+E)},onArrayBegin:(m,E)=>{s=I({type:"array",offset:m,length:-1,parent:s,children:[]})},onArrayEnd:(m,E)=>{s.length=m+E-s.offset,s=s.parent,w(m+E)},onLiteralValue:(m,E,f)=>{I({type:v(m),offset:E,length:f,parent:s,value:m}),w(E+f)},onSeparator:(m,E,f)=>{s.type==="property"&&(m===":"?s.colonOffset=E:m===","&&w(E))},onError:(m,E,f)=>{a.push({error:m,offset:E,length:f})}},r);const l=s.children[0];return l&&delete l.parent,l}e.parseTree=_;function p(i,a){if(!i)return;let r=i;for(const s of a)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let w=!1;for(const I of r.children)if(Array.isArray(I.children)&&I.children[0].value===s){r=I.children[1],w=!0;break}if(!w)return}else{const w=s;if(r.type!=="array"||w<0||!Array.isArray(r.children)||w>=r.children.length)return;r=r.children[w]}return r}e.findNodeAtLocation=p;function u(i){if(!i.parent||!i.parent.children)return[];const a=u(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;a.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&a.push(r)}return a}e.getNodePath=u;function t(i){switch(i.type){case"array":return i.children.map(t);case"object":{const a=Object.create(null);for(const r of i.children){const s=r.children[1];s&&(a[r.children[0].value]=t(s))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=t;function o(i,a,r=!1){return a>=i.offset&&a<i.offset+i.length||r&&a===i.offset+i.length}e.contains=o;function d(i,a,r=!1){if(o(i,a,r)){const s=i.children;if(Array.isArray(s))for(let w=0;w<s.length&&s[w].offset<=a;w++){const I=d(s[w],a,r);if(I)return I}return i}}e.findNodeAtOffset=d;function y(i,a,r=F.DEFAULT){const s=A(i,!1);function w(Ae){return Ae?()=>Ae(s.getTokenOffset(),s.getTokenLength()):()=>!0}function I(Ae){return Ae?ue=>Ae(ue,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=w(a.onObjectBegin),l=I(a.onObjectProperty),m=w(a.onObjectEnd),E=w(a.onArrayBegin),f=w(a.onArrayEnd),L=I(a.onLiteralValue),W=I(a.onSeparator),J=w(a.onComment),q=I(a.onError),U=r&&r.disallowComments,B=r&&r.allowTrailingComma;function G(){for(;;){const Ae=s.scan();switch(s.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:U||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(Ae){case 12:case 13:U?N(10):J();break;case 16:N(1);break;case 15:case 14:break;default:return Ae}}}function N(Ae,ue=[],le=[]){if(q(Ae),ue.length+le.length>0){let $=s.getToken();for(;$!==17;){if(ue.indexOf($)!==-1){G();break}else if(le.indexOf($)!==-1)break;$=G()}}}function H(Ae){const ue=s.getTokenValue();return Ae?L(ue):l(ue),G(),!0}function Q(){switch(s.getToken()){case 11:{let Ae=0;try{Ae=JSON.parse(s.getTokenValue()),typeof Ae!="number"&&(N(2),Ae=0)}catch{N(2)}L(Ae);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return G(),!0}function pe(){return s.getToken()!==10?(N(3,[],[2,5]),!1):(H(!1),s.getToken()===6?(W(":"),G(),de()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function we(){c(),G();let Ae=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(Ae||N(4,[],[]),W(","),G(),s.getToken()===2&&B)break}else Ae&&N(6,[],[]);pe()||N(4,[],[2,5]),Ae=!0}return m(),s.getToken()!==2?N(7,[2],[]):G(),!0}function he(){E(),G();let Ae=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(Ae||N(4,[],[]),W(","),G(),s.getToken()===4&&B)break}else Ae&&N(6,[],[]);de()||N(4,[],[4,5]),Ae=!0}return f(),s.getToken()!==4?N(8,[4],[]):G(),!0}function de(){switch(s.getToken()){case 3:return he();case 1:return we();case 10:return H(!0);default:return Q()}}return G(),s.getToken()===17?r.allowEmptyContent?!0:(N(4,[],[]),!1):de()?(s.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=y;function k(i,a){const r=A(i),s=[];let w,I=0,c;do switch(c=r.getPosition(),w=r.scan(),w){case 12:case 13:case 17:I!==c&&s.push(i.substring(I,c)),a!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,a)),I=r.getPosition();break}while(w!==17);return s.join("")}e.stripComments=k;function v(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Te[28],Pe([1,0]),function(te,e){"use strict";var n,T,D;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function F(u,t,o){let d=u.get(t);return d===void 0&&(d=o,u.set(t,d)),d}e.getOrSet=F;function A(u){const t=[];return u.forEach((o,d)=>{t.push(`${d} => ${o}`)}),`Map(${u.size}) {${t.join(", ")}}`}e.mapToString=A;function P(u){const t=[];return u.forEach(o=>{t.push(o)}),`Set(${u.size}) {${t.join(", ")}}`}e.setToString=P;class S{constructor(t,o){this.uri=t,this.value=o}}class h{constructor(t,o){this[n]="ResourceMap",t instanceof h?(this.map=new Map(t.map),this.toKey=o??h.defaultToKey):(this.map=new Map,this.toKey=t??h.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new S(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[d,y]of this.map)t(y.value,y.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=h,h.defaultToKey=u=>u.toString();class R{constructor(t,o){this[T]="ResourceSet",!t||typeof t=="function"?this._map=new h(t):(this._map=new h(o),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,o){this._map.forEach((d,y)=>t.call(o,y,y,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var b;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class g{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const d=this._map.get(t);if(d)return o!==0&&this.touch(d,o),d.value}set(t,o,d=0){let y=this._map.get(t);if(y)y.value=o,d!==0&&this.touch(y,d);else{switch(y={key:t,value:o,next:void 0,previous:void 0},d){case 0:this.addItemLast(y);break;case 1:this.addItemFirst(y);break;case 2:this.addItemLast(y);break;default:this.addItemLast(y);break}this._map.set(t,y),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const d=this._state;let y=this._head;for(;y;){if(o?t.bind(o)(y.value,y.key,this):t(y.value,y.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const t=this,o=this._state;let d=this._head;const y={[Symbol.iterator](){return y},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const k={value:d.key,done:!1};return d=d.next,k}else return{value:void 0,done:!0}}};return y}values(){const t=this,o=this._state;let d=this._head;const y={[Symbol.iterator](){return y},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const k={value:d.value,done:!1};return d=d.next,k}else return{value:void 0,done:!0}}};return y}entries(){const t=this,o=this._state;let d=this._head;const y={[Symbol.iterator](){return y},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const k={value:[d.key,d.value],done:!1};return d=d.next,k}else return{value:void 0,done:!0}}};return y}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,d=this.size;for(;o&&d>t;)this._map.delete(o.key),o=o.next,d--;this._head=o,this._size=d,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,d=t.previous;if(!o||!d)throw new Error("Invalid list");o.previous=d,d.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const d=t.next,y=t.previous;t===this._tail?(y.next=void 0,this._tail=y):(d.previous=y,y.next=d),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const d=t.next,y=t.previous;t===this._head?(d.previous=void 0,this._head=d):(d.previous=y,y.next=d),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,d)=>{t.push([d,o])}),t}fromJSON(t){this.clear();for(const[o,d]of t)this.set(o,d)}}e.LinkedMap=g;class _ extends g{constructor(t,o=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=_;class p{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let o=this.map.get(t)||0;return o===0?!1:(o--,o===0?this.map.delete(t):this.map.set(t,o),!0)}has(t){return this.map.has(t)}}e.CounterSet=p}),function(te,e){typeof define=="function"&&define.amd?define(Te[115],Pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(ye,Ee){for(var Ie=0;Ie<Ee.length;Ie++){var oe=Ee[Ie];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(ye,oe.key,oe)}}function n(ye,Ee,Ie){return Ee&&e(ye.prototype,Ee),Ie&&e(ye,Ie),Object.defineProperty(ye,"prototype",{writable:!1}),ye}function T(ye,Ee){if(ye){if(typeof ye=="string")return D(ye,Ee);var Ie=Object.prototype.toString.call(ye).slice(8,-1);if(Ie==="Object"&&ye.constructor&&(Ie=ye.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(ye);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return D(ye,Ee)}}function D(ye,Ee){(Ee==null||Ee>ye.length)&&(Ee=ye.length);for(var Ie=0,oe=new Array(Ee);Ie<Ee;Ie++)oe[Ie]=ye[Ie];return oe}function F(ye,Ee){var Ie=typeof Symbol<"u"&&ye[Symbol.iterator]||ye["@@iterator"];if(Ie)return(Ie=Ie.call(ye)).next.bind(Ie);if(Array.isArray(ye)||(Ie=T(ye))||Ee&&ye&&typeof ye.length=="number"){Ie&&(ye=Ie);var oe=0;return function(){return oe>=ye.length?{done:!0}:{done:!1,value:ye[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=A();function P(ye){te.defaults=ye}var S=/[&<>"']/,h=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},_=function(Ee){return g[Ee]};function p(ye,Ee){if(Ee){if(S.test(ye))return ye.replace(h,_)}else if(R.test(ye))return ye.replace(b,_);return ye}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ye){return ye.replace(u,function(Ee,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var o=/(^|[^\[])\^/g;function d(ye,Ee){ye=typeof ye=="string"?ye:ye.source,Ee=Ee||"";var Ie={replace:function(ce,ie){return ie=ie.source||ie,ie=ie.replace(o,"$1"),ye=ye.replace(ce,ie),Ie},getRegex:function(){return new RegExp(ye,Ee)}};return Ie}var y=/[^\w:]/g,k=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(ye,Ee,Ie){if(ye){var oe;try{oe=decodeURIComponent(t(Ie)).replace(y,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Ee&&!k.test(Ie)&&(Ie=w(Ee,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch{return null}return Ie}var i={},a=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(ye,Ee){i[" "+ye]||(a.test(ye)?i[" "+ye]=ye+"/":i[" "+ye]=m(ye,"/",!0)),ye=i[" "+ye];var Ie=ye.indexOf(":")===-1;return Ee.substring(0,2)==="//"?Ie?Ee:ye.replace(r,"$1")+Ee:Ee.charAt(0)==="/"?Ie?Ee:ye.replace(s,"$1")+Ee:ye+Ee}var I={exec:function(){}};function c(ye){for(var Ee=1,Ie,oe;Ee<arguments.length;Ee++){Ie=arguments[Ee];for(oe in Ie)Object.prototype.hasOwnProperty.call(Ie,oe)&&(ye[oe]=Ie[oe])}return ye}function l(ye,Ee){var Ie=ye.replace(/\|/g,function(ie,ne,C){for(var z=!1,V=ne;--V>=0&&C[V]==="\\";)z=!z;return z?"|":" |"}),oe=Ie.split(/ \|/),ce=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>Ee)oe.splice(Ee);else for(;oe.length<Ee;)oe.push("");for(;ce<oe.length;ce++)oe[ce]=oe[ce].trim().replace(/\\\|/g,"|");return oe}function m(ye,Ee,Ie){var oe=ye.length;if(oe===0)return"";for(var ce=0;ce<oe;){var ie=ye.charAt(oe-ce-1);if(ie===Ee&&!Ie)ce++;else if(ie!==Ee&&Ie)ce++;else break}return ye.slice(0,oe-ce)}function E(ye,Ee){if(ye.indexOf(Ee[1])===-1)return-1;for(var Ie=ye.length,oe=0,ce=0;ce<Ie;ce++)if(ye[ce]==="\\")ce++;else if(ye[ce]===Ee[0])oe++;else if(ye[ce]===Ee[1]&&(oe--,oe<0))return ce;return-1}function f(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(ye,Ee){if(Ee<1)return"";for(var Ie="";Ee>1;)Ee&1&&(Ie+=ye),Ee>>=1,ye+=ye;return Ie+ye}function W(ye,Ee,Ie,oe){var ce=Ee.href,ie=Ee.title?p(Ee.title):null,ne=ye[1].replace(/\\([\[\]])/g,"$1");if(ye[0].charAt(0)!=="!"){oe.state.inLink=!0;var C={type:"link",raw:Ie,href:ce,title:ie,text:ne,tokens:oe.inlineTokens(ne)};return oe.state.inLink=!1,C}return{type:"image",raw:Ie,href:ce,title:ie,text:p(ne)}}function J(ye,Ee){var Ie=ye.match(/^(\s+)(?:```)/);if(Ie===null)return Ee;var oe=Ie[1];return Ee.split(`
`).map(function(ce){var ie=ce.match(/^\s+/);if(ie===null)return ce;var ne=ie[0];return ne.length>=oe.length?ce.slice(oe.length):ce}).join(`
`)}var q=function(){function ye(Ie){this.options=Ie||te.defaults}var Ee=ye.prototype;return Ee.space=function(oe){var ce=this.rules.block.newline.exec(oe);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},Ee.code=function(oe){var ce=this.rules.block.code.exec(oe);if(ce){var ie=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:m(ie,`
`)}}},Ee.fences=function(oe){var ce=this.rules.block.fences.exec(oe);if(ce){var ie=ce[0],ne=J(ie,ce[3]||"");return{type:"code",raw:ie,lang:ce[2]?ce[2].trim():ce[2],text:ne}}},Ee.heading=function(oe){var ce=this.rules.block.heading.exec(oe);if(ce){var ie=ce[2].trim();if(/#$/.test(ie)){var ne=m(ie,"#");(this.options.pedantic||!ne||/ $/.test(ne))&&(ie=ne.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:ie,tokens:this.lexer.inline(ie)}}},Ee.hr=function(oe){var ce=this.rules.block.hr.exec(oe);if(ce)return{type:"hr",raw:ce[0]}},Ee.blockquote=function(oe){var ce=this.rules.block.blockquote.exec(oe);if(ce){var ie=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},Ee.list=function(oe){var ce=this.rules.block.list.exec(oe);if(ce){var ie,ne,C,z,V,j,ae,ge,ee,be,Se,xe,He=ce[1].trim(),et=He.length>1,Qe={type:"list",raw:"",ordered:et,start:et?+He.slice(0,-1):"",loose:!1,items:[]};He=et?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=et?He:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(xe=!1,!(!(ce=Ye.exec(oe))||this.rules.block.hr.test(oe)));){if(ie=ce[0],oe=oe.substring(ie.length),ge=ce[2].split(`
`,1)[0],ee=oe.split(`
`,1)[0],this.options.pedantic?(z=2,Se=ge.trimLeft()):(z=ce[2].search(/[^ ]/),z=z>4?1:z,Se=ge.slice(z),z+=ce[1].length),j=!1,!ge&&/^ *$/.test(ee)&&(ie+=ee+`
`,oe=oe.substring(ee.length+1),xe=!0),!xe)for(var rt=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),lt=new RegExp("^ {0,"+Math.min(3,z-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,z-1)+"}#");oe&&(be=oe.split(`
`,1)[0],ge=be,this.options.pedantic&&(ge=ge.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(ge)||st.test(ge)||rt.test(ge)||lt.test(oe)));){if(ge.search(/[^ ]/)>=z||!ge.trim())Se+=`
`+ge.slice(z);else if(!j)Se+=`
`+ge;else break;!j&&!ge.trim()&&(j=!0),ie+=be+`
`,oe=oe.substring(be.length+1)}Qe.loose||(ae?Qe.loose=!0:/\n *\n *$/.test(ie)&&(ae=!0)),this.options.gfm&&(ne=/^\[[ xX]\] /.exec(Se),ne&&(C=ne[0]!=="[ ] ",Se=Se.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ie,task:!!ne,checked:C,loose:!1,text:Se}),Qe.raw+=ie}Qe.items[Qe.items.length-1].raw=ie.trimRight(),Qe.items[Qe.items.length-1].text=Se.trimRight(),Qe.raw=Qe.raw.trimRight();var Z=Qe.items.length;for(V=0;V<Z;V++){this.lexer.state.top=!1,Qe.items[V].tokens=this.lexer.blockTokens(Qe.items[V].text,[]);var Y=Qe.items[V].tokens.filter(function(Ne){return Ne.type==="space"}),_e=Y.every(function(Ne){for(var ze=Ne.raw.split(""),Xe=0,We=F(ze),it;!(it=We()).done;){var wt=it.value;if(wt===`
`&&(Xe+=1),Xe>1)return!0}return!1});!Qe.loose&&Y.length&&_e&&(Qe.loose=!0,Qe.items[V].loose=!0)}return Qe}},Ee.html=function(oe){var ce=this.rules.block.html.exec(oe);if(ce){var ie={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var ne=this.options.sanitizer?this.options.sanitizer(ce[0]):p(ce[0]);ie.type="paragraph",ie.text=ne,ie.tokens=this.lexer.inline(ne)}return ie}},Ee.def=function(oe){var ce=this.rules.block.def.exec(oe);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ie=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:ce[0],href:ce[2],title:ce[3]}}},Ee.table=function(oe){var ce=this.rules.block.table.exec(oe);if(ce){var ie={type:"table",header:l(ce[1]).map(function(ae){return{text:ae}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=ce[0];var ne=ie.align.length,C,z,V,j;for(C=0;C<ne;C++)/^ *-+: *$/.test(ie.align[C])?ie.align[C]="right":/^ *:-+: *$/.test(ie.align[C])?ie.align[C]="center":/^ *:-+ *$/.test(ie.align[C])?ie.align[C]="left":ie.align[C]=null;for(ne=ie.rows.length,C=0;C<ne;C++)ie.rows[C]=l(ie.rows[C],ie.header.length).map(function(ae){return{text:ae}});for(ne=ie.header.length,z=0;z<ne;z++)ie.header[z].tokens=this.lexer.inline(ie.header[z].text);for(ne=ie.rows.length,z=0;z<ne;z++)for(j=ie.rows[z],V=0;V<j.length;V++)j[V].tokens=this.lexer.inline(j[V].text);return ie}}},Ee.lheading=function(oe){var ce=this.rules.block.lheading.exec(oe);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},Ee.paragraph=function(oe){var ce=this.rules.block.paragraph.exec(oe);if(ce){var ie=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:ie,tokens:this.lexer.inline(ie)}}},Ee.text=function(oe){var ce=this.rules.block.text.exec(oe);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},Ee.escape=function(oe){var ce=this.rules.inline.escape.exec(oe);if(ce)return{type:"escape",raw:ce[0],text:p(ce[1])}},Ee.tag=function(oe){var ce=this.rules.inline.tag.exec(oe);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):p(ce[0]):ce[0]}},Ee.link=function(oe){var ce=this.rules.inline.link.exec(oe);if(ce){var ie=ce[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var ne=m(ie.slice(0,-1),"\\");if((ie.length-ne.length)%2===0)return}else{var C=E(ce[2],"()");if(C>-1){var z=ce[0].indexOf("!")===0?5:4,V=z+ce[1].length+C;ce[2]=ce[2].substring(0,C),ce[0]=ce[0].substring(0,V).trim(),ce[3]=""}}var j=ce[2],ae="";if(this.options.pedantic){var ge=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);ge&&(j=ge[1],ae=ge[3])}else ae=ce[3]?ce[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(ie)?j=j.slice(1):j=j.slice(1,-1)),W(ce,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:ae&&ae.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},Ee.reflink=function(oe,ce){var ie;if((ie=this.rules.inline.reflink.exec(oe))||(ie=this.rules.inline.nolink.exec(oe))){var ne=(ie[2]||ie[1]).replace(/\s+/g," ");if(ne=ce[ne.toLowerCase()],!ne||!ne.href){var C=ie[0].charAt(0);return{type:"text",raw:C,text:C}}return W(ie,ne,ie[0],this.lexer)}},Ee.emStrong=function(oe,ce,ie){ie===void 0&&(ie="");var ne=this.rules.inline.emStrong.lDelim.exec(oe);if(ne&&!(ne[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var C=ne[1]||ne[2]||"";if(!C||C&&(ie===""||this.rules.inline.punctuation.exec(ie))){var z=ne[0].length-1,V,j,ae=z,ge=0,ee=ne[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ee.lastIndex=0,ce=ce.slice(-1*oe.length+z);(ne=ee.exec(ce))!=null;)if(V=ne[1]||ne[2]||ne[3]||ne[4]||ne[5]||ne[6],!!V){if(j=V.length,ne[3]||ne[4]){ae+=j;continue}else if((ne[5]||ne[6])&&z%3&&!((z+j)%3)){ge+=j;continue}if(ae-=j,!(ae>0)){if(j=Math.min(j,j+ae+ge),Math.min(z,j)%2){var be=oe.slice(1,z+ne.index+j);return{type:"em",raw:oe.slice(0,z+ne.index+j+1),text:be,tokens:this.lexer.inlineTokens(be)}}var Se=oe.slice(2,z+ne.index+j-1);return{type:"strong",raw:oe.slice(0,z+ne.index+j+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}}}}},Ee.codespan=function(oe){var ce=this.rules.inline.code.exec(oe);if(ce){var ie=ce[2].replace(/\n/g," "),ne=/[^ ]/.test(ie),C=/^ /.test(ie)&&/ $/.test(ie);return ne&&C&&(ie=ie.substring(1,ie.length-1)),ie=p(ie,!0),{type:"codespan",raw:ce[0],text:ie}}},Ee.br=function(oe){var ce=this.rules.inline.br.exec(oe);if(ce)return{type:"br",raw:ce[0]}},Ee.del=function(oe){var ce=this.rules.inline.del.exec(oe);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},Ee.autolink=function(oe,ce){var ie=this.rules.inline.autolink.exec(oe);if(ie){var ne,C;return ie[2]==="@"?(ne=p(this.options.mangle?ce(ie[1]):ie[1]),C="mailto:"+ne):(ne=p(ie[1]),C=ne),{type:"link",raw:ie[0],text:ne,href:C,tokens:[{type:"text",raw:ne,text:ne}]}}},Ee.url=function(oe,ce){var ie;if(ie=this.rules.inline.url.exec(oe)){var ne,C;if(ie[2]==="@")ne=p(this.options.mangle?ce(ie[0]):ie[0]),C="mailto:"+ne;else{var z;do z=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(z!==ie[0]);ne=p(ie[0]),ie[1]==="www."?C="http://"+ne:C=ne}return{type:"link",raw:ie[0],text:ne,href:C,tokens:[{type:"text",raw:ne,text:ne}]}}},Ee.inlineText=function(oe,ce){var ie=this.rules.inline.text.exec(oe);if(ie){var ne;return this.lexer.state.inRawBlock?ne=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):p(ie[0]):ie[0]:ne=p(this.options.smartypants?ce(ie[0]):ie[0]),{type:"text",raw:ie[0],text:ne}}},ye}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=d(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=d(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=d(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=d(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=d(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=d(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=c({},U),U.gfm=c({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=d(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=d(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=c({},U.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:d(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=d(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=d(U._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=d(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=d(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=d(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=d(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=d(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=d(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=d(B.reflink).replace("label",B._label).replace("ref",U._label).getRegex(),B.nolink=d(B.nolink).replace("ref",U._label).getRegex(),B.reflinkSearch=d(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=c({},B),B.pedantic=c({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=c({},B.normal,{escape:d(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=d(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=c({},B.gfm,{br:d(B.br).replace("{2,}","*").getRegex(),text:d(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function G(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function N(ye){var Ee="",Ie,oe,ce=ye.length;for(Ie=0;Ie<ce;Ie++)oe=ye.charCodeAt(Ie),Math.random()>.5&&(oe="x"+oe.toString(16)),Ee+="&#"+oe+";";return Ee}var H=function(){function ye(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||te.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:U.normal,inline:B.normal};this.options.pedantic?(oe.block=U.pedantic,oe.inline=B.pedantic):this.options.gfm&&(oe.block=U.gfm,this.options.breaks?oe.inline=B.breaks:oe.inline=B.gfm),this.tokenizer.rules=oe}ye.lex=function(oe,ce){var ie=new ye(ce);return ie.lex(oe)},ye.lexInline=function(oe,ce){var ie=new ye(ce);return ie.inlineTokens(oe)};var Ee=ye.prototype;return Ee.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},Ee.blockTokens=function(oe,ce){var ie=this;ce===void 0&&(ce=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(ae,ge,ee){return ge+"    ".repeat(ee.length)});for(var ne,C,z,V;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ae){return(ne=ae.call({lexer:ie},oe,ce))?(oe=oe.substring(ne.raw.length),ce.push(ne),!0):!1}))){if(ne=this.tokenizer.space(oe)){oe=oe.substring(ne.raw.length),ne.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(ne);continue}if(ne=this.tokenizer.code(oe)){oe=oe.substring(ne.raw.length),C=ce[ce.length-1],C&&(C.type==="paragraph"||C.type==="text")?(C.raw+=`
`+ne.raw,C.text+=`
`+ne.text,this.inlineQueue[this.inlineQueue.length-1].src=C.text):ce.push(ne);continue}if(ne=this.tokenizer.fences(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.heading(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.hr(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.blockquote(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.list(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.html(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.def(oe)){oe=oe.substring(ne.raw.length),C=ce[ce.length-1],C&&(C.type==="paragraph"||C.type==="text")?(C.raw+=`
`+ne.raw,C.text+=`
`+ne.raw,this.inlineQueue[this.inlineQueue.length-1].src=C.text):this.tokens.links[ne.tag]||(this.tokens.links[ne.tag]={href:ne.href,title:ne.title});continue}if(ne=this.tokenizer.table(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.lheading(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(z=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var ae=1/0,ge=oe.slice(1),ee=void 0;ie.options.extensions.startBlock.forEach(function(be){ee=be.call({lexer:this},ge),typeof ee=="number"&&ee>=0&&(ae=Math.min(ae,ee))}),ae<1/0&&ae>=0&&(z=oe.substring(0,ae+1))}(),this.state.top&&(ne=this.tokenizer.paragraph(z))){C=ce[ce.length-1],V&&C.type==="paragraph"?(C.raw+=`
`+ne.raw,C.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=C.text):ce.push(ne),V=z.length!==oe.length,oe=oe.substring(ne.raw.length);continue}if(ne=this.tokenizer.text(oe)){oe=oe.substring(ne.raw.length),C=ce[ce.length-1],C&&C.type==="text"?(C.raw+=`
`+ne.raw,C.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=C.text):ce.push(ne);continue}if(oe){var j="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,ce},Ee.inline=function(oe,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:oe,tokens:ce}),ce},Ee.inlineTokens=function(oe,ce){var ie=this;ce===void 0&&(ce=[]);var ne,C,z,V=oe,j,ae,ge;if(this.tokens.links){var ee=Object.keys(this.tokens.links);if(ee.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)ee.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,j.index)+"["+L("a",j[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,j.index)+"["+L("a",j[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,j.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(ae||(ge=""),ae=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Se){return(ne=Se.call({lexer:ie},oe,ce))?(oe=oe.substring(ne.raw.length),ce.push(ne),!0):!1}))){if(ne=this.tokenizer.escape(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.tag(oe)){oe=oe.substring(ne.raw.length),C=ce[ce.length-1],C&&ne.type==="text"&&C.type==="text"?(C.raw+=ne.raw,C.text+=ne.text):ce.push(ne);continue}if(ne=this.tokenizer.link(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ne.raw.length),C=ce[ce.length-1],C&&ne.type==="text"&&C.type==="text"?(C.raw+=ne.raw,C.text+=ne.text):ce.push(ne);continue}if(ne=this.tokenizer.emStrong(oe,V,ge)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.codespan(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.br(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.del(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.autolink(oe,N)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(!this.state.inLink&&(ne=this.tokenizer.url(oe,N))){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(z=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var Se=1/0,xe=oe.slice(1),He=void 0;ie.options.extensions.startInline.forEach(function(et){He=et.call({lexer:this},xe),typeof He=="number"&&He>=0&&(Se=Math.min(Se,He))}),Se<1/0&&Se>=0&&(z=oe.substring(0,Se+1))}(),ne=this.tokenizer.inlineText(z,G)){oe=oe.substring(ne.raw.length),ne.raw.slice(-1)!=="_"&&(ge=ne.raw.slice(-1)),ae=!0,C=ce[ce.length-1],C&&C.type==="text"?(C.raw+=ne.raw,C.text+=ne.text):ce.push(ne);continue}if(oe){var be="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ce},n(ye,null,[{key:"rules",get:function(){return{block:U,inline:B}}}]),ye}(),Q=function(){function ye(Ie){this.options=Ie||te.defaults}var Ee=ye.prototype;return Ee.code=function(oe,ce,ie){var ne=(ce||"").match(/\S*/)[0];if(this.options.highlight){var C=this.options.highlight(oe,ne);C!=null&&C!==oe&&(ie=!0,oe=C)}return oe=oe.replace(/\n$/,"")+`
`,ne?'<pre><code class="'+this.options.langPrefix+p(ne,!0)+'">'+(ie?oe:p(oe,!0))+`</code></pre>
`:"<pre><code>"+(ie?oe:p(oe,!0))+`</code></pre>
`},Ee.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Ee.html=function(oe){return oe},Ee.heading=function(oe,ce,ie,ne){if(this.options.headerIds){var C=this.options.headerPrefix+ne.slug(ie);return"<h"+ce+' id="'+C+'">'+oe+"</h"+ce+`>
`}return"<h"+ce+">"+oe+"</h"+ce+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(oe,ce,ie){var ne=ce?"ol":"ul",C=ce&&ie!==1?' start="'+ie+'"':"";return"<"+ne+C+`>
`+oe+"</"+ne+`>
`},Ee.listitem=function(oe){return"<li>"+oe+`</li>
`},Ee.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(oe){return"<p>"+oe+`</p>
`},Ee.table=function(oe,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ce+`</table>
`},Ee.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Ee.tablecell=function(oe,ce){var ie=ce.header?"th":"td",ne=ce.align?"<"+ie+' align="'+ce.align+'">':"<"+ie+">";return ne+oe+("</"+ie+`>
`)},Ee.strong=function(oe){return"<strong>"+oe+"</strong>"},Ee.em=function(oe){return"<em>"+oe+"</em>"},Ee.codespan=function(oe){return"<code>"+oe+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(oe){return"<del>"+oe+"</del>"},Ee.link=function(oe,ce,ie){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ie;var ne='<a href="'+p(oe)+'"';return ce&&(ne+=' title="'+ce+'"'),ne+=">"+ie+"</a>",ne},Ee.image=function(oe,ce,ie){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ie;var ne='<img src="'+oe+'" alt="'+ie+'"';return ce&&(ne+=' title="'+ce+'"'),ne+=this.options.xhtml?"/>":">",ne},Ee.text=function(oe){return oe},ye}(),pe=function(){function ye(){}var Ee=ye.prototype;return Ee.strong=function(oe){return oe},Ee.em=function(oe){return oe},Ee.codespan=function(oe){return oe},Ee.del=function(oe){return oe},Ee.html=function(oe){return oe},Ee.text=function(oe){return oe},Ee.link=function(oe,ce,ie){return""+ie},Ee.image=function(oe,ce,ie){return""+ie},Ee.br=function(){return""},ye}(),we=function(){function ye(){this.seen={}}var Ee=ye.prototype;return Ee.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(oe,ce){var ie=oe,ne=0;if(this.seen.hasOwnProperty(ie)){ne=this.seen[oe];do ne++,ie=oe+"-"+ne;while(this.seen.hasOwnProperty(ie))}return ce||(this.seen[oe]=ne,this.seen[ie]=0),ie},Ee.slug=function(oe,ce){ce===void 0&&(ce={});var ie=this.serialize(oe);return this.getNextSafeSlug(ie,ce.dryrun)},ye}(),he=function(){function ye(Ie){this.options=Ie||te.defaults,this.options.renderer=this.options.renderer||new Q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new we}ye.parse=function(oe,ce){var ie=new ye(ce);return ie.parse(oe)},ye.parseInline=function(oe,ce){var ie=new ye(ce);return ie.parseInline(oe)};var Ee=ye.prototype;return Ee.parse=function(oe,ce){ce===void 0&&(ce=!0);var ie="",ne,C,z,V,j,ae,ge,ee,be,Se,xe,He,et,Qe,Ye,rt,lt,Me,st,Z=oe.length;for(ne=0;ne<Z;ne++){if(Se=oe[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Se.type]&&(st=this.options.extensions.renderers[Se.type].call({parser:this},Se),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Se.type))){ie+=st||"";continue}switch(Se.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(Se.tokens),Se.depth,t(this.parseInline(Se.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(Se.text,Se.lang,Se.escaped);continue}case"table":{for(ee="",ge="",V=Se.header.length,C=0;C<V;C++)ge+=this.renderer.tablecell(this.parseInline(Se.header[C].tokens),{header:!0,align:Se.align[C]});for(ee+=this.renderer.tablerow(ge),be="",V=Se.rows.length,C=0;C<V;C++){for(ae=Se.rows[C],ge="",j=ae.length,z=0;z<j;z++)ge+=this.renderer.tablecell(this.parseInline(ae[z].tokens),{header:!1,align:Se.align[z]});be+=this.renderer.tablerow(ge)}ie+=this.renderer.table(ee,be);continue}case"blockquote":{be=this.parse(Se.tokens),ie+=this.renderer.blockquote(be);continue}case"list":{for(xe=Se.ordered,He=Se.start,et=Se.loose,V=Se.items.length,be="",C=0;C<V;C++)Ye=Se.items[C],rt=Ye.checked,lt=Ye.task,Qe="",Ye.task&&(Me=this.renderer.checkbox(rt),et?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=Me+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=Me+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:Me}):Qe+=Me),Qe+=this.parse(Ye.tokens,et),be+=this.renderer.listitem(Qe,lt,rt);ie+=this.renderer.list(be,xe,He);continue}case"html":{ie+=this.renderer.html(Se.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(Se.tokens));continue}case"text":{for(be=Se.tokens?this.parseInline(Se.tokens):Se.text;ne+1<Z&&oe[ne+1].type==="text";)Se=oe[++ne],be+=`
`+(Se.tokens?this.parseInline(Se.tokens):Se.text);ie+=ce?this.renderer.paragraph(be):be;continue}default:{var Y='Token with "'+Se.type+'" type was not found.';if(this.options.silent){console.error(Y);return}else throw new Error(Y)}}}return ie},Ee.parseInline=function(oe,ce){ce=ce||this.renderer;var ie="",ne,C,z,V=oe.length;for(ne=0;ne<V;ne++){if(C=oe[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[C.type]&&(z=this.options.extensions.renderers[C.type].call({parser:this},C),z!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(C.type))){ie+=z||"";continue}switch(C.type){case"escape":{ie+=ce.text(C.text);break}case"html":{ie+=ce.html(C.text);break}case"link":{ie+=ce.link(C.href,C.title,this.parseInline(C.tokens,ce));break}case"image":{ie+=ce.image(C.href,C.title,C.text);break}case"strong":{ie+=ce.strong(this.parseInline(C.tokens,ce));break}case"em":{ie+=ce.em(this.parseInline(C.tokens,ce));break}case"codespan":{ie+=ce.codespan(C.text);break}case"br":{ie+=ce.br();break}case"del":{ie+=ce.del(this.parseInline(C.tokens,ce));break}case"text":{ie+=ce.text(C.text);break}default:{var j='Token with "'+C.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return ie},ye}();function de(ye,Ee,Ie){if(typeof ye>"u"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof Ee=="function"&&(Ie=Ee,Ee=null),Ee=c({},de.defaults,Ee||{}),f(Ee),Ie){var oe=Ee.highlight,ce;try{ce=H.lex(ye,Ee)}catch(V){return Ie(V)}var ie=function(j){var ae;if(!j)try{Ee.walkTokens&&de.walkTokens(ce,Ee.walkTokens),ae=he.parse(ce,Ee)}catch(ge){j=ge}return Ee.highlight=oe,j?Ie(j):Ie(null,ae)};if(!oe||oe.length<3||(delete Ee.highlight,!ce.length))return ie();var ne=0;de.walkTokens(ce,function(V){V.type==="code"&&(ne++,setTimeout(function(){oe(V.text,V.lang,function(j,ae){if(j)return ie(j);ae!=null&&ae!==V.text&&(V.text=ae,V.escaped=!0),ne--,ne===0&&ie()})},0))}),ne===0&&ie();return}function C(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+p(V.message+"",!0)+"</pre>";throw V}try{var z=H.lex(ye,Ee);if(Ee.walkTokens){if(Ee.async)return Promise.all(de.walkTokens(z,Ee.walkTokens)).then(function(){return he.parse(z,Ee)}).catch(C);de.walkTokens(z,Ee.walkTokens)}return he.parse(z,Ee)}catch(V){C(V)}}de.options=de.setOptions=function(ye){return c(de.defaults,ye),P(de.defaults),de},de.getDefaults=A,de.defaults=te.defaults,de.use=function(){for(var ye=arguments.length,Ee=new Array(ye),Ie=0;Ie<ye;Ie++)Ee[Ie]=arguments[Ie];var oe=c.apply(void 0,[{}].concat(Ee)),ce=de.defaults.extensions||{renderers:{},childTokens:{}},ie;Ee.forEach(function(ne){if(ne.extensions&&(ie=!0,ne.extensions.forEach(function(z){if(!z.name)throw new Error("extension name required");if(z.renderer){var V=ce.renderers?ce.renderers[z.name]:null;V?ce.renderers[z.name]=function(){for(var j=arguments.length,ae=new Array(j),ge=0;ge<j;ge++)ae[ge]=arguments[ge];var ee=z.renderer.apply(this,ae);return ee===!1&&(ee=V.apply(this,ae)),ee}:ce.renderers[z.name]=z.renderer}if(z.tokenizer){if(!z.level||z.level!=="block"&&z.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[z.level]?ce[z.level].unshift(z.tokenizer):ce[z.level]=[z.tokenizer],z.start&&(z.level==="block"?ce.startBlock?ce.startBlock.push(z.start):ce.startBlock=[z.start]:z.level==="inline"&&(ce.startInline?ce.startInline.push(z.start):ce.startInline=[z.start]))}z.childTokens&&(ce.childTokens[z.name]=z.childTokens)})),ne.renderer&&function(){var z=de.defaults.renderer||new Q,V=function(ge){var ee=z[ge];z[ge]=function(){for(var be=arguments.length,Se=new Array(be),xe=0;xe<be;xe++)Se[xe]=arguments[xe];var He=ne.renderer[ge].apply(z,Se);return He===!1&&(He=ee.apply(z,Se)),He}};for(var j in ne.renderer)V(j);oe.renderer=z}(),ne.tokenizer&&function(){var z=de.defaults.tokenizer||new q,V=function(ge){var ee=z[ge];z[ge]=function(){for(var be=arguments.length,Se=new Array(be),xe=0;xe<be;xe++)Se[xe]=arguments[xe];var He=ne.tokenizer[ge].apply(z,Se);return He===!1&&(He=ee.apply(z,Se)),He}};for(var j in ne.tokenizer)V(j);oe.tokenizer=z}(),ne.walkTokens){var C=de.defaults.walkTokens;oe.walkTokens=function(z){var V=[];return V.push(ne.walkTokens.call(this,z)),C&&(V=V.concat(C.call(this,z))),V}}ie&&(oe.extensions=ce),de.setOptions(oe)})},de.walkTokens=function(ye,Ee){for(var Ie=[],oe=function(){var C=ie.value;switch(Ie=Ie.concat(Ee.call(de,C)),C.type){case"table":{for(var z=F(C.header),V;!(V=z()).done;){var j=V.value;Ie=Ie.concat(de.walkTokens(j.tokens,Ee))}for(var ae=F(C.rows),ge;!(ge=ae()).done;)for(var ee=ge.value,be=F(ee),Se;!(Se=be()).done;){var xe=Se.value;Ie=Ie.concat(de.walkTokens(xe.tokens,Ee))}break}case"list":{Ie=Ie.concat(de.walkTokens(C.items,Ee));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[C.type]?de.defaults.extensions.childTokens[C.type].forEach(function(He){Ie=Ie.concat(de.walkTokens(C[He],Ee))}):C.tokens&&(Ie=Ie.concat(de.walkTokens(C.tokens,Ee)))}},ce=F(ye),ie;!(ie=ce()).done;)oe();return Ie},de.parseInline=function(ye,Ee){if(typeof ye>"u"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");Ee=c({},de.defaults,Ee||{}),f(Ee);try{var Ie=H.lexInline(ye,Ee);return Ee.walkTokens&&de.walkTokens(Ie,Ee.walkTokens),he.parseInline(Ie,Ee)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+p(oe.message+"",!0)+"</pre>";throw oe}},de.Parser=he,de.parser=he.parse,de.Renderer=Q,de.TextRenderer=pe,de.Lexer=H,de.lexer=H.lex,de.Tokenizer=q,de.Slugger=we,de.parse=de;var Ae=de.options,ue=de.setOptions,le=de.use,$=de.walkTokens,O=de.parseInline,X=de,me=he.parse,Ce=H.lex;te.Lexer=H,te.Parser=he,te.Renderer=Q,te.Slugger=we,te.TextRenderer=pe,te.Tokenizer=q,te.getDefaults=A,te.lexer=Ce,te.marked=de,te.options=Ae,te.parse=X,te.parseInline=O,te.parser=me,te.setOptions=ue,te.use=le,te.walkTokens=$,Object.defineProperty(te,"__esModule",{value:!0})}),define(Te[116],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(P,S,h){return Math.min(Math.max(P,S),h)}e.clamp=n;function T(P,S){return(S+P%S)%S}e.rot=T;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class F{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=F;class A{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const h=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=h,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),function(){function te(D){const F=[];typeof D=="number"&&F.push("code/timeOrigin",D);function A(S){F.push(S,Date.now())}function P(){const S=[];for(let h=0;h<F.length;h+=2)S.push({name:F[h],startTime:F[h+1]});return S}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const A of performance.getEntriesByType("mark"))F.push({name:A.name,startTime:Math.round(D+A.startTime)});return F}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function n(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=n(T))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var T in n)(typeof exports=="object"?exports:te)[T]=n[T]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function n(T){if(e[T])return e[T].exports;var D=e[T]={i:T,l:!1,exports:{}};return te[T].call(D.exports,D,D.exports,n),D.l=!0,D.exports}return n.m=te,n.c=e,n.d=function(T,D,F){n.o(T,D)||Object.defineProperty(T,D,{enumerable:!0,get:F})},n.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},n.t=function(T,D){if(1&D&&(T=n(T)),8&D||4&D&&typeof T=="object"&&T&&T.__esModule)return T;var F=Object.create(null);if(n.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:T}),2&D&&typeof T!="string")for(var A in T)n.d(F,A,function(P){return T[P]}.bind(null,A));return F},n.n=function(T){var D=T&&T.__esModule?function(){return T.default}:function(){return T};return n.d(D,"a",D),D},n.o=function(T,D){return Object.prototype.hasOwnProperty.call(T,D)},n.p="",n(n.s=0)}([function(te,e,n){(function(T){var D;e=te.exports=le,D=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],h=0,R=h++;S[R]="0|[1-9]\\d*";var b=h++;S[b]="[0-9]+";var g=h++;S[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var _=h++;S[_]="("+S[R]+")\\.("+S[R]+")\\.("+S[R]+")";var p=h++;S[p]="("+S[b]+")\\.("+S[b]+")\\.("+S[b]+")";var u=h++;S[u]="(?:"+S[R]+"|"+S[g]+")";var t=h++;S[t]="(?:"+S[b]+"|"+S[g]+")";var o=h++;S[o]="(?:-("+S[u]+"(?:\\."+S[u]+")*))";var d=h++;S[d]="(?:-?("+S[t]+"(?:\\."+S[t]+")*))";var y=h++;S[y]="[0-9A-Za-z-]+";var k=h++;S[k]="(?:\\+("+S[y]+"(?:\\."+S[y]+")*))";var v=h++,i="v?"+S[_]+S[o]+"?"+S[k]+"?";S[v]="^"+i+"$";var a="[v=\\s]*"+S[p]+S[d]+"?"+S[k]+"?",r=h++;S[r]="^"+a+"$";var s=h++;S[s]="((?:<|>)?=?)";var w=h++;S[w]=S[b]+"|x|X|\\*";var I=h++;S[I]=S[R]+"|x|X|\\*";var c=h++;S[c]="[v=\\s]*("+S[I]+")(?:\\.("+S[I]+")(?:\\.("+S[I]+")(?:"+S[o]+")?"+S[k]+"?)?)?";var l=h++;S[l]="[v=\\s]*("+S[w]+")(?:\\.("+S[w]+")(?:\\.("+S[w]+")(?:"+S[d]+")?"+S[k]+"?)?)?";var m=h++;S[m]="^"+S[s]+"\\s*"+S[c]+"$";var E=h++;S[E]="^"+S[s]+"\\s*"+S[l]+"$";var f=h++;S[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=h++;S[L]="(?:~>?)";var W=h++;S[W]="(\\s*)"+S[L]+"\\s+",P[W]=new RegExp(S[W],"g");var J=h++;S[J]="^"+S[L]+S[c]+"$";var q=h++;S[q]="^"+S[L]+S[l]+"$";var U=h++;S[U]="(?:\\^)";var B=h++;S[B]="(\\s*)"+S[U]+"\\s+",P[B]=new RegExp(S[B],"g");var G=h++;S[G]="^"+S[U]+S[c]+"$";var N=h++;S[N]="^"+S[U]+S[l]+"$";var H=h++;S[H]="^"+S[s]+"\\s*("+a+")$|^$";var Q=h++;S[Q]="^"+S[s]+"\\s*("+i+")$|^$";var pe=h++;S[pe]="(\\s*)"+S[s]+"\\s*("+a+"|"+S[c]+")",P[pe]=new RegExp(S[pe],"g");var we=h++;S[we]="^\\s*("+S[c]+")\\s+-\\s+("+S[c]+")\\s*$";var he=h++;S[he]="^\\s*("+S[l]+")\\s+-\\s+("+S[l]+")\\s*$";var de=h++;S[de]="(<|>)?=?\\s*\\*";for(var Ae=0;Ae<35;Ae++)D(Ae,S[Ae]),P[Ae]||(P[Ae]=new RegExp(S[Ae]));function ue(ee,be){if(ee instanceof le)return ee;if(typeof ee!="string"||ee.length>F||!(be?P[r]:P[v]).test(ee))return null;try{return new le(ee,be)}catch{return null}}function le(ee,be){if(ee instanceof le){if(ee.loose===be)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof le))return new le(ee,be);D("SemVer",ee,be),this.loose=be;var Se=ee.trim().match(be?P[r]:P[v]);if(!Se)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+Se[1],this.minor=+Se[2],this.patch=+Se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Se[4]?this.prerelease=Se[4].split(".").map(function(xe){if(/^[0-9]+$/.test(xe)){var He=+xe;if(He>=0&&He<A)return He}return xe}):this.prerelease=[],this.build=Se[5]?Se[5].split("."):[],this.format()}e.parse=ue,e.valid=function(ee,be){var Se=ue(ee,be);return Se?Se.version:null},e.clean=function(ee,be){var Se=ue(ee.trim().replace(/^[=v]+/,""),be);return Se?Se.version:null},e.SemVer=le,le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},le.prototype.toString=function(){return this.version},le.prototype.compare=function(ee){return D("SemVer.compare",this.version,this.loose,ee),ee instanceof le||(ee=new le(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},le.prototype.compareMain=function(ee){return ee instanceof le||(ee=new le(ee,this.loose)),O(this.major,ee.major)||O(this.minor,ee.minor)||O(this.patch,ee.patch)},le.prototype.comparePre=function(ee){if(ee instanceof le||(ee=new le(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var be=0;do{var Se=this.prerelease[be],xe=ee.prerelease[be];if(D("prerelease compare",be,Se,xe),Se===void 0&&xe===void 0)return 0;if(xe===void 0)return 1;if(Se===void 0)return-1;if(Se!==xe)return O(Se,xe)}while(++be)},le.prototype.inc=function(ee,be){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Se=this.prerelease.length;--Se>=0;)typeof this.prerelease[Se]=="number"&&(this.prerelease[Se]++,Se=-2);Se===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,be,Se,xe){typeof Se=="string"&&(xe=Se,Se=void 0);try{return new le(ee,Se).inc(be,xe).version}catch{return null}},e.diff=function(ee,be){if(ye(ee,be))return null;var Se=ue(ee),xe=ue(be);if(Se.prerelease.length||xe.prerelease.length){for(var He in Se)if((He==="major"||He==="minor"||He==="patch")&&Se[He]!==xe[He])return"pre"+He;return"prerelease"}for(var He in Se)if((He==="major"||He==="minor"||He==="patch")&&Se[He]!==xe[He])return He},e.compareIdentifiers=O;var $=/^[0-9]+$/;function O(ee,be){var Se=$.test(ee),xe=$.test(be);return Se&&xe&&(ee=+ee,be=+be),Se&&!xe?-1:xe&&!Se?1:ee<be?-1:ee>be?1:0}function X(ee,be,Se){return new le(ee,Se).compare(new le(be,Se))}function me(ee,be,Se){return X(ee,be,Se)>0}function Ce(ee,be,Se){return X(ee,be,Se)<0}function ye(ee,be,Se){return X(ee,be,Se)===0}function Ee(ee,be,Se){return X(ee,be,Se)!==0}function Ie(ee,be,Se){return X(ee,be,Se)>=0}function oe(ee,be,Se){return X(ee,be,Se)<=0}function ce(ee,be,Se,xe){var He;switch(be){case"===":typeof ee=="object"&&(ee=ee.version),typeof Se=="object"&&(Se=Se.version),He=ee===Se;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof Se=="object"&&(Se=Se.version),He=ee!==Se;break;case"":case"=":case"==":He=ye(ee,Se,xe);break;case"!=":He=Ee(ee,Se,xe);break;case">":He=me(ee,Se,xe);break;case">=":He=Ie(ee,Se,xe);break;case"<":He=Ce(ee,Se,xe);break;case"<=":He=oe(ee,Se,xe);break;default:throw new TypeError("Invalid operator: "+be)}return He}function ie(ee,be){if(ee instanceof ie){if(ee.loose===be)return ee;ee=ee.value}if(!(this instanceof ie))return new ie(ee,be);D("comparator",ee,be),this.loose=be,this.parse(ee),this.semver===ne?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ee,be){return O(be,ee)},e.major=function(ee,be){return new le(ee,be).major},e.minor=function(ee,be){return new le(ee,be).minor},e.patch=function(ee,be){return new le(ee,be).patch},e.compare=X,e.compareLoose=function(ee,be){return X(ee,be,!0)},e.rcompare=function(ee,be,Se){return X(be,ee,Se)},e.sort=function(ee,be){return ee.sort(function(Se,xe){return e.compare(Se,xe,be)})},e.rsort=function(ee,be){return ee.sort(function(Se,xe){return e.rcompare(Se,xe,be)})},e.gt=me,e.lt=Ce,e.eq=ye,e.neq=Ee,e.gte=Ie,e.lte=oe,e.cmp=ce,e.Comparator=ie;var ne={};function C(ee,be){if(ee instanceof C)return ee.loose===be?ee:new C(ee.raw,be);if(ee instanceof ie)return new C(ee.value,be);if(!(this instanceof C))return new C(ee,be);if(this.loose=be,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(Se){return this.parseRange(Se.trim())},this).filter(function(Se){return Se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function z(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function V(ee,be,Se,xe,He,et,Qe,Ye,rt,lt,Me,st,Z){return((be=z(Se)?"":z(xe)?">="+Se+".0.0":z(He)?">="+Se+"."+xe+".0":">="+be)+" "+(Ye=z(rt)?"":z(lt)?"<"+(+rt+1)+".0.0":z(Me)?"<"+rt+"."+(+lt+1)+".0":st?"<="+rt+"."+lt+"."+Me+"-"+st:"<="+Ye)).trim()}function j(ee,be){for(var Se=0;Se<ee.length;Se++)if(!ee[Se].test(be))return!1;if(be.prerelease.length){for(Se=0;Se<ee.length;Se++)if(D(ee[Se].semver),ee[Se].semver!==ne&&ee[Se].semver.prerelease.length>0){var xe=ee[Se].semver;if(xe.major===be.major&&xe.minor===be.minor&&xe.patch===be.patch)return!0}return!1}return!0}function ae(ee,be,Se){try{be=new C(be,Se)}catch{return!1}return be.test(ee)}function ge(ee,be,Se,xe){var He,et,Qe,Ye,rt;switch(ee=new le(ee,xe),be=new C(be,xe),Se){case">":He=me,et=oe,Qe=Ce,Ye=">",rt=">=";break;case"<":He=Ce,et=Ie,Qe=me,Ye="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ae(ee,be,xe))return!1;for(var lt=0;lt<be.set.length;++lt){var Me=be.set[lt],st=null,Z=null;if(Me.forEach(function(Y){Y.semver===ne&&(Y=new ie(">=0.0.0")),st=st||Y,Z=Z||Y,He(Y.semver,st.semver,xe)?st=Y:Qe(Y.semver,Z.semver,xe)&&(Z=Y)}),st.operator===Ye||st.operator===rt||(!Z.operator||Z.operator===Ye)&&et(ee,Z.semver)||Z.operator===rt&&Qe(ee,Z.semver))return!1}return!0}ie.prototype.parse=function(ee){var be=this.loose?P[H]:P[Q],Se=ee.match(be);if(!Se)throw new TypeError("Invalid comparator: "+ee);this.operator=Se[1],this.operator==="="&&(this.operator=""),Se[2]?this.semver=new le(Se[2],this.loose):this.semver=ne},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(ee){return D("Comparator.test",ee,this.loose),this.semver===ne||(typeof ee=="string"&&(ee=new le(ee,this.loose)),ce(ee,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(ee,be){if(!(ee instanceof ie))throw new TypeError("a Comparator is required");var Se;if(this.operator==="")return Se=new C(ee.value,be),ae(this.value,Se,be);if(ee.operator==="")return Se=new C(this.value,be),ae(ee.semver,Se,be);var xe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),et=this.semver.version===ee.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Ye=ce(this.semver,"<",ee.semver,be)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),rt=ce(this.semver,">",ee.semver,be)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return xe||He||et&&Qe||Ye||rt},e.Range=C,C.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},C.prototype.toString=function(){return this.range},C.prototype.parseRange=function(ee){var be=this.loose;ee=ee.trim(),D("range",ee,be);var Se=be?P[he]:P[we];ee=ee.replace(Se,V),D("hyphen replace",ee),ee=ee.replace(P[pe],"$1$2$3"),D("comparator trim",ee,P[pe]),ee=(ee=(ee=ee.replace(P[W],"$1~")).replace(P[B],"$1^")).split(/\s+/).join(" ");var xe=be?P[H]:P[Q],He=ee.split(" ").map(function(et){return function(Qe,Ye){return D("comp",Qe),Qe=function(rt,lt){return rt.trim().split(/\s+/).map(function(Me){return function(st,Z){D("caret",st,Z);var Y=Z?P[N]:P[G];return st.replace(Y,function(_e,Ne,ze,Xe,We){var it;return D("caret",st,_e,Ne,ze,Xe,We),z(Ne)?it="":z(ze)?it=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":z(Xe)?it=Ne==="0"?">="+Ne+"."+ze+".0 <"+Ne+"."+(+ze+1)+".0":">="+Ne+"."+ze+".0 <"+(+Ne+1)+".0.0":We?(D("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),it=Ne==="0"?ze==="0"?">="+Ne+"."+ze+"."+Xe+We+" <"+Ne+"."+ze+"."+(+Xe+1):">="+Ne+"."+ze+"."+Xe+We+" <"+Ne+"."+(+ze+1)+".0":">="+Ne+"."+ze+"."+Xe+We+" <"+(+Ne+1)+".0.0"):(D("no pr"),it=Ne==="0"?ze==="0"?">="+Ne+"."+ze+"."+Xe+" <"+Ne+"."+ze+"."+(+Xe+1):">="+Ne+"."+ze+"."+Xe+" <"+Ne+"."+(+ze+1)+".0":">="+Ne+"."+ze+"."+Xe+" <"+(+Ne+1)+".0.0"),D("caret return",it),it})}(Me,lt)}).join(" ")}(Qe,Ye),D("caret",Qe),Qe=function(rt,lt){return rt.trim().split(/\s+/).map(function(Me){return function(st,Z){var Y=Z?P[q]:P[J];return st.replace(Y,function(_e,Ne,ze,Xe,We){var it;return D("tilde",st,_e,Ne,ze,Xe,We),z(Ne)?it="":z(ze)?it=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":z(Xe)?it=">="+Ne+"."+ze+".0 <"+Ne+"."+(+ze+1)+".0":We?(D("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),it=">="+Ne+"."+ze+"."+Xe+We+" <"+Ne+"."+(+ze+1)+".0"):it=">="+Ne+"."+ze+"."+Xe+" <"+Ne+"."+(+ze+1)+".0",D("tilde return",it),it})}(Me,lt)}).join(" ")}(Qe,Ye),D("tildes",Qe),Qe=function(rt,lt){return D("replaceXRanges",rt,lt),rt.split(/\s+/).map(function(Me){return function(st,Z){st=st.trim();var Y=Z?P[E]:P[m];return st.replace(Y,function(_e,Ne,ze,Xe,We,it){D("xRange",st,_e,Ne,ze,Xe,We,it);var wt=z(ze),St=wt||z(Xe),kt=St||z(We);return Ne==="="&&kt&&(Ne=""),wt?_e=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&kt?(St&&(Xe=0),kt&&(We=0),Ne===">"?(Ne=">=",St?(ze=+ze+1,Xe=0,We=0):kt&&(Xe=+Xe+1,We=0)):Ne==="<="&&(Ne="<",St?ze=+ze+1:Xe=+Xe+1),_e=Ne+ze+"."+Xe+"."+We):St?_e=">="+ze+".0.0 <"+(+ze+1)+".0.0":kt&&(_e=">="+ze+"."+Xe+".0 <"+ze+"."+(+Xe+1)+".0"),D("xRange return",_e),_e})}(Me,lt)}).join(" ")}(Qe,Ye),D("xrange",Qe),Qe=function(rt,lt){return D("replaceStars",rt,lt),rt.trim().replace(P[de],"")}(Qe,Ye),D("stars",Qe),Qe}(et,be)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(et){return!!et.match(xe)})),He=He.map(function(et){return new ie(et,be)})},C.prototype.intersects=function(ee,be){if(!(ee instanceof C))throw new TypeError("a Range is required");return this.set.some(function(Se){return Se.every(function(xe){return ee.set.some(function(He){return He.every(function(et){return xe.intersects(et,be)})})})})},e.toComparators=function(ee,be){return new C(ee,be).set.map(function(Se){return Se.map(function(xe){return xe.value}).join(" ").trim().split(" ")})},C.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new le(ee,this.loose));for(var be=0;be<this.set.length;be++)if(j(this.set[be],ee))return!0;return!1},e.satisfies=ae,e.maxSatisfying=function(ee,be,Se){var xe=null,He=null;try{var et=new C(be,Se)}catch{return null}return ee.forEach(function(Qe){et.test(Qe)&&(xe&&He.compare(Qe)!==-1||(He=new le(xe=Qe,Se)))}),xe},e.minSatisfying=function(ee,be,Se){var xe=null,He=null;try{var et=new C(be,Se)}catch{return null}return ee.forEach(function(Qe){et.test(Qe)&&(xe&&He.compare(Qe)!==1||(He=new le(xe=Qe,Se)))}),xe},e.validRange=function(ee,be){try{return new C(ee,be).range||"*"}catch{return null}},e.ltr=function(ee,be,Se){return ge(ee,be,"<",Se)},e.gtr=function(ee,be,Se){return ge(ee,be,">",Se)},e.outside=ge,e.prerelease=function(ee,be){var Se=ue(ee,be);return Se&&Se.prerelease.length?Se.prerelease:null},e.intersects=function(ee,be,Se){return ee=new C(ee,Se),be=new C(be,Se),ee.intersects(be)},e.coerce=function(ee){if(ee instanceof le)return ee;if(typeof ee!="string")return null;var be=ee.match(P[f]);return be==null?null:ue((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,n(1))},function(te,e){var n,T,D=te.exports={};function F(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(t){if(n===setTimeout)return setTimeout(t,0);if((n===F||!n)&&setTimeout)return n=setTimeout,setTimeout(t,0);try{return n(t,0)}catch{try{return n.call(null,t,0)}catch{return n.call(this,t,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:F}catch{n=F}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var S,h=[],R=!1,b=-1;function g(){R&&S&&(R=!1,S.length?h=S.concat(h):b=-1,h.length&&_())}function _(){if(!R){var t=P(g);R=!0;for(var o=h.length;o;){for(S=h,h=[];++b<o;)S&&S[b].run();b=-1,o=h.length}S=null,R=!1,function(d){if(T===clearTimeout)return clearTimeout(d);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(d);try{T(d)}catch{try{return T.call(null,d)}catch{return T.call(this,d)}}}(t)}}function p(t,o){this.fun=t,this.array=o}function u(){}D.nextTick=function(t){var o=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)o[d-1]=arguments[d];h.push(new p(t,o)),h.length!==1||R||P(_)},p.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=u,D.addListener=u,D.once=u,D.off=u,D.removeListener=u,D.removeAllListeners=u,D.emit=u,D.prependListener=u,D.prependOnceListener=u,D.listeners=function(t){return[]},D.binding=function(t){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(t){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Te[117],Pe([1,0,9,6]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(k){const v=k;return v?typeof v.read=="function":!1}e.isReadable=D;function F(k){const v=k;return v?[v.on,v.pause,v.resume,v.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=F;function A(k){const v=k;return v?F(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(k,v){return new S(k,v)}e.newWriteableStream=P;class S{constructor(v,i){this.reducer=v,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v<"u"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(i=>i(v))}emitError(v){this.listeners.error.length===0?(0,n.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(i=>i(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,i){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(v,i){if(this.state.destroyed)return;let a;switch(v){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const r=a.indexOf(i);r>=0&&a.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(k,v){const i=[];let a;for(;(a=k.read())!==null;)i.push(a);return v(i)}e.consumeReadable=h;function R(k,v,i){const a=[];let r;for(;(r=k.read())!==null&&a.length<i;)a.push(r);return r===null&&a.length>0?v(a):{read:()=>{if(a.length>0)return a.shift();if(typeof r<"u"){const s=r;return r=void 0,s}return k.read()}}}e.peekReadable=R;function b(k,v){return new Promise((i,a)=>{const r=[];g(k,{onData:s=>{v&&r.push(s)},onError:s=>{v?a(s):i(void 0)},onEnd:()=>{i(v?v(r):void 0)}})})}e.consumeStream=b;function g(k,v){let i=!1;return k.on("error",a=>{i||v.onError(a)}),k.on("end",()=>{i||v.onEnd()}),k.on("data",a=>{i||v.onData(a)}),(0,T.toDisposable)(()=>i=!0)}e.listenStream=g;function _(k,v){return new Promise((i,a)=>{const r=new T.DisposableStore,s=[],w=l=>{if(s.push(l),s.length>v)return r.dispose(),k.pause(),i({stream:k,buffer:s,ended:!1})},I=l=>a(l),c=()=>i({stream:k,buffer:s,ended:!0});r.add((0,T.toDisposable)(()=>k.removeListener("error",I))),k.on("error",I),r.add((0,T.toDisposable)(()=>k.removeListener("end",c))),k.on("end",c),r.add((0,T.toDisposable)(()=>k.removeListener("data",w))),k.on("data",w)})}e.peekStream=_;function p(k,v){const i=P(v);return i.end(k),i}e.toStream=p;function u(){const k=P(()=>{throw new Error("not supported")});return k.end(),k}e.emptyStream=u;function t(k){let v=!1;return{read:()=>v?null:(v=!0,k)}}e.toReadable=t;function o(k,v,i){const a=P(i);return g(k,{onData:r=>a.write(v.data(r)),onError:r=>a.error(v.error?v.error(r):r),onEnd:()=>a.end()}),a}e.transform=o;function d(k,v,i){let a=!1;return{read:()=>{const r=v.read();return a?r:(a=!0,r!==null?i([k,r]):k)}}}e.prefixedReadable=d;function y(k,v,i){let a=!1;const r=P(i);return g(v,{onData:s=>a?r.write(s):(a=!0,r.write(i([k,s]))),onError:s=>r.error(s),onEnd:()=>{a||(a=!0,r.write(k)),r.end()}}),r}e.prefixedStream=y}),define(Te[25],Pe([1,0,117]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let D,F;class A{static alloc(l){return T?new A(Buffer.allocUnsafe(l)):new A(new Uint8Array(l))}static wrap(l){return T&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new A(l)}static fromString(l,m){return!(m?.dontUseNodeBuffer||!1)&&T?new A(Buffer.from(l)):(D||(D=new TextEncoder),new A(D.encode(l)))}static fromByteArray(l){const m=A.alloc(l.length);for(let E=0,f=l.length;E<f;E++)m.buffer[E]=l[E];return m}static concat(l,m){if(typeof m>"u"){m=0;for(let L=0,W=l.length;L<W;L++)m+=l[L].byteLength}const E=A.alloc(m);let f=0;for(let L=0,W=l.length;L<W;L++){const J=l[L];E.set(J,f),f+=J.byteLength}return E}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=A.alloc(this.byteLength);return l.set(this),l}toString(){return T?this.buffer.toString():(F||(F=new TextDecoder),F.decode(this.buffer))}slice(l,m){return new A(this.buffer.subarray(l,m))}set(l,m){if(l instanceof A)this.buffer.set(l.buffer,m);else if(l instanceof Uint8Array)this.buffer.set(l,m);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),m);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return h(this.buffer,l)}writeUInt32BE(l,m){R(this.buffer,l,m)}readUInt32LE(l){return b(this.buffer,l)}writeUInt32LE(l,m){g(this.buffer,l,m)}readUInt8(l){return _(this.buffer,l)}writeUInt8(l,m){p(this.buffer,l,m)}}e.VSBuffer=A;function P(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0}e.readUInt16LE=P;function S(c,l,m){c[m+0]=l&255,l=l>>>8,c[m+1]=l&255}e.writeUInt16LE=S;function h(c,l){return c[l]*2**24+c[l+1]*2**16+c[l+2]*2**8+c[l+3]}e.readUInt32BE=h;function R(c,l,m){c[m+3]=l,l=l>>>8,c[m+2]=l,l=l>>>8,c[m+1]=l,l=l>>>8,c[m]=l}e.writeUInt32BE=R;function b(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0|c[l+2]<<16>>>0|c[l+3]<<24>>>0}e.readUInt32LE=b;function g(c,l,m){c[m+0]=l&255,l=l>>>8,c[m+1]=l&255,l=l>>>8,c[m+2]=l&255,l=l>>>8,c[m+3]=l&255}e.writeUInt32LE=g;function _(c,l){return c[l]}e.readUInt8=_;function p(c,l,m){c[m]=l}e.writeUInt8=p;function u(c){return n.consumeReadable(c,l=>A.concat(l))}e.readableToBuffer=u;function t(c){return n.toReadable(c)}e.bufferToReadable=t;function o(c){return n.consumeStream(c,l=>A.concat(l))}e.streamToBuffer=o;async function d(c){return c.ended?A.concat(c.buffer):A.concat([...c.buffer,await o(c.stream)])}e.bufferedStreamToBuffer=d;function y(c){return n.toStream(c,l=>A.concat(l))}e.bufferToStream=y;function k(c){return n.transform(c,{data:l=>typeof l=="string"?A.fromString(l):A.wrap(l)},l=>A.concat(l))}e.streamToBufferReadableStream=k;function v(c){return n.newWriteableStream(l=>A.concat(l),c)}e.newWriteableBufferStream=v;function i(c,l){return n.prefixedReadable(c,l,m=>A.concat(m))}e.prefixedBufferReadable=i;function a(c,l){return n.prefixedStream(c,l,m=>A.concat(m))}e.prefixedBufferStream=a;function r(c){let l=0,m=0,E=0;const f=new Uint8Array(Math.floor(c.length/4*3)),L=J=>{switch(m){case 3:f[E++]=l|J,m=0;break;case 2:f[E++]=l|J>>>2,l=J<<6,m=3;break;case 1:f[E++]=l|J>>>4,l=J<<4,m=2;break;default:l=J<<2,m=1}};for(let J=0;J<c.length;J++){const q=c.charCodeAt(J);if(q>=65&&q<=90)L(q-65);else if(q>=97&&q<=122)L(q-97+26);else if(q>=48&&q<=57)L(q-48+52);else if(q===43||q===45)L(62);else if(q===47||q===95)L(63);else{if(q===61)break;throw new SyntaxError(`Unexpected base64 character ${c[J]}`)}}const W=E;for(;m>0;)L(0);return A.wrap(f).slice(0,W)}e.decodeBase64=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:c},l=!0,m=!1){const E=m?w:s;let f="";const L=c.byteLength%3;let W=0;for(;W<c.byteLength-L;W+=3){const J=c[W+0],q=c[W+1],U=c[W+2];f+=E[J>>>2],f+=E[(J<<4|q>>>4)&63],f+=E[(q<<2|U>>>6)&63],f+=E[U&63]}if(L===1){const J=c[W+0];f+=E[J>>>2],f+=E[J<<4&63],l&&(f+="==")}else if(L===2){const J=c[W+0],q=c[W+1];f+=E[J>>>2],f+=E[(J<<4|q>>>4)&63],f+=E[q<<2&63],l&&(f+="=")}return f}e.encodeBase64=I}),define(Te[118],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Te[39],Pe([1,0,85]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var T;(function(A){function P(S){return S&&typeof S=="object"&&typeof S.id=="string"}A.isThemeColor=P})(T||(e.ThemeColor=T={}));function D(A){return{id:A}}e.themeColorFromId=D;var F;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function S(d){const y=P.exec(d.id);if(!y)return S(n.Codicon.error);const[,k,v]=y,i=["codicon","codicon-"+k];return v&&i.push("codicon-modifier-"+v.substring(1)),i}A.asClassNameArray=S;function h(d){return S(d).join(" ")}A.asClassName=h;function R(d){return"."+S(d).join(".")}A.asCSSSelector=R;function b(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||T.isThemeColor(d.color))}A.isThemeIcon=b;const g=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function _(d){const y=g.exec(d);if(!y)return;const[,k]=y;return{id:k}}A.fromString=_;function p(d){return{id:d}}A.fromId=p;function u(d,y){let k=d.id;const v=k.lastIndexOf("~");return v!==-1&&(k=k.substring(0,v)),y&&(k=`${k}~${y}`),{id:k}}A.modify=u;function t(d){const y=d.id.lastIndexOf("~");if(y!==-1)return d.id.substring(y+1)}A.getModifier=t;function o(d,y){return d.id===y.id&&d.color?.id===y.color?.id}A.isEqual=o})(F||(e.ThemeIcon=F={}))}),define(Te[35],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(D){return n.test(D)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(P){for(let S=0;S<P.length;S++)P[S]=Math.floor(Math.random()*256);return P};const F=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){D(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let S=0,h="";return h+=A[F[S++]],h+=A[F[S++]],h+=A[F[S++]],h+=A[F[S++]],h+="-",h+=A[F[S++]],h+=A[F[S++]],h+="-",h+=A[F[S++]],h+=A[F[S++]],h+="-",h+=A[F[S++]],h+=A[F[S++]],h+="-",h+=A[F[S++]],h+=A[F[S++]],h+=A[F[S++]],h+=A[F[S++]],h+=A[F[S++]],h+=A[F[S++]],h}}()}),define(Te[119],Pe([1,0,16,86,35]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function F(S){return{id:(0,D.generateUuid)(),asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.createStringDataTransferItem=F;function A(S,h,R){return{id:(0,D.generateUuid)(),asString:async()=>"",asFile:()=>({name:S,uri:h,data:R}),value:void 0}}e.createFileDataTransferItem=A;class P{constructor(){this._entries=new Map}get size(){let h=0;return this.forEach(()=>h++),h}has(h){return this._entries.has(this.toKey(h))}matches(h){if(this.has(h))return!0;if(h.toLowerCase()==="files")return T.Iterable.some(this.values(),p=>p.asFile());if(h==="*/*")return this._entries.size>0;const R=this.toKey(h).match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!R)return!1;const[b,g,_]=R;return _==="*"?T.Iterable.some(this._entries.keys(),p=>p.startsWith(g+"/")):!1}get(h){return this._entries.get(this.toKey(h))?.[0]}append(h,R){const b=this._entries.get(h);b?b.push(R):this._entries.set(this.toKey(h),[R])}replace(h,R){this._entries.set(this.toKey(h),[R])}delete(h){this._entries.delete(this.toKey(h))}*entries(){for(const[h,R]of this._entries.entries())for(const b of R)yield[h,b]}values(){return Array.from(this._entries.values()).flat()}forEach(h){for(const[R,b]of this.entries())h(b,R)}toKey(h){return h.toLowerCase()}}e.VSDataTransfer=P,e.UriList=Object.freeze({create:S=>(0,n.distinct)(S.map(h=>h.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.UriList.split(S).filter(h=>!h.startsWith("#"))})}),define(Te[120],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Te[121],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(n||(e.IndentAction=n={}));class T{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let S=0,h=P.notIn.length;S<h;S++)switch(P.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,S){if(P.getTokenCount()===0)return!0;const h=P.findTokenIndexAtOffset(S-2),R=P.getStandardTokenType(h);return this.isOK(R)}_findNeutralCharacterInRange(P,S){for(let h=P;h<=S;h++){const R=String.fromCharCode(h);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=T;class D{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of P)F(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),F(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),F(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),F(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&F(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=D;function F(A,P,S){A.has(P)?A.get(P).push(S):A.set(P,[S])}}),define(Te[122],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class n{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(F){if(F&&this._dragOperations.has(F)){const A=this._dragOperations.get(F);return this._dragOperations.delete(F),A}}addDragOperationTransfer(F,A){this._dragOperations.set(F,A)}}e.TreeViewsDnDService=n;class T{constructor(F){this.identifier=F}}e.DraggedTreeItemsIdentifier=T}),define(Te[123],Pe([10,11]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Te[124],Pe([10,11]),function(te,e){return te.create("vs/base/common/date",e)}),define(Te[125],Pe([1,0,124]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,D=T*60,F=D*24,A=F*7,P=F*30,S=F*365;function h(b,g,_,p){typeof b!="number"&&(b=b.getTime());const u=Math.round((new Date().getTime()-b)/1e3);if(u<-30)return(0,n.localize)(0,null,h(new Date().getTime()+u*1e3,!1));if(!p&&u<30)return(0,n.localize)(1,null);let t;return u<T?(t=u,g?t===1?_?(0,n.localize)(2,null,t):(0,n.localize)(3,null,t):_?(0,n.localize)(4,null,t):(0,n.localize)(5,null,t):t===1?_?(0,n.localize)(6,null,t):(0,n.localize)(7,null,t):_?(0,n.localize)(8,null,t):(0,n.localize)(9,null,t)):u<D?(t=Math.floor(u/T),g?t===1?_?(0,n.localize)(10,null,t):(0,n.localize)(11,null,t):_?(0,n.localize)(12,null,t):(0,n.localize)(13,null,t):t===1?_?(0,n.localize)(14,null,t):(0,n.localize)(15,null,t):_?(0,n.localize)(16,null,t):(0,n.localize)(17,null,t)):u<F?(t=Math.floor(u/D),g?t===1?_?(0,n.localize)(18,null,t):(0,n.localize)(19,null,t):_?(0,n.localize)(20,null,t):(0,n.localize)(21,null,t):t===1?_?(0,n.localize)(22,null,t):(0,n.localize)(23,null,t):_?(0,n.localize)(24,null,t):(0,n.localize)(25,null,t)):u<A?(t=Math.floor(u/F),g?t===1?(0,n.localize)(26,null,t):(0,n.localize)(27,null,t):t===1?(0,n.localize)(28,null,t):(0,n.localize)(29,null,t)):u<P?(t=Math.floor(u/A),g?t===1?_?(0,n.localize)(30,null,t):(0,n.localize)(31,null,t):_?(0,n.localize)(32,null,t):(0,n.localize)(33,null,t):t===1?_?(0,n.localize)(34,null,t):(0,n.localize)(35,null,t):_?(0,n.localize)(36,null,t):(0,n.localize)(37,null,t)):u<S?(t=Math.floor(u/P),g?t===1?_?(0,n.localize)(38,null,t):(0,n.localize)(39,null,t):_?(0,n.localize)(40,null,t):(0,n.localize)(41,null,t):t===1?_?(0,n.localize)(42,null,t):(0,n.localize)(43,null,t):_?(0,n.localize)(44,null,t):(0,n.localize)(45,null,t)):(t=Math.floor(u/S),g?t===1?_?(0,n.localize)(46,null,t):(0,n.localize)(47,null,t):_?(0,n.localize)(48,null,t):(0,n.localize)(49,null,t):t===1?_?(0,n.localize)(50,null,t):(0,n.localize)(51,null,t):_?(0,n.localize)(52,null,t):(0,n.localize)(53,null,t))}e.fromNow=h;function R(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Te[126],Pe([10,11]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Te[40],Pe([1,0,16,12,126]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function F(b,g){return g&&(b.stack||b.stacktrace)?D.localize(0,null,P(b),A(b.stack)||A(b.stacktrace)):P(b)}function A(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?D.localize(1,null,b.message):b.message||D.localize(2,null)}function S(b=null,g=!1){if(!b)return D.localize(3,null);if(Array.isArray(b)){const _=n.coalesce(b),p=S(_[0],g);return _.length>1?D.localize(4,null,p,_.length):p}if(T.isString(b))return b;if(b.detail){const _=b.detail;if(_.error)return F(_.error,g);if(_.exception)return F(_.exception,g)}return b.stack?F(b,g):b.message?b.message:D.localize(5,null)}e.toErrorMessage=S;function h(b){const g=b;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=h;function R(b,g){let _;return typeof b=="string"?_=new Error(b):_=b,_.actions=g,_}e.createErrorWithActions=R}),define(Te[127],Pe([1,0,87,19]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new n.Lazy(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),F=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(l,m,E=!1){const f=l||"",L=m||"",W=D.value.collator.compare(f,L);return D.value.collatorIsNumeric&&W===0&&f!==L?f<L?-1:1:W}e.compareFileNames=P;function S(l,m){const E=F.value.collator;return l=l||"",m=m||"",k(E,l,m)}e.compareFileNamesDefault=S;function h(l,m){const E=F.value.collator;return l=l||"",m=m||"",r(l,m)||k(E,l,m)}e.compareFileNamesUpper=h;function R(l,m){const E=F.value.collator;return l=l||"",m=m||"",a(l,m)||k(E,l,m)}e.compareFileNamesLower=R;function b(l,m){return l=l||"",m=m||"",l===m?0:l<m?-1:1}e.compareFileNamesUnicode=b;function g(l,m){const[E,f]=d(l),[L,W]=d(m);let J=D.value.collator.compare(f,W);if(J===0){if(D.value.collatorIsNumeric&&f!==W)return f<W?-1:1;if(J=D.value.collator.compare(E,L),D.value.collatorIsNumeric&&J===0&&E!==L)return E<L?-1:1}return J}e.compareFileExtensions=g;function _(l,m){l=l||"",m=m||"";const E=y(l),f=y(m),L=F.value.collator,W=A.value.collator;return k(W,E,f)||k(L,l,m)}e.compareFileExtensionsDefault=_;function p(l,m){l=l||"",m=m||"";const E=y(l),f=y(m),L=F.value.collator,W=A.value.collator;return k(W,E,f)||r(l,m)||k(L,l,m)}e.compareFileExtensionsUpper=p;function u(l,m){l=l||"",m=m||"";const E=y(l),f=y(m),L=F.value.collator,W=A.value.collator;return k(W,E,f)||a(l,m)||k(L,l,m)}e.compareFileExtensionsLower=u;function t(l,m){l=l||"",m=m||"";const E=y(l).toLowerCase(),f=y(m).toLowerCase();return E!==f?E<f?-1:1:l!==m?l<m?-1:1:0}e.compareFileExtensionsUnicode=t;const o=/^(.*?)(\.([^.]*))?$/;function d(l,m=!1){const E=l?o.exec(l):[];let f=[E&&E[1]||"",E&&E[3]||""];return m&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function y(l){const m=l?o.exec(l):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function k(l,m,E){const f=l.compare(m,E);return f!==0?f:m.length!==E.length?m.length<E.length?-1:1:0}function v(l){const m=l.charAt(0);return m.toLocaleUpperCase()!==m}function i(l){const m=l.charAt(0);return m.toLocaleLowerCase()!==m}function a(l,m){return v(l)&&i(m)?-1:i(l)&&v(m)?1:0}function r(l,m){return i(l)&&v(m)?-1:v(l)&&i(m)?1:0}function s(l,m,E=!1){return E||(l=l&&l.toLowerCase(),m=m&&m.toLowerCase()),l===m?0:l<m?-1:1}function w(l,m,E=!1){const f=l.split(T.sep),L=m.split(T.sep),W=f.length-1,J=L.length-1;let q,U;for(let B=0;;B++){if(q=W===B,U=J===B,q&&U)return P(f[B],L[B],E);if(q)return-1;if(U)return 1;const G=s(f[B],L[B],E);if(G!==0)return G}}e.comparePaths=w;function I(l,m,E){const f=l.toLowerCase(),L=m.toLowerCase(),W=c(l,m,E);if(W)return W;const J=f.endsWith(E),q=L.endsWith(E);if(J!==q)return J?-1:1;const U=P(f,L);return U!==0?U:f.localeCompare(L)}e.compareAnything=I;function c(l,m,E){const f=l.toLowerCase(),L=m.toLowerCase(),W=f.startsWith(E),J=L.startsWith(E);if(W!==J)return W?-1:1;if(W&&J){if(f.length<L.length)return-1;if(f.length>L.length)return 1}return 0}e.compareByPrefix=c}),define(Te[66],Pe([1,0,19]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(R){const b=(0,n.extname)(R),g=T[b.toLowerCase()];return g!==void 0?g:A(R)}e.getMediaOrTextMime=F;function A(R){const b=(0,n.extname)(R);return D[b.toLowerCase()]}e.getMediaMime=A;function P(R){for(const b in D)if(D[b]===R)return b}e.getExtensionForMimeType=P;const S=/^(.+)\/(.+?)(;.+)?$/;function h(R,b){const g=S.exec(R);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:b?void 0:R}e.normalizeMimeType=h}),define(Te[128],Pe([1,0,5,6,123]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class F extends T.Disposable{constructor(g,_="",p="",u=!0,t){super(),this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=g,this._label=_,this._cssClass=p,this._enabled=u,this._actionCallback=t}get id(){return this._id}get label(){return this._label}set label(g){this._setLabel(g)}_setLabel(g){this._label!==g&&(this._label=g,this._onDidChange.fire({label:g}))}get tooltip(){return this._tooltip||""}set tooltip(g){this._setTooltip(g)}_setTooltip(g){this._tooltip!==g&&(this._tooltip=g,this._onDidChange.fire({tooltip:g}))}get class(){return this._cssClass}set class(g){this._setClass(g)}_setClass(g){this._cssClass!==g&&(this._cssClass=g,this._onDidChange.fire({class:g}))}get enabled(){return this._enabled}set enabled(g){this._setEnabled(g)}_setEnabled(g){this._enabled!==g&&(this._enabled=g,this._onDidChange.fire({enabled:g}))}get checked(){return this._checked}set checked(g){this._setChecked(g)}_setChecked(g){this._checked!==g&&(this._checked=g,this._onDidChange.fire({checked:g}))}async run(g,_){this._actionCallback&&await this._actionCallback(g)}}e.Action=F;class A extends T.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new n.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new n.Emitter),this.onDidRun=this._onDidRun.event}async run(g,_){if(!g.enabled)return;this._onWillRun.fire({action:g});let p;try{await this.runAction(g,_)}catch(u){p=u}this._onDidRun.fire({action:g,error:p})}async runAction(g,_){await g.run(_)}}e.ActionRunner=A;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...g){let _=[];for(const p of g)p.length&&(_.length?_=[..._,new P,...p]:_=p);return _}async run(){}}e.Separator=P,P.ID="vs.actions.separator";class S{get actions(){return this._actions}constructor(g,_,p,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=g,this.label=_,this.class=u,this._actions=p}async run(){}}e.SubmenuAction=S;class h extends F{constructor(){super(h.ID,D.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=h,h.ID="vs.actions.empty";function R(b){return{id:b.id,label:b.label,class:void 0,enabled:b.enabled??!0,checked:b.checked??!1,run:async()=>b.run(),tooltip:b.label}}e.toAction=R}),define(Te[41],Pe([1,0,19,20,13,12]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(I){return I===47||I===92}e.isPathSeparator=A;function P(I){return I.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=P;function S(I){return I.indexOf("/")===-1&&(I=P(I)),/^[a-zA-Z]:(\/|$)/.test(I)&&(I="/"+I),I}e.toPosixPath=S;function h(I,c=n.posix.sep){if(!I)return"";const l=I.length,m=I.charCodeAt(0);if(A(m)){if(A(I.charCodeAt(1))&&!A(I.charCodeAt(2))){let f=3;const L=f;for(;f<l&&!A(I.charCodeAt(f));f++);if(L!==f&&!A(I.charCodeAt(f+1))){for(f+=1;f<l;f++)if(A(I.charCodeAt(f)))return I.slice(0,f+1).replace(/[\\/]/g,c)}}return c}else if(o(m)&&I.charCodeAt(1)===58)return A(I.charCodeAt(2))?I.slice(0,2)+c:I.slice(0,2);let E=I.indexOf("://");if(E!==-1){for(E+=3;E<l;E++)if(A(I.charCodeAt(E)))return I.slice(0,E+1)}return""}e.getRoot=h;function R(I){if(!T.isWindows||!I||I.length<5)return!1;let c=I.charCodeAt(0);if(c!==92||(c=I.charCodeAt(1),c!==92))return!1;let l=2;const m=l;for(;l<I.length&&(c=I.charCodeAt(l),c!==92);l++);return!(m===l||(c=I.charCodeAt(l+1),isNaN(c)||c===92))}e.isUNC=R;const b=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,_=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(I,c=T.isWindows){const l=c?b:g;return!(!I||I.length===0||/^\s+$/.test(I)||(l.lastIndex=0,l.test(I))||c&&_.test(I)||I==="."||I===".."||c&&I[I.length-1]==="."||c&&I.length!==I.trim().length||I.length>255)}e.isValidBasename=p;function u(I,c,l){const m=I===c;return!l||m?m:!I||!c?!1:(0,D.equalsIgnoreCase)(I,c)}e.isEqual=u;function t(I,c,l,m=n.sep){if(I===c)return!0;if(!I||!c||c.length>I.length)return!1;if(l){if(!(0,D.startsWithIgnoreCase)(I,c))return!1;if(c.length===I.length)return!0;let f=c.length;return c.charAt(c.length-1)===m&&f--,I.charAt(f)===m}return c.charAt(c.length-1)!==m&&(c+=m),I.indexOf(c)===0}e.isEqualOrParent=t;function o(I){return I>=65&&I<=90||I>=97&&I<=122}e.isWindowsDriveLetter=o;function d(I,c){return T.isWindows&&I.endsWith(":")&&(I+=n.sep),(0,n.isAbsolute)(I)||(I=(0,n.join)(c,I)),I=(0,n.normalize)(I),T.isWindows?(I=(0,D.rtrim)(I,n.sep),I.endsWith(":")&&(I+=n.sep)):(I=(0,D.rtrim)(I,n.sep),I||(I=n.sep)),I}e.sanitizeFilePath=d;function y(I){const c=(0,n.normalize)(I);return T.isWindows?I.length>3?!1:k(c)&&(I.length===2||c.charCodeAt(2)===92):c===n.posix.sep}e.isRootOrDriveLetter=y;function k(I,c=T.isWindows){return c?o(I.charCodeAt(0))&&I.charCodeAt(1)===58:!1}e.hasDriveLetter=k;function v(I){return k(I)?I[0]:void 0}e.getDriveLetter=v;function i(I,c,l){return c.length>I.length?-1:I===c?0:(l&&(I=I.toLowerCase(),c=c.toLowerCase()),I.indexOf(c))}e.indexOfPath=i;function a(I){const c=I.split(":");let l,m,E;for(const f of c){const L=Number(f);(0,F.isNumber)(L)?m===void 0?m=L:E===void 0&&(E=L):l=l?[l,f].join(":"):f}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:m!==void 0?m:void 0,column:E!==void 0?E:m!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(I,c,l=8){let m="";for(let f=0;f<l;f++){let L;f===0&&T.isWindows&&!c&&(l===3||l===4)?L=s:L=r,m+=L.charAt(Math.floor(Math.random()*L.length))}let E;return c?E=`${c}-${m}`:E=m,I?(0,n.join)(I,E):E}e.randomPath=w}),define(Te[129],Pe([1,0,28,13]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...ie){return function(ne,C){for(let z=0,V=ie.length;z<V;z++){const j=ie[z](ne,C);if(j)return j}return null}}e.or=D,e.matchesStrictPrefix=F.bind(void 0,!1),e.matchesPrefix=F.bind(void 0,!0);function F(ie,ne,C){if(!C||C.length<ne.length)return null;let z;return ie?z=T.startsWithIgnoreCase(C,ne):z=C.indexOf(ne)===0,z?ne.length>0?[{start:0,end:ne.length}]:[]:null}function A(ie,ne){const C=ne.toLowerCase().indexOf(ie.toLowerCase());return C===-1?null:[{start:C,end:C+ie.length}]}e.matchesContiguousSubString=A;function P(ie,ne){return S(ie.toLowerCase(),ne.toLowerCase(),0,0)}e.matchesSubString=P;function S(ie,ne,C,z){if(C===ie.length)return[];if(z===ne.length)return null;if(ie[C]===ne[z]){let V=null;return(V=S(ie,ne,C+1,z+1))?o({start:z,end:z+1},V):null}return S(ie,ne,C,z+1)}function h(ie){return 97<=ie&&ie<=122}function R(ie){return 65<=ie&&ie<=90}e.isUpper=R;function b(ie){return 48<=ie&&ie<=57}function g(ie){return ie===32||ie===9||ie===10||ie===13}const _=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>_.add(ie.charCodeAt(0)));function p(ie){return g(ie)||_.has(ie)}function u(ie,ne){return ie===ne||p(ie)&&p(ne)}function t(ie){return h(ie)||R(ie)||b(ie)}function o(ie,ne){return ne.length===0?ne=[ie]:ie.end===ne[0].start?ne[0].start=ie.start:ne.unshift(ie),ne}function d(ie,ne){for(let C=ne;C<ie.length;C++){const z=ie.charCodeAt(C);if(R(z)||b(z)||C>0&&!t(ie.charCodeAt(C-1)))return C}return ie.length}function y(ie,ne,C,z){if(C===ie.length)return[];if(z===ne.length)return null;if(ie[C]!==ne[z].toLowerCase())return null;{let V=null,j=z+1;for(V=y(ie,ne,C+1,z+1);!V&&(j=d(ne,j))<ne.length;)V=y(ie,ne,C+1,j),j++;return V===null?null:o({start:z,end:z+1},V)}}function k(ie){let ne=0,C=0,z=0,V=0,j=0;for(let Se=0;Se<ie.length;Se++)j=ie.charCodeAt(Se),R(j)&&ne++,h(j)&&C++,t(j)&&z++,b(j)&&V++;const ae=ne/ie.length,ge=C/ie.length,ee=z/ie.length,be=V/ie.length;return{upperPercent:ae,lowerPercent:ge,alphaPercent:ee,numericPercent:be}}function v(ie){const{upperPercent:ne,lowerPercent:C}=ie;return C===0&&ne>.6}function i(ie){const{upperPercent:ne,lowerPercent:C,alphaPercent:z,numericPercent:V}=ie;return C>.2&&ne<.8&&z>.6&&V<.2}function a(ie){let ne=0,C=0,z=0,V=0;for(let j=0;j<ie.length;j++)z=ie.charCodeAt(j),R(z)&&ne++,h(z)&&C++,g(z)&&V++;return(ne===0||C===0)&&V===0?ie.length<=30:ne<=5}function r(ie,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!a(ie)||ne.length>60)return null;const C=k(ne);if(!i(C)){if(!v(C))return null;ne=ne.toLowerCase()}let z=null,V=0;for(ie=ie.toLowerCase();V<ne.length&&(z=y(ie,ne,0,V))===null;)V=d(ne,V+1);return z}e.matchesCamelCase=r;function s(ie,ne,C=!1){if(!ne||ne.length===0)return null;let z=null,V=0;for(ie=ie.toLowerCase(),ne=ne.toLowerCase();V<ne.length&&(z=w(ie,ne,0,V,C))===null;)V=I(ne,V+1);return z}e.matchesWords=s;function w(ie,ne,C,z,V){if(C===ie.length)return[];if(z===ne.length)return null;if(u(ie.charCodeAt(C),ne.charCodeAt(z))){let j=null,ae=z+1;if(j=w(ie,ne,C+1,z+1,V),!V)for(;!j&&(ae=I(ne,ae))<ne.length;)j=w(ie,ne,C+1,ae,V),ae++;return j?ie.charCodeAt(C)!==ne.charCodeAt(z)?j:o({start:z,end:z+1},j):null}else return null}function I(ie,ne){for(let C=ne;C<ie.length;C++)if(p(ie.charCodeAt(C))||C>0&&p(ie.charCodeAt(C-1)))return C;return ie.length}const c=D(e.matchesPrefix,r,A),l=D(e.matchesPrefix,r,P),m=new n.LRUCache(1e4);function E(ie,ne,C=!1){if(typeof ie!="string"||typeof ne!="string")return null;let z=m.get(ie);z||(z=new RegExp(T.convertSimple2RegExpPattern(ie),"i"),m.set(ie,z));const V=z.exec(ne);return V?[{start:V.index,end:V.index+V[0].length}]:C?l(ie,ne):c(ie,ne)}e.matchesFuzzy=E;function f(ie,ne){const C=me(ie,ie.toLowerCase(),0,ne,ne.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return C?W(C):null}e.matchesFuzzy2=f;function L(ie,ne,C,z,V,j){const ae=Math.min(13,ie.length);for(;C<ae;C++){const ge=me(ie,ne,C,z,V,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ge)return ge}return[0,j]}e.anyScore=L;function W(ie){if(typeof ie>"u")return[];const ne=[],C=ie[1];for(let z=ie.length-1;z>1;z--){const V=ie[z]+C,j=ne[ne.length-1];j&&j.end===V?j.end=V+1:ne.push({start:V,end:V+1})}return ne}e.createMatches=W;const J=128;function q(){const ie=[],ne=[];for(let C=0;C<=J;C++)ne[C]=0;for(let C=0;C<=J;C++)ie.push(ne.slice(0));return ie}function U(ie){const ne=[];for(let C=0;C<=ie;C++)ne[C]=0;return ne}const B=U(2*J),G=U(2*J),N=q(),H=q(),Q=q(),pe=!1;function we(ie,ne,C,z,V){function j(ge,ee,be=" "){for(;ge.length<ee;)ge=be+ge;return ge}let ae=` |   |${z.split("").map(ge=>j(ge,3)).join("|")}
`;for(let ge=0;ge<=C;ge++)ge===0?ae+=" |":ae+=`${ne[ge-1]}|`,ae+=ie[ge].slice(0,V+1).map(ee=>j(ee.toString(),3)).join("|")+`
`;return ae}function he(ie,ne,C,z){ie=ie.substr(ne),C=C.substr(z),console.log(we(H,ie,ie.length,C,C.length)),console.log(we(Q,ie,ie.length,C,C.length)),console.log(we(N,ie,ie.length,C,C.length))}function de(ie,ne){if(ne<0||ne>=ie.length)return!1;const C=ie.codePointAt(ne);switch(C){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(C)}}function Ae(ie,ne){if(ne<0||ne>=ie.length)return!1;switch(ie.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function ue(ie,ne,C){return ne[ie]!==C[ie]}function le(ie,ne,C,z,V,j,ae=!1){for(;ne<C&&V<j;)ie[ne]===z[V]&&(ae&&(B[ne]=V),ne+=1),V+=1;return ne===C}e.isPatternInWord=le;var $;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})($||($={}));var O;(function(ie){ie.Default=[-100,0];function ne(C){return!C||C.length===2&&C[0]===-100&&C[1]===0}ie.isDefault=ne})(O||(e.FuzzyScore=O={}));class X{constructor(ne,C){this.firstMatchCanBeWeak=ne,this.boostFullMatch=C}}e.FuzzyScoreOptions=X,X.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function me(ie,ne,C,z,V,j,ae=X.default){const ge=ie.length>J?J:ie.length,ee=z.length>J?J:z.length;if(C>=ge||j>=ee||ge-C>ee-j||!le(ne,C,ge,V,j,ee,!0))return;Ce(ge,ee,C,j,ne,V);let be=1,Se=1,xe=C,He=j;const et=[!1];for(be=1,xe=C;xe<ge;be++,xe++){const Me=B[xe],st=G[xe],Z=xe+1<ge?G[xe+1]:ee;for(Se=Me-j+1,He=Me;He<Z;Se++,He++){let Y=Number.MIN_SAFE_INTEGER,_e=!1;He<=st&&(Y=ye(ie,ne,xe,C,z,V,He,ee,j,N[be-1][Se-1]===0,et));let Ne=0;Y!==Number.MAX_SAFE_INTEGER&&(_e=!0,Ne=Y+H[be-1][Se-1]);const ze=He>Me,Xe=ze?H[be][Se-1]+(N[be][Se-1]>0?-5:0):0,We=He>Me+1&&N[be][Se-1]>0,it=We?H[be][Se-2]+(N[be][Se-2]>0?-5:0):0;if(We&&(!ze||it>=Xe)&&(!_e||it>=Ne))H[be][Se]=it,Q[be][Se]=3,N[be][Se]=0;else if(ze&&(!_e||Xe>=Ne))H[be][Se]=Xe,Q[be][Se]=2,N[be][Se]=0;else if(_e)H[be][Se]=Ne,Q[be][Se]=1,N[be][Se]=N[be-1][Se-1]+1;else throw new Error("not possible")}}if(pe&&he(ie,C,z,j),!et[0]&&!ae.firstMatchCanBeWeak)return;be--,Se--;const Qe=[H[be][Se],j];let Ye=0,rt=0;for(;be>=1;){let Me=Se;do{const st=Q[be][Me];if(st===3)Me=Me-2;else if(st===2)Me=Me-1;else break}while(Me>=1);Ye>1&&ne[C+be-1]===V[j+Se-1]&&!ue(Me+j-1,z,V)&&Ye+1>N[be][Me]&&(Me=Se),Me===Se?Ye++:Ye=1,rt||(rt=Me),be--,Se=Me-1,Qe.push(Se)}ee===ge&&ae.boostFullMatch&&(Qe[0]+=2);const lt=rt-ge;return Qe[0]-=lt,Qe}e.fuzzyScore=me;function Ce(ie,ne,C,z,V,j){let ae=ie-1,ge=ne-1;for(;ae>=C&&ge>=z;)V[ae]===j[ge]&&(G[ae]=ge,ae--),ge--}function ye(ie,ne,C,z,V,j,ae,ge,ee,be,Se){if(ne[C]!==j[ae])return Number.MIN_SAFE_INTEGER;let xe=1,He=!1;return ae===C-z?xe=ie[C]===V[ae]?7:5:ue(ae,V,j)&&(ae===0||!ue(ae-1,V,j))?(xe=ie[C]===V[ae]?7:5,He=!0):de(j,ae)&&(ae===0||!de(j,ae-1))?xe=5:(de(j,ae-1)||Ae(j,ae-1))&&(xe=5,He=!0),xe>1&&C===z&&(Se[0]=!0),He||(He=ue(ae,V,j)||de(j,ae-1)||Ae(j,ae-1)),C===z?ae>ee&&(xe-=He?3:5):be?xe+=He?2:0:xe+=He?0:1,ae+1===ge&&(xe-=He?3:5),xe}function Ee(ie,ne,C,z,V,j,ae){return oe(ie,ne,C,z,V,j,!0,ae)}e.fuzzyScoreGracefulAggressive=Ee;function Ie(ie,ne,C,z,V,j,ae){return oe(ie,ne,C,z,V,j,!1,ae)}e.fuzzyScoreGraceful=Ie;function oe(ie,ne,C,z,V,j,ae,ge){let ee=me(ie,ne,C,z,V,j,ge);if(ee&&!ae)return ee;if(ie.length>=3){const be=Math.min(7,ie.length-1);for(let Se=C+1;Se<be;Se++){const xe=ce(ie,Se);if(xe){const He=me(xe,xe.toLowerCase(),C,z,V,j,ge);He&&(He[0]-=3,(!ee||He[0]>ee[0])&&(ee=He))}}}return ee}function ce(ie,ne){if(ne+1>=ie.length)return;const C=ie[ne],z=ie[ne+1];if(C!==z)return ie.slice(0,ne)+z+C+ie.slice(ne+2)}}),define(Te[130],Pe([1,0,129,13,39]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const F="$(",A=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${A.source}`,"g");function S(o){return o.replace(P,(d,y)=>y?d:`\\${d}`)}e.escapeIcons=S;const h=new RegExp(`\\\\${A.source}`,"g");function R(o){return o.replace(h,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=R;const b=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function g(o){return o.indexOf(F)===-1?o:o.replace(b,(d,y,k,v)=>k?d:y||v||"")}e.stripIcons=g;function _(o){return o?o.replace(/\$\((.*?)\)/g,(d,y)=>` ${y} `).trim():""}e.getCodiconAriaLabel=_;const p=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(o){p.lastIndex=0;let d="";const y=[];let k=0;for(;;){const v=p.lastIndex,i=p.exec(o),a=o.substring(v,i?.index);if(a.length>0){d+=a;for(let r=0;r<a.length;r++)y.push(k)}if(!i)break;k+=i[0].length}return{text:d,iconOffsets:y}}e.parseLabelWithIcons=u;function t(o,d,y=!1){const{text:k,iconOffsets:v}=d;if(!v||v.length===0)return(0,n.matchesFuzzy)(o,k,y);const i=(0,T.ltrim)(k," "),a=k.length-i.length,r=(0,n.matchesFuzzy)(o,i,y);if(r)for(const s of r){const w=v[s.start+a]+a;s.start+=w,s.end+=w}return r}e.matchesFuzzyIconAware=t}),define(Te[29],Pe([1,0,13]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(T||(T={})),function(D){const F="error",A="warning",P="warn",S="info",h="ignore";function R(g){return g?n.equalsIgnoreCase(F,g)?D.Error:n.equalsIgnoreCase(A,g)||n.equalsIgnoreCase(P,g)?D.Warning:n.equalsIgnoreCase(S,g)?D.Info:D.Ignore:D.Ignore}D.fromValue=R;function b(g){switch(g){case D.Error:return F;case D.Warning:return A;case D.Info:return S;default:return h}}D.toString=b}(T||(T={})),e.default=T}),define(Te[48],Pe([1,0,16,13]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this._value="",this._pos=0}reset(_){return this._value=_,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(_){const p=_.charCodeAt(0),u=this._value.charCodeAt(this._pos);return p-u}value(){return this._value[this._pos]}}e.StringIterator=D;class F{constructor(_=!0){this._caseSensitive=_}reset(_){return this._value=_,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let _=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(_)this._from++;else break;else _=!1;return this}cmp(_){return this._caseSensitive?(0,T.compareSubstring)(_,this._value,0,_.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(_,this._value,0,_.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=F;class A{constructor(_=!0,p=!0){this._splitOnBackslash=_,this._caseSensitive=p}reset(_){this._from=0,this._to=0,this._value=_,this._valueLen=_.length;for(let p=_.length-1;p>=0;p--,this._valueLen--){const u=this._value.charCodeAt(p);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let _=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(_)this._from++;else break;else _=!1}return this}cmp(_){return this._caseSensitive?(0,T.compareSubstring)(_,this._value,0,_.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(_,this._value,0,_.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=A;var P;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(P||(P={}));class S{constructor(_,p){this._ignorePathCasing=_,this._ignoreQueryAndFragment=p,this._states=[],this._stateIdx=0}reset(_){return this._value=_,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new A(!1,!this._ignorePathCasing(_)),this._pathIterator.reset(_.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(_)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(_){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(_,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(_,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(_);if(this._states[this._stateIdx]===4)return(0,T.compare)(_,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(_,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const _=this.right;return this.right=_.left,_.left=this,this.updateHeight(),_.updateHeight(),_}rotateRight(){const _=this.left;return this.left=_.right,_.right=this,this.updateHeight(),_.updateHeight(),_}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(R||(R={}));class b{static forUris(_=()=>!1,p=()=>!1){return new b(new S(_,p))}static forPaths(_=!1){return new b(new A(void 0,!_))}static forStrings(){return new b(new D)}static forConfigKeys(){return new b(new F)}constructor(_){this._iter=_}clear(){this._root=void 0}fill(_,p){if(p){const u=p.slice(0);(0,n.shuffle)(u);for(const t of u)this.set(t,_)}else{const u=_.slice(0);(0,n.shuffle)(u);for(const t of u)this.set(t[0],t[1])}}set(_,p){const u=this._iter.reset(_);let t;this._root||(this._root=new h,this._root.segment=u.value());const o=[];for(t=this._root;;){const y=u.cmp(t.segment);if(y>0)t.left||(t.left=new h,t.left.segment=u.value()),o.push([-1,t]),t=t.left;else if(y<0)t.right||(t.right=new h,t.right.segment=u.value()),o.push([1,t]),t=t.right;else if(u.hasNext())u.next(),t.mid||(t.mid=new h,t.mid.segment=u.value()),o.push([0,t]),t=t.mid;else break}const d=t.value;t.value=p,t.key=_;for(let y=o.length-1;y>=0;y--){const k=o[y][1];k.updateHeight();const v=k.balanceFactor();if(v<-1||v>1){const i=o[y][0],a=o[y+1][0];if(i===1&&a===1)o[y][1]=k.rotateLeft();else if(i===-1&&a===-1)o[y][1]=k.rotateRight();else if(i===1&&a===-1)k.right=o[y+1][1]=o[y+1][1].rotateRight(),o[y][1]=k.rotateLeft();else if(i===-1&&a===1)k.left=o[y+1][1]=o[y+1][1].rotateLeft(),o[y][1]=k.rotateRight();else throw new Error;if(y>0)switch(o[y-1][0]){case-1:o[y-1][1].left=o[y][1];break;case 1:o[y-1][1].right=o[y][1];break;case 0:o[y-1][1].mid=o[y][1];break}else this._root=o[0][1]}}return d}get(_){return this._getNode(_)?.value}_getNode(_){const p=this._iter.reset(_);let u=this._root;for(;u;){const t=p.cmp(u.segment);if(t>0)u=u.left;else if(t<0)u=u.right;else if(p.hasNext())p.next(),u=u.mid;else break}return u}has(_){const p=this._getNode(_);return!(p?.value===void 0&&p?.mid===void 0)}delete(_){return this._delete(_,!1)}deleteSuperstr(_){return this._delete(_,!0)}_delete(_,p){const u=this._iter.reset(_),t=[];let o=this._root;for(;o;){const d=u.cmp(o.segment);if(d>0)t.push([-1,o]),o=o.left;else if(d<0)t.push([1,o]),o=o.right;else if(u.hasNext())u.next(),t.push([0,o]),o=o.mid;else break}if(o){if(p?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const d=this._min(o.right);if(d.key){const{key:y,value:k,segment:v}=d;this._delete(d.key,!1),o.key=y,o.value=k,o.segment=v}}else{const d=o.left??o.right;if(t.length>0){const[y,k]=t[t.length-1];switch(y){case-1:k.left=d;break;case 0:k.mid=d;break;case 1:k.right=d;break}}else this._root=d}for(let d=t.length-1;d>=0;d--){const y=t[d][1];y.updateHeight();const k=y.balanceFactor();if(k>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),t[d][1]=y.rotateLeft()):k<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),t[d][1]=y.rotateRight()),d>0)switch(t[d-1][0]){case-1:t[d-1][1].left=t[d][1];break;case 1:t[d-1][1].right=t[d][1];break;case 0:t[d-1][1].mid=t[d][1];break}else this._root=t[0][1]}}}_min(_){for(;_.left;)_=_.left;return _}findSubstr(_){const p=this._iter.reset(_);let u=this._root,t;for(;u;){const o=p.cmp(u.segment);if(o>0)u=u.left;else if(o<0)u=u.right;else if(p.hasNext())p.next(),t=u.value||t,u=u.mid;else break}return u&&u.value||t}findSuperstr(_){return this._findSuperstrOrElement(_,!1)}_findSuperstrOrElement(_,p){const u=this._iter.reset(_);let t=this._root;for(;t;){const o=u.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(u.hasNext())u.next(),t=t.mid;else return t.mid?this._entries(t.mid):p?t.value:void 0}}hasElementOrSubtree(_){return this._findSuperstrOrElement(_,!0)!==void 0}forEach(_){for(const[p,u]of this)_(u,p)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(_){const p=[];return this._dfsEntries(_,p),p[Symbol.iterator]()}_dfsEntries(_,p){_&&(_.left&&this._dfsEntries(_.left,p),_.value&&p.push([_.key,_.value]),_.mid&&this._dfsEntries(_.mid,p),_.right&&this._dfsEntries(_.right,p))}_isBalanced(){const _=p=>{if(!p)return!0;const u=p.balanceFactor();return u<-1||u>1?!1:_(p.left)&&_(p.right)};return _(this._root)}}e.TernarySearchTree=b}),define(Te[67],Pe([1,0,25,13,2]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function F(h){return JSON.stringify(h,P)}e.stringify=F;function A(h){let R=JSON.parse(h);return R=S(R),R}e.parse=A;function P(h,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,T.regExpFlags)(R)}:R}function S(h,R=0){if(!h||R>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof n.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let b=0;b<h.length;++b)h[b]=S(h[b],R+1);else for(const b in h)Object.hasOwnProperty.call(h,b)&&(h[b]=S(h[b],R+1))}return h}e.revive=S}),define(Te[15],Pe([1,0,9,20,2]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var F;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractive="vscode-interactive",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeInteractiveSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(F||(e.Schemas=F={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${F.vscodeRemoteResource}`}setPreferredWebSchema(R){this._preferredWebSchema=R}setDelegate(R){this._delegate=R}setServerRootPath(R){this._remoteResourcesPath=`${R}/${F.vscodeRemoteResource}`}set(R,b,g){this._hosts[R]=b,this._ports[R]=g}setConnectionToken(R,b){this._connectionTokens[R]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(R){if(this._delegate)try{return this._delegate(R)}catch(t){return n.onUnexpectedError(t),R}const b=R.authority;let g=this._hosts[b];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const _=this._ports[b],p=this._connectionTokens[b];let u=`path=${encodeURIComponent(R.path)}`;return typeof p=="string"&&(u+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),D.URI.from({scheme:T.isWeb?this._preferredWebSchema:F.vscodeRemoteResource,authority:`${g}:${_}`,path:this._remoteResourcesPath,query:u})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(R){const b=this.toUri(R,te);return this.uriToBrowserUri(b)}uriToBrowserUri(R){return R.scheme===F.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===F.file&&(T.isNative||T.isWebWorker&&T.globals.origin===`${F.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?R.with({scheme:F.vscodeFileResource,authority:R.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(R){const b=this.toUri(R,te);return this.uriToFileUri(b)}uriToFileUri(R){return R.scheme===F.vscodeFileResource?R.with({scheme:F.file,authority:R.authority!==P.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(R,b){return D.URI.isUri(R)?R:D.URI.parse(b.toUrl(R))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P;var S;(function(h){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(R.get("3"));const b="vscode-coi";function g(p){let u;typeof p=="string"?u=new URL(p).searchParams:p instanceof URL?u=p.searchParams:D.URI.isUri(p)&&(u=new URL(p.toString(!0)).searchParams);const t=u?.get(b);if(t)return R.get(t)}h.getHeadersFromQuery=g;function _(p,u,t){if(!globalThis.crossOriginIsolated)return;const o=u&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(b,o):p[b]=o}h.addSearchParam=_})(S||(e.COI=S={}))}),define(Te[22],Pe([1,0,41,15,19,20,13,2]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(_){return(0,P.uriToFsPath)(_,!0)}e.originalFSPath=S;class h{constructor(p){this._ignorePathCasing=p}compare(p,u,t=!1){return p===u?0:(0,A.compare)(this.getComparisonKey(p,t),this.getComparisonKey(u,t))}isEqual(p,u,t=!1){return p===u?!0:!p||!u?!1:this.getComparisonKey(p,t)===this.getComparisonKey(u,t)}getComparisonKey(p,u=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,u,t=!1){if(p.scheme===u.scheme){if(p.scheme===T.Schemas.file)return n.isEqualOrParent(S(p),S(u),this._ignorePathCasing(p))&&p.query===u.query&&(t||p.fragment===u.fragment);if((0,e.isEqualAuthority)(p.authority,u.authority))return n.isEqualOrParent(p.path,u.path,this._ignorePathCasing(p),"/")&&p.query===u.query&&(t||p.fragment===u.fragment)}return!1}joinPath(p,...u){return P.URI.joinPath(p,...u)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return D.posix.basename(p.path)}extname(p){return D.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let u;return p.scheme===T.Schemas.file?u=P.URI.file(D.dirname(S(p))).path:(u=D.posix.dirname(p.path),p.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),u="/")),p.with({path:u})}normalizePath(p){if(!p.path.length)return p;let u;return p.scheme===T.Schemas.file?u=P.URI.file(D.normalize(S(p))).path:u=D.posix.normalize(p.path),p.with({path:u})}relativePath(p,u){if(p.scheme!==u.scheme||!(0,e.isEqualAuthority)(p.authority,u.authority))return;if(p.scheme===T.Schemas.file){const d=D.relative(S(p),S(u));return F.isWindows?n.toSlashes(d):d}let t=p.path||"/";const o=u.path||"/";if(this._ignorePathCasing(p)){let d=0;for(const y=Math.min(t.length,o.length);d<y&&!(t.charCodeAt(d)!==o.charCodeAt(d)&&t.charAt(d).toLowerCase()!==o.charAt(d).toLowerCase());d++);t=o.substr(0,d)+t.substr(d)}return D.posix.relative(t,o)}resolvePath(p,u){if(p.scheme===T.Schemas.file){const t=P.URI.file(D.resolve(S(p),u));return p.with({authority:t.authority,path:t.path})}return u=n.toPosixPath(u),p.with({path:D.posix.resolve(p.path,u)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,u){return p===u||p!==void 0&&u!==void 0&&(0,A.equalsIgnoreCase)(p,u)}hasTrailingPathSeparator(p,u=D.sep){if(p.scheme===T.Schemas.file){const t=S(p);return t.length>n.getRoot(t).length&&t[t.length-1]===u}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,u=D.sep){return(0,e.hasTrailingPathSeparator)(p,u)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,u=D.sep){let t=!1;if(p.scheme===T.Schemas.file){const o=S(p);t=o!==void 0&&o.length===n.getRoot(o).length&&o[o.length-1]===u}else{u="/";const o=p.path;t=o.length===1&&o.charCodeAt(o.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(p,u)?p.with({path:p.path+"/"}):p}}e.ExtUri=h,e.extUri=new h(()=>!1),e.extUriBiasedIgnorePathCase=new h(_=>_.scheme===T.Schemas.file?!F.isLinux:!0),e.extUriIgnorePathCase=new h(_=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(_,p){const u=[];for(let t=0;t<_.length;t++){const o=p(_[t]);_.some((d,y)=>y===t?!1:(0,e.isEqualOrParent)(o,p(d)))||u.push(_[t])}return u}e.distinctParents=R;var b;(function(_){_.META_DATA_LABEL="label",_.META_DATA_DESCRIPTION="description",_.META_DATA_SIZE="size",_.META_DATA_MIME="mime";function p(u){const t=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(y=>{const[k,v]=y.split(":");k&&v&&t.set(k,v)});const d=u.path.substring(0,u.path.indexOf(";"));return d&&t.set(_.META_DATA_MIME,d),t}_.parseMetaData=p})(b||(e.DataUri=b={}));function g(_,p,u){if(p){let t=_.path;return t&&t[0]!==D.posix.sep&&(t=D.posix.sep+t),_.with({scheme:u,authority:p,path:t})}return _.with({scheme:u})}e.toLocalResource=g}),define(Te[17],Pe([1,0,21,9,5,6,22,20,118]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(le){return!!le&&typeof le.then=="function"}e.isThenable=h;function R(le){const $=new n.CancellationTokenSource,O=le($.token),X=new Promise((me,Ce)=>{const ye=$.token.onCancellationRequested(()=>{ye.dispose(),$.dispose(),Ce(new T.CancellationError)});Promise.resolve(O).then(Ee=>{ye.dispose(),$.dispose(),me(Ee)},Ee=>{ye.dispose(),$.dispose(),Ce(Ee)})});return new class{cancel(){$.cancel()}then(me,Ce){return X.then(me,Ce)}catch(me){return this.then(void 0,me)}finally(me){return X.finally(me)}}}e.createCancelablePromise=R;function b(le,$,O){return new Promise((X,me)=>{const Ce=$.onCancellationRequested(()=>{Ce.dispose(),X(O)});le.then(X,me).finally(()=>Ce.dispose())})}e.raceCancellation=b;function g(le,$){return new Promise((O,X)=>{const me=$.onCancellationRequested(()=>{me.dispose(),X(new T.CancellationError)});le.then(O,X).finally(()=>me.dispose())})}e.raceCancellationError=g;async function _(le){let $=-1;const O=le.map((X,me)=>X.then(Ce=>($=me,Ce)));try{return await Promise.race(O)}finally{le.forEach((X,me)=>{me!==$&&X.cancel()})}}e.raceCancellablePromises=_;function p(le,$,O){let X;const me=setTimeout(()=>{X?.(void 0),O?.()},$);return Promise.race([le.finally(()=>clearTimeout(me)),new Promise(Ce=>X=Ce)])}e.raceTimeout=p;function u(le){return new Promise(($,O)=>{const X=le();h(X)?X.then($,O):$(X)})}e.asPromise=u;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const X=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,X};this.queuedPromise=new Promise(X=>{this.activePromise.then(O,O).then(X)})}return new Promise((O,X)=>{this.queuedPromise.then(O,X)})}return this.activePromise=$(),new Promise((O,X)=>{this.activePromise.then(me=>{this.activePromise=null,O(me)},me=>{this.activePromise=null,X(me)})})}}e.Throttler=t;class o{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=o;class d{constructor(){this.promiseMap=new Map}queue($,O){const me=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get($)===me&&this.promiseMap.delete($)});return this.promiseMap.set($,me),me}}e.SequencerByKey=d;const y=(le,$)=>{let O=!0;const X=setTimeout(()=>{O=!1,$()},le);return{isTriggered:()=>O,dispose:()=>{clearTimeout(X),O=!1}}},k=le=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,le())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};class v{constructor($){this.defaultDelay=$,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,O=this.defaultDelay){this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((me,Ce)=>{this.doResolve=me,this.doReject=Ce}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const me=this.task;return this.task=null,me()}}));const X=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===S.MicrotaskDelay?k(X):y(O,X),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new T.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=v;class i{constructor($){this.delayer=new v($),this.throttler=new t}trigger($,O){return this.delayer.trigger(()=>this.throttler.queue($),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=i;class a{constructor(){this._isOpen=!1,this._promise=new Promise(($,O)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class r extends a{constructor($){super(),this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function s(le,$){return $?new Promise((O,X)=>{const me=setTimeout(()=>{Ce.dispose(),O()},le),Ce=$.onCancellationRequested(()=>{clearTimeout(me),Ce.dispose(),X(new T.CancellationError)})}):R(O=>s(le,O))}e.timeout=s;function w(le,$=0){const O=setTimeout(le,$);return(0,F.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=w;function I(le){const $=[];let O=0;const X=le.length;function me(){return O<X?le[O++]():null}function Ce(ye){ye!=null&&$.push(ye);const Ee=me();return Ee?Ee.then(Ce):Promise.resolve($)}return Promise.resolve(null).then(Ce)}e.sequence=I;function c(le,$=X=>!!X,O=null){let X=0;const me=le.length,Ce=()=>{if(X>=me)return Promise.resolve(O);const ye=le[X++];return Promise.resolve(ye()).then(Ie=>$(Ie)?Promise.resolve(Ie):Ce())};return Ce()}e.first=c;function l(le,$=X=>!!X,O=null){if(le.length===0)return Promise.resolve(O);let X=le.length;const me=()=>{X=-1;for(const Ce of le)Ce.cancel?.()};return new Promise((Ce,ye)=>{for(const Ee of le)Ee.then(Ie=>{--X>=0&&$(Ie)?(me(),Ce(Ie)):X===0&&Ce(O)}).catch(Ie=>{--X>=0&&(me(),ye(Ie))})})}e.firstParallel=l;class m{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue($){return this._size++,new Promise((O,X)=>{this.outstandingPromises.push({factory:$,c:O,e:X}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const O=$.factory();O.then($.c,$.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=m;class E extends m{constructor(){super(1)}}e.Queue=E;class f{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const $=new pe;return this.drainers.add($),$.p}isDrained(){for(const[,$]of this.queues)if($.size>0)return!1;return!0}queueFor($,O=A.extUri){const X=O.getComparisonKey($);let me=this.queues.get(X);return me||(me=new E,D.Event.once(me.onDrained)(()=>{me?.dispose(),this.queues.delete(X),this.onDidQueueDrain()}),this.queues.set(X,me)),me}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const $ of this.drainers)$.complete();this.drainers.clear()}dispose(){for(const[,$]of this.queues)$.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=f;class L{constructor($,O){this._token=-1,typeof $=="function"&&typeof O=="number"&&this.setIfNotSet($,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},O)}setIfNotSet($,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},O))}}e.TimeoutTimer=L;class W{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,O){this.cancel(),this._token=setInterval(()=>{$()},O)}}e.IntervalTimer=W;class J{constructor($,O){this.timeoutToken=-1,this.runner=$,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=J;class q{constructor($,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=q;class U extends J{constructor($,O){super($,O),this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner?.($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class B extends F.Disposable{constructor($,O){super(),this.options=$,this.handler=O,this.pendingWork=[],this.throttler=this._register(new F.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.options.maxBufferedWork)return!1}else if(this.pending+$.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const O of $)this.pendingWork.push(O);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new J(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=le=>{(0,P.setTimeout0)(()=>{if($)return;const O=Date.now()+15;le(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let $=!1;return{dispose(){$||($=!0)}}}:e.runWhenIdle=(le,$)=>{const O=requestIdleCallback(le,typeof $=="number"?{timeout:$}:void 0);let X=!1;return{dispose(){X||(X=!0,cancelIdleCallback(O))}}}}();class G{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=G;async function N(le,$,O){let X;for(let me=0;me<O;me++)try{return await le()}catch(Ce){X=Ce,await s($)}throw X}e.retry=N;class H{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending($,O,X){return this._pending={taskId:$,cancel:()=>X?.(),promise:O},O.then(()=>this.donePending($),()=>this.donePending($)),O}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let O,X;const me=new Promise((Ce,ye)=>{O=Ce,X=ye});this._next={run:$,promise:me,promiseResolve:O,promiseReject:X}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=H;class Q{constructor($,O=()=>Date.now()){this.interval=$,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const $=this.nowFn();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class pe{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,O)=>{this.completeCallback=$,this.errorCallback=O})}complete($){return new Promise(O=>{this.completeCallback($),this.resolved=!0,O()})}error($){return new Promise(O=>{this.errorCallback($),this.rejected=!0,O()})}cancel(){new Promise($=>{this.errorCallback(new T.CancellationError),this.rejected=!0,$()})}}e.DeferredPromise=pe;var we;(function(le){async function $(X){let me;const Ce=await Promise.all(X.map(ye=>ye.then(Ee=>Ee,Ee=>{me||(me=Ee)})));if(typeof me<"u")throw me;return Ce}le.settled=$;function O(X){return new Promise(async(me,Ce)=>{try{await X(me,Ce)}catch(ye){Ce(ye)}})}le.withAsyncBody=O})(we||(e.Promises=we={}));var he;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(he||(he={}));class de{static fromArray($){return new de(O=>{O.emitMany($)})}static fromPromise($){return new de(async O=>{O.emitMany(await $)})}static fromPromises($){return new de(async O=>{await Promise.all($.map(async X=>O.emitOne(await X)))})}static merge($){return new de(async O=>{await Promise.all($.map(async X=>{for await(const me of X)O.emitOne(me)}))})}constructor($){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const O={emitOne:X=>this.emitOne(X),emitMany:X=>this.emitMany(X),reject:X=>this.reject(X)};try{await Promise.resolve($(O)),this.resolve()}catch(X){this.reject(X)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this._state===2)throw this._error;if($<this._results.length)return{done:!1,value:this._results[$++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map($,O){return new de(async X=>{for await(const me of $)X.emitOne(O(me))})}map($){return de.map(this,$)}static filter($,O){return new de(async X=>{for await(const me of $)O(me)&&X.emitOne(me)})}filter($){return de.filter(this,$)}static coalesce($){return de.filter($,O=>!!O)}coalesce(){return de.coalesce(this)}static async toPromise($){const O=[];for await(const X of $)O.push(X);return O}toPromise(){return de.toPromise(this)}emitOne($){this._state===0&&(this._results.push($),this._onStateChanged.fire())}emitMany($){this._state===0&&(this._results=this._results.concat($),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject($){this._state===0&&(this._state=2,this._error=$,this._onStateChanged.fire())}}e.AsyncIterableObject=de,de.EMPTY=de.fromArray([]);class Ae extends de{constructor($,O){super(O),this._source=$}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Ae;function ue(le){const $=new n.CancellationTokenSource,O=le($.token);return new Ae($,async X=>{const me=$.token.onCancellationRequested(()=>{me.dispose(),$.dispose(),X.reject(new T.CancellationError)});try{for await(const Ce of O){if($.token.isCancellationRequested)return;X.emitOne(Ce)}me.dispose(),$.dispose()}catch(Ce){me.dispose(),$.dispose(),X.reject(Ce)}})}e.createCancelableAsyncIterable=ue}),define(Te[36],Pe([1,0,16,17,41,28,19,20,13]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function h(){return Object.create(null)}e.getEmptyExpression=h,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",b="[^/\\\\]",g=/\//g;function _(Q,pe){switch(Q){case 0:return"";case 1:return`${b}*?`;default:return`(?:${R}|${b}+${R}${pe?`|${R}${b}+`:""})*?`}}function p(Q,pe){if(!Q)return[];const we=[];let he=!1,de=!1,Ae="";for(const ue of Q){switch(ue){case pe:if(!he&&!de){we.push(Ae),Ae="";continue}break;case"{":he=!0;break;case"}":he=!1;break;case"[":de=!0;break;case"]":de=!1;break}Ae+=ue}return Ae&&we.push(Ae),we}e.splitGlobAware=p;function u(Q){if(!Q)return"";let pe="";const we=p(Q,e.GLOB_SPLIT);if(we.every(he=>he===e.GLOBSTAR))pe=".*";else{let he=!1;we.forEach((de,Ae)=>{if(de===e.GLOBSTAR){if(he)return;pe+=_(2,Ae===we.length-1)}else{let ue=!1,le="",$=!1,O="";for(const X of de){if(X!=="}"&&ue){le+=X;continue}if($&&(X!=="]"||!O)){let me;X==="-"?me=X:(X==="^"||X==="!")&&!O?me="^":X===e.GLOB_SPLIT?me="":me=(0,S.escapeRegExpCharacters)(X),O+=me;continue}switch(X){case"{":ue=!0;continue;case"[":$=!0;continue;case"}":{const Ce=`(?:${p(le,",").map(ye=>u(ye)).join("|")})`;pe+=Ce,ue=!1,le="";break}case"]":{pe+="["+O+"]",$=!1,O="";break}case"?":pe+=b;continue;case"*":pe+=_(1);continue;default:pe+=(0,S.escapeRegExpCharacters)(X)}}Ae<we.length-1&&(we[Ae+1]!==e.GLOBSTAR||Ae+2<we.length)&&(pe+=R)}he=de===e.GLOBSTAR})}return pe}const t=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new F.LRUCache(1e4),a=function(){return!1},r=function(){return null};function s(Q,pe){if(!Q)return r;let we;typeof Q!="string"?we=Q.pattern:we=Q,we=we.trim();const he=`${we}_${!!pe.trimForExclusions}`;let de=i.get(he);if(de)return w(de,Q);let Ae;return t.test(we)?de=c(we.substr(4),we):(Ae=o.exec(I(we,pe)))?de=l(Ae[1],we):(pe.trimForExclusions?y:d).test(we)?de=m(we,pe):(Ae=k.exec(I(we,pe)))?de=E(Ae[1].substr(1),we,!0):(Ae=v.exec(I(we,pe)))?de=E(Ae[1],we,!1):de=f(we),i.set(he,de),w(de,Q)}function w(Q,pe){if(typeof pe=="string")return Q;const we=function(he,de){return(0,D.isEqualOrParent)(he,pe.base,!P.isLinux)?Q((0,S.ltrim)(he.substr(pe.base.length),A.sep),de):null};return we.allBasenames=Q.allBasenames,we.allPaths=Q.allPaths,we.basenames=Q.basenames,we.patterns=Q.patterns,we}function I(Q,pe){return pe.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function c(Q,pe){return function(we,he){return typeof we=="string"&&we.endsWith(Q)?pe:null}}function l(Q,pe){const we=`/${Q}`,he=`\\${Q}`,de=function(ue,le){return typeof ue!="string"?null:le?le===Q?pe:null:ue===Q||ue.endsWith(we)||ue.endsWith(he)?pe:null},Ae=[Q];return de.basenames=Ae,de.patterns=[pe],de.allBasenames=Ae,de}function m(Q,pe){const we=N(Q.slice(1,-1).split(",").map(le=>s(le,pe)).filter(le=>le!==r),Q),he=we.length;if(!he)return r;if(he===1)return we[0];const de=function(le,$){for(let O=0,X=we.length;O<X;O++)if(we[O](le,$))return Q;return null},Ae=we.find(le=>!!le.allBasenames);Ae&&(de.allBasenames=Ae.allBasenames);const ue=we.reduce((le,$)=>$.allPaths?le.concat($.allPaths):le,[]);return ue.length&&(de.allPaths=ue),de}function E(Q,pe,we){const he=A.sep===A.posix.sep,de=he?Q:Q.replace(g,A.sep),Ae=A.sep+de,ue=A.posix.sep+Q;let le;return we?le=function($,O){return typeof $=="string"&&($===de||$.endsWith(Ae)||!he&&($===Q||$.endsWith(ue)))?pe:null}:le=function($,O){return typeof $=="string"&&($===de||!he&&$===Q)?pe:null},le.allPaths=[(we?"*/":"./")+Q],le}function f(Q){try{const pe=new RegExp(`^${u(Q)}$`);return function(we){return pe.lastIndex=0,typeof we=="string"&&pe.test(we)?Q:null}}catch{return r}}function L(Q,pe,we){return!Q||typeof pe!="string"?!1:W(Q)(pe,void 0,we)}e.match=L;function W(Q,pe={}){if(!Q)return a;if(typeof Q=="string"||J(Q)){const we=s(Q,pe);if(we===r)return a;const he=function(de,Ae){return!!we(de,Ae)};return we.allBasenames&&(he.allBasenames=we.allBasenames),we.allPaths&&(he.allPaths=we.allPaths),he}return B(Q,pe)}e.parse=W;function J(Q){const pe=Q;return pe?typeof pe.base=="string"&&typeof pe.pattern=="string":!1}e.isRelativePattern=J;function q(Q){return Q.allBasenames||[]}e.getBasenameTerms=q;function U(Q){return Q.allPaths||[]}e.getPathTerms=U;function B(Q,pe){const we=N(Object.getOwnPropertyNames(Q).map(le=>G(le,Q[le],pe)).filter(le=>le!==r)),he=we.length;if(!he)return r;if(!we.some(le=>!!le.requiresSiblings)){if(he===1)return we[0];const le=function(X,me){let Ce;for(let ye=0,Ee=we.length;ye<Ee;ye++){const Ie=we[ye](X,me);if(typeof Ie=="string")return Ie;(0,T.isThenable)(Ie)&&(Ce||(Ce=[]),Ce.push(Ie))}return Ce?(async()=>{for(const ye of Ce){const Ee=await ye;if(typeof Ee=="string")return Ee}return null})():null},$=we.find(X=>!!X.allBasenames);$&&(le.allBasenames=$.allBasenames);const O=we.reduce((X,me)=>me.allPaths?X.concat(me.allPaths):X,[]);return O.length&&(le.allPaths=O),le}const de=function(le,$,O){let X,me;for(let Ce=0,ye=we.length;Ce<ye;Ce++){const Ee=we[Ce];Ee.requiresSiblings&&O&&($||($=(0,A.basename)(le)),X||(X=$.substr(0,$.length-(0,A.extname)(le).length)));const Ie=Ee(le,$,X,O);if(typeof Ie=="string")return Ie;(0,T.isThenable)(Ie)&&(me||(me=[]),me.push(Ie))}return me?(async()=>{for(const Ce of me){const ye=await Ce;if(typeof ye=="string")return ye}return null})():null},Ae=we.find(le=>!!le.allBasenames);Ae&&(de.allBasenames=Ae.allBasenames);const ue=we.reduce((le,$)=>$.allPaths?le.concat($.allPaths):le,[]);return ue.length&&(de.allPaths=ue),de}function G(Q,pe,we){if(pe===!1)return r;const he=s(Q,we);if(he===r)return r;if(typeof pe=="boolean")return he;if(pe){const de=pe.when;if(typeof de=="string"){const Ae=(ue,le,$,O)=>{if(!O||!he(ue,le))return null;const X=de.replace("$(basename)",()=>$),me=O(X);return(0,T.isThenable)(me)?me.then(Ce=>Ce?Q:null):me?Q:null};return Ae.requiresSiblings=!0,Ae}}return he}function N(Q,pe){const we=Q.filter(le=>!!le.basenames);if(we.length<2)return Q;const he=we.reduce((le,$)=>{const O=$.basenames;return O?le.concat(O):le},[]);let de;if(pe){de=[];for(let le=0,$=he.length;le<$;le++)de.push(pe)}else de=we.reduce((le,$)=>{const O=$.patterns;return O?le.concat(O):le},[]);const Ae=function(le,$){if(typeof le!="string")return null;if(!$){let X;for(X=le.length;X>0;X--){const me=le.charCodeAt(X-1);if(me===47||me===92)break}$=le.substr(X)}const O=he.indexOf($);return O!==-1?de[O]:null};Ae.basenames=he,Ae.patterns=de,Ae.allBasenames=he;const ue=Q.filter(le=>!le.basenames);return ue.push(Ae),ue}function H(Q,pe){return(0,n.equals)(Q,pe,(we,he)=>typeof we=="string"&&typeof he=="string"?we===he:typeof we!="string"&&typeof he!="string"?we.base===he.base&&we.pattern===he.pattern:!1)}e.patternsEquals=H}),define(Te[88],Pe([1,0,9,130,22,13,2]),function(te,e,n,T,D,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(P||(e.MarkdownStringTextNewlineStyle=P={}));class S{constructor(o="",d=!1){if(this.value=o,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(o,d=0){return this.value+=g(this.supportThemeIcons?(0,T.escapeIcons)(o):o).replace(/([ \t]+)/g,(y,k)=>"&nbsp;".repeat(k.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,d){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}appendLink(o,d,y){return this.value+="[",this.value+=this._escape(d,"]"),this.value+="](",this.value+=this._escape(String(o),")"),y&&(this.value+=` "${this._escape(this._escape(y,'"'),")")}"`),this.value+=")",this}_escape(o,d){const y=new RegExp((0,F.escapeRegExpCharacters)(d),"g");return o.replace(y,(k,v)=>o.charAt(v-1)!=="\\"?`\\${k}`:k)}}e.MarkdownString=S;function h(t){return R(t)?!t.value:Array.isArray(t)?t.every(h):!0}e.isEmptyMarkdownString=h;function R(t){return t instanceof S?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function b(t,o){return t===o?!0:!t||!o?!1:t.value===o.value&&t.isTrusted===o.isTrusted&&t.supportThemeIcons===o.supportThemeIcons&&t.supportHtml===o.supportHtml&&(t.baseUri===o.baseUri||!!t.baseUri&&!!o.baseUri&&(0,D.isEqual)(A.URI.from(t.baseUri),A.URI.from(o.baseUri)))}e.markdownStringEqual=b;function g(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=g;function _(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=_;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=p;function u(t){const o=[],d=t.split("|").map(k=>k.trim());t=d[0];const y=d[1];if(y){const k=/height=(\d+)/.exec(y),v=/width=(\d+)/.exec(y),i=k?k[1]:"",a=v?v[1]:"",r=isFinite(parseInt(a)),s=isFinite(parseInt(i));r&&o.push(`width="${a}"`),s&&o.push(`height="${i}"`)}return{href:t,dimensions:o}}e.parseHrefAndDimensions=u}),define(Te[89],Pe([1,0,16,41,19,20,22,13]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(r,s){const{os:w,tildify:I,relative:c}=s;if(c){const E=h(r,c,w);if(typeof E=="string")return E}let l=r.fsPath;if(w===1&&!F.isWindows?l=l.replace(/\//g,"\\"):w!==1&&F.isWindows&&(l=l.replace(/\\/g,"/")),w!==1&&I?.userHome){const E=I.userHome.fsPath;let f;r.scheme!==I.userHome.scheme&&r.path.startsWith(D.posix.sep)?f=I.userHome.with({path:r.path}).fsPath:f=r.fsPath,l=g(f,E,w)}return(w===1?D.win32:D.posix).normalize(R(l,w===1))}e.getPathLabel=S;function h(r,s,w){const I=w===1?D.win32:D.posix,c=w===3?A.extUri:A.extUriIgnorePathCase,l=s.getWorkspace(),m=(0,n.firstOrDefault)(l.folders);if(!m)return;r.scheme!==m.uri.scheme&&r.path.startsWith(D.posix.sep)&&(r=m.uri.with({path:r.path}));const E=s.getWorkspaceFolder(r);if(!E)return;let f;if(c.isEqual(E.uri,r)?f="":f=c.relativePath(E.uri,r)??"",f&&(f=I.normalize(f)),l.folders.length>1&&!s.noPrefix){const L=E.name?E.name:c.basenameOrAuthority(E.uri);f=f?`${L} \u2022 ${f}`:L}return f}function R(r,s=F.isWindows){return(0,T.hasDriveLetter)(r,s)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=R;let b=Object.create(null);function g(r,s,w=F.OS){if(w===1||!r||!s)return r;let I=b.original===s?b.normalized:void 0;I||(I=s,F.isWindows&&(I=(0,T.toSlashes)(I)),I=`${(0,P.rtrim)(I,D.posix.sep)}${D.posix.sep}`,b={original:s,normalized:I});let c=r;return F.isWindows&&(c=(0,T.toSlashes)(c)),(w===3?c.startsWith(I):(0,P.startsWithIgnoreCase)(c,I))?`~/${c.substr(I.length)}`:r}e.tildify=g;function _(r,s){return r.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=_;const p="\u2026",u="\\\\",t="~";function o(r,s=D.sep){const w=new Array(r.length);let I=!1;for(let c=0;c<r.length;c++){const l=r[c];if(l===""){w[c]=`.${s}`;continue}if(!l){w[c]=l;continue}I=!0;let m="",E=l;E.indexOf(u)===0?(m=E.substr(0,E.indexOf(u)+u.length),E=E.substr(E.indexOf(u)+u.length)):E.indexOf(s)===0?(m=E.substr(0,E.indexOf(s)+s.length),E=E.substr(E.indexOf(s)+s.length)):E.indexOf(t)===0&&(m=E.substr(0,E.indexOf(t)+t.length),E=E.substr(E.indexOf(t)+t.length));const f=E.split(s);for(let L=1;I&&L<=f.length;L++)for(let W=f.length-L;I&&W>=0;W--){I=!1;let J=f.slice(W,W+L).join(s);for(let q=0;!I&&q<r.length;q++)if(q!==c&&r[q]&&r[q].indexOf(J)>-1){const U=W+L===f.length,B=W>0&&r[q].indexOf(s)>-1?s+J:J,G=r[q].endsWith(B);I=!U||G}if(!I){let q="";(f[0].endsWith(":")||m!=="")&&(W===1&&(W=0,L++,J=f[0]+s+J),W>0&&(q=f[0]+s),q=m+q),W>0&&(q=q+p+s),q=q+J,W+L<f.length&&(q=q+s+p),w[c]=q}}I&&(w[c]=l)}return w}e.shorten=o;var d;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function y(r,s=Object.create(null)){const w=[];let I=!1,c="";for(const l of r)if(l==="$"||I&&l==="{")c&&w.push({value:c,type:d.TEXT}),c="",I=!0;else if(l==="}"&&I){const m=s[c];if(typeof m=="string")m.length&&w.push({value:m,type:d.VARIABLE});else if(m){const E=w[w.length-1];(!E||E.type!==d.SEPARATOR)&&w.push({value:m.label,type:d.SEPARATOR})}c="",I=!1}else c+=l;return c&&!I&&w.push({value:c,type:d.TEXT}),w.filter((l,m)=>{if(l.type===d.SEPARATOR){const E=w[m-1],f=w[m+1];return[E,f].every(L=>L&&(L.type===d.VARIABLE||L.type===d.TEXT)&&L.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=y;function k(r,s){return F.isMacintosh||s?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):r.replace(/&&|&/g,w=>w==="&"?"&&":"&")}e.mnemonicMenuLabel=k;function v(r,s){return F.isMacintosh||s?r.replace(/\(&&\w\)|&&/g,""):F.isWindows?r.replace(/&&|&/g,w=>w==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function a(r){const s=r.indexOf("/")!==-1?D.posix:D.win32,w=s.basename(r),I=s.dirname(r);return w.length?{name:w,parentPath:I}:{name:I,parentPath:""}}e.splitName=a}),define(Te[131],Pe([1,0,25,2]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(b){return b.toJSON()}class F{constructor(g){this._uriTransformer=g}transformIncoming(g){const _=this._uriTransformer.transformIncoming(g);return _===g?g:D(T.URI.from(_))}transformOutgoing(g){const _=this._uriTransformer.transformOutgoing(g);return _===g?g:D(T.URI.from(_))}transformOutgoingURI(g){const _=this._uriTransformer.transformOutgoing(g);return _===g?g:T.URI.from(_)}transformOutgoingScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}}e.URITransformer=F,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function A(b,g,_){if(!b||_>200)return null;if(typeof b=="object"){if(b instanceof T.URI)return g.transformOutgoing(b);for(const p in b)if(Object.hasOwnProperty.call(b,p)){const u=A(b[p],g,_+1);u!==null&&(b[p]=u)}}return null}function P(b,g){const _=A(b,g,0);return _===null?b:_}e.transformOutgoingURIs=P;function S(b,g,_,p){if(!b||p>200)return null;if(typeof b=="object"){if(b.$mid===1)return _?T.URI.revive(g.transformIncoming(b)):g.transformIncoming(b);if(b instanceof n.VSBuffer)return null;for(const u in b)if(Object.hasOwnProperty.call(b,u)){const t=S(b[u],g,_,p+1);t!==null&&(b[u]=t)}}return null}function h(b,g){const _=S(b,g,!1,0);return _===null?b:_}e.transformIncomingURIs=h;function R(b,g){const _=S(b,g,!0,0);return _===null?b:_}e.transformAndReviveIncomingURIs=R}),define(Te[132],Pe([1,0,36,19]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(F,A,P,S,h,R){if(Array.isArray(F)){let b=0;for(const g of F){const _=D(g,A,P,S,h,R);if(_===10)return _;_>b&&(b=_)}return b}else{if(typeof F=="string")return S?F==="*"?5:F===P?10:0:0;if(F){const{language:b,pattern:g,scheme:_,hasAccessToAllModels:p,notebookType:u}=F;if(!S&&!p)return 0;u&&h&&(A=h);let t=0;if(_)if(_===A.scheme)t=10;else if(_==="*")t=5;else return 0;if(b)if(b===P)t=10;else if(b==="*")t=Math.max(t,5);else return 0;if(u)if(u===R)t=10;else if(u==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(g){let o;if(typeof g=="string"?o=g:o={...g,base:(0,T.normalize)(g.base)},o===A.fsPath||(0,n.match)(o,A.fsPath))t=10;else return 0}return t}else return 0}}e.score=D}),define(Te[90],Pe([1,0,25,20]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(D||(D={}));function F(b){for(let g=0,_=b.length;g<_;g+=4){const p=b[g+0],u=b[g+1],t=b[g+2],o=b[g+3];b[g+0]=o,b[g+1]=t,b[g+2]=u,b[g+3]=p}}function A(b){const g=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return T.isLittleEndian()||F(g),n.VSBuffer.wrap(g)}function P(b){const g=b.buffer;if(T.isLittleEndian()||F(g),g.byteOffset%4===0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const _=new Uint8Array(g.byteLength);return _.set(g),new Uint32Array(_.buffer,_.byteOffset,_.length/4)}}function S(b){const g=new Uint32Array(h(b));let _=0;if(g[_++]=b.id,b.type==="full")g[_++]=1,g[_++]=b.data.length,g.set(b.data,_),_+=b.data.length;else{g[_++]=2,g[_++]=b.deltas.length;for(const p of b.deltas)g[_++]=p.start,g[_++]=p.deleteCount,p.data?(g[_++]=p.data.length,g.set(p.data,_),_+=p.data.length):g[_++]=0}return A(g)}e.encodeSemanticTokensDto=S;function h(b){let g=0;if(g+=1+1,b.type==="full")g+=1+b.data.length;else{g+=1,g+=(1+1+1)*b.deltas.length;for(const _ of b.deltas)_.data&&(g+=_.data.length)}return g}function R(b){const g=P(b);let _=0;const p=g[_++];if(g[_++]===1){const d=g[_++],y=g.subarray(_,_+d);return _+=d,{id:p,type:"full",data:y}}const t=g[_++],o=[];for(let d=0;d<t;d++){const y=g[_++],k=g[_++],v=g[_++];let i;v>0&&(i=g.subarray(_,_+v),_+=v),o[d]={start:y,deleteCount:k,data:i}}return{id:p,type:"delta",deltas:o}}e.decodeSemanticTokensDto=R}),define(Te[133],Pe([10,11]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Te[134],Pe([1,0,133,20,135,16,23,120]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class h{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=h;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class b{constructor(Y,_e,Ne,ze){this.id=Y,this.name=_e,this.defaultValue=Ne,this.schema=ze}applyUpdate(Y,_e){return _(Y,_e)}compute(Y,_e,Ne){return Ne}}class g{constructor(Y,_e){this.newValue=Y,this.didChange=_e}}e.ApplyUpdateResult=g;function _(Z,Y){if(typeof Z!="object"||typeof Y!="object"||!Z||!Y)return new g(Y,Z!==Y);if(Array.isArray(Z)||Array.isArray(Y)){const Ne=Array.isArray(Z)&&Array.isArray(Y)&&F.equals(Z,Y);return new g(Y,!Ne)}let _e=!1;for(const Ne in Y)if(Y.hasOwnProperty(Ne)){const ze=_(Z[Ne],Y[Ne]);ze.didChange&&(Z[Ne]=ze.newValue,_e=!0)}return new g(Z,_e)}class p{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,_e){return _(Y,_e)}validate(Y){return this.defaultValue}}class u{constructor(Y,_e,Ne,ze){this.id=Y,this.name=_e,this.defaultValue=Ne,this.schema=ze}applyUpdate(Y,_e){return _(Y,_e)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,_e,Ne){return Ne}}function t(Z,Y){return typeof Z>"u"?Y:Z==="false"?!1:!!Z}e.boolean=t;class o extends u{constructor(Y,_e,Ne,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Ne),super(Y,_e,Ne,ze)}validate(Y){return t(Y,this.defaultValue)}}function d(Z,Y,_e,Ne){if(typeof Z>"u")return Y;let ze=parseInt(Z,10);return isNaN(ze)?Y:(ze=Math.max(_e,ze),ze=Math.min(Ne,ze),ze|0)}e.clampedInt=d;class y extends u{static clampedInt(Y,_e,Ne,ze){return d(Y,_e,Ne,ze)}constructor(Y,_e,Ne,ze,Xe,We=void 0){typeof We<"u"&&(We.type="integer",We.default=Ne,We.minimum=ze,We.maximum=Xe),super(Y,_e,Ne,We),this.minimum=ze,this.maximum=Xe}validate(Y){return y.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function k(Z,Y,_e,Ne){if(typeof Z>"u")return Y;const ze=v.float(Z,Y);return v.clamp(ze,_e,Ne)}e.clampedFloat=k;class v extends u{static clamp(Y,_e,Ne){return Y<_e?_e:Y>Ne?Ne:Y}static float(Y,_e){if(typeof Y=="number")return Y;if(typeof Y>"u")return _e;const Ne=parseFloat(Y);return isNaN(Ne)?_e:Ne}constructor(Y,_e,Ne,ze,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Ne),super(Y,_e,Ne,Xe),this.validationFn=ze}validate(Y){return this.validationFn(v.float(Y,this.defaultValue))}}class i extends u{static string(Y,_e){return typeof Y!="string"?_e:Y}constructor(Y,_e,Ne,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Ne),super(Y,_e,Ne,ze)}validate(Y){return i.string(Y,this.defaultValue)}}function a(Z,Y,_e,Ne){return typeof Z!="string"?Y:Ne&&Z in Ne?Ne[Z]:_e.indexOf(Z)===-1?Y:Z}e.stringSet=a;class r extends u{constructor(Y,_e,Ne,ze,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=ze,Xe.default=Ne),super(Y,_e,Ne,Xe),this._allowedValues=ze}validate(Y){return a(Y,this.defaultValue,this._allowedValues)}}class s extends b{constructor(Y,_e,Ne,ze,Xe,We,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Xe,it.default=ze),super(Y,_e,Ne,it),this._allowedValues=Xe,this._convert=We}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function w(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class I extends b{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,_e,Ne){return Ne===0?Y.accessibilitySupport:Ne}}class c extends b{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:n.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{insertSpace:t(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(l||(e.TextEditorCursorBlinkingStyle=l={}));function m(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function f(Z){switch(Z){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function L(Z){switch(Z){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class W extends p{constructor(){super(136)}compute(Y,_e,Ne){const ze=["monaco-editor"];return _e.get(37)&&ze.push(_e.get(37)),Y.extraEditorClassName&&ze.push(Y.extraEditorClassName),_e.get(71)==="default"?ze.push("mouse-default"):_e.get(71)==="copy"&&ze.push("mouse-copy"),_e.get(106)&&ze.push("showUnused"),_e.get(134)&&ze.push("showDeprecated"),ze.join(" ")}}class J extends o{constructor(){super(35,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(Y,_e,Ne){return Ne&&Y.emptySelectionClipboard}}class q extends b{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:n.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:n.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{cursorMoveOnType:t(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":a(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":a(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(_e.loop,this.defaultValue.loop)}}}class U extends b{constructor(){super(49,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?U.OFF:Y==="true"?U.ON:Y:Y?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class B extends b{constructor(){super(52,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?B.OFF:Y==="true"?B.TRANSLATE:Y:Y?B.TRANSLATE:B.OFF}compute(Y,_e,Ne){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=B,B.OFF="normal",B.TRANSLATE="translate";class G extends p{constructor(){super(48)}compute(Y,_e,Ne){return Y.fontInfo}}class N extends u{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(Y){const _e=v.float(Y,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(_e,6,100)}compute(Y,_e,Ne){return Y.fontInfo.fontSize}}class H extends b{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(y.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class Q extends b{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),..._e},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),..._e},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),..._e},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),..._e},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),..._e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Ne,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Ne,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Ne,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Ne,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Ne,description:n.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{multiple:a(_e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:_e.multipleDefinitions??a(_e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:_e.multipleTypeDefinitions??a(_e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:_e.multipleDeclarations??a(_e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:_e.multipleImplementations??a(_e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:_e.multipleReferences??a(_e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(_e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(_e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(_e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(_e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(_e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class pe extends b{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:n.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{enabled:t(_e.enabled,this.defaultValue.enabled),delay:y.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:t(_e.sticky,this.defaultValue.sticky),above:t(_e.above,this.defaultValue.above)}}}var we;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(we||(e.RenderMinimap=we={}));class he extends p{constructor(){super(139)}compute(Y,_e,Ne){return he.computeLayout(_e,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const _e=Y.height/Y.lineHeight,Ne=Math.floor(Y.paddingTop/Y.lineHeight);let ze=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(ze=Math.max(ze,_e-1));const Xe=(Ne+Y.viewLineCount+ze)/(Y.pixelRatio*Y.height),We=Math.floor(Y.viewLineCount/Xe);return{typicalViewportLineCount:_e,extraLinesBeforeFirstLine:Ne,extraLinesBeyondLastLine:ze,desiredRatio:Xe,minimapLineCount:We}}static _computeMinimapLayout(Y,_e){const Ne=Y.outerWidth,ze=Y.outerHeight,Xe=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const We=_e.stableMinimapLayoutInput,it=We&&Y.outerHeight===We.outerHeight&&Y.lineHeight===We.lineHeight&&Y.typicalHalfwidthCharacterWidth===We.typicalHalfwidthCharacterWidth&&Y.pixelRatio===We.pixelRatio&&Y.scrollBeyondLastLine===We.scrollBeyondLastLine&&Y.paddingTop===We.paddingTop&&Y.paddingBottom===We.paddingBottom&&Y.minimap.enabled===We.minimap.enabled&&Y.minimap.side===We.minimap.side&&Y.minimap.size===We.minimap.size&&Y.minimap.showSlider===We.minimap.showSlider&&Y.minimap.renderCharacters===We.minimap.renderCharacters&&Y.minimap.maxColumn===We.minimap.maxColumn&&Y.minimap.scale===We.minimap.scale&&Y.verticalScrollbarWidth===We.verticalScrollbarWidth&&Y.isViewportWrapping===We.isViewportWrapping,wt=Y.lineHeight,St=Y.typicalHalfwidthCharacterWidth,kt=Y.scrollBeyondLastLine,$t=Y.minimap.renderCharacters;let bt=Xe>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Bt=Y.minimap.maxColumn,Mt=Y.minimap.size,jt=Y.minimap.side,Wt=Y.verticalScrollbarWidth,Tt=Y.viewLineCount,at=Y.remainingWidth,gt=Y.isViewportWrapping,zt=$t?2:3;let Nt=Math.floor(Xe*ze);const It=Nt/Xe;let ht=!1,Ct=!1,Ot=zt*bt,Pt=bt/Xe,Ke=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeforeFirstLine:$e,extraLinesBeyondLastLine:tt,desiredRatio:Et,minimapLineCount:pt}=he.computeContainedMinimapLineCount({viewLineCount:Tt,scrollBeyondLastLine:kt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:ze,lineHeight:wt,pixelRatio:Xe});if(Tt/pt>1)ht=!0,Ct=!0,bt=1,Ot=1,Pt=bt/Xe;else{let nt=!1,ut=bt+1;if(Mt==="fit"){const Rt=Math.ceil(($e+Tt+tt)*Ot);gt&&it&&at<=_e.stableFitRemainingWidth?(nt=!0,ut=_e.stableFitMaxMinimapScale):nt=Rt>Nt}if(Mt==="fill"||nt){ht=!0;const Rt=bt;Ot=Math.min(wt*Xe,Math.max(1,Math.floor(1/Et))),gt&&it&&at<=_e.stableFitRemainingWidth&&(ut=_e.stableFitMaxMinimapScale),bt=Math.min(ut,Math.max(1,Math.floor(Ot/zt))),bt>Rt&&(Ke=Math.min(2,bt/Rt)),Pt=bt/Xe/Ke,Nt=Math.ceil(Math.max(Ge,$e+Tt+tt)*Ot),gt?(_e.stableMinimapLayoutInput=Y,_e.stableFitRemainingWidth=at,_e.stableFitMaxMinimapScale=bt):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0)}}}const ke=Math.floor(Bt*Pt),Re=Math.min(ke,Math.max(0,Math.floor((at-Wt-2)*Pt/(St+Pt)))+e.MINIMAP_GUTTER_WIDTH);let ve=Math.floor(Xe*Re);const K=ve/Xe;ve=Math.floor(ve*Ke);const Oe=$t?1:2,Be=jt==="left"?0:Ne-Re-Wt;return{renderMinimap:Oe,minimapLeft:Be,minimapWidth:Re,minimapHeightIsEditorHeight:ht,minimapIsSampling:Ct,minimapScale:bt,minimapLineHeight:Ot,minimapCanvasInnerWidth:ve,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:K,minimapCanvasOuterHeight:It}}static computeLayout(Y,_e){const Ne=_e.outerWidth|0,ze=_e.outerHeight|0,Xe=_e.lineHeight|0,We=_e.lineNumbersDigitCount|0,it=_e.typicalHalfwidthCharacterWidth,wt=_e.maxDigitWidth,St=_e.pixelRatio,kt=_e.viewLineCount,$t=Y.get(131),bt=$t==="inherit"?Y.get(130):$t,Bt=bt==="inherit"?Y.get(126):bt,Mt=Y.get(129),jt=_e.isDominatedByLongLines,Wt=Y.get(55),Tt=Y.get(65).renderType!==0,at=Y.get(66),gt=Y.get(100),zt=Y.get(81),Nt=Y.get(70),It=Y.get(98),ht=It.verticalScrollbarSize,Ct=It.verticalHasArrows,Ot=It.arrowSize,Pt=It.horizontalScrollbarSize,Ke=Y.get(41),ke=Y.get(105)!=="never";let Re=Y.get(63);Ke&&ke&&(Re+=16);let ve=0;if(Tt){const ai=Math.max(We,at);ve=Math.round(ai*wt)}let K=0;Wt&&(K=Xe*_e.glyphMarginDecorationLaneCount);let Oe=0,Be=Oe+K,Ge=Be+ve,$e=Ge+Re;const tt=Ne-K-ve-Re;let Et=!1,pt=!1,dt=-1;bt==="inherit"&&jt?(Et=!0,pt=!0):Bt==="on"||Bt==="bounded"?pt=!0:Bt==="wordWrapColumn"&&(dt=Mt);const nt=he._computeMinimapLayout({outerWidth:Ne,outerHeight:ze,lineHeight:Xe,typicalHalfwidthCharacterWidth:it,pixelRatio:St,scrollBeyondLastLine:gt,paddingTop:zt.top,paddingBottom:zt.bottom,minimap:Nt,verticalScrollbarWidth:ht,viewLineCount:kt,remainingWidth:tt,isViewportWrapping:pt},_e.memory||new R);nt.renderMinimap!==0&&nt.minimapLeft===0&&(Oe+=nt.minimapWidth,Be+=nt.minimapWidth,Ge+=nt.minimapWidth,$e+=nt.minimapWidth);const ut=tt-nt.minimapWidth,Rt=Math.max(1,Math.floor((ut-ht-2)/it)),Ut=Ct?Ot:0;return pt&&(dt=Math.max(1,Rt),Bt==="bounded"&&(dt=Math.min(dt,Mt))),{width:Ne,height:ze,glyphMarginLeft:Oe,glyphMarginWidth:K,glyphMarginDecorationLaneCount:_e.glyphMarginDecorationLaneCount,lineNumbersLeft:Be,lineNumbersWidth:ve,decorationsLeft:Ge,decorationsWidth:Re,contentLeft:$e,contentWidth:ut,minimap:nt,viewportColumn:Rt,isWordWrapMinified:Et,isViewportWrapping:pt,wrappingColumn:dt,verticalScrollbarWidth:ht,horizontalScrollbarHeight:Pt,overviewRuler:{top:Ut,width:ht,height:ze-2*Ut,right:0}}}}e.EditorLayoutInfoComputer=he;class de extends b{constructor(){super(133,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(Y){return a(Y,"simple",["simple","advanced"])}compute(Y,_e,Ne){return _e.get(2)===2?"advanced":Ne}}class Ae extends b{constructor(){const Y={enabled:!0};super(62,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:n.localize(49,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:t(Y.enabled,this.defaultValue.enabled)}}}class ue extends b{constructor(){const Y={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(110,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:n.localize(52,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{enabled:t(_e.enabled,this.defaultValue.enabled),maxLineCount:y.clampedInt(_e.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a(_e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class le extends b{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(135,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:n.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(54,null),n.localize(55,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:n.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:n.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:n.localize(60,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return typeof _e.enabled=="boolean"&&(_e.enabled=_e.enabled?"on":"off"),{enabled:a(_e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:y.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(_e.fontFamily,this.defaultValue.fontFamily),padding:t(_e.padding,this.defaultValue.padding)}}}class $ extends b{constructor(){super(63,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):y.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,_e,Ne){return Ne<0?y.clampedInt(-Ne*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ne}}class O extends v{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>v.clamp(Y,0,150),{markdownDescription:n.localize(61,null)})}compute(Y,_e,Ne){return Y.fontInfo.lineHeight}}class X extends b{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:n.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:n.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(64,null),n.localize(65,null),n.localize(66,null)],default:Y.size,description:n.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:n.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:n.localize(69,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:n.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:n.localize(72,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{enabled:t(_e.enabled,this.defaultValue.enabled),autohide:t(_e.autohide,this.defaultValue.autohide),size:a(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(_e.side,this.defaultValue.side,["right","left"]),showSlider:a(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(_e.renderCharacters,this.defaultValue.renderCharacters),scale:y.clampedInt(_e.scale,1,1,3),maxColumn:y.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function me(Z){return Z==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ce extends b{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(74,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{top:y.clampedInt(_e.top,0,0,1e3),bottom:y.clampedInt(_e.bottom,0,0,1e3)}}}class ye extends b{constructor(){const Y={enabled:!0,cycle:!0};super(82,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:n.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:n.localize(76,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{enabled:t(_e.enabled,this.defaultValue.enabled),cycle:t(_e.cycle,this.defaultValue.cycle)}}}class Ee extends p{constructor(){super(137)}compute(Y,_e,Ne){return Y.pixelRatio}}class Ie extends b{constructor(){const Y={other:"on",comments:"off",strings:"off"},_e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(77,null),n.localize(78,null),n.localize(79,null)]}];super(85,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:_e,default:Y.strings,description:n.localize(80,null)},comments:{anyOf:_e,default:Y.comments,description:n.localize(81,null)},other:{anyOf:_e,default:Y.other,description:n.localize(82,null)}},default:Y,markdownDescription:n.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const St=Y?"on":"off";return{comments:St,strings:St,other:St}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:_e,comments:Ne,strings:ze}=Y,Xe=["on","inline","off"];let We,it,wt;return typeof _e=="boolean"?We=_e?"on":"off":We=a(_e,this.defaultValue.other,Xe),typeof Ne=="boolean"?it=Ne?"on":"off":it=a(Ne,this.defaultValue.comments,Xe),typeof ze=="boolean"?wt=ze?"on":"off":wt=a(ze,this.defaultValue.strings,Xe),{other:We,comments:it,strings:wt}}}var oe;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class ce extends b{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(84,null),n.localize(85,null),n.localize(86,null),n.localize(87,null)],default:"on",description:n.localize(88,null)})}validate(Y){let _e=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(_e=4,Ne=Y):Y==="interval"?_e=3:Y==="relative"?_e=2:Y==="on"?_e=1:_e=0),{renderType:_e,renderFn:Ne}}}function ie(Z){const Y=Z.get(93);return Y==="editable"?Z.get(87):Y!=="on"}e.filterValidationDecorations=ie;class ne extends b{constructor(){const Y=[],_e={type:"number",description:n.localize(89,null)};super(97,"rulers",Y,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:n.localize(90,null),format:"color-hex"}}}]},default:Y,description:n.localize(91,null)})}validate(Y){if(Array.isArray(Y)){const _e=[];for(const Ne of Y)if(typeof Ne=="number")_e.push({column:y.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const ze=Ne;_e.push({column:y.clampedInt(ze.column,0,0,1e4),color:ze.color})}return _e.sort((Ne,ze)=>Ne.column-ze.column),_e}return this.defaultValue}}function C(Z,Y){if(typeof Z!="string")return Y;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends b{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(98,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(92,null),n.localize(93,null),n.localize(94,null)],default:"auto",description:n.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(96,null),n.localize(97,null),n.localize(98,null)],default:"auto",description:n.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:n.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:n.localize(102,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y,Ne=y.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=y.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:y.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:C(_e.vertical,this.defaultValue.vertical),horizontal:C(_e.horizontal,this.defaultValue.horizontal),useShadows:t(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:y.clampedInt(_e.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:y.clampedInt(_e.verticalSliderSize,ze,0,1e3),scrollByPage:t(_e.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends b{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(120,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:n.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:n.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:n.localize(109,null)}})}applyUpdate(Y,_e){let Ne=!1;_e.allowedCharacters&&Y&&(A.equals(Y.allowedCharacters,_e.allowedCharacters)||(Y={...Y,allowedCharacters:_e.allowedCharacters},Ne=!0)),_e.allowedLocales&&Y&&(A.equals(Y.allowedLocales,_e.allowedLocales)||(Y={...Y,allowedLocales:_e.allowedLocales},Ne=!0));const ze=super.applyUpdate(Y,_e);return Ne?new g(ze.newValue,!0):ze}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{nonBasicASCII:ee(_e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(_e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(_e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(_e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(_e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,_e){if(typeof Y!="object"||!Y)return _e;const Ne={};for(const[ze,Xe]of Object.entries(Y))Xe===!0&&(Ne[ze]=!0);return Ne}}class j extends b{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(60,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:n.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[n.localize(111,null),n.localize(112,null)],description:n.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:n.localize(114,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{enabled:t(_e.enabled,this.defaultValue.enabled),mode:a(_e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a(_e.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(_e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(_e.keepOnBlur,this.defaultValue.keepOnBlur)}}}class ae extends b{constructor(){const Y={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:n.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:n.localize(116,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{enabled:t(_e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(_e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ge extends b{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(117,null),n.localize(118,null),n.localize(119,null)],default:Y.bracketPairs,description:n.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(121,null),n.localize(122,null),n.localize(123,null)],default:Y.bracketPairsHorizontal,description:n.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:n.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:n.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(127,null),n.localize(128,null),n.localize(129,null)],default:Y.highlightActiveIndentation,description:n.localize(130,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{bracketPairs:ee(_e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(_e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(_e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(_e.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(_e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,Y,_e){const Ne=_e.indexOf(Z);return Ne===-1?Y:_e[Ne]}class be extends b{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(113,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(131,null),n.localize(132,null)],default:Y.insertMode,description:n.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:n.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:n.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:n.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(137,null),n.localize(138,null),n.localize(139,null),n.localize(140,null)],default:Y.selectionMode,markdownDescription:n.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:n.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:n.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:n.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:n.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:n.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(178,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{insertMode:a(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a(_e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(_e.showIcons,this.defaultValue.showIcons),showStatusBar:t(_e.showStatusBar,this.defaultValue.showStatusBar),preview:t(_e.preview,this.defaultValue.preview),previewMode:a(_e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(_e.showMethods,this.defaultValue.showMethods),showFunctions:t(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:t(_e.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(_e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(_e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(_e.showFields,this.defaultValue.showFields),showVariables:t(_e.showVariables,this.defaultValue.showVariables),showClasses:t(_e.showClasses,this.defaultValue.showClasses),showStructs:t(_e.showStructs,this.defaultValue.showStructs),showInterfaces:t(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:t(_e.showModules,this.defaultValue.showModules),showProperties:t(_e.showProperties,this.defaultValue.showProperties),showEvents:t(_e.showEvents,this.defaultValue.showEvents),showOperators:t(_e.showOperators,this.defaultValue.showOperators),showUnits:t(_e.showUnits,this.defaultValue.showUnits),showValues:t(_e.showValues,this.defaultValue.showValues),showConstants:t(_e.showConstants,this.defaultValue.showConstants),showEnums:t(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:t(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(_e.showKeywords,this.defaultValue.showKeywords),showWords:t(_e.showWords,this.defaultValue.showWords),showColors:t(_e.showColors,this.defaultValue.showColors),showFiles:t(_e.showFiles,this.defaultValue.showFiles),showReferences:t(_e.showReferences,this.defaultValue.showReferences),showFolders:t(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:t(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(_e.showSnippets,this.defaultValue.showSnippets),showUsers:t(_e.showUsers,this.defaultValue.showUsers),showIssues:t(_e.showIssues,this.defaultValue.showIssues)}}}class Se extends b{constructor(){super(108,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(179,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var xe;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(xe||(e.WrappingIndent=xe={}));class He extends b{constructor(){super(132,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(180,null),n.localize(181,null),n.localize(182,null),n.localize(183,null)],description:n.localize(184,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,_e,Ne){return _e.get(2)===2?0:Ne}}class et extends p{constructor(){super(140)}compute(Y,_e,Ne){const ze=_e.get(139);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class Qe extends b{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(34,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:n.localize(185,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:n.localize(186,null),enum:["afterDrop","never"],enumDescriptions:[n.localize(187,null),n.localize(188,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const _e=Y;return{enabled:t(_e.enabled,this.defaultValue.enabled),showDropSelector:a(_e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}const Ye="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",lt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?rt:T.isLinux?lt:Ye,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var st;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.autoClosingBrackets=5]="autoClosingBrackets",Z[Z.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=7]="autoClosingDelete",Z[Z.autoClosingOvertype=8]="autoClosingOvertype",Z[Z.autoClosingQuotes=9]="autoClosingQuotes",Z[Z.autoIndent=10]="autoIndent",Z[Z.automaticLayout=11]="automaticLayout",Z[Z.autoSurround=12]="autoSurround",Z[Z.bracketPairColorization=13]="bracketPairColorization",Z[Z.guides=14]="guides",Z[Z.codeLens=15]="codeLens",Z[Z.codeLensFontFamily=16]="codeLensFontFamily",Z[Z.codeLensFontSize=17]="codeLensFontSize",Z[Z.colorDecorators=18]="colorDecorators",Z[Z.colorDecoratorsLimit=19]="colorDecoratorsLimit",Z[Z.columnSelection=20]="columnSelection",Z[Z.comments=21]="comments",Z[Z.contextmenu=22]="contextmenu",Z[Z.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=24]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=26]="cursorStyle",Z[Z.cursorSurroundingLines=27]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=29]="cursorWidth",Z[Z.disableLayerHinting=30]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",Z[Z.domReadOnly=32]="domReadOnly",Z[Z.dragAndDrop=33]="dragAndDrop",Z[Z.dropIntoEditor=34]="dropIntoEditor",Z[Z.emptySelectionClipboard=35]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=37]="extraEditorClassName",Z[Z.fastScrollSensitivity=38]="fastScrollSensitivity",Z[Z.find=39]="find",Z[Z.fixedOverflowWidgets=40]="fixedOverflowWidgets",Z[Z.folding=41]="folding",Z[Z.foldingStrategy=42]="foldingStrategy",Z[Z.foldingHighlight=43]="foldingHighlight",Z[Z.foldingImportsByDefault=44]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=45]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=47]="fontFamily",Z[Z.fontInfo=48]="fontInfo",Z[Z.fontLigatures=49]="fontLigatures",Z[Z.fontSize=50]="fontSize",Z[Z.fontWeight=51]="fontWeight",Z[Z.fontVariations=52]="fontVariations",Z[Z.formatOnPaste=53]="formatOnPaste",Z[Z.formatOnType=54]="formatOnType",Z[Z.glyphMargin=55]="glyphMargin",Z[Z.gotoLocation=56]="gotoLocation",Z[Z.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",Z[Z.hover=58]="hover",Z[Z.inDiffEditor=59]="inDiffEditor",Z[Z.inlineSuggest=60]="inlineSuggest",Z[Z.letterSpacing=61]="letterSpacing",Z[Z.lightbulb=62]="lightbulb",Z[Z.lineDecorationsWidth=63]="lineDecorationsWidth",Z[Z.lineHeight=64]="lineHeight",Z[Z.lineNumbers=65]="lineNumbers",Z[Z.lineNumbersMinChars=66]="lineNumbersMinChars",Z[Z.linkedEditing=67]="linkedEditing",Z[Z.links=68]="links",Z[Z.matchBrackets=69]="matchBrackets",Z[Z.minimap=70]="minimap",Z[Z.mouseStyle=71]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=73]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=75]="multiCursorModifier",Z[Z.multiCursorPaste=76]="multiCursorPaste",Z[Z.multiCursorLimit=77]="multiCursorLimit",Z[Z.occurrencesHighlight=78]="occurrencesHighlight",Z[Z.overviewRulerBorder=79]="overviewRulerBorder",Z[Z.overviewRulerLanes=80]="overviewRulerLanes",Z[Z.padding=81]="padding",Z[Z.parameterHints=82]="parameterHints",Z[Z.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=85]="quickSuggestions",Z[Z.quickSuggestionsDelay=86]="quickSuggestionsDelay",Z[Z.readOnly=87]="readOnly",Z[Z.renameOnType=88]="renameOnType",Z[Z.renderControlCharacters=89]="renderControlCharacters",Z[Z.renderFinalNewline=90]="renderFinalNewline",Z[Z.renderLineHighlight=91]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=93]="renderValidationDecorations",Z[Z.renderWhitespace=94]="renderWhitespace",Z[Z.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",Z[Z.roundedSelection=96]="roundedSelection",Z[Z.rulers=97]="rulers",Z[Z.scrollbar=98]="scrollbar",Z[Z.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=100]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=101]="scrollPredominantAxis",Z[Z.selectionClipboard=102]="selectionClipboard",Z[Z.selectionHighlight=103]="selectionHighlight",Z[Z.selectOnLineNumbers=104]="selectOnLineNumbers",Z[Z.showFoldingControls=105]="showFoldingControls",Z[Z.showUnused=106]="showUnused",Z[Z.snippetSuggestions=107]="snippetSuggestions",Z[Z.smartSelect=108]="smartSelect",Z[Z.smoothScrolling=109]="smoothScrolling",Z[Z.stickyScroll=110]="stickyScroll",Z[Z.stickyTabStops=111]="stickyTabStops",Z[Z.stopRenderingLineAfter=112]="stopRenderingLineAfter",Z[Z.suggest=113]="suggest",Z[Z.suggestFontSize=114]="suggestFontSize",Z[Z.suggestLineHeight=115]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",Z[Z.suggestSelection=117]="suggestSelection",Z[Z.tabCompletion=118]="tabCompletion",Z[Z.tabIndex=119]="tabIndex",Z[Z.unicodeHighlighting=120]="unicodeHighlighting",Z[Z.unusualLineTerminators=121]="unusualLineTerminators",Z[Z.useShadowDOM=122]="useShadowDOM",Z[Z.useTabStops=123]="useTabStops",Z[Z.wordBreak=124]="wordBreak",Z[Z.wordSeparators=125]="wordSeparators",Z[Z.wordWrap=126]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=129]="wordWrapColumn",Z[Z.wordWrapOverride1=130]="wordWrapOverride1",Z[Z.wordWrapOverride2=131]="wordWrapOverride2",Z[Z.wrappingIndent=132]="wrappingIndent",Z[Z.wrappingStrategy=133]="wrappingStrategy",Z[Z.showDeprecated=134]="showDeprecated",Z[Z.inlayHints=135]="inlayHints",Z[Z.editorClassName=136]="editorClassName",Z[Z.pixelRatio=137]="pixelRatio",Z[Z.tabFocusMode=138]="tabFocusMode",Z[Z.layoutInfo=139]="layoutInfo",Z[Z.wrappingInfo=140]="wrappingInfo",Z[Z.defaultColorDecorators=141]="defaultColorDecorators"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(189,null)})),acceptSuggestionOnEnter:Me(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(190,null),""],markdownDescription:n.localize(191,null)})),accessibilitySupport:Me(new I),accessibilityPageSize:Me(new y(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(192,null),tags:["accessibility"]})),ariaLabel:Me(new i(4,"ariaLabel",n.localize(193,null))),screenReaderAnnounceInlineSuggestion:Me(new o(6,"screenReaderAnnounceInlineSuggestion",!1,{description:n.localize(194,null),tags:["accessibility"]})),autoClosingBrackets:Me(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(195,null),n.localize(196,null),""],description:n.localize(197,null)})),autoClosingDelete:Me(new r(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(198,null),""],description:n.localize(199,null)})),autoClosingOvertype:Me(new r(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(200,null),""],description:n.localize(201,null)})),autoClosingQuotes:Me(new r(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(202,null),n.localize(203,null),""],description:n.localize(204,null)})),autoIndent:Me(new s(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[n.localize(205,null),n.localize(206,null),n.localize(207,null),n.localize(208,null),n.localize(209,null)],description:n.localize(210,null)})),automaticLayout:Me(new o(11,"automaticLayout",!1)),autoSurround:Me(new r(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(211,null),n.localize(212,null),n.localize(213,null),""],description:n.localize(214,null)})),bracketPairColorization:Me(new ae),bracketPairGuides:Me(new ge),stickyTabStops:Me(new o(111,"stickyTabStops",!1,{description:n.localize(215,null)})),codeLens:Me(new o(15,"codeLens",!0,{description:n.localize(216,null)})),codeLensFontFamily:Me(new i(16,"codeLensFontFamily","",{description:n.localize(217,null)})),codeLensFontSize:Me(new y(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(218,null)})),colorDecorators:Me(new o(18,"colorDecorators",!0,{description:n.localize(219,null)})),colorDecoratorsLimit:Me(new y(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(220,null)})),columnSelection:Me(new o(20,"columnSelection",!1,{description:n.localize(221,null)})),comments:Me(new c),contextmenu:Me(new o(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new o(23,"copyWithSyntaxHighlighting",!0,{description:n.localize(222,null)})),cursorBlinking:Me(new s(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:n.localize(223,null)})),cursorSmoothCaretAnimation:Me(new r(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(224,null),n.localize(225,null),n.localize(226,null)],description:n.localize(227,null)})),cursorStyle:Me(new s(26,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:n.localize(228,null)})),cursorSurroundingLines:Me(new y(27,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(229,null)})),cursorSurroundingLinesStyle:Me(new r(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(230,null),n.localize(231,null)],description:n.localize(232,null)})),cursorWidth:Me(new y(29,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(233,null)})),disableLayerHinting:Me(new o(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new o(31,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new o(32,"domReadOnly",!1)),dragAndDrop:Me(new o(33,"dragAndDrop",!0,{description:n.localize(234,null)})),emptySelectionClipboard:Me(new J),dropIntoEditor:Me(new Qe),stickyScroll:Me(new ue),experimentalWhitespaceRendering:Me(new r(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(235,null),n.localize(236,null),n.localize(237,null)],description:n.localize(238,null)})),extraEditorClassName:Me(new i(37,"extraEditorClassName","")),fastScrollSensitivity:Me(new v(38,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:n.localize(239,null)})),find:Me(new q),fixedOverflowWidgets:Me(new o(40,"fixedOverflowWidgets",!1)),folding:Me(new o(41,"folding",!0,{description:n.localize(240,null)})),foldingStrategy:Me(new r(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(241,null),n.localize(242,null)],description:n.localize(243,null)})),foldingHighlight:Me(new o(43,"foldingHighlight",!0,{description:n.localize(244,null)})),foldingImportsByDefault:Me(new o(44,"foldingImportsByDefault",!1,{description:n.localize(245,null)})),foldingMaximumRegions:Me(new y(45,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(246,null)})),unfoldOnClickAfterEndOfLine:Me(new o(46,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(247,null)})),fontFamily:Me(new i(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(248,null)})),fontInfo:Me(new G),fontLigatures2:Me(new U),fontSize:Me(new N),fontWeight:Me(new H),fontVariations:Me(new B),formatOnPaste:Me(new o(53,"formatOnPaste",!1,{description:n.localize(249,null)})),formatOnType:Me(new o(54,"formatOnType",!1,{description:n.localize(250,null)})),glyphMargin:Me(new o(55,"glyphMargin",!0,{description:n.localize(251,null)})),gotoLocation:Me(new Q),hideCursorInOverviewRuler:Me(new o(57,"hideCursorInOverviewRuler",!1,{description:n.localize(252,null)})),hover:Me(new pe),inDiffEditor:Me(new o(59,"inDiffEditor",!1)),letterSpacing:Me(new v(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>v.clamp(Z,-5,20),{description:n.localize(253,null)})),lightbulb:Me(new Ae),lineDecorationsWidth:Me(new $),lineHeight:Me(new O),lineNumbers:Me(new ce),lineNumbersMinChars:Me(new y(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new o(67,"linkedEditing",!1,{description:n.localize(254,null)})),links:Me(new o(68,"links",!0,{description:n.localize(255,null)})),matchBrackets:Me(new r(69,"matchBrackets","always",["always","near","never"],{description:n.localize(256,null)})),minimap:Me(new X),mouseStyle:Me(new r(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new v(72,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:n.localize(257,null)})),mouseWheelZoom:Me(new o(73,"mouseWheelZoom",!1,{markdownDescription:n.localize(258,null)})),multiCursorMergeOverlapping:Me(new o(74,"multiCursorMergeOverlapping",!0,{description:n.localize(259,null)})),multiCursorModifier:Me(new s(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],me,{markdownEnumDescriptions:[n.localize(260,null),n.localize(261,null)],markdownDescription:n.localize(262,null)})),multiCursorPaste:Me(new r(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(263,null),n.localize(264,null)],markdownDescription:n.localize(265,null)})),multiCursorLimit:Me(new y(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(266,null)})),occurrencesHighlight:Me(new o(78,"occurrencesHighlight",!0,{description:n.localize(267,null)})),overviewRulerBorder:Me(new o(79,"overviewRulerBorder",!0,{description:n.localize(268,null)})),overviewRulerLanes:Me(new y(80,"overviewRulerLanes",3,0,3)),padding:Me(new Ce),parameterHints:Me(new ye),peekWidgetDefaultFocus:Me(new r(83,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(269,null),n.localize(270,null)],description:n.localize(271,null)})),definitionLinkOpensInPeek:Me(new o(84,"definitionLinkOpensInPeek",!1,{description:n.localize(272,null)})),quickSuggestions:Me(new Ie),quickSuggestionsDelay:Me(new y(86,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(273,null)})),readOnly:Me(new o(87,"readOnly",!1)),renameOnType:Me(new o(88,"renameOnType",!1,{description:n.localize(274,null),markdownDeprecationMessage:n.localize(275,null)})),renderControlCharacters:Me(new o(89,"renderControlCharacters",!0,{description:n.localize(276,null),restricted:!0})),renderFinalNewline:Me(new r(90,"renderFinalNewline",T.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(277,null)})),renderLineHighlight:Me(new r(91,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(278,null)],description:n.localize(279,null)})),renderLineHighlightOnlyWhenFocus:Me(new o(92,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(280,null)})),renderValidationDecorations:Me(new r(93,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new r(94,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(281,null),n.localize(282,null),n.localize(283,null),""],description:n.localize(284,null)})),revealHorizontalRightPadding:Me(new y(95,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new o(96,"roundedSelection",!0,{description:n.localize(285,null)})),rulers:Me(new ne),scrollbar:Me(new z),scrollBeyondLastColumn:Me(new y(99,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(286,null)})),scrollBeyondLastLine:Me(new o(100,"scrollBeyondLastLine",!0,{description:n.localize(287,null)})),scrollPredominantAxis:Me(new o(101,"scrollPredominantAxis",!0,{description:n.localize(288,null)})),selectionClipboard:Me(new o(102,"selectionClipboard",!0,{description:n.localize(289,null),included:T.isLinux})),selectionHighlight:Me(new o(103,"selectionHighlight",!0,{description:n.localize(290,null)})),selectOnLineNumbers:Me(new o(104,"selectOnLineNumbers",!0)),showFoldingControls:Me(new r(105,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(291,null),n.localize(292,null),n.localize(293,null)],description:n.localize(294,null)})),showUnused:Me(new o(106,"showUnused",!0,{description:n.localize(295,null)})),showDeprecated:Me(new o(134,"showDeprecated",!0,{description:n.localize(296,null)})),inlayHints:Me(new le),snippetSuggestions:Me(new r(107,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(297,null),n.localize(298,null),n.localize(299,null),n.localize(300,null)],description:n.localize(301,null)})),smartSelect:Me(new Se),smoothScrolling:Me(new o(109,"smoothScrolling",!1,{description:n.localize(302,null)})),stopRenderingLineAfter:Me(new y(112,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new be),inlineSuggest:Me(new j),suggestFontSize:Me(new y(114,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(303,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new y(115,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(304,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new o(116,"suggestOnTriggerCharacters",!0,{description:n.localize(305,null)})),suggestSelection:Me(new r(117,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(306,null),n.localize(307,null),n.localize(308,null)],description:n.localize(309,null)})),tabCompletion:Me(new r(118,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(310,null),n.localize(311,null),n.localize(312,null)],description:n.localize(313,null)})),tabIndex:Me(new y(119,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new V),unusualLineTerminators:Me(new r(121,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(314,null),n.localize(315,null),n.localize(316,null)],description:n.localize(317,null)})),useShadowDOM:Me(new o(122,"useShadowDOM",!0)),useTabStops:Me(new o(123,"useTabStops",!0,{description:n.localize(318,null)})),wordBreak:Me(new r(124,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(319,null),n.localize(320,null)],description:n.localize(321,null)})),wordSeparators:Me(new i(125,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:n.localize(322,null)})),wordWrap:Me(new r(126,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(323,null),n.localize(324,null),n.localize(325,null),n.localize(326,null)],description:n.localize(327,null)})),wordWrapBreakAfterCharacters:Me(new i(127,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new i(128,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new y(129,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(328,null)})),wordWrapOverride1:Me(new r(130,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new r(131,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new W),defaultColorDecorators:Me(new o(141,"defaultColorDecorators",!1,{markdownDescription:n.localize(329,null)})),pixelRatio:Me(new Ee),tabFocusMode:Me(new o(138,"tabFocusMode",!1,{markdownDescription:n.localize(330,null)})),layoutInfo:Me(new he),wrappingInfo:Me(new et),wrappingIndent:Me(new He),wrappingStrategy:Me(new de)}}),define(Te[136],Pe([10,11]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Te[137],Pe([10,11]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(Te[138],Pe([10,11]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(Te[139],Pe([10,11]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Te[140],Pe([10,11]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Te[141],Pe([10,11]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Te[142],Pe([10,11]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Te[143],Pe([10,11]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Te[144],Pe([10,11]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Te[145],Pe([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Te[146],Pe([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Te[147],Pe([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostInteractiveSession",e)}),define(Te[148],Pe([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Te[149],Pe([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostLogService",e)}),define(Te[150],Pe([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Te[151],Pe([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Te[152],Pe([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Te[153],Pe([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Te[154],Pe([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Te[155],Pe([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Te[156],Pe([10,11]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Te[157],Pe([10,11]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Te[158],Pe([10,11]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Te[159],Pe([10,11]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Te[160],Pe([10,11]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Te[161],Pe([10,11]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Te[162],Pe([10,11]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Te[163],Pe([10,11]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Te[164],Pe([10,11]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Te[165],Pe([1,0,9,138]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var D;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(D||(e.TokenType=D={}));function F(...h){switch(h.length){case 1:return(0,T.localize)(0,null,h[0]);case 2:return(0,T.localize)(1,null,h[0],h[1]);case 3:return(0,T.localize)(2,null,h[0],h[1],h[2]);default:return}}const A=(0,T.localize)(3,null),P=(0,T.localize)(4,null);class S{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,n.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(R){return this._input=R,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const b=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:b})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const b=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:b})}else this._match(126)?this._addToken(9):this._error(F("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(F("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(R){return this._isAtEnd()||this._input.charCodeAt(this._current)!==R?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(R){this._tokens.push({type:R,offset:this._start})}_error(R){const b=this._start,g=this._input.substring(this._start,this._current),_={type:19,offset:this._start,lexeme:g};this._errors.push({offset:b,lexeme:g,additionalInfo:R}),this._tokens.push(_)}_string(){this.stringRe.lastIndex=this._start;const R=this.stringRe.exec(this._input);if(R){this._current=this._start+R[0].length;const b=this._input.substring(this._start,this._current),g=S._keywords.get(b);g?this._addToken(g):this._tokens.push({type:17,lexeme:b,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(A);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let R=this._current,b=!1,g=!1;for(;;){if(R>=this._input.length){this._current=R,this._error(P);return}const p=this._input.charCodeAt(R);if(b)b=!1;else if(p===47&&!g){R++;break}else p===91?g=!0:p===92?b=!0:p===93&&(g=!1);R++}for(;R<this._input.length&&S._regexFlags.has(this._input.charCodeAt(R));)R++;this._current=R;const _=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:_,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=S,S._regexFlags=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0))),S._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Te[166],Pe([1,0,22,29,140,268]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function S(o){return o=o.trim(),o==="*"||A.test(o)}e.isValidVersionStr=S;function h(o){if(!S(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=o.match(A);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=h;function R(o){if(!o)return null;const d=o.majorBase,y=o.majorMustEqual,k=o.minorBase;let v=o.minorMustEqual;const i=o.patchBase;let a=o.patchMustEqual;o.hasCaret&&(d===0||(v=!1),a=!1);let r=0;if(o.preRelease){const s=P.exec(o.preRelease);if(s){const[,w,I,c]=s;r=Date.UTC(Number(w),Number(I)-1,Number(c))}}return{majorBase:d,majorMustEqual:y,minorBase:k,minorMustEqual:v,patchBase:i,patchMustEqual:a,isMinimum:o.hasGreaterEquals,notBefore:r}}e.normalizeVersion=R;function b(o,d,y){let k;typeof o=="string"?k=R(h(o)):k=o;let v;d instanceof Date?v=d.getTime():typeof d=="string"&&(v=new Date(d).getTime());let i;if(typeof y=="string"?i=R(h(y)):i=y,!k||!i)return!1;const a=k.majorBase,r=k.minorBase,s=k.patchBase;let w=i.majorBase,I=i.minorBase,c=i.patchBase;const l=i.notBefore;let m=i.majorMustEqual,E=i.minorMustEqual,f=i.patchMustEqual;return i.isMinimum?a>w?!0:a<w?!1:r>I?!0:r<I||v&&v<l?!1:s>=c:(a===1&&w===0&&(!m||!E||!f)&&(w=1,I=0,c=0,m=!0,E=!1,f=!1),a<w?!1:a>w?!m:r<I?!1:r>I?!E:s<c?!1:s>c?!f:!(v&&v<l))}e.isValidVersion=b;function g(o,d,y,k,v){const i=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return i.push([T.default.Error,D.localize(0,null)]),i;if(typeof k.name!="string")return i.push([T.default.Error,D.localize(1,null,"name")]),i;if(typeof k.version!="string")return i.push([T.default.Error,D.localize(2,null,"version")]),i;if(!k.engines)return i.push([T.default.Error,D.localize(3,null,"engines")]),i;if(typeof k.engines.vscode!="string")return i.push([T.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof k.extensionDependencies<"u"&&!t(k.extensionDependencies))return i.push([T.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof k.activationEvents<"u"){if(!t(k.activationEvents))return i.push([T.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof k.main>"u"&&typeof k.browser>"u")return i.push([T.default.Error,D.localize(7,null,"activationEvents","main","browser")]),i}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&i.push([T.default.Warning,D.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return i.push([T.default.Error,D.localize(9,null,"main")]),i;{const s=(0,n.joinPath)(y,k.main);(0,n.isEqualOrParent)(s,y)||i.push([T.default.Warning,D.localize(10,null,s.path,y.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return i.push([T.default.Error,D.localize(11,null,"browser")]),i;{const s=(0,n.joinPath)(y,k.browser);(0,n.isEqualOrParent)(s,y)||i.push([T.default.Warning,D.localize(12,null,s.path,y.path)])}}if(!F.valid(k.version))return i.push([T.default.Error,D.localize(13,null)]),i;const a=[];if(!_(o,d,k,v,a))for(const s of a)i.push([T.default.Error,s]);return i}e.validateExtensionManifest=g;function _(o,d,y,k,v){return k||typeof y.main>"u"&&typeof y.browser>"u"?!0:u(o,d,y.engines.vscode,v)}e.isValidExtensionVersion=_;function p(o,d,y){return o==="*"||u(d,y,o)}e.isEngineValid=p;function u(o,d,y,k=[]){const v=R(h(y));if(!v)return k.push(D.localize(14,null,y)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return k.push(D.localize(15,null,y)),!1}else if(!v.majorMustEqual)return k.push(D.localize(16,null,y)),!1;return b(o,d,v)?!0:(k.push(D.localize(17,null,o,y)),!1)}function t(o){if(!Array.isArray(o))return!1;for(let d=0,y=o.length;d<y;d++)if(typeof o[d]!="string")return!1;return!0}}),define(Te[68],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(D,F=[],A=!1){this.ctor=D,this.staticArguments=F,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=n}),define(Te[69],Pe([1,0,68]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var D;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function F(P,S,h){S instanceof n.SyncDescriptor||(S=new n.SyncDescriptor(S,[],!!h)),T.push([P,S])}e.registerSingleton=F;function A(){return T}e.getSingletonServiceDescriptors=A}),define(Te[167],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(F,A){this.key=F,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class T{constructor(F){this._hashFn=F,this._nodes=new Map}roots(){const F=[];for(const A of this._nodes.values())A.outgoing.size===0&&F.push(A);return F}insertEdge(F,A){const P=this.lookupOrInsertNode(F),S=this.lookupOrInsertNode(A);P.outgoing.set(S.key,S),S.incoming.set(P.key,P)}removeNode(F){const A=this._hashFn(F);this._nodes.delete(A);for(const P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(F){const A=this._hashFn(F);let P=this._nodes.get(A);return P||(P=new n(A,F),this._nodes.set(A,P)),P}lookup(F){return this._nodes.get(this._hashFn(F))}isEmpty(){return this._nodes.size===0}toString(){const F=[];for(const[A,P]of this._nodes)F.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,A]of this._nodes){const P=new Set([F]),S=this._findCycle(A,P);if(S)return S}}_findCycle(F,A){for(const[P,S]of F.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const h=this._findCycle(S,A);if(h)return h;A.delete(P)}}}e.Graph=T}),define(Te[3],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(S){return S[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(n||(e._util=n={})),e.IInstantiationService=D("instantiationService");function T(A,P,S){P[n.DI_TARGET]===P?P[n.DI_DEPENDENCIES].push({id:A,index:S}):(P[n.DI_DEPENDENCIES]=[{id:A,index:S}],P[n.DI_TARGET]=P)}function D(A){if(n.serviceIds.has(A))return n.serviceIds.get(A);const P=function(S,h,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(P,S,R)};return P.toString=()=>A,n.serviceIds.set(A,P),P}e.createDecorator=D;function F(A){return A}e.refineServiceDecorator=F}),define(Te[42],Pe([1,0,12,2,3]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function F(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.isConfigurationOverrides=F;function A(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=A;var P;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function S(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function h(t,o){const d=Object.create(null);for(const y in t)R(d,y,t[y],o);return d}e.toValuesTree=h;function R(t,o,d,y){const k=o.split("."),v=k.pop();let i=t;for(let a=0;a<k.length;a++){const r=k[a];let s=i[r];switch(typeof s){case"undefined":s=i[r]=Object.create(null);break;case"object":break;default:y(`Ignoring ${o} as ${k.slice(0,a+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[v]=d}catch{y(`Ignoring ${o} as ${k.join(".")} is ${JSON.stringify(i)}`)}else y(`Ignoring ${o} as ${k.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=R;function b(t,o){const d=o.split(".");g(t,d)}e.removeFromValueTree=b;function g(t,o){const d=o.shift();if(o.length===0){delete t[d];return}if(Object.keys(t).indexOf(d)!==-1){const y=t[d];typeof y=="object"&&!Array.isArray(y)&&(g(y,o),Object.keys(y).length===0&&delete t[d])}}function _(t,o,d){function y(i,a){let r=i;for(const s of a){if(typeof r!="object"||r===null)return;r=r[s]}return r}const k=o.split("."),v=y(t,k);return typeof v>"u"?d:v}e.getConfigurationValue=_;function p(t,o,d){Object.keys(o).forEach(y=>{y!=="__proto__"&&(y in t?n.isObject(t[y])&&n.isObject(o[y])?p(t[y],o[y],d):d&&(t[y]=o[y]):t[y]=o[y])})}e.merge=p;function u(t){return t.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=u}),define(Te[31],Pe([1,0,20,13,165,3,137,9]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",n.isMacintosh),S.set("isLinux",n.isLinux),S.set("isWindows",n.isWindows),S.set("isWeb",n.isWeb),S.set("isMacNative",n.isMacintosh&&!n.isWeb),S.set("isEdge",n.isEdge),S.set("isFirefox",n.isFirefox),S.set("isChrome",n.isChrome),S.set("isSafari",n.isSafari);function h($,O){if(S.get($)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set($,O)}e.setConstant=h;const R=Object.prototype.hasOwnProperty;var b;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const g={regexParsingWithErrorRecovery:!0},_=(0,A.localize)(0,null),p=(0,A.localize)(1,null),u=(0,A.localize)(2,null),t=(0,A.localize)(3,null),o=(0,A.localize)(4,null),d=(0,A.localize)(5,null),y=(0,A.localize)(6,null),k=(0,A.localize)(7,null);class v{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(O=g){this._config=O,this._scanner=new D.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(O){if(O===""){this._parsingErrors.push({message:_,offset:0,lexeme:"",additionalInfo:p});return}this._tokens=this._scanner.reset(O).scan(),this._current=0,this._parsingErrors=[];try{const X=this._expr();if(!this._isAtEnd()){const me=this._peek(),Ce=me.type===17?d:void 0;throw this._parsingErrors.push({message:o,offset:me.offset,lexeme:D.Scanner.getLexeme(me),additionalInfo:Ce}),v._parseError}return X}catch(X){if(X!==v._parseError)throw X;return}}_expr(){return this._or()}_or(){const O=[this._and()];for(;this._matchOne(16);){const X=this._and();O.push(X)}return O.length===1?O[0]:i.or(...O)}_and(){const O=[this._term()];for(;this._matchOne(15);){const X=this._term();O.push(X)}return O.length===1?O[0]:i.and(...O)}_term(){if(this._matchOne(2)){const O=this._peek();switch(O.type){case 11:return this._advance(),w.INSTANCE;case 12:return this._advance(),I.INSTANCE;case 0:{this._advance();const X=this._expr();return this._consume(1,t),X?.negate()}case 17:return this._advance(),L.create(O.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",O)}}return this._primary()}_primary(){const O=this._peek();switch(O.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const X=this._expr();return this._consume(1,t),X}case 17:{const X=O.lexeme;if(this._advance(),this._matchOne(9)){const Ce=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Ce.type!==10)throw this._errExpectedButGot("REGEX",Ce);const ye=Ce.lexeme,Ee=ye.lastIndexOf("/"),Ie=Ee===ye.length-1?void 0:this._removeFlagsGY(ye.substring(Ee+1));let oe;try{oe=new RegExp(ye.substring(1,Ee),Ie)}catch{throw this._errExpectedButGot("REGEX",Ce)}return G.create(X,oe)}switch(Ce.type){case 10:case 19:{const ye=[Ce.lexeme];this._advance();let Ee=this._peek(),Ie=0;for(let C=0;C<Ce.lexeme.length;C++)Ce.lexeme.charCodeAt(C)===40?Ie++:Ce.lexeme.charCodeAt(C)===41&&Ie--;for(;!this._isAtEnd()&&Ee.type!==15&&Ee.type!==16;){switch(Ee.type){case 0:Ie++;break;case 1:Ie--;break;case 10:case 18:for(let C=0;C<Ee.lexeme.length;C++)Ee.lexeme.charCodeAt(C)===40?Ie++:Ce.lexeme.charCodeAt(C)===41&&Ie--}if(Ie<0)break;ye.push(D.Scanner.getLexeme(Ee)),this._advance(),Ee=this._peek()}const oe=ye.join(""),ce=oe.lastIndexOf("/"),ie=ce===oe.length-1?void 0:this._removeFlagsGY(oe.substring(ce+1));let ne;try{ne=new RegExp(oe.substring(1,ce),ie)}catch{throw this._errExpectedButGot("REGEX",Ce)}return i.regex(X,ne)}case 18:{const ye=Ce.lexeme;this._advance();let Ee=null;if(!(0,T.isFalsyOrWhitespace)(ye)){const Ie=ye.indexOf("/"),oe=ye.lastIndexOf("/");if(Ie!==oe&&Ie>=0){const ce=ye.slice(Ie+1,oe),ie=ye[oe+1]==="i"?"i":"";try{Ee=new RegExp(ce,ie)}catch{throw this._errExpectedButGot("REGEX",Ce)}}}if(Ee===null)throw this._errExpectedButGot("REGEX",Ce);return G.create(X,Ee)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,u);const Ce=this._value();return i.notIn(X,Ce)}switch(this._peek().type){case 3:{this._advance();const Ce=this._value();if(this._previous().type===18)return i.equals(X,Ce);switch(Ce){case"true":return i.has(X);case"false":return i.not(X);default:return i.equals(X,Ce)}}case 4:{this._advance();const Ce=this._value();if(this._previous().type===18)return i.notEquals(X,Ce);switch(Ce){case"true":return i.not(X);case"false":return i.has(X);default:return i.notEquals(X,Ce)}}case 5:return this._advance(),U.create(X,this._value());case 6:return this._advance(),B.create(X,this._value());case 7:return this._advance(),J.create(X,this._value());case 8:return this._advance(),q.create(X,this._value());case 13:return this._advance(),i.in(X,this._value());default:return i.has(X)}}case 20:throw this._parsingErrors.push({message:y,offset:O.offset,lexeme:"",additionalInfo:k}),v._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const O=this._peek();switch(O.type){case 17:case 18:return this._advance(),O.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(O){return O.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(O){return this._check(O)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(O,X){if(this._check(O))return this._advance();throw this._errExpectedButGot(X,this._peek())}_errExpectedButGot(O,X,me){const Ce=(0,A.localize)(8,null,O,D.Scanner.getLexeme(X)),ye=X.offset,Ee=D.Scanner.getLexeme(X);return this._parsingErrors.push({message:Ce,offset:ye,lexeme:Ee,additionalInfo:me}),v._parseError}_check(O){return this._peek().type===O}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=v,v._parseError=new Error;class i{static false(){return w.INSTANCE}static true(){return I.INSTANCE}static has(O){return c.create(O)}static equals(O,X){return l.create(O,X)}static notEquals(O,X){return f.create(O,X)}static regex(O,X){return G.create(O,X)}static in(O,X){return m.create(O,X)}static notIn(O,X){return E.create(O,X)}static not(O){return L.create(O)}static and(...O){return Q.create(O,null,!0)}static or(...O){return pe.create(O,null,!0)}static greater(O,X){return J.create(O,X)}static greaterEquals(O,X){return q.create(O,X)}static smaller(O,X){return U.create(O,X)}static smallerEquals(O,X){return B.create(O,X)}static deserialize(O){return O==null?void 0:this._parser.parse(O)}}e.ContextKeyExpr=i,i._parser=new v({regexParsingWithErrorRecovery:!1});function a($){const O=new v({regexParsingWithErrorRecovery:!1});return $.map(X=>(O.parse(X),O.lexingErrors.length>0?O.lexingErrors.map(me=>({errorMessage:me.additionalInfo?(0,A.localize)(9,null,me.additionalInfo):(0,A.localize)(10,null),offset:me.offset,length:me.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(me=>({errorMessage:me.additionalInfo?`${me.message}. ${me.additionalInfo}`:me.message,offset:me.offset,length:me.lexeme.length})):[]))}e.validateWhenClauses=a;function r($,O){const X=$?$.substituteConstants():void 0,me=O?O.substituteConstants():void 0;return!X&&!me?!0:!X||!me?!1:X.equals(me)}e.expressionsAreEqualWithConstantSubstitution=r;function s($,O){return $.cmp(O)}class w{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return I.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class I{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=I,I.INSTANCE=new I;class c{static create(O,X=null){const me=S.get(O);return typeof me=="boolean"?me?I.INSTANCE:w.INSTANCE:new c(O,X)}constructor(O,X){this.key=O,this.negated=X,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:he(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=S.get(this.key);return typeof O=="boolean"?O?I.INSTANCE:w.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.negated||(this.negated=L.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=c;class l{static create(O,X,me=null){if(typeof X=="boolean")return X?c.create(O,me):L.create(O,me);const Ce=S.get(O);return typeof Ce=="boolean"?X===(Ce?"true":"false")?I.INSTANCE:w.INSTANCE:new l(O,X,me)}constructor(O,X,me){this.key=O,this.value=X,this.negated=me,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:de(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=S.get(this.key);if(typeof O=="boolean"){const X=O?"true":"false";return this.value===X?I.INSTANCE:w.INSTANCE}return this}evaluate(O){return O.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(O){return O.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=l;class m{static create(O,X){return new m(O,X)}constructor(O,X){this.key=O,this.valueKey=X,this.type=10,this.negated=null}cmp(O){return O.type!==this.type?this.type-O.type:de(this.key,this.valueKey,O.key,O.valueKey)}equals(O){return O.type===this.type?this.key===O.key&&this.valueKey===O.valueKey:!1}substituteConstants(){return this}evaluate(O){const X=O.getValue(this.valueKey),me=O.getValue(this.key);return Array.isArray(X)?X.includes(me):typeof me=="string"&&typeof X=="object"&&X!==null?R.call(X,me):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(O){return O.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=E.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=m;class E{static create(O,X){return new E(O,X)}constructor(O,X){this.key=O,this.valueKey=X,this.type=11,this._negated=m.create(O,X)}cmp(O){return O.type!==this.type?this.type-O.type:this._negated.cmp(O._negated)}equals(O){return O.type===this.type?this._negated.equals(O._negated):!1}substituteConstants(){return this}evaluate(O){return!this._negated.evaluate(O)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(O){return O.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=E;class f{static create(O,X,me=null){if(typeof X=="boolean")return X?L.create(O,me):c.create(O,me);const Ce=S.get(O);return typeof Ce=="boolean"?X===(Ce?"true":"false")?w.INSTANCE:I.INSTANCE:new f(O,X,me)}constructor(O,X,me){this.key=O,this.value=X,this.negated=me,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:de(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=S.get(this.key);if(typeof O=="boolean"){const X=O?"true":"false";return this.value===X?w.INSTANCE:I.INSTANCE}return this}evaluate(O){return O.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(O){return O.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class L{static create(O,X=null){const me=S.get(O);return typeof me=="boolean"?me?w.INSTANCE:I.INSTANCE:new L(O,X)}constructor(O,X){this.key=O,this.negated=X,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:he(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=S.get(this.key);return typeof O=="boolean"?O?w.INSTANCE:I.INSTANCE:this}evaluate(O){return!O.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(O){return O.mapNot(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=L;function W($,O){if(typeof $=="string"){const X=parseFloat($);isNaN(X)||($=X)}return typeof $=="string"||typeof $=="number"?O($):w.INSTANCE}class J{static create(O,X,me=null){return W(X,Ce=>new J(O,Ce,me))}constructor(O,X,me){this.key=O,this.value=X,this.negated=me,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:de(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=J;class q{static create(O,X,me=null){return W(X,Ce=>new q(O,Ce,me))}constructor(O,X,me){this.key=O,this.value=X,this.negated=me,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:de(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=q;class U{static create(O,X,me=null){return W(X,Ce=>new U(O,Ce,me))}constructor(O,X,me){this.key=O,this.value=X,this.negated=me,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:de(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=U;class B{static create(O,X,me=null){return W(X,Ce=>new B(O,Ce,me))}constructor(O,X,me){this.key=O,this.value=X,this.negated=me,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:de(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=J.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=B;class G{static create(O,X){return new G(O,X)}constructor(O,X){this.key=O,this.regexp=X,this.type=7,this.negated=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.key<O.key)return-1;if(this.key>O.key)return 1;const X=this.regexp?this.regexp.source:"",me=O.regexp?O.regexp.source:"";return X<me?-1:X>me?1:0}equals(O){if(O.type===this.type){const X=this.regexp?this.regexp.source:"",me=O.regexp?O.regexp.source:"";return this.key===O.key&&X===me}return!1}substituteConstants(){return this}evaluate(O){const X=O.getValue(this.key);return this.regexp?this.regexp.test(X):!1}serialize(){const O=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${O}`}keys(){return[this.key]}map(O){return O.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=N.create(this)),this.negated}}e.ContextKeyRegexExpr=G;class N{static create(O){return new N(O)}constructor(O){this._actual=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this._actual.cmp(O._actual)}equals(O){return O.type===this.type?this._actual.equals(O._actual):!1}substituteConstants(){return this}evaluate(O){return!this._actual.evaluate(O)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(O){return new N(this._actual.map(O))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=N;function H($){let O=null;for(let X=0,me=$.length;X<me;X++){const Ce=$[X].substituteConstants();if($[X]!==Ce&&O===null){O=[];for(let ye=0;ye<X;ye++)O[ye]=$[ye]}O!==null&&(O[X]=Ce)}return O===null?$:O}class Q{static create(O,X,me){return Q._normalizeArr(O,X,me)}constructor(O,X){this.expr=O,this.negated=X,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let X=0,me=this.expr.length;X<me;X++){const Ce=s(this.expr[X],O.expr[X]);if(Ce!==0)return Ce}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let X=0,me=this.expr.length;X<me;X++)if(!this.expr[X].equals(O.expr[X]))return!1;return!0}return!1}substituteConstants(){const O=H(this.expr);return O===this.expr?this:Q.create(O,this.negated,!1)}evaluate(O){for(let X=0,me=this.expr.length;X<me;X++)if(!this.expr[X].evaluate(O))return!1;return!0}static _normalizeArr(O,X,me){const Ce=[];let ye=!1;for(const Ee of O)if(Ee){if(Ee.type===1){ye=!0;continue}if(Ee.type===0)return w.INSTANCE;if(Ee.type===6){Ce.push(...Ee.expr);continue}Ce.push(Ee)}if(Ce.length===0&&ye)return I.INSTANCE;if(Ce.length!==0){if(Ce.length===1)return Ce[0];Ce.sort(s);for(let Ee=1;Ee<Ce.length;Ee++)Ce[Ee-1].equals(Ce[Ee])&&(Ce.splice(Ee,1),Ee--);if(Ce.length===1)return Ce[0];for(;Ce.length>1;){const Ee=Ce[Ce.length-1];if(Ee.type!==9)break;Ce.pop();const Ie=Ce.pop(),oe=Ce.length===0,ce=pe.create(Ee.expr.map(ie=>Q.create([ie,Ie],null,me)),null,oe);ce&&(Ce.push(ce),Ce.sort(s))}if(Ce.length===1)return Ce[0];if(me){for(let Ee=0;Ee<Ce.length;Ee++)for(let Ie=Ee+1;Ie<Ce.length;Ie++)if(Ce[Ee].negate().equals(Ce[Ie]))return w.INSTANCE;if(Ce.length===1)return Ce[0]}return new Q(Ce,X)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const X of this.expr)O.push(...X.keys());return O}map(O){return new Q(this.expr.map(X=>X.map(O)),null)}negate(){if(!this.negated){const O=[];for(const X of this.expr)O.push(X.negate());this.negated=pe.create(O,this,!0)}return this.negated}}e.ContextKeyAndExpr=Q;class pe{static create(O,X,me){return pe._normalizeArr(O,X,me)}constructor(O,X){this.expr=O,this.negated=X,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let X=0,me=this.expr.length;X<me;X++){const Ce=s(this.expr[X],O.expr[X]);if(Ce!==0)return Ce}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let X=0,me=this.expr.length;X<me;X++)if(!this.expr[X].equals(O.expr[X]))return!1;return!0}return!1}substituteConstants(){const O=H(this.expr);return O===this.expr?this:pe.create(O,this.negated,!1)}evaluate(O){for(let X=0,me=this.expr.length;X<me;X++)if(this.expr[X].evaluate(O))return!0;return!1}static _normalizeArr(O,X,me){let Ce=[],ye=!1;if(O){for(let Ee=0,Ie=O.length;Ee<Ie;Ee++){const oe=O[Ee];if(oe){if(oe.type===0){ye=!0;continue}if(oe.type===1)return I.INSTANCE;if(oe.type===9){Ce=Ce.concat(oe.expr);continue}Ce.push(oe)}}if(Ce.length===0&&ye)return w.INSTANCE;Ce.sort(s)}if(Ce.length!==0){if(Ce.length===1)return Ce[0];for(let Ee=1;Ee<Ce.length;Ee++)Ce[Ee-1].equals(Ce[Ee])&&(Ce.splice(Ee,1),Ee--);if(Ce.length===1)return Ce[0];if(me){for(let Ee=0;Ee<Ce.length;Ee++)for(let Ie=Ee+1;Ie<Ce.length;Ie++)if(Ce[Ee].negate().equals(Ce[Ie]))return I.INSTANCE;if(Ce.length===1)return Ce[0]}return new pe(Ce,X)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const X of this.expr)O.push(...X.keys());return O}map(O){return new pe(this.expr.map(X=>X.map(O)),null)}negate(){if(!this.negated){const O=[];for(const X of this.expr)O.push(X.negate());for(;O.length>1;){const X=O.shift(),me=O.shift(),Ce=[];for(const ye of le(X))for(const Ee of le(me))Ce.push(Q.create([ye,Ee],null,!1));O.unshift(pe.create(Ce,null,!1))}this.negated=pe.create(O,this,!0)}return this.negated}}e.ContextKeyOrExpr=pe;class we extends c{static all(){return we._info.values()}constructor(O,X,me){super(O,null),this._defaultValue=X,typeof me=="object"?we._info.push({...me,key:O}):me!==!0&&we._info.push({key:O,description:me,type:X!=null?typeof X:void 0})}bindTo(O){return O.createKey(this.key,this._defaultValue)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return l.create(this.key,O)}notEqualsTo(O){return f.create(this.key,O)}}e.RawContextKey=we,we._info=[],e.IContextKeyService=(0,F.createDecorator)("contextKeyService");function he($,O){return $<O?-1:$>O?1:0}function de($,O,X,me){return $<X?-1:$>X?1:O<me?-1:O>me?1:0}function Ae($,O){if($.type===0||O.type===1)return!0;if($.type===9)return O.type===9?ue($.expr,O.expr):!1;if(O.type===9){for(const X of O.expr)if(Ae($,X))return!0;return!1}if($.type===6){if(O.type===6)return ue(O.expr,$.expr);for(const X of $.expr)if(Ae(X,O))return!0;return!1}return $.equals(O)}e.implies=Ae;function ue($,O){let X=0,me=0;for(;X<$.length&&me<O.length;){const Ce=$[X].cmp(O[me]);if(Ce<0)return!1;Ce===0&&X++,me++}return X===$.length}function le($){return $.type===9?$.expr:[$]}}),define(Te[168],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Te[91],Pe([1,0,139,3]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function D(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function F(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function A(d,y){switch(d){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function P(d,y){return y==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function S(d,y,k){return P(y,k)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===k?!0:h(k).includes(d)}e.isTargetPlatformCompatible=S;function h(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function R(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=R;var b;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var g;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var _;(function(d){d.Install="install",d.Uninstall="uninstall"})(_||(e.StatisticType=_={}));var p;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var u;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.Internal="Internal"})(u||(e.ExtensionManagementErrorCode=u={}));var t;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class o extends Error{constructor(y,k){super(y),this.code=k,this.name=k}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,n.localize)(1,null),original:"Preferences"}}),define(Te[43],Pe([1,0,48,19,13,12,2,141,3,20,15]),function(te,e,n,T,D,F,A,P,S,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function b(Q){return Q.create===!0}e.isFileOpenForWriteOptions=b;var g;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.File=1]="File",Q[Q.Directory=2]="Directory",Q[Q.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var _;(function(Q){Q[Q.Readonly=1]="Readonly"})(_||(e.FilePermission=_={}));var p;(function(Q){Q[Q.None=0]="None",Q[Q.FileReadWrite=2]="FileReadWrite",Q[Q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Q[Q.FileReadStream=16]="FileReadStream",Q[Q.FileFolderCopy=8]="FileFolderCopy",Q[Q.PathCaseSensitive=1024]="PathCaseSensitive",Q[Q.Readonly=2048]="Readonly",Q[Q.Trash=4096]="Trash",Q[Q.FileWriteUnlock=8192]="FileWriteUnlock",Q[Q.FileAtomicRead=16384]="FileAtomicRead",Q[Q.FileClone=32768]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function u(Q){return!!(Q.capabilities&2)}e.hasReadWriteCapability=u;function t(Q){return!!(Q.capabilities&8)}e.hasFileFolderCopyCapability=t;function o(Q){return!!(Q.capabilities&32768)}e.hasFileCloneCapability=o;function d(Q){return!!(Q.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function y(Q){return!!(Q.capabilities&16)}e.hasFileReadStreamCapability=y;function k(Q){return u(Q)?!!(Q.capabilities&16384):!1}e.hasFileAtomicReadCapability=k;var v;(function(Q){Q.FileExists="EntryExists",Q.FileNotFound="EntryNotFound",Q.FileNotADirectory="EntryNotADirectory",Q.FileIsADirectory="EntryIsADirectory",Q.FileExceedsStorageQuota="EntryExceedsStorageQuota",Q.FileTooLarge="EntryTooLarge",Q.FileWriteLocked="EntryWriteLocked",Q.NoPermissions="NoPermissions",Q.Unavailable="Unavailable",Q.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class i extends Error{static create(pe,we){const he=new i(pe.toString(),we);return s(he,we),he}constructor(pe,we){super(pe),this.code=we}}e.FileSystemProviderError=i;function a(Q,pe){return i.create(Q,pe)}e.createFileSystemProviderError=a;function r(Q){return Q||a((0,P.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=r;function s(Q,pe){return Q.name=pe?`${pe} (FileSystemError)`:"FileSystemError",Q}e.markAsFileSystemProviderError=s;function w(Q){if(!Q)return v.Unknown;if(Q instanceof i)return Q.code;const pe=/^(.+) \(FileSystemError\)$/.exec(Q.name);if(!pe)return v.Unknown;switch(pe[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=w;function I(Q){if(Q instanceof L)return Q.fileOperationResult;switch(w(Q)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=I;var c;(function(Q){Q[Q.CREATE=0]="CREATE",Q[Q.DELETE=1]="DELETE",Q[Q.MOVE=2]="MOVE",Q[Q.COPY=3]="COPY",Q[Q.WRITE=4]="WRITE"})(c||(e.FileOperation=c={}));class l{constructor(pe,we,he){this.resource=pe,this.operation=we,this.target=he}isOperation(pe){return this.operation===pe}}e.FileOperationEvent=l;var m;(function(Q){Q[Q.UPDATED=0]="UPDATED",Q[Q.ADDED=1]="ADDED",Q[Q.DELETED=2]="DELETED"})(m||(e.FileChangeType=m={}));class E{constructor(pe,we){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const he=new Map;for(const de of pe){const Ae=he.get(de.type);switch(Ae?Ae.push([de.resource,de]):he.set(de.type,[[de.resource,de]]),de.type){case 1:this.rawAdded.push(de.resource);break;case 0:this.rawUpdated.push(de.resource);break;case 2:this.rawDeleted.push(de.resource);break}}for(const[de,Ae]of he)switch(de){case 1:this.added=n.TernarySearchTree.forUris(()=>we),this.added.fill(Ae);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>we),this.updated.fill(Ae);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>we),this.deleted.fill(Ae);break}}contains(pe,...we){return this.doContains(pe,{includeChildren:!1},...we)}affects(pe,...we){return this.doContains(pe,{includeChildren:!0},...we)}doContains(pe,we,...he){if(!pe)return!1;const de=he.length>0;return!!((!de||he.includes(1))&&(this.added?.get(pe)||we.includeChildren&&this.added?.findSuperstr(pe))||(!de||he.includes(0))&&(this.updated?.get(pe)||we.includeChildren&&this.updated?.findSuperstr(pe))||(!de||he.includes(2))&&(this.deleted?.findSubstr(pe)||we.includeChildren&&this.deleted?.findSuperstr(pe)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=E;function f(Q,pe,we){return!Q||!pe||Q===pe||pe.length>Q.length?!1:(pe.charAt(pe.length-1)!==T.sep&&(pe+=T.sep),we?(0,D.startsWithIgnoreCase)(Q,pe):Q.indexOf(pe)===0)}e.isParent=f;class L extends Error{constructor(pe,we,he){super(pe),this.fileOperationResult=we,this.options=he}}e.FileOperationError=L;class W extends L{constructor(pe,we,he,de){super(pe,we,de),this.fileOperationResult=we,this.size=he}}e.TooLargeFileOperationError=W;class J extends L{constructor(pe,we,he){super(pe,2,he),this.stat=we}}e.NotModifiedSinceFileOperationError=J;var q;(function(Q){Q[Q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Q[Q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Q[Q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Q[Q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Q[Q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Q[Q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Q[Q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Q[Q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Q[Q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Q[Q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Q[Q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(q||(e.FileOperationResult=q={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(Q){Q[Q.FILE=0]="FILE",Q[Q.FOLDER=1]="FOLDER",Q[Q.ROOT_FOLDER=2]="ROOT_FOLDER"})(U||(e.FileKind=U={})),e.ETAG_DISABLED="";function B(Q){if(!(typeof Q.size!="number"||typeof Q.mtime!="number"))return Q.mtime.toString(29)+Q.size.toString(31)}e.etag=B;async function G(Q,pe){if(!pe.hasProvider(A.URI.from({scheme:Q.scheme})))return new Promise(we=>{const he=pe.onDidChangeFileSystemProviderRegistrations(de=>{de.scheme===Q.scheme&&de.added&&(he.dispose(),we())})})}e.whenProviderRegistered=G;class N{static formatSize(pe){return(0,F.isNumber)(pe)||(pe=0),pe<N.KB?(0,P.localize)(1,null,pe.toFixed(0)):pe<N.MB?(0,P.localize)(2,null,(pe/N.KB).toFixed(2)):pe<N.GB?(0,P.localize)(3,null,(pe/N.MB).toFixed(2)):pe<N.TB?(0,P.localize)(4,null,(pe/N.GB).toFixed(2)):(0,P.localize)(5,null,(pe/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;function H(Q){const pe=typeof Q=="string"||Q?.scheme===R.Schemas.vscodeRemote;return typeof Q!="string"&&Q?.scheme===R.Schemas.file?1024*N.MB:pe?10*N.MB:h.isWeb?50*N.MB:1024*N.MB}e.getLargeFileConfirmationLimit=H}),define(Te[70],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...D){this._entries=new Map;for(const[F,A]of D)this.set(F,A)}set(D,F){const A=this._entries.get(D);return this._entries.set(D,F),A}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=n}),define(Te[169],Pe([1,0,17,9,6,68,167,3,70,170]),function(te,e,n,T,D,F,A,P,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class b extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class g{constructor(t=new S.ServiceCollection,o=!1,d,y=R){this._services=t,this._strict=o,this._parent=d,this._enableTracing=y,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=y?d?._globalGraph??new A.Graph(k=>k):void 0}createChild(t){return new g(t,this._strict,this,this._enableTracing)}invokeFunction(t,...o){const d=p.traceInvocation(this._enableTracing,t);let y=!1;try{return t({get:v=>{if(y)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(v,d);if(!i)throw new Error(`[invokeFunction] unknown service '${v}'`);return i}},...o)}finally{y=!0,d.stop()}}createInstance(t,...o){let d,y;return t instanceof F.SyncDescriptor?(d=p.traceCreation(this._enableTracing,t.ctor),y=this._createInstance(t.ctor,t.staticArguments.concat(o),d)):(d=p.traceCreation(this._enableTracing,t),y=this._createInstance(t,o,d)),d.stop(),y}_createInstance(t,o=[],d){const y=P._util.getServiceDependencies(t).sort((i,a)=>i.index-a.index),k=[];for(const i of y){const a=this._getOrCreateServiceInstance(i.id,d);a||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${i.id}.`,!1),k.push(a)}const v=y.length>0?y[0].index:o.length;if(o.length!==v){console.trace(`[createInstance] First service dependency of ${t.name} at position ${v+1} conflicts with ${o.length} static arguments`);const i=v-o.length;i>0?o=o.concat(new Array(i)):o=o.slice(0,v)}return Reflect.construct(t,o.concat(k))}_setServiceInstance(t,o){if(this._services.get(t)instanceof F.SyncDescriptor)this._services.set(t,o);else if(this._parent)this._parent._setServiceInstance(t,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){const o=this._services.get(t);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):o}_getOrCreateServiceInstance(t,o){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(t));const d=this._getServiceInstanceOrDescriptor(t);return d instanceof F.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,d,o.branch(t,!0)):(o.branch(t,!1),d)}_safeCreateAndCacheServiceInstance(t,o,d){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,o,d)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,o,d){const y=new A.Graph(i=>i.id.toString());let k=0;const v=[{id:t,desc:o,_trace:d}];for(;v.length;){const i=v.pop();if(y.lookupOrInsertNode(i),k++>1e3)throw new b(y);for(const a of P._util.getServiceDependencies(i.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(a.id);if(r||this._throwIfStrict(`[createInstance] ${t} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(a.id)),r instanceof F.SyncDescriptor){const s={id:a.id,desc:r,_trace:i._trace.branch(a.id,!0)};y.insertEdge(i,s),v.push(s)}}}for(;;){const i=y.roots();if(i.length===0){if(!y.isEmpty())throw new b(y);break}for(const{data:a}of i){if(this._getServiceInstanceOrDescriptor(a.id)instanceof F.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}y.removeNode(a)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,o,d=[],y,k){if(this._services.get(t)instanceof F.SyncDescriptor)return this._createServiceInstance(t,o,d,y,k);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,o,d,y,k);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(t,o,d=[],y,k){if(y){const v=new g(void 0,this._strict,this,this._enableTracing);v._globalGraphImplicitDependency=String(t);const i=new Map,a=new n.IdleValue(()=>{const r=v._createInstance(o,d,k);for(const[s,w]of i){const I=r[s];if(typeof I=="function")for(const c of w)I.apply(r,c)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let c=i.get(s);return c||(c=new h.LinkedList,i.set(s,c)),(m,E,f)=>{const L=c.push([m,E,f]);return(0,D.toDisposable)(L)}}if(s in r)return r[s];const w=a.value;let I=w[s];return typeof I!="function"||(I=I.bind(w),r[s]=I),I},set(r,s,w){return a.value[s]=w,!0},getPrototypeOf(r){return o.prototype}})}else return this._createInstance(o,d,k)}_throwIfStrict(t,o){if(o&&console.warn(t),this._strict)throw new Error(t)}}e.InstantiationService=g;var _;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})(_||(_={}));class p{static traceInvocation(t,o){return t?new p(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(t,o){return t?new p(1,o.name):p._None}constructor(t,o){this.type=t,this.name=o,this._start=Date.now(),this._dep=[]}branch(t,o){const d=new p(3,t.toString());return this._dep.push([t,o,d]),d}stop(){const t=Date.now()-this._start;p._totals+=t;let o=!1;function d(k,v){const i=[],a=new Array(k+1).join("	");for(const[r,s,w]of v._dep)if(s&&w){o=!0,i.push(`${a}CREATES -> ${r}`);const I=d(k+1,w);I&&i.push(I)}else i.push(`${a}uses -> ${r}`);return i.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(t>2||o)&&p.all.add(y.join(`
`))}}e.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p._totals=0}),define(Te[14],Pe([1,0,40,5,92,6,28,20,22,12,2,31,3]),function(te,e,n,T,D,F,A,P,S,h,R,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function _(){return new Date().toISOString()}function p(m){return(0,h.isNumber)(m)}e.isLogLevel=p;var u;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(u||(e.LogLevel=u={})),e.DEFAULT_LOG_LEVEL=u.Info;function t(m,E,f){switch(E){case u.Trace:m.trace(f);break;case u.Debug:m.debug(f);break;case u.Info:m.info(f);break;case u.Warning:m.warn(f);break;case u.Error:m.error(f);break;case u.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=t;function o(m,E=!1){let f="";for(let L=0;L<m.length;L++){let W=m[L];if(W instanceof Error&&(W=(0,n.toErrorMessage)(W,E)),typeof W=="object")try{W=JSON.stringify(W)}catch{}f+=(L>0?" ":"")+W}return f}class d extends F.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(E){this.level!==E&&(this.level=E,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(E){return this.level!==u.Off&&this.level<=E}}e.AbstractLogger=d;class y extends d{constructor(E){super(),this.logAlways=E}checkLogLevel(E){return this.logAlways||super.checkLogLevel(E)}trace(E,...f){this.checkLogLevel(u.Trace)&&this.log(u.Trace,o([E,...f],!0))}debug(E,...f){this.checkLogLevel(u.Debug)&&this.log(u.Debug,o([E,...f]))}info(E,...f){this.checkLogLevel(u.Info)&&this.log(u.Info,o([E,...f]))}warn(E,...f){this.checkLogLevel(u.Warning)&&this.log(u.Warning,o([E,...f]))}error(E,...f){if(this.checkLogLevel(u.Error))if(E instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=E.stack,this.log(u.Error,o(L))}else this.log(u.Error,o([E,...f]))}flush(){}}e.AbstractMessageLogger=y;class k extends d{constructor(E=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(E),this.useColors=!P.isWindows}trace(E,...f){this.checkLogLevel(u.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${_()}]\x1B[0m`,E,...f):console.log(`[main ${_()}]`,E,...f))}debug(E,...f){this.checkLogLevel(u.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${_()}]\x1B[0m`,E,...f):console.log(`[main ${_()}]`,E,...f))}info(E,...f){this.checkLogLevel(u.Info)&&(this.useColors?console.log(`\x1B[90m[main ${_()}]\x1B[0m`,E,...f):console.log(`[main ${_()}]`,E,...f))}warn(E,...f){this.checkLogLevel(u.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${_()}]\x1B[0m`,E,...f):console.warn(`[main ${_()}]`,E,...f))}error(E,...f){this.checkLogLevel(u.Error)&&(this.useColors?console.error(`\x1B[91m[main ${_()}]\x1B[0m`,E,...f):console.error(`[main ${_()}]`,E,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class v extends d{constructor(E=e.DEFAULT_LOG_LEVEL,f=!0){super(),this.useColors=f,this.setLevel(E)}trace(E,...f){this.checkLogLevel(u.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",E,...f):console.log(E,...f))}debug(E,...f){this.checkLogLevel(u.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",E,...f):console.log(E,...f))}info(E,...f){this.checkLogLevel(u.Info)&&(this.useColors?console.log("%c INFO","color: #33f",E,...f):console.log(E,...f))}warn(E,...f){this.checkLogLevel(u.Warning)&&(this.useColors?console.log("%c WARN","color: #993",E,...f):console.log(E,...f))}error(E,...f){this.checkLogLevel(u.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",E,...f):console.error(E,...f))}dispose(){}flush(){}}e.ConsoleLogger=v;class i extends d{constructor(E,f=e.DEFAULT_LOG_LEVEL){super(),this.adapter=E,this.setLevel(f)}trace(E,...f){this.checkLogLevel(u.Trace)&&this.adapter.log(u.Trace,[this.extractMessage(E),...f])}debug(E,...f){this.checkLogLevel(u.Debug)&&this.adapter.log(u.Debug,[this.extractMessage(E),...f])}info(E,...f){this.checkLogLevel(u.Info)&&this.adapter.log(u.Info,[this.extractMessage(E),...f])}warn(E,...f){this.checkLogLevel(u.Warning)&&this.adapter.log(u.Warning,[this.extractMessage(E),...f])}error(E,...f){this.checkLogLevel(u.Error)&&this.adapter.log(u.Error,[this.extractMessage(E),...f])}extractMessage(E){return typeof E=="string"?E:(0,n.toErrorMessage)(E,this.checkLogLevel(u.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class a extends d{constructor(E){super(),this.loggers=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const f of this.loggers)f.setLevel(E);super.setLevel(E)}trace(E,...f){for(const L of this.loggers)L.trace(E,...f)}debug(E,...f){for(const L of this.loggers)L.debug(E,...f)}info(E,...f){for(const L of this.loggers)L.info(E,...f)}warn(E,...f){for(const L of this.loggers)L.warn(E,...f)}error(E,...f){for(const L of this.loggers)L.error(E,...f)}flush(){for(const E of this.loggers)E.flush()}dispose(){for(const E of this.loggers)E.dispose()}}e.MultiplexLogger=a;class r extends F.Disposable{constructor(E,f,L){if(super(),this.logLevel=E,this.logsHome=f,this._loggers=new A.ResourceMap,this._onDidChangeLoggers=this._register(new T.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,L)for(const W of L)this._loggers.set(W.resource,{logger:void 0,info:W})}getLoggerEntry(E){return(0,h.isString)(E)?[...this._loggers.values()].find(f=>f.info.id===E):this._loggers.get(E)}getLogger(E){return this.getLoggerEntry(E)?.logger}createLogger(E,f){const L=this.toResource(E),W=(0,h.isString)(E)?E:f?.id??(0,D.hash)(L.toString()).toString(16);let J=this._loggers.get(L)?.logger;const q=f?.logLevel==="always"?u.Trace:f?.logLevel;J||(J=this.doCreateLogger(L,q??this.getLogLevel(L)??this.logLevel,{...f,id:W}));const U={logger:J,info:{resource:L,id:W,logLevel:q,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId,when:f?.when}};return this.registerLogger(U.info),this._loggers.set(L,U),J}toResource(E){return(0,h.isString)(E)?(0,S.joinPath)(this.logsHome,`${E}.log`):E}setLogLevel(E,f){if(R.URI.isUri(E)){const L=E,W=f,J=this._loggers.get(L);J&&W!==J.info.logLevel&&(J.info.logLevel=W===this.logLevel?void 0:W,J.logger?.setLevel(W),this._loggers.set(J.info.resource,J),this._onDidChangeLogLevel.fire([L,W]))}else{this.logLevel=E;for(const[L,W]of this._loggers.entries())this._loggers.get(L)?.info.logLevel===void 0&&W.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(E,f){const L=this.getLoggerEntry(E);L&&f!==!L.info.hidden&&(L.info.hidden=!f,this._loggers.set(L.info.resource,L),this._onDidChangeVisibility.fire([L.info.resource,f]))}getLogLevel(E){let f;return E&&(f=this._loggers.get(E)?.info.logLevel),f??this.logLevel}registerLogger(E){const f=this._loggers.get(E.resource);f?f.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this._loggers.set(E.resource,{info:E,logger:void 0}),this._onDidChangeLoggers.fire({added:[E],removed:[]}))}deregisterLogger(E){const f=this._loggers.get(E);f&&(f.logger&&f.logger.dispose(),this._loggers.delete(E),this._onDidChangeLoggers.fire({added:[],removed:[f.info]}))}*getRegisteredLoggers(){for(const E of this._loggers.values())yield E.info}getRegisteredLogger(E){return this._loggers.get(E)?.info}dispose(){this._loggers.forEach(E=>E.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=r;class s{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(E){}getLevel(){return u.Info}trace(E,...f){}debug(E,...f){}info(E,...f){}warn(E,...f){}error(E,...f){}critical(E,...f){}dispose(){}flush(){}}e.NullLogger=s;class w extends s{}e.NullLogService=w;function I(m){if(m.verbose)return u.Trace;if(typeof m.logLevel=="string"){const E=l(m.logLevel.toLowerCase());if(E!==void 0)return E}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function c(m){switch(m){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}e.LogLevelToString=c;function l(m){switch(m){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.parseLogLevel=l,e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",c(u.Info))}),define(Te[171],Pe([1,0,6,14]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends n.Disposable{constructor(A,P=[]){super(),this.logger=new T.MultiplexLogger([A,...P]),this._register(A.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}flush(){this.logger.flush()}}e.LogService=D}),define(Te[93],Pe([1,0,29,142,3]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var A;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(S){function h(p,u){return u-p}S.compare=h;const R=Object.create(null);R[S.Error]=(0,T.localize)(0,null),R[S.Warning]=(0,T.localize)(1,null),R[S.Info]=(0,T.localize)(2,null);function b(p){return R[p]||""}S.toString=b;function g(p){switch(p){case n.default.Error:return S.Error;case n.default.Warning:return S.Warning;case n.default.Info:return S.Info;case n.default.Ignore:return S.Hint}}S.fromSeverity=g;function _(p){switch(p){case S.Error:return n.default.Error;case S.Warning:return n.default.Warning;case S.Info:return n.default.Info;case S.Hint:return n.default.Ignore}}S.toSeverity=_}(A||(e.MarkerSeverity=A={}));var P;(function(S){const h="";function R(g){return b(g,!0)}S.makeKey=R;function b(g,_){const p=[h];return g.source?p.push(g.source.replace("\xA6","\\\xA6")):p.push(h),g.code?typeof g.code=="string"?p.push(g.code.replace("\xA6","\\\xA6")):p.push(g.code.value.replace("\xA6","\\\xA6")):p.push(h),g.severity!==void 0&&g.severity!==null?p.push(A.toString(g.severity)):p.push(h),g.message&&_?p.push(g.message.replace("\xA6","\\\xA6")):p.push(h),g.startLineNumber!==void 0&&g.startLineNumber!==null?p.push(g.startLineNumber.toString()):p.push(h),g.startColumn!==void 0&&g.startColumn!==null?p.push(g.startColumn.toString()):p.push(h),g.endLineNumber!==void 0&&g.endLineNumber!==null?p.push(g.endLineNumber.toString()):p.push(h),g.endColumn!==void 0&&g.endColumn!==null?p.push(g.endColumn.toString()):p.push(h),p.push(h),p.join("\xA6")}S.makeKeyOptionalMessage=b})(P||(e.IMarkerData=P={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Te[172],Pe([1,0,5,29,3]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,D.createDecorator)("notificationService");var F;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var P;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(P||(e.NotificationsFilter=P={}));class S{constructor(){this.progress=new h,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(b){}updateMessage(b){}updateActions(b){}close(){}}e.NoOpNotification=S;class h{infinite(){}done(){}total(b){}worked(b){}}e.NoOpProgress=h}),define(Te[94],Pe([1,0,13,2,3]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService");function F(h,R){return T.URI.isUri(h)?(0,n.equalsIgnoreCase)(h.scheme,R):(0,n.startsWithIgnoreCase)(h,R+":")}e.matchesScheme=F;function A(h,...R){return R.some(b=>F(h,b))}e.matchesSomeScheme=A;function P(h,R){return h.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=P;function S(h){let R;const b=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(h.fragment);return b&&(R={startLineNumber:parseInt(b[1]),startColumn:b[2]?parseInt(b[2]):1,endLineNumber:b[4]?parseInt(b[4]):void 0,endColumn:b[4]?b[5]?parseInt(b[5]):1:void 0},h=h.with({fragment:""})),{selection:R,uri:h}}e.extractSelection=S}),define(Te[173],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var je=this&&this.__decorate||function(te,e,n,T){var D=arguments.length,F=D<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,n):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(te,e,n,T);else for(var P=te.length-1;P>=0;P--)(A=te[P])&&(F=(D<3?A(F):D>3?A(e,n,F):A(e,n))||F);return D>3&&F&&Object.defineProperty(e,n,F),F},Ve=this&&this.__param||function(te,e){return function(n,T){e(n,T,te)}};define(Te[174],Pe([1,0,17,21,6,3]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,F.createDecorator)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this._value}constructor(b){this.callback=b}report(b){this._value=b,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let S=e.UnmanagedProgress=class extends D.Disposable{constructor(b,g){super(),this.deferred=new n.DeferredPromise,g.withProgress(b,_=>(this.reporter=_,this.lastStep&&_.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};e.UnmanagedProgress=S=je([Ve(1,e.IProgressService)],S);class h extends D.Disposable{constructor(b){super(),this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(b){this.stop();const g=++this.currentOperationId,_=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>_.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:_.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=h,e.IEditorProgressService=(0,F.createDecorator)("editorProgressService")}),define(Te[30],Pe([1,0,49,12]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(A,P){n.ok(T.isString(A)),n.ok(T.isObject(P)),n.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new D}),define(Te[71],Pe([1,0,5,30]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class F{constructor(){this._onDidChangeSchema=new n.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,h){this.schemasById[D(S)]=h,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new F;T.Registry.add(e.Extensions.JSONContribution,A)}),define(Te[95],Pe([1,0,16,5,12,136,42,71,30]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(h||(e.EditPresentationTypes=h={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=S.Registry.as(P.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,a=!0){this.registerConfigurations([i],a)}registerConfigurations(i,a=!0){const r=new Set;this.doRegisterConfigurations(i,a,r),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(i){const a=new Set;this.doDeregisterConfigurations(i,a),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:i,remove:a}){const r=new Set;this.doDeregisterConfigurations(a,r),this.doRegisterConfigurations(i,!1,r),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(i){const a=new Set;this.doRegisterDefaultConfigurations(i,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,a){const r=[];for(const{overrides:s,source:w}of i)for(const I in s)if(a.add(I),e.OVERRIDE_PROPERTY_REGEX.test(I)){const c=this.configurationDefaultsOverrides.get(I),l=c?.valuesSources??new Map;if(w)for(const L of Object.keys(s[I]))l.set(L,w);const m={...c?.value||{},...s[I]};this.configurationDefaultsOverrides.set(I,{source:w,value:m,valuesSources:l});const E=(0,A.getLanguageTagSettingPlainKey)(I),f={type:"object",default:m,description:F.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:D.isString(w)?void 0:w,defaultValueSource:w};r.push(...u(I)),this.configurationProperties[I]=f,this.defaultLanguageConfigurationOverridesNode.properties[I]=f}else{this.configurationDefaultsOverrides.set(I,{value:s[I],source:w});const c=this.configurationProperties[I];c&&(this.updatePropertyDefaultValue(I,c),this.updateSchema(I,c))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(i){const a=new Set;this.doDeregisterDefaultConfigurations(i,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,a){for(const{overrides:r,source:s}of i)for(const w in r){const I=this.configurationDefaultsOverrides.get(w),c=D.isString(s)?s:s?.id,l=D.isString(I?.source)?I?.source:I?.source?.id;if(c===l)if(a.add(w),this.configurationDefaultsOverrides.delete(w),e.OVERRIDE_PROPERTY_REGEX.test(w))delete this.configurationProperties[w],delete this.defaultLanguageConfigurationOverridesNode.properties[w];else{const m=this.configurationProperties[w];m&&(this.updatePropertyDefaultValue(w,m),this.updateSchema(w,m))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let a=!1;const r=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,r),a=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,r),a=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,r),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const a of i)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,a,r){i.forEach(s=>{this.validateAndRegisterProperties(s,a,s.extensionInfo,s.restrictedProperties,void 0,r),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(i,a){const r=s=>{if(s.properties)for(const w in s.properties){a.add(w);const I=this.configurationProperties[w];I?.policy?.name&&this.policyConfigurations.delete(I.policy.name),delete this.configurationProperties[w],this.removeFromSchema(w,s.properties[w])}s.allOf?.forEach(w=>r(w))};for(const s of i){r(s);const w=this.configurationContributors.indexOf(s);w!==-1&&this.configurationContributors.splice(w,1)}}validateAndRegisterProperties(i,a=!0,r,s,w=3,I){w=D.isUndefinedOrNull(i.scope)?w:i.scope;const c=i.properties;if(c)for(const m in c){const E=c[m];if(a&&y(m,E)){delete c[m];continue}if(E.source=r,E.defaultDefaultValue=c[m].default,this.updatePropertyDefaultValue(m,E),e.OVERRIDE_PROPERTY_REGEX.test(m)?E.scope=void 0:(E.scope=D.isUndefinedOrNull(E.scope)?w:E.scope,E.restricted=D.isUndefinedOrNull(E.restricted)?!!s?.includes(m):E.restricted),c[m].hasOwnProperty("included")&&!c[m].included){this.excludedConfigurationProperties[m]=c[m],delete c[m];continue}else this.configurationProperties[m]=c[m],c[m].policy?.name&&this.policyConfigurations.set(c[m].policy.name,m);!c[m].deprecationMessage&&c[m].markdownDeprecationMessage&&(c[m].deprecationMessage=c[m].markdownDeprecationMessage),I.add(m)}const l=i.allOf;if(l)for(const m of l)this.validateAndRegisterProperties(m,a,r,s,w,I)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const a=r=>{const s=r.properties;if(s)for(const I in s)this.updateSchema(I,s[I]);r.allOf?.forEach(a)};a(i)}updateSchema(i,a){switch(e.allSettings.properties[i]=a,a.scope){case 1:e.applicationSettings.properties[i]=a;break;case 2:e.machineSettings.properties[i]=a;break;case 6:e.machineOverridableSettings.properties[i]=a;break;case 3:e.windowSettings.properties[i]=a;break;case 4:e.resourceSettings.properties[i]=a;break;case 5:e.resourceSettings.properties[i]=a,this.resourceLanguageSettingsSchema.properties[i]=a;break}}removeFromSchema(i,a){switch(delete e.allSettings.properties[i],a.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const a=`[${i}]`,r={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,r),e.allSettings.properties[a]=r,e.applicationSettings.properties[a]=r,e.machineSettings.properties[a]=r,e.machineOverridableSettings.properties[a]=r,e.windowSettings.properties[a]=r,e.resourceSettings.properties[a]=r}}registerOverridePropertyPatternKey(){const i={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,a){const r=this.configurationDefaultsOverrides.get(i);let s=r?.value,w=r?.source;D.isUndefined(s)&&(s=a.defaultDefaultValue,w=void 0),D.isUndefined(s)&&(s=o(a.type)),a.default=s,a.defaultValueSource=w}}const _="\\[([^\\]]+)\\]",p=new RegExp(_,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${_})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function u(v){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let a=p.exec(v);for(;a?.length;){const r=a[1].trim();r&&i.push(r),a=p.exec(v)}}return(0,n.distinct)(i)}e.overrideIdentifiersFromKey=u;function t(v){return v.reduce((i,a)=>`${i}[${a}]`,"")}e.keyFromOverrideIdentifiers=t;function o(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const d=new g;S.Registry.add(e.Extensions.Configuration,d);function y(v,i){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?F.localize(7,null,v):d.getConfigurationProperties()[v]!==void 0?F.localize(8,null,v):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?F.localize(9,null,v,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:F.localize(6,null)}e.validateProperty=y;function k(){const v=[],i=d.getConfigurationProperties();for(const a of Object.keys(i))v.push([a,i[a].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=k}),define(Te[175],Pe([1,0,16,5,114,6,28,23,12,2,42,95,30]),function(te,e,n,T,D,F,A,P,S,h,R,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function _(a){return Object.isFrozen(a)?a:P.deepFreeze(a)}class p{constructor(r={},s=[],w=[],I){this._contents=r,this._keys=s,this._overrides=w,this.raw=I,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(s=>{if(s instanceof p)return s;const w=new u("");return w.parseRaw(s),w.configurationModel});this._rawConfiguration=r.reduce((s,w)=>w===s?w:s.merge(w),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}inspect(r,s){const w=this.rawConfiguration.getValue(r),I=s?this.rawConfiguration.getOverrideValue(r,s):void 0,c=s?this.rawConfiguration.override(s).getValue(r):w;return{value:w,override:I,merged:c}}getOverrideValue(r,s){const w=this.getContentsForOverrideIdentifer(s);return w?r?(0,R.getConfigurationValue)(w,r):w:void 0}getKeysForOverrideIdentifier(r){const s=[];for(const w of this.overrides)w.identifiers.includes(r)&&s.push(...w.keys);return n.distinct(s)}getAllOverrideIdentifiers(){const r=[];for(const s of this.overrides)r.push(...s.identifiers);return n.distinct(r)}override(r){let s=this.overrideConfigurations.get(r);return s||(s=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,s)),s}merge(...r){const s=P.deepClone(this.contents),w=P.deepClone(this.overrides),I=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const l of r)if(c.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.mergeContents(s,l.contents);for(const m of l.overrides){const[E]=w.filter(f=>n.equals(f.identifiers,m.identifiers));E?(this.mergeContents(E.contents,m.contents),E.keys.push(...m.keys),E.keys=n.distinct(E.keys)):w.push(P.deepClone(m))}for(const m of l.keys)I.indexOf(m)===-1&&I.push(m)}return new p(s,I,w,c.every(l=>l instanceof p)?void 0:c)}createOverrideConfigurationModel(r){const s=this.getContentsForOverrideIdentifer(r);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const w={};for(const I of n.distinct([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[I];const l=s[I];l&&(typeof c=="object"&&typeof l=="object"?(c=P.deepClone(c),this.mergeContents(c,l)):c=l),w[I]=c}return new p(w,this.keys,this.overrides)}mergeContents(r,s){for(const w of Object.keys(s)){if(w in r&&S.isObject(r[w])&&S.isObject(s[w])){this.mergeContents(r[w],s[w]);continue}r[w]=P.deepClone(s[w])}}getContentsForOverrideIdentifer(r){let s=null,w=null;const I=c=>{c&&(w?this.mergeContents(w,c):w=P.deepClone(c))};for(const c of this.overrides)n.equals(c.identifiers,[r])?s=c.contents:c.identifiers.includes(r)&&I(c.contents);return I(s),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,s){this.updateValue(r,s,!0)}setValue(r,s){this.updateValue(r,s,!1)}removeValue(r){const s=this.keys.indexOf(r);s!==-1&&(this.keys.splice(s,1),(0,R.removeFromValueTree)(this.contents,r),b.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(w=>n.equals(w.identifiers,(0,b.overrideIdentifiersFromKey)(r))),1))}updateValue(r,s,w){(0,R.addToValueTree)(this.contents,r,s,I=>console.error(I)),w=w||this.keys.indexOf(r)===-1,w&&this.keys.push(r),b.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,R.toValuesTree)(this.contents[r],I=>console.error(I))})}}e.ConfigurationModel=p;class u{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,s){if(!S.isUndefinedOrNull(r)){const w=this.doParseContent(r);this.parseRaw(w,s)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,s){this._raw=r;const{contents:w,keys:I,overrides:c,restricted:l,hasExcludedProperties:m}=this.doParseRaw(r,s);this._configurationModel=new p(w,I,c,m?[r]:void 0),this._restrictedConfigurations=l||[]}doParseContent(r){let s={},w=null,I=[];const c=[],l=[];function m(f){Array.isArray(I)?I.push(f):w!==null&&(I[w]=f)}const E={onObjectBegin:()=>{const f={};m(f),c.push(I),I=f,w=null},onObjectProperty:f=>{w=f},onObjectEnd:()=>{I=c.pop()},onArrayBegin:()=>{const f=[];m(f),c.push(I),I=f,w=null},onArrayEnd:()=>{I=c.pop()},onLiteralValue:m,onError:(f,L,W)=>{l.push({error:f,offset:L,length:W})}};if(r)try{D.visit(r,E),s=I[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return s}doParseRaw(r,s){const w=g.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),I=this.filter(r,w,!0,s);r=I.raw;const c=(0,R.toValuesTree)(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),l=Object.keys(r),m=this.toOverrides(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:c,keys:l,overrides:m,restricted:I.restricted,hasExcludedProperties:I.hasExcludedProperties}}filter(r,s,w,I){let c=!1;if(!I?.scopes&&!I?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const l={},m=[];for(const E in r)if(b.OVERRIDE_PROPERTY_REGEX.test(E)&&w){const f=this.filter(r[E],s,!1,I);l[E]=f.raw,c=c||f.hasExcludedProperties,m.push(...f.restricted)}else{const f=s[E],L=f?typeof f.scope<"u"?f.scope:3:void 0;f?.restricted&&m.push(E),(L===void 0||I.scopes===void 0||I.scopes.includes(L))&&!(I.skipRestricted&&f?.restricted)?l[E]=r[E]:c=!0}return{raw:l,restricted:m,hasExcludedProperties:c}}toOverrides(r,s){const w=[];for(const I of Object.keys(r))if(b.OVERRIDE_PROPERTY_REGEX.test(I)){const c={};for(const l in r[I])c[l]=r[I][l];w.push({identifiers:(0,b.overrideIdentifiersFromKey)(I),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,s)})}return w}}e.ConfigurationModelParser=u;class t extends F.Disposable{constructor(r,s,w,I){super(),this.userSettingsResource=r,this.scopes=s,this.fileService=I,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(w.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.any(T.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),T.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&w.isEqual(c.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class o{constructor(r,s,w,I,c,l,m,E,f,L,W,J,q){this.key=r,this.overrides=s,this._value=w,this.overrideIdentifiers=I,this.defaultConfiguration=c,this.policyConfiguration=l,this.applicationConfiguration=m,this.userConfiguration=E,this.localUserConfiguration=f,this.remoteUserConfiguration=L,this.workspaceConfiguration=W,this.folderConfigurationModel=J,this.memoryConfigurationModel=q}get value(){return _(this._value)}inspect(r,s,w){const I=r.inspect(s,w);return{get value(){return _(I.value)},get override(){return _(I.override)},get merged(){return _(I.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class d{constructor(r,s,w,I,c=new p,l=new p,m=new A.ResourceMap,E=new p,f=new A.ResourceMap){this._defaultConfiguration=r,this._policyConfiguration=s,this._applicationConfiguration=w,this._localUserConfiguration=I,this._remoteUserConfiguration=c,this._workspaceConfiguration=l,this._folderConfigurations=m,this._memoryConfiguration=E,this._memoryConfigurationByResource=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(r,s,w){return this.getConsolidatedConfigurationModel(r,s,w).getValue(r)}updateValue(r,s,w={}){let I;w.resource?(I=this._memoryConfigurationByResource.get(w.resource),I||(I=new p,this._memoryConfigurationByResource.set(w.resource,I))):I=this._memoryConfiguration,s===void 0?I.removeValue(r):I.setValue(r,s),w.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,s,w){const I=this.getConsolidatedConfigurationModel(r,s,w),c=this.getFolderConfigurationModelForResource(s.resource,w),l=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,m=new Set;for(const E of I.overrides)for(const f of E.identifiers)I.getOverrideValue(r,f)!==void 0&&m.add(f);return new o(r,s,I.getValue(r),m.size?[...m]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this._workspaceConfiguration:void 0,c||void 0,l)}keys(r){const s=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,s){this._folderConfigurations.set(r,s),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,s){const w=[];if(!s){const{added:I,updated:c,removed:l}=v(this._defaultConfiguration,r);s=[...I,...c,...l]}for(const I of s)for(const c of(0,b.overrideIdentifiersFromKey)(I)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(c),m=r.getKeysForOverrideIdentifier(c),E=[...m.filter(f=>l.indexOf(f)===-1),...l.filter(f=>m.indexOf(f)===-1),...l.filter(f=>!P.equals(this._defaultConfiguration.override(c).getValue(f),r.override(c).getValue(f)))];w.push([c,E])}return this.updateDefaultConfiguration(r),{keys:s,overrides:w}}compareAndUpdatePolicyConfiguration(r){const{added:s,updated:w,removed:I}=v(this._policyConfiguration,r),c=[...s,...w,...I];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:s,updated:w,removed:I,overrides:c}=v(this.applicationConfiguration,r),l=[...s,...w,...I];return l.length&&this.updateApplicationConfiguration(r),{keys:l,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:s,updated:w,removed:I,overrides:c}=v(this.localUserConfiguration,r),l=[...s,...w,...I];return l.length&&this.updateLocalUserConfiguration(r),{keys:l,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:s,updated:w,removed:I,overrides:c}=v(this.remoteUserConfiguration,r),l=[...s,...w,...I];return l.length&&this.updateRemoteUserConfiguration(r),{keys:l,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:s,updated:w,removed:I,overrides:c}=v(this.workspaceConfiguration,r),l=[...s,...w,...I];return l.length&&this.updateWorkspaceConfiguration(r),{keys:l,overrides:c}}compareAndUpdateFolderConfiguration(r,s){const w=this.folderConfigurations.get(r),{added:I,updated:c,removed:l,overrides:m}=v(w,s),E=[...I,...c,...l];return(E.length||!w)&&this.updateFolderConfiguration(r,s),{keys:E,overrides:m}}compareAndDeleteFolderConfiguration(r){const s=this.folderConfigurations.get(r);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:w,updated:I,removed:c,overrides:l}=v(s,void 0);return{keys:[...w,...I,...c],overrides:l}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,s,w){let I=this.getConsolidatedConfigurationModelForResource(s,w);return s.overrideIdentifier&&(I=I.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(I=I.merge(this._policyConfiguration)),I}getConsolidatedConfigurationModelForResource({resource:r},s){let w=this.getWorkspaceConsolidatedConfiguration();if(s&&r){const I=s.getFolder(r);I&&(w=this.getFolderConsolidatedConfiguration(I.uri)||w);const c=this._memoryConfigurationByResource.get(r);c&&(w=w.merge(c))}return w}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let s=this._foldersConsolidatedConfigurations.get(r);if(!s){const w=this.getWorkspaceConsolidatedConfiguration(),I=this._folderConfigurations.get(r);I?(s=w.merge(I),this._foldersConsolidatedConfigurations.set(r,s)):s=w}return s}getFolderConfigurationModelForResource(r,s){if(s&&r){const w=s.getFolder(r);if(w)return this._folderConfigurations.get(w.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,s)=>{const{contents:w,overrides:I,keys:c}=this._folderConfigurations.get(s);return r.push([s,{contents:w,overrides:I,keys:c}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(s=>r.add(s)),this.userConfiguration.keys.forEach(s=>r.add(s)),this._workspaceConfiguration.keys.forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(w=>r.add(w))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(w=>r.add(w))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(w=>s.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(w=>s.add(w)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(w=>s.add(w)),this._folderConfigurations.forEach(w=>w.getKeysForOverrideIdentifier(r).forEach(I=>s.add(I))),[...s.values()]}static parse(r){const s=this.parseConfigurationModel(r.defaults),w=this.parseConfigurationModel(r.policy),I=this.parseConfigurationModel(r.application),c=this.parseConfigurationModel(r.user),l=this.parseConfigurationModel(r.workspace),m=r.folders.reduce((E,f)=>(E.set(h.URI.revive(f[0]),this.parseConfigurationModel(f[1])),E),new A.ResourceMap);return new d(s,w,I,c,new p,l,m,new p,new A.ResourceMap)}static parseConfigurationModel(r){return new p(r.contents,r.keys,r.overrides)}}e.Configuration=d;function y(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const r=new Set,s=new Map;for(const I of a)I.keys.forEach(c=>r.add(c)),I.overrides.forEach(([c,l])=>{const m=(0,A.getOrSet)(s,c,new Set);l.forEach(E=>m.add(E))});const w=[];return s.forEach((I,c)=>w.push([c,[...I.values()]])),{keys:[...r.values()],overrides:w}}e.mergeChanges=y;class k{constructor(r,s,w,I){this.change=r,this.previous=s,this.currentConfiguraiton=w,this.currentWorkspace=I,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const l of c)this.affectedKeys.add(l);this._affectsConfigStr=this._marker;for(const c of this.affectedKeys)this._affectsConfigStr+=c+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,s){const w=this._marker+r,I=this._affectsConfigStr.indexOf(w);if(I<0)return!1;const c=I+w.length;if(c>=this._affectsConfigStr.length)return!1;const l=this._affectsConfigStr.charCodeAt(c);if(l!==this._markerCode1&&l!==this._markerCode2)return!1;if(s){const m=this.previousConfiguration?this.previousConfiguration.getValue(r,s,this.previous?.workspace):void 0,E=this.currentConfiguraiton.getValue(r,s,this.currentWorkspace);return!P.equals(m,E)}return!0}}e.ConfigurationChangeEvent=k;function v(a,r){const{added:s,removed:w,updated:I}=i(r?.rawConfiguration,a?.rawConfiguration),c=[],l=a?.getAllOverrideIdentifiers()||[],m=r?.getAllOverrideIdentifiers()||[];if(r){const E=m.filter(f=>!l.includes(f));for(const f of E)c.push([f,r.getKeysForOverrideIdentifier(f)])}if(a){const E=l.filter(f=>!m.includes(f));for(const f of E)c.push([f,a.getKeysForOverrideIdentifier(f)])}if(r&&a){for(const E of l)if(m.includes(E)){const f=i({contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});c.push([E,[...f.added,...f.removed,...f.updated]])}}return{added:s,removed:w,updated:I,overrides:c}}function i(a,r){const s=a?r?a.keys.filter(c=>r.keys.indexOf(c)===-1):[...a.keys]:[],w=r?a?r.keys.filter(c=>a.keys.indexOf(c)===-1):[...r.keys]:[],I=[];if(a&&r){for(const c of r.keys)if(a.keys.indexOf(c)!==-1){const l=(0,R.getConfigurationValue)(r.contents,c),m=(0,R.getConfigurationValue)(a.contents,c);P.equals(l,m)||I.push(c)}}return{added:s,removed:w,updated:I}}}),define(Te[96],Pe([1,0,9,3]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var D;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(D||(e.RemoteAuthorityResolverErrorCode=D={}));class F extends n.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof F&&S._code===D.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof F&&S._code===D.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof F&&S._code===D.NoResolverFound}static isHandled(S){return S instanceof F&&S.isHandled}constructor(S,h=D.Unknown,R){super(S),this._message=S,this._code=h,this._detail=R,this.isHandled=h===D.NotAvailable&&R===!0,Object.setPrototypeOf(this,F.prototype)}}e.RemoteAuthorityResolverError=F;function A(P){const S=P.indexOf("+");return S===-1?P:P.substring(0,S)}e.getRemoteAuthorityPrefix=A}),define(Te[50],Pe([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}e.getRemoteAuthority=T;function D(h){if(!h)return;const R=h.indexOf("+");return R<0?h:h.substr(0,R)}e.getRemoteName=D;function F(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.getRemoteServerRootPath=F;function A(h){const{host:R,port:b}=S(h);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:b}}e.parseAuthorityWithPort=A;function P(h,R){let{host:b,port:g}=S(h);return typeof g>"u"&&(g=R),{host:b,port:g}}e.parseAuthorityWithOptionalPort=P;function S(h){const R=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const b=h.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const g=h.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:h,port:void 0}}}),define(Te[24],Pe([1,0,13,3,50]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function F(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.getWorkspaceSupportTypeMessage=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(A||(e.ExtensionType=A={}));var P;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class S{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,o){if(typeof t>"u"||t===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof t=="string"||typeof o=="string"){const d=typeof t=="string"?t:t.value,y=typeof o=="string"?o:o.value;return n.equalsIgnoreCase(d,y)}return t._lower===o._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=S;class h{get size(){return this._set.size}constructor(t){if(this._set=new Set,t)for(const o of t)this.add(o)}add(t){this._set.add(S.toKey(t))}delete(t){return this._set.delete(S.toKey(t))}has(t){return this._set.has(S.toKey(t))}}e.ExtensionIdentifierSet=h;class R{constructor(){this._map=new Map}clear(){this._map.clear()}delete(t){this._map.delete(S.toKey(t))}get(t){return this._map.get(S.toKey(t))}has(t){return this._map.has(S.toKey(t))}set(t,o){this._map.set(S.toKey(t),o)}values(){return this._map.values()}forEach(t){this._map.forEach(t)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function b(u){return g(u)}e.isApplicationScopedExtension=b;function g(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function _(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=_;function p(u,t){if(t){const o=`onResolveRemoteAuthority:${(0,D.getRemoteName)(t)}`;return!!u.activationEvents?.includes(o)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Te[97],Pe([1,0,9,24]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this._generators=new Map,this._cache=new WeakMap}register(A,P){this._generators.set(A,P)}readActivationEvents(A){return this._cache.has(A)||this._cache.set(A,this._readActivationEvents(A)),this._cache.get(A)}createActivationEventsMap(A){const P=Object.create(null);for(const S of A){const h=this.readActivationEvents(S);h.length>0&&(P[T.ExtensionIdentifier.toKey(S.identifier)]=h)}return P}_readActivationEvents(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const P=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return P;for(const S in A.contributes){const h=this._generators.get(S);if(!h)continue;const R=A.contributes[S],b=Array.isArray(R)?R:[R];try{h(b,P)}catch(g){(0,n.onUnexpectedError)(g)}}return P}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D}),define(Te[176],Pe([1,0,20,51,35]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function F(S){if(n.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function A(S,h,R,b,g,_,p,u){const t=Object.create(null);t["common.machineId"]=_,t.sessionID=(0,D.generateUuid)()+Date.now(),t.commitHash=b,t.version=g,t["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,n.PlatformToString)(n.platform),t["common.nodePlatform"]=T.platform,t["common.nodeArch"]=R,t["common.product"]=u||"desktop",p&&(t["common.msftInternal"]=p);let o=0;const d=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),n.isLinuxSnap&&(t["common.snap"]="true");const y=F(h);return y&&(t["common.platformDetail"]=y),t}e.resolveCommonProperties=A;function P(S){const h=T.env.USERDNSDOMAIN;if(!h)return!1;const R=h.toLowerCase();return S.some(b=>R===b)}e.verifyMicrosoftInternalDomain=P}),define(Te[177],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var D;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(Te[52],Pe([1,0,23,12,5,42,50,176,177]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class h{constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=h;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=R,e.NullTelemetryService=new R;class b{async publicLog(w,I,c){}async publicLogError(w,I,c){}}e.NullEndpointTelemetryService=b,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(s,w){return D.Event.debounce(w.onDidChangeConfiguration,(c,l)=>{const m=c?new Set([...c.affectedKeys,...l.affectedKeys]):l.affectedKeys;return{...l,affectedKeys:m}},1e3,!0)(c=>{c.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,F.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=g;function _(s,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!s.enableTelemetry||w.extensionTestsLocationURI)}e.supportsTelemetry=_;function p(s,w){return!(w.isBuilt||w.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=p;function u(s){const w=s.getValue(S.TELEMETRY_SETTING_ID),I=s.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(s.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||I===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=u;function t(s){const w={},I={},c={};y(s,c);for(let l in c){l=l.length>150?l.substr(l.length-149):l;const m=c[l];typeof m=="number"?I[l]=m:typeof m=="boolean"?I[l]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${m.length}`),w[l]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(w[l]=m)}return{properties:w,measurements:I}}e.validateTelemetryData=t;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(s){if(!s)return"none";const w=(0,A.getRemoteName)(s);return o.has(w)?w:"other"}e.cleanRemoteAuthority=d;function y(s,w,I=0,c){if(s)for(const l of Object.getOwnPropertyNames(s)){const m=s[l],E=c?c+l:l;Array.isArray(m)?w[E]=(0,n.safeStringify)(m):m instanceof Date?w[E]=m.toISOString():(0,T.isObject)(m)?I<2?y(m,w,I+1,E+"."):w[E]=(0,n.safeStringify)(m):w[E]=m}}function k(s,w){const I=s.msftInternalDomains||[],c=w.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(I)||c}e.isInternalTelemetry=k;function v(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=v;function i(s,w){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let I=s;const c=[];for(const f of w)for(;;){const L=f.exec(s);if(!L)break;c.push([L.index,f.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(I="";;){const f=m.exec(s);if(!f)break;const L=c.some(([W,J])=>f.index<J&&W<m.lastIndex);!l.test(f[0])&&!L&&(I+=s.substring(E,f.index)+"<REDACTED: user-file-path>",E=m.lastIndex)}return E<s.length&&(I+=s.substr(E)),I}function a(s){if(!s)return s;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const I of w)if(I.regex.test(s))return`<REDACTED: ${I.label}>`;return s}function r(s,w){return(0,n.cloneAndChange)(s,I=>{if(I instanceof h||Object.hasOwnProperty.call(I,"isTrustedTelemetryValue"))return I.value;if(typeof I=="string"){let c=I.replaceAll("%20"," ");c=i(c,w);for(const l of w)c=c.replace(l,"");return c=a(c),c}})}e.cleanData=r}),define(Te[178],Pe([1,0,13,91,24,20,2,9,51,52]),function(te,e,n,T,D,F,A,P,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(r,s){return r.uuid&&s.uuid?r.uuid===s.uuid:r.id===s.id?!0:(0,n.compareIgnoreCase)(r.id,s.id)===0}e.areSameExtensions=R;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(s){const w=s.manifest?s.manifest.version:s.version,I=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new g(s.identifier,w,I)}static parse(s){const w=b.exec(s);return w&&w[1]&&w[2]?new g({id:w[1]},w[2],w[4]||void 0):null}constructor(s,w,I="undefined"){this.version=w,this.targetPlatform=I,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof g?R(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=g;const _=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const s=_.exec(r);return s&&s[1]?[t(s[1]),s[2]]:[t(r),void 0]}e.getIdAndVersion=p;function u(r,s){return`${r}.${s}`}e.getExtensionId=u;function t(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=t;function o(r,s){return t(u(r??D.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=o;function d(r,s){const w=[],I=c=>{for(const l of w)if(l.some(m=>R(s(m),s(c))))return l;return null};for(const c of r){const l=I(c);l?l.push(c):w.push([c])}return w}e.groupByExtension=d;function y(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function k(r){return{id:new h.TelemetryTrustedValue(r.identifier.id),name:new h.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function v(r,s){const w=[],I=s.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const c=I.shift();if(c&&w.every(l=>!R(l.identifier,{id:c}))){const l=r.filter(m=>R(m.identifier,{id:c}));l.length===1&&(w.push(l[0]),I.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=v;async function i(r,s){if(!F.isLinux)return!1;let w;try{w=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){s.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(r,s){const w=await i(r,s),I=(0,T.getTargetPlatform)(w?"alpine":F.platform,S.arch);return s.debug("ComputeTargetPlatform:",I),I}e.computeTargetPlatform=a}),define(Te[179],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function n(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=n;function T(S){return S?[...S.entries()]:[]}e.serializeEnvironmentDescriptionMap=T;function D(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=D;function F(S){return new Map(S??[])}e.deserializeEnvironmentDescriptionMap=F;function A(S){return Array.from(S.entries()).map(h=>[h[0],n(h[1].map),T(h[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=A;function P(S){return new Map(S.map(h=>[h[0],{map:D(h[1]),descriptionMap:F(h[2])}]))}e.deserializeEnvironmentVariableCollections=P}),define(Te[180],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,F,A=5){const P=F(S=>{const h=typeof S=="string"?S:S.data;let R=this._terminalBufferMap.get(D);if(R){R.data.push(h);return}const b=setTimeout(()=>this.flushBuffer(D),A);R={data:[h],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(D),P.dispose()}},this._terminalBufferMap.set(D,R)});return P}stopBuffering(D){this._terminalBufferMap.get(D)?.dispose()}flushBuffer(D){const F=this._terminalBufferMap.get(D);F&&(this._terminalBufferMap.delete(D),this._callback(D,F.data.join("")))}}e.TerminalDataBufferer=n}),define(Te[181],Pe([1,0,17,85,39,5,12,2,143,71,30]),function(te,e,n,T,D,F,A,P,S,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var b;(function(k){function v(i,a){let r=i.defaults;for(;D.ThemeIcon.isThemeIcon(r);){const s=p.getIcon(r.id);if(!s)return;r=s.defaults}return r}k.getDefinition=v})(b||(e.IconContribution=b={}));var g;(function(k){function v(a){return{weight:a.weight,style:a.style,src:a.src.map(r=>({format:r.format,location:r.location.toString()}))}}k.toJSONObject=v;function i(a){const r=s=>(0,A.isString)(s)?s:void 0;if(a&&Array.isArray(a.src)&&a.src.every(s=>(0,A.isString)(s.format)&&(0,A.isString)(s.location)))return{weight:r(a.weight),style:r(a.style),src:a.src.map(s=>({format:s.format,location:P.URI.parse(s.location)}))}}k.fromJSONObject=i})(g||(e.IconFontDefinition=g={}));class _{constructor(){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,i,a,r){const s=this.iconsById[v];if(s){if(a&&!s.description){s.description=a,this.iconSchema.properties[v].markdownDescription=`${a} $(${v})`;const c=this.iconReferenceSchema.enum.indexOf(v);c!==-1&&(this.iconReferenceSchema.enumDescriptions[c]=a),this._onDidChange.fire()}return s}const w={id:v,description:a,defaults:i,deprecationMessage:r};this.iconsById[v]=w;const I={$ref:"#/definitions/icons"};return r&&(I.deprecationMessage=r),a&&(I.markdownDescription=`${a}: $(${v})`),this.iconSchema.properties[v]=I,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const i=this.iconReferenceSchema.enum.indexOf(v);i!==-1&&(this.iconReferenceSchema.enum.splice(i,1),this.iconReferenceSchema.enumDescriptions.splice(i,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,i){const a=this.iconFontsById[v];return a||(this.iconFontsById[v]=i,this._onDidChange.fire(),i)}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(s,w)=>s.id.localeCompare(w.id),i=s=>{for(;D.ThemeIcon.isThemeIcon(s.defaults);)s=this.iconsById[s.defaults.id];return`codicon codicon-${s?s.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.iconsById).map(s=>this.iconsById[s]);for(const s of r.filter(w=>!!w.description).sort(v))a.push(`|<i class="${i(s)}"></i>|${s.id}|${D.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const s of r.filter(w=>!D.ThemeIcon.isThemeIcon(w.defaults)).sort(v))a.push(`|<i class="${i(s)}"></i>|${s.id}|`);return a.join(`
`)}}const p=new _;R.Registry.add(e.Extensions.IconContribution,p);function u(k,v,i,a){return p.registerIcon(k,v,i,a)}e.registerIcon=u;function t(){return p}e.getIconRegistry=t;function o(){const k=(0,T.getCodiconFontCharacters)();for(const v in k){const i="\\"+k[v].toString(16);p.registerIcon(v,{fontCharacter:i})}}o(),e.iconsSchemaId="vscode://schemas/icons";const d=R.Registry.as(h.Extensions.JSONContribution);d.registerSchema(e.iconsSchemaId,p.getIconSchema());const y=new n.RunOnceScheduler(()=>d.notifySchemaChanged(e.iconsSchemaId),200);p.onDidChange(()=>{y.isScheduled()||y.schedule()}),e.widgetClose=u("widget-close",T.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=u("goto-previous-location",T.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=u("goto-next-location",T.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=D.ThemeIcon.modify(T.Codicon.sync,"spin"),e.spinningLoading=D.ThemeIcon.modify(T.Codicon.loading,"spin")}),define(Te[182],Pe([1,0,5,42,3,14]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var A;(function(u){u.Http="http",u.Https="https"})(A||(e.TunnelProtocol=A={}));var P;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(P||(e.TunnelPrivacyId=P={}));var S;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(S||(e.ProvidedOnAutoForward=S={}));function h(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=h,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(u){return e.LOCALHOST_ADDRESSES.indexOf(u)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(u){return e.ALL_INTERFACES_ADDRESSES.indexOf(u)>=0}e.isAllInterfaces=b;function g(u,t,o,d){if(o===1)return!1;if(o===2&&b(t)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(y?.length===4&&parseInt(y[1])>=18)return!1}return u<1024}e.isPortPrivileged=g;class _{constructor(t,o,d){this.remoteAddress=t,this.localAddress=o,this._dispose=d,this._onDispose=new n.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=_;let p=e.AbstractTunnelService=class{constructor(t,o){this.logService=t,this.configurationService=o,this._onTunnelOpened=new n.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new n.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new n.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],o=Array.from(this._tunnels.values());for(const d of o){const y=Array.from(d.values());for(const k of y){const v=await k.value;v&&t.push(v)}}return t}async dispose(){for(const t of this._tunnels.values()){for(const{value:o}of t.values())await o.then(d=>d?.dispose());t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,o,d,y,k){this.addTunnelToMap(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:d,privacy:y,protocol:k,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(b(t)||R(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const d=this.getTunnelFromMap(t,o);if(d)return++d.refcount,d.value}openTunnel(t,o,d,y,k,v=!1,i,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${d} on local port ${k}.`),!t)return;if(o||(o="localhost"),y||(y=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(d)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(t,o,d,y,k,v,i,a);return r?r.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(o,d);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.makeTunnel(s);return(s.tunnelRemoteHost!==o||s.tunnelRemotePort!==d)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(w),w}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this._tunnels.get(t.tunnelRemoteHost);if(o){const d=o.get(t.tunnelRemotePort);d&&(d.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,d))}}}}async tryDisposeTunnel(t,o,d){if(d.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const y=d.value.then(async k=>{k&&(await k.dispose(!0),this._onTunnelClosed.fire({host:k.tunnelRemoteHost,port:k.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(o),y}}async closeTunnel(t,o){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const d=this._tunnels.get(t);if(d&&d.has(o)){const y=d.get(o);y.refcount=0,await this.tryDisposeTunnel(t,o,y)}}addTunnelToMap(t,o,d){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(o,{refcount:1,value:d})}async removeEmptyTunnelFromMap(t,o){const d=this._tunnels.get(t);d&&(await d.get(o)||d.delete(o),d.size===0&&this._tunnels.delete(t))}getTunnelFromMap(t,o){const d=[t];R(t)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):b(t)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const y=d.map(k=>this._tunnels.get(k));for(const k of y){const v=k?.get(o);if(v)return v}}canTunnel(t){return!!h(t)}createWithProvider(t,o,d,y,k,v,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${d} on local port ${y}.`);const a=d;this._factoryInProgress.add(a);const r=y===void 0?d:y,s={elevationRequired:k?this.isPortPrivileged(r):!1},w={remoteAddress:{host:o,port:d},localAddressPort:y,privacy:v,public:v?v!==P.Private:void 0,protocol:i},I=t.forwardPort(w,s);return I?(this.addTunnelToMap(o,d,I),I.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(a)})):this._factoryInProgress.delete(a),I}};e.AbstractTunnelService=p=je([Ve(0,F.ILogService),Ve(1,T.IConfigurationService)],p)}),define(Te[183],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var T;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Te[184],Pe([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(S){return S.scheme!==n.Schemas.file&&S.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=T;function D(S){if(S.folders.length)return S.folders.every(h=>T(h.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=D;function F(S){return D(S)?.scheme}e.getVirtualWorkspaceScheme=F;function A(S){return D(S)?.authority}e.getVirtualWorkspaceAuthority=A;function P(S){return D(S)!==void 0}e.isVirtualWorkspace=P}),define(Te[53],Pe([1,0,144,19,48,22,2,3,15]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function h(s){const w=s;return typeof w?.id=="string"&&A.URI.isUri(w.uri)}e.isSingleFolderWorkspaceIdentifier=h;function R(s){return typeof s?.id=="string"&&!h(s)&&!g(s)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(s,w){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,T.basename)(s)}:w?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const I=s;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}e.toWorkspaceIdentifier=b;function g(s){const w=s;return typeof w?.id=="string"&&A.URI.isUri(w.configPath)}e.isWorkspaceIdentifier=g;function _(s){const w=s;if(w?.uri)return{id:w.id,uri:A.URI.revive(w.uri)};const I=s;if(I?.configPath)return{id:I.id,configPath:A.URI.revive(I.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=_;var p;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function u(s){const w=s;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.isWorkspace=u;function t(s){const w=s;return!!(w&&typeof w=="object"&&A.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.isWorkspaceFolder=t;class o{constructor(w,I,c,l,m){this._id=w,this._transient=c,this._configuration=l,this._ignorePathCasing=m,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=I}update(w){this._id=w.id,this._configuration=w.configuration,this._transient=w.transient,this._ignorePathCasing=w._ignorePathCasing,this.folders=w.folders}get folders(){return this._folders}set folders(w){this._folders=w,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(w){this._configuration=w}getFolder(w){return w&&this._foldersMap.findSubstr(w)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const w of this.folders)this._foldersMap.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class d{constructor(w,I){this.raw=I,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,F.joinPath)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function y(s){return new d({uri:s,index:0,name:(0,F.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function k(s,w){return F.extUriBiasedIgnorePathCase.isEqualOrParent(s,w.untitledWorkspacesHome)}e.isUntitledWorkspace=k;function v(s){let w;return A.URI.isUri(s)?w=s:w=s.configuration,w?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=v,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function a(s,w){return!k(s,w)&&!v(s)}e.isSavedWorkspace=a;function r(s){return(typeof s=="string"?(0,T.extname)(s):(0,F.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Te[54],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const F=this._idPool++;return this._data.set(F,D),this.logDebugInfo(),F}get(D,F){return this._data.has(D)?this._data.get(D)[F]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){n.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=n,n.enableDebugLogging=!1}),define(Te[37],Pe([1,0,15,22,3]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class F{constructor(){this._systemSchemes=new Set(Object.keys(n.Schemas)),this._providerInfo=new Map,this.extUri=new T.ExtUri(P=>{const S=this._providerInfo.get(P.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(P,S){S===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,S)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=F,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Te[27],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Te[185],Pe([1,0,149,14,171,27]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=e.ExtHostLogService=class extends D.LogService{constructor(S,h,R){const b=R.remote.isRemote?"remoteexthost":S?"workerexthost":"exthost",g=R.remote.isRemote?(0,n.localize)(0,null):S?(0,n.localize)(1,null):(0,n.localize)(2,null);super(h.createLogger(b,{name:g}))}};e.ExtHostLogService=A=je([Ve(1,T.ILoggerService),Ve(2,F.IExtHostInitDataService)],A)}),define(Te[186],Pe([1,0,17]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(A,P,S){this._deferredPromises=new Map,this._id=A,this._shared=P,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(h=>(this._value=h,this)),this._storageListener=this._storage.onDidChangeStorage(h=>{h.shared===this._shared&&h.key===this._id&&(this._value=h.value)}),this._scheduler=new n.RunOnceScheduler(()=>{const h=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of h.values())R.complete()}catch(R){for(const b of h.values())b.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,P){let S=this._value[A];return typeof S>"u"&&(S=P),S}update(A,P){this._value[A]=P;const S=this._deferredPromises.get(A);if(S!==void 0)return S.p;const h=new n.DeferredPromise;return this._deferredPromises.set(A,h),this._scheduler.isScheduled()||this._scheduler.schedule(),h.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class D extends T{setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}constructor(A,P){super(A.identifier.value,!0,P),this._extension=A}}e.ExtensionGlobalMemento=D}),define(Te[187],Pe([1,0,5,2]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(A){this._notebooksAndEditors=A,this._onDidSaveNotebookDocument=new n.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new n.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(A,P,S,h){const b=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A)).acceptModelChanged(P.value,S,h);this._onDidChangeNotebookDocument.fire(b)}$acceptDirtyStateChanged(A,P){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A)).acceptDirty(P)}$acceptModelSaved(A){const P=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Te[18],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class T{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.ExtHostRpcService=T});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Te[188],Pe([1,0,24,5]),function(te,e,n,T){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class F{constructor(P,S){D.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=n.ExtensionIdentifier.toKey(P.identifier),Je(this,D,S,"f"),Le(this,D,"f").onDidChangePassword(h=>{h.extensionId===this._id&&this._onDidChange.fire({key:h.key})})}get(P){return Le(this,D,"f").get(this._id,P)}store(P,S){return Le(this,D,"f").store(this._id,P,S)}delete(P){return Le(this,D,"f").delete(this._id,P)}}e.ExtensionSecrets=F,D=new WeakMap}),define(Te[72],Pe([1,0,3,182,5,18]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var A;(function(S){function h(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:b.protocol}}S.fromApiTunnel=h;function R(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==T.TunnelPrivacyId.ConstantPrivate&&b.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}S.fromServiceTunnel=R})(A||(e.TunnelDtoConverter=A={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let P=e.ExtHostTunnelService=class{constructor(h){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(h){return h}async openTunnel(h,R){}async getTunnels(){return[]}async setTunnelFactory(h){return{dispose:()=>{}}}registerPortsAttributesProvider(h,R){return{dispose:()=>{}}}async $providePortAttributes(h,R,b,g,_){return[]}async $forwardPort(h,R){}async $closeTunnel(h){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.ExtHostTunnelService=P=je([Ve(0,F.IExtHostRpcService)],P)}),define(Te[55],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class T{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=T}),define(Te[189],Pe([1,0,25]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(S){let h=this.buffers.indexOf(S);return h<0&&(h=this.buffers.length,this.buffers.push(S)),h}}function D(P,S){if(S.serializeBuffersForPostMessage){const h=new T,b=JSON.stringify(P,(_,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:h.add(p)};if(ArrayBuffer.isView(p)){const u=F(p);if(u)return{$$vscode_array_buffer_reference$$:!0,index:h.add(p.buffer),view:{type:u,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),g=h.buffers.map(_=>{const p=new Uint8Array(_);return n.VSBuffer.wrap(p)});return{message:b,buffers:g}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=D;function F(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(P,S){const h=S.map(g=>{const _=new ArrayBuffer(g.byteLength);return new Uint8Array(_).set(g.buffer),_}),R=S.length?(g,_)=>{if(_&&typeof _=="object"&&_.$$vscode_array_buffer_reference$$){const p=_,{index:u}=p,t=h[u];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return _}:void 0;return{message:JSON.parse(P,R),arrayBuffers:h}}e.deserializeWebviewMessage=A}),define(Te[98],Pe([1,0,156,12,2,6,3,30,43,15,40,128,29]),function(te,e,n,T,D,F,A,P,S,h,R,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var _;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(_||(e.EditorPaneSelectionChangeReason=_={}));var p;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function u(ue){const le=ue;return!!le&&typeof le.getSelection=="function"&&!!le.onDidChangeSelection}e.isEditorPaneWithSelection=u;function t(ue,le,$){for(const O of $.visibleEditorPanes)if(O.group.id===le&&ue.matches(O.input))return O.getViewState()}e.findViewStateForEditor=t;function o(ue){if(l(ue))return!1;const le=ue;return D.URI.isUri(le?.resource)}e.isResourceEditorInput=o;function d(ue){if(l(ue))return!1;const le=ue;return le?.original!==void 0&&le.modified!==void 0}e.isResourceDiffEditorInput=d;function y(ue){if(l(ue)||d(ue))return!1;const le=ue;return le?.primary!==void 0&&le.secondary!==void 0}e.isResourceSideBySideEditorInput=y;function k(ue){if(l(ue))return!1;const le=ue;return le?le.resource===void 0||le.resource.scheme===h.Schemas.untitled||le.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=k;const v=/Untitled-\d+/;function i(ue){return ue.scheme===h.Schemas.untitled&&ue.path.length>1&&!v.test(ue.path)}e.isUntitledWithAssociatedResource=i;function a(ue){if(l(ue))return!1;const le=ue;return D.URI.isUri(le?.base?.resource)&&D.URI.isUri(le?.input1?.resource)&&D.URI.isUri(le?.input2?.resource)&&D.URI.isUri(le?.result?.resource)}e.isResourceMergeEditorInput=a;var r;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class w{constructor(){this.mapIdToSaveSource=new Map}registerSource(le,$){let O=this.mapIdToSaveSource.get(le);return O||(O={source:le,label:$},this.mapIdToSaveSource.set(le,O)),O.source}getSourceLabel(le){return this.mapIdToSaveSource.get(le)?.label??le}}e.SaveSourceRegistry=new w;var I;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors"})(I||(e.EditorInputCapabilities=I={}));class c extends F.Disposable{}e.AbstractEditorInput=c;function l(ue){return ue instanceof c}e.isEditorInput=l;function m(ue){const le=ue;return D.URI.isUri(le?.preferredResource)}function E(ue){const le=ue;return l(le?.primary)&&l(le?.secondary)}e.isSideBySideEditorInput=E;function f(ue){const le=ue;return l(le?.modified)&&l(le?.original)}e.isDiffEditorInput=f;function L(ue,le,$,O,X){return Ae(O,[(0,b.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const me={...$,limits:{size:Number.MAX_VALUE}};ue.openEditor(le,me)}}),(0,b.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>X.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:g.default.Warning})}e.createTooLargeFileError=L;function W(ue){return l(ue?.editor)}e.isEditorInputWithOptions=W;function J(ue){const le=ue;return W(ue)&&le?.group!==void 0}e.isEditorInputWithOptionsAndGroup=J;function q(ue){const le=ue;return typeof le?.groupId=="number"&&l(le.editor)}e.isEditorIdentifier=q;var U;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var B;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LOCKED=2]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=3]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=4]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=5]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=7]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=9]="EDITOR_PIN",ue[ue.EDITOR_STICKY=10]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=11]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(B||(e.GroupModelChangeKind=B={}));var G;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(G||(e.SideBySideEditor=G={}));class N{getOriginalUri(le,$){if(!le)return;if(a(le))return e.EditorResourceAccessor.getOriginalUri(le.result,$);if($?.supportSideBySide){const{primary:X,secondary:me}=this.getSideEditors(le);if(X&&me){if($?.supportSideBySide===G.BOTH)return{primary:this.getOriginalUri(X,{filterByScheme:$.filterByScheme}),secondary:this.getOriginalUri(me,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===G.ANY)return this.getOriginalUri(X,{filterByScheme:$.filterByScheme})??this.getOriginalUri(me,{filterByScheme:$.filterByScheme});le=$.supportSideBySide===G.PRIMARY?X:me}}if(d(le)||y(le)||a(le))return;const O=m(le)?le.preferredResource:le.resource;return!O||!$||!$.filterByScheme?O:this.filterUri(O,$.filterByScheme)}getSideEditors(le){return E(le)||y(le)?{primary:le.primary,secondary:le.secondary}:f(le)||d(le)?{primary:le.modified,secondary:le.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(le,$){if(!le)return;if(a(le))return e.EditorResourceAccessor.getCanonicalUri(le.result,$);if($?.supportSideBySide){const{primary:X,secondary:me}=this.getSideEditors(le);if(X&&me){if($?.supportSideBySide===G.BOTH)return{primary:this.getCanonicalUri(X,{filterByScheme:$.filterByScheme}),secondary:this.getCanonicalUri(me,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===G.ANY)return this.getCanonicalUri(X,{filterByScheme:$.filterByScheme})??this.getCanonicalUri(me,{filterByScheme:$.filterByScheme});le=$.supportSideBySide===G.PRIMARY?X:me}}if(d(le)||y(le)||a(le))return;const O=le.resource;return!O||!$||!$.filterByScheme?O:this.filterUri(O,$.filterByScheme)}filterUri(le,$){if(Array.isArray($)){if($.some(O=>le.scheme===O))return le}else if($===le.scheme)return le}}e.EditorResourceAccessor=new N;var H;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(H||(e.CloseDirection=H={}));class Q{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(le){const $=this.instantiationService=le.get(A.IInstantiationService);for(const[O,X]of this.editorSerializerConstructors)this.createEditorSerializer(O,X,$);this.editorSerializerConstructors.clear()}createEditorSerializer(le,$,O){const X=O.createInstance($);this.editorSerializerInstances.set(le,X)}registerFileEditorFactory(le){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=le}getFileEditorFactory(){return(0,T.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(le,$){if(this.editorSerializerConstructors.has(le)||this.editorSerializerInstances.has(le))throw new Error(`A editor serializer with type ID '${le}' was already registered.`);return this.instantiationService?this.createEditorSerializer(le,$,this.instantiationService):this.editorSerializerConstructors.set(le,$),(0,F.toDisposable)(()=>{this.editorSerializerConstructors.delete(le),this.editorSerializerInstances.delete(le)})}getEditorSerializer(le){return this.editorSerializerInstances.get(typeof le=="string"?le:le.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new Q);async function pe(ue,le,$){return!ue||!ue.length?[]:await Promise.all(ue.map(async O=>{const X=D.URI.revive(O.fileUri);if(!X){$.info("Cannot resolve the path because it is not valid.",O);return}if(!await le.canHandleResource(X)){$.info("Cannot resolve the path because it cannot be handled",O);return}let Ce=O.exists,ye=O.type;if(typeof Ce!="boolean"||typeof ye!="number")try{ye=(await le.stat(X)).isDirectory?S.FileType.Directory:S.FileType.Unknown,Ce=!0}catch(Ie){$.error(Ie),Ce=!1}if(!Ce&&O.openOnlyIfExists){$.info("Cannot resolve the path because it does not exist",O);return}if(ye===S.FileType.Directory){$.info("Cannot resolve the path because it is a directory",O);return}const Ee={...O.options,pinned:!0};return Ce?{resource:X,options:Ee}:{resource:X,options:Ee,forceUntitled:!0}}))}e.pathsToEditors=pe;var we;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(we||(e.EditorsOrder=we={}));function he(ue){const le=ue;if(!le)return!1;const $=le;if($.modified)return he($.modified);const O=le;return!!(O.contributionsState&&O.viewState&&Array.isArray(O.cursorState))}e.isTextEditorViewState=he;function de(ue){return(0,R.isErrorWithActions)(ue)}e.isEditorOpenError=de;function Ae(ue,le,$){const O=(0,R.createErrorWithActions)(ue,le);return O.forceMessage=$?.forceMessage,O.forceSeverity=$?.forceSeverity,O.allowDialog=$?.allowDialog,O}e.createEditorOpenError=Ae}),define(Te[190],Pe([1,0,5,157,3,6,28,30,16,64,23,85,181]),function(te,e,n,T,D,F,A,P,S,h,R,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",b.Codicon.window,(0,T.localize)(0,null));var _;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(_||(e.Extensions=_={}));var p;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.ViewContainerLocations=[0,1,2];function u(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=u;class t extends F.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new n.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new n.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,S.flatten)([...this.viewContainers.values()])}registerViewContainer(s,w,I){const c=this.get(s.id);if(c)return c;const l=s;return l.openCommandActionDescriptor=I?.doNotRegisterOpenCommand?void 0:l.openCommandActionDescriptor??{id:l.id},(0,A.getOrSet)(this.viewContainers,w,[]).push(l),I?.isDefault&&this.defaultViewContainers.push(l),this._onDidRegister.fire({viewContainer:l,viewContainerLocation:w}),l}deregisterViewContainer(s){for(const w of this.viewContainers.keys()){const I=this.viewContainers.get(w),c=I?.indexOf(s);if(c!==-1){I?.splice(c,1),I.length===0&&this.viewContainers.delete(w),this._onDidDeregister.fire({viewContainer:s,viewContainerLocation:w});return}}}get(s){return this.all.filter(w=>w.id===s)[0]}getViewContainers(s){return[...this.viewContainers.get(s)||[]]}getViewContainerLocation(s){return[...this.viewContainers.keys()].filter(w=>this.getViewContainers(w).filter(I=>I?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.defaultViewContainers.find(w=>this.getViewContainerLocation(w)===s)}}P.Registry.add(_.ViewContainersRegistry,new t);var o;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(o||(e.ViewContentGroups=o={}));function d(r,s){const w=r.group??o.More,I=s.group??o.More;return w!==I?w.localeCompare(I):(r.order??5)-(s.order??5)}class y extends F.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new n.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new n.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new n.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new n.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new h.SetMap}registerViews(s,w){this.registerViews2([{views:s,viewContainer:w}])}registerViews2(s){s.forEach(({views:w,viewContainer:I})=>this.addViews(w,I)),this._onViewsRegistered.fire(s)}deregisterViews(s,w){const I=this.removeViews(s,w);I.length&&this._onViewsDeregistered.fire({views:I,viewContainer:w})}moveViews(s,w){for(const I of this._views.keys())if(I!==w){const c=this.removeViews(s,I);c.length&&(this.addViews(c,w),this._onDidChangeContainer.fire({views:c,from:I,to:w}))}}getViews(s){return this._views.get(s)||[]}getView(s){for(const w of this._viewContainers){const I=(this._views.get(w)||[]).filter(c=>c.id===s)[0];if(I)return I}return null}getViewContainer(s){for(const w of this._viewContainers)if((this._views.get(w)||[]).filter(c=>c.id===s)[0])return w;return null}registerViewWelcomeContent(s,w){return this._viewWelcomeContents.add(s,w),this._onDidChangeViewWelcomeContent.fire(s),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(s,w),this._onDidChangeViewWelcomeContent.fire(s)})}registerViewWelcomeContent2(s,w){const I=new Map;for(const[c,l]of w)this._viewWelcomeContents.add(s,l),I.set(c,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(s,l),this._onDidChangeViewWelcomeContent.fire(s)}));return this._onDidChangeViewWelcomeContent.fire(s),I}getViewWelcomeContent(s){const w=[];return this._viewWelcomeContents.forEach(s,I=>w.push(I)),w.sort(d)}addViews(s,w){let I=this._views.get(w);I||(I=[],this._views.set(w,I),this._viewContainers.push(w));for(const c of s){if(this.getView(c.id)!==null)throw new Error((0,T.localize)(1,null,c.id));I.push(c)}}removeViews(s,w){const I=this._views.get(w);if(!I)return[];const c=[],l=[];for(const m of I)s.includes(m)?c.push(m):l.push(m);return c.length&&(l.length?this._views.set(w,l):(this._views.delete(w),this._viewContainers.splice(this._viewContainers.indexOf(w),1))),c}}P.Registry.add(_.ViewsRegistry,new y),e.IViewsService=(0,D.createDecorator)("viewsService"),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var k;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(k||(e.ViewVisibilityState=k={}));var v;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(v||(e.TreeItemCollapsibleState=v={}));class i{constructor(s,w){this.resolved=!1,this._hasResolve=!1,(0,R.mixin)(this,s),this._hasResolve=!!w,this.resolve=async I=>{if(w&&!this.resolved){const c=await w(I);c&&(this.tooltip=this.tooltip??c.tooltip,this.command=this.command??c.command)}I.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class a extends Error{constructor(s){super((0,T.localize)(2,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.NoTreeViewError=a}),define(Te[191],Pe([1,0,5,17,158]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class F{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new n.Emitter,this._onExit=new n.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,S,h,R){const b={command:P};if(S&&Object.keys(S).length>0&&(b.arguments=S),this.internalSend("request",b),typeof R=="number"){const g=setTimeout(()=>{clearTimeout(g);const _=this.pendingRequests.get(b.seq);if(_){this.pendingRequests.delete(b.seq);const p={type:"response",seq:0,request_seq:b.seq,success:!1,command:P,message:(0,D.localize)(0,null,R,P)};_(p)}},R)}return h&&this.pendingRequests.set(b.seq,h),b.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,S){return P.type!=="event"||S.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,T.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback?.(P);break;case"request":this.requestCallback?.(P);break;case"response":{const S=P,h=this.pendingRequests.get(S.request_seq);h&&(this.pendingRequests.delete(S.request_seq),h(S));break}}}}internalSend(P,S){S.type=P,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((S,h)=>P.set(h,S)),await(0,T.timeout)(500),P.forEach((S,h)=>{S({type:"response",seq:0,request_seq:h,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(h)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=F}),define(Te[192],Pe([1,0,159,31,3]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new T.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const F=g=>n.localize(51,null,g);e.debuggerDisabledMessage=F,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var A;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(A||(e.State=A={}));function P(g){switch(g){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var S;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var h;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(h||(e.DebugConfigurationProviderTriggerKind=h={}));var R;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.IDebugService=(0,D.createDecorator)("debugService");var b;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE"})(b||(e.BreakpointWidgetContext=b={}))}),define(Te[193],Pe([1,0,13,2,19,23,15,44,21,16]),function(te,e,n,T,D,F,A,P,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function b(c,l,m){return c.replace(R,function(E,f){return l&&f.length>0&&f[0]!=="_"?E:m&&m.hasOwnProperty(f)?m[f]:E})}e.formatPII=b;function g(c){const l={};for(const m of Object.keys(c))m.startsWith("!")||(l[m]=c[m]);return l}e.filterExceptionsFromTelemetry=g;function _(c){return c.configuration.request==="attach"&&!p(c)&&(!c.parentSession||_(c.parentSession))}e.isSessionAttach=_;function p(c){let l=c.configuration.type;if(l)return l==="vslsShare"&&(l=c.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(l,"extensionhost")||(0,n.equalsIgnoreCase)(l,"pwa-extensionhost")?c:c.parentSession?p(c.parentSession):void 0}e.getExtensionHostDebugSession=p;function u(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=u;function t(c,l,m){let E,f=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=L.exec(c);){const J=W.index+1,q=J+W[0].length;if(J<=l&&q>=m){E=W[0],f=J;break}}if(E){const J=/\w+/g;let q=null;for(;(q=J.exec(E))&&!(q.index+1+f+q[0].length>=m););q&&(E=E.substring(0,J.lastIndex))}return E?{start:f,end:f+E.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function o(c,l,m,E){if(c.evaluatableExpressionProvider.has(l)){const f=c.evaluatableExpressionProvider.ordered(l),L=(0,h.coalesce)(await Promise.all(f.map(async W=>{try{return await W.provideEvaluatableExpression(l,m,E??S.CancellationToken.None)}catch{return}})));if(L.length>0){let W=L[0].expression;const J=L[0].range;return W||(W=l.getLineContent(m.lineNumber).substring(J.startColumn-1,J.endColumn-1)),{range:J,matchingExpression:W}}}else{const f=l.getLineContent(m.lineNumber),{start:L,end:W}=t(f,m.column,m.column),J=f.substring(L-1,W);return{matchingExpression:J,range:new P.Range(m.lineNumber,L,m.lineNumber,L+J.length)}}return null}e.getEvaluatableExpressionAtPosition=o;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function y(c){return!!(c&&c.match(d))}e.isUri=y;function k(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(y(c.path))return T.URI.parse(c.path);if((0,D.isAbsolute)(c.path))return T.URI.file(c.path)}return c.path}function v(c){if(typeof c.path=="object"){const l=T.URI.revive(c.path);if(l)return l.scheme===A.Schemas.file?l.fsPath:l.toString()}return c.path}function i(c,l){const m=l?k:v,E=(0,F.deepClone)(c);return r(E,(f,L)=>{f&&L&&(L.path=m(L))}),E}e.convertToDAPaths=i;function a(c,l){const m=l?k:v,E=(0,F.deepClone)(c);return r(E,(f,L)=>{!f&&L&&(L.path=m(L))}),E}e.convertToVSCPaths=a;function r(c,l){switch(c.type){case"event":{const m=c;switch(m.event){case"output":l(!1,m.body.source);break;case"loadedSource":l(!1,m.body.source);break;case"breakpoint":l(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=c;switch(m.command){case"setBreakpoints":l(!0,m.arguments.source);break;case"breakpointLocations":l(!0,m.arguments.source);break;case"source":l(!0,m.arguments.source);break;case"gotoTargets":l(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(E=>l(!1,E));break;default:break}break}case"response":{const m=c;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(E=>l(!1,E.source));break;case"loadedSources":m.body.sources.forEach(E=>l(!1,E));break;case"scopes":m.body.scopes.forEach(E=>l(!1,E.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(E=>l(!1,E.source));break;case"setBreakpoints":m.body.breakpoints.forEach(E=>l(!1,E.source));break;case"disassemble":m.body?.instructions.forEach(f=>l(!1,f.location));break;default:break}break}}}function s(c){return c.filter(l=>!l.presentation?.hidden).sort((l,m)=>l.presentation?m.presentation?l.presentation.group?m.presentation.group?l.presentation.group!==m.presentation.group?l.presentation.group.localeCompare(m.presentation.group):w(l.presentation.order,m.presentation.order):-1:m.presentation.group?1:w(l.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.getVisibleAndSorted=s;function w(c,l){return typeof c!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:c-l}async function I(c,l){const m=c.getValue("debug.saveBeforeStart",{overrideIdentifier:l.activeTextEditorLanguageId});if(m!=="none"&&(await l.saveAll(),m==="allEditorsInActiveGroup")){const E=l.activeEditorPane;E&&E.input.resource?.scheme===A.Schemas.untitled&&await l.save({editor:E.input,groupId:E.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=I}),define(Te[73],Pe([1,0,25,36,86,66,15,19,20,31]),function(te,e,n,T,D,F,A,P,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(R||(e.CellKind=R={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.latex,F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.latex,F.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var b;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(b||(e.NotebookRunState=b={}));var g;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(g||(e.NotebookCellExecutionState=g={}));var _;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(_||(e.NotebookExecutionState=_={}));var p;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var u;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(u||(e.RendererMessagingSpec=u={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var o;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var d;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var y;(function(N){N.scheme=A.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],Q=new RegExp(`^[${H.join("")}]+`),pe=7;function we($,O){const X=O.toString(pe),Ce=`${X.length<H.length?H[X.length-1]:"z"}${X}s${(0,n.encodeBase64)(n.VSBuffer.fromString($.scheme),!0,!0)}`;return $.with({scheme:N.scheme,fragment:Ce})}N.generate=we;function he($){if($.scheme!==N.scheme)return;const O=$.fragment.indexOf("s");if(O<0)return;const X=parseInt($.fragment.substring(0,O).replace(Q,""),pe),me=(0,n.decodeBase64)($.fragment.substring(O+1)).toString();if(!isNaN(X))return{handle:X,notebook:$.with({scheme:me,fragment:null})}}N.parse=he;function de($,O){return $.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${O??""},${$.scheme!==A.Schemas.file?$.scheme:""}`})}N.generateCellOutputUri=de;function Ae($){if($.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const O=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($.fragment);if(!O)return;const X=O[1]&&O[1]!==""?O[1]:void 0,me=O[2];return{outputId:X,notebook:$.with({scheme:me||A.Schemas.file,fragment:null})}}N.parseCellOutputUri=Ae;function ue($,O,X){return N.generate($,O).with({scheme:X})}N.generateCellPropertyUri=ue;function le($,O){if($.scheme===O)return N.parse($.with({scheme:N.scheme}))}N.parseCellPropertyUri=le})(y||(e.CellUri=y={}));const k=N=>S.isWindows?N.replace(/\//g,"\\"):N;class v{constructor(H=[],Q=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=Q,this.order=[...new Set(H)].map(pe=>({pattern:pe,matches:T.parse(k(pe))}))}sort(H){const Q=new Map(D.Iterable.map(H,we=>[we,k(we)]));let pe=[];for(const{matches:we}of this.order)for(const[he,de]of Q)if(we(de)){pe.push(he),Q.delete(he);break}return Q.size&&(pe=pe.concat([...Q.keys()].sort((we,he)=>this.defaultOrder.indexOf(we)-this.defaultOrder.indexOf(he)))),pe}prioritize(H,Q){const pe=this.findIndex(H);if(pe===-1){this.order.unshift({pattern:H,matches:T.parse(k(H))});return}const we=new Set(Q.map(de=>this.findIndex(de,pe)));we.delete(-1);const he=Array.from(we).sort();this.order.splice(pe+1,0,...he.map(de=>this.order[de]));for(let de=he.length-1;de>=0;de--)this.order.splice(he[de],1)}toArray(){return this.order.map(H=>H.pattern)}findIndex(H,Q=this.order.length){const pe=k(H);for(let we=0;we<Q;we++)if(this.order[we].matches(pe))return we;return-1}}e.MimeTypeDisplayOrder=v;function i(N,H,Q,pe=(we,he)=>we===he){const we=[];function he(ue,le,$){if(le===0&&$.length===0)return;const O=we[we.length-1];O&&O.start+O.deleteCount===ue?(O.deleteCount+=le,O.toInsert.push(...$)):we.push({start:ue,deleteCount:le,toInsert:$})}let de=0,Ae=0;for(;;){if(de===N.length){he(de,0,H.slice(Ae));break}if(Ae===H.length){he(de,N.length-de,[]);break}const ue=N[de],le=H[Ae];if(pe(ue,le)){de+=1,Ae+=1;continue}Q(le)?(he(de,1,[]),de+=1):(he(de,0,[le]),Ae+=1)}return we}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new h.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(N){N.default="default",N.option="option"})(a||(e.NotebookEditorPriority=a={}));function r(N){const H=N;return!!((typeof H.include=="string"||T.isRelativePattern(H.include))&&(typeof H.exclude=="string"||T.isRelativePattern(H.exclude)))}e.isDocumentExcludePattern=r;function s(N,H,Q){if(Array.isArray(N.viewType)&&N.viewType.indexOf(H)>=0||N.viewType===H)return!0;if(N.filenamePattern){const pe=r(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,we=r(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(T.match(pe,(0,P.basename)(Q.fsPath).toLowerCase()))return!(we&&T.match(we,(0,P.basename)(Q.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",codeActionsOnSave:"notebook.experimental.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var w;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class I{static create(H){return`${I._prefix}${H}`}static parse(H){if(H.startsWith(I._prefix))return H.substring(I._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=I,I._prefix="notebook/";function c(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.isTextStreamMime=c;const l=new TextDecoder;function m(N){const H=[];let Q=!1;for(const pe of N)(H.length===0||Q)&&(H.push(pe),Q=!0);return W(H),G(n.VSBuffer.concat(H.map(pe=>n.VSBuffer.wrap(pe))))}e.compressOutputItemStreams=m;const E=`${String.fromCharCode(27)}[A`,f=E.split("").map(N=>N.charCodeAt(0)),L=10;function W(N){N.forEach((H,Q)=>{if(Q===0||H.length<E.length)return;const pe=N[Q-1],we=H.subarray(0,E.length);if(we[0]===f[0]&&we[1]===f[1]&&we[2]===f[2]){const he=pe.lastIndexOf(L);if(he===-1)return;N[Q-1]=pe.subarray(0,he),N[Q]=H.subarray(E.length)}})}function J(N){let H=N;do N=H,H=N.replace(/[^\n]\x08/gm,"");while(H.length<N.length);return N}function q(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const H=N.match(/^(.*)\r+/m)[1];let Q=N.match(/\r+(.*)$/m)[1];Q=Q+H.slice(Q.length,H.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return N}const U="\b".charCodeAt(0),B="\r".charCodeAt(0);function G(N){return!N.buffer.includes(U)&&!N.buffer.includes(B)?N:n.VSBuffer.fromString(q(J(l.decode(N.buffer))))}}),define(Te[194],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Te[45],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(F){F.Delimiter="\0"})(n||(e.TestIdPathParts=n={}));var T;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class D{static fromExtHostTestItem(A,P,S=A.parent){if(A._isRoot)return new D([P]);const h=[A.id];for(let R=S;R&&R.id!==P;R=R.parent)h.push(R.id);return h.push(P),new D(h.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const P=A.indexOf("\0");return P===-1?A:A.slice(0,P)}static fromString(A){return new D(A.split("\0"))}static join(A,P){return new D([...A.path,P])}static joinToString(A,P){return A.toString()+"\0"+P}static parentId(A){const P=A.lastIndexOf("\0");return P===-1?void 0:A.slice(0,P)}static localId(A){const P=A.lastIndexOf("\0");return P===-1?A:A.slice(P+1)}static isChild(A,P){return P.startsWith(A)&&P[A.length]==="\0"}static compare(A,P){return A===P?0:D.isChild(A,P)?2:D.isChild(P,A)?3:1}constructor(A,P=A.length){if(this.path=A,this.viewEnd=P,A.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new D(this.path,A)}*idsToRoot(){for(let A=this.viewEnd;A>0;A--)yield new D(this.path,A)}compare(A){if(typeof A=="string")return D.compare(this.toString(),A);for(let P=0;P<A.viewEnd&&P<this.viewEnd;P++)if(A.path[P]!==this.path[P])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=D}),define(Te[56],Pe([1,0,2,44,45]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var F;(function(l){l[l.Unset=0]="Unset",l[l.Queued=1]="Queued",l[l.Running=2]="Running",l[l.Passed=3]="Passed",l[l.Failed=4]="Failed",l[l.Skipped=5]="Skipped",l[l.Errored=6]="Errored"})(F||(e.TestResultState=F={}));var A;(function(l){l[l.Run=1]="Run",l[l.Debug=2]="Debug",l[l.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var P;(function(l){l[l.Run=2]="Run",l[l.Debug=4]="Debug",l[l.Coverage=8]="Coverage",l[l.HasNonDefaultProfile=16]="HasNonDefaultProfile",l[l.HasConfigurable=32]="HasConfigurable",l[l.SupportsContinuousRun=64]="SupportsContinuousRun"})(P||(e.TestRunProfileBitset=P={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const S=l=>"runId"in l;e.isStartControllerTests=S;var h;(function(l){l.serialize=m=>({range:m.range.toJSON(),uri:m.uri.toJSON()}),l.deserialize=m=>({range:T.Range.lift(m.range),uri:n.URI.revive(m.uri)})})(h||(e.IRichLocation=h={}));var R;(function(l){l[l.Error=0]="Error",l[l.Output=1]="Output"})(R||(e.TestMessageType=R={}));var b;(function(l){l.serialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,location:m.location&&h.serialize(m.location)}),l.deserialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,location:m.location&&h.deserialize(m.location)})})(b||(e.ITestErrorMessage=b={}));const g=(l,m)=>`${m?"s":"e"}${l}`;e.getMarkId=g;var _;(function(l){l.serialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&h.serialize(m.location)}),l.deserialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&h.deserialize(m.location)})})(_||(e.ITestOutputMessage=_={}));var p;(function(l){l.serialize=m=>m.type===0?b.serialize(m):_.serialize(m),l.deserialize=m=>m.type===0?b.deserialize(m):_.deserialize(m)})(p||(e.ITestMessage=p={}));var u;(function(l){l.serializeWithoutMessages=m=>({state:m.state,duration:m.duration,messages:[]}),l.serialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(p.serialize)}),l.deserialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(p.deserialize)})})(u||(e.ITestTaskState=u={}));const t="\0",o=(l,m)=>l+t+m;e.namespaceTestTag=o;const d=l=>{const m=l.indexOf(t);return{ctrlId:l.slice(0,m),tagId:l.slice(m+1)}};e.denamespaceTestTag=d;var y;(function(l){l.serialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?.toJSON(),range:m.range?.toJSON()||null,description:m.description,error:m.error,sortText:m.sortText}),l.deserialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?n.URI.revive(m.uri):void 0,range:m.range?T.Range.lift(m.range):null,description:m.description,error:m.error,sortText:m.sortText})})(y||(e.ITestItem=y={}));var k;(function(l){l[l.NotExpandable=0]="NotExpandable",l[l.Expandable=1]="Expandable",l[l.BusyExpanding=2]="BusyExpanding",l[l.Expanded=3]="Expanded"})(k||(e.TestItemExpandState=k={}));var v;(function(l){l.serialize=m=>({expand:m.expand,item:y.serialize(m.item)}),l.deserialize=m=>({controllerId:D.TestId.root(m.item.extId),expand:m.expand,item:y.deserialize(m.item)})})(v||(e.InternalTestItem=v={}));var i;(function(l){l.serialize=m=>{let E;return m.item&&(E={},m.item.label!==void 0&&(E.label=m.item.label),m.item.tags!==void 0&&(E.tags=m.item.tags),m.item.busy!==void 0&&(E.busy=m.item.busy),m.item.uri!==void 0&&(E.uri=m.item.uri?.toJSON()),m.item.range!==void 0&&(E.range=m.item.range?.toJSON()),m.item.description!==void 0&&(E.description=m.item.description),m.item.error!==void 0&&(E.error=m.item.error),m.item.sortText!==void 0&&(E.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:E}},l.deserialize=m=>{let E;return m.item&&(E={},m.item.label!==void 0&&(E.label=m.item.label),m.item.tags!==void 0&&(E.tags=m.item.tags),m.item.busy!==void 0&&(E.busy=m.item.busy),m.item.range!==void 0&&(E.range=m.item.range?T.Range.lift(m.item.range):null),m.item.description!==void 0&&(E.description=m.item.description),m.item.error!==void 0&&(E.error=m.item.error),m.item.sortText!==void 0&&(E.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:E}}})(i||(e.ITestItemUpdate=i={}));const a=(l,m)=>{m.expand!==void 0&&(l.expand=m.expand),m.item!==void 0&&(l.item=l.item?Object.assign(l.item,m.item):m.item)};e.applyTestItemUpdate=a;var r;(function(l){l.serializeWithoutMessages=m=>({...v.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(u.serializeWithoutMessages),retired:m.retired}),l.serialize=m=>({...v.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(u.serialize),retired:m.retired}),l.deserialize=m=>({...v.deserialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(u.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var s;(function(l){l[l.Function=0]="Function",l[l.Statement=1]="Statement"})(s||(e.DetailType=s={}));var w;(function(l){l[l.Add=0]="Add",l[l.Update=1]="Update",l[l.DocumentSynced=2]="DocumentSynced",l[l.Remove=3]="Remove",l[l.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",l[l.Retire=5]="Retire",l[l.AddTag=6]="AddTag",l[l.RemoveTag=7]="RemoveTag"})(w||(e.TestDiffOpType=w={}));var I;(function(l){l.deserialize=m=>m.op===0?{op:m.op,item:v.deserialize(m.item)}:m.op===1?{op:m.op,item:i.deserialize(m.item)}:m.op===2?{op:m.op,uri:n.URI.revive(m.uri),docv:m.docv}:m,l.serialize=m=>m.op===0?{op:m.op,item:v.serialize(m.item)}:m.op===1?{op:m.op,item:i.serialize(m.item)}:m})(I||(e.TestsDiffOp=I={}));class c{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(m){const E=this.createChangeCollector();for(const f of m)switch(f.op){case 0:this.add(v.deserialize(f.item),E);break;case 1:this.update(i.deserialize(f.item),E);break;case 3:this.remove(f.itemId,E);break;case 5:this.retireTest(f.itemId);break;case 4:this.updatePendingRoots(f.amount);break;case 6:this._tags.set(f.tag.id,f.tag);break;case 7:this._tags.delete(f.id);break}E.complete?.()}add(m,E){const f=D.TestId.parentId(m.item.extId)?.toString();let L;if(!f)L=this.createItem(m),this.roots.add(L),this.items.set(m.item.extId,L);else if(this.items.has(f)){const W=this.items.get(f);W.children.add(m.item.extId),L=this.createItem(m,W),this.items.set(m.item.extId,L)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(m)}`);return}return E.add?.(L),m.expand===2&&this.busyControllerCount++,L}update(m,E){const f=this.items.get(m.extId);if(f)return m.expand!==void 0&&(f.expand===2&&this.busyControllerCount--,m.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(f,m),E.update?.(f),f}remove(m,E){const f=this.items.get(m);if(!f)return;const L=D.TestId.parentId(f.item.extId)?.toString();L?this.items.get(L).children.delete(f.item.extId):this.roots.delete(f);const W=[[m]];for(;W.length;)for(const J of W.pop()){const q=this.items.get(J);q&&(W.push(q.children),this.items.delete(J),E.remove?.(q,q!==f),q.expand===2&&this.busyControllerCount--)}}retireTest(m){}updatePendingRoots(m){this.pendingRootCount+=m}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=c}),define(Te[74],Pe([1,0,17,5,6,49,56,45]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(S||(e.TestItemEventOp=S={}));const h=(d,y)=>d===y,b=Object.entries({range:(d,y)=>d===y?!0:!d||!y?!1:d.equalsRange(y),busy:h,label:h,description:h,error:h,sortText:h,tags:(d,y)=>!(d.length!==y.length||d.some(k=>!y.includes(k)))}),g=(d,y)=>{let k;for(const[v,i]of b)i(d[v],y[v])||(k?k[v]=y[v]:k={[v]:y[v]});return k};class _ extends D.Disposable{get root(){return this.options.root}constructor(y){super(),this.options=y,this.debounceSendDiff=this._register(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new T.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(y){this._resolveHandler=y;for(const k of this.tree.values())this.updateExpandability(k)}get resolveHandler(){return this._resolveHandler}collectDiff(){const y=this.diff;return this.diff=[],y}pushDiff(y){switch(y.op){case 2:{for(const k of this.diff)if(k.op===2&&k.uri===y.uri){k.docv=y.docv;return}break}case 1:{const k=this.diff[this.diff.length-1];if(k){if(k.op===1&&k.item.extId===y.item.extId){(0,A.applyTestItemUpdate)(k.item,y.item);return}if(k.op===0&&k.item.item.extId===y.item.extId){(0,A.applyTestItemUpdate)(k.item,y.item);return}}break}}this.diff.push(y),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(y,k){const v=this.tree.get(y);if(v){if((v.expandLevels===void 0||k>v.expandLevels)&&(v.expandLevels=k),v.expand===1){const i=this.resolveChildren(v);return i.isOpen()?this.expandChildren(v,k-1):i.wait().then(()=>this.expandChildren(v,k-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.expandChildren(v,k-1)):this.expandChildren(v,k-1)}}dispose(){for(const y of this.tree.values())this.options.getApiFor(y.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(y,k){switch(k.op){case 3:this.removeItem(P.TestId.joinToString(y.fullId,k.id));break;case 0:this.upsertItem(k.item,y);break;case 5:for(const v of k.ops)this.onTestItemEvent(y,v);break;case 1:this.diffTagRefs(k.new,k.old,y.fullId.toString());break;case 2:this.updateExpandability(y);break;case 4:this.pushDiff({op:1,item:{extId:y.fullId.toString(),item:k.update}});break;case 6:this.documentSynced(y.actual.uri);break;default:(0,F.assertNever)(k)}}documentSynced(y){y&&this.pushDiff({op:2,uri:y,docv:this.options.getDocumentVersion(y)})}upsertItem(y,k){const v=P.TestId.fromExtHostTestItem(y,this.root.id,k?.actual),i=this.options.getApiFor(y);i.parent&&i.parent!==k?.actual&&this.options.getChildren(i.parent).delete(y.id);let a=this.tree.get(v.toString());if(!a){a={fullId:v,actual:y,expandLevels:k?.expandLevels?k.expandLevels-1:void 0,expand:0},y.tags.forEach(this.incrementTagRefs,this),this.tree.set(a.fullId.toString(),a),this.setItemParent(y,k),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:a.expand,item:this.options.toITestItem(y)}}),this.connectItemAndChildren(y,a,k);return}if(a.actual===y){this.connectItem(y,a,k);return}if(a.actual.uri?.toString()!==y.uri?.toString())return this.removeItem(v.toString()),this.upsertItem(y,k);const r=this.options.getChildren(a.actual),s=a.actual,w=g(this.options.toITestItem(s),this.options.toITestItem(y));this.options.getApiFor(s).listener=void 0,a.actual=y,a.expand=0,w&&(w.hasOwnProperty("tags")&&(this.diffTagRefs(y.tags,s.tags,v.toString()),delete w.tags),this.onTestItemEvent(a,{op:4,update:w})),this.connectItemAndChildren(y,a,k);for(const[I,c]of r)this.options.getChildren(y).get(c.id)||this.removeItem(P.TestId.joinToString(v,c.id));this.documentSynced(a.actual.uri)}diffTagRefs(y,k,v){const i=new Set(k.map(a=>a.id));for(const a of y)i.delete(a.id)||this.incrementTagRefs(a);this.pushDiff({op:1,item:{extId:v,item:{tags:y.map(a=>(0,A.namespaceTestTag)(this.options.controllerId,a.id))}}}),i.forEach(this.decrementTagRefs,this)}incrementTagRefs(y){const k=this.tags.get(y.id);k?k.refCount++:(this.tags.set(y.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.namespaceTestTag)(this.options.controllerId,y.id)}}))}decrementTagRefs(y){const k=this.tags.get(y);k&&!--k.refCount&&(this.tags.delete(y),this.pushDiff({op:7,id:(0,A.namespaceTestTag)(this.options.controllerId,y)}))}setItemParent(y,k){this.options.getApiFor(y).parent=k&&k.actual!==this.root?k.actual:void 0}connectItem(y,k,v){this.setItemParent(y,v);const i=this.options.getApiFor(y);i.parent=v?.actual,i.listener=a=>this.onTestItemEvent(k,a),this.updateExpandability(k)}connectItemAndChildren(y,k,v){this.connectItem(y,k,v);for(const[i,a]of this.options.getChildren(y))this.upsertItem(a,k)}updateExpandability(y){let k;this._resolveHandler?y.resolveBarrier?k=y.resolveBarrier.isOpen()?3:2:k=y.actual.canResolveChildren?1:0:k=0,k!==y.expand&&(y.expand=k,this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:k}}),k===1&&y.expandLevels!==void 0&&this.resolveChildren(y))}expandChildren(y,k){if(k<0)return;const v=[];for(const[i,a]of this.options.getChildren(y.actual)){const r=this.expand(P.TestId.joinToString(y.fullId,a.id),k);(0,n.isThenable)(r)&&v.push(r)}if(v.length)return Promise.all(v).then(()=>{})}resolveChildren(y){if(y.resolveBarrier)return y.resolveBarrier;if(!this._resolveHandler){const a=new n.Barrier;return a.open(),a}y.expand=2,this.pushExpandStateUpdate(y);const k=y.resolveBarrier=new n.Barrier,v=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,a)};let i;try{i=this._resolveHandler(y.actual===this.root?void 0:y.actual)}catch(a){v(a)}return(0,n.isThenable)(i)?i.catch(v).then(()=>{k.open(),this.updateExpandability(y)}):(k.open(),this.updateExpandability(y)),y.resolveBarrier}pushExpandStateUpdate(y){this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:y.expand}})}removeItem(y){const k=this.tree.get(y);if(!k)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:y});const v=[k];for(;v.length;){const i=v.pop();if(i){this.options.getApiFor(i.actual).listener=void 0;for(const a of i.actual.tags)this.decrementTagRefs(a.id);this.tree.delete(i.fullId.toString());for(const[a,r]of this.options.getChildren(i.actual))v.push(this.tree.get(P.TestId.joinToString(i.fullId,r.id)))}}}flushDiff(){const y=this.collectDiff();y.length&&this.diffOpEmitter.fire(y)}}e.TestItemCollection=_;class p extends Error{constructor(y){super(`Attempted to insert a duplicate test item ID ${y}`)}}e.DuplicateTestItemError=p;class u extends Error{constructor(y){super(`TestItem with ID "${y}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=u;class t extends Error{constructor(y,k,v){super(`TestItem with ID "${y}" is from controller "${k}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=t;const o=(d,y,k)=>{let v=new Map;return{get size(){return v.size},forEach(i,a){for(const r of v.values())i.call(a,r,this)},[Symbol.iterator](){return v.entries()},replace(i){const a=new Map,r=new Set(v.keys()),s={op:5,ops:[]};for(const w of i){if(!(w instanceof k))throw new u(w.id);const I=y(w).controllerId;if(I!==d.controllerId)throw new t(w.id,I,d.controllerId);if(a.has(w.id))throw new p(w.id);a.set(w.id,w),r.delete(w.id),s.ops.push({op:0,item:w})}for(const w of r.keys())s.ops.push({op:3,id:w});d.listener?.(s),v=a},add(i){if(!(i instanceof k))throw new u(i.id);v.set(i.id,i),d.listener?.({op:0,item:i})},delete(i){v.delete(i)&&d.listener?.({op:3,id:i})},get(i){return v.get(i)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=o}),define(Te[99],Pe([1,0,74]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,D=(A,P)=>{const S={controllerId:P};return T.set(A,S),S};e.createPrivateApiFor=D;const F=A=>{const P=T.get(A);if(!P)throw new n.InvalidTestItemError(A?.id||"<unknown>");return P};e.getPrivateApiFor=F}),define(Te[75],Pe([1,0,15,2]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(P,S){return P.scheme===n.Schemas.http||P.scheme===n.Schemas.https?P:(S&&S.authority&&S.isRemote&&P.scheme===n.Schemas.file&&(P=T.URI.from({scheme:n.Schemas.vscodeRemote,authority:S.authority,path:P.path})),T.URI.from({scheme:n.Schemas.https,authority:`${P.scheme}+${F(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=D;function F(P){return P.replace(/./g,S=>{const h=S.charCodeAt(0);return h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57?S:"-"+h.toString(16).padStart(4,"0")})}function A(P){return P.replace(/-([0-9a-f]{4})/g,(S,h)=>String.fromCharCode(parseInt(h,16)))}e.decodeAuthority=A}),define(Te[195],Pe([1,0,5,6,75]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class F{constructor(P,S,h){this._proxy=P,this._editors=S,this._remoteInfo=h,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const R=S.getVisibleTextEditors();for(const b of this._insets.values())R.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,S,h,R,b){let g;for(const y of this._editors.getVisibleTextEditors(!0))if(y.value===P){g=y;break}if(!g)throw new Error("not a visible editor");const _=this,p=this._handlePool++,u=new n.Emitter,t=new n.Emitter,o=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(y){return(0,D.asWebviewUri)(y,_._remoteInfo)}get cspSource(){return D.webviewGenericCspSource}set options(y){this._options=y,_._proxy.$setOptions(p,y)}get options(){return this._options}set html(y){this._html=y,_._proxy.$setHtml(p,y)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(y){return _._proxy.$postMessage(p,y)}},d=new class{constructor(){this.editor=P,this.line=S,this.height=h,this.webview=o,this.onDidDispose=t.event}dispose(){_._insets.has(p)&&(_._insets.delete(p),_._proxy.$disposeEditorInset(p),t.fire(),t.dispose(),u.dispose())}};return this._proxy.$createEditorInset(p,g.id,g.value.document.uri,S+1,h,R||{},b.identifier,b.extensionLocation),this._insets.set(p,{editor:P,inset:d,onDidReceiveMessage:u}),d}$onDidDispose(P){const S=this._insets.get(P);S&&S.inset.dispose()}$onDidReceiveMessage(P,S){this._insets.get(P)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=F}),define(Te[196],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var T;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class D extends Error{constructor(A,P){super(P),this.variable=A}}e.VariableError=D}),define(Te[197],Pe([1,0,19,51,12,23,20,89,162,196,13]),function(te,e,n,T,D,F,A,P,S,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class b{constructor(_,p,u,t){this._contributedVariables=new Map,this._context=_,this._labelService=p,this._userHomePromise=u,t&&(this._envVariablesPromise=t.then(o=>this.prepareEnv(o)))}prepareEnv(_){if(A.isWindows){const p=Object.create(null);return Object.keys(_).forEach(u=>{p[u.toLowerCase()]=_[u]}),p}return _}resolveWithEnvironment(_,p,u){return this.recursiveResolve({env:this.prepareEnv(_),userHome:void 0},p?p.uri:void 0,u)}async resolveAsync(_,p){const u={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(u,_?_.uri:void 0,p)}async resolveAnyBase(_,p,u,t){const o=F.deepClone(p);A.isWindows&&o.windows?Object.keys(o.windows).forEach(y=>o[y]=o.windows[y]):A.isMacintosh&&o.osx?Object.keys(o.osx).forEach(y=>o[y]=o.osx[y]):A.isLinux&&o.linux&&Object.keys(o.linux).forEach(y=>o[y]=o.linux[y]),delete o.windows,delete o.osx,delete o.linux;const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,_?_.uri:void 0,o,u,t)}async resolveAnyAsync(_,p,u){return this.resolveAnyBase(_,p,u)}async resolveAnyMap(_,p,u){const t=new Map;return{newConfig:await this.resolveAnyBase(_,p,u,t),resolvedVariables:t}}resolveWithInteractionReplace(_,p,u,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,p,u,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,p){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,p)}async recursiveResolve(_,p,u,t,o){if(D.isString(u))return this.resolveString(_,p,u,t,o);if(Array.isArray(u))return Promise.all(u.map(d=>this.recursiveResolve(_,p,d,t,o)));if(D.isObject(u)){const d=Object.create(null),y=await Promise.all(Object.keys(u).map(async k=>[await this.resolveString(_,p,k,t,o),await this.recursiveResolve(_,p,u[k],t,o)]));for(const[k,v]of y)d[k]=v;return d}return u}resolveString(_,p,u,t,o){return(0,R.replaceAsync)(u,b.VARIABLE_REGEXP,async(d,y)=>{if(y.includes(b.VARIABLE_LHS))return d;let k=await this.evaluateSingleVariable(_,d,y,p,t);return o?.set(y,k),k!==d&&D.isString(k)&&k.match(b.VARIABLE_REGEXP)&&(k=await this.resolveString(_,p,k,t,o)),k})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}async evaluateSingleVariable(_,p,u,t,o){let d;const y=u.split(":");y.length>1&&(u=y[0],d=y[1]);const k=a=>{const r=this._context.getFilePath();if(r)return(0,P.normalizeDriveLetter)(r);throw new h.VariableError(a,(0,S.localize)(0,null,p))},v=a=>{const r=k(a);if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return(0,P.normalizeDriveLetter)(s)}throw new h.VariableError(a,(0,S.localize)(1,null,p,n.basename(r)))},i=a=>{if(d){const r=this._context.getFolderUri(d);if(r)return r;throw new h.VariableError(a,(0,S.localize)(2,null,p,d))}if(t)return t;throw this._context.getWorkspaceFolderCount()>1?new h.VariableError(a,(0,S.localize)(3,null,p)):new h.VariableError(a,(0,S.localize)(4,null,p))};switch(u){case"env":if(d){if(_.env){const a=_.env[A.isWindows?d.toLowerCase():d];if(D.isString(a))return a}return""}throw new h.VariableError(h.VariableKind.Env,(0,S.localize)(5,null,p));case"config":if(d){const a=this._context.getConfigurationValue(t,d);if(D.isUndefinedOrNull(a))throw new h.VariableError(h.VariableKind.Config,(0,S.localize)(6,null,p,d));if(D.isObject(a))throw new h.VariableError(h.VariableKind.Config,(0,S.localize)(7,null,p,d));return a}throw new h.VariableError(h.VariableKind.Config,(0,S.localize)(8,null,p));case"command":return this.resolveFromMap(h.VariableKind.Command,p,d,o,"command");case"input":return this.resolveFromMap(h.VariableKind.Input,p,d,o,"input");case"extensionInstallFolder":if(d){const a=await this._context.getExtension(d);if(!a)throw new h.VariableError(h.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,p,d));return this.fsPath(a.extensionLocation)}throw new h.VariableError(h.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,p));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(i(h.VariableKind.WorkspaceFolder)));case"cwd":return t||d?(0,P.normalizeDriveLetter)(this.fsPath(i(h.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(n.basename(this.fsPath(i(h.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(_.userHome)return _.userHome;throw new h.VariableError(h.VariableKind.UserHome,(0,S.localize)(11,null,p))}case"lineNumber":{const a=this._context.getLineNumber();if(a)return a;throw new h.VariableError(h.VariableKind.LineNumber,(0,S.localize)(12,null,p))}case"selectedText":{const a=this._context.getSelectedText();if(a)return a;throw new h.VariableError(h.VariableKind.SelectedText,(0,S.localize)(13,null,p))}case"file":return k(h.VariableKind.File);case"fileWorkspaceFolder":return v(h.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||d?n.relative(this.fsPath(i(h.VariableKind.RelativeFile)),k(h.VariableKind.RelativeFile)):k(h.VariableKind.RelativeFile);case"relativeFileDirname":{const a=n.dirname(k(h.VariableKind.RelativeFileDirname));if(t||d){const r=n.relative(this.fsPath(i(h.VariableKind.RelativeFileDirname)),a);return r.length===0?".":r}return a}case"fileDirname":return n.dirname(k(h.VariableKind.FileDirname));case"fileExtname":return n.extname(k(h.VariableKind.FileExtname));case"fileBasename":return n.basename(k(h.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=n.basename(k(h.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-n.extname(a).length)}case"fileDirnameBasename":return n.basename(n.dirname(k(h.VariableKind.FileDirnameBasename)));case"execPath":{const a=this._context.getExecPath();return a||p}case"execInstallFolder":{const a=this._context.getAppRoot();return a||p}case"pathSeparator":return n.sep;default:try{const a=d?`${u}:${d}`:u;return this.resolveFromMap(h.VariableKind.Unknown,p,a,o,void 0)}catch{return p}}}}resolveFromMap(_,p,u,t,o){if(u&&t){const d=o===void 0?t[u]:t[o+":"+u];if(typeof d=="string")return d;throw new h.VariableError(_,(0,S.localize)(14,null,p))}return p}}e.AbstractVariableResolverService=b,b.VARIABLE_LHS="${",b.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Te[100],Pe([1,0,3,98]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var D;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(D||(e.GroupDirection=D={}));var F;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var A;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var P;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(P||(e.GroupsArrangement=P={}));var S;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(S||(e.MergeGroupMode=S={}));function h(p){const u=p;return(0,T.isEditorInput)(u?.editor)&&(0,T.isEditorInput)(u?.replacement)}e.isEditorReplacement=h;var R;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var b;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(b||(e.OpenEditorContext=b={}));function g(p){const u=p;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.isEditorGroup=g;function _(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=_}),define(Te[198],Pe([1,0,3,100]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(F){const A=F;return typeof F=="number"||(0,T.isEditorGroup)(A)}e.isPreferredGroup=D}),define(Te[199],Pe([1,0,3,168]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(T.IEnvironmentService)}),define(Te[101],Pe([1,0,24,5,19,6]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class P{static isHostExtension(t,o,d){if(o.getExtensionDescription(t))return!1;const y=d.getExtensionDescription(t);return y?!!((y.main||y.browser)&&y.api==="none"):!1}constructor(t,o){this._activationEventsReader=t,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=o,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new n.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this._extensionsMap.set(t.identifier,t),this._extensionsArr.push(t);const o=this._activationEventsReader.readActivationEvents(t);if(Array.isArray(o))for(let d of o)d==="onUri"&&(d=`onUri:${n.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(d)||this._activationMap.set(d,[]),this._activationMap.get(d).push(t)}}set(t){this._extensionDescriptions=t,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,o){this._extensionDescriptions=p(this._extensionDescriptions,o),this._extensionDescriptions=this._extensionDescriptions.concat(t);const d=P._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=p(this._extensionDescriptions,d.map(y=>y.identifier)),this._initialize(),this._onDidChange.fire(void 0),new A(d)}static _findLoopingExtensions(t){const o=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(i){this._nodesSet.has(i)||(this._nodesSet.add(i),this._nodesArr.push(i))}addArc(i,a){this.addNode(i),this.addNode(a),this._arcs.has(i)?this._arcs.get(i).push(a):this._arcs.set(i,[a])}getArcs(i){return this._arcs.has(i)?this._arcs.get(i):[]}hasOnlyGoodArcs(i,a){const r=o.getArcs(i);for(let s=0;s<r.length;s++)if(!a.has(r[s]))return!1;return!0}getNodes(){return this._nodesArr}},d=new n.ExtensionIdentifierMap;for(const i of t)if(d.set(i.identifier,i),i.extensionDependencies)for(const a of i.extensionDependencies)o.addArc(n.ExtensionIdentifier.toKey(i.identifier),n.ExtensionIdentifier.toKey(a));const y=new Set;o.getNodes().filter(i=>o.getArcs(i).length===0).forEach(i=>y.add(i));const k=o.getNodes().filter(i=>!y.has(i));let v;do{v=!1;for(let i=0;i<k.length;i++){const a=k[i];o.hasOnlyGoodArcs(a,y)&&(k.splice(i,1),i--,y.add(a),v=!0)}}while(v);return k.map(i=>d.get(i))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(t)}getExtensionDescriptionsForActivationEvent(t){const o=this._activationMap.get(t);return o?o.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const o=this._extensionsMap.get(t);return o||void 0}getExtensionDescriptionByUUID(t){for(const o of this._extensionsArr)if(o.uuid===t)return o}getExtensionDescriptionByIdOrUUID(t,o){return this.getExtensionDescription(t)??(o?this.getExtensionDescriptionByUUID(o):void 0)}}e.ExtensionDescriptionRegistry=P,e.basicActivationEventsReader={readActivationEvents:u=>u.activationEvents};class S{constructor(t){this._lock=new b,this._actual=new P(t,[])}async acquireLock(t){const o=await this._lock.acquire(t);return new h(this,o)}deltaExtensions(t,o,d){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(o,d)}containsActivationEvent(t){return this._actual.containsActivationEvent(t)}containsExtension(t){return this._actual.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this._actual.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getExtensionDescription(t){return this._actual.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this._actual.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,o){return this._actual.getExtensionDescriptionByIdOrUUID(t,o)}}e.LockableExtensionDescriptionRegistry=S;class h extends F.Disposable{constructor(t,o){super(),this._registry=t,this._isDisposed=!1,this._register(o)}isAcquiredFor(t){return!this._isDisposed&&this._registry===t}}e.ExtensionDescriptionRegistryLock=h;class R{constructor(t){this.name=t,this.promise=new Promise((o,d)=>{this._resolve=o})}resolve(t){this._resolve(t)}}class b{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(t){const o=new R(t);return this._pendingCustomers.push(o),this._advance(),o.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const t=this._pendingCustomers.shift();this._isLocked=!0;let o=!0;const d=setTimeout(()=>{o&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),y=()=>{o&&(clearTimeout(d),o=!1,this._isLocked=!1,this._advance())};t.resolve((0,F.toDisposable)(y))}}var g;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(g||(g={}));function _(u,t){const o=u.isBuiltin?0:u.isUnderDevelopment?2:1,d=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(o!==d)return o-d;const y=D.posix.basename(u.extensionLocation.path),k=D.posix.basename(t.extensionLocation.path);return y<k?-1:y>k?1:0}function p(u,t){const o=new n.ExtensionIdentifierSet(t);return u.filter(d=>!o.has(d.identifier))}}),define(Te[76],Pe([1,0,25]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(h){h[h.Desktop=1]="Desktop",h[h.Web=2]="Web"})(T||(e.UIKind=T={}));var D;(function(h){h[h.VersionMismatch=55]="VersionMismatch",h[h.UnexpectedError=81]="UnexpectedError"})(D||(e.ExtensionHostExitCode=D={}));var F;(function(h){h[h.Initialized=0]="Initialized",h[h.Ready=1]="Ready",h[h.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function A(h){const R=n.VSBuffer.alloc(1);switch(h){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=A;function P(h,R){if(h.byteLength!==1)return!1;switch(h.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=P;var S;(function(h){h.Start="START_NATIVE_LOG",h.End="END_NATIVE_LOG"})(S||(e.NativeLogMarkers=S={}))}),define(Te[57],Pe([1,0,3,5,14,27,76,50,52,23,2,6,152]),function(te,e,n,T,D,F,A,P,S,h,R,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let _=e.ExtHostTelemetry=class extends b.Disposable{constructor(o,d){super(),this.initData=o,this.loggerService=d,this._onDidChangeTelemetryEnabled=this._register(new T.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new T.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=R.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=d.createLogger(this.extHostTelemetryLogFile,{id:S.extensionTelemetryLogChannelId,name:(0,g.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(d.onDidChangeLogLevel(y=>{(0,D.isLogLevel)(y)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===D.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(o,d,y){const k=this.getTelemetryDetails(),v=new p(d,y,o,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(o),{isUsageEnabled:k.isUsageEnabled,isErrorsEnabled:k.isErrorsEnabled}),i=this._telemetryLoggers.get(o.identifier.value)??[];return this._telemetryLoggers.set(o.identifier.value,[...i,v]),v.apiTelemetryLogger}$initializeTelemetryLevel(o,d,y){this._level=o,this._telemetryIsSupported=d,this._productConfig=y??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(o){const d=Object.create(null);switch(d["common.extname"]=`${o.publisher}.${o.name}`,d["common.extversion"]=o.version,d["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,d["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,d["common.vscodeversion"]=this.initData.version,d["common.isnewappinstall"]=u(this.initData.telemetryInfo.firstSessionDate),d["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case A.UIKind.Web:d["common.uikind"]="web";break;case A.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,P.getRemoteName)((0,S.cleanRemoteAuthority)(this.initData.remote.authority)),d}$onDidChangeTelemetryLevel(o){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=o;const d=this.getTelemetryDetails();this._telemetryLoggers.forEach((y,k)=>{const v=y.filter(i=>!i.isDisposed);v.length===0?this._telemetryLoggers.delete(k):this._telemetryLoggers.set(k,v)}),this._telemetryLoggers.forEach(y=>{for(const k of y)k.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(o,d){const k=this._telemetryLoggers.get(o.value)?.filter(i=>!i.isDisposed);if(!k)return this._telemetryLoggers.delete(o.value),!1;let v=!1;for(const i of k)i.ignoreUnhandledExtHostErrors||(i.logError(d),v=!0);return v}};e.ExtHostTelemetry=_=je([Ve(0,F.IExtHostInitDataService),Ve(1,D.ILoggerService)],_);class p{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,d,y,k,v,i,a){this._extension=y,this._logger=k,this._inLoggingOnlyMode=v,this._commonProperties=i,this._onDidChangeEnableStates=new T.Emitter,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=d?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=d?.additionalCommonProperties,this._sender=o,this._telemetryEnablements={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(o,d){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:o,isErrorsEnabled:d},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(o){let d="properties"in o?o.properties??{}:o;return d=(0,S.cleanData)(d,[]),this._additionalCommonProperties&&(d=(0,h.mixin)(d,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(d=(0,h.mixin)(d,this._commonProperties)),"properties"in o?o.properties=d:o=d,o}logEvent(o,d){this._sender&&(this._extension.publisher==="vscode"?o=this._extension.name+"/"+o:o=this._extension.identifier.value+"/"+o,d=this.mixInCommonPropsAndCleanData(d||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(o,d),this._logger.trace(o,d))}logUsage(o,d){this._telemetryEnablements.isUsageEnabled&&this.logEvent(o,d)}logError(o,d){!this._telemetryEnablements.isErrorsEnabled||!this._sender||(typeof o=="string"?this.logEvent(o,d):this._sender.sendErrorData(o,d))}get apiTelemetryLogger(){if(!this._apiObject){const o=this,d={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return o._telemetryEnablements.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o._onDidChangeEnableStates.event.bind(o)};this._apiObject=Object.freeze(d)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let o=this._sender;this._sender=void 0,Promise.resolve(o.flush()).then(o=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=p;function u(t){const o=Date.now()-new Date(t).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.isNewAppInstall=u,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Te[26],Pe([1,0,5,2,178,97,24,3]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class S{constructor(v){this.dependency=v}}e.MissingExtensionDependency=S;var h;(function(k){k[k.EagerAutoStart=1]="EagerAutoStart",k[k.EagerManualStart=2]="EagerManualStart",k[k.Lazy=3]="Lazy"})(h||(e.ExtensionHostStartup=h={}));class R{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,addActivationEvents:F.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions),myToRemove:[],myToAdd:this._myExtensions}}set(v,i){const a=[],r=[],s=[],w=[],I=b(this._allExtensions),c=b(v),l=(W,J)=>W.extensionLocation.toString()===J.extensionLocation.toString()||W.isBuiltin===J.isBuiltin||W.isUserBuiltin===J.isUserBuiltin||W.isUnderDevelopment===J.isUnderDevelopment;for(const W of this._allExtensions){const J=c.get(W.identifier);if(!J){a.push(W.identifier),I.delete(W.identifier);continue}if(!l(W,J)){a.push(W.identifier),I.delete(W.identifier);continue}}for(const W of v){const J=I.get(W.identifier);if(!J){r.push(W);continue}if(!l(J,W)){a.push(J.identifier),I.delete(J.identifier);continue}}const m=new A.ExtensionIdentifierSet(this._myExtensions),E=new A.ExtensionIdentifierSet(i);for(const W of this._myExtensions)E.has(W)||s.push(W);for(const W of i)m.has(W)||w.push(W);const f=F.ImplicitActivationEvents.createActivationEventsMap(r),L={toRemove:a,toAdd:r,addActivationEvents:f,myToRemove:s,myToAdd:w};return this.delta(L),L}delta(v){const{toRemove:i,toAdd:a,myToRemove:r,myToAdd:s}=v,w=new A.ExtensionIdentifierSet(i),I=new A.ExtensionIdentifierSet(r);for(let c=0;c<this._allExtensions.length;c++)w.has(this._allExtensions[c].identifier)&&(this._allExtensions.splice(c,1),c--);for(let c=0;c<this._myExtensions.length;c++)I.has(this._myExtensions[c])&&(this._myExtensions.splice(c,1),c--);for(const c of a)this._allExtensions.push(c);for(const c of s)this._myExtensions.push(c)}containsExtension(v){for(const i of this._myExtensions)if(A.ExtensionIdentifier.equals(i,v))return!0;return!1}}e.ExtensionHostExtensions=R;function b(k){const v=new A.ExtensionIdentifierMap;for(const i of k)v.set(i.identifier,i);return v}function g(k,v){return k.enabledApiProposals?k.enabledApiProposals.includes(v):!1}e.isProposedApiEnabled=g;function _(k,v){if(!g(k,v))throw new Error(`Extension '${k.identifier.value}' CANNOT use API proposal: ${v}.
Its package.json#enabledApiProposals-property declares: ${k.enabledApiProposals?.join(", ")??"[]"} but NOT ${v}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${k.identifier.value}`)}e.checkProposedApiEnabled=_;class p{constructor(v,i,a,r){this.codeLoadingTime=v,this.activateCallTime=i,this.activateResolvedTime=a,this.activationReason=r}}e.ActivationTimes=p;class u{constructor(v,i){this.description=v,this.value=i}}e.ExtensionPointContribution=u;var t;(function(k){k[k.Normal=0]="Normal",k[k.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function o(k){return{type:k.isBuiltin?0:1,isBuiltin:k.isBuiltin||k.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(k.publisher,k.name),uuid:k.uuid},manifest:k,location:k.extensionLocation,targetPlatform:k.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function d(k,v){return{identifier:new A.ExtensionIdentifier((0,D.getExtensionId)(k.manifest.publisher,k.manifest.name)),isBuiltin:k.type===0,isUserBuiltin:k.type===1&&k.isBuiltin,isUnderDevelopment:!!v,extensionLocation:k.location,...k.manifest,uuid:k.identifier.uuid,targetPlatform:k.targetPlatform}}e.toExtensionDescription=d;class y{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.onWillStop=n.Event.None,this.extensions=[]}activateByEvent(v){return Promise.resolve(void 0)}activationEventIsDone(v){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(v,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=y}),define(Te[200],Pe([1,0,9,101,24,26,14,17]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(o,d,y,k){this.startup=o,this.codeLoadingTime=d,this.activateCallTime=y,this.activateResolvedTime=k}}e.ExtensionActivationTimes=S,S.NONE=new S(!1,-1,-1,-1);class h{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,d){return o===-1||d===-1?-1:d-o}build(){return new S(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=h;class R{constructor(o,d,y,k,v,i){this.activationFailed=o,this.activationFailedError=d,this.activationTimes=y,this.module=k,this.exports=v,this.subscriptions=i}}e.ActivatedExtension=R;class b extends R{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=b;class g extends R{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=g;class _ extends R{constructor(o){super(!0,o,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=e.ExtensionsActivator=class{constructor(o,d,y,k){this._logService=k,this._registry=o,this._globalRegistry=d,this._host=y,this._operations=new D.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[o,d]of this._operations)d.dispose()}async waitForActivatingExtensions(){const o=[];for(const[d,y]of this._operations)o.push(y.wait());await Promise.all(o)}isActivated(o){const d=this._operations.get(o);return!!(d&&d.value)}getActivatedExtension(o){const d=this._operations.get(o);if(!d||!d.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return d.value}async activateByEvent(o,d){if(this._alreadyActivatedEvents[o])return;const y=this._registry.getExtensionDescriptionsForActivationEvent(o);await this._activateExtensions(y.map(k=>({id:k.identifier,reason:{startup:d,extensionId:k.identifier,activationEvent:o}}))),this._alreadyActivatedEvents[o]=!0}activateById(o,d){const y=this._registry.getExtensionDescription(o);if(!y)throw new Error(`Extension '${o}' is not known`);return this._activateExtensions([{id:y.identifier,reason:d}])}async _activateExtensions(o){const d=o.filter(y=>!this.isActivated(y.id)).map(y=>this._handleActivationRequest(y));await Promise.all(d.map(y=>y.wait()))}_handleActivationRequest(o){if(this._operations.has(o.id))return this._operations.get(o.id);if(this._isHostExtension(o.id))return this._createAndSaveOperation(o,null,[],null);const d=this._registry.getExtensionDescription(o.id);if(!d){const v=new Error(`Cannot activate unknown extension '${o.id.value}'`),i=this._createAndSaveOperation(o,null,[],new _(v));return this._host.onExtensionActivationError(o.id,v,new F.MissingExtensionDependency(o.id.value)),i}const y=[],k=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const v of k){if(this._isResolvedExtension(v))continue;const i=this._operations.get(v);if(i){y.push(i);continue}if(this._isHostExtension(v)){y.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(v).identifier,reason:o.reason}));continue}const a=this._registry.getExtensionDescription(v);if(a){if(!a.main&&!a.browser)continue;y.push(this._handleActivationRequest({id:a.identifier,reason:o.reason}));continue}const r=d.displayName||d.identifier.value,s=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${v}'`),w=this._createAndSaveOperation(o,d.displayName,[],new _(s));return this._host.onExtensionActivationError(d.identifier,s,new F.MissingExtensionDependency(v)),w}return this._createAndSaveOperation(o,d.displayName,y,null)}_createAndSaveOperation(o,d,y,k){const v=new u(o.id,d,o.reason,y,k,this._host,this._logService);return this._operations.set(o.id,v),v}_isHostExtension(o){return T.ExtensionDescriptionRegistry.isHostExtension(o,this._registry,this._globalRegistry)}_isResolvedExtension(o){const d=this._globalRegistry.getExtensionDescription(o);return d?!d.main&&!d.browser:!1}};e.ExtensionsActivator=p=je([Ve(3,A.ILogService)],p);let u=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(o,d,y,k,v,i,a){this._id=o,this._displayName=d,this._reason=y,this._deps=k,this._value=v,this._host=i,this._logService=a,this._barrier=new P.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let o=0;o<this._deps.length;o++){const d=this._deps[o];if(d.value&&!d.value.activationFailed){this._deps.splice(o,1),o--;continue}if(d.value&&d.value.activationFailed){const y=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);y.detail=d.value.activationFailedError,this._value=new _(y),this._host.onExtensionActivationError(this._id,y,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(o=>o.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(o){const d=new Error;if(o&&o.name&&(d.name=o.name),o&&o.message?d.message=`Activating extension '${this._id.value}' failed: ${o.message}.`:d.message=`Activating extension '${this._id.value}' failed: ${o}.`,o&&o.stack&&(d.stack=o.stack),this._value=new _(d),this._isDisposed&&n.isCancellationError(o))return;this._host.onExtensionActivationError(this._id,d,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(o)}}};u=je([Ve(6,A.ILogService)],u)});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Te[7],Pe([1,0,16,9,88,28,66,13,12,2,35,43,96,73,26]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p){"use strict";var u,t,o,d,y,k,v,i,a,r,s,w,I,c,l,m,E,f,L,W,J,q,U,B,G;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function N(x){return Object.assign(x,{apply:function(){const se=arguments.length===1?[]:arguments[1];return Reflect.construct(x,se,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[se,...De]=arguments;return Reflect.construct(x,De,se.constructor)}}})}var H;(function(x){x[x.Top=0]="Top",x[x.Bottom=1]="Bottom"})(H||(e.TerminalOutputAnchor=H={}));var Q;(function(x){x[x.Command=0]="Command",x[x.Opener=1]="Opener"})(Q||(e.TerminalQuickFixType=Q={}));let pe=e.Disposable=i=class{static from(...M){let se=M;return new i(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}constructor(M){u.set(this,void 0),Je(this,u,M,"f")}dispose(){typeof Le(this,u,"f")=="function"&&(Le(this,u,"f").call(this),Je(this,u,void 0,"f"))}};u=new WeakMap,e.Disposable=pe=i=je([N],pe);let we=e.Position=a=class{static Min(...M){if(M.length===0)throw new TypeError;let se=M[0];for(let De=1;De<M.length;De++){const qe=M[De];qe.isBefore(se)&&(se=qe)}return se}static Max(...M){if(M.length===0)throw new TypeError;let se=M[0];for(let De=1;De<M.length;De++){const qe=M[De];qe.isAfter(se)&&(se=qe)}return se}static isPosition(M){if(!M)return!1;if(M instanceof a)return!0;const{line:se,character:De}=M;return typeof se=="number"&&typeof De=="number"}static of(M){if(M instanceof a)return M;if(this.isPosition(M))return new a(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(M,se){if(M<0)throw(0,T.illegalArgument)("line must be non-negative");if(se<0)throw(0,T.illegalArgument)("character must be non-negative");this._line=M,this._character=se}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,se=0){if(M===null||se===null)throw(0,T.illegalArgument)();let De;return typeof M>"u"?De=0:typeof M=="number"?De=M:(De=typeof M.lineDelta=="number"?M.lineDelta:0,se=typeof M.characterDelta=="number"?M.characterDelta:0),De===0&&se===0?this:new a(this.line+De,this.character+se)}with(M,se=this.character){if(M===null||se===null)throw(0,T.illegalArgument)();let De;return typeof M>"u"?De=this.line:typeof M=="number"?De=M:(De=typeof M.line=="number"?M.line:this.line,se=typeof M.character=="number"?M.character:this.character),De===this.line&&se===this.character?this:new a(De,se)}toJSON(){return{line:this.line,character:this.character}}};e.Position=we=a=je([N],we);let he=e.Range=r=class{static isRange(M){return M instanceof r?!0:M?we.isPosition(M.start)&&we.isPosition(M.end):!1}static of(M){if(M instanceof r)return M;if(this.isRange(M))return new r(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(M,se,De,qe){let Ze,ct;if(typeof M=="number"&&typeof se=="number"&&typeof De=="number"&&typeof qe=="number"?(Ze=new we(M,se),ct=new we(De,qe)):we.isPosition(M)&&we.isPosition(se)&&(Ze=we.of(M),ct=we.of(se)),!Ze||!ct)throw new Error("Invalid arguments");Ze.isBefore(ct)?(this._start=Ze,this._end=ct):(this._start=ct,this._end=Ze)}contains(M){return r.isRange(M)?this.contains(M.start)&&this.contains(M.end):we.isPosition(M)?!(we.of(M).isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const se=we.Max(M.start,this._start),De=we.Min(M.end,this._end);if(!se.isAfter(De))return new r(se,De)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const se=we.Min(M.start,this._start),De=we.Max(M.end,this.end);return new r(se,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,se=this.end){if(M===null||se===null)throw(0,T.illegalArgument)();let De;return M?we.isPosition(M)?De=M:(De=M.start||this.start,se=M.end||this.end):De=this.start,De.isEqual(this._start)&&se.isEqual(this.end)?this:new r(De,se)}toJSON(){return[this.start,this.end]}};e.Range=he=r=je([N],he);let de=e.Selection=s=class extends he{static isSelection(M){return M instanceof s?!0:M?he.isRange(M)&&we.isPosition(M.anchor)&&we.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(M,se,De,qe){let Ze,ct;if(typeof M=="number"&&typeof se=="number"&&typeof De=="number"&&typeof qe=="number"?(Ze=new we(M,se),ct=new we(De,qe)):we.isPosition(M)&&we.isPosition(se)&&(Ze=we.of(M),ct=we.of(se)),!Ze||!ct)throw new Error("Invalid arguments");super(Ze,ct),this._anchor=Ze,this._active=ct}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=de=s=je([N],de);class Ae{constructor(M,se,De){if(typeof M!="string"||M.length===0)throw(0,T.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,T.illegalArgument)("port");if(typeof De<"u"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z_\-]+$/.test(De)))throw(0,T.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(se),this.connectionToken=De}}e.ResolvedAuthority=Ae;class ue extends Error{static NotAvailable(M,se){return new ue(M,g.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(M){return new ue(M,g.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,se=g.RemoteAuthorityResolverErrorCode.Unknown,De){super(M),this._message=M,this._code=se,this._detail=De,Object.setPrototypeOf(this,ue.prototype)}}e.RemoteAuthorityResolverError=ue;var le;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(le||(e.EndOfLine=le={}));var $;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})($||(e.EnvironmentVariableMutatorType=$={}));let O=e.TextEdit=w=class{static isTextEdit(M){return M instanceof w?!0:M?he.isRange(M)&&typeof M.newText=="string":!1}static replace(M,se){return new w(M,se)}static insert(M,se){return w.replace(new he(M,M),se)}static delete(M){return w.replace(M,"")}static setEndOfLine(M){const se=new w(new he(new we(0,0),new we(0,0)),"");return se.newEol=M,se}get range(){return this._range}set range(M){if(M&&!he.isRange(M))throw(0,T.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,T.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,T.illegalArgument)("newEol");this._newEol=M}constructor(M,se){this._range=M,this._newText=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=O=w=je([N],O);let X=e.NotebookEdit=I=class{static isNotebookCellEdit(M){return M instanceof I?!0:M?Qt.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,se){return new I(M,se)}static insertCells(M,se){return new I(new Qt(M,M),se)}static deleteCells(M){return new I(M,[])}static updateCellMetadata(M,se){const De=new I(new Qt(M,M),[]);return De.newCellMetadata=se,De}static updateNotebookMetadata(M){const se=new I(new Qt(0,0),[]);return se.newNotebookMetadata=M,se}constructor(M,se){this.range=M,this.newCells=se}};e.NotebookEdit=X=I=je([N],X);class me{static isSnippetTextEdit(M){return M instanceof me?!0:M?he.isRange(M.range)&&Ee.isSnippetString(M.snippet):!1}static replace(M,se){return new me(M,se)}static insert(M,se){return me.replace(new he(M,M),se)}constructor(M,se){this.range=M,this.snippet=se}}e.SnippetTextEdit=me;var Ce;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(Ce||(e.FileEditType=Ce={}));let ye=e.WorkspaceEdit=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,se,De,qe){this._edits.push({_type:1,from:M,to:se,options:De,metadata:qe})}createFile(M,se,De){this._edits.push({_type:1,from:void 0,to:M,options:se,metadata:De})}deleteFile(M,se,De){this._edits.push({_type:1,from:M,to:void 0,options:se,metadata:De})}replaceNotebookMetadata(M,se,De){this._edits.push({_type:3,metadata:De,uri:M,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(M,se,De,qe){const Ze=se.start,ct=se.end;(Ze!==ct||De.length>0)&&this._edits.push({_type:5,uri:M,index:Ze,count:ct-Ze,cells:De,metadata:qe})}replaceNotebookCellMetadata(M,se,De,qe){this._edits.push({_type:3,metadata:qe,uri:M,edit:{editType:8,index:se,metadata:De}})}replace(M,se,De,qe){this._edits.push({_type:2,uri:M,edit:new O(se,De),metadata:qe})}insert(M,se,De,qe){this.replace(M,new he(se,se),De,qe)}delete(M,se,De){this.replace(M,se,"",De)}has(M){return this._edits.some(se=>se._type===2&&se.uri.toString()===M.toString())}set(M,se){if(se)for(const De of se){if(!De)continue;let qe,Ze;Array.isArray(De)?(qe=De[0],Ze=De[1]):qe=De,X.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(M,qe.range.start,qe.newCellMetadata,Ze):qe.newNotebookMetadata?this.replaceNotebookMetadata(M,qe.newNotebookMetadata,Ze):this.replaceNotebookCells(M,qe.range,qe.newCells,Ze):me.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:M,range:qe.range,edit:qe.snippet,metadata:Ze}):this._edits.push({_type:2,uri:M,edit:qe,metadata:Ze})}else{for(let De=0;De<this._edits.length;De++){const qe=this._edits[De];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===M.toString()&&(this._edits[De]=void 0);break}}(0,n.coalesceInPlace)(this._edits)}}get(M){const se=[];for(const De of this._edits)De._type===2&&De.uri.toString()===M.toString()&&se.push(De.edit);return se}entries(){const M=new F.ResourceMap;for(const se of this._edits)if(se._type===2){let De=M.get(se.uri);De||(De=[se.uri,[]],M.set(se.uri,De)),De[1].push(se.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=ye=je([N],ye);let Ee=e.SnippetString=c=class{static isSnippetString(M){return M instanceof c?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this._tabstop=1,this.value=M||""}appendText(M){return this.value+=c._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,se=this._tabstop++){if(typeof M=="function"){const De=new c;De._tabstop=this._tabstop,M(De),this._tabstop=De._tabstop,M=De.value}else M=c._escape(M);return this.value+="${",this.value+=se,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,se=this._tabstop++){const De=M.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(M,se){if(typeof se=="function"){const De=new c;De._tabstop=this._tabstop,se(De),this._tabstop=De._tabstop,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.SnippetString=Ee=c=je([N],Ee);var Ie;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(Ie||(e.DiagnosticTag=Ie={}));var oe;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(oe||(e.DiagnosticSeverity=oe={}));let ce=e.Location=l=class{static isLocation(M){return M instanceof l?!0:M?he.isRange(M.range)&&h.URI.isUri(M.uri):!1}constructor(M,se){if(this.uri=M,se)if(he.isRange(se))this.range=he.of(se);else if(we.isPosition(se))this.range=new he(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=ce=l=je([N],ce);let ie=e.DiagnosticRelatedInformation=class{static is(M){return M?typeof M.message=="string"&&M.location&&he.isRange(M.location.range)&&h.URI.isUri(M.location.uri):!1}constructor(M,se){this.location=M,this.message=se}static isEqual(M,se){return M===se?!0:!M||!se?!1:M.message===se.message&&M.location.range.isEqual(se.location.range)&&M.location.uri.toString()===se.location.uri.toString()}};e.DiagnosticRelatedInformation=ie=je([N],ie);let ne=e.Diagnostic=class{constructor(M,se,De=oe.Error){if(!he.isRange(M))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=M,this.message=se,this.severity=De}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,se){return M===se?!0:!M||!se?!1:M.message===se.message&&M.severity===se.severity&&M.code===se.code&&M.severity===se.severity&&M.source===se.source&&M.range.isEqual(se.range)&&(0,n.equals)(M.tags,se.tags)&&(0,n.equals)(M.relatedInformation,se.relatedInformation,ie.isEqual)}};e.Diagnostic=ne=je([N],ne);let C=e.Hover=class{constructor(M,se){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=se}};e.Hover=C=je([N],C);var z;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(z||(e.DocumentHighlightKind=z={}));let V=e.DocumentHighlight=class{constructor(M,se=z.Text){this.range=M,this.kind=se}toJSON(){return{range:this.range,kind:z[this.kind]}}};e.DocumentHighlight=V=je([N],V);var j;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(j||(e.SymbolKind=j={}));var ae;(function(x){x[x.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let ge=e.SymbolInformation=m=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,se,De,qe,Ze){this.name=M,this.kind=se,this.containerName=Ze,typeof De=="string"&&(this.containerName=De),qe instanceof ce?this.location=qe:De instanceof he&&(this.location=new ce(qe,De)),m.validate(this)}toJSON(){return{name:this.name,kind:j[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=ge=m=je([N],ge);let ee=e.DocumentSymbol=E=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(E.validate)}constructor(M,se,De,qe,Ze){this.name=M,this.detail=se,this.kind=De,this.range=qe,this.selectionRange=Ze,this.children=[],E.validate(this)}};e.DocumentSymbol=ee=E=je([N],ee);var be;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(be||(e.CodeActionTriggerKind=be={}));let Se=e.CodeAction=class{constructor(M,se){this.title=M,this.kind=se}};e.CodeAction=Se=je([N],Se);let xe=e.CodeActionKind=f=class{constructor(M){this.value=M}append(M){return new f(this.value?this.value+f.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+f.sep)}};xe.sep=".",e.CodeActionKind=xe=f=je([N],xe),xe.Empty=new xe(""),xe.QuickFix=xe.Empty.append("quickfix"),xe.Refactor=xe.Empty.append("refactor"),xe.RefactorExtract=xe.Refactor.append("extract"),xe.RefactorInline=xe.Refactor.append("inline"),xe.RefactorMove=xe.Refactor.append("move"),xe.RefactorRewrite=xe.Refactor.append("rewrite"),xe.Source=xe.Empty.append("source"),xe.SourceOrganizeImports=xe.Source.append("organizeImports"),xe.SourceFixAll=xe.Source.append("fixAll");let He=e.SelectionRange=class{constructor(M,se){if(this.range=M,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=He=je([N],He);class et{constructor(M,se,De,qe,Ze,ct){this.kind=M,this.name=se,this.detail=De,this.uri=qe,this.range=Ze,this.selectionRange=ct}}e.CallHierarchyItem=et;class Qe{constructor(M,se){this.fromRanges=se,this.from=M}}e.CallHierarchyIncomingCall=Qe;class Ye{constructor(M,se){this.fromRanges=se,this.to=M}}e.CallHierarchyOutgoingCall=Ye;var rt;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(rt||(e.LanguageStatusSeverity=rt={}));let lt=e.CodeLens=class{constructor(M,se){this.range=M,this.command=se}get isResolved(){return!!this.command}};e.CodeLens=lt=je([N],lt);let Me=e.MarkdownString=L=class{static isMarkdownString(M){return M instanceof L?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,se=!1){t.set(this,void 0),Je(this,t,new D.MarkdownString(M,{supportThemeIcons:se}),"f")}get value(){return Le(this,t,"f").value}set value(M){Le(this,t,"f").value=M}get isTrusted(){return Le(this,t,"f").isTrusted}set isTrusted(M){Le(this,t,"f").isTrusted=M}get supportThemeIcons(){return Le(this,t,"f").supportThemeIcons}set supportThemeIcons(M){Le(this,t,"f").supportThemeIcons=M}get supportHtml(){return Le(this,t,"f").supportHtml}set supportHtml(M){Le(this,t,"f").supportHtml=M}get baseUri(){return Le(this,t,"f").baseUri}set baseUri(M){Le(this,t,"f").baseUri=M}appendText(M){return Le(this,t,"f").appendText(M),this}appendMarkdown(M){return Le(this,t,"f").appendMarkdown(M),this}appendCodeblock(M,se){return Le(this,t,"f").appendCodeblock(se??"",M),this}};t=new WeakMap,e.MarkdownString=Me=L=je([N],Me);let st=e.ParameterInformation=class{constructor(M,se){this.label=M,this.documentation=se}};e.ParameterInformation=st=je([N],st);let Z=e.SignatureInformation=class{constructor(M,se){this.label=M,this.documentation=se,this.parameters=[]}};e.SignatureInformation=Z=je([N],Z);let Y=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Y=je([N],Y);var _e;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(_e||(e.SignatureHelpTriggerKind=_e={}));var Ne;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Ne||(e.InlayHintKind=Ne={}));let ze=e.InlayHintLabelPart=class{constructor(M){this.value=M}};e.InlayHintLabelPart=ze=je([N],ze);let Xe=e.InlayHint=class{constructor(M,se,De){this.position=M,this.label=se,this.kind=De}};e.InlayHint=Xe=je([N],Xe);var We;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(We||(e.CompletionTriggerKind=We={}));var it;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(it||(e.CompletionItemKind=it={}));var wt;(function(x){x[x.Deprecated=1]="Deprecated"})(wt||(e.CompletionItemTag=wt={}));let St=e.CompletionItem=class{constructor(M,se){this.label=M,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&it[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=St=je([N],St);let kt=e.CompletionList=class{constructor(M=[],se=!1){this.items=M,this.isIncomplete=se}};e.CompletionList=kt=je([N],kt);let $t=e.InlineSuggestion=class{constructor(M,se,De){this.insertText=M,this.range=se,this.command=De}};e.InlineSuggestion=$t=je([N],$t);let bt=e.InlineSuggestionList=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.InlineSuggestionList=bt=je([N],bt);var Bt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Bt||(e.ViewColumn=Bt={}));var Mt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Mt||(e.StatusBarAlignment=Mt={}));var jt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(jt||(e.TextEditorLineNumbersStyle=jt={}));var Wt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Wt||(e.TextDocumentSaveReason=Wt={}));var Tt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Tt||(e.TextEditorRevealType=Tt={}));var at;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(at||(e.TextEditorSelectionChangeKind=at={}));var gt;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(gt||(e.TextDocumentChangeReason=gt={}));var zt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(zt||(e.DecorationRangeBehavior=zt={})),function(x){function M(se){switch(se){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=M}(at||(e.TextEditorSelectionChangeKind=at={}));let Nt=e.DocumentLink=class{constructor(M,se){if(se&&!h.URI.isUri(se))throw(0,T.illegalArgument)("target");if(!he.isRange(M)||M.isEmpty)throw(0,T.illegalArgument)("range");this.range=M,this.target=se}};e.DocumentLink=Nt=je([N],Nt);let It=e.Color=class{constructor(M,se,De,qe){this.red=M,this.green=se,this.blue=De,this.alpha=qe}};e.Color=It=je([N],It);let ht=e.ColorInformation=class{constructor(M,se){if(se&&!(se instanceof It))throw(0,T.illegalArgument)("color");if(!he.isRange(M)||M.isEmpty)throw(0,T.illegalArgument)("range");this.range=M,this.color=se}};e.ColorInformation=ht=je([N],ht);let Ct=e.ColorPresentation=class{constructor(M){if(!M||typeof M!="string")throw(0,T.illegalArgument)("label");this.label=M}};e.ColorPresentation=Ct=je([N],Ct);var Ot;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Ot||(e.ColorFormat=Ot={}));var Pt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Pt||(e.SourceControlInputBoxValidationType=Pt={}));var Ke;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(Ke||(e.TerminalExitReason=Ke={}));class ke{constructor(M,se,De){if(this.startIndex=M,this.length=se,this.tooltip=De,typeof M!="number"||M<0)throw(0,T.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,T.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=ke;class Re{constructor(M){this.uri=M}}e.TerminalQuickFixOpener=Re;class ve{constructor(M){this.terminalCommand=M}}e.TerminalQuickFixCommand=ve;var K;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(K||(e.TerminalLocation=K={}));class Oe{constructor(M){if(this.options=M,typeof M!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=Oe;var Be;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(Be||(e.TaskRevealKind=Be={}));var Ge;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Ge||(e.TaskPanelKind=Ge={}));let $e=e.TaskGroup=W=class{static from(M){switch(M){case"clean":return W.Clean;case"build":return W.Build;case"rebuild":return W.Rebuild;case"test":return W.Test;default:return}}constructor(M,se){if(this.label=se,typeof M!="string"||typeof se!="string")throw(0,T.illegalArgument)("name");this._id=M}get id(){return this._id}};$e.Clean=new W("clean","Clean"),$e.Build=new W("build","Build"),$e.Rebuild=new W("rebuild","Rebuild"),$e.Test=new W("test","Test"),e.TaskGroup=$e=W=je([N],$e);function tt(x){let M="";for(let se=0;se<x.length;se++)M+=x[se].replace(/,/g,",,")+",";return M}let Et=e.ProcessExecution=class{constructor(M,se,De){if(typeof M!="string")throw(0,T.illegalArgument)("process");this._args=[],this._process=M,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=De):this._options=se)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,T.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(const se of this._args)M.push(se);return tt(M)}};e.ProcessExecution=Et=je([N],Et);let pt=e.ShellExecution=class{constructor(M,se,De){if(this._args=[],Array.isArray(se)){if(!M)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,T.illegalArgument)("command");this._command=M,this._args=se,this._options=De}else{if(typeof M!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=M,this._options=se}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,T.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const se of this._args)M.push(typeof se=="string"?se:se.value);return tt(M)}};e.ShellExecution=pt=je([N],pt);var dt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(dt||(e.ShellQuoting=dt={}));var nt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(nt||(e.TaskScope=nt={}));class ut{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=ut;let Rt=e.Task=J=class{constructor(M,se,De,qe,Ze,ct){this.__deprecated=!1,this._definition=this.definition=M;let mt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=De,this.execution=qe,mt=Ze,this.__deprecated=!0):se===nt.Global||se===nt.Workspace?(this.target=se,this._name=this.name=De,this._source=this.source=qe,this.execution=Ze,mt=ct):(this.target=se,this._name=this.name=De,this._source=this.source=qe,this.execution=Ze,mt=ct),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Et?this._definition={type:J.ProcessType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:J.ShellType,id:this._execution.computeId()}:this._execution instanceof ut?this._definition={type:J.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:J.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,T.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const se=this._definition.type;(J.EmptyType===se||J.ProcessType===se||J.ShellType===se||J.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};Rt.ExtensionCallbackType="customExecution",Rt.ProcessType="process",Rt.ShellType="shell",Rt.EmptyType="$empty",e.Task=Rt=J=je([N],Rt);var Ut;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Ut||(e.ProgressLocation=Ut={}));var ai;(function(x){function M(se){const De=se;return(0,S.isNumber)(De.value)?De.tooltip&&!(0,S.isString)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}x.isViewBadge=M})(ai||(e.ViewBadge=ai={}));let ri=e.TreeItem=q=class{static isTreeItem(M,se){const De=M;if(De.checkboxState!==void 0){(0,p.checkProposedApiEnabled)(se,"treeItemCheckbox");const qe=(0,S.isNumber)(De.checkboxState)?De.checkboxState:(0,S.isObject)(De.checkboxState)&&(0,S.isNumber)(De.checkboxState.state)?De.checkboxState.state:void 0,Ze=!(0,S.isNumber)(De.checkboxState)&&(0,S.isObject)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(qe===void 0||qe!==Dt.Checked&&qe!==Dt.Unchecked||Ze!==void 0&&!(0,S.isString)(Ze))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(M instanceof q)return!0;if(De.label!==void 0&&!(0,S.isString)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,S.isString)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,S.isString)(De.iconPath)&&!h.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,S.isString)(De.iconPath.id))){const qe=De.iconPath;if(!qe||!(0,S.isString)(qe.light)&&!h.URI.isUri(qe.light)&&!(0,S.isString)(qe.dark)&&!h.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,S.isString)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!h.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,S.isString)(De.tooltip)&&!(De.tooltip instanceof Me)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<ei.None&&De.collapsibleState>ei.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,S.isString)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(M,se=ei.None){this.collapsibleState=se,h.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.TreeItem=ri=q=je([N],ri);var ei;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(ei||(e.TreeItemCollapsibleState=ei={}));var Dt;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let Ti=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M,se){this.value=M,this.id=se??(0,R.generateUuid)()}};e.DataTransferItem=Ti=je([N],Ti);class Yi{constructor(M,se,De,qe){this.name=M,this.uri=se,this._itemId=De,this._getData=qe}data(){return this._getData()}}e.DataTransferFile=Yi;let yt=e.DataTransfer=class{constructor(M){o.add(this),d.set(this,new Map);for(const[se,De]of M??[]){const qe=Le(this,d,"f").get(Le(this,o,"m",y).call(this,se));qe?qe.push(De):Le(this,d,"f").set(Le(this,o,"m",y).call(this,se),[De])}}get(M){return Le(this,d,"f").get(Le(this,o,"m",y).call(this,M))?.[0]}set(M,se){Le(this,d,"f").set(Le(this,o,"m",y).call(this,M),[se])}forEach(M,se){for(const[De,qe]of Le(this,d,"f"))for(const Ze of qe)M.call(se,Ze,De,this)}*[(d=new WeakMap,o=new WeakSet,Symbol.iterator)](){for(const[M,se]of Le(this,d,"f"))for(const De of se)yield[M,De]}};y=function(M){return M.toLowerCase()},e.DataTransfer=yt=je([N],yt);let gi=e.DocumentDropEdit=class{constructor(M){this.insertText=M}};e.DocumentDropEdit=gi=je([N],gi);let pi=e.DocumentPasteEdit=class{constructor(M){this.insertText=M}};e.DocumentPasteEdit=pi=je([N],pi);let Ht=e.ThemeIcon=class{constructor(M,se){this.id=M,this.color=se}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.ThemeIcon=Ht=je([N],Ht),Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let Pi=e.ThemeColor=class{constructor(M){this.id=M}};e.ThemeColor=Pi=je([N],Pi);var Ai;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(Ai||(e.ConfigurationTarget=Ai={}));let Ft=e.RelativePattern=class{get base(){return this._base}set base(M){this._base=M,this._baseUri=h.URI.file(M)}get baseUri(){return this._baseUri}set baseUri(M){this._baseUri=M,this._base=M.fsPath}constructor(M,se){if(typeof M!="string"&&(!M||!h.URI.isUri(M)&&!h.URI.isUri(M.uri)))throw(0,T.illegalArgument)("base");if(typeof se!="string")throw(0,T.illegalArgument)("pattern");typeof M=="string"?this.baseUri=h.URI.file(M):h.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Ft=je([N],Ft);const vi=new WeakMap;function Ji(x,M){vi.set(x,M)}e.setBreakpointId=Ji;let Gt=e.Breakpoint=class{constructor(M,se,De,qe){this.enabled=typeof M=="boolean"?M:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=vi.get(this)??(0,R.generateUuid)()),this._id}};e.Breakpoint=Gt=je([N],Gt);let si=e.SourceBreakpoint=class extends Gt{constructor(M,se,De,qe,Ze){if(super(se,De,qe,Ze),M===null)throw(0,T.illegalArgument)("location");this.location=M}};e.SourceBreakpoint=si=je([N],si);let ft=e.FunctionBreakpoint=class extends Gt{constructor(M,se,De,qe,Ze){super(se,De,qe,Ze),this.functionName=M}};e.FunctionBreakpoint=ft=je([N],ft);let Ri=e.DataBreakpoint=class extends Gt{constructor(M,se,De,qe,Ze,ct,mt){if(super(qe,Ze,ct,mt),!se)throw(0,T.illegalArgument)("dataId");this.label=M,this.dataId=se,this.canPersist=De}};e.DataBreakpoint=Ri=je([N],Ri);let Xt=e.DebugAdapterExecutable=class{constructor(M,se,De){this.command=M,this.args=se||[],this.options=De}};e.DebugAdapterExecutable=Xt=je([N],Xt);let ti=e.DebugAdapterServer=class{constructor(M,se){this.port=M,this.host=se}};e.DebugAdapterServer=ti=je([N],ti);let Ei=e.DebugAdapterNamedPipeServer=class{constructor(M){this.path=M}};e.DebugAdapterNamedPipeServer=Ei=je([N],Ei);let Oi=e.DebugAdapterInlineImplementation=class{constructor(M){this.implementation=M}};e.DebugAdapterInlineImplementation=Oi=je([N],Oi);let Fi=e.EvaluatableExpression=class{constructor(M,se){this.range=M,this.expression=se}};e.EvaluatableExpression=Fi=je([N],Fi);var wi;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(wi||(e.InlineCompletionTriggerKind=wi={}));let Li=e.InlineValueText=class{constructor(M,se){this.range=M,this.text=se}};e.InlineValueText=Li=je([N],Li);let bi=e.InlineValueVariableLookup=class{constructor(M,se,De=!0){this.range=M,this.variableName=se,this.caseSensitiveLookup=De}};e.InlineValueVariableLookup=bi=je([N],bi);let ii=e.InlineValueEvaluatableExpression=class{constructor(M,se){this.range=M,this.expression=se}};e.InlineValueEvaluatableExpression=ii=je([N],ii);let Mi=e.InlineValueContext=class{constructor(M,se){this.frameId=M,this.stoppedLocation=se}};e.InlineValueContext=Mi=je([N],Mi);var ci;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(ci||(e.FileChangeType=ci={}));let li=e.FileSystemError=U=class extends Error{static FileExists(M){return new U(M,b.FileSystemProviderErrorCode.FileExists,U.FileExists)}static FileNotFound(M){return new U(M,b.FileSystemProviderErrorCode.FileNotFound,U.FileNotFound)}static FileNotADirectory(M){return new U(M,b.FileSystemProviderErrorCode.FileNotADirectory,U.FileNotADirectory)}static FileIsADirectory(M){return new U(M,b.FileSystemProviderErrorCode.FileIsADirectory,U.FileIsADirectory)}static NoPermissions(M){return new U(M,b.FileSystemProviderErrorCode.NoPermissions,U.NoPermissions)}static Unavailable(M){return new U(M,b.FileSystemProviderErrorCode.Unavailable,U.Unavailable)}constructor(M,se=b.FileSystemProviderErrorCode.Unknown,De){super(h.URI.isUri(M)?M.toString(!0):M),this.code=De?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,U.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.FileSystemError=li=U=je([N],li);let Ni=e.FoldingRange=class{constructor(M,se,De){this.start=M,this.end=se,this.kind=De}};e.FoldingRange=Ni=je([N],Ni);var Ui;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Ui||(e.FoldingRangeKind=Ui={}));var ni;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(ni||(e.CommentThreadCollapsibleState=ni={}));var xi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(xi||(e.CommentMode=xi={}));var Bi;(function(x){x[x.Published=0]="Published",x[x.Draft=1]="Draft"})(Bi||(e.CommentState=Bi={}));var zi;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(zi||(e.CommentThreadState=zi={}));class ui{constructor(M,se=[]){this.tokenTypes=M,this.tokenModifiers=se}}e.SemanticTokensLegend=ui;function Zi(x){return typeof x>"u"||(0,S.isStringArray)(x)}class _i{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let se=0,De=M.tokenTypes.length;se<De;se++)this._tokenTypeStrToInt.set(M.tokenTypes[se],se);for(let se=0,De=M.tokenModifiers.length;se<De;se++)this._tokenModifierStrToInt.set(M.tokenModifiers[se],se)}}push(M,se,De,qe,Ze){if(typeof M=="number"&&typeof se=="number"&&typeof De=="number"&&typeof qe=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this._pushEncoded(M,se,De,qe,Ze);if(he.isRange(M)&&typeof se=="string"&&Zi(De))return this._push(M,se,De);throw(0,T.illegalArgument)()}_push(M,se,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const qe=M.start.line,Ze=M.start.character,ct=M.end.character-M.start.character,mt=this._tokenTypeStrToInt.get(se);let xt=0;if(De)for(const Vt of De){if(!this._tokenModifierStrToInt.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Kt=this._tokenModifierStrToInt.get(Vt);xt|=1<<Kt>>>0}this._pushEncoded(qe,Ze,ct,mt,xt)}_pushEncoded(M,se,De,qe,Ze){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const xt=this._data.length/5|0;let Vt=0,Kt=0;for(let Yt=0;Yt<xt;Yt++){let Jt=this._data[5*Yt],Ci=this._data[5*Yt+1];Jt===0?(Jt=Vt,Ci+=Kt):Jt+=Vt,this._data[5*Yt]=Jt,this._data[5*Yt+1]=Ci,Vt=Jt,Kt=Ci}}let ct=M,mt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Ze,this._prevLine=M,this._prevChar=se}static _sortAndDeltaEncode(M){const se=[],De=M.length/5|0;for(let mt=0;mt<De;mt++)se[mt]=mt;se.sort((mt,xt)=>{const Vt=M[5*mt],Kt=M[5*xt];if(Vt===Kt){const Yt=M[5*mt+1],Jt=M[5*xt+1];return Yt-Jt}return Vt-Kt});const qe=new Uint32Array(M.length);let Ze=0,ct=0;for(let mt=0;mt<De;mt++){const xt=5*se[mt],Vt=M[xt+0],Kt=M[xt+1],Yt=M[xt+2],Jt=M[xt+3],Ci=M[xt+4],Sn=Vt-Ze,Un=Sn===0?Kt-ct:Kt,ki=5*mt;qe[ki+0]=Sn,qe[ki+1]=Un,qe[ki+2]=Yt,qe[ki+3]=Jt,qe[ki+4]=Ci,Ze=Vt,ct=Kt}return qe}build(M){return this._dataIsSortedAndDeltaEncoded?new Si(new Uint32Array(this._data),M):new Si(_i._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=_i;class Si{constructor(M,se){this.resultId=se,this.data=M}}e.SemanticTokens=Si;class en{constructor(M,se,De){this.start=M,this.deleteCount=se,this.data=De}}e.SemanticTokensEdit=en;class tn{constructor(M,se){this.resultId=se,this.edits=M}}e.SemanticTokensEdits=tn;var di;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(di||(e.DebugConsoleMode=di={}));let hi=e.QuickInputButtons=class{constructor(){}};hi.Back={iconPath:new Ht("arrow-left")},e.QuickInputButtons=hi=je([N],hi);var yi;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(yi||(e.QuickPickItemKind=yi={}));var Ue;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Ue||(e.InputBoxValidationSeverity=Ue={}));var qt;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(qt||(e.ExtensionKind=qt={}));class $i{static validate(M){if(typeof M.badge=="string"){let se=(0,P.nextCharLength)(M.badge,0);if(se<M.badge.length&&(se+=(0,P.nextCharLength)(M.badge,se)),M.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!Ht.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,se,De){this.badge=M,this.tooltip=se,this.color=De}}e.FileDecoration=$i;let vt=e.ColorTheme=class{constructor(M){this.kind=M}};e.ColorTheme=vt=je([N],vt);var Wi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(Wi||(e.ColorThemeKind=Wi={}));class Qt{static isNotebookRange(M){return M instanceof Qt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(M,se){if(M<0)throw(0,T.illegalArgument)("start must be positive");if(se<0)throw(0,T.illegalArgument)("end must be positive");M<=se?(this._start=M,this._end=se):(this._start=se,this._end=M)}with(M){let se=this._start,De=this._end;return M.start!==void 0&&(se=M.start),M.end!==void 0&&(De=M.end),se===this._start&&De===this._end?this:new Qt(se,De)}}e.NotebookRange=Qt;class oi{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(se=>oi.isNotebookCellData(se))}static isNotebookCellData(M){return!0}constructor(M,se,De,qe,Ze,ct,mt){this.kind=M,this.value=se,this.languageId=De,this.mime=qe,this.outputs=Ze??[],this.metadata=ct,this.executionSummary=mt,oi.validate(this)}}e.NotebookCellData=oi;class nn{constructor(M){this.cells=M}}e.NotebookData=nn;class Lt{static isNotebookCellOutputItem(M){return M instanceof Lt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const se={name:M.name,message:M.message,stack:M.stack};return Lt.json(se,"application/vnd.code.notebook.error")}static stdout(M){return Lt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Lt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,se="application/octet-stream"){return new Lt(M,se)}static text(M,se=A.Mimes.text){const De=Le(Lt,k,"f",v).encode(String(M));return new Lt(De,se)}static json(M,se="text/x-json"){const De=JSON.stringify(M,void 0,"	");return Lt.text(De,se)}constructor(M,se){this.data=M,this.mime=se;const De=(0,A.normalizeMimeType)(se,!0);if(!De)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.NotebookCellOutputItem=Lt,k=Lt,v={value:new TextEncoder};class fi{static isNotebookCellOutput(M){return M instanceof fi?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,se=!1){const De=new Set,qe=new Set;for(let Ze=0;Ze<M.length;Ze++){const ct=M[Ze],mt=(0,A.normalizeMimeType)(ct.mime);if(!De.has(mt)||(0,_.isTextStreamMime)(mt)){De.add(mt);continue}qe.add(Ze),se&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return qe.size===0?M:M.filter((Ze,ct)=>!qe.has(ct))}constructor(M,se,De){this.items=fi.ensureUniqueMimeTypes(M,!0),typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,R.generateUuid)(),this.metadata=se??De)}}e.NotebookCellOutput=fi;var Hi;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Hi||(e.NotebookCellKind=Hi={}));var Vi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Vi||(e.NotebookCellExecutionState=Vi={}));var Di;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Di||(e.NotebookCellStatusBarAlignment=Di={}));var ji;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(ji||(e.NotebookEditorRevealType=ji={}));class rn{constructor(M,se){this.text=M,this.alignment=se}}e.NotebookCellStatusBarItem=rn;var qi;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(qi||(e.NotebookControllerAffinity=qi={}));var Ki;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(Ki||(e.NotebookControllerAffinity2=Ki={}));class sn{constructor(M,se=[]){this.uri=M,this.provides=(0,n.asArray)(se)}}e.NotebookRendererScript=sn;class on{constructor(M){this.label=M}}e.NotebookKernelSourceAction=on;let Gi=e.TimelineItem=class{constructor(M,se){this.label=M,this.timestamp=se}};e.TimelineItem=Gi=je([N],Gi);var Xi;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(Xi||(e.ExtensionMode=Xi={}));var re;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(re||(e.ExtensionRuntime=re={}));var fe;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(fe||(e.StandardTokenType=fe={}));class Fe{constructor(M,se){this.ranges=M,this.wordPattern=se}}e.LinkedEditingRanges=Fe;class ot{constructor(M,se){this._port=M,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ot;var _t;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(_t||(e.TestResultState=_t={}));var At;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(At||(e.TestRunProfileKind=At={}));let an=e.TestRunRequest=class{constructor(M=void 0,se=void 0,De=void 0,qe=!1){this.include=M,this.exclude=se,this.profile=De,this.continuous=qe}};e.TestRunRequest=an=je([N],an);let ln=e.TestRunRequest2=class extends an{};e.TestRunRequest2=ln=je([N],ln);let un=e.TestMessage=B=class{static diff(M,se,De){const qe=new B(M);return qe.expectedOutput=se,qe.actualOutput=De,qe}constructor(M){this.message=M}};e.TestMessage=un=B=je([N],un);let dn=e.TestTag=class{constructor(M){this.id=M}};e.TestTag=dn=je([N],dn);let Ii=e.CoveredCount=class{constructor(M,se){this.covered=M,this.total=se}};e.CoveredCount=Ii=je([N],Ii);let hn=e.FileCoverage=G=class{static fromDetails(M,se){const De=new Ii(0,0),qe=new Ii(0,0),Ze=new Ii(0,0);for(const mt of se)if("branches"in mt){De.total+=1,De.covered+=mt.executionCount>0?1:0;for(const xt of mt.branches)qe.total+=1,qe.covered+=xt.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=mt.executionCount>0?1:0;const ct=new G(M,De,qe.total>0?qe:void 0,Ze.total>0?Ze:void 0);return ct.detailedCoverage=se,ct}constructor(M,se,De,qe){this.uri=M,this.statementCoverage=se,this.branchCoverage=De,this.functionCoverage=qe}};e.FileCoverage=hn=G=je([N],hn);let fn=e.StatementCoverage=class{constructor(M,se,De=[]){this.executionCount=M,this.location=se,this.branches=De}};e.StatementCoverage=fn=je([N],fn);let mn=e.BranchCoverage=class{constructor(M,se){this.executionCount=M,this.location=se}};e.BranchCoverage=mn=je([N],mn);let gn=e.FunctionCoverage=class{constructor(M,se){this.executionCount=M,this.location=se}};e.FunctionCoverage=gn=je([N],gn);var pn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(pn||(e.ExternalUriOpenerPriority=pn={}));var vn;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(vn||(e.WorkspaceTrustState=vn={}));var En;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(En||(e.PortAutoForwardAction=En={}));class kn{constructor(M,se,De,qe,Ze,ct){this.kind=M,this.name=se,this.detail=De,this.uri=qe,this.range=Ze,this.selectionRange=ct}}e.TypeHierarchyItem=kn;class Tn{constructor(M){this.uri=M}}e.TextTabInput=Tn;class Pn{constructor(M,se){this.original=M,this.modified=se}}e.TextDiffTabInput=Pn;class An{constructor(M,se,De,qe){this.base=M,this.input1=se,this.input2=De,this.result=qe}}e.TextMergeTabInput=An;class Rn{constructor(M,se){this.uri=M,this.viewType=se}}e.CustomEditorTabInput=Rn;class On{constructor(M){this.viewType=M}}e.WebviewEditorTabInput=On;class Fn{constructor(M,se){this.uri=M,this.notebookType=se}}e.NotebookEditorTabInput=Fn;class Ln{constructor(M,se,De){this.original=M,this.modified=se,this.notebookType=De}}e.NotebookDiffEditorTabInput=Ln;class Mn{constructor(){}}e.TerminalEditorTabInput=Mn;class Nn{constructor(M,se){this.uri=M,this.inputBoxUri=se}}e.InteractiveWindowInput=Nn;var wn;(function(x){x[x.Up=1]="Up",x[x.Down=2]="Down"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var bn;(function(x){x[x.Action=1]="Action",x[x.Toolbar=2]="Toolbar"})(bn||(e.InteractiveSessionCopyKind=bn={}));var _n;(function(x){x[x.Unhelpful=0]="Unhelpful",x[x.Helpful=1]="Helpful",x[x.Undone=2]="Undone"})(_n||(e.InteractiveEditorResponseFeedbackKind=_n={}))}),define(Te[102],Pe([1,0,49,15,13,269,135,7,16]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const h=new Map;function R(p,u){u?h.set(p,u):h.delete(p)}e.setWordDefinitionFor=R;function b(p){return h.get(p)}class g extends F.MirrorTextModel{constructor(u,t,o,d,y,k,v,i){super(t,o,d,y),this._proxy=u,this._languageId=k,this._isDirty=v,this.notebook=i,this._isDisposed=!1}dispose(){(0,n.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,S.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===T.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},save(){return u._save()},getText(t){return t?u._getTextInRange(t):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(t){return u._lineAt(t)},offsetAt(t){return u._offsetAt(t)},positionAt(t){return u._positionAt(t)},validateRange(t){return u._validateRange(t)},validatePosition(t){return u._validatePosition(t)},getWordRangeAtPosition(t,o){return u._getWordRangeAtPosition(t,o)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,n.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,n.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const t=this._validateRange(u);if(t.isEmpty)return"";if(t.isSingleLine)return this._lines[t.start.line].substring(t.start.character,t.end.character);const o=this._eol,d=t.start.line,y=t.end.line,k=[];k.push(this._lines[d].substring(t.start.character));for(let v=d+1;v<y;v++)k.push(this._lines[v]);return k.push(this._lines[y].substring(0,t.end.character)),k.join(o)}_lineAt(u){let t;if(u instanceof P.Position?t=u.line:typeof u=="number"&&(t=u),typeof t!="number"||t<0||t>=this._lines.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new _(t,this._lines[t],t===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const t=this._lineStarts.getIndexOf(u),o=this._lines[t.index].length;return new P.Position(t.index,Math.min(t.remainder,o))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const t=this._validatePosition(u.start),o=this._validatePosition(u.end);return t===u.start&&o===u.end?u:new P.Range(t.line,t.character,o.line,o.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:t,character:o}=u,d=!1;if(t<0)t=0,o=0,d=!0;else if(t>=this._lines.length)t=this._lines.length-1,o=this._lines[t].length,d=!0;else{const y=this._lines[t].length;o<0?(o=0,d=!0):o>y&&(o=y,d=!0)}return d?new P.Position(t,o):u}_getWordRangeAtPosition(u,t){const o=this._validatePosition(u);if(!t)t=b(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const d=(0,A.getWordAtText)(o.character+1,(0,A.ensureValidWordDefinition)(t),this._lines[o.line],0);if(d)return new P.Range(o.line,d.startColumn-1,o.line,d.endColumn-1)}}e.ExtHostDocumentData=g;class _{constructor(u,t,o){this._line=u,this._text=t,this._isLastLine=o}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=_}),define(Te[201],Pe([1,0,7,18,5]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let F=e.ExtHostTheming=class{constructor(P){this._actual=new n.ColorTheme(n.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let S;switch(P){case"light":S=n.ColorThemeKind.Light;break;case"hcDark":S=n.ColorThemeKind.HighContrast;break;case"hcLight":S=n.ColorThemeKind.HighContrastLight;break;default:S=n.ColorThemeKind.Dark}this._actual=new n.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=F=je([Ve(0,T.IExtHostRpcService)],F)}),define(Te[8],Pe([1,0,16,25,119,202,88,28,115,67,66,23,12,2,44,77,93,99,98,73,45,56,198,7]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o,d,y,k,v,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveSessionFollowup=e.InteractiveSessionReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(ke){function Re(K){const{selectionStartLineNumber:Oe,selectionStartColumn:Be,positionLineNumber:Ge,positionColumn:$e}=K,tt=new a.Position(Oe-1,Be-1),Et=new a.Position(Ge-1,$e-1);return new a.Selection(tt,Et)}ke.to=Re;function ve(K){const{anchor:Oe,active:Be}=K;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}ke.from=ve})(r||(e.Selection=r={}));var s;(function(ke){function Re(K){if(!K)return;const{start:Oe,end:Be}=K;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}ke.from=Re;function ve(K){if(!K)return;const{startLineNumber:Oe,startColumn:Be,endLineNumber:Ge,endColumn:$e}=K;return new a.Range(Oe-1,Be-1,Ge-1,$e-1)}ke.to=ve})(s||(e.Range=s={}));var w;(function(ke){function Re(ve){switch(ve){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}ke.to=Re})(w||(e.TokenType=w={}));var I;(function(ke){function Re(K){return new a.Position(K.lineNumber-1,K.column-1)}ke.to=Re;function ve(K){return{lineNumber:K.line+1,column:K.character+1}}ke.from=ve})(I||(e.Position=I={}));var c;(function(ke){function Re(Oe,Be,Ge){return(0,n.coalesce)((0,n.asArray)(Oe).map($e=>ve($e,Be,Ge)))}ke.from=Re;function ve(Oe,Be,Ge){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:Ge?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:K(Oe.scheme,Be),pattern:Y.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:Ge?.isBuiltin}}function K(Oe,Be){return Be&&typeof Oe=="string"?Be.transformOutgoingScheme(Oe):Oe}})(c||(e.DocumentSelector=c={}));var l;(function(ke){function Re(K){switch(K){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}ke.from=Re;function ve(K){switch(K){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}ke.to=ve})(l||(e.DiagnosticTag=l={}));var m;(function(ke){function Re(K){let Oe;return K.code&&((0,g.isString)(K.code)||(0,g.isNumber)(K.code)?Oe=String(K.code):Oe={value:String(K.code.value),target:K.code.target}),{...s.from(K.range),message:K.message,source:K.source,code:Oe,severity:f.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(E.from),tags:Array.isArray(K.tags)?(0,n.coalesce)(K.tags.map(l.from)):void 0}}ke.from=Re;function ve(K){const Oe=new a.Diagnostic(s.to(K),K.message,f.to(K.severity));return Oe.source=K.source,Oe.code=(0,g.isString)(K.code)?K.code:K.code?.value,Oe.relatedInformation=K.relatedInformation&&K.relatedInformation.map(E.to),Oe.tags=K.tags&&(0,n.coalesce)(K.tags.map(l.to)),Oe}ke.to=ve})(m||(e.Diagnostic=m={}));var E;(function(ke){function Re(K){return{...s.from(K.location.range),message:K.message,resource:K.location.uri}}ke.from=Re;function ve(K){return new a.DiagnosticRelatedInformation(new a.Location(K.resource,s.to(K)),K.message)}ke.to=ve})(E||(e.DiagnosticRelatedInformation=E={}));var f;(function(ke){function Re(K){switch(K){case a.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}ke.from=Re;function ve(K){switch(K){case t.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}ke.to=ve})(f||(e.DiagnosticSeverity=f={}));var L;(function(ke){function Re(K){return typeof K=="number"&&K>=a.ViewColumn.One?K-1:K===a.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}ke.from=Re;function ve(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ke.to=ve})(L||(e.ViewColumn=L={}));function W(ke){return typeof ke.range<"u"}function J(ke){return ke.length===0?!0:!!W(ke[0])}e.isDecorationOptionsArr=J;var q;(function(ke){function Re($e){return $e.map(ke.from)}ke.fromMany=Re;function ve($e){return $e&&typeof $e=="object"&&typeof $e.language=="string"&&typeof $e.value=="string"}function K($e){let tt;if(ve($e)){const{language:nt,value:ut}=$e;tt={value:"```"+nt+`
`+ut+"\n```\n"}}else a.MarkdownString.isMarkdownString($e)?tt={value:$e.value,isTrusted:$e.isTrusted,supportThemeIcons:$e.supportThemeIcons,supportHtml:$e.supportHtml,baseUri:$e.baseUri}:typeof $e=="string"?tt={value:$e}:tt={value:""};const Et=Object.create(null);tt.uris=Et;const pt=nt=>{try{let ut=_.URI.parse(nt,!0);ut=ut.with({query:Oe(ut.query,Et)}),Et[nt]=ut}catch{}return""},dt=new S.marked.Renderer;return dt.link=pt,dt.image=nt=>typeof nt=="string"?pt(A.parseHrefAndDimensions(nt).href):"",(0,S.marked)(tt.value,{renderer:dt}),tt}ke.from=K;function Oe($e,tt){if(!$e)return $e;let Et;try{Et=(0,h.parse)($e)}catch{}if(!Et)return $e;let pt=!1;return Et=(0,b.cloneAndChange)(Et,dt=>{if(_.URI.isUri(dt)){const nt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[nt]=dt,pt=!0,nt}else return}),pt?JSON.stringify(Et):$e}function Be($e){const tt=new a.MarkdownString($e.value,$e.supportThemeIcons);return tt.isTrusted=$e.isTrusted,tt.supportHtml=$e.supportHtml,tt.baseUri=$e.baseUri?_.URI.from($e.baseUri):void 0,tt}ke.to=Be;function Ge($e){if($e)return typeof $e=="string"?$e:ke.from($e)}ke.fromStrict=Ge})(q||(e.MarkdownString=q={}));function U(ke){return J(ke)?ke.map(Re=>({range:s.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?q.fromMany(Re.hoverMessage):Re.hoverMessage?q.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):ke.map(Re=>({range:s.from(Re)}))}e.fromRangeOrRangeWithMessage=U;function B(ke){return typeof ke>"u"?ke:typeof ke=="string"?_.URI.file(ke):ke}e.pathOrURIToURI=B;var G;(function(ke){function Re(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?B(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}ke.from=Re})(G||(e.ThemableDecorationAttachmentRenderOptions=G={}));var N;(function(ke){function Re(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?B(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?G.from(ve.before):void 0,after:ve.after?G.from(ve.after):void 0}}ke.from=Re})(N||(e.ThemableDecorationRenderOptions=N={}));var H;(function(ke){function Re(ve){if(typeof ve>"u")return ve;switch(ve){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}ke.from=Re})(H||(e.DecorationRangeBehavior=H={}));var Q;(function(ke){function Re(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?H.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?N.from(ve.light):void 0,dark:ve.dark?N.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?B(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?G.from(ve.before):void 0,after:ve.after?G.from(ve.after):void 0}}ke.from=Re})(Q||(e.DecorationRenderOptions=Q={}));var pe;(function(ke){function Re(K){return{text:K.newText,eol:K.newEol&&rt.from(K.newEol),range:s.from(K.range)}}ke.from=Re;function ve(K){const Oe=new a.TextEdit(s.to(K.range),K.text);return Oe.newEol=typeof K.eol>"u"?void 0:rt.to(K.eol),Oe}ke.to=ve})(pe||(e.TextEdit=pe={}));var we;(function(ke){function Re(K,Oe){const Be={edits:[]};if(K instanceof a.WorkspaceEdit){const Ge=new P.ResourceSet;for(const $e of K._allEntries())$e._type===1&&_.URI.isUri($e.to)&&$e.from===void 0&&Ge.add($e.to);for(const $e of K._allEntries())if($e._type===1){let tt;$e.options?.contents&&(ArrayBuffer.isView($e.options.contents)?tt={type:"base64",value:(0,T.encodeBase64)(T.VSBuffer.wrap($e.options.contents))}:tt={type:"dataTransferItem",id:$e.options.contents._itemId}),Be.edits.push({oldResource:$e.from,newResource:$e.to,options:{...$e.options,contents:tt},metadata:$e.metadata})}else $e._type===2?Be.edits.push({resource:$e.uri,textEdit:pe.from($e.edit),versionId:Ge.has($e.uri)?void 0:Oe?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===6?Be.edits.push({resource:$e.uri,textEdit:{range:s.from($e.range),text:$e.edit.value,insertAsSnippet:!0},versionId:Ge.has($e.uri)?void 0:Oe?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===3?Be.edits.push({metadata:$e.metadata,resource:$e.uri,cellEdit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion($e.uri)}):$e._type===5&&Be.edits.push({metadata:$e.metadata,resource:$e.uri,notebookVersionId:Oe?.getNotebookDocumentVersion($e.uri),cellEdit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(wt.from)}})}return Be}ke.from=Re;function ve(K){const Oe=new a.WorkspaceEdit,Be=new P.ResourceMap;for(const Ge of K.edits)if(Ge.textEdit){const $e=Ge,tt=_.URI.revive($e.resource),Et=s.to($e.textEdit.range),pt=$e.textEdit.text,dt=$e.textEdit.insertAsSnippet;let nt;dt?nt=a.SnippetTextEdit.replace(Et,new a.SnippetString(pt)):nt=a.TextEdit.replace(Et,pt);const ut=Be.get(tt);ut?ut.push(nt):Be.set(tt,[nt])}else Oe.renameFile(_.URI.revive(Ge.oldResource),_.URI.revive(Ge.newResource),Ge.options);for(const[Ge,$e]of Be)Oe.set(Ge,$e);return Oe}ke.to=ve})(we||(e.WorkspaceEdit=we={}));var he;(function(ke){const Re=Object.create(null);Re[a.SymbolKind.File]=0,Re[a.SymbolKind.Module]=1,Re[a.SymbolKind.Namespace]=2,Re[a.SymbolKind.Package]=3,Re[a.SymbolKind.Class]=4,Re[a.SymbolKind.Method]=5,Re[a.SymbolKind.Property]=6,Re[a.SymbolKind.Field]=7,Re[a.SymbolKind.Constructor]=8,Re[a.SymbolKind.Enum]=9,Re[a.SymbolKind.Interface]=10,Re[a.SymbolKind.Function]=11,Re[a.SymbolKind.Variable]=12,Re[a.SymbolKind.Constant]=13,Re[a.SymbolKind.String]=14,Re[a.SymbolKind.Number]=15,Re[a.SymbolKind.Boolean]=16,Re[a.SymbolKind.Array]=17,Re[a.SymbolKind.Object]=18,Re[a.SymbolKind.Key]=19,Re[a.SymbolKind.Null]=20,Re[a.SymbolKind.EnumMember]=21,Re[a.SymbolKind.Struct]=22,Re[a.SymbolKind.Event]=23,Re[a.SymbolKind.Operator]=24,Re[a.SymbolKind.TypeParameter]=25;function ve(Oe){return typeof Re[Oe]=="number"?Re[Oe]:6}ke.from=ve;function K(Oe){for(const Be in Re)if(Re[Be]===Oe)return Number(Be);return a.SymbolKind.Property}ke.to=K})(he||(e.SymbolKind=he={}));var de;(function(ke){function Re(K){switch(K){case a.SymbolTag.Deprecated:return 1}}ke.from=Re;function ve(K){switch(K){case 1:return a.SymbolTag.Deprecated}}ke.to=ve})(de||(e.SymbolTag=de={}));var Ae;(function(ke){function Re(K){return{name:K.name,kind:he.from(K.kind),tags:K.tags&&K.tags.map(de.from),containerName:K.containerName,location:X.from(K.location)}}ke.from=Re;function ve(K){const Oe=new a.SymbolInformation(K.name,he.to(K.kind),K.containerName,X.to(K.location));return Oe.tags=K.tags&&K.tags.map(de.to),Oe}ke.to=ve})(Ae||(e.WorkspaceSymbol=Ae={}));var ue;(function(ke){function Re(K){const Oe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:s.from(K.range),selectionRange:s.from(K.selectionRange),kind:he.from(K.kind),tags:K.tags?.map(de.from)??[]};return K.children&&(Oe.children=K.children.map(Re)),Oe}ke.from=Re;function ve(K){const Oe=new a.DocumentSymbol(K.name,K.detail,he.to(K.kind),s.to(K.range),s.to(K.selectionRange));return(0,n.isNonEmptyArray)(K.tags)&&(Oe.tags=K.tags.map(de.to)),K.children&&(Oe.children=K.children.map(ve)),Oe}ke.to=ve})(ue||(e.DocumentSymbol=ue={}));var le;(function(ke){function Re(K){const Oe=new a.CallHierarchyItem(he.to(K.kind),K.name,K.detail||"",_.URI.revive(K.uri),s.to(K.range),s.to(K.selectionRange));return Oe._sessionId=K._sessionId,Oe._itemId=K._itemId,Oe}ke.to=Re;function ve(K,Oe,Be){if(Oe=Oe??K._sessionId,Be=Be??K._itemId,Oe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Be,name:K.name,detail:K.detail,kind:he.from(K.kind),uri:K.uri,range:s.from(K.range),selectionRange:s.from(K.selectionRange),tags:K.tags?.map(de.from)}}ke.from=ve})(le||(e.CallHierarchyItem=le={}));var $;(function(ke){function Re(ve){return new a.CallHierarchyIncomingCall(le.to(ve.from),ve.fromRanges.map(K=>s.to(K)))}ke.to=Re})($||(e.CallHierarchyIncomingCall=$={}));var O;(function(ke){function Re(ve){return new a.CallHierarchyOutgoingCall(le.to(ve.to),ve.fromRanges.map(K=>s.to(K)))}ke.to=Re})(O||(e.CallHierarchyOutgoingCall=O={}));var X;(function(ke){function Re(K){return{range:K.range&&s.from(K.range),uri:K.uri}}ke.from=Re;function ve(K){return new a.Location(_.URI.revive(K.uri),s.to(K.range))}ke.to=ve})(X||(e.location=X={}));var me;(function(ke){function Re(K){const Oe=K,Be=K;return{originSelectionRange:Oe.originSelectionRange?s.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Be.uri,range:s.from(Oe.targetRange?Oe.targetRange:Be.range),targetSelectionRange:Oe.targetSelectionRange?s.from(Oe.targetSelectionRange):void 0}}ke.from=Re;function ve(K){return{targetUri:_.URI.revive(K.uri),targetRange:s.to(K.range),targetSelectionRange:K.targetSelectionRange?s.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?s.to(K.originSelectionRange):void 0}}ke.to=ve})(me||(e.DefinitionLink=me={}));var Ce;(function(ke){function Re(K){return{range:s.from(K.range),contents:q.fromMany(K.contents)}}ke.from=Re;function ve(K){return new a.Hover(K.contents.map(q.to),s.to(K.range))}ke.to=ve})(Ce||(e.Hover=Ce={}));var ye;(function(ke){function Re(K){return{range:s.from(K.range),expression:K.expression}}ke.from=Re;function ve(K){return new a.EvaluatableExpression(s.to(K.range),K.expression)}ke.to=ve})(ye||(e.EvaluatableExpression=ye={}));var Ee;(function(ke){function Re(K){if(K instanceof a.InlineValueText)return{type:"text",range:s.from(K.range),text:K.text};if(K instanceof a.InlineValueVariableLookup)return{type:"variable",range:s.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ke.from=Re;function ve(K){switch(K.type){case"text":return{range:s.to(K.range),text:K.text};case"variable":return{range:s.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:s.to(K.range),expression:K.expression}}}ke.to=ve})(Ee||(e.InlineValue=Ee={}));var Ie;(function(ke){function Re(K){return{frameId:K.frameId,stoppedLocation:s.from(K.stoppedLocation)}}ke.from=Re;function ve(K){return new a.InlineValueContext(K.frameId,s.to(K.stoppedLocation))}ke.to=ve})(Ie||(e.InlineValueContext=Ie={}));var oe;(function(ke){function Re(K){return{range:s.from(K.range),kind:K.kind}}ke.from=Re;function ve(K){return new a.DocumentHighlight(s.to(K.range),K.kind)}ke.to=ve})(oe||(e.DocumentHighlight=oe={}));var ce;(function(ke){function Re(ve){switch(ve){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}ke.to=Re})(ce||(e.CompletionTriggerKind=ce={}));var ie;(function(ke){function Re(ve){return{triggerKind:ce.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}ke.to=Re})(ie||(e.CompletionContext=ie={}));var ne;(function(ke){function Re(K){switch(K){case a.CompletionItemTag.Deprecated:return 1}}ke.from=Re;function ve(K){switch(K){case 1:return a.CompletionItemTag.Deprecated}}ke.to=ve})(ne||(e.CompletionItemTag=ne={}));var C;(function(ke){const Re=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ve(Be){return Re.get(Be)??9}ke.from=ve;const K=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Oe(Be){return K.get(Be)??a.CompletionItemKind.Property}ke.to=Oe})(C||(e.CompletionItemKind=C={}));var z;(function(ke){function Re(ve,K){const Oe=new a.CompletionItem(ve.label);return Oe.insertText=ve.insertText,Oe.kind=C.to(ve.kind),Oe.tags=ve.tags?.map(ne.to),Oe.detail=ve.detail,Oe.documentation=A.isMarkdownString(ve.documentation)?q.to(ve.documentation):ve.documentation,Oe.sortText=ve.sortText,Oe.filterText=ve.filterText,Oe.preselect=ve.preselect,Oe.commitCharacters=ve.commitCharacters,p.Range.isIRange(ve.range)?Oe.range=s.to(ve.range):typeof ve.range=="object"&&(Oe.range={inserting:s.to(ve.range.insert),replacing:s.to(ve.range.replace)}),Oe.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Oe.insertText=new a.SnippetString(ve.insertText):(Oe.insertText=ve.insertText,Oe.textEdit=Oe.range instanceof a.Range?new a.TextEdit(Oe.range,Oe.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Oe.additionalTextEdits=ve.additionalTextEdits.map(Be=>pe.to(Be))),Oe.command=K&&ve.command?K.fromInternal(ve.command):void 0,Oe}ke.to=Re})(z||(e.CompletionItem=z={}));var V;(function(ke){function Re(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:q.fromStrict(K.documentation)}}ke.from=Re;function ve(K){return{label:K.label,documentation:A.isMarkdownString(K.documentation)?q.to(K.documentation):K.documentation}}ke.to=ve})(V||(e.ParameterInformation=V={}));var j;(function(ke){function Re(K){return{label:K.label,documentation:q.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(V.from):[],activeParameter:K.activeParameter}}ke.from=Re;function ve(K){return{label:K.label,documentation:A.isMarkdownString(K.documentation)?q.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(V.to):[],activeParameter:K.activeParameter}}ke.to=ve})(j||(e.SignatureInformation=j={}));var ae;(function(ke){function Re(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(j.from):[]}}ke.from=Re;function ve(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(j.to):[]}}ke.to=ve})(ae||(e.SignatureHelp=ae={}));var ge;(function(ke){function Re(ve,K){const Oe=new a.InlayHint(I.to(K.position),typeof K.label=="string"?K.label:K.label.map(ee.to.bind(void 0,ve)),K.kind&&be.to(K.kind));return Oe.textEdits=K.textEdits&&K.textEdits.map(pe.to),Oe.tooltip=A.isMarkdownString(K.tooltip)?q.to(K.tooltip):K.tooltip,Oe.paddingLeft=K.paddingLeft,Oe.paddingRight=K.paddingRight,Oe}ke.to=Re})(ge||(e.InlayHint=ge={}));var ee;(function(ke){function Re(ve,K){const Oe=new a.InlayHintLabelPart(K.label);return Oe.tooltip=A.isMarkdownString(K.tooltip)?q.to(K.tooltip):K.tooltip,u.Command.is(K.command)&&(Oe.command=ve.fromInternal(K.command)),K.location&&(Oe.location=X.to(K.location)),Oe}ke.to=Re})(ee||(e.InlayHintLabelPart=ee={}));var be;(function(ke){function Re(K){return K}ke.from=Re;function ve(K){return K}ke.to=ve})(be||(e.InlayHintKind=be={}));var Se;(function(ke){function Re(K){return{range:s.from(K.range),url:K.target,tooltip:K.tooltip}}ke.from=Re;function ve(K){let Oe;if(K.url)try{Oe=typeof K.url=="string"?_.URI.parse(K.url,!0):_.URI.revive(K.url)}catch{}return new a.DocumentLink(s.to(K.range),Oe)}ke.to=ve})(Se||(e.DocumentLink=Se={}));var xe;(function(ke){function Re(K){const Oe=new a.ColorPresentation(K.label);return K.textEdit&&(Oe.textEdit=pe.to(K.textEdit)),K.additionalTextEdits&&(Oe.additionalTextEdits=K.additionalTextEdits.map(Be=>pe.to(Be))),Oe}ke.to=Re;function ve(K){return{label:K.label,textEdit:K.textEdit?pe.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Oe=>pe.from(Oe)):void 0}}ke.from=ve})(xe||(e.ColorPresentation=xe={}));var He;(function(ke){function Re(K){return new a.Color(K[0],K[1],K[2],K[3])}ke.to=Re;function ve(K){return[K.red,K.green,K.blue,K.alpha]}ke.from=ve})(He||(e.Color=He={}));var et;(function(ke){function Re(K){return{range:s.from(K.range)}}ke.from=Re;function ve(K){return new a.SelectionRange(s.to(K.range))}ke.to=ve})(et||(e.SelectionRange=et={}));var Qe;(function(ke){function Re(ve){switch(ve){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}ke.to=Re})(Qe||(e.TextDocumentSaveReason=Qe={}));var Ye;(function(ke){function Re(K){switch(K){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}ke.from=Re;function ve(K){switch(K){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}ke.to=ve})(Ye||(e.TextEditorLineNumbersStyle=Ye={}));var rt;(function(ke){function Re(K){if(K===a.EndOfLine.CRLF)return 1;if(K===a.EndOfLine.LF)return 0}ke.from=Re;function ve(K){if(K===1)return a.EndOfLine.CRLF;if(K===0)return a.EndOfLine.LF}ke.to=ve})(rt||(e.EndOfLine=rt={}));var lt;(function(ke){function Re(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ke.from=Re})(lt||(e.ProgressLocation=lt={}));var Me;(function(ke){function Re(K){const Oe={start:K.start+1,end:K.end+1};return K.kind&&(Oe.kind=st.from(K.kind)),Oe}ke.from=Re;function ve(K){const Oe={start:K.start-1,end:K.end-1};return K.kind&&(Oe.kind=st.to(K.kind)),Oe}ke.to=ve})(Me||(e.FoldingRange=Me={}));var st;(function(ke){function Re(K){if(K)switch(K){case a.FoldingRangeKind.Comment:return u.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return u.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return u.FoldingRangeKind.Region}}ke.from=Re;function ve(K){if(K)switch(K.value){case u.FoldingRangeKind.Comment.value:return a.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports.value:return a.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region.value:return a.FoldingRangeKind.Region}}ke.to=ve})(st||(e.FoldingRangeKind=st={}));var Z;(function(ke){function Re(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?s.from(ve.selection):void 0,override:typeof ve.override=="boolean"?d.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ke.from=Re})(Z||(e.TextEditorOpenOptions=Z={}));var Y;(function(ke){function Re(Be){return Be instanceof a.RelativePattern?Be.toJSON():typeof Be=="string"?Be:ve(Be)||K(Be)?new a.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}ke.from=Re;function ve(Be){const Ge=Be;return Ge?_.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function K(Be){const Ge=Be;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Oe(Be){return typeof Be=="string"?Be:new a.RelativePattern(_.URI.revive(Be.baseUri),Be.pattern)}ke.to=Oe})(Y||(e.GlobPattern=Y={}));var _e;(function(ke){function Re(ve){if(ve){if(Array.isArray(ve))return ve.map(Re);if(typeof ve=="string")return ve;{const K=ve;return{language:K.language,scheme:K.scheme,pattern:Y.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}ke.from=Re})(_e||(e.LanguageSelector=_e={}));var Ne;(function(ke){function Re(K){return{start:K.start,end:K.end}}ke.from=Re;function ve(K){return new a.NotebookRange(K.start,K.end)}ke.to=ve})(Ne||(e.NotebookRange=Ne={}));var ze;(function(ke){function Re(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ke.to=Re;function ve(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ke.from=ve})(ze||(e.NotebookCellExecutionSummary=ze={}));var Xe;(function(ke){function Re(ve){if(ve===y.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(ve===y.NotebookCellExecutionState.Pending)return;if(ve===y.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}ke.to=Re})(Xe||(e.NotebookCellExecutionState=Xe={}));var We;(function(ke){function Re(K){switch(K){case a.NotebookCellKind.Markup:return y.CellKind.Markup;case a.NotebookCellKind.Code:default:return y.CellKind.Code}}ke.from=Re;function ve(K){switch(K){case y.CellKind.Markup:return a.NotebookCellKind.Markup;case y.CellKind.Code:default:return a.NotebookCellKind.Code}}ke.to=ve})(We||(e.NotebookCellKind=We={}));var it;(function(ke){function Re(K){const Oe={metadata:K.metadata??Object.create(null),cells:[]};for(const Be of K.cells)a.NotebookCellData.validate(Be),Oe.cells.push(wt.from(Be));return Oe}ke.from=Re;function ve(K){const Oe=new a.NotebookData(K.cells.map(wt.to));return(0,g.isEmptyObject)(K.metadata)||(Oe.metadata=K.metadata),Oe}ke.to=ve})(it||(e.NotebookData=it={}));var wt;(function(ke){function Re(K){return{cellKind:We.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:ze.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(kt.from):[]}}ke.from=Re;function ve(K){return new a.NotebookCellData(We.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(kt.to):void 0,K.metadata,K.internalMetadata?ze.to(K.internalMetadata):void 0)}ke.to=ve})(wt||(e.NotebookCellData=wt={}));var St;(function(ke){function Re(K){return{mime:K.mime,valueBytes:T.VSBuffer.wrap(K.data)}}ke.from=Re;function ve(K){return new a.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}ke.to=ve})(St||(e.NotebookCellOutputItem=St={}));var kt;(function(ke){function Re(K){return{outputId:K.id,items:K.items.map(St.from),metadata:K.metadata}}ke.from=Re;function ve(K){const Oe=K.items.map(St.to);return new a.NotebookCellOutput(Oe,K.outputId,K.metadata)}ke.to=ve})(kt||(e.NotebookCellOutput=kt={}));var $t;(function(ke){function Re(Oe){return K(Oe)?{include:(0,g.withNullAsUndefined)(Y.from(Oe.include)),exclude:(0,g.withNullAsUndefined)(Y.from(Oe.exclude))}:(0,g.withNullAsUndefined)(Y.from(Oe))}ke.from=Re;function ve(Oe){return K(Oe)?{include:Y.to(Oe.include),exclude:Y.to(Oe.exclude)}:Y.to(Oe)}ke.to=ve;function K(Oe){const Be=Oe;return Be?!(0,g.isUndefinedOrNull)(Be.include)&&!(0,g.isUndefinedOrNull)(Be.exclude):!1}})($t||(e.NotebookExclusiveDocumentPattern=$t={}));var bt;(function(ke){function Re(ve,K,Oe){const Be=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Be,Oe),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}ke.from=Re})(bt||(e.NotebookStatusBarItem=bt={}));var Bt;(function(ke){function Re(ve,K,Oe){const Be=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:K.toInternal(Be,Oe),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}ke.from=Re})(Bt||(e.NotebookKernelSourceAction=Bt={}));var Mt;(function(ke){function Re(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}ke.from=Re})(Mt||(e.NotebookDocumentContentOptions=Mt={}));var jt;(function(ke){function Re(K){return{uri:K.uri,provides:K.provides}}ke.from=Re;function ve(K){return new a.NotebookRendererScript(_.URI.revive(K.uri),K.provides)}ke.to=ve})(jt||(e.NotebookRendererScript=jt={}));var Wt;(function(ke){function Re(K){return{message:q.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:s.from(K.location.range),uri:K.location.uri}}}ke.from=Re;function ve(K){const Oe=new a.TestMessage(typeof K.message=="string"?K.message:q.to(K.message));return Oe.actualOutput=K.actual,Oe.expectedOutput=K.expected,Oe.location=K.location?X.to(K.location):void 0,Oe}ke.to=ve})(Wt||(e.TestMessage=Wt={}));var Tt;(function(ke){ke.namespace=v.namespaceTestTag,ke.denamespace=v.denamespaceTestTag})(Tt||(e.TestTag=Tt={}));var at;(function(ke){function Re(K){const Oe=(0,o.getPrivateApiFor)(K).controllerId;return{extId:k.TestId.fromExtHostTestItem(K,Oe).toString(),label:K.label,uri:_.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Be=>Tt.namespace(Oe,Be.id)),range:p.Range.lift(s.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&q.fromStrict(K.error)||null}}ke.from=Re;function ve(K){return{parent:void 0,error:void 0,id:k.TestId.fromString(K.extId).localId,label:K.label,uri:_.URI.revive(K.uri),tags:(K.tags||[]).map(Oe=>{const{tagId:Be}=Tt.denamespace(Oe);return new a.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:s.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}ke.toPlain=ve})(at||(e.TestItem=at={})),function(ke){function Re(K){return{id:K.id}}ke.from=Re;function ve(K){return new a.TestTag(K.id)}ke.to=ve}(Tt||(e.TestTag=Tt={}));var gt;(function(ke){const Re=(K,Oe)=>{const Be=[];for(const[$e,tt]of Oe)k.TestId.compare(tt.item.extId,$e)===2&&(Oe.delete($e),Be.push(tt));const Ge={...at.toPlain(K.item),parent:void 0,taskStates:K.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(tt=>tt.type===0).map(Wt.to)})),children:Be.map($e=>Re($e,Oe))};for(const $e of Ge.children)$e.parent=Ge;return Ge};function ve(K){const Oe=[],Be=new Map;for(const Ge of K.items){Be.set(Ge.item.extId,Ge);const $e=k.TestId.root(Ge.item.extId);K.request.targets.some(tt=>tt.controllerId===$e&&tt.testIds.includes(Ge.item.extId))&&Oe.push(Ge)}return{completedAt:K.completedAt,results:Oe.map(Ge=>Re(Ge,Be))}}ke.to=ve})(gt||(e.TestResults=gt={}));var zt;(function(ke){function Re(Be){return{covered:Be.covered,total:Be.covered}}function ve(Be){return"line"in Be?I.from(Be):s.from(Be)}function K(Be){return"branches"in Be?{count:Be.executionCount,location:ve(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ve(Ge.location)})):void 0}:{type:0,count:Be.executionCount,location:ve(Be.location)}}ke.fromDetailed=K;function Oe(Be){return{uri:Be.uri,statement:Re(Be.statementCoverage),branch:Be.branchCoverage&&Re(Be.branchCoverage),function:Be.functionCoverage&&Re(Be.functionCoverage),details:Be.detailedCoverage?.map(K)}}ke.fromFile=Oe})(zt||(e.TestCoverage=zt={}));var Nt;(function(ke){function Re(ve){switch(ve){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}ke.to=Re})(Nt||(e.CodeActionTriggerKind=Nt={}));var It;(function(ke){function Re(K){const Oe=new a.TypeHierarchyItem(he.to(K.kind),K.name,K.detail||"",_.URI.revive(K.uri),s.to(K.range),s.to(K.selectionRange));return Oe._sessionId=K._sessionId,Oe._itemId=K._itemId,Oe}ke.to=Re;function ve(K,Oe,Be){if(Oe=Oe??K._sessionId,Be=Be??K._itemId,Oe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Be,kind:he.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:s.from(K.range),selectionRange:s.from(K.selectionRange),tags:K.tags?.map(de.from)}}ke.from=ve})(It||(e.TypeHierarchyItem=It={}));var ht;(function(ke){function Re(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}ke.from=Re})(ht||(e.ViewBadge=ht={}));var Ct;(function(ke){function Re(Be,Ge,$e){const tt=Ge.fileData;return tt?new class extends a.DataTransferItem{asFile(){return new a.DataTransferFile(tt.name,_.URI.revive(tt.uri),Ge.id,(0,F.once)(()=>$e()))}}("",Ge.id):Be===R.Mimes.uriList&&Ge.uriListData?new a.DataTransferItem(Oe(Ge.uriListData)):new a.DataTransferItem(Ge.asString)}ke.to=Re;async function ve(Be,Ge){const $e=await Ge.asString();if(Be===R.Mimes.uriList)return{id:Ge.id,asString:$e,fileData:void 0,uriListData:K($e)};const tt=Ge.asFile();return{id:Ge.id,asString:$e,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}ke.from=ve;function K(Be){return D.UriList.split(Be).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return _.URI.parse(Ge)}catch{}return Ge})}function Oe(Be){return D.UriList.create(Be.map(Ge=>typeof Ge=="string"?Ge:_.URI.revive(Ge)))}})(Ct||(e.DataTransferItem=Ct={}));var Ot;(function(ke){function Re(K,Oe){const Be=K.items.map(([Ge,$e])=>[Ge,Ct.to(Ge,$e,()=>Oe($e.id))]);return new a.DataTransfer(Be)}ke.toDataTransfer=Re;async function ve(K){const Oe={items:[]},Be=[];return K.forEach((Ge,$e)=>{Be.push((async()=>{Oe.items.push([$e,await Ct.from($e,Ge)])})())}),await Promise.all(Be),Oe}ke.toDataTransferDTO=ve})(Ot||(e.DataTransfer=Ot={}));var Pt;(function(ke){function Re(K){return{message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}ke.to=Re;function ve(K){return{kind:"reply",message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}ke.from=ve})(Pt||(e.InteractiveSessionReplyFollowup=Pt={}));var Ke;(function(ke){function Re(ve){return typeof ve=="string"?{title:ve,message:ve,kind:"reply"}:"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",args:ve.args}:Pt.from(ve)}ke.from=Re})(Ke||(e.InteractiveSessionFollowup=Ke={}))}),define(Te[203],Pe([1,0,2,9,7,8,170]),function(te,e,n,T,D,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(h,R,b,g={timeout:1500,errors:3}){this._logService=h,this._documents=R,this._mainThreadBulkEdits=b,this._thresholds=g,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(h){return(R,b,g)=>{const p={dispose:this._callbacks.push([R,b,h])};return Array.isArray(g)&&g.push(p),p}}async $participateInSave(h,R){const b=n.URI.revive(h);let g=!1;const _=setTimeout(()=>g=!0,this._thresholds.timeout),p=[];try{for(const u of[...this._callbacks]){if(g)break;const t=this._documents.getDocument(b),o=await this._deliverEventAsyncAndBlameBadListeners(u,{document:t,reason:F.TextDocumentSaveReason.to(R)});p.push(o)}}finally{clearTimeout(_)}return p}_deliverEventAsyncAndBlameBadListeners([h,R,b],g){const _=this._badListeners.get(h);return typeof _=="number"&&_>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,h,R,g).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const u=this._badListeners.get(h);this._badListeners.set(h,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(h,R,b,g){const _=[],p=Date.now(),{document:u,reason:t}=g,{version:o}=u,d=Object.freeze({document:u,reason:t,waitUntil(y){if(Object.isFrozen(_))throw(0,T.illegalState)("waitUntil can not be called async");_.push(Promise.resolve(y))}});try{R.apply(b,[d])}catch(y){return Promise.reject(y)}return Object.freeze(_),new Promise((y,k)=>{const v=setTimeout(()=>k(new Error("timeout")),this._thresholds.timeout);return Promise.all(_).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(v),y(i)}).catch(i=>{clearTimeout(v),k(i)})}).then(y=>{const k={edits:[]};for(const v of y)if(Array.isArray(v)&&v.every(i=>i instanceof D.TextEdit))for(const{newText:i,newEol:a,range:r}of v)k.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:r&&F.Range.from(r),text:i,eol:a&&F.EndOfLine.from(a)}});if(k.edits.length!==0)return o===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(k):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(Te[204],Pe([1,0,15,2,8,7,73]),function(te,e,n,T,D,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(b,g,_,p){this.start=b,this.deletedCount=g,this.deletedItems=_,this.items=p}asApiEvent(){return{range:new F.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(b=>b.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(b,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:b}}constructor(b,g,_){this.notebook=b,this._extHostDocument=g,this._cellData=_,this.handle=_.handle,this.uri=T.URI.revive(_.uri),this.cellKind=_.cellKind,this._outputs=_.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=_.internalMetadata??{},this._metadata=Object.freeze(_.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(_.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const _={get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get mime(){return b._mime},set mime(p){b._mime=p},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}};this._apiCell=Object.freeze(_)}return this._apiCell}setOutputs(b){this._outputs=b.map(D.NotebookCellOutput.to)}setOutputItems(b,g,_){const p=_.map(D.NotebookCellOutputItem.to),u=this._outputs.find(t=>t.id===b);if(u&&(g||(u.items.length=0),u.items.push(...p),u.items.length>1&&u.items.every(t=>A.isTextStreamMime(t.mime)))){const t=new Map,o=[];u.items.forEach(d=>{let y;t.has(d.mime)?y=t.get(d.mime):(y=[],t.set(d.mime,y),o.push(d.mime)),y.push(d.data)}),u.items.length=0,o.forEach(d=>{const y=A.compressOutputItemStreams(t.get(d));u.items.push({mime:d,data:y.buffer})})}}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=S;class h{constructor(b,g,_,p,u){this._proxy=b,this._textDocumentsAndEditors=g,this._textDocuments=_,this.uri=p,this.handle=h._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=u.viewType,this._metadata=Object.freeze(u.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,u.cells]],!0,void 0),this._versionId=u.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this,g={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===n.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(_){return _=b._validateIndex(_),b._cells[_].apiCell},getCells(_){return(_?b._getCells(_):b._cells).map(u=>u.apiCell)},save(){return b._save()}};this._notebook=Object.freeze(g)}return this._notebook}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,g,_){this._versionId=b.versionId,this._isDirty=g,this.acceptDocumentPropertiesChanged({metadata:_});const p={notebook:this.apiNotebook,metadata:_,cellChanges:[],contentChanges:[]},u=[];for(const o of b.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1,p.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this._moveCells(o.index,o.length,o.newIdx,p.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(o.index,o.outputs),u.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems),u.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(o.index,o.language),u.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(o.index,o.metadata),u.push({cell:this._cells[o.index].apiCell,metadata:this._cells[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(o.index,o.internalMetadata),u.push({cell:this._cells[o.index].apiCell,executionSummary:this._cells[o.index].apiCell.executionSummary}));const t=new Map;for(let o=0;o<u.length;o++){const d=u[o],y=t.get(d.cell);if(y===void 0){const k=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...d});t.set(d.cell,k-1)}else p.cellChanges[y]={...p.cellChanges[y],...d}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let g=b.start|0,_=b.end|0;return g<0&&(g=0),_>this._cells.length&&(_=this._cells.length),b.with({start:g,end:_})}_getCells(b){b=this._validateRange(b);const g=[];for(let _=b.start;_<b.end;_++)g.push(this._cells[_]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,g,_){if(this._disposed)return;const p=[],u=[],t=[];if(b.reverse().forEach(o=>{const y=o[2].map(i=>{const a=new S(this,this._textDocumentsAndEditors,i);return g||u.push(S.asModelAddData(this.apiNotebook,i)),a}),k=new P(o[0],o[1],[],y),v=this._cells.splice(o[0],o[1],...y);for(const i of v)t.push(i.uri),k.deletedItems.push(i.apiCell);p.push(k)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:t}),_)for(const o of p)_.push(o.asApiEvent())}_moveCells(b,g,_,p){const u=this._cells.splice(b,g);this._cells.splice(_,0,...u);const t=[new P(b,g,u.map(o=>o.apiCell),[]),new P(_,0,[],u)];for(const o of t)p.push(o.asApiEvent())}_setCellOutputs(b,g){this._cells[b].setOutputs(g)}_setCellOutputItems(b,g,_,p){this._cells[b].setOutputItems(g,_,p)}_changeCellLanguage(b,g){const _=this._cells[b];_.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelLanguageChanged(_.uri,g)}_changeCellMime(b,g){const _=this._cells[b];_.apiCell.mime=g}_changeCellMetadata(b,g){this._cells[b].setMetadata(g)}_changeCellInternalMetadata(b,g){this._cells[b].setInternalMetadata(g)}getCellFromApiCell(b){return this._cells.find(g=>g.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(g=>g.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=h,h._handlePool=0}),define(Te[205],Pe([1,0,5,2,8,7]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class A{constructor(S,h,R,b={timeout:1500,errors:3}){this._logService=S,this._notebooksAndEditors=h,this._mainThreadBulkEdits=R,this._thresholds=b,this._onWillSaveNotebookDocumentEvent=new n.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(h,R,b)=>{const g=function(p){h.call(R,p)};return g.extension=S,this._onWillSaveNotebookDocumentEvent.event(g,void 0,b)}}async $participateInSave(S,h,R){const b=T.URI.revive(S),g=this._notebooksAndEditors.getNotebookDocument(b);if(!g)throw new Error("Unable to resolve notebook document");const _=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:g.apiNotebook,reason:D.TextDocumentSaveReason.to(h)},R,async(u,t)=>{const o=Date.now(),d=await await Promise.resolve(u);Date.now()-o>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&d&&(d instanceof F.WorkspaceEdit?_.push(d):this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(_.length===0)return!0;const p={edits:[]};for(const u of _){const{edits:t}=D.WorkspaceEdit.from(u);p.edits=p.edits.concat(t)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p)}}e.ExtHostNotebookDocumentSaveParticipant=A}),define(Te[103],Pe([1,0,9,8,7]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class F{constructor(P,S,h,R,b,g){this.id=P,this._proxy=S,this.notebookData=h,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=b,this._visibleRanges=R,this._viewColumn=g}get apiEditor(){if(!this._editor){const P=this;this._editor={get notebook(){return P.notebookData.apiNotebook},get selection(){return P._selections[0]},set selection(S){this.selections=[S]},get selections(){return P._selections},set selections(S){if(!Array.isArray(S)||!S.every(D.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");P._selections=S,P._trySetSelections(S)},get visibleRanges(){return P._visibleRanges},revealRange(S,h){P._proxy.$tryRevealRange(P.id,T.NotebookRange.from(S),h??D.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_trySetSelections(P){this._proxy.$trySetSelections(this.id,P.map(T.NotebookRange.from))}_acceptViewColumn(P){this._viewColumn=P}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(Te[206],Pe([1,0,9,5,14,8]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=e.ExtHostNotebookEditors=class{constructor(S,h){this._logService=S,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new T.Emitter({onListenerError:n.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter({onListenerError:n.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(S,h){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",S,h);const R=this._notebooksAndEditors.getEditorById(S);h.visibleRanges&&R._acceptVisibleRanges(h.visibleRanges.ranges.map(F.NotebookRange.to)),h.selections&&R._acceptSelections(h.selections.selections.map(F.NotebookRange.to)),h.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),h.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(S){for(const h in S)this._notebooksAndEditors.getEditorById(h)._acceptViewColumn(F.ViewColumn.to(S[h]))}};e.ExtHostNotebookEditors=A=je([Ve(0,D.ILogService)],A)}),define(Te[207],Pe([1,0,8,174,150,21,65,9]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(g){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=g}async withProgress(g,_,p){const u=this._handles++,{title:t,location:o,cancellable:d}=_,y={label:(0,D.localize)(0,null,g.displayName||g.name),id:g.identifier.value};return this._proxy.$startProgress(u,{location:n.ProgressLocation.from(o),title:t,source:y,cancellable:d},g.isUnderDevelopment?void 0:g.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(u,p,!!d)}_withProgress(g,_,p){let u;p&&(u=new F.CancellationTokenSource,this._mapHandleToCancellationSource.set(g,u));const t=d=>{this._proxy.$progressEnd(d),this._mapHandleToCancellationSource.delete(d),u?.dispose()};let o;try{o=_(new R(this._proxy,g),p&&u?u.token:F.CancellationToken.None)}catch(d){throw t(g),d}return o.then(d=>t(g),d=>t(g)),o}$acceptProgressCanceled(g){const _=this._mapHandleToCancellationSource.get(g);_&&(_.cancel(),this._mapHandleToCancellationSource.delete(g))}}e.ExtHostProgress=S;function h(b,g){return b.message=g.message,typeof g.increment=="number"&&(typeof b.increment=="number"?b.increment+=g.increment:b.increment=g.increment),b}class R extends T.Progress{constructor(g,_){super(p=>this.throttledReport(p)),this._proxy=g,this._handle=_}throttledReport(g){this._proxy.$progressReport(this._handle,g)}}je([(0,A.throttle)(100,(b,g)=>h(b,g),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Te[104],Pe([1,0,44,99,45,74,56,8,2]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const h=(y,k,v,i)=>{let a=k;return{enumerable:!0,configurable:!1,get(){return a},set(r){if(!v(a,r)){const s=a;a=r,y.listener?.(i(r,s))}}}},R=(y,k)=>y===k,b={range:(y,k)=>y===k?!0:!y||!k?!1:y.isEqual(k),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(y,k)=>!(y.length!==k.length||y.some(v=>!k.find(i=>v.id===i.id)))},g=y=>k=>({op:4,update:y(k)}),_=(y,k)=>({range:(()=>{let v;const i=g(a=>({range:n.Range.lift(P.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return v},set(a){y.listener?.({op:6}),b.range(v,a)||(v=a,y.listener?.(i(a)))}}})(),label:h(y,k,b.label,g(v=>({label:v}))),description:h(y,void 0,b.description,g(v=>({description:v}))),sortText:h(y,void 0,b.sortText,g(v=>({sortText:v}))),canResolveChildren:h(y,!1,b.canResolveChildren,v=>({op:2,state:v})),busy:h(y,!1,b.busy,g(v=>({busy:v}))),error:h(y,void 0,b.error,g(v=>({error:P.MarkdownString.fromStrict(v)||null}))),tags:h(y,[],b.tags,(v,i)=>({op:1,new:v.map(P.TestTag.from),old:i.map(P.TestTag.from)}))}),p=y=>{const k=D.TestId.fromString(y.extId),v=new t(k.controllerId,k.localId,y.label,S.URI.revive(y.uri)||void 0);return v.range=P.Range.to(y.range||void 0),v.description=y.description||void 0,v.sortText=y.sortText||void 0,v.tags=y.tags.map(i=>P.TestTag.to({id:(0,A.denamespaceTestTag)(i).tagId})),v},u=y=>{let k;for(const v of y.tests){const i=p(v.item);(0,T.getPrivateApiFor)(i).parent=k,k=i}return k};e.toItemFromContext=u;class t{constructor(k,v,i,a){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const r=(0,T.createPrivateApiFor)(this,k);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof o?void 0:r.parent}},children:{value:(0,F.createTestItemChildren)(r,T.getPrivateApiFor,t),enumerable:!0,writable:!1},..._(r,i)})}}e.TestItemImpl=t;class o extends t{constructor(k,v){super(k,k,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=o;class d extends F.TestItemCollection{constructor(k,v,i){super({controllerId:k,getDocumentVersion:a=>a&&i.getDocument(a)?.version,getApiFor:T.getPrivateApiFor,getChildren:a=>a.children,root:new o(k,v),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=d}),define(Te[105],Pe([1,0,49,9,84,8,7]),function(te,e,n,T,D,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class P{constructor(g,_,p){const u=P._Keys.nextId();g.$registerTextEditorDecorationType(_.identifier,u,F.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:u,dispose(){g.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=P,P._Keys=new D.IdGenerator("TextEditorDecorationType");class S{constructor(g,_){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=_.undoStopBefore,this._undoStopAfter=_.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,_){this._throwIfFinalized();let p=null;if(g instanceof A.Position)p=new A.Range(g,g);else if(g instanceof A.Range)p=g;else throw new Error("Unrecognized location");this._pushEdit(p,_,!1)}insert(g,_){this._throwIfFinalized(),this._pushEdit(new A.Range(g,g),_,!0)}delete(g){this._throwIfFinalized();let _=null;if(g instanceof A.Range)_=g;else throw new Error("Unrecognized location");this._pushEdit(_,null,!0)}_pushEdit(g,_,p){const u=this._document.validateRange(g);this._collectedEdits.push({range:u,text:_,forceMoveMarkers:p})}setEndOfLine(g){if(this._throwIfFinalized(),g!==A.EndOfLine.LF&&g!==A.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this._setEndOfLine=g}}class h{constructor(g,_,p,u){this._proxy=g,this._id=_,this._accept(p),this._logService=u;const t=this;this.value={get tabSize(){return t._tabSize},set tabSize(o){t._setTabSize(o)},get indentSize(){return t._indentSize},set indentSize(o){t._setIndentSize(o)},get insertSpaces(){return t._insertSpaces},set insertSpaces(o){t._setInsertSpaces(o)},get cursorStyle(){return t._cursorStyle},set cursorStyle(o){t._setCursorStyle(o)},get lineNumbers(){return t._lineNumbers},set lineNumbers(o){t._setLineNumbers(o)}}}_accept(g){this._tabSize=g.tabSize,this._indentSize=g.indentSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=F.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const _=Math.floor(g);return _>0?_:null}if(typeof g=="string"){const _=parseInt(g,10);return isNaN(_)?null:_>0?_:null}return null}_setTabSize(g){const _=this._validateTabSize(g);if(_!==null){if(typeof _=="number"){if(this._tabSize===_)return;this._tabSize=_}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:_}))}}_validateIndentSize(g){if(g==="tabSize")return"tabSize";if(typeof g=="number"){const _=Math.floor(g);return _>0?_:null}if(typeof g=="string"){const _=parseInt(g,10);return isNaN(_)?null:_>0?_:null}return null}_setIndentSize(g){const _=this._validateIndentSize(g);if(_!==null){if(typeof _=="number"){if(this._indentSize===_)return;this._indentSize=_}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:_}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:!!g}_setInsertSpaces(g){const _=this._validateInsertSpaces(g);if(typeof _=="boolean"){if(this._insertSpaces===_)return;this._insertSpaces=_}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:_}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:F.TextEditorLineNumbersStyle.from(g)})))}assign(g){const _={};let p=!1;if(typeof g.tabSize<"u"){const u=this._validateTabSize(g.tabSize);u==="auto"?(p=!0,_.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,p=!0,_.tabSize=u)}if(typeof g.indentSize<"u"){const u=this._validateIndentSize(g.indentSize);u==="tabSize"?(p=!0,_.indentSize=u):typeof u=="number"&&this._indentSize!==u&&(this._indentSize=u,p=!0,_.indentSize=u)}if(typeof g.insertSpaces<"u"){const u=this._validateInsertSpaces(g.insertSpaces);u==="auto"?(p=!0,_.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,p=!0,_.insertSpaces=u)}typeof g.cursorStyle<"u"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,p=!0,_.cursorStyle=g.cursorStyle),typeof g.lineNumbers<"u"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,p=!0,_.lineNumbers=F.TextEditorLineNumbersStyle.from(g.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,_))}_warnOnError(g,_){_.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=h;class R{constructor(g,_,p,u,t,o,d,y){this.id=g,this._proxy=_,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=t,this._options=new h(this._proxy,this.id,o,p),this._visibleRanges=d,this._viewColumn=y;const k=this;this.value=Object.freeze({get document(){return u.value},set document(v){throw(0,T.readonly)("document")},get selection(){return k._selections&&k._selections[0]},set selection(v){if(!(v instanceof A.Selection))throw(0,T.illegalArgument)("selection");k._selections=[v],k._trySetSelection()},get selections(){return k._selections},set selections(v){if(!Array.isArray(v)||v.some(i=>!(i instanceof A.Selection)))throw(0,T.illegalArgument)("selections");k._selections=v,k._trySetSelection()},get visibleRanges(){return k._visibleRanges},set visibleRanges(v){throw(0,T.readonly)("visibleRanges")},get options(){return k._options.value},set options(v){k._disposed||k._options.assign(v)},get viewColumn(){return k._viewColumn},set viewColumn(v){throw(0,T.readonly)("viewColumn")},edit(v,i={undoStopBefore:!0,undoStopAfter:!0}){if(k._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new S(u.value,i);return v(a),k._applyEdit(a)},insertSnippet(v,i,a={undoStopBefore:!0,undoStopAfter:!0}){if(k._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=k._selections.map(s=>F.Range.from(s));else if(i instanceof A.Position){const{lineNumber:s,column:w}=F.Position.from(i);r=[{startLineNumber:s,startColumn:w,endLineNumber:s,endColumn:w}]}else if(i instanceof A.Range)r=[F.Range.from(i)];else{r=[];for(const s of i)if(s instanceof A.Range)r.push(F.Range.from(s));else{const{lineNumber:w,column:I}=F.Position.from(s);r.push({startLineNumber:w,startColumn:I,endLineNumber:w,endColumn:I})}}return _.$tryInsertSnippet(g,u.value.version,v.value,r,a)},setDecorations(v,i){const a=i.length===0;a&&!k._hasDecorationsForKey.has(v.key)||(a?k._hasDecorationsForKey.delete(v.key):k._hasDecorationsForKey.add(v.key),k._runOnProxy(()=>{if(F.isDecorationOptionsArr(i))return _.$trySetDecorations(g,v.key,F.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let s=0,w=i.length;s<w;s++){const I=i[s];r[4*s]=I.start.line+1,r[4*s+1]=I.start.character+1,r[4*s+2]=I.end.line+1,r[4*s+3]=I.end.character+1}return _.$trySetDecorationsFast(g,v.key,r)}}))},revealRange(v,i){k._runOnProxy(()=>_.$tryRevealRange(g,F.Range.from(v),i||A.TextEditorRevealType.Default))},show(v){_.$tryShowEditor(g,F.ViewColumn.from(v))},hide(){_.$tryHideEditor(g)}})}dispose(){(0,n.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,n.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,n.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,n.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,n.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(F.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const _=g.finalize();if(_.edits.length===0&&!_.setEndOfLine)return Promise.resolve(!0);const p=_.edits.map(t=>t.range);p.sort((t,o)=>t.end.line===o.end.line?t.end.character===o.end.character?t.start.line===o.start.line?t.start.character-o.start.character:t.start.line-o.start.line:t.end.character-o.end.character:t.end.line-o.end.line);for(let t=0,o=p.length-1;t<o;t++){const d=p[t].end;if(p[t+1].start.isBefore(d))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=_.edits.map(t=>({range:F.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,u,{setEndOfLine:typeof _.setEndOfLine=="number"?F.EndOfLine.from(_.setEndOfLine):void 0,undoStopBefore:_.undoStopBefore,undoStopAfter:_.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,_=>(_ instanceof Error&&_.name==="DISPOSED"||this._logService.warn(_),null))}}e.ExtHostTextEditor=R}),define(Te[208],Pe([1,0,154,7,22,2,5,6,190,17,7,12,16,8,21,26,122]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(k,v){if((0,b.isString)(k))return{label:k};if(k&&typeof k=="object"&&typeof k.label=="string"){let i;return Array.isArray(k.highlights)&&(i=k.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),i=i.length?i:void 0),{label:k.label,highlights:i}}}class d{constructor(v,i,a){this._proxy=v,this.commands=i,this.logService=a,this.treeViews=new Map,this.treeDragAndDropService=new t.TreeViewsDnDService;function r(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:s=>r(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(w=>r(w)?this.convertArgument(w):w):s})}registerTreeDataProvider(v,i,a){const r=this.createTreeView(v,{treeDataProvider:i},a);return{dispose:()=>r.dispose()}}createTreeView(v,i,a){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=i.dragAndDropController?.dropMimeTypes??[],s=i.dragAndDropController?.dragMimeTypes??[],w=!!i.dragAndDropController?.handleDrag,I=!!i.dragAndDropController?.handleDrop,c=this.createExtHostTreeView(v,i,a),l=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:r,dragMimeTypes:s,hasHandleDrag:w,hasHandleDrop:I});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,u.checkProposedApiEnabled)(a,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(m){c.message=m},get title(){return c.title},set title(m){c.title=m},get description(){return c.description},set description(m){c.description=m},get badge(){return c.badge},set badge(m){m!==void 0&&R.ViewBadge.isViewBadge(m)?c.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(c.badge=void 0)},reveal:(m,E)=>c.reveal(m,E),dispose:async()=>{await l,this.treeViews.delete(v),c.dispose()}}}$getChildren(v,i){const a=this.treeViews.get(v);return a?a.getChildren(i):Promise.reject(new S.NoTreeViewError(v))}async $handleDrop(v,i,a,r,s,w,I,c){const l=this.treeViews.get(v);if(!l)return Promise.reject(new S.NoTreeViewError(v));const m=_.DataTransfer.toDataTransfer(a,async E=>(await this._proxy.$resolveDropFileData(v,i,E)).buffer);return I===v&&c&&await this.addAdditionalTransferItems(m,l,c,s,w),l.onDrop(m,r,s)}async addAdditionalTransferItems(v,i,a,r,s){const w=this.treeDragAndDropService.removeDragOperationTransfer(s);if(w)(await w)?.forEach((I,c)=>{I&&v.set(c,I)});else if(s&&i.handleDrag){const I=i.handleDrag(a,v,r);this.treeDragAndDropService.addDragOperationTransfer(s,I),await I}return v}async $handleDrag(v,i,a,r){const s=this.treeViews.get(v);if(!s)return Promise.reject(new S.NoTreeViewError(v));const w=await this.addAdditionalTransferItems(new T.DataTransfer,s,i,r,a);if(w)return _.DataTransfer.toDataTransferDTO(w)}async $hasResolve(v){const i=this.treeViews.get(v);if(!i)throw new S.NoTreeViewError(v);return i.hasResolve}$resolve(v,i,a){const r=this.treeViews.get(v);if(!r)throw new S.NoTreeViewError(v);return r.resolveTreeItem(i,a)}$setExpanded(v,i,a){const r=this.treeViews.get(v);if(!r)throw new S.NoTreeViewError(v);r.setExpanded(i,a)}$setSelection(v,i){const a=this.treeViews.get(v);if(!a)throw new S.NoTreeViewError(v);a.setSelection(i)}$setFocus(v,i){const a=this.treeViews.get(v);if(!a)throw new S.NoTreeViewError(v);a.setFocus(i)}$setVisible(v,i){const a=this.treeViews.get(v);if(!a)throw new S.NoTreeViewError(v);a.setVisible(i)}$changeCheckboxState(v,i){const a=this.treeViews.get(v);if(!a)throw new S.NoTreeViewError(v);a.setCheckboxState(i)}createExtHostTreeView(v,i,a){const r=new y(v,i,this._proxy,this.commands.converter,this.logService,a);return this.treeViews.set(v,r),r}convertArgument(v){const i=this.treeViews.get(v.$treeViewId);return i&&"$treeItemHandle"in v?i.getExtensionElement(v.$treeItemHandle):i&&"$focusedTreeItem"in v&&v.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=d;class y extends P.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,b.isUndefinedOrNull)(v))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(v,i,a,r,s,w){if(super(),this.viewId=v,this.proxy=a,this.commands=r,this.logService=s,this.extension=w,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new A.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,w.contributes&&w.contributes.views)for(const l in w.contributes.views)for(const m of w.contributes.views[l])m.id===v&&(this._title=m.name);this.dataProvider=i.treeDataProvider,this.dndController=i.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let I,c;this._register(A.Event.debounce(this._onDidChangeData.event,(l,m)=>(l||(l={message:!1,elements:[]}),m.element!==!1&&(I||(I=new Promise(E=>c=E),this.refreshPromise=this.refreshPromise.then(()=>I)),Array.isArray(m.element)?l.elements.push(...m.element):l.elements.push(m.element)),m.message&&(l.message=!0),l),200,!0)(({message:l,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const E=c;return I=null,this.refresh(m).then(()=>E())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(v){const i=v?this.getExtensionElement(v):void 0;if(v&&!i)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let a=this.getChildrenNodes(v);return a||(a=await this.fetchChildrenNodes(i)),a?a.map(r=>r.item):void 0}getExtensionElement(v){return this.elements.get(v)}reveal(v,i){i=i||{select:!0,focus:!1};const a=(0,b.isUndefinedOrNull)(i.select)?!0:i.select,r=(0,b.isUndefinedOrNull)(i.focus)?!1:i.focus,s=(0,b.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(w=>this.resolveTreeNode(v,w[w.length-1]).then(I=>this.proxy.$reveal(this.viewId,{item:I.item,parentChain:w.map(c=>c.item)},{select:a,focus:r,expand:s})),w=>this.logService.error(w)):this.proxy.$reveal(this.viewId,void 0,{select:a,focus:r,expand:s})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}get badge(){return this._badge}set badge(v){this._badge?.value===v?.value&&this._badge?.tooltip===v?.tooltip||(this._badge=_.ViewBadge.from(v),this.proxy.$setBadge(this.viewId,v))}setExpanded(v,i){const a=this.getExtensionElement(v);a&&(i?this._onDidExpandElement.fire(Object.freeze({element:a})):this._onDidCollapseElement.fire(Object.freeze({element:a})))}setSelection(v){(0,g.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this._focusedHandle=v}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(v){const i=(await Promise.all(v.map(async a=>{const r=this.getExtensionElement(a.treeItemHandle);return r?{extensionItem:r,treeItem:await this.dataProvider.getTreeItem(r),newState:a.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);i.forEach(a=>{a.treeItem.checkboxState=a.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:i.map(a=>[a.extensionItem,a.newState])})}async handleDrag(v,i,a){const r=[];for(const s of v){const w=this.getExtensionElement(s);w&&r.push(w)}if(!(!this.dndController?.handleDrag||r.length===0))return await this.dndController.handleDrag(r,i,a),i}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(v,i,a){const r=i?this.getExtensionElement(i):void 0;if(!(!r&&i||!this.dndController?.handleDrop))return(0,h.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(r,v,a):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,i){if(!this.dataProvider.resolveTreeItem)return;const a=this.elements.get(v);if(a){const r=this.nodes.get(a);if(r){const s=await this.dataProvider.resolveTreeItem(r.extensionItem,a,i)??r.extensionItem;return this.validateTreeItem(s),r.item.tooltip=this.getTooltip(s.tooltip),r.item.command=this.getCommand(r.disposableStore,s.command),r.item}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(i=>i?this.resolveUnknownParentChain(i).then(a=>this.resolveTreeNode(i,a[a.length-1]).then(r=>(a.push(r),a))):Promise.resolve([]))}resolveParent(v){const i=this.nodes.get(v);return i?Promise.resolve(i.parent?this.elements.get(i.parent.item.handle):void 0):(0,h.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,i){const a=this.nodes.get(v);return a?Promise.resolve(a):(0,h.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(r=>this.createHandle(v,r,i,!0)).then(r=>this.getChildren(i?i.item.handle:void 0).then(()=>{const s=this.getExtensionElement(r);if(s){const w=this.nodes.get(s);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(v){if(v){let i;if(typeof v=="string"){const a=this.getExtensionElement(v);i=a?this.nodes.get(a):void 0}else i=v;return i&&i.children||void 0}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const i=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const a=v?this.nodes.get(v):void 0,r=await this.dataProvider.getChildren(v);if(i.token.isCancellationRequested)return;const s=await Promise.all((0,g.coalesce)(r||[]).map(async w=>{const I=await this.dataProvider.getTreeItem(w);return I&&!i.token.isCancellationRequested?this.createAndRegisterTreeNode(w,I,a):null}));return i.token.isCancellationRequested?void 0:(0,g.coalesce)(s)}finally{i.dispose()}}refresh(v){if(v.some(a=>!a))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const a=this.getHandlesToRefresh(v);if(a.length)return this.refreshHandles(a)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const i=new Set,a=v.map(s=>this.nodes.get(s));for(const s of a)if(s&&!i.has(s.item.handle)){let w=s;for(;w&&w.parent&&a.findIndex(I=>w&&w.parent&&I&&I.item.handle===w.parent.item.handle)===-1;){const I=this.elements.get(w.parent.item.handle);w=I?this.nodes.get(I):void 0}w&&!w.parent&&i.add(s.item.handle)}const r=[];return i.forEach(s=>{const w=this.elements.get(s);if(w){const I=this.nodes.get(w);I&&(!I.parent||!i.has(I.parent.item.handle))&&r.push(s)}}),r}refreshHandles(v){const i={};return Promise.all(v.map(a=>this.refreshNode(a).then(r=>{r&&(i[a]=r.item)}))).then(()=>Object.keys(i).length?this.proxy.$refresh(this.viewId,i):void 0)}refreshNode(v){const i=this.getExtensionElement(v);if(i){const a=this.nodes.get(i);if(a)return this.clearChildren(i),(0,h.asPromise)(()=>this.dataProvider.getTreeItem(i)).then(r=>{if(r){const s=this.createTreeNode(i,r,a.parent);return this.updateNodeCache(i,s,a,a.parent),a.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,i,a){const r=this.createTreeNode(v,i,a);if(i.id&&this.elements.has(r.item.handle))throw new Error((0,n.localize)(0,null,i.id));return this.addNodeToCache(v,r),this.addNodeToParentCache(r,a),r}getTooltip(v){return R.MarkdownString.isMarkdownString(v)?_.MarkdownString.from(v):v}getCommand(v,i){return i?{...this.commands.toInternal(i,v),originalId:i.command}:void 0}getCheckbox(v){if(!v.checkboxState)return;let i,a;return typeof v.checkboxState=="number"?i=v.checkboxState:(i=v.checkboxState.state,a=v.checkboxState.tooltip),{isChecked:i===R.TreeItemCheckboxState.Checked,tooltip:a}}validateTreeItem(v){if(!R.TreeItem.isTreeItem(v,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(v,i,a){this.validateTreeItem(i);const r=new P.DisposableStore,s=this.createHandle(v,i,a),w=this.getLightIconPath(i);return{item:{handle:s,parentHandle:a?a.item.handle:void 0,label:o(i.label,this.extension),description:i.description,resourceUri:i.resourceUri,tooltip:this.getTooltip(i.tooltip),command:this.getCommand(r,i.command),contextValue:i.contextValue,icon:w,iconDark:this.getDarkIconPath(i)||w,themeIcon:this.getThemeIcon(i),collapsibleState:(0,b.isUndefinedOrNull)(i.collapsibleState)?R.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.getCheckbox(i)},extensionItem:i,parent:a,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(v){return v.iconPath instanceof R.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:i,label:a,resourceUri:r},s,w){if(i)return`${y.ID_HANDLE_PREFIX}/${i}`;const I=o(a,this.extension),c=s?s.item.handle:y.LABEL_HANDLE_PREFIX;let l=I?I.label:r?(0,D.basename)(r):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const m=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,E=this.getChildrenNodes(s)||[];let f,L=0;do{if(f=`${c}/${L}:${l}`,w||!this.elements.has(f)||m===f)break;L++}while(L<=E.length);return f}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof R.ThemeIcon))return typeof v.iconPath=="string"||F.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof R.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return F.URI.isUri(v)?v:F.URI.file(v)}addNodeToCache(v,i){this.elements.set(i.item.handle,v),this.nodes.set(v,i)}updateNodeCache(v,i,a,r){this.elements.delete(i.item.handle),this.nodes.delete(v),i.item.handle!==a.item.handle&&this.elements.delete(a.item.handle),this.addNodeToCache(v,i);const s=this.getChildrenNodes(r)||[],w=s.filter(I=>I.item.handle===a.item.handle)[0];w&&s.splice(s.indexOf(w),1,i)}addNodeToParentCache(v,i){i?(i.children||(i.children=[]),i.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const i=this.nodes.get(v);if(i){if(i.children)for(const a of i.children){const r=this.elements.get(a.item.handle);r&&this.clear(r)}i.children=void 0}}else this.clearAll()}clear(v){const i=this.nodes.get(v);if(i){if(i.children)for(const a of i.children){const r=this.elements.get(a.item.handle);r&&this.clear(r)}this.nodes.delete(v),this.elements.delete(i.item.handle),i.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}y.LABEL_HANDLE_PREFIX="0",y.ID_HANDLE_PREFIX="1"}),define(Te[209],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",getSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.getSessions.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Te[210],Pe([1,0,163,9,29,91,71,30,24,209,173,97]),function(te,e,n,T,D,F,A,P,S,h,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const g=P.Registry.as(A.Extensions.JSONContribution);class _{constructor(v,i,a){this._messageHandler=v,this._extension=i,this._extensionPointId=a}_msg(v,i){this._messageHandler({type:v,message:i,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(v){this._msg(D.default.Error,v)}warn(v){this._msg(D.default.Warning,v)}info(v){this._msg(D.default.Info,v)}}e.ExtensionMessageCollector=_;class p{static _toSet(v){const i=new S.ExtensionIdentifierSet;for(let a=0,r=v.length;a<r;a++)i.add(v[a].description.identifier);return i}static compute(v,i){if(!v||!v.length)return new p(i,[]);if(!i||!i.length)return new p([],v);const a=this._toSet(v),r=this._toSet(i),s=i.filter(I=>!a.has(I.description.identifier)),w=v.filter(I=>!r.has(I.description.identifier));return new p(s,w)}constructor(v,i){this.added=v,this.removed=i}}e.ExtensionPointUserDelta=p;class u{constructor(v,i){this.name=v,this.defaultExtensionKind=i,this._handler=null,this._users=null,this._delta=null}setHandler(v){if(this._handler!==null)throw new Error("Handler already set!");this._handler=v,this._handle()}acceptUsers(v){this._delta=p.compute(this._users,v),this._users=v,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(v){(0,T.onUnexpectedError)(v)}}}e.ExtensionPoint=u;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(h.allApiProposals),markdownEnumDescriptions:Object.values(h.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class d{constructor(){this._extensionPoints=new Map}registerExtensionPoint(v){if(this._extensionPoints.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const i=new u(v.extensionPoint,v.defaultExtensionKind);return this._extensionPoints.set(v.extensionPoint,i),v.activationEventsGenerator&&b.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,g.registerSchema(o,e.schema),i}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=d;const y={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(y.ExtensionsRegistry,new d),e.ExtensionsRegistry=P.Registry.as(y.ExtensionsRegistry),g.registerSchema(o,e.schema),g.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(h.allApiProposals),markdownEnumDescriptions:Object.values(h.allApiProposals)}}]}}}})}),define(Te[211],Pe([1,0,160,12,23,210,31,5]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var h;(function(g){function _(p,u,t){if(!p)return;const o=T.isString(p.type)?p.type:void 0;if(!o||o.length===0){t.error(n.localize(3,null));return}const d=[];if(Array.isArray(p.required))for(const y of p.required)T.isString(y)&&d.push(y);return{extensionId:u.value,taskType:o,required:d,properties:p.properties?D.deepClone(p.properties):{},when:p.when?A.ContextKeyExpr.deserialize(p.when):void 0}}g.from=_})(h||(h={}));const R=F.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(g,_)=>{for(const p of g)p.type&&_.push(`onTaskType:${p.type}`)},jsonSchema:{description:n.localize(4,null),type:"array",items:S}});class b{constructor(){this._onDefinitionsChanged=new P.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((_,p)=>{R.setHandler((u,t)=>{this._schema=void 0;try{for(const o of t.removed){const d=o.value;for(const y of d)this.taskTypes&&y.type&&this.taskTypes[y.type]&&delete this.taskTypes[y.type]}for(const o of t.added){const d=o.value;for(const y of d){const k=h.from(y,o.description.identifier,o.collector);k&&(this.taskTypes[k.taskType]=k)}}(t.removed.length>0||t.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}_(void 0)})})}onReady(){return this.readyPromise}get(_){return this.taskTypes[_]}all(){return Object.keys(this.taskTypes).map(_=>this.taskTypes[_])}getJsonSchema(){if(this._schema===void 0){const _=[];for(const p of this.all()){const u={type:"object",additionalProperties:!1};p.required.length>0&&(u.required=p.required.slice(0)),p.properties!==void 0?u.properties=D.deepClone(p.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[p.taskType]},_.push(u)}this._schema={oneOf:_}}return this._schema}}e.TaskDefinitionRegistry=new b}),define(Te[212],Pe([1,0,161,12,22,23,31,211]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new A.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var S;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(S||(e.ShellQuoting=S={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(B){function G(N){if(!N)return B.Strong;switch(N.toLowerCase()){case"escape":return B.Escape;case"strong":return B.Strong;case"weak":return B.Weak;default:return B.Strong}}B.from=G}(S||(e.ShellQuoting=S={}));var h;(function(B){B.defaults={cwd:"${workspaceFolder}"}})(h||(e.CommandOptions=h={}));var R;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(R||(e.RevealKind=R={})),function(B){function G(N){switch(N.toLowerCase()){case"always":return B.Always;case"silent":return B.Silent;case"never":return B.Never;default:return B.Always}}B.fromString=G}(R||(e.RevealKind=R={}));var b;(function(B){B[B.Never=1]="Never",B[B.OnProblem=2]="OnProblem",B[B.Always=3]="Always"})(b||(e.RevealProblemKind=b={})),function(B){function G(N){switch(N.toLowerCase()){case"always":return B.Always;case"never":return B.Never;case"onproblem":return B.OnProblem;default:return B.OnProblem}}B.fromString=G}(b||(e.RevealProblemKind=b={}));var g;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(g||(e.PanelKind=g={})),function(B){function G(N){switch(N.toLowerCase()){case"shared":return B.Shared;case"dedicated":return B.Dedicated;case"new":return B.New;default:return B.Shared}}B.fromString=G}(g||(e.PanelKind=g={}));var _;(function(B){B.defaults={echo:!0,reveal:R.Always,revealProblems:b.Never,focus:!1,panel:g.Shared,showReuseMessage:!0,clear:!1}})(_||(e.PresentationOptions=_={}));var p;(function(B){B[B.Shell=1]="Shell",B[B.Process=2]="Process",B[B.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(B){function G(H){switch(H.toLowerCase()){case"shell":return B.Shell;case"process":return B.Process;case"customExecution":return B.CustomExecution;default:return B.Process}}B.fromString=G;function N(H){switch(H){case B.Shell:return"shell";case B.Process:return"process";case B.CustomExecution:return"customExecution";default:return"process"}}B.toString=N}(p||(e.RuntimeType=p={}));var u;(function(B){function G(N){return T.isString(N)?N:N.value}B.value=G})(u||(e.CommandString=u={}));var t;(function(B){B.Clean={_id:"clean",isDefault:!1},B.Build={_id:"build",isDefault:!1},B.Rebuild={_id:"rebuild",isDefault:!1},B.Test={_id:"test",isDefault:!1};function G(H){return H===B.Clean._id||H===B.Build._id||H===B.Rebuild._id||H===B.Test._id}B.is=G;function N(H){if(H!==void 0)return T.isString(H)?G(H)?{_id:H,isDefault:!1}:void 0:H}B.from=N})(t||(e.TaskGroup=t={}));var o;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var d;(function(B){B.Workspace="workspace",B.Extension="extension",B.InMemory="inMemory",B.WorkspaceFile="workspaceFile",B.User="user";function G(N){switch(N){case B.User:return 2;case B.WorkspaceFile:return 5;default:return 6}}B.toConfigurationTarget=G})(d||(e.TaskSourceKind=d={}));var y;(function(B){B.parallel="parallel",B.sequence="sequence"})(y||(e.DependsOrder=y={}));var k;(function(B){B[B.default=1]="default",B[B.folderOpen=2]="folderOpen"})(k||(e.RunOnOptions=k={}));var v;(function(B){B.defaults={reevaluateOnRerun:!0,runOn:k.default,instanceLimit:1}})(v||(e.RunOptions=v={}));class i{constructor(G,N,H,Q,pe,we){this._label="",this._id=G,N&&(this._label=N),H&&(this.type=H),this.runOptions=Q,this.configurationProperties=pe,this._source=we}getDefinition(G){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const G={folder:this.getFolderId(),id:this._id};return JSON.stringify(G)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(G,N=!1){if(G===void 0)return!1;if(T.isString(G))return G===this._label||G===this.configurationProperties.identifier||N&&G===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===G._key}getQualifiedLabel(){const G=this.getWorkspaceFolder();return G?`${this._label} (${G.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(G){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),G&&(this._taskLoadMessages=this._taskLoadMessages.concat(G))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=i;class a extends i{constructor(G,N,H,Q,pe,we,he,de){super(G,H,void 0,he,de,N),this.command={},this._source=N,this.hasDefinedMatchers=we,pe&&(this.command=pe)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(G=!1){if(G&&this._source.customizes!==void 0)return this._source.customizes;{let N;switch(this.command?this.command.runtime:void 0){case p.Shell:N="shell";break;case p.Process:N="process";break;case p.CustomExecution:N="customExecution";break;case void 0:N="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:N,_key:this._id,id:this._id}}}static is(G){return G instanceof a}getMapKey(){const G=this._source.config.workspaceFolder;return G?`${G.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===d.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const G=this.getFolderId();if(!G)return;let N=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(N+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:G,id:N};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(G){return new a(G._id,G._source,G._label,G.type,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.CustomTask=a;class r extends i{constructor(G,N,H,Q,pe,we,he){super(G,H,Q,we,he,N),this._source=N,this.configures=pe}static is(G){return G instanceof r}fromObject(G){return G}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===d.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const G=this.getFolderId();if(!G)return;let N=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(N+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:G,id:N};return JSON.stringify(H)}}e.ConfiguringTask=r;class s extends i{constructor(G,N,H,Q,pe,we,he,de,Ae){super(G,H,Q,de,Ae,N),this.defines=pe,this.hasDefinedMatchers=he,this.command=we,this.icon=Ae.icon,this.hide=Ae.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(G){return G instanceof s}getMapKey(){const G=this._source.workspaceFolder;return G?`${this._source.scope.toString()}|${G.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const G={type:"contributed",scope:this._source.scope,id:this._id};return G.folder=this.getFolderId(),JSON.stringify(G)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(G){return new s(G._id,G._source,G._label,G.type,G.defines,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.ContributedTask=s;class w extends i{constructor(G,N,H,Q,pe,we){super(G,H,Q,pe,we,N),this._source=N}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(G){return G instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(G){return new w(G._id,G._source,G._label,G.type,G.runOptions,G.configurationProperties)}}e.InMemoryTask=w;var I;(function(B){B[B.Process=1]="Process",B[B.Terminal=2]="Terminal"})(I||(e.ExecutionEngine=I={})),function(B){B._default=B.Terminal}(I||(e.ExecutionEngine=I={}));var c;(function(B){B[B.V0_1_0=1]="V0_1_0",B[B.V2_0_0=2]="V2_0_0"})(c||(e.JsonSchemaVersion=c={}));class l{constructor(G){this._order=new Map;for(let N=0;N<G.length;N++)this._order.set(G[N].uri.toString(),N)}compare(G,N){const H=G.getWorkspaceFolder(),Q=N.getWorkspaceFolder();if(H&&Q){let pe=this._order.get(H.uri.toString());pe=pe===void 0?0:pe+1;let we=this._order.get(Q.uri.toString());return we=we===void 0?0:we+1,pe===we?G._label.localeCompare(N._label):pe-we}else return!H&&Q?-1:H&&!Q?1:0}}e.TaskSorter=l;var m;(function(B){B.DependsOnStarted="dependsOnStarted",B.AcquiredInput="acquiredInput",B.Start="start",B.ProcessStarted="processStarted",B.Active="active",B.Inactive="inactive",B.Changed="changed",B.Terminated="terminated",B.ProcessEnded="processEnded",B.End="end"})(m||(e.TaskEventKind=m={}));var E;(function(B){B.SingleRun="singleRun",B.Background="background"})(E||(e.TaskRunType=E={}));var f;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.FolderOpen=2]="FolderOpen",B[B.ConfigurationChange=3]="ConfigurationChange",B[B.Reconnect=4]="Reconnect"})(f||(e.TaskRunSource=f={}));var L;(function(B){function G(N,H,Q,pe){if(H){const we={kind:N,taskId:H._id,taskName:H.configurationProperties.name,runType:H.configurationProperties.isBackground?"background":"singleRun",group:H.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:Q,__task:H};return N==="start"?we.resolvedVariables=pe:N==="processStarted"?we.processId=pe:N==="processEnded"&&(we.exitCode=pe),Object.freeze(we)}else return Object.freeze({kind:"changed"})}B.create=G})(L||(e.TaskEvent=L={}));var W;(function(B){function G(H){const Q=Object.keys(H).sort();let pe="";for(const we of Q){let he=H[we];he instanceof Object?he=G(he):typeof he=="string"&&(he=he.replace(/,/g,",,")),pe+=we+","+he+","}return pe}function N(H){const pe={_key:G(H),type:H.taskType};return Object.assign(pe,H),pe}B.create=N})(W||(e.KeyedTaskIdentifier=W={}));var J;(function(B){B.AutoDetect="task.autoDetect",B.SaveBeforeRun="task.saveBeforeRun",B.ShowDecorations="task.showDecorations",B.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",B.SlowProviderWarning="task.slowProviderWarning",B.QuickOpenHistory="task.quickOpen.history",B.QuickOpenDetail="task.quickOpen.detail",B.QuickOpenSkip="task.quickOpen.skip",B.QuickOpenShowAll="task.quickOpen.showAll",B.AllowAutomaticTasks="task.allowAutomaticTasks",B.Reconnection="task.reconnection"})(J||(e.TaskSettingId=J={}));var q;(function(B){B.Tasks="tasks",B.SuppressTaskName="tasks.suppressTaskName",B.Windows="tasks.windows",B.Osx="tasks.osx",B.Linux="tasks.linux",B.ShowOutput="tasks.showOutput",B.IsShellCommand="tasks.isShellCommand",B.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var U;(function(B){function G(N,H){const Q=P.TaskDefinitionRegistry.get(N.type);if(Q===void 0){const de=F.deepClone(N);return delete de._key,W.create(de)}const pe=Object.create(null);pe.type=Q.taskType;const we=new Set;Q.required.forEach(de=>we.add(de));const he=Q.properties;for(const de of Object.keys(he)){const Ae=N[de];if(Ae!=null)pe[de]=Ae;else if(we.has(de)){const ue=he[de];if(ue.default!==void 0)pe[de]=F.deepClone(ue.default);else switch(ue.type){case"boolean":pe[de]=!1;break;case"number":case"integer":pe[de]=0;break;case"string":pe[de]="";break;default:H.error(n.localize(2,null,JSON.stringify(N,void 0,0),de));return}}}return W.create(pe)}B.createTaskIdentifier=G})(U||(e.TaskDefinition=U={}))}),define(Te[213],Pe([1,0,9]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,P)=>{this._actualOk=A,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,n.onUnexpectedError)(A))}then(A,P){return this._ensureActual().then(A,P)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=T;class D extends T{constructor(){super(),this._hasErr=!0,this._err=new n.CancellationError}}e.CanceledLazyPromise=D}),define(Te[46],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++n.count}}e.ProxyIdentifier=n,n.count=0;const T=[];function D(P){const S=new n(P);return T[S.nid]=S,S}e.createProxyIdentifier=D;function F(P){return T[P].sid}e.getStringIdentifierForProxy=F;class A{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=A}),define(Te[4],Pe([1,0,46]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var D;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput"})(D||(e.TabInputKind=D={}));var F;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var A;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var P;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(P||(e.WebviewMessageArrayBufferViewType=P={}));var S;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(S||(e.CellOutputKind=S={}));var h;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(h||(e.NotebookEditorRevealType=h={}));var R;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class b{static mixin(t){return t._id=b._n++,t}}e.IdObject=b,b._n=0;var g;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})(g||(e.ISuggestDataDtoField=g={}));var _;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(_||(e.ISuggestResultDtoField=_={}));var p;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,n.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,n.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,n.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,n.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,n.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,n.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostSemanticSimilarity:(0,n.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,n.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Te[78],Pe([1,0,3,14,4,18]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let A=e.ExtHostApiDeprecationService=class{constructor(S,h){this._extHostLogService=h,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(D.MainContext.MainThreadTelemetry)}report(S,h,R){const b=this.getUsageKey(S,h);this._reportedUsages.has(b)||(this._reportedUsages.add(b),h.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:h.identifier.value,apiId:S}))}getUsageKey(S,h){return`${S}-${h.identifier.value}`}};e.ExtHostApiDeprecationService=A=je([Ve(0,F.IExtHostRpcService),Ve(1,T.ILogService)],A),e.NullApiDeprecationService=Object.freeze(new class{report(P,S,h){}})}),define(Te[214],Pe([1,0,5,4,7,24]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(h){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new n.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new P,this._getSessionsTaskSingler=new P,this._proxy=h.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(h){return this._providers=h,Promise.resolve()}async getSession(h,R,b,g={}){const _=F.ExtensionIdentifier.toKey(h.identifier),p=[...b].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${_} ${R} ${p}`,async()=>{await this._proxy.$ensureProvider(R);const u=h.displayName||h.name;return this._proxy.$getSession(R,b,_,u,g)})}async getSessions(h,R,b){const g=F.ExtensionIdentifier.toKey(h.identifier),_=[...b].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${g} ${_}`,async()=>{await this._proxy.$ensureProvider(R);const p=h.displayName||h.name;return this._proxy.$getSessions(R,b,g,p)})}async removeSession(h,R){const b=this._authenticationProviders.get(h);return b?b.provider.removeSession(R):this._proxy.$removeSession(h,R)}registerAuthenticationProvider(h,R,b,g){if(this._authenticationProviders.get(h))throw new Error(`An authentication provider with id '${h}' is already registered.`);this._authenticationProviders.set(h,{label:R,provider:b,options:g??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===h)||this._providers.push({id:h,label:R});const _=b.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(h,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(h,R,g?.supportsMultipleAccounts??!1),new D.Disposable(()=>{_.dispose(),this._authenticationProviders.delete(h);const p=this._providers.findIndex(u=>u.id===h);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(h)})}$createSession(h,R){const b=this._authenticationProviders.get(h);if(b)return Promise.resolve(b.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${h}`)}$removeSession(h,R){const b=this._authenticationProviders.get(h);if(b)return Promise.resolve(b.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${h}`)}$getSessions(h,R){const b=this._authenticationProviders.get(h);if(b)return Promise.resolve(b.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${h}`)}$onDidChangeAuthenticationSessions(h,R){return this._onDidChangeSessions.fire({provider:{id:h,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=A;class P{constructor(){this._inFlightPromises=new Map}getOrCreate(h,R){const b=this._inFlightPromises.get(h);if(b)return b;const g=R().finally(()=>this._inFlightPromises.delete(h));return this._inFlightPromises.set(h,g),g}}}),define(Te[215],Pe([1,0,4,18,8]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let F=e.ExtHostBulkEdits=class{constructor(P,S){this._proxy=P.getProxy(n.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:h=>S.getDocument(h)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P,S,h){const R=D.WorkspaceEdit.from(P,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,h?.isRefactoring??!1)}};e.ExtHostBulkEdits=F=je([Ve(0,T.IExtHostRpcService)],F)}),define(Te[216],Pe([1,0,4]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(F){const A=F.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(P){return A.$writeText(P)}})}}e.ExtHostClipboard=T});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Te[38],Pe([1,0,12,7,8,23,4,16,14,67,44,270,2,6,3,18,104,25,46,40,58,52,57]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o,d,y,k,v,i){"use strict";var a,r,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=e.ExtHostCommands=class{constructor(f,L,W){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,r.set(this,void 0),s.set(this,void 0),Je(this,a,f.getProxy(A.MainContext.MainThreadCommands),"f"),this._logService=L,Je(this,s,W,"f"),Je(this,r,f.getProxy(A.MainContext.MainThreadTelemetry),"f"),this.converter=new I(this,J=>{const q=this._apiCommands.get(J);return q?.result===l.Void?q:void 0},L),this._argumentProcessors=[{processArgument(J){return(0,h.revive)(J)}},{processArgument(J){return(0,F.cloneAndChange)(J,function(q){if(R.Range.isIRange(q))return D.Range.to(q);if(b.Position.isIPosition(q))return D.Position.to(q);if(R.Range.isIRange(q.range)&&g.URI.isUri(q.uri))return D.location.to(q);if(q instanceof o.VSBuffer)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(f){this._argumentProcessors.push(f)}registerApiCommand(f){const L=this.registerCommand(!1,f.id,async(...W)=>{const J=f.args.map((U,B)=>{if(!U.validate(W[B]))throw new Error(`Invalid argument '${U.name}' when running '${f.id}', received: ${W[B]}`);return U.convert(W[B])}),q=await this.executeCommand(f.internalId,...J);return f.result.convert(q,W,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this._apiCommands.set(f.id,f),new T.Disposable(()=>{L.dispose(),this._apiCommands.delete(f.id)})}registerCommand(f,L,W,J,q,U){if(this._logService.trace("ExtHostCommands#registerCommand",L),!L.trim().length)throw new Error("invalid id");if(this._commands.has(L))throw new Error(`command '${L}' already exists`);return this._commands.set(L,{callback:W,thisArg:J,description:q,extension:U}),f&&Le(this,a,"f").$registerCommand(L),new T.Disposable(()=>{this._commands.delete(L)&&f&&Le(this,a,"f").$unregisterCommand(L)})}executeCommand(f,...L){return this._logService.trace("ExtHostCommands#executeCommand",f),this._doExecuteCommand(f,L,!0)}async _doExecuteCommand(f,L,W){if(this._commands.has(f))return Le(this,a,"f").$fireCommandActivationEvent(f),this._executeContributedCommand(f,L,!1);{let J=!1;const q=(0,F.cloneAndChange)(L,function(U){if(U instanceof T.Position)return D.Position.from(U);if(U instanceof T.Range)return D.Range.from(U);if(U instanceof T.Location)return D.location.from(U);if(T.NotebookRange.isNotebookRange(U))return D.NotebookRange.from(U);if(U instanceof ArrayBuffer)return J=!0,o.VSBuffer.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return J=!0,o.VSBuffer.wrap(U);if(U instanceof o.VSBuffer)return J=!0,U;if(!Array.isArray(U))return U});try{const U=await Le(this,a,"f").$executeCommand(f,J?new d.SerializableObjectWithBuffers(q):q,W);return(0,h.revive)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this._doExecuteCommand(f,L,!1);throw U}}}async _executeContributedCommand(f,L,W){const J=this._commands.get(f);if(!J)throw new Error("Unknown command");const{callback:q,thisArg:U,description:B}=J;if(B)for(let N=0;N<B.args.length;N++)try{(0,n.validateConstraint)(L[N],B.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${B.args[N].name}' - ${B.args[N].description}`)}const G=k.StopWatch.create();try{return await q.apply(U,L)}catch(N){if(f===this.converter.delegatingCommandId){const H=this.converter.getActualCommand(...L);H&&(f=H.command)}if(this._logService.error(N,f,J.extension?.identifier),!W)throw N;if(J.extension?.identifier){const H=Le(this,s,"f").onExtensionError(J.extension.identifier,N);this._logService.trace("forwarded error to extension?",H,J.extension?.identifier)}throw new class extends Error{constructor(){super((0,y.toErrorMessage)(N)),this.id=f,this.source=J.extension?.displayName??J.extension?.name}}}finally{this._reportTelemetry(J,f,G.elapsed())}}_reportTelemetry(f,L,W){f.extension&&Le(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new v.TelemetryTrustedValue(L),duration:W})}$executeContributedCommand(f,...L){this._logService.trace("ExtHostCommands#$executeContributedCommand",f);const W=this._commands.get(f);return W?(L=L.map(J=>this._argumentProcessors.reduce((q,U)=>U.processArgument(q,W.extension?.identifier),J)),this._executeContributedCommand(f,L,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this._logService.trace("ExtHostCommands#getCommands",f),Le(this,a,"f").$getCommands().then(L=>(f&&(L=L.filter(W=>W[0]!=="_")),L))}$getContributedCommandHandlerDescriptions(){const f=Object.create(null);for(const[L,W]of this._commands){const{description:J}=W;J&&(f[L]=J)}return Promise.resolve(f)}};a=new WeakMap,r=new WeakMap,s=new WeakMap,e.ExtHostCommands=w=je([Ve(0,u.IExtHostRpcService),Ve(1,S.ILogService),Ve(2,i.IExtHostTelemetry)],w),e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class I{constructor(f,L,W){this._commands=f,this._lookupApiCommand=L,this._logService=W,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(f,L){if(!f)return;const W={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return W;const J=this._lookupApiCommand(f.command);if(J)W.id=J.internalId,W.arguments=J.args.map((q,U)=>q.convert(f.arguments&&f.arguments[U]));else if((0,P.isNonEmptyArray)(f.arguments)){const q=`${f.command}/${++this._cachIdPool}`;this._cache.set(q,f),L.add((0,_.toDisposable)(()=>{this._cache.delete(q),this._logService.trace("CommandsConverter#DISPOSE",q)})),W.$ident=q,W.id=this.delegatingCommandId,W.arguments=[q],this._logService.trace("CommandsConverter#CREATE",f.command,q)}return W}fromInternal(f){return typeof f.$ident=="string"?this._cache.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this._cache.get(f[0])}_executeConvertedCommand(...f){const L=this.getActualCommand(...f);return this._logService.trace("CommandsConverter#EXECUTE",f[0],L?L.command:"MISSING"),L?this._commands.executeCommand(L.command,...L.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.CommandsConverter=I;class c{constructor(f,L,W,J){this.name=f,this.description=L,this.validate=W,this.convert=J}optional(){return new c(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,L){return new c(f??this.name,L??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",E=>g.URI.isUri(E),E=>E),c.Position=new c("position","A position in a text document",E=>T.Position.isPosition(E),D.Position.from),c.Range=new c("range","A range in a text document",E=>T.Range.isRange(E),D.Range.from),c.Selection=new c("selection","A selection in a text document",E=>T.Selection.isSelection(E),D.Selection.from),c.Number=new c("number","",E=>typeof E=="number",E=>E),c.String=new c("string","",E=>typeof E=="string",E=>E),c.CallHierarchyItem=new c("item","A call hierarchy item",E=>E instanceof T.CallHierarchyItem,D.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",E=>E instanceof T.TypeHierarchyItem,D.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VSCodium TestItem",E=>E instanceof t.TestItemImpl,D.TestItem.from);class l{constructor(f,L){this.description=f,this.convert=L}}e.ApiCommandResult=l,l.Void=new l("no result",E=>E);class m{constructor(f,L,W,J,q){this.id=f,this.internalId=L,this.description=W,this.args=J,this.result=q}}e.ApiCommand=m}),define(Te[217],Pe([1,0,16,15,2,77,90,31,94,38,8,7]),function(te,e,n,T,D,F,A,P,S,h,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const g=[new h.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(R.DocumentHighlight.to))),new h.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,o)=>{if((0,n.isFalsyOrEmpty)(t))return;class d extends b.SymbolInformation{static to(k){const v=new d(k.name,R.SymbolKind.to(k.kind),k.containerName||"",new b.Location(o[0],R.Range.to(k.range)));return v.detail=k.detail,v.range=v.location.range,v.selectionRange=R.Range.to(k.selectionRange),v.children=k.children?k.children.map(d.to):[],v}}return t.map(d.to)})),new h.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(R.TextEdit.to))),new h.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range,new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(R.TextEdit.to))),new h.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,new h.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(R.TextEdit.to))),new h.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",u)),new h.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",u)),new h.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",u)),new h.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",u)),new h.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(R.location.to))),new h.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(R.Hover.to))),new h.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(o=>b.Position.isPosition(o)),t=>t.map(R.Position.from))],new h.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(o=>{let d;for(const y of o.reverse())d=new b.SelectionRange(R.Range.to(y),d);return d}))),new h.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[h.ApiCommandArgument.String.with("query","Search string")],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new h.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new h.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new h.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new h.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:R.Range.to(t.range),placeholder:t.text}})),new h.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("newName","The new symbol name")],new h.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new h.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new h.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new h.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new b.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,A.decodeSemanticTokensDto)(t);if(o.type==="full")return new b.SemanticTokens(o.data,void 0)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range.optional()],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new b.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,A.decodeSemanticTokensDto)(t);if(o.type==="full")return new b.SemanticTokens(o.data,void 0)})),new h.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new h.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,o,d)=>{if(!t)return new b.CompletionList([]);const y=t.suggestions.map(k=>R.CompletionItem.to(k,d));return new b.CompletionList(y,t.incomplete)})),new h.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new h.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new h.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new h.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,o,d)=>p(y=>new b.CodeLens(R.Range.to(y.range),y.command&&d.fromInternal(y.command)))(t))),new h.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>b.Range.isRange(t),t=>b.Selection.isSelection(t)?R.Selection.from(t):R.Range.from(t)),h.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new h.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,o,d)=>p(y=>{if(y._isSynthetic){if(!y.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(y.command)}else{const k=new b.CodeAction(y.title,y.kind?new b.CodeActionKind(y.kind):void 0);return y.edit&&(k.edit=R.WorkspaceEdit.to(y.edit)),y.command&&(k.command=d.fromInternal(y.command)),k.isPreferred=y.isPreferred,k}})(t))),new h.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(o=>new b.ColorInformation(R.Range.to(o.range),R.Color.to(o.color))):[])),new h.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new h.ApiCommandArgument("color","The color to show and insert",t=>t instanceof b.Color,R.Color.from),new h.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new h.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new h.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,o,d)=>t.map(R.InlayHint.to.bind(void 0,d)))),new h.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,o)=>{if(t)return t.map(R.FoldingRange.to)})),new h.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new h.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(o=>R.NotebookExclusiveDocumentPattern.to(o))})))),new h.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new h.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new h.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>D.URI.isUri(t)||typeof t=="string"&&(0,S.matchesSomeScheme)(t,T.Schemas.http,T.Schemas.https),t=>t),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),h.ApiCommandArgument.String.with("label","").optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[h.ApiCommandArgument.Uri.with("resource","Resource to open"),h.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VSCodium's default editor"),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[h.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),h.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),h.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new h.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[h.ApiCommandArgument.TestItem],h.ApiCommandResult.Void),new h.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[h.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],h.ApiCommandResult.Void),new h.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[h.ApiCommandArgument.String.with("name","The context key name"),new h.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],h.ApiCommandResult.Void)];class _{static register(o){g.forEach(o.registerApiCommand,o),this._registerValidateWhenClausesCommand(o)}static _registerValidateWhenClausesCommand(o){o.registerCommand(!1,"_validateWhenClauses",P.validateWhenClauses)}}e.ExtHostApiCommands=_;function p(t){return o=>{if(Array.isArray(o))return o.map(t)}}function u(t){if(!Array.isArray(t))return;const o=[];for(const d of t)F.isLocationLink(d)?o.push(R.DefinitionLink.to(d)):o.push(R.location.to(d));return o}}),define(Te[218],Pe([1,0,17,65,5,6,2,77,24,8,7,4,26,12]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(u,t,o){const d=u.getProxy(b.MainContext.MainThreadComments);class y{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new S.ExtensionIdentifierMap,t.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const l=this._commentControllers.get(c.handle);return l?l.value:c}else if(c&&c.$mid===7){const l=this._commentControllers.get(c.commentControlHandle);if(!l)return c;const m=l.getCommentThread(c.commentThreadHandle);return m?m.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const l=this._commentControllers.get(c.thread.commentControlHandle);if(!l)return c;const m=l.getCommentThread(c.thread.commentThreadHandle);return m?c.$mid===8?m.value:{thread:m.value,text:c.text}:c}else if(c&&c.$mid===10){const l=this._commentControllers.get(c.thread.commentControlHandle);if(!l)return c;const m=l.getCommentThread(c.thread.commentThreadHandle);if(!m)return c;const E=c.commentUniqueId,f=m.getCommentByUniqueId(E);return f||c}else if(c&&c.$mid===11){const l=this._commentControllers.get(c.thread.commentControlHandle);if(!l)return c;const m=l.getCommentThread(c.thread.commentThreadHandle);if(!m)return c;const E=c.text,f=c.commentUniqueId,L=m.getCommentByUniqueId(f);return L?(typeof L.body=="string"?L.body=E:L.body=new R.MarkdownString(E),L):c}return c}})}createCommentController(c,l,m){const E=y.handlePool++,f=new v(c,E,l,m);this._commentControllers.set(f.handle,f);const L=this._commentControllersByExtension.get(c.identifier)||[];return L.push(f),this._commentControllersByExtension.set(c.identifier,L),f.value}$createCommentThreadTemplate(c,l,m){const E=this._commentControllers.get(c);E&&E.$createCommentThreadTemplate(l,m)}async $updateCommentThreadTemplate(c,l,m){const E=this._commentControllers.get(c);E&&E.$updateCommentThreadTemplate(l,m)}$deleteCommentThread(c,l){this._commentControllers.get(c)?.$deleteCommentThread(l)}$provideCommentingRanges(c,l,m){const E=this._commentControllers.get(c);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const f=o.getDocument(A.URI.revive(l));return(0,n.asPromise)(async()=>{const L=await E.commentingRangeProvider.provideCommentingRanges(f,m);let W;return Array.isArray(L)?W={ranges:L,fileComments:!1}:L?W={ranges:L.ranges||[],fileComments:L.fileComments||!1}:W=(0,_.withNullAsUndefined)(L),W}).then(L=>{let W;return L&&(W={ranges:L.ranges.map(J=>h.Range.from(J)),fileComments:L.fileComments}),W})}$toggleReaction(c,l,m,E,f){const L=this._commentControllers.get(c);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const W=L.getCommentThread(l);if(W){const J=W.getCommentByUniqueId(E.uniqueIdInThread);if(L!==void 0&&J&&L.reactionHandler)return L.reactionHandler(J,r(f))}return Promise.resolve(void 0)})}}y.handlePool=0;class k{set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){(c===void 0!=(this._range===void 0)||!c||!this._range||!c.isEqual(this._range))&&(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(c){this._state=c,this.modifications.state=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(c,l,m,E,f,L,W,J){this._commentControllerHandle=l,this._id=m,this._uri=E,this._range=f,this._comments=L,this.extensionDescription=W,this._isTemplate=J,this.handle=k._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new F.MutableDisposable,this._acceptInputDisposables.value=new F.DisposableStore,this._id===void 0&&(this._id=`${c}.${this.handle}`),d.$createCommentThread(l,this.handle,this._id,this._uri,h.Range.from(this._range),W.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(l,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(U){q.range=U},get comments(){return q.comments},set comments(U){q.comments=U},get collapsibleState(){return q.collapsibleState},set collapsibleState(U){q.collapsibleState=U},get canReply(){return q.canReply},set canReply(U){q.canReply=U},get contextValue(){return q.contextValue},set contextValue(U){q.contextValue=U},get label(){return q.label},set label(U){q.label=U},get state(){return q.state},set state(U){q.state=U},dispose:()=>{q.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new F.DisposableStore);const c=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),l={};c("range")&&(l.range=h.Range.from(this._range)),c("label")&&(l.label=this.label),c("contextValue")&&(l.contextValue=this.contextValue??null),c("comments")&&(l.comments=this._comments.map(m=>i(this,m,this._commentsMap,this.extensionDescription))),c("collapsibleState")&&(l.collapseState=s(this._collapseState)),c("canReply")&&(l.canReply=this.canReply),c("state")&&(l.state=w(this._state)),c("isTemplate")&&(l.isTemplate=this._isTemplate),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,l)}getCommentByUniqueId(c){for(const l of this._commentsMap){const m=l[0],E=l[1];if(c===E)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose())}}k._handlePool=0,je([(0,T.debounce)(100)],k.prototype,"eventuallyUpdateCommentThread",null);class v{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(c){this._commentingRangeProvider=c,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(c,l,m,E){this._extension=c,this._handle=l,this._id=m,this._label=E,this._threads=new Map,d.$registerCommentController(this.handle,m,E);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(L){f.options=L},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(L){f.commentingRangeProvider=L},get reactionHandler(){return f.reactionHandler},set reactionHandler(L){f.reactionHandler=L},createCommentThread(L,W,J){return f.createCommentThread(L,W,J).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(c,l,m){l===void 0&&(0,g.checkProposedApiEnabled)(this._extension,"fileComments");const E=new k(this.id,this.handle,void 0,c,l,m,this._extension,!1);return this._threads.set(E.handle,E),E}$createCommentThreadTemplate(c,l){const m=new k(this.id,this.handle,void 0,A.URI.revive(c),h.Range.to(l),[],this._extension,!0);return m.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(c,l){const m=this._threads.get(c);m&&(m.range=h.Range.to(l))}$deleteCommentThread(c){this._threads.get(c)?.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._localDisposables.forEach(c=>c.dispose())}}function i(I,c,l,m){let E=l.get(c);return E||(E=++I.commentHandle,l.set(c,E)),c.state!==void 0&&(0,g.checkProposedApiEnabled)(m,"commentsDraftState"),{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:E,body:typeof c.body=="string"?c.body:h.MarkdownString.from(c.body),userName:c.author.name,userIconPath:c.author.iconPath,label:c.label,commentReactions:c.reactions?c.reactions.map(f=>a(f)):void 0,state:c.state,timestamp:c.timestamp?.toJSON()}}function a(I){return{label:I.label,iconPath:I.iconPath?h.pathOrURIToURI(I.iconPath):void 0,count:I.count,hasReacted:I.authorHasReacted}}function r(I){return{label:I.label||"",count:I.count||0,iconPath:I.iconPath?A.URI.revive(I.iconPath):"",authorHasReacted:I.hasReacted||!1}}function s(I){if(I!==void 0)switch(I){case R.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function w(I){if(I!==void 0)switch(I){case R.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new y}e.createExtHostComments=p}),define(Te[219],Pe([1,0,23,4,27,18]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let A=e.AbstractExtHostConsoleForwarder=class{constructor(R,b){this._mainThreadConsole=R.getProxy(T.MainContext.MainThreadConsole),this._includeStack=b.consoleForward.includeStack,this._logNative=b.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,b){const g=this,_=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){g._handleConsoleCall(R,b,_,arguments)}})}_handleConsoleCall(R,b,g,_){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:b,arguments:S(_,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,g,_)}};e.AbstractExtHostConsoleForwarder=A=je([Ve(0,F.IExtHostRpcService),Ve(1,D.IExtHostInitDataService)],A);const P=1e5;function S(h,R){const b=[];if(h.length)for(let g=0;g<h.length;g++){let _=h[g];if(typeof _>"u")_="undefined";else if(_ instanceof Error){const p=_;p.stack?_=p.stack:_=p.toString()}b.push(_)}if(R){const g=new Error().stack;g&&b.push({__$stack:g.split(`
`).slice(3).join(`
`)})}try{const g=(0,n.safeStringify)(b);return g.length>P?"Output omitted for a large object that exceeds the limits":g}catch(g){return`Output omitted for an object that cannot be inspected ('${g.toString()}')`}}}),define(Te[106],Pe([1,0,2,4,7,3,18,14,16,13,19,26]),function(te,e,n,T,D,F,A,P,S,h,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let g=e.ExtHostDecorations=class Qi{constructor(p,u){this._logService=u,this._provider=new Map,this._proxy=p.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,u){const t=Qi._handlePool++;this._provider.set(t,{provider:p,extensionDescription:u}),this._proxy.$registerDecorationProvider(t,u.identifier.value);const o=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(d=>{if(!d){this._proxy.$onDidChange(t,null);return}const y=(0,S.asArray)(d);if(y.length<=Qi._maxEventSize){this._proxy.$onDidChange(t,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,y.length);const k=y.map(a=>({uri:a,rank:(0,h.count)(a.path,"/")})),v=(0,S.groupBy)(k,(a,r)=>a.rank-r.rank||(0,h.compare)(a.uri.path,r.uri.path)),i=[];e:for(const a of v){let r;for(const s of a){const w=(0,R.dirname)(s.uri.path);if(r!==w&&(r=w,i.push(s.uri)>=Qi._maxEventSize))break e}}this._proxy.$onDidChange(t,i)});return new D.Disposable(()=>{o?.dispose(),this._proxy.$unregisterDecorationProvider(t),this._provider.delete(t)})}async $provideDecorations(p,u,t){if(!this._provider.has(p))return Object.create(null);const o=Object.create(null),{provider:d,extensionDescription:y}=this._provider.get(p);return await Promise.all(u.map(async k=>{try{const{uri:v,id:i}=k,a=await Promise.resolve(d.provideFileDecoration(n.URI.revive(v),t));if(!a)return;try{D.FileDecoration.validate(a),a.badge&&typeof a.badge!="string"&&(0,b.checkProposedApiEnabled)(y,"codiconDecoration"),o[i]=[a.propagate,a.tooltip,a.badge,a.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${y}': ${r}`)}}catch(v){this._logService.error(v)}})),o}};g._handlePool=0,g._maxEventSize=250,e.ExtHostDecorations=g=je([Ve(0,A.IExtHostRpcService),Ve(1,P.ILogService)],g),e.IExtHostDecorations=(0,F.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Te[220],Pe([1,0,145,93,2,4,7,8,5,14,28,37]),function(te,e,n,T,D,F,A,P,S,h,R,b){"use strict";var g,_,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(d,y,k,v,i,a,r){this._name=d,this._owner=y,this._maxDiagnosticsPerFile=k,this._modelVersionIdProvider=v,g.set(this,void 0),_.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,Je(this,p,new R.ResourceMap(s=>i.getComparisonKey(s)),"f"),Je(this,g,a,"f"),Je(this,_,r,"f")}dispose(){this._isDisposed||(Le(this,_,"f").fire([...Le(this,p,"f").keys()]),Le(this,g,"f")?.$clear(this._owner),Le(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(d,y){if(!d){this.clear();return}this._checkDisposed();let k=[];if(D.URI.isUri(d)){if(!y){this.delete(d);return}Le(this,p,"f").set(d,y.slice()),k=[d]}else if(Array.isArray(d)){k=[];let i;d=[...d].sort(u._compareIndexedTuplesByUri);for(const a of d){const[r,s]=a;if((!i||r.toString()!==i.toString())&&(i&&Le(this,p,"f").get(i).length===0&&Le(this,p,"f").delete(i),i=r,k.push(r),Le(this,p,"f").set(r,[])),s)Le(this,p,"f").get(r)?.push(...s);else{const w=Le(this,p,"f").get(r);w&&(w.length=0)}}}if(Le(this,_,"f").fire(k),!Le(this,g,"f"))return;const v=[];for(const i of k){let a=[];const r=Le(this,p,"f").get(i);if(r)if(r.length>this._maxDiagnosticsPerFile){a=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let w=0;w<4;w++)for(const I of r)if(I.severity===s[w]&&a.push({...P.Diagnostic.from(I),modelVersionId:this._modelVersionIdProvider(i)})===this._maxDiagnosticsPerFile)break e;a.push({severity:T.MarkerSeverity.Info,message:(0,n.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=r.map(s=>({...P.Diagnostic.from(s),modelVersionId:this._modelVersionIdProvider(i)}));v.push([i,a])}Le(this,g,"f").$changeMany(this._owner,v)}delete(d){this._checkDisposed(),Le(this,_,"f").fire([d]),Le(this,p,"f").delete(d),Le(this,g,"f")?.$changeMany(this._owner,[[d,void 0]])}clear(){this._checkDisposed(),Le(this,_,"f").fire([...Le(this,p,"f").keys()]),Le(this,p,"f").clear(),Le(this,g,"f")?.$clear(this._owner)}forEach(d,y){this._checkDisposed();for(const[k,v]of this)d.call(y,k,v,this)}*[(g=new WeakMap,_=new WeakMap,p=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const d of Le(this,p,"f").keys())yield[d,this.get(d)]}get(d){this._checkDisposed();const y=Le(this,p,"f").get(d);return Array.isArray(y)?Object.freeze(y.slice(0)):[]}has(d){return this._checkDisposed(),Array.isArray(Le(this,p,"f").get(d))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(d,y){return d[0].toString()<y[0].toString()?-1:d[0].toString()>y[0].toString()?1:0}}e.DiagnosticCollection=u;let t=e.ExtHostDiagnostics=class mi{static _mapper(d){const y=new R.ResourceMap;for(const k of d)y.set(k,k);return{uris:Object.freeze(Array.from(y.values()))}}constructor(d,y,k,v){this._logService=y,this._fileSystemInfoService=k,this._extHostDocumentsAndEditors=v,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,mi._mapper),this._proxy=d.getProxy(F.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(d,y){const{_collections:k,_proxy:v,_onDidChangeDiagnostics:i,_logService:a,_fileSystemInfoService:r,_extHostDocumentsAndEditors:s}=this,w=new class{$changeMany(l,m){v.$changeMany(l,m),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,l,m.length===0?"CLEARING":m)}$clear(l){v.$clear(l),a.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,l)}dispose(){v.dispose()}};let I;if(!y)y="_generated_diagnostic_collection_name_#"+mi._idPool++,I=y;else if(!k.has(y))I=y;else{this._logService.warn(`DiagnosticCollection with name '${y}' does already exist.`);do I=y+mi._idPool++;while(k.has(I))}return new class extends u{constructor(){super(y,I,mi._maxDiagnosticsPerFile,l=>s.getDocument(l)?.version,r.extUri,w,i),k.set(I,this)}dispose(){super.dispose(),k.delete(I)}}}getDiagnostics(d){if(d)return this._getDiagnostics(d);{const y=new Map,k=[];for(const v of this._collections.values())v.forEach((i,a)=>{let r=y.get(i.toString());typeof r>"u"&&(r=k.length,y.set(i.toString(),r),k.push([i,[]])),k[r][1]=k[r][1].concat(...a)});return k}}_getDiagnostics(d){let y=[];for(const k of this._collections.values())k.has(d)&&(y=y.concat(k.get(d)));return y}$acceptMarkersChange(d){if(!this._mirrorCollection){const y="_generated_mirror",k=new u(y,y,mi._maxDiagnosticsPerFile,v=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(y,k),this._mirrorCollection=k}for(const[y,k]of d)this._mirrorCollection.set(D.URI.revive(y),k.map(P.Diagnostic.to))}};t._idPool=0,t._maxDiagnosticsPerFile=1e3,e.ExtHostDiagnostics=t=je([Ve(1,h.ILogService),Ve(2,b.IExtHostFileSystemInfo)],t)}),define(Te[221],Pe([1,0,2,4,26]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class F{constructor(P){this._proxy=P.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(P,S){return S?.allowUIResources&&(0,D.checkProposedApiEnabled)(P,"showLocal"),this._proxy.$showOpenDialog(S).then(h=>h?h.map(R=>n.URI.revive(R)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(S=>S?n.URI.revive(S):void 0)}}e.ExtHostDialogs=F}),define(Te[222],Pe([1,0,9,2,7,4,15,21,13]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class h{constructor(b,g,_){this._documentsAndEditors=g,this._logService=_,this._documentContentProviders=new Map,this._proxy=b.getProxy(F.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,g){if(Object.keys(A.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const _=h._handlePool++;this._documentContentProviders.set(_,g),this._proxy.$registerTextContentProvider(_,b);let p;return typeof g.onDidChange=="function"&&(p=g.onDidChange(u=>{if(u.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(_,u).then(t=>{if(!t&&typeof t!="string")return;const o=this._documentsAndEditors.getDocument(u);if(!o)return;const d=(0,S.splitLines)(t);if(!o.equalLines(d))return this._proxy.$onVirtualDocumentChange(u,t)},n.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(_)&&this._proxy.$unregisterTextContentProvider(_),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(b,g){const _=this._documentContentProviders.get(b);return _?Promise.resolve(_.provideTextDocumentContent(T.URI.revive(g),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=h,h._handlePool=0}),define(Te[223],Pe([1,0,5,6,2,4,102,8,12,23,7]),function(te,e,n,T,D,F,A,P,S,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(_,p){this._onDidAddDocument=new n.Emitter,this._onDidRemoveDocument=new n.Emitter,this._onDidChangeDocument=new n.Emitter,this._onDidSaveDocument=new n.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(F.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const t of u)this._onDidRemoveDocument.fire(t.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const t of u)this._onDidAddDocument.fire(t.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!_)return;const p=this._documentsAndEditors.getDocument(_);if(p)return p}getDocument(_){const p=this.getDocumentData(_);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${_}'`);return p.document}ensureDocumentData(_){const p=this._documentsAndEditors.getDocument(_);if(p)return Promise.resolve(p);let u=this._documentLoader.get(_.toString());return u||(u=this._proxy.$tryOpenDocument(_).then(t=>{this._documentLoader.delete(_.toString());const o=D.URI.revive(t);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(o))},t=>(this._documentLoader.delete(_.toString()),Promise.reject(t))),this._documentLoader.set(_.toString(),u)),u}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(p=>D.URI.revive(p))}$acceptModelLanguageChanged(_,p){const u=D.URI.revive(_),t=this._documentsAndEditors.getDocument(u);if(!t)throw new Error("unknown document");this._onDidRemoveDocument.fire(t.document),t._acceptLanguageId(p),this._onDidAddDocument.fire(t.document)}$acceptModelSaved(_){const p=D.URI.revive(_),u=this._documentsAndEditors.getDocument(p);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(_,p){const u=D.URI.revive(_),t=this._documentsAndEditors.getDocument(u);if(!t)throw new Error("unknown document");t._acceptIsDirty(p),this._onDidChangeDocument.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(_,p,u){const t=D.URI.revive(_),o=this._documentsAndEditors.getDocument(t);if(!o)throw new Error("unknown document");o._acceptIsDirty(u),o.onEvents(p);let d;p.isUndoing?d=R.TextDocumentChangeReason.Undo:p.isRedoing&&(d=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,h.deepFreeze)({document:o.document,contentChanges:p.changes.map(y=>({range:P.Range.to(y.range),rangeOffset:y.rangeOffset,rangeLength:y.rangeLength,text:y.text})),reason:d}))}setWordDefinitionFor(_,p){(0,A.setWordDefinitionFor)(_,p)}}e.ExtHostDocuments=b}),define(Te[59],Pe([1,0,49,5,6,2,3,4,102,18,105,8,14,28,15,86,87]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class o{constructor(k){this.value=k,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let d=e.ExtHostDocumentsAndEditors=class{constructor(k,v){this._extHostRpc=k,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new _.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(k){this.acceptDocumentsAndEditorsDelta(k)}acceptDocumentsAndEditorsDelta(k){const v=[],i=[],a=[];if(k.removedDocuments)for(const r of k.removedDocuments){const s=F.URI.revive(r),w=this._documents.get(s);w?.unref()&&(this._documents.delete(s),v.push(w.value))}if(k.addedDocuments)for(const r of k.addedDocuments){const s=F.URI.revive(r.uri);let w=this._documents.get(s);if(w&&s.scheme!==p.Schemas.vscodeNotebookCell&&s.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);w||(w=new o(new S.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(s,w),i.push(w.value)),w.ref()}if(k.removedEditors)for(const r of k.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&a.push(s)}if(k.addedEditors)for(const r of k.addedEditors){const s=F.URI.revive(r.documentUri);n.ok(this._documents.has(s),`document '${s}' does not exist`),n.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const w=this._documents.get(s).value,I=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new t.Lazy(()=>w.document),r.selections.map(b.Selection.to),r.options,r.visibleRanges.map(c=>b.Range.to(c)),typeof r.editorPosition=="number"?b.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,I)}k.newActiveEditor!==void 0&&(n.ok(k.newActiveEditor===null||this._editors.has(k.newActiveEditor),`active editor '${k.newActiveEditor}' does not exist`),this._activeEditorId=k.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(a),k.removedDocuments&&this._onDidRemoveDocuments.fire(v),k.addedDocuments&&this._onDidAddDocuments.fire(i),(k.removedEditors||k.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),k.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(k){return this._documents.get(k)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),k=>k.value)}getEditor(k){return this._editors.get(k)}activeEditor(k){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return k?v:v?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=d=je([Ve(0,h.IExtHostRpcService),Ve(1,g.ILogService)],d),e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(Te[60],Pe([1,0,8,4,2,5,3,7,18,12,64]),function(te,e,n,T,D,F,A,P,S,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class b{constructor(t,o,d){this._activeTabIdGetter=d,this._parentGroup=o,this.acceptDtoUpdate(t)}get apiObject(){if(!this._apiObject){const t=this,o={get isActive(){return t._dto.id===t._activeTabIdGetter()},get label(){return t._dto.label},get input(){return t._input},get isDirty(){return t._dto.isDirty},get isPinned(){return t._dto.isPinned},get isPreview(){return t._dto.isPreview},get group(){return t._parentGroup.apiObject}};this._apiObject=Object.freeze(o)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(t){this._dto=t,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(D.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified));case 3:return new P.TextMergeTabInput(D.URI.revive(this._dto.input.base),D.URI.revive(this._dto.input.input1),D.URI.revive(this._dto.input.input2),D.URI.revive(this._dto.input.result));case 6:return new P.CustomEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new P.NotebookEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(D.URI.revive(this._dto.input.uri),D.URI.revive(this._dto.input.inputBoxUri));default:return}}}class g{constructor(t,o){this._tabs=[],this._activeTabId="",this._dto=t,this._activeGroupIdGetter=o;for(const d of t.tabs)d.isActive&&(this._activeTabId=d.id),this._tabs.push(new b(d,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const t=this,o={get isActive(){return t._dto.groupId===t._activeGroupIdGetter()},get viewColumn(){return n.ViewColumn.to(t._dto.viewColumn)},get activeTab(){return t._tabs.find(d=>d.tabId===t._activeTabId)?.apiObject},get tabs(){return Object.freeze(t._tabs.map(d=>d.apiObject))}};this._apiObject=Object.freeze(o)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(t){this._dto=t}acceptTabOperation(t){if(t.kind===0){const d=new b(t.tabDto,this,()=>this.activeTabId());return this._tabs.splice(t.index,0,d),t.tabDto.isActive&&(this._activeTabId=d.tabId),d}else if(t.kind===1){const d=this._tabs.splice(t.index,1)[0];if(!d)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return d.tabId===this._activeTabId&&(this._activeTabId=""),d}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const d=this._tabs.splice(t.oldIndex,1)[0];if(!d)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this._tabs.splice(t.index,0,d),d}const o=this._tabs.find(d=>d.tabId===t.tabDto.id);if(!o)throw new Error("INVALID tab");return t.tabDto.isActive?this._activeTabId=t.tabDto.id:this._activeTabId===t.tabDto.id&&!t.tabDto.isActive&&(this._activeTabId=""),o.acceptDtoUpdate(t.tabDto),o}activeTabId(){return this._activeTabId}}let _=e.ExtHostEditorTabs=class{constructor(t){this._onDidChangeTabs=new F.Emitter,this._onDidChangeTabGroups=new F.Emitter,this._extHostTabGroups=[],this._proxy=t.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const t=this,o={onDidChangeTabGroups:t._onDidChangeTabGroups.event,onDidChangeTabs:t._onDidChangeTabs.event,get all(){return Object.freeze(t._extHostTabGroups.map(d=>d.apiObject))},get activeTabGroup(){const d=t._activeGroupId;return(0,h.assertIsDefined)(t._extHostTabGroups.find(k=>k.groupId===d)?.apiObject)},close:async(d,y)=>{const k=Array.isArray(d)?d:[d];return k.length?p(k[0])?this._closeGroups(k,y):this._closeTabs(k,y):!0}};this._apiObject=Object.freeze(o)}return this._apiObject}$acceptEditorTabModel(t){const o=new Set(this._extHostTabGroups.map(r=>r.groupId)),d=new Set(t.map(r=>r.groupId)),y=(0,R.diffSets)(o,d),k=this._extHostTabGroups.filter(r=>y.removed.includes(r.groupId)).map(r=>r.apiObject),v=[],i=[];this._extHostTabGroups=t.map(r=>{const s=new g(r,()=>this._activeGroupId);return y.added.includes(s.groupId)?v.push(s.apiObject):i.push(s.apiObject),s});const a=(0,h.assertIsDefined)(t.find(r=>r.isActive===!0)?.groupId);a!==void 0&&this._activeGroupId!==a&&(this._activeGroupId=a),this._onDidChangeTabGroups.fire(Object.freeze({opened:v,closed:k,changed:i}))}$acceptTabGroupUpdate(t){const o=this._extHostTabGroups.find(d=>d.groupId===t.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(t),t.isActive&&(this._activeGroupId=t.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const o=this._extHostTabGroups.find(y=>y.groupId===t.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const d=o.acceptTabOperation(t);switch(t.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[d.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[d.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[d.apiObject]}));return}}_findExtHostTabFromApi(t){for(const o of this._extHostTabGroups)for(const d of o.tabs)if(d.apiObject===t)return d}_findExtHostTabGroupFromApi(t){return this._extHostTabGroups.find(o=>o.apiObject===t)}async _closeTabs(t,o){const d=[];for(const y of t){const k=this._findExtHostTabFromApi(y);if(!k)throw new Error("Tab close: Invalid tab not found!");d.push(k.tabId)}return this._proxy.$closeTab(d,o)}async _closeGroups(t,o){const d=[];for(const y of t){const k=this._findExtHostTabGroupFromApi(y);if(!k)throw new Error("Group close: Invalid group not found!");d.push(k.groupId)}return this._proxy.$closeGroup(d,o)}};e.ExtHostEditorTabs=_=je([Ve(0,S.IExtHostRpcService)],_);function p(u){return u.tabs!==void 0}}),define(Te[224],Pe([1,0,2,4,6,7,8,271,13,25,26]),function(te,e,n,T,D,F,A,P,S,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const u=this._schemes.indexOf(p);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),u=[];let t,o,d=14,y=14;for(const k of p){let v=t?(0,S.commonPrefixLength)(t,k):0;for(v===0?o=1:o=y;v<k.length;v++)v+1===k.length?(d=y,y=9):y+=1,u.push([o,k.toUpperCase().charCodeAt(v),y]),u.push([o,k.toLowerCase().charCodeAt(v),y]),o=y;t=k,y=d}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new P.StateMachine(u)}}provideDocumentLinks(p){this._initStateMachine();const u=[],t=P.LinkComputer.computeLinks({getLineContent(o){return p.lineAt(o-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const o of t){const d=A.DocumentLink.to(o);d.target&&u.push(d)}return u}}class g{constructor(p,u){this._extHostLanguageFeatures=u,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(p,u,t,o={}){if(g._validateFileSystemProvider(t),this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(p,"*",this._linkProvider));const d=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(d,t);let y=2;o.isCaseSensitive&&(y+=1024),o.isReadonly&&(y+=2048),typeof t.copy=="function"&&(y+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,R.checkProposedApiEnabled)(p,"fsChunks"),y+=4),this._proxy.$registerFileSystemProvider(d,u,y).catch(v=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${u}`),console.error(v)});const k=t.onDidChangeFile(v=>{const i=[];for(const a of v){const{uri:r,type:s}=a;if(r.scheme!==u)continue;let w;switch(s){case F.FileChangeType.Changed:w=0;break;case F.FileChangeType.Created:w=1;break;case F.FileChangeType.Deleted:w=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:r,type:w})}this._proxy.$onFileSystemChange(d,i)});return(0,D.toDisposable)(()=>{k.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(d),this._proxy.$unregisterProvider(d)})}static _validateFileSystemProvider(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(p){const{type:u,ctime:t,mtime:o,size:d,permissions:y}=p;return{type:u,ctime:t,mtime:o,size:d,permissions:y}}$stat(p,u){return Promise.resolve(this._getFsProvider(p).stat(n.URI.revive(u))).then(t=>g._asIStat(t))}$readdir(p,u){return Promise.resolve(this._getFsProvider(p).readDirectory(n.URI.revive(u)))}$readFile(p,u){return Promise.resolve(this._getFsProvider(p).readFile(n.URI.revive(u))).then(t=>h.VSBuffer.wrap(t))}$writeFile(p,u,t,o){return Promise.resolve(this._getFsProvider(p).writeFile(n.URI.revive(u),t.buffer,o))}$delete(p,u,t){return Promise.resolve(this._getFsProvider(p).delete(n.URI.revive(u),t))}$rename(p,u,t,o){return Promise.resolve(this._getFsProvider(p).rename(n.URI.revive(u),n.URI.revive(t),o))}$copy(p,u,t,o){const d=this._getFsProvider(p);if(!d.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(d.copy(n.URI.revive(u),n.URI.revive(t),o))}$mkdir(p,u){return Promise.resolve(this._getFsProvider(p).createDirectory(n.URI.revive(u)))}$watch(p,u,t,o){const d=this._getFsProvider(p).watch(n.URI.revive(t),o);this._watches.set(u,d)}$unwatch(p,u){const t=this._watches.get(u);t&&(t.dispose(),this._watches.delete(u))}$open(p,u,t){const o=this._getFsProvider(p);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(n.URI.revive(u),t))}$close(p,u){const t=this._getFsProvider(p);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(u))}$read(p,u,t,o){const d=this._getFsProvider(p);if(!d.read)throw new Error('FileSystemProvider does not implement "read"');const y=h.VSBuffer.alloc(o);return Promise.resolve(d.read(u,t,y.buffer,0,o)).then(k=>y.slice(0,k))}$write(p,u,t,o){const d=this._getFsProvider(p);if(!d.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(d.write(u,t,o.buffer,0,o.byteLength))}_getFsProvider(p){const u=this._fsProvider.get(p);if(!u){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return u}}e.ExtHostFileSystem=g}),define(Te[61],Pe([1,0,4,43,7,25,3,18,37,6]),function(te,e,n,T,D,F,A,P,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=e.ExtHostConsumerFileSystem=class Zt{constructor(g,_){this._fileSystemProvider=new Map,this._proxy=g.getProxy(n.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(u){try{const t=p._fileSystemProvider.get(u.scheme);if(!t)return await p._proxy.$stat(u);await p._proxy.$ensureActivation(u.scheme);const o=await t.stat(u);return{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions}}catch(t){Zt._handleError(t)}},async readDirectory(u){try{const t=p._fileSystemProvider.get(u.scheme);return t?(await p._proxy.$ensureActivation(u.scheme),(await t.readDirectory(u)).slice()):await p._proxy.$readdir(u)}catch(t){return Zt._handleError(t)}},async createDirectory(u){try{return await p._proxy.$mkdir(u)}catch(t){return Zt._handleError(t)}},async readFile(u){try{const t=p._fileSystemProvider.get(u.scheme);return t?(await p._proxy.$ensureActivation(u.scheme),(await t.readFile(u)).slice()):(await p._proxy.$readFile(u)).buffer}catch(t){return Zt._handleError(t)}},async writeFile(u,t){try{return await p._proxy.$writeFile(u,F.VSBuffer.wrap(t))}catch(o){return Zt._handleError(o)}},async delete(u,t){try{const o=p._fileSystemProvider.get(u.scheme);return o?(await p._proxy.$ensureActivation(u.scheme),await o.delete(u,{recursive:!1,...t})):await p._proxy.$delete(u,{recursive:!1,useTrash:!1,...t})}catch(o){return Zt._handleError(o)}},async rename(u,t,o){try{return await p._proxy.$rename(u,t,{overwrite:!1,...o})}catch(d){return Zt._handleError(d)}},async copy(u,t,o){try{return await p._proxy.$copy(u,t,{overwrite:!1,...o})}catch(d){return Zt._handleError(d)}},isWritableFileSystem(u){const t=_.getCapabilities(u);if(typeof t=="number")return!(t&2048)}})}static _handleError(g){if(g instanceof D.FileSystemError)throw g;if(!(g instanceof Error))throw new D.FileSystemError(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(g.message);switch(g.name){case T.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(g.message);case T.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(g.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(g.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(g.message);case T.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(g.message);case T.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(g.message);default:throw new D.FileSystemError(g.message,g.name)}}addFileSystemProvider(g,_){return this._fileSystemProvider.set(g,_),(0,h.toDisposable)(()=>this._fileSystemProvider.delete(g))}};e.ExtHostConsumerFileSystem=R=je([Ve(0,P.IExtHostRpcService),Ve(1,S.IExtHostFileSystemInfo)],R),e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(Te[225],Pe([1,0,5,36,2,4,8,7]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(b,g,_,p,u,t,o,d){this._onDidCreate=new n.Emitter,this._onDidChange=new n.Emitter,this._onDidDelete=new n.Emitter;const y=this.ensureWatching(b,_,u);this._config=0,t&&(this._config+=1),o&&(this._config+=2),d&&(this._config+=4);const k=(0,T.parse)(u),v=typeof u=="string",i=p(a=>{if(!t)for(const r of a.created){const s=D.URI.revive(r);k(s.fsPath)&&(!v||g.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!o)for(const r of a.changed){const s=D.URI.revive(r);k(s.fsPath)&&(!v||g.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!d)for(const r of a.deleted){const s=D.URI.revive(r);k(s.fsPath)&&(!v||g.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=P.Disposable.from(y,this._onDidCreate,this._onDidChange,this._onDidDelete,i)}ensureWatching(b,g,_){const p=P.Disposable.from();if(typeof _=="string")return p;const u=b.getProxy(F.MainContext.MainThreadFileSystem);let t=!1;(_.pattern.includes(T.GLOBSTAR)||_.pattern.includes(T.GLOB_SPLIT))&&(t=!0);const o=Math.random();return u.$watch(g.identifier.value,o,_.baseUri,{recursive:t,excludes:[]}),P.Disposable.from({dispose:()=>u.$unwatch(o)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class h{constructor(b,g,_){this._mainContext=b,this._logService=g,this._extHostDocumentsAndEditors=_,this._onFileSystemEvent=new n.Emitter,this._onDidRenameFile=new n.Emitter,this._onDidCreateFile=new n.Emitter,this._onDidDeleteFile=new n.Emitter,this._onWillRenameFile=new n.AsyncEmitter,this._onWillCreateFile=new n.AsyncEmitter,this._onWillDeleteFile=new n.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,g,_,p,u,t){return new S(this._mainContext,b,g,this._onFileSystemEvent.event,A.GlobPattern.from(_),p,u,t)}$onFileEvent(b){this._onFileSystemEvent.fire(b)}$onDidRunFileOperation(b,g){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(_=>({oldUri:D.URI.revive(_.source),newUri:D.URI.revive(_.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(_=>D.URI.revive(_.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:g.map(_=>D.URI.revive(_.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,g){return(_,p,u)=>{const t=function(d){_.call(p,d)};return t.extension=b,g.event(t,void 0,u)}}async $onWillRunFileOperation(b,g,_,p){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(u=>({oldUri:D.URI.revive(u.source),newUri:D.URI.revive(u.target)}))},_,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(u=>D.URI.revive(u.target))},_,p);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(u=>D.URI.revive(u.target))},_,p)}}async _fireWillEvent(b,g,_,p){const u=new Set,t=[];if(await b.fireAsync(g,p,async(d,y)=>{const k=Date.now(),v=await Promise.resolve(d);v instanceof P.WorkspaceEdit&&(t.push([y.extension,v]),u.add(y.extension.displayName??y.extension.identifier.value)),Date.now()-k>_&&this._logService.warn("SLOW file-participant",y.extension.identifier)}),p.isCancellationRequested||t.length===0)return;const o={edits:[]};for(const[,d]of t){const{edits:y}=A.WorkspaceEdit.from(d,{getTextDocumentVersion:k=>this._extHostDocumentsAndEditors.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(y)}return{edit:o,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=h}),define(Te[226],Pe([1,0,2,38]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(A,P,S,h,R){this._extHostNotebooks=P,this._textDocumentsAndEditors=S,this._commands=h;const b=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",g=>!0,g=>g),new T.ApiCommandArgument("resource","Interactive resource Uri",g=>!0,g=>g),new T.ApiCommandArgument("controllerId","Notebook controller Id",g=>!0,g=>g),new T.ApiCommandArgument("title","Interactive editor title",g=>!0,g=>g)],new T.ApiCommandResult("Notebook and input URI",g=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",g.notebookEditorId),g.notebookEditorId!==void 0){const _=this._extHostNotebooks.getEditorById(g.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",_.id),{notebookUri:n.URI.revive(g.notebookUri),inputUri:n.URI.revive(g.inputUri),notebookEditor:_.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",g.notebookUri,g.inputUri),{notebookUri:n.URI.revive(g.notebookUri),inputUri:n.URI.revive(g.inputUri)}}));this._commands.registerApiCommand(b)}$willAddInteractiveDocument(A,P,S,h){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:S,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(n.URI.revive(h))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=D}),define(Te[227],Pe([1,0,6,2,4,8,7]),function(te,e,n,T,D,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class P{constructor(b,g){this.extension=b,this.provider=g,this.handle=P._pool++}}P._pool=0;class S{constructor(b){this.session=b,this.responses=[]}}class h{constructor(b,g,_){this._documents=g,this._logService=_,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=b.getProxy(D.MainContext.MainThreadInteractiveEditor)}registerProvider(b,g){const _=new P(b,g);return this._inputProvider.set(_.handle,_),this._proxy.$registerInteractiveEditorProvider(_.handle,b.identifier.value,typeof g.handleInteractiveEditorResponseFeedback=="function"),(0,n.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(_.handle),this._inputProvider.delete(_.handle)})}async $prepareInteractiveSession(b,g,_,p){const u=this._inputProvider.get(b);if(!u){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const t=this._documents.getDocument(T.URI.revive(g)),o=F.Selection.to(_),d=await u.provider.prepareInteractiveEditorSession({document:t,selection:o},p);if(!d)return;if(d.wholeRange&&!d.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const y=h._nextId++;return this._inputSessions.set(y,new S(d)),{id:y,placeholder:d.placeholder,slashCommands:d.slashCommands,wholeRange:F.Range.from(d.wholeRange)}}async $provideResponse(b,g,_,p){const u=this._inputProvider.get(b);if(!u)return;const t=this._inputSessions.get(g.id);if(!t)return;const o=await u.provider.provideInteractiveEditorResponse({session:t.session,prompt:_.prompt,selection:F.Selection.to(_.selection),wholeRange:F.Range.to(_.wholeRange)},p);if(o){const d=t.responses.push(o)-1,y={wholeRange:F.Range.from(o.wholeRange),placeholder:o.placeholder};if(h._isMessageResponse(o))return{...y,id:d,type:"message",message:F.MarkdownString.from(o.contents)};const{edits:k}=o;if(k instanceof A.WorkspaceEdit)return{...y,id:d,type:"bulkEdit",edits:F.WorkspaceEdit.from(k)};if(Array.isArray(k))return{...y,id:d,type:"editorEdit",edits:k.map(F.TextEdit.from)}}}$handleFeedback(b,g,_,p){const u=this._inputProvider.get(b),t=this._inputSessions.get(g),o=t?.responses[_];if(u&&o){let d;switch(p){case 1:d=A.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:d=A.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:d=A.InteractiveEditorResponseFeedbackKind.Undone;break}u.provider.handleInteractiveEditorResponseFeedback?.(t.session,o,d)}}$releaseSession(b,g){const _=this._inputSessions.get(g),p=this._inputProvider.get(b);_&&p&&p.provider.releaseInteractiveEditorSession?.(_.session),this._inputSessions.delete(g)}static _isMessageResponse(b){return typeof b=="object"&&typeof b.contents=="object"}}e.ExtHostInteractiveEditor=h,h._nextId=0}),define(Te[228],Pe([1,0,5,6,58,147,4,8]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class S{constructor(b,g){this.extension=b,this.provider=g,this.handle=S._pool++}}S._pool=0;class h{constructor(b,g){this.logService=g,this._interactiveSessionProvider=new Map,this._interactiveSessions=new Map,this._onDidPerformUserAction=new n.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=b.getProxy(A.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(b,g,_){const p=new S(b,_);return this._interactiveSessionProvider.set(p.handle,p),this._proxy.$registerInteractiveSessionProvider(p.handle,g),(0,T.toDisposable)(()=>{this._proxy.$unregisterInteractiveSessionProvider(p.handle),this._interactiveSessionProvider.delete(p.handle)})}addInteractiveSessionRequest(b){this._proxy.$addInteractiveSessionRequest(b)}sendInteractiveRequestToProvider(b,g){this._proxy.$sendInteractiveRequestToProvider(b,g)}async $prepareInteractiveSession(b,g,_){const p=this._interactiveSessionProvider.get(b);if(!p)return;const u=await p.provider.prepareSession(g,_);if(!u)return;const t=h._nextId++;return this._interactiveSessions.set(t,u),{id:t,requesterUsername:u.requester?.name,requesterAvatarIconUri:u.requester?.icon,responderUsername:u.responder?.name,responderAvatarIconUri:u.responder?.icon,inputPlaceholder:u.inputPlaceholder}}async $resolveInteractiveRequest(b,g,_,p){const u=this._interactiveSessionProvider.get(b);if(!u)return;const t=this._interactiveSessions.get(g);if(!t||!u.provider.resolveRequest)return;const o=await u.provider.resolveRequest(t,_,p);if(o)return{message:typeof o.message=="string"?o.message:P.InteractiveSessionReplyFollowup.from(o.message)}}async $provideWelcomeMessage(b,g){const _=this._interactiveSessionProvider.get(b);if(!_||!_.provider.provideWelcomeMessage)return;const p=await _.provider.provideWelcomeMessage(g);if(p)return p.map(u=>typeof u=="string"?u:u.map(t=>P.InteractiveSessionReplyFollowup.from(t)))}async $provideFollowups(b,g,_){const p=this._interactiveSessionProvider.get(b);if(!p)return;const u=this._interactiveSessions.get(g);return!u||!p.provider.provideFollowups?void 0:(await p.provider.provideFollowups(u,_))?.map(o=>P.InteractiveSessionFollowup.from(o))}async $provideInteractiveReply(b,g,_,p){const u=this._interactiveSessionProvider.get(b);if(!u)return;const t=this._interactiveSessions.get(g);if(!t)return;const o={session:t,message:typeof _.message=="string"?_.message:P.InteractiveSessionReplyFollowup.to(_.message)},d=D.StopWatch.create(!1);let y;const k={report:a=>{p.isCancellationRequested||(typeof y>"u"&&(y=d.elapsed()),this._proxy.$acceptInteractiveResponseProgress(b,g,a))}};let v;try{v=await u.provider.provideResponseWithProgress(o,k,p),v||(v={errorDetails:{message:(0,F.localize)(0,null)}})}catch(a){v={errorDetails:{message:(0,F.localize)(1,null,a.message),responseIsIncomplete:!0}},this.logService.error(a)}try{if(t.saveState&&this._interactiveSessions.has(g)){const a=t.saveState();this._proxy.$acceptInteractiveSessionState(g,a)}}catch(a){this.logService.warn(a)}const i={firstProgress:y??0,totalElapsed:d.elapsed()};return{errorDetails:v.errorDetails,timings:i}}async $provideSlashCommands(b,g,_){const p=this._interactiveSessionProvider.get(b);if(!p)return;const u=this._interactiveSessions.get(g);return!u||!p.provider.provideSlashCommands?void 0:(await p.provider.provideSlashCommands(u,_))?.map(o=>({...o,kind:P.CompletionItemKind.from(o.kind)}))}$releaseSession(b){this._interactiveSessions.delete(b)}async $onDidPerformUserAction(b){this._onDidPerformUserAction.fire(b)}}e.ExtHostInteractiveSession=h,h._nextId=0}),define(Te[229],Pe([1,0,4,7]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class D{constructor(A){this._IssueUriRequestHandlers=new Map,this._proxy=A.getProxy(n.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(A,P){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const S=this._IssueUriRequestHandlers.get(A);if(!S)throw new Error("Issue request handler not found");const h=await S.handleIssueUrlRequest();if(!h)throw new Error("Issue request handler returned no result");return h}registerIssueUriRequestHandler(A,P){const S=A.identifier.value;return this._IssueUriRequestHandlers.set(S,P),this._proxy.$registerIssueUriRequestHandler(S),new T.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(S),this._IssueUriRequestHandlers.delete(S)})}}e.ExtHostIssueReporter=D}),define(Te[230],Pe([1,0,6,4]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(A){this._handlePool=0,this._proxy=A.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,A),(0,n.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=D}),define(Te[231],Pe([1,0,2,23,8,7,77,4,13,44,16,12,272,21,6,90,84,54,58,9,17,26,148]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o,d,y,k,v,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class a{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentSymbols(C,z){const V=this._documents.getDocument(C),j=await this._provider.provideDocumentSymbols(V,z);if(!(0,R.isFalsyOrEmpty)(j))return j[0]instanceof F.DocumentSymbol?j.map(D.DocumentSymbol.from):a._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(C){C=C.slice(0).sort((j,ae)=>{let ge=j.location.range.start.compareTo(ae.location.range.start);return ge===0&&(ge=ae.location.range.end.compareTo(j.location.range.end)),ge});const z=[],V=[];for(const j of C){const ae={name:j.name||"!!MISSING: name!!",kind:D.SymbolKind.from(j.kind),tags:j.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:D.Range.from(j.location.range),selectionRange:D.Range.from(j.location.range),children:[]};for(;;){if(V.length===0){V.push(ae),z.push(ae);break}const ge=V[V.length-1];if(h.Range.containsRange(ge.range,ae.range)&&!h.Range.equalsRange(ge.range,ae.range)){ge.children?.push(ae),V.push(ae);break}V.pop()}}return z}}class r{constructor(C,z,V){this._documents=C,this._commands=z,this._provider=V,this._cache=new o.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(C,z){const V=this._documents.getDocument(C),j=await this._provider.provideCodeLenses(V,z);if(!j||z.isCancellationRequested)return;const ae=this._cache.add(j),ge=new p.DisposableStore;this._disposables.set(ae,ge);const ee={cacheId:ae,lenses:[]};for(let be=0;be<j.length;be++)ee.lenses.push({cacheId:[ae,be],range:D.Range.from(j[be].range),command:this._commands.toInternal(j[be].command,ge)});return ee}async resolveCodeLens(C,z){const V=C.cacheId&&this._cache.get(...C.cacheId);if(!V)return;let j;if(typeof this._provider.resolveCodeLens!="function"||V.isResolved?j=V:j=await this._provider.resolveCodeLens(V,z),j||(j=V),z.isCancellationRequested)return;const ae=C.cacheId&&this._disposables.get(C.cacheId[0]);if(ae)return C.command=this._commands.toInternal(j.command??r._badCmd,ae),C}releaseCodeLenses(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(ne){return Array.isArray(ne)?ne.map(D.DefinitionLink.from):ne?[D.DefinitionLink.from(ne)]:[]}class w{constructor(C,z){this._documents=C,this._provider=z}async provideDefinition(C,z,V){const j=this._documents.getDocument(C),ae=D.Position.to(z),ge=await this._provider.provideDefinition(j,ae,V);return s(ge)}}class I{constructor(C,z){this._documents=C,this._provider=z}async provideDeclaration(C,z,V){const j=this._documents.getDocument(C),ae=D.Position.to(z),ge=await this._provider.provideDeclaration(j,ae,V);return s(ge)}}class c{constructor(C,z){this._documents=C,this._provider=z}async provideImplementation(C,z,V){const j=this._documents.getDocument(C),ae=D.Position.to(z),ge=await this._provider.provideImplementation(j,ae,V);return s(ge)}}class l{constructor(C,z){this._documents=C,this._provider=z}async provideTypeDefinition(C,z,V){const j=this._documents.getDocument(C),ae=D.Position.to(z),ge=await this._provider.provideTypeDefinition(j,ae,V);return s(ge)}}class m{constructor(C,z){this._documents=C,this._provider=z}async provideHover(C,z,V){const j=this._documents.getDocument(C),ae=D.Position.to(z),ge=await this._provider.provideHover(j,ae,V);if(!(!ge||(0,R.isFalsyOrEmpty)(ge.contents)))return ge.range||(ge.range=j.getWordRangeAtPosition(ae)),ge.range||(ge.range=new F.Range(ae,ae)),D.Hover.from(ge)}}class E{constructor(C,z){this._documents=C,this._provider=z}async provideEvaluatableExpression(C,z,V){const j=this._documents.getDocument(C),ae=D.Position.to(z),ge=await this._provider.provideEvaluatableExpression(j,ae,V);if(ge)return D.EvaluatableExpression.from(ge)}}class f{constructor(C,z){this._documents=C,this._provider=z}async provideInlineValues(C,z,V,j){const ae=this._documents.getDocument(C),ge=await this._provider.provideInlineValues(ae,D.Range.to(z),D.InlineValueContext.to(V),j);if(Array.isArray(ge))return ge.map(ee=>D.InlineValue.from(ee))}}class L{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentHighlights(C,z,V){const j=this._documents.getDocument(C),ae=D.Position.to(z),ge=await this._provider.provideDocumentHighlights(j,ae,V);if(Array.isArray(ge))return ge.map(D.DocumentHighlight.from)}}class W{constructor(C,z){this._documents=C,this._provider=z}async provideLinkedEditingRanges(C,z,V){const j=this._documents.getDocument(C),ae=D.Position.to(z),ge=await this._provider.provideLinkedEditingRanges(j,ae,V);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,R.coalesce)(ge.ranges.map(D.Range.from)),wordPattern:ge.wordPattern}}}class J{constructor(C,z){this._documents=C,this._provider=z}async provideReferences(C,z,V,j){const ae=this._documents.getDocument(C),ge=D.Position.to(z),ee=await this._provider.provideReferences(ae,ge,V,j);if(Array.isArray(ee))return ee.map(D.location.from)}}class q{constructor(C,z,V,j,ae,ge,ee){this._documents=C,this._commands=z,this._diagnostics=V,this._provider=j,this._logService=ae,this._extension=ge,this._apiDeprecation=ee,this._cache=new o.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(C,z,V,j){const ae=this._documents.getDocument(C),ge=g.Selection.isISelection(z)?D.Selection.to(z):D.Range.to(z),ee=[];for(const Qe of this._diagnostics.getDiagnostics(C))if(ge.intersection(Qe.range)&&ee.push(Qe)>q._maxCodeActionsPerFile)break;const be={diagnostics:ee,only:V.only?new F.CodeActionKind(V.only):void 0,triggerKind:D.CodeActionTriggerKind.to(V.trigger)},Se=await this._provider.provideCodeActions(ae,ge,be,j);if(!(0,R.isNonEmptyArray)(Se)||j.isCancellationRequested)return;const xe=this._cache.add(Se),He=new p.DisposableStore;this._disposables.set(xe,He);const et=[];for(let Qe=0;Qe<Se.length;Qe++){const Ye=Se[Qe];Ye&&(q._isCommand(Ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Ye.title,command:this._commands.toInternal(Ye,He)})):(be.only&&(Ye.kind?be.only.contains(Ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${Ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[xe,Qe],title:Ye.title,command:Ye.command&&this._commands.toInternal(Ye.command,He),diagnostics:Ye.diagnostics&&Ye.diagnostics.map(D.Diagnostic.from),edit:Ye.edit&&D.WorkspaceEdit.from(Ye.edit,void 0),kind:Ye.kind&&Ye.kind.value,isPreferred:Ye.isPreferred,disabled:Ye.disabled?.reason})))}return{cacheId:xe,actions:et}}async resolveCodeAction(C,z){const[V,j]=C,ae=this._cache.get(V,j);if(!ae||q._isCommand(ae))return{};if(!this._provider.resolveCodeAction)return{};const ge=await this._provider.resolveCodeAction(ae,z)??ae;let ee;ge.edit&&(ee=D.WorkspaceEdit.from(ge.edit,void 0));let be;if(ge.command){const Se=this._disposables.get(V);Se&&(be=this._commands.toInternal(ge.command,Se))}return{edit:ee,command:be}}releaseCodeActions(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}static _isCommand(C){return typeof C.command=="string"&&typeof C.title=="string"}}q._maxCodeActionsPerFile=1e3;class U{constructor(C,z,V,j){this._proxy=C,this._documents=z,this._provider=V,this._handle=j}async prepareDocumentPaste(C,z,V,j){if(!this._provider.prepareDocumentPaste)return;const ae=this._documents.getDocument(C),ge=z.map(be=>D.Range.to(be)),ee=D.DataTransfer.toDataTransfer(V,()=>{throw new y.NotImplementedError});return await this._provider.prepareDocumentPaste(ae,ge,ee,j),D.DataTransfer.toDataTransferDTO(ee)}async providePasteEdits(C,z,V,j,ae){const ge=this._documents.getDocument(z),ee=V.map(xe=>D.Range.to(xe)),be=D.DataTransfer.toDataTransfer(j,async xe=>(await this._proxy.$resolvePasteFileData(this._handle,C,xe)).buffer),Se=await this._provider.provideDocumentPasteEdits(ge,ee,be,ae);if(Se)return{insertText:typeof Se.insertText=="string"?Se.insertText:{snippet:Se.insertText.value},additionalEdit:Se.additionalEdit?D.WorkspaceEdit.from(Se.additionalEdit,void 0):void 0}}}class B{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentFormattingEdits(C,z,V){const j=this._documents.getDocument(C),ae=await this._provider.provideDocumentFormattingEdits(j,z,V);if(Array.isArray(ae))return ae.map(D.TextEdit.from)}}class G{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentRangeFormattingEdits(C,z,V,j){const ae=this._documents.getDocument(C),ge=D.Range.to(z),ee=await this._provider.provideDocumentRangeFormattingEdits(ae,ge,V,j);if(Array.isArray(ee))return ee.map(D.TextEdit.from)}async provideDocumentRangesFormattingEdits(C,z,V,j){(0,b.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this._documents.getDocument(C),ge=z.map(D.Range.to),ee=await this._provider.provideDocumentRangesFormattingEdits(ae,ge,V,j);if(Array.isArray(ee))return ee.map(D.TextEdit.from)}}class N{constructor(C,z){this._documents=C,this._provider=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(C,z,V,j,ae){const ge=this._documents.getDocument(C),ee=D.Position.to(z),be=await this._provider.provideOnTypeFormattingEdits(ge,ee,V,j,ae);if(Array.isArray(be))return be.map(D.TextEdit.from)}}class H{constructor(C,z){this._provider=C,this._logService=z,this._cache=new o.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(C,z){const V=await this._provider.provideWorkspaceSymbols(C,z);if(!(0,R.isNonEmptyArray)(V))return{symbols:[]};const j=this._cache.add(V),ae={cacheId:j,symbols:[]};for(let ge=0;ge<V.length;ge++){const ee=V[ge];if(!ee||!ee.name){this._logService.warn("INVALID SymbolInformation",ee);continue}ae.symbols.push({...D.WorkspaceSymbol.from(ee),cacheId:[j,ge]})}return ae}async resolveWorkspaceSymbol(C,z){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!C.cacheId)return C;const V=this._cache.get(...C.cacheId);if(V){const j=await this._provider.resolveWorkspaceSymbol(V,z);return j&&(0,T.mixin)(C,D.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(C){this._cache.delete(C)}}class Q{static supportsResolving(C){return typeof C.prepareRename=="function"}constructor(C,z,V){this._documents=C,this._provider=z,this._logService=V}async provideRenameEdits(C,z,V,j){const ae=this._documents.getDocument(C),ge=D.Position.to(z);try{const ee=await this._provider.provideRenameEdits(ae,ge,V,j);return ee?D.WorkspaceEdit.from(ee):void 0}catch(ee){const be=Q._asMessage(ee);return be?{rejectReason:be,edits:void 0}:Promise.reject(ee)}}async resolveRenameLocation(C,z,V){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(C),ae=D.Position.to(z);try{const ge=await this._provider.prepareRename(j,ae,V);let ee,be;if(F.Range.isRange(ge)?(ee=ge,be=j.getText(ge)):(0,b.isObject)(ge)&&(ee=ge.range,be=ge.placeholder),!ee||!be)return;if(ee.start.line>ae.line||ee.end.line<ae.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ee),text:be}}catch(ge){const ee=Q._asMessage(ge);return ee?{rejectReason:ee,range:void 0,text:void 0}:Promise.reject(ge)}}static _asMessage(C){return typeof C=="string"?C:C instanceof Error&&typeof C.message=="string"?C.message:void 0}}class pe{constructor(C,z){this.resultId=C,this.tokens=z}}class we{constructor(C,z){this._documents=C,this._provider=z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(C,z,V){const j=this._documents.getDocument(C),ae=z!==0?this._previousResults.get(z):null;let ge=typeof ae?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,ae.resultId,V):await this._provider.provideDocumentSemanticTokens(j,V);return ae&&this._previousResults.delete(z),ge?(ge=we._fixProvidedSemanticTokens(ge),this._send(we._convertToEdits(ae,ge),ge)):null}async releaseDocumentSemanticColoring(C){this._previousResults.delete(C)}static _fixProvidedSemanticTokens(C){return we._isSemanticTokens(C)?we._isCorrectSemanticTokens(C)?C:new F.SemanticTokens(new Uint32Array(C.data),C.resultId):we._isSemanticTokensEdits(C)?we._isCorrectSemanticTokensEdits(C)?C:new F.SemanticTokensEdits(C.edits.map(z=>new F.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),C.resultId):C}static _isSemanticTokens(C){return C&&!!C.data}static _isCorrectSemanticTokens(C){return C.data instanceof Uint32Array}static _isSemanticTokensEdits(C){return C&&Array.isArray(C.edits)}static _isCorrectSemanticTokensEdits(C){for(const z of C.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(C,z){if(!we._isSemanticTokens(z)||!C||!C.tokens)return z;const V=C.tokens,j=V.length,ae=z.data,ge=ae.length;let ee=0;const be=Math.min(j,ge);for(;ee<be&&V[ee]===ae[ee];)ee++;if(ee===j&&ee===ge)return new F.SemanticTokensEdits([],z.resultId);let Se=0;const xe=be-ee;for(;Se<xe&&V[j-Se-1]===ae[ge-Se-1];)Se++;return new F.SemanticTokensEdits([{start:ee,deleteCount:j-ee-Se,data:ae.subarray(ee,ge-Se)}],z.resultId)}_send(C,z){if(we._isSemanticTokens(C)){const V=this._nextResultId++;return this._previousResults.set(V,new pe(C.resultId,C.data)),(0,u.encodeSemanticTokensDto)({id:V,type:"full",data:C.data})}if(we._isSemanticTokensEdits(C)){const V=this._nextResultId++;return we._isSemanticTokens(z)?this._previousResults.set(V,new pe(z.resultId,z.data)):this._previousResults.set(V,new pe(C.resultId)),(0,u.encodeSemanticTokensDto)({id:V,type:"delta",deltas:(C.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}class he{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentRangeSemanticTokens(C,z,V){const j=this._documents.getDocument(C),ae=await this._provider.provideDocumentRangeSemanticTokens(j,D.Range.to(z),V);return ae?this._send(ae):null}_send(C){return(0,u.encodeSemanticTokensDto)({id:0,type:"full",data:C.data})}}class de{static supportsResolving(C){return typeof C.resolveCompletionItem=="function"}constructor(C,z,V,j,ae){this._documents=C,this._commands=z,this._provider=V,this._apiDeprecation=j,this._extension=ae,this._cache=new o.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(C,z,V,j){const ae=this._documents.getDocument(C),ge=D.Position.to(z),ee=ae.getWordRangeAtPosition(ge)||new F.Range(ge,ge),be=ee.with({end:ge}),Se=new d.StopWatch(!0),xe=await this._provider.provideCompletionItems(ae,ge,j,D.CompletionContext.to(V));if(!xe||j.isCancellationRequested)return;const He=Array.isArray(xe)?new F.CompletionList(xe):xe,et=de.supportsResolving(this._provider)?this._cache.add(He.items):this._cache.add([]),Qe=new p.DisposableStore;this._disposables.set(et,Qe);const Ye=[],rt={x:et,b:Ye,a:{replace:D.Range.from(ee),insert:D.Range.from(be)},c:He.isIncomplete||void 0,d:Se.elapsed()};for(let lt=0;lt<He.items.length;lt++){const Me=He.items[lt],st=this._convertCompletionItem(Me,[et,lt],be,ee);Ye.push(st)}return rt}async resolveCompletionItem(C,z){if(typeof this._provider.resolveCompletionItem!="function")return;const V=this._cache.get(...C);if(!V)return;const j=await this._provider.resolveCompletionItem(V,z);if(j)return this._convertCompletionItem(j,C)}releaseCompletionItems(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}_convertCompletionItem(C,z,V,j){const ae=this._disposables.get(z[0]);if(!ae)throw Error("DisposableStore is missing...");const ge=this._commands.toInternal(C.command,ae),ee={x:z,a:C.label,b:C.kind!==void 0?D.CompletionItemKind.from(C.kind):void 0,m:C.tags&&C.tags.map(D.CompletionItemTag.from),c:C.detail,d:typeof C.documentation>"u"?void 0:D.MarkdownString.fromStrict(C.documentation),e:C.sortText!==C.label?C.sortText:void 0,f:C.filterText!==C.label?C.filterText:void 0,g:C.preselect||void 0,i:C.keepWhitespace?1:0,k:C.commitCharacters?.join(""),l:C.additionalTextEdits&&C.additionalTextEdits.map(D.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};C.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ee.h=C.textEdit.newText):typeof C.insertText=="string"?ee.h=C.insertText:C.insertText instanceof F.SnippetString&&(ee.h=C.insertText.value,ee.i|=4);let be;return C.textEdit?be=C.textEdit.range:C.range&&(be=C.range),F.Range.isRange(be)?ee.j=D.Range.from(be):be&&(!V?.isEqual(be.inserting)||!j?.isEqual(be.replacing))&&(ee.j={insert:D.Range.from(be.inserting),replace:D.Range.from(be.replacing)}),ee}}class Ae{async provideInlineCompletions(C,z,V,j){}disposeCompletions(C){}handleDidShowCompletionItem(C,z,V){}handlePartialAccept(C,z,V){}}class ue extends Ae{constructor(C,z,V,j){super(),this._extension=C,this._documents=z,this._provider=V,this._commands=j,this._references=new le,this._isAdditionsProposedApiEnabled=(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[A.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(C,z,V,j){const ae=this._documents.getDocument(C),ge=D.Position.to(z),ee=await this._provider.provideInlineCompletionItems(ae,ge,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:D.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},j);if(!ee||j.isCancellationRequested)return;const be=Array.isArray(ee)?ee:ee.items,Se=this._isAdditionsProposedApiEnabled?Array.isArray(ee)?[]:ee.commands||[]:[],xe=this._isAdditionsProposedApiEnabled&&!Array.isArray(ee)?ee.suppressSuggestions:void 0,He=this._isAdditionsProposedApiEnabled&&!Array.isArray(ee)?ee.enableForwardStability:void 0;let et;return{pid:this._references.createReferenceId({dispose(){et?.dispose()},items:be}),items:be.map((Ye,rt)=>{let lt;Ye.command&&(et||(et=new p.DisposableStore),lt=this._commands.toInternal(Ye.command,et));const Me=Ye.insertText;return{insertText:typeof Me=="string"?Me:{snippet:Me.value},filterText:Ye.filterText,range:Ye.range?D.Range.from(Ye.range):void 0,command:lt,idx:rt,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:Se.map(Ye=>(et||(et=new p.DisposableStore),this._commands.toInternal(Ye,et))),suppressSuggestions:xe,enableForwardStability:He}}disposeCompletions(C){this._references.disposeReferenceId(C)?.dispose()}handleDidShowCompletionItem(C,z,V){const j=this._references.get(C)?.items[z];j&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(j,V)}handlePartialAccept(C,z,V){const j=this._references.get(C)?.items[z];j&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(j,V)}}class le{constructor(){this._references=new Map,this._idPool=1}createReferenceId(C){const z=this._idPool++;return this._references.set(z,C),z}disposeReferenceId(C){const z=this._references.get(C);return this._references.delete(C),z}get(C){return this._references.get(C)}}class ${constructor(C,z){this._documents=C,this._provider=z,this._cache=new o.Cache("SignatureHelp")}async provideSignatureHelp(C,z,V,j){const ae=this._documents.getDocument(C),ge=D.Position.to(z),ee=this.reviveContext(V),be=await this._provider.provideSignatureHelp(ae,ge,j,ee);if(be){const Se=this._cache.add([be]);return{...D.SignatureHelp.from(be),id:Se}}}reviveContext(C){let z;if(C.activeSignatureHelp){const V=D.SignatureHelp.to(C.activeSignatureHelp),j=this._cache.get(C.activeSignatureHelp.id,0);j?(z=j,z.activeSignature=V.activeSignature,z.activeParameter=V.activeParameter):z=V}return{...C,activeSignatureHelp:z}}releaseSignatureHelp(C){this._cache.delete(C)}}class O{constructor(C,z,V,j,ae){this._documents=C,this._commands=z,this._provider=V,this._logService=j,this._extension=ae,this._cache=new o.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(C,z,V){const j=this._documents.getDocument(C),ae=D.Range.to(z),ge=await this._provider.provideInlayHints(j,ae,V);if(!Array.isArray(ge)||ge.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${z}`);return}if(V.isCancellationRequested)return;const ee=this._cache.add(ge);this._disposables.set(ee,new p.DisposableStore);const be={hints:[],cacheId:ee};for(let Se=0;Se<ge.length;Se++)this._isValidInlayHint(ge[Se],ae)&&be.hints.push(this._convertInlayHint(ge[Se],[ee,Se]));return this._logService.trace(`[InlayHints] ${be.hints.length} inlay hints from '${this._extension.identifier.value}' for ${z}`),be}async resolveInlayHint(C,z){if(typeof this._provider.resolveInlayHint!="function")return;const V=this._cache.get(...C);if(!V)return;const j=await this._provider.resolveInlayHint(V,z);if(j&&this._isValidInlayHint(j))return this._convertInlayHint(j,C)}releaseHints(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}_isValidInlayHint(C,z){return C.label.length===0||Array.isArray(C.label)&&C.label.every(V=>V.value.length===0)?(console.log("INVALID inlay hint, empty label",C),!1):!(z&&!z.contains(C.position))}_convertInlayHint(C,z){const V=this._disposables.get(z[0]);if(!V)throw Error("DisposableStore is missing...");const j={label:"",cacheId:z,tooltip:D.MarkdownString.fromStrict(C.tooltip),position:D.Position.from(C.position),textEdits:C.textEdits&&C.textEdits.map(D.TextEdit.from),kind:C.kind&&D.InlayHintKind.from(C.kind),paddingLeft:C.paddingLeft,paddingRight:C.paddingRight};return typeof C.label=="string"?j.label=C.label:j.label=C.label.map(ae=>{const ge={label:ae.value};return ge.tooltip=D.MarkdownString.fromStrict(ae.tooltip),F.Location.isLocation(ae.location)&&(ge.location=D.location.from(ae.location)),ae.command&&(ge.command=this._commands.toInternal(ae.command,V)),ge}),j}}class X{constructor(C,z){this._documents=C,this._provider=z,this._cache=new o.Cache("DocumentLink")}async provideLinks(C,z){const V=this._documents.getDocument(C),j=await this._provider.provideDocumentLinks(V,z);if(!(!Array.isArray(j)||j.length===0)&&!z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(X._validateLink).map(D.DocumentLink.from)};{const ae=this._cache.add(j),ge={links:[],cacheId:ae};for(let ee=0;ee<j.length;ee++){if(!X._validateLink(j[ee]))continue;const be=D.DocumentLink.from(j[ee]);be.cacheId=[ae,ee],ge.links.push(be)}return ge}}}static _validateLink(C){return C.target&&C.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(C,z){if(typeof this._provider.resolveDocumentLink!="function")return;const V=this._cache.get(...C);if(!V)return;const j=await this._provider.resolveDocumentLink(V,z);if(!(!j||!X._validateLink(j)))return D.DocumentLink.from(j)}releaseLinks(C){this._cache.delete(C)}}class me{constructor(C,z){this._documents=C,this._provider=z}async provideColors(C,z){const V=this._documents.getDocument(C),j=await this._provider.provideDocumentColors(V,z);return Array.isArray(j)?j.map(ge=>({color:D.Color.from(ge.color),range:D.Range.from(ge.range)})):[]}async provideColorPresentations(C,z,V){const j=this._documents.getDocument(C),ae=D.Range.to(z.range),ge=D.Color.to(z.color),ee=await this._provider.provideColorPresentations(ge,{document:j,range:ae},V);if(Array.isArray(ee))return ee.map(D.ColorPresentation.from)}}class Ce{constructor(C,z){this._documents=C,this._provider=z}async provideFoldingRanges(C,z,V){const j=this._documents.getDocument(C),ae=await this._provider.provideFoldingRanges(j,z,V);if(Array.isArray(ae))return ae.map(D.FoldingRange.from)}}class ye{constructor(C,z,V){this._documents=C,this._provider=z,this._logService=V}async provideSelectionRanges(C,z,V){const j=this._documents.getDocument(C),ae=z.map(D.Position.to),ge=await this._provider.provideSelectionRanges(j,ae,V);if(!(0,R.isNonEmptyArray)(ge))return[];if(ge.length!==ae.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ee=[];for(let be=0;be<ae.length;be++){const Se=[];ee.push(Se);let xe=ae[be],He=ge[be];for(;;){if(!He.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Se.push(D.SelectionRange.from(He)),!He.parent)break;xe=He.range,He=He.parent}}return ee}}class Ee{constructor(C,z){this._documents=C,this._provider=z,this._idPool=new t.IdGenerator(""),this._cache=new Map}async prepareSession(C,z,V){const j=this._documents.getDocument(C),ae=D.Position.to(z),ge=await this._provider.prepareCallHierarchy(j,ae,V);if(!ge)return;const ee=this._idPool.nextId();return this._cache.set(ee,new Map),Array.isArray(ge)?ge.map(be=>this._cacheAndConvertItem(ee,be)):[this._cacheAndConvertItem(ee,ge)]}async provideCallsTo(C,z,V){const j=this._itemFromCache(C,z);if(!j)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyIncomingCalls(j,V);if(ae)return ae.map(ge=>({from:this._cacheAndConvertItem(C,ge.from),fromRanges:ge.fromRanges.map(ee=>D.Range.from(ee))}))}async provideCallsFrom(C,z,V){const j=this._itemFromCache(C,z);if(!j)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyOutgoingCalls(j,V);if(ae)return ae.map(ge=>({to:this._cacheAndConvertItem(C,ge.to),fromRanges:ge.fromRanges.map(ee=>D.Range.from(ee))}))}releaseSession(C){this._cache.delete(C)}_cacheAndConvertItem(C,z){const V=this._cache.get(C),j=D.CallHierarchyItem.from(z,C,V.size.toString(36));return V.set(j._itemId,z),j}_itemFromCache(C,z){return this._cache.get(C)?.get(z)}}class Ie{constructor(C,z){this._documents=C,this._provider=z,this._idPool=new t.IdGenerator(""),this._cache=new Map}async prepareSession(C,z,V){const j=this._documents.getDocument(C),ae=D.Position.to(z),ge=await this._provider.prepareTypeHierarchy(j,ae,V);if(!ge)return;const ee=this._idPool.nextId();return this._cache.set(ee,new Map),Array.isArray(ge)?ge.map(be=>this._cacheAndConvertItem(ee,be)):[this._cacheAndConvertItem(ee,ge)]}async provideSupertypes(C,z,V){const j=this._itemFromCache(C,z);if(!j)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySupertypes(j,V);if(ae)return ae.map(ge=>this._cacheAndConvertItem(C,ge))}async provideSubtypes(C,z,V){const j=this._itemFromCache(C,z);if(!j)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySubtypes(j,V);if(ae)return ae.map(ge=>this._cacheAndConvertItem(C,ge))}releaseSession(C){this._cache.delete(C)}_cacheAndConvertItem(C,z){const V=this._cache.get(C),j=D.TypeHierarchyItem.from(z,C,V.size.toString(36));return V.set(j._itemId,z),j}_itemFromCache(C,z){return this._cache.get(C)?.get(z)}}class oe{constructor(C,z,V,j,ae){this._proxy=C,this._documents=z,this._provider=V,this._handle=j,this._extension=ae}async provideDocumentOnDropEdits(C,z,V,j,ae){const ge=this._documents.getDocument(z),ee=D.Position.to(V),be=D.DataTransfer.toDataTransfer(j,async xe=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,C,xe)).buffer),Se=await this._provider.provideDocumentDropEdits(ge,ee,be,ae);if(Se)return{label:Se.label??(0,i.localize)(0,null,this._extension.displayName||this._extension.name),insertText:typeof Se.insertText=="string"?Se.insertText:{snippet:Se.insertText.value},additionalEdit:Se.additionalEdit?D.WorkspaceEdit.from(Se.additionalEdit,void 0):void 0}}}class ce{constructor(C,z){this.adapter=C,this.extension=z}}class ie{constructor(C,z,V,j,ae,ge,ee,be){this._uriTransformer=z,this._documents=V,this._commands=j,this._diagnostics=ae,this._logService=ge,this._apiDeprecation=ee,this._extensionTelemetry=be,this._adapter=new Map,this._proxy=C.getProxy(P.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(C,z){return D.DocumentSelector.from(C,this._uriTransformer,z)}_createDisposable(C){return new F.Disposable(()=>{this._adapter.delete(C),this._proxy.$unregister(C)})}_nextHandle(){return ie._handlePool++}async _withAdapter(C,z,V,j,ae,ge=!1){const ee=this._adapter.get(C);if(!ee||!(ee.adapter instanceof z))return j;const be=Date.now();ge||this._logService.trace(`[${ee.extension.identifier.value}] INVOKE provider '${V.toString().replace(/[\r\n]/g,"")}'`);const Se=V(ee.adapter,ee.extension);return Promise.resolve(Se).catch(xe=>{(0,y.isCancellationError)(xe)||(this._logService.error(`[${ee.extension.identifier.value}] provider FAILED`),this._logService.error(xe),this._extensionTelemetry.onExtensionError(ee.extension.identifier,xe))}).finally(()=>{ge||this._logService.trace(`[${ee.extension.identifier.value}] provider DONE after ${Date.now()-be}ms`)}),_.CancellationToken.isCancellationToken(ae)?(0,k.raceCancellationError)(Se,ae):Se}_addNewAdapter(C,z){const V=this._nextHandle();return this._adapter.set(V,new ce(C,z)),V}static _extLabel(C){return C.displayName||C.name}registerDocumentSymbolProvider(C,z,V,j){const ae=this._addNewAdapter(new a(this._documents,V),C),ge=j&&j.label||ie._extLabel(C);return this._proxy.$registerDocumentSymbolProvider(ae,this._transformDocumentSelector(z,C),ge),this._createDisposable(ae)}$provideDocumentSymbols(C,z,V){return this._withAdapter(C,a,j=>j.provideDocumentSymbols(n.URI.revive(z),V),void 0,V)}registerCodeLensProvider(C,z,V){const j=this._nextHandle(),ae=typeof V.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new ce(new r(this._documents,this._commands.converter,V),C)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(z,C),ae);let ge=this._createDisposable(j);if(ae!==void 0){const ee=V.onDidChangeCodeLenses(be=>this._proxy.$emitCodeLensEvent(ae));ge=F.Disposable.from(ge,ee)}return ge}$provideCodeLenses(C,z,V){return this._withAdapter(C,r,j=>j.provideCodeLenses(n.URI.revive(z),V),void 0,V)}$resolveCodeLens(C,z,V){return this._withAdapter(C,r,j=>j.resolveCodeLens(z,V),void 0,void 0)}$releaseCodeLenses(C,z){this._withAdapter(C,r,V=>Promise.resolve(V.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(C,z,V){const j=this._addNewAdapter(new w(this._documents,V),C);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(z,C)),this._createDisposable(j)}$provideDefinition(C,z,V,j){return this._withAdapter(C,w,ae=>ae.provideDefinition(n.URI.revive(z),V,j),[],j)}registerDeclarationProvider(C,z,V){const j=this._addNewAdapter(new I(this._documents,V),C);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(z,C)),this._createDisposable(j)}$provideDeclaration(C,z,V,j){return this._withAdapter(C,I,ae=>ae.provideDeclaration(n.URI.revive(z),V,j),[],j)}registerImplementationProvider(C,z,V){const j=this._addNewAdapter(new c(this._documents,V),C);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(z,C)),this._createDisposable(j)}$provideImplementation(C,z,V,j){return this._withAdapter(C,c,ae=>ae.provideImplementation(n.URI.revive(z),V,j),[],j)}registerTypeDefinitionProvider(C,z,V){const j=this._addNewAdapter(new l(this._documents,V),C);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(z,C)),this._createDisposable(j)}$provideTypeDefinition(C,z,V,j){return this._withAdapter(C,l,ae=>ae.provideTypeDefinition(n.URI.revive(z),V,j),[],j)}registerHoverProvider(C,z,V,j){const ae=this._addNewAdapter(new m(this._documents,V),C);return this._proxy.$registerHoverProvider(ae,this._transformDocumentSelector(z,C)),this._createDisposable(ae)}$provideHover(C,z,V,j){return this._withAdapter(C,m,ae=>ae.provideHover(n.URI.revive(z),V,j),void 0,j)}registerEvaluatableExpressionProvider(C,z,V,j){const ae=this._addNewAdapter(new E(this._documents,V),C);return this._proxy.$registerEvaluatableExpressionProvider(ae,this._transformDocumentSelector(z,C)),this._createDisposable(ae)}$provideEvaluatableExpression(C,z,V,j){return this._withAdapter(C,E,ae=>ae.provideEvaluatableExpression(n.URI.revive(z),V,j),void 0,j)}registerInlineValuesProvider(C,z,V,j){const ae=typeof V.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ge=this._addNewAdapter(new f(this._documents,V),C);this._proxy.$registerInlineValuesProvider(ge,this._transformDocumentSelector(z,C),ae);let ee=this._createDisposable(ge);if(ae!==void 0){const be=V.onDidChangeInlineValues(Se=>this._proxy.$emitInlineValuesEvent(ae));ee=F.Disposable.from(ee,be)}return ee}$provideInlineValues(C,z,V,j,ae){return this._withAdapter(C,f,ge=>ge.provideInlineValues(n.URI.revive(z),V,j,ae),void 0,ae)}registerDocumentHighlightProvider(C,z,V){const j=this._addNewAdapter(new L(this._documents,V),C);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(z,C)),this._createDisposable(j)}$provideDocumentHighlights(C,z,V,j){return this._withAdapter(C,L,ae=>ae.provideDocumentHighlights(n.URI.revive(z),V,j),void 0,j)}registerLinkedEditingRangeProvider(C,z,V){const j=this._addNewAdapter(new W(this._documents,V),C);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(z,C)),this._createDisposable(j)}$provideLinkedEditingRanges(C,z,V,j){return this._withAdapter(C,W,async ae=>{const ge=await ae.provideLinkedEditingRanges(n.URI.revive(z),V,j);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?ie._serializeRegExp(ge.wordPattern):void 0}},void 0,j)}registerReferenceProvider(C,z,V){const j=this._addNewAdapter(new J(this._documents,V),C);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(z,C)),this._createDisposable(j)}$provideReferences(C,z,V,j,ae){return this._withAdapter(C,J,ge=>ge.provideReferences(n.URI.revive(z),V,j,ae),void 0,ae)}registerCodeActionProvider(C,z,V,j){const ae=new p.DisposableStore,ge=this._addNewAdapter(new q(this._documents,this._commands.converter,this._diagnostics,V,this._logService,C,this._apiDeprecation),C);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(z,C),{providedKinds:j?.providedCodeActionKinds?.map(ee=>ee.value),documentation:j?.documentation?.map(ee=>({kind:ee.kind.value,command:this._commands.converter.toInternal(ee.command,ae)}))},ie._extLabel(C),!!V.resolveCodeAction),ae.add(this._createDisposable(ge)),ae}$provideCodeActions(C,z,V,j,ae){return this._withAdapter(C,q,ge=>ge.provideCodeActions(n.URI.revive(z),V,j,ae),void 0,ae)}$resolveCodeAction(C,z,V){return this._withAdapter(C,q,j=>j.resolveCodeAction(z,V),{},void 0)}$releaseCodeActions(C,z){this._withAdapter(C,q,V=>Promise.resolve(V.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(C,z,V){const j=this._addNewAdapter(new B(this._documents,V),C);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(z,C),C.identifier,C.displayName||C.name),this._createDisposable(j)}$provideDocumentFormattingEdits(C,z,V,j){return this._withAdapter(C,B,ae=>ae.provideDocumentFormattingEdits(n.URI.revive(z),V,j),void 0,j)}registerDocumentRangeFormattingEditProvider(C,z,V){const j=typeof V.provideDocumentRangesFormattingEdits=="function";j&&(0,v.checkProposedApiEnabled)(C,"formatMultipleRanges");const ae=this._addNewAdapter(new G(this._documents,V),C);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(z,C),C.identifier,C.displayName||C.name,j),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(C,z,V,j,ae){return this._withAdapter(C,G,ge=>ge.provideDocumentRangeFormattingEdits(n.URI.revive(z),V,j,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(C,z,V,j,ae){return this._withAdapter(C,G,ge=>ge.provideDocumentRangesFormattingEdits(n.URI.revive(z),V,j,ae),void 0,ae)}registerOnTypeFormattingEditProvider(C,z,V,j){const ae=this._addNewAdapter(new N(this._documents,V),C);return this._proxy.$registerOnTypeFormattingSupport(ae,this._transformDocumentSelector(z,C),j,C.identifier),this._createDisposable(ae)}$provideOnTypeFormattingEdits(C,z,V,j,ae,ge){return this._withAdapter(C,N,ee=>ee.provideOnTypeFormattingEdits(n.URI.revive(z),V,j,ae,ge),void 0,ge)}registerWorkspaceSymbolProvider(C,z){const V=this._addNewAdapter(new H(z,this._logService),C);return this._proxy.$registerNavigateTypeSupport(V,typeof z.resolveWorkspaceSymbol=="function"),this._createDisposable(V)}$provideWorkspaceSymbols(C,z,V){return this._withAdapter(C,H,j=>j.provideWorkspaceSymbols(z,V),{symbols:[]},V)}$resolveWorkspaceSymbol(C,z,V){return this._withAdapter(C,H,j=>j.resolveWorkspaceSymbol(z,V),void 0,void 0)}$releaseWorkspaceSymbols(C,z){this._withAdapter(C,H,V=>V.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(C,z,V){const j=this._addNewAdapter(new Q(this._documents,V,this._logService),C);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(z,C),Q.supportsResolving(V)),this._createDisposable(j)}$provideRenameEdits(C,z,V,j,ae){return this._withAdapter(C,Q,ge=>ge.provideRenameEdits(n.URI.revive(z),V,j,ae),void 0,ae)}$resolveRenameLocation(C,z,V,j){return this._withAdapter(C,Q,ae=>ae.resolveRenameLocation(n.URI.revive(z),V,j),void 0,j)}registerDocumentSemanticTokensProvider(C,z,V,j){const ae=this._addNewAdapter(new we(this._documents,V),C),ge=typeof V.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ae,this._transformDocumentSelector(z,C),j,ge);let ee=this._createDisposable(ae);if(ge){const be=V.onDidChangeSemanticTokens(Se=>this._proxy.$emitDocumentSemanticTokensEvent(ge));ee=F.Disposable.from(ee,be)}return ee}$provideDocumentSemanticTokens(C,z,V,j){return this._withAdapter(C,we,ae=>ae.provideDocumentSemanticTokens(n.URI.revive(z),V,j),null,j)}$releaseDocumentSemanticTokens(C,z){this._withAdapter(C,we,V=>V.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(C,z,V,j){const ae=this._addNewAdapter(new he(this._documents,V),C);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ae,this._transformDocumentSelector(z,C),j),this._createDisposable(ae)}$provideDocumentRangeSemanticTokens(C,z,V,j){return this._withAdapter(C,he,ae=>ae.provideDocumentRangeSemanticTokens(n.URI.revive(z),V,j),null,j)}registerCompletionItemProvider(C,z,V,j){const ae=this._addNewAdapter(new de(this._documents,this._commands.converter,V,this._apiDeprecation,C),C);return this._proxy.$registerCompletionsProvider(ae,this._transformDocumentSelector(z,C),j,de.supportsResolving(V),`${C.identifier.value}(${j.join("")})`),this._createDisposable(ae)}$provideCompletionItems(C,z,V,j,ae){return this._withAdapter(C,de,ge=>ge.provideCompletionItems(n.URI.revive(z),V,j,ae),void 0,ae)}$resolveCompletionItem(C,z,V){return this._withAdapter(C,de,j=>j.resolveCompletionItem(z,V),void 0,V)}$releaseCompletionItems(C,z){this._withAdapter(C,de,V=>V.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(C,z,V){const j=new ue(C,this._documents,V,this._commands.converter),ae=this._addNewAdapter(j,C);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(z,C),j.supportsHandleEvents),this._createDisposable(ae)}$provideInlineCompletions(C,z,V,j,ae){return this._withAdapter(C,Ae,ge=>ge.provideInlineCompletions(n.URI.revive(z),V,j,ae),void 0,ae)}$handleInlineCompletionDidShow(C,z,V,j){this._withAdapter(C,Ae,async ae=>{ae.handleDidShowCompletionItem(z,V,j)},void 0,void 0)}$handleInlineCompletionPartialAccept(C,z,V,j){this._withAdapter(C,Ae,async ae=>{ae.handlePartialAccept(z,V,j)},void 0,void 0)}$freeInlineCompletionsList(C,z){this._withAdapter(C,Ae,async V=>{V.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(C,z,V,j){const ae=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,ge=this._addNewAdapter(new $(this._documents,V),C);return this._proxy.$registerSignatureHelpProvider(ge,this._transformDocumentSelector(z,C),ae),this._createDisposable(ge)}$provideSignatureHelp(C,z,V,j,ae){return this._withAdapter(C,$,ge=>ge.provideSignatureHelp(n.URI.revive(z),V,j,ae),void 0,ae)}$releaseSignatureHelp(C,z){this._withAdapter(C,$,V=>V.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(C,z,V){const j=typeof V.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new O(this._documents,this._commands.converter,V,this._logService,C),C);this._proxy.$registerInlayHintsProvider(ae,this._transformDocumentSelector(z,C),typeof V.resolveInlayHint=="function",j,ie._extLabel(C));let ge=this._createDisposable(ae);if(j!==void 0){const ee=V.onDidChangeInlayHints(be=>this._proxy.$emitInlayHintsEvent(j));ge=F.Disposable.from(ge,ee)}return ge}$provideInlayHints(C,z,V,j){return this._withAdapter(C,O,ae=>ae.provideInlayHints(n.URI.revive(z),V,j),void 0,j)}$resolveInlayHint(C,z,V){return this._withAdapter(C,O,j=>j.resolveInlayHint(z,V),void 0,V)}$releaseInlayHints(C,z){this._withAdapter(C,O,V=>V.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(C,z,V){const j=this._addNewAdapter(new X(this._documents,V),C);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(z,C),typeof V.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(C,z,V){return this._withAdapter(C,X,j=>j.provideLinks(n.URI.revive(z),V),void 0,V,z.scheme==="output")}$resolveDocumentLink(C,z,V){return this._withAdapter(C,X,j=>j.resolveLink(z,V),void 0,void 0,!0)}$releaseDocumentLinks(C,z){this._withAdapter(C,X,V=>V.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(C,z,V){const j=this._addNewAdapter(new me(this._documents,V),C);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(z,C)),this._createDisposable(j)}$provideDocumentColors(C,z,V){return this._withAdapter(C,me,j=>j.provideColors(n.URI.revive(z),V),[],V)}$provideColorPresentations(C,z,V,j){return this._withAdapter(C,me,ae=>ae.provideColorPresentations(n.URI.revive(z),V,j),void 0,j)}registerFoldingRangeProvider(C,z,V){const j=this._nextHandle(),ae=typeof V.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new ce(new Ce(this._documents,V),C)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(z,C),C.identifier,ae);let ge=this._createDisposable(j);if(ae!==void 0){const ee=V.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ae));ge=F.Disposable.from(ge,ee)}return ge}$provideFoldingRanges(C,z,V,j){return this._withAdapter(C,Ce,ae=>ae.provideFoldingRanges(n.URI.revive(z),V,j),void 0,j)}registerSelectionRangeProvider(C,z,V){const j=this._addNewAdapter(new ye(this._documents,V,this._logService),C);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(z,C)),this._createDisposable(j)}$provideSelectionRanges(C,z,V,j){return this._withAdapter(C,ye,ae=>ae.provideSelectionRanges(n.URI.revive(z),V,j),[],j)}registerCallHierarchyProvider(C,z,V){const j=this._addNewAdapter(new Ee(this._documents,V),C);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(z,C)),this._createDisposable(j)}$prepareCallHierarchy(C,z,V,j){return this._withAdapter(C,Ee,ae=>Promise.resolve(ae.prepareSession(n.URI.revive(z),V,j)),void 0,j)}$provideCallHierarchyIncomingCalls(C,z,V,j){return this._withAdapter(C,Ee,ae=>ae.provideCallsTo(z,V,j),void 0,j)}$provideCallHierarchyOutgoingCalls(C,z,V,j){return this._withAdapter(C,Ee,ae=>ae.provideCallsFrom(z,V,j),void 0,j)}$releaseCallHierarchy(C,z){this._withAdapter(C,Ee,V=>Promise.resolve(V.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(C,z,V){const j=this._addNewAdapter(new Ie(this._documents,V),C);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(z,C)),this._createDisposable(j)}$prepareTypeHierarchy(C,z,V,j){return this._withAdapter(C,Ie,ae=>Promise.resolve(ae.prepareSession(n.URI.revive(z),V,j)),void 0,j)}$provideTypeHierarchySupertypes(C,z,V,j){return this._withAdapter(C,Ie,ae=>ae.provideSupertypes(z,V,j),void 0,j)}$provideTypeHierarchySubtypes(C,z,V,j){return this._withAdapter(C,Ie,ae=>ae.provideSubtypes(z,V,j),void 0,j)}$releaseTypeHierarchy(C,z){this._withAdapter(C,Ie,V=>Promise.resolve(V.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(C,z,V,j){const ae=this._nextHandle();return this._adapter.set(ae,new ce(new oe(this._proxy,this._documents,V,ae,C),C)),this._proxy.$registerDocumentOnDropEditProvider(ae,this._transformDocumentSelector(z,C),C.identifier,(0,v.isProposedApiEnabled)(C,"dropMetadata")?j:void 0),this._createDisposable(ae)}$provideDocumentOnDropEdits(C,z,V,j,ae,ge){return this._withAdapter(C,oe,ee=>Promise.resolve(ee.provideDocumentOnDropEdits(z,n.URI.revive(V),j,ae,ge)),void 0,void 0)}registerDocumentPasteEditProvider(C,z,V,j){const ae=this._nextHandle();return this._adapter.set(ae,new ce(new U(this._proxy,this._documents,V,ae),C)),this._proxy.$registerPasteEditProvider(ae,this._transformDocumentSelector(z,C),!!V.prepareDocumentPaste,j.pasteMimeTypes),this._createDisposable(ae)}$prepareDocumentPaste(C,z,V,j,ae){return this._withAdapter(C,U,ge=>ge.prepareDocumentPaste(n.URI.revive(z),V,j,ae),void 0,ae)}$providePasteEdits(C,z,V,j,ae,ge){return this._withAdapter(C,U,ee=>ee.providePasteEdits(z,n.URI.revive(V),j,ae,ge),void 0,ge)}static _serializeRegExp(C){return{pattern:C.source,flags:(0,S.regExpFlags)(C)}}static _serializeIndentationRule(C){return{decreaseIndentPattern:ie._serializeRegExp(C.decreaseIndentPattern),increaseIndentPattern:ie._serializeRegExp(C.increaseIndentPattern),indentNextLinePattern:C.indentNextLinePattern?ie._serializeRegExp(C.indentNextLinePattern):void 0,unIndentedLinePattern:C.unIndentedLinePattern?ie._serializeRegExp(C.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(C){return{beforeText:ie._serializeRegExp(C.beforeText),afterText:C.afterText?ie._serializeRegExp(C.afterText):void 0,previousLineText:C.previousLineText?ie._serializeRegExp(C.previousLineText):void 0,action:C.action}}static _serializeOnEnterRules(C){return C.map(ie._serializeOnEnterRule)}setLanguageConfiguration(C,z,V){const{wordPattern:j}=V;if(j&&(0,S.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(z,j):this._documents.setWordDefinitionFor(z,void 0),V.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",C,"Do not use."),V.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",C,"Do not use.");const ae=this._nextHandle(),ge={comments:V.comments,brackets:V.brackets,wordPattern:V.wordPattern?ie._serializeRegExp(V.wordPattern):void 0,indentationRules:V.indentationRules?ie._serializeIndentationRule(V.indentationRules):void 0,onEnterRules:V.onEnterRules?ie._serializeOnEnterRules(V.onEnterRules):void 0,__electricCharacterSupport:V.__electricCharacterSupport,__characterPairSupport:V.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ae,z,ge),this._createDisposable(ae)}$setWordDefinitions(C){for(const z of C)this._documents.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.ExtHostLanguageFeatures=ie,ie._handlePool=0}),define(Te[232],Pe([1,0,4,8,7,29,17,6]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(R,b,g,_){this._documents=b,this._commands=g,this._uriTransformer=_,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,b){await this._proxy.$changeLanguage(R,b);const g=this._documents.getDocumentData(R);if(!g)throw new Error(`document '${R.toString()}' NOT found`);return g.document}async tokenAtPosition(R,b){const g=R.version,_=T.Position.from(b),p=await this._proxy.$tokensAtPosition(R.uri,_),u={type:D.StandardTokenType.Other,range:R.getWordRangeAtPosition(b)??new D.Range(b.line,b.character,b.line,b.character)};if(!p)return u;const t={range:T.Range.to(p.range),type:T.TokenType.to(p.type)};return!t.range.contains(b)||g!==R.version?u:t}createLanguageStatusItem(R,b,g){const _=this._handlePool++,p=this._proxy,u=this._ids,t=`${R.identifier.value}/${b}`;if(u.has(t))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);u.add(t);const o={selector:g,id:b,name:R.displayName??R.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let d;const y=new P.DisposableStore,k=()=>{d?.dispose(),d=(0,A.disposableTimeout)(()=>{y.clear(),this._proxy.$setLanguageStatus(_,{id:t,name:o.name??R.displayName??R.name,source:R.displayName??R.name,selector:T.DocumentSelector.from(o.selector,this._uriTransformer),label:o.text,detail:o.detail??"",severity:o.severity===D.LanguageStatusSeverity.Error?F.default.Error:o.severity===D.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:o.command&&this._commands.toInternal(o.command,y),accessibilityInfo:o.accessibilityInformation,busy:o.busy})},0)},v={dispose(){y.dispose(),d?.dispose(),p.$removeLanguageStatus(_),u.delete(t)},get id(){return o.id},get name(){return o.name},set name(i){o.name=i,k()},get selector(){return o.selector},set selector(i){o.selector=i,k()},get text(){return o.text},set text(i){o.text=i,k()},get detail(){return o.detail},set detail(i){o.detail=i,k()},get severity(){return o.severity},set severity(i){o.severity=i,k()},get accessibilityInformation(){return o.accessibilityInformation},set accessibilityInformation(i){o.accessibilityInformation=i,k()},get command(){return o.command},set command(i){o.command=i,k()},get busy(){return o.busy},set busy(i){o.busy=i,k()}};return k(),v}}e.ExtHostLanguages=S}),define(Te[79],Pe([1,0,20,13,2,3,14,4,27,18]),function(te,e,n,T,D,F,A,P,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=e.ExtHostLocalizationService=class{constructor(g,_,p){this.logService=p,this.bundleCache=new Map,this._proxy=_.getProxy(P.MainContext.MainThreadLocalization),this.currentLanguage=g.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===n.LANGUAGE_DEFAULT}getMessage(g,_){const{message:p,args:u,comment:t}=_;if(this.isDefaultLanguage)return(0,T.format2)(p,u??{});let o=p;t&&t.length>0&&(o+=`/${Array.isArray(t)?t.join(""):t}`);const d=this.bundleCache.get(g)?.contents[o];return d||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,T.format2)(d??p,u??{})}getBundle(g){return this.bundleCache.get(g)?.contents}getBundleUri(g){return this.bundleCache.get(g)?.uri}async initializeLocalizedMessages(g){if(this.isDefaultLanguage||!g.l10n&&!g.isBuiltin||this.bundleCache.has(g.identifier.value))return;let _;const p=await this.getBundleLocation(g);if(!p){this.logService.error(`No bundle location found for extension ${g.identifier.value}`);return}try{const u=await this._proxy.$fetchBundleContents(p),t=JSON.parse(u);_=g.isBuiltin?t.contents?.bundle:t}catch(u){this.logService.error(`Failed to load translations for ${g.identifier.value} from ${p}: ${u.message}`);return}_&&this.bundleCache.set(g.identifier.value,{contents:_,uri:p})}async getBundleLocation(g){if(g.isBuiltin){const _=await this._proxy.$fetchBuiltInBundleUri(g.identifier.value,this.currentLanguage);return D.URI.revive(_)}return g.l10n?D.URI.joinPath(g.extensionLocation,g.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=R=je([Ve(0,S.IExtHostInitDataService),Ve(1,h.IExtHostRpcService),Ve(2,A.ILogService)],R),e.IExtHostLocalizationService=(0,F.createDecorator)("IExtHostLocalizationService")}),define(Te[233],Pe([1,0,14,4,27,18,2,67]),function(te,e,n,T,D,F,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let S=e.ExtHostLoggerService=class extends n.AbstractLoggerService{constructor(b,g){super(g.logLevel,g.logsLocation,g.loggers.map(_=>(0,P.revive)(_))),this._proxy=b.getProxy(T.MainContext.MainThreadLogger)}$setLogLevel(b,g){g?this.setLogLevel(A.URI.revive(g),b):this.setLogLevel(b)}setVisibility(b,g){super.setVisibility(b,g),this._proxy.$setVisibility(b,g)}doCreateLogger(b,g,_){return new h(this._proxy,b,g,_)}};e.ExtHostLoggerService=S=je([Ve(0,F.IExtHostRpcService),Ve(1,D.IExtHostInitDataService)],S);class h extends n.AbstractMessageLogger{constructor(b,g,_,p){super(p?.logLevel==="always"),this.proxy=b,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(_),this.proxy.$createLogger(g,p).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,g){const _=[[b,g]];this.isLoggerCreated?this.doLog(_):this.buffer.push(..._)}doLog(b){this.proxy.$log(this.file,b)}flush(){this.proxy.$flush(this.file)}}}),define(Te[234],Pe([1,0,4,14,26]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function F(P){return P&&P.title}let A=e.ExtHostMessageService=class{constructor(S,h){this._logService=h,this._proxy=S.getProxy(n.MainContext.MainThreadMessageService)}showMessage(S,h,R,b,g){const _={source:{identifier:S.identifier,label:S.displayName||S.name}};let p;typeof b=="string"||F(b)?p=[b,...g]:(_.modal=b?.modal,_.useCustom=b?.useCustom,_.detail=b?.detail,p=g),_.useCustom&&(0,D.checkProposedApiEnabled)(S,"resolvers");const u=[];for(let t=0;t<p.length;t++){const o=p[t];if(typeof o=="string")u.push({title:o,handle:t,isCloseAffordance:!1});else if(typeof o=="object"){const{title:d,isCloseAffordance:y}=o;u.push({title:d,isCloseAffordance:!!y,handle:t})}else this._logService.warn("Invalid message item:",o)}return this._proxy.$showMessage(h,R,_,u).then(t=>{if(typeof t=="number")return p[t]})}};e.ExtHostMessageService=A=je([Ve(1,T.ILogService)],A)}),define(Te[235],Pe([1,0,25,5,6,28,13,12,2,54,4,38,8,7,46,204,103,9]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(k=>k.apiEditor)}constructor(k,v,i,a){this._textDocumentsAndEditors=i,this._textDocuments=a,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new T.Emitter({onListenerError:o.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter({onListenerError:o.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter({onListenerError:o.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter({onListenerError:o.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new h.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=k.getProxy(R.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=k.getProxy(R.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=k.getProxy(R.MainContext.MainThreadNotebookEditors),this._commandsConverter=v.converter,v.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const s=r.notebookEditor?.notebookUri,w=r.cell.handle,c=this._documents.get(s)?.getCell(w);if(c)return c.apiCell}if(r&&r.$mid===14){const s=r.uri,w=this._documents.get(s);if(w)return w.apiNotebook}return r}}),d._registerApiCommands(v)}getEditorById(k){const v=this._editors.get(k);if(!v)throw new Error(`unknown text editor: ${k}. known editors: ${[...this._editors.keys()]} `);return v}getIdByEditor(k){for(const[v,i]of this._editors)if(i.apiEditor===k)return v}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(k,v){const i=this._documents.get(k);if(!i&&!v)throw new Error(`NO notebook document for '${k}'`);return i}static _convertNotebookRegistrationData(k,v){if(!v)return;const i=v.filenamePattern.map(a=>g.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(v.filenamePattern&&!i){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:k.identifier,providerDisplayName:k.displayName||k.name,displayName:v.displayName,filenamePattern:i,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(k,v,i){const a=d._notebookStatusBarItemProviderHandlePool++,r=typeof i.onDidChangeCellStatusBarItems=="function"?d._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,i),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,r,v);let s;return r!==void 0&&(s=i.onDidChangeCellStatusBarItems(w=>this._notebookProxy.$emitCellStatusBarEvent(r))),new _.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,r),s?.dispose()})}async createNotebookDocument(k){const v=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:k.viewType,content:k.content&&g.NotebookData.from(k.content)});return S.URI.revive(v)}async openNotebookDocument(k){const v=this._documents.get(k);if(v)return v.apiNotebook;const i=await this._notebookDocumentsProxy.$tryOpenNotebook(k),a=this._documents.get(S.URI.revive(i));return(0,P.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(k,v){S.URI.isUri(k)&&(k=await this.openNotebookDocument(k));let i;typeof v=="object"?i={position:g.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(g.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:i={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(k.uri,k.notebookType,i),r=a&&this._editors.get(a)?.apiEditor;if(r)return r;throw a?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(k,v,i,a){const r=this._notebookStatusBarItemProviders.get(k),s=S.URI.revive(v),w=this._documents.get(s);if(!w||!r)return;const I=w.getCellFromIndex(i);if(!I)return;const c=await r.provideCellStatusBarItems(I.apiCell,a);if(!c)return;const l=new D.DisposableStore,m=this._statusBarCache.add([l]),f=(Array.isArray(c)?c:[c]).map(L=>g.NotebookStatusBarItem.from(L,this._commandsConverter,l));return{cacheId:m,items:f}}$releaseNotebookCellStatusBarItems(k){this._statusBarCache.delete(k)}registerNotebookSerializer(k,v,i,a,r){if((0,A.isFalsyOrWhitespace)(v))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,i),this._notebookProxy.$registerNotebookSerializer(s,{id:k.identifier,location:k.extensionLocation},v,g.NotebookDocumentContentOptions.from(a),d._convertNotebookRegistrationData(k,r)),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(k,v,i){const a=this._notebookSerializer.get(k);if(!a)throw new Error("NO serializer found");const r=await a.deserializeNotebook(v.buffer,i);return new p.SerializableObjectWithBuffers(g.NotebookData.from(r))}async $notebookToData(k,v,i){const a=this._notebookSerializer.get(k);if(!a)throw new Error("NO serializer found");const r=await a.serializeNotebook(g.NotebookData.to(v.value),i);return n.VSBuffer.wrap(r)}_createExtHostEditor(k,v,i){if(this._editors.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const a=new t.ExtHostNotebookEditor(v,this._notebookEditorsProxy,k,i.visibleRanges.map(g.NotebookRange.to),i.selections.map(g.NotebookRange.to),typeof i.viewColumn=="number"?g.ViewColumn.to(i.viewColumn):void 0);this._editors.set(v,a)}$acceptDocumentAndEditorsDelta(k){if(k.value.removedDocuments)for(const i of k.value.removedDocuments){const a=S.URI.revive(i),r=this._documents.get(a);r&&(r.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===a.toString()&&this._editors.delete(s.id)}if(k.value.addedDocuments){const i=[];for(const a of k.value.addedDocuments){const r=S.URI.revive(a.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const s=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,a);i.push(...a.cells.map(w=>u.ExtHostCell.asModelAddData(s.apiNotebook,w))),this._documents.get(r)?.dispose(),this._documents.set(r,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(k.value.addedEditors)for(const i of k.value.addedEditors){if(this._editors.has(i.id))return;const a=S.URI.revive(i.documentUri),r=this._documents.get(a);r&&this._createExtHostEditor(r,i.id,i)}const v=[];if(k.value.removedEditors)for(const i of k.value.removedEditors){const a=this._editors.get(i);a&&(this._editors.delete(i),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),v.push(a))}if(k.value.visibleEditors){this._visibleNotebookEditors=k.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const i=new Set;this._visibleNotebookEditors.forEach(a=>i.add(a.id));for(const a of this._editors.values()){const r=i.has(a.id);a._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}k.value.newActiveEditor===null?this._activeNotebookEditor=void 0:k.value.newActiveEditor&&(this._editors.get(k.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${k.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(k.value.newActiveEditor)),k.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(k){const v=b.ApiCommandArgument.String.with("notebookType","A notebook type"),i=new b.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new b.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>n.VSBuffer.wrap(r))],new b.ApiCommandResult("Notebook Data",r=>g.NotebookData.to(r.value))),a=new b.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new b.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new p.SerializableObjectWithBuffers(g.NotebookData.from(r)))],new b.ApiCommandResult("Bytes",r=>r.buffer));k.registerApiCommand(i),k.registerApiCommand(a)}}e.ExtHostNotebookController=d,d._notebookStatusBarItemProviderHandlePool=0}),define(Te[236],Pe([1,0,16,17,21,5,6,28,2,24,14,54,4,38,8,7,75,194,26,46]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let k=e.ExtHostNotebookKernels=class{constructor(c,l,m,E,f){this._initData=l,this._extHostNotebook=m,this._commands=E,this._logService=f,this._activeExecutions=new P.ResourceMap,this._activeNotebookExecutions=new P.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new b.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=c.getProxy(g.MainContext.MainThreadNotebookKernels);const L=new _.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new _.ApiCommandArgument("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const J=this._extHostNotebook.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:J}}else if(W&&"notebookEditor"in W){const J=this._extHostNotebook.getIdByEditor(W.notebookEditor);if(J===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:J}}return W})],_.ApiCommandResult.Void);this._commands.registerApiCommand(L)}createNotebookController(c,l,m,E,f,L){for(const ue of this._kernelData.values())if(ue.controller.id===l&&h.ExtensionIdentifier.equals(c.identifier,ue.extensionId))throw new Error(`notebook controller with id '${l}' ALREADY exist`);const W=this._handlePool++,J=this;this._logService.trace(`NotebookController[${W}], CREATED by ${c.identifier.value}, ${l}`);const q=()=>console.warn(`NO execute handler from notebook controller '${H.id}' of extension: '${c.identifier}'`);let U=!1;const B=new A.DisposableStore,G=new F.Emitter,N=new F.Emitter,H={id:w(c.identifier,l),notebookType:m,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:E||c.identifier.value,preloads:L?L.map(p.NotebookRendererScript.from):[]};let Q=f??q,pe;this._proxy.$addKernel(W,H).catch(ue=>{console.log(ue),U=!0});let we=0;const he=()=>{if(U)return;const ue=++we;Promise.resolve().then(()=>{ue===we&&this._proxy.$updateKernel(W,H)})},de=new P.ResourceMap,Ae={get id(){return l},get notebookType(){return H.notebookType},onDidChangeSelectedNotebooks:G.event,get label(){return H.label},set label(ue){H.label=ue??c.displayName??c.name,he()},get detail(){return H.detail??""},set detail(ue){H.detail=ue,he()},get description(){return H.description??""},set description(ue){H.description=ue,he()},get supportedLanguages(){return H.supportedLanguages},set supportedLanguages(ue){H.supportedLanguages=ue,he()},get supportsExecutionOrder(){return H.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){H.supportsExecutionOrder=ue,he()},get rendererScripts(){return H.preloads?H.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(ue){Q=ue??q},get interruptHandler(){return pe},set interruptHandler(ue){pe=ue,H.supportsInterrupt=!!ue,he()},createNotebookCellExecution(ue){if(U)throw new Error("notebook controller is DISPOSED");if(!de.has(ue.notebook.uri))throw J._logService.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(le=>le.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return J._createNotebookCellExecution(ue,w(c.identifier,this.id))},createNotebookExecution(ue){if((0,d.checkProposedApiEnabled)(c,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!de.has(ue.uri))throw J._logService.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(le=>le.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.uri.toString()}`);return J._createNotebookExecution(ue,w(c.identifier,this.id))},dispose:()=>{U||(this._logService.trace(`NotebookController[${W}], DISPOSED`),U=!0,this._kernelData.delete(W),B.dispose(),G.dispose(),N.dispose(),this._proxy.$removeKernel(W))},updateNotebookAffinity(ue,le){le===u.NotebookControllerAffinity2.Hidden&&(0,d.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),J._proxy.$updateNotebookPriority(W,ue.uri,le)},onDidReceiveMessage:N.event,postMessage(ue,le){return(0,d.checkProposedApiEnabled)(c,"notebookMessaging"),J._proxy.$postMessage(W,le&&J._extHostNotebook.getIdByEditor(le),ue)},asWebviewUri(ue){return(0,d.checkProposedApiEnabled)(c,"notebookMessaging"),(0,t.asWebviewUri)(ue,J._initData.remote)}};return this._kernelData.set(W,{extensionId:c.identifier,controller:Ae,onDidReceiveMessage:N,onDidChangeSelection:G,associatedNotebooks:de}),Ae}getIdByController(c){for(const[l,m]of this._kernelData)if(m.controller===c)return w(m.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,l){const m=this._kernelDetectionTaskHandlePool++,E=this;this._logService.trace(`NotebookControllerDetectionTask[${m}], CREATED by ${c.identifier.value}`),this._proxy.$addKernelDetectionTask(m,l);const f={dispose:()=>{this._kernelDetectionTask.delete(m),E._proxy.$removeKernelDetectionTask(m)}};return this._kernelDetectionTask.set(m,f),f}registerKernelSourceActionProvider(c,l,m){const E=this._kernelSourceActionProviderHandlePool++,f=typeof m.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,L=this;this._kernelSourceActionProviders.set(E,m),this._logService.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${c.identifier.value}`),this._proxy.$addKernelSourceActionProvider(E,E,l);let W;return f!==void 0&&(W=m.onDidChangeNotebookKernelSourceActions(J=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this._kernelSourceActionProviders.delete(E),L._proxy.$removeKernelSourceActionProvider(E,E),W?.dispose()}}}async $provideKernelSourceActions(c,l){const m=this._kernelSourceActionProviders.get(c);if(m){const E=new A.DisposableStore;return this._kernelSourceActionProviderCache.add([E]),(await m.provideNotebookKernelSourceActions(l)??[]).map(L=>p.NotebookKernelSourceAction.from(L,this._commands.converter,E))}return[]}$acceptNotebookAssociation(c,l,m){const E=this._kernelData.get(c);if(E){const f=this._extHostNotebook.getNotebookDocument(S.URI.revive(l));m?E.associatedNotebooks.set(f.uri,!0):E.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${c}] ASSOCIATE notebook`,f.uri.toString(),m),E.onDidChangeSelection.fire({selected:m,notebook:f.apiNotebook})}}async $executeCells(c,l,m){const E=this._kernelData.get(c);if(!E)return;const f=this._extHostNotebook.getNotebookDocument(S.URI.revive(l)),L=[];for(const W of m){const J=f.getCell(W);J&&L.push(J.apiCell)}try{this._logService.trace(`NotebookController[${c}] EXECUTE cells`,f.uri.toString(),L.length),await E.controller.executeHandler.call(E.controller,L,f.apiNotebook,E.controller)}catch(W){this._logService.error(`NotebookController[${c}] execute cells FAILED`,W),console.error(W)}}async $cancelCells(c,l,m){const E=this._kernelData.get(c);if(!E)return;const f=this._extHostNotebook.getNotebookDocument(S.URI.revive(l));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,f.apiNotebook);else for(const L of m){const W=f.getCell(L);W&&this._activeExecutions.get(W.uri)?.cancel()}if(E.controller.interruptHandler){const L=this._activeNotebookExecutions.get(f.uri);m.length&&Array.isArray(L)&&L.length&&L.forEach(W=>W.dispose())}}$acceptKernelMessageFromRenderer(c,l,m){const E=this._kernelData.get(c);if(!E)return;const f=this._extHostNotebook.getEditorById(l);E.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:m}))}$cellExecutionChanged(c,l,m){const f=this._extHostNotebook.getNotebookDocument(S.URI.revive(c)).getCell(l);if(f){const L=m?p.NotebookCellExecutionState.to(m):u.NotebookCellExecutionState.Idle;L!==void 0&&this._onDidChangeCellExecutionState.fire({cell:f.apiCell,state:L})}}_createNotebookCellExecution(c,l){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!E)throw new Error("invalid cell");if(this._activeExecutions.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const f=new i(l,E,this._proxy);this._activeExecutions.set(E.uri,f);const L=f.onDidChangeState(()=>{f.state===v.Resolved&&(f.dispose(),L.dispose(),this._activeExecutions.delete(E.uri))});return f.asApiObject()}_createNotebookExecution(c,l){const m=this._extHostNotebook.getNotebookDocument(c.uri),E=c.getCells().find(W=>{const J=m.getCellFromApiCell(W);return J&&this._activeExecutions.has(J.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this._activeNotebookExecutions.has(m.uri))throw new Error(`duplicate notebook execution for ${m.uri}`);const f=new r(l,m,this._proxy),L=f.onDidChangeState(()=>{f.state===a.Resolved&&(f.dispose(),L.dispose(),this._activeNotebookExecutions.delete(m.uri))});return this._activeNotebookExecutions.set(m.uri,[f,L]),f.asApiObject()}};e.ExtHostNotebookKernels=k=je([Ve(4,R.ILogService)],k);var v;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(v||(v={}));class i extends A.Disposable{get state(){return this._state}constructor(c,l,m){super(),this._cell=l,this._proxy=m,this._handle=i.HANDLE++,this._onDidChangeState=new F.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=v.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new s(10,E=>this.update(E)),this._executionOrder=l.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,c,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(c){await this._collector.addItem(c)}async update(c){const l=Array.isArray(c)?c:[c];return this._proxy.$updateExecution(this._handle,new y.SerializableObjectWithBuffers(l))}verifyStateForOutput(){if(this._state===v.Init)throw new Error("Must call start before modifying cell output");if(this._state===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(c){let l=this._cell;if(c&&(l=this._cell.notebook.getCellFromApiCell(c)),!l)throw new Error("INVALID cell");return l.handle}validateAndConvertOutputs(c){return c.map(l=>{const m=u.NotebookCellOutput.ensureUniqueMimeTypes(l.items,!0);return m===l.items?p.NotebookCellOutput.from(l):p.NotebookCellOutput.from({items:m,id:l.id,metadata:l.metadata})})}async updateOutputs(c,l,m){const E=this.cellIndexToHandle(l),f=this.validateAndConvertOutputs((0,n.asArray)(c));return this.updateSoon({editType:o.CellExecutionUpdateType.Output,cellHandle:E,append:m,outputs:f})}async updateOutputItems(c,l,m){return c=u.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(c),!0),this.updateSoon({editType:o.CellExecutionUpdateType.OutputItems,items:c.map(p.NotebookCellOutputItem.from),outputId:l.id,append:m})}asApiObject(){const c=this;return Object.freeze({get token(){return c._tokenSource.token},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(m){c._executionOrder=m,c.update([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:c._executionOrder}])},start(m){if(c._state===v.Resolved||c._state===v.Started)throw new Error("Cannot call start again");c._state=v.Started,c._onDidChangeState.fire(),c.update({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:m})},end(m,E){if(c._state===v.Resolved)throw new Error("Cannot call resolve twice");c._state=v.Resolved,c._onDidChangeState.fire(),c._collector.flush(),c._proxy.$completeExecution(c._handle,new y.SerializableObjectWithBuffers({runEndTime:E,lastRunSuccess:m}))},clearOutput(m){return c.verifyStateForOutput(),c.updateOutputs([],m,!1)},appendOutput(m,E){return c.verifyStateForOutput(),c.updateOutputs(m,E,!0)},replaceOutput(m,E){return c.verifyStateForOutput(),c.updateOutputs(m,E,!1)},appendOutputItems(m,E){return c.verifyStateForOutput(),c.updateOutputItems(m,E,!0)},replaceOutputItems(m,E){return c.verifyStateForOutput(),c.updateOutputItems(m,E,!1)}})}}i.HANDLE=0;var a;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(a||(a={}));class r extends A.Disposable{get state(){return this._state}constructor(c,l,m){super(),this._notebook=l,this._proxy=m,this._handle=r.HANDLE++,this._onDidChangeState=new F.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,c,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===a.Resolved||this._state===a.Started)throw new Error("Cannot call start again");this._state=a.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===a.Resolved)throw new Error("Cannot call resolve twice");this._state=a.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}r.HANDLE=0;class s{constructor(c,l){this.delay=c,this.callback=l,this.batch=[],this.startedTimer=Date.now()}addItem(c){return this.batch.push(c),this.currentDeferred||(this.currentDeferred=new T.DeferredPromise,this.startedTimer=Date.now(),(0,T.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const c=this.currentDeferred;this.currentDeferred=void 0;const l=this.batch;return this.batch=[],this.callback(l).finally(()=>c.complete())}}function w(I,c){return`${I.value}/${c}`}e.createKernelId=w}),define(Te[237],Pe([1,0,5,4,103]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class F{constructor(P,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,S,h){const R=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(S)?.fire({editor:R.apiEditor,message:h})}createRendererMessaging(P,S){if(!P.contributes?.notebookRenderer?.some(R=>R.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(R,b,g)=>this.getOrCreateEmitterFor(S).event(R,b,g),postMessage:(R,b)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,b]=[b,R]);const g=b&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(b);return this.proxy.$postMessage(g?.id,S,R)}}}getOrCreateEmitterFor(P){let S=this._rendererMessageEmitters.get(P);return S||(S=new n.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,S),S)}}e.ExtHostNotebookRenderers=F}),define(Te[238],Pe([1,0,6,12,2,26,4]),function(te,e,n,T,D,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class P{constructor(h){this.handlers=new Map,this.proxy=h.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(h,R,b){if((0,F.checkProposedApiEnabled)(h,"profileContentHandlers"),this.handlers.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.handlers.set(R,b),this.proxy.$registerProfileContentHandler(R,b.name,b.description,h.identifier.value),(0,n.toDisposable)(()=>{this.handlers.delete(R),this.proxy.$unregisterProfileContentHandler(R)})}async $saveProfile(h,R,b,g){const _=this.handlers.get(h);if(!_)throw new Error(`Unknown handler with id: ${h}`);return _.saveProfile(R,b,g)}async $readProfile(h,R,b){const g=this.handlers.get(h);if(!g)throw new Error(`Unknown handler with id: ${h}`);return g.readProfile((0,T.isString)(R)?R:D.URI.revive(R),b)}}e.ExtHostProfileContentHandlers=P}),define(Te[239],Pe([1,0,2,4,17,8]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class A{constructor(S,h){this.uriTransformer=h,this.providers=new Map,this.proxy=S.getProxy(T.MainContext.MainThreadQuickDiff)}$provideOriginalResource(S,h,R){const b=n.URI.revive(h),g=this.providers.get(S);return g?(0,D.asPromise)(()=>g.provideOriginalResource(b,R)).then(_=>_||null):Promise.resolve(null)}registerQuickDiffProvider(S,h,R,b){const g=A.handlePool++;return this.providers.set(g,h),this.proxy.$registerQuickDiffProvider(g,F.DocumentSelector.from(S,this.uriTransformer),R,b),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(g),this.providers.delete(g)}}}}e.ExtHostQuickDiff=A,A.handlePool=0}),define(Te[240],Pe([1,0,21,5,6,4,2,7,9,16,29,39,26,8]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(u,t,o){const d=u.getProxy(F.MainContext.MainThreadQuickOpen);class y{constructor(c,l){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=l}showQuickPick(c,l,m,E=n.CancellationToken.None){this._onDidSelectItem=void 0;const f=Promise.resolve(l),L=++this._instances,W=d.$show(L,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},E),J={},q=W.then(()=>J);return Promise.race([q,f]).then(U=>{if(U===J)return;const B=(0,g.isProposedApiEnabled)(c,"quickPickItemTooltip");return f.then(G=>{const N=[];for(let H=0;H<G.length;H++){const Q=G[H];typeof Q=="string"?N.push({label:Q,handle:H}):Q.kind===P.QuickPickItemKind.Separator?N.push({type:"separator",label:Q.label}):(Q.tooltip&&!B&&console.warn(`Extension '${c.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${c.identifier.value}`),N.push({label:Q.label,description:Q.description,detail:Q.detail,picked:Q.picked,alwaysShow:Q.alwaysShow,tooltip:B?_.MarkdownString.fromStrict(Q.tooltip):void 0,handle:H}))}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{m.onDidSelectItem(G[H])}),d.$setItems(L,N),W.then(H=>{if(typeof H=="number")return G[H];if(Array.isArray(H))return H.map(Q=>G[Q])})})}).then(void 0,U=>{if(!(0,S.isCancellationError)(U))return d.$setError(L,U),Promise.reject(U)})}$onItemSelected(c){this._onDidSelectItem?.(c)}showInput(c,l=n.CancellationToken.None){return this._validateInput=c?.validateInput,d.$input(c,typeof this._validateInput=="function",l).then(void 0,m=>{if(!(0,S.isCancellationError)(m))return Promise.reject(m)})}async $validateInput(c){if(!this._validateInput)return;const l=await this._validateInput(c);if(!l||typeof l=="string")return l;let m;switch(l.severity){case P.InputBoxValidationSeverity.Info:m=R.default.Info;break;case P.InputBoxValidationSeverity.Warning:m=R.default.Warning;break;case P.InputBoxValidationSeverity.Error:m=R.default.Error;break;default:m=l.message?R.default.Error:R.default.Ignore;break}return{content:l.message,severity:m}}async showWorkspaceFolderPick(c,l=n.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!m)return;const E=await this._workspace.getWorkspaceFolders2();if(E)return E.find(f=>f.uri.toString()===m.uri.toString())}createQuickPick(c){const l=new s(c,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}createInputBox(c){const l=new w(c,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(c,l){this._sessions.get(c)?._fireDidChangeValue(l)}$onDidAccept(c){this._sessions.get(c)?._fireDidAccept()}$onDidChangeActive(c,l){const m=this._sessions.get(c);m instanceof s&&m._fireDidChangeActive(l)}$onDidChangeSelection(c,l){const m=this._sessions.get(c);m instanceof s&&m._fireDidChangeSelection(l)}$onDidTriggerButton(c,l){this._sessions.get(c)?._fireDidTriggerButton(l)}$onDidTriggerItemButton(c,l,m){const E=this._sessions.get(c);E instanceof s&&E._fireDidTriggerItemButton(l,m)}$onDidHide(c){this._sessions.get(c)?._fireDidHide()}}class k{constructor(c,l){this._extensionId=c,this._onDidDispose=l,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((l,m)=>{const E=l===P.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(E,l)}),this.update({buttons:c.map((l,m)=>({...r(l),tooltip:l.tooltip,handle:l===P.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const l=this._handlesToButtons.get(c);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(c){if(!this._disposed){for(const l of Object.keys(c)){const m=c[l];this._pendingUpdate[l]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}k._nextId=1;function v(I){if(I instanceof P.ThemeIcon)return{id:I.id};const c=a(I),l=i(I);return{dark:typeof c=="string"?A.URI.file(c):c,light:typeof l=="string"?A.URI.file(l):l}}function i(I){return typeof I=="object"&&"light"in I?I.light:I}function a(I){return typeof I=="object"&&"dark"in I?I.dark:I}function r(I){const c=v(I.iconPath);let l,m;return"id"in c?m=b.ThemeIcon.asClassName(c):l=c,{iconPath:l,iconClass:m}}class s extends k{constructor(c,l){super(c.identifier,l),this.extension=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this._onDidTriggerItemButtonEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((E,f)=>{this._handlesToItems.set(f,E),this._itemsToHandles.set(E,f)});const l=(0,g.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),m=[];for(let E=0;E<c.length;E++){const f=c[E];f.kind===P.QuickPickItemKind.Separator?m.push({type:"separator",label:f.label}):(f.tooltip&&!l&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`),m.push({handle:E,label:f.label,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:l?_.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((L,W)=>({...r(L),tooltip:L.tooltip,handle:W}))}))}this.update({items:m})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(c){const l=(0,h.coalesce)(c.map(m=>this._handlesToItems.get(m)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(c){const l=(0,h.coalesce)(c.map(m=>this._handlesToItems.get(m)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}_fireDidTriggerItemButton(c,l){const m=this._handlesToItems.get(c);if(!m||!m.buttons||!m.buttons.length)return;const E=m.buttons[l];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:m})}}class w extends k{constructor(c,l){super(c.identifier,l),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get valueSelection(){return this._valueSelection}set valueSelection(c){this._valueSelection=c,this.update({valueSelection:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,c?typeof c=="string"?this.update({validationMessage:c,severity:R.default.Error}):this.update({validationMessage:c.message,severity:c.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new y(t,o)}e.createExtHostQuickOpen=p});var Le=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n};define(Te[241],Pe([1,0,2,5,65,6,17,4,16,127,14,24,39,8,26,15]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u){"use strict";var t,o,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function y(E){if(E)return typeof E.iconPath=="string"?n.URI.file(E.iconPath):n.URI.isUri(E.iconPath)||g.ThemeIcon.isThemeIcon(E.iconPath)?E.iconPath:void 0}function k(E,f){if(!E.iconPath&&!f.iconPath)return 0;if(E.iconPath){if(!f.iconPath)return 1}else return-1;const L=typeof E.iconPath=="string"?E.iconPath:n.URI.isUri(E.iconPath)?E.iconPath.fsPath:E.iconPath.id,W=typeof f.iconPath=="string"?f.iconPath:n.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,h.comparePaths)(L,W)}function v(E,f){let L=0;if(E.strikeThrough!==f.strikeThrough)return E.strikeThrough?1:-1;if(E.faded!==f.faded)return E.faded?1:-1;if(E.tooltip!==f.tooltip)return(E.tooltip||"").localeCompare(f.tooltip||"");if(L=k(E,f),L!==0)return L;if(E.light&&f.light)L=k(E.light,f.light);else{if(E.light)return 1;if(f.light)return-1}if(L!==0)return L;if(E.dark&&f.dark)L=k(E.dark,f.dark);else{if(E.dark)return 1;if(f.dark)return-1}return L}function i(E,f){if(E.command!==f.command)return E.command<f.command?-1:1;if(E.title!==f.title)return E.title<f.title?-1:1;if(E.tooltip!==f.tooltip){if(E.tooltip!==void 0&&f.tooltip!==void 0)return E.tooltip<f.tooltip?-1:1;if(E.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(E.arguments===f.arguments)return 0;if(E.arguments)if(f.arguments){if(E.arguments.length!==f.arguments.length)return E.arguments.length-f.arguments.length}else return 1;else return-1;for(let L=0;L<E.arguments.length;L++){const W=E.arguments[L],J=f.arguments[L];if(W!==J)return W<J?-1:1}return 0}function a(E,f){let L=(0,h.comparePaths)(E.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(L!==0)return L;if(E.command&&f.command)L=i(E.command,f.command);else{if(E.command)return 1;if(f.command)return-1}if(L!==0)return L;if(E.decorations&&f.decorations)L=v(E.decorations,f.decorations);else{if(E.decorations)return 1;if(f.decorations)return-1}return L}function r(E,f){for(let L=0;L<E.length;L++)if(E[L]!==f[L])return!1;return!0}function s(E,f){return E.command===f.command&&E.title===f.title&&E.tooltip===f.tooltip&&(E.arguments&&f.arguments?r(E.arguments,f.arguments):E.arguments===f.arguments)}function w(E,f){return(0,S.equals)(E,f,s)}class I{get value(){return this._value}set value(f){f=f??"",Le(this,t,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){Le(this,t,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,Le(this,t,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get enabled(){return this._enabled}set enabled(f){f=!!f,this._enabled!==f&&(this._enabled=f,Le(this,t,"f").$setInputBoxEnablement(this._sourceControlHandle,f))}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,Le(this,t,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}get document(){return(0,p.checkProposedApiEnabled)(this._extension,"scmTextDocument"),Le(this,o,"f").getDocument(this._documentUri)}constructor(f,L,W,J,q){this._extension=f,this._sourceControlHandle=J,this._documentUri=q,t.set(this,void 0),o.set(this,void 0),this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,o,L,"f"),Je(this,t,W,"f")}showValidationMessage(f,L){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),Le(this,t,"f").$showValidationMessage(this._sourceControlHandle,f,L)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=I,t=new WeakMap,o=new WeakMap;class c{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}constructor(f,L,W,J,q){this._proxy=f,this._commands=L,this._sourceControlHandle=W,this._id=J,this._label=q,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=c._handlePool++}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,L){const W=this._resourceStatesCommandsMap.get(f);return W?(0,A.asPromise)(()=>this._commands.executeCommand(W.command,...W.arguments||[],L)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(a),W=(0,S.sortedDiff)(this._resourceSnapshot,f,a).map(U=>{const B=U.toInsert.map(G=>{const N=this._resourceHandlePool++;this._resourceStatesMap.set(N,G);const H=G.resourceUri;let Q;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"){const X=new F.DisposableStore;Q=this._commands.converter.toInternal(G.command,X),this._resourceStatesDisposablesMap.set(N,X)}else this._resourceStatesCommandsMap.set(N,G.command);const pe=y(G.decorations),we=G.decorations&&y(G.decorations.light)||pe,he=G.decorations&&y(G.decorations.dark)||pe,de=[we,he],Ae=G.decorations&&G.decorations.tooltip||"",ue=G.decorations&&!!G.decorations.strikeThrough,le=G.decorations&&!!G.decorations.faded,$=G.contextValue||"";return{rawResource:[N,H,de,Ae,ue,le,$,Q],handle:N}});return{start:U.start,deleteCount:U.deleteCount,toInsert:B}}),J=W.map(({start:U,deleteCount:B,toInsert:G})=>[U,B,G.map(N=>N.rawResource)]),q=W.reverse();for(const{start:U,deleteCount:B,toInsert:G}of q){const N=G.map(Q=>Q.handle),H=this._handlesSnapshot.splice(U,B,...N);for(const Q of H)this._resourceStatesMap.delete(Q),this._resourceStatesCommandsMap.delete(Q),this._resourceStatesDisposablesMap.get(Q)?.dispose(),this._resourceStatesDisposablesMap.delete(Q)}return this._resourceSnapshot=f,J}dispose(){this._disposed=!0,this._onDidDispose.fire()}}c._handlePool=0;class l{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,Le(this,d,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f;let L;(0,p.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(L=f?.label),Le(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f,quickDiffLabel:L})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,Le(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new F.DisposableStore,this._acceptInputCommand=f;const L=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);Le(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:L})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new F.DisposableStore,this._actionButton=f;const L=f!==void 0?{command:this._commands.converter.toInternal(f.command,this._actionButtonDisposables.value),secondaryCommands:f.secondaryCommands?.map(W=>W.map(J=>this._commands.converter.toInternal(J,this._actionButtonDisposables.value))),description:f.description,enabled:f.enabled}:void 0;Le(this,d,"f").$updateSourceControl(this.handle,{actionButton:L??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&w(this._statusBarCommands,f))return;this._statusBarDisposables.value=new F.DisposableStore,this._statusBarCommands=f;const L=(f||[]).map(W=>this._commands.converter.toInternal(W,this._statusBarDisposables.value));Le(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:L})}get selected(){return this._selected}constructor(f,L,W,J,q,U,B){this._extension=f,this._commands=J,this._id=q,this._label=U,this._rootUri=B,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new F.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new F.MutableDisposable,this._statusBarDisposables=new F.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=l._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,d,W,"f");const G=n.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${q}/scm${this.handle}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this._inputBox=new I(f,L,Le(this,d,"f"),this.handle,G),Le(this,d,"f").$registerSourceControl(this.handle,q,U,B,G)}createResourceGroup(f,L){const W=new c(Le(this,d,"f"),this._commands,this.handle,f,L),J=T.Event.once(W.onDidDispose)(()=>this.createdResourceGroups.delete(W));return this.createdResourceGroups.set(W,J),this.eventuallyAddResourceGroups(),W}eventuallyAddResourceGroups(){const f=[],L=[];for(const[W,J]of this.createdResourceGroups){J.dispose();const q=W.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(W),this.eventuallyUpdateResourceStates()});T.Event.once(W.onDidDispose)(()=>{this.updatedResourceGroups.delete(W),q.dispose(),this._groups.delete(W.handle),Le(this,d,"f").$unregisterGroup(this.handle,W.handle)}),f.push([W.handle,W.id,W.label,W.features]);const U=W._takeResourceStateSnapshot();U.length>0&&L.push([W.handle,U]),this._groups.set(W.handle,W)}Le(this,d,"f").$registerGroups(this.handle,f,L),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(L=>{const W=L._takeResourceStateSnapshot();W.length!==0&&f.push([L.handle,W])}),f.length>0&&Le(this,d,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),Le(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,l._handlePool=0,je([(0,D.debounce)(100)],l.prototype,"eventuallyAddResourceGroups",null),je([(0,D.debounce)(100)],l.prototype,"eventuallyUpdateResourceStates",null);let m=e.ExtHostSCM=class yn{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(f,L,W,J){this._commands=L,this._extHostDocuments=W,this.logService=J,this._sourceControls=new Map,this._sourceControlsByExtension=new b.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=f.getProxy(P.MainContext.MainThreadSCM),this._telemetry=f.getProxy(P.MainContext.MainThreadTelemetry),L.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const U=this._sourceControls.get(q.sourceControlHandle);if(!U)return q;const B=U.getResourceGroup(q.groupHandle);return B?B.getResourceState(q.handle):q}else if(q&&q.$mid===4){const U=this._sourceControls.get(q.sourceControlHandle);return U?U.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const U=this._sourceControls.get(q.handle);return U||q}return q}})}createSourceControl(f,L,W,J){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,L,W,J),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const q=yn._handlePool++,U=new l(f,this._extHostDocuments,this._proxy,this._commands,L,W,J);this._sourceControls.set(q,U);const B=this._sourceControlsByExtension.get(f.identifier)||[];return B.push(U),this._sourceControlsByExtension.set(f.identifier,B),U}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const L=this._sourceControlsByExtension.get(f.identifier),W=L&&L[L.length-1];return W&&W.inputBox}$provideOriginalResource(f,L,W){const J=n.URI.revive(L);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,J.toString());const q=this._sourceControls.get(f);return!q||!q.quickDiffProvider||!q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>q.quickDiffProvider.provideOriginalResource(J,W)).then(U=>U||null)}$onInputBoxValueChange(f,L){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const W=this._sourceControls.get(f);return W&&W.inputBox.$onInputBoxValueChange(L),Promise.resolve(void 0)}$executeResourceCommand(f,L,W,J){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,L,W);const q=this._sourceControls.get(f);if(!q)return Promise.resolve(void 0);const U=q.getResourceGroup(L);return U?U.$executeResourceCommand(W,J):Promise.resolve(void 0)}$validateInput(f,L,W){this.logService.trace("ExtHostSCM#$validateInput",f);const J=this._sourceControls.get(f);return!J||!J.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>J.inputBox.validateInput(L,W)).then(q=>{if(!q)return Promise.resolve(void 0);const U=_.MarkdownString.fromStrict(q.message);return U?Promise.resolve([U,q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};m._handlePool=0,e.ExtHostSCM=m=je([Ve(3,R.ILogService)],m)}),define(Te[80],Pe([1,0,4,5,3]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class F{constructor(P){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,S){return this._proxy.$getPassword(P,S)}store(P,S,h){return this._proxy.$setPassword(P,S,h)}delete(P,S){return this._proxy.$deletePassword(P,S)}}e.ExtHostSecretState=F,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(Te[242],Pe([1,0,4,7]),function(te,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSemanticSimilarity=void 0;class D{constructor(A){this._semanticSimilarityProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(n.MainContext.MainThreadSemanticSimilarity)}async $provideSimilarityScore(A,P,S,h){if(this._semanticSimilarityProviders.size===0)throw new Error("No semantic similarity providers registered");const R=this._semanticSimilarityProviders.get(A);if(!R)throw new Error("Semantic similarity provider not found");return await R.provideSimilarityScore(P,S,h)}registerSemanticSimilarityProvider(A,P){const S=this._nextHandle;return this._nextHandle++,this._semanticSimilarityProviders.set(S,P),this._proxy.$registerSemanticSimilarityProvider(S),new T.Disposable(()=>{this._proxy.$unregisterSemanticSimilarityProvider(S),this._semanticSimilarityProviders.delete(S)})}}e.ExtHostSemanticSimilarity=D});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Te[243],Pe([1,0,7,4,151,6,8,12]),function(te,e,n,T,D,F,A,P){"use strict";var S,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(p,u,t,o,d=n.StatusBarAlignment.Left,y){S.set(this,void 0),h.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._staleCommandRegistrations=new F.DisposableStore,Je(this,S,p,"f"),Je(this,h,u,"f"),this._entryId=R.ID_GEN++,this._extension=t,this._id=o,this._alignment=d,this._priority=this.validatePriority(y)}validatePriority(p){if((0,P.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!R.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new F.DisposableStore,typeof p=="string"?this._command={fromApi:p,internal:Le(this,h,"f").toInternal({title:"",command:p},this._latestCommandRegistration)}:p?this._command={fromApi:p,internal:Le(this,h,"f").toInternal(p,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Le(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let u;this._name?u=this._name:u=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let t=this._color;this._backgroundColor&&(t=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const o=A.MarkdownString.fromStrict(this._tooltip);Le(this,S,"f").$setEntry(this._entryId,p,this._extension?.identifier.value,u,this._text,o,this._command?.internal,t,this._backgroundColor,this._alignment===n.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,S=new WeakMap,h=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const u={message:p};return this._messages.unshift(u),this._update(),new n.Disposable(()=>{const t=this._messages.indexOf(u);t>=0&&(this._messages.splice(t,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class g{constructor(p,u){this._proxy=p.getProxy(T.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new b(this)}createStatusBarEntry(p,u,t,o){return new R(this._proxy,this._commands,p,u,t,o)}setStatusBarMessage(p,u){const t=this._statusMessage.setMessage(p);let o;return typeof u=="number"?o=setTimeout(()=>t.dispose(),u):typeof u<"u"&&u.then(()=>t.dispose(),()=>t.dispose()),new n.Disposable(()=>{t.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=g}),define(Te[81],Pe([1,0,4,5,3]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class F{constructor(P,S){this._logService=S,this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,S){this._proxy.$registerExtensionStorageKeysToSync(P,S)}async initializeExtensionStorage(P,S,h){const R=await this._proxy.$initializeExtensionStorage(P,S);let b;return R&&(b=this.safeParseValue(P,S,R)),b||h}setValue(P,S,h){return this._proxy.$setValue(P,S,h)}$acceptValue(P,S,h){const R=this.safeParseValue(P,S,h);R&&this._onDidChangeStorage.fire({shared:P,key:S,value:R})}safeParseValue(P,S,h){try{return JSON.parse(h)}catch(R){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${P}): ${R}`)}}}e.ExtHostStorage=F,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Te[82],Pe([1,0,3,27,14,61,2]),function(te,e,n,T,D,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let P=e.ExtensionStoragePaths=class{constructor(h,R,b){this._logService=R,this._extHostFileSystem=b,this._workspace=h.workspace??void 0,this._environment=h.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getWorkspaceStorageURI(h){return A.URI.joinPath(this._environment.workspaceStorageHome,h)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const h=this._workspace.id,R=await this._getWorkspaceStorageURI(h);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(h){if(this._value)return A.URI.joinPath(this._value,h.identifier.value)}globalValue(h){return A.URI.joinPath(this._environment.globalStorageHome,h.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=P=je([Ve(0,T.IExtHostInitDataService),Ve(1,D.ILogService),Ve(2,F.IExtHostConsumerFileSystem)],P)}),define(Te[62],Pe([1,0,5,4,3,2,18,6,7,153,9,179,21,35,180,39,12,17,8]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class y{constructor(l,m,E,f){this._proxy=l,this._id=m,this._creationOptions=E,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(W=>this._pidPromiseComplete=W);const L=this;this.value={get name(){return L._name||""},get processId(){return L._pidPromise},get creationOptions(){return L._creationOptions},get exitStatus(){return L._exitStatus},get state(){return L._state},sendText(W,J=!0){L._checkDisposed(),L._proxy.$sendText(L._id,W,J)},show(W){L._checkDisposed(),L._proxy.$show(L._id,W)},hide(){L._checkDisposed(),L._proxy.$hide(L._id)},dispose(){L._disposed||(L._disposed=!0,L._proxy.$dispose(L._id))},get dimensions(){if(!(L._cols===void 0||L._rows===void 0))return{columns:L._cols,rows:L._rows}}}}async create(l,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,t.withNullAsUndefined)(l.shellPath),shellArgs:(0,t.withNullAsUndefined)(l.shellArgs),cwd:(0,t.withNullAsUndefined)(l.cwd),env:(0,t.withNullAsUndefined)(l.env),icon:(0,t.withNullAsUndefined)(s(l.iconPath)),color:u.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,t.withNullAsUndefined)(l.message),strictEnv:(0,t.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,t.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,t.withNullAsUndefined)(m?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.withNullAsUndefined)(m?.useShellEnvironment),location:m?.location||this._serializeParentTerminal(l.location,m?.resolvedExtHostIdentifier),isTransient:(0,t.withNullAsUndefined)(l.isTransient)})}async createExtensionTerminal(l,m,E,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:E,color:u.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(l,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,m){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in l?{viewColumn:d.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitStatus(l,m){this._exitStatus=Object.freeze({code:l,reason:m})}setDimensions(l,m){return l===this._cols&&m===this._rows||l===0||m===0?!1:(this._cols=l,this._rows=m,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(m=>{m!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=y;class k{get onProcessReady(){return this._onProcessReady.event}constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._onProcessData=new n.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new n.Emitter,this._onDidChangeProperty=new n.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new n.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(l){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${l}`)}updateProperty(l,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${l}, value: ${m}`)}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput?.(l)}resize(l,m){this._pty.setDimensions?.({columns:l,rows:m})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(m=>this._onProcessData.fire(m)),this._pty.onDidClose?.((m=void 0)=>{this._onProcessExit.fire(m===void 0?void 0:m)}),this._pty.onDidOverrideDimensions?.(m=>{m&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this._pty.onDidChangeName?.(m=>{this._onDidChangeProperty.fire({type:"title",value:m})}),this._pty.open(l||void 0),l&&this._pty.setDimensions?.(l),this._onProcessReady.fire({pid:-1,cwd:""})}}let v=1,i=e.BaseExtHostTerminalService=class extends P.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(l,m){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new n.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new n.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new n.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new n.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new n.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new n.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=m.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new n.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[E,f]of this._terminalProcesses)f.shutdown(!0)}})}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,m){const E=new y(this._proxy,(0,_.generateUuid)(),l,l.name),f=new k(l.pty);return E.createExtensionTerminal(l.location,this._serializeParentTerminal(l,m).resolvedExtHostIdentifier,s(l.iconPath),w(l.color)).then(L=>{const W=this._setupExtHostProcessListeners(L,f);this._terminalProcessDisposables[L]=W}),this._terminals.push(E),E.value}_serializeParentTerminal(l,m){if(m=m||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const E=l.location.parentTerminal;if(E){const f=this._terminals.find(L=>L.value===E);f&&(m.resolvedExtHostIdentifier=f._id)}}else l.location&&typeof l.location!="object"?m.location=l.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(l,m){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const f=new k(m),L=this._setupExtHostProcessListeners(l,f);this._terminalProcessDisposables[l]=L}async $acceptActiveTerminalChanged(l){const m=this._activeTerminal;if(l===null){this._activeTerminal=void 0,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const E=this._getTerminalById(l);E&&(this._activeTerminal=E,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,m){const E=this._getTerminalById(l);E&&this._onDidWriteTerminalData.fire({terminal:E.value,data:m})}async $acceptTerminalDimensions(l,m,E){const f=this._getTerminalById(l);f&&f.setDimensions(m,E)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(l,m,E){this._terminalProcesses.get(l)?.resize(m,E)}async $acceptTerminalTitleChange(l,m){const E=this._getTerminalById(l);E&&(E.name=m)}async $acceptTerminalClosed(l,m,E){const f=this._getTerminalObjectIndexById(this._terminals,l);if(f!==null){const L=this._terminals.splice(f,1)[0];L.setExitStatus(m,E),this._onDidCloseTerminal.fire(L.value)}}$acceptTerminalOpened(l,m,E,f){if(m){const J=this._getTerminalObjectIndexById(this._terminals,m);if(J!==null){this._terminals[J]._id=l,this._onDidOpenTerminal.fire(this.terminals[J]),this._terminals[J].isOpen=!0;return}}const L={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:F.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},W=new y(this._proxy,l,L,E);this._terminals.push(W),this._onDidOpenTerminal.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(l,m){this._getTerminalById(l)?._setProcessId(m)}async $startExtensionTerminal(l,m){const E=this._getTerminalById(l);if(!E)return{message:(0,h.localize)(0,null,l)};E.isOpen||await new Promise(L=>{const W=this.onDidOpenTerminal(async J=>{J===E.value&&(W.dispose(),L())})});const f=this._terminalProcesses.get(l);f?f.startSendingEvents(m):this._extensionTerminalAwaitingStart[l]={initialDimensions:m}}_setupExtHostProcessListeners(l,m){const E=new P.DisposableStore;E.add(m.onProcessReady(L=>this._proxy.$sendProcessReady(l,L.pid,L.cwd))),E.add(m.onDidChangeProperty(L=>this._proxy.$sendProcessProperty(l,L))),this._bufferer.startBuffering(l,m.onProcessData),E.add(m.onProcessExit(L=>this._onProcessExit(l,L))),this._terminalProcesses.set(l,m);const f=this._extensionTerminalAwaitingStart[l];return f&&m instanceof k&&(m.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),E}$acceptProcessAckDataEvent(l,m){this._terminalProcesses.get(l)?.acknowledgeDataEvent(m)}$acceptProcessInput(l,m){this._terminalProcesses.get(l)?.input(m)}$acceptTerminalInteraction(l){const m=this._getTerminalById(l);m?.setInteractedWith()&&this._onDidChangeTerminalState.fire(m.value)}$acceptProcessResize(l,m,E){try{this._terminalProcesses.get(l)?.resize(m,E)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(l,m){this._terminalProcesses.get(l)?.shutdown(m)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(m=>this._proxy.$sendProcessProperty(l,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(m=>this._proxy.$sendProcessProperty(l,{type:"cwd",value:m}))}$acceptProcessRequestLatency(l){return Promise.resolve(l)}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,m,E){if(this._profileProviders.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this._profileProviders.set(m,E),this._proxy.$registerProfileProvider(m,l.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(m),this._proxy.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(l,m,E){if(this._quickFixProviders.has(l))throw new Error(`Terminal quick fix provider "${l}" is already registered`);return this._quickFixProviders.set(l,E),this._proxy.$registerQuickFixProvider(l,m),new S.Disposable(()=>{this._quickFixProviders.delete(l),this._proxy.$unregisterQuickFixProvider(l)})}async $provideTerminalQuickFixes(l,m){const E=new g.CancellationTokenSource().token;if(E.isCancellationRequested)return;const f=this._quickFixProviders.get(l);if(!f)return;const L=await f.provideTerminalQuickFixes(m,E);if(L!==null)return L}async $createContributedProfileTerminal(l,m){const E=new g.CancellationTokenSource().token;let f=await this._profileProviders.get(l)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,m);return}this.createTerminalFromOptions(f.options,m)}}async $provideLinks(l,m){const E=this._getTerminalById(l);if(!E)return[];this._terminalLinkCache.delete(l),this._terminalLinkCancellationSource.get(l)?.dispose(!0);const L=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,L);const W=[],J={terminal:E.value,line:m},q=[];for(const G of this._linkProviders)q.push(o.Promises.withAsyncBody(async N=>{L.token.onCancellationRequested(()=>N({provider:G,links:[]}));const H=await G.provideTerminalLinks(J,L.token)||[];L.token.isCancellationRequested||N({provider:G,links:H})}));const U=await Promise.all(q);if(L.token.isCancellationRequested)return[];const B=new Map;for(const G of U)G&&G.links.length>0&&W.push(...G.links.map(N=>{const H={id:v++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return B.set(H.id,{provider:G.provider,link:N}),H}));return this._terminalLinkCache.set(l,B),W}$activateLink(l,m){const E=this._terminalLinkCache.get(l)?.get(m);E&&E.provider.handleTerminalLink(E.link)}_onProcessExit(l,m){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const E=this._terminalProcessDisposables[l];E&&(E.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,m)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,m){const E=this._getTerminalObjectIndexById(l,m);return E!==null?l[E]:null}_getTerminalObjectIndexById(l,m){let E=null;return l.some((f,L)=>f._id===m?(E=L,!0):!1),E}getEnvironmentVariableCollection(l){let m=this._environmentVariableCollections.get(l.identifier.value);return m||(m=new a,this._setEnvironmentVariableCollection(l.identifier.value,m)),m}_syncEnvironmentVariableCollection(l,m){const E=(0,b.serializeEnvironmentVariableCollection)(m.map),f=(0,b.serializeEnvironmentDescriptionMap)(m.descriptionMap);this._proxy.$setEnvironmentVariableCollection(l,m.persistent,E.length===0?void 0:E,f)}$initEnvironmentVariableCollections(l){l.forEach(m=>{const E=m[0],f=new a(m[1]);this._setEnvironmentVariableCollection(E,f)})}$acceptDefaultProfile(l,m){const E=this._defaultProfile;this._defaultProfile=l,this._defaultAutomationProfile=m,E?.path!==l.path&&this._onDidChangeShell.fire(l.path)}_setEnvironmentVariableCollection(l,m){this._environmentVariableCollections.set(l,m),m.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,m)})}};e.BaseExtHostTerminalService=i=je([Ve(1,A.IExtHostRpcService)],i);class a{get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(l){this.map=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new n.Emitter,this.map=new Map(l)}get size(){return this.map.size}replace(l,m,E){this._setIfDiffers(l,{value:m,type:S.EnvironmentVariableMutatorType.Replace,scope:E})}append(l,m,E){this._setIfDiffers(l,{value:m,type:S.EnvironmentVariableMutatorType.Append,scope:E})}prepend(l,m,E){this._setIfDiffers(l,{value:m,type:S.EnvironmentVariableMutatorType.Prepend,scope:E})}_setIfDiffers(l,m){m.scope||delete m.scope;const E=this.getKey(l,m.scope),f=this.map.get(E);if(!f||f.value!==m.value||f.type!==m.type||f.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const L=this.getKey(l,m.scope),W={variable:l,...m};this.map.set(L,W),this._onDidChangeCollection.fire()}}get(l,m){const E=this.getKey(l,m),f=this.map.get(E);return f?I(f):void 0}getKey(l,m){const E=this.getWorkspaceKey(m?.workspaceFolder);return E?`${l}:::${E}`:l}getWorkspaceKey(l){return l?l.uri.toString():void 0}forEach(l,m){this.map.forEach((E,f)=>l.call(m,E.variable,I(E),this))}[Symbol.iterator](){const l=new Map;return this.map.forEach((m,E)=>{m.scope||l.set(m.variable,I(m))}),l.entries()}delete(l,m){const E=this.getKey(l,m);this.map.delete(E),this._onDidChangeCollection.fire()}clear(l){if(l?.workspaceFolder){for(const[m,E]of this.map)E.scope?.workspaceFolder?.index===l.workspaceFolder.index&&this.map.delete(m);this.clearDescription(l)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(l,m){const E=this.getKey("",m),f=this.descriptionMap.get(E);if(!f||f.description!==l){let L;typeof l=="string"?L=l:L=l?.value.split(`

`)[0];const W={description:L,scope:m};this.descriptionMap.set(E,W),this._onDidChangeCollection.fire()}}clearDescription(l){const m=this.getKey("",l);this.descriptionMap.delete(m)}}let r=e.WorkerExtHostTerminalService=class extends i{constructor(l){super(!1,l)}createTerminal(l,m,E){throw new R.NotSupportedError}createTerminalFromOptions(l,m){throw new R.NotSupportedError}};e.WorkerExtHostTerminalService=r=je([Ve(0,A.IExtHostRpcService)],r);function s(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function w(c){return u.ThemeColor.isThemeColor(c)?c:void 0}function I(c){const l={...c};return l.scope=l.scope??void 0,delete l.variable,l}});var Le=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n};define(Te[244],Pe([1,0,16,17,25,21,5,202,92,6,23,12,35,4,18,104,8,7,45,74,56]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o,d,y,k){"use strict";var v,i;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=e.ExtHostTesting=class{constructor(U,B,G){this.editors=G,this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(_.MainContext.MainThreadTesting),this.observer=new L(this.proxy),this.runTracker=new I(this.proxy),B.registerArgumentProcessor({processArgument:N=>{if(N?.$mid!==15)return N;const H=N,Q=H.tests[H.tests.length-1].item.extId;return this.controllers.get(d.TestId.root(Q))?.collection.tree.get(Q)?.actual??(0,u.toItemFromContext)(N)}}),B.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await B.executeCommand("_testing.getExplorerSelection"),H=Q=>{const pe=this.controllers.get(d.TestId.root(Q));if(pe)return d.TestId.isRoot(Q)?pe.controller:pe.collection.tree.get(Q)?.actual};return{include:N?.include.map(H).filter(b.isDefined)||[],exclude:N?.exclude.map(H).filter(b.isDefined)||[]}})}createTestController(U,B,G,N){if(this.controllers.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const H=new h.DisposableStore,Q=H.add(new u.ExtHostTestItemCollection(B,G,this.editors));Q.root.label=G;const pe=new Map,we=this.proxy,he={items:Q.root.children,get label(){return G},set label(Ae){G=Ae,Q.root.label=Ae,we.$updateController(B,{label:G})},get refreshHandler(){return N},set refreshHandler(Ae){N=Ae,we.$updateController(B,{canRefresh:!!Ae})},get id(){return B},createRunProfile:(Ae,ue,le,$,O,X)=>{let me=(0,S.hash)(Ae);for(;pe.has(me);)me++;return new W(this.proxy,pe,B,me,Ae,ue,le,$,O,X)},createTestItem(Ae,ue,le){return new u.TestItemImpl(B,Ae,ue,le)},createTestRun:(Ae,ue,le=!0)=>this.runTracker.createTestRun(B,Q,Ae,ue,le),set resolveHandler(Ae){Q.resolveHandler=Ae},get resolveHandler(){return Q.resolveHandler},dispose:()=>{H.dispose()}};we.$registerTestController(B,G,!!N),H.add((0,h.toDisposable)(()=>we.$unregisterTestController(B)));const de={controller:he,collection:Q,profiles:pe};return this.controllers.set(B,de),H.add((0,h.toDisposable)(()=>this.controllers.delete(B))),H.add(Q.onDidGenerateDiff(Ae=>we.$publishDiff(B,Ae.map(k.TestsDiffOp.serialize)))),he}createTestObserver(){return this.observer.checkout()}async runTests(U,B=F.CancellationToken.None){const G=c(U);if(!G)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.controllers.get(G.controllerId);if(!N)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(H=>d.TestId.fromExtHostTestItem(H,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:J[G.kind],profileId:G.profileId,controllerId:G.controllerId}],exclude:U.exclude?.map(H=>H.id)},B)}$syncTests(){for(const{collection:U}of this.controllers.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,B,G){return(0,n.mapFind)(this.runTracker.trackers,H=>H.id===U?H.getCoverage(B):void 0)?.provideFileCoverage(G)??Promise.resolve([])}$resolveFileCoverage(U,B,G,N){return(0,n.mapFind)(this.runTracker.trackers,Q=>Q.id===U?Q.getCoverage(B):void 0)?.resolveFileCoverage(G,N)??Promise.resolve([])}$configureRunProfile(U,B){this.controllers.get(U)?.profiles.get(B)?.configureHandler?.()}async $refreshTests(U,B){await this.controllers.get(U)?.controller.refreshHandler?.(B)}$publishTestResults(U){this.results=Object.freeze(U.map(B=>(0,R.deepFreeze)(t.TestResults.to(B))).concat(this.results).sort((B,G)=>G.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(U,B){const G=this.controllers.get(d.TestId.fromString(U).controllerId)?.collection;G&&(await G.expand(U,B<0?1/0:B),G.flushDiff())}$acceptDiff(U){this.observer.applyDiff(U.map(k.TestsDiffOp.deserialize))}async $runControllerTests(U,B){return Promise.all(U.map(G=>this.runControllerTestRequest(G,!1,B)))}async $startContinuousRun(U,B){const G=new F.CancellationTokenSource(B),N=await Promise.all(U.map(H=>this.runControllerTestRequest(H,!0,G.token)));return!B.isCancellationRequested&&!N.some(H=>H.error)&&await new Promise(H=>B.onCancellationRequested(H)),G.dispose(!0),N}async runControllerTestRequest(U,B,G){const N=this.controllers.get(U.controllerId);if(!N)return{};const{collection:H,profiles:Q}=N,pe=Q.get(U.profileId);if(!pe)return{};const we=U.testIds.map(ue=>H.tree.get(ue)).filter(b.isDefined),he=U.excludeExtIds.map(ue=>N.collection.tree.get(ue)).filter(b.isDefined).filter(ue=>we.some(le=>le.fullId.compare(ue.fullId)===2));if(!we.length)return{};const de=new o.TestRunRequest(we.some(ue=>ue.actual instanceof u.TestItemRootImpl)?void 0:we.map(ue=>ue.actual),he.map(ue=>ue.actual),pe,B),Ae=(0,k.isStartControllerTests)(U)&&this.runTracker.prepareForMainThreadTestRun(de,l.fromInternal(U,N.collection),G);try{return await pe.runHandler(de,G),{}}catch(ue){return{error:String(ue)}}finally{Ae&&(Ae.hasRunningTasks&&!G.isCancellationRequested&&await A.Event.toPromise(Ae.onEnd),Ae.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}};e.ExtHostTesting=a=je([Ve(0,p.IExtHostRpcService)],a);const r=1e4;var s;(function(q){q[q.Running=0]="Running",q[q.Cancelling=1]="Cancelling",q[q.Ended=2]="Ended"})(s||(s={}));class w extends h.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(U,B,G){super(),this.dto=U,this.proxy=B,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new F.CancellationTokenSource(G));const N=this._register(new T.RunOnceScheduler(()=>this.forciblyEndTasks(),r));this._register(this.cts.token.onCancellationRequested(()=>N.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(U){return this.tasks.get(U)?.coverage}createRun(U){const B=this.dto.id,G=this.dto.controllerId,N=(0,g.generateUuid)(),H=new m(this.proxy,B,N),Q=de=>(Ae,...ue)=>{if(we){console.warn(`Setting the state of test "${Ae.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(Ae)&&(this.ensureTestIsKnown(Ae),de(Ae,...ue))},pe=(de,Ae)=>{const ue=Ae instanceof Array?Ae.map(t.TestMessage.from):[t.TestMessage.from(Ae)];if(de.uri&&de.range){const le={range:t.Range.from(de.range),uri:de.uri};for(const $ of ue)$.location=$.location||le}this.proxy.$appendTestMessagesInRun(B,N,d.TestId.fromExtHostTestItem(de,G).toString(),ue)};let we=!1;const he={isPersisted:this.dto.isPersisted,token:this.cts.token,name:U,get coverageProvider(){return H.coverageProvider},set coverageProvider(de){H.coverageProvider=de},enqueued:Q(de=>{this.proxy.$updateTestStateInRun(B,N,d.TestId.fromExtHostTestItem(de,G).toString(),1)}),skipped:Q(de=>{this.proxy.$updateTestStateInRun(B,N,d.TestId.fromExtHostTestItem(de,G).toString(),5)}),started:Q(de=>{this.proxy.$updateTestStateInRun(B,N,d.TestId.fromExtHostTestItem(de,G).toString(),2)}),errored:Q((de,Ae,ue)=>{pe(de,Ae),this.proxy.$updateTestStateInRun(B,N,d.TestId.fromExtHostTestItem(de,G).toString(),6,ue)}),failed:Q((de,Ae,ue)=>{pe(de,Ae),this.proxy.$updateTestStateInRun(B,N,d.TestId.fromExtHostTestItem(de,G).toString(),4,ue)}),passed:Q((de,Ae)=>{this.proxy.$updateTestStateInRun(B,N,d.TestId.fromExtHostTestItem(de,this.dto.controllerId).toString(),3,Ae)}),appendOutput:(de,Ae,ue)=>{we||(ue&&(this.dto.isIncluded(ue)?this.ensureTestIsKnown(ue):ue=void 0),this.proxy.$appendOutputToRun(B,N,D.VSBuffer.fromString(de),Ae&&t.location.from(Ae),ue&&d.TestId.fromExtHostTestItem(ue,G).toString()))},end:()=>{we||(we=!0,this.proxy.$finishedTestRunTask(B,N),this.tasks.delete(N),this.tasks.size||this.markEnded())}};return this.tasks.set(N,{run:he,coverage:H}),this.proxy.$startedTestRunTask(B,{id:N,name:U,running:!0}),he}forciblyEndTasks(){for(const{run:U}of this.tasks.values())U.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(U){if(!(U instanceof u.TestItemImpl))throw new y.InvalidTestItemError(U.id);if(this.sharedTestIds.has(d.TestId.fromExtHostTestItem(U,this.dto.controllerId).toString()))return;const B=[],G=this.dto.colllection.root;for(;;){const N=t.TestItem.from(U);if(B.unshift(N),this.sharedTestIds.has(N.extId)||(this.sharedTestIds.add(N.extId),U===G))break;U=U.parent||G}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class I{get trackers(){return this.tracked.values()}constructor(U){this.proxy=U,this.tracked=new Map}prepareForMainThreadTestRun(U,B,G){return this.getTracker(U,B,G)}cancelRunById(U){for(const B of this.tracked.values())if(B.id===U){B.cancel();return}}cancelAllRuns(){for(const U of this.tracked.values())U.cancel()}createTestRun(U,B,G,N,H){const Q=this.tracked.get(G);if(Q)return Q.createRun(N);const pe=l.fromPublic(U,B,G,H),we=c(G);this.proxy.$startedExtensionTestRun({controllerId:U,continuous:!!G.continuous,profile:we&&{group:J[we.kind],id:we.profileId},exclude:G.exclude?.map(de=>d.TestId.fromExtHostTestItem(de,B.root.id).toString())??[],id:pe.id,include:G.include?.map(de=>d.TestId.fromExtHostTestItem(de,B.root.id).toString())??[B.root.id],persist:H});const he=this.getTracker(G,pe);return he.onEnd(()=>{this.proxy.$finishedExtensionTestRun(pe.id),he.dispose()}),he.createRun(N)}getTracker(U,B,G){const N=new w(B,this.proxy,G);return this.tracked.set(U,N),N.onEnd(()=>this.tracked.delete(U)),N}}e.TestRunCoordinator=I;const c=q=>{if(q.profile){if(!(q.profile instanceof W))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class l{static fromPublic(U,B,G,N){return new l(U,(0,g.generateUuid)(),G.include?.map(H=>d.TestId.fromExtHostTestItem(H,U).toString())??[U],G.exclude?.map(H=>d.TestId.fromExtHostTestItem(H,U).toString())??[],N,B)}static fromInternal(U,B){return new l(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,B)}constructor(U,B,G,N,H,Q){this.controllerId=U,this.id=B,this.isPersisted=H,this.colllection=Q,this.includePrefix=G.map(pe=>pe+"\0"),this.excludePrefix=N.map(pe=>pe+"\0")}isIncluded(U){const B=d.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const G of this.excludePrefix)if(B===G||B.startsWith(G))return!1;for(const G of this.includePrefix)if(B===G||B.startsWith(G))return!0;return!1}}e.TestRunDto=l;class m{set coverageProvider(U){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this._coverageProvider=U,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(U,B,G){this.proxy=U,this.runId=B,this.taskId=G}async provideFileCoverage(U){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(U))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(U,B){const G=await this.fileCoverage;let N=G?.[U];return!this._coverageProvider||!G||!N?[]:(N.detailedCoverage||(N=G[U]=await this._coverageProvider.resolveFileCoverage?.(N,B)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class E{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(U){this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(U){this.added.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}this.updated.delete(U);const B=d.TestId.parentId(U.item.extId);if(B&&this.alreadyRemoved.has(B.toString())){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:B,removed:G}=this;return{get added(){return[...U].map(N=>N.revived)},get updated(){return[...B].map(N=>N.revived)},get removed(){return[...G].map(N=>N.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class f extends k.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,B){return{...U,revived:t.TestItem.toPlain(U.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new E(this.changeEmitter)}}class L{constructor(U){this.proxy=U}checkout(){this.current||(this.current=this.createObserverData());const U=this.current;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(B=>B.revived)},dispose:(0,P.once)(()=>{--U.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(U){return this.current?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.current?.tests.apply(U)}createObserverData(){const U=new f;return this.proxy.$subscribeToDiffs(),{observers:0,tests:U}}}class W{get label(){return this._label}set label(U){U!==this._label&&(this._label=U,Le(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(U){U!==this._supportsContinuousRun&&(this._supportsContinuousRun=U,Le(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this._isDefault}set isDefault(U){U!==this._isDefault&&(this._isDefault=U,Le(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Le(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(U){U!==this._configureHandler&&(this._configureHandler=U,Le(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,B,G,N,H,Q,pe,we=!1,he=void 0,de=!1){this.controllerId=G,this.profileId=N,this._label=H,this.kind=Q,this.runHandler=pe,this._isDefault=we,this._tag=he,this._supportsContinuousRun=de,v.set(this,void 0),i.set(this,void 0),Je(this,v,U,"f"),Je(this,i,B,"f"),B.set(N,this);const Ae=J[Q];if(typeof Ae!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);Le(this,v,"f").$publishTestRunProfile({profileId:N,controllerId:G,tag:he?t.TestTag.namespace(this.controllerId,he.id):null,label:H,group:Ae,isDefault:we,hasConfigurationHandler:!1,supportsContinuousRun:de})}dispose(){Le(this,i,"f")?.delete(this.profileId)&&(Je(this,i,void 0,"f"),Le(this,v,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=W,v=new WeakMap,i=new WeakMap;const J={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Te[245],Pe([1,0,16,9,5,4,105,8,7]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class h{constructor(b,g){this._extHostDocumentsAndEditors=g,this._onDidChangeTextEditorSelection=new D.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new D.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new D.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new D.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new D.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new D.Emitter({onListenerError:T.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=b.getProxy(F.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(_=>this._onDidChangeVisibleTextEditors.fire(_)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(_=>this._onDidChangeActiveTextEditor.fire(_))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(b){const g=this._extHostDocumentsAndEditors.allEditors();return b?g:g.map(_=>_.value)}async showTextDocument(b,g,_){let p;typeof g=="number"?p={position:P.ViewColumn.from(g),preserveFocus:_}:typeof g=="object"?p={position:P.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selection:typeof g.selection=="object"?P.Range.from(g.selection):void 0,pinned:typeof g.preview=="boolean"?!g.preview:void 0}:p={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(b.uri,p),t=u&&this._extHostDocumentsAndEditors.getEditor(u);if(t)return t.value;throw u?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}createTextEditorDecorationType(b,g){return new A.TextEditorDecorationType(this._proxy,b,g).value}$acceptEditorPropertiesChanged(b,g){const _=this._extHostDocumentsAndEditors.getEditor(b);if(!_)throw new Error("unknown text editor");if(g.options&&_._acceptOptions(g.options),g.selections){const p=g.selections.selections.map(P.Selection.to);_._acceptSelections(p)}if(g.visibleRanges){const p=n.coalesce(g.visibleRanges.map(P.Range.to));_._acceptVisibleRanges(p)}if(g.options&&this._onDidChangeTextEditorOptions.fire({textEditor:_.value,options:{...g.options,lineNumbers:P.TextEditorLineNumbersStyle.to(g.options.lineNumbers)}}),g.selections){const p=S.TextEditorSelectionChangeKind.fromValue(g.selections.source),u=g.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:_.value,selections:u,kind:p})}if(g.visibleRanges){const p=n.coalesce(g.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:_.value,visibleRanges:p})}}$acceptEditorPositionData(b){for(const g in b){const _=this._extHostDocumentsAndEditors.getEditor(g);if(!_)throw new Error("Unknown text editor");const p=P.ViewColumn.to(b[g]);_.value.viewColumn!==p&&(_._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:_.value,viewColumn:p}))}}getDiffInformation(b){return Promise.resolve(this._proxy.$getDiffInformation(b))}}e.ExtHostEditors=h}),define(Te[246],Pe([1,0,2,3,4,6,7,8,24,12]),function(te,e,n,T,D,F,A,P,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class R{constructor(_,p){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=_.getProxy(D.MainContext.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(u,t)=>{if(u&&u.$mid===12)if(this._providers.get(u.source)&&S.ExtensionIdentifier.equals(t,this._providers.get(u.source)?.extension)){const o=u.uri===void 0?void 0:n.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(b(o))?.get(u.handle)}else return;return u}})}async $getTimeline(_,p,u,t){return this._providers.get(_)?.provider.provideTimeline(n.URI.revive(p),u,t)}registerTimelineProvider(_,p,u,t){const o=new F.DisposableStore,d=this.convertTimelineItem(p.id,t,o).bind(this);let y;p.onDidChange&&(y=p.onDidChange(v=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:p.id}),this));const k=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...p,scheme:_,onDidChange:void 0,async provideTimeline(v,i,a){i?.resetCache&&(o.clear(),k.get(p.id)?.clear());const r=await p.provideTimeline(v,i,a);if(r==null)return;const s=d(v,i);return{...r,source:p.id,items:r.items.map(s)}},dispose(){for(const v of k.values())v.get(p.id)?.clear();y?.dispose(),o.dispose()}},u)}convertTimelineItem(_,p,u){return(t,o)=>{let d;if(o?.cacheResults){let y=this._itemsBySourceAndUriMap.get(_);y===void 0&&(y=new Map,this._itemsBySourceAndUriMap.set(_,y));const k=b(t);d=y.get(k),d===void 0&&(d=new Map,y.set(k,d))}return y=>{const{iconPath:k,...v}=y,i=`${_}|${y.id??y.timestamp}`;d?.set(i,y);let a,r,s;y.iconPath&&(k instanceof A.ThemeIcon?s={id:k.id,color:k.color}:n.URI.isUri(k)?(a=k,r=k):{light:a,dark:r}=k);let w;return A.MarkdownString.isMarkdownString(v.tooltip)?w=P.MarkdownString.from(v.tooltip):(0,h.isString)(v.tooltip)?w=v.tooltip:A.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=P.MarkdownString.from(v.detail)):(0,h.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=v.detail),{...v,id:v.id??void 0,handle:i,source:_,command:y.command?p.toInternal(y.command,u):void 0,icon:a,iconDark:r,themeIcon:s,tooltip:w,accessibilityInformation:y.accessibilityInformation}}}}registerTimelineProviderCore(_,p){if(this._providers.get(_.id))throw new Error(`Timeline Provider ${_.id} already exists.`);return this._proxy.$registerTimelineProvider({id:_.id,label:_.label,scheme:_.scheme}),this._providers.set(_.id,{provider:_,extension:p}),(0,F.toDisposable)(()=>{for(const t of this._itemsBySourceAndUriMap.values())t.get(_.id)?.clear();this._providers.delete(_.id),this._proxy.$unregisterTimelineProvider(_.id),_.dispose()})}}e.ExtHostTimeline=R;function b(g){return g?.toString()}}),define(Te[247],Pe([1,0,6,15,2,4]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(S){this._openers=new Map,this._proxy=S.getProxy(F.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,h,R,b){if(this._openers.has(h))throw new Error(`Opener with id '${h}' already registered`);const g=b.schemes.find(_=>!A.supportedSchemes.has(_));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(h,R),this._proxy.$registerUriOpener(h,b.schemes,S,b.label),(0,n.toDisposable)(()=>{this._openers.delete(h),this._proxy.$unregisterUriOpener(h)})}async $canOpenUri(S,h,R){const b=this._openers.get(S);if(!b)throw new Error(`Unknown opener with id: ${S}`);const g=D.URI.revive(h);return b.canOpenExternalUri(g,R)}async $openUri(S,h,R){const b=this._openers.get(S);if(!b)throw new Error(`Unknown opener id: '${S}'`);return b.openExternalUri(D.URI.revive(h.resolvedUri),{sourceUri:D.URI.revive(h.sourceUri)},R)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(Te[248],Pe([1,0,4,2,6,9,24]),function(te,e,n,T,D,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(h){this.handles=new A.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=h.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(h,R){if(this.handles.has(h))throw new Error(`Protocol handler already registered for extension ${h}`);const b=P.HandlePool++;return this.handles.add(h),this.handlers.set(b,R),this._proxy.$registerUriHandler(b,h),(0,D.toDisposable)(()=>{this.handles.delete(h),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(h,R){const b=this.handlers.get(h);if(!b)return Promise.resolve(void 0);try{b.handleUri(T.URI.revive(R))}catch(g){(0,F.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(h){return T.URI.revive(await this._proxy.$createAppUri(h))}}e.ExtHostUrls=P,P.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Te[63],Pe([1,0,5,15,23,2,166,189,75,4]),function(te,e,n,T,D,F,A,P,S,h){"use strict";var R,b,g,_,p,u,t,o,d,y,k,v,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class a{constructor(f,L,W,J,q,U,B){R.set(this,void 0),b.set(this,void 0),g.set(this,void 0),_.set(this,void 0),p.set(this,void 0),u.set(this,void 0),t.set(this,""),o.set(this,void 0),d.set(this,!1),y.set(this,!1),k.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new n.Emitter),this._onDidDispose=Le(this,i,"f").event,Je(this,R,f,"f"),Je(this,b,L,"f"),Je(this,o,W,"f"),Je(this,_,J,"f"),Je(this,p,q,"f"),Je(this,u,U,"f"),Je(this,k,r(U),"f"),Je(this,v,s(U),"f"),Je(this,g,B,"f")}dispose(){Je(this,d,!0,"f"),Le(this,i,"f").fire(),Le(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return Je(this,y,!0,"f"),(0,S.asWebviewUri)(f,Le(this,_,"f"))}get cspSource(){const f=Le(this,u,"f").extensionLocation;if(f.scheme===T.Schemas.https||f.scheme===T.Schemas.http){let L=f.toString();return L.endsWith("/")||(L+="/"),L+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Le(this,t,"f")}set html(f){this.assertNotDisposed(),Le(this,t,"f")!==f&&(Je(this,t,f,"f"),Le(this,v,"f")&&!Le(this,y,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(Je(this,y,!0,"f"),Le(this,g,"f").report("Webview vscode-resource: uris",Le(this,u,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,b,"f").$setHtml(Le(this,R,"f"),this.rewriteOldResourceUrlsIfNeeded(f)))}get options(){return this.assertNotDisposed(),Le(this,o,"f")}set options(f){this.assertNotDisposed(),D.equals(Le(this,o,"f"),f)||Le(this,b,"f").$setOptions(Le(this,R,"f"),c(Le(this,u,"f"),Le(this,p,"f"),f)),Je(this,o,f,"f")}async postMessage(f){if(Le(this,d,"f"))return!1;const L=(0,P.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:Le(this,k,"f")});return Le(this,b,"f").$postMessage(Le(this,R,"f"),L.message,...L.buffers)}assertNotDisposed(){if(Le(this,d,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(f){if(!Le(this,v,"f"))return f;const L=Le(this,u,"f").extensionLocation?.scheme===T.Schemas.vscodeRemote,W=Le(this,u,"f").extensionLocation.scheme===T.Schemas.vscodeRemote?Le(this,u,"f").extensionLocation.authority:void 0;return f.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(J,q,U,B,G,N)=>{const H=F.URI.from({scheme:B||"file",path:decodeURIComponent(G)}),Q=(0,S.asWebviewUri)(H,{isRemote:L,authority:W}).toString();return`${q}${Q}${N}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(J,q,U,B,G,N)=>{const H=F.URI.from({scheme:B||"file",path:decodeURIComponent(G)}),Q=(0,S.asWebviewUri)(H,{isRemote:L,authority:W}).toString();return`${q}${Q}${N}`})}}e.ExtHostWebview=a,R=new WeakMap,b=new WeakMap,g=new WeakMap,_=new WeakMap,p=new WeakMap,u=new WeakMap,t=new WeakMap,o=new WeakMap,d=new WeakMap,y=new WeakMap,k=new WeakMap,v=new WeakMap,i=new WeakMap;function r(E){try{const f=(0,A.normalizeVersion)((0,A.parseVersion)(E.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function s(E){try{const f=(0,A.normalizeVersion)((0,A.parseVersion)(E.engines.vscode));return f?f.majorBase<1||f.majorBase===1&&f.minorBase<60:!1}catch{return!1}}class w{constructor(f,L,W,J,q){this.remoteInfo=L,this.workspace=W,this._logService=J,this._deprecationService=q,this._webviews=new Map,this._webviewProxy=f.getProxy(h.MainContext.MainThreadWebviews)}$onMessage(f,L,W){const J=this.getWebview(f);if(J){const{message:q}=(0,P.deserializeWebviewMessage)(L,W.value);J._onMessageEmitter.fire(q)}}$onMissingCsp(f,L){this._logService.warn(`${L} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,L,W){const J=new a(f,this._webviewProxy,l(L),this.remoteInfo,this.workspace,W,this._deprecationService);return this._webviews.set(f,J),J._onDidDispose(()=>{this._webviews.delete(f)}),J}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=w;function I(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=I;function c(E,f,L){return{enableCommandUris:L.enableCommandUris,enableScripts:L.enableScripts,enableForms:L.enableForms,portMapping:L.portMapping,localResourceRoots:L.localResourceRoots||m(E,f)}}e.serializeWebviewOptions=c;function l(E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots?.map(f=>F.URI.from(f))}}function m(E,f){return[...(f?.getWorkspaceFolders()||[]).map(L=>L.uri),E.extensionLocation]}}),define(Te[249],Pe([1,0,21,92,6,15,22,2,8,63,54,4,7]),function(te,e,n,T,D,F,A,P,S,h,R,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class _{constructor(a,r){this.document=a,this._storagePath=r,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,r){await this.getEdit(a).undo(),r||this.disposeBackup()}async redo(a,r){await this.getEdit(a).redo(),r||this.disposeBackup()}disposeEdits(a){for(const r of a)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=v(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const r=this._edits.get(a,0);if(!r)throw new Error("No edit found");return r}}class p{constructor(){this._documents=new Map}get(a,r){return this._documents.get(this.key(a,r))}add(a,r,s){const w=this.key(a,r.uri);if(this._documents.has(w))throw new Error(`Document already exists for viewType:${a} resource:${r.uri}`);const I=new _(r,s);return this._documents.set(w,I),I}delete(a,r){const s=this.key(a,r.uri);this._documents.delete(s)}key(a,r){return`${a}@@@${r}`}}var u;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(u||(u={}));class t{constructor(){this._providers=new Map}addTextProvider(a,r,s){return this.add(0,a,r,s)}addCustomProvider(a,r,s){return this.add(1,a,r,s)}get(a){return this._providers.get(a)}add(a,r,s,w){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:a,extension:s,provider:w}),new g.Disposable(()=>this._providers.delete(r))}}class o{constructor(a,r,s,w,I){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=w,this._extHostWebviewPanels=I,this._editorProviders=new t,this._documents=new p,this._proxy=a.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,r,s,w){const I=new D.DisposableStore;return y(s)?(I.add(this._editorProviders.addTextProvider(r,a,s)),this._proxy.$registerTextEditorProvider((0,h.toExtensionData)(a),r,w.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,h.shouldSerializeBuffersForPostMessage)(a))):(I.add(this._editorProviders.addCustomProvider(r,a,s)),d(s)&&I.add(s.onDidChangeCustomDocument(c=>{const l=this.getCustomDocumentEntry(r,c.document.uri);if(k(c)){const m=l.addEdit(c);this._proxy.$onDidEdit(c.document.uri,r,m,c.label)}else this._proxy.$onContentChange(c.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,h.toExtensionData)(a),r,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,h.shouldSerializeBuffersForPostMessage)(a))),g.Disposable.from(I,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(a,r,s,w,I){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${r}'`);const l=P.URI.revive(a),m=await c.provider.openCustomDocument(l,{backupId:s,untitledDocumentData:w?.buffer},I);let E;return d(c.provider)&&this._extensionStoragePaths&&(E=this._extensionStoragePaths.workspaceValue(c.extension)??this._extensionStoragePaths.globalValue(c.extension)),this._documents.add(r,m,E),{editable:d(c.provider)}}async $disposeCustomDocument(a,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const w=P.URI.revive(a),{document:I}=this.getCustomDocumentEntry(r,w);this._documents.delete(r,I),I.dispose()}async $resolveCustomEditor(a,r,s,w,I,c){const l=this._editorProviders.get(s);if(!l)throw new Error(`No provider found for '${s}'`);const m=S.ViewColumn.to(I),E=this._extHostWebview.createNewWebview(r,w.contentOptions,l.extension),f=this._extHostWebviewPanels.createNewWebviewPanel(r,s,w.title,m,w.options,E,!0),L=P.URI.revive(a);switch(l.type){case 1:{const{document:W}=this.getCustomDocumentEntry(s,L);return l.provider.resolveCustomEditor(W,f,c)}case 0:{const W=this._extHostDocuments.getDocument(L);return l.provider.resolveCustomTextEditor(W,f,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,r,s){this.getCustomDocumentEntry(r,a).disposeEdits(s)}async $onMoveCustomEditor(a,r,s){const w=this._editorProviders.get(s);if(!w)throw new Error(`No provider found for '${s}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const I=this._extHostWebviewPanels.getWebviewPanel(a);if(!I)throw new Error("No webview found");const c=P.URI.revive(r),l=this._extHostDocuments.getDocument(c);await w.provider.moveCustomTextEditor(l,I,n.CancellationToken.None)}async $undo(a,r,s,w){return this.getCustomDocumentEntry(r,a).undo(s,w)}async $redo(a,r,s,w){return this.getCustomDocumentEntry(r,a).redo(s,w)}async $revert(a,r,s){const w=this.getCustomDocumentEntry(r,a);await this.getCustomEditorProvider(r).revertCustomDocument(w.document,s),w.disposeBackup()}async $onSave(a,r,s){const w=this.getCustomDocumentEntry(r,a);await this.getCustomEditorProvider(r).saveCustomDocument(w.document,s),w.disposeBackup()}async $onSaveAs(a,r,s,w){const I=this.getCustomDocumentEntry(r,a);return this.getCustomEditorProvider(r).saveCustomDocumentAs(I.document,P.URI.revive(s),w)}async $backup(a,r,s){const w=this.getCustomDocumentEntry(r,a),c=await this.getCustomEditorProvider(r).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},s);return w.updateBackup(c),c.id}getCustomDocumentEntry(a,r){const s=this._documents.get(a,P.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(a){const s=this._editorProviders.get(a)?.provider;if(!s||!d(s))throw new Error("Custom document is not editable");return s}}e.ExtHostCustomEditors=o;function d(i){return!!i.onDidChangeCustomDocument}function y(i){return typeof i.resolveCustomTextEditor=="function"}function k(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function v(i){const a=i.scheme===F.Schemas.file||i.scheme===F.Schemas.untitled?i.fsPath:i.toString();return(0,T.hash)(a)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Te[250],Pe([1,0,5,6,2,35,8,63,4,7]),function(te,e,n,T,D,F,A,P,S,h){"use strict";var R,b,g,_,p,u,t,o,d,y,k,v,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class a extends T.Disposable{constructor(I,c,l,m){super(),R.set(this,void 0),b.set(this,void 0),g.set(this,void 0),_.set(this,void 0),p.set(this,void 0),u.set(this,void 0),t.set(this,void 0),o.set(this,void 0),d.set(this,!0),y.set(this,void 0),k.set(this,!1),v.set(this,this._register(new n.Emitter)),this.onDidDispose=Le(this,v,"f").event,i.set(this,this._register(new n.Emitter)),this.onDidChangeViewState=Le(this,i,"f").event,Je(this,R,I,"f"),Je(this,b,c,"f"),Je(this,_,l,"f"),Je(this,g,m.viewType,"f"),Je(this,p,m.panelOptions,"f"),Je(this,o,m.viewColumn,"f"),Je(this,u,m.title,"f"),Je(this,y,m.active,"f")}dispose(){Le(this,k,"f")||(Je(this,k,!0,"f"),Le(this,v,"f").fire(),Le(this,b,"f").$disposeWebview(Le(this,R,"f")),Le(this,_,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Le(this,_,"f")}get viewType(){return this.assertNotDisposed(),Le(this,g,"f")}get title(){return this.assertNotDisposed(),Le(this,u,"f")}set title(I){this.assertNotDisposed(),Le(this,u,"f")!==I&&(Je(this,u,I,"f"),Le(this,b,"f").$setTitle(Le(this,R,"f"),I))}get iconPath(){return this.assertNotDisposed(),Le(this,t,"f")}set iconPath(I){this.assertNotDisposed(),Le(this,t,"f")!==I&&(Je(this,t,I,"f"),Le(this,b,"f").$setIconPath(Le(this,R,"f"),D.URI.isUri(I)?{light:I,dark:I}:I))}get options(){return Le(this,p,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Le(this,o,"f")=="number"&&Le(this,o,"f")<0))return Le(this,o,"f")}get active(){return this.assertNotDisposed(),Le(this,y,"f")}get visible(){return this.assertNotDisposed(),Le(this,d,"f")}_updateViewState(I){Le(this,k,"f")||(this.active!==I.active||this.visible!==I.visible||this.viewColumn!==I.viewColumn)&&(Je(this,y,I.active,"f"),Je(this,d,I.visible,"f"),Je(this,o,I.viewColumn,"f"),Le(this,i,"f").fire({webviewPanel:this}))}reveal(I,c){this.assertNotDisposed(),Le(this,b,"f").$reveal(Le(this,R,"f"),{viewColumn:typeof I>"u"?void 0:A.ViewColumn.from(I),preserveFocus:!!c})}assertNotDisposed(){if(Le(this,k,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,b=new WeakMap,g=new WeakMap,_=new WeakMap,p=new WeakMap,u=new WeakMap,t=new WeakMap,o=new WeakMap,d=new WeakMap,y=new WeakMap,k=new WeakMap,v=new WeakMap,i=new WeakMap;class r{static newHandle(){return(0,F.generateUuid)()}constructor(I,c,l){this.webviews=c,this.workspace=l,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=I.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(I,c,l,m,E={}){const f=typeof m=="object"?m.viewColumn:m,L={viewColumn:A.ViewColumn.from(f),preserveFocus:typeof m=="object"&&!!m.preserveFocus},W=(0,P.shouldSerializeBuffersForPostMessage)(I),J=r.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(I),J,c,{title:l,panelOptions:s(E),webviewOptions:(0,P.serializeWebviewOptions)(I,this.workspace,E),serializeBuffersForPostMessage:W},L);const q=this.webviews.createNewWebview(J,E,I);return this.createNewWebviewPanel(J,c,l,f,E,q,!0)}$onDidChangeWebviewPanelViewStates(I){const c=Object.keys(I);c.sort((l,m)=>{const E=I[l],f=I[m];return E.active?1:f.active?-1:+E.visible-+f.visible});for(const l of c){const m=this.getWebviewPanel(l);if(!m)continue;const E=I[l];m._updateViewState({active:E.active,visible:E.visible,viewColumn:A.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(I){this.getWebviewPanel(I)?.dispose(),this._webviewPanels.delete(I),this.webviews.deleteWebview(I)}registerWebviewPanelSerializer(I,c,l){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:l,extension:I}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(I)}),new h.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(I,c,l,m){const E=this._serializers.get(c);if(!E)throw new Error(`No serializer found for '${c}'`);const{serializer:f,extension:L}=E,W=this.webviews.createNewWebview(I,l.webviewOptions,L),J=this.createNewWebviewPanel(I,c,l.title,m,l.panelOptions,W,l.active);await f.deserializeWebviewPanel(J,l.state)}createNewWebviewPanel(I,c,l,m,E,f,L){const W=new a(I,this._proxy,f,{viewType:c,title:l,viewColumn:m,panelOptions:E,active:L});return this._webviewPanels.set(I,W),W}getWebviewPanel(I){return this._webviewPanels.get(I)}}e.ExtHostWebviewPanels=r;function s(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Te[251],Pe([1,0,5,6,63,8,4,7]),function(te,e,n,T,D,F,A,P){"use strict";var S,h,R,b,g,_,p,u,t,o,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends T.Disposable{constructor(i,a,r,s,w,I){super(),S.set(this,void 0),h.set(this,void 0),R.set(this,void 0),b.set(this,void 0),g.set(this,!1),_.set(this,void 0),p.set(this,void 0),u.set(this,void 0),t.set(this,void 0),o.set(this,this._register(new n.Emitter)),this.onDidChangeVisibility=Le(this,o,"f").event,d.set(this,this._register(new n.Emitter)),this.onDidDispose=Le(this,d,"f").event,Je(this,R,r,"f"),Je(this,p,s,"f"),Je(this,S,i,"f"),Je(this,h,a,"f"),Je(this,b,w,"f"),Je(this,_,I,"f")}dispose(){Le(this,g,"f")||(Je(this,g,!0,"f"),Le(this,d,"f").fire(),Le(this,b,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Le(this,p,"f")}set title(i){this.assertNotDisposed(),Le(this,p,"f")!==i&&(Je(this,p,i,"f"),Le(this,h,"f").$setWebviewViewTitle(Le(this,S,"f"),i))}get description(){return this.assertNotDisposed(),Le(this,u,"f")}set description(i){this.assertNotDisposed(),Le(this,u,"f")!==i&&(Je(this,u,i,"f"),Le(this,h,"f").$setWebviewViewDescription(Le(this,S,"f"),i))}get visible(){return Le(this,_,"f")}get webview(){return Le(this,b,"f")}get viewType(){return Le(this,R,"f")}_setVisible(i){i===Le(this,_,"f")||Le(this,g,"f")||(Je(this,_,i,"f"),Le(this,o,"f").fire())}get badge(){return this.assertNotDisposed(),Le(this,t,"f")}set badge(i){this.assertNotDisposed(),!(i?.value===Le(this,t,"f")?.value&&i?.tooltip===Le(this,t,"f")?.tooltip)&&(Je(this,t,F.ViewBadge.from(i),"f"),Le(this,h,"f").$setWebviewViewBadge(Le(this,S,"f"),i))}show(i){this.assertNotDisposed(),Le(this,h,"f").$show(Le(this,S,"f"),!!i)}assertNotDisposed(){if(Le(this,g,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,h=new WeakMap,R=new WeakMap,b=new WeakMap,g=new WeakMap,_=new WeakMap,p=new WeakMap,u=new WeakMap,t=new WeakMap,o=new WeakMap,d=new WeakMap;class k{constructor(i,a){this._extHostWebview=a,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,a,r,s){if(this._viewProviders.has(a))throw new Error(`View provider for '${a}' already registered`);return this._viewProviders.set(a,{provider:r,extension:i}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(i),a,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(i)}),new P.Disposable(()=>{this._viewProviders.delete(a),this._proxy.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(i,a,r,s,w){const I=this._viewProviders.get(a);if(!I)throw new Error(`No view provider found for '${a}'`);const{provider:c,extension:l}=I,m=this._extHostWebview.createNewWebview(i,{},l),E=new y(i,this._proxy,a,r,m,!0);this._webviewViews.set(i,E),await c.resolveWebviewView(E,{state:s},w)}async $onDidChangeWebviewViewVisibility(i,a){this.getWebviewView(i)._setVisible(a)}async $disposeWebviewView(i){const a=this.getWebviewView(i);this._webviewViews.delete(i),a.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const a=this._webviewViews.get(i);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=k}),define(Te[107],Pe([1,0,5,4,2,15,13,3,18]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let h=e.ExtHostWindow=class Dn{get state(){return this._state}constructor(b){this._onDidChangeWindowState=new n.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Dn.InitialState,this._proxy=b.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,g){let _;if(typeof b=="string"){_=b;try{b=D.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,_,g)}async asExternalUri(b,g){if((0,A.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const _=await this._proxy.$asExternalUri(b,g);return D.URI.from(_)}};h.InitialState={focused:!0},e.ExtHostWindow=h=je([Ve(0,S.IExtHostRpcService)],h),e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(Te[252],Pe([1,0,219,27,18]),function(te,e,n,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let F=e.ExtHostConsoleForwarder=class extends n.AbstractExtHostConsoleForwarder{constructor(P,S){super(P,S)}_nativeConsoleLogMessage(P,S,h){S.apply(console,h)}};e.ExtHostConsoleForwarder=F=je([Ve(0,D.IExtHostRpcService),Ve(1,T.IExtHostInitDataService)],F)}),define(Te[253],Pe([1,0,17,25,21,9,5,6,131,213,46]),function(te,e,n,T,D,F,A,P,S,h,R){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function g(E,f){try{return JSON.stringify(E,f)}catch{return"null"}}const _="$$ref$$",p={[_]:-1};class u{constructor(f,L){this.jsonString=f,this.referencedBuffers=L}}function t(E,f=null,L=!1){const W=[];return{jsonString:(L?g:JSON.stringify)(E,(q,U)=>{if(typeof U>"u")return p;if(typeof U=="object"){if(U instanceof T.VSBuffer){const B=W.push(U)-1;return{[_]:B}}if(f)return f(q,U)}return U}),referencedBuffers:W}}e.stringifyJsonWithBufferRefs=t;function o(E,f,L){return JSON.parse(E,(W,J)=>{if(J){const q=J[_];if(typeof q=="number")return f[q];if(L&&J.$mid===1)return L.transformIncoming(J)}return J})}e.parseJsonAndRestoreBufferRefs=o;function d(E,f){return JSON.stringify(E,f)}function y(E){return E?(f,L)=>L&&L.$mid===1?E.transformOutgoing(L):L:null}var k;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));var v;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(v||(e.ResponsiveState=v={}));const i=()=>{},a=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends P.Disposable{constructor(f,L=null,W=null){super(),this[b]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=f,this._logger=L,this._uriTransformer=W,this._uriReplacer=y(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let J=0,q=R.ProxyIdentifier.count;J<q;J++)this._locals[J]=null,this._proxies[J]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new n.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(J=>this._receiveOneMessage(J))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(f=>{this._pendingRPCReplies[f].resolveErr(F.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(f){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(f){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(f){this._responsiveState!==f&&(this._responsiveState=f,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(f){return this._uriTransformer?(0,S.transformIncomingURIs)(f,this._uriTransformer):f}getProxy(f){const{nid:L,sid:W}=f;return this._proxies[L]||(this._proxies[L]=this._createProxy(L,W)),this._proxies[L]}_createProxy(f,L){const W={get:(J,q)=>(typeof q=="string"&&!J[q]&&q.charCodeAt(0)===36&&(J[q]=(...U)=>this._remoteCall(f,q,U)),q===r?L:J[q])};return new Proxy(Object.create(null),W)}set(f,L){return this._locals[f.nid]=L,L}assertRegistered(f){for(let L=0,W=f.length;L<W;L++){const J=f[L];if(!this._locals[J.nid])throw new Error(`Missing proxy instance ${J.sid}`)}}_receiveOneMessage(f){if(this._isDisposed)return;const L=f.byteLength,W=w.read(f,0),J=W.readUInt8(),q=W.readUInt32();switch(J){case 1:case 2:{let{rpcId:U,method:B,args:G}=c.deserializeRequestJSONArgs(W);this._uriTransformer&&(G=(0,S.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(L,q,U,B,G,J===2);break}case 3:case 4:{let{rpcId:U,method:B,args:G}=c.deserializeRequestMixedArgs(W);this._uriTransformer&&(G=(0,S.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(L,q,U,B,G,J===4);break}case 5:{this._logger?.logIncoming(L,q,0,"ack"),this._onDidReceiveAcknowledge(q);break}case 6:{this._receiveCancel(L,q);break}case 7:{this._receiveReply(L,q,void 0);break}case 9:{let U=c.deserializeReplyOKJSON(W);this._uriTransformer&&(U=(0,S.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(L,q,U);break}case 10:{const U=c.deserializeReplyOKJSONWithBuffers(W,this._uriTransformer);this._receiveReply(L,q,U);break}case 8:{const U=c.deserializeReplyOKVSBuffer(W);this._receiveReply(L,q,U);break}case 11:{let U=c.deserializeReplyErrError(W);this._uriTransformer&&(U=(0,S.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(L,q,U);break}case 12:{this._receiveReplyErr(L,q,void 0);break}default:console.error("received unexpected message"),console.error(f)}}_receiveRequest(f,L,W,J,q,U){this._logger?.logIncoming(f,L,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(W)}.${J}(`,q);const B=String(L);let G,N;if(U){const Q=new D.CancellationTokenSource;q.push(Q.token),G=this._invokeHandler(W,J,q),N=()=>Q.cancel()}else G=this._invokeHandler(W,J,q),N=i;this._cancelInvokedHandlers[B]=N;const H=c.serializeAcknowledged(L);this._logger?.logOutgoing(H.byteLength,L,1,"ack"),this._protocol.send(H),G.then(Q=>{delete this._cancelInvokedHandlers[B];const pe=c.serializeReplyOK(L,Q,this._uriReplacer);this._logger?.logOutgoing(pe.byteLength,L,1,"reply:",Q),this._protocol.send(pe)},Q=>{delete this._cancelInvokedHandlers[B];const pe=c.serializeReplyErr(L,Q);this._logger?.logOutgoing(pe.byteLength,L,1,"replyErr:",Q),this._protocol.send(pe)})}_receiveCancel(f,L){this._logger?.logIncoming(f,L,1,"receiveCancel");const W=String(L);this._cancelInvokedHandlers[W]?.()}_receiveReply(f,L,W){this._logger?.logIncoming(f,L,0,"receiveReply:",W);const J=String(L);if(!this._pendingRPCReplies.hasOwnProperty(J))return;const q=this._pendingRPCReplies[J];delete this._pendingRPCReplies[J],q.resolveOk(W)}_receiveReplyErr(f,L,W){this._logger?.logIncoming(f,L,0,"receiveReplyErr:",W);const J=String(L);if(!this._pendingRPCReplies.hasOwnProperty(J))return;const q=this._pendingRPCReplies[J];delete this._pendingRPCReplies[J];let U;W&&(W.$isError?(U=new Error,U.name=W.name,U.message=W.message,U.stack=W.stack):U=W),q.resolveErr(U)}_invokeHandler(f,L,W){try{return Promise.resolve(this._doInvokeHandler(f,L,W))}catch(J){return Promise.reject(J)}}_doInvokeHandler(f,L,W){const J=this._locals[f];if(!J)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(f));const q=J[L];if(typeof q!="function")throw new Error("Unknown method "+L+" on actor "+(0,R.getStringIdentifierForProxy)(f));return q.apply(J,W)}_remoteCall(f,L,W){if(this._isDisposed)return new h.CanceledLazyPromise;let J=null;if(W.length>0&&D.CancellationToken.isCancellationToken(W[W.length-1])&&(J=W.pop()),J&&J.isCancellationRequested)return Promise.reject(F.canceled());const q=c.serializeRequestArguments(W,this._uriReplacer),U=++this._lastMessageId,B=String(U),G=new h.LazyPromise;J&&J.onCancellationRequested(()=>{const H=c.serializeCancel(U);this._logger?.logOutgoing(H.byteLength,U,0,"cancel"),this._protocol.send(c.serializeCancel(U))}),this._pendingRPCReplies[B]=G,this._onWillSendRequest(U);const N=c.serializeRequest(U,f,L,q,!!J);return this._logger?.logOutgoing(N.byteLength,U,0,`request: ${(0,R.getStringIdentifierForProxy)(f)}.${L}(`,W),this._protocol.send(N),G}}e.RPCProtocol=s,b=a,s.UNRESPONSIVE_TIME=3*1e3;class w{static alloc(f,L,W){const J=new w(T.VSBuffer.alloc(W+1+4),0);return J.writeUInt8(f),J.writeUInt32(L),J}static read(f,L){return new w(f,L)}get buffer(){return this._buff}constructor(f,L){this._buff=f,this._offset=L}static sizeUInt8(){return 1}writeUInt8(f){this._buff.writeUInt8(f,this._offset),this._offset+=1}readUInt8(){const f=this._buff.readUInt8(this._offset);return this._offset+=1,f}writeUInt32(f){this._buff.writeUInt32BE(f,this._offset),this._offset+=4}readUInt32(){const f=this._buff.readUInt32BE(this._offset);return this._offset+=4,f}static sizeShortString(f){return 1+f.byteLength}writeShortString(f){this._buff.writeUInt8(f.byteLength,this._offset),this._offset+=1,this._buff.set(f,this._offset),this._offset+=f.byteLength}readShortString(){const f=this._buff.readUInt8(this._offset);this._offset+=1;const W=this._buff.slice(this._offset,this._offset+f).toString();return this._offset+=f,W}static sizeLongString(f){return 4+f.byteLength}writeLongString(f){this._buff.writeUInt32BE(f.byteLength,this._offset),this._offset+=4,this._buff.set(f,this._offset),this._offset+=f.byteLength}readLongString(){const f=this._buff.readUInt32BE(this._offset);this._offset+=4;const W=this._buff.slice(this._offset,this._offset+f).toString();return this._offset+=f,W}writeBuffer(f){this._buff.writeUInt32BE(f.byteLength,this._offset),this._offset+=4,this._buff.set(f,this._offset),this._offset+=f.byteLength}static sizeVSBuffer(f){return 4+f.byteLength}writeVSBuffer(f){this._buff.writeUInt32BE(f.byteLength,this._offset),this._offset+=4,this._buff.set(f,this._offset),this._offset+=f.byteLength}readVSBuffer(){const f=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+f);return this._offset+=f,L}static sizeMixedArray(f){let L=0;L+=1;for(let W=0,J=f.length;W<J;W++){const q=f[W];switch(L+=1,q.type){case 1:L+=this.sizeLongString(q.value);break;case 2:L+=this.sizeVSBuffer(q.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(q.value);for(let U=0;U<q.buffers.length;++U)L+=this.sizeVSBuffer(q.buffers[U]);break;case 4:break}}return L}writeMixedArray(f){this._buff.writeUInt8(f.length,this._offset),this._offset+=1;for(let L=0,W=f.length;L<W;L++){const J=f[L];switch(J.type){case 1:this.writeUInt8(1),this.writeLongString(J.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(J.value);break;case 3:this.writeUInt8(3),this.writeUInt32(J.buffers.length),this.writeLongString(J.value);for(let q=0;q<J.buffers.length;++q)this.writeBuffer(J.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const f=this._buff.readUInt8(this._offset);this._offset+=1;const L=new Array(f);for(let W=0;W<f;W++)switch(this.readUInt8()){case 1:L[W]=this.readLongString();break;case 2:L[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),U=this.readLongString(),B=[];for(let G=0;G<q;++G)B.push(this.readVSBuffer());L[W]=new R.SerializableObjectWithBuffers(o(U,B,null));break}case 4:L[W]=void 0;break}return L}}w.sizeUInt32=4;var I;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(I||(I={}));class c{static _useMixedArgSerialization(f){for(let L=0,W=f.length;L<W;L++)if(f[L]instanceof T.VSBuffer||f[L]instanceof R.SerializableObjectWithBuffers||typeof f[L]>"u")return!0;return!1}static serializeRequestArguments(f,L){if(this._useMixedArgSerialization(f)){const W=[];for(let J=0,q=f.length;J<q;J++){const U=f[J];if(U instanceof T.VSBuffer)W[J]={type:2,value:U};else if(typeof U>"u")W[J]={type:4};else if(U instanceof R.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:G}=t(U.value,L);W[J]={type:3,value:T.VSBuffer.fromString(B),buffers:G}}else W[J]={type:1,value:T.VSBuffer.fromString(d(U,L))}}return{type:1,args:W}}return{type:0,args:d(f,L)}}static serializeRequest(f,L,W,J,q){switch(J.type){case 0:return this._requestJSONArgs(f,L,W,J.args,q);case 1:return this._requestMixedArgs(f,L,W,J.args,q)}}static _requestJSONArgs(f,L,W,J,q){const U=T.VSBuffer.fromString(W),B=T.VSBuffer.fromString(J);let G=0;G+=w.sizeUInt8(),G+=w.sizeShortString(U),G+=w.sizeLongString(B);const N=w.alloc(q?2:1,f,G);return N.writeUInt8(L),N.writeShortString(U),N.writeLongString(B),N.buffer}static deserializeRequestJSONArgs(f){const L=f.readUInt8(),W=f.readShortString(),J=f.readLongString();return{rpcId:L,method:W,args:JSON.parse(J)}}static _requestMixedArgs(f,L,W,J,q){const U=T.VSBuffer.fromString(W);let B=0;B+=w.sizeUInt8(),B+=w.sizeShortString(U),B+=w.sizeMixedArray(J);const G=w.alloc(q?4:3,f,B);return G.writeUInt8(L),G.writeShortString(U),G.writeMixedArray(J),G.buffer}static deserializeRequestMixedArgs(f){const L=f.readUInt8(),W=f.readShortString(),J=f.readMixedArray(),q=new Array(J.length);for(let U=0,B=J.length;U<B;U++){const G=J[U];typeof G=="string"?q[U]=JSON.parse(G):q[U]=G}return{rpcId:L,method:W,args:q}}static serializeAcknowledged(f){return w.alloc(5,f,0).buffer}static serializeCancel(f){return w.alloc(6,f,0).buffer}static serializeReplyOK(f,L,W){if(typeof L>"u")return this._serializeReplyOKEmpty(f);if(L instanceof T.VSBuffer)return this._serializeReplyOKVSBuffer(f,L);if(L instanceof R.SerializableObjectWithBuffers){const{jsonString:J,referencedBuffers:q}=t(L.value,W,!0);return this._serializeReplyOKJSONWithBuffers(f,J,q)}else return this._serializeReplyOKJSON(f,g(L,W))}static _serializeReplyOKEmpty(f){return w.alloc(7,f,0).buffer}static _serializeReplyOKVSBuffer(f,L){let W=0;W+=w.sizeVSBuffer(L);const J=w.alloc(8,f,W);return J.writeVSBuffer(L),J.buffer}static deserializeReplyOKVSBuffer(f){return f.readVSBuffer()}static _serializeReplyOKJSON(f,L){const W=T.VSBuffer.fromString(L);let J=0;J+=w.sizeLongString(W);const q=w.alloc(9,f,J);return q.writeLongString(W),q.buffer}static _serializeReplyOKJSONWithBuffers(f,L,W){const J=T.VSBuffer.fromString(L);let q=0;q+=w.sizeUInt32,q+=w.sizeLongString(J);for(const B of W)q+=w.sizeVSBuffer(B);const U=w.alloc(10,f,q);U.writeUInt32(W.length),U.writeLongString(J);for(const B of W)U.writeBuffer(B);return U.buffer}static deserializeReplyOKJSON(f){const L=f.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(f,L){const W=f.readUInt32(),J=f.readLongString(),q=[];for(let U=0;U<W;++U)q.push(f.readVSBuffer());return new R.SerializableObjectWithBuffers(o(J,q,L))}static serializeReplyErr(f,L){const W=L?g(F.transformErrorForSerialization(L),null):void 0;if(typeof W!="string")return this._serializeReplyErrEmpty(f);const J=T.VSBuffer.fromString(W);let q=0;q+=w.sizeLongString(J);const U=w.alloc(11,f,q);return U.writeLongString(J),U.buffer}static deserializeReplyErrError(f){const L=f.readLongString();return JSON.parse(L)}static _serializeReplyErrEmpty(f){return w.alloc(12,f,0).buffer}}var l;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var m;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(m||(m={}))}),define(Te[254],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(F){const A=P=>{globalThis.removeEventListener("message",A);const S=P.data;Object.defineProperties(globalThis,{postMessage:{value(h,R){S.postMessage(h,R)}},onmessage:{get(){return S.onmessage},set(h){S.onmessage=h}}}),S.addEventListener("message",h=>{globalThis.dispatchEvent(new MessageEvent("message",{data:h.data,ports:h.ports?[...h.ports]:void 0}))}),S.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",A)}.toString();class T extends EventTarget{constructor(F,A,P){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${n})('${A}'))`,h=new Blob([S],{type:"application/javascript"}),R=URL.createObjectURL(h),b=new MessageChannel,g=R,_={type:"_newWorker",id:g,port:b.port2,url:R,options:P};F(_,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{F({type:"_terminateWorker",id:g}),URL.revokeObjectURL(R),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(p){b.port1.onmessage=p}},onmessageerror:{get(){return b.port1.onmessageerror},set(p){b.port1.onmessageerror=p}}}),b.port1.addEventListener("messageerror",p=>{const u=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(u)}),b.port1.addEventListener("message",p=>{const u=new MessageEvent("message",{data:p.data});this.dispatchEvent(u)}),b.port1.start()}}e.NestedWorker=T}),define(Te[255],Pe([1,0,5,30,31,3]),function(te,e,n,T,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,F.createDecorator)("outputService");var A;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class P{constructor(){this.channels=new Map,this._onDidRegisterChannel=new n.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new n.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(h){this.channels.has(h.id)||(this.channels.set(h.id,h),this._onDidRegisterChannel.fire(h.id))}getChannels(){const h=[];return this.channels.forEach(R=>h.push(R)),h}getChannel(h){return this.channels.get(h)}removeChannel(h){this.channels.delete(h),this._onDidRemoveChannel.fire(h)}}T.Registry.add(e.Extensions.OutputChannels,new P),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(Te[108],Pe([1,0,4,3,18,24,14,255,61,27,37,125,25,12,43,5,6]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class o extends A.AbstractMessageLogger{get disposed(){return this._disposed}constructor(v,i,a,r,s){super(),this.id=v,this.name=i,this.logger=a,this.proxy=r,this.extension=s,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(a.getLevel()),this._register(a.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,v)}replace(v){const i=this.offset;this.info(v),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,i),this.visible&&this.logger.flush()}show(v,i){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:i))}hide(){this.proxy.$close(this.id)}log(v,i){this.offset+=g.VSBuffer.fromString(i).byteLength,(0,A.log)(this.logger,v,i),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class d extends o{appendLine(v){this.append(v)}}let y=e.ExtHostOutputService=class{constructor(v,i,a,r,s,w){this.initData=i,this.extHostFileSystem=a,this.extHostFileSystemInfo=r,this.loggerService=s,this.logService=w,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(n.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(i.logsLocation,`output_logging_${(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[i,a]of this.channels)a.visible=i===this.visibleChannelId}createOutputChannel(v,i,a){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const r=typeof i=="object"&&i.log,s=(0,_.isString)(i)?i:void 0;if((0,_.isString)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const I=this.initData.environment.extensionLogLevel?.find(([l])=>F.ExtensionIdentifier.equals(a.identifier,l))?.[1];I&&(w=(0,A.parseLogLevel)(I));const c=r?this.doCreateLogOutputChannel(v,w,a):this.doCreateOutputChannel(v,s,a);return c.then(l=>{this.channels.set(l.id,l),l.visible=l.id===this.visibleChannelId}),r?this.createExtHostLogOutputChannel(v,w??this.logService.getLevel(),c):this.createExtHostOutputChannel(v,c)}async doCreateOutputChannel(v,i,a){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const r=await this.outputDirectoryPromise,s=this.extHostFileSystemInfo.extUri.joinPath(r,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.loggerService.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.proxy.$register(v,s,i,a.identifier.value);return new o(I,v,w,this.proxy,a)}async doCreateLogOutputChannel(v,i,a){const r=await this.createExtensionLogDirectory(a),s=v.replace(/[\\/:\*\?"<>\|]/g,""),w=this.extHostFileSystemInfo.extUri.joinPath(r,`${s}.log`),I=`${a.identifier.value}.${s}`,c=this.loggerService.createLogger(w,{id:I,name:v,logLevel:i,extensionId:a.identifier.value});return new d(I,v,c,this.proxy,a)}createExtensionLogDirectory(v){let i=this.extensionLogDirectoryPromise.get(v.identifier.value);if(!i){const a=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,v.identifier.value);this.extensionLogDirectoryPromise.set(v.identifier.value,i=(async()=>{try{await this.extHostFileSystem.value.createDirectory(a)}catch(r){if((0,p.toFileSystemProviderErrorCode)(r)!==p.FileSystemProviderErrorCode.FileExists)throw r}return a})())}return i}createExtHostOutputChannel(v,i){let a=!1;const r=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return v},append(s){r(),i.then(w=>w.append(s))},appendLine(s){r(),i.then(w=>w.appendLine(s))},clear(){r(),i.then(s=>s.clear())},replace(s){r(),i.then(w=>w.replace(s))},show(s,w){r(),i.then(I=>I.show(s,w))},hide(){r(),i.then(s=>s.hide())},dispose(){a=!0,i.then(s=>s.dispose())}}}createExtHostLogOutputChannel(v,i,a){const r=new t.DisposableStore,s=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},w=r.add(new u.Emitter);function I(c){i=c,w.fire(c)}return a.then(c=>{r.add(c),c.logLevel!==i&&I(c.logLevel),r.add(c.onDidChangeLogLevel(l=>I(l)))}),{...this.createExtHostOutputChannel(v,a),get logLevel(){return i},onDidChangeLogLevel:w.event,trace(c,...l){s(),a.then(m=>m.trace(c,...l))},debug(c,...l){s(),a.then(m=>m.debug(c,...l))},info(c,...l){s(),a.then(m=>m.info(c,...l))},warn(c,...l){s(),a.then(m=>m.warn(c,...l))},error(c,...l){s(),a.then(m=>m.error(c,...l))},dispose(){r.dispose()}}}};e.ExtHostOutputService=y=je([Ve(0,D.IExtHostRpcService),Ve(1,h.IExtHostInitDataService),Ve(2,S.IExtHostConsumerFileSystem),Ve(3,R.IExtHostFileSystemInfo),Ve(4,A.ILoggerService),Ve(5,A.ILogService)],y),e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(Te[256],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Te[257],Pe([1,0,41,15,19,20,22,2,3,184,53,199,256]),function(te,e,n,T,D,F,A,P,S,h,R,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let _=e.AbstractPathService=class In{constructor(u,t,o,d){this.localUserHome=u,this.remoteAgentService=t,this.environmentService=o,this.contextService=d,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||F.OS)(),this.resolveUserHome=(async()=>{const y=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=y?.userHome??u})()}hasValidBasename(u,t,o){return typeof t=="string"||typeof t>"u"?this.resolveOS.then(d=>this.doHasValidBasename(u,d,t)):this.doHasValidBasename(u,t,o)}doHasValidBasename(u,t,o){return u.scheme===T.Schemas.file||u.scheme===T.Schemas.vscodeRemote?(0,n.isValidBasename)(o??(0,A.basename)(u),t===1):!0}get defaultUriScheme(){return In.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,t){if(u.remoteAuthority)return T.Schemas.vscodeRemote;const o=(0,h.getVirtualWorkspaceScheme)(t.getWorkspace());if(o)return o;const d=t.getWorkspace().folders[0];if(d)return d.uri.scheme;const y=t.getWorkspace().configuration;return y?y.scheme:T.Schemas.file}userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===1?D.win32:D.posix)}async fileURI(u){let t="";if(await this.resolveOS===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const d=u.indexOf("/",2);d===-1?(t=u.substring(2),u="/"):(t=u.substring(2,d),u=u.substring(d)||"/")}return P.URI.from({scheme:T.Schemas.file,authority:t,path:u,query:"",fragment:""})}};e.AbstractPathService=_=je([Ve(1,g.IRemoteAgentService),Ve(2,b.IWorkbenchEnvironmentService),Ve(3,R.IWorkspaceContextService)],_)}),define(Te[109],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(A,P){this.line=A,this.character=P}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,P){return new n(0,0)}with(A){return new n(0,0)}}e.Position=n;class T{constructor(A,P,S,h){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(A,P),this.end=new n(S,h)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.Range=T;var D;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(D||(e.TextSearchCompleteMessageType=D={}))}),define(Te[47],Pe([1,0,16,36,23,41,13,3,19,9,109,17]),function(te,e,n,T,D,F,A,P,S,h,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const g="\u27EA ",_=" characters skipped \u27EB",p=(g.length+_.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var u;(function(he){he[he.file=0]="file",he[he.text=1]="text"})(u||(e.SearchProviderType=u={}));var t;(function(he){he[he.File=1]="File",he[he.Text=2]="Text"})(t||(e.QueryType=t={}));function o(he){return!!he.preview}e.resultIsMatch=o;function d(he){return!!he.resource}e.isFileMatch=d;function y(he){return!!he.message}e.isProgressMessage=y;var k;(function(he){he[he.Normal=0]="Normal",he[he.NewSearchStarted=1]="NewSearchStarted"})(k||(e.SearchCompletionExitCode=k={}));class v{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=v;class i{constructor(de,Ae,ue,le){this.ranges=Ae,this.webviewIndex=le;const $=Array.isArray(Ae)?Ae:[Ae];if(ue&&ue.matchLines===1&&a($)){de=(0,A.getNLines)(de,ue.matchLines);let O="",X=0,me=0;const Ce=Math.floor(ue.charsPerLine/5),ye=[];for(const Ee of $){const Ie=Math.max(Ee.startColumn-Ce,0),oe=Ee.startColumn+ue.charsPerLine;if(Ie>me+Ce+p){const ce=g+(Ie-me)+_;O+=ce+de.slice(Ie,oe),X+=Ie-(me+ce.length)}else O+=de.slice(me,oe);ye.push(new s(0,Ee.startColumn-X,Ee.endColumn-X)),me=oe}this.preview={text:O,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const O=Array.isArray(Ae)?Ae[0].startLineNumber:Ae.startLineNumber;this.preview={text:de,matches:(0,n.mapArrayOrNot)(Ae,X=>new r(X.startLineNumber-O,X.startColumn,X.endLineNumber-O,X.endColumn))}}}}e.TextSearchMatch=i;function a(he){const de=he[0].startLineNumber;for(const Ae of he)if(Ae.startLineNumber!==de||Ae.endLineNumber!==de)return!1;return!0}class r{constructor(de,Ae,ue,le){this.startLineNumber=de,this.startColumn=Ae,this.endLineNumber=ue,this.endColumn=le}}e.SearchRange=r;class s extends r{constructor(de,Ae,ue){super(de,Ae,de,ue)}}e.OneLineRange=s;var w;(function(he){he.List="list",he.Tree="tree"})(w||(e.ViewMode=w={}));var I;(function(he){he.Default="default",he.FileNames="fileNames",he.Type="type",he.Modified="modified",he.CountDescending="countDescending",he.CountAscending="countAscending"})(I||(e.SearchSortOrder=I={}));function c(he,de=!0){const Ae=he&&he.files&&he.files.exclude,ue=de&&he&&he.search&&he.search.exclude;if(!Ae&&!ue)return;if(!Ae||!ue)return Ae||ue;let le=Object.create(null);return le=D.mixin(le,D.deepClone(Ae)),le=D.mixin(le,D.deepClone(ue),!0),le}e.getExcludes=c;function l(he,de){return he.excludePattern&&T.match(he.excludePattern,de)?!1:he.includePattern||he.usingSearchPaths?he.includePattern&&T.match(he.includePattern,de)?!0:he.usingSearchPaths?!!he.folderQueries&&he.folderQueries.some(Ae=>{const ue=Ae.folder.fsPath;if(F.isEqualOrParent(de,ue)){const le=S.relative(ue,de);return!Ae.includePattern||!!T.match(Ae.includePattern,le)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var m;(function(he){he[he.unknownEncoding=1]="unknownEncoding",he[he.regexParseError=2]="regexParseError",he[he.globParseError=3]="globParseError",he[he.invalidLiteral=4]="invalidLiteral",he[he.rgProcessError=5]="rgProcessError",he[he.other=6]="other",he[he.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class E extends Error{constructor(de,Ae){super(de),this.code=Ae}}e.SearchError=E;function f(he){const de=he.message;if((0,h.isCancellationError)(he))return new E(de,m.canceled);try{const Ae=JSON.parse(de);return new E(Ae.message,Ae.code)}catch{return new E(de,m.other)}}e.deserializeSearchError=f;function L(he){const de={message:he.message,code:he.code};return new Error(JSON.stringify(de))}e.serializeSearchError=L;function W(he){return he.type==="error"?!0:he.type==="success"}e.isSerializedSearchComplete=W;function J(he){return he.type==="success"}e.isSerializedSearchSuccess=J;function q(he){return!!he.path}e.isSerializedFileMatch=q;function U(he,de){const Ae=he.searchPath?he.searchPath:he.relativePath;return(0,A.fuzzyContains)(Ae,de)}e.isFilePatternMatch=U;class B{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function G(he,de){const Ae={...he||{},...de||{}};return Object.keys(Ae).filter(ue=>{const le=Ae[ue];return typeof le=="boolean"&&le})}e.resolvePatternsForProvider=G;class N{constructor(de,Ae){this._parsedIncludeExpression=null,this._excludeExpression={...de.excludePattern||{},...Ae.excludePattern||{}},this._parsedExcludeExpression=T.parse(this._excludeExpression);let ue=de.includePattern;Ae.includePattern&&(ue?ue={...ue,...Ae.includePattern}:ue=Ae.includePattern),ue&&(this._parsedIncludeExpression=T.parse(ue))}matchesExcludesSync(de,Ae,ue){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,Ae,ue))}includedInQuerySync(de,Ae,ue){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,Ae,ue)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(de,Ae,ue))}includedInQuery(de,Ae,ue){const le=this._parsedExcludeExpression(de,Ae,ue),$=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(de,Ae,ue):!0;return(0,b.isThenable)(le)?le.then(O=>O?!1:$()):$()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=N;function H(he){for(const de in he)if(typeof he[de]!="boolean")return!0;return!1}function Q(he){if(!he)return;let de;return Ae=>(de||(de=(he()||Promise.resolve([])).then(ue=>ue?we(ue):{})),de.then(ue=>!!ue[Ae]))}e.hasSiblingPromiseFn=Q;function pe(he){if(!he)return;let de;return Ae=>{if(!de){const ue=he();de=ue?we(ue):{}}return!!de[Ae]}}e.hasSiblingFn=pe;function we(he){const de={};for(const Ae of he)de[Ae]=!0;return de}}),define(Te[32],Pe([1,0,16,17,21,5,6,48,15,116,22,13,12,2,155,3,14,172,53,37,27,18,8,7,55,47,4]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o,d,y,k,v,i,a,r,s,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function I(J,q,U){return new R.ExtUri(B=>E(B,U)).isEqual(J,q)}function c(J,q,U){return I(J.uri,q.uri,U)?0:(0,b.compare)(J.uri.toString(),q.uri.toString())}function l(J,q,U){return J.index!==q.index?J.index<q.index?-1:1:I(J.uri,q.uri,U)?(0,b.compare)(J.name,q.name):(0,b.compare)(J.uri.toString(),q.uri.toString())}function m(J,q,U,B){const G=J.slice(0).sort((H,Q)=>U(H,Q,B)),N=q.slice(0).sort((H,Q)=>U(H,Q,B));return(0,n.delta)(G,N,(H,Q)=>U(H,Q,B))}function E(J,q){const U=q.getCapabilities(J.scheme);return!(U&&U&1024)}class f extends d.Workspace{static toExtHostWorkspace(q,U,B,G){if(!q)return{workspace:null,added:[],removed:[]};const{id:N,name:H,folders:Q,configuration:pe,transient:we,isUntitled:he}=q,de=[],Ae=U;U?Q.forEach((O,X)=>{const me=_.URI.revive(O.uri),Ce=f._findFolder(B||U,me,G);Ce?(Ce.name=O.name,Ce.index=O.index,de.push(Ce)):de.push({uri:me,name:O.name,index:X})}):de.push(...Q.map(({uri:O,name:X,index:me})=>({uri:_.URI.revive(O),name:X,index:me}))),de.sort((O,X)=>O.index<X.index?-1:1);const ue=new f(N,H,de,!!we,pe?_.URI.revive(pe):null,!!he,O=>E(O,G)),{added:le,removed:$}=m(Ae?Ae.workspaceFolders:[],ue.workspaceFolders,c,G);return{workspace:ue,added:le,removed:$}}static _findFolder(q,U,B){for(let G=0;G<q.folders.length;G++){const N=q.workspaceFolders[G];if(I(N.uri,U,B))return N}}constructor(q,U,B,G,N,H,Q){super(q,B.map(pe=>new d.WorkspaceFolder(pe)),G,N,Q),this._name=U,this._isUntitled=H,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(Q),B.forEach(pe=>{this._workspaceFolders.push(pe),this._structure.set(pe.uri,pe)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(q,U){return U&&this._structure.get(q)&&(q=(0,R.dirname)(q)),this._structure.findSubstr(q)}resolveWorkspaceFolder(q){return this._structure.get(q)}}let L=e.ExtHostWorkspace=class{constructor(q,U,B,G,N){this._onDidChangeWorkspace=new F.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new F.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new F.AsyncEmitter,this._logService=G,this._extHostFileSystemInfo=B,this._uriTransformerService=N,this._requestIdProvider=new h.Counter,this._barrier=new T.Barrier,this._proxy=q.getProxy(w.MainContext.MainThreadWorkspace),this._messageService=q.getProxy(w.MainContext.MainThreadMessageService);const H=U.workspace;this._confirmedWorkspace=H?new f(H.id,H.name,[],!!H.transient,H.configuration?_.URI.revive(H.configuration):null,!!H.isUntitled,Q=>E(Q,B)):void 0}$initializeWorkspace(q,U){this._trusted=U,this.$acceptWorkspaceData(q),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?_.URI.from({scheme:S.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(q,U,B,...G){const N=[];if(Array.isArray(G)&&G.forEach(he=>{_.URI.isUri(he.uri)&&!N.some(de=>I(de.uri,he.uri,this._extHostFileSystemInfo))&&N.push({uri:he.uri,name:he.name||(0,R.basenameOrAuthority)(he.uri)})}),this._unconfirmedWorkspace||[U,B].some(he=>typeof he!="number"||he<0)||B===0&&N.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+B>H.length)return!1;const Q=H.slice(0);Q.splice(U,B,...N.map(he=>({uri:he.uri,name:he.name||(0,R.basenameOrAuthority)(he.uri),index:void 0})));for(let he=0;he<Q.length;he++){const de=Q[he];if(Q.some((Ae,ue)=>ue!==he&&I(de.uri,Ae.uri,this._extHostFileSystemInfo)))return!1}Q.forEach((he,de)=>he.index=de);const{added:pe,removed:we}=m(H,Q,l,this._extHostFileSystemInfo);if(pe.length===0&&we.length===0)return!1;if(this._proxy){const he=q.displayName||q.name;this._proxy.$updateWorkspaceFolders(he,U,B,N).then(void 0,de=>{this._unconfirmedWorkspace=void 0;const Ae={source:{identifier:q.identifier,label:q.displayName||q.name}};this._messageService.$showMessage(o.Severity.Error,(0,p.localize)(0,null,he,de.toString()),Ae,[])})}return this.trySetWorkspaceFolders(Q),!0}getWorkspaceFolder(q,U){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(q,U)}async getWorkspaceFolder2(q,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(q,U)}async resolveWorkspaceFolder(q){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(q)}getPath(){if(!this._actualWorkspace)return;const{folders:q}=this._actualWorkspace;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,U){let B,G="";if(typeof q=="string"?(B=_.URI.file(q),G=q):typeof q<"u"&&(B=q,G=q.fsPath),!B)return G;const N=this.getWorkspaceFolder(B,!0);if(!N)return G;typeof U>"u"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let H=(0,R.relativePath)(N.uri,B);return U&&N.name&&(H=`${N.name}/${H}`),H}trySetWorkspaceFolders(q){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:q,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:U,added:B,removed:G}=f.toExtHostWorkspace(q,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:G}))}findFiles(q,U,B,G,N=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let H;if(U===null?H=!1:U&&(typeof U=="string"?H=U:H=U.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:Q,folder:pe}=W(i.GlobPattern.from(q));return this._proxy.$startFileSearch((0,g.withUndefinedAsNull)(Q),(0,g.withUndefinedAsNull)(pe),(0,g.withUndefinedAsNull)(H),(0,g.withUndefinedAsNull)(B),N).then(we=>Array.isArray(we)?we.map(he=>_.URI.revive(he)):[])}async findTextInFiles(q,U,B,G,N=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),Q=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:pe,folder:we}=W(i.GlobPattern.from(U.include)),he=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,de={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Q,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:pe,excludePattern:he},Ae=!1;if(this._activeSearchCallbacks[H]=ue=>{if(Ae)return;const le=_.URI.revive(ue.resource);ue.results.forEach($=>{(0,s.resultIsMatch)($)?B({uri:le,preview:{text:$.preview.text,matches:(0,n.mapArrayOrNot)($.preview.matches,O=>new a.Range(O.startLineNumber,O.startColumn,O.endLineNumber,O.endColumn))},ranges:(0,n.mapArrayOrNot)($.ranges,O=>new a.Range(O.startLineNumber,O.startColumn,O.endLineNumber,O.endColumn))}):B({uri:le,text:$.text,lineNumber:$.lineNumber})})},N.isCancellationRequested)return{};try{const ue=await this._proxy.$startTextSearch(q,(0,g.withUndefinedAsNull)(we),de,H,N);return delete this._activeSearchCallbacks[H],ue||{}}catch(ue){throw delete this._activeSearchCallbacks[H],ue}}$handleTextSearchResult(q,U){this._activeSearchCallbacks[U]?.(q)}async save(q){const U=await this._proxy.$save(q,{saveAs:!1});return _.URI.revive(U)}async saveAs(q){const U=await this._proxy.$save(q,{saveAs:!0});return _.URI.revive(U)}saveAll(q){return this._proxy.$saveAll(q)}resolveProxy(q){return this._proxy.$resolveProxy(q)}get trusted(){return this._trusted}requestWorkspaceTrust(q){return this._proxy.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(q,U){if(this._editSessionIdentityProviders.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this._editSessionIdentityProviders.set(q,U);const B=this._uriTransformerService.transformOutgoingScheme(q),G=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(G,B),(0,A.toDisposable)(()=>{this._editSessionIdentityProviders.delete(q),this._proxy.$unregisterEditSessionIdentityProvider(G)})}async $getEditSessionIdentifier(q,U){this._logService.info("Getting edit session identifier for workspaceFolder",q);const B=await this.resolveWorkspaceFolder(_.URI.revive(q));if(!B){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const G=this._editSessionIdentityProviders.get(B.uri.scheme);if(this._logService.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!G),!G)return;const N=await G.provideEditSessionIdentity(B,U);if(this._logService.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(q,U,B,G){this._logService.info("Getting edit session identifier for workspaceFolder",q);const N=await this.resolveWorkspaceFolder(_.URI.revive(q));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const H=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!H),!H)return;const Q=await H.provideEditSessionIdentityMatch?.(U,B,G);if(this._logService.info("Provider returned edit session identifier match result: ",Q),!!Q)return Q}getOnWillCreateEditSessionIdentityEvent(q){return(U,B,G)=>{const N=function(Q){U.call(B,Q)};return N.extension=q,this._onWillCreateEditSessionIdentityEvent.event(N,void 0,G)}}async $onWillCreateEditSessionIdentity(q,U,B){const G=await this.resolveWorkspaceFolder(_.URI.revive(q));if(G===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:G},U,async(N,H)=>{const Q=Date.now();await Promise.resolve(N),Date.now()-Q>B&&this._logService.warn("SLOW edit session create-participant",H.extension.identifier)}),U.isCancellationRequested}};e.ExtHostWorkspace=L=je([Ve(0,v.IExtHostRpcService),Ve(1,k.IExtHostInitDataService),Ve(2,y.IExtHostFileSystemInfo),Ve(3,t.ILogService),Ve(4,r.IURITransformerService)],L),e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function W(J){let q,U;return J&&(typeof J=="string"?q=J:(q=J.pattern,U=_.URI.revive(J.baseUri))),{includePattern:q,folder:U}}}),define(Te[33],Pe([1,0,23,5,32,4,7,175,95,12,17,3,18,14,2]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(a,r){if(r){const s=r.split(".");let w=a;for(let I=0;w&&I<s.length;I++)w=w[s[I]];return w}}function t(a){return a instanceof p.URI}function o(a){return a&&a.uri instanceof p.URI&&a.languageId&&typeof a.languageId=="string"}function d(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function y(a){return a&&a.uri instanceof p.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function k(a){if(t(a))return{resource:a};if(o(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(d(a))return{overrideIdentifier:a.languageId};if(y(a))return{resource:a.uri};if(a===null)return{resource:null}}let v=e.ExtHostConfiguration=class{constructor(r,s,w){this._proxy=r.getProxy(F.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=w,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(r,s))}};e.ExtHostConfiguration=v=je([Ve(0,g.IExtHostRpcService),Ve(1,D.IExtHostWorkspace),Ve(2,_.ILogService)],v);class i{constructor(r,s,w,I){this._onDidChangeConfiguration=new T.Emitter,this._proxy=r,this._logService=I,this._extHostWorkspace=s,this._configuration=P.Configuration.parse(w),this._configurationScopes=this._toMap(w.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const w={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,w))}getConfiguration(r,s,w){const I=k(s)||{},c=this._toReadonlyValue(r?u(this._configuration.getValue(void 0,I,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,I,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,I,w?.identifier);function l(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(E){return typeof u(c,E)<"u"},get:(E,f)=>{this._validateConfigurationAccess(r?`${r}.${E}`:E,I,w?.identifier);let L=u(c,E);if(typeof L>"u")L=f;else{let W;const J=(q,U)=>{if((0,h.isObject)(q)){let B;const G=()=>{W=W||(0,n.deepClone)(c),B=B||u(W,U)};return new Proxy(q,{get:(N,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return G(),()=>B;if(W)return B=B||u(W,U),B[H];const Q=N[H];return typeof H=="string"?J(Q,`${U}.${H}`):Q},set:(N,H,Q)=>(G(),B&&(B[H]=Q),!0),deleteProperty:(N,H)=>(G(),B&&delete B[H],!0),defineProperty:(N,H,Q)=>(G(),B&&Object.defineProperty(B,H,Q),!0)})}return Array.isArray(q)?(0,n.deepClone)(q):q};L=J(L,E)}return L},update:(E,f,L,W)=>{E=r?`${r}.${E}`:E;const J=l(L);return f!==void 0?this._proxy.$updateConfigurationOption(J,E,f,I,W):this._proxy.$removeConfigurationOption(J,E,I,W)},inspect:E=>{E=r?`${r}.${E}`:E;const f=this._configuration.inspect(E,I,this._extHostWorkspace.workspace);if(f)return{key:E,defaultValue:(0,n.deepClone)(f.policy?.value??f.default?.value),globalValue:(0,n.deepClone)(f.user?.value??f.application?.value),workspaceValue:(0,n.deepClone)(f.workspace?.value),workspaceFolderValue:(0,n.deepClone)(f.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(f.default?.override),globalLanguageValue:(0,n.deepClone)(f.user?.override??f.application?.override),workspaceLanguageValue:(0,n.deepClone)(f.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(f.workspaceFolder?.override),languageIds:(0,n.deepClone)(f.overrideIdentifiers)}}};return typeof c=="object"&&(0,n.mixin)(m,c,!1),Object.freeze(m)}_toReadonlyValue(r){const s=w=>(0,h.isObject)(w)?new Proxy(w,{get:(I,c)=>s(I[c]),set:(I,c,l)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(I,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(I,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:I=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return s(r)}_validateConfigurationAccess(r,s,w){const I=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),c=w?`[${w.value}] `:"";if(I===4){typeof s?.resource>"u"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(I===3){s?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const w=new P.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(I,c)=>w.affectsConfiguration(I,k(c))})}_toMap(r){return r.reduce((s,w)=>(s.set(w[0],w[1]),s),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Te[110],Pe([1,0,2,17,5,4,7,32,59,33,21,62,18,27,3,15,20,14,78,212,9]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o,d,y,k){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(q){function U(G){if(G!=null)return G}q.from=U;function B(G){if(G!=null)return G}q.to=B})(i||(i={}));var a;(function(q){function U(G){if(G!=null)return G}q.from=U;function B(G){if(G!=null)return G}q.to=B})(a||(a={}));var r;(function(q){function U(G){if(G!=null)return G}q.from=U;function B(G){if(G!=null)return G}q.to=B})(r||(r={}));var s;(function(q){function U(N){if(N){const H=N;return H&&!!H.process}else return!1}q.is=U;function B(N){if(N==null)return;const H={process:N.process,args:N.args};return N.options&&(H.options=r.from(N.options)),H}q.from=B;function G(N){if(N!=null)return new A.ProcessExecution(N.process,N.args,N.options)}q.to=G})(s||(s={}));var w;(function(q){function U(G){if(G!=null)return G}q.from=U;function B(G){if(G!=null)return G}q.to=B})(w||(w={}));var I;(function(q){function U(N){if(N){const H=N;return H&&(!!H.commandLine||!!H.command)}else return!1}q.is=U;function B(N){if(N==null)return;const H={};return N.commandLine!==void 0?H.commandLine=N.commandLine:(H.command=N.command,H.args=N.args),N.options&&(H.options=w.from(N.options)),H}q.from=B;function G(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.ShellExecution(N.commandLine,N.options):new A.ShellExecution(N.command,N.args?N.args:[],N.options)}q.to=G})(I||(I={}));var c;(function(q){function U(N){if(N){const H=N;return H&&H.customExecution==="customExecution"}else return!1}q.is=U;function B(N){return{customExecution:"customExecution"}}q.from=B;function G(N,H){return H.get(N)}q.to=G})(c||(e.CustomExecutionDTO=c={}));var l;(function(q){function U(B,G){let N;return B.scope!==void 0&&typeof B.scope!="number"?N=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===A.TaskScope.Workspace&&G&&G.workspaceFile?N=G.workspaceFile:N=y.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:N}}q.from=U})(l||(e.TaskHandleDTO=l={}));var m;(function(q){function U(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}q.from=U})(m||(m={}));var E;(function(q){function U(N,H){if(N==null)return[];const Q=[];for(const pe of N){const we=B(pe,H);we&&Q.push(we)}return Q}q.fromMany=U;function B(N,H){if(N==null)return;let Q;N.execution instanceof A.ProcessExecution?Q=s.from(N.execution):N.execution instanceof A.ShellExecution?Q=I.from(N.execution):N.execution&&N.execution instanceof A.CustomExecution&&(Q=c.from(N.execution));const pe=i.from(N.definition);let we;return N.scope?typeof N.scope=="number"?we=N.scope:we=N.scope.uri:we=A.TaskScope.Workspace,!pe||!we?void 0:{_id:N._id,definition:pe,name:N.name,source:{extensionId:H.identifier.value,label:N.source,scope:we},execution:Q,isBackground:N.isBackground,group:m.from(N.group),presentationOptions:a.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}q.from=B;async function G(N,H,Q){if(N==null)return;let pe;s.is(N.execution)?pe=s.to(N.execution):I.is(N.execution)?pe=I.to(N.execution):c.is(N.execution)&&(pe=c.to(N._id,Q));const we=i.to(N.definition);let he;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?he=N.source.scope:he=await H.resolveWorkspaceFolder(n.URI.revive(N.source.scope)):he=A.TaskScope.Workspace),!we||!he)return;const de=new A.Task(we,he,N.name,N.source.label,pe,N.problemMatchers);return N.isBackground!==void 0&&(de.isBackground=N.isBackground),N.group!==void 0&&(de.group=A.TaskGroup.from(N.group._id),de.group&&N.group.isDefault&&(de.group=new A.TaskGroup(de.group.id,de.group.label),N.group.isDefault===!0&&(de.group.isDefault=N.group.isDefault))),N.presentationOptions&&(de.presentationOptions=a.to(N.presentationOptions)),N._id&&(de._id=N._id),N.detail&&(de.detail=N.detail),de}q.to=G})(E||(e.TaskDTO=E={}));var f;(function(q){function U(G){return G}q.from=U;function B(G){if(G)return Object.assign(Object.create(null),G)}q.to=B})(f||(f={}));class L{constructor(U,B,G){this._id=B,this._task=G,v.set(this,void 0),Je(this,v,U,"f")}get task(){return this._task}terminate(){Le(this,v,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}v=new WeakMap;let W=e.ExtHostTaskBase=class{constructor(U,B,G,N,H,Q,pe,we){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=U.getProxy(F.MainContext.MainThreadTask),this._workspaceProvider=G,this._editorService=N,this._configurationService=H,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=pe,this._deprecationService=we,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,B,G){if(!G)return new A.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:B,provider:G,extension:U}),this._proxy.$registerTaskProvider(N,B),new A.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(U,B){this._proxy.$registerTaskSystem(U,B)}fetchTasks(U){return this._proxy.$fetchTasks(f.from(U)).then(async B=>{const G=[];for(const N of B){const H=await E.to(N,this._workspaceProvider,this._providedCustomExecutions2);H&&G.push(H)}return G})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(B=>U.push(B)),U}terminateTask(U){if(!(U instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,B,G){const N=this._providedCustomExecutions2.get(U.id);N&&(this._activeCustomExecutions2.set(U.id,N),this._terminalService.attachPtyToTerminal(B,await N.callback(G))),this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const B=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const B=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:B,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const B=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:U.exitCode})}$provideTasks(U,B){const G=this._handlers.get(U);if(!G)return Promise.reject(new Error("no handler found"));const N=[],H=(0,T.asPromise)(()=>G.provider.provideTasks(R.CancellationToken.None)).then(Q=>this.provideTasksInternal(B,N,G,Q));return new Promise(Q=>{H.then(pe=>{Promise.all(N).then(()=>{Q(pe)})})})}async $resolveTask(U,B){const G=this._handlers.get(U);if(!G)return Promise.reject(new Error("no handler found"));if(B.definition.type!==G.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${G.type}].`);const N=await E.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const H=await G.provider.resolveTask(N,R.CancellationToken.None);if(!H)return;this.checkDeprecation(H,G);const Q=E.from(H,G.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(Q.execution)&&await this.addCustomExecution(Q,H,!0),await this.resolveTaskInternal(Q)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,B,G){const N=await this._proxy.$createTaskId(U);!G&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,B.execution)),this._providedCustomExecutions2.set(N,B.execution)}async getTaskExecution(U,B){if(typeof U=="string"){const H=this._taskExecutionPromises.get(U);if(!H)throw new k.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return H}const G=this._taskExecutionPromises.get(U.id);if(G)return G;const N=new Promise((H,Q)=>{function pe(we,he,de){de?H(new L(we,he.id,de)):Q("Unexpected: Task does not exist.")}B?pe(this,U,B):E.to(U.task,this._workspaceProvider,this._providedCustomExecutions2).then(we=>pe(this,U,we))});return this._taskExecutionPromises.set(U.id,N),N.then(H=>(this._taskExecutions.set(U.id,H),H),H=>Promise.reject(H))}checkDeprecation(U,B){U._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));const G=this._notProvidedCustomExecutions.values();let N=G.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=G.next()}};e.ExtHostTaskBase=W=je([Ve(0,g.IExtHostRpcService),Ve(1,_.IExtHostInitDataService),Ve(2,P.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,b.IExtHostTerminalService),Ve(6,o.ILogService),Ve(7,d.IExtHostApiDeprecationService)],W);let J=e.WorkerExtHostTask=class extends W{constructor(U,B,G,N,H,Q,pe,we){super(U,B,G,N,H,Q,pe,we),this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(U,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const G=E.from(B,U);if(G===void 0)throw new Error("Task is not valid");if(c.is(G.execution))await this.addCustomExecution(G,B,!1);else throw new k.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(G),B);return this._proxy.$executeTask(G).catch(H=>{throw new Error(H)}),N}provideTasksInternal(U,B,G,N){const H=[];if(N)for(const Q of N){this.checkDeprecation(Q,G),(!Q.definition||!U[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const pe=E.from(Q,G.extension);pe&&c.is(pe.execution)?(H.push(pe),B.push(this.addCustomExecution(pe,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:G.extension}}async resolveTaskInternal(U){if(c.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,B,G){}};e.WorkerExtHostTask=J=je([Ve(0,g.IExtHostRpcService),Ve(1,_.IExtHostInitDataService),Ve(2,P.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,b.IExtHostTerminalService),Ve(6,o.ILogService),Ve(7,d.IExtHostApiDeprecationService)],J),e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(Te[258],Pe([1,0,19,21,40,36,22,58,47]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class h{constructor(g,_,p){this.config=g,this.provider=_,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&F.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&F.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const _=this.config.folderQueries||[];return new Promise((p,u)=>{const t=o=>{this.resultCount++,g(o)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(o=>{const d=o.toString(),y=n.basename(d);this.globalExcludePattern&&this.globalExcludePattern(d,y)||this.matchFile(t,{base:o,basename:y})}),Promise.all(_.map(o=>this.searchInFolder(o,t))).then(o=>{p({limitHit:this.isLimitHit,stats:o[0]||void 0})},o=>{u(new Error((0,D.toErrorMessage)(o)))})})}async searchInFolder(g,_){const p=new T.CancellationTokenSource,u=this.getSearchOptionsForFolder(g),t=this.initDirectoryTree(),o=new S.QueryGlobTester(this.config,g),d=!o.hasSiblingExcludeClauses();let y;try{this.activeCancellationTokens.add(p),y=P.StopWatch.create();const k=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,p.token),v=y.elapsed(),i=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(k&&k.forEach(a=>{const r=n.posix.relative(g.folder.path,a.path);if(d){const s=n.basename(a.path);this.matchFile(_,{base:g.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(t,g.folder,r,_)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(t,o,_),{providerTime:v,postProcessTime:i.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(g){const _=(0,S.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),p=(0,S.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:p,includes:_,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},_,p,u){if(p===this.filePattern){const o=n.basename(this.filePattern);this.matchFile(u,{base:_,relativePath:this.filePattern,basename:o})}function t(o){const d=n.basename(o),y=n.dirname(o);let k=g[y];k||(k=g[y]=[],t(y)),k.push({base:_,relativePath:o,basename:d})}t(p)}matchDirectoryTree({rootEntries:g,pathToEntries:_},p,u){const t=this,o=this.filePattern;function d(y){const k=(0,S.hasSiblingFn)(()=>y.map(v=>v.basename));for(let v=0,i=y.length;v<i;v++){const a=y[v],{relativePath:r,basename:s}=a;if(p.matchesExcludesSync(r,s,o!==s?k:void 0))continue;const w=_[r];if(w)d(w);else{if(r===o)continue;t.matchFile(u,a)}if(t.isLimitHit)break}}d(g)}matchFile(g,_){(!this.includePattern||_.relativePath&&this.includePattern(_.relativePath,_.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(_))}}class R{constructor(){this.sessions=new Map}fileSearch(g,_,p,u){const t=this.getSessionTokenSource(g.cacheKey),o=new h(g,_,t&&t.token);let d=0;const y=k=>{d+=k.length,p(k.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(o,R.BATCH_SIZE,y,u).then(k=>({limitHit:k.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:k.stats}}))}clearCache(g){this.getSessionTokenSource(g)?.cancel()}getSessionTokenSource(g){if(g)return this.sessions.has(g)||this.sessions.set(g,new T.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:A.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,_,p,u){u.onCancellationRequested(()=>{g.cancel()});const t=d=>{d&&(o.push(d),_>0&&o.length>=_&&(p(o),o=[]))};let o=[];return g.search(t).then(d=>(o.length&&p(o),d),d=>(o.length&&p(o),Promise.reject(d)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Te[259],Pe([1,0,16,64,36,89,28,15,19,22,13,12,2,273,164,42,14,53,100,257,47]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o,d,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=e.QueryBuilder=class{constructor(E,f,L,W,J){this.configurationService=E,this.workspaceContextService=f,this.editorGroupsService=L,this.logService=W,this.pathService=J}text(E,f,L={}){E=this.getContentPattern(E,L);const W=this.configurationService.getValue(),J=f&&f.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(f?.map(o.toWorkspaceFolder),L),type:2,contentPattern:E,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:W.search.usePCRE2||J||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(E,f){const L=this.configurationService.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const W={...E,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(E,f)&&(W.isCaseSensitive=!0),this.isMultiline(E)&&(W.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),W}file(E,f={}){return{...this.commonQuery(E,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}handleIncludeExclude(E,f){return E?(E=Array.isArray(E)?E.map(w):w(E),f?this.parseSearchPaths(E):{pattern:a(...Array.isArray(E)?E:[E])}):{}}commonQuery(E=[],f={}){const L=this.handleIncludeExclude(f.includePattern,f.expandPatterns),W=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),J=E.length>1,q=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(G=>this.getFolderQueryForSearchPath(G,f,W)):E.map(G=>this.getFolderQueryForRoot(G,f,W,J))).filter(G=>!!G),U={_reason:f._reason,folderQueries:q,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:W.pattern,includePattern:L.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const G=n.coalesce(n.flatten(this.editorGroupsService.groups.map(Q=>Q.editors.map(pe=>pe.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(G));const N=G.filter(Q=>(0,k.pathIncludedInQuery)(U,Q.fsPath)),H=this.commonQueryFromFileList(N);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...U,...H}}const B=f.extraFileResources&&f.extraFileResources.filter(G=>(0,k.pathIncludedInQuery)(U,G.fsPath));return U.extraFileResources=B&&B.length?B:void 0,U}commonQueryFromFileList(E){const f=[],L=new A.ResourceMap,W={};let J=!1;return E.forEach(q=>{if(q.scheme===P.Schemas.walkThrough)return;if((0,h.isAbsolutePath)(q)){const B=this.workspaceContextService.getWorkspaceFolder(q)?.uri??q.with({path:S.dirname(q.fsPath)});let G=L.get(B);G||(J=!0,G={folder:B,includePattern:{}},f.push(G),L.set(B,G));const N=S.relative(B.fsPath,q.fsPath);(0,b.assertIsDefined)(G.includePattern)[N.replace(/\\/g,"/")]=!0}else q.fsPath&&(J=!0,W[q.fsPath]=!0)}),{folderQueries:f,includePattern:W,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}isCaseSensitive(E,f){if(f.isSmartCase){if(E.isRegExp){if(R.containsUppercaseCharacter(E.pattern,!0))return!0}else if(R.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}isMultiline(E){return E.isMultiline||E.isRegExp&&(0,_.isMultilineRegexSource)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const f=H=>S.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),W=(Array.isArray(E)?E:r(E)).map(H=>{const Q=this.pathService.resolvedUserHome;return Q?(0,F.untildify)(H,Q.scheme===P.Schemas.file?Q.fsPath:Q.path):H}),J=T.groupBy(W,H=>f(H)?"searchPaths":"exprSegments"),q=(J.exprSegments||[]).map(H=>R.rtrim(H,"/")).map(H=>R.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),s(H))),U={},B=this.expandSearchPathPatterns(J.searchPaths||[]);B&&B.length&&(U.searchPaths=B);const G=n.flatten(q),N=a(...G);return N&&(U.pattern=N),U}getExcludesForFolder(E,f){return f.disregardExcludeSettings?void 0:(0,k.getExcludes)(E,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(E){if(!E||!E.length)return[];const f=E.flatMap(W=>{let{pathPortion:J,globPortion:q}=i(W);return q&&(q=I(q)),this.expandOneSearchPath(J).flatMap(B=>this.resolveOneSearchPathPattern(B,q))}),L=new Map;return f.forEach(W=>{const J=W.searchPath.toString(),q=L.get(J);q?W.pattern&&(q.pattern=q.pattern||{},q.pattern[W.pattern]=!0):L.set(J,{searchPath:W.searchPath,pattern:W.pattern?a(W.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(E){if(S.isAbsolute(E)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==P.Schemas.file?[{searchPath:f[0].uri.with({path:E})}]:[{searchPath:g.URI.file(S.normalize(E))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(E=w(E),E.startsWith("../")||E===".."){const W=S.posix.resolve(f.path,E);return[{searchPath:f.with({path:W})}]}const L=I(E);return[{searchPath:f,pattern:L}]}else{if(E==="./"||E===".\\")return[];{const f=E.replace(/^\.[\/\\]/,""),W=this.workspaceContextService.getWorkspace().folders.map(J=>{const q=f.match(new RegExp(`^${R.escapeRegExpCharacters(J.name)}(?:/(.*)|$)`));return q?{match:q,folder:J}:null}).filter(b.isDefined);if(W.length)return W.map(J=>{const q=J.match[1];return{searchPath:J.folder.uri,pattern:q&&I(q)}});{const J=E.match(/\.[\/\\](.+)[\/\\]?/),q=J?J[1]:E,U=p.localize(0,null,q);throw new Error(U)}}}}resolveOneSearchPathPattern(E,f){const L=E.pattern&&f?`${E.pattern}/${f}`:E.pattern||f,W=[{searchPath:E.searchPath,pattern:L}];return L&&!L.endsWith("**")&&W.push({searchPath:E.searchPath,pattern:L+"/**"}),W}getFolderQueryForSearchPath(E,f,L){const W=this.getFolderQueryForRoot((0,o.toWorkspaceFolder)(E.searchPath),f,L,!1);return W?{...W,includePattern:E.pattern}:null}getFolderQueryForRoot(E,f,L,W){let J;const q=g.URI.isUri(E)?E:E.uri;if(L.searchPaths){const H=L.searchPaths.filter(Q=>(0,h.isEqual)(Q.searchPath,q))[0];if(H&&!H.pattern)return null;H&&(J=H.pattern)}const U=this.configurationService.getValue({resource:q}),G={...this.getExcludesForFolder(U,f)||{},...J||{}},N=g.URI.isUri(E)?(0,h.basename)(E):E.name;return{folder:q,folderName:W?N:void 0,excludePattern:Object.keys(G).length>0?G:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!U.search.followSymlinks}}};e.QueryBuilder=v=je([Ve(0,u.IConfigurationService),Ve(1,o.IWorkspaceContextService),Ve(2,d.IEditorGroupsService),Ve(3,t.ILogService),Ve(4,y.IPathService)],v);function i(m){const E=m.match(/[\*\{\}\(\)\[\]\?]/);if(E){const f=E.index,L=m.substr(0,f).match(/[/|\\][^/\\]*$/);if(L){let W=m.substr(0,L.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:m.substr((L.index||0)+1)}}}return{pathPortion:m}}function a(...m){return m.length?m.reduce((E,f)=>(E[f]=!0,E),Object.create(null)):void 0}function r(m){return D.splitGlobAware(m,",").map(E=>E.trim()).filter(E=>!!E.length)}function s(m){return[`**/${m}/**`,`**/${m}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function w(m){return m.replace(/\\/g,"/")}function I(m){return w(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(m){return m.replace(/([?*[\]])/g,"[$1]")}function l(m,E){m=n.distinct(m,W=>W.toString());const f=[],L=E.getWorkspace();return m&&m.forEach(W=>{let J;if(E.getWorkbenchState()===2)J=(0,h.relativePath)(L.folders[0].uri,W),J&&J!=="."&&(J="./"+J);else{const q=E.getWorkspaceFolder(W);if(q){const U=q.name;if(L.folders.filter(G=>G.name===U).length===1){const G=(0,h.relativePath)(q.uri,W);G===""?J=`./${q.name}`:J=`./${q.name}/${G}`}else J=W.fsPath}}J&&f.push(c(J))}),f}e.resolveResourcesForSearchIncludes=l}),define(Te[260],Pe([1,0,22,2,21,9,3,259,47,53]),function(te,e,n,T,D,F,A,P,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function b(u,t){const o=t.activationEvents;if(!o)return Promise.resolve(void 0);const d=[],y=[];for(const s of o)if(/^workspaceContains:/.test(s)){const w=s.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||u.forceUsingSearch?y.push(w):d.push(w)}if(d.length===0&&y.length===0)return Promise.resolve(void 0);let k;const v=new Promise((s,w)=>{k=s}),i=s=>k({activationEvent:s}),a=Promise.all(d.map(s=>g(u,s,i))).then(()=>{}),r=_(u,t.identifier,y,i);return Promise.all([a,r]).then(()=>{k(void 0)}),v}e.checkActivateWorkspaceContainsExtension=b;async function g(u,t,o){for(const d of u.folders)if(await u.exists(n.joinPath(T.URI.revive(d),t))){o(`workspaceContains:${t}`);return}}async function _(u,t,o,d){if(o.length===0)return Promise.resolve(void 0);const y=new D.CancellationTokenSource,k=u.checkExists(u.folders,o,y.token),v=setTimeout(async()=>{y.cancel(),u.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},R);let i=!1;try{i=await k}catch(a){F.isCancellationError(a)||F.onUnexpectedError(a)}y.dispose(),clearTimeout(v),i&&d(`workspaceContains:${o.join(",")}`)}function p(u,t,o,d){const y=u.get(A.IInstantiationService),k=u.get(S.ISearchService),i=y.createInstance(P.QueryBuilder).file(t.map(a=>(0,h.toWorkspaceFolder)(T.URI.revive(a))),{_reason:"checkExists",includePattern:o,exists:!0});return k.fileSearch(i,d).then(a=>!!a.limitHit,a=>F.isCancellationError(a)?!1:Promise.reject(a))}e.checkGlobFileExists=p});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(te):T?T.value:e.get(te)};define(Te[34],Pe([1,0,146,19,83,22,17,6,48,2,14,4,33,200,81,32,26,101,9,24,25,186,7,96,3,27,82,18,70,72,62,5,260,80,188,15,79,58,20]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o,d,y,k,v,i,a,r,s,w,I,c,l,m,E,f,L,W,J,q,U,B){"use strict";var G,N,H;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let Q=e.AbstractExtHostExtensionService=class Cn extends P.Disposable{constructor($,O,X,me,Ce,ye,Ee,Ie,oe,ce,ie){super(),this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=O,this._extHostContext=X,this._initData=Ee,this._extHostWorkspace=me,this._extHostConfiguration=Ce,this._logService=ye,this._extHostTunnelService=oe,this._extHostTerminalService=ce,this._extHostLocalizationService=ie,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._activationEventsReader=new ue(this._initData.activationEvents),this._globalRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.allExtensions);const ne=new y.ExtensionIdentifierSet(this._initData.myExtensions);this._myRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,de(this._globalRegistry,ne)),this._storage=new p.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=$.createChild(new c.ServiceCollection([p.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState])),this._activator=this._register(new _.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(C,z,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(C,d.transformErrorForSerialization(z),V)},actualActivateExtension:async(C,z)=>{if(o.ExtensionDescriptionRegistry.isHostExtension(C,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(C,z),new _.HostExtension;const V=this._myRegistry.getExtensionDescription(C);return this._activateExtension(V,z)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch($){d.onUnexpectedError($)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let $=[];try{$=this._myRegistry.getAllExtensionDescriptions().map(Ce=>Ce.identifier).filter(Ce=>this.isActivated(Ce)).map(Ce=>this._deactivate(Ce))}catch{}await Promise.all($)}terminate($,O=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${$}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),d.setUnexpectedErrorHandler(me=>{this._logService.error(me)}),this._extHostContext.dispose();const X=this._deactivateAll();Promise.race([(0,A.timeout)(5e3),X]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${O}`):this._logService.info(`Extension host exiting with code ${O}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(O)})}isActivated($){return this._readyToRunExtensions.isOpen()?this._activator.isActivated($):!1}async getExtension($){const O=await this._mainThreadExtensionsProxy.$getExtension($);return O&&{...O,identifier:new y.ExtensionIdentifier(O.identifier.value),extensionLocation:h.URI.revive(O.extensionLocation)}}_activateByEvent($,O){return this._activator.activateByEvent($,O)}_activateById($,O){return this._activator.activateById($,O)}activateByIdWithErrors($,O){return this._activateById($,O).then(()=>{const X=this._activator.getActivatedExtension($);if(X.activationFailed)return Promise.reject(X.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then($=>this._myRegistry)}getExtensionExports($){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension($).exports:null}async _realPathExtensionUri($){if($.scheme!==J.Schemas.file)return $;const O=await this._hostUtils.realpath($.fsPath);return h.URI.file(O)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then($=>new Ae($))),this._extensionPathIndex}async _createExtensionPathIndex($){const O=S.TernarySearchTree.forUris(X=>F.extUriBiasedIgnorePathCase.ignorePathCasing(X));return await Promise.all($.map(async X=>{if(this._getEntryPoint(X)){const me=await this._realPathExtensionUri(X.extensionLocation);O.set(me,X)}})),O}_deactivate($){let O=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated($))return O;const X=this._activator.getActivatedExtension($);if(!X)return O;try{typeof X.module.deactivate=="function"&&(O=Promise.resolve(X.module.deactivate()).then(void 0,me=>(this._logService.error(me),Promise.resolve(void 0))))}catch(me){this._logService.error(`An error occurred when deactivating the extension '${$.value}':`),this._logService.error(me)}try{(0,P.dispose)(X.subscriptions)}catch(me){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${$.value}':`),this._logService.error(me)}return O}async _activateExtension($,O){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier),this._doActivateExtension($,O).then(X=>{const me=X.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension($.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,O),this._logExtensionActivationTimes($,O,"success",me),X},X=>{throw this._logExtensionActivationTimes($,O,"failure"),X})}_logExtensionActivationTimes($,O,X,me){const Ce=we($,O);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Ce,...me||{},outcome:X})}_doActivateExtension($,O){const X=we($,O);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",X);const me=this._getEntryPoint($);if(!me)return Promise.resolve(new _.EmptyExtension(_.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${$.identifier.value}, startup: ${O.startup}, activationEvent: '${O.activationEvent}'${$.identifier.value!==O.extensionId.value?`, root cause: ${O.extensionId.value}`:""}`),this._logService.flush();const Ce=new _.ExtensionActivationTimesBuilder(O.startup);return Promise.all([this._loadCommonJSModule($,(0,F.joinPath)($.extensionLocation,me),Ce),this._loadExtensionContext($)]).then(ye=>(D.mark(`code/extHost/willActivateExtension/${$.identifier.value}`),Cn._callActivate(this._logService,$.identifier,ye[0],ye[1],Ce))).then(ye=>(D.mark(`code/extHost/didActivateExtension/${$.identifier.value}`),ye))}_loadExtensionContext($){const O=new v.ExtensionGlobalMemento($,this._storage),X=new v.ExtensionMemento($.identifier.value,!1,this._storage),me=new W.ExtensionSecrets($,this._secretState),Ce=$.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ye=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${$.identifier.value}`),Promise.all([O.whenReady,X.whenReady,this._storagePath.whenReady]).then(()=>{const Ee=this;let Ie,oe;const ce=(0,t.isProposedApiEnabled)($,"ipc")?this._initData.messagePorts?.get(y.ExtensionIdentifier.toKey($.identifier)):void 0;return Object.freeze({globalState:O,workspaceState:X,secrets:me,subscriptions:[],get extensionUri(){return $.extensionLocation},get extensionPath(){return $.extensionLocation.fsPath},asAbsolutePath(ie){return T.join($.extensionLocation.fsPath,ie)},get storagePath(){return Ee._storagePath.workspaceValue($)?.fsPath},get globalStoragePath(){return Ee._storagePath.globalValue($).fsPath},get logPath(){return T.join(Ee._initData.logsLocation.fsPath,$.identifier.value)},get logUri(){return h.URI.joinPath(Ee._initData.logsLocation,$.identifier.value)},get storageUri(){return Ee._storagePath.workspaceValue($)},get globalStorageUri(){return Ee._storagePath.globalValue($)},get extensionMode(){return Ce},get extension(){return Ie===void 0&&(Ie=new he(Ee,$.identifier,$,ye,!1)),Ie},get extensionRuntime(){return(0,t.checkProposedApiEnabled)($,"extensionRuntime"),Ee.extensionRuntime},get environmentVariableCollection(){return Ee._extHostTerminalService.getEnvironmentVariableCollection($)},get messagePassingProtocol(){if(!oe){if(!ce)return;const ie=E.Event.buffer(E.Event.fromDOMEventEmitter(ce,"message",ne=>ne.data));ce.start(),oe={onDidReceiveMessage:ie,postMessage:ce.postMessage.bind(ce)}}return oe}})})}static _callActivate($,O,X,me,Ce){return X=X||{activate:void 0,deactivate:void 0},this._callActivateOptional($,O,X,me,Ce).then(ye=>new _.ActivatedExtension(!1,null,Ce.build(),X,ye,me.subscriptions))}static _callActivateOptional($,O,X,me,Ce){if(typeof X.activate=="function")try{Ce.activateCallStart(),$.trace(`ExtensionService#_callActivateOptional ${O.value}`);const ye=typeof global=="object"?global:self,Ee=X.activate.apply(ye,[me]);return Ce.activateCallStop(),Ce.activateResolveStart(),Promise.resolve(Ee).then(Ie=>(Ce.activateResolveStop(),Ie))}catch(ye){return Promise.reject(ye)}else return Promise.resolve(X)}_activateOneStartupFinished($,O){this._activateById($.identifier,{startup:!1,extensionId:$.identifier,activationEvent:O}).then(void 0,X=>{this._logService.error(X)})}_activateAllStartupFinishedDeferred($,O=0){const me=Date.now();(0,B.setTimeout0)(()=>{for(let Ce=O;Ce<$.length;Ce+=1){const ye=$[Ce];for(const Ee of ye.activationEvents??[])if(Ee==="onStartupFinished")if(Date.now()-me>50){this._activateAllStartupFinishedDeferred($,Ce);break}else this._activateOneStartupFinished(ye,Ee)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks()),this._extHostConfiguration.getConfigProvider().then($=>{const O=$.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),X=this._myRegistry.getAllExtensionDescriptions();if(O)this._activateAllStartupFinishedDeferred(X);else for(const me of X)if(me.activationEvents)for(const Ce of me.activationEvents)Ce==="onStartupFinished"&&this._activateOneStartupFinished(me,Ce)})}_handleEagerExtensions(){const $=this._activateByEvent("*",!0).then(void 0,ye=>{this._logService.error(ye)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ye=>this._handleWorkspaceContainsEagerExtensions(ye.added)));const O=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],X=this._handleWorkspaceContainsEagerExtensions(O),me=this._handleRemoteResolverEagerExtensions(),Ce=Promise.all([me,$,X]).then(()=>{});return Promise.race([Ce,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Ce}_handleWorkspaceContainsEagerExtensions($){return $.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(O=>this._handleWorkspaceContainsEagerExtension($,O))).then(()=>{})}async _handleWorkspaceContainsEagerExtension($,O){if(this.isActivated(O.identifier))return;const X=!this._initData.remote.isRemote&&!!this._initData.remote.authority,me={logService:this._logService,folders:$.map(ye=>ye.uri),forceUsingSearch:X,exists:ye=>this._hostUtils.exists(ye.fsPath),checkExists:(ye,Ee,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(ye,Ee,Ie)},Ce=await(0,f.checkActivateWorkspaceContainsExtension)(me,O);if(Ce)return this._activateById(O.identifier,{startup:!0,extensionId:O.identifier,activationEvent:Ce.activationEvent}).then(void 0,ye=>this._logService.error(ye))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch($){throw console.error($),$}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:$,extensionTestsLocationURI:O}=this._initData.environment;if(!$||!O)throw new Error(n.localize(0,null));const X=await this._loadCommonJSModule(null,O,new _.ExtensionActivationTimesBuilder(!1));if(!X||typeof X.run!="function")throw new Error(n.localize(1,null,O.toString()));return new Promise((me,Ce)=>{const ye=(oe,ce)=>{oe?Ce(oe):me(typeof ce=="number"&&ce>0?1:0)},Ee=(0,F.originalFSPath)(O),Ie=X.run(Ee,ye);Ie&&Ie.then&&Ie.then(()=>{me(0)}).catch(oe=>{Ce(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,A.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver($,O){return this._resolvers[$]=O,(0,P.toDisposable)(()=>{delete this._resolvers[$]})}async _activateAndGetResolver($){const O=$.indexOf("+");if(O===-1)throw new Error("Not an authority that can be resolved!");const X=$.substr(0,O);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1),{authorityPrefix:X,resolver:this._resolvers[X]}}async $resolveAuthority($,O){const X=U.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,a.getRemoteAuthorityPrefix)($)},${O})][${X.elapsed()}ms] `,Ce=ce=>this._logService.info(`${me()}${ce}`),ye=(ce,ie=void 0)=>this._logService.error(`${me()}${ce}`,ie);Ce("activating resolver...");const{authorityPrefix:Ee,resolver:Ie}=await this._activateAndGetResolver($);if(!Ie)return ye("no resolver"),{type:"error",error:{code:a.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ee}.`,detail:void 0}};const oe=new A.IntervalTimer;try{Ce("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(Ie)),oe.cancelAndSet(()=>Ce("waiting..."),1e3),Ce("invoking resolve()..."),D.mark(`code/extHost/willResolveAuthority/${Ee}`);const ce=await Ie.resolve($,{resolveAttempt:O});D.mark(`code/extHost/didResolveAuthorityOK/${Ee}`),oe.dispose(),Ce(`returned ${ce.host}:${ce.port}`);const ie={authority:$,host:ce.host,port:ce.port,connectionToken:ce.connectionToken},ne={extensionHostEnv:ce.extensionHostEnv,isTrusted:ce.isTrusted,authenticationSession:ce.authenticationSessionForInitializingExtensions?{id:ce.authenticationSessionForInitializingExtensions.id,providerId:ce.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ie,options:ne,tunnelInformation:{environmentTunnels:ce.environmentTunnels,features:ce.tunnelFeatures}}}}catch(ce){if(D.mark(`code/extHost/didResolveAuthorityError/${Ee}`),oe.dispose(),ye("returned an error",ce),ce instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ce._code,message:ce._message,detail:ce._detail}};throw ce}}async $getCanonicalURI($,O){this._logService.info(`$getCanonicalURI invoked for authority (${(0,a.getRemoteAuthorityPrefix)($)})`);const{resolver:X}=await this._activateAndGetResolver($);if(!X)return null;const me=h.URI.revive(O);if(typeof X.getCanonicalURI>"u")return me;const Ce=await(0,A.asPromise)(()=>X.getCanonicalURI(me));return Ce||me}$startExtensionHost($){$.toAdd.forEach(me=>me.extensionLocation=h.URI.revive(me.extensionLocation));const{globalRegistry:O,myExtensions:X}=pe(this._activationEventsReader,this._globalRegistry,this._myRegistry,$);return this._globalRegistry.set(O.getAllExtensionDescriptions()),this._myRegistry.set(X),this._startExtensionHost()}$activateByEvent($,O){return O===1?this._activateByEvent($,!1):this._readyToRunExtensions.wait().then(X=>this._activateByEvent($,!1))}async $activate($,O){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription($)?(await this._activateById($,O),!0):!1}async $deltaExtensions($){$.toAdd.forEach(ye=>ye.extensionLocation=h.URI.revive(ye.extensionLocation));const{globalRegistry:O,myExtensions:X}=pe(this._activationEventsReader,this._globalRegistry,this._myRegistry,$),me=await this._createExtensionPathIndex(X);return(await this.getExtensionPathIndex()).setSearchTree(me),this._globalRegistry.set(O.getAllExtensionDescriptions()),this._myRegistry.set(X),Promise.resolve(void 0)}async $test_latency($){return $}async $test_up($){return $.byteLength}async $test_down($){const O=k.VSBuffer.alloc($),X=Math.random()%256;for(let me=0;me<$;me++)O.writeUInt8(X,me);return O}async $updateRemoteConnectionData($){this._remoteConnectionData=$,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=Q=je([Ve(0,r.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,I.IExtHostRpcService),Ve(3,u.IExtHostWorkspace),Ve(4,g.IExtHostConfiguration),Ve(5,R.ILogService),Ve(6,s.IExtHostInitDataService),Ve(7,w.IExtensionStoragePaths),Ve(8,l.IExtHostTunnelService),Ve(9,m.IExtHostTerminalService),Ve(10,q.IExtHostLocalizationService)],Q);function pe(le,$,O,X){le.addActivationEvents(X.addActivationEvents);const me=new o.ExtensionDescriptionRegistry(le,$.getAllExtensionDescriptions());me.deltaExtensions(X.toAdd,X.toRemove);const Ce=new y.ExtensionIdentifierSet(O.getAllExtensionDescriptions().map(Ee=>Ee.identifier));for(const Ee of X.myToRemove)Ce.delete(Ee);for(const Ee of X.myToAdd)Ce.add(Ee);const ye=de(me,Ce);return{globalRegistry:me,myExtensions:ye}}function we(le,$){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:$.activationEvent,reasonId:$.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class he{constructor($,O,X,me,Ce){G.set(this,void 0),N.set(this,void 0),H.set(this,void 0),Je(this,G,$,"f"),Je(this,N,O,"f"),Je(this,H,X.identifier,"f"),this.id=X.identifier.value,this.extensionUri=X.extensionLocation,this.extensionPath=T.normalize((0,F.originalFSPath)(X.extensionLocation)),this.packageJSON=X,this.extensionKind=me,this.isFromDifferentExtensionHost=Ce}get isActive(){return Le(this,G,"f").isActivated(Le(this,H,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Le(this,G,"f").getExtensionExports(Le(this,H,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Le(this,G,"f").activateByIdWithErrors(Le(this,H,"f"),{startup:!1,extensionId:Le(this,N,"f"),activationEvent:"api"}),this.exports}}e.Extension=he,G=new WeakMap,N=new WeakMap,H=new WeakMap;function de(le,$){return le.getAllExtensionDescriptions().filter(O=>$.has(O.identifier))}class Ae{constructor($){this._searchTree=$}setSearchTree($){this._searchTree=$}findSubstr($){return this._searchTree.findSubstr($)}forEach($){return this._searchTree.forEach($)}}e.ExtensionPaths=Ae;class ue{constructor($){this._map=new y.ExtensionIdentifierMap,this.addActivationEvents($)}readActivationEvents($){return this._map.get($.identifier)}addActivationEvents($){for(const O of Object.keys($))this._map.set(O,$[O])}}}),define(Te[261],Pe([1,0,83,2,4,33,26,24,18,27,3,34,51,14,13]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=e.RequireInterceptor=class{constructor(v,i,a,r,s,w,I){this._apiFactory=v,this._extensionRegistry=i,this._instaService=a,this._extHostConfiguration=r,this._extHostExtensionService=s,this._initData=w,this._logService=I,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),n.mark("code/extHost/willWaitForConfig");const v=await this._extHostConfiguration.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const i=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,i,this._extensionRegistry,v,this._logService)),this.register(this._instaService.createInstance(d,i)),this.register(this._instaService.createInstance(t)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(y,i,this._initData.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const i of v.nodeModuleName)this._factories.set(i,v);else this._factories.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this._alternatives.push(i=>v.alternativeModuleName(i))}};e.RequireInterceptor=u=je([Ve(2,R.IInstantiationService),Ve(3,F.IExtHostConfiguration),Ve(4,b.IExtHostExtensionService),Ve(5,h.IExtHostInitDataService),Ve(6,_.ILogService)],u);let t=class cn{constructor(v){if(v.environment.appRoot&&cn.aliased.size){const i=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(v.environment.appRoot.fsPath)),a="[a-z0-9_.-]",r=`@${a}+\\/${a}+|${a}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${i}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(v){if(!this.re)return;const i=this.re.exec(this.forceForwardSlashes(v));if(!i)return;const[,a,r,s]=i,w=cn.aliased.get(r);if(w!==void 0)return console.warn(`${r} as been renamed to ${w}, please update your imports`),a+w+s}forceForwardSlashes(v){return v.replace(/\\/g,"/")}};t.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=je([Ve(0,h.IExtHostInitDataService)],t);class o{constructor(v,i,a,r,s){this._apiFactory=v,this._extensionPaths=i,this._extensionRegistry=a,this._configProvider=r,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new P.ExtensionIdentifierMap}load(v,i){const a=this._extensionPaths.findSubstr(i);if(a){let r=this._extApiImpl.get(a.identifier);return r||(r=this._apiFactory(a,this._extensionRegistry,this._configProvider),this._extApiImpl.set(a.identifier,r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((s,w)=>r+=`	${w} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let d=class{constructor(v,i,a){this._extensionPaths=v,this.nodeModuleName="keytar",this._mainThreadTelemetry=i.getProxy(D.MainContext.MainThreadTelemetry);const{environment:r}=a,s=i.getProxy(D.MainContext.MainThreadKeytar);if(r.appRoot){let w=r.appRoot.fsPath;g.platform==="win32"&&(w=w.replace(/\\/g,"/")),w[w.length-1]==="/"&&(w=w.substr(0,w.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${w}/node_modules.asar/keytar`),this.alternativeNames.add(`${w}/node_modules/keytar`)}this._impl={getPassword:(w,I)=>s.$getPassword(w,I),setPassword:(w,I,c)=>s.$setPassword(w,I,c),deletePassword:(w,I)=>s.$deletePassword(w,I),findPassword:w=>s.$findPassword(w),findCredentials(w){return s.$findCredentials(w)}}}load(v,i){const a=this._extensionPaths.findSubstr(i);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:a?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(v){const i=v.length;if(i<=7||!this.alternativeNames)return;const a=i-7;if((v.charAt(a)==="/"||v.charAt(a)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.alternativeNames.has(v)))return"keytar"}};d=je([Ve(1,S.IExtHostRpcService),Ve(2,h.IExtHostInitDataService)],d);let y=class{constructor(v,i,a){this._extensionPaths=v,this._appUriScheme=i,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=a.getProxy(D.MainContext.MainThreadTelemetry);const r=a.getProxy(D.MainContext.MainThreadWindow);this._impl=(s,w)=>{const I=T.URI.parse(s);return w?this.callOriginal(s,w):I.scheme==="http"||I.scheme==="https"?r.$openUri(I,s,{allowTunneling:!0}):I.scheme==="mailto"||I.scheme===this._appUriScheme?r.$openUri(I,s,{}):this.callOriginal(s,w)}}load(v,i,a){const r=this._extensionPaths.findSubstr(i);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=a(v),this._impl}callOriginal(v,i){return this.sendNoForwardTelemetry(),this._original(v,i)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};y=je([Ve(2,S.IExtHostRpcService)],y)}),define(Te[111],Pe([1,0,87,6,19,51,3,59,60,34,7,32,197,33]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,A.createDecorator)("IExtHostVariableResolverProvider");class p extends g.AbstractVariableResolverService{constructor(o,d,y,k,v,i,a){function r(){if(y){const s=y.activeEditor();if(s)return s.document.uri;const w=k.tabGroups.all.find(I=>I.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof R.TextDiffTabInput||w.input instanceof R.NotebookDiffEditorTabInput)return w.input.modified;if(w.input instanceof R.TextTabInput||w.input instanceof R.NotebookEditorTabInput||w.input instanceof R.CustomEditorTabInput)return w.input.uri}}}super({getFolderUri:s=>{const w=i.folders.filter(I=>I.name===s);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(s,w)=>v.getConfiguration(void 0,s).get(w),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=r();if(s)return D.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(d){const s=r();if(s){const w=d.getWorkspaceFolder(s);if(w)return D.normalize(w.uri.fsPath)}}},getSelectedText:()=>{if(y){const s=y.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(y){const s=y.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>o.getExtension(s)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(F.env))}}let u=e.ExtHostVariableResolverProviderService=class extends T.Disposable{constructor(o,d,y,k,v){super(),this.extensionService=o,this.workspaceService=d,this.editorService=y,this.configurationService=k,this.editorTabs=v,this._resolver=new n.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new p(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,r,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=u=je([Ve(0,h.IExtHostExtensionService),Ve(1,b.IExtHostWorkspace),Ve(2,P.IExtHostDocumentsAndEditors),Ve(3,_.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs)],u)}),define(Te[112],Pe([1,0,17,5,12,2,3,4,60,34,18,7,32,191,193,33,111]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,A.createDecorator)("IExtHostDebugService");let o=e.ExtHostDebugServiceBase=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,s,w,I,c,l){this._workspaceService=s,this._extensionService=w,this._configurationService=I,this._editorTabs=c,this._variableResolver=l,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=r.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._onDidChangeStackFrameFocus=new T.Emitter,this._activeDebugConsole=new y(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(m=>{m.onDidChange(E=>{this.registerAllDebugTypes(m)}),this.registerAllDebugTypes(m)})}asDebugSourceUri(r,s){const w=r;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let I=`debug:${encodeURIComponent(w.path||"")}`,c="?";return s&&(I+=`${c}session=${encodeURIComponent(s.id)}`,c="&"),I+=`${c}ref=${w.sourceReference}`,F.URI.parse(I)}else{if(w.path)return F.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const s=[];for(const w of r.getAllExtensionDescriptions())if(w.contributes){const I=w.contributes.debuggers;if(I&&I.length>0)for(const c of I)(0,p.isDebuggerMainContribution)(c)&&s.push(c.type)}this._debugServiceProxy.$registerDebugTypes(s)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(s=>r.push(s)),r}addBreakpoints(r){this.startBreakpoints();const s=r.filter(c=>{const l=c.id;return this._breakpoints.has(l)?!1:(this._breakpoints.set(l,c),!0)});this.fireBreakpointChanges(s,[],[]);const w=[],I=new Map;for(const c of s)if(c instanceof b.SourceBreakpoint){let l=I.get(c.location.uri.toString());l||(l={type:"sourceMulti",uri:c.location.uri,lines:[]},I.set(c.location.uri.toString(),l),w.push(l)),l.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof b.FunctionBreakpoint&&w.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(w)}removeBreakpoints(r){this.startBreakpoints();const s=r.filter(l=>this._breakpoints.delete(l.id));this.fireBreakpointChanges([],s,[]);const w=s.filter(l=>l instanceof b.SourceBreakpoint).map(l=>l.id),I=s.filter(l=>l instanceof b.FunctionBreakpoint).map(l=>l.id),c=s.filter(l=>l instanceof b.DataBreakpoint).map(l=>l.id);return this._debugServiceProxy.$unregisterBreakpoints(w,I,c)}startDebugging(r,s,w){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,s,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===b.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,w){if(!s)return new b.Disposable(()=>{});const I=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:I,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,w,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,I),new b.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(I)})}registerDebugAdapterDescriptorFactory(r,s,w){if(!w)return new b.Disposable(()=>{});if(!this.definesDebugType(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const I=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:I,factory:w}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,I),new b.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==w),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(I)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new b.Disposable(()=>{});const w=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:w,factory:s}),new b.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(I=>I.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let w;const I=await this.getFolder(r);return I&&(w={uri:I.uri,name:I.name,index:I.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(w,s)}createDebugAdapter(r,s){if(r.type==="implementation")return new v(r.implementation)}createSignService(){}async $startDASession(r,s){const w=this,I=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(I.type),I).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}' (extension might have failed to activate)`);const l=this.convertToDto(c),m=this.createDebugAdapter(l,I);if(!m)throw new Error(`Couldn't create a debug adapter for type '${I.type}'.`);const E=m;return this._debugAdapters.set(r,E),this.getDebugAdapterTrackers(I).then(f=>(f&&this._debugAdaptersTrackers.set(r,f),E.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const W=L,J={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const q=await this._signService.sign(W.arguments.value);J.body={signature:q},E.sendResponse(J)}else throw new Error("no signer")}catch(q){J.success=!1,J.message=q.message,E.sendResponse(J)}}else f&&f.onDidSendMessage&&f.onDidSendMessage(L),L=(0,p.convertToVSCPaths)(L,!0),w._debugServiceProxy.$acceptDAMessage(r,L)}),E.onError(L=>{f&&f.onError&&f.onError(L),this._debugServiceProxy.$acceptDAError(r,L.name,L.message,L.stack)}),E.onExit(L=>{f&&f.onExit&&f.onExit((0,D.withNullAsUndefined)(L),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,D.withNullAsUndefined)(L),void 0)}),f&&f.onWillStartSession&&f.onWillStartSession(),E.startSession()))})}$sendDAMessage(r,s){s=(0,p.convertToDAPaths)(s,!1);const w=this._debugAdaptersTrackers.get(r);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(s),this._debugAdapters.get(r)?.sendMessage(s)}$stopDASession(r){const s=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const w=this._debugAdapters.get(r);return this._debugAdapters.delete(r),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],w=[],I=[];if(r.added)for(const c of r.added){const l=c.id;if(l&&!this._breakpoints.has(l)){let m;if(c.type==="function")m=new b.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")m=new b.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const E=F.URI.revive(c.uri);m=new b.SourceBreakpoint(new b.Location(E,new b.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}(0,b.setBreakpointId)(m,l),this._breakpoints.set(l,m),s.push(m)}}if(r.removed)for(const c of r.removed){const l=this._breakpoints.get(c);l&&(this._breakpoints.delete(c),w.push(l))}if(r.changed){for(const c of r.changed)if(c.id){const l=this._breakpoints.get(c.id);if(l){if(l instanceof b.FunctionBreakpoint&&c.type==="function"){const m=l;m.enabled=c.enabled,m.condition=c.condition,m.hitCondition=c.hitCondition,m.logMessage=c.logMessage,m.functionName=c.functionName}else if(l instanceof b.SourceBreakpoint&&c.type==="source"){const m=l;m.enabled=c.enabled,m.condition=c.condition,m.hitCondition=c.hitCondition,m.logMessage=c.logMessage,m.location=new b.Location(F.URI.revive(c.uri),new b.Position(c.line,c.character))}I.push(l)}}}this.fireBreakpointChanges(s,w,I)}async $acceptStackFrameFocus(r){let s;const w=r.sessionId?await this.getSession(r.sessionId):void 0;if(!w)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?s={kind:r.kind,threadId:r.threadId,session:w}:s={kind:r.kind,threadId:r.threadId,frameId:r.frameId,session:w},this._stackFrameFocus=s,this._onDidChangeStackFrameFocus.fire(s)}$provideDebugConfigurations(r,s,w){return(0,n.asPromise)(async()=>{const I=this.getConfigProviderByHandle(r);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(s);return I.provideDebugConfigurations(c,w)}).then(I=>{if(!I)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return I})}$resolveDebugConfiguration(r,s,w,I){return(0,n.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const l=await this.getFolder(s);return c.resolveDebugConfiguration(l,w,I)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,w,I){return(0,n.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const l=await this.getFolder(s);return c.resolveDebugConfigurationWithSubstitutedVariables(l,w,I)})}async $provideDebugAdapter(r,s){const w=this.getAdapterDescriptorFactoryByHandle(r);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const I=await this.getSession(s);return this.getAdapterDescriptor(w,I).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(r){const s=await this.getSession(r);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.getSession(r);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,s){(await this.getSession(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const I={session:await this.getSession(r),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(I)}convertToDto(r){if(r instanceof b.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof b.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof b.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof b.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const s=this._adapterFactories.filter(w=>w.type===r);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(r){const s=this._adapterFactories.filter(w=>w.handle===r);if(s.length>0)return s[0].factory}getConfigProviderByHandle(r){const s=this._configProviders.filter(w=>w.handle===r);if(s.length>0)return s[0].provider}definesDebugType(r,s){if(r.contributes){const w=r.contributes.debuggers;if(w&&w.length>0){for(const I of w)if(I.label&&I.type&&I.type===s)return!0}}return!1}getDebugAdapterTrackers(r){const w=r.configuration.type,I=this._trackerFactories.filter(c=>c.type===w||c.type==="*").map(c=>(0,n.asPromise)(()=>c.factory.createDebugAdapterTracker(r)).then(l=>l,l=>null));return Promise.race([Promise.all(I).then(c=>{const l=c.filter(m=>!!m);if(l.length>0)return new k(l)}),new Promise(c=>setTimeout(()=>c(void 0),1e3))]).catch(c=>{})}async getAdapterDescriptor(r,s){const w=s.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new b.DebugAdapterServer(w));if(r){const c=await this._extensionService.getExtensionRegistry();return(0,n.asPromise)(()=>r.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,c))).then(l=>{if(l)return l})}const I=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,I))}daExecutableFromPackage(r,s){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,s,w){(r.length>0||s.length>0||w.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:s,changed:w}))}async getSession(r){if(r)if(typeof r=="string"){const s=this._debugSessions.get(r);if(s)return s}else{let s=this._debugSessions.get(r.id);if(!s){const w=await this.getFolder(r.folderUri),I=r.parent?this._debugSessions.get(r.parent):void 0;s=new d(this._debugServiceProxy,r.id,r.type,r.name,w,r.configuration,I),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(r){if(r){const s=F.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=o=je([Ve(0,R.IExtHostRpcService),Ve(1,g.IExtHostWorkspace),Ve(2,h.IExtHostExtensionService),Ve(3,u.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,t.IExtHostVariableResolverProvider)],o);class d{constructor(r,s,w,I,c,l,m){this._debugServiceProxy=r,this._id=s,this._type=w,this._name=I,this._workspaceFolder=c,this._configuration=l,this._parentSession=m}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,s)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=d;class y{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=y;class k{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.trackers.forEach(w=>w.onExit?w.onExit(r,s):void 0)}}class v extends _.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=e.WorkerExtHostDebugService=class extends o{constructor(r,s,w,I,c,l){super(r,s,w,I,c,l)}};e.WorkerExtHostDebugService=i=je([Ve(0,R.IExtHostRpcService),Ve(1,g.IExtHostWorkspace),Ve(2,h.IExtHostExtensionService),Ve(3,u.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,t.IExtHostVariableResolverProvider)],i)}),define(Te[262],Pe([1,0,9,83,2,4,253,14,69,70,27,169,18,55,34,57]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class t{static async installEarlyHandler(y){const k=y.get(P.ILogService),i=y.get(g.IExtHostRpcService).getProxy(F.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(a=>{k.error(a);const r=n.transformErrorForSerialization(a);i.$onUnexpectedError(r)})}static async installFullHandler(y){const k=y.get(P.ILogService),v=y.get(g.IExtHostRpcService),i=y.get(p.IExtHostExtensionService),a=y.get(u.IExtHostTelemetry),r=v.getProxy(F.MainContext.MainThreadExtensionService),s=v.getProxy(F.MainContext.MainThreadErrors),w=await i.getExtensionPathIndex(),I=new WeakMap;function c(m,E){let f="",L,W;for(const J of E)f+=`
	at ${J.toString()}`,W=J.getFileName(),!L&&W&&(L=w.findSubstr(D.URI.file(W)));return I.set(m,L?.identifier),`${m.name||"Error"}: ${m.message||""}${f}`}let l=c;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return l},set(m){l=function(E,f){return c(E,f),m.call(Error,E,f)}}}),n.setUnexpectedErrorHandler(m=>{k.error(m);const E=n.transformErrorForSerialization(m),f=I.get(m);if(!f){s.$onUnexpectedError(E);return}r.$onExtensionRuntimeError(f,E);const L=a.onExtensionError(f,m);k.trace("forwarded error to extension?",L,f)})}}Error.stackTraceLimit=100;class o{constructor(y,k,v,i,a){this._hostUtils=v,this._rpcProtocol=new A.RPCProtocol(y,null,i),k=o._transform(k,this._rpcProtocol);const r=new h.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());r.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...k,messagePorts:a}),r.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),r.set(_.IURITransformerService,new _.URITransformerService(i)),r.set(p.IHostUtils,v);const s=new b.InstantiationService(r,!0);s.invokeFunction(t.installEarlyHandler),this._logService=s.invokeFunction(w=>w.get(P.ILogService)),T.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",k),this._extensionService=s.invokeFunction(w=>w.get(p.IExtHostExtensionService)),this._extensionService.initialize(),s.invokeFunction(t.installFullHandler)}async asBrowserUri(y){const k=this._rpcProtocol.getProxy(F.MainContext.MainThreadExtensionService);return D.URI.revive(await k.$asBrowserUri(y))}terminate(y){this._extensionService.terminate(y)}static _transform(y,k){y.allExtensions.forEach(i=>{i.extensionLocation=D.URI.revive(k.transformIncomingURIs(i.extensionLocation))}),y.environment.appRoot=D.URI.revive(k.transformIncomingURIs(y.environment.appRoot));const v=y.environment.extensionDevelopmentLocationURI;return v&&(y.environment.extensionDevelopmentLocationURI=v.map(i=>D.URI.revive(k.transformIncomingURIs(i)))),y.environment.extensionTestsLocationURI=D.URI.revive(k.transformIncomingURIs(y.environment.extensionTestsLocationURI)),y.environment.globalStorageHome=D.URI.revive(k.transformIncomingURIs(y.environment.globalStorageHome)),y.environment.workspaceStorageHome=D.URI.revive(k.transformIncomingURIs(y.environment.workspaceStorageHome)),y.environment.extensionTelemetryLogResource=D.URI.revive(k.transformIncomingURIs(y.environment.extensionTelemetryLogResource)),y.nlsBaseUrl=D.URI.revive(k.transformIncomingURIs(y.nlsBaseUrl)),y.logsLocation=D.URI.revive(k.transformIncomingURIs(y.logsLocation)),y.workspace=k.transformIncomingURIs(y.workspace),y}}e.ExtensionHostMain=o}),define(Te[263],Pe([1,0,16,17,21,40,15,19,22,2,47]),function(te,e,n,T,D,F,A,P,S,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(d,y,k,v){this.query=d,this.provider=y,this.fileUtils=k,this.processType=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,y){const k=this.query.folderQueries||[],v=new D.CancellationTokenSource;return y.onCancellationRequested(()=>v.cancel()),new Promise((i,a)=>{this.collector=new _(d);let r=!1;const s=(w,I)=>{if(!r&&!this.isLimitHit){const c=this.resultSize(w);u(w)&&typeof this.query.maxResults=="number"&&this.resultCount+c>this.query.maxResults&&(this.isLimitHit=!0,r=!0,v.cancel(),w=this.trimResultToSize(w,this.query.maxResults-this.resultCount));const l=this.resultSize(w);this.resultCount+=l,(l>0||!u(w))&&this.collector.add(w,I)}};Promise.all(k.map((w,I)=>this.searchInFolder(w,c=>s(c,I),v.token))).then(w=>{v.dispose(),this.collector.flush();const I=w.some(c=>!!c&&!!c.limitHit);i({limitHit:this.isLimitHit||I,messages:(0,n.flatten)(w.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.processType}})},w=>{v.dispose();const I=(0,F.toErrorMessage)(w);a(new Error(I))})})}resultSize(d){return u(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,y){const k=Array.isArray(d.ranges)?d.ranges:[d.ranges],v=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:k.slice(0,y),preview:{matches:v.slice(0,y),text:d.preview.text},uri:d.uri}}async searchInFolder(d,y,k){const v=new R.QueryGlobTester(this.query,d),i=[],a={report:w=>{if(!this.validateProviderResult(w))return;const I=d.folder.scheme===A.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(S.dirname(w.uri))):void 0,c=S.relativePath(d.folder,w.uri);if(c){const l=v.includedInQuery(c,P.basename(c),I);(0,T.isThenable)(l)?i.push(l.then(m=>{m&&y(w)})):l&&y(w)}}},r=this.getSearchOptionsForFolder(d),s=await this.provider.provideTextSearchResults(g(this.query.contentPattern),r,a,k);return i.length&&await Promise.all(i),s}validateProviderResult(d){if(u(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const y=(0,R.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),k=(0,R.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),v={folder:h.URI.from(d.folder),excludes:k,includes:y,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return v.usePCRE2=this.query.usePCRE2,v}}e.TextSearchManager=b;function g(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class _{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new t(512,y=>this.sendItems(y))}add(d,y){this._currentFileMatch&&(this._currentFolderIdx!==y||!S.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=y,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(p(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=_;function p(o){return u(o)?{preview:{matches:(0,n.mapArrayOrNot)(o.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:o.preview.text},ranges:(0,n.mapArrayOrNot)(o.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function u(o){return!!o.preview}e.extensionResultIsMatch=u;class t{constructor(d,y){this.maxBatchSize=d,this.cb=y,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,y){d&&this.addItemToBatch(d,y)}addItems(d,y){d&&this.addItemsToBatch(d,y)}addItemToBatch(d,y){this.batch.push(d),this.batchSize+=y,this.onUpdate()}addItemsToBatch(d,y){this.batch=this.batch.concat(d),this.batchSize+=y,this.onUpdate()}onUpdate(){this.totalNumberCompleted<t.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},t.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=t,t.TIMEOUT=4e3,t.START_BATCH_AFTER_COUNT=50}),define(Te[113],Pe([1,0,6,4,3,258,18,55,14,2,263]),function(te,e,n,T,D,F,A,P,S,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let b=e.ExtHostSearch=class{constructor(u,t,o){this.extHostRpc=u,this._uriTransformer=t,this._logService=o,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new F.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,t){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const o=this._handlePool++;return this._textSearchProvider.set(o,t),this._proxy.$registerTextSearchProvider(o,this._transformScheme(u)),(0,n.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerFileSearchProvider(u,t){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const o=this._handlePool++;return this._fileSearchProvider.set(o,t),this._proxy.$registerFileSearchProvider(o,this._transformScheme(u)),(0,n.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(u,t,o,d){const y=g(o),k=this._fileSearchProvider.get(u);if(k)return this._fileSearchManager.fileSearch(y,k,v=>{this._proxy.$handleFileMatch(u,t,v.map(i=>i.resource))},d);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,t,o,d){const y=this._textSearchProvider.get(u);if(!y||!y.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const k=g(o);return this.createTextSearchManager(k,y).search(i=>this._proxy.$handleTextMatch(u,t,i),d)}$enableExtensionHostSearch(){}createTextSearchManager(u,t){return new R.TextSearchManager(u,t,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.ExtHostSearch=b=je([Ve(0,A.IExtHostRpcService),Ve(1,P.IURITransformerService),Ve(2,S.ILogService)],b);function g(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(_),extraFileResources:p.extraFileResources&&p.extraFileResources.map(u=>h.URI.revive(u))}}e.reviveQuery=g;function _(p){return{...p,folder:h.URI.revive(p.folder)}}}),define(Te[264],Pe([1,0,21,9,5,29,2,134,274,121,132,43,4,76,217,216,38,218,33,220,221,222,203,223,59,34,224,225,231,232,234,108,207,240,241,243,81,62,245,208,8,7,52,248,63,107,32,24,195,230,50,106,110,112,113,14,55,18,27,235,201,72,78,214,246,82,61,251,249,250,215,37,244,247,80,60,57,236,109,237,15,94,206,187,226,6,26,192,79,183,238,239,228,227,205,242,229]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o,d,y,k,v,i,a,r,s,w,I,c,l,m,E,f,L,W,J,q,U,B,G,N,H,Q,pe,we,he,de,Ae,ue,le,$,O,X,me,Ce,ye,Ee,Ie,oe,ce,ie,ne,C,z,V,j,ae,ge,ee,be,Se,xe,He,et,Qe,Ye,rt,lt,Me,st,Z,Y,_e,Ne,ze,Xe,We,it,wt,St,kt,$t,bt,Bt,Mt,jt,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Tt(at){const gt=at.get(oe.IExtHostInitDataService),zt=at.get(xe.IExtHostFileSystemInfo),Nt=at.get(ae.IExtHostConsumerFileSystem),It=at.get(s.IExtHostExtensionService),ht=at.get(de.IExtHostWorkspace),Ct=at.get(rt.IExtHostTelemetry),Ot=at.get(d.IExtHostConfiguration),Pt=at.get(Ee.IURITransformerService),Ke=at.get(Ie.IExtHostRpcService),ke=at.get(q.IExtHostStorage),Re=at.get(j.IExtensionStoragePaths),ve=at.get(ye.ILoggerService),K=at.get(ye.ILogService),Oe=at.get(ne.IExtHostTunnelService),Be=at.get(C.IExtHostApiDeprecationService),Ge=at.get(he.IExtHostWindow),$e=at.get(Qe.IExtHostSecretState),tt=at.get(Ye.IExtHostEditorTabs);Ke.set(g.ExtHostContext.ExtHostFileSystemInfo,zt),Ke.set(g.ExtHostContext.ExtHostLogLevelServiceShape,ve),Ke.set(g.ExtHostContext.ExtHostWorkspace,ht),Ke.set(g.ExtHostContext.ExtHostConfiguration,Ot),Ke.set(g.ExtHostContext.ExtHostExtensionService,It),Ke.set(g.ExtHostContext.ExtHostStorage,ke),Ke.set(g.ExtHostContext.ExtHostTunnelService,Oe),Ke.set(g.ExtHostContext.ExtHostWindow,Ge),Ke.set(g.ExtHostContext.ExtHostSecretState,$e),Ke.set(g.ExtHostContext.ExtHostTelemetry,Ct),Ke.set(g.ExtHostContext.ExtHostEditorTabs,tt);const Et=Ke.set(g.ExtHostContext.ExtHostDecorations,at.get(O.IExtHostDecorations)),pt=Ke.set(g.ExtHostContext.ExtHostDocumentsAndEditors,at.get(r.IExtHostDocumentsAndEditors)),dt=Ke.set(g.ExtHostContext.ExtHostCommands,at.get(t.IExtHostCommands)),nt=Ke.set(g.ExtHostContext.ExtHostTerminalService,at.get(U.IExtHostTerminalService)),ut=Ke.set(g.ExtHostContext.ExtHostDebugService,at.get(me.IExtHostDebugService)),Rt=Ke.set(g.ExtHostContext.ExtHostSearch,at.get(Ce.IExtHostSearch)),Ut=Ke.set(g.ExtHostContext.ExtHostTask,at.get(X.IExtHostTask)),ai=Ke.set(g.ExtHostContext.ExtHostOutputService,at.get(E.IExtHostOutputService)),ri=Ke.set(g.ExtHostContext.ExtHostLocalization,at.get(wt.IExtHostLocalizationService)),ei=Ke.set(g.ExtHostContext.ExtHostUrls,new pe.ExtHostUrls(Ke)),Dt=Ke.set(g.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(Ke,pt)),Ti=Ke.set(g.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ke,pt,K)),Yi=Ke.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(K,Dt,Ke.getProxy(g.MainContext.MainThreadBulkEdits))),yt=Ke.set(g.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(Ke,dt,pt,Dt)),gi=Ke.set(g.ExtHostContext.ExtHostNotebookDocuments,new Ne.ExtHostNotebookDocuments(yt)),pi=Ke.set(g.ExtHostContext.ExtHostNotebookEditors,new _e.ExtHostNotebookEditors(K,yt)),Ht=Ke.set(g.ExtHostContext.ExtHostNotebookKernels,new lt.ExtHostNotebookKernels(Ke,gt,yt,dt,K)),Pi=Ke.set(g.ExtHostContext.ExtHostNotebookRenderers,new st.ExtHostNotebookRenderers(Ke,yt)),Ai=Ke.set(g.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Mt.ExtHostNotebookDocumentSaveParticipant(K,yt,Ke.getProxy(g.MainContext.MainThreadBulkEdits))),Ft=Ke.set(g.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(Ke,pt)),vi=Ke.set(g.ExtHostContext.ExtHostTreeViews,new G.ExtHostTreeViews(Ke.getProxy(g.MainContext.MainThreadTreeViews),dt,K)),Ji=Ke.set(g.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(Ke.getProxy(g.MainContext.MainThreadEditorInsets),Ft,gt.remote)),Gt=Ke.set(g.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(Ke,K,zt,pt)),si=Ke.set(g.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Ke,Dt,dt.converter,Pt)),ft=Ke.set(g.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ke,Pt,Dt,dt,Gt,K,Be,Ct)),Ri=Ke.set(g.ExtHostContext.ExtHostFileSystem,new w.ExtHostFileSystem(Ke,ft)),Xt=Ke.set(g.ExtHostContext.ExtHostFileSystemEventService,new I.ExtHostFileSystemEventService(Ke,K,pt)),ti=Ke.set(g.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(Ke,ht,dt)),Ei=Ke.set(g.ExtHostContext.ExtHostSCM,new W.ExtHostSCM(Ke,dt,Dt,K)),Oi=Ke.set(g.ExtHostContext.ExtHostQuickDiff,new $t.ExtHostQuickDiff(Ke,Pt)),Fi=Ke.set(g.ExtHostContext.ExtHostComments,(0,o.createExtHostComments)(Ke,dt,Dt)),wi=Ke.set(g.ExtHostContext.ExtHostProgress,new f.ExtHostProgress(Ke.getProxy(g.MainContext.MainThreadProgress))),Li=Ke.set(g.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Ke)),bi=Ke.set(g.ExtHostContext.ExtHostTheming,new ie.ExtHostTheming(Ke)),ii=Ke.set(g.ExtHostContext.ExtHostAuthentication,new z.ExtHostAuthentication(Ke)),Mi=Ke.set(g.ExtHostContext.ExtHostTimeline,new V.ExtHostTimeline(Ke,dt)),ci=Ke.set(g.ExtHostContext.ExtHostWebviews,new we.ExtHostWebviews(Ke,gt.remote,ht,K,Be)),li=Ke.set(g.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Ke,ci,ht)),Ni=Ke.set(g.ExtHostContext.ExtHostCustomEditors,new ee.ExtHostCustomEditors(Ke,Dt,Re,ci,li)),Ui=Ke.set(g.ExtHostContext.ExtHostWebviewViews,new ge.ExtHostWebviewViews(Ke,ci)),ni=Ke.set(g.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Ke,dt,pt)),xi=Ke.set(g.ExtHostContext.ExtHostUriOpeners,new et.ExtHostUriOpeners(Ke)),Bi=Ke.set(g.ExtHostContext.ExtHostProfileContentHandlers,new kt.ExtHostProfileContentHandlers(Ke));Ke.set(g.ExtHostContext.ExtHostInteractive,new ze.ExtHostInteractive(Ke,yt,pt,dt,K));const zi=Ke.set(g.ExtHostContext.ExtHostInteractiveEditor,new Bt.ExtHostInteractiveEditor(Ke,Dt,K)),ui=Ke.set(g.ExtHostContext.ExtHostInteractiveSession,new bt.ExtHostInteractiveSession(Ke,K)),Zi=Ke.set(g.ExtHostContext.ExtHostSemanticSimilarity,new jt.ExtHostSemanticSimilarity(Ke)),_i=Ke.set(g.ExtHostContext.ExtHostIssueReporter,new Wt.ExtHostIssueReporter(Ke)),Si=Object.values(g.ExtHostContext);Ke.assertRegistered(Si);const en=new Se.ExtHostBulkEdits(Ke,pt),tn=new u.ExtHostClipboard(Ke),di=new m.ExtHostMessageService(Ke,K),hi=new k.ExtHostDialogs(Ke),yi=new J.ExtHostStatusBar(Ke,dt.converter);return p.ExtHostApiCommands.register(dt),function(Ue,qt,$i){const vt=function(){let re=!Ue.isUnderDevelopment;function fe(){re||(K.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Fe(ot){if(Array.isArray(ot))ot.forEach(Fe);else if(typeof ot=="string")fe();else{const _t=ot;typeof _t.scheme>"u"&&fe(),typeof _t.exclusive=="boolean"&&(0,We.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return ot}}(),Wi={getSession(re,fe,Fe){return ii.getSession(Ue,re,fe,Fe)},getSessions(re,fe){return(0,We.checkProposedApiEnabled)(Ue,"getSessions"),ii.getSessions(Ue,re,fe)},async hasSession(re,fe){return(0,We.checkProposedApiEnabled)(Ue,"authSession"),!!await ii.getSession(Ue,re,fe,{silent:!0})},get onDidChangeSessions(){return ii.onDidChangeSessions},registerAuthenticationProvider(re,fe,Fe,ot){return ii.registerAuthenticationProvider(re,fe,Fe,ot)}},Qt={registerCommand(re,fe,Fe){return dt.registerCommand(!0,re,fe,Fe,void 0,Ue)},registerTextEditorCommand(re,fe,Fe){return dt.registerCommand(!0,re,(...ot)=>{const _t=Ft.getActiveTextEditor();if(!_t){K.warn("Cannot execute "+re+" because there is no active text editor.");return}return _t.edit(At=>{fe.apply(Fe,[_t,At,...ot])}).then(At=>{At||K.warn("Edits from command "+re+" were not applied.")},At=>{K.warn("An error occurred while running command "+re,At)})},void 0,void 0,Ue)},registerDiffInformationCommand:(re,fe,Fe)=>((0,We.checkProposedApiEnabled)(Ue,"diffCommand"),dt.registerCommand(!0,re,async(...ot)=>{const _t=pt.activeEditor(!0);if(!_t){K.warn("Cannot execute "+re+" because there is no active text editor.");return}const At=await Ft.getDiffInformation(_t.id);fe.apply(Fe,[At,...ot])},void 0,void 0,Ue)),executeCommand(re,...fe){return dt.executeCommand(re,...fe)},getCommands(re=!1){return dt.getCommands(re)}},oi={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return tn.value},get shell(){return nt.getDefaultShell(!1)},get onDidChangeShell(){return(0,We.checkProposedApiEnabled)(Ue,"envShellEvent"),nt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Ue,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,rt.isNewAppInstall)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,fe){return rt.ExtHostTelemetryLogger.validateSender(re),Ct.instantiateLogger(Ue,re,fe)},openExternal(re,fe){return Ge.openUri(re,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===gt.environment.appUriScheme)return ei.createAppUri(re);try{return await Ge.asExternalUri(re,{allowTunneling:!!gt.remote.authority})}catch(fe){if((0,Y.matchesScheme)(re,Z.Schemas.http)||(0,Y.matchesScheme)(re,Z.Schemas.https))return re;throw fe}},get remoteName(){return(0,$.getRemoteName)(gt.remote.authority)},get remoteAuthority(){return(0,We.checkProposedApiEnabled)(Ue,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return K.getLevel()},get onDidChangeLogLevel(){return K.onDidChangeLogLevel},registerIssueUriRequestHandler(re){return(0,We.checkProposedApiEnabled)(Ue,"handleIssueUri"),_i.registerIssueUriRequestHandler(Ue,re)}};gt.environment.extensionTestsLocationURI||Object.freeze(oi);const nn={createTestController(re,fe,Fe){return ni.createTestController(Ue,re,fe,Fe)},createTestObserver(){return(0,We.checkProposedApiEnabled)(Ue,"testObserver"),ni.createTestObserver()},runTests(re){return(0,We.checkProposedApiEnabled)(Ue,"testObserver"),ni.runTests(re)},get onDidChangeTestResults(){return(0,We.checkProposedApiEnabled)(Ue,"testObserver"),ni.onResultsChanged},get testResults(){return(0,We.checkProposedApiEnabled)(Ue,"testObserver"),ni.results}},Lt=gt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,fi={getExtension(re,fe){(0,We.isProposedApiEnabled)(Ue,"extensionsAny")||(fe=!1);const Fe=qt.mine.getExtensionDescription(re);if(Fe)return new s.Extension(It,Ue.identifier,Fe,Lt,!1);if(fe){const ot=qt.all.getExtensionDescription(re);if(ot)return new s.Extension(It,Ue.identifier,ot,Lt,!0)}},get all(){const re=[];for(const fe of qt.mine.getAllExtensionDescriptions())re.push(new s.Extension(It,Ue.identifier,fe,Lt,!1));return re},get allAcrossExtensionHosts(){(0,We.checkProposedApiEnabled)(Ue,"extensionsAny");const re=new Ae.ExtensionIdentifierSet(qt.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),fe=[];for(const Fe of qt.all.getAllExtensionDescriptions()){const ot=!re.has(Fe.identifier);fe.push(new s.Extension(It,Ue.identifier,Fe,Lt,ot))}return fe},get onDidChange(){return(0,We.isProposedApiEnabled)(Ue,"extensionsAny")?D.Event.any(qt.mine.onDidChange,qt.all.onDidChange):qt.mine.onDidChange}},Hi={createDiagnosticCollection(re){return Gt.createDiagnosticCollection(Ue.identifier,re)},get onDidChangeDiagnostics(){return Gt.onDidChangeDiagnostics},getDiagnostics:re=>Gt.getDiagnostics(re),getLanguages(){return si.getLanguages()},setTextDocumentLanguage(re,fe){return si.changeLanguage(re.uri,fe)},match(re,fe){const Fe=Dt.getDocumentData(fe.uri)?.notebook;return(0,R.score)(N.LanguageSelector.from(re),fe.uri,fe.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(re,fe,Fe){return ft.registerCodeActionProvider(Ue,vt(re),fe,Fe)},registerDocumentPasteEditProvider(re,fe,Fe){return(0,We.checkProposedApiEnabled)(Ue,"documentPaste"),ft.registerDocumentPasteEditProvider(Ue,vt(re),fe,Fe)},registerCodeLensProvider(re,fe){return ft.registerCodeLensProvider(Ue,vt(re),fe)},registerDefinitionProvider(re,fe){return ft.registerDefinitionProvider(Ue,vt(re),fe)},registerDeclarationProvider(re,fe){return ft.registerDeclarationProvider(Ue,vt(re),fe)},registerImplementationProvider(re,fe){return ft.registerImplementationProvider(Ue,vt(re),fe)},registerTypeDefinitionProvider(re,fe){return ft.registerTypeDefinitionProvider(Ue,vt(re),fe)},registerHoverProvider(re,fe){return ft.registerHoverProvider(Ue,vt(re),fe,Ue.identifier)},registerEvaluatableExpressionProvider(re,fe){return ft.registerEvaluatableExpressionProvider(Ue,vt(re),fe,Ue.identifier)},registerInlineValuesProvider(re,fe){return ft.registerInlineValuesProvider(Ue,vt(re),fe,Ue.identifier)},registerDocumentHighlightProvider(re,fe){return ft.registerDocumentHighlightProvider(Ue,vt(re),fe)},registerLinkedEditingRangeProvider(re,fe){return ft.registerLinkedEditingRangeProvider(Ue,vt(re),fe)},registerReferenceProvider(re,fe){return ft.registerReferenceProvider(Ue,vt(re),fe)},registerRenameProvider(re,fe){return ft.registerRenameProvider(Ue,vt(re),fe)},registerDocumentSymbolProvider(re,fe,Fe){return ft.registerDocumentSymbolProvider(Ue,vt(re),fe,Fe)},registerWorkspaceSymbolProvider(re){return ft.registerWorkspaceSymbolProvider(Ue,re)},registerDocumentFormattingEditProvider(re,fe){return ft.registerDocumentFormattingEditProvider(Ue,vt(re),fe)},registerDocumentRangeFormattingEditProvider(re,fe){return ft.registerDocumentRangeFormattingEditProvider(Ue,vt(re),fe)},registerOnTypeFormattingEditProvider(re,fe,Fe,...ot){return ft.registerOnTypeFormattingEditProvider(Ue,vt(re),fe,[Fe].concat(ot))},registerDocumentSemanticTokensProvider(re,fe,Fe){return ft.registerDocumentSemanticTokensProvider(Ue,vt(re),fe,Fe)},registerDocumentRangeSemanticTokensProvider(re,fe,Fe){return ft.registerDocumentRangeSemanticTokensProvider(Ue,vt(re),fe,Fe)},registerSignatureHelpProvider(re,fe,Fe,...ot){return typeof Fe=="object"?ft.registerSignatureHelpProvider(Ue,vt(re),fe,Fe):ft.registerSignatureHelpProvider(Ue,vt(re),fe,typeof Fe>"u"?[]:[Fe,...ot])},registerCompletionItemProvider(re,fe,...Fe){return ft.registerCompletionItemProvider(Ue,vt(re),fe,Fe)},registerInlineCompletionItemProvider(re,fe){return fe.handleDidShowCompletionItem&&(0,We.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,We.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ft.registerInlineCompletionsProvider(Ue,vt(re),fe)},registerDocumentLinkProvider(re,fe){return ft.registerDocumentLinkProvider(Ue,vt(re),fe)},registerColorProvider(re,fe){return ft.registerColorProvider(Ue,vt(re),fe)},registerFoldingRangeProvider(re,fe){return ft.registerFoldingRangeProvider(Ue,vt(re),fe)},registerSelectionRangeProvider(re,fe){return ft.registerSelectionRangeProvider(Ue,re,fe)},registerCallHierarchyProvider(re,fe){return ft.registerCallHierarchyProvider(Ue,re,fe)},registerTypeHierarchyProvider(re,fe){return ft.registerTypeHierarchyProvider(Ue,re,fe)},setLanguageConfiguration:(re,fe)=>ft.setLanguageConfiguration(Ue,re,fe),getTokenInformationAtPosition(re,fe){return(0,We.checkProposedApiEnabled)(Ue,"tokenInformation"),si.tokenAtPosition(re,fe)},registerInlayHintsProvider(re,fe){return ft.registerInlayHintsProvider(Ue,re,fe)},createLanguageStatusItem(re,fe){return si.createLanguageStatusItem(Ue,re,fe)},registerDocumentDropEditProvider(re,fe,Fe){return ft.registerDocumentOnDropEditProvider(Ue,re,fe,(0,We.isProposedApiEnabled)(Ue,"dropMetadata")?Fe:void 0)}},Vi={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return nt.activeTerminal},get terminals(){return nt.terminals},async showTextDocument(re,fe,Fe){const ot=await(A.URI.isUri(re)?Promise.resolve(Di.openTextDocument(re)):Promise.resolve(re));return Ft.showTextDocument(ot,fe,Fe)},createTextEditorDecorationType(re){return Ft.createTextEditorDecorationType(Ue,re)},onDidChangeActiveTextEditor(re,fe,Fe){return Ft.onDidChangeActiveTextEditor(re,fe,Fe)},onDidChangeVisibleTextEditors(re,fe,Fe){return Ft.onDidChangeVisibleTextEditors(re,fe,Fe)},onDidChangeTextEditorSelection(re,fe,Fe){return Ft.onDidChangeTextEditorSelection(re,fe,Fe)},onDidChangeTextEditorOptions(re,fe,Fe){return Ft.onDidChangeTextEditorOptions(re,fe,Fe)},onDidChangeTextEditorVisibleRanges(re,fe,Fe){return Ft.onDidChangeTextEditorVisibleRanges(re,fe,Fe)},onDidChangeTextEditorViewColumn(re,fe,Fe){return Ft.onDidChangeTextEditorViewColumn(re,fe,Fe)},onDidCloseTerminal(re,fe,Fe){return nt.onDidCloseTerminal(re,fe,Fe)},onDidOpenTerminal(re,fe,Fe){return nt.onDidOpenTerminal(re,fe,Fe)},onDidChangeActiveTerminal(re,fe,Fe){return nt.onDidChangeActiveTerminal(re,fe,Fe)},onDidChangeTerminalDimensions(re,fe,Fe){return(0,We.checkProposedApiEnabled)(Ue,"terminalDimensions"),nt.onDidChangeTerminalDimensions(re,fe,Fe)},onDidChangeTerminalState(re,fe,Fe){return nt.onDidChangeTerminalState(re,fe,Fe)},onDidWriteTerminalData(re,fe,Fe){return(0,We.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),nt.onDidWriteTerminalData(re,fe,Fe)},get state(){return Ge.state},onDidChangeWindowState(re,fe,Fe){return Ge.onDidChangeWindowState(re,fe,Fe)},showInformationMessage(re,...fe){return di.showMessage(Ue,F.default.Info,re,fe[0],fe.slice(1))},showWarningMessage(re,...fe){return di.showMessage(Ue,F.default.Warning,re,fe[0],fe.slice(1))},showErrorMessage(re,...fe){return di.showMessage(Ue,F.default.Error,re,fe[0],fe.slice(1))},showQuickPick(re,fe,Fe){return ti.showQuickPick(Ue,re,fe,Fe)},showWorkspaceFolderPick(re){return ti.showWorkspaceFolderPick(re)},showInputBox(re,fe){return ti.showInput(re,fe)},showOpenDialog(re){return hi.showOpenDialog(Ue,re)},showSaveDialog(re){return hi.showSaveDialog(re)},createStatusBarItem(re,fe,Fe){let ot,_t,At;return typeof re=="string"?(ot=re,_t=fe,At=Fe):(_t=re,At=fe),yi.createStatusBarEntry(Ue,ot,_t,At)},setStatusBarMessage(re,fe){return yi.setStatusBarMessage(re,fe)},withScmProgress(re){return Be.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),wi.withProgress(Ue,{location:H.ProgressLocation.SourceControl},(fe,Fe)=>re({report(ot){}}))},withProgress(re,fe){return wi.withProgress(Ue,re,fe)},createOutputChannel(re,fe){return ai.createOutputChannel(re,fe,Ue)},createWebviewPanel(re,fe,Fe,ot){return li.createWebviewPanel(Ue,re,fe,Fe,ot)},createWebviewTextEditorInset(re,fe,Fe,ot){return(0,We.checkProposedApiEnabled)(Ue,"editorInsets"),Ji.createWebviewEditorInset(re,fe,Fe,ot,Ue)},createTerminal(re,fe,Fe){return typeof re=="object"?"pty"in re?nt.createExtensionTerminal(re):nt.createTerminalFromOptions(re):nt.createTerminal(re,fe,Fe)},registerTerminalLinkProvider(re){return nt.registerLinkProvider(re)},registerTerminalProfileProvider(re,fe){return nt.registerProfileProvider(Ue,re,fe)},registerTerminalQuickFixProvider(re,fe){return(0,We.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),nt.registerTerminalQuickFixProvider(re,Ue.identifier.value,fe)},registerTreeDataProvider(re,fe){return vi.registerTreeDataProvider(re,fe,Ue)},createTreeView(re,fe){return vi.createTreeView(re,fe,Ue)},registerWebviewPanelSerializer:(re,fe)=>li.registerWebviewPanelSerializer(Ue,re,fe),registerCustomEditorProvider:(re,fe,Fe={})=>Ni.registerCustomEditorProvider(Ue,re,fe,Fe),registerFileDecorationProvider(re){return Et.registerFileDecorationProvider(re,Ue)},registerUriHandler(re){return ei.registerUriHandler(Ue.identifier,re)},createQuickPick(){return ti.createQuickPick(Ue)},createInputBox(){return ti.createInputBox(Ue)},get activeColorTheme(){return bi.activeColorTheme},onDidChangeActiveColorTheme(re,fe,Fe){return bi.onDidChangeActiveColorTheme(re,fe,Fe)},registerWebviewViewProvider(re,fe,Fe){return Ui.registerWebviewViewProvider(Ue,re,fe,Fe?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,fe,Fe){return yt.onDidChangeActiveNotebookEditor(re,fe,Fe)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,fe,Fe){return pi.onDidChangeNotebookEditorSelection(re,fe,Fe)},onDidChangeNotebookEditorVisibleRanges(re,fe,Fe){return pi.onDidChangeNotebookEditorVisibleRanges(re,fe,Fe)},showNotebookDocument(re,fe){return yt.showNotebookDocument(re,fe)},registerExternalUriOpener(re,fe,Fe){return(0,We.checkProposedApiEnabled)(Ue,"externalUriOpener"),xi.registerExternalUriOpener(Ue.identifier,re,fe,Fe)},registerProfileContentHandler(re,fe){return(0,We.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Bi.registrProfileContentHandler(Ue,re,fe)},registerQuickDiffProvider(re,fe,Fe,ot){return(0,We.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Oi.registerQuickDiffProvider(vt(re),fe,Fe,ot)},get tabGroups(){return tt.tabGroups}},Di={get rootPath(){return Be.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(re){throw T.readonly()},getWorkspaceFolder(re){return ht.getWorkspaceFolder(re)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(re){throw T.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(re){throw T.readonly()},updateWorkspaceFolders:(re,fe,...Fe)=>ht.updateWorkspaceFolders(Ue,re,fe||0,...Fe),onDidChangeWorkspaceFolders:function(re,fe,Fe){return ht.onDidChangeWorkspace(re,fe,Fe)},asRelativePath:(re,fe)=>ht.getRelativePath(re,fe),findFiles:(re,fe,Fe,ot)=>ht.findFiles(re,fe,Fe,Ue.identifier,ot),findTextInFiles:(re,fe,Fe,ot)=>{(0,We.checkProposedApiEnabled)(Ue,"findTextInFiles");let _t,At;return typeof fe=="object"?(_t=fe,At=Fe):(_t={},At=fe,ot=Fe),ht.findTextInFiles(re,_t||{},At,Ue.identifier,ot)},save:re=>((0,We.checkProposedApiEnabled)(Ue,"saveEditor"),ht.save(re)),saveAs:re=>((0,We.checkProposedApiEnabled)(Ue,"saveEditor"),ht.saveAs(re)),saveAll:re=>ht.saveAll(re),applyEdit(re,fe){return en.applyWorkspaceEdit(re,Ue,fe)},createFileSystemWatcher:(re,fe,Fe,ot)=>Xt.createFileSystemWatcher(ht,Ue,re,fe,Fe,ot),get textDocuments(){return Dt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw T.readonly()},openTextDocument(re){let fe;const Fe=re;if(typeof re=="string")fe=Promise.resolve(A.URI.file(re));else if(A.URI.isUri(re))fe=Promise.resolve(re);else if(!Fe||typeof Fe=="object")fe=Dt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(ot=>Dt.ensureDocumentData(ot).then(_t=>_t.document))},onDidOpenTextDocument:(re,fe,Fe)=>Dt.onDidAddDocument(re,fe,Fe),onDidCloseTextDocument:(re,fe,Fe)=>Dt.onDidRemoveDocument(re,fe,Fe),onDidChangeTextDocument:(re,fe,Fe)=>Dt.onDidChangeDocument(re,fe,Fe),onDidSaveTextDocument:(re,fe,Fe)=>Dt.onDidSaveDocument(re,fe,Fe),onWillSaveTextDocument:(re,fe,Fe)=>Yi.getOnWillSaveTextDocumentEvent(Ue)(re,fe,Fe),get notebookDocuments(){return yt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,fe){let Fe;if(A.URI.isUri(re))Fe=re,await yt.openNotebookDocument(re);else if(typeof re=="string")Fe=A.URI.revive(await yt.createNotebookDocument({viewType:re,content:fe}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(re,fe,Fe){return gi.onDidSaveNotebookDocument(re,fe,Fe)},onDidChangeNotebookDocument(re,fe,Fe){return gi.onDidChangeNotebookDocument(re,fe,Fe)},onWillSaveNotebookDocument(re,fe,Fe){return Ai.getOnWillSaveNotebookDocumentEvent(Ue)(re,fe,Fe)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(re,fe,Fe,ot){return yt.registerNotebookSerializer(Ue,re,fe,Fe,(0,We.isProposedApiEnabled)(Ue,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(re,fe,Fe)=>$i.onDidChangeConfiguration(re,fe,Fe),getConfiguration(re,fe){return fe=arguments.length===1?void 0:fe,$i.getConfiguration(re,fe,Ue)},registerTextDocumentContentProvider(re,fe){return Ti.registerTextDocumentContentProvider(re,fe)},registerTaskProvider:(re,fe)=>(Be.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Ut.registerTaskProvider(Ue,re,fe)),registerFileSystemProvider(re,fe,Fe){return(0,Xe.combinedDisposable)(Ri.registerFileSystemProvider(Ue,re,fe,Fe),Nt.addFileSystemProvider(re,fe))},get fs(){return Nt.value},registerFileSearchProvider:(re,fe)=>((0,We.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Rt.registerFileSearchProvider(re,fe)),registerTextSearchProvider:(re,fe)=>((0,We.checkProposedApiEnabled)(Ue,"textSearchProvider"),Rt.registerTextSearchProvider(re,fe)),registerRemoteAuthorityResolver:(re,fe)=>((0,We.checkProposedApiEnabled)(Ue,"resolvers"),It.registerRemoteAuthorityResolver(re,fe)),registerResourceLabelFormatter:re=>((0,We.checkProposedApiEnabled)(Ue,"resolvers"),Li.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,fe,Fe)=>Xt.onDidCreateFile(re,fe,Fe),onDidDeleteFiles:(re,fe,Fe)=>Xt.onDidDeleteFile(re,fe,Fe),onDidRenameFiles:(re,fe,Fe)=>Xt.onDidRenameFile(re,fe,Fe),onWillCreateFiles:(re,fe,Fe)=>Xt.getOnWillCreateFileEvent(Ue)(re,fe,Fe),onWillDeleteFiles:(re,fe,Fe)=>Xt.getOnWillDeleteFileEvent(Ue)(re,fe,Fe),onWillRenameFiles:(re,fe,Fe)=>Xt.getOnWillRenameFileEvent(Ue)(re,fe,Fe),openTunnel:re=>((0,We.checkProposedApiEnabled)(Ue,"tunnels"),Oe.openTunnel(Ue,re).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,We.checkProposedApiEnabled)(Ue,"tunnels"),Oe.getTunnels()},onDidChangeTunnels:(re,fe,Fe)=>((0,We.checkProposedApiEnabled)(Ue,"tunnels"),Oe.onDidChangeTunnels(re,fe,Fe)),registerPortAttributesProvider:(re,fe)=>((0,We.checkProposedApiEnabled)(Ue,"portsAttributes"),Oe.registerPortsAttributesProvider(re,fe)),registerTimelineProvider:(re,fe)=>((0,We.checkProposedApiEnabled)(Ue,"timeline"),Mi.registerTimelineProvider(re,fe,Ue.identifier,dt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:re=>((0,We.checkProposedApiEnabled)(Ue,"workspaceTrust"),ht.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,fe,Fe)=>ht.onDidGrantWorkspaceTrust(re,fe,Fe),registerEditSessionIdentityProvider:(re,fe)=>((0,We.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(re,fe)),onWillCreateEditSessionIdentity:(re,fe,Fe)=>((0,We.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Ue)(re,fe,Fe))},ji={get inputBox(){return Be.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Ei.getLastInputBox(Ue)},createSourceControl(re,fe,Fe){return Ei.createSourceControl(Ue,re,fe,Fe)}},rn={createCommentController(re,fe){return Fi.createCommentController(Ue,re,fe)}},qi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},get stackFrameFocus(){return ut.stackFrameFocus},onDidStartDebugSession(re,fe,Fe){return ut.onDidStartDebugSession(re,fe,Fe)},onDidTerminateDebugSession(re,fe,Fe){return ut.onDidTerminateDebugSession(re,fe,Fe)},onDidChangeActiveDebugSession(re,fe,Fe){return ut.onDidChangeActiveDebugSession(re,fe,Fe)},onDidReceiveDebugSessionCustomEvent(re,fe,Fe){return ut.onDidReceiveDebugSessionCustomEvent(re,fe,Fe)},onDidChangeBreakpoints(re,fe,Fe){return ut.onDidChangeBreakpoints(re,fe,Fe)},onDidChangeStackFrameFocus(re,fe,Fe){return(0,We.checkProposedApiEnabled)(Ue,"debugFocus"),ut.onDidChangeStackFrameFocus(re,fe,Fe)},registerDebugConfigurationProvider(re,fe,Fe){return ut.registerDebugConfigurationProvider(re,fe,Fe||it.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,fe){return ut.registerDebugAdapterDescriptorFactory(Ue,re,fe)},registerDebugAdapterTrackerFactory(re,fe){return ut.registerDebugAdapterTrackerFactory(re,fe)},startDebugging(re,fe,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ut.startDebugging(re,fe,{parentSession:Fe}):ut.startDebugging(re,fe,Fe||{})},stopDebugging(re){return ut.stopDebugging(re)},addBreakpoints(re){return ut.addBreakpoints(re)},removeBreakpoints(re){return ut.removeBreakpoints(re)},asDebugSourceUri(re,fe){return ut.asDebugSourceUri(re,fe)}},Ki={registerTaskProvider:(re,fe)=>Ut.registerTaskProvider(Ue,re,fe),fetchTasks:re=>Ut.fetchTasks(re),executeTask:re=>Ut.executeTask(Ue,re),get taskExecutions(){return Ut.taskExecutions},onDidStartTask:(re,fe,Fe)=>Ut.onDidStartTask(re,fe,Fe),onDidEndTask:(re,fe,Fe)=>Ut.onDidEndTask(re,fe,Fe),onDidStartTaskProcess:(re,fe,Fe)=>Ut.onDidStartTaskProcess(re,fe,Fe),onDidEndTaskProcess:(re,fe,Fe)=>Ut.onDidEndTaskProcess(re,fe,Fe)},sn={createNotebookController(re,fe,Fe,ot,_t){return Ht.createNotebookController(Ue,re,fe,Fe,ot,(0,We.isProposedApiEnabled)(Ue,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(re,fe)=>yt.registerNotebookCellStatusBarItemProvider(Ue,re,fe),createRendererMessaging(re){return Pi.createRendererMessaging(Ue,re)},createNotebookControllerDetectionTask(re){return(0,We.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Ht.createNotebookControllerDetectionTask(Ue,re)},registerKernelSourceActionProvider(re,fe){return(0,We.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Ht.registerKernelSourceActionProvider(Ue,re,fe)},onDidChangeNotebookCellExecutionState(re,fe,Fe){return(0,We.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Ht.onDidChangeNotebookCellExecutionState(re,fe,Fe)}},on={t(...re){if(typeof re[0]=="string"){const fe=re.shift(),Fe=!re||typeof re[0]!="object"?re:re[0];return ri.getMessage(Ue.identifier.value,{message:fe,args:Fe})}return ri.getMessage(Ue.identifier.value,re[0])},get bundle(){return ri.getBundle(Ue.identifier.value)},get uri(){return ri.getBundleUri(Ue.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(re){return(0,We.checkProposedApiEnabled)(Ue,"interactive"),zi.registerProvider(Ue,re)},registerInteractiveSessionProvider(re,fe){return(0,We.checkProposedApiEnabled)(Ue,"interactive"),ui.registerInteractiveSessionProvider(Ue,re,fe)},addInteractiveRequest(re){return(0,We.checkProposedApiEnabled)(Ue,"interactive"),ui.addInteractiveSessionRequest(re)},sendInteractiveRequestToProvider(re,fe){return(0,We.checkProposedApiEnabled)(Ue,"interactive"),ui.sendInteractiveRequestToProvider(re,fe)},get onDidPerformUserAction(){return ui.onDidPerformUserAction}},Xi={registerSemanticSimilarityProvider(re){return(0,We.checkProposedApiEnabled)(Ue,"semanticSimilarity"),Zi.registerSemanticSimilarityProvider(Ue,re)}};return{version:gt.version,ai:Xi,authentication:Wi,commands:Qt,comments:rn,debug:qi,env:oi,extensions:fi,interactive:Gi,l10n:on,languages:Hi,notebooks:sn,scm:ji,tasks:Ki,tests:nn,window:Vi,workspace:Di,Breakpoint:H.Breakpoint,TerminalOutputAnchor:H.TerminalOutputAnchor,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentState:H.CommentState,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:it.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileDecoration2:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestionList,Hover:H.Hover,IndentAction:h.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalQuickFixCommand:H.TerminalQuickFixCommand,TerminalQuickFixOpener:H.TerminalQuickFixOpener,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TerminalExitReason:H.TerminalExitReason,TerminalQuickFixType:H.TerminalQuickFixType,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,SnippetTextEdit:H.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItem2:H.TreeItem,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:_.UIKind,Uri:A.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,DocumentDropEdit:H.DocumentDropEdit,DocumentPasteEdit:H.DocumentPasteEdit,InlayHint:H.InlayHint,InlayHintLabelPart:H.InlayHintLabelPart,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.NotebookEdit,NotebookKernelSourceAction:H.NotebookKernelSourceAction,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestRunRequest2:H.TestRunRequest2,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Me.TextSearchCompleteMessageType,DataTransfer:H.DataTransfer,DataTransferItem:H.DataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.TextTabInput,TabInputTextDiff:H.TextDiffTabInput,TabInputTextMerge:H.TextMergeTabInput,TabInputCustom:H.CustomEditorTabInput,TabInputNotebook:H.NotebookEditorTabInput,TabInputNotebookDiff:H.NotebookDiffEditorTabInput,TabInputWebview:H.WebviewEditorTabInput,TabInputTerminal:H.TerminalEditorTabInput,TabInputInteractiveWindow:H.InteractiveWindowInput,TelemetryTrustedValue:Q.TelemetryTrustedValue,LogLevel:ye.LogLevel,EditSessionIdentityMatch:St.EditSessionIdentityMatch,InteractiveSessionVoteDirection:H.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:H.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:H.InteractiveEditorResponseFeedbackKind}}}e.createApiFactoryAndRegisterActors=Tt}),define(Te[265],Pe([1,0,69,108,32,106,33,38,59,62,110,112,113,81,72,78,107,61,37,80,57,60,233,14,111,79]),function(te,e,n,T,D,F,A,P,S,h,R,b,g,_,p,u,t,o,d,y,k,v,i,a,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,n.registerSingleton)(a.ILoggerService,i.ExtHostLoggerService,1),(0,n.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,0),(0,n.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration,0),(0,n.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService,0),(0,n.registerSingleton)(F.IExtHostDecorations,F.ExtHostDecorations,0),(0,n.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,1),(0,n.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch,0),(0,n.registerSingleton)(_.IExtHostStorage,_.ExtHostStorage,0),(0,n.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,n.registerSingleton)(h.IExtHostTerminalService,h.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService,0),(0,n.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,n.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,0),(0,n.registerSingleton)(y.IExtHostSecretState,y.ExtHostSecretState,0),(0,n.registerSingleton)(k.IExtHostTelemetry,k.ExtHostTelemetry,0),(0,n.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,n.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(Te[266],Pe([1,0,264,34,2,261,7,17,252]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends F.RequireInterceptor{_installInterceptor(){}getModule(_,p){for(const u of this._alternatives){const t=u(_);if(t){_=t;break}}if(this._factories.has(_))return this._factories.get(_).load(_,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(S.ExtHostConsoleForwarder);const _=this._instaService.invokeFunction(n.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(h,_,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(_){return _.browser}async _loadCommonJSModule(_,p,u){p=p.with({path:b(p.path,".js")});const t=_?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const o=D.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(p)),d=await fetch(o.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),d.status!==200)throw new Error(d.statusText);const y=await d.text(),k=`${p.toString(!0)}#vscode-extension`,v=`${y}
//# sourceURL=${k}`;let i;try{i=new Function("module","exports","require",v)}catch(w){throw console.error(t?`Loading code for extension ${t} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${p.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}_&&await this._extHostLocalizationService.initializeLocalizedMessages(_);const a={},r={exports:a},s=w=>{const I=this._fakeModules.getModule(w,p);if(I===void 0)throw new Error(`Cannot load module '${w}'`);return I};try{return u.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),i(r,a,s),r.exports!==a?r.exports:a}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),u.codeLoadingStop()}}async $setRemoteEnvironment(_){}async _waitForDebuggerAttachment(_=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+_;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,P.timeout)(10)}}e.ExtHostExtensionService=R;function b(g,_){return g.endsWith(_)?g:g+_}}),define(Te[267],Pe([1,0,68,69,14,34,185,82,266]),function(te,e,n,T,D,F,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.registerSingleton)(D.ILogService,new n.SyncDescriptor(A.ExtHostLogService,[!0],!0)),(0,T.registerSingleton)(F.IExtHostExtensionService,S.ExtHostExtensionService,0),(0,T.registerSingleton)(P.IExtensionStoragePaths,P.ExtensionStoragePaths,0)}),define(Te[275],Pe([1,0,25,5,76,262,254,19,83,15,2,265,267]),function(te,e,n,T,D,F,A,P,S,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const g=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function _(i){return/^(file|vscode-remote):/i.test(i)}const p=fetch.bind(self);function u(i){self.fetch=async function(a,r){return a instanceof Request||_(String(a))&&(a=(await i(R.URI.parse(String(a)))).toString(!0)),p(a,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,r,s,w,I){(async()=>(_(r.toString())&&(r=(await i(R.URI.parse(r.toString()))).toString(!0)),super.open(a,r,s??!0,w,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(a,r){if(/^file:/i.test(a.toString()))a=h.FileAccess.uriToBrowserUri(R.URI.parse(a.toString())).toString(!0);else if(/^vscode-remote:/i.test(a.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(m){function E(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const f=fetch.bind(self);self.fetch=function(W,J){return W instanceof Request?f(W,J):f(E(W),J)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,J,q,U,B){return super.open(W,E(J),q??!0,U,B)}};const L=importScripts.bind(self);self.importScripts=(...W)=>{L(...W.map(E))},L(m)}.toString()}('${a}'))`;r=r||{},r.name=r.name||P.basename(a.toString());const I=new Blob([w],{type:"application/javascript"}),c=URL.createObjectURL(I);return new i(c,r)}}else self.Worker=class extends A.NestedWorker{constructor(i,a){super(g,i,{name:P.basename(i.toString()),...a})}};const t=new class{constructor(){this.pid=void 0}exit(i){b()}async exists(i){return!0}async realpath(i){return i}};class o{constructor(){const a=new MessageChannel,r=new T.Emitter;let s=!1;g(a.port2,[a.port2]),a.port1.onmessage=w=>{const{data:I}=w;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const c=n.VSBuffer.wrap(new Uint8Array(I,0,I.byteLength));if((0,D.isMessageOfType)(c,2)){s=!0,y("received terminate message from renderer");return}r.fire(c)},this.protocol={onMessage:r.event,send:w=>{if(!s){const I=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);a.port1.postMessage(I,[I])}}}}}function d(i){return new Promise(a=>{const r=i.onMessage(s=>{r.dispose();const w=JSON.parse(s.toString());i.send((0,D.createMessageOfType)(0)),a({protocol:i,initData:w})});i.send((0,D.createMessageOfType)(1))})}let y=i=>b();function k(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function v(){S.mark("code/extHost/willConnectToRenderer");const i=new o;return{onmessage(a){k(a)&&d(i.protocol).then(r=>{S.mark("code/extHost/didWaitForInitData");const s=new F.ExtensionHostMain(r.protocol,r.initData,t,null,a.data);u(w=>s.asBrowserUri(w)),y=w=>s.terminate(w)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e06ea6147733c975d26c3d3552462681e05cb147/core/vs/workbench/api/worker/extensionHostWorker.js.map
