/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var W=["require","exports","vs/base/common/lifecycle","vs/base/common/observableImpl/logging","vs/base/common/errors","vs/base/common/platform","vs/base/common/observableImpl/base","vs/editor/common/tokens/lineTokens","vs/base/common/observableImpl/autorun","vs/base/common/observableImpl/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/uri","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/observableImpl/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/workbench/services/textMate/browser/worker/textMateWorkerModel","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/base/common/stopwatch","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vscode-textmate","vs/workbench/services/textMate/browser/worker/textMate.worker"],q=function(U){for(var e=[],S=0,E=U.length;S<E;S++)e[S]=W[U[S]];return e};define(W[3],q([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let S;function E(o){S=o}e.setLogger=E;function v(){return S}e.getLogger=v;class L{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(h){return n([c(k("|  ",this.indentation)),h])}formatInfo(h){return h.didChange?[c(" "),i(r(h.oldValue,70),{color:"red",strikeThrough:!0}),c(" "),i(r(h.newValue,60),{color:"green"})]:[c(" (unchanged)")]}handleObservableChanged(h,O){console.log(...this.textToConsoleArgs([t("observable value changed"),i(h.debugName,{color:"BlueViolet"}),...this.formatInfo(O)]))}formatChanges(h){if(h.size!==0)return i(" (changed deps: "+[...h].map(O=>O.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(h){const O=h.handleChange;this.changedObservablesSets.set(h,new Set),h.handleChange=(I,M)=>(this.changedObservablesSets.get(h).add(I),O.apply(h,[I,M]))}handleDerivedRecomputed(h,O){const I=this.changedObservablesSets.get(h);console.log(...this.textToConsoleArgs([t("derived recomputed"),i(h.debugName,{color:"BlueViolet"}),...this.formatInfo(O),this.formatChanges(I)])),I.clear()}handleFromEventObservableTriggered(h,O){console.log(...this.textToConsoleArgs([t("observable from event triggered"),i(h.debugName,{color:"BlueViolet"}),...this.formatInfo(O)]))}handleAutorunCreated(h){const O=h.handleChange;this.changedObservablesSets.set(h,new Set),h.handleChange=(I,M)=>(this.changedObservablesSets.get(h).add(I),O.apply(h,[I,M]))}handleAutorunTriggered(h){const O=this.changedObservablesSets.get(h);console.log(...this.textToConsoleArgs([t("autorun"),i(h.debugName,{color:"BlueViolet"}),this.formatChanges(O)])),O.clear()}handleBeginTransaction(h){let O=h.getDebugName();O===void 0&&(O=""),console.log(...this.textToConsoleArgs([t("transaction"),i(O,{color:"BlueViolet"})])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=L;function n(o){const h=new Array,I={};let M="";function p(f){if("length"in f)for(const m of f)m&&p(m);else"text"in f?(M+=`%c${f.text}`,h.push(f.style),f.data&&Object.assign(I,f.data)):"data"in f&&Object.assign(I,f.data)}p(o);const w=[M,...h];return Object.keys(I).length>0&&w.push(I),w}function c(o){return i(o,{color:"black"})}function t(o){return i(u(`${o}: `,10),{color:"black",bold:!0})}function i(o,h={color:"black"}){function O(M){return Object.entries(M).reduce((p,[w,f])=>`${p}${w}:${f};`,"")}const I={color:h.color};return h.strikeThrough&&(I["text-decoration"]="line-through"),h.bold&&(I["font-weight"]="bold"),{text:o,style:O(I)}}function r(o,h){switch(typeof o){case"number":return""+o;case"string":return o.length+2<=h?`"${o}"`:`"${o.substr(0,h-7)}"+...`;case"boolean":return o?"true":"false";case"undefined":return"undefined";case"object":return o===null?"null":Array.isArray(o)?s(o,h):b(o,h);case"symbol":return o.toString();case"function":return`[[Function${o.name?" "+o.name:""}]]`;default:return""+o}}function s(o,h){let O="[ ",I=!0;for(const M of o){if(I||(O+=", "),O.length-5>h){O+="...";break}I=!1,O+=`${r(M,h-O.length)}`}return O+=" ]",O}function b(o,h){let O="{ ",I=!0;for(const[M,p]of Object.entries(o)){if(I||(O+=", "),O.length-5>h){O+="...";break}I=!1,O+=`${M}: ${r(p,h-O.length)}`}return O+=" }",O}function k(o,h){let O="";for(let I=1;I<=h;I++)O+=o;return O}function u(o,h){for(;o.length<h;)o+=" ";return o}}),define(W[8],q([0,1,2,3]),function(U,e,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunHandleChanges=e.autorun=void 0;function v(r,s){return new t(r,s,void 0)}e.autorun=v;function L(r,s,b){return new t(r,b,s.handleChange)}e.autorunHandleChanges=L;function n(r,s){const b=new S.DisposableStore,k=v(s,u=>{b.clear(),r(u,b)});return(0,S.toDisposable)(()=>{k.dispose(),b.dispose()})}e.autorunWithStore=n;var c;(function(r){r[r.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",r[r.stale=2]="stale",r[r.upToDate=3]="upToDate"})(c||(c={}));class t{constructor(s,b,k){this.debugName=s,this.runFn=b,this._handleChange=k,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,(0,E.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded()}dispose(){this.disposed=!0;for(const s of this.dependencies)s.removeObserver(this);this.dependencies.clear()}_runIfNeeded(){if(this.state===3)return;const s=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=s,this.state=3,(0,E.getLogger)()?.handleAutorunTriggered(this);try{this.runFn(this)}finally{for(const b of this.dependenciesToBeRemoved)b.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const s of this.dependencies)if(s.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--}handlePossibleChange(s){this.state===3&&this.dependencies.has(s)&&(this.state=1)}handleChange(s,b){this.dependencies.has(s)&&(!this._handleChange||this._handleChange({changedObservable:s,change:b,didChange:u=>u===s}))&&(this.state=2)}readObservable(s){if(this.disposed)return s.get();s.addObserver(this);const b=s.get();return this.dependencies.add(s),this.dependenciesToBeRemoved.delete(s),b}}e.AutorunObserver=t,function(r){r.Observer=t}(v||(e.autorun=v={}));function i(r,s,b){let k;return v(r,u=>{const o=s.read(u),h=k;k=o,b({lastValue:h,newValue:o})})}e.autorunDelta=i}),define(W[6],q([0,1,3]),function(U,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.getFunctionName=e.TransactionImpl=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerived=void 0;let E;function v(u){E=u}e._setDerived=v;class L{get TChange(){return null}reportChanges(){this.get()}read(o){return o?o.readObservable(this):this.get()}map(o){return E(()=>{const h=i(o);return h!==void 0?h:`${this.debugName} (mapped)`},h=>o(this.read(h),h))}}e.ConvenientObservable=L;class n extends L{constructor(){super(...arguments),this.observers=new Set}addObserver(o){const h=this.observers.size;this.observers.add(o),h===0&&this.onFirstObserverAdded()}removeObserver(o){this.observers.delete(o)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=n;function c(u,o){const h=new t(u,o);try{(0,S.getLogger)()?.handleBeginTransaction(h),u(h)}finally{h.finish(),(0,S.getLogger)()?.handleEndTransaction()}}e.transaction=c;class t{constructor(o,h){this.fn=o,this._getDebugName=h,this.updatingObservers=[]}getDebugName(){return this._getDebugName?this._getDebugName():i(this.fn)}updateObserver(o,h){this.updatingObservers.push({observer:o,observable:h}),o.beginUpdate(h)}finish(){const o=this.updatingObservers;this.updatingObservers=null;for(const{observer:h,observable:O}of o)h.endUpdate(O)}}e.TransactionImpl=t;function i(u){const o=u.toString(),O=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(o);return(O?O[1]:void 0)?.trim()}e.getFunctionName=i;function r(u,o){return new s(u,o)}e.observableValue=r;class s extends n{constructor(o,h){super(),this.debugName=o,this._value=h}get(){return this._value}set(o,h,O){if(this._value===o)return;let I;h||(h=I=new t(()=>{},()=>`Setting ${this.debugName}`));try{const M=this._value;this._setValue(o),(0,S.getLogger)()?.handleObservableChanged(this,{oldValue:M,newValue:o,change:O,didChange:!0});for(const p of this.observers)h.updateObserver(p,this),p.handleChange(this,O)}finally{I&&I.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(o){this._value=o}}e.ObservableValue=s;function b(u,o){return new k(u,o)}e.disposableObservableValue=b;class k extends s{_setValue(o){this._value!==o&&(this._value&&this._value.dispose(),this._value=o)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=k}),define(W[9],q([0,1,4,6,3]),function(U,e,S,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derived=void 0;function L(t,i){return new c(t,i)}e.derived=L,(0,E._setDerived)(L);var n;(function(t){t[t.initial=0]="initial",t[t.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",t[t.stale=2]="stale",t[t.upToDate=3]="upToDate"})(n||(n={}));class c extends E.BaseObservable{get debugName(){return typeof this._debugName=="function"?this._debugName():this._debugName}constructor(i,r){super(),this._debugName=i,this.computeFn=r,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,(0,v.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const i of this.dependencies)i.removeObserver(this);this.dependencies.clear()}get(){if(this.observers.size===0){const i=this.computeFn(this);return this.onLastObserverRemoved(),i}else{do{if(this.state===1){this.state=3;for(const i of this.dependencies)if(i.reportChanges(),this.state===2)break}this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const i=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=i;const r=this.state!==0,s=this.value;this.state=3;try{this.value=this.computeFn(this)}finally{for(const k of this.dependenciesToBeRemoved)k.removeObserver(this);this.dependenciesToBeRemoved.clear()}const b=r&&s!==this.value;if((0,v.getLogger)()?.handleDerivedRecomputed(this,{oldValue:s,newValue:this.value,change:void 0,didChange:b}),b)for(const k of this.observers)k.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(){this.updateCount++;const i=this.updateCount===1;if(this.state===3&&(this.state=1,!i))for(const r of this.observers)r.handlePossibleChange(this);if(i)for(const r of this.observers)r.beginUpdate(this)}endUpdate(){if(this.updateCount--,this.updateCount===0){const i=[...this.observers];for(const r of i)r.endUpdate(this)}if(this.updateCount<0)throw new S.BugIndicatingError}handlePossibleChange(i){if(this.state===3&&this.dependencies.has(i)){this.state=1;for(const r of this.observers)r.handlePossibleChange(this)}}handleChange(i,r){const s=this.state===3;if((this.state===1||s)&&this.dependencies.has(i)&&(this.state=2,s))for(const b of this.observers)b.handlePossibleChange(this)}readObservable(i){i.addObserver(this);const r=i.get();return this.dependencies.add(i),this.dependenciesToBeRemoved.delete(i),r}}e.Derived=c}),define(W[20],q([0,1,2,8,6,9,3]),function(U,e,S,E,v,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.keepAlive=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function c(m){return new t(m)}e.constObservable=c;class t extends v.ConvenientObservable{constructor(_){super(),this.value=_}get debugName(){return this.toString()}get(){return this.value}addObserver(_){}removeObserver(_){}toString(){return`Const: ${this.value}`}}function i(m){const _=(0,v.observableValue)("promiseValue",{});return m.then(P=>{_.set({value:P},void 0)}),_}e.observableFromPromise=i;function r(m,_){return new Promise(P=>{let A=!1,d=!1;const g=(0,E.autorun)("waitForState",l=>{const C=m.read(l);_(C)&&(A?g.dispose():d=!0,P(C))});A=!0,d&&g.dispose()})}e.waitForState=r;function s(m,_){return new b(m,_)}e.observableFromEvent=s;class b extends v.BaseObservable{constructor(_,P){super(),this.event=_,this.getValue=P,this.hasValue=!1,this.handleEvent=A=>{const d=this.getValue(A),g=!this.hasValue||this.value!==d;(0,n.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:this.value,newValue:d,change:void 0,didChange:g}),g&&(this.value=d,this.hasValue&&(0,v.transaction)(l=>{for(const C of this.observers)l.updateObserver(C,this),C.handleChange(this,void 0)},()=>{const l=this.getDebugName();return"Event fired"+(l?`: ${l}`:"")}),this.hasValue=!0)}}getDebugName(){return(0,v.getFunctionName)(this.getValue)}get debugName(){const _=this.getDebugName();return"From Event"+(_?`: ${_}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this.getValue(void 0)}}e.FromEventObservable=b,function(m){m.Observer=b}(s||(e.observableFromEvent=s={}));function k(m,_){return new u(m,_)}e.observableSignalFromEvent=k;class u extends v.BaseObservable{constructor(_,P){super(),this.debugName=_,this.event=P,this.handleEvent=()=>{(0,v.transaction)(A=>{for(const d of this.observers)A.updateObserver(d,this),d.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function o(m){return new h(m)}e.observableSignal=o;class h extends v.BaseObservable{constructor(_){super(),this.debugName=_}trigger(_,P){if(!_){(0,v.transaction)(A=>{this.trigger(A,P)},()=>`Trigger signal ${this.debugName}`);return}for(const A of this.observers)_.updateObserver(A,this),A.handleChange(this,P)}get(){}}function O(m,_,P){const A=(0,v.observableValue)("debounced",void 0);let d;return P.add((0,E.autorun)("debounce",g=>{const l=m.read(g);d&&clearTimeout(d),d=setTimeout(()=>{(0,v.transaction)(C=>{A.set(l,C)})},_)})),A}e.debouncedObservable=O;function I(m,_,P){const A=(0,v.observableValue)("triggeredRecently",!1);let d;return P.add(m(()=>{A.set(!0,void 0),d&&clearTimeout(d),d=setTimeout(()=>{A.set(!1,void 0)},_)})),A}e.wasEventTriggeredRecently=I;function M(m){const _=new p;return m.addObserver(_),(0,S.toDisposable)(()=>{m.removeObserver(_)})}e.keepAlive=M;class p{beginUpdate(_){}endUpdate(_){}handlePossibleChange(_){}handleChange(_,P){}}function w(m,_){let P;return(0,L.derived)(m,d=>(P=_(d,P),P))}e.derivedObservableWithCache=w;function f(m,_){let P;const A=(0,v.observableValue)("derivedObservableWithWritableCache.counter",0),d=(0,L.derived)(m,g=>(A.read(g),P=_(g,P),P));return Object.assign(d,{clearCache:g=>{P=void 0,A.set(A.get()+1,g)}})}e.derivedObservableWithWritableCache=f});var ee=this&&this.__createBinding||(Object.create?function(U,e,S,E){E===void 0&&(E=S);var v=Object.getOwnPropertyDescriptor(e,S);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[S]}}),Object.defineProperty(U,E,v)}:function(U,e,S,E){E===void 0&&(E=S),U[E]=e[S]}),te=this&&this.__exportStar||function(U,e){for(var S in U)S!=="default"&&!Object.prototype.hasOwnProperty.call(e,S)&&ee(e,U,S)};define(W[10],q([0,1,6,9,8,20,3]),function(U,e,S,E,v,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derived=e.transaction=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return S.observableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return S.transaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return E.derived}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.autorunWithStore}}),te(L,e),!1&&(0,n.setLogger)(new n.ConsoleObservableLogger)}),define(W[21],q([0,1,4,2]),function(U,e,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function v(p){const w=p;return w?typeof w.read=="function":!1}e.isReadable=v;function L(p){const w=p;return w?[w.on,w.pause,w.resume,w.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=L;function n(p){const w=p;return w?L(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=n;function c(p,w){return new t(p,w)}e.newWriteableStream=c;class t{constructor(w,f){this.reducer=w,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(f=>f(w))}emitError(w){this.listeners.error.length===0?(0,S.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(f=>f(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,f){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(w,f){if(this.state.destroyed)return;let m;switch(w){case"data":m=this.listeners.data;break;case"end":m=this.listeners.end;break;case"error":m=this.listeners.error;break}if(m){const _=m.indexOf(f);_>=0&&m.splice(_,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(m=>m())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function i(p,w){const f=[];let m;for(;(m=p.read())!==null;)f.push(m);return w(f)}e.consumeReadable=i;function r(p,w,f){const m=[];let _;for(;(_=p.read())!==null&&m.length<f;)m.push(_);return _===null&&m.length>0?w(m):{read:()=>{if(m.length>0)return m.shift();if(typeof _<"u"){const P=_;return _=void 0,P}return p.read()}}}e.peekReadable=r;function s(p,w){return new Promise((f,m)=>{const _=[];b(p,{onData:P=>{w&&_.push(P)},onError:P=>{w?m(P):f(void 0)},onEnd:()=>{f(w?w(_):void 0)}})})}e.consumeStream=s;function b(p,w){let f=!1;return p.on("error",m=>{f||w.onError(m)}),p.on("end",()=>{f||w.onEnd()}),p.on("data",m=>{f||w.onData(m)}),(0,E.toDisposable)(()=>f=!0)}e.listenStream=b;function k(p,w){return new Promise((f,m)=>{const _=new E.DisposableStore,P=[],A=l=>{if(P.push(l),P.length>w)return _.dispose(),p.pause(),f({stream:p,buffer:P,ended:!1})},d=l=>m(l),g=()=>f({stream:p,buffer:P,ended:!0});_.add((0,E.toDisposable)(()=>p.removeListener("error",d))),p.on("error",d),_.add((0,E.toDisposable)(()=>p.removeListener("end",g))),p.on("end",g),_.add((0,E.toDisposable)(()=>p.removeListener("data",A))),p.on("data",A)})}e.peekStream=k;function u(p,w){const f=c(w);return f.end(p),f}e.toStream=u;function o(){const p=c(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=o;function h(p){let w=!1;return{read:()=>w?null:(w=!0,p)}}e.toReadable=h;function O(p,w,f){const m=c(f);return b(p,{onData:_=>m.write(w.data(_)),onError:_=>m.error(w.error?w.error(_):_),onEnd:()=>m.end()}),m}e.transform=O;function I(p,w,f){let m=!1;return{read:()=>{const _=w.read();return m?_:(m=!0,_!==null?f([p,_]):p)}}}e.prefixedReadable=I;function M(p,w,f){let m=!1;const _=c(f);return b(w,{onData:P=>m?_.write(P):(m=!0,_.write(f([p,P]))),onError:P=>_.error(P),onEnd:()=>{m||(m=!0,_.write(p)),_.end()}}),_}e.prefixedStream=M}),define(W[11],q([0,1,21]),function(U,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const E=typeof Buffer<"u";let v,L;class n{static alloc(l){return E?new n(Buffer.allocUnsafe(l)):new n(new Uint8Array(l))}static wrap(l){return E&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new n(l)}static fromString(l,C){return!(C?.dontUseNodeBuffer||!1)&&E?new n(Buffer.from(l)):(v||(v=new TextEncoder),new n(v.encode(l)))}static fromByteArray(l){const C=n.alloc(l.length);for(let D=0,z=l.length;D<z;D++)C.buffer[D]=l[D];return C}static concat(l,C){if(typeof C>"u"){C=0;for(let F=0,G=l.length;F<G;F++)C+=l[F].byteLength}const D=n.alloc(C);let z=0;for(let F=0,G=l.length;F<G;F++){const j=l[F];D.set(j,z),z+=j.byteLength}return D}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=n.alloc(this.byteLength);return l.set(this),l}toString(){return E?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(l,C){return new n(this.buffer.subarray(l,C))}set(l,C){if(l instanceof n)this.buffer.set(l.buffer,C);else if(l instanceof Uint8Array)this.buffer.set(l,C);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),C);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return i(this.buffer,l)}writeUInt32BE(l,C){r(this.buffer,l,C)}readUInt32LE(l){return s(this.buffer,l)}writeUInt32LE(l,C){b(this.buffer,l,C)}readUInt8(l){return k(this.buffer,l)}writeUInt8(l,C){u(this.buffer,l,C)}}e.VSBuffer=n;function c(g,l){return g[l+0]<<0>>>0|g[l+1]<<8>>>0}e.readUInt16LE=c;function t(g,l,C){g[C+0]=l&255,l=l>>>8,g[C+1]=l&255}e.writeUInt16LE=t;function i(g,l){return g[l]*2**24+g[l+1]*2**16+g[l+2]*2**8+g[l+3]}e.readUInt32BE=i;function r(g,l,C){g[C+3]=l,l=l>>>8,g[C+2]=l,l=l>>>8,g[C+1]=l,l=l>>>8,g[C]=l}e.writeUInt32BE=r;function s(g,l){return g[l+0]<<0>>>0|g[l+1]<<8>>>0|g[l+2]<<16>>>0|g[l+3]<<24>>>0}e.readUInt32LE=s;function b(g,l,C){g[C+0]=l&255,l=l>>>8,g[C+1]=l&255,l=l>>>8,g[C+2]=l&255,l=l>>>8,g[C+3]=l&255}e.writeUInt32LE=b;function k(g,l){return g[l]}e.readUInt8=k;function u(g,l,C){g[C]=l}e.writeUInt8=u;function o(g){return S.consumeReadable(g,l=>n.concat(l))}e.readableToBuffer=o;function h(g){return S.toReadable(g)}e.bufferToReadable=h;function O(g){return S.consumeStream(g,l=>n.concat(l))}e.streamToBuffer=O;async function I(g){return g.ended?n.concat(g.buffer):n.concat([...g.buffer,await O(g.stream)])}e.bufferedStreamToBuffer=I;function M(g){return S.toStream(g,l=>n.concat(l))}e.bufferToStream=M;function p(g){return S.transform(g,{data:l=>typeof l=="string"?n.fromString(l):n.wrap(l)},l=>n.concat(l))}e.streamToBufferReadableStream=p;function w(g){return S.newWriteableStream(l=>n.concat(l),g)}e.newWriteableBufferStream=w;function f(g,l){return S.prefixedReadable(g,l,C=>n.concat(C))}e.prefixedBufferReadable=f;function m(g,l){return S.prefixedStream(g,l,C=>n.concat(C))}e.prefixedBufferStream=m;function _(g){let l=0,C=0,D=0;const z=new Uint8Array(Math.floor(g.length/4*3)),F=j=>{switch(C){case 3:z[D++]=l|j,C=0;break;case 2:z[D++]=l|j>>>2,l=j<<6,C=3;break;case 1:z[D++]=l|j>>>4,l=j<<4,C=2;break;default:l=j<<2,C=1}};for(let j=0;j<g.length;j++){const K=g.charCodeAt(j);if(K>=65&&K<=90)F(K-65);else if(K>=97&&K<=122)F(K-97+26);else if(K>=48&&K<=57)F(K-48+52);else if(K===43||K===45)F(62);else if(K===47||K===95)F(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${g[j]}`)}}const G=D;for(;C>0;)F(0);return n.wrap(z).slice(0,G)}e.decodeBase64=_;const P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:g},l=!0,C=!1){const D=C?A:P;let z="";const F=g.byteLength%3;let G=0;for(;G<g.byteLength-F;G+=3){const j=g[G+0],K=g[G+1],Q=g[G+2];z+=D[j>>>2],z+=D[(j<<4|K>>>4)&63],z+=D[(K<<2|Q>>>6)&63],z+=D[Q&63]}if(F===1){const j=g[G+0];z+=D[j>>>2],z+=D[j<<4&63],l&&(z+="==")}else if(F===2){const j=g[G+0],K=g[G+1];z+=D[j>>>2],z+=D[(j<<4|K>>>4)&63],z+=D[K<<2&63],l&&(z+="=")}return z}e.encodeBase64=d}),define(W[22],q([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(W[12],q([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var S;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function E(v){let L=0,n=0,c=0,t=0;for(let i=0,r=v.length;i<r;i++){const s=v.charCodeAt(i);s===13?(L===0&&(n=i),L++,i+1<r&&v.charCodeAt(i+1)===10?(t|=2,i++):t|=3,c=i+1):s===10&&(t|=1,L===0&&(n=i),L++,c=i+1)}return L===0&&(n=v.length),[L,n,v.length-c,t]}e.countEOL=E}),define(W[13],q([0,1]),function(U,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var S;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(S||(e.LanguageId=S={}));var E;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(E||(e.FontStyle=E={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var L;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(L||(e.StandardTokenType=L={}));var n;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(n||(e.MetadataConsts=n={}));class c{static getLanguageId(i){return(i&255)>>>0}static getTokenType(i){return(i&768)>>>8}static containsBalancedBrackets(i){return(i&1024)!==0}static getFontStyle(i){return(i&30720)>>>11}static getForeground(i){return(i&16744448)>>>15}static getBackground(i){return(i&4278190080)>>>24}static getClassNameFromMetadata(i){let s="mtk"+this.getForeground(i);const b=this.getFontStyle(i);return b&1&&(s+=" mtki"),b&2&&(s+=" mtkb"),b&4&&(s+=" mtku"),b&8&&(s+=" mtks"),s}static getInlineStyleFromMetadata(i,r){const s=this.getForeground(i),b=this.getFontStyle(i);let k=`color: ${r[s]};`;b&1&&(k+="font-style: italic;"),b&2&&(k+="font-weight: bold;");let u="";return b&4&&(u+=" underline"),b&8&&(u+=" line-through"),u&&(k+=`text-decoration:${u};`),k}static getPresentationFromMetadata(i){const r=this.getForeground(i),s=this.getFontStyle(i);return{foreground:r,italic:!!(s&1),bold:!!(s&2),underline:!!(s&4),strikethrough:!!(s&8)}}}e.TokenMetadata=c}),define(W[23],q([0,1,24]),function(U,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class E{constructor(n){this._default=n,this._store=[]}get(n){return n<this._store.length?this._store[n]:this._default}set(n,c){for(;n>=this._store.length;)this._store[this._store.length]=this._default;this._store[n]=c}replace(n,c,t){if(n>=this._store.length)return;if(c===0){this.insert(n,t);return}else if(t===0){this.delete(n,c);return}const i=this._store.slice(0,n),r=this._store.slice(n+c),s=v(t,this._default);this._store=i.concat(s,r)}delete(n,c){c===0||n>=this._store.length||this._store.splice(n,c)}insert(n,c){if(c===0||n>=this._store.length)return;const t=[];for(let i=0;i<c;i++)t[i]=this._default;this._store=(0,S.arrayInsert)(this._store,n,t)}}e.FixedArray=E;function v(L,n){const c=[];for(let t=0;t<L;t++)c[t]=n;return c}}),define(W[7],q([0,1,13]),function(U,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class E{static createEmpty(n,c){const t=E.defaultTokenMetadata,i=new Uint32Array(2);return i[0]=n.length,i[1]=t,new E(i,n,c)}constructor(n,c,t){this._lineTokensBrand=void 0,this._tokens=n,this._tokensCount=this._tokens.length>>>1,this._text=c,this._languageIdCodec=t}equals(n){return n instanceof E?this.slicedEquals(n,0,this._tokensCount):!1}slicedEquals(n,c,t){if(this._text!==n._text||this._tokensCount!==n._tokensCount)return!1;const i=c<<1,r=i+(t<<1);for(let s=i;s<r;s++)if(this._tokens[s]!==n._tokens[s])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(n){return n>0?this._tokens[n-1<<1]:0}getMetadata(n){return this._tokens[(n<<1)+1]}getLanguageId(n){const c=this._tokens[(n<<1)+1],t=S.TokenMetadata.getLanguageId(c);return this._languageIdCodec.decodeLanguageId(t)}getStandardTokenType(n){const c=this._tokens[(n<<1)+1];return S.TokenMetadata.getTokenType(c)}getForeground(n){const c=this._tokens[(n<<1)+1];return S.TokenMetadata.getForeground(c)}getClassName(n){const c=this._tokens[(n<<1)+1];return S.TokenMetadata.getClassNameFromMetadata(c)}getInlineStyle(n,c){const t=this._tokens[(n<<1)+1];return S.TokenMetadata.getInlineStyleFromMetadata(t,c)}getPresentation(n){const c=this._tokens[(n<<1)+1];return S.TokenMetadata.getPresentationFromMetadata(c)}getEndOffset(n){return this._tokens[n<<1]}findTokenIndexAtOffset(n){return E.findIndexInTokensArray(this._tokens,n)}inflate(){return this}sliceAndInflate(n,c,t){return new v(this,n,c,t)}static convertToEndOffset(n,c){const i=(n.length>>>1)-1;for(let r=0;r<i;r++)n[r<<1]=n[r+1<<1];n[i<<1]=c}static findIndexInTokensArray(n,c){if(n.length<=2)return 0;let t=0,i=(n.length>>>1)-1;for(;t<i;){const r=t+Math.floor((i-t)/2),s=n[r<<1];if(s===c)return r+1;s<c?t=r+1:s>c&&(i=r)}return t}withInserted(n){if(n.length===0)return this;let c=0,t=0,i="";const r=new Array;let s=0;for(;;){const b=c<this._tokensCount?this._tokens[c<<1]:-1,k=t<n.length?n[t]:null;if(b!==-1&&(k===null||b<=k.offset)){i+=this._text.substring(s,b);const u=this._tokens[(c<<1)+1];r.push(i.length,u),c++,s=b}else if(k){if(k.offset>s){i+=this._text.substring(s,k.offset);const u=this._tokens[(c<<1)+1];r.push(i.length,u),s=k.offset}i+=k.text,r.push(i.length,k.tokenMetadata),t++}else break}return new E(new Uint32Array(r),i,this._languageIdCodec)}}e.LineTokens=E,E.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0;class v{constructor(n,c,t,i){this._source=n,this._startOffset=c,this._endOffset=t,this._deltaOffset=i,this._firstTokenIndex=n.findTokenIndexAtOffset(c),this._tokensCount=0;for(let r=this._firstTokenIndex,s=n.getCount();r<s&&!(n.getStartOffset(r)>=t);r++)this._tokensCount++}getMetadata(n){return this._source.getMetadata(this._firstTokenIndex+n)}getLanguageId(n){return this._source.getLanguageId(this._firstTokenIndex+n)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(n){return n instanceof v?this._startOffset===n._startOffset&&this._endOffset===n._endOffset&&this._deltaOffset===n._deltaOffset&&this._source.slicedEquals(n._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(n){return this._source.getForeground(this._firstTokenIndex+n)}getEndOffset(n){const c=this._source.getEndOffset(this._firstTokenIndex+n);return Math.min(this._endOffset,c)-this._startOffset+this._deltaOffset}getClassName(n){return this._source.getClassName(this._firstTokenIndex+n)}getInlineStyle(n,c){return this._source.getInlineStyle(this._firstTokenIndex+n,c)}getPresentation(n){return this._source.getPresentation(this._firstTokenIndex+n)}findTokenIndexAtOffset(n){return this._source.findTokenIndexAtOffset(n+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(W[25],q([0,1,7]),function(U,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class E{static deleteBeginning(n,c){return n===null||n===e.EMPTY_LINE_TOKENS?n:E.delete(n,0,c)}static deleteEnding(n,c){if(n===null||n===e.EMPTY_LINE_TOKENS)return n;const t=v(n),i=t[t.length-2];return E.delete(n,c,i)}static delete(n,c,t){if(n===null||n===e.EMPTY_LINE_TOKENS||c===t)return n;const i=v(n),r=i.length>>>1;if(c===0&&i[i.length-2]===t)return e.EMPTY_LINE_TOKENS;const s=S.LineTokens.findIndexInTokensArray(i,c),b=s>0?i[s-1<<1]:0,k=i[s<<1];if(t<k){const I=t-c;for(let M=s;M<r;M++)i[M<<1]-=I;return n}let u,o;b!==c?(i[s<<1]=c,u=s+1<<1,o=c):(u=s<<1,o=b);const h=t-c;for(let I=s+1;I<r;I++){const M=i[I<<1]-h;M>o&&(i[u++]=M,i[u++]=i[(I<<1)+1],o=M)}if(u===i.length)return n;const O=new Uint32Array(u);return O.set(i.subarray(0,u),0),O.buffer}static append(n,c){if(c===e.EMPTY_LINE_TOKENS)return n;if(n===e.EMPTY_LINE_TOKENS)return c;if(n===null)return n;if(c===null)return null;const t=v(n),i=v(c),r=i.length>>>1,s=new Uint32Array(t.length+i.length);s.set(t,0);let b=t.length;const k=t[t.length-2];for(let u=0;u<r;u++)s[b++]=i[u<<1]+k,s[b++]=i[(u<<1)+1];return s.buffer}static insert(n,c,t){if(n===null||n===e.EMPTY_LINE_TOKENS)return n;const i=v(n),r=i.length>>>1;let s=S.LineTokens.findIndexInTokensArray(i,c);s>0&&i[s-1<<1]===c&&s--;for(let b=s;b<r;b++)i[b<<1]+=t;return n}}e.ContiguousTokensEditing=E;function v(L){return L instanceof Uint32Array?L:new Uint32Array(L)}e.toUint32Array=v}),define(W[26],q([0,1,24,11,39,12,25,14]),function(U,e,S,E,v,L,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(r,s,b){const k=new Uint32Array(r.buffer),u=(0,E.readUInt32BE)(r,s);s+=4;const o=(0,E.readUInt32BE)(r,s);s+=4;const h=[];for(let O=0;O<o;O++){const I=(0,E.readUInt32BE)(r,s);s+=4,h.push(k.subarray(s/4,s/4+I/4)),s+=I}return b.push(new t(u,h)),s}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(r,s){this._startLineNumber=r,this._tokens=s}getLineRange(){return new c.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(r){return this._tokens[r-this._startLineNumber]}appendLineTokens(r){this._tokens.push(r)}serializeSize(){let r=0;r+=4,r+=4;for(let s=0;s<this._tokens.length;s++){const b=this._tokens[s];if(!(b instanceof Uint32Array))throw new Error("Not supported!");r+=4,r+=b.byteLength}return r}serialize(r,s){(0,E.writeUInt32BE)(r,this._startLineNumber,s),s+=4,(0,E.writeUInt32BE)(r,this._tokens.length,s),s+=4;for(let b=0;b<this._tokens.length;b++){const k=this._tokens[b];if(!(k instanceof Uint32Array))throw new Error("Not supported!");(0,E.writeUInt32BE)(r,k.byteLength,s),s+=4,r.set(new Uint8Array(k.buffer),s),s+=k.byteLength}return s}applyEdit(r,s){const[b,k]=(0,L.countEOL)(s);this._acceptDeleteRange(r),this._acceptInsertText(new v.Position(r.startLineNumber,r.startColumn),b,k)}_acceptDeleteRange(r){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return;const s=r.startLineNumber-this._startLineNumber,b=r.endLineNumber-this._startLineNumber;if(b<0){const k=b-s;this._startLineNumber-=k;return}if(!(s>=this._tokens.length)){if(s<0&&b>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(s===b){this._tokens[s]=n.ContiguousTokensEditing.delete(this._tokens[s],r.startColumn-1,r.endColumn-1);return}if(s>=0)if(this._tokens[s]=n.ContiguousTokensEditing.deleteEnding(this._tokens[s],r.startColumn-1),b<this._tokens.length){const k=n.ContiguousTokensEditing.deleteBeginning(this._tokens[b],r.endColumn-1);this._tokens[s]=n.ContiguousTokensEditing.append(this._tokens[s],k),this._tokens.splice(s+1,b-s)}else this._tokens[s]=n.ContiguousTokensEditing.append(this._tokens[s],null),this._tokens=this._tokens.slice(0,s+1);else{const k=-s;this._startLineNumber-=k,this._tokens[b]=n.ContiguousTokensEditing.deleteBeginning(this._tokens[b],r.endColumn-1),this._tokens=this._tokens.slice(b)}}}_acceptInsertText(r,s,b){if(s===0&&b===0)return;const k=r.lineNumber-this._startLineNumber;if(k<0){this._startLineNumber+=s;return}if(!(k>=this._tokens.length)){if(s===0){this._tokens[k]=n.ContiguousTokensEditing.insert(this._tokens[k],r.column-1,b);return}this._tokens[k]=n.ContiguousTokensEditing.deleteEnding(this._tokens[k],r.column-1),this._tokens[k]=n.ContiguousTokensEditing.insert(this._tokens[k],r.column-1,b),this._insertLines(r.lineNumber,s)}}_insertLines(r,s){if(s===0)return;const b=[];for(let k=0;k<s;k++)b[k]=null;this._tokens=S.arrayInsert(this._tokens,r,b)}}e.ContiguousMultilineTokens=t}),define(W[15],q([0,1,11,26]),function(U,e,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class v{static deserialize(n){let c=0;const t=(0,S.readUInt32BE)(n,c);c+=4;const i=[];for(let r=0;r<t;r++)c=E.ContiguousMultilineTokens.deserialize(n,c,i);return i}constructor(){this._tokens=[]}add(n,c){if(this._tokens.length>0){const t=this._tokens[this._tokens.length-1];if(t.endLineNumber+1===n){t.appendLineTokens(c);return}}this._tokens.push(new E.ContiguousMultilineTokens(n,[c]))}finalize(){return this._tokens}serialize(){const n=this._serializeSize(),c=new Uint8Array(n);return this._serialize(c),c}_serializeSize(){let n=0;n+=4;for(let c=0;c<this._tokens.length;c++)n+=this._tokens[c].serializeSize();return n}_serialize(n){let c=0;(0,S.writeUInt32BE)(n,this._tokens.length,c),c+=4;for(let t=0;t<this._tokens.length;t++)c=this._tokens[t].serialize(n,c)}}e.ContiguousMultilineTokensBuilder=v}),define(W[27],q([0,1,28,5,29,40]),function(U,e,S,E,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(d){return d===47||d===92}e.isPathSeparator=n;function c(d){return d.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=c;function t(d){return d.indexOf("/")===-1&&(d=c(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.toPosixPath=t;function i(d,g=S.posix.sep){if(!d)return"";const l=d.length,C=d.charCodeAt(0);if(n(C)){if(n(d.charCodeAt(1))&&!n(d.charCodeAt(2))){let z=3;const F=z;for(;z<l&&!n(d.charCodeAt(z));z++);if(F!==z&&!n(d.charCodeAt(z+1))){for(z+=1;z<l;z++)if(n(d.charCodeAt(z)))return d.slice(0,z+1).replace(/[\\/]/g,g)}}return g}else if(O(C)&&d.charCodeAt(1)===58)return n(d.charCodeAt(2))?d.slice(0,2)+g:d.slice(0,2);let D=d.indexOf("://");if(D!==-1){for(D+=3;D<l;D++)if(n(d.charCodeAt(D)))return d.slice(0,D+1)}return""}e.getRoot=i;function r(d){if(!E.isWindows||!d||d.length<5)return!1;let g=d.charCodeAt(0);if(g!==92||(g=d.charCodeAt(1),g!==92))return!1;let l=2;const C=l;for(;l<d.length&&(g=d.charCodeAt(l),g!==92);l++);return!(C===l||(g=d.charCodeAt(l+1),isNaN(g)||g===92))}e.isUNC=r;const s=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(d,g=E.isWindows){const l=g?s:b;return!(!d||d.length===0||/^\s+$/.test(d)||(l.lastIndex=0,l.test(d))||g&&k.test(d)||d==="."||d===".."||g&&d[d.length-1]==="."||g&&d.length!==d.trim().length||d.length>255)}e.isValidBasename=u;function o(d,g,l){const C=d===g;return!l||C?C:!d||!g?!1:(0,v.equalsIgnoreCase)(d,g)}e.isEqual=o;function h(d,g,l,C=S.sep){if(d===g)return!0;if(!d||!g||g.length>d.length)return!1;if(l){if(!(0,v.startsWithIgnoreCase)(d,g))return!1;if(g.length===d.length)return!0;let z=g.length;return g.charAt(g.length-1)===C&&z--,d.charAt(z)===C}return g.charAt(g.length-1)!==C&&(g+=C),d.indexOf(g)===0}e.isEqualOrParent=h;function O(d){return d>=65&&d<=90||d>=97&&d<=122}e.isWindowsDriveLetter=O;function I(d,g){return E.isWindows&&d.endsWith(":")&&(d+=S.sep),(0,S.isAbsolute)(d)||(d=(0,S.join)(g,d)),d=(0,S.normalize)(d),E.isWindows?(d=(0,v.rtrim)(d,S.sep),d.endsWith(":")&&(d+=S.sep)):(d=(0,v.rtrim)(d,S.sep),d||(d=S.sep)),d}e.sanitizeFilePath=I;function M(d){const g=(0,S.normalize)(d);return E.isWindows?d.length>3?!1:p(g)&&(d.length===2||g.charCodeAt(2)===92):g===S.posix.sep}e.isRootOrDriveLetter=M;function p(d,g=E.isWindows){return g?O(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function w(d){return p(d)?d[0]:void 0}e.getDriveLetter=w;function f(d,g,l){return g.length>d.length?-1:d===g?0:(l&&(d=d.toLowerCase(),g=g.toLowerCase()),d.indexOf(g))}e.indexOfPath=f;function m(d){const g=d.split(":");let l,C,D;for(const z of g){const F=Number(z);(0,L.isNumber)(F)?C===void 0?C=F:D===void 0&&(D=F):l=l?[l,z].join(":"):z}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:C!==void 0?C:void 0,column:D!==void 0?D:C!==void 0?1:void 0}}e.parseLineAndColumnAware=m;const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",P="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function A(d,g,l=8){let C="";for(let z=0;z<l;z++){let F;z===0&&E.isWindows&&!g&&(l===3||l===4)?F=P:F=_,C+=F.charAt(Math.floor(Math.random()*F.length))}let D;return g?D=`${g}-${C}`:D=C,d?(0,S.join)(d,D):D}e.randomPath=A}),define(W[30],q([0,1,4,5,16]),function(U,e,S,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(i){i.inMemory="inmemory",i.vscode="vscode",i.internal="private",i.walkThrough="walkThrough",i.walkThroughSnippet="walkThroughSnippet",i.http="http",i.https="https",i.file="file",i.mailto="mailto",i.untitled="untitled",i.data="data",i.command="command",i.vscodeRemote="vscode-remote",i.vscodeRemoteResource="vscode-remote-resource",i.vscodeUserData="vscode-userdata",i.vscodeCustomEditor="vscode-custom-editor",i.vscodeNotebookCell="vscode-notebook-cell",i.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",i.vscodeNotebookCellOutput="vscode-notebook-cell-output",i.vscodeInteractive="vscode-interactive",i.vscodeInteractiveInput="vscode-interactive-input",i.vscodeSettings="vscode-settings",i.vscodeWorkspaceTrust="vscode-workspace-trust",i.vscodeTerminal="vscode-terminal",i.vscodeInteractiveSesssion="vscode-chat-editor",i.webviewPanel="webview-panel",i.vscodeWebview="vscode-webview",i.extension="extension",i.vscodeFileResource="vscode-file",i.tmp="tmp",i.vsls="vsls",i.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class n{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(r){this._preferredWebSchema=r}setDelegate(r){this._delegate=r}setServerRootPath(r){this._remoteResourcesPath=`${r}/${L.vscodeRemoteResource}`}set(r,s,b){this._hosts[r]=s,this._ports[r]=b}setConnectionToken(r,s){this._connectionTokens[r]=s}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(r){if(this._delegate)try{return this._delegate(r)}catch(h){return S.onUnexpectedError(h),r}const s=r.authority;let b=this._hosts[s];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const k=this._ports[s],u=this._connectionTokens[s];let o=`path=${encodeURIComponent(r.path)}`;return typeof u=="string"&&(o+=`&${e.connectionTokenQueryName}=${encodeURIComponent(u)}`),v.URI.from({scheme:E.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${b}:${k}`,path:this._remoteResourcesPath,query:o})}}e.RemoteAuthorities=new n,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class c{asBrowserUri(r){const s=this.toUri(r,U);return this.uriToBrowserUri(s)}uriToBrowserUri(r){return r.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===L.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${L.vscodeFileResource}://${c.FALLBACK_AUTHORITY}`)?r.with({scheme:L.vscodeFileResource,authority:r.authority||c.FALLBACK_AUTHORITY,query:null,fragment:null}):r}asFileUri(r){const s=this.toUri(r,U);return this.uriToFileUri(s)}uriToFileUri(r){return r.scheme===L.vscodeFileResource?r.with({scheme:L.file,authority:r.authority!==c.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(r,s){return v.URI.isUri(r)?r:v.URI.parse(s.toUrl(r))}}c.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new c;var t;(function(i){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);i.CoopAndCoep=Object.freeze(r.get("3"));const s="vscode-coi";function b(u){let o;typeof u=="string"?o=new URL(u).searchParams:u instanceof URL?o=u.searchParams:v.URI.isUri(u)&&(o=new URL(u.toString(!0)).searchParams);const h=o?.get(s);if(h)return r.get(h)}i.getHeadersFromQuery=b;function k(u,o,h){if(!globalThis.crossOriginIsolated)return;const O=o&&h?"3":h?"2":"1";u instanceof URLSearchParams?u.set(s,O):u[s]=O}i.addSearchParam=k})(t||(e.COI=t={}))}),define(W[17],q([0,1,27,30,28,5,29,16]),function(U,e,S,E,v,L,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(k){return(0,c.uriToFsPath)(k,!0)}e.originalFSPath=t;class i{constructor(u){this._ignorePathCasing=u}compare(u,o,h=!1){return u===o?0:(0,n.compare)(this.getComparisonKey(u,h),this.getComparisonKey(o,h))}isEqual(u,o,h=!1){return u===o?!0:!u||!o?!1:this.getComparisonKey(u,h)===this.getComparisonKey(o,h)}getComparisonKey(u,o=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,o,h=!1){if(u.scheme===o.scheme){if(u.scheme===E.Schemas.file)return S.isEqualOrParent(t(u),t(o),this._ignorePathCasing(u))&&u.query===o.query&&(h||u.fragment===o.fragment);if((0,e.isEqualAuthority)(u.authority,o.authority))return S.isEqualOrParent(u.path,o.path,this._ignorePathCasing(u),"/")&&u.query===o.query&&(h||u.fragment===o.fragment)}return!1}joinPath(u,...o){return c.URI.joinPath(u,...o)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return v.posix.basename(u.path)}extname(u){return v.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let o;return u.scheme===E.Schemas.file?o=c.URI.file(v.dirname(t(u))).path:(o=v.posix.dirname(u.path),u.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),o="/")),u.with({path:o})}normalizePath(u){if(!u.path.length)return u;let o;return u.scheme===E.Schemas.file?o=c.URI.file(v.normalize(t(u))).path:o=v.posix.normalize(u.path),u.with({path:o})}relativePath(u,o){if(u.scheme!==o.scheme||!(0,e.isEqualAuthority)(u.authority,o.authority))return;if(u.scheme===E.Schemas.file){const I=v.relative(t(u),t(o));return L.isWindows?S.toSlashes(I):I}let h=u.path||"/";const O=o.path||"/";if(this._ignorePathCasing(u)){let I=0;for(const M=Math.min(h.length,O.length);I<M&&!(h.charCodeAt(I)!==O.charCodeAt(I)&&h.charAt(I).toLowerCase()!==O.charAt(I).toLowerCase());I++);h=O.substr(0,I)+h.substr(I)}return v.posix.relative(h,O)}resolvePath(u,o){if(u.scheme===E.Schemas.file){const h=c.URI.file(v.resolve(t(u),o));return u.with({authority:h.authority,path:h.path})}return o=S.toPosixPath(o),u.with({path:v.posix.resolve(u.path,o)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,o){return u===o||u!==void 0&&o!==void 0&&(0,n.equalsIgnoreCase)(u,o)}hasTrailingPathSeparator(u,o=v.sep){if(u.scheme===E.Schemas.file){const h=t(u);return h.length>S.getRoot(h).length&&h[h.length-1]===o}else{const h=u.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,o=v.sep){return(0,e.hasTrailingPathSeparator)(u,o)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,o=v.sep){let h=!1;if(u.scheme===E.Schemas.file){const O=t(u);h=O!==void 0&&O.length===S.getRoot(O).length&&O[O.length-1]===o}else{o="/";const O=u.path;h=O.length===1&&O.charCodeAt(O.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(u,o)?u.with({path:u.path+"/"}):u}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(k=>k.scheme===E.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new i(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(k,u){const o=[];for(let h=0;h<k.length;h++){const O=u(k[h]);k.some((I,M)=>M===h?!1:(0,e.isEqualOrParent)(O,u(I)))||o.push(k[h])}return o}e.distinctParents=r;var s;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function u(o){const h=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(M=>{const[p,w]=M.split(":");p&&w&&h.set(p,w)});const I=o.path.substring(0,o.path.indexOf(";"));return I&&h.set(k.META_DATA_MIME,I),h}k.parseMetaData=u})(s||(e.DataUri=s={}));function b(k,u,o){if(u){let h=k.path;return h&&h[0]!==v.posix.sep&&(h=v.posix.sep+h),k.with({scheme:o,authority:u,path:h})}return k.with({scheme:o})}e.toLocalResource=b}),define(W[18],q([0,1,41,4,31,2,17,5,22]),function(U,e,S,E,v,L,n,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function i(R){return!!R&&typeof R.then=="function"}e.isThenable=i;function r(R){const a=new S.CancellationTokenSource,T=R(a.token),y=new Promise((N,B)=>{const V=a.token.onCancellationRequested(()=>{V.dispose(),a.dispose(),B(new E.CancellationError)});Promise.resolve(T).then(H=>{V.dispose(),a.dispose(),N(H)},H=>{V.dispose(),a.dispose(),B(H)})});return new class{cancel(){a.cancel()}then(N,B){return y.then(N,B)}catch(N){return this.then(void 0,N)}finally(N){return y.finally(N)}}}e.createCancelablePromise=r;function s(R,a,T){return new Promise((y,N)=>{const B=a.onCancellationRequested(()=>{B.dispose(),y(T)});R.then(y,N).finally(()=>B.dispose())})}e.raceCancellation=s;function b(R,a){return new Promise((T,y)=>{const N=a.onCancellationRequested(()=>{N.dispose(),y(new E.CancellationError)});R.then(T,y).finally(()=>N.dispose())})}e.raceCancellationError=b;async function k(R){let a=-1;const T=R.map((y,N)=>y.then(B=>(a=N,B)));try{return await Promise.race(T)}finally{R.forEach((y,N)=>{N!==a&&y.cancel()})}}e.raceCancellablePromises=k;function u(R,a,T){let y;const N=setTimeout(()=>{y?.(void 0),T?.()},a);return Promise.race([R.finally(()=>clearTimeout(N)),new Promise(B=>y=B)])}e.raceTimeout=u;function o(R){return new Promise((a,T)=>{const y=R();i(y)?y.then(a,T):a(y)})}e.asPromise=o;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(a){if(this.activePromise){if(this.queuedPromiseFactory=a,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const y=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,y};this.queuedPromise=new Promise(y=>{this.activePromise.then(T,T).then(y)})}return new Promise((T,y)=>{this.queuedPromise.then(T,y)})}return this.activePromise=a(),new Promise((T,y)=>{this.activePromise.then(N=>{this.activePromise=null,T(N)},N=>{this.activePromise=null,y(N)})})}}e.Throttler=h;class O{constructor(){this.current=Promise.resolve(null)}queue(a){return this.current=this.current.then(()=>a(),()=>a())}}e.Sequencer=O;class I{constructor(){this.promiseMap=new Map}queue(a,T){const N=(this.promiseMap.get(a)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(a)===N&&this.promiseMap.delete(a)});return this.promiseMap.set(a,N),N}}e.SequencerByKey=I;const M=(R,a)=>{let T=!0;const y=setTimeout(()=>{T=!1,a()},R);return{isTriggered:()=>T,dispose:()=>{clearTimeout(y),T=!1}}},p=R=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,R())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class w{constructor(a){this.defaultDelay=a,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(a,T=this.defaultDelay){this.task=a,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,B)=>{this.doResolve=N,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}}));const y=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=T===t.MicrotaskDelay?p(y):M(T,y),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new E.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=w;class f{constructor(a){this.delayer=new w(a),this.throttler=new h}trigger(a,T){return this.delayer.trigger(()=>this.throttler.queue(a),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class m{constructor(){this._isOpen=!1,this._promise=new Promise((a,T)=>{this._completePromise=a})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class _ extends m{constructor(a){super(),this._timeout=setTimeout(()=>this.open(),a)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=_;function P(R,a){return a?new Promise((T,y)=>{const N=setTimeout(()=>{B.dispose(),T()},R),B=a.onCancellationRequested(()=>{clearTimeout(N),B.dispose(),y(new E.CancellationError)})}):r(T=>P(R,T))}e.timeout=P;function A(R,a=0){const T=setTimeout(R,a);return(0,L.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=A;function d(R){const a=[];let T=0;const y=R.length;function N(){return T<y?R[T++]():null}function B(V){V!=null&&a.push(V);const H=N();return H?H.then(B):Promise.resolve(a)}return Promise.resolve(null).then(B)}e.sequence=d;function g(R,a=y=>!!y,T=null){let y=0;const N=R.length,B=()=>{if(y>=N)return Promise.resolve(T);const V=R[y++];return Promise.resolve(V()).then(Y=>a(Y)?Promise.resolve(Y):B())};return B()}e.first=g;function l(R,a=y=>!!y,T=null){if(R.length===0)return Promise.resolve(T);let y=R.length;const N=()=>{y=-1;for(const B of R)B.cancel?.()};return new Promise((B,V)=>{for(const H of R)H.then(Y=>{--y>=0&&a(Y)?(N(),B(Y)):y===0&&B(T)}).catch(Y=>{--y>=0&&(N(),V(Y))})})}e.firstParallel=l;class C{constructor(a){this._size=0,this.maxDegreeOfParalellism=a,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new v.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(a){return this._size++,new Promise((T,y)=>{this.outstandingPromises.push({factory:a,c:T,e:y}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const a=this.outstandingPromises.shift();this.runningPromises++;const T=a.factory();T.then(a.c,a.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=C;class D extends C{constructor(){super(1)}}e.Queue=D;class z{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const a=new Z;return this.drainers.add(a),a.p}isDrained(){for(const[,a]of this.queues)if(a.size>0)return!1;return!0}queueFor(a,T=n.extUri){const y=T.getComparisonKey(a);let N=this.queues.get(y);return N||(N=new D,v.Event.once(N.onDrained)(()=>{N?.dispose(),this.queues.delete(y),this.onDidQueueDrain()}),this.queues.set(y,N)),N}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const a of this.drainers)a.complete();this.drainers.clear()}dispose(){for(const[,a]of this.queues)a.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=z;class F{constructor(a,T){this._token=-1,typeof a=="function"&&typeof T=="number"&&this.setIfNotSet(a,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(a,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,a()},T)}setIfNotSet(a,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,a()},T))}}e.TimeoutTimer=F;class G{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(a,T){this.cancel(),this._token=setInterval(()=>{a()},T)}}e.IntervalTimer=G;class j{constructor(a,T){this.timeoutToken=-1,this.runner=a,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(a=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,a)}get delay(){return this.timeout}set delay(a){this.timeout=a}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=j;class K{constructor(a,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=a,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(a=this.timeout){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(a/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=K;class Q extends j{constructor(a,T){super(a,T),this.units=[]}work(a){this.units.push(a),this.isScheduled()||this.schedule()}doRun(){const a=this.units;this.units=[],this.runner?.(a)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q;class ne extends L.Disposable{constructor(a,T){super(),this.options=a,this.handler=T,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(a){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+a.length>this.options.maxBufferedWork)return!1}else if(this.pending+a.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const T of a)this.pendingWork.push(T);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new j(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=R=>{(0,c.setTimeout0)(()=>{if(a)return;const T=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let a=!1;return{dispose(){a||(a=!0)}}}:e.runWhenIdle=(R,a)=>{const T=requestIdleCallback(R,typeof a=="number"?{timeout:a}:void 0);let y=!1;return{dispose(){y||(y=!0,cancelIdleCallback(T))}}}}();class ie{constructor(a){this._didRun=!1,this._executor=()=>{try{this._value=a()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ie;async function re(R,a,T){let y;for(let N=0;N<T;N++)try{return await R()}catch(B){y=B,await P(a)}throw y}e.retry=re;class se{hasPending(a){return this._pending?typeof a=="number"?this._pending.taskId===a:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(a,T,y){return this._pending={taskId:a,cancel:()=>y?.(),promise:T},T.then(()=>this.donePending(a),()=>this.donePending(a)),T}donePending(a){this._pending&&a===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const a=this._next;this._next=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}setNext(a){if(this._next)this._next.run=a;else{let T,y;const N=new Promise((B,V)=>{T=B,y=V});this._next={run:a,promise:N,promiseResolve:T,promiseReject:y}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=se;class oe{constructor(a,T=()=>Date.now()){this.interval=a,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const a=this.nowFn();return a-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=a,this.value=0),this.value++,this.value}}e.IntervalCounter=oe;class Z{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((a,T)=>{this.completeCallback=a,this.errorCallback=T})}complete(a){return new Promise(T=>{this.completeCallback(a),this.resolved=!0,T()})}error(a){return new Promise(T=>{this.errorCallback(a),this.rejected=!0,T()})}cancel(){new Promise(a=>{this.errorCallback(new E.CancellationError),this.rejected=!0,a()})}}e.DeferredPromise=Z;var X;(function(R){async function a(y){let N;const B=await Promise.all(y.map(V=>V.then(H=>H,H=>{N||(N=H)})));if(typeof N<"u")throw N;return B}R.settled=a;function T(y){return new Promise(async(N,B)=>{try{await y(N,B)}catch(V){B(V)}})}R.withAsyncBody=T})(X||(e.Promises=X={}));var J;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(J||(J={}));class ${static fromArray(a){return new $(T=>{T.emitMany(a)})}static fromPromise(a){return new $(async T=>{T.emitMany(await a)})}static fromPromises(a){return new $(async T=>{await Promise.all(a.map(async y=>T.emitOne(await y)))})}static merge(a){return new $(async T=>{await Promise.all(a.map(async y=>{for await(const N of y)T.emitOne(N)}))})}constructor(a){this._state=0,this._results=[],this._error=null,this._onStateChanged=new v.Emitter,queueMicrotask(async()=>{const T={emitOne:y=>this.emitOne(y),emitMany:y=>this.emitMany(y),reject:y=>this.reject(y)};try{await Promise.resolve(a(T)),this.resolve()}catch(y){this.reject(y)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(a<this._results.length)return{done:!1,value:this._results[a++]};if(this._state===1)return{done:!0,value:void 0};await v.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(a,T){return new $(async y=>{for await(const N of a)y.emitOne(T(N))})}map(a){return $.map(this,a)}static filter(a,T){return new $(async y=>{for await(const N of a)T(N)&&y.emitOne(N)})}filter(a){return $.filter(this,a)}static coalesce(a){return $.filter(a,T=>!!T)}coalesce(){return $.coalesce(this)}static async toPromise(a){const T=[];for await(const y of a)T.push(y);return T}toPromise(){return $.toPromise(this)}emitOne(a){this._state===0&&(this._results.push(a),this._onStateChanged.fire())}emitMany(a){this._state===0&&(this._results=this._results.concat(a),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(a){this._state===0&&(this._state=2,this._error=a,this._onStateChanged.fire())}}e.AsyncIterableObject=$,$.EMPTY=$.fromArray([]);class x extends ${constructor(a,T){super(T),this._source=a}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=x;function ae(R){const a=new S.CancellationTokenSource,T=R(a.token);return new x(a,async y=>{const N=a.token.onCancellationRequested(()=>{N.dispose(),a.dispose(),y.reject(new E.CancellationError)});try{for await(const B of T){if(a.token.isCancellationRequested)return;y.emitOne(B)}N.dispose(),a.dispose()}catch(B){N.dispose(),a.dispose(),y.reject(B)}})}e.createCancelableAsyncIterable=ae}),define(W[19],q([0,1,32]),function(U,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(L){return this===L}};function E(L,n){return new S.TokenizationResult([new S.Token(0,"",L)],n)}e.nullTokenize=E;function v(L,n){const c=new Uint32Array(2);return c[0]=0,c[1]=(L<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new S.EncodedTokenizationResult(c,n===null?e.NullState:n)}e.nullTokenizeEncoded=v}),define(W[33],q([0,1,18,4,5,42,12,14,43,19,23,15,7]),function(U,e,S,E,v,L,n,c,t,i,r,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var k;(function(w){w[w.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(k||(k={}));class u{constructor(f,m){this.tokenizationSupport=m,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new h(f)}getStartState(f){return f===1?this.initialState:this.store.getEndState(f-1)}}e.TokenizerWithStateStore=u;class o extends u{constructor(f,m,_,P){super(f,m),this._textModel=_,this._languageIdCodec=P}updateTokensUntilLine(f,m){const _=this._textModel.getLanguageId();for(;;){const P=this.store.getFirstInvalidEndStateLineNumber();if(!P||P>m)break;const A=this._textModel.getLineContent(P),d=this.getStartState(P),g=M(this._languageIdCodec,_,this.tokenizationSupport,A,!0,d);f.add(P,g.tokens),this.store.setEndState(P,g.endState)}}getTokenTypeIfInsertingCharacter(f,m){const _=this.getStartState(f.lineNumber);if(!_)return 0;const P=this._textModel.getLanguageId(),A=this._textModel.getLineContent(f.lineNumber),d=A.substring(0,f.column-1)+m+A.substring(f.column-1),g=M(this._languageIdCodec,P,this.tokenizationSupport,d,!0,_),l=new b.LineTokens(g.tokens,d,this._languageIdCodec);if(l.getCount()===0)return 0;const C=l.findTokenIndexAtOffset(f.column-1);return l.getStandardTokenType(C)}tokenizeLineWithEdit(f,m,_){const P=f.lineNumber,A=f.column,d=this.getStartState(P);if(!d)return null;const g=this._textModel.getLineContent(P),l=g.substring(0,A-1)+_+g.substring(A-1+m),C=this._textModel.getLanguageIdAtPosition(P,0),D=M(this._languageIdCodec,C,this.tokenizationSupport,l,!0,d);return new b.LineTokens(D.tokens,l,this._languageIdCodec)}isCheapToTokenize(f){const m=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<m||f===m&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,m,_){if(_<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,_),{heuristicTokens:!1};let P=this.guessStartState(m);const A=this._textModel.getLanguageId();for(let d=m;d<=_;d++){const g=this._textModel.getLineContent(d),l=M(this._languageIdCodec,A,this.tokenizationSupport,g,!0,P);f.add(d,l.tokens),P=l.endState}return{heuristicTokens:!0}}guessStartState(f){let m=this._textModel.getLineFirstNonWhitespaceColumn(f);const _=[];let P=null;for(let g=f-1;m>1&&g>=1;g--){const l=this._textModel.getLineFirstNonWhitespaceColumn(g);if(l!==0&&l<m&&(_.push(this._textModel.getLineContent(g)),m=l,P=this.getStartState(g),P))break}P||(P=this.tokenizationSupport.getInitialState()),_.reverse();const A=this._textModel.getLanguageId();let d=P;for(const g of _)d=M(this._languageIdCodec,A,this.tokenizationSupport,g,!1,d).endState;return d}}e.TokenizerWithStateStoreAndTextModel=o;class h{constructor(f){this.lineCount=f,this.tokenizationStateStore=new O,this._invalidEndStatesLineNumbers=new I,this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(1,f+1))}getEndState(f){return this.tokenizationStateStore.getEndState(f)}setEndState(f,m){for(;;){const P=this._invalidEndStatesLineNumbers.min;if(P!==null&&P<=f)this._invalidEndStatesLineNumbers.removeMin();else break}const _=this.tokenizationStateStore.setEndState(f,m);return _&&f<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(f+1,f+2)),_}acceptChange(f,m){this.lineCount+=m-f.length,this.tokenizationStateStore.acceptChange(f,m),this._invalidEndStatesLineNumbers.addRangeAndResize(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive),m)}acceptChanges(f){for(const m of f){const[_]=(0,n.countEOL)(m.text);this.acceptChange(new c.LineRange(m.range.startLineNumber,m.range.endLineNumber+1),_+1)}}invalidateEndStateRange(f){this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this._invalidEndStatesLineNumbers.min||Number.MAX_SAFE_INTEGER}isTokenizationComplete(){return this._invalidEndStatesLineNumbers.min===null}}e.TrackingTokenizationStateStore=h;class O{constructor(){this._lineEndStates=new r.FixedArray(null)}getEndState(f){return this._lineEndStates.get(f)}setEndState(f,m){const _=this._lineEndStates.get(f);return _&&_.equals(m)?!1:(this._lineEndStates.set(f,m),!0)}acceptChange(f,m){let _=f.length;m>0&&_>0&&(_--,m--),this._lineEndStates.replace(f.startLineNumber,_,m)}acceptChanges(f){for(const m of f){const[_]=(0,n.countEOL)(m.text);this.acceptChange(new c.LineRange(m.range.startLineNumber,m.range.endLineNumber+1),_+1)}}}e.TokenizationStateStore=O;class I{constructor(){this._ranges=[]}getRanges(){return this._ranges}get min(){return this._ranges.length===0?null:this._ranges[0].start}removeMin(){if(this._ranges.length===0)return null;const f=this._ranges[0];return f.start+1===f.endExclusive?this._ranges.shift():this._ranges[0]=new t.OffsetRange(f.start+1,f.endExclusive),f.start}addRange(f){t.OffsetRange.addRange(f,this._ranges)}addRangeAndResize(f,m){let _=0;for(;!(_>=this._ranges.length||f.start<=this._ranges[_].endExclusive);)_++;let P=_;for(;!(P>=this._ranges.length||f.endExclusive<this._ranges[P].start);)P++;const A=m-f.length;for(let d=P;d<this._ranges.length;d++)this._ranges[d]=this._ranges[d].delta(A);if(_===P){const d=new t.OffsetRange(f.start,f.start+m);d.isEmpty||this._ranges.splice(_,0,d)}else{const d=Math.min(f.start,this._ranges[_].start),g=Math.max(f.endExclusive,this._ranges[P-1].endExclusive),l=new t.OffsetRange(d,g+A);l.isEmpty?this._ranges.splice(_,P-_):this._ranges.splice(_,P-_,l)}}toString(){return this._ranges.map(f=>f.toString()).join(" + ")}}e.RangePriorityQueueImpl=I;function M(w,f,m,_,P,A){let d=null;if(m)try{d=m.tokenizeEncoded(_,P,A.clone())}catch(g){(0,E.onUnexpectedError)(g)}return d||(d=(0,i.nullTokenizeEncoded)(w.encodeLanguageId(f),A)),b.LineTokens.convertToEndOffset(d.tokens,_.length),d}class p{constructor(f,m){this._tokenizerWithStateStore=f,this._backgroundTokenStore=m,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,S.runWhenIdle)(f=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(f)}))}_backgroundTokenizeWithDeadline(f){const m=Date.now()+f.timeRemaining(),_=()=>{this._isDisposed||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<m?(0,v.setTimeout0)(_):this._beginBackgroundTokenization())};_()}_backgroundTokenizeForAtLeast1ms(){const f=this._tokenizerWithStateStore._textModel.getLineCount(),m=new s.ContiguousMultilineTokensBuilder,_=L.StopWatch.create(!1);do if(_.elapsed()>1||this._tokenizeOneInvalidLine(m)>=f)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(m.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._tokenizerWithStateStore?!this._tokenizerWithStateStore.store.isTokenizationComplete():!1}_tokenizeOneInvalidLine(f){if(!this._tokenizerWithStateStore||!this._hasLinesToTokenize())return this._tokenizerWithStateStore._textModel.getLineCount()+1;const m=this._tokenizerWithStateStore.store.getFirstInvalidEndStateLineNumber();return this._tokenizerWithStateStore.updateTokensUntilLine(f,m),m}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.isTokenizationComplete()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(f,m){this._tokenizerWithStateStore.store.invalidateEndStateRange(new c.LineRange(f,m))}}e.DefaultBackgroundTokenizer=p}),define(W[34],q([0,1,31,2,13,32]),function(U,e,S,E,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class n extends E.Disposable{constructor(t,i,r,s,b=()=>!1){super(),this._grammar=t,this._initialState=i,this._containsEmbeddedLanguages=r,this._createBackgroundTokenizer=s,this._backgroundTokenizerShouldOnlyVerifyTokens=b,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new S.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this._backgroundTokenizerShouldOnlyVerifyTokens()}getInitialState(){return this._initialState}tokenize(t,i,r){throw new Error("Not supported!")}createBackgroundTokenizer(t,i){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(t,i)}tokenizeEncoded(t,i,r){const s=this._grammar.tokenizeLine2(t,r,500);if(s.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${t.substring(0,100)}`),new L.EncodedTokenizationResult(s.tokens,r);if(this._containsEmbeddedLanguages){const k=this._seenLanguages,u=s.tokens;for(let o=0,h=u.length>>>1;o<h;o++){const O=u[(o<<1)+1],I=v.TokenMetadata.getLanguageId(O);k[I]||(k[I]=!0,this._onDidEncounterLanguage.fire(I))}}let b;return r.equals(s.ruleStack)?b=r:b=s.ruleStack,new L.EncodedTokenizationResult(s.tokens,b)}}e.TextMateTokenizationSupport=n}),define(W[35],q([0,1,19,2,10]),function(U,e,S,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class L extends E.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this._actual.backgroundTokenizerShouldOnlyVerifyTokens}constructor(c,t,i){super(),this._encodedLanguageId=c,this._actual=t,this._maxTokenizationLineLength=i,this._register((0,v.keepAlive)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(c,t,i){throw new Error("Not supported!")}tokenizeEncoded(c,t,i){return c.length>=this._maxTokenizationLineLength.get()?(0,S.nullTokenizeEncoded)(this._encodedLanguageId,i):this._actual.tokenizeEncoded(c,t,i)}createBackgroundTokenizer(c,t){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(c,t)}}e.TokenizationSupportWithLineLimit=L}),define(W[36],q([0,1,17]),function(U,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class E{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(L){if(this._scopeNameToLanguageRegistration[L.scopeName]){const n=this._scopeNameToLanguageRegistration[L.scopeName];S.isEqual(n.location,L.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${L.scopeName}.
Old grammar file: ${n.location.toString()}.
New grammar file: ${L.location.toString()}`)}this._scopeNameToLanguageRegistration[L.scopeName]=L}getGrammarDefinition(L){return this._scopeNameToLanguageRegistration[L]||null}}e.TMScopeRegistry=E}),define(W[37],q([0,1,2,36]),function(U,e,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class v extends S.Disposable{constructor(n,c,t,i){super(),this._host=n,this._initialState=t.INITIAL,this._scopeRegistry=new E.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new t.Registry({onigLib:i,loadGrammar:async r=>{const s=this._scopeRegistry.getGrammarDefinition(r);if(!s)return this._host.logTrace(`No grammar found for scope ${r}`),null;const b=s.location;try{const k=await this._host.readFile(b);return t.parseRawGrammar(k,b.path)}catch(k){return this._host.logError(`Unable to load and parse grammar for scope ${r} from ${b}`,k),null}},getInjections:r=>{const s=r.split(".");let b=[];for(let k=1;k<=s.length;k++){const u=s.slice(0,k).join(".");b=[...b,...this._injections[u]||[]]}return b}}));for(const r of c){if(this._scopeRegistry.register(r),r.injectTo){for(const s of r.injectTo){let b=this._injections[s];b||(this._injections[s]=b=[]),b.push(r.scopeName)}if(r.embeddedLanguages)for(const s of r.injectTo){let b=this._injectedEmbeddedLanguages[s];b||(this._injectedEmbeddedLanguages[s]=b=[]),b.push(r.embeddedLanguages)}}r.language&&this._languageToScope.set(r.language,r.scopeName)}}has(n){return this._languageToScope.has(n)}setTheme(n,c){this._grammarRegistry.setTheme(n,c)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(n,c){const t=this._languageToScope.get(n);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const i=this._scopeRegistry.getGrammarDefinition(t);if(!i)throw new Error(e.missingTMGrammarErrorMessage);const r=i.embeddedLanguages;if(this._injectedEmbeddedLanguages[t]){const k=this._injectedEmbeddedLanguages[t];for(const u of k)for(const o of Object.keys(u))r[o]=u[o]}const s=Object.keys(r).length>0;let b;try{b=await this._grammarRegistry.loadGrammarWithConfiguration(t,c,{embeddedLanguages:r,tokenTypes:i.tokenTypes,balancedBracketSelectors:i.balancedBracketSelectors,unbalancedBracketSelectors:i.unbalancedBracketSelectors})}catch(k){throw k.message&&k.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):k}return{languageId:n,grammar:b,initialState:this._initialState,containsEmbeddedLanguages:s}}}e.TMGrammarFactory=v}),define(W[38],q([0,1,44,33,45,15,7,34,18,10,35,14]),function(U,e,S,E,v,L,n,c,t,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerModel=void 0;class b extends S.MirrorTextModel{constructor(o,h,O,I,M,p,w,f){super(o,h,O,I),this._worker=M,this._languageId=p,this._encodedLanguageId=w,this._tokenizationStateStore=null,this._isDisposed=!1,this._maxTokenizationLineLength=(0,i.observableValue)("_maxTokenizationLineLength",-1),this.tokenizeDebouncer=new t.RunOnceScheduler(()=>this._tokenize(),10),this._maxTokenizationLineLength.set(f,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(o,h){this._languageId=o,this._encodedLanguageId=h,this._resetTokenization()}onEvents(o){super.onEvents(o),this._tokenizationStateStore&&this._tokenizationStateStore.store.acceptChanges(o.changes),this.tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(o){this._maxTokenizationLineLength.set(o,void 0)}retokenize(o,h){this._tokenizationStateStore&&(this._tokenizationStateStore.store.invalidateEndStateRange(new s.LineRange(o,h)),this.tokenizeDebouncer.schedule())}_resetTokenization(){this._tokenizationStateStore=null;const o=this._languageId,h=this._encodedLanguageId;this._worker.getOrCreateGrammar(o,h).then(O=>{if(!(this._isDisposed||o!==this._languageId||h!==this._encodedLanguageId||!O)){if(O.grammar){const I=new r.TokenizationSupportWithLineLimit(this._encodedLanguageId,new c.TextMateTokenizationSupport(O.grammar,O.initialState,!1),this._maxTokenizationLineLength);this._tokenizationStateStore=new E.TokenizerWithStateStore(this._lines.length,I)}else this._tokenizationStateStore=null;this._tokenize()}})}_tokenize(){if(this._isDisposed||!this._tokenizationStateStore)return;const o=new Date().getTime();for(;;){let h=0;const O=new L.ContiguousMultilineTokensBuilder,I=new k;for(;;){const w=this._tokenizationStateStore.store.getFirstInvalidEndStateLineNumber();if(w===null||h>200)break;h++;const f=this._lines[w-1],m=this._tokenizationStateStore.getStartState(w),_=this._tokenizationStateStore.tokenizationSupport.tokenizeEncoded(f,!0,m);if(this._tokenizationStateStore.store.setEndState(w,_.endState)){const A=(0,v.diffStateStacksRefEq)(m,_.endState);I.setState(w,A)}else I.setState(w,null);if(n.LineTokens.convertToEndOffset(_.tokens,f.length),O.add(w,_.tokens),new Date().getTime()-o>20)break}if(h===0)break;const M=I.getStateDeltas();if(this._worker.setTokensAndStates(this._uri,this._versionId,O.serialize(),M),new Date().getTime()-o>20){setTimeout(()=>this._tokenize(),3);return}}}}e.TextMateWorkerModel=b;class k{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(o,h){o===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(h):this._stateDeltas.push({startLineNumber:o,stateDeltas:[h]}),this._lastStartLineNumber=o}getStateDeltas(){return this._stateDeltas}}}),define(W[46],q([0,1,16,37,38]),function(U,e,S,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.TextMateTokenizationWorker=void 0;class L{constructor(t,i){this.createData=i,this._models=Object.create(null),this._grammarCache=[],this._host=t.host;const r=i.grammarDefinitions.map(s=>({location:S.URI.revive(s.location),language:s.language,scopeName:s.scopeName,embeddedLanguages:s.embeddedLanguages,tokenTypes:s.tokenTypes,injectTo:s.injectTo,balancedBracketSelectors:s.balancedBracketSelectors,unbalancedBracketSelectors:s.unbalancedBracketSelectors}));this._grammarFactory=this._loadTMGrammarFactory(r)}async _loadTMGrammarFactory(t){const i=this.createData.textmateMainUri,r=await new Promise((o,h)=>{U([i],o,h)}),s=await new Promise((o,h)=>{U([this.createData.onigurumaMainUri],o,h)}),k=await(await fetch(this.createData.onigurumaWASMUri)).arrayBuffer();await s.loadWASM(k);const u=Promise.resolve({createOnigScanner:o=>s.createOnigScanner(o),createOnigString:o=>s.createOnigString(o)});return new E.TMGrammarFactory({logTrace:o=>{},logError:(o,h)=>console.error(o,h),readFile:o=>this._host.readFile(o)},t,r,u)}acceptNewModel(t){const i=S.URI.revive(t.uri),r=i.toString();this._models[r]=new v.TextMateWorkerModel(i,t.lines,t.EOL,t.versionId,this,t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength)}acceptModelChanged(t,i){this._models[t].onEvents(i)}retokenize(t,i,r){this._models[t].retokenize(i,r)}acceptModelLanguageChanged(t,i,r){this._models[t].onLanguageId(i,r)}acceptRemovedModel(t){this._models[t]&&(this._models[t].dispose(),delete this._models[t])}async acceptTheme(t,i){(await this._grammarFactory)?.setTheme(t,i)}acceptMaxTokenizationLineLength(t,i){this._models[t].acceptMaxTokenizationLineLength(i)}async getOrCreateGrammar(t,i){const r=await this._grammarFactory;return r?(this._grammarCache[i]||(this._grammarCache[i]=r.createGrammar(t,i)),this._grammarCache[i]):Promise.resolve(null)}setTokensAndStates(t,i,r,s){this._host.setTokensAndStates(t,i,r,s)}}e.TextMateTokenizationWorker=L;function n(c,t){return new L(c,t)}e.create=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e06ea6147733c975d26c3d3552462681e05cb147/core/vs/workbench/services/textMate/browser/worker/textMate.worker.js.map
